/*!
*  filename: ej.widget.all.js
*  version : 15.3.0.33
*  Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
*/


window.ej = window.Syncfusion = window.Syncfusion || {};


(function ($, ej, undefined) {
    'use strict';

    ej.version = "15.3.0.33";

    ej.consts = {
        NamespaceJoin: '-'
    };
    ej.TextAlign = {
        Center: 'center',
        Justify: 'justify',
        Left: 'left',
        Right: 'right'
    };
    ej.Orientation = { Horizontal: "horizontal", Vertical: "vertical" };

    ej.serverTimezoneOffset = 0;

    ej.persistStateVersion = null;

    ej.locales = ej.locales || [];

    if (!Object.prototype.hasOwnProperty) {
        Object.prototype.hasOwnProperty = function (obj, prop) {
            return obj[prop] !== undefined;
        };
    }

    //to support toISOString() in IE8
    if (!Date.prototype.toISOString) {
        (function () {
            function pad(number) {
                var r = String(number);
                if (r.length === 1) {
                    r = '0' + r;
                }
                return r;
            }
            Date.prototype.toISOString = function () {
                return this.getUTCFullYear()
                    + '-' + pad(this.getUTCMonth() + 1)
                    + '-' + pad(this.getUTCDate())
                    + 'T' + pad(this.getUTCHours())
                    + ':' + pad(this.getUTCMinutes())
                    + ':' + pad(this.getUTCSeconds())
                    + '.' + String((this.getUTCMilliseconds() / 1000).toFixed(3)).slice(2, 5)
                    + 'Z';
            };
        }());
    }

    String.format = function () {
        var source = arguments[0];
        for (var i = 0; i < arguments.length - 1; i++)
            source = source.replace(new RegExp("\\{" + i + "\\}", "gm"), arguments[i + 1]);

        source = source.replace(/\{[0-9]\}/g, "");
        return source;
    };

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };
    // Function to create new class
    ej.defineClass = function (className, constructor, proto, replace) {
        /// <summary>Creates the javascript class with given namespace & class name & constructor etc</summary>
        /// <param name="className" type="String">class name prefixed with namespace</param>
        /// <param name="constructor" type="Function">constructor function</param>
        /// <param name="proto" type="Object">prototype for the class</param>
        /// <param name="replace" type="Boolean">[Optional]Replace existing class if exists</param>
        /// <returns type="Function">returns the class function</returns>
        if (!className || !proto) return undefined;

        var parts = className.split(".");

        // Object creation
        var obj = window, i = 0;
        for (; i < parts.length - 1; i++) {

            if (ej.isNullOrUndefined(obj[parts[i]]))
                obj[parts[i]] = {};

            obj = obj[parts[i]];
        }

        if (replace || ej.isNullOrUndefined(obj[parts[i]])) {

            //constructor
            constructor = typeof constructor === "function" ? constructor : function () {
            };

            obj[parts[i]] = constructor;

            // prototype
            obj[parts[i]].prototype = proto;
        }

        return obj[parts[i]];
    };

    ej.util = {
        getNameSpace: function (className) {
            /// <summary>Internal function, this will create namespace for plugins using class name</summary>
            /// <param name="className" type="String"></param>
            /// <returns type="String"></returns>
            var splits = className.toLowerCase().split(".");
            splits[0] === "ej" && (splits[0] = "e");

            return splits.join(ej.consts.NamespaceJoin);
        },

        getObject: function (nameSpace, from) {
            if (!from || !nameSpace) return undefined;

            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (ej.util.isNullOrUndefined(value)) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i, t, length = splits.length;

            for (i = 0; i < length; i++) {
                t = splits[i];
                if (i + 1 == length)
                    from[t] = value;
                else if (ej.isNullOrUndefined(from[t]))
                    from[t] = {};

                from = from[t];
            }

            return start;
        },

        isNullOrUndefined: function (value) {
            /// <summary>Util to check null or undefined</summary>
            /// <param name="value" type="Object"></param>
            /// <returns type="Boolean"></returns>
            return value === undefined || value === null;
        },
        print: function (element, printWin) {
            var $div = ej.buildTag('div')
            var elementClone = element.clone();
            $div.append(elementClone);
            if (!printWin)
                var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no");
            printWin.document.write('<!DOCTYPE html>');
            var links = $('head').find('link').add("style");
            if (ej.browserInfo().name === "msie") {
                var a = ""
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.write('<html><head></head><body>' + a + $div[0].innerHTML + '</body></html>');
            }
            else {
                var a = ""
                printWin.document.write('<html><head>')
                links.each(function (index, obj) {
                    if (obj.tagName == "LINK")
                        $(obj).attr('href', obj.href);
                    a += obj.outerHTML;
                });
                printWin.document.writeln(a + '</head><body>')
                printWin.document.writeln($div[0].innerHTML + '</body></html>')
            }
            printWin.document.close();
            printWin.focus();
            setTimeout(function () {
                if (!ej.isNullOrUndefined(printWin.window)) {
                    printWin.print();
                    setTimeout(function () { printWin.close() }, 1000);
                }
            }, 1000);
        },
        ieClearRemover: function (element) {
            var searchBoxHeight = $(element).height();
            element.style.paddingTop = parseFloat(searchBoxHeight / 2) + "px";
            element.style.paddingBottom = parseFloat(searchBoxHeight / 2) + "px";
            element.style.height = "1px";
            element.style.lineHeight = "1px";
        },
        //To send ajax request
        sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.successHandler,
                error: ajaxOptions.errorHandler,
                beforeSend: ajaxOptions.beforeSendHandler,
                complete: ajaxOptions.completeHandler
            });
        },

        buildTag: function (tag, innerHtml, styles, attrs) {
            /// <summary>Helper to build jQuery element</summary>
            /// <param name="tag" type="String">tagName#id.cssClass</param>
            /// <param name="innerHtml" type="String"></param>
            /// <param name="styles" type="Object">A set of key/value pairs that configure styles</param>
            /// <param name="attrs" type="Object">A set of key/value pairs that configure attributes</param>
            /// <returns type="jQuery"></returns>
            var tagName = /^[a-z]*[0-9a-z]+/ig.exec(tag)[0];

            var id = /#([_a-z]+[-_0-9a-z]+)/ig.exec(tag);
            id = id ? id[id.length - 1] : undefined;

            var className = /\.([a-z]+[-_0-9a-z ]+)/ig.exec(tag);
            className = className ? className[className.length - 1] : undefined;

            return $(document.createElement(tagName))
                .attr(id ? { "id": id } : {})
                .addClass(className || "")
                .css(styles || {})
                .attr(attrs || {})
                .html(innerHtml || "");
        },
        _preventDefaultException: function (el, exceptions) {
            if (el) {
                for (var i in exceptions) {
                    if (exceptions[i].test(el[i])) {
                        return true;
                    }
                }
            }

            return false;
        },

        //Gets the maximum z-index in the document
        getMaxZindex: function () {
            var maxZ = 1;
            maxZ = Math.max.apply(null, $.map($('body *'), function (e, n) {
                if ($(e).css('position') == 'absolute' || $(e).css('position') == 'fixed')
                    return parseInt($(e).css('z-index')) || 1;
            })
            );
            if (maxZ == undefined || maxZ == null)
                maxZ = 1;
            return maxZ;
        },

        //To prevent default actions for the element
        blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },

        //To get dimensions of the element when its hidden
        getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().andSelf().filter(':hidden');
            if ($hidden) {
                var prop = { visibility: 'hidden', display: 'block' };
                var tmp = [];
                $hidden.each(function () {
                    var temp = {}, name;
                    for (name in prop) {
                        temp[name] = this.style[name];
                        this.style[name] = prop[name];
                    }
                    tmp.push(temp);
                });
                value = /(outer)/g.test(method) ?
                $(element)[method](true) :
               $(element)[method]();

                $hidden.each(function (i) {
                    var temp = tmp[i], name;
                    for (name in prop) {
                        this.style[name] = temp[name];
                    }
                });
            }
            return value;
        },
        //Get triggers when transition End
        transitionEndEvent: function () {
            var transitionEnd = {
                '': 'transitionend',
                'webkit': 'webkitTransitionEnd',
                'Moz': 'transitionend',
                'O': 'otransitionend',
                'ms': 'MSTransitionEnd'
            };

            return transitionEnd[ej.userAgent()];
        },
        //Get triggers when transition End
        animationEndEvent: function () {
            var animationEnd = {
                '': 'animationend',
                'webkit': 'webkitAnimationEnd',
                'Moz': 'animationend',
                'O': 'webkitAnimationEnd',
                'ms': 'animationend'
            };

            return animationEnd[ej.userAgent()];
        },
        //To return the start event to bind for element
        startEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchstart" : "mousedown";
        },
        //To return end event to bind for element
        endEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchend" : "mouseup"
        },
        //To return move event to bind for element
        moveEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? ($.support.hasPointer && !ej.isMobile()) ? "ejtouchmove" : "touchmove" : "mousemove";
        },
        //To return cancel event to bind for element
        cancelEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "touchcancel" : "mousecancel";
        },
        //To return tap event to bind for element
        tapEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "tap" : "click";
        },
        //To return tap hold event to bind for element
        tapHoldEvent: function () {
            return (ej.isTouchDevice() || $.support.hasPointer) ? "taphold" : "click";
        },
        //To check whether its Device
        isDevice: function () {
            if (ej.getBooleanVal($('head'), 'data-ej-forceset', false))
                return ej.getBooleanVal($('head'), 'data-ej-device', this._device());
            else
                return this._device();
        },
        //To check whether its portrait or landscape mode
        isPortrait: function () {
            var elem = document.documentElement;
            return (elem) && ((elem.clientWidth / elem.clientHeight) < 1.1);
        },
        //To check whether its in lower resolution
        isLowerResolution: function () {
            return ((window.innerWidth <= 640 && ej.isPortrait() && ej.isDevice()) || (window.innerWidth <= 800 && !ej.isDevice()) || (window.innerWidth <= 800 && !ej.isPortrait() && ej.isWindows() && ej.isDevice()) || ej.isMobile());
        },
        //To check whether its iOS web view
        isIOSWebView: function () {
            return (/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(navigator.userAgent));
        },
        //To check whether its Android web view
        isAndroidWebView: function () {
            return (!(typeof (Android) === "undefined"));
        },
        //To check whether its windows web view
        isWindowsWebView: function () {
            return location.href.indexOf("x-wmapp") != -1;
        },
        _device: function () {
            return (/Android|BlackBerry|iPhone|iPad|iPod|IEMobile|kindle|windows\sce|palm|smartphone|iemobile|mobile|pad|xoom|sch-i800|playbook/i.test(navigator.userAgent.toLowerCase()));
        },
        //To check whether its Mobile
        isMobile: function () {
            return ((/iphone|ipod|android|blackberry|opera|mini|windows\sce|palm|smartphone|iemobile/i.test(navigator.userAgent.toLowerCase()) && /mobile/i.test(navigator.userAgent.toLowerCase()))) || (ej.getBooleanVal($('head'), 'data-ej-mobile', false) === true);
        },
        //To check whether its Tablet
        isTablet: function () {
            return (/ipad|xoom|sch-i800|playbook|tablet|kindle/i.test(navigator.userAgent.toLowerCase())) || (ej.getBooleanVal($('head'), 'data-ej-tablet', false) === true) || (!ej.isMobile() && ej.isDevice());
        },
        //To check whether its Touch Device
        isTouchDevice: function () {
            return (('ontouchstart' in window || (window.navigator.msPointerEnabled && ej.isMobile())) && this.isDevice());
        },
        //To get the outerHTML string for object
        getClearString: function (string) {
            return $.trim(string.replace(/\s+/g, " ").replace(/(\r\n|\n|\r)/gm, "").replace(new RegExp("\>[\n\t ]+\<", "g"), "><"));
        },
        //Get the attribute value with boolean type of element
        getBooleanVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value.toLowerCase() == "true";
            else
                return option;
        },
        //Gets the Skew class based on the element current position
        _getSkewClass: function (item, pageX, pageY) {
            var itemwidth = item.width();
            var itemheight = item.height();
            var leftOffset = item.offset().left;
            var rightOffset = item.offset().left + itemwidth;
            var topOffset = item.offset().top;
            var bottomOffset = item.offset().top + itemheight;
            var widthoffset = itemwidth * 0.3;
            var heightoffset = itemheight * 0.3;
            if (pageX < leftOffset + widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topleft";
            if (pageX > rightOffset - widthoffset && pageY < topOffset + heightoffset)
                return "e-m-skew-topright";
            if (pageX > rightOffset - widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomright";
            if (pageX < leftOffset + widthoffset && pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottomleft";
            if (pageX > leftOffset + widthoffset && pageY < topOffset + heightoffset && pageX < rightOffset - widthoffset)
                return "e-m-skew-top";
            if (pageX < leftOffset + widthoffset)
                return "e-m-skew-left";
            if (pageX > rightOffset - widthoffset)
                return "e-m-skew-right";
            if (pageY > bottomOffset - heightoffset)
                return "e-m-skew-bottom";
            return "e-m-skew-center";
        },
        //Removes the added Skew class on the element
        _removeSkewClass: function (element) {
            $(element).removeClass("e-m-skew-top e-m-skew-bottom e-m-skew-left e-m-skew-right e-m-skew-topleft e-m-skew-topright e-m-skew-bottomleft e-m-skew-bottomright e-m-skew-center e-skew-top e-skew-bottom e-skew-left e-skew-right e-skew-topleft e-skew-topright e-skew-bottomleft e-skew-bottomright e-skew-center");
        },
        //Object.keys  method to support all the browser including IE8.
        _getObjectKeys: function (obj) {
            var i, keys = [];
            obj = Object.prototype.toString.call(obj) === Object.prototype.toString() ? obj : {};
            if (!Object.keys) {
                for (i in obj) {
                    if (obj.hasOwnProperty(i))
                        keys.push(i);
                }
                return keys;
            }
            if (Object.keys)
                return Object.keys(obj);
        },
        _touchStartPoints: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt;
                object._distX = 0;
                object._distY = 0;
                object._moved = false;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
            }
        },
        _isTouchMoved: function (evt, object) {
            if (evt) {
                var point = evt.touches ? evt.touches[0] : evt,
                deltaX = point.pageX - object._pointX,
                deltaY = point.pageY - object._pointY,
                timestamp = Date.now(),
                newX, newY,
                absDistX, absDistY;
                object._pointX = point.pageX;
                object._pointY = point.pageY;
                object._distX += deltaX;
                object._distY += deltaY;
                absDistX = Math.abs(object._distX);
                absDistY = Math.abs(object._distY);
                return !(absDistX < 5 && absDistY < 5);
            }
        },
        //To bind events for element
        listenEvents: function (selectors, eventTypes, handlers, remove, pluginObj, disableMouse) {
            for (var i = 0; i < selectors.length; i++) {
                ej.listenTouchEvent(selectors[i], eventTypes[i], handlers[i], remove, pluginObj, disableMouse);
            }
        },
        //To bind touch events for element
        listenTouchEvent: function (selector, eventType, handler, remove, pluginObj, disableMouse) {
            var event = remove ? "removeEventListener" : "addEventListener";
            var jqueryEvent = remove ? "off" : "on";
            var elements = $(selector);
            for (var i = 0; i < elements.length; i++) {
                var element = elements[i];
                switch (eventType) {
                    case "touchstart":
                        ej._bindEvent(element, event, eventType, handler, "mousedown", "MSPointerDown", "pointerdown", disableMouse);
                        break;
                    case "touchmove":
                        ej._bindEvent(element, event, eventType, handler, "mousemove", "MSPointerMove", "pointermove", disableMouse);
                        break;
                    case "touchend":
                        ej._bindEvent(element, event, eventType, handler, "mouseup", "MSPointerUp", "pointerup", disableMouse);
                        break;
                    case "touchcancel":
                        ej._bindEvent(element, event, eventType, handler, "mousecancel", "MSPointerCancel", "pointercancel", disableMouse);
                        break;
                    case "tap": case "taphold": case "ejtouchmove": case "click":
                        $(element)[jqueryEvent](eventType, handler);
                        break;
                    default:
                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                            pluginObj["_on"]($(element), eventType, handler);
                        else
                            element[event](eventType, handler, true);
                        break;
                }
            }
        },
        //To bind events for element
        _bindEvent: function (element, event, eventType, handler, mouseEvent, pointerEvent, ie11pointerEvent, disableMouse) {
            if ($.support.hasPointer)
                element[event](window.navigator.pointerEnabled ? ie11pointerEvent : pointerEvent, handler, true);
            else
                element[event](eventType, handler, true);
        },
        _browser: function () {
            return (/webkit/i).test(navigator.appVersion) ? 'webkit' : (/firefox/i).test(navigator.userAgent) ? 'Moz' : (/trident/i).test(navigator.userAgent) ? 'ms' : 'opera' in window ? 'O' : '';
        },
        styles: document.createElement('div').style,
        /**
       * To get the userAgent Name     
       * @example             
       * &lt;script&gt;
       *       ej.userAgent();//return user agent name
       * &lt;/script&gt         
       * @memberof AppView
       * @instance
       */
        userAgent: function () {
            var agents = 'webkitT,t,MozT,msT,OT'.split(','),
            t,
            i = 0,
            l = agents.length;

            for (; i < l; i++) {
                t = agents[i] + 'ransform';
                if (t in ej.styles) {
                    return agents[i].substr(0, agents[i].length - 1);
                }
            }

            return false;
        },
        addPrefix: function (style) {
            if (ej.userAgent() === '') return style;

            style = style.charAt(0).toUpperCase() + style.substr(1);
            return ej.userAgent() + style;
        },
        //To Prevent Default Exception

        //To destroy the mobile widgets
        destroyWidgets: function (element) {
            var dataEl = $(element).find("[data-role *= ejm]");
            dataEl.each(function (index, element) {
                var $element = $(element);
                var plugin = $element.data("ejWidgets");
                if (plugin)
                    $element[plugin]("destroy");
            });
        },
        //Get the attribute value of element
        getAttrVal: function (ele, val, option) {
            /// <summary>Util to get the property from data attributes</summary>
            /// <param name="ele" type="Object"></param>
            /// <param name="val" type="String"></param>
            /// <param name="option" type="GenericType"></param>
            /// <returns type="GenericType"></returns>
            var value = $(ele).attr(val);
            if (value != null)
                return value;
            else
                return option;
        },

        // Get the offset value of element
        getOffset: function (ele) {
            var pos = {};
            var offsetObj = ele.offset() || { left: 0, top: 0 };
            $.extend(true, pos, offsetObj);
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },

        // Z-index calculation for the element
        getZindexPartial: function (element, popupEle) {
            if (!ej.isNullOrUndefined(element) && element.length > 0) {
                var parents = element.parents(), bodyEle;
                bodyEle = $('body').children();
                if (!ej.isNullOrUndefined(element) && element.length > 0)
                    bodyEle.splice(bodyEle.index(popupEle), 1);
                $(bodyEle).each(function (i, ele) { parents.push(ele); });

                var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                    if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
                }));
                if (!maxZ || maxZ < 10000) maxZ = 10000;
                else maxZ += 1;
                return maxZ;
            }
        },

        isValidAttr: function (element, attribute) {
            var element = $(element)[0];
            if (typeof element[attribute] != "undefined")
                return true;
            else {
                var _isValid = false;
                $.each(element, function (key) {
                    if (key.toLowerCase() == attribute.toLowerCase()) {
                        _isValid = true;
                        return false;
                    }
                });
            }
            return _isValid;
        }

    };

    $.extend(ej, ej.util);

    // base class for all ej widgets. It will automatically inhertied
    ej.widgetBase = {
        droppables: { 'default': [] },
        resizables: { 'default': [] },

        _renderEjTemplate: function (selector, data, index, prop, ngTemplateType) {
            var type = null;
            if (typeof selector === "object" || selector.startsWith("#") || selector.startsWith("."))
                type = $(selector).attr("type");
            if (type) {
                type = type.toLowerCase();
                if (ej.template[type])
                    return ej.template[type](this, selector, data, index, prop);
            }
            // For ejGrid Angular2 Template Support
            else if (!ej.isNullOrUndefined(ngTemplateType))
                 return ej.template['text/x-'+ ngTemplateType](this, selector, data, index, prop);
            return ej.template.render(this, selector, data, index, prop);
        },

        destroy: function () {

            if (this._trigger("destroy"))
                return;

            if (this.model.enablePersistence) {
                this.persistState();
                $(window).off("unload", this._persistHandler);
            }

            try {
                this._destroy();
            } catch (e) { }

            var arr = this.element.data("ejWidgets") || [];
            for (var i = 0; i < arr.length; i++) {
                if (arr[i] == this.pluginName) {
                    arr.splice(i, 1);
                }
            }
            if (!arr.length)
                this.element.removeData("ejWidgets");

            while (this._events) {
                var item = this._events.pop(), args = [];

                if (!item)
                    break;

                for (var i = 0; i < item[1].length; i++)
                    if (!$.isPlainObject(item[1][i]))
                        args.push(item[1][i]);

                $.fn.off.apply(item[0], args);
            }

            this._events = null;

            this.element
                .removeClass(ej.util.getNameSpace(this.sfType))
                .removeClass("e-js")
                .removeData(this.pluginName);

            this.element = null;
            this.model = null;
        },

        _on: function (element) {
            if (!this._events)
                this._events = [];
            var args = [].splice.call(arguments, 1, arguments.length - 1);

            var handler = {}, i = args.length;
            while (handler && typeof handler !== "function") {
                handler = args[--i];
            }

            args[i] = ej.proxy(args[i], this);

            this._events.push([element, args, handler, args[i]]);

            $.fn.on.apply(element, args);

            return this;
        },

        _off: function (element, eventName, selector, handlerObject) {
            var e = this._events, temp;
            if (!e || !e.length)
                return this;
            if (typeof selector == "function") {
                temp = handlerObject;
                handlerObject = selector;
                selector = temp;
            }
            var t = (eventName.match(/\S+/g) || [""]);
            for (var i = 0; i < e.length; i++) {
                var arg = e[i],
                r = arg[0].length && (!handlerObject || arg[2] === handlerObject) && (arg[1][0] === eventName || t[0]) && (!selector || arg[1][1] === selector) && $.inArray(element[0], arg[0]) > -1;
                if (r) {
                    $.fn.off.apply(element, handlerObject ? [eventName, selector, arg[3]] : [eventName, selector]);
                    e.splice(i, 1);
                    break;
                }
            }

            return this;
        },

        // Client side events wire-up / trigger helper.
        _trigger: function (eventName, eventProp) {
            var fn = null, returnValue, args, clientProp = {};
            $.extend(clientProp, eventProp)

            if (eventName in this.model)
                fn = this.model[eventName];

            if (fn) {
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }

                if ($.isFunction(fn)) {

                    args = ej.event(eventName, this.model, eventProp);

                    var scopeFn = this.model["_applyScope"];

                    returnValue = fn.call(this, args);

                    scopeFn && scopeFn.call();

                    // sending changes back - deep copy option should not be enabled for this $.extend 
                    if (eventProp) $.extend(eventProp, args);

                    if (args.cancel || !ej.isNullOrUndefined(returnValue))
                        return returnValue === false || args.cancel;
                }
            }

            var isPropDefined = Boolean(eventProp);
            eventProp = eventProp || {};
            eventProp.originalEventType = eventName;
            eventProp.type = this.pluginName + eventName;

            args = $.Event(eventProp.type, ej.event(eventProp.type, this.model, eventProp));

            this.element && this.element.trigger(args);

            // sending changes back - deep copy option should not be enabled for this $.extend 
            if (isPropDefined) $.extend(eventProp, args);

            if (ej.isOnWebForms && args.cancel == false && this.model.serverEvents && this.model.serverEvents.length)
                ej.raiseWebFormsServerEvents(eventName, eventProp, clientProp);

            return args.cancel;
        },

        setModel: function (options, forceSet) {
            // check for whether to apply values are not. if _setModel function is defined in child,
            //  this will call that function and validate it using return value

            if (this._trigger("modelChange", { "changes": options }))
                return;

            for (var prop in options) {
                if (!forceSet) {
                    if (this.model[prop] === options[prop]) {
                        delete options[prop];
                        continue;
                    }
                    if ($.isPlainObject(options[prop])) {
                        iterateAndRemoveProps(this.model[prop], options[prop]);
                        if ($.isEmptyObject(options[prop])) {
                            delete options[prop];
                            continue;
                        }
                    }
                }

                if (this.dataTypes) {
                    var returnValue = this._isValidModelValue(prop, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + prop + " - " + returnValue;
                }
                if (this.model.notifyOnEachPropertyChanges && this.model[prop] !== options[prop]) {
                    var arg = {
                        oldValue: this.model[prop],
                        newValue: options[prop]
                    };

                    options[prop] = this._trigger(prop + "Change", arg) ? this.model[prop] : arg.newValue;
                }
            }
            if ($.isEmptyObject(options))
                return;

            if (this._setFirst) {
                var ds = options.dataSource;
                if (ds) delete options.dataSource;

                $.extend(true, this.model, options);
                if (ds) {
                    this.model.dataSource = (ds instanceof Array) ? ds.slice() : ds;
                    options["dataSource"] = this.model.dataSource;
                }
                !this._setModel || this._setModel(options);

            } else if (!this._setModel || this._setModel(options) !== false) {
                $.extend(true, this.model, options);
            }
            if ("enablePersistence" in options) {
                this._setState(options.enablePersistence);
            }
        },
        option: function (prop, value, forceSet) {
            if (!prop)
                return this.model;

            if ($.isPlainObject(prop))
                return this.setModel(prop, forceSet);

            if (typeof prop === "string") {
                prop = prop.replace(/^model\./, "");
                var oldValue = ej.getObject(prop, this.model);

                if (value === undefined && !forceSet)
                    return oldValue;

                if (prop === "enablePersistence")
                    return this._setState(value);

                if (forceSet && value === ej.extensions.modelGUID) {
                    return this._setModel(ej.createObject(prop, ej.getObject(prop, this.model), {}));
                }

                if (forceSet || ej.getObject(prop, this.model) !== value)
                    return this.setModel(ej.createObject(prop, value, {}), forceSet);
            }
            return undefined;
        },

        _isValidModelValue: function (prop, types, options) {
            var value = types[prop], option = options[prop], returnValue;

            if (!value)
                return true;

            if (typeof value === "string") {
                if (value == "enum") {
                    options[prop] = option ? option.toString().toLowerCase() : option;
                    value = "string";
                }

                if (value === "array") {
                    if (Object.prototype.toString.call(option) === '[object Array]')
                        return true;
                }
                else if (value === "data") {
                    return true;
                }
                else if (value === "parent") {
                    return true;
                }
                else if (typeof option === value)
                    return true;

                return "Expected type - " + value;
            }

            if (option instanceof Array) {
                for (var i = 0; i < option.length; i++) {
                    returnValue = this._isValidModelValue(prop, types, option[i]);
                    if (returnValue !== true) {
                        return " [" + i + "] - " + returnValue;
                    }
                }
                return true;
            }

            for (var innerProp in option) {
                returnValue = this._isValidModelValue(innerProp, value, option);
                if (returnValue !== true)
                    return innerProp + " : " + returnValue;
            }

            return true;
        },

        _returnFn: function (obj, propName) {
            if (propName.indexOf('.') != -1) {
                this._returnFn(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
            }
            else
                obj[propName] = obj[propName].call(obj.propName);
        },

        _removeCircularRef: function (obj) {
            var seen = [];
            function detect(obj, key, parent) {
                if (typeof obj != 'object') { return; }
                if (!Array.prototype.indexOf) {
                    Array.prototype.indexOf = function (val) {
                        return jQuery.inArray(val, this);
                    };
                }
                if (seen.indexOf(obj) >= 0) {
                    delete parent[key];
                    return;
                }
                seen.push(obj);
                for (var k in obj) { //dive on the object's children
                    if (obj.hasOwnProperty(k)) { detect(obj[k], k, obj); }
                }
                seen.pop();
                return;
            }
            detect(obj, 'obj', null);
            return obj;
        },

        stringify: function (model, removeCircular) {
            var observables = this.observables;
            for (var k = 0; k < observables.length; k++) {
                var val = ej.getObject(observables[k], model);
                if (!ej.isNullOrUndefined(val) && typeof (val) === "function")
                    this._returnFn(model, observables[k]);
            }
            if (removeCircular) model = this._removeCircularRef(model);
            return JSON.stringify(model);
        },

        _setState: function (val) {
            if (val === true) {
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
            } else {
                this.deleteState();
                $(window).off("unload", this._persistHandler);
            }
        },

        _removeProp: function (obj, propName) {
            if (!ej.isNullOrUndefined(obj)) {
                if (propName.indexOf('.') != -1) {
                    this._removeProp(obj[propName.split('.')[0]], propName.split('.').slice(1).join('.'));
                }
                else
                    delete obj[propName];
            }
        },

        persistState: function () {
            var model;

            if (this._ignoreOnPersist) {
                model = copyObject({}, this.model);
                for (var i = 0; i < this._ignoreOnPersist.length; i++) {
                    this._removeProp(model, this._ignoreOnPersist[i]);
                }
                model.ignoreOnPersist = this._ignoreOnPersist;
            } else if (this._addToPersist) {
                model = {};
                for (var i = 0; i < this._addToPersist.length; i++) {
                    ej.createObject(this._addToPersist[i], ej.getObject(this._addToPersist[i], this.model), model);
                }
                model.addToPersist = this._addToPersist;
            } else {
                model = copyObject({}, this.model);
            }

            if (this._persistState) {
                model.customPersists = {};
                this._persistState(model.customPersists);
            }

            if (window.localStorage) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") == null)
                    window.localStorage.setItem("persistKey", ej.persistStateVersion);
                window.localStorage.setItem("$ej$" + this.pluginName + this._id, JSON.stringify(model));
            }
            else if (document.cookie) {
                if (!ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") == null)
                    ej.cookie.set("persistKey", ej.persistStateVersion);
                ej.cookie.set("$ej$" + this.pluginName + this._id, model);
            }
        },

        deleteState: function () {
            if (window.localStorage)
                window.localStorage.removeItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                ej.cookie.set("$ej$" + this.pluginName + this._id, model, new Date());
        },

        restoreState: function (silent) {
            var value = null;
            if (window.localStorage)
                value = window.localStorage.getItem("$ej$" + this.pluginName + this._id);
            else if (document.cookie)
                value = ej.cookie.get("$ej$" + this.pluginName + this._id);

            if (value) {
                var model = JSON.parse(value);

                if (this._restoreState) {
                    this._restoreState(model.customPersists);
                    delete model.customPersists;
                }

                if (ej.isNullOrUndefined(model) === false)
                    if (!ej.isNullOrUndefined(model.ignoreOnPersist)) {
                        this._ignoreOnPersist = model.ignoreOnPersist;
                        delete model.ignoreOnPersist;
                    } else if (!ej.isNullOrUndefined(model.addToPersist)) {
                        this._addToPersist = model.addToPersist;
                        delete model.addToPersist;
                    }
            }
            if (!ej.isNullOrUndefined(model) && !ej.isNullOrUndefined(this._ignoreOnPersist)) {
                for (var i in this._ignoreOnPersist) {
                    if (this._ignoreOnPersist[i].indexOf('.') !== -1)
                        ej.createObject(this._ignoreOnPersist[i], ej.getObject(this._ignoreOnPersist[i], this.model), model);
                    else
                        model[this._ignoreOnPersist[i]] = this.model[this._ignoreOnPersist[i]];
                }
                this.model = model;
            }
            else
                this.model = $.extend(true, this.model, model);

            if (!silent && value && this._setModel)
                this._setModel(this.model);
        },

        //to prevent persistence
        ignoreOnPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    this._ignoreOnPersist.push(collection[i]);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    var index = this._addToPersist.indexOf(collection[i]);
                    this._addToPersist.splice(index, 1);
                }
            }
        },

        //to maintain persistence
        addToPersist: function (properties) {
            var collection = [];
            if (typeof (properties) == "object")
                collection = properties;
            else if (typeof (properties) == 'string')
                collection.push(properties);
            if (this._addToPersist === undefined) {
                this._ignoreOnPersist = this._ignoreOnPersist || [];
                for (var i = 0; i < collection.length; i++) {
                    var index = this._ignoreOnPersist.indexOf(collection[i]);
                    this._ignoreOnPersist.splice(index, 1);
                }
            } else {
                for (var i = 0; i < collection.length; i++) {
                    if ($.inArray(collection[i], this._addToPersist) === -1)
                        this._addToPersist.push(collection[i]);
                }
            }
        },

        // Get formatted text 
        formatting: function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture(locale) ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (s.startsWith("{") && !s.startsWith("{0:")) {
                var fVal = s.split(""), str = (str || "") + "", strSplt = str.split(""), formats = /[0aA\*CN<>\?]/gm;
                for (var f = 0, f, val = 0; f < fVal.length; f++)
                    fVal[f] = formats.test(fVal[f]) ? "{" + val++ + "}" : fVal[f];
                return String.format.apply(String, [fVal.join("")].concat(strSplt)).replace('{', '').replace('}', '');
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        },
    };

    ej.WidgetBase = function () {
    }

    var iterateAndRemoveProps = function (source, target) {
        for (var prop in source) {
            if (source[prop] === target[prop])
                delete target[prop];
            if ($.isPlainObject(target[prop]) && $.isPlainObject(source[prop]))
                iterateAndRemoveProps(source[prop], target[prop]);
        }
    }

    ej.widget = function (pluginName, className, proto) {
        /// <summary>Widget helper for developers, this set have predefined function to jQuery plug-ins</summary>
        /// <param name="pluginName" type="String">the plugin name that will be added in jquery.fn</param>
        /// <param name="className" type="String">the class name for your plugin, this will help create default cssClas</param>
        /// <param name="proto" type="Object">prototype for of the plug-in</param>

        if (typeof pluginName === "object") {
            proto = className;
            for (var prop in pluginName) {
                var name = pluginName[prop];

                if (name instanceof Array) {
                    proto._rootCSS = name[1];
                    name = name[0];
                }

                ej.widget(prop, name, proto);

                if (pluginName[prop] instanceof Array)
                    proto._rootCSS = "";
            }

            return;
        }

        var nameSpace = proto._rootCSS || ej.getNameSpace(className);

        proto = ej.defineClass(className, function (element, options) {

            this.sfType = className;
            this.pluginName = pluginName;
            this.instance = pInstance;

            if (ej.isNullOrUndefined(this._setFirst))
                this._setFirst = true;

            this["ob.values"] = {};

            $.extend(this, ej.widgetBase);

            if (this.dataTypes) {
                for (var property in options) {
                    var returnValue = this._isValidModelValue(property, this.dataTypes, options);
                    if (returnValue !== true)
                        throw "setModel - Invalid input for property :" + property + " - " + returnValue;
                }
            }

            var arr = (element.data("ejWidgets") || []);
            arr.push(pluginName);
            element.data("ejWidgets", arr);

            for (var i = 0; ej.widget.observables && this.observables && i < this.observables.length; i++) {
                var t = ej.getObject(this.observables[i], options);
                if (t) ej.createObject(this.observables[i], ej.widget.observables.register(t, this.observables[i], this, element), options);
            }

            this.element = element.jquery ? element : $(element);
            this.model = copyObject(true, {}, proto.prototype.defaults, options);
            this.model.keyConfigs = copyObject(this.keyConfigs);

            this.element.addClass(nameSpace + " e-js").data(pluginName, this);

            this._id = element[0].id;

            if (this.model.enablePersistence) {
                if (window.localStorage && !ej.isNullOrUndefined(ej.persistStateVersion) && window.localStorage.getItem("persistKey") != ej.persistStateVersion) {
                    for (var i in window.localStorage) {
                        if (i.indexOf("$ej$") != -1) {
                            window.localStorage.removeItem(i); //removing the previously stored plugin item from local storage
							window.localStorage.setItem("persistKey", ej.persistStateVersion);
						}				
                    }
                }
                else if (document.cookie && !ej.isNullOrUndefined(ej.persistStateVersion) && ej.cookie.get("persistKey") != ej.persistStateVersion) {
                    var splits = document.cookie.split(/; */);
                    for (var k in splits) {
                        if (k.indexOf("$ej$") != -1) {
                            ej.cookie.set(k.split("=")[0], model, new Date()); //removing the previously stored plugin item from local storage
							ej.cookie.set("persistKey", ej.persistStateVersion);
						}		
                    }
                }
                this._persistHandler = ej.proxy(this.persistState, this);
                $(window).on("unload", this._persistHandler);
                this.restoreState(true);
            }

            this._init(options);

            if (typeof this.model.keyConfigs === "object" && !(this.model.keyConfigs instanceof Array)) {
                var requiresEvt = false;
                if (this.model.keyConfigs.focus)
                    this.element.attr("accesskey", this.model.keyConfigs.focus);

                for (var keyProps in this.model.keyConfigs) {
                    if (keyProps !== "focus") {
                        requiresEvt = true;
                        break;
                    }
                }

                if (requiresEvt && this._keyPressed) {
                    var el = element, evt = "keydown";

                    if (this.keySettings) {
                        el = this.keySettings.getElement ? this.keySettings.getElement() || el : el;
                        evt = this.keySettings.event || evt;
                    }

                    this._on(el, evt, function (e) {
                        if (!this.model.keyConfigs) return;

                        var action = keyFn.getActionFromCode(this.model.keyConfigs, e.which, e.ctrlKey, e.shiftKey, e.altKey);
                        var arg = {
                            code: e.which,
                            ctrl: e.ctrlKey,
                            alt: e.altKey,
                            shift: e.shiftKey
                        };
                        if (!action) return;

                        if (this._keyPressed(action, e.target, arg, e) === false)
                            e.preventDefault();
                    });
                }
            }
            this._trigger("create");
        }, proto);

        $.fn[pluginName] = function (options) {
            var opt = options, args;
            for (var i = 0; i < this.length; i++) {

                var $this = $(this[i]),
                    pluginObj = $this.data(pluginName),
                    isAlreadyExists = pluginObj && $this.hasClass(nameSpace),
                    obj = null;

                if (this.length > 0 && $.isPlainObject(opt))
                    options = ej.copyObject({}, opt);

                // ----- plug-in creation/init
                if (!isAlreadyExists) {
                    if (proto.prototype._requiresID === true && !$(this[i]).attr("id")) {
                        $this.attr("id", getUid("ejControl_"));
                    }
                    if (!options || typeof options === "object") {
                        if (proto.prototype.defaults && !ej.isNullOrUndefined(ej.setCulture) && "locale" in proto.prototype.defaults && pluginName != "ejChart") {
                            if (options && !("locale" in options)) options.locale = ej.setCulture().name;
                            else if (ej.isNullOrUndefined(options)) {
                                options = {}; options.locale = ej.setCulture().name;
                            }
                        }
                        new proto($this, options);
                    }
                    else {
                        throwError(pluginName + ": methods/properties can be accessed only after plugin creation");
                    }
                    continue;
                }

                if (!options) continue;

                args = [].slice.call(arguments, 1);

                if (this.length > 0 && args[0] && opt === "option" && $.isPlainObject(args[0])) {
                    args[0] = ej.copyObject({}, args[0]);
                }

                // --- Function/property set/access
                if ($.isPlainObject(options)) {
                    // setModel using JSON object
                    pluginObj.setModel(options);
                }

                    // function/property name starts with "_" is private so ignore it.
                else if (options.indexOf('_') !== 0
                    && !ej.isNullOrUndefined(obj = ej.getObject(options, pluginObj))
                    || options.indexOf("model.") === 0) {

                    if (!obj || !$.isFunction(obj)) {

                        // if property is accessed, then break the jquery chain
                        if (arguments.length == 1)
                            return obj;

                        //setModel using string input
                        pluginObj.option(options, arguments[1]);

                        continue;
                    }

                    var value = obj.apply(pluginObj, args);

                    // If function call returns any value, then break the jquery chain
                    if (value !== undefined)
                        return value;

                } else {
                    throwError(className + ": function/property - " + options + " does not exist");
                }
            }
            if (pluginName.indexOf("ejm") != -1)
                ej.widget.registerInstance($this, pluginName, className, proto.prototype);
            // maintaining jquery chain
            return this;
        };

        ej.widget.register(pluginName, className, proto.prototype);
        ej.loadLocale(pluginName);
    };

    ej.loadLocale = function (pluginName) {
        var i, len, locales = ej.locales;
        for (i = 0, len = locales.length; i < len; i++)
            $.fn["Locale_" + locales[i]](pluginName);
    };


    $.extend(ej.widget, (function () {
        var _widgets = {}, _registeredInstances = [],

        register = function (pluginName, className, prototype) {
            if (!ej.isNullOrUndefined(_widgets[pluginName]))
                throwError("ej.widget : The widget named " + pluginName + " is trying to register twice.");

            _widgets[pluginName] = { name: pluginName, className: className, proto: prototype };

            ej.widget.extensions && ej.widget.extensions.registerWidget(pluginName);
        },
        registerInstance = function (element, pluginName, className, prototype) {
            _registeredInstances.push({ element: element, pluginName: pluginName, className: className, proto: prototype });
        }

        return {
            register: register,
            registerInstance: registerInstance,
            registeredWidgets: _widgets,
            registeredInstances: _registeredInstances
        };

    })());

    ej.widget.destroyAll = function (elements) {
        if (!elements || !elements.length) return;

        for (var i = 0; i < elements.length; i++) {
            var data = elements.eq(i).data(), wds = data["ejWidgets"];
            if (wds && wds.length) {
                for (var j = 0; j < wds.length; j++) {
                    if (data[wds[j]] && data[wds[j]].destroy)
                        data[wds[j]].destroy();
                }
            }
        }
    };

    ej.cookie = {
        get: function (name) {
            var value = RegExp(name + "=([^;]+)").exec(document.cookie);

            if (value && value.length > 1)
                return value[1];

            return undefined;
        },
        set: function (name, value, expiryDate) {
            if (typeof value === "object")
                value = JSON.stringify(value);

            value = escape(value) + ((expiryDate == null) ? "" : "; expires=" + expiryDate.toUTCString());
            document.cookie = name + "=" + value;
        }
    };

    var keyFn = {
        getActionFromCode: function (keyConfigs, keyCode, isCtrl, isShift, isAlt) {
            isCtrl = isCtrl || false;
            isShift = isShift || false;
            isAlt = isAlt || false;

            for (var keys in keyConfigs) {
                if (keys === "focus") continue;

                var key = keyFn.getKeyObject(keyConfigs[keys]);
                for (var i = 0; i < key.length; i++) {
                    if (keyCode === key[i].code && isCtrl == key[i].isCtrl && isShift == key[i].isShift && isAlt == key[i].isAlt)
                        return keys;
                }
            }
            return null;
        },
        getKeyObject: function (key) {
            var res = {
                isCtrl: false,
                isShift: false,
                isAlt: false
            };
            var tempRes = $.extend(true, {}, res);
            var $key = key.split(","), $res = [];
            for (var i = 0; i < $key.length; i++) {
                var rslt = null;
                if ($key[i].indexOf("+") != -1) {
                    var k = $key[i].split("+");
                    for (var j = 0; j < k.length; j++) {
                        rslt = keyFn.getResult($.trim(k[j]), res);
                    }
                }
                else {
                    rslt = keyFn.getResult($.trim($key[i]), $.extend(true, {}, tempRes));
                }
                $res.push(rslt);
            }
            return $res;
        },
        getResult: function (key, res) {
            if (key === "ctrl")
                res.isCtrl = true;
            else if (key === "shift")
                res.isShift = true;
            else if (key === "alt")
                res.isAlt = true;
            else res.code = parseInt(key, 10);
            return res;
        }
    };

    ej.getScrollableParents = function (element) {
        return $(element).parentsUntil("html").filter(function () {
            return $(this).css("overflow") != "visible";
        }).add($(window));
    }
    ej.browserInfo = function () {
        var browser = {}, clientInfo = [],
        browserClients = {
            opera: /(opera|opr)(?:.*version|)[ \/]([\w.]+)/i, edge: /(edge)(?:.*version|)[ \/]([\w.]+)/i, webkit: /(chrome)[ \/]([\w.]+)/i, safari: /(webkit)[ \/]([\w.]+)/i, msie: /(msie|trident) ([\w.]+)/i, mozilla: /(mozilla)(?:.*? rv:([\w.]+)|)/i
        };
        for (var client in browserClients) {
            if (browserClients.hasOwnProperty(client)) {
                clientInfo = navigator.userAgent.match(browserClients[client]);
                if (clientInfo) {
                    browser.name = clientInfo[1].toLowerCase() == "opr" ? "opera" : clientInfo[1].toLowerCase();
                    browser.version = clientInfo[2];
                    browser.culture = {};
                    browser.culture.name = browser.culture.language = navigator.language || navigator.userLanguage;
                    if (typeof (ej.globalize) != 'undefined') {
                        var oldCulture = ej.preferredCulture().name;
                        var culture = (navigator.language || navigator.userLanguage) ? ej.preferredCulture(navigator.language || navigator.userLanguage) : ej.preferredCulture("en-US");
                        for (var i = 0; (navigator.languages) && i < navigator.languages.length; i++) {
                            culture = ej.preferredCulture(navigator.languages[i]);
                            if (culture.language == navigator.languages[i])
                                break;
                        }
                        ej.preferredCulture(oldCulture);
                        $.extend(true, browser.culture, culture);
                    }
                    if (!!navigator.userAgent.match(/Trident\/7\./)) {
                        browser.name = "msie";
                    }
                    break;
                }
            }
        }
        browser.isMSPointerEnabled = (browser.name == 'msie') && browser.version > 9 && window.navigator.msPointerEnabled;
        browser.pointerEnabled = window.navigator.pointerEnabled;
        return browser;
    };
    ej.eventType = {
        mouseDown: "mousedown touchstart",
        mouseMove: "mousemove touchmove",
        mouseUp: "mouseup touchend",
        mouseLeave: "mouseleave touchcancel",
        click: "click touchend"
    };

    ej.event = function (type, data, eventProp) {

        var e = $.extend(eventProp || {},
            {
                "type": type,
                "model": data,
                "cancel": false
            });

        return e;
    };

    ej.proxy = function (fn, context, arg) {
        if (!fn || typeof fn !== "function")
            return null;

        if ('on' in fn && context)
            return arg ? fn.on(context, arg) : fn.on(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.hasStyle = function (prop) {
        var style = document.documentElement.style;

        if (prop in style) return true;

        var prefixs = ['ms', 'Moz', 'Webkit', 'O', 'Khtml'];

        prop = prop[0].toUpperCase() + prop.slice(1);

        for (var i = 0; i < prefixs.length; i++) {
            if (prefixs[i] + prop in style)
                return true;
        }

        return false;
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };
    var copyObject = ej.copyObject = function (isDeepCopy, target) {
        var start = 2, current, source;
        if (typeof isDeepCopy !== "boolean") {
            start = 1;
        }
        var objects = [].slice.call(arguments, start);
        if (start === 1) {
            target = isDeepCopy;
            isDeepCopy = undefined;
        }

        for (var i = 0; i < objects.length; i++) {
            for (var prop in objects[i]) {
                current = target[prop], source = objects[i][prop];

                if (source === undefined || current === source || objects[i] === source || target === source)
                    continue;
                if (source instanceof Array) {
                    if (i === 0 && isDeepCopy) {
                        target[prop] = new Array();
                        for (var j = 0; j < source.length; j++) {
                            copyObject(true, target[prop], source);
                        }
                    }
                    else
                        target[prop] = source.slice();
                }
                else if (ej.isPlainObject(source)) {
                    target[prop] = current || {};
                    if (isDeepCopy)
                        copyObject(isDeepCopy, target[prop], source);
                    else
                        copyObject(target[prop], source);
                } else
                    target[prop] = source;
            }
        }
        return target;
    };
    var pInstance = function () {
        return this;
    }

    var _uid = 0;
    var getUid = function (prefix) {
        return prefix + _uid++;
    }

    ej.template = {};

    ej.template.render = ej.template["text/x-jsrender"] = function (self, selector, data, index, prop) {
        if (selector.slice(0, 1) !== "#")
            selector = ["<div>", selector, "</div>"].join("");
        var property = { prop: prop, index: index };
        return $(selector).render(data, property);
    }

    ej.isPlainObject = function (obj) {
        if (!obj) return false;
        if (ej.DataManager !== undefined && obj instanceof ej.DataManager) return false;
        if (typeof obj !== "object" || obj.nodeType || jQuery.isWindow(obj)) return false;
        try {
            if (obj.constructor &&
                !obj.constructor.prototype.hasOwnProperty("isPrototypeOf")) {
                return false;
            }
        } catch (e) {
            return false;
        }

        var key, ownLast = ej.support.isOwnLast;
        for (key in obj) {
            if (ownLast) break;
        }

        return key === undefined || obj.hasOwnProperty(key);
    };
    var getValueFn = false;
    ej.util.valueFunction = function (prop) {
        return function (value, getObservable) {
            var val = ej.getObject(prop, this.model);

            if (getValueFn === false)
                getValueFn = ej.getObject("observables.getValue", ej.widget);

            if (value === undefined) {
                if (!ej.isNullOrUndefined(getValueFn)) {
                    return getValueFn(val, getObservable);
                }
                return typeof val === "function" ? val.call(this) : val;
            }

            if (typeof val === "function") {
                this["ob.values"][prop] = value;
                val.call(this, value);
            }
            else
                ej.createObject(prop, value, this.model);
        }
    };
    ej.util.getVal = function (val) {
        if (typeof val === "function")
            return val();
        return val;
    };
    ej.support = {
        isOwnLast: function () {
            var fn = function () { this.a = 1; };
            fn.prototype.b = 1;

            for (var p in new fn()) {
                return p === "b";
            }
        }(),
        outerHTML: function () {
            return document.createElement("div").outerHTML !== undefined;
        }()
    };

    var throwError = ej.throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

    ej.getRandomValue = function (min, max) {
        if (min === undefined || max === undefined)
            return ej.throwError("Min and Max values are required for generating a random number");

        var rand;
        if ("crypto" in window && "getRandomValues" in crypto) {
            var arr = new Uint16Array(1);
            window.crypto.getRandomValues(arr);
            rand = arr[0] % (max - min) + min;
        }
        else rand = Math.random() * (max - min) + min;
        return rand | 0;
    }

    ej.extensions = {};
    ej.extensions.modelGUID = "{0B1051BA-1CCB-42C2-A3B5-635389B92A50}";
})(window.jQuery, window.Syncfusion);
(function () {
    $.fn.addEleAttrs = function (json) {
        var $this = $(this);
        $.each(json, function (i, attr) {
            if (attr && attr.specified) {
                $this.attr(attr.name, attr.value);
            }
        });

    };
    $.fn.removeEleAttrs = function (regex) {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && regex.test(attr.name)) {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.fn.attrNotStartsWith = function (regex) {
        var proxy = this;
        var attributes = [], attrs;
        this.each(function () {
            attrs = $(this.attributes).clone();
        });
        for (i = 0; i < attrs.length; i++) {
            if (attrs[i] && attrs[i].specified && regex.test(attrs[i].name)) {
                continue
            }
            else
                attributes.push(attrs[i])
        }
        return attributes;

    }
    $.fn.removeEleEmptyAttrs = function () {
        return this.each(function () {
            var $this = $(this),
                names = [],
                attrs = $(this.attributes).clone();
            $.each(attrs, function (i, attr) {
                if (attr && attr.specified && attr.value === "") {
                    $this.removeAttr(attr.name);
                }
            });
        });
    };
    $.extend($.support, {
        has3d: ej.addPrefix('perspective') in ej.styles,
        hasTouch: 'ontouchstart' in window,
        hasPointer: navigator.msPointerEnabled,
        hasTransform: ej.userAgent() !== false,
        pushstate: "pushState" in history &&
        "replaceState" in history,
        hasTransition: ej.addPrefix('transition') in ej.styles
    });
    //Ensuring elements having attribute starts with 'ejm-' 
    $.extend($.expr[':'], {
        attrNotStartsWith: function (element, index, match) {
            var i, attrs = element.attributes;
            for (i = 0; i < attrs.length; i++) {
                if (attrs[i].nodeName.indexOf(match[3]) === 0) {
                    return false;
                }
            }
            return true;
        }
    });
    //addBack() is supported from Jquery >1.8 and andSelf() supports later version< 1.8. support for both the method is provided by extending the JQuery function.
    var oldSelf = $.fn.andSelf || $.fn.addBack;
    $.fn.andSelf = $.fn.addBack = function () {
        return oldSelf.apply(this, arguments);
    };
})();;
;
window.ej = window.Syncfusion = window.Syncfusion || {};

(function ($, ej, doc, undefined) {
    'use strict';
	
    ej.DataManager = function (dataSource, query, adaptor) {
          if (!(this instanceof ej.DataManager))
            return new ej.DataManager(dataSource, query, adaptor);

        if (!dataSource)
            dataSource = [];
        adaptor = adaptor || dataSource.adaptor;

        if (typeof (adaptor) === "string") 
            adaptor = new ej[adaptor]();
        var data = [], self = this;

        if (dataSource instanceof Array) {
            // JSON array
            data = {
                json: dataSource,
                offline: true
            };

        } else if (typeof dataSource === "object") {
            if ($.isPlainObject(dataSource)) {
                if (!dataSource.json)
                    dataSource.json = [];
                if (dataSource.table)
                    dataSource.json = this._getJsonFromElement(dataSource.table, dataSource.headerOption);
                data = {
                    url: dataSource.url,
                    insertUrl: dataSource.insertUrl,
                    removeUrl: dataSource.removeUrl,
                    updateUrl: dataSource.updateUrl,
                    crudUrl: dataSource.crudUrl,
                    batchUrl: dataSource.batchUrl,
                    json: dataSource.json,
                    headers: dataSource.headers,
                    accept: dataSource.accept,
                    data: dataSource.data,
					async : dataSource.async,
                    timeTillExpiration: dataSource.timeTillExpiration,
                    cachingPageSize: dataSource.cachingPageSize,
                    enableCaching: dataSource.enableCaching,
                    requestType: dataSource.requestType,
                    key: dataSource.key,
                    crossDomain: dataSource.crossDomain,
                    jsonp: dataSource.jsonp,
                    dataType: dataSource.dataType,
                    offline: dataSource.offline !== undefined ? dataSource.offline : dataSource.adaptor == "remoteSaveAdaptor" || dataSource.adaptor instanceof ej.remoteSaveAdaptor ? false : dataSource.url ? false : true,
                    requiresFormat: dataSource.requiresFormat
                };
            } else if (dataSource.jquery || isHtmlElement(dataSource)) {
                data = {
                    json: this._getJsonFromElement(dataSource),
                    offline: true,
                    table: dataSource
                };
            }
        } else if (typeof dataSource === "string") {
            data = {
                url: dataSource,
                offline: false,
                dataType: "json",
                json: []
            };
        }

        if (data.requiresFormat === undefined && !ej.support.cors)
            data.requiresFormat = isNull(data.crossDomain) ? true : data.crossDomain;
        if (data.dataType === undefined)
            data.dataType = "json";
        this.dataSource = data;
        this.defaultQuery = query;

        if (data.url && data.offline && !data.json.length) {
            this.isDataAvailable = false;
            this.adaptor = adaptor || new ej.ODataAdaptor();
            this.dataSource.offline = false;
            this.ready = this.executeQuery(query || ej.Query()).done(function (e) {
                self.dataSource.offline = true;
                self.isDataAvailable = true;
                data.json = e.result;
                self.adaptor = new ej.JsonAdaptor();
            });
        }
        else
            this.adaptor = data.offline ? new ej.JsonAdaptor() : new ej.ODataAdaptor();
        if (!data.jsonp && this.adaptor instanceof ej.ODataAdaptor)
            data.jsonp = "callback";
        this.adaptor = adaptor || this.adaptor;
        if (data.enableCaching)
            this.adaptor = new ej.CacheAdaptor(this.adaptor, data.timeTillExpiration, data.cachingPageSize);
        return this;
    };

    ej.DataManager.prototype = {
        setDefaultQuery: function (query) {
            this.defaultQuery = query;
        },
	
        executeQuery: function (query, done, fail, always) {
            if (typeof query === "function") {
                always = fail;
                fail = done;
                done = query;
                query = null;
            }

            if (!query)
                query = this.defaultQuery;

            if (!(query instanceof ej.Query))
                throwError("DataManager - executeQuery() : A query is required to execute");

            var deffered = $.Deferred();

            deffered.then(done, fail, always);
            var args = { query: query };

            if (!this.dataSource.offline && this.dataSource.url != undefined) {
				 var result = this.adaptor.processQuery(this, query);
                if (!ej.isNullOrUndefined(result.url))
                    this._makeRequest(result, deffered, args, query);
                else {
                    nextTick(function () {
                        args = this._getDeferedArgs(query, result, args);
                        deffered.resolveWith(this, [args]);;
                    }, this);
                }
            } else {
				if(!ej.isNullOrUndefined(this.dataSource.async) && this.dataSource.async == false)
					this._localQueryProcess(query, args, deffered);
				else{
					nextTick(function () {
						this._localQueryProcess(query, args, deffered);
					}, this);
				}
            }
            return deffered.promise();
        },
		_localQueryProcess: function(query, args, deffered){
			var res = this.executeLocal(query);
			args = this._getDeferedArgs(query, res, args);
			deffered.resolveWith(this, [args]);
		},
        _getDeferedArgs: function (query, result, args) {
            if (query._requiresCount) {
                args.result = result.result;
                args.count = result.count;
            } else
                args.result = result;
            args.getTableModel = getTableModel(query._fromTable, args.result, this);
            args.getKnockoutModel = getKnockoutModel(args.result);
            return args;
        },
	
        executeLocal: function (query) {
            if (!this.defaultQuery && !(query instanceof ej.Query))
                throwError("DataManager - executeLocal() : A query is required to execute");

            if (!this.dataSource.json)
                throwError("DataManager - executeLocal() : Json data is required to execute");

            query = query || this.defaultQuery;

            var result = this.adaptor.processQuery(this, query);

            if (query._subQuery) {
                var from = query._subQuery._fromTable, lookup = query._subQuery._lookup,
                    res = query._requiresCount ? result.result : result;

                if (lookup && lookup instanceof Array) {
                    buildHierarchy(query._subQuery._fKey, from, res, lookup, query._subQuery._key);
                }

                for (var j = 0; j < res.length; j++) {
                    if (res[j][from] instanceof Array) {
                        res[j] = $.extend({}, res[j]);
                        res[j][from] = this.adaptor.processResponse(query._subQuery.using(ej.DataManager(res[j][from].slice(0))).executeLocal(), this, query);
                    }
                }
            }

            return this.adaptor.processResponse(result, this, query);
        },

        _makeRequest: function (url, deffered, args, query) {
            var isSelector = !!query._subQuerySelector;

            var fnFail = $proxy(function (e) {
                args.error = e;
                deffered.rejectWith(this, [args]);
            }, this);

            var process = $proxy(function (data, count, xhr, request, actual, aggregates, virtualSelectRecords) {
                if (isSelector) return;

                args.xhr = xhr;
                args.count = parseInt(count, 10);
                args.result = data;
                args.request = request;
                args.aggregates = aggregates;
                args.getTableModel = getTableModel(query._fromTable, data, this);
                args.getKnockoutModel = getKnockoutModel(data);
                args.actual = actual;
                args.virtualSelectRecords = virtualSelectRecords;
                deffered.resolveWith(this, [args]);

            }, this);

            var fnQueryChild = $proxy(function (data, selector) {
                var subDeffer = $.Deferred(),
                    childArgs = { parent: args };

                query._subQuery._isChild = true;

                var subUrl = this.adaptor.processQuery(this, query._subQuery, data ? this.adaptor.processResponse(data) : selector);

                var childReq = this._makeRequest(subUrl, subDeffer, childArgs, query._subQuery);

                if(!isSelector)
                    subDeffer.then(function (subData) {
                        if (data) {
                            buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, data, subData, query._subQuery._key);
                            process(data);
                        }
                    }, fnFail);

                return childReq;
            }, this);

            var fnSuccess = proxy(function (data, status, xhr, request) {
                if (xhr.getResponseHeader("Content-Type").indexOf("xml") == -1 && ej.dateParse)
                    data = ej.parseJSON(data);
                var result = this.adaptor.processResponse(data, this, query, xhr, request), count = 0, aggregates = null;
                var virtualSelectRecords = data.virtualSelectRecords;
                if (query._requiresCount) {
                    count = result.count;
                    aggregates = result.aggregates;
                    result = result.result;
                }

                if (!query._subQuery) {
                    process(result, count, xhr, request, data, aggregates, virtualSelectRecords);
                    return;
                }

                if (!isSelector)
                    fnQueryChild(result);

            }, this);

            var req = $.extend({
                type: "GET",
                dataType: this.dataSource.dataType,
                crossDomain: this.dataSource.crossDomain,
                jsonp: this.dataSource.jsonp,
                cache: true,
                beforeSend: $proxy(this._beforeSend, this),
                processData: false,
                success: fnSuccess,
                error: fnFail
            }, url);

            if ("async" in this.dataSource)
                req.async = this.dataSource.async;

            req = $.ajax(req);

            if (isSelector) {
                var res = query._subQuerySelector.call(this, { query: query._subQuery, parent: query });

                if (res && res.length) {
                    req = $.when(req, fnQueryChild(null, res));

                    req.then(proxy(function (pData, cData, requests) {
                        var pResult = this.adaptor.processResponse(pData[0], this, query, pData[2], requests[0]), count = 0;
                        if (query._requiresCount) {
                            count = pResult.count;
                            pResult = pResult.result;
                        }
                        var cResult = this.adaptor.processResponse(cData[0], this, query._subQuery, cData[2], requests[1]), count = 0;
                        if (query._subQuery._requiresCount) {
                            count = cResult.count;
                            cResult = cResult.result;
                        }

                        buildHierarchy(query._subQuery._fKey, query._subQuery._fromTable, pResult, cResult, query._subQuery._key);
                        isSelector = false;
                        process(pResult, count, pData[2]);

                    }, this), fnFail);
                } else {
                    isSelector = false;
                }
            }

            return req;
        },

        _beforeSend: function (request, settings) {
            this.adaptor.beforeSend(this, request, settings);

            var headers = this.dataSource.headers, props;
            for (var i = 0; headers && i < headers.length; i++) {
                props = [];
                for (var prop in headers[i]) {
                    props.push(prop);
                    request.setRequestHeader(prop, headers[i][prop]);
                }
            }
        },
	
        saveChanges: function (changes, key, tableName, query) {

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var args = {
                url: tableName,
                key: key || this.dataSource.key
            };

            var req = this.adaptor.batchRequest(this, changes, args, query);

            if (this.dataSource.offline) {
                return req;
            }

            var deff = $.Deferred();
            $.ajax($.extend({
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (data, status, xhr, request) {
                    deff.resolveWith(this, [this.adaptor.processResponse(data, this, null, xhr, request, changes, key)]);
                }, this),
                error: function (e) {
                    deff.rejectWith(this, [{ error: e }]);
                }
            }, req));

            return deff.promise();
        },
	
        insert: function (data, tableName, query) {           
            data = p.replacer(data);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.insert(this, data, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }            

            var deffer = $.Deferred();

            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                processData: false,
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));

            return deffer.promise();
        },
	
        remove: function (keyField, value, tableName, query) {
            if (typeof value === "object")
                value = value[keyField];

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.remove(this, keyField, value, tableName, query);

            if (this.dataSource.offline)
                return res;          

            var deffer = $.Deferred();
            $.ajax($.extend({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
            }, res));
            return deffer.promise();
        },
	
        update: function (keyField, value, tableName, query) {
            value = p.replacer(value);

            if (tableName instanceof ej.Query) {
                query = tableName;
                tableName = null;
            }

            var res = this.adaptor.update(this, keyField, value, tableName, query);

            if (this.dataSource.offline) {
                return res;
            }           

            var deffer = $.Deferred();

           $.ajax($.extend({
                contentType: "application/json; charset=utf-8",
                beforeSend: $proxy(this._beforeSend, this),
                success: proxy(function (record, status, xhr, request) {
                    try {
                        if (ej.isNullOrUndefined(record))
                            record = [];
                        else
                            p.parseJson(record);
                    }
                    catch (e) {
                        record = [];
                    }
                    record = this.adaptor.processResponse(p.parseJson(record), this, null, xhr, request);
                    deffer.resolveWith(this, [{ record: record, dataManager: this }]);
                }, this),
                error: function (e) {
                    deffer.rejectWith(this, [{ error: e, dataManager: this }]);
                }
           }, res));

           return deffer.promise();
        },

        _getJsonFromElement: function (ds) {
            if (typeof (ds) == "string")
                ds = $($(ds).html());

            ds = ds.jquery ? ds[0] : ds;

            var tagName = ds.tagName.toLowerCase();

            if (tagName !== "table")
                throwError("ej.DataManager : Unsupported htmlElement : " + tagName);

            return ej.parseTable(ds);
        }
    };

    var buildHierarchy = function (fKey, from, source, lookup, pKey) {
        var i, grp = {}, t;
        if (lookup.result) lookup = lookup.result;

        if (lookup.GROUPGUID)
            throwError("ej.DataManager: Do not have support Grouping in hierarchy");

        for (i = 0; i < lookup.length; i++) {
            var fKeyData = ej.getObject(fKey, lookup[i]);
            t = grp[fKeyData] || (grp[fKeyData] = []);

            t.push(lookup[i]);
        }

        for (i = 0; i < source.length; i++) {
            source[i][from] = grp[ej.getObject(pKey || fKey, source[i])];
        }
    };

    var oData = {
        accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
        multipartAccept: "multipart/mixed",
        batch: "$batch",
        changeSet: "--changeset_",
        batchPre: "batch_",
        contentId: "Content-Id: ",
        batchContent: "Content-Type: multipart/mixed; boundary=",
        changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
        batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
    };
    var p = {
        parseJson: function (jsonText) {
            var type = typeof jsonText;
            if (type === "string") {
                jsonText = JSON.parse(jsonText, p.jsonReviver);
            } else if (jsonText instanceof Array) {
                p.iterateAndReviveArray(jsonText);
            } else if (type === "object")
                p.iterateAndReviveJson(jsonText);
            return jsonText;
        },
        iterateAndReviveArray: function (array) {
            for (var i = 0; i < array.length; i++) {
                if (typeof array[i] === "object")
                    p.iterateAndReviveJson(array[i]);
                else if (typeof array[i] === "string" && !/^[\s]*\[|^[\s]*\{|\"/g.test(array[i]))
                    array[i] = p.jsonReviver("",array[i]);
                else
                    array[i] = p.parseJson(array[i]);
            }
        },
        iterateAndReviveJson: function (json) {
            var value;

            for (var prop in json) {
                if (prop.startsWith("__"))
                    continue;

                value = json[prop];
                if (typeof value === "object") {
                    if (value instanceof Array)
                        p.iterateAndReviveArray(value);
                    else
                        p.iterateAndReviveJson(value);
                } else
                    json[prop] = p.jsonReviver(prop, value);
            }
        },
        jsonReviver: function (field, value) {
            var s = value;
            if (typeof value === "string") {
                var ms = /^\/Date\(([+-]?[0-9]+)([+-][0-9]{4})?\)\/$/.exec(value);
                if (ms)
                    return p.replacer(new Date(parseInt(ms[1])));
                else if (/^(\d{4}\-\d\d\-\d\d([tT][\d:\.]*){1})([zZ]|([+\-])(\d\d):?(\d\d))?$/.test(value)) {
                    value = p.replacer(new Date(value));
                    if (isNaN(value)) {
                        var a = s.split(/[^0-9]/);
                        value = p.replacer(new Date(a[0], a[1] - 1, a[2], a[3], a[4], a[5]));
                    }
                }
            }

            return value;
        },
        isJson: function (jsonData) {
            if(typeof jsonData[0]== "string")
                return jsonData;
            return ej.parseJSON(jsonData);
        },
        isGuid: function (value) {
            var regex = /[A-Fa-f0-9]{8}(?:-[A-Fa-f0-9]{4}){3}-[A-Fa-f0-9]{12}/i;
            var match = regex.exec(value);
            return match != null;
        },
        replacer: function (value) {

            if (ej.isPlainObject(value))
                return p.jsonReplacer(value);

            if (value instanceof Array)
                return p.arrayReplacer(value);

            if (value instanceof Date)
                return p.jsonReplacer({ val: value }).val;

            return value;
        },
        jsonReplacer: function (val) {
            var value;
            for (var prop in val) {
                value = val[prop];

                if (!(value instanceof Date))
                    continue;
                val[prop] = new Date(+value + (ej.serverTimezoneOffset * 60 * 60 * 1000));
            }

            return val;
        },
        arrayReplacer: function (val) {

            for (var i = 0; i < val.length; i++) {            
                if (ej.isPlainObject(val[i]))
                    val[i] = p.jsonReplacer(val[i]);
                else if (val[i] instanceof Date)
                    val[i] = p.jsonReplacer({ date: val[i] }).date;
            }

            return val;
        }
    };

    ej.isJSON = p.isJson;
    ej.parseJSON = p.parseJson;
    ej.dateParse = true;
    ej.isGUID = p.isGuid;
    ej.Query = function (from) {
        if (!(this instanceof ej.Query))
            return new ej.Query(from);

        this.queries = [];
        this._key = "";
        this._fKey = "";

        if (typeof from === "string")
            this._fromTable = from || "";
        else if (from && from instanceof Array)
            this._lookup = from;

        this._expands = [];
        this._sortedColumns = [];
        this._groupedColumns = [];
        this._subQuery = null;
        this._isChild = false;
        this._params = [];
        return this;
    };

    ej.Query.prototype = {
        key: function (field) {
            if (typeof field === "string")
                this._key = field;

            return this;
        },
	
        using: function (dataManager) {
            if (dataManager instanceof ej.DataManager) {
                this.dataManagar = dataManager;
                return this;
            }

            return throwError("Query - using() : 'using' function should be called with parameter of instance ej.DataManager");
        },
	
        execute: function (dataManager, done, fail, always) {
            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeQuery(this, done, fail, always);

            return throwError("Query - execute() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        executeLocal: function (dataManager) {
            // this does not support for URL binding
            

            dataManager = dataManager || this.dataManagar;

            if (dataManager && dataManager instanceof ej.DataManager)
                return dataManager.executeLocal(this);

            return throwError("Query - executeLocal() : dataManager needs to be is set using 'using' function or should be passed as argument");
        },
	
        clone: function () {
            var cl = new ej.Query();
            cl.queries = this.queries.slice(0);
            cl._key = this._key;
            cl._isChild = this._isChild;
            cl.dataManagar = this.dataManager;
            cl._fromTable = this._fromTable;
            cl._params = this._params.slice(0);
            cl._expands = this._expands.slice(0);
            cl._sortedColumns = this._sortedColumns.slice(0);
            cl._groupedColumns = this._groupedColumns.slice(0);
            cl._subQuerySelector = this._subQuerySelector;
            cl._subQuery = this._subQuery;
            cl._fKey = this._fKey;
            cl._requiresCount = this._requiresCount;
            return cl;
        },
	
        from: function (tableName) {
            if (typeof tableName === "string")
                this._fromTable = tableName;

            return this;
        },
	
        addParams: function (key, value) {
            if (typeof value !== "function" && !ej.isPlainObject(value))
                this._params.push({ key: key, value: value });
            else if (typeof value === "function")
                this._params.push({ key: key, fn: value });

            return this;
        },
	
        expand: function (tables) {
            if (typeof tables === "string")
                this._expands = [].slice.call(arguments, 0);
            else
                this._expands = tables.slice(0);

            return this;
        },
	
        where: function (fieldName, operator, value, ignoreCase) {
            operator = (operator || ej.FilterOperators.equal).toLowerCase();
            var predicate = null;

            if (typeof fieldName === "string")
                predicate = new ej.Predicate(fieldName, operator, value, ignoreCase);
            else if (fieldName instanceof ej.Predicate)
                predicate = fieldName;
            else
                throwError("Query - where : Invalid arguments");

            this.queries.push({
                fn: "onWhere",
                e: predicate
            });
            return this;
        },
	
        search: function (searchKey, fieldNames, operator, ignoreCase) {
            if (!fieldNames || typeof fieldNames === "boolean") {
                fieldNames = [];
                ignoreCase = fieldNames;
            } else if (typeof fieldNames === "string")
                fieldNames = [fieldNames];

            if (typeof operator === "boolean") {
                ignoreCase = operator;
                operator = null;
            }
            operator = operator || ej.FilterOperators.contains;
            if (operator.length < 3)
                operator = ej.data.operatorSymbols[operator];

            var comparer = ej.data.fnOperators[operator] || ej.data.fnOperators.processSymbols(operator);

            this.queries.push({
                fn: "onSearch",
                e: {
                    fieldNames: fieldNames,
                    operator: operator,
                    searchKey: searchKey,
                    ignoreCase: ignoreCase,
                    comparer: comparer
                }
            });
            return this;
        },
		
        sortBy: function (fieldName, comparer, isFromGroup) {
            var order = ej.sortOrder.Ascending, sorts, t;

            if (typeof fieldName === "string" && fieldName.toLowerCase().endsWith(" desc")) {
                fieldName = fieldName.replace(/ desc$/i, '');
                comparer = ej.sortOrder.Descending;
            }
            if (fieldName instanceof Array) {
                for(var i=0;i<fieldName.length;i++)
                   this.sortBy(fieldName[i],comparer,isFromGroup);
                return this;
            }
            if (typeof comparer === "boolean")
                comparer = !comparer ? ej.sortOrder.Ascending : ej.sortOrder.Descending;
            else if (typeof comparer === "function")
                order = "custom";

            if (!comparer || typeof comparer === "string") {
                order = comparer ? comparer.toLowerCase() : ej.sortOrder.Ascending;
                comparer = ej.pvt.fnSort(comparer);
            }
            if (isFromGroup) {
                sorts = filterQueries(this.queries, "onSortBy");

                for (var i = 0; i < sorts.length; i++) {
                    t = sorts[i].e.fieldName;
                    if (typeof t === "string") {
                        if (t === fieldName) return this;
                    } else if (t instanceof Array) {
                        for (var j = 0; j < t.length; j++)
                            if (t[j] === fieldName || fieldName.toLowerCase() === t[j] + " desc")
                                return this;
                    }
                }
            }

            this.queries.push({
                fn: "onSortBy",
                e: {
                    fieldName: fieldName,
                    comparer: comparer,
                    direction: order
                }
            });

            return this;
        },
		
        sortByDesc: function (fieldName) {
            return this.sortBy(fieldName, ej.sortOrder.Descending);
        },
		
        group: function (fieldName,fn) {
            this.sortBy(fieldName, null, true);

            this.queries.push({
                fn: "onGroup",
                e: {
                    fieldName: fieldName,
                    fn: fn
                }
            });
            return this;
        },
	
        page: function (pageIndex, pageSize) {
            this.queries.push({
                fn: "onPage",
                e: {
                    pageIndex: pageIndex,
                    pageSize: pageSize
                }
            });
            return this;
        },
	
        range: function (start, end) {
            if (typeof start !== "number" || typeof end !== "number")
                throwError("Query() - range : Arguments type should be a number");

            this.queries.push({
                fn: "onRange",
                e: {
                    start: start,
                    end: end
                }
            });
            return this;
        },
	

        take: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Take : Argument type should be a number");

            this.queries.push({
                fn: "onTake",
                e: {
                    nos: nos
                }
            });
            return this;
        },
	
        skip: function (nos) {
            if (typeof nos !== "number")
                throwError("Query() - Skip : Argument type should be a number");

            this.queries.push({
                fn: "onSkip",
                e: { nos: nos }
            });
            return this;
        },
	
        select: function (fieldNames) {
            if (typeof fieldNames === "string")
                fieldNames = [].slice.call(arguments, 0);

            if (!(fieldNames instanceof Array)) {
                throwError("Query() - Select : Argument type should be String or Array");
            }

            this.queries.push({
                fn: "onSelect",
                e: { fieldNames: fieldNames }
            });
            return this;
        },
	
        hierarchy: function (query, selectorFn) {
            if (!query || !(query instanceof ej.Query))
                throwError("Query() - hierarchy : query must be instance of ej.Query");

            if (typeof selectorFn === "function")
                this._subQuerySelector = selectorFn;

            this._subQuery = query;
            return this;
        },
	
        foreignKey: function (key) {
            if (typeof key === "string")
                this._fKey = key;

            return this;
        },
	
        requiresCount: function () {
            this._requiresCount = true;

            return this;
        },
        //type - sum, avg, min, max
        aggregate: function (type, field) {
            this.queries.push({
                fn: "onAggregates",
                e: { field: field, type: type }
            });
        }
    };

    ej.Adaptor = function (ds) {
        this.dataSource = ds;
        this.pvt = {};
		this.init.apply(this, [].slice.call(arguments, 1));
    };

    ej.Adaptor.prototype = {
        options: {
            from: "table",
            requestType: "json",
            sortBy: "sorted",
            select: "select",
            skip: "skip",
            group: "group",
            take: "take",
            search: "search",
            count: "requiresCounts",
            where: "where",
            aggregates: "aggregates"
        },
        init: function () {
        },
        extend: function (overrides) {
            var fn = function (ds) {
                this.dataSource = ds;

                if (this.options)
                    this.options = $.extend({}, this.options);
				this.init.apply(this, [].slice.call(arguments, 0));

                this.pvt = {};
            };
            fn.prototype = new this.type();
            fn.prototype.type = fn;

            var base = fn.prototype.base = {};
            for (var p in overrides) {
                if (fn.prototype[p])
                    base[p] = fn.prototype[p];
            }
            $.extend(true, fn.prototype, overrides);
            return fn;
        },
        processQuery: function (dm, query) {
            // this needs to be overridden
        },
        processResponse: function (data, ds, query, xhr) {
            if (data.d)
               return data.d;
            return data;
        },
        convertToQueryString: function (req, query, dm) {
            return $.param(req);
        },
        type: ej.Adaptor
    };

    ej.UrlAdaptor = new ej.Adaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
                aggregates = filterQueries(query.queries, "onAggregates"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params,
                url = dm.dataSource.url, tmp, skip, take = null,
                op = this.options;

            var r = {
                sorted: [],
                grouped: [],
                filters: [],
                searches: [],
                aggregates: []
            };

            // calc Paging & Range
            if (singles["onPage"]) {
                tmp = singles["onPage"];
                skip = getValue(tmp.pageIndex, query);
                take = getValue(tmp.pageSize, query);
				skip = (skip - 1) * take;
            } else if (singles["onRange"]) {
                tmp = singles["onRange"];
                skip = tmp.start;
                take = tmp.end - tmp.start;
            }

            // Sorting
            for (var i = 0; i < sorted.length; i++) {
                tmp = getValue(sorted[i].e.fieldName, query);

                r.sorted.push(callAdaptorFunc(this, "onEachSort", { name: tmp, direction: sorted[i].e.direction }, query));
            }

            // hierarchy
            if (hierarchyFilters) {
                tmp = this.getFiltersFrom(hierarchyFilters, query);
                if (tmp)
                    r.filters.push(callAdaptorFunc(this, "onEachWhere", tmp.toJSON(), query));
            }

            // Filters
            for (var i = 0; i < filters.length; i++) {
                r.filters.push(callAdaptorFunc(this, "onEachWhere", filters[i].e.toJSON(), query));

                for (var prop in r.filters[i]) {
                    if (isNull(r[prop]))
                        delete r[prop];
                }
            }

            // Searches
            for (var i = 0; i < searchs.length; i++) {
                tmp = searchs[i].e;
                r.searches.push(callAdaptorFunc(this, "onEachSearch", {
                    fields: tmp.fieldNames,
                    operator: tmp.operator,
                    key: tmp.searchKey,
                    ignoreCase: tmp.ignoreCase
                }, query));
            }

            // Grouping
            for (var i = 0; i < grouped.length; i++) {
                r.grouped.push(getValue(grouped[i].e.fieldName, query));
            }

            // aggregates
            for (var i = 0; i < aggregates.length; i++) {
                tmp = aggregates[i].e; 
                r.aggregates.push({ type: tmp.type, field: getValue(tmp.field, query) });
            }

            var req = {};
            req[op.from] = query._fromTable;
            if (op.expand) req[op.expand] = query._expands;
            req[op.select] = singles["onSelect"] ? callAdaptorFunc(this, "onSelect", getValue(singles["onSelect"].fieldNames, query), query) : "";
            req[op.count] = query._requiresCount ? callAdaptorFunc(this, "onCount", query._requiresCount, query) : "";
            req[op.search] = r.searches.length ? callAdaptorFunc(this, "onSearch", r.searches, query) : "";
            req[op.skip] = singles["onSkip"] ? callAdaptorFunc(this, "onSkip", getValue(singles["onSkip"].nos, query), query) : "";
            req[op.take] = singles["onTake"] ? callAdaptorFunc(this, "onTake", getValue(singles["onTake"].nos, query), query) : "";
            req[op.where] = r.filters.length || r.searches.length ? callAdaptorFunc(this, "onWhere", r.filters, query) : "";
            req[op.sortBy] = r.sorted.length ? callAdaptorFunc(this, "onSortBy", r.sorted, query) : "";
            req[op.group] = r.grouped.length ? callAdaptorFunc(this, "onGroup", r.grouped, query) : "";
            req[op.aggregates] = r.aggregates.length ? callAdaptorFunc(this, "onAggregates", r.aggregates, query) : "";
			req["param"] = [];
			
            // Params
			callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: params, reqParams: req });

            // cleanup
            for (var prop in req) {
                if (isNull(req[prop]) || req[prop] === "" || req[prop].length === 0 || prop === "params")
                    delete req[prop];
            }

            if (!(op.skip in req && op.take in req) && take !== null) {
                req[op.skip] = callAdaptorFunc(this, "onSkip", skip, query);
                req[op.take] = callAdaptorFunc(this, "onTake", take, query);
            }
            var p = this.pvt;
            this.pvt = {};

            if (this.options.requestType === "json") {
                return {
                    data: JSON.stringify(req),
                    url: url,
                    ejPvtData: p,
                    type: "POST",
                    contentType: "application/json; charset=utf-8"
                }
            }
            tmp = this.convertToQueryString(req, query, dm);
            tmp =  (dm.dataSource.url.indexOf("?")!== -1 ? "&" : "/") + tmp;
            return {
                type: "GET",
                url: tmp.length ? url.replace(/\/*$/, tmp) : url,
                ejPvtData: p
            };
        },
        convertToQueryString: function (req, query, dm) {
            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1)
                return $.param(req);
            return "?" + $.param(req);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request.ejPvtData || {};
			var groupDs= data.groupDs;
			if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            var d = JSON.parse(request.data);
            if (d && d.action === "batch" && data.added) {
                changes.added = data.added;
                return changes;
            }
            if (data.d)
                data = data.d;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                if ('count' in data) args.count = data.count;
                if (data["result"]) args.result = data.result;
                if (data["aggregate"]) data = data.aggregate;
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                args["aggregates"] = res;
                data = args;
            }

            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups, args = {};
                if ('count' in data) args.count = data.count;
                if (data["aggregates"]) args.aggregates = data.aggregates;
                if (data["result"]) data = data.result;
                for (var i = 0; i < groups.length; i++){
                    var level = null;
                    var format = getColFormat(groups[i], query.queries);
                    if (!ej.isNullOrUndefined(groupDs))
                        groupDs = ej.group(groupDs, groups[i], null, format);
                    data = ej.group(data, groups[i], pvt.aggregates, format, level, groupDs);
                }
                if (args.count != undefined)
                    args.result = data;
                else
                    args = data;
                return args;
            }
            return data;
        },
        onGroup: function (e) {
            this.pvt.groups = e;
        },
        onAggregates: function (e) {
            this.pvt.aggregates = e;
        },
        batchRequest: function (dm, changes, e, query) {
            var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.removeUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        },
        beforeSend: function (dm, request) {
        },
        insert: function (dm, data, tableName, query) {
            var res = {
                value: data,
                table: tableName,
                action: "insert"
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        remove: function (dm, keyField, value, tableName, query) {
            var res = {
                key: value,
                keyColumn: keyField,
                table: tableName,
                action: "remove"
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.removeUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        update: function (dm, keyField, value, tableName, query) {
            var res = {
                value: value,
                action: "update",
                keyColumn: keyField,
                key: value[keyField],
                table: tableName
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });

            return {
                type: "POST",
                url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: JSON.stringify(res)
            };
        },
        getFiltersFrom: function (data, query) {
            if (!(data instanceof Array) || !data.length)
                throwError("ej.SubQuery: Array of key values required");
            var key = query._fKey, value, prop = key, pKey = query._key, predicats = [],
                isValues = typeof data[0] !== "object";

            if (typeof data[0] !== "object") prop = null;

            for (var i = 0; i < data.length; i++) {
                value = !isValues ? ej.pvt.getObject(pKey || prop, data[i]) : data[i];
                predicats.push(new ej.Predicate(key, "==", value));
            }

            return ej.Predicate.or(predicats);
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                req[tmp.key] = tmp.value;
                if (tmp.fn)
                    req[tmp.key] = tmp.fn.call(query, tmp.key, query, dm);                
                req["params"][tmp.key] = req[tmp.key];
            }
        }
    });
    ej.WebMethodAdaptor = new ej.UrlAdaptor().extend({
        processQuery: function (dm, query, hierarchyFilters) {
            var obj = ej.UrlAdaptor.prototype.processQuery(dm, query, hierarchyFilters);
            var data = ej.parseJSON(obj.data), result = {};

            result["value"] = data;

            //Params             
            callAdaptorFunc(this, "addParams", { dm: dm, query: query, params: query._params, reqParams: result });

            return {
                data: JSON.stringify(result),
                url: obj.url,
                ejPvtData: obj.ejPvtData,
                type: "POST",
                contentType: "application/json; charset=utf-8"
            }
        },
        addParams: function (options) {
            var dm = options.dm, query = options.query, params = options.params, req = options.reqParams; req["params"] = {};
            for (var i = 0, tmp; tmp = params[i]; i++) {
                if (req[tmp.key]) throwError("ej.Query: Custom Param is conflicting other request arguments");
                var webkey = tmp.key, webvalue = tmp.value;
                if (tmp.fn)
                    webvalue = tmp.fn.call(query, tmp.key, query, dm);
                req[webkey] = webvalue;
                req["params"][webkey] = req[webkey];
            }
        }
    });
    ej.CacheAdaptor = new ej.UrlAdaptor().extend({
        init: function (adaptor, timeStamp, pageSize) {
            if (!ej.isNullOrUndefined(adaptor)) {
                this.cacheAdaptor = adaptor;
            }
            this.pageSize = pageSize;
            this.guidId = ej.getGuid("cacheAdaptor");
            var obj = { keys: [], results: [] };
            if (window.localStorage)
                window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            var guid = this.guidId;
            if (!ej.isNullOrUndefined(timeStamp)) {
                setInterval(function () {
                    var data = ej.parseJSON(window.localStorage.getItem(guid));
                    var forDel = [];
                    for (var i = 0; i < data.results.length; i++) {
                        data.results[i].timeStamp = new Date() - new Date(data.results[i].timeStamp)
                        if (new Date() - new Date(data.results[i].timeStamp) > timeStamp)
                            forDel.push(i);
                    }
                    var d = forDel;
                    for (var i = 0; i < forDel.length; i++) {
                        data.results.splice(forDel[i], 1);
                        data.keys.splice(forDel[i], 1);
                    }
                    window.localStorage.removeItem(guid);
                    window.localStorage.setItem(guid, JSON.stringify(data));
                }, timeStamp);
            }
        },
        generateKey: function (url, query) {
            var sorted = filterQueries(query.queries, "onSortBy"),
                grouped = filterQueries(query.queries, "onGroup"),
                filters = filterQueries(query.queries, "onWhere"),
                searchs = filterQueries(query.queries, "onSearch"),
				pageQuery = filterQueries(query.queries, "onPage"),
                singles = filterQueryLists(query.queries, ["onSelect", "onPage", "onSkip", "onTake", "onRange"]),
                params = query._params;
            var key = url;
            if (singles["onPage"])
              key += singles["onPage"].pageIndex;
              sorted.forEach(function (obj) {
                   key += obj.e.direction + obj.e.fieldName;
              });
                grouped.forEach(function (obj) {
                    key += obj.e.fieldName;
                });
                searchs.forEach(function (obj) {
                    key += obj.e.searchKey;
                });
            
            for (var filter = 0; filter < filters.length; filter++) {
                var currentFilter = filters[filter];
                if (currentFilter.e.isComplex) {
                    var newQuery = query.clone();
                    newQuery.queries = [];
                    for (var i = 0; i < currentFilter.e.predicates.length; i++) {
                        newQuery.queries.push({ fn: "onWhere", e: currentFilter.e.predicates[i], filter: query.queries.filter });
                    }
                    key += currentFilter.e.condition + this.generateKey(url, newQuery);
                }
                else
                    key += currentFilter.e.field + currentFilter.e.operator + currentFilter.e.value
            }
            return key;
        },
        processQuery: function (dm, query, hierarchyFilters) {
            var key = this.generateKey(dm.dataSource.url, query);
            var cachedItems;
            if (window.localStorage)
                cachedItems = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var data = cachedItems ? cachedItems.results[cachedItems.keys.indexOf(key)] : null;
            if (data != null && !this._crudAction && !this._insertAction) {
                return data;
            }
            this._crudAction = null; this._insertAction = null;
            return this.cacheAdaptor.processQuery.apply(this.cacheAdaptor, [].slice.call(arguments, 0))
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (this._insertAction || (request && this.cacheAdaptor.options.batch && request.url.endsWith(this.cacheAdaptor.options.batch) && request.type.toLowerCase() === "post")) {
                return this.cacheAdaptor.processResponse(data, ds, query, xhr, request, changes);
            }
            var data = this.cacheAdaptor.processResponse.apply(this, [].slice.call(arguments, 0));
            var key = this.generateKey(ds.dataSource.url, query)
            var obj = {};
            if (window.localStorage)
                obj = ej.parseJSON(window.localStorage.getItem(this.guidId));
            var index = $.inArray(key, obj.keys);
            if (index != -1) {
                obj.results.splice(index, 1);
                obj.keys.splice(index, 1);
            }
            obj.results[obj.keys.push(key) - 1] = { keys: key, result: data.result, timeStamp: new Date(), count: data.count }
            while (obj.results.length > this.pageSize) {
                obj.results.splice(0, 1);
                obj.keys.splice(0, 1);
            }
            window.localStorage.setItem(this.guidId, JSON.stringify(obj));
            return data;
        },
        update: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.update(dm, keyField, value, tableName);
        },
        insert: function (dm, data, tableName) {
            this._insertAction = true;
            return this.cacheAdaptor.insert(dm, data, tableName);
        },
        remove: function (dm, keyField, value, tableName) {
            this._crudAction = true;
            return this.cacheAdaptor.remove(dm, keyField, value, tableName);
        },
        batchRequest: function (dm, changes, e) {
            return this.cacheAdaptor.batchRequest(dm, changes, e);
        }
    });
    var filterQueries = function (queries, name) {
        return queries.filter(function (q) {
            return q.fn === name;
        }) || [];
    };
    var filterQueryLists = function (queries, singles) {
        var filtered = queries.filter(function (q) {
            return singles.indexOf(q.fn) !== -1;
        }), res = {};
        for (var i = 0; i < filtered.length; i++) {
            if (!res[filtered[i].fn])
                res[filtered[i].fn] = filtered[i].e;
        }
        return res;
    };
    var callAdaptorFunc = function (obj, fnName, param, param1) {
        if (obj[fnName]) {
            var res = obj[fnName](param, param1);
            if (!isNull(res)) param = res;
        }
        return param;
    };

    ej.ODataAdaptor = new ej.UrlAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$inlinecount",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onEachWhere: function (filter, requiresCast) {
            return filter.isComplex ? this.onComplexPredicate(filter, requiresCast) : this.onPredicate(filter, requiresCast);
        },
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                operator,guid,
                val = pred.value,
                type = typeof val,
                field = this._p(pred.field);

            if (val instanceof Date)
                val = "datetime'" + p.replacer(val).toJSON() + "'";

            if (type === "string") {
				if(val.indexOf("'") != -1)
                    val = val.replace(new RegExp(/'/g),"''");
                val = "'" + val + "'";

                if (requiresCast) {
                    field = "cast(" + field + ", 'Edm.String')";
                }
                if (ej.isGUID(val))
                    guid = 'guid';
                if (pred.ignoreCase) {
                    !guid ? field = "tolower(" + field + ")" : field;
                    val = val.toLowerCase();
                }
            }

            operator = ej.data.odBiOperator[pred.operator];
            if (operator) {
                returnValue += field;
                returnValue += operator;
                if (guid)
                    returnValue += guid;
                return returnValue + val;
            }

            operator = ej.data.odUniOperator[pred.operator];
            if (!operator || type !== "string") return "";

            if (operator === "substringof") {
                var t = val;
                val = field;
                field = t;
            }

            returnValue += operator + "(";
            returnValue += field + ",";
            if (guid) returnValue += guid;
            returnValue += val + ")";

            return returnValue;
        },
        onComplexPredicate: function (pred, requiresCast) {
            var res = [];
            for (var i = 0; i < pred.predicates.length; i++) {
                res.push("(" + this.onEachWhere(pred.predicates[i], requiresCast) + ")");
            }
            return res.join(" " + pred.condition + " ");
        },
        onWhere: function (filters) {
            if (this.pvt.searches)
                filters.push(this.onEachWhere(this.pvt.searches, null, true));

            return filters.join(" and ");
        },
        onEachSearch: function (e) {
            if (e.fields.length === 0)
                throwError("Query() - Search : oData search requires list of field names to search");

            var filter = this.pvt.searches || [];
            for (var i = 0; i < e.fields.length; i++) {
                filter.push(new ej.Predicate(e.fields[i], e.operator, e.key, e.ignoreCase));
            }
            this.pvt.searches = filter;
        },
        onSearch: function (e) {
            this.pvt.searches = ej.Predicate.or(this.pvt.searches);
            return "";
        },
        onEachSort: function (e) {
            var res = [];
            if (e.name instanceof Array) {
                for (var i = 0; i < e.name.length; i++)
                    res.push(this._p(e.name[i]));
            } else {
                res.push(this._p(e.name) + (e.direction === "descending" ? " desc" : ""));
            }
            return res.join(",");
        },
        onSortBy: function (e) {
            return e.reverse().join(",");
        },
        onGroup: function (e) {
            this.pvt.groups = e;
            return "";
        },
        onSelect: function (e) {
            for (var i = 0; i < e.length; i++)
                e[i] = this._p(e[i]);

            return e.join(',');
        },
        onAggregates: function(e){
            this.pvt.aggregates = e;
            return "";
        },
        onCount: function (e) {
            return e === true ? "allpages" : "";
        },
        beforeSend: function (dm, request, settings) {
            if (settings.url.endsWith(this.options.batch) && settings.type.toLowerCase() === "post") {
                request.setRequestHeader("Accept", oData.multipartAccept);
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.overrideMimeType("text/plain; charset=x-user-defined");
            }

            if (!dm.dataSource.crossDomain) {
                request.setRequestHeader("DataServiceVersion", "2.0");
                request.setRequestHeader("MaxDataServiceVersion", "2.0");
            }
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            if (!ej.isNullOrUndefined(data.d)) {
                var dataCopy = (query && query._requiresCount) ? data.d.results : data.d;
                if (!ej.isNullOrUndefined(dataCopy))
                    for (var i = 0; i < dataCopy.length; i++) {
                        !ej.isNullOrUndefined(dataCopy[i].__metadata) && delete dataCopy[i].__metadata;
                    }
            }
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                    if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
            }
            var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
            version = (version && parseInt(version, 10)) || 2;

            if (query && query._requiresCount) {
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
                if (data.d) data = data.d;
                if (data.__count || data['odata.count']) count = data.__count || data['odata.count'];
            }

            if (version === 3 && data.value) data = data.value;
            if (data.d) data = data.d;
            if (version < 3 && data.results) data = data.results;

            if (pvt && pvt.aggregates && pvt.aggregates.length) {
                var agg = pvt.aggregates, args = {}, fn, res = {};
                for (var i = 0; i < agg.length; i++) {
                    fn = ej.aggregates[agg[i].type];
                    if (fn)
                        res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                }
                aggregateResult = res;
            }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries)
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
        convertToQueryString: function (req, query, dm) {
            var res = [], tableName = req.table || "";
            delete req.table;

            if (dm.dataSource.requiresFormat)
                req["$format"] = "json";

            for (var prop in req)
                res.push(prop + "=" + req[prop]);

            res = res.join("&");

            if (dm.dataSource.url && dm.dataSource.url.indexOf("?") !== -1 && !tableName)
                return res;

            return res.length ? tableName + "?" + res : tableName || "";
        },
        insert: function (dm, data, tableName) {
            return {
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : ''),
                data: JSON.stringify(data)
            }
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value + ')'
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url.replace(/\/*$/, tableName ? '/' + tableName : '') + '(' + value[keyField] + ')',
                data: JSON.stringify(value),
                accept: this.options.accept
            };
        },
        batchRequest: function (dm, changes, e) {
            var initialGuid = e.guid = ej.getGuid(oData.batchPre);
            var url = dm.dataSource.url.replace(/\/*$/, '/' + this.options.batch);
            var args = {
                url: e.url,
                key: e.key,
                cid: 1,
                cSet: ej.getGuid(oData.changeSet)
            };
            var req = "--" + initialGuid + "\n";

            req += "Content-Type: multipart/mixed; boundary=" + args.cSet.replace("--", "") + "\n";

            this.pvt.changeSet = 0;

            req += this.generateInsertRequest(changes.added, args);
            req += this.generateUpdateRequest(changes.changed, args);
            req += this.generateDeleteRequest(changes.deleted, args);

            req += args.cSet + "--\n";
            req += "--" + initialGuid + "--";

            return {
                type: "POST",
                url: url,
                contentType: "multipart/mixed; charset=UTF-8;boundary=" + initialGuid,
                data: req
            };
        },
        generateDeleteRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "DELETE ";
                req += e.url + "(" + arr[i][e.key] + ") HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n";
            }

            return req + "\n";
        },
        generateInsertRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "POST ";
                req += e.url + " HTTP/1.1\n";
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n";
            }

            return req;
        },
        generateUpdateRequest: function (arr, e) {
            if (!arr) return "";
            var req = "";

            for (var i = 0; i < arr.length; i++) {
                req += "\n" + e.cSet + "\n";
                req += oData.changeSetContent + "\n\n";
                req += "PUT ";
                req += e.url + "(" + arr[i][e.key] + ")" + " HTTP/1.1\n";
                req += "If-Match : * \n"
                req += "Accept: " + oData.accept + "\n";
                req += "Content-Id: " + this.pvt.changeSet++ + "\n";
                req += oData.batchChangeSetContentType + "\n\n";

                req += JSON.stringify(arr[i]) + "\n\n";
            }

            return req;
        },
        _p: function (prop) {
            return prop.replace(/\./g, "/");
        }
    });
    ej.ODataV4Adaptor = new ej.ODataAdaptor().extend({
        options: {
            requestType: "get",
            accept: "application/json;odata=light;q=1,application/json;odata=verbose;q=0.5",
            multipartAccept: "multipart/mixed",
            sortBy: "$orderby",
            select: "$select",
            skip: "$skip",
            take: "$top",
            count: "$count",
            search: "$search",
            where: "$filter",
            expand: "$expand",
            batch: "$batch",
            changeSet: "--changeset_",
            batchPre: "batch_",
            contentId: "Content-Id: ",
            batchContent: "Content-Type: multipart/mixed; boundary=",
            changeSetContent: "Content-Type: application/http\nContent-Transfer-Encoding: binary ",
            batchChangeSetContentType: "Content-Type: application/json; charset=utf-8 "
        },
        onCount: function (e) {
            return e === true ? "true" : "";
        },
        onPredicate: function (pred, query, requiresCast) {
            var returnValue = "",
                val = pred.value,
                isDate = val instanceof Date;               
            ej.data.odUniOperator["contains"] = "contains";
            returnValue = ej.ODataAdaptor.prototype.onPredicate.call(this, pred, query, requiresCast);
            ej.data.odUniOperator["contains"] = "substringof";
                if (isDate)
                    returnValue = returnValue.replace(/datetime'(.*)'$/, "$1");

            return returnValue;
        },
        onEachSearch: function (e) {
			 var search = this.pvt.search || [];
			 search.push(e.key);
			 this.pvt.search = search;
		},
		onSearch: function (e) {
			 return this.pvt.search.join(" OR ");
		},
        beforeSend: function (dm, request, settings) {
 
        },
        processQuery: function (ds, query) {
            var digitsWithSlashesExp = /\/[\d*\/]*/g;
            var poppedExpand = "";
            for (var i = query._expands.length - 1; i > 0; i--) {
                if (poppedExpand.indexOf(query._expands[i]) >= 0) { // If current expand is child of previous
                    query._expands.pop(); // Just remove it because its in the expand already
                }
                else {
                    if (digitsWithSlashesExp.test(query._expands[i])) { //If expanded to subentities
                        poppedExpand = query._expands.pop();
                        var r = poppedExpand.replace(digitsWithSlashesExp, "($expand="); //Rewrite into odata v4 expand
                        for (var j = 0; j < poppedExpand.split(digitsWithSlashesExp).length - 1; j++) {
                            r = r + ")"; // Add closing brackets
                        }
                        query._expands.unshift(r); // Add to the front of the array
                        i++;
                    }
                }
            }
            return ej.ODataAdaptor.prototype.processQuery.apply(this, [ds, query]);
        },
        processResponse: function (data, ds, query, xhr, request, changes) {
            var pvt = request && request.ejPvtData;
            if (xhr && xhr.getResponseHeader("Content-Type") && xhr.getResponseHeader("Content-Type").indexOf("xml") != -1 && data.nodeType == 9)
                return query._requiresCount ? { result: [], count: 0 } : [];
            if (request && this.options.batch && request.url.endsWith(this.options.batch) && request.type.toLowerCase() === "post") {
                var guid = xhr.getResponseHeader("Content-Type"), cIdx, jsonObj;
                guid = guid.substring(guid.indexOf("=batchresponse") + 1);
                data = data.split(guid);
                if (data.length < 2) return;

                data = data[1];
                var exVal = /(?:\bContent-Type.+boundary=)(changesetresponse.+)/i.exec(data);
                data.replace(exVal[0], "");

                var changeGuid = exVal[1];
                data = data.split(changeGuid);

                for (var i = data.length; i > -1; i--) {
                   if (!/\bContent-ID:/i.test(data[i]) || !/\bHTTP.+201/.test(data[i]))
                        continue;

                    cIdx = parseInt(/\bContent-ID: (\d+)/i.exec(data[i])[1]);

                    if (changes.added[cIdx]) {
                        jsonObj = p.parseJson(/^\{.+\}/m.exec(data[i])[0]);
                        $.extend(changes.added[cIdx], this.processResponse(jsonObj));
                    }
                }
                return changes;
           }
            var count = null, aggregateResult = {};
            if (query && query._requiresCount)
                if ('@odata.count' in data) count = data['@odata.count'];

            data = ej.isNullOrUndefined(data.value) ? data : data.value;
           if (pvt && pvt.aggregates && pvt.aggregates.length) {
               var agg = pvt.aggregates, args = {}, fn, res = {};
               for (var i = 0; i < agg.length; i++) {
                   fn = ej.aggregates[agg[i].type];
                   if (fn)
                       res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
               }
               aggregateResult = res;
           }
            if (pvt && pvt.groups && pvt.groups.length) {
                var groups = pvt.groups;
                for (var i = 0; i < groups.length; i++) {
                    var format = getColFormat(groups[i], query.queries);
                    data = ej.group(data, groups[i], pvt.aggregates, format);
                }
            }
            return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
        },
    });
    ej.JsonAdaptor = new ej.Adaptor().extend({
        processQuery: function (ds, query) {
            var result = ds.dataSource.json.slice(0), count = result.length, cntFlg = true, ret, key, agg = {};

            for (var i = 0; i < query.queries.length; i++) {
                key = query.queries[i];
                ret = this[key.fn].call(this, result, key.e, query);
                if (key.fn == "onAggregates")
                    agg[key.e.field + " - " + key.e.type] = ret;
                else
                result = ret !== undefined ? ret : result;

                if (key.fn === "onPage" || key.fn === "onSkip" || key.fn === "onTake" || key.fn === "onRange") cntFlg = false;

                if (cntFlg) count = result.length;
            }

            if (query._requiresCount) {
                result = {
                    result: result,
                    count: count,
                    aggregates: agg
                };
            }

            return result;
        },
        batchRequest: function (dm, changes, e) {
            var i;
            for (i = 0; i < changes.added.length; i++)
                this.insert(dm, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                this.update(dm, e.key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                this.remove(dm, e.key, changes.deleted[i]);
            return changes;
        },
        onWhere: function (ds, e) {
            if (!ds) return ds;

            return ds.filter(function (obj) {
                return e.validate(obj);
            });
        },
        onAggregates: function(ds, e){
            var fn = ej.aggregates[e.type];
            if (!ds || !fn || ds.length == 0) return null;
            return fn(ds, e.field);
        },
        onSearch: function (ds, e) {
            if (!ds || !ds.length) return ds;

            if (e.fieldNames.length === 0) {
                ej.pvt.getFieldList(ds[0], e.fieldNames);
            }

            return ds.filter(function (obj) {
                for (var j = 0; j < e.fieldNames.length; j++) {
                    if (e.comparer.call(obj, ej.pvt.getObject(e.fieldNames[j], obj), e.searchKey, e.ignoreCase))
                        return true;
                }
                return false;
            });
        },
        onSortBy: function (ds, e, query) {
            if (!ds) return ds;
            var fnCompare, field = getValue(e.fieldName, query);
            if (!field)
                return ds.sort(e.comparer);

            if (field instanceof Array) {
                field = field.slice(0);

                for (var i = field.length - 1; i >= 0; i--) {
                    if (!field[i]) continue;

                    fnCompare = e.comparer;

                    if (field[i].endsWith(" desc")) {
                        fnCompare = ej.pvt.fnSort(ej.sortOrder.Descending);
                        field[i] = field[i].replace(" desc", "");
                    }

                    ds = stableSort(ds, field[i], fnCompare, []);
                }
                return ds;
            }
            return stableSort(ds, field, e.comparer, query ? query.queries : []);
        },
        onGroup: function (ds, e, query) {
            if (!ds) return ds;
            var aggQuery = filterQueries(query.queries, "onAggregates"), agg = [];
            if (aggQuery.length) {
                var tmp;
                for (var i = 0; i < aggQuery.length; i++) {
                    tmp = aggQuery[i].e;
                    agg.push({ type: tmp.type, field: getValue(tmp.field, query) });
                }
            }
            var format = getColFormat(e.fieldName, query.queries);
            return ej.group(ds, getValue(e.fieldName, query), agg, format);
        },
        onPage: function (ds, e, query) {
            var size = getValue(e.pageSize, query),
                start = (getValue(e.pageIndex, query) - 1) * size, end = start + size;

            if (!ds) return ds;

            return ds.slice(start, end);
        },
        onRange: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.start), getValue(e.end));
        },
        onTake: function (ds, e) {
            if (!ds) return ds;

            return ds.slice(0, getValue(e.nos));
        },
        onSkip: function (ds, e) {
            if (!ds) return ds;
            return ds.slice(getValue(e.nos));
        },
        onSelect: function (ds, e) {
            if (!ds) return ds;
            return ej.select(ds, getValue(e.fieldNames));
        },
        insert: function (dm, data) {
            return dm.dataSource.json.push(data);
        },
        remove: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i;
            if (typeof value === "object")
                value = ej.getObject(keyField, value);
            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === value) break;
            }

            return i !== ds.length ? ds.splice(i, 1) : null;
        },
        update: function (dm, keyField, value, tableName) {
            var ds = dm.dataSource.json, i, key = ej.getObject(keyField, value);

            for (i = 0; i < ds.length; i++) {
                if (ej.getObject(keyField, ds[i]) === key) break;
            }

            return i < ds.length ? $.extend(ds[i], value) : null;
        }
    });
    ej.ForeignKeyAdaptor = function (data, type) {
        var foreignObj = new ej[type || "JsonAdaptor"]().extend({
            init: function () {
                this.foreignData = [];
                this.key = [];
                this.adaptorType = type;
                this.value = [];
                this.fValue = [];
                this.keyField = [];
                var dataObj = data;
                for (var i = 0; i < dataObj.length; i++) {
                    this.foreignData[i] = dataObj[i].dataSource;
                    this.key[i] = dataObj[i].foreignKeyField;
                    this.fValue[i] = ej.isNullOrUndefined(dataObj[i].field)? dataObj[i].foreignKeyValue : dataObj[i].field + "_" + dataObj[i].foreignKeyValue;
                    this.value[i] = dataObj[i].foreignKeyValue;
                    this.keyField[i] = dataObj[i].field || dataObj[i].foreignKeyField;
                    this.initial = true;
                }
            },
            processQuery: function (ds, query) {
                var data = ds.dataSource.json;
                if (this.initial) {
                    for (var i = 0; i < data.length; i++) {
                        var proxy = this;
                        for (var j = 0; j < this.foreignData.length; j++) {
                            this.foreignData[j].filter(function (col) { //filtering the foreignKey dataSource
                                if (ej.getObject(proxy.key[j], col) == ej.getObject(proxy.keyField[j], data[i]))
                                    data[i][proxy.fValue[j]] = ej.getObject(proxy.value[j], col);
                            });
                        }
                    }
                    this.initial = false;
                }
                return this.base.processQuery.apply(this, [ds, query]);
            },
            setValue: function (value) {
                for (var i = 0; i < this.foreignData.length; i++) {
                    var proxy = this;
                    var keyValue = value[this.fValue[i]];
                    if (typeof keyValue == "string" && !isNaN(keyValue))
                        keyValue = ej.parseFloat(keyValue);
                    var data = $.grep(proxy.foreignData[i], function (e) {
                        return e[proxy.value[i]] == keyValue;
                    })[0];
                    if (ej.isNullOrUndefined(data)) {
                        data = $.grep(proxy.foreignData[i], function (e) {
                            return e[proxy.key[i]] == keyValue;
                        })[0];
                        if (ej.getObject(this.value[i], data) != undefined)
                            ej.createObject(proxy.value[i], ej.getObject(this.value[i], data), value);
                    }
                    if (ej.getObject(this.value[i], data) != undefined)
                        ej.createObject(this.keyField[i], ej.getObject(this.key[i], data), value);
                }
            },
            insert: function (dm, data, tableName) {
                this.setValue(data);
                return {
                    url: dm.dataSource.insertUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: data,
                        table: tableName,
                        action: "insert"
                    })
                };
            },
            update: function (dm, keyField, value, tableName) {
                this.setValue(value);
                ej.JsonAdaptor.prototype.update(dm, keyField, value, tableName);
                return {
                    type: "POST",
                    url: dm.dataSource.updateUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                    data: JSON.stringify({
                        value: value,
                        action: "update",
                        keyColumn: keyField,
                        key: value[keyField],
                        table: tableName
                    })
                };
            }
        });
        $.extend(this, new foreignObj());
        return this;
    }
    ej.remoteSaveAdaptor = new ej.JsonAdaptor().extend({
        beforeSend: ej.UrlAdaptor.prototype.beforeSend,
        insert: ej.UrlAdaptor.prototype.insert,
        update: ej.UrlAdaptor.prototype.update,
        remove: ej.UrlAdaptor.prototype.remove,
        addParams: ej.UrlAdaptor.prototype.addParams,
        batchRequest: function (dm, changes, e, query) { 
			var res = {
                changed: changes.changed,
                added: changes.added,
                deleted: changes.deleted,
                action: "batch",
                table: e.url,
                key: e.key
            };
            if (query)
                this.addParams({ dm: dm, query: query, params: query._params, reqParams: res });
            return {
                type: "POST",
                url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                data: JSON.stringify(res)
            };
        },
         processResponse: function (data, ds, query, xhr, request, changes, key) {
			if(!ej.isNullOrUndefined(changes)){
            var i;
            for (i = 0; i < changes.added.length; i++)
                ej.JsonAdaptor.prototype.insert(ds, changes.added[i]);
            for (i = 0; i < changes.changed.length; i++)
                ej.JsonAdaptor.prototype.update(ds, key, changes.changed[i]);
            for (i = 0; i < changes.deleted.length; i++)
                ej.JsonAdaptor.prototype.remove(ds, key, changes.deleted[i]);
            return this.base.processResponse.apply(this, [data, ds, query, xhr, request, changes]);
             }
            else{
                if (data.d)
               return data.d;
            return data;
            }
        }
    });
    ej.WebApiAdaptor = new ej.ODataAdaptor().extend({
        insert: function (dm, data, tableName) {
            return {
                type: "POST",
                url: dm.dataSource.url,
                data: JSON.stringify(data)
            };
        },
        remove: function (dm, keyField, value, tableName) {
            return {
                type: "DELETE",
                url: dm.dataSource.url + "/" + value,
                data: JSON.stringify(value)
            };
        },
        update: function (dm, keyField, value, tableName) {
            return {
                type: "PUT",
                url: dm.dataSource.url,
                data: JSON.stringify(value)
            };
        },
		batchRequest: function (dm, changes, e) {
            var initialGuid = e.guid = ej.getGuid(oData.batchPre);
            var req = [];

		    //insertion 
		
			$.each(changes.added, function (i, d) {
			    req.push('--' + initialGuid);
			    req.push('Content-Type: application/http; msgtype=request', '');
			    req.push('POST' + ' ' + dm.dataSource.insertUrl + ' HTTP/1.1');
			    req.push('Content-Type: ' + 'application/json; charset=utf-8');
			    req.push('Host: ' + location.host);
			    req.push('', d ? JSON.stringify(d) : '');
			});
			
			//updation
			$.each(changes.changed, function (i, d) {
			    req.push('--' + initialGuid);
			    req.push('Content-Type: application/http; msgtype=request', '');
			    req.push('PUT' + ' ' + dm.dataSource.updateUrl + ' HTTP/1.1');
			    req.push('Content-Type: ' + 'application/json; charset=utf-8');
			    req.push('Host: ' + location.host);
			    req.push('', d ? JSON.stringify(d) : '');
			});
			
			//deletion
			$.each(changes.deleted, function (i, d) {
			    req.push('--' + initialGuid);
                req.push('Content-Type: application/http; msgtype=request', '');
                req.push('DELETE' + ' ' + dm.dataSource.removeUrl +"/"+ d[e.key] + ' HTTP/1.1');
                req.push('Content-Type: ' + 'application/json; charset=utf-8');
                req.push('Host: ' + location.host);
                req.push('', d ? JSON.stringify(d) : '');		
			});
			req.push('--' + initialGuid + '--', '');
            return {
				type: 'POST',
				url: dm.dataSource.batchUrl || dm.dataSource.crudUrl || dm.dataSource.url,
                data: req.join('\r\n'),
                contentType: 'multipart/mixed; boundary="' + initialGuid + '"',
            };
        },
        processResponse: function (data, ds, query, xhr, request, changes) {

            var pvt = request && request.ejPvtData;
            if (request && request.type.toLowerCase() != "post") {
                var version = xhr && xhr.getResponseHeader("DataServiceVersion"), count = null, aggregateResult = {};
                version = (version && parseInt(version, 10)) || 2;

                if (query && query._requiresCount) {
                     if (!isNull(data.Count)) count = data.Count;
                }

                if (version < 3 && data.Items) data = data.Items;

                if (pvt && pvt.aggregates && pvt.aggregates.length) {
                    var agg = pvt.aggregates, args = {}, fn, res = {};
                    for (var i = 0; i < agg.length; i++) {
                        fn = ej.aggregates[agg[i].type];
                        if (fn)
                            res[agg[i].field + " - " + agg[i].type] = fn(data, agg[i].field);
                    }
                    aggregateResult = res;
                }
                if (pvt && pvt.groups && pvt.groups.length) {
                    var groups = pvt.groups;
                    for (var i = 0; i < groups.length; i++) {
                        var format = getColFormat(groups[i], query.queries);
                        data = ej.group(data, groups[i], pvt.aggregates, format);
                    }
                }
                return isNull(count) ? data : { result: data, count: count, aggregates: aggregateResult };
            }
        }
    });
    var getValue = function (value, inst) {
        if (typeof value === "function")
            return value.call(inst || {});
        return value;
    }

    ej.TableModel = function (name, jsonArray, dataManager, modelComputed) {
        if (!instance(this, ej.TableModel))
            return new ej.TableModel(jsonArray);

        if (!instance(jsonArray, Array))
            throwError("ej.TableModel - Json Array is required");

        var rows = [], model, dirtyFn = $proxy(setDirty, this);

        for (var i = 0; i < jsonArray.length; i++) {
            model = new ej.Model(jsonArray[i], this);
            model.state = "unchanged";
            model.on("stateChange", dirtyFn);
            if (modelComputed)
                model.computes(modelComputed);
            rows.push(model);
        }

        this.name = name || "table1";

        this.rows = ej.NotifierArray(rows);
        this._deleted = [];

        this._events = $({});

        this.dataManager = dataManager;

        this._isDirty = false;

        return this;
    };

    ej.TableModel.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },

        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },

        setDataManager: function (dataManager) {
            this.dataManagar = dataManager;
        },

        saveChanges: function () {
            if (!this.dataManager || !instance(this.dataManager, ej.DataManager))
                throwError("ej.TableModel - saveChanges : Set the dataManager using setDataManager function");

            if (!this.isDirty())
                return;

            var promise = this.dataManager.saveChanges(this.getChanges(), this.key, this.name);

            promise.done($proxy(function (changes) {
                var rows = this.toArray();
                for (var i = 0; i < rows.length; i++) {
                    if (rows.state === "added") {
                        rows.set(this.key, changes.added.filter(function (e) {
                            return e[this.key] === rows.get(this.key);
                        })[0][this.key]);
                    }
                    rows[i].markCommit();
                }

                this._events.triggerHandler({ type: "save", table: this });

            }, this));

            promise.fail($proxy(function (e) {
                this.rejectChanges();
                this._events.triggerHandler({ type: "reject", table: this, error: e });
            }, this));

            this._isDirty = false;
        },

        rejectChanges: function () {
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++)
                rows[i].revert(true);

            this._isDirty = false;
            this._events.triggerHandler({ type: "reject", table: this });
        },

        insert: function (json) {
            var model = new ej.Model(json);
            model._isDirty = this._isDirty = true;

            this.rows.push(model);

            this._events.triggerHandler({ type: "insert", model: model, table: this });
        },

        update: function (value) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var row = value, model, key = this.key, keyValue = row[key];

            model = this.rows.array.filter(function (obj) {
                return obj.get(key) === keyValue;
            });

            model = model[0];

            for (var col in row) {
                model.set(col, row[col]);
            }

            this._isDirty = true;

            this._events.triggerHandler({ type: "update", model: model, table: this });
        },

        remove: function (key) {
            if (!this.key)
                throwError("TableModel - update : Primary key should be assigned to TableModel.key");

            var field = this.key;

            var index = -1, model;

            if (key && typeof key === "object") {
                key = key[field] !== undefined ? key[field] : key.get(field);
            }

            for (var i = 0; i < this.rows.length() ; i++) {
                if (this.rows.array[i].get(field) === key) {
                    index = i;
                    break;
                }
            }

            if (index > -1) {
                model = this.rows.removeAt(index);
                model.markDelete();

                this._deleted.push({ model: model, position: index });

                this._isDirty = true;
                this._events.triggerHandler({ type: "remove", model: model, table: this });
            }
        },

        isDirty: function () {
            return this._isDirty;
        },

        getChanges: function () {

            var changes = {
                added: [],
                changed: []
            };
            var rows = this.toArray();
            for (var i = 0; i < rows.length; i++) {
                if (changes[rows[i].state])
                    changes[rows[i].state].push(rows[i].json);
            }

            changes.deleted = ej.select(this._deleted, ["model"]);

            return changes;
        },

        toArray: function () {
            return this.rows.toArray();
        },

        setDirty: function (dirty, model) {
            if (this._isDirty === !!dirty) return;

            this._isDirty = !!dirty;

            this._events.triggerHandler({ type: "dirty", table: this, model: model });
        },
        get: function (index) {
            return this.rows.array[index];
        },
        length: function () {
            return this.rows.array.length;
        },

        bindTo: function (element) {
            var marker = tDiv, template = $(element.html()), rows = this.toArray(), cur;
            if ($.inArray(element.prop("tagName").toLowerCase(), ["table", "tbody"]))
                marker = tTR;

            marker.insertBefore(element);
            element.detach().empty();

            for (var i = 0; i < rows.length; i++) {
                cur = template.clone();
                rows[i].bindTo(cur);
                element.append(cur);
            }

            element.insertAfter(marker);
            marker.remove();
        }
    };

    var tDiv = doc ? $(document.createElement("div")) : {},
        tTR = doc ? $(document.createElement("tr")) : {};

    ej.Model = function (json, table, name) {
        if (typeof table === "string") {
            name = table;
            table = null;
        }
        this.$id = getUid("m");

        this.json = json;
        this.table = table instanceof ej.TableModel ? table : null;
        this.name = name || (this.table && this.table.name);
        this.dataManager = (table instanceof ej.DataManager) ? table : table.dataManagar;
        this.actual = {};
        this._events = $({});
        this.isDirty = false;
        this.state = "added";
        this._props = [];
        this._computeEls = {};
        this._fields = {};
        this._attrEls = {};
        this._updates = {};
        this.computed = {};
    };

    ej.Model.prototype = {
        computes: function (value) {
            $.extend(this.computed, value);
        },
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        set: function (field, value) {
            var obj = this.json, actual = field, prev;
            field = field.split('.');

            for (var i = 0; i < field.length - 1; i++) {
                field = field[0];
                obj = obj[field[0]];
            }

            this.isDirty = true;
            this.changeState("changed", { from: "set" });

            prev = obj[field];

            if (this.actual[field] === undefined && !(field in this.actual))
                this.actual[field] = value; // Complex property ?

            obj[field] = value;

            this._updateValues(field, value);
            this._events.triggerHandler({ type: actual, current: value, previous: prev, model: this });
        },
        get: function (field) {
            return ej.pvt.getObject(field, this.json);
        },
        revert: function (suspendEvent) {
            for (var prop in this.actual) {
                this.json[prop] = this.actual[prop];
            }

            this.isDirty = false;

            if (suspendEvent)
                this.state = "unchanged";
            else
                this.changeState("unchanged", { from: "revert" });
        },
        save: function (dm, key) {
            dm = dm || this.dataManagar;
            key = key || dm.dataSource.key;
            if (!dm) throwError("ej.Model - DataManager is required to commit the changes");
            if (this.state === "added") {
                return dm.insert(this.json, this.name).done(ej.proxy(function (e) {
                    $.extend(this.json, e.record);
                }, this));
            }
            else if (this.state === "changed") {
                return dm.update(key, this.json, this.name);
            }
            else if (this.state === "deleted") {
                return dm.remove(key, this.json, this.name);
            }
        },
        markCommit: function () {
            this.isDirty = false;
            this.changeState("unchanged", { from: "commit" });
        },
        markDelete: function () {
            this.changeState("deleted", { from: "delete" });
        },
        changeState: function (state, args) {
            if (this.state === state) return;

            if (this.state === "added") {
                if (state === "deleted")
                    state = "unchanged";
                else return;
            }

            var prev = state;
            args = args || {};

            this.state = state;
            this._events.triggerHandler($.extend({ type: "stateChange", current: state, previous: prev, model: this }, args));
        },
        properties: function () {
            if (this._props.length)
                return this._props;

            for (var pr in this.json) {
                this._props.push(pr);
                this._updates[pr] = { read: [], input: [] };
            }

            return this._props;
        },
        bindTo: function (element) {
            var el = $(element), ctl, field,
                elements = el.find("[ej-observe], [ej-computed], [ej-prop]"), len = elements.length;

            el.data("ejModel", this);
            var unbindData = { fields: [], props: [], computes: [] };
            for (var i = 0; i < len; i++) {
                ctl = elements.eq(i);

                field = ctl.attr("ej-prop");
                if (field) {
                    this._processAttrib(field, ctl, unbindData);
                }
                field = ctl.attr("ej-observe");
                if (field && this._props.indexOf(field) !== -1) {
                    this._processField(ctl, field, unbindData);
                    continue;
                }

                field = ctl.attr("ej-computed");
                if (field) {
                    this._processComputed(field, ctl, unbindData);
                    continue;
                }
            }
            el.data("ejModelBinding" + this.$id, unbindData);
        },
        unbind: function (element) {
            var tmp, data = {
                props: this._attrEls,
                computes: this._computeEls
            }, isCustom = false;

            if (element) {
                data = $(element).removeData("ejModel").data("ejModelBinding" + this.$id) || data;
                isCustom = true;
            }

            for (var p in this.computed) {
                tmp = data.computes[p], p = this.computed[p];
                if (tmp && p.deps) {
                    this.off(p.deps.join(' '), tmp.handle);
                    if (isCustom)
                        delete this._computeEls[p];
                }
            }
            if (!isCustom)
                this._computeEls = {};

            for (var p in data.props) {
                tmp = data.props[p];
                if (tmp) {
                    this.off(tmp.deps.join(' '), tmp.handle);
                    delete data.props[p];
                    if (isCustom)
                        delete this._attrEls[p];
                }
            }
            if (!isCustom)
                this._attrEls = {};

            if (data.fields && data.fields.length) {
                var len = data.fields.length, ctl, idx, ty;
                for (var i = 0; i < len; i++) {
                    ctl = data.fields[i];
                    $(ctl).off("change", null, this._changeHandler);

                    ty = this.formElements.indexOf(ctl.tagName.toLowerCase()) !== -1 ? "input" : "read";
                    idx = this._updates[ty].indexOf(ctl);
                    if (idx !== -1)
                        this._updates[ty].splice(idx, 1);
                }
            }
        },
        _processComputed: function (value, element, data) {
            if (!value) return;

            var val, deps, safeVal = safeStr(value),
            type = this.formElements.indexOf(element[0].tagName.toLowerCase()) !== -1 ? "val" : "html";

            if (!this.computed[value] || !this.computed[safeVal]) {
                this.computed[safeVal] = {
                    value: new Function("var e = this; return " + value),
                    deps: this._generateDeps(value)
                }
                value = safeVal;
            }

            val = this.computed[value];
            if (!val.get) {
                val.get = function () {
                    val.value.call(this.json);
                }
            }

            deps = val.deps;
            val = val.value;

            this._updateDeps(deps);
            this._updateElement(element, type, val);

            val = { el: element, handle: $proxy(this._computeHandle, this, { value: value, type: type }) };
            this._computeEls[value] = val;
            data.computes[value] = val;

            this.on(deps.join(' '), val.handle);
        },
        _computeHandle: function (e) {
            var el = this._computeEls[e.value];
            if (el && this.computed[e.value])
                this._updateElement(el.el, e.type, this.computed[e.value].value);
        },
        _updateElement: function (el, type, val) {
            el[type](val.call($.extend({}, this.json, this.computed)));
        },
        _updateDeps: function (deps) {
            for (var i = 0; i < deps.length; i++) {
                if (!(deps[i] in this.json) && deps[i] in this.computed)
                    ej.merge(deps, this.computed[deps[i]].deps);
            }
        },
        _generateDeps: function (value) {
            var splits = value.replace(/(^e\.)|( e\.)/g, '#%^*##ej.#').split("#%^*#"),
                field, deps = [];

            for (var i = 0; i < splits.length; i++) {
                if (splits[i].startsWith("#ej.#")) {
                    field = splits[i].replace("#ej.#", "").split(' ')[0];
                    if (field && this._props.indexOf(field) !== -1)
                        deps.push(field);
                }
            }

            return deps;
        },
        _processAttrib: function (value, el, data) {
            var prop, val, res = {};
            value = value.replace(/^ +| +$/g, "").split(";");
            for (var i = 0; i < value.length; i++) {
                value[i] = value[i].split(":");
                if (value[i].length < 2) continue;

                prop = value[i][0].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
                res[prop] = value[i][1].replace(/^ +| +$/g, "").replace(/^'|^"|'$|"$/g, "");
            }
            value = res;
            var deps = [];
            for (prop in value)
                deps.push(value[prop]);

            this._updateDeps(deps);
            this._updateProps(el, value);

            res = getUid("emak");
            val = { el: el, handle: $proxy(this._attrHandle, this, res), value: value, deps: deps };
            el.prop("ejmodelattrkey", res);

            data.props[res] = val;
            this._attrEls[res] = val;

            this.on(deps.join(' '), val.handle);
        },
        _attrHandle: function (res) {
            var el = this._attrEls[res];
            if (el)
                this._updateProps(el.el, el.value);
        },
        _updateProps: function (element, value) {
            var json = this.json, t, c = this.computed;
            for (var prop in value) {
                t = value[prop];
                if (t in json)
                    t = json[t];
                else if (t in c) {
                    t = c[t];
                    if (t) {
                        t = t.value.call($.extend({}, this.json, c));
                    }
                }

                if (!isNull(t)) {
                    element.prop(prop, t);
                }
            }
        },
        _updateValues: function (prop, value) {
            var arr = this._updates[prop];

            if (!arr || (!arr.read && !arr.input)) return;

            this._ensureItems(arr.read, "html", value);
            this._ensureItems(arr.input, "val", value);
        },
        _ensureItems: function (a, type, value) {
            if (!a) return;

            for (var i = a.length - 1; i > -1; i--) {
                if (!a[i].offsetParent) {
                    a.splice(i, 1);
                    continue;
                }
                $(a[i])[type](value);
            }
        },
        _changeHandler: function (e) {
            e.data.self.set(e.data.prop, $(this).val());
        },
        _processField: function (ctl, field, data) {
            var e = { self: this, prop: field }, val = this.get(field);

            data.fields.push(ctl[0]);

            if (this.formElements.indexOf(ctl[0].tagName.toLowerCase()) === -1) {
                ctl.html(val);
                return this._updates[field].read.push(ctl[0]);
            }

            ctl.val(val)
                    .off("change", null, this._changeHandler)
                    .on("change", null, e, this._changeHandler);

            return this._updates[field].input.push(ctl[0]);
        },
        formElements: ["input", "select", "textarea"]
    };

    var safeReg = /[^\w]+/g;
    var safeStr = function (value) {
        return value.replace(safeReg, "_");
    };
    var setDirty = function (e) {
        this.setDirty(true, e.model);
    };

    ej.Predicate = function (field, operator, value, ignoreCase) {
        if (!(this instanceof ej.Predicate))
            return new ej.Predicate(field, operator, value, ignoreCase);

        if (typeof field === "string") {
            this.field = field;
            this.operator = operator;
            this.value = value;
            this.ignoreCase = ignoreCase;
            this.isComplex = false;

            this._comparer = ej.data.fnOperators.processOperator(this.operator);

        } else if (field instanceof ej.Predicate && value instanceof ej.Predicate || value instanceof Array) {
            this.isComplex = true;
            this.condition = operator.toLowerCase();
            this.predicates = [field];
            if (value instanceof Array)
                [].push.apply(this.predicates, value);
            else
                this.predicates.push(value);
        }
        return this;
    };

    ej.Predicate.and = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "and");
    };

    ej.Predicate.or = function () {
        return pvtPredicate._combinePredicates([].slice.call(arguments, 0), "or");
    };

    ej.Predicate.fromJSON = function (json) {
        if (instance(json, Array)) {
            var res = [];
            for (var i = 0, len = json.length; i < len; i++)
                res.push(pvtPredicate._fromJSON(json[i]));
            return res;
        }

        return pvtPredicate._fromJSON(json);
    };

    // Private fn
    var pvtPredicate = {
        _combinePredicates: function (predicates, operator) {
            if (!predicates.length) return undefined;
            if (predicates.length === 1) {
                if (!instance(predicates[0], Array))
                    return predicates[0];
                predicates = predicates[0];
            }
            return new ej.Predicate(predicates[0], operator, predicates.slice(1));
        },

        _combine: function (pred, field, operator, value, condition, ignoreCase) {
            if (field instanceof ej.Predicate)
                return ej.Predicate[condition](pred, field);

            if (typeof field === "string")
                return ej.Predicate[condition](pred, new ej.Predicate(field, operator, value, ignoreCase));

            return throwError("Predicate - " + condition + " : invalid arguments");
        },

        _fromJSON: function (json) {

            if (!json || instance(json, ej.Predicate))
                return json;

            var preds = json.predicates || [], len = preds.length, predicates = [], result;

            for (var i = 0; i < len; i++)
                predicates.push(pvtPredicate._fromJSON(preds[i]));                     

            if(!json.isComplex)
                result = new ej.Predicate(json.field, json.operator, ej.parseJSON({ val: json.value }).val, json.ignoreCase);
            else
                result = new ej.Predicate(predicates[0], json.condition, predicates.slice(1));

            return result;
        }
    };

    ej.Predicate.prototype = {
        and: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "and", ignoreCase);
        },
        or: function (field, operator, value, ignoreCase) {
            return pvtPredicate._combine(this, field, operator, value, "or", ignoreCase);
        },
        validate: function (record) {
            var p = this.predicates, isAnd, ret;

            if (!this.isComplex) {
                return this._comparer.call(this, ej.pvt.getObject(this.field, record), this.value, this.ignoreCase);
            }

            isAnd = this.condition === "and";

            for (var i = 0; i < p.length; i++) {
                ret = p[i].validate(record);
                if (isAnd) {
                    if (!ret) return false;
                } else {
                    if (ret) return true;
                }
            }

            return isAnd;
        },
        toJSON: function () {
            var predicates, p;
            if (this.isComplex) {
                predicates = [], p = this.predicates;
                for (var i = 0; i < p.length; i++)
                    predicates.push(p[i].toJSON());
            }
            return {
                isComplex: this.isComplex,
                field: this.field,
                operator: this.operator,
                value: this.value,
                ignoreCase: this.ignoreCase,
                condition: this.condition,
                predicates: predicates
            }
        }
    };

    ej.dataUtil = {
        swap: function (array, x, y) {
            if (x == y) return;

            var tmp = array[x];
            array[x] = array[y];
            array[y] = tmp;
        },

        mergeSort: function (jsonArray, fieldName, comparer) {
            if (!comparer || typeof comparer === "string")
                comparer = ej.pvt.fnSort(comparer, true);

            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.mergeSort(jsonArray, fieldName, comparer);
        },

        max: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnDescending);
        },

        min: function (jsonArray, fieldName, comparer) {
            if (typeof fieldName === "function") {
                comparer = fieldName;
                fieldName = null;
            }

            return ej.pvt.getItemFromComparer(jsonArray, fieldName, comparer || ej.pvt.fnAscending);
        },

        distinct: function (json, fieldName, requiresCompleteRecord) {
            var result = [], val, tmp = {};
            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!(val in tmp)) {
                    result.push(!requiresCompleteRecord ? val : json[i]);
                    tmp[val] = 1;
                }
            }
            return result;
        },

        sum: function (json, fieldName) {
            var result = 0, val, castRequired = typeof getVal(json, fieldName, 0) !== "number";

            for (var i = 0; i < json.length; i++) {
                val = getVal(json, fieldName, i);
                if (!isNaN(val) && val !== null) {
                    if (castRequired)
                       val = +val;
                   result += val;
                }
            }
            return result;
        },

        avg: function (json, fieldName) {
            return ej.sum(json, fieldName) / json.length;
        },

        select: function (jsonArray, fields) {
            var newData = [];

            for (var i = 0; i < jsonArray.length; i++) {
                newData.push(ej.pvt.extractFields(jsonArray[i], fields));
            }

            return newData;
        },

        group: function (jsonArray, field, agg, format,/* internal */ level,groupDs) {
            level = level || 1;

            if (jsonArray.GROUPGUID == ej.pvt.consts.GROUPGUID) {
                for (var j = 0; j < jsonArray.length; j++) {
                    if(!ej.isNullOrUndefined(groupDs)){
                        var indx = -1;
                        var temp = $.grep(groupDs,function(e){return e.key==jsonArray[j].key});
                        indx = groupDs.indexOf(temp[0]);
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1, groupDs[indx].items);
                        jsonArray[j].count = groupDs[indx].count;
                    }
                    else{
                        jsonArray[j].items = ej.group(jsonArray[j].items, field, agg, format, jsonArray.level + 1);
                        jsonArray[j].count = jsonArray[j].items.length;
                    }  
                }

                jsonArray.childLevels += 1;
                return jsonArray;
            }

            var grouped = {}, groupedArray = [];

            groupedArray.GROUPGUID = ej.pvt.consts.GROUPGUID;
            groupedArray.level = level;
            groupedArray.childLevels = 0;
            groupedArray.records = jsonArray;

            for (var i = 0; i < jsonArray.length; i++) {
                var val = getVal(jsonArray, field, i);
                if (!ej.isNullOrUndefined(format)) val = format(val, field);

                if (!grouped[val]) {
                    grouped[val] = {
                        key: val,
                        count: 0,
                        items: [],
                        aggregates: {},
                        field: field
                    };
                    groupedArray.push(grouped[val]);
					if(!ej.isNullOrUndefined(groupDs)) {
                        var tempObj = $.grep(groupDs,function(e){return e.key==grouped[val].key});
                       grouped[val].count = tempObj[0].count
                    }
                }

                grouped[val].count = !ej.isNullOrUndefined(groupDs) ? grouped[val].count :  grouped[val].count += 1;
                grouped[val].items.push(jsonArray[i]);
            }
            if (agg && agg.length) {

                for (var i = 0; i < groupedArray.length; i++) {
                    var res = {}, fn;
                    for (var j = 0; j < agg.length; j++) {

                        fn = ej.aggregates[agg[j].type];
                        if(!ej.isNullOrUndefined(groupDs)) {
                            var temp = $.grep(groupDs,function(e){return e.key==groupedArray[i].key});
                            if(fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(temp[0].items, agg[j].field);
                        }
                        else{
                            if (fn)
                                res[agg[j].field + " - " + agg[j].type] = fn(groupedArray[i].items, agg[j].field);
                        }

                    }
                    groupedArray[i]["aggregates"] = res;
                }
            }
            return groupedArray;
        },

        parseTable: function (table, headerOption, headerRowIndex) {
            var tr = table.rows, headerRow, headerTds = [], data = [], i;

            if (!tr.length) return [];

            headerRowIndex = headerRowIndex || 0;

            switch ((headerOption || "").toLowerCase()) {
                case ej.headerOption.tHead:
                    headerRow = table.tHead.rows[headerRowIndex];
                    break;
                case ej.headerOption.row:
                default:
                    headerRow = table.rows[headerRowIndex];
                    break;
            }

            var hTd = headerRow.cells;

            for (i = 0; i < hTd.length; i++)
                headerTds.push($.trim(hTd[i].innerHTML));

            for (i = headerRowIndex + 1; i < tr.length; i++) {
                var json = {}, td = tr[i].cells;
                for (var j = 0; j < td.length; j++) {
                    var temp = td[j].innerHTML;
                    if (typeof temp == "string" && $.isNumeric(temp))
                       json[headerTds[j]] = Number(temp);
				    else
                       json[headerTds[j]] = temp;
                }
                data.push(json);
            }
            return data;
        }
    };

    ej.headerOption = {
        tHead: "thead",
        row: "row"
    };

    ej.aggregates = {
        sum: function (ds, field) {
            return ej.sum(ds, field);
        },
        average: function (ds, field) {
            return ej.avg(ds, field);
        },
        minimum: function (ds, field) {
            return ej.getObject(field, ej.min(ds, field));
        },
        maximum: function (ds, field) {
            return  ej.getObject(field, ej.max(ds, field));
        },
        truecount: function (ds, field){
            var predicate = ej.Predicate(field, "equal", true);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        falsecount: function (ds, field) {
            var predicate = ej.Predicate(field, "equal", false);
            return ej.DataManager(ds).executeLocal(ej.Query().where(predicate)).length;
        },
        count: function (ds, field) {
            return ds.length;
        }

    };
    ej.pvt = {
        filterQueries: filterQueries,
        mergeSort: function (jsonArray, fieldName, comparer) {
            if (jsonArray.length <= 1)
                return jsonArray;

            // else list size is > 1, so split the list into two sublists
            var middle = parseInt(jsonArray.length / 2, 10);

            var left = jsonArray.slice(0, middle),
                right = jsonArray.slice(middle);

            left = ej.pvt.mergeSort(left, fieldName, comparer);
            right = ej.pvt.mergeSort(right, fieldName, comparer);

            return ej.pvt.merge(left, right, fieldName, comparer);
        },

        getItemFromComparer: function (array, field, comparer) {
            var keyVal, current, key, i = 0,castRequired = typeof getVal(array, field, 0) == "string";
            if (array.length)
            while (ej.isNullOrUndefined(keyVal) && i < array.length) {
                keyVal = getVal(array, field, i);
                key = array[i++];
            }
            for (; i < array.length; i++) {
                current = getVal(array, field, i);
                if (ej.isNullOrUndefined(current))
                    continue;
                if (castRequired) {
                    keyVal = +keyVal;
                    current = +current;
                }
                if (comparer(keyVal, current) > 0) {
                    keyVal = current;
                    key = array[i];
                }
            }
            return key;
        },

        quickSelect: function (array, fieldName, left, right, k, comparer) {
            if (left == right)
                return array[left];

            var pivotNewIndex = ej.pvt.partition(array, fieldName, left, right, comparer);

            var pivotDist = pivotNewIndex - left + 1;

            if (pivotDist == k)
                return array[pivotNewIndex];

            else if (k < pivotDist)
                return ej.pvt.quickSelect(array, fieldName, left, pivotNewIndex - 1, k, comparer);
            else
                return ej.pvt.quickSelect(array, fieldName, pivotNewIndex + 1, right, k - pivotDist, comparer);
        },

        extractFields: function (obj, fields) {
            var newObj = {};

            if (fields.length == 1)
                return ej.pvt.getObject(fields[0], obj);

            for (var i = 0; i < fields.length; i++) {
                newObj[fields[i].replace('.', ej.pvt.consts.complexPropertyMerge)] = ej.pvt.getObject(fields[i], obj);
            }

            return newObj;
        },

        partition: function (array, field, left, right, comparer) {

            var pivotIndex = parseInt((left + right) / 2, 10),
                pivot = getVal(array, field, pivotIndex);

            ej.swap(array, pivotIndex, right);

            pivotIndex = left;

            for (var i = left; i < right; i++) {
                if (comparer(getVal(array, field, i), pivot)) {
                    ej.swap(array, i, pivotIndex);
                    pivotIndex++;
                }
            }

            ej.swap(array, pivotIndex, right);

            return pivotIndex;
        },

        fnSort: function (order) {
            order = order ? order.toLowerCase() : ej.sortOrder.Ascending;

            if (order == ej.sortOrder.Ascending)
                return ej.pvt.fnAscending;

            return ej.pvt.fnDescending;
        },

        fnGetComparer: function (field, fn) {
            return function (x, y) {
                return fn(ej.pvt.getObject(field, x), ej.pvt.getObject(field, y));
            }
        },

        fnAscending: function (x, y) {
            if (y === null || y === undefined)
                return -1;

            if (typeof x === "string")
                return x.localeCompare(y);

            if (x === null || x === undefined)
                return 1;

            return x - y;
        },

        fnDescending: function (x, y) {
            if (y === null || y === undefined)
                return 1;

            if (typeof x === "string")
                return x.localeCompare(y) * -1;

            if (x === null || x === undefined)
                return -1;

            return y - x;
        },

        merge: function (left, right, fieldName, comparer) {
            var result = [], current;

            while (left.length > 0 || right.length > 0) {
                if (left.length > 0 && right.length > 0) {
                    if (comparer)
                        current = comparer(getVal(left, fieldName, 0), getVal(right, fieldName, 0)) <= 0 ? left : right;
                    else
                        current = left[0][fieldName] < left[0][fieldName] ? left : right;
                } else {
                    current = left.length > 0 ? left : right;
                }

                result.push(current.shift());
            }

            return result;
        },

        getObject: function (nameSpace, from) {
            if (!from) return undefined;
            if (!nameSpace) return from;

            if (nameSpace.indexOf('.') === -1) return from[nameSpace];

            var value = from, splits = nameSpace.split('.');

            for (var i = 0; i < splits.length; i++) {

                if (value == null) break;

                value = value[splits[i]];
            }

            return value;
        },

        createObject: function (nameSpace, value, initIn) {
            var splits = nameSpace.split('.'), start = initIn || window, from = start, i;

            for (i = 0; i < splits.length; i++) {

                if (i + 1 == splits.length)
                    from[splits[i]] = value === undefined ? {} : value;
                else if (from[splits[i]] == null)
                    from[splits[i]] = {};

                from = from[splits[i]];
            }

            return start;
        },

        getFieldList: function (obj, fields, prefix) {
            if (prefix === undefined)
                prefix = "";

            if (fields === undefined || fields === null)
                return ej.pvt.getFieldList(obj, [], prefix);

            for (var prop in obj) {
                if (typeof obj[prop] === "object" && !(obj[prop] instanceof Array))
                    ej.pvt.getFieldList(obj[prop], fields, prefix + prop + ".");
                else
                    fields.push(prefix + prop);
            }

            return fields;
        }
    };

    ej.FilterOperators = {
        lessThan: "lessthan",
        greaterThan: "greaterthan",
        lessThanOrEqual: "lessthanorequal",
        greaterThanOrEqual: "greaterthanorequal",
        equal: "equal",
        contains: "contains",
        startsWith: "startswith",
        endsWith: "endswith",
        notEqual: "notequal"
    };

    ej.data = {};

    ej.data.operatorSymbols = {
        "<": "lessthan",
        ">": "greaterthan",
        "<=": "lessthanorequal",
        ">=": "greaterthanorequal",
        "==": "equal",
        "!=": "notequal",
        "*=": "contains",
        "$=": "endswith",
        "^=": "startswith"
    };

    ej.data.odBiOperator = {
        "<": " lt ",
        ">": " gt ",
        "<=": " le ",
        ">=": " ge ",
        "==": " eq ",
        "!=": " ne ",
        "lessthan": " lt ",
        "lessthanorequal": " le ",
        "greaterthan": " gt ",
        "greaterthanorequal": " ge ",
        "equal": " eq ",
        "notequal": " ne "
    };

    ej.data.odUniOperator = {
        "$=": "endswith",
        "^=": "startswith",
        "*=": "substringof",
        "endswith": "endswith",
        "startswith": "startswith",
        "contains": "substringof"
    };

    ej.data.fnOperators = {
        equal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) == toLowerCase(expected);

            return actual == expected;
        },
        notequal: function (actual, expected, ignoreCase) {
            return !ej.data.fnOperators.equal(actual, expected, ignoreCase);
        },
        lessthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) < toLowerCase(expected);

            return actual < expected;
        },
        greaterthan: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) > toLowerCase(expected);

            return actual > expected;
        },
        lessthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) <= toLowerCase(expected);

            return actual <= expected;
        },
        greaterthanorequal: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return toLowerCase(actual) >= toLowerCase(expected);

            return actual >= expected;
        },
        contains: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return !isNull(actual) && !isNull(expected) && toLowerCase(actual).indexOf(toLowerCase(expected)) != -1;

            return !isNull(actual) && !isNull(expected) && actual.toString().indexOf(expected) != -1;
        },
        notnull: function (actual) {
            return actual !== null;
        },
        isnull: function (actual) {
            return actual === null;
        },
        startswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).startsWith(toLowerCase(expected));

            return actual && expected && actual.startsWith(expected);
        },
        endswith: function (actual, expected, ignoreCase) {
            if (ignoreCase)
                return actual && expected && toLowerCase(actual).endsWith(toLowerCase(expected));

            return actual && expected && actual.endsWith(expected);
        },

        processSymbols: function (operator) {
            var fnName = ej.data.operatorSymbols[operator];
            if (fnName) {
                var fn = ej.data.fnOperators[fnName];
                if (fn) return fn;
            }

            return throwError("Query - Process Operator : Invalid operator");
        },

        processOperator: function (operator) {
            var fn = ej.data.fnOperators[operator];
            if (fn) return fn;
            return ej.data.fnOperators.processSymbols(operator);
        }
    };

    ej.NotifierArray = function (array) {
        if (!instance(this, ej.NotifierArray))
            return new ej.NotifierArray(array);

        this.array = array;

        this._events = $({});
        this._isDirty = false;

        return this;
    };

    ej.NotifierArray.prototype = {
        on: function (eventName, handler) {
            this._events.on(eventName, handler);
        },
        off: function (eventName, handler) {
            this._events.off(eventName, handler);
        },
        push: function (item) {
            var ret;

            if (instance(item, Array))
                ret = [].push.apply(this.array, item);
            else
                ret = this.array.push(item);

            this._raise("add", { item: item, index: this.length() - 1 });

            return ret;
        },
        pop: function () {
            var ret = this.array.pop();

            this._raise("remove", { item: ret, index: this.length() - 1 });

            return ret;
        },
        addAt: function (index, item) {
            this.array.splice(index, 0, item);

            this._raise("add", { item: item, index: index });

            return item;
        },
        removeAt: function (index) {
            var ret = this.array.splice(index, 1)[0];

            this._raise("remove", { item: ret, index: index });

            return ret;
        },
        remove: function (item) {
            var index = this.array.indexOf(item);

            if (index > -1) {
                this.array.splice(index, 1);
                this._raise("remove", { item: item, index: index });
            }

            return index;
        },
        length: function () {
            return this.array.length;
        },
        _raise: function (e, args) {
            this._events.triggerHandler($.extend({ type: e }, args));
            this._events.triggerHandler({ type: "all", name: e, args: args });
        },
        toArray: function () {
            return this.array;
        }
    };

    $.extend(ej, ej.dataUtil);

    // For IE8
    Array.prototype.forEach = Array.prototype.forEach || function (fn, scope) {
        for (var i = 0, len = this.length; i < len; ++i) {
            fn.call(scope, this[i], i, this);
        }
    };

    Array.prototype.indexOf = Array.prototype.indexOf || function (searchElement) {
        var len = this.length;

        if (len === 0) return -1;

        for (var i = 0; i < len; i++) {
            if (i in this && this[i] === searchElement)
                return i;
        }
        return -1;
    };

    Array.prototype.filter = Array.prototype.filter || function (fn) {
        if (typeof fn != "function")
            throw new TypeError();

        var res = [];
        var thisp = arguments[1] || this;
        for (var i = 0; i < this.length; i++) {
            var val = this[i]; // in case fun mutates this
            if (fn.call(thisp, val, i, this))
                res.push(val);
        }

        return res;
    };

    String.prototype.endsWith = String.prototype.endsWith || function (key) {
        return this.slice(-key.length) === key;
    };

    String.prototype.startsWith = String.prototype.startsWith || function (key) {
        return this.slice(0, key.length) === key;
    };

    if (!ej.support) ej.support = {};
    ej.support.stableSort = function () {
        var res = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16].sort(function () { return 0; });
		for(var i = 0; i < 17; i++){
		    if(i !== res[i]) return false;
		}
        return true;
    }();
    ej.support.cors = $.support.cors;

    if (!$.support.cors && window.XDomainRequest) {
        var httpRegEx = /^https?:\/\//i;
        var getOrPostRegEx = /^get|post$/i;
        var sameSchemeRegEx = new RegExp('^' + location.protocol, 'i');
        var xmlRegEx = /\/xml/i;

        // ajaxTransport exists in jQuery 1.5+
        $.ajaxTransport('text html xml json', function (options, userOptions, jqXHR) {
            // XDomainRequests must be: asynchronous, GET or POST methods, HTTP or HTTPS protocol, and same scheme as calling page
            if (options.crossDomain && options.async && getOrPostRegEx.test(options.type) && httpRegEx.test(userOptions.url) && sameSchemeRegEx.test(userOptions.url)) {
                var xdr = null;
                var userType = (userOptions.dataType || '').toLowerCase();
                return {
                    send: function (headers, complete) {
                        xdr = new XDomainRequest();
                        if (/^\d+$/.test(userOptions.timeout)) {
                            xdr.timeout = userOptions.timeout;
                        }
                        xdr.ontimeout = function () {
                            complete(500, 'timeout');
                        };
                        xdr.onload = function () {
                            var allResponseHeaders = 'Content-Length: ' + xdr.responseText.length + '\r\nContent-Type: ' + xdr.contentType;
                            var status = {
                                code: 200,
                                message: 'success'
                            };
                            var responses = {
                                text: xdr.responseText
                            };

                            try {
                                if (userType === 'json') {
                                    try {
                                        responses.json = JSON.parse(xdr.responseText);
                                    } catch (e) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        //throw 'Invalid JSON: ' + xdr.responseText;
                                    }
                                } else if ((userType === 'xml') || ((userType !== 'text') && xmlRegEx.test(xdr.contentType))) {
                                    var doc = new ActiveXObject('Microsoft.XMLDOM');
                                    doc.async = false;
                                    try {
                                        doc.loadXML(xdr.responseText);
                                    } catch (e) {
                                        doc = undefined;
                                    }
                                    if (!doc || !doc.documentElement || doc.getElementsByTagName('parsererror').length) {
                                        status.code = 500;
                                        status.message = 'parseerror';
                                        throw 'Invalid XML: ' + xdr.responseText;
                                    }
                                    responses.xml = doc;
                                }
                            } catch (parseMessage) {
                                throw parseMessage;
                            } finally {
                                complete(status.code, status.message, responses, allResponseHeaders);
                            }
                        };
                        xdr.onerror = function () {
                            complete(500, 'error', {
                                text: xdr.responseText
                            });
                        };
						if(navigator.userAgent.indexOf("MSIE 9.0") != -1)
							xdr.onprogress = function() {};
                        xdr.open(options.type, options.url);
                        xdr.send(userOptions.data);
                        //xdr.send();
                    },
                    abort: function () {
                        if (xdr) {
                            xdr.abort();
                        }
                    }
                };
            }
        });
    }

    $.support.cors = true;

    ej.sortOrder = {
        Ascending: "ascending",
        Descending: "descending"
    };

    // privates
    ej.pvt.consts = {
        GROUPGUID: "{271bbba0-1ee7}",
        complexPropertyMerge: "_"
    };

    // private utils
    var nextTick = function (fn, context) {
        if (context) fn = $proxy(fn, context);
        (window.setImmediate || window.setTimeout)(fn, 0);
    };

    ej.support.enableLocalizedSort = false;

    var stableSort = function (ds, field, comparer, queries) {
        if (ej.support.stableSort) {
            if(!ej.support.enableLocalizedSort && typeof ej.pvt.getObject(field, ds[0] || {}) == "string" 
                && (comparer === ej.pvt.fnAscending || comparer === ej.pvt.fnDescending)
                && queries.filter(function(e){return e.fn === "onSortBy";}).length === 1)
                return fastSort(ds, field, comparer === ej.pvt.fnDescending);
            return ds.sort(ej.pvt.fnGetComparer(field, comparer));
        }
        return ej.mergeSort(ds, field, comparer);
    };
    var getColFormat = function (field, query) {
        var grpQuery = $.grep(query, function (args) { return args.fn == "onGroup" });
        for (var grp = 0; grp < grpQuery.length; grp++) {
            if (ej.getObject("fieldName", grpQuery[grp].e) == field) {
                return ej.getObject("fn", grpQuery[grp].e);
            }
        }
    };
    var fastSort = function(ds, field, isDesc){
        var old = Object.prototype.toString;
        Object.prototype.toString = (field.indexOf('.') === -1) ? function(){
            return this[field];
        }:function(){
            return ej.pvt.getObject(field, this);
        };
        ds = ds.sort();
        Object.prototype.toString = old;
        if(isDesc)
            ds.reverse();
    }

    var toLowerCase = function (val) {
        return val ? val.toLowerCase ? val.toLowerCase() : val.toString().toLowerCase() : (val === 0 || val === false) ? val.toString() : "";
    };

    var getVal = function (array, field, index) {
        return field ? ej.pvt.getObject(field, array[index]) : array[index];
    };

    var isHtmlElement = function (e) {
        return typeof HTMLElement === "object" ? e instanceof HTMLElement :
            e && e.nodeType === 1 && typeof e === "object" && typeof e.nodeName === "string";
    };

    var instance = function (obj, element) {
        return obj instanceof element;
    };

    var getTableModel = function (name, result, dm, computed) {
        return function (tName) {
            if (typeof tName === "object") {
                computed = tName;
                tName = null;
            }
            return new ej.TableModel(tName || name, result, dm, computed);
        };
    };

    var getKnockoutModel = function (result) {
        return function (computedObservables, ko) {
            ko = ko || window.ko;

            if (!ko) throwError("Knockout is undefined");

            var model, koModels = [], prop, ob;
            for (var i = 0; i < result.length; i++) {
                model = {};
                for (prop in result[i]) {
                    if (!prop.startsWith("_"))
                        model[prop] = ko.observable(result[i][prop]);
                }
                for (prop in computedObservables) {
                    ob = computedObservables[prop];

                    if ($.isPlainObject(ob)) {
                        if (!ob.owner) ob.owner = model;
                        ob = ko.computed(ob);
                    } else
                        ob = ko.computed(ob, model);

                    model[prop] = ob;
                }
                koModels.push(model);
            }

            return ko.observableArray(koModels);
        };
    };

    var uidIndex = 0;
    var getUid = function (prefix) {
        uidIndex += 1;
        return prefix + uidIndex;
    };

    ej.getGuid = function (prefix) {
        var hexs = '0123456789abcdef', rand;
        return (prefix || "") + '00000000-0000-4000-0000-000000000000'.replace(/0/g, function (val, i) {
            if ("crypto" in window && "getRandomValues" in crypto) {
                var arr = new Uint8Array(1)
                window.crypto.getRandomValues(arr);
                rand = arr[0] % 16|0
            }
            else rand = Math.random() * 16 | 0;
            return hexs[i === 19 ? rand & 0x3 | 0x8 : rand];
        });
    };

    var proxy = function (fn, context) {
        return function () {
            var args = [].slice.call(arguments, 0);
            args.push(this);

            return fn.apply(context || this, args);
        };
    };

    var $proxy = function (fn, context, arg) {
        if ('bind' in fn)
            return arg ? fn.bind(context, arg) : fn.bind(context);

        return function () {
            var args = arg ? [arg] : []; args.push.apply(args, arguments);
            return fn.apply(context || this, args);
        };
    };

    ej.merge = function (first, second) {
        if (!first || !second) return;

        Array.prototype.push.apply(first, second);
    };

    var isNull = function (val) {
        return val === undefined || val === null;
    };

    var throwError = function (er) {
        try {
            throw new Error(er);
        } catch (e) {
            throw e.message + "\n" + e.stack;
        }
    };

})(window.jQuery, window.Syncfusion, window.document);;
(function($, undefined){
    
ej.globalize = {};
ej.cultures = {};

ej.cultures['default'] = ej.cultures['en-US'] = $.extend(true, {
    name: 'en-US',
    englishName: "English",
    nativeName: "English",
    language: 'en',
    isRTL: false,
    numberFormat: {
        pattern: ["-n"],
        decimals: 2,
        ',': ",",
        '.': ".",
        groupSizes: [3],
        '+': "+",
        '-': "-",
        percent: {
            pattern: ["-n %", "n %"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '%'
        },
        currency: {
            pattern: ["($n)", "$n"],
            decimals: 2,
            groupSizes: [3],
            ',': ",",
            '.': ".",
            symbol: '$'
        }
    },
    calendars: {
    	standard: {
	        '/': '/',
	        ':': ':',
	        firstDay: 0,
			week:{
			name:"Week",
			nameAbbr:"Wek",
			nameShort:"Wk"
			},
	        days: {
	            names: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
	            namesAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
	            namesShort: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"]
	        },
	        months: {
	            names: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", ""],
	            namesAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", ""]
	        },
	        AM: ['AM', 'am', 'AM'],
	        PM: ['PM', 'pm', 'PM'],
            twoDigitYearMax: 2029,
	        patterns: {
                d: "M/d/yyyy",
                D: "dddd, MMMM dd, yyyy",
                t: "h:mm tt",
                T: "h:mm:ss tt",
                f: "dddd, MMMM dd, yyyy h:mm tt",
                F: "dddd, MMMM dd, yyyy h:mm:ss tt",
                M: "MMMM dd",
                Y: "yyyy MMMM",
                S: "yyyy\u0027-\u0027MM\u0027-\u0027dd\u0027T\u0027HH\u0027:\u0027mm\u0027:\u0027ss"

	        }
    	}
    }
}, ej.cultures['en-US']);

ej.cultures['en-US'].calendar = ej.cultures['en-US'].calendar || ej.cultures['en-US'].calendars.standard; 



// *************************************** Numbers ***************************************
var regexTrim = /^\s+|\s+$/g,
    regexInfinity = /^[+-]?infinity$/i,
    regexHex = /^0x[a-f0-9]+$/i,
    regexParseFloat = /^[+-]?\d*\.?\d*(e[+-]?\d+)?$/;

function patternStartsWith(value, pattern) {
    return value.indexOf( pattern ) === 0;
}

function patternEndsWith(value, pattern) {
    return value.substr( value.length - pattern.length ) === pattern;
}

function trim(value) {
    return (value+"").replace( regexTrim, "" );
}

function truncate(value){
    if(isNaN(value))
        return NaN;
    
    return Math[value < 0 ? "ceil" : "floor"](value);
}

function padWithZero(str, count, left) {
    for (var l = str.length; l < count; l++) {
        str = (left ? ('0' + str) : (str + '0'));
    }
    return str;
}

function parseNumberWithNegativePattern(value, nf, negativePattern) {
    var neg = nf["-"],
        pos = nf["+"],
        ret;
    switch (negativePattern) {
        case "n -":
            neg = ' ' + neg;
            pos = ' ' + pos;
            // fall through
        case "n-":
            if ( patternEndsWith( value, neg ) ) {
                ret = [ '-', value.substr( 0, value.length - neg.length ) ];
            }
            else if ( patternEndsWith( value, pos ) ) {
                ret = [ '+', value.substr( 0, value.length - pos.length ) ];
            }
            break;
        case "- n":
            neg += ' ';
            pos += ' ';
            // fall through
        case "-n":
            if ( patternStartsWith( value, neg ) ) {
                ret = [ '-', value.substr( neg.length ) ];
            }
            else if ( patternStartsWith(value, pos) ) {
                ret = [ '+', value.substr( pos.length ) ];
            }
            break;
        case "(n)":
            if ( patternStartsWith( value, '(' ) && patternEndsWith( value, ')' ) ) {
                ret = [ '-', value.substr( 1, value.length - 2 ) ];
            }
            break;
    }
    return ret || [ '', value ];
}

function getFullNumber(number, precision, formatInfo) {
    var groupSizes = formatInfo.groupSizes || [3],
        curSize = groupSizes[0],
        curGroupIndex = 1,
        factor = Math.pow(10, precision),
        rounded = Math.round(number * factor) / factor;
    if (!isFinite(rounded)) {
        rounded = number;
    }
    number = rounded;

    var numberString = number + "",
        right = "",
        split = numberString.split(/e/i),
        exponent = split.length > 1 ? parseInt(split[1], 10) : 0;
    numberString = split[0];
    split = numberString.split(".");
    numberString = split[0];
    right = split.length > 1 ? split[1] : "";

    var l;
    if (exponent > 0) {
        right = padWithZero(right, exponent, false);
        numberString += right.slice(0, exponent);
        right = right.substr(exponent);
    } else if (exponent < 0) {
        exponent = -exponent;
        numberString = padWithZero(numberString, exponent + 1);
        right = numberString.slice(-exponent, numberString.length) + right;
        numberString = numberString.slice(0, -exponent);
    }

    var dot = formatInfo['.'] || '.';
    if (precision > 0) {
        right = dot +
            ((right.length > precision) ? right.slice(0, precision) : padWithZero(right, precision));
    } else {
        right = "";
    }

    var stringIndex = numberString.length - 1,
        sep = formatInfo[","] || ',',
        ret = "";

    while (stringIndex >= 0) {
        if (curSize === 0 || curSize > stringIndex) {
            return numberString.slice(0, stringIndex + 1) + (ret.length ? (sep + ret + right) : right);
        }
        ret = numberString.slice(stringIndex - curSize + 1, stringIndex + 1) + (ret.length ? (sep + ret) : "");

        stringIndex -= curSize;

        if (curGroupIndex < groupSizes.length) {
            curSize = groupSizes[curGroupIndex];
            curGroupIndex++;
        }
    }
    return numberString.slice(0, stringIndex + 1) + sep + ret + right;
}

function formatNumberToCulture(value, format, culture) {
    if (!format || format === 'i') {
        return culture.name.length ? value.toLocaleString() : value.toString();
    }
    format = format || "D";

    var nf = culture.numberFormat,
        number = Math.abs(value),
        precision = -1,
        pattern;

    if (format.length > 1) precision = parseInt(format.slice(1), 10);

    var current = format.charAt(0).toUpperCase(),
        formatInfo;

    switch (current) {
        case 'D':
            pattern = 'n';
            number = truncate(number);
            if (precision !== -1) {
                number = padWithZero("" + number, precision, true);
            }
            if (value < 0) number = -number;
            break;
        case 'N':
            formatInfo = nf;
            formatInfo.pattern = formatInfo.pattern || ['-n'];
            // fall through
        case 'C':
            formatInfo = formatInfo || nf.currency;
            formatInfo.pattern = formatInfo.pattern || ['-$n', '$n'];
            // fall through
        case 'P':
            formatInfo = formatInfo || nf.percent;
            formatInfo.pattern = formatInfo.pattern || ['-n %', 'n %'];
            pattern = value < 0 ? (formatInfo.pattern[0] || "-n") : (formatInfo.pattern[1] || "n");
            if (precision === -1) precision = formatInfo.decimals;
            number = getFullNumber(number * (current === "P" ? 100 : 1), precision, formatInfo);
            break;
        default:
            throw "Bad number format specifier: " + current;
    }

    return matchNumberToPattern(number, pattern, nf);
}



function matchNumberToPattern(number, pattern, nf){
    var patternParts = /n|\$|-|%/g,
        ret = "";
    for (;;) {
        var index = patternParts.lastIndex,
            ar = patternParts.exec(pattern);

        ret += pattern.slice(index, ar ? ar.index : pattern.length);

        if (!ar) {
            break;
        }

        switch (ar[0]) {
            case "n":
                ret += number;
                break;
            case "$":
                ret += nf.currency.symbol || "$";
                break;
            case "-":
                // don't make 0 negative
                if (/[1-9]/.test(number)) {
                    ret += nf["-"] || "-";
                }
                break;
            case "%":
                ret += nf.percent.symbol || "%";
                break;
        }
    }

    return ret;
}

function parseValue(value, culture, radix ) {
		// make radix optional
    if (typeof radix === "string") {
        culture = radix;
        radix = 10;
    }
    culture = ej.globalize.findCulture(culture);
    var ret = NaN, nf = culture.numberFormat, npattern = culture.numberFormat.pattern[0];
    value = value.replace(/ /g, '');
    if (value.indexOf(culture.numberFormat.currency.symbol) > -1) {
        // remove currency symbol
        value = value.replace(culture.numberFormat.currency.symbol || "$", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.currency["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the currency
        npattern = trim(culture.numberFormat.currency.pattern[0].replace("$", ""));
    } else if (value.indexOf(culture.numberFormat.percent.symbol) > -1) {
        // remove percentage symbol
        value = value.replace(culture.numberFormat.percent.symbol || "%", "");
        // replace decimal seperator
        value = value.replace(culture.numberFormat.percent["."] || ".", culture.numberFormat["."] || ".");
        // pattern of the percent
        npattern = trim(culture.numberFormat.percent.pattern[0].replace("%", ""));
    }

    // trim leading and trailing whitespace
    value = trim( value );

    // allow infinity or hexidecimal
    if (regexInfinity.test(value)) {
        ret = parseFloat(value, "" ,radix);
    }
    else if (regexHex.test(value)) {
        ret = parseInt(value, 16);
    }
    else {
        var signInfo = parseNumberWithNegativePattern( value, nf, npattern ),
            sign = signInfo[0],
            num = signInfo[1];
        // determine sign and number
        if ( sign === "" && nf.pattern[0] !== "-n" ) {
            signInfo = parseNumberWithNegativePattern( value, nf, "-n" );
            sign = signInfo[0];
            num = signInfo[1];
        }
        sign = sign || "+";
        // determine exponent and number
        var exponent,
            intAndFraction,
            exponentPos = num.indexOf( 'e' );
        if ( exponentPos < 0 ) exponentPos = num.indexOf( 'E' );
        if ( exponentPos < 0 ) {
            intAndFraction = num;
            exponent = null;
        }
        else {
            intAndFraction = num.substr( 0, exponentPos );
            exponent = num.substr( exponentPos + 1 );
        }
        // determine decimal position
        var integer,
            fraction,
            decSep = nf['.'] || '.',
            decimalPos = intAndFraction.indexOf( decSep );
        if ( decimalPos < 0 ) {
            integer = intAndFraction;
            fraction = null;
        }
        else {
            integer = intAndFraction.substr( 0, decimalPos );
            fraction = intAndFraction.substr( decimalPos + decSep.length );
        }
        // handle groups (e.g. 1,000,000)
        var groupSep = nf[","] || ",";
        integer = integer.split(groupSep).join('');
        var altGroupSep = groupSep.replace(/\u00A0/g, " ");
        if ( groupSep !== altGroupSep ) {
            integer = integer.split(altGroupSep).join('');
        }
        // build a natively parsable number string
        var p = sign + integer;
        if ( fraction !== null ) {
            p += '.' + fraction;
        }
        if ( exponent !== null ) {
            // exponent itself may have a number patternd
            var expSignInfo = parseNumberWithNegativePattern( exponent, nf, npattern );
            p += 'e' + (expSignInfo[0] || "+") + expSignInfo[1];
        }
        if ( !radix && regexParseFloat.test( p ) ) {
            ret = parseFloat( p );
        }
		else if(radix)
			ret = parseInt(p, radix);
    }
    return ret;
}

// *************************************** Dates ***************************************

var dateFormat = {
    DAY_OF_WEEK_THREE_LETTER : "ddd",
    DAY_OF_WEEK_FULL_NAME : "dddd",
    DAY_OF_MONTH_SINGLE_DIGIT : "d",
    DAY_OF_MONTH_DOUBLE_DIGIT : "dd",
    MONTH_THREE_LETTER : "MMM",
    MONTH_FULL_NAME : "MMMM",
    MONTH_SINGLE_DIGIT : "M",
    MONTH_DOUBLE_DIGIT : "MM",
    YEAR_SINGLE_DIGIT : "y",
    YEAR_DOUBLE_DIGIT : "yy",
    YEAR_FULL : "yyyy",
    HOURS_SINGLE_DIGIT_12_HOUR_CLOCK : "h",
    HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK : "hh",
    HOURS_SINGLE_DIGIT_24_HOUR_CLOCK : "H",
    HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK : "HH",
    MINUTES_SINGLE_DIGIT : "m",
    MINUTES_DOUBLE_DIGIT : "mm",
    SECONDS_SINGLE_DIGIT : "s",
    SECONDS_DOUBLE_DIGIT : "ss",
    MERIDIAN_INDICATOR_SINGLE : "t",
    MERIDIAN_INDICATOR_FULL : "tt",
    DECISECONDS : "f",
    CENTISECONDS: "ff",
    MILLISECONDS : "fff",
    TIME_ZONE_OFFSET_SINGLE_DIGIT : "z",
    TIME_ZONE_OFFSET_DOUBLE_DIGIT : "zz",
    TIME_ZONE_OFFSET_FULL : "zzz",
    DATE_SEPARATOR : "/"
};

function valueOutOfRange(value, low, high) {
    return value < low || value > high;
}

function expandYear(cal, year) {
    // expands 2-digit year into 4 digits.
    var now = new Date();
    if ( year < 100 ) {
        var twoDigitYearMax = cal.twoDigitYearMax;
        twoDigitYearMax = typeof twoDigitYearMax === 'string' ? new Date().getFullYear() % 100 + parseInt( twoDigitYearMax, 10 ) : twoDigitYearMax;
        var curr = now.getFullYear();
        year += curr - ( curr % 100 );
        if ( year > twoDigitYearMax ) {
            year -= 100;
        }
    }
    return year;
}

function arrayIndexOf( array, item ) {
    if ( array.indexOf ) {
        return array.indexOf( item );
    }
    for ( var i = 0, length = array.length; i < length; i++ ) {
        if ( array[ i ] === item ) return i;
    }
    return -1;
}

function toUpper(value) {
    // 'he-IL' has non-breaking space in weekday names.
    return value.split( "\u00A0" ).join(' ').toUpperCase();
}

function toUpperArray(arr) {
    var results = [];
    for ( var i = 0, l = arr.length; i < l; i++ ) {
        results[i] = toUpper(arr[i]);
    }
    return results;
}

function getIndexOfDay(cal, value, abbr) {
    var ret,
        days = cal.days,
        upperDays = cal._upperDays;
    if ( !upperDays ) {
        cal._upperDays = upperDays = [
            toUpperArray( days.names ),
            toUpperArray( days.namesAbbr ),
            toUpperArray( days.namesShort )
        ];
    }
    value = toUpper( value );
    if ( abbr ) {
        ret = arrayIndexOf( upperDays[ 1 ], value );
        if ( ret === -1 ) {
            ret = arrayIndexOf( upperDays[ 2 ], value );
        }
    }
    else {
        ret = arrayIndexOf( upperDays[ 0 ], value );
    }
    return ret;
}

function getIndexOfMonth(cal, value, abbr) {
    var months = cal.months,
        monthsGen = cal.monthsGenitive || cal.months,
        upperMonths = cal._upperMonths,
        upperMonthsGen = cal._upperMonthsGen;
    if ( !upperMonths ) {
        cal._upperMonths = upperMonths = [
            toUpperArray( months.names ),
            toUpperArray( months.namesAbbr )
        ];
        cal._upperMonthsGen = upperMonthsGen = [
            toUpperArray( monthsGen.names ),
            toUpperArray( monthsGen.namesAbbr )
        ];
    }
    value = toUpper( value );
    var i = arrayIndexOf( abbr ? upperMonths[ 1 ] : upperMonths[ 0 ], value );
    if ( i < 0 ) {
        i = arrayIndexOf( abbr ? upperMonthsGen[ 1 ] : upperMonthsGen[ 0 ], value );
    }
    return i;
}

function appendMatchStringCount(preMatch, strings) {
    var quoteCount = 0,
        escaped = false;
    for ( var i = 0, il = preMatch.length; i < il; i++ ) {
        var c = preMatch.charAt( i );
        if(c == '\''){
            escaped ? strings.push( "'" ) : quoteCount++;
            escaped = false;
        } else if( c == '\\'){
            if (escaped) strings.push( "\\" );
            escaped = !escaped;
        } else {
            strings.push( c );
            escaped = false;
        }
    }
    return quoteCount;
}


function parseDayByInt(value, format, culture, cal) {
    if (!value) {
        return null;
    }
    var index = 0, valueX = 0, day = null;
    format = format.split("");
    length = format.length;
    var countDays = function (match) {
        var i = 0;
        while (format[index] === match) {
            i++;
            index++;
        }
        if (i > 0) {
            index -= 1;
        }
        return i;
    },
    getNumber = function (size) {
        var rg = new RegExp('^\\d{1,' + size + '}'),
            match = value.substr(valueX, size).match(rg);

        if (match) {
            match = match[0];
            valueX += match.length;
            return parseInt(match, 10);
        }
        return null;
    },
    getName = function (names, lower) {
        var i = 0,
            length = names.length,
            name, nameLength,
            subValue;

        for (; i < length; i++) {
            name = names[i];
            nameLength = name.length;
            subValue = value.substr(valueX, nameLength);

            if (lower) {
                subValue = subValue.toLowerCase();
            }

            if (subValue == name) {
                valueX += nameLength;
                return i + 1;
            }
        }
        return null;
    },
     lowerArray = function (data) {
         var index = 0,
             length = data.length,
             array = [];

         for (; index < length; index++) {
             array[index] = (data[index] + "").toLowerCase();
         }

         return array;
     },
     lowerInfo = function (localInfo) {
         var newLocalInfo = {}, property;

         for (property in localInfo) {
             newLocalInfo[property] = lowerArray(localInfo[property]);
         }

         return newLocalInfo;
     };
    for (; index < length; index++) {
        ch = format[index];
        if (ch === "d") {
            count = countDays("d");
            if (!cal._lowerDays) {
                cal._lowerDays = lowerInfo(cal.days);
            }
            day = count < 3 ? getNumber(2) : getName(cal._lowerDays[count == 3 ? "namesAbbr" : "names"], true)
        }
    }
    return day;
}


function getFullDateFormat(cal, format) {
    // expands unspecified or single character date formats into the full pattern.
    format = format || "F";
    var pattern,
        patterns = cal.patterns,
        len = format.length;
    if ( len === 1 ) {
        pattern = patterns[ format ];
        if ( !pattern ) {
            throw "Invalid date format string '" + format + "'.";
        }
        format = pattern;
    }
    else if ( len === 2  && format.charAt(0) === "%" ) {
        // %X escape format -- intended as a custom format string that is only one character, not a built-in format.
        format = format.charAt( 1 );
    }
    return format;
}

ej.globalize._getDateParseRegExp = function (cal, format) {
    // converts a format string into a regular expression with groups that
    // can be used to extract date fields from a date string.
    // check for a cached parse regex.
    var re = cal._parseRegExp;
    if ( !re ) {
        cal._parseRegExp = re = {};
    }
    else {
        var reFormat = re[ format ];
        if ( reFormat ) {
            return reFormat;
        }
    }

    // expand single digit formats, then escape regular expression characters.
    var expFormat = getFullDateFormat( cal, format ).replace( /([\^\$\.\*\+\?\|\[\]\(\)\{\}])/g, "\\\\$1" ),
        regexp = ["^"],
        groups = [],
        index = 0,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        match;

    // iterate through each date token found.
    while ( (match = tokenRegExp.exec( expFormat )) !== null ) {
        var preMatch = expFormat.slice( index, match.index );
        index = tokenRegExp.lastIndex;

        // don't replace any matches that occur inside a string literal.
        quoteCount += appendMatchStringCount( preMatch, regexp );
        if ( quoteCount % 2 ) {
            regexp.push( match[ 0 ] );
            continue;
        }

        // add a regex group for the token.
        var m = match[ 0 ],
            len = m.length,
            add;
            
        switch ( m ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER: case dateFormat.DAY_OF_WEEK_FULL_NAME:
            case dateFormat.MONTH_FULL_NAME: case dateFormat.MONTH_THREE_LETTER:
                add = "(\\D+)";
                break;
            case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                add = "(\\D*)";
                break;
            case dateFormat.YEAR_FULL:
            case dateFormat.MILLISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.DECISECONDS:
                add = "(\\d{" + len + "})";
                break;
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT: case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT: case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.MINUTES_DOUBLE_DIGIT: case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT: case dateFormat.SECONDS_SINGLE_DIGIT:
                add = "(\\d\\d?)";
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                add = "([+-]?\\d\\d?:\\d{2})";
                break;
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
                add = "([+-]?\\d\\d?)";
                break;
            case dateFormat.DATE_SEPARATOR:
                add = "(\\" + cal["/"] + ")";
                break;
            default:
                throw "Invalid date format pattern '" + m + "'.";
                break;
        }
        if ( add ) {
            regexp.push( add );
        }
        groups.push( match[ 0 ] );
    }
    appendMatchStringCount( expFormat.slice( index ), regexp );
    regexp.push( "$" );

    // allow whitespace to differ when matching formats.
    var regexpStr = regexp.join( '' ).replace( /\s+/g, "\\s+" ),
        parseRegExp = {'regExp': regexpStr, 'groups': groups};

    // cache the regex for this format.
    return re[ format ] = parseRegExp;
}

function getParsedDate(value, format, culture) {
    // try to parse the date string by matching against the format string
    // while using the specified culture for date field names.
    value = trim( value );
    format = trim(format);
    var cal = culture.calendar,
        // convert date formats into regular expressions with groupings.
        parseInfo = ej.globalize._getDateParseRegExp(cal, format),
        match = new RegExp(parseInfo.regExp).exec(value);
    if (match === null) {
        return null;
    }
    // found a date format that matches the input.
    var groups = parseInfo.groups,
        year = null, month = null, date = null, weekDay = null,
        hour = 0, hourOffset, min = 0, sec = 0, msec = 0, tzMinOffset = null,
        pmHour = false;
    // iterate the format groups to extract and set the date fields.
    for ( var j = 0, jl = groups.length; j < jl; j++ ) {
        var matchGroup = match[ j + 1 ];
        if ( matchGroup ) {
            var current = groups[ j ],
                clength = current.length,
                matchInt = parseInt( matchGroup, 10 );
            
            switch ( current ) {
                case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT: case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
                    date = matchInt;
                    if ( valueOutOfRange( date, 1, 31 ) ) return null;
                    break;
                case dateFormat.MONTH_THREE_LETTER:
                case dateFormat.MONTH_FULL_NAME:
                    month = getIndexOfMonth( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.MONTH_SINGLE_DIGIT: case dateFormat.MONTH_DOUBLE_DIGIT:
                    month = matchInt - 1;
                    if ( valueOutOfRange( month, 0, 11 ) ) return null;
                    break;
                case dateFormat.YEAR_SINGLE_DIGIT: case dateFormat.YEAR_DOUBLE_DIGIT:
                case dateFormat.YEAR_FULL:
                    year = clength < 4 ? expandYear( cal, matchInt ) : matchInt;
                    if ( valueOutOfRange( year, 0, 9999 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                    hour = matchInt;
                    if ( hour === 12 ) hour = 0;
                    if ( valueOutOfRange( hour, 0, 11 ) ) return null;
                    break;
                case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK: case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                    hour = matchInt;
                    if ( valueOutOfRange( hour, 0, 23 ) ) return null;
                    break;
                case dateFormat.MINUTES_SINGLE_DIGIT: case dateFormat.MINUTES_DOUBLE_DIGIT:
                    min = matchInt;
                    if ( valueOutOfRange( min, 0, 59 ) ) return null;
                    break;
                case dateFormat.SECONDS_SINGLE_DIGIT: case dateFormat.SECONDS_DOUBLE_DIGIT:
                    sec = matchInt;
                    if ( valueOutOfRange( sec, 0, 59 ) ) return null;
                    break;
                case dateFormat.MERIDIAN_INDICATOR_FULL: case dateFormat.MERIDIAN_INDICATOR_SINGLE:
                    pmHour = cal.PM && ( matchGroup === cal.PM[0] || matchGroup === cal.PM[1] || matchGroup === cal.PM[2] );
                    if ( !pmHour && ( !cal.AM || (matchGroup !== cal.AM[0] && matchGroup !== cal.AM[1] && matchGroup !== cal.AM[2]) ) ) return null;
                    break;
                case dateFormat.DECISECONDS:
                case dateFormat.CENTISECONDS:
                case dateFormat.MILLISECONDS:
                    msec = matchInt * Math.pow( 10, 3-clength );
                    if ( valueOutOfRange( msec, 0, 999 ) ) return null;
                    break;
                case dateFormat.DAY_OF_WEEK_THREE_LETTER:
                    date = parseDayByInt(value, format, culture, cal);
                    break;
                case dateFormat.DAY_OF_WEEK_FULL_NAME:
                     getIndexOfDay( cal, matchGroup, clength === 3 );
                    if ( valueOutOfRange( weekDay, 0, 6 ) ) return null;
                    break;
                case dateFormat.TIME_ZONE_OFFSET_FULL:
                    var offsets = matchGroup.split( /:/ );
                    if ( offsets.length !== 2 ) return null;

                    hourOffset = parseInt( offsets[ 0 ], 10 );
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    
                    var minOffset = parseInt( offsets[ 1 ], 10 );
                    if ( valueOutOfRange( minOffset, 0, 59 ) ) return null;
                    
                    tzMinOffset = (hourOffset * 60) + (patternStartsWith( matchGroup, '-' ) ? -minOffset : minOffset);
                    break;
                case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT: case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                    // Time zone offset in +/- hours.
                    hourOffset = matchInt;
                    if ( valueOutOfRange( hourOffset, -12, 13 ) ) return null;
                    tzMinOffset = hourOffset * 60;
                    break;
            }
        }
    }
    var result = new Date(), defaultYear, convert = cal.convert;
    defaultYear = convert ? convert.fromGregorian( result )[ 0 ] : result.getFullYear();
    if ( year === null ) {
        year = defaultYear;
    }
    
    // set default day and month to 1 and January, so if unspecified, these are the defaults
    // instead of the current day/month.
    if ( month === null ) {
        month = 0;
    }
    if ( date === null ) {
        date = 1;
    }
    // now have year, month, and date, but in the culture's calendar.
    if ( convert ) {
        result = convert.toGregorian( year, month, date );
        if ( result === null ) return null;
    }
    else {
        // have to set year, month and date together to avoid overflow based on current date.
        result.setFullYear( year, month, date );
        // check to see if date overflowed for specified month (only checked 1-31 above).
        if ( result.getDate() !== date ) return null;
        // invalid day of week.
        if ( weekDay !== null && result.getDay() !== weekDay ) {
            return null;
        }
    }
    // if pm designator token was found make sure the hours fit the 24-hour clock.
    if ( pmHour && hour < 12 ) {
        hour += 12;
    }
    result.setHours( hour, min, sec, msec );
    if ( tzMinOffset !== null ) {
        var adjustedMin = result.getMinutes() - ( tzMinOffset + result.getTimezoneOffset() );
        result.setHours( result.getHours() + parseInt( adjustedMin / 60, 10 ), adjustedMin % 60 );
    }
    return result;
}


function formatDateToCulture(value, format, culture) {
    var cal = culture.calendar,
        convert = cal.convert;
    if ( !format || !format.length || format === 'i' ) {
        var ret;
        if ( culture && culture.name.length ) {
            if ( convert ) {
                // non-gregorian calendar, so we cannot use built-in toLocaleString()
                ret = formatDateToCulture( value, cal.patterns.F, culture );
            }
            else {
                ret = value.toLocaleString();
            }
        }
        else {
            ret = value.toString();
        }
        return ret;
    }

    var sortable = format === "s";
        format = getFullDateFormat(cal, format);


    // Start with an empty string
    ret = [];
    var hour,
        zeros = ['0','00','000'],
        foundDay,
        checkedDay,
        dayPartRegExp = /([^d]|^)(d|dd)([^d]|$)/g,
        quoteCount = 0,
        tokenRegExp = /\/|dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|y|hh|h|HH|H|mm|m|ss|s|tt|t|fff|ff|f|zzz|zz|z|gg|g/g,
        converted;

    function padWithZeros(num, c) {
        var r, s = num+'';
        if ( c > 1 && s.length < c ) {
            r = ( zeros[ c - 2 ] + s);
            return r.substr( r.length - c, c );
        }
        else {
            r = s;
        }
        return r;
    }

    function hasDay() {
        if ( foundDay || checkedDay ) {
            return foundDay;
        }
        foundDay = dayPartRegExp.test( format );
        checkedDay = true;
        return foundDay;
    }

    if ( !sortable && convert ) {
        converted = convert.fromGregorian( value );
    }

    for (;;) {
        // Save the current index
        var index = tokenRegExp.lastIndex,
            // Look for the next pattern
            ar = tokenRegExp.exec( format );

        // Append the text before the pattern (or the end of the string if not found)
        var preMatch = format.slice( index, ar ? ar.index : format.length );
        quoteCount += appendMatchStringCount( preMatch, ret );

        if ( !ar ) {
            break;
        }

        // do not replace any matches that occur inside a string literal.
        if ( quoteCount % 2 ) {
            ret.push( ar[ 0 ] );
            continue;
        }

        var current = ar[ 0 ],
            clength = current.length;


        switch ( current ) {
            case dateFormat.DAY_OF_WEEK_THREE_LETTER:
            case dateFormat.DAY_OF_WEEK_FULL_NAME:
                var names = (clength === 3) ? cal.days.namesAbbr : cal.days.names;
                ret.push( names[ value.getDay() ] );
                break;
            case dateFormat.DAY_OF_MONTH_SINGLE_DIGIT:
            case dateFormat.DAY_OF_MONTH_DOUBLE_DIGIT:
                foundDay = true;
                ret.push( padWithZeros( (converted ? converted[2] : value.getDate()), clength ) );
                break;
            case dateFormat.MONTH_THREE_LETTER:
            case dateFormat.MONTH_FULL_NAME:
                var part = converted ? converted[1] : value.getMonth();
                ret.push( (cal.monthsGenitive && hasDay())
                    ? cal.monthsGenitive[ clength === 3 ? "namesAbbr" : "names" ][ part ]
                    : cal.months[ clength === 3 ? "namesAbbr" : "names" ][ part ] );
                break;
            case dateFormat.MONTH_SINGLE_DIGIT:
            case dateFormat.MONTH_DOUBLE_DIGIT:
                ret.push( padWithZeros((converted ? converted[1] : value.getMonth()) + 1, clength ) );
                break;
            case dateFormat.YEAR_SINGLE_DIGIT:
            case dateFormat.YEAR_DOUBLE_DIGIT:
            case dateFormat.YEAR_FULL:
                part = converted ? converted[ 0 ] : value.getFullYear();
                if ( clength < 4 ) {
                    part = part % 100;
                }
                ret.push( padWithZeros( part, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_12_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_12_HOUR_CLOCK:
                hour = value.getHours() % 12;
                if ( hour === 0 ) hour = 12;
                ret.push( padWithZeros( hour, clength ) );
                break;
            case dateFormat.HOURS_SINGLE_DIGIT_24_HOUR_CLOCK:
            case dateFormat.HOURS_DOUBLE_DIGIT_24_HOUR_CLOCK:
                ret.push( padWithZeros( value.getHours(), clength ) );
                break;
            case dateFormat.MINUTES_SINGLE_DIGIT:
            case dateFormat.MINUTES_DOUBLE_DIGIT:
                ret.push( padWithZeros( value.getMinutes(), clength ) );
                break;
            case dateFormat.SECONDS_SINGLE_DIGIT:
            case dateFormat.SECONDS_DOUBLE_DIGIT:
                ret.push( padWithZeros(value .getSeconds(), clength ) );
                break;
            case dateFormat.MERIDIAN_INDICATOR_SINGLE:
            case dateFormat.MERIDIAN_INDICATOR_FULL:
                part = value.getHours() < 12 ? (cal.AM ? cal.AM[0] : " ") : (cal.PM ? cal.PM[0] : " ");
                ret.push( clength === 1 ? part.charAt( 0 ) : part );
                break;
            case dateFormat.DECISECONDS:
            case dateFormat.CENTISECONDS:
            case dateFormat.MILLISECONDS:
                ret.push( padWithZeros( value.getMilliseconds(), 3 ).substr( 0, clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_SINGLE_DIGIT:
            case dateFormat.TIME_ZONE_OFFSET_DOUBLE_DIGIT:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), clength ) );
                break;
            case dateFormat.TIME_ZONE_OFFSET_FULL:
                hour = value.getTimezoneOffset() / 60;
                ret.push( (hour <= 0 ? '+' : '-') + padWithZeros( Math.floor( Math.abs( hour ) ), 2 ) +
                    ":" + padWithZeros( Math.abs( value.getTimezoneOffset() % 60 ), 2 ) );
                break;
            case dateFormat.DATE_SEPARATOR:
                ret.push( cal["/"] || "/" );
                break;
            default:
                throw "Invalid date format pattern '" + current + "'.";
                break;
        }
    }
    return ret.join( '' );
}

//add new culture into ej 
ej.globalize.addCulture = function (name, culture) {
    ej.cultures[name] = $.extend(true, $.extend(true, {}, ej.cultures['default'], culture), ej.cultures[name]);
	ej.cultures[name].calendar = ej.cultures[name].calendars.standard;
}

//return the specified culture or default if not found
ej.globalize.preferredCulture = function (culture) {
    culture = (typeof culture != "undefined" && typeof culture === typeof this.cultureObject) ? culture.name : culture;
    this.cultureObject = ej.globalize.findCulture(culture);
    return this.cultureObject;
}
ej.globalize.setCulture = function (culture) {
	if (ej.isNullOrUndefined(this.globalCultureObject)) this.globalCultureObject = ej.globalize.findCulture(culture);
	culture = (typeof culture != "undefined" && typeof culture === typeof this.globalCultureObject) ? culture.name : culture;
    if (culture) this.globalCultureObject = ej.globalize.findCulture(culture);
    ej.cultures.current = this.globalCultureObject;
    return this.globalCultureObject;
}
ej.globalize.culture=function(name){
    ej.cultures.current = ej.globalize.findCulture(name);
}

//return the specified culture or current else default if not found
ej.globalize.findCulture = function (culture) {
    var cultureObject;
    if (culture) {

        if ($.isPlainObject(culture) && culture.numberFormat) {
            cultureObject = culture;
        }
        if (typeof culture === "string") {
            var cultures = ej.cultures;
            if (cultures[culture]) {
                return cultures[culture];
            }
            else {
                if (culture.indexOf("-") > -1) {
                    var cultureShortName = culture.split("-")[0];
                    if (cultures[cultureShortName]) {
                        return cultures[cultureShortName];
                    }
                }
                else {
                    var cultureArray = $.map(cultures, function (el) { return el });
                    for (var i = 0; i < cultureArray.length; i++) {
                        var shortName = cultureArray[i].name.split("-")[0];
                        if (shortName === culture) {
                            return cultureArray[i];
                        }
                    };
                }
            }
            return ej.cultures["default"];
        }
    }
    else {
        cultureObject = ej.cultures.current || ej.cultures["default"];
    }

    return cultureObject;
}
//formatting date and number based on given format
ej.globalize.format = function (value, format, culture) {
    var cultureObject =  ej.globalize.findCulture(culture);
    if (typeof(value) === 'number') {
        value = formatNumberToCulture(value, format, cultureObject);
    } else if(value instanceof Date){
    	value = formatDateToCulture(value, format, cultureObject);
    }

    return value;
}

//parsing integer takes string as input and return as number
ej.globalize.parseInt = function(value, radix, culture) {
	if(!radix)
		radix = 10;
    return Math.floor( parseValue( value, culture, radix ) );
}

//returns the ISO date string from date object
ej.globalize.getISODate = function(value) {
    if(value instanceof Date) return value.toISOString();
}

//parsing floationg poing number takes string as input and return as number
ej.globalize.parseFloat = function(value, radix, culture) {
	if (typeof radix === "string") {
        culture = radix;
        radix = 10;
    }
    return parseValue( value, culture);
}

//parsing date takes string as input and return as date object
ej.globalize.parseDate = function(value, formats, culture) {
    culture = ej.globalize.findCulture(culture);

    var date, prop, patterns;
    if ( formats ) {
        if ( typeof formats === "string" ) {
            formats = [ formats ];
        }
        if ( formats.length ) {
            for ( var i = 0, l = formats.length; i < l; i++ ) {
                var format = formats[ i ];
                if ( format ) {
                    date = getParsedDate( value, format, culture );
                    if ( date ) break;
                }
            }
        }
    }
    else {
        patterns = culture.calendar.patterns;
        for ( prop in patterns ) {
            date = getParsedDate( value, patterns[prop], culture );
            if ( date ) break;
        }
    }
    return date || null;
}

function getControlObject(obj, stringArray){
    return stringArray.length ? getControlObject(obj[stringArray[0]], stringArray.slice(1)) : obj;
}

//return localized constants as object for the given widget control and culture
ej.globalize.getLocalizedConstants = function(controlName, culture){
    var returnObject,
        controlNameArray = controlName.replace("ej.", "").split(".");
    
    returnObject = getControlObject(ej, controlNameArray);

    return ( $.extend(true, {}, returnObject.Locale['default'], returnObject.Locale[culture ? culture : this.cultureObject.name]) ) ;
}

$.extend(ej, ej.globalize);

}(jQuery));;
/**
* @fileOverview Plugin to style the Html Div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitter", "ej.Splitter", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _rootCSS: "e-splitter",
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            cssClass: "",

            orientation: "horizontal",

            enableAnimation: true,

            properties: [],

            height: null,

            width: null,

            // EnableAutoResize is a deprecated API, we can achieve this requirement by isResponsive property
            enableAutoResize: false,

            isResponsive: false,

            enableRTL: false,
			
			allowKeyboardNavigation: true,

            htmlAttributes: {},

            animationSpeed: 300,

            beforeExpandCollapse: null,

            expandCollapse: null,

            resize: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            cssClass: "string",
            orientation: "enum",
            properties: "data",
            enableAutoResize: "boolean",
            isResponsive: "boolean",
            enableRTL: "boolean",
			allowKeyboardNavigation: "boolean",
            animationSpeed: "number",
            enableAnimation: "boolean",
            htmlAttributes: "data",
        },


        _init: function () {
            this._initialize();
            this._render();
            if (this.model.isResponsive || this.model.enableAutoResize)
                this._wireEvents(true);
            else
                this._wireEvents(false);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "enableAutoResize": this._windowResizing(options[option]); break;
                    case "isResponsive": this._windowResizing(options[option]); break;
                    case "enableRTL": this._rtl(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "orientation": this._refreshSplitter("orientation", options[option]); break;
                    case "properties": this._refreshSplitter("properties", options[option]); break;
                    case "width": this.model.width = options[option]; this._setHeightWidth(); break;
                    case "height": this.model.height = options[option]; this._setHeightWidth(); break;
                }
            }
        },

        refresh: function () {
            this._setPanesSize();
            this._getPanesPercent();
        },

        collapse: function (paneIndex) {
            this._clickArrow(paneIndex, true, true);
        },

        expand: function (paneIndex) {
            this._clickArrow(paneIndex, false, true);
        },

        _clickArrow: function (index, bool, canClick) {
            if (this._inMovement || index < 0 || index > this.panes.length || this.panes.length <= 1) return false;
            var arrow, cls = bool ? "e-collapse" : "e-expand", splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == splitbars.length) arrow = this._clickArrow(index - 1, !bool, false);
            else arrow = $(splitbars[index]).children("." + cls);
            if (canClick) arrow.css("display") != "none" && arrow.mouseup();
            else return arrow;
        },


        addItem: function (content, property, index) {
            var paneCount = this.panes.length;
            index = this._getNumber(index);
			 var totalSize = this.element[this.containerCss]();
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount) return "";
            var property = this._getPaneProperty(property), paneDiv, paneDivSize, requiredSize;
            property = this._checkMinMaxSize(property);
            paneDiv = ej.buildTag("div.e-pane e-" + this.model.orientation.substr(0, 1) + "-pane");
            this.element.append(paneDiv[this.containerCss](property.paneSize));
            paneDivSize = property.paneSize = paneDiv[this.containerCss]();
			 if(paneCount==0) this.panes.push(paneDiv);	
            paneDiv.remove();
            var start = index, end = (paneCount>0)?paneCount:this.panes.length, i, j, insert, before, direction = 2, getters = {}, taken = 0, canInsert = false;
            requiredSize = paneDivSize + this._bar;

            for (j = 0; j < direction; j++) {
                for (i = start; i < end; i++) {
                    var _paneSize = $(this.panes[i])[this.containerCss]();
					 var minSize=(!ej.isNullOrUndefined(this.model.properties[i]))?(this.model.properties[i].minSize): property.minSize;
                    var availableSpace = _paneSize - minSize;
                    if (availableSpace >= requiredSize - taken) {
                        getters[i] = _paneSize - (requiredSize - taken);
                        canInsert = true;
                        break;
                    }
					else if((paneCount==0)&&(availableSpace>=0)){
						  getters[i] = minSize;
                        taken += availableSpace;
						canInsert=true;
					}
                    else if (availableSpace > 0) {
                        getters[i] = minSize;
                        taken += availableSpace;
                    }
                }
                if (canInsert) break;
                else end = start, start = 0;
            }
            if (!canInsert) return "";
            for (var pos in getters)
                $(this.panes[pos])[this.containerCss](getters[pos]);
			if(paneCount<=0) paneDiv.append($(this.panes[index]));
			else{
            if (index == paneCount) {
                insert = "insertBefore", before = 1;
                paneDiv.insertAfter($(this.panes[index - 1]));
            }
            else {
                insert = "insertAfter", before = 0;
                paneDiv.insertBefore($(this.panes[index]));
            }
			 }
            this.model.properties.splice(index, 0, property);
			 if(paneCount==0)this.element.append(paneDiv[this.containerCss](totalSize));			
			 if(paneCount>0){
            this.panes.splice(index, 0, paneDiv);
            var splitBar = this._createSplitBar(index - before);
            splitBar[insert](paneDiv);
			 }
            paneDiv.append(content);
            this._updateModel();
            return paneDiv;
        },


        removeItem: function (index) {
            var paneCount = this.panes.length - 1;
            index = this._getNumber(index);
            if (ej.isNullOrUndefined(index)) index = paneCount;
            if (index < 0 || index > paneCount || paneCount < 0) return null;
            var targetPane, nextPane, splitbars, removedSize;
            targetPane = $(this.panes[index]);
            removedSize = targetPane[this.containerCss]() + this._bar;
            targetPane.remove();
            splitbars = this.element.children(".e-splitbar:not(.e-shadowbar)");
            if (index == paneCount) {
                nextPane = $(this.panes[index - 1]);
                $(splitbars[index - 1]).remove();
            }
            else {
                nextPane = $(this.panes[index + 1]);
                $(splitbars[index]).remove();
            }
            nextPane[this.containerCss](nextPane[this.containerCss]() + removedSize);
            this._removeArrays(index);
            this._updateModel();
        },
        _checkMinMaxSize: function (property) {
            if ((!ej.isNullOrUndefined(property.minSize))&&(property.paneSize < property.minSize))
                property.paneSize = property.minSize;
            if ((!ej.isNullOrUndefined(property.maxSize))&&(property.paneSize > property.maxSize))
                property.paneSize = property.maxSize;
            return property;
        },

        _removeArrays: function (index) {
            this.model.properties.splice(index, 1);
            this.panes.splice(index, 1);
            this.oldPaneSize.splice(index, 1);
            this.oldPanePercent.splice(index, 1);
            this._sizePercent.splice(index, 1);
        },

        _getNumber: function (value) {
            value = parseFloat(value);
            return isNaN(value) ? null : value;
        },

        _updateModel: function () {
            for (var i = 0; i < this.panes.length; i++)
                this.model.properties[i].paneSize = $(this.panes[i])[this.containerCss]();
            this._getPanesPercent();
        },

        _getPaneProperty: function (property) {
            var _default = { paneSize: 10, minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true };
            return $.extend(_default, property);
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
        },

        _windowResizing: function (boolean) {
            if (boolean) this._wireEvents(boolean);
            else this._unWireEvents();
        },

        _refreshSplitter:function(key,value){
            this._unWireEvents();
            this._refreshDestroy();
            this.model[key] = value;
            this._init();
        },

		_destroy: function() {
			this.element.removeClass("e-splitter");
			this._refreshDestroy();
			this._unWireEvents();
		},

        _refreshDestroy: function () {
            this.element.removeClass("e-widget e-box e-rtl" + this.model.cssClass + " e-" + this.model.orientation);
            this.element.children(".e-splitbar").remove();
            this.element.children(".e-pane").removeClass("e-pane e-" + this.model.orientation.substr(0, 1) + "-pane").height("").width("");
        },

        _initialize: function () {
            this.panes = [];
            this.oldPaneSize = [];
            this.oldPanePercent = [];
            this._initialPropertiesValue = [];
            this._updateHeightWidth = false;
            this.shadowBar = null;
            this._inMovement = false;
            this.containerCss = this.model.orientation == "horizontal" ? "width" : "height";
            this.displayCss = this.model.orientation == "horizontal" ? "left" : "top";
            this.borderCss = this.model.orientation == "horizontal" ? "right" : "bottom";
            this._bar = 9;      // For the center splitbar size
        },

        _render: function () {
            this.element.addClass("e-widget e-box " + this.model.cssClass + " e-" + this.model.orientation).attr("data-role", "splitter");
            var i, j, target = this.element[0];
            for (i = 0, j = 0; i < target.children.length; i++) {
                $(target.children[i]).addClass("e-pane");
                this.panes.push(target.children[i]);
            }
            this._setPanesProperty();
            this._insertSplitBar();
            this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
            this._addAttr(this.model.htmlAttributes);
            this._checkProperties();
            this.element.find(".e-pane").addClass("e-" + this.model.orientation.substr(0, 1) + "-pane");
			if(this.model.isResponsive){
				if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
					this.element.css("height",this.model.height);
				if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
					this.element.css("width",this.model.width );
			}
        },

        _setPanesProperty: function () {
            for (var p = 0; p < this.panes.length; p++) {
                if (this.model.properties[p] != undefined) {
                    this.model.properties[p].paneSize = this.model.properties[p].paneSize == undefined ? "0px" : this.model.properties[p].paneSize;
                    this.model.properties[p].minSize = isNaN(parseFloat(this.model.properties[p].minSize)) ? 10 : parseFloat(this.model.properties[p].minSize);
                    this.model.properties[p].maxSize = isNaN(parseFloat(this.model.properties[p].maxSize)) ? null : parseFloat(this.model.properties[p].maxSize);
                    this.model.properties[p].collapsible = this.model.properties[p].collapsible != false ? true : false;
                    this.model.properties[p].resizable = this.model.properties[p].resizable != false ? true : false;
                    this.model.properties[p].expandable = this.model.properties[p].expandable != false ? true : false;
                }
                else this.model.properties.push({ paneSize: "0px", minSize: 10, maxSize: null, collapsible: true, resizable: true, expandable: true });
                this._initialPropertiesValue[p] = this.model.properties[p].paneSize;
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value)
            });
        },


        _insertSplitBar: function () {
            if (this.panes.length > 1) {
                var i, splitBar;
                for (i = 0; i < this.panes.length - 1; i++) {
                    splitBar = this._createSplitBar(i);
                    splitBar.insertAfter(this.panes[i]);
                }
            }
        },

        _createSplitBar: function (i) {
            var orient = this.model.orientation.substr(0, 1), arrow1, arrow2, arrow3, splitBar, accessible = false;
            splitBar = ej.buildTag("span.e-box e-splitbar e-split-divider e-" + orient + "-bar").attr("aria-expanded", true);
            ej.browserInfo().name == "msie" && splitBar.addClass("e-pinch");
            arrow1 = ej.buildTag("span.e-icon e-collapse e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-left" :"e-arrow-sans-up"));
            splitBar.append(arrow1);
            arrow3 = ej.buildTag("span.e-activebar e-" + orient + "-arrow ");
            splitBar.append(arrow3);
            arrow2 = ej.buildTag("span.e-icon e-expand e-" + orient + "-arrow " + ((orient == "h") ? "e-arrow-sans-right" :"e-arrow-sans-down"));
            splitBar.append(arrow2);
            accessible = true;
            this._on(arrow1, "mouseup", this._collapseArrowClick);
            this._on(arrow2, "mouseup", this._expandArrowClick);
            if (!this.model.properties[i].collapsible)
                arrow1.css("display", "none");
		   if(!this.model.properties[i].expandable)
			   arrow2.css("display", "none");
            if (this.model.properties[i + 1].collapsible)
                arrow2.css("display", "block");
            if (this.model.properties[i].resizable && this.model.properties[i + 1].resizable) {
                splitBar.addClass("e-resize").removeClass("e-icon-hide");
                accessible = true;
                this._on(splitBar, ej.eventType.mouseDown, this._mouseDownOnDivider);
                this._on(arrow3, ej.eventType.mouseDown, this._mouseDownOnDivider);
            }
            if (accessible) {
                splitBar.attr({ "role": "separator", "tabindex": "0" });
                this._on(splitBar, "focus focusout", this._focusOnDivider);
            }
            else splitBar.attr({ "role": "presentation" });
            return splitBar;
        },
        _getPanesPercent: function () {
            this._sizePercent = [];
            var size = this.element[this.containerCss](), outerSize = size - ((this.panes.length - 1) * this._bar), i;
            for (i = 0; i < this.panes.length; i++) {
                if (!$(this.panes[i]).hasClass("collapsed"))
                    this.oldPaneSize[i] = $(this.panes[i])[this.containerCss]();
                this.oldPanePercent[i] = this._convertToPercent(outerSize, this.oldPaneSize[i]);
                this._sizePercent.push(this._convertToPercent(outerSize, $(this.panes[i])[this.containerCss]()));
            }
        },

        _setDimentions: function () {
			var parentObj = this._getParentObj(),_width = parseInt(this.model.width), _height = parseInt(this.model.height);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerWidth(), _width):this.model.width;
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = (this.model.isResponsive) ? this._convertToPixel(parentObj.innerHeight(), _height):this.model.height;
            if (this.model.height)
                this.element.css("height",_height);
            if (this.model.width)
                this.element.css("width",_width );
        },

        _setHeightWidth: function () {
            this._updateHeightWidth = true;
   		    this._setDimentions();
            this._setPanesSize();
            this._getPanesPercent();
        },

         _getParentObj: function () {
            return this.element.parent();
        },
        _checkProperties: function () {
            if (this.model.enableRTL) this._rtl(this.model.enableRTL);
            this._prevSize = this.element[this.containerCss]();
        },
        _getExactInnerWidth: function () {
            var browser = ej.browserInfo(), exactInnerWidth;
            if (browser.name == "msie") {
                if (browser.version == 8 || browser.version == 9)
                    exactInnerWidth = $(this.element)[this.containerCss]();
                else
                    exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss]);
            }
            else
                exactInnerWidth = parseFloat(window.getComputedStyle(this.element[0])[this.containerCss])
                                 - (parseFloat(this.element.css("border-" + this.displayCss + "-width")) +
                                     parseFloat(this.element.css("border-" + this.borderCss + "-width")) +
                                     parseFloat(this.element.css("padding-" + this.displayCss)) +
                                     parseFloat(this.element.css("padding-" + this.borderCss)));
            return exactInnerWidth;
        },

        _rtl: function (boolean) {
            if (boolean) this.element.addClass("e-rtl");
            else this.element.removeClass("e-rtl");
        },

        _setPanesSize: function () {
            var attr = this.containerCss,
            zeroPanes = 0,
            totalPaneSize = 0,
            totalSize = this.element[attr](),
            remainZero = false,
            bar = this._bar=($(this.element).find(">.e-splitbar").length>0)?parseFloat($(this.element).find(">.e-splitbar").css(attr)):this._bar,
            zerothPanes = [],
            panLength, j, paneCount = this.panes.length;

            if (paneCount > 1) {
                for (j = 0; j < paneCount ; j++) {
                    $(this.panes[j]).css(attr, (this._updateHeightWidth == true) ? this._initialPropertiesValue[j] : this.model.properties[j].paneSize);
                    this._updateHeightWidth = false;
                    bar = (j == paneCount - 1) ? 0 : bar;
                    panLength = parseFloat($(this.panes[j])[attr]());
                    if(!ej.isNullOrUndefined(this.model.properties[j].maxSize)) panLength = panLength > this.model.properties[j].maxSize ? this.model.properties[j].maxSize : panLength;
                    $(this.panes[j]).css(attr, panLength);
                    if (panLength <= 0) {
                        zeroPanes++;
                        zerothPanes.push(j);
                        totalPaneSize += bar;
                    }
                    else {
                        if (remainZero) {
                            $(this.panes[j]).css(attr, 0);
                            totalPaneSize += panLength + bar;
                            this.model.properties[j].paneSize = 0;
                        }
                        else {
                            totalPaneSize += panLength + bar;
                            if (totalPaneSize > totalSize) {
                                var currPane = totalPaneSize - totalSize + bar,
                                remainDivider = paneCount - j - 1;
                                currPane += remainDivider * bar;
                                $(this.panes[j]).css(attr, currPane);
                                remainZero = true;
                                totalPaneSize += currPane + bar;
                            }
                            this.model.properties[j].paneSize = panLength;
                        }
                    }
                }
            }
            else if (paneCount == 1) {
                $(this.panes[0]).css(attr, "100%");
                totalPaneSize = totalSize;
            }

            if (paneCount > 1 && totalPaneSize != totalSize) {
			     var remainingSize, lastPane = $(this.panes[paneCount - 1]);
                if (totalPaneSize > totalSize) {
                    remainingSize = totalPaneSize - totalSize;
                    lastPane.css(attr, remainingSize);
                }
                else if (totalPaneSize < totalSize) {
                    remainingSize = totalSize - totalPaneSize;
                    if (zeroPanes > 0) {
                        var z, avgWid = parseFloat(remainingSize / zeroPanes);
                        for (z = 0; z < zeroPanes ; z++) {
                            $(this.panes[zerothPanes[z]]).css(attr, avgWid);
                            this.model.properties[zerothPanes[z]].paneSize = avgWid;
                        }
                    }
                    else {
                        for(var i = paneCount; i > 0; i--){
                            if(ej.isNullOrUndefined(this.model.properties[i - 1].maxSize)){ lastPane = $(this.panes[i - 1]); break;	}
                        }
                        lastPane.css(attr, parseFloat(lastPane[attr]() + remainingSize));
                        this.model.properties[paneCount - 1].paneSize = lastPane[attr]();
                    }
                }
            }
            if (paneCount > 1) this._checkPaneSize();
        },

        _getUnit: function (str) {
            if (str == "px") return "px";
            else if (str == "pt") return "pt";
            else if (str.substr(1) == "%") return "%";
            else return "px";
        },

        _getNormalValue: function (position) {
            var currentLOB, currentLOBPercent, totalValue, currentValue;
            if (this.model.orientation == "vertical") {
                currentLOB = position.y - this.element.offset().top;
                currentLOBPercent = currentLOB / this.element.outerHeight();
                totalValue = this.element.height();
            }
            else {
                currentLOB = position.x - this.element.offset().left;
                currentLOBPercent = currentLOB / this.element.outerWidth();
                totalValue = this.element.width();
            }
            if (currentLOBPercent > 1) {
                currentLOBPercent = 1;
            }
            if (currentLOBPercent < 0) {
                currentLOBPercent = 0;
            }
            currentValue = currentLOBPercent * totalValue;
            return this._trimValue(currentValue);
        },

        _trimValue: function (value) {
            var step, stepModValue, correctedValue;
            step = 1;
            stepModValue = (value) % step;
            correctedValue = value - stepModValue;
            if (Math.abs(stepModValue) * 2 >= step)
                correctedValue += (stepModValue > 0) ? step : (-step);
            return parseFloat(correctedValue.toFixed(5));
        },

        _getSplitbarIndex: function () {
            return this.element.children(".e-splitbar:not(.e-shadowbar)").index(this.currentSplitBar);
        },

        _paneResize: function () {
            if (this.shadowBar == null) return false;
            this.currentSplitBar = this.shadowBar.next();
            var newPosition, prevPane, nextPane, prevPaneIndex, nextPaneIndex, index = this._getSplitbarIndex();
            prevPane = this.shadowBar.prev(), nextPane = this.currentSplitBar.next();
            prevPaneIndex = index, nextPaneIndex = index + 1;
            newPosition = this.shadowBar.offset()[this.displayCss];
            newPosition = newPosition - this.currentSplitBar.offset()[this.displayCss];
            $(prevPane).css(this.containerCss, newPosition + $(prevPane)[this.containerCss]() + "px");
            $(nextPane).css(this.containerCss, $(nextPane)[this.containerCss]() - newPosition + "px");
            this.oldPaneSize[prevPaneIndex] = $(prevPane)[this.containerCss]();
            this.oldPaneSize[nextPaneIndex] = $(nextPane)[this.containerCss]();
            this.shadowBar.remove();
            this._checkPaneSize();
            var prevObj = { item: prevPane, index: prevPaneIndex, size: this.oldPaneSize[prevPaneIndex] };
            var nextObj = { item: nextPane, index: nextPaneIndex, size: this.oldPaneSize[nextPaneIndex] };
            this._updateModelValue(prevObj, nextObj);
            this._trigger("resize", {
                prevPane: prevObj,
                nextPane: nextObj,
                splitbarIndex: index
            });
        },

        _checkPaneSize: function () {
            var total = 0, len, i, splitterLen, paneCount = this.panes.length;
            for (i = 0; i < paneCount; i++) {
                len = this.containerCss=='width' ? $(this.panes[i])['outerWidth']() :$(this.panes[i])['outerHeight']();
                total += len + this._bar;
            }
            total -= this._bar;
            splitterLen = this._getExactInnerWidth();
            if (total != splitterLen) {
                var remain = splitterLen - total;
                var last = $(this.panes[paneCount - 1])[this.containerCss]();
                var lastPaneBorder = parseFloat($(this.panes[paneCount-1]).css('border-left-width'))+parseFloat($(this.panes[paneCount-1]).css('border-right-width'));
                var lastPaneBorderLength = (lastPaneBorder > 0) ? lastPaneBorder : 1;
                if (last == 0) {
                    for (i = paneCount - 1; i >= 0; i--) {
                        if ($(this.panes[i]).hasClass("expanded") && !$(this.panes[i]).hasClass("collapsed")) {
                            last = $(this.panes[i])[this.containerCss]();
                            $(this.panes[i]).css(this.containerCss, parseFloat(last + remain));
                            break;
                        }
                    }
                }
                else
                    $(this.panes[paneCount - 1]).css(this.containerCss, parseFloat(last + remain - lastPaneBorderLength));
            }
        },

        _maxminDraggableRange: function (shadowbarPos) {
            var prevPane, nextPane, prevPaneSize, nextPaneSize, splitbarPosition, prevPaneRange, nextPaneRange,
                prevPaneIndex, nextPaneIndex, PaneMax1, PaneMax2, PaneMin1, PaneMin2, index;
            prevPane = this.shadowBar.prev();
            this.currentSplitBar = this.shadowBar.next();
            nextPane = this.currentSplitBar.next();
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            splitbarPosition = this.displayCss == "left" ? this.currentSplitBar[0].offsetLeft : this.currentSplitBar[0].offsetTop;
            prevPaneRange = splitbarPosition - prevPaneSize;
            nextPaneRange = nextPaneSize + splitbarPosition;
            index = this._getSplitbarIndex();
            prevPaneIndex = index;
            nextPaneIndex = index + 1;
            PaneMax1 = this.model.properties[prevPaneIndex].maxSize;
            PaneMax2 = this.model.properties[nextPaneIndex].maxSize;
            PaneMax1 = PaneMax1 != null ? parseInt(PaneMax1, 10) : null;
            PaneMax2 = PaneMax2 != null ? parseInt(PaneMax2, 10) : null;
            this.model.properties[prevPaneIndex].minSize = parseInt(this.model.properties[prevPaneIndex].minSize, 10);
            this.model.properties[nextPaneIndex].minSize = parseInt(this.model.properties[nextPaneIndex].minSize, 10);
            PaneMin1 = this.model.properties[prevPaneIndex].minSize;
            PaneMin2 = this.model.properties[nextPaneIndex].minSize;
            this.shadowBar.removeClass("e-end-indicaton");
            if (shadowbarPos > nextPaneRange - PaneMin2) {
                this.resizedPosition = nextPaneRange - PaneMin2;
                this.shadowBar.addClass("e-end-indicaton");
            }
            else if (shadowbarPos < prevPaneRange + PaneMin1) {
                this.resizedPosition = prevPaneRange + PaneMin1;
                this.shadowBar.addClass("e-end-indicaton");
            }
            if (PaneMax1 != null) {
                if (shadowbarPos > prevPaneRange + PaneMax1) {
                    this.resizedPosition = prevPaneRange + PaneMax1;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
            else if (PaneMax2 != null) {
                if (shadowbarPos < nextPaneRange - PaneMax2) {
                    this.resizedPosition = nextPaneRange - PaneMax2;
                    this.shadowBar.addClass("e-end-indicaton");
                }
            }
        },

        _collapseArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };
            expanded = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!nextPane.hasClass("collapsed")) {
                this.oldPaneSize[prevPaneIndex] = prevPaneSize;
                prevPane.addClass("collapsed");
                nextPane.addClass("expanded");
                this.currentSplitBar.attr("aria-expanded", false);
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[nextPaneIndex].collapsible)
                     $($target.siblings()).not('.e-activebar').css("display", "block");
                if (prevPaneIndex != 0) {
                    var preBar = prevPane.prev();
                    preBar.find(".e-expand").css("display", "none");
                    if (!this.model.properties[prevPaneIndex - 1].collapsible && $(prevPane.prev().prev()[0]).hasClass("expanded"))
                        preBar.find(".e-collapse").css("display", "block");
                    preBar.removeClass("e-resize").addClass("e-icon-hide");
                }
                properties[this.containerCss] = 0;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (prevPaneSize < this.oldPaneSize[nextPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("expanded");
                    nextPane.removeClass("collapsed");
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                    $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[prevPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (nextPaneIndex != paneCount - 1) {
                        var nextBar = nextPane.next();
                        if (!this.model.properties[nextPaneIndex + 1].collapsible)
                            nextBar.find(".e-expand").css("display", "none");
                        nextBar.find(".e-collapse").css("display", "block");
                        if (!nextBar.next().hasClass("collapsed")) {
                            nextBar.addClass("e-resize").removeClass("e-icon-hide");
                            nextBar.attr("aria-expanded", true);
                        }
                    }

                    properties[this.containerCss] = this.oldPaneSize[nextPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = prevPaneSize - this.oldPaneSize[nextPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _expandArrowClick: function (event) {
            if (this.shadowBar != null) return;
            var $target = $(event.target);
            this._inMovement = true;
            this.currentSplitBar = $target.parent();
            var currBarNo, prevPane, nextPane, prevPaneIndex, nextPaneIndex, prevPaneSize, nextPaneSize, properties = {};
            var paneCount = this.panes.length;
            currBarNo = this._getSplitbarIndex();
            prevPane = this.currentSplitBar.prev();
            nextPane = this.currentSplitBar.next();
            prevPaneIndex = currBarNo;
            nextPaneIndex = currBarNo + 1;
            prevPaneSize = prevPane[this.containerCss]();
            nextPaneSize = nextPane[this.containerCss]();
            var proxy = this, collapsed, expanded;
            collapsed = { item: nextPane, index: nextPaneIndex, size: nextPaneSize };
            expanded = { item: prevPane, index: prevPaneIndex, size: prevPaneSize };

            if (this._raiseEvent("beforeExpandCollapse", collapsed, expanded, currBarNo))
                return false;
            if (!prevPane.hasClass("collapsed")) {
                this.oldPaneSize[nextPaneIndex] = nextPaneSize;
                prevPane.addClass("expanded");
                nextPane.addClass("collapsed");
                $target.parent().removeClass("e-resize").addClass("e-icon-hide");
                $target.css("display", "none");
                if (!this.model.properties[prevPaneIndex].collapsible)
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                if (nextPaneIndex != paneCount - 1) {
                    var nextBar = nextPane.next();
                    nextBar.find(".e-collapse").css("display", "none");
                    if (!this.model.properties[nextPaneIndex + 1].collapsible && $(nextPane.next().next()[0]).hasClass("collapsed"))
                        nextBar.find(".e-expand").css("display", "block");
                    nextBar.removeClass("e-resize").addClass("e-icon-hide");
                    nextBar.attr("aria-expanded", false);
                }
                properties[this.containerCss] = prevPaneSize + nextPaneSize;
                prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                properties[this.containerCss] = 0;
                nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                    proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                });
            }
            else {
                if (nextPaneSize < this.oldPaneSize[prevPaneIndex]) {
                    $target.addClass("e-end-indicaton");
                    this._inMovement = false;
                    $(document).on("mouseup", $.proxy(this._mouseUpOnArrow, this));
                    return false;
                }
                else {
                    prevPane.removeClass("collapsed");
                    nextPane.removeClass("expanded");
                    this.currentSplitBar.attr("aria-expanded", true);
                    $target.parent().addClass("e-resize").removeClass("e-icon-hide");
                      $($target.siblings()).not('.e-activebar').css("display", "block");
                    if (!this.model.properties[nextPaneIndex].collapsible)
                        $target.css("display", "none");
                    if (prevPaneIndex != 0) {
                        var preBar = prevPane.prev();
                        if (!this.model.properties[currBarNo - 1].collapsible)
                            preBar.find(".e-collapse").css("display", "none");
                        preBar.find(".e-expand").css("display", "block");
                        if (!preBar.prev().hasClass("collapsed")) preBar.addClass("e-resize").removeClass("e-icon-hide");
                    }

                    properties[this.containerCss] = this.oldPaneSize[prevPaneIndex];
                    prevPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0);
                    properties[this.containerCss] = nextPaneSize - this.oldPaneSize[prevPaneIndex];
                    nextPane.animate(properties, this.model.enableAnimation ? this.model.animationSpeed : 0, function () {
                        proxy._raiseEvent("expandCollapse", collapsed, expanded, currBarNo);
                    });
                }
            }
        },

        _raiseEvent: function (evtName, collapsed, expanded, index) {
            if (evtName == "expandCollapse") {
                this._inMovement = false;
                this._updateModelValue(collapsed, expanded);
            }
            return this._trigger(evtName, {
                collapsed: collapsed,
                expanded: expanded,
                splitbarIndex: index
            });

        },

        _updateModelValue: function (collapsed, expanded) {
            this.model.properties[collapsed.index].paneSize = collapsed.item[this.containerCss]();
            this.model.properties[expanded.index].paneSize = expanded.item[this.containerCss]();
            this._getPanesPercent();
        },

        _mouseUpOnArrow: function (event) {
            this.element.find(".e-end-indicaton").removeClass("e-end-indicaton");
            $(document).off("mouseup", $.proxy(this._mouseUpOnArrow, this));
        },

        _keydownOnDivider: function (e) {
            var key = e.keyCode;
            if (key == 37 || key == 38 || key == 39 || key == 40) {
                e.preventDefault();
                var oriTarget = $(e.data.target);
                if (e.ctrlKey) {
                    if (this.shadowBar == null) {
                        this.currentSplitBar = oriTarget;
                        var index = this._getSplitbarIndex();
                        if (this.model.orientation == "vertical") {
                            if (e.keyCode == 38) this.collapse(index);
                            else if (e.keyCode == 40) this.expand(index);
                        }
                        else {
                            if (e.keyCode == 37) this.collapse(index);
                            else if (e.keyCode == 39) this.expand(index);
                        }
                    }
                }
                else if (oriTarget.hasClass("e-resize")) {
                    var target = (this.shadowBar != null) ? this.shadowBar : oriTarget;
                    var offset = target.offset(), location = { pageX: offset.left, pageY: offset.top };
                    $.extend(true, e, location);
                    if ((this.model.orientation == "vertical" && (e.keyCode == 38 || e.keyCode == 40)) ||
                        (this.model.orientation == "horizontal" && (e.keyCode == 37 || e.keyCode == 39))) {
                        if (e.keyCode == 38) e.pageY -= 5;
                        else if (e.keyCode == 40) e.pageY += 5;
                        else if (e.keyCode == 37) e.pageX -= 5;
                        else if (e.keyCode == 39) e.pageX += 5;
                        this._mouseMoveOnDivider(e);
                    }
                }
            }
            else if (key == 13) {
                e.preventDefault();
                this._mouseUpOnDivider();
            }
            else if (key == 27) {
                e.preventDefault();
                if (this.shadowBar != null) this.shadowBar.remove();
                this.shadowBar = null;
                this._mouseUpOnDivider();
                this.element.children(".e-splitbar.e-hover").focusout();
            }
        },

        _focusOnDivider: function (e) {
            if (e.type == "focus") {
                if (!$(e.target).hasClass("e-hover")) {
                    $(e.target).addClass("e-hover");
                    if (this.model.allowKeyboardNavigation)
                        $(document).on("keydown", { target: e.target }, $.proxy(this._keydownOnDivider, this));
                }
            }
            else {
                this.element.children(".e-splitbar.e-hover").removeClass("e-hover");
                this._mouseUpOnDivider();
                $(document).off("keydown", $.proxy(this._keydownOnDivider, this));
            }
        },

        _mouseDownOnDivider: function (event) {
            event.preventDefault();
            var $target;
            ($(event.target).hasClass("e-activebar")) ? $target=$(event.target.parentElement) : $target=$(event.target);
            if ($target.hasClass("e-splitbar") && $target.hasClass("e-resize")) {
                this._overlayElement = ej.buildTag('div.e-pane-overlay');
                if (!$target.hasClass("e-hover")) $target.focus();
                this.element.find(".e-pane").not(".e-splitter").append(this._overlayElement);
                $(document).on(ej.eventType.mouseMove, { target: ($(event.target).hasClass("e-activebar")) ? event.target.parentElement : event.target }, $.proxy(this._mouseMoveOnDivider, this));
                $(document).on(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
                $(document).on("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            }
            else if ($target.hasClass("e-expand") || $target.hasClass("e-collapse")) {
                $target.parent().focus();
            }
        },

        _mouseMoveOnDivider: function (event) {
            var _data = event.data;
            event = event.type == "touchmove" ? event.originalEvent.changedTouches[0] : event;
            var position = { x: event.pageX, y: event.pageY };
            this.resizedPosition = this._getNormalValue(position);
            if (this.shadowBar == null) {
                var target;
                ($(_data.target).hasClass('e-activebar')) ? target=$(_data.target.parentElement) : target=$(_data.target);
                this.shadowBar = target.clone().addClass("e-shadowbar").removeClass("e-hover").removeClass("e-split-divider").insertBefore(target);
                this.shadowBar.children().remove();
            }
            this._maxminDraggableRange(this.resizedPosition);
            this.shadowBar.css(this.displayCss, this.resizedPosition);
        },

        _mouseUpOnDivider: function (event) {
            this._paneResize();
            this.element.find(".e-pane").not(".e-splitter").find(".e-pane-overlay").remove();
            $(document).off(ej.eventType.mouseMove, $.proxy(this._mouseMoveOnDivider, this));
            $(document).off(ej.eventType.mouseUp, $.proxy(this._mouseUpOnDivider, this));
            $(document).off("mouseleave", $.proxy(this._mouseUpOnDivider, this));
            // sets shadowBar null after removing shadowBar element
            this.shadowBar = null;
        },

        _windowResized: function (event) {
            var size = this._getExactInnerWidth();
            if (this._prevSize == size) return false;
            var paneCount = this.panes.length, outerSize = size - ((paneCount - 1) * this._bar), i, val;
            this._prevSize = size;
            for (i = 0; i < paneCount; i++) {
                val = this._convertToPixel(outerSize, this._sizePercent[i]);
                $(this.panes[i]).css(this.containerCss, val + "px");
            }
            for (i = 0; i < this.oldPaneSize.length; i++)
                this.oldPaneSize[i] = this._convertToPixel(outerSize, this.oldPanePercent[i]);
            this._checkPaneSize();
        },

        _convertToPercent: function (outer, pane) {
            return (pane * 100) / outer;
        },
        _convertToPixel: function (tot, percent) {
            return parseFloat((tot * percent) / 100);
        },

        _wireEvents: function (boolean) {
            if (boolean) $(window).on('resize', $.proxy(this._windowResized, this));
        },

        _unWireEvents: function () {
            $(window).off('resize', $.proxy(this._windowResized, this));
        }
    });

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejButton", "ej.Button", {

        element: null,

        model: null,
        validTags: ["button", "input"],
        _setFirst: false,

        _rootCSS: "e-button",
        _requiresID: true,

        defaults: {

            size: "normal",

            type: "submit",

            height: "",

            width: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            showRoundedCorner: false,

            cssClass: "",

            prefixIcon: null,

            suffixIcon: null,

            enableRTL: false,

            repeatButton: false,

            timeInterval: "150",

            create: null,

            click: null,

            destroy: null
        },


        dataTypes: {
            size: "enum",
            enabled: "boolean",
            type: "enum",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            repeatButton: "boolean",
            enableRTL: "boolean",
            timeInterval: "string",
            htmlAttributes: "data"
        },

        disable: function () {
            this.element.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            this.element.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._render();
            this._controlStatus(this.model.enabled);
            this._wireEvents(this.model.repeatButton);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else proxy.element.attr(key, value);
                if (key == "disabled" && value == "disabled") proxy.disable();
            });
        },

        _destroy: function () {
            this._off(this.element, "blur", this._btnBlur);
            this.element.removeClass(this.model.cssClass + "e-ntouch e-btn e-txt e-select e-disable e-corner e-widget").removeAttr("role aria-describedby aria-disabled");
            !this._cloneElement.attr("type") && this.element.attr("type") && this.element.removeAttr("type");			
            this.element.removeClass("e-btn-" + this.model.size);
            this.model.contentType && this.model.contentType != "textonly" ? this.element.append(this._cloneElement.text()) && this.imgtxtwrap[0].remove() : "";
            
        },


        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        if (!this.element.is("input"))
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        if (!this.element.is("input"))
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "timeInterval":
                        this.model.timeInterval = options[option];
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },


        _setSize: function (val) {
            this.element.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.element.addClass("e-btn-" + val);
        },
        _setType: function (val) {
            this.element.prop({ "type": val });
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function (val) {
            this.element.css('width', val);
        },

        _setText: function (val) {
            if (this.buttonType == "inputButton") {
                this.element.val(val);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.element.html(val);
                } else {
                    this.textspan.html(val);
                }
            }
            this.model.text = val;
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
            this.model.prefixIcon = val;
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
            this.model.suffixIcon = val;
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                if (!this.element.is("input"))
                this._renderButtonNormal();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.element.empty();
                this.model.imagePosition = val;
                if (!this.element.is("input"))
                this._renderButtonNormal();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.element.addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
        },

        _initialize: function () {
            if(!ej.isTouchDevice()) this.element.addClass("e-ntouch");
            if (this.element.is("input")) {
                this.buttonType = "inputButton";
            }
            else if ((this.element.is("a")) || (this.element.is("button"))) {
                this.buttonType = "tagButton";
            }
            else {
                this.element.removeClass("e-button");
            }
            if (this.element.attr("type")) {
                this.model.type = this.element.attr("type");
            }
            else
                this._setType(this.model.type);
            this._timeout = null;
        },


        _render: function () {
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this.element.addClass(this.model.cssClass + " e-btn e-select e-widget").attr("role", "button");
            if (this.buttonType == "inputButton") {
                this.element.addClass("e-txt");
                if ((this.model.text != null) && (this.model.text != "")) {
                    this.element.val(this.model.text);
                } else {
                    this.model.text = this.element.val();
                }
            } else { this._renderButtonNormal(); }
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.element[0].id)
                this.element.attr("aria-describedby", this.element[0].id);
        },

        _renderButtonNormal: function () {
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.html();
            }
            this.element.empty();
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            if (this.model.contentType.indexOf("image") > -1) {
                this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
                this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
                this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');
            }

            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
                this.element.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
                this.element.append(this.imgtxtwrap);
            } else {
                this.element.addClass("e-txt");
                this.element.html(this.model.text);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.element.addClass('e-corner') : this.element.removeClass('e-corner');
        },

        _wireEvents: function (val) {
            if (val) {
                this._on(this.element, "mousedown", this._btnRepatMouseClickEvent);
                this._on($(document), 'mouseup', this._mouseUpClick);
                this._on(this.element, "keyup", this._btnRepatKeyUpEvent);
                this._on($(document), "keypress", this._btnRepatKeyDownEvent);

            }
            this._on(this.element, "click", this._btnMouseClickEvent);
            this._on(this.element, "blur", this._btnBlur);
        },

        _btnBlur:function(e){
            this.element.removeClass("e-animate");
        },

        _btnMouseClickEvent: function (e) {
            var self = this;
            this.element.addClass("e-animate");
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                // here aregument 'e' used in serverside events 
                var args = { target: e.currentTarget, e : e , status:self.model.enabled};
                self._trigger("click", args);
            } 
        },

        _btnRepatMouseClickEvent: function (e) {
            var self = this;
            if(!self.model.enabled) return false;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.button == 0) || (e.which == 1)) {

                    self._timeout = setInterval(function () { self._trigger("click", { target: e.currentTarget, status: self.model.enabled }); }, this.model.timeInterval);
                }
            }
        },

        _mouseUpClick: function (event) {
            clearTimeout(this._timeout);
        },

        _btnRepatKeyDownEvent: function (e) {
            var self = this;
            if (!self.element.hasClass("e-disable")) {
                var args = { status: self.model.enabled };
                if ((e.keyCode == 32) || (e.keyCode == 13)) {
                    self._trigger("click", args);
                }
            }
        },

        _btnRepatKeyUpEvent: function (e) {
            if ((e.keyCode == 32) || (e.keyCode == 13)) {
                clearTimeout(this._timeout);
            }
        },
    });


    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft",
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
		ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
        Large: "large"
    };

    ej.ButtonType = {
		/**  Creates button with inbuilt button type specified */
		Button : "button",
		/**  Creates button with inbuilt reset type specified */
		Reset: "reset", 
		/**  Creates button with inbuilt submit type specified */
		Submit: "submit"
    };
})(jQuery, Syncfusion);
;

/**
* @fileOverview Plugin to style the Dialog control
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDialog", "ej.Dialog", {
        _rootCSS: "e-dialog",

        element: null,
        _ignoreOnPersist: ["drag", "dragStart", "dragStop", "resizeStop", "resizeStart", "resize", "beforeClose", "beforeOpen", "collapse", "expand", "close", "open", "destroy", "create", "ajaxSuccess", "ajaxError", "contentLoad", "actionButtonClick", "enableResize"],

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            showOnInit: true,

            closeOnEscape: true,

            //currently we have deprecated this API
            closeIconTooltip: "close",

            enableAnimation: true,

            allowDraggable: true,

            backgroundScroll: true,

            height: "auto",

            minHeight: 120,

            minWidth: 200,

            maxHeight: null,

            maxWidth: null,

            enableModal: false,

            position: { X: "", Y: "" },

            containment: null,

            enableResize: true,

            htmlAttributes: {},

            showHeader: true,

            showFooter: false,

            contentType: null,

            contentUrl: null,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            title: "",

            width: 400,

            zIndex: 1000,

            cssClass: "",

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            actionButtons: ["close"],

            animation:{
                show:{
                    effect:"fade",
                    duration:400
                },
                hide:{
                    effect:"fade",
                    duration:400
                }
            },            

            tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },

            footerTemplateId: null,
            
            locale:"en-US",
            
            faviconCSS: null,

            content: null,

            target: null,

            enablePersistence: false,

            enabled: true,

            isResponsive: false,

            actionButtonClick: null,

            beforeClose: null,

            close: null,            

            expand: null,

            collapse: null,

            beforeOpen: null,

            open: null,

            drag: null,

            dragStart: null,

            dragStop: null,

            resize: null,

            resizeStart: null,

            resizeStop: null,

            contentLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            create: null,

            destroy: null,

            /*Deprecated*/            
            Close:null
        },

        dataTypes: {
            showOnInit: "boolean",
            closeOnEscape: "boolean",
            enableAnimation: "boolean",
            backgroundScroll: "boolean",
            position: "data",
            animation:"data",
            closeIconTooltip: "string",
            tooltip: "data",
            allowDraggable: "boolean",
            enableModal: "boolean",
            enableResize: "boolean",
            isResponsive: "boolean",
            showHeader: "boolean",
            showFooter: "boolean",
            title: "string",
            faviconCSS:"string",
            zIndex: "number",
            cssClass: "string",
            enablePersistence: "boolean",
            contentUrl: "string",
            contentType: "string",
            enableRTL: "boolean",
            enabled: "boolean",
            allowKeyboardNavigation: "boolean",
            showRoundedCorner: "boolean",
            locale: "string",
            htmlAttributes: "data",
            ajaxSettings: "data",
            actionButtons: "array",
			footerTemplateId: "string"
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "closeIconTooltip": this._dialogClose.attr("title", options[key]); break;
                    case "tooltip": this._tooltipText(options[key]); break;
                    case "title":
                        this.model.title = options[key];
                        if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(options[key]);
                        this._updateCaptionWidth();
                        break;
                    case "width": this.model.width = options[key]; this._changeSize(); this._updateCaptionWidth(); options[key] = this.model.width; break;
                    case "height": this.model.height = options[key]; this._changeSize(); options[key] = this.model.height; break;
                    case "position": this.model.position = options[key]; this._dialogPosition(); break;
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this.model.showRoundedCorner=options[key]; this._roundedCorner(options[key]); break;
                    case "contentType": { this.model.contentType = options[key]; this._appendContent(options[key]); break; }
                    case "enabled": { this.model.enabled = options[key]; this._enabledAction(options[key]); break; }
                    case "contentUrl": { this.model.contentUrl = options[key]; this._appendContent(this.model.contentType); break; }
					case "backgroundScroll":
						this.model.backgroundScroll = options[key]; 
						if (!this.model.backgroundScroll && this.model.enableModal) $("body").addClass("e-dialog-modal");
						else $("body").removeClass("e-dialog-modal");
						break;
                    case "content":
                    case "target": 
                        this._ejDialog.appendTo($(options[key]));
                        this.model.target = this.model.content = options[key];
                        this._dialogPosition();
                        break;
                    case "containment":
                        this._setDragArea(options[key]);
                        !ej.isNullOrUndefined(this._target) ? this._ejDialog.appendTo(this._target) : this._ejDialog.appendTo(document.body);
                        this.model.position.X = this.model.position.Y = "";
                        this._dialogPosition();
                        this.model.containment = options[key] = this._target;
                        this.model.enableModal && this._createOverlay();
                        this._dialogTitlebar.ejDraggable({ dragArea: this._target });
                        break;
                    case "locale":
					    this.model.locale = options[key];
                        this.localizedLabels = this._getLocalizedLabels(); 
                        this._setLocaleCulture(this.localizedLabels, true);
                        this._tooltipText(this.model.tooltip);
						if (this._ejDialog.find("span.e-title").length <= 0) 
                            this._addTitleText();
                        else
                            this._ejDialog.find("span.e-title").html(this.model.title);
                        this._updateCaptionWidth();                       				
                        break;
                    case "minHeight": { this.model.minHeight = options[key]; this._ejDialog.css("minHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "minWidth": { this.model.minWidth = options[key]; this._ejDialog.css("minWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxHeight": { this.model.maxHeight = options[key]; this._ejDialog.css("maxHeight", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "maxWidth": { this.model.maxWidth = options[key]; this._ejDialog.css("maxWidth", options[key]); this._minMaxValidation(); this._resetScroller(); this._resizeDialog(); break; }
                    case "zIndex": { this._ejDialog.css('z-index', options[key]); break; }
                    case "faviconCSS":
                        this.model.faviconCSS = options[key]; this._favIcon();this._updateCaptionWidth(); break;
                    case "isResponsive": {
                        this.model.isResponsive = options[key];
                        this.model.isResponsive ? this._ejDialog.addClass("e-dialog-resize") : this._ejDialog.removeClass("e-dialog-resize");
                        this._wireResizing();
                        break;
                    }
                    case "allowDraggable": {
                        this.model.allowDraggable = options[key];
                        if (options[key])
                            this._enableDrag();
                        else {
                            this._dialogTitlebar.removeClass("e-draggable");
                        }
                        break;
                    }
                    case "enableResize": {
                        this.model.enableResize = options[key];
                        if (options[key])
                            this._enableResize();
                        else {
                            this._ejDialog.removeClass("e-resizable");
                            this._ejDialog.find(".e-resize-handle").remove();
                        }
                        this._reRenderScroller();
                        break;
                    }
                    case "showHeader": {
                        this.model.showHeader = options[key];
                        if (options[key]) {
                            this._renderTitleBar();
                            this._iconsRender(this.model.actionButtons);
                            if (this.model.faviconCSS) { this._dialogFavIcon = false; this._favIcon(); }
                            this._enableDrag();
                            if (!this._maximize) this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? (this._ejDialog.outerHeight(true) - (this._dialogTitlebar.outerHeight(true))) : this._ejDialog.outerHeight(true) - 1 - (this._dialogTitlebar.outerHeight(true)), (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        else {
                            this._ejDialog.find(".e-titlebar").remove();
                            this._maximize ? this.refresh() : this._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.outerHeight(true) : this._ejDialog.outerHeight(true) - 1, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2);
                        }
                        this._roundedCorner(this.model.showRoundedCorner);
                        if (this.model.showFooter) this._setContainerSize()._resetScroller();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[key];
                        if (options[key]) {
                            this._appendContent();
                            this._ejDialog.find(".e-resizable").remove();
                        }
                        else 
                            this._ejDialog.find(".e-footerbar").remove();
                        this._enableResize()._enableDrag()._sizeInPercent();
                        this._reRenderScroller();
                        this._setContainerSize()._resetScroller();
                        this._roundedCorner(this.model.showRoundedCorner);
                        break;
                    }
                    case "footerTemplateId": {
                        this.model.footerTemplateId = options[key];
                        if (this.model.showFooter) {
                            this._ejDialog.find(".e-footerbar").empty();
                            var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                            this._dialogFooterbar.append(templateContent);
                            this._enableResize();
                        }
                        break;
                    }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            if (this.model.faviconCSS) this._favIcon();
                            if (options[key]) {
                                this._ejDialog.addClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "rtl");
                                if (this.scroller) 
                                    this._resetScroller();
                            } else {
                                this._ejDialog.removeClass("e-rtl");
                                this.iframe && this.iframe.contents().find("body").css("direction", "ltr");
                                if (this.scroller) 
                                    this._resetScroller();
                            }
                            break;
                        }
                    case "actionButtons":
                        {
                            if (!ej.isNullOrUndefined(this._dialogTitlebar) ){
                                this._removeAllIcons();
                                this._iconsRender(options[key]);
                            }
                            this.model.actionButtons = options[key];
                            this._updateCaptionWidth();
                            break;
                        }
                    case "enableModal": {
                        this._enableModal(options[key]);
                        break;
                    }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                }
            }
        },


        _destroy: function () {
            if (this._overLay) this._overLay.remove();
            this._cloneElement.appendTo(this._ejDialog.parent());
            this._ejDialog.remove();
            this._cloneElement.removeClass("e-dialog");
            this.element = this._cloneElement;
            this._isOpen = false;
            $(window).off("resize", $.proxy(this._reSizeHandler, this));
        },

        keyConfigs: [37, 38, 39, 40],

        _init: function () {
			this._init=true;
            this._widthPercent = null;
            this._heightPercent = null;
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType = { width: isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g)[0] : null, height: isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g)[0] : null };
            this._isOpen = this._maximize = this._minimize = false;
            this.localizedLabels = this._getLocalizedLabels(); 
            this._setLocaleCulture(this.localizedLabels);
            this._setDimension();
            if (!this.model.close) this.model.close = this.model.Close;
            if (!this.model.target) this.model.target = this.model.content;
			this._responsive();
            this._renderControl();
            this._wireEvents();    
            this.scrObj= this._ejDialog.closest(".e-dialog.e-js").data("ejDialog")
            if(this.scrObj) this.scrObj._resetScroller(); 
			this.hidden=false;			
            this._init=false;
            this._keyNavigation=false;	
        },
		
		_responsive: function () {
            this.width = this.model.width;
            $(this.element).width(this.width);

            this.height = this.model.height;
            $(this.element).height(this.height);
            $(window).on("resize", $.proxy(this._resizeHandler, this));
        },
        
        _resizeHandler: function () {
            if (this._maximize) {
                this.width = $(this._dialogTitlebar).outerWidth();
                $(this.contentDiv).width(this.width);
                $(this.contentDiv).children().width(this.width);

                this.model.height = this.height = $(window).height();
                this._ejDialog.css({ height: this.height });
                this.contentDiv.height(this._ejDialog.height() - $(this._dialogTitlebar).outerHeight() - $(this._dialogFooterbar).outerHeight());
                this.element.height(this.contentDiv.height());
            }
			if(!ej.isNullOrUndefined(this.element)) this._resetScroller();
        },
       
        _setLocaleCulture:function(localizedLabels, isSetModel){
            //Deprecated closeIconTooltip locale
            if(this.defaults.closeIconTooltip===this.model.closeIconTooltip)
                this.model.closeIconTooltip=localizedLabels.closeIconTooltip;
			
                if (isSetModel) {	
                 	 this.model.tooltip= this.localizedLabels.tooltip ;
                     this.model.title= this.localizedLabels.title;			 
				} 
				if(JSON.stringify(this.model.tooltip) === JSON.stringify(this.defaults.tooltip))
                this.model.tooltip=localizedLabels.tooltip;  				
				if(this.model.title === this.defaults.title)
				this.model.title=localizedLabels.title;  
        },

        _setDragArea: function (value) {
            if (!ej.isNullOrUndefined(value))
            {
                if (typeof value == "string") {
                    if (value == "parent") this._target = $(this.element).parent();
                    if (value.toLowerCase() == "document") this._target = $(document);
                    if (value.toLowerCase() == "window") this._target = $(window);
                    else if ($(value).length > 0) this._target = $(value);
                } else if (typeof value == "object") {
                    if (value.length > 0) this._target = value;
                }
                else this._target = null;
            } else this._target = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy._ejDialog.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else{
					if(proxy._ejDialog[0].hasAttribute("style")){
					 var newValue = proxy._ejDialog[0].getAttribute("style") + value;
					 proxy._ejDialog.attr(key, newValue);
					}					
				} 
            });
        },
        _tooltipText: function(data){
            $.extend(this.model.tooltip, data);
            if(!ej.isNullOrUndefined(this._dialogClose) && this._dialogClose.hasClass('e-close'))
                this._dialogClose.attr("title", this.model.tooltip.close);
            if (!ej.isNullOrUndefined(this._dialogCollapsible) && (data.collapse || data.expand)) {
                if (this._dialogCollapsible.hasClass('e-arrowhead-up'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                if (this._dialogCollapsible.hasClass('e-arrowhead-down'))
                    this._dialogCollapsible.attr("title", this.model.tooltip.expand);
            }
            if (!ej.isNullOrUndefined(this._dialogMaximize) && (data.maximize || data.restore)) {
                if (this._dialogMaximize.hasClass('e-maximize'))
                    this._dialogMaximize.attr("title", this.model.tooltip.maximize);
                if (this._dialogMaximize.hasClass('e-restore'))
                    this._dialogMaximize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogMinimize) && (data.minimize || data.restore)) {
                if (this._dialogMinimize.hasClass('e-minus'))
                    this._dialogMinimize.attr("title", this.model.tooltip.minimize);
                if (this._dialogMinimize.hasClass('e-restore'))
                    this._dialogMinimize.attr("title", this.model.tooltip.restore);
            }
            if (!ej.isNullOrUndefined(this._dialogPin) && (data.pin || data.unPin)) {
                if (this._dialogPin.hasClass('e-unpin'))
                    this._dialogPin.attr("title", this.model.tooltip.pin);
                if (this._dialogPin.hasClass('e-pin'))
                    this._dialogPin.attr("title", this.model.tooltip.unPin);
            }
        },
        _renderControl: function () {
            this._cloneElement = this.element.clone();
            this.element.attr("tabindex", 0).attr({ "role": "dialog", "aria-labelledby": this.element.prop("id") + "_title" });
            this._ejDialog = ej.buildTag("div.e-dialog e-widget e-box " + this.model.cssClass + " e-dialog-wrap e-shadow#" + (this.element.prop("id") == "" ? "" : this.element.prop("id") + "_wrapper"), "", { display: "none", zIndex: this.model.zIndex }, { tabindex: 0 });
            if(this.model.isResponsive) this._ejDialog.addClass("e-dialog-resize");
            this.wrapper = this._ejDialog;
            this._addAttr(this.model.htmlAttributes);
            this._setDragArea(this.model.containment);
            if(!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) var target = this._target;                
            else if(!ej.isNullOrUndefined(this.model.target)) var target = this.model.target;
            var wrapperTarget = !ej.isNullOrUndefined(target) ? target : document.body;
            var oldWrapper = $(wrapperTarget).find("#" + this._id + "_wrapper").get(0);
            if (oldWrapper) $(oldWrapper).remove();
            this._ejDialog.appendTo(wrapperTarget);
            if (this.model.enableRTL) this._ejDialog.addClass("e-rtl");
            if (this.model.showHeader) {
                this._renderTitleBar();
                this._iconsRender(this.model.actionButtons);
                if (this.model.faviconCSS) this._favIcon();
            }
            this._appendContent(this.model.contentType);
            this._enableResize()._enableDrag()._setSize();
			if(this.model.height != "auto") this._sizeInPercent();
            if (this.model.contentType != "ajax"){                                                                  
                if (this.model.showOnInit && this.open()) {
                    this._setContainerSize()._resetScroller();
                }
                else this._setHiddenDialogSize();
            }
            this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            if (this._sizeType.width == "auto") this._maxWidth = this.model.width;
            if (this._sizeType.height == "auto") this._maxHeight = this.model.height;
        },

        _setContainerSize: function () {
            if (this.model.height != "auto") {
                var cntHeight = this._ejDialog.outerHeight() - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)  + ((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0) - 1;
                this.contentDiv.height(cntHeight);
                this.element.outerHeight(cntHeight);
            }
            return this;
        },

        _changeSize: function () {
            this._initSize = { width: this.model.width, height: this.model.height };
            this._sizeType.width = isNaN(this.model.width) ? this.model.width.match(/px|%|auto/g) : null;
            this._sizeType.height = isNaN(this.model.height) ? this.model.height.match(/px|%|auto/g) : null;
            this._setSize()._sizeInPercent()._setContainerSize()._resetScroller();
        },

        _enableDrag: function () {
            if (this.model.allowDraggable && this.model.showHeader) {
                this._dialogTitlebar.addClass("e-draggable");
                this._dragDialog();
            }
            return this;
        },

        _enableResize: function () {
            if (this.model.enableResize) {
                this._ejDialog.addClass("e-resizable");
                var resizeDiv = ej.buildTag("div.e-icon e-resize-handle");
                if (this.model.showFooter) 
                    resizeDiv.appendTo(this._dialogFooterbar);
                else
                    resizeDiv.appendTo(this._ejDialog);
                this._resizeDialog();
            }
            return this;
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this._ejDialog.removeClass(this.model.cssClass).addClass(skin);
            }
        },
        _enableModal: function (value) {
            if (value) this._isOpen && this._createOverlay();
            else if (this._overLay) this._overLay.remove();
        },

        _enabledAction: function (flag) {
            if (flag) {
                this._ejDialog.removeClass("e-disable");
                this.wrapper.children(".e-disable-overlay").remove();
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.enable();
            }
            else {
                this._ejDialog.addClass("e-disable");
                ej.buildTag("div.e-disable-overlay").appendTo(this.wrapper);
                if (!ej.isNullOrUndefined(this.scroller))
                    this.scroller.disable();
            }
        },

        _renderTitleBar: function () {
            this._elementTitle = this.element.attr("title");
            if (typeof this._elementTitle !== "string")
                this._elementTitle = "";
            this.model.title = this.model.title || this._elementTitle;
            this._dialogTitlebar = ej.buildTag("div#" + this.element.prop("id") + "_title.e-titlebar e-header e-dialog").prependTo(this._ejDialog);
            this._addTitleText();
        },

        _renderFooterBar: function () {
            this._dialogFooterbar = ej.buildTag("div#" + this.element.prop("id") + "_foot.e-footerbar e-dialog e-js").appendTo(this._ejDialog);
        },

        _addTitleText: function () {
            if (this.model.title) 
                this._titleText = ej.buildTag("span.e-title", this.model.title).prependTo(this._dialogTitlebar);
            return this;
        },
        _updateCaptionWidth: function () {
            var addWidth=this.model.faviconCSS && !ej.isNullOrUndefined(this._dialogFavIcon)?this._dialogFavIcon.outerWidth():0;
			if(this._titleText && !ej.isNullOrUndefined(this._dialogTitlebar))
			    this._titleText.css("max-width", (this._dialogTitlebar.width() - 20 - (this._dialogTitlebar.find(".e-dialog-icon").width() * this._dialogTitlebar.find(".e-dialog-icon").length) - addWidth));
			return this;
        },
        _iconsRender: function (iconArray) {
            for (var icon = 0; icon < iconArray.length; icon++) {
                switch ((ej.browserInfo().name == "msie" && ej.browserInfo().version <= 8) ? $.trim(iconArray[icon]) : iconArray[icon].trim()) {
                    case "close": {
                        this._closeIcon();
                        break;
                    }
                    case "collapse":
                    case "collapsible": {
                        this._collapsibleIcon();
                        break;
                    }
                    case "maximize": {
                        this._maximizeIcon();
                        break;
                    }
                    case "minimize": {
                        this._minimizeIcon();
                        break;
                    }
                    case "pin": {
                        this._pinIcon();
                        break;
                    }
                    default: {
                        this._customIconsRender(iconArray[icon]);
                        break;
                    }
                }
            }
        },

        _customIconsRender: function (icon) {
            this._customIcon = ej.util.buildTag("div#" + this.element[0].id + "_" + icon + "button.e-dialog-icon e-icon e-" + icon, null, null).attr('tabIndex', '0').attr('title', icon);
            this._customIcon.appendTo(this._dialogTitlebar);
            this._on(this._customIcon, "touchstart click", this._iconClick);
        },

        _iconClick: function () {
            
            if (!this.element.hasClass("e-disable")) {
                var args = {
                    cancel: false,
                    buttonID: $(event.target).attr("id"),
                    event: event.type,
                    model: this.model,
                    currentTarget: event.currentTarget.title
                }
                this._trigger("actionButtonClick", args);
            }
        },

        _removeAllIcons: function () {
            this._dialogTitlebar.find("div.e-dialog-icon").remove();
        },

        _appendContent: function (contentType) {
            this.contentDiv = ej.isNullOrUndefined(this.contentDiv) ? ej.buildTag("div.e-dialog-scroller") : this.contentDiv;
            this.element.removeAttr("title").addClass("e-widget-content e-box");
            var proxy = this;
            if (!ej.isNullOrUndefined(this.model.contentUrl) && !ej.isNullOrUndefined(contentType)) {
                if (contentType == "ajax") {
                    this.model.ajaxSettings.url = this.model.contentUrl;
                    this._sendAjaxOptions(this.element, this.model.ajaxSettings.url);
                }
                else if (contentType == "iframe") {
                    if (this.element.children('.e-iframe').length > 0) {
                        this.iframe = this.element.find('iframe.e-iframe');
                        this.iframe.attr('src', this.model.contentUrl);
                    }
                    else {
                        this.iframe = ej.buildTag("iframe.e-iframe", "", { width: "100%", height:"100%" }, { scrolling: "auto", frameborder: 0, src: this.model.contentUrl });
                        this.element.appendTo(this.contentDiv).append(this.iframe).show();
                    }
                    if (this.model.enableRTL) {
                        $(this.iframe).load(function () {
                            proxy.iframe.contents().find("body").css("direction", "rtl");
                        });
                    }
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else if (contentType == "image") {
                    var img = ej.buildTag("img.e-images", "", "", { src: this.model.contentUrl });
                    this.element.append(img).show().appendTo(this.contentDiv);
                    $(img).on("load", function () {
                        proxy._dialogPosition();
                    });
                    this._trigger("contentLoad", { contentType: contentType, url: this.model.contentUrl });
                }
                else
                    this.element.show().appendTo(this.contentDiv);
            }
            else {
				this.dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(this.dialogIframeContent)) {
				   this.element.show().appendTo(this.contentDiv).find('iframe').append(this.dialogIframeContent.lastChild);
				}
				else
					this.element.show().appendTo(this.contentDiv);
			}
            if (this._ejDialog.find("div.e-resize-handle").length > 0) {
                if (this._ejDialog.find(".e-footerbar").length == 0)
				this.contentDiv.insertBefore(this._ejDialog.find("div.e-resize-handle"));
			}
			else {
				var dialogIframeContent = this.element.children().find('iframe').contents()[0];
				if (!ej.isNullOrUndefined(dialogIframeContent)) {
                    this.contentDiv.appendTo(this._ejDialog);
					var getid = $("#"+this.contentDiv.find('iframe').attr('id'));
					$(getid[0].contentDocument.lastChild).remove();
				    getid[0].contentDocument.appendChild(dialogIframeContent);
					if(ej.browserInfo().name == "mozilla")
					setTimeout(function () {
						$(getid[0].contentDocument.lastChild).remove();
				        getid[0].contentDocument.appendChild(dialogIframeContent);
                    },500);
				}
				else {
					if(this._ejDialog.find(".e-footerbar").length == 0)
					this.contentDiv.appendTo(this._ejDialog);
				    else
                    this.contentDiv.insertBefore(this._dialogFooterbar);
				     }
				}
            if (this.model.showFooter && this._ejDialog.find(".e-footerbar").length == 0) {
                this._renderFooterBar();
                if (this.model.footerTemplateId != null) {
                    var templateContent = $('body').find("#" + this.model.footerTemplateId).html();
                    this._dialogFooterbar.append(templateContent);
                }
            }
        },

        _roundedCorner: function (value) {
            this._ejDialog[(value ? "addClass" : "removeClass")]('e-corner');
            this.contentDiv.removeClass('e-dialog-top e-dialog-bottom e-dialog-content');
            if (this.model.showRoundedCorner) {
                this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-bottom') : !this.model.showHeader && this.model.showFooter ? this.contentDiv.addClass('e-dialog-top') : !this.model.showHeader && !this.model.showFooter ? this.contentDiv.addClass('e-dialog-content') : true;
            }
        },

        _reRenderScroller: function () {
            if (this.scroller != undefined) {
                    this.scroller.refresh(true);
                if (!this.model.enableRTL) {
                    if ((this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var height = this.scroller._vScrollbar.element.find('> div.e-vscroll').height(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerHeight();
	                    if (Math.floor(this.contentDiv.outerHeight()) === Math.floor(this.scroller._vScrollbar.model.height + 1)) {
                            this.scroller._vScrollbar.model.height -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._scrollData.handle -= resizeHandleSize;
                            this.scroller._vScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                            this.scroller._vScrollbar._updateLayout(this.scroller._vScrollbar._scrollData);
                            this.scroller._vScrollbar.element.find('> div.e-vscroll').height(height - resizeHandleSize - padngSpace);
                        }
                    }
                    if (!(this.scroller._vScrollbar && this.scroller._vScrollbar._scrollData) && (this.scroller._hScrollbar && this.scroller._hScrollbar._scrollData) && this.model.enableResize) {
                        if (this.model.showFooter) 
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 0, resizeHandleSize = 0;
                        else
                            var width = this.scroller._hScrollbar.element.find('> div.e-hscroll').width(), padngSpace = 2, resizeHandleSize = this._ejDialog.find('div.e-resize-handle').outerWidth();
                        this.scroller._hScrollbar.model.width -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handle -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._scrollData.handleSpace -= resizeHandleSize + padngSpace;
                        this.scroller._hScrollbar._updateLayout(this.scroller._hScrollbar._scrollData);
                        this.scroller._hScrollbar.element.find('> div.e-hscroll').width(width - resizeHandleSize - padngSpace);
                    }
                }
            }
        },       

        _dialogMaxZindex: function () {
            var parents = this.element.parents(), bodyEle, contEle,index,cindex;
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            contEle = $(this.model.target).children(), cindex = contEle.index(this.popup);
            contEle.splice(cindex, 1);
            $(contEle).each(function (i, ele) { parents.push(ele); });
            var maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;
        },

        _setZindex: function () {
            var zindex = this._dialogMaxZindex();
            if (this.model.zIndex <= zindex)
                this._ejDialog.css({ zIndex: zindex + 1 });
        },

        _createOverlay: function () {
            var zindex = this._ejDialog.css('zIndex'), target, element, position;
            !ej.isNullOrUndefined(this._overLay) && this._overLay.remove();
            if (!this.model.backgroundScroll) $("body").addClass("e-dialog-modal");
            this._overLay = ej.buildTag("div#" + this.element.attr("id") + "_overLay.e-overlay", "", { zIndex: zindex - 1 });
            if (!ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target)) target = this._target;
            else if (!ej.isNullOrUndefined(this.model.target)) target = this.model.target;
            this._overLay.appendTo(!ej.isNullOrUndefined(target) ? target : document.body);
            var position = !ej.isNullOrUndefined(this.model.containment) && !ej.isNullOrUndefined(this._target) ? "absolute" : "fixed";
            var left =(ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().left;
            var top = (ej.isNullOrUndefined(target) || position=="fixed") ? 0 : $(target).css('position').toLowerCase() != "static" ? 0 : $(target).offset().top;
            this._overLay.css({ top: top, left: left, position: position });
        },

        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            content.addClass("e-load");
            var proxy = this;
            var curTitle = this.model.title;
            var hrefLink = link;
            var ajaxOptions = {
                "success": function (data) {
                    try { proxy._ajaxSuccessHandler(data, content, link, curTitle); }
                    catch (e) { }
                },
                "error": function (e) {
                    try { proxy._ajaxErrorHandler({ "status": e.status, "responseText": e.responseText, "statusText": e.statusText }, content, link, curTitle); }
                    catch (e) { }
                },
                "complete": function () {
                    try {
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        if (!proxy.model.showOnInit) proxy._setHiddenDialogSize();
                    } catch (e) {}
                }
            };
            $.extend(true, ajaxOptions, this.model.ajaxSettings);
            this._sendAjaxRequest(ajaxOptions);
        },

        _setHiddenDialogSize: function () {
            if (!this._isOpen) {
                this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                this._setContainerSize()._resetScroller();
                this._ejDialog.css({ "display": "none", "visibility": "" });
            }
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },

        _ajaxSuccessHandler: function (data, content, link, curTitle) {
            content.removeClass("e-load");
            content.html(data).addClass("e-dialog-loaded").appendTo(this._ejDialog);
            content.appendTo(this.contentDiv);
            this._dialogPosition();
            if (this.model.showOnInit)
                this.open();
            this._trigger("ajaxSuccess", { data: data, url: link });
        },

        _ajaxErrorHandler: function (data, content, link, curTitle) {
            content.addClass("e-dialog-loaded").appendTo(this.contentDiv);
            this._dialogPosition().open();
            this._trigger("ajaxError", { data: data, url: link });
        },
        _closeIcon: function () {
            this._dialogClose = ej.util.buildTag("div#" + this.element[0].id + "_closebutton.e-dialog-icon e-icon e-close",null,null).attr('tabIndex','0');            
            if(this.model.closeIconTooltip == "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else if(this.model.closeIconTooltip != "close" && this.model.tooltip.close == "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.closeIconTooltip);
            else if(this.model.closeIconTooltip == "close" && this.model.tooltip.close != "Close")
                this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            else   this._dialogClose.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.close);
            this._on(this._dialogClose, "touchstart click", this._closeClick);
        },
		
        _collapsibleIcon: function () {            
            this._dialogCollapsible = ej.util.buildTag("div#" + this.element[0].id + "_collapsbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');             
            if (this._collapsible) {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.expand).addClass("e-arrowhead-down").removeClass("e-arrowhead-up");
            }
            else {
                this._dialogCollapsible.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.collapse).addClass("e-arrowhead-up").removeClass("e-arrowhead-down");
            }
            this._on(this._dialogCollapsible, "touchstart click", this._collapsibleClick);
        },

        _maximizeIcon: function () {
            this._dialogMaximize = ej.util.buildTag("div#" + this.element[0].id + "_maximizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            if (this._maximize) {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-maximize");
            }
            else {
                this._dialogMaximize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.maximize).addClass("e-maximize").removeClass("e-restore");
            }
            this._on(this._dialogMaximize, "touchstart click", this._maximizeClick);
        },

        _minimizeIcon: function () {
            this._dialogMinimize = ej.util.buildTag("div#" + this.element[0].id + "_minimizebutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0');           
            if (this._minimize) {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.restore).addClass("e-restore").removeClass("e-minus");
            }
            else {
                this._dialogMinimize.appendTo(this._dialogTitlebar).attr("title", this.model.tooltip.minimize).addClass("e-minus").removeClass("e-restore");
            }
            this._on(this._dialogMinimize, "touchstart click", this._minimizeClick);
        },

        _pinIcon: function () {
            this._dialogPin = ej.util.buildTag("div#" + this.element[0].id + "_pinbutton.e-dialog-icon e-icon",null,null).attr('tabIndex','0'); 
            this._dialogPin.appendTo(this._dialogTitlebar).attr("title", this.dialogPin ? this.model.tooltip.unPin : this.model.tooltip.pin).addClass(this.dialogPin ? "e-pin" : "e-unpin").removeClass(this.dialogPin ? "e-unpin" : "e-pin");
            this._on(this._dialogPin, "touchstart click", this._pinClick);
        },

        _favIcon: function () {
            if (!this._dialogFavIcon) {
                this._dialogFavIcon = ej.util.buildTag("div.e-dialog-favicon", "", {}, { style: "float:"+ (this.model.enableRTL?"right":"left") });
                var span = ej.util.buildTag("span.e-dialog-custom", "", {}, { role: "presentation" });
                span.appendTo(this._dialogFavIcon);
                this._dialogFavIcon.appendTo(this._dialogTitlebar);
            }
            else 
                span = this._dialogFavIcon.find("span").removeClass().addClass("e-dialog-custom");
            if (!this.model.faviconCSS) this._dialogFavIcon.remove();
            else span.addClass(this.model.faviconCSS); this._dialogFavIcon.css("float", (this.model.enableRTL ? "right" : "left"));
        },

        _minMaxValidation: function () {
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight), _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight),_width = parseInt(this.model.width), _height = parseInt(this.model.height), parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
			if (isNaN(this.model.width) && (this.model.width.indexOf("%") > 0))
                _width = this._convertPercentageToPixel(parentObj.innerWidth(), _width);
            if (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0))
                _height = this._convertPercentageToPixel(parentObj.innerHeight(), _height);
            if (_maxWidth && _width > _maxWidth || _minWidth && _width < _minWidth) {
                if (_width > _maxWidth) this.model.width = _maxWidth;
                else this.model.width = _minWidth;
            }
            if (_maxHeight && _height >_maxHeight || _minHeight && _height< _minHeight) {
                if (_height > _maxHeight) this.model.height = _maxHeight;
                else this.model.height = _minHeight;
            }
        },

        _setSize: function () {
            var mdl = this.model;
            this._minMaxValidation();
            this._ejDialog.css({ width: mdl.width, minWidth: mdl.minWidth, maxWidth: mdl.maxWidth });
            this._ejDialog.css({ height: mdl.height, minHeight: mdl.minHeight, maxHeight: mdl.maxHeight });
            this._dialogPosition();
            return this;
        },

        _resetScroller: function () {		
			this.element.css({ "height": "auto", "max-width": "", "max-height": "", "width": "" });
            var scrHeight = this._ejDialog.outerHeight(true) - ((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)-((this.model.showFooter)? $(this._ejDialog.find("div.e-footerbar")).outerHeight(true) : 0), eleHeight;
            var scrModel = { width: (this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? Math.round(this._ejDialog.width()) : Math.round(this._ejDialog.width() - 2), enableRTL: this.model.enableRTL, height: (this.contentDiv.css('border-width') == "0px") ? scrHeight : scrHeight - 1, enableTouchScroll: false }; // 2px border width
            if ((this.model.height == "auto") && (this.element.height() < this.model.maxHeight || !this.model.maxHeight) && !this._maximize)
                scrModel.height = "auto";
            if (this.model.width == "auto" && !this._maximize)
                scrModel.width = this.model.width;
            this.contentDiv.ejScroller(scrModel);
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            this._padding = parseInt($(this.element).css("padding-top")) + parseInt($(this.element).css("padding-bottom"));
            if(($(this._ejDialog).css("display"))=="none"){
				  this.hidden=true;         
                  this._ejDialog.css({"display":"block"}); 
			}		
			if (!ej.isNullOrUndefined(this.contentDiv.height()) && this.contentDiv.height() > 0) {
                if (!ej.isNullOrUndefined(this.scroller))
                    if (!this.scroller._hScrollbar && this.scroller._vScrollbar)
                        eleHeight = this.contentDiv.outerHeight();
                    else if (this.scroller._hScrollbar)
                         eleHeight = this.contentDiv.outerHeight() - this.scroller.model.buttonSize;
                     else  eleHeight = this.contentDiv.outerHeight();
                 else
                    eleHeight = this.contentDiv.outerHeight() - this._padding;
                if ((this.model.height != "auto" && this.model.height != "100%"))
                    this.element.css({ "height": eleHeight-1 });
                else
                    this.element.css("height", this.model.height);
                if ((this.model.height == "auto" || this.model.height == "100%") && !this.scroller._vScrollbar)
                    this.element.css({ "min-height": this.model.minHeight -((this.model.showHeader)? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0)});
                if (!this.scroller._vScrollbar && (this.model.width != "auto" && this.model.width != "100%"))
                    this.element.outerWidth((this.contentDiv.css('border-width') == "0px" || this.contentDiv.css('border-left-width') == "0px") ? this._ejDialog.width() : this._ejDialog.width() - 2);
                else if (!this.scroller._vScrollbar)
                    this.element.css("width", this.model.width);
                this.element.css({"max-width": this.model.maxWidth, "max-height": this.model.maxHeight });
            }
			if(this.hidden) this._ejDialog.css({"display":"none"});					
			this.hidden=false;
        },

        _updateScroller: function (height, width) {
            this.contentDiv.ejScroller({ width: width, height: height, enableRTL: this.model.enableRTL, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
			this._changeSize();
        },

        _dragDialog: function () {
            var proxy = this;
            var pos = this._ejDialog.parents(".e-dialog-scroller");
            this._dialogTitlebar.ejDraggable({
                handle: ".e-titlebar",
                cursorAt: { top: 0, left: 0 },
                dragArea: proxy._target,
                dragStart: function (event) {
					event.element.attr('aria-grabbed', true);
                    proxy._clickHandler();
                    if (proxy.dialogPin || !proxy.model.allowDraggable || !proxy.model.enabled) {
                        event.cancel = true;
                        return false;
                    }
                    if (proxy._trigger("dragStart", { event: event })) {
                        event.cancel = true;
                        return false;
                    }
                },
                drag: function (event) {
                    proxy._trigger("drag", { event: event });
                },
                dragStop: function (event) {
                    proxy._ejDialog.focus();
					event.element.attr('aria-grabbed', false);
                    if (proxy.element.find("> .e-draggable.e-titlebar")) {
                       var dragobject = $("#" + proxy.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                        if (dragobject)
                            dragobject.option("cursorAt", proxy.element.offset());
                    }
                    var pos = this.helper.offsetParent().offset();
                    proxy._trigger("dragStop", { event: event });
                    proxy.model.position.X = ej.isNullOrUndefined(this.position.left) ? parseInt(this.helper.css('left')) : this.position.left - [pos.left + parseFloat(this.helper.offsetParent().css('border-left-width'))];
                    proxy.model.position.Y = ej.isNullOrUndefined(this.position.top) ? parseInt(this.helper.css('top')) : this.position.top - [pos.top + parseFloat(this.helper.offsetParent().css('border-top-width'))];
                    proxy._positionChanged = true;
                    proxy.dlgresized = true;
                },
                helper: function (event) {
                    return $(proxy._ejDialog).addClass("dragClone");
                }
            });
            return this;
        },

        _resizeDialog: function () {
            if (!this.model.enableResize)  return;
            var proxy = this, started = false, parentObj;
            var _minWidth = parseInt(this.model.minWidth), _minHeight = parseInt(this.model.minHeight);
            var _maxWidth = parseInt(this.model.maxWidth), _maxHeight = parseInt(this.model.maxHeight);
            parentObj = this._getParentObj();
            if (isNaN(this.model.minWidth) && (this.model.minWidth.indexOf("%") > 0))
                _minWidth = this._convertPercentageToPixel(parentObj.outerWidth(), _minWidth);
            if (isNaN(this.model.minHeight) && (this.model.minHeight.indexOf("%") > 0))
                _minHeight = this._convertPercentageToPixel(parentObj.outerHeight(), _minHeight);
            if (isNaN(this.model.maxWidth) && (this.model.maxWidth.indexOf("%") > 0))
                _maxWidth = this._convertPercentageToPixel(parentObj.innerWidth(), _maxWidth);
            if (isNaN(this.model.maxHeight) && (this.model.maxHeight.indexOf("%") > 0))
                _maxHeight = this._convertPercentageToPixel(parentObj.innerHeight(), _maxHeight);
            this._ejDialog.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: _minHeight,
                    minWidth: _minWidth,
                    maxHeight: _maxHeight,
                    maxWidth: _maxWidth,
                    handle: "e-widget-content",
                    resizeStart: function (event) {
                        proxy.dlgresized=true;
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("resizeStart", { event: event });
                        started = true;
                        proxy.model.position = { X: proxy._ejDialog.css("left"), Y: proxy._ejDialog.css("top") };
                        proxy._dialogPosition();
                    },
                    resize: function (event) {
                        proxy.dlgresized=true;
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        proxy._updateCaptionWidth();
                        proxy._trigger("resize", { event: event });
                        proxy._sizeType = { width: "px", height: "px" };
                        if(this.scrObj) this.scrObj._resetScroller();                      
                    },
                    resizeStop: function (event) {
                        proxy.dlgresized=true;
                        proxy._ejDialog.focus();
                        proxy._sizeInPercent();
                        var reElement = $(event.element).parents("div.e-dialog-wrap");
                        proxy.model.height = $(reElement).outerHeight();
                        proxy.model.width = $(reElement).outerWidth();
                        proxy._setSize();
                        proxy._setContainerSize();
                        proxy._resetScroller();
                        started && proxy._trigger("resizeStop", { event: event });
                        started = false;
                        proxy._setDimension();
                    },
                    helper: function (event) {
                        return $(proxy._ejDialog);
                    }
                });
            return this;
        },

        _dialogPosition: function () {
            if (this._ejDialog.parents("form").length > 0 && ej.isNullOrUndefined(this.model.containment) && ej.isNullOrUndefined(this.model.target)) {
                this._ejDialog.appendTo(this._ejDialog.parents("form"));
            }
            if (this.model.position.X != "" || this.model.position.Y != "") {
                this._ejDialog.css("position", "absolute");
                if(ej.isNullOrUndefined(this.model.target) && ej.isNullOrUndefined(this.model.containment)) {
                this._ejDialog.css("left", this.model.position.X);
                this._ejDialog.css("top", this.model.position.Y);
				}
				else {
					  var containerEle=ej.isNullOrUndefined(this.model.containment)?this.model.target:this.model.containment;
					  if (this.dlgresized || this._keyNavigation){
                         this._ejDialog.css("left", this.model.position.X);
                         this._ejDialog.css("top", this.model.position.Y);                   
                                    }
                      else{
                      this._ejDialog.css("left", $(containerEle).offset()["left"]+ parseInt(this.model.position.X));
					  this._ejDialog.css("top", $(containerEle).offset()["top"]+ parseInt(this.model.position.Y));
				}
            }
            }
            else {
                this._centerPosition();
            }
            return this;
        },
        _centerPosition:function(){
            var x = 0, y = 0;
            if (!ej.isNullOrUndefined(this.model.target) ||!ej.isNullOrUndefined(this._target) && !$(this._target).is($(document)) && !($(this._target).is($(window)))) {
                var $content = !ej.isNullOrUndefined(this._target) ? $(this._target) : $(this.model.target);
                if ($content.css("position") == 'static') {
                    var parentOffset = $content.offsetParent().offset();
                    var contentOffset = $content.offset();
                    x = contentOffset.left - parentOffset.left;
                    y = contentOffset.top - parentOffset.top;
                }
                if ($content.outerWidth() > this._ejDialog.width()) x += ($content.outerWidth() - this._ejDialog.width()) / 2;
                if ($content.outerHeight() > this._ejDialog.height()) y += ($content.outerHeight() - this._ejDialog.height()) / 2;
            }
            else {
                var doc = document.documentElement;
                x = (($(window).outerWidth() > this._ejDialog.width()) ? ($(window).outerWidth() - this._ejDialog.outerWidth()) / 2 : 0) + (window.pageXOffset || doc.scrollLeft);
                y = (($(window).outerHeight() > this._ejDialog.height()) ? ($(window).outerHeight() - this._ejDialog.outerHeight()) / 2 : 0) + (window.pageYOffset || doc.scrollTop);
            }
            this._ejDialog.css({ top: y, left: x });
            this._ejDialog.css("position", "absolute");
        },
        _closeClick: function (event) {
            if (this.model.enabled) {
                event.stopPropagation();
                this.close(event);
            }
        },

        _collapsibleClick: function (e) {
            if (this.model.enabled) {
                if ($(e.target).hasClass("e-arrowhead-up")) {
                    this._actionCollapse(e);
                }
                else if ($(e.target).hasClass("e-arrowhead-down")) {
                    this._actionExpand(e);
                }
            }
        },
        _actionCollapse: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-up").addClass("e-arrowhead-down");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.expand);
                this._ejDialog.find("div.e-resize-handle").hide();
                this._ejDialog.find(".e-widget-content").parent().slideUp("fast");
                if(this.model.showFooter)  this._dialogFooterbar.slideUp("fast");
                this._ejDialog.removeClass("e-shadow");
                this._ejDialog.css("minHeight", "0");
                this._ejDialog.height("auto");
                this._trigger("collapse",{isInteraction :(e ? true : false )});
                this._collapsible = true;
            }
        },
        _actionExpand: function (e) {
            if (!this._minimize) {
                this._dialogCollapsible&& this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible && this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                this._ejDialog.addClass("e-shadow");
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast");
                if (this.model.showFooter) this._dialogFooterbar.slideDown("fast");
                if (this._maximize) {
                    this._ejDialog.css({ width: "100%", height: "100%" });
                    this.element.css({ width: "100%", height: "100%" });
                    this.contentDiv.css({ width: "100%", height: "100%" });
                }
                else this._ejDialog.height(this.model.height);
                this._ejDialog.find("div.e-resize-handle").show();
                this._trigger("expand",{isInteraction :(e ? true : false )});
                this._collapsible = false;
            }
        },

        _maximizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMaximize;
                if (_target.hasClass("e-maximize")) {
                    this._actionMaximize();
                    if (this._dialogTitlebar){
                        this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-minus');
                        this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    }
                    _target.removeClass("e-maximize").addClass("e-restore");
                    this._dialogMaximize.attr('title', this.model.tooltip.restore);
                    this._hideIcon(true);
                }
                else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-maximize");
                    this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMaximize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
			this._resetScroller();
        },
        _actionMaximize: function () {
            this._ejDialog.css("top", "0px").css("left", "0px").css("overflow", "hidden").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css({ width: "100%", height: "100%" });
            this.element.css({ width: "100%", height: "100%" });
            this.contentDiv.css({ width: "100%", height: "100%" });
            this._maximize = true;
            this._minimize = false;
            var proxy=this;
            if (this._dialogCollapsible && !ej.isNullOrUndefined(this._dialogCollapsible.hasClass("e-arrowhead-down"))) {
                this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                this._dialogCollapsible.attr('title', this.model.tooltip.collapse);
                this._collapseValue = true
            }
            if(this._collapseValue == true) {
                this._ejDialog.find(".e-widget-content").parent().slideDown("fast",function(){
					proxy.refresh();
                    proxy._reRenderScroller();
                });
            }
            this._resetScroller();
        },
        _actionRestore: function () {
            this.element.height("").width("");
            this.contentDiv.height("").width("");
            this._restoreDialog();
            this._maximize = this._minimize = false;
        },

        _minimizeClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                var hideIcon = this._dialogMinimize.hasClass("e-icon")&& this._dialogMinimize;
                if (_target.hasClass("e-minus")) {
                    if (this._maximize)
                        this._setSize();
                    this._actionMinimize();
                } else if (_target.hasClass("e-restore")) {
                    this._actionRestore();
                    _target.removeClass("e-restore").addClass("e-minus");
                    this._dialogMinimize.attr('title', this.model.tooltip.minimize);
                    if (!ej.isNullOrUndefined(hideIcon) && $(hideIcon).hasClass('e-arrowhead-down')){
                        $(hideIcon).removeClass('e-arrowhead-down').addClass('e-arrowhead-up');
                        this._dialogMinimize.attr('title', this.model.tooltip.collapse);
                    }
                    this._hideIcon(true);
                }
            }
        },

        _actionMinimize: function () {
            var top = ($(window).height() - this._ejDialog.height()) + this.element.height() + 14, _height;
            this._ejDialog.css("top", "").css("bottom", "0").css("left", "0").css("position", (this.model.containment ? "absolute" : this.model.target ? "absolute" : "fixed"));
            this._ejDialog.css("minHeight", "0");
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find('.e-restore').removeClass('e-restore').addClass('e-maximize');
                this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
                this._dialogTitlebar.find(".e-minus").removeClass("e-minus").addClass("e-restore");
                this._dialogMinimize && this._dialogMinimize.attr('title', this.model.tooltip.restore);
                if (this._isOpen)
                    _height = this._dialogTitlebar.outerHeight();
                else {
                    this._ejDialog.css({ "display": "block", "visibility": "hidden" });
                    _height = this._dialogTitlebar.outerHeight();
                    this._ejDialog.css({ "display": "none", "visibility": "" });
                }
                this._ejDialog.css("height", _height + 2); // 1px bordertop + 1px borderbottom of the dialog wrapper is added
                this._hideIcon(false);
            } else this._ejDialog.css("height", "");
            this.contentDiv.hide();
			if(this.model.showFooter) this._dialogFooterbar.hide();
            this._maximize = false;
            this._minimize = true;
        },

        _hideIcon: function (value) {
            var hideIcon = this._dialogCollapsible ? this._dialogCollapsible : null;
            if (value) {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').show();
                this._ejDialog.find("div.e-resize-handle").show();
            } else {
                if (!ej.isNullOrUndefined(hideIcon)) $(hideIcon).parent('.e-dialog-icon').hide();
                this._ejDialog.find("div.e-resize-handle").hide();
            }
        },

        _pinClick: function (e) {
            if (this.model.enabled) {
                var _target = $(e.target);
                if (_target.hasClass("e-unpin")) {
                    this.dialogPin = true;
                    _target.removeClass("e-unpin").addClass("e-pin");
                    this._dialogPin.attr('title', this.model.tooltip.unPin);
                }
                else if (_target.hasClass("e-pin")) {
                    this.dialogPin = false;
                    _target.removeClass("e-pin").addClass("e-unpin");
                    this._dialogPin.attr('title', this.model.tooltip.pin);
                }
            }
        },

        _restoreDialog: function () {
            this.contentDiv.show();
			if(this.model.showFooter) this._dialogFooterbar.show();
            this._ejDialog.css({"position": "absolute", "bottom": ""}).addClass("e-shadow");
            this._setSize()._resetScroller();
            if (this._dialogTitlebar) {
                this._dialogTitlebar.find(".e-minus").parent().show();
                if (this._dialogCollapsible) {
                    this._dialogCollapsible.removeClass("e-arrowhead-down").addClass("e-arrowhead-up");
                    this._dialogCollapsible.attr("title", this.model.tooltip.collapse);
                }
            }
        },

        _clickHandler: function (e) {
            var zindex = this._dialogMaxZindex();
            if (parseInt(this._ejDialog.css("zIndex")) < zindex) 
                this._ejDialog.css({ zIndex: zindex + 1 });            
        },

        _mouseClick: function (e) {
			if(e.currentTarget==this._id)
				if ($(e.target).hasClass("e-dialog") || $(e.target).hasClass("e-icon e-resize-handle")) {
					this._setZindex();
					$(e.target).closest(".e-dialog.e-widget").focus();
				}
        },

        _keyDown: function (e) {
            if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
            else if (e.which) code = e.which; // ns4 and opera
            else code = e.charCode;
            if (this.model.allowKeyboardNavigation && this.model.enabled && $(e.target).hasClass("e-dialog"))
                if ($.inArray(code, this.keyConfigs) > -1 && this.model.allowDraggable && !this.dialogPin) {
                    this._keyPressed(code, e.ctrlKey);
                    e.preventDefault();
                }            
            if (this.model.closeOnEscape && code === 27 && this.model.enabled) 
                if (!this.element.find(".e-js.e-dialog").first().is(":visible")) {
                    this.close(e);
                    e.preventDefault();
                }
            if (code===13 && this.model.enabled){
                if($(e.target).hasClass("e-close")) this.close(e);
                else if ($(e.target).hasClass("e-arrowhead-up") || $(e.target).hasClass("e-arrowhead-down")) this._collapsibleClick(e);                
                if ($(e.target).hasClass("e-maximize") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMaximize)))
				    this._maximizeClick(e);
                else if ($(e.target).hasClass("e-minus") || ($(e.target).hasClass("e-restore") && $(e.target).is(this._dialogMinimize)))
				    this._minimizeClick(e);
				if ($(e.target).hasClass("e-pin") || $(e.target).hasClass("e-unpin")){
				    this._pinClick(e);
					}
            }
            if (code == 9 && this.model.enableModal)
                this._focusOnTab(e);
        },

        _focusOnTab: function (e) {
            var focusEle = this._ejDialog.find("a, button, :input, select, [tabindex]:not('-1')");
            focusEle = $(focusEle).find("a, button, :input, select, [tabindex]:not('')");
            if (e.shiftKey) {
                if (!focusEle[focusEle.index(e.target) - 1]) {
                    e.preventDefault();
                    focusEle.last().focus();
                }
            }
            else if (!focusEle[focusEle.index(e.target) + 1]) {
                e.preventDefault();
                focusEle[0].focus();
            }
        },

        _keyPressed: function (code, ctrlKey) {
            this._keyNavigation=true;
            switch (code) {
                case 40:
                    ctrlKey ?  this._resizing("height", (this._ejDialog.outerHeight() + 3)) : this.option("position", { X: this._ejDialog.position().left, Y: (this._ejDialog.position().top + 3) });
                    break;
                case 39:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() + 3)) : this.option("position", { X: (this._ejDialog.position().left + 3), Y: this._ejDialog.position().top });
                    break;
                case 38:
                    ctrlKey ? this._resizing("height", (this._ejDialog.outerHeight() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left == 0 ? 0 : this._ejDialog.position().left),
						Y: (this._ejDialog.position().top > 3 ? this._ejDialog.position().top - 3 : 0) 
					});
                    break;
                case 37:
                    ctrlKey ? this._resizing("width", (this._ejDialog.outerWidth() - 3)) : this.option("position", { 
						X: (this._ejDialog.position().left > 3 ? this._ejDialog.position().left - 3 : 0), 
						Y: (this._ejDialog.position().top == 0 ? 0 : this._ejDialog.position().top)
					});
                    break;
            }
        },

        _resizing:function(key, value){
            if (this.model.enableResize) this.option(key, value);
        },

        _sizeInPercent: function () {
            if (!this._enableWindowResize()) return this;
            var parentObj = this._getParentObj();
            if (this._sizeType.width == "%") this._widthPercent = parseFloat(this.model.width);
            else this._widthPercent = this._convertPixelToPercentage(parentObj.outerWidth(), this._ejDialog.outerWidth());
            if (this._sizeType.height == "%") this._heightPercent = parseFloat(this.model.height);
            else this._heightPercent = this._convertPixelToPercentage(parentObj.outerHeight(), this._ejDialog.outerHeight());
            if (this._widthPercent >= 100) {
                this._widthPercent = 100;
                this._ejDialog.outerWidth(parentObj.outerWidth());
                this.model.width = this._ejDialog.width();
            }
            if (this._heightPercent >= 100) {
                this._heightPercent = 100;
                this._ejDialog.outerHeight(parentObj.outerHeight());
                this.model.height = this._ejDialog.height();
            }
            return this;
        },

        _getParentObj: function () {
            return (!ej.isNullOrUndefined(this.model.containment) ? $(this.model.containment) : !ej.isNullOrUndefined(this.model.target) ? $(this.model.target) : $(document));
        },

        _convertPercentageToPixel: function (parent, child) {
            return Math.round((child * parent) / 100);
        },

        _convertPixelToPercentage: function (parent, child) {
            return Math.round((child / parent) * 100);
        },

        _reSizeHandler: function () {
            var parentObj;
            if (this._maximize) { this._resetScroller(); return; }
            if (this.model.position.X == "" || this.model.position.Y == "" && !this._minimize) this._centerPosition();
            parentObj = this._getParentObj();
            this._change = false;
            if (this._windowSize.outerWidth != $(window).outerWidth()) {
                if (this._sizeType.width == "%") this._percentageWidthDimension(parentObj);
                else this._pixelsWidthDimension(parentObj);
            }
            else if (this._windowSize.outerHeight != $(window).outerHeight()) {
                if (this._sizeType.height == "%") this._percentageHeightDimension(parentObj);
                else this._pixelsHeightDimension(parentObj);
            }
            this._change && this._resizeContainer(parentObj);
            this._windowSize = { outerWidth: $(window).outerWidth(), outerHeight: $(window).outerHeight() };
			this._centerPosition();
        },
        _setDimension:function(){
            if (ej.isNullOrUndefined(this.model.maxWidth)) {
                if (ej.isNullOrUndefined(this._sizeType.width)) this._maxWidth = +this.model.width;
                else if (this._sizeType.width == "px" || this._sizeType.width == "auto") this._maxWidth = this.model.width;
            } else this._maxWidth = this.model.maxWidth;
            if (ej.isNullOrUndefined(this.model.maxHeight)) {
                if (ej.isNullOrUndefined(this._sizeType.height)) this._maxHeight = +this.model.height;
                else if (this._sizeType.height == "px" || this._sizeType.height == "auto") this._maxHeight = this.model.height;
            } else this._maxHeight = this.model.maxHeight;
        },
        _percentageWidthDimension: function (parentObj) {
            this._ejDialog.outerWidth(this._convertPercentageToPixel(parentObj.outerWidth(), this._widthPercent));
            this._change = true;
        },
        _percentageHeightDimension: function (parentObj) {
            this._ejDialog.outerHeight(this._convertPercentageToPixel(parentObj.outerHeight(), this._heightPercent));
            this._change = true;
        },
        _pixelsWidthDimension: function (parentObj) {
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if (parseInt(this._ejDialog.css("width")) < parseInt(this._maxWidth)) {
                if (parseInt(this._maxWidth) < $(parentObj).outerWidth()) this._ejDialog.outerWidth((parseInt(this._maxWidth)));
                else this._ejDialog.outerWidth((parentObj.outerWidth()));
                this._change = true;
            }
        },
        _pixelsHeightDimension: function (parentObj) {
            if (($(parentObj).outerHeight() <= this._ejDialog.outerHeight()) && !this.model.isResponsive) this._setHeight(parentObj);
            if ($(parentObj).outerWidth() <= this._ejDialog.outerWidth()) this._setWidth(parentObj);
            if (parseInt(this._ejDialog.css("height")) < parseInt(this._maxHeight)) {
                if (parseInt(this._maxHeight) < $(parentObj).outerHeight()) this._ejDialog.outerWidth((parseInt(this._maxHeight)));
                else this._ejDialog.outerHeight((parentObj.outerHeight()));
                this._change = true;
            }
        },
        _setWidth: function (parentObj) {
            this._ejDialog.outerWidth((parentObj.outerWidth()));
            this._change = true;
        },
        _setHeight: function (parentObj) {
            this._ejDialog.outerHeight((parentObj.outerHeight()));
            this._change = true;
        },
        _resizeContainer: function (parentObj) {
            this.contentDiv.width(this._ejDialog.width());
            this.element.outerWidth(this.contentDiv.width());
            var contentDivheight = this._ejDialog.height() - ((this.model.showHeader) ? $(this._ejDialog.find("div.e-titlebar")).outerHeight(true) : 0);
            this.contentDiv.height((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.element.outerHeight((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? contentDivheight : contentDivheight - 1);
            this.scroller = this.contentDiv.ejScroller({ width: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this._ejDialog.width() : this._ejDialog.width() - 2, height: (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? this.element.outerHeight() : this.element.outerHeight() - 2, rtl: this.model.rtl, enableTouchScroll: false });
            this.scroller = this.contentDiv.data("ejScroller");
            this._reRenderScroller();
            if ((this.model.position.X == "" || this.model.position.Y == "" && !this._minimize)||(this._positionChanged)) this._centerPosition();
            else this._ejDialog.css("height", this._dialogTitlebar.outerHeight());
            this._updateCaptionWidth();
            this._change = false;
        },
        _getLocalizedLabels:function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }, 

        _enableWindowResize: function () {
            return (this.model.isResponsive || ((isNaN(this.model.width) && (this.model.width.indexOf("%") > 0)) && (isNaN(this.model.height) && (this.model.height.indexOf("%") > 0) && (this.model.height != "auto")))) ? true : false;
        },

        _wireResizing: function () {             
            $(window)[(this._enableWindowResize() ? "on" : "off")]('resize', $.proxy(this._reSizeHandler, this));                        
        },

        _wireEvents: function () {
            this._on(this._ejDialog, "keydown", this._keyDown);
            this._on(this._ejDialog, "click", this._mouseClick);
            this._wireResizing();
        },

        refresh: function () {
            this._resetScroller();
        },

        open: function () {
            if (this._isOpen) return true;
            if (true == this._trigger("beforeOpen")) return false;
            this.element.css("display", "block");
            this._setZindex();
            if (!this._minimize && !this._maximize && !this._init) this._dialogPosition();
            var proxy = this, effect = {}, height;
            this._ejDialog.show();
            if (this.model.enableAnimation) {
                this._ejDialog.css({ "opacity": 0});
                if (this.model.animation.show.effect == "slide") {
                    var eLeft = this._ejDialog.css("left");
                    this._ejDialog.css({ "left": -this._ejDialog.width() });
                    effect = { left: eLeft, opacity: 1 };
                }
                else {
                    effect = { opacity: 1 };
                }
            }
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.show.duration) : 0), function () {
                if (proxy.model) {
					  if (proxy._ejDialog.css("display") == "none") proxy._ejDialog.show();
                    proxy._ejDialog.eq(0).focus();
                    proxy._ejDialog.css({ "opacity": "" });
                    proxy.contentDiv.find("a:visible:enabled, button:visible:enabled, :input:visible:enabled, select:visible:enabled, .e-input").first().focus();
                    proxy._trigger("open");
                    proxy._updateCaptionWidth();
					if(proxy.model.enableModal && !proxy.model.backgroundScroll)
					{
						if( proxy._ejDialog.height() > $(window).height()) proxy._ejDialog.css("height",$(window).height());
						proxy.model.height=$(window).height(); proxy._overLay.css("position","fixed");
						proxy.scroller.refresh(true); proxy.refresh();
					}
                    if (proxy.model.maxHeight || proxy.model.maxWidth)
                    {
                        height = proxy._ejDialog.outerHeight(true) - ((proxy._dialogTitlebar ? proxy._dialogTitlebar.outerHeight(true) : 0));
                        if ((proxy.model.height == "auto" || proxy.model.height == "100%"))
                            height = proxy.model.height;
                        proxy._updateScroller((!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? height : height - 2, (!ej.isNullOrUndefined(this.contentDiv)) ? (this.contentDiv.css('border-width') == "0px") : false ? proxy._ejDialog.width() : proxy._ejDialog.width() - 2);
                    }
                }
            });
            if (this.model.enableModal == true) this._createOverlay();
            this._isOpen = true;
            if (this.element.find("> .e-draggable.e-titlebar")) {
               var dragobject = $("#" + this.element.find("> .e-draggable.e-titlebar").attr("id")).data("ejDraggable");
                if (dragobject)
                    dragobject.option("cursorAt", this.element.offset());
            }
            return this;
        },

        close: function (event) {
            if (!this._isOpen || !this.model.enabled) return true;
            var isInteraction= event ? true : false;            
            if (true == this._trigger("beforeClose", { event: event,isInteraction:isInteraction })) return false;
            this._isOpen = false;
            var proxy = this, effect = {};
            if (this.model.enableAnimation) 
            effect = this.model.animation.hide.effect == "slide" ? { left: -this._ejDialog.width(), opacity: 0 } : { opacity: 0 };
            this._ejDialog.animate(effect, (this.model.enableAnimation ? Number(this.model.animation.hide.duration) : 0), function () {
                proxy._trigger("close", { event: event, isInteraction:isInteraction });
                proxy._ejDialog.hide();
            });
            if (this.model.enableModal){
                if (this._overLay) this._overLay.remove();
                if (!this.model.backgroundScroll) $("body").removeClass("e-dialog-modal");
            }
            return this;
        },

        isOpened: function () { return this.isOpen() },
        isOpen: function () { return this._isOpen; },

        setTitle: function (titleText) {
            this.model.title = titleText;
            this._titleText.text(titleText);
            this._updateCaptionWidth();
            return this;
        },

        setContent: function (htmlContent) {
            if (!this.model.enabled) return false;
            this.element.html(htmlContent);
            this._resetScroller();
            return this;
        },      

        focus: function () {
            this._setZindex();
            this.element.focus();
            return this;
        },

        minimize: function () {
			if(this.model.showHeader){
            this._actionMinimize();
            $(this.wrapper.find(".e-minus")[0]).parent().hide();
            return this;
			}
        },

        maximize: function () {
			if(this.model.showHeader){
            this._actionMaximize();
            $(this.wrapper.find(".e-maximize")[0]).removeClass("e-maximize").addClass("e-restore");
            $(this.wrapper.find(".e-restore")[1]).removeClass("e-restore").addClass("e-minus");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.restore);
            this.contentDiv.show();
            this._dialogTitlebar && this._dialogTitlebar.find(".e-minus").parent().show();
            this._hideIcon(true);
            return this;
			}
        },

        restore: function () {
			if(this.model.showHeader){
            var action = this._minimize;
            this._actionRestore();
            $(this.wrapper.find(".e-restore")[0]).removeClass("e-restore").addClass(action ? "e-minus" : "e-maximize");
            this._dialogMaximize && this._dialogMaximize.attr('title', this.model.tooltip.maximize);
            this._hideIcon(true);
            return this;
			}
        },

        pin: function () {
			if(this.model.showHeader){
            this.dialogPin = true;
            $(this.wrapper.find(".e-unpin")[0]).removeClass("e-unpin").addClass("e-pin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.unPin);
            return this;
			}
        },

        unpin: function () {
            if(this.model.showHeader){
			this.dialogPin = false;
            $(this.wrapper.find(".e-pin")[0]).removeClass("e-pin").addClass("e-unpin");
            this._dialogPin && this._dialogPin.attr('title', this.model.tooltip.pin);
            return this;
			}
        },

        collapse: function () {
			if(this.model.showHeader){
            this._actionCollapse();
            this._collapseValue=true;
            return this;
			}
        },

        expand: function () {
			if(this.model.showHeader){
            this._actionExpand();
            return this;
			}
        }
    });
    
ej.Dialog.Locale = ej.Dialog.Locale || {} ;
    
ej.Dialog.Locale["default"] = ej.Dialog.Locale["en-US"] = {
    tooltip:{
                close: "Close",
                collapse: "Collapse",
                restore: "Restore",
                maximize: "Maximize",
                minimize: "Minimize",
                expand: "Expand",
                unPin: "UnPin",
                pin: "Pin"
            },
    title:"",
     //currently we have deprecated this API
    closeIconTooltip: "close"
};

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin provides support to display calendar within your web page and allows to pick the date.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDatePicker", "ej.DatePicker", {

        element: null,
        _rootCss: "e-datepicker",

        model: null,
        validTags: ["input", "div", "span"],
        _setFirst: false,
        _addToPersist: ["value"],
        _cancelValue: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },


        defaults: {

            dayHeaderFormat: "min",

            showPopupButton: true,

            enableAnimation: true,

            showFooter: true,

            displayInline: false,

            htmlAttributes: {},

            dateFormat: '',

            watermarkText: "Select date",

            value: null,
            minDate: new Date("01/01/1900"),

            maxDate: new Date("12/31/2099"),

            startLevel: "month",

            depthLevel: "",

            cssClass: "",

            startDay: -1,

            stepMonths: 1,

            locale: "en-US",

            showOtherMonths: true,

            enableStrictMode: false,

            enablePersistence: false,

            enabled: true,

            width: "",

            height: "",

            enableRTL: false,

            showRoundedCorner: false,

            headerFormat: 'MMMM yyyy',

            buttonText: 'Today',

            readOnly: false,

            specialDates: null,

            fields: {

                date: "date",

                tooltip: "tooltip",

                iconClass: "iconClass",

                cssClass: "cssClass"
            },

            showTooltip: true,

            showDisabledRange: true,

            highlightSection: "none",

            highlightWeekend: false,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            allowEdit: true,

            tooltipFormat: "ddd MMM dd yyyy",

            allowDrillDown: true,

            blackoutDates: [],

            beforeDateCreate: null,

            open: null,

            close: null,

            select: null,

            change: null,

            focusIn: null,

            focusOut: null,

            beforeOpen: null,

            beforeClose: null,

            navigate: null,

            create: null,

            destroy: null,

            weekNumber: false

        },


        dataTypes: {
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            displayInline: "boolean",
            showPopupButton: "boolean",
            locale: "string",
            readOnly: "boolean",
            cssClass: "string",
            dateFormat: "string",
            watermarkText: "string",
            headerFormat: "string",
            buttonText: "string",
            specialDates: "data",
            showTooltip: "boolean",
            highlightSection: "enum",
            highlightWeekend: "boolean",
            enableAnimation: "boolean",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data",
            tooltipFormat: "string",
            allowEdit: "boolean",
            allowDrillDown: "boolean",
            weekNumber: "boolean"

        },

        _renderPopup: function () {
            this.sfCalendar = ej.buildTag('div.e-datepicker e-popup e-widget ' + this.model.cssClass + ' e-calendar ' + (this.model.specialDates ? (this.model.specialDates[0][this._mapField._icon] ? 'e-icons ' : '') : ''), "", {}, { id: (this._id ? 'e-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                     .insertBefore(this.element);
            if (this.model.displayInline && !this.element.is("input"))
                this.sfCalendar.addClass('e-inline');
            this.popup = this.sfCalendar;
            if (!ej.isTouchDevice()) this.sfCalendar.addClass('e-ntouch');
            this._setRestrictDateState(this.model.showDisabledRange);
            this._createCalender();
            this._setDisplayInline(this.model.displayInline);
            this._resizeCalender();
            this._setRTL(this.model.enableRTL);
            this._setRoundedCorner(this.model.showRoundedCorner);
            this._wireCalendarEvents();
        },

        _setModel: function (jsondata) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            var callRefresh = false, start = false, validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "dayHeaderFormat":
                        this.model.dayHeaderFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "weekNumber":
                        this.model.weekNumber = jsondata[key];
                        this._refreshDatepicker();
                        break;
                    case "showPopupButton":
                        this._renderDateIcon(jsondata[key], true);
                        break;
                    case "displayInline":
                        if (!jsondata[key]) this._bindDateButton();
                        this._setDisplayInline(jsondata[key]);
                        if (!this.model.allowEdit && !jsondata[key] && this._isInputBox)
                            this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                        break;
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        if (ej.isNullOrUndefined(jsondata["minDate"]) && ej.isNullOrUndefined(jsondata["maxDate"])) {
                            this._setDateValue(jsondata[key]);
                            if (this._specificFormat())
                                this._stopRefresh = true;
                            jsondata[key] = this.model.value;
                        }
                        else
                            this._updateDateValue(jsondata[key]);
                        validate = callRefresh = start = true;
                        break;
                    case "specialDates":
                        this.model.specialDates = jsondata[key];
                        this._createSpecialDateObject();
                        callRefresh = start = true;
                        break;
                    case "fields":
                        this.model.fields = jsondata[key];
                        this._mapField = this._getMapper();
                        callRefresh = start = true;
                        break;
                    case "showTooltip":
                        this.model.showTooltip = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightWeekend":
                        this.model.highlightWeekend = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "highlightSection":
                        this.model.highlightSection = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "dateFormat":
                        this.model.dateFormat = jsondata[key];
                        this._ensureValue();
                        break;
                    case "minDate":
                        this._setMinDate(jsondata[key]);
                        jsondata[key] = this.model.minDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "maxDate":
                        this._setMaxDate(jsondata[key]);
                        jsondata[key] = this.model.maxDate;
                        this._ensureValue();
                        validate = callRefresh = start = true;
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this.model.startDay = ((ej.isNullOrUndefined(this._options.startDay)) && (this.model.startDay === this.culture.calendar.firstDay))
                            ? -1 : (this._options.startDay === this.defaults.startDay) ? -1 : this.model.startDay;
                        this.model.dateFormat = ((ej.isNullOrUndefined(this._options.dateFormat)) && (this.model.dateFormat === this.culture.calendar.patterns.d))
                            ? '' : this.model.dateFormat;
                        this._setCulture(jsondata[key]);
                        if (this.model.value) this._setDateValue(this.model.value);
                        jsondata[key] = this.model.locale;
                        callRefresh = start = true;
                        break;
                    case "showOtherMonths":
                        this.model.showOtherMonths = jsondata[key];
                        this._otherMonthsVisibility();
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = jsondata[key];
                        validate = callRefresh = start = true;
                        break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "readOnly":
                        this.model.readOnly = jsondata[key];
                        this._disbleMaualInput();
                        break;
                    case "width":
                        this._setWidth(jsondata[key]);
                        break;
                    case "height":
                        this._setHeight(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        break;
                    case "enableRTL":
                        this._setRTL(jsondata[key]);
                        break;
                    case "showRoundedCorner":
                        this._setRoundedCorner(jsondata[key]);
                        break;
                    case "enabled":
                        if (!jsondata[key]) this.disable();
                        else this.enable();
                        break;
                    case "buttonText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["buttonText"] = this.model.buttonText = jsondata[key];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._setFooterText(jsondata[key]);
                        break;
                    case "showFooter":
                        this._enableFooter(jsondata[key]);
                        break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "startDay":
                        var initial = jsondata[key];
                        if (parseInt(jsondata[key]) < 0 || parseInt(jsondata[key]) > 6) {
                            jsondata[key] = this.culture.calendar.firstDay;
                            initial = -1;
                        }
                        this.model.startDay = jsondata[key];
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["startDay"] = initial;
                        callRefresh = start = true;
                        break;
                    case "startLevel":
                        this.model.startLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "headerFormat":
                        this.model.headerFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "depthLevel":
                        this.model.depthLevel = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "allowEdit": this._changeEditable(jsondata[key]); break;
                    case "tooltipFormat":
                        this.model.tooltipFormat = jsondata[key];
                        callRefresh = start = true;
                        break;
                    case "allowDrillDown":
                        this._allowQuickPick(jsondata[key]);
                        callRefresh = start = true;
                        break;
                    case "showDisabledRange":
                        this._setRestrictDateState(jsondata[key]);
                        break;
                    case "blackoutDates":
                        this.model.blackoutDates = jsondata[key];
                        this._initDisableObj(this.model.blackoutDates);
                        callRefresh = start = true;
                        break;
                }
            }
            if (validate) {
                this._validateMinMaxDate();
                jsondata["value"] = this.model.value;
                jsondata["maxDate"] = this.model.maxDate;
                jsondata["minDate"] = this.model.minDate;
            }
            this._setWaterMark();

            if (callRefresh && (this.isValidState || this.model.displayInline))
                this._refreshDatepicker();
            if (start) this._startLevel(this.model.startLevel);
            this._triggerChangeEvent();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.model.displayInline)
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
            if (this._isOpen)
                this.hide();
            this.sfCalendar && this.sfCalendar.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
            this._cloneElement.removeClass("e-js e-input").removeClass(ej.util.getNameSpace(this.sfType));
            this._cloneElement.insertAfter(this.element);
            this.element.remove();
        },

        _init: function (options) {
            this._options = options;
            this._cloneElement = this.element.clone();
            this._dt_drilldown = false;
            this._ISORegex();
            this._initDisableObj(this.model.blackoutDates);
            this.animation = {
                open: { duration: 200 },
                close: { duration: 100 }
            };
            this._animating = false;
            this._isInputBox = this._isInputBox();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._checkAttribute();
            this._setValues();
            this._createDatePicker();
            if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
                this.model.validationMessages = this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },

        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _checkAttribute: function () {
            var attr = ["min", "max", "readonly", "disabled"], propName = ["minDate", "maxDate", "readOnly", "enabled"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if (!ej.isNullOrUndefined(value)) {
                    if (ej.isNullOrUndefined(this._options))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                    else if (ej.isNullOrUndefined(this._options[propValue]))
                        this.model[propValue] = ((propValue != "enabled") && (propValue != "readOnly")) ? new Date(value) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _updateDateValue: function (value) {
            var date = this._checkDateObject(value);
            if (date != null) {
                this.isValidState = true;
                if (date == "") {
                    this.element.val("");
                    this.model.value = null;
                } else {
                    this.model.value = date;
                    this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
                }
            }
            else {
                (typeof date === "string" && this.model.enableStrictMode) ? this.element.val(value) : this.element.val("");
                this.model.value = null;
                this.isValidState = (this.element.val() == "") ? true : false;
            }
            this._removeWatermark();
        },
        _ensureValue: function () {
            var dateValue = this._parseDate(this.element.val(), this.model.dateFormat);
            if (this.model.value)
                this._setDateValue(this.model.value);
            else if (dateValue)
                this._setDateValue(dateValue);
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    if (!this.model.displayInline) this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
                }
                this[action](this.element, "blur", this._onFocusOut);
                this[action](this.element, "focus", this._onFocusIn);
                this[action](this.element, "keydown", this._onKeyDown);
            }
        },
        _allowQuickPick: function (value) {
            $('.e-datepicker-headertext', this.sfCalendar)[value ? "on" : "off"]("click", $.proxy(this._forwardNavHandler, this));
        },
        _setRestrictDateState: function (value) {
            var action = value ? "addClass" : "removeClass";
            this.sfCalendar[action]("e-dp-restrict-show");
        },
        _setValues: function () {
            this.Date = new Date();
            this._id = this.element[0].id;
            this.isValidState = true;
            this._setCulture(this.model.locale);
            this._setMinDate(this.model.minDate);
            this._setMaxDate(this.model.maxDate);
            this._calendarDate = this._zeroTime(new Date());
            if (this.model.startDay < 0 || this.model.startDay > 6) this.model.startDay = 0;
            this.Date.firstDayOfWeek = this.model.startDay;
            this.Date.fullYearStart = '20';
            this._showHeader = true;
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "")
                this.model.value = this.element[0].value;
            this._validateMinMaxDate();
            this._dateValue = new Date(this._calendarDate.toString());
            this._isIE7 = this._checkIE7();
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            // this variable is set to true in DateTimePicker control
            this._getInternalEvents = false;
            this._flag = true;
            this._ejHLWeekEnd = false;
            this._isOpen = false;
            this._prevDate = null;
            this._preValue = null;
            this._isFocused = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled") proxy.disable();
                else if (keyName == "readOnly") proxy.model.readOnly = true;
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);

            });
        },
        _createDatePicker: function () {
            this._createWrapper();
            this._wireEvents();
            if (this.model.displayInline) {
                this.show();
            }
            if (this.model.enableRTL) this._setRTL(true);
            if (this.model.showRoundedCorner) this._setRoundedCorner(true);
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name") && this._isInputBox)
                this.element.attr("name", this.element[0].id);
            if (this.model.displayInline && !this._isInputBox)
                this._hiddenInput.attr("name", this.element[0].id);
        },
        _createWrapper: function () {
            this._getMapper();
            if (this.model.specialDates)
                this._createSpecialDateObject();
			this.element.attr("tabindex","0");
            if (this._isInputBox) {
                this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'aria-expanded':'false','role':'combobox' });
                this.wrapper = ej.buildTag("span.e-datewidget e-widget " + this.model.cssClass);
                this.wrapper.attr("style", this.element.attr("style"));
                this.element.removeAttr('style');
                if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
                this.innerWrapper = ej.buildTag("span.e-in-wrap e-box e-padding");
                this.wrapper.append(this.innerWrapper).insertBefore(this.element);
                this.innerWrapper.append(this.element);
                this.dateIcon = ej.buildTag("span.e-select#" + this._id + "-img", "", {}, (this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-icon e-calendar", "", {}, { 'aria-label': 'Select' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})).insertAfter(this.element);
            }
            if (!this._isSupport || (this.model.displayInline && !this._isInputBox)) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                if (this._isInputBox) this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
            this._checkNameAttr();
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            if (this._id)
                $("#e-" + this._id).remove();
            this._setDateValue(this.model.value);
            this._preValue = this._parseDate(this.element.val(), this.model.dateFormat);
            this._setWaterMark();
            this._dateValue = new Date(this._calendarDate.toString());
            if (this.model.displayInline) this._renderPopup();
            else if (this._isInputBox) this._renderDateIcon(this.model.showPopupButton, false);
            if (this.model.readOnly) this._disbleMaualInput();
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && $(this.element).hasClass("e-disable")) this.enable();
            this._layoutChanged();
            this._checkErrorClass();
            this._addAttr(this.model.htmlAttributes);
        },
        _isInputBox: function () {
            return (this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type')));
        },

        _renderDateIcon: function (bool, reRender) {
            if (reRender && this.model.showPopupButton == bool) return;
            if (!bool && this.dateIcon) {
                this._bindInputEvent();
                this.dateIcon.css('display', 'none');
                this.innerWrapper.removeClass('e-padding');
            }
            else {
                if (this.innerWrapper) {
                    this.innerWrapper.addClass('e-padding');
                    this.dateIcon.css('display', 'block');
                }
                if (!this.model.displayInline)
                    this._bindDateButton();
            }
            this.model.showPopupButton = bool;
        },

        _resizeCalender: function () {
            if ((this.model.dayHeaderFormat == "short") || (this.model.dayHeaderFormat == "min") || (this.model.dayHeaderFormat == "none"))
                this.sfCalendar.removeClass("e-headerlong");
            else if (this.model.dayHeaderFormat == "long") {
                this.sfCalendar.addClass("e-headerlong");
            }
        },

        _setWidth: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.width(value);
                else this.element.width(value);
            }
            else
                this.model.width = this.wrapper ? this.wrapper.outerWidth() : this.element.width();
        },
        _setHeight: function (value) {
            if (value) {
                if (this.wrapper) this.wrapper.height(value);
                else this.element.height(value);
            }
            else
                this.model.height = this.wrapper ? this.wrapper.outerHeight() : this.element.height();
            if (this._isIE7) this.element.height(this.innerWrapper.height());
        },
        _setRTL: function (isRTL) {
            if (isRTL) {
                if (this.wrapper) {
                    this.wrapper.addClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.addClass("e-rtl");
            }
            else {
                if (this.wrapper) {
                    this.wrapper.removeClass("e-rtl");
                }
                this.sfCalendar && this.sfCalendar.removeClass("e-rtl");
            }
        },
        _setRoundedCorner: function (bool) {
            if (bool) {
                if (this.innerWrapper)
                    this.innerWrapper.addClass("e-corner");
                this.sfCalendar && this.sfCalendar.addClass("e-corner");
            }
            else {
                if (this.innerWrapper)
                    this.innerWrapper.removeClass("e-corner");
                this.sfCalendar && this.sfCalendar.removeClass("e-corner");
            }
        },

        _refreshDatepicker: function () {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var _currentVal = this.element.val();
            //  For checking the year maximum range....
            if (this._specificFormat() && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != _currentVal)
                var currentValue = this._parseDate(_currentVal, true);
            else var currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            this._setDateValue(currentValue);
            if (this._specificFormat() && this._compareDate(this.model.value, this._calendarDate))
                this.element.val(_currentVal)
            $(".e-datepicker-headertext", this.sfCalendar).text(this._formatter(this._calendarDate, this.model.headerFormat));
            this._resizeCalender();
            this._dateValue = new Date(this._calendarDate.toString());
            this._hoverDate = this._calendarDate.getDate() - 1;
            this._renderCalendar(this, this._dateValue);
            this._setFooterText(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
            this._layoutChanged();
        },
        _validateYearValue: function (value) {
            if (value != null) {
                var twoDigitYearMax = ej.preferredCulture(this.model.locale).calendars.standard.twoDigitYearMax;
                twoDigitYearMax = typeof twoDigitYearMax === "string" ? new Date().getFullYear() % 100 + parseInt(twoDigitYearMax, 10) : twoDigitYearMax;
                if (this._calendarDate.getFullYear() - value.getFullYear() == 100) {
                    if (this._calendarDate.getFullYear() > twoDigitYearMax)
                        value.setFullYear(this._calendarDate.getFullYear())
                }
            }
            return value;
        },
        _setFooterText: function (footerText) {
            $('.e-footer-text', this.sfCalendar).html(footerText);
        },
        _setSkin: function (skin) {
            if (this.wrapper) {
                this.wrapper.removeClass(this.model.cssClass);
                this.wrapper.addClass(skin);
            }
            else {
                this.element.removeClass(this.model.cssClass);
                this.element.addClass(skin);
            }
            this.sfCalendar.removeClass(this.model.cssClass);
            this.sfCalendar.addClass(skin);
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this._isInputBox) {
                this.sfCalendar.insertAfter(this.wrapper);
                this._setDatePickerPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.sfCalendar);
                if (!this._isSupport || !this._isInputBox) this._hiddenInput.css("display", "none");
            }
            else {
                this.sfCalendar.css('display', 'none');
                $('body').append(this.sfCalendar);
                this._isOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                this._off(this.dateIcon, "mousedown", this._showDatePopUp);
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
            }

        },

        _disbleMaualInput: function () {
            if (this.model.readOnly) {
                $(this.element).attr("readonly", "readonly");
                if (!this.model.displayInline) this.hide();
            }
            else if (this.model.allowEdit)
                $(this.element).prop("readonly", false);

        },
        _checkDateObject: function (date, val) {
            if (!date || (typeof JSON === "object" && JSON.stringify(date) === "{}")) return date = null;
            else if (!(date instanceof Date)) {
                if (this._specificFormat())
                    var val = this._parseDate(date, true);
                else
                    var val = this._parseDate(date, val);
                date = val ? val : (val = this._checkJSONString(date)) ? val : null;
            }
            if (!isNaN(Date.parse(date))) {
                this._dateValue = this._calendarDate = this._zeroTime(date)
                if (this._validateDate(date))
                    return this._dateValue;
            }
            return null;
        },
        _checkJSONString: function (date) {
            // Validate the string value
            if (!isNaN(Date.parse(date))) {
                if ((new Date(date).toJSON() === date) || (new Date(date).toDateString() === date) || (new Date(date).toGMTString() === date) ||
                    (new Date(date).toISOString() === date) || (new Date(date).toLocaleString() === date) ||
                    (new Date(date).toString() === date) || (new Date(date).toUTCString() === date)) {
                    return new Date(new Date(date).getTime() + (ej.serverTimezoneOffset * 60 * 60 * 1000));
                }
                else if (typeof date == "string") return this._dateFromISO(date);
            } else if (this._extISORegex.exec(date) || this._basicISORegex.exec(date)) return this._dateFromISO(date);
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _checkInstanceType: function (date) {
            date = this._stringToObject(date);
            if (!date) return null;
            else if (!(date instanceof Date)) {
                date = this._parseDate(date);
            }
            if (!isNaN(Date.parse(date))) return this._zeroTime(date);
            return null;
        },
        _stringToObject: function (value) {
            if (typeof value === "string") {
                var val = ej.parseDate(value, this.model.dateFormat, this.model.locale);
                value = (val != null) ? val : new Date(value);
            }
            return value;
        },
        _validateMinMaxDate: function () {
            var dateChange = false, valueExceed = false;
            if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
            if (!this.model.enableStrictMode) {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.value = this.model.minDate;
                        dateChange = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.value = this.model.maxDate;
                        dateChange = true;
                    }
                }
                else {
                    this.element.val("");
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
                this.isValidState = true;
            }
            else {
                if (this.model.value) {
                    if (this.model.value < this.model.minDate) {
                        this._calendarDate = this.model.minDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else if (this.model.value > this.model.maxDate) {
                        this._calendarDate = this.model.maxDate;
                        this.isValidState = false;
                        valueExceed = true;
                    }
                    else this.isValidState = true;
                }
                else {
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
            if (dateChange) this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
        },
        _setCulture: function (culture) {
            this.culture = ej.preferredCulture(culture);
            if (this.culture) {
                this.model.locale = this.culture.name == "en" ? "en-US" : this.culture.name;
                this.Date.dayNames = this.culture.calendar.days.names;
                this.Date.dayNamesMin = this.culture.calendar.days.namesShort;
                this.Date.abbrDayNames = this.culture.calendar.days.namesAbbr;
                this.Date.monthNames = this.culture.calendar.months.names;
                this.Date.abbrMonthNames = this.culture.calendar.months.namesAbbr;
                this.Date.format = this.culture.calendar.patterns.d;
                if (this.model.dateFormat == '') this.model.dateFormat = this.culture.calendar.patterns.d;
                if (this.model.startDay == -1) this.model.startDay = this.culture.calendar.firstDay;
            }
            this._separator = this._getSeparator();
            this._localizedLabels = this._getLocalizedLabels();

            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    this._localizedLabels.buttonText = this._options.buttonText;
            }
            this._localizedLabelToModel();
        },

        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },

        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "") {
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                }
                else {
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                }
                return true;
            }
        },

        _setDatePickerPosition: function () {
            if (!this.model.displayInline || this._isInputBox) {
                var elementObj = this.element.is('input') ? this.wrapper : this.element;
                var pos = this._getOffset(elementObj), winLeftWidth, winRightWidth,
                winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
                winTopHeight = pos.top - $(document).scrollTop(),
                popupHeight = this.sfCalendar.outerHeight(),
                popupWidth = this.sfCalendar.outerWidth(),
                left = pos.left,
                totalHeight = elementObj.outerHeight(),
                border = (totalHeight - elementObj.height()) / 2,
                maxZ = this._getZindexPartial(), popupmargin = 3,
                topPos = (popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin; // popupmargin denotes space b/w the element and the popup.
                winLeftWidth = $(document).scrollLeft() + $(window).width() - left;
                winRightWidth = $(document).scrollLeft() + left + elementObj.width();
                if (this.model.enableRTL || popupWidth > winLeftWidth && (popupWidth < left + elementObj.outerWidth()) && !ej.isNullOrUndefined(this.wrapper))
                    left += this.wrapper.width() - this.sfCalendar.width();
                if (popupWidth > winRightWidth) left = pos.left;
                this.sfCalendar.css({
                    "left": left + "px",
                    "top": topPos + "px",
                    "z-index": maxZ
                });
            }
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.sfCalendar);
        },

        _setMinDate: function (d) {
            this.model.minDate = this._checkInstanceType(d);
            if (!this.model.minDate) {
                this.model.minDate = (new Date('11/31/1899'));
            }
        },

        _setMaxDate: function (d) {
            this.model.maxDate = this._checkInstanceType(d);
            if (!this.model.maxDate) {
                this.model.maxDate = (new Date('12/31/2099')); // using the JS Date.parse function which expects mm/dd/yyyy
            }
        },
        _setDateValue: function (date, val) {
            var newDate = this._checkDateObject(date, val);
            if (newDate != null) {
                this.isValidState = true;
                this.model.value = new Date(newDate.toString());
                if (!this.model.displayInline)
                    this.wrapper.addClass('e-valid');
                this._validateMinMaxDate();
                this._preTxtValue = this.element.val(this._formatter(this.model.value, this.model.dateFormat));
            }
            else {
                if (date instanceof Date) {
                    this._validateMinMaxDate();
                    date = this._formatter(date, this.model.dateFormat);
                }
                (this.model.enableStrictMode) ? this.element.val(date) : this.element.val(null);
                this.model.value = null; //updating model value as null to avoid the recursive call to this method
                if (!this.model.displayInline)
                    this.wrapper.removeClass('e-valid');
                this._triggerChangeEvent();
                this.isValidState = (this.element.val() == "" || ej.isNullOrUndefined(this.element.val())) ? true : false;
            }
            this._removeWatermark();
        },
        _updateInputVal: function () {
            var val = this._validateValue();
            if ((val != null || !this.model.enableStrictMode) && this.sfCalendar && this.sfCalendar.find('.e-datepicker-days').is(':visible'))
                this._refreshDatepicker();
        },
        _validateInputVal: function () {
            var val = this._validateValue();
            if (val != null) {
                if (!this.model.enableStrictMode) {
                    if (val <= this.model.maxDate && val >= this.model.minDate)
                        this.isValidState = true;
                    else {
                        this.model.value = null;
                        this.isValidState = true;
                    }
                }
            }
        },

        _validateValue: function () {
            if (this._specificFormat() && this.element.val() != this._formatter(this._preValue, this.model.dateFormat, this.model.locale))
                var value = this._parseDate(this.element.val(), true);
            else var value = this._parseDate(this.element.val());
            return this._validateYearValue(value);
        },
        _getSeparator: function () {
            var formats;
            if (this.culture) {
                formats = this.culture.calendar.patterns.d;
            }
            else formats = this.model.dateFormat;
            var regex = new RegExp("^[a-zA-Z0-9]+$");
            for (var i = 0; i < formats.length; i++) {
                if (!regex.test(formats[i])) return formats[i];
            }
        },
        _checkIE7: function () {
            if (navigator.appName == 'Microsoft Internet Explorer') {
                var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})"), version = -1;
                if (re.exec(navigator.userAgent) != null)
                    version = parseFloat(RegExp.$1);
                if (version >= 7 && version < 8) return true;
            }
            return false;
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },

        //Date formatter - Convert date object to specific date format
        _formatter: function (date, format) {
            var newFormat = this._checkFormat(format);
            return ej.format(date, newFormat, this.model.locale);
        },
        _parseDate: function (date, type) {
            var newFormat = this._checkFormat(this.model.dateFormat);
            var DateValue = date;
            if ((this._specificFormat()) && DateValue != undefined && date != "" && type != true && !(ej.format(ej.parseDate(DateValue, newFormat, this.model.locale), this.model.dateFormat, this.model.locale) == DateValue)) {
                return this._dateValue;
            }
            else return ej.parseDate(date, newFormat, this.model.locale);
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },

        isLeapYear: function (year) {
            return (year % 4 == 0 && year % 100 != 0) || year % 400 == 0;
        },
        //Sets the time component of this Date to zero for cleaner, easier comparison of dates where time is not relevant.
        _zeroTime: function (date) {
            var newDate = typeof date === "string" ? this._parseDate(date) : new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },

        _getDaysInMonth: function (date) {
            return [31, (this.isLeapYear(date) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][date.getMonth()];
        },

        _addDays: function (d, number) {
            d.setDate(d.getDate() + number);
            return d;
        },

        _addYears: function (d, number) {
            d.setFullYear(d.getFullYear() + number);
            return d;
        },

        _addMonths: function (d, number) {
            var tempDatedateMonth = d.getDate();
            d.setMonth(d.getMonth() + number);
            if (tempDatedateMonth > d.getDate())
                this._addDays(d, -d.getDate());
            return d;
        },
        //Checks if the day is a weekend day (Sat or Sun).
        _isWeekend: function (date) {
            return date.getDay() == 0 || date.getDay() == 6;
        },

        _isSpecialDates: function (dates) {
            if (this.model.specialDates) {
                for (var i = 0; i < this.model.specialDates.length; i++) {
                    if (this.model.specialDates[i] && this.model.specialDates[i][this._mapField._date]) {
                        if (dates.getDate() == this.model.specialDates[i][this._mapField._date].getDate() && dates.getMonth() == this.model.specialDates[i][this._mapField._date].getMonth() && dates.getFullYear() == this.model.specialDates[i][this._mapField._date].getFullYear()) {
                            this._getIndex = i;
                            return true;
                        }
                    }
                }
            }
            return false;
        },
        _getMapper: function () {
            var mapper = this.model.fields;
            this._mapField = {};
            this._mapField["_date"] = (mapper && mapper.date) ? mapper["date"] : "date";
            this._mapField["_tooltip"] = (mapper && mapper.tooltip) ? mapper["tooltip"] : "tooltip";
            this._mapField["_icon"] = (mapper && mapper.iconClass) ? mapper["iconClass"] : "iconClass";
            this._mapField["_custom"] = (mapper && mapper.cssClass) ? mapper["cssClass"] : "cssClass";
        },
        _createSpecialDateObject: function () {
            for (var i = 0; i < this.model.specialDates.length; i++) {
                this.model.specialDates[i][this._mapField._date] = this._checkInstanceType(this.model.specialDates[i][this._mapField._date]);
            }
        },

        _getMonthName: function (abbreviated, date) {
            return abbreviated ? this.Date.abbrMonthNames[date.getMonth()] : this.Date.monthNames[date.getMonth()];
        },



        _displayNewMonth: function (m, y) {
            this._setDisplayedMonth(this.displayedMonth + m, this.displayedYear + y, true);
            return false;
        },

        _setDisplayedMonth: function (m, y, rerender) {
            if (this.model.minDate == undefined || this.model.maxDate == undefined) {
                return;
            }
            var s = new Date(this.model.minDate.getTime());
            s.setDate(1);
            var e = new Date(this.model.maxDate.getTime());
            e.setDate(1);

            var t;
            if ((!m && !y) || (isNaN(m) && isNaN(y))) {

                t = this._zeroTime(new Date());
                t.setDate(1);
            } else if (isNaN(m)) {

                t = new Date(y, this.displayedMonth, 1);
            } else if (isNaN(y)) {

                t = new Date(this.displayedYear, m, 1);
            } else {

                t = new Date(y, m, 1);
            }

            if (t.getTime() < s.getTime()) {
                t = s;
            } else if (t.getTime() > e.getTime()) {
                t = e;
            }
            var oldMonth = this.displayedMonth;
            var oldYear = this.displayedYear;
            this.displayedMonth = t.getMonth();
            this.displayedYear = t.getFullYear();
            var tempDate = t;
            if (rerender && (this.displayedMonth != oldMonth || this.displayedYear != oldYear)) {
                this._renderCalendar(this, tempDate);
                this._dateValue = tempDate;
                this._trigger("monthChanged", [this.displayedMonth, this.displayedYear]);
            }
        },
        _clearSelected: function () {
            this.numSelected = 0;
            if (!ej.isNullOrUndefined(this.sfCalendar)) {
                if (this.model.highlightSection == "week") {
                    $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-selected-week');
                }
                else if (this.model.highlightSection == "month") {
                    $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().parent().removeClass('e-selected-month');
                }
                else if (this.model.highlightSection == "workdays") {
                    $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false).parent().removeClass('e-work-week');
                }
                else
                    $('td.e-active', this.sfCalendar).removeClass('e-active').addClass('e-state-hover').attr('aria-selected', false);
            }

        },
        _addSelected: function () {
            if (this.model.highlightSection == "week") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-selected-week');
            }
            else if (this.model.highlightSection == "month") {
                $('td.e-active, this.sfCalendar').parent().parent().addClass('e-selected-month');
            }
            else if (this.model.highlightSection == "workdays") {
                $('td.e-active', this.sfCalendar).parent().addClass('e-work-week');
            }
        },

        _hideOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css("visibility", "hidden");
        },
        _showOtherMonths: function (sfCalendar) {
            $('td.other-month', sfCalendar).css({ 'visibility': 'visible' });
        },
        _otherMonthsVisibility: function () {
            if (this.model.showOtherMonths)
                this._showOtherMonths(this.sfCalendar);
            else
                this._hideOtherMonths(this.sfCalendar);
        },

        _createCalender: function () {
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                    .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-datepicker-headertext").text(this._formatter(this._calendarDate, this.model.headerFormat)).attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                    .appendTo(this.sfCalendar);
            this._enableHeader(this._showHeader);
            var table = ej.buildTag("table.e-dp-viewdays", "", {}).data("e-table", "data").attr({ 'role': 'grid'}).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.sfCalendar.append(table);
            this._renderCalendar(this);
            this._startLevel(this.model.startLevel);
            ej.buildTag("div.e-footer")
                .append(ej.buildTag("span.e-footer-icon"))
                .append(ej.buildTag("span.e-footer-text"))
                .appendTo(this.sfCalendar);
            $('.e-footer-text', this.sfCalendar).html(this._localizedLabels.buttonText);
            this._enableFooter(this.model.showFooter);
        },
        _enableHeader: function (show) {
            if (show) $(".e-header", this.sfCalendar).show();
            else $(".e-header", this.sfCalendar).hide();
        },
        _enableFooter: function (show) {
            if (show) $('.e-footer', this.sfCalendar).show();
            else $('.e-footer', this.sfCalendar).hide();
            this._todayBtnDisable();
        },
        _todayBtnDisable: function () {
            var today = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), 0, 0, 0);
            if (!(+this.model.minDate <= +today && +this.model.maxDate >= +today)) {
                $('.e-footer', this.sfCalendar).addClass('e-footer-disable')
            } else {
                $('.e-footer', this.sfCalendar).removeClass('e-footer-disable')
            }
        },
        _checkArrows: function (min, max) {
            this._preArrowCondition(min, this.model.minDate.getFullYear());
            this._nextArrowCondition(max, this.model.maxDate.getFullYear());
        },
        _checkDateArrows: function () {
            this._preArrowCondition(this._tempMinDate, this.model.minDate);
            this._nextArrowCondition(this._tempMaxDate, this.model.maxDate);
        },
        _preArrowCondition: function (val1, val2) {
            if (val1 <= val2) this.sfCalendar.find(".e-arrow-sans-left").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-arrow-sans-left").removeClass("e-disable").attr({ "aria-disabled": false });
        },
        _nextArrowCondition: function (val1, val2) {
            if (val1 >= val2) this.sfCalendar.find(".e-arrow-sans-right").addClass("e-disable").attr({ "aria-disabled": true });
            else this.sfCalendar.find(".e-arrow-sans-right").removeClass("e-disable").attr({ "aria-disabled": false });
        },

        _previousNextHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled || $(event.target).hasClass("e-disable")) return false;
            event.preventDefault();
            var prevTable = $("table", this.sfCalendar), navFrom;
            navFrom = this._navigateFrom(prevTable);
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrevDate(progress);
            var currentTable = $("table", this.sfCalendar), tClassName, navTo;
            tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewdays": navTo = "month"; break;
                case "e-dp-viewmonths": navTo = "year"; break;
                case "e-dp-viewyears": navTo = "decade"; break;
                case "e-dp-viewallyears": navTo = "century"; break;
            }
            this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
        },
        _processNextPrevDate: function (progress) {
            if (this._DRPdisableFade) {
                var s = new Date(this.sfCalendar.find("td.current-month").attr("data-date"));
                this._dateValue = s;
            }
            if (progress && this.sfCalendar.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && this.sfCalendar.find(".e-arrow-sans-right").hasClass("e-disable")) return false;

            var currentTable = $("table", this.sfCalendar), temp;
            var tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case 'e-dp-viewdays':
                    var step = this.model.stepMonths;
                    if (progress) {
                        if (this._dateValue <= this.model.minDate) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (this._dateValue >= this.model.maxDate) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addMonths(this._dateValue, (progress ? -step : step));
                    if (this._clickedDate)
                        this._calendarDate = this._clickedDate;
                    this._dateValue = this._dateValue < this.model.minDate ? new Date(this.model.minDate.toString()) : this._dateValue;
                    this._dateValue = this._dateValue > this.model.maxDate ? new Date(this.model.maxDate.toString()) : this._dateValue;
                    this._renderCalendar(this, this._dateValue);
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    this._addFocus('day', this._hoverDate);
                    var dateRange = this._findFirstLastDay(new Date(this._dateValue.toString()));
                    this._preArrowCondition(dateRange.firstDay, this.model.minDate);
                    this._nextArrowCondition(dateRange.lastDay, this.model.maxDate);
                    break;
                case 'e-dp-viewmonths':
                    var dateValue = this._dateValue;
                    dateValue.setFullYear($('.e-datepicker-headertext', this.sfCalendar).text())
                    if (progress) {
                        if (dateValue.getFullYear() <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (dateValue.getFullYear() >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    this._addYears(dateValue, (progress ? -1 : 1));
                    this._renderCalendar(this, dateValue);
                    temp = dateValue.getFullYear();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-months').hide();
                    $($(currentTable).find('.e-datepicker-months')).show();
                    this._addFocus('month', this._hoverMonth);
                    this._checkArrows(temp, temp);
                    break;
                case 'e-dp-viewyears':
                    var yearValue;
                    yearValue = this._dateValue
                    yearValue.setFullYear($(currentTable).find(".e-state-hover").text());
                    if (progress) {
                        if (parseInt($('td.e-year-first:first').text()) <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    } else {
                        if (parseInt($('td.e-year-last:first').prev().text()) >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        }
                    }
                    this._flag = true;
                    if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && progress) || ($(currentTable).find(".e-state-hover").hasClass('e-year-last') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear());
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-first') && !progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() + 11);
                    else if (($(currentTable).find(".e-state-hover").hasClass('e-year-last') && progress))
                        this._dateValue.setFullYear(yearValue.getFullYear() - 11);
                    else
                        this._dateValue.setFullYear(yearValue.getFullYear() + (progress ? -10 : 10));
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    $(".e-datepicker-headertext", this.sfCalendar).text((setYear + 1) + ' - ' + (setYear + 10));
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-years').hide();
                    $($(currentTable).find('.e-datepicker-years')).show();
                    this._addFocus('year', this._hoverYear + (!($('.e-year-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, setYear + 10);
                    break;
                case 'e-dp-viewallyears':
                    var headYears;
                    if (progress) {
                        headYears = parseFloat($('td.e-allyear-first', currentTable.get(0)).text().split('-')[1]);
                        if (headYears <= this.model.minDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else {
                            this._flag = true;
                        }

                    } else {
                        headYears = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                        if (headYears >= this.model.maxDate.getFullYear()) {
                            this._flag = false;
                            return false;
                        } else
                            this._flag = true;
                    }
                    this._dateValue.setFullYear((!(this._lastHoveredYear) ? this._dateValue.getFullYear() : this._lastHoveredYear) + (progress ? -100 : 100));
                    this._lastHoveredYear = this._dateValue.getFullYear();
                    this._renderCalendar(this, this._dateValue);
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 100) + 1);
                    temp = parseFloat($('td.e-allyear-last', currentTable.get(0)).prev().text().split('-')[1]);
                    $('.e-datepicker-headertext', this.sfCalendar).text((setYear + 1) + ' - ' + temp);
                    $('tbody,tr.e-week-header', currentTable).not('.e-datepicker-allyears').hide();
                    $($(currentTable).find('.e-datepicker-allyears')).show();
                    this._addFocus('allyear', this._hoverAllYear + (!($('.e-allyear-first.e-hidedate').length) ? 0 : -1));
                    this._checkArrows(setYear + 1, temp);
                    break;
            }
            this._layoutChanged();
        },
        _addFocus: function (selection, index) {
            var cls = 'e-current-' + selection;
            if (selection == 'day') cls = 'current-month';
            var items = this.sfCalendar.find('tbody tr td.' + cls);
            if (selection == "month") {
                $(items).each(function (i, ele) {
                    if (parseInt($(ele).attr("data-index")) == parseInt(index)) {
                        index = i;
                        return;
                    }
                });
            }
            var cell = items[index];
            if (!cell) cell = items.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(selection);
            return index;
        },
        _setActiveState: function (selection) {
            if (!(this.model.value instanceof Date)) return;
            var items = this.sfCalendar.find('tbody tr td.e-current-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "month":
                    if (this.model.value.getFullYear() === parseInt($('.e-text', this.sfCalendar).text())) {
                        $(items).each(function (i, ele) {
                            if (parseInt($(ele).attr("data-index")) == parseInt(proxy.model.value.getMonth())) {
                                indx = i;
                                return;
                            }
                        });
                    }
                    break;
                case "year":
                    var value = this.model.value.getFullYear();
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(value)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
                case "allyear":
                    var start = parseInt(this.model.value.getFullYear()) - ((parseInt(this.model.value.getFullYear()) % 10) + 1);
                    var active = (start + 1) + ' - ' + (start + 10);
                    $(items).each(function (i, ele) {
                        if (parseInt(ele.innerHTML) == parseInt(active)) {
                            indx = i;
                            return;
                        }
                    });
                    break;
            }
            cell = items[indx];
            if (cell) {
                this.sfCalendar.find('table td').removeClass("e-active");
                if (!$(cell).hasClass('e-hidedate'))
                    $(cell).addClass("e-active");
            }
        },
        _setFocusByName: function (name, value) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            this.sfCalendar.find('table td').removeClass("e-state-hover");
            $(cell).addClass("e-state-hover");
            this._setActiveState(name);
            return index;
        },
        _getHeaderTxt: function () {
            return this.sfCalendar.find(".e-datepicker-headertext").text();
        },
        _findFirstLastDay: function (value) {
            var y = value.getFullYear(), m = value.getMonth();
            var firstDay = new Date(y, m, 1);
            var lastDay = new Date(y, m + 1, 0);
            return { firstDay: firstDay, lastDay: lastDay }
        },
        _forwardNavHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (event) event.preventDefault();

            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, headerTxt, navTo;
            var navFrom = this._navigateFrom(currentTable);
            switch (tclassName) {
                case 'e-dp-viewdays':
                    this._hoverMonth = this._getDateObj(currentTable.find(".e-state-hover")).getMonth() ||
                                this._getDateObj(currentTable.find(".e-active")).getMonth() || 0;
                    if (this._DRPdisableFade) {
                        this._renderCalendar(this, this._calendarDate);
                        $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat));
                    }
                    this._startLevel("year"); navTo = "year";
                    this._addFocus('month', this._hoverMonth);
                    break;
                case 'e-dp-viewmonths':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("decade"); navTo = "decade";
                    this._hoverYear = this._setFocusByName('year', headerTxt);
                    break;
                case 'e-dp-viewyears':
                    headerTxt = this._getHeaderTxt();
                    this._startLevel("century"); navTo = "century";
                    this._hoverAllYear = this._setFocusByName('allyear', headerTxt);
                    break;
            }
            if (navFrom != "century") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },
        _cellSelection: function () {
            var currentTable = $("table", this.sfCalendar);
            var tclassName = $("table", this.sfCalendar).get(0).className;
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    this._hoverMonth = this._addFocus('month', this._dateValue.getMonth());
                    break;
                case 'e-dp-viewyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('year');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    this._hoverYear = this._setFocusByName('year', this._dateValue.getFullYear());
                    break;
                case 'e-dp-viewallyears':
                    var dateValue = new Date(this._dateValue.toString());
                    // Navigate to Prev/Next year Calendar while selecting the first/last year in the calendar view.
                    this._navigationToPrevNext('allyear');
                    // Reasssign the old value
                    this._dateValue = dateValue;
                    var setYear = parseInt(this._dateValue.getFullYear()) - ((parseInt(this._dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', setYear + 1 + ' - ' + setYear + 10);
                    break;
            }
            this._layoutChanged();
        },
        _navigationToPrevNext: function (name) {
            var allValues = this.sfCalendar.find('tbody tr td.e-current-' + name), index, cell;
            var value = this._dateValue.getFullYear();
            $(allValues).each(function (i, ele) {
                if (parseInt(ele.innerHTML) == parseInt(value)) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (cell) {
                if ($(cell).hasClass('e-' + name + '-last'))
                    this._processNextPrevDate(false)
                else if ($(cell).hasClass('e-' + name + '-first'))
                    this._processNextPrevDate(true);
            }
        },
        _navigateFrom: function (prevTable) {
            var tPrevClassName = prevTable.get(0).className, navFrom;
            switch (tPrevClassName) {
                case "e-dp-viewdays": navFrom = "month"; break;
                case "e-dp-viewmonths": navFrom = "year"; break;
                case "e-dp-viewyears": navFrom = "decade"; break;
                case "e-dp-viewallyears": navFrom = "century"; break;
            }
            return navFrom;
        },
        _backwardNavHandler: function (event) {
            this._animating = true;
            if (this.model.readOnly || !this.model.enabled) return false;
            var element;
            if (event.type) {
                event.preventDefault();
                element = $(event.currentTarget);
            }
            else element = event;
            var cTable = $("table", this.sfCalendar), temp;
            var tclassName = $("table", this.sfCalendar).get(0).className, proxy = this, navTo;
            var navFrom = this._navigateFrom(cTable);
            switch (tclassName) {
                case 'e-dp-viewmonths':
                    cTable.removeClass("e-dp-viewmonths").addClass("e-dp-viewdays");
                    this._lastHoveredMonth = parseInt($(element).attr('data-index'));
                    this._dateValue = new Date(this._dateValue.getFullYear(), this._lastHoveredMonth, 1);
                    if (this._DRPdisableFade) this._trigger("_month_Loaded", { currentTarget: event.currentTarget });
                    this._renderCalendar(this, this._dateValue);
                    $('tbody', cTable).not('.e-datepicker-days,.e-week-header').hide();
                    $($(cTable).find('.e-datepicker-days,.e-week-header')).fadeIn("fast", function () {
                        proxy._addFocus('day', proxy._hoverDate || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(this._formatter(this._dateValue, this.model.headerFormat)); navTo = "month";
                    break;
                case 'e-dp-viewyears':
                    cTable.removeClass("e-dp-viewyears").addClass("e-dp-viewmonths");
                    this._lastHoveredYear = parseInt(element.text());
                    this._dateValue.setFullYear(this._lastHoveredYear);
                    this._renderCalendar(this, this._dateValue);
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-months').hide();
                    if (ej.isNullOrUndefined(this._hoverMonth) && !ej.isNullOrUndefined(this._dateValue)) this._hoverMonth = this._dateValue.getMonth();
                    $($(cTable).find('.e-datepicker-months')).fadeIn("fast", function () {
                        proxy._addFocus('month', proxy._hoverMonth || 0);
                        proxy._animating = false;
                    });
                    temp = element.text();
                    $('.e-datepicker-headertext', this.sfCalendar).text(temp);
                    this._checkArrows(temp, temp); navTo = "year";
                    break;
                case 'e-dp-viewallyears':
                    var headYears = element.text().split('-');
                    cTable.removeClass("e-dp-viewallyears").addClass("e-dp-viewyears");
                    if (headYears[0] < this.model.minDate.getFullYear()) headYears[0] = this.model.minDate.getFullYear().toString();
                    else if (headYears[0] > this.model.maxDate.getFullYear()) headYears[0] = this.model.maxDate.getFullYear().toString();
                    this._renderCalendar(this, (new Date(headYears[0], 0, 1)));
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).fadeIn("fast", function () {
                        proxy._addFocus('year', proxy._hoverYear || 0);
                        proxy._animating = false;
                    });
                    $('.e-datepicker-headertext', this.sfCalendar).text(headYears[0] + ' - ' + headYears[1]);
                    this._checkArrows(headYears[0], headYears[1]); navTo = "decade";
                    this._dateValue = new Date(this._dateValue.setFullYear(parseInt($.trim(headYears[0])) + ((!this._lastHoveredYear) ? this._dateValue.getFullYear() % 10 : this._lastHoveredYear % 10)));
                    break;
                default:
                    this._clearSelected();
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    element.not('td.other-month.e-hidedate').addClass('e-active').attr('aria-selected', true);
                    this._addSelected();

                    this._hoverDate = this._getDateObj(element).getDate() - 1;
                    this._dateValue = new Date(element.attr('data-date'));
                    this._clickedDate = new Date(element.attr('data-date'));
                    this._animating = false;
                    break;
            }
            if (navFrom != "month") this._trigger("navigate", { date: this._dateValue, value: this._formatter(this._dateValue, this.model.dateFormat), navigateTo: navTo, navigateFrom: navFrom });
            this._layoutChanged();
        },

        _startLevel: function (start) {
            var cTable = $("table", this.sfCalendar);
            var headerText = $(".e-datepicker-headertext", this.sfCalendar), s, e;
            var dateValue = this._dateValue;
            switch (start) {
                case "decade":
                    cTable.removeClass("e-dp-viewallyears e-dp-viewmonths e-dp-viewdays").addClass("e-dp-viewyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-years').hide();
                    $($(cTable).find('.e-datepicker-years')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) dateValue = this._calendarDate;
                    else dateValue = dateValue;
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    s = setYear + 1;
                    e = setYear + 10;
                    headerText.text(s + ' - ' + e);
                    this._checkArrows(s, e);
                    this._hoverYear = this._setFocusByName('year', dateValue.getFullYear());
                    break;
                case "century":
                    if (!(this._calendarDate < this._dateValue)) this._renderCalendar(this, dateValue);
                    cTable.removeClass("e-dp-viewyears e-dp-viewdays e-dp-viewmonths").addClass("e-dp-viewallyears");
                    $('tbody,tr.e-week-header', cTable).not('.e-datepicker-allyears').hide();
                    $($(cTable).find('.e-datepicker-allyears')).show();
                    s = parseFloat($('td.e-allyear-first', cTable.get(0)).text().split('-')[1]) + 1;
                    e = parseFloat($('td.e-allyear-last', cTable.get(0)).prev().text().split('-')[1]);
                    var headYears = s + ' - ' + e;
                    headerText.text(headYears);
                    this._checkArrows(s, e);
                    var setYear = parseInt(dateValue.getFullYear()) - ((parseInt(dateValue.getFullYear()) % 10) + 1);
                    this._hoverAllYear = this._setFocusByName('allyear', (setYear + 1) + ' - ' + (setYear + 10));
                    break;
                case "year":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewdays").addClass("e-dp-viewmonths");
                    $('tbody,tr.e-week-header', cTable).hide();
                    $($(cTable).find('.e-datepicker-months')).show();
                    if (this.model.enableStrictMode && this._calendarDate < this._dateValue) s = this._calendarDate.getFullYear();
                    else s = dateValue.getFullYear();
                    headerText.text(s);
                    this._checkArrows(s, s);
                    this._hoverMonth = dateValue.getMonth();
                    this._addFocus('month', this._hoverMonth);
                    break;
                case "month":
                    cTable.removeClass("e-dp-viewyears e-dp-viewallyears e-dp-viewmonths").addClass("e-dp-viewdays ");
                    break;
            }
        },
        _depthLevel: function (depth) {
            var calendarTable = this.sfCalendar;
            switch (depth) {
                case "year":
                    $(calendarTable.find('.e-current-year,.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    this._on($('.e-current-month', this.sfCalendar), "click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "decade":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._backwardNavHandler, this));
                    $('.e-current-year', this.sfCalendar).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "century":
                    $(calendarTable.find('.e-current-allyear')).on("click", $.proxy(this._onDepthSelectHandler, this));
                    break;
                case "month":
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }
        },
        _onDepthSelectHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if ($(e.target).hasClass("e-current-month"))
                this._dateValue = new Date(this._dateValue.setMonth(parseInt(e.target.attributes["data-index"].value)));
            else if ($(e.target).hasClass("e-current-year"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            else if ($(e.target).hasClass("e-current-allyear"))
                this._dateValue = new Date(this._dateValue.setFullYear(parseInt(e.target.innerHTML)));
            this._onSetCancelDateHandler(e);
        },

        _datepickerMonths: function (tbody, calendarTable, currentDate) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var month = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'))
                        .addClass('e-current-month e-state-default')
                        .attr({ 'data-index': month }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .html(this.Date.abbrMonthNames[month++]);
                    if (currentDate.getFullYear() < this.model.minDate.getFullYear() || currentDate.getFullYear() > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    else if ((currentDate.getFullYear() <= this.model.minDate.getFullYear() && month < this.model.minDate.getMonth() + 1) ||
                        (currentDate.getFullYear() >= this.model.maxDate.getFullYear() && month > this.model.maxDate.getMonth() + 1)) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-month');
                    }
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            var s = currentDate.getFullYear();
            this._checkArrows(s, s);
        },

        _datepickerYears: function (tbody, calendarTable, currentYear) {
            var dc = function (a) {
                return document.createElement(a);
            };
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 10) + 1);
            var years = [];
            for (var j = 0; j < 12; j++) {
                years.push(Year + j);
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(dc('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(dc('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-year-first e-current-year ');
                    else if (year == 11)
                        td.addClass('e-year-last e-current-year ');
                    else
                        td.addClass('e-current-year e-state-default');
                    if (years[year] < this.model.minDate.getFullYear() || years[year] > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-year');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
            this._checkArrows(years[0], years[years.length]);
        },

        _datepickerAllYears: function (tbody, calendarTable, currentYear) {
            var Year = parseInt(currentYear) - ((parseInt(currentYear) % 100) + 10);
            var headYear = Year;
            var years = [], newline = this._isIE8 || this._isIE9 ? "" : "\n";

            for (var j = 0; j < 12; j++) {
                years.push(parseInt(Year) + " -" + newline + parseInt(Year + 9));
                Year = Year + 10;
            }
            var year = 0;
            for (var i = 0; i < 3; i++) {
                var row = $(document.createElement('tr'));
                for (var j = 0; j < 4; j++) {
                    var td = $(document.createElement('td'));
                    td.attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    if (year == 0)
                        td.addClass('e-allyear-first e-current-allyear ');
                    else if (year == 11)
                        td.addClass('e-allyear-last e-current-allyear ');
                    else
                        td.addClass('e-current-allyear e-state-default');
                    if (parseInt(years[year].split('-\n')[1]) < this.model.minDate.getFullYear() || parseInt(years[year].split('-\n')[0]) > this.model.maxDate.getFullYear()) {
                        td.addClass('e-hidedate');
                        td.removeClass('e-current-allyear');
                    }
                    td.html(years[year++]);
                    row.append(td);
                }
                tbody.append(row);
            }
            calendarTable.append(tbody);
        },
        _renderHeader: function (dpObject) {
            var thead = $(document.createElement('thead'));
            var cultureObj = ej.preferredCulture(this.model.locale).calendars.standard.days;
            if (dpObject.model.dayHeaderFormat != "none") {
                var headRow = ej.buildTag("tr.e-week-header").attr({ 'role': 'row' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                if (this.model.weekNumber == true) {
                    var WeekCulture = ej.preferredCulture(this.model.locale).calendars.standard.week;
                    var day = WeekCulture.name;
                    var headerday;
                    if (dpObject.model.dayHeaderFormat == "short")
                        headerday = WeekCulture.nameAbbr;
                    else if (dpObject.model.dayHeaderFormat == "long") headerday = week;
                    else headerday = WeekCulture.nameShort;
                    var tr = ej.buildTag("th", "", {}, { 'scope': 'col', 'abbr': day, 'data-date': day, 'title': this._formatter(day, "dddd") }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .html(headerday);
                    headRow.append(tr);
                }
                for (var i = this.Date.firstDayOfWeek; i < this.Date.firstDayOfWeek + 7; i++) {
                    var weekday = i % 7;
                    var day = cultureObj.names[weekday];
                    var headerday;
                    if (dpObject.model.dayHeaderFormat == "short")
                        headerday = cultureObj.namesAbbr[weekday];
                    else if (dpObject.model.dayHeaderFormat == "long") headerday = day;
                    else headerday = cultureObj.namesShort[weekday];
                    var th = ej.buildTag("th", "", {}, { 'scope': 'col', 'abbr': day, 'data-date': day, 'title': this._formatter(day, "dddd"), 'class': (weekday == 0 || weekday == 6 ? 'e-week-end' : 'e-week-day') }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                            .html(headerday);
                    headRow.append(th);
                }
            };
            return thead.append(headRow);
        },

        _renderCalendar: function (dpObject, date) {
            var proxy = this, today;
            dpObject = $.extend({}, ej.DatePicker.prototype.defaults, dpObject);
            this.Date.firstDayOfWeek = this.model.startDay;
            if (date) today = date;
            else if (this._calendarDate) today = this._calendarDate;
            else today = proxy._zeroTime(new Date());
            var calendarTable = $('table', this.sfCalendar);
            calendarTable.empty();

            calendarTable.append(this._renderHeader(dpObject));

            var tbody = ej.buildTag('tbody.e-datepicker-allyears', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerAllYears(tbody, calendarTable, today.getFullYear());

            tbody = ej.buildTag("tbody.e-datepicker-years", "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._datepickerYears(tbody, calendarTable, today.getFullYear());
            var month = dpObject.model.month == undefined ? today.getMonth() : dpObject.model.month;
            var year = dpObject.model.year || today.getFullYear();
            var currentDate = (new Date(year, month, 1, 0, 0, 0));
            var firstDayOffset = this.Date.firstDayOfWeek - currentDate.getDay() + 1;
            if (firstDayOffset > 1) firstDayOffset -= 7;
            var weeksToDraw = Math.ceil(((-1 * firstDayOffset + 1) + this._getDaysInMonth(currentDate)) / 7);
            this._addDays(currentDate, (firstDayOffset - 1));
            var newdate = proxy._zeroTime(new Date());
            var selected = this._calendarDate;
            tbody = ej.buildTag('tbody.e-datepicker-months', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            this._datepickerMonths(tbody, calendarTable, today);

            tbody = ej.buildTag('tbody.e-datepicker-days', "", { 'display': 'none' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var w = 0, _first = true, _last = true;
            while (w++ < weeksToDraw) {
                var r = jQuery(document.createElement('tr')).attr({'role':'row'});
                if (this.model.weekNumber == true)
                {
                    var week = this._weekDate(currentDate);
                    week = $(document.createElement('td')).attr({}).addClass('e-weeknumber').html(week)
                    r.append(week);
                }
                for (var i = 0; i < 7; i++) {
                    var thisMonth = currentDate.getMonth() == month;
                    var checkSpecialDate = this._isSpecialDates(currentDate);
                    var disable = this._checkDisableRange(currentDate);
                    var index = this._getIndex;
                    var d = $(document.createElement('td')).
                        html(checkSpecialDate ? '<span></span>' + currentDate.getDate() : currentDate.getDate() + '')
                        .attr({

                            'data-date': currentDate.toDateString(),
                            'title': (this.model.showTooltip ? (checkSpecialDate && this.model.specialDates[index][this._mapField._tooltip] ? this.model.specialDates[index][this._mapField._tooltip] : this._formatter(currentDate, this.model.tooltipFormat)) : ''),
                            'aria-selected': false,
                            'role': 'gridcell'
                        }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                        .addClass((thisMonth ? 'current-month e-state-default ' : 'other-month e-state-default ') +
                            (this._isWeekend(currentDate) ? (this._ejHLWeekEnd ? 'e-dp-weekend e-week-end ' : (this.model.highlightWeekend ? 'e-week-end ' : '')) : 'e-week-day ') +
                            (thisMonth && currentDate.getTime() == newdate.getTime() ? 'today ' : ''));

                    d.find('span:first-of-type').addClass((checkSpecialDate ? (this.model.specialDates[index][this._mapField._icon] ? 'e-special-date-icon ' + this.model.specialDates[index][this._mapField._icon] + ' ' : 'e-special-day') : ''));
                    d.addClass(checkSpecialDate ? (this.model.specialDates[index][this._mapField._custom] ? this.model.specialDates[index][this._mapField._custom] : '') : '');
                    if (disable) this._disableDates({ date: currentDate, element: d });
                    if (selected.getTime() == currentDate.getTime() && thisMonth) {
                        if (!d.hasClass('e-hidedate'))
                            if (this.model.value) {
                                d.addClass('e-active').attr({ 'aria-selected': true });
                                if (this.model.highlightSection == "week") {
                                    r.addClass('e-selected-week');
                                }
                                if (this.model.highlightSection == "month") {
                                    tbody.addClass('e-selected-month');
                                }
                                if (this.model.highlightSection == "workdays") {
                                    r.addClass('e-work-week');
                                }
                            }
                            else { if(this.model.value!=null)d.addClass('e-state-hover').attr({ 'aria-selected': false }); }
                        if (!this._hoverDate) {
                            if (!d.hasClass('e-hidedate')) d.addClass('e-state-hover');
                            this._hoverDate = currentDate.getDate() - 1;
                        }
                    }
                    var cond = true;
                    if (currentDate < this.model.minDate || currentDate > this.model.maxDate) {
                        d.addClass('e-hidedate');
                        d.removeClass('current-month');
                        if (this.model.showOtherMonths) d.removeClass('other-month');
                        cond = _last = false;
                    }
                    if (thisMonth) {
                        if (cond && _first) {
                            this._tempMinDate = currentDate;
                            _first = false; _last = true;
                        }
                        if (_last) this._tempMaxDate = currentDate;
                    }
                    this._trigger("beforeDateCreate", { date: currentDate, value: this._formatter(currentDate, this.model.dateFormat), element: d });
                    r.append(d);
                    currentDate = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() + 1, 0, 0, 0);
                }
                tbody.append(r);
            }
            calendarTable.append(tbody);
            if (this._DRPdisableFade) {
                $(tbody).css("display", "block");
                $(tbody).css({ display: "table-row-group", "vertical-align": "middle", "border-color": "inherit" });
            }
            else {
                (this._isIE8 || this._isIE7) ? $(tbody).css("display", "block") : $(tbody).fadeIn("fast");
            }
            if (this.model.startLevel === this.model.depthLevel)
                this._depthLevel(this.model.depthLevel);
            else if (this.model.depthLevel != "month" && this.model.depthLevel != "") {
                if (this.model.startLevel == "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else if (this.model.startLevel == "year" && this.model.depthLevel != "decade" && this.model.depthLevel != "century")
                    this._depthLevel(this.model.depthLevel);
                else {
                    this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                    this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
                }
            }
            else {
                this._on(calendarTable.find('.current-month,.other-month,.e-current-month,.e-current-year,.e-current-allyear'), "click", $.proxy(this._backwardNavHandler, this));
                this._on(calendarTable.find('.current-month , .other-month'), "click", $.proxy(this._onSetCancelDateHandler, this));
            }

            this._otherMonthsVisibility();
            this._checkDateArrows();
        },

        _checkDisableRange: function (value) {
            if (!ej.isNullOrUndefined(this._disableCollection[value.getFullYear()]))
                if (jQuery.inArray(value.getMonth(), this._disableCollection[value.getFullYear()]) !== -1)
                    return true;
            return false;
        },
        _initDisableObj: function (disableDates) {
            this._disableCollection = {};
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj) {
                    var year = dateObj.getFullYear();
                    var month = dateObj.getMonth();
                    if (ej.isNullOrUndefined(this._disableCollection[year])) this._disableCollection[year] = [];
                    if (jQuery.inArray(month, this._disableCollection[year]) == -1) this._disableCollection[year].push(month);
                }
            }
        },

        _disableDates: function (args) {
            for (var i = 0; i < this.model.blackoutDates.length; i++) {
                var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                if (dateObj && +args.date === +dateObj)
                    args.element.removeClass('current-month').addClass('e-hidedate');
            }
        },

        _keyboardNavigation: function (e) {
            if (this._animating) return false;
            if ((this._isOpen) && (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                if (e.altKey) { if (e.keyCode == 13) { this._setCurrDate(e); return false; } else return; }
                var t = { row: null, col: null };

                t.col = this.sfCalendar.find('tbody tr td.e-state-hover').index();
                t.row = this.sfCalendar.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this.sfCalendar.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this.sfCalendar.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this.sfCalendar.find('table')[0].className, next, rowLength = 3, colLength = 4;
                switch (tableClass) {
                    case "e-dp-viewallyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "yearall", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverAllYear = this.sfCalendar.find('tbody.e-datepicker-allyears tr td').index(next);
                        break;
                    case "e-dp-viewyears":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "year", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverYear = this.sfCalendar.find('tbody.e-datepicker-years tr td').index(next);
                        break;
                    case "e-dp-viewmonths":
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "month", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverMonth = this.sfCalendar.find('tbody.e-datepicker-months tr td').index(next);
                        break;
                    case "e-dp-viewdays":
                        rowLength = this.sfCalendar.find('tbody.e-datepicker-days tr').length, colLength = 7;
                        next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "day", e.ctrlKey);
                        if (!e.ctrlKey) this._hoverDate = this._getDateObj(next).getDate() - 1;
                        break;
                }
                if (!e.ctrlKey) {
                    this.sfCalendar.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
            else if (!this.model.displayInline && (e.keyCode == 27 || e.keyCode == 9)) { this.hide(); }
            else if (e.altKey && e.keyCode == 40) { this.show(); return false; }
        },
        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, cls = { parent: null, child: null };
            switch (target) {
                case "day": eleClass = "tbody.e-datepicker-days tr td.current-month";
                    cls.parent = ".e-datepicker-days", cls.child = ".current-month";
                    break;
                case "month": eleClass = "tbody.e-datepicker-months tr td.e-current-month";
                    cls.parent = ".e-datepicker-months", cls.child = ".e-current-month";
                    break;
                case "year": eleClass = "tbody.e-datepicker-years tr td.e-current-year";
                    cls.parent = ".e-datepicker-years", cls.child = ".e-current-year";
                    break;
                case "yearall": eleClass = "tbody.e-datepicker-allyears tr td.e-current-allyear";
                    cls.parent = ".e-datepicker-allyears", cls.child = ".e-current-allyear";
                    break;
            }
            if (t.row <= 0 && t.col <= 0)
                return this.sfCalendar.find(eleClass + ':first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return this.sfCalendar.find(eleClass + ':first');
                case 35:
                    return this.sfCalendar.find(eleClass + ':last');
                case 38:
                    if (ctrlKey && this.model.allowDrillDown) {
                        this._forwardNavHandler();
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrevDate(true);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                    }
                    else {
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(true);
                        cell = this.sfCalendar.find(eleClass + ':last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrevDate(false);
                        return this.sfCalendar.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                        return cell;
                    }
                    cell = this._getCell(t, cls);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right");
                        if (cell !== null) return cell;
                        this._processNextPrevDate(false);
                        cell = this.sfCalendar.find(eleClass + ':first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down");
                            if (cell !== null) return cell;
                            this._processNextPrevDate(false);
                            cell = this.sfCalendar.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var tclassName = $("table", this.sfCalendar).get(0).className, ele, element;
                    ele = this._getCell(t, cls); element = $(ele)[0];
                    if (tclassName == "e-dp-viewmonths" && this.model.startLevel == "year" && this.model.depthLevel == "year") {
                        this._dateValue = new Date(this._dateValue.setMonth(parseInt(element.attributes["data-index"].value)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if ((tclassName == "e-dp-viewyears" && this.model.startLevel == "decade" && this.model.depthLevel == "decade") ||
                        (tclassName == "e-dp-viewallyears" && this.model.startLevel == "century" && this.model.depthLevel == "century")) {
                        this._dateValue = new Date(this._dateValue.setFullYear(parseInt(element.innerHTML)));
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else if (tclassName == "e-dp-viewdays") {
                        this._backwardNavHandler(ele);
                        this._onSetCancelDateHandler({ type: null, target: ele });
                    }
                    else
                        this._backwardNavHandler(ele);
                    break;
            }
            return this._getCell(t, cls);
        },
        _findVisible: function (t, cls, key) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                nextElement = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-hidedate') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > this.sfCalendar.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass('other-month')) {
                    return null;
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    return nextElement;
                }
            }
        },
        _getCell: function (t, cls) {
            return this.sfCalendar.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child + ':nth-child(' + t.col + ')');
        },
        _getDateObj: function (element) {
            return new Date(element.attr("data-date"));
        },
        _touchCalendar: function (e) {
            var tableClass = this.sfCalendar.find('table')[0].className;
            switch (e.type) {
                case "pinchin":
                    if (tableClass != "e-dp-viewdays")
                        this._keyboardNavigation({ keyCode: 13 });
                    break;
                case "pinchout":
                    if (tableClass != "e-dp-viewallyears" && this.model.allowDrillDown)
                        this._forwardNavHandler();
                    break;
                case "swipeleft":
                    this._processNextPrevDate(false);
                    break;
                case "swiperight":
                    this._processNextPrevDate(true);
                    break;
            }
        },

        show: function (e) {
            if (ej.isNullOrUndefined(this.sfCalendar)) this._renderPopup();
            if (this._isOpen) return false;
            var proxy = this;
            this._popupOpen = true;
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            if (!this.model.enabled) return;
            if (!this.model.displayInline) this._setDatePickerPosition();
            if (this._trigger("beforeOpen", { element: this.sfCalendar, events: e })) return false;
            this.sfCalendar.attr({ 'aria-hidden': 'false' });
            proxy._isOpen = true;
            this.sfCalendar.slideDown(this.model.enableAnimation ? this.animation.open.duration : 0, function () {
                if (proxy.model && !proxy.model.displayInline)
                    $(document).on("mousedown", $.proxy(proxy._onDocumentClick, proxy));
            });
            if (this._isIE8) {
                if (this.element.val() && this._compareDate(new Date(this.element.val()), previous)) this._updateInputVal();
            }
            else this._updateInputVal();
            this._refreshLevel(previous);
            this._trigger("open", { prevDate: previous, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline) {
              this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
              this._on(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
			}
            this._isInputBox && this.wrapper.addClass("e-active");
        },


        hide: function (e) {
            if (!this._isOpen || this._getInternalEvents) return false;
            if (this._trigger("beforeClose", { element: this.sfCalendar, events: e })) return false;
            var proxy = this;
            this._popupOpen = false;
            this.sfCalendar.attr({ 'aria-hidden': 'true' });
            if (this._popClose && e != undefined && e.type != "click") {
                return;
            }
            this.sfCalendar.slideUp(this.model.enableAnimation ? this.animation.close.duration : 0, function () {
                proxy._isOpen = false;
                $(document).off("mousedown", $.proxy(proxy._onDocumentClick, proxy));
                proxy._setWaterMark();
            });
            if (this.element.val() != "") this._validateInputVal();
            this._trigger("close", { prevDate: this._prevDate, date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            this._off(ej.getScrollableParents(this.wrapper), "touchmove", this.hide);
            this._isInputBox && this.wrapper.removeClass("e-active");
        },


        enable: function () {
            this.model.enabled = true;
            this.wrapper && this.wrapper.removeClass('e-disable');
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this.element.prop("disabled", false);
            if (this.dateIcon) this.dateIcon.removeClass('e-disable').attr({ "aria-disabled": false });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().removeClass("e-disable");
            this.element.prop("disabled", false);
            if (!this._isSupport)
                this._hiddenInput.prop("disabled", false);
            this.sfCalendar && this.sfCalendar.removeClass('e-disable').attr({ "aria-disabled": false });
        },


        disable: function () {
            this.model.enabled = false;
            this.wrapper && this.wrapper.addClass('e-disable');
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this.element.attr("disabled", "disabled");
            if (this.dateIcon) this.dateIcon.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isIE8 && this.dateIcon) this.dateIcon.children().addClass("e-disable");
            this.element.attr("disabled", "disabled");
            if (!this._isSupport)
                this._hiddenInput.attr("disabled", "disabled");
            this.sfCalendar && this.sfCalendar.addClass('e-disable').attr({ "aria-disabled": true });
            if (this._isOpen) {
                if (this.element.is(':input')) this.element.blur();
                if (!this.model.displayInline) this.hide();
            }
        },

        getValue: function () { return this._formatter(this.model.value, this.model.dateFormat); },

        _wireCalendarEvents: function () {
            this._allowQuickPick(this.model.allowDrillDown);
            this._on($('.e-next', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            this._on($('.e-prev', this.sfCalendar), "click", $.proxy(this._previousNextHandler, this));
            if (!this.model.displayInline) {
                this.sfCalendar.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
                this.sfCalendar.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));
            }
            if (this.model.showFooter)
                this._on($('.e-footer', this.sfCalendar), "click", this._setCurrDate);
            this.sfCalendar && this._on(this.sfCalendar, "pinchin pinchout swipeleft swiperight", $.proxy(this._touchCalendar, this));
        },

        _wireEvents: function () {
            if (this.element.is(":input") && (this.model.allowEdit)) {
                this._on(this.element, "blur", this._onFocusOut);
                this._on(this.element, "focus", this._onFocusIn);
                this._on(this.element, "keydown", this._onKeyDown);
            }

            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showDatePopUp, this));
            }
        },
        _bindDateButton: function () {
            this._on(this.dateIcon, "mousedown", this._showDatePopUp);
            if (this.model.allowEdit)
                this.element.off("mousedown", $.proxy(this._showDatePopUp, this));
        },
        _bindInputEvent: function () {
            this._off(this.dateIcon, "mousedown", this._showDatePopUp);
        },

        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },

        _onFocusOut: function (e) {
            this._isFocused = false;
            var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
            this._validateOnFocusOut(this._validateValue(), e);
            this.wrapper.removeClass("e-focus");
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
            if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
            if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
            this.element.off("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            var _currentVal = this.element.val();
            var data = { prevDate: this._prevDate, value: _currentVal };
            if (this._specificFormat()) {
                if (this._prevDate != _currentVal)
                    this._setDateValue(_currentVal, true);
            }
            else
                this._setDateValue(_currentVal);
            if (!this.model.value) this._clearSelected();
            this._trigger("focusOut", data);
            this._checkErrorClass();
        },
        _onFocusIn: function (e) {
            if (this._isSupport) {
                e.preventDefault();
                this._isFocused = true;
            }
            this.wrapper.removeClass('e-error');
            this.isValidState = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.addClass('e-valid');
            if (this.model.readOnly)
                return;
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this.element.on("keydown", $.proxy(this._keyboardNavigation, this));
            if (!this.model.showPopupButton && !this.model.readOnly) this.show(e);
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            this._trigger("focusIn", { date: this.model.value, value: this._formatter(this.model.value, this.model.dateFormat) });
        },
        _elementClick: function (e) {
            if (!this._popupOpen) this.show(e);
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport)
                this._hiddenInput.css("display", "none");
        },
        _refreshPopup: function () {
            this._refreshDatepicker();
            this._startLevel(this.model.startLevel);
        },
        _weekDate: function (currentDate) {
            var time, checkDate = new Date(currentDate.getTime());
            checkDate.setDate(checkDate.getDate() + 4 - (checkDate.getDay() || 7));
            time = checkDate.getTime();
            checkDate.setMonth(0);
            checkDate.setDate(1);
            return Math.floor(Math.round((time - checkDate) / 86400000) / 7) + 1;

        },
        _refreshLevel: function (previous) {
            if ((this.model.startLevel == this.model.depthLevel) && this.model.startLevel != "month") {
                var val = this._stringToObject(this.element.val());
                val = this._validateYearValue(val);
                if (val)
                    if (!this._compareDate(previous, val))
                        this._refreshPopup();
            }
        },
        _validateOnFocusOut: function (val, e) {
            var dateVal = this._preValue != null ? this._calendarDate : this._preValue;
            var calenderDate = this._formatter(dateVal, this.model.dateFormat);
            if (this._specificFormat() && (val > this.model.minDate) && (val < this.model.maxDate)) {
                if (val == null) this.model.value = dateVal
                else {
                    this.model.value = val;
                    var currDate = this._formatter(val, this.model.dateFormat, this.model.locale);
                }
            }
            else var currDate = this._formatter(this._parseDate((this._formatter(new Date(), "MM/dd/yyyy"))), this.model.dateFormat);
            var dateChange = false, valueExceed = false;
            if (val != null && !this.model.enableStrictMode) {
                if (ej.isNullOrUndefined(this.model.value))
                    this.model.value = this._parseDate(this.element.val());
                if (this.model.maxDate < this.model.minDate) this.model.minDate = this.model.maxDate;
                if (!this.model.enableStrictMode) {
                    if (val) {
                        if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                            dateChange = true,
                            this._calendarDate = val = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                        }
                    }
                    else {
                        this.element.val("");
                        if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                        else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                    }
                    this.isValidState = true;
                }
                if (dateChange) this.element.val(this._formatter(val, this.model.dateFormat));
                if (!this._compareDate(this._preValue, this._parseDate(this.element.val(), true))) this._triggerChangeEvent(e);
            }
            else if (val == null && !this.model.enableStrictMode) {
                if (this._preTxtValue == null || this.element.val() == "") {
                    this.element.val("");
                    if (!this._isSupport) this._hiddenInput.css("display", "block");
                } else
                    this.element.val(calenderDate);
                this._triggerChangeEvent(e);
            }
            else {
                if (val) {
                    if ((val < this.model.minDate) || (val > this.model.maxDate)) {
                        this.isValidState = false, valueExceed = true,
                        this._calendarDate = val < this.model.minDate ? this.model.minDate : this.model.maxDate
                    }
                    else
                        this.isValidState = true;
                    this._triggerChangeEvent(e);
                    if (valueExceed && this._getInternalEvents) this._trigger("outOfRange");
                }
                else {
                    this.isValidState = false;
                    if (this._calendarDate < this.model.minDate) this._calendarDate = this.model.minDate;
                    else if (this._calendarDate > this.model.maxDate) this._calendarDate = this.model.maxDate;
                }
            }
        },
        _onKeyDown: function (e) {
            if (e.keyCode === 13) {
                var previous = this._preValue != null ? new Date(this._preValue.toString()) : this._preValue;
                this._validateOnFocusOut(this._validateValue(), e);
                if ((!this._isOpen || this.model.displayInline) && !this._setWaterMark() && !this._compareDate(this._preValue, this._parseDate(this.element.val(), this.model.dateFormat))) this._updateInputVal();
                if ((!this._isOpen || this.model.displayInline)) this._refreshLevel(previous);
                if (this.element.val() != "" && (!this._isOpen || this.model.displayInline)) { this._validateInputVal(); }
                this._checkErrorClass();
            }
        },
        _showhidePopup: function (e) {
            if (!this.model.enabled) return false;
            if (this._isOpen) {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                if (!this._cancelValue) this.hide(e);
            }
            else {
                if (!this._isFocused && this.element.is(':input') && (!ej.isTouchDevice())) this.element.focus();
                this.show(e);
            }
        },
        _compareDate: function (first, second) {
            var result = (+first === +second) ? true : false;
            return result;
        },
        _validateDate: function (val) {
            var result = true;
            if (val != null) {
                for (var i = 0; i < this.model.blackoutDates.length; i++) {
                    var dateObj = this._checkInstanceType(this.model.blackoutDates[i]);
                    if (dateObj && +val === +dateObj)
                        result = false;
                }
                if ((val < this.model.minDate || val > this.model.maxDate) && this.model.enableStrictMode) {
                    result = false;
                    this.isValidState = false;
                }
            }

            return result;
        },

        _triggerChangeEvent: function (e) {
            var currentValue;
            var _currentVal = this.element.val() == "" ? null : this.element.val();
            this._prevDate = this._formatter(this._preValue, this.model.dateFormat);
            var data = { prevDate: this._prevDate, value: _currentVal, isInteraction: !!e };
            if (this._specificFormat() && e != undefined && e.type == "keydown" && this._formatter(this._preValue, this.model.dateFormat, this.model.locale) != this.element.val())
                currentValue = this._parseDate(this.element.val(), true);
            else if ((this._specificFormat() && e != undefined && e.type == "blur"))
                currentValue = this.model.value;
            else currentValue = this._parseDate(_currentVal);
            currentValue = this._validateYearValue(currentValue);
            if (!this._validateDate(currentValue)) currentValue = null;
            if (!this._compareDate(this._preValue, currentValue)) {
                this._preValue = this.model.value = currentValue;
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                if (this.model.value) this._clickedDate = this._calendarDate = this.model.value;
                if (this.model.displayInline && !this._isInputBox) this._hiddenInput.attr('value', _currentVal);
                if (!this.model.value && !this.model.enableStrictMode) this._setDateValue(this.model.value);
                data.value = _currentVal;
                this._trigger("_change", data);
                data.value = this._formatter(this.model.value, this.model.dateFormat);
                this._trigger("change", data);
                this._checkErrorClass();
            }
            else if (!(this.element.val() == "" && this._prevDate == null) && this.element.val() != this._prevDate) {
                data.value = this.element.val();
                this._trigger("_change", data);
            }
        },

        _triggerSelectEvent: function (e) {
            var val = this.element.val();
            if (this._parseDate(val)) {
                var data = { prevDate: this._prevDate, date: this.model.value, value: val, isSpecialDay: this._isSpecialDates(this.model.value) };
                if (this._prevDate != val) {
                    if (this._parseDate(data.value) && (this.model.value >= this.model.minDate && this.model.value <= this.model.maxDate)) {
                        this._cancelValue = this._trigger("select", data);
                    }
                }
                if (this._dt_drilldown) this._trigger("dt_drilldown", data);
            }
        },

        _onDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datewidget").is(this.wrapper)) {
                    this.hide(e);
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-popup").is(this.popup)) {
                    e.preventDefault();
                }
            }
        },

        _OnWindowResize: function (e) {
            if (this.sfCalendar) this._setDatePickerPosition();
        },

        _showDatePopUp: function (e) {
            var isRightClick = false;
            if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            if (isRightClick) return;
            if (!this._isSupport && !this.model.showPopupButton) {
                e.preventDefault();
                this._onFocusIn();
            }
            if (this.model.readOnly) return;
            e.preventDefault();
            if (!this.model.enabled && this.model.displayInline) return false;
            this._showhidePopup(e);
        },
        _layoutChanged: function (e) {
            // this event internally used to observe the layout change in "DateTimePicker" control
            if (this._getInternalEvents) this._trigger("layoutChange");
        },
        _setCurrDate: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e) e.preventDefault();
            var proxy = this;
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._dateValue = this._zeroTime(new Date());
            this.model.value = this._calendarDate = new Date(this._dateValue.toString());
            this._setDateValue(this.model.value);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._refreshDatepicker();
            this._changeDayClass();
            this._startLevel(this.model.startLevel);
            this._onSetCancelDateHandler(e);
            this._layoutChanged();
        },
        _changeDayClass: function () {
            var className = this.popup.children("table")[0].className;
            if (className != "e-dp-viewdays") {
                this.popup.children("table").removeClass(className).addClass("e-dp-viewdays");
            }
        },

        _onSetCancelDateHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && ($(e.target).hasClass("e-disable") || $(e.target).hasClass("e-hidedate"))) return false;
            if (e && e.type) e.preventDefault();
            if (this._specificFormat()) this._prevDate = this.element.val();
            else this.model.value = this._parseDate(this.element.val());
            this._prevDate = this._formatter(this.model.value, this.model.dateFormat);
            this._setDateValue(this._dateValue);
            this._triggerSelectEvent(e);
            this._triggerChangeEvent(e);
            this._dateValue = (this.model.value == null)? null:new Date(this.model.value.toString());
            if (this.element.is(':input') && !this.model.displayInline) {
                this._showhidePopup(e);
            }
            if (e && $(e.currentTarget).hasClass("other-month"))
                this._refreshDatepicker();
            this._cellSelection();
        },
        _closeCalendar: function (ele) {
            if (!ele || ele == this.element) {
                this.sfCalendar.empty().remove();
            }
        },
        //Error class for input value validation
        _checkErrorClass: function () {
            if (this.wrapper) {
                if (this.isValidState) this.wrapper.removeClass("e-error");
                else this.wrapper.addClass("e-error");
            }
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DatePicker.Locale = ej.DatePicker.Locale || {};

    ej.DatePicker.Locale['default'] = ej.DatePicker.Locale['en-US'] = {
        watermarkText: "Select date",
        buttonText: 'Today'
    };


    ej.DatePicker.Header = {
        /**  Removes the day header */
        None: "none",
        /**  Shows the day header format in short like Sun, Mon, Tue … */
        Short: "short",
        /**  Shows the day header format in min like Su, Mo, Tu … */
        Min: "min",
        /**  Shows the day header format in long like Sunday, Monday, Tuesday … */
        Long: "long"
    };

    ej.DatePicker.HighlightSection = {
        /**  Highlight the Current Month. */
        Month: "month",
        /**  Highlight the Current Week. */
        Week: "week",
        /**  Highlight the Current WorkDays. */
        WorkDays: "workdays",
        /** Don't Highlight Anything. */
        None: "none"
    };


    ej.DatePicker.Level = {
        /**  Starts from month level view. */
        Month: "month",
        /**  Starts from year level view. */
        Year: "year",
        /**  Starts from year decade level view. */
        Decade: "decade",
        /**  Starts from century level view.  */
        Century: "century"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html CheckBox elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejCheckBox", "ej.CheckBox", {
        _rootCSS: "e-checkbox",

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["checked", "checkState"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            id: null,

            name: null,

            value: null,

            htmlAttributes: {},

            checked: false,

            enabled: true,

            enableTriState: false,

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            idPrefix: "ej",

            size: "small",

            checkState: "uncheck",

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            enableTriState: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },
        observables: ["checked", "checkState"],
        checked: ej.util.valueFunction("checked"),
        checkState: ej.util.valueFunction("checkState"),

        _init: function (options) {
            this._cloneElement = this.element.clone();
            var browserInfo = ej.browserInfo();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._isIE9 = (browserInfo.name == 'msie' && browserInfo.version == '9.0') ? true : false;
            this._isDevice = this._checkDevice();
            this._setValue();
            this._renderControl();
            this.model.enableRTL && this._setRTL();
            if (this.model.enabled)
                this._wireEvents();
            this._setEnabled(this.model.enabled);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._addAttr(this.model.htmlAttributes);
            if (this._isIE9 || this._isIE8) {
                // In IE8 and IE9, the text of the checkox will float to next line while the length of the text is high fixed this by adding the following class and procssed with CSS
                this.wrapper.addClass("e-tb-cell");
            }
        },
        _checkDevice: function () {
            return (ej.isDevice() && ej.isTouchDevice());
        },
        _setRTL: function () {
            $(this.maindiv).addClass("e-rtl");
        },
        _initValidator: function () {
            (!this.wrapper.closest("form").data("validator")) && this.wrapper.closest("form").validate();
        },
        _setValidation: function () {
            this.wrapper.find('input').rules("add", this.model.validationRules);
            var validator = this.wrapper.closest("form").data("validator");
            validator = validator ? validator : this.wrapper.closest("form").validate();
            name = this.wrapper.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "name") proxy.element.attr(key, value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._setEnabled(false);
                else if (key == "checked" && value == "checked") {
                    if (proxy.checked() instanceof Array)
                        proxy._updateCheckedItem();
                    else
                        proxy._checked(true);
                }
                else proxy.wrapper.attr(key, value);
            });
        },

        _triggerBeforeChange: function () {
            var data = { isChecked: this._isChecked, isInteraction: false };
            if (true == this._trigger("beforeChange", data)) return false;
        },

        _triggerChange: function () {
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: false };
            this._trigger("change", data);
        },

        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "checked":
                        $(this.maindiv).removeClass("e-material-animate");
                        if (this.model.beforeChange) this._triggerBeforeChange();
                        if (this.checked() instanceof Array) {
                            var checkedItemArray = ej.util.getVal(options[prop]);
                            var lastVal = checkedItemArray[checkedItemArray.length - 1];
                            if (this.model.value == lastVal) this._isChecked = true;
                        }
                        else {
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checked(this._isChecked);
                        }
                        this._isChecked ? this._checked() : this._unChecked();
                        if (this.model.change) this._triggerChange();
                        break;
                    case "enableTriState":
                        if (options[prop]) {
                            this.model.enableTriState = options[prop];
                            this._indeterminateState = options[prop];
                        }
                        break;
                    case "checkState":
                        if (this.model.enableTriState) {
                            if (this.model.beforeChange) this._triggerBeforeChange();
                            this._isChecked = ej.util.getVal(options[prop]);
                            this.checkState(this._isChecked);
                            this._changeState(this._isChecked);
                            this._setCheckBoxState();
                            this.checked(this._isChecked);
                            if (this.model.checkState == "indeterminate")
                                this._setIndeterminate(this._indeterminateState);
                            if (this.checked() instanceof Array)
                                this._updateCheckedItem();
                            else if (options[prop] == "check") this._hiddenInput.removeAttribute("name");
                            else this._hiddenInput.setAttribute("name", this.model.name);
                            if (this.model.change) {
                                if (!(this.checked() instanceof Array)) this._isChecked = this.checkState() == "uncheck" ? false : true;
                                this._triggerChange();
                            }
                        }
                        break;
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        (options[prop]) ? this._setRTL() : $(this.maindiv).removeClass("e-rtl");
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.wrapper.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
					this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                         break;
					case "validationMessages":
					  this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.element.attr('name', options[prop]);
                        if (!this._isChecked || this.spanImg.hasClass("e-chk-indeter")) this._hiddenInput.setAttribute('name', options[prop]);
                        this.model.name = options[prop];
                        break;
                    case "value": this.element.attr('value', options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[prop]); break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.element.removeClass("e-checkbox e-input");
            !this._cloneElement.attr("name") && this.element.attr("name") && this.element.removeAttr("name");
            !this._cloneElement.attr("value") && this.element.attr("value") && this.element.removeAttr("value");
            this.element.insertBefore(this.wrapper);
            this.wrapper.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.wrapper.removeClass(this.model.cssClass).addClass(skin);
                $("#" + this.model.idPrefix + this.model.id + "_wrapper").removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            this._indeterminateState = false;
            this._isChecked = false;
            var _id = this.element[0].getAttribute("id"), _name = this.element[0].getAttribute('name'), _value = this.element[0].getAttribute('value');
            !ej.isNullOrUndefined(_id) && (this.model.id = _id);
            !ej.isNullOrUndefined(_name) && (this.model.name = _name);
            if (!ej.isNullOrUndefined(_value) && _value != "") this.model.value = _value;
            if (!this.checked() && !ej.isNullOrUndefined(this.element.attr('checked'))) this._isChecked = true;
            ej.isNullOrUndefined(this.model.name) && (this.model.name = this.model.id);
            this.model.enabled = this.model.enabled && !this.element.attr("disabled");
        },

        _setSize: function (val) {
            if (val == ej.CheckboxSize.Medium) {
                $(this.innerdiv).removeClass('e-chkbox-small').addClass('e-chkbox-medium');
                $(this.maindiv).removeClass('e-check-small').addClass('e-check-medium');
				
			}
            else {
                $(this.innerdiv).removeClass('e-chkbox-medium').addClass('e-chkbox-small');
				$(this.maindiv).removeClass('e-check-medium').addClass('e-check-small');
			}
        },

        _setRoundedCorner: function (val) {
            if (val)
                this.span.addClass("e-corner");
            else
                this.span.removeClass("e-corner");
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },
        _setCheckBoxState: function () {
            if (this.model.enableTriState) {
                if (this.checkState() == "indeterminate")
                    this._indeterminateState = true;
                else if (this.checkState() == "check")
                    this._isChecked = true;
                else if (this.checkState() == "uncheck")
                    this._isChecked = false;
            }
            else if (this.checkState() == "indeterminate")
                this.checkState("uncheck");
        },
        _createElement: function (tagName, attrs) {
            var ele = document.createElement(tagName);
            this._setAttributes(ele, attrs);
            return ele;
        },
        _setAttributes: function (ele, attrs) {
            for (var key in attrs) {
                ele.setAttribute(key, attrs[key]);
            }
        },
        _renderControl: function () {
            this._setCheckBoxState();
            this.maindiv = this._createElement("span", { "class": "e-chkbox-wrap e-widget " + this.model.cssClass, "role": "checkbox", tabindex: 0 });
            if (this._isValid(this.model.id)) {
                this.maindiv.setAttribute("id", this.model.idPrefix + this.model.id);
                this.element[0].setAttribute("id", this.model.id);
            }
            this.innerdiv = document.createElement("div");
            this._setSize(this.model.size);
            this.span = document.createElement("span");
            this.span = $(this.span);
            this.spanImg = this._createElement("span", { "class": "e-chk-image e-icon", "role": "presentation" });
            this.spanImg = $(this.spanImg);
            this.element.addClass("e-input");
            this.model.name = ej.isNullOrUndefined(this.model.name) ? this.model.id : this.model.name;
            this._setAttributes(this.element[0], { "name": this.model.name, "value": this.model.value });
            var hiddenEl = $("#" + this._id + "_hidden")
            // hidden input element will be generated in MVC wrapper
            this._hiddenInput = hiddenEl.length ? hiddenEl[0] : this._createElement("input", { type: "checkbox", value: false, style: "display:none" });
            this._isValid(this.model.name) && this._hiddenInput.setAttribute("id", this.model.name + "_hidden");

            this._setRoundedCorner(this.model.showRoundedCorner);
            if (this.checked())
                this._setCheckedItem(this.checked());
            if (this._isChecked) {
                this.spanImg.addClass("e-checkmark");
                this.span.addClass("e-chk-act");
                this.maindiv.setAttribute("aria-checked", true);
                this.element.attr("checked", "checked")
            }
            else {
                this.span.addClass("e-chk-inact");
                this.maindiv.setAttribute("aria-checked", false);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            if (!(this.checked() instanceof Array))
                this.checked(this._isChecked);
            this.span[0].appendChild(this.spanImg[0]);
            this.innerdiv.appendChild(this.span[0]);
            this.element[0].parentNode && this.element[0].parentNode.insertBefore(this.maindiv, this.element[0]);
            this.maindiv.appendChild(this.element[0]);
            this.maindiv.appendChild(this._hiddenInput);
            this.maindiv.appendChild(this.innerdiv);
            this.wrapper = $(this.maindiv);
            this._setTextWrapper(this.model.text);
            this.chkbx = this.element;
            if (this.model.enableTriState == true && this._indeterminateState == true)
                this._setIndeterminate(this._indeterminateState);
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
        },
        _changeState: function (state) {
            if (state == "indeterminate") {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                if (!(this.checked() instanceof Array))
                    this.checked(null);
            }
            else if (state == "check") {
                this.spanImg.removeClass("e-stop").addClass("e-checkmark");
                this.span.removeClass("e-chk-act e-chk-inact e-chk-indeter").addClass("e-chk-act");
                this.wrapper[0].setAttribute("aria-checked", true);
            }
            else if (state == "uncheck") {
                this.spanImg.removeClass("e-checkmark e-stop");
                this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
                this.wrapper[0].setAttribute("aria-checked", false);
            }
        },

        _setIndeterminate: function (indeter) {
            if (indeter) {
                this.spanImg.removeClass("e-checkmark").addClass("e-stop");
                this.span.removeClass("e-chk-act e-chk-inact").addClass("e-chk-indeter");
                this.wrapper[0].setAttribute("aria-checked", "mixed");
                this.wrapper.find('input').prop('enableTriState', true);
                this.checkState("indeterminate");
                if (!(this.checked() instanceof Array))
                    this.checked(null);
                this._hiddenInput.setAttribute("name", this.model.name);
            }
            else {
                this.span.removeClass("e-chk-indeter");
                this.spanImg.removeClass("e-stop");
                this.wrapper.find('input').removeAttr('enableTriState');
                this.wrapper.find('input').prop('enableTriState', false);
                if (this.checked())
                    this._checked();
                else
                    this._unChecked();
            }
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.wrapper.append(this.txtSpan);
                this.model.enableRTL && this._setRTL();
            }
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            this.element[0].setAttribute('id', val);
        },

        _isValid: function (value) {
            return (!ej.isNullOrUndefined(value) && value != "") ? true : false;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "click", this._checkedHandler);
            if (this._isIE8) {
                this._isValid(this.model.id) && this._on($("label[for=" + this.model.id + "]"), "click", function () { this.wrapper.click(); });
            }
            this._on(this.wrapper, "focus", this._focusIn);
            this._on(this.wrapper, "focusout", this._focusOut);
        },


        _unWireEvents: function () {
            this._off(this.wrapper, (this._isDevice && $.isFunction($.fn.tap)) ? "tap" : "click");
            if (this._isIE8) {
                this._isValid(this.model.id) && this._off($("label[for=" + this.model.id + "]"), "click");
            }
            this._off(this.wrapper, "focus");
            this._off(this.wrapper, "focusout");
        },
        _focusIn: function (evt) {
            $(this.wrapper).addClass("e-focus");
            $(this.wrapper).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.wrapper).removeClass("e-focus");
            $(this.wrapper).off("keydown", $.proxy(this._checkUnCheck, this));
        },
        _checkUnCheck: function (evt) {
            //Space bar to check and uncheck
            if (evt.keyCode == 32) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },
        _checkedHandler: function (evt) {
            var data = { isChecked: this._isChecked, isInteraction: true, event: evt };
            if (true == this._trigger("beforeChange", data)) {
                return false;
            }
            if (this.span.hasClass("e-chk-inact")) {
                this._checked();
                if (!(this.checked() instanceof Array))
                    this.checked(true);
                if (this.model.enableTriState) {
                    this._indeterminateState = true;
                    this.checkState("check");
                }
            }
            else if (this.span.hasClass("e-chk-act")) {
                if ((this.model.enableTriState == true) && (this.model.checkState == "check") && (this.model.checked == true)){
                    this._setIndeterminate(true);
                    if (!(this.checked() instanceof Array)) {
                        this.checked(true);
                        this.checkState("indeterminate");
                    }
                } else {
                    this._unChecked();
                    if (!(this.checked() instanceof Array)) {
                        this.checked(false);
                        this.checkState("uncheck");
                    }
                }
            }
            else if (this.span.hasClass("e-chk-indeter")) {
                if (!(this.checked() instanceof Array))
                    this.checked(false);
                else
                    this._isChecked = false;
                this._setIndeterminate(false);
                this._indeterminateState = false;
            }
            if (this.checked() instanceof Array)
                this._updateCheckedItem();
            else
                this._isChecked = this.checked();
            $(this.maindiv).addClass("e-material-animate");
            var data = { isChecked: this._isChecked, checkState: this.checkState(), isInteraction: true, event: evt };
            this._trigger("change", data);
            return true;
        },


        _checked: function () {
            this.span.removeClass("e-chk-inact").addClass("e-chk-act");
            this.spanImg.removeClass("e-stop").addClass("e-checkmark");
            this.wrapper[0].setAttribute("aria-checked", true);
            this.wrapper.find('input[type=checkbox]').prop('checked', true);
            this.checkState("check");
            this._hiddenInput.removeAttribute("name");
        },


        _unChecked: function () {
            this.span.removeClass("e-chk-act e-chk-indeter").addClass("e-chk-inact");
            this.wrapper[0].setAttribute("aria-checked", false);
            this.spanImg.removeClass("e-checkmark e-stop");
            this.wrapper.find('input[type=checkbox]').prop('checked', false);
            this.checkState("uncheck");
            this._hiddenInput.setAttribute("name", this.model.name);
        },

        _setCheckedItem: function (value) {
            if (typeof(value) == "boolean" && !(value instanceof Array))
                this._isChecked = true;
            else if (value instanceof Array && !ej.isNullOrUndefined(this.model.value) && this.model.value != "") {
                for (var item = 0; item < value.length; item++) {
                    if (value[item] == this.model.value)
                        this._isChecked = true;
                }
            }
        },

        _updateCheckedItem: function () {
            if (!ej.isNullOrUndefined(this.model.value) && this.model.value != "" && !this.wrapper.find("span:first").hasClass("e-chk-indeter")) {
                if (($.inArray(this.model.value, this.checked()) < 0) && this.wrapper.find("span:first").hasClass("e-chk-act")) {
                    this.checked().push(this.model.value);
                    this._isChecked = true;
                    this._hiddenInput.removeAttribute("name");
                }
                else if (($.inArray(this.model.value, this.checked()) > -1) && this.wrapper.find("span:first").hasClass("e-chk-inact")) {
                    this.checked().splice($.inArray(this.model.value, this.checked()), 1);
                    this._isChecked = false;
                    this._hiddenInput.setAttribute("name", this.model.name);
                }
            }
        },


        disable: function () {
            if (!this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", true);
                this.element[0].setAttribute("disabled", "disabled");
                if (this._isIE8) this.span.addClass("e-disable");
                this._unWireEvents();
                this.model.enabled = false;
            }
        },

        enable: function () {
            if (this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.wrapper[0].setAttribute("aria-disabled", false);
                this.element.prop("disabled", false);
                if (this._isIE8) this.span.removeClass("e-disable");
                this._wireEvents();
                this.model.enabled = true;
            }
        },

        isChecked: function () {
            if ((this._isChecked != null) && (this._isChecked != undefined))
                return this._isChecked;
        }
    });

    ej.CheckboxSize = {
        /**  Creates checkbox with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates checkbox with inbuilt medium size height, width specified */
        Medium: "medium"
    };

    ej.CheckState = {
        /**  Specifies the Check attribute of the Checkbox */
        Check: "check",
        /**  Specifies the Uncheck attribute of the Checkbox */
        Uncheck: "uncheck",
        /**  Specifies the Indeterminate state of the Checkbox */
        Indeterminate: "indeterminate"
    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 

    ej.widget("ejDropDownList", "ej.DropDownList", {
        element: null,

        model: null,
        validTags: ["select", "input"],
        _addToPersist: ["value", "text", "selectedIndex", "selectedItemIndex", "selectedItems", "selectedIndices", "popupWidth", "popupHeight", "itemValue"],
        _setFirst: false,

        _rootCSS: "e-dropdownlist",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },
        _requiresID: true,
      


        defaults: {
            cssClass: "",

            value: null,

            htmlAttributes: {},

            text: null,

            itemValue: "",

            itemsCount: 0,

            dataSource: null,

            delimiterChar: ',',

            query: null,

            fields: {
                id: null,

                text: null,

                value: null,

                category: null,
                
                groupBy:null,

                imageUrl: null,

                imageAttributes: null,

                spriteCssClass: null,

                htmlAttributes: null,

                selected: null,

                tableName: null
            },
			
			locale: "en-US",

            watermarkText: null,

            height: "",

            width: "",

            popupHeight: "152px",

            popupWidth: "auto",

            maxPopupHeight: null,

            minPopupHeight: '20',

            maxPopupWidth: null,

            minPopupWidth: '0',

            targetID: null,

            template: null,

            headerTemplate: null,

            selectedItemIndex: -1,

            selectedIndex: -1,

            disableItemsByIndex: null,

            enableItemsByIndex: null,

            selectedItems: [],

            selectedIndices: [],

            cascadeTo: null,

            enablePopupResize: false,

            allowVirtualScrolling: false,

            virtualScrollMode: "normal",

            showRoundedCorner: false,

            showPopupOnLoad: false,

            enableRTL: false,

            enabled: true,

            filterType: "contains",

            sortOrder: "ascending",

            caseSensitiveSearch: false,

            showCheckbox: false,

            checkAll: false,

            uncheckAll: false,

            enablePersistence: false,

            enableFilterSearch: false,

            enableServerFiltering: false,

            enableIncrementalSearch: true,

            readOnly: false,

            enableAnimation: false,

            multiSelectMode: "none",

            allowGrouping: false,

            enableSorting: false,

            validationRules: null,

            validationMessage: null,

            actionBegin: null,

            actionComplete: null,

            actionFailure: null,

            actionSuccess: null,

            create: null,

            popupHide: null,

            popupShown: null,

            beforePopupShown: null,

            beforePopupHide: null,

            popupResizeStart: null,

            popupResize: null,

            popupResizeStop: null,

            change: null,

            select: null,

            dataBound: null,

            search: null,

            checkChange: null,

            cascade: null,

            destroy: null

        },

        dataTypes: {
            cssClass: "string",
            itemsCount: "number",
            watermarkText: "string",
            template: "string",
            disableItemsByIndex: "string",
            enableItemsByIndex: "string",
            enableIncrementalSearch: "boolean",
            cascadeTo: "string",
            delimiterChar: "string",
            showRoundedCorner: "boolean",
            showPopupOnLoad: "boolean",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            allowVirtualScrolling: "boolean",
            virtualScrollMode: "enum",
            enabled: "boolean",
            readOnly: "boolean",
            multiSelectMode: "enum",
            dataSource: "data",
            query: "data",
            fields: "data",
            selectedItems: "array",
            enableAnimation: "boolean",
            allowGrouping: "boolean",
            enableSorting: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
			locale:"string"
        },

        observables: ["value", "selectedItemIndex", "selectedIndex"],
        value: ej.util.valueFunction("value"),
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),
        selectedIndex: ej.util.valueFunction("selectedIndex"),
        

        enable: function () {
            if (this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = false;
                this.model.enabled = true;
				this.container.removeClass('e-disable');
                this._visibleInput.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
                this.popupListWrapper.removeClass('e-disable');
                if (this._isIE8) this.drpbtnspan.removeClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
                if (this.model.multiSelectMode == "visualmode") this._ulBox.removeClass("e-disable");
                this.wrapper.attr('tabindex', '0');
            }
            this._wireEvents();
        },

        disable: function () {
            if (!this._visibleInput.hasClass("e-disable")) {
                this.target.disabled = true;
                this.model.enabled = false;
				this.container.addClass('e-disable');
                this._visibleInput.addClass('e-disable');
                this.popupListWrapper.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
                if (this._isIE8) this.drpbtnspan.addClass("e-disable");
                if (this.model.multiSelectMode == "visualmode") this._ulBox.addClass("e-disable");
                //Element not Maintain in Multiselection
                this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
                this._unwireEvents();
                this.wrapper.removeAttr('tabindex');
                if (this._isPopupShown()) this._hideResult();
            }
        },

        /* will deprecate with text property */
        getValue: function () {
			return this._visibleInput.val();
        },
        _setValue: function (value) {
            if (!ej.isNullOrUndefined(value)) {
                this._raiseEvents = false;
                if (!ej.isNullOrUndefined(this.model.text)) this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this._addValue(value);
                this.selectItemByValue(value);
            }
        },
        _addValue: function (args) {
            if (this.model.itemsCount > 0 && args != "") {
                this._checkValue = true;
                var listitems = args.split(this.model.delimiterChar);
                var field = this.mapFld._value; 
                this._addListItems(listitems, this._rawList, "local");
                if (this._checkValue) {
                    var source = this.model.dataSource;
                    if (ej.DataManager && source instanceof ej.DataManager) {
                        if (source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0))
                            this._addListItems(listitems, source.dataSource.json,"remote");
                        else {
                            var proxy = this;
                            var value= args;
                                source.executeQuery(ej.Query()).done(function (e) {
                                proxy._addListItems(listitems, e.result, "remote");
                                proxy.selectItemByValue(value);
                            });
                        }
                    }
                    else
                        this._addListItems(listitems, source, "remote");
                }

            }
        },
        _addListItems: function (listitems, source, checkValue) {
            for (k = 0; k < listitems.length; k++) {
                for (var i = 0; i < source.length; i++) {
                    if (checkValue == "local" && source[i][this.mapFld._value] == listitems[k])
                        this._checkValue = false;
                    if (checkValue == "remote" && source[i][this.mapFld._value] == listitems[k])
                        this.addItem(source[i]);
                }
            }
        },
        _setText: function (text) {
            if (text) {
                this._raiseEvents = false;
                this.unselectItemByText(this.model.text);
                this._raiseEvents = true;
                this.selectItemByText(text);
            }
        },
        _setItemValue: function (itemValue) {
            this.model.itemValue = itemValue;
        },
        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) this._visibleInput.attr("placeholder", text);
            else this._hiddenSpan.text(text);
        },

        hidePopup: function () {
            if (!this.model.enabled) return false;
            if (this.ultag.find('li').length > 0)
                this._hideResult();
        },

        showPopup: function () {
            if (!this.model.enabled) return false;
            if (this.ultag.find('li').length > 0)
                this._showResult();
        },

        clearText: function () {
            this._clearTextboxValue(); 
            if (!this._isWatermark)
                this._setWatermark();
        },

        addItem: function (itemTag) {
            if (!this.model.enabled || !itemTag) return false;
            this._mapFields();
            var list = $.isArray(itemTag) ? itemTag : [itemTag];
            if (list.length < 1) return false;
            var mapper = this.mapFld,
                mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null, _category: null };
            mapFld._id = list[0][mapper._id] ? mapper._id : "id";
            mapFld._imageUrl = list[0][mapper._imageUrl] ? mapper._imageUrl : "imageUrl";
            mapFld._imageAttributes = list[0][mapper._imageAttributes] ? mapper._imageAttributes : "imageAttributes";
            mapFld._spriteCSS = list[0][mapper._spriteCSS] ? mapper._spriteCSS : "spriteCssClass";
            mapFld._text = list[0][mapper._text] ? mapper._text : "text";
            mapFld._value = list[0][mapper._value] ? mapper._value : "value";
            mapFld._htmlAttributes = list[0][mapper._htmlAttributes] ? mapper._htmlAttributes : "htmlAttributes";
            mapFld._selected = list[0][mapper._selected] ? mapper._selected : "selected";
            mapFld._category = list[0][mapper._category] ? mapper._category : "groupBy";
            this._generateLi(list, mapFld);
            
            var i, listItems = this.dummyUl;
            for (var i = 0; i < list.length; i++)
                this._listItem(list[i], "add");
            if (this.model.showCheckbox) {
                this._appendCheckbox(listItems, true);               
            }
            else if (!this._isSingleSelect()) this._multiItemSelection(listItems, true);
			this._virtualUl.append($(this.dummyUl).clone(true));
            this.ultag.append(this.dummyUl);

            if (this._isPopupShown()) {
                var scrollerPosition = this.scrollerObj ? this.scrollerObj.scrollTop() : 0;
                this._refreshScroller();
                if (this.scrollerObj) this.scrollerObj.option("scrollTop", scrollerPosition);
            }
        },

        _toArray: function (index, mode) {
            var items;
            if (typeof index == "function") index = ej.util.getVal(index);
            if ($.isArray(index)) items = index;
            else if (typeof index == "string") {
                if ((mode && (this.model.multiSelectMode == "visualmode" || this.model.multiSelectMode == "delimiter" || this.model.showCheckbox))) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else if (!mode) {
                    items = index.split(this.model.delimiterChar);
                    if (items.length == 0) items = [index];
                }
                else items = [index];
            } else items = [index];
            return items;
        },
        _trim: function (val) {
            return typeof val == "string" ? $.trim(val) : val;
        },
        /*will deprecate with selectItemsByIndices */
        selectItemByIndex: function (index) {
            this._selectItemByIndex(index);
        },

        selectItemsByIndices: function (index) {
            this._selectItemByIndex(index);
        },

        _selectItemByIndex: function (val) {
            this.listitems = this._getLi();
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
			if( parseInt(val) == -1 && this.model.selectedItems.length > 0) {
				this._clearTextboxValue();
				this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
			}
			else {
            var items = this._toArray(val, true), index;
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                if (index != null && index >= 0) {
                    if ($.inArray(index, this._selectedIndices) == -1)
                        for (var i = 0; i < this.listitems.length; i++) {
                            if (!$(this.listitems[i]).hasClass('e-disable')) {
                                if (i == index) {
                                    this.selectedIndexValue = i;
                                    this._activeItem = index;
                                    this._enterTextBoxValue();
                                }
                            }
                        }
                } else if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && this.model.selectedItems.length > 0) {
					this._clearTextboxValue();
				   this._trigger("change",{ text: this._visibleInput[0].value, selectedText: "", selectedValue: "", value: "" });
				} 
            }
			}
        },

        unselectItemsByIndices: function (val) { this._unselectItemByIndex(val); },

        /*will deprecate with unselectItemsByIndices method */
        unselectItemByIndex: function (val) { this._unselectItemByIndex(val); },

        _unselectItemByIndex: function (val) {
            this._selectedIndices = $.map(this._selectedIndices, function (a) { return parseInt(a); });
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            var i, items = this._toArray(val, true), index;
            this.listitems = this._getLi();
            for (var k = 0; k < items.length; k++) {
                index = parseInt(items[k]);
                for (i = 0; i < this.listitems.length; i++) {
                    if (i == index) {
                        this.selectedIndexValue = i;
                        this._activeItem = index;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                    }
                }
            }
        },

        /*Deprecated with selectedItemByValue */
        setSelectedValue: function (idvalue) { this.selectItemByValue(idvalue); },

        selectItemByValue: function (val) {
            var i, hidelement, items;
            this.listitems = this._getLi();
            if(this.inputSearch && this.inputSearch.val() != "" && this.model.enableServerFiltering && !ej.isNullOrUndefined(this._searchresult)){
                var field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
                for(i=0; i< this._searchresult.length; i++){
                for (var j = 0; j < this.listitems.length; j++) {
					if ($(this.listitems[j]).attr("data-value") == this._searchresult[i][field]) {
						this._searchresult=null;
					}
                }
            }
                this.addItem(this._searchresult);
            }
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else {
                items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable')) {
                            var fieldValue = this._getAttributeValue(this.listitems[i]) || $(this.listitems[i]).text();
                            if (fieldValue) {
                                this._selectedValue = fieldValue;
                                if (this._selectedValue == items[k]) {
                                    this._activeItem = i;
                                    this._aselectedItem = this._activeItem;
                                    this._enterTextBoxValue();
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        },


        unselectItemByValue: function (val) {
            var i, hidelement, items = this._toArray(val, true);
            this.listitems = this._getLi();
            for (var k = 0; k < items.length; k++) {
                for (i = 0; i < this.listitems.length; i++) {
                    if (this._getAttributeValue(this.listitems[i])) {
                        this._selectedValue = this._getAttributeValue(this.listitems[i]);
                        if (this._selectedValue == items[k]) {
                            this._activeItem = i;
                            if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                            this._removeTextBoxValue();
                            break;
                        }
                    }
                }
            }
        },

        /* Deprecated with selectItemByText*/
        setSelectedText: function (value) { this.selectItemByText(value); },

        selectItemByText: function (val) {
            var i, hidelement, items;
            this.listitems = this._getLi();
            this._mapFields();
            if (ej.isNullOrUndefined(val) || val === "") this._clearTextboxValue();
            else {
                items = this._toArray(val, true);
                for (var k = 0; k < items.length; k++) {
                    for (i = 0; i < this.listitems.length; i++) {
                        if (!$(this.listitems[i]).hasClass('e-disable')) {
                            this.selectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                            if (this.selectedTextValue == items[k]) {
                                this._activeItem = i;
                                this._aselectedItem = this._activeItem;
                                this._enterTextBoxValue();
                                break;
                            }
                        }
                    }
                }
            }
        },


        unselectItemByText: function (val) {
            var i, hidelement, items = this._toArray(val, true);
            this.listitems = this._getLi();
            this._mapFields();
            for (var k = 0; k < items.length; k++) {
                for (i = 0; i < this.listitems.length; i++) {
                    this.unselectedTextValue = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    if (this.unselectedTextValue == items[k]) {
                        this._activeItem = i;
                        if (this._activeItem == this._aselectedItem) this._aselectedItem = null;
                        this._removeTextBoxValue();
                        break;
                    }
                }
            }
        },

        getSelectedValue: function () {
			return this.element.val();
        },

        getSelectedItem: function () {
            var k, selected = [];
            this.listitems = this._getLi();
            for (k = 0; k < this._selectedIndices.length; k++) {
                selected.push(this.listitems[this._selectedIndices[k]]);
            }
            return selected;
        },
        getItemDataByValue: function (value) {
            var listitems = this._toArray(value, false);
			var rawList  = (!ej.isNullOrUndefined(this.resultList)) ? this._rawList.concat(this.resultList): this._rawList;
            var k, m, selected = [], field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
            for (k = 0; k < listitems.length; k++) {
                for (m = 0; m < rawList.length; m++) {
                    if (rawList[m][field] == listitems[k])
                        selected.push(rawList[m]);
                }
            }
            return selected;
        },

        getListData: function () { return this._rawList; },

        /* will be deprecate in upcoming releases*/
        getSelectedItemsID: function () {
            return this._selectedItemsID;
        },

        disableItemsByIndices: function (value) { this._disableItemByIndex(value) },

        /*Deprecated with disableItemsByIndices method */
        disableItemByIndex: function (value) { this._disableItemByIndex(value) },

        _disableItemByIndex: function (value) {
            if (!this.model.enabled) return false;
            var listitems = this._toArray(value, false),index;
            for (var i = 0; i < listitems.length; i++) {
                if (listitems[i] != null && !isNaN(parseInt(listitems[i]))) {
                    if (listitems.length > 0 && !($.inArray(parseInt(listitems[i]), this._disabledItems) > -1)) {
                        index = $.inArray(listitems[i], this._disabledItems);
                        this._setClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                        this._disabledItems.push(parseInt(listitems[i]));
                        this.model.disableItemsByIndex = String(this._disabledItems.join(","));
                    }
                }
            }
        },

        enableItemsByIndices: function (value) { this._enableItemByIndex(value) },

        /*Deprecated with enableItemsByIndices method */
        enableItemByIndex: function (value) { this._enableItemByIndex(value) },

        _enableItemByIndex: function (value) {
            var listitems = this._toArray(value, false), index;
            this.model.enableItemsByIndex = value;
            for (var i = 0; i < listitems.length; i++) {
                if (listitems.length > 0 && ($.inArray(parseInt(listitems[i]), this._disabledItems) > -1) &&  !isNaN(parseInt(listitems[i]))) {
                    index = $.inArray(parseInt(listitems[i]), this._disabledItems);
                    this._removeClass(this._getLi()[parseInt(listitems[i])], "e-disable");
                    this._disabledItems.splice(index, 1);
                }
            }
            this.model.enableItemsByIndex = null;
            this.model.disableItemsByIndex = this._disabledItems.join(this.model.delimiterChar);
        },
        _validateDelimiter: function (deli) {
            if (this._trim(deli).length == 1) {
                var RegEx = /^[a-zA-Z0-9]+$/;
                if (!RegEx.test(deli)) return deli;
            }
            return ",";
        },

        _removeText: function (currentValue) {
            var eleVal = this.element[0].value.split(this.model.delimiterChar), hidVal = this._visibleInput[0].value.split(this.model.delimiterChar),
            index = $.inArray(currentValue, eleVal);
            if (index >= 0) {
                eleVal.splice(index, 1);
                hidVal.splice(index, 1);
            }
            this.element[0].value = eleVal.join(this.model.delimiterChar);
            this._visibleInput[0].value = hidVal.join(this.model.delimiterChar);
        },
        _addText: function (currentValue) {
            if (this._checkContains(this._hiddenValue)) return false;
            var ele = ["element", "_visibleInput"], val;
            for (var i = 0; i < ele.length; i++) {
                val = ele[i] == "element" ? this._hiddenValue : currentValue;
                if (this[ele[i]][0].value && this[ele[i]][0].value != "") {
                    var splitedText = this[ele[i]][0].value.split(this.model.delimiterChar);
                    splitedText.push(val);
                    this[ele[i]][0].value = splitedText.join(this.model.delimiterChar);
                } else this[ele[i]][0].value = val;
            }
        },
        _checkContains: function (chkValue) {
            var values = this.element[0].value.split(this.model.delimiterChar);
            this.contains = false;
            for (var i = 0; i < values.length; i++) {
                values[i] = isNaN(parseInt(values[i])) || (typeof(this._rawList[i][this.mapFld._value]) == 'string') ? values[i] : parseInt(values[i]);
                if (values[i] === chkValue) {
                    this.contains = true;
                    break;
                }
            }
            return this.contains;
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.DropDownList", this.model.locale);
        },
        _init: function () {
            var browserInfo = ej.browserInfo();
            this._updateLocalConstant();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0');
            this._textContent = this._isIE8 ? "innerText" : "textContent";
            if ((this.element.is("input") && (this.element.is("input[type=text]") || !this.element.attr('type'))) || this.element.is("select")) {
                this._isWatermark = 'placeholder' in $(document.createElement('input')).attr("placeholder", '')[0];
                this._id = this.element[0].id;
                this._initialize();
                this._render();
                this._addAttr(this.model.htmlAttributes);
                this._enabled(this.model.enabled);
                this._initValue = false;
                this._checkboxValue = false;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            }
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                this.element.rules("add", this.model.validationRules);
                var validator = this.element.closest("form").data("validator");
                if (!validator) validator = this.element.closest("form").validate();
                var name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                            message = this.model.validationRules["messages"][ruleName];
                        else {
                            validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                    }
                }
            }
        },

        _setInitialPopup: function (value) {
            if (this.model.enabled && !this.model.readOnly)
                value == false ? this._hideResult() : this._showResult();
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.popupListWrapper.removeClass(this.model.cssClass).addClass(skin);
        },

        _setRTL: function (val) {
            if (this.model.enableRTL != val) {
                this.model.enableRTL = val;
                this._RightToLeft();
                this._dropbtnRTL();
            }
        },

        _changeHeight: function (height) {
            this.wrapper.height(height);
            this._setListHeight();
        },
        _changeWidth: function (width) {
            this.wrapper.width(width);
            this._setListWidth();
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "dataSource": if (!this._isEqualDataSource(options[option])) this._checkModelDataBinding(options[option], this.model.query); break;
                    case "query": this._checkModelDataBinding(this.model.dataSource, options[option]); break;
                    case "fields": this.model.fields = $.extend(this.model.fields, options[option]); this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "itemsCount": this.model.itemsCount = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query);; break;
                    case "template": this.model.template = options[option]; this._checkModelDataBinding(this.model.dataSource, this.model.query); break;
                    case "value": 
					var optionValue = ej.util.getVal(options[option]);
					if (ej.isNullOrUndefined(optionValue) || optionValue === "") this._clearTextboxValue();
					if (ej.isNullOrUndefined(optionValue) || optionValue === "") this._clearTextboxValue();
                    else { this._setValue(ej.util.getVal(options[option])); options[option] = this.model.value; } break;
                    case "delimiterChar": 
						var delchar = this.model.delimiterChar; 
						options[option] = this._validateDelimiter(options[option]);
                        this.model.delimiterChar = options[option];
                        if (!this._isSingleSelect()) {
						if (this.model.text) {
							this.model.text = this.model.text.split(delchar).join(this.model.delimiterChar);
							this._visibleInput.val(this.model.text);							
						}
						if(!ej.isNullOrUndefined(this.value())) {
							this.value(this.value().split(delchar).join(this.model.delimiterChar));
							this.element.val(this.value());	
						}
                    }
                        break;
                    case "text": if (ej.isNullOrUndefined(options[option]) || options[option] === "") this._clearTextboxValue();
                    else { this._setText(options[option]); options[option] = this.model.text; } break;
                    case "itemValue": this._setItemValue(options[option]); break;
                    case "enableRTL": this._setRTL(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "height": this._changeHeight(options[option]); break;
                    case "width": this._changeWidth(options[option]); break;
                    case "popupHeight": this.model.popupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "popupWidth": this.model.popupWidth = options[option]; this._setListWidth(); break;
                    case "minPopupHeight": this.model.minPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "minPopupWidth": this.model.minPopupWidth = options[option]; this._setListWidth(); break;
                    case "maxPopupHeight": this.model.maxPopupHeight = options[option]; this._setListHeight(options[option]); break;
                    case "maxPopupWidth": this.model.maxPopupWidth = options[option]; this._setListWidth(); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showCheckbox": this.model.showCheckbox = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        this._checkboxHideShow(options[option]);
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else if (_textes && _textes.length)
                            this._setText(_textes[0]);
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will depreciate with checkAll  Method*/
                    case "checkAll": this._setCheckAll(options[option]); return false; break;
                        /* will depreciate with uncheckAll  Method*/
                    case "uncheckAll": this._setUncheckAll(options[option]); return false; break;
                    case "watermarkText": this._changeWatermark(options[option]); break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        this._updateLocalConstant();
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "showRoundedCorner": this._roundedCorner(options[option]); this.model.showRoundedCorner = options[option]; break;
                    case "showPopupOnLoad": this._setInitialPopup(options[option]); break;
                    case "targetID": this.model.targetID = options[option]; this._showFullList(); break;
                        /* will depreciate with selectedIndex  Method*/
                    case "selectedItemIndex":
                    case "selectedIndex":
                        this._selectItemByIndex(options[option]);
                        this.model.selectedItemIndex = this.model.selectedIndex = options[option];
                        break;
                        /* will depreciate with unselectItemByIndex API Method*/
                    case "unselectItemByIndex": this._unselectItemByIndex(options[option]); break;
                        /* will depreciate with disableItemsByIndex API Method*/
                    case "disableItemsByIndex": this._disableItemByIndex(options[option]); break;
                        /* will depreciate with enableItemsByIndex API Method*/
                    case "enableItemsByIndex": this._enableItemByIndex(options[option]); break;
                        /* will depreciate with selectedIndices  Method*/
                    case "selectedItems":
                    case "selectedIndices":
                        this._selectCheckedItem(options[option]);
                        options[option] = this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        break;
                    case "multiSelectMode":
                        if (this.model.multiSelectMode == "visualmode") {
                            this._swapUlandInput(false);
                            this._ulBox.remove();                         
                            this._ulBox = null;                     
                        }
                        this.model.multiSelectMode = options[option];
                        var _text = this.model.text;
                        var _textes = this.model.text ? this.model.text.split(this.model.delimiterChar) : this.model.text;
                        this._raiseEvents = false;
                        this._clearTextboxValue();
                        this._raiseEvents = true;
                        if (this.model.showCheckbox || (this.model.multiSelectMode != "none")) {
                            if (this.model.multiSelectMode == "visualmode")
                                this._renderBoxModel();
                            this._setText(_text);
                        }
                        else {
                            this._setText(_textes[0]);
                            this.wrapper.find("input[name=" + this._name + "]").remove();
                        }
                        if (this._isPopupShown())
                            this._setListPosition();
                        break;
                        /* will deprecate with fields.groupBy and e-category element in target element binding */
                    case "allowGrouping":
                        this._setGroupingAndSorting("allowGrouping", options[option]);
                        break;
                    case "enableSorting":
                        this._setGroupingAndSorting("enableSorting", options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "enablePopupResize": this.model.enablePopupResize = options[option];
                        (options[option]) ? this._enablePopupResize() : this.popupListWrapper.removeClass("e-resizable").find(".e-resizebar").remove() && this._hideResult();
                        break;
                    case "enableFilterSearch":
                        if (!options[option]) this._removeSearch();
                        else {
                            this.model.enableFilterSearch = true;
                            this._enableSearch();
                            break;
                        }
                        case "enableServerFiltering": 
                            this._enableSearch();
                            break; 
                }
            }
        },

        _clearTextboxValue: function () {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = this.model.itemValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = []; this._selectedIndices = [];
            this.model.selectedItems = [];
            this.model.selectedIndices = [];
            this.selectedIndex(null);
            this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
            if (this.model.showCheckbox) this._resetCheck();
            if (this.wrapper.find('ul.e-ul.e-boxes').length != 0) {
                this._ulBox.children("li").remove();
                if (this._name === "")
                    this.wrapper.find("input:hidden[id^='#']").remove();
                else
                    this.wrapper.find("input:hidden[id^='#'][name=" + this._name + "]").remove();
                $(this.element).attr("name", this._name);
            }
        },

        _destroy: function () {
            if( this.selectOptions) {
                if (!this.model.dataSource && this.docbdy ) 
                    this.docbdy.append(this.selectOptions.removeClass("e-dropdownlist e-js").show()).show();
                else this.selectOptions.insertAfter(this.wrapper).removeClass("e-dropdownlist e-js").show();
                this.element.remove();
            }
            else {
                this.element.insertAfter(this.wrapper);
                this.element.width(this.element.width() + this.dropdownbutton.outerWidth());
                this._visibleInput.removeClass("e-input ");
                this._setAttr( this.element[0], { 'accesskey': this.wrapper.attr('accesskey'), type:"text" });
                if (this._isWatermark) this._visibleInput.removeAttr("placeholder");
                this.element[0].value = "";
                this.element.removeAttr("aria-expanded aria-autocomplete aria-haspopup aria-owns accesskey role").css({"width": "", "display": "block"});
                (!this.model.dataSource) && this.docbdy && this.ultag.find("li").removeClass("e-active") && this.docbdy.append(this.ultag.html()).show();
            }
            this.wrapper.remove();
            this.container.off("mousedown", $.proxy(this._OnDropdownClick, this));
            this._hideResult();
            this.popupPanelWrapper.remove();
			this._unwireEvents();
        },


        _finalize: function () {
            if (this.value() == "" && this._visibleInput[0].value !== "")
                this._updateValue(this.element[0].value);
            if (this.value() !== this.element.val())
                this._setValue(this.value());
            if (this.model.text != this._visibleInput.val())
                this._setText(this.model.text);
            this.selectedIndex((this.selectedIndex() != -1) ? this.selectedIndex() : this.selectedItemIndex());
            if (this.selectedIndex() != -1) {
                this._selectItemByIndex(this.selectedIndex());
            } else if (this._selectedIndices.length > 0) {
                this._selectCheckedItem(this._selectedIndices);
            } if (this.model.disableItemsByIndex != null)
                this._disableItemByIndex(this.model.disableItemsByIndex);
            if (this.model.enableItemsByIndex != null)
                this._enableItemByIndex(this.model.enableItemsByIndex);
        },


        _initialize: function () {
            this._selectedIndices = this.model.selectedIndices.length > 0 ? this.model.selectedIndices : this.model.selectedItems;
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
            this.model.selectedIndex = this.model.selectedIndex != -1 ? this.model.selectedIndex : this.model.selectedItemIndex;
            if (this.element.is("select")) {
                this.selectelement = true;
                this._renderSelectToDropdown();
            }
            this._selectedItemsID = [];
            this.target = this.element[0];
            this._disabledItems = new Array();
            this._queryString = null;
            this.suggLen = 0;
            this._itemId = null;
            this.checkedStatus = false;
            this._incqueryString = "";
            this._activeItem = null;
            this.ddWidth = 0;
            this._initValue = true;
            this._virtualCount = 0;
            this._raiseEvents = true;
        },
        _renderSelectToDropdown: function () {
            var i, optionLength, optionText, item;
            this.inputElement = ej.buildTag("input.e-dropdownlist#" + this._id + "_input", "", {}, { "type": "text", "data-role": "none" });
            this.inputElement.insertAfter(this.element);
			if (this.element.attr("name")) {
                this.inputElement.attr("name", this.element.attr("name"));
                this.element.removeAttr("name");
            }
			this.selectOptions = this.element;
            this.selectOptions.attr('id', this._id);
			if( this.model.dataSource == null ) {
            this.optionDiv = ej.buildTag("div#" + this._id + "_list");
            this.optionDiv.insertAfter(this.inputElement);
            this.optionUl = ej.buildTag("ul");
            this.optionDiv.append(this.optionUl);

            this.selectOptionItems = this.element.children("option");
            optionLength = this.selectOptionItems.length;
            this.optionDummyUl = $();

            for (i = 0; i < optionLength; i++) {
                item = this.selectOptionItems[i], optionText = $(item).attr('label') ? $(item).attr('label') : item.innerHTML;
                if (optionText != null) {
                    this.optionLi = ej.buildTag("li", optionText, {}, { 'data-value': item.value, "unselectable": "on" });
                    this.optionDummyUl.push(this.optionLi[0]);
                    if ($(item).attr("selected")) {
                        if (this.model.showCheckbox)
                            if ($.inArray(i, this._selectedIndices) == -1) {
                                this._selectedIndices.push(i);
                                this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                            }
                            else if (ej.isNullOrUndefined(this.selectedIndex())) this.selectedIndex(i);
                    }
                }
            }
            this.optionUl.append(this.optionDummyUl);

			}
            this.element.css('display', 'none');
            this.element = this.inputElement;
        },


        _render: function () {
            this._renderDropdown();
            this._setWatermark();
            this._renderPopupPanelWrapper();
            this._showFullList();
            this._roundedCorner(this.model.showRoundedCorner);
            //To call finalize() only local data source
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._finalize();
                }               
            }
            else this._finalize();
            if (!(ej.DataManager && this.model.dataSource instanceof ej.DataManager)){
                
                 this._finalize();
            }               
            this._setCheckAll(this.model.checkAll);
            if(this.element.attr("disabled") || $(this.selectOptions).attr("disabled"))this.disable();
        },

        _isEqualDataSource: function (source) {
            if (!this.model.dataSource || !source || !(this.model.dataSource.length === source.length) || (ej.DataManager && source instanceof ej.DataManager)) return false;
            var equal = true;
            for (var i = 0, len = this.model.dataSource.length; i < len; i++) {
                if (this.model.dataSource[i] !== source[i]) {
                    equal = false;
                    break;
                }
            }
            return equal;
        },

        _checkModelDataBinding: function (source, query) {
            this.element.val("");
            this._visibleInput.val("");
            this._updateValue("");
            this.selectedTextValue = this._selectedValue = this._hiddenValue = "";
            this._updateText();
            this.selectedIndexValue = this._hiddenDelimiterIndex = this._activeItem = -1;
            this._selectedItemsID = [];
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices = [];
            this.model.selectedIndex = this.model.selectedItemIndex = -1;
            if (this.model.multiSelectMode == "visualmode") this._destroyBoxModel();
            this.model.dataSource = source;
            this.model.query = query;
            this.ultag.empty();
            this._showFullList();
        },
        _initDataSource: function (source) {
            var proxy = this;
            if (ej.DataManager && source instanceof ej.DataManager) {
                proxy._addLoadingClass();
                if (!proxy._trigger("actionBegin", { requestFrom: "default" })) {
                    var queryPromise = source.executeQuery(this._getQuery());
                    queryPromise.done(function (e) {
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "default" });
                        proxy._totalCount = e.count;
                        proxy._listItem(e.result);
                        proxy._removeLoadingClass();
                        proxy._renderPopupList();
                        proxy._finalize();

                    }).fail(function (e) {
                        proxy.model.dataSource = null;
                        proxy._addLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "default" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "default" });
                    });
                }
            }
        },
        _listItem: function (list, type) {
            if (type == "add") {
                this.popupListItems.push(list);
                this._rawList.push(list);
            } else if ($.isArray(list)) {
                this.popupListItems = list.slice(0);
                this._rawList = list.slice(0);
            }
        },
        _getQuery: function (isLocal) {
            var remoteUrl, mapper = this.model.fields, queryManager = ej.Query();
            if (ej.isNullOrUndefined(this.model.query) && !this.model.template && !isLocal) {
                var column = [];
                for (var col in mapper) {
                    if (col !== "tableName" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
            }
            else if (this.model.query) queryManager = this.model.query.clone();

            if (this.model.allowVirtualScrolling) queryManager.requiresCount();
            if (this.model.itemsCount > 0) queryManager.take(this.model.itemsCount);

            remoteUrl = this.model.dataSource.dataSource;
            if (mapper)
                if ((remoteUrl && remoteUrl.url && !remoteUrl.url.match(mapper.tableName + "$")) || (remoteUrl && !remoteUrl.url) || (!remoteUrl))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);

            return queryManager;
        },

        _addLoadingClass: function () {
            if (this._isPopupShown()) {
                this.popupListWrapper.addClass("e-load");
            } else {
                this.dropdownbutton.addClass("e-load");
                this.drpbtnspan.removeClass("e-icon e-arrow-sans-down");
            }
            this._readOnly = true;
        },
        _removeLoadingClass: function () {
            this.dropdownbutton.removeClass("e-load");
            this.drpbtnspan.addClass("e-icon e-arrow-sans-down");
            this._readOnly = false;
            this.popupListWrapper.removeClass("e-load");
        },

        _renderDropdown: function () {
            this.wrapper = ej.buildTag("span.e-ddl e-widget " + this.model.cssClass + "#" + this._id + "_wrapper", "", {}, { "tabindex": "0", "accesskey": this.element.attr("accesskey") });
            this.container = ej.buildTag("span.e-in-wrap e-box " + "#" + this._id + "_container");
            this.element.removeAttr('accesskey');            
			if(this.model.value == null && this.element.attr("value") != null)
				this.model.value = this.element.attr("value");				
			this.element.attr("value","").val("");
            if(!this._isIE8)
            this._setAttr(this.element[0], { "type":"hidden","role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();
			else
			this._setAttr(this.element[0], {"role": "combobox", "aria-expanded": false, "aria-autocomplete": "list", "aria-haspopup": true, "aria-owns": this._id + "_popup" }).element.hide();			
            this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select", "unselectable": "on" });
            this.dropdownbutton = ej.buildTag("span.e-select#" + this._id + "_dropdown", "", {}, { "role": "button", "unselectable": "on" }).append(this.drpbtnspan);
            this.container.insertAfter(this.element);
            this.container.append(this.element);
            this.container.append(this.dropdownbutton);
            this.wrapper.insertBefore(this.container);
            this.wrapper.append(this.container);
            if (this.selectelement) {
                this.selectOptions.insertBefore(this.element);
            }
            this._visibleInput = ej.buildTag("input#" + this._id + "_hidden", "", {}).insertAfter(this.element);
            this._visibleInput.addClass("e-input ");
			this._setAttr(this._visibleInput[0],{ "readonly": "readonly", "tabindex": -1,"data-role": "none" });        
            if (!this._isWatermark) {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(watermark);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.on("mousedown", $.proxy(this._OnDropdownClick, this));
            }
            this._checkNameAttr();
            this._setDimentions();
            this._RightToLeft();
            this.ddWidth = (this.dropdownbutton.outerWidth() > 0) ? this.dropdownbutton.outerWidth() : 24;
            //Element not Maintain in Multiselection
            this.container.on("mousedown", $.proxy(this._OnDropdownClick, this));
        },

        _checkNameAttr: function () {
            this._name = ej.isNullOrUndefined(this.element.attr("name")) ? this._id : this.element.attr("name");
            this.element.attr("name", this._name);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
				var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value); 
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readOnly" && value == "readOnly") proxy.model.readOnly = true; 
                else if (keyName == "style") proxy.wrapper.attr(key, value);
				else if (ej.isValidAttr(proxy._visibleInput[0], key)) $(proxy._visibleInput).attr(key, value);
                else proxy.wrapper.attr(key, value)
            });
        },
        _renderBoxModel: function () {
            if (!ej.isNullOrUndefined(this._ulBox) || this.model.multiSelectMode != "visualmode") return false;
            this._ulBox = ej.buildTag("ul.e-ul e-boxes");
            this.container.prepend(this._ulBox);
            this._ulBox.css('min-height', '30px');
            this._ulBox.css('display', 'none');
            this._on(this.container, "click", function (e) {
                if (!this.model.enabled) return false;
                var $target = $(e.target);
                if ($target.hasClass("e-options")) {
                    if (!e.ctrlKey && $target.siblings().hasClass("e-active")) this._removeActive();
                    if ($target.hasClass("e-active")) $target.removeClass("e-active");
                    else $target.addClass("e-active");
                }
                if (!e.ctrlKey && ($target.hasClass("e-boxes"))) this._removeActive();
            });
        },

        _renderPopupPanelWrapper: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup_wrapper").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popupPanelWrapper = ej.buildTag("div#" + this._id + "_popup_wrapper");
            $('body').append(this.popupPanelWrapper);
            this.popupListWrapper = ej.buildTag("div.e-ddl-popup e-box e-widget  e-popup#" + this._id + "_popup_list_wrapper", "", { display: "none", overflow: "hidden" });
            this.popupList = ej.buildTag("div#" + this._id + "_popup", { "tabIndex": 0 });
            this.popupListWrapper.addClass(this.model.cssClass);
            this.popup = this.popupList;
            this.popupScroller = ej.buildTag("div"); this.ultag = ej.buildTag("ul.e-ul", "", {}, { "role": "listbox" });
            this.popupScroller.append(this.ultag);
            this.popupList.append(this.popupScroller);
            if (this.model.headerTemplate) {
                this.headerTemplate = $("<div>").append(this.model.headerTemplate);
                this.popupListWrapper.append(this.headerTemplate);
            }
            this.popupListWrapper.append(this.popupList);
            this.popupPanelWrapper.append(this.popupListWrapper);
            this.ultag.on({ mouseenter: $.proxy(this._OnMouseEnter, this), mouseleave: $.proxy(this._OnMouseLeave, this), click: $.proxy(this._OnMouseClick, this)}, "li:not('.e-category')");
            if (ej.isTouchDevice())
             {
             this.ultag.on({tap:$.proxy(this._OnMouseEnter, this) }, "li:not('.e-category')");
               }
            $(window).on("resize", $.proxy(this._OnWindowResize, this));

        },

        _updateText: function () {
            this.model.text = this._visibleInput.val() == "" ? null : this._visibleInput.val();
        },
        _updateValue: function (val) {
            this.value(val == "" ? null : val);
        },
        _setGroupingAndSorting: function (prop, value) {
            this.model[prop] = value;
            var oldValue = this.model.text;
            this._updateValue("");
            this._selectedIndices = [];
            this.ultag.empty();
            this._showFullList();
            if (this.model.showCheckbox && oldValue) {
                var values = oldValue.split(this.model.delimiterChar);
                for (var i = 0; i < values.length; i++)
                    this.selectItemByText(values[i]);
            }
            else
                this.selectItemByText(oldValue);
        },
        _setSortingList: function () {
            var sortedlist = document.createElement("ul"), i, sortitems;
            $(sortedlist).append(this.itemsContainer.children());
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (i = 0; i < $(sortedlist).find(">.e-category").length; i++) {
                    sortitems = $(sortedlist).find(">.e-category").eq(0).first().nextUntil(".e-category").get();
                    this._setSortList(sortedlist, sortitems);
                }
            }
            else {
                $(sortedlist).children('>.e-category').remove();
                sortitems = $(sortedlist).children('li').get();
                this._setSortList(sortedlist, sortitems);
            }
            this.itemsContainer = $(sortedlist);
        },
        _setSortList: function (sortedlist, sortitems) {
            sortitems.sort(function (objA, objB) {
                var sortA = $(objA).text().toUpperCase();
                var sortB = $(objB).text().toUpperCase();
                return (sortA < sortB) ? -1 : (sortA > sortB) ? 1 : 0;
            });
            if (this.model.sortOrder == "descending") sortitems.reverse();
            if (this.model.allowGrouping || $(sortedlist).find(">.e-category").length > 0) {
                $(sortedlist).append($("<li>").text($(sortedlist).find(">.e-category").eq(0).text()).addClass("e-category"));
                $(sortedlist).find(">.e-category").eq(0).remove();
            }
            $.each(sortitems, function (index, item) {
                $(sortedlist).append(item);
            });
        },

        _renderPopupList: function () {
            this._doDataBind();
            this._renderRemaining();
        },
        _renderRemaining: function () {
            var proxy = this;
            this._dropbtnRTL();
            if (this.model.enableFilterSearch) this._enableSearch();
            if (this.model.enablePopupResize) this._enablePopupResize();
            if (this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal") {
                if (this._totalCount && this._totalCount > 0) {
                    this._totalHeight = this._totalCount * 29;
                    this._totalPages = this._totalCount / (this.model.itemsCount * 29);
                    this._loadedItemHeight =  this._getLi().length * 29;
                    this._getLi().attr("page", 0);
                    this._virtualPages = [0];
                    this.ultag.append($("<span>").addClass("e-virtual").css({ "height": this._totalHeight - this._loadedItemHeight, "display": "block" }));
                }
            }
            this._virtualUl = this.ultag.clone(true);
            this._setListWidth();
            this._setListHeight();
			if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) this._checkboxHideShow(this.model.showCheckbox);
                else this._multiItemSelection(this._getLi());
            }
            this._setUncheckAll(this.model.uncheckAll);
            this.popupScroller.css({ "height": "", "width": "" });
            this.popupList.ejScroller({
                height: this._getPopupHeight(), width: 0, scrollerSize: 20, scroll: function (e) {
                    if (proxy.model.allowVirtualScrolling) proxy._onScroll(e);
                }
            });
            this.scrollerObj = this.popupList.ejScroller("instance");
            this.popupList.find("div.e-scrollbar div").attr("unselectable", "on");
			this._setListPosition();
            this.popupListWrapper.css({ 'display': 'none', 'visibility': 'visible' });
            this._changeSkin(this.model.cssClass);
            this.model.showPopupOnLoad && this._showResult();
           
        },

        _enableSearch: function () {
            if (this.model.enableFilterSearch)
                if (!this.inputSearch) {
                    this.inputSearch = ej.buildTag("input#" + this._id + "_inputSearch.e-input", "", {}, { "type": "text", "data-role": "none" });
                    this.popupListWrapper.prepend($("<span>").addClass("e-atc e-search").append($("<span>").addClass("e-in-wrap ").append(this.inputSearch).append($("<span>").addClass(" e-icon e-search"))));
                    var debounceListener = (this.model.enableServerFiltering) ? this._debounce(this._OnSearchEnter, 200): this._OnSearchEnter;
                    this._on(this.inputSearch, "keyup", debounceListener)._on(this.inputSearch, "keydown", function(args){
						var keyCode = args.keyCode || args.which; 
						  if (keyCode == 9) { 
						    args.preventDefault(); 
						    this.wrapper.focus();
							this._hideResult();
						  } 
					});
                }
        },
        _removeSearch: function () {
            this.model.enableFilterSearch = false;
            this.popupListWrapper.find(".e-atc.e-search").remove();
            if (this._isPopupShown()) this.hidePopup();
            this.inputSearch = null;
        },

        _OnSearchEnter: function (e) {
            var proxy = this;
            if ($.inArray(e.keyCode, [38, 40, 13]) != -1 && this.ultag.find("li.e-nosuggestion").length <= 0) {
                if (e.keyCode == 13) this._OnKeyUp(e);
                else this._OnKeyDown(e);
            }
            else {
                this._activeItem = -1;
                this._queryString = this.inputSearch.val();
                if (this._queryString == "" && this._virtualUl) {
                    var args = { searchString: this._queryString, searchQuery: null, items: this._rawList };
                    this._trigger("search", args);
                    this._resetList();
                    this._updateSelectedIndexByValue(this.value());
                    this._refreshScroller();
                    this._setListPosition();
                } else {
                    this._mapFields();
                    var searchQuery = this._addSearchQuery(ej.Query(), !this._isPlainType(this._rawList));
                    var args = { searchString: this._queryString, items: this._rawList, searchQuery: searchQuery };
                    this.popupListWrapper.find(".e-atc.e-search .e-search").addClass("e-cross-circle").removeClass("e-search");
                    this._on(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
                    if (!this._trigger("search", args)){ 
                        proxy._onActionComplete(args); 
                }
                  
                }
            } 
        },
     _debounce: function(eventFunction, delay) { 
         var out;
         var proxy = this;
        return function (){
            var args= arguments;
            var later = function(){
                out = null;
                return eventFunction.apply(proxy, args);
            };
            clearTimeout(out);
            out = setTimeout(later, delay);
        };
    },


        _onActionComplete: function(args){
            var proxy = this; 
            this._queryString = this.inputSearch.val();
                        var searchQuery = this._addSearchQuery(ej.Query(), !this._isPlainType(this._rawList));
                    var args = { searchString: this._queryString, items: this._rawList, searchQuery: searchQuery }; 
                if(ej.DataManager && this.model.dataSource instanceof ej.DataManager && this.model.enableServerFiltering && window.getSelection().type == "Caret"){
                        var searchQuery = args.searchQuery.clone();
                        var queryPromise = proxy.model.dataSource.executeQuery(searchQuery);
                        queryPromise.done(function (e) { 
                        proxy._filterSearch(args.searchQuery, e); 
                    });
                        }
                        else{
                            proxy._filterSearch(searchQuery, args);
                        }
        },
        _refreshSearch: function () {
            this._resetSearch();
            this._refreshPopup();
        },
        _filterSearch: function (searchQuery, args) {
            var flag = false; 
            this.resultList = args.result ? args.result : ej.DataManager(this._rawList).executeLocal(searchQuery);
            if (this.resultList.length == 0) {
                flag = true;
                this.resultList.push(this._getLocalizedLabels("emptyResultText"));
            }
            this.popupListItems = this.resultList;
            this.ultag.empty();
            this._isPlainType(this.popupListItems) ? this._plainArrayTypeBinding(this.resultList) :
            this._objectArrayTypeBinding(this.resultList, "search");
            if (flag && this.ultag.find("li").length == 1) {
                this.ultag.find("li").eq(0).addClass("e-nosuggestion");
            }
            if (this.model.showCheckbox && !flag) {
                this._appendCheckbox( this._getLi());
            }
            this._onSearch = true;
            var value = this.value(), visibleText = this._visibleInput[0].value;
            this._setValue(this.value());
			var checkVal = typeof this.model.value === "function" ? this.model.value() : this.model.value;
			if(checkVal != value){
				this.element[0].value = value;
				this._visibleInput[0].value = visibleText;
				this.model.text = visibleText == "" ? null : visibleText;
				if (this.value() != value && !(this.value() == null && value =="" )) {
					this._updateValue(value);
				}
			}
            this._onSearch = false;
            this._updateSelectedIndexByValue(this.value());
            this._refreshScroller();
            this._setListPosition();
        },
        _updateSelectedIndexByValue: function (value) {
            if (!value || !this.model.enableFilterSearch) return;
            this._selectedIndices = this.model.selectedItems = this.model.selectedIndices = [];
            this._virtualList = this._virtualUl.children("li:not('.e-category')");
            var item = this._toArray(value);
            for (var k = 0; k < item.length; k++) {
                for (var m = 0; m < this._virtualList.length; m++) {
                    if (item[k] == this._getIndexedValue(this._virtualList[m])) {
                        this._selectedIndices.push(m);
                        break;
                    }
                }
            }
            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
        },
        _getIndexedValue: function (item) {
            return this._getAttributeValue(item) ? this._getAttributeValue(item) : item.innerText;
        },

        _resetSearch: function () {
            if (!this.inputSearch || !(this.model && this.model.enableFilterSearch)) return;
            if (this.inputSearch.val() != "" && this._virtualUl) {
                this.inputSearch.val("");
                this._resetList();
            }
        },
        _resetList: function () {
            if (this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").length == 1) {
                this.popupListWrapper.find(".e-atc.e-search .e-cross-circle").addClass("e-search").removeClass("e-cross-circle");
                this._off(this.popupListWrapper.find(".e-atc.e-search .e-cross-circle"), "mousedown", this._refreshSearch);
            }
            if(this.model.enableServerFiltering){
			var field = (this.model.fields && this.model.fields.value) ? this.model.fields["value"] : "value";
			for (var i=0; i< this._rawList.length; i++){
				if(this._rawList[i][field] == this._selectedValue)
					this._searchresult= null;
			} 
			if(!ej.isNullOrUndefined(this._searchresult) && !(this.model.allowVirtualScrolling && this.model.virtualScrollMode == "normal"))
                this.addItem(this._searchresult);
            }
            this._listItem(this._rawList);
            this.ultag.empty().append(this._virtualUl.children().clone(true));           
            // this._onSearch variable will restrict the change and select event on searching
            this._onSearch = true;
            this._setValue(this.value());
            this._onSearch = false;
			this._searchresult = [];
        },

       
        _addSearchQuery: function (query, checkMapper) {
            var bindTo = "";
            if (checkMapper) {
                var mapper = this.model.fields;
                bindTo = (mapper && mapper.text) ? mapper["text"] : "text";
            }
            if (this._queryString) query.where(bindTo, this.model.filterType, this._queryString, !this.model.caseSensitiveSearch);
            if (this.model.itemsCount > 0) query.take(this.model.itemsCount);
            return query;
        },

        _targetElementBinding: function () {
            var predecessor = this.element.parents().last();
            this.docbdy = this.model.targetID ? predecessor.find("#" + this.model.targetID) : this.optionDiv ? this.optionDiv : null;
            if (!this.docbdy) return false;
            this.itemsContainer = this.docbdy[0].nodeName == "UL" ? this.docbdy : this.docbdy.children("ol,ul");
            if ((this.model.allowGrouping || this.itemsContainer.find(">.e-category").length > 0) && !this.model.enableSorting) {
                this.popupListWrapper.addClass("e-atc-popup");
                for (var k = 0; k < this.itemsContainer.find(">.e-category").length; k++) {
                    var ele = this.itemsContainer.find(">.e-category").eq(k);
                    ele.replaceWith($("<li>").text(ele.text()).addClass("e-category"));
                }
            }
            else if (this.model.enableSorting) this._setSortingList();
            this.itemsContainer.children("ol,ul").remove();
            this.items = this.itemsContainer.children('li');
            this.items.children("img,div").addClass("e-align");
            this._listItem([]);
            for (var i = 0; i < this.items.length; i++) {
                var fieldText = $(this.items[i]).text(), fieldValue = this._getAttributeValue(this.items[i]);
                if(!$(this.items[i]).attr("data-value")) $(this.items[i]).attr("data-value", fieldValue ? fieldValue : fieldText);
                this._listItem({ text: fieldText, value: fieldValue ? fieldValue : fieldText }, "add");
            }
            //This will append the list with the popup wrapper
            this.ultag.empty().append(this.itemsContainer.children());
			this.ultag.children('li').attr("role", "option").attr("unselectable", "on");		
            this.docbdy.css({ 'display': 'none' }).children("ol,ul").remove();
        },
        _plainArrayTypeBinding: function (list) {
            this.dummyUl = $();
            if (this.model.enableSorting) {
                list.sort();
                if (this.model.sortOrder == "descending") list.reverse();
            }
            if (list.length > 0) {
                for (var i = 0; i < list.length; i++) {
                    if (!ej.isNullOrUndefined(list[i])) {
                        var litag = ej.buildTag("li", list[i], {}, { 'data-value': list[i], "unselectable": "on" });
                        this.dummyUl.push(litag[0]);
                    }
                }
                this.ultag.append(this.dummyUl);
                this._trigger('dataBound', { data: list });
            }

        },
        _mapFields: function () {
            this.model.fields.groupBy = this.model.fields.groupBy ? this.model.fields.groupBy : this.model.fields.category;
            var mapper = this.model.fields;
            this.mapFld = { _id: null, _imageUrl: null, _imageAttributes: null, _spriteCSS: null, _text: null, _value: null, _htmlAttributes: null, _selected: null };
            this.mapFld._id = (mapper && mapper.id) ? mapper["id"] : "id";
            this.mapFld._imageUrl = (mapper && mapper.imageUrl) ? mapper["imageUrl"] : "imageUrl";
            this.mapFld._imageAttributes = (mapper && mapper.imageAttributes) ? mapper["imageAttributes"] : "imageAttributes";
            this.mapFld._spriteCSS = (mapper && mapper.spriteCssClass) ? mapper["spriteCssClass"] : "spriteCssClass";
            this.mapFld._text = (mapper && mapper.text) ? mapper["text"] : "text";
            this.mapFld._value = (mapper && mapper.value) ? mapper["value"] : "value";
            this.mapFld._htmlAttributes = (mapper && mapper.htmlAttributes) ? mapper["htmlAttributes"] : "htmlAttributes";
            this.mapFld._selected = (mapper && mapper.selected) ? mapper["selected"] : "selected";
            this.mapFld._category = (mapper && mapper.groupBy) ? mapper["groupBy"] : "groupBy";
        },
        _doDataBind: function () {
            var source = this.model.dataSource, list = this.popupListItems;
            !source || !list || !list.length || list.length < 1 ? this._targetElementBinding()
            : this._isPlainType(list) ? this._plainArrayTypeBinding(list)
            : this._objectArrayTypeBinding(list);
        },
        _isPlainType: function (list) {
            return typeof list[0] != "object";
        },
        _objectArrayTypeBinding: function (list, from) {
            this.dummyUl = $();
            this._mapFields();
            if (this.model.enableSorting) {
                var sortQuery = ej.Query().sortBy(this.mapFld._text, this.model.sortOrder, true);
                list = ej.DataManager(list).executeLocal(sortQuery);
				this.popupListItems = list;
            }
            if (this.model.allowGrouping || this.model.fields.groupBy) {
                this.popupListWrapper.addClass("e-atc-popup");
                var mapCateg = this.mapFld._category, groupedList, groupQuery;
                groupQuery = ej.Query().group(mapCateg);
                if (!this.model.enableSorting) groupQuery.queries.splice(0, 1);
                groupedList = ej.DataManager(list).executeLocal(groupQuery);
                this._swapUnCategorized(groupedList);
                (from == "search") ? this.popupListItems = [] : this._listItem([]);
                for (var i = 0; i < groupedList.length; i++) {
                    if (groupedList[i].key)
                        this.ultag.append(ej.buildTag("li.e-category", groupedList[i].key).attr("role", "option")[0]);
                    this._generateLi(groupedList[i].items, this.mapFld);
                    this.ultag.append(this.dummyUl);
                    for (var j = 0; j < groupedList[i].items.length; j++) {
                        (from == "search") ? this.popupListItems.push(groupedList[i].items[j]) : this._listItem(groupedList[i].items[j], "add");
                    }
                }
            }
            else {
                this._generateLi(list, this.mapFld);
                this.ultag.append(this.dummyUl);//ko binding
            }
            this._trigger('dataBound', { data: list });
        },
        _onScroll: function (e) {
            if (!e.scrollTop) return;
            var scrollerPositon = e.scrollTop, proxy = this;
            var source = this.model.dataSource;
            if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "continuous") {
                var list, queryPromise, skipQuery = ej.Query().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                if (scrollerPositon >= Math.round($(proxy.popupList).find("ul,ol").height() - $(proxy.popupList).height()) && proxy._rawList.length < proxy._totalCount) {
                    proxy._addLoadingClass();
                    if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager && !ej.isNullOrUndefined(proxy.model.dataSource.dataSource.url)) {
                        if (proxy.inputSearch && proxy.inputSearch.val() != "" && this.model.enableServerFiltering) 
                         skipQuery = proxy._addSearchQuery(ej.Query(), !proxy._isPlainType(proxy._rawList)).skip(proxy._getLi().length).clone();
                        else
                        skipQuery = proxy._getQuery().skip(proxy._rawList.length).take(proxy.model.itemsCount).clone();
                        if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                            queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                            queryPromise.done(function (e) {
                                if (!ej.isNullOrUndefined(proxy.model.value) && proxy.model.enableServerFiltering)
                                    e.result = proxy._removeSelectedValue(e.result);
                                proxy.addItem(e.result);
                                proxy._removeLoadingClass();
                                proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                            }).fail(function () {
                                proxy.model.dataSource = null;
                                proxy._removeLoadingClass();
                                proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                            }).always(function (e) {
                                proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                            });
                        }
                    }
                    else if (ej.DataManager && source instanceof ej.DataManager && source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                                proxy.addItem(this._localDataVirtualScroll());
                                window.setTimeout(function () {
                                proxy._removeLoadingClass();
                            }, 100);
                    }
                    else {
                        list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                        proxy.addItem(proxy._removeSelectedValue(list));
                        proxy._removeLoadingClass();
                    }
                }
            } else if (proxy.model.allowVirtualScrolling && proxy.model.virtualScrollMode == "normal") {

                window.setTimeout(function () {
                    if (proxy._virtualCount == 0) {
                        proxy._loadList();
                    }
                }, 300);

            }

        },
        _localDataVirtualScroll: function () {
            var proxy = this;
            var selectValue = (!ej.isNullOrUndefined(proxy.value())) ? proxy.value().split(proxy.model.delimiterChar).length : 0;
            var _rawlist = (proxy._checkValue) ? proxy._rawList.length - selectValue : proxy._rawList.length;
            var queryPromise = ej.DataManager(proxy.model.dataSource.dataSource.json).executeLocal(ej.Query().skip(_rawlist).take(proxy.model.itemsCount).clone());
            return proxy._removeSelectedValue(queryPromise); 
        },
        _removeSelectedValue: function (data) { 
            if (!ej.isNullOrUndefined(this.value())) {
                var listitems = this.value().split(this.model.delimiterChar);
                for (var k = 0; k < listitems.length; k++) {
                    for (var m = 0; m < data.length; m++) {
                        if (data[m][this.mapFld._value] == listitems[k]) 
                            data.splice(data.indexOf(data[m]), 1);
                    }
                }
                return data;
            }
            else
                return data;
        },
        _loadList: function () {
            this._virtualCount++;
            var source = this.model.dataSource;
            var top = this.scrollerObj.scrollTop(), proxy = this, prevIndex = 0, prevPageLoad, nextIndex = null;
            this._currentPage = Math.round(top / (29 * this.model.itemsCount));
            if (($.inArray(this._currentPage, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) {
                if (this._currentPage == 0) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else if (($.inArray(this._currentPage - 1, this._virtualPages)) != -1) {
                    if (($.inArray(this._currentPage + 1, this._virtualPages)) != -1) {
                        this._virtualCount--;
                        return false;
                    } else {
                        this._currentPage = this._currentPage + 1;
                    }
                }
                else {
                    this._currentPage = this._currentPage - 1;
                }
            }
            prevPageLoad = !($.inArray(this._currentPage - 1, this._virtualPages) != -1);
            this._addLoadingClass();
            for (var i = this._virtualPages.length - 1; i >= 0; i--) {
                if (this._virtualPages[i] < this._currentPage) {
                    prevIndex = this._virtualPages[i];
                    if (!(i + 1 == this._virtualPages.length))
                        nextIndex = this._virtualPages[i + 1];
                    break;
                }
            }

            var firstArg = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
            var skipQuery = ej.Query().range(firstArg, this._currentPage * this.model.itemsCount + this.model.itemsCount), queryPromise, list;
            if (ej.DataManager && proxy.model.dataSource instanceof ej.DataManager && !ej.isNullOrUndefined(proxy.model.dataSource.dataSource.url)) {
                var skipParam = prevPageLoad ? (this._currentPage - 1) * this.model.itemsCount : this._currentPage * this.model.itemsCount;
                skipQuery = this._getQuery().skip(skipParam);
                if (prevPageLoad) {
                    for (i = 0; i < skipQuery.queries.length; i++) {
                        if (skipQuery.queries[i].fn == "onTake") {
                            skipQuery.queries.splice(i, 1);
                            break;
                        }
                    }
                    skipQuery.take(2 * this.model.itemsCount);
                }
                if (!proxy._trigger("actionBegin", { requestFrom: "scroll" })) {
                   if (proxy.inputSearch && proxy.inputSearch.val() != "" && this.model.enableServerFiltering) var skipQuery = proxy._addSearchQuery(ej.Query(), !proxy._isPlainType(proxy._rawList)).skip(proxy._getLi().length).clone();
                    queryPromise = proxy.model.dataSource.executeQuery(skipQuery);
                    queryPromise.done(function (e) {
                        e.result = proxy._removeSelectedValue(e.result);
                        proxy._appendVirtualList(e.result, prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                        proxy._removeLoadingClass();
                        proxy._trigger("actionSuccess", { e: e, requestFrom: "scroll" });
                    }).fail(function (e) {
                        proxy._virtualCount--;
                        proxy._removeLoadingClass();
                        proxy._trigger("actionFailure", { e: e, requestFrom: "scroll" });
                    }).always(function (e) {
                        proxy._trigger("actionComplete", { e: e, requestFrom: "scroll" });
                    });
                }
            }
            else if (ej.DataManager && source instanceof ej.DataManager && source.dataSource.offline && (source.dataSource.json && source.dataSource.json.length > 0)) {
                proxy._appendVirtualList(this._localDataVirtualScroll(), prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                window.setTimeout(function () {
                    proxy._removeLoadingClass();
                }, 100);
            }
            else {
                list = ej.DataManager(proxy.model.dataSource).executeLocal(skipQuery);
                proxy._appendVirtualList(proxy._removeSelectedValue(list), prevIndex, proxy._currentPage, nextIndex, prevPageLoad);
                proxy._removeLoadingClass();
            }
        },
        _appendVirtualList: function (list, prevIndex, currentIndex, nextIndex, prevPageLoad) {
            this._virtualCount--;
            this.ultag.find("span.e-virtual").remove();
            if (!ej.isNullOrUndefined(this.activeItem)) this.activeItem.attr("page", "0");
            if (($.inArray(currentIndex, this._virtualPages.sort(function (a, b) { return a - b; }))) != -1) return false;
            if (prevPageLoad && ($.inArray(currentIndex - 1, this._virtualPages.sort()) != -1)) {
                list.splice(0, this.model.itemsCount);
                prevPageLoad = false;
            }
            var items = this.model.itemsCount, tempUl = $("<ul>"), firstVirtualHeight, secondVirtualHeight;
            firstVirtualHeight = prevPageLoad ? ((currentIndex - 1) * items * 29) - (prevIndex * items + items) * 29 : (currentIndex * items * 29) - (prevIndex * items + items) * 29;
            if (firstVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: firstVirtualHeight }));
            this._mapFields();
            this._generateLi(list, this.mapFld);
            $(this.dummyUl).attr("page", currentIndex);
            if (prevPageLoad) {
                $(this.dummyUl).slice(0, items).attr("page", currentIndex - 1);
            }
            if (this.model.showCheckbox) {
                this._appendCheckbox(this.dummyUl);
            }
            tempUl.append(this.dummyUl);
            secondVirtualHeight = (currentIndex * items + items) * 29;
            if (nextIndex != null) secondVirtualHeight = (nextIndex * items * 29) - secondVirtualHeight;
            else secondVirtualHeight = this.ultag.height() - secondVirtualHeight;
            if (secondVirtualHeight != 0) tempUl.append($("<span>").addClass("e-virtual").css({ display: "block", height: secondVirtualHeight }));
            if (this.model.itemsCount > 0 && this.value() != "" && (this.model.dataSource instanceof ej.DataManager && this.model.dataSource.dataSource.offline))
                var selector = this.ultag.find("li").last();
            else
                var selector = this.ultag.find("li[page=" + prevIndex + "]").last();
            selector.next().remove();
            tempUl.children().insertAfter(selector);
            this._virtualPages.push(currentIndex);
            if (prevPageLoad) this._virtualPages.push(currentIndex - 1);
            for (var i = 0; i < list.length; i++) {
                this._listItem(list[i], "add");
            }
            this._virtualUl = this.ultag.clone(true);
            this._renderBoxModel();
        },

        _generateLi: function (list, mapFld) {
            this.mapFld = mapFld;
            this.dummyUl = [];
            if (!list || !list.length || list.length < 1) return false;
            for (var i = 0; i < list.length; i++) {
                var _did = this._getField(list[i], this.mapFld._id),
                    _dimageUrl = this._getField(list[i], this.mapFld._imageUrl),
                    _dimageAttributes = this._getField(list[i], this.mapFld._imageAttributes),
                    _dspriteCss = this._getField(list[i], this.mapFld._spriteCSS),
                    _dtext = this._getField(list[i], this.mapFld._text),
                    _dvalue = this._getField(list[i], this.mapFld._value),
                    _dhtmlAttributes = this._getField(list[i], this.mapFld._htmlAttributes),
                    _dselected = this._getField(list[i], this.mapFld._selected),
                    litag = document.createElement("li");

                if (!ej.isNullOrUndefined(_dvalue) && _dvalue.toString().length > 0) {
                    litag.setAttribute('data-value', typeof _dvalue == "object" ? JSON.stringify(_dvalue) : _dvalue);
                }
                else {
                     litag.setAttribute('data-value', _dtext);
                }
                if (!ej.isNullOrUndefined(_did) && (_did !== ""))
                    litag.setAttribute('id', _did);
                if (!ej.isNullOrUndefined(_dhtmlAttributes) && (_dhtmlAttributes != "")) {
                    this._setAttr(litag, _dhtmlAttributes);
                }

                if (this.model.template) {
                    $(litag).append(this._getTemplatedString(list[i]));
                } else {
                    if (!ej.isNullOrUndefined(_dimageUrl) && (_dimageUrl != "")) {
                        var imgtag = document.createElement("img");
                        this._setClass(imgtag, "e-align")._setAttr(imgtag, { 'src': _dimageUrl, 'alt': _dtext });
                        if ((_dimageAttributes) && (_dimageAttributes != "")) {
                            this._setAttr(imgtag, _dimageAttributes);
                        }
                        litag.appendChild(imgtag);
                    }
                    if (!ej.isNullOrUndefined(_dspriteCss) && (_dspriteCss != "")) {
                        var divtag = document.createElement("div");
                        this._setClass(divtag, 'div.e-align ' + _dspriteCss + ' sprite-image');
                        litag.appendChild(divtag);
                    }
                    if (_dselected) {
                        this._setClass(litag, "chkselect");
                    }
                    {
                        if (ej.isNullOrUndefined(_dtext)) _dtext = String(_dtext);
                        var textEle = document.createElement("span");
                        textEle.innerHTML = _dtext;                      
                        this._setClass(textEle, "e-ddltxt");
                        litag.innerHTML += textEle.outerHTML;
                    }
                }
                this._setAttr(litag, { "role": "option", "unselectable": "on" });
                this.dummyUl.push(litag);
             
            }
        },

        _setAttr: function (element, attrs) {
            if (typeof attrs == "string") {
                var sAttr = attrs.replace(/['"]/g, "").split("=");
                if (sAttr.length == 2) element.setAttribute(sAttr[0], sAttr[1]);
            }
            else {
                for (var idx in attrs) {
                    if ((idx == 'styles' || idx == 'style') && typeof attrs[idx] == 'object') {
                        for (var prop in attrs[idx]) {
                            element.style[prop] = attrs[idx][prop];
                        }
                    }
                    else
                        element.setAttribute(idx, attrs[idx]);
                }
            }
            return this;
        },
        _setClass: function (element, classNme) {
            element.className += " " + classNme;
            return this;
        },
        _removeClass: function (element, classNme) {
            var index = element.className.indexOf(classNme);
            if (index >= 0) {
                if (index != 0 && element.className[index - 1] === " ")
                    element.className = element.className.replace(" " + classNme, "");
                else element.className = element.className.replace(classNme, "");
            }
            return this;
        },
        _hasClass: function (element, classNme) {
            return element.className.indexOf(classNme) >= 0;
        },
        _swapUnCategorized: function (list) {
            $(list).each(function (i, obj) {
                if (!obj.key) {
                    for (var j = i; j > 0; j--) {
                        list[j] = list[j - 1];
                    }
                    list[j] = obj;
                    return false;
                }
            });
        },

        _getField: function (obj, fieldName) {
            return ej.pvt.getObject(fieldName, obj);
        },

        _getTemplatedString: function (list) {

            var str = this.model.template, start = str.indexOf("${"), end = str.indexOf("}");
            while (start != -1 && end != -1) {
                var content = str.substring(start, end + 1);
                var field = content.replace("${", "").replace("}", "");
                str = str.replace(content, this._getField(list, field));
                start = str.indexOf("${"), end = str.indexOf("}");
            }
            return str;
        },

        _setWatermark: function () {
            if ((this.element.val() == "") && this._trim(this._visibleInput.val()) == "") {
				var watermark=(this.model.watermarkText != null)? this.model.watermarkText:this._localizedLabels.watermarkText;
                if (this._isWatermark)
                    this._visibleInput.attr("placeholder", watermark);
                else
                    this._hiddenSpan.css("display", "block").text(watermark);
                //In visual mode, to show watermark text when no items selected.
                if (this.model.multiSelectMode == "visualmode" && this._ulBox && this._ulBox.find('li').length == 0) this._swapUlandInput(false);
            }
        },

        _checkboxHideShow: function (value) {
            if (value) {
                this.listitems = this._getLi();
                var chklist = this.listitems.find('input[type=checkbox]');
                if (chklist.length == 0) {
                    this._appendCheckbox(this.listitems);
                }
            }

            else
                this._removeCheck(this.popupList);
            this.model.showCheckbox = value;
			this._virtualUl = this.ultag.clone(true);
        },
        
        _setCheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.checkAll();
            else this.model.checkAll = false;
        },
        _setUncheckAll: function (value) {
            if (!this._isSingleSelect() && (value))
                this.uncheckAll();
            else this.model.uncheckAll = false;
        },

        checkAll: function () {
            var _nodes = this._selectedIndices, isAlreadySelected = false;
            this._mapFields();
            this.listitems = this._getLi();
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(!this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && !this._isChecked(checkboxWrap)) {
                            this._setClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":true});
                            checkboxWrap.firstChild.checked = true;
                            isAlreadySelected = false;
                        }
                        else isAlreadySelected = true;
                    }
                    else {
                        isAlreadySelected = false;
                        $(this.listitems[i]).addClass("e-active");
                    }
                    else isAlreadySelected = true;
                    
                    if (!isAlreadySelected) {
						this.checkedStatus = true;
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._selectedItemsID.push(this._itemID);
                        this._createListHidden(this._hiddenValue);
                        if (this.model.multiSelectMode == "visualmode") {
                            this._ulBox.append(this._createBox(this._currentText,this._hiddenValue));
                            if (this._isPopupShown()) this._setListPosition();
                        }
                        this._addText(this._currentText);
                        if ($.inArray(i, _nodes) == -1) {
                            this._selectedIndices.push(i);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._cascadeAction();
                    }
                }
                this.model.itemValue = this._selectedValue;
                this.model.uncheckAll = false;
                this.model.checkAll = true;
                this._activeItem = -1;
                this._setWatermark();
            }
        },
        _createListHidden: function (value) {
            var arrayHidden = document.createElement("input");
			var quote = /'/;
			if(quote.test(value))
			   value =value.replace(quote,"&apos;")
            this._setAttr(arrayHidden, { type: "hidden", name: this._name, value: value, id: "#" + value });
            this.container.append(arrayHidden);
            $(this.element).attr("name", "hiddenEle");
        },
        _removeListHidden: function (value) {
			var quote = /'/;
			if(quote.test(value))
			     value =value.replace(quote,"&apos;")
            var arrayEle = this.container.find("[id='#" + value + "']");
            $(arrayEle).remove();
			if (!this._isSingleSelect())this.element.attr("name", this._name);
        },
        _getAttributeValue: function (val) {
            return val ? val.getAttribute("data-value") || val.getAttribute("value") : null;
        },
       
        _selectCheckedItem: function (chkitems) {
            for (var i = 0; i < chkitems.length; i++) {
                this._activeItem = chkitems[i];
                this._enterTextBoxValue();
            }
        },

        /* will deprecate with uncheckAll method */
        unCheckAll: function () { this.uncheckAll(); },

        uncheckAll: function () {
            var isAlreadySelected = false;
            this.listitems = this._getLi();
            this._mapFields();
            if (!this._isSingleSelect()) {
                for (var i = 0; i < this.listitems.length; i++) {
                    this._currentText = this._isPlainType(this.popupListItems) ? this.popupListItems[i] : this._getField(this.popupListItems[i], this.mapFld._text);
                    this._hiddenValue = this._getAttributeValue(this.listitems[i]) || this._currentText;
                    if(this._checkContains(this._hiddenValue))
                    if (this.model.showCheckbox) {
                        var checkboxWrap = $(this.listitems[i]).children(".e-checkwrap")[0];
                        if (checkboxWrap && this._isChecked(checkboxWrap)) {
                            this._removeClass(checkboxWrap, "e-check-act");
							this._setAttr(checkboxWrap,{"aria-checked":false});
                            checkboxWrap.firstChild.checked = false;
                            isAlreadySelected = true;
                        }
                        else isAlreadySelected = false;
                    }
                    else {
                        $(this.listitems[i]).removeClass("e-active");
                        isAlreadySelected = true;
                    }
                    else isAlreadySelected = false;
                    
                    if (isAlreadySelected) {
                        this.checkedStatus = false;
                        this._activeItem = i;
                        this.activeItem = this._getActiveItem();
                        this._removeText(this._hiddenValue);
                        this._removeListHidden(this._hiddenValue);
                        var _nodes = this._selectedIndices;
                        if ($.inArray(i, _nodes) > -1) {
                            this._selectedIndices.splice($.inArray(i, _nodes), 1);
                            this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                        }
                        this._selectedValue = this._getAttributeValue(this.listitems[i]) || "";
                        this._itemID = $(this.listitems[i]).attr("id");
                        if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "")
                            this._removeSelectedItemsID();
                        if (!this._initValue)
                            this._trigger('checkChange', { isChecked: this.checkedStatus, data: this.model });
                        var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: i, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus };
                        this._updateValue(this.element.val());
                        this._updateText();
                        if (!this._initValue)
                            this._trigger("change", args);
                        this._cascadeAction();
                        if (this.model.multiSelectMode == "visualmode") {
                            this._deleteBoxCheck(this._hiddenValue);
                            if (this._isPopupShown())
                                this._setListPosition();
                        }
                    }
                    
                }
                this.model.itemValue = this._selectedValue;
                this.model.checkAll = false;
                this.model.uncheckAll = true;
                this._setWatermark();
                this._activeItem = -1;
            }

        },
        _removeSelectedItemsID: function () {
            var itemToRemove;
            itemToRemove = this._selectedItemsID.indexOf(this._itemID);
            this._selectedItemsID.splice(itemToRemove, 1);
            this._itemID = "";
        },


        _refreshScroller: function () {
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.popupList.find(".e-content, .e-vhandle").removeAttr("style");
            this.popupList.find(".e-vhandle div").removeAttr("style");
            this.popupList.children(".e-content").removeClass("e-content");
            var flag = this._isPopupShown();
            this.popupListWrapper.css("display", "block");
            this.popupList.css({ "display": "block" });  // For get the height of the popup
            this.scrollerObj.model.height = Math.ceil(this._getPopupHeight());
            this.scrollerObj.refresh();
            if (!this.model.enablePopupResize) { // to set popup height as per the no.of list items
                this.popupList.css("height", "auto");
                this.popupListWrapper.css("height", "auto");
            }
            this.scrollerObj.option("scrollTop", 0);
            if (!flag) this.popupListWrapper.css("display", "none");
        },
        _enablePopupResize: function () {
            if (this.model.enablePopupResize) {
                this.popupListWrapper.addClass("e-resizable").append(ej.buildTag("div.e-resizebar").append(ej.buildTag("div.e-icon e-resize-handle")))
                .find(".e-resize-handle").addClass((this.model.enableRTL) ? "e-rtl-resize" : "");
                this._resizePopup();
            }
        },


        _resizePopup: function () {
            var proxy = this, started = false;
            this.popupListWrapper.find("div.e-resize-handle").ejResizable(
                {
                    minHeight: proxy._validatePixelData(proxy.model.minPopupHeight),
                    minWidth:  proxy._validatePixelData(proxy.model.minPopupWidth),
                    maxHeight: proxy._validatePixelData(proxy.model.maxPopupHeight),
                    maxWidth:  proxy._validatePixelData(proxy.model.maxPopupWidth),
                    handle: "e-ddl-popup",
                    resizeStart: function (event) {
                        if (!proxy.model.enabled)
                            return false;
                        !started && proxy._trigger("popupResizeStart", { event: event });
                        started = true;
                    },
                    resize: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        proxy._trigger("popupResize", { event: event });
                    },
                    resizeStop: function (event) {
                        if (started) {
                            proxy._refreshPopupOnResize(proxy.model.popupHeight, proxy.model.popupWidth);
                            started && proxy._trigger("popupResizeStop", { event: event });
                            started = false;
                        }
                    },
                    helper: function (event) {
                        var reElement = $(event.element).parents("div.e-ddl-popup");
                        proxy._refreshPopupOnResize($(reElement).outerHeight(), $(reElement).outerWidth());
                        return $(proxy.popupListWrapper);
                    }
                });
        },

        _refreshPopupOnResize: function (currHeight, currWidth) {
            if (currHeight) this.model.popupHeight = currHeight;
            if (currWidth) this.model.popupWidth = currWidth;
            this.popupListWrapper.css({ "height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight) });
            this._setListWidth();
            this._refreshScroller();
        },

        _setListWidth: function () {
            var width = this.model.popupWidth;
            if (width != "auto") this.popupListWrapper.css({ "width": width });
            else this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            this.popupListWrapper.css({ "max-width": this._validatePixelData(this.model.maxPopupWidth) });
        },

        _setListHeight: function () {
            if (this.model.enablePopupResize && this.model.enableFilterSearch && this.model.minPopupHeight && this.model.minPopupHeight.toString().indexOf("%") <0 && this._validatePixelData(this.model.minPopupHeight) == 20)
                this.model.minPopupHeight = '65'; /* adding default height of search box*/
            this.model.enablePopupResize ? this.popupListWrapper.css({ "min-height": this._validatePixelData(this.model.minPopupHeight), "max-height": this._validatePixelData(this.model.maxPopupHeight), "height": this._validatePixelData(this.model.popupHeight) }) :
            this.popupListWrapper.css({ "max-height": this._validatePixelData(this.model.popupHeight), "min-height": this._validatePixelData(this.model.minPopupHeight) });
        },
		_validatePixelData: function (data) {			
			return (data && !isNaN(data))? Number(data):data;
		},
        _getPopupHeight: function () {
            var wrap = this.popupListWrapper.height();
            if (this.model.enablePopupResize) wrap -= this.popupListWrapper.find(">div.e-resizebar").height();
            if (this.model.headerTemplate && this.headerTemplate) wrap -= this.headerTemplate.height();
            if (this.model.enableFilterSearch && this.inputSearch) {
                var ele = this.inputSearch.parent(".e-in-wrap");
                wrap -= (parseInt(ele.css("height")) + parseInt(ele.css('margin-top')) + parseInt(ele.css('margin-bottom')));
            }
            return wrap;
        },

        _refreshPopup: function () {
            if (this.model.popupWidth == "auto" && !this._validatePixelData(this.model.minPopupWidth)) this.popupListWrapper.css({ "min-width": this.wrapper.width() });
			else if(this._validatePixelData(this.model.minPopupWidth))this.popupListWrapper.css({ "min-width": this._validatePixelData(this.model.minPopupWidth) });
            if(this.scrollerObj != undefined) this._refreshScroller();
            this._setListPosition();
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupListWrapper.outerHeight(),
            popupWidth = this.popupListWrapper.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupListWrapper.outerWidth() - elementObj.outerWidth();
            this.popupListWrapper.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });

        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupListWrapper);
        },


        _showResult: function () {
            var proxy = this;
            var args = { text: this._visibleInput[0].value, value: this._selectedValue, refreshPopup: true };
            if (this._trigger("beforePopupShown", args)) return;
            if (args.refreshPopup) this._refreshPopup();
            $(this.popupListWrapper).slideDown(this.model.enableAnimation ? 200 : 1, function () {
                $(document).on("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                if(!(ej.isDevice()))
                proxy._on(ej.getScrollableParents(proxy.wrapper), "scroll", proxy._hideResult);
            });
            this.element[0].setAttribute("aria-expanded", true);
            this._listSize =  this._getLi().length;
            this.wrapper.addClass("e-popactive");
            this._trigger("popupShown", { text: this._visibleInput[0].value, value: this._selectedValue });
            this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
        },

        _OnWindowResize: function (e) {
            if (!ej.isNullOrUndefined(this.model) && this._isPopupShown()) {
                this._refreshPopup();
            }
        },
        _hideResult: function (e) {
            if (this.model && this._isPopupShown()) {
				if (!ej.isNullOrUndefined(e) && !ej.isNullOrUndefined(this.inputSearch) && $(this.inputSearch).is(":focus")){
					if(e.type == "scroll" && ej.isTouchDevice())
						return false;
				}
                var proxy = this;
                if (this._trigger("beforePopupHide", { text: this._visibleInput[0].value, value: this._selectedValue })) return;
                $(this.popupListWrapper).slideUp(this.model.enableAnimation ? 100 : 0, function () {
                    $(document).off("mousedown", $.proxy(proxy._OnDocumentClick, proxy));
                });
                if (this.element != null)
                    this.element.attr( "aria-expanded", false );
				if(!(ej.isDevice()))
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
                if (this._visibleInput != null)
                this.wrapper.removeClass("e-popactive");
                    this._trigger("popupHide", { text: this._visibleInput[0].value, value: this._selectedValue });

                setTimeout(function () {
                    proxy._resetSearch();                 
                }, 100);
				this._getLi().find(".e-ddl-anim").removeClass("e-ddl-anim");
            }
        },

        _isPopupShown: function () {
            return (this.popupListWrapper.css("display") == "block");
        },

        _enterTextBoxValue: function () {
            var args, valueModified = true;
            this.removeID = false;
			this.checkedStatus = false;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-check-inact');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}
            args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };
            if (!this._initValue && !this._onSearch && this._raiseEvents){ 
                if(this._trigger("select", args)) {
                    this._setWatermark();
                    return;
                }
            }
            if (this._activeItem >=0 || this._activeItem != null) {
                if (!this._isSingleSelect() && !this._checkContains(this._selectedValue)) {                   
                    if (this.model.showCheckbox) {
                        var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                        if (!this._isChecked(checkboxEle)) {
							this._removeClass(checkboxEle, "e-ddl-anim");	
                            this._setClass(checkboxEle, "e-check-act e-ddl-anim");
                            this._setAttr(checkboxEle,{"aria-checked":true});
                            $(checkboxEle).find(".e-check-input")[0].checked = true;
                        }
                    }
                    else {
                        this.activeItem.addClass('e-active');
                    }
                    if (this.model.multiSelectMode == "visualmode") {
                        this._ulBox.append(this._createBox(this._currentText, this._selectedValue));
                        if (this._isPopupShown())
                            this._setListPosition();
                    }

                    this._maintainHiddenValue();
                    this._addText(this._currentText);
                    this._createListHidden(this._hiddenValue);
                    if ($.inArray(this.selectedIndexValue, this._selectedIndices) == -1) {
                        this._selectedIndices.push(this.selectedIndexValue);
                        this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                    }                
                } else if( this._isSingleSelect()){
                    this.ultag.children("li").removeClass('e-hover').removeClass('e-active');
                    this.activeItem.addClass('e-active');                    
                    this._maintainHiddenValue();
                    this._visibleInput.val(this._currentText);
                    this.element.val(this._hiddenValue);
                    this.selectedItemIndex(this.selectedIndexValue);
                    this.selectedIndex(this.selectedIndexValue);
                    this._selectedIndices[0] = this.selectedIndexValue;
                }
                else valueModified = false;
                if(valueModified) {
					this.checkedStatus = true;
                    this._onValueChange();
                    this._cascadeAction();
                    if (this.selectelement) {
                    if ($("#" + this._id).children().length > this.selectedIndexValue)
                        $("#" + this._id).children()[this.selectedIndexValue].selected = true;
                    }
                }
            }
            this.model.uncheckAll = false;
            this._setWatermark();
			this._uiInteract = false;
        },
        _onValueChange: function () {
            this.model.itemValue = this._selectedValue;
            this._updateText();
            if (this.value() != this.element.val() && !(this.value() == null && this.element.val() =="" )) {
                this._updateSelectedIndexByValue(this.element.val());
                this._updateValue(this.element.val());
				if (!this.model.showCheckbox && this.model.multiSelectMode == "none" && (this.model.value == null || this.model.value == "")){
					this.model.itemValue = "";
				}
               var args = { text: this._visibleInput[0].value, selectedText: this._currentText, itemId: this.selectedIndexValue, selectedValue: this._selectedValue, value: this._selectedValue, isChecked: this.checkedStatus, isInteraction: !!this._uiInteract };

                if (!this._initValue && !this._onSearch && this._raiseEvents) {
					if(typeof this.model._change == "function") this._trigger("_change", { isChecked: this.checkedStatus, text: this._visibleInput.val(), itemId: this.selectedIndexValue, selectedText: this._currentText, selectedValue: this._selectedValue, value: this.value(), data: this.model, isInteraction: !!this._uiInteract  });
                    this._trigger("change", args);
                    if (this.model.showCheckbox)
                        this._trigger('checkChange', { isChecked: this.checkedStatus, text: this._visibleInput.val(), itemId: this.selectedIndexValue, selectedText: this._currentText, selectedValue: this._selectedValue, value: this._selectedValue, data: this.model });
                }
                this._uiInteract = false;
                if(this.model.enableFilterSearch && this.model.enableServerFiltering){
				this._searchresult = [];
                this._searchresult = this.getItemDataByValue(this.value());
                }
                
            }
        },
        _decode: function (val) {
            return $("<span>").html(val).text();
        },
        _chooseSelectionType: function () {
            this.activeItem = this._getActiveItem();
            this.selectedIndexValue = this._activeItem;
            this._mapFields();
            if (this.model.dataSource != null && (!this._isPlainType(this.model.dataSource) || !this._isPlainType(this.popupListItems))) {
                this._currentText = this._decode(this._getField(this.popupListItems[this._activeItem], this.mapFld._text));
                this._currentText = (this._currentText === "" || this._currentText == null) ? this.activeItem.text() : this._currentText;
                this._selectedValue = this._getField(this.popupListItems[this._activeItem], this.mapFld._value);
                this._selectedValue = (this._selectedValue != null) ? this._selectedValue : this._currentText;
                this._itemID = this._getField(this.popupListItems[this._activeItem], this.mapFld._id);
            } else {
                this._currentText = this.activeItem.text();
                if (this._getAttributeValue(this.activeItem[0]))
                    this._selectedValue = this._getAttributeValue(this.activeItem[0]);
                else {
                    if (this._currentText != null) {
                        if(!ej.isNullOrUndefined(this.activeItem[0]))this.activeItem[0].setAttribute("value", this._currentText);
                        this._selectedValue = this._currentText;
                    }
                    else
                        this._selectedValue = "";
                }
                this._itemID = $(this.activeItem).attr("id");
            }
            if (!ej.isNullOrUndefined(this._itemID) && this._itemID != "") {
                if (!this.model.showCheckbox) {
                    this._selectedItemsID = [];
                    !this.removeID && this._selectedItemsID.push(this._itemID);
                }
                else
                    !this.removeID ? this._selectedItemsID.push(this._itemID) : this._removeSelectedItemsID();
            }
            this.selectedTextValue = this._currentText;
        },
        _maintainHiddenValue: function () {
            this._hiddenValue = this._getAttributeValue(this.activeItem[0]) || this._currentText;
        },
        _removeTextBoxValue: function (delvalue) {
            this._uiInteract = true;
            this.removeID = true;
			this.checkedStatus = true;
			if(this._isFilterInput()){
				for (var j = 0; j < this._getLi().length; j++) {
					if ($(this._getLi()[j]).attr("data-value") == delvalue) {
						this._activeItem = j;
					}
				}
			}
            this._chooseSelectionType();
			if (this._activeItem >=0 || this._activeItem != null) {
				if (this.model.showCheckbox) {
					var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
					$(checkboxEle).removeClass('e-ddl-anim').addClass('e-check-inact e-ddl-anim');
					this.checkedStatus = this._isChecked(checkboxEle);                   
				}
				else{
					this.checkedStatus = this.activeItem.hasClass('e-active')
				}            
			}			
            var args = { text: this._currentText, selectedText: this._currentText, itemId: this.selectedIndexValue, value: this._selectedValue, isChecked: this.checkedStatus };
            if (!this._initValue && !this._onSearch && this._raiseEvents){
                if(this._trigger("select", args)){
                    this._setWatermark();
                    return;
                }
            }                
            this._maintainHiddenValue();
			this._hiddenValue = this._isFilterInput() && !ej.isNullOrUndefined(delvalue) ? delvalue : this._hiddenValue;
            this._removeText(this._hiddenValue);
            this._removeListHidden(this._hiddenValue);
			if(this._isFilterInput() && !this.activeItem.attr("data-value") == delvalue)
				this.activeItem.removeClass('e-active');
            if (!this._isSingleSelect()) {
                if (this.model.showCheckbox) {
                    var checkboxEle = this.activeItem.find('.e-checkwrap')[0];
                    if (this._isChecked(checkboxEle)) {
                        this._removeClass(checkboxEle, "e-check-act");
						this._setAttr(checkboxEle,{"aria-checked":false});
                        $(checkboxEle).find(".e-check-input")[0].checked = true;
                    }
                }
                else this.activeItem.removeClass('e-active');

                if ($.inArray(this.selectedIndexValue, this._selectedIndices) > -1) {
                    this._selectedIndices.splice($.inArray(this.selectedIndexValue, this._selectedIndices), 1);
                    this.model.selectedItems = this.model.selectedIndices = this._selectedIndices;
                }
                if (this.model.multiSelectMode == "visualmode") {
                    this._deleteBoxCheck(this._hiddenValue);
                    if (this._isPopupShown())
                        this._setListPosition();
                }
            }
			this.checkedStatus = false;            
            this._onValueChange();
            if ((this.model.cascadeTo != null) && !this._isSingleSelect() && !this._initValue ) this._cascadeAction();
            this.model.checkAll = false;
            this._setWatermark();
        },


        _createBox: function (text, value) {
            if (!this._checkContains(value)) {

                if (this._ulBox.css('display') == "none" && this._visibleInput.css('display') != "none") this._swapUlandInput(true);
                var span = ej.buildTag("span.e-icon e-close", "", {}, { "unselectable": "on" });
                var li = ej.buildTag("li.e-options").text(text).attr("data-value",value).append(span);
                this._on(span, "click", function (e) {
                    if (!this.model.enabled) return false;
                    this._deleteBox($(e.target).parent());                   
                });
                return li;
            }
        },
        _deleteBoxCheck: function (val) {
            var items = this._ulBox.children('li');
            for (var i = 0; i < items.length; i++) {
                if ($(items[i]).attr("data-value") == val) {
                    $(items[i]).remove();
                }
            }
        },
        _deleteLastBox: function () {
            var items = this._ulBox.children("li:not(.e-search-box)");
            var item = items.last();
            if (item.hasClass("e-active")) this._deleteBox(item);
            else {
                this._removeActive();
                item.addClass("e-active");
            }
        },
        _deleteBox: function (items) {
            for (var i = 0; i < items.length; i++) {              
                var deltext = $(items[i]).attr("data-value");
                if(this._isFilterInput()){ 
                    var datalist = this.getListData();
                    for (var j = 0; j < datalist.length; j++) {
                        var val = this._getField(datalist[j], this.mapFld._value) ? this._getField(datalist[j], this.mapFld._value): this._getField(datalist[j], this.mapFld._text);
                        if (val == deltext) {
                            this._removeTextBoxValue(deltext);
                            break;
                        }
                    }
				}else{
					var listItems = this._getLi();
					for (var j = 0; j < listItems.length; j++) {
						if ($(listItems[j]).attr("data-value") == deltext) {
							this._activeItem = j;
							this._removeTextBoxValue();
							break;
						}
					}
				}
            }
            if (!this._isFocused && !this._isPopupShown())
                this._setWatermark();
        },
        _isFilterInput: function(){
            if(this.model.enableFilterSearch){
                if(!this.inputSearch.val() == ""){
                       return true; 
                }
            }else{
                return false;
            }
        },
        _swapUlandInput: function (inputHide) {
            if (inputHide) {
                this._visibleInput.css('display', 'none');
                this._ulBox.css('display', 'block');
                this.wrapper.css({ 'height': 'auto' });
            }
            else {
                this._visibleInput.css('display', 'block');
                this._ulBox.css('display', 'none');
                this.wrapper.css({ 'height': this.model.height });
            }
        },
        _removeActive: function () {
            this._ulBox.children("li").removeClass("e-active");
        },
        _adjustWidth: function () {
            var tempSpan = ej.buildTag("span", this._visibleInput.val());
            this.container.append(tempSpan);
            this._visibleInput.width(tempSpan.width() + 30);
            tempSpan.remove();
        },
        _destroyBoxModel: function () {
            this._visibleInput.css('display', 'block');
            this.wrapper.height(this.model.height);
            this._ulBox.remove();
			this._ulBox = null;
            this._off(this.container, "click");
        },

        _removeListHover: function () {
            this.ultag.children("li").removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            activeItem.addClass("e-hover");
            this.scrollerObj.setModel({ "scrollTop": this._calcScrollTop('hover') });
            activeItem.focus();
        },
        _getLi: function () {
            return this.ultag.children("li:not('.e-category'):not('.e-nosuggestion')");
        },
        _calcScrollTop: function (val) {
            var ulH = this.ultag.outerHeight(), li = this.ultag.find("li"), liH = 0, index, top, i;
            if (this._selectedIndices && this._selectedIndices.length > 0 && val == "active") {
                var getLi = this._getLi();
                index = this._selectedIndices.length == getLi.length ? 0
                : this._selectedIndices[this._selectedIndices.length - 1];
                if (this.model.fields.groupBy != null || this.ultag.find("li.e-category").length > 0) {
                    index = $.inArray(getLi.eq(index)[0], li);
                }
            }
            else index = this.ultag.find("li.e-" + val).index();

            for (i = 0; i < index; i++) { liH += li.eq(i).outerHeight(true); }
            top = liH - ((this.popupList.outerHeight() - li.eq(index).outerHeight(true)) / 2);
            return top < 0 ? 0 : top;
        },
        _getActiveItem: function () {
            return this._getLi().eq(this._activeItem);
        },
        _setDimentions: function () {
            if (this.model.height)
                this.wrapper.height(this.model.height);
            if (this.model.width)
                this.wrapper.width(this.model.width);
        },


        _roundedCorner: function (val) {
            if (val) {
                this.container.addClass("e-corner");
                this.popupListWrapper.addClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                this.popupListWrapper.removeClass("e-corner");
                if (this.inputSearch) this.inputSearch.parent('.e-in-wrap').removeClass("e-corner");
            }

        },

        _enabled: function (boolean) {
            if (boolean) this.enable();
            else this.disable();
        },

        _RightToLeft: function () {
            if (this.model.enableRTL) {
                this.wrapper.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
            }

        },
        _dropbtnRTL: function () {
            if (this.model.enableRTL) {
                this.popupListWrapper.addClass("e-rtl").find(".e-resize-handle").addClass("e-rtl-resize");
                this.popupList.addClass("e-rtl");
            }
            else {
                this.popupListWrapper.removeClass("e-rtl").find(".e-resize-handle").removeClass("e-rtl-resize");
                this.popupList.removeClass("e-rtl");
            }
        },
        _OnDropdownClick: function (e) {
            this._preventDefaultAction(e);
            if (($(e.target).is("li") && $(e.target).parent().hasClass("e-boxes")) || ($(e.target).parents("ul").hasClass("e-boxes") && $(e.target).hasClass("e-icon e-close")))
                return false;
            if (this.model.readOnly || this._readOnly) return false;
            if (this.ultag.find('li').length > 0 && ((e.which && e.which == 1 ) ||(e.button && e.button == 0) )) {
                this._OnPopupHideShow();
            }
        },
        _OnPopupHideShow: function () {
            if (this._isPopupShown()) {
                this._hideResult();
            }
            else {
				this._showResult();
				if (this.model.enableFilterSearch){
					if(this.getSelectedItem().length == 0)
						this.ultag.find("li:first").addClass("e-hover");
					else{
						var length = this.getSelectedItem().length;
						$(this.getSelectedItem()[length -1]).addClass("e-hover");
					}
                    $(this.inputSearch).focus();
				}
				else
					this.wrapper.focus();
            }
        },

        _showFullList: function () {
            var source = this.model.dataSource;
            if (ej.DataManager && source instanceof ej.DataManager) {
                if (!source.dataSource.offline && !(source.dataSource.json && source.dataSource.json.length > 0)) {
                    var proxy = this;
                    proxy._initDataSource(source);
                }
                else this._getFilteredList(source.dataSource.json);
            }
            else this._getFilteredList(source);
        },
        _getFilteredList: function (list) {
            if (!list || !list.length || list.length < 1) {
                this._targetElementBinding();
                this._renderRemaining();
            }
            else {
                var listItem = ej.DataManager(list).executeLocal(this._isPlainType(list) ? ej.Query() : this._getQuery(true));
                this._totalCount = listItem.count;
                this._listItem(listItem.result ? listItem.result : listItem);
                this._renderPopupList();
                this._rawList =  this.popupListItems.slice();
            }
        },

        _cascadeAction: function () {
            if (this.model.cascadeTo) {
                var citem = this.model.cascadeTo.split(","), i;
                for (i = 0; i < citem.length; i++) {
                    if ($('#' + citem[i]).hasClass("e-dropdownlist")) {
                        this._doCascadeAction(citem[i], this, this.checkedStatus);
                    }
                    else {
                        $('#' + citem[i]).on("ejDropDownListcreate", { Obj: this, status: this.checkedStatus }, function (e) {
                            if (!ej.isNullOrUndefined(e.data.Obj.getValue()) && e.data.Obj.getValue() != "") {
                                e.data.Obj._doCascadeAction(this.id, e.data.Obj, e.data.status);
                            }
                        });
                    }
                }
            }
        },
        _doCascadeAction: function (id, parentObj, status) {
            parentObj._currentValue = parentObj._getField(parentObj.popupListItems[parentObj._activeItem], parentObj.mapFld._value);
            parentObj.selectDropObj = $('#' + id).ejDropDownList('instance');
            var args = { cascadeModel: parentObj.selectDropObj.model, cascadeValue: parentObj._currentValue, setCascadeModel:{}, requiresDefaultFilter: true };
            this._trigger("cascade", args);
            parentObj.selectDropObj._setCascadeModel = args.setCascadeModel;
            if (ej.isNullOrUndefined(parentObj[id])) {
                parentObj[id] = parentObj.selectDropObj.model.dataSource;
            }
            (ej.DataManager && parentObj[id] instanceof ej.DataManager) ?
                parentObj._cascadeOdataInit(parentObj[id], args.requiresDefaultFilter, status, args.cascadeQuery) :
            parentObj._cascadeJsonInit(parentObj.selectDropObj, parentObj[id], parentObj.mapFld._value, args.requiresDefaultFilter, status, args.cascadeQuery);
        },
        _cascadeOdataInit: function (_dSource, requiresFilter, status, cascadeQuery) {
            var proxy = this, queryPromise, tempQuery;
            proxy._dQuery = this.selectDropObj._getQuery().clone();
            tempQuery = proxy._dQuery.clone();
            requiresFilter ? tempQuery.where(proxy.mapFld._value, "equal", proxy._currentValue) : tempQuery = cascadeQuery;
            proxy.selectDropObj._addLoadingClass();
            if (!proxy._trigger("actionBegin", { requestFrom: "cascade" })) {
                queryPromise = _dSource.executeQuery(tempQuery);
                queryPromise.fail(function (e) {
                    proxy._changedSource = null;
                    proxy.selectDropObj.setModel({ dataSource: proxy._changedSource, enabled: false });
                    proxy._trigger("actionFailure", { e: e, requestFrom: "cascade" });
                }).done(function (e) {
                    proxy._trigger("actionSuccess", { e: e, requestFrom: "cascade" });
                    proxy._cascadeDataBind(proxy.selectDropObj, e.result, status);
                    proxy.selectDropObj._removeLoadingClass();
                }).always(function (e) {
                    proxy._trigger("actionComplete", { e: e, requestFrom: "cascade" });
                });
            }
        },

        _cascadeJsonInit: function (cascadeDropDownObj, _dSource, mapFld, requiresFilter, status, cascadeQuery) {           
            var tempQuery = requiresFilter ? ej.Query().where(mapFld, "==", this._currentValue) : cascadeQuery
            var changedSource = ej.DataManager(_dSource).executeLocal(tempQuery);
            this._cascadeDataBind(cascadeDropDownObj, changedSource, status);
        },

        _cascadeDataBind: function (cascadeDropDownObj, changedSource, status) {
			var cascadeVal  = cascadeDropDownObj.value();
            if ((this.model.showCheckbox && status) || (this.model.multiSelectMode != "none" && this.activeItem.hasClass("e-active"))) {
                this._changedSource = (!ej.isNullOrUndefined(this._changedSource)) ? this._changedSource.concat(changedSource) : changedSource;
            }
            else if (!this.model.showCheckbox && this.model.multiSelectMode == "none") this._changedSource = changedSource;
            else {
                for (var i = 0; i < changedSource.length; i++) {
                    if (this._isPlainType(changedSource) && this._isPlainType(this._changedSource)) this._changedSource.splice(this._changedSource.indexOf(changedSource[i]), 1);
                    else {
                        for (var j = 0; j < this._changedSource.length; j++) {
                            if (JSON.stringify(this._changedSource[j]) == JSON.stringify(changedSource[i]))
                                this._changedSource.splice(j, 1);
                        }

                    }
                }
                cascadeDropDownObj.setModel({ dataSource: null });
            }
			var cascadeValFn = cascadeDropDownObj.model.value;
            var cascadeModel = JSON.parse(JSON.stringify(cascadeDropDownObj.model)),enable;
            cascadeDropDownObj.setModel({ dataSource: this._changedSource, enabled: this._changedSource.length > 0 });
			if( !this._isSingleSelect() ) cascadeDropDownObj.selectItemByValue(cascadeVal);
            if (cascadeDropDownObj.model.showCheckbox || cascadeDropDownObj.model.multiSelectMode != "none") {
                $("input:hidden[id^='#'][name=" + cascadeDropDownObj._id + "]").remove();
            }
            
            if (!cascadeDropDownObj._setSelectedItem) {
                var selectProp = ["value", "text", "selectedIndex", "selectedIndices"];
                for (var m = 0; m < selectProp.length ; m++)
                    cascadeDropDownObj.model[selectProp[m]] = cascadeModel[selectProp[m]];
				cascadeDropDownObj.model["value"] = cascadeValFn;
                cascadeDropDownObj._finalize();                
            }            
            else {                                               
               cascadeDropDownObj.setModel(cascadeDropDownObj._setCascadeModel);
            }
            cascadeDropDownObj._setSelectedItem = true;
        },        

        _OnMouseEnter: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            var targetEle;
            this.ultag.children("li").removeClass("e-hover");
            if ($(e.target).is("li:not('.e-category')")) { $(e.target).addClass("e-hover"); }
            if ($(e.target).hasClass("e-disable"))
                $(e.target).removeClass('e-hover');
            else if (e.target.tagName != "li") {
                targetEle = $(e.target).parents("li:not('.e-category')");
                $(targetEle).addClass("e-hover");
            }
            var activeItem;
            this.ultag.children("li:not('.e-category')").each(function (index) {
                if ($(this).hasClass("e-hover")) {
                    activeItem = index;
                    return false;
                }
            });
            this._activeItem = activeItem;
        },
        _OnMouseLeave: function (e) {
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            this.ultag.children("li").removeClass("e-hover");
        },
        _OnMouseClick: function (e) {
            this._uiInteract = true;
            if (!this.model.enabled || this.model.readOnly || this._readOnly) return false;
            if (this.model.enableFilterSearch && $(e.target).is("li") && $(e.target).hasClass('e-nosuggestion')) return false;
            else if (($(e.target).is("li") && !$(e.target).hasClass('e-disable')) || (!$(e.target).is("li") && !$(e.target).closest("li").hasClass('e-disable'))) {
                if (this._isSingleSelect()) {
                    this._enterTextBoxValue();
                    this._hideResult();
                } else {
                    if (this.model.showCheckbox) {
                        var liEle = e.target.nodeName === "LI" ? e.target : $(e.target).parents("li.e-hover"),
                        checkboxEle = $(liEle).find('.e-checkwrap')[0];
                        this._onCheckChange({ target: checkboxEle });
                    }
                    else {
                        var ele = $(e.target).is("li") ? e.target : $(e.target).closest("li")[0];
                        this._activeItem = $.inArray(ele, this._getLi());
                        if ($(ele).hasClass("e-active")) this._removeTextBoxValue();
                        else this._enterTextBoxValue();
                    }
                   
                }
            }
        },        

        _OnDocumentClick: function (e) {
            if (this.model && (!this.model.enabled || this.model.readOnly || this._readOnly)) return false;
            if (!$(e.target).is(this.popupList) && !$(e.target).parents(".e-ddl-popup").is(this.popupListWrapper) &&
                !$(e.target).is(this._visibleInput) && !$(e.target).parents(".e-ddl").is(this.wrapper)) {
                this._hideResult();
            }
            else if ($(e.target).is(this.inputSearch)) {
                this.inputSearch.focus();
            }
            else if ($(e.target).is(this.popupList) || $(e.target).parents(".e-ddl-popup").is(this.popupListWrapper))
                this._preventDefaultAction(e);
        },

        _OnKeyPress: function (e) {
            if (this.model.enableIncrementalSearch && e.keyCode != 13) {
                this._OnTextEnter((ej.browserInfo().name == "mozilla") ? e.charCode : e.keyCode);
            }
            if (e.keyCode == 32) this._preventDefaultAction(e);
        },
        _OnTextEnter: function (from) {
            var proxy = this;
            this._incqueryString += String.fromCharCode(from);
            if (this._incqueryString.length > 0) {
                setTimeout(function () { proxy._incqueryString = ""; }, 1000);
            }
            var list = this._getLi(), i,
            caseSence = this.model.caseSensitiveSearch,            
            str, queryStr = this._incqueryString,
            querylength = this._incqueryString.length, searchflag = false;

            if (!caseSence) queryStr = queryStr.toLowerCase();

            for (i = 0; i < list.length; i++) {
                str = $(list[i]).text();
                str = caseSence ? str : str.toLowerCase();
                if (str.substr(0, querylength) == queryStr) {
                    this._activeItem = i;
                    if (this._isSingleSelect()){
						this._enterTextBoxValue();
						this.scrollerObj.setModel({ scrollTop: this._calcScrollTop('active') });
					}
                    else if (this._isPopupShown()) {
                        this._removeListHover();                      
                        this._addListHover();
                    } 
                    searchflag = true;
                }                 
                if (searchflag) break;
            }

        },

        _selectItem: function (current) {
            if (!this._isSingle) this._clearTextboxValue();
            this._activeItem = current;
            this._addListHover();
            this._enterTextBoxValue();
        },
        _focusItem: function (current) {
            this._removeListHover();
            this._activeItem = current;
            this._addListHover();
        },
        _selectFocusedItem: function (current) {
            this._focusItem(current);
            this._enterTextBoxValue();
        },
        
        _selectShiftDown: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = start; n <= stop; n++) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftUp: function (start, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            for (var n = stop; n >= start ; n--) {
                if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                    this._selectFocusedItem(n);
                }
            }
        },
        _selectShiftHome: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current >= 0 && current <= this._listSize - 1) {
                if (current == 0) this._clearTextboxValue();
                else {
                    for (var n = current; n >= stop ; n--) {
                        if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                            this._activeItem = n;
                            this._enterTextBoxValue();
                        }
                    }
                }
                this._activeItem = current;
                if (current == 0) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": 0 });
            }
        },
        _selectShiftEnd: function (current, stop, isCtrl) {
            if (!isCtrl) this._clearTextboxValue();
            if (current <= this._listSize - 1) {
                if (current == stop) this._clearTextboxValue();
                else 
                for (var n = current; n <= stop; n++) {
                    if ($.inArray(n, this._disabledItems) < 0 && $.inArray(n, this.model.selectedIndices) < 0) {
                        this._activeItem = n;
                        this._enterTextBoxValue();
                    }
                }
                this._activeItem = current;
                if (current == stop) this._enterTextBoxValue();
                this.scrollerObj.setModel({ "scrollTop": this.ultag.outerHeight() });
            }
        },


        _getLastFocusedLi: function () {
            return this._selectedIndices && this._selectedIndices.length > 0 ? this._selectedIndices[this._selectedIndices.length - 1] : null;
        },

        _getLastShiftFocusedLi: function (index, isDown) {
            var step = isDown ? index - 1 : index + 1;
            if ($.inArray(step, this._selectedIndices) < 0) {
                return index;
            }
            else {
                return this._getLastShiftFocusedLi(step, isDown);
            }
        },

        _shiftUp: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(0, step, false, false, true);
            }
            else if (current > 0 && current <= this._listSize - 1) {

                var select = this._disableItemSelectUp(current - step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current - 1 == this._selectedIndices[this._selectedIndices.length - 2])
                            for (var s = 1; s <= step; s++) {
                                if (current - s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current + 1 -s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current - s);
                                }
                                else break;
                            }
                        else {
                            var next = this._getLastShiftFocusedLi(this._getLastFocusedLi(), false);
                            this._selectShiftUp(select, next, isCtrl);
                        }
                    }
                    else {
                        this._moveUp(current, step, false);
                    }

                }

            }
        },

        _shiftDown: function (current, step, isCtrl) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, false, true);
            }
            else if (current < this._listSize - 1) {
                var select = this._disableItemSelectDown(current + step)
                if (select != null) {
                    if (this._getLastFocusedLi() != null) {
                        if (this._selectedIndices.length > 1 && current + 1 == this._selectedIndices[this._selectedIndices.length - 2]) {
                           for (var s = 1; s <= step; s++) {
                                if (current + s == this._selectedIndices[this._selectedIndices.length - 2]) {
                                    this._activeItem = current - 1 +s;
                                    this._removeTextBoxValue();
                                    this._focusItem(current + s);
                                }
                                else break;
                            }
                        }
                        else {
                            var start = this._getLastShiftFocusedLi(this._getLastFocusedLi(), true);
                            this._selectShiftDown(start, select, isCtrl);
                        }
                    }
                    else {
                        this._moveDown(current, step, false);
                    }
                }

            }
        },
        _moveUp: function (current, step, isMulti) {
            if (current == null || current <= 0) {
                this._checkDisableStep(0, step, false, isMulti);
            }
            else if (current > this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, false, isMulti);
            }
            else if (current > 0 && current <= this._listSize - 1) {
                this._checkDisableStep(current, step, false, isMulti);
            }
        },
        _moveDown: function (current, step, isMulti) {
            if (current == null || current < 0) {
                this._checkDisableStep(-1, step, true, isMulti);
            }
            else if (current == 0) {
                this._checkDisableStep(0, step, true, isMulti);
            }
            else if (current >= this._listSize - 1) {
                this._checkDisableStep(this._listSize - 1, step, true, isMulti);
            }
            else if (current < this._listSize - 1) {
                this._checkDisableStep(current, step, true, isMulti);
            }
        },
        _checkDisableStep: function (current, step, isdown, isMulti, shift) {
            var command = isdown ? "_disableItemSelectDown" : "_disableItemSelectUp";
            var index = isdown ? current + step : current - step;
            var select = this[command](index);
            if (select == null) {
                for (var i = step; i >= 0; i--) {
                    index = isdown ? current + i : current - i;
                    select = this[command](index);
                    if (select != null) break;
                }
            }
            if (select != null) {
                isMulti ? this._focusItem(select) : this._selectItem(select);
                if (shift && isMulti) this._enterTextBoxValue();
            }

        },
        _disableItemSelectDown: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    return this._disableItemSelectDown(current + 1);
                }
            }
            else return this._listSize - 1;
        },

        _disableItemSelectUp: function (current) {
            if (current == null || current < 0) current = 0;
            if (current < this._listSize) {
                if ($.inArray(current, this._disabledItems) < 0) {
                    return current;
                }
                else {
                    if (current > 0) {
                        return this._disableItemSelectUp(current - 1);
                    }
                }
            }
        },

        _preventDefaultAction: function (e, stopBubble) {
            e.preventDefault ? e.preventDefault() : (e.returnValue = false);
            if (stopBubble) {
                e.stopPropagation ? e.stopPropagation() : (e.cancelBubble = true);
            }
        },

        _OnKeyDown: function (e) {
            this._uiInteract = true;
            if (this.model.enabled) {
                this._itemId = null;
                var _popupListItems = this._getLi(), liH, popupH, activeitem, flag;
                this._listSize = _popupListItems.length;                
                popupH = this.popupList.height();
                liH = this.ultag.children("li").outerHeight();
                activeitem = Math.round(popupH / liH) != 0 ? Math.round(popupH / liH) : 5;
                this._isSingle = this._isSingleSelect();
                if (this._isSingle) {
                    switch (e.keyCode) {
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                                break;
                            }
                        case 33: /* page up */
                            var step = e.keyCode == 33 ? activeitem : 1;
                            this._moveUp(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
					    case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                                break;
                            }
                        case 34: /* page down */
                            var step = e.keyCode == 34 ? activeitem : 1;
                            this._moveDown(this._activeItem, step);
                            this._preventDefaultAction(e,true);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1);
                            else this._moveUp(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1);
                            else this._moveDown(this._activeItem, 1);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            this._moveDown(this._listSize - 1, 0);
                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            this._moveUp(step, step);
                            this._preventDefaultAction(e);
                            break;
                    }
                }
                else {
                    switch (e.keyCode) {
                        
                        case 38: /* up arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._hideResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftUp(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 33: /* page up */
                            if (e.shiftKey) {
                                this._shiftUp(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, activeitem, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
						case 8:
                            this._preventDefaultAction(e);
                            break;
                        case 40: /* down arrow*/
                            if (e.altKey) {
                                if (this.ultag.find('li').length > 0)
                                    this._showResult();
                            }
                            else if (e.shiftKey) {
                                this._shiftDown(this._activeItem, 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, 1, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;

                        case 34: /* page down */

                            if (e.shiftKey) {
                                this._shiftDown(this._activeItem, activeitem, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, activeitem, e.ctrlKey);
                            this._preventDefaultAction(e);
                            break;
                        case 37 /* left arrow*/:
                            if (this.model.enableRTL) this._moveDown(this._activeItem, 1, false);
                            else this._moveUp(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 39 /* right arrow */:
                            if (this.model.enableRTL) this._moveUp(this._activeItem, 1, false);
                            else this._moveDown(this._activeItem, 1, false);
                            this._preventDefaultAction(e);
                            break;
                        case 9 /* Tab */:
                        case 27 /*ESC*/:
                            if (this._isPopupShown()) this._hideResult();
                            break;
                        case 35 /*End*/:
                            if (e.shiftKey) {
                                this._selectShiftEnd(this._activeItem, this._listSize - 1, e.ctrlKey);
                            }
                            else this._moveDown(this._activeItem, this._listSize, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                        case 36 /*Home*/:
                            var step = this._activeItem != null ? this._activeItem : this._listSize - 1;
                            if (e.shiftKey) {
                                this._selectShiftHome(this._activeItem, 0, e.ctrlKey);
                            }
                            else this._moveUp(this._activeItem, step, e.ctrlKey);

                            this._preventDefaultAction(e);
                            break;
                    }
                }
            }
        },

        _OnKeyUp: function (e) {
            if (this.model.enabled) {
                this._preventDefaultAction(e);
                var target = e.target;
                if (this._activeItem == null) {
                    this._activeItem = this._getLi().index(this.popupList.find("ol,ul").children("li.e-hover"));
                }
                if (this._trim(this._visibleInput.val()) == "" && e.keyCode == 38 && e.keyCode == 40) {
                    this._hideResult();
                    return false;
                }

                switch (e.keyCode) {
                    case 38: break;
                    case 40: break;
                    case 37: break;
                    case 39: break;

                    case 20: break;
                    case 16: break;
                    case 17: break;
                    case 18: break;
                    case 35: break;
                    case 36: break;
                    case 144: break;
                    case 27: break;
                    case 9: break;

                    case 13 /*Enter*/:
                        if (!this._isSingle && this._isPopupShown() && (e.ctrlKey || e.shiftKey) && this._activeItem >= 0) 
                            this._selectAndUnselect();
                        else if (this._isPopupShown() && !e.ctrlKey && !e.shiftKey){
							if(!ej.isNullOrUndefined(this.inputSearch)){
								if(this.getSelectedItem().length == 0) {
									this.selectItemByIndex(0);
									$(this.listitems[0]).removeClass("e-hover");
								}
								else {		
									var focusedItems = this._getLastFocusedLi();
                                    if(this.model.multiSelectMode  != "none" || this.model.showCheckbox) {
										this.unselectItemByIndex(focusedItems);
										$(this.listitems[focusedItems]).removeClass("e-hover");
									}
								}
							}
							this._hideResult();
						}
						else if (this._isPopupShown()) this._hideResult();
                        this._preventDefaultAction(e);
                        break;

                    case 32 /*spacebar*/:
                        if (this._isPopupShown() && this._isSingle) this._hideResult();
                        if (!this._isSingle && this._isPopupShown() && this._activeItem >= 0) {
                            this._selectAndUnselect();
                        }
                        this._preventDefaultAction(e);
                        break;
                    case 8 /*backspace*/:
                        if(this.model.multiSelectMode =="visualmode") this._deleteLastBox();                        
                        this._preventDefaultAction(e);
                        break;
                    case 46 /*Del*/:
                        if (this.model.multiSelectMode == "visualmode" || this.model.showCheckbox) {
                            this._deleteBox(this._ulBox.children("li.e-active"));
                            break;
                        }
                }
            }
        },

        _isSingleSelect: function () {
            return !this.model.showCheckbox && this.model.multiSelectMode == "none";
        },

        _selectAndUnselect: function () {
            if (this.model.showCheckbox) {
                this._isChecked(this._getActiveItem().find(".e-checkwrap")[0]) ?
                        this._removeTextBoxValue() : this._enterTextBoxValue();
            }
            else if (this.model.MultiSelectMode != "none") {
                this._getActiveItem().hasClass("e-active") ? this._removeTextBoxValue() : this._enterTextBoxValue();
            }
        },

        _targetFocus: function () {
            if (this.model.enabled && !this._isFocused) {
                if (!this._isWatermark)
                    this._hiddenSpan.css("display", "none");
                this.wrapper.addClass("e-focus e-popactive");
                this._isFocused = true;
                this._trigger("focusIn");
            }
        },

        _targetBlur: function () {
            if (this.model.enabled) {
                this._isFocused = false;
                this.wrapper.removeClass("e-focus e-popactive");
                this._setWatermark();
                this._trigger("focusOut");
            }
        },

		_getLocalizedLabels: function (property) {
            return this._localizedLabels[property] === undefined ? ej.DropDownList.Locale["en-US"][property] : this._localizedLabels[property]
        },
        _wireEvents: function () {
            this._on(this.wrapper, "focus", this._targetFocus);
            this._on(this.wrapper, "blur", this._targetBlur);
            this._on(this.wrapper, "keydown", this._OnKeyDown);
            this._on(this.popupList, "keydown", this._OnKeyDown);
            this._on(this.popupList, "keyup", this._OnKeyUp);
            this._on(this.wrapper, "keyup", this._OnKeyUp);
            this._on(this.popupList, "keypress", this._OnKeyPress);
            this._on(this.wrapper, "keypress", this._OnKeyPress);
        },

        _unwireEvents: function () {
            this._off(this.wrapper, "focus", this._targetFocus);
            this._off(this.wrapper, "blur", this._targetBlur);
            this._off(this.wrapper, "keydown", this._OnKeyDown);
            this._off(this.popupList, "keydown", this._OnKeyDown);
            this._off(this.popupList, "keyup", this._OnKeyUp);
            this._off(this.wrapper, "keyup", this._OnKeyUp);
            this._off(this.popupList, "keypress", this._OnKeyPress);
            this._off(this.wrapper, "keypress", this._OnKeyPress);
			$(window).off("resize", $.proxy(this._OnWindowResize, this));
        },

        _multiItemSelection: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i;
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },
        _appendCheckbox: function (listItems, isAddItem) {
            if (!this._ulBox && this.model.multiSelectMode == "visualmode") this._renderBoxModel();
            for (var i = 0; i < listItems.length; i++) {
                var index = isAddItem ? this._rawList.length - (listItems.length - i) : i,
                $checkbox = document.createElement("input"),
                $spanCheck = document.createElement("span");
                this._setAttr($checkbox, { type: "checkbox", name: "list" + index, "data-role": "none", id: this._id + "_" + "check" + index })
                    ._setClass($checkbox, "e-check-input")
                    ._setAttr($spanCheck, { name: "list" + index + "_wrap", "data-role": "none", id: this._id + "_" + "check" + index + "wrap", unselectable: "on", "aria-checked": false})
                    ._setClass($spanCheck, "e-checkwrap e-icon ");
                $spanCheck.appendChild($checkbox);
                listItems[i].insertBefore($spanCheck, listItems[i].childNodes[0]);
                if (this._hasClass(listItems[i], "chkselect")) {
                    this._activeItem = index;
                    this._enterTextBoxValue();
                    this._removeClass(listItems[i], "chkselect");
                }
            }
            this._setWatermark();
        },

        _onCheckChange: function (e) {
            var curEle = e.target.nodeName === "INPUT" ? e.target.parentElement : e.target;
            this._activeItem = $.inArray($(curEle).parents("li")[0], this._getLi());
            if (!this._hasClass(curEle, "e-check-act")) {
                this._enterTextBoxValue();
            }
            else {
                this._removeTextBoxValue();
            }
        },
        _isChecked: function (checkEle) {
            return (this._hasClass(checkEle, "e-check-act") && $(checkEle).children(".e-check-input")[0].checked == true);
        },
        _removeCheck: function () {
            this._getLi().find(".e-checkwrap").remove();
        },
        _resetCheck: function () {
            var getLi = this._getLi(), checkEle;
            getLi.find(".e-check-act").removeClass("e-check-act").attr("aria-checked",false);
            checkEle = getLi.find(".e-check-input:checked");
            for (var e = 0; e < checkEle.length; e++) {
                checkEle[e].checked = false;
            }
        }

    });
	ej.DropDownList.Locale = ej.DropDownList.Locale || {};
    ej.DropDownList.Locale["default"] = ej.DropDownList.Locale["en-US"] = {        
        emptyResultText: "No suggestions",  
		watermarkText:""
    };
    ej.MultiSelectMode = {
        /** Supports to selection mode with none only */
        None: "none",
        /** Supports to selection mode with delimitter only */
        Delimiter: "delimiter",
        /** Supports to selection mode with visualmode only */
        VisualMode: "visualmode"
    };
    ej.VirtualScrollMode = {      
        /** Make virtual scrollbar in normal mode */
        Normal: "normal",
        /** Make virtual scrollbar in continuous mode*/
        Continuous: "continuous"
    };
    
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget(
    {
        "ejNumericTextbox": ["ej.NumericTextbox", "e-numerictextbox"],
        "ejPercentageTextbox": ["ej.PercentageTextbox", "e-percentagetextbox"],
        "ejCurrencyTextbox": ["ej.CurrencyTextbox", "e-currencytextbox"]
    },
    {
        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true,
            requireParser:true
        },

        defaults: {

            width: "",

            height: "",

            value: null,

            name: null,

            htmlAttributes: {},

            minValue: -(Number.MAX_VALUE),

            maxValue: Number.MAX_VALUE,

            incrementStep: 1,

            decimalPlaces: 0,

            validateOnType: false,

            cssClass: "",

            enablePersistence: false,

            showSpinButton: true,

            locale: "en-US",

            enableStrictMode: false,

            showRoundedCorner: false,

            readOnly: false,

            enabled: true,

            enableRTL: false,

            watermarkText: "Enter value",

            validationRules: null,

            validationMessage: null,

            groupSeparator: null,

            groupSize: null,

            positivePattern: null,

            currencySymbol:null,

            negativePattern: null,

            change: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null
        },

        dataTypes: {
            minValue: "number",
            maxValue: "number",
            incrementStep: "number",
            decimalPlaces: "number",
            showSpinButton: "boolean",
            enableStrictMode: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            locale: "string",
            watermarkText: "string",
            cssClass: "string",
            readOnly: "boolean",
            enabled: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data",
            validateOnType: "boolean",
            groupSeparator: "string"
        },
        observables: ["value"],

        _setModel: function (jsondata) {
            var validate = false;
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isNullOrUndefined(jsondata["minValue"]) && ej.isNullOrUndefined(jsondata["maxValue"])) {
                            this._setValue(jsondata[key], true);
                            jsondata[key] = this.model.value;
                        }
                        else {
                            this.model.value = this._checkNumValue(jsondata[key]);
                            this._localizedFormat();
                            this._raiseChangeEvent(true);
                            validate = true;
                        }
                        break;
                    case "enableRTL": this._enableRTL(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "minValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.minValue = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "maxValue":
                        if (isNaN(jsondata[key])) return;
                        this.model.maxValue = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        validate = true;
                        break;
                    case "incrementStep":
                        if (isNaN(jsondata[key])) return;
                        this.model.incrementStep = (this.model.decimalPlaces == -1) ? jsondata[key] : parseFloat(jsondata[key].toFixed(this.model.decimalPlaces));
                        break;
                    case "enableStrictMode": this.model.enableStrictMode = jsondata[key]; break;
                    case "showSpinButton": this._showSpin(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "locale":                        
                        this.model.decimalPlaces = ((ej.isNullOrUndefined(this._options.decimalPlaces)) && (this.model.decimalPlaces === this.culture.numberFormat.decimals))
                           ? -1 : (this._options.decimalPlaces === -1) ? -1 : this.model.decimalPlaces;
                        this._setLocalize(jsondata[key]);
                        this._options.decimalPlaces = this.model.decimalPlaces;
						jsondata[key] = this.model.locale;
						break;
                    case "decimalPlaces":
                        this._setDecimal(jsondata[key]);
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options["decimalPlaces"] = jsondata[key];
                        break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": if (jsondata[key]) this.enable(); else this.disable(); break;
                    case "watermarkText":
                        if(!ej.isNullOrUndefined(this._options)) this._options = [];
                        this._options["watermarkText"] = this.model.watermarkText = jsondata[key];
                        this._localizedLabels.watermarkText = this.model.watermarkText;						
						this._changeWatermark(jsondata[key]);
						break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "groupSeparator":
                        this._checkSeparator(jsondata[key]);
                        jsondata[key] = this.model.groupSeparator;
                        break;
                    case "positivePattern":
                    case "negativePattern":
                    case "groupSize":
                    case "currencySymbol":
                        this.model[key] = jsondata[key];
                        this._options[key] = jsondata[key];
                        this._initCustomValue();
                        jsondata[key] = this.model[key];
                        this._setValue(this.model.value, true);
                        break;                    
                }
            }
            if (validate) {
                this._validateMinMaxValue(true, true);
                jsondata["value"] = this.model.value;
                jsondata["maxValue"] = this.model.maxValue;
                jsondata["minValue"] = this.model.minValue;
                if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
				this.wrapper.attr({ 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value });
            }
            this._checkSeparator(this.model.groupSeparator);
            this.element.val(this._removeSeparator(this.model.value));
            this._updateSeparator();
            this._checkErrorClass();
        },


        _destroy: function () {
            if (this.wrapper) {
                this.element.insertBefore(this.wrapper);
                this.wrapper.remove();
            }
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.val("").removeClass('e-input e-disable').empty();
            this.element.removeAttr('disabled aria-disabled');
			this.wrapper.removeAttr('aria-valuemin aria-valuemax aria-valuenow aria-live');
            if (!(this._cloneElement).attr('role')) this.element.removeAttr('role');
            this.element.css("display", "block");
        },



        _init: function (options) {
            this._cloneElement = this.element.clone();
            this._options = ej.isNullOrUndefined(options) ? {} :options;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=number]") || !this.element.attr('type'))) {
                if(this.model.decimalPlaces > 0){
                    this.element[0].type = "text";
                }
                this._isWatermark = 'placeholder' in document.createElement('input');
                this.model.locale = ej.preferredCulture(this.model.locale).name == "en" ? "en-US" : ej.preferredCulture(this.model.locale).name;
                this._localizedLabels = this._getLocalizedLabels();
                this.culture = ej.preferredCulture(this.model.locale);
                this._browsername = ej.browserInfo().name;
                this._initCustomValue();
                this._prevSeparator = null;
                this._checkSeparator(this.model.groupSeparator);
                this._checkAttribute();
                this._renderControl();
                this._setValues();
                this._wireEvents();
                this._initObjects();
                this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                this._updateSeparator();
                if (options && options.value != undefined) {
                    this._trigger("_change", { value: this.model.value });
                }
            }
            else {
                this._destroy();
                return false;
            }
        },
		
        _checkAttribute: function () {
            var attr = ["min", "max", "step", "readonly", "disabled", "placeholder"], propName = ["minValue", "maxValue", "incrementStep", "readOnly", "enabled", "watermarkText"], value, propValue;
            for (var i = 0; i < attr.length; i++) {
                value = this.element.attr(attr[i]); propValue = propName[i];
                if ((!ej.isNullOrUndefined(value)) && !ej.isNullOrUndefined(this._options) && (ej.isNullOrUndefined(this._options[propValue]))) {
                    if (propValue == "watermarkText") this._options[propValue] = value;
                    else this.model[propValue] = ((propValue != "disabled") && (propValue != "readOnly")) ? ej.parseFloat(value, this.model.locale) : propValue == "readOnly" ? this.element.is("[readonly]") : !this.element.is("[disabled]");
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "accesskey") proxy._hiddenInput.attr(key, value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "tabindex") {
                    proxy._hiddenInput.attr(key, value);
                    proxy.element.attr(key, value);
                }
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },

        _setValues: function () {
            this._id = this.element[0].id;
            this._textBox = this._hiddenInput[0];
            this._error = false;
            this._timeout = null;
            this.isValidState = true;
            this._allowkeyboard = true;
            this._validateOnType = false;
            this._focused = false;
            this._startValue = 0;
            if (this.sfType === "ej.CurrencyTextbox" && this.model.minValue == -(Number.MAX_VALUE))
                this.model.minValue = 0;
            if (ej.isNullOrUndefined(this.model.decimalPlaces)) {
                if (this.sfType === "ej.CurrencyTextbox")
                    this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.currency.decimals;
                else this.model.decimalPlaces = ej.preferredCulture(this.model.locale).numberFormat.decimals;

            }
            if (this.model.decimalPlaces >= 0) {
                this.model.minValue = parseFloat(this.model.minValue.toFixed(this.model.decimalPlaces));
                this.model.maxValue = parseFloat(this.model.maxValue.toFixed(this.model.decimalPlaces));
            }
            if (this.model.minValue != -(Number.MAX_VALUE)) this._startValue = this.model.minValue;
			if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
                
            }
            this._localizedLabelToModel();
            this._localizedFormat();
            this._validateMinMaxValue(true);
            this._updateSymbol(this.model.locale);
            var value;
            if (ej.isNullOrUndefined(this.model.value)) {
                value = this.model.value;
                this.wrapper.removeClass('e-valid');
            }
            else {
                value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.wrapper.addClass('e-valid');
            }
           this.element.val(value);
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            var rules = this.model.validationRules;
            this.element.rules("add", rules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in rules) {
                var message = null;
                if (!ej.isNullOrUndefined(rules[ruleName])) {
                    if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"][ruleName]))
                        message = rules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _renderControl: function () {
            this.wrapper = ej.buildTag("span.e-widget e-pinch");
            this.innerWrap = ej.buildTag("span.e-in-wrap e-box ");
            this.wrapper.attr("style", this.element.attr("style"));
            if (this.sfType === "ej.NumericTextbox")
                this.wrapper.addClass('e-numeric');
            else if (this.sfType === "ej.PercentageTextbox")
                this.wrapper.addClass('e-percent');
            else if (this.sfType === "ej.CurrencyTextbox")
                this.wrapper.addClass('e-currency');
            this.wrapper.append(this.innerWrap).insertAfter(this.element);
            this.innerWrap.append(this.element);
            this._hiddenInput = ej.buildTag("input", "", {}, { type: "text" }).insertBefore(this.element);
            this._hiddenInput.attr('data-role', 'none');

            this._hiddenInput[0].tabIndex = this.element[0].tabIndex;
            this._hiddenInput.attr("accesskey", this.element[0].accessKey);
            this.element[0].accessKey = "";

            this._hiddenInput.css("display", "block");
            this.element.css("display", "none");
            if (!this._isWatermark) {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this._localizedLabels.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._on(this._hiddenSpan,"mousedown", this._focusIn);
                this._on(this._hiddenSpan,'mousewheel', this._mouseWheel);
                this._on(this._hiddenSpan,'DOMMouseScroll',this._mouseWheel);
            }
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            this.element.attr("name") == null ? this.element.attr("name", this.model.name) : "";
            this.element.addClass('e-input');
            if (ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") {
                if (ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.element[0].value = this.element[0].value.replace(".", ",");
                this.model.value = this._checkNumValue(this.element[0].value);
            }   
            else {
                if (typeof this.model.value== "string" && ej.preferredCulture(this.model.locale).numberFormat[','] == ".")
                    this.model.value = this.model.value.replace(".", ",");
                this.model.value = this._checkNumValue(this.model.value);
            }
            this._hiddenInput.attr({ 'value': this.model.value }).addClass('e-input');
			this.wrapper.attr({'role': 'spinbutton', 'aria-valuemin': this.model.minValue, 'aria-valuemax': this.model.maxValue, 'aria-valuenow': this.model.value,});
            this.element.attr({'aria-live': 'assertive', "value": this.model.value });
            var spinbutton = $('<span class="e-select"><span class="e-spin e-spin-up " role="button" aria-label="Increase Value" unselectable="on" /><span class="e-spin e-spin-down" role="button" aria-label="Decrease Value" unselectable="on" /></span>');
            spinbutton.find('.e-spin-up').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-up').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            spinbutton.find('.e-spin-down').append(ej.buildTag('span.e-icon e-arrow e-arrow-sans-down').attr({ 'role': 'presentation', 'unselectable': 'on' }));
            this.innerWrap.append(spinbutton);
            this.spin = this.wrapper.find('.e-select');
            this.spinUp = this.wrapper.find('.e-spin-up');
            this.spinDown = this.wrapper.find('.e-spin-down');
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            if (this.model.cssClass != "") this._setSkin(this.model.cssClass);
            this._showSpin(this.model.showSpinButton);
            if (this.model.showRoundedCorner) this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableRTL) this._enableRTL(this.model.enableRTL);
            if (this.model.readOnly) this._setReadOnly(this.model.readOnly);
            if (!this.model.enabled) this.disable();
            else if (this.model.enabled && this.element.hasClass("e-disable")) this.enable();
        },


        _initObjects: function () {
            this._preVal = this.model.value;
            if (this.model.value === null) {
                this.isValidState = true;
                this._hiddenInput.val(null);
            }
            else if ((this.model.value < this.model.minValue) || (this.model.value > this.model.maxValue))
                this.isValidState = false;
            this._checkErrorClass();
            this._setWaterMark();
        },


        _showSpin: function (value) {
            if (!value) {
                if (this.spin) {
                    this.spin.hide();
                    this.innerWrap.removeClass('e-padding');
                }
                this._spinEvents("_off");
            }
            else {
                if (this.spin) {
                    this.spin.show();
                    this.innerWrap.addClass('e-padding');
                }
                this._spinEvents("_on");
            }
        },


        _roundedCorner: function (value) {
            if (value && !this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.addClass('e-corner');
            } else if (this.innerWrap.hasClass('e-corner')) {
                this.innerWrap.removeClass('e-corner');
            }
        },


        _enableRTL: function (enableRTL) {
            if (enableRTL) {
                if (this.spin) {
                    this.wrapper.addClass("e-rtl");
                }
                else this.element.addClass("e-rtl");
            }
            else {
                if (this.spin) {
                    this.wrapper.removeClass("e-rtl");
                }
                else this.element.removeClass("e-rtl");
            }
        },


        _setWidth: function (value) {
            value != "" ? this.wrapper.width(value) : this.model.width = this.wrapper.outerWidth();
        },


        _setHeight: function (value) {
            value != "" ? this.wrapper.height(value) : this.model.height = this.wrapper.outerHeight();
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },


        _setValue: function (value, isCode) {
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.model.value = this._checkNumValue(value);
            this._validateMinMaxValue(false);
            this._checkErrorClass();
            this._localizedFormat();
            this._raiseChangeEvent(isCode);
            this._setWaterMark();
        },

        _setLocalize: function (val) {
            var prevSeparator = ej.preferredCulture(this.model.locale).numberFormat[',']
            this.model.locale = ej.preferredCulture(val).name == "en" ? "en-US" : ej.preferredCulture(val).name;
            this.model.groupSeparator = ((ej.isNullOrUndefined(this._options.groupSeparator) && (prevSeparator === this.model.groupSeparator))) ?
                ej.preferredCulture(this.model.locale).numberFormat[','] : this.model.groupSeparator;
			this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this.culture = ej.preferredCulture(this.model.locale);
            this._initCustomValue();
            this._updateSymbol(this.model.locale);
            this._localizedFormat();
            this._changeWatermark(this.model.watermarkText);
            if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
            else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n",true) : this._convertToExponetial(this.model.value).unformattedValue;
            this.element.val(value);
			
        },
		 _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            
        },
        _updateSymbol: function (locale) {
            this._percentSymbol = ej.preferredCulture(locale).numberFormat.percent.symbol;
            this._currencySymbol = ej.preferredCulture(locale).numberFormat.currency.symbol;
        },

        _setDecimal: function (val) {
            this.model.decimalPlaces = val;
            this._localizedFormat();
        },


        _validateMinMaxValue: function (fromMinMax, isCode) {
            var valChange = false, value;
            if (this.model.minValue > this.model.maxValue) this.model.minValue = this.model.maxValue;
            if (!ej.isNullOrUndefined(this.model.value) && this.model.minValue > this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this._startValue = this.model.value = this.model.minValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else if (!ej.isNullOrUndefined(this.model.value) && this.model.maxValue < this.model.value) {
                if (this.model.enableStrictMode != true) {
                    this.isValidState = true;
                    this.model.value = this.model.maxValue;
                }
                else this.isValidState = false;
                valChange = true;
            }
            else this.isValidState = true;
            if (this.model.minValue == this.model.maxValue) this._startValue = this.model.minValue;
            if ((valChange && fromMinMax)) {
                value = this._formatValue(this.model.value, "n", true);
                this._hiddenInput.val(value);
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._formatValue(this.model.value, "n", true) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._localizedFormat();
                this._raiseChangeEvent(isCode);
            }
        },

        _convertToExponetial: function (value) {
            var number = "", pattern, format;
            var negative = value < 0 ? true : false;
            value = value.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            unformattedValue = value;
            var length = null;
            if (this.sfType === "ej.NumericTextbox") {
                pattern = negative ? format.pattern[0] : ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = "";
            }
            else if (this.sfType === "ej.PercentageTextbox") {
                pattern = negative ? format.percent.pattern[0] : format.percent.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.percent.symbol;
            }
            else if (this.sfType === "ej.CurrencyTextbox") {
                pattern = negative ? format.currency.pattern[0] : format.currency.pattern[1];
                value = negative ? value.replace("-", "") : value;
                symbol = format.currency.symbol;
            }
            for (idx = 0, length = pattern.length; idx < length; idx++) {
                ch = pattern.charAt(idx);
                (ch === "n") ? number += value : (ch === "$" || ch === "%") ? number += symbol : number += ch;
            }
            return { formattedValue: number, unformattedValue: unformattedValue }
        },

        _localizedFormat: function () {
            this.culture = ej.preferredCulture(this.model.locale);
            this._decimalSep = ej.preferredCulture(this.model.locale).numberFormat['.'];
            if (ej.isNullOrUndefined(this.model.value)) {
                this._textBox.value = "";
                return;
            }
            if (this.model.value.toString().indexOf('e') == -1) {
                this._textBox.value = this._removeSeparator(this.model.value)
                if (!this._focused && this._textBox.value != "") {
                    this._textBox.value = this._formatValue(this.model.value, "n", true);
					
                    if (this.sfType === "ej.PercentageTextbox") this._appendPercentSymbol(this._textBox.value);
                    else if (this.sfType === "ej.CurrencyTextbox") this._appendCurrencySymbol(this._textBox.value);


                    var symbolIndex = (this.sfType === "ej.CurrencyTextbox") ? this._textBox.value.indexOf(this._currencySymbol) : (this.sfType === "ej.PercentageTextbox") ? this._textBox.value.indexOf(this._percentSymbol) : -1;

                    if (this.model.decimalPlaces == -1) {
                        this._textBox.value = this._textBox.value.substr(0, this._textBox.value.lastIndexOf(this._decimalSep));
                        if (symbolIndex > 1 && (ej.isNullOrUndefined(this._afterDec) || this._afterDec == "")) {
                            if (this.sfType === "ej.CurrencyTextbox")
                                this._textBox.value = this._textBox.value + " " + this._currencySymbol;
                            if (this.sfType === "ej.PercentageTextbox")
                                this._textBox.value = this._textBox.value + " " + this._percentSymbol;
                        }
                        if (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this._afterDec) && this._afterDec != "") {
                            var index = this._textBox.value.lastIndexOf(this._decimalSep);
                            if (index >= 0) {
                                this._textBox.value = this._textBox.value.substr(0, index);
                            }
                            var symbolPos = this._afterDec;
                            if (symbolIndex > 1) {
                                if (this.sfType === "ej.CurrencyTextbox")
                                    symbolPos = symbolPos + " " + this._currencySymbol;
                                if (this.sfType === "ej.PercentageTextbox")
                                    symbolPos = symbolPos + " " + this._percentSymbol;

                            }
                            this._textBox.value = this._textBox.value + this._decimalSep + symbolPos;
                        }
                    }
                }
                else {
                    var value = this._convertToExponetial(this.model.value);
                    this._textBox.value = value.unformattedValue;
                    if (!this._focused && this._textBox.value != "")
                        this._textBox.value = value.formattedValue;
                }
            }
        },

        _checkNumValue: function (value) {
            if (typeof value == "string")
                value = !this._changeSeparator ? value : this._replaceSeparator(value, this.model.groupSeparator, ej.preferredCulture(this.model.locale).numberFormat[',']);
            if (typeof value == "string" && !isNaN(this._parseValue(value))) {
                value = this._parseValue(value);
                return parseFloat(value);
            }
            else if ((typeof value == "number") && !isNaN(value))
                return value;
            else return null;
        },


        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) {
                this.element.attr("readonly", true);
                this._hiddenInput.attr("readonly", true);
            }
            else {
                this.element.prop("readonly",false);
                this._hiddenInput.prop("readonly",false);
            }
        },


        _setWaterMark: function () {
            if ((this._localizedLabels.watermarkText != null) && (this._textBox.value === "") && $.trim(this._hiddenInput.val()) === "") {
                if (this._isWatermark) {
                    this._hiddenInput.attr("placeholder", this._localizedLabels.watermarkText);
                    this.element.attr("placeholder", this._localizedLabels.watermarkText);
                }
                else
                    this._hiddenSpan.css("display", "block").text(this._localizedLabels.watermarkText);
            }
        },


        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            if (this._isWatermark) {
                this._hiddenInput.attr("placeholder", text);
                this.element.attr("placeholder", text);
            }
            else this._hiddenSpan.text(text);
        },


        _setSelectionRange: function (selectionStart, selectionEnd) {
            var input = this._textBox;
            try {
                if (input.setSelectionRange) {
                    if (this._browsername == "edge")  setTimeout(function () { input.setSelectionRange(selectionStart, selectionEnd) })
                    else input.setSelectionRange(selectionStart, selectionEnd);
                }
                else if (input.createTextRange) {
                    var range = input.createTextRange();
                    _setselction(range);
                }
            }
            catch (e) {
                var control = this;
                window.setTimeout(function () {
                    document.body.focus();
                    control._textBox.select();
                    if (document.selection) {
                        var range = document.selection.createRange();
                        _setselction(range);
                    }
                }, 1);
            }
            function _setselction(range) {
                range.collapse(true);
                range.moveEnd('character', selectionEnd);
                range.moveStart('character', selectionStart);
                range.select();
            }
        },


        _getSelection: function (value) {
            if (this._textBox.type != "number") {
                var oSel = null;
                if (document.selection) {
                    oSel = document.selection.createRange();
                    return (oSel.text === "" ? oSel.text : this._removeFormats(oSel.text));
                }
                else {
                    if (value == null)
                        return this.model.value;
                    else {
                        oSel = this._removeFormats(value.substring(this._textBox.selectionStart, this._textBox.selectionEnd));
                        return oSel;
                    }
                }
            }
        },


        _caretPosition: function () {
            var oField = this._textBox;
            var iCaretPos = 0;
            // IE Support
            if (oField.type != "number") {
                if (document.selection) {
                    oField.focus();
                    // To get cursor position, get empty selection range
                    var oSel = document.selection.createRange();
                    // Move selection start to 0 position
                    oSel.moveStart('character', -oField.value.length);
                    // The caret position is selection length
                    iCaretPos = oSel.text.length;
                }
                    // Firefox support
                else if (oField.selectionStart || oField.selectionStart == '0')
                    iCaretPos = oField.selectionEnd;
                return (iCaretPos);
            }  
        },


        _appendPercentSymbol: function (value) {
            if (this._percentSymbol) value = value.replace(this._percentSymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value) / 100, "p", true);
            this._percentSymbol = ej.preferredCulture(this.model.locale).numberFormat.percent.symbol;
        },

        _appendCurrencySymbol: function (value) {
            if (this._currencySymbol) value = value.replace(this._currencySymbol, "");
            if (value.indexOf(ej.preferredCulture(this.model.locale).numberFormat.currency.symbol) < 0)
                this._textBox.value = this._formatValue(this._parseValue(value), "c", true);
            this._currencySymbol = ej.preferredCulture(this.model.locale).numberFormat.currency.symbol;

        },

        _removeFormats: function (val) {
            var grpSep = ej.preferredCulture(this.model.locale).numberFormat[","];
            if (val != null) {
                if (grpSep == ".")
                    return (val.toString().replace(/["."]/g, ""));
                else if (val.toString().match(new RegExp(grpSep, "g")))
                    return (val.toString().replace(new RegExp(grpSep, "g"), ""));
                else
                    return val;
            }
            else
                return null;
        },


        _checkErrorClass: function (obj) {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
		


        enable: function () {
            this.model.enabled = true;
            this.element[0].disabled = false;
            this.element.prop("disabled",false);
            this._hiddenInput.prop("disabled", false);
            this.element.removeClass('e-disable').attr({ "aria-disabled": false });
            this._hiddenInput.removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select").removeClass('e-disable').attr({ "aria-disabled": false });
            this.wrapper.find(".e-select span.e-icon.e-arrow").removeClass('e-disable');
            this.wrapper.removeClass('e-disable-wrap');
        },


        disable: function () {
            this.model.enabled = false;
            this.element[0].disabled = true;
            this.element.attr("disabled", "disabled");
            this._hiddenInput.attr("disabled", "disabled");
            this.element.addClass('e-disable').attr({ "aria-disabled": true });
            this._hiddenInput.addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select").addClass('e-disable').attr({ "aria-disabled": true });
            this.wrapper.find(".e-select span.e-icon.e-arrow").addClass('e-disable');
            this.wrapper.addClass('e-disable-wrap');
        },


        getValue: function () {
            return this.model.value;
        },

        _wireEvents: function () {
            this._on(this._hiddenInput, 'focus', this._focusIn);
            this._on(this.element, 'paste', this._paste);
            this._on(this.element, 'blur', this._focusOut);
            this._on(this.element, 'keydown', this._keyDown);
            this._on(this.element, 'keypress', this._keyPress);
            this._on(this.element, 'mousewheel', this._mouseWheel);
            this._on(this.element, 'DOMMouseScroll', this._mouseWheel);
        },

        _spinEvents: function (action) {
            this[action](this.spinUp, "mousedown mouseup touchstart touchend", this._spinUpClick);
            this[action](this.spinDown, "mousedown mouseup touchstart touchend", this._spinDownClick);
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },

        _spinUpClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinUp.addClass("e-animate");
            this._on(this.spinUp, 'mouseleave', this._mouseUpClick);
            this.spinUp.addClass("e-active");
            var self = this;
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("increment");
                this.spinUp.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus();
                this._timeout = setInterval(function () {
                    self._updateInputField("increment");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _spinDownClick: function (event) {
            var isNotLeftClick = false;
            if (event.button)
                isNotLeftClick = this._isIE8() ? event.button != 1 : event.button != 0;
            else if (event.which)
                isNotLeftClick = (event.which == 3); //for Opera
            if (isNotLeftClick) return;
            var self = this;
            event.preventDefault();
            clearTimeout(this._timeout);
            if (!this.model.enabled || this.model.readOnly) return;
            this.wrapper.find(".e-animate").removeClass("e-animate");
            this.spinDown.addClass("e-animate");
            this._on(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.addClass("e-active");
            if (event.type == "mouseup"|| event.type == "touchend") {
                this._updateInputField("decrement");
                this.spinDown.removeClass("e-active");
                this._off($(document), 'mouseup', this._mouseUpClick);
            }
            else if (event.type == "mousedown"|| event.type == "touchstart") {
                if (!this._focused) this._hiddenInput[0].focus()
                this._timeout = setInterval(function () {
                    self._updateInputField("decrement");
                }, 150);
                this._on($(document), 'mouseup', this._mouseUpClick);
            }
        },

        _mouseUpClick: function (event) {
            event.stopPropagation();
            clearTimeout(this._timeout);
            this._off(this.spinUp, 'mouseleave', this._mouseUpClick);
            this._off(this.spinDown, 'mouseleave', this._mouseUpClick);
            this.spinDown.removeClass("e-active");
            this.spinUp.removeClass("e-active");
        },

        _mouseWheel: function (event) {
            event.preventDefault();
            if (!this._focused) this.element[0].focus();
            if (!this.model.enabled || this.model.readOnly) return;
            var delta;
            var rawEvent = event.originalEvent;
            if (rawEvent.wheelDelta) {
                // IE and Opera use wheelDelta, which is a multiple of 120 (possible values -120, 0, 120).
                delta = rawEvent.wheelDelta / 120;
                // In Opera, value is negated.
                //if (Sys.Browser.agent === Sys.Browser.Opera) delta = -delta;
            }
            else if (rawEvent.detail) {
                // Firefox uses detail property, which is a multiple of 3.
                delta = -rawEvent.detail / 3;
            }
            if (delta > 0)
                this._updateInputField("increment");
            else if (delta < 0)
                this._updateInputField("decrement");
            this._cancelEvent(event);
        },


        _numberValue: function () {
            var value = this._textBox.value;
            if (this.sfType === "ej.NumericTextbox")
                value = this._formatValue(this.model.value, "n", true);
            if (this.sfType === "ej.PercentageTextbox")
                value = this._formatValue(this.model.value, "n", true);
            else if (this.sfType === "ej.CurrencyTextbox")
                value = this._formatValue(this.model.value, "n", true);
            value = (typeof value == "string" && !isNaN(this._parseValue(value))) ? value : "";
            return value;
        },
        _formatValue: function (value, format,flag) {
            if(flag) this._updateCultureInfo();
            var value = ej.format(value, format + this.model.decimalPlaces, this.model.locale);
            if (flag) this._restCultureInfo();
            return value;
        },
        _parseValue: function (value) {
            this._updateCultureInfo();
            var value = ej.parseFloat(value, this.model.locale);
            this._restCultureInfo();
            return value;            
        },

        _initCustomValue: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            switch (ctr) {
                case "percent":
                case "currency":
                    format = this.culture.numberFormat[ctr];
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.currencySymbol) && ctr == "currency") this.model.currencySymbol = format.symbol;
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];                    
                    break;
                case "numeric":
                    format = this.culture.numberFormat;
                    if (ej.isNullOrUndefined(this._options.negativePattern)) this.model.negativePattern = format.pattern[0];
                    if (ej.isNullOrUndefined(this._options.positivePattern)) this.model.positivePattern = ej.isNullOrUndefined(format.pattern[1]) ? "n" : format.pattern[1];
                    if (ej.isNullOrUndefined(this._options.groupSize)) this.model.groupSize = format.groupSizes[0];
                    break;
            }
        },

        _updateCultureInfo: function (flag) {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            this._oldNegativePattern = format.pattern[0];
            this._oldGroupSize = format.groupSizes[0];
            format.pattern[0] = this.model.negativePattern;
            format.groupSizes[0] = this.model.groupSize;
            this._oldPositivePattern = format.pattern[1];
            format.pattern[1] = this.model.positivePattern;
            if (ctr == "currency") {
                this._oldcurrencySymbol = format.symbol;
                format.symbol = this.model.currencySymbol;
            }
        },
        _restCultureInfo: function () {
            var format, ctr = this.sfType == "ej.PercentageTextbox" ? "percent" : this.sfType == "ej.CurrencyTextbox" ? "currency" : "numeric";
            format = ctr == "numeric" ? this.culture.numberFormat : this.culture.numberFormat[ctr];
            format.pattern[0] = this._oldNegativePattern;
            format.groupSizes[0] = this._oldGroupSize;
            format.pattern[1] = this._oldPositivePattern;
            if (ctr == "currency")
                format.symbol = this._oldcurrencySymbol;;
        },
        _toggleTextbox: function (toggle) {
            var proxy = this;
            proxy._hiddenInput.toggle(toggle);
            proxy.element.toggle(!toggle);
        },

        _paste: function (event) {
            var text;
            if (window.clipboardData && window.clipboardData.getData) { // IE
                text = window.clipboardData.getData('Text');
            }
            else if (event.originalEvent.clipboardData && event.originalEvent.clipboardData.getData) { // other browsers
                text = event.originalEvent.clipboardData.getData('text/plain');
            }
            var data = ej.parseFloat(text, this.model.locale);
            if (isNaN(data))
                this._cancelEvent(event)
            else {
                this.element.val(data);
                this._cancelEvent(event);
            }
        },
        _focusIn: function (event) {
            if (this.model.readOnly)
                return;
            this._focused = true;
            if(!ej.isNullOrUndefined(this.model.value)) this.element.val(this._removeSeparator(this.model.value));
            this._toggleTextbox(false);
            this._textBox = this.element[0];
            this.element[0].focus();
            this._preVal = this.model.value;
            if (!this._isWatermark)
                this._hiddenSpan.css("display", "none");
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass('e-error');
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = this._formatValue(this._textBox.value, "n", true);
                    if (this.model.decimalPlaces == -1) {
                        this._separateValue(this._textBox.value.toString(), true, true);
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            value = this._beforeDec + this._decimalSep + this._afterDec
                    }
                    this._textBox.value = value;
                    this._hiddenInput.val(value);
                }
                this._setSelectionRange(0, this._textBox.value.length);
            }
            this._trigger("focusIn", { value: this.model.value });
        },

        _separateValue: function (value, isDecimal, isgroupSep) {
            var index = (!isDecimal) ? value.lastIndexOf(".") : value.lastIndexOf(this._decimalSep);
            this._beforeDec = (index >= 0) ? value.substr(0, index) : value;
            if (!isDecimal && isgroupSep)
                this._afterDec = (index >= 0) ? value.substr(index + 1) : "";
        },

        _focusOut: function (event) {
            this._focused = false;
            this.wrapper.removeClass("e-focus");
            this._separateValue(this._textBox.value,false,true);
            if (!this._error) {
                if (this._textBox.value != "") {
                    var value = ej.parseFloat(this._textBox.value, this.model.locale);
                    if (value < this.model.minValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.minValue, "n", false)
                        else
                            this.isValidState = false
                    }
                    else if (value > this.model.maxValue) {
                        if (!this.model.enableStrictMode)
                            this._textBox.value = this._formatValue(this.model.maxValue, "n", false);
                        else
                            this.isValidState = false;
                    }
                    this.model.value = (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this._afterDec) && (this._textBox.value.lastIndexOf(this._decimalSep) == -1)) ? ej.parseFloat(this._textBox.value + this._decimalSep + this._afterDec, this.model.locale) : ej.parseFloat(this._textBox.value, this.model.locale);
                    if (isNaN(this.model.value) && !this.model.value) {
                        this.model.value = null;
                        this.isValidState = false;
                    }
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                    this._localizedFormat();
                    this._checkErrorClass();
                }
                else {
                    var value = this._textBox.value == "" ? null : this._textBox.value;
                    this.model.value = value;
                    this._hiddenInput.val(value);
                    this._toggleTextbox(true);
                    this._textBox = this._hiddenInput[0];
                }
                if (this.model.value === null || this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) this.isValidState = true;
                else if (this.model.enableStrictMode) this.isValidState = false;
                this._raiseChangeEvent();
                this._setWaterMark();
                if (ej.isNullOrUndefined(this.model.value)) value = this.model.value;
                else value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                this.element.val(value);
                this._updateSeparator();
                this._trigger("focusOut", { value: this.model.value });
            }
            this._checkErrorClass();
            this._afterDec = "";
        },

        _cancelEvent: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _updateInputField: function (operation) {
            this.isValidState = true;
            if (!this._focused) $(this._hiddenInput[0]).focus();
            var step = this.model.incrementStep;
            var itemValue = this.model.value;
            if (this._textBox.value === "") {
                this._textBox.value = this._formatValue(this._startValue, "n", true);
                step = 0;
            }
            else if (this._textBox.value.indexOf(" ") >= 0)
                this._textBox.value = this._textBox.value.replace(" ", "");
            if (this.sfType === "ej.PercentageTextbox" || this.sfType === "ej.CurrencyTextbox") {
                var editorvalue = this._textBox.value, value = editorvalue;
                if (editorvalue.indexOf(ej.preferredCulture(this.model.locale).numberFormat.percent.symbol) > -1)
                    value = editorvalue.substring(0, editorvalue.length - 1);
                this.model.value = this._parseValue(value);
            }
            else if (this.sfType == "ej.NumericTextbox")
                this.model.value = ej.parseFloat(this._textBox.value, this.model.locale);

            if (isNaN(this.model.value) && !this.model.value)
                this.model.value = this._startValue;

            if (this.model.value >= this.model.minValue && this.model.value > this.model.maxValue) {
                this.model.value = this.model.maxValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value < this.model.minValue && this.model.value <= this.model.maxValue) {
                this.model.value = this.model.minValue;
                this._setValue(this.model.value);
            }
            else if (this.model.value >= this.model.minValue && this.model.value <= this.model.maxValue) {
                value = operation == "increment" ? this.model.value + step : this.model.value - step;
                 if(this.model.decimalPlaces == -1) value = parseFloat(value.toFixed(this._afterDec.length));
                if (value >= this.model.minValue && value <= this.model.maxValue)
                    this._setValue(value);
            }
            this._checkErrorClass();
        },

        _validateDecimal: function (e) {
            var char = String.fromCharCode(e.keyCode);
            char = e.keyCode == 188 ? "," : (e.keyCode == 190) ? "." : (e.keyCode == 110) ? ej.preferredCulture(this.model.locale).numberFormat["."] : char;
            if (ej.preferredCulture(this.model.locale).numberFormat["."].charCodeAt(0) == char.charCodeAt(0))
                return true;
            return false;
        },

        _allowKeyCodes: function (e) {
            var keys = new Array(38, 40, 35, 36, 109, 189, 46, 8, 127, 37, 39, 190, 9, 13, 16, 17, 18, 20, 110, 173, 86, 88, 67);
            for (var i = 0; i < keys.length; i++) {
                if (e.keyCode == keys[i] || (this._validateDecimal(e) && this.model.decimalPlaces != 0))
                    return true;
            }
            return false;
        },

        _raiseChangeEvent: function (isCode) {
            var currVal = this.model.value, value;
            if ((this._checkNumValue(this._preVal) !== this._checkNumValue(currVal))) {
                this._preVal = currVal;
                this.model.value = (this.model.decimalPlaces == -1 && !ej.isNullOrUndefined(this.model.value)) ? parseFloat(this.model.value) : this._checkNumValue(this._formatValue(this._preVal, "n", false));
                this._updateHiddenField();
                if (ej.isNullOrUndefined(this.model.value)) {
                    value = this.model.value;
                    this.wrapper.removeClass('e-valid');
                }
                else {
                    value = (this.model.value.toString().indexOf('e') == -1) ? this._removeSeparator(this.model.value) : this._convertToExponetial(this.model.value).unformattedValue;
                    if (this.model.decimalPlaces == -1) {
                        this._separateValue(this.model.value.toString(), false,true);
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            value = this._beforeDec + this._decimalSep + this._afterDec;
                    }
                    this.wrapper.addClass('e-valid');
                }
                this.element.val(value);
			    this.wrapper.attr('aria-valuenow', value);
                this._updateSeparator();
                // Trigger the Jquery change event for the input element.
                this.element.trigger("change");
                this._trigger("_change", { value: this.model.value, isInteraction: !isCode });
                this._trigger("change", { value: this.model.value, isInteraction: !isCode });
            }
        },
        _updateHiddenField: function () {
            var prevActive = this._textBox;
            this._textBox = this._hiddenInput[0];
            this._localizedFormat();
            this._textBox = prevActive;
        },
        _removeSeparator: function (number) {
            if (ej.isNullOrUndefined(number)) return;
            var value, format, tag;
            if (this.model.decimalPlaces == -1) {
                this._separateValue(number.toString(), false,true);
            }
            number = this._checkNumValue(this._formatValue(number, "n", false));
            value = number.toString();
            format = ej.preferredCulture(this.model.locale).numberFormat;
            value = value.replace(".", format["."]);
            return value;
        },
        _updateSeparator: function () {
            if (this._changeSeparator && this.model.value) {
                var formatValue;
                    if (this.sfType === "ej.NumericTextbox")
                        formatValue = this._formatValue(this.model.value, "n", true);
                    else if (this.sfType === "ej.PercentageTextbox")
                        formatValue = this._formatValue((this.model.value) / 100, "p", true);
                    else if (this.sfType === "ej.CurrencyTextbox")
                        formatValue = this._formatValue(this.model.value, "c", true);
                    if (this.model.decimalPlaces == -1) {
                        var index = formatValue.lastIndexOf(this._decimalSep);
                        var val = formatValue.substr(index + 1);
                        this._separateValue(formatValue, true, false);
                        var symbolIndex = (this.sfType === "ej.CurrencyTextbox") ? formatValue.indexOf(this._currencySymbol) : (this.sfType === "ej.PercentageTextbox") ? this._textBox.value.indexOf(this._percentSymbol) : -1;
                        var symbolPos = this._afterDec;
                         if (symbolIndex > 1) {
                           if (this.sfType === "ej.CurrencyTextbox")
                                symbolPos = symbolPos + " " + this._currencySymbol;
                            if (this.sfType === "ej.PercentageTextbox")
                                symbolPos = symbolPos + " " + this._percentSymbol;
                         }
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec != "")
                            formatValue = this._beforeDec + this._decimalSep + symbolPos;
                        if (!ej.isNullOrUndefined(this._afterDec) && this._afterDec == "")
                            formatValue = this._beforeDec + this._decimalSep + val;
                    }
                
                this._hiddenInput.val(this._replaceSeparator(formatValue, ej.preferredCulture(this.model.locale).numberFormat[","], this.model.groupSeparator));
            }
        },

        _replaceSeparator: function (value, find, replaceWith) {
            this._decimalSep = ej.preferredCulture(this.model.locale).numberFormat['.'];
            var reg = find === "" ? new RegExp("\\s", "g") : new RegExp("\\" + find, "g");
            if (this.model.groupSeparator == ej.preferredCulture(this.model.locale).numberFormat['.']) {
                var decimalpoints = this.model.decimalPlaces;
                if (this.model.decimalPlaces == -1) {
                    var index = value.lastIndexOf(this._decimalSep);
                    decimalpoints = value.substr(index + 1).length;
                 }
                var valuelength = value.length - decimalpoints - 1;
                return value.substring(0, valuelength).replace(reg, replaceWith) + value.substring(valuelength, value.length);
            }
            return value.replace(reg, replaceWith);
        },

        _checkSeparator: function (value) {
            this.model.groupSeparator = value != null ? this._validateSeparator(value) : ej.preferredCulture(this.model.locale).numberFormat[','];
            this._changeSeparator = ej.preferredCulture(this.model.locale).numberFormat[","] != this.model.groupSeparator ? true : false;
            this._prevSeparator = this.model.groupSeparator;
        },
        _validateSeparator: function (value) {
            var separator = value.toString();
            var reg = new RegExp("[a-zA-Z0-9]");
            separator = (separator.length > 1) ? separator[0] : separator;
            separator = (!reg.test(separator)) ? separator : this._prevSeparator != null ? this._prevSeparator : ej.preferredCulture(this.model.locale).numberFormat[','];
            return separator;
        },
        _keyPress: function (e) {
            if (e.which === 0 || e.metaKey || e.ctrlKey || e.keyCode === 8 || e.keyCode === 13)
                return;
            var proxy = this, regExp = null, point = ".", cursor, beforeCursor, afterCursor, numberFormat, value;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            numberFormat = ej.preferredCulture(this.model.locale).numberFormat;

            var character = String.fromCharCode(e.which);
            value = beforeCursor + character + afterCursor;
            var separator = numberFormat[point];
            separator = (separator === point) ? "\\" + separator : separator;
            regExp = proxy.model.decimalPlaces === 0 ? new RegExp("^((-)?(\\d*)(-)?)?$") : new RegExp("^(-)?(((\\d+(" + separator + "\\d*)?)|(" + separator + "\\d*)))?((-)?)$");
            // Validate the textbox value 
            if (!regExp.test(value))
                return false;
        },
        _validateDecimalOnType: function (e) {
            var cursor, cancelEvent, beforeCursor, afterCursor, sel, temp;
            cursor = this._caretPosition();
            beforeCursor = this._textBox.value.toString().substring(0, cursor);
            afterCursor = this._textBox.value.toString().substring(cursor);
            sel = this._getSelection(this._textBox.value);
            var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
            temp = (ej.isNullOrUndefined(this.model.value)) ? "" : this.model.value.toString();
            if (this.model.decimalPlaces != 0) {
                var afterdeci = (this._textBox.value).split(decSep)[1];
                if (temp.indexOf(decSep) > 0) {
                    if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                        cancelEvent = true;
                    else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                    else cancelEvent = false;
                }
                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                else
                    cancelEvent = false;
            }
            else
                cancelEvent = false;
            if (cancelEvent) {
                this._keypressFlag = false;
                this._cancelEvent(e);
                return false;
            }
        },

        _keyDown: function (e) {
            if (this.model.readOnly) return;
            this._CurrentCultureInfo = JSON.parse(JSON.stringify(ej.preferredCulture()));
            var cursor, cancelEvent, beforeCursor, afterCursor, sel;
            if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || this._allowKeyCodes(e)) {
                if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 118 || e.keyCode == 67 || e.keyCode == 88)))
                    return true;
                if ((((e.ctrlKey == true) && (e.keyCode != 9 && e.keyCode != 17 && e.keyCode != 86 && e.keyCode != 67))) || (e.keyCode == 67 || e.keyCode == 86 || e.keyCode == 88)) {//Prevent Shift + Tab event
                    this._keypressFlag = false;
                    this._cancelEvent(e);
                    return false;
                }

                if (e.keyCode >= 48 && e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105 || e.keyCode == 110) {//Numbers from 0 to 9 in keyboard and numpad (110 for decimal)
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.toString().substring(0, cursor);
                    afterCursor = this._textBox.value.toString().substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                    // For Numpad issue
                    if (e.keyCode >= 96 && e.keyCode <= 105)
                        e.keyCode -= 48;
                    if (this.model.validateOnType) this._validateDecimalOnType(e);
                    if (this._validateOnType) {
                        var decSep = ej.preferredCulture(this.model.locale).numberFormat["."];
                        var temp = this.model.value.toString();
                        var tempIndex = temp.indexOf(decSep);
                        var value = this.model.value;

                        var replaceminVal = (this.model.decimalPlaces == -1) ? this.model.minValue : this.model.minValue.toFixed(this.model.decimalPlaces);
                        var replacemaxVal = (this.model.decimalPlaces == -1) ? this.model.maxValue : this.model.maxValue.toFixed(this.model.decimalPlaces);
                        var exp = false;
                        if (replaceminVal.toString().indexOf("e") > 0 || replacemaxVal.toString().indexOf("e") > 0)
                            exp = true;
                        if (!exp) {
                            if (decSep != ".") {
                                temp = this._textBox.value.toString();
                                if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                    replaceminVal = this.model.minValue.toString().replace(/["."]/g, decSep);
                                if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                    replacemaxVal = this.model.maxValue.toString().replace(/["."]/g, decSep);
                            }
                            if (replaceminVal.toString().indexOf(decSep) > 0)
                                minVal = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                            else
                                minVal = this.model.minValue;
                            if (replacemaxVal.toString().indexOf(decSep) > 0)
                                maxVal = Number(replacemaxVal.toString().toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                            else
                                maxVal = this.model.maxValue;
                            if (tempIndex > 0) {
                                value = Number(temp.substring(temp.indexOf(decSep) + 1, temp.toString().length));
                                if (replaceminVal.toString().indexOf(decSep) > 0)
                                    minVal = Number(replaceminVal.toString().substring(replaceminVal.toString().indexOf(decSep) + 1, replaceminVal.toString().length));
                                else
                                    minVal = 0;
                                if (replacemaxVal.toString().indexOf(decSep) > 0)
                                    maxVal = Number(replacemaxVal.toString().substring(replacemaxVal.toString().indexOf(decSep) + 1, replacemaxVal.toString().length));
                                else
                                    maxVal = 0;
                                var valb4Dec = Number(temp.substring(0, temp.indexOf(decSep)));
                                var minValb4Dec = Number(replaceminVal.toString().substring(0, replaceminVal.toString().indexOf(decSep)));
                                var maxValb4Dec = Number(replacemaxVal.toString().substring(0, replacemaxVal.toString().indexOf(decSep)));
                                if (!this._validateValue(value, minVal, maxVal, true, valb4Dec, minValb4Dec, maxValb4Dec))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                            else {
                                if (!this._validateValue(value, minVal, maxVal, false))
                                    cancelEvent = true;
                                else
                                    cancelEvent = false;
                            }
                        }
                        else if (this.model.decimalPlaces != 0) {
                            var afterdeci = (this._textBox.value).split(".")[1];
                            if (temp.indexOf(decSep) > 0 || (Number(temp) < Number(replaceminVal) || Number(temp) > Number(replacemaxVal))) {
                                if ((temp.substring(temp.indexOf(decSep) + 1, temp.length)).length > this.model.decimalPlaces)
                                    cancelEvent = true;
                                else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                                else cancelEvent = false;
                            }
                            else if (sel.length == 0 && cursor > (this._textBox.value.indexOf(decSep)) && afterdeci && afterdeci.length >= this.model.decimalPlaces) cancelEvent = true;
                            else
                                cancelEvent = false;
                        }
                        else
                            cancelEvent = false;
                        if (cancelEvent) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                    }

                }
                if (e.keyCode == 38 && this._allowkeyboard) {
                    this._updateInputField("increment");
                    this._cancelEvent(e);
                }

                if (e.keyCode == 40 && this._allowkeyboard) {
                    this._updateInputField("decrement");
                    this._cancelEvent(e);

                }
                if (e.keyCode == 8) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }

                if (e.keyCode == 46 || e.keyCode == 127) {
                    cursor = this._caretPosition();
                    beforeCursor = this._textBox.value.substring(0, cursor);
                    afterCursor = this._textBox.value.substring(cursor);
                    sel = this._getSelection(this._textBox.value);
                }
                if (this._validateDecimal(e) && this.model.decimalPlaces != 0 && e.keyCode != 46) {
                    var decChar = ej.preferredCulture(this.model.locale).numberFormat["."];
                    var minVal, maxVal;
                    var dotSplit = this._textBox.value.split(decChar);
                    if (dotSplit[1] == undefined) {
                        var curPosition = this._caretPosition();
                        var strBeforeCursor = dotSplit[0].substring(0, curPosition);
                        var strAfterCursor = dotSplit[0].substring(curPosition);
                        if (this.model.minValue.toString().indexOf("e") > 0 || this.model.maxValue.toString().indexOf("e") > 0)
                            exp = true;
                        if (strAfterCursor.length > this.model.decimalPlaces && this.model.validateOnType == true) {
                            this._keypressFlag = false;
                            this._cancelEvent(e);
                            return false;
                        }
                        if (this._validateOnType && !exp) {
                            if (this.model.minValue.toString().match(new RegExp(".", "g")))
                                minVal = this.model.minValue.toString().replace(/["."]/g, decChar);
                            if (this.model.maxValue.toString().match(new RegExp(".", "g")))
                                maxVal = this.model.maxValue.toString().replace(/["."]/g, decChar);
                            if (minVal.indexOf(decChar) > 0)
                                minVal = Number(minVal.substring(0, minVal.indexOf(decChar)));
                            else
                                minVal = Number(minVal);
                            if (maxVal.indexOf(decChar) > 0)
                                maxVal = Number(maxVal.substring(0, maxVal.indexOf(decChar)));
                            else
                                maxVal = Number(maxVal);
                            if (this._validateValue(this.model.value, minVal, maxVal, "DecimalKeyPressed"))
                                this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                            else {
                                this._keypressFlag = false;
                                this._cancelEvent(e);
                                return false;
                            }
                        }
                        else
                            this._textBox.value = strBeforeCursor + decChar + strAfterCursor;
                        this._setSelectionRange(curPosition + 1, curPosition + 1);
                    }
                    this._cancelEvent(e);
                } else if (e.keyCode == 190 || e.keyCode == 110) {
                    this._cancelEvent(e);
                }
                if (e.keyCode == 109 || e.keyCode == 189 || e.keyCode == 173) { //'-' char key press.
                    if ((this._caretPosition() != 0 && this._getSelection(this._removeFormats(this._textBox.value)) != this.model.value) || (this.model.minValue >= 0 && !this.model.enableStrictMode) || (this._textBox.value.toString().match(new RegExp("-", "g")) && this._getSelection(this._textBox.value) === ""))
                        this._cancelEvent(e);

                    else if (this._getSelection() == this.model.value)
                        this.model.value = null;
                }

                if (e.keyCode == 13)
                    if ((this._checkNumValue(this._preVal) !== this._checkNumValue(this._textBox.value)))
                        this._setValue(this._textBox.value);
            }

            else if (e.keyCode != 27 && !e.ctrlKey || (e.ctrlKey && e.keyCode == 90 && $.trim(this._textBox.value) === "")) {
                this._keypressFlag = false;
                this._cancelEvent(e);
            }
        },
		_getLocalizedLabels: function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
		
    });
	
    ej.NumericTextbox.Locale = ej.NumericTextbox.Locale || {} ;
    
    ej.NumericTextbox.Locale['default'] = ej.NumericTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.PercentageTextbox.Locale = ej.PercentageTextbox.Locale || {} ;
    
    ej.PercentageTextbox.Locale['default'] = ej.PercentageTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	ej.CurrencyTextbox.Locale = ej.CurrencyTextbox.Locale || {} ;
    
    ej.CurrencyTextbox.Locale['default'] = ej.CurrencyTextbox.Locale['en-US'] = {
        watermarkText: "Enter value"
        
    };
	
		
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to drag the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejDraggable", "ej.Draggable", {
        
        element: null,

        
        model: null,
        validTags: ["div", "span", "a"],

        
        defaults: {
            
            scope: 'default', 
            
            handle: null,  
            
            dragArea: null,
            
            clone: false,
            
            distance: 1, 
			
			dragOnTaphold: false,
            
            cursorAt: { top: -1, left: -2 }, 
            
            dragStart: null, 
            
            drag: null, 
            
            dragStop: null, 
			
			create: null,
            
            destroy: null, 
            
            helper: function () {
                return $('<div class="e-drag-helper" />').html("draggable").appendTo(document.body);
            }
        },

        
        _init: function () {
            this.handler = function () { },
			this.resizables = {};
            this._wireEvents();
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            //e-pinch class enables the touch mode operations in IE browsers
            this._browser.name == "msie" && this.element.addClass("e-pinch");
            this._browser.name == "edge" && this.element.css("touch-action", "none");
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "dragArea":
                        this.model.dragArea = options[key];
                        break;
						case "dragOnTaphold":
                        this.model.dragOnTaphold = options[key];
                        break; 
                }
            }
        },
        
        
        _destroy: function () {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._dragStopHandler)
                .off(ej.eventType.mouseMove, this._dragStartHandler)
                .off(ej.eventType.mouseMove, this._dragHandler)
                .off("mouseleave", this._dragMouseOutHandler)
                .off('selectstart', false);

            

            ej.widgetBase.droppables[this.scope] = null;
            
        },

        _initialize: function (e) {
            if( e.target && e.target.nodeName && $( e.target ).closest( "input[type='text'], textarea, select, option" ).length) return true;
            var ori = e;
			e.preventDefault();
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            
            $(document).on(ej.eventType.mouseMove, this._dragStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);
            if (!this.model.clone) {
                var _offset = this.element.offset();
                this._relXposition = e.pageX - _offset.left;
                this._relYposition = e.pageY - _offset.top;
            }
            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
           //return false;
        },
        _setDragArea: function () {
            var _dragElement = $(this.model.dragArea)[0]; if (!_dragElement) return;
            var elementArea, elementWidthBound, elementHeightBound, elementArea, direction = ["left", "right", "bottom", "top"], top, left;
            if (!ej.isNullOrUndefined(_dragElement.getBoundingClientRect)) {
                elementArea = _dragElement.getBoundingClientRect();
                elementArea.width ? elementWidthBound = elementArea.width : elementWidthBound = elementArea.right - elementArea.left;
                elementArea.height ? elementHeightBound = elementArea.height : elementHeightBound = elementArea.bottom - elementArea.top;
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("border-" + direction[j] + "-width"));
                    this["padding-" + direction[j]] = isNaN(parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]))) ? 0 : parseFloat($($(this.model.dragArea)[0]).css("padding-" + direction[j]));
                }
                top = $(this.model.dragArea).offset().top; left = $(this.model.dragArea).offset().left;
            } else {
                elementWidthBound = $(this.model.dragArea).outerWidth();
                elementHeightBound = $(this.model.dragArea).outerHeight();
                for (var j = 0; j < direction.length; j++) {
                    this["border-" + direction[j] + "-width"] = 0;
                    this["padding-" + direction[j]] = 0;
                }
                top = left = 0;
            }
            this._left = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-left-width"] + this["padding-left"] : left + this["border-left-width"] + this["padding-left"];
            this._top = ej.isNullOrUndefined($(this.model.dragArea).offset()) ? 0 + this["border-top-width"] + this["padding-top"] : top + this["border-top-width"] + this["padding-top"];
            this._right = left + elementWidthBound - [this["border-right-width"] + this["padding-right"]];
            this._bottom = top + elementHeightBound - [this["border-bottom-width"] + this["padding-bottom"]];
        },
        _dragStart: function (e) {
            var ori = e;
            e = this._getCoordinate(e);
            this.margins = {
                left: (parseInt(this.element.css("marginLeft"), 10) || 0),
                top: (parseInt(this.element.css("marginTop"), 10) || 0),
                right: (parseInt(this.element.css("marginRight"), 10) || 0),
                bottom: (parseInt(this.element.css("marginBottom"), 10) || 0)
            };
            this.offset = this.element.offset();
            this.offset = {
                top: this.offset.top - this.margins.top,
                left: this.offset.left - this.margins.left
            };
            this.position = this._getMousePosition(ori);
            var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY;
            var distance = Math.sqrt((x * x) + (y * y));

            if (distance >= this.model.distance) {
			    var ele = this.model.helper({ sender: ori, element: this.target });
				if(!ele || ej.isNullOrUndefined(ele)) return;
                var dragTargetElmnt = this.model.handle = this.helper = ele;
                if (this.model.dragStart) {
                    var currTarget = null;
                    if (ori.type == 'touchmove') {
                        var coor = ori.originalEvent.changedTouches[0];
                        currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                    }
                    else currTarget = ori.originalEvent.target || ori.target;
					if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
						currTarget = this._checkTargetElement(e) || currTarget;   
                    if (this._trigger("dragStart", { event: ori, element: this.element, target: currTarget })) {
                        this._destroy();
                        return false;
                    }
                }
                if (this.model.dragArea) this._setDragArea();
                else {
                    this._left = this._top = this._right = this._bottom = 0;
                    this["border-top-width"] = this["border-left-width"] = 0;
                }
                
                var pos= dragTargetElmnt.offsetParent().offset();
                $(document).off(ej.eventType.mouseMove, this._dragStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                    .on(ej.eventType.mouseMove, this._dragHandler).on(ej.eventType.mouseUp, this._dragStopHandler).on("mouseleave", this._dragMouseOutHandler).on("selectstart", false);
                ej.widgetBase.droppables[this.model.scope] = {
                    draggable: this.element,
                    helper: dragTargetElmnt.css({ position: 'absolute',  left: (this.position.left-pos.left), top: (this.position.top-pos.top) }),
                    destroy: this._destroyHandler
                }
            }
        },

        _drag: function (e) {
            var left, top, pageX, pageY;
			e.preventDefault();
            this.position = this._getMousePosition(e);
            if (this.position.top < 0)
                this.position.top = 0;
            if ($(document).height() < this.position.top)
                this.position.top = $(document).height();
            if ($(document).width() < this.position.left)
                this.position.left = $(document).width();
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
            if (this.model.drag) {
                var currTarget = null;
                if (e.type == 'touchmove') {
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }
                else currTarget = e.originalEvent.target || e.target;
				if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0 )
                    currTarget = this._checkTargetElement(e)|| currTarget; 
                this._trigger("drag", { event: e, element: this.target, target: currTarget });// Raise the dragging event
            }
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._over(e); 
                this._hoverTarget = element; 
            }
            else if (this._hoverTarget) {
                e.target = e.toElement = this._hoverTarget;
                this._hoverTarget.object._out(e);
                this._hoverTarget = null;
            }
            var helperElement = ej.widgetBase.droppables[this.model.scope].helper;
			var pos= helperElement.offsetParent().offset();			 
            pageX = ej.isNullOrUndefined(e.pageX) ? e.originalEvent.changedTouches[0].pageX : e.pageX;
            pageY = ej.isNullOrUndefined(e.pageY) ? e.originalEvent.changedTouches[0].pageY : e.pageY;
            if (this.model.dragArea) {
                if (this._pageX != pageX) {
                    if (this._left > this.position.left) left = this._left;
                    else if (this._right < this.position.left + helperElement.outerWidth(true)) left = this._right - helperElement.outerWidth(true);
                    else left = this.position.left;
                }
                if (this._pageY != pageY) {
                    if (this._top > this.position.top) top = this._top;
                    else if (this._bottom < this.position.top + helperElement.outerHeight(true)) top = this._bottom - helperElement.outerHeight(true);
                    else top = this.position.top;
                }
            }
            else {
                left = this.position.left;
                top = this.position.top;
            }
            if (top < 0 || top - [pos.top + this["border-top-width"]] < 0) top = [pos.top + this["border-top-width"]];
            if (left < 0 || left - [pos.left + this["border-left-width"]] < 0) left = [pos.left + this["border-left-width"]];
            helperElement.css({ left: left - [pos.left + this["border-left-width"]], top: top - [pos.top + this["border-top-width"]] });
            this.position.left = left;
            this.position.top = top;
            this._pageX = pageX;
            this._pageY = pageY;
        },

        _dragStop: function (e) {
            if (e.type == 'mouseup' || e.type == 'touchend') 
                this._destroy(e);
            if (this.model.dragStop) {
                var currTarget = null;
                if (e.type == 'touchend') {
                if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
				currTarget = e.originalEvent.target || e.target;  
                else{
                    var coor = e.originalEvent.changedTouches[0];
                    currTarget = document.elementFromPoint(coor.clientX, coor.clientY);
                }  
                }
                else currTarget = e.originalEvent.target || e.target;                
                if(this.model.cursorAt["top"] == 0 && this.model.cursorAt["left"] ==0)
                    currTarget = this._checkTargetElement(e) || currTarget;              
                this._trigger("dragStop", { event: e, element: this.target, target: currTarget });// Raise the dragstop event
            }
            this._dragEnd(e);
        },
        _dragEnd: function (e) {
            var element = this._checkTargetElement(e);
            if (!ej.isNullOrUndefined(element)) {
                e.target = e.toElement = element;
                element.object._drop(e, this.element);
            }
        },

        _dragMouseEnter: function (e) {
            $(document).off("mouseenter", this._dragMouseEnterHandler);
            if (this._isIE9)
                this._dragManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._dragManualStop(e);
            }
            else if (e.buttons == 0)
                this._dragManualStop(e);
        },

        _dragManualStop: function (e) {
            if (this.model.dragStop != null)
                this._trigger("dragStop", { event: e, element: this.target, target: e.originalEvent.target || e.target });  // Raise the dragstop event
            this._destroy(e);
        },

        _dragMouseOut: function (e) {
            $(document).on("mouseenter", this._dragMouseEnterHandler);
        },

        _checkTargetElement:function(e)
        {
            var target ;
			if (e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold") {
				var coor = e.originalEvent.changedTouches[0];
				target = document.elementFromPoint(coor.clientX, coor.clientY);
			}
			else
				target = e.target;
            if (this.helper && this._contains(this.helper[0], target)) {
                this.helper.hide();
                target = this._elementUnderCursor(e);
                this.helper.show();
                return this._withDropElement(target);
            }
            return this._withDropElement(target);
        },
        _withDropElement:function(target)
        {
            if (target) {
                var dropObj = $(target).data('ejDroppable');
                if (ej.isNullOrUndefined(dropObj)) dropObj = this._checkParentElement($(target));
                if (!ej.isNullOrUndefined(dropObj)) {
                    return $.extend(target, { object: dropObj });
                }
            }
        },
        _checkParentElement: function (element) {
            var target = $(element).closest('.e-droppable');
            if (target.length > 0) {
                var dropObj = $(target).data('ejDroppable');
                if (!ej.isNullOrUndefined(dropObj)) return dropObj;
            }
        },
        _elementUnderCursor:function(e){
            if(e.type == "touchmove" || e.type == "touchstart" || e.type == "touchend" || e.type=="taphold")
                return document.elementFromPoint(e.originalEvent.changedTouches[0].clientX, e.originalEvent.changedTouches[0].clientY);
            else return document.elementFromPoint(e.clientX, e.clientY);
        },
        _contains:function(parent, child) {
            try {
                return $.contains(parent, child) || parent == child;
            } catch (e) {
                    return false;
                }
        },
        _wireEvents: function () {
			if(ej.isDevice()==true && this.model.dragOnTaphold==true)
            this._on(this.element, "taphold", this._initialize);
		else
            this._on(this.element, ej.eventType.mouseDown, this._initialize);
            this._dragStartHandler = $.proxy(this._dragStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._dragStopHandler = $.proxy(this._dragStop, this);
            this._dragHandler = $.proxy(this._drag, this);
            this._dragMouseEnterHandler = $.proxy(this._dragMouseEnter, this);
            this._dragMouseOutHandler = $.proxy(this._dragMouseOut, this);
        },
        _getMousePosition: function (event) {
            event = this._getCoordinate(event);
            var pageX = this.model.clone ? event.pageX : event.pageX - this._relXposition;
            var pageY = this.model.clone ? event.pageY : event.pageY - this._relYposition;
            return { left: pageX - [this.margins.left + this.model.cursorAt.left ], top: pageY - [this.margins.top + this.model.cursorAt.top ] };
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend" || evt.type== "taphold" && ej.browserInfo().name !="msie")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to drop the html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejDroppable", "ej.Droppable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        dropElements : [],
        defaults: {
            
            accept: null,
            
            scope: 'default',
            
            drop: null,
            
            over: null,
            
            out: null,
			
			create: null,
            
            destroy: null
        },

        
        _init: function () {
            this._mouseOver = false;
			this.dropElements.push(this);
        },

        _setModel: function (options) {

        },
        
        
        _destroy: function () {
			 $(this.element).off('mouseup', $.proxy(this._drop, this));
        },

        _over: function (e) {
            if (!this._mouseOver) {
                this._trigger("over", e);
                this._mouseOver = true;
            }
        },
        _out: function (e) {
            if (this._mouseOver) {
                this._trigger("out", e);
                this._mouseOver = false;
            }
        },
        _drop: function (e, dragElement) {
			var _target = e.target; 
			var _parents = $(_target).parents(".e-droppable");
			if($(_target).hasClass("e-droppable")) _parents.push(_target);
			for (var i =0; i< this.dropElements.length; i++ ){
				if ($(_parents).is($(this.dropElements[i].element)))
					this.dropElements[i]._dropEvent.call( this.dropElements[i], e, dragElement );
			}
        },
		_dropEvent : function (e, dragElement){
			var drag = ej.widgetBase.droppables[this.model.scope];
            var isDragged = !ej.isNullOrUndefined(drag.helper) && drag.helper.is(":visible");
			if(isDragged && e.type == "touchend") $(drag.helper).hide();
            var area = this._isDropArea(e);
			if(isDragged && e.type == "touchend") $(drag.helper).show();
            if (drag && !ej.isNullOrUndefined(this.model.drop) && isDragged && area.canDrop) {
                this.model.drop($.extend(e, { dropTarget: area.target , dragElement : dragElement }, true), drag);
            }
		},
        _isDropArea: function (e) {
            // check for touch devices only
            var area = { canDrop: true, target: $(e.target) };
            if (e.type == "touchend") {
                var coor = e.originalEvent.changedTouches[0], _target;
                _target = document.elementFromPoint(coor.clientX, coor.clientY);
                area.canDrop = false;
                var _parents = $(_target).parents();

                for (var i = 0; i < this.element.length; i++) {
                    if ($(_target).is($(this.element[i]))) area = { canDrop: true, target: $(_target) };
                    else for (var j = 0; j < _parents.length; j++) {
                        if ($(this.element[i]).is($(_parents[j]))) {
                            area = { canDrop: true, target: $(_target) };
                            break;
                        }
                    }
                    if (area.canDrop) break;
                }
            }
            return area;
        }
    });

})(jQuery, Syncfusion);

/**
* @fileOverview Plugin to resize the Html elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejResizable", "ej.resizable", {
        
        element: null,        
        model: null,
        validTags: ["div", "span", "a"],
        
        defaults: {
            
            scope: 'default',
            
            handle: null,
            
            distance: 1,
            
            maxHeight: null,
            
            maxWidth: null,
            
            minHeight: 10,
            
            minWidth: 10,
            
            cursorAt: { top: 1, left: 1 },
            
            resizeStart: null,
            
            resize: null,
            
            resizeStop: null,
			
			create: null,
            
            destroy: null,
            
            helper: function () {
                return $('<div class="e-resize-helper" />').html("resizable").appendTo(document.body);
            }
        },
        
        _init: function () {
            this.target = this.element;
            this._browser = ej.browserInfo();
            this._isIE8 = this._browser.name == "msie" && this._browser.version == "8.0";
            this._isIE9 = this._browser.name == "msie" && this._browser.version == "9.0";
            if (this.handle != null) {
                $(this.target).delegate(this.handle, ej.eventType.mouseDown, $.proxy(this._mousedown, this))
                .delegate(this.handle, 'resizestart', this._blockDefaultActions);
            }
            else {
                $(this.target).on("mousedown", $.proxy(this._mousedown, this));                                
            }
            this._resizeStartHandler = $.proxy(this._resizeStart, this);
            this._destroyHandler = $.proxy(this._destroy, this);
            this._resizeStopHandler = $.proxy(this._resizeStop, this);
            this._resizeHandler = $.proxy(this._resize, this);
            this._resizeMouseEnterHandler = $.proxy(this._resizeMouseEnter, this);
        },
        _mouseover: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                $(e.target).css({ cursor: "se-resize" });
                $(this.target).on(ej.eventType.mouseDown, $.proxy(this._mousedown, this));
            }
            else {
                $(this.target).off(ej.eventType.mouseDown);
                $(this.target).css({ cursor: "" });
            }
        },
        _blockDefaultActions: function (e) {
            e.cancelBubble = true;
            e.returnValue = false;
            if (e.preventDefault) e.preventDefault();
            if (e.stopPropagation) e.stopPropagation();
        },
        _setModel: function (options) {

        },
        _mousedown: function (e) {
            var ori = e;
            e = this._getCoordinate(e);
            this.target = $(ori.currentTarget);
            this._initPosition = { x: e.pageX, y: e.pageY };
            this._pageX = e.pageX;
            this._pageY = e.pageY;

            $(document).on(ej.eventType.mouseMove, this._resizeStartHandler).on(ej.eventType.mouseUp, this._destroyHandler);

            $(document.documentElement).trigger(ej.eventType.mouseDown, ori); // The next statement will prevent 'mousedown', so manually trigger it.
            return false;
        },

        _resizeStart: function (e) {
            if ($(e.target).hasClass("e-resizable")) {
                e = this._getCoordinate(e);
                var x = this._initPosition.x - e.pageX, y = this._initPosition.y - e.pageY, _width, _height;
                var distance = Math.sqrt((x * x) + (y * y));
                if (distance >= this.model.distance) {
                    if (this.model.resizeStart != null) 
                        if (this._trigger("resizeStart", { event: e, element: this.target }))  // Raise the resize start event
                            return;
                    var resizeTargetElmnt = this.model.helper({ element: this.target });
                    _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
                    _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
                    this._pageX = e.pageX;
                    this._pageY = e.pageY;
                    var pos = this.getElementPosition(resizeTargetElmnt);
                    $(document).off(ej.eventType.mouseMove, this._resizeStartHandler).off(ej.eventType.mouseUp, this._destroyHandler)
                        .on(ej.eventType.mouseMove, this._resizeHandler).on(ej.eventType.mouseUp, this._resizeStopHandler).on("mouseenter", this._resizeMouseEnterHandler).on("selectstart", false);
                    ej.widgetBase.resizables[this.scope] = {
                        resizable: this.target,
                        helper: resizeTargetElmnt.css({ width: _width, height: _height }),
                        destroy: this._destroyHandler
                    }
                }
            }
        },

        _resize: function (e) {
            var _width, _height, _diff;
            e = this._getCoordinate(e);
            var pos = this.getElementPosition(ej.widgetBase.resizables[this.scope].helper);
            var resizeTargetElmnt = this.model.helper({ element: this.target });
            _width = (e.pageX - this._pageX) + resizeTargetElmnt.outerWidth();
            _height = (e.pageY - this._pageY) + resizeTargetElmnt.outerHeight();
            this._pageX = e.pageX;
            this._pageY = e.pageY;
            if (_width < this.model.minWidth) {
                _diff = this.model.minWidth - _width;
                _width = this.model.minWidth;
                this._pageX = e.pageX + _diff;
            }
            if (_height < this.model.minHeight) {
                _diff = this.model.minHeight - _height;
                _height = this.model.minHeight;
                this._pageY = e.pageY + _diff;
            }
            if (this.model.maxHeight != null && _height > this.model.maxHeight) {
                _diff = _height - this.model.maxHeight;
                _height = this.model.maxHeight;
                this._pageY = e.pageY - _diff;
            }
            if (this.model.maxWidth != null && _width > this.model.maxWidth) {
                _diff = _width - this.model.maxWidth;
                _width = this.model.maxWidth;
                this._pageX = e.pageX - _diff;
            }
            ej.widgetBase.resizables[this.scope].helper.css({ width: _width, height: _height });
            this._trigger("resize", { element: this.target }) // Raise the resize event
        },

        _resizeStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            if (e.type == 'mouseup' || e.type == 'touchend')
                this._destroy(e);
        },

        _resizeMouseEnter: function (e) {
            if (this._isIE9)
                this._resizeManualStop(e);
            else if (this._isIE8) {
                if (e.button == 0)
                    this._resizeManualStop(e);
            }
            else if (e.buttons == 0)
                this._resizeManualStop(e);
        },

        _resizeManualStop: function (e) {
            if (this.model.resizeStop != null)
                this._trigger("resizeStop", { element: this.target });  // Raise the resize stop event
            this._destroy(e);
        },

        
        _destroy: function (e) {
            $(document)
                .off(ej.eventType.mouseUp, this._destroyHandler)
                .off(ej.eventType.mouseUp, this._resizeStopHandler)
                .off(ej.eventType.mouseMove, this._resizeStartHandler)
                .off(ej.eventType.mouseMove, this._resizeHandler)
                .off("mouseenter", this._resizeMouseEnterHandler)
                .off('selectstart', false);            
            ej.widgetBase.resizables[this.scope] = null;
            
        },

        getElementPosition: function (elemnt) {
            if (elemnt != null && elemnt.length > 0)
                return {
                    left: elemnt[0].offsetLeft,
                    top: elemnt[0].offsetTop
                };
            else
                return null;
        },
        _getCoordinate: function (evt) {
            var coor = evt;
            if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend")
                coor = evt.originalEvent.changedTouches[0];
            return coor;
        }
    });

})(jQuery, Syncfusion);;

/**
* @fileOverview Plugin to style the Html ScrollBar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScrollBar", "ej.ScrollBar", {
        defaults: {

            orientation: "horizontal",

            viewportSize: 0,

            height: 18,

            width: 18,

            smallChange: 57,

            largeChange: 57,

            value: 0,

            maximum: 0,

            minimum: 0,

            buttonSize: 18,

            infiniteScrolling: false
        },
        validTags: ["div"],
        type: "transclude",
        dataTypes: {
            buttonSize: "number",
            smallChange: "number",
            largeChange: "number",
        },
        observables: ["value"],
        value: ej.util.valueFunction("value"),
        _enabled: true,
        content: function () {
            if (!this._content || !this._content.length) {
                if (this.model.orientation === "horizontal") {
                    this._content = this.element.find(".e-hhandle");
                }
                else {
                    this._content = this.element.find(".e-vhandle");
                }
            }
            return this._content;
        },
        _init: function () {
            this.element.addClass("e-widget");
            this._ensureScrollers();
            this.content();
            this._setInitialValues();

        },

        _setInitialValues: function () {
            var xy = "X";
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                this.element.addClass("e-hscrollbar");
            }
            else {
                this.element.addClass("e-vscrollbar");
                xy = "Y";
            }
            if (this.value() !== 0 || this.model.minimum !== 0) {
                if (this.value() < this.model.minimum)
                    this.value(this.model.minimum);
                this["scroll"](this.value(), "none");
            }
        },

        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }
            var d2;
            if (!this._scrollData) {
                if (this.model.orientation === "vertical") {
                    this._scrollData = this._createScroller("Height", "Y", "Top", "e-v");
                }
                else {
                    this._scrollData = this._createScroller("Width", "X", "Left", "e-h");
                }
            }
        },

        _setModel: function (option) {
            for (var prop in option) {
                if (prop === "value") {
                    if (this.value()) {
                        this.scroll(this.value(), "none");
                    }
                } else {
                    this.refresh();
                    break;
                }
            }
        },

        _createScroller: function (dimension, xy, position, css) {
            var height;
            var d = {};
            var jqVersion = $.fn.jquery;
            d.dimension = dimension;
            d.xy = xy;
            d.position = position;
            d.css = css;
            d.uDimension = dimension;

            this._calculateLayout(d);
            this._createLayout(d);
            var buttons = this[d.main].find(".e-button");

            this._off(buttons, "mousedown")
                ._on(buttons, "mousedown", { d: d, step: 1 }, this._spaceMouseDown);
            this._off(this[d.scroll], "mousedown")
                ._on(this[d.scroll], "mousedown", { d: d }, this._spaceMouseDown);
            this._off(this[d.handler], "mousedown touchstart")
                ._on(this[d.handler], "mousedown touchstart", { d: d }, this._mouseDown);

            return d;
        },
        _createLayout: function (d) {
            var divString = "<div class='" + d.css + "{0}' style='" + d.dimension + ":{1}px'>{2}</div>";
            var jqVersion = $.fn.jquery;
            var lit = {}, height;
            lit[d.dimension] = d.modelDim;

            var el = ej.buildTag(
                "div." + d.css + "scroll e-box",
                    String.format(divString, "up e-chevron-up_01 e-icon e-box e-button", d.buttonSize) +
                    String.format(divString, "handlespace", d.handleSpace,
                        String.format(divString, "handle e-box e-pinch", d.handle)) +
                    String.format(divString, "down e-chevron-down_01 e-icon e-box e-button", d.buttonSize),
                lit
            );

            this.element.append(el);
            this.element.find('.e-vhandle').addClass("e-v-line e-icon");
            this.element.find('.e-hhandle').addClass("e-h-line e-icon");
            jqVersion === "1.7.1" || jqVersion === "1.7.2" ? height = d.uDimension.toLowerCase() : height = "outer" + d.uDimension;
            this[d.handler] = this.element.find("." + d.handler);
            this[d.handler].css("transition", "none");
            this[d.scroll] = this[d.handler].parent();
            this[d.main] = this[d.scroll].parent();
            this[d.main].find(".e-button")["outer" + d.uDimension](d.buttonSize);
        },
        _calculateLayout: function (d) {
            d.scrollDim = "scroll" + d.dimension;
            d.lPosition = d.position.toLowerCase();
            d.clientXy = "page" + d.xy;
            d.scrollVal = "scroll" + d.position;
            d.scrollOneStepBy = this.model.smallChange;
            d.modelDim = this.model[(d.dimension = d.dimension.toLowerCase())];
            d.handler = d.css + "handle";
            d.buttonSize = this.model.buttonSize;
            d.main = d.css + "scroll";
            d.scroll = d.css + "ScrollSpace";
            d.handleSpace = d.modelDim - 2 * d.buttonSize;
            d.scrollable = (this.model.maximum - this.model.minimum);
            var trackLength = this.model.height;
            if (this.model.orientation === "horizontal")
                trackLength = this.model.width;
            d.handle = (this.model.viewportSize / ((this.model.maximum - this.model.minimum) + this.model.viewportSize)) * (trackLength - 2 * this.model.buttonSize);
            var check;
            !ej.isNullOrUndefined(this.model.elementHeight) && typeof this.model.elementHeight === "string" && this.model.elementHeight.indexOf("%") != -1 ? check = true : check = false;
            if (d.handle < 20 && !check) d.handle = 20;
            d.onePx = d.scrollable / (d.handleSpace - d.handle);
            d.fromScroller = false;
            d.up = true;
            d.vInterval = undefined;
        },
        _updateLayout: function (d) {
            this.element.height(this.model.height);
            this.element.width(this.model.width);
            var handle = this.element.find("." + d.css + "handle");
            var handleSpace = this.element.find("." + d.css + "handlespace");
            var size = d.dimension == "width" ? handle.css('left') : handle.css('top');
            var dimension = d.dimension == "width" ? handleSpace.outerWidth() : handleSpace.outerHeight();
            if (size !== undefined && size !== "auto") {
                if (!(dimension >= d.handle + parseFloat(size)))
                    if (this.model.enableRTL) handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle));
                    else handle.css(d.dimension === "width" ? 'left' : 'top', (parseFloat(dimension) - d.handle) > 0 ? (parseFloat(dimension) - d.handle) : 0);
            }
            this.element.find("." + d.css + "scroll").css(d.dimension, d.modelDim + "px")
                .find(".e-button").css(d.dimension, this.model.buttonSize).end()
                .find("." + d.css + "handlespace").css(d.dimension, d.handleSpace + "px")
                .find("." + d.css + "handle").css(d.dimension, d.handle + "px");
        },
        refresh: function () {
            this._ensureScrollers();
            if (this.value()) {
                this.scroll(this.value(), "none");
            }
            if (this._scrollData) {
                this._calculateLayout(this._scrollData);
                this._updateLayout(this._scrollData);
            }
        },

        scroll: function (pixel, source, triggerEvent, e) {
            var dS = this._scrollData;
            if (!triggerEvent) {
                if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollLeft: pixel, originalEvent: e }))
                        return;
                }
                else {
                    if (this._trigger("scroll", { source: source || "custom", scrollData: this._scrollData, scrollTop: pixel, originalEvent: e }))
                        return;
                }
            }
            if (this._scrollData) {
                if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie")
                    this.value(-dS.scrollable + pixel);
                else {
                    if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie") this.value(-1 * pixel);
                    else this.value(pixel);
                }
                if (this.content().length > 0) {
                    if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal) {
                        var left = (this.element.find('.e-hhandlespace').width() - this.element.find('.e-hhandle').outerWidth());
                        pixel = left < ((pixel - this.model.minimum) / this._scrollData.onePx) ? left : ((pixel - this.model.minimum) / this._scrollData.onePx);
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name != "msie") {
                            pixel = left - pixel;
                            pixel > 0 ? pixel = pixel * -1 : pixel;
                        }
                        if (this._scrollData.enableRTL && (e == "mousemove" || e == "touchmove") && ej.browserInfo().name == "msie") pixel = -pixel;
                        this._scrollData.enableRTL && pixel > 0 && !this._scrollData._scrollleftflag ? pixel = 0 : pixel
                        if (this._scrollData._scrollleftflag) {

                            pixel > 0 ? pixel = pixel * -1 : pixel;
                            this.value(pixel);
                        }
                        this.content()[0].style.left = pixel + "px";
                        this._scrollData._scrollleftflag = false;
                    }
                    else {
                        var top = (this.element.find('.e-vhandlespace').height() - this.element.find('.e-vhandle').outerHeight());
                        pixel = top < ((pixel - this.model.minimum) / this._scrollData.onePx) ? top : ((pixel - this.model.minimum) / this._scrollData.onePx);
                        if (ej.browserInfo().name == "msie" && isNaN(pixel)) pixel = "";
                        this.content()[0].style.top = pixel + "px";
                    }
                }
            }
        },

        _changeTop: function (d, step, source) {
            var start, t;
            if (d.dimension === "height")
                start = this.value();
            else
                start = this.value();
            t = start + step;
            d.step = step;
            if ((d.enableRTL && step < 0) || (step > 0 && !d.enableRTL)) {
                if (d.enableRTL) {
                    if (t < this.model.maximum * -1)
                        t = this.model.maximum * -1;
                }
                else {
                    if (t > this.model.maximum)
                        t = this.model.maximum;
                }
            }
            else {
                if (d.enableRTL) {
                    if (t > this.model.minimum)
                        t = this.model.minimum;
                }
                else {
                    if (t < this.model.minimum)
                        t = this.model.minimum;
                }
            }
            if (t !== start || this.model.infiniteScrolling) {
                this["scroll"](t, source);
            }
            return t !== start;
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            clearInterval(d.vInterval);
            if (e.type == "touchend") $(e.target).removeClass("e-touch");
            if (e.type === "mouseup" || e.type === "touchend" || (!e.toElement && !e.relatedTarget && !e.target)) {
                this._prevY = this._d = this._data = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._mouseUp, this));
                d.fromScroller = false;
                this[d.scroll].off("mousemove");
                this[d.handler].off("mousemove").css("transition", "");
                if (e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                }
            }
            d.up = true;
        },


        _mouseDown: function (down) {
            if (!this._enabled) return;
            this._d = down;
            this._data = this._d.data.d,
            this._data.target = this._d.target;
            this._data.fromScroller = true;
            this[this._data.handler].css("transition", "none");
            this._on($(document), "mousemove touchmove", { d: this._data, source: "thumb" }, this._mouseMove);
            this._trigger("thumbStart", { originalEvent: this._d, scrollData: this._data });
            $(document).one("mouseup touchend", { d: this._data, source: "thumb" }, ej.proxy(this._mouseUp, this));
            if (down.type == "touchstart") $(down.target).addClass("e-touch");
        },
        _mouseCall: function (move) {
            move.type = "mouseup";
            this._mouseUp(move);
        },
        _mouseMove: function (move) {
            var value, step = 0, top = parseInt(this[this._data.handler].css(this._data.lPosition)) || 0;
            move.preventDefault();
            var skip = 1;
            if (ej.isNullOrUndefined(move.target.tagName)) {
                if ($(move.target).is(document)) {
                    this._mouseCall(move);
                    return;
                }
            }
            else if (move.target.tagName.toLowerCase() === "iframe") { this._mouseCall(move); return; }
            var pageXY = move.type == "mousemove" ? move[this._data.clientXy] : move.originalEvent.changedTouches[0][this._data.clientXy];
            if (this._prevY && pageXY !== this._prevY) {
                step = (pageXY - this._prevY);
                if (this.model.infiniteScrolling) {
                    top = top + step;
                    this._data.step = step;
                    if (this._data.enableRTL ? top > 0 : top < 0) top = 0;
                    if ((top * (this._data.enableRTL ? -1 : 1)) + this._data.handle >= this._data.handleSpace)
                        top = (this._data.handleSpace - this._data.handle) * (this._data.enableRTL ? -1 : 1);
                    value = Math.ceil(top * this._data.onePx);
                    this["scroll"](value, "thumb");
                }
                else {
                    value = step * this._data.onePx;
                    this._changeTop(this._data, value, "thumb", this._d);
                }
                this._trigger("thumbMove", { originalEvent: move, scrollData: this._data });
            }
            if (skip === 1)
                this._prevY = pageXY;
        },

        _spaceMouseDown: function (e) {
            if (!e.data || !this._enabled) return;
            var d = e.data.d;
            if (e.which !== 1 || e.target === this[d.handler][0]) return;
            var step = e.data.step ? this.model.smallChange : this.model.largeChange, hTop = e.data.top || this[d.handler].offset()[d.lPosition];
            e[d.clientXy] = e[d.clientXy] || 0;
            if (e[d.clientXy] < hTop) step *= -1;
            d.target = e.target;
            this._changeTop(d, step, step === 3 ? "track" : "button", e);
            if (e.data.step !== 1) {
                this[d.scroll].mousemove(function () {
                    d.up = true;
                });
            }
            d.up = false;
            d.vInterval = setInterval(ej.proxy(function () {
                if (step < 0 ? hTop + (step / d.onePx) < e[d.clientXy] : hTop + d.handle + (step / d.onePx) > e[d.clientXy])
                    d.up = true;
                if (d.up) {
                    clearInterval(d.vInterval);
                    return;
                }
                this._changeTop(d, step, step === 3 ? "track" : "button", e);
                e.data ? hTop = e.data.top || this[d.handler].offset()[d.lPosition] : hTop = this[d.handler].offset()[d.lPosition];
            }, this), 150);

            $(document).one("mouseup", { d: d }, ej.proxy(this._mouseUp, this));
            $(document).mouseout({ d: d }, ej.proxy(this._mouseUp, this));
        },

        _remove: function () {
            if (this.model.orientation === ej.ScrollBar.Orientation.Horizontal)
                this.element.find(".e-hscroll").remove();
            if (this.model.orientation === ej.ScrollBar.Orientation.Vertical)
                this.element.find(".e-vscroll").remove();
            this._scrollData = null;
            this._content = null;
        },

        _destroy: function () {
            this.element.remove();
        },
    });

    ej.ScrollBar.Orientation = {
        Horizontal: "horizontal",
        Vertical: "vertical"
    };
})(jQuery, Syncfusion, window);;

/**
* @fileOverview Plugin to style the Html Scroller elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/


(function ($, ej, window, undefined) {
    'use strict';

    ej.widget("ejScroller", "ej.Scroller", {
        _addToPersist: ["scrollLeft", "scrollTop"],
        defaults: {

            height: 250,

            autoHide: false,

            animationSpeed: 600,

            width: 0,

            scrollOneStepBy: 57,

            buttonSize: 18,

            scrollLeft: 0,

            scrollTop: 0,

            targetPane: null,

            scrollerSize: 18,

            enablePersistence: false,

            enableRTL: undefined,

            enableTouchScroll: true,

            enabled: true,

            create: null,

            destroy: null,

            wheelStart: null,

            wheelMove: null,

            wheelStop: null
        },
        validTags: ["div"],
        type: "transclude",

        dataTypes: {
            buttonSize: "number",
            scrollOneStepBy: "number"
        },
        observables: ["scrollTop", "scrollLeft"],
        scrollTop: ej.util.valueFunction("scrollTop"),
        scrollLeft: ej.util.valueFunction("scrollLeft"),

        keyConfigs: {
            up: "38",
            down: "40",
            left: "37",
            right: "39",
            pageUp: "33",
            pageDown: "34",
            pageLeft: "ctrl+37",
            pageRight: "ctrl+39"
        },

        content: function () {
            if (!this._content || !this._content.length || !this._content[0].offsetParent)
                this._content = this.element.children().first().addClass("e-content");

            return this._content;
        },
        _setFirst: true,
        _updateScroll: false,

        _init: function () {
            if (!ej.isNullOrUndefined(this.content()[0])) {
                this._prevScrollWidth = this.content()[0].scrollWidth, this._prevScrollHeight = this.content()[0].scrollHeight;
                this.element.addClass("e-widget");
                this.content();
                this._browser = ej.browserInfo().name;
                this._wheelStart = true;
                this._eleHeight = this.model.height;
                this._eleWidth = this.model.width;
                if (this.model.enableRTL === undefined) {
                    this.model.enableRTL = this.element.css("direction") === "rtl";
                }
                this._ensureScrollers();
                if (this.model.enableRTL) {
                    this.element.addClass("e-rtl");
                    this._rtlScrollLeftValue = this.content().scrollLeft();
                }
                this._on(this.content(), "scroll", this._scroll);
                this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
                if (this.scrollLeft())
                    this._setScrollLeftValue(this.scrollLeft());
                if (this.scrollTop())
                    this.content().scrollTop(this.scrollTop());

                if (this.model.autoHide) {
                    this._autohide();
                }
                if (this.model.enabled) {
                    this.enable();
                }
                else {
                    this.disable();
                }
                this._setDimension();
                if (this._prevScrollWidth !== this.content()[0].scrollWidth || this._prevScrollHeight !== this.content()[0].scrollHeight) this.refresh();
            }
            this._addActionClass();
        },
        _addActionClass: function () {
            //e-pinch class enables the touch mode operations in IE browsers
            if (this._browser == "msie") {
                this.content().removeClass('e-pinch e-pan-x e-pan-y');
                if (this._vScrollbar && this._hScrollbar) this.content().addClass('e-pinch');
                else if (this._vScrollbar && !this._hScrollbar) this.content().addClass('e-pan-x');
                else if (this._hScrollbar && !this._vScrollbar) this.content().addClass('e-pan-y');
            }
        },
        _setDimension: function () {
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1) {
                if (!this._vScroll) $(this.content()[0]).height("");
                else this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());
            }
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                if (!this._hScroll) $(this.content()[0]).width("");
                else this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), this.element.parent().width());
            }
        },
        _setScrollLeftValue: function (leftValue) {
            if (this.model.enableRTL) {
                if (ej.browserInfo().name == "mozilla")
                    leftValue = leftValue < 0 ? leftValue : (leftValue * -1);
                else if (!ej.isNullOrUndefined(this._rtlScrollLeftValue) && (ej.browserInfo().name == "chrome" || this._rtlScrollLeftValue > 0))
                    leftValue = leftValue < 0 ? (this._rtlScrollLeftValue + leftValue) : (this._rtlScrollLeftValue - leftValue);
                else
                    leftValue = Math.abs(leftValue);
            }
            this.content().scrollLeft(leftValue);
        },


        _ensureScrollers: function () {
            var jqVersion = $.fn.jquery, height, width;
            this.model.height = typeof this.model.height == "string" && this.model.height.indexOf("px") != -1 ? parseInt(this.model.height) : this.model.height;
            this.model.width = typeof this.model.width == "string" && this.model.width.indexOf("px") != -1 ? parseInt(this.model.width) : this.model.width;
            if (this.model.height) {
                this.element.height(this.model.height);
            }
            if (this.model.width) {
                this.element.width(this.model.width);
            }

            this._off(this.content(), "mousedown touchstart");
            if (this.content().length > 0) {
                if (this.isVScroll()) {
                    if (!this._vScrollbar) {
                        this._vScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Vertical, this.isHScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._vScrollbar = null;
                    this.element.children(".e-vscrollbar").remove();
                }
                if (this.isHScroll()) {
                    if (!this._hScrollbar) {
                        this._hScrollbar = this._createScrollbar(ej.ScrollBar.Orientation.Horizontal, this.isVScroll());
                    }
                    if (this.model.enableTouchScroll)
                        this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                } else {
                    this._hScrollbar = null;
                    this.element.children(".e-hscrollbar").remove();
                }

                if (!this._vScrollbar && !this._hScrollbar)
                    this.content().css({ width: "auto", height: "auto" });

                if (!(this.element.find(".e-hscroll").length > 0)) {
                    if (this._vScrollbar) {
                        this.content().outerHeight(this.content().outerHeight() - 1);
                    }
                }
                jqVersion === "1.7.1" || jqVersion === "1.7.2" ? (this._contentHeight = "height", this._contentWidth = "width") : (this._contentHeight = "outerHeight", this._contentWidth = "outerWidth");
                this._hScroll = this.isHScroll(), this._vScroll = this.isVScroll();
                if (this._hScroll || this._vScroll) {
                    this.content().addClass("e-content");
                    var rect = this._exactElementDimension(this.element);
                    this._elementDimension(rect);
                    if(this.model.targetPane !== null && this.content().find(this.model.targetPane)[0] !== undefined) this.content().find(this.model.targetPane)[0].scrollLeft = this.scrollLeft();
                    if ((isNaN(this._eleWidth) && (this._eleWidth.indexOf("%") > 0)) && (isNaN(this._eleHeight) && (this._eleHeight.indexOf("%") > 0))) $(window).on('resize', $.proxy(this._resetScroller, this));
                } else
                    this.content().removeClass("e-content");
                this._setDimension();
                this._parentHeight = $(this.element).parent().height(); this._parentWidth = $(this.element).parent().width();
            }
        },
        _elementDimension:function(rect){
            this._ElementHeight = rect.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
            this.content()[this._contentHeight](this._ElementHeight - ((this._hScroll && !this.model.autoHide) ? this.model.scrollerSize :
             this.element.find(".e-hscrollbar").is(':visible') ? this.model.scrollerSize : 0));
            this._ElementWidth = rect.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
            this.content()[this._contentWidth](this._ElementWidth - ((this._vScroll && !this.model.autoHide) ? this.model.scrollerSize :
            this.element.find(".e-vscrollbar").is(':visible') ? this.model.scrollerSize : 0));
        },        
        _convertPercentageToPixel: function (ele, outer) {
            return Math.floor((ele * outer) / 100);
        },

        isHScroll: function () {
            if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1)
                return this.content()[0].scrollWidth > this.element.width();
            else {
                if (this.model.width > 0) {
                    var $paneObject = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $paneObject.length)
                        return ($paneObject[0].scrollWidth + $paneObject.siblings().width()) > this.model.width;
                    else {
                        if (this.content()[0].scrollWidth > this.model.width) return true;
                        else if (this.content()[0].scrollWidth == this.model.width)
                            if (this.model.autoHide && $(this.content()[0]).find('> *').length > 0) return $(this.content()[0]).find('> *')[0].scrollWidth > $(this.content()[0]).width();
                            else if ($(this.content()[0]).find('> *').length > 0) return $(this.content()[0]).find('> *')[0].scrollWidth > this.model.width;
                        return false;
                    }
                    return false;
                }
                return false;
            }
        },

        isVScroll: function () {
            //To avoid unnecessarilly render the vertical scrollbar for 1 or 2 px difference range.
            var border = 2;
            if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                return this.content()[0].scrollHeight > this.element.outerHeight(); //this._convertPercentageToPixel(parseInt(this._eleHeight), this.element.parent().height());        
            else if (this.model.height > 0) {
                if ((this.content()[0].scrollHeight > this.model.height)) return true;
                else if (this.isHScroll()) if ((this.content()[0].scrollHeight == this.model.height || (this.content()[0].scrollHeight > this.model.height - (this.model.scrollerSize - border)))) return true;
            }
            return false;
        },
        _setModel: function (option) {
            for (var prop in option) {
                switch (prop) {
                    case "enableRTL":
                        if (option[prop]) {
                            this.element.addClass("e-rtl");
                            this._rtlScrollLeftValue = this.content().scrollLeft();
                            if (!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = true;

                        } else {
                            this.element.removeClass("e-rtl");
                            if (!ej.isNullOrUndefined(this._hScrollbar)) this._hScrollbar._scrollData.enableRTL = false;
                        }
                        if (this._hScrollbar) {
                            this.element.find(".e-hhandle").css("left", 0);
                            this._hScrollbar.value(0);
                        }
                        break;
                    case "scrollLeft":
                        if (parseFloat(ej.util.getVal(option[prop])) < 0 || !this._hScroll) option[prop] = 0;
                        this._externalCall = true;
                        if (this._hScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        this._setScrollLeftValue(parseFloat(option[prop]));
                        this["scrollLeft"](option[prop]);
                        if (this._hScrollbar && !(this._hScrollbar._scrollData._scrollleftflag && this.model.enableRTL))
                            this.scrollX(option[prop], true);
                        break;
                    case "scrollTop":
                        if (this._vScrollbar) option[prop] = parseFloat(ej.util.getVal(option[prop])) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(ej.util.getVal(option[prop]));
                        if (parseFloat(option[prop]) < 0 || !this._vScroll) option[prop] = 0;
                        this._externalCall = true;
                        this.content().scrollTop(parseFloat(option[prop]));
                        this["scrollTop"](option[prop]);
                        this.scrollY(option[prop], true);
                        break;
                    case "touchScroll":
                        if (!this.model.enableTouchScroll)
                            this._off(this.content(), "mousedown touchstart");
                        else {
                            if (this._vScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._vScrollbar._scrollData }, this._mouseDownOnContent);
                            if (this._hScrollbar)
                                this._on(this.content(), "mousedown touchstart", { d: this._hScrollbar._scrollData }, this._mouseDownOnContent);
                        }
                        break;
                    case "scrollOneStepBy":
                        if (this._vScrollbar) {
                            this._vScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._vScrollbar.model.smallChange = option[prop];
                        }
                        if (this._hScrollbar) {
                            this._hScrollbar._scrollData.scrollOneStepBy = option[prop];
                            this._hScrollbar.model.smallChange = option[prop];
                        }
                        break;
                    case "buttonSize":
                        if (this._vScrollbar) this._vScrollbar.model.buttonSize = this.model.buttonSize;
                        if (this._hScrollbar) this._hScrollbar.model.buttonSize = this.model.buttonSize;
                        this.refresh();
                        break;
                    case "height": this._eleHeight = option[prop];
                        this.refresh();
                        break;
                    case "width": this._eleWidth = option[prop];
                        this.refresh();
                        break;
                    case "enabled":
                        if (!option[prop]) this.disable();
                        else this.enable();
                        break;
                    default:
                        this.refresh();
                }
            }
        },

        _createScrollbar: function (orientation, isOtherScroll) {
            var proxy = this;
            var id, viewportSize, width, height, maximum, value;
            var div = document.createElement("div");
            if (orientation === ej.ScrollBar.Orientation.Vertical) {
                width = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.height) && typeof this.model.height === "string" && this.model.height.indexOf("%") != -1)
                    height = viewportSize = this.element.height() - (isOtherScroll ? this.model.scrollerSize : 0);
                else
                    height = viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                maximum = this.content()[0]["scrollHeight"];
                value = this.scrollTop();
            }
            else {
                width = viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                height = this.model.scrollerSize;
                if (!ej.isNullOrUndefined(this.model.width) && typeof this.model.width === "string" && this.model.width.indexOf("%") != -1) {
                    width = viewportSize = this.element.width() - (isOtherScroll ? this.model.scrollerSize : 0);
                    maximum = this.content()[0]["scrollWidth"];
                }
                else {
                    var $pane = this.content().find(this.model.targetPane);
                    if (this.model.targetPane != null && $pane.length)
                        maximum = $pane[0]["scrollWidth"] + $pane.parent().width() - $pane.width();
                    else
                        maximum = this.content()[0]["scrollWidth"];
                }
                value = this.scrollLeft();
            }
            if (this.element.children(".e-hscrollbar").length > 0)
                $(this.element.children(".e-hscrollbar")).before(div);
            else
                this.element.append(div);
            $(div).ejScrollBar({
                elementHeight: proxy._eleHeight,
                elementWidth: proxy._eleWidth,
                buttonSize: proxy.model.buttonSize,
                orientation: orientation,
                viewportSize: viewportSize,
                height: height,
                width: width,
                maximum: maximum - viewportSize,
                value: value,
                smallChange: this.model.scrollOneStepBy,
                largeChange: 3 * this.model.scrollOneStepBy,
                scroll: ej.proxy(this._scrollChanged, this),
                thumbEnd: ej.proxy(this._thumbEnd, this),
                thumbStart: ej.proxy(this._thumbStart, this),
                thumbMove: ej.proxy(this._thumbMove, this),
            });
            var scrollbar = $(div).ejScrollBar("instance");
            (orientation === ej.ScrollBar.Orientation.Vertical || !isOtherScroll) && this._off(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", this._mouseWheel)
                ._on(this.element, this._browser == "msie" ? "wheel mousewheel" : "mousewheel DOMMouseScroll", { d: scrollbar._scrollData }, this._mouseWheel);
            if (orientation === ej.ScrollBar.Orientation.Horizontal) {
                this._scrollXdata = scrollbar._scrollData;
            }
            else
                this._scrollYdata = scrollbar._scrollData;
            if (orientation === ej.ScrollBar.Orientation.Horizontal && this.model.enableRTL) {
                scrollbar._scrollData.enableRTL = true;
            }
            scrollbar._enabled = this.model.enabled;
            return scrollbar;
        },

        _updateScrollbar: function (orientation, isOtherScroll) {
            var scrollbar = orientation === ej.ScrollBar.Orientation.Vertical ? this._vScrollbar : this._hScrollbar;
            if (scrollbar) {
                if (orientation === ej.ScrollBar.Orientation.Vertical) {
                    scrollbar.model.width = this.model.scrollerSize;
                    scrollbar.model.height = scrollbar.model.viewportSize = this.model.height - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.maximum = this.content()[0]["scrollHeight"] - scrollbar.model.viewportSize;
                    scrollbar.model.value = this.scrollTop();
                }
                else {
                    scrollbar.model.width = scrollbar.model.viewportSize = this.model.width - (isOtherScroll ? this.model.scrollerSize : 0);
                    scrollbar.model.height = this.model.scrollerSize;
                    scrollbar.model.maximum = ((this.model.targetPane != null && this.content().find(this.model.targetPane).length > 0) ? this.content().find(this.model.targetPane)[0]["scrollWidth"] + (this.content().width() - $(this.model.targetPane).outerWidth()) : this.content()[0]["scrollWidth"]) - scrollbar.model.viewportSize;
                    if (!this.model.enableRTL)
                        scrollbar.model.value = this.scrollLeft();
                }
            }
        },

        _autohide: function () {
            if (this.model.autoHide) {
                this.element.addClass("e-autohide");
                this._on(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").hide();
				this._elementDimension(this._exactElementDimension(this.element));
            }
            else {
                this.element.removeClass("e-autohide");
                this._off(this.element, "mouseenter mouseleave touchstart touchend", this._scrollerHover);
                this.content().siblings(".e-scrollbar.e-js").show();
            }
        },

        _scrollChanged: function (e) {
            this._updateScroll = true;
            if (e.scrollTop !== undefined)
                this.scrollY(e.scrollTop, true, "", e.source);
            else if (e.scrollLeft !== undefined)
                this.scrollX(e.scrollLeft, true, "", e.source);
            this._updateScroll = false;
            var proxy = this;
            $.when(this.content()).done(ej.proxy(function () {
                proxy._trigger("scrollEnd", { scrollData: e });
            }));
        },
        _bindBlurEvent: function (scrollObj, e) {
            this._scrollEle = $(scrollObj).data('ejScrollBar');
            this._event = e; var proxy = this;
            this._listener = function (e) {
                this._scrollEle._off($(document), "mousemove touchmove", this._scrollEle._mouseMove);
                $(document).off("mouseup touchend", ej.proxy(this._scrollEle._mouseUp, this._scrollEle));
                this._scrollEle._prevY = null;
                this._off($(document), "mousemove touchmove", this._mouseMove);
                this._off($(document), "mouseup touchend", this._mouseUp);
                this._off($(window), "blur");
                if (this._evtData.handler === "e-vhandle") this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
                else this._scrollEle._trigger("thumbEnd", { originalEvent: this._event, scrollData: this._evtData });
            };
            this._on($(window), "blur", this._listener);
        },
        _thumbStart: function (e) {
            this._evtData = e.scrollData;
            var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar'); var scrollObj = e.scrollData.handler === "e-vhandle" ? this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar') : this.element.find('.' + e.scrollData.handler).closest('.e-scrollbar');
            this._bindBlurEvent(scrollObj, e);
            this._trigger("thumbStart", e);
        },
        _thumbMove: function (e) {
            this._trigger("thumbMove", e);
        },
        _thumbEnd: function (e) {
            this._trigger("thumbEnd", e);
            this._off($(window), "blur");
        },

        refresh: function (needRefresh) {
            if (!needRefresh)
                this.element.find(">.e-content").removeAttr("style");

            if (!ej.isNullOrUndefined(this._eleHeight) && typeof this._eleHeight === "string" && this._eleHeight.indexOf("%") != -1 && this._parentHeight != $(this.element).parent().height()) {
                var element = this._exactElementDimension(this.element.parent());
                element = element.height - (this["border_bottom"] + this["border_top"] + this["padding_bottom"] + this["padding_top"]);
                this.model.height = this._convertPercentageToPixel(parseInt(this._eleHeight), element);
            }
            if (!ej.isNullOrUndefined(this._eleWidth) && typeof this._eleWidth === "string" && this._eleWidth.indexOf("%") != -1 && this._parentWidth != $(this.element).parent().width()) {
                var element = this._exactElementDimension(this.element.parent());
                element = element.width - (this["border_left"] + this["border_right"] + this["padding_left"] + this["padding_right"]);
                this.model.width = this._convertPercentageToPixel(parseInt(this._eleWidth), element);
            }

            this._ensureScrollers();
            var scrollLeftValue = this.scrollLeft();
            if (this.model.enableRTL) {
                !this.element.hasClass("e-rtl") && this.element.addClass("e-rtl");
                this._rtlScrollLeftValue = this.content().scrollLeft();
                scrollLeftValue > 0 ? this.content().scrollLeft(scrollLeftValue) : this._setScrollLeftValue(scrollLeftValue);
            }
            else
                this.content().scrollLeft(scrollLeftValue);
            if ((this.scrollTop() && this._vScrollbar == null) || (this._vScrollbar !== null && (this._vScrollbar && this._vScrollbar._scrollData != null) && !this._vScrollbar._scrollData.skipChange))
                this.content().scrollTop(this.scrollTop());

            if (this._vScrollbar) {
                this._vScrollbar._scrollData.dimension = "Height";
                this._updateScrollbar(ej.ScrollBar.Orientation.Vertical, this._hScroll);
                this._vScroll && !this._vScrollbar._calculateLayout(this._vScrollbar._scrollData) && this._vScrollbar._updateLayout(this._vScrollbar._scrollData);
            }
            if (this._hScrollbar) {
                this._hScrollbar._scrollData.dimension = "Width";
                this._updateScrollbar(ej.ScrollBar.Orientation.Horizontal, this._vScroll);
                this._hScroll && !this._hScrollbar._calculateLayout(this._hScrollbar._scrollData) && this._hScrollbar._updateLayout(this._hScrollbar._scrollData);
            }
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this.element.find(".e-hhandle").css("left", "0px");
            else
                this.model.targetPane != null && this._on(this.content().find(this.model.targetPane), "scroll", this._scroll);
            this._addActionClass();
            this._autohide();
        },
        _exactElementDimension: function (element) {
            var rect = element.get(0).getBoundingClientRect(), direction = ["left", "right", "top", "bottom"], width, height;
            rect.width ? width = rect.width : width = rect.right - rect.left;
            rect.height ? height = rect.height : height = rect.bottom - rect.top;
            for (var i = 0; i < direction.length; i++) {
                this["border_" + direction[i]] = isNaN(parseFloat(element.css("border-" + direction[i] + "-width"))) ? 0 : parseFloat(element.css("border-" + direction[i] + "-width"));
                this["padding_" + direction[i]] = isNaN(parseFloat(element.css("padding-" + direction[i]))) ? 0 : parseFloat(element.css("padding-" + direction[i]));
            }
            return rect = { width: width, height: height };
        },
        _keyPressed: function (action, target) {
            if (!this.model.enabled) return;
            if (["input", "select", "textarea"].indexOf(target.tagName.toLowerCase()) !== -1)
                return true;

            var d, iChar;

            if (["up", "down", "pageUp", "pageDown"].indexOf(action) !== -1) {
                if (this._vScrollbar) {
                    if (ej.browserInfo().name == "msie" && this.model.allowVirtualScrolling)
                        this._content.focus();
                    d = this._vScrollbar._scrollData;
                }
                iChar = "o";
            } else if (["left", "right", "pageLeft", "pageRight"].indexOf(action) !== -1) {
                if (this._hScrollbar)
                    d = this._hScrollbar._scrollData;
                iChar = "i";
            } else return true;
            if (!d) return true;

            return !this._changeTop(d, (action.indexOf(iChar) < 0 ? -1 : 1) * (action[0] !== "p" ? 1 : 3) * d.scrollOneStepBy, "key");
        },

        scrollY: function (pixel, disableAnimation, animationSpeed, source, e) {
            var proxy = this;
            if (pixel === "") return;
            if (disableAnimation) {
                var e = { source: source || "custom", scrollData: this._vScrollbar ? this._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e };
                pixel = e.scrollTop;
                this.scrollTop(pixel);
                if (this._trigger("scroll", e)) return;
                this.content().scrollTop(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this._vScrollbar) pixel = parseFloat(pixel) > this._vScrollbar._scrollData.scrollable ? this._vScrollbar._scrollData.scrollable : parseFloat(pixel)
            this.scrollTop(pixel);
            this.content().stop().animate({
                scrollTop: pixel
            }, animationSpeed, 'linear', function () {
                if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._vScrollbar ? proxy._vScrollbar._scrollData : null, scrollTop: pixel, originalEvent: e })) return;
            })
        },

        scrollX: function (pixel, disableAnimation, animationSpeed, source, e) {
            var proxy = this;
            if (pixel === "") return;
            if (this._hScrollbar) pixel = parseFloat(pixel) > this._hScrollbar._scrollData.scrollable ? this._hScrollbar._scrollData.scrollable : parseFloat(pixel)
            this._externalCall = true;
            var browserName = ej.browserInfo().name;
            if (this.model.enableRTL && browserName != "mozilla") {
                if (pixel < 0) pixel = Math.abs(pixel);
                var content = this.model.targetPane != null ? this.content().find(this.model.targetPane)[0] : this.content()[0];
                if (e != "mousemove" && e != "touchmove" && (browserName != "msie")) if (browserName != "msie") pixel = this._hScrollbar._scrollData.scrollable - pixel;
            }
            this.scrollLeft(pixel);
            if (disableAnimation) {
                if (this._trigger("scroll", { source: source || "custom", scrollData: this._hScrollbar ? this._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e }))
                    return;
                if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                    this.content().find(this.model.targetPane).scrollLeft(pixel);
                else
                    this.content().scrollLeft(pixel);
                return;
            }
            if (ej.isNullOrUndefined(animationSpeed) || animationSpeed === "") animationSpeed = 100;
            if (this.model.targetPane != null && this.content().find(this.model.targetPane).length)
                this.content().find(this.model.targetPane).stop().animate({
                    scrollLeft: pixel
                }, animationSpeed, 'linear');
            else this.content().stop().animate({
                scrollLeft: pixel
            }, animationSpeed, 'linear', function () {
                if (proxy._trigger("scroll", { source: source || "custom", scrollData: proxy._hScrollbar ? proxy._hScrollbar._scrollData : null, scrollLeft: pixel, originalEvent: e })) return;
            });
        },

        enable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            if (scroller.hasClass("e-disable")) {
                scroller.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        disable: function () {
            var scroller = this.element.find(".e-vscrollbar,.e-hscrollbar,.e-vscroll,.e-hscroll,.e-vhandle,.e-hhandle,.e-vscroll .e-icon,.e-hscroll .e-icon");
            scroller.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
            if (this._vScrollbar)
                this._vScrollbar._enabled = this.model.enabled;
            if (this._hScrollbar)
                this._hScrollbar._enabled = this.model.enabled;
        },

        _changeTop: function (d, step, source, e) {
            var start = Math.ceil(this.model.targetPane != null && d.dimension != "height" ? this.content().find(this.model.targetPane)[d.scrollVal]() : this.content()[d.scrollVal]()), t;

            if (d.dimension == "height" && start == 0)
                start = this.scrollTop() != 0 ? this.scrollTop() : 0;
            t = start + step;
            if (!d.enableRTL ? t > d.scrollable : t < d.scrollable) t = Math.round(d.scrollable);
            if (!d.enableRTL ? t < 0 : t > 0) t = 0;

            if (t !== start) {
                this["scroll" + d.xy](t, true, "", source, e);
                if (d.xy === "X" && !ej.isNullOrUndefined(this._hScrollbar))
                    this._hScrollbar["scroll"](t, source, true, e);
                else if (!ej.isNullOrUndefined(this._vScrollbar))
                    this._vScrollbar["scroll"](t, source, true, e);
            }

            return t !== start;
        },

        _mouseWheel: function (e) {
            if (this._vScrollbar && e.ctrlKey)
                return;
            if (!this._vScrollbar && !e.shiftKey)
                return;
            if (!e.data || !this.model.enabled) return;
            var delta = 0, data = e.data.d, ori = e, direction;
            e = e.originalEvent;
            this._wheelStart && this._trigger("wheelStart", { originalEvent: e, scrollData: ori.data.d });
            this._wheelStart = false;
            clearTimeout($.data(this, 'timer'));
            if (this._wheelx != 1 && (e.wheelDeltaX == 0 || e.wheelDeltaY == 0))
                this._wheelx = 1;
            if (navigator.platform.indexOf("Mac") == 0 && (this._wheelx == 0)) {
                if (this._browser == "webkit" || this._browser == "chrome")
                    return true;
            }
            if (this._browser == "mozilla")
                e.axis == e.HORIZONTAL_AXIS ? data = this._scrollXdata : this._scrollYdata;
            else if (this._browser == "msie") {
                if ((e.type == "wheel")) delta = e.deltaX / 120;
                if ((e.type == "mousewheel" && e.shiftKey)) {
                    data = this._scrollXdata;
                    e.preventDefault ? e.preventDefault() : (e.returnValue = false);
                }
            }
            else if (this._wheelx && e.wheelDeltaX != 0 && e.wheelDeltaY == 0 && this._scrollXdata)
                data = this._scrollXdata;
            if (e.wheelDeltaX == 0) this._wheelx = e.wheelDeltaX;
            if (e.wheelDelta) {
                delta = navigator.platform.indexOf("Mac") == 0 ? -e.wheelDelta / 3 : -e.wheelDelta / 120;
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) delta = e.detail / 3;
            if (!delta) return;
            if ((ori.originalEvent))
                if (ori.originalEvent.wheelDelta && ori.originalEvent.wheelDelta > 0 || ori.originalEvent.detail && ori.originalEvent.detail < 0) direction = -1;
                else direction = 1;
            if (this._changeTop(data, delta * data.scrollOneStepBy, "wheel", e)) {
                e.preventDefault ? e.preventDefault() : ori.preventDefault();
                ori.stopImmediatePropagation();
                ori.stopPropagation();
                this._trigger("wheelMove", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }
            else {
                this._trigger("scrollEnd", { originalEvent: e, scrollData: ori });
                this._wheelx = 0;
            }
            var proxy = this;
            $.data(this, 'timer', setTimeout(function () {
                proxy._wheelStart = true;
                proxy._trigger("wheelStop", { originalEvent: e, scrollData: ori.data.d, direction: direction });
            }, 250));
        },
        _contentHeightWidth: function () {
            if (this.content().siblings().css("display") == "block" && this.model.autoHide) {
                this._hScroll && this.content()[this._contentHeight](this._ElementHeight - (this.model.scrollerSize));
                this._vScroll && this.content()[this._contentWidth](this._ElementWidth - (this.model.scrollerSize));
            }
            else if (this.content().siblings().css("display") == "none" && this.model.autoHide && (this._vScroll || this._hScroll)) {
                this.content()[this._contentHeight](this._ElementHeight);
                this.content()[this._contentWidth](this._ElementWidth);
            }
        },
        _scrollerHover: function (e) {
            if (this.model.enabled) {
                if ((e.type == "mouseenter" || e.type == "touchstart") && !this.content().siblings().is(":visible")) {
                    this.content().siblings().css("display", "block");
                    this._contentHeightWidth();
                    this._ensureScrollers();
                    this._setScrollLeftValue(this.model.scrollLeft);
                    this._trigger("scrollVisible", { originalEvent: e });
                }
                else if (e.type == "mouseleave" || e.type == "touchend") {
                    this.content().siblings().hide();
                    this._contentHeightWidth();
                    this._trigger("scrollHide", { originalEvent: e });
                }
            }
        },

        _mouseUp: function (e) {
            if (!e.data) return;
            var d = e.data.d;
            if (e.type === "mouseup" || e.type === "touchend" || (!e.toElement && !e.relatedTarget)) {
                this.content().css("cursor", "default");
                this._off($(document), "mousemove touchmove");
                this._off($(document), "mouseup touchend", this._mouseUp);
                d.fromScroller = false;
                if (this._mouseMoved === true && e.data.source === "thumb" && !ej.isNullOrUndefined(this.model)) {
                    $.when(this.content()).done(ej.proxy(function () {
                        this._trigger("thumbEnd", { originalEvent: e, scrollData: d });
                    }, this));
                    this._off($(window), "blur");
                }
            }
            d.up = true;
            window.ontouchmove = null;
        },

        _mouseDownOnContent: function (down) {
            this._startX = (down.clientX != undefined) ? down.clientX : down.originalEvent.changedTouches[0].clientX;
            this._startY = (down.clientY != undefined) ? down.clientY : down.originalEvent.changedTouches[0].clientY;
            this._timeStart = down.timeStamp || Date.now();
            if (!this.model.enabled) return;
            var d = down.data.d;
            this._evtData = down.data;
            var scrollObj = d.handler === "e-vhandle" ? this.element.find('.' + d.handler).closest('.e-scrollbar') : this.element.find('.' + d.handler).closest('.e-scrollbar');
            this._bindBlurEvent(scrollObj, down);
            if (this._trigger("thumbStart", { originalEvent: down, scrollData: d }))
                return;
            if (down.which == 3 && down.button == 2) return;
            d.fromScroller = true;
            var prevY = null, skip = 1, min = 5, direction;
            this._document = $(document); this._window = $(window);
            this._mouseMove = function (move) {
                if (this._startX + this._startY != move.clientX + move.clientY) {
                    this._relDisX = ((move.clientX != undefined) ? this._startx = move.clientX : this._startx = move.originalEvent.changedTouches[0].clientX) - this._startX;
                    this._relDisY = ((move.clientY != undefined) ? this._starty = move.clientY : this._starty = move.originalEvent.changedTouches[0].clientY) - this._startY;
                    this._duration = (move.timeStamp || Date.now()) - this._timeStart;
                    this._velocityY = Math.abs(this._relDisY) / this._duration;
                    this._velocityX = Math.abs(this._relDisX) / this._duration;
                    if (!ej.isNullOrUndefined(move.target.tagName) && move.target.tagName.toLowerCase() === "iframe") {
                        move.type = "mouseup";
                        this._mouseUp(move);
                        return;
                    }
                    var pageXY = move.type == "mousemove" ? move[d.clientXy] : move.originalEvent.changedTouches[0][d.clientXy];
                    if (prevY && pageXY !== prevY) {
                        this._mouseMoved = true;
                        var diff = pageXY - prevY, sTop = this.model[d.scrollVal] - (diff);

                        if (skip == 1 && Math.abs(diff) > min) {
                            direction = d.position;
                            skip = 0;
                        }
                        if (skip == 0) prevY = pageXY;

                        if (sTop >= 0 && sTop <= d.scrollable && direction === d.position) {
                            var top = this._velocityY > 0.5 && this._duration < 50 && d.position == "Top";
                            var left = this._velocityX > 0.5 && this._duration < 50 && d.position == "Left";
                            var swipeXY = ((this._velocityY > 0.5) || (this._velocityX > 0.5)) && this._duration < 50;
                            if (swipeXY) {
                                if (top) {
                                    sTop = Math.abs(this._relDisY) + (this._duration * this._velocityY);
                                    if (this._startY > this._starty) {
                                        sTop += this.scrollTop();
                                        if (sTop > d.scrollable) sTop = d.scrollable;
                                    }
                                    else {
                                        if (sTop < this.scrollTop()) sTop = Math.abs(sTop - this.scrollTop());
                                        if (sTop > this.scrollTop())
                                            sTop = 0;
                                    }
                                    if (this.scrollTop() <= d.scrollable) this["scrollY"](sTop, false, this.model.animationSpeed, "thumb");
                                }
                                else if (left) {
                                    sTop = Math.abs(this._relDisX);
                                    if (this._startX > this._startx) {
                                        sTop += this.scrollLeft();
                                        if (sTop > d.scrollable) sTop = d.scrollable;
                                    }
                                    else {
                                        sTop -= this.scrollLeft();
                                        sTop = Math.abs(sTop);
                                        if (sTop > d.scrollable || sTop >= this.scrollLeft()) sTop = 0;
                                    }
                                    if (this.scrollLeft() <= d.scrollable) this["scrollX"](sTop, false, this.model.animationSpeed, "thumb");
                                }
                            }
                            else {
                                this["scroll" + d.xy](sTop, true, "", "thumb", move.type);
                                if (d.xy === "X")
                                    this._hScrollbar["scroll"](sTop, "thumb", true, move.type);
                                else if (!ej.isNullOrUndefined(this._vScrollbar))
                                    this._vScrollbar["scroll"](sTop, "thumb", true, move.type);
                                this.content().css("cursor", "pointer");
                                this._trigger("thumbMove", { originalEvent: move, scrollData: d });
                            }
                        }
                    }
                    window.ontouchmove = function (e) {
                        e = e || window.event;
                        if (e.preventDefault) e.preventDefault();

                        e.returnValue = false;
                    }
                    if (prevY == null) prevY = pageXY;
                    if (Math.abs(this._relDisX) > Math.abs(this._relDisY))
                        this._swipe = (this._relDisX < 0) ? "left" : "right";
                    else
                        this._swipe = (this._relDisY < 0) ? "up" : "down";
                    if (((Math.round(this._content["scrollTop"]()) == 0) && this._swipe == "down" || ((Math.ceil(this._content["scrollTop"]()) == d.scrollable || Math.ceil(this._content["scrollTop"]()) + 1 == d.scrollable) && this._swipe == "up"))) {
                        this._trigger("scrollEnd", { originalEvent: move.originalEvent, scrollData: move });
                        window.ontouchmove = null;
                    }
                }
            }
            this._on($(document), "mousemove touchmove", { d: d, source: "thumb" }, this._mouseMove);
            this._mouseMoved = false;
            this._on($(document), "mouseup touchend", { d: d, source: "thumb" }, this._mouseUp);
        },

        _scroll: function (e) {
            var dS = [this._vScrollbar ? this._vScrollbar._scrollData : null, this._hScrollbar ? this._hScrollbar._scrollData : null];

            for (var i = 0; i < 2; i++) {
                var d = dS[i];
                if (!d || d.skipChange) continue;
                if (!this._externalCall) d.dimension === "height" ? this.scrollTop(e.target[d.scrollVal]) : this.scrollLeft(e.target[d.scrollVal])
                if (this.model && this.model.targetPane != null && i == 1 && this.content().find(this.model.targetPane).length)
                    d.sTop = this.content().find(this.model.targetPane)[0][d.scrollVal];
                else d.scrollVal == "scrollTop" ? d.sTop = this.scrollTop() : d.sTop = this.scrollLeft();
                this[d.scrollVal](d.sTop);
                if (d.fromScroller) return;
                if (i === 1) {
                    var content = this.content()[0];
                    if (this._rtlScrollLeftValue && content.scrollWidth - content.clientWidth != this._rtlScrollLeftValue)
                        this._rtlScrollLeftValue = content.scrollWidth - content.clientWidth;
                    d.sTop = (this.model && ej.browserInfo().name != "mozilla" && this.model.enableRTL && !this._hScrollbar._scrollData._scrollleftflag) ? (this._rtlScrollLeftValue == 0 ? (d.sTop * -1) : (d.sTop - this._rtlScrollLeftValue)) : d.sTop;
                    this._hScrollbar["scroll"](d.sTop, "", true);
                } else
                    this._vScrollbar["scroll"](d.sTop, "", true);
                if (dS.length == 2 && i == 1 || dS.length == 1 && i == 0){
                    this._externalScroller = false;
                    this.model && this._trigger('scroll', { source: "custom", scrollData: this._hScrollbar ? this._hScrollbar._scrollData : null, scrollLeft: this.scrollLeft(), originalEvent: e });
                }
            }
        },

        _changevHandlerPosition: function (top) {
            var scrollbar = this._vScrollbar;
            if (scrollbar) {
                top = scrollbar._scrollData != null && top >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : top;
                if (scrollbar != null && top >= 0 && top <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (top / scrollbar._scrollData.onePx) + "px");
            }
        },

        _changehHandlerPosition: function (left) {
            var scrollbar = this._hScrollbar;
            if (scrollbar) {
                left = scrollbar._scrollData != null && left >= scrollbar._scrollData.scrollable ? scrollbar._scrollData.scrollable : left;
                if (scrollbar != null && top >= 0 && left <= scrollbar._scrollData.scrollable)
                    scrollbar[scrollbar._scrollData.handler].css(scrollbar._scrollData.lPosition, (left / scrollbar._scrollData.onePx) + "px");
            }
        },

        _destroy: function () {
            this.element.css({ "width": "", "height": "" }).find(".e-vscrollbar,.e-hscrollbar").remove();
            this.content().removeClass("e-content").css({ "width": "", "height": "" });
            this.element.removeClass("e-widget");
        },
        _preventDefault: function (e) {
            e = e || window.event;
            if (e.preventDefault) e.preventDefault();

            e.returnValue = false;
        }
    });
})(jQuery, Syncfusion, window);;
(function ($, ej, undefined) {
    ej.gridFeatures = ej.gridFeatures || {};
    ej.gridFeatures.gridResize = function (instance) {
        this.$headerTable = instance.getHeaderTable();
        this.gridInstance = instance;
        this._colMinWidth = 15;
        this._$visualElement = $();
        this._currentCell = -1;
        this._allowStart = false;
        this._oldWidth = null;
        this._orgX = null;
        this._orgY = null;
        this._extra = null;
        this._expand = false;
        this._target = null;
        this._cellIndex = -1;
    }

    ej.gridFeatures.gridResize.prototype = {
        _mouseHover: function (e) {
            if (this._$visualElement.is(":visible"))
                return;
            this._allowStart = false;
            if ($(e.target).is(".e-headercelldiv"))
                e.target = e.target.parentNode;
            var $target = $(e.target);
			if ($(e.target).hasClass("e-filtericon") && ($(e.target).css("cursor") == "col-resize" || $(e.target).closest("tr").css("cursor") == "col-resize")) {
                $(e.target).css("cursor", "pointer");
                $(e.target).closest("tr").css("cursor", "pointer");
            }
            if ($target.hasClass("e-headercell")) {
                var _resizableCell = e.target;
                var location = _resizableCell.getBoundingClientRect(), _x = 0, _y = 0;
                if (e.type = "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }
                else if (e.type = "touchmove") {
                    _x = evt.originalEvent.changedTouches[0].clientX;
                    _y = evt.originalEvent.changedTouches[0].clientY;
                }
                else if (e.type = "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                    var _nlx = this.gridInstance.getHeaderContent().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                else
                    var _nlx = this.gridInstance.getHeaderTable().width() + this.gridInstance.element.children(".e-gridheader").find(".e-columnheader").offset().left;
                if (((_x >= (location.left + document.documentElement.scrollLeft + _resizableCell.offsetWidth - 5)) || ((_x <= (location.left + 3)))) && (_x < _nlx) && (_x >= location.left) && (_y <= location.top + document.documentElement.scrollTop + e.target.offsetHeight)) {
                    if (_x > location.left + 3)
                        var tempTarget = $(e.target).find(".e-headercelldiv");
                    else
                        var tempTarget = $(e.target).prevAll("th:visible:first").find(".e-headercelldiv");
                    var windowScrollX = window.pageXOffset || document.documentElement.scrollTop || document.body.scrollTop;
                    var _lx = (this.gridInstance.element.find(".e-headercell").not('.e-detailheadercell').offset().left + 10) - windowScrollX;
                    if ((this.gridInstance.model.enableRTL && (_x <= _lx)) || (!this.gridInstance.model.enableRTL && (_x >= _lx))) {
                        if ((this.gridInstance.model.showStackedHeader || tempTarget.length) && $.inArray($(tempTarget).attr("data-ej-mappingname"), this.gridInstance._disabledResizingColumns) == -1) {
                            this.gridInstance.model.showStackedHeader && $($target.parents('thead')).find('tr').css("cursor", "col-resize");
                            !this.gridInstance.model.showStackedHeader && $target.parent().css("cursor", "col-resize");
                            if ($(e.target).hasClass('e-stackedHeaderCell'))
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").index(_resizableCell);
                            else
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").not(".e-stackedHeaderCell,.e-detailheadercell").index(_resizableCell);
                            if (this.gridInstance.model.enableRTL)
                                this._currentCell = this._currentCell - 1;
                            this._allowStart = true;
                        }
                        else {
                            $target.parent().css("cursor", "pointer");
                            this._currentCell = -1;
                        }
                    }
                }
                else {
                    this.gridInstance.element.find(".e-columnheader").css("cursor", "pointer");
                    this._currentCell = -1;
                }
            }
        },
        _start: function (_x, _y) {
            var _myrow = this.gridInstance.getHeaderTable().find(".e-columnheader"), _top;
            var _cells, _mycel;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                _cells = _myrow.find(".e-headercell").not(".e-hide");
            else
                _cells = _myrow.find(".e-headercell").not(".e-stackedHeaderCell,.e-hide");
            if (this._currentCell != -1 && this._currentCell < _cells.length)
                _mycel = _cells[this._currentCell];
            if (typeof (_mycel) == 'undefined')
                return;
            var _j = _mycel.getBoundingClientRect();
            _top = this._tableY = _j.top + parseInt(navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollTop : document.documentElement.scrollTop);
            if (this._allowStart) {
                var vElement = this._$visualElement = $(document.createElement('div')),
                _height = this.gridInstance.element.find(".e-gridcontent").first().height() + this.gridInstance.element.find(".e-gridheader").height();
                if (this.gridInstance.model.showStackedHeader && this.gridInstance.model.stackedHeaderRows.length > 0) {
                    var headerRow = this.gridInstance.getHeaderTable().find('tr.e-columnheader')
                    var lenght = headerRow.length;
                    var currentIndex = $(this._target).parent('tr')[0].rowIndex;
                    for (var i = 0; i < currentIndex; i++) {
                        _height = _height - $(headerRow[i]).height();
                    }
                    // _height = _height - $(".e-stackedHeaderRow").height();
                }
                vElement.addClass("e-reSizeColbg").appendTo(this.gridInstance.element).attr("unselectable", "on").css("visibility", "hidden");
                this.gridInstance._resizeTimeOut = setTimeout(function() {
                    vElement.css({ visibility: "visible", height: _height + 'px', cursor: 'col-resize', left: _x, top: _top, position: 'fixed' });
                }, 100);
                this._oldWidth = _mycel.offsetWidth;
                this._orgX = _x;
                this._orgY = _y;
                this._extra = _x - this._orgX;
                this._expand = true;
            }
            else {
                this._currentCell = -1;
            }
        },
        _mouseMove: function (e) {
            if (this._expand) {
                var _x = 0, _y = 0;
                if (e.type == "mousemove") {
                    _x = e.clientX;
                    _y = e.clientY;
                }                
                else if (e.type == "MSPointerMove") {
                    _x = e.originalEvent.clientX;
                    _y = e.originalEvent.clientY;
                }
                else if (e.type == "touchmove") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                if ((_x == 0 && _y == 0) && navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                _x += document.documentElement.scrollLeft;
                e.preventDefault();
                this._moveVisual(_x);
            }
            else
                this._mouseHover(e);
        },
        _touchStart: function (e) {
            if (this._$visualElement.is(":visible"))
                return;
            this._allowStart = false;
            if ($(e.target).is(".e-headercelldiv"))
                e.target = e.target.parentNode;
            var $target = $(e.target);            
            if ($target.hasClass("e-headercell")) {
                var _resizableCell = e.target;
                var location = _resizableCell.getBoundingClientRect(), _x = 0, _y = 0;
                if (e.type == "touchstart") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                var gridInstChildren = this.gridInstance.element.children(".e-gridheader");
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                    var _nlx = this.gridInstance.getHeaderContent().width() + gridInstChildren.find(".e-columnheader").offset().left;
                else
                    var _nlx = this.gridInstance.getHeaderTable().width() + gridInstChildren.find(".e-columnheader").offset().left;
                if (((_x >= (location.left + document.documentElement.scrollLeft + _resizableCell.offsetWidth - 10)) || ((_x <= (location.left + 8)))) && (_x < _nlx) && (_x >= location.left) && (_y <= location.top + document.documentElement.scrollTop + e.target.offsetHeight)) {
                    if (_x > location.left + 8)
                        var tempTarget = $(e.target).find(".e-headercelldiv");
                    else
                        var tempTarget = $(e.target).prevAll("th:visible:first").find(".e-headercelldiv");
                    var windowScrollX = window.pageXOffset || document.documentElement.scrollTop || document.body.scrollTop;
                    var _lx = (this.gridInstance.element.find(".e-headercell").not('.e-detailheadercell').offset().left + 10) - windowScrollX;
                    if ((this.gridInstance.model.enableRTL && (_x <= _lx)) || (!this.gridInstance.model.enableRTL && (_x >= _lx))) {
                        if ((this.gridInstance.model.showStackedHeader || tempTarget.length) && $.inArray($(tempTarget).attr("data-ej-mappingname"), this.gridInstance._disabledResizingColumns) == -1) {                            
                            if ($(e.target).hasClass('e-stackedHeaderCell'))
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").index(_resizableCell);
                            else
                                this._currentCell = this.gridInstance.getHeaderContent().find(".e-headercell:visible").not(".e-stackedHeaderCell,.e-detailheadercell").index(_resizableCell);
                            if (this.gridInstance.model.enableRTL)
                                this._currentCell = this._currentCell - 1;
                            this._allowStart = true;
                        }
                        else {                            
                            this._currentCell = -1;
                        }
                    }
                }
                else {                    
                    this._currentCell = -1;
                }
            }
            if (this._allowStart) {
                this._target = $target;
                if (this.gridInstance.pluginName == "ejGrid" && this.gridInstance.model.allowResizing) {                    
                    if (this._triggerResizeEvents("resizeStart", _x))
                        return;
                } else if (this.gridInstance.pluginName == "ejTreeGrid" && this.gridInstance.model.allowColumnResize) {
                    if (this.gridInstance._triggerColumnResize("columnResizeStart", _x, e))
                        return;
                }
                var gridobj = this;
                _x += document.documentElement.scrollLeft;
                if (e.button != 2)
                    this._start(_x, _y);
                return false;
            }
            return true;
        },
        _getCellIndex: function (e) {
            var $target = $(e._target);
            var targetCell = e._target;
            var location = targetCell.getBoundingClientRect();
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            if (this._orgX < location.left + 5 + scrollLeft)
                targetCell = $(targetCell).prevAll(":visible:first")[0];
            var hCellIndex = targetCell.cellIndex;
            var cellIndex = hCellIndex;
            if (e.gridInstance.model.groupSettings.groupedColumns.length) {
                cellIndex = hCellIndex - e.gridInstance.model.groupSettings.groupedColumns.length;
            }
            return cellIndex;
        },
        _reSize: function (_x, _y) {
            // Function used for Resizing the column
            var proxy = this;
            var resized = false, $content;
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns)
                this._initialTableWidth = this.gridInstance.getHeaderTable().first().parent().width() + this.gridInstance.getHeaderTable().last().parent().width();
            else
                this._initialTableWidth = this.gridInstance.getHeaderTable().parent().width();
            if (this.gridInstance.model.enableRTL && (this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid))
                this._currentCell = this._currentCell - 1;
            else
                !this.gridInstance.model.enableRTL && this._getResizableCell();
            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0)
                var _rowobj = this.gridInstance.getHeaderTable().find('thead');
            else
                var _rowobj = $(this._target).parents('thead');
            if (this._currentCell != -1 && this._expand) {
                this._expand = false;
                var _childTH = $(this._target).hasClass('e-stackedHeaderCell') ? _rowobj.find(".e-headercell:not(.e-detailheadercell)").filter(":visible") : _rowobj.find(".e-headercell:not(.e-detailheadercell,.e-stackedHeaderCell)").filter(":visible");
                var _outerCell = _childTH[this._currentCell];
                var _oldWidth = _outerCell.offsetWidth;
                var _extra = _x - this._orgX;
                if (this.gridInstance.model.enableRTL)
                    _extra = -_extra;
                //Check whether the column minimum width reached
                if (parseInt(_extra) + parseInt(_oldWidth) > this._colMinWidth) {
                    if (_extra != 0)
                        _rowobj.css("cursor", 'default');
                     var $prevheaderCol, oldColWidth;
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                     var $prevheaderCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                     if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                     this.gridInstance._detailColsRefresh();
                    $prevheaderCols = this.gridInstance._$headerCols;
                   }
                    var $prevheaderCol = $prevheaderCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    var oldColWidth = $prevheaderCol.width();
                   }
                    this._resizeColumnUsingDiff(_oldWidth, _extra);
                    $content = this.gridInstance.element.find(".e-gridcontent").first();
                    var scrollContent = $content.find("div").hasClass("e-content");                    
                    var browser = !ej.isIOSWebView() && this.gridInstance.getBrowserDetails();
                    if (browser && browser.browser == "msie" && this.gridInstance.model.allowScrolling) {
                        var oldWidth = this.gridInstance.getContentTable().width(), newwidth = this.gridInstance._calculateWidth();
                        if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns > 0) {
                            this.gridInstance.getHeaderTable().last().width(newwidth - this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width());
                            this.gridInstance.getContentTable().last().width(newwidth - this.gridInstance.getContent().find(".e-frozencontentdiv").width());
                            this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().last().width(newwidth - this.gridInstance.getFooterContent().find(".e-frozenfootertdiv").width());
                        }
                        else {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getHeaderTable().width(newwidth);
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.model.showSummary && this.gridInstance.getFooterTable().width(newwidth);
                            }
                        }
                        if (parseInt(browser.version, 10) > 8 && this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                            if (newwidth > oldWidth) {
                                this.gridInstance.getContentTable().width(newwidth);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", (20 / $content.find("table").first().width()) * 100 + "%");
                            }
                            else {
                                this.gridInstance.getContentTable().css("width", "100%");
                                this.gridInstance._groupingAction(true);
                                this.gridInstance.getContentTable().children("colgroup").find("col").first().css("width", ((this.gridInstance.getHeaderTable().find("colgroup").find("col").first().width() / $content.find("table").first().width()) * 100).toFixed(2) + "%");
                            }
                        }
                        this.gridInstance.getHeaderTable().parent().scrollLeft($content.find(".e-content").scrollLeft() - 1);
                    }
                    this.gridInstance._colgroupRefresh();
                    if (this.gridInstance.model.allowTextWrap)
                        this.gridInstance.rowHeightRefresh();
                    if (this.gridInstance.model.groupSettings.groupedColumns.length && !this.gridInstance.model.isEdit)
                        this.gridInstance._recalculateIndentWidth();
                    if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'normal') {
                        if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
                            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
                            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                                this.gridInstance._detailColsRefresh();
                                $headerCols = this.gridInstance._$headerCols;
                                $ContentCols = this.gridInstance._$contentCols;
                            }
                            var nextCell = this._currentCell + 1;
                            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                            var newWidth = $headerCol.width() + (oldColWidth - $prevheaderCol.width()), $ContentCol;
                            if (newWidth < this._colMinWidth)
                                newWidth = this._colMinWidth;
                            $headerCol.width(newWidth);
                            if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                                var $colGroup = $tables.find("colgroup");
                                var colCount = this.gridInstance.getVisibleColumnNames().length;
                                if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                                    $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                                for (var i = 0 ; i < $colGroup.length; i++) {
                                    var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                                    if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                                    $(cols[nextCell]).width(newWidth);
                                }
                            }
                            if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                                if (nextCell >= 0 && nextCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                                    return;
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(nextCell);
                            }
                            else
                                $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) ? nextCell : nextCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                            $ContentCol.width(newWidth);
                            this.gridInstance._findColumnsWidth();
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(_outerCell).is(":last-child") && this.gridInstance.pluginName == "ejGrid") {
                                var val = $prevheaderCol.width() - oldColWidth;
                                var frozenWidth = this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width() + val;
                                var movableWidth = this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width() - val;
                                var marginLeft = parseInt(this.gridInstance.getHeaderContent().find('.e-movableheader')[0].style["margin-left"]) + val;
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(frozenWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(frozenWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-frozenfooterdiv').width(frozenWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width(movableWidth);
                                this.gridInstance.getContent().find('.e-movablecontentdiv').width(movableWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-movablefooterdiv').width(movableWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheader').css("margin-left", marginLeft);
                                this.gridInstance.getContent().find('.e-movablecontent').css("margin-left", marginLeft);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-movablefooter').css("margin-left", marginLeft);
                            }
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(_outerCell).is(":last-child") && this.gridInstance.pluginName == "ejTreeGrid") {
                                var val = $prevheaderCol.width() - oldColWidth;
                                var frozenWidth = this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width() + val;
                                var movableWidth = this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width() - val;
                                var marginLeft = parseInt(this.gridInstance.getHeaderContent().find('.e-movableheader')[0].style["margin-left"]) + val;
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(frozenWidth);
                                this.gridInstance.getHeaderContent().find('.e-movableheader').css("margin-left", marginLeft);
                                this.gridInstance.getHeaderContent().find('.e-movableheaderdiv').width(movableWidth);
                                this.gridInstance.getContent().find(".e-frozencontainer").width(frozenWidth).next().css("margin-left", marginLeft + "px");
                                this.gridInstance.getContent().find('.e-movablecontent').width(movableWidth);
                                if (this.gridInstance.model.showTotalSummary) {
                                    this.gridInstance._$totalSummaryRowContainer.find(".e-frozenfooterdiv").width(frozenWidth);
                                    this.gridInstance._$totalSummaryRowContainer.find(".e-movablefooter").css("margin-left", marginLeft + "px");
                                }
                                this.gridInstance._renderScroller(true);                             
                            }

                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 && $(this._target).parent('tr').parents('div:first').hasClass('e-frozenheaderdiv') && this.gridInstance.pluginName == "ejGrid") {
                                this.gridInstance.getHeaderContent().find('.e-frozenheaderdiv').width(this._newWidth);
                                this.gridInstance.getContent().find('.e-frozencontentdiv').width(this._newWidth);
                                if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                    this.gridInstance.getFooterContent().find('.e-frozenfooterdiv').width(this._newWidth);
                            }
                        }
                        else if (!this.gridInstance.model.scrollSettings.frozenColumns) {
                            var oldTableWidth = this.gridInstance.getHeaderTable().width();
                            this.gridInstance.getHeaderTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.getContentTable().css("width", oldTableWidth + parseInt(_extra));
                            if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterTable()))
                                this.gridInstance.getFooterTable().css("width", oldTableWidth + parseInt(_extra));
                            this.gridInstance.model.scrollSettings.width += parseInt(_extra);
                            if (this.gridInstance.getContent().width() > this.gridInstance.getContentTable().width()) {
                                this.gridInstance.getContentTable().addClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().addClass('e-tableLastCell');
                            }
                            else {
                                this.gridInstance.getContentTable().removeClass('e-tableLastCell');
                                this.gridInstance.getHeaderTable().removeClass('e-tableLastCell');
                            }
                        }
                    }
                    if (!(browser.browser == "msie") && browser && this.gridInstance.model.allowScrolling && this.gridInstance.model.scrollSettings.frozenColumns == 0) {
                        this.gridInstance.getHeaderTable().width("100%");
                        this.gridInstance.getContentTable().width("100%");
                        if(this.gridInstance.model.showSummary)
                            this.gridInstance.getFooterTable().width("100%");
                        var tableWidth = this.gridInstance._calculateWidth();
                        if (tableWidth <= this.gridInstance.getContentTable().width() || this.gridInstance.getHeaderTable().width() > this.gridInstance.getContentTable().width()) {
                            this.gridInstance.getHeaderTable().width(tableWidth);
                            this.gridInstance.getContentTable().width(tableWidth);
                            if(this.gridInstance.model.showSummary)
                                this.gridInstance.getFooterTable().width(tableWidth);
                        }
                    }
                    if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'default') {
                        var cellIndex = this._currentCell;
                        var target = $(this._target), columnIndex = [], col = [];
                        var newWidth = _oldWidth + _extra;
                        var args = {};
                        if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                            var rowindex = target.parent(".e-stackedHeaderRow").index(),
                            stackedHeaderText = target.text(),
                            stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                            for(i=0;i<stackedHeaderCol.length;i++){
                                if(stackedHeaderCol[i].headerText == stackedHeaderText)
                                    stackedHeaderColumns = stackedHeaderCol[i].column;
                            }
                            var columns = stackedHeaderColumns;
                            if (!(stackedHeaderColumns instanceof Array))
                                columns = stackedHeaderColumns.split(",");
                            for (var i = 0 ; i < columns.length; i++) {
                                var index = this.gridInstance.getColumnIndexByField(columns[i]);
                                columnIndex.push(index)
                                col.push(this.gridInstance.model.columns[index]);
                            }
                            args = { columnIndex: columnIndex, column: col, oldWidth: _oldWidth, newWidth: newWidth };
                        }
                        else
                        args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], oldWidth: _oldWidth, newWidth: newWidth };
                        this.gridInstance._trigger("resized", args);
                    }
                    if (this.gridInstance.model.allowScrolling) {
                        this.gridInstance.getScrollObject().refresh(this.gridInstance.model.scrollSettings.frozenColumns > 0);
                        if (this.gridInstance.model.isResponsive && this.gridInstance.model.minWidth)
                            this.gridInstance.windowonresize();
                        if (!scrollContent && $content.find("div").hasClass("e-content"))
                            this.gridInstance.refreshScrollerEvent();
                        this.gridInstance._isHscrollcss();
                    }
                }

            }

            this._target = null;
            this._$visualElement.remove();
            this._expand = false;
            this._currentCell = -1;
            this._allowStart = false;

        },
        _getFrozenResizeWidth: function () {
            var $frozenColumnsCol = this.gridInstance.getHeaderTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0), width = 0;
            for (var i = 0; i < $frozenColumnsCol.length; i++) {
                if ($frozenColumnsCol.eq(i).css("display") != "none")
                    width += parseInt($frozenColumnsCol[i].style.width.replace("px", ""));
            }
            return width;
        },
        _diaplayFinder: function () {
            return $(this).css('display') != 'none';
        },
        _resizeColumnUsingDiff: function (_oldWidth, _extra) {
            var proxy = this, _extraVal;			
            this._currntCe = this._currentCell;
            var $headerCols = this.gridInstance.getHeaderTable().find('colgroup').find("col");
            var $ContentCols = this.gridInstance.getContentTable().find('colgroup').find("col");
            if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)) {
                this.gridInstance._detailColsRefresh();
                $headerCols = this.gridInstance._$headerCols;
                $ContentCols = this.gridInstance._$contentCols;
            }
            var $headerCol = $headerCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length)
                    , $ContentCol, $footerCol, $frozenCols = $headerCols.slice(0, this.gridInstance.model.scrollSettings ? this.gridInstance.model.scrollSettings.frozenColumns : 0);
            var colWidth = $headerCol[0].style.width, isPercent = colWidth.indexOf("%") != -1;
            var _inlineWidth = (!colWidth || isPercent)? $(this._target).outerWidth() : colWidth;
            var indent = !isPercent ? _oldWidth / parseInt(_inlineWidth) : 1;
            _extraVal = _extra = _extra / indent
            var _newWidth = this._newWidth = parseInt(_extra) + parseInt(_inlineWidth);
            if (this.gridInstance.pluginName == "ejTreeGrid" && _extra > 0 && !ej.isNullOrUndefined(this.gridInstance._currentCell) && this.gridInstance.model.columns[this.gridInstance._currentCell].isFrozen == true) {
                var width = this.gridInstance._frozenWidth();
                //if resizing exceeds the grid width
                if (width > this.gridInstance._gridWidth - 18 - 50) {//container width-scrollerwidth- minimum width of unfrozen column
                    return
                }
            }
            if (_newWidth > 0 && _extra != 0) {
                if (_newWidth < this._colMinWidth)
                    _newWidth = this._colMinWidth;
                if (ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) == 'nextcolumn') {
                    var nextCol = $headerCol.next();
                    var isFrozenLastCell = this.gridInstance.model.scrollSettings.frozenColumns && this._currentCell == this.gridInstance.model.scrollSettings.frozenColumns - 1 ? true : false;
                    if (isFrozenLastCell)
                        nextCol = $headerCols.eq(this.gridInstance.model.scrollSettings.frozenColumns);
                    if ((isFrozenLastCell || !$headerCol.is(":last-child")) && (nextCol.width() + ($headerCol.width() - _newWidth) <= this._colMinWidth))
                        _newWidth = $headerCol.width() + (nextCol.width() - this._colMinWidth);
                }
                var _extra = _newWidth - _oldWidth;
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns) {
                    if (this._currentCell >= 0 && this._currentCell < this.gridInstance.model.scrollSettings.frozenColumns && this._getFrozenResizeWidth() + _extra > this.gridInstance.element.find(".e-headercontent").first().width())
                        return;
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(this._currentCell);
                }
                else
                    $ContentCol = $ContentCols.filter(this._diaplayFinder).eq(!this.gridInstance.model.allowGrouping || !ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid) ? this._currentCell : this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length);
                if (this.gridInstance.model.showSummary) {
                    this._$footerCols = this.gridInstance.getFooterTable().find('colgroup').find("col");
                    var colCount = this.gridInstance.model.columns.length;
                    if (this._$footerCols.length > colCount) this._$footerCols.splice(0, (this._$footerCols.length - colCount));
                    var $footerCols = this._$footerCols,
                    $footerCol = $footerCols.filter(this._diaplayFinder).eq(this._currentCell);
                    $footerCol.outerWidth(_newWidth);
                }
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    this._resizeStackedHeaderColumn($(this._target).parent('tr'), _extraVal, this._currntCe);
                }
                else
                    $headerCol.outerWidth(_newWidth);
                if ($(this._target).parent('tr').hasClass('e-stackedHeaderRow')) {
                    if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        for (var i = 0; i < this._changedcell.length; i++) {
                            var cellIndex = this._changedcell[i];
                            for (var j = 0 ; j < $colGroup.length; j++) {
                                var visibleCols = $($colGroup[j]).children().filter(this._diaplayFinder);
                                var width = parseInt((_extraVal)) + parseInt(visibleCols[cellIndex].style.width);
                                if (width < this._colMinWidth)
                                    width = this._colMinWidth
                                $(visibleCols[cellIndex]).width(width);
                            }
                        }
                    }
                    var length = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder).length;
                    for (var i = 0; i < this._changedcell.length; i++) {
                        var $conCol = this.gridInstance.getContentTable().find('colgroup').find("col").filter(this._diaplayFinder)[this._changedcell[i]]
                        var width = parseInt((_extraVal)) + parseInt($conCol.style.width);
                        if (width < this._colMinWidth)
                            width = this._colMinWidth
                        $($conCol).outerWidth(width);
                        if (this.gridInstance.model.isEdit && (this.gridInstance.model.allowGrouping && this.gridInstance.model.groupSettings.groupedColumns.length == 0)) {
                            var $sEditCol = this.gridInstance.getContentTable().find(".gridform").find("colgroup col").filter(this._diaplayFinder)[this._changedcell[i]];
                            $($sEditCol).outerWidth(width);
                        }
                    }
                }
                else {
                    if (this.gridInstance.model.groupSettings && this.gridInstance.model.groupSettings.groupedColumns.length) {
                        var $tables = this.gridInstance.getContentTable().find(".e-recordtable");
                        var $colGroup = $tables.find("colgroup");
                        var cellIndex = this._currentCell;
                        var colCount = this.gridInstance.getVisibleColumnNames().length;
                        if (this.gridInstance.getContentTable().find('.e-detailrow').length)
                            $colGroup = $colGroup.not($tables.find(".e-detailrow").find("colgroup")).get();
                        for (var i = 0 ; i < $colGroup.length; i++) {
                            var cols = $($colGroup[i]).find("col").filter(this._diaplayFinder);
                            if (cols.length > colCount) cols.splice(0, (cols.length - colCount));
                            $(cols[cellIndex]).width(_newWidth);
                        }
                    }
                    $ContentCol.outerWidth(_newWidth);
                    if (this.gridInstance.model.isEdit) {
                        var $editableRow = this.gridInstance.getContentTable().find(".e-editedrow,.e-addedrow");
                        var $editCols = $editableRow.find("table").find("colgroup col");
                        var addCol;
                        if ($editableRow.hasClass("e-addedrow") && this.gridInstance.model.groupSettings.groupedColumns.length)
                            addCol = this._currentCell + this.gridInstance.model.groupSettings.groupedColumns.length - 1;
                        else
                            addCol = this._currentCell;
                        var $editCol = $editCols.filter(this._diaplayFinder).eq(addCol);
                        $editCol.outerWidth(_newWidth);
                    }
                }
                this.gridInstance._findColumnsWidth();
                if (this.gridInstance.model.scrollSettings && this.gridInstance.model.scrollSettings.frozenColumns && ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'nextcolumn' && this.gridInstance.pluginName == "ejGrid") {
                    var frozenColumns = this.gridInstance.getContentTable().find('colgroup').find("col").slice(0, this.gridInstance.model.scrollSettings.frozenColumns)
                        , width = 0, direction;
                    for (i = 0; i < frozenColumns.length; i++)
                        width += frozenColumns[i].style.display == 'none' ? 0 : parseInt(frozenColumns[i].style.width.replace("px", ""));
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width);
                    direction = this.gridInstance.model.enableRTL ? "margin-right" : "margin-left";
                    this.gridInstance.getContent().find(".e-frozencontentdiv").width(width).next().css(direction, width + "px");
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width).next().css(direction, width + "px");
                    this.gridInstance.model.showSummary && this.gridInstance.getFooterContent().find(".e-frozenfooterdiv").width(width);
                }
                if (this.gridInstance.pluginName == "ejTreeGrid" && !ej.isNullOrUndefined(this.gridInstance._currentCell) && this.gridInstance.model.columns[this.gridInstance._currentCell].isFrozen == true && ej.getObject("resizeSettings.resizeMode", this.gridInstance.model) != 'nextcolumn') {
                    var width = this.gridInstance._frozenWidth();                    
                    this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width);
                    this.gridInstance.getContent().find(".e-frozencontainer").width(width).next().css("margin-left", width + "px");
                        this.gridInstance.getHeaderContent().find(".e-frozenheaderdiv").width(width).next().css("margin-left", width + "px");
                        if (this.gridInstance.model.showTotalSummary) {
                            this.gridInstance._$totalSummaryRowContainer.find(".e-frozenfooterdiv").width(width);
                            this.gridInstance._$totalSummaryRowContainer.find(".e-movablefooter").css("margin-left", width + "px");
                        }
                        this.gridInstance._renderScroller(true);
                     }
                this.gridInstance.getHeaderTable().find(".e-columnheader").css("cursor", "default");
            }
        },
        _resizeStackedHeaderColumn: function (currentTr, extra, currentCell) {
            // var currentIndex = this._currntCe;
            this._changedcell = [];
            var headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
            var preCol = 0, limit = 0, currentTh = headerCells[currentCell], currentSpan = $(currentTh).attr('colspan'), commonExtra = extra / currentSpan, tr = $(currentTh).parent('tr');
            var nextTr = tr.next();
            var currentIndex = currentTh.cellIndex;
            if (this.gridInstance.model.groupSettings.showGroupedColumn) {
                limit = this.gridInstance.model.groupSettings.groupedColumns.length;
                preCol += limit
            }
            while (currentIndex > limit) {
                currentIndex--;
                var th = $(tr).children('th').not(".e-detailheadercell")[currentIndex];
                preCol += parseInt($(th).attr('colspan'));
            }
            this._currentCell = preCol;
            var length = preCol + parseInt(currentSpan);
            for (var i = preCol; i < length; i++) {
                var $colG = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder)[i];
                this._changedcell.push(i - limit)
                var width = parseInt(extra) + parseInt($colG.style.width);
                if (width < this._colMinWidth)
                    width = this._colMinWidth;
                $($colG).outerWidth(width);
             }
        },
        _triggerResizeEvents: function (event, _x) {
            var _rowobj = this.gridInstance.getHeaderTable().find(".e-columnheader");
            var _childTH = _rowobj.find(".e-headercell").filter(":visible");
            var cellIndex = this._cellIndex;
            var target = $(this._target), columnIndex = [], col = [];
            if (event == "resizeStart") {
                this._orgX = _x;
                cellIndex = this._cellIndex = this._getCellIndex(this, _x);
            }
            var _outerCell = _childTH[this._currentCell];
            var _oldWidth = _outerCell.offsetWidth;
            if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                var rowindex = target.parent(".e-stackedHeaderRow").index(),
                stackedHeaderText = target.text(),
                stackedHeaderCol = this.gridInstance.model.stackedHeaderRows[rowindex].stackedHeaderColumns,stackedHeaderColumns;
                for(i=0;i<stackedHeaderCol.length;i++){
                    if(stackedHeaderCol[i].headerText == stackedHeaderText)
                        stackedHeaderColumns = stackedHeaderCol[i].column;
                }
                var columns = stackedHeaderColumns;
                if (!(stackedHeaderColumns instanceof Array))
                    columns = stackedHeaderColumns.split(",");
                for (var i = 0 ; i < columns.length; i++) {
                    var index = this.gridInstance.getColumnIndexByField(columns[i]);
                    columnIndex.push(index)
                    col.push(this.gridInstance.model.columns[index]);
                }
            }
            if (event == "resizeStart") {
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: target, oldWidth: _oldWidth };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth };
                return this.gridInstance._trigger("resizeStart", args);
            }
            else {
                var _childth = _rowobj.find(".e-headercell").not(".e-detailheadercell").filter(":visible");
                var _extra = _x - this._orgX;
                var newWidth = _oldWidth + _extra;
                this.gridInstance._colgroupRefresh();
                var args = {};
                if (this.gridInstance.model.showStackedHeader && target.hasClass("e-stackedHeaderCell")) {
                    args = { columnIndex: columnIndex, column: col, target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                }
                else
                    args = { columnIndex: cellIndex, column: this.gridInstance.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth, newWidth: newWidth, extra: _extra };
                return this.gridInstance._trigger("resizeEnd", args);
            }
        },
        _mouseUp: function (e) {
            if (this.gridInstance._resizeTimeOut){
                clearTimeout(this.gridInstance._resizeTimeOut);
                this.gridInstance._resizeTimeOut = 0;
            }
            if (this._expand) {
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY;
                }
                if (e.type == "touchend") {
                    _x = e.originalEvent.changedTouches[0].clientX;
                    _y = e.originalEvent.changedTouches[0].clientY;
                }
                if (this.gridInstance.model.allowResizing && (this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize' || e.type == "touchend")) {
                    if (this._triggerResizeEvents("resizeEnd", _x)) {
                        this.gridInstance.element.find(".e-reSizeColbg").remove();
                        return;
                    }
                }
                _x += document.documentElement.scrollLeft;
                this._reSize(_x, _y);
                if (!ej.isNullOrUndefined(this._currntCe) && this._currntCe >= 0)
                    this.gridInstance.model.columns[this._currntCe].width = this.gridInstance.columnsWidthCollection[this._currntCe];
            }
        },
        _getResizableCell: function () {
            var row, frozenColumns = this.gridInstance.model.scrollSettings.frozenColumns;
            if ($(this._target).hasClass('e-stackedHeaderCell'))
                row = this.gridInstance.getHeaderTable().find(".e-columnheader");
            else
                row = this.gridInstance.getHeaderTable().find(".e-columnheader").not('.e-stackedHeaderRow');
            var cell = row.find(".e-headercell").not(".e-hide,.e-detailheadercell");
            var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
            //To identify whether it is previous cell to final frozen cell
            if (frozenColumns && this._currentCell != -1 && this._currentCell == frozenColumns - 1) {
                var cellPoint = cell[this._currentCell].getBoundingClientRect().left + scrollLeft + 5,
                    isFrozenPreviousCell = cellPoint > this._orgX ? true : false;
            }
            if (!frozenColumns || this._currentCell != frozenColumns - 1 || isFrozenPreviousCell)
                for (var i = 0; i < cell.length; i++) {
                    var point = cell[i].getBoundingClientRect();
                    var xlimit = point.left + scrollLeft + 5;
                    if (xlimit > this._orgX && $(cell[i]).height() + point.top >= this._orgY) {
                        this._currentCell = i - 1;
                        return;
                    }
                    if (i == cell.length - 1 || (this.gridInstance.model.showStackedHeader && $(this._target).get(0) === cell[i])) {
                        this._currentCell = i;
                        return;
                    }
                }
        },
        _moveVisual: function (_x) {
            /// Used to move the visual element in mouse move
            var _bounds = this.gridInstance.getHeaderContent().find("div").first()[0].getBoundingClientRect();
            if ((_bounds.left + document.documentElement.scrollLeft + _bounds.width < _x) || (_x < _bounds.left + document.documentElement.scrollLeft))
                this._$visualElement.remove();
            else if (this._currentCell != -1)
                this._$visualElement.css({ left: _x, top: this._tableY });
        },
        _mouseDown: function (e) {
            if (this._allowStart && ($(e.target).closest("tr").css("cursor") == 'col-resize')) {
                this._target = e.target;
                var _x = e.clientX, _y = e.clientY;
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = e.pageX;
                    _y = e.pageY - document.body.scrollTop;
                }
                if (this.gridInstance.model.allowResizing && this.gridInstance.getHeaderTable().find(".e-columnheader").css('cursor') == 'col-resize') {
                    if ($(e.target).is(".e-headercelldiv"))
                        e.target = e.target.parentNode;
                    this._target = e.target;
                    if (this._triggerResizeEvents("resizeStart", _x))
                        return;
                }
                var gridobj = this;
                _x += document.documentElement.scrollLeft;
                if (e.button != 2)
                    this._start(_x, _y);
                return false;
            }
            return true;
        },
        _columnResizeToFit: function (e) {
            var resize = this.gridInstance.getHeaderTable().find(".e-columnheader").filter(function (e) {
                return $(this).css("cursor") == "col-resize";
            });
            if (this.gridInstance.model.allowResizeToFit && resize.length) {
                if ($(e.target).is(".e-headercelldiv"))
                    e.target = e.target.parentNode;
                var $target = $(e.target);
                var headerCells, preCol = 0, indent = 0;
                if ($target.hasClass('e-stackedHeaderCell'))
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-detailheadercell");
                else
                    headerCells = this.gridInstance.getHeaderContent().find(".e-headercell").not(".e-stackedHeaderCell,.e-detailheadercell");
                this._target = $target;
                if ($target.hasClass("e-headercell")) {
                    var targetCell = e.target;
                    var hCellIndex = $.inArray(targetCell, headerCells);
                    var cellIndex = hCellIndex;
                    this._orgX = e.pageX;
                    if(!this.gridInstance.model.enableRTL) 
						this._getResizableCell();
					else
						this._currentCell = hCellIndex;
                    if (hCellIndex != this._currentCell) {
                        hCellIndex = cellIndex = this._currentCell;
                        targetCell = e.target.previousSibling;
                    }
                    var currentTh = headerCells.filter(":visible")[cellIndex], changesCellIndex = [], changesFinalWdith = [], changesOldWidth = [];
                    indent = this.gridInstance.model.groupSettings.groupedColumns.length;
                    if (!ej.isNullOrUndefined(this.gridInstance.model.detailsTemplate) || !ej.isNullOrUndefined(this.gridInstance.model.childGrid))
                        indent += 1;
                    if ($(targetCell).parent("tr").hasClass('e-stackedHeaderRow')) {
                        var currentSpan = $(currentTh).attr('colspan'), tr = $(currentTh).parent('tr'), tHeadIndex = currentTh.cellIndex;
                        var nextTr = tr.next();
                        while (tHeadIndex > indent) {
                            tHeadIndex--
                            var th = $(tr).children('th')[tHeadIndex];
                            preCol += parseInt($(th).attr('colspan'))
                        };
                        var length = preCol + parseInt(currentSpan);
                    }
                    else {

                        preCol = cellIndex; length = cellIndex + 1;
                    }
                    var finalWidth = 0, headerWidth = 0, contentWidth = 0, argCols = [], argExtra = [];
                    if (preCol != -1) {
                        var hiddenLen = headerCells.slice(0, preCol + 1).filter(".e-hide").length;
                        var args = { columnIndex: preCol + hiddenLen, column: this.gridInstance.model.columns[preCol + hiddenLen], target: $target, oldWidth: oldWidth };
                        this.gridInstance._trigger("resizeStart", args);
                        for (var i = preCol; i < length; i++) {
                            hiddenLen = headerCells.slice(0, i + 1).filter(".e-hide").length;
                            contentWidth = this._getContentWidth(i + hiddenLen);
                            var $cellDiv = this.gridInstance.getHeaderTable().find('.e-headercell:not(.e-hide, .e-stackedHeaderCell)').children(".e-headercelldiv").eq(i);
                            headerWidth = this._getHeaderContentWidth($cellDiv);
                            finalWidth = headerWidth > contentWidth ? headerWidth : contentWidth;
                            finalWidth += parseInt(($cellDiv.css("padding-left"), 10) + ($cellDiv.css("padding-right"), 10));
                            var oldWidth = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder).eq(i + indent).width();
                            finalWidth = oldWidth > finalWidth ? finalWidth : (this._colMinWidth < finalWidth ? finalWidth : this._colMinWidth);

                            var headerCols = this.gridInstance.getHeaderTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                headerCols.splice(0, 1);
                            headerCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.groupSettings.groupedColumns.length) {
                                var $colGroups = this.gridInstance.getContentTable().find('.e-recordtable').find('colgroup');
                                var proxy = this;
                                $.each($colGroups, function (indx, colgroup) {
                                    $(colgroup).find('col').filter(proxy._diaplayFinder).eq(i).width(finalWidth);
                                });
                            }
                            var contentCols = this.gridInstance.getContentTable().find('col').filter(this._diaplayFinder);
                            if(this.gridInstance.model.detailsTemplate || this.gridInstance.model.childGrid)
                                contentCols.splice(0, 1);
                            contentCols.eq(i + indent).width(finalWidth);
                            if (this.gridInstance.model.isEdit) {
                                var $editableCol = this.gridInstance.getContentTable().find(".e-editedrow").find("col");
                                var $form = this.gridInstance.element.find(".gridform");
                                for (var j = 0; j < $form.length; j++) {
                                   var $editableCol = $($form[j]).find("col")
                                   $editableCol.eq(i + indent).width(finalWidth);
                               }
                            }
                            argCols.push(this.gridInstance.model.columns[i + hiddenLen]);
                            argExtra.push(Math.abs(finalWidth - oldWidth))
                            changesCellIndex.push(i + hiddenLen); changesFinalWdith.push(finalWidth); changesOldWidth.push(oldWidth);
                            if (this.gridInstance.model.scrollSettings.frozenColumns > 0 || (this.gridInstance.model.groupSettings.groupedColumns.length && this.gridInstance.model.isEdit)) {
                                var colIndex = i + hiddenLen;
                                this.gridInstance.columnsWidthCollection[colIndex] = finalWidth;
                                this.gridInstance.setWidthToColumns();
                                if (this.gridInstance.model.scrollSettings.frozenColumns <= colIndex + 1) {
                                    this.gridInstance.getHeaderContent().find(".e-movableheader").css("margin-left", finalWidth);
                                    this.gridInstance.getContent().find(".e-movablecontent").css("margin-left", finalWidth);
                                    if(this.gridInstance.model.showSummary && !ej.isNullOrUndefined(this.gridInstance.getFooterContent()))
                                        this.gridInstance.getFooterContent().find(".e-movablefooter").css("margin-left", finalWidth);
                                }
                            }
                        }

                    }
                    this.gridInstance._colgroupRefresh();
                    this.gridInstance._recalculateIndentWidth();
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resizeEnd", args);
                    for (var i = 0; i < changesCellIndex.length; i++) {
                        this.gridInstance.columnsWidthCollection[changesCellIndex[i]] = changesFinalWdith[i];
                        this.gridInstance.model.columns[changesCellIndex[i]]["width"] = changesFinalWdith[i];
                    }
                    args = { columnIndex: changesCellIndex, column: argCols, target: currentTh, oldWidth: changesOldWidth, newWidth: changesFinalWdith, extra: argExtra };
                    this.gridInstance._trigger("resized", args);
                    if (this.gridInstance.model.summaryRows.length > 0)
                        this.gridInstance._summaryColRrefresh();
					this.gridInstance._findColumnsWidth();
                }				
            }
        },
        _getContentWidth: function (cellindx) {
            var contentWidth = 0;
            var $span = ej.buildTag('span', {}, {}), proxy = this.gridInstance, tdWidth;
            if (!ej.isNullOrUndefined(proxy._gridRows)) {
                var rows = proxy._gridRows;
                if (this.gridInstance.model.scrollSettings.frozenColumns && cellindx >= this.gridInstance.model.scrollSettings.frozenColumns) {
                    rows = rows[1];
                    cellindx = cellindx - this.gridInstance.model.scrollSettings.frozenColumns;
                }
                $.each(rows, function (indx, row) {
                    if ($(row).is('.e-row,.e-alt_row') && !$(row).is('.e-editedrow')) {
					    var td = $(row).find('td.e-rowcell').eq(cellindx);
					    var content = $(td).html();
					    if (proxy.model.columns[cellindx]["commands"])
					        $span.html($(content).children());
					    else if (td.hasClass("e-validError"))
					        $span.html($(content).attr("value"));
					    else
						    $span.html(content);
					    $(td).html($span);
					    tdWidth = td.find('span:first').width();
					    if (tdWidth > contentWidth)
						    contentWidth = tdWidth;
					    $(td).html(content);
                    }
				});
			}
            proxy._refreshUnboundTemplate(this.gridInstance.getContentTable());
            return contentWidth;
        },
        _getHeaderContentWidth: function ($cellDiv) {
            var headerWidth = 0, $span = ej.buildTag('span', {}, {});
            var content = $cellDiv.html();
            $span.html(content);
            $cellDiv.html($span);
            headerWidth = $cellDiv.find('span:first').width();
            if (this.gridInstance.model.allowFiltering && this.gridInstance.model.filterSettings.filterType == "menu" || this.gridInstance.model.filterSettings.filterType == "excel")
                headerWidth = headerWidth + $cellDiv.parent().find(".e-filtericon").width() + 10;
            $cellDiv.html(content);
            return headerWidth;
        },
    };
})(jQuery, Syncfusion);;
/**
 * @fileOverview Plugin to style the Html TreeGrid elements
 * @copyright Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
 *  Use of this code is subject to the terms of our license.
 *  A copy of the current license can be obtained at any time by e-mailing
 *  licensing@syncfusion.com. Any infringement will be prosecuted under
 *  applicable laws. 
 * @version 12.1 
 * @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
 */

(function ($, ej, undefined) {
    'use strict';
    ej.widget("ejTreeGrid", "ej.TreeGrid", {
        // widget element will be automatically set in this
        _rootCSS: "e-treegrid",

        // widget element will be automatically set in this
        element: null,

        validTags: ["div"],

        // user defined model will be automatically set in this
        model: null,

        _requiresID: true,
        _tags: [
        {
            tag: "columns",
            attr: ["field", "headerText", "allowSorting", "editType", "allowFiltering", "filterEditType", "width", "visible", "editParams", 
			"format", "isFrozen", "allowFreezing", "headerTemplateID", "allowCellSelection", "showCheckbox","showInColumnChooser", "validationRules.minlength", 
			"validationRules.maxlength", "validationRules.range", "validationRules.number", "validationRules.required", "displayAsCheckbox", "editTemplate", "priority", [{ tag: "commands", attr: ["type", "buttonOptions"] }]],
            content: "template"
        },
        {
            tag: "summaryRows",
            attr: ["title", "summaryColumns"],
            content: "template"
        },
         {
             tag: "summaryRows.summaryColumns",
             attr: ["summaryType", "dataMember", "displayColumn", "prefix", "suffix", "format"],
             content: "template"
         },
        {
            tag: "sortSettings.sortedColumns",
            attr: ["field", "direction"]
        },
        {
            tag: "sizeSettings",
            attr:["height","width"]
        },
        {
            tag:"columnResizeSettings",
            attr: ["columnResizeMode"]
        }
        ],
        _columns: function (index, property, value, old){
            var $header = this.element.find(".e-headercelldiv");
            $header[index.columns].innerHTML=value;
            this._trigger("refresh");
        },
        keyConfigs: {
            focus: "e",
            editRecord: "113", //F2
            saveRequest: "13", // enter
            cancelRequest: "27", //Esc         
            firstRowSelection: "36", //"Home",
            lastRowSelection: "35", //"End",
            leftArrow:"37",//Left arrow
            upArrow: "38", //Up arrow
            rightArrow:"39",//Right arrow
            downArrow: "40", //Down arrow
            moveCellRight: "9", //tab
            moveCellLeft: "shift+9", //shifttab
            shiftDownArrow: "shift+40", //shift + DownArrow
            shiftUpArrow: "shift+38", //shift + UpArrow
            shiftRightArrow: "shift+39", //shift + RightArrow
            shiftLeftArrow: "shift+37", //shift + LeftArrow
            shiftHomeButton: "shift+36",//shift + HomeButton
            shiftEndButton: "shift+35",//shift + EndButton
            selectedRowExpand: "alt+40", //"AltPlusDownArrow",
            totalRowExpand: "ctrl+40", //"CtrlPlusDownArrow",
            selectedRowCollapse: "alt+38", //"AltPlusUpArrow",
            totalRowCollapse: "ctrl+38", //"CtrlPlusUpArrow"
            deleteRecord: "46", // delete
            spaceBar: "32", // spacebar
            topRowSelection: "ctrl+36", //CtrlPlusHome
            bottomRowSelection: "ctrl+35",//CtrlPlusEnd
            nextPage: "33", //PageUp
            prevPage:"34", //PageDown            
        },
      
        defaults: {
            expandStateMapping:"",
            allowFiltering: false,            
            allowDragAndDrop: false,            
            dragTooltip: {                
                showTooltip: false,                
                tooltipItems:[],                
                tooltipTemplate: "",
            },  
            allowSorting: false,            
            allowColumnResize: false, 
            allowSelection: true,   
            allowPaging: false,
            dataSource: null,
            query: ej.Query(),            
            idMapping: "",            
            parentIdMapping: "",  
            readOnly: false,
            showGridCellTooltip: false,
            cellTooltipTemplate:null,
            showGridExpandCellTooltip: false,
            showColumnChooser: false,
            showColumnOptions: false,
            enableAltRow: true,			
            enableLoadOnDemand: false,
            hasChildMapping: "",
            selectedItem: null,            
            toolbarSettings: {                
                showToolbar: false,                
                toolbarItems: [],
                customToolbarItems:[]
            },         
            editSettings: {       
                allowEditing: false,  
                allowAdding: true,
                allowDeleting: true,                
                editMode: "cellEditing",                
                rowPosition: "top",
                beginEditAction: "dblclick",
                dialogEditorTemplateID: ""
            },                   
            enableVirtualization: false,   
            allowMultiSorting: false,
            sortSettings: {                
                sortedColumns: []
            },
            filterSettings: {
                filterBarMode: "immediate",
                filteredColumns: [],
                filterType: "filterbar",
            },
            printingEnabled:false,
            selectionType: "single",    
            selectionMode: "row",
            selectionSettings: {
                selectionType: "single",
                selectionMode: "row",
                enableHierarchySelection: true,
                enableSelectAll: true,
            },
            selectedCellIndexes: [],
            selectedRowIndex: -1,
            showSummaryRow: false,
            summaryRows: [],            
            showTotalSummary: false,    
            allowKeyboardNavigation: true,
            cssClass: "",           
            locale: "en-US",
            isEdit: false,
            allowScrolling: false,
            scrollSettings: {
                frozenColumns: 0
            },
            groupSettings: {
                groupedColumns:[]
            },            
            sizeSettings: {                
                height: "",                
                width: "",
            },            
            enableResize: true,            
            allowTextWrap: false,
            isResponsive: true,
            showDetailsRow: false,            
            showDetailsRowInfoColumn: false,            
            detailsTemplate: "",            
            detailsRowHeight: 100,    
            rowDataBound: null,                        
            load: null,
            create:null,
            queryCellInfo: null,            
            rowSelecting: null,           
            rowSelected: null,           
            cellSelecting: null,
            cellSelected: null,
            beginEdit: null,            
            endEdit: null,            
            expanding: null,            
            expanded: null,            
            collapsing: null,            
            collapsed: null,            
            dataBound:null,
            beforePrint:null,
            actionComplete: null,            
            actionBegin: null,
            actionFailure: null,
            currentViewData: [],
            flatRecords: [],
            parentRecords: [],
            updatedRecords:[],
            summaryRowRecords: [],
            selectedItems: [],
            ids: [],      
            columns: [
            {
                field: "",
                headerText: "",
                editType: "",
                filterEditType: "",
                allowFiltering: false,
                allowFilteringBlankContent: true,
                allowSorting: false,
                visible: "",
                textAlign: ej.TextAlign.Left,
                headerTextAlign: ej.TextAlign.Left,
                allowCellSelection: true,
                clipMode: "",
                headerTooltip: "",
                tooltip:"",
                showInColumnChooser:true,
                commands: [{
                    type: "",
                    buttonOptions:{},
                }],
                //isFrozen: false,
                //allowFreezing: false
                //displayAsCheckbox
            },
            ],
            columnDialogFields: [],
            commonWidth: 150,
            dateFormat: "MM/dd/yyyy",   
            rowHeight: 30,
            emptyRecordText: "No Records To Display",            
            treeColumnIndex: 0,
            //API for toggle between datepicker and datetimepicker
            workingTimeScale: 'TimeScale8Hours',            
            childMapping: "",             
            enableCollapseAll:false,
            rowTemplateID: "",
            altRowTemplateID: "",
            parseRowTemplate: true,
            contextMenuSettings: {                
                showContextMenu: false,                
                contextMenuItems: []
            },            
            contextMenuOpen: null,            
            rowDragStart: null,            
            rowDrag: null,            
            rowDragStop: null,       
            detailsDataBound: null,            
            detailsShown: null,            
            detailsHidden: null,
            toolbarClick: null,
            columnResizeStart: null,
            columnResizeEnd: null,
            columnResized:null,
            recordClick:null,
            exportToPdfAction: "",
            exportToExcelAction: "",
            allowMultipleExporting: false,
            headerTextOverflow: "none",
            pageSettings: {
                pageSize: 12,
                pageCount: 8,
                currentPage: 1,
                totalPages: 0,
                totalRecordsCount: null,
                pageSizeMode: "all",
                template: null,                
                printMode:"allPages",
            },
            allowColumnReordering: false,
            columnResizeSettings: {
                columnResizeMode: "normal"
            }
        },

        dataTypes: {
            columns: "array",            
            summaryRows: "array",
            sortSettings: {
                sortedColumns: "array"
            },
            filterSettings: {
                filteredColumns: "array",
                filterType: "string",
            },
            dataSource: "data",
            query: "data",
            currentViewData: "array",
            flatRecords: "array",
            parentRecords: "array",
            updatedRecords:"array",
            summaryRowRecords: "array",
            ids: "array",
            contextMenuSettings: {
                contextMenuItems: "array"
            },
            toolbarSettings: {
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            selectedItem: "data",            
        },
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "enableRTL", "rowDataBound", "rowTemplate","parseRowTemplate",
             "detailsTemplate", "editSettings", "localization", "cssClass", "dataSource", "allowKeyboardNavigation","pageSettings","columnResizeSettings"
        ],
        observables: ["selectedRowIndex", "dataSource", "selectedCellIndexes","pageSettings.currentPage"],
        selectedItem: ej.util.valueFunction("selectedItem"),
        selectedRowIndex: ej.util.valueFunction("selectedRowIndex"),
        selectedCellIndexes: ej.util.valueFunction("selectedCellIndexes"),
        dataSource: ej.util.valueFunction("dataSource"),
        _currentPage: ej.util.valueFunction("pageSettings.currentPage"),

        //GET THE LOCALIZATION OBJECT
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },

        //GET THE GRID HEADER TABLE FOR COLUMNRESIZE
        getHeaderTable: function () {
            return this._$gridHeaderTable;
        },

        //SET THE GRID HEADER TABLE
        setGridHeaderTable: function (value) {
            this._$gridHeaderTable = value;
        },

        //GET THE GRIDHEADERCONTENT
        getHeaderContent: function () {
            return this._$gridHeaderContent;
        },

        //SET THE GRIDHEADERCONTENT
        setGridHeaderContent: function (value) {
            this._$gridHeaderContent = value;
        },

        //GET THE GRID CONTENT TABLE
        getContentTable: function () {
            return this._$gridContentTable;
        },

        getContent: function () {
            return this._$gridContent;
        },
        
        //SET THE GRID CONTENT TABLE
        setGridContentTable: function (value) {
            this._$gridContentTable = value;
        },

        //GET TREEGRID ROWS
        getRows: function () {
            var $gridRows = this._excludeDetailRows();
            return $gridRows;
        },

        //GET SELECTED CELLS
        getSelectedCells: function () {
            var proxy = this, model = proxy.model;
            var selectedCellElement = [];
            this._selectedCellDetails.forEach(function (item) {
                //Replace the current view cell Element after scrolling.
                var record = item.data,
                    currentRowIndex = model.currentViewData.indexOf(record), $target = $(item.cellElement);
                if (currentRowIndex != -1) {
                    if (proxy._frozenColumnsLength > 0) {
                        if ($target.closest(".e-frozencontentdiv").length > 0)
                            item.cellElement = proxy.getRows()[0][currentRowIndex].childNodes[item.cellIndex];
                        else if ($target.closest(".e-movablecontentdiv").length > 0)
                            item.cellElement = proxy.getRows()[1][currentRowIndex].childNodes[(item.cellIndex - proxy._frozenColumnsLength)];
                    } else {
                        item.cellElement = proxy.getRows()[currentRowIndex].childNodes[item.cellIndex];
                    }
                }
                selectedCellElement.push(item.cellElement);
            });
            return selectedCellElement;
        },

        //SET TREEGRID ROWS
        setGridRows: function (value) {
            this._$gridRows = value;
        },

        //GET CURRENTVIEWPORT DATA
        getCurrentViewData: function () {
            return this.model.currentViewData;
        },

        //GET UPDATED CURRENT VIEW DATA
        getUpdatedCurrentViewData: function () {
            this._updateCurrentViewData();
            return this.model.currentViewData;
        },

        //GET FLAT RECORDS
        getFlatRecords: function () {
            return this.model.flatRecords;
        },

        //SET THE HEIGHT BASED ON THE RECORD COUNT
        setHeight: function (value) {
            this._totalHeight = value;
        },

        //GET THE UPDATEDRECORDS[SORTED,FILTERED,EXPANDCOLLAPSED]
        getUpdatedRecords: function () {
            var model = this.model,updatedRecords = [];
            if (!this._isFromGantt && model.allowPaging)
                updatedRecords = this._updatedPageData;
            else
                updatedRecords = model.updatedRecords;           
            return updatedRecords;
        },

        //GET THE SUMMARY ROW RECORDS
        getsummaryRowRecords: function () {
            return this.model.summaryRowRecords;
        },
        //GET THE UPDATED DATASOURCE
        getDataSource: function () {
            return this.dataSource();
        },

        //get the ids collection after perform the addition/delete operation
        //GET THE IDS COLLECTION AFTER PERFORM THE ADDITION/DELETE OPERATION
        getUpdatedIds: function () {
            return this.model.ids;
        },

        //GET THE RECORDS COUNT
        getRecordsCount: function () {
            return this._recordsCount;
        },

        //SET THE RECORDS COUNT
        setRecordsCount: function (value) {
            this._recordsCount = value;
        },
        // SET FOCUS ON ELEMENT
        setFocusOnTreeGridElement: function(){
            this._focusTreeGridElement();
        },

        //update the collapseRecount by updatedRecord collection
        updateCollapsedRecordCount:function()
        {
            var proxy = this,
                model = this.model,
                resultRecord = [];
            resultRecord = model.updatedRecords.filter(function (record) {
                return proxy.getExpandStatus(record) == false;
            });
            proxy._totalCollapsedRecordCount = resultRecord.length;
        },

        //In virtualization get expaned records from total record collection only
        _getDetailsExpandedRecords: function (records) {            
            var resultRecord = records.filter(function (record) {
                return record.isDetailsExpanded == true;
            });
            return resultRecord;
        },

        /* Get expanded details row height */
        _getExpandedDetailsRowHeight:function()
        {
            var proxy = this,                
                expandedRecords, 
                detailExpandedRecords,
                updatedRecords = proxy.getUpdatedRecords();

            expandedRecords = this.getExpandedRecords(updatedRecords);
            detailExpandedRecords = this._getDetailsExpandedRecords(expandedRecords);
            detailExpandedRecords = proxy._spliceSummaryRows(detailExpandedRecords);
            return (proxy._detailsRowHeight * detailExpandedRecords.length);
        },
        //return collapsed recount length in updatedRecord collectio
        getCollapsedRecordCount: function (records) {
            return this._totalCollapsedRecordCount;
        },
        
        _colgroupRefresh: function () {
            var gridheaderCol, gridcontentCol;
            
            if (this._frozenColumnsLength > 0) {
                gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                gridcontentCol = $(this.getContentTable()).find('colgroup');
            }
            else {
                gridheaderCol = $(this.getHeaderTable()).find('colgroup')[0];
                gridcontentCol = $(this.getContentTable()).find('colgroup')[0];
            }
            var headerColClone = $(gridheaderCol).clone();
            var contentColClone = $(gridcontentCol).clone();
            var footerColClone = $(gridcontentCol).clone();
            $(gridcontentCol).remove();
            $(gridheaderCol).remove();
            if (this._frozenColumnsLength > 0) {
                $(headerColClone[0]).prependTo(this.getHeaderTable()[0]);
                $(headerColClone[1]).prependTo(this.getHeaderTable()[1]);
                $(contentColClone[0]).prependTo(this.getContentTable()[0]);
                $(contentColClone[1]).prependTo(this.getContentTable()[1]);
                if (this._$footertableContent) {
                    $(this._$footertableContent).find('colgroup').remove();
                    $(footerColClone[0]).prependTo(this._$footertableContent[0]);
                    $(footerColClone[1]).prependTo(this._$footertableContent[1]);
                }
                if (this._$totalSummaryRowContainer) {
                    if (this.getBrowserDetails().browser == "safari")
                        this._$totalSummaryRowContainer.find("#e-movablefooter" + this._id).css("margin-left", "auto");
                }
                if (this.getBrowserDetails().browser == "safari")
                    this.getHeaderContent().find("#e-movableheader" + this._id).add(this.getContent().find("#e-movablecontainer" + this._id)).css("margin-left", "auto");
                $("#e-frozencontentdiv" + this._id).length && $("#e-frozencontentdiv" + this._id).css("width", "100%");
            }
            else {
                $(headerColClone).prependTo(this.getHeaderTable());
                $(contentColClone).prependTo(this.getContentTable());
                if (this._$footertableContent) {
                    $(this._$footertableContent).find('colgroup').remove();
                    $(footerColClone).prependTo(this._$footertableContent);
                }
            }
        },
        _detailColsRefresh: function () {
            this._$headerCols = this.getHeaderTable().children("colgroup").find("col");
            this._$contentCols = this.getContentTable().children("colgroup").find("col");
            if (this.model.detailsTemplate && this.model.showDetailsRow && this.model.showDetailsRowInfoColumn || this.model.isFromGantt) {
                var colCount = this.model.columns.length;
                if (this._$headerCols.length > colCount) this._$headerCols.splice(colCount, 1);
                if (this._$contentCols.length > colCount) this._$contentCols.splice(colCount, 1);
            }
        },

        _swipeAction: function (e) {
            var proxy = this,curPage = this._currentPage(), doPage = true;
            var hScroll = (this.getScrollObject() || {})._scrollXdata;
            if (hScroll)
                doPage = e.type == "swipeleft" ? hScroll.scrollable - hScroll.sTop == 0 : hScroll.sTop == 0;

            switch (e.type) {
                case "swipeleft":
                    if (this.model.allowPaging && curPage != this.model.pageSettings.totalPages && !this.model.isEdit && !this._isRowEdit) {
                        if (doPage || !proxy.getScrollElement().ejScroller("isHScroll")) {
                            this.element.ejTreeGrid("gotoPage", curPage + 1);
                        }
                    }
                    break;
                case "swiperight":
                    if (this.model.allowPaging && curPage > 1 && !this.model.isEdit && !this._isRowEdit) {
                        if (doPage || !proxy.getScrollElement().ejScroller("isHScroll")) {
                            this.element.ejTreeGrid("gotoPage", curPage - 1);
                        }
                    }
                    break;
            }
        },

        // Move to the given page number
        gotoPage: function (pageIndex) {
            var proxy = this, model = proxy.model,
               args = {}, returnValue;

            if (!this.model.allowPaging)
                return;
            if (this._isLoadonDemand && pageIndex && pageIndex != this._currentPage()) {
                this._currentPage(pageIndex);
                proxy._refreshDataSource();
                if (this._prevPageNo != pageIndex)
                    this._prevPageNo = pageIndex;
                return;
            }
            if (ej.isNullOrUndefined(pageIndex))
                pageIndex = proxy._currentPage();
            else {
                if (pageIndex <= 0)
                    pageIndex = 1;
                else if (pageIndex > model.pageSettings.totalPages)
                    pageIndex = model.pageSettings.totalPages;
            }
            pageIndex = ej.isNullOrUndefined(pageIndex) ? proxy._currentPage() : pageIndex;
            this._currentPage(pageIndex);           
            args.previousPage = this._prevPageNo;                      
            args.currentPage = pageIndex;
            if (model.allowPaging) {                
                args.requestType = ej.TreeGrid.Actions.Paging;
            }
            proxy._setScrollTop();
            proxy._updateCurrentViewData();            
            proxy.renderRecords(args);
            proxy._updateWrapRowHeights("total,header");
            proxy.updateHeight();
            proxy._updateScrollCss();
            if (model.allowTextWrap && model.enableVirtualization)
                proxy._updateWrapRowHeights("header", "refreshAll");
            if (returnValue)
                this._currentPage(args.previousPage);
            if (args.previousPage != args.currentPage) {                
                proxy.clearSelection(-1);
                proxy.selectedRowIndex(-1);
                proxy.model.selectedItem = null;
                proxy._cancelSaveTools();
                proxy._clearContextMenu();
                if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                    proxy._clearMultiSelectPopup();
                }
                this._prevPageNo = args.currentPage;
            }
        },

        /*Handler for pager change event*/
        _pagerClickHandler: function (sender) {
            var proxy = this;
            if (this._prevPageNo == sender.currentPage)
                return;
            proxy._isNextPage = true;
            if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            else if (proxy.model.isEdit)
                proxy.cancelEditCell();
            this.gotoPage(sender.currentPage);
            return false;
        },
        /*CONSTRUCTOR FUNCTION*/
        _init: function () {

            var proxy = this;

            /* default value for asp designer */
            if (proxy.model.isdesignMode) {
                proxy.model.columns = [
                    { "field": "Column1", "HeaderText": "Column1" },
                    { "field": "Column2", "HeaderText": "Column2" },
                    { "field": "Column3", "HeaderText": "Column3" },
                    { "field": "Column4", "HeaderText": "Column4" }];
                proxy.model.childMapping = "Children";
                var tempDataSource = [{ Column1: "Value 1", Column2: "Value 2", Column3: "Value 3", Column4: "Value 4", Children: [] }];

                for (var count = 1; count < 4; count++) {
                    var data = { Column1: "Value 1", Column2: "Value 2", Column3: "Value 3", Column4: "Value 4" };
                    tempDataSource[0].Children.push(data);
                }
                this.dataSource(tempDataSource);
                this.model.sizeSettings.height = "250px";
                this.model.sizeSettings.width = "600px";
            }
            proxy._trigger("load");
            proxy._validateColumnFields();
            if (!proxy.model.isFromGantt)
                proxy._validateColumnVisible(true);
            proxy._initPrivateProperties();
            proxy._setCultureInfo();
                        
            if (this.dataSource() instanceof ej.DataManager && this.dataSource().ready != undefined) {
                var proxy = this;
                proxy._renderWaitingPopup();
                this.dataSource().ready.done(function (args) {                    
                    proxy.model.dataSource = ej.DataManager(args.result);
                    proxy._initDatasource();
                });
            }
            else
                proxy._initDatasource();
            proxy._processEditing();
            if (proxy.model.showColumnChooser && proxy.model.showColumnOptions) {
                proxy.columnAddDialogTemplate();
                proxy._renderUpdateConfirmDialog();
            }
            proxy._createDragTooltipTemplate();
            proxy._createTooltipTemplate();
        },

        // Method to render the outer div element for Add/edit dialog into the DOM
        _renderEditDialog: function () {
            var $dialog = ej.buildTag("div.e-editdialog-padding", "", { display: "none" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },

        // Method to validate the column fields
        _validateColumnFields: function ()
        {
            var proxy = this, column = proxy.model.columns;
            if (!ej.isNullOrUndefined(column)) {
                for (var index = 0; index < column.length; index++) {
                    if (ej.isNullOrUndefined(column[index].field)) {
                        column[index].field = "";
                        column[index].allowEditing = false;
                        column[index].allowSorting = false;
                        column[index].allowFiltering = false;
                    }
                    if (proxy._isCommandColumn(column[index])) {                       
                        column[index].allowEditing = false;
                        column[index].allowSorting = false;
                        column[index].allowFiltering = false;
                        column[index].showCheckbox = false;
                    }
                    if (ej.isNullOrUndefined(column[index].editType)) {
                        column[index].editType = "stringedit";
                    }
                    if (column[index].editType == "maskedit" && ej.isNullOrUndefined(column[index].filterEditType)) {
                        column[index].filterEditType = "stringedit";
                    }
                }
            }

        },

        //Set the column visibility based on column priority and document width
        _validateColumnVisible: function (isLoad) {
            var proxy = this,
                model = proxy.model;
            proxy._autoHideColumns = [];
            proxy._autoShowColumns = [];
            if (model.isResponsive && model.enableResize) {
                var width = document.body.clientWidth,
                    priority = null;
                if (width >= 960 && width <= 1120)
                    priority = 6;
                else if (width >= 800 && width <= 959)
                    priority = 5;
                else if (width >= 640 && width <= 799)
                    priority = 4;
                else if (width >= 480 && width <= 639)
                    priority = 3;
                else if (width >= 0 && width <= 479)
                    priority = 2;
                var columns = model.columns,
                    length = columns.length;
                if (isLoad) {
                    for (var index = 0; index < length; index++) {
                        if (priority != null) {
                            if (columns[index].priority)
                                if (columns[index].priority >= priority)
                                    columns[index].visible = false;
                                else
                                    columns[index].visible = true;
                        }
                        else {
                            if (!ej.isNullOrUndefined(columns[index].priority))
                                columns[index].visible = true;
                        }
                    }
                }
                else
                {
                    for (var index = 0; index < length; index++) {
                        if (priority != null) {
                            if (columns[index].priority)
                                if (columns[index].priority >= priority) {
                                    if (columns[index].visible != false)
                                        proxy._autoHideColumns.push(columns[index]);
                                }
                                else
                                {
                                    if (columns[index].visible == false)
                                        proxy._autoShowColumns.push(columns[index]);
                                }
                                    
                        }
                        else {
                            if (!ej.isNullOrUndefined(columns[index].priority))
                                if (columns[index].visible == false)
                                    proxy._autoShowColumns.push(columns[index]);
                        }
                    }
                }
            }
        },
        //Hidden column using column values
        _hideColumns: function (columns) {
            var proxy = this,
                model = proxy.model;
            columns.reverse();
            columns.sort(function (column1, column2) {
                return column2.priority - column1.priority;
            });
            if (columns && columns.length > 0) {
                var length = columns.length;
                //Table column width not properly set in firefox, so just remove and add the e-table class from both header and content table
                proxy.getHeaderTable().removeClass("e-table");
                proxy.getContentTable().removeClass("e-table");
                for (var columnIndex = 0; columnIndex < length; columnIndex++) {
                    var column = columns[columnIndex],
                        index = $.inArray(column, model.columns),
                        headerText = column.headerText,
                        hiddenColumnIndex = $.inArray(headerText, proxy._hiddenColumns);
                    /* check this is single column in frozen or movable column*/
                    if (column && !proxy._isColumnHidable(column))
                        continue;
                    if (index != -1 && index != model.treeColumnIndex && hiddenColumnIndex == -1)
                        proxy._autoHideShowColumn(headerText,index, true);
                    index = $.inArray(headerText, proxy._visibleColumns);
                    if (index != -1)
                        proxy._visibleColumns.splice(index, 1);
                }
                proxy.getHeaderTable().addClass("e-table");
                proxy.getContentTable().addClass("e-table");
                proxy._updateHideShowColumnAlignment();
            }
        },
        //Show the hidden column using column values
        _showColumns: function (columns) {
            var proxy = this,
                model = proxy.model;
            if (columns && columns.length > 0) {
                var length = columns.length;
                for (var columnIndex = 0; columnIndex < length; columnIndex++) {
                    var column = columns[columnIndex],
                        index = $.inArray(column, model.columns),
                        headerText = column.headerText,
                        visibleColumnIndex = $.inArray(headerText, proxy._visibleColumns);
                    if (index != -1 && visibleColumnIndex == -1)
                        proxy._autoHideShowColumn(headerText,index, false);
                    index = $.inArray(headerText, proxy._hiddenColumns);
                    if (index != -1)
                        proxy._hiddenColumns.splice(index, 1);
                }
                proxy._updateHideShowColumnAlignment();
            }
        },

        //Hide or show the tree grid column
        _autoHideShowColumn: function (headerText,index, isHide)
        {
            var proxy = this,
                model = proxy.model;
            /* Cancel edited cell before sort the column*/
            proxy._cancelEditState();
            if (isHide) {
                proxy._hiddenColumns.push(headerText);
                model.columns[index].visible = false;
            }
            else {
                proxy._visibleColumns.push(headerText);
                model.columns[index].visible = true;
            }
            var headerrows,
                headerColgroup = proxy.getHeaderTable().find('colgroup').find("col"),
                headerRows = proxy.getHeaderTable().find('thead').find("th.e-headercell");
            if (model.allowFiltering && model.filterSettings.filterType == "filterbar") {
                headerrows = proxy.getHeaderTable().find('thead').find("th.e-filterbarcell");
            }
            if (proxy.model.columns[index].isFrozen == true) {
                proxy._updateFrozenColumnOnResize(index);
                proxy.setWidthToColumns();
            }
            var gridColGroup = proxy.getContentTable().find("colgroup").find("col"),
                isFrozenTable = true, cellIndex = index, footerRows,gridrows;
            gridrows = proxy.getRows();
            footerRows = proxy._getFooterRows();
            if (isHide) {
                $(headerColgroup).eq(index).hide();
                $(headerRows).eq(index).addClass("e-hide");
                headerrows && $(headerrows).eq(index).addClass("e-hide");
                $(gridColGroup).eq(index).hide();
            }
            else {
                $(headerColgroup).eq(index).show();
                $(headerRows).eq(index).removeClass("e-hide");
                headerrows && $(headerrows).eq(index).removeClass("e-hide");
                $(gridColGroup).eq(index).show();
            }

            if (proxy._frozenColumnsLength > 0) {
                if (index < proxy._frozenColumnsLength) {
                    gridrows = $(proxy.getRows()[0]);
                    footerRows = $(footerRows[0]);
                    if (proxy._gridRows && $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        tempColSpan = isHide ? (tempColSpan - 1) : (tempColSpan + 1);
                        $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan);
                    }
                }
                else {
                    gridrows = $(proxy.getRows()[1]);
                    footerRows = $(footerRows[1]);
                    isFrozenTable = false;
                    cellIndex = index - this._frozenColumnsLength;
                    if (proxy._gridRows && $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        tempColSpan = isHide ? (tempColSpan - 1) : (tempColSpan + 1);
                        $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan);
                    }
                }
            } else {
                if (proxy._gridRows && $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                    var tempColSpan = parseInt($(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                    tempColSpan = isHide ? (tempColSpan - 1) : (tempColSpan + 1);
                    $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan);
                }
            }

            //Display or hide the specified column     
            gridrows.each(function () {
                var td = $(this).children("td").eq(cellIndex);
                isHide ? $(td).addClass("e-hide") : $(td).removeClass("e-hide");
                if (model.showSummaryRow && $(td).hasClass('e-summaryrowcell') && isFrozenTable)
                    proxy._updateSummaryRowTitleCell(headerColgroup, td[0].parentElement);
            });

            //Show or Hide the specific column from total summary row.
            if (model.showTotalSummary) {
                var footerColGroup = proxy._$footertableContent.find("colgroup").find("col");
                isHide ? $(footerColGroup).eq(index).hide() : $(footerColGroup).eq(index).show();
                footerRows.each(function () {
                    var footerSummarytd = $(this).children("td").eq(cellIndex);
                    isHide ? $(footerSummarytd).addClass("e-hide"):$(footerSummarytd).removeClass("e-hide");
                    if ($(footerSummarytd).hasClass('e-footersummaryrowcell'))
                        proxy._updateSummaryRowTitleCell(footerColGroup, footerSummarytd[0].parentElement);
                });
            }
        },

        //Update the tree grid alignment after hide and show the column
        _updateHideShowColumnAlignment:function()
        {
            var proxy = this,
                model = proxy.model;
            proxy._addInitTemplate();
            var gridContent = proxy.getScrollElement();
            if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                proxy._updateTableWidth();
            gridContent.ejScroller("refresh");
            proxy._updateScrollCss();
            proxy._updateHeaderScrollLeft();
            if (model.showColumnChooser) {
                proxy._renderColumnChooserList(true);
                proxy._updateColumnMenuVisibility();
            }
        },
        // Method to create a template for add/edit dialog.
        _treeGridAddEditDialog: function () {
            if (this.model.columns.length == 0)
                return;
            var $formbody = ej.buildTag('div');
            var $form = ej.buildTag('form.e-treegridform', "", {}, { id: this._id + "EditFormDialog" });
            var $table = ej.buildTag('table', "", { "margin": "0 auto" }, {});
            var $innerTr, $labelTd, $valueTd, trElement, tdElement;
            for (var columnCount = 0; columnCount < this.model.columns.length; columnCount++) {
                if ((this.model.columns[columnCount].visible || ej.isNullOrUndefined(this.model.columns[columnCount].visible)) && this.model.columns[columnCount].field != "checkboxState" && !this._isCommandColumn(this.model.columns[columnCount])) {
                    trElement = 'tr';
                    tdElement = 'td';
                    $innerTr = ej.buildTag(trElement);
                    $labelTd = ej.buildTag(tdElement + ".e-editdialoglabel", "", { "text-align": "right" });
                    $valueTd = ej.buildTag(tdElement + ".e-editdialogrowcell", "", { "text-align": "left" });
                    $innerTr.append($labelTd.get(0)).append($valueTd.get(0));
                    if (this.model.columns[columnCount].headerText == undefined)
                        this.model.columns[columnCount].headerText = this.model.columns[columnCount].field;
                    $labelTd.append("<label>" + this.model.columns[columnCount].headerText + "</label>");
                    if (this.model.columns[columnCount]["allowEditing"] != false && this.model.columns[columnCount]["field"])
                        ej.TreeGrid._initCellEditType(this, $valueTd, this._id, columnCount);
                    this.model.columns[columnCount]["allowEditing"] == false && $valueTd.find(".e-field").attr("disabled", true).addClass("e-disable");
                    if (this.model.columns[columnCount]["visible"] === false)
                        $innerTr.addClass("e-hide");
                    $table.append($innerTr);
                }
            }
            $form.append($table);
            $form.appendTo($formbody);
            $formbody = this._renderDiaglogButton($form, $formbody, $table);
            $.templates(this._id + "_JSONDialogEditingTemplate", $formbody.html());
        },

        //  Method to create a template for add/edit template dialog.
        _treeGridAddEditDialogTemplate: function () {
            if (this.model.columns.length == 0)
                return;
            var $tbody = ej.buildTag('div', "", { 'display': 'none' });
            var $form = ej.buildTag('form.e-treegridform', "", {}, { id: this._id + "EditFormDialog" });
            var cloneElement = this.model.editSettings.dialogEditorTemplateID;
            $form.html($(cloneElement).html());
            $tbody = this._renderDiaglogButton($form, $tbody);
            $.templates(this._id + "_JSONdialogTemplateMode", $tbody.html());
        },

        // To render the save/cancel buttons for treegrid add/edit dialog and add/edit template dialog
        _renderDiaglogButton: function (form, $formbody, $table) {
            var btnId, contextMenuLabel = this._contextMenuTexts, savebtn, cancelbtn;
            btnId = "EditFormDialog_";
            if (ej.isNullOrUndefined($table)) {
                savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '33%' }, { type: "button", id: btnId + this._id + "_Save" });
                savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["saveText"], width: "30%" });
                cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '7%' }, { type: "button", id: btnId + this._id + "_Cancel" });
                cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["cancelText"], width: "30%" });
            } else {
                savebtn = ej.buildTag('input.e-save e-button e-btnsub e-flat', "", { 'margin-left': '0px' }, { type: "button", id: btnId + this._id + "_Save" });
                savebtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["saveText"], width: "45%" });
                cancelbtn = ej.buildTag('input.e-cancel e-button e-btncan e-flat', "", { 'margin-left': '10%' }, { type: "button", id: btnId + this._id + "_Cancel" });
                cancelbtn.ejButton({ cssClass: this.model.cssClass, enableRTL: this.model.enableRTL, text: contextMenuLabel["cancelText"], width: "45%" });
            }
            var btnDiv = ej.buildTag('div', "", {}, { 'class': "e-editform-btn e-editdialogbutton" }),
                $innerTr, $innerTd1, $innerTd2;
            if (!ej.isNullOrUndefined($table)) {
                $innerTr = ej.buildTag('tr');
                $innerTd1 = ej.buildTag('td.e-editdialoglabel');
                $innerTd2 = ej.buildTag('td.e-editdialogrowcell');
            }
            btnDiv.append(savebtn);
            btnDiv.append(cancelbtn);
            if (!ej.isNullOrUndefined($table)) {
                $innerTd2.append(btnDiv);
                $innerTr.append($innerTd1);
                $innerTr.append($innerTd2);
                $table.append($innerTr);
            }
            form.appendTo($formbody);
            if (!ej.isNullOrUndefined($table))
                form.append($table);
            else
                form.append(btnDiv);
            return $formbody;
        },

        /* update allow keyboard navigation value*/
        updateAllowKeyboardNavigation: function (bool)
        {
            this.model.allowKeyboardNavigation = bool;
        },
        /* Refresh footer summary records if total summary exist */
        _refreshFooterSummaryRecords: function () {
            var proxy = this,
                model = this.model;
            if (model.showTotalSummary && proxy._$footerContainer.length > 0) {
                if (this._frozenColumnsLength > 0) {
                    proxy._$footerContainer.html(this._renderSummaryByFrozenDesign());
                    this._renderFrozenSummary();
                } else {
                    var $table = ej.buildTag('table.e-table e-zerospace#' + proxy._id + "summarye-table", "",
                    { top: "0px" }),
                      $tbody = ej.buildTag('tbody');
                    $table.append(proxy.getContentTable().find('colgroup').clone()).append($tbody);
                    $tbody.html($.render[this._id + "_Template"](proxy._footerSummaryRecord));
                    proxy._$footerContainer.empty().append($table);
                }
                proxy._$footertableContent = proxy._$footerContainer.find(".e-table");
            }
        },
        /* update scrollLeft of header container with content scrollLeft*/
        _updateHeaderScrollLeft: function (scrollLeft) {
            var proxy = this;
            if (ej.isNullOrUndefined(scrollLeft))
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");
            if (this._frozenColumnsLength > 0) {
                proxy._$gridHeaderContainer.find("#e-movableheader" + this._id).scrollLeft(scrollLeft);
                if (proxy.model.showTotalSummary && proxy._$footerContainer)
                    proxy._$footerContainer.find("#e-movablefooter" + this._id).scrollLeft(scrollLeft);
            } else {
                proxy._$gridHeaderContainer.scrollLeft(scrollLeft);
                if (proxy.model.showTotalSummary && proxy._$footerContainer)
                    proxy._$footerContainer.scrollLeft(scrollLeft);
            }
        },
        //Update Columns Dynamically.
        updateColumns: function (columns) {
            var proxy = this,
               model = this.model;
            model.columns = columns;
            proxy._refreshFrozenColumns();
        },
        //Update the Gantt Columns from TreeGrid Columns.
        updateToGanttColumns: function () {
            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            ganttObject.updateGanttColumns(columns);            
        },

        //Update the add and edit dialog template.
        _updateAddEditDialogTemplate: function () {
            var proxy = this, ganttObject;
            ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            ganttObject.addDialogTemplate();
            ganttObject.editDialogTemplate();
        },
        /* Refresh columns collection with freeze and unfreeze*/
        _refreshFrozenColumns: function () {
            var proxy = this,
               model = this.model,
               layoutUpdated = false;
            proxy._initFrozenColumns();
            proxy._processEditing();
            //Rerendering the column header with new columns.;
            proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
            proxy._addInitTemplate();
            if (model.isFromGantt)
                proxy._$gridContent.removeClass("e-borderbox");
            /* Render frozen and movable table if any column is frozen*/
            if (this._frozenColumnsLength > 0 && proxy._$frozenTableContent.length == 0) {
                layoutUpdated = true;
                var contentWidth = proxy._$gridContent.css("width"),
                    contentHeight = proxy._$gridContent.css("height");
                proxy._$gridContent.ejScroller("destroy");
                proxy._$gridContent.css("width", contentWidth);
                proxy._$gridContent.css("height", contentHeight);
                proxy._$gridContainer.html(proxy._renderByFrozenDesign());
                proxy.setGridContentTable(proxy._$gridContainer.find(".e-table"));
                if (model.allowTextWrap && !model.enableVirtualization)
                    proxy._$gridContainer.find("#e-movablecontent" + proxy._id + ",#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", "auto");
                else
                    proxy._$gridContainer.find("#e-movablecontent" + proxy._id + ",#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", proxy._$gridContainer.css("height"));
                proxy._renderScroller(true);
            } else if (proxy._$frozenTableContent.length > 0 && this._frozenColumnsLength == 0) {
                layoutUpdated = true;
                proxy._$gridContent.find("#e-movablecontainer" + proxy._id).ejScroller("destroy");
                var $table = ej.buildTag('table.e-table e-zerospace#' + proxy._id + "e-table", "",
                     { top: "0px", "position": "relative" }),
                     $tbody = ej.buildTag('tbody');
                $table.append(proxy.getHeaderTable().find('colgroup').clone()).append($tbody);
                proxy._$gridContainer.html($table);
                proxy.setGridContentTable($table);
                proxy._renderScroller(true);
            }
            /* Update table private  properties*/
            proxy._$frozenTableContent = $("#" + proxy._id + "frozene-table");
            proxy._$movableTableContent = $("#" + proxy._id + "movablee-table");
            proxy._$tableContent = $("#" + proxy._id + "e-table");

            if (model.showTotalSummary && proxy._$footerContainer.length > 0) {
                proxy._refreshFooterSummaryRecords();
            }

            if (layoutUpdated) {
                proxy.onScrollHelper(0);
            }
            var args = {};
            args.requestType = ej.TreeGrid.Actions.Refresh;
            /* for details rows detailsDataBound event can be called after the width update of column */
            proxy._isRendered = false;
            //Rerendering the content of the tree grid
            proxy.sendDataRenderingRequest(args);
            proxy.setWidthToColumns();
            proxy._isRendered = true;
            /* trigger queryCellInfo ,detailsDataBoundEvent after update the width of the columns */
            proxy._trigger("refresh");
            this._eventBindings();
            this._hideCollapsedDetailsRows();
            /* Update the scrollbar*/           
            proxy.getScrollElement().ejScroller("refresh");
            proxy._updateScrollCss();                
            if (model.isFromGantt) {
                var gridContent = proxy.getScrollElement(),
                    isHorizontalScroll = gridContent.ejScroller("isHScroll");
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            }
            if (model.showColumnChooser)
                proxy._renderColumnChooserList(true);
            /* update header and footer scrollLeft value*/
            proxy._updateHeaderScrollLeft();            
            
            if (model.isFromGantt) {
                /*Add additional td on column header to maintain column width*/
                proxy._addEmptyColumntoGrid();
                /*Updating the column properties to Gantt's model.columns*/
                proxy.updateToGanttColumns();
            }           
        },
        /* Freeze all Columns before argumented column*/
        freezePrecedingColumns: function (field) {
            var proxy = this, model = this.model,
                columns = model.columns,
                currentColumn = this.getColumnByField(field),
                columnIndex = columns.indexOf(currentColumn);
            /* Clear edit state , context menu and details template*/
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
                      
            this._clearContextMenu();
            this._removeDetailsRow();
            this._clearColumnMenu();

            /* Check column is available or not*/
            if (ej.isNullOrUndefined(currentColumn) || columnIndex == -1)
                return false;
            /*Check all previous columns are in frozen*/
            if (columnIndex == 0 && columnIndex <= this._frozenColumnsLength)
                return false;
            /*Check frozen column width and container width */
            var frozenWidth = this._getFrozenColumnWidth(columnIndex);
            frozenWidth = frozenWidth + 18;
            if (frozenWidth > this._gridWidth)
                return false;
            /* update isFrozen API of columns and refresh the columns*/
            for (var count = 0; count < columnIndex; count++) {
                columns[count].isFrozen = true;
            }
            proxy._refreshFrozenColumns();
            proxy._updateWrapRowHeights(null,"virtualRefresh");
        },
        /* Public method for freeze or unfreeze the columns */
        freezeColumn: function (field, isFrozen) {
            var proxy = this, model = this.model,
                columns = model.columns,                
                currentColumn = this.getColumnByField(field);

            /* Clear edit state , context menu and details template*/
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }

            this._clearContextMenu();
            this._removeDetailsRow();
            this._clearColumnMenu();

            if (model.selectionSettings.selectionMode == "cell")
                proxy.clearSelection();

            /* Check column is available or not*/
            if (ej.isNullOrUndefined(currentColumn))
                return false;
            /*Check all other columns are in frozen*/
            if (proxy._frozenColumnsLength == model.columns.length - 1 && isFrozen)
                return false;
            /* Check column is in same state*/
            if (currentColumn.isFrozen == isFrozen)
                return false;
            /*Check frozen column width and container width */
            var frozenWidth = this._getFrozenColumnWidth(),
                columnIndex = columns.indexOf(currentColumn);
            frozenWidth = frozenWidth + (isFrozen ? (this.columnsWidthCollection[columnIndex] + 18) : (-this.columnsWidthCollection[columnIndex]));
            if (frozenWidth > this._gridWidth)
                return false;

            currentColumn.isFrozen = isFrozen;
            /* refresh columns collection in UI*/
            proxy._refreshFrozenColumns();
			proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            if (this._frozenColumnsLength)
                proxy._on(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            proxy._updateWrapRowHeights(null, "virtualRefresh");
        },

        //Public method use to change checkbox Column
        updateCheckboxColumn: function(fieldName){
            var proxy = this, model = proxy.model,
                columns = model.columns,
                column = proxy.getColumnByField(fieldName);
            if (!proxy._checkboxSelection)
                return;
            $.each (columns, function (index, value) {
                value["showCheckbox"] = false;
            });
            if (!ej.isNullOrUndefined(column)) {                
                var index = columns.indexOf(column);
                if(index > -1)
                    columns[index]["showCheckbox"] = true;
            }            
            var selectionSettings = {}, args = {};
            selectionSettings.selectionType = ej.TreeGrid.SelectionType.Checkbox;
            args.selectionSettings = selectionSettings;
            proxy._refreshSelectionSettings(args, "selectionSettings");
        },

        //Refresh selectionSettings when update by setModel
        _refreshSelectionSettings: function (options, prop) {
            var proxy = this,
                model = proxy.model,
                isSelectionChanged = false;

            isSelectionChanged = !ej.isNullOrUndefined(options[prop].selectionType) || !ej.isNullOrUndefined(options[prop].selectionMode);

            if (prop == "selectionType") {
                model.selectionSettings.selectionType = options[prop];
                isSelectionChanged = true;
            }
            else if (prop == "selectionMode") {
                model.selectionSettings.selectionMode = options[prop];
                isSelectionChanged = true;
                if (model.showColumnChooser && model.showColumnOptions)
                    proxy.columnAddDialogTemplate();
            }
            else
                $.extend(model.selectionSettings, options[prop]);
                    

            var isCheckboxType = (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox &&
              model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row);

            // Unchecked all checked records
            if ((!ej.isNullOrUndefined(options[prop].enableHierarchySelection) && model.selectedItems.length > 0) ||
                    (!isCheckboxType && proxy._checkboxSelection)) {
                proxy._isFromSetmodel = true;
                proxy.selectAllRows(false);
                proxy._isFromSetmodel = false;
            }

            if (proxy._checkboxSelection || isCheckboxType) {
                proxy._checkboxSelection = isCheckboxType;

                proxy._processEditing();

                if ((!isCheckboxType && proxy._checkboxColumnName == "checkboxState") || 
                        (model.columns[0].nonColumn && proxy._checkboxColumnName != "checkboxState")) {
                    var treeGridIndexColumn = model.columns[model.treeColumnIndex];
                    if (model.columns[0]['isFrozen']) {
                        model.columns[0]['isFrozen'] = false;
                        proxy._frozenColumnsLength -= 1;
                        var index = proxy._frozenColumns.indexOf(model.columns[0]);
                        proxy._frozenColumns.splice(index, 1);
                        model.scrollSettings.frozenColumns = this._frozenColumnsLength;
                    }
                    model.columns.splice(0, 1);
                    if (treeGridIndexColumn)
                        model.treeColumnIndex = model.columns.indexOf(treeGridIndexColumn);
                }
                if (!proxy._checkboxSelection) proxy._checkboxColumnName = null;

                proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                proxy._setWidthToHeaders();
                if (model.allowFiltering)
                    proxy._resizeFilteringElements();
                if (isSelectionChanged) {
                    proxy._addInitTemplate();
                    this.renderRecords();
                }
                proxy.setWidthToColumns();
                proxy._updateScrollCss();
                proxy._updateHeaderScrollLeft();
                //Updating header checkbox state while render dynamically            
                if (model.selectedItems.length > 0)
                    proxy.selectAllRows();
            }
        },

        //#region RUNTIME UPDATE METHOD FOR TREEGRID
        //METHOD FOR UPDATE THE TREEGRID IN RUN TIME
        _setModel: function (options) {

            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            for (var prop in options) {

                switch (prop) {

                    case "enableAltRow":
                        model.enableAltRow = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        proxy._updateWrapRowHeights("header", "refreshAll");
                        break;
                    case "allowFiltering":
                        if (!model.allowFiltering && proxy._filteredColumnValueID.length > 0) {
                            proxy._clearAllFilter(proxy._filteredColumnValue);
                        }
                        model.allowFiltering = options[prop];
                        proxy._initiateSetModel();
                        model.allowFiltering = options[prop];
                        var scroller = proxy.getScrollElement().ejScroller("instance"),
                          left = scroller.scrollLeft(), totalSummaryHeight = 0,
                          top = scroller.scrollTop();
                        //Re render the grid header
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy._setWidthToHeaders();
                        if (model.showTotalSummary)
                            totalSummaryHeight = proxy.element.find('.e-footersummaryrowdiv').outerHeight();
                        $("#" + proxy._id).addClass('e-treegrid-overflow');
                        proxy._viewPortHeight = proxy.element.height() - (proxy._getNonContentHeight() + totalSummaryHeight);
                        $("#" + proxy._id).removeClass('e-treegrid-overflow');
                        if (proxy._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }
                        scroller.option("height", proxy._viewPortHeight);
                        if (model.enableVirtualization) {
                            var length = model.currentViewData.length,
                                rowHeight = model.rowHeight, isTopChanged;
                            rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                            if ((length * rowHeight) < proxy._viewPortHeight) {
                                if (length > 0) {
                                    top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                    if (top < 0)
                                        top = 0;
                                } else {
                                    proxy.processBindings();
                                    proxy.renderRecords();
                                }
                            }
                        }
                        //Update columnOptions fields
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy.columnAddDialogTemplate();
                        if (model.allowFiltering && model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                        //update the column width
                        this.setWidthToColumns();
                        scroller.scrollY(top, true);
                        scroller.scrollX(left, true);
                        proxy._updateHeaderScrollLeft(left);
                        proxy._updateScrollCss();
                        proxy._updateWrapRowHeights("row,total", "refreshAll");
                        break;
                    case "enableResize":
                        proxy.model.enableResize = options[prop];
                        if (model.enableResize) {
                            proxy._on($(window), "resize", proxy._windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy._windowResize);
                        }
                        break;

                    case "isResponsive":
                        proxy.model.isResponsive = options[prop];
                        if (model.isResponsive) {
                            proxy._on($(window), "resize", proxy._windowResize);
                            $("#" + proxy._id + "_toolbarItems").addClass("e-treegridadaptivetoolbar");
                            proxy._mediaQueryUpdate();
                            proxy._off(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                            proxy._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                        }
                        else {
                            proxy._off($(window), "resize", proxy._windowResize);
                            proxy._off(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));
                            $("#" + proxy._id + "_toolbarItems").removeClass("e-treegridadaptivetoolbar");
                            proxy._mediaQueryUpdate();
                        }
                        break;

                    case "enableVirtualization":
                        model.enableVirtualization = options[prop];
                        var previousRecord = proxy._prevSelectedItem,
                            selectedRecord = proxy.selectedRowIndex() && updatedRecords[proxy.selectedRowIndex()];
                        proxy.processBindings();
                        // change the table top position is 0 and change the update records for non-virtulization mode.
                        if (!model.enableVirtualization) {
                            if (this._frozenColumnsLength > 0) {
                                proxy._$frozenTableContent.css({
                                    "top": 0
                                });
                                proxy._$movableTableContent.css({
                                    "top": 0
                                });
                            } else {
                                proxy._$tableContent.css({
                                    "top": 0
                                });
                            }
                        }
                        selectedRecord && proxy.selectedRowIndex(updatedRecords.indexOf(selectedRecord));
                        var args = {};
                        args.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy.sendDataRenderingRequest(args);
                        proxy._updateWrapRowHeights(null,"refreshAll");
                        proxy._isRowEdit = model.isEdit = false;
                        proxy._cancelSaveTools();
                        proxy._clearColumnMenu();
                        proxy._clearContextMenu();
                        this._removeDetailsRow();
                        break;

                    case "allowColumnResize":
                        model.allowColumnResize = options[prop];
                        if (model.allowColumnResize)
                            proxy._resizer = new ej.gridFeatures.gridResize(proxy);
                        proxy._enableColumnResizeEvents();
                        break;

                    case "allowSorting":
                        model.allowSorting = options[prop];
                        proxy.sortSetting(options[prop]);
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy.columnAddDialogTemplate();
                        break;
                    case "allowPaging":
                        if (model.allowPaging) {                            
                            proxy.element.append(proxy._renderGridPager());
                            proxy.element.append(proxy.element.find(".e-pager").first());
                            proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
                            var scroller = proxy.getScrollElement().ejScroller("instance"),
                                left = scroller.scrollLeft(),
                                top = scroller.scrollTop();                            
                            proxy._viewPortHeight = proxy._getViewPortHeight();                            
                            if (model.showTotalSummary)
                                proxy._viewPortHeight -= proxy._$totalSummaryRowContainer.outerHeight();
                            if (proxy._frozenColumnsLength > 0)
                                proxy._$gridContent.css("height", proxy._viewPortHeight);
                            scroller.option("height", proxy._viewPortHeight);                            
                            scroller.scrollY(top, true);
                            scroller.scrollX(left, true);
                            proxy._pagerHeight = proxy.element.find(".e-pager").outerHeight();
                            proxy.gotoPage();                            
                        }
                        else {
                            var height = proxy.element.find(".e-pager").first().outerHeight();
                        proxy.element.find(".e-pager").first().remove();
                        proxy._viewPortHeight = proxy._viewPortHeight + height;
                        if (this._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }

                        proxy.getScrollElement().ejScroller({
                            height: proxy._viewPortHeight,//for border-width of gridcontent
                        });                            
                        if(model.pageSettings.totalRecordsCount > 0)
                            proxy._refreshDataSource();
                        else
                            proxy.refreshContent();
                        proxy.renderRecords();
                        proxy._isRefreshAddedRecord = false;
                }                
                        proxy._updateWrapRowHeights("header","refreshAll");
                        break;
                   
                    case "dragTooltip":
                        var tooltipValue = options[prop].tooltipItems;
                        if (tooltipValue && !$.isArray(tooltipValue)) {
                            tooltipValue = tooltipValue.length > 0 ? tooltipValue.split(",") : [];
                            options[prop].tooltipItems = tooltipValue;
                        }
                        $.extend(model.dragTooltip, options[prop]);
                        proxy._createDragTooltipTemplate();
                        proxy.refreshContent();
                        break;

                    case "allowDragAndDrop":
                        model.allowDragAndDrop = options[prop];
                        var matched = jQuery.uaMatch(navigator.userAgent);                                                
                        proxy.refreshContent();
                        break;

                    case "sortSettings":
                        $.extend(model.sortSettings, options[prop]);
                        proxy.refreshContent();
                        var refreshArgs = {};
                        refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy.sendDataRenderingRequest(refreshArgs);                       
                        break;

                    case "allowSelection":                      
                        model.allowSelection = options[prop];
                        if (!model.allowSelection) {
                            if (proxy._checkboxSelection && model.selectedItems.length > 0) {
                                proxy._isFromSetmodel = true;
                                proxy.selectAllRows(false);
                                proxy._isFromSetmodel = false;
                            }
                            proxy.clearSelection(-1);
                            proxy.selectedRowIndex(-1);
                            proxy.model.selectedItem = null;
                            proxy._cancelSaveTools();
                        }
                        break;

                    case "allowTextWrap":
                    case "headerTextOverflow":
                        if (prop == "allowTextWrap")
                            model.allowTextWrap = options[prop];
                        if (prop == "headerTextOverflow") {
                            model.headerTextOverflow = options[prop];
                            proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                            proxy.setWidthToColumns();
                            proxy.getScrollElement().ejScroller("refresh");
                            proxy._updateScrollCss();
                        }
                        if (prop == "allowTextWrap") {
                            proxy._addInitTemplate();
                            proxy.renderRecords(args);
                            if (proxy.model.showTotalSummary) {
                                proxy._createTotalSummaryRow();
                                proxy._setWidthToFooters();
                            }
                        }
                        proxy._updateWrapRowHeights(null,"refreshAll");
                        break;

                    case "selectionType":
                    case "selectionMode":
                    case "selectionSettings":
                        this._initiateSetModel();
                        proxy.clearAllSelection();
                        proxy._refreshSelectionSettings(options, prop);
                        if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && $("#" + proxy._id + "_selectionpopup").length == 0 && !proxy.model.isFromGantt) {
                            proxy._renderMultiSelectionIndicator();
                        }
                        break;
                    case "showSummaryRow":
                        model.showSummaryRow = options[prop];
                        if (model.showSummaryRow) {
                            proxy._createSummaryRow();
                            var refreshArgs = {};
                            refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                            proxy.sendDataRenderingRequest(refreshArgs);
                        }
                        else {
                            $(proxy.element).find(".e-summaryrow").hide();
                            model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords);
                            if (model.allowPaging) { 
                                proxy._updateCurrentViewData();
                                var refreshArgs = {};
                                refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                                proxy.sendDataRenderingRequest(refreshArgs);
                            }
                        }                       
                        proxy.updateCollapsedRecordCount();
                        proxy._updateWrapRowHeights("header");
                        proxy.updateHeight();
                        if (model.allowTextWrap || model.headerTextOverflow == "wrap") {
                            proxy._updateGridContentHeight();
                        }
                        break;
                    case "showTotalSummary":
                        model.showTotalSummary = options[prop];
                        if (model.showTotalSummary) {
                            proxy._createTotalSummaryRow();
                            proxy._setWidthToFooters();
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                            proxy._viewPortHeight -= $(proxy._$totalSummaryRowContainer).height();
                        }
                        else {
                            $(proxy.element).find(".e-footersummaryrowdiv").remove();
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                        }

                        var scroller = proxy.getScrollElement().ejScroller("instance"),
                            left = scroller.scrollLeft(),
                            top = scroller.scrollTop();
                        if (proxy._frozenColumnsLength > 0) {
                            proxy._$gridContent.css("height", proxy._viewPortHeight);
                        }
                        scroller.option("height", proxy._viewPortHeight);
                        if (model.enableVirtualization) {
                            var length = model.currentViewData.length,
                                rowHeight = model.rowHeight;
                            rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                            if ((length * rowHeight) < proxy._viewPortHeight) {
                                if (length > 0) {
                                    top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                    if (top < 0)
                                        top = 0;
                                } else {
                                    proxy.processBindings();
                                    proxy.renderRecords();
                                }
                            }
                        }
                        scroller.scrollY(top, true);
                        scroller.scrollX(left, true);
                        proxy._updateHeaderScrollLeft(left);
                        proxy._updateScrollCss();
                        proxy._updateWrapRowHeights("header", "refreshAll");
                        break;
                    case "selectedRowIndex":
                        if (!this.isEdit && !this._isRowEdit) {
                            if (this.selectedRowIndex() >= 0
                                && !ej.isNullOrUndefined(this.selectedRowIndex()) && model.allowSelection && updatedRecords.length > this.selectedRowIndex()
                                && this.getExpandStatus(updatedRecords[this.selectedRowIndex()])) {
                                var index = this.selectedRowIndex();
                                if (!proxy._rowSelectingEventTrigger(this._previousIndex, index)) {
                                    if (model.showSummaryRow) {
                                        var recordsWithOutSummary = proxy._spliceSummaryRows(model.updatedRecords),
                                            currentSelectedRecord = recordsWithOutSummary[index];
                                        index = updatedRecords.indexOf(currentSelectedRecord);
                                    }
                                    proxy.selectRows(index);
                                    proxy._rowSelectedEventTrigger(index);
                                }
                            } else {
                                proxy.clearSelection(-1);
                                proxy.selectedRowIndex(-1);
                                proxy.model.selectedItem = null;
                                proxy._previousIndex = -1;
                            }
                            proxy._cancelSaveTools();
                        } else {
                            this.selectedRowIndex(updatedRecords.indexOf(proxy._prevSelectedItem));
                        }
                        break;
                    case "selectedCellIndexes":
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell") {                            
                            proxy.selectCells(options[prop]);                            
                        }
                        break;
                    case "editSettings":
                        $.extend(model.editSettings, options[prop]);
                        proxy._processEditing();
                        proxy._enableEditingEvents();
                        proxy._updateToolbarItems();
                        break;

                    case "allowKeyboardNavigation":
                        model.allowKeyboardNavigation = options[prop];
                        break;

                    case "dataSource":
                        if (!proxy._isRowEdit && !proxy.model.isEdit) {
                            proxy._fieldNamesToQuery = [];
                            proxy._assignedIdCollections = [];
                            proxy._assignedParendIDs = [];
                            proxy._refreshDataSource();
                        }
                        break;

                    case "columns":
                        model.columns = options[prop].slice(0);
                        proxy._validateColumnFields();
                        proxy._validateColumnVisible(true);
                        proxy._refreshFrozenColumns();
                        proxy._updateWrapRowHeights(null, "refreshAll");
                        break;
                    
                    case "rowHeight":
                        model.rowHeight = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        proxy.updateHeight();
                        break;

                    case "treeColumnIndex":
                        proxy.columnIndex(options[prop]);
                        break;

                    case "showColumnChooser":
                        model.showColumnChooser = options[prop];
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.setWidthToColumns();
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        if (!model.showColumnChooser){
                            proxy._clearColumnMenu();
                            $("#" + proxy._id + "ccDiv_wrapper").remove();
                            $("#" + proxy._id + "filterMenu_wrapper").remove();
                        }
                        else {
                            proxy._renderColumnChooser();
                            if(model.allowFiltering && model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                        }
                        proxy._updateWrapRowHeights("row,total", "refreshAll");
                        /*Add empty column in gantt*/
                        if (model.isFromGantt) {
                            proxy._addEmptyColumntoGrid();
                            this._updateHeaderScrollLeft(this.getScrollElement().ejScroller("model.scrollLeft"));
                        }
                        break;
                    case "showColumnOptions":
                        model.showColumnOptions = options[prop];
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.setWidthToColumns();
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        if (model.showColumnChooser && model.showColumnOptions) {
                            proxy.columnAddDialogTemplate();
                            proxy._renderUpdateConfirmDialog();
                        }
                        else {
                            proxy._clearColumnMenu();
                            $("#" + proxy._id + "ccDiv_wrapper").remove();
                            $("#" + proxy._id + "filterMenu_wrapper").remove();
                        }
                        proxy._updateWrapRowHeights("row,total", "refreshAll");
                        /*Add empty column in gantt*/
                        if (model.isFromGantt) {
                            proxy._addEmptyColumntoGrid();
                        }
                        break;
                    case "locale":
                        proxy._clearContextMenu();
                        proxy._clearColumnMenu();
                        proxy._removeDetailsRow();
                        model.locale = options[prop];
                        proxy._setCultureInfo();
                        proxy._processEditing();
                        proxy._addInitTemplate();
                        proxy.refreshContent();
                        //Re render the grid header(for updating filtering elements also) and content
                        proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                        proxy.renderRecords(args);
                        proxy.setWidthToColumns();
                        // Update the scrollbar
                        proxy.getScrollElement().ejScroller("refresh");
                        proxy._updateScrollCss();
                        // Update the column chooser
                        if (model.showColumnChooser)
                            proxy._renderColumnChooserList(true);
                        // Update the toolbar
                        if (model.toolbarSettings.showToolbar)
                            proxy._updateToolbar();
                        if (model.allowPaging)
                            proxy.getPager().ejPager("option", options[prop]).ejPager("refreshPager");
                        if (proxy.model.showColumnChooser && proxy.model.showColumnOptions) {
                            proxy.columnAddDialogTemplate();
                            proxy._renderUpdateConfirmDialog();
                        }
                        if (model.allowFiltering && model.filterSettings.filterType == "menu")
                            proxy._renderFilterMenu();
                        proxy._updateWrapRowHeights(null,"refreshAll");
                        break;
                    case "toolbarSettings": 
                        $.extend(proxy.model.toolbarSettings, options[prop]);
                        proxy._updateToolbar();
                        proxy._updateWrapRowHeights("header","refreshAll");
                        break;
                    case "contextMenuSettings":
                        $.extend(proxy.model.contextMenuSettings, options[prop]);
                        if (!model.contextMenuSettings.showContextMenu)
                            proxy._clearContextMenu();
                        this._removeDetailsRow();
                        break;
                    case "enableCollapseAll":
                        model.enableCollapseAll = options[prop];
                        if (model.enableCollapseAll)
                            proxy.collapseAll();
                        else
                            proxy.expandAll();
                        break;
                    case "showDetailsRow":
                        model.showDetailsRow = options[prop];
                        this._updateDetailsRowProperties("showDetailsRow");
                        break;
                    case "detailsRowHeight":
                        model.detailsRowHeight = options[prop];
                        this._updateDetailsRowProperties("detailsRowHeight");
                        break;
                    case "detailsTemplate":
                        model.detailsTemplate = options[prop];
                        this._updateDetailsRowProperties("detailsTemplate");
                        break;
                    case "showDetailsRowInfoColumn":
                        model.showDetailsRowInfoColumn = options[prop];
                        this._updateDetailsRowProperties("showDetailsRowInfoColumn");
                        break;
                    case "altRowTemplateID":
                        this._initiateSetModel();
                        model.altRowTemplateID = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        proxy._updateWrapRowHeights("header");
                        this.updateHeight();
                        if (model.allowTextWrap || model.headerTextOverflow == "wrap") {
                            proxy._updateGridContentHeight();
                        }
                        break;
                    case "rowTemplateID":
                        this._initiateSetModel();
                        model.rowTemplateID = options[prop];
                        proxy._addInitTemplate();
                        proxy.renderRecords(args);
                        proxy._updateWrapRowHeights("header");
                        this.updateHeight();
                        if (model.allowTextWrap || model.headerTextOverflow == "wrap") {
                            proxy._updateGridContentHeight();
                        }
                        break;
                    case "pageSettings":
                        this._initiateSetModel();
                        if (model.allowPaging) {
                            $.extend(model.pageSettings, options[prop]);
                            this.getPager().ejPager("option", model.pageSettings).ejPager("refreshPager");
                            if (options[prop].totalRecordsCount > 0) {
                                proxy._refreshDataSource();
                            }
                                else
                                    proxy.gotoPage();
                            }
                        break;
                    case "sizeSettings":
                        this._initiateSetModel();
                        $.extend(model.sizeSettings, options[prop]);

                        this._calculateDimensions();
                        if (this._getViewPortHeight() <= 0) {
                            model.sizeSettings.height = "450px";
                            this._updateElementHeight();
                        }
                        this._windowResize();
                        break;
                    case "readOnly":
                        model.readOnly = options[prop];
                        break;
                    case "showGridCellTooltip":
                        model.showGridCellTooltip = options[prop];
                        break;

                    case "showGridExpandCellTooltip":
                        model.showGridExpandCellTooltip = options[prop];
                        break;

                    case "allowMultiSorting":
                        model.allowMultiSorting = options[prop];
                        break;

                    case "query":
                        if (!ej.isNullOrUndefined(options[prop]))
                            model.query = options[prop];
                        else
                            model.query = ej.Query();
                        proxy._refreshDataSource();
                        break;
                    case "filterSettings":
                        if (model.allowFiltering) {
                            if (!options.filterSettings.filterType && model.filterSettings.filterType == "filterbar") {
                            var filterSettings,
                                filterBarMode, args = {};
                            $.extend(proxy.model.filterSettings, options[prop]);
                            filterSettings = proxy.model.filterSettings;
                            filterBarMode = ej.isNullOrUndefined(filterSettings.filterBarMode) ? "immediate" : filterSettings.filterBarMode;
                            // Get the filteredColumn value before going to clear the filter columns
                            var newFilterColumn = $.extend([], filterSettings.filteredColumns);

                            for (var column = 0; column < model.columns.length; column++) {
                                if (model.columns[column].allowFiltering)
                                proxy._clearFilterElementValue(model.columns[column]);
                            }

                            filterSettings.filteredColumns = newFilterColumn;
                            filterSettings.filterBarMode = filterBarMode;
                            args.requestType = "filtering";

                            for (var i = 0; i < newFilterColumn.length; i++)
                                $("#" + proxy._id + "_" + newFilterColumn[i].field.split('.').join("") + "_filterbarcell").val(newFilterColumn[i].value);
                            //Render the record with sorting and filtering
                            proxy._ensureDataSource(args);
                            proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                            proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
                            //Method binding for filtering data.
                            if (filterBarMode == "immediate") {
                                proxy._on(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._on(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
                            }
                            } else if (options.filterSettings.filterType) {
                            model.allowFiltering = true;
                            $.extend(proxy.model.filterSettings, options[prop]);
                            proxy._initiateSetModel();
                            var scroller = proxy.getScrollElement().ejScroller("instance"),
                              left = scroller.scrollLeft(),
                              top = scroller.scrollTop();
                            //Re render the grid header
                            proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                            proxy._setWidthToHeaders();
                            $("#" + proxy._id).addClass('e-treegrid-overflow');
                            proxy._viewPortHeight = proxy._getViewPortHeight();
                            $("#" + proxy._id).removeClass('e-treegrid-overflow');
                            if (model.filterSettings.filterType == "menu" && proxy._renderedFilterMenuDialog.length == 0)
                            proxy._renderFilterMenu();
                            if (proxy._frozenColumnsLength > 0) {
                                proxy._$gridContent.css("height", proxy._viewPortHeight);
                            }
                            scroller.option("height", proxy._viewPortHeight);
                            if (model.enableVirtualization) {
                                var length = model.currentViewData.length,
                                    rowHeight = model.rowHeight, isTopChanged;
                                rowHeight += (model.showDetailsRow && !model.showDetailsRowInfoColumn) ? model.detailsRowHeight : 0;
                                if ((length * rowHeight) < proxy._viewPortHeight) {
                                    if (length > 0) {
                                        top = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                                        if (top < 0)
                                            top = 0;
                                    } else {
                                        proxy.processBindings();
                                        proxy.renderRecords();
                                    }
                                }
                            }
                            //Update columnOptions fields
                            if (model.showColumnChooser && model.showColumnOptions)
                                proxy.columnAddDialogTemplate();
                            //update the column width
                            this.setWidthToColumns();
                            scroller.scrollY(top, true);
                            scroller.scrollX(left, true);
                            proxy._updateHeaderScrollLeft(left);
                            proxy._updateScrollCss();

                            }                            
                            proxy._updateWrapRowHeights("row,total", "refreshAll");
                        }
                        break;
                    case "columnResizeSettings":
                        var $headerTable, $contentTable, $totalSummaryTable;
                        this._initiateSetModel();
                        $.extend(model.columnResizeSettings, options[prop]);
                        this._updateGridResizeSettings();
                        var columnResizeMode = model.columnResizeSettings.columnResizeMode;
                        if (columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns) {
                            this._updateTableWidth();
                        } else {
                            if (this._frozenColumnsLength > 0) {
                                $headerTable = $(this.getHeaderTable()[1]);
                                $contentTable = $(this.getContentTable()[1]);
                                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[1]) : null;
                            } else {
                                $headerTable = this.getHeaderTable();
                                $contentTable = this.getContentTable();
                                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[0]) : null;
                            }
                            //set width to 100% for all tables in treegrid in normal resize mode
                            $headerTable.css("width", "").removeClass("e-tableLastCell");
                            $contentTable.css("width", "").removeClass("e-tableLastCell");
                            $totalSummaryTable && $totalSummaryTable.css("width", "").removeClass("e-tableLastCell");
                        }
                        this._updateScrollCss();
                        break;
                    case "cssClass":
                        this.element.removeClass(proxy._cssClass).addClass(options[prop]);
                        this.model.allowPaging && ($("#" + this._id + "Pager").ejPager("model.cssClass", options[prop]));
                        model.toolbarSettings.showToolbar && ($("#" + proxy._id + "_toolbarItems").ejToolbar("model.cssClass", options[prop]));
                        if (proxy._updateConfirmDialog) {
                            proxy._updateConfirmDialog.data("ejDialog") && proxy._updateConfirmDialog.ejDialog("model.cssClass", options[prop]);
                        }
                        for (var count = 0; count < proxy._renderedFilterMenuDialog.length; count++) {
                            if (proxy._renderedFilterMenuDialog[count] == "stringedit") {
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterStringMenuDiv_wrapper").find(".e-autocomplete").ejAutocomplete("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "numericedit") {
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterNumericMenuDiv_wrapper").find(".e-numerictextbox").ejNumericTextbox("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "datepicker") {
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatepickerMenuDiv_wrapper").find(".e-datepicker").ejDatePicker("model.cssClass", options[prop]);
                            }
                            else if (proxy._renderedFilterMenuDialog[count] == "datetimepicker") {
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDatetimePickerMenuDiv_wrapper").find(".e-datetimepicker").ejDateTimePicker("model.cssClass", options[prop]);
                            }
                            else if ("#" + proxy._renderedFilterMenuDialog[count] == "dropdownedit") {
                                $("#" + this._id + "filterDropdownMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterDropdownMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                            }
                            else if ("#" + proxy._renderedFilterMenuDialog[count] == "booleanedit") {
                                $("#" + this._id + "filterBooleanMenuDiv_wrapper").find(".e-dropdownlist").ejDropDownList("model.cssClass", options[prop]);
                                $("#" + this._id + "filterBooleanMenuDiv_wrapper").find(".e-button").ejButton("model.cssClass", options[prop]);
                            }
                        }
                        this.columnAddDialogTemplate();
                        $("#" + proxy._id + 'ConfirmDialog_wrapper').find(".e-button").ejButton("model.cssClass", options[prop]);
                        if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")) {
                            proxy._treeGridAddEditDialog();
                        } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")) {
                            proxy._treeGridAddEditDialogTemplate();
                        }
                        if (model.showColumnChooser)
                            this._renderColumnChooserList(true);
                        proxy._cssClass = options[prop];
                        break;
                    case "enableLoadOnDemand":
                        model.enableLoadOnDemand = options[prop];
                        proxy._refreshDataSource();
                        break;
                }
            }
        },
        /* clear contextMenu, columnChooser, detailsTemplate and save edited item before change
        property by setModel*/
        _initiateSetModel: function ()
        {
            var model = this.model;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }

            this._clearContextMenu();
            this._clearColumnMenu();
            this._removeDetailsRow();
        },
        /* update the tree grid control as per new detailsRow fetaures API values by setModel */
        _updateDetailsRowProperties: function (property) {

            var proxy = this,
                model = this.model;

            /* cance edited cell or row */
            if(model.isEdit || this._isRowEdit){
                this.cancelRowEditCell();
                this._cancelSaveTools();
            }
            /* clear columnchooser menu and contextmenu and detail wrapper */
            this.clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
             
            /* update the detailsRowHeight private property */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                proxy._detailsRowHeight = model.detailsRowHeight;
            } else {
                proxy._detailsRowHeight = 0;
            }

            /* update the details expand status as per details feture API values */
            model.flatRecords.forEach(function (record) {
                if (model.showDetailsRow && model.detailsTemplate) {
                    record.isDetailsExpanded = model.showDetailsRowInfoColumn ? false : true;
                } else {
                    record.isDetailsExpanded = false;
                }
            });
            
            /* update the tree grid control as per new detailsRow API's */
            if ((property == "detailsTemplate" || property == "detailsRowHeight") && model.showDetailsRowInfoColumn) {
                proxy._addInitTemplate();
            } else {
                proxy._$gridHeaderContent.replaceWith(proxy._renderGridHeader());
                proxy._addInitTemplate();
                /* while changing details row features API scroll top is assigned to beacause of rowHeight changes*/
                this.onScrollHelper(0);
                proxy.refreshContent();

                /* for details rows detailsDataBound event can be called after the width update of column */
                proxy._isRendered = false;
                //Rerendering the content of the tree grid
                var refreshArgs = {};
                refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.sendDataRenderingRequest(refreshArgs);
                proxy.setWidthToColumns();
                proxy._isRendered = true;
                proxy._trigger("refresh");
                /* trigger queryCellInfo ,detailsDataBoundEvent after update the width of the columns */
                this._eventBindings();
                this._hideCollapsedDetailsRows();

                proxy.getScrollElement().ejScroller("refresh");
                proxy._updateScrollCss();
            }
            proxy._updateWrapRowHeights(null,"refreshAll");
        },
        /* hide the collapsed state detail rows for prevent alignement issue for rendering sf control in  display none state*/
        _hideCollapsedDetailsRows:function()
        {
            var proxy = this, model = this.model;
            /* Collapse hidden expanded details rows */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                if (this._frozenColumnsLength > 0)
                    $(proxy.getTreeGridRows()[0]).add(proxy.getTreeGridRows()[1]).filter("tr.e-collapsedrowexpandeddetailsrow").css("display", "none");
                else
                    $(proxy.getTreeGridRows()).filter("tr.e-collapsedrowexpandeddetailsrow").css("display", "none");
            }
        },
        _updateToolbar: function () {
            var proxy = this,
                model = proxy.model,
                scroller = proxy.getScrollElement().ejScroller("instance"),
                           left = scroller.scrollLeft(),
                           top = scroller.scrollTop();
            //$.extend(proxy.model.toolbarSettings, options[prop]);
            $("#" + proxy._id + "_toolbarItems").remove();
            $("#" + proxy._id + "_toolbarItems_Main").remove();
            if (model.toolbarSettings.showToolbar)
                proxy._renderToolbarTemplate().insertBefore($("#" + proxy._id + "e-gridheader"));
            if (model.isEdit)
                proxy.cancelEditCell();
            if (proxy._isRowEdit) {
                proxy.cancelRowEditCell();
                proxy._cancelSaveTools();
            }
            proxy._viewPortHeight = proxy._getViewPortHeight();
            if (proxy._frozenColumnsLength > 0) {
                proxy._$gridContent.css("height", proxy._viewPortHeight);
            }
            scroller.option("height", proxy._viewPortHeight);
            if (model.enableVirtualization) {
                proxy.processBindings();
                proxy.renderRecords();
            }
            scroller.option("scrollTop", top);
            scroller.option("scrollLeft", left);
            proxy._clearContextMenu();
            this._removeDetailsRow();

        },
        //refresh data source on set model     
        _refreshDataSource: function ()
        {
            var proxy = this, model = this.model, args;
            //Cancelling the editable state of the row
            if (proxy._isRowEdit || proxy.model.isEdit) {
                proxy.cancelRowEditCell();
            }
            proxy.resetModelCollections();
            proxy._createdAt = "load";
            if (this.dataSource() instanceof ej.DataManager || this.dataSource()) {
                proxy._isForDataSourceRefresh = true;
                proxy._initDatasource();               
            }           
            else if (this.dataSource() == null) {
                args = {};
                args["requestType"] = ej.TreeGrid.Actions.RefreshDataSource;
                proxy._ensureDataSource(args);
                proxy._createdAt = null;
            }
            $(".e-tooltiptable").remove();
            if(model.showSummaryRow || model.showTotalSummary)
                proxy._summaryRow();
        },
        //REFRESH THE TREEGRIDCONTENT
        refreshContent: function () {

            var proxy = this,
                args = {};     
            args.requestType = ej.TreeGrid.Actions.Refresh;
            proxy.processBindings(args);
        },


        //RESET THE COLLECTIONS WHILE CHANGING THE DATASOURCE
       
        resetModelCollections: function () {

            var proxy = this,
            model = proxy.model;

            // model.sortSettings.sortedColumns = [];
            model.currentViewData = [];
            model.flatRecords = [];
            model.parentRecords = [];
            model.updatedRecords = [];
            model.summaryRowRecords = [];
            model.ids = [];
            proxy.secondaryDatasource = [];
            proxy._parentRecords = [];
            proxy._storedIndex = -1;
            proxy._idGenerator = -1; //unique id only use for treegrid
            proxy._taskIds = [];
            proxy._jsonData = null;
            proxy._lastInsertedId = -1;
        },        

        //#endregion

        //DECLARE THE PRIVATE VARIABLES
        _initPrivateProperties: function () {

            var proxy = this,
                model = this.model;

            proxy._id = proxy.element.attr("id"),
            proxy.columnsWidthCollection = [],
            proxy._cSortedColumn = null,
            proxy._taskIds=[],
            proxy._maxZIndex=0,
            proxy._cSortedDirection = null,
            proxy._dataManager = null,
            proxy._filteredRecords = [],
            proxy._disabledToolItems = [],
            proxy._currentFilterColumn = [],
            proxy._fieldColumnNames = [],
            proxy._multiSortRequest = null,
            proxy._$gridContainer = null,
            proxy._$gridContent = null,
            proxy._$gridContentTable = null,
            proxy._$gridHeaderTable = null,
            proxy._$gridHeaderContainer = null,
            proxy._$totalSummaryRowContainer = null,
            proxy._recordsCount = null,
            proxy._$gridRows = null,
            proxy._gridRows = null,
            proxy._commandColumnLength = 0,
            this._frozenColumnsLength = 0,
            proxy._initFrozenColumns(),
            proxy._allowFreezingDefault = this._frozenColumnsLength > 0 ? true : false;
            proxy._calculateDimensions(),
            proxy._headerColumnNames = [],
            proxy._hiddenColumns = [],
            proxy._multiSelectCtrlRequest = false,
            proxy._multiSelectShiftRequest = false,
            proxy._offset = 0,
            proxy._previousIndex = -1,
            proxy._prevRBottom = 0,
            proxy._prevRTop = 0,
            proxy._prevScrollTop = 0,
            proxy._prevScrollLeft = 0,
            proxy._prevVBottom = 0,
            proxy._resizer = null,
            proxy._scrollTop = 0,
            proxy._scrollLeft = 0,
            proxy._searchString = "",
            proxy._fieldName = "",
            proxy._selectedCellsinARow = [],
            proxy._currentRecordIndex = -1,
            proxy._sortedRecords = [],
            proxy._storedIndex = -1,
            proxy._rowIndex = -1,
            proxy._$tableContent = null,
            proxy._$footertableContent = null,
             proxy._$footerContainer = null,
            proxy._tempsortedrecords = [],
            proxy._totalHeight = 0,
            proxy._viewPortHeight = 0,
            proxy._recordIndexCount = 0,
            proxy._totalCollapsedRecordCount = 0,
            proxy._visibleColumns = [],
            proxy._visibleRange = null,
            proxy._vScrollDir = 1,
            proxy._vScrollDist = 0,
            proxy._cellEditTemplate = $(),
            proxy._tooltipTimer,
            proxy._totalBorderWidth = 2;//left and right border width
            proxy._totalBorderHeight = 1;
            proxy._toolboxTooltipTexts = null;
            proxy._contextMenuTexts = null;
            proxy._columnMenuTexts = null;
            proxy._deleteColumnText = null;
            proxy._okButtonText = null;
            proxy._cancelButtonText = null;
            proxy._confirmDeleteText = null;
            proxy._dropDownListBlanksText = null;
            proxy._editTypeText = null;
            proxy._textAlignType = null;
            proxy._clipMode = null;
            proxy._dropDownListClearText = null;
            proxy._trueText = null;
            proxy._falseText = null;
            proxy._rowDragIndexes = [];
            proxy._dropCancel = false;
            proxy._cellEditingDetails = {
                cellValue: null,
                rowIndex: -1,
                columnIndex: -1,
                fieldName: null,
                _data: null,
                cellEditType: "",
                cancelSave: false,
                defaultData: null,
                insertedTrCollection: [],
                data: null
            },
           proxy._previousSelectedCellDetails = {
               rowElement: null,
               cellElement: null,
               cellIndex: -1,
               rowIndex: -1,
           },
           proxy._shiftKeyFirstElementDetails = {
               firstElementRowIndex: -1,
               firstElementCellIndex: -1
           },
            proxy._selectedCellDetails = [];
            proxy._focusingRowIndex = -1,
            proxy._rowIndexOfLastSelectedCell = -1,
            proxy._lastSelectedCellIndex = -1,
            proxy._isEnterKeyPressed = false,
            proxy._isShiftKeyNavigation = false;
            proxy._scrollBarHeight = 18,
            proxy._removedCount = 0,
            proxy._$gridHeaderContent = null,
            proxy.secondaryDatasource = [],
            //variables for context menu items
            proxy._contextMenuItems = null;
            proxy._subContextMenuItems = null;
           
            proxy._createContextMenuTemplate();
            proxy._createColumnMenuTemplate();
            proxy._retrivedData = this.dataSource();
            proxy._createdAt = "load";
            proxy._isInExpandCollapseAll = false;
            proxy._isLoadonDemand = false;
            proxy._assignedIdCollections = [];
            proxy._totalItemCounts = null;
            proxy._assignedParendIDs = [];
            proxy._fieldNamesToQuery = [];
            proxy._isForDataSourceRefresh = false;
            proxy._allParentItems = [];
            proxy._queryForLoadonDemand = [];
            proxy._pageRecordCountOnDemand = null;
            proxy._isFromDemandMethod = false;                        
            proxy._dataManager = proxy.dataSource() instanceof ej.DataManager ? proxy.dataSource() :
                proxy.dataSource() != null ? ej.DataManager(proxy.dataSource()) : null;
            proxy._dragMouseDown = false;
            proxy._dragTooltip = false;
            proxy._dragMouseLeave = false;
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            /* Check data manger is updatable */ 
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            /* flag for refreshing newly added record */
            proxy._isRefreshAddedRecord = false;
            /* Used as flag for refresh chart and grid rows on adding when parent item is in collpased state*/
            proxy._isInAdd = false;         
            /* get unique index for tree grid add whil add */
            proxy._maxRowIndex = 0;
           /* used to check treegrid rendering is completed on load time*/
            proxy._isRendered = false;
            this._updateGridResizeSettings();
            proxy._isSummaryRow = false;
            proxy._flatChildRecords = [];
            proxy._footerSummaryRecord = [];
            proxy._filteredChildRecords = [];
            proxy._parentRecords = [];
            proxy._zerothLevelParentRecords = [];
            proxy._detailsRowHeight = 0;
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
            {
                proxy._detailsRowHeight = model.detailsRowHeight;
            }
            proxy._isEmptyRow = false;            
            proxy._prevSelectedItem = null;
            proxy._dataSourcefields = [];
            proxy._columnDialogTexts = null;
            proxy._columnDialogTitle = null;
            proxy._addColumnFields = [];
            proxy._addColumnFieldsTxt = [];
            proxy._targetColumnIndex = 0;
            proxy._insertPosition = null;
            proxy._updateconfirmDialog = null;
            proxy._columnRenameDialog = null;
            proxy._renderedSubMenuType = null;
            proxy.localizedLabels = proxy._getLocalizedLabels();
            proxy._gridRecordsCount = model.pageSettings.totalRecordsCount;                            
            proxy._gridPager = null;
            proxy._summaryRowsCount = 0;                                 
            proxy._updatedPageData = [];
            proxy._isNextPage = false;
            model.selectionSettings.selectionType = model.selectionSettings.selectionType != "single" ? model.selectionSettings.selectionType :
                    model.selectionType != "single" ? model.selectionType : model.selectionSettings.selectionType;
            model.selectionSettings.selectionMode = model.selectionSettings.selectionMode != "row" ? model.selectionSettings.selectionMode :
                    model.selectionMode != "row" ? model.selectionMode : model.selectionSettings.selectionMode;
            proxy._idGenerator = -1;
            proxy._checkboxColumnName = null;
            proxy._isFromSetmodel = false;
            proxy._flatFilteredRecords = [];
            proxy._checkboxSelection = (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox && 
                model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row),            
            proxy._addCheckboxColumn = this._getDefaultCheckboxColumn(),
            proxy._filteredColumnValue = [];
            proxy._filteredColumnValueID = [];
            proxy._filterIconTarget = null;
            proxy._renderedFilterMenuDialog = [];
            proxy._filtermenutext = null;
            proxy._headerDragStatus = "";
            proxy._draggedColumn = null;
            proxy._mouseDragged = false;
            if (!ej.isNullOrUndefined(model.indentLevelWidth) && model.isFromGantt)
                proxy.treeIndentLevelWidth = model.indentLevelWidth;
            else
                proxy.treeIndentLevelWidth =  proxy.treeIndentLevelWidth ? proxy.treeIndentLevelWidth : 10;
            proxy._draggedColumnTemplate = null;
            proxy._viewPortWidth = proxy._gridLeft = 0;            
            proxy._responsiveMinWidth = 768;
            proxy._dy = proxy._dx = 0;
            proxy._isTouchEvent = false;
            proxy._isTouchTrigger = false;
            proxy._currentEditRecordDialogIndex = -1;
            proxy._isTreeAddEditDialogSave = false;
            proxy._displayContextMenu = model.contextMenuSettings.showContextMenu ? true : false;
            proxy._isEmptyRowDeleted = false;
            proxy._cssClass = this.model.cssClass;
            proxy._autoHideColumns = [];
            proxy._autoShowColumns = [];
            proxy._textWrapRowsDatas = [];
            proxy._textWrapNoCalculate = false;
            proxy._isRemoteData = false;
            proxy._lastInsertedId = -1;
        },
        //Return default check box selection column obect
        _getDefaultCheckboxColumn: function () {
            return {
                field: "checkboxState",
                headerText: "",
                allowEditing: false,
                allowDelete: false,
                allowSorting: false,
                allowFiltering: false,
                allowCellSelection: false,
                isFrozen: false,
                nonColumn:true,
                editType: "booleanedit",
                width: 50,
                textAlign:"center"
            };
        },
        //update columnResizeSettings API to grid resizeSettings API
        _updateGridResizeSettings: function () {
            var resizeSettings = {
                resizeMode: (this.model.columnResizeSettings.columnResizeMode == "fixedcolumns" ? "control" : this.model.columnResizeSettings.columnResizeMode)
            };
            this.model.resizeSettings = resizeSettings;
        },
        //set size to treegrid core by user values
        _calculateDimensions: function ()
        {
            var proxy = this, model = this.model;

            if (!model.isFromGantt) {
                if (model.sizeSettings.width)
                    proxy.element.css("width", model.sizeSettings.width);

                if (model.sizeSettings.height)
                    proxy.element.css("height", model.sizeSettings.height);
                else
                {
                    if (!proxy.element[0].style.height) {
                        proxy.element.height(450);
                    }
                    else
                        model.sizeSettings.height = proxy.element[0].style.height;
                }
            }
            proxy._gridHeight = Math.round(proxy.element.height());
            proxy._gridWidth = Math.round(proxy.element.width());

            if (this._frozenColumnsLength > 0) {
                var frozenWidth = 0;
                for (var count = 0; count <= this._frozenColumnsLength; count++) {
                    if (model.columns[count])
                        frozenWidth += ej.isNullOrUndefined(model.columns[count].width) ? 150 : parseInt(model.columns[count].width);
                }
                if (proxy._gridWidth < frozenWidth) {
                    proxy.element.css("width", frozenWidth);
                    model.sizeSettings.width = proxy._gridWidth = frozenWidth;
                }
            }
        },

        /* Reordering and initialize frozen and unfrozen columns*/
        _initFrozenColumns: function ()
        {
            var frozen = [], unfrozen = [], visibleFrozenColumns = 0, visibleUnfrozenColumns = 0,
                model = this.model, columns = model.columns, treeColumn;
            treeColumn = columns[model.treeColumnIndex];
            for (var columnCount = 0; columnCount < columns.length; columnCount++) {
                if (columns[columnCount]["isFrozen"] === true) {
                    frozen.push(columns[columnCount]);
                    if (ej.isNullOrUndefined(columns[columnCount].visible) || columns[columnCount].visible)
                        visibleFrozenColumns += 1;
                }
                else {
                    unfrozen.push(columns[columnCount]);
                    if (ej.isNullOrUndefined(columns[columnCount].visible) || columns[columnCount].visible)
                        visibleUnfrozenColumns += 1;
                }
            }
            if (frozen.length > 0) {
                /*one column must be in un frozen state*/
                if (model.columns.length && model.columns.length == frozen.length) {
                    unfrozen = frozen.splice(frozen.length - 1, 1);
                    unfrozen[0].isFrozen = false;
                }
                model.columns = $.merge($.merge([], frozen), unfrozen);
            }
            this._frozenColumns = frozen;
            this._unFrozenColumns = unfrozen;
            /*Update minimum number of column to visible*/
            if (visibleFrozenColumns == 0 && this._frozenColumns[0])
                this._frozenColumns[0].visible = true;
            if (visibleUnfrozenColumns == 0 && this._unFrozenColumns[0])
                this._unFrozenColumns[0].visible = true;
            if (treeColumn)
                model.treeColumnIndex = model.columns.indexOf(treeColumn);

            this._frozenColumnsLength = frozen.length;
            model.scrollSettings.frozenColumns = this._frozenColumnsLength;
        },
        //update altrow when enableCollapseAll enabled.
        updateAltRowOnCollapseAll: function () {
            var proxy=this, model=proxy.model;
            if (model.enableAltRow && model.enableCollapseAll) {
                var records = model.parentRecords,
                    record;
                for (var count = 0; count < records.length; count++) {
                    record = records[count];
                    if (record.isSummaryRow)
                        continue;
                    record.isAltRow = count % 2 == 0 ? false : true;
                }
            }
        },
        //update altrow when expandStateMapping is defined.
        updateAltRowOnRendering: function () {
            var proxy = this, model = proxy.model;           
            var records = model.updatedRecords.filter(function (record) {
                if (record.parentItem == null)
                    return record;
                else if (record.parentItem.expanded)
                    return record;
            });
            for (var count = 0; count < records.length; count++) {
                var record = records[count];
                if (record.isSummaryRow)
                    continue;
                record.isAltRow = count % 2 == 0 ? false : true;
            }            
        },
        //DATASOURCE CHECKING
        _checkDataBinding: function () {

            var proxy = this,
                model = proxy.model;
            $("#" + proxy._id).addClass('e-treegrid-overflow');
            proxy._createdAt = null;
            proxy.element.addClass('e-treegrid-core');
            proxy.element.attr("tabindex", "0");
            model.cssClass && this.element.addClass(model.cssClass);
            proxy._renderToolbar();
            if (proxy._checkboxSelection)
                proxy._updateCheckboxColumnName();
            proxy._renderAfterColumnInitialize();
            if (proxy.model.showColumnChooser) {
                proxy._renderColumnChooser();
                if(proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu")
                proxy._renderFilterMenu();
            } else if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                proxy._renderFilterMenu();
            }
            proxy._setWidthToHeaders();
            if (proxy.model.allowPaging) {
                proxy.element.append(proxy._renderGridPager());
                proxy.element.append(proxy.element.find(".e-pager").attr({ "id": this._id + "Pager" }));
            }
            proxy._viewPortHeight = proxy._getViewPortHeight();

            /* check if viewport heigth value*/
            if (!model.isFromGantt && proxy._viewPortHeight < 0) {
                proxy._updateElementHeight();
            }
            proxy._ensureDataSource();
            if (model.showSummaryRow)
                proxy._createSummaryRow();
            if (!model.isFromGantt)
                proxy.updateAltRowOnCollapseAll();
            if (model.expandStateMapping && model.enableAltRow)
                proxy.updateAltRowOnRendering();
            proxy._initGridRender();          
            proxy._$gridContent = $("#" + proxy._id + "e-gridcontent");
            proxy._$gridContainer = $("#" + proxy._id + "e-gridcontainer");
            proxy._$tableContent = $("#" + proxy._id + "e-table");
            proxy._$frozenTableContent = $("#" + proxy._id + "frozene-table");
            proxy._$movableTableContent = $("#" + proxy._id + "movablee-table");
            proxy._viewPortHeight = proxy._getViewPortHeight();
            proxy._$gridContent.css({ "height": proxy._viewPortHeight + "px" });
            proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
            proxy._pagerHeight = proxy.element.find(".e-pager").outerHeight();
            if (model.showTotalSummary) {
                proxy._createTotalSummaryRow();
                proxy._viewPortHeight = proxy._getViewPortHeight();
                if (!model.allowPaging || model.sizeSettings.height)
                    proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
            proxy._updatePagerTextAlignment();
           // proxy.updateHeight();
            proxy._wireEvents();
            
            proxy.setWidthToColumns();
            
            proxy._renderScroller();
            proxy._updateWrapRowHeights();
            if (model.allowTextWrap && model.enableVirtualization) {
                proxy._textWrapRowsDatas = proxy._getAvgTextWrapRowHeight("getAvgHeight");
            }
            proxy.updateHeight();
            proxy._updateScrollCss();
            proxy._resizeFilteringElements();
            proxy._initialEndRendering();
            if (model.allowTextWrap || model.headerTextOverflow == "wrap")
                proxy._updateGridContentHeight();
            if (model.isFromGantt) {
                proxy._addEmptyColumntoGrid();
            }
            if (!model.isFromGantt) {
                proxy._checkDataManagerUpdate();
            } else {
                proxy._isDataManagerUpdate = model.dataManagerUpdate.isDataManagerUpdate;
                proxy._jsonData = model.dataManagerUpdate.jsonData;
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt) {
                proxy._renderMultiSelectionIndicator();
            }
            $("#" + proxy._id).removeClass('e-treegrid-overflow');
        },

        //Render Multi selection indicator
        _renderMultiSelectionIndicator: function () {
            this._multiSelectPopup = ej.buildTag("div.e-treegridpopup#" + this._id + "_selectionpopup", "", { display: "none" });
            var $content = ej.buildTag("div.e-popupcontent"), $downTail = ej.buildTag("div.e-downtail e-tail");
                var $selElement = ej.buildTag("span.e-rowselect e-icon");
                $content.append($selElement);
            this._multiSelectPopup.append($content);
            this._multiSelectPopup.append($downTail);
            this.element.append(this._multiSelectPopup);
        },

        //Updated records of online data manager 
        getUpdatedDataManagerData: function () {
            var proxy = this, data;
            data = proxy._jsonData;
            return data;
        },

        //Method to update the text wrap grids heights.
        //element atgument is used prevent the specific row heights.
        //refreshAction argument is used to make necessary view port height updation.
        //Index and type argument is used to update the specific row height.
        _updateWrapRowHeights: function (element, refreshAction, index, type) {
            var proxy = this, model = this.model;
            if ((model.allowTextWrap || model.headerTextOverflow == "wrap") && proxy._$frozenTableContent.length > 0) {
                proxy.getScrollElement().ejScroller("refresh");
                if (model.headerTextOverflow == "wrap" && (ej.isNullOrUndefined(element) || element.indexOf("header") == -1))
                    proxy._updateHeaderHeight();
                if (model.allowTextWrap && (ej.isNullOrUndefined(element) || element.indexOf("row") == -1)) {
                    if (ej.isNullOrUndefined(index) && ej.isNullOrUndefined(type))
                        proxy._updateRowHeight();
                    else
                        proxy._updateRowHeight(index, type);
                    if (model.showTotalSummary && (ej.isNullOrUndefined(element) || element.indexOf("total") == -1)) {
                        proxy._updateTotalSummaryHeight();
                    }
                    proxy.getScrollElement().ejScroller("refresh");
                    var movableScrollTop = proxy.getScrollElement().ejScroller("model.scrollTop");
                    proxy._getFrozenScrollElement().scrollTop(movableScrollTop);
                }
            }
            if (refreshAction == "virtualRefresh" && (model.allowTextWrap || model.headerTextOverflow == "wrap")) {
                if (model.allowTextWrap && model.enableVirtualization) {
                    proxy.updateHeight();
                }
                proxy._updateGridContentHeight();
            } else if (refreshAction == "refreshAll" && (model.allowTextWrap || model.headerTextOverflow == "wrap")) {
                proxy.updateHeight();
                proxy._updateGridContentHeight();
            }
        },

        //Update Header height when and frozen column text wrap is in enable state.
        _updateHeaderHeight: function () {
            var proxy = this, maxheight = 0, frozen = proxy.getHeaderContent().find("#e-frozenheaderdiv" + this._id).find('tr')[0],
                movable = proxy.getHeaderContent().find("#e-movableheaderdiv" + this._id).find('tr')[0];
            $(movable).css('height', 'auto');
            $(frozen).css('height', 'auto');
            if (frozen.offsetHeight > movable.offsetHeight)
                $(movable).css('height', frozen.offsetHeight);
            else if (movable.offsetHeight > frozen.offsetHeight)
                $(frozen).css('height', movable.offsetHeight);
        },

        //Update total summary row height when text wrap and frozen column  is in enable state.
        _updateTotalSummaryHeight: function () {
            var proxy = this, model = this.model, maxheight = 0, frozen = $(proxy._$footertableContent[0]).find('tr'),
                movable = $(proxy._$footertableContent[1]).find('tr'), length = $(frozen).length, frozenHeight, movableHeight;
            for (var index = 0; index < length; index++) {
                $(movable[index]).css('height', model.rowHeight);
                $(frozen[index]).css('height', model.rowHeight);
                frozenHeight = $(frozen[index]).height();
                movableHeight = $(movable[index]).height();
                if (frozenHeight >= movableHeight) {
                    $(movable[index]).css('height', frozenHeight);
                } else if (movableHeight > frozenHeight) {
                    $(frozen[index]).css('height', movableHeight);
                }
            }
                if (proxy._$totalSummaryRowContainer.hasClass("e-scroller"))
                    proxy._$totalSummaryRowContainer.ejScroller("refresh");
        },

        //Update all rows height when text wrap and frozen column is in enable state.
        _updateRowHeight: function (index, type) {
            var proxy = this, model = this.model, frozenHeight = 0, start = 0, movableHeight = 0, length = 0, frozen = [], movable = [], currentData;
            if (!ej.isNullOrUndefined(index)) {
                if (model.enableVirtualization && type != "rowEdit") {
                    currentData = model.currentViewData[index];
                    index = proxy.getUpdatedRecords().indexOf(currentData);
                }
                start = index;
                length = index + 1;
                frozen[start] = $(ej.TreeGrid.getRowByIndex(proxy, index)[0]);
                movable[start] = $(ej.TreeGrid.getRowByIndex(proxy, index)[1]);
            } else {
                start = 0;
                length = proxy.getRows()[0].length;
                frozen = proxy.getRows()[0];
                movable = proxy.getRows()[1];
            }
            for (var rowIndex = start; rowIndex < length; rowIndex++) {
                if ((!ej.isNullOrUndefined(index) && (type == "rowEdit" || type == "savecell")) || type == "resize") {
                    $(frozen[rowIndex]).css('height', model.rowHeight);
                    $(movable[rowIndex]).css('height', model.rowHeight);
                }
                if (type != "rowEdit") {
                    frozenHeight = $(frozen[rowIndex]).height();
                    movableHeight = $(movable[rowIndex]).height();
                    if (frozenHeight >= movableHeight) {
                        $(movable[rowIndex]).css('height', frozenHeight);
                    } else if (movableHeight > frozenHeight) {
                        $(frozen[rowIndex]).css('height', movableHeight);
                    }
                }
            }
        },

        //Check if data manager is updatable
        _checkDataManagerUpdate: function () {
            var proxy = this,
                dataSource = this.dataSource();
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            if (dataSource instanceof ej.DataManager) {
                if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = dataSource.dataSource.json;
                }
                else if (!dataSource.dataSource.offline) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = proxy._retrivedData;
                }
            }
        },

        _initDatasource: function () {
            var proxy = this,
                model = proxy.model, retriveData;
            if (!model.isFromGantt) {
                if (this.dataSource() instanceof ej.DataManager) {

                    if (ej.isNullOrUndefined(proxy._waitingPopupObj))
                        proxy._renderWaitingPopup();
                    else
                        proxy._waitingPopupObj.show();
                    var isRemoteData = this.dataSource().adaptor instanceof ej.UrlAdaptor || this.dataSource().adaptor instanceof ej.WebMethodAdaptor,
                        isStaticData = (ej.pvt.filterQueries(model.query.queries, "onTake").length == 0 && ej.pvt.filterQueries(model.query.queries, "onPage").length == 0
                                        && ej.pvt.filterQueries(model.query.queries, "onWhere").length == 0) ? false : true;
                    proxy._isRemoteData = isRemoteData;
                    if (isRemoteData && !this.dataSource().dataSource.offline && !isStaticData && (this.dataSource().dataSource.crossDomain || model.enableLoadOnDemand)) {
                        proxy._isLoadonDemand = true;
                        proxy._getAndRenderRecordsonDemand();
                    }
                    else {
                        proxy._isLoadonDemand = false;
                        model.query.requiresCount();
                        var queryPromise = this.dataSource().executeQuery(model.query);
                        queryPromise.done(ej.proxy(function (e) { proxy._renderQueriedRecords(e, proxy); }))
                                    .fail(ej.proxy(function (e) { proxy._triggerFailureEvent(e, proxy); }));                           
                    }
                }
                else if (this.dataSource()) {
                    proxy._retrivedData = proxy.dataSource();
                    proxy._renderQueriedRecords(null, proxy, proxy._retrivedData);                    
                }
                else {
                    proxy._checkDataBinding();
                }
            } else {
                proxy._isLoadonDemand = model.isLoadonDemand;
                proxy._checkDataBinding();
            }            
        },
        _intersectionObjects: function (flatCollection, rootCollection) {
            var result = [];
            while (flatCollection.length > 0 && rootCollection.length > 0) {
                var index = rootCollection.indexOf(flatCollection[0]);
                if ( index == -1) {
                    flatCollection.shift();
                }
                else {
                    result.push(flatCollection.shift());
                    rootCollection.splice(index, 1);
                }
            }

            return result;
        },

        _getAndRenderRecordsonDemand:function(){
            var proxy = this, model = proxy.model;
            model.query.requiresCount();
            model.pageSettings.pageSizeMode = ej.TreeGrid.PageSizeMode.Root;
            if (model.parentIdMapping) {
                proxy._queryAndRenderParentRecords();
            }
            else {
                var newQuery = proxy._updateQueryForLoadonDemand();
                var queryPromise = proxy.dataSource().executeQuery(newQuery);
                queryPromise.done(ej.proxy(function (e) {
                    //proxy._fieldNamesToQuery = existSelectQuery[0].e.fieldNames;
                    proxy._pageRecordCountOnDemand = e.count;
                    proxy._renderQueriedRecords(e, proxy);
                    proxy._setScrollTop();
                    proxy.updateHeight();

                })).fail(ej.proxy(function (e) { proxy._triggerFailureEvent(e, proxy); }));                   
            }
            proxy._allParentItems = $.extend([], model.parentRecords);
        },

        /*Create waiting popup for load on demand request*/
        _renderWaitingPopup: function () {
            var proxy=this;
            $(this.element).ejWaitingPopup({ showOnInit: true, });
            this._waitingPopupObj = $(this.element).data("ejWaitingPopup")
        },

        _renderQueriedRecords: function (e, proxy, retrivedItems) {
            var model = proxy.model;
            if (retrivedItems)
                proxy._retrivedData = retrivedItems;
            else {
                proxy._retrivedData = e.result;
                if (proxy._fieldNamesToQuery.length == 0 && proxy._retrivedData.length > 0) {
                    for (var field in e.result[0])
                        proxy._fieldNamesToQuery.push(field);
                }
            }
            if (model.flatRecords.length == 0) {
                if (model.allowPaging && model.parentIdMapping) {
                    if (!proxy._isRemoteData) {
                        if (ej.isNullOrUndefined(model.pageSettings.totalRecordsCount))
                            model.pageSettings.totalRecordsCount = e.count;
                        else
                            proxy._retrivedData = proxy._retrivedData.splice(model.pageSettings.totalRecordsCount);
                    }
                    else
                        model.pageSettings.totalRecordsCount = e.count;
                }
                
                proxy._createQueriedRecords(proxy._retrivedData);
            }
            if (!proxy._isForDataSourceRefresh)
                proxy._checkDataBinding();
            else {
                var args = {};
                args["requestType"] = ej.TreeGrid.Actions.RefreshDataSource;
                proxy._ensureDataSource(args);
                if (!model.isFromGantt) {
                    proxy._checkDataManagerUpdate();
                }
                if (proxy.selectedRowIndex() !== -1 && proxy.selectedRowIndex() < proxy.model.currentViewData.length) {
                    proxy.selectRows(proxy.selectedRowIndex());
                }
                if (proxy.getScrollElement().hasClass("e-scroller"))
                    proxy.getScrollElement().ejScroller("refresh");
                proxy._createdAt = null;
                proxy._isForDataSourceRefresh = false;
            }
            if (e)
                proxy._waitingPopupObj.hide();
        },

        _createQueriedRecords: function (retrivedItems) {
            var proxy = this, model = proxy.model;
            if (model.idMapping && model.parentIdMapping && retrivedItems.length > 0) {
                //cloning the datasource                    
                var data = []; proxy._taskIds = [], proxy._lastInsertedId = -1;
                for (var i = 0; i < retrivedItems.length; i++) {
                    var tempData = retrivedItems[i];
                    data.push($.extend(true, {}, tempData));
                    if (!ej.isNullOrUndefined(tempData[model.idMapping])) {
                        proxy._updateLastInsertedId(tempData[model.idMapping]);
                        proxy._taskIds.push(tempData[model.idMapping]);
                    }
                }
                proxy._reconstructDatasource(data);
                proxy._createRecords(proxy.secondaryDatasource);
            }
            else
                retrivedItems && proxy._createRecords(retrivedItems);
        },

        _queryAndRenderParentRecords: function () {
            var proxy = this, model = proxy.model;
            if (model.hasChildMapping)
                proxy._renderRootRecords(proxy);            
            else {
                if (proxy._assignedIdCollections.length == 0 && proxy._assignedParendIDs.length == 0) {
                var queryParentIds = ej.Query(), parentIdQueryPromise,
                    existSelectQuery = ej.pvt.filterQueries(model.query.queries, "onSelect");

                queryParentIds.queries = $.extend([], model.query.queries);
                queryParentIds.requiresCount();
                if (existSelectQuery.length > 0)
                    queryParentIds.queries.splice($.inArray(existSelectQuery[0], queryParentIds.queries), 1);
                queryParentIds.select(model.parentIdMapping, model.idMapping);

                parentIdQueryPromise = this.dataSource().executeQuery(queryParentIds);
                parentIdQueryPromise.done(ej.proxy(function (e) {
                    e.result.map(function (res) {
                        proxy._assignedIdCollections.push(res[model.idMapping]);
                        if (res[model.parentIdMapping] && proxy._assignedParendIDs.indexOf(res[model.parentIdMapping]) == -1)
                            proxy._assignedParendIDs.push(res[model.parentIdMapping]);
                    });

                    proxy._totalItemCounts = e.result.length;
                        proxy._renderRootRecords(proxy);

                    })).fail(ej.proxy(function (e) { proxy._triggerFailureEvent(e, proxy); }));
                }
                else
                    proxy._renderRootRecords(proxy);
            }
        },

        _renderRootRecords:function(proxy){
                    var updatedQuery = proxy._updateQueryForLoadonDemand();
                    var queryPromise = proxy.dataSource().executeQuery(updatedQuery);

                    queryPromise.done(ej.proxy(function (e) { proxy._renderZerothLevelParentItems(e); }))
                                .fail(ej.proxy(function (e) { proxy._triggerFailureEvent(e, proxy); }));
        },
        _renderExpandedChildRecords: function (expcolargs) {
            var proxy = this, model = proxy.model;          
            proxy._ensureDataSource(expcolargs);
            if (model.showSummaryRow) {
                proxy._parentRecords = proxy._allParentItems;
                proxy._createSummaryRow();
            }
            if (model.enableAltRow) {
                proxy.updateAltRow();
            }
            proxy.sendDataRenderingRequest(expcolargs);
            proxy._setScrollTop();
            proxy.updateHeight();
            proxy._waitingPopupObj.hide();            
        },
        _triggerFailureEvent: function (e, proxy) {
            proxy._waitingPopupObj.hide();
            var args = { error: e.error };
            proxy._trigger("actionFailure", args);
        },
        _renderZerothLevelParentItems: function (e) {
            var proxy = this, model = proxy.model;           
            proxy._pageRecordCountOnDemand = e.count;
            proxy._renderQueriedRecords(e, proxy);
            proxy._allParentItems = $.extend([], model.parentRecords);
            proxy._isForDataSourceRefresh = false;
            proxy._maxRowIndex = proxy._totalItemCounts;
        },
        _updateQueryForLoadonDemand: function () {
            var proxy = this, model = proxy.model,
                updateQuery = new ej.Query(),
                condition = ej.Predicate(model.parentIdMapping, ej.FilterOperators.equal, null);

            updateQuery.queries = $.extend([], model.query.queries);
            if (model.parentIdMapping)
                updateQuery.where(condition);
            if (model.allowPaging)
                updateQuery.page(proxy._currentPage(), proxy.model.pageSettings.pageSize);
            updateQuery.requiresCount();
            proxy._queryForLoadonDemand = updateQuery;
            //model.query = updateQuery;
            return updateQuery;
        },
                    
        _reconstructDatasource: function (datasource) {
            var proxy = this, model = proxy.model, data, filter;                      

            filter = ej.Predicate(model.parentIdMapping, ej.FilterOperators.notEqual, "null");
            data = ej.DataManager(datasource).executeLocal(ej.Query().where(filter).group(model.parentIdMapping));            
            var tempParent = [];

            if (!model.childMapping) model.childMapping = "Children";

            for (var i = 0; i < data.length; i++) {
                if (!ej.isNullOrUndefined(data[i].key)) {

                    var index = proxy._taskIds.indexOf(data[i].key);
                    if (index > -1) {
                        datasource[index][model.childMapping] = data[i].items;
                        continue;
                    }
                }
                var items = data[i].items;
                for (var item in data[i].items)
                    tempParent.push(items[item]);
            }
            proxy.secondaryDatasource = proxy._intersectionObjects(datasource, tempParent);           
        },        
               
        //Window resize event
        _windowResize: function (e)
        {
            if (!this.element.is(":visible")) {
                return;
            }
            var proxy = this,
               model = this.model;
            $("#" + proxy._id).addClass('e-treegrid-overflow');

            var treeGridHeader = proxy._$gridHeaderContent,
               totalSummaryRowContent = proxy._$totalSummaryRowContainer,
               treeGridContent,
               treegridToolbar = $("#" + proxy._id + "_toolbarItems"),
               sizeSettingsHeight = model.sizeSettings.height,
               sizeSettingsWidth = model.sizeSettings.width,
               elementStyleWidth = proxy.element[0].style.width,
               elementStyleHeight = proxy.element[0].style.height,
               width, height;

            proxy._clearContextMenu();
            if (!proxy.model.isResponsive && !ej.isTouchDevice()) {
                    proxy._clearColumnMenu();
                    proxy._clearFilterMenu();
            }
            else {
                if (!ej.isTouchDevice()) {
                    proxy._clearColumnMenu('resize');
                }
            }

            if (this._frozenColumnsLength > 0)
                treeGridContent = this.element.find("#e-movablecontainer" + this._id);
            else
                treeGridContent = $("#" + proxy._id + "e-gridcontent");


            $("#" + this._id + "detailscellwrapper").length > 0 && this._removeDetailsRow();

            //Width calculation
            if ((sizeSettingsWidth && (typeof(sizeSettingsWidth) != "number" && sizeSettingsWidth.indexOf("%") != -1)) || elementStyleWidth.indexOf("%") != -1) {
                var ganttWidth = sizeSettingsWidth ? sizeSettingsWidth : elementStyleWidth;
                var containerWidth = $(proxy.element).parent().width() ? $(proxy.element).parent().width() : $(proxy.element).width();
                var tempWidth = (containerWidth / 100) * parseInt(ganttWidth);
                width = tempWidth;
            }
            else
                width = $(proxy.element).width();
            proxy._gridWidth = width;
            if (proxy._frozenColumnsLength > 0) {
                var totalWidth = 0;
                for (var i = 0; i < proxy._frozenColumnsLength; i++) {
                    if (model.columns[i].visible == true) {
                        totalWidth += proxy.columnsWidthCollection[i];
                    }
                }
                if (width < totalWidth)
                    proxy._gridWidth = width = totalWidth;
            }
            //height calculation
            if ((sizeSettingsHeight && (typeof (sizeSettingsHeight) != "number" && sizeSettingsHeight.indexOf("%") != -1)) || elementStyleHeight.indexOf("%") != -1) {
                var ganttHeight = sizeSettingsHeight ? sizeSettingsHeight : elementStyleHeight;
                var containerHeight = $(proxy.element).parent().height() ? $(proxy.element).parent().height() : $(proxy.element).height();
                var tempHeight;
                if ($(proxy.element).parent().height())
                    tempHeight = (containerHeight / 100) * parseInt(ganttHeight);
                else
                    tempHeight = $(proxy.element).height();
                height = tempHeight;
            }
            else
                height = $(proxy.element).height();

            //excludes border 
            height = height - proxy._totalBorderHeight; 
            
            if (proxy._$totalSummaryRowContainer)
                height -= proxy._$totalSummaryRowContainer.outerHeight();
            width = Math.round(width - proxy._totalBorderWidth);
            var treeGridWidth, headerHeight, headerWidth, top, left,
                toolbarHeight = treegridToolbar.length > 0 ? treegridToolbar.outerHeight() : 0;
            top = treeGridContent.ejScroller("option", "scrollTop");
            left = treeGridContent.ejScroller("option", "scrollLeft");
            var scrollerWidth = width,
                PagerHgDiff = 0;
            if (model.allowPaging) {
                var pagerHeight = proxy.element.find('.e-pager').outerHeight(),
                    isPagerTemplate = ej.isNullOrUndefined(model.pageSettings.template)? false : true;
                height -= pagerHeight;               
                if (!model.sizeSettings.height) {
                    var totalWidth = 0;
                    if (pagerHeight > proxy._pagerHeight && !isPagerTemplate)
                        PagerHgDiff = pagerHeight - proxy._pagerHeight;
                    for (var i = 0; i < proxy.columnsWidthCollection.length; i++)
                        totalWidth += proxy.columnsWidthCollection[i];
                    if (totalWidth > proxy._gridWidth) {
                        height = height + proxy._scrollBarHeight;
                    }                   
                }
            }
            if (this._frozenColumnsLength > 0) {
                proxy._$gridContent.css("width", width);
                proxy._$gridContent.css("height", height - $(treeGridHeader).outerHeight() - toolbarHeight);
                scrollerWidth = width - this._getFrozenColumnWidth() - 1;//frozen div border width
            }
            proxy.getScrollElement().ejScroller({
                width: scrollerWidth,
                height: height - $(treeGridHeader).outerHeight() - toolbarHeight + PagerHgDiff//for border-width of gridcontent
            });
            proxy._updateScrollCss();
            if ($(treeGridHeader).hasClass("e-scrollcss") && proxy.getScrollElement().children(".e-vscrollbar").length > 0) {
                $(treeGridHeader).width(width - 17);
            }
            else {
                $(treeGridHeader).width(width);
            }

            if (proxy._$totalSummaryRowContainer) {
                if (proxy._$totalSummaryRowContainer.height() >= 90 && proxy._$totalSummaryRowContainer.hasClass("e-scroller"))
                    proxy._$totalSummaryRowContainer.ejScroller("refresh");
                else if ($(totalSummaryRowContent).hasClass("e-scrollcss") && proxy.getScrollElement().children(".e-vscrollbar").length > 0 )
                    $(totalSummaryRowContent).width(width - 17);
                else 
                    $(totalSummaryRowContent).width(width);
            }
            if (model.toolbarSettings.showToolbar && treegridToolbar.length > 0) {
                treegridToolbar.width(width);
            }

            proxy.getScrollElement().ejScroller("refresh");
            proxy.updateViewPortHeight();

            if(model.showTotalSummary)
                proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            proxy.getScrollElement().ejScroller("option", "scrollTop",top);
            proxy.getScrollElement().ejScroller("option", "scrollLeft", left);
            proxy._updateHeaderScrollLeft();
            if (model.enableVirtualization) {
                proxy.cancelRowEditCell(); // To hide or destroy popup menu
                var tempArgs = {},
                    rowHeight = model.rowHeight;
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.processBindings(tempArgs);                
                proxy.sendDataRenderingRequest(tempArgs);
                /* check detail template and its row height */
                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
                {
                    rowHeight += model.detailsRowHeight;
                }
                
                if ((model.currentViewData.length * rowHeight) < proxy._viewPortHeight) {

                    var currentPosition = top - (proxy._viewPortHeight - model.currentViewData.length * rowHeight);
                    if (currentPosition < 0)
                        currentPosition = 0;
                    proxy.getScrollElement().ejScroller("scrollY",currentPosition, true);
                }
            }
            if (model.allowPaging)
                proxy.element.find(".e-pager").css({ "width": proxy._gridWidth - 2 });
            proxy._resizeFilteringElements();
            if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt) {
                this._updateTableWidth(true);
            }
            if (proxy.model.isResponsive && !proxy.model.isFromGantt) {
                proxy._mediaQueryUpdate();
            }
            proxy._updatePagerTextAlignment();
            proxy._updateWrapRowHeights(null, "virtualRefresh", null, "resize");
            if (model.allowPaging && !model.sizeSettings.height) {
                proxy.updateHeight();
            }
            if (model.allowTextWrap || model.headerTextOverflow == "wrap") {
                if (proxy.model.allowTextWrap && proxy.model.enableVirtualization) {
                    proxy.updateHeight();
                }
                proxy._updateGridContentHeight();
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._alignMultiSelectPopup();
            }
            $("#" + proxy._id).removeClass('e-treegrid-overflow');
            if (model.isResponsive && model.enableResize) {
                proxy._validateColumnVisible();
                proxy._hideColumns(proxy._autoHideColumns);
                proxy._showColumns(proxy._autoShowColumns);
            }
        },
		
        _updatePagerTextAlignment: function () {
            var proxy = this;
            if (proxy.model.allowPaging) {
                if (($('#' + proxy._id + 'Pager').find('.e-pagercontainer').outerWidth() + $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').outerWidth() + 10) > $('#' + proxy._id).width()) {
                    var pagecontainer = ($('#' + proxy._id).width() - $('#' + proxy._id + 'Pager').find('.e-pagercontainer').outerWidth()) / 2;
                    var parentmsgbar = ($('#' + proxy._id).width() - $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').width()) / 2;
                    if (pagecontainer > 0) {
                        $('#' + proxy._id + 'Pager').find('.e-pagercontainer').css("margin-left", pagecontainer + 'px');
                    }
                    if (parentmsgbar > 0) {
                        $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').css("margin-right", (parentmsgbar - 6) + 'px');
                    }
                } else {
                    $('#' + proxy._id + 'Pager').find('.e-pagercontainer').css("margin-left", "");
                    $('#' + proxy._id + 'Pager').find('.e-parentmsgbar').css("margin-right", "");
                }
            }
        },

        _alignMultiSelectPopup: function() {
            var proxy = this,
                contentHeightLimit = proxy._$gridContent.offset().top + proxy._$gridContent.outerHeight(),
                contentWidthLimit = proxy._$gridContent.offset().left + proxy._$gridContent.outerWidth();
            if ((proxy._multiSelectPopup.offset().top + proxy._multiSelectPopup.outerHeight() + 10) > contentHeightLimit || proxy._multiSelectPopup.offset().top < proxy._$gridContent.offset().top || (proxy._multiSelectPopup.offset().left + proxy._multiSelectPopup.outerWidth()) > contentWidthLimit || proxy._multiSelectPopup.offset().left < proxy._$gridContent.offset().left) {
                var top = proxy._$gridContent.offset().top + (proxy._$gridContent.outerHeight() / 2),
               left = proxy._$gridContent.offset().left + (proxy._$gridContent.outerWidth() / 2);
                if (proxy._$gridContent.find(".e-hscrollbar").length > 0)
                    top = top - proxy._$gridContent.find(".e-hscrollbar").outerHeight();
                if (proxy._$gridContent.find(".e-vscrollbar").length > 0)
                    left = left - proxy._$gridContent.find(".e-vscrollbar").outerWidth();
            proxy._multiSelectPopup.offset({ top: (top - (this._multiSelectPopup.height() / 2) - 5), left: (left - (this._multiSelectPopup.width() / 2)) });
        }
        },

        _mediaQueryUpdate: function () {
            var proxy = this, length, sliceFilterMenuDivID, filterMenuDivID,
                temp = "",
                controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);

            // Insert dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "_dialogColumnAdd_wrapper").length > 0 && $("#" + proxy._id + "_dialogColumnAdd_wrapper").css('display') != 'none') {
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {

                        $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "_dialogColumnAdd").find(".e-dropdowntreegrid").css('width', ($("#" + proxy._id).width() - 80) + 'px');  // 80px ((28px of $("#" + proxy._id + "_dialogColumnAdd"))+(18px of Hscrollbar)+(30px of $("#" + proxy._id + "ColumnAddForm div"))) get minused in width to place the dropdown dialog treegrid div in absolute position.
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: false, enableModal: false, isResponsive: false });

                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-shadow");

                } else {
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 0, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "_dialogColumnAdd").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".e-dropdowntreegrid").css('width', '438px');  // fixed width of dialog dropdown treegrid div.
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-shadow");
                }
            }

            // Column rename dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "ColumnRenameDialog_wrapper").length > 0 && $("#" + proxy._id + "ColumnRenameDialog_wrapper").css('display') != 'none') {

                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {

                        $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-treegridadaptivedialog");
                        proxy._columnRenameDialog.ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", position: { X: controlPosition.left, Y: controlPosition.top }, minHeight: "50px", minWidth: "50px", showOnInit: false, allowDraggable: false, enableResize: false, enableModal: false, isResponsive: false });
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-shadow");
                        $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-treegridadaptivedialog");

                } else {
                    proxy._columnRenameDialog.ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 0, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "ColumnRenameDialog").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "ColumnRenameDialog_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                }
            }

            // Filter menu dialog-box changes with respect to window resize.

            if (proxy._renderedSubMenuType) { // proxy._renderedSubMenuType shows the rendered type of sub menu (filter menu / column chooser) dialog of column menu.
                temp = "";
                if (proxy._renderedSubMenuType.indexOf("Desktop") == -1) {
                    temp = proxy._renderedSubMenuType;
                } else {
                    var index = proxy._renderedSubMenuType.indexOf("Desktop");
                    temp = proxy._renderedSubMenuType.slice(0, index);
                }
                if ($(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') != 'none') {
                    if ($(window).width() <= proxy._responsiveMinWidth && proxy._renderedSubMenuType.indexOf("Desktop") == -1 && proxy.model.isResponsive) {

                        var dialogInnerDivHeight = ($("#" + proxy._id).height() - 50) + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                            $(proxy._renderedSubMenuType + "_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivewidth");
                            $(proxy._renderedSubMenuType).ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", position: { X: controlPosition.left + "px", Y: controlPosition.top + "px" }, minHeight: "50px", minWidth: "50px", showOnInit: false, enableResize: false, enableModal: false, isResponsive: false });
                            if ($(proxy._renderedSubMenuType).height() > $(proxy._renderedSubMenuType + "_wrapper").height() - 48) { // 48px - Dialog box header height
                                $(proxy._renderedSubMenuType + "_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); // 48px - Dialog box header height
                                $(proxy._renderedSubMenuType).ejDialog("refresh"); // 'refresh' event get called inorder to update dialog scroll bar
                            } else {
                                $(proxy._renderedSubMenuType+"_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto' });
                              //$(proxy._renderedSubMenuType).ejDialog("refresh"); // 'refresh' event get called inorder to update dialog scroll bar
                            }

                    } else {
                        if (ej.isTouchDevice()) {
                            if (((proxy._renderedSubMenuType.indexOf("Desktop") == -1) && ($(window).width() > proxy._responsiveMinWidth)) || ((proxy._renderedSubMenuType.indexOf("Desktop") != -1) && ($(window).width() <= proxy._responsiveMinWidth))) {
                                proxy._clearColumnMenu();
                                proxy._clearFilterMenu();
                            }
                        } else {
                            proxy._clearFilterMenu();
                        }
                    }
                } else if ((ej.isTouchDevice() && !proxy._renderedSubMenuType) || (ej.isTouchDevice() && $(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') == 'none')) {
                    proxy._clearColumnMenu();
                }
            } else if ((ej.isTouchDevice() && !proxy._renderedSubMenuType) || (ej.isTouchDevice() && $(temp + "_wrapper").length > 0 && $(temp + "_wrapper").css('display') == 'none')) {
                proxy._clearColumnMenu();
            }

            // Column chooser dialog-box changes with respect to window resize.

            if ($("#" + proxy._id + "ccDiv_wrapper").length > 0 && $("#" + proxy._id + "ccDiv_wrapper").css('display') != 'none') {
                if ($(window).width() < proxy._responsiveMinWidth && proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == 0 && proxy.model.isResponsive) {

                    var dialogInnerDivHeight = ($("#" + proxy._id).height() - 66) + "px"; //(48px - Dialog box header height) + (16px - $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller") of padding) + (2px - excess border of parent div) 
                        $("#" + proxy._id + "ccDiv").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, enableModal: false, isResponsive: false });
                        $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                        $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': 'auto' });
                        if ($("#" + proxy._id + "ccDiv").height() > $("#" + proxy._id + "ccDiv_wrapper").height() - 48) { //(48px - Dialog box header height)
                            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); //(48px - Dialog box header height)
                            $("#" + proxy._id + "ccDiv").removeClass("e-columnSelector");
                            $("#" + proxy._id + "ccDiv").ejDialog("refresh");
                        } else {
                            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto', 'padding': '8px 16px' });
                            $("#" + proxy._id + "ccDiv").css({ 'padding': '0px' });
                        }
                        $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-shadow");
                        $("#" + proxy._id + "ccDiv").removeClass("e-shadow");

                } else {
                    proxy._clearColumnMenu();
                }
            }

            if ($("#" + proxy._id + "_dialogEdit").length > 0 && $("#" + proxy._id + "_dialogEdit").css('display') != 'none') {
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                    $("#" + proxy._id + "_dialogEdit").ejDialog({ width: $("#" + proxy._id).width() + "px", height: $("#" + proxy._id).height() + "px", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: false, enableModal: false, isResponsive: false });
                    $("#" + proxy._id + "_dialogEdit_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                    $("#" + proxy._id + "_dialogEdit_wrapper").removeClass("e-shadow").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogEdit").removeClass("e-shadow");
                } else {
                    $("#" + proxy._id + "_dialogEdit").ejDialog({ width: "auto", height: "auto", minHeight: "150px", minWidth: "150px", showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true });
                    $("#" + proxy._id + "_dialogEdit_wrapper").addClass("e-shadow").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogEdit").addClass("e-shadow");
                }
            }

            if (proxy._renderedSubMenuType && (proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == 0 || proxy._renderedSubMenuType.indexOf("ColumnDesktop") == 0)) {
                proxy._clearColumnMenu();
            }
        },

        updateResponsiveMinWidth: function (width) {
            var proxy = this;
            if (parseInt(width) < 150)
                width = 150;

            proxy._responsiveMinWidth = parseInt(width);

            proxy._mediaQueryUpdate();

        },

        //PROCESSBINDING
        processBindings: function (args) {

            var proxy = this,
                model = proxy.model;

            model.query = new ej.Query();

            if (!proxy._isEmptyRow && proxy._trigger("actionBegin", args)) {
                if (args.requestType == "filtering") 
                    $("#" + proxy._id + "_" + args.currentFilteringColumn + "_filterbarcell").val("");               
                return true;
            }

            proxy._ensureDataSource(args);

        },
        //updated the treegrid record collection after record update in Gantt
        setUpdatedRecords: function (flatRecords, updatedRecords, ids, parentRecords, dataSource) {
            var model = this.model;
            model.flatRecords = flatRecords;
            model.updatedRecords = updatedRecords;
            model.ids = ids;
            model.parentRecords = parentRecords;
            this.dataSource(dataSource);
        },
        //In virtualization get expaned records from total record collection only
        getExpandedRecords: function (records) {
            var proxy = this;
            var resultRecord = records.filter(function (record) {
                return proxy.getExpandStatus(record) == true;
            });
            return resultRecord;
        },

        //update the expandStatus of all child records in non-virtualization mode
        updateExpandStatus:function(record , expanded)
        {
            var proxy = this,
                childRecords = record.childRecords;
                for (var count = 0; count < childRecords.length; count++) {
                    childRecords[count].isExpanded = expanded;
                    if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                        proxy.updateExpandStatus(childRecords[count], expanded);
                    }
                }
        },
        //Expand collapse, sort, delete, filter search the record collections
        _ensureDataSource: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns,
                filteredColumns = model.filterSettings.filteredColumns,
                isupdatedHeight = false,
                index,
                dataSource = this.dataSource(),
                childIndex, ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            proxy._filteredRecords = [];
            proxy._flatFilteredRecords = [];

            model.query.requiresCount();
            proxy._queryManagar = new ej.Query();
            proxy._queryManagar.requiresCount();

            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager)) {
                this.dataSource([]);
                dataSource = this.dataSource();
            }

            //Expand Collapse Opearation
            if (args && args.requestType === ej.TreeGrid.Actions.ExpandCollapse) {

                isupdatedHeight = true;
                proxy._filteredRecords = [];
                args.data.expanded = args.expanded;               
                if (!ej.isNullOrUndefined(args.data.item[model.expandStateMapping])) {
                    args.data[model.expandStateMapping] = args.expanded;
                    args.data.item[model.expandStateMapping] = args.expanded;
                }
                model.updatedRecords = [];
                proxy._flatFilteredRecords = model.flatRecords;
                proxy._filteredRecords = proxy._flatFilteredRecords.filter(function (record) {
                    return proxy.getExpandStatus(record) == true;
                });
                model.updatedRecords = proxy._filteredRecords;
            }

            // Condition for filtering columns.
            if ((args && args.requestType == "filtering") || (model.allowFiltering && !model.isFromGantt && filteredColumns.length)) {
                //Removed the summary rows before filtering the datasource.
                if (model.showSummaryRow) {
                    model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords);
                    model.flatRecords = proxy._spliceSummaryRows(model.flatRecords);
                }
                if ((model.allowFiltering && !model.isFromGantt &&filteredColumns.length)) {
                    var predicate, firstFilterCondition =filteredColumns[0];
                    // Condition to collect the details of filtering column.
                    if (firstFilterCondition.value == proxy._dropDownListBlanksText) {
                        predicate = ej.Predicate(firstFilterCondition.field, "equal", null,true);
                        predicate = predicate["or"](firstFilterCondition.field, "equal", "",true);
                    }
                    else if (!firstFilterCondition.isComplex)
                        predicate = ej.Predicate(firstFilterCondition.field, firstFilterCondition.operator, firstFilterCondition.value, !firstFilterCondition.matchcase);
                    else
                        predicate = firstFilterCondition;
                    if (ej.isNullOrUndefined(args))
                      proxy._storePreviousFilteredValue(firstFilterCondition.field, firstFilterCondition.value, firstFilterCondition.operator);
                    for (var i = 1; i < filteredColumns.length; i++) {
                        //Loop to gather all the column condition as array.
                        if (!filteredColumns[i].isComplex)
                            predicate = predicate[filteredColumns[i].predicate](filteredColumns[i].field,filteredColumns[i].operator,filteredColumns[i].value, !filteredColumns[i].matchcase);
                        else
                            predicate = predicate["and"](filteredColumns[i]);
                        if (ej.isNullOrUndefined(args))
                          proxy._storePreviousFilteredValue(filteredColumns[i].field, filteredColumns[i].value, filteredColumns[i].operator);
                    }
                    proxy._queryManagar.where(predicate);
                    proxy._filteredRecords = model.flatRecords.slice();
                    var dataManager = new ej.DataManager(proxy._filteredRecords);
                    proxy._tempfilteredrecords = dataManager.executeLocal(proxy._queryManagar).result;
                    proxy._updateFilteredRecords(proxy._tempfilteredrecords);
                    model.updatedRecords = proxy._filteredRecords;
                    if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                        model.parentRecords = proxy._getParentRecords(model.updatedRecords, proxy, true);
                    if (model.allowSorting && model.sortSettings.sortedColumns.length > 0) {
                        proxy._sortingRecords();
                    }
                } else {
                    model.updatedRecords = model.enableVirtualization ? proxy.getExpandedRecords(model.flatRecords) : model.flatRecords.slice();
                    proxy._updateHasFilteredChildRecordsStatus(model.updatedRecords);
                    if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                        model.parentRecords = proxy._getParentRecords(model.updatedRecords, proxy, true);
                }
                //// Updating checkbox state of parent records when enableHierarchySelection is true
                if (args && !model.isFromGantt && args.requestType == "filtering" && proxy._checkboxSelection &&
						 model.selectionSettings.enableHierarchySelection) {
                    if (args.requestType == "filtering") {
                        $.each(model.updatedRecords, function (index, record) {
                            if (record.hasChildRecords)
                                proxy._updateParentSelection(record);

                        });
                        proxy.selectAllRows();
                    }
                }

                if (model.showSummaryRow)
                    proxy._createSummaryRow(args);
                if (args) {
                    if (model.showTotalSummary)
                        proxy._updateTotalSummaryRow(args);
                }
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
                isupdatedHeight = true;
                if (model.enableAltRow) {
                    proxy.updateAltRow();
                }
            }

            if ((model.allowSearching && proxy._searchString.length) || (args && args.requestType==="searching")) {

                proxy._queryManagar.search(proxy._searchString, proxy.getColumnFieldNames(),
                    ej.FilterOperators.contains, true);

                proxy._filteredRecords = model.flatRecords.filter(function (record) {
                    return record.hasChildRecords === false;
                });
                if (model.isFromGantt) {
                    ganttObject.model.searchSettings = {
                        fields: proxy._getColumnMappingNames(),
                        key: proxy._queryManagar.queries[0].e.searchKey,
                        operator: "contains",
                        ignoreCase: true
                    };  
                }
                var dataManager = new ej.DataManager(proxy._filteredRecords);
                proxy._tempfilteredrecords = dataManager.executeLocal(proxy._queryManagar).result;
                proxy._updateFilteredRecords(proxy._tempfilteredrecords);
                model.updatedRecords = proxy._filteredRecords;
                //Render parent records again while no childs are retrieved from server.
                if (proxy._isLoadonDemand && proxy._searchString.length == 0 && proxy._filteredRecords == 0)
                    model.updatedRecords = model.flatRecords;
                if (model.allowSorting && model.sortSettings.sortedColumns.length > 0) {
                    proxy._sortingRecords();
                }
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
                isupdatedHeight = true;

                if (model.enableAltRow) {

                    proxy.updateAltRow();
                }

                proxy.clearSelection();

            }
            else if (model.allowSorting && sortcolumns.length > 0 || (args && args.requestType == "sorting")) {
                
                proxy._sortingRecords();
                if (model.showSummaryRow)
                    proxy._createSummaryRow(args);
                if (!isupdatedHeight)
                {
                    proxy.updateCollapsedRecordCount();
                    proxy.updateHeight();
                    isupdatedHeight = true;
                }
            }

            if (args && (args.requestType === "outdent" || args.requestType === "indent")) {
                args = {};
                args.requestType = ej.TreeGrid.Actions.Refresh;
                isupdatedHeight = true;
            }
            if (args && model.allowPaging && args.requestType == "delete") {
                var arg = {};
                if (!proxy._isLoadonDemand) {
                arg.totalRecordsCount = proxy.getExpandedRecords(model.flatRecords).length;                
                proxy.getPager().ejPager("option", arg).ejPager("refreshPager");
                var pagerModel = this.getPager().ejPager("model");
                if (proxy._currentPage() > pagerModel.totalPages)
                    proxy._currentPage(pagerModel.totalPages);
                isupdatedHeight = true;                
            }
            }

            if (!isupdatedHeight) {
                proxy._zerothLevelParentRecords = model.parentRecords.slice();
                model.updatedRecords = model.enableVirtualization ? ((model.enableCollapseAll && !args) ? proxy._zerothLevelParentRecords : proxy.getExpandedRecords(model.flatRecords)) : model.flatRecords.slice();
                proxy.updateCollapsedRecordCount();
                proxy.updateHeight();
            }

            if (!args) {
                args = {};
                if (model.allowPaging)
                    args.requestType = ej.TreeGrid.Actions.Paging;
                else
                    args.requestType = ej.TreeGrid.Actions.Refresh;
                args.inital = true;
            }
            

            proxy._updateCurrentViewData(args.requestType);

            if (!ej.isNullOrUndefined(model.printingEnabled) && model.printingEnabled && model.pageSettings.printMode=="currentPage") {
                var updatedRecords = this.getExpandedRecords(model.updatedRecords),
                    dataManager = new ej.DataManager(updatedRecords),
                    result = dataManager.executeLocal(model.query);
                model.currentViewData = result.result;
            }

             if ((!model.isFromGantt && args.requestType === "save") || args.requestType === "sorting" || args.requestType === "searching"
                || args.requestType === "delete" || args.requestType === "refreshDataSource" || args.requestType === "filtering"
                || args.requestType === "dragAndDrop" || ( !args.inital && args.requestType === "paging")) {
				    proxy._isRefreshAddedRecord = false; /* flag new added record is sorted or filtered in treegrid */
                proxy.renderRecords(args);
                proxy._updateWrapRowHeights(null,"refreshAll");
                proxy._setScrollTop();
                proxy.getScrollElement().ejScroller("refresh");
                proxy._updateScrollCss();
            }
        },
         //Remove parent & children records which available in the data collection 
        _removeChildRecords: function(data, record){
            var proxy = this, model = proxy.model,
                childRecords = ej.isNullOrUndefined(record.childRecords) ? [] : record.childRecords;
            var recordIndex = data.indexOf(record);
            if(recordIndex > -1){
                record.checkboxState = "unchecked";
                data.splice(recordIndex, 1);
            }
            for(var i = 0; i < childRecords.length; i++){                
                if(childRecords[i].hasChildRecords)
                    proxy._removeChildRecords(data, childRecords[i]);
                else{
                    recordIndex = data.indexOf(childRecords[i]);
                    if(recordIndex > -1){
                        childRecords[i].checkboxState = "unchecked";
                        data.splice(recordIndex, 1);
                    }
                }
            }
            if(record.parentItem && model.selectionSettings.enableHierarchySelection){                
                proxy._updateParentSelection(record.parentItem);
            }
        },
        //remove child record in data source on self reference
        _removeChildItem: function (record) {
            var currentRecord, proxy = this, idx;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                if (this.dataSource() instanceof ej.DataManager) {
                    if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                        idx = this.dataSource().dataSource.json.indexOf(currentRecord.item);
                        if(idx!==-1)
                            this.dataSource().dataSource.json.splice(idx, 1);

                        if (currentRecord.hasChildRecords) {
                            proxy._removeChildItem(currentRecord);
                        }
                    }
                    else if (proxy._isDataManagerUpdate) {
                        idx = proxy._jsonData.indexOf(currentRecord.item);
                        if (idx !== -1)
                            proxy._jsonData.splice(idx, 1);
                        if (currentRecord.hasChildRecords) {
                            proxy._removeChildItem(currentRecord);
                        }
                    }
                } else {
                    idx = this.dataSource().indexOf(currentRecord.item);
                    if (idx !== -1)
                        this.dataSource().splice(idx, 1);

                    if (currentRecord.hasChildRecords) {
                        proxy._removeChildItem(currentRecord);
                    }
                }
            }
        },

        //Update checkbox columnName to change dynamically 
        _updateCheckboxColumnName: function(){
            var proxy = this,
                model = proxy.model;

            // Checkbox column is decide by showCheckbox API or default 
            if (proxy._checkboxSelection) {
                var column = model.columns.filter(function (column) {
                    return column['showCheckbox'] == true;
                });
                proxy._addCheckboxColumn = this._getDefaultCheckboxColumn();
                proxy._checkboxColumnName = column.length > 0 ? column[0].isTemplateColumn ? null : column[0].field : null;
                if (ej.isNullOrUndefined(proxy._checkboxColumnName)) {
                    var treeGridIndexColumn = model.columns[model.treeColumnIndex];
                    if (!model.columns[0].nonColumn) {
                        model.columns.splice(0, 0, proxy._addCheckboxColumn);
                        proxy._checkboxColumnName = proxy._addCheckboxColumn.field;
                    }
                    else
                        proxy._checkboxColumnName = model.columns[0].field;
                    if (treeGridIndexColumn)
                        model.treeColumnIndex = model.columns.indexOf(treeGridIndexColumn);
                }
                if (proxy._frozenColumnsLength > 0 && !model.columns[0]['isFrozen'] &&
                        proxy._checkboxColumnName == proxy._addCheckboxColumn.field) {
                    model.columns[0]['isFrozen'] = true;
                    proxy._frozenColumnsLength += 1;
                    proxy._frozenColumns.splice(0, 0, model.columns[0]);
                    model.scrollSettings.frozenColumns = this._frozenColumnsLength;
                }

            }
        },

        //CHECK EDITING OPTIONS 
        _processEditing:function(){

            var proxy = this,
                model = proxy.model;

            if (proxy._checkboxSelection)
                proxy._updateCheckboxColumnName();

            if (model.editSettings.allowEditing || model.editSettings.allowAdding) {
                if (model.editSettings.editMode.toLowerCase() === "cellediting" || model.editSettings.editMode.toLowerCase() === "rowediting" || (model.editSettings.editMode.toLowerCase() === "normal" && model.selectionSettings.selectionMode.toLowerCase() === "cell")) {
                    proxy._addCellEditTemplate();
                } else if (model.editSettings.editMode.toLowerCase() === "dialogediting" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                    if ($("#" + this._id + "_dialogEdit").length == 0)
                        this.element.append(this._renderEditDialog());
                } else if (model.editSettings.editMode.toLowerCase() === "dialogediting" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                    if ($("#" + this._id + "_dialogEdit").length == 0)
                        this.element.append(this._renderEditDialog());
                }
            }

        },

        _toolBarClick: function (sender) {

            //Skip the mouse right click and mouse wheel
            if ((sender.event.which && (sender.event.which == 3 || sender.event.which == 2)) ||
                     (sender.event.button && sender.event.button == 2))
                return false;

            var proxy = this,
               model = proxy.model,
               $gridEle = $(this.itemsContainer).closest(".e-treegrid"),
               gridInstance = $gridEle.ejTreeGrid("instance"),
               gridId = $gridEle.attr('id'),
                toolbarObj = $("#" + gridInstance._id + "_toolbarItems");
            
            if (sender.event == undefined && sender.target.tagName == "INPUT" && sender.currentTarget.id == gridId + "_search")
                return false;

            if (gridInstance.model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $.isFunction($.fn.ejDateTimePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDateTimePicker("hide");
            else
                $.isFunction($.fn.ejDatePicker) && $("#" + gridId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = sender.currentTarget; var target = sender.target;
            var args = {
                itemName: sender.text,
                currentTarget: currentTarget,
                model: gridInstance.model,
                sender: sender
            };
            if ($gridEle.ejTreeGrid("instance")._trigger("toolbarClick", args))
                return false;
            $(toolbarObj).ejToolbar('deselectItem', sender.currentTarget);
            switch (sender.currentTarget.id) {

                case gridId + "_add":
                    gridInstance._toolbarOperation(gridId + "_add", sender);
                    break;

                case gridId + "_edit":
                    gridInstance._toolbarOperation(gridId + "_edit", sender);
                    break;

                case gridId + "_delete":
                    gridInstance._toolbarOperation(gridId + "_delete", sender);
                    break;

                case gridId + "_update":
                    gridInstance._toolbarOperation(gridId + "_update", sender);
                    break;

                case gridId + "_cancel":
                    gridInstance._toolbarOperation(gridId + "_cancel", sender);
                    break;

                case gridId + "_expandAll":
                    gridInstance._toolbarOperation(gridId + "_expandAll", sender);
                    break;

                case gridId + "_collapseAll":
                    gridInstance._toolbarOperation(gridId + "_collapseAll", sender);
                    break;
                case gridId + "_pdfExport":
                    gridInstance._toolbarOperation(gridId + "_pdfExport",sender);
                    break;
                case gridId + "_excelExport":
                    gridInstance._toolbarOperation(gridId + "_excelExport", sender);
                    break;
                case gridId + "_print":
                    gridInstance._toolbarOperation(gridId + "_print", sender);
                    break;
            }
            return false;
        },
        _toolbarOperation: function (operation, searchEle) {
            var $gridEle = this.element, gridObject = $gridEle.ejTreeGrid("instance"), gridId = $gridEle.attr('id'), proxy = this;
            var selectedrow = this.selectedItem();
            var parentEle = searchEle.target;
            var index = proxy.model.allowPaging ? this._updatedPageData.indexOf(selectedrow) : this.selectedRowIndex();
            gridObject._exportTo = gridObject["export"];
            switch (operation) {

                case gridId + "_add":
                    if (proxy.model.selectionSettings.selectionMode == "cell") {
                        proxy.model.editSettings.rowPosition = "top";
                    }
                    if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                        proxy._showTreeGridAddEditDialog(-1, "add");
                    } else {
                        proxy._startAdd(parentEle, null);
                    }
                    break;
                    
                case gridId + "_edit":
                    proxy.updateScrollBar();
                    if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                        proxy._showTreeGridAddEditDialog(index);
                    } else {
                        proxy._editRow(index);
                    }
                    break;

                case gridId + "_delete":
                    proxy.deleteRow();
                    proxy._cancelSaveTools();
                    proxy._isRefreshAddedRecord = false;/* flag new added record is sorted or filtered in treegrid */
                    break;

                case gridId + "_update":
                    editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {                      
                        if (this.editFormValidate()) {
                            if (proxy.model.isEdit)
                                this.saveCell();
                            else if (this._isRowEdit)
                                this.saveRow();
                        }
                    }
                    else if (editMode.toLowerCase() == "rowediting" && this.editFormValidate())
                        proxy.saveRow();
                    proxy._clearContextMenu();
                    this._removeDetailsRow();
                    proxy._focusTreeGridElement();

                    break;

                case gridId + "_cancel":
                    var editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {
                        if (proxy._isRowEdit)
                            proxy.cancelRowEditCell();
                        else proxy.cancelEditCell();
                    }
                    else if (editMode.toLowerCase() == "rowediting")
                        proxy.cancelRowEditCell();
                    proxy._cancelSaveTools();
                    proxy._clearContextMenu();
                    this._removeDetailsRow();
                    break;

                case gridId + "_expandAll":
                    proxy.expandAll();
                    break;

                case gridId + "_collapseAll":
                    proxy.collapseAll();
                    break;
                case gridId + "_pdfExport":
                    gridObject._exportTo(gridObject.model.exportToPdfAction, 'pdfExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_excelExport":
                    gridObject._exportTo(gridObject.model.exportToExcelAction, 'excelExporting', gridObject.model.allowMultipleExporting);
                    break;
                case gridId + "_print":
                    gridObject.print();
                    break;
            }
            proxy._refreshToolBar();
            return false;
        },

        // To print the page
        print: function () {
            var args = {}, proxy = this, model = proxy.model;
            args.requestType = "print";
            proxy._trigger("actionBegin", args);
            var printWin = window.open('', 'print', "height=452,width=1024,tabbar=no"), $printDiv = ej.buildTag("div#" + proxy._id + "Print"),
                cloneTreeGridModel = $.extend({}, proxy.model), cloneTreeGridModelColumn = $.extend(true, [], model.columns),
                columns = cloneTreeGridModelColumn, length = columns.length;
            cloneTreeGridModel.toolbarSettings = $.extend({}, model.toolbarSettings);
            cloneTreeGridModel.toolbarSettings.showToolbar = cloneTreeGridModel.allowPaging = false;
            cloneTreeGridModel.selectedItem = null;
            cloneTreeGridModel.enableVirtualization = false;
            cloneTreeGridModel.query.queries = [];
            cloneTreeGridModel.printingEnabled = true;            
            //To remove the frozen columns while printing.
            if (this._frozenColumnsLength > 0) {
                for (var i = 0; i < length; i++) {
                    if (columns[i].isFrozen)
                        columns[i].isFrozen = false;
                }
                cloneTreeGridModel.columns = columns;
            }
            if (this._commandColumnLength > 0) {
                for (var i = 0; i < length; i++) {
                    if (columns[i].commands) {
                        columns.splice(i, 1);
                        length--;
                        i--;
                    }
                }
                cloneTreeGridModel.columns = columns;
            }
            //To check the page settings to print the current page or all the pages.
            if (model.allowPaging && model.pageSettings.printMode == ej.TreeGrid.PrintMode.CurrentPage) {
                cloneTreeGridModel.query.queries = [{ fn: "onPage", e:{ pageIndex: proxy._currentPage(), pageSize: model.pageSettings.pageSize }}];
                cloneTreeGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            else {                
                cloneTreeGridModel.dataBound = function () {
                    this._printProcess(printWin);
                }
            }
            $printDiv.ejTreeGrid(cloneTreeGridModel);            
        },
        //To call the print option for TreeGrid.
        _printProcess: function (printWin) {
            var proxy = this,
                elementClone = this.element,
                args = { requestType: "print", element: elementClone};                      
            if (this.model.allowFiltering && this.model.filterSettings.filterType == "filterbar")
                elementClone.find(".e-filterbar").remove();
            $(elementClone).find(".e-gridheader").css({ "width": "auto" });
            this.clearSelection();
            elementClone.show();
            proxy._trigger("beforePrint", args);          
            ej.print(elementClone, printWin);
            proxy._trigger("actionComplete", args);
        },

		 // Perform Tree grid context menu operations.
        contextMenuOperations:function(option){
            var proxy = this,
                model = proxy.model,
                index = proxy._contextMenuSelectedIndex,
                e = proxy._contextMenuEvent,
                fieldName,
                item = proxy._contextMenuSelectedItem;
            switch (option)
            {
                case "Delete":
                    proxy.deleteRow(null,true);
                    proxy._cancelSaveTools();
                    proxy._clearContextMenu();
                    break;
                case "Above":
                    proxy._subContextMenuAction(item, index, "Above");
                    proxy._focusTreeGridElement();
                    break;
                case "Below":
                    proxy._subContextMenuAction(item, index, "Below");
                    proxy._focusTreeGridElement();
                    break;
                case "Add":
                    proxy._setInitialData();
                    proxy._clearContextMenu();
                    break;
                case "Edit":
                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        var column = model.columns[proxy.getCellIndex(e)];
                        if (!ej.isNullOrUndefined(column) && column.allowEditing != false) {
                            proxy._focusTreeGridElement();
                            proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                            proxy._editedRowIndex = proxy._cellEditingDetails.rowIndex = proxy.getRowIndex(e);
                            fieldName = proxy._cellEditingDetails.columnIndex >= 0 && column.field;
                            if (fieldName) {
                                proxy.updateScrollBar();
                                model.editSettings.allowEditing &&
                                    model.editSettings.editMode == ej.TreeGrid.EditMode.CellEditing &&
                                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName) && proxy._editAddTools();
                            }
                        }
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting") {
                        proxy.updateScrollBar();
                        proxy._editRow(index);
                    } else if (proxy.model.editSettings.editMode.toLowerCase() == "dialogediting") {
                        proxy._showTreeGridAddEditDialog(index);
                    }
                    proxy._clearContextMenu();
                    break;
                case "Save":
                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        if (this.editFormValidate()) {
                            if (proxy._isRowEdit)
                                proxy._endEdit();
                            else proxy.saveCell();
                        }
                        else
                            return true;
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting" && this.editFormValidate())
                        proxy.saveRow();
                    proxy._clearContextMenu();
                    proxy._focusTreeGridElement();
                    break;
                case "Cancel":
                    var editMode = proxy.model.editSettings.editMode;
                    if (editMode.toLowerCase() == "cellediting") {
                        if (proxy._isRowEdit)
                            proxy.cancelRowEditCell();
                        else if (model.isEdit) proxy.cancelEditCell();
                    }
                    else if (editMode.toLowerCase() == "rowediting")
                        proxy.cancelRowEditCell();
                    proxy._clearContextMenu();
                    proxy._focusTreeGridElement();
                    break;
                default:
                    var eventArgs = {};
                    eventArgs.data = item;
                    eventArgs.menuId = option;
                    proxy._triggerMenuEventHandler(option, eventArgs);
                    proxy._clearContextMenu();
                    break;
            }
            if (model.enableAltRow && model.currentViewData[0])
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);            
        },
        //Change the text based on culture information.
        _setCultureInfo: function () {
            var proxy = this,
              model = proxy.model,
              culture = model.locale,
              localization = proxy.localizedLabel, 
              defaultLocalization = ej.TreeGrid.Locale["default"];
            if (!(model.predecessorTable || model.resourceTable))
                localization = ej.TreeGrid.Locale[culture];
            else
                localization = ej.Gantt.Locale[culture];
            //Tooltip Text to be displayed in the Toolbar
            proxy._toolboxTooltipTexts = (localization && localization["toolboxTooltipTexts"])?
                localization["toolboxTooltipTexts"] : defaultLocalization["toolboxTooltipTexts"];

            //Context Menu Text
            proxy._contextMenuTexts = (localization && localization["contextMenuTexts"]) ?
                localization["contextMenuTexts"] : defaultLocalization["contextMenuTexts"];

            if (proxy.model.isFromGantt) {
                proxy._columnMenuTexts = proxy.model.columnMenuTexts;
                proxy._deleteColumnText = proxy.model.deleteColumnText;
                proxy._okButtonText = proxy.model.okButtonText;
                proxy._cancelButtonText = proxy.model.cancelButtonText;
                proxy._columnDialogTexts = proxy.model.columnDialogTexts;
                proxy._columnDialogTitle = proxy.model.columnDialogTitle;
                proxy._confirmDeleteText = proxy.model.confirmDeleteText;
                proxy._editTypeText = proxy.model.editTypeText;
                proxy._textAlignTypeText = proxy.model.textAlignTypeText;
                proxy._clipModeText = proxy.model.clipModeText;
            }
            else {
                //Column Menu Text
                proxy._columnMenuTexts = (localization && localization["columnMenuTexts"]) ?
                    localization["columnMenuTexts"] : defaultLocalization["columnMenuTexts"];
                
                //Add Column Dialog Text to be displayed in popup window
                proxy._columnDialogTexts = (localization && localization["columnDialogTexts"]) ?
                    localization["columnDialogTexts"] : defaultLocalization["columnDialogTexts"];

                //Add Column Dialog Titles
                proxy._columnDialogTitle = (localization && localization["columnDialogTitle"]) ?
                    localization["columnDialogTitle"] : defaultLocalization["columnDialogTitle"];

                //Deleting the column texts 
                proxy._deleteColumnText = (localization && localization["deleteColumnText"]) ?
                    localization["deleteColumnText"] : defaultLocalization["deleteColumnText"];
                proxy._okButtonText = (localization && localization["okButtonText"]) ?
                    localization["okButtonText"] : defaultLocalization["okButtonText"];
                proxy._cancelButtonText = (localization && localization["cancelButtonText"]) ?
                    localization["cancelButtonText"] : defaultLocalization["cancelButtonText"];
                proxy._confirmDeleteText = (localization && localization["confirmDeleteText"]) ?
                    localization["confirmDeleteText"] : defaultLocalization["confirmDeleteText"];

                //edit Types text
                proxy._editTypeText = (localization && localization["editTypeTexts"]) ?
                    localization["editTypeTexts"] : defaultLocalization["editTypeTexts"];

                //Edit types text
                proxy._textAlignTypeText = (localization && localization["textAlignTypes"]) ?
                    localization["textAlignTypes"] : defaultLocalization["textAlignTypes"];

                //Clip mode types text
                proxy._clipModeText = (localization && localization["clipModeTexts"]) ?
                    localization["clipModeTexts"] : defaultLocalization["clipModeTexts"];

                //String to be displayed in drop down list for filtering blank items
                proxy._dropDownListBlanksText = (localization && localization["dropDownListBlanksText"]) ?
                    localization["dropDownListBlanksText"] : defaultLocalization["dropDownListBlanksText"];

                //String to be displayed in drop down list to clear filtered items
                proxy._dropDownListClearText = (localization && localization["dropDownListClearText"]) ?
                    localization["dropDownListClearText"] : defaultLocalization["dropDownListClearText"];

                //Text to be displayed in drop down list for TRUE value in boolean edit type column
                proxy._trueText = (localization && localization["trueText"]) ?
                    localization["trueText"] : defaultLocalization["trueText"];

                //Text to be displayed in drop down list for FALSE value in boolean edit type column
                proxy._falseText = (localization && localization["falseText"]) ?
                    localization["falseText"] : defaultLocalization["falseText"];

                //EmptyRecord text to be displayed with dataSource is null
                proxy.model.emptyRecordText = (localization && localization["emptyRecord"]) ?
                    localization["emptyRecord"] : defaultLocalization["emptyRecord"];

                //Text to be displayed in filter menu
                proxy._filterMenuTexts = (localization && localization["filterMenuTexts"]) ?
                    localization["filterMenuTexts"] : defaultLocalization["filterMenuTexts"];
            }
        },

        //Create the instances for newly added row.
        _createNewRowInstance: function (obj) {
            var keys = [];
            for (var key in obj) {
                keys.push(key);
            }
            return keys;
        },
		
        //Public method to pass a datasource from customer side.

        //REFRESH THE TREEGRIDCONTENT
        

        refresh:function(datasource, query){
            var proxy = this, model = proxy.model;
            if (!ej.isNullOrUndefined(datasource)) {
                proxy.resetModelCollections();
                proxy._fieldNamesToQuery = [];
                proxy._assignedIdCollections = [];
                proxy._assignedParendIDs = [];
                model.dataSource = datasource;
                model.query = query;
                proxy.element.ejTreeGrid("destroy").ejTreeGrid(model);                
            }
            else {
                var args = {};
                args.requestType = ej.TreeGrid.Actions.Refresh;
                this.sendDataRenderingRequest(args);
            }
        },		
        /* get index for new record */
        _getNewIndex: function () {
            var proxy = this;
            proxy._maxRowIndex += 1;
            return (proxy._maxRowIndex);            
        },
        _getNewId: function () {
            var proxy = this,
                newId = proxy._lastInsertedId + 1;
            return newId;
        },
        _updateLastInsertedId: function (Id) {
            var proxy = this, newId = isNaN(parseInt(Id)) ? proxy._lastInsertedId < 1 ? 1 : proxy._lastInsertedId : parseInt(Id);
            proxy._lastInsertedId = proxy._lastInsertedId < newId ? newId : proxy._lastInsertedId;
        },
        //Add new record in treeGrid control
        _addRecord: function (data, rowPosition, isEdit, isFrom) {
            var proxy = this;

            /*Cancel if treegrid is in edit*/
            if (proxy.model.isEdit || proxy._isRowEdit) {
                proxy.cancelRowEditCell();
            }

            var model = this.model,
                selectedRowIndex = this.selectedRowIndex(),
                //selectedCellIndexes = this.selectedCellIndexes(),
                _cAddedRecord,
                updatedRecords = model.updatedRecords,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell],
                columns = model.columns,
                dataSource = this.dataSource(),
                level = 0, insertIndex, validateArgs = {}, currentPageRowIndex = -1,
                isRecordAdded = false,
                isToolbarAdd = false,
                newIndex,                
                dataChildCount,
                parentItem, nextBelowItemInflatRecords, nextBelowItemInUpdatedRecords,
                isParentItemAdd = false, args = {}, argsLevel, argsParentItem;

            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager)) {
                this.dataSource([]);
                dataSource = this.dataSource();
            }
            if (ej.isNullOrUndefined(data)) {
                data = null;
                for (var count = 0; count < columns.length; count++) {
                    data = proxy._restoreCustomData(data, "", columns[count].field);
                }
                isToolbarAdd = true;
            }
            if (model.idMapping && model.parentIdMapping && !ej.isNullOrUndefined(data[proxy.model.parentIdMapping]) && rowPosition != "child") {
                var parentRec = model.flatRecords.filter(function (item) {
                    return item[model.idMapping] == data[model.parentIdMapping];
                });
                if (parentRec.length > 0) {
                    selectedItem = parentRec[0];
                    rowPosition = ej.TreeGrid.RowPosition.Child;
                    isParentItemAdd = true;
                }
            }

            if ((selectedRowIndex === -1 && proxy._rowIndexOfLastSelectedCell == -1) && (rowPosition === ej.TreeGrid.RowPosition.Above
                 || rowPosition === ej.TreeGrid.RowPosition.Below
                 || rowPosition === ej.TreeGrid.RowPosition.Child) || !rowPosition || (model.selectedItems.length > 1 && !proxy._checkboxSelection)) {
                if (!isParentItemAdd)
                    rowPosition = ej.TreeGrid.RowPosition.Top;
            }
            if (rowPosition == ej.TreeGrid.RowPosition.Top || rowPosition == ej.TreeGrid.RowPosition.Bottom)
            {
                argsLevel = 0;
                argsParentItem = null;
            }
            else if (rowPosition == ej.TreeGrid.RowPosition.Above || rowPosition == ej.TreeGrid.RowPosition.Below) {
                argsLevel = selectedItem.level;
                argsParentItem = selectedItem.parentItem;
            }
            else if (rowPosition == ej.TreeGrid.RowPosition.Child) {
                argsLevel = selectedItem.level + 1;
                argsParentItem = selectedItem;
            }
            if (model.idMapping && model.parentIdMapping) {
                var id = data[model.idMapping];
                if (ej.isNullOrUndefined(id) || id == "" || isFrom == "contextMenu")
                    data[model.idMapping] = proxy._getNewId();
                else if (proxy._validateIdValue(id)) return false;
            }

            args.requestType = "add";
            args.data = data;
            args.level = argsLevel;
            args.rowPosition = rowPosition;
            args.parentItem = argsParentItem;
            if (!proxy._trigger("actionBegin", args)) {
                data = args.data;

                if (rowPosition != args.rowPosition)
                    rowPosition = args.rowPosition;

                if (data[model.childMapping] && data[model.childMapping].length)
                    delete data[model.childMapping]; // Remove the child items for externally adding row

                //Clear previously selected Item
                //proxy.clearSelection()
                proxy.selectRows(-1);
                newIndex = this._getNewIndex();

                switch (rowPosition) {
                    case ej.TreeGrid.RowPosition.Top:
                        level = 0;
                        parentItem = null;
                        _cAddedRecord = proxy._createRecord(data, level);
                        _cAddedRecord.index = newIndex;
                        
                        /*record update*/
                        flatRecords.splice(0, 0, _cAddedRecord);
                        updatedRecords.splice(0, 0, _cAddedRecord);
                        parentRecords.splice(0, 0, _cAddedRecord);

                        /*data source update*/
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(0, 0, _cAddedRecord.item);
                        } else {
                            dataSource.splice(0, 0, _cAddedRecord.item);
                        }
                        insertIndex = 0;
                        break;

                    case ej.TreeGrid.RowPosition.Bottom:
                        level = 0;
                        parentItem = null;
                        _cAddedRecord = proxy._createRecord(data, level);
                        _cAddedRecord.index = newIndex;
                        
                        /*record update*/
                        flatRecords.push(_cAddedRecord);
                        updatedRecords.push(_cAddedRecord);
                        //ids.push(newIndex);
                        parentRecords.push(_cAddedRecord);
                        /*data source update*/
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.push(_cAddedRecord.item);
                        } else {
                            dataSource.push(_cAddedRecord.item);
                        }
                        insertIndex = updatedRecords.indexOf(_cAddedRecord);
                        break;

                    case ej.TreeGrid.RowPosition.Above:
                        level = selectedItem.level;
                        parentItem = selectedItem.parentItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;                        

                        var childIndex, recordIndex, updatedCollectionIndex;
                        /*Record Updates*/
                        recordIndex = flatRecords.indexOf(selectedItem);
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem);
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);

                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        } else {
                            /* Parent records collection and data source update*/
                            parentRecords.splice(parentRecords.indexOf(selectedItem), 0, _cAddedRecord);
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                            }
                            else {
                                dataSource.splice(dataSource.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                    case ej.TreeGrid.RowPosition.Below:
                        level = selectedItem.level;
                        parentItem = selectedItem.parentItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;

                        //find next item position
                        var currentItemIndex = flatRecords.indexOf(selectedItem);

                        if (selectedItem.hasChildRecords) {
                            dataChildCount = proxy.getChildCount(selectedItem, 0);
                            recordIndex = currentItemIndex + dataChildCount + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                        } else {
                            recordIndex = currentItemIndex + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        }

                        /* Record collection update */
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        /* data Source update */
                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);

                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        } else {
                            /* Parent records collection and data source update*/
                            parentRecords.splice(parentRecords.indexOf(selectedItem) + 1, 0, _cAddedRecord);
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                dataSource.splice(dataSource.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                    case ej.TreeGrid.RowPosition.Child:
                        level = selectedItem.level + 1;
                        parentItem = selectedItem;
                        _cAddedRecord = proxy._createRecord(data, level, parentItem);
                        _cAddedRecord.index = newIndex;
                        
                        //find next item position
                        var currentItemIndex = flatRecords.indexOf(selectedItem);

                        if (selectedItem.hasChildRecords) {
                            dataChildCount = proxy.getChildCount(selectedItem, 0);
                            recordIndex = currentItemIndex + dataChildCount + 1;
                            //Expand Add record's parent item 
                            if (!selectedItem.expanded || !proxy.getExpandStatus(selectedItem)) {
                                var expanargs = {};
                                expanargs.expanded = true;
                                expanargs.data = selectedItem;
                                proxy._isInAdd = true;
                                /* refresh Added row on expand collapse */
                                if (proxy._isRefreshAddedRecord) {
                                    expanargs.data.expanded = true;
                                    proxy.updateExpandStatus(args.data, args.expanded);
                                    proxy.refreshContent();
                                    proxy._isRefreshAddedRecord = false;
                                } else {
                                    proxy._expandRecord(selectedItem);
                                }
                                proxy._isInAdd = false;
                                updatedRecords = proxy.getUpdatedRecords();
                            }
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1 - model.summaryRows.length;

                        } else {
                            if (proxy._isLoadonDemand)
                                selectedItem.isChildRetrieved = true;
                            if (!proxy.getExpandStatus(selectedItem))
                                proxy._expandRecord(selectedItem.parentItem);
                            updatedRecords = proxy.getUpdatedRecords();
                            selectedItem.hasChildRecords = true;
                            selectedItem.childRecords = [];
                            selectedItem.expanded = true;
                            if (!model.parentIdMapping) {
                                selectedItem.item[model.childMapping] = [];
                            }
                            selectedItem.isMilestone = false;
                            recordIndex = currentItemIndex + 1;
                            updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        }

                        /* Record collection update */
                        flatRecords.splice(recordIndex, 0, _cAddedRecord);
                        if (proxy._isLoadonDemand) {
                            if (selectedItem.isChildRetrieved)
                                updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        }
                        else
                            updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                        //ids.splice(recordIndex, 0, newIndex);

                        /* data Source update */
                        if (!ej.isNullOrUndefined(parentItem)) {
                            childIndex = parentItem.childRecords.indexOf(selectedItem);
                            /*Child collection update*/
                            parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                            if (!model.parentIdMapping) {
                                parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                            }
                            else {
                                _cAddedRecord.item[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                _cAddedRecord[model.parentIdMapping] = _cAddedRecord.parentItem.item[model.idMapping];
                                if (proxy._isDataManagerUpdate) {
                                    proxy._jsonData.push(_cAddedRecord.item);
                                } else {
                                    dataSource.push(_cAddedRecord.item);
                                }
                            }
                        }
                        insertIndex = updatedCollectionIndex;
                        break;
                }
                if (model.allowPaging) {
                    //Goto next page if New record insertIndex exit than pagesize
                    if (rowPosition == ej.TreeGrid.RowPosition.Below || rowPosition == ej.TreeGrid.RowPosition.Child) {
                        if ((model.pageSettings.pageSizeMode !== "root" || ej.isNullOrUndefined(selectedItem.parentItem))) {
                            var targetData = proxy._updatedPageData[proxy._updatedPageData.length - 1],
                                currentIndex = proxy._updatedPageData.length == model.pageSettings.pageSize ?
                                model.updatedRecords.indexOf(targetData) : insertIndex;
                            if (insertIndex > currentIndex) {
                                proxy._currentPage(this._currentPage() + 1);
                                currentPageRowIndex = 0;
                            }
                        }
                    }
                        //Goto first page
                    else if (rowPosition == ej.TreeGrid.RowPosition.Top && (proxy._currentPage() > 1 || proxy._currentPage() < 1)) {
                        proxy._currentPage(1);
                        currentPageRowIndex = 0;
                    }
                        //Goto last page
                    else if (rowPosition == ej.TreeGrid.RowPosition.Bottom && proxy._currentPage() < model.pageSettings.totalPages) {
                        proxy._currentPage(model.pageSettings.totalPages);
                        currentPageRowIndex = insertIndex;
                    }

                }
                if (!isToolbarAdd && (ej.TreeGrid.RowPosition.Above || ej.TreeGrid.RowPosition.Below)) {
                    var args = {},
                        currentValue = {},
                        columns = model.columns,
                        length = columns.length;
                    if (!model.allowPaging)
                        currentPageRowIndex = insertIndex;
                    args.rowIndex = insertIndex;
                    args.requestType = "addNewRow";
                    args.addedRow = data;

                    if (!proxy._trigger("actionComplete", args)) {
                        proxy._renderAddedRow(insertIndex, _cAddedRecord);
                        if (model.showSummaryRow) {
                            if (args.requestType == "addNewRow" && rowPosition == "child") {
                                proxy._createAndRenderSummaryRecords(args);
                            }
                            proxy._updateSummaryRow(args);
                        }
                        if (model.showTotalSummary)
                            proxy._updateTotalSummaryRow(args);
                        isRecordAdded = true;
                        if (model.idMapping && model.parentIdMapping) {
                            proxy. _updateLastInsertedId(_cAddedRecord[model.idMapping]);                            
                        }                        
                    }
                    else {
                        updatedRecords.splice(insertIndex, 1);
                    }
                }
                else {
                    proxy._renderAddedRow(insertIndex, _cAddedRecord);
                    isRecordAdded = true;
                }

                /*Set flag for refresh newly added record in non virtalization mode*/
                if (model.enableVirtualization === false &&
                    (model.sortSettings.sortedColumns.length > 0 || model.filterSettings.filteredColumns.length > 0)) {
                    proxy._isRefreshAddedRecord = true;
                }
                if (model.allowPaging)
                    updatedRecords = proxy._updatedPageData;
                /* select add row */
                var currentRowIndex = isRecordAdded ? updatedRecords.indexOf(_cAddedRecord) : selectedRowIndex;
                
                if (currentRowIndex == -1)
                    currentRowIndex = selectedRowIndex;

                if (model.allowSelection && model.selectionSettings.selectionMode == "row") {
                    
                    if (!proxy._rowSelectingEventTrigger(this._previousIndex, currentRowIndex)) {  
						proxy.selectRows(currentRowIndex);					
                        if (model.selectionSettings.enableSelectAll)
                            proxy.selectAllRows();
                        if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection && _cAddedRecord.parentItem)
                            proxy._updateParentSelection(_cAddedRecord.parentItem);
                        proxy._rowSelectedEventTrigger(currentRowIndex);
                    }
                }
                if (!model.allowSelection && model.selectionSettings.selectionMode == "row") {
                    proxy.selectRows(currentRowIndex);
                }
                if (model.selectionSettings.selectionMode == "cell")
                    proxy._rowIndexOfLastSelectedCell = updatedRecords.indexOf(_cAddedRecord);
                /* scroll to new added record */
                proxy.updateScrollBar();

                if (isEdit == "isEditRow") {
                    proxy._editRow(updatedRecords.indexOf(_cAddedRecord), _cAddedRecord);
                }
                else {
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(_cAddedRecord));
                    proxy._cancelSaveTools();
                    if (model.enableAltRow)
                        ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
                }
                //refresh parent item for expand collapse icons
                if (_cAddedRecord.parentItem && rowPosition == ej.TreeGrid.RowPosition.Child && (_cAddedRecord.parentItem.childRecords.length == 1 || !_cAddedRecord.parentItem.hasFilteredChildRecords)) {
                    _cAddedRecord.parentItem.hasFilteredChildRecords = true;
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(_cAddedRecord.parentItem));
                }
                if (model.allowTextWrap && proxy._$frozenTableContent.length > 0) {
                    proxy._updateWrapRowHeights("total,header");
                    proxy.updateHeight();
                } else if (model.allowTextWrap && model.enableVirtualization) {
                    proxy.updateHeight();
                }
            } else {
                if (isFrom == "dialog")
                    return false;
            }
            if (proxy._commandColumnLength > 0) {
                if (ej.isNullOrUndefined(isEdit)) {
                    var tr = ej.TreeGrid.getRowByIndex(proxy, currentRowIndex)
                    proxy._refreshUnboundTemplate(tr);
                }
                if (rowPosition == ej.TreeGrid.RowPosition.Child) {
                    var parentIndex = updatedRecords.indexOf(_cAddedRecord.parentItem),
                    parentTr = ej.TreeGrid.getRowByIndex(proxy, parentIndex);
                    proxy._refreshUnboundTemplate(parentTr);
                }
            }
            return true;
        },

        //validate the taskId to avoid duplicate value
        _validateIdValue: function (dataID) {
            var proxy = this, model = proxy.model,
                matchedItem = [],
                fRecords = model.flatRecords;
            if (proxy._isLoadonDemand) {
                matchedItem = $.map(proxy._assignedIdCollections, function (value) {
                    if (value == dataID)
                        return value;
                });
            }
            else {
                matchedItem = $.map(fRecords, function (record) {
                    if (record[model.idMapping] == dataID)
                        return record;
                });
            }
            if (matchedItem.length)
                return true;
            else return false;
        },         
         
        // Method to trigger the actionbegin event while close the Add/Edit dialog
        _closeTreegridAddEditDialog: function (args, type) {
            var proxy = this;
            var eventArgs = {};
            if (proxy._isTreeAddEditDialogSave)
                proxy._isTreeAddEditDialogSave = false;
            else {
                if (type === "Add")
                    eventArgs.requestType = "closeAddDialog";
                else
                    eventArgs.requestType = "closeEditDialog";
                return proxy._trigger("actionBegin", eventArgs);
            }
        },

        // Public method to show the Add dialog/Add template dialog
        showAddDialog: function () {
            var proxy = this;
            if (proxy.model.editSettings.allowAdding && proxy.model.editSettings.editMode == "dialogEditing")
                proxy._showTreeGridAddEditDialog(null, "add");
        },

        // Public method to show the Edit dialog/Edit template dialog
        showEditDialog: function (index) {
            var proxy = this;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing")
                proxy._showTreeGridAddEditDialog(index);
        },

        // Method to open/show the ADD/EDIT dialog from all possible ways (double/single click edit, toolbar click, public method, context menu)
        _showTreeGridAddEditDialog: function (index, addrow) {
            var temp = document.createElement('div'), proxy = this,
            $temp = $(temp), controlPosition = proxy.getOffsetRect($("#" + proxy._id)[0]),
            currentData = [], columns = proxy.model.columns, contextMenuLabel = proxy._contextMenuTexts;
            if ((ej.isNullOrUndefined(index) || index == -1) && !addrow) {
                if (proxy.model.selectionSettings.selectionMode == "cell")
                    index = proxy.selectedCellIndexes()[0].rowIndex;
                else
                    index = proxy.selectedRowIndex();
            }
            currentData[0] = proxy.model.allowPaging ? this._updatedPageData[index] : proxy.model.updatedRecords[index];
            if (addrow && addrow.toLowerCase() === "add") {
                if (ej.isNullOrUndefined(currentData[0])) {
                    currentData[0] = null;
                    for (var count = 0; count < columns.length; count++) {
                        currentData[0] = proxy._restoreCustomData(currentData[0], "", columns[count].field);
                    }
                    if (proxy.model.parentIdMapping)
                        currentData[0][proxy.model.idMapping] = proxy._getNewId();
                }
                $temp.addClass("e-dialogaddrow");
            } else {
                $temp.addClass("e-dialogeditedrow");
            }
            if (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")
                temp.innerHTML = $.render[this._id + "_JSONDialogEditingTemplate"](currentData);
            else if (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")
                temp.innerHTML = $.render[this._id + "_JSONdialogTemplateMode"](currentData);

            if (this.model.editSettings.editMode == "dialogEditing") {
                $("#" + this._id + "_dialogEdit").html($(temp));
                var model = {};
                model.cssClass = this.model.cssClass;
                model.enableRTL = false;
                model.enableResize = false;
                model.showOnInit = false;
                model.content = "#" + this._id;
                if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                    model.width = $("#" + proxy._id).width() + "px";
                    model.height = $("#" + proxy._id).height() + "px";
                    model.enableModal = false;
                    model.isResponsive = false;
                    model.allowDraggable = false;
                } else {
                    model.width = "auto";
                    model.height = "auto";
                    model.enableModal = true;
                    model.isResponsive = false;
                    model.allowDraggable = true;
                }
                model.allowKeyboardNavigation = false;
                if (addrow && addrow.toLowerCase() === "add") {
                    model.title = contextMenuLabel["addRowText"];
                    model.beforeClose = function (args) {
                        if (proxy._closeTreegridAddEditDialog(args, "Add"))
                            args.cancel = true; // Cancel the add dialog box close.
                    };
                }
                else {
                    model.title = contextMenuLabel["editText"];
                    model.beforeClose = function (args) {
                        if (proxy._closeTreegridAddEditDialog(args, "Edit"))
                            args.cancel = true; // Cancel the add dialog box close.
                    };
                }
                $("#" + this._id + "_dialogEdit").ejDialog(model);
                var dialogArgs = {};
                dialogArgs.data = currentData[0];
                if (addrow && addrow.toLowerCase() === "add") {
                    dialogArgs.requestType = "beforeOpenAddDialog";
                    dialogArgs.rowPosition = proxy.model.editSettings.rowPosition;
                }
                else
                    dialogArgs.requestType = "beforeOpenEditDialog";
                dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                if (!proxy._trigger("actionBegin", dialogArgs)) {
                    var args = {};
                    args.columnIndex = index;
                    args.data = dialogArgs.data;
                    args.requestType = "beginEdit";
                    proxy._refreshEditForm(args);
                    dialogArgs.data = args.data;
                    if (addrow && addrow.toLowerCase() === "add")
                        dialogArgs.requestType = "openAddDialog";
                    else
                        dialogArgs.requestType = "openEditDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        $("#" + this._id + "_dialogEdit").ejDialog("open");
                        proxy._currentEditRecordDialogIndex = index;
                        if ($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) {
                            $("#" + proxy._id + "_dialogEdit_wrapper").css({ 'left': controlPosition.left + "px", 'top': controlPosition.top + "px" });
                            $("#" + proxy._id + "_dialogEdit_wrapper").removeClass("e-shadow").removeClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "_dialogEdit").removeClass("e-shadow");
                        } else {
                            $("#" + proxy._id + "_dialogEdit_wrapper").addClass("e-shadow").addClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "_dialogEdit").addClass("e-shadow");
                        }
                        this._on($("#" + this._id + "_dialogEdit"),
                       "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        $("#" + proxy._id + "_dialogEdit").ejDialog("refresh");
                    }
                }
            }
            if ($.isFunction($.validator)) {
                proxy._initValidator();
                proxy.setValidation();
            }
        },

        //Public method for adding new record
        addRow: function (data, rowPosition) {
            var proxy = this, model = proxy.model;
            /* Cancel edited cell before sort the column*/
            proxy._cancelEditState();

            if (!data) {
                proxy._addRecord(null, rowPosition, "isEditRow");
            } else {
                if (proxy._addRecord(data, rowPosition)) return true;
                else
                    return false;
            } 
        },

        _startAdd: function (parentEle, rowPos) {
            var proxy = this, model = this.model, rowPosition;
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
            proxy._addRecord(null, model.editSettings.rowPosition, "isEditRow");
        },
        _getRecordIndexByItem: function (item, collection) {
            var record = ej.DataManager(collection).executeLocal(ej.Query().where("item", ej.FilterOperators.equal, item));
            if (record.length > 0)
                return collection.indexOf(record[0]);
            else
                return -1;
        },
        /* update the reord's expand status in expanded state*/
        _expandRecord: function (record)
        {
            if (this._isLoadonDemand && !record.isChildRetrieved)
                return;
            var parentItem = record, args = {};
            while (parentItem != null) {
                if (parentItem.expanded == false) {
                    args.expanded = true;
                    args.data = parentItem;
                    if (!parentItem.parentItem)
                        this._isInExpandCollapseAll = false;
                    else
                        this._isInExpandCollapseAll = true;
                    ej.TreeGrid.sendExpandCollapseRequest(this, args);
                }
                parentItem = parentItem.parentItem;
            }
        },

        /* Public method for scroll to the corresponding offset value */
        scrollOffset: function (left, top) {
            var scrollerObj = this.getScrollElement().data("ejScroller"),
                model = this.model;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            if ((typeof top == "number" || typeof parseInt(top) == "number")) {
                top = parseInt(top);
                if(top >= 0 && this.getMaxScrollHeight() > top)
                    scrollerObj.scrollY(top, true);
            }
            if (typeof left == "number" || typeof parseInt(left) == "number") {
                left = parseInt(left);
                if (left >= 0 && this.getMaxScrollWidth() > left)
                    scrollerObj.scrollX(left, true);
            } 
        },
        /* Public method for get scrollTop value*/
        getScrollTopOffset: function () {
            return this.getScrollElement().ejScroller("model.scrollTop");
        },
        /* Public method for get scrollLeft value*/
        getScrollLeftOffset: function () {
            return this.getScrollElement().ejScroller("model.scrollLeft");
        },
        /* Public method for scroll to first row of treegrid*/
        scrollToTop:function()
        {
            var model = this.model,
                updatedRecords = this.getUpdatedRecords(), record, rowIndex = -1;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            updatedRecords = model.allowPaging ? updatedRecords : this.getExpandedRecords(model.updatedRecords);
            if (updatedRecords.length > 0) {
                rowIndex = 0;
                record = updatedRecords[0];
                rowIndex = updatedRecords.indexOf(record);
                if (model.allowSelection && !this._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                    this.selectRows(rowIndex);
                    this._rowSelectedEventTrigger(rowIndex);
                }
                this.updateScrollBar(rowIndex);
            }
        },
        /* Public method for scroll to last row of treegrid*/
        scrollToBottom: function ()
        {
            var model = this.model,
                updatedRecords, record, rowIndex = -1;

            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            updatedRecords = this.getExpandedRecords(model.updatedRecords);

            if (updatedRecords.length > 0) {
                rowIndex = updatedRecords.length - 1;
                record = updatedRecords[rowIndex];
                rowIndex = model.updatedRecords.indexOf(record);
                if (model.allowSelection && !this._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                    this.selectRows(rowIndex);
                    this._rowSelectedEventTrigger(rowIndex);
                }
                this.updateScrollBar(rowIndex);
            }
        },

        //ENABLE AND DISABLE THE CORRESPONDING TOOLS WHILE ADDING AND EDITING THE ROW RECORD.
        _editAddTools: function () {
            var proxy = this, model = proxy.model;
            var toolbar = $("#" + proxy._id + "_toolbarItems");
            var editSettings = proxy.model.editSettings,
            toolbarItems = model.toolbarSettings.toolbarItems;
            var disableToolItems = [];
            if (editSettings.allowAdding && toolbarItems.indexOf("add") !== -1 && !$(toolbar).find(".e-addnew").parent("li").hasClass("e-disable"))
                disableToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
            if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1 && !$(toolbar).find(".e-edit").parent("li").hasClass("e-disable"))
                disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
            if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1 && !$(toolbar).find(".e-delete").parent("li").hasClass("e-disable") && model.editSettings.beginEditAction != "click")
                disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
            disableToolItems.forEach(function (element) {
                $(toolbar).ejToolbar('disableItem', element);
            });

            var enabledToolItems = [];
            if (toolbarItems.indexOf("cancel") !== -1)
                enabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
            if (toolbarItems.indexOf("update") !== -1)
                enabledToolItems.push($(toolbar).find(".e-save").parent()[0]);
            enabledToolItems.forEach(function (element) {
                $(toolbar).ejToolbar('enableItem', element);
            });

        },
        //ENABLE AND DISABLE THE CORRESPONDING TOOLS WHILE CANCEL AND SAVING THE ROW RECORD.
        _cancelSaveTools: function () {
            var proxy = this,
                model = proxy.model,
                editSettings = proxy.model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                parentRecords = [],
                enabledToolItems,
                disableToolItems,
                toolbarItems = model.toolbarSettings.toolbarItems;
            if (!model.isFromGantt) {
                enabledToolItems = [];
                disableToolItems = [];
                if (editSettings.allowAdding) {
                    if (toolbarItems.indexOf("add") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-addnew").parent()[0]);
                }

                if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1) {
                    if (proxy.selectedRowIndex() != -1 && model.allowSelection && (model.selectedItems.length == 1 || proxy._checkboxSelection)  && editSettings.beginEditAction != "click")
                        enabledToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                    else if (!$(toolbar).find(".e-edit").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-edit").parent()[0]);
                }
                if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1) {
                    if ((proxy.selectedRowIndex() != -1 || (model.selectedItems.length >= 0 && proxy._checkboxSelection)) && model.allowSelection && model.selectedItems.length > 0)
                        enabledToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                    else if (!$(toolbar).find(".e-delete").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                } else {
                    disableToolItems.push($(toolbar).find(".e-delete").parent()[0]);
                }

                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);

                if (parentRecords.length <= 0) {
                    if (toolbarItems.indexOf("expandAll") !== -1 && !$(toolbar).find(".e-expandall").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-expandall").parent()[0]);
                    if (toolbarItems.indexOf("collapseAll") !== -1 && !$(toolbar).find(".e-collapseall").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-collapseall").parent()[0]);
                }
                else {
                    if (toolbarItems.indexOf("expandAll") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-expandall").parent()[0]);
                    if (toolbarItems.indexOf("collapseAll") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-collapseall").parent()[0]);
                }
                if (editSettings.beginEditAction != "click" || (editSettings.beginEditAction == "click" && !model.isEdit)) {
                    if (toolbarItems.indexOf("cancel") !== -1 && !$(toolbar).find(".e-cancel").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    if (toolbarItems.indexOf("update") !== -1 && !$(toolbar).find(".e-save").parent("li").hasClass("e-disable"))
                        disableToolItems.push($(toolbar).find(".e-save").parent()[0]);
                }

                disableToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('disableItem', element);
                });
                enabledToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('enableItem', element);
                });
            }
            else {
                var toolbar = $("#" + proxy._id.replace("ejTreeGrid", "") + "_toolbarItems");
                var enabledToolItems = [],disableToolItems = [];
                if (model.readOnly == true) {
                    disableToolItems = [];
                    disableToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                }
                else {
                    if (editSettings.allowAdding && toolbarItems.indexOf("add") !== -1)
                        enabledToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);

                    if (editSettings.allowEditing && toolbarItems.indexOf("edit") !== -1 && model.allowSelection && editSettings.beginEditAction != "click") {
                        if (proxy.selectedRowIndex() != -1)
                            enabledToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                        else
                            disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    }
                    if (editSettings.allowDeleting && toolbarItems.indexOf("delete") !== -1 && model.allowSelection) {
                        if (proxy.selectedRowIndex() != -1)
                            enabledToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                        else
                            disableToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    }
                    if (editSettings.allowIndent && (toolbarItems.indexOf("indent") !== -1 || toolbarItems.indexOf("outdent") !== -1) && model.allowSelection) {
                        if (proxy.selectedRowIndex() == -1) {
                            disableToolItems.push($(toolbar).find(".e-indent").parent()[0]);
                            disableToolItems.push($(toolbar).find(".e-outdent").parent()[0]);
                        }
                    }
                    $(toolbar).ejToolbar('enableItem', enabledToolItems);

                  
                    if (toolbarItems.indexOf("cancel") !== -1)
                        disableToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    if (toolbarItems.indexOf("update") !== -1)
                        disableToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                }
                disableToolItems.forEach(function (element) {
                    $(toolbar).ejToolbar('disableItem', element);

                });
            }
        },

        
        _checkIsEmptyRow: function (item) {
            var column = this.model.columns,
                itemIndex;
                    for (itemIndex = 0; itemIndex < column.length ; itemIndex++) {
                        var value = this._getCustomCellValue(item, column[itemIndex].field);
                        if (value === " " || ej.isNullOrUndefined(value) || value === "" || value === false)
                            continue;
                        return false;
                    }
            return true;
        },
        /*Method to trigger begin edit event*/   
        _beginEdit: function () {
            var proxy = this, args = {};
            proxy._trigger("beginEdit", args);
            proxy._isinBeginEdit = true;           
        },

        /*Method to save edited/added row*/
        _endEdit: function () {
            var proxy = this;

            proxy._isinBeginEdit = false;
            var index = this.selectedRowIndex();
            var tr = ej.TreeGrid.getRowByIndex(proxy, index);
            if (this.editFormValidate()) {
                if ($('tr').hasClass("e-addedrow") || $('tr').hasClass("e-rowedit"))
                    proxy.saveRow();
                else
                    proxy.saveCell();
            }
            else
                return true;

        },
        //Refresh the treegrid content after expandAll or collapseAll
        _refreshTreeGridOnExpandCollapseAll:function(args)
        {
            var proxy = this,
                model = this.model;
            if (model.enableVirtualization) {
                if (model.enableAltRow)
                    proxy.updateAltRow();
                proxy.sendDataRenderingRequest(args);
                if (model.allowTextWrap) {
                    if (proxy._$frozenTableContent.length > 0)
                        proxy._updateRowHeight();
                    proxy._setScrollTop(args.requestType);
                    proxy.updateHeight();
                    if (proxy.getScrollElement().hasClass("e-scroller")) {
                        proxy.getScrollElement().ejScroller("refresh");
                    }
                } else {
                    proxy._setScrollTop();
                    proxy.updateHeight();
                }
            }             
            else {
                if (model.allowPaging) {
                    var arg = {},
                        pagerModel;
                    arg.totalRecordsCount = this.getExpandedRecords(model.updatedRecords).length;
                    proxy.getPager().ejPager("option", arg).ejPager("refreshPager");
                    pagerModel = this.getPager().ejPager("model");
                    proxy._currentPage(pagerModel.currentPage);
                    arg.requestType = "paging";
                    proxy.processBindings(arg);
                }
                //If need refresh chart if record is added after searching or sorting
                if (proxy._isRefreshAddedRecord) {
                    proxy.processBindings();
                    this.renderRecords();
                    proxy._isRefreshAddedRecord = false;
                    return;
                }
                if (model.allowTextWrap && proxy._$frozenTableContent.length > 0) {
                    proxy.getScrollElement().ejScroller("refresh");
                    var movableScrollTop = proxy.getScrollElement().ejScroller("model.scrollTop");
                    proxy._getFrozenScrollElement().scrollTop(movableScrollTop);
                } else {
                    proxy.updateHeight();
                }
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
            }
        },
        //expand or collapse all inner level child records on expandAll or collapseAll
        _expandCollapseInnerLevelRecord: function (record, expanded) {
            var proxy = this,
                length = record.childRecords.length,
                tempArgs = {};

            for (var count = 0; count < length; count++) {
                if (record.childRecords[count].hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(record.childRecords[count], expanded);
                    tempArgs.data = record.childRecords[count];
                    tempArgs.expanded = expanded;
                    if (record.childRecords[count].expanded != expanded) {

                        if (proxy._isLoadonDemand && !record.childRecords[count].isChildRetrieved) {
                            proxy._isInExpandCollapseAll = true;
                            tempArgs.requestType = ej.TreeGrid.Actions.ExpandCollapse;
                            var isNotExpanded = ej.TreeGrid.expandRowsonDemand(proxy, record.childRecords[count], tempArgs);
                            if (isNotExpanded) {
                                proxy._allParentItems.splice(proxy._allParentItems.indexOf(record.childRecords[count]), 1);
                                record.childRecords[count].expanded = false;
                                continue;
                            }
                            else {
                                return true;
                            }
                        }
                        else
                            ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);
                    }
                }
            }
        },
        _expandParentLevelRecord: function (record, expanded) {
            var proxy = this,               
                tempArgs = {};
            var parentExpandState = proxy.getExpandStatus(record);
            if (!record.expanded || !parentExpandState) {
                tempArgs.data = record;
                tempArgs.expanded = expanded;
                ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);
                if (tempArgs.data.parentItem) {
                    proxy._expandParentLevelRecord(tempArgs.data.parentItem, expanded);
                }
            }
        },
        // expand the specified level record
        expandAtLevel: function (index) {
            var proxy = this, args = {}, treegridRecord,
                parentRecords = proxy._getParentRecords(proxy.model.updatedRecords, proxy);
            for (var count = 0; count < parentRecords.length; count++) {
                treegridRecord = parentRecords[count];
                if (treegridRecord.level == index) {
                    args.data = treegridRecord;
                    args.expanded = true;
                    if (proxy._isLoadonDemand && !treegridRecord.isChildRetrieved) {
                        args.recordLevel = index;
                        args.isExpandingParticularLevelParent = true;
                        args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
                        var isNotExpanded = ej.TreeGrid.expandRowsonDemand(proxy, treegridRecord, args);
                        if (isNotExpanded) {
                            proxy._allParentItems.splice(proxy._allParentItems.indexOf(treegridRecord), 1);
                            treegridRecord.expanded = false;
                            continue;
                        }
                        else {
                            return;
                        }
                    }
                    else
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    // expand its parent if it is collapsed.
                    if (treegridRecord.parentItem && !treegridRecord.parentItem.expanded) {
                        proxy._expandParentLevelRecord(treegridRecord.parentItem, args.expanded);
                    }
                    
                }
            }
        },
        // collapse the specified level record
        collapseAtLevel: function (index) {
            var proxy = this, args = {},
                model = proxy.model,
                treegridRecord,
                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);
            for (var count = 0; count < parentRecords.length; count++) {
                treegridRecord = parentRecords[count];                
                if (treegridRecord.level == index && treegridRecord.expanded) {
                    var parentExpandState = proxy.getExpandStatus(treegridRecord);
                    if (parentExpandState) {
                        args.data = treegridRecord;
                        args.expanded = false;
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
            }
        },

        // expand/collapse the specified record using its index
        expandCollapseRow: function (index) {
            var proxy = this, args = {}, treegridRecord;
            index = parseInt(index);
            if (proxy.model.updatedRecords.length > index && index >= 0) {
                treegridRecord = proxy.model.updatedRecords[index];
                if (treegridRecord.hasChildRecords) {
                    args.data = treegridRecord;
                    if (treegridRecord.expanded)
                        args.expanded = false;
                    else
                        args.expanded = true;
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
        },

        //Expand the child records from parent.
        expandAll: function () {

            var proxy = this,
                model = proxy.model,
                count = 0,
                treegridRecord,
                args = {};

            if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            else if(proxy.model.isEdit)
                proxy.cancelEditCell();

            args.requestType = ej.TreeGrid.Actions.ExpandCollapse;

            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control

            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                treegridRecord = proxy.model.parentRecords[count];
                args.data = treegridRecord;
                args.recordIndex = count;
                args.expanded = true;
                if (treegridRecord.hasChildRecords) {
                    if (proxy._isLoadonDemand && !treegridRecord.isChildRetrieved) {                        
                        proxy._isInExpandCollapseAll = true;                     
                        var isNotExpanded = ej.TreeGrid.expandRowsonDemand(proxy, treegridRecord, args);
                        if (isNotExpanded) {
                            proxy._allParentItems.splice(proxy._allParentItems.indexOf(treegridRecord), 1);
                            treegridRecord.expanded = false;
                            continue;
                        }
                        else {                                                        
                            return;
                        }
                    }
                    else {
                        var isServerCalled = proxy._expandCollapseInnerLevelRecord(treegridRecord, args.expanded);
                        if (isServerCalled)
                            return;
                        if (treegridRecord.expanded != args.expanded)
                            ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }               
            }

            if (model.flatRecords.length > 0)
                proxy._refreshTreeGridOnExpandCollapseAll(args);

            proxy._isInExpandCollapseAll = false;
        },

           

        _refreshToolBar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            $toolbar.find("li").removeClass("e-hover");
        },

        //RENDER TOOL BAR
        _renderToolbar: function () {
            var proxy = this,
                model = proxy.model,
                element = proxy.element;
            if (!model.isFromGantt) {
                if (proxy.model.toolbarSettings.showToolbar) {
                    element.append(proxy._renderToolbarTemplate());
                }
                if (proxy.model.isResponsive) {
                    $("#" + proxy._id + "_toolbarItems").addClass("e-treegridadaptivetoolbar");
                }
            }
        },

        //RENDER TOOLBAR TEMPLATE
        _renderToolbarTemplate: function () {
            var proxy = this,
                model = proxy.model,
                $div = ej.buildTag("div.e-treegridtoolbar#" + proxy._id + "_toolbarItems", "", { 'height': '36px', 'border': '1px solid' }, { "data-unselectable": "on" });
            if(!ej.isNullOrUndefined(model.toolbarSettings.toolbarItems) && model.toolbarSettings.toolbarItems.length){
                var $ul = ej.buildTag("ul", "", {},{});
                proxy._renderLi($ul);
                $div.append($ul);
            }
            if (!ej.isNullOrUndefined(model.toolbarSettings.customToolbarItems) && model.toolbarSettings.customToolbarItems.length) {
                var $customUl = ej.buildTag("ul", "", {}, {});
                proxy._renderCustomLi($customUl);
                $div.append($customUl);
            }
            var helper = {};
            helper.click = proxy._toolBarClick;
            helper.cssClass = proxy.model.cssClass;
            helper.rtl = false;
            helper.itemSeparator = false;
            helper.itemLeave = proxy._toolbarItemLeave;
            helper.width = proxy._gridWidth;
            helper.fields = {
                id: "",
                tooltipText: "",
                imageUrl: "",
                text: "",
                imageAttributes: "",
                spriteCSS: "",
                htmlAttributes: "",
            };
            $div.ejToolbar(helper);
            $div.ejToolbar("disableItem", proxy._disabledToolItems);
            proxy._disabledToolItems = $();
            return $div;
        },        
        //to renderCustom Li
        _renderCustomLi: function ($ul) {
            var proxy = this,
            model = proxy.model,
            $li,$item,
            customToolbarItems = model.toolbarSettings.customToolbarItems;
            for (var i = 0; i < customToolbarItems.length; i++) {
                if (customToolbarItems[i]["text"] || customToolbarItems[i]["templateID"]) {                   
                        if (customToolbarItems[i]["text"]) {
                            var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["text"];
                            $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["text"], title: customToolbar });
                            $item = ej.buildTag("a.e-toolbaricons e-icon e-treegridcustomtoolbaritem", "", {}).addClass(customToolbarItems[i]["text"]);
                            $li.addClass("e-treegridtoolbaritem");
                        }
                        else {                          
                            var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["templateID"].replace("#", "");
                            $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["templateID"].replace("#", ""), title: customToolbar });
                            $item = $(customToolbarItems[i]["templateID"]).hide().html();
                }                
                $li.html($item);              
                $ul.append($li);
                }
            }
        },
        //Render list to display the tools in toolbar.
        _renderLi: function ($ul) {
            var proxy = this,
                toolBarItems = proxy.model.toolbarSettings.toolbarItems,
                length = toolBarItems.length,
                i = 0,
                $li;
            for (i; i < length; i++) {

                $li = ej.buildTag("li.e-treegridtoolbaritem", "", {}, {
                    id: proxy._id + "_" + toolBarItems[i]
                });             
                proxy._renderLiContent($li, toolBarItems[i]);
                $ul.append($li);
            }
        },

        //RENDER TOOLBAR ICONS
        _renderLiContent: function ($li, item) {
            var $a, $input, selectionMode = this.model.selectionSettings.selectionMode;
            var selectedRowIndex = this.selectedRowIndex();
            var editSetting = this.model.editSettings;
            switch (item) {

                case "add":
                    $a = ej.buildTag("a.e-addnew e-toolbaricons e-icon e-treegrid-add", "", {});
                    var addTitle = this._toolboxTooltipTexts["addTool"];
                    $li.attr("title", addTitle);
                    if (!this.model.editSettings.allowAdding)
                        this._disabledToolItems.push($li.get(0));
                    break;

                case "edit":
                    $a = ej.buildTag("a.e-edit e-toolbaricons e-icon e-treegrid-edit", "", {});
                    var editTitle = this._toolboxTooltipTexts["editTool"];
                    $li.attr("title", editTitle);
                    if (!this.model.editSettings.allowEditing || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")) || !this.model.allowSelection || this.model.editSettings.beginEditAction == "click") {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "delete":
                    var deleteTitle = this._toolboxTooltipTexts["deleteTool"];
                    $li.attr("title", deleteTitle);
                    $a = ej.buildTag("a.e-delete e-toolbaricons e-icon e-treegrid-delete", "", {});

                    if (!this.model.editSettings.allowDeleting || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")) || !this.model.allowSelection) {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "update":
                    var updateTitle = this._toolboxTooltipTexts["updateTool"];
                    $li.attr("title", updateTitle);
                    $a = ej.buildTag("a.e-save e-toolbaricons e-icon e-treegrid-save e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "cancel":
                    var cancelTitle = this._toolboxTooltipTexts["cancelTool"];
                    $li.attr("title", cancelTitle);
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-icon e-treegrid-cancel e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "expandAll":
                    var expandAllTitle = this._toolboxTooltipTexts["expandAllTool"];
                    $li.attr("title", expandAllTitle);
                    $input = ej.buildTag("a.e-expandall e-toolbaricons e-icon e-treegrid-expandall", "", {}, {});
                    $li.append($input);
                    break;

                case "collapseAll":
                    var collapseAllTitle = this._toolboxTooltipTexts["collapseAllTool"];
                    $li.attr("title", collapseAllTitle);
                    $input = ej.buildTag("a.e-collapseall e-toolbaricons e-icon e-treegrid-collapseall", "", {}, {});
                    $li.append($input);
                    break;

                case "pdfExport":
                    var pdfExportTitle = this._toolboxTooltipTexts["pdfExportTool"];
                    $li.attr("title", pdfExportTitle);
                    $input = ej.buildTag("a.e-pdfIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
                case "excelExport":
                    var excelExportTitle = this._toolboxTooltipTexts["excelExportTool"];
                    $li.attr("title", excelExportTitle);
                    $input = ej.buildTag("a.e-excelIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
                case "print":
                    var printTitle = this._toolboxTooltipTexts["printTool"];
                    $li.attr("title", printTitle);
                    $input = ej.buildTag("a.e-printIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
            }

            $li.append($a);
        },

        //update the toolbar items when dynamically update the editSettings property
        _updateToolbarItems: function () {
            var proxy = this,
                model = proxy.model,
                toolbarItems = model.toolbarSettings.toolbarItems,
                editSettings = model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                selectedRowIndex = proxy.selectedRowIndex(),
                editMode = editSettings.editMode,
                disableToolItems = [],
                enableToolItems = [];
                if (editMode.toLowerCase() == "cellediting" || editMode.toLowerCase() == "dialogediting") {
                    /* We can able perform rowEditing using toolbar, whether the editMode also in cellEditing.
                       So cancel the editing based on edit type.*/
                    if (proxy._isRowEdit)
                        proxy.cancelRowEditCell();
                    else if (model.isEdit)
                        proxy.cancelEditCell();
                }
                else if (editMode.toLowerCase() == "rowediting")
                    proxy.cancelRowEditCell();
                proxy._cancelSaveTools();
        },


        //#region TREEGRIDHEADER RENDERIGN

        //TREEGRID HEADER RENDER INITIALIZATION
        _renderAfterColumnInitialize:function(){
            var proxy = this;
            proxy.element.append(proxy._renderGridHeader());
        },

        //TO CHECK FILTER FORM ELEMENTS EDIT TYPE
        filterEditType: function (column, element, filterValue) {

            var proxy = this,
                model = proxy.model,
                columnField = column.field.split('.').join("");
               
            if (ej.isNullOrUndefined(column["filterEditType"]))
                column["filterEditType"] = column["editType"];

            switch (column["filterEditType"]) {
                case "stringedit":
                    element.html(ej.buildTag('input.e-ejinputtext e-filtertext e-field e-filterwidth', "", {}, { id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue }));
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", { "width": column.width - 15 }, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + column["filterEditType"] + ' e-field', "", {}, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($datePicker);
                    break;
                case "booleanedit":
                case "dropdownedit":
                    var $dropDownList = ej.buildTag('input.e-field e-dropdownlist e-field', "", {}, { type: "text", id: proxy._id + "_" + columnField + "_filterbarcell", name: column.field, value: filterValue });
                    element.append($dropDownList);
                    break;
            }
        },


        //RENDER FILTER BAR ELEMENTS ACCORDING TO ITS TYPE
        _filteringElements: function (args) {
            var proxy = this,
                model=proxy.model,
                elementFocused = false,
                $formElement,
                form, length,
                $element,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat,
                formatVal,
            selectedItem = model.selectedItem;

            if (args.requestType == "filtering") {
                form = document.getElementById(proxy._id + "_filterBar" + args.fieldname.split('.').join(""));
            }
            
            column = customParams = ej.TreeGrid.getColumnByField(model.columns, args.fieldname);
            $formElement = $(form).find("input,select");
            length = $formElement.length;
            for (var i=0; i < length; i++) {
                $element = $formElement.eq(i);
                params = {};
                //inputWidth = column.width ? column.width - 2 : proxy.model.commonWidth - 2;
                var inputWidth = $element.closest("div").width()-2;
                if ($element.hasClass("e-numerictextbox")) {
                    width = inputWidth;
                    value = $element.val();
                    params.width = width;                    
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    params.locale = model.locale;
                    params.height = 28;
                    params.focusIn = $.proxy(proxy._cancelEditState, proxy, $element);
                    //for parent editing 
                    var tempId = $element[0].id;
                    tempId=tempId.replace(proxy._id, '');
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.change = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.change = null;
                    if (value.length)
                        params.value = parseFloat(value);
                    else
                        params.value = null;
                    customParams = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (!ej.isNullOrUndefined(customParams) && !ej.isNullOrUndefined(customParams["editParams"]))
                        $.extend(params, customParams["editParams"]);
                    $element.ejNumericTextbox(params);
                    $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                }
                else if ($element.hasClass("e-datepicker")) {
                    width = inputWidth;
                    params.width = width;                    
                    params.cssClass = model.cssClass;
                    params.dateFormat = model.dateFormat;
                    params.locale = model.locale;
                    params.height = 28;
                    params.focusIn = $.proxy(proxy._cancelEditState, proxy, $element);
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    //To filter the records once the date seleted.
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.select = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.select = null;
                    column = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateFormat = formatVal[2];
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $element.ejDateTimePicker(params);
                    else
                        $element.ejDatePicker(params);
                    proxy._preventDoubleClick(column); //To prevent double click event
                }
                else if ($element.hasClass("e-datetimepicker")) {
                    width = inputWidth;
                    params = {
                        width: width,
                        rtl: model.rtl,
                        locale: model.locale,
                        cssClass: model.cssClass,
                        showButton: false,
                        focusIn : $.proxy(proxy._cancelEditState, proxy, $element),
                    };
                    params.height = 28;
                    if (model.filterSettings.filterBarMode == "immediate")
                        params.close = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        params.close = null;
                    column = ej.TreeGrid.getColumnByField(proxy.model.columns, $element.prop("name"));
                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateTimeFormat = formatVal[2];
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    $element.ejDateTimePicker(params);
                    proxy._preventDoubleClick(column); //To prevent double click event

                }
                else if ($element.hasClass("e-dropdownlist")) {
                    column = ej.TreeGrid.getColumnByField(model.columns, args.fieldname);
                    var text = (column.editParams && column.editParams.fields && column.editParams.fields.text) ? column.editParams.fields.text : "text";
                    var value = (column.editParams && column.editParams.fields && column.editParams.fields.value) ? column.editParams.fields.value : "value";
                    var clear, emptyString, dropData = [], blank, selectAll, dropDatatrue, dropDatafalse;
                    //Collecting the drop down data for drop down filter bar
                    if (column.dropdownData && column.dropdownData.length > 0)
                        dropData = $.extend(true, [], column.dropdownData);
                    else {
                        //Default drop down data for boolean editType columns
                        if (column.editType == "booleanedit") {
                            dropData = [];
                            dropDatatrue = {};
                            dropDatatrue[text] = proxy._trueText;
                            dropDatatrue[value] = "true";
                            dropData.push(dropDatatrue);
                            dropDatafalse = {};
                            dropDatafalse[text] = proxy._falseText;
                            dropDatafalse[value] = "false";
                            dropData.push(dropDatafalse);
                        }
                        else
                            dropData = proxy._dropDownArrayCollection(column, args.fieldname);  //Gathering dropdown data from datasource                       
                    }
                    //To append selectAll(clear) label in the drop down list                   
                    //clear = { text: proxy._dropDownListClearText, value: "" };
                    clear = {};
                    clear[text] = proxy._dropDownListClearText;
                    clear[value] = "";
                    dropData.splice(0, 0, clear);
                    //To append (Blanks) label in the drop down list
                        blank = column.allowFilteringBlankContent == undefined ? true : column.allowFilteringBlankContent;
                    if (blank) {
                        //emptyString = { text: proxy._dropDownListBlanksText, value: proxy._dropDownListBlanksText };
                        emptyString = {};
                        emptyString[text] = proxy._dropDownListBlanksText;
                        emptyString[value] = proxy._dropDownListBlanksText;
                        dropData.push(emptyString);
                    }
                    var param = {}, inputValue = $element.val(), $dropDownObj, dropObject = $("#" + $element[0].id).data("ejDropDownList");
                    if (dropObject) {
                        $dropDownObj = $(dropObject.popupList);
                    }
                    
                    param.width = inputWidth;
                    param.showCheckbox = false;
                    param.dataSource = dropData;
                    param.height = 28;
                    param.popupShown = $.proxy(proxy._cancelEditState, proxy, $element);
                    param.fields = { text: text, value: value };
                    //To filter the records once the item has been selected.
                    if (model.filterSettings.filterBarMode == "immediate")
                        param.popupHide = $.proxy(proxy._filterBarHandler, proxy, $element);
                    else
                        param.popupHide = null;
                    $element.ejDropDownList(param);
                    //Apply italic font style for "(Clear Filter)" and "(Blanks)" label
                    if ($dropDownObj) {
                        $dropDownObj.find(".e-ul :first-child").find(".e-ddltxt").css("font-style", "italic");
                        if(blank)
                            $dropDownObj.find(".e-ul :last-child").find(".e-ddltxt").css("font-style", "italic");
                    }
                    if (inputValue == proxy._dropDownListClearText)
                        inputValue = "";
                    $element.ejDropDownList("selectItemByValue", inputValue);//To retain the selected value in dropdown    
                    proxy._preventDoubleClick(column); //To prevent double click event                 
                } else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":
                            $element.width(inputWidth - 4);
                            if (column.filterEditType == "stringedit")
                                proxy._on($("#" + proxy._id + "_" + column.field.split('.').join("") + "_filterbarcell"), "focus", proxy._cancelEditState);
                            break;

                        case "SELECT":
                            $element.width(inputWidth).height(15);
                            break;
                    }
                }
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        elementFocused = true;
                    }
                }
            }
        },

        // Method for retriving drop down data to filterbar from data source
        _dropDownArrayCollection: function (column, fieldItems) {
            var proxy = this,
                model = proxy.model,
                fieldName = fieldItems,
                dropDownRecords = [],
                uniqueDropDownRecords = [],
                dropdownData = [],
                columnEditType = column.editType;

            dropDownRecords = $.map(model.flatRecords, function (record) {
                if (!ej.isNullOrUndefined(record.item[fieldName]))
                    return record.item[fieldName];
            });
            $.each(dropDownRecords, function (i, el) {
                el=$.trim(el); 
                if ($.inArray(el, uniqueDropDownRecords) === -1) uniqueDropDownRecords.push(el);
            });
            if (columnEditType != "numericedit")
                uniqueDropDownRecords.sort(proxy.stringCompare);
            else {
                uniqueDropDownRecords = uniqueDropDownRecords.sort(function (a, b) {
                    return a - b;
                });
            }
            $.each(uniqueDropDownRecords, function (i, val) {
                dropdownData.push({ text: val, value: val });
            });
            return dropdownData;
        },

        stringCompare: function (s1, s2) {
            var str1 = [], str2 = [];

            s1.replace(/(\d+)|(\D+)/g, function (_, $1, $2) { str1.push([$1 || Infinity, $2 || ""]) });
            s2.replace(/(\d+)|(\D+)/g, function (_, $1, $2) { str2.push([$1 || Infinity, $2 || ""]) });
    
            while (str1.length && str2.length) {
                var st1 = str1.shift();
                var st2 = str2.shift();
                var val = (st1[0] - st2[0]) || st1[1].localeCompare(st2[1]);
                if(val) return val;
            }

            return str1.length - str2.length;
        },
        // Method to prevent double click event during dropDown list and date picker filtering
        _preventDoubleClick: function (col) {
            var proxy = this,
                filterBoxTool = $("#" + proxy._id + "_" + col.field.split('.').join("") + "_filterbarcell_popup");
            if (filterBoxTool.length != 0) {
                $(filterBoxTool).on('click', function (e) {
                    if (ej.isTouchDevice())
                        proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                    else
                        proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    setTimeout(function () {
                        if (ej.isTouchDevice())
                            proxy._on(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                        else
                            proxy._on(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    }, 300);
                });
            }
        },
        // METHOD TO RENDER FILDERING ELEMENTS
        _renderFiltering: function (columns, showDetailColumn) {
            var proxy = this, model = this.model,
            totColumns = model.columns,
            filteredColumns = model.filterSettings.filteredColumns;
            var $tr = ej.buildTag('tr.e-filterbar', "", {}, {});
            if (proxy.model.allowFiltering) {
                $.each(totColumns, function (i, column) {
                    if (ej.isNullOrUndefined(column["allowFiltering"]))
                        column["allowFiltering"] = true;
                });
                var filterEnabled = false;
                //To check whether atleast any one of the column's allowFiltering has been enabled
                $.each(totColumns, function (i, column) {
                    if (column.allowFiltering == true) {
                        filterEnabled = true;
                        return false;
                    }
                });
                if (filterEnabled) {
                    for (var column = 0; column < columns.length; column++) {

                    var $th = ej.buildTag('th.e-filterbarcell .e-editValue', "", {}, {});
                    columns[column]["visible"] === false && $th.addClass("e-hide");
                    var $div = ej.buildTag('div.e-filterdiv', "", {}, { id: proxy._id + "_filterBar" + columns[column].field.split('.').join("") });
                        $tr.append($th.append($div));
                        //Condition to check whether allow filtering enabled for the individual column before rendering filtering elements
                        if (columns[column].allowFiltering == false)
                            continue;
                        else {
                            var filterValue = "";
                            if (filteredColumns.length > 0) {
                                for (var fcolumn = 0; fcolumn < filteredColumns.length; fcolumn++) {
                                    if (columns[column].field == filteredColumns[fcolumn].field) {
                                        filterValue = filteredColumns[fcolumn].value;
                                    }
                                }
                            }
                       
                            this.filterEditType(columns[column], $div, filterValue);
                        var $span = ej.buildTag('span.e-cancel e-icon e-hide e-spanstyle');
                        $div.append($span);
                    }                   
                }          
                }
            }
            /* add details column to last in column header */
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && showDetailColumn) {
                $tr.append(ej.buildTag('th.e-filterbarcell e-detailheadercell', '<div style="width:35px;"></div>'));
            }
            return $tr;
        },


        _getIndentCol: function () {
            return ej.buildTag("col", "", { width: "35px" });
        },

        //METHOD FOR RENDERING TREEGRID HEADER
        _renderGridHeader: function () {

            var proxy = this,
                model = proxy.model,
                doc = document, temp, $frozenDiv, $movableDiv,
                $innerDiv = ej.buildTag('div.e-gridheadercontainer', "", { "overflow": "hidden" }, { "data-unselectable": "on" }),
                $div = model.isFromGantt ? ej.buildTag('div.e-gridheader#' + proxy._id + "e-gridheader", "", {
                    "border-left-style": "solid",
                    "border-left-width": "1px"
                }, "") :
                    ej.buildTag('div.e-gridheader#' + proxy._id + "e-gridheader", "",
                {
                    "border-top-style": "solid",
                    "border-left-style": "solid",
                    "border-right-style": "solid",
                    "border-top-width": "1px",
                    "border-left-width": "1px",
                    "border-right-width": "1px",
                    "width": proxy._gridWidth,
                }, "");
            if (model.allowFiltering == true && model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar)
                $innerDiv.addClass("e-headercontent-material-filterbar");
            $innerDiv.addClass("e-headercontent");
            proxy.setGridHeaderContent($div);
            proxy._$gridHeaderContainer = $innerDiv;
            proxy._hiddenColumns = [];
            proxy._visibleColumns = [];
            proxy.columnsWidthCollection = [];

            if (this._frozenColumnsLength > 0) {
                $innerDiv.addClass("e-frozen-header-container");
                $frozenDiv = ej.buildTag("div.e-frozenheaderdiv#e-frozenheaderdiv" + proxy._id, this._renderGridHeaderInternalDesign(model.columns.slice(0, this._frozenColumnsLength), false));
                if (model.allowFiltering == true && model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar)
                    $frozenDiv.addClass("e-filterbar-header-material");
                $movableDiv = ej.buildTag("div.e-movableheader#e-movableheader" + proxy._id, ej.buildTag("div.e-movableheaderdiv#e-movableheaderdiv" + proxy._id, this._renderGridHeaderInternalDesign(this.model.columns.slice(this._frozenColumnsLength), true)));
                $innerDiv.append($frozenDiv).append($movableDiv);
            } else {
                $innerDiv.append(this._renderGridHeaderInternalDesign(this.model.columns, true));
                $innerDiv.removeClass("e-frozen-header-container");
            }
            $div.html($innerDiv);
            this.setGridHeaderTable(this.getHeaderContent().find(".e-table"));
            return $div;
        },

        getPager: function () {
            return this._gridPager;
        },

        setTreeGridPager: function (value) {
            this._gridPager = value;
        },

        _renderGridPager: function () {
            var proxy = this,
                $div = $(document.createElement('div')),
                pagerModel = {}, pageSettings = proxy.model.pageSettings;

            pageSettings.change = $.proxy(proxy._pagerClickHandler, proxy);
            if (ej.isNullOrUndefined(pageSettings.totalRecordsCount))
                pageSettings.totalRecordsCount = proxy._isLoadonDemand ? proxy._pageRecordCountOnDemand : pageSettings.totalRecordsCount;
            $.extend(pagerModel, pageSettings);
            pagerModel.locale = proxy.model.locale;
            if (proxy._currentPage() < 0)
                proxy._currentPage(1);
            pagerModel.currentPage = this._prevPageNo = proxy._currentPage();
            pagerModel.masterObject = proxy;
            pagerModel.cssClass = proxy.model.cssClass;
            proxy.setTreeGridPager($div);
            $div.ejPager(pagerModel);
            $div.ejPager("refreshPager");
            pagerModel = $div.ejPager("model");
            pageSettings.totalPages = pagerModel.totalPages;
            if (proxy._currentPage() !== pagerModel.currentPage)
                proxy._currentPage(pagerModel.currentPage);
            //Create custom Paging Template
            if (!ej.isNullOrUndefined(pageSettings.template) && pageSettings.template.length > 0) {
                $div.children().remove();                
                var $customDiv = ej.buildTag('div.e-pagercontainer'),
                $template = this._createTemplateElement(pageSettings, true);
                $customDiv.append($template.innerHTML);
                $div.append($customDiv);
            }
            return $div;
        },
		// Tempalte to render header checkbox selection
        _addHeaderCheckboxTemplate: function () {
            var model = this.model, template;

            if (model.flatRecords.length == model.selectedItems.length) {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-act">' +
                        '<span class="e-checkbox e-checkmark e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            else if (model.flatRecords.length > model.selectedItems.length && model.selectedItems.length > 0) {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-indeter">' +
                        '<span class="e-checkbox e-stop e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            else {
                template = '<div><span class="e-chkbox-wrap e-widget" style="margin-left:5px;padding-right:10px;color:#c8c8c8;">' +
                        '<div class="e-chkbox-small"><span class="e-chk-inact">' +
                        '<span class="e-checkbox e-chk-image e-icon e-headerCheckbox"' +
                'id =' + this._id + '_headerCheckbox></span></span></div></span></div>';
            }
            return template;
        },
        _renderGridHeaderInternalDesign: function (columns, showDetailColumn)
        {
            var proxy = this,
             model = proxy.model,
             doc = document,
             $table = ej.buildTag('table.e-table e-zerospace'),
             $thead = ej.buildTag('thead'),
             $tbody = ej.buildTag('tbody.e-hide'),
             $columnHeader = ej.buildTag('tr.e-columnheader'),
             $colGroup = $(doc.createElement('colgroup')),
             $rowBody = $(doc.createElement('tr')),
             columnCount = 0,
             length = columns.length,
             $headerCell,
             bodyCell,
             $headerCellDiv, 
             col, $filterHeader,
             $columnFilter;

            //CHECK SORTING ENABLED OR NOT
            if (model.allowSorting || model.showColumnChooser || model.allowColumnReordering) {
                $columnHeader.css({ 'cursor': 'pointer' });
            }

            if (model.headerTextOverflow === "wrap")
                proxy.element.addClass("e-wrap");
            else
                proxy.element.removeClass("e-wrap");

            for (columnCount; columnCount < length; columnCount++) {
                if (columns[columnCount]) {
                    var headerTextAlign = columns[columnCount].headerTextAlign ? columns[columnCount].headerTextAlign
                                                           : (columns[columnCount].textAlign ? columns[columnCount].textAlign : ej.TextAlign.Left);
                    // set padding right 35px for displaying column menu icon
                    if ((proxy.model.showColumnChooser || (!proxy.model.showColumnChooser && proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu")) && columns[columnCount].field != "checkboxState") {
                        if (!ej.isNullOrUndefined(columns[columnCount].allowFiltering) && !columns[columnCount].allowFiltering && !proxy.model.showColumnChooser) {
                            $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                        } else {
                            $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                            $headerCell.addClass("e-column-menu-padding");
                        }
                    }
                    else {
                        $headerCell = ej.buildTag('th.e-headercell', "", {}, {});
                    }
                    if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == ej.TreeGrid.FilterType.FilterBar) {
                        $headerCell.addClass("e-filterbar-material");
                    }
                    bodyCell = doc.createElement('td');

                    $headerCellDiv = ej.buildTag(
                        'div.e-headercelldiv', "",
                        { "text-align": headerTextAlign },
                        { 'data-ej-mappingname': columns[columnCount]["field"], 'data-unselectable': "on" }
                    );
                    if (columns[columnCount]["clipMode"] && columns[columnCount]["clipMode"] == ej.TreeGrid.ClipMode.Ellipsis) {
                        $headerCellDiv.addClass("e-treegridtrimcell");
                    }
                    // add checkbox that name of column have in proxy._checkboxColumnName
                    if (proxy._checkboxSelection && model.selectionSettings.enableSelectAll) {
                        if (proxy._checkboxColumnName == columns[columnCount]["field"])
                            $headerCellDiv.append(proxy._addHeaderCheckboxTemplate());                        
                    }
                    if (columns[columnCount]["field"] == "checkboxState")
                        $headerCell.css({ cursor: "default" });

                    var headerText = ej.buildTag('span',columns[columnCount]["headerText"] == undefined ?
                        columns[columnCount]["headerText"] = columns[columnCount]["field"] :
                        columns[columnCount]["headerText"]);

                    if (model.headerTextOverflow == "wrap") {
                        $headerCellDiv.addClass("e-textwrapheaderdiv");
                    }
                    $headerCellDiv.append(headerText);
                    $headerCell.append($headerCellDiv);
                    // Add column menu icon in header columns
                    if (proxy.model.showColumnChooser && !columns[columnCount].nonColumn) {
                        var $columnChooser = ej.buildTag('div.e-columnmenu-icon e-icon e-columnicon', "", { "cursor": "pointer" });
                        if (model.headerTextOverflow == "wrap")
                            $columnChooser.addClass("e-textwrapcolumnicon");
                        $columnChooser.data("isClicked", false);
                        $headerCell.append($columnChooser);
                    } else if ((!proxy.model.showColumnChooser && proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu" && (ej.isNullOrUndefined(columns[columnCount].allowFiltering) || columns[columnCount].allowFiltering)) && columns[columnCount].field != "checkboxState") {
                        if (proxy._filteredColumnValueID.indexOf(columns[columnCount].field) != -1)
                            $columnFilter = ej.buildTag('div.e-column-filtered-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                        else
                            $columnFilter = ej.buildTag('div.e-column-filter-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                        if (proxy.model.filterSettings.filteredColumns) {
                            for (var x = 0; x < proxy.model.filterSettings.filteredColumns.length; x++) {
                                if (proxy.model.filterSettings.filteredColumns[x].field == columns[columnCount].field && proxy.model.filterSettings.filteredColumns[x].value.toString() != "")
                                    $columnFilter = ej.buildTag('div.e-column-filtered-icon e-icon e-filtericon', "", { "cursor": "pointer" });
                            }
                        }
                        $columnFilter.data("isClicked", false);
                        $headerCell.append($columnFilter);
                    }
                    
                    col = doc.createElement('col');

                    $rowBody.append(bodyCell);
                    $columnHeader.append($headerCell);
                    $colGroup.append(col);


                    //CHECK VISIBLE PROPERTY OF THE COLUMN
                    if (columns[columnCount]["visible"] === false && columns[columnCount] != model.columns[model.treeColumnIndex]) {
                        $headerCell.addClass("e-hide") && $(col).css("display", "none") &&
                        proxy._hiddenColumns.push(columns[columnCount].headerText);

                    } else {
                        proxy._visibleColumns.push(columns[columnCount].headerText);
                        columns[columnCount]["visible"] = true;
                    }

                    if (columns[columnCount]["allowSorting"] === false) {
                        $headerCell.css({ 'cursor': 'normal' });
                    }

                    if (!ej.isNullOrUndefined(columns[columnCount]["headerTemplateID"])) {
                        $headerCellDiv.html($(columns[columnCount]["headerTemplateID"]).hide().html()).parent().addClass("e-headertemplate");
                    }
                    if (columns[columnCount]["allowCellSelection"] == undefined) {
                        columns[columnCount]["allowCellSelection"] = true;
                    }
                    if (columns[columnCount]["showInColumnChooser"] == undefined) {
                        columns[columnCount]["showInColumnChooser"] = true;
                    }
                    if (columns[columnCount]["width"] == undefined && model.commonWidth !== undefined) {
                        proxy.columnsWidthCollection.push(model.commonWidth);
                        columns[columnCount]["width"] = model.commonWidth;
                    } else {
                        proxy.columnsWidthCollection.push(parseFloat(columns[columnCount]["width"]));
                        columns[columnCount]["width"] = parseFloat(columns[columnCount]["width"]);
                    }

                    proxy._fieldColumnNames[columns[columnCount].headerText] = columns[columnCount].field;
                    proxy._headerColumnNames[columns[columnCount].field] = columns[columnCount].headerText;
                }
            }
            //Updating the column properties to Gantt's model.columns also
            if (model.isFromGantt)
                proxy.updateToGanttColumns();

            /* add detail column to last*/
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && showDetailColumn) {
                $columnHeader.append(ej.buildTag('th.e-headercell e-detailheadercell', '<div style="width:35px;"></div>', {}, {}));
                $colGroup.append(this._getIndentCol());
            }

            // Condition to check whether filtering enabled to render filter elements.
            if (model.allowFiltering && !model.isFromGantt && model.filterSettings.filterType == "filterbar") {
                $filterHeader = this._renderFiltering(columns, showDetailColumn);
            }            
            $thead.append($columnHeader);
            if ($filterHeader)
                $thead.append($filterHeader);
            $table.append($colGroup).append($thead);
            return $table;
        },

        //#endregion

        //#region TREEGRIDCONTENT RENDERING
        //TREEGRID CONTENT RENDER INITIALIZATION
        _initGridRender: function () {

            var proxy = this;
            proxy._addInitTemplate();
            proxy._renderGrid();

            //CHECK COLUMN RESIZE IS ENABLED OR NOT AND INITIALIZE THE RESIZER
            if (proxy.model.allowColumnResize) {
                proxy._resizer = new ej.gridFeatures.gridResize(proxy);
            }

        },
        //Create a summary row.
        _summaryRow: function () {
            var proxy = this, model = proxy.model;
            if (model.showSummaryRow)
                proxy._createSummaryRow();
            if (model.showTotalSummary) {
                proxy._createTotalSummaryRow();
                proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
        },


        //ADD GRIDCONTENT TO THE TREEGRID
        _renderGrid: function () {
            
            var proxy = this;
            proxy._renderGridContent().insertAfter(proxy.element.children(".e-gridheader"));
            

        },
        _renderFrozenSummary: function ()
        {
            this._$footerContainer.find("#e-frozenfooterdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[0]);
            this._$footerContainer.find("#e-movablefooterdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[1]);
            this._$footerContainer.find("#e-frozenfooterdiv" + this._id + " .e-table tbody").html($.render[this._id + "_JSONFrozenTemplate"](this._footerSummaryRecord));
            this._$footerContainer.find("#e-movablefooterdiv" + this._id + " .e-table tbody").html($.render[this._id + "_Template"](this._footerSummaryRecord));
        },

        _renderSummaryByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this._frozenColumnsLength))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            if (!$.templates[this._id + "_FrozenSummaryTemplate"])
                this.addFrozenSummaryTemplate();
            return $.render[this._id + "_FrozenSummaryTemplate"](colgroups);
           
        },
        _spliceSummaryRows: function (updatedRecords) {
            var proxy = this,
                model = proxy.model, records=[];
            var nonSummaryRowChildRecords = updatedRecords.filter(function (data) {
                if (!data.isSummaryRow)
                    records.push(data);
            });
            return records;
        },
        addFrozenSummaryTemplate: function () {
            var template = "<div class='e-frozenfooterdiv' id='e-frozenfooterdiv" + this._id +"'>"
            + "<table class='e-table e-zerospace' style='width:100%' id='" + this._id + "frozensummarye-table'>{{:colgroup1}}<tbody>"
            + "</tbody></table></div>"
            + "<div class='e-movablefooter' id='e-movablefooter" + this._id + "'><div class='e-movablefooterdiv' id='e-movablefooterdiv" + this._id + "'><table class='e-table e-zerospace' id='" + this._id + "movablesummarye-table'>{{:colgroup2}}<tbody>"
            + "</tbody></table></div></div>", templates = {};
            templates[this._id + "_FrozenSummaryTemplate"] = template;
            $.templates(templates);
        },

        //Add a total summary row after treegrid content.
        _createTotalSummaryRow: function () {
            var proxy = this, $summaryDiv, $table, model = proxy.model, flatRecords = model.flatRecords,
                summaryRows = model.summaryRows, summaryRowLength = summaryRows.length,
                updatedRecords = model.updatedRecords, parentRecords = model.parentRecords,
                columns = model.columns, $tbody = ej.buildTag('tbody');

            proxy._footerSummaryRecord = [];
            proxy._footerSummaryRows = [];
            $("#" + proxy._id + "-footersummaryrow").remove();
            $summaryDiv = ej.buildTag('div.e-footersummaryrowdiv#' + proxy._id + '-footersummaryrow', '',
                {
                    "overflow": "hidden",
                    "cursor": "default"
                });
            var $footerContainer = ej.buildTag('div.e-footercontainer#e-footercontainer' + proxy._id, '',
               {
                   "overflow": "hidden"
               });
            proxy._flatChildRecords = proxy._spliceSummaryRows(model.updatedRecords);

            for (var summaryRowIndex = 1; summaryRowIndex <= summaryRowLength; summaryRowIndex++) {
                var item = {};
                for (var columnLength = 0; columnLength < columns.length; columnLength++) {
                    item[columns[columnLength].field] = "";
                }
                item = proxy._createSummaryItem(item, summaryRows[summaryRowIndex - 1]);
                var record = proxy._createRecord(item, 0);
                record.footerSummaryRowRecord = true;
                record.index = summaryRowIndex;
                proxy._footerSummaryRecord.push(record);
                //GridRow = $.render[this._id + "_Template"](record);
                //proxy._footerSummaryRows.push(GridRow);
                //$tbody.append(GridRow);
            }
            proxy._$footerContainer = $footerContainer;
            if (this._frozenColumnsLength > 0) {
                $footerContainer.html(this._renderSummaryByFrozenDesign());
                this._renderFrozenSummary();
            } else {
                var $table = ej.buildTag('table.e-table.e-zerospace#' + proxy._id + "summarye-table", "",
                { top: "0px" });
                $table.append(proxy.getContentTable().find('colgroup').clone()).append($tbody);
                $tbody.html($.render[this._id + "_Template"](proxy._footerSummaryRecord));
                $footerContainer.append($table);
            }
            proxy._$totalSummaryRowContainer = $summaryDiv;
            proxy._$footertableContent = $footerContainer.find(".e-table");
            $summaryDiv.append($footerContainer);
            //Always display after TotalSummaryRow
            if (model.allowPaging) {
                proxy.element.append($("#" + this._id + "Pager").before($summaryDiv));
            }
            else
                proxy.element.append($summaryDiv);

            proxy._flatChildRecords = [];
            this._setWidthToFooters();
            if (this._$totalSummaryRowContainer.height() < 90) {
                if (proxy.isVScroll())
                    proxy._$totalSummaryRowContainer.addClass("e-scrollcss");
            }
            else {
                proxy._$totalSummaryRowContainer.ejScroller({ height: 90 });
            }
        },
        _getFooterRows: function ()
        {
            var gridFooterRows = $();
            if (this.model.showTotalSummary && this._$footertableContent) {
                gridFooterRows = this._$footertableContent.get(0).rows;
                if (this._frozenColumnsLength > 0)
                    gridFooterRows = [gridFooterRows, this._$footertableContent.get(1).rows];
            }
            return $(gridFooterRows);
        },
        //update footer container width for frozen columns
        _setWidthToFooters: function () {
            var width = this._gridWidth;
            if (this._frozenColumnsLength > 0) {
                var totalWidth = 0, frozenWidth;
                for (var i = 0; i < this.columnsWidthCollection.length; i++) {
                    totalWidth += this.columnsWidthCollection[i];
                    if (this._frozenColumnsLength - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                }
                this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).outerWidth(frozenWidth)
                    .end().find("#e-movablefooterdiv" + this._id).css("width", "100%");
            }
        },
        _excludeSummaryRows: function () {

            var $gridRows = $(), model = this.model;
            if (this.getTreeGridRows() && this.getTreeGridRows().length > 0) {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]).not(".e-summaryrow"), $(this.getTreeGridRows()[1]).not(".e-summaryrow")];
                    else
                        $gridRows = $(this.getTreeGridRows()).not(".e-summaryrow");
            }
            return $gridRows;
        },

        //Add a summary row for every parent item in Tree grid.
        _createSummaryRow: function (args) {
            var proxy = this, model = proxy.model, parentRecords,
                recordIndex,
                item = {},
                docsummaryRow,
                totalChildRecordsLength,
                summaryRows = model.summaryRows,
                summaryRowLength = summaryRows.length,
                columns = model.columns;
            if (args && (args.requestType == "dragAndDrop" || args.requestType == "addNewRow" ||
                 args.requestType == "sorting")) {
                parentRecords = proxy._getParentRecords(model.updatedRecords, proxy);
                //Remove the summaryRow records from the childRecords collection of parentRecords
                if (args.requestType == "dragAndDrop") {
                    for (var i = 0; i < parentRecords.length; i++) {
                        var nonSummaryRowChildRecords = [];
                        nonSummaryRowChildRecords = parentRecords[i].childRecords.filter(function (data) {
                            if (!data.isSummaryRow)
                                return true;

                        });
                        parentRecords[i].childRecords = nonSummaryRowChildRecords.slice();
                    }
                }
            }
            else
                parentRecords = proxy._parentRecords;
            var length = parentRecords.length;
            if (args && ej.isNullOrUndefined(args.filterCollection))
                args.filterCollection = [];
            if (model.enableCollapseAll && model.enableVirtualization && !args)
                model.updatedRecords = model.flatRecords.slice();
            model.updatedRecords = proxy._spliceSummaryRows(model.updatedRecords); 
            model.flatRecords = proxy._spliceSummaryRows(model.flatRecords);
            model.summaryRowRecords = [];
            //$(proxy.element).find(".e-summaryrow").remove();                       
            //this._$gridRows = proxy._excludeSummaryRows();
            proxy._flatChildRecords = [];
            for (var parentIndex = 0; parentIndex < length; parentIndex++) {
                var parentRecord = parentRecords[parentIndex];
                totalChildRecordsLength = proxy._getChildRecordsLength(parentRecord, model.updatedRecords);              
                if (totalChildRecordsLength == 0)
                    continue;
                for (var summaryRowIndex = 1; summaryRowIndex <= summaryRowLength; summaryRowIndex++) {
                    for (var columnLength = 0; columnLength < columns.length; columnLength++) {
                        item[columns[columnLength].field] = "";
                    }
                    item = proxy._createSummaryItem(item, summaryRows[summaryRowIndex - 1], parentRecord);
                    var currentIndex = model.updatedRecords.indexOf(parentRecord) + totalChildRecordsLength + summaryRowIndex,
                        summaryRecord = proxy._createRecord(item, currentIndex);
                    proxy._isSummaryRow = true;
                    summaryRecord.level = parentRecord.level + 1;
                    summaryRecord.parentItem = parentRecord;
                    summaryRecord.isSummaryRow = true;
                    summaryRecord.index = model.flatRecords.length + 1;
                    if (model.enableVirtualization) {                        
                            model.updatedRecords.splice(currentIndex, 0, summaryRecord);
                            if (!args || (args && args.filterCollection))
                                model.summaryRowRecords.push(model.updatedRecords[currentIndex]);
                    }
                    else {
                        model.updatedRecords.splice(currentIndex, 0, summaryRecord);
                        model.summaryRowRecords.push(model.updatedRecords[currentIndex]);
                    }
                    currentIndex = model.flatRecords.indexOf(parentRecord) + totalChildRecordsLength + summaryRowIndex;
                    model.flatRecords.splice(currentIndex, 0, summaryRecord);
                    var getExistingSummaryChild = parentRecord.childRecords.filter(function (data) {
                        if (data.isSummaryRow && summaryRecord.summaryColumn.summaryType == data.summaryColumn.summaryType) {
                            return true;
                        }
                    });

                    if (getExistingSummaryChild.length > 0) {
                        var index = parentRecord.childRecords.indexOf(getExistingSummaryChild[0]);
                        parentRecord.childRecords.splice(index, 1);
                        parentRecord.childRecords.push(summaryRecord);
                    }
                    else
                        parentRecord.childRecords.push(summaryRecord);
                    item = {};
                    if (summaryRowIndex == summaryRowLength) {
                        summaryRecord.isLastSummary = true;
                    }
                }
                proxy._flatChildRecords = [];
            }
            proxy._isSummaryRow = false;
            proxy._summaryRowsCount = parentRecords.length;
            if (model.enableVirtualization) {
                model.updatedRecords = proxy.getExpandedRecords(model.updatedRecords);
                if (model.enableAltRow)
                    proxy.updateAltRow();
            }
            this._updateCurrentViewData();
        },
        //Get all inner parent records for Virtualization is true
        _getInnerParentRecords: function (records, proxy, parentRecords) {
            var recordLength = records.childRecords.length;

            for (var count = 0; count < records.childRecords.length; count++) {
                
                if (records.childRecords[count].hasChildRecords) {
                    if (parentRecords.indexOf(records.childRecords[count]) == -1)
                        parentRecords.push(records.childRecords[count]);
                    proxy._getInnerParentRecords(records.childRecords[count], proxy, parentRecords);
                }
            }           
        },

        //Get all parent records from updated records.
        _getParentRecords: function (updatedRecords, proxy, rootParent) {
            var recordLength = updatedRecords.length, record, parentRecords = [];
            for (var length = 0; length < recordLength; length++) {
                record = updatedRecords[length];
                if (rootParent) {
                    if (ej.isNullOrUndefined(record.parentItem))
                        parentRecords.push(record);
                }
                else if (record.childRecords && record.childRecords.length > 0) {
                    if ((proxy.model.enableVirtualization) || (proxy.model.allowPaging && proxy.model.showSummaryRow)) {
                        if (parentRecords.indexOf(record) == -1)
                            parentRecords.push(record);
                        proxy._getInnerParentRecords(record, proxy, parentRecords);
                    }
                    else
                        parentRecords.push(record);
                }
                else if (proxy._isLoadonDemand && record.hasChildRecords && parentRecords.indexOf(record) == -1)
                    parentRecords.push(record);
            }
            return parentRecords;
        },
        //To get all child and grand child of one parent record when the datasource is in hierarchy form.
        _getChildRecordsLength: function (parentRecord, updatedRecords) {
            var proxy = this,
                recordLength = updatedRecords.length, record;
            for (var length = 0; length < recordLength; length++) {
                record = updatedRecords[length];
                if (record.summaryRow)
                    continue;
                if (parentRecord == record.parentItem) {
                    proxy._flatChildRecords.push(record);
                    if (record.hasChildRecords)
                        proxy._getChildRecordsLength(record, updatedRecords);
                }
            }
            return proxy._flatChildRecords.length;
        },

        //Assign the values for item properties to create a summary record.
        _createSummaryItem: function (item, targetSummaryRow, parentRecord) {
            var proxy = this,
                summaryColumns = targetSummaryRow.summaryColumns,
                summaryColumnsLength = summaryColumns.length;
            for (var columnLength = 0; columnLength < summaryColumnsLength; columnLength++) {
                var targetSummaryColumn = summaryColumns[columnLength],
                    prefix = targetSummaryColumn.prefix,
                    suffix = targetSummaryColumn.suffix,
                    displayColumn = targetSummaryColumn.displayColumn;

                if (ej.isNullOrUndefined(displayColumn))
                    displayColumn = targetSummaryColumn.dataMember;
                if (ej.isNullOrUndefined(prefix))
                    prefix = "";
                if (ej.isNullOrUndefined(suffix))
                    suffix = "";
                item.summaryColumn = targetSummaryColumn;
                item.summaryRow = targetSummaryRow;

                for (var key in item) {
                    if (key == displayColumn) {
                        if (item[key])
                            item[key] = item[key] + " " + prefix + proxy._getSummaryValues(targetSummaryColumn, proxy._flatChildRecords) + suffix;
                        else
                            item[key] = prefix + proxy._getSummaryValues(targetSummaryColumn, proxy._flatChildRecords) + suffix;
                    }
                }
            }
            return item;
        },

        //Calculate the summary values.
        _getSummaryValues: function (summaryColumn, summaryData) {
            var dataMember = summaryColumn.dataMember, format = summaryColumn.format,
                jsonData = summaryData;
            var dbMgr, $value;
            if (jsonData instanceof ej.DataManager) {
                dbMgr = jsonData;
                jsonData = jsonData.dataSource.json;
            } else
                dbMgr = ej.DataManager(jsonData);
            switch (summaryColumn.summaryType) {
                case ej.TreeGrid.SummaryType.Sum:
                    $value = ej.sum(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Average:
                    $value = ej.avg(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Maximum:
                    var obj = ej.max(jsonData, dataMember);
                    $value = parseInt(this._getCustomCellValue(obj, summaryColumn.dataMember));
                    break;
                case ej.TreeGrid.SummaryType.Minimum:
					var filteringData = jsonData.filter(function (data) {
                        if (data[dataMember] !== "")
                            return true;
                    });
                    var obj = ej.min(filteringData, dataMember);
                    $value = parseInt(this._getCustomCellValue(obj, summaryColumn.dataMember));
                    break;
                case ej.TreeGrid.SummaryType.MaximumDate:
                    $value = this._getMaxDate(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.MinimumDate:
                    $value = this._getMinDate(jsonData, dataMember);
                    break;
                case ej.TreeGrid.SummaryType.Count:
                    $value = jsonData.length;
                    break;
                case ej.TreeGrid.SummaryType.TrueCount:
                    var predicate = ej.Predicate(summaryColumn.dataMember, "equal", true);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
                case ej.TreeGrid.SummaryType.FalseCount:
                    var predicate = ej.Predicate(summaryColumn.dataMember, "equal", false);
                    $value = dbMgr.executeLocal(ej.Query().where(predicate)).length;
                    break;
            }
            if (!ej.isNullOrUndefined(format))
                $value = this.formatting(format, $value, this.model.locale);
            return $value;
        },
        // To Get Maximum Date of Particular Datamember in JSON data.
        _getMaxDate: function (jsonData, dataMember) {
            var max = 0;
            var maxDate = null;
            for (var i = 0; i < jsonData.length; i++) {
                var item = jsonData[i],
                    date = new Date(item[dataMember]),
                    time = date.getTime();
                if (time > max) {
                    max = time;
                    maxDate = item[dataMember];
                }
            }

            return maxDate;
        },
        // To Get Minimum Date of Particular Datamember in JSON data.
        _getMinDate: function (jsonData, dataMember) {
            var firstMinDate = new Date(jsonData[0][dataMember]),
                min = firstMinDate.getTime();
            var minDate = jsonData[0][dataMember];
            for (var i = 0; i < jsonData.length; i++) {
                var item = jsonData[i],
                    date = new Date(item[dataMember]),
                    time = date.getTime();
                if (time < min) {
                    min = time;
                    minDate = item[dataMember];
                }
            }

            return minDate;
        },
        /*Create new summary records and re render all records*/
        _createAndRenderSummaryRecords: function (args)
        {
            var proxy = this;
            proxy._createSummaryRow(args);
            var refreshArgs = {};
            refreshArgs.requestType = ej.TreeGrid.Actions.Refresh;
            proxy.sendDataRenderingRequest(refreshArgs);
            proxy.updateCollapsedRecordCount();
            proxy.updateHeight();
        },
        //Update the summary after add, edit or delete the record.
        _updateSummaryRow: function (args) {
            var proxy = this, model = proxy.model, summaryRow,
                editedRecord, editedRecordIndex, updatedSummaryRecords = [],
                _pRecords = [], cellvalue,
            updatedRecords = proxy.getUpdatedRecords();

            if (args && args.requestType == "dragAndDrop") {
                args.rowIndex = updatedRecords.indexOf(proxy._droppedRecord);
            }
            if (args && args.requestType == "delete") {
                proxy._updateAfterDeleteRecord(args);
                return;
            }

            if (args && args.editType == "celledit") {
                if (args.columnObject.editType == "numericedit") {
                    cellvalue = parseInt(args.value);
					args.value = isNaN(cellvalue) ? "" : cellvalue;
                    args.data[args.columnName] = args.value;
                }
                args.currentValue = args.value;
                var rowIndex = proxy.getIndexByRow(args.rowElement);
                var data = model.enableVirtualization ? model.currentViewData[rowIndex] : updatedRecords[rowIndex];
                args.rowIndex = updatedRecords.indexOf(data);
            }
            if ((args.currentValue != args.previousValue) || args.requestType == "dragAndDrop"
                || args.requestType == "addNewRow") {
                editedRecord = args.requestType == "addNewRow" ? model.updatedRecords[args.rowIndex] : updatedRecords[args.rowIndex];
                if (editedRecord.parentItem)
                    _pRecords = proxy._getpRecords(editedRecord, proxy);
                if (ej.isNullOrUndefined(_pRecords))
                    return;
                for (var parentLength = 0; parentLength < _pRecords.length; parentLength++) {
                    var summaryRowRecords = model.summaryRowRecords, recordindex, columnIndex;
                    proxy._getChildRecordsLength(_pRecords[parentLength], updatedRecords);
                    $.each(summaryRowRecords, function (index, record) {
                        summaryRow = record.summaryRow;
                        if (record.parentItem === _pRecords[parentLength]) {
                            var summaryColumnLength = summaryRow.summaryColumns.length;
                            for (var length = 0; length < summaryColumnLength; length++) {
                                var summaryColumn = summaryRow.summaryColumns[length],
                                    prefix = summaryColumn.prefix,
                                    suffix = summaryColumn.suffix;
                                if (ej.isNullOrUndefined(prefix))
                                    prefix = "";
                                if (ej.isNullOrUndefined(suffix))
                                    suffix = "";
                                if (args.editType == "rowedit") {
                                    args.columnName = summaryColumn.dataMember;
                                    var columnList = model.columns,
                                        dataMemberColumnIndex = proxy.getColumnIndexByField(args.columnName);
                                    //To convert empty string to integer while adding the new row.    
                                    if (model.columns[dataMemberColumnIndex].editType == "numericedit")
                                        editedRecord[args.columnName] = parseInt(editedRecord[args.columnName]);
                                }
                                var displayColumn = summaryColumn.displayColumn;
                                if (!displayColumn)
                                    displayColumn = summaryColumn.dataMember;
                                if (model.enableVirtualization)
                                    recordindex = model.currentViewData.indexOf(record);
                                else
                                    recordindex = updatedRecords.indexOf(record);
                                columnIndex = proxy.getColumnIndexByField(displayColumn);
                                args.data = record;
                                if (columnIndex != -1) {
                                if (proxy._frozenColumnsLength > 0) {
                                    if (proxy._frozenColumnsLength > columnIndex)
                                        args.rowElement = $(proxy.getRows()[0][recordindex]);
                                    else {
                                        args.rowElement = $(proxy.getRows()[1][recordindex]);
                                        columnIndex -= proxy._frozenColumnsLength;
                                    }
                                } else {
                                    args.rowElement = $(proxy.getRows()[recordindex]);
                                }
                                args.cellElement = args.rowElement.find(".e-rowcell").eq(columnIndex);

                                var value = proxy._getSummaryValues(summaryColumn, proxy._flatChildRecords);
                                record[displayColumn] = prefix + value + suffix;
                                args.cellElement.empty().html(prefix + value + suffix);
                                updatedSummaryRecords.push(record);
                                proxy._updateWrapRowHeights("total,header", "virtualRefresh", recordindex, "savecell");
                                }
                            }
                        }
                    });
                    proxy._flatChildRecords = [];
                    proxy._summaryRowCount = _pRecords.length;
                }
            }
        },
        //Update the Total summary after add, edit or delete the record.
        _updateTotalSummaryRow: function (args) {
            if (args.requestType == "dragAndDrop" || args.isDragAndDropDelete)
                return;
            var proxy = this, model = proxy.model, summaryRows = model.summaryRows, summaryColumns, summaryRow,
                summaryColumnsLength, record, summaryRowLength = summaryRows.length, displayColumn, recordindex, columnIndex;
            if (model.updatedRecords.length == 0) {
                $("#" + proxy._id + "-footersummaryrow").hide();
                return;
            }
            else
                $("#" + proxy._id + "-footersummaryrow").show();
            for (var length = 0; length < summaryRowLength; length++) {
                summaryRow = summaryRows[length];
                summaryColumns = summaryRow.summaryColumns;
                summaryColumnsLength = summaryColumns.length;
                record = proxy._footerSummaryRecord[length];
                for (var columnLength = 0; columnLength < summaryColumnsLength; columnLength++) {
                    var summaryColumn = summaryColumns[columnLength],
                        prefix = summaryColumn.prefix,
                        suffix = summaryColumn.suffix;
                    if (ej.isNullOrUndefined(prefix))
                        prefix = "";
                    if (ej.isNullOrUndefined(suffix))
                        suffix = "";
                    if (args.editType == "rowedit")
                        args.columnName = summaryColumn.dataMember;
                    if (!displayColumn)
                        displayColumn = summaryColumn.dataMember;
                    if (summaryColumn.dataMember == args.columnName || args.requestType == "delete"
                        || args.requestType == "filtering" || args.requestType == "addNewRow") {
                        displayColumn = summaryColumn.displayColumn;
                        recordindex = proxy._footerSummaryRecord.indexOf(record);
                        columnIndex = proxy.getColumnIndexByField(displayColumn);
                        args.data = record;
                        if (columnIndex != -1) {
                        if (this._frozenColumnsLength > 0) {
                            if (this._frozenColumnsLength > columnIndex)
                                args.rowElement = this._getFooterRows()[0][recordindex];
                            else {
                                args.rowElement = this._getFooterRows()[1][recordindex];
                                columnIndex -= this._frozenColumnsLength;
                            }
                        } else {
                            args.rowElement = this._getFooterRows()[recordindex];
                        }
                        args.cellElement = args.rowElement.childNodes[columnIndex];
                        var footerUpdatedRecords = proxy._spliceSummaryRows(model.updatedRecords),
                        value = proxy._getSummaryValues(summaryColumn, footerUpdatedRecords);
                        record[displayColumn] = prefix + value + suffix;
                        args.cellElement.innerHTML = prefix + value + suffix;
                    }
                        }
                }
            }
            if (model.allowTextWrap) {
                proxy._updateTotalSummaryHeight();
            }
        },
        //Update summary row after deleted the record.
        _updateAfterDeleteRecord: function (args) {
            var proxy = this, model = proxy.model, summaryRow,
                editedRecord, editedRecordIndex, updatedSummaryRecords = [],
                _pRecords,
                deletedRecord = args.data;
            if (deletedRecord.parentItem)
                _pRecords = proxy._getpRecords(deletedRecord, proxy);
            if (ej.isNullOrUndefined(_pRecords))
                return;
            for (var parentLength = 0; parentLength < _pRecords.length; parentLength++) {
                var summaryRowRecords = model.summaryRowRecords,
                    childRecords = _pRecords[parentLength].childRecords;
                if (childRecords.length == 0)
                    continue;
                proxy._getChildRecordsLength(_pRecords[parentLength], model.updatedRecords);
                $.each(summaryRowRecords, function (index, record) {
                    summaryRow = record.summaryRow;
                    if (record.parentItem === _pRecords[parentLength]) {
                        var summaryColumnLength = summaryRow.summaryColumns.length;
                        for (var length = 0; length < summaryColumnLength; length++) {
                            var summaryColumn = summaryRow.summaryColumns[length],
                                displayColumn = summaryColumn.displayColumn,
                                recordindex = model.updatedRecords.indexOf(record),
                                columnIndex = proxy.getColumnIndexByField(displayColumn),
                                 prefix = summaryColumn.prefix,
                                 suffix = summaryColumn.suffix;
                            if (ej.isNullOrUndefined(prefix))
                                prefix = "";
                            if (ej.isNullOrUndefined(suffix))
                                suffix = "";
                            args.data = record;
                            if (proxy._frozenColumnsLength > 0) {
                                if (proxy._frozenColumnsLength > columnIndex)
                                    args.tr = $(proxy.getRows()[0][recordindex]);
                                else {
                                    args.tr = $(proxy.getRows()[1][recordindex]);
                                    columnIndex -= proxy._frozenColumnsLength;
                                }
                            } else {
                                args.tr = $(proxy.getRows()[recordindex]);
                            }
                            args.tr = $(proxy.getRows()[recordindex]);
                            args.cellElement = args.tr.find(".e-rowcell").eq(columnIndex);
                            var value = proxy._getSummaryValues(summaryColumn, proxy._flatChildRecords);
                            record[displayColumn] = prefix + value + suffix;
                            args.cellElement.empty().html(prefix + value + suffix);
                        }
                        updatedSummaryRecords.push(record);
                    }

                })
                proxy._flatChildRecords = [];
            }
        },
        //To get parent and grand Parent of one Child record.
        _getpRecords: function (record, proxy) {
            var recordParents = [];
            do {
                record = record.parentItem;
                recordParents.push(record);
            } while (record.parentItem);
            return recordParents;
        },

        //RENDER THE GRIDCONTENT
        _renderGridContent:function(){
            
            var proxy = this,
                doc = document,
                model = proxy.model,
                $tbody = $(doc.createElement('tbody')),
                $div = ej.buildTag("div.e-gridcontent#" + proxy._id + "e-gridcontent", "",
                {                    
                    "height": proxy._viewPortHeight
                }),
                $innderDiv = ej.buildTag('div.e-gridcontainer#' + proxy._id + "e-gridcontainer", "", {}, {}),
                //Insert e-contet div for ejScroller
                $scrolllerContentDiv = ej.buildTag('div', {}, { "width": "auto", "height": "auto" });
                $scrolllerContentDiv.append($innderDiv);
            //CHECK VIRTUALIZATION ENABLED OR NOT
            if (model.enableVirtualization || model.allowPaging) {
                $innderDiv.css({ 'height': proxy._totalHeight });
            }

            if (this._frozenColumnsLength > 0) {
                $innderDiv.html(proxy._renderByFrozenDesign());
                proxy.setGridContentTable($innderDiv.find(".e-table"));

            }
            else {
                var $table = ej.buildTag('table.e-table e-zerospace#' + proxy._id + "e-table", "",
                    { top: "0px", "position": "relative" });
                $table.append(proxy.getHeaderTable().find('colgroup').clone()).append($tbody);
                $innderDiv.html($table);
                proxy.setGridContentTable($table);
            }
            $div.html($scrolllerContentDiv);
            proxy._$gridContent = $div;
            //CHECK DATASOURCE IS DEFINED OR NOT
            if (this.dataSource() === null || this.model.currentViewData.length == 0) {
                if (this._frozenColumnsLength > 0) {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: this._frozenColumns.length });
                    $innderDiv.find("#e-frozencontentdiv" + proxy._id + " .e-table tbody").append($(doc.createElement("tr")).append($emptyTd));
                    $emptyTd = ej.buildTag('td', model.emptyRecordText, { visibility: "hidden" }, { colSpan: this._unFrozenColumns.length });
                    $innderDiv.find("#e-movablecontentdiv" + proxy._id + " .e-table tbody").append($(doc.createElement("tr")).append($emptyTd));
                } else {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: model.columns.length });
                    $tbody.append($(doc.createElement("tr")).append($emptyTd));
                    $innderDiv.css('height', model.rowHeight);
                }
            } else
            {
                proxy.renderRecords();
            }

            if (!model.isFromGantt) {
                $div.css({
                    "border-bottom-style": "solid",
                    "border-bottom-width": "1px",
                    "border-left-style": "solid",
                    "border-left-width": "1px",
                    "border-right-style": "solid",
                    "border-right-width": "1px",
                    "width": "auto",
                    "height": "auto",
                    "cursor": "default"
                });
            } else {
                $div.css({
                    "border-left-style": "solid",
                    "border-left-width": "1px"
                });
            }
            return $div;

        },


        //AFTER INITIALIZATION END RENDERING
        _initialEndRendering: function () {

            var proxy = this, model = proxy.model, currentSelectingRecord,
                expandedRecords = proxy.getExpandedRecords(model.updatedRecords),
                index = proxy.selectedRowIndex(), cellIndexes = proxy.selectedCellIndexes();

            if (model.allowSelection) {
                if (model.selectionSettings.selectionMode == "row" && index != -1 && !model.isFromGantt) {
                if (model.showSummaryRow) {
                    var recordsWithOutSummary = proxy._spliceSummaryRows(model.updatedRecords),
                        currentSelectedRecord = recordsWithOutSummary[index];
                    index = model.updatedRecords.indexOf(currentSelectedRecord);                    
                }
                if (!proxy._rowSelectingEventTrigger(this._previousIndex, index)) {
                    proxy.selectRows(index);
                    proxy._cancelSaveTools();
                    proxy._rowSelectedEventTrigger(index);

                }
            }
                if (model.selectionSettings.selectionMode == "cell" && cellIndexes.length > 0) {
                    proxy.selectedRowIndex(-1);
                    proxy.selectCells(cellIndexes);
                    proxy._cancelSaveTools();
                }
                }

            /* treegrid rendering completed here at load time*/
            proxy._isRendered = true;
            this._trigger("dataBound", {});
            proxy._trigger("refresh");
            proxy._eventBindings();
            proxy._hideCollapsedDetailsRows();
            proxy.getScrollElement().ejScroller("refresh");
            proxy._updateScrollCss();
        },

        //#endregion
        
        //#region TEMPLATE

        //ADD CELLEDITING TEMPLATE
        _addCellEditTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                columnCount = 0,
                $outerDiv = ej.buildTag('div', "", { display: 'none' }, { id: proxy._id + "_CellEditTemplate" }),
                $innerDiv, columnField;

            for (columnCount = 0; columnCount < columns.length; columnCount++) {
                if (columns[columnCount]) {
                    columnField = proxy._getFieldValue(columns[columnCount].field, columnCount);
                    if (proxy._isCommandColumn(columns[columnCount])) {
                        $innerDiv = ej.buildTag('td.e-rowcell e-unboundcell', "", {}, { id: columnField + "_CellEdit" });
                        var column = columns[columnCount];
                        $("#" + this._id + columnCount + "_UnboundTemplate").remove();
                        var divElement = this._createCommandElement(column, columnCount);
                        $innerDiv.addClass("e-unboundcell").html("{{:~_" + this._id + "UnboundTemplate('" + divElement.id + "')}}");
                        }
                    else {            
                        $innerDiv = ej.buildTag('div', "", {}, { id: columnField + "_CellEdit" });
                        ej.TreeGrid._initCellEditType(proxy, $innerDiv, proxy._id, columnCount);
                    }
                    $outerDiv.append($innerDiv);
                }
            }

            if ($outerDiv.children().length) {
                proxy._cellEditTemplate = $outerDiv;
            }

        },

        _getState: function () {
            if (this.data.parentItem)
                return false;
            else
                return true;
        },

        _getCellIndex: function (array, findItem) {
            var proxy = this, cellIndexArray = [];
            for (var i = 0; i < array.length; i++) {
                cellIndexArray[i] = array[i][findItem];
            }
            return cellIndexArray;
        },
        _getSelectedCellClass: function (data, columnCount) {
            var proxy = this, model = proxy.model,
                columnIndex = parseInt(columnCount),
                selectedCellDetails = proxy._selectedCellDetails;
            if (model.selectionSettings.selectionMode == "cell" && selectedCellDetails.length > 0) {
                    proxy._getSelectedCellsinARow(data.index, selectedCellDetails);
                if (proxy._selectedCellsinARow.length > 0) {
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                        var currentSelectingCellIndex = proxy._getCellIndex(proxy._selectedCellsinARow,"cellIndex").indexOf(columnIndex);
                    else
                        var currentSelectingCellIndex = proxy._selectedCellsinARow.map(function (e) { return e.cellIndex }).indexOf(columnIndex);                    
                    if (currentSelectingCellIndex != -1) {
                        if (proxy._selectedCellsinARow[currentSelectingCellIndex].cellIndex == columnIndex)
                            return "e-selectingcell";
                    }
                }
            }
            return "";
        },

        _getSelectedCellsinARow: function (recordIndex, selectedCellDetails) {
            var proxy = this;
            proxy._selectedCellsinARow = [];
            selectedCellDetails.forEach(function (selectedcell) {
                if (selectedcell.data.index == recordIndex)
                    proxy._selectedCellsinARow.push(selectedcell);
            });
            proxy._currentRecordIndex = recordIndex;
        },
        _getrowName: function () {
            var rowClass = "gridrowIndex",
                proxy = this;
            rowClass += proxy.data.index.toString() + "level" + proxy.data.level.toString();
            return rowClass;
        },
        /* get details row col span with showDetailROwInfoColumn API value */
        _getDetailsColSpan:function(isFrozenTable)
        {
            var model = this.model, visibleColumns = [];
            if (this._frozenColumnsLength > 0) {
                if (!isFrozenTable) {
                    visibleColumns = this._unFrozenColumns.filter(function (value) {
                        return value.visible !== false;
                    });
                    return visibleColumns.length;
                } else {
                    visibleColumns = this._frozenColumns.filter(function (value) {
                        return value.visible !== false;
                    });
                    return visibleColumns.length;
                }
            }
            return model.showDetailsRowInfoColumn ? this._visibleColumns.length + 1 : this._visibleColumns.length;
        },
        /* expand status for details rows */
        _getDetailsExpandStatus: function (data) {
            var proxy = this;
            if (proxy.getExpandStatus(data) && data.isDetailsExpanded) {
                return true;
            } else
            {
                return false;
            }
        },
        _createDetailsRowTemplate: function (isFrozenTable) {
            var proxy = this,
                model = this.model,
                helpers = {};

            helpers["_" + proxy._id + "getDetailsColSpan"] = $.proxy(proxy._getDetailsColSpan, proxy);
            helpers["_" + proxy._id + "getDetailsExpandStatus"] = $.proxy(proxy._getDetailsExpandStatus, proxy);
            helpers["_" + proxy._id + "getExpandStatus"] = $.proxy(proxy.getExpandStatus, proxy);
            
            $.views.helpers(helpers);

            var tr = '{{if !isSummaryRow && !footerSummaryRowRecord}}' + "<tr class='e-detailsrow e-treegridrows detailsrow{{:~_" + proxy._id + "rowClassName()}} {{if isDetailsExpanded}}" +
                      "e-detailsrowexpanded{{else}}e-detailsrowcollapsed{{/if}}{{if !~_" + proxy._id + "getExpandStatus(#data) && isDetailsExpanded}} e-collapsedrowexpandeddetailsrow{{/if}}' " +
                      "style='{{if ~_" + proxy._id + "getDetailsExpandStatus(#data)}}display:table-row;{{else}}visibility:none;{{/if}}height:" + model.detailsRowHeight + "px;'>" +
                      "<td class='e-detailsrowcell' colspan='{{:~_" + proxy._id + "getDetailsColSpan(" + isFrozenTable + ")}}'>" +
                      "<div class='e-detailscellwrapper' style='height:" + (model.detailsRowHeight - 1) + "px;'>";

            var templateString = "";
            if (model.detailsTemplate && model.detailsTemplate.length > 0) {

                if (document.getElementById(model.detailsTemplate))
                {
                    templateString = "#" + model.detailsTemplate;
                } else
                {
                    templateString = model.detailsTemplate;
                }
            }
            if (!isFrozenTable) {
                $("#treeGridDetailsRowTemplateElement" + proxy._id).remove();
                var scriptElement = this._createDetailRowTemplateElement(templateString);
                tr += "{{:~_" + proxy._id + "treeGridTemplating('" + scriptElement.id + "')}}";
            }
            tr += "</div></td></tr>";
            tr += "{{/if}}";
            if (!isFrozenTable) {
                var templates = {};
                templates[proxy._id + "_detailRowTemplate"] = tr;
                $.templates(templates);
            }
            return tr;

        },

        _SelectState:function(args){
            var proxy = this,
                model = this.model;
            if (model.allowSelection)
                return true;
            else
                return false;
        },
        _unboundClickHandler: function (e) {
            var proxy = this,
              model = this.model, form, isAddRow,
            $target = $(e.target).closest("button");
            if (!($target.hasClass("e-deletebutton") || $target.hasClass("e-editbutton") || $target.hasClass("e-savebutton") || $target.hasClass("e-cancelbutton"))) {
                return
            }
            if ($target.hasClass("e-button") && ($target.hasClass("e-disable") || $target.prop("disabled"))) return;
            if ($(e.target).hasClass("e-unboundcelldiv"))
                return;
            if (model.editSettings.allowEditing) {
                if (proxy.model.editSettings.editMode == "dialogEditing") {
                    form = $("#" + proxy._id + "EditFormDialog");
                } else {
                    form = $("#" + proxy._id + "EditForm");
                }
            }
            var index = ($target.hasClass("e-savebutton") || $target.hasClass("e-cancelbutton")) ? proxy.getIndexByRow(form.closest("tr")) : proxy.getIndexByRow($target.closest("tr"));
            proxy.selectRows(proxy.getUpdatedRecords().indexOf(model.currentViewData[index]));
            if ($target.hasClass("e-editbutton") && model.editSettings.allowEditing) {
                if (proxy._isRowEdit) {
                    proxy.cancelEdit();
                }
                if (model.editSettings.editMode != "dialogEditing") {
                    var columnIndex = proxy.getCellIndex(e);
                    proxy._editRow(proxy.getUpdatedRecords().indexOf(model.currentViewData[index]), null, columnIndex);
                }
                else {
                    proxy.showEditDialog(proxy.getUpdatedRecords().indexOf(model.currentViewData[index]));
                }
            } else if ($target.hasClass("e-deletebutton")) {
                proxy.deleteRow(null, true);
            }
            else if ($target.hasClass("e-savebutton")) {
                if (this.editFormValidate()) {
                    proxy.saveRow();
                }
            }
            else if ($target.hasClass("e-cancelbutton")) {
                proxy.cancelEdit();
            }
        },
        _createCommandElement: function (column, count) {
            var divElement = document.createElement("div");
            divElement.id = this._id + count + "_UnboundTemplate";
            var $div = ej.buildTag("div.e-unboundcelldiv"), commands = column.commands;
            for (var unbounType = 0; unbounType < commands.length; unbounType++) {
                if (!ej.isNullOrUndefined(commands[unbounType].type)) {
                    var $button = ej.buildTag("button.e-" + commands[unbounType].type.replace(/\s+/g, "") + "button", "", {}, { type: "button" });
                    $button.val(commands[unbounType].type);
                    $div.append($button);
                }
            }
            $("body").append($(divElement).html($div).hide());
            return divElement;
        },
        _refreshUnboundTemplate: function ($target) {
            var proxy = this,
                model = proxy.model;
            if (proxy._commandColumnLength > 0) {
                for (var column = 0; column < model.columns.length; column++) {
                    if (proxy._isCommandColumn(model.columns[column])) {
                        var $unboundDivs = $target.find(".e-unboundcell").find(".e-unboundcelldiv");
                        var commands = $.extend(true, [], model.columns[column].commands);
                        for (var j = 0; j < commands.length; j++) {
                            if (ej.isNullOrUndefined(commands[j].buttonOptions))
                                commands[j].buttonOptions = {};
                            commands[j].buttonOptions.width = ej.isNullOrUndefined(commands[j].buttonOptions.width) ? "52" : commands[j].buttonOptions.width;
                            commands[j].buttonOptions.height = ej.isNullOrUndefined(commands[j].buttonOptions.height) ? "22" : commands[j].buttonOptions.height;
                            commands[j].buttonOptions.showRoundedCorner = ej.isNullOrUndefined(commands[j].buttonOptions.showRoundedCorner) ? true : commands[j].buttonOptions.showRoundedCorner;
                            commands[j].buttonOptions.size = ej.isNullOrUndefined(commands[j].buttonOptions.size) ? "small" : commands[j].buttonOptions.size;
                            if (!ej.isNullOrUndefined(commands[j].type)) {
                                var $buttons = $unboundDivs.find(".e-" + commands[j].type.replace(/\s+/g, "") + "button");

                                if ($target.find(".e-unboundeditedcell").length > 0) {
                                    if (commands[j].type == "save" || commands[j].type == "cancel")
                                        $buttons.show();
                                    else {
                                        $buttons.hasClass("e-deletebutton") && $buttons.hide();
                                        $buttons.hasClass("e-editbutton") && $buttons.hide();
                                    }
                                } else {
                                    if (commands[j].type == "save" || commands[j].type == "cancel")
                                        $buttons.hide();
                                    else {
                                        $buttons.hasClass("e-deletebutton") && $buttons.show();
                                        $buttons.hasClass("e-editbutton") && $buttons.show();
                                    }
                                }
                                $buttons.ejButton(commands[j].buttonOptions);
                            }
                        }
                    } else
                        continue;
                }
            }
        },
        _unboundTemplateRendering: function (unboundTemplateId) {
            return $("#" + unboundTemplateId).html();
        },
        //ADD TEMPLATE FOR RENDERING GRIDCONTENT
        _addInitTemplate:function(){

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                columnCount = 0,
                length = columns.length,
                columnName,
                column,
                tdCell,
                summaryTitle, isTextWrap = false,
                helpers = {};
            proxy._commandColumnLength = 0;

            //CHECK THE COLUMNS ARRAY CONTAIN THE COLUMN OBJECT
            if (columns.length === 0) {
                return false;
            }
            if (this._frozenColumnsLength > 0) {
                this.addFrozenTemplate();
                if (model.showTotalSummary)
                    this.addFrozenSummaryTemplate();
            }
            helpers["_" + proxy._id + "rowClassName"] = ej.TreeGrid._getrowClassName;
            helpers["_" + proxy._id + "SummaryRowtdClassName"] = ej.TreeGrid._getSummaryRowtdClassName;
            helpers["_" + proxy._id + "isSelectedCell"] = $.proxy(proxy._getSelectedCellClass, proxy);
            helpers["_" + proxy._id + "summaryTitle"] = proxy._getSummaryTitle;
            // helpers for drag row indicator icon class
            helpers["_" + proxy._id + "rowName"] = proxy._getrowName;
            helpers["_" + proxy._id + "getState"] = proxy._getState;
            helpers["_" + proxy._id + "SelectState"] = $.proxy(proxy._SelectState, proxy);
            helpers["_" + proxy._id + "expandStatus"] = $.proxy(proxy._getExpandStatusRecord, proxy);         
            helpers["_" + proxy._id + "cellValue"] = $.proxy(proxy._getCellValue, proxy);
            helpers["_" + proxy._id + "TemplateCellValue"] = $.proxy(proxy._getTemplateCellValue, proxy);
            helpers["_" + proxy._id + "isTreeColumnIndex"] = $.proxy(proxy._isTreeColumnIndex, proxy);
            helpers["_" + proxy._id + "getIndentWidth"] = $.proxy(proxy._getIndentWidth, proxy);
            helpers["_" + proxy._id + "checkColumn"] = $.proxy(proxy._getCellColumn, proxy);
            helpers["_" + proxy._id + "formatting"] = $.proxy(proxy.formatting, proxy);
            helpers["_" + proxy._id + "treeGridTemplating"] = ej.proxy(proxy._gridTemplate, null, proxy);
            helpers["_" + proxy._id + "getCheckboxState"] = $.proxy(proxy._getCheckboxState, proxy);
            helpers["_" + proxy._id + "UnboundTemplate"] = $.proxy(proxy._unboundTemplateRendering, proxy);
            helpers["_" + proxy._id + "isTrimCell"] = $.proxy(proxy._checkIsTrimCell, proxy);

            $.views.helpers(helpers);

            if (model.allowTextWrap)
                isTextWrap = proxy.model.allowTextWrap;

            if (model.parseRowTemplate && (model.rowTemplateID.length > 0 || model.altRowTemplateID.length > 0)) {
                
                var altRowTemplateElement = ej.buildTag("tbody", "", {}, {});
                var rowTemplateElement = ej.buildTag("tbody", "", {}, {});
                var rowTemplateHTML = "";
                var altRowTemplateHTML = "";

                var altRowTemplateScript = model.altRowTemplateID.length > 0 ? $("#" + model.altRowTemplateID): $("#" + model.rowTemplateID);
                var rowTemplateScript = model.rowTemplateID.length > 0 ? $("#" + model.rowTemplateID): $("#" + model.altRowTemplateID);
                var altRowTemplate = altRowTemplateScript[0].innerHTML;
                var rowTemplate = rowTemplateScript[0].innerHTML;

                $(altRowTemplateElement[0]).html(altRowTemplate);
                $(rowTemplateElement[0]).html(rowTemplate);

                if (rowTemplateElement[0].childNodes.length > 0) {
                    for (var i = 0; i < rowTemplateElement[0].childNodes.length; i++) {
                        if (rowTemplateElement[0].childNodes[i].nodeName == 'TR') {

                            rowTemplateElement[0].className = rowTemplateElement[0].childNodes[i].className;
                            rowTemplateElement[0].style.cssText = rowTemplateElement[0].childNodes[i].style.cssText;

                            if (rowTemplateElement[0].childNodes[i].childNodes.length > 0) {
                                var tdCount = 0;
                                for (var j = 0; j < rowTemplateElement[0].childNodes[i].childNodes.length; j++) {

                                    var childNode = rowTemplateElement[0].childNodes[i].childNodes[j];

                                    if (childNode.nodeName == 'TD') {
                                        var innerHtml = childNode.innerHTML,
                                            templateId = proxy._id + "RowTemplateElement" + tdCount;

                                        $("#" + templateId).remove();
                                        var scriptElement = this._createRowTemplateElement(innerHtml, templateId, rowTemplateScript[0].type);
                                        childNode.innerHTML = "{{:~_" + proxy._id + "treeGridTemplating('" + scriptElement.id + "')}}";
                                        childNode.className += " e-rowcell e-templatecell";


                                        if (columns[tdCount]) {
                                            column = columns[tdCount];
                                            columnName = column.field;
                                            var visible = column.visible == undefined ? true : column.visible;
                                            //To create a seperate div in summary cell to display a summary title.
                                            var summaryTitlediv = "";
                                            if (column.headerText == proxy._visibleColumns[0]) {
                                                summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                                    "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                                     + "</div>" + '{{/if}}';
                                            }

                                            if (tdCount == model.treeColumnIndex) {
                                                var indentDiv = "<div class='e-inner-treecolumn-container' style='min-height:20px;' data-unselectable='on'>" +
                                                "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                                "<div class='e-dragintend'" +
                                                "style='height:1px; float:left; width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                                 //indicator icons included for drag and drop
                                                "{{if !~_" + proxy._id + "getState() || !hasChildRecords }}" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='e-aboveIcon e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='e-belowIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='e-childIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='e-cancelIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "</div>" +
                                                "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                                "<div " +
                                                "class='e-dragintend'" +
                                                "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                                //indicator icons included for drag and drop
                                                "{{if !~_" + proxy._id + "getState() || !hasChildRecords}}" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='e-aboveIcon iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='e-belowIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='e-childIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='e-cancelIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "{{if ~_" + proxy._id + "getState() && hasChildRecords}}" +
                                                "<div class='e-intendparent'>" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='e-aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                                "<span class='e-belowIcon e-icon' style='float:left;display:none;'></span>" +
                                                "<span class='e-childIcon e-icon' style='float:left;display:none;'></span>" +
                                                "<span class='e-cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                                "</div>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "<div class='{{if expanded && hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}e-treegridcollapse e-icon{{/if}}' " +
                                                "style='float:left;display:inline-block;font-size:10px;'>" +
                                                "</div>" +
                                                "<div class='e-cell{{if " + (column.showCheckbox && (this.model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox)) + "}} e-treecheckboxcolumn{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}}{{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='overflow: hidden;'>";

                                                childNode.style.cssText = "padding-left:0px;";

                                                rowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~_" + proxy._id + "SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "'>" + indentDiv + "{{else}}'>{{/if}}" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                                     if (!ej.isNullOrUndefined(column["format"]))
                                                         rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                                     else
                                                         rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                                     rowTemplateHTML += "</div></div></td>";
                                            }
                                            else {
                                                rowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~_" + proxy._id + "SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "{{/if}}'>" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                                if (!ej.isNullOrUndefined(column["format"]))
                                                    rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                                else
                                                    rowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                                rowTemplateHTML += "</td>";
                                            }
                                            if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == tdCount + 1) {
                                                var frozenRowTemplate = "";
                                                frozenRowTemplate += rowTemplateHTML;
                                                frozenRowTemplate += "</tr>";
                                                rowTemplateHTML = "";
                                            }
                                            tdCount++;

                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                if (altRowTemplateElement[0].childNodes.length > 0) {
                    for (var i = 0; i < altRowTemplateElement[0].childNodes.length; i++) {
                        if (altRowTemplateElement[0].childNodes[i].nodeName == 'TR') {
                            altRowTemplateElement[0].className = altRowTemplateElement[0].childNodes[i].className;
                            altRowTemplateElement[0].style.cssText = altRowTemplateElement[0].childNodes[i].style.cssText;
                            var tdCount = 0;

                            for (var j = 0; j < altRowTemplateElement[0].childNodes[i].childNodes.length; j++) {

                                var childNode = altRowTemplateElement[0].childNodes[i].childNodes[j];

                                if (childNode.nodeName == 'TD') {

                                    var innerHtml = childNode.innerHTML,
                                        templateId = proxy._id + "AltRowTemplateElement" + tdCount;
                                    $("#" + templateId).remove();
                                    var scriptElement = this._createRowTemplateElement(innerHtml, templateId, altRowTemplateScript[0].type);
                                    childNode.innerHTML = "{{:~_" + proxy._id + "treeGridTemplating('" + scriptElement.id + "')}}";

                                    childNode.className += " e-rowcell e-templatecell";
                                    if (columns[tdCount]) {
                                        column = columns[tdCount];
                                        columnName = column.field;
                                        var visible = column.visible == undefined ? true : column.visible;
                                        //To create a seperate div in summary cell to display a summary title.
                                        var summaryTitlediv = "";
                                        if (column.headerText == proxy._visibleColumns[0]) {
                                            summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                                "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                                 + "</div>" + '{{/if}}';
                                        }
                                        if (tdCount == model.treeColumnIndex) {
                                            var indentDiv = "<div class='e-inner-treecolumn-container' style='min-height:20px;'>" +
                                            "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                            "<div class='e-dragintend' style='height:1px; float:left;width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                             //indicator icons included for drag and drop
                                            "{{if !~_" + proxy._id + "getState() || !hasChildRecords }}" +
                                            "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                            "<span class='e-aboveIcon e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='e-belowIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='e-childIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "<span class='e-cancelIcon e-icon' style='position:relative;float:right;display:none;'></span>" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "</div>" +
                                            "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                                "<div " +
                                                "class='e-dragintend'" +
                                                "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                                //indicator icons included for drag and drop
                                                "{{if !~_" + proxy._id + "getState() || !hasChildRecords}}" +
                                                "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                                "<span class='e-aboveIcon iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                                "<span class='e-belowIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='e-childIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "<span class='e-cancelIcon iconMargin e-icon' style='float:right;display:none;'></span>" +
                                                "</div>" +
                                                "{{/if}}" +
                                                "</div>" +
                                                "{{/if}}" +
                                            "{{if ~_" + proxy._id + "getState() && hasChildRecords}}" +
                                            "<div class='e-intendparent'>" +
                                            "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                            "<span class='e-aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                            "<span class='e-belowIcon e-icon' style='float:left;display:none;'></span>" +
                                            "<span class='e-childIcon e-icon' style='float:left;display:none;'></span>" +
                                            "<span class='e-cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                            "</div>" +
                                            "</div>" +
                                            "{{/if}}" +
                                            "<div class='{{if expanded&& hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}e-treegridcollapse e-icon{{/if}}' " +
                                            "style='float:left;display:inline-block;font-size:10px;'></div>" +
                                            "<div class='e-cell{{if " + column.showCheckbox + "}} e-treecheckboxcolumn{{/if}}{{if  ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='overflow:hidden'>";

                                            childNode.style.cssText = "padding-left:0px;";

                                            altRowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~_" + proxy._id + "SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                 + childNode.style.cssText + "'>" + indentDiv + "{{else}}'>{{/if}}" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                            if (!ej.isNullOrUndefined(column["format"]))
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                            else
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                            altRowTemplateHTML += "</div></div></td>";

                                        }
                                        else {
                                            altRowTemplateHTML += "<td class='" + childNode.className + "{{if isSummaryRow || footerSummaryRowRecord}} e-summaryrowcell{{/if}}{{if isSelected && ~_" + proxy._id + "SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}} {{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}' style='{{if !isSummaryRow && !footerSummaryRowRecord}}"
                                                    + childNode.style.cssText + "{{/if}}'>" +
                                                    '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                                     childNode.innerHTML +
                                                    '{{else}}' + summaryTitlediv + '{{/if}}';

                                            if (!ej.isNullOrUndefined(column["format"]))
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                                            else
                                                altRowTemplateHTML += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                                            altRowTemplateHTML += "</td>";
                                        }
                                        if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == tdCount + 1) {
                                            var frozenAltRowTemplate = "";
                                            frozenAltRowTemplate += altRowTemplateHTML;
                                            frozenAltRowTemplate += "</tr>";
                                            altRowTemplateHTML = "";
                                        }
                                        tdCount++;
                                    }
                                }
                            }
                        }
                    }
                }
               
                /* add details column to end of headers */
                if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn) {
                    altRowTemplateHTML += "<td class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                          "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                    rowTemplateHTML += "<td class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                        "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                }

                var trRow = "{{if isAltRow}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + altRowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + altRowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + altRowTemplateHTML + "</tr>"

                    + "{{else}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + rowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + rowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + rowTemplateHTML + "</tr>" +
                    "{{/if}}";


                var frozenTrRow = "{{if isAltRow}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + altRowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + altRowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + frozenRowTemplate + "</tr>"

                    + "{{else}}" + "<tr class='{{:~_" + proxy._id + "rowClassName()}} " +
                    "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} e-treegridrowcollapse {{/if}} e-templaterow "
                    + rowTemplateElement[0].className + "' style='{{if !isSummaryRow && !footerSummaryRowRecord}}" + rowTemplateElement[0].style.cssText + "{{else}}height:" + model.rowHeight + "px;{{/if}}display:{{:~_" + proxy._id + "expandStatus(#data)}}'" + "'>" + frozenAltRowTemplate + "</tr>" +
                    "{{/if}}";
            } else if (!model.parseRowTemplate && (model.rowTemplateID.length > 0 || model.altRowTemplateID.length > 0)) {
                /*Render rowTemplates without parsing*/
                if (model.rowTemplateID && model.altRowTemplateID) {
                    trRow = "{{if isAltRow}}" + $("#" + model.rowTemplateID).html().trim() + "{{else}}" + $("#" + model.altRowTemplateID).html().trim() + "{{/if}}";
                }
                else if (model.rowTemplateID.length > 0) {
                    trRow = $("#" + model.rowTemplateID).html().trim();
                } else if (model.altRowTemplateID.length > 0) {
                    trRow = $("#" + model.altRowTemplateID).html().trim();
                }   
            }

            else {

                var trRow = "<tr class='e-treegridrows {{:~_" + proxy._id + "rowClassName()}} ";

                if (model.enableAltRow) {
                    trRow += "{{if isAltRow}}e-alt-row{{/if}} ";
                }

              
                var tdCellCollections = "";
                for (columnCount = 0; columnCount < length; columnCount++) {
                    if (columns[columnCount]) {
                        columnName = columns[columnCount].field;
                        column = columns[columnCount];
                        var visible = columns[columnCount].visible == undefined ? true : columns[columnCount].visible;
                        var textAlign = columns[columnCount].textAlign;
                        //To create a seperate div in summary cell to display a summary title.
                        summaryTitlediv = "";
                        if (column.headerText == proxy._visibleColumns[0]) {
                            summaryTitlediv = '{{if isSummaryRow || footerSummaryRowRecord}}' + "<div " +
                                "class='e-summarytitle{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" + "style='float:left;display:block;'>" + "{{:~_" + proxy._id + "summaryTitle()}}"
                                 + "</div>" + '{{/if}}';
                        }

                        //CHECK THE template COLUMN OR NOT
                        if (column["isTemplateColumn"] && (column["angularTemplate"] || column["templateID"] || column["template"])) {

                            trRow += "e-templaterow ";
                            var headerText = column['headerText'];
                            if (!ej.isNullOrUndefined(headerText) && !ej.isNullOrUndefined(headerText.match(/(\\|[^0-9A-z-_])/g)))
                                headerText = headerText.replace(/(\\|[^0-9A-z-_])/g, "");
                            $("#" + proxy._id + headerText + $.inArray(column, this.model.columns) + "_Template").remove(); //Remove if any template already rendered
                            var scriptElement = this._createTemplateElement(column);
                            tdCell = "<td " +
                                 "class='{{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} e-rowcell e-templatecell{{if isSelected && ~_" + proxy._id + "SelectState()}} e-selectionbackground{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}} e-hide{{/if}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" +
                                 "style='text-Align:" + textAlign + ";'" +
                                 "role='row'>" +
                                 '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                 "{{:~_" + proxy._id + "treeGridTemplating('" + scriptElement.id + "','" + columnCount + "')}}" +
                                 '{{else}}' + summaryTitlediv + '{{/if}}';

                            if (!ej.isNullOrUndefined(column["format"]))
                                tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}" + '{{/if}}';
                            else
                                tdCell += '{{if isSummaryRow || footerSummaryRowRecord}}' + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + '{{/if}}';
                            tdCell += "</td>";
                            //EXPAND COLLAPSE COLUMN BASED ON THE TREECOLUMNINDEX
                        } else if (columnCount === model.treeColumnIndex) {

                            tdCell = "<td " +
                                 "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground e-intend {{else}}e-rowcell {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if !isSummaryRow && !footerSummaryRowRecord}} e-intend{{/if}} {{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" +
                                 "style='padding-left:{{if ~_" + proxy._id + "isTreeColumnIndex('" + columnName + "') && isSummaryRow }}{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px{{/if}};background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                 "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                 "role='row'>" +
                                 '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                 "<div class='e-inner-treecolumn-container' style='min-height:20px;'>" +
                                 "{{if hasChildRecords && hasFilteredChildRecords}}" +
                                 "<div " +
                                 "class='e-dragintend'" +
                                 "style='height:1px; float:left; width:{{:((level)*" + proxy.treeIndentLevelWidth + ")}}" + "px; display:inline-block;'>" +
                                 //indicators include for drag and drop
                                 "{{if !~_" + proxy._id + "getState() || !hasChildRecords}}" +
                                  "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                 "<span class='e-aboveIcon {{if level == 1 && hasChildRecords}} e-firstLevIconMargin {{/if}}  e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='e-belowIcon {{if level == 1 && hasChildRecords}} e-firstLevIconMargin {{/if}}  e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='e-childIcon {{if level == 1 && hasChildRecords}} e-firstLevIconMargin {{/if}}  e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='e-cancelIcon {{if level == 1 && hasChildRecords}} e-firstLevIconMargin {{/if}} e-icon' style='position:relative;float:right;display:none;'></span>" +
                                 "</div>" +
                                 "{{/if}}"+
                                 "</div>" +
                                 "{{else !hasChildRecords || (!hasFilteredChildRecords && hasChildRecords)}}" +
                                 "<div " +
                                 "class='e-dragintend'" +
                                 "style='height:1px; float:left; width:{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px; display:inline-block;'>" +
                                   //indicator icons included for drag and drop
                                 "{{if !~_" + proxy._id + "getState() || !hasChildRecords}}" +
                                 "<div class={{:~_" + proxy._id + "rowName()}} >"+
                                 "<span class='e-aboveIcon e-iconMargin e-icon'  style='position:relative;float:right;display:none;'></span>" +
                                 "<span class='e-belowIcon e-iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "<span class='e-childIcon e-iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "<span class='e-cancelIcon e-iconMargin e-icon' style='float:right;display:none;'></span>" +
                                 "</div>" +
                                  "{{/if}}" +
                                 "</div>" +
                                 "{{/if}}" +
                                 //indicator icons included for drag and drop
                                 "{{if ~_" + proxy._id + "getState() && hasChildRecords}}" +
                                 "<div " +
                                 "class='e-intendparent'>" +
                                 "<div class={{:~_" + proxy._id + "rowName()}} >" +
                                 "<span class='e-aboveIcon e-icon'  style='position:relative;float:left;display:none;'></span>" +
                                 "<span class='e-belowIcon e-icon' style='float:left;display:none;'></span>" +
                                 "<span class='e-childIcon e-icon' style='float:left;display:none;'></span>" +
                                 "<span class='e-cancelIcon e-icon' style='float:left;display:none;'></span>" +
                                 "</div>" +
                                 "</div>" +
                                 "{{/if}}" +
                                 "<div " +
                                 "class='{{if expanded && hasFilteredChildRecords}}e-treegridexpand e-icon{{else hasChildRecords && hasFilteredChildRecords}}" +
                                 "e-treegridcollapse e-icon{{/if}}'" +
                                 "style='float:left;display:inline-block; font-size:10px;'>" +
                                 "</div>" +
                                 "<div class='e-cell{{if " + (column.showCheckbox && (this.model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Checkbox)) + "}} e-treecheckboxcolumn{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" +
                                 "style='overflow: hidden;padding-left:{{if ~_" + proxy._id + "isTreeColumnIndex('" + columnName + "') && isSummaryRow}}{{:(level*" + proxy.treeIndentLevelWidth + ")+24}}" + "px{{/if}};'>" +
                                '{{/if}}' +
                                "{{:~_" + proxy._id + "getCheckboxState(#data, '" + columnName + "', '" + proxy._checkboxColumnName + "')}}";
                                
                            if (!ej.isNullOrUndefined(column["format"]))
                                tdCell += "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}";
                            else if (model.isFromGantt && column.mappingName === model.resourceInfoMapping) {
                                helpers = {};
                                helpers["_" + proxy._id + "resourceName"] = proxy._getResourceName;
                                $.views.helpers(helpers);
                                tdCell += "{{:~_" + proxy._id + "resourceName('" + proxy._id + "Object','"
                                 + model.resourceNameMapping + "','"
                                 + model.resourceUnitMapping + "','" + columnName + "')}}" +
                                "</div>" +
                                "</div>" +
                                "</td>";
                            } else if (model.isFromGantt && column.mappingName === model.predecessorMapping) {

                                helpers = {};
                                helpers["_" + proxy._id + "predecessor"] = $.proxy(proxy._getPredecessorsValue, proxy);
                                $.views.helpers(helpers);

                                tdCell += "{{:~_" + proxy._id + "predecessor(#data)}}" +
                                "</div>" +
                                "</div>" +
                                "</td>";
                            }
                            else {                               
                                tdCell += "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}" + summaryTitlediv +
                                '{{if !isSummaryRow && !footerSummaryRowRecord}}' +
                                "</div>" +
                                "</div>" +
                                "</td>" +
                                '{{/if}}';
                                summaryTitlediv = "";
                            }
                            //CHECK RESOURCE COLUMN FROM GANTT OR NOT
                        } else if (model.isFromGantt && column.mappingName === model.resourceInfoMapping) {
                            helpers = {};
                            helpers["_" + proxy._id + "resourceName"] = proxy._getResourceName;
                            $.views.helpers(helpers);

                            tdCell = "<td  " +
                                 "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}'" +
                                 "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                 "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                 "role='row'>" +
                                 "{{:~_" + proxy._id + "resourceName('" + proxy._id + "Object','"
                                 + model.resourceNameMapping + "','"
                                 + model.resourceUnitMapping + "','" + columnName + "')}}" +
                                 "</td>";
                            //CHECK PREDECESSOR COLUMN FROM GANTT OR NOT
                        } else if (model.isFromGantt && column.mappingName === model.predecessorMapping) {

                            helpers = {};
                            helpers["_" + proxy._id + "predecessor"] = $.proxy(proxy._getPredecessorsValue, proxy);
                            $.views.helpers(helpers);

                            tdCell = "<td " +
                                "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}' " +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                "role='row'>" +
                                "{{:~_" + proxy._id + "predecessor(#data)}}" +
                                "</td>";

                        } else if (model.isFromGantt && column.mappingName === model.durationMapping) {

                            helpers = {};
                            helpers["_" + proxy._id + "getDurationString"] = $.proxy(proxy._getDurationString, proxy);
                            $.views.helpers(helpers);

                            tdCell = "<td " +
                                "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}' " +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};'" +
                                "role='row'>" +
                                "{{:~_" + proxy._id + "getDurationString(#data)}}" +
                                "</td>";

                        }
                        else if (column["editType"] == "booleanedit" && proxy._checkboxSelection && columnName == "checkboxState") {
                            tdCell = "<td " +
                                "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};text-Align: center;'" +
                                "role='row'" +
                                ">" + summaryTitlediv + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "', '" + proxy._checkboxColumnName + "')}}";
                        }
                        else if (proxy._isCommandColumn(column)) {                            
                            $("#" + this._id + columnCount + "_UnboundTemplate").remove();
                            var divElement = proxy._createCommandElement(column, columnCount);                            
                            tdCell = "<td " +
                           "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-unboundcell e-selectionbackground {{else}}e-rowcell e-unboundcell {{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}}{{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}'" +
                           "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                           "{{:cellBackgroundColor}}{{else}}none{{/if}};text-Align:" + textAlign + "'" +
                           "role='row'> {{if !isSummaryRow && !footerSummaryRowRecord}}{{:~_" + proxy._id + "UnboundTemplate('" + divElement.id + "')}}{{else}}" + summaryTitlediv + "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "', '" + proxy._checkboxColumnName + "')}}{{/if}}";
                            proxy._commandColumnLength = proxy._commandColumnLength + 1;
                            tdCell += "</td>";
                        }
                        else {
                            tdCell = "<td " +
                                "class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-rowcell e-selectionbackground{{else}}e-rowcell{{/if}} {{:~_" + proxy._id + "isSelectedCell(#data,'" + columnCount + "')}} {{if " + !visible + "}}e-hide{{/if}} {{:~_" + proxy._id + "SummaryRowtdClassName()}}{{if isLastSummary}} e-lastsummaryrow{{/if}}{{if ~_" + proxy._id + "isTrimCell('" + column['clipMode'] + "')}} e-treegridtrimcell{{/if}} {{if " + isTextWrap + "}} e-textwrapcell{{/if}}'" +
                                "style='background-color:{{if cellBackgroundColor && ~_" + proxy._id + "checkColumn('" + columnName + "',#data)=='" + columnName + "'}}" +
                                "{{:cellBackgroundColor}}{{else}}none{{/if}};text-Align:" + textAlign + "'" +
                                "role='row'" +
                                ">" +
                                "{{:~_" + proxy._id + "getCheckboxState(#data, '" + columnName + "', '" + proxy._checkboxColumnName + "')}}" + summaryTitlediv;

                            if (!ej.isNullOrUndefined(column["format"]))
                                tdCell += "{{:~_" + proxy._id + "formatting('" + column["format"] + "',~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "'),'" + this.model.locale + "')}}";
                            else {
                                tdCell += "{{:~_" + proxy._id + "TemplateCellValue(#data,'" + columnName + "')}}";

                            }    
                            tdCell+= "</td>";
                            summaryTitlediv = "";
                        }

                        tdCellCollections += tdCell;
                    }
                    if (this._frozenColumnsLength > 0 && this._frozenColumnsLength == columnCount + 1) {
                        var frozenTrRow = "";
                        frozenTrRow += tdCellCollections;
                        frozenTrRow += "</tr>";
                        tdCellCollections = "";
                    }
                }

                /* add details column to end of header cell*/
                if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn) {
                    tdCellCollections += "<td class='{{if isSelected && ~_" + proxy._id + "SelectState()}}e-selectionbackground{{/if}} {{if isDetailsExpanded}}e-detailsrowexpand{{else}}e-detailsrowcollapse{{/if}}  " +
                                         "e-detailsrowcell{{if isLastSummary}} e-lastsummaryrow{{/if}}'>{{if !isSummaryRow && !footerSummaryRowRecord}}<div class='e-detailsiconcell e-icon {{if isDetailsExpanded}}e-detailsinfoiconhide{{else}}e-detailsinfoiconshow{{/if}}'></div>{{/if}}";
                }

                trRow += "{{if expanded && hasFilteredChildRecords}}e-treegridrowexpand {{else hasChildRecords && hasFilteredChildRecords}} " +
                      "e-treegridrowcollapse {{/if}} '" +
                      "style='background-color:{{if rowBackgroundColor }}{{:rowBackgroundColor}}{{else}}none{{/if}}; height:" + model.rowHeight + "px;" +
                      "display:{{:~_" + proxy._id + "expandStatus(#data)}}'" +
                      "role='treegrid'>";
                frozenTrRow = trRow + frozenTrRow;
                trRow += tdCellCollections;

                if (model.isFromGantt) {
                    trRow += "<td class='e-extendcolumn'></td></tr>";
                } else {
                    trRow += "</tr>";
                }
            }

            if (model.showDetailsRow && model.detailsTemplate)
            {
                trRow += "{{if isDetailsExpanded}}" + proxy._createDetailsRowTemplate() + "{{/if}}";
                frozenTrRow += "{{if isDetailsExpanded}}" + proxy._createDetailsRowTemplate(true) + "{{/if}}";
            }

            var templates = {};
            templates[proxy._id + "_Template"] = trRow;
            templates[proxy._id + "_JSONFrozenTemplate"] = frozenTrRow;

            $.templates(templates);

            

        },
        
        //#endregion template

        //#region template METHODS

        _gridTemplate: function (self, templateId, columnIndex) {
            var column;
            if (!ej.isNullOrUndefined(columnIndex))
                column = self.model.columns[columnIndex];
            return self._renderEjTemplate("#" + templateId, this.data, this.data.index, column);
        },

        //method for calculating the indent width for expander column
        _getIndentWidth:function(data){
            var level = data.level;
            return (level * this.treeIndentLevelWidth) + "px";
		},


        //creating template element for angulartemplate in details row template
        _createDetailRowTemplateElement: function (detailTemplate) {
            var quickReg = /^#([\w-]*)/,
                scripEle,
                match = quickReg.exec(detailTemplate), scriptReg = /^<script/i;

            var options = {
                name: "SCRIPT",
                type: "text/x-template",
                text: detailTemplate,
                id: "treeGridDetailsRowTemplateElement" + this._id
            };

            if (match && match[1])
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(detailTemplate))
                    scripEle = $(detailTemplate).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }

            scripEle.id = scripEle.id || options.id;
            scripEle.type = scripEle.type || options.type;
            $("body").append(scripEle);
            return scripEle;
        },


        //creating template element for angulartemplate in row template
        _createRowTemplateElement: function (innerHtml, id, type) {
            var scriptElement = document.createElement("script");
            scriptElement.id = id;
            scriptElement.type = type || "text/x-template";
            scriptElement.text = innerHtml;

            $("body").append(scriptElement);
            return scriptElement;
        },

        //creating a template element for angularjs template
        _createTemplateElement: function (column, text) {

            var idText = text ? "Pager" : column.headerText + $.inArray(column, this.model.columns) + "_Template",
                property = "template" in column ? "template" : "templateID" in column ? "templateID" : "angularTemplate",
                template = column[property],
                quickReg = /^#([\w-]*)/, scriptReg = /^<script/i, scripEle;

            if (property == "templateID") {
                if (template.indexOf("#") == -1)
                    template = "#" + template;
            }

            var match = quickReg.exec(template),
                options = {
                    name: "SCRIPT",
                    type: "text/x-template",
                    text: template,
                    id: (this._id + idText).replace(/(\\|[^0-9A-z-_])/g, "")
                };

            if (match && match[1])
                scripEle = document.getElementById(match[1]);
            else {
                if (scriptReg.test(template)) // branch here to handle tmpl string with SCRIPT. 
                    scripEle = $(template).get(0);
                else
                    scripEle = ej.buildTag(options.name, options.text).get(0);
            }
            scripEle.id = scripEle.id || options.id;
            scripEle.type = scripEle.type || options.type;
            $("body").append(scripEle);
            return scripEle;
        },

        //Get checkbox state while rendering the treegrid
        _getCheckboxState: function (data, columnName, checkboxColumnName) {
            if (columnName != checkboxColumnName)
                return;
            if (data['isSummaryRow'] == true || data.summaryColumn || data.summaryRow)
                return;
            var checkboxState;
            if (data.checkboxState == "indeterminate") {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                '<div class="e-chkbox-small">' +
                '<span class="e-chk-indeter"><span class="e-checkbox e-chk-image e-icon e-stop" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            else if (data.checkboxState == "unchecked") {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                    '<div class="e-chkbox-small">' +
                    '<span class="e-chk-inact"><span class="e-checkbox e-chk-image e-icon" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            else {
                checkboxState = '<span class="e-chkbox-wrap e-widget" style="padding-right:10px;color:#c8c8c8;">' +
                    '<div class="e-chkbox-small">' +
                    '<span class="e-chk-act"><span class=" e-checkbox e-chk-image e-icon e-checkmark" id =' + this._id + '_checkbox' + data.ejRowId + '></span></span></div></span>';
            }
            return checkboxState;
        },

        // Healper method to check the clip mode of the cell is in 'ellipsis'.
        _checkIsTrimCell: function (clipMode) {
            var proxy = this;
            if (clipMode && clipMode == "ellipsis")
                return true;
            else
                return false;
        },

        _getCustomCellValue: function (data, columnName) {
            if (!ej.isNullOrUndefined(data)) {
                var splits = (columnName || "").split("."), cellValue;
                if (splits.length <= 1)
                    cellValue = data[columnName];
                else {
                    cellValue = data[splits[0]];
                    if (ej.isNullOrUndefined(cellValue)) {
                        //if (typeof cellValue === "undefined")
                        //    this._restoreCustomData(data, "", columnName);
                        return null;
                    }
                    for (var splitKeyIndex = 1; splitKeyIndex < splits.length; splitKeyIndex++) {
                        cellValue = cellValue[splits[splitKeyIndex]];
                        if (ej.isNullOrUndefined(cellValue)) {
                            //if (typeof cellValue === "undefined")
                            //    this._restoreCustomData(data, "", columnName);
                            return null;
                        }
                    }
                }
                return cellValue;
            }
        },

        _restoreCustomData: function (data, value, fieldName) {
            var proxy = this, splitIndex = 0,dataIndex = 0;
            if (ej.isNullOrUndefined(fieldName)) {
                var fieldName = proxy._cellEditingDetails.fieldName;
            }
            var splits = (fieldName || "").split("."), cellValue = {};
            if (splits.length <= 1) {
                if (!ej.isNullOrUndefined(data)) {
                    data[fieldName] = value;
                } else {
                    data = {};
                    data[fieldName] = value;
                }
            }
            else {
                if (!ej.isNullOrUndefined(data)) {
                    cellValue = data[splits[0]];
                    if (ej.isNullOrUndefined(cellValue)) {
                        cellValue = {};
                        data[splits[0]] = cellValue;
                    }
                    dataIndex = 1;
                } else {
                    data = {};
                    cellValue = data;
                    dataIndex = 0;
                }
                for (splitIndex = dataIndex; splitIndex < (splits.length - 1) ; splitIndex++) {
                    if (ej.isNullOrUndefined(cellValue[splits[splitIndex]])) {
                        cellValue[splits[splitIndex]] = {};
                    }
                    cellValue = cellValue[splits[splitIndex]];
                }
                cellValue[splits[splitIndex]] = value;
            }
                return data;
        },

        //Get the cell value while rendering the tree grid.
        _getTemplateCellValue:function(data,columnName, checkboxColumn)
        {
            var proxy = this,
                column = proxy.getColumnByField(columnName),
                editType = column.editType, i, dropdownValue,
                cellValue = proxy._getCustomCellValue(data, columnName);
               var value, text;
            if (!ej.isNullOrUndefined(cellValue)) {
                cellValue = cellValue;
            } else {
                cellValue = data.item && data.item[columnName];
            }
            if (editType == ej.TreeGrid.EditingType.Boolean && columnName == checkboxColumn) {
                cellValue = proxy._getCheckboxState(data, columnName, checkboxColumn);
            } else if (!data['isSummaryRow'] && !data["footerSummaryRowRecord"] && editType == ej.TreeGrid.EditingType.Boolean && columnName != checkboxColumn && (ej.isNullOrUndefined(column.displayAsCheckbox) || column.displayAsCheckbox)) {
                if (cellValue == "true" || cellValue == true)
                    cellValue = "<input class='e-treegrid-chekboxcell' type='checkbox' disabled='disabled' checked/>";
                else
                    cellValue = "<input class='e-treegrid-chekboxcell' type='checkbox' disabled='disabled'/>";
            }

            if (proxy.model.isFromGantt) {

                if (columnName == "work")
                    cellValue += " " + proxy.model.workUnit;
                if (columnName == "taskMode")
                    cellValue = !data.isAutoSchedule;
                if (columnName == "unit")
                    cellValue += "" + "%";
                if (columnName == "duration")
                    cellValue = proxy._getDurationString(data);
            }

            if (editType == ej.TreeGrid.EditingType.Dropdown)
            {
                var editParams = column.editParams;
                cellValue = (cellValue != null || cellValue != undefined) ? cellValue : "";
                if(editParams && editParams.fields)
                {
                    text = editParams.fields.text ? editParams.fields.text : "text";
                    value = editParams.fields.value ? editParams.fields.value : "value";
                }
                else
                {
                    value = "value";
                    text = "text";
                }
                if (editParams && editParams.showCheckbox) {
                    var cellValueCollection = cellValue.split(",");
                    var length = cellValueCollection.length;
                    cellValue = "";
                    if (column.dropdownData) {
                        for (var i = 0; i < length; i++) {
                            var dropdownDataCollection = column.dropdownData;
                            dropdownValue = $.map(dropdownDataCollection, function (dropdownData) {
                                if (!ej.isNullOrUndefined(dropdownData[value])) {
                                    if (dropdownData[value].toString() == cellValueCollection[i].toString())
                                        return dropdownData[text];
                                }
                                else {
                                    if (dropdownData[text] == cellValueCollection[i])
                                        return dropdownData[text];
                                }
                            });
                            dropdownValue[0] = dropdownValue[0] ? dropdownValue[0] : "";
                            cellValue += i == 0 ? dropdownValue[0] : ","+dropdownValue[0];
                        }
                    }
                }
                else {
                    if (column.dropdownData) {
                        var dropdownDataCollection = column.dropdownData;
                        dropdownValue = $.map(dropdownDataCollection, function (dropdownData) {
                            if (!ej.isNullOrUndefined(dropdownData[value])) {
                                if (dropdownData[value].toString() == cellValue.toString())
                                    return dropdownData[text];
                            }
                            else {
                                if (dropdownData[text].toString() == cellValue)
                                    return dropdownData[text];
                            }
                        });
                        dropdownValue[0] = ej.isNullOrUndefined(dropdownValue[0]) ? "" : dropdownValue[0];
                        cellValue = dropdownValue[0];
                    }
                }
            }           
            return cellValue;
        },

        _getCellValue: function (data, columnName) {

            var cellValue = this._getCustomCellValue(data, columnName);

            if (cellValue || cellValue===0) {
                return cellValue;
            } else {
                return data.item && data.item[columnName];
            }


        },
        _isCommandColumn: function (column) {
            var proxy = this, model = proxy.model,
            commands = column.commands;
            if ((!ej.isNullOrUndefined(commands) && commands.length == 0 )|| ej.isNullOrUndefined(commands))
                return false;
            else
                return true;
        },
        _isTreeColumnIndex: function (columnName) {
            var proxy = this, model = proxy.model,
            currentColumn = model.columns[model.treeColumnIndex];
            if (currentColumn && currentColumn.field == columnName)
                return true;
            else
                return false;
        },
        _getSummaryTitle: function () {
            var proxy = this;
            var summaryTitleValue = proxy.data.summaryRow.title;
            if (summaryTitleValue)
                return summaryTitleValue;
            else
                return proxy.data.item && proxy.data.item.summaryRow.title;
        },

        _getCellColumn: function (columnName,data) {
            var proxy = this;

            if (data.treeMappingName.indexOf(columnName) !== -1) {
                return columnName;
            }
            else {
                return "none";
            }


        },

        //GET RESOURCE NAME FOR RESOURCE COLUMN IN THE GANTT CONTROL
        _getResourceName: function (gridObject, mappingName, unitMappingName, columnName) {

            var proxy = this,
                data = proxy.data[columnName],
                count = 0,
                resourceString, resourceUnit,
                length = data && data.length,
                resourceName = [];

            if (data && data.length > 0) {
                for (count; count < length; count++) {
                    resourceString = data[count][mappingName];
                    resourceUnit = data[count][unitMappingName];
                    if (resourceUnit != 100)
                        resourceString += "[" + resourceUnit + "%]";                    
                    resourceName.push(resourceString);
                }
            }
            return resourceName;
        },

        _getDurationString: function (data) {
            var val = "";
            if (data.duration != null && data.duration != "")
                if (typeof data.duration == "string") {
                    var duration = parseFloat(data.duration);
                    val += !isNaN(duration) ? parseFloat(duration.toFixed(2)) + " " : "";
                }
                else
                    val += parseFloat(data.duration.toFixed(2)) + " ";
            if (data.durationUnit != null) {
                var multiple = data.duration != 1;
                if (data.durationUnit == "day")
                    val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                else if (data.durationUnit == "hour")
                    val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                else
                    val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
            }
            return val;
        },
        //GET PREDECESSOR VALUE FOR PREDECESSOR COLUMN IN THE GANTT CONTROL
        _getPredecessorsValue: function (data) {
            var predecessors = data.predecessor,
                returnVal = "",
                resultString = "";
            if (predecessors) {
                var length = predecessors.length;
                for (var i = 0; i < length; i++) {
                    var cPredecessor = predecessors[i],
                        temp = "";
                    if (cPredecessor.from != data.taskId) {
                        temp = cPredecessor.from + cPredecessor.predecessorsType;
                        if (cPredecessor.offset != 0) {
                            temp += cPredecessor.offset > 0 ? ("+" + cPredecessor.offset + " ") : (cPredecessor.offset + " ");
                            var multiple = Math.abs(cPredecessor.offset) != 1;
                            if (cPredecessor.offsetDurationUnit == "day")
                                temp += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                            else if (cPredecessor.offsetDurationUnit == "hour")
                                temp += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                            else
                                temp += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
                        }
                        if (resultString.length > 0)
                            resultString = resultString + "," + temp;
                        else
                            resultString = temp;
                    }
                }
            }
            return resultString;
        },

        //GET THE EXPAND COLLAPSE STATUS OF TABLE ROW
        _getExpandStatusRecord: function (data) {

            var proxy = this;

            if (proxy.getExpandStatus(data)) {

                return 'table-row';

            }

            return 'none';
        },

        //#endregion TEMPLATE METHODS

        //#region CONVERT HIERARCHICAL RECORDS TO FLAT RECORDS
        //CREATE FLATRECORDS FROM HIERARCHICAL DATASOURCE
        _createRecords: function (dataSource) {

            var proxy = this,
                model = proxy.model,
                ids=proxy.model.ids,
                flatRecords = model.flatRecords,
                length = dataSource.length,
                count = 0,
                expanded = true,
                parentRecord,
                parentRecords = model.parentRecords;

            if (!model.isFromGantt && model.enableCollapseAll) 
                expanded = false;            

            for (count; count < length; count++) {

                parentRecord = proxy._createRecord(dataSource[count], 0, null, expanded);
                proxy._storedIndex++;

                //CHECK ALTROW ENABLED OR NOT
                
                parentRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                

                //CHECK SORTING ENABLED OR NOT
                
                parentRecords.push(parentRecord);
                

                parentRecord.index = proxy._storedIndex;
                ids[proxy._storedIndex] = parentRecord.index;
                flatRecords.push(parentRecord);
                if (parentRecord.hasChildRecords)
                    proxy._parentRecords.push(parentRecord);
                parentRecord.childRecords && proxy._addNestedRecords(parentRecord.childRecords);

                if (this.dataSource() instanceof ej.DataManager && proxy._isLoadonDemand) {
                    if (parentRecord.item[model.hasChildMapping] || proxy._assignedParendIDs.indexOf(parentRecord.item[model.idMapping]) != -1) {
                        parentRecord.hasChildRecords = true;
                        parentRecord.childRecords = [];
                        parentRecord.isChildRetrieved = false;
                    }
                }
            }
            if (model.allowPaging && !proxy._isRemoteData) {

                if (!ej.isNullOrUndefined(model.pageSettings.totalRecordsCount) && model.pageSettings.totalRecordsCount <= flatRecords.length) {
                    var totalRecordsCount = model.pageSettings.totalRecordsCount;
                    model.flatRecords = flatRecords.slice(0, totalRecordsCount);
                    if (model.flatRecords[totalRecordsCount - 1].hasChildRecords) {
                        model.flatRecords[totalRecordsCount - 1].hasChildRecords = false;
                        model.flatRecords[totalRecordsCount - 1].expanded = false;
                        model.flatRecords[totalRecordsCount - 1].childRecords = null;
                        model.flatRecords[totalRecordsCount - 1].hasFilteredChildRecords = false;
                    }
                }
                else if (ej.isNullOrUndefined(model.pageSettings.totalRecordsCount))
                    model.pageSettings.totalRecordsCount = flatRecords.length;
            }
            /* assign records length as max index */
            proxy._maxRowIndex = this.model.flatRecords.length;
        },


        //CREATE RECORD OBJECT
        _createRecord: function (data, level, parentItem, expanded) {

            var proxy = this,
                record,
                childDataSource = data[proxy.model.childMapping], model = this.model;

            //To create and maintain record collections for multi select dropdownedit of columns
            record = $.extend({}, data);
            var tempData;
            if (model.parentIdMapping && proxy._createdAt === "load") {
                var id = data[model.idMapping],
                   index = proxy._taskIds.indexOf(id);
                record.item = (index > -1) ? proxy._retrivedData[index] : [];              
            }
            else {

                if (this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.json && this.dataSource().dataSource.offline && proxy._createdAt === "load") {

                    if (model.parentIdMapping) {
                        var id = data[model.idMapping],
                           index = proxy._taskIds.indexOf(id);
                        record.item = (index > -1) ? proxy._retrivedData[index] : [];
                    }
                    else {
                        record.item = data;
                    }
                }
                else {
                    record.item = data;
                }
            }
            record.parentItem = parentItem;
			record.childRecords = (childDataSource && childDataSource.length > 0) && proxy._createChildRecords(childDataSource, level + 1, record);
			record.hasChildRecords = (childDataSource && childDataSource.length > 0) ? true : false;
			if (model.expandStateMapping && record.hasChildRecords) {
			    if (!ej.isNullOrUndefined(data[model.expandStateMapping])) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping];
			    } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && !model.enableCollapseAll) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping] = true;
			    } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && model.enableCollapseAll) {
			        record[model.expandStateMapping] = record.item[model.expandStateMapping] = data[model.expandStateMapping] = false;
			    }
			    var expandStateMapping = data[model.expandStateMapping];
			}
			else
			    var expandStateMapping = true;
			record.expanded = (expanded !== undefined && childDataSource !== undefined && record.hasChildRecords == true
                && expandStateMapping) ? expanded : expandStateMapping && childDataSource ? childDataSource.length > 0 : false;
            record.dragState = true;
            record.isSelected = false;
            record.hasFilteredChildRecords = true;//Used to Indicates Parent records can expandable or not on Filtering operation
            record.level = level;
            record.cellBackgroundColor = null;
            record.rowBackgroundColor = null;
            record.textWrapRowHeight = model.rowHeight;
            record.treeMappingName = [];
            if (model.showDetailsRow && model.detailsTemplate) {
                record.isDetailsExpanded = model.showDetailsRowInfoColumn ? false : true;
            } else {
                record.isDetailsExpanded = false;
            }
            if (!model.isFromGantt)
                record.ejRowId = ++proxy._idGenerator;
            record.checkboxState = "unchecked";
            delete record[model.childMapping];
            return record;
        },


        //CREATE CHILD GANTT RECORDS
        _createChildRecords: function (childDataSource, level, parentItem) {

            var proxy = this,
                model=proxy.model,
                records = [],
                count = 0,
                length = childDataSource.length,
                record = null,
                expanded,
                childRecord;

            if (!model.isFromGantt && model.enableCollapseAll)
                expanded = false;

            for (count = 0; count < length; count++) {

                record = childDataSource[count];

                if (record) {
                    childRecord = proxy._createRecord(record, level, parentItem, expanded);
                    records.push(childRecord);
                }
            }

            return records;

        },


        //ADD NESTED RECORDS TO FLATRECORDS
        _addNestedRecords: function (childDataSource) {

            var proxy = this,
                model = proxy.model,
                ids=proxy.model.ids,
                flatRecords = model.flatRecords,
                updatedRecords = model.updatedRecords,
                count = 0,
                length = childDataSource.length,
                records = [],
                record;
                

            for (count = 0; count < length; count++) {

                record = childDataSource[count];
                proxy._storedIndex++;

                //CHECK ALTROW ENABLED OR NOT
                
                record.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                

                record.index = proxy._storedIndex;
                ids[proxy._storedIndex] = record.index;
                flatRecords.push(record);
                updatedRecords.push(record);
                if (record.hasChildRecords)
                    proxy._parentRecords.push(record);
                records = record.childRecords;

                if (records) {

                    var j = 0,
                        recordlength = records.length,
                        childRecord = null;

                    for (j = 0; j < recordlength; j++) {

                        childRecord = records[j];
                        proxy._storedIndex++;     
                        childRecord.index = proxy._storedIndex;
                        ids[proxy._storedIndex] = childRecord.index;
                        //CHECK ALTROW ENABLED OR NOT
                        
                        childRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        
                        flatRecords.push(childRecord);
                        updatedRecords.push(record);
                        if (childRecord.hasChildRecords)
                            proxy._parentRecords.push(childRecord);
                        childRecord.childRecords && proxy._addNestedRecords(childRecord.childRecords);
                    }
                }
            }
        },

        //EVENT FOR COLUMN RESIZE
        _enableColumnResizeEvents: function () {

            var proxy = this;

            if (proxy.model.allowColumnResize) {
                proxy._on(proxy.element, "mousemove", proxy._mouseMove);
            } else {
                proxy._off(proxy.element, "mousemove", proxy._mouseMove);
            }
        },

        //#endregion CONVERT HIERARCHICAL RECORDS TO FLAT RECORDS

        //#region METHOD FOR EVENTS

        //INITIALIZE THE EVENTS
        _wireEvents: function () {

            var proxy = this,
                model = proxy.model,
                matched = jQuery.uaMatch(navigator.userAgent);

            //proxy._$gridContent.bind("scroll", $.proxy(proxy._onScroll, proxy));
            if (ej.isTouchDevice()) {
                proxy._on(proxy.element, "tap", proxy._onRecordClick);// ".e-gridcontent",
                proxy._on(proxy.element, "tap", proxy._onClick);
            }
            else {
                proxy._on(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",
                proxy._on(proxy.element, "click", proxy._onClick);
            }            
            proxy._on(proxy.element, "keydown", proxy._keyDown);
            proxy._on(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._on(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._on($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._on(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);            
            
            if (this.model.isResponsive)
                this._on(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));

            if (proxy.model.allowColumnResize)
                proxy._on(proxy.element, "mousemove", proxy._mouseMove);
            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._on(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._on(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }
            proxy._on(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._on(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip || proxy.model.showGridExpandCellTooltip) {
                proxy._on(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {
                proxy._on(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
            }
            proxy._on(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._on(proxy.element, "mouseleave", proxy._cellMouseLeave);            
            proxy._on(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._on(proxy.element, "mouseleave", proxy._headerMouseLeave);
            

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._on(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._on($(window), "resize", proxy._windowResize);
            }
            proxy._enableEditingEvents();
            this._on(this.element, "click", ".e-unboundcelldiv button", this._unboundClickHandler);
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._on(proxy.element, "keyup contextmenu taphold", this._preventContextMenu);
            }
        },
        /* prevent context menu action by menu option key*/
        _preventContextMenu: function (e) {
            
            if (e.keyCode == 93 || e.type == "contextmenu" || e.type == "taphold") {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
        },
        _mouseDownHandler:function(e)
        {
            var proxy = this,
                target = $(e.target);
            //Check the whether the mouse down on column menu and column menu items
            if (target.closest("div.e-columnmenuitem").length == 0 && target.closest("div.e-columnMenuListDiv").length == 0 && ((!target.hasClass("e-columnmenu-icon") && !target.hasClass("e-column-filter-icon") && !target.hasClass("e-column-filtered-icon")) || $(e.target).closest("#" + proxy._id).length == 0) && target.closest("div.e-" + proxy._id + "filterStringSelector").length == 0 && target.closest("div#" + proxy._id + "filterStringDropDown_popup_list_wrapper").length == 0
                && target.closest("div#" + proxy._id + "filterStringInputBox_suggestion").length == 0 && target.closest("div.e-" + proxy._id + "filterNumericSelector").length == 0 && target.closest("div#" + proxy._id + "filterNumericDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div.e-" + proxy._id + "filterDatepickerSelector").length == 0 && target.closest("div#" + proxy._id + "filterDatepickerDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div#e-" + proxy._id + "filterDatepickerInputBox").length == 0 && target.closest("div.e-" + proxy._id + "filterDatetimepickerSelector").length == 0 && target.closest("div#" + proxy._id + "filterDatetimepickerDropDown_popup_list_wrapper").length == 0 &&
                target.closest("div#" + proxy._id + "filterDatetimepickerInputBox_popup").length == 0 && target.closest("div.e-" + proxy._id + "filterDropdownSelector").length == 0 && target.closest("div#" + proxy._id + "filterDropdownDropDown_popup_list_wrapper").length == 0 && target.closest("div.e-" + proxy._id + "filterBooleanSelector").length == 0)
                proxy._clearColumnMenu();
            //Check the whether the mouse down on context menu items
            if (target.closest("div.e-menuitem").length == 0)
                proxy._clearContextMenu();
            //Check the detail template items on mouse down event
            if (target.closest("div.e-detailscellwrapperfly").length == 0)
                proxy._removeDetailsRow(e);            
        },
        // Auto scroll the content if mouse move out of grid area while dragging a row.
        _mouseout: function (e) {
            var proxy = this,
                model = proxy.model,
                topvalue, bottomScrollPos, topScrollPos,
                position = proxy._gridPosition,
                top = position.top, contentHeight = proxy._gridHeight,
                height = proxy._$gridHeaderContainer.height() + top;

            if (model.toolbarSettings.showToolbar) {
                var id = model.isFromGantt ? proxy._id.replace("ejTreeGrid", "") : proxy._id;
                height += $("#" + id + "_toolbarItems").length > 0 ? $("#" + id + "_toolbarItems").outerHeight() : 0;
            }            
            if (model.allowPaging) {
                contentHeight = contentHeight - proxy.element.find(".e-pager").first().outerHeight();
            }
            if (model.showTotalSummary) {
                contentHeight = contentHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
            if (proxy._dragMouseDown) {
                var posx = position.left, posy = e.pageY;

                if (proxy.model.isFromGantt) {
                    var id = proxy._id.replace("ejTreeGrid", "");
                    var ganttbody = $("#"+id).find(".e-ganttviewerbodyContianer"),
                        isVscroll = ganttbody.ejScroller("isVScroll"),
                        max = isVscroll ? ganttbody.find(".e-content").get(0).scrollHeight - 1 : 0;
                    bottomScrollPos = ganttbody.ejScroller("isHScroll") ? (contentHeight + top - (model.rowHeight / 2) - 18) :
                                        (contentHeight + top - (model.rowHeight / 2));
                    }
                else{
                    var max = proxy.isVScroll() ? proxy.getMaxScrollHeight() + 1 : 0;
                    bottomScrollPos = proxy.getScrollElement().ejScroller("isHScroll") ? (contentHeight + top - (model.rowHeight / 2) - 18) :
                                           (contentHeight + top - (model.rowHeight / 2));
                }
                    topScrollPos = height + (model.rowHeight/2);
                   
                    //condition to whether the mouse pointer below the content.
                if (posy > bottomScrollPos) {
                        //Condition to check whether the scroller reaches the end.

                        if (max > (proxy._scrollTop)) {
                            if (!proxy._timerDragDown) {

                                //Timer started for scrolling the content till the end.
                                proxy._timerDragDown = window.setInterval(function () {
                                    if (max > proxy._scrollTop) {
                                        topvalue = proxy._scrollTop + 20;
                                        topvalue = topvalue > max ? max : topvalue;
                                        if (proxy.model.isFromGantt)
                                            ganttbody.ejScroller("scrollY", topvalue, true);
                                        else
                                            proxy.getScrollElement().ejScroller("scrollY", topvalue, true);                       
                                    }                                    
                                }, 100);
                            }
                        }
                        else {
                            proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
                        }
                    }
                    else {
                    proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
                    }
                    //condition to check if the mouse points above to content area.
                if (posy < topScrollPos && proxy._scrollTop != 0) {
                        if (proxy._scrollTop > 0) {
                            if (!proxy._timerDragUp) {
                                proxy._timerDragUp = window.setInterval(function () {
                                    if (proxy._scrollTop > 0) {
                                        topvalue = proxy._scrollTop - 20;                                        
                                        if (topvalue < 0)
                                            topvalue = 0;
                                        if (proxy.model.isFromGantt)
                                            ganttbody.ejScroller("scrollY", topvalue, true);
                                        else
                                            proxy.getScrollElement().ejScroller("scrollY", topvalue, true);
                                    }
                                }, 100);
                            }
                        }
                        else {
                            proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                        }
                    }
                    else {
                    proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                    }                
            }
        },       
        // This method is to get the row range to enable the drag row indicators consequently.
        getRange: function (record, index,$tr) {
            
            var proxy = this,
                model = proxy.model,
                roundOff = 0, rowTop = 0,
                rowHeight = $tr[0].offsetHeight,
                position = proxy.getOffsetRect($("#" + proxy._id)[0]),
                height = proxy._$gridHeaderContainer.height() + position.top;
                rowHeight += proxy._detailsRowHeight;

            if (model.toolbarSettings.showToolbar)
                height += !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").height()) ? $("#" + proxy._id + "_toolbarItems").height() : 0;
            if (model.allowTextWrap) {
                rowTop = $tr.offset().top;
            }
            else if (proxy._scrollTop != 0) {
                roundOff = rowHeight - proxy._scrollTop % rowHeight;
                rowTop = (index * rowHeight) + height + roundOff;
            } else {
                rowTop = (index * rowHeight) + height + roundOff;
            }
            // 7 is to equalize the height.
            var rowBottom = rowTop + $tr[0].offsetHeight,
                difference = rowBottom - rowTop,
                divide = difference / 3,
                topRowSegment = rowTop + divide,
                middleRowSegment = topRowSegment + divide,
                bottomRowSegment = middleRowSegment + divide,
                position = {
                    topRowSegment: topRowSegment,
                    middleRowSegment: middleRowSegment,
                    bottomRowSegment: bottomRowSegment
                };
            return position;
        },
        //Child validation to display the child indicator.
        _childValidation: function (record) {            
            var childIndex,
                proxy = this,
                draggedRecord = proxy._draggedRecord,
                parentItem = draggedRecord.parentItem,
                childRecords;
            if (parentItem) {
                childRecords = parentItem.childRecords;
                childIndex = childRecords.indexOf(this._draggedRecord);
                if (record == parentItem && childIndex != -1)
                    this._childItem = true;
            }
        },
        _isColumnHidable: function (column) {
            var model = this.model, visibleFrozenColumn = [], visibleUnfrozenColumn = [], returnValue = true;

            visibleFrozenColumn = this._frozenColumns.filter(function (value) {
                return value.visible == true;
            });
            visibleUnfrozenColumn = this._unFrozenColumns.filter(function (value) {
                return value.visible == true;
            });
            if (visibleFrozenColumn.length == 1 && visibleFrozenColumn[0].field == column.field) {
                returnValue = false;
            }
            if (visibleUnfrozenColumn.length == 1 && visibleUnfrozenColumn[0].field == column.field) {
                returnValue = false;
            }
            return returnValue;
        },
        _updateColumnMenuVisibility: function () {
            var model = this.model, visibleFrozenColumn = [], visibleUnfrozenColumn = [];
            if (model.showColumnChooser) {
                visibleFrozenColumn = this._frozenColumns.filter(function (value) {
                    return value.visible == true;
                });
                visibleUnfrozenColumn = this._unFrozenColumns.filter(function (value) {
                    return value.visible == true;
                });
                if (visibleFrozenColumn.length == 1) {
                    var checkBoxData = $("#" + this._id + "_columnMenu_" + visibleFrozenColumn[0].field.split('.').join("")).data("ejCheckBox");
                    if (checkBoxData)
                        checkBoxData.option("enabled", false);
                }
                if (visibleUnfrozenColumn.length == 1) {
                    var checkBoxData = $("#" + this._id + "_columnMenu_" + visibleUnfrozenColumn[0].field.split('.').join("")).data("ejCheckBox");
                    if (checkBoxData)
                        checkBoxData.option("enabled", false);
                }
            }
        },
        //This method is to render the tooltip while dragging.
        _renderToolTip: function (e, element, args, $target) {
            var proxy = this,                
                model = this.model,
                positions = [],
                doc = document,
                item,
                columns = proxy.model.columns,
                tooltipItemLength = model.dragTooltip.tooltipItems.length,
                columnTooltipValue,
                $tr = $target.closest('tr'),
                $td,
                recordIndex = proxy.getIndexByRow($tr),
                positions = {}, records, dragRecIndex, index,
            updatedRecords = proxy.getUpdatedRecords();
            proxy._insertAbove = false;
            proxy._insertAsChild = false;
            proxy._insertBelow = false;
            proxy._childItem = false;            
            proxy._currentRecord = model.currentViewData[recordIndex];
            item = proxy._draggedRecord;

            if (recordIndex != proxy._draggedIndex)
                proxy._displayContextMenu = false;
                        
            // disable all the icons initially.
            $(".e-dragintend").find(".e-icon").css({ "display": "none" });
            $(".e-intendparent").find(".e-icon").css({ "display": "none" });
            $(".e-error").css({ "display": "none" });
            $(".e-treegridexpand").css({ "display": "inline-block" });
            $(".e-treegridcollapse").css({ "display": "inline-block" });           
               
            // to get the record index to find its mouse position.            
            var records = proxy.getExpandedRecords(updatedRecords);
                proxy.getVisibleRange();
                var currentViewData = records.slice(proxy._visibleRange.top, proxy._visibleRange.bottom);
                if (proxy._scrollTop != 0) {
                    dragRecIndex = updatedRecords.indexOf(proxy._draggedRecord) - 1;
                    index = currentViewData.indexOf(proxy._currentRecord) - 1;
                }
                else {
                    dragRecIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    var index = currentViewData.indexOf(proxy._currentRecord);
                }
            var currentIndex = updatedRecords.indexOf(proxy._currentRecord),
            isNextRecord = proxy._currentRecord && proxy._checkPrevNextRecord(proxy._draggedRecord, currentIndex, proxy._currentRecord.level, "next"),
            isPrevRecord = proxy._currentRecord && proxy._checkPrevNextRecord(proxy._draggedRecord, currentIndex, proxy._currentRecord.level, "prev"),
            posx = proxy._gridPosition.left, posy = e.pageY;

            if (proxy._currentRecord)
                positions = proxy.getRange(proxy._currentRecord, index, $tr);
                                           
            var isTopRowSegment = posy <= positions.topRowSegment,
                isMiddleRowSegment = (posy > positions.topRowSegment && posy <= positions.middleRowSegment),
                isBottomRowSegment = (posy > positions.middleRowSegment && posy <= positions.bottomRowSegment);
            /* check current record or else render previous records tootip*/
            if (proxy._currentRecord) {
                proxy.data = proxy._currentRecord;
                var classname = this._getrowName();
                proxy._childValidation(proxy._currentRecord);
                // This condition is to disapper the expand collapse icon if it is top most level.
                if (!proxy._currentRecord.parentItem) {
                    if (proxy._currentRecord.hasChildRecords)
                        if (proxy._currentRecord.expanded)
                            $tr.find(".e-treegridexpand").css({ "display": "none" });
                        else
                            $tr.find(".e-treegridcollapse").css({ "display": "none" });
                }
                else {
                    if (proxy._currentRecord.hasChildRecords)
                        if (proxy._currentRecord.expanded)
                            $tr.find(".e-treegridexpand").css({ "display": "inline-block" });
                        else
                            $tr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                }
                //To get the dropPosition
                if (proxy._currentRecord.dragState == true && args.canDrop != false) {
                    if (isTopRowSegment && !isPrevRecord) {
                        args.dropPosition = "insertAbove";
                    }
                    else if (isMiddleRowSegment && proxy._childItem == false) {
                        args.dropPosition = "insertAsChild";
                    }
                    else if (isMiddleRowSegment && proxy._childItem == true) {
                        args.dropPosition = "invalidPosition";
                    }
                    else if (isBottomRowSegment && !isNextRecord) {
                        args.dropPosition = "insertBelow";
                    }
                    else {
                        args.dropPosition = "invalidPosition";
                    }
                }
                else {
                    args.dropPosition = "invalidPosition";
                }
                proxy._trigger("rowDrag", args);
                //To render the indicators according to its position.
                if (proxy._currentRecord.dragState == true && args.canDrop != false) {
                    if (isTopRowSegment && !isPrevRecord) {
                        $(proxy.element).find("." + classname).find(".e-aboveIcon").css({ "display": "block" });
                        proxy._insertAbove = true;
                    }
                    else if (isMiddleRowSegment && proxy._childItem == false) {
                        $(proxy.element).find("." + classname).find(".e-childIcon").css({ "display": "block" });
                        proxy._insertAsChild = true;
                    }
                    else if (isMiddleRowSegment && proxy._childItem == true) {
                        $(proxy.element).find("." + classname).find(".e-cancelIcon").css({ "display": "block" });
                        proxy.cancelDrop = true;
                    }
                    else if (isBottomRowSegment && !isNextRecord) {
                        $(proxy.element).find("." + classname).find(".e-belowIcon").css({ "display": "block" });
                        proxy._insertBelow = true;
                    }
                }
                else {
                    $(proxy.element).find("." + classname).find(".e-cancelIcon").css({ "display": "block" });
                    proxy.cancelDrop = true;
                }
            }

            $(proxy._dragmouseOverTooltip).css({
                "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                'position': 'absolute',
                'z-index': proxy.getMaxZIndex() + 1,
                'padding': '0',
                'border-right': '0',
                'border-bottom': '0',
                'border-radius': '3px',
                'height': "auto",
            });                            
        },

        //Used for check whether the dragged record is previous or next to current record based on position argument
        //If it is previous or next to current record, this method return true otherwise return false.
        _checkPrevNextRecord:function(record,index,level, position)
        {
            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                currentIndex = index;
            position == "next" ? index++ : index--;
            while(updatedRecords[index])
            {
                if (updatedRecords[index].level == level)
                {
                    if (updatedRecords[index] == record && record.parentItem == updatedRecords[currentIndex].parentItem)
                        return true;
                    return false;
                }
                position == "next" ? index++ : index--;
            }
            return false;
        },
        //Tooltip template for row drag and drop
        _createDragTooltipTemplate: function () {
            var proxy = this,
                td,               
                template = proxy.model.dragTooltip.tooltipTemplate,
                parentTr;
            if (template) {
                var templateString = template.charAt(0);
             
                if (templateString == "#")
                     parentTr = $(proxy.model.dragTooltip.tooltipTemplate)[0].innerHTML;
                else
                     parentTr = proxy.model.dragTooltip.tooltipTemplate;
            }            
            var templates = {};
            templates[proxy._id + "dragtooltipTemplate"] = parentTr;
            $.templates(templates);
        },       

        //render the cancel icon if drag over its child.
		_updateDragStateFalse: function (record, count) {
		    var currentRecord, proxy = this, length;
		    record.dragState = false;		   
		    if (record.hasChildRecords) {
		        length = record.childRecords.length;
		        for (var i = 0; i < length; i++) {
		            currentRecord = record.childRecords[i];
		            currentRecord.dragState = false;
		            if (currentRecord.hasChildRecords) {
		                count = proxy._updateDragStateFalse(currentRecord, count);
		            }
		        }
		    }
		    return;
		},

        //Turn all the records dragState to true once dragging finished.
		_updateDragStateTrue: function (record, count) {
		    var currentRecord, proxy = this, length;
		    if (!ej.isNullOrUndefined(record)) {
		        record.dragState = true;
		        if (record.hasChildRecords) {
		            length = record.childRecords.length;
		            for (var i = 0; i < length; i++) {
		                currentRecord = record.childRecords[i];
		                currentRecord.dragState = true;
		                if (currentRecord.hasChildRecords) {
		                    count = proxy._updateDragStateTrue(currentRecord, count);
		                }
		            }
		        }
		    }
		    return;
		},

		// Get XY coordinates for touch and non-touch device
		_getCoordinate: function (evt) {
		    var coor = evt;
		    if (evt.type == "touchmove" || evt.type == "touchstart" || evt.type == "touchend" || evt.type== "taphold" || evt.type == "tap")
		        coor = evt.originalEvent.changedTouches[0];
		    return coor;
		},

        // Get current target element by mouse position
        // window.pageXOffset && window.pageYOffset is used to find the accurate element position in IPad/IPhone
		_getElementByPosition: function (x, y) {
		    return $(document.elementFromPoint((x - window.pageXOffset), (y - window.pageYOffset)));
		},      

        //Mouse down action for to display a Drag tooltip   
		dragRecord: function (e) {
            /*verify ctlkey and shift key and mouse button*/
		    if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
		        return true;
		    
		    var proxy = this,
               model=proxy.model,
               recordIndex,
               args = {},               
               coord = proxy._getCoordinate(e),
               $target = $(e.target),
               $tr = $target.closest('tr'),
               record,
               tooltipbody,
		       updatedRecords = proxy.getUpdatedRecords();

		    window.clearTimeout(this._dragTooltipTimer);
		    this._dragTooltipTimer = null;

		    if (!proxy._mouseDown) {		       
		        return true;
		    }
                        
		    if (!$tr.hasClass("e-editedrow") && proxy.editFormValidate()) {
                if (model.selectionSettings.selectionMode == "cell")
                    proxy.clearSelection();
		       
		        proxy._clearColumnMenu();		        
		        proxy._removeDetailsRow();
		        proxy._saveCellHandler(e);
		        

		        proxy._posx = coord.pageX;
		        proxy._posy = coord.pageY;

		        if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle") || $target.closest("tr").hasClass("e-detailsrowexpanded"))
		            return;
		        if (!model.enableVirtualization)
		            proxy._currentIndex = proxy.getIndexByRow($tr);
		        else {
		            proxy._currentIndex = proxy.getIndexByRow($tr);
		            record = model.currentViewData[proxy._currentIndex];
		            proxy._currentIndex = updatedRecords.indexOf(record);
		        }
		        proxy._draggedIndex = recordIndex = proxy.getIndexByRow($tr);
		        proxy._draggedRecord = proxy.model.currentViewData[recordIndex];
		        args.draggedRowIndex = recordIndex;
		        args.draggedRow = proxy._draggedRecord;
		        proxy._trigger("rowDragStart", args);
		        if (args.draggedRow && args.draggedRow.isSummaryRow)
		            args.cancel = true;

		        proxy._gridPosition = proxy.getOffsetRect($("#" + proxy._id)[0]);

		        if (proxy._frozenColumnsLength > 0 && recordIndex != -1) {
		            var tempTr, index = $tr.index();
		            if ($tr.closest(".e-movablecontentdiv").length > 0)
		                tempTr = $(proxy._gridRows[0])[recordIndex];
		            else
		                tempTr = $(proxy._gridRows[1])[recordIndex];
		            $tr = $tr.add(tempTr);
		        }

		        var posx = proxy._gridPosition.left, posy = coord.pageY,
		         width = model.isFromGantt ? model.ganttElement.width() : proxy._gridWidth,
		         element = $tr.clone();
		        width = width - 50;//to render tooltip inside the control container element
		        //Remove the hided columns.
		        element.find(".e-hide").remove();
                var tooltipItemLength = model.dragTooltip.tooltipItems.length,
		        tooltiptable = ej.buildTag("table.e-zerospace", "", { 'padding': '1', "width": width - 1, "border-collapse": "collapse" });
		        //to render the tooltip according the option given in the model.
		        if (proxy.model.dragTooltip.showTooltip) {
		            if (proxy._dragTooltip == false) {
		                if (!proxy.model.dragTooltip.tooltipTemplate && proxy.model.dragTooltip.tooltipItems.length == 0) {

		                    tooltipbody = ej.buildTag("tbody", "", {}, {});
		                    element.find(".e-treegridexpand").css({ "display": "none" });
		                    element.find("td.e-unboundcell").css({ "display": "none" });
		                    element.find("td.e-detailsrowcell").css({ "display": "none" });
		                    element.find(".e-treegridcollapse").css({ "display": "none" });
		                    $(element.find(".e-dragintend")).css({ "width": 0 });
		                    element.find(".e-intend").removeClass("e-intend");
		                    element.find(".e-rowcell ").removeClass("e-rowcell ").addClass("e-dragrowcell");
		                    element.addClass("e-dragtooltipbackground");
		                    if (model.isFromGantt)
		                        element.find("td:last").remove();
		                    if (element.length == 2 && this._frozenColumnsLength > 0) {
		                        $(element[0]).append($(element[1].childNodes));
		                        element.splice(1, 1);
		                    }
		                    tooltipbody.append(element);
		                    tooltiptable.append(tooltipbody);
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", tooltiptable,
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'overflow': 'hidden',
                                    'z-index': proxy.getMaxZIndex() + 1,
                                    'padding': '0',
                                    'border-radius': '3px',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'width': width,
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    $(proxy._dragmouseOverTooltip).addClass("e-dragtooltipbackground").addClass("e-dragrowcell");		                    
		                    proxy._dragTooltip = true;
		                }
		                else if (tooltipItemLength != 0) {
		                    var columns = model.columns;
		                    tooltipbody = ej.buildTag("tbody", "", {}, {});
		                    var tooltiptr = ej.buildTag("tr.e-dragtooltipbackground", "", {}, {}),
		                        columnTooltipValue;
		                    for (var j = 0; j < tooltipItemLength; j++) {
		                        for (var i = 0; i < columns.length; i++) {
		                            //Skip the columns which is not visible in TreeGrid.
		                            if (columns[i].visible == false)
		                                continue;
		                            if (model.isFromGantt)
		                                columnTooltipValue = columns[i].mappingName
		                            else
		                                columnTooltipValue = columns[i].field;
		                            if (model.dragTooltip.tooltipItems[j] == columnTooltipValue) {
		                                var value = proxy._getCustomCellValue(proxy._draggedRecord, columns[i].field),
		                                    $td;
		                                if (columns[i].format)
		                                    value = proxy.formatting(columns[i].format, value, model.locale)
		                                if (!ej.isNullOrUndefined(value)) {
		                                    $td = ej.buildTag("td.e-dragrowcell", value.toString(), { "padding": "5px", "width": proxy.columnsWidthCollection[i], "height": model.rowHeight }, {});
		                                    tooltiptr.append($td);
		                                }
		                                tooltiptr.append($td);
		                                break;
		                            }
		                        }
		                    }
		                    tooltipbody.append(tooltiptr);
		                    tooltiptable.append(tooltipbody);
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", tooltiptable,
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': proxy.getMaxZIndex() + 1,
                                    'padding': '0',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'border-radius': '3px',
                                    'height': "auto",
                                    'width': width,
                                    'overflow': 'hidden'
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    $(proxy._dragmouseOverTooltip).addClass("e-dragtooltipbackground").addClass("e-dragrowcell");		                    
		                    proxy._dragTooltip = true;
		                }
		                else if (proxy.model.dragTooltip.tooltipTemplate) {
		                    proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltiptreegrid" + proxy._id + "", "",
                                {
                                    "top": (posy + 20) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': proxy.getMaxZIndex() + 1,
                                    'padding': '0',
                                    'border-right': '0',
                                    'border-bottom': '0',
                                    'border-radius': '3px',
                                    'height': "auto"
                                }, {});
		                    model.cssClass && $(proxy._dragmouseOverTooltip).addClass(model.cssClass);
		                    proxy.tooltipState = "TemplateID";
		                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "dragtooltipTemplate"](proxy._draggedRecord), {}, {});
		                    proxy._dragmouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
		                    proxy._dragTooltip = true;
		                }                                       
		            }
		        }
		        
		        if (proxy._draggedRecord) {		            
		            proxy._draggedElement = $tr;
		            proxy._updateDragStateFalse(proxy._draggedRecord);		                                
		            proxy._dragMouseDown = true;		            
                        //if(ej.isTouchDevice() || (ej.browserInfo().name == "chrome" && e.type == "touchstart"))
                        //    $(document.body).bind("touchmove", $.proxy(proxy.dragToolTip, proxy));
		            //else
		            if (e.type == "touchstart"){
		                $(document.body).append(proxy._dragmouseOverTooltip);
		                proxy._off(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
		                proxy._on(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            }		                
		            else{
		                proxy._off(proxy.element, "mousemove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
		                proxy._on(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            }		            
		        }

		        if (args.cancel) {
		            proxy._dragMouseDown = false;
		            proxy._updateDragStateTrue(proxy._draggedRecord);
		            proxy._dragTooltip = false;
		            proxy._dragmouseOverTooltip && proxy._dragmouseOverTooltip.remove();
		            proxy._dragmouseOverTooltip = null;
		            if (e.type == "touchstart")
		                proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		            else
		                proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
		        }
		    }
		},

        //Mouse move action for to move the drag tooltip
        dragToolTip: function (e) {
            var proxy = this,
                model = proxy.model,
                args = {},
                draggedrows = [],
                length,
                recordIndex, item,
                $trClone, $target, $tr,
                $tr_summary,
                coord = proxy._getCoordinate(e);
            e.preventDefault();
            
            var diffX = Math.abs(coord.pageX - proxy._posx),
                diffY = Math.abs(coord.pageY - proxy._posy);

            if (ej.isNullOrUndefined(proxy._posx) || ej.isNullOrUndefined(proxy._posy) || (diffX < 10 && diffY < 10))
                return;                        
            
            if (proxy._dragMouseDown == true && proxy.model.allowDragAndDrop == true) {

                if (e.type == "touchmove")
                    $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                else {
                    $target = $(e.target);
                    $(document.body).append(proxy._dragmouseOverTooltip);
                }

                $tr = $target.closest('tr');
                recordIndex = proxy.getIndexByRow($tr);
                
                var updatedRecords = proxy.getUpdatedRecords();

                if (recordIndex != -1) {
                    item = proxy.model.currentViewData[recordIndex];
                    $tr = ej.TreeGrid.getRowByIndex(proxy, proxy._currentIndex);
                    $trClone = $tr.clone();
                    //Remove the hided columns.
                    $trClone.find(".e-hide").remove();
                    proxy._dragTargetItem = item;
                    args.targetRowIndex = recordIndex;
                    args.targetRow = item;
                    args.canDrop = true;
                    args.draggedRow = proxy._draggedRecord;
                    args.draggedRowIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    proxy._renderToolTip(coord, $trClone, args, $target);                 
                    if (args.targetRow && args.targetRow.isSummaryRow) {
                        proxy._draggedRecord.canDrop = false;
                        $(".e-dragintend").find(".e-icon").css({ "display": "none" });
                        $(".e-intendparent").find(".e-icon").css({ "display": "none" });
                    }
                    else if (args.canDrop == false) {
                        proxy._draggedRecord.canDrop = false;
                    }
                    else {
                        proxy._draggedRecord.canDrop = true;
                    }
                } else if (proxy._draggedRecord && proxy._dragMouseDown) {
                    item = null;
                    $tr = ej.TreeGrid.getRowByIndex(proxy, proxy._currentIndex);
                    $trClone = $tr.clone();
                    $tr_summary = $target.closest('tr'),
                    args.targetRowIndex = null;
                    args.targetRow = null;
                    proxy._dragTargetItem = null;
                    args.canDrop = true;
                    args.draggedRow = proxy._draggedRecord;
                    args.draggedRowIndex = proxy._draggedRecord.index;
                    proxy._trigger("rowDrag", args);
                    if (!$tr_summary.hasClass("e-footersummaryrow"))
                        proxy._renderToolTip(coord, $trClone, args, $target);
                }
                proxy._mouseout(coord);
            }
        },

        _mouseupHandler: function(e){
            var proxy = this,
                model = proxy.model;
            
            if (e.type == "touchend")
                proxy._off(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);
            else
                proxy._off(proxy.element, "mousemove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);

            proxy._off($(document), "mouseup touchend", proxy._mouseupHandler);
            proxy._mouseDown = false;
            proxy._isTouchEvent = false;
            window.clearTimeout(proxy._dragTooltipTimer);
            if (model.allowDragAndDrop && proxy._dragMouseDown)
                proxy.dragMouseUp(e);

            if (model.contextMenuSettings.showContextMenu && proxy._contextMenuHandler && proxy._displayContextMenu) {
                proxy._rightClick(e);
            }
            else
                proxy._contextMenuHandler = false;
            proxy._displayContextMenu = true;
            proxy._dy = proxy._dx = 0;
        },
         
        //Mouse up event for drag and drop
        dragMouseUp: function (e) {
            var count = 0,
                args = {},
                arg = {},
                proxy = this,
                model = proxy.model, $target, $tr,
                draggedRecord = proxy._draggedRecord,
                currentRecord = proxy._currentRecord, droppedRecord,
                canDrop, length = model.selectedItems.length,
                dropPosition, coord = proxy._getCoordinate(e);

            proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
            proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
            
            // unbind the drag events once row dropped
            if (model.allowDragAndDrop) {
                if (e.type == "touchstart")
                    proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                else
                    proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);

                if (ej.isNullOrUndefined(draggedRecord))
                    canDrop = true;
                else
                    canDrop = draggedRecord.canDrop;
            }

            window.clearTimeout(proxy._dragTooltipTimer);
            proxy._dragMouseDown = false;
            $(proxy._dragmouseOverTooltip).remove();
            proxy._dragTooltip = false;

            if (e.type == "touchend")
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            else
                $target = $(e.target);

            $tr = $target.closest('tr');

            $(".e-dragintend").find(".e-icon").css({ "display": "none" });
            $(".e-intendparent").find(".e-icon").css({ "display": "none" });
            var targetItem = model.currentViewData[proxy.getIndexByRow($tr)];
            if (this.cancelDrop == true && !ej.isNullOrUndefined(targetItem) && targetItem.parentItem == null) {
                var targetTr = ej.TreeGrid.getRowByIndex(this, model.updatedRecords.indexOf(targetItem));
                if (targetItem.expanded)
                    targetTr.find(".e-treegridexpand").css({ "display": "inline-block" });
                else
                    targetTr.find(".e-treegridcollapse").css({ "display": "inline-block" });
            }
            proxy._dragMouseLeave = true;
            if ($target.closest("#" + proxy._id).length == 1 && !ej.isNullOrUndefined(draggedRecord) && proxy._dropCancel == false) {
                
                if (model.allowDragAndDrop && canDrop) {
                    proxy._dragMouseLeave = false;                    
                    var recordIndex = proxy.getIndexByRow($tr);
                    if (recordIndex != proxy._currentIndex && recordIndex != -1) {
                        proxy._droppedRecord = model.currentViewData[recordIndex];
                        droppedRecord = proxy._droppedRecord;
                        var flatRecords = model.flatRecords;
                        args.previousParentItem = draggedRecord.parentItem ? $.extend({}, draggedRecord.parentItem) : draggedRecord.parentItem;
                        if (!ej.isNullOrUndefined(draggedRecord.parentItem)) {
                            args.previousParentItem.childRecords = $.extend([], draggedRecord.parentItem.childRecords)
                            args.parentChildState = draggedRecord.parentItem.hasChildRecords;
                            args.parentExpandedState = draggedRecord.parentItem.expanded;
                        }
                        arg.targetRow = $.extend({}, proxy._droppedRecord);
                        arg.targetRow.item = $.extend({}, proxy._droppedRecord.item);
                        arg.targetRowIndex = model.updatedRecords.indexOf(droppedRecord);
                        arg.draggedRow = $.extend({}, proxy._draggedRecord);
                        arg.draggedRow.item = $.extend({}, proxy._draggedRecord.item);
                        arg.draggedRowIndex = model.updatedRecords.indexOf(draggedRecord);

                        args.previousItem = arg.draggedRow;
                        args.previousItemIndex = flatRecords.indexOf(proxy._draggedRecord);
                        args.previousTarget = proxy._droppedRecord;
                        args.previousTargetItemIndex = flatRecords.indexOf(proxy._droppedRecord);
                        args.clonedTarget = $.extend({}, proxy._droppedRecord);
                        args.hasChildRecords = droppedRecord.hasChildRecords;
                        args.expanded = droppedRecord.expanded;
                        args.childIndex = args.previousParentItem ? args.previousParentItem.childRecords.indexOf(draggedRecord) : 0;
                        args.previousLevel = draggedRecord.level;
                        var draggedrows = [];

                        if (droppedRecord.dragState == true) {
                            proxy._updateDragStateTrue(draggedRecord);

                            if (proxy._insertAbove == true || proxy._insertBelow == true || proxy._insertAsChild == true) {
                                if (!proxy.model.isEdit && !proxy._isRowEdit)
                                    proxy._cancelSaveTools();
                                for (var i = 0; i < length; i++)
                                    proxy.clearSelection(model.selectedItems[i]);

                                proxy._deleteDragRow();
                                var recordIndex1 = flatRecords.indexOf(droppedRecord);
                                // Update checkbox state of parent record of dragged record
                                if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection) {
                                    draggedRecord.parentItem && proxy._updateParentSelection(draggedRecord.parentItem);
                                }

                                //Condition to splice above to the dropped record.
                                if (proxy._insertAbove == true) {
                                    dropPosition = "insertAbove";
                                    args.index = recordIndex1;
                                    draggedRecord.parentItem = flatRecords[recordIndex1].parentItem;
                                    draggedRecord.level = flatRecords[recordIndex1].level;
                                    flatRecords.splice(recordIndex1, 0, draggedRecord);
                                    model.updatedRecords.splice(recordIndex1, 0, draggedRecord);
                                    if (model.isFromGantt)
                                        model.ids.splice(recordIndex1, 0, (draggedRecord.taskId).toString());
                                    if (draggedRecord.hasChildRecords) {
                                        var level = 1;
                                        proxy._updateChildRecord(draggedRecord, recordIndex1);
                                        proxy._updateChildRecordLevel(draggedRecord, level);
                                    }
                                    if (droppedRecord.parentItem)
                                        droppedRecord.parentItem.childRecords.splice(droppedRecord.parentItem.childRecords.indexOf(droppedRecord), 0, draggedRecord);
                                }

                                    //condition to splice below to the dropped record.
                                else if (proxy._insertBelow == true) {
                                    dropPosition = "insertBelow";
                                    args.index = recordIndex1 + 1;
                                    if (!droppedRecord.hasChildRecords) {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                    }
                                    else {
                                        count = proxy.getChildCount(droppedRecord, 0);
                                        flatRecords.splice(recordIndex1 + count + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + count + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + count + 1, 0, (draggedRecord.taskId).toString());
                                    }
                                    draggedRecord.parentItem = flatRecords[recordIndex1].parentItem;
                                    draggedRecord.level = flatRecords[recordIndex1].level;
                                    if (draggedRecord.hasChildRecords) {
                                        var level = 1;
                                        proxy._updateChildRecordLevel(draggedRecord, level);
                                        proxy._updateChildRecord(draggedRecord, recordIndex1 + count + 1);
                                    }
                                    if (droppedRecord.parentItem)
                                        droppedRecord.parentItem.childRecords.splice(droppedRecord.parentItem.childRecords.indexOf(droppedRecord) + 1, 0, draggedRecord);
                                }

                                    // Condition to insert as child to the dropped Record.
                                else if (proxy._insertAsChild == true) {
                                    dropPosition = "insertAsChild";
                                    args.index = recordIndex1 + 1;
                                    if (!draggedRecord.hasChildRecords) {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                        proxy._recordLevel(recordIndex);
                                    }
                                    else {
                                        flatRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        model.updatedRecords.splice(recordIndex1 + 1, 0, draggedRecord);
                                        if (model.isFromGantt)
                                            model.ids.splice(recordIndex1 + 1, 0, (draggedRecord.taskId).toString());
                                        proxy._recordLevel(recordIndex);
                                        if (droppedRecord.hasChildRecords)
                                            droppedRecord.expanded = proxy._isLoadonDemand ? droppedRecord.isChildRetrieved : droppedRecord.expanded;
                                        proxy._updateChildRecord(draggedRecord, recordIndex1 + 1, droppedRecord.expanded);
                                    }
                                }
                            }
                            //update checkbox state of parent record and header of dropped record
                            if (proxy._checkboxSelection && model.selectionSettings.enableHierarchySelection) {
                                draggedRecord.parentItem && proxy._updateParentSelection(draggedRecord.parentItem);
                                proxy.selectAllRows();
                            }
                            if (draggedRecord.parentItem == null) {
                                var newPIndex = model.parentRecords.indexOf(proxy._droppedRecord);
                                if (proxy._insertBelow == true)
                                    model.parentRecords.splice(newPIndex + 1, 0, draggedRecord);
                                else if (proxy._insertAbove == true)
                                    model.parentRecords.splice(newPIndex, 0, draggedRecord);
                            }
                            args.requestType = "dragAndDrop";
                            args.draggedRow = draggedRecord;
                            args.targetRow = droppedRecord;
                            args.droppedPosition = dropPosition;
                            proxy._updateDataSource();
                            /*update summary rows collection*/
                            if (model.showSummaryRow && proxy._insertAsChild == true)
                                proxy._createSummaryRow(args);
                            if (model.enableWBS) {
                                var ddSiblings;
                                if (draggedRecord.parentItem)
                                    ddSiblings = draggedRecord.parentItem.childRecords;
                                else {
                                    var flatData = model.flatRecords,
                                        Level0 = flatData.filter(function (item) {
                                            return item && item.level == 0;
                                        });
                                    ddSiblings = Level0;
                                }
                                var ddIndex = ddSiblings.indexOf(draggedRecord),
                                    selectedRecords = ddSiblings.slice(ddIndex, ddSiblings.length),
                                    parentVal = draggedRecord.parentItem ? draggedRecord.parentItem.WBS : null,
                                    lastVal = ddIndex + 1;
                                proxy.reCalculateWBS(selectedRecords, lastVal, parentVal);
                            }
                            proxy.processBindings(args);
                            arg.draggedRow = args.draggedRow;                                                            
                            arg.draggedRow.item = args.draggedRow.item;
                            arg.draggedRowIndex = model.updatedRecords.indexOf(draggedRecord);
                            arg.targetRowIndex = model.updatedRecords.indexOf(droppedRecord);
                            arg.requestType = dropPosition;
                            proxy._trigger("rowDragStop", arg);
                            if (model.enableAltRow && model.currentViewData.length > 0)
                                ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);
                            if (arg.cancel)
                                proxy._revertDragging(args);
                            
                            if (model.allowSelection) {
                                if (model.selectionSettings.selectionMode == "row")
                                    proxy._selectDraggedRow($tr);
                                if (model.selectionSettings.selectionMode == "cell")
                                    proxy.updateScrollBar(model.updatedRecords.indexOf(proxy._draggedRecord));
                            }
                        }
                        else
                            //If drag state false then drop will cancel so have change the drag state.
                            proxy._updateDragStateTrue(draggedRecord);
                    }
                    else {
                        // If drop record not found means condition failed and drag state should change
                        proxy._updateDragStateTrue(draggedRecord);
                        if (!proxy.model.isEdit && !proxy._isRowEdit)
                            proxy._cancelSaveTools();
                    }
                }
                else {
                    // if canDrop true then drop will cancelled and state should change
                    proxy._updateDragStateTrue(draggedRecord);
                    proxy._resetPrivateProperties();
                    return 0;
                }
            }
            else
                // if esc key pressed or user drops a record other the tree grid content then 
                //drop cancelled and have to change the drag state.
                proxy._updateDragStateTrue(draggedRecord);
            // to enable expand and collapse icon of top most record if user mouse up outside of the grid area. 
            if (!ej.isNullOrUndefined(proxy._currentRecord)) {
                if (proxy._currentRecord.parentItem == null) {
                    $tr = ej.TreeGrid.getRowByIndex(proxy, model.updatedRecords.indexOf(proxy._currentRecord));
                    if (proxy._currentRecord.expanded)
                        $tr.find(".e-treegridexpand").css({ "display": "inline-block" });
                    else
                        $tr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                }
            }
            //Update the summary row after perform the drag and drop action.
            if (model.showSummaryRow && args.requestType == "dragAndDrop" && proxy._insertAsChild != true)
                proxy._updateSummaryRow(args);

            proxy._dropCancel = false;
            proxy._resetPrivateProperties();
            if (!ej.isNullOrUndefined(draggedRecord) && !proxy.model.isEdit && !proxy._isRowEdit)
                proxy._cancelSaveTools();                        
        },

        // Mouse down action to start a Drag Column
        dragColumn: function (e) {
            
            var $target = $(e.target),
               proxy = this,
            coord = proxy._getCoordinate(e);

            proxy._posx = coord.pageX
            proxy._posy = coord.pageY;

            /*verify ctlkey and shift key and mouse button*/
            if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
                return true;

            var model = proxy.model,
               columns = model.columns,
               columnIndex,
               args = {};

            if ($target.css("cursor") == "col-resize") return; // Return if mousedown action on column resizer

            if ($target.closest(".e-headercelldiv") && !$target.hasClass("e-columnmenu-icon")) {
                var columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("data-ej-mappingname");
                if (ej.isNullOrUndefined(columnFieldName) && ej.isNullOrUndefined(this.getColumnByField(columnFieldName))) return;

                if (this.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                if ($target.hasClass("e-checkbox"))
                    return false;

                proxy._draggedColumn = this.getColumnByField(columnFieldName);
                columnIndex = columns.indexOf(proxy._draggedColumn);
                args.draggedColumnIndex = columnIndex;
                args.draggedColumn = proxy._draggedColumn;
                args.requestType = "columnDragStart";
                if (!ej.isNullOrUndefined(proxy._draggedColumn.headerTemplateID)) {
                    proxy._draggedColumnTemplate = $target.closest(".e-headertemplate");
                }
                else {
                    proxy._draggedColumnTemplate = null;
                }
                if (!ej.isNullOrUndefined(proxy._draggedColumn.nonColumn)) return;
                proxy._trigger("columnDragStart", args);
                if (args.cancel) return;
                if (model.selectionSettings.selectionMode == "cell")
                    proxy.clearSelection();
                proxy._headerDragStatus = "mousedown";                
                proxy._dragMouseDown = true;
                proxy._mouseDragged = false;
                var gridPos = proxy.getOffsetRect(proxy.element[0]);
                proxy._gridLeft = gridPos.left;
                proxy._touchstart = true;
                // Mousemove event bind for Drag a column                
                if (e.type != "touchstart") {
                    proxy._on(proxy.element, "mousemove", proxy.dragColumnToolTip);
                }
            }
        },

        //Mousemove action to dragging tooltip
        dragColumnToolTip: function (e) {
            var proxy = this,
                model = proxy.model,
                args = {},
                $target,
                columns = model.columns,
                columnIndex, item, column = {},
                coord = proxy._getCoordinate(e),
                posx = coord.pageX, posy = coord.pageY;
                        
            if (proxy._touchstart) {
                proxy._touchstart = false;
                return;
            }
            if (e.type == "touchmove") {
                e.preventDefault();
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            }
            else
                $target = $(e.target);

            if (proxy._headerDragStatus.length > 0 && model.allowColumnReordering == true) {

                if (model.selectionSettings.selectionMode == "cell" && proxy._headerDragStatus != "mousemove")
                    proxy.clearSelection();
                var $hcell = $target.closest(".e-headercell");
                var columnFieldName = $hcell.find(".e-headercelldiv").attr("data-ej-mappingname");

                if (!ej.isNullOrUndefined(columnFieldName) && !ej.isNullOrUndefined(this.getColumnByField(columnFieldName))) {

                    var targetColumn = this.getColumnByField(columnFieldName);
                    proxy._currentIndex = columns.indexOf(targetColumn);
                    args.targetColumnIndex = proxy._currentIndex;
                    args.draggedColumnIndex = columns.indexOf(proxy._draggedColumn);
                    args.draggedColumn = proxy._draggedColumn;
                    args.targetColumn = targetColumn;
                    args.requestType = "columnDrag";
                    args.canDrop = true;

                    proxy._trigger("columnDrag", args);
                    if (args.cancel) return;

                    column.pos = proxy.getOffsetRect($hcell[0]);
                    column.height = $($hcell).height();
                    column.width = $($hcell).outerWidth();
                    column.pos.top = proxy.getOffsetRect($hcell.closest(".e-gridheader")[0]).top;
                    column.pos.left = ((args.draggedColumnIndex > args.targetColumnIndex)) ? (column.pos.left - 2) : (column.pos.left + column.width - 2);
                    column.display = "block";
                    args.column = column;
                    args.direction = (args.draggedColumnIndex > args.targetColumnIndex) ? "left" : "right";
                    proxy._autoHscroll(posx, posy, args);

                    if ((args.draggedColumnIndex == args.targetColumnIndex) || !ej.isNullOrUndefined(args.targetColumn.nonColumn) ||
                        ((column.pos.left - 8) > (proxy._gridWidth + proxy._gridLeft))) {
                        column.display = "none";
                    }
                    if (proxy._headerDragStatus != "mousemove" && !proxy._dragTooltip) {

                        var height = proxy._gridHeight - 1;
                        if (proxy.model.toolbarSettings.showToolbar) {
                            height -= !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").outerHeight()) ? $("#" + proxy._id + "_toolbarItems").outerHeight() : 0;
                        }
                        height -= proxy.getScrollElement().ejScroller("isHScroll") ? 18 : 0;

                        var tooltipcolumn = ej.buildTag('div', proxy._draggedColumn.headerText, { "margin-top": "5px" });
                        if (!ej.isNullOrUndefined(proxy._draggedColumnTemplate) && !ej.isNullOrUndefined(proxy._draggedColumn) && !ej.isNullOrUndefined(proxy._draggedColumn.headerTemplateID))
                            tooltipcolumn[0].innerHTML = proxy._draggedColumnTemplate[0].innerHTML;
                        proxy._dragmouseOverTooltip = ej.buildTag("div.e-tooltipgantt#columnreordertooltip" + proxy._id + "", tooltipcolumn,
                            {
                                "top": posy + "px", "left": (posx - 57) + "px",
                                'position':'absolute',
                                'z-index': proxy.getMaxZIndex() + 1
                            }, {});
                        model.cssClass && proxy._dragmouseOverTooltip.addClass(model.cssClass);
                        proxy._reordervline = ej.buildTag("div.e-vline#reorderline" + proxy._id + "", {
                            "height": height,
                            "width": 0,
                            "border-width": 0,
                            "position": "absolute",
                            "top": column.pos.top + "px",
                            "left": column.pos.left + "px",
                            "border-left-width": "3px",
                            "border-style": "solid",
                            "display": column.display,
                        });
                        model.cssClass && proxy._reordervline.addClass(model.cssClass);
                        $(document.body).append(proxy._dragmouseOverTooltip);
                        $(document.body).append(proxy._reordervline);
                        $(proxy._dragmouseOverTooltip).addClass("e-headertooltip");
                        $(proxy._reordervline).addClass("e-headervline");
                        proxy._dragmouseOverTooltip["width"] = $(proxy._dragmouseOverTooltip).outerWidth();
                        proxy._reordervline["height"] = height;
                        proxy._dragTooltip = true;
                    }
                    else {
                        $(proxy._reordervline).css({
                            "height": proxy._reordervline["height"],
                            "width": 0,
                            "border-width": 0,
                            "position": "absolute",
                            "top": column.pos.top + "px",
                            "left": column.pos.left + "px",
                            "border-left-width": "3px",
                            "border-style": "solid",
                            "display": column.display,
                        });

                        $(proxy._dragmouseOverTooltip).css({
                            'top': posy + "px",
                            'left': posx - (proxy._dragmouseOverTooltip["width"] / 2) + "px",
                        });
                    }
                    proxy._headerDragStatus = "mousemove";                    
                }
                else {
                    if (!ej.isNullOrUndefined(proxy._dragmouseOverTooltip)) {
                        $(proxy._dragmouseOverTooltip).css({
                            'top': posy + "px",
                            'left': posx - (proxy._dragmouseOverTooltip["width"] / 2) + "px",
                        });
                    }
                }
            }
        },      

        //Public method to reorder the Column position.
        reorderColumn: function (fieldName, targetColumnIndex) {
            var proxy = this, model = proxy.model,
                columns = model.columns, draggedColumn, 
                draggedColumnIndex, targetColumn, width, treeColumn,
                frozenWidth;

            treeColumn = columns[model.treeColumnIndex];
            draggedColumn = proxy.getColumnByField(fieldName);
            draggedColumnIndex = columns.indexOf(draggedColumn);
            width = proxy.columnsWidthCollection[draggedColumnIndex];
            
            targetColumn = columns[targetColumnIndex];
            if (targetColumn && targetColumn.nonColumn) return;
           
            if (proxy._frozenColumnsLength > 0) {

                frozenWidth = this._getFrozenColumnWidth();
                // Drag from non-freeze column and drop on frozen column
                if (proxy._frozenColumnsLength <= draggedColumnIndex && proxy._frozenColumnsLength > targetColumnIndex && proxy._frozenColumns.indexOf(draggedColumn) == -1) {                    
                    frozenWidth = frozenWidth + (this.columnsWidthCollection[draggedColumnIndex] + 18);
                    if (frozenWidth > this._gridWidth)
                        return false;
                    draggedColumn['isFrozen'] = true;
                    proxy._frozenColumns.splice(targetColumnIndex, 0, draggedColumn);
                }
                    // Drag from frozen column and drop on non-freeze column
                else if (proxy._frozenColumnsLength > draggedColumnIndex && proxy._frozenColumnsLength <= targetColumnIndex && proxy._frozenColumns.indexOf(draggedColumn) != -1) {                   
                    draggedColumn['isFrozen'] = false;
                    proxy._frozenColumns.splice(draggedColumnIndex, 1);
                    if (proxy._checkboxSelection && proxy._frozenColumns.length == 1 && proxy._frozenColumns[0]['nonColumn']) {
                        proxy._frozenColumns[0]['isFrozen'] = false;
                        proxy._frozenColumns.splice(0, 1);
                    }

                }
            }

            columns.splice(draggedColumnIndex, 1);
            proxy.columnsWidthCollection.splice(draggedColumnIndex, 1);
            columns.splice(targetColumnIndex, 0, draggedColumn);
            proxy.columnsWidthCollection.splice(targetColumnIndex, 0, width);
            
            model.treeColumnIndex = columns.indexOf(treeColumn);
            proxy._refreshFrozenColumns();
            proxy._updateWrapRowHeights(null,"virtualRefresh");
        },

        //Horizontal auto scroll while drag towards the end
        _autoHscroll: function (posx, posy, args) {
            var proxy = this,
                model = proxy.model,
                maxWidth,
                isHscroll,
                columns = model.columns,
                frozenWidth = 0,
                columnsWidth = proxy.columnsWidthCollection,
            gridContent = proxy.getScrollElement();

            isHscroll = gridContent.ejScroller("isHScroll");

            maxWidth = isHscroll ? gridContent.find(".e-content").get(0).scrollWidth : 0;
            proxy._viewPortWidth = gridContent.find(".e-content").width();

            if (proxy._frozenColumnsLength > 0) {
                frozenWidth = this._getFrozenColumnWidth();
            }
            var rightScrollPos = Math.round(((proxy._gridLeft + proxy._gridWidth) * 10)/ 100) + 18,
                leftScrollPos = Math.round((proxy._gridLeft * 10) / 100) + 18,
                topvalue = 0;

            if (((proxy._gridLeft + proxy._gridWidth) - rightScrollPos) < posx) {
                if (!proxy._timerDragDown) {

                    //Timer started for scrolling the content till the end.
                    proxy._timerDragDown = window.setInterval(function () {
                        if (maxWidth > (proxy._scrollLeft + proxy._viewPortWidth)) {
                            topvalue = proxy._scrollLeft;
                            topvalue = topvalue + 50;
                            proxy.getScrollElement().ejScroller("scrollX", topvalue, true);
                        }
                    }, 300);
                }
            }
            else {
                proxy._timerDragDown && (proxy._timerDragDown = window.clearInterval(proxy._timerDragDown));
            }            

            if ((posx < (proxy._gridLeft + frozenWidth + leftScrollPos)) && ( posx > (proxy._gridLeft + frozenWidth)) && proxy._scrollLeft != 0) {
                if (proxy._scrollLeft > 0) {
                    if (!proxy._timerDragUp) {
                        proxy._timerDragUp = window.setInterval(function () {
                            if (proxy._scrollLeft > 0) {
                                topvalue = proxy._scrollLeft;
                                topvalue = topvalue - 50;
                                if (topvalue < 0)
                                    topvalue = 0;
                                proxy.getScrollElement().ejScroller("scrollX", topvalue, true);
                            }
                        }, 300);
                    }
                }
                else {
                    proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
                }
            }
            else {
                proxy._timerDragUp && (proxy._timerDragUp = window.clearInterval(proxy._timerDragUp));
            }
        },

        _resetPrivateProperties: function () {
            this._timerDragDown && (this._timerDragDown = window.clearInterval(this._timerDragDown));
            this._timerDragUp && (this._timerDragUp = window.clearInterval(this._timerDragUp));
            var proxy = this, model = proxy.model;
            proxy.cancelDrop = false;
            proxy._draggedRecord = null;            
            proxy._dragMouseDown = false;
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            proxy._childItem = false;
            proxy._dragMouseLeave = false;
            proxy._currentRecord = null;
            proxy._currentIndex = null;
            proxy._droppedRecord = null;
            proxy._insertAsChild = false;
            proxy._insertAbove = false;
            proxy._insertBelow = false;
            if (model.allowDragAndDrop && model.enableVirtualization && (ej.browserInfo().name == "chrome" || ej.isTouchDevice())) {
                proxy._dummyElement && $(proxy._draggedElement).remove();
                proxy._dummyElement = false;
                proxy._draggedElement = null;
            }          
            proxy._dragTooltipTimer = null;
            proxy._dragColumnTooltipTimer = null;
            proxy._dragmouseOverTooltip = null;
        },
        // To select the dragged Record after drag stopped.
        _selectDraggedRow: function ($tr) {
            var proxy = this, model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                rowIndex = updatedRecords.indexOf(proxy._draggedRecord);
            if (rowIndex != -1) {
                proxy._focusTreeGridElement();
                if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex))) {
                    proxy.selectRows(rowIndex);
                    proxy._rowSelectedEventTrigger(rowIndex);
                }
            }
        },
        //Add child records to the data source
        _addChildItem: function (record) {
            var currentRecord, proxy = this, length=0;
            length = record.childRecords.length;
            for (var i = 0; i < length; i++) {
                currentRecord = record.childRecords[i];
                if (proxy.dataSource() instanceof ej.DataManager) {
                    if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                        proxy.dataSource().dataSource.json.push(currentRecord.item);
                        if (currentRecord.hasChildRecords) {
                            proxy._addChildItem(currentRecord);
                        }
                    }
                } else {
                    proxy.dataSource().push(currentRecord.item);                     
                    if (currentRecord.hasChildRecords) {
                        proxy._addChildItem(currentRecord);
                    }
                }
            }
        },
        //Update the changes in DataSource.
        _updateDataSource: function () {
            var proxy = this,
                model = proxy.model,
                draggedRecord = proxy._draggedRecord,
                droppedRecord = proxy._droppedRecord,
                tempDataSource, idx, childIndex;
            if (proxy.dataSource() instanceof ej.DataManager) {
                if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                    tempDataSource = proxy.dataSource().dataSource.json;
                }
            }
            else 
                tempDataSource = proxy.dataSource();
            
            if (tempDataSource && !droppedRecord.parentItem) {
                idx = tempDataSource.indexOf(droppedRecord.item);
                if (proxy._insertAbove) {
                    if (!model.parentIdMapping)
                        tempDataSource.splice(idx, 0, draggedRecord.item);
                }
                else if (proxy._insertBelow) {
                    if (!model.parentIdMapping)
                        tempDataSource.splice(idx + 1, 0, draggedRecord.item);
                }
            }
            else if (!model.parentIdMapping && droppedRecord.parentItem) {
                childIndex = droppedRecord.parentItem.childRecords.indexOf(draggedRecord);
                if (proxy._insertAbove) 
                    droppedRecord.parentItem.item[proxy.model.childMapping].splice(childIndex, 0, draggedRecord.item);
                else if (proxy._insertBelow)
                    droppedRecord.parentItem.item[proxy.model.childMapping].splice(childIndex, 0, draggedRecord.item);
            }

            if (model.parentIdMapping) {
                if (draggedRecord.parentItem) {
                    if (proxy._insertAbove || proxy._insertBelow) {
                        if (model.isFromGantt == true) {
                            draggedRecord.item[model.parentIdMapping] = droppedRecord.item[proxy.model.parentIdMapping];
                        }
                        else {
                            draggedRecord[model.parentIdMapping] = droppedRecord[proxy.model.parentIdMapping];
                            draggedRecord.item[model.parentIdMapping] = droppedRecord[proxy.model.parentIdMapping];
                        }
                    }
                    else {
                        if (model.isFromGantt == true) {
                            draggedRecord.item[model.parentIdMapping] = droppedRecord.item[proxy.model.idMapping];
                        }
                        else {
                            draggedRecord[model.parentIdMapping] = droppedRecord[proxy.model.idMapping];
                            draggedRecord.item[model.parentIdMapping] = droppedRecord[proxy.model.idMapping];
                        }
                    }
                }
                else {
                    draggedRecord.item[model.parentIdMapping] = null;
                    draggedRecord[model.parentIdMapping] = null;
                }

                if (proxy.dataSource() instanceof ej.DataManager) {
                    if (proxy.dataSource().dataSource.offline && proxy.dataSource().dataSource.json) {
                        proxy.dataSource().dataSource.json.push(draggedRecord.item);
                    }
                } else {

                    if (proxy._insertAbove || proxy._insertBelow || proxy._insertAsChild)
                        proxy.dataSource().push(draggedRecord.item);
                    if (draggedRecord.hasChildRecords) {
                        proxy._addChildItem(draggedRecord);
                    }
                }

            }
        },

        //This method is to delete the dragged record 
        _deleteDragRow: function ($tr) {
            var proxy = this,
                model = proxy.model,
                 deletedRowIndex,
                 deletedRow,
                 dataRows,
                 isUpdateWBS,
                 targetRowIndex,
                 args = {},
                 updatedRecords = proxy.getUpdatedRecords();
            deletedRowIndex = updatedRecords.indexOf(proxy._draggedRecord);
            deletedRow = updatedRecords[deletedRowIndex];
            args.tr = $tr;
            args.data = deletedRow;
            args.requestType = ej.TreeGrid.Actions.Delete;
            args.isDragAndDropDelete = true;
            if (proxy._trigger("actionBegin", args)) {
                return true;
            }
            if (proxy.model.enableWBS) {
                dataRows, targetRowIndex, isUpdateWBS = false;
                if (deletedRow && deletedRow.parentItem) {
                    dataRows = deletedRow.parentItem.childRecords;
                    targetRowIndex = dataRows.indexOf(deletedRow);
                } else if (model.flatRecords.length) {
                    var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                    dataRows = Level0;
                    targetRowIndex = dataRows.indexOf(deletedRow);
                }
                if (targetRowIndex != dataRows.length - 1)
                    isUpdateWBS = true;
            }
            proxy._removeRecords(args);           
            if (isUpdateWBS) {
                var targetRow;
                if (deletedRow.parentItem)
                    targetRow = dataRows[targetRowIndex];//Here we are having the updated 'dataRows'
                else {
                    //for level 0 records
                    dataRows.splice(targetRowIndex, 1);
                    targetRow = dataRows[targetRowIndex];
                }
                proxy.updateWBSdetails(targetRow);
            }
            if (!proxy._checkboxSelection)
                model.selectedItems = [];
            proxy._previousIndex = -1;
        },
        // To revert the changes if drop get cancelled.
        _revertDragging: function (args) {
            var proxy = this,
                model=proxy.model,
                flatRecords = model.flatRecords;
            proxy._draggedRecord = args.draggedRow;
            proxy._deleteDragRow();
            if (!proxy._draggedRecord.hasChildRecords) {
                flatRecords.splice(args.previousItemIndex, 0, proxy._draggedRecord);
                flatRecords[args.previousItemIndex].parentItem = args.previousItem.parentItem;
                if (!ej.isNullOrUndefined(args.previousParentItem)) {
                    flatRecords[args.previousItemIndex].parentItem.childRecords.splice(args.childIndex, 0, proxy._draggedRecord);
                    flatRecords[args.previousItemIndex].parentItem.hasChildRecords = true;
                    flatRecords[args.previousItemIndex].parentItem.hasFilteredChildRecords = true;
                    flatRecords[args.previousItemIndex].parentItem.expanded = true;
                }
                flatRecords[args.previousItemIndex].level = args.previousLevel;
            }
            else {
                flatRecords.splice(args.previousItemIndex, 0, proxy._draggedRecord);
                if (!ej.isNullOrUndefined(flatRecords[args.previousItemIndex].parentItem)) {
                    flatRecords[args.previousItemIndex].parentItem = args.previousParentItem;
                    if (!ej.isNullOrUndefined(args.previousParentItem))
                        flatRecords[args.previousItemIndex].parentItem.childRecords.splice(args.childIndex, 0, proxy._draggedRecord);
                }
                var recordIndex = model.flatRecords.indexOf(proxy._draggedRecord);
                proxy._updateChildRecord(proxy._draggedRecord,recordIndex, args.previousItem.index);
                proxy._draggedRecord.level = args.previousLevel;
                proxy._updateChildRecordLevel(proxy._draggedRecord, args.previousLevel);
            }
            if (model.parentIdMapping) {
                flatRecords[args.previousItemIndex][model.parentIdMapping] = args.previousItem[model.parentIdMapping];
                flatRecords[args.previousItemIndex].item[model.parentIdMapping] = args.previousItem[model.parentIdMapping];
            }
            if (!ej.isNullOrUndefined(args.previousItem.parentItem)) {
                args.previousItem.parentItem.hasChildRecords = args.parentChildState;
                args.previousItem.parentItem.expanded = args.parentExpandedState;
                if (model.childMapping && args.previousItem.parentItem.item[proxy.model.childMapping])
                    args.previousItem.parentItem.item[proxy.model.childMapping].splice(args.childIndex, 0, args.previousItem.item);
            }
            if (model.isFromGantt) {
                flatRecords[args.previousTargetItemIndex] = args.previousTarget;
                if (args.previousTarget.isAutoSchedule == true) {
                    args.previousTarget.startDate = args.previousTarget.item[args.model.startDateMapping] = new Date(args.clonedTarget.startDate);
                    args.previousTarget.endDate = new Date(args.clonedTarget.endDate);
                    args.previousTarget.duration = args.clonedTarget.duration;
                    args.previousTarget.status = args.clonedTarget.status;
                    if (args.model.endDateMapping) {
                        args.previousTarget.item[args.model.endDateMapping] = new Date(args.clonedTarget.endDate);
                    }
                    if (args.model.progressMapping) {
                        args.previousTarget.item[args.model.progressMapping] = args.clonedTarget.status;
                    }
                    if (args.model.durationMapping) {
                        args.previousTarget.item[args.model.durationMapping] = args.clonedTarget.duration;
                    }
                    args.previousTarget.expanded = args.clonedTarget.expanded;
                    var ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
                    ganttObject._updateTargetGanttRecord(args.previousTarget);
                }
                else {
                    args.previousTarget.manualStartDate = new Date(args.clonedTarget.manualStartDate);
                    args.previousTarget.manualEndDate = new Date(args.clonedTarget.manualEndDate);
                    args.previousTarget.manualDuration = args.clonedTarget.manualDuration;
                    args.previousTarget.status = args.clonedTarget.status;
                    if (args.model.progressMapping) {
                        args.previousTarget.item[args.model.progressMapping] = args.clonedTarget.status;
                    }
                    args.previousTarget.expanded = args.clonedTarget.expanded;
                    var ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
                    ganttObject._updateGanttRecord(args.previousTarget);
                }
            }
            if (model.enableWBS) {
                var ddSiblings,
                    draggedRecord = proxy._draggedRecord;
                if (draggedRecord.parentItem)
                    ddSiblings = draggedRecord.parentItem.childRecords;
                else {
                    var flatData = model.flatRecords,
                        Level0 = flatData.filter(function (item) {
                            return item && item.level == 0;
                        });
                    ddSiblings = Level0;
                }
                var ddIndex = ddSiblings.indexOf(draggedRecord),
                    selectedRecords = ddSiblings.slice(ddIndex, ddSiblings.length),
                    parentVal = draggedRecord.parentItem ? draggedRecord.parentItem.WBS : null,
                    lastVal = ddIndex + 1;
                proxy.reCalculateWBS(selectedRecords, lastVal, parentVal);
            }
            proxy.processBindings(args);
            if (model.currentViewData.length > 0)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
        },

        //To splice the child records if user drag and dropped the parent item.
        _updateChildRecord: function (record, count,expandState){
            var currentRecord,
                proxy = this,
                model = proxy.model,
                length;
            if (!record.hasChildRecords)
                return 0;
            length = record.childRecords.length;
            for (var i = 0; i < length; i++) {
                currentRecord = record.childRecords[i];
                count++;
                model.flatRecords.splice(count, 0, currentRecord);
                model.updatedRecords.splice(count, 0, currentRecord);
                if (model.isFromGantt)
                    model.ids.splice(count, 0, (currentRecord.taskId).toString());
                if (currentRecord.hasChildRecords) {
                    count = proxy._updateChildRecord(currentRecord, count);
                }
            }
            return count;
        },
        //This method is to leveling the records when it is inserted as child.
        _recordLevel: function (recordIndex) {
            var j = 0, proxy = this,
                model = proxy.model,
                draggedRecord=proxy._draggedRecord,
                droppedRecord = proxy._droppedRecord,
                childItem = proxy.model.childMapping;
            if (!droppedRecord.hasChildRecords) {
                droppedRecord.hasChildRecords = true;
                droppedRecord.hasFilteredChildRecords = true;
                if (proxy._isLoadonDemand)
                    droppedRecord.isChildRetrieved = true;
                if (ej.util.isNullOrUndefined(droppedRecord.childRecords) || $.isEmptyObject(droppedRecord.childRecords)) {
                    droppedRecord.childRecords = [];
                    if (!model.parentIdMapping)
                        droppedRecord.item[childItem] = [];
                }
            }
            if (proxy._insertAsChild) {
                draggedRecord.parentItem = droppedRecord;
                droppedRecord.childRecords.splice(0, 0, draggedRecord);
                if (!ej.isNullOrUndefined(draggedRecord) && !ej.isNullOrUndefined(droppedRecord.item[childItem]) && !model.parentIdMapping) {
                    droppedRecord.item[childItem].splice(0, 0, draggedRecord.item);
                }
                if (!draggedRecord.hasChildRecords)
                    draggedRecord.level = droppedRecord.level + 1;
                else {
                    var level = 1;
                    draggedRecord.level = droppedRecord.level + 1;
                    proxy._updateChildRecordLevel(draggedRecord, level);
                }
                droppedRecord.expanded = true;
                if (proxy._isLoadonDemand && !droppedRecord.isChildRetrieved)
                    droppedRecord.expanded = false;                
                proxy._parentRecords.push(droppedRecord);
            }
        },
        // This method is to level the parent record at the end of it hierarchy.
        _updateChildRecordLevel: function (record,level) {
            var proxy = this,
                length=0,
                currentRecord;
            level++;
            if (!record.hasChildRecords)
                return 0;
            length = record.childRecords.length;
            for (var i = 0; i < length ; i++) {
                currentRecord = record.childRecords[i];
                currentRecord.level = record.parentItem ? record.parentItem.level + level : record.level + 1;
                if (currentRecord.hasChildRecords) {
                    level--;
                    level = proxy._updateChildRecordLevel(currentRecord, level);
                }
            }
            return level;
        },
                   
        //To renter cancel icon in filtering elements.
        _filterBarClose: function (e) {
            var $target = $(e.target);
            if (e.type == "click" && $target.hasClass("e-cancel")) {
                var $targetText = $target.prev();
                    $targetText.focus().val("");
                $targetText.prop('checked', false);
                $targetText.trigger("keyup");
                e.stopPropagation();
            }
            if (e.type == "focusin") { 
                $target = $(e.target).next();
                this.getHeaderTable().find(".e-cancel").addClass("e-hide");
                $target.removeClass("e-hide");
            }
        },

        _checkIdenticalValue: function (val, currentFilterColumn) {
            var proxy = this,
                model = proxy.model,
                flag,
                filteredColumns = model.filterSettings.filteredColumns,
                columnLength = filteredColumns.length;
            for (var col = 0; col < columnLength; col++) {
                if (filteredColumns[col].value === val && filteredColumns[col].field == currentFilterColumn.field) {
                    flag = true;
                    break;
                }               
            }
            return flag;            
        },
        //To wireup method while user enter text to the filter textbox.
        _filterBarHandler: function (e) {
            var proxy = this,
                $target,
                model = proxy.model,filteringColumn;
            //cancel the edited cell and row
            if (proxy.model.isEdit)
                proxy.cancelEditCell();
            else if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            /* flag new added record is sorted or filttered in treegrid */
            proxy._isRefreshAddedRecord = false;

            /* clear selction*/
            proxy.clearAllSelection();

            if (e.target == undefined)
                $target =$(e);
            else
                $target = $(e.target);
            
            if (this.model.allowFiltering ) {
                var cols=proxy.model.columns;
                var matchcase;
                matchcase = proxy._cellEditingDetails;
                var key = proxy._queryManagar.queries[0], $element;
                //Get input element onEnter event
                if ($target.hasClass("e-ddl"))
                    $element = $target.find("input.e-field");
                else
                    $element = $target;
                proxy._fieldName = $element[0].id.replace(proxy._id + "_", "").replace("_filterbarcell", "");
                this._currentFilterColumn = ej.TreeGrid.getColumnByField(model.columns, proxy._fieldName);
                proxy._fieldName = this._currentFilterColumn.field;
                var currentFilterCol = this._currentFilterColumn, currentDateformat;
                if ($target.hasClass("e-checkbox"))
                    proxy._searchString = $target[0].checked;
                else if ($target.hasClass("e-ddl")) {
                    // To get the value from dropdown filter (onEnter) mode
                    $target = $target.find("input.e-dropdownlist");
                    var dropDownElement = $("#" + $target[0].id).data("ejDropDownList");
                    if (dropDownElement.selectedIndexValue == -1 || (proxy._checkIdenticalValue(dropDownElement._selectedValue, this._currentFilterColumn)))
                        return true;
                    proxy._searchString = dropDownElement._selectedValue;
                }
                else if ($target.hasClass("e-dropdownlist")) {
                    // To get the value from dropdown filter (immediate) mode
                    var dropdownobject = $("#" + $target[0].id).data("ejDropDownList");
                    if (dropdownobject.selectedIndexValue == -1 || (proxy._checkIdenticalValue(dropdownobject._selectedValue, this._currentFilterColumn)))
                        return true;
                    if (dropdownobject._selectedValue==proxy._dropDownListClearText)
                        proxy._searchString = "";
                    else
                        proxy._searchString = dropdownobject._selectedValue;
                }
                else
                    proxy._searchString = $target.closest("input").val();
                if ((this._currentFilterColumn.filterEditType == "datepicker" || this._currentFilterColumn.filterEditType == "datetimepicker") && proxy._searchString != "") {
                    if (proxy._searchString) {
                        if (currentFilterCol.format)
                            currentDateformat = proxy._getDateFormat(this._currentFilterColumn.format);
                        else
                            currentDateformat = proxy.model.dateFormat;
                        if (ej.isNullOrUndefined(ej.parseDate(proxy._searchString, currentDateformat, model.locale)))
                            proxy._searchString = "";
                        else
                            proxy._searchString = ej.parseDate(proxy._searchString, currentDateformat, model.locale);
                    }
                }
                if (proxy._searchString == "") {
                    filteringColumn = model.filterSettings.filteredColumns.filter(function (column) {
                        if (column.field === proxy._fieldName)
                            return true;
                    });
                    if (!filteringColumn.length) {
                        proxy._resizeFilteringElements();
                        return true;
                    }
                }
               
                proxy._validateFilterValue(proxy._searchString);
                proxy.filterColumn(proxy._fieldName, this._operator, proxy._searchString, this._predicate);                
                proxy._storePreviousFilteredValue(proxy._fieldName, proxy._searchString, this._operator);
                if (proxy.model.currentViewData.length > 0 && proxy.model.enableAltRow)
                    ej.TreeGrid.updateAltRow(proxy, proxy.model.currentViewData[0], 0, 0);                
            }
        },
        //Method to validate search string type and assign operators accordingly.
        _validateFilterValue: function (_value) {
            var proxy = this;
            this._predicate = "and";
            switch (this._currentFilterColumn.filterEditType) {
                case "numericedit":
                    this._operator = ej.FilterOperators.equal;
                    break;
                case "datepicker":
                    this._operator = ej.FilterOperators.equal;
                    
                    var _format;
                    if (this._currentFilterColumn.format == "" || this._currentFilterColumn.format == undefined)
                        _format = ej.preferredCulture().calendar.patterns.d; //System Date format
                    else
                        _format = this._currentFilterColumn.format.split(':')[1].replace('}', "");
                    if (this._currentFilterbarValue != "")
                        this._currentFilterbarValue = ej.format(_value, _format, this.model.locale);
                    break;
                case "datetimepicker":
                    this._operator = ej.FilterOperators.equal;
                  
                    var _format;
                    if (this._currentFilterColumn.format == "" || this._currentFilterColumn.format == undefined)
                        _format = ej.preferredCulture().calendar.patterns.f; //System DateTime format
                    else
                        _format = this._currentFilterColumn.format.split(':')[1].replace('}', "");
                    if (this._currentFilterbarValue != "")
                        this._currentFilterbarValue = ej.format(_value, _format, this.model.locale);
                    break;
                case "stringedit":
                    this._operator = ej.FilterOperators.startsWith;
                    break;
                case "dropdownedit":
                    var filterColumn = this._currentFilterColumn;
                    if (filterColumn.editType == "dropdownedit" && filterColumn.editParams && filterColumn.editParams.showCheckbox)
                        this._operator = ej.FilterOperators.contains;
                    else
                        this._operator = ej.FilterOperators.equal;
                    break;
                case "booleanedit":
                    if (proxy._searchString == true || proxy._searchString == "1")
                        proxy._searchString = true;
                    else if (proxy._searchString == "false" || proxy._searchString == "0")
                        proxy._searchString = false;
                    this._operator = ej.FilterOperators.equal;
                    break;
                default:
                    this._operator = ej.FilterOperators.equal;
            }
        },

        // Method to render header tooltip and header template tooltip.
        _headermouseHover: function (e) {
            e.preventDefault();
            var proxy = this,
                model = proxy.model;
            if (model.showGridCellTooltip) {
                if (!proxy._dragTooltip) {
                    var $target = $(e.target),
                        posx = 0,
                        posy = 0,
                        column = $target.closest('div.e-headercelldiv'),
                        tooltiptable, tooltipbody, textContent, tooltipWidth,
                        tooltipHeight, containerWidth, containerHeight,
                        currentColumn, columnFieldName;
                    proxy._headerMouseLeave();
                    if (!e) e = window.event;
                    if (e.originalEvent.pageX || e.originalEvent.pageY) {
                        posx = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;
                    }
                    else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        posx = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                    }
                    textContent = column.clone();
                    if (textContent.find(".e-ascending").length > 0) {
                        textContent.find(".e-ascending").remove();
                    } else if (textContent.find(".e-descending").length > 0) {
                        textContent.find(".e-descending").remove();
                    }
                    textContent.find(".e-chkbox-wrap").remove();
                    if ($target.closest(".e-headercell").hasClass("e-headertemplate")) {
                        textContent = textContent.clone();
                    } else {
                        textContent = textContent.find("span").clone();
                    }
                    tooltiptable = ej.buildTag("table.e-tooltiptable e-zerospace", "", { 'padding': '0' });
                    tooltipbody = ej.buildTag("tbody", textContent, {}, {});
                    tooltiptable.append(tooltipbody);
                    var isNonEmptyText = $(textContent).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                    if (tooltipbody) {
                        columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("data-ej-mappingname");
                        currentColumn = this.getColumnByField(columnFieldName);
                        if (currentColumn && (ej.isNullOrUndefined(currentColumn['headerTooltip']) || currentColumn['headerTooltip'] == "")) {
                            if (model.showGridCellTooltip && isNonEmptyText) {
                                var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5;
                                proxy._headerMouseOverTooltip = ej.buildTag("div.e-tooltipgantt#headertooltip" + proxy._id + "", tooltiptable,
                                    {
                                        "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                        'position': 'absolute',
                                        'z-index': proxy.getMaxZIndex() + 1,
                                        'padding': '0',
                                        'border-radius': '3px'
                                    }, {});
                                model.cssClass && (proxy._headerMouseOverTooltip.addClass(model.cssClass));
                                //Providing a time delay to render the tooltip to improve UI
                                proxy._headerTooltipTimer = setTimeout(function () {
                                    $(document.body).append(proxy._headerMouseOverTooltip);
                                    var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                        position = proxy.getOffsetRect(element[0]);
                                    containerWidth = $(element).width() + position.left;
                                    containerHeight = $(element).height() + position.top;
                                    tooltipWidth = $(proxy._headerMouseOverTooltip).width();
                                    tooltipHeight = $(proxy._headerMouseOverTooltip).height();
                                    // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                    if ((posx + tooltipWidth + 15) >= containerWidth) {
                                        posx = posx - tooltipWidth - 15;
                                    }
                                    if ((posy + tooltipHeight + 10) >= containerHeight) {
                                        posy = posy - tooltipHeight - 10;
                                    }
                                    $(proxy._headerMouseOverTooltip).css({ "top": posy, "left": posx });
                                }, 700);
                            }
                        } else if (currentColumn && !ej.isNullOrUndefined(currentColumn['headerTooltip']) && currentColumn['headerTooltip'] != "") {
                            var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5,
                                dataObj = {};
                            dataObj["column"] = currentColumn;
                            proxy._createColumnTooltipTemplate(currentColumn['headerTooltip']);
                            proxy._headerMouseOverTooltip = ej.buildTag("div.e-tooltipgantt#headertooltip" + proxy._id + "", "",
                                {
                                    "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                    'position': 'absolute',
                                    'z-index': proxy.getMaxZIndex() + 1,
                                    'padding': '0',
                                    'border-radius': '3px'
                                }, {});
                            model.cssClass && (proxy._headerMouseOverTooltip.addClass(model.cssClass));
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "columnTooltipTemplate"](dataObj), {}, {});
                            proxy._headerMouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                            var isNonEmptyText = $(tooltipbody).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                            if (isNonEmptyText){
                            proxy._headerTooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._headerMouseOverTooltip);
                                if (!model.isFromGantt) {
                                    var position = proxy.getOffsetRect(proxy.element[0]);
                                    containerWidth = $(proxy.element).width() + position.left;
                                    containerHeight = $(proxy.element).height() + position.top;
                                }
                                else {
                                    var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                        position = proxy.getOffsetRect(element[0]);
                                    containerWidth = $(element).width() + position.left;
                                    containerHeight = $(element).height() + position.top;
                                }
                                tooltipWidth = $(proxy._headerMouseOverTooltip).width();
                                tooltipHeight = $(proxy._headerMouseOverTooltip).height();
                                // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                if ((posx + tooltipWidth + 15) >= containerWidth) {
                                    posx = posx - tooltipWidth - 15;
                                }
                                if ((posy + tooltipHeight + 10) >= containerHeight) {
                                    posy = posy - tooltipHeight - 10;
                                }
                                $(proxy._headerMouseOverTooltip).css({ "top": posy, "left": posx });
                            }, 700);
                            }
                        }
                    }
                }
            }
        },
        
        _mouseHover: function (e) {            
            var proxy = this,
                model = proxy.model;
            if (model.showGridCellTooltip) {
                if (this._dragMouseDown != true) {
                    var $target = $(e.target),
                        posx = 0,
                        posy = 0,
                        $ganttGridRows = proxy.getRows(),
                        row = $target.closest('tr'),
                        column = $target.closest('td.e-rowcell'),
                        recordIndex = this.getIndexByRow(row),
                        item = model.currentViewData[recordIndex],
                        tooltiptable, tooltipbody, textContent, tooltipWidth,
                        tooltipHeight, containerWidth, containerHeight,
                        columns = model.columns,
                        currentColumn;

                    if (row.hasClass("e-footersummaryrow")) {
                        recordIndex = proxy._getFooterRows().index(row);
                        item = proxy._footerSummaryRecord[recordIndex];
                    }
                    
                    if (recordIndex >= 0 || row.hasClass("e-footersummaryrow")) {
                        var columnIndex = proxy.getCellIndex(e);
                        proxy._cellMouseLeave();

                        currentColumn = columns[columnIndex];
                        if (!e) e = window.event;
                        if (e.originalEvent.pageX || e.originalEvent.pageY) {
                            posx = e.originalEvent.pageX;
                            posy = e.originalEvent.pageY;
                        }
                        else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                            posx = e.originalEvent.clientX + document.body.scrollLeft
                                + document.documentElement.scrollLeft;
                            posy = e.originalEvent.clientY + document.body.scrollTop
                                + document.documentElement.scrollTop;
                        }

                        if (item || row.hasClass("e-footersummaryrow")) {
                            if (columnIndex != model.treeColumnIndex) {
                                var clonedCellElement = column.clone();
                                clonedCellElement.find(".e-chkbox-wrap").remove();
                                textContent = clonedCellElement.children().length ? clonedCellElement.children().clone() : clonedCellElement.clone(); // Copying the DOM element of particular cell.
                            }
                            else {
                                if (column.find(".e-cell").length > 0) {
                                    textContent = column.find(".e-cell").clone();
                                    textContent.find(".e-chkbox-wrap").remove();
                                }
                                else if (column.hasClass("e-summaryrowcell")) {
                                    if (column.find(".e-summarytitle").length > 0) {
                                        textContent = column.find(".e-summarytitle").clone();
                                    } else {
                                        textContent = column.clone();
                                        $(textContent).css({ "cssText": "padding-left: 0px;" });
                                    }
                                }
                            }
                            tooltiptable = ej.buildTag("table.e-tooltiptable e-zerospace", "", { 'padding': '0' });

                            if (!model.showGridExpandCellTooltip || (model.showGridExpandCellTooltip && columnIndex == proxy.model.treeColumnIndex)) {
                                tooltipbody = ej.buildTag("tbody", textContent, {}, {});
                            }
                            tooltiptable.append(tooltipbody);

                            var isNonEmptyText = $(textContent).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;

                            if (tooltipbody && $(column).find("#" + proxy._id + "EditForm").length == 0 && !proxy._isCommandColumn(currentColumn)) {
                                if ((!model.cellTooltipTemplate && (ej.isNullOrUndefined(currentColumn['tooltip']) || currentColumn['tooltip'] == "")) || (model.cellTooltipTemplate && !ej.isNullOrUndefined(currentColumn['tooltip']) && currentColumn['tooltip'] == "")) {
                                    if (!(model.showGridExpandCellTooltip) && isNonEmptyText
                                        || (model.showGridExpandCellTooltip && isNonEmptyText)) {
                                        var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5;
                                        proxy._mouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                                            {
                                                "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                                'position': 'absolute',
                                                'z-index': proxy.getMaxZIndex() + 1,
                                                'padding': '0',
                                                'border-radius': '3px'
                                            }, {});
                                        model.cssClass && (proxy._mouseOverTooltip.addClass(model.cssClass));
                                        //Providing a time delay to render the tooltip to improve UI
                                        proxy._tooltipTimer = setTimeout(function () {
                                            $(document.body).append(proxy._mouseOverTooltip);
                                            if (!model.isFromGantt) {
                                                var position = proxy.getOffsetRect(proxy.element[0]);
                                                containerWidth = $(proxy.element).width() + position.left;
                                                containerHeight = $(proxy.element).height() + position.top;
                                            }
                                            else {
                                                var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                                    position = proxy.getOffsetRect(element[0]);
                                                containerWidth = $(element).width() + position.left;
                                                containerHeight = $(element).height() + position.top;
                                            }
                                            tooltipWidth = $(proxy._mouseOverTooltip).width();
                                            tooltipHeight = $(proxy._mouseOverTooltip).height();
                                            // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                            if ((posx + tooltipWidth + 15) >= containerWidth) {
                                                posx = posx - tooltipWidth - 15;
                                            }

                                            if ((posy + tooltipHeight + 10) >= containerHeight) {
                                                posy = posy - tooltipHeight - 10;
                                            }
                                            $(proxy._mouseOverTooltip).css({ "top": posy, "left": posx });
                                        }, 700);
                                    }
                                }
                                else if (model.cellTooltipTemplate || (!ej.isNullOrUndefined(currentColumn['tooltip']) && currentColumn['tooltip'] != "")) {
                            var z_index = $("#" + this._id + "detailscellwrapper").length > 0 ? 110 : 5,
                                dataObj = {};
                            dataObj["record"] = item;
                            dataObj["column"] = columns[columnIndex];
                            if (!ej.isNullOrUndefined(currentColumn['tooltip']))
                                proxy._createColumnTooltipTemplate(currentColumn['tooltip']);
                                proxy._mouseOverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                                    {
                                        "top": (posy + 10) + "px", "left": (posx + 15) + "px",
                                        'position': 'absolute',
                                        'z-index': proxy.getMaxZIndex() + 1,
                                        'padding': '0',
                                        'border-radius': '3px'
                                    }, {});
                                model.cssClass && (proxy._mouseOverTooltip.addClass(model.cssClass));
                                proxy.tooltipState = "Template";
                                var tooltipbody;
                                if (!ej.isNullOrUndefined(currentColumn['tooltip']))
                                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "columnTooltipTemplate"](dataObj), {}, {});
                                    else
                                    tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](dataObj), {}, {});
                                proxy._mouseOverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                                var isNonEmptyText = $(tooltipbody).text().replace(/[ \t\r]+/g, "").length > 0 ? true : false;
                                if (isNonEmptyText){
                                proxy._tooltipTimer = setTimeout(function () {
                                    $(document.body).append(proxy._mouseOverTooltip);
                                    if (!model.isFromGantt) {
                                        var position = proxy.getOffsetRect(proxy.element[0]);
                                        containerWidth = $(proxy.element).width() + position.left;
                                        containerHeight = $(proxy.element).height() + position.top;
                                    }
                                    else {
                                        var element = $("#" + proxy._id.replace("ejTreeGrid", "")),
                                            position = proxy.getOffsetRect(element[0]);
                                        containerWidth = $(element).width() + position.left;
                                        containerHeight = $(element).height() + position.top;
                                    }
                                    tooltipWidth = $(proxy._mouseOverTooltip).width();
                                    tooltipHeight = $(proxy._mouseOverTooltip).height();
                                    // Calculation for reposition the tooltip when tooltip is exist the container height or width
                                    if ((posx + tooltipWidth + 15) >= containerWidth) {
                                        posx = posx - tooltipWidth - 15;
                                    }

                                    if ((posy + tooltipHeight + 10) >= containerHeight) {
                                        posy = posy - tooltipHeight - 10;
                                    }
                                    $(proxy._mouseOverTooltip).css({ "top": posy, "left": posx });
                                }, 700);
                                    }
                            }

                    }
                }
            }
        }

     }
 },
        _cellMouseLeave: function () {

            var proxy = this;
            if (proxy._mouseOverTooltip != null) {
                $("#tooltipgantt").remove();
                window.clearTimeout(proxy._tooltipTimer);
                $(proxy._mouseOverTooltip).remove();
            }
        },

        // Method to clear the header tooltip.
        _headerMouseLeave: function () {
            var proxy = this;
            if (proxy._headerMouseOverTooltip != null) {
                $("#headertooltip").remove();
                window.clearTimeout(proxy._headerTooltipTimer);
                $(proxy._headerMouseOverTooltip).remove();
            }
        },

        disableTooltip: function () {
            this._cellMouseLeave();
        },
       
        _createTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                helpers = {},
                template = proxy.model.cellTooltipTemplate,
                parentTr = null;
            helpers["_" + proxy._id + "getTaskName"] = proxy._tooltipTaskName;
            $.views.helpers(helpers);
            var templateString = "";
            if (template) {

                if (document.getElementById(template)) {
                    templateString = $("#" + template)[0].innerHTML;
                } else {
                    templateString = template;
                }
                 parentTr = templateString;
                
            }
            else {
                var parentTr = "<tr class='e-tooltip_rowcell'>";

                td = "{{if ~_" + proxy._id + "getTaskName()}}" +
                    "<td class='e-tooltiptaskname' style='height:auto;width:auto;font-weight:normal;'>{{:ttiptaskname}}</td>{{/if}}";

                parentTr += td;
                parentTr += "</tr>";
            }
            var templates = {};
            templates[proxy._id + "tooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        _tooltipTaskName: function () {
            return this.data.ttiptaskname;
        },

        // Method to create cell tooltip template.
        _createColumnTooltipTemplate: function (columnTemplate) {
            var proxy = this, parentTr = null, templateString = "";
            if (columnTemplate) {
                if (document.getElementById(columnTemplate)) {
                    templateString = $("#" + columnTemplate)[0].innerHTML;
                } else if (columnTemplate.slice(0, 1) === "#" && document.getElementById(columnTemplate.slice(1, columnTemplate.length))) {
                    templateString = $(columnTemplate)[0].innerHTML;
                } else {
                    templateString = columnTemplate;
                }
                parentTr = templateString;
            }
            var templates = {};
            templates[proxy._id + "columnTooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        getMaxZIndex: function () {
            var divs = document.getElementsByTagName('div'),
                highest = 0,
                divLength = divs.length;
            if (this._maxZIndex == 0) {
                for (var i = 0; i < divLength; i++) {
                    var zindex = divs[i].style.zIndex;
                    if (zindex > highest && zindex != "auto") {
                        highest = zindex;
                    }
                }
                this._maxZIndex = highest;
            }
            return this._maxZIndex;
        },

        //SCROLL EVENT FOR VIRTUALIZATION
        _onScroll: function (args) {

            var proxy = this,
                model = this.model,
                hScrollDist, vScrollDist;
            proxy._popupHide();
            proxy._clearContextMenu();                       
            
            $("#" + this._id + "detailscellwrapper").length > 0 && this._removeDetailsRow();

            if (proxy.model.showGridCellTooltip) {
                proxy._cellMouseLeave();
                proxy._headerMouseLeave();
            }

            if (!model.isFromGantt && proxy._dragTooltip && (!proxy._timerDragDown && !proxy._timerDragUp)) {
                args.cancel = true;
                return;
            }

            if (!proxy.isVScroll() && !proxy.model.isFromGantt && args.source === "wheel") {
                args.cancel = true;
                return;
            }                        

            if (args.scrollLeft != undefined) {
                proxy._scrollLeft = args.scrollLeft;
                hScrollDist = Math.abs(proxy._scrollLeft - proxy._prevScrollLeft);
            }

            if (args.scrollTop != undefined) {
                proxy._scrollTop = args.scrollTop; //Maintain the scroll top for dynamic update of virtualization and non-virtualization mode.
                vScrollDist = Math.abs(proxy._scrollTop - proxy._preVScrollTop);
            }            

            if (hScrollDist) {
                proxy._updateHeaderScrollLeft(proxy._scrollLeft);
                proxy._prevScrollLeft = proxy._scrollLeft;
            }
            
            if (args.scrollTop != undefined) {

                /*Cancel if treegrid is in edit*/
                if (proxy.model.isEdit) {
                    proxy.cancelEditCell();
                    proxy._focusTreeGridElement();
                }
                else if (proxy._isRowEdit) {
                    proxy.cancelRowEditCell();
                    proxy._focusTreeGridElement();
                }

                proxy._vScrollDist = Math.abs(proxy._scrollTop - proxy._prevScrollTop);
                proxy._preVScrollTop = proxy._scrollTop;
                //CHECK VIRTUALIZATION IS ENABLED OR NOT
                if (proxy.model.enableVirtualization) {

                    proxy._vScrollDir = proxy._prevScrollTop <= proxy._scrollTop ? 1 : -1;
                    //console.log("VScrollDist:" + proxy._vScrollDist);
                    if (model.allowPaging && !proxy.model.sizeSettings.height) {
                        return;
                    }else if (proxy._vScrollDist && (proxy._scrollTop != proxy._prevScrollTop)) {
                        proxy._updateCurrentViewData(ej.TreeGrid.Actions.Scroll);
                        proxy._prevScrollTop = proxy._scrollTop;
                    }
                }
                proxy._scrollTop = args.scrollTop;
                if(this._frozenColumnsLength)
                    proxy.getContent().find("#e-frozencontainer" + proxy._id).scrollTop(proxy._scrollTop);
            }
        },

        editFormValidate: function () {
            if ($.isFunction($.validator)) {
                if (this._frozenColumnsLength > 0) {
                    var forms = this.element.find(".e-treegridform");
                    if (forms.length > 1) {
                        var form1, form2;
                        form1 = forms.eq(0).validate().form();
                        form2 = forms.eq(1).validate().form();
                        if (!(form1 && form2))
                            return false;
                        else
                            return true;
                    }
                    else if (forms.length > 0)
                        return forms.validate().form();
                    else
                        return true;
                }
                else if ($("#" + this._id + "EditFormDialog").length > 0)
                    return $("#" + this._id + "EditFormDialog").validate().form();
                else if ($("#" + this._id + "EditForm").length > 0)
                    return $("#" + this._id + "EditForm").validate().form();
                else
                    return true;
            }
            return true;
        },
        
        //Save the edited row

        saveRow:function()
        {
            var proxy = this,
           model = proxy.model, form, index, isDialogEdit,editType;

            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                form = $("#" + proxy._id + "EditFormDialog");
                index = proxy._currentEditRecordDialogIndex;
                isDialogEdit = true;
            } else {
                form = $("#" + proxy._id + "EditForm");
                index = this.getIndexByRow(form.closest("tr"));
            }

            var frozenForm = $("#" + proxy._id + "EditFrozenForm"),
                formElement = frozenForm.add(form).find("td"),
                isAddRow = form.closest("tr").hasClass("e-addedrow"),
                columns = model.columns,
                columnLength = columns.length,
                currentItem =model.currentViewData[index],
                currentValue = {},
                previousValue = {},
                column,
                value,
                args = {};

           proxy._focusTreeGridElement();

            if (form.length <= 0 && index == -1)
                return;

            for (var i = 0; i < columnLength; i++) {
                column = columns[i];
                if (!ej.isNullOrUndefined(column) && column["field"] != "") {
                    if (column.visible) {
                        if (ej.isNullOrUndefined(column["editType"])) {
                            editType = "stringedit";
                        } else {
                            editType = column["editType"];
                        }
                        value = proxy.getCurrentEditCellDataForRowEdit(column["field"], editType, i);
                        if (proxy._checkboxSelection && column["field"] == "checkboxState") {                            
                            continue;
                        }
                        //To avoid duplicate ID for TreeGrid on self reference while row editing
                        if (model.idMapping && model.parentIdMapping && column["field"] == model.idMapping) {
                            if (proxy._validateIdValue(value))
                                value = currentItem[column["field"]]; //Replacing the old value
                        }
                        var splits = (column["field"] || "").split(".");
                        if (splits.length <= 1) {                            
                            previousValue[column["field"]] = currentItem.item[column["field"]];
                            currentValue[column["field"]] = currentItem[column["field"]] = currentItem.item[column["field"]] = value;
                        } else {

                        var prevalue = proxy._getCustomCellValue(currentItem.item, column["field"]);
                            previousValue = proxy._restoreCustomData(previousValue, prevalue, column["field"]);
                            currentValue = proxy._restoreCustomData(currentValue, value, column["field"]);
                            currentItem = proxy._restoreCustomData(currentItem, value, column["field"]);
                            currentItem.item = proxy._restoreCustomData(currentItem.item, value, column["field"]);
                        }
                    }
                    else {
                        var prevalue = proxy._getCustomCellValue(currentItem, column["field"]);
                        previousValue = proxy._restoreCustomData(previousValue, prevalue, column["field"]);
                        currentValue = proxy._restoreCustomData(currentValue, prevalue, column["field"]);
                    }
                }
            }

            if (!isAddRow) {
                args.previousValue = previousValue;
                args.requestType = "update";
                if (isDialogEdit) {
                    args.rowIndex = proxy._currentEditRecordDialogIndex;
                    args.element = $("#" + proxy._id + "_dialogEdit");
                }
                else {
                    args.rowIndex = proxy.selectedRowIndex();
                    args.rowElement = form.add(frozenForm).closest("tr");
                }
                args.currentValue = currentItem.item;
                if (isDialogEdit) {
                    if (proxy._trigger("actionBegin", args)) {
                        for (i = 0; i < columnLength; i++) {
                            column = columns[i];
                            if (!ej.isNullOrUndefined(column))
                                if (column.visible) {
                                    var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                    currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                    currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                                }
                        }
                        return true;
                    } else {
                        for (var colIndex = 0 ; colIndex < columns.length ; colIndex++) {
                            if (columns[colIndex]["editType"] == ej.TreeGrid.EditingType.Dropdown || columns[colIndex]["editType"] == ej.TreeGrid.EditingType.DatePicker || columns[colIndex]["editType"] == ej.TreeGrid.EditingType.DateTimePicker) {
                                var $element = $("#" + proxy._id + proxy._getFieldValue(columns[colIndex]["field"]));
                                $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                            }
                        }
                    }
                } else {
                    if (proxy._trigger("endEdit", args)) {
                        for (i = 0; i < columnLength; i++) {
                            column = columns[i];
                            if (!ej.isNullOrUndefined(column))
                                if (column.visible) {
                                    var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                    currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                    currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                                }
                        }
                    }
                    else {
                        if (model.idMapping && model.parentIdMapping) {
                            proxy._updateLastInsertedId(args.currentValue[model.idMapping]);
                        }
                    }
                }
            }
            else {
                args.rowIndex = proxy.selectedRowIndex();
                args.previousValue = previousValue;
                args.requestType = "addNewRow";
                args.addedRow = proxy._checkIsEmptyRow(currentItem.item) ? null : currentItem.item;
                args.rowElement = form.closest("tr");
                if (proxy._trigger("actionComplete", args)) {
                    for (i = 0; i < columnLength; i++) {
                        column = columns[i];
                        if (!ej.isNullOrUndefined(column))
                            if (column.visible) {
                                var prevalue = proxy._getCustomCellValue(previousValue, column["field"]);
                                currentItem = proxy._restoreCustomData(currentItem, prevalue, column["field"]);
                                currentItem.item = proxy._restoreCustomData(currentItem.item, prevalue, column["field"]);
                            }
                    }
                }
                else {
                    proxy._updateLastInsertedId(currentItem[model.idMapping]);                    
                }
            }

            /* delete the row if new added row is not have any values */
            if (proxy._checkIsEmptyRow(currentItem.item) && isAddRow) {
                var deleteValueUpdated = false;
                proxy._isEmptyRow = true;
                if (!model.editSettings.allowDeleting) {
                    deleteValueUpdated = true;
                    model.editSettings.allowDeleting = true;
                }
				// Only checked records delete by toolbar action, hence passing it as contextMenu deletion
                if (proxy._checkboxSelection)
                    proxy.deleteRow(null, true, null);
                else
                    proxy.deleteRow();
                proxy._isEmptyRow = false;
                proxy._isEmptyRowDeleted = true;
                if (deleteValueUpdated) {
                    model.editSettings.allowDeleting = false;
                }
            } else {
                // Save the edited row           
                ej.TreeGrid.refreshRow(proxy, index);
                if (isAddRow && currentItem.parentItem && currentItem.parentItem.childRecords.length == 1) {
                    ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(currentItem.parentItem));
                }
                if (model.showSummaryRow) {
                    args.editType = "rowedit";
                    if (args.requestType == "addNewRow" && model.editSettings.rowPosition == "child") {
                        proxy._createAndRenderSummaryRecords(args);
                    }
                    proxy._updateSummaryRow(args);
                }
                if (model.showTotalSummary) {
                    args.editType = "rowedit";
                    proxy._updateTotalSummaryRow(args);
                }
                if (isDialogEdit) {
                    //Client side event is triggerd for upadte the server side database
                    var eventArgs = {};
                    eventArgs.data = model.currentViewData[index];
                    eventArgs.item = model.currentViewData[index].item;
                    eventArgs.requestType = "recordUpdate";
                    proxy._trigger("actionComplete", eventArgs);
                    if (model.idMapping && model.parentIdMapping) {
                        proxy._updateLastInsertedId(eventArgs.item[model.idMapping]);
                    }
                }

            }
            proxy._isRowEdit = false;
            if (model.currentViewData.length > 0 && model.enableAltRow && !model.enableVirtualization)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
            proxy._cancelSaveTools();
            var colObject = columns.filter(function (column) {
                if (column.filterEditType == "dropdownedit" && column.editType != "dropdownedit")
                    return true;
            });
            if (model.allowFiltering && colObject.length)
                proxy._resizeFilteringElements();
            if (proxy._commandColumnLength > 0) {
                var tr = ej.TreeGrid.getRowByIndex(proxy, proxy.getUpdatedRecords().indexOf(model.currentViewData[index]))
                proxy._refreshUnboundTemplate(tr);
                if (args.requestType == "addNewRow" && model.editSettings.rowPosition == ej.TreeGrid.RowPosition.Child) {
                    var parentTr = ej.TreeGrid.getRowByIndex(proxy, proxy.getUpdatedRecords().indexOf(model.currentViewData[index].parentItem));
                    proxy._refreshUnboundTemplate(parentTr);
                }
            }
            if (model.allowTextWrap && proxy._$frozenTableContent.length > 0) {
                proxy._updateRowHeight(index);
                proxy._updateGridContentHeight();
                proxy.getScrollElement().ejScroller("refresh");
                var movableScrollTop = proxy.getScrollElement().ejScroller("model.scrollTop");
                proxy._getFrozenScrollElement().scrollTop(movableScrollTop);
                if (proxy.model.enableVirtualization) {
                    proxy.updateHeight();
                }
            } else if (model.allowTextWrap) {
                if (model.allowPaging && !model.sizeSettings.height) {
                    proxy.updateHeight();
                } else {
                    proxy.getScrollElement().ejScroller("refresh");
                }
            }
        },
        _excludeDetailRows : function()
        {
            var $gridRows = $(), model = this.model;
            if (this.getTreeGridRows() && this.getTreeGridRows().length > 0) {
                if (model.showDetailsRow && model.detailsTemplate) {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]).not(".e-detailsrow"), $(this.getTreeGridRows()[1]).not(".e-detailsrow")];
                    else
                        $gridRows = $(this.getTreeGridRows()).not(".e-detailsrow");
                }
                else {
                    if (this._frozenColumnsLength > 0)
                        $gridRows = [$(this.getTreeGridRows()[0]), $(this.getTreeGridRows()[1])];
                    else
                        $gridRows = $(this.getTreeGridRows());
                }
            }
            return $gridRows;
        },

        getIndexByRow: function ($tr) {
            var $gridRows = this._excludeDetailRows(), rowIndex = -1;
            if (this._frozenColumnsLength > 0) {
                rowIndex = $($gridRows[0]).index($tr);
                if (rowIndex == -1)
                    rowIndex = $($gridRows[1]).index($tr);
                return rowIndex;
            }
            return $gridRows.index($tr);
        },
        /*get all treegrid rows with details rows*/
        getTreeGridRows: function () {
            return this._gridRows;
        },

        _keyDown: function (e) {
            var proxy = this;
            if (e.shiftKey && proxy._shiftKeyFirstElementDetails.firstElementRowIndex == -1) {
                proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                proxy._shiftKeyFirstElementDetails.firstElementCellIndex = proxy._cellIndex;
            }
        },

        /*focus treegrid element*/
        _focusTreeGridElement: function () {
            if (ej.browserInfo().name == "msie") {
                try { this.element[0].setActive(); } catch (e) { }
            }
            else
                this.element[0].focus();
        },

        _onRecordClick: function (e) {
            var proxy = this,$target = $(e.target), model= proxy.model, column,
            $td = $target.closest("td"), args = {},$tr=$target.closest("tr");
            if (($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell"))
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) && $tr.find(".e-editedcell").length == 0 && !$tr.hasClass("e-summaryrow") && !$td.hasClass("e-unboundcell")) {
                args.cell = $td;
                args.cellIndex = proxy.getCellIndex(e);
                args.row = $tr;
                args.rowIndex = proxy.getIndexByRow(args.row);
                args.data = proxy.model.currentViewData[args.rowIndex];
                column = model.columns[args.cellIndex];
                args.columnName = column.headerText;
                args.cellValue = !ej.isNullOrUndefined(args.data) ? args.data[column.field] : "";
                args.targetElement = $target;
                proxy._trigger("recordClick", args);
            }
        },
        //add remove animation class for expand/collpase and header icons
        _addRemoveAnimateClass:function(element)
        {
            var proxy = this;
           this._$gridContentTable && this._$gridContentTable.find(".e-treegrid-animate").removeClass("e-treegrid-animate");
            proxy._$gridHeaderContainer && proxy._$gridHeaderContainer.find(".e-treegrid-animate").removeClass("e-treegrid-animate");
            $(element).addClass("e-treegrid-animate");
        },
        //CLICK HANDLER FOR PERFORM ROWSELECTION AND EXPANDCOLLAPSE THE RECORD
        _onClick: function (e) {

            var proxy = this,
                model = proxy.model,
                $target = $(e.target), currentRowIndex, args = {}, rowIndex = -1, expandRecord, id = $target.closest(".e-treegrid").attr("id"),
                updatedRecords = proxy.getUpdatedRecords();
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").attr("id") !== this._id) return false;
            proxy._clearContextMenu();
            this._removeDetailsRow(e);            
            if (model.allowDragAndDrop)
                window.clearTimeout(proxy._dragTooltipTimer);
            if (model.allowColumnReordering) {
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;
            }
            proxy._cellIndex = proxy.getCellIndex(e);
            this.getHeaderTable().find(".e-cancel").addClass("e-hide");
            if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                model.editSettings.editMode = "cellEditing";
            }
            rowIndex = proxy.getRowIndex(e);
            if ((model.editSettings.beginEditAction == "click" || $target.hasClass('e-treegridexpand')
                || $target.hasClass("e-treegridcollapse")) && $target.closest('.e-scrollbar').length==0 && this.editFormValidate()) {  //                                
                                if(model.editSettings.editMode.toLowerCase() == "cellediting")
                                    proxy._cellEditingDetails.rowIndex = rowIndex;
                                expandRecord = model.currentViewData && model.currentViewData[rowIndex];
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt && !($target.hasClass("e-downtail"))) {
                if ($target.hasClass("e-rowselect")) {
                    if (!$target.hasClass("e-spanclicked")) {
                        $target.addClass("e-spanclicked");
                    } else {
                        proxy._clearMultiSelectPopup();
                    }
                } else {
                    if (!$("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                        this._multiSelectPopup.hide();
                    }
                }
            }
            proxy._saveCellHandler(e);
            if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle"))
                return;
            if (($target.hasClass('e-treegridexpand') || $target.hasClass("e-treegridcollapse")) && rowIndex != -1) {
                var $tr = $target.closest('tr'),
                    recordIndex = updatedRecords.indexOf(expandRecord),
                    args = {},
                    isExpandCollapseEnabeled;
                $target.removeClass("e-treegrid-animate");
                args.data = record;
                args.data = expandRecord;
                args.recordIndex = recordIndex;
                args.expanded = $tr.hasClass("e-treegridrowexpand") ? false : true;
                //Set the focus to the element when row or column not in edit mode.
                if ($("#" + proxy._id + "EditForm").length == 0 && ($target.hasClass("e-rowcell") ||  !$target.closest(".e-rowcell").hasClass("e-templatecell"))) {
                   proxy._focusTreeGridElement();
                } else {
                    proxy._cancelEditState();
                }
                if (args.expanded) {

                    isExpandCollapseEnabeled = proxy._trigger("expanding", args);

                } else {

                    isExpandCollapseEnabeled = proxy._trigger("collapsing", args);
                    
                }

                if (!isExpandCollapseEnabeled&&!model.isFromGantt) {

                    /* refresh Added row on expand collapse */
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = args.expanded;
                        proxy.updateExpandStatus(args.data, args.expanded);
                        proxy.refreshContent();
                        proxy.renderRecords();
                        proxy._isRefreshAddedRecord = false;
                    } else {
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
                //To set animate class for clicked item
                if (model.allowPaging || model.enableVirtualization) {
                    var newUpdatedRecords = proxy.getUpdatedRecords(),
                        currentRowElement = ej.TreeGrid.getRowByIndex(this,newUpdatedRecords.indexOf(expandRecord));
                    currentRowElement && proxy._addRemoveAnimateClass($(currentRowElement).find(".e-treegridcollapse,.e-treegridexpand"));
                }else
                {
                    proxy._addRemoveAnimateClass($target);
                }
                
            } else if ($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell")) || $target.parent().hasClass("e-detailsrowcell") || $target.hasClass("e-detailsrowcell")
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) {

                if ($("#" + id + "_selectionpopup").is(":visible")) {
                    if ($("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                        e.ctrlKey = true;
                        if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row)
                        proxy._multiSelectCtrlRequest = true;
                    }
                    else {
                        e.ctrlKey = false; proxy._multiSelectCtrlRequest = false;
                    }
                }
                //Set the focus to the element when row or column not in edit mode.
                if ($("#" + proxy._id + "EditForm").length == 0 && ($target.hasClass("e-rowcell") || !$target.closest(".e-rowcell").hasClass("e-templatecell"))) {
                    proxy._focusTreeGridElement();
                }
                //Check selction is enabled or not
                
                    currentRowIndex = proxy.getIndexByRow($target.closest('tr'));
                    if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row) {

                        if (proxy._checkboxSelection && ($("#" + proxy._id + "EditForm").length == 0 || model.editSettings.beginEditAction == "click") && proxy.editFormValidate()) {
                            var record = proxy.model.currentViewData[currentRowIndex],
                        recordIndex = updatedRecords.indexOf(record), isCheckbox = false;
                            if (currentRowIndex != -1 && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)) {
                                if ($target.hasClass("e-checkbox"))
                                    isCheckbox = true;
                                proxy.selectRows(recordIndex, null, isCheckbox);
                                proxy._cancelSaveTools();
                                proxy._rowSelectedEventTrigger(recordIndex);
                            }
                        }
                if (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Multiple) {

                    if (e.ctrlKey) proxy._multiSelectCtrlRequest = true;

                    if (e.shiftKey) {
                        currentRowIndex = proxy.getIndexByRow($target.closest('tr'));
                                record = model.currentViewData[currentRowIndex];
                                currentRowIndex = updatedRecords.indexOf(record);
                        proxy._multiSelectShiftRequest = true;
                        if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)) {
                                    if (proxy.getRows() && proxy._prevSelectedItem != null) {
                                        if (proxy.getExpandStatus(proxy._prevSelectedItem))
                                            proxy.selectRows(updatedRecords.indexOf(proxy._prevSelectedItem), currentRowIndex);
                                        else
                                            proxy.selectRows(currentRowIndex);
                            }
                                    else if (proxy.getRows() && proxy._prevSelectedItem == null) {
                                        proxy.selectRows(0, currentRowIndex);
                            }
                            proxy._cancelSaveTools();
                            proxy._rowSelectedEventTrigger(currentRowIndex);
                        }
                    }
                }
                if (!proxy._checkboxSelection &&!proxy._multiSelectShiftRequest && $("#" + proxy._id + "EditForm").length == 0 ) {

                    //recordIndex = proxy.getIndexByRow($target.closest('tr'));

                    if (rowIndex != -1) {

                        record = model.currentViewData[rowIndex];
                        currentRowIndex = updatedRecords.indexOf(record);
                       
                        if (model.allowSelection &&!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), currentRowIndex)){
                            proxy.selectRows(currentRowIndex);                        
                            proxy._cancelSaveTools();
                            proxy._rowSelectedEventTrigger(currentRowIndex);  
                        }                      
                    }
                }
                proxy._multiSelectShiftRequest = false;
                    }
                    if (model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Cell && $("#" + proxy._id + "EditForm").length == 0 && proxy._cellIndex != -1 &&
                        currentRowIndex != -1 && model.allowSelection) {
                        var frozenColumnRowIndex = proxy._cellIndex >= proxy._frozenColumnsLength ? 1 : 0,
                            targetRow;
                        if (proxy._frozenColumnsLength > 0) {
                            targetRow = proxy.getRows()[frozenColumnRowIndex][currentRowIndex];
                        }
                        else
                            targetRow = proxy.getRows()[currentRowIndex];
                        var columns = model.columns,
                            record = model.currentViewData && model.currentViewData[currentRowIndex],
                            targetIndex = updatedRecords.indexOf(record),
                            targetCellIndex = proxy._cellIndex >= proxy._frozenColumnsLength ? proxy._cellIndex - proxy._frozenColumnsLength : proxy._cellIndex,
                            target = targetRow.childNodes[targetCellIndex],
                            previousRowIndex = proxy._previousSelectedCellDetails.rowIndex,
                            previousCellIndex = proxy._previousSelectedCellDetails.cellIndex,
                            targetCell = $(target).closest("td"),
                            currentCellIndex;
                        proxy._focusingRowIndex = targetIndex;

                        if (currentRowIndex != -1) {

                            if (record.isSummaryRow)
                                return;
                            var args = {
                                rowIndex: targetIndex,
                                cellIndex: proxy._cellIndex,
                                rowElement: targetRow,
                                cellElement: targetCell[0]
                            };
                            
                            var selectedCellInfo = {
                                rowIndex: targetIndex,
                                cellIndex: proxy._cellIndex,
                                cellElement: targetCell[0],                                
                                data: record
                            };

                            if (!proxy._cellSelectingEventTrigger(args) && columns[proxy._cellIndex].allowCellSelection) {
                                if (model.selectionSettings.selectionType == "multiple" && (e.ctrlKey || e.shiftKey)) {
                                    //Select Multiple cells dynamically using Ctrl Key + mouse click.
                                    if (e.ctrlKey) {
                                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                                            currentCellIndex = proxy._getCellIndex(proxy._selectedCellDetails, "cellElement").indexOf(targetCell[0]);
                                        else
                                            currentCellIndex = proxy._selectedCellDetails.map(function (e) { return e.cellElement; }).indexOf(targetCell[0]);


                                        if (currentCellIndex == -1) {
                                            $(targetCell[0]).addClass("e-selectingcell");
                                                proxy._selectedCellDetails.push(selectedCellInfo);                                            
                                            model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });
                                                proxy._cellSelectedEventTrigger(args, proxy._previousSelectedCellDetails);
                                        }
                                        else {
                                            $(targetCell[0]).removeClass("e-selectingcell");
                                            proxy._selectedCellDetails.splice(currentCellIndex, 1);
                                            model.selectedCellIndexes.splice(currentCellIndex, 1);
                                        }                                       
                                    }
                                        //Select multiple cells using Shift Key + mouse Click.
                                    else if (e.shiftKey) {
                                        var args = {
                                            rowIndex: targetIndex,
                                            cellIndex: proxy._cellIndex,
                                        };
                                        proxy._shiftKeySelectCells(args);
                                        proxy._rowIndexOfLastSelectedCell = targetIndex;
                                        proxy._focusingRowIndex = proxy._shiftKeyFirstElementDetails.firstElementRowIndex;                                     
                                    }
                                }
                                    //Select single cell using mouse click.
                                else  {
                                    proxy._selectedCellDetails = [];
                                    model.selectedCellIndexes = [];
                                    $("#" + proxy._id).find(".e-selectingcell").removeClass("e-selectingcell");
                                    $(targetCell[0]).addClass("e-selectingcell");
                                    proxy._selectedCellDetails.push(selectedCellInfo);
                                    model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });                                   
                                    proxy._cellSelectedEventTrigger(args, proxy._previousSelectedCellDetails);
                                    //Clear the Details of shiftKeyFirstElement.
                                    proxy._shiftKeyFirstElementDetails = {
                                        firstElementRowIndex: -1,
                                        firstElementCellIndex: -1
                                    }
                                    proxy._updateSecondRowIndexBy = 1;
                                }
                                if (!e.shiftKey) {
                                    proxy._previousSelectedCellDetails = {
                                        rowElement: targetRow,
                                        cellElement: targetCell[0],
                                        cellIndex: args.cellIndex,
                                        rowIndex: targetIndex,
                                    };
                                    proxy._rowIndexOfLastSelectedCell = proxy._focusingRowIndex;
                                    proxy._isShiftKeyNavigation = false;
                                }
                            }
                            if (!e.shiftKey)
                                proxy._rowIndexOfLastSelectedCell = proxy._focusingRowIndex;
                            proxy._cancelSaveTools();
                            //Get back default values to perform keypressed event.                            
                            proxy._lastSelectedCellIndex = proxy._cellIndex;
                        }
                    }
                
                    if (proxy._isTouchTrigger && proxy.model.allowSelection && this.model.selectionSettings.selectionType == "multiple" && !proxy.model.isFromGantt) {
                        if (proxy._isTouchTrigger && this._multiSelectPopup != null && !this._multiSelectPopup.is(":visible") && this._multiSelectPopup.find(".e-rowselect").hasClass("e-spanclicked"))
                            this._multiSelectPopup.show();
                        if (proxy._isTouchTrigger && this._multiSelectPopup != null && !this._multiSelectPopup.find(".e-rowselect").hasClass("e-spanclicked")) {
                            if (!$target.hasClass("e-detailsrowcell") && !$target.parent("td").hasClass("e-detailsrowcell") && !$target.closest("tr").hasClass('e-detailsrow')) {
                                this._multiSelectPopup.removeAttr("style");
                                var offset = $target.closest(".e-rowcell").offset();
                                this._multiSelectPopup.offset({ top: 0, left: 0 }).offset({ left: (offset.left + (($target.closest(".e-rowcell").outerWidth() / 2) - (this._multiSelectPopup.width() / 2))), top: (offset.top - this._multiSelectPopup.outerHeight() - 10) }).show();
                            }
                        }
                        proxy._isTouchTrigger = false;
                    }
            }

            /* detail row show and hide */
            if (($target.hasClass("e-detailsrowcell") || $target.parent("td").hasClass("e-detailsrowcell")) && !$target.closest("tr").hasClass('e-detailsrow')) {
                if (!e.ctrlKey && !e.shiftKey) {
                    var editState=$("#" + this._id + "EditForm").length>0 ? this.editFormValidate()?true:false:true;                  
                    if (proxy._isRowEdit) {
                        this.saveRow();
                    } else if (editState)
                    {
                        proxy._detailsExpandCollapse($target);
                    }
                }
            }

            if (proxy._isRowEdit)
                $target.focus();
            if (!$target.closest("#" + proxy._id + "_ColumnMenu").hasClass("e-columnmenu"))
            {
                proxy._clearColumnMenu();
            }
            if (model.editSettings.beginEditAction == "click" && $target.closest("#" + proxy._id + "EditForm").length == 0 &&
                !proxy._isShiftKeyNavigation && !proxy._isEmptyRowDeleted)
                proxy._editdblClickHandler(e);
            proxy._isEmptyRowDeleted = false;
        },
		// Method to check/uncheck all the records
        selectAllRows: function (checkAll) {
            var proxy = this, model = proxy.model, index = -1,
                data = (proxy._flatFilteredRecords.length > 0) ? proxy._flatFilteredRecords : model.flatRecords,
                updatedRecords = proxy.getUpdatedRecords(),
                length = 0;
            if (!model.selectionSettings.enableSelectAll && !proxy._isFromSetmodel)
                return;

            if (model.showSummaryRow)
                data = proxy._spliceSummaryRows(data);
            if (!ej.isNullOrUndefined(checkAll)) {                
                if (!checkAll)
                    data = proxy._flatFilteredRecords.length > 0 ? proxy._flatFilteredRecords : $.extend([], model.selectedItems);

                for (var i = 0; i < data.length; i++) {
                    if (checkAll) {
                        if (data[i].checkboxState == "checked") continue;
                        data[i].checkboxState = "checked";
                        model.selectedItems.push(data[i]);
                        $('#' + this._id + "_checkbox" + data[i].ejRowId).removeClass("e-stop").addClass("e-checkmark");
                        $('#' + this._id + "_checkbox" + data[i].ejRowId).parent("span").removeAttr("class").addClass("e-chk-act");
                    }
                    else {                                             
                        index = model.selectedItems.indexOf(data[i]);
                        if (index > -1) {
                            data[i].checkboxState = "unchecked";
                            model.selectedItems.splice(index, 1);
                            $('#' + this._id + "_checkbox" + data[i].ejRowId).removeClass("e-checkmark");
                            $('#' + this._id + "_checkbox" + data[i].ejRowId).parent("span").removeAttr("class").addClass("e-chk-inact");
                            if (model.selectionSettings.enableHierarchySelection || proxy._isFromSetmodel)
                                proxy._updateParentSelection(data[i]);
                        }
                    }
                }                
                proxy._cancelSaveTools();
            }
            if (proxy._flatFilteredRecords.length > 0 && model.selectedItems.length > 0) {
                var selectedFilteredRecords = proxy._flatFilteredRecords.filter(function (data) {
                    return data.checkboxState == "checked";
                });
                length = selectedFilteredRecords.length;
            }
            else
                length = model.selectedItems.length;
            if (length > 0) {
                if (length != data.length) {
                    $('#' + this._id + "_headerCheckbox").removeClass("e-checkmark").addClass("e-stop");
                    $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-indeter");
                }
                else {
                    $('#' + this._id + "_headerCheckbox").removeClass("e-stop").addClass("e-checkmark");
                    $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-act");
                }
            }
            else {
                $('#' + this._id + "_headerCheckbox").removeClass("e-stop e-checkmark");
                $('#' + this._id + "_headerCheckbox").parent("span").removeAttr("class").addClass("e-chk-inact");
            }
        },

        //Add/Remove records in selectedItems collection
        _updateSelectedItems: function (currentRecord, checkboxState) {
            var proxy = this, model = proxy.model, length = 0,
                selectedRowIndex = -1, recordIndex = -1,
                updatedRecords = proxy.getUpdatedRecords();
            recordIndex = updatedRecords.indexOf(currentRecord);
            currentRecord.checkboxState = checkboxState;
            selectedRowIndex = $.inArray(currentRecord, model.selectedItems);
            if (currentRecord.checkboxState == "unchecked") {
                selectedRowIndex != -1 && model.selectedItems.splice(selectedRowIndex, 1);
                if (recordIndex > -1) {
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).removeClass("e-checkmark e-stop");
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-inact");
                }
            }
            else if (currentRecord.checkboxState == "checked") {
                selectedRowIndex == -1 && model.selectedItems.push(currentRecord);
                if (recordIndex > -1) {
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).removeClass("e-stop").addClass("e-checkmark");
                    $('#' + this._id + "_checkbox" + currentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-act");
                }
            }            
        },
        // Check/Uncheck parents & Children records Hierarchy selection
        _traverseSelection: function (record, checkboxState, ischildItem) {
            var proxy = this, length = 0, childRecords, updateParent = false, model = this.model;

                proxy._updateSelectedItems(record, checkboxState);                            

            if (!ischildItem && record.parentItem && model.selectionSettings.enableHierarchySelection) 
                proxy._updateParentSelection(record.parentItem);

            if (record.hasChildRecords && model.selectionSettings.enableHierarchySelection) {
                childRecords = record.childRecords;
                if (proxy._flatFilteredRecords.length > 0) {
                    var filteredChildRecords = childRecords.filter(function (record) {
                        return proxy._flatFilteredRecords.indexOf(record) > -1;
                    });
                    childRecords = filteredChildRecords;
                }
                length = childRecords.length;
                for (var count = 0; count < length; count++) {
                    if (childRecords[count].hasChildRecords)
                        proxy._traverseSelection(childRecords[count], checkboxState, true);
                    else if (!childRecords[count]['isSummaryRow']) {                        
                        proxy._updateSelectedItems(childRecords[count], checkboxState);
                    }
                }
            }
        },

        // Update parent checkbox state by its children checkbox state
        _updateParentSelection: function (parentRecord) {

            var proxy = this, length = 0, isChanged = false,
                model = this.model,
            childRecords = [];
            if (parentRecord && parentRecord.childRecords)
                childRecords = proxy._spliceSummaryRows(parentRecord.childRecords);
            if (proxy._flatFilteredRecords.length > 0 && proxy.model.selectionSettings.enableHierarchySelection) {
                var filteredChildRecords = childRecords.filter(function (record) {
                    return proxy._flatFilteredRecords.indexOf(record) > -1;
                });
                childRecords = filteredChildRecords;
            }
            length = childRecords && childRecords.length;
            var callMe = false;

            var indeter = childRecords.filter(function (record) {
                return record.checkboxState == "indeterminate";
            });
            var checkChildRecords = childRecords.filter(function (record) {
                return record.checkboxState == "checked";
            });

            if (indeter.length > 0 || (checkChildRecords.length > 0 && checkChildRecords.length != length)) {
                if (parentRecord.checkboxState == "checked") {
                    this._updateSelectedItems(parentRecord, "unchecked");
                    callMe = true;
                }
                else if (parentRecord.checkboxState == "unchecked") callMe = true;

                if (callMe) {
                    $('#' + this._id + "_checkbox" + parentRecord.ejRowId).addClass("e-stop");
                    $('#' + this._id + "_checkbox" + parentRecord.ejRowId).parent("span").removeAttr("class").addClass("e-chk-indeter");
                    parentRecord.checkboxState = "indeterminate";
                    if (parentRecord.parentItem) this._updateParentSelection(parentRecord.parentItem);
                }
            }
            else if (checkChildRecords.length == 0 && indeter.length == 0) {

                $('#' + this._id + "_checkbox" + parentRecord.ejRowId).removeClass("e-stop e-checkmark").parent("span").removeClass("e-chk-indeter");
                if (parentRecord.checkboxState == "checked")
                    this._updateSelectedItems(parentRecord, "unchecked");                
                else
                    parentRecord.checkboxState = "unchecked";
                parentRecord.parentItem && this._updateParentSelection(parentRecord.parentItem);
            }
            else {
                parentRecord.checkboxState = "checked";
                this._updateSelectedItems(parentRecord, "checked");
                if (parentRecord.parentItem) this._updateParentSelection(parentRecord.parentItem);
            }
        },

         /* remove child detail row wraper when detail row contains another treegrid*/
        _removeInnerDetailRows: function ($target, eventCheck)
        {
            /* check if target is in any of detail rows */
            var detailRows = $(".e-detailscellwrapperfly"),
                detailRowsLength = detailRows.length, count = 0, containsFlag = false;

            for (count; count < detailRowsLength; count++) {
                if ($.contains(detailRows[count], $target[0]) || $target == detailRows[count]) {
                    containsFlag = true;
                    break;
                }
            }

            var countFlag = false;
            if (ej.isNullOrUndefined(detailRows[count])) {
                count = detailRows.index($("#" + this._id + "detailscellwrapper"));
                countFlag = true;
            }
            var countFlagString = countFlag ? "" : ",";
            var parentTreeGridId = $(detailRows[count]).attr("parentTreeGridIds");
            var parentDetailWrapperElement = $("[parentTreeGridIds$='" + countFlagString + parentTreeGridId + "']"),
                length = parentDetailWrapperElement.length, i = 0;
            this._triggerDetailRowHideEvent(parentDetailWrapperElement, eventCheck);
        },

        /* trigger detail row collaspse event */
        _triggerDetailRowHideEvent: function (elements, eventCheck)
        {
            var proxy = this,
                model = this.model;
            var length = elements.length, i = 0;

            if (length > 0 && $("#" + this._id + "detailscellwrapper").length > 0)
            {
                var detailElement = $("#" + this._id + "detailscellwrapper"),
                    selectedItem = model.selectedItem;
                var detailsCollapseEventArgs = {};
                detailsCollapseEventArgs.rowData = selectedItem;

                if (!this._trigger("detailsHidden", detailsCollapseEventArgs) || eventCheck) {
                    for (i; i < length; i++) {
                        var treeGridContainerId = $(elements[i]).attr('id').replace("detailscellwrapper", "");
                       
                            $("#" + treeGridContainerId).find(".e-detailsrowexpand").removeClass("e-detailsrowexpand").addClass("e-detailsrowcollapse");
                            $("#" + treeGridContainerId).find(".e-detailsinfoiconhide").removeClass("e-detailsinfoiconhide").addClass("e-detailsinfoiconshow");
                        
                            $(elements[i]).remove();
                    }
                }
            }
        },
        /* remove all child detail row */
        _removeDetailsRow: function (e, eventCheck)
        {
            var model= this.model;
            
                if (e) {
                    var target = $(e.target);
                    var detailCellElement = target;
                    if (target.parent("td").hasClass("e-detailsrowcell"))
                        detailCellElement = target.parent("td");

                    if (target.closest(".e-popup").length == 0 && target[0] != $('html').get(0)) {

                        /* check if target is in any of detail rows */
                        var detailRows = $(".e-detailscellwrapperfly"),
                            detailRowsLength = detailRows.length, count = 0, containsFlag = false;

                        for (count; count < detailRowsLength; count++) {
                            if ($.contains(detailRows[count], target[0]) || target[0] == detailRows[count]) {
                                containsFlag = true;
                                break;
                            }
                        }

                        if (!target.hasClass("e-detailscellwrapperfly") && !detailCellElement.hasClass("e-detailsrowexpand") && !detailCellElement.hasClass("e-detailsrowcollapse")
                            && !containsFlag) {
                            this._removeInnerDetailRows($("#" + this._id + "detailscellwrapper"), eventCheck);
                        }

                        if (target.hasClass("e-detailscellwrapperfly") || detailCellElement.hasClass("e-detailsrowcollapse") || (!detailCellElement.hasClass("e-detailsrowexpand") && containsFlag)) {
                            var countFlag = false;
                            if (ej.isNullOrUndefined(detailRows[count])) {
                                count = detailRows.index($("#" + this._id + "detailscellwrapper"));
                                countFlag = true;
                            }
                            var countFlagString = countFlag ? "" : ",";
                            var parentTreeGridId = $(detailRows[count]).attr("parentTreeGridIds");
                            var parentDetailWrapperElement = $("[parentTreeGridIds$='" + countFlagString + parentTreeGridId + "']");
                            this._triggerDetailRowHideEvent(parentDetailWrapperElement, eventCheck);
                        }
                    }
                } else {
                    $("#" + this._id + "detailscellwrapper").length > 0 && this._removeInnerDetailRows($("#" + this._id + "detailscellwrapper")[0], eventCheck);
                    this._triggerDetailRowHideEvent($("#" + this._id + "detailscellwrapper"), eventCheck);
                }
            
        },

        /* show hide detail rows public method*/
        
        showHideDetailsRow:function(rowIndex)
        {
            var proxy = this, model = this.model;
            /* save if tree grid is in edit state */
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            if (model.showDetailsRow && model.detailsTemplate && model.showDetailsRowInfoColumn && !ej.isNullOrUndefined(rowIndex)
                 && rowIndex <= model.updatedRecords.length && proxy.getExpandStatus(model.updatedRecords[rowIndex])) {
                if (rowIndex != this.selectedRowIndex()) {
                    if (rowIndex != -1 && $.inArray(rowIndex, proxy._selectedRowsIndexes == -1) && model.allowSelection && model.updatedRecords.length > rowIndex) {
                        if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), rowIndex)) {
                            proxy.selectRows(rowIndex);
                            proxy._rowSelectedEventTrigger(rowIndex);
                        }
                    }
                }

                this.updateScrollBar(rowIndex);
                var targetRowElement = $(ej.TreeGrid.getRowByIndex(proxy, rowIndex)), targetCellElement;
                if (targetRowElement.length > 0 && model.updatedRecords[rowIndex] && proxy.getExpandStatus(model.updatedRecords[rowIndex]))
                {
                    targetCellElement = $(targetRowElement).find(".e-detailsrowcell");
                    if ($(targetCellElement).length > 0 && $(targetCellElement).hasClass("e-detailsrowcell"))
                    {
                        if (this.element.find(".e-detailsrowexpand")[0] != targetCellElement[0])
                            this._removeDetailsRow();

                        this._detailsExpandCollapse($(targetCellElement));
                    }
                }
            }
        },
        /* expand collapse the detail row */
        _detailsExpandCollapse:function($target)
        {
            var proxy = this,
                model = this.model;
            
            if ($target.parent("td").hasClass("e-detailsrowcell"))
                $target = $target.parent("td");
            var rowElement = $target.closest('tr'),
                detailsIconElement = rowElement.find(".e-detailsrowcell");

            if (detailsIconElement.hasClass("e-detailsrowcollapse")) {

                var rowIndexValue = this.getIndexByRow(rowElement),
                   rowData = this.model.currentViewData[rowIndexValue];
                if (ej.isNullOrUndefined(rowData) || rowData.isSummaryRow)
                    return;
                var rowBottom = this.getOffsetRect(rowElement[0]),
                   detailtr = $($.render[proxy._id + "_detailRowTemplate"](rowData)),
                   detailsCellElement = $(detailtr).find(".e-detailscellwrapper").attr({ "id": this._id + "detailscellwrapper" }),
                   width = proxy._gridWidth - (proxy.element.find(".e-scrollcss").length > 0 ? 18 : 0) - 2;//2 - treegrid border

                /* add treegrid attribute for detail row wraaper element */
                var rowWrapperElement = this.element.parents().filter(".e-detailscellwrapperfly"),
                    wrapperElementID = this._id, tempTreeGridId = "";
                while (rowWrapperElement.length > 0) {
                    tempTreeGridId = rowWrapperElement.attr("id").replace("detailscellwrapper", "");
                    wrapperElementID += "," + tempTreeGridId;
                    rowWrapperElement = $("#" + tempTreeGridId).parents().filter(".e-detailscellwrapperfly");
                }

                detailsCellElement.attr("parentTreeGridIds", wrapperElementID);
                
                //Edge detection for detail rows
                var treeGridContentOffset = this.getOffsetRect(proxy._$gridContent[0]), topPosition, bottomPosition;
                treeGridContentOffset.bottom = treeGridContentOffset.top + proxy._$gridContent[0].offsetHeight;
                topPosition = rowBottom.top + rowElement[0].offsetHeight;
                bottomPosition = topPosition + model.detailsRowHeight;
                if (topPosition > treeGridContentOffset.bottom || bottomPosition > treeGridContentOffset.bottom)
                {
                    var tempTopPosition = rowBottom.top - model.detailsRowHeight;
                    if (tempTopPosition > treeGridContentOffset.top)
                        topPosition = tempTopPosition;
                }

                detailsCellElement.removeClass("e-detailscellwrapper").addClass("e-detailscellwrapperfly");
                model.cssClass && detailsCellElement.addClass(model.cssClass);
                var scrollerLeft = proxy.getScrollElement().ejScroller("isHScroll") ? proxy.getScrollElement().ejScroller("option", "scrollLeft") : 0;
                if (scrollerLeft > proxy.getMaxScrollWidth())
                    scrollerLeft = proxy.getMaxScrollWidth();
                var frozenTableWidth = 0;
                if (this._frozenColumnsLength > 0) {
                    frozenTableWidth = $(this.element).find("#e-frozencontentdiv" + this._id).width();
                }
                detailsCellElement.css({
                    "top": topPosition, "left": rowBottom.left + scrollerLeft - frozenTableWidth,
                    "z-index": proxy.getMaxZIndex() + 1, position: "absolute", width: width
                }).appendTo(this.element);
                this._trigger("refresh");
                var eventArgs = {};
                eventArgs.detailsElement = detailsCellElement;
                eventArgs.data = rowData;
                eventArgs.rowIndex = this.selectedRowIndex();
                this._trigger("detailsDataBound", eventArgs);

                /* details show/expand event trigger*/
                var expandEventArgs = {};
                expandEventArgs.detailsElement = detailsCellElement;
                expandEventArgs.data = rowData;
                expandEventArgs.rowIndex = this.selectedRowIndex();
                expandEventArgs.appendTarget = null;
                if (this._trigger("detailsShown", expandEventArgs)) {
                    this._removeInnerDetailRows($target);
                }else
                {
                    detailsIconElement.find(".e-detailsinfoiconshow").removeClass("e-detailsinfoiconshow").addClass("e-detailsinfoiconhide");
                    detailsIconElement.removeClass("e-detailsrowcollapse").addClass("e-detailsrowexpand");
                    if (expandEventArgs.appendTarget)
                    {
                        $(detailsCellElement).css({ "top": "auto", left: "auto", position: "auto" });
                        $(detailsCellElement).detach().appendTo($("#" + expandEventArgs.appendTarget));
                    }

                }
            }else
            {
                this._removeInnerDetailRows($target);
            }
        },

        //CLICK HANDLER FOR PERFORM THE SORTING ACTION
        _onHeaderClick: function (e) {

            var proxy = this,
                model = proxy.model;
            proxy._cellMouseLeave();
            proxy._headerMouseLeave();
            proxy._clearContextMenu();
            this._removeDetailsRow();
            if ($(e.target).is(".e-ascending, .e-descending")) e.target = e.target.parentNode;

            var $target = $(e.target),
                columnFieldName,
                columnSortDirection,
                column, canSort = true;

            proxy.getHeaderTable().find(".e-columnheader").find(".e-headercellactive").removeClass("e-headercellactive");

            if (proxy._mouseDragged && model.allowColumnReordering) canSort = false;

            if (proxy._checkboxSelection && model.allowSelection && model.selectionSettings.enableSelectAll && $target.hasClass("e-headerCheckbox")) {
                proxy.selectAllRows(!$target.hasClass("e-checkmark") && !$target.hasClass("e-stop"));
                canSort = false;
            }

            if ($target.closest(".e-headercelldiv") && !$target.hasClass("e-columnmenu-icon") && !$target.hasClass("e-column-filter-icon") && !$target.hasClass("e-column-filtered-icon")) {
                columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("data-ej-mappingname");
                if (!canSort || (ej.isNullOrUndefined(columnFieldName) && ej.isNullOrUndefined(this.getColumnByField(columnFieldName)) || this.getColumnByField(columnFieldName).allowSorting == false)) {
                    if ((model.isEdit || this._isRowEdit) && this.editFormValidate()) {
                        if (model.isEdit)
                            this.saveCell();
                        else if (this._isRowEdit)
                            this.saveRow();
                    }
                }                                    
                else if (canSort && model.allowSorting) {
                    column = this.getColumnByField(columnFieldName);
                    if ($target.closest(".e-headercell").find('span').hasClass("e-ascending")) {
                        columnSortDirection = ej.sortOrder.Descending;
                    } else {
                        columnSortDirection = ej.sortOrder.Ascending;
                    }

                    if (model.allowMultiSorting && e.ctrlKey) {
                        proxy._multiSortRequest = true;
                    }
                    proxy._isRefreshAddedRecord = false;
                    if(model.isFromGantt)
                        proxy.sortColumn(column.mappingName ? column.mappingName : column.field, columnSortDirection);
                    else
                        proxy.sortColumn(column.field, columnSortDirection);
                    if (proxy.model.isFromGantt && this.selectedRowIndex() >= 0) {
                        var args = {};
                        args.data = proxy.model.selectedItem;
                        args.target = "ejTreeGrid";
                        args.recordIndex = this.selectedRowIndex();
                        proxy._trigger("rowSelected", args);
                    }
                }
            }            
                                            

            // Show the column menu / filter menu while clicking the column menu icon / filter menu icon

            if ($target.hasClass("e-column-filter-icon") || $target.hasClass("e-column-filtered-icon"))
            {
                
                if (!$target.data("isClicked")) {
                    proxy._updateFilterMenuList(e);
                    $(".e-filtericon").data("isClicked", false);
                    $target.data("isClicked", true);
                }
                else {
                    proxy._clearColumnMenu();
                    $target.data("isClicked", false);
                }
                this._addRemoveAnimateClass($target);
            }
            else if ($target.hasClass("e-columnmenu-icon")) {
                if (!$target.data("isClicked")) {
                    proxy._renderColumnMenu(e);
                    $(".e-columnicon").data("isClicked", false);
                    $target.data("isClicked", true);
                }
                else{
                    proxy._clearColumnMenu();
                    $target.data("isClicked", false);
                }
                this._addRemoveAnimateClass($target);
            }
            else
                proxy._clearColumnMenu();
            if ($target.hasClass("e-checkbox"))
                return true;
            else if ($target.hasClass("e-columnmenu-icon") || $target.hasClass("e-column-filter-icon") || $target.hasClass("e-column-filtered-icon"))
                return false;
        },

        // Method to trigger the column resizing events.
        _triggerColumnResize: function (event, _x, e) {
            var proxy = this, model=proxy.model;
            var _rowobj = proxy.getHeaderTable().find(".e-columnheader");
            var _childTH = _rowobj.find(".e-headercell");
            var cellIndex = proxy._cellIndex, newWidth;
            var target = $(proxy._target), columnIndex = [], col = [];
            if (event == "columnResizeStart") {
                proxy._orgX = _x;
                cellIndex = proxy._currentCell = proxy._cellIndex= proxy.getCellIndex(e);
            }
            if (proxy._currentCell !=-1) {
                var _outerCell = _childTH[proxy._currentCell];
                var _oldWidth = _outerCell.offsetWidth;
                // condition for column resize start event
                if (event == "columnResizeStart") {
                    var args = {};
                    args = { columnIndex: cellIndex, column: proxy.model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth };
                    return proxy._trigger("columnResizeStart", args);
                }
                    //condition for column resize end event
                else if (event == "columnResizeEnd") {
                    var _childth = _rowobj.find(".e-headercell").not(".e-detailheadercell").filter(":visible");
                    //to calculate old, new and extra width values for event argument
                    var _extra = _x - proxy._orgX;
                    proxy._newWidth = _oldWidth + _extra;
                    proxy.__oldWidth = _oldWidth;
                    var args = {};
                    args = { columnIndex: cellIndex, column: model.columns[cellIndex], target: $(_outerCell), oldWidth: _oldWidth, newWidth: proxy._newWidth, extra: _extra };
                    return proxy._trigger("columnResizeEnd", args);
                }
                    //condition for column resized event
                else {
                    if (this.model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !this.model.isFromGantt) {
                        this._updateTableWidth();
                    } else if (!this.model.isFromGantt && this.model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.NextColumn && this.model.showTotalSummary) {
                        this._colgroupRefresh();
                    }
                    var args = {};
                    //to calculate old, new and extra width values for event argument
                    var _extra = _x - proxy._orgX;
                    newWidth = _oldWidth + _extra;
                    args = { columnIndex: cellIndex, column: model.columns[cellIndex], oldWidth: proxy.__oldWidth, newWidth: proxy._newWidth };
                    return proxy._trigger("columnResized", args);
                }
            }
        },

        //HEADER MOUSE DOWN EVENT FOR COLUMN RESIZING
        _headerMouseDown: function (e) {

            var proxy = this,
                coord = proxy._getCoordinate(e),                
            $target, $div, model = proxy.model;            
            proxy._cellMouseLeave();            
            proxy._headerMouseLeave();
            if (e.type == "touchstart") {
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                proxy._on(proxy.element, "touchmove", proxy._mouseMove);
                proxy._resizer && proxy._resizer._touchStart(e);
            } else
                $target = $(e.target);

            proxy._on($(document), "mouseup touchend", proxy._headerMouseUp);            

            if (model.allowColumnReordering) {
                if ($target.closest(".e-columnheader").length > 0)
                    proxy.dragColumn(e);
                if (e.type == "touchstart") {
                    proxy._dragColumnTooltipTimer = window.setTimeout(function () {
                        proxy._touchstart = false;
                        if (!proxy._dragTooltip && e.type == "touchstart") {
                            proxy.dragColumnToolTip(e);
                            if (proxy._dragTooltip) {
                                proxy._on(proxy.element, "touchmove", proxy.dragColumnToolTip);
                            }
                        }
                    }, 550);
                }
            }
            if (proxy.model.allowColumnResize) {
                if(model.isFromGantt)
                    proxy._on(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);                
                else
                    proxy._on(proxy.element, "mouseup touchend", proxy._mouseUp);

                $div = $target.closest('tr');
            
                this._target = $target;
                var _x = coord.pageX, _y = coord.pageY;            
                if (navigator.userAgent.indexOf("WebKit") != -1) {
                    _x = coord.pageX;
                    _y = coord.pageY - document.body.scrollTop;
                }
                if ($div.length > 0 && $div[0].style.cursor == "col-resize" && !$target.hasClass("e-columnicon")) {
                    if ($target.is(".e-headercelldiv"))
                        $target = $($target[0].parentNode);
                    this._target = $target;

                    if (proxy._frozenColumnsLength > 0) {
                        var columnFieldName = $target.closest(".e-headercell").find(".e-headercelldiv").attr("data-ej-mappingname"),
                         column = proxy.getColumnByField(columnFieldName);
                    }
                    // Event triggered when we start to resize the column
                    if (this._triggerColumnResize("columnResizeStart", _x, e))
                        return;
                }
                if (e.type != "touchstart")
                    proxy._resizer._mouseDown(e);
            }

            //if (($(e.target).hasClass("headercelldiv") && $(e.target).hasClass("headercell"))) {

            //    var $headercell = $(e.target).hasClass("headercelldiv") ? $(e.target).parent() : $(e.target);
            //    model.headerEffects && $headercell.addClass("headercellactive");

            //}
        },

        _headerMouseUp: function(e){
            var proxy = this, model = proxy.model,
                args = {}, coord = proxy._getCoordinate(e),
                $target;

            if (e.type == "touchend") {
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                proxy._off(proxy.element, "touchmove", proxy._mouseMove);
            }
            else
                $target = $(e.target);            
            proxy._off($(document), "mouseup touchend", proxy._headerMouseUp);

            if (proxy.model.allowColumnResize) {
                if (model.isFromGantt)
                    proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                else
                    proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                this.element.find(".e-reSizeColbg").remove();
                proxy._resizer._expand = false;
            }

            if (model.allowColumnReordering) {
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;
                proxy._off(proxy.element, "mousemove touchmove", proxy.dragColumnToolTip);
                $(proxy._reordervline).remove();
                $(proxy._dragmouseOverTooltip).remove();
                if (proxy._posx != coord.pageX || proxy._posy != coord.pageY) proxy._mouseDragged = true;
                if (model.allowColumnReordering && $target.closest('.e-headercell').length > 0 && proxy._headerDragStatus == "mousemove") {
                    var columns = model.columns;
                    args.targetColumn = columns[proxy._currentIndex];
                    args.targetColumnIndex = proxy._currentIndex;
                    args.draggedColumn = proxy._draggedColumn;
                    args.draggedColumnIndex = columns.indexOf(proxy._draggedColumn);

                    if (ej.isNullOrUndefined(args.targetColumn.nonColumn) && !ej.isNullOrUndefined(args.targetColumnIndex) && args.targetColumnIndex != args.draggedColumnIndex) {
                        proxy._trigger("columnDrop", args);
                        if (!args.cancel) {
                            proxy.reorderColumn(args.draggedColumn.field, args.targetColumnIndex);
                        }
                    }
                }
            }
            proxy._resetHeaderPrivateProperties();
        },

        _resetHeaderPrivateProperties: function () {
            this._timerDragDown && (this._timerDragDown = window.clearInterval(this._timerDragDown));
            this._timerDragUp && (this._timerDragUp = window.clearInterval(this._timerDragUp));
            var proxy = this, model = proxy.model;                      
            proxy._draggedColumn = null;
            proxy._dragMouseDown = false;
            proxy._dragTooltip = false;
            proxy._headerDragStatus = "";
            proxy._timerDragDown = null;
            proxy._timerDragUp = null;
            proxy._currentIndex = null;                        
            proxy._dragmouseOverTooltip = null;
        },

        //TREE GRID CONTENT MOUSE DOWN EVENT

        _contentMouseDown: function (e) {
            var $target = $(e.target), 
                proxy = this, model = proxy.model, coord = proxy._getCoordinate(e), id = $target.closest(".e-treegrid").attr("id");
            proxy._contentPageY = coord.pageY, proxy._contentPageX = coord.pageX;
            
            proxy._on($(document), "mouseup touchend", proxy._mouseupHandler);

            if (e.type == "touchstart") {
                proxy._isTouchEvent = true;            
                proxy._isTouchTrigger = true;
            }

            if ($("#" + id + "_selectionpopup").is(":visible")) {
                if ($("#" + id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                    e.ctrlKey = true;
                    if (proxy.model.selectionSettings.selectionMode == ej.TreeGrid.SelectionMode.Row)
                    proxy._multiSelectCtrlRequest = true;
                }
                else {
                    e.ctrlKey = false; proxy._multiSelectCtrlRequest = false;
                }
            }
            if (!proxy.model.isFromGantt && model.contextMenuSettings.showContextMenu) {
                if (ej.isTouchDevice()) {                    
                    proxy._off(proxy.element, "taphold", proxy._contextMenuAction);
                    proxy._on(proxy.element, "taphold", proxy._contextMenuAction);
                }
                else {
                    proxy._off(proxy.element, "contextmenu", proxy._contextMenuAction);
                    proxy._on(proxy.element, "contextmenu", proxy._contextMenuAction);
                }
            }
            
            if (!($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown")
                  || $target.hasClass("e-vhandlespace") || $target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hdown")
                  || $target.hasClass("e-hhandlespace") || $target.closest(".e-editedcell").length > 0 || $target.closest(".e-unboundeditedcell").length > 0||$target.parent().hasClass("e-unboundcelldiv")))
            {                
                proxy._mouseDown = true;
                if (ej.isTouchDevice())
                    e.preventDefault();
                if (model.allowDragAndDrop) {
                    //Events binded for Row drag and drop
                    if ($target.closest(".e-treegridrows").length > 0 || $target.closest(".e-templatecell").length > 0) {
                        if (e.type == "touchstart") {
                            proxy._dragTooltipTimer = window.setTimeout(function () {
                                proxy.dragRecord(e);
                                if (proxy._multiSelectPopup && proxy._multiSelectPopup.is(":visible") && proxy._dragTooltip)
                                    proxy._clearMultiSelectPopup();

                            }, 550);
                        }
                        else
                            proxy.dragRecord(e);
                    }
                }
                if (!model.isFromGantt) {
                    if (e.type == "touchstart")
                        proxy._on(proxy.element, "touchmove", "#" + proxy._id + "e-gridcontent", proxy._touchScroll);                   
                }
                if (e.ctrlKey || e.shiftKey || e.which == 2 || e.which == 3)
                    return true;
            }
        },

        _touchScroll: function (e) {
            var proxy = this, model = proxy.model, args = {},
                coord = proxy._getCoordinate(e), $target, pixelX,pixelY,               
                prevX = proxy._contentPageX, prevY = proxy._contentPageY,
                posX = coord.pageX, posY = coord.pageY,
                dx, dy;
            proxy._isTouchTrigger = false;
            
            dx = posX - prevX;
            dy = posY - prevY;                        
            if (e.type == "touchmove") {                
                e.preventDefault();                
            }
            if ((proxy._mouseDown &&  !proxy._dragMouseDown)) {

                window.clearTimeout(this._dragTooltipTimer);
                this._dragTooltipTimer = null;
                window.clearTimeout(this._dragColumnTooltipTimer);
                this._dragColumnTooltipTimer = null;

                if (e.type == "touchmove")
                    $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
                else
                    $target = $(e.target);

                if (!model.isFromGantt && $target.closest('div').find('.e-content')) {

                    if (prevY < posY)
                        pixelY = -Math.abs(dy);
                    else
                        pixelY = Math.abs(dy);

                    if (prevX < posX)
                        pixelX = -Math.abs(dx);
                    else
                        pixelX = Math.abs(dx);

                    proxy._contentPageX = posX;
                    proxy._contentPageY = posY;

                    proxy._updateScrollPosition($target, pixelX, pixelY);
                }
            }
        },

        _updateScrollPosition: function (target, px, py) {

            var proxy = this,
                scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop"),
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft"),
                deltaX = scrollLeft + px, deltaY = scrollTop + py,
                sHeight = proxy.isVScroll() ? proxy.getMaxScrollHeight() : null,
                sWidth = proxy.getScrollElement().ejScroller("isHScroll") ? proxy.getScrollElement().find(".e-content").get(0).scrollWidth : null;
            
            if (sHeight) {
                deltaY = sHeight < deltaY ? sHeight : deltaY < 0 ? 0 : deltaY;
                if ((deltaY > 0 && scrollTop > 0) || (deltaY < sHeight && scrollTop < sHeight)) {
                    proxy._$gridContent.scrollTop(0);
                    proxy.getScrollElement().ejScroller("scrollY", deltaY, true);
                }
            }

            if (sWidth) {
                deltaX = sWidth < deltaX ? sWidth : deltaX < 0 ? 0 : deltaX;
                if ((deltaX > 0 && scrollLeft > 0) || (deltaX < sWidth && scrollLeft < sWidth)) {
                    proxy._$gridContent.scrollLeft(0);
                    proxy.getScrollElement().ejScroller("scrollX", deltaX, true);
                }
            }                        
        },

        _mouseMove: function (e) {

            var proxy = this, model = this.model;
            window.clearTimeout(this._dragColumnTooltipTimer);
            this._dragColumnTooltipTimer = null;
            if (e.type == "touchmove") {                
                if (proxy._resizer && proxy._resizer._allowStart)
                    proxy._headerDragStatus = "";
            }
            if (proxy.model.allowColumnResize && proxy._headerDragStatus.length == 0) {
                proxy._resizer._mouseMove(e);
                if (proxy._resizer._expand)
                    proxy._cancelEditState();
                if ($(e.target).parent().css("cursor") !== "col-resize") {
                    if ((model.allowSorting || model.showColumnChooser || (!model.showColumnChooser && model.allowFiltering && model.filterSettings.filterType == "menu")) && !$(e.target).closest("th").hasClass("e-detailheadercell")) {
                        proxy.getHeaderTable().find(".e-columnheader").css({ 'cursor': 'pointer' });
                    } else {
                        proxy.getHeaderTable().find(".e-columnheader").css({ 'cursor': 'default' });
                    }
                }
            }
        },
        //to get the frozen width by using col group element
        _frozenWidth: function () {
            var proxy = this, frozenColumns, width;
            var frozenColumns = proxy.getContentTable().find('colgroup').find("col").slice(0, proxy.model.scrollSettings.frozenColumns),
                       width = 0;
            for (var i = 0; i < frozenColumns.length; i++)
                width += frozenColumns[i].style.display == 'none' ? 0 : parseInt(frozenColumns[i].style.width.replace("px", ""));
            return width;
        },


        _mouseUp: function (e) {

            var proxy = this,
                model = proxy.model;

            if (proxy._headerDragStatus == "mousemove") return;

            if (model.allowColumnResize) {
                
                if ($(e.target).hasClass('e-headercelldiv') || $(e.target).hasClass('e-reSizeColbg')) {
                    proxy._focusTreeGridElement();
                    proxy._clearColumnMenu();
                }
                if ($(e.target).hasClass("e-reSizeColbg") || $(e.target).closest(".e-gridheader").length > 0) {
                // if treegrid column resizer initiated
                if (proxy._resizer._expand) {
                    var _x = e.clientX, _y = e.clientY;
                    if (navigator.userAgent.indexOf("WebKit") != -1) {
                        _x = e.pageX;
                        _y = e.pageY;
                    }
                    if (e.type == "touchend") {
                        _x = e.originalEvent.changedTouches[0].clientX;
                        _y = e.originalEvent.changedTouches[0].clientY;
                    }
                    // Event triggered when we mouse the column resize
                    if (!ej.isNullOrUndefined(proxy._currentCell) && this._triggerColumnResize("columnResizeEnd", _x, e))
                    {
                        this.element.find(".e-reSizeColbg").remove();
                        proxy._resizer._expand = false;
                        if (model.isFromGantt)
                            proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                        else
                            proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                        return;
                    }
                    //to cancel the column resize of frozen column if it exceeds the grid width
                    if (!ej.isNullOrUndefined(proxy._currentCell) && model.columns[proxy._currentCell].isFrozen == true && _x + 100 > this._gridWidth) {
                        return;
                    }
                    proxy._resizer._mouseUp(e);
                    //update columnWidthCollection after column resize
                    if (!ej.isNullOrUndefined(proxy._currentCell) && proxy._currentCell >= 0 && proxy._currentCell < model.columns.length) {
                        model.columns[proxy._currentCell] && (model.columns[proxy._currentCell].width = proxy._resizer._newWidth);
                    }
                    // Event triggered after column resized
                    !ej.isNullOrUndefined(proxy._currentCell) && this._triggerColumnResize("columnResized", _x, e);                    
                    
                    proxy.getScrollElement().ejScroller("refresh");
                    proxy._updateHeaderScrollLeft();
                    proxy._updateScrollCss();
                    }
                }else
                {
                    this.element.find(".e-reSizeColbg").remove();
                    proxy._resizer._expand = false;
                    if (model.isFromGantt)
                        proxy._off(proxy.element.closest(".e-gantt"), "mouseup touchend", proxy._mouseUp);
                    else
                        proxy._off(proxy.element, "mouseup touchend", proxy._mouseUp);
                }
            }
        },

        // resize the filtering elements after column resized.

        _resizeFilteringElements:function()
        {
            var proxy = this;
            if (proxy.model.allowFiltering) {
                var args = {}, colLength = proxy.model.columns.length;
                ej.TreeGrid.Actions.Filter = "filtering";
                args.requestType = ej.TreeGrid.Actions.Filter;
                for (var item = 0; item < colLength ; item++) {
                    proxy.model.columns[item].width = proxy.columnsWidthCollection[item];
                    args.fieldname = proxy.model.columns[item].field;
                    this._filteringElements(args);
                }
            }
        },

        //ENABLE THE EDITING EVENTS
        _enableEditingEvents: function () {

            var proxy = this,
                model = proxy.model;

            if (model.editSettings.allowEditing) {
                if (ej.isTouchDevice()) {
                    proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                    proxy._on(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                }
                else {
                    proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                    proxy._on(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
                }
            }
            else {
                if (ej.isTouchDevice())
                    proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
                else
                    proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            }

        },


        //ENABLE THE MOUSEDOWNEVENT HANDLER FOR SAVE CELL
        _saveCellHandler: function (e) {

            var $target = $(e.target),
                proxy = this, model = proxy.model, targetIndex;
            if (model.isFromGantt && $target.closest("tr").length) {
                var $targetElement = $target.closest("tr"),
                    $gridRows = proxy.getRows(),
                    rowIndex = this.getIndexByRow($targetElement),
                    record = model.currentViewData && model.currentViewData[rowIndex];
                targetIndex = model.updatedRecords.indexOf(record);             
            }
            //SKIP THE SCROLL BAR CLICK IN TREE GRID.
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-vscroll"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace") || $target.hasClass("e-hscroll"))
                return;
          //  e.stopPropagation();
            if ($target.closest(".e-gridcontent").length > 0 || $target.hasClass(".e-gridcontent")) {
                if (proxy._isRowEdit && this.editFormValidate()) {
                    if ($target.closest("form#" + proxy._id + "EditForm").length == 0 && $target.closest("form#" + proxy._id + "EditFrozenForm").length == 0 &&  $("#" + proxy._id + "EditForm").length > 0)
                        proxy.saveRow();
                 } else if ($target.closest(".e-popup").length == 0 && $target.closest(".e-rowcell").find("#" + proxy._id + "EditForm").length == 0
                     && $target.closest("form#" + proxy._id + "EditFrozenForm").length == 0 && $("#" + proxy._id + "EditForm").length > 0 && this.editFormValidate()) {
                    proxy.saveCell();
                }
            }

            //Row selection for Gantt alone here
            //Why because, To select the clicked row after saving the edited cell (Due to predecessor and Row refresh)
            if (model.selectedMode == "row" && model.isFromGantt && model.updatedRecords.length && !ej.isNullOrUndefined(targetIndex) && !$target.hasClass('e-treegridexpand') && !$target.hasClass("e-treegridcollapse")) {
               if (this.selectedRowIndex() != targetIndex && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), targetIndex)) {
                    if (model.allowSelection)
                   proxy.selectRows(targetIndex);
                   proxy._rowSelectedEventTrigger(targetIndex);
               }
           }
        },

        //Mouse right click (Context Menu) handler
        _contextMenuAction: function(e){
            var proxy = this,
                $target, model = proxy.model,
                coord = proxy._getCoordinate(e);

            if(e.type == "taphold")
                $target = proxy._getElementByPosition(coord.pageX, coord.pageY);
            else
                $target = $(e.target);
            if (model.contextMenuSettings.showContextMenu && $target.closest(".e-gridcontent").length > 0) {
                e.preventDefault();
                if (proxy._multiSelectCtrlRequest)
                    proxy._multiSelectCtrlRequest = false;
                if (e.which == 3 && !proxy._isTouchEvent)
                    proxy._rightClick(e);
                else {
                    proxy._contextMenuHandler = true;
                    return true;
                }
            }
            else{
                e.stopPropagation();
            }            
        },

        _rightClick: function (e) {
            
            var proxy = this,
                model = proxy.model,
               $target = $(e.target),
               div = $target[0].parentNode,
               $ganttGridRows,
               row,
               recordIndexr,
               item, selectIndex,
               args = {},
               checkEditMenu = false,
               updatedRecords = proxy.getUpdatedRecords();
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").attr("id") !== this._id) return false;

            if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                model.editSettings.editMode = "cellEditing";
            }

            if (proxy.model.contextMenuSettings.showContextMenu) {
                proxy._clearContextMenu();
                this._removeDetailsRow();
                proxy.disableTooltip();
                if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-summarytitle"))
                    return;
                if ($target.hasClass("e-cell") || $target.hasClass("e-treegridexpand"))
                    div = $target.closest('tr');
                row = $target.closest('tr');
                recordIndexr = proxy.getIndexByRow(row);
                proxy.model.currentViewData = proxy.getCurrentViewData();
                item = proxy.model.currentViewData[recordIndexr];
                recordIndexr = updatedRecords.indexOf(item);
                args.data = item;
                args.recordIndex = recordIndexr;
                if (model.isEdit)
                    checkEditMenu = ($target.closest(".e-rowcell").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-rowcell").find("form#" + proxy._id + "EditFrozenForm").length > 0);
                else if (this._isRowEdit) {
                    checkEditMenu = ($target.closest(".e-rowedit").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-rowedit").find("form#" + proxy._id + "EditFrozenForm").length > 0) ||
                                    ($target.closest(".e-addedrow").find("form#" + proxy._id + "EditForm").length > 0) || ($target.closest(".e-addedrow").find("form#" + proxy._id + "EditFrozenForm").length > 0);
                }
                /* save edited value before rendering contextmenu on non edited cell*/
                if (!checkEditMenu && proxy.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                //Context menu for edited row or empty records
                if ((proxy.dataSource() == null || proxy.dataSource().length == 0 || checkEditMenu || model.flatRecords.length == 0)) {
                    proxy._contextMenuItems = [];
                    proxy._contextMenuItems = proxy._getContextMenuItems();
                    proxy._subContextMenuItems = [];
                    proxy._updateContextmenuOption(recordIndexr, item);
                    proxy._clearContextMenu();
                    if (proxy._contextMenuItems.length > 0)
                        proxy._renderContextMenu(e, recordIndexr, item, checkEditMenu);

                } else if (item) {
                    e.preventDefault();
                    proxy._contextMenuItems = [];
                    proxy._contextMenuItems = proxy._getContextMenuItems();
                    proxy._subContextMenuItems = [];
                    proxy._subContextMenuItems = proxy._getsubContextMenuItems();
                    proxy._updateContextmenuOption(recordIndexr, item);
                    proxy._clearContextMenu();

                   
                    if (model.selectionSettings.selectionMode == "row") {
                        if (model.allowSelection &&!(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), recordIndexr))){
                            proxy.selectRows(recordIndexr);
                            proxy._rowSelectedEventTrigger(recordIndexr);}
                    }
                    if (model.selectionSettings.selectionMode == "cell") {
                        var selectCellIndex = proxy.getCellIndex(e);
                        proxy.selectCells([{ rowIndex: recordIndexr, cellIndex: selectCellIndex }]);
                        proxy._rowIndexOfLastSelectedCell = recordIndexr;
                    }

                    if (proxy._contextMenuItems.length > 0)
                        proxy._renderContextMenu(e, recordIndexr, item, checkEditMenu);
                    if (proxy.editFormValidate()) proxy._cancelSaveTools();
                }
            }
            proxy._clearColumnMenu();
            proxy._contextMenuHandler = false;
            if (!proxy.model.isFromGantt && model.contextMenuSettings.showContextMenu) {
                if (ej.isTouchDevice())
                    proxy._off(proxy.element, "taphold", proxy._contextMenuAction);
                else
                    proxy._off(proxy.element, "contextmenu", proxy._contextMenuAction);
                
            }
            return;
        },

        //DOUBLE CLICK EVENT HANDLER FOR DIALOG EDITING

        _editdblClickHandler: function (e) {

            var proxy = this,
                model = proxy.model,
                $form = $("#" + proxy._id + "EditForm"),
                args = {},
                $target = $(e.target),
                row = $target.closest('tr'),
                record,
                cellEditingDetails = proxy._cellEditingDetails;
            if (model.readOnly == true || $target.hasClass("e-unboundcelldiv") || $target.hasClass("e-unboundcell") || $target.closest('td').hasClass("e-unboundcell")) {
                return true;
            }
            
            var updatedRecords = proxy.getUpdatedRecords();
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") ||
                $target.hasClass("e-treegridexpand") || $target.hasClass("e-treegridcollapse"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace"))
                return;
            if ($target.hasClass("e-summaryrowcell") || $target.hasClass("e-footersummaryrowcell")
                || $target.hasClass("e-summarytitle") || $target.hasClass("e-lastsummaryrow"))
                return;
            /* check inner treegrid click events and  */
            if ($target.closest(".e-treegrid").length && $target.closest(".e-treegrid").attr("id") !== this._id) return false;            

            if ($target.hasClass("e-rowcell") || $target.parent().hasClass("e-rowcell") || ($target.closest("td").hasClass("e-rowcell"))
                || ($target.closest("td").hasClass("e-rowcell")) && $target.hasClass("e-cell")) {

                if (model.editSettings.editMode === "normal" && model.editSettings.allowEditing) {
                    args.requestType = ej.TreeGrid.Actions.BeginEdit;
                    proxy._trigger("actionBegin", args);
                }

                if (proxy._cellEditingDetails.cancelSave) {

                    proxy._cellEditingDetails.cancelSave = false;
                    return;

                }

                if ($form.length === 0 && proxy.getRows() !== null) {

                    if (model.editSettings.editMode.toLowerCase() == "cellediting") {
                        proxy._focusTreeGridElement();
                        proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                        if (model.editSettings.beginEditAction != "click")
                        proxy._cellEditingDetails.rowIndex = proxy.getRowIndex(e);
                        record = model.currentViewData[proxy._cellEditingDetails.rowIndex];
                        if (record.summaryRow)
                            return;
                        model.selectedItem = record;                        
                        if (model.columns[cellEditingDetails.columnIndex].allowEditing == false)
                            return;
                        var fieldName = proxy._cellEditingDetails.columnIndex >= 0 && model.columns[proxy._cellEditingDetails.columnIndex].field;
                        if (fieldName) {
                            proxy.updateScrollBar();
                            model.editSettings.allowEditing &&
                                model.editSettings.editMode.toLowerCase() == ej.TreeGrid.EditMode.CellEditing.toLowerCase() &&
                                proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName);
                        }
                    }
                    else if (model.editSettings.editMode.toLowerCase() == "rowediting" || model.editSettings.editMode.toLowerCase() == "dialogediting") {
                        model.currentViewData = proxy.getCurrentViewData();
                        if (proxy.getCellIndex(e) != -1 && proxy.getRowIndex(e) != -1) {
                            proxy._cellEditingDetails.columnIndex = proxy.getCellIndex(e);
                            var rowIndex = proxy.getRowIndex(e);
                            if (model.enableVirtualization) {
                                var selectedItem = model.selectionSettings.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                rowIndex = updatedRecords.indexOf(selectedItem);
                            }
                            if ((proxy.model.editSettings.editMode.toLowerCase() == "dialogediting")) {
                                proxy._showTreeGridAddEditDialog(rowIndex);
                            } else {
                                proxy.updateScrollBar();
                                proxy._editRow(rowIndex, undefined, proxy._cellEditingDetails.columnIndex);
                            }
                        }
                    }
                    $form = $("#" + proxy._id + "EditForm");
                    if ($form.length > 0)
                        proxy._editAddTools();

                    if ($.isFunction($.validator)) {
                        proxy._initValidator();
                        proxy.setValidation();
                    }
                }

                if (!proxy.model.allowSelection)
                    row.find(".e-active").removeClass("e-active").removeClass("e-selectionbackground");
                proxy._clearContextMenu();
                this._removeDetailsRow();
            }            
        },

        //To hide the datepicker and dropdown list.
        _popupHide: function (element) {
            var proxy = this,
             column = proxy.model.columns,
             object = null,
             dateobj = null,
             columnField = null,
             tdElement = element && $(element).closest("td");
            if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "filterbar") {
                tdElement = element && $(element).closest("td, th");
            }
            var columnChooser = $("#" + proxy._id + "_ColumnMenu").length;
            if (columnChooser > 0) {
                if (!ej.isTouchDevice())
                proxy._clearColumnMenu();
            }
            for (var i = 0; i < column.length; i++) {
                object = null;

                if (column[i]) {
                    columnField = column[i].field.split('.').join("");
                    if (column[i].editType == "datepicker" || column[i].editType == "datetimepicker")
                        object = $("#" + proxy._id + columnField).data("ejDatePicker");
                    else if (column[i].editType == "dropdownedit") {
                        var dropdownobject = $("#" + proxy._id + columnField).data("ejDropDownList");
                        if (dropdownobject && $(tdElement).find("#" + dropdownobject._id).length == 0)
                            dropdownobject.model && dropdownobject.hidePopup();
                    }                    
                    if (object && $(tdElement).find("#" + object._id).length == 0)
                        object.hide();

                    if (column[i].filterEditType == "datepicker" || column[i].filterEditType == "datetimepicker") {
                        dateobj = $("#" + proxy._id + "_" + columnField + "_filterbarcell").data("ejDatePicker");
                        if (dateobj && $(tdElement).find("#" + dateobj._id).length == 0)
                            dateobj.hide();
                    }
                    if (column[i].filterEditType == "dropdownedit") {
                        var dropdownobject = $("#" + proxy._id + "_" + columnField + "_filterbarcell").data("ejDropDownList");
                        if (dropdownobject && $(tdElement).find("#" + dropdownobject._id).length == 0)
                            dropdownobject.hidePopup();
                    }
                }
            }
        },
        //PERFORM SCROLLING IN TREEGRID
        _mouseWheel: function (e) {

            var proxy = this,
                model = proxy.model,
                delta = null,
                ori = e;            
            proxy._popupHide();
            
            e = e.originalEvent;

            if ($(e.target).hasClass('e-footersummaryrowcell'))
                return;
            if (proxy.getScrollElement().height() > proxy._$gridContainer.height()) {
                proxy.getScrollElement().ejScroller("scrollY", 0, true);
                return;
            }

            if (e.wheelDelta) {
                delta = -e.wheelDelta / 120;
                if (window.opera) {
                    if (parseFloat(window.opera.version, 10) < 10)
                        delta = -delta;
                }
            } else if (e.detail) {
                delta = e.detail / 3;
            }
	
            if (!delta) return false;

            var scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop"),

                change = scrollTop + (delta * 57);  

            var h = this.model.isFromGantt ? parseInt(proxy.model.updatedRecords.length * proxy.model.rowHeight) - (proxy._viewPortHeight - 18) : this.getMaxScrollHeight();
            if (change > h) {
                change = h;
            }
            if (change < 0) {
                change = 0;
            }
            if (scrollTop != change) {
                try {
                    e.preventDefault ? e.preventDefault() : ori.preventDefault();
                }
                catch (err) {
                }
            }
            proxy.updateScrollTop(change);
            return true;

        },
        _getCollapsedParentItem:function(record)
        {
            var parentRecord = record.parentItem;
            if (parentRecord) {
                if (this.getExpandStatus(parentRecord) === true) {
                    return parentRecord;
                } else {
                    return this._getCollapsedParentItem(parentRecord)
                }
            }
            else {
                return null;
            }
        },


        // Update the scroll bar while edit, expand and collapse the record for focusing the row.
        updateScrollBar: function (rowIndex) {
            var proxy = this,
                model = proxy.model, horizontalScrollBarHeight = 0,
                currentUpdatedRecords, recordIndex, rowTop,
                rowHeight, totalHeight,
                isInViewPortAbove, isInViewPortBelow,
                updatedRecords = proxy.getUpdatedRecords(), selectedItem;
            if (model.allowSelection) {
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell];
            }
            else {
                selectedItem = this.selectedItem();
            }
            currentUpdatedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(updatedRecords);
            if (rowIndex || rowIndex == 0) {
                    recordIndex = currentUpdatedRecords.indexOf(updatedRecords[rowIndex]);
                } else {
                    recordIndex = currentUpdatedRecords.indexOf(selectedItem);
                }            

            if (model.allowTextWrap) {
                var updatedrecord = proxy.getUpdatedRecords(),
                    recordIndex = updatedrecord.indexOf(selectedItem);
                if (model.enableVirtualization) {
                    rowTop = proxy._getAvgTextWrapRowHeight("updateHeight", recordIndex).height;
                    rowHeight = updatedrecord[recordIndex].textWrapRowHeight + proxy._detailsRowHeight;
                } else {
                    var $tr = ej.TreeGrid.getRowByIndex(proxy, recordIndex);
                    if ($tr.length > 0) {
                        rowHeight = $tr.height() + proxy._detailsRowHeight;
                        rowTop = $tr[0].offsetTop;
                    } else {
                        rowHeight = model.rowHeight + proxy._detailsRowHeight;
                        rowTop = recordIndex * rowHeight;
                    }
                }
            } else {
                rowHeight = model.rowHeight + proxy._detailsRowHeight;
                rowTop = recordIndex * rowHeight;
            }

            var rowBottom = rowTop + rowHeight,
                scrollTop,
                containerWidth,
                scrollerExist = proxy.getScrollElement().children(".e-content").length;
   
            if (scrollerExist)
                scrollTop = proxy.getScrollElement().children(".e-content").scrollTop();
            else
                scrollTop = proxy.getScrollElement().scrollTop();

            if (model.allowTextWrap) {
                if (proxy.model.enableVirtualization) {
                    totalHeight = proxy._getAvgTextWrapRowHeight("updateHeight").height;
                } else {
                    totalHeight = proxy._$gridContentTable.height();
                }
            } else {
                totalHeight = currentUpdatedRecords.length * rowHeight;
            }
    
            if(proxy.getScrollElement().ejScroller("isHScroll")  || proxy.element.find(".e-borderbox").length > 0)
            {
                horizontalScrollBarHeight = 18; /* default horizontal scrollbar height*/
            }

            isInViewPortAbove = (rowTop < scrollTop);
            isInViewPortBelow = (scrollTop + proxy._viewPortHeight - horizontalScrollBarHeight) <= rowBottom;


            if (isInViewPortAbove || isInViewPortBelow) {

                if ((rowTop + proxy._viewPortHeight) > totalHeight) {
                    rowTop = totalHeight - proxy._viewPortHeight;

                    if (isInViewPortBelow)
                        rowTop += horizontalScrollBarHeight;
                }

                    var args = {
                        requestType: ej.TreeGrid.Actions.Scroll,
                         delta: rowTop
                    };
                    if (scrollerExist)
                        proxy.updateScrollTop(rowTop);
                    else {
                        proxy.getScrollElement().scrollTop(args.delta);
                        proxy._completeAction(args);
                    }
                    if (model.enableVirtualization) {
                       proxy._focusTreeGridElement();
                    }
            }
        },

        //KEY PRESSED EVENT FOR KEY BOARD INTERACTION IN TREEGRID CONTROL

        _keyPressed: function (action, target, e) {

            var proxy = this,
            model = this.model,
            lastRowIndex,
            selectingRowIndex,
            updatedRecords = proxy.getUpdatedRecords(), index, editType, str,
            expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords), filterMenuDiv,
            currentSelectingRecord;
            this._removeDetailsRow();
            //CHECK THE ALLOWKEYBOARDNAVIGATION
            if (!model.allowKeyboardNavigation){
                return false;
            }

            if (this.model.editSettings.editMode == "dialogEditing" && $(target).closest("#" + this._id + "_dialogEdit").length)
                return true;
            var returnValue = false,
                $target = $(target),
            $form = $("#" + proxy._id + "EditForm");
            if (action !="downArrow" && action != "upArrow" && action != "saveRequest" && action != "moveCellLeft" && action != "moveCellRight"
                   && action != "cancelRequest" && $target.prop("tagName") == "INPUT") // Skip the keypress event for filter bar input box except enter
                return true;
            var contextMenu, subContextMenu, columnMenu, columnChooserMenu, isVisible, isVisibleColumnChooserMenu, isVisibleFilterMenu;
            if (model.isFromGantt) {
                contextMenu = $("#" + proxy._id.replace("ejTreeGrid", "") + "_ContextMenu");
                subContextMenu = $("#" + proxy._id.replace("ejTreeGrid", "") + "_SubContextMenu");
            }
            else {
                contextMenu = $("#" + proxy._id + "_ContextMenu");
                subContextMenu = $("#" + proxy._id + "_SubContextMenu");
            }
            columnMenu = $("#" + proxy._id + "_ColumnMenu");
            columnChooserMenu = $("#" + proxy._id + "ccDiv_wrapper");
            if (proxy._columnMenuTarget) {
                var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("data-ej-mappingname")),
                column = proxy.getColumnByField(columnFieldName), filtertype;
                if (column) {
                    if (column.filterEditType) {
                        index = column.filterEditType.indexOf("edit");
                        filtertype = column.filterEditType;
                    }
                    else {
                        index = column.editType.indexOf("edit");
                        filtertype = column.editType;
                    }
                    if (index != -1) {
                        editType = filtertype.slice(0, index);
                        str = editType.charAt(0).toUpperCase() + editType.slice(1);
                        filterMenuDiv = $("#" + proxy._id + "filter" + str + "MenuDiv_wrapper");
                    } else {
                        str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                        filterMenuDiv = $("#" + proxy._id + "filter" + str + "MenuDiv_wrapper");
                    }
                }
                isVisibleFilterMenu = !ej.isNullOrUndefined(filterMenuDiv) && filterMenuDiv.is(":visible");
            }
            isVisible = subContextMenu.css("visibility") == "visible" ? true : false;
            isVisibleColumnChooserMenu = columnChooserMenu.is(":visible");
            switch (action) {

                //save the current edited cellValue on Enter key press
                case "saveRequest":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) {
                            $target.blur();
                            proxy._endEdit();
                           proxy._focusTreeGridElement();
                        }
                        if (model.filterSettings.filterBarMode == "onEnter" && model.filterSettings.filterType == "filterbar" && model.allowFiltering && $target.closest("th").hasClass("e-filterbarcell"))
                            proxy._filterBarHandler(target);
                    }
                    else
                    {
                        if (contextMenu.length)
                        {
                            proxy._moveToNextMenuItem("save");
                        }
                        else if (columnMenu.length)
                        {
                            var option = null,
                                columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection");                            
                            if (isVisibleColumnChooserMenu) {                                
                                option = columnChooserMenuItem.data("column");
                            }
                            else
                            {
                                var columnMenuItem = columnMenu.find("div.e-columnmenuselection");
                                if (columnMenuItem.length > 0) {
                                    option = columnMenuItem[0].id;
                                }
                            }
                            if (!ej.isNullOrUndefined(option))
                            {
                                $target = proxy._columnMenuTarget;
                                var columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("data-ej-mappingname")),
                                column = proxy.getColumnByField(columnFieldName);
                                switch(option)
                                {
                                    case proxy._id + "_SortAscendingChooser":
                                        
                                        if (proxy.model.allowMultiSorting) proxy._multiSortRequest = true;
                                        if (model.isFromGantt)
                                            proxy.sortColumn(column.mappingName ? column.mappingName : column.field, ej.sortOrder.Ascending);
                                        else
                                            proxy.sortColumn(column.field, ej.sortOrder.Ascending);
                                        proxy._multiSortRequest = false;
                                        break;
                                    case proxy._id + "_SortDescendingChooser":
                                       
                                        if (proxy.model.allowMultiSorting) proxy._multiSortRequest = true;
                                        if (model.isFromGantt)
                                            proxy.sortColumn(column.mappingName ? column.mappingName : column.field, ej.sortOrder.Descending);
                                        else
                                            proxy.sortColumn(column.field, ej.sortOrder.Descending);
                                        proxy._multiSortRequest = false;
                                        break;
                                    case proxy._id + "_FreezeColumnsChooser":
                                        if (column && !$(proxy._id + "_FreezeColumnChooser").hasClass("e-disable")) {
                                            if (proxy._checkboxSelection) {
                                                if (model.columns[0].nonColumn && !model.columns[0].isFrozen)
                                                    model.columns[0]['isFrozen'] = true;
                                            }
                                            proxy.freezeColumn(column.field, true);
                                        }
                                        break;
                                    case proxy._id + "_UnfreezeColumnsChooser":
                                        if (column && !$(proxy._id + "_UnfreezeColumnChooser").hasClass("e-disable")) {                                           
                                            if (proxy._checkboxSelection && proxy._frozenColumnsLength == 2) {
                                                if (model.columns[0].nonColumn && model.columns[0].isFrozen)
                                                    model.columns[0]['isFrozen'] = false;
                                            }
                                            proxy.freezeColumn(column.field, false);
                                        }
                                        break;
                                    case proxy._id + "_FreezePrecedingColumnsChooser":
                                        if (column && !$(proxy._id + "_FreezePrecedingColumnsChooser").hasClass("e-disable"))
                                            proxy.freezePrecedingColumns(column.field);
                                        break;
                                    case proxy._id + "_ColumnLeftChooser":
                                        if (column && !$(proxy._id + "_ColumnLeftChooser").hasClass("e-disable"))
                                            proxy.insertColumnChooser(column, "left");
                                        break;
                                    case proxy._id + "_ColumnRightChooser":
                                        if (column && !$(proxy._id + "_ColumnRightChooser").hasClass("e-disable"))
                                            proxy.insertColumnChooser(column, "right");
                                        break;
                                    case proxy._id + "_DeleteColumnChooser":
                                        if (column && !$(proxy._id + "_DeleteColumnChooser").hasClass("e-disable")) {
                                            proxy._targetColumnIndex = model.columns.indexOf(column);
                                            proxy._updateConfirmDialog.ejDialog("open");
                                            proxy._clearColumnMenu();
                                        }
                                        break;
                                    case proxy._id + "_RenameColumnChooser":
                                        if (column && !$(proxy._id + "_RenameColumnChooser").hasClass("e-disable")) {
                                            proxy._targetColumnIndex = model.columns.indexOf(column);
                                            proxy._renderColumnRenameDialog(column);
                                            proxy._columnRenameDialog.ejDialog("open");
                                            proxy._clearColumnMenu();
                                        }
                                        break;
                                    case proxy._id + "_FilterChooser":
                                        if (column && $("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                            var idValue = filterMenuDiv[0].id.substring(proxy._id.length, filterMenuDiv[0].id.indexOf("MenuDiv"));
                                            proxy._showFilterMenu(null, idValue, null, null, null, null, null, null, column, null);
                                        }
                                        break;
                                    case proxy._id + "_ColumnsChooser":
                                        if ((column && $("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) && !proxy.model.isFromGantt) {
                                            proxy._adaptiveColumnChooser();
                                        }
                                        break;
                                    default:
                                        if (!columnChooserMenuItem.find("span").hasClass("e-disable")) {
                                            var isColumnVisible = columnChooserMenuItem.find("span").attr("aria-checked");
                                            isColumnVisible == "true" ? proxy.hideColumn(option) : proxy.showColumn(option);
                                        }
                                        break;
                                }
                            }
                        }

                    }
                    break;

                    //cancel the cell editing in the current cell Esc key press
                case "cancelRequest":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if ($form.length > 0) {
                            var editMode = model.editSettings.editMode;
                            if (editMode.toLowerCase() == "cellediting") {
                                if (proxy._isRowEdit)
                                    proxy.cancelRowEditCell();
                                else
                                    proxy.cancelEditCell();
                            }
                            else if (editMode.toLowerCase() == "rowediting") {
                                proxy.cancelRowEditCell();
                            }
                            proxy._cancelSaveTools();
                        }
                       proxy._focusTreeGridElement();
                        if (proxy._dragMouseDown == true) {
                            $(proxy._dragmouseOverTooltip).remove();
                            $(".e-dragintend").find(".e-icon").css({ "display": "none" });
                            $(".e-intendparent").find(".e-icon").css({ "display": "none" });
                            proxy._dropCancel = true;
                            proxy._dragMouseDown = false;
                            proxy._dragTooltip = false;
                            proxy._headerDragStatus = "";
                            /*hide drag icons for target row element*/
                            if (proxy._dragTargetItem && proxy._dragTargetItem.hasChildRecords && proxy._dragTargetItem.level ==0) {
                                var targetTr = ej.TreeGrid.getRowByIndex(this, updatedRecords.indexOf(proxy._dragTargetItem));
                                if (proxy._dragTargetItem)
                                    targetTr.find(".e-treegridexpand").css({ "display": "inline-block" });
                                else
                                    targetTr.find(".e-treegridcollapse").css({ "display": "inline-block" });
                            }
                            /*unbind mouse move event of row drag*/
                            proxy._off(proxy.element, "touchmove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                            proxy._off(proxy.element, "mousemove", ".e-treegridrows, .e-templatecell", proxy.dragToolTip);
                        }
                    }
                    else {
                        proxy._clearContextMenu();
                        proxy._clearColumnMenu();
                    }
                    break;
                case "editRecord":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (model.selectionSettings.selectionMode == "cell" && model.editSettings.editMode != "dialogEditing") {
                            model.editSettings.editMode = "cellEditing";
                        }
                        var editSettings = model.editSettings,
                            editMode = editSettings.editMode;
                        if (model.readOnly == false && ((editSettings.allowEditing && model.selectedItems.length == 1) || (editSettings.allowEditing && model.selectionSettings.selectionMode == "cell") ||
                            (editSettings.allowEditing && model.selectedItem && proxy._checkboxSelection))) {
                            if (editMode.toLowerCase() == "cellediting" || model.selectionSettings.selectionMode == "cell") {
                                var column = proxy.model.columns[proxy._cellIndex];
                                if (ej.isNullOrUndefined(column) || !column.visible || column.allowEditing == false)
                                    return;
                                if (model.selectionSettings.selectionMode === "cell")
                                    proxy._cellEditingDetails.rowIndex = this._rowIndexOfLastSelectedCell;
                                else
                                    proxy._cellEditingDetails.rowIndex = this.selectedRowIndex();
                                proxy._cellEditingDetails.columnIndex = proxy._cellIndex;//proxy.getCellIndex(e, target);
                                model.selectedItem = updatedRecords[this.selectedRowIndex()];
                                if (proxy._cellEditingDetails.columnIndex > -1) {
                                    proxy.updateScrollBar();
                                    var fieldName = column.field;
                                    fieldName && proxy.cellEdit(proxy._cellEditingDetails.rowIndex, fieldName);
                                    proxy._editAddTools();
                                }
                            }
                            else if (editMode.toLowerCase() == "rowediting" && !proxy._isRowEdit && model.selectionSettings.selectionMode != "cell") {
                                var index = proxy.selectedRowIndex();
                                if (index >= 0) {                                   
                                    proxy.updateScrollBar();
                                    proxy._editRow(index);
                                }
                            } else if (editMode.toLowerCase() == "dialogediting" && model.selectionSettings.selectionMode != "cell") {
                                var index = proxy.selectedRowIndex();
                                if (index >= 0) {
                                    proxy._showTreeGridAddEditDialog(index);
                                }
                            }
                        }
                    }
                    break;
                    //Select first row of current Page if Paging is enabled
                case "topRowSelection":
                    if (model.allowPaging && contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {
                            var topRowIndex = 0;
                            if (updatedRecords[0].isSummaryRow) {
                                var record = proxy._getNextRecord(topRowIndex +1, updatedRecords, action);
                                topRowIndex = updatedRecords.indexOf(record);
                            }
                            if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), topRowIndex)) {
                                proxy.selectRows(topRowIndex);
                               proxy._focusTreeGridElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(topRowIndex);
                            }
                        }
                    }
                    break;
                    //Move to next page
                case "nextPage":
                    if (model.allowPaging) {
                        var currentPage = proxy._currentPage();
                       proxy._focusTreeGridElement();
                        if (currentPage < model.pageSettings.totalPages)
                            proxy.gotoPage(currentPage + 1);
                    }
                    break;
                    //Move to previous page
                case "prevPage":
                    if (model.allowPaging) {
                        var currentPage = proxy._currentPage();
                       proxy._focusTreeGridElement();
                        if (currentPage != 1)
                            proxy.gotoPage(currentPage - 1);
                    }
                    break;
                    //Select last row of current Page if Paging is enabled
                case "bottomRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {

                            var bottomRowIndex = updatedRecords.length - 1;
                            if (updatedRecords[bottomRowIndex].isSummaryRow) {
                                var record = proxy._getNextRecord(bottomRowIndex - 1, updatedRecords, action);
                                bottomRowIndex = updatedRecords.indexOf(record);
                            }
                            if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), bottomRowIndex)) {
                                proxy.selectRows(bottomRowIndex);
                               proxy._focusTreeGridElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(bottomRowIndex);
                            }
                        }

                    }
                    break;

                    //select the first row while press the Home key 
                case "firstRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;

                        if (updatedRecords.length > 0) {
                            if (model.selectionSettings.selectionMode == "row") {
                                if (model.allowPaging)
                                    proxy.gotoPage(1);
                                if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), 0))){
                                    proxy.selectRows(0);
                                    proxy.updateScrollBar();
                                    proxy._focusTreeGridElement();

                                    proxy._rowSelectedEventTrigger(0);}
                            }
                                //Select first cell of a row.
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex,
                                    cellInfo = {
                                        rowIndex: rowIndex,
                                        cellIndex: 0
                                    };
                                proxy._isShiftKeyNavigation = false;
                                proxy._cellIndex = 0;
                                proxy.selectCells([cellInfo]);

                            }
                            proxy._cancelSaveTools();
                        }  
                    }
                    break;

                case "lastRowSelection":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit)
                            return true;
                        if (updatedRecords.length > 0) {
                            lastRowIndex = expandedRecords.length - 1;
                            currentSelectingRecord = expandedRecords[lastRowIndex];                            
                            if (currentSelectingRecord.isSummaryRow)
                                currentSelectingRecord = proxy._getNextRecord(lastRowIndex - 1, expandedRecords, action);
                            if (model.allowPaging && currentSelectingRecord) {
                                proxy.gotoPage(model.pageSettings.totalPages);
                                updatedRecords = proxy._updatedPageData;
                            }
                            selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                            if (model.selectionSettings.selectionMode == "row") {
                                if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex))){
                                    proxy.selectRows(selectingRowIndex);
                                    proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                    proxy._rowSelectedEventTrigger(selectingRowIndex);}
                            }
                                //Select last cell of a row.
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex, columns = model.columns;
                                proxy._isShiftKeyNavigation = false;
                                proxy._cellIndex = columns.length - 1;

                                var cellInfo = {
                                    rowIndex: rowIndex,
                                    cellIndex: proxy._cellIndex
                                };

                                proxy.selectCells([cellInfo]);
                            }
                            proxy._cancelSaveTools();
                        }
                    }
                    break;
                    //set the edit mode to previous cell by press shift +tab key
                case "moveCellLeft":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        //Row edit Element focusing for Shift + tab key press
                        if (proxy._isRowEdit) {
                            var cellIndex = $target.closest("td").prev("td").length > 0 ? $target.closest("td").prev("td")[0].cellIndex : -1;
                            if (this._frozenColumnsLength > 0 && $("#" + proxy._id + "EditForm").has($target).length > 0)
                                cellIndex = cellIndex + this._frozenColumnsLength;
                            var previousElement =cellIndex !=-1 && proxy._getPreviousElement($target, cellIndex);
                            if (previousElement.length)
                                proxy._focusElementsForRowEdit(previousElement);
                        } else if (model.editSettings.allowEditing && model.editSettings.editMode.toLowerCase() == "cellediting" && $form.length > 0 && proxy.editFormValidate()) {
                            $target.blur();
                            returnValue = proxy._moveCurrentCell("left");
                        }
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && !proxy._isRowEdit && (proxy._focusingRowIndex != 0 || proxy._cellIndex != 0)) {
                            if (proxy.model.isEdit) {
                                proxy._focusingRowIndex = proxy._cellEditingDetails.rowIndex;
                                proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                                var cellInfo = {
                                    rowIndex: proxy._focusingRowIndex,
                                    cellIndex: proxy._cellIndex
                                };
                                proxy.selectCells([cellInfo]);
                            }
                            else proxy._selectNextCell("left", action);
                    }
                    }
                    break;

                    //set the edit mode to next cell by tab key
                case "moveCellRight":
                        if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit) {
                                var cellIndex = $target.closest("td").next("td").length > 0 ? $target.closest("td").next("td")[0].cellIndex : -1;
                                cellIndex = cellIndex == -1 && $("#" + proxy._id + "EditFrozenForm").has($target).length > 0 ? $("#" + proxy._id + "EditForm").find('td').eq(0).index() : cellIndex;
                                if (this._frozenColumnsLength > 0 && cellIndex !=-1 && $("#" + proxy._id + "EditForm").has($target).length > 0)
                                    cellIndex = cellIndex + this._frozenColumnsLength;
                                var nextElement =cellIndex!=-1 && proxy._getNextElement($target, cellIndex);
                            if (nextElement.length)
                                proxy._focusElementsForRowEdit(nextElement);
                        } else if (model.editSettings.allowEditing && (model.editSettings.editMode == "cellEditing" || model.selectionSettings.selectionMode == "cell")
                            && $target && $form.length > 0 && this.editFormValidate()) {
                            $target.blur();
                            returnValue = proxy._moveCurrentCell("right");
                        }
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && !proxy._isRowEdit && (proxy._focusingRowIndex != proxy.getRows().length - 1 || proxy._cellIndex != columnLength - 1)) {
                            if (proxy.model.isEdit) {
                                proxy._focusingRowIndex = proxy._cellEditingDetails.rowIndex;
                                proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                                var cellInfo = {
                                    rowIndex: proxy._focusingRowIndex,
                                    cellIndex: proxy._cellIndex
                                };
                                proxy.selectCells([cellInfo]);
                            }
                            else proxy._selectNextCell("right", action);
                    }
                    }
                    break;

                    //select the next row by press down arrow key
                case "downArrow":
                    if (model.allowSelection) {
                        if (contextMenu.length == 0 && columnMenu.length == 0) {
                            if (proxy._isRowEdit || proxy.model.isEdit)
                                return true;

                            if (updatedRecords.length > 0 && model.selectedItem && proxy.selectedRowIndex() > -1 && model.selectionSettings.selectionMode == "row") {
                                //get the last row index of the ganttchart control
                                lastRowIndex = updatedRecords.length - 1;
                                if (proxy.selectedRowIndex() != lastRowIndex) {
                                    var selectedItem = updatedRecords[proxy.selectedRowIndex()];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                                        //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                                                                  
                                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                                        if (currentSelectingRecord && selectingRowIndex <= lastRowIndex) {
                                            if (model.allowSelection && !(proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex))){
                                                proxy.selectRows(selectingRowIndex);
                                                proxy.updateScrollBar();
                                                proxy._focusTreeGridElement();
                                                proxy._rowSelectedEventTrigger(proxy.selectedRowIndex());}
                                        }
                                }
                            proxy._cancelSaveTools();
                        }
                            else if (model.selectionSettings.selectionMode == "cell" && proxy.selectedCellIndexes().length > 0) {
                                var rowIndex = proxy._focusingRowIndex + 1, cellIndex = proxy._cellIndex,
                                    recordLength = updatedRecords.length;
                                proxy._isShiftKeyNavigation = false;
                                if (rowIndex < recordLength) {
                                    var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                                    //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow) {
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                                        rowIndex = updatedRecords.indexOf(currentSelectingRecord);
                                    }
                                    if (currentSelectingRecord) {
                                    cellInfo = {
                                        rowIndex: rowIndex,
                                        cellIndex: cellIndex
                                    };
                                        proxy._focusingRowIndex = rowIndex;
                                        proxy.selectCells([cellInfo]);
                                        proxy.updateScrollBar();
                                }
                            }
                        }
                        }
                        else {
                            if (contextMenu.length) {
                                proxy._moveToNextMenuItem("next");
                            }
                            else if (columnMenu.length) {
                                if (isVisibleColumnChooserMenu) {
                                    var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection"),
                                       nextItem = columnChooserMenuItem.next("div.e-columnMenuListDiv");
                                    if (nextItem.length > 0) {
                                        columnChooserMenuItem.removeClass("e-columnmenuselection");
                                        nextItem.addClass("e-columnmenuselection");
                                    }
                                }
                                else {
                                    var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                        nextItem = proxy._findNextColumnMenuItem(columnMenuItem, "next");
                                    if (nextItem.length > 0) {
                                        columnMenuItem.removeClass("e-columnmenuselection");
                                        nextItem.addClass("e-columnmenuselection");
                                        proxy._focusTreeGridElement();
                                        proxy._clearFilterMenu();
                                    }
                                }
                            }
                        }
					}
                    break;
                // expand the child task by press right arrow
                case "rightArrow":
					if (model.allowSelection) {
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        var rowIndex = proxy.selectedRowIndex(),
                        record = updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = true;
                        if (record) {
                            if (record.hasChildRecords && !record.expanded) {
                                if (proxy.selectedRowIndex() >= 0) {
                                    isExpandCollapseEnabeled = proxy._trigger("expanding", args);
                                    if (!isExpandCollapseEnabeled && !model.isFromGantt) {
                                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                                    }
                                    if (model.enableVirtualization)
                                       proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                }
                            }
                        }
                        proxy._cancelSaveTools();
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && (proxy._focusingRowIndex != proxy.getRows().length -1 || proxy._cellIndex != columnLength - 1)) {
                            proxy._selectNextCell("right", action);
                    }
                    }
                    else
                    {
                        if (contextMenu.length && !isVisible) {
                            proxy._moveToNextMenuItem("expand");
                        }
                        else if (columnMenu.length && !isVisibleColumnChooserMenu) {

                            var evntArgs = {};
                            evntArgs.width = "auto";
                            evntArgs.height = "auto";
                            evntArgs.minWidth = "0px";
                            evntArgs.minHeight = "0px";
                            evntArgs.showHeader = false;
                            evntArgs.position = { X: 1, Y: 1 };
                            evntArgs.enableModal = false;
                            evntArgs.isResponsive = false;
                            evntArgs.enableResize = false;
                            evntArgs.cssClass = model.cssClass;
                            $("#" + proxy._id + "ccDiv_wrapper").addClass("e-treegridadaptivedialog");
                            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                            $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
                            $("#" + proxy._id + "ccDiv").css({ 'height': 'auto' });

                            var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                columnChooserMenuList = columnChooserMenu.find("div.e-columnMenuListDiv"),
                                columnListPosX = proxy._columnListPosX,
                                columnFilterPosX = proxy._columnFilterPosX,
                                columnChooserListIndex = proxy._columnChooserListIndex,
                                windowWidth = $(document).width();
                            if (columnMenuItem.length > 0 && columnMenuItem[0].id == proxy._id + "_ColumnsChooser" && !$("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                var columnchooser = $("#" + proxy._id + "ccDiv").ejDialog("instance"),
                                    columnListWidth = $("#" + proxy._id + "ccDiv_wrapper").width();
                                columnchooser.open();
                                if (windowWidth < columnListPosX + columnMenu.width()) {
                                    columnListPosX = columnListPosX - columnMenu.width() - columnListWidth;
                                }
                                var position = {
                                    X: columnListPosX,
                                    Y: proxy._columnMenuPopupY + $("#" + proxy._id + "_ColumnsChooser").position().top
                                };
                                columnchooser.option({ "position": position });
                                columnChooserMenu.css("z-index", proxy.getMaxZIndex() + 1);
                                columnChooserMenuList.removeClass("e-columnmenuselection");
                                columnChooserMenuList.eq(0).addClass("e-columnmenuselection");
                                proxy._focusTreeGridElement();
                                proxy._renderedSubMenuType = "ColumnDesktop";
                            } else if (columnMenuItem.length > 0 && columnMenuItem[0].id == proxy._id + "_FilterChooser" && !$("#" + proxy._id + "_ColumnMenu").find(".e-expander").hasClass("e-treegridadaptivesubicon")) {
                                var sliceFilterMenuDivID = filterMenuDiv[0].id.indexOf("_"),
                                    filterMenuDivID = "#"+ filterMenuDiv[0].id.slice(0, sliceFilterMenuDivID),
                                    filterMenuInstance = $(filterMenuDivID).ejDialog("instance"), filterMenuPosition, filterMenuIndex;

                                var proxy = this;
                                var evntArgs = {};
                                evntArgs.width = "auto",
                                evntArgs.height = "auto",
                                evntArgs.minWidth = "0px",
                                evntArgs.minHeight = "0px",
                                evntArgs.showHeader = false,
                                evntArgs.position = { X: 1, Y: 1 },
                                evntArgs.enableModal = false,
                                evntArgs.isResponsive = false,
                                evntArgs.enableResize = false,
                                $(filterMenuDivID + "_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                                $(filterMenuDivID).ejDialog(evntArgs);

                                    if (windowWidth < columnFilterPosX + $("#" + filterMenuDiv[0].id).width()) {
                                        columnFilterPosX = columnFilterPosX - columnMenu.width() - $("#" + FilterMenuDiv[0].id).width();
                                    }
                                    filterMenuIndex = columnMenu.find("div.e-columnmenuselection").closest("li").index();
                                    filterMenuPosition = {
                                        X: columnFilterPosX,
                                        Y: proxy._columnMenuPopupY + $("#" + proxy._id + "_FilterChooser").position().top
                                    };
                                    filterMenuInstance.option({ "position": filterMenuPosition });
                                    filterMenuInstance.open();
                                    proxy._updatePreviousFilteredValue(column);
                                    filterMenuDiv.css("z-index", proxy.getMaxZIndex() + 1);
                                    proxy._focusTreeGridElement();
                                    proxy._renderedSubMenuType = filterMenuDivID + "Desktop";
                                }
                        }
                    }
					}
                    break;
				
                //collapse the child task by press left arrow 
                case "leftArrow":
					if (model.allowSelection) {
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        var rowIndex = proxy.selectedRowIndex(),
                        record = updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = false;
                        if (record) {
                            if (record.hasChildRecords && record.expanded) {
                                if (proxy.selectedRowIndex() >= 0) {
                                    isExpandCollapseEnabeled = proxy._trigger("collapsing", args);
                                    if (!isExpandCollapseEnabeled && !model.isFromGantt) {
                                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                                    }
                                    if (model.enableVirtualization)
                                       proxy._focusTreeGridElement();
                                    proxy.updateScrollBar();
                                }
                            }
                        }
                        proxy._cancelSaveTools();
                        if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && (proxy._focusingRowIndex != 0 || proxy._cellIndex != 0)) {
                            proxy._selectNextCell("left", action);
                    }
                    }
                    else if (contextMenu.length)
                        proxy._moveToNextMenuItem("collapse");
                    else if (columnMenu.length && (isVisibleColumnChooserMenu || isVisibleFilterMenu)) {
                        $("#" + proxy._id + "ccDiv").ejDialog("close");
                        proxy._clearFilterMenu();
                    }
					}
                    break;
				
                    //select the previous row by press down arrow key
                case "upArrow":
					if (model.allowSelection) {
					    if (contextMenu.length == 0 && columnMenu.length == 0) {
					       if (proxy._isRowEdit || proxy.model.isEdit)
                                return true;

                            if (model.selectionSettings.selectionMode == "row" && this.selectedRowIndex() > 0 && updatedRecords.length > 0 && model.selectedItem) {
                            var selectedItem = updatedRecords[proxy.selectedRowIndex()];
                            selectingRowIndex = expandedRecords.indexOf(selectedItem);
                            currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                                if (currentSelectingRecord.isSummaryRow)
                                    currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, action);
                                selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                                if (selectingRowIndex !=-1  && !proxy._rowSelectingEventTrigger(this.selectedRowIndex(), selectingRowIndex)) {
                                    proxy.selectRows(selectingRowIndex);
                                    proxy.updateScrollBar();
                                    proxy._focusTreeGridElement();
                                    proxy._rowSelectedEventTrigger(proxy.selectedRowIndex());
                                }
                            proxy._cancelSaveTools();
                        }
                            else if (model.selectionSettings.selectionMode == "cell") {
                                var rowIndex = proxy._focusingRowIndex - 1, cellIndex = proxy._cellIndex,
                                   recordLength = model.flatRecords.length;
                                proxy._isShiftKeyNavigation = false;
                                if (rowIndex != -1) {
                                    var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                                    selectingRowIndex = expandedRecords.indexOf(selectedItem);
                                    currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                                    //To skip the key Navigation from summary row.
                                    if (currentSelectingRecord && currentSelectingRecord.isSummaryRow) {
                                        currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, action);
                                        rowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                                    if (currentSelectingRecord) {
                                   cellInfo = {
                                       rowIndex: rowIndex,
                                       cellIndex: cellIndex
                                   };
                                        proxy._focusingRowIndex = rowIndex;
                                    proxy.selectCells([cellInfo]);
                                        proxy.updateScrollBar();
                                    }

                    }
                            }
                        }
                        else {
                        if (contextMenu.length) {
                            proxy._moveToNextMenuItem("prev");
                        }
                        else if (columnMenu.length) {
                            if (isVisibleColumnChooserMenu) {
                                var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection"),
                                  prevItem = columnChooserMenuItem.prev("div.e-columnMenuListDiv");
                                if (prevItem.length > 0) {
                                    columnChooserMenuItem.removeClass("e-columnmenuselection");
                                    prevItem.addClass("e-columnmenuselection");
                                }
                            }
                            else {
                                var columnMenuItem = columnMenu.find("div.e-columnmenuselection"),
                                    prevItem = proxy._findNextColumnMenuItem(columnMenuItem, "prev");
                                if (prevItem.length > 0) {
                                    columnMenuItem.removeClass("e-columnmenuselection");
                                    prevItem.addClass("e-columnmenuselection");
                                    proxy._clearFilterMenu();
                                }
                            }
                        }
                    }
					}
                    break;
                case "deleteRecord":
                    if (model.readOnly == false && model.editSettings.allowDeleting && contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy._isRowEdit || proxy.model.isEdit) return true;
                        if (proxy.selectedRowIndex() >= 0) {
                            proxy.deleteRow();
                            proxy._cancelSaveTools();
                           proxy._focusTreeGridElement();
                        }
                    }
                    break;
                case "totalRowCollapse":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy.model.isFromGantt) {
                            args = {};
                            args.requestType = "collapseAll";
                            proxy._trigger("expandAllCollapseAllRequest", args);
                        }
                        else
                            proxy.collapseAll();
                        break;
                    }
                case "totalRowExpand":
                    if (contextMenu.length == 0 && columnMenu.length == 0) {
                        if (proxy.model.isFromGantt) {
                            args = {};
                            args.requestType = "expandAll";
                            proxy._trigger("expandAllCollapseAllRequest", args);
                        }
                        else
                            proxy.expandAll();
                    }
                    break;
                case "spaceBar":
                var option = null;
                if (columnMenu.length && isVisibleColumnChooserMenu) {
                    var columnChooserMenuItem = columnChooserMenu.find("div.e-columnmenuselection");
                    option = columnChooserMenuItem.data("column");
                    if (!ej.isNullOrUndefined(option) && !columnChooserMenuItem.find("span").hasClass("e-disable")) {
                        var isColumnVisible = columnChooserMenuItem.find("span").attr("aria-checked");
                        isColumnVisible == "true" ? proxy.hideColumn(option) : proxy.showColumn(option);
                    }
                }
                if (proxy._checkboxSelection && $target.hasClass('e-treegrid') && $("#" + proxy._id + "EditForm").length == 0) {
                    proxy.selectRows(this.selectedRowIndex(), null, true);
                    proxy._cancelSaveTools();
                }
                break;
                case "shiftDownArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var recordLength = updatedRecords.length,                            
                            selectedCellElementLength = proxy._selectedCellDetails.length,
                            nextRowIndex;

                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);
                        if (!currentSelectingRecord)
                            return;
                        nextRowIndex = updatedRecords.indexOf(currentSelectingRecord);                        
                        if (proxy._focusingRowIndex > proxy._rowIndexOfLastSelectedCell) {
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy._selectedCellDetails.sort(function (a, b) {
                                return parseFloat(a.rowIndex) - parseFloat(b.rowIndex);
                            });
                            proxy._getSelectedCellsinARow(proxy._selectedCellDetails[0].data.index, proxy._selectedCellDetails);
                            for (var i = 0; i < proxy._selectedCellsinARow.length; i++) {
                                var selectedCellIndex = proxy._selectedCellDetails.indexOf(proxy._selectedCellsinARow[i]);
                                $(proxy._selectedCellsinARow[i].cellElement).removeClass("e-selectingcell");
                                proxy._selectedCellDetails.splice(selectedCellIndex, 1);
                            }
                            proxy.updateScrollBar();
                        }
                        else if (nextRowIndex < recordLength) {
                            var args = {
                                rowIndex: nextRowIndex,
                                cellIndex: proxy._lastSelectedCellIndex,
                            }
                            proxy.updateScrollBar();
                            proxy._shiftKeySelectCells(args);
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                        }

                    }
                    break;
                case "shiftUpArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var selectedCellElementLength = proxy._selectedCellDetails.length;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, "upArrow");
                        if (!currentSelectingRecord)
                            return;
                        nextRowIndex = updatedRecords.indexOf(currentSelectingRecord);                        
                        if (selectedCellElementLength > 0 && proxy._focusingRowIndex < proxy._rowIndexOfLastSelectedCell) {
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy._getSelectedCellsinARow(proxy._selectedCellDetails[selectedCellElementLength - 1].data.index, proxy._selectedCellDetails);
                            for (var i = 0; i < proxy._selectedCellsinARow.length; i++) {
                                var selectedCellIndex = proxy._selectedCellDetails.indexOf(proxy._selectedCellsinARow[i]);
                                $(proxy._selectedCellsinARow[i].cellElement).removeClass("e-selectingcell");
                                proxy._selectedCellDetails.splice(selectedCellIndex, 1);
                            }
                            proxy.updateScrollBar();
                        }
                        else if (nextRowIndex >= 0) {
                            var args = {
                                rowIndex: nextRowIndex,
                                cellIndex: proxy._lastSelectedCellIndex,
                            }
                            proxy._rowIndexOfLastSelectedCell = nextRowIndex;
                            proxy.updateScrollBar();
                            proxy._shiftKeySelectCells(args);
                        }

                    }
                    break;

                case "shiftRightArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var columnLength = model.columns.length, cellIndex = proxy._lastSelectedCellIndex + 1;
                        if (cellIndex < columnLength - 1 && (!model.columns[cellIndex].visible || !model.columns[cellIndex].allowCellSelection))
                            cellIndex = proxy.getUpNextVisibleColumnIndex(cellIndex);
                        if (cellIndex < columnLength) {

                            var args = {
                                rowIndex: proxy._rowIndexOfLastSelectedCell,
                                cellIndex: cellIndex,
                            }
                            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                            proxy._shiftKeySelectCells(args);
                            proxy._lastSelectedCellIndex = cellIndex;                            
                        }
                    }
                    //proxy.updateScrollBar(proxy._rowIndexOfLastSelectedCell);                    
                    break;
                case "shiftLeftArrow":
                    if (model.allowSelection && model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var cellIndex = proxy._lastSelectedCellIndex - 1;
                        if (cellIndex != -1 && (!model.columns[cellIndex].visible || !model.columns[cellIndex].allowCellSelection))
                            cellIndex = proxy.getPreviousVisibleColumnIndex(cellIndex);
                        var args = {
                            rowIndex: proxy._rowIndexOfLastSelectedCell,
                            cellIndex: cellIndex,
                        }
                        if (cellIndex != -1) {
                            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
                            proxy._shiftKeySelectCells(args);
                            proxy._lastSelectedCellIndex = cellIndex;
                        }
                    }
                    //proxy.updateScrollBar(targetIndex);                    
                    break;

                case "shiftHomeButton":
                    if (model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var rowIndex = proxy._rowIndexOfLastSelectedCell,
                           args = {
                               rowIndex: rowIndex,
                               cellIndex: 0
                           };
                        proxy._cellIndex = 0;
                        proxy._lastSelectedCellIndex = 0;
                        proxy._shiftKeySelectCells(args);

                    }
                    break;
                case "shiftEndButton":
                    if (model.selectionSettings.selectionMode == "cell" && model.selectionSettings.selectionType == "multiple") {
                        var rowIndex = proxy._rowIndexOfLastSelectedCell, columns = model.columns;
                        proxy._cellIndex = columns.length - 1;
                        args = {
                            rowIndex: rowIndex,
                            cellIndex: proxy._cellIndex
                        };
                        proxy._lastSelectedCellIndex = proxy._cellIndex;
                        proxy._shiftKeySelectCells(args);

                    }
                    break;
                default:
                    returnValue = true;
            }

            return returnValue;
        },

        _getNextElement: function ($target, cellIndex) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns;
            $target = $target.closest("td").next("td");
            if (this._frozenColumnsLength > 0 && $target.length == 0) {
                $target = $("#" + proxy._id + "EditForm").find('td').eq(0);
                cellIndex = this._frozenColumnsLength;
            }
            if ((!ej.isNullOrUndefined(columns[cellIndex]) && ej.isNullOrUndefined(columns[cellIndex].allowEditing)) || columns[cellIndex].allowEditing)
                return $target;
            else 
                return proxy._getNextElement($target, cellIndex+1);
        },

        _getPreviousElement: function ($target, cellIndex) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns;
            $target = $target.closest("td").prev("td");
            if (this._frozenColumnsLength > 0 && $target.length == 0)
                $target = $("#" + proxy._id + "EditFrozenForm").find('td').last();            

            if ((!ej.isNullOrUndefined(columns[cellIndex]) && ej.isNullOrUndefined(columns[cellIndex].allowEditing)) || columns[cellIndex].allowEditing)
                return $target;
            else 
                return proxy._getPreviousElement($target, cellIndex - 1);
        },
        _clearAllFilter: function (fieldName) {
            var proxy = this, column = proxy.model.filterSettings.filteredColumns[0];
            proxy.model.allowFiltering = true;
            proxy.model.filterSettings.filteredColumns = [];
            proxy.filterColumn(column.field, column.operator, "", "and");
            proxy._filteredColumnValue = [];
            proxy._filteredColumnValueID = [];
        },

        //Method to bind all the filter condition and splice the over writed condition.
        filterColumn: function (fieldName, filterOperator, filterValue, predicate, matchcase, actualFilterValue) {
           
            var proxy = this,
                model = proxy.model,
                filteredColumns = model.filterSettings.filteredColumns;
            if (!this.model.allowFiltering)
                return;
            var args = {};
            ej.TreeGrid.Actions.Filter = "filtering";
            args.requestType = ej.TreeGrid.Actions.Filter;
            args.currentFilterObject = [];           
            if (!$.isArray(filterOperator))
                filterOperator = $.makeArray(filterOperator);
            if (!$.isArray(filterValue))
                filterValue = $.makeArray(filterValue);
            var firstLoop = false;
            var filterCol = this._filterCollection;
            if (ej.util.isNullOrUndefined(this._currentFilterColumn))
                this._currentFilterColumn = this.getColumnByField(fieldName);
            for (var index = 0; index < filterOperator.length; index++) {
                    var filterObject = {
                        field: fieldName,
                        operator: filterOperator[index],
                        value: filterValue[index],
                        matchcase: matchcase,
                        predicate: predicate,
                        actualFilterValue: actualFilterValue
                    };
                this._$colType = "string";
                if (filteredColumns.length == 0 && filterObject.value !== "") {
                    if (this._$colType == "date" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                        this._setDateFilters(filterObject);
                    else
                        filteredColumns.push(filterObject);
                } else {
                    var proxy = this;
                    if (!firstLoop) {
                        var dataManger = ej.DataManager(filteredColumns);
                        var query = new ej.Query().where("field", ej.FilterOperators.equal, filterObject.field);
                        var object = dataManger.executeLocal(query);
                        for (var i = 0; i < object.length; i++) {
                            var objectIndex = $.inArray(object[i], filteredColumns)
                            if (objectIndex != -1)
                                filteredColumns.splice(objectIndex, 1);
                        }
                    }
                    if (filterObject.value !== "") {
                        if (this._$colType == "date" && (filterOperator == "equal" || filterOperator == "notequal") && typeof (filterObject.value) !== "string")
                            this._setDateFilters(filterObject);
                        else
                            filteredColumns.push(filterObject);
                    }
                }
                firstLoop = true;
                args.currentFilterObject.push(filterObject);
            }
            args.filterCollection = filteredColumns;
            args.currentFilteringColumn = fieldName;
            args.fieldName = fieldName;
            var returnValue = this.processBindings(args);
            if (returnValue) {
                filteredColumns.reverse().splice(0, filterOperator.length);
                filteredColumns.reverse();
            }
        },

        _cellSelectingEventTrigger: function (selectedCellInfo) {
            var proxy = this,
               model = proxy.model,
               args = {}, targetIndex = selectedCellInfo.rowIndex,
               currentCellIndex = selectedCellInfo.cellIndex,
               updatedRecords = proxy.getUpdatedRecords();
            args.data = updatedRecords[targetIndex];
            args.targetRow = selectedCellInfo.rowElement;
            args.targetCell = selectedCellInfo.cellElement;
            args.rowIndex = targetIndex;
            args.cellIndex = currentCellIndex;
            return proxy._trigger('cellSelecting', args);
        },
        _cellSelectedEventTrigger: function (selectedCellInfo, previousSelectedCellDetails) {
            var proxy = this,
                model = proxy.model,
                args = {}, targetIndex = selectedCellInfo.rowIndex,
                currentCellIndex = selectedCellInfo.cellIndex,
                previousRowIndex = previousSelectedCellDetails.rowIndex,
                previousCellIndex = previousSelectedCellDetails.cellIndex,
                updatedRecords = proxy.getUpdatedRecords();

            //previousSelectedCellDetails
            args.PreviousTargetRow = previousSelectedCellDetails.rowElement;
            args.previousTargetCell = previousSelectedCellDetails.cellElement;
            args.previousData = updatedRecords[previousRowIndex];
            args.previousRowIndex = previousRowIndex;
            args.previousCellIndex = previousCellIndex;
            //currentSelectedCellDetails
            args.data = updatedRecords[targetIndex];           
            args.targetRow = selectedCellInfo.rowElement;
            args.targetCell = selectedCellInfo.cellElement;
            args.rowIndex = targetIndex;
            args.cellIndex = currentCellIndex;
            return proxy._trigger('cellSelected', args);
        },

        //ROWSELECTING EVENT METHOD
        _rowSelectingEventTrigger: function (previousIndex, currentIndex) {

            var proxy = this,
                model = proxy.model,
                args = {},
                selectedItem,
                $gridRows,
                updatedRecords = proxy.getUpdatedRecords();
                args.targetRow = ej.TreeGrid.getRowByIndex(proxy, currentIndex);
                args.previousTreeGridRow = ej.TreeGrid.getRowByIndex(proxy, previousIndex);
                args.data = updatedRecords[currentIndex];
                args.previousData = updatedRecords[previousIndex];
                args.recordIndex = currentIndex;
                args.previousIndex = previousIndex;
                if (proxy.model.isFromGantt) {
                    args.target = "ejTreeGrid";
                }
                var isCancel = proxy._trigger('rowSelecting', args);
				if (isCancel)
                    model.selectedItem = args.data;
                return isCancel;
        },


        //ROWSELECTED EVENT METHOD
        _rowSelectedEventTrigger: function (index) {

            var proxy = this, model = proxy.model,
                args = {}, updatedRecords = proxy.getUpdatedRecords();
            var record = $.extend({}, updatedRecords[index]);
            /*Remove childRecords and parentItem from record object, 
              To avoid the cyclic dependency when performing postback action in ASP.NET */
            delete record.childRecords;
            delete record.parentItem;

            args = {
                targetRow: ej.TreeGrid.getRowByIndex(proxy, index),
                recordIndex: index
            };
            if (proxy.model.isFromGantt) {
                args.target = "ejTreeGrid";
                args.data = model.updatedRecords[index];
            }
            else
                args.data = record;

                proxy._trigger("rowSelected", args);
        },


        //QUERYCELLINFO,ROWDATABOUND EVENT BINDING FOR TREEGRID
        _eventBindings: function (data) {

            var proxy = this,
                model = proxy.model,
                count = 0,
                row, updatedRecords = proxy.getUpdatedRecords(),
                gridRows = proxy.getRows(),
                length;
            
            if (ej.isNullOrUndefined(data)) {
                length = this._frozenColumnsLength > 0 ? $(gridRows[0]).length : $(gridRows).length;
                data = model.currentViewData;
            }
            else
                length = data.length;
            if (proxy._commandColumnLength > 0) {
                this._refreshUnboundTemplate(this.getContentTable());
            }
            if (model.queryCellInfo != null || model.rowDataBound != null || model.detailsDataBound) {

                for (count; count < length; count++) {
                    var rowIndex = updatedRecords.indexOf(data[count]);
                    row = ej.TreeGrid.getRowByIndex(this, rowIndex);
                    proxy._rowEventTrigger(row,data[count]);
                }
            }
        },

        //ROWDATABOUND EVENT TRIGGER
        _rowEventTrigger: function (row, data) {

            var proxy = this,
                model = this.model;

            if (model.rowDataBound) {
                proxy._trigger("rowDataBound", {
                    rowElement: row,
                    data: data
                });
            }
           
            var tdCells = row.cells,
                $tdRowcells = $(row).find(".e-rowcell"),
                cellIndex = 0,
                length = $tdRowcells.length,
                column=null,
                columns = proxy.model.columns;
            if (model.queryCellInfo) {
                for (cellIndex; cellIndex < length; cellIndex++) {

                    if ($($tdRowcells[cellIndex]).hasClass("e-rowcell")) {
                        column = columns[cellIndex];
                    }

                    if (column) {
                        proxy._cellEventTrigger($tdRowcells[cellIndex], data, column);
                    }
                }
            }

            if (model.detailsDataBound && $(row).next("tr").hasClass("e-detailsrow")) {
                var detailsRowElement = $(row).next("tr");
                if (this._frozenColumnsLength > 0)
                    detailsRowElement = $(detailsRowElement[1]);
                this._trigger("detailsDataBound", { detailsElement: detailsRowElement, data: data });
            }
        },


        //QUERYCELLINFO EVENT TRIGGER
        _cellEventTrigger: function (cell, data, column) {

            var args = {
                cellElement: cell,
                data: data,
                column: column,

            };
            args.cellValue = args.column && this._getCustomCellValue(data, args.column.field);
            this._trigger("queryCellInfo", args);
        },


        //ACTION COMPLETE EVENT TRIGGER
        _completeAction: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns,
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");

            model.isEdit = false;

            if (model.allowPaging && args.requestType != ej.TreeGrid.Actions.Scroll)
                this._refreshGridPager();
            if ((ej.TreeGrid.Actions.Sorting == args.requestType && model.allowSorting)
                || (ej.TreeGrid.Actions.Refresh == args.requestType)) {

                if (model.allowSorting) {

                    if (!proxy._multiSortRequest) {
                        proxy.getHeaderTable().find(".e-columnheader").
                            find(".e-headercelldiv").find(".e-ascending,.e-descending").remove();

                        proxy.getHeaderTable().find("[aria-sort]").removeAttr("aria-sort");
                    }

                    for (var i = 0; i < sortcolumns.length; i++) {
                        proxy._addSortElementToColumn(sortcolumns[i].field, sortcolumns[i].direction);
                    }

                }

                proxy._multiSortRequest = false;
            } else if (ej.TreeGrid.Actions.BeginEdit == args.requestType || ej.TreeGrid.Actions.Add == args.requestType) {

                var $form = $("#" + proxy._id + "EditForm");

                proxy.model.isEdit = true;
                proxy.setWidthToColumns();

                if (ej.TreeGrid.Actions.Add == args.requestType) {

                    $form.find(".e-field:disabled").not(".e-identity").removeAttr("disabled").removeClass("e-disable");

                }

                if ($.isFunction($.validator))
                    this._initValidator();
            }
            else if (model.isFromGantt && args.requestType === ej.TreeGrid.Actions.Scroll)
            {
                proxy._updateCurrentViewData();
            }
            if (model.isFromGantt)
                ganttObject.model.sortSettings = model.sortSettings;
            proxy._trigger("actionComplete", args);
        },


        //#endregion

        //#region METHOD FOR DATA PROCESSING

        //RENDERING THE DATA
        sendDataRenderingRequest: function (args) {

            var proxy = this, model = this.model,
                temp, data;
            if (proxy.model.currentViewData.length) {

                switch (args.requestType) {

                    case ej.TreeGrid.Actions.Delete:
                    case ej.TreeGrid.Actions.Refresh:
                    case ej.TreeGrid.Actions.Save:
                    case ej.TreeGrid.Actions.Filter:
                    case ej.TreeGrid.Actions.Sorting:
                    case ej.TreeGrid.Actions.Searching:
                    case ej.TreeGrid.Actions.ExpandCollapse:
                    case ej.TreeGrid.Actions.RefreshDataSource:
                    case ej.TreeGrid.Actions.DragAndDrop:
                    case ej.TreeGrid.Actions.Paging:
                    case ej.TreeGrid.Actions.Scroll:

                        temp = document.createElement('div');
                       

                        if (args.requestType != ej.TreeGrid.Actions.Scroll) {
                            if (this._frozenColumnsLength > 0) {
                                proxy._renderFrozenRecords();

                            }
                            else {
                                proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                                var $tbody = proxy.getContentTable().children('tbody');
                                $tbody.empty();

                                temp.innerHTML = ['<table>', $.render[proxy._id + "_Template"](proxy.model.currentViewData), '</table>'].join("");

                                proxy.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                                    proxy.getContentTable().get(0).lastChild);
                                proxy.setGridRows($(proxy.getContentTable().get(0).rows));
                            }
                        }
                        else {
                            var $tbody = proxy.getContentTable().children('tbody'),
                                                           currentViewData = proxy.model.currentViewData,
                                                           visibleRange = proxy._visibleRange,
                                                           length = this._frozenColumnsLength > 0 ? $($tbody[0]).children("tr:not(.e-detailsrow)").length : $tbody.children("tr:not(.e-detailsrow)").length, isTopToBottom = false;
                            if (proxy._scrollTop > proxy._prevScrollTop) {
                                var removeLength = visibleRange.top - proxy._prevRTop,
                                     addLength = visibleRange.bottom - proxy._prevRBottom,
                                     data;
                                if (addLength >= 0) {
                                    data = addLength ? currentViewData.slice(-addLength) : [];
                                } else {
                                    if (this._frozenColumnsLength > 0) {
                                        $($tbody.get(0)).children(":visible:gt(" + (length + (addLength - 1)) + ")").remove();
                                        $($tbody.get(1)).children(":visible:gt(" + (length + (addLength - 1)) + ")").remove();
                                    } else {
                                        if (model.showDetailsRow && !model.showDetailsRowInfoColumn) {
                                            var childLength = 2 * (length + (addLength - 1));
                                            $tbody.children(":visible:gt(" + childLength + ")").remove();
                                        }
                                        else
                                            $tbody.children(":visible:gt(" + (length + (addLength - 1)) + ")").remove();    
                                    }
                                    data = [];
                                }
                                isTopToBottom = true;
                            }
                            else {
                                var removeLength = length - (proxy._prevRBottom - visibleRange.bottom + 1),
                                      addLength = proxy._prevRTop - visibleRange.top, data;
                                if (addLength >= 0) {
                                    data = currentViewData.slice(0, addLength);
                                } else {
                                    data = [];
                                }
                                removeLength = removeLength >= 0 ? removeLength : (-length - 1);
                                
                                isTopToBottom = false;
                            }                            
                            if (this._frozenColumnsLength > 0) {
                                proxy._renderFrozenRecords(data, addLength, removeLength, isTopToBottom);
                            }
                            else {
                                proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                                if (isTopToBottom) {
                                    if (model.showDetailsRow && !model.showDetailsRowInfoColumn) {
                                        var childLength = 2 * removeLength;
                                        $tbody.children(":visible:lt(" + childLength + ")").remove();
                                    }
                                    else
                                        $tbody.children(":visible:lt(" + removeLength + ")").remove();
                                    var dataHtml = $.render[proxy._id + "_Template"](data);
                                    $tbody.append(dataHtml);
                                }
                                else {
                                    if (model.showDetailsRow && !model.showDetailsRowInfoColumn) {
                                        var childLength = 2 * removeLength + 1;
                                        $tbody.children(":visible:gt(" + childLength + ")").remove();
                                    }
                                    else
                                        $tbody.children(":visible:gt(" + removeLength + ")").remove();
                                    var dataHtml = $.render[proxy._id + "_Template"](data);
                                    $tbody.prepend(dataHtml);
                                }
                                proxy._gridRows = proxy.getContentTable().find("tr");
                                proxy.setGridRows(proxy._gridRows);
                            }
                        }
                        this._gridRows = this.getContentTable().get(0).rows;
                        if (this._frozenColumnsLength > 0)
                            this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

                        /* check treee grid rows are append in DOM and Trigger refresh and querycellInfo events */
                        if (proxy._$gridContent && proxy._isRendered){
                            proxy._trigger("refresh");
                            proxy._eventBindings(data);
                            this._hideCollapsedDetailsRows();
                            proxy.getScrollElement().ejScroller("refresh");
                            proxy._updateScrollCss();
                        }
                        break;
                }

            } else {
                if (proxy._frozenColumnsLength > 0) {
                    var $emptyTd = ej.buildTag('td', model.emptyRecordText, {}, { colSpan: this._frozenColumns.length }), doc = document;
                    proxy.getContent().find("#e-frozencontentdiv" + proxy._id + " .e-table tbody").empty().append($(doc.createElement("tr")).append($emptyTd));
                    $emptyTd = ej.buildTag('td', model.emptyRecordText, { visibility: "hidden" }, { colSpan: this._unFrozenColumns.length });
                    proxy.getContent().find("#e-movablecontentdiv" + proxy._id + " .e-table tbody").empty().append($(doc.createElement("tr")).append($emptyTd));
                    proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", "30px");
                } else {
                    proxy.getContentTable().find('tbody').empty().append(proxy._getEmptyTbody());
                    proxy._$gridContainer && proxy._$gridContainer.css({ height: "30px" }); // for render no record text
                }
                proxy._gridRows = null;
                proxy.setGridRows(null);

            }

            if (proxy.model.showGridCellTooltip || proxy.model.showGridExpandCellTooltip) {
                proxy._cellMouseLeave();
                proxy._headerMouseLeave();
            }

            if (args.requestType == ej.TreeGrid.Actions.Scroll)
                args.requestType == ej.TreeGrid.Actions.Refresh;

            proxy._completeAction(args);

        },
        _renderFrozenRecords: function (data, addLength, removeLength, isTopToBottom)
        {
            /* Update colgroup of frozen and movable tables while rendering records*/
            this.getContent().find("#e-frozencontentdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[0]);
            this.getContent().find("#e-movablecontentdiv" + this._id + " .e-table colgroup").replaceWith(this._getMetaColGroup()[1]);
            var $tbody = this.getContentTable().children('tbody'), temp;
            

            if (ej.isNullOrUndefined(data)) {
                $tbody.empty();
                /*Render frozen Table*/
                temp = document.createElement('div');
                temp.innerHTML = ['<table>', $.render[this._id + "_JSONFrozenTemplate"](this.model.currentViewData),
                    '</table>'].join("");
                this.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                    this.getContentTable().get(0).lastChild);
                /*Render movable Table*/
                temp = document.createElement('div');
                temp.innerHTML = ['<table>', $.render[this._id + "_Template"](this.model.currentViewData),
                    '</table>'].join("");
                this.getContentTable().get(1).replaceChild(temp.firstChild.firstChild,
                    this.getContentTable().get(1).lastChild);
            }
            else {
                if (isTopToBottom) {
                    if (this.model.showDetailsRow && !this.model.showDetailsRowInfoColumn) {
                        var childLength = 2 * removeLength;
                        $($tbody.get(0)).children(":visible:lt(" + childLength + ")").remove();
                        $($tbody.get(1)).children(":visible:lt(" + childLength + ")").remove();
                    }
                    else {
                        $($tbody.get(0)).children(":visible:lt(" + removeLength + ")").remove();
                        $($tbody.get(1)).children(":visible:lt(" + removeLength + ")").remove();
                    }
                    var frozenHtml = $.render[this._id + "_JSONFrozenTemplate"](data);
                    var moveHtml = $.render[this._id + "_Template"](data);
                    $($tbody.get(0)).append(frozenHtml);
                    $($tbody.get(1)).append(moveHtml);
                }
                else {
                    if (this.model.showDetailsRow && !this.model.showDetailsRowInfoColumn) {
                        var childLength = 2 * removeLength + 1;
                        $($tbody.get(0)).children(":visible:gt(" + childLength + ")").remove();
                        $($tbody.get(1)).children(":visible:gt(" + childLength + ")").remove();
                    }
                    else {
                        $($tbody.get(0)).children(":visible:gt(" + removeLength + ")").remove();
                        $($tbody.get(1)).children(":visible:gt(" + removeLength + ")").remove();
                    }
                    var frozenHtml = $.render[this._id + "_JSONFrozenTemplate"](data);
                    var moveHtml = $.render[this._id + "_Template"](data);
                    $($tbody.get(0)).prepend(frozenHtml);
                    $($tbody.get(1)).prepend(moveHtml);
                }
            }

            this.setGridContentTable(this.getContent().find(".e-table"));
        },

        _renderByFrozenDesign: function () {
            var $div = $(document.createElement('div')), col = this._getMetaColGroup().find("col"), colgroups = {};
            colgroups["colgroup1"] = $div.append(ej.buildTag("colgroup").append(col.splice(0, this._frozenColumnsLength))).html();
            colgroups["colgroup2"] = $div.html(ej.buildTag("colgroup").append(col)).html();
            return $.render[this._id + "_FrozenTemplate"](colgroups);
           
        },
        addFrozenTemplate: function () {
            var template = "<div class='e-frozencontainer' id='e-frozencontainer" + this._id + "' style='overflow:hidden;float:left;'><div class='e-frozencontentdiv' id='e-frozencontentdiv" + this._id + "' style='width:100%;'>"
            + "<table class='e-table e-zerospace' style='width:100%' id='" + this._id + "frozene-table'>{{:colgroup1}}<tbody>"
            + "</tbody></table></div></div>"
            + "<div class='e-movablecontainer' id='e-movablecontainer" + this._id + "'><div class='e-movablecontent' id='e-movablecontent" + this._id + "'><div class='e-movablecontentdiv' id='e-movablecontentdiv" + this._id + "'><table class='e-table e-zerospace' id='" + this._id + "movablee-table'>{{:colgroup2}}<tbody>"
            + "</tbody></table></div></div></div>", templates = {};
            templates[this._id + "_FrozenTemplate"] = template;
            $.templates(templates);
        },
       

        //Public method to change the allowSorting value dynamically.
        sortSetting: function (value) {
            var proxy = this, model = this.model,
                ascendingIcon = $("#" + proxy._id).find(".e-ascending.e-icon"),
                descendingIcon = $("#" + proxy._id).find(".e-descending.e-icon");
            model.allowSorting = value;
            if (!model.allowSorting)
                proxy.clearSorting();
                if (ascendingIcon.length > 0) {
                    for (var length = 0 ; length < ascendingIcon.length; length++) {
                        $(ascendingIcon[length]).css("visibility", "hidden");
                    }
                }                                      
            if (descendingIcon.length > 0)
                for (var length = 0 ; length < descendingIcon.length; length++) {
                    $(descendingIcon[length]).css("visibility", "hidden");
                }
        },
        //Public method to change the treeColumnIndex value dynamically.
        columnIndex:function(value){
            var proxy = this, model = proxy.model;
            if (!isNaN(parseInt(value)) && parseInt(value) >= 0 && parseInt(value) < model.columns.length) {
                model.treeColumnIndex = parseInt(value);
                proxy._addInitTemplate();
                this.renderRecords();
                if (model.showColumnChooser)
                    proxy._renderColumnChooserList(true);
            }
            proxy._updateWrapRowHeights("header","refreshAll");
        },


        //SORTING THE DATA BASED ON THE PARTICULAR FIELDS
        
        sortColumn: function (columnName, columnSortDirection) {

            var proxy = this,
                model = proxy.model,
                sortColumns = model.sortSettings.sortedColumns,
                args = {},
                column,
                count = 0,
                length = sortColumns.length;
            /* Cancel edited cell before sort the column*/
            proxy._cancelEditState();
            proxy.clearSelection();
            if (model.isFromGantt)
                column = ej.TreeGrid.getColumnByMappingName(model.columns, columnName);
            if (ej.isNullOrUndefined(column))
                column = this.getColumnByField(columnName);
            if (!model.allowSorting || ej.isNullOrUndefined(column) || column.allowSorting == false) {
                return;
            }

            if (!proxy._multiSortRequest) {
                model.sortSettings.sortedColumns = [];
            }

            args.requestType = ej.TreeGrid.Actions.Sorting;
            args.columnName = columnName;

            // proxy._cSortedColumn = proxy.getFieldNameByHeaderText(columnName);

            proxy._cSortedColumn = columnName;

            proxy._cSortedDirection = args.columnSortDirection = columnSortDirection === undefined ?
                ej.sortOrder.Ascending : columnSortDirection;

            for (count; count < length; count++) {
                
                if (sortColumns[count].field == proxy._cSortedColumn) {
                    sortColumns.splice(count, 1);
                    break;
                }

            }

            model.sortSettings.sortedColumns.push({
                field: proxy._cSortedColumn,
                direction: proxy._cSortedDirection
            });

            var returnValue = proxy.processBindings(args);

            if (returnValue) {

                proxy._cSortedDirection = proxy._cSortedColumn = null;

            }
            if (proxy.selectedRowIndex() >= 0 && proxy._isRendered) {
                proxy.selectedRowIndex(proxy._sortedRecords.indexOf(this.selectedItem()));
            }
            proxy._clearColumnMenu();
        },


        //Clear the sorting
        clearSorting: function()
        {
            var proxy = this,
                model = proxy.model;
            model.sortSettings.sortedColumns = [];
            var args = {};
            args.requestType = ej.TreeGrid.Actions.Sorting;
            proxy.processBindings(args);
        },


        //DELETE THE PARTICULAR RECORD AND MULTIPLE RECORD
        deleteRow: function ($tr, isFromContextmenu, index) {

            var proxy = this,
                deletedRowIndex,
                deletedRow,
                args = {},
                eveArgs = {},
                model = proxy.model,
                selectedItems = $.extend([],model.selectedItems),
                length = isFromContextmenu ? 1 : selectedItems.length,
                updatedRecords = proxy.getUpdatedRecords();
            
            if (proxy._isEmptyRow && model.selectionSettings.selectionMode == "cell")
                length = 1;
            if (!model.editSettings.allowDeleting || length == 0)
                return false;

            for (var del = 0; del < length; del++) {
                if (model.isFromGantt && isFromContextmenu)
                    args.data = updatedRecords[index];
                else if (proxy._checkboxSelection && isFromContextmenu) {
                    args.data = model.selectionSettings.selectionMode == "row" ? model.selectedItem : updatedRecords[proxy._rowIndexOfLastSelectedCell];
                }
                else
                args.data = model.selectionSettings.selectionMode == "row" ? selectedItems[del] : updatedRecords[proxy._rowIndexOfLastSelectedCell];
                deletedRow = args.data;
                if (proxy.model.enableWBS) {
                    var dataRows, targetRowIndex, isUpdateWBS = false;
                    if (deletedRow && deletedRow.parentItem) {
                        dataRows = deletedRow.parentItem.childRecords,
                        targetRowIndex = dataRows.indexOf(deletedRow);
                    } else if (model.flatRecords.length) {
                        var flatData = model.flatRecords,
                            Level0 = flatData.filter(function (item) {
                                return item && item.level == 0;
                            });
                        dataRows = Level0;
                        targetRowIndex = dataRows.indexOf(deletedRow);
                    }
                    if (targetRowIndex != dataRows.length - 1)
                        isUpdateWBS = true;
                }
                if (model.flatRecords.indexOf(args.data) != -1) {
                    args.requestType = ej.TreeGrid.Actions.Delete;
                    args.isFromContextmenu = isFromContextmenu;
                    proxy._selectedCellDetails = [];
                    if (proxy._removeRecords(args))
                        return true;            
            }
                if (isUpdateWBS) {
                    var targetRow;
                    if (deletedRow.parentItem)
                        targetRow = dataRows[targetRowIndex];//Here we are having the updated 'dataRows'
                    else {
                        //for level 0 records
                        dataRows.splice(targetRowIndex, 1);
                        targetRow = dataRows[targetRowIndex];
            }
                    proxy.updateWBSdetails(targetRow);
                }
            }

            proxy._ensureDataSource(args);
            proxy.updateHeight();
            if (model.currentViewData.length > 0 && model.enableAltRow)
                ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

            if (proxy._checkboxSelection) {                
                model.selectedCellIndexes = [];
                proxy._prevSelectedItems = null;
                if (!isFromContextmenu)
                    model.selectedItems = [];
                model.selectedItem = null;
                proxy.selectedRowIndex(-1);
                proxy.selectAllRows();
            }
            else {
                model.selectedItems = [];
                model.selectedCellIndexes = [];
                model.selectedItem = null;
				proxy.selectedRowIndex(-1);
                proxy._prevSelectedItems = null;
				if (this._multiSelectPopup && this._multiSelectPopup.is(":visible") && !proxy.model.isFromGantt)
				proxy._clearMultiSelectPopup();
            }
            if (proxy._isLoadonDemand && model.allowPaging)
                proxy._refreshDataSource();
        },
		//Delete selected records
        _removeRecords: function(args){
            var proxy = this,
                model = proxy.model,
                dataSource =this.dataSource();
            if (args && (model.editSettings.allowDeleting || args.isDragAndDropDelete) && args.requestType === ej.TreeGrid.Actions.Delete) {
                var deletedRow = args.data,
                    recordIndex, rowindex;

                if (proxy._trigger("actionBegin", args)) {
                    return true;
                }

                recordIndex = model.flatRecords.indexOf(deletedRow);                

                if (deletedRow.parentItem) {

                    var childRecords = deletedRow.parentItem.childRecords,
                    childIndex = childRecords.indexOf(deletedRow);

                    deletedRow.parentItem.childRecords.splice(childIndex, 1);
                    //Delete the summary row of one parent after deleted the all child records of the parent
                    if (model.showSummaryRow) {
                        var summaryRowLength = model.summaryRows.length;
                        if (summaryRowLength == childRecords.length) {
                            deletedRow.parentItem.childRecords.splice(0, summaryRowLength);
                            model.flatRecords.splice(recordIndex, summaryRowLength);
                        }
                    }
                    if (!model.parentIdMapping)
                        deletedRow.parentItem.item[model.childMapping].splice(childIndex, 1);
                }

                if (proxy._checkboxSelection && !args.isDragAndDropDelete) {
                    if (args.isFromContextmenu)
                        proxy._removeChildRecords(model.selectedItems, args.data);
                    else {
                        while (model.selectedItems.length > 0) {
                            proxy._removeChildRecords(model.selectedItems, model.selectedItems[0]);
                        }
                    }
                }

                //Delete from parent collection if item is parent
                var parentIndex=model.parentRecords.indexOf(deletedRow);
                if (parentIndex!== -1)
                {
                    model.parentRecords.splice(parentIndex, 1);
                }
                
                if (recordIndex !== -1) {
                    var deletedRecordCount = proxy.getChildCount(deletedRow, 0);
                    model.flatRecords.splice(recordIndex, deletedRecordCount + 1);
                    model.ids && model.ids.splice(recordIndex, deletedRecordCount + 1);                    
                }

                model.updatedRecords = model.enableVirtualization ? proxy.getExpandedRecords(model.flatRecords) : model.flatRecords.slice();
                proxy.updateCollapsedRecordCount();                                
                
                if(!model.parentIdMapping)
                {
                    if (dataSource instanceof ej.DataManager) {
                        if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                            rowindex = dataSource.dataSource.json.indexOf(deletedRow.item);
                            if (rowindex !== -1)
                                dataSource.dataSource.json.splice(rowindex, 1);
                        }
                        else if (proxy._isDataManagerUpdate) {
                            rowindex = proxy._jsonData.indexOf(deletedRow.item);
                            proxy._jsonData.splice(rowindex, 1);
                        }
                    } else {
                        rowindex = dataSource.indexOf(deletedRow.item);
                        if (rowindex !== -1)
                            dataSource.splice(rowindex, 1);
                    }
                }
                else
                {
                    //remove child item
                    if (deletedRow.hasChildRecords && deletedRow.childRecords.length > 0)
                    {
                        proxy._removeChildItem(deletedRow);
                    }
                    //remove deleting item

                    if (dataSource instanceof ej.DataManager) {
                        if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                            var idx = dataSource.dataSource.json.indexOf(deletedRow.item);
                            if (idx !== -1)
                                dataSource.dataSource.json.splice(idx, 1);
                        }
                        else if (proxy._isDataManagerUpdate) {
                            var idx = proxy._jsonData.indexOf(deletedRow.item);
                            if (idx !== -1)
                                proxy._jsonData.splice(idx, 1);
                        }
                    }
                    else
                    {
                        var idx = dataSource.indexOf(deletedRow.item);
                        if (idx !== -1)
                            dataSource.splice(idx, 1);
                    }
                }
                
                if (deletedRow.parentItem)
                    if (deletedRow.parentItem.childRecords.length == 0) {
                        deletedRow.parentItem.expanded = false;
                        deletedRow.parentItem.hasChildRecords = false;
                        deletedRow.parentItem.hasFilteredChildRecords = false;
                    }
                //Update the summary and total summary row after deleted a record.
                if (model.showSummaryRow)
                    proxy._updateSummaryRow(args);
                if (model.showTotalSummary)
                    proxy._updateTotalSummaryRow(args);
            }
        },

        /*Update the WBS value of all the records that are below the newly added row*/
        updateWBSdetails: function (delTargetRow) {
            var proxy = this,
                model = proxy.model,
                dataW = delTargetRow,
                newWBS = dataW["WBS"];

            //Updating the WBS value of other records that are below the newly added row
            var childItems, markedIndex, markedRecords, dataS, dataLength;
            if (dataW.parentItem) {
                childItems = dataW.parentItem.childRecords;
                markedIndex = childItems.indexOf(dataW);
                dataS = childItems;
                dataLength = dataS.length;
            } else if (model.flatRecords.length) {
                var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                dataS = Level0;
                markedIndex = dataS.indexOf(dataW);
                dataLength = dataS.length;
            }
            markedRecords = dataS.slice(markedIndex, dataLength);
            if (markedRecords.length) {
                var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                    parentVal = dataW.parentItem ? dataW.parentItem.WBS : null;
                lastVal--;
                proxy.reCalculateWBS(markedRecords, lastVal, parentVal);
            }
        },

        /* To recalculate the WBS value */
        reCalculateWBS: function (selectedRecords, lastDigit, parentWBS) {
            var proxy = this, model = proxy.model,
                cViewData = model.currentViewData, final,
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt"),
                previousVaue = "";

            if (parentWBS) {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = lastDigit + i;
                    previousVaue = selectedRecords[i]["WBS"];
                    selectedRecords[i]["WBS"] = parentWBS + "." + final;
                    selectedRecords[i]["item"]["WBS"] = parentWBS + "." + final;
                    if (model.enableWBSPredecessor)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    if (previousVaue != selectedRecords[i]["WBS"])
                        ganttObject.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i])
                }
            }
            else {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = (lastDigit + i).toString();
                    previousVaue = selectedRecords[i]["WBS"];
                    selectedRecords[i]["WBS"] = final;
                    selectedRecords[i]["item"]["WBS"] = final;
                    if (model.enableWBSPredecessor)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    if (previousVaue != selectedRecords[i]["WBS"])
                        ganttObject.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i])
                }
            }
        },

        _updateChildWBS: function (parentRecord) {
            var proxy = this, model = proxy.model,
                cViewData = model.currentViewData,
                childRecs = parentRecord.childRecords,
                pWBS = parentRecord["WBS"],
                ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt"),
                previousValue = "";
            for (var c = 0; c < childRecs.length; c++) {
                previousValue = childRecs[c]["WBS"];
                childRecs[c]["WBS"] = pWBS + "." + (c + 1);
                childRecs[c]["item"]["WBS"] = pWBS + "." + (c + 1);
                if (model.enableWBSPredecessor)
                    proxy._getPredecessorIds(childRecs[c]);
                if (previousValue != childRecs[c]["WBS"])
                    ganttObject.refreshGanttRecord(childRecs[c]);
                if (childRecs[c].hasChildRecords) {
                    proxy._updateChildWBS(childRecs[c]);
                }
            }
        },

        /*Get all the predecessor rows that are matching the taskId*/
        _getPredecessorIds: function (pData) {
            var proxy = this,
                model = proxy.model,
                dataTID = pData.taskId,
                flatDatas = model.flatRecords,
                updatedRecs = model.updatedRecords,
                targetRecords = flatDatas.filter(function (item) {
                    if (item["predecessorsName"]) {
                        var prdcList = item["predecessorsName"].split(',');
                        for (var p = 0; p < prdcList.length; p++) {
                            var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                                refId = +ref[0];
                            if (refId == dataTID)
                                return item;
                        }
                    }
                });
            for (var t = 0; t < targetRecords.length; t++) {
                proxy.updateWBSPredecessor(targetRecords[t]);
                proxy.refreshRow(updatedRecs.indexOf(targetRecords[t]));
            }
        },

        //SEARCH THE TASK FROM TREE GRID CONTROL

        

        search: function (searchString) {

            var proxy = this,
                args = {};

            args.requestType = ej.TreeGrid.Actions.Searching;
            args.keyValue = searchString;

            proxy._searchString = searchString;

            proxy.processBindings(args);
        },

        //SEND SAVE REQUEST
        endEdit: function () {

            var proxy = this;

            if (proxy.model.editSettings.editMode.toLowerCase() == "cellediting" && !proxy._isRowEdit) {
                if (!this.editFormValidate())
                    return true;
                return proxy.saveCell();
            } else if (proxy.model.editSettings.editMode.toLowerCase() == "dialogediting") {
                return proxy.saveRow();
            }

            return true;

        },
        updateReadOnly:function(bool){
            var proxy=this;
            proxy.model.readOnly = bool;           
           
        },
        updateShowGridExpandCellTooltip: function (bool) {
            var proxy = this;
            proxy.model.showGridExpandCellTooltip = bool;
            proxy.refreshContent();
        },
        updateShowGridCellTooltip: function (bool) {
            var proxy = this;
            proxy.model.showGridCellTooltip = bool;
            proxy.refreshContent();
        },

        //#endregion

        //#region PUBLIC METHODS

        //CALCULATE THE VISIBLE RANGE OF RECORDS TO DISPLAYED IN CURRENT VIEWPORT
        getVisibleRange: function (type) {

            var proxy = this,
                model = this.model,
                calcHeight = (model.rowHeight + proxy._detailsRowHeight),
                topIndex, bottomIndex, top, coeff, testWrapRow,
                updatedRecords = proxy.getUpdatedRecords();

            if (model.allowTextWrap) {
                testWrapRow = proxy._getVisibleTextWrapRows(proxy._scrollTop);
                top = testWrapRow.top;
                if (type == "scroll" && proxy._scrollTop > proxy._prevScrollTop) {
                    testWrapRow.bottom = testWrapRow.bottom + 4;
                }
                bottomIndex = testWrapRow.bottom;
                proxy._offset = testWrapRow.offSet;
            } else {
                top = proxy._scrollTop / calcHeight;
                bottomIndex = proxy._getRowPosition(proxy._scrollTop + proxy._viewPortHeight);
                coeff = top - Math.floor(top);
                proxy._offset = coeff * calcHeight;
            }
            topIndex = Math.floor(top);
                topIndex = Math.max(0, topIndex);
                bottomIndex = Math.min(updatedRecords.length, bottomIndex);

                proxy._visibleRange = {
                    top: topIndex,
                    bottom: bottomIndex
                };

            return proxy._visibleRange;

        },

        //get the index of visible top row and bottom row.
        _getVisibleTextWrapRows: function (scrollTop) {
            var proxy = this, model = this.model, length = 0, offSet = 0, top = 0, topFlag = true, updateHeight = 0, bottomFlag = true,
                textWrapRow = {}, bottom = 0, updatedRecord, start = 0, height = 0;
            if (model.allowPaging) {
                updatedRecord = proxy._updatedPageData;
                length = proxy._updatedPageData.length;
            } else {
                updatedRecord = model.updatedRecords;
                length = updatedRecord.length;
            }
            for (var x = start; x < length; x++) {
                updateHeight = updateHeight + updatedRecord[x].textWrapRowHeight;
                if (model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                    if (!updatedRecord[x].isSummaryRow)
                        updateHeight = updateHeight + proxy._detailsRowHeight;
                }
                if ((updateHeight) >= scrollTop && topFlag) {
                    top = x;
                    offSet = parseInt(scrollTop) - parseInt(updateHeight - updatedRecord[x].textWrapRowHeight);
                    topFlag = !topFlag;
                }
                if (!topFlag) {
                    height = height + updatedRecord[x].textWrapRowHeight;
                }
                if (((updateHeight) >= (scrollTop + proxy._viewPortHeight) && bottomFlag) || (bottomFlag && x == (updatedRecord.length - 1))) {
                    bottom = x + 1;
                    bottomFlag = !bottomFlag;
                    break;
                }                                                                            
            }
            if (height < proxy._viewPortHeight) {
                if (parseInt(((proxy._viewPortHeight - height) / model.rowHeight)) > 0) {
                    top = top - parseInt(((proxy._viewPortHeight - height) / model.rowHeight));
                } else {
                    top = top - 1;
                }
            }
            textWrapRow = {
                top: top,
                offSet: offSet,
                bottom: bottom,
            };
            return textWrapRow;
        },

        //get the average height and the total height of text wrap rows.
        _getAvgTextWrapRowHeight: function (type, rowIndex) {
            var proxy = this, model = this.model, length = 0, recordIndex = 0, index = 0, isEnd = false,
            height = 0,textWrapRow = {}, currentViewData = model.currentViewData,updatedRecord, $gridRows;
            if (!model.allowPaging) {
                updatedRecord = model.updatedRecords;
            } else if (model.allowPaging) {
                updatedRecord = proxy._updatedPageData;
            }
            if ($("#" + proxy._id).find(".e-frozencontainer").length > 0) {
                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
                    $gridRows = proxy.getTreeGridRows()[0];
                else
                    $gridRows = proxy.getRows()[0];
            } else {
                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn)
                    $gridRows = proxy.getTreeGridRows();
                else
                    $gridRows = proxy.getRows();
            }
            if (type == "updateHeight" && ej.isNullOrUndefined(rowIndex)) {
                length = updatedRecord.length;
            } else if (type == "updateHeight" && !ej.isNullOrUndefined(rowIndex)) {
                length = rowIndex;
            } else {
                length = $gridRows.length;
            }
            if ($gridRows.length > 0) {
                for (var x = 0; x < length; x++) {
                    if (type == "getAvgHeight") {
                        index = proxy.getIndexByRow($gridRows[x]);
                        if (currentViewData[index]) {
                            if (currentViewData[index].textWrapRowHeight != $($gridRows[x]).height() && $($gridRows[x]).height() >= model.rowHeight)
                                currentViewData[index].textWrapRowHeight = $($gridRows[x]).height();
                            recordIndex = updatedRecord.indexOf(currentViewData[index]);
                            if (recordIndex > (updatedRecord.length - 5) && !proxy._textWrapNoCalculate) {
                                isEnd = true;
                            }
                        }
                        height = height + $($gridRows[x]).height();
                    } else if (type == "updateHeight") {
                        height = height + updatedRecord[x].textWrapRowHeight;
                    }
                }
            }
            if (type == "getAvgHeight") {
                height = height / length;
                textWrapRow = {
                    avgHeight: height,
                    isEnd: isEnd,
                };
            } else {
                textWrapRow = {
                    height: height,
                };
            }
            return textWrapRow;
        },

        /* set width to frozen and movable header columns to prevent
        improper view port height calculation while load time*/
        _setWidthToHeaders: function ()
        {
            var width = this._gridWidth;
            if (this._frozenColumnsLength > 0) {
                var totalWidth = 0, frozenWidth, headerColumns = this.getHeaderContent().find('.e-headercell');
                for (var i = 0; i < this.columnsWidthCollection.length; i++) {
                    totalWidth += this.columnsWidthCollection[i];
                    if (this._frozenColumnsLength - 1 == i)
                        frozenWidth = Math.ceil(totalWidth);
                    if (this.model.headerTextOverflow) {
                        $(headerColumns[i]).css({ "width": this.columnsWidthCollection[i] + "px" });
                    }
                }
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).outerWidth(frozenWidth)
                    .end().find("#e-movableheaderdiv" + this._id).css("width", "100%");
            }
        },
        //SET THE COLUMNWIDTH TO EACH COLUMN IN TREEGRID
        setWidthToColumns: function () {

            var proxy = this,
                model = proxy.model,
                $cols1 = proxy.getContentTable().children("colgroup").find("col"),
                $cols2 = proxy.getHeaderTable().children("colgroup").find("col"),
                width = proxy._gridWidth,
                colCount = model.columns.length;

            for (var i = 0; i < $cols2.length; i++) {

                if (!ej.isNullOrUndefined(proxy.columnsWidthCollection[i])) {

                    $cols1.eq(i).width(proxy.columnsWidthCollection[i]);
                    $cols2.eq(i).width(proxy.columnsWidthCollection[i]);
                    }
            }
            /* width fro details col group cell */
            if (!model.isFromGantt) {
                if ($cols1.length > colCount) {
                    $cols1.eq(colCount).width(35);
                }

                if ($cols2.length > colCount) {
                    $cols2.eq(colCount).width(35);
                }
            }

            /* Update column width in total summary table*/
            if (model.showTotalSummary && this._$totalSummaryRowContainer) {
                var gridheaderCol = $(this.getHeaderTable()).find('colgroup');
                var footerColClone = $(gridheaderCol).clone();
                if (this._frozenColumnsLength > 0) {
                    if (this._$footertableContent) {
                        $(this._$footertableContent).find('colgroup').remove();
                        $(footerColClone[0]).prependTo(this._$footertableContent[0]);
                        $(footerColClone[1]).prependTo(this._$footertableContent[1]);
                    }
                }
                else {
                    if (this._$footertableContent) {
                        $(this._$footertableContent).find('colgroup').remove();
                        $(footerColClone).prependTo(this._$footertableContent);
                    }
                }
            }

            if (this._frozenColumnsLength > 0) {
                var frozenWidth = this._getFrozenColumnWidth();
                if (frozenWidth < this._gridWidth) {
                    this.getContent().find("#e-movablecontainer" + this._id).css("margin-left", frozenWidth + "px");
                    this.getContent().find("#e-frozencontainer" + this._id).outerWidth(frozenWidth);
                    if (this.getScrollElement().data("ejScroller")) {
                        this.getScrollElement().ejScroller("option", "width", this._gridWidth - frozenWidth - this._totalBorderWidth - 1);
                        this.getScrollElement().ejScroller("option", "scrollTop", proxy._scrollTop);
                        this.getScrollElement().ejScroller("option", "scrollLeft", proxy._scrollLeft);
                    }
                    this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).next().css("margin-left", frozenWidth + "px");
                    this.getHeaderContent().find("#e-frozenheaderdiv" + this._id).outerWidth(frozenWidth)
                        .end().find("#e-movableheaderdiv" + this._id).css("width", "100%");
                    if (this._$totalSummaryRowContainer) {
                        this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).width(width).next().css("margin-left", frozenWidth + "px");
                        this._$totalSummaryRowContainer.find("#e-frozenfooterdiv" + this._id).outerWidth(frozenWidth)
                            .end().find("#e-movablefooterdiv" + this._id).css("width", "100%");
                        if (this.getBrowserDetails().browser == "safari")
                            this._$totalSummaryRowContainer.find("#e-movablefooter" + this._id).css("margin-left", "auto");
                    }
                    if (this.getBrowserDetails().browser == "safari")
                        this.getHeaderContent().find("#e-movableheader" + this._id).add(this.getContent().find("#e-movablecontainer" + this._id)).css("margin-left", "auto");
                }
            }
            if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                this._updateTableWidth();
        },
        //Set width for table according to column resize mode
        _updateTableWidth: function (isUpdateCssOnly) {
            var totWidth = 0, $headerTable, $contentTable, $totalSummaryTable,
                model = this.model, frozenColumnWidth = this._getFrozenColumnWidth(),
                columnLength = model.columns.length;
            for (var i = 0; i < columnLength; i++) {
                if (model.columns[i].isFrozen || model.columns[i].visible != false)
                    totWidth += model.columns[i].width;
            }
            if (this._frozenColumnsLength > 0) {
                totWidth -= frozenColumnWidth;
                $headerTable = $(this.getHeaderTable()[1]);
                $contentTable = $(this.getContentTable()[1]);
                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[1]) : null;
            } else {
                $headerTable = this.getHeaderTable();
                $contentTable = this.getContentTable();
                $totalSummaryTable = model.showTotalSummary ? $(this._$footertableContent[0]) : null;
            }
            if (model.showDetailsRow && model.showDetailsRowInfoColumn && model.detailsTemplate)
                totWidth += 35; // 35 denoted detail row icon column
            //when window resize no need to update the table width values
            if (!isUpdateCssOnly) {
                $headerTable.width(totWidth);
                $contentTable.width(totWidth);
                $totalSummaryTable && $totalSummaryTable.width(totWidth);
            }
            if (totWidth < (this._gridWidth - frozenColumnWidth) && model.columns[columnLength - 1].visible) {
                $headerTable.addClass('e-tableLastCell');
                $contentTable.addClass('e-tableLastCell');
             //   $totalSummaryTable && $totalSummaryTable.addClass('e-tableLastCell');
            } else {
                $headerTable.removeClass('e-tableLastCell');
                $contentTable.removeClass('e-tableLastCell');
              //  $totalSummaryTable && $totalSummaryTable.removeClass('e-tableLastCell');
            }
        },
        _convertHtml: function (text) {
            return text
                .replace(/&/g, "&amp;")
                .replace(/</g, "&lt;")
                .replace(/>/g, "&gt;")
                .replace(/"/g, "&quot;")
                .replace(/'/g, "&#039;");
        },

        //ENTER EDIT MODE INTO THE TREEGRID CELL
        cellEdit: function (index, fieldName) {

            var proxy = this,
                $form,
                model = proxy.model,
                row, rowIndex = index,
                updatedRecords = proxy.getUpdatedRecords(), selectedItem;
            if (model.allowSelection == true) {
                selectedItem = model.selectionSettings.selectionMode == "row" ? this.selectedItem() : updatedRecords[proxy._rowIndexOfLastSelectedCell];
            }
            else {
                selectedItem = this.selectedItem();
            }
            if (proxy.model.showGridCellTooltip) {
                proxy._cellMouseLeave();
            }

            proxy.model.isEdit && proxy.saveCell();

            $form = $("#" + proxy._id + "EditForm");

            if ($form.length > 0) return true;

            if (!selectedItem) return false;

            if (model.isFromGantt && selectedItem.hasChildRecords) {
                if (fieldName === "status" ||
                (fieldName === "startDate" && selectedItem.isAutoSchedule) ||
                (fieldName === "endDate" && selectedItem.isAutoSchedule) ||
                (fieldName === "duration" && selectedItem.isAutoSchedule) ||
                 fieldName === "work" || fieldName === "effortDriven" || fieldName === "taskType" ||
                 fieldName === "predecessor" ||
                 fieldName === "taskId")
                    return false;
            }
            if (model.isFromGantt) {
                if (selectedItem.isAutoSchedule && selectedItem.taskType == "fixedWork" && fieldName == "effortDriven")
                    return false;
                if (!selectedItem.isAutoSchedule && (fieldName == "taskType" || fieldName == "effortDriven"))
                    return false;
            }
            if (model.enableVirtualization || model.selectionSettings.selectionMode === "cell" ) {
                rowIndex = updatedRecords.indexOf(selectedItem);
                index = model.currentViewData.indexOf(selectedItem);
            }

            row = ej.TreeGrid.getRowByIndex(this, rowIndex);
            if (row && $(row).find(".e-rowcell").length > 0) {
                var $targetTr = $(row),
                columnIndex = proxy.getColumnIndexByField(fieldName),
                $targetTd = $targetTr.find(".e-rowcell").eq(columnIndex),
                column = proxy.model.columns[columnIndex],
                data = selectedItem,
                cellValue = proxy._getCustomCellValue(data, column.field),
                beginEditArgs = {},
                args = {
                    validationRules: ej.isNullOrUndefined(column.validationRules) ? {} : $.extend(true, {},
                        column.validationRules),
                    columnName: column.field,
                    value: !ej.isNullOrUndefined(cellValue) ? cellValue : data.item && data.item[fieldName],
                    data: data,
                    columnObject: column,
                    cell: $targetTd
                },
                isEditable = true;
                if (column.field == "notesText") {
                    args.value = !ej.isNullOrUndefined(data[fieldName]) ? data[fieldName] : data.item && data.item[fieldName];
                    args.value = args.value ? proxy._convertHtml(args.value) : args.value;
                }
                else {
                    args.value = !ej.isNullOrUndefined(cellValue) ? cellValue : data.item && data.item[fieldName];
                }
            if (model.isFromGantt && args.columnName === "predecessor") {

                var predecessor = args.data.item[proxy.model.predecessorMapping];
                args.value = predecessor ? predecessor : "";

            }
            if (model.isFromGantt && args.columnName === "taskMode") {
                var taskModeValue = !args.data.isAutoSchedule;
                args.value = taskModeValue;
            }

            beginEditArgs.data = data;
            beginEditArgs.columnIndex = columnIndex;
            beginEditArgs.rowElement = $targetTr;
            beginEditArgs.cellElement = $targetTd;

          

            proxy._cellEventTrigger($targetTd, data, args.columnObject);

                if (proxy._trigger("beginEdit", beginEditArgs)) return false;               

                if ($targetTr.hasClass("e-insertedrow") && (!args.columnObject.isTemplateColumn)) isEditable = true;

                if (isEditable) {

                    $.extend(proxy._cellEditingDetails, {
                        rowIndex: index,
                        cellValue: args.value,
                        columnIndex: columnIndex,
                        fieldName: fieldName,
                        cellEditType: args.columnObject.editType,
                        data: data
                    });
                }
                args.columnIndex = columnIndex;
                proxy._renderCellEditObject(args, $targetTd);
                if (!$targetTr.hasClass("e-templaterow")) {
                    $targetTr.addClass("e-editedrow");
                }

                args.cell && args.cell.addClass("e-editedcell");
                proxy._updateHorizontalScrollBar(fieldName);
                proxy._updateWrapRowHeights("total,header", null, proxy._cellEditingDetails.rowIndex, "cellEdit");
                return true;
            }
        },

        _updateHorizontalScrollBar: function (fieldName)
        {
            var proxy = this,
                gridContent = proxy.getScrollElement(),
                isHorizontalScroll = gridContent.ejScroller("isHScroll");
            //Check if the horizontal scrollbar is exists or not
            if (isHorizontalScroll) {
                var model = proxy.model,
                columns = model.columns,
                columnLength = columns.length,
                columnIndex = proxy.getColumnIndexByField(fieldName),                
                width = 0, startWidth = 0,
                endWidth = 0, left = 0,
                viewPortWidth = gridContent.find(".e-content").width(),
                scrollLeft = gridContent.ejScroller("option", "scrollLeft"),
                form = $("#" + proxy._id + "EditForm"), row,
                cells=[];                
                if (model.selectionSettings.selectionMode == "cell" && form.length == 0)
                    cells = $("#" + proxy._id).find(".e-selectingcell");//$(proxy._selectedCellDetails[proxy._selectedCellDetails.length - 1].cellElement).clone();
                else {
                    row = $(form).closest("tr.e-treegridrows");
                    cells = $(row).find("td.e-rowcell");
                }
                if (proxy._frozenColumnsLength > 0 && columnIndex < proxy._frozenColumnsLength)
                    return false;

                //Calculate the start and end width for edited cell
                for (var index = proxy._frozenColumnsLength; index <= columnIndex; index++) {
                    if (model.selectionSettings.selectionMode == "cell" && form.length == 0)
                        var cell = cells[cells.length - 1];
                    else
                        var cell = $(cells[index - proxy._frozenColumnsLength]);
                    if (index == columnIndex) {
                        startWidth = width;
                        endWidth = width + $(cell).width() + parseFloat($(cell).css("padding-left")) + parseFloat($(cell).css("padding-right")) + 1; // 1 for border
                    }
                    if (columns[index].visible) {
                        width = width + $(cell).width() + parseFloat($(cell).css("padding-left")) + parseFloat($(cell).css("padding-right")) + 1; // 1 for border
                    }
                }
                // Check if the edited cell in viewport.
                if (startWidth < scrollLeft || endWidth > scrollLeft + viewPortWidth) {
                    if (startWidth < scrollLeft) {
                        left = scrollLeft - (scrollLeft - startWidth) - 3;
                    } else {
                        left = scrollLeft + (endWidth - (scrollLeft + viewPortWidth) + 3);// 3 for slightly adjust the left scrollbar
                    }
                    gridContent.ejScroller("option", { "scrollLeft": left });
                    proxy._updateHeaderScrollLeft(left);
                }
            }
        },
        updateAllowColumnResize: function (bool) {
            var proxy = this,
                model = proxy.model;
            model.allowColumnResize = bool;
            if (model.allowColumnResize)
                proxy._resizer = new ej.gridFeatures.gridResize(proxy);
            proxy._enableColumnResizeEvents();
        },

        //validate predecessor string

        _validatePredecessorString: function (string) {
            var proxy = this, result, values, offsetvalue, match;
            if (string.length > 0) {
                string.split(',').forEach(function (el) {
                    values = el.split('+');
                    offsetvalue = '+';
                    if (el.indexOf('-') >= 0) {
                        values = el.split('-');
                        offsetvalue = '-';
                    }
                    match = values[0].match(/(\d+|[A-z]+)/g);
                    if (match && proxy.model.ids.indexOf(match[0]) != -1) {
                        if (match[1]) {
                            if (match[1].toUpperCase() == 'FS' || match[1].toUpperCase() == 'FF' || match[1].toUpperCase() == 'SF' || match[1].toUpperCase() == 'SS') {
                            }
                            else {
                                result = false;
                            }
                        }
                    } else {
                        result = false;
                    }
                });
            } else {
                return true;
            }
            if (result === undefined || result)
                return true;
            else
                return false;
        },

        //SAVE THE EDITED CELL
        
        saveCell: function () {

            var proxy = this,
                model = proxy.model;

            if ($("#" + proxy._id + "EditForm").length > 0) {

                if (!proxy.editFormValidate()) return true;

                if (proxy._cellEditingDetails.columnIndex >= 0) {
                    proxy._focusTreeGridElement();

                    var $form = $("#" + proxy._id + "EditForm"),
                        recordIndex = model.allowPaging ? proxy._updatedPageData.indexOf(proxy._cellEditingDetails.data) : model.updatedRecords.indexOf(proxy._cellEditingDetails.data),
                        $targetTr = ej.TreeGrid.getRowByIndex(this, recordIndex),
                        $targetTd = $form.closest("td"),
                        formattedValue, args = {},
                        column = model.columns[proxy._cellEditingDetails.columnIndex],
                        $element = $("#" + proxy._id + proxy._cellEditingDetails.fieldName.split('.').join("")),
                        cellElement;

                    args = {
                        columnName: column.field,
                        value: proxy.getCurrentEditCellData(),
                        data: proxy._cellEditingDetails.data,
                        previousValue: proxy._cellEditingDetails.cellValue,
                        columnObject: column,
                        cellElement: $targetTd,
                        rowElement: $targetTr,
                    };

                    if (proxy._cellEditingDetails.cellEditType == "datetimepicker" ||
                        proxy._cellEditingDetails.cellEditType == "dropdownedit" ||
                        proxy._cellEditingDetails.cellEditType == "datepicker") {

                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");

                    }

                    if (!ej.isNullOrUndefined(column.format)) {

                        formattedValue = proxy.formatting(column.format, args.value, model.locale);
                        args.cellElement.empty().html(formattedValue);

                    } else {

                        if (args.columnObject.type == "boolean") {

                            var cellData = {};
                            cellData[args.columnObject.field] = args.value;
                            args.cellElement.empty().html(
                                $($.templates.Grid_JSONTemplate.render(cellData))[0].cells[proxy._cellEditingDetails.columnIndex].innerHTML
                            );

                        } else if (args.columnObject.field == "notesText") {
                            args.cellElement.empty().html(proxy._convertHtml(args.value));
                        }
                        else args.cellElement.empty().html(args.value);
                    }

                    var isValueModified = ((proxy._cellEditingDetails.cellEditType == "datepicker" ||
                            proxy._cellEditingDetails.cellEditType == "datetimepicker") &&
                        args.value instanceof Date && args.previousValue instanceof Date) ?
                        (args.value.getTime() !== args.previousValue.getTime()) :
                        (args.value !== args.previousValue);

                    model.isEdit = false;

                    var fieldName = proxy._cellEditingDetails["fieldName"];

                    //To avoid duplicate ID for TreeGrid on self reference while editing ID value
                    if (!model.isFromGantt && model.idMapping && model.parentIdMapping && fieldName == model.idMapping) {
                        if (proxy._validateIdValue(args.value)) {
                            args.value = args.previousValue
                            isValueModified = false;
                        }
                    }

                    if (model.isFromGantt && fieldName === "taskMode") {
                        isValueModified = (args.value !== args.previousValue) ? true : false;
                    }
                    //check start or end date value is changed on cell edit in Gantt
                    if (model.isFromGantt && args.value && (fieldName === "startDate" || fieldName === "endDate")) {
                        if (this.getFormatedDate(args.value) == this.getFormatedDate(args.data[fieldName])) {
                            isValueModified = false;
                        }
                    }

                    if (model.isFromGantt && fieldName === "predecessor") {

                        var eventArg = {}, stringResult, logicResult;
                        args.value = args.value.trim();
                        stringResult = proxy._validatePredecessorString(args.value);
                        if (stringResult) {
                            eventArg.predecessorString = args.value.split(',');
                            eventArg.currentRecord = args.data;
                            eventArg.requestType = "validatePredecessor";
                            proxy._trigger("actionComplete", eventArg);
                            logicResult = eventArg.result;
                            if (!logicResult) {
                                args.value = args.previousValue;
                            }
                        }
                        else {
                            args.value = args.previousValue;
                        }
                        var ganttPredecessor = [],
                        prevPredecessors = [],
                        modifiedPredecessors = [],
                        count = 0,
                        length, predecessor;
                        args.previousValue = args.data.predecessor;
                        prevPredecessors = args.previousValue;
                        if (args.value.length > 0) {
                            var ganttProxy = $("#" + this._id.replace("ejTreeGrid", "")).data("ejGantt");
                            modifiedPredecessors = args.data._calculatePredecessor(args.value, model.durationUnitEditText, model.durationUnit, ganttProxy);                            
                        }
                        length = modifiedPredecessors.length;
                        var index = 0,
                            prevPrdecessorlength = args.previousValue && args.previousValue.length;
                        for (index = 0; index < prevPrdecessorlength; index++) {
                            predecessor = prevPredecessors[index];
                            if (predecessor.from === args.data.taskId.toString()) {
                                ganttPredecessor.push(predecessor);
                            }
                        }
                        for (count = 0; count < length; count++) {
                            ganttPredecessor.push(modifiedPredecessors[count]);
                        }
                        args.data[proxy._cellEditingDetails["fieldName"]] = ganttPredecessor;
                        if (ganttProxy && !ganttProxy._isValidPredecessorString) {
                            args.value = proxy._getPredecessorsValue(args.data);
                            ganttProxy._isValidPredecessorString = true;
                        }
                        args.data.item[model.predecessorMapping] = args.value;
                        args.data.predecessorsName = args.value;
                        if (model.enableWBS && model.enableWBSPredecessor)
                            proxy.updateWBSPredecessor(args.data);

                    } else if (model.isFromGantt && fieldName === "duration") {
                        //validate text from duration field
                        var val = args.value,
                        duration = args.data.duration,
                        durationUnit = args.data.durationUnit;

                        var values = val.match(/(\d*\.*\d+|[A-z]+)/g);
                        if (values && values.length <= 2) {
                            duration = parseFloat(values[0]);
                            durationUnit = values[1] ? values[1].toLowerCase() : "";
                            if (model.durationUnitEditText.minute.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Minute;
                            else if (model.durationUnitEditText.hour.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Hour;
                            else if (model.durationUnitEditText.day.indexOf(durationUnit) != -1)
                                durationUnit = ej.Gantt.DurationUnit.Day;
                            else
                                durationUnit = model.durationUnit;
                        }
                        if (!isNaN(duration) && (parseFloat(args.data.duration.toFixed(2)) != duration || args.data.durationUnit.toLowerCase() !=durationUnit)) {
                            args.data.item[model.durationMapping] = args.data.duration = duration;
                            args.data.durationUnit = durationUnit;
                        } else {
                            args.data.item[model.durationMapping] = args.previousValue;
                        }

                    } else if (isValueModified) {
                        if (model.isFromGantt) {

                            switch (fieldName) {

                                case "taskId":
                                    args.data.item[model.idMapping] = args.value;
                                    break;
                                case "taskName":
                                    args.data.item[model.taskNameMapping] = args.value;
                                    break;
                                case "startDate":
                                    if (!args.value)
                                        args.value = args.previousValue;
                                    args.data.item[model.startDateMapping] = args.value;
                                    break;
                                case "endDate":
                                    if (!args.value)
                                        args.value = args.previousValue;
                                    args.data.item[model.endDateMapping] = args.value;
                                    break;
                                case "resourceInfo":
                                    args.data.item[model.resourceInfoMapping] = proxy._getResourceId(args.value);
                                    break;
                                    //case "duration":
                                    //    args.data.item[model.durationMapping] = args.value;
                                    //    break;
                                case "status":
                                    args.data.item[model.progressMapping] = args.value;
                                    break;
                                case "notesText":
                                    args.data.item[model.notesMapping] = args.value;
                                    args.data["notes"] = args.value;
                                    args.data["notesText"] = args.value;
                                    break;
                                case "taskMode":
                                    args.data.item[model.taskSchedulingModeMapping] = args.value;
                                    args.data["isAutoSchedule"] = args.value == true ? false : true;
                                    break;
                                case "work":
                                    if (model.workMapping)
                                        args.data.item[model.workMapping] = args.value;
                                    else
                                        args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                                    break;
                                case "baselineStartDate":
                                    args.data.item[model.baselineStartDateMapping] = args.value;
                                    break;
                                case "baselineEndDate":
                                    args.data.item[model.baselineEndDateMapping] = args.value;
                                    break;
                                default:
                                    args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                                    break;
                            }

                        } else {
                            var splits = (proxy._cellEditingDetails.fieldName || "").split(".")
                            if (splits <= 1)
                                args.data.item[proxy._cellEditingDetails.fieldName] = args.value;
                            else
                                args.data.item = proxy._restoreCustomData(args.data.item, args.value);
                        }
                        var splits = (proxy._cellEditingDetails.fieldName || "").split(".")
                        if (splits <= 1)
                            args.data[proxy._cellEditingDetails.fieldName] = args.value;
                        else
                            args.data = proxy._restoreCustomData(args.data, args.value);
                        
                    }

                    if (model.isFromGantt && (args.columnName === "startDate" ||
                        args.columnName === "endDate" ||
                        args.columnName === "duration" ||
                        (args.columnName === "taskMode" && isValueModified) ||
                        args.columnName === "predecessor" ||
                        args.columnName == "status") ||
                        args.columnName == "baselineStartDate" ||
                        args.columnName == "baselineEndDate") {

                        args.isModified = true;

                    }
                    if (this._frozenColumnsLength > 0) {
                        if (!model.allowSelection)
                            args.data.isSelected = false;
                        if (proxy._cellEditingDetails.columnIndex < this._frozenColumnsLength)
                            cellElement = $($.render[proxy._id + "_JSONFrozenTemplate"](args.data))[0].cells[proxy._cellEditingDetails.columnIndex];
                        else
                            cellElement = $($.render[proxy._id + "_Template"](args.data))[0].cells[(proxy._cellEditingDetails.columnIndex - this._frozenColumnsLength)];
                    } else {
                        if (!model.allowSelection)
                            args.data.isSelected = false;
                        cellElement = $($.render[proxy._id + "_Template"](args.data))[0].cells[proxy._cellEditingDetails.columnIndex];
                    }
                    args.cellElement.removeClass("e-editedcell").replaceWith(cellElement);
                    args.cellElement = $(cellElement);
                    /* refresh details Row */
                    if (model.showDetailsRow && !model.showDetailsRowInfoColumn && model.detailsTemplate) {
                        this._refreshDetailsRow(model.currentViewData.indexOf(args.data));
                    }

                    proxy._trigger("refresh");
                    if (!args.data.treeMappingName)
                        args.data.treeMappingName = [];
                    args.data.treeMappingName.push(args.columnName);
                    if (proxy._trigger("endEdit", args)) {
                        args.data[args.columnName] = args.previousValue;
                        args.data.item[args.columnObject.field] = args.previousValue;
                        proxy.selectRows(this.selectedRowIndex());
                        ej.TreeGrid.refreshRow(proxy, model.currentViewData.indexOf(args.data));
                    }
                    else {
                        if (model.idMapping && model.parentIdMapping) {
                            proxy._updateLastInsertedId(args.data[model.idMapping]);
                        }
                    }
                   
                    proxy._cellEventTrigger(args.cellElement[0], args.data, args.columnObject);
                    $targetTr.removeClass("e-editedrow");

                    if (model.showSummaryRow) {
                        args.editType = "celledit";
                        proxy._updateSummaryRow(args);
                    }
                    if (model.showTotalSummary) {
                        args.editType = "celledit";
                        proxy._updateTotalSummaryRow(args);
                }
                if (model.allowTextWrap) {
                    if (proxy._$frozenTableContent.length > 0) {
                        proxy._updateRowHeight(proxy._cellEditingDetails.rowIndex, "savecell");
                        proxy._updateGridContentHeight();
                        proxy.getScrollElement().ejScroller("refresh");
                        var movableScrollTop = proxy.getScrollElement().ejScroller("model.scrollTop");
                        proxy._getFrozenScrollElement().scrollTop(movableScrollTop);
                        if (model.enableVirtualization) {
                            proxy.updateHeight();
                        }
                    } else {
                        proxy.getScrollElement().ejScroller("refresh");
                    }
                    if (model.allowPaging && !model.sizeSettings.height) {
                        proxy.updateHeight();
                    }
                }
                proxy._cancelSaveTools();
                var colObject = args.columnObject;
                if (model.allowFiltering && colObject && model.filterSettings.filterType == "filterbar" && colObject.filterEditType == "dropdownedit" && colObject.editType != "dropdownedit")
                        proxy._resizeFilteringElements();
                }
            }
            return false;
        },

        
        /*Update WBS predecessors value*/
        updateWBSPredecessor: function (preData) {
            var proxy = this,
                model = proxy.model,
                prdc = preData["predecessorsName"],
                wbspred = null;
            if (prdc && prdc.length > 0) {
                var prdcList = prdc.split(',');
                for (var p = 0; p < prdcList.length; p++) {
                    var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                        refId = +ref[0],
                        refType = ref[1],
                        refRecord;
                    refRecord = model.flatRecords.filter(function (record) {
                        return record && record.taskId == refId;
                    });
                    var newOne;
                    if (refType)
                        newOne = refRecord[0] && refRecord[0]["WBS"] + refType;
                    else
                        newOne = refRecord[0] && refRecord[0]["WBS"];
                    wbspred = wbspred ? (wbspred + "," + newOne) : newOne;
                }
                preData["WBSPredecessor"] = wbspred;
                preData["item"]["WBSPredecessor"] = wbspred;
            }
            else {
                preData["WBSPredecessor"] = "";
                preData["item"]["WBSPredecessor"] = "";
            }
        },

        //GET THE CURRENT CELL DATA
        getCurrentEditCellData: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                column, cellDate;

            if ($("#" + proxy._id + "EditForm").length) {

                var $element = $("#" + proxy._id + proxy._cellEditingDetails.fieldName.split('.').join("")),
                    cellValue;
                column = columns[proxy._cellEditingDetails.columnIndex];
                switch (proxy._cellEditingDetails.cellEditType) {

                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;

                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = parseFloat($element.val());
                        if ((model.isFromGantt && (column.field == "work" || column.field == "status" || column.field == "duration") || column.field == "unit")) {
                            cellValue = isNaN(cellValue) ? proxy._cellEditingDetails.cellValue : cellValue;
                        } else {
                            cellValue = $element.ejNumericTextbox("model.value");
                        }
                        break;

                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:
                        if (model.isFromGantt && proxy._cellEditingDetails.fieldName === "resourceInfo") {
                            cellValue = proxy._getSelectedItem($element.ejDropDownList("model.selectedItems"));
                        }
                        else if (model.isFromGantt && proxy._cellEditingDetails.fieldName === "taskMode") {
                            cellValue = $element.ejDropDownList("model.value") == "true" ? true : false;
                        }
                        else
                            cellValue = $element.ejDropDownList("model.value");
                        break;

                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        if (column && !column.format) {
                            cellValue = ej.format($element.ejDatePicker("model.value"), this.model.dateFormat, this.model.locale)
                        }
                        else {
                            cellValue = $element.ejDatePicker("model.value");
                        }
                        if (cellValue == "" && model.isFromGantt)
                            cellValue = proxy._cellEditingDetails.cellValue;
                        break;

                    case ej.TreeGrid.EditingType.DateTimePicker:

                        var dateTimePickerValue = $element.ejDateTimePicker("model.value"),
                            dateTimePickerFormat = $element.ejDateTimePicker("model.dateTimeFormat"),
                            dateTimePickerLocale = $element.ejDateTimePicker("model.locale"),
                            tempValue;

                        if (column && !column.format) {
                            cellValue = ej.format($element.ejDateTimePicker("model.value"), this.model.dateFormat, this.model.locale)
                        }
                        else {
                            cellValue = $element.ejDateTimePicker("model.value");
                        }
                        cellDate = ej.format($element.val(), dateTimePickerFormat, dateTimePickerLocale);
                        tempValue = ej.format(dateTimePickerValue, dateTimePickerFormat, dateTimePickerLocale);
                        if (cellDate !== tempValue && model.isFromGantt)
                            cellValue = proxy._cellEditingDetails.cellValue;
                        break;
                    case "edittemplate":
                        var temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;

                }
                if (typeof cellValue == "string" && cellValue.length &&
                    model.columns[proxy._cellEditingDetails.columnIndex].type == "number") {

                    cellValue = parseFloat(cellValue);

                }

                return cellValue;
            }

            return null;
        },
        //Get the value from edited row

        getCurrentEditCellDataForRowEdit: function (field,type,cellIndex) {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                column, field = field.split('.').join(""), length, $element, isDialogEdit;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                length = $("#" + proxy._id + "EditFormDialog").length;
                $element = $("#" + proxy._id + field);
                isDialogEdit = true;
            } else {
                length = $("#" + proxy._id + "EditForm").length;
                $element = $("#" + proxy._id + field);
            }

            if (length) {

                var cellValue, dateValue;
                column = columns[cellIndex];

                switch (type) {

                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;

                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = parseFloat($element.val());
                        if ($element.data("ejNumericTextbox"))
                            cellValue = $element.ejNumericTextbox("model.value");
                        else
                            cellValue = cellValue;
                        break;

                    case ej.TreeGrid.EditingType.Dropdown:
                        if ($element.data("ejDropDownList"))
                            cellValue = $element.ejDropDownList("model.value");
                        else
                            cellValue = $element.val();
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:

                        if ($element.hasClass("e-datepicker")) {
                            if (model.dateFormat.toLowerCase().indexOf("hh") == -1)
                                dateValue = $element.ejDatePicker("model.value");
                            else {
                                dateValue = $element.ejDateTimePicker("model.value");
                            }
                        } else {
                           dateValue = $element.val();
                        }

                        if (column && !column.format) {
                            cellValue = proxy.getFormatedDate(dateValue);
                        }
                        else {
                            cellValue = dateValue;
                        }
                       
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.DateTimePicker:

                        if ($element.hasClass("e-datetimepicker")) {
                            if (column && !column.format) {
                                cellValue = ej.format($element.ejDateTimePicker("model.value"), this.model.dateFormat, this.model.locale)
                            }
                            else {
                                cellValue = $element.ejDateTimePicker("model.value");
                            }
                        } else {
                            cellValue = $element.val();
                        }
                        if (!isDialogEdit)
                        $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
                        break;

                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                    case "edittemplate":
                        var temp1 = column.editTemplate.read;
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        cellValue = temp1($element);
                        break;

                }
                if (typeof cellValue == "string" && cellValue.length &&
                    model.columns[cellIndex].type == "number") {
                    cellValue = parseFloat(cellValue);
                }

                return cellValue;
            }

            return null;
        },

        _getResourceId:function(dataSource){

            var resourceIds = [],
                count = 0, length = dataSource.length;

            for (count = 0; count < length; count++) {
                resourceIds.push(dataSource[count][this.model.resourceIdMapping]);
            }
            return resourceIds;
        },

        _getSelectedItem: function (indexArray) {

            var proxy = this, model = proxy.model,
                count = 0, index, 
                length = indexArray.length,
                resourceUnitMapping = model.resourceUnitMapping,
                resourceIdMapping = model.resourceIdMapping,
                dropDownData = model.columns[proxy._cellEditingDetails.columnIndex].dropdownData,
                selectedItemResourceInfo = model.selectedItem.resourceInfo,
                selectedItems = [];

            if (dropDownData) {

                for (count = 0; count < length; count++) {                    
                    if (selectedItemResourceInfo) {
                        for (var newIndex = 0; newIndex < selectedItemResourceInfo.length; newIndex++) {
                            if (selectedItemResourceInfo[newIndex][resourceIdMapping] === indexArray[count] + 1) {
                                index = newIndex;
                                break;
                            }
                            else
                                index = -1;
                        }
                    }
                    if (!ej.isNullOrUndefined(index) && index != -1)
                        selectedItems.push(selectedItemResourceInfo[index]);
                    else {
                        $.each(dropDownData, function (index, resourceInfo) {
                            if (indexArray[count] === index) {
                                var ganttRecordResource = $.extend({}, resourceInfo);
                                ganttRecordResource[resourceUnitMapping] = 100;
                                selectedItems.push(ganttRecordResource);
                            }
                        });
                    }
                }
            }

            return selectedItems;
        },       
        //GET THE FORMATED DATE 
        getFormatedDate: function (date) {
            return ej.format(date, this.model.dateFormat, this.model.locale);
        },
        //Get formated string from date object
        getDateFromFormat: function (date) {

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },

        //GET THE FORMATTED TEXT
        formatting: function (formatstring, str, locale) {
            formatstring = formatstring.replace(/%280/g, "\"").replace(/&lt;/g, "<").replace(/&gt;/g, ">");
            locale = ej.preferredCulture[locale] ? locale : "en-US";
            var s = formatstring;
            var frontHtmlidx, FrontHtml, RearHtml, lastidxval;
            frontHtmlidx = formatstring.split("{0:");
            lastidxval = formatstring.split("}");
            FrontHtml = frontHtmlidx[0];
            RearHtml = lastidxval[1];
            if (typeof (str) == "string" && $.isNumeric(str))
                str = Number(str);
            if (formatstring.indexOf("{0:") != -1) {
                var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                var formatVal = toformat.exec(formatstring);
                if (formatVal != null && str != null) {
                    if (FrontHtml != null && RearHtml != null)
                        str = FrontHtml + ej.format(str, formatVal[2], locale) + RearHtml;
                    else
                        str = ej.format(str, formatVal[2], locale);
                } else if (str != null)
                    str = str;
                else
                    str = "";
                return str;
            } else if (this.data != null && this.data.Value == null) {
                $.each(this.data, function (dataIndex, dataValue) {
                    s = s.replace(new RegExp('\\{' + dataIndex + '\\}', 'gm'), dataValue);
                });
                return s;
            } else {
                return this.data.Value;
            }
        },


        //GET THE COLUMNINDEX BY USIGN THE FIELD NAME
        getColumnIndexByField: function (fieldName) {

            var proxy = this,
                columns = proxy.model.columns,
                length = columns.length,
                column = 0;

            for (column; column < length; column++) {
                if (columns[column]["field"] == fieldName)
                    break;
            }

            return column == columns.length ? -1 : column; // if field name not available in columns collection, it return -1 value.
        },

        getUpNextVisibleColumnIndex: function (index, action) {
            var proxy = this, columns = proxy.model.columns;
            if (!index)
                index = 0;
            for (index; index <= columns.length; index++) {
                if (index == columns.length && (action == "rightArrow" || action == "moveCellRight")) {
                    index = 0;
                    proxy._focusingRowIndex += 1;
                }
                if (columns[index].visible && columns[index].allowCellSelection)
                    return columns.indexOf(columns[index]);
            }
        },
        getPreviousVisibleColumnIndex: function (index, action) {
            var proxy = this, columns = proxy.model.columns;
            if (!index)
                index = columns.length - 1;
            for (index; index < columns.length; index--) {
                if (index < 0 && (action == "leftArrow" || action == "moveCellLeft")) {
                    index = columns.length - 1;
                    proxy._focusingRowIndex -= 1;
                }
                if (columns[index].visible && columns[index].allowCellSelection)
                    return columns.indexOf(columns[index]);
            }
        },
        //GET THE BROWSER DETAILS
        getBrowserDetails: function () {
            var b = navigator.userAgent.match(/(firefox|chrome|opera|msie|safari)\s?\/?(\d+(.\d+)*)/i);
            if (!!navigator.userAgent.match(/Trident\/7\./))
                return { browser: "msie", version: jQuery.uaMatch(navigator.userAgent).version };
            return { browser: b[1].toLowerCase(), version: b[2] };
        },

        //Check whether the Browser is Mobile Device's or not.
        mobileDevice: function () {
            if (navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i)
                || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i)
                || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/BlackBerry/i)
                || navigator.userAgent.match(/Windows Phone/i)) {
                return true;
            }
            else {
                return false;
            }
        },


        //GET THE FIELDNAME OF COLUMN BY USING THE HEADERTEXT
        getFieldNameByHeaderText: function (headerText) {

            var proxy = this;

            if (ej.isNullOrUndefined(proxy._fieldColumnNames[headerText])) return null;

            return proxy._fieldColumnNames[headerText];
        },


        //CLEAR THE SELECTION

        

        clearSelection: function (index) {

            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            if (this.selectedRowIndex() != -1 || (this.selectedRowIndex() == -1 && proxy._previousIndex != -1) || index == -1) {
                                                 //To clear the row selection of previously selected row via set model (selectedRowIndex)
                var $gridRows,
                    index;
                if (this._frozenColumnsLength) {
                    $gridRows = $(proxy.getRows()[0]).add(proxy.getRows()[1]);
                } else {
                    $gridRows = proxy.getRows();
                }     
                if (!ej.isNullOrUndefined(index) && index != -1) {
                    ej.TreeGrid.getRowByIndex(proxy, index).find(".e-selectionbackground").removeClass("e-selectionbackground").removeClass("e-active");
                    var record = updatedRecords[index];
                    record && (record.isSelected = false);
                    }
                else {

                    if ($gridRows) {
                        $gridRows.find(".e-rowcell,.e-detailsrowcell").removeClass("e-selectionbackground").removeClass("e-active");
                    }
                    var dataManager = new ej.DataManager(model.flatRecords);

                    var query = new ej.Query();
                    query.search(true, ['isSelected'], ej.FilterOperators.Equals, true);

                    var records = dataManager.executeLocal(query);
                    var length = records && records.length;

                    if (length > 0) {

                        var count = 0;

                        for (count = 0; count < length; count++) {
                            records[count].isSelected = false;                            
                        }

                    }
                }

                if (proxy._checkboxSelection) {
                    proxy.selectedRowIndex(-1);
                    model.selectedItem = null;              
                    proxy._cancelSaveTools();
                }
                //Clearing the selected item and index while clearing the row selection itself
                else if (!model.selectedItems.length || (model.selectedItems.length && !proxy._multiSelectCtrlRequest) || index == -1) {
                    proxy.selectedRowIndex(-1);
                    model.selectedItem = null;//For single selection only
                    model.selectedItems = [];
                    proxy._cancelSaveTools();
                }               

                if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible") && !$gridRows.find(".e-rowcell,.e-detailsrowcell").hasClass("e-selectionbackground") && !$("#" + proxy._id + "_selectionpopup").find(".e-rowselect").hasClass("e-spanclicked")) {
                    proxy._clearMultiSelectPopup();
                }
            }
            if (model.selectionSettings.selectionMode == "cell") {
                proxy._selectedCellDetails = [];
                model.selectedCellIndexes = [];
                $("#" + proxy._id).find(".e-selectingcell").removeClass("e-selectingcell");

                proxy._rowIndexOfLastSelectedCell = -1;
                proxy._lastSelectedCellIndex = -1;
                proxy._focusingRowIndex = -1;
            }
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && ej.isNullOrUndefined(index) && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
        },

        //To hide the selection popup
        _clearMultiSelectPopup: function () {
            var proxy = this;
            $("#" + proxy._id + "_selectionpopup").find(".e-rowselect").removeClass("e-spanclicked");
            proxy._multiSelectPopup.hide();
            proxy._multiSelectCtrlRequest = false;
            proxy._isTouchTrigger = false;
        },

        //COUNT THE CHILDRECORDS COUNT
        getChildRecordsCount: function (record) {

            var proxy = this,
                childRecords = record.childRecords,
                count = 0,
                length = childRecords ? childRecords.length : 0;

            for (count; count < length; count++) {

                if (proxy._filteredRecords.length > 0) {

                    var recordIndex = proxy._filteredRecords.indexOf(childRecords[count]);

                    if (recordIndex != -1) {

                        ++proxy._removedCount;

                        if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                            proxy.getChildRecordsCount(childRecords[count]);
                        }

                    }
                } else {

                    ++proxy._removedCount;

                    if (childRecords[count].hasChildRecords && childRecords[count].expanded) {
                        proxy.getChildRecordsCount(childRecords[count]);
                    }

                }
            }

            return proxy._removedCount;
        },


        //GET THE EXPAND STATUS OF RECORD
        getExpandStatus: function (record) {

            var parentRecord = record.parentItem;

            if (parentRecord != null) {

                if (parentRecord.expanded === false) {
                    return false;
                } else if (parentRecord.parentItem) {

                    if (parentRecord.parentItem.expanded === false) {
                        return false;
                    } else {
                        return this.getExpandStatus(parentRecord.parentItem);
                    }

                } else return true;
            } else return true;
        },


        //RETURN THE COLUMN FIELD NAMES
        getColumnFieldNames: function () {

            var columnNames = [],
                columns = this.model.columns,
                count = 0,
                length = columns.length;

            for (count; count < length; count++) {

                if (columns[count]["field"] && (columns[count]["field"] != "resourceInfo") && (columns[count]["field"] != "predecessor")) { 
                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "resourceInfo") {
                    
                    columnNames.push("resourceNames");
                }
                else if (columns[count]["field"] == "predecessor")
                {
                    
                    columnNames.push("predecessorsName");
                }

            }

            return columnNames;
        },

        _getColumnMappingNames: function () {

            var columnNames = [],
                columns = this.model.columns,
                count = 0,
                length = columns.length;

            for (count; count < length; count++) {

                if (columns[count]["field"] && (columns[count]["field"] != "resourceInfo") && (columns[count]["field"] != "predecessor")

                    && (columns[count]["field"] != "work") && (columns[count]["field"] != "taskType") && (columns[count]["field"] != "effortDriven")) {
                    columnNames.push(columns[count]["mappingName"]);
                }
                else if (columns[count]["field"] == "resourceInfo") {

                    columnNames.push("resourceNames");
                }
                else if (columns[count]["field"] == "work") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "taskType") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "effortDriven") {

                    columnNames.push(columns[count]["field"]);
                }
                else if (columns[count]["field"] == "predecessor") {

                    columnNames.push("predecessorsName");
                }

            }

            return columnNames;
        },

        //RENDERED  RECORDS
        renderRecords: function (args) {

            var proxy = this,
                model = proxy.model;

            if (!args) {

                args = {};
                if (!model.isFromGantt && model.enableCollapseAll) {
                    args.requestType = ej.TreeGrid.Actions.ExpandCollapse;                   
                    proxy._isInExpandCollapseAll = true;                                    
                }
                else
                    args.requestType = ej.TreeGrid.Actions.Refresh;

            }

            this.sendDataRenderingRequest(args);
            proxy._isInExpandCollapseAll = false;
        },       

        _shiftKeySelectCells: function (args, targetIndex) {
            var proxy = this, model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                //Get First Row Details for shift key functions.
                firstRowElementIndex = proxy._shiftKeyFirstElementDetails.firstElementRowIndex,
                firstRowCellIndex = ej.isNullOrUndefined(proxy._shiftKeyFirstElementDetails.firstElementCellIndex) ? -1 : 
                                    proxy._shiftKeyFirstElementDetails.firstElementCellIndex,
                secondRowElementIndex = args.rowIndex,
                secondRowCellIndex = args.cellIndex,
                shiftKeyRowIndexes = [firstRowElementIndex, secondRowElementIndex],
                shiftKeyCellIndexes = [firstRowCellIndex, secondRowCellIndex];

            //Sort the two Selected row and cell Indexes.
            shiftKeyRowIndexes.sort(function (a, b) {
                return (a - b);
            });
            shiftKeyCellIndexes.sort(function (a, b) {
                return (a - b);
            });
            proxy._isShiftKeyNavigation = true;
            proxy._selectedCellDetails = [];
            model.selectedCellIndexes = [];
            $("#" + proxy._id).find(".e-selectingcell").removeClass("e-selectingcell");

            for (var rowIndex = shiftKeyRowIndexes[0]; rowIndex <= shiftKeyRowIndexes[1]; rowIndex++) {
                var record = updatedRecords && updatedRecords[rowIndex],
                    currentRowIndex = model.currentViewData.indexOf(record);
                if (ej.isNullOrUndefined(record) || record.isSummaryRow)
                    continue;
                for (var cellIndex = shiftKeyCellIndexes[0]; cellIndex <= shiftKeyCellIndexes[1]; cellIndex++) {
                    proxy.selectCells([{ rowIndex: rowIndex, cellIndex: cellIndex }]);
                }
            }
        },

        selectCells: function (indexes, preservePreviousSelectedCells) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
                $gridRows = proxy.getRows(), $targetRow, targetCell, record, length = indexes.length, columns=model.columns;

            if (model.selectionSettings.selectionType == "single")
                length = 1;
            if ((!preservePreviousSelectedCells || ej.isNullOrUndefined(preservePreviousSelectedCells)) &&
                proxy._isShiftKeyNavigation == false) {
            proxy._selectedCellDetails = [];
                model.selectedCellIndexes = [];
            $("#" + proxy._id).find(".e-selectingcell").removeClass("e-selectingcell");
            }
            if (model.selectionSettings.selectionMode == "cell" && model.allowSelection && $gridRows.length > 0) {
                for (var index = 0; index < length; index++) {
                    if (indexes[index].rowIndex == -1)
                        continue;
                    var record = updatedRecords && updatedRecords[indexes[index].rowIndex],
                        currentRowIndex = model.currentViewData.indexOf(record);
                    if (record.isSummaryRow)
                        continue;
                    var frozenColumnRowIndex = indexes[index].cellIndex >= proxy._frozenColumnsLength ? 1 : 0,
                       targetCellIndex = indexes[index].cellIndex >= proxy._frozenColumnsLength ? indexes[index].cellIndex - proxy._frozenColumnsLength : indexes[index].cellIndex;
                    if (proxy._frozenColumnsLength > 0) {
                        $targetRow = $gridRows[frozenColumnRowIndex][currentRowIndex];
                    }
                    else
                        $targetRow = $gridRows[currentRowIndex];

                    if (!ej.isNullOrUndefined(record) && ej.isNullOrUndefined($targetRow))
                        $targetRow = $($.render[proxy._id + "_Template"](record))[0];

                    targetCell = $targetRow.childNodes[targetCellIndex];
                    if (indexes[index].cellIndex != -1 && columns[indexes[index].cellIndex].allowCellSelection && columns[indexes[index].cellIndex].visible &&
                           !proxy._cellSelectingEventTrigger({ rowIndex: indexes[index].rowIndex, cellIndex: indexes[index].cellIndex, rowElement: $targetRow, cellElement: targetCell })) {
                        $(targetCell).addClass("e-selectingcell");

                        var selectedCellInfo = {
                            rowIndex: indexes[index].rowIndex,
                            cellIndex: indexes[index].cellIndex,
                            cellElement: targetCell,
                            data: record
                        };
                        var currentCellIndex;
                        if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)
                            currentCellIndex = proxy._getCellIndex(proxy._selectedCellDetails, "cellElement").indexOf(targetCell);
                        else
                            currentCellIndex = proxy._selectedCellDetails.map(function (e) { return e.cellElement; }).indexOf(targetCell);

                        
                        if (currentCellIndex == -1) {
                            proxy._selectedCellDetails.push(selectedCellInfo);
                            model.selectedCellIndexes.push({ rowIndex: selectedCellInfo.rowIndex, cellIndex: selectedCellInfo.cellIndex });
                        }
                        proxy._cellSelectedEventTrigger({ rowIndex: indexes[index].rowIndex, cellIndex: indexes[index].cellIndex, rowElement: $targetRow, cellElement: targetCell }, proxy._previousSelectedCellDetails);
                        proxy._previousSelectedCellDetails = {
                            rowElement: $targetRow,
                            cellElement: targetCell,
                            cellIndex: indexes[index].cellIndex,
                            rowIndex: indexes[index].rowIndex,
                        }
                        proxy._updateHorizontalScrollBar(columns[indexes[index].cellIndex].field);
                    }
                }
            }
            if (proxy._isShiftKeyNavigation == false) {
            //For selecting multiple cells with Shift key.
            proxy._shiftKeyFirstElementDetails.firstElementRowIndex = proxy._focusingRowIndex;
            proxy._shiftKeyFirstElementDetails.firstElementCellIndex = proxy._cellIndex;
            //Get back Default values for key board navigation.           
            proxy._rowIndexOfLastSelectedCell = selectedCellInfo ? selectedCellInfo.rowIndex : proxy._rowIndexOfLastSelectedCell;
            proxy._lastSelectedCellIndex = proxy._cellIndex;
            }
        },

        //SELECT THE ROW IN TREEGRID
        selectRows: function (rowIndex, toIndex, isCheckbox) {

            var proxy = this,
                model = proxy.model;

            var $gridRows = proxy.getRows(),
            selectedItem;
            if (model.selectionSettings.selectionMode == "cell" && rowIndex != -1)
                return;
            if (ej.TreeGrid.getRowByIndex(proxy, rowIndex).hasClass("e-summaryrow"))
                return;
            if ((model.editSettings.allowEditing || model.editSettings.allowAdding) && !proxy._isRowEdit && model.editSettings.beginEditAction != "click") {
                if ($("#" + proxy._id + "EditForm").length > 0 && proxy.endEdit()) {
                    $gridRows = proxy.getRows();
                    return;
                }
            }
            if (this._frozenColumnsLength > 0)
                $gridRows = $(proxy.getRows()[0]);

             var updatedRecords = proxy.getUpdatedRecords();

            if (ej.isNullOrUndefined(toIndex) || ej.isNullOrUndefined(rowIndex)) {

                rowIndex = ej.isNullOrUndefined(rowIndex) ? toIndex : rowIndex;        

                switch (model.selectionSettings.selectionType) {

                    case ej.TreeGrid.SelectionType.Checkbox:
                        var currentRecord = updatedRecords[rowIndex];

                        proxy.clearSelection(-1)
                        if (isCheckbox) {
                            var checkboxState = (currentRecord.checkboxState == "unchecked") ? "checked" : "unchecked";
                            proxy._traverseSelection(currentRecord, checkboxState, false);
                            proxy.selectAllRows();
                        }

                        if (updatedRecords[rowIndex] && !updatedRecords[rowIndex].isSelected) {
                            if (model.allowSelection)
                                ej.TreeGrid.getRowByIndex(proxy, rowIndex).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                            updatedRecords[rowIndex].isSelected = true;
                            model.selectedItem = updatedRecords[rowIndex];
                        }
                        if (proxy._prevSelectedItem && proxy._prevSelectedItem != model.selectedItem) {
                            proxy._prevSelectedItem.isSelected = false;
                        }



                        proxy._prevSelectedItem = updatedRecords[rowIndex];
                        this.selectedRowIndex(rowIndex);
                        return false;                                                    
                        case ej.TreeGrid.SelectionType.Multiple:                        

                            if (proxy._multiSelectCtrlRequest) {
                            var currentRecord = updatedRecords[rowIndex],
                            selectedRowIndex = $.inArray(currentRecord, model.selectedItems);
                            proxy._prevSelectedItem = updatedRecords[rowIndex];
                                if (selectedRowIndex != -1) {
                                    proxy.clearSelection(rowIndex);
                                model.selectedItems.splice(selectedRowIndex, 1);
                                currentRecord.isSelected = false;
                                model.selectedItem = model.selectedItems.length > 0 ? model.selectedItems[model.selectedItems.length - 1] : null;
                                }

                                if (selectedRowIndex == -1) {
                                model.selectedItems.push(currentRecord);
                                    if (model.allowSelection)
                                        ej.TreeGrid.getRowByIndex(proxy, rowIndex).attr("aria-selected", "true").find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active").attr("tabindex", "0");
                                currentRecord.isSelected = true;
                                model.selectedItem = updatedRecords[rowIndex];
                                }
                                break;
                            }
                            

                        case ej.TreeGrid.SelectionType.Single:
                            proxy.clearSelection(-1);
                            model.selectedItem = null;
                            if (rowIndex <= updatedRecords.length - 1) {
                            (rowIndex != -1) && model.selectedItems.push(updatedRecords[rowIndex]);
                            proxy._prevSelectedItem = updatedRecords[rowIndex];
                                if (model.allowSelection)
                                    ej.TreeGrid.getRowByIndex(proxy, rowIndex).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                                if (updatedRecords[rowIndex]) {
                                    updatedRecords[rowIndex].isSelected = true;  //Selection issue Changes
                                    model.selectedItem = updatedRecords[rowIndex];
                                }
                                
                            if (proxy._prevSelectedItem && proxy._prevSelectedItem != model.selectedItem) {
                                proxy._prevSelectedItem.isSelected = false;
                                }

                            }
                            break;
                    }
                if (model.selectedItems.length && model.selectedItems.indexOf(updatedRecords[rowIndex]) != -1) {
                    proxy._prevSelectedItem = updatedRecords[rowIndex];
                    if (this.selectedRowIndex() != rowIndex) {
                        this.selectedRowIndex(rowIndex);
                    }
              
                }
                else if (model.selectedItems.length == 0 && this.selectedRowIndex() != -1) {
                    this.selectedRowIndex(-1);
            } else {
                    this.selectedRowIndex(model.updatedRecords.indexOf(model.selectedItems[model.selectedItems.length - 1]));
                }

            } else {

                if (model.selectionSettings.selectionType == ej.TreeGrid.SelectionType.Multiple) {
                proxy.clearSelection(-1);
                    proxy.selectedRowIndex(rowIndex);
                    model.selectedItem = model.updatedRecords[rowIndex];
                    var count = 0,
                    records = rowIndex - toIndex < 0 ? updatedRecords.slice(rowIndex, toIndex + 1) : updatedRecords.slice(toIndex, rowIndex + 1),
                    row, updatedRowIndex, tempRows;
                    for (count; count < records.length; count++) {
                        if (proxy.getExpandStatus(records[count])) {
                            records[count].isSelected = true;
                            updatedRowIndex = updatedRecords.indexOf(records[count]);
                            row = ej.TreeGrid.getRowByIndex(proxy, updatedRowIndex);
                    if (this._frozenColumnsLength) {
                                tempRows = $(row[0]).add(row[1]);
                                row = row[0];
                    } else {
                                tempRows = row;
                    }
                            tempRows && $(tempRows).find('.e-rowcell,.e-detailsrowcell').addClass(" e-selectionbackground e-active");
                    }
                }

                }
            }

            model.selectedItems = proxy.getSelectedRecords();
            proxy._multiSelectCtrlRequest = false;
            if(model.isFromGantt)
               proxy._cancelSaveTools();
            return false;
        },

        /* Get all selected records from treegrid*/
        getSelectedRecords: function () {
            var proxy = this,
                model = this.model,
                selectedRecords = [];
            selectedRecords = model.updatedRecords.filter(function (record) {
                return record.isSelected;
            });
            return selectedRecords.slice();
        },
        /* Clear all selected rows and cells*/
        clearAllSelection: function () {
            var proxy = this,
                model = this.model;
            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }
            proxy.selectRows(-1);
            model.selectedItem = null;

            //To clear cell Selections
            proxy._selectedCellDetails = [];
            model.selectedCellIndexes = [];            
            proxy._rowIndexOfLastSelectedCell = -1;
            proxy._lastSelectedCellIndex = -1;
            proxy._focusingRowIndex = -1;
            $("#" + proxy._id).find(".e-selectingcell").removeClass("e-selectingcell");

            proxy._cancelSaveTools();
        },
        //GET THE CURRENTCELLINDEX
        getCellIndex: function (e, target) {

            var $target = $(e.target),
                cellIndex = -1,
                model =this.model;

            if (target) $target = $(target);
            if ($target.hasClass("e-detailsrowcell") || $target.closest("td").hasClass("e-detailsrowcell"))
                return -1;
            if ($target.prop("tagName") == "TD") {
                cellIndex =  $target.index();
            } else if ($target.prop('tagName') == "DIV" && $target.hasClass('e-cell')) {

                var $td = $target.closest('td');
                cellIndex = $td.index();

            } else if ($target.prop('tagName') == "DIV" && $($target.closest('td')[0]).hasClass("e-templatecell")) {

                var $td = $target.closest('td');
                cellIndex = $td.index();
            }
            else if ($($target.closest('td')[0]).hasClass("e-templatecell") && $($target.closest("tr")[0]).hasClass("e-templaterow")) {

                var $td = $target.closest('td');
                cellIndex = $td.index();
            }
            else if ($target.parent().prop("tagName") == "TD") {
                var $td = $target.closest('td');
                cellIndex = $target.parent().index();
            }
            else if ($target.prop("tagName") == "TH" || ($target.prop("tagName") == "DIV" && $($target.closest("th")[0]).css("cursor") == "col-resize")) {
                var $th,
                    $targetElement = $target.prop("tagName") == "TH" ? $($target) : $target.closest("th");
                var location = $target[0].getBoundingClientRect();
                var scrollLeft = navigator.userAgent.indexOf("WebKit") != -1 ? document.body.scrollLeft : document.documentElement.scrollLeft;
                if (this._orgX < location.left + 5 + scrollLeft)
                    cellIndex = $targetElement.prevAll(":visible:first")[0].cellIndex;
                else
                    cellIndex = $targetElement.index();
            }
            else if ($target.closest("td.e-rowcell").length > 0) {
                var $td = $target.closest('td.e-rowcell');
                cellIndex = $td.index();
            }

            /*get cellIndex with frozen columns*/
            if (cellIndex != -1 && this._frozenColumnsLength > 0 && ($target.closest(".e-movablecontentdiv").length > 0 || $target.closest(".e-movableheaderdiv").length > 0 || $target.closest(".e-movablefooterdiv").length > 0))
                cellIndex += this._frozenColumnsLength;
            return cellIndex;
        },


        //GET THE CURRENT ROW INDEX
        getRowIndex: function (e) {

            var proxy = this,
                $target = $(e.target),
                $gridRows = proxy.getRows(),
                index = -1,
                model = this.model;

            if ($target.closest('.e-gridcontainer').length > 0) {
                if (this._frozenColumnsLength > 0) {
                    if ($target.closest(".e-frozencontentdiv").length > 0 || $target.closest(".e-frozencontainer").length > 0)
                        $gridRows = $($gridRows[0]);
                    else if ($target.closest(".e-movablecontentdiv").length > 0 || $target.closest(".e-movablecontainer").length > 0)
                        $gridRows = $($gridRows[1]);
                        else
                            return index;
                    }
                    index = $gridRows.index($target);
                    if (index == -1) {
                        var row = $target.closest('tr');
                        index = $gridRows.index(row);

                    }       

                return index;
            }
        },

        //Cancel the edited cell and row
        _cancelEditState: function (e) {
            var proxy = this;
            if (!ej.isNullOrUndefined(e)) {
                if (!ej.isNullOrUndefined(e.target))
                    e.stopImmediatePropagation();
                /*Change scrollLeft of content while header is auto scrolled on filtering element focus*/
                var scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft"),
                    headerScrollLeft = 0;
                if (this._frozenColumnsLength > 0)
                    headerScrollLeft = proxy._$gridHeaderContainer.find("#e-movableheader" + this._id).scrollLeft();
                else
                    headerScrollLeft = proxy._$gridHeaderContainer.scrollLeft();
                if (scrollLeft != headerScrollLeft) {
                    proxy.getScrollElement().ejScroller("option", "scrollLeft", headerScrollLeft);
                    if (proxy.model.showTotalSummary && proxy._$footerContainer) {
                        if (this._frozenColumnsLength > 0)
                            proxy._$footerContainer.find("#e-movablefooter" + this._id).scrollLeft(headerScrollLeft);
                        else
                            proxy._$footerContainer.scrollLeft(headerScrollLeft);
                    }
                }
            }
            if (proxy.model.isEdit)
                proxy.cancelEditCell();
            else if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
        },

        //cancel the editMode of the cell
        cancelEditCell: function (e) {

            var proxy = this,
                model = proxy.model,
                tr,
                data = proxy.model.selectedItem,
                cell, cellIndex = proxy._cellEditingDetails.columnIndex,
                args = {}, column = model.columns[cellIndex];
            if (model.isFromGantt && !model.isEdit)
                return true;
            args = {
                columnName: column.field,
                value: proxy.getCurrentEditCellData(),
                data: proxy._cellEditingDetails.data,
                previousValue: proxy._cellEditingDetails.cellValue,
                columnObject: column,                
            };
            if (this._frozenColumnsLength > 0) {
                if (this._frozenColumnsLength <= proxy._cellEditingDetails.columnIndex) {
                    cellIndex = proxy._cellEditingDetails.columnIndex - this._frozenColumnsLength;
                    tr = $(proxy.getRows()[1])[proxy._cellEditingDetails.rowIndex];
                    if ($(tr).hasClass("e-editedrow"))
                        $(tr).removeClass("e-editedrow");
                    cell = tr.cells[cellIndex];
                    $(cell).removeClass("e-editedcell").empty().html(
                       $($.render[proxy._id + "_Template"](args.data))[0].cells[cellIndex].innerHTML
                    );
                } else {
                    tr = $(proxy.getRows()[0])[proxy._cellEditingDetails.rowIndex];
                    if ($(tr).hasClass("e-editedrow"))
                        $(tr).removeClass("e-editedrow");
                    cell = tr.cells[cellIndex];
                    $(cell).removeClass("e-editedcell").empty().html(
                      $($.render[proxy._id + "_JSONFrozenTemplate"](args.data))[0].cells[cellIndex].innerHTML
                    );
                }
            } else {
                tr = $(proxy.getRows())[proxy._cellEditingDetails.rowIndex];
                if ($(tr).hasClass("e-editedrow"))
                    $(tr).removeClass("e-editedrow");
                cell = tr.cells[cellIndex];
                $(cell).removeClass("e-editedcell").empty().html(
                    $($.render[proxy._id + "_Template"](args.data))[0].cells[cellIndex].innerHTML
                );
            }
            proxy._cellEventTrigger($(cell)[0], args.data, args.columnObject);
            proxy.model.isEdit = false;
            proxy._cancelSaveTools();
            proxy._trigger("refresh");
        },

        // To destroy the edit forms and popup menu
        _destroyWidgetElements:function()
        {
            var proxy = this, model = this.model, column = model.columns, columnLength = column.length,
                columnField;
            for (var i = 0; i < columnLength; i++) {
                columnField = proxy._getFieldValue(column[i].field,i);
                var $element = $("#" + proxy._id + columnField);
                $element.data("ejWidgets") && $element[$element.data("ejWidgets")[0]]("destroy");
            }
        },

        //Cancel row edit.
        cancelRowEditCell: function () {

            var proxy = this, model = this.model,
            //  To delete the empty added row when allowDeleting is false.
            temp = model.editSettings.allowDeleting,
            form = $(document.getElementById(proxy._id + "EditForm")), $tr,
            frozenForm = $("#" + proxy._id + "EditFrozenForm"), $frozenTr;
            if (form.length > 0)
                this._destroyWidgetElements();
            $tr = $(form.closest("tr"));
            $frozenTr = frozenForm.closest("tr");

            var rowIndex = proxy.getIndexByRow($tr),
            data = model.currentViewData[rowIndex];
            if (rowIndex == -1 && form.length == 0)
                return;
            
            if ($tr.hasClass('e-addedrow')) {
                if (!proxy.model.editSettings.allowDeleting)
                    proxy.model.editSettings.allowDeleting = true;
            }
            
            //Cancel the edited row.
            if ($tr.hasClass('e-editedrow')) {
                $tr.removeClass("e-editedrow").empty().html(
                    $($.render[proxy._id + "_Template"](data))[0].innerHTML);
                if ($frozenTr.length > 0) {
                    $frozenTr.removeClass("e-editedrow").empty().html(
                        $($.render[proxy._id + "_JSONFrozenTemplate"](data))[0].innerHTML);
                }
                proxy._rowEventTrigger($tr, data);
            }
            else if ($tr.hasClass('e-rowedit')) {
                $tr.removeClass("e-rowedit").empty().html(
                    $($.render[proxy._id + "_Template"](data))[0].innerHTML);
                if ($frozenTr.length > 0) {
                    $frozenTr.removeClass("e-rowedit").empty().html(
                        $($.render[proxy._id + "_JSONFrozenTemplate"](data))[0].innerHTML);
                }
                proxy._rowEventTrigger($tr, data);
            }               
            //Cancel the newly added row.
            else if ($tr.hasClass('e-addedrow')) {
                proxy._isRefreshAddedRecord = false;
                proxy._isEmptyRow = true;
			// Only checked records delete by toolbar action, hence passing it as contextMenu deletion
                if (proxy._checkboxSelection)
                    proxy.deleteRow(null, true, null);
                else
                    proxy.deleteRow();
                proxy._isEmptyRow = false;
            }           
            model.isEdit = proxy._isRowEdit = false;
            model.editSettings.allowDeleting = temp;
            proxy._updateWrapRowHeights("total,header", null, rowIndex);
            proxy._cancelSaveTools();
            proxy._trigger("refresh");
            if (proxy._commandColumnLength > 0) {
                var tr = ej.TreeGrid.getRowByIndex(proxy, proxy.getUpdatedRecords().indexOf(model.currentViewData[rowIndex]))
                proxy._refreshUnboundTemplate(tr);
            }
        },

        //RERENDERED THE EDITED RECORD
        refreshRow: function (index) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = model.allowPaging ? proxy._updatedPageData : model.updatedRecords,
                data = updatedRecords[index], eventArgs = {},
                editIndex = proxy.getIndexByRow($("#" + proxy._id + "EditForm").closest("tr"));
            if (model.enableVirtualization || model.allowPaging)
            {
                index = model.currentViewData.indexOf(data);
            }
            if (data && index > -1) {
                ej.TreeGrid.refreshRow(this, index);

                //var currentRefreshingRow = $(proxy.getRows()[index]);

                //if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                //    var detailsRow = currentRefreshingRow.next("tr");
                //    if (detailsRow.hasClass("e-detailsrow"))
                //        detailsRow.remove();
                //}
                //currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
                //proxy.setGridRows($(proxy.getContentTable().get(0).rows));

                //eventArgs.rowElement = $(proxy.getRows()[index])[0];
                //eventArgs.data = data;
                //proxy._trigger("refresh");
                //proxy._refreshedCellEventTrigger(eventArgs);

                // Check whether the edited index and refreshed index are same
                // If it is same either rowEdit or cellEdit is enable in particular row.
                // So update the _isRowEdit and isEdit value is false, and also update the toolbar item.s
                if (editIndex == index) {
                    proxy._isRowEdit = proxy.model.isEdit = false;
                    proxy._cancelSaveTools();
                }
            }
        },
        /* refresh the details row while cell editing */
        _refreshDetailsRow: function (index) {
            var proxy = this,
                model = this.model,
                data = proxy.model.currentViewData[index], eventArgs = {},
                gridRows = {};

            if (data) {
                if (this._frozenColumnsLength > 0)
                    gridRows = $(proxy.getRows()[1]);
                else
                    gridRows = $(proxy.getRows());

                var currentRefreshingRow = $(gridRows[index]).next("tr");
                if (currentRefreshingRow.hasClass("e-detailsrow")) {
                    currentRefreshingRow.remove();
                    var detailsRow = $($.render[proxy._id + "_detailRowTemplate"](data));
                    $(gridRows[index]).after(detailsRow);
                    proxy.setGridRows($(proxy.getContentTable().get(0).rows));
                    this._gridRows = this.getContentTable().get(0).rows;
                    if (this._frozenColumnsLength > 0)
                        this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];
                    proxy._trigger("refresh");
                    if (model.detailsDataBound) {
                        this._trigger("detailsDataBound", { detailsElement: detailsRow, data: data });
                    }
                }
            }
        },
        //Trigger rowDataBound and queryCellInfo event when row is refreshed
        _refreshedCellEventTrigger:function(eventArgs)
        {
            var proxy = this, model = this.model;
            if (model.queryCellInfo != null || model.rowDataBound != null || model.detailsDataBound != null) {
                if (model.rowDataBound != null){
                    proxy._trigger("rowDataBound", {
                        rowElement: eventArgs.rowElement,
                        data: eventArgs.data
                    });
                }

                var tdCells = eventArgs.rowElement.cells,
                $tdRowcells = $(eventArgs.rowElement).find(".e-rowcell"),
                cellIndex = 0,
                length = tdCells.length,
                column = null,
                columns = proxy.model.columns;

                if (model.queryCellInfo != null) {

                    for (cellIndex; cellIndex < length; cellIndex++) {
                        if ($(tdCells[cellIndex]).hasClass("e-rowcell")) {
                            column = columns[$tdRowcells.index(tdCells[cellIndex])];
                        }
                        if (column) {
                            proxy._cellEventTrigger(tdCells[cellIndex], eventArgs.data, column);
                        }
                    }
                }
                if (model.detailsDataBound && $(eventArgs.rowElement).next("tr").hasClass("e-detailsrow")) {
                    var detailsRowElement = $(eventArgs.rowElement).next("tr");
                    if (this._frozenColumnsLength > 0)
                        detailsRowElement = $(detailsRowElement[1]);
                    this._trigger("detailsDataBound", { detailsElement: $(eventArgs.rowElement).next("tr"), data: eventArgs.data });
                }
            }
        },

        _refreshGridPager: function () {
            if (this.getPager() != null) {
                var proxy = this,
                    model = proxy.model,
                     pagerModel = this.getPager().ejPager("model"), args = {};
                args.currentPage = this._currentPage();
                if (model.currentViewData.length == 0 && model.updatedRecords.length > 0) {
                    if (pagerModel.totalPages != 1) {
                        proxy.gotoPage(args.currentPage - 1);
                        return;
                    }                   
                }
                args.totalRecordsCount = proxy._isLoadonDemand ? proxy._pageRecordCountOnDemand :
                    proxy._isRemoteData ? model.pageSettings.totalRecordsCount : proxy._gridRecordsCount;
                this.getPager().ejPager("option", args).ejPager("refreshPager");                
                model.pageSettings.totalPages = pagerModel.totalPages || null;
                if (!proxy._isRemoteData)
                    model.pageSettings.totalRecordsCount = pagerModel.totalRecordsCount || null;
                proxy._updatePagerTextAlignment();
            }
        },
        /* get visible child record count in udpated records */
        _getVisibleChildRecordCount: function (data, count, collection) {
            var proxy = this, model = this.model, childRecords, length;

            if (data.hasChildRecords) {
                childRecords = data.childRecords;
                length = childRecords.length;
                for (var i = 0; i < length; i++) {
                    if (collection.indexOf(childRecords[i]) !== -1)
                        count++;
                    if (childRecords[i].hasChildRecords) {
                        count = proxy._getVisibleChildRecordCount(childRecords[i], count, collection);
                    }
                }
            }
            else {
                if (collection.indexOf(data) !== -1) {
                    count++;
                }
            }
            return count;
        },
        //Insert templated row in DOM for newly added record
        _renderAddedRow: function (index, data) {
            var proxy = this, model = this.model;
            proxy._updateCurrentViewData();
            if (model.enableVirtualization || model.allowPaging) {
                proxy.updateAltRow();
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy.sendDataRenderingRequest(tempArgs);
            }
            else {
                proxy.renderNewAddedRow(index, data);
            }
            proxy.updateHeight();
        },

        //insert new item in DOM 
        renderNewAddedRow:function(index, data)
        {
            var proxy = this, model = this.model, length,
                gridRows = proxy.getRows(),
                addedGridRow = $.render[this._id + "_Template"](data),
                isFrozenColumn = this._frozenColumnsLength > 0,
                addedFrozenRow,
                frozenTableRows;
            if (isFrozenColumn) {
                gridRows = $(proxy.getRows()[1]);
                frozenTableRows = $(proxy.getRows()[0]);
                addedFrozenRow = $.render[this._id + "_JSONFrozenTemplate"](data);
            }


            if (!ej.isNullOrUndefined(gridRows) && gridRows.length > 0) {
                if (gridRows.length == index) {
                    var insertPositionRow = gridRows.eq(index - 1),
                        insertPositionFrRow;
                    if (isFrozenColumn)
                        insertPositionFrRow = frozenTableRows.eq(index - 1);
                    /*check whether the next row is detail row or not */
                    if($(insertPositionRow).next("tr").hasClass("e-detailsrow"))
                    {
                        $(insertPositionRow).next("tr").after(addedGridRow);
                        isFrozenColumn && $(insertPositionFrRow).next("tr").after(addedFrozenRow);
                    }else
                    {
                        $(insertPositionRow).after(addedGridRow);
                        isFrozenColumn && $(insertPositionFrRow).after(addedFrozenRow);
                    }
                } else {
                    gridRows.eq(index).before(addedGridRow);
                    isFrozenColumn && frozenTableRows.eq(index).before(addedFrozenRow);
                }
            } else {
                if (this._frozenColumnsLength > 0)
                    proxy._renderFrozenRecords();
                else {
                    proxy.getContentTable().find('tbody').empty().append(proxy._getEmptyTbody());
                    var temp = document.createElement('div');
                    proxy.getContentTable().find("colgroup").first().replaceWith(proxy._getMetaColGroup());
                    var $tbody = proxy.getContentTable().children('tbody');
                    $tbody.empty();
                    temp.innerHTML = ['<table>', $.render[proxy._id + "_Template"](proxy.model.currentViewData),
                        '</table>'].join("");
                    proxy.getContentTable().get(0).replaceChild(temp.firstChild.firstChild,
                        proxy.getContentTable().get(0).lastChild);
                }
            }
            this._gridRows = this.getContentTable().get(0).rows;
            if (this._frozenColumnsLength > 0)
                this._gridRows = [this._gridRows, this.getContentTable().get(1).rows];

            proxy.setGridRows($(proxy.getContentTable().get(0).rows));
          
        },


        
        onScrollHelper: function (scrolltop, isFromChart) {
            var proxy = this;
            proxy._isFromChart = isFromChart;
            proxy.getScrollElement().ejScroller("scrollY", scrolltop, true);
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");
            if (!isHorizontalScroll && this.model.isFromGantt)
                proxy.getScrollElement().scrollTop(scrolltop);
        },

        isVScroll: function () {
            if (this.getScrollElement().hasClass("e-scroller")) {
                return this.getScrollElement().ejScroller("isVScroll");
            }
            else
            {
                return false;
            }
        },

        //REFRESH THE SCROLLER FOR TREEGRIDCONTENT
        refreshScroller:function(panSize){
            
            var proxy = this;
            proxy._$gridContent.removeClass("e-borderbox");
            
            var scrollTop = proxy.getScrollElement().ejScroller("option", "scrollTop");
            var scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");

            proxy.getScrollElement().ejScroller("option", { "persist": true });
            proxy.getScrollElement().ejScroller("option", { "width": panSize });
            
            var maxScrollWidth = proxy.getMaxScrollWidth();
            if (scrollLeft > maxScrollWidth)
                scrollLeft = maxScrollWidth > 0 ? maxScrollWidth : 0;

            proxy._$gridContent.css("height", proxy._viewPortHeight);
            proxy.getScrollElement().ejScroller("refresh");
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");

            if (proxy.model.isFromGantt)
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            proxy.getScrollElement().ejScroller("option", { "scrollTop": scrollTop });
            isHorizontalScroll && proxy.getScrollElement().ejScroller("option", { "scrollLeft": scrollLeft });
            proxy._$gridHeaderContainer.scrollLeft(scrollLeft);

            if (!isHorizontalScroll)
                this.getScrollElement().scrollTop(scrollTop);
            else {
                this.getScrollElement().scrollTop(0);
            }
        },
        getMaxScrollHeight: function () {
            var proxy = this;
            return proxy.getScrollElement().children(".e-content").children().height() - this.getScrollElement().children(".e-content").height();
        },
        getMaxScrollWidth:function()
        {
            var proxy=this;
            return proxy.getScrollElement().children(".e-content").find(".e-table").width() - this.getScrollElement().children(".e-content").width();
        },
        refreshHeight:function(){

            var proxy = this;
            proxy.getScrollElement().ejScroller("refresh");            

        },

		// Get the column using header text
        // argument headerText is column header text value

        getColumnByHeaderText: function (headerText) {
            var proxy = this;
            var length = proxy.model.columns.length;
            var columns = proxy.model.columns;
            for (var column = 0; column < length; column++) {
                if (columns[column]["headerText"] == headerText)
                    break;
            }
            return column == columns.length ? null : columns[column];
        },

        //Hide the column by using header text
        //argument headerText is column header text value
        
        hideColumn: function (headerText) {
            var proxy = this,
                model = proxy.model,
                column = this.getColumnByHeaderText(headerText),
                index = $.inArray(column, model.columns),
                hiddenColumnIndex = $.inArray(headerText, proxy._hiddenColumns);

            /* check this is single column in frozen or movable column*/
            if (column && !proxy._isColumnHidable(column))
                return;
            if (index != -1 && index != model.treeColumnIndex && hiddenColumnIndex == -1) {
                /* Cancel edited cell before sort the column*/
                proxy._cancelEditState();
                proxy._hiddenColumns.push(headerText);
                proxy.model.columns[index].visible = false;
               
				//Table column width not properly set in firefox, so just remove and add the e-table class from both header and content table
                proxy.getHeaderTable().removeClass("e-table");
                proxy.getContentTable().removeClass("e-table");
                var headerColgroup = proxy.getHeaderTable().find('colgroup').find("col");
                $(headerColgroup).eq(index).hide();
                var headerRows = proxy.getHeaderTable().find('thead').find("th.e-headercell");
                $(headerRows).eq(index).addClass("e-hide");
                if (model.allowFiltering && model.filterSettings.filterType == "filterbar") {
                    var headerrows = proxy.getHeaderTable().find('thead').find("th.e-filterbarcell");
                    $(headerrows).eq(index).addClass("e-hide");
                }
                if (proxy.model.columns[index].isFrozen == true) {
                    proxy.setWidthToColumns();
                }
                var gridrows = proxy.getContentTable().find("colgroup").find("col"),
                    isFrozenTable = true, cellIndex = index, footerRows;
                $(gridrows).eq(index).hide();
                gridrows = proxy.getRows();
                footerRows = this._getFooterRows();
                //hidding the specified column
                if (this._frozenColumnsLength > 0) {
                    if (index < this._frozenColumnsLength) {
                        gridrows = $(proxy.getRows()[0]);
                        footerRows = $(footerRows[0]);
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                        }
                    }
                    else {
                        gridrows = $(proxy.getRows()[1]);
                        footerRows = $(footerRows[1]);
                        isFrozenTable = false;
                        cellIndex = index - this._frozenColumnsLength;
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                        }
                    }
                } else {
                    if (proxy._gridRows && $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan - 1);
                    }
                }
                
                gridrows.each(function () {
                    var td = $(this).children("td").eq(cellIndex);
                    $(td).addClass("e-hide");
                    if (model.showSummaryRow && $(td).hasClass('e-summaryrowcell') && isFrozenTable)
                        proxy._updateSummaryRowTitleCell(headerColgroup, td[0].parentElement);
                });
                //Hide the specific column from total summary row.
                if (model.showTotalSummary) {
                    var footerColGroup = proxy._$footertableContent.find("colgroup").find("col");
                    $(footerColGroup).eq(index).hide();
                    footerRows.each(function () {
                        var footerSummarytd = $(this).children("td").eq(cellIndex);
                        $(footerSummarytd).addClass("e-hide");
                        if ($(footerSummarytd).hasClass('e-footersummaryrowcell'))
                            proxy._updateSummaryRowTitleCell(footerColGroup, footerSummarytd[0].parentElement);
                    });
                }
                proxy.getHeaderTable().addClass("e-table");
                proxy.getContentTable().addClass("e-table");
                var gridContent = proxy.getScrollElement();
                if (model.isFromGantt) {
                    var isHorizontalScroll = gridContent.ejScroller("isHScroll");
                    if (!isHorizontalScroll)
                        gridContent.addClass("e-borderbox");
                    else
                        gridContent.removeClass("e-borderbox");
                }
                if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                    this._updateTableWidth();
                gridContent.ejScroller("refresh");
                proxy._updateScrollCss();                
                proxy._updateHeaderScrollLeft();
                /* update scrollTop in gantt when treegrid horizontal scroller not exist*/
                if (model.isFromGantt && !gridContent.ejScroller("isHScroll")) {
                    gridContent.scrollTop(gridContent.data("ejScroller").scrollTop());
                }
                index = $.inArray(headerText, proxy._visibleColumns);
                if (index != -1)
                    proxy._visibleColumns.splice(index, 1);
                if (model.showColumnChooser) {
                    proxy._renderColumnChooserList(true, headerText);
                    proxy._updateColumnMenuVisibility();
                }
                proxy._addInitTemplate();
                if (model.editSettings.allowEditing && model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (model.editSettings.allowEditing && model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            //Updating the column properties to Gantt's model.columns
            if (model.isFromGantt)
                proxy.updateToGanttColumns();
        },

        //Clear the filter based on fieldName.
        //clearFilter method without argumentment means, it clear the all filter in tree grid.
        clearFilter: function (fieldName) {
            var proxy = this,
                model = proxy.model;
            if (ej.isNullOrUndefined(fieldName)) {
                var filteredColumns = model.filterSettings.filteredColumns,
                    length = filteredColumns && filteredColumns.length;
                //Loop for clearing all the filter in tree grid
                while (filteredColumns && filteredColumns.length > 0) {
                    proxy.clearFilter(filteredColumns[0].field);
                }

            } else {
                var column = proxy.getColumnByField(fieldName),
                    filteredColumn = $.grep(model.filterSettings.filteredColumns, function (filterColumn, index) {
                        return filterColumn.field === fieldName;
                    });
                if (column && filteredColumn.length > 0) {
                    /*Skip the filterColumn method for numeric textbox in immediate filterbar mode.
                      Because while set the empty value to numeric text box, it automatically triiger filterBarHanlder method*/
                    if (!(model.filterBarMode == "immediate" && column.filterEditType == "numericedit")) {
                        proxy._searchString = "";
                        proxy._fieldName = "";
                        proxy.filterColumn(fieldName, "equal", "", "and");
                        proxy._storePreviousFilteredValue(proxy._fieldName, proxy._searchString, this._operator);
                    }
                    proxy._clearFilterElementValue(column);
                }
            }
        },

        //Get the column details based on the given field in tree grid
        getColumnByField: function (fieldName) {
            var proxy = this,
              model = proxy.model,
              columns = model.columns;
            for (var index = 0; index < columns.length; index++) {
                if (columns[index]["field"] == fieldName)
                    break;
            }
            return index == columns.length ? null : columns[index]; //If field name not available in column collection, it returns null value.
        },

        //Set the empty value to filter input elements
        _clearFilterElementValue: function (column) {
            var proxy = this, columnField = column.field.split('.').join(""),
                element = $("#" + proxy._id + "_" + columnField + "_filterbarcell");
            switch (column.filterEditType) {
                case "stringedit":
                    $(element).val("");
                    break;
                case "booleanedit":
                    $(element).prop("checked", false);
                    break;
                case "numericedit":
                    $(element).ejNumericTextbox("instance").option("value", "");
                    break;
                case "dropdownedit":
                    $(element).ejDropDownList("instance").option("value", "");
                    break;
                case "datepicker":
                    $(element).ejDatePicker("instance").option("value", "");
                    break;
                case "datetimepicker":
                    $(element).ejDateTimePicker("instance").option("value", "");
                    break;
            }
        },

        //To maintain the summary row title after hide/show the column using columnChooser.
        _updateSummaryRowTitleCell: function (colgroup, summaryRow) {
            var length = colgroup.length;
            for (var cell = 0; cell < length; cell++) {
                if ($(colgroup[cell]).css('display') == 'none')
                    continue;
                var summaryTitleElement = $(summaryRow).find(".e-summarytitle")[0],
                    currentColumnSummaryTitle = $(summaryRow.childNodes[cell]).find(".e-summarytitle")[0];
                if (currentColumnSummaryTitle)
                    return;
                else
                    $(summaryRow.childNodes[cell]).append(summaryTitleElement);
                return;

            }

        },
        //to update the frozen column width on resizing
        _updateFrozenColumnOnResize: function (index) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns;
            var frozenWidth = this._getFrozenColumnWidth();
            if (frozenWidth + 18 > this._gridWidth) {
                var max_width = 0,
                    max_index = -1;
                for (var i = 0; i < proxy._frozenColumnsLength; i++) {
                    if (columns[i].visible == true) {
                        if (max_width < columns[i].width) {
                            max_width = columns[i].width;
                            max_index = i;
                        }
                    }
                }
                //update max column width
                if (columns[index].width < (max_width - model.commonWidth)) {
                    if (columns[max_index].width == max_width) {
                        columns[max_index].width = proxy.columnsWidthCollection[max_index] = columns[max_index].width - columns[index].width;
                    }
                }
                else {
                    //if column doesnot have max width reduce all frozen widths
                    if (model.columns[index].width > model.commonWidth)
                        model.columns[index].width = model.commonWidth;
                    var modifiedFrozenWidth = Math.round(columns[index].width / proxy._frozenColumnsLength);
                    for (var i = 0; i < proxy._frozenColumnsLength; i++) {
                        if (columns[i].isFrozen == true && columns[i].visible == true) {
                            columns[i].width = proxy.columnsWidthCollection[i] = columns[i].width - modifiedFrozenWidth;
                        }
                    }
                }

            }            
        },

        //Show the column by using header text
        // argument headerText is column header text value

        
        showColumn: function (headerText) {
            var proxy = this,
                model = proxy.model,
                column = this.getColumnByHeaderText(headerText),
                index = $.inArray(column, model.columns),
                visibleColumnIndex = $.inArray(headerText, proxy._visibleColumns);
            if (index != -1 && visibleColumnIndex == -1) {
                /* Cancel edited cell before sort the column*/
                proxy._cancelEditState();
                proxy._visibleColumns.push(headerText);
                proxy.model.columns[index].visible = true;
                var headerColgroup = proxy.getHeaderTable().find('colgroup').find("col");
                $(headerColgroup).eq(index).show();
                var headerRows = proxy.getHeaderTable().find('thead').find("th.e-headercell");
                $(headerRows).eq(index).removeClass("e-hide");
                if (model.allowFiltering && model.filterSettings.filterType == "filterbar") {
                    var headerrows = proxy.getHeaderTable().find('thead').find("th.e-filterbarcell");
                    $(headerrows).eq(index).removeClass("e-hide");
                }
                if (proxy.model.columns[index].isFrozen == true) {
                    proxy._updateFrozenColumnOnResize(index);                  
                    proxy.setWidthToColumns();
                }               
                var gridrows = proxy.getContentTable().find("colgroup").find("col"),
                    isFrozenTable = true, cellIndex = index, footerRows;
                $(gridrows).eq(index).show();
                gridrows = proxy.getRows();
                footerRows = this._getFooterRows();

                if (this._frozenColumnsLength > 0) {
                    if (index < this._frozenColumnsLength) {
                        gridrows = $(proxy.getRows()[0]);
                        footerRows = $(footerRows[0]);
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[0]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                        }
                    }
                    else {
                        gridrows = $(proxy.getRows()[1]);
                        footerRows = $(footerRows[1]);
                        isFrozenTable = false;
                        cellIndex = index - this._frozenColumnsLength;
                        if (proxy._gridRows && $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                            var tempColSpan = parseInt($(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                            $(proxy.getTreeGridRows()[1]).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                        }
                    }
                } else {
                    if (proxy._gridRows && $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").length > 0) {
                        var tempColSpan = parseInt($(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan"));
                        $(proxy.getTreeGridRows()).find(".e-detailscellwrapper").parent(".e-detailsrowcell").attr("colspan", tempColSpan + 1);
                    }
                }


				//Display the specified column
                gridrows.each(function () {
                    var td = $(this).children("td").eq(cellIndex);
                    $(td).removeClass("e-hide");
                    if (model.showSummaryRow && $(td).hasClass('e-summaryrowcell') && isFrozenTable)
                        proxy._updateSummaryRowTitleCell(headerColgroup, td[0].parentElement);
                });
                //Show the specific column from total summary row.
                if (model.showTotalSummary) {
                    var footerColGroup = proxy._$footertableContent.find("colgroup").find("col");
                    $(footerColGroup).eq(index).show();
                    footerRows.each(function () {
                        var footerSummarytd = $(this).children("td").eq(cellIndex);
                        $(footerSummarytd).removeClass("e-hide");
                        if ($(footerSummarytd).hasClass('e-footersummaryrowcell'))
                            proxy._updateSummaryRowTitleCell(footerColGroup, footerSummarytd[0].parentElement);
                    });
                }
                proxy._addInitTemplate();
                var gridContent = proxy.getScrollElement();
                if (model.isFromGantt) {
                    var isHorizontalScroll = gridContent.ejScroller("isHScroll");
                    if (!isHorizontalScroll) {
                        gridContent.addClass("e-borderbox");
                    }
                    else {
                        gridContent.removeClass("e-borderbox");
                    }
                }
                if (model.columnResizeSettings.columnResizeMode == ej.TreeGrid.ColumnResizeMode.FixedColumns && !model.isFromGantt)
                    this._updateTableWidth();
                gridContent.ejScroller("refresh");
                proxy._updateScrollCss();
                proxy._updateHeaderScrollLeft();
                /* update scrollTop in gantt when treegrid horizontal scroller not exist*/
                if (model.isFromGantt && !gridContent.ejScroller("isHScroll")) {
                    gridContent.scrollTop(gridContent.data("ejScroller").scrollTop());
                }
                index = $.inArray(headerText, proxy._hiddenColumns);
                if (index != -1)
                    proxy._hiddenColumns.splice(index, 1);
                if (model.showColumnChooser) {
                    proxy._renderColumnChooserList(true, headerText);
                    proxy._updateColumnMenuVisibility();
                }
                if (model.editSettings.allowEditing && model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (model.editSettings.allowEditing && model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            //Updating the column properties to Gantt's model.columns
            if (model.isFromGantt)
                proxy.updateToGanttColumns();
        },

        // Get the hidden columns detail in tree grid
        getHiddenColumns: function () {
            var proxy = this,
                model = proxy.model,
                hiddenColumn = proxy._hiddenColumns,
                length = hiddenColumn.length,
                hiddenColumns = [];
            for (var i = 0; i < length; i++)
                hiddenColumns.push(proxy.getColumnByHeaderText(hiddenColumn[i])); //Get the column by using header text
            return hiddenColumns;

        },

        // Get the column details based on the given column index in tree grid
        getColumnByIndex: function (index) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns;
            if (columns.length > index)
                return columns[index];
            return null;
        },

        // Get the visible columns detail in tree grid
        getVisibleColumns: function () {
            var proxy = this,
                model = proxy.model,
                visibleColumn = proxy._visibleColumns,
                length = visibleColumn.length,
                visibleColumns = [];
            for (var i = 0; i < length; i++)
                visibleColumns.push(proxy.getColumnByHeaderText(visibleColumn[i])); //Get the column by using header text
            return visibleColumns;

        },

        //Cancel the edit cell or row based on editing.
        cancelEdit: function () {
            if (this._isRowEdit)
                this.cancelRowEditCell();
            else if (this.model.isEdit)
                this.cancelEditCell();
        },

        //Rerender the tree grid content.
        redraw: function () {
            this.resetModelCollections();
            this._clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
            this.element.empty();
            /*Remove all events binded in treegrid*/
            this.element.off();
            var matched = jQuery.uaMatch(navigator.userAgent),
                proxy = this, model = this.model;

            proxy._off(proxy.element, "click", proxy._onClick);
            proxy._off(proxy.element, "keydown", proxy._keyDown);
            proxy._off(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._off(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._off($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._off(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);
            proxy._off(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",

            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }
            proxy._off(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._off(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip && !proxy.model.showGridExpandCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
                }
            }
            else {
                proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-headercelldiv", proxy._headermouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
                }
            }
            proxy._off(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._headerMouseLeave);

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._off($(window), "resize", proxy._windowResize);
            }
            if (ej.isTouchDevice())
                proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
            else
                proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._off(proxy.element, "keyup contextmenu taphold", this._preventContextMenu);
            }                        
            
            /*Redraw all elements in treegrid toolbar, header,content and summary*/
            this._init();
        },

        // Public method for removing column menu
		clearColumnMenu:function()
        {
            var proxy=this;
            proxy._clearColumnMenu();
		},

		"export": function (action, serverEvent, multipleExport) {
		    var proxy = this,
                model = proxy.model;
		   
		    proxy.contextMenuOperations("Cancel"); // Cancel the edit row or empty newly added row.
		    var modelClone = proxy._getExportModel(model);
		    var attr = { action: action, method: 'post', "data-ajax": "false" };
		    $('form#' + proxy._id + 'export').remove();
		    var form = ej.buildTag('form#'+proxy._id+'export', "", null, attr);
		    if (ej.raiseWebFormsServerEvents) {
		        var args = { model: modelClone, originalEventType: serverEvent };
		        var clientArgs = { model: JSON.stringify(modelClone) };
		        ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
		    }
		    else {
		        var treegridObjectArray = {};
		        if (multipleExport) {
		            $('body').find('.e-treegrid').each(function (index, object) {
		                var gridObject = $(object).data('ejTreeGrid');
		                if (!ej.isNullOrUndefined(gridObject)) {
		                    var gridmodel = gridObject.model,
		                        modelClone = proxy._getExportModel(gridmodel);
		                        treegridObjectArray[index] = JSON.stringify(modelClone);
		                        var inputAttr = { name: 'TreeGridModel', type: 'hidden', value: JSON.stringify(modelClone) };
		                        var input = ej.buildTag('input', "", null, inputAttr);
		                        form.append(input);
		                }
		            });
		        }
		        else {
		            var inputAttr = { name: 'TreeGridModel', type: 'hidden', value: JSON.stringify(modelClone) };
		            var input = ej.buildTag('input', "", null, inputAttr);
		            form.append(input);
		            form.append(this);
		        }
		        $('body').append(form);
		        form.submit();
		    }
		    return true;
		},

        //#endregion

        //#region PRIVATE METHODS

		_getExportModel: function (treegridModel) {
		    var proxy = this,
		        model = treegridModel,
		        updatedRecords = model.updatedRecords,
                currentViewData = model.currentViewData,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                summaryRowRecords = model.summaryRowRecords,
                selectedItem = model.selectedItem,
                selectedItems = model.selectedItems;
		    // Delete the below internal items in model for avoid the circular reference while extend the model
		    delete model.updatedRecords;
		    delete model.currentViewData;
		    delete model.flatRecords;
		    delete model.parentRecords;
		    delete model.summaryRowRecords;
		    delete model.selectedItem;
		    delete model.selectedItems;
		    var modelClone = $.extend(true, {}, model);
		    model.updatedRecords = updatedRecords;
		    model.currentViewData = currentViewData;
		    model.flatRecords = flatRecords;
		    model.parentRecords = parentRecords;
		    model.selectedItem = selectedItem;
		    model.selectedItems = selectedItems;
		    model.summaryRowRecords = summaryRowRecords;
		    var columns = modelClone.columns,
                columnLength = columns.length,
                filteredColumns = modelClone.filterSettings.filteredColumns,
                filterColumnLength = filteredColumns.length;
		    for (var i = 0; i < columnLength; i++) {
		        if (modelClone.columns[i].editType != undefined) {
		            switch (columns[i].editType) {
		                case "stringedit":
		                case "edittemplate":
		                    columns[i].editType = "string";
		                    break;
		                case "numericedit":
		                    columns[i].editType = "numeric";
		                    break;
		                case "dropdownedit":
		                    columns[i].editType = "dropdown";
		                    break;
		                case "booleanedit":
		                    columns[i].editType = "boolean";
		                    break;
		                default:
		                    break;
		            }
		        }
		        if (columns[i].filterEditType != undefined) {
		            switch (columns[i].filterEditType) {
		                case "stringedit":
		                    columns[i].filterEditType = "string";
		                    break;
		                case "numericedit":
		                    columns[i].filterEditType = "numeric";
		                    break;
		                case "dropdownedit":
		                    columns[i].filterEditType = "dropdown";
		                    break;
		                case "booleanedit":
		                    columns[i].filterEditType = "boolean";
		                    break;
		                default:
		                    break;
		            }
		        }
		    }
		    for (var i = 0; i < filterColumnLength; i++) {
		        if (filteredColumns[i].operator == "equal")
		            filteredColumns[i].operator = "equals";
		        else if (modelClone.filterSettings.filteredColumns[i].operator == "notequal")
		            filteredColumns[i].operator = "notequals";
		    }
		    var ignoreOnExport = proxy.ignoreOnExport,
                igonreLength = ignoreOnExport.length;
		    if (proxy.ignoreOnExport) {
		        for (var i = 0; i < igonreLength; i++) {
		            delete modelClone[ignoreOnExport[i]];
		        }
		    }
		    return modelClone;
		},

		_getNonContentHeight: function(){
		    var proxy = this, model = proxy.model,
                height = 0, borderTopWidth = 0;
		    borderTopWidth = proxy.model.isFromGantt ? 0 : 1;
		    height = proxy._$gridHeaderContent.outerHeight() + parseFloat(borderTopWidth);
		    if (proxy.model.toolbarSettings.showToolbar) {
		        height += !ej.isNullOrUndefined($("#" + proxy._id + "_toolbarItems").outerHeight()) ?$("#" + proxy._id + "_toolbarItems").outerHeight():0;
		    }
		    if (model.allowPaging)
		        height += proxy.element.find('.e-pager').outerHeight();		    	    

		    return height;
                
		},
        //CALCULATE THE VIEWPORTHEIGHT
		_getViewPortHeight: function () {		    
		    return (this.element.height() - this._getNonContentHeight());
        },

        updateViewPortHeight: function () {
            var proxy = this;
            proxy._viewPortHeight = proxy._getViewPortHeight();
        },

        _updateScrollCss: function () {
            var proxy = this,
                model = proxy.model;
            if (!model.isFromGantt) {
                var isVscroll = proxy.isVScroll(),
                    isPaddingExist = proxy._$gridHeaderContent.hasClass("e-scrollcss");
                var isSafari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor);
                if (isSafari)
                    proxy._$gridHeaderContent.removeClass("e-gridheader");
                if (isVscroll) {
                    if (!this.mobileDevice())
                    proxy._$gridHeaderContent.addClass("e-scrollcss");
                    if (model.showTotalSummary && proxy._$totalSummaryRowContainer && proxy._$totalSummaryRowContainer.height() <= 90 && proxy._$totalSummaryRowContainer.find(".e-vscrollbar").length == 0) {
                        if (!this.mobileDevice())
                            proxy._$totalSummaryRowContainer.addClass("e-scrollcss");
                        if (!this.mobileDevice())
                            proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width() - 17);
                        else
                            proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width());
                    }
                } else {
                    proxy._$gridHeaderContent.removeClass("e-scrollcss");
                    if (model.showTotalSummary && proxy._$totalSummaryRowContainer && proxy._$totalSummaryRowContainer.height() <= 90) {
                        proxy._$totalSummaryRowContainer.removeClass("e-scrollcss");
                        proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width());
                    }
                }
                if (proxy.getScrollElement().hasClass("e-scroller"))
                this._updateHeaderScrollLeft(this.getScrollElement().ejScroller("model.scrollLeft"));
                //update frozenContainer height
                if (this._frozenColumnsLength) {
                    var movableContainerHeight = this.getContent().find("#e-movablecontent" + proxy._id).height();
                    if (movableContainerHeight != this.getContent().find("#e-frozencontainer" + proxy._id).height()) {
                        this.getContent().find("#e-frozencontainer" + proxy._id).height(movableContainerHeight);
                    }
                }
                // Tree grid header not properly aligned in safari browser.
                // Because dynamically add or remove any css class it not affected immediately in safari browser
                // So just refresh the tree grid header
                if (isSafari) {
                    proxy._$gridHeaderContent[0].style.width=proxy._gridWidth+"px";
                    proxy._$gridHeaderContent.addClass("e-gridheader");
                }
                    proxy._resizeFilteringElements();
            }
        },

        _updatePagerIndex: function(){
            var proxy = this,
                model = proxy.model,
                expandedRecords = [], endIndex = -1, startIndex = -1,
                updatedRecords = model.updatedRecords;
            if (model.allowPaging) {
                var pageSize = model.pageSettings.pageSize;

                if (model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root) {
                    var rootParentRecords = model.parentRecords.slice(),
                        index = -1, rootEndIndex = -1, rootStartIndex = -1;
                    proxy._gridRecordsCount = rootParentRecords.length;
                    var totalAvailablePages = proxy._isLoadonDemand == false ? (proxy._gridRecordsCount < 1) ? 0 : (pageSize == 0) ? 0 : Math.ceil(proxy._gridRecordsCount / pageSize) : Math.ceil(proxy._pageRecordCountOnDemand / pageSize);
                    if (proxy._currentPage() > totalAvailablePages)
                        proxy._currentPage(totalAvailablePages);
                    rootEndIndex = ((proxy._currentPage() * pageSize) > proxy._gridRecordsCount)? (proxy._gridRecordsCount) : (proxy._currentPage() * pageSize);
                    rootStartIndex = (proxy._gridRecordsCount <= pageSize) ? 0 : ((proxy._currentPage() * pageSize) - pageSize);                                     
                    endIndex = updatedRecords.indexOf(rootParentRecords[rootEndIndex]);
                    if (rootStartIndex > rootEndIndex)
                        rootStartIndex = rootEndIndex - pageSize;
                    else if (proxy._gridRecordsCount == rootEndIndex)
                        endIndex = updatedRecords.length;
                    startIndex = updatedRecords.indexOf(rootParentRecords[rootStartIndex]);                    
                    proxy._updatedPageData = this.getExpandedRecords(updatedRecords.slice(startIndex, endIndex));
                }
                else {
                    expandedRecords = this.getExpandedRecords(updatedRecords);
                    if (model.enableVirtualization) {
                        proxy._gridRecordsCount = updatedRecords.length;                        
                    }
                    else {                        
                        proxy._gridRecordsCount = expandedRecords.length;                        
                    }
                   
                    var currentTotalPages = (proxy._gridRecordsCount < 1) ? 0 : (pageSize == 0)? 0 : Math.ceil(proxy._gridRecordsCount / pageSize) ;
                    if (proxy._currentPage() > currentTotalPages)
                        proxy._currentPage(currentTotalPages);
                    endIndex = ((proxy._currentPage() * pageSize) > proxy._gridRecordsCount) ? (proxy._gridRecordsCount) : (proxy._currentPage() * pageSize),
                    startIndex = (proxy._gridRecordsCount < pageSize) ? 0 : ((proxy._currentPage() * pageSize) - pageSize);
                    if (startIndex > endIndex)
                        startIndex = endIndex - pageSize;
                    proxy._updatedPageData = expandedRecords.slice(startIndex, endIndex);
                }               
                proxy.updateHeight();
            }
        },

        //UPDATE CURRENT VIEWPORT DATA FROM FLATRECORDS/UPDATED RECORDS
        _updateCurrentViewData: function (requestType) {

            var proxy = this,
                model = proxy.model,
                args = {},
                tMargin,
                isRangeModified = false;

            //CHECK VIRTUALIZATION IS ENABLED OR NOT 
            if (model.enableVirtualization) {

                if (model.allowPaging) {
                    if (requestType != ej.TreeGrid.Actions.Scroll)
                        proxy._updatePagerIndex();
                    proxy.getVisibleRange(requestType);
                    if (model.sizeSettings.height)
                        model.currentViewData = proxy._updatedPageData.slice(proxy._visibleRange.top,
                        proxy._visibleRange.bottom);
                    else
                        model.currentViewData = proxy._updatedPageData;
                }

                else {
                    proxy.getVisibleRange(requestType);
                    model.currentViewData = proxy.model.updatedRecords.slice(proxy._visibleRange.top,
                    proxy._visibleRange.bottom);                    
                }

                if (model.allowDragAndDrop && proxy._dragMouseDown && (ej.browserInfo().name == "chrome" || ej.isTouchDevice())) {
                    var updatedRecords = proxy.getUpdatedRecords(),
                       draggedItemIndex = updatedRecords.indexOf(proxy._draggedRecord);
                    if (proxy._visibleRange.top > draggedItemIndex || proxy._visibleRange.bottom < draggedItemIndex) {
                        if (!proxy._dummyElement) {
                            var cloneElement = proxy._draggedElement.clone();
                            proxy._draggedElement.before(cloneElement)
                            proxy._draggedElement.hide();
                            $(proxy.element).append(proxy._draggedElement);
                            proxy._dummyElement = true;
                        }
                    }
                }

                if (proxy._vScrollDist !== 0) {

                    tMargin = proxy._scrollTop - proxy._offset;
                    if (requestType && requestType == ej.TreeGrid.Actions.Scroll) args.requestType = ej.TreeGrid.Actions.Scroll;

                    else args.requestType = ej.TreeGrid.Actions.Refresh;

                    proxy.sendDataRenderingRequest(args);
                if (model.allowTextWrap && model.enableVirtualization && requestType == "scroll"){
                    proxy._updateWrapRowHeights("total,header");
                    proxy._textWrapRowsDatas = proxy._getAvgTextWrapRowHeight("getAvgHeight");
                }
                    isRangeModified = true;

                    if (this._frozenColumnsLength > 0) {
                        proxy._$frozenTableContent.css({ "top": tMargin });

                        proxy._$movableTableContent.css({ "top": tMargin });
                    } else 
                        proxy._$tableContent.css({ "top": tMargin });
                    if (model.allowTextWrap && model.enableVirtualization) {
                        if (proxy._textWrapRowsDatas.isEnd && !proxy._textWrapNoCalculate) {
                            proxy.updateHeight();
                            proxy._textWrapNoCalculate = true;
                        } else if (parseInt(proxy._scrollTop) >= parseInt(proxy.getMaxScrollHeight() - 10) && !proxy._textWrapRowsDatas.isEnd && !proxy._textWrapNoCalculate) {
                            proxy.updateHeight('extendHeight');
                            proxy._textWrapNoCalculate = false;
                        }
                        if (proxy._scrollTop >= (proxy.getMaxScrollHeight() - 10) && requestType != "expandcollapse") {
                            var offsetHeight, maxScrollHeight;
                            maxScrollHeight = proxy.getMaxScrollHeight();
                            if (this._frozenColumnsLength > 0) {
                                offsetHeight = (maxScrollHeight + $("#" + proxy._id + "frozene-table").height()) - $("#" + proxy._id + "e-gridcontainer").height();
                            } else {
                                offsetHeight = (maxScrollHeight + $("#" + proxy._id + "e-table").height()) - $("#" + proxy._id + "e-gridcontainer").height();
                            }
                            tMargin = maxScrollHeight - offsetHeight;
                            if (this._frozenColumnsLength > 0) {
                                proxy._$frozenTableContent.css({ "top": tMargin });
                                proxy._$movableTableContent.css({ "top": tMargin });
                            } else
                                proxy._$tableContent.css({ "top": tMargin });
                        }
                        if (proxy._scrollTop < 30) {
                            proxy._textWrapNoCalculate = false;
                        }
                    }
                }
                proxy._prevRTop = proxy._visibleRange.top;
                proxy._prevRBottom = proxy._visibleRange.bottom;

            } else {
                if (model.allowPaging) {
                    proxy._updatePagerIndex();
                    model.currentViewData = proxy._updatedPageData;
                }
                else
                    model.currentViewData = proxy.model.updatedRecords.slice();
            }


            if (proxy._isEnterKeyPressed) {

                proxy._isEnterKeyPressed = false;
                if (model.allowSelection && model.editSettings.allowEditing) {

                    if (!isRangeModified) proxy._cellEditingDetails.rowIndex += 1;

                    if (!proxy._rowSelectingEventTrigger(this.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {

                        proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                        proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);

                    }

                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, proxy.model.columns[proxy._cellEditingDetails.columnIndex].field);

                }
            }
        },


        //GET THE TABLE ROW POSITION
        _getRowPosition: function (y) {
            return Math.ceil((y) / (this.model.rowHeight + this._detailsRowHeight));
        },


        //GET THE COLUMNGROUP FOR HEADER TABLE
        _getMetaColGroup: function () {

            var $colgroup = this.getHeaderTable().find('colgroup').clone();
            return $colgroup;

        },


        //CREATE EMPTY ROW WHILE DATASOURCE OBJECT AS NULL
        _getEmptyTbody: function () {

            var proxy = this,
                $emptyTd = ej.buildTag('td', proxy.model.emptyRecordText, {}, { colSpan: proxy.model.columns.length });
            return $(document.createElement("tr")).append($emptyTd);

        },


        //ADD SORTICON TO THE COLUMN HEADER
        _addSortElementToColumn: function (field, direction) {

            var proxy = this, model = this.model,
                column,index;
            if (model.isFromGantt) {
                column = ej.TreeGrid.getColumnByMappingName(proxy.model.columns, field);
                if (ej.isNullOrUndefined(column))
                    column = proxy.getColumnByField(field);
            }
            else
                column = ej.TreeGrid.getColumnByField(proxy.model.columns, field);
            index = $.inArray(column, proxy.model.columns);
            var $headerCellDiv = proxy.getHeaderTable().find("thead").
                find(".e-headercell").eq(index).find(".e-headercelldiv");
            $headerCellDiv.find(".e-ascending,.e-descending").remove();
            $headerCellDiv.append(proxy._createSortElement().addClass("e-" + direction).addClass("e-icon"));
            $headerCellDiv.parent().attr("aria-sort", direction);
        },


        //CREATE SORT ELEMENT        
        _createSortElement: function () {
            return ej.buildTag('span', "&nbsp;");
        },


        //RENDERED EDITED CELL
        _renderCellEditObject: function (cellEditArgs, $td) {

            var proxy = this,
                $form = ej.buildTag("form.e-treegridform#" + proxy._id + "EditForm", "", {}, {}),
                $cellEditTemplate = proxy._cellEditTemplate,
                $element,
                htmlString,
                cellData = {},
                cellValue,
                columnObject = cellEditArgs.columnObject,
                columnField = columnObject.field.split('.').join(""),
                columnIndex = -1,
            cellValue = cellEditArgs.value;
            if (columnObject.editType == "dropdownedit" && cellValue == false)
                cellValue = cellValue.toString();
            cellData[columnField] = cellValue,
            columnIndex = proxy.getColumnIndexByField(columnObject.field);

            $td.empty();

            $td.addClass("e-validError");

            htmlString = $cellEditTemplate.find("#" + columnField + "_CellEdit").html();
            if (columnObject.field === "predecessor" || columnObject.field === "duration")
                $element = $($.templates(htmlString).render(cellEditArgs.data));
            else
                $element = $($.templates(htmlString).render(cellData));

            if ($element.get(0).tagName == "SELECT") {

                $element.val(cellData[columnField]);
                $element.val() == null && $element.val($element.find("option").first().val());

            }

            if ($element.get(0).tagName == "INPUT" && proxy.model.isFromGantt) {
                if (columnObject.field != "predecessor" && columnObject.field != "duration")
                    $element.val(cellData[columnField]);
            } else if ($element.get(0).tagName == "INPUT") {
                $element.val(cellData[columnField]);
            }

            $form.append($element);

           $td.append($form);

           var args = {};
           args.columnIndex = cellEditArgs.columnIndex;
           args.data = cellEditArgs.data.item;
           args.requestType = "beginEdit";
           proxy._refreshEditForm(args);

            if ($.isFunction($.validator) && !$.isEmptyObject(cellEditArgs.validationRules)) {

                proxy._initValidator();
                proxy.setValidation();

            }
            proxy.model.isEdit = true;

        },

        //get Index of resourceInfo
        getIndexofresourceInfo: function (dataSource) {

            var proxy = this, model = proxy.model,
                resourceIdMapping = model.resourceIdMapping,
                data = proxy._cellEditingDetails.data,
                resourceInfo = data.resourceInfo,
                count = 0,
                length = resourceInfo && resourceInfo.length,
                resourceIndex = [];

            for (count; count < length; count++) {                
                for (var index = 0; index < dataSource.length; index++) {
                    if (dataSource[index][resourceIdMapping] == resourceInfo[count][resourceIdMapping])
                        resourceIndex.push(index)
                }
            }

            return resourceIndex;

        },

        //REFRESH THE EDITED FORM
        _refreshEditForm: function (args) {

            var proxy = this, $form, rowHeight, isDialogEdit;
            if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                $form = $("#" + proxy._id + "EditFormDialog");
                rowHeight = "";
                isDialogEdit = true;
            } else {
                $form = $("#" + proxy._id + "EditForm");
                rowHeight = proxy.model.rowHeight - 5;
            }
            var $frozenForm = $("#" + proxy._id + "EditFrozenForm"),
                elementFocused = false,
                $formElement = $frozenForm.add($form).find("input,select,textarea"),
                percent = 86,
                i = 0,
                length = $formElement.length,
                $element, inputWidth,
                model = proxy.model,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat,
                formatVal,
                cellEditType;

            for (i; i < length; i++) {

                $element = $formElement.eq(i);
                cellEditType = $element.attr("data-edittype");
                column = ej.TreeGrid.getColumnByField(model.columns, $element.prop("name"));
                if (ej.isNullOrUndefined(column) && proxy.model.editSettings.editMode == "dialogEditing") {
                    if (($element).hasClass("e-btn") || (proxy.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != ""))) {
                        return;
                    } else
                        $element.closest("tr").addClass("e-hide");
                } else {
              
                    if (proxy.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != ""))
                        cellEditType = column.editType;
              
                        inputWidth = "100%";

                    switch (cellEditType) {
              
                        case ej.TreeGrid.EditingType.Numeric:
                            params = {};
                            width = inputWidth;
                            value = $element.val();
                            params.width = width;
                            params.locale = model.locale;
                            params.height = rowHeight;
                            params.showSpinButton = true;
                            params.cssClass = model.cssClass;
                  
                        if (value.length)
                           {
                                  params.value = parseFloat(value);
                           }

                        if (model.isFromGantt && column.field === "status") {
                            params.minValue = 0;
                            params.maxValue = 100;
                            params.decimalPlaces = 0;
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                        $element.ejNumericTextbox(params);
                        $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        params = {};
                        params.width = inputWidth;
                        params.height = rowHeight;
                        params.locale = model.locale;
                        params.cssClass = model.cssClass;
                        params.dateFormat = model.dateFormat;
                        params.enableStrictMode = true;
                        if (model.isFromGantt)
                            params.startDay = model.weekStartDay;
                        if ($element.val().length) params.value = proxy.getDateFromFormat($element.val());

                        if (column["format"] !== undefined && column.format.length > 0) {

                            toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                            formatVal = toformat.exec(column.format);
                            params.dateFormat = formatVal[2];
                            if ($element.val().length) {
                                params.value = ej.format(new Date($element.val()), params.dateFormat, params.locale);
                                $element.val(params.value);
                            }
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                        if (model.dateFormat.toLowerCase().indexOf("hh") == -1)
                            $element.ejDatePicker(params);
                        else {
                            $element.ejDateTimePicker(params);
                        }
                        break;
                    case ej.TreeGrid.EditingType.DateTimePicker:
                        params = {};
                        params.width = inputWidth;
                        params.height = rowHeight;
                        params.locale = model.locale;
                        params.cssClass = model.cssClass;
                        params.displayDefaultDate = true;
                        params.dateTimeFormat = model.dateFormat;
                        params.enableStrictMode = true;
                        if (model.isFromGantt)
                            params.startDay = model.weekStartDay;
                        if ($element.val().length) params.value = proxy.getDateFromFormat($element.val());

                        if (column["format"] !== undefined && column.format.length > 0) {

                            toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                            formatVal = toformat.exec(column.format);
                            params.dateTimeFormat = formatVal[2];
                            if ($element.val().length) {
                                params.value = ej.format(new Date($element.val()), params.dateTimeFormat, params.locale);
                                $element.val(params.value);
                            }
                        }

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);

                            $element.ejDateTimePicker(params);
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:

                        var dataSource, fieldName;

                        if (proxy._isRowEdit)
                        {
                            dataSource = column.dropdownData;
                            fieldName = column.field;
                        }
                        else{
                            dataSource = column.dropdownData;
                            fieldName = column.field;
                        }

                        if(model.isFromGantt && fieldName === "resourceInfo"){
                            $element.ejDropDownList({
                                width: inputWidth,
                                height: rowHeight,
                                showCheckbox: true,
                                dataSource: dataSource,
                                fields: {
                                    id: model.resourceIdMapping,
                                    text: model.resourceNameMapping,
                                    value: model.resourceNameMapping
                                },
                                selectedItems: proxy.getIndexofresourceInfo(dataSource)
                            });
                        
                        } else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.width = inputWidth;
                            controlArgs.height = rowHeight;
                            controlArgs.dataSource = dataSource;
                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);

                            $element.ejDropDownList(controlArgs);

                            var obj = $element.ejDropDownList("instance");
                            obj._setValue($element.attr("data-cellvalue"));
                           
                        }
                        break;

                    case ej.TreeGrid.EditingType.String:
                        if (proxy.model.editSettings.allowEditing && proxy.model.editSettings.editMode == "dialogEditing") {
                            $element.outerWidth("100%").height(27);
                        } else {
                            $element.outerWidth(inputWidth).height(model.rowHeight - 9);
                        }
                        $element.css({ 'margin': '0px', 'padding': '1px' });
                        break;
                    case ej.TreeGrid.EditingType.Boolean:
                        if (proxy._checkboxSelection && column["nonColumn"]) {                            
                            $element[0].style.display = "none";
                        }
                        else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.size = "small";                            

                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);

                            $element.ejCheckBox(controlArgs);
                            ////center align of check box control
                            var parentElement = $element.parent(".e-chkbox-wrap"),
                                formElement = parentElement.parent("form");

                            if (!isDialogEdit) {
                                if (formElement.length > 0)
                                    formElement.css("margin-left", "45%");
                                else
                                    parentElement.css("margin-left", "45%");
                            }
                        }                       
                        break;
                   
                    case ej.TreeGrid.EditingType.Maskedit:
                        var controlArgs = {};
                        controlArgs.locale = model.locale;
                        controlArgs.cssClass = model.cssClass;
                        controlArgs.width = inputWidth;
                        controlArgs.height = rowHeight;
                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(controlArgs, column["editParams"]);

                        $element.ejMaskEdit(controlArgs);
                        break;
                    case "edittemplate":
                        var temp = { rowdata: args.data, "column": column, element: $element, requestType: args.requestType};
                        var temp1 = column.editTemplate.write;
                        if (!ej.isNullOrUndefined(args) && args.requestType == "add") temp.rowdata = {};
                        if (typeof temp1 == "string")
                            temp1 = ej.util.getObject(temp1, window);
                        temp1(temp);
                        break;
                }

                if (!$element.is(":disabled") && !elementFocused &&
                   (!$element.is(":hidden") || typeof ($element.data("ejDropDownList") || $element.data("ejNumericTextbox") ||
                   $element.data("ejDatePicker") || $element.data("ejCheckBox")) == "object")) {

                    if ((!proxy._isEnterKeyPressed && column == model.columns[args.columnIndex]) || ((!args.columnIndex || args.columnIndex == -1) && !proxy._isEnterKeyPressed)) {

                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;

                    }
                }
                }
        }
            },

        _getRecordIndex: function () {
            var proxy = this,
                model = proxy.model,
                currentViewData, index,
                records = model.allowPaging ? proxy._updatedPageData : proxy.getExpandedRecords(model.updatedRecords);
            proxy.getVisibleRange();
            currentViewData =  records.slice(proxy._visibleRange.top, proxy._visibleRange.bottom); 
            index = currentViewData.indexOf(model.selectedItem);
            return index;
        },
         //INITIALIZE THE VALIDATOR
        _initValidator: function () {
            var proxy = this, elements = this._frozenColumnsLength > 0 ? this.element.find(".e-treegridform") : $("#" + this._id + "EditForm").length > 0 ? $("#" + this._id + "EditForm") : $("#" + this._id + "EditFormDialog");
            for (var i = 0; i < elements.length ; i++) {
                elements.eq(i).validate({
                    ignore: ".e-hide",
                    errorClass: 'e-field-validation-error',
                    errorElement: 'div',
                    wrapper: "div",
                    errorPlacement: function (error, element) {
                        proxy._renderValidator(error, element);
                    },
                });
            }
        },

        _renderValidator: function (error, element) {
            if (element.is(":hidden"))
                element = element.siblings("input:visible");
            if (!element.length)
                return;
            var proxy=this,
                model = proxy.model,
                recordIndex,
                $td = element.closest(".e-rowcell"),
                $container = $(error).addClass("e-error"),
                $tail = ej.buildTag("div.e-errortail");
            $td = $td.length == 0 ? element.closest("td") : $td;
            $td.removeClass(".e-error");
            if (model.editSettings.editMode != "dialogEditing") {
                recordIndex = proxy._getRecordIndex();                
                var recordPosition = (recordIndex + 1) * model.rowHeight;
                if (!model.enableVirtualization) {
                    var expandRecords = proxy.getExpandedRecords(model.updatedRecords);
                    recordIndex = model.allowPaging ? proxy._updatedPageData.indexOf(model.selectedItem) : expandRecords.indexOf(model.selectedItem);
                }
                if (recordIndex == -1) {
                    if (model.editSettings.rowPosition == "bottom")
                        recordIndex = model.updatedRecords.length - 1;
                    else if (model.editSettings.rowPosition == "top")
                        recordIndex = 0;
                    recordPosition = (recordIndex + 1) * model.rowHeight;
                }
                // here 45 is the error container height
                if (proxy._viewPortHeight < recordPosition + 45) {
                    $tail.addClass("e-bottomarrow");
                    var top = recordIndex * model.rowHeight - 45;
                    var operation = "append";
                }
                else {                   
                    $tail.addClass("e-toparrow");
                    var top = (recordIndex + 1) * model.rowHeight;
                    var operation = "prepend";
                }
            }
            else {
                var top = $td.offset().top - $("#" + this._id + "EditFormDialog").offset().top + $td.parent()[0].offsetHeight;
                $tail.addClass("e-toparrow");
                var operation = "prepend";
            }
            $($container).css({ "top": top });
            if (element.parent().hasClass("e-in-wrap"))
                $container.insertAfter(element.closest(".e-widget"));
            else
                $container.insertAfter(element);
            $container[operation]($tail);            
            $container.show("slow");
        },

        setValidation: function () {
            var proxy=this,
                model=proxy.model;
            
            for (var i = 0; i < this.model.columns.length; i++) {
                if (!ej.isNullOrUndefined(model.columns[i]["validationRules"])) {
                    if (model.editSettings.editMode == ej.TreeGrid.EditMode.RowEditing
                         || model.editSettings.editMode == ej.TreeGrid.EditMode.DialogEditing || proxy.element.find(".e-rowedit").length > 0
						 || proxy.element.find(".e-addedrow").length > 0)
                        this.setValidationToField(model.columns[i].field, model.columns[i].validationRules);
                    else if (model.editSettings.editMode == ej.TreeGrid.EditMode.CellEditing && proxy._cellEditingDetails.columnIndex == i) {
                        this.setValidationToField(model.columns[i].field, model.columns[i].validationRules);
                        return;
                    }
                }                
            }
        },

        setValidationToField: function (name, rules) {
            var fName = name, ele, form,proxy=this;
            if (!ej.isNullOrUndefined(name))
                fName = fName.replace(/[^a-z0-9\s_]/gi, ''); 
            var form = $("#" + this._id + "EditForm").length > 0 ? $("#" + this._id + "EditForm") : $("#" + this._id + "EditFormDialog"),
                column = proxy.getColumnByField(name);
            if (!ej.isNullOrUndefined(column) && column.isFrozen)
                var form = $("#" + this._id + "EditFrozenForm").length > 0 ? $("#" + this._id + "EditFrozenForm") : $("#" + this._id + "EditFormDialog");

            ele = form.find("#" + this._id + fName).length > 0 ? form.find("#" + this._id + fName) : form.find("#" + fName);
            if (rules["regex"]) {
                rules[name + "regex"] = rules["regex"]; delete rules["regex"];
                $.validator.addMethod(fName + "regex", function (value, element, options) {
                    var ptn = options instanceof RegExp ? options : new RegExp(options);
                    return ptn.test(value);
                }, ej.getObject("messages.regex", rules) || this.getColumnByField(name).headerText + " should match the given pattern");
            }
            !ele.attr("name") && ele.attr("name", name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").length > 0 ? $("#" + this._id + "EditForm").validate() : $("#" + this._id + "EditFormDialog").validate();
            validator.settings.messages[name] = validator.settings.messages[name] || {};
            if (!ej.isNullOrUndefined(rules["required"])) {
                if (!ej.isNullOrUndefined(rules["messages"] && rules["messages"]["required"]))
                    var message = rules["messages"]["required"];
                else
                    var message = $.validator.messages.required;
                if (message.indexOf("This field") == 0)
                    message = message.replace("This field", this.getColumnByField(name).headerText);
                validator.settings.messages[name]["required"] = message;
                if (ele.hasClass("e-datepicker"))
                    ele.ejDatePicker({ watermarkText: "" });
            }
        },

        //SET FOCUS TO EDITED ELEMENT
        _focusElements: function ($currentCell) {
            var proxy = this;

            if ($currentCell.length) {

                $currentCell.focus();
                var $childElem = $currentCell.children();

                if ($childElem[0]) {

                    if ($childElem[0].tagName.toLowerCase() == "select" || 
                        $childElem[0].tagName.toLowerCase() == "input") {

                        $childElem.focus().select();
                        $childElem[0].focus();

                    } else if ($childElem.find(".e-field.e-dropdownlist").length) {

                        $childElem.find(".e-ddl").focus();

                    } else if ($childElem.find(".e-chkbox-wrap.e-widget").length) {

                        $childElem.find(".e-chkbox-wrap.e-widget").focus();

                    }
                    else {
                        if ($childElem.find(".e-datepicker").length <= 0)
                            $childElem.find('input,select').select().focus();
                        else
                            $childElem.find('input,select').select();
                    }
                }
            }

            var contentScrollLeft = proxy.getScrollElement().children('.e-content').scrollLeft(),
                scrollLeft = proxy.getScrollElement().ejScroller("option", "scrollLeft");
            if (proxy.getScrollElement().hasClass("e-scroller") && contentScrollLeft != scrollLeft) {
                if (!ej.isNullOrUndefined(contentScrollLeft))
                proxy.getScrollElement().ejScroller("option", "scrollLeft", contentScrollLeft);
            }
            proxy._updateHeaderScrollLeft(proxy.getScrollElement().children('.e-content').scrollLeft());
        },
        //Set the focus for edit row elements
        _focusElementsForRowEdit: function ($currentCell) {
            if ($currentCell.length) {
                var $childElem = $currentCell.children();
                if ($childElem[0].tagName.toLowerCase() == "select" || $childElem[0].tagName.toLowerCase() == "input") {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.find(".e-field.e-dropdownlist").length)
                    $childElem[0].focus();
                else if ($childElem.hasClass("e-chkbox-wrap")) {
                    $childElem[0].focus();
                } else {
                    if ($childElem.find(".e-datepicker").length <= 0)
                        $childElem.find('input:visible,select').first().select().focus();
                    else
                        $childElem.find('input,select').select();
                }
            }
        },
        //UPDATE THE GRID CONTAINER HEIGHT
        //By updatedRecords and CollapsedRecord count length
        updateHeight: function (type) {

            var proxy = this,
                model = this.model,
                height = 0,
                detailsRowHeight = 0;
            if (proxy._$gridContainer && proxy._$gridContent) {
                if (model.allowPaging && !(proxy.model.allowTextWrap && model.enableVirtualization)) {
                    height = model.rowHeight * proxy._updatedPageData.length;
                }
                else if (model.enableVirtualization) {
                    if (model.allowTextWrap) {
                        if (model.allowPaging && !proxy._textWrapRowsDatas.isEnd) {
                            proxy._textWrapRowsDatas = proxy._getAvgTextWrapRowHeight("getAvgHeight");
                            height = proxy._textWrapRowsDatas.avgHeight * proxy._updatedPageData.length;
                        }else if (proxy._textWrapRowsDatas.isEnd) {
                            height = proxy._getAvgTextWrapRowHeight('updateHeight').height;
                        }else if(type == "extendHeight"){
                            height = $("#" + proxy._id + "e-gridcontainer").height() + ((proxy.model.updatedRecords.length - proxy._visibleRange.bottom) * proxy.model.rowHeight);
                        } else {
                            proxy._textWrapRowsDatas = proxy._getAvgTextWrapRowHeight("getAvgHeight");
                            height = model.updatedRecords.length * proxy._textWrapRowsDatas.avgHeight;
                        }
                    } else {
                        height = model.updatedRecords.length * model.rowHeight;
                    }
                }

                else {
                    height = model.rowHeight * (model.updatedRecords.length - proxy.getCollapsedRecordCount());
                }

                if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                    detailsRowHeight = proxy._getExpandedDetailsRowHeight();
                }

                height += detailsRowHeight;

                if (height == 0 && (model.currentViewData.length == 0 || model.flatRecords.length == 0))
                    height = 30;
                //To skip Vertical scrollbar
                if (model.allowPaging && !model.sizeSettings.height) {
                    var viewPortHeight;
                    if (model.allowTextWrap && !model.enableVirtualization) {
                        if (proxy._$frozenTableContent.length > 0) {
                            var frozenHeight = viewPortHeight = proxy._$gridContainer.find("#e-frozencontentdiv" + proxy._id).outerHeight(),
                                movableHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                            if (movableHeight > frozenHeight)
                                viewPortHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                        } else {
                            viewPortHeight = proxy._$gridContainer.find('.e-table').outerHeight();
                        }
                    }
                    else
                        viewPortHeight = height;
                    if (this._frozenColumnsLength > 0) {
                        proxy._$gridContent.css("height", viewPortHeight);
                        if (model.allowPaging && !model.sizeSettings.height) {
                            var scroller = proxy.getScrollElement().ejScroller("instance");
                            scroller.option("height", viewPortHeight);
                        }
                    }
                    else if (proxy.getScrollElement().hasClass("e-scroller")) {
                        if (proxy.getScrollElement().ejScroller("isHScroll")) {
                            viewPortHeight = height + proxy._scrollBarHeight;
                        }
                        proxy.getScrollElement().ejScroller({
                            height: viewPortHeight,//for border-width of gridcontent
                        });
                        
                    }
                    proxy._viewPortHeight = viewPortHeight;
                    proxy._gridHeight = height + proxy._getNonContentHeight();
                    if (proxy._summaryRowsCount > 0 && model.showTotalSummary)
                        proxy._gridHeight += proxy._$totalSummaryRowContainer.outerHeight();
                    proxy.element.height(proxy._gridHeight);                    
                }
                if (proxy.model.allowTextWrap && !proxy.model.enableVirtualization) {
                    proxy._$gridContainer.css({
                        "height": "auto",
                        "width": "auto"
                    });
                    if (this._frozenColumnsLength) {
                        proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", "auto");
                    }
                } else {
                    proxy._$gridContainer.css({
                        "height": height + "px",
                        "width": "auto"
                    });
                    if (this._frozenColumnsLength) {
                        proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id + ",#e-frozencontentdiv" + proxy._id).css("height", height + "px");
                    }
                }
                if (proxy.getScrollElement().hasClass("e-scroller")) {
                    proxy.getScrollElement().ejScroller("refresh");
                    if (proxy._textWrapRowsDatas.isEnd) {
                        proxy._textWrapRowsDatas.isEnd = false;
                    }
                    proxy._updateScrollCss();
                }
            }
        },
        //check scroller position in virtualization
        _setScrollTop: function (requestType) {

            var proxy = this,
            model = this.model,
            currentPosition = 0,
            top = proxy._scrollTop,
            rowHeight = model.rowHeight,
            length = model.currentViewData.length, id = model.isFromGantt ? proxy._id.replace("ejTreeGrid", "") : proxy._id,
            ganttbody = $("#" + id).find(".e-ganttviewerbodyContianer");

            /* check detail template and its row height */
            if (model.showDetailsRow && model.detailsTemplate && !model.showDetailsRowInfoColumn) {
                rowHeight += proxy._detailsRowHeight;
            }
            if (model.allowPaging && proxy._isNextPage) {
                top = 0;
                proxy._isNextPage = false;
                proxy.getScrollElement().ejScroller("scrollY", top, true);
            }
            if (top !== 0) {
                if(model.enableVirtualization){
                    if ((length * rowHeight) < proxy._viewPortHeight) {
                        if (requestType == "expandcollapse" && model.allowTextWrap && model.enableVirtualization) {
                            top = 0;
                        }else if (length > 0) {
                            currentPosition = top - (proxy._viewPortHeight - ((length - 1) * rowHeight));
                            if (currentPosition < 0)
                                currentPosition = 0;
                        }
                        if (model.isFromGantt)
                            ganttbody.ejScroller("scrollY", currentPosition, true);
                        else
                        proxy.getScrollElement().ejScroller("scrollY", currentPosition, true);
                    }
                }
                else {
                    if (model.isFromGantt)
                        ganttbody.ejScroller("scrollY", top, true);
                else
                    proxy.getScrollElement().ejScroller("scrollY", top, true);
            }
            }
        },

        // Height Refresh method that used in grid while perform column resize.
        rowHeightRefresh: function () {
            var proxy = this, model = this.model;
            proxy._updateWrapRowHeights(null, "virtualRefresh", null, "resize");
            if (proxy._$frozenTableContent.length > 0) {
                proxy.getScrollElement().ejScroller("refresh");
                var movableScrollTop = proxy.getScrollElement().ejScroller("model.scrollTop");
                proxy._getFrozenScrollElement().scrollTop(movableScrollTop);
            }
        },

        //Update the viewport,total summary container height for every action that affects columns when allowTextWrap is in enable state.
        _updateGridContentHeight: function () {
            var proxy = this, model = this.model;
            if (proxy._$totalSummaryRowContainer) {
                proxy._$totalSummaryRowContainer.ejScroller({ 'height': 'auto' });
                proxy._$footerContainer.css({ 'overflow': 'hidden' });
                if (proxy._$totalSummaryRowContainer.find(".e-footercontainer").height() < 90) {
                    if (proxy.isVScroll())
                        proxy._$totalSummaryRowContainer.addClass("e-scrollcss");
                } else {
                    proxy._$totalSummaryRowContainer.removeClass("e-scrollcss");
                    proxy._$totalSummaryRowContainer.ejScroller({ 'height': 90 });
                    proxy._$totalSummaryRowContainer.width(proxy._$gridContent.width());
                    proxy._$totalSummaryRowContainer.width('auto');
                }
            }
            if (model.allowPaging && !model.sizeSettings.height) {
                if (proxy._$frozenTableContent.length > 0) {
                    var frozenHeight = proxy._viewPortHeight = proxy._$gridContainer.find("#e-frozencontentdiv" + proxy._id).outerHeight(),
                        movableHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                    if (movableHeight > frozenHeight)
                        proxy._viewPortHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                } else {
                    proxy._viewPortHeight = proxy._$gridContainer.find('.e-table').outerHeight();
                }
            }
            else {
                proxy._viewPortHeight = proxy._getViewPortHeight();
                if (proxy._$totalSummaryRowContainer)
                    proxy._viewPortHeight = proxy._viewPortHeight - proxy._$totalSummaryRowContainer.outerHeight();
            }
            proxy._$gridContent.css({ "height": proxy._viewPortHeight + "px" });
                if (proxy.getScrollElement().hasClass("e-scroller")) {
                    var scroller = proxy.getScrollElement().ejScroller("instance");
                    scroller.option("height", proxy._viewPortHeight);
                }
            if (proxy._frozenColumnsLength) {
                var movableContainerHeight = this.getContent().find("#e-movablecontent" + proxy._id).height();
                if (movableContainerHeight != this.getContent().find("#e-frozencontainer" + proxy._id).height()) {
                    this.getContent().find("#e-frozencontainer" + proxy._id).height(movableContainerHeight);
                }
            }
            proxy._updateScrollCss();
        },

        getChildCount:function(record,count)
        {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length;i++)
            {
                currentRecord= record.childRecords[i];
                count++;
                if(currentRecord.hasChildRecords)
                {
                    count=proxy.getChildCount(currentRecord, count);
                }
            }
            return count;
        },
        //UPDATE THE FILTERED RECORDS FOR ADDING PARENTRECORDS
        _updateFilteredRecords: function (data) {

            var proxy = this,
                count = 0,
                length = data.length,
                record,virtualization=proxy.model.enableVirtualization;

            proxy._flatFilteredRecords = [];
            proxy._filteredRecords = [];
            proxy._filteredGanttRecords = [];

            for (count; count < length; count++) {

                record = data[count];

                proxy._addParentRecord(record);

                if (!this.model.isFromGantt) {
                    if (record.hasChildRecords && record.childRecords.length > 0) {
                        if (!this._checkChildExsist(record, data)) {
                            record.hasFilteredChildRecords = false;
                        } else {
                            record.hasFilteredChildRecords = true;
                        }
                    }
                    if (record.parentItem) {
                        record.parentItem.hasFilteredChildRecords = true;
                    }
                }
            }
            if (virtualization)
            proxy._filteredRecords = proxy.getExpandedRecords(proxy._flatFilteredRecords);
            else
                proxy._filteredRecords = proxy._flatFilteredRecords.slice();
        },
        /* Check child records of filtered parent records exists or not in updated records*/
        _checkChildExsist: function (record, collection)
        {
            var childRecords = record.childRecords,
                length = childRecords.length, isExsist = false;
            for (var count = 0; count < length; count++) {
                if ($.inArray(childRecords[count], collection) != -1) {
                    isExsist = true;
                    break;
                } else if (childRecords[count].hasChildRecords) {
                    isExsist = this._checkChildExsist(childRecords[count], collection);
                }
            }
            return isExsist;
        },
        /* While clear the filter, update hasFilteredChildRecords status of all records*/
        _updateHasFilteredChildRecordsStatus: function (collection)
        {
            var count=0,length=collection.length,currentRecord;
            for (count; count < length; count++) {
                currentRecord = collection[count];
                if (currentRecord.hasChildRecords && !currentRecord.hasFilteredChildRecords)
                    currentRecord.hasFilteredChildRecords = true;
            }
        },
        //ADD PARENTRECORD FOR FILTERED OTH LEVEL ITEMS
        _addParentRecord: function (record) {

            var proxy = this;

            if (record.parentItem)
                proxy._addParentRecord(record.parentItem);

            if ($.inArray(record, proxy._flatFilteredRecords) === -1) {
                proxy._flatFilteredRecords.push(record);
            }
        },


        //UPDATEEXPANDCOLLAPSE FOR SORTED RECORDS
        _updateExpandCollapseForSortedRecords: function (Record, expanded) {

            var proxy = this,
                count = 0,
                length = proxy._sortedRecords.length,
                record,
                index = proxy._sortedRecords.indexOf(Record);

            if (expanded) {

                proxy._addNestedSortRecords(Record, index);

            } else {

                var removedCount = 0;

                for (count = index + 1; count < length; count++) {

                    record = proxy._sortedRecords[count];

                    if (record.level === Record.level) {
                        break;
                    } else if (!proxy.getExpandStatus(record)) {
                        removedCount++;
                    }

                }

                proxy._sortedRecords.splice(index + 1, removedCount);

            }
        },


        //ADD NESTEDSORTRECORDS
        _addNestedSortRecords: function (record, index) {

            var proxy = this,
                childRecords,
                sortColumns = proxy.model.sortSettings.sortedColumns,
                length;

            if (sortColumns.length) {

                length = sortColumns.length - 1;
                proxy._queryManagar.queries = [];

                for (var i = length; i >= 0; i--) {

                    proxy._queryManagar.sortBy(sortColumns[i].field, sortColumns[i].direction);

                }

            }
            if (record.hasChildRecords) {

                var dataManager = ej.DataManager(record.childRecords),
                    count,
                    childrecord;

                childRecords = dataManager.executeLocal(proxy._queryManagar).result;
                length = childRecords.length;

                for (count = 0; count < length; count++) {

                    childrecord = childRecords[count];

                    if (proxy._filteredRecords.length) {

                        if ($.inArray(childrecord, proxy._filteredRecords) !== -1) {
                            proxy._sortedRecords.splice(++index, 0, childrecord);
                        }

                    } else {
                        proxy._sortedRecords.splice(++index, 0, childrecord);
                    }

                    if (childrecord.hasChildRecords && childrecord.expanded) {
                        proxy._addNestedSortRecords(childrecord, index);
                    }
                }
            }
        },

        //UPDATE Edit Settings
        updateEditSettings: function (edit) {

            var proxy = this;

            if (edit) {
                if (edit.editMode) {
                    if (proxy.model.editSettings.editMode === "normal" && edit.editMode === "cellEditing") {
                        proxy.model.editSettings.editMode = edit.editMode;
                        proxy._processEditing();
                    } else {
                        proxy.model.editSettings.editMode = edit.editMode;
                    }
                }
                if (!ej.isNullOrUndefined(edit.allowAdding))
                    proxy.model.editSettings.allowAdding = edit.allowAdding;
                if (!ej.isNullOrUndefined(edit.allowEditing))
                    proxy.model.editSettings.allowEditing = edit.allowEditing;
                if (!ej.isNullOrUndefined(edit.allowDeleting))
                    proxy.model.editSettings.allowDeleting = edit.allowDeleting;
                if (!ej.isNullOrUndefined(edit.beginEditAction))
                    proxy.model.editSettings.beginEditAction = edit.beginEditAction;
                proxy._enableEditingEvents();
            }
        },

        //UPDATE ALTROW
        updateAltRow: function () {

            var proxy = this,
                count = 0,
                currentViewData = proxy.model.updatedRecords,
                length = currentViewData.length,
                record, isAltRow = true;

            for (count = 0; count < length; count++) {
                record = currentViewData[count];
                if (record.isSummaryRow || !proxy.getExpandStatus(record))
                    continue;
                // record.isAltRow = count % 2 == 0 ? false : true;
                record.isAltRow = !isAltRow;
                isAltRow = record.isAltRow;
            }

        },


        
        //COUNT THE NUMBER OF CHILD RECORDS PRESENT IN THE GANTTRECORD
        _getFilteredChildRecordsCount: function (Record) {

            var proxy = this,
                model=proxy.model,
                length = Record&&Record.childRecords && Record.childRecords.length,
                i = 0,
                record;

            for (i = 0; i < length; i++) {

                record = Record.childRecords[i];
                if (model.enableVirtualization)
                {
                    if(proxy.getExpandStatus(record))
                    {
                        proxy._removedCount++;
                    }
                }
                else
                {
                    proxy._removedCount++;
                }
                   
                if (record.childRecords) {
                    proxy._getFilteredChildRecordsCount(record);
                }
            }

            return proxy._removedCount;
        },


        //SORTING THE RECORDS
        _sortingRecords: function (args) {

            var proxy = this,
                model = proxy.model,
                sortcolumns = model.sortSettings.sortedColumns;

            proxy._queryManagar.queries = [];

            if (sortcolumns.length) {

                var length = sortcolumns.length - 1;

                for (var i = length; i >= 0; i--) {
                    var fieldName;
                    if (model.isFromGantt) {
                        var currentColumn = ej.TreeGrid.getColumnByMappingName(proxy.model.columns, sortcolumns[i].field);
                        if (ej.isNullOrUndefined(currentColumn))
                            currentColumn = this.getColumnByField(sortcolumns[i].field);
                        fieldName = currentColumn.field;
                    } else {
                        fieldName = sortcolumns[i].field;
                    }
                    if (model.isFromGantt) {
                            if (fieldName === "resourceInfo")
                                fieldName = "resourceNames";
                            else if (fieldName === "predecessor")
                                fieldName = "predecessorsName";
                    }

                    proxy._queryManagar.sortBy(fieldName, sortcolumns[i].direction);
                }
            }

            var dataManager = new ej.DataManager(model.parentRecords),
                records = dataManager.executeLocal(proxy._queryManagar).result;

            proxy._sortedRecords = [];
            proxy._storedIndex = -1;
            proxy._rowIndex = -1;

            proxy._createSortedRecords(records);
            proxy._tempsortedrecords = proxy._sortedRecords;
            proxy.model.updatedRecords = proxy._sortedRecords;
            //Update zeroLevelParentRecords
            if (model.allowPaging && model.pageSettings.pageSizeMode === ej.TreeGrid.PageSizeMode.Root)
                model.parentRecords = proxy._getParentRecords(proxy.model.updatedRecords, proxy, true);

            return true;
        },


        /**
        * Create sorted collection argumented data
        * @param {data} collection of records to sorting
        */
        _createSortedRecords: function (data) {

            var proxy = this, model = proxy.model,
                sortedRecords = proxy._sortedRecords,
                dataManager,
                enableAltRow = proxy.model.enableAltRow,model=this.model;
            data = proxy._spliceSummaryRows(data);
            $.each(data, function (index, record) {
                //Skip the summary record from sorting.
                if (record.isSummaryRow) {
                    var recordIndex = record.parentItem.childRecords.indexOf(record);
                    record.parentItem.childRecords.splice(recordIndex, 1);
                    return;
                }
                if (proxy._searchString.length > 0 || (model.filterSettings.filteredColumns.length > 0)) {

                    if (proxy._filteredRecords.length > 0 && proxy._filteredRecords.indexOf(record) !== -1) {

                        proxy._storedIndex++;
                        proxy._rowIndex++;

                        if (enableAltRow) {

                            record.isAltRow = proxy._rowIndex % 2 == 0 ? false : true;

                        }

                        sortedRecords[proxy._storedIndex] = record;

                    }
                } else {

                    proxy._storedIndex++;
                    proxy._rowIndex++;

                    if (enableAltRow) {

                        record.isAltRow =proxy._rowIndex % 2 == 0 ? false : true;

                    }

                    sortedRecords[proxy._storedIndex] = record;

                }

                if (record.hasChildRecords && record.expanded) {
                    record.childRecords = proxy._spliceSummaryRows(record.childRecords);
                    dataManager = ej.DataManager(record.childRecords);
                    var childRecords = dataManager.executeLocal(proxy._queryManagar).result;
                    proxy._createSortedRecords(childRecords);

                }
                else if (record.hasChildRecords && !record.expanded && !model.enableVirtualization) {
                    record.childRecords = proxy._spliceSummaryRows(record.childRecords);
                    proxy._setChildRecords(record, sortedRecords);
                }
            });
        },

        _setChildRecords:function(record,sortedRecords)
        {
            var proxy = this,
                model = proxy.model,
                enableAltRow = proxy.model.enableAltRow,
                length = record.childRecords.length,
                dataManager;
            dataManager = ej.DataManager(record.childRecords);
            var childRecords = dataManager.executeLocal(proxy._queryManagar).result;
            for(var count=0;count<length;count++)
            {
                if (proxy._searchString.length > 0 || (model.filterSettings.filteredColumns.length > 0)) {

                    if (proxy._filteredRecords.length > 0 && proxy._filteredRecords.indexOf(childRecords[count]) !== -1) {
                        proxy._storedIndex++;
                        if (enableAltRow) {
                            childRecords[count].isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        }
                        sortedRecords[proxy._storedIndex] = childRecords[count];
                        if (childRecords[count].hasChildRecords) {
                            this._setChildRecords(childRecords[count], sortedRecords);
                        }
                    }
                } else
                {
                    proxy._storedIndex++;
                    if (enableAltRow) {
                        childRecords[count].isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                    }
                    sortedRecords[proxy._storedIndex] = childRecords[count];
                    if (childRecords[count].hasChildRecords) {
                        this._setChildRecords(childRecords[count], sortedRecords);
                    }
                }
            }
        },
        //UPDAT THE SORTED RECORDS
        _updateSortedRecords: function (data) {

            var proxy = this,
                count = 0,
                length = data.length,
                record, model = this.model;

            for (count; count < length; count++) {

                record = data[count];

                if (!model.enableVirtualization) {

                    if (proxy._filteredRecords.length > 0) {

                        if ($.inArray(record, proxy._filteredRecords) !== -1 && $.inArray(record, proxy._sortedRecords) === -1) {
                            proxy._sortedRecords.push(record);
                        }

                    } else {

                        if ($.inArray(record, proxy._sortedRecords) === -1) {
                            proxy._sortedRecords.push(record);
                        }

                    }

                    if (record.hasChildRecords && record.childRecords.length > 0) {

                        var dataManager = ej.DataManager(record.childRecords),
                            sortedChildRecords = dataManager.executeLocal(proxy._queryManagar).result;
                        proxy._updateSortedRecords(sortedChildRecords);

                    }
                }
            }
        },


        //REMOVE SORT ICON FORM COLUMN HEADER
        _removeSortElementFromColumn: function (field) {

            var proxy = this,
                column = ej.TreeGrid.getColumnByField(proxy.model.columns, field),
                index = $.inArray(column, proxy.model.columns),
                $headerCellDiv = proxy.getHeaderTable().find("thead").find(".e-headercell").eq(index).find(".e-headercelldiv");

            $headerCellDiv.find(".ascending,.descending").remove();
            $headerCellDiv.parent().removeAttr("aria-sort");
        },


        //ADD EMPTYCOLUMN TO THE TREEGRID
        _addEmptyColumntoGrid: function () {

            var proxy = this;
            $(proxy.element).find('.e-gridheadercontainer table colgroup').append(ej.buildTag('col', "", {
                "width": "auto"
            },
            {}));
            proxy._$gridContainer.find('table colgroup').append(ej.buildTag('col', "", {
                "width": "auto"
            },
            {}));
            $(proxy.element).find('.e-gridheadercontainer table thead tr').append(ej.buildTag('th.e-headercell'));
        },


        //UPDATE THE SCROLLTOP OF THE GRIDCONTAINER
        updateScrollTop: function (y, isFromChart) {

            var args = {},
                proxy = this;

            args.requestType = ej.TreeGrid.Actions.Scroll;
            args.delta = y;

            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");

            if (!isHorizontalScroll && this.model.isFromGantt) {
                proxy._$gridContent.scrollTop(y);//grid container
            }
            else
            {
                proxy._$gridContent.scrollTop(0);
            }
            proxy.getScrollElement().ejScroller("scrollY", y, true);
            if (proxy.model.isFromGantt && !isFromChart) {
                proxy._completeAction(args);
               proxy._focusTreeGridElement();
            }
            else proxy._isFromChart = false;
            
        },

        _selectNextCell: function (direction, action) {
            var proxy = this, model = proxy.model,
                columns = model.columns,
                columnLength = columns.length,
                rowElement, cellElement,
                selectingRowIndex,
                currentSelectingRecord,
                $form = $("#" + proxy._id + "EditForm"),
                updatedRecords = proxy.getUpdatedRecords(),
                expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords);
            proxy._isShiftKeyNavigation = false;

            switch (direction) {
                case "right":                   
                    if ((proxy._focusingRowIndex >= updatedRecords.length - 1 && proxy._cellIndex >= columnLength - 1)
                        || (proxy._focusingRowIndex == -1 || proxy._cellIndex == -1)) {
                        proxy.element[0].focus();
                        return;
                    }
                    proxy._cellIndex += 1;
                    if (proxy._cellIndex == columnLength) {
                        proxy._cellIndex = 0;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex + 1, expandedRecords);

                        if (!currentSelectingRecord)
                            return;
                        proxy._focusingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                    if (proxy._focusingRowIndex >= updatedRecords.length)
                        return;
                    if ((!columns[proxy._cellIndex].visible || !columns[proxy._cellIndex].allowCellSelection) && $form.length <= 0)
                        proxy._cellIndex = proxy.getUpNextVisibleColumnIndex(proxy._cellIndex, action);
                    if ($form.length > 0 && columns[proxy._cellEditingDetails.columnIndex].allowCellSelection)
                        proxy._cellIndex = proxy._cellEditingDetails.columnIndex;
                    var cellInfo = {
                        rowIndex: proxy._focusingRowIndex,
                        cellIndex: proxy._cellIndex
                    };
                    proxy.selectCells([cellInfo]);
                    proxy.updateScrollBar();
                    break;
                case "left":                    
                    proxy._cellIndex -= 1;
                    columnLength = columns.length;

                    if (proxy._cellIndex < 0) {
                        proxy._cellIndex = columnLength - 1;
                        var selectedItem = updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        selectingRowIndex = expandedRecords.indexOf(selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        //To skip the key Navigation from summary row.
                        if (currentSelectingRecord && currentSelectingRecord.isSummaryRow)
                            currentSelectingRecord = proxy._getNextRecord(selectingRowIndex - 1, expandedRecords, "upArrow");

                        if (!currentSelectingRecord)
                            return;
                        proxy._focusingRowIndex = updatedRecords.indexOf(currentSelectingRecord);
                    }
                    if (proxy._focusingRowIndex < 0)
                        return;
                    if (proxy._focusingRowIndex >= updatedRecords.length)
                        proxy._focusingRowIndex = updatedRecords.length - 1;
                    if ((!columns[proxy._cellIndex].visible || !columns[proxy._cellIndex].allowCellSelection) && $form.length <= 0)
                        proxy._cellIndex = proxy.getPreviousVisibleColumnIndex(proxy._cellIndex, action);
                    if ($form.length > 0 && columns[proxy._cellEditingDetails.columnIndex].allowCellSelection)
                        proxy._cellIndex = proxy._cellEditingDetails.columnIndex;

                    var cellInfo = {
                        rowIndex: proxy._focusingRowIndex,
                        cellIndex: proxy._cellIndex
                    };
                    proxy.selectCells([cellInfo]);
                    proxy.updateScrollBar();
                    break;
            }
        },
        //MOVE CURRENT CELL FOR KEYBOARD INTERACTION
        _moveCurrentCell: function (direction) {

            var proxy = this,
                rowIndex = proxy._cellEditingDetails.rowIndex,
                columnIndex = proxy._cellEditingDetails.columnIndex,
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords();

            if (rowIndex == -1 && columnIndex == -1) return false;

            if (proxy.model.isEdit) {

                proxy.saveCell();
                proxy.model.isEdit = false;

            }
            if (model.enableVirtualization) {
                var record = model.currentViewData[rowIndex];
                proxy._cellEditingDetails.rowIndex = rowIndex = updatedRecords.indexOf(record);
            }
            switch (direction) {

                case "right":
                    var columns = model.columns,
                        columnLength = columns.length,
                        hiddenColumn = proxy.getHiddenColumns(),
                        visibleColumn = $.extend([], columns),
                        nextColumnIndex, newColumnIndex, visibleColumnLength;
                    if(hiddenColumn)
                    hiddenColumn.forEach(function (item) {
                        visibleColumn.splice(visibleColumn.indexOf(item), 1);
                    });
                    newColumnIndex = visibleColumn.indexOf(columns[columnIndex]);
                    visibleColumnLength = visibleColumn.length;
                    if (rowIndex == updatedRecords.length - 1 && newColumnIndex == visibleColumnLength - 1) {
                        return true;
                    }
                    if (newColumnIndex == visibleColumnLength - 1) {
                        nextColumnIndex = 0;
                        while (!columns[nextColumnIndex].visible) {
                            nextColumnIndex++;
                        }
                        proxy._cellEditingDetails.columnIndex = nextColumnIndex;
                        if(proxy._getNextRow(direction, rowIndex, proxy))
                            return true;
                        
                    }
                    else {
                        nextColumnIndex = columnIndex + 1;
                        while (!columns[nextColumnIndex].visible) {
                            nextColumnIndex++;
                        }
                        proxy._cellEditingDetails.columnIndex = nextColumnIndex;
                    }
                    while (model.columns[nextColumnIndex].allowEditing == false || !columns[nextColumnIndex].visible) {
                        if ((nextColumnIndex + 1) == model.columns.length) {
                            proxy._cellEditingDetails.columnIndex = nextColumnIndex = 0;
                            if (proxy._getNextRow(direction, rowIndex, proxy))
                                return true;
                            continue;
                        }
                        proxy._cellEditingDetails.columnIndex = ++nextColumnIndex;
                    }
                    proxy.updateScrollBar();
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex,
                        model.columns[proxy._cellEditingDetails.columnIndex].field);
                    proxy._editAddTools();
                    break;

                case "left":
                    var columns = model.columns,
                       columnLength = columns.length,
                       hiddenColumn = proxy.getHiddenColumns(),
                       visibleColumn = $.extend([], columns),
                       prevColumnIndex, newColumnIndex, visibleColumnLength;
                    if (hiddenColumn)
                        hiddenColumn.forEach(function (item) {
                            visibleColumn.splice(visibleColumn.indexOf(item), 1);
                        });
                    newColumnIndex = visibleColumn.indexOf(columns[columnIndex]);
                    visibleColumnLength = visibleColumn.length;
                    if ((rowIndex == 0 && newColumnIndex == 0)) return true;
                    if (newColumnIndex == 0) {
                        prevColumnIndex = model.columns.length - 1;
                        while (!columns[prevColumnIndex].visible) {
                            prevColumnIndex--;
                        }
                        proxy._cellEditingDetails.columnIndex = prevColumnIndex;
                        if(proxy._getNextRow(direction, rowIndex, proxy))
                            return true;
                    } else {
                        prevColumnIndex = columnIndex - 1;
                        while (!columns[prevColumnIndex].visible) {
                            prevColumnIndex--;
                        }
                        proxy._cellEditingDetails.columnIndex = prevColumnIndex;
                    }

                    while (model.columns[prevColumnIndex].allowEditing == false || !columns[prevColumnIndex].visible) {

                        if ((prevColumnIndex - 1) == -1) {
                            proxy._cellEditingDetails.columnIndex = prevColumnIndex = columnLength - 1;
                            if (proxy._getNextRow(direction, rowIndex, proxy))
                                return true;
                            continue;
                        }
                        proxy._cellEditingDetails.columnIndex = --prevColumnIndex;
                    }
                    proxy.updateScrollBar();
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                    proxy._editAddTools();
                    break;

                case "up":
                    if (rowIndex == 0) return true;
                    proxy._cellEditingDetails.rowIndex = rowIndex - 1;
                    proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                    proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
                    proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                    break;

                case "down":
                    if (rowIndex + 1 == updatedRecords.length) {
                        proxy._focusTreeGridElement();
                        proxy._isEnterKeyPressed = true;
                    }
                    if (model.showSummaryRow) {
                        if (rowIndex + 1 == updatedRecords.length - model.summaryRows.length)
                            proxy._isEnterKeyPressed = true;
                    }
                    if (!proxy._isEnterKeyPressed) {
                        if (updatedRecords.length > (rowIndex + 1))
                            if (!model.enableVirtualization) {
                                var currentRecord = updatedRecords[rowIndex],
                                    expandedRecords = model.allowPaging? updatedRecords : proxy.getExpandedRecords(model.updatedRecords),
                                    nextRecord = expandedRecords[expandedRecords.indexOf(currentRecord) + 1];
                                //Skip the summary row from keyboard navigation.
                                if (nextRecord && nextRecord.isSummaryRow)
                                    nextRecord = proxy._getNextRecord(rowIndex + 1, expandedRecords);
                                var index = updatedRecords.indexOf(nextRecord);
                                if ((rowIndex == expandedRecords.length - 1 && columnIndex == model.columns.length - 1) || index == -1) {
                                    return true;
                                }
                                proxy._cellEditingDetails.rowIndex = index;
                            }
                            else {
                                var nextRecord = updatedRecords[rowIndex + 1];
                                //Skip the summary row from keyboard navigation.
                                if (nextRecord && nextRecord.isSummaryRow)
                                    nextRecord = proxy._getNextRecord(rowIndex + 1, updatedRecords);
                                index = updatedRecords.indexOf(nextRecord);
                                if (index == -1)
                                    return true;
                                proxy._cellEditingDetails.rowIndex = index;
                            }
                        if (!proxy._rowSelectingEventTrigger(proxy.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {
                            proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                            proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
                        }
                        proxy.updateScrollBar();
                        var args = {};
                        args.requestType = ej.TreeGrid.Actions.Scroll;
                        args.delta = proxy._$gridContent.children('.e-content').scrollTop();
                        proxy._trigger("actionComplete", args);
                        proxy.cellEdit(proxy._cellEditingDetails.rowIndex, model.columns[proxy._cellEditingDetails.columnIndex].field);
                        proxy._editAddTools();
                    }
                    else
                        proxy._isEnterKeyPressed = false;
                    break;
            }

            return false;

        },
        //To skip the summary record. 
        _getNextRecord: function (index, expandedRecords, action) {
            var nextRecord;
            do {
                nextRecord = expandedRecords[index];
                if (action == "upArrow" || action == "lastRowSelection" || action == "bottomRowSelection")
                    index--;
                else
                    index++;
            } while (nextRecord && nextRecord.isSummaryRow);
            return nextRecord;
        },

        _getNextRow: function (direction, rowIndex, proxy) {
            var cellIndex,
            model = proxy.model,
            index,
            updatedRecords = proxy.getUpdatedRecords();
            if (direction == "right")
                cellIndex = 1;
            else
                cellIndex = -1;

            if (!model.enableVirtualization) {
                var currentRecord = updatedRecords[rowIndex],
                  expandedRecords = model.allowPaging ? updatedRecords : proxy.getExpandedRecords(model.updatedRecords),
                  nextRecord = expandedRecords[expandedRecords.indexOf(currentRecord) + cellIndex];
                //Skip the summary row from keyboard navigation.
                if (nextRecord && nextRecord.isSummaryRow) {
                    var action = cellIndex > 0 ? "" : "lastRowSelection";
                    nextRecord = proxy._getNextRecord(rowIndex + cellIndex, expandedRecords, action);
                }
                if (model.allowPaging && nextRecord) {
                    index = updatedRecords.indexOf(nextRecord);
                    if (index < 0 && cellIndex == 1)
                        proxy.gotoPage(proxy._currentPage() + 1);
                    else if (index < 0 && cellIndex == -1)
                        proxy.gotoPage(proxy._currentPage() - 1);
                }
                index = updatedRecords.indexOf(nextRecord);
                if(index == -1) {
                    return true;
                }
                proxy._cellEditingDetails.rowIndex = index;
            }
            else {
                var nextRecord = updatedRecords[rowIndex + cellIndex];
                //Skip the summary row from keyboard navigation.
                if (nextRecord && nextRecord.isSummaryRow) {
                    var action = cellIndex > 0 ? "" : "lastRowSelection";
                    nextRecord = proxy._getNextRecord(rowIndex + cellIndex, updatedRecords, action);
                }
                if (model.allowPaging && nextRecord) {
                    index = updatedRecords.indexOf(nextRecord);
                    if (index < 0 && cellIndex == 1)
                        proxy.gotoPage(proxy._currentPage() + 1);
                    else if(index < 0 && cellIndex == -1)
                        proxy.gotoPage(proxy._currentPage() - 1);
                }
                index = updatedRecords.indexOf(nextRecord);
                if (index == -1)
                    return true;
                proxy._cellEditingDetails.rowIndex = index;
            }
            if (model.allowSelection && model.selectionSettings.selectionMode == "cell") {
                model.selectedItem = updatedRecords[proxy._cellEditingDetails.rowIndex];
                proxy._rowIndexOfLastSelectedCell = proxy._cellEditingDetails.rowIndex;
            }
            else if (!proxy._rowSelectingEventTrigger(proxy.selectedRowIndex(), proxy._cellEditingDetails.rowIndex)) {
                proxy.selectRows(proxy._cellEditingDetails.rowIndex);
                proxy._rowSelectedEventTrigger(proxy._cellEditingDetails.rowIndex);
            }

        },

        //FIND THE COLUMNWIDTH OF THE TREEGRID COLUMN
        _findColumnsWidth: function (extra) {

            var proxy = this,
                length = proxy.model.columns.length,
                j = proxy.getHeaderTable().find("colgroup").find("col");
            
            for (var i = 0; i < length; i++)
                proxy.columnsWidthCollection[i] = j.eq(i).width();

        },

        //CALCULATE THE TOTAL WIDTH OF THE COLUMNS
        _calculateWidth: function () {

            var j = this.getHeaderTable().find("colgroup").find("col"),
                width = 0;

            for (var i = 0; i < j.length; i++)
                width += j.eq(i).width();

            return width;
        },
        getScrollObject: function () {
            return this.getScrollElement().data("ejScroller");

        },
        //update element height when viewport height is <0
        _updateElementHeight:function()
        {
            var proxy = this;
            proxy._calculateDimensions();
            proxy.updateViewPortHeight();
        },
        /* Get scroller rendered div in treegrid*/
        getScrollElement: function () {
            if (this._frozenColumnsLength > 0)
                return this.element.find("#e-movablecontainer" + this._id);
            else
                return this._$gridContent;
        },

        /* Get scroller rendered frozen div in treegrid*/
        _getFrozenScrollElement: function () {
            if (this._frozenColumnsLength > 0)
                return this.element.find("#e-frozencontainer" + this._id);
            else
                return null;
        },
        /* Get width of all columns before the index or get frozen column width*/
        _getFrozenColumnWidth: function (index) {
            var width = 0,
                index = ej.isNullOrUndefined(index) ? this._frozenColumnsLength : index,
                columns = ej.isNullOrUndefined(index) ? this._frozenColumns : this.model.columns;
            if (index > 0)
            {
                for (var count = 0; count < index; count++) {
                    if (columns[count].visible == true) {
                        width += columns[count] ? this.columnsWidthCollection[count] : 0;
                    }
                }
            }
            return width;
        },
        _renderScroller: function (isFromFreezeColumn) {

            var proxy = this,
            model = proxy.model;
            var containerHeight = model.flatRecords.length * model.rowHeight;
            var contentHeight = proxy._viewPortHeight, autoHide = false;            
            if (model.allowPaging && !model.sizeSettings.height) {
                if (model.allowTextWrap && !model.enableVirtualization) {
                    if (proxy._$frozenTableContent.length > 0) {
                        var frozenHeight = contentHeight = proxy._$gridContainer.find("#e-frozencontentdiv" + proxy._id).outerHeight(),
                            movableHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                        if (movableHeight > frozenHeight)
                            contentHeight = proxy._$gridContainer.find("#e-movablecontentdiv" + proxy._id).outerHeight();
                    } else {
                        contentHeight = proxy._$gridContainer.find('.e-table').outerHeight();
                    }
                }
            }
            if (!proxy._$gridContent.hasClass("e-scroller") || (model.allowPaging && !model.sizeSettings.height)) {
                var height = proxy._gridHeight ? contentHeight : "auto", enableTouchScroll = false;
                var width = this._gridWidth, targetPane = null;
                if (this._frozenColumnsLength > 0) {
                    proxy._$gridContent.css("width", width - proxy._totalBorderWidth);
                    width = width - this._getFrozenColumnWidth() - 1;//frozen div border width
                }
                if (!model.isFromGantt) enableTouchScroll = true;
                if (this.mobileDevice() && !model.isFromGantt) {
                    autoHide = true;
                    proxy._scrollBarHeight = 10;
                }

                proxy.getScrollElement().ejScroller({
                    enableTouchScroll: false,
                    autoHide: autoHide,
                    scrollerSize: proxy._scrollBarHeight,
                    height: proxy.model.isFromGantt ? 0 : height,
                    width: proxy.model.isFromGantt ? width : width - proxy._totalBorderWidth,
                    scroll: $.proxy(proxy._onScroll, proxy)
                });
            }
            else {
                proxy.getScrollElement().ejScroller("refresh");
            }
            proxy.getScrollElement().ejScroller("model.keyConfigs", { up: "", down: "", left: "", right: "" });
            if (ej.isNullOrUndefined(isFromFreezeColumn))
                proxy._updateScrollCss();
            var isHorizontalScroll = proxy.getScrollElement().ejScroller("isHScroll");
            if (model.allowPaging && !model.sizeSettings.height && isHorizontalScroll) {
                var scrollHeight = height + proxy._scrollBarHeight;
                proxy.getScrollElement().ejScroller({
                    height: scrollHeight,
                });
                proxy.getScrollElement().ejScroller("refresh");
            }
            if (proxy.model.isFromGantt) {
                if (!isHorizontalScroll) {
                    proxy._$gridContent.addClass("e-borderbox");
                }
                else {
                    proxy._$gridContent.removeClass("e-borderbox");
                }
            }
            
            if (!this.mobileDevice() && this.getBrowserDetails().browser== "safari" && this._frozenColumnsLength > 0) {
                this.getHeaderContent().find("#e-movableheader" + proxy._id).add(this.getContent().find("#e-movablecontainer" + proxy._id)).css("margin-left", "auto");
                if(this._$totalSummaryRowContainer)
                    this._$totalSummaryRowContainer.find("#e-movablefooter" + proxy._id).css("margin-left", "auto");
            }
            if (this._frozenColumnsLength > 0) {
                proxy._$gridContent.height(height);
                proxy.getContent().find("#e-frozencontainer" + proxy._id).height(proxy.getContent().find("#e-movablecontent" + proxy._id).height());
            }
        },
        

        
        //ALL EVENTS BOUND USING THIS._ON WILL BE UNBIND AUTOMATICALLY
        _destroy: function () {
            var proxy = this,
                model = this.model,
                columns = model.columns;
            proxy.element.off();
            
            proxy._off(proxy.element, "click", proxy._onClick);
            proxy._off(proxy.element, "keydown", proxy._keyDown);
            proxy._off(proxy.element, "click", "#" + proxy._id + "e-gridheader", proxy._onHeaderClick);
            proxy._off(proxy.element, "mousedown touchstart", "#" + proxy._id + "e-gridheader", proxy._headerMouseDown);
            proxy._off($(document), "mousedown touchstart", proxy._mouseDownHandler);
            proxy._off(proxy.element, "mousedown touchstart", ".e-gridcontent", proxy._contentMouseDown);
            proxy._off(proxy.element, "click", proxy._onRecordClick);// ".e-gridcontent",

            //Method binding for filtering data.
            if (model.filterSettings.filterBarMode == "immediate") {
                proxy._off(proxy.element, "keyup", ".e-filterbarcell input", proxy._filterBarHandler);
                proxy._off(proxy.element, "click", ".e-filterbarcell .e-checkbox")._off(proxy.element, "click", ".e-filterbarcell .e-checkbox", proxy._filterBarHandler);
            }

            if (model.isResponsive)
                proxy._off(this.element, "swipeleft swiperight", ".e-gridcontent div > .e-table", $.proxy(this._swipeAction, this));

            proxy._off(proxy.element, "mousemove", proxy._mouseMove);
            proxy._off(proxy.element, "touchmove", proxy._mouseMove);

            proxy._off(proxy.element, "focus click", ".e-filterbarcell input", proxy._filterBarClose);
            proxy._off(proxy.element, "click", ".e-filterbarcell .e-cancel", proxy._filterBarClose);
            if (proxy.model.showGridCellTooltip && !proxy.model.showGridExpandCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-rowcell", proxy._mouseHover);
                }
            }
            else {
                proxy._off(proxy.element, "mouseenter", ".e-rowcell", proxy._mouseHover);
            }
            if (proxy.model.showGridCellTooltip) {

                if (ej.browserInfo().name == "msie") {
                    proxy._off(proxy.element, "mouseenter", ".e-headercelldiv", proxy._headermouseHover);
                }
                else {
                    proxy._off(proxy.element, "mousemove", ".e-headercelldiv", proxy._headermouseHover);
                }
            }
            proxy._off(proxy.element, "mouseleave", ".e-rowcell", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._cellMouseLeave);
            proxy._off(proxy.element, "mouseleave", ".e-headercelldiv", proxy._headerMouseLeave);
            proxy._off(proxy.element, "mouseleave", proxy._headerMouseLeave);
            

            //MOUSE WHEEL EVENT FOR GANTT CONTROL
            if (model.isFromGantt || this._frozenColumnsLength) {
                proxy._off(proxy.element, "mousewheel DOMMouseScroll", proxy._mouseWheel);
            }

            if (model.enableResize && model.isResponsive && !model.isFromGantt) {
                proxy._off($(window), "resize", proxy._windowResize);
            }
            if (ej.isTouchDevice())
                proxy._off(proxy.element, "doubletap ", ".e-gridcontent", proxy._editdblClickHandler);
            else
                proxy._off(proxy.element, "dblclick ", ".e-gridcontent", proxy._editdblClickHandler);
            //Mouse right click event for tree grid


            if (model.contextMenuSettings.showContextMenu) {
                proxy._off(proxy.element, "keyup contextmenu taphold", this._preventContextMenu);
            }
            proxy.getScrollElement().ejScroller("content").stop(true);
            this._clearColumnMenu();
            this._clearContextMenu();
            this._removeDetailsRow();
            $("#" + this._id + "_toolbarItems_Main").remove();
            if (proxy._columnRenameDialog) {
                $("#" + proxy._columnRenameDialog.attr("id") + "_wrapper").clearQueue();
                $("#" + proxy._columnRenameDialog.attr("id") + "_wrapper").stop();
                proxy._columnRenameDialog.data("ejDialog") && proxy._columnRenameDialog.data("ejDialog").destroy();
                $("#" + proxy._columnRenameDialog.attr("id") + "_wrapper").remove();
                $("#" + proxy._id + 'ColumnRenameDialog').remove();
            }
            if (this.model.showColumnChooser) {
                $("#" + proxy._id + "ccDiv_wrapper").clearQueue();
                $("#" + proxy._id + "ccDiv_wrapper").stop();
                $("#" + this._id + "ccDiv").data("ejDialog") && $("#" + this._id + "ccDiv").data("ejDialog").destroy();
                $("#" + proxy._id + "ccDiv_wrapper").remove();
                $("#" + this._id + "ccDiv").remove();
            }
            if (proxy._updateConfirmDialog) {
                $("#" + proxy._updateConfirmDialog.attr("id") + "_wrapper").clearQueue();
                $("#" + proxy._updateConfirmDialog.attr("id") + "_wrapper").stop();
                proxy._updateConfirmDialog.data("ejDialog") && proxy._updateConfirmDialog.data("ejDialog").destroy();
                $("#" + proxy._updateConfirmDialog.attr("id") + "_wrapper").remove();
                $("#" + proxy._id + 'ConfirmDialog').remove();
            }
            if ($("#" + proxy._id + "_dialogColumnAdd_wrapper").length > 0) {
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").clearQueue();
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").stop();
                $("#" + proxy._id + "_dialogColumnAdd").find('.e-datepicker').ejDatePicker("destroy");
                $("#" + proxy._id + "_dialogColumnAdd").find('.e-datetimepicker').ejDateTimePicker("destroy");
                $("#" + proxy._id + "_dialogColumnAdd").find('.e-numerictextbox').ejNumericTextbox("destroy");
                $("#" + proxy._id + "_dialogColumnAdd").find('.e-dropdownlist').ejDropDownList("destroy");
                $("#" + proxy._id + "_dialogColumnAdd").find('.e-treegrid').ejTreeGrid("destroy");
                $("#" + proxy._id + "_dialogColumnAdd").data("ejDialog") && $("#" + proxy._id + "_dialogColumnAdd").data("ejDialog").destroy();
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").remove();
                $("#" + proxy._id + "_dialogColumnAdd").remove();
            }

            //destroy all widgets in filtterbar
            if (model.allowFiltering && !model.isFromGantt) {
                for (var count = 0 ; count < columns.length; count++) {
                    var currentElement = $("#" + this._id + "_" + columns[count].field.split('.').join("") + "_filterbarcell");
                    currentElement.data("ejWidgets") && $(currentElement).data($(currentElement).data("ejWidgets")[0]).destroy();
                }
            }

            if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                var menuFilter = proxy._renderedFilterMenuDialog, filtertype;
                for (var i = 0; i < menuFilter.length; i++) {
                    var str;
                    if (menuFilter[i]) {
                        var index = menuFilter[i].indexOf("edit");
                        filtertype = menuFilter[i];
                        if (index != -1) {
                            var editType = filtertype.slice(0, index);
                            str = editType.charAt(0).toUpperCase() + editType.slice(1);
                        } else {
                            str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                        }
                    }
                    if (str == "String")
                        $("#" + this._id + "filter" + str + "MenuDiv").find('.e-autocomplete').ejAutocomplete("destroy");
                    else if (str == "Datepicker")
                        $("#" + this._id + "filter" + str + "MenuDiv").find('.e-datepicker').ejDatePicker("destroy");
                    else if (str == "Datetimepicker")
                        $("#" + this._id + "filter" + str + "MenuDiv").find('.e-datetimepicker').ejDateTimePicker("destroy");
                    else if (str == "Numeric")
                        $("#" + this._id + "filter" + str + "MenuDiv").find('.e-numerictextbox').ejNumericTextbox("destroy");

                    $("#" + this._id + "filter" + str + "MenuDiv_wrapper").clearQueue();
                    $("#" + this._id + "filter" + str + "MenuDiv_wrapper").stop();
                    $("#" + this._id + "filter" + str + "MenuDiv").find('.e-dropdownlist').ejDropDownList("destroy");
                    $("#" + this._id + "filter" + str + "MenuDiv").data("ejDialog") && $("#" + this._id + "filter" + str + "MenuDiv").data("ejDialog").destroy();
                    $("#" + this._id + "filter" + str + "MenuDiv_wrapper").remove();
                    $("#" + this._id + "filter" + str + "MenuDiv").remove();
                }
            }
            if (proxy._commandColumnLength > 0) {
                for (var i = 0; i < columns.length; i++) {
                    if (columns[i].commands && columns[i].commands.length > 0) {
                        $("#" + this._id + i + "_UnboundTemplate").remove();
                    }
                }
            }
            proxy.element.empty().removeClass("e-treegrid-core e-treegrid " + proxy.model.cssClass);
            proxy.element.data("ejWaitingPopup") && proxy.element.ejWaitingPopup("destroy");            
            for (var i = 0; i < columns.length; i++) {
                if (columns[i].isTemplateColumn) {
                    var headerText = columns[i]['headerText'];
                    if (!ej.isNullOrUndefined(headerText) && !ej.isNullOrUndefined(headerText.match(/(\\|[^0-9A-z-_])/g)))
                        headerText = headerText.replace(/(\\|[^0-9A-z-_])/g, "");
                    $("#" + proxy._id + headerText + $.inArray(columns[i], proxy.model.columns) + "_Template").length > 0 &&
                        $("#" + proxy._id + headerText + $.inArray(columns[i], proxy.model.columns) + "_Template").remove();
                }
            }            
        },

        

        collapseAll: function () {
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                $gridRows = proxy.getRows(),
                $rowElement = null;

            
            //To cancel the cell edit or row edit mode when collapse the all record.
            if (proxy._isRowEdit || proxy.model.isEdit) {
                proxy._isRowEdit ? proxy.cancelRowEditCell() : proxy.cancelEditCell();
                proxy.selectRows(-1);                          
                proxy._cancelSaveTools();
            }
            args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control
            proxy._isInExpandCollapseAll = true;

            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                var treegridRecord = proxy.model.parentRecords[count];
                args.data = treegridRecord;
                args.recordIndex = count;
                args.expanded = false;
                if (treegridRecord.hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(treegridRecord, args.expanded);
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshTreeGridOnExpandCollapseAll(args);

            proxy._isInExpandCollapseAll = false;

        },
        //populate the context menu with items
        _getContextMenuItems: function () {
            var contextMenuItems = [],
            proxy = this,
            contextMenuLabel = proxy._contextMenuTexts;
            contextMenuItems = [ {
                headerText: contextMenuLabel["addRowText"],
                eventHandler: null,
                isDefault: true,
                disable: false,
                menuId: "Add",
                parentMenuId: null
            },
             {
                 iconClass: "e-edit",
                 headerText: contextMenuLabel["editText"],
                 eventHandler: null,
                 isDefault: true,
                 disable: false,
                 menuId: "Edit",
                 parentMenuId: null
             },
            {
                headerText: contextMenuLabel["deleteText"],
                eventHandler: null,
                isDefault: true,
                disable: false,
                menuId: "Delete",
                parentMenuId: null
            },
            {
                iconClass: "e-save",
                headerText: contextMenuLabel["saveText"],
                eventHandler: null,
                isDefault: true,
                isEdit: true,
                disable: false,
                menuId: "Save",
                parentMenuId: null
            },
             {
                 iconClass: "e-cancel",
                 headerText: contextMenuLabel["cancelText"],
                 eventHandler: null,
                 isDefault: true,
                 isEdit: true,
                 disable: false,
                 menuId: "Cancel",
                 parentMenuId: null
             },
             {
                 iconPath: null,
                 headerText: contextMenuLabel["aboveText"],
                 eventHandler: null,
                 menuId: "Above",
                 parentMenuId: "Add"
             }, {
                 iconPath: null,
                 headerText: contextMenuLabel["belowText"],
                 eventHandler: null,
                 menuId: "Below",
                 parentMenuId: "Add"
             }
            ];
            return contextMenuItems;
        },

        //populate sub context menu items
        _getsubContextMenuItems: function () {
            var contextMenuItems = [],
            proxy = this,
            contextMenuLabel = proxy._contextMenuTexts;
            contextMenuItems = [{
                iconPath: null,
                headerText: contextMenuLabel["aboveText"],
                eventHandler: null,
                menuId: "Above",
                parentMenuId: "Add"
            }, {
                iconPath: null,
                headerText: contextMenuLabel["belowText"],
                eventHandler: null,
                menuId: "Below",
                parentMenuId: "Add"
            }
            ];
            return contextMenuItems;
        },
        _clearContextMenu: function () {
            //remove context menu items
            $('.e-contextmenu').remove();
            $('.e-innerContextmenu').remove();
        },
        // create and append a context menu and also bind the events for context menu option
        _renderContextMenu: function (e, index, item, checkEditMenu) {

            var proxy = this,
            model = proxy.model,
                eventArgs = {},
                args = {},
                posx,
				subposX,
                posy,
                subposY,
                contextMenu,
                contextMenuUList,
                subContextMenu,
                subContextMenuUList,
                coord = proxy._getCoordinate(e);
            proxy._contextMenuSelectedIndex = index;
            proxy._contextMenuSelectedItem = item;
            proxy._contextMenuEvent = e;


            if (!checkEditMenu && !this.editFormValidate())
                return;
            if (!e) e = window.event;
            subposX = posx = coord.pageX;
            subposY = posy = coord.pageY;
            
            //Edge detection for context menu
            var treeGridOffset = this.getOffsetRect(proxy.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
           
            args.targetElement = e;
            args.item = item;
            args.index = index;
            args.columnIndex = proxy.getCellIndex(e);
            args.requestType = "ContextMenuOpen";
            args.contextMenuItems = proxy._contextMenuItems;
            if (proxy._trigger("contextMenuOpen", args)) return false;
            proxy._activeMenuItemId = null;
            proxy._contextMenuItems = args.contextMenuItems;
            contextMenu = ej.buildTag("div.e-contextmenu", "", {
                'display': 'table',
                'position': 'absolute',
                'z-index': proxy.getMaxZIndex() + 1,
            }, { "id": proxy._id + "_ContextMenu" });
            model.cssClass && (contextMenu.addClass(model.cssClass));
            //Get zero th level menu items
            var parentMenuItems = args.contextMenuItems.filter(function (value) {
                if (value.parentMenuId == null || value.parentMenuId == undefined)
                    return true;
            });
            contextMenuUList = ej.buildTag("ul.e-treegrid-contextmenu", $.render[proxy._id + "contextMenuTemplate"](parentMenuItems), {
                'margin': '0px',
                'padding-left': '0px',
                'list-style-type': 'none'
            }, {
                'data-icon': false,
                'data-role': 'list-divider'
            });
            
            
            contextMenu.append(contextMenuUList);
            $(document.body).append(contextMenu);

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive) 
                proxy._off($(window), "resize", proxy.windowResize);
            var contextMenuHeight = $(contextMenu).outerHeight(),
                contextMenuWidth = $(contextMenu).outerWidth(),
                contextMenuItems = contextMenu.find(".e-menuitem"),
                contextMenuSelectItem = contextMenuItems.eq(0);
            contextMenuItems.outerWidth(contextMenuWidth + 2);
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + contextMenuWidth))) {
                if (treeGridOffset.right < (posx + contextMenuWidth)) {
                    posx = posx - contextMenuWidth;
                }
                if (posx < 0) {
                    posx = treeGridOffset.left + 10;
                }
            }
            if (treeGridOffset.bottom < posy + (contextMenuHeight)) {
                var tempPosY = posy - (contextMenuHeight);
                if (tempPosY > 0) {
                    posy = tempPosY;
                }
            }         
            contextMenu.css({ 'left': posx + 'px', 'top': posy + 'px', });
            proxy._focusTreeGridElement();
            $(contextMenu).css({ 'height': 'auto' });
            proxy._on(contextMenu, "contextmenu", function (argsE) {
                argsE.preventDefault();
            });
            //click event handlers for contextmenu items and subcontextmenu items
            $(contextMenuItems).click(function () {
                proxy._contextMenuClickHandler(this);
            });

            //Mouseenter and mouse leave handler for contextmenu items and Subcontextmenuitems
            $(contextMenuItems).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    contextMenu.find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                    $(this).addClass("e-contextmenu-mouseover");
                    proxy._activeMenuItemId = $(this).attr("id");
                    proxy._showSubContextMenu(this, args.contextMenuItems);
                }
            });

            if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                proxy._clearMultiSelectPopup();
            }

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive) 
                proxy._on($(window), "resize", proxy.windowResize);
            e.preventDefault();
        },

        //Show SubContext menu for selected Menu items
        _showSubContextMenu: function (element, menuItems) {
            var model = this.model,
                proxy = this,
                currentMenuItem = [],
                menuId = $(element).attr("id"),
                subContextMenu, subContextMenuUList, subMenuItems = [], subContextMenuItems;

            subMenuItems = menuItems.filter(function (value) {
                if (value.menuId == menuId)
                    currentMenuItem = value;
                if (value.parentMenuId == menuId)
                    return true;
            });

            if (!currentMenuItem.parentMenuId)
                $(".e-innerContextmenu").remove();

            if (currentMenuItem.parentMenuId) {
                this._removeContextMenu(currentMenuItem, menuItems);
            }

            if (subMenuItems.length > 0) {
                subContextMenu = ej.buildTag("div.e-innerContextmenu", "", {
                    'display': 'table',
                    'position': 'absolute',
                    'z-index': proxy.getMaxZIndex() + 1,
                }, { "id": this._id + "_SubContextMenu" + menuId });
                model.cssClass && (subContextMenu.addClass(model.cssClass));
                subContextMenuUList = ej.buildTag("ul", $.render[proxy._id + "contextMenuTemplate"](subMenuItems), {
                    'margin': '0px',
                    'padding-left': '0px'
                }, {
                    'data-icon': false,
                    'type': 'none',
                    'data-role': 'list-divider'
                });
                subContextMenu.append(subContextMenuUList);
                $(document.body).append(subContextMenu);
                subContextMenuItems = subContextMenu.find(".e-menuitem");
                var menuWidth = $(subContextMenu).outerWidth();
                subContextMenuItems.outerWidth(menuWidth > 100 ? menuWidth : 100);
                var subMenuOffset = proxy._getSubContextMenuPosition(element, subContextMenu);
                $(subContextMenu).css({ "top": subMenuOffset.top, "left": subMenuOffset.left });
                $(subContextMenuItems).mouseenter(function () {
                    if (!$(this).hasClass("e-disable")) {
                        proxy._showSubContextMenu(this, menuItems);
                        $(this).closest(".e-innerContextmenu").find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                        $(this).addClass("e-contextmenu-mouseover");
                        proxy._activeMenuItemId = $(this).attr("id");
                    }
                });
                proxy._on(subContextMenu, "contextmenu", function (argsE) {
                    argsE.preventDefault();
                });
                $(subContextMenuItems).click(function () {
                    proxy._contextMenuClickHandler(this);
                });
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive)
                    proxy._on($(window), "resize", proxy.windowResize);
                
            }
        },
        _removeContextMenu: function (menuItem, menuItems) {

            var currentMeuItemContainer = $("#" + this._id + "_SubContextMenu" + menuItem.parentMenuId),
                expandedMenu = $(currentMeuItemContainer).find(".e-contextmenu-mouseover");
            if ($(expandedMenu).length > 0 ) {
                var innerMenu = menuItems.filter(function (value) {
                    if (value.menuId == $(expandedMenu).attr("id"))
                        return true;
                });
                if (innerMenu.length > 0) {
                    var nextLevelItem = menuItems.filter(function (value) {
                        if (value.parentMenuId == innerMenu[0].menuId)
                            return true;
                    });
                    if (nextLevelItem.length > 0)
                        this._removeContextMenu(nextLevelItem[0], menuItems);
                }
                $("#" + this._id + "_SubContextMenu" + $(expandedMenu).attr("id")).remove();
            }
        },
        _getSubContextMenuPosition: function (element, subMenu) {
            var proxy = this, model = this.model,
                subContextMenuWidth,
                subContextMenuHeight,
                elementOffset, subMenuOffset = { top: "", left: "" },
                parentElement = $(element).closest(".e-contextmenu"),
                posx, posy,
                contextMenuWidth;
            if (parentElement.length == 0)
                parentElement = $(element).closest(".e-innerContextmenu");

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9 && model.isResponsive)
                proxy._off($(window), "resize", proxy.windowResize);

            subContextMenuWidth = $(subMenu).outerWidth(),
            subContextMenuHeight = $(subMenu).height(),
            elementOffset = this.getOffsetRect(element),

            contextMenuWidth = $(parentElement).outerWidth();
            subMenuOffset.top = elementOffset.top - 1;
            subMenuOffset.left = elementOffset.left + $(parentElement).width() + 1;
            posx = subMenuOffset.left;

            //Edge detection for context menu
            var treeGridOffset = this.getOffsetRect(this.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + subContextMenuWidth))) {
                if (treeGridOffset.right < (posx + subContextMenuWidth)) {
                    posx = posx - contextMenuWidth - subContextMenuWidth;
                }
                if (posx > 0) {
                    subMenuOffset.left = posx;
                }
            }
            if (treeGridOffset.bottom < subMenuOffset.top + subContextMenuHeight) {
                var tempPosY = (subMenuOffset.top + subContextMenuHeight) - treeGridOffset.bottom;
                tempPosY = subMenuOffset.top - tempPosY - 2;
                if (tempPosY > 0) {
                    subMenuOffset.top = tempPosY;
                }
            }
            return subMenuOffset;
        },
        _contextMenuClickHandler: function (target)
        {
            var choice = $(target).attr('id'),
                proxy = this;
            if (!$(target).hasClass("e-disable") && $(target).find(".e-expander").length == 0) {
                switch (choice) {
                    case "Delete":
                        proxy.contextMenuOperations("Delete");
                        break;
                    case "Above":
                        proxy.contextMenuOperations("Above");
                        break;
                    case "Below":
                        proxy.contextMenuOperations("Below");
                        break;
                    case "Add":
                        proxy.contextMenuOperations("Add");
                        break;
                    case "Edit":
                        proxy.contextMenuOperations("Edit");
                        break;
                    case "Save":
                        proxy.contextMenuOperations("Save");
                        break;
                    case "Cancel":
                        proxy.contextMenuOperations("Cancel");
                        break;
                    default:
                        proxy.contextMenuOperations(choice);
                        break;
                }
            }
        },

        //Call custom context menu event handlers
        _triggerMenuEventHandler: function (menuId, eventArgs) {
            var proxy = this,
                contextMenuItems = proxy._contextMenuItems,
                currentMenuItemCollection, menuItem;

            if (!ej.isNullOrUndefined(contextMenuItems)) {
                currentMenuItemCollection = contextMenuItems.filter(function (value) {
                    //convert menu id to string if it is given as number
                    if (value.menuId.toString() === menuId)
                        return true;
                });

                if (currentMenuItemCollection.length > 0) {
                    menuItem = currentMenuItemCollection[0];
                    var fn = menuItem.eventHandler;
                    if (fn) {
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        if ($.isFunction(fn)) {
                            var args = ej.event("customContextMenuHandler", this.model, eventArgs);
                            fn.call(this, args);
                        }
                    }

                }
            }
        },

        _createContextMenuTemplate: function () {
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "getHeaderName"] = $.proxy(proxy._getHeaderName, proxy);

            $.views.helpers(helpers);

            var menuItemList = "<li style='list-style-type:none;margin:0px;'>";
            var listChild = "<div class='e-menuitem {{if disable}}e-disable{{/if}}{{if ~_" + proxy._id + "getHeaderName(#data)}} e-parent-menuitem{{/if}}' id={{:menuId}}  style='display:table;cursor:{{if disable}}default{{else}}pointer{{/if}};min-width:100px;'>" +
                            "{{if iconPath}}" +
                           "<div class='e-icon e-contextmenu-image'" +
                            " style='background-image:{{:iconPath}};background-repeat:no-repeat;'/> " + 
                            "{{else}}" +
                            "<div class='e-icon {{:iconClass}} e-contextmenu-icon'/>" +
                            "{{/if}}" +
                            "<div class='e-contextmenu-label'>" +
                            "<span>{{:headerText}}</span></div>" +
                            "{{if ~_" + proxy._id + "getHeaderName(#data)}}<div class='e-icon e-expander'/> {{/if}}";

            menuItemList += listChild;
            menuItemList += "</div></li>";
            var templates = {};
            templates[proxy._id + "contextMenuTemplate"] = menuItemList;
            $.templates(templates);
        },
        _getHeaderName: function (data) {
            var childMenuItems = this._contextMenuItems.filter(function (value) {
                if (data.menuId != null && data.menuId == value.parentMenuId)
                    return true;
            });
            if (childMenuItems.length > 0) {
                return true;
            }
            return false;
        },

        // Remove the speace from column menu name for chaning name to id.

        _getColumnId: function (data) {
            return data.name.replace(/\s/g, "");
        },

        //Change the context menu based on context menu item list.
        _updateContextmenuOption: function (recordIndex) {
            //removing empty string and undefined from contextmenu items.
            Array.prototype.clean = function (deleteValue) {
                for (var i = 0; i < this.length; i++) {
                    if (this[i] == deleteValue) {
                        this.splice(i, 1);
                        i--;
                    }
                }
                return this;
            };
            var proxy = this;
            
            if(proxy._isRowEdit || proxy.model.isEdit)
            {
                //Remove add, delete and edit context menu when row in edit mode.
                proxy._contextMenuItems.splice(0, 3);
            }
            else
            {
                proxy._contextMenuItems.splice(3, 2); //Remove save and cancel when row not in edit mode
                var editSetting = proxy.model.editSettings;
                var contextMenuItems = $.extend(true, [], proxy._contextMenuItems);
                var contextMenuList = proxy.model.contextMenuSettings.contextMenuItems.clean("").clean(undefined);
                var contextMenuItemList = [];
                //removing duplicate conetxt menu items
                $.each(contextMenuList, function (i, el) {
                    if ($.inArray(el.toLowerCase(), contextMenuItemList) === -1) contextMenuItemList.push(el.toLowerCase());
                });
                proxy._contextMenuItems = [];
                if (recordIndex == -1) {
                    if (contextMenuItemList.indexOf("add") != -1 || contextMenuItemList.length==0)
                        proxy._contextMenuItems[0] = contextMenuItems[0];
                    if (!editSetting.allowAdding)
                        proxy._contextMenuItems[0].disable = true;
                    proxy._contextAddMenuIndex = 0;
                }
                //Adding default context menu when user not specify the context menu items.
                else if (contextMenuItemList.length == 0)
                {
                    proxy._contextMenuItems[0] = contextMenuItems[0];
                    if (!editSetting.allowAdding)
                        proxy._contextMenuItems[0].disable = true;
                    proxy._contextAddMenuIndex = 0;
                    proxy._contextMenuItems[1] = contextMenuItems[2];
                    if (!editSetting.allowDeleting)
                        proxy._contextMenuItems[1].disable = true;
                    proxy._contextMenuItems.push.apply(proxy._contextMenuItems, proxy._subContextMenuItems);
                }
                //Change the context menu order based on context menu items order
                else {
                for(var i=0;i<contextMenuItemList.length;i++)
                {
                    var item=contextMenuItemList[i];
                    switch(item.toLowerCase())
                    {
                        case "add":
                            proxy._contextMenuItems[i] = contextMenuItems[0];
                            proxy._contextAddMenuIndex = i;
                            if (!editSetting.allowAdding)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                        case "delete":
                            proxy._contextMenuItems[i] = contextMenuItems[2];
                            if (!editSetting.allowDeleting)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                        case "edit":
                            proxy._contextMenuItems[i] = contextMenuItems[1];
                            if (!editSetting.allowEditing)
                                proxy._contextMenuItems[i].disable = true;
                            break;
                    }
                }
                proxy._contextMenuItems.push.apply(proxy._contextMenuItems, proxy._subContextMenuItems);
                }
            }
        },
        //Assign default value to columns based on column edit type
        _setInitialData:function()
        {
            var eventArgs = {}, proxy = this,
               model = proxy.model, data = [], item, initialData = {};
            for (var i = 0; i < model.columns.length; i++)
            {
                var column = model.columns[i];
                switch(column.editType)
                {
                    case "booleanedit":
                        initialData[column.field] = false;
                        break;
                    case "stringedit":
                        initialData[column.field] = null;
                        break;
                    case "datepicker":
                        initialData[column.field] = ej.format(new Date(), this.model.dateFormat, this.model.locale);
                        break;
                    case "datetimepicker":
                        initialData[column.field] = ej.format(new Date(), "MM/dd/yyyy hh:mm tt", this.model.locale);
                        break;
                    case "numericedit":
                        initialData[column.field] = 0;
                        break;
                    default:
                        initialData[column.field] = null;

            }
            }
            data.push(initialData);
            if (proxy.dataSource() == null || proxy.dataSource().length == 0 || model.flatRecords.length == 0) {
                
                item = proxy._createRecord(data[0], 0, null);
                item.index = 0;
                proxy._addRecord(item, ej.TreeGrid.RowPosition.Top);
                proxy._clearContextMenu();
                this._removeDetailsRow();
            }
        },
        
        // Perform add new row operation
           
        _subContextMenuAction: function (item, index, position, addrow)
        {
            var proxy = this, model = proxy.model,
            eventArgs = {},
            newItem, selectionIndex;

            eventArgs.requestType = "save";
            newItem = jQuery.extend(true, {}, item.item);
            newItem[proxy.model.childMapping] = null;
            if (model.idMapping && model.parentIdMapping && newItem[model.parentIdMapping])
                delete newItem[model.parentIdMapping];

            if (position == "Above") {
                proxy._addRecord(newItem, ej.TreeGrid.RowPosition.Above, null, "contextMenu");
            } else if (position == "Below") {
                proxy._addRecord(newItem, ej.TreeGrid.RowPosition.Below, null, "contextMenu");
            }
            proxy._clearContextMenu();
        },

        _appendEditTemplateRow: function (columns, $targetTr, index, isFrozenTr, addrow) {

            var model = this.model,
                proxy = this,
                rowHeight = proxy.model.rowHeight, $mainTd,
                $form, $frozenForm, $table, $detailCell, visibleColumns = [],
                updatedRecords = proxy.getUpdatedRecords();

            this._editedRowIndex = index;
            $table = ej.buildTag('table.e-table e-zerospace', "", {});
            if (this._frozenColumnsLength > 0) {
                if (isFrozenTr) {
                    $form = ej.buildTag("form.e-treegridform#" + proxy._id + "EditFrozenForm", "", { "margin": "-2px 0px" }, {});
                    $table.append(proxy._$gridHeaderContainer.find("#e-frozenheaderdiv" + proxy._id).find('colgroup').clone());
                } else {
                    $form = ej.buildTag("form.e-treegridform#" + proxy._id + "EditForm", "", { "margin": "-2px 0px" }, {});
                    $table.append(proxy._$gridHeaderContainer.find("#e-movableheaderdiv" + proxy._id).find('colgroup').clone());
                }
            } else {
                $form = ej.buildTag("form.e-treegridform#" + proxy._id + "EditForm", "", { "margin": "-2px 0px" }, {});
                $table.append(proxy.getHeaderTable().find('colgroup').clone());
            }


            if (!isFrozenTr && model.showDetailsRow && model.showDetailsRowInfoColumn && model.detailsTemplate) {
                $detailCell = $targetTr.find("td.e-detailsrowcell");
            }

            $targetTr.empty();
            if (addrow) {
                $targetTr.addClass('e-addedrow');
                if ($targetTr.next('tr').hasClass('e-detailsrow'))
                    $targetTr.next('tr').remove();
            }
            else
                $targetTr.addClass('e-rowedit');

            visibleColumns = columns.filter(function (value) {
                return !(value.visible === false);
            });
            $mainTd = ej.buildTag("td", "", { "padding": "1px" }, { "colspan": $detailCell ? visibleColumns.length + 1 : visibleColumns.length });
            if (model.allowSelection)
                var $tr = ej.buildTag('tr.e-treegridrows e-selectionbackground e-active', { "height": rowHeight }, {});
            else
                var $tr = ej.buildTag('tr.e-treegridrows', { "height": rowHeight }, {});
            var $tbody = ej.buildTag('tbody'),
            $cellEditTemplate = proxy._cellEditTemplate;
            var columnLength = columns.length;
            for (var column = 0; column < columnLength; column++) {
                if (!ej.isNullOrUndefined(column)) {
                    if (columns[column].visible) {
                        var data = {}, columnField = proxy._getFieldValue(columns[column].field, model.columns.indexOf(columns[column])),
                        //Create a html string for column field with specific edit type using cellEditTemplate
                        htmlString = $cellEditTemplate.find("#" + columnField + "_CellEdit").html();
                        var value = proxy._getCustomCellValue(updatedRecords[index], columns[column]["field"]);
                        data[columnField] = value;
                            if (columns[column]["editType"] == "dropdownedit" && data[columns[column]["field"]] == false)
                                data[columnField] = data[columnField].toString();
                            var $element = $($.templates(htmlString).render(data));
                        if (proxy._isCommandColumn(columns[column])) {                              
                            var $td = ej.buildTag('td.e-rowcell e-unboundcell e-unboundeditedcell', "", { "height": rowHeight, "vertical-align": "middle;", "overflow": "hidden" }, {});
                        }
                        else {
                            var $td = ej.buildTag('td.e-rowcell e-editedcell', "", { "height": rowHeight, "vertical-align": "middle;", "overflow": "hidden" }, {});
                            $td.addClass('e-validError');
                        }
                        if (columns[column].allowEditing == false && proxy._commandColumnLength == 0)
                            $element.attr('disabled', true).addClass('e-disable');

                        if ($element.get(0).tagName == "SELECT") {
                            $element.val(data[columns[column]["field"]]);
                            $element.val() == null && $element.val($element.find("option").first().val());
                        }
                        if ($element.get(0).tagName == "INPUT") {
                            $element.val(data[columnField]);
                        }
                        $tr.append($td.append($element));
                        $tbody.append($tr);
                    }
                }
            }
            if ($detailCell) {
                $tr.append($detailCell);
            }
            $table.append($tbody);
            $form.append($table);
            $mainTd.append($form);
            $targetTr.append($mainTd);

        },
        //Create editable row with specific edit type.

        _editRow: function (index, addrow, columnIndex) {
            var proxy = this,
                model = proxy.model,
            rowHeight = model.rowHeight,
            $form, $frozenForm, $table,
            updatedRecords = proxy.getUpdatedRecords(),
            isAddRow = false;

            proxy._editedRowIndex = index;

            var $targetTr = ej.TreeGrid.getRowByIndex(proxy, index);
            if ($targetTr.hasClass("e-summaryrow")) {
                proxy._editAddTools();
                return;
            }
            if (ej.isNullOrUndefined(addrow)) {
                var args = {};
                args.data = updatedRecords[index];
                args.rowElement = $targetTr;
                args.rowIndex = index;
                args.columnIndex = columnIndex;
                isAddRow = false;
                if (proxy._trigger("beginEdit", args)) return false;
            }
            else
                isAddRow = true;
            if (this._frozenColumnsLength > 0) {
                proxy._appendEditTemplateRow(proxy._frozenColumns, $($targetTr[0]), index, true, addrow);
                proxy._appendEditTemplateRow(proxy._unFrozenColumns, $($targetTr[1]), index, false, addrow);
            } else {
                proxy._appendEditTemplateRow(model.columns, $($targetTr), index, false, addrow);
            }
            proxy._isRowEdit = true;
            proxy._editAddTools();
            var args = {};
            if (isAddRow)
            {
                args.data = {};
                args.requestType = "add";
            }
            else
            {
                args.columnIndex = columnIndex;
                args.data = updatedRecords[index];
                args.requestType = "beginEdit";
            }
           
           
            proxy._refreshEditForm(args);
            proxy._updateWrapRowHeights("total,header", null, index, "rowEdit");
            if ($.isFunction($.validator)) {
                proxy._initValidator();
                proxy.setValidation();
            }
            model.selectedItem = updatedRecords[index];
            for(var i=0;i<model.columns.length;i++){
                if (proxy._isCommandColumn(model.columns[i]) && model.columns[i]["isFrozen"]==true) {
                    this._refreshUnboundTemplate($targetTr.find("#" + this._id + "EditFrozenForm"))
                }
                else if (proxy._isCommandColumn(model.columns[i])) {
                    this._refreshUnboundTemplate($targetTr.find("#" + this._id + "EditForm"));
                }
            }            
        },

        //Creating column chooser menu

        _renderColumnChooser: function () {
            var proxy = this,
                $outerDiv = ej.buildTag("div.e-columnSelector", '',"", { id: this._id + "ccDiv" });
            $("#" + proxy._id + "ccDiv_wrapper").remove();
            proxy._renderColumnChooserList(false);
            $outerDiv.append(proxy._columnChooserList);
            $outerDiv.insertAfter(proxy.element);
            $outerDiv.data("columnMenuDialog", "TreeGrid");
            $outerDiv.ejDialog({ showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": false, showHeader: false, width: "auto",allowDraggable: false,
                                 position: { X: 1, Y: 1 }, enableAnimation: false, minWidth:"0px", minHeight:"0px" });
            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content").addClass("e-treegrid-columnchooser");
        },

        //render filter menu dialog
        _renderFilterMenu: function (filterType) {
            var proxy = this, numeric = 0, srting = 0, datepicker = 0, DropDown = 0, datetimepicker = 0, boolean = 0, column = this.model.columns, dropdownValue;
            if (!filterType) {
                for (var x = 0; x < column.length; x++) {
                    if (column[x].filterEditType == "numericedit" || column[x].editType == "numericedit")
                        numeric++;
                    if (column[x].filterEditType == "stringedit" || column[x].editType == "stringedit")
                        srting++;
                    if (column[x].filterEditType == "datepicker" || column[x].editType == "datepicker")
                        datepicker++;
                    if (column[x].filterEditType == "datetimepicker" || column[x].editType == "datetimepicker")
                        datetimepicker++;
                    if (column[x].filterEditType == "booleanedit" || column[x].editType == "booleanedit")
                        boolean++;
                    if (column[x].filterEditType == "dropdownedit" || column[x].editType == "dropdownedit") {
                        DropDown++;
                        dropdownValue = column[x];
                    }
                }
            }
            if (srting > 0 || filterType == "stringedit") {
                proxy._renderEdittypeFilterMenu("String");
                proxy._renderedFilterMenuDialog.push("stringedit");
            }
            if (numeric > 0 || filterType == "numericedit") {
                proxy._renderEdittypeFilterMenu("Numeric");
                proxy._renderedFilterMenuDialog.push("numericedit");
            }
            if (datepicker > 0 || filterType == "datepicker") {
                proxy._renderEdittypeFilterMenu("Datepicker");
                proxy._renderedFilterMenuDialog.push("datepicker");
            }
            if (datetimepicker > 0 || filterType == "datetimepicker") {
                proxy._renderEdittypeFilterMenu("Datetimepicker");
                proxy._renderedFilterMenuDialog.push("datetimepicker");
            }
            if (DropDown > 0 || filterType == "dropdownedit") {
                proxy._renderEdittypeFilterMenu("Dropdown", dropdownValue);
                proxy._renderedFilterMenuDialog.push("dropdownedit");
            }
            if (boolean > 0 || filterType == "booleanedit") {
                proxy._renderEdittypeFilterMenu("Boolean");
                proxy._renderedFilterMenuDialog.push("booleanedit");
            }
        },

        //render filter menu dialog box depends on its filterEditType
        _renderEdittypeFilterMenu: function (idvalue, dropdownValue) {
            var proxy = this, filterTable,
                $outerDiv = ej.buildTag("div.e-" + proxy._id + "filter" + idvalue + "Selector e-filterMenuDiv e-treegridmenufilterwraper", "", {}, { id: this._id + "filter" + idvalue + "MenuDiv" }),
                localeFilterTexts = proxy._filterMenuTexts;
            if (idvalue == "Dropdown") {
                filterTable = "<div class='e-filter-container'><div class='e-dropdown-filter-container'><input id='" + this._id + "filter" + idvalue + "DropDown'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            } else if (idvalue == "Boolean") {
                filterTable = "<div class='e-filter-container'><div class='e-checkbox-filter-container'><span class='e-checkbox-filter-text'>" + localeFilterTexts.filterValue + "</span><div class='e-checkbox-filter-control' style='padding-bottom:14px;padding-left: 48%;'><input id='" + this._id + "filter" + idvalue + "InputBox'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            }
            else {
                filterTable = "<div class='e-filter-container'><div class='e-filter-operator'><input id='" + this._id + "filter" + idvalue + "DropDown'/></div><span class='e-filter-text'>" + localeFilterTexts.filterValue + "</span><div class='e-filter-value'><input id='" + this._id + "filter" + idvalue + "InputBox'/></div><div class='e-filter-button-container'><div class='e-filter-btn-filter'><button id='" + this._id + "filter" + idvalue + "MenuButton' class='e-filterMenuDiv'>" + localeFilterTexts.filterButton + "</button></div><div class='e-filter-btn-clear'><button id='" + this._id + "filter" + idvalue + "ClearButton' class='e-filterMenuDiv'>" + localeFilterTexts.clearButton + "</button></div></div></div>";
            }
            $outerDiv.append(filterTable);
            $outerDiv.insertAfter(proxy.element);
            proxy._renderFilterMenuDialog(idvalue + "MenuDiv", idvalue, dropdownValue, localeFilterTexts);
            $outerDiv.data("filter" + idvalue + "MenuDialog", "TreeGrid");
            $outerDiv.ejDialog({
                showOnInit: false, allowKeyboardNavigation: false, enableResize: false, "enableRTL": false, showHeader: false, width: "auto", allowDraggable : false,
                position: { X: 1, Y: 1 }, enableAnimation: false, cssClass: proxy.model.cssClass
            });
            $("#" + proxy._id + "filter" + idvalue + "MenuDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css({ 'height': 'auto','width':'auto' }).removeClass("e-widget-content");
            $("#" + proxy._id + "filter" + idvalue + "MenuDiv_wrapper").css("outline", "none").addClass("e-treegrid-columnchooser");
        },

        //render filter menu inner components for each dialog box depends on its filterEditType
        _renderFilterMenuDialog: function (idValue, inputIdValue, dropdownValue, localeFilterTexts) {

            var proxy = this, localization, groups, initialtextvalue, field1;
            if (inputIdValue == "String") {
                groups = localeFilterTexts.stringMenuOptions;
                initialtextvalue = "endswith";
                field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "Numeric" || inputIdValue == "Datepicker" || inputIdValue == "Datetimepicker") {
                groups = localeFilterTexts.numberMenuOptions;
                initialtextvalue = "GreaterThan";
                field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "Dropdown") {
                groups = dropdownValue.dropdownData;
                if (dropdownValue.editParams)
                    field1 = { value: dropdownValue.editParams.fields.value, text: dropdownValue.editParams.fields.text };
                else
                    field1 = { value: "value", text: "text" };
            }
            if (inputIdValue == "String") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejAutocomplete({
                    width: "100%",
                    watermarkText: localeFilterTexts.enterValueText,
                    filterType: initialtextvalue,
                    enableResize:false,
                    enableDistinct: true,
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue == "Numeric") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejNumericTextbox({
                    decimalPlaces: 2,
                    width: "100%",
                    locale: proxy.model.locale,
                });
            }
            if (inputIdValue == "Boolean") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejCheckBox({
                    size: "small"
                });
            }
            if (inputIdValue == "Datetimepicker") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejDateTimePicker({
                    width: "100%",
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue == "Datepicker") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'InputBox').ejDatePicker({
                    width: "100%",
                    locale: proxy.model.locale,
                    cssClass: proxy.model.cssClass
                });
            }
            if (inputIdValue != "Boolean") {
                $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'DropDown').ejDropDownList({
                    dataSource: groups,
                    selectedIndex: 1,
                    fields: field1,
                    select: function (args) {
                        if (inputIdValue == "String") {
                            var suggesionBox = $("#" + proxy._id + "filter" + inputIdValue + "InputBox").data("ejAutocomplete");
                            suggesionBox.option("filterType", args.value);
                        }
                    },
                    cssClass: proxy.model.cssClass,
                    width: "100%"
                });
            }

            $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'MenuButton').ejButton({
                size: "normal",
                width: "100%",
                cssClass: proxy.model.cssClass,
                click: function (args) {
                    var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("data-ej-mappingname")),
                    column = proxy.getColumnByField(columnFieldName), suggesionBox, dropDown;
                    if (args.e.target.id == proxy._id + "filterStringMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterStringInputBox").data("ejAutocomplete");
                        dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.value(), dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterNumericMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterNumericInputBox").data("ejNumericTextbox");
                        dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDropdownMenuButton") {
                        dropDown = $("#" + proxy._id + "filterDropdownMenuDiv").find("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, dropDown.model.value, "equal");
                    }
                    if (args.e.target.id == proxy._id + "filterDatepickerMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                        dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDatetimepickerMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                        dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, suggesionBox.model.value, dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterBooleanMenuButton") {
                        suggesionBox = $("#" + proxy._id + "filterBooleanInputBox").data("ejCheckBox");
                        if (suggesionBox.model.checkState == "uncheck")
                            proxy._performMenuFilter(column, false, "equal");
                        else if (suggesionBox.model.checkState == "check")
                            proxy._performMenuFilter(column, true, "equal");
                    }
                }
            });

            $("#" + proxy._id + "filter" + idValue).find('#' + proxy._id + "filter" + inputIdValue + 'ClearButton').ejButton({
                size: "normal",
                width: "100%",
                cssClass: proxy.model.cssClass,
                click: function (args) {
                    var columnFieldName = $.trim(proxy._columnMenuTarget.prev("div.e-headercelldiv").attr("data-ej-mappingname")),
                    column = proxy.getColumnByField(columnFieldName), dropDown;
                    if (args.e.target.id == proxy._id + "filterStringClearButton") {
                        dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterNumericClearButton") {
                        dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDropdownClearButton") {
                        dropDown = $("#" + proxy._id + "filterDropdownMenuDiv").find("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", "equal");
                    }
                    if (args.e.target.id == proxy._id + "filterDatepickerClearButton") {
                        dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterDatetimepickerClearButton") {
                        dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                        proxy._performMenuFilter(column, "", dropDown.model.value);
                    }
                    if (args.e.target.id == proxy._id + "filterBooleanClearButton") {
                        proxy._performMenuFilter(column, "", "equal");
                    }
                }
            });
        },
        /*  Creating Column Chooser menu list with column header name
		    argument refresh in boolean data type
		    If it is false, rendering the column chooser list
            If is is true, rerendering the column chooser list
        */

        _renderColumnChooserList: function (refresh, headerText) {
            var proxy = this,
                length = proxy.model.columns.length,
                columns = proxy.model.columns,
                $listBox = ej.buildTag("div", '', { 'margin-left': '0px', "width": "auto" });
            for (var index = 0; index < length; index++) {
                if (proxy.model.treeColumnIndex != index && columns[index].showInColumnChooser ==true ) {
                    var column = columns[index];
                    if (column.nonColumn) continue;
                    if (!ej.isNullOrUndefined(column)) {
                        var $innerDiv = ej.buildTag('div', '',"", { 'class': 'e-columnMenuListDiv' }),
                            styleAttr = {},
                            colValue = ej.isNullOrUndefined(column.headerText) ? column.field : column.headerText,
                            $input = ej.buildTag('input', '', styleAttr, { 'id': proxy._id + "_columnMenu_" + column.field.split('.').join(""), 'value': colValue, 'type': 'checkbox' }),
                            label = ej.buildTag('label', colValue, {"width": "auto" }, { 'for': proxy._id + "_columnMenu_" + column.field.split('.').join("") });
                        $innerDiv.append($input);
                        $innerDiv.append(label);
                        $innerDiv.data("column", column.headerText);
                        $listBox.append($innerDiv);
                        if (column.headerText == headerText)
                            $innerDiv.addClass("e-columnmenuselection");
                        $input.ejCheckBox({
                            checked: !ej.isNullOrUndefined(column.visible) ? column.visible : true,
                            cssClass: proxy.model.cssClass,
                            change: function(args)
                            {
                                var columnName = "";
                                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                                    columnName = this.element.closest(".e-columnMenuListDiv").data().column;
                                } else {
                                    columnName = args.model.value;
                                }
                                if (!args.isChecked)
                                    proxy.hideColumn(columnName);
                                else
                                    proxy.showColumn(columnName);
                                proxy._updateWrapRowHeights(null,"virtualRefresh");
                            }
                        });
                    }
                }
            }
            if (!refresh) 
                proxy._columnChooserList = $listBox;
            else {
                proxy._columnChooserList.empty().append($listBox.children());
                proxy._focusTreeGridElement();
            }
            var columnChooserListItem = proxy._columnChooserList.find("div.e-columnMenuListDiv");
            $(columnChooserListItem).mouseenter(function () {
                columnChooserListItem.removeClass("e-columnmenuselection");
                $(this).addClass("e-columnmenuselection");
            });
        },

        //Template for column menu

        _createColumnMenuTemplate:function()
        {
            var proxy = this;
            var columnMenuList = "<li style='list-style-type:none;'>" +
                                 "<div class='e-columnmenuitem{{if enabled==false}} e-disable{{/if}}{{if (menuId =='Columns' || menuId =='Filter')}} e-parent-menuitem{{/if}}' style='display:table;cursor:pointer'" +
                                    " id='" + proxy._id + "_{{:menuId}}Chooser'>" +
                                "<div class='e-icon {{:icon}} e-treegridicon' style='display:inline-block;'></div>" +
                                "<div class='e-menuitem-label' style='display:inline-block;width:auto'>" +
                                "<span>{{:name}}</span></div>" +
                                "{{if (menuId =='Columns' || menuId =='Filter')}}<div class='e-icon e-expander e-treegridicon' style='display:inline-block;float:right;'/> {{/if}}" +
                                "</div>" +
                                "{{if menuId == 'RenameColumn' || menuId == 'SortDescending'}}<hr class='e-menuitem-hr'>{{/if}}" +
                                "</li>";            
            var templates = {};
            templates[proxy._id + "columnMenuTemplate"] = columnMenuList;
            $.templates(templates);
        },

        //render filter menu dialog in a respective position while clicking filter menu icon
        _updateFilterMenuList: function (e) {
            var proxy = this,
               model = proxy.model,
               columnFilterPosX, posY,
               posX,
               containerOffset,
               $target = $(e.target),
               targetWidth = targetHeight = 0,
               targetWidth = $target[0].offsetWidth,
               targetHeight = $target[0].offsetHeight,
               columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("data-ej-mappingname")), position,
               element, editType, str, index, filtertype,
               column = proxy.getColumnByField(columnFieldName);
            posX = columnFilterPosX = posY = 0;
            proxy._clearFilterMenu();
            proxy._clearColumnMenu("columnmenu");
            proxy._columnMenuTarget = $target;
            proxy._filterIconTarget = e;
            if (this.editFormValidate()) {
                if (model.isEdit)
                    this.saveCell();
                else if (this._isRowEdit)
                    this.saveRow();
            }
            position = proxy.getOffsetRect($target[0]);
            position.top = position.top + targetHeight;
            if (!proxy.model.isFromGantt)
                posY = position.top + targetHeight;
            else
                posY = position.top + targetHeight;
            element = !model.isFromGantt ? $(this.element) : $(this.element).closest(".e-gantt"),
            containerOffset = this.getOffsetRect(element[0]);
            containerOffset.bottom = containerOffset.top + element[0].offsetHeight;
            containerOffset.right = containerOffset.left + $(element).width();
            if (column.filterEditType) {
                index = column.filterEditType.indexOf("edit");
                filtertype = column.filterEditType;
            }
            else {
                index = column.editType.indexOf("edit");
                filtertype = column.editType;
            }
            if (index != -1) {
                editType = filtertype.slice(0, index);
                str = editType.charAt(0).toUpperCase() + editType.slice(1);
                proxy._showFilterMenu("filtermenu", "filter" + str, position, targetWidth, containerOffset.right, posX, null, null, column, posY);
            } else {
                str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                proxy._showFilterMenu("filtermenu", "filter" + str, position, targetWidth, containerOffset.right, posX, null, null, column, posY);
            }
            proxy._updatePreviousFilteredValue(column);
        },
        //Creating Column Menu

        _renderColumnMenu: function (e) {
            var proxy = this,
                model = proxy.model,
                posX, columnListPosX, columnFilterPosX, posY,
                $target = $(e.target),
                targetWidth = targetHeight = 0,
                columnMenuItems = [],
                columnChooserListIndex = 0,
                targetWidth = $target[0].offsetWidth,
                targetHeight = $target[0].offsetHeight,
                columnMenuText = proxy._columnMenuTexts,
                columnFieldName = $.trim($target.prev("div.e-headercelldiv").attr("data-ej-mappingname")),
                column = proxy.getColumnByField(columnFieldName),
                filtermenuindex,
                allowSorting = column.allowSorting == undefined ? true : column.allowSorting;
            posX = columnListPosX = columnFilterPosX = posY = 0;
            proxy._clearColumnMenu("columnmenu");
            proxy._columnMenuTarget = $target;
            /* save edited value before rendering contextmenu on non edited cell*/
            if ((model.isEdit || this._isRowEdit)) {
                if (this.editFormValidate()) {
                    if (model.isEdit)
                        this.saveCell();
                    else if (this._isRowEdit)
                        this.saveRow();
                }
                else
                    return true;
            }
            

            if (model.showColumnChooser && model.showColumnOptions) {
                var isInsert = proxy._enableDisableInsertLabel();
                columnMenuItems.push({ "name": columnMenuText["insertColumnLeft"], "icon": "e-column-insertleft-icon", "menuId": "ColumnLeft", enabled: isInsert });
                columnMenuItems.push({ "name": columnMenuText["insertColumnRight"], "icon": "e-column-insertright-icon", "menuId": "ColumnRight", enabled: isInsert });
                columnMenuItems.push({ "name": columnMenuText["deleteColumn"], "icon": "e-column-delete-icon", "menuId": "DeleteColumn", enabled: proxy._enableDisableDEL(column) });
                columnMenuItems.push({ "name": columnMenuText["renameColumn"], "icon": "e-column-rename-icon", "menuId": "RenameColumn" });
            }
            if (model.allowFiltering && (ej.isNullOrUndefined(column.allowFiltering) || column.allowFiltering) && model.filterSettings.filterType == "menu") {
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    columnMenuItems.push({ "name": columnMenuText["menuFilter"], "icon": "e-column-filtered-icon", "menuId": "Filter" });
                    filtermenuindex = columnMenuItems.length;
                } else {
                    columnMenuItems.push({ "name": columnMenuText["menuFilter"], "icon": "e-column-filter-icon", "menuId": "Filter" });
                    filtermenuindex = columnMenuItems.length;
                }
            }
            if (model.allowSorting && allowSorting)
            {
                columnMenuItems.push({ "name": columnMenuText["sortAscendingText"], "icon": "e-columnmenu-ascending", "menuId": "SortAscending" });
                columnMenuItems.push({ "name": columnMenuText["sortDescendingText"], "icon": "e-columnmenu-descending", "menuId": "SortDescending" });
            }
            if (model.showColumnChooser) {
                columnChooserListIndex = columnMenuItems.length;
                columnMenuItems.push({ "name": columnMenuText["columnsText"], "icon": "e-columnchooser-icon", "menuId": "Columns" });
            }

            if (!model.isFromGantt) {
                if (column.allowFreezing || (proxy._allowFreezingDefault && ej.isNullOrUndefined(column.allowFreezing))) {
                    var enableFreeze, enableFreezeBefore = false;
                    /*Check all other columns are in frozen*/
                    if (proxy._frozenColumnsLength == model.columns.length - 1 && !column.isFrozen)
                        enableFreeze = true;

                    /*Check frozen column width and container width */
                    var frozenWidth = this._getFrozenColumnWidth(),
                        columnIndex = model.columns.indexOf(column);
                    frozenWidth = frozenWidth + this.columnsWidthCollection[columnIndex] + 18;
                    if (frozenWidth > this._gridWidth)
                        enableFreeze = true;

                    columnMenuItems.push({ "name": columnMenuText["freezeText"], "icon": "e-freezecolumn-icon", "menuId": "FreezeColumns", enabled: enableFreeze ? false : !column.isFrozen });
                    columnMenuItems.push({ "name": columnMenuText["unfreezeText"], "icon": "e-unfreezecolumn-icon", "menuId": "UnfreezeColumns", enabled: (column.isFrozen == true) });
                    if (proxy._checkboxSelection && model.columns[0].nonColumn) {
                        if (model.columns.indexOf(column) != 1 && model.columns.indexOf(column) > this._frozenColumnsLength)
                            enableFreezeBefore = true;
                    }
                    else if (model.columns.indexOf(column) != 0 && model.columns.indexOf(column) > this._frozenColumnsLength)
                        enableFreezeBefore = true;

                    /*Check frozen column width and container width */
                    frozenWidth = this._getFrozenColumnWidth(columnIndex);
                    frozenWidth = frozenWidth + 18;
                    if (frozenWidth > this._gridWidth)
                        enableFreezeBefore = false;
                    columnMenuItems.push({ "name": columnMenuText["freezePrecedingColumnsText"], "icon": "e-freezecolumnbefore-icon", "menuId": "FreezePrecedingColumns", enabled: enableFreezeBefore });
                }
            }
            var position = proxy.getOffsetRect($target[0]);            
            var elementPosition = proxy.getOffsetRect(proxy.element[0]);           
            if (!proxy.model.isFromGantt)
                posY = position.top + targetHeight;
            else
                posY = position.top + targetHeight;            
            proxy._columnChooserListIndex = columnChooserListIndex;
            var $outerDiv = ej.buildTag("div.e-columnmenu", "", {
                "display": "table",
                "position": "absolute", "top": posY, "z-index": proxy.getMaxZIndex() + 1
            }, { id: proxy._id + "_ColumnMenu" }),
                $outerUl = ej.buildTag("ul.e-treegrid-columnmenu", "", {}, {}),
                $columnMenuList = $.render[proxy._id + "columnMenuTemplate"](columnMenuItems);
            model.cssClass && ($outerDiv.addClass(model.cssClass));
            $outerUl.append($columnMenuList);
            $outerDiv.append($outerUl);
            $(document.body).append($outerDiv);
            var columnMenuHeight = $outerDiv.height(),
                columnMenuWidth = ($outerDiv.outerWidth() + 1);
            posX = position.left + targetWidth - columnMenuWidth;
            if (posX <= elementPosition.left)
                posX = elementPosition.left;
            columnListPosX = posX + columnMenuWidth;
            columnFilterPosX = posX + columnMenuWidth;
            proxy._columnListPosX = columnListPosX;
            proxy._columnFilterPosX = columnFilterPosX;
            proxy._columnMenuPopupY = posY;
            $outerDiv.css({ 'left': posX });
            $outerDiv.find(".e-columnmenuitem").outerWidth(columnMenuWidth);

            //Edge detection for column menu
            var element = !model.isFromGantt ? $(this.element) : $(this.element).closest(".e-gantt"),
                containerOffset = this.getOffsetRect(element[0]);
            containerOffset.bottom = containerOffset.top + element[0].offsetHeight;
            containerOffset.right = containerOffset.left + $(element).width();
            if (!model.isFromGantt) {
                if (proxy.model.isResponsive && $(window).width() <= proxy._responsiveMinWidth)
                    $("#" + proxy._id + "_ColumnMenu").find(".e-expander").addClass("e-treegridadaptivesubicon");
                else
                    $("#" + proxy._id + "_ColumnMenu").find(".e-expander").removeClass("e-treegridadaptivesubicon");
            }

            $("#" + proxy._id + "_ColumnsChooser").on("mouseenter click", function (e) {

                if (((e.type == "mouseenter" && $(window).width() > proxy._responsiveMinWidth) || !proxy.model.isResponsive) || ((e.type == "click" && $(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive)) || model.isFromGantt) {
                    if (($(window).width() > proxy._responsiveMinWidth || !proxy.model.isResponsive) || model.isFromGantt) {
                        var evntArgs = {};
                        evntArgs.width = "auto";
                        evntArgs.height = "auto";
                        evntArgs.minWidth = "0px";
                        evntArgs.minHeight = "0px";
                        evntArgs.showHeader = false;
                        evntArgs.position = { X: 1, Y: 1 };
                        evntArgs.enableModal = false;
                        evntArgs.isResponsive = false;
                        evntArgs.enableResize = false;
                        evntArgs.cssClass = proxy.model.cssClass;
                         $("#" + proxy._id + "ccDiv_wrapper").addClass("e-treegridadaptivedialog")
                        $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                        $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
                        $("#" + proxy._id + "ccDiv").css({ 'height': 'auto' });

                        proxy._updateColumnMenuVisibility();
                        var columnchooser = $("#" + proxy._id + "ccDiv").ejDialog("instance"),
                            columnChooserList = $("#" + proxy._id + "ccDiv_wrapper"),
                            columnChooserMenuList = columnChooserList.find("div.e-columnMenuListDiv");
                        columnchooser.open();
                        if (containerOffset.right < columnListPosX + columnChooserList.width()) {
                            columnListPosX = columnListPosX - columnChooserList.width() - columnMenuWidth;
                            if (columnListPosX <= (columnMenuWidth)) {
                                columnListPosX = posX + columnMenuWidth;
                            }
                        }
                        proxy._columnListPosX = columnListPosX;
                        var position = {
                            X: columnListPosX,
                            Y: posY + $("#" + proxy._id + "_ColumnsChooser").position().top
                        };
                        columnchooser.option({ "position": position });
                        columnChooserList.css("z-index", proxy.getMaxZIndex() + 1);
                        columnChooserMenuList.removeClass("e-columnmenuselection");
                        columnChooserMenuList.eq(0).addClass("e-columnmenuselection");
                        proxy._focusTreeGridElement();
                        proxy._renderedSubMenuType = "ColumnDesktop";
                    } else {
                        proxy._adaptiveColumnChooser();

                    }
                    if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                        proxy._clearFilterMenu();
                    }
                }
                });

            $("#" + proxy._id + "_FilterChooser").on("mouseenter click", function (e) {
                if (((e.type == "mouseenter" && $(window).width() > proxy._responsiveMinWidth) || !proxy.model.isResponsive) || ((e.type == "click" && $(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive))) {

                    var index, editType, str, filtertype;
                    proxy._updateColumnMenuVisibility();
                    if (column.filterEditType) {
                        index = column.filterEditType.indexOf("edit");
                        filtertype = column.filterEditType;
                    }
                    else {
                        index = column.editType.indexOf("edit");
                        filtertype = column.editType;
                    }
                    if (index != -1) {
                        editType = filtertype.slice(0, index);
                        str = editType.charAt(0).toUpperCase() + editType.slice(1);
                        proxy._showFilterMenu("columnchooser", "filter" + str, columnFilterPosX, columnMenuWidth, containerOffset.right, posX, columnChooserListIndex, filtermenuindex, column, posY);
                    } else {
                        str = filtertype.charAt(0).toUpperCase() + filtertype.slice(1);
                        proxy._showFilterMenu("columnchooser", "filter" + str, columnFilterPosX, columnMenuWidth, containerOffset.right, posX, columnChooserListIndex, filtermenuindex, column, posY);
                    }
                    proxy._updatePreviousFilteredValue(column);
                    $("#" + proxy._id + "ccDiv").ejDialog("close");
                }
                });
            $("#" + proxy._id + "_SortAscendingChooser," + "#" + proxy._id + "_SortDescendingChooser," +
              "#" + proxy._id + "_FreezeColumnsChooser," + "#" + proxy._id + "_UnfreezeColumnsChooser," +
              "#" + proxy._id + "_FreezePrecedingColumnsChooser," + "#" + proxy._id + "_ColumnLeftChooser," +
              "#" + proxy._id + "_ColumnRightChooser," + "#" + proxy._id + "_DeleteColumnChooser," +
              "#" + proxy._id + "_RenameColumnChooser").mouseenter(function () {
                $("#" + proxy._id + "ccDiv").ejDialog("close");
                  if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                      proxy._clearFilterMenu();
                  }
              });
            $("#" + proxy._id + "_SortAscendingChooser").click(function () {
                if (model.allowMultiSorting)  proxy._multiSortRequest = true;
                if (model.isFromGantt)
                    proxy.sortColumn(column.mappingName ? column.mappingName : column.field, ej.sortOrder.Ascending);
                else
                    proxy.sortColumn(column.field, ej.sortOrder.Ascending);
                proxy._multiSortRequest = false;
            });
            $("#" + proxy._id + "_SortDescendingChooser").click(function () {
                if(model.allowMultiSorting) proxy._multiSortRequest = true;
                if (model.isFromGantt)
                    proxy.sortColumn(column.mappingName ? column.mappingName : column.field, ej.sortOrder.Descending);
                else
                    proxy.sortColumn(column.field, ej.sortOrder.Descending);
                proxy._multiSortRequest = false;
            });
            $("#" + proxy._id + "_FreezeColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {
                    if (proxy._checkboxSelection) {
                        if (model.columns[0].nonColumn && !model.columns[0].isFrozen)
                            model.columns[0]['isFrozen'] = true;                        
                    }
                    proxy.freezeColumn(column.field, true);
                }
            });
            $("#" + proxy._id + "_UnfreezeColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {                    
                    if (proxy._checkboxSelection && proxy._frozenColumnsLength == 2) {
                        if (model.columns[0].nonColumn && model.columns[0].isFrozen)
                            model.columns[0]['isFrozen'] = false;                            
                    }
                    proxy.freezeColumn(column.field, false);
                }
            });
            $("#" + proxy._id + "_FreezePrecedingColumnsChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.freezePrecedingColumns(column.field);
            });

            $("#" + proxy._id + "_ColumnLeftChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.insertColumnChooser(column, "left");
                else
                    return false;
            });
            $("#" + proxy._id + "_ColumnRightChooser").click(function () {
                if (!$(this).hasClass("e-disable"))
                    proxy.insertColumnChooser(column, "right");
                else
                    return false;
            });

            $("#" + proxy._id + "_DeleteColumnChooser").click(function () {
                if (!$(this).hasClass("e-disable")) {
                    proxy._targetColumnIndex = model.columns.indexOf(column);
                    proxy._updateConfirmDialog.ejDialog("open");
                    proxy._clearColumnMenu();
                }
                else
                    return false;
            });

            $("#" + proxy._id + "_RenameColumnChooser").click(function () {
                proxy._targetColumnIndex = model.columns.indexOf(column);
                proxy._renderColumnRenameDialog(column);
                proxy._columnRenameDialog.ejDialog("open");
                proxy._clearColumnMenu();
            });

            var columnMenu = $("#" + proxy._id + "_ColumnMenu"),
                columnMenuItem = columnMenu.find("div.e-columnmenuitem");
            columnMenuItem.eq(0).addClass("e-columnmenuselection");
            $(columnMenuItem).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    columnMenuItem.removeClass("e-columnmenuselection");
                    $(this).addClass("e-columnmenuselection");
                }
            });
        },

        // Method to render adaptive column chooser

        _adaptiveColumnChooser: function () {
            var proxy = this, evntArgs = {}, controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]),columnMenuText = proxy._columnMenuTexts;
            evntArgs.cssClass = proxy.model.cssClass,
            evntArgs.enableModal = false,
            evntArgs.enableResize = false;
            evntArgs.enableResize = false,
            evntArgs.contentSelector = "#" + proxy._id,
            evntArgs.rtl = proxy.model.rtl,
            evntArgs.allowDraggable = false;
            evntArgs.showHeader = true;
            evntArgs.minHeight = "50px";
            evntArgs.minWidth = "50px";
                evntArgs.width = $("#" + proxy._id).width() + "px";
                evntArgs.height = $("#" + proxy._id).height() + "px";
                evntArgs.position = { X: controlPosition .left + "px", Y: controlPosition .top + "px" };
                evntArgs.isResponsive = false;
            evntArgs.allowKeyboardNavigation = false;
            evntArgs.title = columnMenuText["columnsText"];
            $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-treegridadaptivedialog");
            $("#" + proxy._id + "ccDiv_wrapper").addClass("e-dialog").addClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%");
            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivedialog");
            $("#" + proxy._id + "ccDiv").ejDialog(evntArgs);
            $("#" + proxy._id + "ccDiv").ejDialog("open");

            $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': '100%' });
            if (proxy.model.isResponsive) {
                var dialogInnerDivHeight = ($("#" + proxy._id).height() - 50) + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                $("#" + proxy._id + "ccDiv_wrapper").css({ 'width': $("#" + proxy._id).width(), 'height': $("#" + proxy._id).height() });
                $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");
                $("#" + proxy._id + "ccDiv").css({ 'width': '100%', 'height': 'auto' });
                if ($("#" + proxy._id + "ccDiv").height() > $("#" + proxy._id + "ccDiv_wrapper").height() - 48) { // 48px - Dialog box header height
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 48) + "px", 'width': 'auto', 'padding': '0px' }); // 48px - Dialog box header height
                    $("#" + proxy._id + "ccDiv").removeClass("e-columnSelector");
                    $("#" + proxy._id + "ccDiv").ejDialog("refresh");
                } else {
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight, 'width': 'auto' });
                    $("#" + proxy._id + "ccDiv").css({ 'padding': '8px 16px' });
                }
                $("#" + proxy._id + "ccDiv_wrapper").removeClass("e-shadow");
                $("#" + proxy._id + "ccDiv").removeClass("e-shadow");
            }

            proxy._renderedSubMenuType = "AdaptiveColChooser";
            $("#" + proxy._id + "_ColumnMenu").remove();

        },

        //update previous filtered value for current rendering dialog box depends on its filter edit type
        _updatePreviousFilteredValue: function (column) {
            var proxy = this, suggesionBox, dropDown, dataManager, query, result, fieldIndex, groups = [], field1, filtertype, emptydrop;
            if (column.filterEditType)
                filtertype = column.filterEditType;
            else
                filtertype = column.editType;
            if (filtertype == "stringedit") {
                suggesionBox = $("#" + proxy._id + "filterStringInputBox").data("ejAutocomplete");
                dropDown = $("#" + proxy._id + "filterStringMenuDiv").find("#" + proxy._id + "filterStringDropDown").data("ejDropDownList");
                query = ej.Query().select(column.field);
                dataManager = new ej.DataManager(proxy.model.flatRecords.slice());
                result = dataManager.executeLocal(query);
                suggesionBox.option("dataSource", result);
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "startswith");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                    $("#" + proxy._id + "filterStringInputBox").val(proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    dropDown.option("value", "startswith");
                    suggesionBox.option("value", null);
                }
            }
            if (filtertype == "numericedit") {
                suggesionBox = $("#" + proxy._id + "filterNumericInputBox").data("ejNumericTextbox");
                dropDown = $("#" + proxy._id + "filterNumericMenuDiv").find("#" + proxy._id + "filterNumericDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                    $("#" + proxy._id + "filterNumericInputBox").val(proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
            }
            if (filtertype == "datepicker") {
                suggesionBox = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                dropDown = $("#" + proxy._id + "filterDatepickerMenuDiv").find("#" + proxy._id + "filterDatepickerDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
                if (column.format) {
                    suggesionBox.option("dateFormat", proxy._getDateFormat(column.format));
                }
            }
            if (filtertype == "datetimepicker") {
                suggesionBox = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                dropDown = $("#" + proxy._id + "filterDatetimepickerMenuDiv").find("#" + proxy._id + "filterDatetimepickerDropDown").data("ejDropDownList");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "")
                        dropDown.option("value", "lessthan");
                    else
                        dropDown.option("value", proxy._filteredColumnValue[fieldIndex].dropdown);
                    suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("value", null);
                    dropDown.option("value", "lessthan");
                }
                if (column.format) {
                    suggesionBox.option("dateFormat", proxy._getDateFormat(column.format));
                }
            }
            if (filtertype == "dropdownedit") {
                $.extend(groups, column.dropdownData);
                if (column.editParams) {
                    field1 = { value: column.editParams.fields.value, text: column.editParams.fields.text };
                        emptydrop = {};
                        emptydrop[column.editParams.fields.text] = proxy._dropDownListBlanksText;
                        emptydrop[column.editParams.fields.value] = "(Blanks)";
                } else {
                    field1 = { value: "value", text: "text" };
                    emptydrop = { text: proxy._dropDownListBlanksText, value: "(Blanks)" };
                }
                dropDown = $("#" + proxy._id + "filterDropdownDropDown").data("ejDropDownList");
                if (!ej.isNullOrUndefined(groups) && groups.length != 0) {

                    if (column.allowFilteringBlankContent || ej.isNullOrUndefined(column.allowFilteringBlankContent))
                        groups.unshift(emptydrop);

                    dropDown.option("dataSource", groups);
                }
                else {
                    groups = proxy._dropDownArrayCollection(column, column.field);
                    if (column.allowFilteringBlankContent || ej.isNullOrUndefined(column.allowFilteringBlankContent))
                        groups.unshift(emptydrop);
                    dropDown.option("dataSource", groups);
                }
                dropDown.option("fields", field1);

                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    dropDown.option("value", proxy._filteredColumnValue[fieldIndex].value);

                } else {
                        dropDown.option("value", null);
                }
            }
            if (filtertype == "booleanedit") {
                var suggesionBox = $("#" + proxy._id + "filterBooleanInputBox").data("ejCheckBox");
                if (proxy._filteredColumnValueID.indexOf(column.field) != -1) {
                    fieldIndex = proxy._filteredColumnValueID.indexOf(column.field);
                    if (proxy._filteredColumnValue[fieldIndex].value == "") {
                        suggesionBox.option("checkState", "uncheck");
                    }
                    else
                        suggesionBox.option("value", proxy._filteredColumnValue[fieldIndex].value);
                } else {
                    suggesionBox.option("selectedIndex", "");
                }
            }
        },

        //perform filter operation
        _performMenuFilter: function (column, suggesionBoxValue, dropDownValue) {
            var proxy = this, filteredColumnIdIndex, filtertype;
            proxy.clearAllSelection();
            if (column.filterEditType)
                filtertype = column.filterEditType;
            else
                filtertype = column.editType;
            if (ej.isNullOrUndefined(suggesionBoxValue)) {
                suggesionBoxValue = "";
            }
            proxy._searchString = suggesionBoxValue;
            if (proxy._filteredColumnValueID.indexOf(column.field) == -1 && suggesionBoxValue.toString() == "") {
                proxy.clearColumnMenu();
                proxy._clearFilterMenu();
            } else {
                if (filtertype == "numericedit" || filtertype == "datepicker" || filtertype == "datetimepicker") {
                    if ((filtertype == "datepicker" || filtertype == "datetimepicker") && (dropDownValue == "equal" || dropDownValue == "notequal"))
                        proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and");
                    else
                        proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and", true);
                }
                else {
                    proxy.filterColumn(column.field, dropDownValue, suggesionBoxValue, "and");
                }
            if (!proxy.model.showColumnChooser) {
                if (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false") {
                    proxy._filterIconTarget.target.className = "e-column-filtered-icon e-icon e-filtericon";
                } else {
                    proxy._filterIconTarget.target.className = "e-column-filter-icon e-icon e-filtericon";
                }
            }
            proxy._storePreviousFilteredValue(column.field, suggesionBoxValue, dropDownValue);
            proxy._searchString = suggesionBoxValue;
            proxy.clearColumnMenu();
            proxy._clearFilterMenu();
        }

        },

        // Resore the previous filtered values.
        _storePreviousFilteredValue: function (field, suggesionBoxValue, dropDownValue) {
            var proxy = this, filteredColumnIdIndex;
            if (proxy._filteredColumnValueID.indexOf(field) == -1 && (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false")) {
                proxy._filteredColumnValue.push({ column: field, value: suggesionBoxValue, dropdown: dropDownValue });
                proxy._filteredColumnValueID.push(field);
            } else {
                if (suggesionBoxValue.toString() != "" || suggesionBoxValue.toString() == "false") {
                    filteredColumnIdIndex = proxy._filteredColumnValueID.indexOf(field);
                    proxy._filteredColumnValue[filteredColumnIdIndex].value = suggesionBoxValue;
                    proxy._filteredColumnValue[filteredColumnIdIndex].dropdown = dropDownValue;
                } else {
                    if (proxy._filteredColumnValueID.indexOf(field) != -1) {
                        filteredColumnIdIndex = proxy._filteredColumnValueID.indexOf(field);
                        proxy._filteredColumnValue.splice(filteredColumnIdIndex, 1);
                        proxy._filteredColumnValueID.splice(filteredColumnIdIndex, 1);
                    }
                }
            }
        },

        //render filter menu dialog in a respective position
        _showFilterMenu: function (from, idValue, columnFilterPosX, columnMenuWidth, containerRightOffset, posX, columnChooserListIndex, filtermenuindex, column, posY) {
            if (!this.editFormValidate()) return;
            if (($(window).width() <= this._responsiveMinWidth && this.model.isResponsive) && !this.model.isFromGantt) {
                var proxy = this,
                evntArgs = {},
                controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);
                evntArgs.cssClass = this.model.cssClass;
                evntArgs.enableModal = false;
                evntArgs.isResponsive = false;
                evntArgs.enableRTL = this.model.enableRTL;
                evntArgs.enableResize = false;
                evntArgs.allowDraggable = false;
                evntArgs.minWidth = "50px";
                evntArgs.minHeight = "50px";
                evntArgs.width = $("#" + proxy._id).width() + "px";
                evntArgs.height = $("#" + proxy._id).height() + "px";
                evntArgs.position = { X: controlPosition .left + "px", Y: controlPosition .top + "px" };
                evntArgs.contentSelector = "#" + proxy._id;
                evntArgs.rtl = proxy.model.rtl;
                evntArgs.allowKeyboardNavigation = false;
                evntArgs.showHeader = true;
                evntArgs.title = column.headerText;
                $("#" + proxy._id + idValue + "MenuDiv").removeClass("e-treegridadaptivedialog");
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog(evntArgs);
                $("#" + proxy._id + idValue + "MenuDiv_wrapper").addClass("e-dialog").addClass("e-shadow").find("div.e-dialog-scroller").addClass("e-treegridadaptivewidth");
                $("#" + proxy._id + idValue + "MenuDiv").css({ 'width': '100%','height':'auto' });
                var dialogInnerDivHeight = $("#" + proxy._id).height() - 50 + "px"; // (48px - Dialog box header height) + (2px - excess border of parent div).
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog('open');
                    $("#" + proxy._id + idValue + "MenuDiv_wrapper").find("div.e-dialog-scroller").css({ 'height': dialogInnerDivHeight });
                    $("#" + proxy._id + idValue + "MenuDiv_wrapper").removeClass("e-shadow");
                    $("#" + proxy._id + idValue + "MenuDiv").removeClass("e-shadow");

                    if ($("#" + proxy._id + idValue + "MenuDiv").height() > $("#" + proxy._id + idValue + "MenuDiv_wrapper").height() - 48) { // 48px - Dialog box header height
                        $("#" + proxy._id + idValue + "MenuDiv").ejDialog("refresh");
                    }
                proxy._renderedSubMenuType = "#" + proxy._id + idValue + "MenuDiv";
                $("#" + proxy._id + "_ColumnMenu").remove();
            } else {
                var proxy = this;
                var evntArgs = {};
                evntArgs.width = "auto",
                evntArgs.height = "auto",
                evntArgs.minWidth = "0px",
                evntArgs.minHeight = "0px",
                evntArgs.showHeader = false,
                evntArgs.position = { X: 1, Y: 1 },
                evntArgs.enableModal = false,
                evntArgs.isResponsive = false,
                evntArgs.enableResize = false,
                evntArgs.cssClass = this.model.cssClass;
                $("#" + proxy._id + idValue + "MenuDiv_wrapper").removeClass("e-dialog").removeClass("e-shadow").find("div.e-dialog-scroller").css("height", "100%").removeClass("e-widget-content");
                $("#" + proxy._id + idValue + "MenuDiv").ejDialog(evntArgs);
                var filterMenuDiv, filterMenuDivWrapper, filterMenuPosition;
                filterMenuDiv = $("#" + proxy._id + idValue + "MenuDiv").ejDialog("instance");
                filterMenuDivWrapper = $("#" + proxy._id + idValue + "MenuDiv_wrapper");
                if (from == "columnchooser") {
                    var windowWidth = $(document).width();
                    if ((containerRightOffset < columnFilterPosX + filterMenuDivWrapper.width()) || (windowWidth < columnFilterPosX + filterMenuDivWrapper.width())) {
                        if ((columnFilterPosX - columnMenuWidth - filterMenuDivWrapper.width()) > 0)
                            columnFilterPosX = columnFilterPosX - columnMenuWidth - filterMenuDivWrapper.width();
                    }
                    filterMenuPosition = {
                        X: columnFilterPosX,
                        Y: posY + $("#" + proxy._id + "_FilterChooser").position().top
                    };
                    filterMenuDiv.option({ "position": filterMenuPosition });
                    filterMenuDiv.open();
                } else if (from = "filtermenu") {
                    var position = columnFilterPosX,
                    targetWidth = columnMenuWidth;
                    posX = position.left + targetWidth - filterMenuDivWrapper.width();
                    position.left = posX + filterMenuDivWrapper.width() + 4;
                    if (containerRightOffset < position.left + filterMenuDivWrapper.width()) {
                        position.left = position.left - filterMenuDivWrapper.width() - targetWidth;
                    }
                    filterMenuPosition = {
                        X: position.left,
                        Y: position.top
                    };
                    filterMenuDiv.option({ "position": filterMenuPosition });
                    filterMenuDiv.open();
                }
                proxy._renderedSubMenuType = "#" + proxy._id + idValue + "MenuDivDesktop";
            }
        },

        _clearResponsiveColumnMenu:function(){
            var proxy = this;
            $("div[id$='ccDiv']").each(function () {
                if ($(this).data("columnMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'padding': '0px' });
            $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
            $("div[id$='filterStringMenuDiv']").each(function () {
                if ($(this).data("filterStringMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterNumericMenuDiv']").each(function () {
                if ($(this).data("filterNumericMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterBooleanMenuDiv']").each(function () {
                if ($(this).data("filterBooleanMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDatepickerMenuDiv']").each(function () {
                if ($(this).data("filterDatepickerMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDatetimepickerMenuDiv']").each(function () {
                if ($(this).data("filterDatetimepickerMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='filterDropdownMenuDiv']").each(function () {
                if ($(this).data("filterDropdownMenuDialog") == "TreeGrid")
                    $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='ColumnRenameDialog']").each(function () {
                $(this).data("ejDialog") && $(this).ejDialog("close");
            });
            $("div[id$='dialogColumnAdd']").each(function () {
                $(this).data("ejDialog") && $(this).ejDialog("close");
            });

            $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
        },

        //Clear the column menu and menu list

        _clearColumnMenu:function(args)
        {
            var proxy = this;
            if (args === "columnmenu" && $(window).width() < proxy._responsiveMinWidth) {
                proxy._clearResponsiveColumnMenu();
            }
            if (proxy.model.isResponsive && $(window).width() < proxy._responsiveMinWidth) {
                $("#" + proxy._id + "_ColumnMenu").remove();
                if (proxy._renderedSubMenuType && proxy._renderedSubMenuType.indexOf("AdaptiveColChooser") == -1) {
                    $("div[id$='" + proxy._id + "ccDiv']").each(function () {
                        if ($(this).data("columnMenuDialog") == "TreeGrid")
                            $(this).data("ejDialog") && $(this).ejDialog("close");
                    });
                    $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({'padding': '0px' });
                    $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
                }
            }
        else{
            $("#" + proxy._id + "_ColumnMenu").remove();
            if (args != "resize") {
                $("div[id$='" + proxy._id + "ccDiv']").each(function () {
                    if ($(this).data("columnMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("#" + proxy._id + "ccDiv_wrapper").find("div.e-dialog-scroller").css({ 'padding': '0px' });
                $("#" + proxy._id + "ccDiv").addClass("e-columnSelector");
                if (args != "resize") {
                    if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                        proxy._clearFilterMenu();
                    }
                }
            }
    }

            $("#" + proxy._id).find(".e-columnicon").data("isClicked", false);
            $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
        },

        // clear the filter menu dialog and its inner components
        _clearFilterMenu: function () {
            var proxy = this;
            if (proxy.model.allowFiltering && proxy.model.filterSettings.filterType == "menu") {
                $("div[id$='" + proxy._id + "filterStringMenuDiv']").each(function () {
                    if ($(this).data("filterStringMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterNumericMenuDiv']").each(function () {
                    if ($(this).data("filterNumericMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterBooleanMenuDiv']").each(function () {
                    if ($(this).data("filterBooleanMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDatepickerMenuDiv']").each(function () {
                    if ($(this).data("filterDatepickerMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDatetimepickerMenuDiv']").each(function () {
                    if ($(this).data("filterDatetimepickerMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("div[id$='" + proxy._id + "filterDropdownMenuDiv']").each(function () {
                    if ($(this).data("filterDropdownMenuDialog") == "TreeGrid")
                        $(this).data("ejDialog") && $(this).ejDialog("close");
                });
                $("#" + proxy._id + "filterStringDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterStringInputBox_suggestion").hide();
                $("#" + proxy._id + "filterNumericDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterNumericInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDatepickerDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterDatepickerInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDatetimepickerDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id + "filterDatetimepickerInputBox_suggestion").hide();
                $("#" + proxy._id + "filterDropdownDropDown_popup_list_wrapper").hide();
                $("#" + proxy._id).find(".e-filtericon").data("isClicked", false);
                var datetimepicobj = $("#" + proxy._id + "filterDatetimepickerInputBox").data("ejDateTimePicker");
                if (datetimepicobj)
                    datetimepicobj.hide();
                var datepicobj = $("#" + proxy._id + "filterDatepickerInputBox").data("ejDatePicker");
                if (datepicobj)
                    datepicobj.hide();
            }
        },

        _getDateFormat: function (format) {
            var toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm"),
                formatVal = toformat.exec(format),
                dateFormat = formatVal[2];
            return dateFormat;
        },

        //Enabling or disabling delete button of columnchooser
        _enableDisableDEL: function (colItem) {
            var proxy = this, model = proxy.model,
                fieldName = colItem.field,
                columnIndex = model.columns.indexOf(colItem);
            if (model.isFromGantt) {
                if (fieldName == "taskId" || fieldName == "taskName" || fieldName == "startDate" || fieldName == "endDate" || (fieldName == "duration" && !model.endDateMapping) || columnIndex == model.treeColumnIndex)
                    return false;
                else
                    return true;
            }
            else {
                if (columnIndex == model.treeColumnIndex)
                    return false;
                else
                    return true;
            }
        },

        //Enabling or disabling Insert column label columnchooser
        _enableDisableInsertLabel: function () {
            var proxy = this, model = proxy.model;
            //Block column add operation while frozen columns Width is near to grid width
            if (!model.isFromGantt && proxy._frozenColumnsLength > 0) {
                var frozenWidth = this._getFrozenColumnWidth();
                frozenWidth = frozenWidth + 250;
                if (frozenWidth > this._gridWidth)
                    return false;
                else
                    return true;
            }
            else
                return true;
        },

        //Insert column through column chooser
        insertColumnChooser: function (column, position) {
            var proxy = this, model = proxy.model;
            if ($("#" + proxy._id + "_dialogColumnAdd").length === 0) {
                var $dialogCol = ej.buildTag("div.e-dialog e-dialog-content e-widget-content", "", { display: "none" }, { id: proxy._id + "_dialogColumnAdd" });
                proxy.element.append($dialogCol);
                proxy._on($("#" + proxy._id + "_dialogColumnAdd"),
               "click keypress", "#ColumnAddDialog_" + proxy._id + "_Ok ,#ColumnAddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);
            }
            proxy.renderColumnAddDialog();
            proxy._targetColumnIndex = model.columns.indexOf(column);
            proxy._insertPosition = position;
        },

        // To change the headerText of column
        renameColumn: function (colIndex, name) {
            var proxy = this, model = proxy.model,
                columns = model.columns, args = {};
            args.requestType = "renameColumn";
            args.columnObject = columns[colIndex];
            args.previousName = columns[colIndex].headerText;
            args.currentName = name;          
            if (!proxy._trigger("actionComplete", args)) {
                columns[colIndex].headerText = name;
                proxy._refreshFrozenColumns();
            }
            proxy._updateWrapRowHeights();
            if (model.allowTextWrap || model.headerTextOverflow == "wrap")
                proxy._updateGridContentHeight();
        },

        //Method to render dialog box for renaming column
        _renderColumnRenameDialog: function (columnItem) {
            var proxy = this, columnMenuText = proxy._columnMenuTexts,
                $contentDiv = ej.buildTag('div.e-treegridrenamedialog', "", {}, { 'data-unselectable': 'on' }), controlWidth = $("#" + proxy._id).width(), controlHeight = $("#" + proxy._id).height(),
                $form = ej.buildTag('form', "", { 'height': '100%', 'width': '100%', 'font-size': '14px' }, { id: proxy._id + "ColumnRenameForm", onsubmit: "return false" }),
            $buttons = ej.buildTag('span.e-buttons', "<input class='e-treegrid-rename-dialog-btn-ok' type='button' id=" + proxy._id + 'RenameDialogOK' + " value=" + proxy._okButtonText + " /> "
            + "<input class='e-treegrid-rename-dialog-btn-cancel' type='button' id=" + proxy._id + 'RenameDialogCancel' + " value='" + proxy._cancelButtonText + "' />"),
            btnDiv = ej.buildTag('div', "", {}, { 'class': "e-treegrid-rename-dialog-btn" }),

            $innerTable = ej.buildTag('table', "", { 'outline': 'none', 'width': '100%', 'margin-top': '0px' }, { 'data-unselectable': "on" }),

            $inTr1 = ej.buildTag('tr'),

            $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none" }, { 'data-unselectable': "on" });
            $inTd.append("<label style='font-weight:normal;'>" + proxy._columnDialogTitle["renameColumn"] + "</label>");

            $inTr1.append($inTd);

            $innerTable.append($inTr1);

            var $inTr2 = ej.buildTag('tr'),
            $inTd2 = ej.buildTag('td.e-editValue'),

            $input = ej.buildTag('input.e-field e-ejinputtext',
                                            "",
                                            {},
                                            {
                                                value: columnItem.headerText,
                                                id: proxy._id + "RenameHeaderText",
                                                name: columnItem.field,
                                                "data-dialog": "RenameHeaderText"
                                            });
            $input.css({ 'margin': '0px', 'padding': '1px 4px 1px 0px' });
            $inTd2.html($input);
            $inTr2.append($inTd2);
            $innerTable.append($inTr2);
            $form.append($innerTable);
            $contentDiv.append($form);

            proxy._columnRenameDialog = ej.buildTag('div', '', '', { 'title': columnMenuText["renameColumn"], 'id': proxy._id + 'ColumnRenameDialog' });
            btnDiv.append($buttons);
            proxy._columnRenameDialog.append($contentDiv).append(btnDiv);
            proxy.element.append(proxy._columnRenameDialog);
            $buttons.find("input").ejButton({
                cssClass: proxy.model.cssClass,
                showRoundedCorner: true,
                size: "normal",
                click: $.proxy(proxy._triggerRenameColumn, proxy)
            });
            if (($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) && !proxy.model.isFromGantt) {
                if (proxy.model.isResponsive) {
                    var controlPosition = proxy.getOffsetRect($("#" + proxy._id)[0]);
                    $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-treegridadaptivedialog");
                    proxy._columnRenameDialog.ejDialog({ width: controlWidth + "px", height: controlHeight + "px", position: { X: controlPosition.left + "px", Y: controlPosition.top + "px" }, minHeight: "50px", minWidth: "50px", showOnInit: false, allowDraggable: false, enableResize: false, enableModal: false, isResponsive: false, cssClass: this.model.cssClass });
                    $("#" + proxy._id + "ColumnRenameDialog_wrapper").removeClass("e-shadow").addClass("e-treegrid-dialog");
                    $("#" + proxy._id + "ColumnRenameDialog").removeClass("e-shadow");
                }
            } else {
                proxy._columnRenameDialog.ejDialog({ width: "auto", height: "auto", minHeight: 0, minWidth: 240, showOnInit: false, enableResize: false, allowDraggable: true, enableModal: true, isResponsive: true, cssClass: this.model.cssClass });
                $("#" + proxy._id + "ColumnRenameDialog_wrapper").addClass("e-treegrid-dialog");
            }
            $input.focus().select();
        },

        _triggerRenameColumn: function (args) {
            var proxy = this, $elem, text;
            if (args !== undefined && args.model.text == proxy._okButtonText) {
                $elem = proxy._columnRenameDialog.find("#" + proxy._id + "RenameHeaderText");
                text = $elem.val();
                proxy.renameColumn(proxy._targetColumnIndex, text);
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) || proxy.model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(proxy.model.editSettings.dialogEditorTemplateID) && proxy.model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            proxy._columnRenameDialog.ejDialog("close");
        },

        //To render dialog for adding custom column
        renderColumnAddDialog: function () {

            var proxy = this, model = proxy.model, colDialogFields = model.columnDialogFields,
                args = {}, controlPosition  = proxy.getOffsetRect($("#" + proxy._id)[0]);;

            args.requestType = "openColumnAddDialog";
            if (colDialogFields.length) {
                args.data = {};
                for (var i = 0; i < colDialogFields.length; i++) {
                    var val = colDialogFields[i];
                    args.data[val] = "";
                }
            }
            else args.data = { "field": "", "headerText": "", "editType": "" };

            if (!proxy._trigger("actionBegin", args)) {
                args.requestType = "columnAdd";
                var temp = document.createElement('div');
                $(temp).addClass("e-addedColumn");
                temp.innerHTML = $.render[proxy._id + "_ColumnAddTemplate"](args.data);
                $("#" + proxy._id + "_dialogColumnAdd").html($(temp));
                var evntArgs = {};
                evntArgs.cssClass = this.model.cssClass,
                evntArgs.enableResize = false,
                evntArgs.width = "auto",
                evntArgs.height = "auto",
                evntArgs.contentSelector = "#" + proxy._id,
                evntArgs.rtl = proxy.model.rtl,
                evntArgs.allowKeyboardNavigation = false;
                var title = proxy._columnDialogTitle["insertColumn"];
                evntArgs.title = title;
                if (($(window).width() > proxy._responsiveMinWidth || !proxy.model.isResponsive) || proxy.model.isFromGantt) {
                    evntArgs.enableModal = true,
                    evntArgs.allowDraggable = true,
                    evntArgs.isResponsive = true;
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog(evntArgs);
                    $("#" + proxy._id + "_dialogColumnAdd").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").addClass("e-treegridadaptivedialog e-treegrid-dialog");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").addClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog("open");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".e-dropdowntreegrid").css('width', '438px'); // fixed width of dialog dropdown treegrid div.
                }
                if (($(window).width() <= proxy._responsiveMinWidth && proxy.model.isResponsive) && !proxy.model.isFromGantt) {

                    evntArgs.isResponsive = false;
                    evntArgs.enableResize = false;
                    evntArgs.enableModal = false,
                    evntArgs.allowDraggable = false;
                    evntArgs.width = $("#" + proxy._id).width() + "px";
                    evntArgs.height = $("#" + proxy._id).height() + "px";
                    evntArgs.minHeight= "150px";
                    evntArgs.minWidth = "150px";
                    $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-treegridadaptivedialog");
                    $("#" + proxy._id + "_dialogColumnAdd").find(".e-dropdowntreegrid").css({ 'width': ($("#" + proxy._id).width() - 80) + 'px', 'height': '150px' }); // 80px ((28px of $("#" + proxy._id + "_dialogColumnAdd"))+(18px of Hscrollbar)+(30px of $("#" + proxy._id + "ColumnAddForm div"))) get minused in width to place the dropdown dialog treegrid div in absolute position.
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog(evntArgs);
                        $("#" + proxy._id + "_dialogColumnAdd").ejDialog("open");
                        $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-treegridadaptivedialog").addClass("e-treegrid-dialog");
   
                $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").removeClass("e-treegridadaptivedialog");

                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").css({ 'left': controlPosition .left + "px", 'top': controlPosition .top + "px" });
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").removeClass("e-shadow");
                    $("#" + proxy._id + "_dialogColumnAdd").removeClass("e-shadow");
                    $("#" + proxy._id + "_dialogColumnAdd_wrapper").find("div.e-dialog-scroller").css({ 'height': ($("#" + proxy._id).height() - 50) + "px" }); // (48px - Dialog box header height) + (1px - excess border of parent div).

            }
                proxy._clearColumnMenu();
                proxy._refreshColumnAddForm();
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("refresh");
            }
        },

        setAddColumnFields: function () {
            var proxy = this,
                model = proxy.model;
            if (model.columnDialogFields.length) {
                proxy._addColumnFields = model.columnDialogFields;
                var tempFields = ["field", "headerText", "editType"];
                //Ensure the above 3 default fields with "model.columnDialogFields"
                for (var i = 0; i < tempFields.length; i++) {
                    if ($.inArray(tempFields[i], proxy._addColumnFields) == -1) {
                        switch (tempFields[i]) {
                            case "field":
                                proxy._addColumnFields.splice(0, 0, tempFields[i]);
                                break;
                            case "headerText":
                                proxy._addColumnFields.splice(1, 0, tempFields[i]);
                                break;
                            case "editType":
                                proxy._addColumnFields.splice(2, 0, tempFields[i]);
                                break;
                        }
                    }
                }
                //Check the "model.columnDialogFields" with allowSorting, allowFiltering and selectionType APIs
                if (model.isFromGantt) {
                    if (!model.allowSorting && proxy._addColumnFields.indexOf("allowSorting") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowSorting"), 1);
                    }
                    if (model.selectionSettings.selectionMode == "row" && proxy._addColumnFields.indexOf("allowCellSelection") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowCellSelection"), 1);
                    }
                }
                else {
                    if (!model.allowSorting && proxy._addColumnFields.indexOf("allowSorting") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowSorting"), 1);
                    }
                    if (!model.allowFiltering && proxy._addColumnFields.indexOf("allowFiltering") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowFiltering"), 1);
                    }
                    if (model.selectionSettings.selectionMode == "row" && proxy._addColumnFields.indexOf("allowCellSelection") != -1) {
                        proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("allowCellSelection"), 1);
                    }
                }
                //Move displayAsCheckbox to end o hide this field in column add dialog, if edittype choosed ad boolean then it will be shown
                if (proxy._addColumnFields.indexOf("displayAsCheckbox") != -1) {
                    proxy._addColumnFields.push(proxy._addColumnFields.splice(proxy._addColumnFields.indexOf("displayAsCheckbox"), 1)[0]);
                }

                //Assign appropriate header text to fields
                proxy._addColumnFieldsTxt = [];
                for (var i = 0; i < proxy._addColumnFields.length; i++) {
                    switch (proxy._addColumnFields[i]) {
                        case "field":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["field"]);
                            break;
                        case "headerText":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerText"]);
                            break;
                        case "editType":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["editType"]);
                            break;
                        case "filterEditType":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["filterEditType"]);
                            break;
                        case "allowFiltering":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFiltering"]);
                            break;
                        case "allowFilteringBlankContent":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFilteringBlankContent"]);
                            break;
                        case "allowSorting":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowSorting"]);
                            break;
                        case "visible":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["visible"]);
                            break;
                        case "width":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["width"]);
                            break;
                        case "textAlign":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["textAlign"]);
                            break;
                        case "headerTextAlign":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerTextAlign"]);
                            break;
                        case "isFrozen":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["isFrozen"]);
                            break;
                        case "allowFreezing":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowFreezing"]);
                            break;
                        case "allowCellSelection":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["allowCellSelection"]);
                            break;
                        case "showInColumnChooser":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["showInColumnChooser"]);
                            break;
                        case "clipMode":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["clipMode"]);
                            break;
                        case "tooltip":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["tooltip"]);
                            break;
                        case "headerTooltip":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["headerTooltip"]);
                            break;
                        case "displayAsCheckbox":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["displayAsCheckbox"]);
                            break;
                        case "priority":
                            proxy._addColumnFieldsTxt.push(proxy._columnDialogTexts["priority"]);
                            break;
                    }                  
                }
            }
            else {
                proxy._addColumnFields = ["field", "headerText", "editType"];
                proxy._addColumnFieldsTxt = [proxy._columnDialogTexts["field"], proxy._columnDialogTexts["headerText"], proxy._columnDialogTexts["editType"]];
            }
        },

        //Method for creating cell edit type
        setColumnCelEditType: function (columnAttr) {
            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                $input;
            if (columnAttr == "field" || columnAttr == "filterEditType" || columnAttr == "editType" || columnAttr == "textAlign" || columnAttr == "headerTextAlign" || columnAttr == "clipMode") {
                $input = ej.buildTag('input.e-field e-dropdownlist',
                                         "",
                                         {},
                                         {
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                            "data-dialog": "ColumnAdd"
                                         });
            }
            else if (columnAttr == "headerText" || columnAttr == "tooltip" || columnAttr == "headerTooltip") {
                $input = ej.buildTag('input.e-field e-ejinputtext',
                                         "",
                                         {},
                                         {
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                            "data-dialog": "ColumnAdd"
                                         });
                $input.css({ 'margin': '0px', 'padding': '1px 4px 1px 0px' });
            }
            else if (columnAttr == "allowFiltering" || columnAttr == "allowSorting" || columnAttr == "isFrozen" || columnAttr == "allowFreezing") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' data-dialog ="ColumnAdd"' +
                         ' name="' + columnAttr + '" data-edittype="booleanedit">';
            }
            else if (columnAttr == "allowFilteringBlankContent" || columnAttr == "visible") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' data-dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" data-edittype="booleanedit">';
            }
            else if (columnAttr == "allowCellSelection") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' data-dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" data-edittype="booleanedit">';
            }
            else if (columnAttr == "showInColumnChooser" || columnAttr == "displayAsCheckbox") {
                $input = ' <input' +
                         ' type ="checkbox"' +
                         ' id="' + proxy._id + columnAttr + 'ColumnAdd"' +
                         ' data-dialog = "ColumnAdd"' +
                         ' checked = "checked"' +
                         ' name="' + columnAttr + '" data-edittype="booleanedit">';
            }
            else if (columnAttr == "width" || columnAttr == "priority") {
                $input = ej.buildTag('input.e-numerictextbox e-field',
                                         "",
                                         {},
                                         {
                                             type: "text",
                                             value: "{{:#data['" + columnAttr + "']}}",
                                             id: proxy._id + columnAttr + "ColumnAdd",
                                             name: columnAttr,
                                             "data-dialog": "ColumnAdd"
                                         });
                $input.attr("data-edittype", "numericedit")
                $input.css({ 'margin': '0px', 'padding': '1px 4px 1px 0px' });
            }
            return $input;
        },

        //Template for adding custom column through dialog
        columnAddDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = model.columns,
                length = columns.length,
                $inputElem;

            if (length == 0)
                return;

            proxy.setAddColumnFields();

            var $tbody = ej.buildTag('div', "", {}, { 'data-unselectable': 'on' }),
            $form = ej.buildTag('form', "", { 'height': '100%', 'width': '100%', 'font-size': '14px' }, { id: proxy._id + "ColumnAddForm" }),
            $table = ej.buildTag('table', "", { width: "100%", "margin-top": "0px" }, { 'data-unselectable': "on" }),
            $tr = ej.buildTag('tr', "", { width: "100%" }),
            $td, $innerTable, $inTr, $inTd, $inTr2, $inTd2;
            for (var i = 0; i < proxy._addColumnFields.length; i++) {
                if ($tr.children("td").length < 2) {
                    $td = ej.buildTag('td.e-add-property-container', "", {}, { 'data-unselectable': "on" });
                    $innerTable = ej.buildTag('table', "", { "width": "100%", "outline": "none", "margin-top": "0px" }, { 'data-unselectable': "on" });

                    $inTr = ej.buildTag('tr');

                    $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none" }, { 'data-unselectable': "on" });
                    $inTd.append("<label style='font-weight:normal;'>" + proxy._addColumnFieldsTxt[i] + "</label>");

                    $inTr.append($inTd);

                    $innerTable.append($inTr);

                    $inTr2 = ej.buildTag('tr');
                    $inTd2 = ej.buildTag('td.e-editValue');

                    $inputElem = proxy.setColumnCelEditType(proxy._addColumnFields[i]);


                    $inTd2.html($inputElem);

                    $inTr2.append($inTd2);
                    $innerTable.append($inTr2);
                    if (proxy._addColumnFields[i] == "displayAsCheckbox") {
                        $innerTable.addClass("e-display-checkbox-conatiner").css("display","none");
                    }
                    $td.append($innerTable);
                    $tr.append($td);

                }
                else {
                    $table.append($tr);
                    $tr = ej.buildTag('tr');
                    i--;
                }

            }
            $table.append($tr);

          //  Table of Dropdown data for drop down edit type
            var $tr2 = ej.buildTag("tr"),
                $inTr3, $inTd3;

            if (model.showColumnChooser) {

                $td = ej.buildTag('td.e-add-property-container', "", {}, { colspan: 2, 'data-unselectable': "on" });

                $innerTable = ej.buildTag('table#' + proxy._id + 'dropdownDataTable', "", { "width": "100%", "outline": "none" }, { 'data-unselectable': "on" });

                $inTr3 = ej.buildTag('tr');
                $inTd3 = ej.buildTag('td.e-editLabel', "", { "outline": "none" }, { 'data-unselectable': "on" });
                $inTd3.append("<label for='dropdownData' style='font-weight:normal;'>" + proxy._columnDialogTexts["columnsDropdownData"] + "</label>");

                $inTr3.append($inTd3);
                $innerTable.append($inTr3);

                $inTr = ej.buildTag('tr');
                $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none" }, { 'data-unselectable': "on" });

                $inTd.append("<span class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;'>" + proxy._columnDialogTexts["addData"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;'>&nbsp;&nbsp;" + proxy._columnDialogTexts["deleteData"] + "</span>");

                $inTr.append($inTd);
                $innerTable.append($inTr);

                $inTr2 = ej.buildTag('tr');
                $inTd2 = ej.buildTag('td.e-editValue');
                if ($("#" + proxy._id).width() <= proxy._responsiveMinWidth) {
                    var dropdownTreegridWidth = ($("#" + proxy._id).width() - 80) + 'px';
                    $inTd3 = ej.buildTag('div.e-dropdowntreegrid', "", { 'width': dropdownTreegridWidth, 'overflow':'hidden' });
                } else {
                    $inTd3 = ej.buildTag('div.e-dropdowntreegrid', "", { 'width': '438px', 'overflow': 'hidden' });
                }
                var $preDiv = ej.buildTag("div#treegrid" + proxy._id + "dropdownData", "", { "width": "100%", "height": "150px" }, {});
                $inTd3.append($preDiv);
                $inTd2.append($inTd3);

                $inTr2.append($inTd2);
                $innerTable.append($inTr2);

                $td.append($innerTable);
                $tr2.append($td);
                $table.append($tr2);
            }


            $form.append($table);

            $tbody = proxy.renderColumnAddDialogButton($form, $tbody);
            $.templates(proxy._id + "_ColumnAddTemplate", $tbody.html());
        },

        //button templates for column add dialog
        renderColumnAddDialogButton: function (form, tbody) {

            var btnId = "ColumnAddDialog_",
                proxy = this,
                model = proxy.model,
                $btnokDiv = ej.buildTag("div.e-add-dialog-btn-ok", "", {}, {}),
                $innerButokDiv = ej.buildTag("div", "", {}, {});
            var okbtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px'
                 },
                 { type: "button", id: btnId + proxy._id + "_Ok" }),
             okText = proxy._okButtonText;

            okbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: okText,
                    width: "100%"
                });

            var $btncanDiv = ej.buildTag("div.e-add-dialog-btn-cancel", "", {}, {}),
            $innerButcanDiv = ej.buildTag("div", "", {}, {});
            var cancelText = proxy._cancelButtonText,
             cancelbtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px'
                 },
                 {
                     type: "button",
                     id: btnId + proxy._id + "_Cancel"
                 });

            cancelbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: cancelText,
                    width: "100%"
                });

                var btnDiv = ej.buildTag('div', "", {}, { 'class': "e-treegrid-add-btn" });

            $innerButokDiv.append(okbtn)
            $btnokDiv.append($innerButokDiv);
            btnDiv.append($btnokDiv);
            $innerButcanDiv.append(cancelbtn)
            $btncanDiv.append($innerButcanDiv);
            btnDiv.append($btncanDiv);
            form.appendTo(tbody);
            btnDiv.appendTo(tbody);

            return tbody;
        },

        //button click event column add dialog
        _buttonClick: function (e) {

            if (e.keyCode != 0 && e.keyCode !== undefined && e.keyCode != 13)
                return true;

            var proxy = this,
                model = proxy.model, treeIndex = model.treeColumnIndex, setFrozen = false,
                dialogId = "ColumnAdd", $element, columnVals = {}, colFields = proxy._addColumnFields, columns = model.columns,
                insertIndex, args = {}, isAlreadyRender,filtertype;

            if (e.target.id == "ColumnAddDialog_" + proxy._id + "_Ok") {
                var formelement = document.getElementById(proxy._id + "ColumnAddForm"), ddl;
                for (var count = 0; count < colFields.length; count++) {
                    var colField = colFields[count];
                    $element = $(formelement).find("#" + proxy._id + colField + dialogId);
                    if (colField == "editType" || colField == "filterEditType" || colField == "textAlign" || colField == "headerTextAlign" || colField == "clipMode") {
                        ddl = $element.data("ejDropDownList");
                        columnVals[colField] = ddl._selectedValue;
                        //To get column's dropdown data if edit type is dropdownedit
                        if (colField == "editType" && columnVals[colField] == "dropdownedit") {
                            var tableTreeGrid = $(formelement).find("#treegrid" + proxy._id + "dropdownData"),
                                tableTreeGridObj = tableTreeGrid.data("ejTreeGrid"),
                                treeData = tableTreeGridObj.model.dataSource;
                            if (treeData.length > 0)
                                columnVals["dropdownData"] = treeData;
                        }
                    }
                    else if (colField == "showInColumnChooser" || colField == "allowCellSelection" || colField == "allowSorting" || colField == "allowFiltering" || colField == "allowFilteringBlankContent" || colField == "visible" || colField == "isFrozen" || colField == "allowFreezing" || colField == "displayAsCheckbox") {
                        var ch = $element.data("ejCheckBox");
                        columnVals[colField] = ch._isChecked;
                    }
                    else if ($element.val() == "" && (colField == "headerText" || colField == "field")) {
                        if (colField == "field")
                            columnVals[colField] = "Column" + (model.columns.length + 1);
                        else if (colField == "headerText")
                            columnVals[colField] = "Column " + (model.columns.length + 1);
                    }
                    else if (colField == "priority") {
                        columnVals[colField] = $element.ejNumericTextbox("getValue");
                    }
                    else
                        columnVals[colField] = $element.val();
                }
                if (proxy._insertPosition == "left")
                    insertIndex = proxy._targetColumnIndex;
                else if (proxy._insertPosition == "right")
                    insertIndex = proxy._targetColumnIndex + 1;
                //To shift and maintain treecolumn index
                if (insertIndex <= treeIndex)
                    model.treeColumnIndex = treeIndex + 1;
                //Inserting new columns between frozen columns
                if (!model.isFromGantt) {
                    if (insertIndex <= proxy._frozenColumnsLength - 1)
                        setFrozen = true;
                }
                //Inserting columns -  left or right
                var newColumnObject = {};
                if (model.isFromGantt) {
                    newColumnObject = {
                        field: columnVals.field,
                        headerText: columnVals.headerText,
                        editType: columnVals.editType,
                        allowSorting: ej.isNullOrUndefined(columnVals.allowSorting) ? null : columnVals.allowSorting,
                        visible: columnVals.visible == false ? false : true,
                        width: columnVals.width ? columnVals.width : 150,
                        textAlign: columnVals.textAlign ? columnVals.textAlign : "left",
                        headerTextAlign: columnVals.headerTextAlign ? columnVals.headerTextAlign : "left",
                        dropdownData: columnVals.dropdownData ? columnVals.dropdownData : null,
                        allowCellSelection: ej.isNullOrUndefined(columnVals.allowCellSelection) ? null : columnVals.allowCellSelection,
                        mappingName: columnVals.field,
                        displayAsCheckbox: columnVals.displayAsCheckbox == false ? false : true,
                        clipMode: columnVals.clipMode ? columnVals.clipMode : "clip",
                        tooltip: columnVals.tooltip,
                        headerTooltip: columnVals.headerTooltip
                    };
                }
                else {
                    newColumnObject = {
                        field: columnVals.field,
                        headerText: columnVals.headerText,
                        editType: columnVals.editType,
                        filterEditType: columnVals.filterEditType ? columnVals.filterEditType : "stringedit",
                        allowFiltering: ej.isNullOrUndefined(columnVals.allowFiltering) ? null : columnVals.allowFiltering,
                        allowFilteringBlankContent: ej.isNullOrUndefined(columnVals.allowFilteringBlankContent) ? null : columnVals.allowFilteringBlankContent,
                        allowSorting: ej.isNullOrUndefined(columnVals.allowSorting) ? null : columnVals.allowSorting,
                        visible: columnVals.visible == false ? false : true,
                        width: columnVals.width ? columnVals.width : 150,
                        textAlign: columnVals.textAlign ? columnVals.textAlign : "left",
                        headerTextAlign: columnVals.headerTextAlign ? columnVals.headerTextAlign : "left",
                        clipMode: columnVals.clipMode ? columnVals.clipMode : "clip",
                        tooltip: columnVals.tooltip,
                        headerTooltip: columnVals.headerTooltip,
                        isFrozen: (columnVals.isFrozen == true || setFrozen == true) ? true : false,
                        allowFreezing: ej.isNullOrUndefined(columnVals.allowFreezing) ? null : columnVals.allowFreezing,
                        dropdownData: columnVals.dropdownData ? columnVals.dropdownData : null,
                        allowCellSelection: ej.isNullOrUndefined(columnVals.allowCellSelection) ? null : columnVals.allowCellSelection,
                        showInColumnChooser: columnVals.showInColumnChooser == false ? false : true,
                        displayAsCheckbox: columnVals.displayAsCheckbox == false ? false : true,
                        priority: columnVals.priority ? columnVals.priority : "",
                    };
                }
                args.requestType = "insertColumn";
                args.columnObject = newColumnObject;
                args.insertIndex = insertIndex;
                if (!proxy._trigger("actionComplete", args)) {
                    columns.splice(args.insertIndex, 0, args.columnObject);
                    proxy._refreshFrozenColumns();
                    proxy._updateWrapRowHeights(null,"virtualRefresh");
                    if (model.isFromGantt)
                        proxy._updateAddEditDialogTemplate();
                }
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("close");
                if (model.allowFiltering && model.filterSettings.filterType == "menu") {
                    if (args.columnObject.filterEditType)
                        filtertype = args.columnObject.filterEditType;
                    else
                        filtertype = args.columnObject.editType;
                    var isAlreadyRender = proxy._renderedFilterMenuDialog.indexOf(filtertype);
                    if (isAlreadyRender == -1) {
                        proxy._renderFilterMenu(filtertype);
                    }
                }
                if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) || model.editSettings.dialogEditorTemplateID == "")) {
                    proxy._treeGridAddEditDialog();
                } else if (this.model.editSettings.allowEditing && this.model.editSettings.editMode == "dialogEditing" && (!ej.isNullOrUndefined(model.editSettings.dialogEditorTemplateID) && model.editSettings.dialogEditorTemplateID != "")) {
                    proxy._treeGridAddEditDialogTemplate();
                }
            }
            else if (e.target.id == "ColumnAddDialog_" + proxy._id + "_Cancel") {
                $("#" + proxy._id + "_dialogColumnAdd").ejDialog("close");
            }

            if (this.model.editSettings.editMode == "dialogEditing") {
                if (e.target.id == "EditFormDialog_" + this._id + "_Save") {
                    if (!proxy.editFormValidate())
                        return true;
                    if (this.element.find(".e-dialogaddrow .e-treegridform").length > 0) {
                        if (proxy.model.allowSelection && proxy.model.selectionSettings.selectionType == "multiple" && this._multiSelectPopup && this._multiSelectPopup.is(":visible")) {
                            proxy._clearMultiSelectPopup();
                        }
                        if (proxy._treegridDialogAddRow()) {
                            proxy._isTreeAddEditDialogSave = true;
                            $("#" + this._id + "_dialogEdit").ejDialog("close");
                            this._off($("#" + this._id + "_dialogEdit"),
                            "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        }
                    } else if (this.element.find(".e-dialogeditedrow .e-treegridform").length > 0) {
                        if (!proxy.endEdit()) {
                            proxy._isTreeAddEditDialogSave = true;
                            $("#" + this._id + "_dialogEdit").ejDialog("close");
                            this._off($("#" + this._id + "_dialogEdit"),
                            "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                        }
                    }
                }
                else if (e.target.id == "EditFormDialog_" + this._id + "_Cancel") {
                    $("#" + this._id + "_dialogEdit").ejDialog("close");
                    this._off($("#" + this._id + "_dialogEdit"),
                  "click keypress", "#EditFormDialog_" + this._id + "_Save ,#EditFormDialog_" + this._id + "_Cancel", proxy._buttonClick);
                }
            }

            return false;
        },

        // Method to save the newly added record via Add dialog or Add template dialog
        _treegridDialogAddRow: function () {
            var proxy = this, columns = proxy.model.columns, newItem = {}, value, column;
            for (var i = 0; i < columns.length; i++) {
                column = columns[i];
                if (!ej.isNullOrUndefined(column) && column["field"] != "") {
                    if (column.visible && !proxy._isCommandColumn(column)) {
                        value = proxy.getCurrentEditCellDataForRowEdit(column["field"], column["editType"], i);
                        if (proxy._checkboxSelection && column["field"] == "checkboxState") {
                            continue;
                        }
                        var splits = (column["field"] || "").split(".");
                        if (splits.length <= 1) {
                            newItem[column["field"]] = value;
                        } else {
                            newItem = proxy._restoreCustomData(newItem, value, column["field"]);
                        }
                    }
                }
            }
            if (proxy._addRecord(newItem, proxy.model.editSettings.rowPosition, null, "dialog"))
                return true;
            else return false;
        },

        //REFRESH THE EDITED FORM
        _refreshColumnAddForm: function () {
            var proxy = this,
               $form = $("#" + proxy._id + "ColumnAddForm"),
               $formElement = $form.find("input,select"),
               i = 0,
               elementFocused = false,
               length = $formElement.length,
               $element, inputWidth,
               model = proxy.model,
               width,
               params = {},
               value,
               columnPpty,
               customParams,
               toformat,
               formatVal,
               tableTreeGridId,
               dropdownDataTable,
               allColFields = [],
               rowHeight = proxy.model.rowHeight,
               editTypeLocaleText = proxy._editTypeText,
               textAlignLocaleText = proxy._textAlignTypeText,
               clipModeLocaleText = proxy._clipModeText,
               cellEditType;


            for (i; i < length; i++) {

                $element = $formElement.eq(i);
                inputWidth = '100%';

                columnPpty = $element.prop("name");

                if ($element.hasClass("e-dropdownlist")) {
                    if (columnPpty == "field") {
                        var fieldData = [], reqFields = [];

                        if (model.columns.length) {
                            allColFields = $.map(model.columns, function (col) {
                                if (model.isFromGantt)
                                    return col.mappingName ? col.mappingName : col.field;
                                else
                                    return col.field;
                            });
                        }

                        //getting all the fields of datasource
                        if (!proxy._dataSourcefields.length) {
                            proxy._dataSourcefields = $.extend(true, [], allColFields);
                            proxy.getAllDataSourceFields();
                        }
                        //comaparing and taking the non column fields alone for add column dialog - fields
                        for (var k = 0; k < proxy._dataSourcefields.length; k++) {
                            if ($.inArray(proxy._dataSourcefields[k], allColFields) == -1 && proxy._dataSourcefields[k] != model.notesMapping)
                                reqFields.push(proxy._dataSourcefields[k]);
                        }

                        for (var fd = 0; fd < reqFields.length; fd++) {
                            fieldData.push({ "text": reqFields[fd] });
                        }
                        $element.ejDropDownList({
                            width: inputWidth,
                            cssClass: model.cssClass,
                            dataSource: fieldData,
                            fields: {
                                text: "text",
                                value: "text"
                            },
                        });
                    }
                    else if (columnPpty == "editType" || columnPpty == "filterEditType") {
                        var fieldData = [
                            {  "text": editTypeLocaleText['string'], "value": "stringedit" }, {  "text": editTypeLocaleText['numeric'], "value": "numericedit" },
                            {  "text": editTypeLocaleText['datePicker'], "value": "datepicker" }, {  "text": editTypeLocaleText['dateTimePicker'], "value": "datetimepicker" },
                            {  "text": editTypeLocaleText['dropdown'], "value": "dropdownedit" }, {  "text": editTypeLocaleText['boolean'], "value": "booleanedit" }
                        ];
                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: fieldData,
                            cssClass: model.cssClass,
                            fields: {
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0,
                            change: function (args) {
                                var isRefreshDialog = false;
                                if (dropdownDataTable.hidden == true && args.value == "dropdownedit") {
                                    dropdownDataTable.hidden = false;
                                    isRefreshDialog = true;
                                }
                                else if (dropdownDataTable.hidden == false && args.value != "dropdownedit") {
                                    dropdownDataTable.hidden = true;
                                    isRefreshDialog = true;
                                }

                                var checkBoxContainer = $("#" + proxy._id + "_dialogColumnAdd").find(".e-display-checkbox-conatiner");
                                if (args.value == "booleanedit" && checkBoxContainer.length > 0 && checkBoxContainer.css("display") == "none") {
                                    checkBoxContainer.css("display", "block");
                                    isRefreshDialog = true;
                                } else if (args.value != "booleanedit" && checkBoxContainer.length > 0 && checkBoxContainer.css("display") == "block") {
                                    checkBoxContainer.css("display", "none");
                                    isRefreshDialog = true;
                                }
                                if (isRefreshDialog) {
                                    $("#" + proxy._id + "_dialogColumnAdd").ejDialog("refresh");
                                }
                            }
                        });
                    }
                    else if (columnPpty == "textAlign" || columnPpty == "headerTextAlign") {
                        var fieldData1 = [
                            {  "text": textAlignLocaleText["left"], "value": "left" }, { "text": textAlignLocaleText["right"], "value": "right" },
                            {  "text": textAlignLocaleText["center"], "value": "center" }];

                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: fieldData1,
                            cssClass: model.cssClass,
                            fields: {
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0
                        });
                    } else if (columnPpty == "clipMode") {
                        var clipModeData = [
                                                    {  "text": clipModeLocaleText["clip"], "value": "clip" }, {  "text": clipModeLocaleText["ellipsis"], "value": "ellipsis" }];

                        $element.ejDropDownList({
                            width: inputWidth,
                            dataSource: clipModeData,
                            cssClass: model.cssClass,
                            fields: {
                                text: "text",
                                value: "value"
                            },
                            selectedIndex: 0
                        });
                    }
                }
                else if ($element.hasClass("e-numerictextbox")) {
                    value = $element.val();
                    params.width = inputWidth;
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    if (columnPpty == "width") {
                        params.maxValue = 250;
                        params.minValue = 30;
                        if (value.length)
                            params.value = parseFloat(value);
                        else
                            params.value = 150;
                    }
                    else if (columnPpty == "priority")
                    {
                        params.maxValue = 6;
                        params.minValue = 1;
                        if (value.length)
                            params.value = parseFloat(value);
                        else
                            params.value = null;
                    }
                    $element.ejNumericTextbox(params);
                }
                else if (columnPpty == "showInColumnChooser" || columnPpty == "allowCellSelection" || columnPpty == "allowFiltering" || columnPpty == "allowFilteringBlankContent" || columnPpty == "allowSorting" || columnPpty == "visible" || columnPpty == "isFrozen" || columnPpty == "allowFreezing" || columnPpty == "displayAsCheckbox") {

                    var controlArgs = {};
                    controlArgs.cssClass = model.cssClass;
                    controlArgs.size = "small";
                    $element.ejCheckBox(controlArgs);
                }               

                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;
                    }
                }
            }

            tableTreeGridId = "#treegrid" + proxy._id + "dropdownData";
            //Render dropdown data table for column add dialog 
            if ($(tableTreeGridId).length) {
                var ds = [];

                $(tableTreeGridId).ejTreeGrid({
                    dataSource: ds,
                    allowSorting: false,
                    allowAdding: true,
                    columns: [{ headerText: proxy._columnDialogTexts["dropdownTableText"], field: "text", editType: ej.TreeGrid.EditingType.String, width: "150px" },
                              { headerText: proxy._columnDialogTexts["dropdownTableValue"], field: "value", editType: ej.TreeGrid.EditingType.String, width: "150px" }],
                    enableAltRow: true,
                    allowColumnResize: true,
                    cssClass: model.cssClass,
                    enableResize:true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                    },
                    locale: model.locale,
                    treeColumnIndex: 5,
                    emptyRecordText: "Add values for dropdown",
                    rowSelected: function (args) {
                        if (args.data) {
                            $('.e-deletepre').addClass('e-enable').removeClass('e-disable');
                            $(".e-deletepre").bind("click", $.proxy(proxy._deleteDropDownRow, proxy, $(tableTreeGridId)));
                        }
                    },

                });
                //Hide the dropdown data table while initializing
                dropdownDataTable = $form.find("#" + proxy._id + "dropdownDataTable").parent()[0];
                dropdownDataTable.hidden = true;
                //Enable the click event for Add icon
                $(".e-addpre").bind("click", $.proxy(proxy._addDropDownRow, proxy, $(tableTreeGridId)));
            }

        },

        // Add new row for the drop down table
        _addDropDownRow: function (tableTreeGrid, e) {
            var proxy = this, args = {},
                treeGridObj = tableTreeGrid.data("ejTreeGrid"),
                treeData = treeGridObj.model.dataSource,
                dlength = treeData.length,
                item = { text: "Text " + (dlength + 1), value: "Value" + (dlength + 1) };
            treeGridObj.addRow(item, "bottom");
        },
        // delete row from the drop down table
        _deleteDropDownRow: function (tableTreeGrid, e) {
            var proxy = this, args = {},
                treeGridObj = tableTreeGrid.data("ejTreeGrid"),
                treeData = treeGridObj.model.updatedRecords,
                dlength = treeData.length,
                selectedItem = treeGridObj.model.selectedItem;
            if (dlength != 0 && selectedItem) {
                treeGridObj.deleteRow();
                $('.e-deletepre').addClass('e-disable').removeClass('e-enable');
                $(".e-deletepre").unbind("click", $.proxy(proxy._deleteDropDownRow, proxy, tableTreeGrid));
            }

        },

        //get all the fields of the dataSource
        getAllDataSourceFields: function () {
            var proxy = this, model = proxy.model,
                dataSourceCol = model.dataSource;
            for (var d = 0; d < dataSourceCol.length; d++) {
                var jsonData = dataSourceCol[d];
                for (var dsKey in jsonData) {
                    if (dsKey == model.childMapping) {
                        proxy.getChildKeys(jsonData[dsKey]);
                    }
                    else if ($.inArray(dsKey, proxy._dataSourcefields) == -1)
                        if (model.isFromGantt) {
                            if (dsKey != "undefined" && dsKey != model.notesMapping)
                                proxy._dataSourcefields.push(dsKey);
                        }
                        else {
                            if (typeof jsonData[dsKey] != "object")
                            proxy._dataSourcefields.push(dsKey);
                        }
                }
            }
        },

        //get keys of child from datasource.
        getChildKeys: function (childData) {
            var proxy = this, model = proxy.model;
            if (childData) {
                for (var c = 0; c < childData.length; c++) {
                    var chData = childData[c];
                    for (var childKey in chData)
                        if (childKey == model.childMapping) {
                            proxy.getChildKeys(chData[childKey]);
                        }
                        else if ($.inArray(childKey, proxy._dataSourcefields) == -1) {
                            if (typeof chData[childKey] != "object")
                            proxy._dataSourcefields.push(childKey);
                        }
                }
            }
        },

        //Method to render confirm dialog box while saving and cancelling and deleting
        _renderUpdateConfirmDialog: function () {
            var proxy = this,
                confDelTxt = proxy._confirmDeleteText,
                $contentDiv = ej.buildTag('div.e-content', proxy._deleteColumnText),
                $buttons = ej.buildTag('span.e-buttons', "<input class='e-confirm-dialog-btn-ok' type='button' id=" + proxy._id + 'ConfirmDialogOK' + " value=" + proxy._okButtonText + " /> "
                + "<input class='e-confirm-dialog-btn-cancel' type='button' id=" + proxy._id + 'ConfirmDialogCancel' + " value='" + proxy._cancelButtonText + "' />"),
                btnDiv = ej.buildTag('div', "", {}, { 'class': "e-confirm-dialog-btn" });
            btnDiv.append($buttons);
            proxy._updateConfirmDialog = ej.buildTag('div', '', '', { 'title': confDelTxt, 'id': proxy._id + 'ConfirmDialog' });
            proxy._updateConfirmDialog.append($contentDiv).append(btnDiv);
            proxy.element.append(proxy._updateConfirmDialog);
            $buttons.find("input").ejButton({
                cssClass: proxy.model.cssClass,
                showRoundedCorner: true,
                size: "normal",
                click: $.proxy(proxy._triggerUpdateConfirm, proxy)
            });
            proxy._updateConfirmDialog.ejDialog({ width: "auto", minHeight: 0, minWidth: 0, showOnInit: false, isResponsive: true, enableResize: false, enableModal: true, cssClass: proxy.model.cssClass });
            $("#" + proxy._id + "ConfirmDialog_wrapper").addClass("e-treegrid-dialog");
        },

        _triggerUpdateConfirm: function (args) {
            var proxy = this;
            if (args !== undefined && args.model.text == proxy._okButtonText) {
                if (proxy._updateConfirmDialog.find(".e-content").text() == proxy._deleteColumnText)
                    proxy.deleteColumn(proxy._targetColumnIndex);
            }
            proxy._updateConfirmDialog.ejDialog("close");
        },

        //Method to delete column
        deleteColumn: function (columnIndex) {
            var proxy = this, model = proxy.model, columns = model.columns, deletedColumn,
                sortedColumns = model.sortSettings && model.sortSettings.sortedColumns.length ? model.sortSettings.sortedColumns : null,
                column = columns[columnIndex], args = {};
            args.requestType="deleteColumn";
            args.columnObject = column;
            args.deleteIndex = columnIndex;
            if (!proxy._trigger("actionComplete", args)) {
                deletedColumn = columns.splice(columnIndex, 1);
                if (sortedColumns) {
                    var resultCol = $.grep(sortedColumns, function (sCol) {
                        if (model.isFromGantt)
                            return sCol.field == deletedColumn[0].mappingName;
                        else
                            return sCol.field == deletedColumn[0].field;
                    });
                    if (resultCol.length) {
                        sortedColumns.splice(sortedColumns.indexOf(resultCol[0]), 1);
                        proxy.processBindings();
                        if (model.isFromGantt) {
                            args.requestType = "sorting";
                            proxy._trigger("actionComplete", args)
                        }
                    }
                }
                if (proxy._targetColumnIndex <= model.treeColumnIndex)
                    model.treeColumnIndex = model.treeColumnIndex - 1;
                proxy._refreshFrozenColumns();
                proxy._updateWrapRowHeights(null,"virtualRefresh");
                if (model.isFromGantt)
                    proxy._updateAddEditDialogTemplate();
            }
        },

        //Get the element Left and Top position

        getOffsetRect:function(elem) {
            var box = elem.getBoundingClientRect(),
                body = document.body,
                docElem = document.documentElement,
                scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
                scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
                clientTop = docElem.clientTop || body.clientTop || 0 ,
                clientLeft = docElem.clientLeft || body.clientLeft || 0 ,
                top  = box.top +  scrollTop - clientTop ,
                left = box.left + scrollLeft- clientLeft;
            return { top: Math.round(top), left: Math.round(left) };
        },
        _moveToNextMenuItem: function (move) {

            var proxy,
              currentMenuItem,
              contextMenu, model = this.model,
              nextMenuItem = {};
            if (model.isFromGantt) {
                proxy = $("#" + this._id.replace("ejTreeGrid", "")).data("ejGantt");
                contextMenu = $("#" + this._id.replace("ejTreeGrid", "") + "_ContextMenu");
            }
            else {
                proxy = this;
                contextMenu = $("#" + this._id + "_ContextMenu");
            }
            currentMenuItem = $("#" + proxy._activeMenuItemId);

            switch (move) {
                case "next":
                    if (currentMenuItem.length == 0) {
                        nextMenuItem = contextMenu.find("div.e-menuitem:not(.e-disable)").first();
                    } else {
                        nextMenuItem = currentMenuItem.closest("li").next("li").find("div.e-menuitem");
                        if (nextMenuItem.length > 0) {
                            if (nextMenuItem.hasClass("e-disable")) {
                                nextMenuItem = this._findContextMenuItem(nextMenuItem, "next");
                            }
                        }
                    }
                    var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                    nextSubContextMenu.remove();
                    break;
                case "prev":
                    nextMenuItem = this._findContextMenuItem(currentMenuItem, "prev");
                    var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                    nextSubContextMenu.remove();
                    break;
                case "expand":
                    if (currentMenuItem.length > 0) {
                        proxy._showSubContextMenu(currentMenuItem[0], proxy._contextMenuItems);
                        var subContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                        if (subContextMenu.length > 0) {
                            nextMenuItem = subContextMenu.find("div.e-menuitem:not(.e-disable)").first();
                        }
                    }
                    break;
                case "collapse":
                    var subContextMenu = $(currentMenuItem).closest(".e-innerContextmenu");
                    if (subContextMenu.length > 0) {
                        var parentMenuId = subContextMenu.attr("id").replace(proxy._id + "_SubContextMenu", "");
                        nextMenuItem = $("#" + parentMenuId);
                        var nextSubContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                        nextSubContextMenu.remove();
                        subContextMenu.remove();
                    }
                    break;
                case "save":
                    if (currentMenuItem.length > 0) {
                        if ($("#" + proxy._activeMenuItemId).find(".e-expander").length == 0) {
                            if (!model.isFromGantt)
                                proxy.contextMenuOperations(proxy._activeMenuItemId);
                            else
                                proxy._contextMenuClickHandler($("#" + proxy._activeMenuItemId));
                            proxy._clearContextMenu();
                        } else {
                            proxy._showSubContextMenu(currentMenuItem[0], proxy._contextMenuItems);
                            var subContextMenu = $("#" + proxy._id + "_SubContextMenu" + proxy._activeMenuItemId);
                            if (subContextMenu.length > 0) {
                                nextMenuItem = subContextMenu.find("div.e-menuitem:not(.e-disable)").first();
                            }
                        }
                    }
            }

            if (nextMenuItem.length > 0) {
                if((move == "next" || move == "prev"))
                    currentMenuItem.removeClass("e-contextmenu-mouseover");
                nextMenuItem.addClass("e-contextmenu-mouseover");
                proxy._activeMenuItemId = $(nextMenuItem).attr("id");
            }
        },
        /*Get Next active columnMenu item*/
        _findNextColumnMenuItem: function (item, move) {
            var proxy = this, nextItem, prevItem;
            if (move === "next") {
                nextItem = item.closest("li").next("li").find("div.e-columnmenuitem");
                if (nextItem.length > 0) {
                    if (!nextItem.hasClass("e-disable")) {
                        return nextItem;
                    }
                    else
                        return proxy._findNextColumnMenuItem(nextItem, "next");
                }
                else
                    return nextItem;
            }
            else {
                prevItem = item.closest("li").prev("li").find("div.e-columnmenuitem");
                if (prevItem.length > 0) {
                    if (!prevItem.hasClass("e-disable")) {
                        return prevItem;
                    }
                    else
                        return proxy._findNextColumnMenuItem(prevItem, "prev");
                }
                else
                    return prevItem;
            }
        },
        // get concade field value
        _getFieldValue: function (field, columnCount) {

            if (field != "") {
                return field.split('.').join("");
            } else {
                return "TGcolumn" + columnCount;
            }

        },

        // Find the next context menu item to select
        _findContextMenuItem: function (item, move) {
            var proxy = this, nextItem, prevItem;
            if (move === "next") {
                nextItem = item.closest("li").next("li").find("div.e-menuitem");
                if (nextItem.length > 0) {
                    if (!nextItem.hasClass("e-disable")) {
                        return nextItem;
                    }
                    else
                        return proxy._findContextMenuItem(nextItem, "next");
                }
                else
                    return nextItem;
            }
            else {
                prevItem = item.closest("li").prev("li").find("div.e-menuitem");
                if (prevItem.length > 0) {
                    if (!prevItem.hasClass("e-disable")) {
                        return prevItem;
                    }
                    else
                        return proxy._findContextMenuItem(prevItem, "prev");
                }
                else
                    return prevItem;
            }
        },
        updateRecordByIndex: function (index, data) {
            var proxy = this, model = proxy.model,
                updatedRecords = model.updatedRecords, args = {},
                recordIndex = index,
                record = recordIndex > -1 ? updatedRecords.length > 0 ? updatedRecords[recordIndex] : null : null;

            if (proxy._isRowEdit)
                proxy.cancelRowEditCell();
            else if (proxy.model.isEdit)
                proxy.cancelEditCell();

            if (!ej.isNullOrUndefined(record) && !record.isSummaryRow) {
                var item = record.item,
                previousValue = $.extend(true, {}, item),
                columns = $.extend(true, {}, model.columns);
                $.each(data, function (key, value) {
                    var fieldName = key, fieldValue = value;
                    if (!ej.isNullOrUndefined(fieldName)) {
                        var isValidColumn = false;
                        $.each(columns, function (index, column) {
                            if (column.field == fieldName) {
                                isValidColumn = true;
                                delete columns[parseInt(index)];
                                return false;
                            }
                        });

                        if (isValidColumn) {
                            record = proxy._restoreCustomData(record, fieldValue, fieldName);
                            record.item = proxy._restoreCustomData(record.item, fieldValue, fieldName);
                        }
                    }
                });

            }
            else
                return false;

            var rowIndex = model.currentViewData.indexOf(record);

            if (model.enableVirtualization) {
                if (rowIndex > -1)
                    ej.TreeGrid.refreshRow(proxy, rowIndex);
            } else {
                ej.TreeGrid.refreshRow(proxy, rowIndex);
            }
            if (model.idMapping && model.parentIdMapping) {
                proxy._updateLastInsertedId(record[model.idMapping]);
            }
            args.editType = "rowedit";
            args.previousValue = previousValue;
            args.currentValue = record.item;
            args.rowIndex = recordIndex;

            if (model.showSummaryRow)
                proxy._updateSummaryRow(args);
            if (model.showTotalSummary)
                proxy._updateTotalSummaryRow(args);
        }
    });

    //ENUM FOR EACH ACTION IN TREEGRID
    ej.TreeGrid.Actions = {
        Sorting: "sorting",
        BeginEdit: "beginedit",
        Save: "save",
        Add: "add",
        Delete: "delete",
        Cancel: "cancel",
        Refresh: "refresh",
        Searching: "searching",
        ExpandCollapse: "expandcollapse",
        Selection: "selection",
        rowHover: "rowHover",
        Scroll: "scroll",
        ContextMenuAdd: "contextMenuAdd",
        RefreshDataSource: "refreshDataSource",
        DragAndDrop: "dragAndDrop",
        Paging: "paging"
    };

    //ENUM FOR SELECTION MODE IN TREEGRID
    ej.TreeGrid.SelectionType = {
        Single: "single",
        Multiple: "multiple",
        Checkbox: "checkbox"
    };

    //ENUM FOR FILTER TYPE IN TREEGRID
    ej.TreeGrid.FilterType = {
        FilterBar: "filterbar",
        Menu: "menu",
    };

    //ENUM FOR DIFFERENT EDIT MODE IN TREEGRID
    ej.TreeGrid.EditMode = {
        CellEditing: "cellEditing",
        RowEditing: "rowEditing",
        DialogEditing: "dialogEditing",
    };

    //ENUM FOR DIFFERENT WRAP MODE IN TREEGRID
    ej.TreeGrid.ClipMode = {
        Clip: "clip",
        Ellipsis: "ellipsis"
    };

    //ENUM FOR DIFFERENT PAGE MODE IN TREEGRID
    ej.TreeGrid.PageSizeMode = {
        All: "all",
        Root: "root",
    };

    ej.TreeGrid.PrintMode = {
        AllPages: "allPages",
        CurrentPage: "currentPage",
    };

    //Enum for position of new added row.
    ej.TreeGrid.RowPosition = {
        Top: "top",
        Bottom: "bottom",
        Above: "aboveSelectedRow",
        Below: "belowSelectedRow",
        Child : "child"
    }

    //Enum for Edit Action of TreeGrid.
    ej.TreeGrid.BeginEditAction = {
        DblClick: "dblClick",
        Click: "click"
    };
    /* enum for six different columnEditType for treegrid */
    ej.TreeGrid.EditingType = {
        String: "stringedit",
        Boolean: "booleanedit",
        Numeric: "numericedit",
        Dropdown: "dropdownedit",
        DatePicker: "datepicker",
        DateTimePicker: "datetimepicker",
        Maskedit : "maskedit"
    };
    /* enum for different context menu in treegrid */
    ej.TreeGrid.ContextMenuItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
    };
    //enum for column width mode
    ej.TreeGrid.ColumnResizeMode = {
        Normal: "normal",
        FixedColumns: "fixedcolumns",
        NextColumn: "nextcolumn"
    }
    //commands
    ej.TreeGrid.UnboundType = {
        /** Used to specify unbound type as Edit   */
        Edit: "edit",
        /** Used to specify unbound type as Save   */
        Save: "save",
        /** Used to specify unbound type as Delete   */
        Delete: "delete",
        /** Used to specify unbound type as Cancel   */
        Cancel: "cancel"
    };
    ej.TreeGrid = ej.TreeGrid || {};


    //INITIALIZE THE CELLEDIT ELEMENT FOR DIFFERENT TYPES OF EDITORS
    ej.TreeGrid._initCellEditType = function (instance, $element, id, columnCount, dialogId) {

        var proxy = instance,
            model = proxy.model,
            columns = model.columns,
            column = columns[columnCount],
            dialogId = dialogId ? dialogId : "", splits = (columns[columnCount].field || "").split("."), columnName;

        if (columns[columnCount]["editTemplate"])
            columns[columnCount]["editType"] = "edittemplate";
        else if (ej.isNullOrUndefined(columns[columnCount]["editType"])) {
            column["editType"] = "stringedit";
        }

        if (proxy.model.editSettings.editMode == "dialogEditing") {
            columnName = columns[columnCount].field;
        } else {
            columnName = proxy._getFieldValue(columns[columnCount].field, columnCount);
        }

        switch (column["editType"]) {

            case "stringedit":

                if (model.isFromGantt) {

                    var helpers = {};

                    if (column.field === "predecessor") {
                        helpers["_" + id + "predecessorCell"] = $.proxy(proxy._getPredecessorsValue, proxy);
                    }

                    $.views.helpers(helpers);


                    if (column.field === "predecessor") { //get the predecessor value from item of GanttRecord

                        var $input = ej.buildTag('input.e-field e-ejinputtext',
                                       "", {},
                                       {
                                           value: "{{:~_" + id + "predecessorCell(#data)}}",
                                           id: id + column.field + dialogId,
                                           name: column.field,
                                           "data-dialog": dialogId
                                       });

                    } else if (column.field === "duration") { //get the predecessor value from item of GanttRecord
                        var helpers = {};
                        helpers["_" + id + "getDurationStringValue"] = $.proxy(ej.Gantt._getDurationStringValue, proxy);
                        $.views.helpers(helpers);
                        var $input = ej.buildTag('input.e-field e-ejinputtext',
                                       "", {},
                                       {
                                           value: "{{:~_" + id + "getDurationStringValue(#data)}}",
                                           id: id + column.field + dialogId,
                                           name: column.field,
                                           "data-dialog": dialogId
                                       });

                    }
                    else { /*get the cellValue if the column does not exist in the GanttRecord object and
                           present in the item of GanttRecord*/
                        $input = ej.buildTag('input.e-field e-ejinputtext',
                                            "",
                                            {},
                                            {
                                                value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                id: id + model.columns[columnCount].field + dialogId,
                                                name: model.columns[columnCount].field,
                                                "data-dialog": dialogId
                                            });

                    }

                } else { /*Get the cellvalue of the normal gridcell*/
                    $input = ej.buildTag('input.e-field e-ejinputtext',
                                          "",
                                          {},
                                          {
                                              value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                              id: id + proxy._getFieldValue(column.field,columnCount) + dialogId,
                                              name: column.field,
                                              "data-dialog": dialogId
                                          });
                }
                $input.attr("data-edittype", columns[columnCount].editType);
                $element.html($input);
            
                break;

            case "maskedit":
                $input = ej.buildTag('input.e-field e-maskedit', "", {},
                                         {
                                             value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                             id: id + proxy._getFieldValue(column.field,columnCount) + dialogId,
                                             name: column.field,
                                             "data-dialog": dialogId
                                         });
                $input.attr("data-edittype", columns[columnCount].editType);
                $element.html($input);
                break;

            case "booleanedit":
                $element.html('{{if true===~_' + proxy._id + 'cellValue(#data,"' + columnName + '")}}' +
                         '<input type ="checkbox" ' +
                         'id="' + id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId +
                         '" data-dialog ="' + dialogId +
                         '" name="' + columns[columnCount].field +
                         '" checked="checked" data-edittype="' + columns[columnCount].editType + '"></input>' +
                         ' {{else}}' +
                         '<input' +
                         ' type ="checkbox"' +
                         ' id="' + id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId +
                         '" data-dialog ="' + dialogId +
                         '" name="' + columns[columnCount].field + '" data-edittype="' + columns[columnCount].editType + '">' +
                         '{{/if}}');

                break;

            case "numericedit":

                var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, {
                    type: "text",
                    value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                    id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                    name: columns[columnCount].field,
                    "data-dialog": dialogId
                });
                $numericText.attr("data-edittype", columns[columnCount].editType);
                $element.append($numericText);

                break;

            case "datepicker":

                var $datePicker = ej.buildTag('input.e-datepicker e-field', "",
                                             {},
                                             {
                                                 type: "text",
                                                 value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                 id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                                                 name: columns[columnCount].field,
                                                 "data-dialog": dialogId
                                             });
                $datePicker.attr("data-edittype", columns[columnCount].editType);
                $element.append($datePicker);

                break;
            case "datetimepicker":

                var $datePicker = ej.buildTag('input.e-datetimepicker e-field', "",
                                             {},
                                             {
                                                 type: "text",
                                                 value: "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}",
                                                 id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                                                 name: columns[columnCount].field,
                                                 "data-dialog": dialogId
                                             });
                $datePicker.attr("data-edittype", columns[columnCount].editType);
                $element.append($datePicker);

                break;
            case "dropdownedit":

                var $dropDownList = ej.buildTag('input.e-field e-dropdownlist',
                    "",
                    {},
                    {
                        type: "text",
                        id: id + proxy._getFieldValue(columns[columnCount].field,columnCount) + dialogId,
                        name: columns[columnCount].field,
                        "data-dialog": dialogId
                    });
                $dropDownList.attr("data-edittype", columns[columnCount].editType)
                    .attr("data-cellvalue", "{{:~_" + proxy._id + "cellValue(#data,'" + columnName + "')}}");
                $element.append($dropDownList);

                break;
            case "edittemplate":
                var temp = columns[columnCount].editTemplate.create;
                if (typeof temp == "string") {
                    var temp1 = ej.util.getObject(temp, window);
                    if (!$.isFunction(temp1)) {
                        if ($(temp).length == 1 && $(temp).get(0).tagName == "SCRIPT")
                            var $edittemplate = $($(temp).html()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                        else
                            var $edittemplate = $(temp).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                    }
                    else
                        var $edittemplate = $(temp1()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                }
                else
                    var $edittemplate = $(temp()).attr({ "id": id + proxy._getFieldValue(column.field,columnCount), "name": column.field });
                $edittemplate.attr("data-edittype", columns[columnCount].editType);
                $element.append($edittemplate);
                break;
        }
    };
    
    //Initialize tree grid toolbar item.
    ej.TreeGrid.ToolbarItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
        Update: "update",
        Cancel: "cancel",
        ExpandAll: "expandAll",
        CollapseAll: "collapseAll",
        PdfExport: "pdfExport",
        ExcelExport: "excelExport",
        Print: "print"
    };

    //Enum Values of summaryType
    ej.TreeGrid.SummaryType = {
        Sum: "sum",
        Average: "average",
        Maximum: "maximum",
        Minimum: "minimum",
        Count: "count",
        MinimumDate: "minimumDate",
        MaximumDate: "maximumDate",
        TrueCount: "trueCount",
        FalseCount: "falseCount",
    };

    //Enum Value of selectionMode.
    ej.TreeGrid.SelectionMode = {
        Row: "row",
        Cell: "cell"
    };

    ej.TreeGrid.Locale = ej.TreeGrid.Locale || {};

    ej.TreeGrid.Locale["default"] = ej.TreeGrid.Locale["en-US"] = {
        //string to be displayed in Toolbox's tooltip 
        toolboxTooltipTexts: {
            addTool: "Add",
            editTool: "Edit",
            updateTool: "Update",
            deleteTool: "Delete",
            cancelTool: "Cancel",
            expandAllTool: "Expand All",
            collapseAllTool: "Collapse All",
            pdfExportTool: "PDF Export",
            excelExportTool: "Excel Export",
            printTool: "Print"
        },
        //string to be displayed in context menu 
        contextMenuTexts: {
            addRowText: "Add Row",
            editText: "Edit",
            deleteText: "Delete",
            saveText: "Save",
            cancelText : "Cancel",
            aboveText: "Above",
            belowText: "Below"
        },
        filterMenuTexts:{
            stringMenuOptions: [{ text: "Starts With", value: "startswith" },
                    { text: "Ends With", value: "endswith" },
                    { text: "Contains", value: "contains" },
                    { text: "Equals", value: "equal" },
                    { text: "Does Not Equal", value: "notequal" }],
            numberMenuOptions: [{ text: "Less Than", value: "lessthan" },
                        { text: "Greater Than", value: "greaterthan" },
                        { text: "Less Than Or Equal To", value: "lessthanorequal" },
                        { text: "Greater Than Or Equal To", value: "greaterthanorequal" },
                        { text: "Equals", value: "equal" },
                        { text: "Does Not Equal", value: "notequal" }],
            filterValue: "Filter Value",
            filterButton: "Filter",
            clearButton: "Clear",
            enterValueText: "enter value",
        },
        //string to be displayed in column menu 
        columnMenuTexts: {
            sortAscendingText: "Sort Ascending",
            sortDescendingText: "Sort Descending",
            columnsText: "Columns",
            freezeText: "Freeze",
            unfreezeText: "Unfreeze",
            freezePrecedingColumnsText: "Freeze Preceding Columns",
            insertColumnLeft: "Insert Column Left",
            insertColumnRight: "Insert Column Right",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column",
            menuFilter: "Filter"
        },

        //string to display in column add dialog 
        columnDialogTexts: {
            field: "Field",
            headerText: "Header Text",
            editType: "Edit Type",
            filterEditType: "Filter Edit Type",
            allowFiltering: "Allow Filtering",
            allowFilteringBlankContent: "Allow Filtering Blank Content",
            allowSorting: "Allow Sorting",
            visible: "Visible",
            width: "Width",
            textAlign: "Text Alignment",
            headerTextAlign: "Header Text Alignment",
            isFrozen: "Is Frozen",
            allowFreezing: "Allow Freezing",
            columnsDropdownData: "Column Dropdown Data",
            dropdownTableText: "Text",
            dropdownTableValue: "Value",
            addData: "Add",
            deleteData: "Remove",
            allowCellSelection: "Allow Cell Selection",
            showInColumnChooser: "Show In Column Chooser",
            clipMode: "Clip Mode",
            tooltip: "Tooltip",
            headerTooltip: "Header Tooltip",
            displayAsCheckbox: "Display As Checkbox",
            priority:"Priority"
        },

        //string to be displayed in column add dialog title 
        columnDialogTitle: {
            insertColumn: "Insert Column",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        //String to be display for edittype and filter edit type.
        editTypeTexts: {
            string: "String",
            numeric: "Numeric",
            datePicker: "Date Picker",
            dateTimePicker: "Date Time Picker",
            dropdown: "Dropdown",
            boolean: "Boolean"

        },

        // String to be display for text align type.
        textAlignTypes:{
            right: "Right",
            left: "Left",
            center: "Center"
        },

        // String to be display for clip mode type.
        clipModeTexts:{
            clip: "Clip",
            ellipsis: "Ellipsis"
        },

        //Locale Text for delete confirm dialog
        deleteColumnText: "Are you sure you want to delete this column?",
        okButtonText: "OK",
        cancelButtonText: "Cancel",
        confirmDeleteText: "Confirm Delete",

        //String to be displayed in drop down list for filtering blank items
        dropDownListBlanksText: "(Blanks)",
        //String to be displayed in drop down list to clear filtered items
        dropDownListClearText: "(Clear Filter)",
        //Text to be displayed in drop down list for FALSE value in boolean edit type column
        trueText: "True",
        //Text to be displayed in drop down list for True value in boolean edit type column
        falseText: "False",
        emptyRecord: "No records to display",
    };

    //GET ROW CLASS NAME FOR EXPAND COLLAPSE ACTION
    ej.TreeGrid._getrowClassName = function () {

        var rowClass = "gridrowIndex",
            proxy = this;

        if (proxy.data.parentItem) {

            rowClass += proxy.data.parentItem.index.toString();

        }

        rowClass += "level";
        rowClass += proxy.data.level.toString();
        if (proxy.data.isSummaryRow) {
            rowClass += " ";
            rowClass += "e-summaryrow";
        }
        if (proxy.data.footerSummaryRowRecord) {
            rowClass += " ";
            rowClass += "e-footersummaryrow";
        }

        return rowClass;
    };
    ej.TreeGrid._getSummaryRowtdClassName = function () {
        var proxy = this;
        var tdClass = "";
        if (proxy.data.isSummaryRow) {
            tdClass += " ";
            tdClass += "e-summaryrowcell";
        }
        if (proxy.data.footerSummaryRowRecord) {
            tdClass += " ";
            tdClass += "e-footersummaryrowcell";
        }
        return tdClass;
    };

    //GET COLUMN BY FIELD NAME
    ej.TreeGrid.getColumnByField = function (columns, field) {

        var column = 0;

        for (column; column < columns.length; column++) {

            if (columns[column]["field"].split('.').join("") == field.split('.').join("")) break;

        }

        return column == columns.length ? null : columns[column];
    };


    ej.TreeGrid.getColumnByMappingName = function (columns, field) {
        var column = 0;
        for (column; column < columns.length; column++) {
            if (columns[column]["mappingName"] == field) break;
        }
        return column == columns.length ? null : columns[column];
    };

    //EXPAND COLLAPSE THE PARTICULAR RECORD OBJECT
    ej.TreeGrid.sendExpandCollapseRequest = function (element, args) {

        var proxy = element,
             model = proxy.model,
             toolbarItems = model.toolbarSettings.toolbarItems,
             updatedRecords;

        args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
        //To cancel the cell edit or row edit mode when expand the all record.
        if (proxy._isRowEdit) 
            proxy.cancelRowEditCell();
        else if (proxy.model.isEdit)
            proxy.cancelEditCell();

        if (model.enableVirtualization) {

            if (proxy._isFromGantt) {
                if (proxy._isLoadonDemand && !args.data.isChildRetrieved && args.expanded == true) {
                    ej.TreeGrid.expandRowsonDemand(proxy, args.data, args);
                    return;
                }
                else
                    proxy._$treegridHelper.ejTreeGrid("processBindings", args);
            }
            else if (proxy._isLoadonDemand && !args.data.isChildRetrieved && args.expanded == true) {
                ej.TreeGrid.expandRowsonDemand(proxy, args.data, args);
                return;
            }
            else {
                proxy.processBindings(args);
            }
            if (proxy._isFromGantt) {
                if (proxy._isInExpandCollapseAll === false) {
                    if (model.enableAltRow) {
                        proxy._$treegridHelper.ejTreeGrid("updateAltRow");
                    }
                    proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
                    proxy._$treegridHelper.ejTreeGrid("updateHeight");
                    proxy.model.updatedGanttRecords = proxy.getUpdatedRecords();
                    proxy.model.currentViewData = proxy.getCurrentViewData();
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedGanttRecords);
                  
                }
            }
            else {
                if (proxy._isInExpandCollapseAll === false) {
                    if (model.enableAltRow) {
                        proxy.updateAltRow();
                    }
                    proxy.sendDataRenderingRequest(args);
                    proxy._updateWrapRowHeights("total,header");
                    proxy._setScrollTop();
                    proxy.updateHeight();
                }
            }
            
        } else {
            var record = args.data,
                index,
                $row,
                height = 0,
                isModified = record.expanded !== args.expanded;
                index = proxy.model.currentViewData.indexOf(record);
            
                if (proxy._frozenColumnsLength && proxy.getRows()) {
                    $row = $(proxy.getRows()[0][index]).add(proxy.getRows()[1][index]);
                }
                else if (proxy.getRows()) {
                    $row = proxy.getRows() && $(proxy.getRows()[index]);
                }

                if (args.expanded) {
                    record.expanded = args.expanded;
                    if (proxy._isLoadonDemand && !record.isChildRetrieved) {
                        ej.TreeGrid.expandRowsonDemand(proxy, record, args);
                        return;
                    }
                    else
                        $row && ej.TreeGrid.expandRecord(proxy, record, args.expanded, args);
                    if (record.hasFilteredChildRecords) {
                        $row && $row.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
                        $row && $row.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
                    }
                    if (model.enableAltRow && proxy._isInExpandCollapseAll === false && !model.allowPaging) {
                        ej.TreeGrid.updateAltRow(proxy, record, index, 1);
                    }
                }
                else {
                    proxy._collapsedRecordCount = 0;//For update alt row
                    $row && ej.TreeGrid.collapseRecord(proxy, record, args.expanded);
                    record.expanded = args.expanded;
                    if (record.hasFilteredChildRecords) {
                        $row && $row.find(".e-treegridexpand").removeClass('e-treegridexpand').addClass('e-treegridcollapse');
                        $row && $row.removeClass('e-treegridrowexpand').addClass('e-treegridrowcollapse');
                    }
                    if (model.enableAltRow && proxy._isInExpandCollapseAll === false && proxy._collapsedRecordCount != 0 && !model.allowPaging)
                        ej.TreeGrid.updateAltRow(proxy, record, index, proxy._collapsedRecordCount);
                }

            var collapsedRecordCount= 0;
            if (proxy._isFromGantt) {
                proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", record, args.expanded);
                proxy._$treegridHelper.ejTreeGrid("updateCollapsedRecordCount");
                collapsedRecordCount =  proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            } else {
                proxy.updateExpandStatus(record, args.expanded);
                proxy.updateCollapsedRecordCount();
                collapsedRecordCount = proxy.getCollapsedRecordCount();
            }

            height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;

            if (model.allowPaging && (args.type == "ejTreeGridcollapsing" || args.type =="ejTreeGridexpanding")) {
                if (!ej.isNullOrUndefined(proxy.getPager())) {                    
                    proxy.gotoPage();
                }
                if (model.enableAltRow && proxy._isInExpandCollapseAll === false)
                    ej.TreeGrid.updateAltRow(proxy, record, index, 1);               
            }
            
            if (proxy._isFromGantt)
            {
                if (proxy._isInExpandCollapseAll === false) {
                    proxy._totalCollapseRecordCount = collapsedRecordCount;
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._$treegridHelper.ejTreeGrid("updateHeight");
                    proxy._$ganttchartHelper.ejGanttChart("updateHeight", height);
                    proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                    proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                }
                
            } else {
                if (proxy._isInExpandCollapseAll === false) {
                    if (model.allowTextWrap && proxy._$frozenTableContent.length > 0) {
                        proxy._updateWrapRowHeights("total,header");
                    } else {
                        proxy.updateHeight();
                    }
                }
            }
        }

        
        if (proxy._isFromGantt && proxy.model.predecessorMapping && proxy._isInExpandCollapseAll === false) {
            proxy._isValidationEnabled = false;
            proxy._connectorlineIds = [];
            proxy._connectorLinesCollection = [];
            proxy._createConnectorLinesCollection();
            if (element.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", element.criticalPathCollection, element.detailPredecessorCollection, true, element.collectionTaskId);
            }
        }

        if (proxy._isFromGantt) {
            var treeGrid = proxy._$treegridHelper.ejTreeGrid("instance");
            var chart = proxy._$ganttchartHelper.ejGanttChart("instance");
            var top = treeGrid._$gridContent.ejScroller("option", "scrollTop");
            chart._$bodyContainer.ejScroller("option", "scrollTop", top);
            var isHorizontalScroll = treeGrid.getScrollElement().ejScroller("isHScroll");
            if (!isHorizontalScroll)
                treeGrid.getScrollElement().scrollTop(top);
        }
       
        var argstemp = {};
        argstemp.recordIndex = args.recordIndex;
        argstemp.data = args.data;
        argstemp.requestType = args.requestType;
        argstemp.expanded = args.expanded;
        if (!ej.isNullOrUndefined(argstemp.data.item[model.expandStateMapping])) {
            argstemp.data[model.expandStateMapping] = args.expanded;
            argstemp.data.item[model.expandStateMapping] = args.expanded;
        }
        if (args.expanded) {
            proxy._trigger("expanded", argstemp);
        } else {
            proxy._trigger("collapsed", argstemp);
        }

        var selectItem = proxy.selectedItem();
        if (!proxy._isFromGantt && selectItem && (model.selectedItems.length == 1 || proxy._checkboxSelection)) {
            var expanded = proxy.getExpandStatus(selectItem);
            if (!expanded && !args.expanded) {
                proxy.selectRows(-1);
                proxy.selectedRowIndex(-1);
                selectItem.isSelected = false;
                model.selectedItem = null;
                selectItem = null;
            }
            if (model.allowPaging)
                updatedRecords = proxy._updatedPageData;
            else
                updatedRecords = proxy.model.updatedRecords;
            if (model.enableVirtualization && selectItem && updatedRecords.indexOf(selectItem) !== proxy.selectedRowIndex())
                proxy.selectRows(updatedRecords.indexOf(selectItem));
            proxy._cancelSaveTools();
        }
    };

    ej.TreeGrid.expandRowsonDemand = function (controlObject, parent, expcolargs) {
        var proxy = controlObject, model = proxy.model,         
            queryChildRecords = ej.Query().select(proxy._fieldNamesToQuery),
            flatRecords = model.flatRecords, updatedRecords = model.updatedRecords, args = {};
        if (proxy._isFromGantt) {
            var condition = ej.Predicate(model.parentTaskIdMapping, ej.FilterOperators.equal, parent.item[model.taskIdMapping]),
                idMapping = model.taskIdMapping, parentMapping = model.parentTaskIdMapping;
        }
        else {
            var condition = ej.Predicate(model.parentIdMapping, ej.FilterOperators.equal, parent.item[model.idMapping]),
                idMapping = model.idMapping, parentMapping = model.parentIdMapping;
        }

        if (parent.isChildRetrieved) {
            parent.expanded = true;
            ej.TreeGrid.sendExpandCollapseRequest(proxy, expcolargs);
            return true;
        }
        if (proxy._trigger("actionBegin", expcolargs))
            return true;

        queryChildRecords.where(condition);
        proxy._waitingPopupObj.show();
        queryChildRecords.requiresCount();
        var queryPromise = proxy.dataSource().executeQuery(queryChildRecords);
        queryPromise.done(ej.proxy(function (e) {
            var queriedChildItems = e.result, length = queriedChildItems.length, recordCollection = [], idCollection = [], jsonData = [],
                flatRecordIndex = flatRecords.indexOf(parent), childLength = parent.childRecords && parent.childRecords.length;
            //if (model.isFromGantt)
            //    var ganttObject = $("#" + proxy._id.replace("ejTreeGrid", "")).data("ejGantt");
            for (var index = 0; index < length; index++) {
                if (proxy._isFromGantt) {
                    var expandedChildRecord = proxy._createGanttRecord(queriedChildItems[index], parent.level + 1, parent);
                    if (model.enableWBS) {
                        var parentWBS = parent.WBS;
                        expandedChildRecord["WBS"] = parentWBS + "." + (index + 1);
                    }
                }
                else
                    var expandedChildRecord = proxy._createRecord(queriedChildItems[index], parent.level + 1, parent);
                expandedChildRecord.index = flatRecords.length + recordCollection.length;
                parent.childRecords.push(expandedChildRecord);

                //Update Child Record Info of Queried Child Items.
                if (expandedChildRecord.item[model.hasChildMapping] || proxy._assignedParendIDs.indexOf(expandedChildRecord.item[idMapping]) != -1) {
                    expandedChildRecord.hasChildRecords = true;
                    expandedChildRecord.childRecords = [];
                    expandedChildRecord.isChildRetrieved = false;
                    proxy._allParentItems.push(expandedChildRecord);
                    if (proxy._isFromGantt) {
                        expandedChildRecord.manualStartDate = expandedChildRecord.startDate;
                        expandedChildRecord.manualEndDate = expandedChildRecord.endDate;
                        expandedChildRecord.manualDuration = expandedChildRecord.duration;
                        if(!expandedChildRecord.isAutoSchedule)
                            proxy._updateManualParentItem(expandedChildRecord, null, true);
                    }
                }

                if (expandedChildRecord.item[idMapping])
                    idCollection.push(expandedChildRecord.item[idMapping]);

                recordCollection.push(expandedChildRecord);

                jsonData.push(queriedChildItems[index]);
            }

            //update Task Id Collection.
            proxy._taskIds.splice.apply(proxy._taskIds, [flatRecordIndex + 1, 0].concat(idCollection));
            //update gantt model Id Collection
            if (proxy._isFromGantt)
                model.ids.splice.apply(model.ids, [flatRecordIndex + 1, 0].concat(idCollection.toString().split(",")));
            //Update Record Collections
            flatRecords.splice.apply(flatRecords, [flatRecordIndex + 1, 0].concat(recordCollection));
            //updateJson Data
            if (proxy._isDataManagerUpdate)
                proxy._jsonData.splice.apply(proxy._jsonData, [flatRecordIndex + 1, 0].concat(jsonData));

            parent.isChildRetrieved = true;
            parent.expanded = true;
            var exargs = {
                recordIndex: flatRecordIndex,
                data: parent,
                requestType: "expandcollapse",
                expanded: true
            };
            if (expcolargs && (expcolargs.isExpandingParticularLevelParent || proxy._isInExpandCollapseAll)) {
                ej.TreeGrid.expandMultipleRecordsonDemand(proxy, parent, expcolargs, exargs);
            }
            else {
                proxy._renderExpandedChildRecords(expcolargs);
                proxy._trigger("expanded", exargs);
            }

        })).fail(ej.proxy(function (e) { proxy._triggerFailureEvent(e, proxy); }));          
    };

    ej.TreeGrid.expandMultipleRecordsonDemand = function (controlObject, parent, expcolargs, exargs) {
        var proxy = controlObject;
        if (expcolargs.isExpandingParticularLevelParent) {
            var collapsedParentItems = proxy._allParentItems.filter(function (record) {
                if (record.level == expcolargs.recordLevel && !record.expanded && record.hasChildRecords)
                    return record;
            });

            //Expand, if higher level parent is in collapsed state.
            var targetParentItem = parent.parentItem;
            for (var level = 0; level < expcolargs.recordLevel; level++) {
                if (targetParentItem && targetParentItem.isChildRetrieved)
                    targetParentItem.expanded = true;
                targetParentItem = targetParentItem && targetParentItem.parentItem;
            }
        }
        if (proxy._isInExpandCollapseAll) {
            var collapsedParentItems = proxy._allParentItems.filter(function (record) {
                if (!record.expanded && record.hasChildRecords)
                    return record;
            });
        }
        for (var targetItem = 0; targetItem < collapsedParentItems.length; targetItem++) {
            var exponDemand = {};
            exponDemand.data = collapsedParentItems[targetItem];
            exponDemand.recordIndex = proxy.model.updatedRecords.indexOf(collapsedParentItems[targetItem]);
            exponDemand.expanded = true;
            if (expcolargs.isExpandingParticularLevelParent) {
                exponDemand.recordLevel = expcolargs.recordLevel;
                exponDemand.isExpandingParticularLevelParent = true;
            }
            exponDemand.requestType = ej.TreeGrid.Actions.ExpandCollapse;
            var isExpanded = ej.TreeGrid.expandRowsonDemand(proxy, collapsedParentItems[targetItem], exponDemand);
            if (isExpanded) {
                proxy._allParentItems.splice(proxy._allParentItems.indexOf(collapsedParentItems[targetItem]), 1);                   
                collapsedParentItems.splice(collapsedParentItems.indexOf(collapsedParentItems[targetItem]), 1);
                if (collapsedParentItems.length > 0)
                    targetItem = -1;
            }
            else
                break;
        }
        if (collapsedParentItems.length == 0) {
            proxy._isInExpandCollapseAll = false;
            proxy._renderExpandedChildRecords(expcolargs);
            proxy._trigger("expanded", exargs);
        }
    },    

    //EXPAND THE RECORD
    ej.TreeGrid.expandRecord = function (controlObject, Record, expanded, args) {
  
        var proxy = controlObject,
            rowClassName = ".gridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            detailsRowClassName = ".detailsrowgridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            $rows = $(proxy.element).find(rowClassName),
            count = 0,
            length = $rows.length,
            row,
            index,
            record,
            model = proxy.model,
            $detailRows = $(proxy.element).find(detailsRowClassName),
            $expandedRows = $(proxy.element).find(rowClassName),
            index,
            $gridRows = proxy.getRows(),
            $row = $($gridRows[index]);

            index = model.currentViewData.indexOf(Record);

        if (Record.hasChildRecords && Record.childRecords.length > 0) {
            $row.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
            $row.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
        }
        proxy._expandedRecordsCount += (proxy._isFromGantt || proxy._frozenColumnsLength > 0) ? $expandedRows.length / 2 : $expandedRows.length;
        $expandedRows.css({ 'display': 'table-row' });
        $detailRows.filter("tr.e-detailsrowexpanded").css('display', 'table-row');
        if (proxy._isFromGantt || proxy._frozenColumnsLength > 0) {
            length = length / 2;
        }

        for (count; count < length; count++) {
            row = $rows[count];
            index = -1;
            if (proxy._frozenColumnsLength > 0)
                index = $(proxy.getRows()[0]).index(row);
            else
                index = proxy.getRows().index(row);

            if (index !== -1) {
                record = proxy._isFromGantt ? proxy.model.updatedRecords[index] : proxy.model.updatedRecords[index];
                record.isExpanded = true;
                if (record.expanded)
                    ej.TreeGrid.expandRecord(proxy,record, expanded);
            }
        }
    },
    
    //COLLAPSE THE RECORD
    ej.TreeGrid.collapseRecord = function (controlObject, Record, expanded) {

        var proxy = controlObject,
            model = proxy.model,
            rowClassName = ".gridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            detailsRowClassName = ".detailsrowgridrowIndex" + Record.index.toString() + "level" + (Record.level + 1).toString(),
            $rows = $(proxy.element).find(rowClassName),
            count = 0,
            length = $rows.length,
            row,
            index,
            record,
            $detailRows = $(proxy.element).find(detailsRowClassName),
            $collapsedRows = $(proxy.element).find(rowClassName),
        $gridRows = proxy.getRows();

        proxy._collapsedRecordCount += (proxy._isFromGantt || proxy._frozenColumnsLength > 0) ? $collapsedRows.length / 2 : $collapsedRows.length;
        $collapsedRows.css({ 'display': 'none' });
        $detailRows.css({ 'display': 'none' });

        if (proxy._isFromGantt || proxy._frozenColumnsLength > 0) {
            length = length / 2;
        }

        for (count; count < length; count++) {

            row = $rows[count];
            index = -1;
            if (proxy._frozenColumnsLength > 0)
                index = $(proxy.getRows()[0]).index(row);
            else
                index = proxy.getRows().index(row);


            if (index !== -1) {
                record = proxy.getUpdatedRecords()[index];

                if (record.expanded)
                    ej.TreeGrid.collapseRecord(proxy,record, expanded);
            }
        }
    },

    //UPDATE THE ALT ROW FUNCTION
    ej.TreeGrid.updateAltRow = function (controlObject, Record, recordIndex, offset) {

        var proxy = controlObject,
            count = 0,
            model = proxy.model,
            currentViewData = model.currentViewData,
            length = currentViewData.length,
            isAltRow = Record.isAltRow,
            record,
            $gridRows,
            $gridAllRows = proxy.getRows();

        if (proxy._frozenColumnsLength)
            $gridRows = proxy.getRows()[0];
        else
            $gridRows = proxy.getRows();

        /* for rowTemplate no need set alt row class*/
        if (model.rowTemplateID || model.altRowTemplateID)
            return;

        for (count = recordIndex + offset; count < length; count++) {

            if ($($gridRows[count]).hasClass("e-summaryrow"))
                continue;

            if ($($gridRows[count]).css('display') === "none")
                continue;

            record = currentViewData[count];
            if(count!=0)
            record.isAltRow = !isAltRow;
            isAltRow = record.isAltRow;
            var currentRow = {};
            if (proxy._frozenColumnsLength) {
                currentRow = $($gridAllRows[0][count]).add($gridAllRows[1][count]);
            }
            else
                currentRow = $($gridAllRows[count])
            if (isAltRow) {
                $(currentRow).addClass('e-alt-row');
            }
            else {
                $(currentRow).removeClass('e-alt-row');
            }
        }
    };

    //RERENDERED THE EDITED RECORD
    ej.TreeGrid.refreshRow = function (controlObject, index) {
        var proxy = controlObject,
            model = proxy.model,
            data = proxy.model.currentViewData[index], eventArgs = {},
            currentRefreshingRow, currentFrozenRow;
        if (data) {
            if (proxy._frozenColumnsLength > 0) {
                currentFrozenRow = $(proxy.getRows()[0][index]);
                currentRefreshingRow = $(proxy.getRows()[1][index]);
                if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                    var detailsRow = currentFrozenRow.next("tr");
                    if (detailsRow.hasClass("e-detailsrow")) {
                        detailsRow.remove();
                        currentRefreshingRow.next("tr").remove();
                    }
                }
                currentFrozenRow.replaceWith($($.render[proxy._id + "_JSONFrozenTemplate"](data)));
                currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
            } else {
                currentRefreshingRow = $(proxy.getRows()[index]);
                if (model.showDetailsRow && model.detailsTemplate && data.isDetailsExpanded) {
                    var detailsRow = currentRefreshingRow.next("tr");
                    if (detailsRow.hasClass("e-detailsrow"))
                        detailsRow.remove();
            }
            if (!model.allowSelection)
                data.isSelected = false;
            currentRefreshingRow.replaceWith($($.render[proxy._id + "_Template"](data)));
            }
            proxy.setGridRows($(proxy.getContentTable().get(0).rows));

            proxy._gridRows = proxy.getContentTable().get(0).rows;
            if (proxy._frozenColumnsLength > 0)
                proxy._gridRows = [proxy._gridRows, proxy.getContentTable().get(1).rows];

            var rowElement = ej.TreeGrid.getRowByIndex(proxy, proxy.getUpdatedRecords().indexOf(model.currentViewData[index]));
            proxy._trigger("refresh");
            proxy._rowEventTrigger(rowElement, data);
        }
    };

    //Return corressponding treegrid rows jquery object
    ej.TreeGrid.getRowByIndex = function (controlObject, from, to) {

        try {
            var proxy;
            if (controlObject.pluginName == "ejTreeGrid")
                proxy = controlObject;
            else
                proxy = controlObject._$treegridHelper.data("ejTreeGrid");

            var $gridRows = proxy.getRows(),
                model = proxy.model,
                updatedRecords = proxy.getUpdatedRecords(),
               // gridRows=proxy._gridRows,
                $row = $();

            if (proxy.model.enableVirtualization) {
                var recordstart = updatedRecords[from];
                from = proxy.model.currentViewData.indexOf(recordstart);
            }

            if (ej.isNullOrUndefined(to)) {
                if (proxy._frozenColumnsLength > 0) {
                    if ($gridRows[0][from]) {
                        $row.push($gridRows[0][from]);
                        $row.push($gridRows[1][from]);
                    }
                    return $row;
                }
                return $($gridRows[from]);
            } else {
                if (proxy.model.enableVirtualization) {
                    var recordend = updatedRecords[to];
                    to = proxy.model.currentViewData.indexOf(recordend);
                }
                if (proxy._frozenColumnsLength > 0) {
                    $row.push($($gridRows[0]).slice(from, to));
                    $row.push($($gridRows[1]).slice(from, to));
                    return $row;
                }
                return $($gridRows.slice(from, to));
            }
        } catch (e) {
            return $();
        }
    }

})(jQuery, Syncfusion);;;;
(function ($, ej, undefined) {
    // ejGanttChart is the plugin name 
    // "ej.GanttChart" is "namespace.className" will hold functions and properties
    'use strict';
    ej.widget("ejGanttChart", "ej.GanttChart", {
        // widget element will be automatically set in this
        element: null,

        // user defined model will be automatically set in this
        model: null,
        _rootCSS: "e-ganttchart",

        /* keyConfigurations for keyboard interaction in treegrid */
        keyConfigs: {
            focus: "e",

            //Insert
            insertRecord: "45",

            // delete
            deleteRecord: "46",

            //F2
            editRecord: "113",

            // Enter
            saveRequest: "13",

            //Esc   
            cancelRequest: "27",

            //Home,
            firstRowSelection: "36",

            //End,
            lastRowSelection: "35",

            //Left arrow
            leftArrow: "37",

            //Right arrow
            rightArrow: "39",

            //Up arrow
            upArrow: "38",

            //Down arrow
            downArrow: "40",

            //tab
            moveCellRight: "9",

            //shifttab
            moveCellLeft: "shift+9",

            //AltPlusDownArrow
            selectedRowExpand: "alt+40",

            //CtrlPlusDownArrow
            totalRowExpand: "ctrl+40",

            //AltPlusUpArrow
            selectedRowCollapse: "alt+38",

            //CtrlPlusUpArrow
            totalRowCollapse: "ctrl+38"
        },

        //default model
        defaults: {
            childPropertyName: "",
            taskIdMapping: "",
            taskNameMapping: "",
            startDateMapping: "",
            endDateMapping: "",
            childMapping: "",
            finishDateMapping: "",
            durationMapping: "",
            milestoneMapping: "",
            progressMapping: "",
            predecessorMapping: "",
            resourceInfoMapping: "",
            resourceNameMapping: "",
            resourceCollection: [], /*--------------Array containing the resource names */

            holidays: [
                {
                    day: null,
                    label: null,
                    background: null
                }
            ],

            stripLines: [
                {
                    day: null,
                    label: null,
                    lineStyle: "dotted",
                    lineColor: "#169dd7",
                    lineWidth: 2
                }
            ],

            enableTaskbarTooltip: true, /*------------showing tooltip on taskbar mouse over */
            enableTaskbarDragTooltip: true, /*--------showing taskbar while dragging taskbar */

            highlightWeekends: true, /*-------------Boolean value for highlighting weekends */

            scheduleStartDate: null, /*-------------start date of entire project */
            scheduleEndDate: null, /*---------------end date of entire project */

            enableProgressBarResizing: true, /*----------Boolean value for resizing progress bar */

            rowHeight: 30,
            progressbarHeight: 100,
            connectorlineWidth: 1,
            dateFormat: "MM/dd/yyyy",
            locale: "en-US",

            //background style
            taskbarBackground: "#DE8080", //"#5AC1E0",
            progressbarBackground: "#C44647", //"#169DD7",
            weekendBackground: '#F2F2F2',
            connectorLineBackground: "#383838",
            parentTaskbarBackground: "#383838",
            parentProgressbarBackground: "#1C1C1C",

            selectedItem: null,
            selectedRowIndex: -1,
            perDayWidth: null,

            perMonthWidth: null,//year-month schedule mode
            perWeekWidth: null,//month-week schedule mode
            perHourWidth:null,
            queryTaskbarInfo: null,

            taskbarTemplate: "",
            progressbarTemplate: null,
            parenttaskbarTemplate: "",
            parentprogressbarTemplate: null,
            milestoneTemplate:"",

            //internal collections
            flatRecords: [],
            updatedRecords: [],
            ids: [],
            currentViewData: [],

            scheduleWeeks: [],

            scheduleYears: [],
            scheduleMonths: [], //new property for month schedule
            scheduleDays:[],
            scheduleHours:[],
            projectStartDate: null, //new property instead of scheduleWeeks[0] and scheduleYears[0]
            projectEndDate: null,

           

            //tooltip templates
            tooltipTemplate: "",
            tooltipTemplateId:"",
            progressbarTooltipTemplateId: "",
            taskbarEditingTooltipTemplateId: "",

            taskbarEditingTooltipTemplate: "",
            progressbarTooltipTemplate: "",

            //boolean values
            showTaskNames: true,
            leftTaskLabelMapping: "",
            rightTaskLabelMapping: "",
            LeftTaskLabelTemplate: "",
            rightTaskLabelTemplate: "",
            showProgressStatus: true,
            showResourceNames: true,
            includeWeekend: false,
            allowZooming: false,
            readOnly:false,
            allowGanttChartEditing: true,
            allowKeyboardNavigation: true,

            //baselines
            renderBaseline: false,
            baselineColor: '#fba41c ',

            /* editing API's */
            editSettings: {
                allowEditing: false,
                allowAdding: false,
                allowDeleting: false,
                editMode: "normal",
                dialogEditorTemplateId: null
            },

            scheduleHeaderSettings:
            {
                weekHeaderFormat: "MMM dd , yyyy",//for week - Day schedule mode
                dayHeaderFormat: "",
                weekendBackground: '#F2F2F2',

                yearHeaderFormat: "yyyy",
                monthHeaderFormat: "MMM",

                hourHeaderFormat: "HH",
                minuteHeaderFormat:"mm",
                scheduleHeaderType: "week",
                weekStartDay: 0
            },
            workingTimeScale: "TimeScale8Hours",
            roundOffDayworkingTime: true,
            durationUnit: "day",

            localizedDays: null,
            localizedMonths: null,
            //localized string to be displayed in toolTip
            columnHeaderTexts: null,
            predecessorEditingTexts: null,
            enablePredecessorEditing: true,
            taskbarClick: null
        },

        updateHighlightWeekends: function (boolValue) {
            var proxy = this;
            proxy.model.highlightWeekends = boolValue;

            if (proxy.model.highlightWeekends == true)
                proxy._renderWeekends();
            else
                proxy._$weekendsContainer.remove();
        },

        updateWeekendBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.weekendBackground = bgcolor;
            proxy._$weekendsContainer.remove();
            proxy._renderWeekends();
        },

        showTooltip: function (boolValue) {
            var proxy = this;
            proxy.model.enableTaskbarTooltip = boolValue;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        showEditingTooltip: function (boolValue) {
            var proxy = this;
            proxy.model.enableTaskbarDragTooltip = boolValue;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateConnectorLineBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.connectorLineBackground = bgcolor;
            proxy._createConnectorLineTemplate();
        },

        updateConnectorlineWidth: function (lineWidth) {
            var proxy = this;
            proxy.model.connectorlineWidth = parseInt(lineWidth);
            proxy._createConnectorLineTemplate();
        },
        updateEditedRecordEndDate: function (endDate) {
            var proxy = this;
            proxy._currentEditedRecord.endDate = endDate;
        },

        updateEditedRecordDuration: function (duration) {
            var proxy = this;
            proxy._currentEditedRecord.duration = duration;
        },

        updateTaskbarBackground: function (bgcolor) {
            var proxy = this;
            proxy.model.taskbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateProgressbarBackground: function (bgcolor) {
            this.model.progressbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateParentTaskbarBackground: function (bgcolor) {
            this.model.parentTaskbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateParentProgressbarBackground: function (bgcolor) {
            this.model.parentProgressbarBackground = bgcolor;
            this._createTaskbarTemplate();
            this._refresh();
        },

        updateRenderTaskNames: function (bool) {
            var proxy = this;
            proxy.model.showTaskNames = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        refreshLeftTaskLabelMapping: function (leftLabel) {
            var proxy = this;
            proxy.model.leftTaskLabelMapping = leftLabel;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshRightTaskLabelMapping: function (rightLabel) {
            var proxy = this;
            proxy.model.rightTaskLabelMapping = rightLabel;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshLeftTaskLabelTemplate: function (leftLabeltemplate) {
            var proxy = this;
            proxy.model.leftTaskLabelTemplate = leftLabeltemplate;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        refreshRightTaskLabelTemplate: function (rightLabeltemplate) {
            var proxy = this;
            proxy.model.rightTaskLabelTemplate = rightLabeltemplate;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },
        updateRendeProgressStatus: function (bool) {
            var proxy = this;
            proxy.model.showProgressStatus = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateRenderResourceNames: function (bool) {
            var proxy = this;
            proxy.model.showResourceNames = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeMilestoneTemplate : function(value)
        {
            var proxy = this;
            proxy.model.milestoneTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.taskbarTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        changeParentTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.parentTaskbarTemplate = value;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        ganttChartEditing: function (boolValue) {
            var proxy = this;
            proxy.model.allowGanttChartEditing = boolValue;
        },
        updateReadOnly: function (boolValue) {
            var proxy = this;
            proxy.model.readOnly = boolValue;
        },
        resizeProgressbar: function (boolValue) {
            var proxy = this;
            proxy.model.enableProgressBarResizing = boolValue;

        },
        /* udpate value of allowKeyboardNavigation API from Gantt */
        updateAllowKeyboardNavigation: function (bool) {
            this.model.allowKeyboardNavigation = bool;
        },

        updateProgressbarHeight: function (height) {
            var proxy = this;
            this.model.progressbarHeight = height;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateBaselineColor: function (color) {
            var proxy = this;
            this.model.baselineColor = color;
            proxy._createTaskbarTemplate();
            proxy._refresh();
        },

        updateRenderBaseline: function (bool) {
            var proxy = this;
            this.model.renderBaseline = bool;
            proxy._createTaskbarTemplate();
            proxy._refresh();
            proxy._createConnectorLineTemplate();
        },

        focusGanttElement: function () {
            if (ej.browserInfo().name == "msie") {
                try { this.element[0].setActive(); } catch (e) { }
            }
            else
                this.element[0].focus();
        },
        
        //returns the schedule year width
        _getYearWidth: function () {
            var proxy = this,count=0,width=0;
            for (count = 0; count < this.model.scheduleYears.length; count++) {
                width += this._getTemplateYearWidth(this.model.scheduleYears[count]);
            }
            return (width);
        },

        //returns the schedule month width
        _getMonthWidth: function () {
            var proxy = this,
                model = proxy.model,
                date, scheduleMonths = model.scheduleMonths,
                    monthWidth = 0;

            for (var i = 0; i < scheduleMonths.length; i++) {
                var startDate = scheduleMonths[i];

                if (typeof startDate === "object") {
                    date = new Date(startDate);
                }
                else {
                    date = ej.parseDate(startDate, this.model.dateFormat, this.model.locale);
                }
                var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

                var lastDate = monthLastDay.getDate();
                // condition to check if the first month having only few weeks.
                if (date.getTime() === proxy.model.scheduleMonths[0].getTime()) {
                    var datediff = monthLastDay.getDate() - date.getDate();
                    monthWidth += (this.model.perDayWidth * (datediff+1));
                }
                else if (lastDate == 31)
                    monthWidth += (this.model.perDayWidth * 31);
                else if (lastDate == 30)
                    monthWidth += (this.model.perDayWidth * 30);
                else if (lastDate == 28)
                    monthWidth += (this.model.perDayWidth * 28);
            }
            return monthWidth;
        },



        //returns the schedule week width
        _getWeekWidth: function () {
            return (this.model.perDayWidth * 7);
        },

        _getNumberOftWeeks: function (startdate, enddate) {


            //var date1 = new Date(startdate), date2 = new Date(enddate);
            //// The number of milliseconds in one week
            //var ONE_WEEK = 1000 * 60 * 60 * 24 * 7;
            //// Convert both dates to milliseconds
            //var date1_ms = date1.getTime();
            //var date2_ms = date2.getTime();
            //// Calculate the difference in milliseconds
            //var difference_ms = Math.abs(date1_ms - date2_ms);
            //// Convert back to weeks and return hole weeks
            //return Math.floor(difference_ms / ONE_WEEK);
            var startDate = new Date(startdate),
                endDate = new Date(enddate);

            var totalWeeksCollection = [];
            do {
                totalWeeksCollection.push(new Date(startDate));
                startDate.setDate(startDate.getDate() + 7);
            } while (!(startDate > endDate));

            return totalWeeksCollection;
        },

        //returns the ganttchart container height
        _getHeight: function () {
            return this._containerHeight;
        },

        //sets the height of the ganttchart container
        _setHeight: function (value) {
            this._containerHeight = value;
        },

        //returns the rows in the ganttchart
        getGanttChartRows: function () {
            return this._ganttChartRows;
        },

        //returns the gantt record collection
        getUpdatedRecords: function () {
            return this.model.flatRecords;
        },

        //sets value for currentviewdata , ganttrecords and row collections
        setUpdatedRecords: function (currentViewData, updatedRecords, flatRecords,ids) {
            var proxy = this;
            proxy.model.currentViewData = currentViewData;
            proxy.model.updatedRecords = updatedRecords;
            proxy.model.flatRecords = flatRecords;
            proxy.model.ids = ids;
        },

        //returns the string date type 
        _getFormatedDate: function (date, format, locale) {
            return ej.format(date, format, locale);
        },

        //returns the viewport height
        _getViewportHeight: function () {
            var proxy = this,
                headerdiv = proxy._$headerContainer,
                height;

            height = proxy.element.height() - headerdiv.height() -
                    parseFloat(headerdiv.css("border-bottom-width"));
            return height;
        },

        updateViewPortHeight:function(){
            var proxy = this;
            proxy._viewportHeight=proxy._getViewportHeight();
        },

        //constructor function
        _init: function () {

            var proxy = this, model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;

            proxy.element.addClass("e-ganttchart-core");
            proxy.element.attr("tabindex", "0");
            model.cssClass && proxy.element.addClass(model.cssClass);
            proxy._initPrivateProperties();
            proxy._initialize();
            proxy._getNonWorkingDayIndex();
            proxy._renderGanttChart();
            proxy._$bodyContainerParent.append(proxy._$bodyContainer);
            proxy._$bodyContainer.append(proxy._$bodyContent);
            proxy._$ganttChartContainer.append(proxy._$bodyContainerParent);

            $(proxy._$bodyContainer).css({ "height": proxy._viewportHeight + "px" });
            if (proxy.model.enableVirtualization)
                $(proxy._$bodyContent).css({ "height": (model.rowHeight * model.updatedRecords.length) + "px" });

            if (scheduleMode == "week") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleWeeks.length * proxy._scheduleWeekWidth) + "px" });
            }
            else if (scheduleMode == "year") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleYearWidth) + "px" });

            }
            else if (scheduleMode == "month") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleMonthWidth) + "px" });
            }
            else if (scheduleMode == "day") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleDays.length * (model.perHourWidth * 24)) + "px" });
            }
            else if (scheduleMode == "hour") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval)) + "px" });
            }
            proxy.createGridLinesTable();
            proxy.renderGanttRecords();
          //  Inner div for scroller
            var scrollerDiv = ej.buildTag('div');
            scrollerDiv.append(proxy._$bodyContent);
            proxy._$bodyContainer.append(scrollerDiv);
            proxy._$bodyContainer.ejScroller({
                width: proxy.element.width() - 1,// additional parent div element added with 1px right border
                enableTouchScroll:false,
                height: proxy._getViewportHeight(), scroll: function (args) {

                    var arg = {},
                        scrollTop = args.scrollTop;

                    args.requestType = "scroll";
                    args.delta = scrollTop;
//                    proxy._completeAction(args);
                    if (scrollTop != undefined) {// && this.isVScroll()
                        if (proxy.onScrollHelper(scrollTop, true) === false) {
                           args.cancel = true;
                        }
                    } else {
                        proxy._handleScroll(args);
                    }
                    
                }
            });
            proxy._$bodyContainer.ejScroller("model.keyConfigs", { up: "", down: "", left: "", right: "" });
            proxy._$bodyContainer.ejScroller("refresh");
            //check if Hscroller is render or not
            var isHorizontalScroll = proxy._$bodyContainer.ejScroller("isHScroll");
                if (!isHorizontalScroll) {
                    proxy._$bodyContainer.find("div.e-content").addClass("e-borderbox");
                }
                else {
                    proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
                }
            proxy._wireEvents();


        },

        //rendering gantt chart again after zoomingvalue changed
        reRenderGanttChart: function (daywidth, flatRecords) {

            var proxy = this, model = proxy.model,
                   scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;

            proxy._wireEvents();
            model.perDayWidth = daywidth;

            // proxy.model.perMonthWidth = monthwidth;

            model.flatRecords = flatRecords;
            proxy._scheduleWeekWidth = proxy._getWeekWidth();
            proxy._scheduleYearWidth = proxy._getYearWidth();
            proxy._scheduleMonthWidth = proxy._getMonthWidth();

            $(proxy._$headerContainer).empty();
            $(proxy._$scheduleDiv).empty();
            proxy._renderGanttChart();
            proxy._$bodyContainerParent.append(proxy._$bodyContainer);
            proxy._$bodyContainer.append(proxy._$bodyContent);
            proxy._$ganttChartContainer.append(proxy._$bodyContainerParent);

            if (scheduleMode == "week") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleWeeks.length * proxy._scheduleWeekWidth) + "px" });
            }
            else if (scheduleMode == "year") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleYearWidth) + "px" });
            }
            else if (scheduleMode == "month") {
                $(proxy._$bodyContent).css({ "width": (proxy._scheduleMonthWidth) + "px" });
            } 
            else if (scheduleMode == "day") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleDays.length * (model.perHourWidth * 24)) + "px" });
            }
            else if (scheduleMode == "hour") {
                $(proxy._$bodyContent).css({ "width": (model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval)) + "px" });
            }
        },

        //declaring private properties
        _initPrivateProperties: function () {
            var proxy = this;
            proxy._viewportHeight = 0,
            proxy._prevScrollTop = 0,
            proxy._scrollTop = 0,
            proxy._vScrollDir = 1,
            proxy._maxZIndex = 0;
            proxy._taskbarEditedArgs = {},
            proxy._$ganttChartContainer = null,
            proxy._$headerContainer = null,
            proxy._$bodyContainer = null,
            proxy._$bodyContent = null,
            proxy._$dependencyViewContainer = null,
            proxy._$secondaryCanvas = null,
            proxy._$ganttViewTable = null,
            proxy._$ganttViewTablebody = null,
            proxy._weekdays = [],
            proxy._rowMargin = 0,
            proxy._renderedRange = null,
            proxy._visibleRange = null,
            proxy._vTop = null,
            proxy._vBottom = null,
            proxy._rTop = null,
            proxy._rBottom = null,
            proxy._vscrollDist = 0,
            proxy._containerHeight = 0,
            proxy._id = this.element.attr("id"),
            proxy._ganttChartRows = null,
            proxy._filteredRecords = [],
            proxy._sortedRecords = [],
            proxy._tempSortedRecords = [],
            proxy._scheduleHours = [],
            proxy._scheduleMinutes = [],
            proxy._updateScheduleWidth(),
            proxy._totalMonthWidth = 0,
            proxy._tempFilteredRecords = [],
            proxy._prevLeft = 0,
            proxy._allowDragging = false,
            proxy._leftResizing = false,
            proxy._rightResizing = false,
            proxy._progressResizing = false,
            proxy._editingContainer = null,
            proxy._allowExpandCollapse = true,
            proxy._leftResizer = null,
            proxy._taskbarItem = null,
            proxy._progressbarItem = null,
            proxy._progressResizer = null,
            proxy._rightResizer = null,
            proxy._manualRightResizer = null,
            proxy._tasknameContainer = null,
            proxy._mousePosX = 0,
            proxy._currMousePosX = 0,
            proxy._currMousePosY = 0,
            proxy._prevItem = {},
            proxy._parentCollectionPreviousValues = [],
            proxy._mouseTarget = null,
            proxy._mouseDown = false,
            proxy._$scheduleDiv = null,
            proxy._leftResizerGripper = null,
            proxy._rightResizerGripper = null,
            proxy._progressHandle = null,
            proxy._progressHandleChild = null,
            proxy._currentEditedRecord = {
                taskId: null,
                taskName: null,
                startDate: null,
                endDate: null,
                duration: null,
                isMilestone: false,
                status: null,
                predecessor: null,
                resourceInfo: null,
                parentItem: null,
                isSelected: false,
                childRecords: null,
                hasChildRecords: false,
                expanded: false,
                level: 0,
                left: 0,
                width: 0,
                progressWidth: 0,
                item: null,
                baselineLeft: 0,
                baselineWidth: 0,
                baselineStartDate: null,
                baselineEndDate: null,
                isReadOnly: false,
                hasFilteredChildRecords: true,
                serialNumber: null,
                taskbarBackground: null,
                progressbarBackground: null,
                parentProgressbarBackground: null,
                parentTaskbarBackground: null,
                cellBackgroundColor: null,
                rowBackgroundColor: null,
                treeMappingName: [],
                dragState: true,
                durationUnit: "",
            },
            proxy._mouseHoverTooltip = document.getElementById(this.model.tooltipTemplate),
            proxy._progressBarTooltipID = document.getElementById(this.model.progressbarTooltipTemplateId),
            proxy._taskbarEditingTooltipID = document.getElementById(this.model.taskbarEditingTooltipTemplateId),
            proxy._scrollBarHeight = 18,
            proxy._windowWidth = $(window).width(),
            proxy._windowHeight = $(window).height(),
            proxy._editingItem = null,
            proxy._editingTarget = null,
            proxy.tooltipState = null,
            proxy._visibleRecordsCount = 0,
            proxy._tooltipTimer,
            proxy._$gridLinesTablebody = null,

            //Properties for connector line mouse
            proxy._leftConnectorPoint = null,
            proxy._rightConnectorPoint = null,
            proxy._childLeftConnectorPoint = null,
            proxy._childRightConnectorPoint = null,
            proxy._editPredecessor = false,
            proxy._connectorPointX = null,
            proxy._connectorPointY = null,
            proxy._predecessorTooltip = null,
            proxy._totalCollapsedRecordCount = 0,
            proxy._milesStoneWidth = 0,
            proxy._connectorPointWidth = 0;
            proxy._newXYPos = true;
            proxy._posX1 = null,
            proxy._posY1 = null;
            proxy._nonWorkingDayIndex = [];
        },
        //Calculate schedulw width for all modes
        _updateScheduleWidth:function(){
            var proxy = this;
            proxy._scheduleWeekWidth = proxy._getWeekWidth();
            proxy._numOfWeeks = proxy._getNumberOftWeeks(this.model.projectStartDate, this.model.projectEndDate);
            proxy._scheduleYearWidth = proxy._getYearWidth();
            proxy._scheduleMonthWidth = proxy._getMonthWidth();
            proxy._totalWeekWidth = proxy._scheduleWeekWidth * proxy._numOfWeeks.length;
            proxy._balanceWidth = proxy._totalWeekWidth - proxy._scheduleMonthWidth;
            proxy._scheduleMonthWidth += proxy._balanceWidth;
        },
        //Initialize ganttchart
        _initialize: function () {
            var proxy = this;
            proxy._$ganttChartContainer = ej.buildTag("div.e-ganttviewercontainer#ganttviewercontainer" + proxy._id, "", { width: "100%" }, {});
            proxy._$headerContainer = ej.buildTag("div.e-ganttviewerheaderContainer#ganttviewerheaderContainer" + proxy._id, "", {
                "border-right-style": "solid",
                "border-right-width": "1px"
            }, {});
            proxy._$bodyContainer = ej.buildTag("div.e-ganttviewerbodyContianer#ganttviewerbodyContianer" + proxy._id, "", {
                '-ms-touch-action': 'none',                
            }, {});

            proxy._$bodyContainerParent = ej.buildTag("div.e-ganttviewerbodyContianerparent#ganttviewerbodyContianerParent" + proxy._id, "", {
                '-ms-touch-action': 'none',                
                "border-right-style": "solid",
                "border-right-width": "1px",
                "box-sizing": "border-box",
                "width": "auto",
                "height": "auto"
            }, {});
            proxy._$bodyContent = ej.buildTag("div.e-ganttviewerbodyContent#ganttviewerbodyContent" + proxy._id, "", {
            }, {});

            proxy._$dependencyViewContainer = ej.buildTag("div.e-ganttviewerbodyContianer-dependencyViewContainer#dependencyViewContainer" + proxy._id,
                "", {
                    'z-index': '4',
                    'position': 'absolute'
                }, {});
            proxy._$secondaryCanvas = ej.buildTag("div.e-ganttviewerbodyContianer-secondaryCanvas", "", {
                'z-index': '3',
                'position': 'absolute'
            }, {});
            //Container for strip lines
            proxy._$stripLineContainer = ej.buildTag("div.e-ganttviewerbodyContianer-stripLines", "", {
                'z-index': '6',
                'position': 'absolute'
            }, {});

            proxy._$weekendsContainer = ej.buildTag("div.e-ganttviewerbodyContianer-weekendsContainer", "", {
                'z-index': '1',
                'position': 'absolute'
            }, {});

            proxy._$ganttViewTable = ej.buildTag("table.e-ganttviewerbodyContianer-ganttViewTable e-zerospacing#ganttViewTable" + proxy._id, "", {
                'z-index': '5',
                'position': 'absolute'
            });
            proxy._$scheduleDiv = ej.buildTag("div.e-gantt-schedule-container#gantt-schedule" + proxy._id + "", "", {}, {});
        },

        _getScheduleLength: function (scheduleMode) {
            var proxy = this,
                model = proxy.model;

            switch (scheduleMode) {
                case "week":                    
                    return (model.scheduleWeeks.length * proxy._scheduleWeekWidth);
                case "year":                    
                    return (proxy._scheduleYearWidth);
                case "month":
                    return (proxy._scheduleMonthWidth);
                case "day":
                    return (model.scheduleDays.length * (proxy.model.perHourWidth * 24));
                case "hour":
                    return ((model.scheduleHours.length) * (model.perMinuteWidth * proxy._totalInterval));
                default:
                    return (model.scheduleWeeks.length * proxy._scheduleWeekWidth);
            }
        },

        //Rendering GanttChart
        _renderGanttChart: function () {
            var proxy = this, model = proxy.model,
                scheduleLength, $colsgroup, $column,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            
        proxy._createSchedule(proxy._getDateType(model.scheduleStartDate),
            proxy._getDateType(model.scheduleEndDate));

            proxy._viewportHeight = proxy._getViewportHeight();
                       
            proxy._$ganttViewTable.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup.append($column);
            proxy._$ganttViewTable.append($colsgroup);

            proxy._createTooltipTemplate();
            proxy._createEditingTooltipTemplate();
            proxy._createProgressbarTooltipTemplate();

            proxy._createTaskbarTemplate();
            proxy._createConnectorLineTemplate();

            proxy._updateCurrentViewData();

            //Display weekends
            if (proxy.model.highlightWeekends == true
                && model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Week)
                proxy._renderWeekends();

            proxy._$stripLineContainer.empty();
            //Display striplines
            if (proxy.model.stripLines != null) {
                this._renderStripLines(proxy.model.stripLines);
            }

            proxy._$secondaryCanvas.empty();
            //Display Holidays
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },

        //Rendering connectorlines from Gantt
        renderConnectorLines: function (connectorLinesCollection) {
            var proxy = this,
                connectorLineContainer = $.render[proxy._id + "ConnectorLineTemplate"](connectorLinesCollection);

            $(proxy._$dependencyViewContainer).empty();
            proxy._$dependencyViewContainer.append(connectorLineContainer);
            proxy._$bodyContent.append(proxy._$dependencyViewContainer);
        },

        //Empty the entire connectorline collection
        clearConnectorLines: function () {
            $(this._$dependencyViewContainer).empty();
        },

        clearSelection: function (index) {

            var proxy = this,
                model = proxy.model;

            if (model.selectedRowIndex != -1 || index == -1) {
                //To clear the row selection of previously selected row via set model (selectedRowIndex)
                var $ganttGridRows = proxy.getGanttChartRows();
                $ganttGridRows.removeClass("e-gantt-mouseclick");
            }
        },

        //append single connectorline
        appendConnectorLine: function (connectorLineCollection) {
            var proxy = this,
            connectorLineContainer = $.render[proxy._id + "ConnectorLineTemplate"](connectorLineCollection);
            proxy._$dependencyViewContainer.append(connectorLineContainer);
        },
        //set Collapsed record Count

        setCollapsedRecordCount:function(count)
        {
            this._totalCollapsedRecordCount = count;
        },
        //get collapsed record count
        getCollapsedRecordCount:function()
        {
            return this._totalCollapsedRecordCount;
        },
        //remove a particular connector line
        removeConnectorline: function (lineId) {
            this.element.find("#ConnectorLine" + lineId).remove();
        },

        //Events
        _wireEvents: function () {
            var proxy = this,
                matched = jQuery.uaMatch(navigator.userAgent);

            //$(proxy._$bodyContainer).bind("scroll", $.proxy(proxy._handleScroll, proxy));
            if (ej.isTouchDevice()) {                
                proxy._on(proxy.element, "touchstart", ".e-gantt-milestone-container,.e-childContainer", this._mouseHover);
                proxy._on(proxy.element, "touchstart", ".e-childContainer,.e-gantt-milestone-container,.e-parentContainer", proxy._mousedown);
                $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
                proxy._on(proxy.element, "touchleave", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseLeave);
                $(proxy._$bodyContainer).bind("touchend", $.proxy(proxy._handleMouseUp, proxy));
                proxy._on(proxy.element, "tap", proxy._cellClickHandler);
            }
            else {
                proxy._on(proxy.element, "mouseenter", ".e-gantt-milestone-container,.e-childContainer,.e-parentContainer", this._mouseHover);//.gantt-viewer-bodyContianer tr td
                proxy._on(proxy.element, "mouseleave", ".e-gantt-milestone-container,.e-childContainer,.e-parentContainer", this._mouseLeave);//.gantt-viewer-bodyContianer tr td
                proxy._on(proxy.element, "click", proxy._cellClickHandler);
                proxy._on(proxy.element, "mouseenter", ".e-taskbarresizer-left", proxy._resizerleftOver);
                proxy._on(proxy.element, "mouseenter", ".e-taskbarresizer-right", proxy._resizerrightOver);
                proxy._on(proxy.element, "mouseenter", ".e-progressbarresizer-right", proxy._progressresizerOver);
                proxy._on(proxy.element, "mouseenter", ".e-connectorpoint-left", proxy._dragLeftOver);
                proxy._on(proxy.element, "mouseenter", ".e-connectorpoint-right", proxy._dragRightOver);
          

                if (ej.browserInfo().name != "msie") {
                    proxy._on(proxy.element, "mousedown", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                }
                else {
                    proxy._on(proxy.element, "mousedown", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                }


                $(proxy._$bodyContainer).bind("mouseup", $.proxy(proxy._handleMouseUp, proxy));
                $(document).bind("mouseup", $.proxy(proxy._tooltipMouseup, proxy));
                proxy._on(proxy.element, "mouseenter", ".e-stripline", proxy._stripLineMouseOver);
                proxy._on(proxy.element, "mouseleave", ".e-stripline", proxy._stripLineMouseLeave);

                //if (matched.browser.toLowerCase() == "msie") {
                //    proxy._on(proxy.element, "MSPointerDown", ".e-tasklabel,.e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                //    $(document.body).bind("MSPointerMove", function (event) {
                //        event.preventDefault();
                //    });
                //    $(document.body).bind("MSPointerMove", $.proxy(proxy.handleMouseMove, proxy));
                //    $(proxy._$bodyContainer).bind("MSPointerUp", $.proxy(proxy._handleMouseUp, proxy));
                //}


                if (matched.browser.toLowerCase() == "chrome") {
                    proxy._on(proxy.element, "touchstart", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseHover);
                    proxy._on(proxy.element, "touchstart", ".e-childContainer,.e-gantt-milestone-container", proxy._mousedown);
                    proxy._on(proxy.element, "touchleave", ".e-gantt-milestone-container,.e-childContainer, .e-parentContainer", this._mouseLeave);                    
                    $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
                    //proxy._on(proxy.element, "touchend", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._handleMouseUp);
                    proxy._on(proxy.element, "touchleave", ".e-parentContainer,.e-childContainer,.e-gantt-milestone-container", proxy._handleMouseUp);
                    $(proxy._$bodyContainer).bind("touchend", $.proxy(proxy._handleMouseUp, proxy));
                    $(proxy._$bodyContainer).bind("touchleave", $.proxy(proxy._handleMouseUp, proxy));
                }
            }
                proxy._enableEditingEvents();
        },

        //Event append for editDialogOpen while perform double click action
        _enableEditingEvents: function () {

            var proxy = this,
                model = proxy.model;

            if (model.editSettings.allowEditing && model.editSettings.editMode === "normal") {
                    if (!ej.isTouchDevice)
                        proxy._on(this.element, "dblclick", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                    else
                        proxy._on(this.element, "doubletap", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
            }else {
                    if (!ej.isTouchDevice)
                        proxy._off(this.element, "dblclick", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                    else
                        proxy._off(this.element, "doubletap", ".e-ganttviewerbodyContent", proxy._editdblClickHandler);
                } 
        },


        //UPDATE Edit Settings
        updateEditSettings: function (edit) {

            var proxy = this;

            if (edit) {
                if (edit.editMode) 
                    proxy.model.editSettings.editMode = edit.editMode;
                if (!ej.isNullOrUndefined(edit.allowAdding))
                    proxy.model.editSettings.allowAdding = edit.allowAdding;
                if (!ej.isNullOrUndefined(edit.allowEditing))
                    proxy.model.editSettings.allowEditing = edit.allowEditing;
                if (!ej.isNullOrUndefined(edit.allowDeleting))
                    proxy.model.editSettings.allowDeleting = edit.allowDeleting;
                if (!ej.isNullOrUndefined(edit.beginEditAction))
                    proxy.model.editSettings.beginEditAction = edit.beginEditAction;
                proxy._enableEditingEvents();
            }
        },

        //Double click event handler for editing with editMode as normal
        _editdblClickHandler: function () {

            var proxy = this,
                model = this.model,
                args = {};

            if (proxy.model.editSettings.editMode === "normal" && !model.readOnly && proxy.model.editSettings.allowEditing) {
                args.requestType = ej.TreeGrid.Actions.BeginEdit;
                proxy._trigger("actionBegin", args);
            }

        },

        //MouseLeave event for striplines to remove tooltip
        _stripLineMouseLeave: function () {
            window.clearTimeout(this._tooltipTimer);
            this._clearTooltip();
        },

        //mouseHover event for stripline to render tooltip
        _stripLineMouseOver: function (e) {

            e.target.style.cursor = "pointer";
            var proxy = this, model = proxy.model,
                $target = $(e.target),
                parentNode, match,
                tooltiptable,
                tooltipbody,
                posx = 0, posy = 0;
            proxy._clearTooltip();
            if ($target.hasClass("e-striplinespan")) {
                parentNode = $target[0].parentNode;
            } else
                parentNode = $target[0];

            match = parentNode.id.match(/(\d+|[A-z]+)/g);

            if (e.type == "mouseenter" || e.type == "mousemove") {
                if (!e) e = window.event;
                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    posx = e.originalEvent.pageX;
                    posy = e.originalEvent.pageY;
                }
                else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    posx = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                    posy = e.originalEvent.clientY + document.body.scrollTop
                        + document.documentElement.scrollTop;
                }

                tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "width": "auto", "margin-top": "0px" },
                    { 'cellspacing': '2px', 'cellpadding': '2px' });
                tooltipbody = ej.buildTag("tbody",
                    "<tr><td>" + model.stripLines[match[1]].day + "</td></tr><tr><td>" +
                        model.stripLines[match[1]].label + "</td></tr>", {}, {});

                tooltiptable.append(tooltipbody);
                proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                    { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1 }, {});
                model.cssClass && proxy._mouseHoverTooltip.addClass(model.cssClass);
                setTimeout(function () {
                    $(document.body).append(proxy._mouseHoverTooltip);
                    proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                }, 700);
            }
        },

        //Mouseup over tooltip 
        _tooltipMouseup: function () {
            var proxy = this;
            if (proxy._mouseTarget != null && !ej.isTouchDevice()) {
                proxy._handleMouseUp(proxy._mouseTarget);
            }
        },

        //removes all the tooltip in ganttchart
        _clearTooltip: function () {
            var proxy = this;
            proxy._mouseHoverTooltip && $(proxy._mouseHoverTooltip).remove();
            $('.e-editingtooltip').remove();
            $("#tooltipgantt").remove();
            $(".e-progressbartooltip").remove();
            proxy._mouseHoverTooltip = null;

        },

        //mouseHover event on taskbar right helper element
        _resizerrightOver: function (e) {

            var proxy = this,
                $target = e.target,
                div = $target.parentNode;

            if (proxy.model.allowGanttChartEditing == true&& proxy.model.readOnly == false) {
                if (this._mouseDown == false)
                    e.target.style.cursor = "w-resize";
                proxy._setEditingElements(div);
            }
        },


        //mouseLeave event for taskbar right helper element
        _resizerrightLeave: function () {

            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        //mouseHover event on taskbar left helper element
        _resizerleftOver: function (e) {

            var proxy = this,
                $target = e.target,
                div = $target.parentNode;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                if (this._mouseDown == false)
                    e.target.style.cursor = "e-resize";
                proxy._setEditingElements(div);
            }
        },


        //mouseLeave event for taskbar left helper element
        _resizerleftLeave: function () {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        //mouseHover event on taskbar progressbar helper element
        _progressresizerOver: function (e) {
            var proxy = this,
                $target = e.target,
                div = $target.parentNode;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                if (proxy.model.enableProgressBarResizing){
                    if (proxy._mouseDown == false && $($target).prev(".e-gantt-childtaskbar").has(".e-gantt-childtaskbar-progress").length > 0)
                        $target.style.cursor = "col-resize";
                    proxy._setEditingElements(div);
                }
                else
                    $target.style.cursor = "move";
            }
        },


        //mouseLeave event for progressbar helper element
        _progressresizerLeave: function () {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },


        _secondMouseOverConnectorPoint: function (e, mouseUp)
        {
            var proxy = this, row, recordIndexr, item;

            if ((proxy._mouseDown && proxy._falseLine) || (mouseUp && proxy._falseLine)) {

                var $target = $(e.target),
                  $ganttGridRows = proxy.getGanttChartRows(),
                  row = $target.closest('tr.e-ganttrowcell'),
                  recordIndexr = $ganttGridRows.index(row),
                  item = proxy.model.currentViewData[recordIndexr];

                var fromItem = proxy._editingItem;
                var toItem = item, predecessor, fullPredecessor, currentTarget,
                    predecessorText = proxy.model.predecessorText;

                if (proxy._prevItem.predecessorTarget === 'Start') {
                    predecessor = fromItem.taskId + 'S';
                } else if (proxy._prevItem.predecessorTarget === 'Finish') {
                    predecessor = fromItem.taskId + 'F';
                }

                if ($target.hasClass('e-connectortouchpoint')) {
                    if ($target.parent().hasClass('e-connectorpoint-left')) {
                        predecessor += 'S';
                        currentTarget = predecessorText["Start"];
                    }
                    else if ($target.parent().hasClass('e-connectorpoint-right')) {
                        predecessor += 'F';
                        currentTarget = predecessorText["Finish"];
                    }
                } else {
                    if ($target.hasClass('e-connectorpoint-left')) {
                        predecessor += 'S';
                        currentTarget = predecessorText["Start"];
                    }
                    else if ($target.hasClass('e-connectorpoint-right')) {
                        predecessor += 'F';
                        currentTarget = predecessorText["Finish"];
                    }
                }
                var $table, $td;
                //Append second item in predecessor tooltip
                //update tooltip on over of second connector point
                if (proxy._predecessorTooltip) {
                    $table = proxy._predecessorTooltip.find("table");
                    $td = $table.find("tbody").find("tr:eq(1)").find("td:eq(2)").text(toItem.taskName);
                    $td = $table.find("tbody").find("tr:eq(1)").find("td:eq(3)").text(currentTarget);
                }

                var args = {};
                args.requestType = "validatePredecessor";
                args.fromItem = fromItem;
                args.toItem = toItem;
                if (args.toItem.item[proxy.model.predecessorMapping]) {
                    fullPredecessor = args.toItem.item[proxy.model.predecessorMapping] + "," + predecessor;
                }
                else {
                    fullPredecessor = predecessor;
                }
                args.predecessor = predecessor;
                args.currentRecord = toItem;
                args.predecessorString = [];
                args.predecessorString.push(fullPredecessor);
                var validation = proxy._completeAction(args);
                //update tooltip after validation
                if (proxy._predecessorTooltip) {
                    $td = $table.find("tbody").find("tr:eq(0)").find("td:eq(0)");
                    if (validation) {
                        // $td.text("True");
                        $td.removeClass();
                        $td.addClass("e-predecessor-true");
                    } else {
                        //  $td.text("False");
                        $td.removeClass();
                        $td.addClass("e-predecessor-false");
                    }
                }

                //Here also update on moueup//same code is required
                if (mouseUp) {
                    return args;
                }
                
            }
        },
        //mouse enter event for left-connectorpoint-point

        _dragLeftOver:function(e)
        {
            var proxy = this,
              $target = e.target,
              div = $target.parentNode;
            if (e.type == "touchmove" && $(e.target).hasClass('e-connectortouchpoint'))
                div = $target.parentNode.parentNode;
            if (proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                if (this._mouseDown == false ) {
                    $target.style.cursor = "pointer";
                }
                proxy._setEditingElements(div);
            }
            if(!$(div).hasClass('e-parentContainer'))
                proxy._secondMouseOverConnectorPoint(e);

        },
        //mouse leave event for left-connectorpoint-point
        _dragLeftLeave: function (e) {

            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },

        //mouse enter event for right-connectorpoint-point

        _dragRightOver: function (e) {
            var proxy = this,
             $target = e.target,
             div = $target.parentNode;
            if (e.type == "touchmove" && $(e.target).hasClass('e-connectortouchpoint'))
                div = $target.parentNode.parentNode;
            if (proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                if (this._mouseDown == false) {
                    $target.style.cursor = "pointer";
                }
                proxy._setEditingElements(div);
            }
            if (!$(div).hasClass('e-parentContainer'))
                proxy._secondMouseOverConnectorPoint(e);
        },
        //mouse leave event for right-connectorpoint-point
        _dragRightLeave: function (e) {
            var proxy = this;
            if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                proxy._removeEditingElements();
            }
        },




        //adding styles for taskbar helper elements
        _setEditingElements: function (div) {
            var proxy = this, progressHandler;

            if (proxy._editingTarget && !proxy._editPredecessor && $(div).find(proxy._editingTarget).length == 0)
                return true;

            if ($(div).hasClass("e-childContainer")) {
                proxy._leftResizerGripper = div.querySelector(".e-taskbarresizer-left"); 
                proxy._rightResizerGripper = div.querySelector(".e-taskbarresizer-right"); 
                progressHandler = div.querySelector(".e-progressbarresizer-right");
                proxy._progressHandle = progressHandler && progressHandler.firstChild;
                proxy._progressHandleChild = progressHandler && progressHandler.childNodes[1];

                $(proxy._leftResizerGripper).addClass("e-gripper");
                $(proxy._rightResizerGripper).addClass("e-gripper");

                if (proxy.model.progressMapping && proxy.model.enableProgressBarResizing) {
                    $(proxy._progressHandle).addClass("e-progresshandle");
                    $(proxy._progressHandleChild).addClass("e-progresshandleafter");
                }
            }


            if (proxy.model.enablePredecessorEditing) {
                if ($(div).hasClass("e-childContainer") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-gantt-milestone-container") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-childContainer") && proxy.model.predecessorMapping && proxy._falseLine) {
                    proxy._childLeftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._childRightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._childLeftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-gantt-milestone-container") && proxy.model.predecessorMapping && proxy._falseLine) {
                    proxy._childLeftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._childRightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._childLeftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).addClass("e-connectorpoint-hover");
                }
                else if ($(div).hasClass("e-parentContainer") && proxy.model.predecessorMapping && !proxy._falseLine) {

                    proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                    proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");

                    if($(div).hasClass("e-manualparenttaskbar"))
                    {
                        $(proxy._leftConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                    }

                }
            }
        },


        //removing styles for taskbar helper elements
        _removeEditingElements: function () {
            var proxy = this;
            $(proxy._leftResizerGripper).removeClass("e-gripper");
            $(proxy._rightResizerGripper).removeClass("e-gripper");

            if (proxy.model.progressMapping) {
                $(proxy._progressHandle).removeClass("e-progresshandle");
                $(proxy._progressHandleChild).removeClass("e-progresshandleafter");
            }


            //Remove Connector points in chart
            if (proxy.model.enablePredecessorEditing) {
                if (proxy.model.predecessorMapping && proxy._mouseDown == false) {

                    $(proxy._leftConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    $(proxy._rightConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    proxy._leftConnectorPoint = null;
                    proxy._rightConnectorPoint = null;
                }

                if (proxy.model.predecessorMapping && proxy._leftConnectorPoint !== null && proxy._mouseDown == true || proxy._childLeftConnectorPoint) {
                    $(proxy._childLeftConnectorPoint).removeClass("e-connectorpoint-hover");
                    $(proxy._childRightConnectorPoint).removeClass("e-connectorpoint-hover");
                    //remove curret target predecessor in tooltip    
                    if (proxy._predecessorTooltip) {
                        var $table = proxy._predecessorTooltip.find("table");
                        $table.find("tbody").find("tr:eq(1)").find("td:eq(2)").text("");
                        $table.find("tbody").find("tr:eq(1)").find("td:eq(3)").text("");
                        var $td = $table.find("tbody").find("tr:eq(0)").find("td:eq(0)").removeClass();
                        //$td.text("False");
                        $td.addClass('e-predecessor-false');
                    }
                }
            }
        },


        refreshHeight:function(){

            var proxy = this;
            proxy._$bodyContainer.ejScroller("refresh");
        },

        //mousedown event for ganttchart
        _mousedown: function (e) {
            if (e.which == 2 || e.which == 3) //2 for mouseWheel, 3 for rightClick button
                return false;
            var proxy = this,
                args = {};
            proxy._clearTooltip();
            proxy._mouseDown = true;
            
            //proxy._clearContextMenu();
            var $target = $(e.target),
            $ganttGridRows = proxy.getGanttChartRows(),
            row = $target.closest('tr.e-ganttrowcell'),
            recordIndexr = $ganttGridRows.index(row),
            item = proxy.model.currentViewData[recordIndexr],
            parentItem = item.parentItem,
            div = $target[0].parentNode,
            matched = jQuery.uaMatch(navigator.userAgent),
            model = this.model;

            if (ej.isNullOrUndefined(item)) {
                return;
            }

            if (e.type == "touchstart") {
                e.preventDefault();
                $(".e-connectortouchpoint").addClass("e-enableconnectortouchpoint");
            }

            proxy._editingItem = item;
            proxy._editingTarget = $target;
            proxy._allowExpandCollapse = true;

            if ($(div).hasClass("e-progressbarresizer-right")) {
                div = div.parentNode;
            }
            else if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer");
            }
            else if ($(div).hasClass("e-progressbarhandler")) {
                div = $target.closest(".e-childContainer")[0];
            }
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container");
            }
            if ($(div).hasClass("e-childContainer") ||
                ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass('e-parentContainer') || $(div).hasClass("e-gantt-milestone-container")) {

                $(row).addClass("e-editmode");
                proxy._mouseTarget = e;
            }

            if (proxy.model.allowGanttChartEditing && proxy.model.readOnly == false && ($(div).hasClass("e-childContainer")
                || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass('e-parentContainer'))) { //mouse down on drag points in child and milestone container and parent container also included 

                if (e.target.style.cursor == "e-resize" && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")))
                    || (e.type == "touchstart" && e.target.className == "e-taskbarresizer-left")) {
                    proxy._updateEditingType();
                    proxy._leftResizing = true;
                }

                if (e.target.style.cursor == "w-resize" && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-parentContainer"))
                    || (e.type == "touchstart" && e.target.className == "e-taskbarresizer-right")) {
                        proxy._updateEditingType();
                    proxy._rightResizing = true;

                }
                var prorgressResize = $(e.target).closest(".e-progressbarresizer-right");
                if ((e.target.style.cursor == "col-resize" || (prorgressResize.length && prorgressResize[0].style.cursor == "col-resize")) && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")))
                    || (e.type == "touchstart" && e.target.className == "e-progressbarresizer-right")) {
                    proxy._updateEditingType();
                    proxy._progressResizing = true;
                }
                var childTaskbar = $(e.target).closest("[style*='cursor: move']");
                if ((e.target.style.cursor == "move" || (childTaskbar.length && childTaskbar[0].style.cursor == "move")) && ($(div).hasClass("e-childContainer")
                    || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container")) || $($target[0]).hasClass("e-gantt-manualparenttaskbar")) {
                    proxy._updateEditingType();
                    proxy._allowDragging = true;
                }
                if (e.target.style.cursor == "" && ((childTaskbar.length && childTaskbar[0].style.cursor == "") || childTaskbar.length==0) && ($(div).hasClass("e-childContainer")
                  || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container")) || (item.isAutoSchedule && $($target).hasClass("e-gantt-manualparenttaskbar"))) {
                    proxy._updateEditingType();
                    if (e.target.className == "e-taskbarresizer-left e-icon" || e.target.className == "e-taskbarresizer-left e-icon e-gripper")
                        proxy._leftResizing = true;
                    else if (e.target.className == "e-taskbarresizer-right e-icon" || e.target.className == "e-taskbarresizer-right e-icon e-gripper")
                        proxy._rightResizing = true;
                    else if ((e.target.className == "e-progressbarhandler e-progresshandle") || (e.target.className == "e-progresshandler-element")
                        || (e.target.className == "e-progresshandlerafter-element") || (e.target.className == "e-progressbarresizer-right"))
                        proxy._progressResizing = true;
                    else if ((e.target.className == "e-gantt-childtaskbar-progress  progressbar") || (e.target.className == "e-tasklabel") || (e.target.className == "e-gantt-childtaskbar") || (e.target.className == "e-gantt-milestone e-milestone-top") ||
                        (e.target.className == "e-gantt-milestone e-milestone-bottom") || $(e.target).hasClass("e-gantt-milestone") || $(e.target).closest(".e-gantt-milestone").length > 0 || $(e.target).closest(".e-gantt-childtaskbar").length > 0)
                        proxy._allowDragging = true;
                }

                // ON drag points initiate the false line and edit type for predecessor

                if (proxy.model.enablePredecessorEditing) {
                    if (e.target.style.cursor == "pointer" && ($(div).hasClass("e-childContainer")
                     || ($(div).hasClass("e-gantt-milestone")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass('e-parentContainer'))
                         || (e.type == "touchstart" && (e.target.className == "e-connectorpoint-right" || e.target.className == "e-connectorpoint-left"
                         || e.target.className == "e-connectorpoint-right e-connectorpoint-hover" || e.target.className == "e-connectorpoint-left e-connectorpoint-hover"))) {
                        proxy._updateEditingType();
                        proxy._editPredecessor = true;
                        if ($target.hasClass('e-connectorpoint-left') || $target.hasClass('e-connectorpoint-left e-connectorpoint-hover')) {
                            proxy._prevItem.predecessorTarget = 'Start';
                        }
                        else if ($target.hasClass('e-connectorpoint-right') || $target.hasClass('e-connectorpoint-right e-connectorpoint-hover')) {
                            proxy._prevItem.predecessorTarget = 'Finish';
                        }
                    }
                }




                if (!e) e = window.event;
                if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                    e.originalEvent.pageX = e.originalEvent.clientX;
                    e.originalEvent.pageY = e.originalEvent.clientY;
                }

                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    proxy._posX1 = proxy._currMousePosX = e.originalEvent.pageX;
                    proxy._posY1 = proxy._currMousePosY = e.originalEvent.pageY;
                    proxy.dragPosX = e.originalEvent.pageX;
                }
                else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    proxy._posX1 = proxy.dragPosX = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                    proxy._posY1 = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                }
                else if (e.originalEvent && e.originalEvent.changedTouches
                    && e.originalEvent.changedTouches.length > 0) {
                    proxy._posX1 = proxy._currMousePosX = e.originalEvent.changedTouches[0].pageX;
                    proxy._posY1 = proxy._currMousePosY = e.originalEvent.changedTouches[0].pageY;
                    proxy.dragPosX = e.originalEvent.changedTouches[0].pageX;
                }

                proxy._prevItem.left = item.left;
                proxy._prevItem.status = item.status;
                proxy._prevItem.duration = item.duration;
                proxy._prevItem.startDate = item.startDate;
                proxy._prevItem.endDate = item.endDate;
                proxy._prevItem.width = item.width;

                proxy._parentCollectionPreviousValues = proxy._getParentCollectionPreviousValues(item);
                //For false line starting point
                if (proxy.model.enablePredecessorEditing) {
                    proxy._connectorPointX = proxy._currMousePosX - proxy._$bodyContent.offset().left;
                    proxy._connectorPointY = proxy._currMousePosY - proxy._$bodyContent.offset().top;
                }


                $(proxy._$bodyContainer).bind("mousemove", $.proxy(proxy.handleMouseMove, proxy));                
            }
             
                proxy._appendTooltip($target, recordIndexr);

            proxy._trigger("clearColumnMenu");
            //return false;
        },

        //Get previous parent item values
        _getParentCollectionPreviousValues: function (item) {
            var record = item,
                parentPrevItem = {},
                allParentRecords = [];
            do {               
                var parentItem = record.parentItem;
                if (!ej.isNullOrUndefined(parentItem)) {
                    parentPrevItem.left = parentItem.left;
                    parentPrevItem.status = parentItem.status;
                    parentPrevItem.duration = parentItem.duration;
                    parentPrevItem.startDate = parentItem.startDate;
                    parentPrevItem.endDate = parentItem.endDate;
                    parentPrevItem.width = parentItem.width;
                    parentPrevItem.index = parentItem.index;

                    if (!parentPrevItem.isAutoSchedule) {
                        parentPrevItem.manualLeft = parentItem.manualLeft;
                        parentPrevItem.manualStartDate = parentItem.manualStartDate;
                        parentPrevItem.manualEndDate = parentItem.manualEndDate;
                        parentPrevItem.manualDuration = parentItem.manualDuration;
                    }
                    allParentRecords.push(parentPrevItem);
                    record = parentItem;
                    parentPrevItem = {};
                }
            } while (record.parentItem);
            return allParentRecords;
        },

        handleMouseMove: function (e) {
            this._updateOnmouseMove(e);

        },              

        // perserve the task edited event arguments 
        taskbarEditedArguments: function (args) {
            var proxy = this;
            return proxy._taskbarEditedArgs;
        },

        taskbarEditedCancel: function (arg) {
            var item = arg.data,
                recordIndexr = arg.recordIndex, proxy = this;

            var args = proxy._taskbarEditedArgs;

            proxy._getPrevItem(item, recordIndexr);
            if (item.parentItem)
                proxy._getParentPreviousValue();
            if (proxy.model.predecessorMapping && (args.dragging || args.rightResizing || args.leftResizing)) {
                args.requestType = "updateConnectors";
                args.ganttRecord = item;
                proxy._trigger("actionComplete", args);
            }
        },
        //Handler for MouseUp event in ganttchart
        _handleMouseUp: function (e) {

            var proxy = this,
                args = {},
                $ganttGridRows = proxy.getGanttChartRows(),
                $target, row, recordIndexr = 0, item,
                x1 = proxy._posX1,
                y1 = proxy._posY1,
                x2, y2,
                tooltipElement, tooltiptable, tooltipbody;

            if (ej.isNullOrUndefined(e.pageX)) {
                x2 = e.originalEvent.changedTouches[0].pageX;
                y2 = e.originalEvent.changedTouches[0].pageY;
                if (!ej.isNullOrUndefined(proxy._predecessorTooltip))
                e.target = document.elementFromPoint(x2, y2);
            }
            else {
                x2 = e.pageX;
                y2 = e.pageY;
            }

            
            //Calculate and validate predecessor and draw connectorline after second connector point connects
            if (($(e.target).hasClass('e-connectorpoint-left') || $(e.target).hasClass('e-connectorpoint-right') || $(e.target).hasClass('e-connectortouchpoint'))
                && proxy._falseLine && !$(e.target).parent().hasClass('e-parentContainer')) {
                proxy._trigger("cancelEditCell");
                if ($(e.target).hasClass('e-connectortouchpoint'))
                    e.target = $(e.target).parent();
                var newArgs = proxy._secondMouseOverConnectorPoint(e, true);
                args.currentRecord = newArgs.currentRecord;
                args.fromItem = newArgs.fromItem;
                args.toItem = newArgs.toItem;
                args.predecessor = newArgs.predecessor;
                args.predecessorString = newArgs.predecessorString;
                args.requestType = "validatePredecessor";
                if (!proxy._trigger("actionBegin",args)) {
                    if (newArgs.predecessorValidation) {
                        newArgs.requestType = "drawConnectorLine";
                        proxy._completeAction(newArgs);
                    }
                }
            }

            if (proxy._editingTarget != null && proxy._editingItem != null) {
                $target = proxy._editingTarget,
                row = $target.closest('tr.e-ganttrowcell'),
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem;
                if ($(row).hasClass("e-editmode")) {
                    $(row).removeClass("e-editmode");
                    proxy._mouseTarget = null;
                }
            }

            $("#ganttviewerbodyContianer" + proxy._id).unbind("mousemove");
            proxy._mouseDown = false;
            proxy._clearTooltip();
            if (x1 != x2 || y1 != y2) {
                proxy._editingTarget = null;
                proxy._editingItem = null;
                proxy._$ganttChartContainer[0].style.cursor = "auto";

                if (item != null && (proxy._allowDragging || proxy._leftResizing || proxy._rightResizing || proxy._progressResizing)) {
                    args.editingFields = { startdate: item.startDate, enddate: item.endDate, progress: item.status, duration: item.duration, durationunit: item.durationUnit };
                    args.data = item;
                    args.recordIndex = recordIndexr;
                    args.previousData = proxy._prevItem;
                    args.dragging = proxy._allowDragging;
                    args.leftResizing = proxy._leftResizing;
                    args.rightResizing = proxy._rightResizing;
                    args.progressResizing = proxy._progressResizing;
                    var newArgs={},
                         validateMode = {
                             respectLink: false,
                             removeLink: false,
                             preserveLinkWithEditing: true,
                         };
                    newArgs.editMode = "dragging";
                    newArgs.data = item;
                    newArgs.recordIndex=recordIndexr;
                    newArgs.requestType = "validateLinkedTask";
                    newArgs.validateMode = validateMode;
                    proxy._taskbarEditedArgs = args;
                    proxy._trigger("actionBegin", newArgs) 
                    if(newArgs.cancel)
                        proxy._taskbarEdited(args);                    
                }

                if (args.cancel)
                    proxy.taskbarEditedCancel(args);
                proxy._updateEditingType();

                //Remove drag point and false lines on mouse up
                proxy._falseLine && proxy._falseLine.remove();
                proxy._falseLine = null;
                proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                proxy._predecessorTooltip = null;
                $(proxy._leftConnectorPoint).removeClass("e-connectorpoint-hover").removeClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                $(proxy._rightConnectorPoint).removeClass("e-connectorpoint-hover").removeClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                $(proxy._childRightConnectorPoint).removeClass("e-connectorpoint-hover");
                $(proxy._childLeftConnectorPoint).removeClass("e-connectorpoint-hover");
                proxy._leftConnectorPoint = null;
                proxy._rightConnectorPoint = null;
                proxy._childRightConnectorPoint = null;
                proxy._childLeftConnectorPoint = null;
                proxy._trigger("clearColumnMenu");
            }
            else {
                proxy._newXYPos = false;
                proxy._$ganttChartContainer[0].style.cursor = "auto";
                proxy._allowDragging = false;
                proxy._falseLine && proxy._falseLine.remove();
                proxy._falseLine = null;
                if (item && proxy.model.enableTaskbarTooltip) {

                    proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                    proxy._predecessorTooltip = null;

                    tooltipElement = {
                        ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                        ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                        ttipduration: item.duration,
                        ttipprogress: item.status.toString(),
                        ttiptaskname: item.taskName,
                        ttipdurationunit: item.durationUnit
                    };


                    tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "margin-top": "0px" }, { 'cellspacing': '5' });


                    if (!proxy.model.tooltipTemplate && !proxy.model.tooltipTemplateId) {
                        proxy.tooltipState = "";
                        tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](tooltipElement), {}, {});
                        tooltiptable.append(tooltipbody);
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                           { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy._mouseHoverTooltip.innerHTML = "<table>" + tooltiptable[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip)
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    else if (proxy.model.tooltipTemplate) {
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                            { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "Template";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                        proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip)
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    else if (proxy.model.tooltipTemplateId) {
                        proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                               { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                        proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "TemplateID";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                        proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                        //Providing a time delay to render the tooltip to improve UI
                        proxy._tooltipTimer = setTimeout(function () {
                            $(document.body).append(proxy._mouseHoverTooltip);
                            proxy._updateTooltipPosition(proxy._mouseHoverTooltip, x2, y2 + 20);
                        }, 300);
                    }
                    $(proxy._mouseHoverTooltip).addClass("e-customTooltip");
                    proxy._trigger("clearColumnMenu");
                }
            }
            if (e.type == "touchend") {
                $(".e-connectortouchpoint").removeClass("e-enableconnectortouchpoint");
            }
        },

        getChildCount: function (record, count) {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                count++;
                if (currentRecord.hasChildRecords) {
                    count = proxy.getChildCount(currentRecord, count);
                }
            }
            return count;
        },

        // Mapping the critical path ID's, Index and Collections from gantt to ganttchart
        criticalDataMapping: function (criticalPathIds, condition, collection, collectionTaskId) {
            if (condition == true) {
                this.model.isCriticalPathEnable = true;
                if (!ej.isNullOrUndefined(criticalPathIds)) {
                    this.model.criticalPathCollection = criticalPathIds;
                    this.model.detailPredecessorCollection = collection;
                    this.collectionTaskId = collectionTaskId;
                }
            }
            if (condition == false) {
                this.model.isCriticalPathEnable = false;
            }
        },

        // Render color to the critical task.
        criticalPathColor: function (criticalPathIds, condition, collection, collectionTaskId) {
            if (condition == true) {
                if (!ej.isNullOrUndefined(criticalPathIds)) {
                    this._refresh();
                    if (!ej.isNullOrUndefined(collection))
                        this.criticalConnectorLine(criticalPathIds, collection, true, collectionTaskId);
                }
            }
            if (condition == false) {
                this.criticalConnectorLine(criticalPathIds, collection, false, collectionTaskId);
                this._refresh();
            }
        },

        // Render color to the critical connector lines.
        criticalConnectorLine: function (criticalPathIds, collection, condition, collectionTaskId) {
            if (condition == false) {
                this.element.find(".e-line").removeClass("e-criticalconnectorline");
                this.element.find(".e-connectorline-rightarrow").removeClass("e-criticalconnectorlinerightarrow");
                this.element.find(".e-connectorline-leftarrow").removeClass("e-criticalconnectorlineleftarrow");
            } else if (collection.length != 0) {
                var index = 0, currentdata, checking = [], checkint;
                for (var xx = 0; xx < this.model.criticalPathCollection.length; xx++) {
                    index = collectionTaskId.indexOf(this.model.criticalPathCollection[xx]);
                    currentdata = collection[index];
                    if (index != -1 && currentdata.to) {
                        checking = currentdata.to.split(",");
                        for (var m = 0; m < checking.length; m++) {
                            checkint = parseInt(checking[m]);
                            if (criticalPathIds.indexOf(checkint) != -1) {
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".e-line").addClass("e-criticalconnectorline");
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".e-connectorline-rightarrow").addClass("e-criticalconnectorlinerightarrow");
                                this.element.find("#ConnectorLineparent" + currentdata.taskid + "child" + checkint).find(".e-connectorline-leftarrow").addClass("e-criticalconnectorlineleftarrow");
                            }
                        }
                    }
                }
            }
        },

        //get the Expand status of GridRecord
        _getCollapsedParentItem: function (record) {
            var parentRecord = record.parentItem;
            if (parentRecord) {
                if (this._getExpandStatus(parentRecord) === true) {
                    return parentRecord;
                } else {
                    return this._getCollapsedParentItem(parentRecord);
                }
            }
            else
            {
                return null;
            }
        },
        /* scroll to selected record */
        updateScrollBar: function () {
            var proxy = this,
                model = proxy.model, horizontalScrollBarHeight,
                currentUpdatedRecords, recordIndex,
                isInViewPortAbove, isInViewPortBelow;

            currentUpdatedRecords = proxy.getExpandedRecords(model.updatedRecords);
            recordIndex = currentUpdatedRecords.indexOf(model.selectedItem);

            if (!model.selectedItem || recordIndex == -1)
                return;

            var rowTop = recordIndex * model.rowHeight,
                rowBottom = rowTop + model.rowHeight,
                scrollTop,
                containerWidth,
                scrollerExist = proxy._$bodyContainer.children(".e-content").length;

            if (scrollerExist)
                scrollTop = proxy._$bodyContainer.children(".e-content").scrollTop();
            else
                scrollTop = proxy._$bodyContainer.scrollTop();

            if (proxy._$bodyContainer.ejScroller("isHScroll") || proxy.element.find(".e-borderbox").length > 0) {
                horizontalScrollBarHeight = 18; /* default horizontal scrollbar height*/
            }

            isInViewPortAbove = (rowTop < scrollTop);
            isInViewPortBelow = (scrollTop + proxy._viewportHeight - horizontalScrollBarHeight) < rowBottom;

            if (isInViewPortAbove || isInViewPortBelow) {

                if ((rowTop + proxy._viewportHeight) > currentUpdatedRecords.length * model.rowHeight) {
                    rowTop = currentUpdatedRecords.length * model.rowHeight - proxy._viewportHeight;

                    if (isInViewPortBelow)
                        rowTop += horizontalScrollBarHeight;
                }
                proxy._$bodyContainer.ejScroller("scrollY", rowTop, true);

                if (model.enableVirtualization) {
                    proxy.focusGanttElement();
                }
            }
        },

        //In virtualization get expaned records from total record collection only
        getExpandedRecords: function (records) {
            var proxy = this;
            var resultRecord = records.filter(function (record) {
                return proxy._getExpandStatus(record) == true;
            });
            return resultRecord;
        },


        //keyPressed event for perform the keynavigate selection in gantt
        _keyPressed: function (action, target, arg, e) {

            var proxy = this,
                model = this.model,
                selectingRowIndex,
                lastRowIndex,
                updatedRecords = model.updatedRecords,
                expandedRecords = proxy.getExpandedRecords(updatedRecords),
                currentSelectingRecord;

            e.stopImmediatePropagation();
            e.preventDefault();

            if (!model.allowKeyboardNavigation)
                return true;

            switch (action) {

                case "downArrow":
                    if (updatedRecords.length > 0 && model.selectedItem) {
                        //get the last row index of the ganttchart control
                        lastRowIndex = updatedRecords.length - 1;
                        if (model.selectedRowIndex != lastRowIndex) {

                            selectingRowIndex = expandedRecords.indexOf(model.selectedItem);
                            currentSelectingRecord = expandedRecords[selectingRowIndex + 1];
                            selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                            if (currentSelectingRecord && selectingRowIndex <= lastRowIndex && !proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                                proxy.selectRows(selectingRowIndex);
                                proxy.focusGanttElement();
                                proxy.updateScrollBar();
                                proxy._rowSelectedEventTrigger(model.selectedRowIndex);
                            }
                        }
                    }
                    break;

                    //select the previous row by press down arrow key
                case "upArrow":
                    if (model.selectedRowIndex !== 0 && updatedRecords.length > 0 && model.selectedItem) {

                        selectingRowIndex = expandedRecords.indexOf(model.selectedItem);
                        currentSelectingRecord = expandedRecords[selectingRowIndex - 1];
                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                            proxy.selectRows(selectingRowIndex);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(model.selectedRowIndex);
                        }
                    }
                    break;

                    //select the first row while press the Home key
                case "firstRowSelection":
                    if (updatedRecords.length > 0) {
                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, 0)) {
                            proxy.selectRows(0);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(0);
                        }
                    }
                    break;

                case "lastRowSelection":

                    if (updatedRecords.length > 0) {

                        lastRowIndex = expandedRecords.length - 1;
                        currentSelectingRecord = expandedRecords[lastRowIndex];
                        selectingRowIndex = updatedRecords.indexOf(currentSelectingRecord);

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, selectingRowIndex)) {
                            proxy.selectRows(selectingRowIndex);
                            proxy.focusGanttElement();
                            proxy.updateScrollBar();
                            proxy._rowSelectedEventTrigger(selectingRowIndex);
                        }
                    }
                    break;

                // expand the child task by press right arrow
                case "rightArrow":
                    var rowIndex = proxy.model.selectedRowIndex,
                    record = proxy.model.updatedRecords[rowIndex],
                    args = {},
                    isExpandCollapseEnabeled;
                    args.data = record;
                    args.recordIndex = rowIndex;
                    args.expanded = true;
                    if (record) {
                        if (!proxy._rowSelectingEventTrigger() && record.hasChildRecords && !record.expanded) {
                            if (rowIndex >= 0)
                                isExpandCollapseEnabeled = proxy._trigger("expanding", args);
                            if (model.enableVirtualization)
                                proxy.focusGanttElement();
                        }
                    }
                    break;
                //collapse the child task by press left arrow 
                case "leftArrow":
                    var rowIndex = proxy.model.selectedRowIndex,
                        record = proxy.model.updatedRecords[rowIndex],
                        args = {},
                        isExpandCollapseEnabeled;   
                        args.data = record;
                        args.recordIndex = rowIndex;
                        args.expanded = false;
                        if (record) {
                            if (!proxy._rowSelectingEventTrigger() && record.hasChildRecords && record.expanded) {
                                if (rowIndex >= 0)
                                    proxy._trigger("collapsing", args);
                                if (model.enableVirtualization)
                                    proxy.focusGanttElement();
                            }
                        }
                    break;
                case "deleteRecord":
                    if (model.editSettings.allowDeleting && model.selectedRowIndex >= 0) {
                        proxy._trigger("deleteRow");
                        proxy.focusGanttElement();
                    }
                    break;
                case "totalRowCollapse":
                    args = {};
                    args.requestType = "collapseAll";
                    proxy._trigger("expandAllCollapseAllRequest", args);
                    break;
                case "totalRowExpand":
                    args = {};
                    args.requestType = "expandAll";
                    proxy._trigger("expandAllCollapseAllRequest", args);
                    break;
            }

            return true;
        },

        _rowSelectingEventTrigger: function (previousIndex, recordIndex) {

            var proxy = this,
                model = proxy.model,
                args = {};
            if (model.selectionMode == "row") {
            args.previousIndex = previousIndex;
            args.recordIndex = recordIndex;
            return proxy._trigger('rowSelecting', args);
            }
        },

        _rowSelectedEventTrigger: function (index) {
            var proxy = this,
                args;
            if (proxy.model.selectionMode == "row") {
            args = {
                data: proxy.model.selectedItem,
                target: "ejGanttChart",
                recordIndex: index
            };
            proxy._trigger("rowSelected", args);
            }
        },

        _updateEditingType: function () {
            var proxy = this;
            proxy._leftResizing = false;
            proxy._allowDragging = false;
            proxy._rightResizing = false;
            proxy._progressResizing = false;
            proxy._editPredecessor = false;
        },

        //Returns the previous item properties
        _getPrevItem: function (item, index) {
            var proxy = this;
            item.left = proxy._prevItem.left;
            item.width = proxy._prevItem.width;
            item.startDate = proxy._prevItem.startDate;
            item.endDate = proxy._prevItem.endDate;
            item.duration = proxy._prevItem.duration;
            item.status = proxy._prevItem.status;
            item.progressWidth = this._getProgressWidth(item.width, item.status);
            this.refreshRow(index);
            var tempArgs = {};
            tempArgs.index = index;
            this._refreshRow(tempArgs);
        },

        //Returns the previous parent item properties
        _getParentPreviousValue: function () {
            var proxy = this, prevParent, index,
                model = proxy.model,
                parentItem,
                length = proxy._parentCollectionPreviousValues.length;
            for (var i = 0; i < length; i++) {
                prevParent = proxy._parentCollectionPreviousValues[i];
                index = prevParent.index;
                parentItem = model.updatedRecords[index];
                parentItem.left = prevParent.left;
                parentItem.width = prevParent.width;
                parentItem.startDate = prevParent.startDate;
                parentItem.endDate = prevParent.endDate;
                parentItem.duration = prevParent.duration;
                parentItem.status = prevParent.status;
                parentItem.progressWidth = this._getProgressWidth(parentItem.width, parentItem.status);
                this.refreshRow(index);
                var tempArgs = {};
                tempArgs.index = index;
                this._refreshRow(tempArgs);
            }

        },

        //handler for left resizing taskbar item
        _enableLeftResizing: function (e, item) {

            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType;
            e.target.style.cursor = "e-resize";
            $(proxy._leftResizer).addClass("e-gripper");
            $(proxy._rightResizer).addClass("e-gripper");

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                        item.left -= proxy._mousePosX;
                        item.width += proxy._mousePosX;
                }
            }
            else {
                proxy._mousePosX -= proxy.dragPosX;
                if ((item.left + 30) < (item.left + item.width) && ((item.left + proxy._mousePosX) <= (this._prevItem.left + this._prevItem.width))) {
                    item.left += proxy._mousePosX;
                    item.width -= proxy._mousePosX;
                }
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            if (scheduleHeaderType == scheduleHeaderValue.Day)
                item.width = item.width < proxy.model.perHourWidth ? proxy.model.perHourWidth : item.width;
            else if (scheduleHeaderType == scheduleHeaderValue.Hour)
                item.width = item.width < proxy.model.perMinuteWidth ? proxy.model.perMinuteWidth : item.width;
            else
                item.width = item.width < proxy.model.perDayWidth ? proxy.model.perDayWidth : item.width;
            item.progressWidth = proxy._getProgressWidth(item.width, item.status);
            /*Adjust left value according to width because of end of taskbar must be in same position while left resizing*/
            item.left = this._prevItem.left + this._prevItem.width - item.width;
            proxy._setItemPosition(item);
        },

        //handler for progressbar resizing
        _enableProgressResizing: function (e, item) {
            var proxy = this,
                diff,
                radius;
            e.target.style.cursor = "col-resize";
            $(proxy._leftResizer).addClass("e-gripper");
            $(proxy._rightResizer).addClass("e-gripper");

            if (proxy._progressResizer) {
                proxy._progressHandle = proxy._progressResizer && proxy._progressResizer.firstChild;
                proxy._progressHandleChild = proxy._progressResizer && proxy._progressResizer.childNodes[1];
            }

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.progressWidth -= proxy._mousePosX;
                }
            }
            else {
                proxy._mousePosX -= proxy.dragPosX;
                item.progressWidth += proxy._mousePosX;
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            item.progressWidth = item.progressWidth > item.width ? item.width : item.progressWidth;
            item.progressWidth = item.progressWidth < 0 ? 0 : item.progressWidth;

            diff = item.width - item.progressWidth;

            if (diff <= 4) {
                radius = 4 - diff;
            }
            else
                radius = 0;

            $(proxy._progressbarItem).css({
                "width": (item.progressWidth) + "px",
                "border-top-right-radius": radius + "px",
                 "border-bottom-right-radius": radius + "px"
            });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });

            $(proxy._progressHandle).addClass("e-progresshandle");
            $(proxy._progressHandleChild).addClass("e-progresshandleafter");
        },


        //handler for right resizing taskbar
        _enableRightResizing: function (e, item) {

            var proxy = this, model = this.model;
            e.target.style.cursor = "w-resize";

            $(proxy._leftResizer).addClass("e-gripper");
            $(proxy._rightResizer).addClass("e-gripper");

            if (proxy.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.width -= proxy._mousePosX;
                }
            } else {
                proxy._mousePosX -= proxy.dragPosX;
                item.width += proxy._mousePosX;
            }
            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }

            if (model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Day)
                item.width = item.width < proxy.model.perHourWidth ? proxy.model.perHourWidth : item.width;
            else if (model.scheduleHeaderSettings.scheduleHeaderType == ej.Gantt.ScheduleHeaderType.Hour)
                item.width = item.width < proxy.model.perMinuteWidth ? proxy.model.perMinuteWidth : item.width;
            else
                item.width = item.width < proxy.model.perDayWidth ? proxy.model.perDayWidth : item.width;
            if (!item.hasChildRecords) {
                item.progressWidth = proxy._getProgressWidth(item.width, item.status);
                $(proxy._tasknameContainer).css({ "left": (item.left) + "px", "width": (item.width) + "px" });
            }
            else
                $(proxy._manualRightResizer).css({ "left": (item.width - (parseInt(proxy._manualRightResizer.style.borderRightWidth.replace("px", "")))) + "px" });

            $(proxy._taskbarItem).css({ "left": (item.left) + "px", "width": (item.width) + "px" });
            $(proxy._progressbarItem).css({ "width": (item.progressWidth) + "px"});
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });
        },


        //Handler for dragging taskbar
        _enableDragging: function (e, item) {
            var proxy = this;
            e.target.style.cursor = "move";

            if ($(e.target.parentNode).hasClass("e-parentContainer")) {
                proxy._allowExpandCollapse = false;
            }

            if (this.dragPosX > proxy._mousePosX) {
                proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                if (item.left > 0) {
                    item.left -= proxy._mousePosX;
                }
            } else {
                proxy._mousePosX -= proxy.dragPosX;
                item.left += proxy._mousePosX;
            }

            if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                this.dragPosX = e.originalEvent.targetTouches[0].pageX;
            }
            else {
                this.dragPosX = e.originalEvent.pageX;
            }
            item.left = item.left < 0 ? 0 : item.left;

            $(proxy._taskbarItem).css({ "left": (item.left) + "px" });
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._leftResizer).css({ "left": (item.left + 2) + "px" });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            $(proxy._tasknameContainer).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });
        },


        //Append tooltip while editing taskbar
        _appendTooltip: function (target, index) {

            var proxy = this, tooltipElement, tooltiptable, tooltipbody,
                $target = $(target),
                model = this.model,
                item = proxy.model.currentViewData[index],
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                predecessorEditingTexts = proxy.model.predecessorEditingTexts;
            if (item != null) {
               
                var div = $target[0];
                if ($($target[0]).hasClass("e-progressbarresizer-right")) {
                    div = $target.closest(".e-childContainer")[0];
                }

                if ($(div).hasClass("e-parentContainer") || $(div).hasClass("e-childContainer")) {
                    proxy._editingContainer = div;
                    proxy._leftResizer = (proxy._editingContainer).querySelector(".e-connectorpoint-left");
                    proxy._taskbarItem = (proxy._editingContainer).querySelector(".e-taskbarresizer-left");
                    proxy._progressbarItem = (proxy._editingContainer).querySelector(".e-gantt-childtaskbar");
                    proxy._progressResizer = (proxy._editingContainer).querySelector(".e-gantt-childtaskbar-progress");
                    proxy._rightResizer = (proxy._editingContainer).querySelector(".e-progressbarresizer-right");
                }

                //Don't need to display the drag tooltip in Parent Taskbar
                if (this.model.enableTaskbarDragTooltip && (!$target.hasClass('e-parentContainer'))) {

                    if (this._progressResizing == true) {

                        proxy._$ganttChartContainer[0].style.cursor = "col-resize";

                        tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "margin-top": "0px" }, { 'cellspacing': '2px', 'cellpadding': '2px' });
                        tooltipbody = ej.buildTag("tbody", "", {}, {});
                        tooltipbody[0].innerHTML = "<tr><td>" + columnHeaderTexts["status"] + " : " + item.status + "%</td></tr>";
                        tooltiptable.append(tooltipbody);
                        if (proxy.model.progressbarTooltipTemplate) {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "", "",
                              {
                                  'position': 'absolute',
                                  'z-index': proxy._getMaxZIndex() + 1
                              }, {});
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                            //proxy.tooltipState = "editingTemplateID";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "progressbarTooltipTemplate"](item), {}, {});
                            proxy._progressBarTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                        }
                        else if (proxy.model.progressbarTooltipTemplateId) {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "", "",
                                    {
                                        'position': 'absolute',
                                        'z-index': proxy._getMaxZIndex() + 1
                                    }, {});
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                            //proxy.tooltipState = "editingTemplate";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "progressbarTooltipTemplate"](item), {}, {});
                            proxy._progressBarTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                        }
                        else {
                            proxy._progressBarTooltipID = ej.buildTag("div.e-progressbartooltip#progressbartooltip" + proxy._id + "",
                                tooltiptable,
                                {
                                    'position': 'absolute',
                                    'z-index': proxy._getMaxZIndex() + 1
                                }, { 'onselectstart': 'return false' });
                            proxy.model.cssClass && proxy._progressBarTooltipID.addClass(proxy.model.cssClass);
                        }
                        if (proxy._progressBarTooltipID) {
                            $(document.body).append(proxy._progressBarTooltipID);
                            proxy._updateTooltipPosition(proxy._progressBarTooltipID, proxy._currMousePosX, proxy._currMousePosY, true);
                        }
                    }
                    // for apend tooltip for connector line
                    else if (this._editPredecessor === true && proxy.model.enablePredecessorEditing) {
                        var predecessorText = model.predecessorText;
                        if (proxy._predecessorTooltip === null) {
                            proxy._predecessorTooltip = ej.buildTag("div.e-tooltipganttpredecessor#predecessortooltip" + proxy._id + "",
                                      "",
                                      {
                                          "top": (proxy._currMousePosY + 10) + "px",
                                          "left": (proxy._currMousePosX + 10) + "px",
                                          'position': 'absolute',
                                          'z-index': proxy._getMaxZIndex() + 1
                                      }, { 'onselectstart': 'return false' });
                            proxy.model.cssClass && proxy._predecessorTooltip.addClass(proxy.model.cssClass);
                            tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "margin-top": "0px" }, { 'cellspacing': '2px', 'cellpadding': '2px' });
                            tooltipbody = ej.buildTag("tbody", "", {}, {});
                            var innerHtml = "<tr><td class='e-predecessor-false'></td><td >" + predecessorEditingTexts["fromText"] + ":</td><td class='e-tooltiptaskname'>" + item.taskName + "</td><td>" + predecessorText[proxy._prevItem.predecessorTarget] + "</td> </tr>" +
                                "<tr><td></td><td>" + predecessorEditingTexts["toText"] + ":</td><td class='e-tooltiptaskname'></td><td></td></tr>";
                            $(tooltipbody).html(innerHtml);
                            tooltiptable.append(tooltipbody);
                            proxy._predecessorTooltip.append(tooltiptable);
                            $(document.body).append(proxy._predecessorTooltip);
                            proxy._updateTooltipPosition(proxy._predecessorTooltip, proxy._currMousePosX, proxy._currMousePosY);
                            //   proxy._$bodyContent.append(proxy._predecessorTooltip);
                        }
                    }
                    else if (proxy._leftResizing == true || proxy._rightResizing == true || proxy._allowDragging == true)
                    {
                    if (proxy._leftResizing == true) {
                        proxy._$ganttChartContainer[0].style.cursor = "e-resize";

                        tooltipElement = {
                            ttipstartDate: this._getFormatedDate(item.startDate, model.dateFormat, model.locale),
                            ttipduration: item.duration,
                            ttipdurationunit: item.durationUnit
                        };
                    } else if (proxy._rightResizing == true) {

                        proxy._$ganttChartContainer[0].style.cursor = "w-resize";

                        tooltipElement = {
                            ttipendDate: this._getFormatedDate(item.endDate, model.dateFormat, model.locale),
                            ttipduration: item.duration,
                            ttipdurationunit: item.durationUnit
                        };
                    } else if (proxy._allowDragging == true) {
                        proxy._$ganttChartContainer[0].style.cursor = "move";

                        tooltipElement = {
                            ttipstartDate: this._getFormatedDate(item.startDate, model.dateFormat, model.locale),
                            ttipendDate: this._getFormatedDate(item.endDate, model.dateFormat, model.locale),
                        };
                    }


                    tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "margin-top": "0px" }, { 'cellspacing': '2px', 'cellpadding': '2px' });

                    if (proxy.model.taskbarEditingTooltipTemplate) {
                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", "",
                           {
                               'position': 'absolute',
                               'z-index': proxy._getMaxZIndex() + 1
                           }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "editingTemplateID";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](item), {}, {});
                        proxy._taskbarEditingTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                    }
                    else if (proxy.model.taskbarEditingTooltipTemplateId) {
                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", "",
                                {
                                    'position': 'absolute',
                                    'z-index': proxy._getMaxZIndex() + 1
                                }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                        proxy.tooltipState = "editingTemplate";
                        var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](item), {}, {});
                        proxy._taskbarEditingTooltipID[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";
                    }

                    else {
                        proxy.tooltipState = "";
                        if (tooltipElement) {
                            tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "editingTooltipTemplate"](tooltipElement), {}, {});
                            tooltiptable.append(tooltipbody);
                        }

                        proxy._taskbarEditingTooltipID = ej.buildTag("div.e-editingtooltip#editingtooltip" + proxy._id + "", tooltiptable,
                            {
                                'position': 'absolute',
                                'z-index': proxy._getMaxZIndex() + 1
                            }, {});
                        proxy.model.cssClass && proxy._taskbarEditingTooltipID.addClass(proxy.model.cssClass);
                    }
                    if (proxy._taskbarEditingTooltipID) {
                        $(document.body).append(proxy._taskbarEditingTooltipID);
                        proxy._updateTooltipPosition(proxy._taskbarEditingTooltipID, proxy._currMousePosX, proxy._currMousePosY, true);
                    }
                }
                }
            }
        },

        _setItemPosition: function (item) {
            var proxy = this;
            $(proxy._leftResizer).css({ "left": (item.left + 2) + "px" });
            $(proxy._rightResizer).css({ "left": (item.left + item.width - proxy._resizerRightAdjust) + "px" });
            $(proxy._taskbarItem).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });
            $(proxy._progressbarItem).css({
                "width": (item.progressWidth) + "px"
            });
            $(proxy._progressResizer).css({ "left": (item.left + item.progressWidth - 10) + "px" });
            $(proxy._tasknameContainer).css({
                "left": (item.left) + "px",
                "width": (item.width) + "px"
            });

            $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
            $(proxy._rightConnectorPoint).css({ "left": (item.left + item.width) + "px" });


        },

        //Handles the mousemove after mousedown event
        _updateOnmouseMove: function (e) {

            var proxy = this, args = {}, posy,
                $target = (proxy._editingTarget) ? proxy._editingTarget : null,
                $ganttGridRows = proxy.getGanttChartRows(),
                row = ($target) ? $target.closest('tr.e-ganttrowcell') : null,
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem,
                div = ($target) ? $target[0].parentNode : null;
            proxy._newXYPos = true;

            if ($(div).hasClass("e-progressbarresizer-right")) {
                div = div.parentNode;
            }
            else if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer")[0];
            }
            else if ($(div).hasClass("e-progressbarhandler")) {
                div = $target.closest(".e-childContainer")[0];
            }
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container")[0];
            }
            if (item != null) {
                proxy._trigger("cancelEditCell");
                args.editingFields = {
                    startdate: item.startDate,
                    enddate: item.endDate,
                    progress: item.status,
                    duration: item.duration,
                    durationunit: item.durationUnit
                };
                args.rowData = { rowData: item };

                proxy._taskbarEditing(args);

                if (!args.cancel) {

                    if (!e) e = window.event;

                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                        e.originalEvent.pageX = e.originalEvent.clientX;
                        e.originalEvent.pageY = e.originalEvent.clientY;
                    }

                    if (e.originalEvent.pageX || e.originalEvent.pageY) {
                        proxy._mousePosX = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;
                    } else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        proxy._mousePosX = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;
                    }
                    else if (e.originalEvent.touches[0].pageX || e.originalEvent.touches[0].pageY) {
                        proxy._mousePosX = e.originalEvent.targetTouches[0].pageX;
                        posy = e.originalEvent.targetTouches[0].pageY;
                    }

                    if ($target.hasClass("e-gantt-milestone") || $(div).hasClass("e-gantt-milestone")) {
                        if ($(row).hasClass("e-editmode")) {
                            this._editMilestone(e);
                        }
                    } else {

                        if ($(div).hasClass("e-childContainer")) {
                            proxy._editingContainer = div;
                            proxy._leftResizer = proxy._editingContainer.querySelector(".e-taskbarresizer-left");
                            proxy._taskbarItem = proxy._editingContainer.querySelector(".e-gantt-childtaskbar");
                            proxy._progressbarItem = proxy._editingContainer.querySelector(".e-gantt-childtaskbar-progress");
                            proxy._progressResizer = proxy._editingContainer.querySelector(".e-progressbarresizer-right");
                            proxy._rightResizer = proxy._editingContainer.querySelector(".e-taskbarresizer-right");
                            if (proxy.model.predecessorMapping && proxy.model.enablePredecessorEditing) {
                                proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left"); 
                                proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                                if (proxy.model.allowGanttChartEditing) {
                                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                                }
                            }

                        }
                        else if (($(div).hasClass("e-parentContainer")) && !item.isAutoSchedule) {
                            proxy._editingContainer = div;
                            proxy._taskbarItem = proxy._editingContainer.querySelector(".e-gantt-manualparenttaskbar");
                            proxy._rightResizer = proxy._editingContainer.querySelector(".e-taskbarresizer-right");
                            proxy._manualRightResizer = proxy._editingContainer.querySelector(".e-gantt-manualparenttaskbar-right");
                        }

                        if ($(row).hasClass("e-editmode") &&
                            (($($target[0]).closest("e-gantt-manualparenttaskbar")) || $(div).hasClass("e-gantt-milestone-container") || $(div).hasClass("e-childContainer"))) {

                            if (proxy._leftResizing == true) {
                                proxy._enableLeftResizing(e, item);
                                proxy._updateEditedItem(item, "leftResizing");

                            } else if (proxy._progressResizing == true
                                && proxy.model.enableProgressBarResizing
                                && proxy.model.progressMapping) {
                                //Remove the progress bar status while resizing the progress bar status
                                
                                if (proxy._editingTarget.hasClass("e-progresshandlerafter-element") || proxy._editingTarget.hasClass("e-progressbarhandler e-progresshandle")
                                    || proxy._editingTarget.hasClass("e-progresshandler-element") || proxy._editingTarget.hasClass("e-progressbarresizer-right")) {
                                    proxy._editingTarget.prev(".e-gantt-childtaskbar").find(".e-tasklabel").text("");
                                }
                                proxy._enableProgressResizing(e, item);
                                proxy._updateEditedItem(item, "progressResizing");

                            } else if (proxy._rightResizing == true) {
                                proxy._enableRightResizing(e, item);
                                proxy._updateEditedItem(item, "rightResizing");

                            } else if (proxy._allowDragging == true) {
                                proxy._enableDragging(e, item);
                                proxy._updateEditedItem(item, "dragging");
                            }

                            //for predecessor , draw false line move the tooltip
                            else if (proxy._editPredecessor == true) {
                                //if ($(e.target).hasClass('e-connectortouchpoint')) {
                                //    e.target = $target.parent();
                                //}
                                proxy._drawFalseLine(e, item);
                            }
                        }
                    }
                    proxy._clearTooltip();
                    proxy._appendTooltip($target, recordIndexr);
                }
            }
            if (ej.isNullOrUndefined(e.pageX) && e.type == "touchmove" && proxy._predecessorTooltip) {
                var x2, y2;
                if (ej.isNullOrUndefined(e.pageX)) {
                    x2 = e.originalEvent.changedTouches[0].pageX;
                    y2 = e.originalEvent.changedTouches[0].pageY;
                    e.target = document.elementFromPoint(x2, y2);
                }
                else {
                    x2 = e.pageX;
                    y2 = e.pageY;
                }
                if ($(e.target).hasClass('e-connectorpoint-left') || $(e.target).hasClass('e-connectortouchpoint')) {
                    proxy._dragLeftOver(e);
                } else if ($(e.target).hasClass('e-connectorpoint-right')) {
                    proxy._dragRightOver(e);
                } else {
                    proxy._mouseLeave();
                    $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                    $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                }
            }
        },


        //Handler for milestone editing
        _editMilestone: function (e) {

            var proxy = this,
                $target = proxy._editingTarget,
                div = ($target.hasClass("e-milestone-top") || $target.hasClass("e-milestone-bottom")) ? $target[0].parentNode: $target.closest(".e-gantt-milestone"),
                $ganttGridRows = proxy.getGanttChartRows(),
                row = $target.closest('tr.e-ganttrowcell'),
                recordIndexr = $ganttGridRows.index(row),
                item = proxy._editingItem;

            if (item != null) {

                if (!e) e = window.event;
                if (e.originalEvent.pageX || e.originalEvent.pageY) {
                    proxy._mousePosX = e.originalEvent.pageX;
                } else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                    proxy._mousePosX = e.originalEvent.clientX + document.body.scrollLeft
                        + document.documentElement.scrollLeft;
                }
                else if (e.originalEvent.touches[0].pageX || e.originalEvent.touches[0].pageY) {
                    proxy._mousePosX = e.originalEvent.targetTouches[0].pageX;
                }

                e.target.style.cursor = "move";
                if (proxy.dragPosX > proxy._mousePosX) {
                    proxy._mousePosX = proxy.dragPosX - proxy._mousePosX;
                    if (item.left > 0) {
                        item.left -= proxy._mousePosX;
                    }
                } else {
                    proxy._mousePosX -= proxy.dragPosX;
                    item.left += proxy._mousePosX;
                }
                if (ej.isNullOrUndefined(e.originalEvent.pageX)) {
                    this.dragPosX = e.originalEvent.targetTouches[0].pageX;
                }
                else {
                    this.dragPosX = e.originalEvent.pageX;
                }
                item.left = item.left < 0 ? 0 : item.left;

                $(div).css({ "left": (item.left) + "px" });

                $(proxy._leftConnectorPoint).css({ "left": (item.left - proxy._connectorPointWidth) + "px" });
                $(proxy._rightConnectorPoint).css({ "left": (item.left + proxy._milesStoneWidth) + "px" });

                proxy._updateEditedItem(item, "dragging");
                proxy._appendTooltip($target, recordIndexr);
            }
        },


        //Updates the edited item's values
        _updateEditedItem: function (ganttRecord, reason) {

            var proxy = this,
                model = proxy.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                durationUnitValue = ej.Gantt.DurationUnit,
                projectStartDate = ganttRecord._getFormatedDate(model.projectStartDate, model.dateFormat, model.locale),
                projectStartDate = ganttRecord._getDateFromFormat(projectStartDate, model.dateFormat, model.locale),
                projectStartDateHours = ganttRecord.startDate.getHours(),
                projectStartDateMinutes = ganttRecord.startDate.getMinutes(),

               remainDays, day, remainDaysInDecimal, perDayHourUnit, offset, rem, startDate, endDate;

            switch (reason) {

                case 'dragging':
                    remainDays = ganttRecord.left % model.perDayWidth;
                    day = (ganttRecord.left - remainDays) / model.perDayWidth;
                    remainDaysInDecimal = remainDays / model.perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = model.secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal != 1) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, model.workingTimeRanges, scheduleHeaderType);                                                           
                    ganttRecord.startDate = new Date(projectStartDate);

                    var editArgs = {};
                    editArgs.startDate = ganttRecord.startDate;
                    editArgs.duration = ganttRecord.duration;
                    editArgs.durationUnit = ganttRecord.durationUnit;
                    editArgs.record = ganttRecord;

                    proxy._calculateEndDate(editArgs);
                    ganttRecord.endDate = proxy._currentEditedRecord.endDate;
                    //update on dataSource
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;

                    break;

                case 'leftResizing':
                    var editMode = "Resizing";
                    remainDays = ganttRecord.left % model.perDayWidth,                        
                    day = (ganttRecord.left - remainDays) / model.perDayWidth;
                    remainDaysInDecimal = remainDays / model.perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }

                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = model.secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, model.workingTimeRanges, scheduleHeaderType);
                    ganttRecord.startDate = new Date(projectStartDate);
                    if (ganttRecord.startDate.getTime() == ganttRecord.endDate.getTime()
                        && ej.isNullOrUndefined(ganttRecord.isMilestone) && ganttRecord.isMilestone == false && ganttRecord.duration == 0) {
                        ganttRecord.duration = 1;
                    }
                    var editArgs = {};
                    editArgs.startDate = ganttRecord.startDate;
                    editArgs.endDate = ganttRecord.endDate;
                    editArgs.durationUnit = ganttRecord.durationUnit;
                    editArgs.record = ganttRecord;

                    proxy._calculateDuration(editArgs);
                    ganttRecord.duration = proxy._currentEditedRecord.duration;
                    //update on dataSource
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    if (model.durationMapping)
                        ganttRecord.item[model.durationMapping] = ganttRecord.duration;
                    break;

                case 'rightResizing':
                    var editMode = "Resizing";
                    if (scheduleHeaderType == scheduleHeaderValue.Day || scheduleHeaderType == scheduleHeaderValue.Hour) {
                        var tempStartDate = new Date(ganttRecord.startDate),
                            tempNewStartDate = new Date(ganttRecord.startDate), timeDiff, taskTempWidth;
                        tempNewStartDate.setHours(0, 0, 0, 0);
                        timeDiff = tempStartDate.getTime() - tempNewStartDate.getTime();
                        if (timeDiff > 0)
                            taskTempWidth = ganttRecord.width + ((timeDiff / (1000 * 60 * 60 * 24)) * model.perDayWidth);
                        else
                            taskTempWidth = ganttRecord.width;
                        remainDays = taskTempWidth % model.perDayWidth;
                        day = (taskTempWidth - remainDays) / model.perDayWidth;
                        perDayHourUnit = 24;
                    }
                    else {
                        remainDays = ganttRecord.width % model.perDayWidth;
                        day = (ganttRecord.width - remainDays) / model.perDayWidth;
                        perDayHourUnit = model.secondsPerDay / 3600;
                    }

                    remainDaysInDecimal = remainDays / model.perDayWidth,
                    startDate = new Date(ganttRecord.startDate);
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (scheduleHeaderType == scheduleHeaderValue.Week || scheduleHeaderType == scheduleHeaderValue.Month || scheduleHeaderType == scheduleHeaderValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                        } else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                        }
                    }

                    /*Calculating the remaining day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    endDate = ganttRecord._endDateUpdate(startDate, day - 1, inMinutes, model.workingTimeRanges, scheduleHeaderType);
                    ganttRecord.endDate = new Date(endDate);
                    var editArgs = {};
                        editArgs.startDate = startDate;
                        editArgs.endDate = endDate;
                        editArgs.durationUnit = ganttRecord.durationUnit;
                        editArgs.record = ganttRecord;
 
                        proxy._calculateDuration(editArgs);
                        ganttRecord.duration = proxy._currentEditedRecord.duration;

                    //update on datasource
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                    if (model.durationMapping)
                        ganttRecord.item[model.durationMapping] = ganttRecord.duration;
                    break;

                case 'progressResizing':
                    ganttRecord.status = proxy._getProgressPercent(ganttRecord.width, ganttRecord.progressWidth);
                    if (model.progressMapping)
                        ganttRecord.item[model.progressMapping] = ganttRecord.status;
                    break;
            }
        },

        _calculateEndDate: function (args) {
            var proxy = this;
            return proxy._trigger("calculateEndDate", args);
        },
        _calculateDuration: function (args) {
            var proxy = this;
            return proxy._trigger("calculateDuration", args);
        },

        //false line implementation 
        _drawFalseLine: function (e, item) {

            var proxy = this,
                pageX = e.pageX,
                pageY = e.pageY,
                x1 = proxy._connectorPointX,
                y1 = proxy._connectorPointY,
                x2, y2;

            if (ej.isNullOrUndefined(e.pageX)) {
                x2 = e.originalEvent.changedTouches[0].pageX - proxy._$bodyContent.offset().left,
                y2 = e.originalEvent.changedTouches[0].pageY - proxy._$bodyContent.offset().top;
                pageX = Math.round(e.originalEvent.changedTouches[0].pageX);
                pageY = Math.round(e.originalEvent.changedTouches[0].pageY);
            }
            else{
                x2 = e.pageX - proxy._$bodyContent.offset().left,
                y2 = e.pageY - proxy._$bodyContent.offset().top;

            }
              
            //var sy=proxy._$bodyContainer.ejScroller("option", "scrollTop");
            //var sx = proxy._$bodyContainer.ejScroller("option", "scrollLeft");

            var length = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
            var angle = Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
            var transform = 'rotate(' + angle + 'deg)';

            proxy._falseLine && proxy._falseLine.remove();

                proxy._falseLine = ej.buildTag("div.e-gantt-falseLine#ganttfalseline" + proxy._id, "", {}, {});
                proxy._falseLine.css({
                    'transform-origin': '0% 100%',
                    'right':'auto',
                    'position': 'absolute',
                    'transform': transform,
                    '-ms-transform':transform, /* IE 9 */
                    '-moz-transform':transform, /* Firefox */
                    '-webkit-transform':transform, /* Safari and Chrome */
                    '-o-transform':transform, /* Opera */
                    'border-top-width': '2px',
                    'border-top-style': 'dashed',
                    'z-index': '5'
                }).width(length - 3).offset({ left: x1, top: y1 });

                if (!(ej.browserInfo().name == "msie" && ej.browserInfo().version < 9)) {
                    proxy._$bodyContent.append(proxy._falseLine);
                }

                //Change the position of predecesspr tooltip
                proxy._updateTooltipPosition(proxy._predecessorTooltip, pageX, pageY);
        },

        _mouseLeave: function () {

            var proxy = this;
            $(".e-progressbarresizer-right").css({ "background-image": "none" });
            window.clearTimeout(proxy._tooltipTimer);
            proxy._clearTooltip();
            

            if (this._mouseDown == false && proxy._newXYPos) {
                $(proxy._leftResizerGripper).removeClass("e-gripper");
                $(proxy._rightResizerGripper).removeClass("e-gripper");

                if (proxy.model.progressMapping) {
                    $(proxy._progressHandle).removeClass("e-progresshandle");
                    $(proxy._progressHandleChild).removeClass("e-progresshandleafter");
                }

                if (proxy.model.predecessorMapping && proxy.model.enablePredecessorEditing) {

                    $(proxy._leftConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');
                    $(proxy._rightConnectorPoint).removeClass('e-connectorpoint-hover').removeClass('e-gantt-manualparenttaskbar-connectorpoint-hover');

                    
                    proxy._leftConnectorPoint = null;
                    proxy._rightConnectorPoint = null;
                }
            }
            else if (proxy._mouseDown && proxy._falseLine) {
                
                if (proxy.model.allowGanttChartEditing == true && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                    proxy._removeEditingElements();
                }
            }
        },

        _getMaxZIndex: function () {
            var divs = document.getElementsByTagName('div'),
                highest = 0,
                divLength = divs.length;
            if (this._maxZIndex == 0) {
                for (var i = 0; i < divLength; i++) {
                    var zindex = divs[i].style.zIndex;
                    if (zindex > highest && zindex != "auto") {
                        highest = zindex;
                    }
                }
                this._maxZIndex = highest;
            }
            return this._maxZIndex;
        },

        _getOffsetRect: function (elem) {
            var box = elem.getBoundingClientRect(),
                body = document.body,
                docElem = document.documentElement,
                scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
                scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
                clientTop = docElem.clientTop || body.clientTop || 0,
                clientLeft = docElem.clientLeft || body.clientLeft || 0,
                top = box.top + scrollTop - clientTop,
                left = box.left + scrollLeft - clientLeft;
            return { top: Math.round(top), left: Math.round(left) }
        },
        /* edge detection for tooltip in ganttchart*/
        _updateTooltipPosition: function (tooltip, posx, posy, isEditingTooltip) {
            if (tooltip && tooltip.length > 0) {
                var proxy = this,
                    containerBoundary = proxy._getOffsetRect(proxy._$bodyContainer[0]),
                    topEnd = containerBoundary.top + proxy._$bodyContainer.height(),
                    leftEnd = containerBoundary.left + proxy._$bodyContainer.width(),
                    rowHeight = proxy.model.rowHeight, pos = 0;
                //Left update
                if (((posx + tooltip.width() + 30) > leftEnd)) {
                    pos = posx - tooltip.width() - 30;//while tooltip rendered outdide of Gantt chart
                    tooltip.css('left', ((pos) + 'px'));
                }
                else {
                    if (!isEditingTooltip)
                        tooltip.css('left', (posx + 15) + 'px');
                    else
                        tooltip.css('left', (posx) + 'px');
                }
                //Top update
                if (isEditingTooltip || ((posy + tooltip.height() + 30) > topEnd)) {
                    if (!isEditingTooltip)
                        pos = posy - tooltip.height() - 30;//while tooltip rendered outdide of Gantt chart
                    else
                        pos = posy - tooltip.height() - rowHeight;

                    tooltip.css('top', ((pos) + 'px'));
                } else {
                    tooltip.css('top', (posy + 10) + 'px');
                }
            }
        },

        _mouseHover: function (e) {

            
            var $target = $(e.target), proxy = this,
                posx = 0,
                posy = 0,
                $ganttChartRows = proxy.getGanttChartRows(),
                row = $target.closest('tr.e-ganttrowcell'),
                div = $target[0].parentNode,
                progressHandler,
                recordIndexr = $ganttChartRows.index(row),
                item = proxy.model.currentViewData[recordIndexr],
                tooltipElement, tooltiptable, tooltipbody;
            if (e.target.className == "e-parentContainer" || e.target.className == "e-gantt-milestone-container" || e.target.className == "e-childContainer")
            {
                return true;
            }

            if ($(div).hasClass("e-gantt-childtaskbar-progress")) {
                div = $(div).closest("div.e-childContainer")[0];
            }
            else if ($target.hasClass("e-tasklabel"))
                div = $target.closest(".e-childContainer")[0];
            else {
                div = $(div).closest("div.e-childContainer,div.e-parentContainer,.e-gantt-milestone,div.e-gantt-milestone-container")[0];
            }

          
            //clearing rendered tooltips in Gantt
            proxy._clearTooltip();
            
            if (!proxy._newXYPos) {
                proxy._newXYPos = true;
                proxy._mouseLeave();
            }
            if (proxy._rightResizing == false && proxy._leftResizing == false &&
                proxy._progressResizing == false && proxy._mouseDown == false) {

                if (proxy.model.allowGanttChartEditing && proxy.model.readOnly == false && ($target.is('.e-gantt-childtaskbar,.e-tasklabel, .e-gantt-manualparenttaskbar') || $target.closest(".e-gantt-childtaskbar").length)) {
                    e.target.style.cursor = "move";
                }


                if (e.type == "mouseenter" || e.type == "mousemove" || e.type == "touchstart") {

                    if (!e) e = window.event;
                    if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                        e.originalEvent.pageX = e.originalEvent.clientX;
                        e.originalEvent.pageY = e.originalEvent.clientY;
                    }

                    if (e.originalEvent.pageX || e.originalEvent.pageY) {

                        posx = e.originalEvent.pageX;
                        posy = e.originalEvent.pageY;

                    }
                    else if (e.originalEvent.clientX || e.originalEvent.clientY) {
                        posx = e.originalEvent.clientX + document.body.scrollLeft
                            + document.documentElement.scrollLeft;
                        posy = e.originalEvent.clientY + document.body.scrollTop
                            + document.documentElement.scrollTop;

                    }
                    else if (e.originalEvent && e.originalEvent.changedTouches
                        && e.originalEvent.changedTouches.length > 0) {
                        posx = e.originalEvent.changedTouches[0].pageX;
                        posy = e.originalEvent.changedTouches[0].pageY;
                    }
                    proxy._posX1 = posx;
                    proxy._posY1 = posy;
                  
                    if ($(div).hasClass("e-childContainer") && proxy.model.allowGanttChartEditing && proxy.model.readOnly == false) {
                        proxy._leftResizerGripper = div.querySelector(".e-taskbarresizer-left"); // New div is added for drag points so other elemnts are changed 
                        proxy._rightResizerGripper = div.querySelector(".e-taskbarresizer-right");
                        progressHandler = div.querySelector(".e-progressbarresizer-right");
                        proxy._progressHandle = progressHandler && progressHandler.firstChild;
                        proxy._progressHandleChild = progressHandler && progressHandler.childNodes[1];

                        $(proxy._leftResizerGripper).addClass("e-gripper");
                        $(proxy._rightResizerGripper).addClass("e-gripper");

                        if (proxy.model.progressMapping && proxy.model.enableProgressBarResizing) {
                            $(proxy._progressHandle).addClass("e-progresshandle");
                            $(proxy._progressHandleChild).addClass("e-progresshandleafter");
                        }
                    }

                    //Before Mouse Down  , Apply style for drag points in child cotainer and miles stone container
                    if (($(div).hasClass("e-childContainer") || $(div).hasClass("e-parentContainer")) && proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {

                        proxy._leftConnectorPoint = div.querySelector(".e-connectorpoint-left");
                        proxy._rightConnectorPoint = div.querySelector(".e-connectorpoint-right");
                        $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                        if ($(div).hasClass("e-parentContainer") && !item.isAutoSchedule) {                            
                            $(proxy._leftConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                            $(proxy._rightConnectorPoint).addClass("e-gantt-manualparenttaskbar-connectorpoint-hover");
                        }
                    }
                    else if (($(div).hasClass("e-gantt-milestone") || $(div).hasClass("e-gantt-milestone-container")) && proxy.model.predecessorMapping && proxy.model.allowGanttChartEditing && proxy.model.enablePredecessorEditing && proxy.model.readOnly == false) {
                        var milesStoneContainer = div.parentNode;
                        proxy._leftConnectorPoint = milesStoneContainer.querySelector(".e-connectorpoint-left");
                        proxy._rightConnectorPoint = milesStoneContainer.querySelector(".e-connectorpoint-right");
                        $(proxy._leftConnectorPoint).addClass("e-connectorpoint-hover");
                        $(proxy._rightConnectorPoint).addClass("e-connectorpoint-hover");
                    }


                    if (item && proxy.model.enableTaskbarTooltip && !ej.isTouchDevice() && !$($target).hasClass("e-connectorpoint-hover")) {
                        proxy._predecessorTooltip && proxy._predecessorTooltip.remove();
                        proxy._predecessorTooltip = null;

                        if (($($target).hasClass("e-gantt-parenttaskbar-innerdiv") || $($target[0].parentNode).hasClass("e-gantt-parenttaskbar-innerdiv")) && !item.isAutoSchedule) {
                            tooltipElement = {
                                ttipscheduleStartDate: this._getFormatedDate(item.manualStartDate, this.model.dateFormat, this.model.locale),
                                ttipscheduleEndDate: this._getFormatedDate(item.manualEndDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.manualDuration,
                                ttipprogress: item.status.toString(),
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit
                            };
                        }
                        else if ($($target).hasClass("e-gantt-manualparenttaskbar") || $($target).hasClass("e-gantt-manualparenttaskbar-left") || $($target).hasClass("e-gantt-manualparenttaskbar-right") && !item.isAutoSchedule) {
                            tooltipElement = {
                                ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                                ttipsubtaskStartDate: this._getFormatedDate(item.manualStartDate, this.model.dateFormat, this.model.locale),
                                ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                                ttipsubtaskEndDate: this._getFormatedDate(item.manualEndDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.duration,
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit

                            };
                        }
                        else {
                            tooltipElement = {
                                ttipstartDate: this._getFormatedDate(item.startDate, this.model.dateFormat, this.model.locale),
                                ttipendDate: this._getFormatedDate(item.endDate, this.model.dateFormat, this.model.locale),
                                ttipduration: item.duration,
                                ttipprogress: item.status.toString(),
                                ttiptaskname: item.taskName,
                                ttipdurationunit: item.durationUnit
                            };
                        }

                        tooltiptable = ej.buildTag("table.e-tooltiptable", "", { "margin-top": "0px" }, { 'cellspacing': '5' });
                      

                        if (!proxy.model.tooltipTemplate && !proxy.model.tooltipTemplateId) {
                            proxy.tooltipState = "";
                            tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](tooltipElement), {}, {});
                            tooltiptable.append(tooltipbody);
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", tooltiptable,
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy._mouseHoverTooltip.innerHTML = "<table>" + tooltiptable[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        else if (proxy.model.tooltipTemplate) {
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "","",
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy.tooltipState = "Template";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                            proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        else if (proxy.model.tooltipTemplateId) {
                            proxy._mouseHoverTooltip = ej.buildTag("div.e-tooltipgantt#tooltipgantt" + proxy._id + "", "",
                                { 'position': 'absolute', 'z-index': proxy._getMaxZIndex() + 1, 'border-radius': '5px' }, {});
                            proxy.model.cssClass && proxy._mouseHoverTooltip.addClass(proxy.model.cssClass);
                            proxy.tooltipState = "TemplateID";
                            var tooltipbody = ej.buildTag("tbody", $.render[proxy._id + "tooltipTemplate"](item), {}, {});
                            proxy._mouseHoverTooltip[0].innerHTML = "<table>" + tooltipbody[0].innerHTML + "</table>";

                            //Providing a time delay to render the tooltip to improve UI
                            proxy._tooltipTimer = setTimeout(function () {
                                $(document.body).append(proxy._mouseHoverTooltip);
                                proxy._updateTooltipPosition(proxy._mouseHoverTooltip, posx, posy);
                            }, 700);
                        }
                        $(proxy._mouseHoverTooltip).addClass("e-customTooltip");
                    }
                }
            }
        },
        
        _createEditingTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                durationUnitTexts = proxy.model.durationUnitTexts,
                editingTemplateId = proxy.model.taskbarEditingTooltipTemplateId,
                editingTemplate = proxy.model.taskbarEditingTooltipTemplate,
                helpers = {};
            helpers["_" + proxy._id + "getStartDate"] = proxy._tooltipStartDate;
            helpers["_" + proxy._id + "getEndDate"] = proxy._tooltipEndDate;
            helpers["_" + proxy._id + "getTaskName"] = proxy._tooltipTaskName;
            helpers["_" + proxy._id + "getProgress"] = proxy._tooltipProgress;
            helpers["_" + proxy._id + "checkDuration"] = proxy._checkDuration;
            helpers["_" + proxy._id + "getDuration"] = $.proxy(proxy._tooltipDuration, proxy);

            $.views.helpers(helpers);

            
            if (editingTemplateId) {
                var parentTr = $("#" + editingTemplateId)[0].innerHTML;
            }
            else if (editingTemplate) {
                var parentTr = editingTemplate;
            }
            else {                
                parentTr = "{{if ~_" + proxy._id + "getTaskName()}}" +
                    "<tr><td class='e-tooltiptaskname' style='width:40px;text-align:left;' colspan='3';>{{:ttiptaskname}}</td></tr>{{/if}}" +                    

                    "{{if ~_" + proxy._id + "getStartDate()}}" +
                    "<tr><td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["startDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipstartDate}}</td></tr>{{/if}}" +                    

                    "{{if ~_" + proxy._id + "getEndDate()}}" +
                    "<tr><td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["endDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipendDate}}</td></tr>{{/if}}" +                    

                    "{{if ~_" + proxy._id + "checkDuration()}}" +
                    "<tr><td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["duration"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:~_" + proxy._id + "getDuration(#data)}}</td></tr>{{/if}}" +                    

                    "{{if ~_" + proxy._id + "getProgress()}}" +
                    "<tr><td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["status"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipprogress}}%</td></tr>{{/if}}";                
            }

            var templates = {};
            templates[proxy._id + "editingTooltipTemplate"] = parentTr;
            $.templates(templates);
        },

        _createProgressbarTooltipTemplate: function () {
            var proxy = this,
                  templateId = proxy.model.progressbarTooltipTemplateId,
            template = proxy.model.progressbarTooltipTemplate;

            if (templateId) {
                var parentTr = $("#" + proxy.model.progressbarTooltipTemplateId)[0].innerHTML;
            }
            else if (proxy.model.progressbarTooltipTemplate) {
                var parentTr = proxy.model.progressbarTooltipTemplate;
            }
            var templates = {};
            templates[proxy._id + "progressbarTooltipTemplate"] = parentTr;
            $.templates(templates);
        },


        //Template to create tooltip
        _createTooltipTemplate: function () {

            var proxy = this,
                td,
                columnHeaderTexts = proxy.model.columnHeaderTexts,
                durationUnitTexts = proxy.model.durationUnitTexts,
                helpers = {},
                templateId = proxy.model.tooltipTemplateId,
                template = proxy.model.tooltipTemplate;
            helpers["_" + proxy._id + "getStartDate"] = proxy._tooltipStartDate;
            helpers["_" + proxy._id + "getSubtaskStartDate"] = proxy._tooltipSubtaskStartDate;
            helpers["_" + proxy._id + "getScheduleStartDate"] = proxy._tooltipScheduleStartDate;
            helpers["_" + proxy._id + "getEndDate"] = proxy._tooltipEndDate;
            helpers["_" + proxy._id + "getSubtaskEndDate"] = proxy._tooltipSubtaskEndDate;
            helpers["_" + proxy._id + "getScheduleEndDate"] = proxy._tooltipScheduleEndDate;
            helpers["_" + proxy._id + "getTaskName"] = proxy._tooltipTaskName;
            helpers["_" + proxy._id + "getProgress"] = proxy._tooltipProgress;
            helpers["_" + proxy._id + "checkDuration"] = proxy._checkDuration;
            helpers["_" + proxy._id + "getDuration"] = $.proxy(proxy._tooltipDuration, proxy);
            $.views.helpers(helpers);

            if (templateId ) {
                var parentTr = $("#" + proxy.model.tooltipTemplateId)[0].innerHTML;
            }
            else if (proxy.model.tooltipTemplate ) {
                var parentTr = proxy.model.tooltipTemplate;
            }
           
            else {
                var parentTr = "<tr class='e-tooltip_rowcell'>";

                td = "{{if ~_" + proxy._id + "getTaskName()}}" +
                    "<td class='e-tooltiptaskname' style='width:40px;text-align:left;' colspan='3';>{{:ttiptaskname}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_" + proxy._id + "getStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["startDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipstartDate}}</td> {{/if}}" +
                    "</tr>" +
                    "{{if ~_" + proxy._id + "getSubtaskStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["subTasksStartDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipsubtaskStartDate}}</td></tr>{{/if}}" +

                    "{{if ~_" + proxy._id + "getScheduleStartDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["scheduleStartDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipscheduleStartDate}}</td></tr>{{/if}}" +

                    "{{if ~_" + proxy._id + "getEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["endDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipendDate}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_" + proxy._id + "getSubtaskEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["subTasksEndDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipsubtaskEndDate}}</td></tr>{{/if}}" +

                    "{{if ~_" + proxy._id + "getScheduleEndDate()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["scheduleEndDate"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipscheduleEndDate}}</td></tr>{{/if}}" +

                    "{{if ~_" + proxy._id + "checkDuration()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["duration"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:~_" + proxy._id + "getDuration(#data)}}</td>{{/if}}" +
                    "</tr>" +
                    "{{if ~_" + proxy._id + "getProgress()}}<tr>" +
                    "<td class='e-tooltiptd-alignleft' style='width:30px;white-space:nowrap;'>" + columnHeaderTexts["status"] + "</td>" +
                    "<td class='e-tooltiptd-aligncenter' style='width:10px;font-weight:bold;'>:</td>" +
                    "<td class='e-tooltiptd-alignright' style='width:30px;white-space:nowrap;'>{{:ttipprogress}}%</td>{{/if}}";

                parentTr += td;
                parentTr += "</tr>";
            }

            var templates = {};
            templates[proxy._id + "tooltipTemplate"] = parentTr;
            $.templates(templates);
        },
        /*check duration is available in tooltip item*/
        _checkDuration: function () {
            return this.data.ttipduration;
        },
        _tooltipTaskName: function () {
            return this.data.ttiptaskname;
        },

        _tooltipProgress: function () {
            return this.data.ttipprogress;
        },

        _tooltipStartDate: function () {
            return this.data.ttipstartDate;
        },

        _tooltipSubtaskStartDate: function () {
            return this.data.ttipsubtaskStartDate;
        },
        _tooltipScheduleStartDate: function () {
            return this.data.ttipscheduleStartDate;
        },

        _tooltipEndDate: function () {
            return this.data.ttipendDate;
        },

        _tooltipSubtaskEndDate: function () {
            return this.data.ttipsubtaskEndDate;
        },

        _tooltipScheduleEndDate: function () {
            return this.data.ttipscheduleEndDate;
        },
        /*get localized text of duration value*/
        _tooltipDuration: function (data) {
            var val = "";
            if (data.ttipduration != null && data.ttipduration != undefined)
                val += parseFloat(data.ttipduration.toFixed(2)) + " ";
            if (data.ttipdurationunit != null && data.ttipdurationunit != undefined) {
                var multiple = data.ttipduration != 1;
                if (data.ttipdurationunit == "day")
                    val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
                else if (data.ttipdurationunit == "hour")
                    val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
                else
                    val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
            }
            return val;
        },

        _getDurationUnits: function (data) {
            var proxy = this;
            if (proxy.model.durationUnit == ej.Gantt.DurationUnit.Hour)
                return "hours";
            else if (proxy.model.durationUnit == ej.Gantt.DurationUnit.Minute)
                return "minutes";
            else
                return "days";

        },

        _cellClickHandler: function (e) {
            var $target = $(e.target),
                $row = $target.closest('tr.e-ganttrowcell'),
                proxy = this,
                model = this.model,
                args = {},
                selectedItem,
                index,
                rowIndex,
                div = $target[0],
                $ganttGridRows = proxy.getGanttChartRows();

            rowIndex = index = $ganttGridRows.index($target.parent());

            if (index == -1) {
                rowIndex = index = $ganttGridRows.index($row);
            }

          
            if (($(div).hasClass("e-parentTask") || $(div).closest(".e-parentTask").length > 0) && !$target.hasClass("e-connectorpoint-left") && !$target.hasClass("e-connectorpoint-right")) { // here check drag point class

                var currentRecordIndex = $ganttGridRows.index($row),
                    selectedItem = model.currentViewData[currentRecordIndex],
                recordIndex = model.updatedRecords.indexOf(selectedItem);
                if (proxy._allowExpandCollapse && selectedItem && selectedItem.hasChildRecords) {
                    /*cancel edited cell in treegrid on mouse down event on parent task bar*/
                    proxy._trigger("cancelEditCell");
                    if (model.selectedRowIndex !== recordIndex && model.allowSelection && recordIndex !== -1) {

                        if (!proxy._rowSelectingEventTrigger(model.selectedRowIndex, recordIndex)) {
                            proxy.selectRows(recordIndex);
                            proxy._rowSelectedEventTrigger(recordIndex);
                        }
                    }
                    proxy._expandCollapse(currentRecordIndex);
                }
            }
            else if (index != -1 && model.allowSelection) {
                selectedItem = model.currentViewData[index];
                index = model.updatedRecords.indexOf(selectedItem);
                if (model.selectionMode == "row") {                    
                if (proxy._rowSelectingEventTrigger(model.selectedRowIndex, index))
                    return;
                proxy.selectRows(index);
                proxy.focusGanttElement();
                proxy._rowSelectedEventTrigger(index);
            }
                if (model.selectionMode == "cell")
                    proxy.model.selectedItem = selectedItem;
            }
            if (model.taskbarClick) {
                if (!$target.is(".e-childContainer,.e-gantt-milestone-container,.e-parentContainer")) {
                    var taskElement = $target.closest(".e-childContainer,.e-gantt-milestone-container,.e-parentContainer");
                    if (taskElement.length) {
                        var args = {}, data;
                        data = model.currentViewData[rowIndex];
                        rowIndex = model.updatedRecords.indexOf(data);
                        args.data = data;
                        args.index = rowIndex;
                        args.taskbarElement = taskElement[0];
                        args.target = $target[0];
                        this._trigger("taskbarClick", args);
                    }
                }
            }
        },

        getRowByIndex: function (from, to) {
            try {
                var proxy = this;

                var gridRows = proxy.getGanttChartRows(),
                    $gridRows = $(gridRows),
                    $row = $();

                if (proxy.model.enableVirtualization) {
                    var recordstart = proxy.model.updatedRecords[from];
                    from = proxy.model.currentViewData.indexOf(recordstart);
                }

                if (ej.isNullOrUndefined(to)) {
                    if (proxy.model.enableVirtualization) {
                        var recordend = proxy.model.updatedRecords[to];
                        to = proxy.model.currentViewData.indexOf(recordend);
                    }
                    return $(gridRows[from]);
                } else {
                    return $($gridRows.slice(from, to));
                }
            } catch (e) {
                return $();
            }
        },

        selectRows: function (index) {
            var proxy = this,
                model = this.model,
                $ganttGridRows = proxy.getGanttChartRows(),
                selectedItem;
            if (!model.allowSelection)
                return;
            if (model.selectionMode == "cell")
                return;
            if (proxy.prevSelectedItem) {
                proxy.prevSelectedItem.isSelected = false;
            }
            $ganttGridRows.removeClass("e-gantt-mouseclick");
            var $row = proxy.getRowByIndex(index);
            if (proxy.model.allowSelection)
                $row.addClass("e-gantt-mouseclick");
            proxy.model.selectedRowIndex = index;
            selectedItem = proxy.model.updatedRecords[index];
            if (selectedItem)
                selectedItem.isSelected = true;
            proxy.model.selectedItem = selectedItem;
            proxy.prevSelectedItem = selectedItem;
        },

        updateSelectedItem: function (recordIndex) {
            var proxy = this,
                $ganttGridRows = $(proxy.getGanttChartRows());

            $ganttGridRows.removeClass("e-gantt-mouseclick");
            proxy.model.updatedRecords[recordIndex].isSelected = true;
            proxy.model.selectedItem = proxy.model.updatedRecords[recordIndex];
            this._refresh();
            proxy._rowSelectedEventTrigger(recordIndex);

        },

        updateHeight: function (height) {
            var proxy = this,
                model = proxy.model;
            proxy._setScrollTop();
            proxy._containerHeight = height;
            $("#ganttviewerbodyContent" + proxy._id + "").css({
                 "height": proxy._containerHeight + "px"
            });

            if (model.stripLines) {
                $(proxy.element).find(".e-stripline,.e-stripLines").css({ height: height + "px" });
            }

            if (model.holidays) {
                $(proxy.element).find(".e-holidays,.e-holiday").css({ height: height + "px" });
            }
            $(".e-secondary_canvas").css({ height: height + "px" });
            $(proxy.element).find(".e-weekends").css({ height: height + "px" });

            var holidayLableSelector = ".e-holiday-label";
            /* for rotate holiday lable in ie8 */
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                holidayLableSelector = ".e-holiday-label-ie8";
            }

            if (height < proxy._viewportHeight) {
                if (height <= model.rowHeight) {
                    $(proxy.element).find(holidayLableSelector).css({ top: -height - 30 });
                }
                else
                    $(proxy.element).find(holidayLableSelector).css({ top: height / 2 });
            }
            else
                $(proxy.element).find(holidayLableSelector).css({ top: proxy._viewportHeight / 2 });
            
            //To enable the Horizontal scroller when all the records were deleted
            if (height == 0) {
                proxy._$bodyContent.css({ "height": "1px" });
            }
            proxy._$bodyContainer.ejScroller("refresh");

            /*While refreshing scroller the gantt chart container height is increased by 16px.
             When horizontal scrollbar not avaiable in gantt chart side.
             So check the chart container height and view port height.
             If it is varies set the view port height to chart container height*/
            if(parseInt(proxy._$bodyContainer.css("height")) != proxy._viewportHeight)
                proxy._$bodyContainer.css("height", proxy._viewportHeight);
        },


        //method to trigger actioncomplete event
        _completeAction: function (args) {
            var proxy = this;
            args.vscrollExsist = proxy._$bodyContainer.ejScroller("isVScroll");
            proxy._trigger("actionComplete", args);
            if (args.requestType === "validatePredecessor") {
                return args.predecessorValidation;
            }
        },


        //method to trigger taskbarediting event
        //to apply changes during taskbar editing
        _taskbarEditing: function (args) {
            var proxy = this;
            proxy._trigger("taskbarEditing", args);
        },


        //method to trigger taskbaredited event
        //to apply changes after taskbar edited
        _taskbarEdited: function (args) {
            var proxy = this;
            proxy._trigger("taskbarEdited", args);
        },


        //method to trigger querytaskbarinfo 
        //to apply changes at load time
        _queryTaskbarinfo: function (args) {
            this._trigger("queryTaskbarInfo", args);
            this._updateTaskbarItems(args);
        },


        //method to trigger refresh row
        _refreshRow: function (args) {
            var proxy = this;
            proxy._trigger("refreshRow", args);
        },

        _updateManualTaskbarItem: function(args, taskElement){

            var parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv"),
                        parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress"),
                        parentOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar"),
                        parentLeftOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar-left"),
                        parentRightOuterTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar-right"),
                        parentRightResizer = taskElement.querySelector(".e-taskbarresizer-right"),
                        parentTaskbarStyle = parentTaskbar.style,
                        parentProgressbarStyle = parentProgressbar && parentProgressbar.style,
                        parentOuterTaskbarStyle = parentOuterTaskbar && parentOuterTaskbar.style,
                        parentLeftOuterTaskbarStyle = parentLeftOuterTaskbar && parentLeftOuterTaskbar.style,
                        parentRightOuterTaskbarStyle = parentRightOuterTaskbar && parentRightOuterTaskbar.style,
                        parentRightResizerStyle = parentRightResizer && parentRightResizer.style,
                        model = this.model;

            var taskbarHeight, tHeight;
            if (model.renderBaseline) {
                taskbarHeight = model.taskbarHeight - 9;
            } else {
                taskbarHeight = model.taskbarHeight - 10;
            }
            tHeight = taskbarHeight / 5;                                                          
            
            if (!ej.isNullOrUndefined(args.manualParentTaskbarBackground) && parentOuterTaskbarStyle.backgroundColor != args.manualParentTaskbarBackground) {
                parentOuterTaskbarStyle.backgroundColor = args.manualParentTaskbarBackground;
                parentLeftOuterTaskbarStyle.borderColor = args.manualParentTaskbarBackground;
                parentRightOuterTaskbarStyle.borderColor = args.manualParentTaskbarBackground;
            }
            parentOuterTaskbarStyle.width = args.data.width + "px";
            parentOuterTaskbarStyle.left = args.data.left + "px";
            parentRightOuterTaskbarStyle.left = (args.data.width - parseInt(tHeight)) + "px";
            parentRightResizerStyle.left = (args.data.width - parseInt(tHeight)) + "px";            
                      
            if (args.data.width == args.data.manualWidth && args.data.left == args.data.manualLeft) {
                parentProgressbarStyle.width = args.data.progressWidth - (tHeight * 2) + "px";
                parentTaskbarStyle.width = args.data.manualWidth - (tHeight * 2) + "px";
                parentTaskbarStyle.left = args.data.manualLeft + tHeight + "px";
            }
            else if (args.data.left == args.data.manualLeft) {
                parentTaskbarStyle.left = args.data.manualLeft + tHeight + "px";
                parentProgressbarStyle.width = args.data.progressWidth - (tHeight) + "px";
                parentTaskbarStyle.width = args.data.manualWidth - (tHeight) + "px";
            }
            else {
                parentProgressbarStyle.width = args.data.progressWidth + "px";
                parentTaskbarStyle.width = args.data.manualWidth + "px";
                parentTaskbarStyle.left = args.data.manualLeft + "px";
            }
        },
        //Updates taskbar items styles when chart loads
        _updateTaskbarItems: function (args) {

            var $ganttChartRows = this.getGanttChartRows(),
                index = this.model.currentViewData.indexOf(args.data),
                taskbarContainer = $ganttChartRows[index], taskElement, mileStone, baseline,baselineMileStone;

            if (taskbarContainer) {
                             
                if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                    mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                if ($(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div').length > 0)
                    baselineMileStone = $(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div')[0];

                if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                    baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];

                if ($(taskbarContainer).find(".e-parentContainer").closest('div').length > 0) {
                    var taskElement = $(taskbarContainer).find(".e-parentContainer").closest('div')[0],
                        parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv"),
                        parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress"),
                        parentTaskbarStyle = parentTaskbar.style,
                        parentProgressbarStyle = parentProgressbar && parentProgressbar.style;

                    if (parentTaskbarStyle.backgroundColor != args.parentTaskbarBackground) {
                        parentTaskbarStyle.backgroundColor = args.parentTaskbarBackground;
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.backgroundColor != args.parentProgressbarBackground) {
                        parentProgressbarStyle.backgroundColor = args.parentProgressbarBackground;
                    }
                    if (parentTaskbarStyle.borderColor != args.parentTaskbarBorder) {
                        parentTaskbarStyle.borderColor = args.parentTaskbarBorder;
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.borderColor != args.parentProgressbarBorder) {
                        parentProgressbarStyle.borderColor = args.parentProgressbarBorder;
                    }
                    if (!args.data.isAutoSchedule && args.data.hasChildRecords) {                                                                        
                        this._updateManualTaskbarItem(args, taskElement);                        
                    }
                    if (parentProgressbarStyle && parentProgressbarStyle.borderColor != args.parentProgressbarBorder) {
                        parentProgressbarStyle.borderColor = args.parentProgressbarBorder;
                    }

                } else if ($(taskbarContainer).find(".e-childContainer").closest('div').length > 0) {
                    var taskElement = $(taskbarContainer).find(".e-childContainer").closest('div')[0],
                        taskbar = taskElement.querySelector(".e-gantt-childtaskbar"),
                        progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress"),
                        taskbarStyle = taskbar.style,
                        progressbarStyle = progressbar && progressbar.style,
                        taskbarLabel = progressbar && progressbar.querySelector(".e-tasklabel"),
                        taskbarText = taskbarLabel && taskbarLabel.style;

                    if (taskbarStyle.backgroundColor != args.taskbarBackground) {
                        taskbarStyle.backgroundColor = args.taskbarBackground;
                    }
                    if (progressbar && progressbarStyle.backgroundColor != args.progressbarBackground) {
                        progressbarStyle.backgroundColor = args.progressbarBackground;
                    }
                    if (taskbarStyle.borderColor != args.taskbarBorder) {
                        taskbarStyle.borderColor = args.taskbarBorder;
                    }
                    if (progressbar && progressbarStyle.borderColor != args.progressbarBorder) {
                        progressbarStyle.borderColor = args.progressbarBorder;
                    }
                    if (taskbarText && taskbarText.color != args.taskbarTextColor) {
                        taskbarText.color = args.taskbarTextColor;
                    }
                }

                if ($(mileStone).length > 0) {
                    var milestoneTop = mileStone.querySelector(".e-gantt-milestone.e-milestone-top"),
                        milestoneBottom = mileStone.querySelector(".e-gantt-milestone.e-milestone-bottom");
                    if (milestoneTop && milestoneBottom) {
                        var milestonetopStyle = milestoneTop.style,
                            milestonebottomStyle = milestoneBottom.style;
                        if (milestonebottomStyle.borderBottomColor != args.milestoneBackground && milestonetopStyle.borderTopColor != args.milestoneBackground) {
                            milestonebottomStyle.borderTopColor = args.milestoneBackground;
                            milestonetopStyle.borderBottomColor = args.milestoneBackground;
                        }
                    }
                    else if(this.model.milestoneTemplate)
                    {
                        var milestoneContainer = mileStone.querySelector(".e-gantt-milestone");
                        if (milestoneContainer.style.backgroundColor != args.milestoneBackground)
                            milestoneContainer.style.backgroundColor = args.milestoneBackground;
                    }
                }
                if ($(baseline).hasClass("e-baselinebar")) {
                    var baselineStyle = baseline.style;
                    if (baselineStyle.backgroundColor != args.baselineBackground) {
                        baselineStyle.backgroundColor = args.baselineBackground;
                    }
                    }
                if ($(baselineMileStone).hasClass("e-baseline-gantt-milestone")) {
                    var baselineTop = baselineMileStone.querySelector(".e-baseline-milestone-top"),
                   baselineBottom = baselineMileStone.querySelector(".e-baseline-milestone-bottom");
                    if (baselineTop && baselineBottom) {
                        var topStyle = baselineTop.style,
                            bottomStyle = baselineBottom.style;
                        if (bottomStyle.borderBottomColor != args.baselineBackground && topStyle.borderTopColor != args.baselineBackground) {
                            bottomStyle.borderTopColor = args.baselineBackground;
                            topStyle.borderBottomColor = args.baselineBackground;
                        }
                    }
                }
            }
        },

        //to perform expand collapse operation from ganttchart
        _expandCollapse: function (recordIndex) {

            var proxy = this,
                args = {},
                data = proxy.model.currentViewData[recordIndex];

            args.data = data;
            args.recordIndex = proxy.model.updatedRecords && proxy.model.updatedRecords.indexOf(data);
            args.source = "ganttChart";
            args.expanded = !data.expanded;
            if (data) {
                if (!args.expanded) {
                    proxy._trigger("collapsing", args);
                }
                else {
                    proxy._trigger("expanding", args);
                }
            }
        },


        //get the Expand status of GridRecord
        _getExpandStatus: function (record) {
            var parentRecord = record.parentItem;
            if (parentRecord != null) {
                if (parentRecord.expanded === false)
                    return false;
                else if (parentRecord.parentItem) {
                    if (parentRecord.parentItem.expanded === false)
                        return false;
                    else
                        return this._getExpandStatus(parentRecord.parentItem);
                }
                else
                    return true;
            } else
                return true;
        },



        //method to scroll ganttchart from gridtree scroll event       
        onScrollHelper: function (scrollTop, fromChartScroller) {

            var proxy = this;
			if (!proxy._$bodyContainer.ejScroller("isVScroll"))
			{
                return false;
            }
			proxy._mouseLeave();
			if (!fromChartScroller)
			    proxy._$bodyContainer.ejScroller("option", "scrollTop", scrollTop);
			var rowHeight = proxy.model.rowHeight;
			if ($("#" + this._$ganttViewTablebody[0].id).find("tr:first")[0])
			    rowHeight = $("#" + this._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
			var h = parseInt(proxy.model.updatedRecords.length * rowHeight) - (proxy._viewportHeight - 18); //proxy.model.
            

            if (scrollTop > h) {
                scrollTop = h;
            }

            if (scrollTop < 0) {
                scrollTop = 0;
            }

            var args = { scrollTop: scrollTop };

            proxy._handleScroll(args);
            
            //var div = $("#ganttviewerbodyContianer" + this._id);
            //div.scrollTop(scrollTop);
            if (this.model.isCriticalPathEnable == true && this.model.enableVirtualization == true) {
                this.criticalConnectorLine(this.model.criticalPathCollection, this.model.detailPredecessorCollection, true, this.collectionTaskId);
            }
        },

        //Handler for scroll event from ganttchart
        _handleScroll: function (args) {

            var proxy = this,
                args =args|| {},
                headerdiv = proxy._$headerContainer,
                contentdiv = proxy._$bodyContainer,
                left = proxy._prevLeft;

            
            if (args.scrollTop !== undefined) {
                proxy._scrollTop = args.scrollTop;
            }

            if (args.scrollLeft !== undefined) {
                left = args.scrollLeft;
            }

            var diff = (left - proxy._prevLeft),
                vDiff = proxy._scrollTop - proxy._prevScrollTop;

            if (diff) {
                headerdiv.scrollLeft(left);
            }
            else {
                headerdiv.scrollLeft(proxy._prevLeft);
            }

            if (proxy.model.enableVirtualization) {
                proxy._vscrollDist = Math.abs(proxy._scrollTop - proxy._prevScrollTop);
                if (proxy._vscrollDist) {
                    proxy._vScrollDir = proxy._prevScrollTop <= proxy._scrollTop ? 1 : -1;
                        proxy._updateCurrentViewData();

                    proxy.renderGanttRecords();
                    proxy._prevScrollTop = proxy._scrollTop;
                }
            }
            args.requestType = "scroll";
            args.delta = proxy._scrollTop;
            proxy._prevLeft = left;
            proxy._prevScrollTop = proxy._scrollTop;
            if (diff === 0 && vDiff !== 0) {
                proxy._completeAction(args);
            }
        },


        //helper method to refresh the ganttchart content from gantt
        refreshHelper: function (currentviewdata, records,collapseRecordsCount) {

            var proxy = this;
            proxy.model.currentViewData = currentviewdata;
            proxy.model.updatedRecords = records;
            if (collapseRecordsCount != undefined)
                proxy._totalCollapsedRecordCount = collapseRecordsCount;
            else
                proxy._totalCollapsedRecordCount = 0;

            if (records) {
                proxy._refresh();
                proxy._setHeight(records.length * proxy.model.rowHeight);
                proxy.updateHeight((records.length - proxy._totalCollapsedRecordCount) * proxy.model.rowHeight);
            }
        },
        _setScrollTop: function () {

            var proxy = this,
            model = this.model,
            top = proxy._scrollTop;

            if (model.enableVirtualization && top!==0) {
                if ((proxy.model.currentViewData.length * proxy.model.rowHeight) < proxy._viewportHeight) {
                    var currentPosition = top - (proxy._viewportHeight - proxy.model.currentViewData.length * proxy.model.rowHeight);
                    if (currentPosition < 0)
                        currentPosition = 0;
                    proxy._$bodyContainer.ejScroller("scrollY", currentPosition, true);
                }
            }
        },
  
        refreshGridLinesTable:function(length)
        {
            var proxy = this;
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(length));
                proxy._$bodyContainer.ejScroller("refresh");

                /*While refreshing scroller the gantt chart container height is increased by 16px.
                When horizontal scrollbar not avaiable in gantt chart side.
                So check the chart container height and view port height.
                If it is varies set the view port height to chart container height*/
                if (parseInt(proxy._$bodyContainer.css("height")) != proxy._viewportHeight)
                    proxy._$bodyContainer.css("height", proxy._viewportHeight);
        },
        //to refresh the content of the ganttchart
        _refresh: function () {

            var proxy = this, model = proxy.model,
                data = $.render[proxy._id + "_CustomTemplate2"](proxy.model.currentViewData);

            proxy._$ganttViewTablebody = $("#ganttViewTablebody" + proxy._id + "");

            proxy._$ganttViewTablebody.empty().append(data);

            //var $gridLinesTablebody = $("#gridLinesTablebody" + proxy._id + "");
            
            if (model.enableVirtualization) {
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.currentViewData.length));
            }
            else {
                proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.currentViewData.length - proxy._totalCollapsedRecordCount));
            }


            if (proxy._$ganttViewTablebody[0] != null) {
                this._ganttChartRows = $(proxy._$ganttViewTablebody[0].childNodes);
            }
            else {
                proxy._$ganttViewTablebody = ej.buildTag("tbody.e-gantt-viewer-ganttViewTablebody#ganttViewTablebody" + proxy._id + "",
                    data, {}, {});
                proxy._ganttChartRows = $(proxy._$ganttViewTablebody[0].childNodes);
            }
            if(model.queryTaskbarInfo)
                proxy._eventBindings();

        },


        //to rerender a particular ganttchart row
        refreshRow: function (index) {

            var proxy = this, model = this.model,
                $tr = $(proxy.getGanttChartRows()[index]),
                selectedItem = proxy.model.currentViewData[index];
            if (!model.allowSelection && selectedItem)
                selectedItem.isSelected = false;
            if (index != -1 && selectedItem) {
                $tr.replaceWith($.render[proxy._id + "_CustomTemplate2"](selectedItem));
                proxy._setGanttChartRows($(proxy._$ganttViewTablebody[0].childNodes));
            }
            if (model.queryTaskbarInfo)
                proxy._refreshedRowEventBinding(index);

        },


        //Trigger queryTaskbarInfo while refresh the row
        _refreshedRowEventBinding: function (index)
        {
            var $ganttChartRows = $(this.getGanttChartRows()),
                    taskbarContainer,
                    args = {}, progressbar, taskbar,
                    parentProgressbar, parentTaskbar, taskElement, mileStone, progressBorder,
                    taskbarBorder,
                    taskbarText,
                    baseline, baselineMileStone;

                    taskbarContainer = $ganttChartRows[index];

                    if ($(taskbarContainer).hasClass("e-ganttrowcell")) {
                        taskElement = $(taskbarContainer).find("td.e-chartcell").has("div.e-childContainer,div.e-parentContainer,div.e-gantt-milestone")[0].firstChild;
                        if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                            mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                            baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div').length > 0)
                            baselineMileStone = $(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div')[0];

                        if ($(taskElement).hasClass("e-parentContainer")) {
                            parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv");
                            parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress");
                        } else if ($(taskElement).hasClass("e-childContainer")) {

                            taskbar = taskElement.querySelector(".e-gantt-childtaskbar");
                            progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress");
                            taskbarText = progressbar && progressbar.querySelector(".e-tasklabel");
                        }

                        args.data = this.model.currentViewData[index];
                        args.taskbar = taskbarContainer;

                        args.taskbarBackground = taskbar != null ?
                            taskbar.style.backgroundColor : null;

                        args.progressbarBackground = progressbar != null ?
                            progressbar.style.backgroundColor : null;

                        args.parentTaskbarBackground = parentTaskbar != null ?
                            parentTaskbar.style.backgroundColor : null;

                        args.parentProgressbarBackground = parentProgressbar != null ?
                            parentProgressbar.style.backgroundColor : null;

                        args.parentProgressbarBorder = parentProgressbar != null ?
                            parentProgressbar.style.border : null;

                        args.progressbarBorder = progressbar != null ?
                            progressbar.style.border : null;

                        args.taskbarBorder = taskbar != null ?
                            taskbar.style.border : null;

                        args.parentTaskbarBorder = parentTaskbar != null ?
                            parentTaskbar.style.border : null;

                        args.taskbarTextColor = taskbarText != null ?
                            taskbarText.style.color : null;                        

                        args.milestoneBackground = mileStone != null ?
                            mileStone.style.backgroundColor : null;

                        if (!ej.isNullOrUndefined(baselineMileStone)) {
                            var baselineTop = baselineMileStone.querySelector(".e-baseline-milestone-top"),
                            baselineBottom = baselineMileStone.querySelector(".e-baseline-milestone-bottom");
                            if (baselineTop && baselineBottom) {
                                args.baselineBackground = baselineTop.style.borderTopColor;
                            }
                        }
                        else {
                            args.baselineBackground = baseline != null ?
                            baseline.style.backgroundColor : null;
                        }
                        this._queryTaskbarinfo(args);
                    }

        },
        //REFRESH THE SCROLLER FOR TREEGRIDCONTENT
        refreshScroller: function (panSize) {

            var proxy = this,maxScrollWidth;
            //proxy._$gridContent.css({'width':panSize+"px"});
            proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
            var scrollTop = proxy._$bodyContainer.ejScroller("option", "scrollTop");
            var scrollLeft = proxy._$bodyContainer.ejScroller("option", "scrollLeft");
            proxy._$bodyContainer.ejScroller("option", { "width": panSize });
            proxy._$bodyContainer.ejScroller("refresh");
            maxScrollWidth=proxy.getMaxScrollWidth();
            
            if (scrollLeft > maxScrollWidth)
                scrollLeft = maxScrollWidth > 0 ? maxScrollWidth : 0;

            var isHorizontalScroll = proxy._$bodyContainer.ejScroller("isHScroll");
            if (!isHorizontalScroll) {
                proxy._$bodyContainer.find("div.e-content").addClass("e-borderbox");
            }
            else {
                proxy._$bodyContainer.find("div.e-content").removeClass("e-borderbox");
            }
            var isVerticalScroll = proxy._$bodyContainer.ejScroller("isVScroll");
            if (isVerticalScroll)
            {
                proxy._$bodyContainer.ejScroller("scrollY", scrollTop, true);
            }
            proxy._$bodyContainer.ejScroller("option", "scrollLeft", scrollLeft);
            proxy._$headerContainer.scrollLeft(scrollLeft);

        },
        getMaxScrollWidth:function()
        {
            var proxy = this;
            return proxy._$bodyContainer.children(".e-content").children().width() - proxy._$bodyContainer.children(".e-content").width();
        },

        /* refresh stripLines Collection*/
        refreshStripLines:function (stripLines)
        {
            var proxy = this;
            if (stripLines) {
                this.model.stripLines = stripLines;
            }
            proxy._$stripLineContainer.empty();
            this._renderStripLines(this.model.stripLines);

        },
        /* refresh holidays Collection*/
        refreshHolidays: function (holidays) {
            //Display Holidays
            var proxy = this;
            if (holidays) {
                proxy.model.holidays = holidays
            }
            proxy._$secondaryCanvas.empty();
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },

        //insert new record in DOM 
        renderNewAddedRow:function(index, data)
        {
            var proxy = this, model = proxy.model,
            addedchartRow = $.render[this._id + "_CustomTemplate2"](data);
            if (proxy._ganttChartRows.length != 0) {
                if (proxy._ganttChartRows.length == index) {
                    proxy.getGanttChartRows().eq(index - 1).after(addedchartRow);
                } else {
                    proxy.getGanttChartRows().eq(index).before(addedchartRow);
                }
            } else {
                proxy._refresh();
            }
            proxy._setGanttChartRows($(proxy._$ganttViewTablebody[0].childNodes));
            proxy._$gridLinesTablebody.empty().append(proxy._createGridLinesTableRow(proxy.model.updatedRecords.length - proxy._totalCollapsedRecordCount));
            if (model.enableVirtualization === false) {
                proxy._setHeight((proxy.model.updatedRecords.length - proxy._totalCollapsedRecordCount) * proxy.model.rowHeight);

            } else {
                proxy._setHeight(proxy.model.updatedRecords.length * proxy.model.rowHeight);
            }
            proxy.updateHeight(proxy._containerHeight);

        },

        _setGanttChartRows: function (value) {
            this._ganttChartRows = value;
        },

        refreshChartHeader:function(startdate,enddate)
        {
            var proxy = this,
            model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
            $colsgroup, $column, $thead,
            $tr, $td, $div, $table;
            proxy._updateScheduleWidth();
            /*Schedule mode - Chart Top header*/
            if (scheduleMode == "hour") {
                proxy._createScheduleTopHourTemplate();
            }
            else if (scheduleMode == "day") {
                proxy._createScheduleTopDayTemplate();
            }
            else if (scheduleMode == "week") {
                proxy._createScheduleWeekTemplate();
            }
            else if (scheduleMode == "month") {
                proxy._createScheduleTopMonthTemplate();
            }
            else if (scheduleMode == "year") {
                proxy._createScheduleYearTemplate();
            }
            
            startdate = startdate == null ? new Date() : startdate;
            enddate = enddate == null ? new Date(null) : enddate;
            proxy._$scheduleDiv.empty();
            $table = ej.buildTag("table.e-schedule-headerrow-week e-zerospacing", "",
                { 'display': 'block' }
            );

            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');

            $colsgroup.append($column);

            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleWeekTemplate"](model.scheduleWeeks), {}, {});
            else if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleYearTemplate"](model.scheduleYears), {}, {});
            else if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopMonthTemplate"](model.scheduleMonths), {}, {});
            else if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopDayTemplate"](model.scheduleDays), {}, {});
            else if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopHourTemplate"](model.scheduleHours), {}, {});

            $td = ej.buildTag("th.e-ganttchart-schedule", "", {}, {});
            $div = ej.buildTag("div.e-ganttchart-schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            $tr = null;
            /*Schedule mode - Chart Bottom header*/
            if (scheduleMode == "hour") {
                proxy._createMinuteTemplate();
            }
            else if (scheduleMode == "day") {
                proxy._createScheduleHourTemplate();
            }
            else if (scheduleMode == "week") {
                proxy._createScheduleDayTemplate();
            }
            else if (scheduleMode == "month") {
                proxy._createScheduleBottomWeekTemplate();
            }
            else if (scheduleMode == "year") {
                proxy._createScheduleMonthTemplate();
            }
            $table = ej.buildTag("table.e-schedule-headerrow-day e-zerospacing", "",
                {
                    'display': 'block',
                    'border-collapse': 'collapse'
                });
            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            var scheduleMonths = proxy._getScheduleMonth(new Date(model.scheduleYears[0]), enddate);
            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "_CustomTemplate1"](proxy.model.scheduleWeeks), {}, {});
            if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleMonthTemplate"](scheduleMonths), {}, {});
            if (scheduleMode == "month") {
                proxy._numOfWeeks = proxy._getNumberOftWeeks(this.model.projectStartDate, this.model.projectEndDate);
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleBottomWeekTemplate"](proxy._numOfWeeks), {}, {});
            }
            if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleHourTemplate"](proxy._getScheduleHours()), {}, {});
            if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleMinuteTemplate"](proxy._getScheduleMinutes()), {}, {});

            $td = ej.buildTag("th.e-ganttchart-schedule", "", {}, {});
            $div = ej.buildTag("div.e-ganttchart-schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);
        },


        //update all containers width
        refreshContainersWidth:function()
        {
            var proxy = this,
                width, model = this.model,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            width = proxy._getScheduleLength(scheduleMode);
            var $gridLineContainerTable=$("#ganttgridLinesTable" + proxy._id);

            proxy._$bodyContent.width(width);//main body container
            proxy.refreshWeekEndContainer();//weekENd Container
            $gridLineContainerTable.width(width);
            $gridLineContainerTable.children("col").width(width);
            proxy._$ganttViewTable.width(width);
            proxy._$ganttViewTable.children("col").width(width);
            proxy._createTaskbarTemplate();
            proxy._updateCurrentViewData();
            proxy._$secondaryCanvas.empty();
            proxy._$stripLineContainer.empty();
            if (proxy.model.stripLines != null) {
                this._renderStripLines(proxy.model.stripLines);
            }
            if (proxy.model.holidays != null) {
                var holidayCount = proxy.model.holidays.length;
                for (var i = 0; i < holidayCount; i++) {
                    proxy._renderHoliday(proxy.model.holidays[i]);
                }
            }
        },
        //refresh week ends when schedule dates changes
        refreshWeekEndContainer:function()
        {
            var proxy = this,
                model = proxy.model,
                left = 0,
                width = (proxy.model.perDayWidth) + 1,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                count = proxy.model.scheduleWeeks.length, $day,
                weekStartDay = model.scheduleHeaderSettings.weekStartDay,
                dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                saturdayIndex = 6 - dayIndex,
                $weekendContainer = proxy._$weekendsContainer.children('.e-secondary_canvas'),
                nonWorkDayLength = proxy._nonWorkingDayIndex.length;
            $weekendContainer.empty();
            for (var i = 0; i < count; i++) {
                var weeDayIndex;
                for (var j = 0; j < nonWorkDayLength; j++) {
                    if (proxy._nonWorkingDayIndex[j] != 6) {
                        var index = (saturdayIndex + proxy._nonWorkingDayIndex[j] + 1);
                        weeDayIndex = (index >= 7 ? proxy._nonWorkingDayIndex[j] - dayIndex : index);
                    }
                    else
                        weeDayIndex = saturdayIndex;
                    $day = ej.buildTag("div.e-weekends", "", {
                        'left': (left + (proxy.model.perDayWidth * weeDayIndex)) + 'px',
                        'width': width + 'px',
                        'height': height + 'px',
                        'background-color': this.model.weekendBackground
                    }, {});
                    $weekendContainer.append($day);
                }
                left = left + this._scheduleWeekWidth;
            }
            proxy._$weekendsContainer.append($weekendContainer);
        },
        //delete gantt chart rows without rerendering of whole page
        deleteChartRows: function (startIndex, count) {
            var proxy = this;
            var $chartRows = proxy.getGanttChartRows();
            for (var i = startIndex; i < startIndex + count; i++) {
                $chartRows.splice(i, 1);
            }
        },


        //helper method to bind querytaskbarinfo events to ganttchart rows
        _eventBindings: function () {

            var $ganttChartRows = $(this.getGanttChartRows()),
                rowsLength = $ganttChartRows.length,
                taskbarContainer,
                args = {}, progressbar, taskbar,
                parentProgressbar,manualParentTaskbar, parentTaskbar, taskElement, mileStone, taskbarText, baseline, baselineMileStone;

            if (rowsLength != 0) {

                for (var row = 0; row < rowsLength; row++) {

                    taskbarContainer = $ganttChartRows[row];

                    if ($(taskbarContainer).hasClass("e-ganttrowcell")) {
                        taskElement = $(taskbarContainer).find("td.e-chartcell").has("div.e-childContainer,div.e-parentContainer,div.e-gantt-milestone")[0].firstChild;
                        if ($(taskbarContainer).find(".e-gantt-milestone-container").closest('div').length > 0)
                            mileStone = $(taskbarContainer).find(".e-gantt-milestone-container").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baselinebar").closest('div').length > 0)
                            baseline = $(taskbarContainer).find(".e-baselinebar").closest('div')[0];

                        if ($(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div').length > 0)
                            baselineMileStone = $(taskbarContainer).find(".e-baseline-gantt-milestone").closest('div')[0];
                        
                        if ($(taskElement).hasClass("e-parentContainer")) {
                            parentTaskbar = taskElement.querySelector(".e-gantt-parenttaskbar-innerdiv");
                            parentProgressbar = taskElement.querySelector(".e-gantt-parenttaskbar-progress");
                            manualParentTaskbar = taskElement.querySelector(".e-gantt-manualparenttaskbar");
                        } else if ($(taskElement).hasClass("e-childContainer")) {

                            taskbar = taskElement.querySelector(".e-gantt-childtaskbar");
                            progressbar = taskElement.querySelector(".e-gantt-childtaskbar-progress");
                            taskbarText = progressbar && progressbar.querySelector(".e-tasklabel");
                        }

                        args.data = this.model.currentViewData[row];
                        args.taskbar = taskbarContainer;

                        args.taskbarBackground = taskbar != null ?
                            taskbar.style.backgroundColor : null;

                        args.progressbarBackground = progressbar != null ?
                            progressbar.style.backgroundColor : null;

                        args.parentTaskbarBackground = parentTaskbar != null ?
                            parentTaskbar.style.backgroundColor : null;

                        args.parentProgressbarBackground = parentProgressbar != null ?
                            parentProgressbar.style.backgroundColor : null;

                        args.parentProgressbarBorder = parentProgressbar != null ?
                            parentProgressbar.style.border : null;

                        args.progressbarBorder = progressbar != null ?
                            progressbar.style.border : null;

                        args.taskbarBorder = taskbar != null ?
                            taskbar.style.border : null;

                        args.parentTaskbarBorder = parentTaskbar != null ?
                            parentTaskbar.style.border : null;

                        args.taskbarTextColor = taskbarText != null ?
                            taskbarText.style.color : null;

                        if (args.data.isMilestone && !ej.isNullOrUndefined(baselineMileStone)) {
                            var baselineTop = baselineMileStone.querySelector(".e-baseline-milestone-top"),
                            baselineBottom = baselineMileStone.querySelector(".e-baseline-milestone-bottom");
                            if (baselineTop && baselineBottom) {
                                args.baselineBackground = baselineTop.style.borderTopColor;                                
                            }
                        }
                        else {
                            args.baselineBackground = baseline != null ?
                            baseline.style.backgroundColor : null;
                        }

                        args.milestoneBackground = mileStone != null ?
                            mileStone.style.backgroundColor : null;

                        if (args.data.hasChildRecords && !args.data.isAutoSchedule) {

                            args.manualParentTaskbarBackground = manualParentTaskbar != null ?
                                manualParentTaskbar.style.backgroundColor : null;
                        }

                        this._queryTaskbarinfo(args);
                    }
                }
            }
        },


        //to update the currentviewdata of ganttchart
        _updateCurrentViewData: function () {
            var proxy = this, margin = 0;
            if (!this.model.enableVirtualization) {
                this.model.currentViewData = this.model.updatedRecords;
            }
            else {
                this._getRenderedRowRange();

                //console.log("Gantt Chart Rendered Range Top: " + proxy._renderedRange.top + "Bottom :" + proxy._renderedRange.bottom);

                this.model.currentViewData = this.model.updatedRecords.slice(proxy._renderedRange.top,
                    proxy._renderedRange.bottom);
                if (proxy._vscrollDist !== 0) {
                    margin = proxy._scrollTop;
                    margin -= proxy._rowMargin;
                    $("#ganttViewTable" + proxy._id + "").css({ "top": margin + "px" });
                    $("#ganttgridLinesTable" + proxy._id + "").css({ "top": margin + "px" });
                }
                proxy._vTop = proxy._visibleRange.top;
                proxy._vBottom = proxy._visibleRange.bottom;
                proxy._rTop = proxy._renderedRange.top;
                proxy._rBottom = proxy._renderedRange.bottom;
            }

        },

       
        //to render ganttchart content
        renderGanttRecords: function () {

            var proxy = this;
            proxy._refresh();
            proxy._$ganttViewTable.append(proxy._$ganttViewTablebody);
            proxy._$bodyContent.append(proxy._$ganttViewTable);
        },

        _getRenderedRowRange: function () {

            var proxy = this;
            proxy._getVisibleRowRange();
            var topIndex = proxy._visibleRange.top;
            var bottomIndex = proxy._visibleRange.bottom;
            proxy._renderedRange = { top: topIndex, bottom: bottomIndex };
            return proxy._renderedRange;
        },

        _getVisibleRowRange: function () {

            var proxy = this,
                top = proxy._scrollTop / proxy.model.rowHeight,
                coeff = top - Math.floor(top),
                topIndex,
                bottomIndex, length;

            //console.log("GanttChart ScrollTop :" + proxy._scrollTop);

            proxy._rowMargin = coeff * proxy.model.rowHeight;
            topIndex = Math.floor(top);
            length = proxy.model.updatedRecords.length;
            bottomIndex = proxy._getrowposition(proxy._scrollTop + proxy._viewportHeight);
            topIndex = Math.max(0, topIndex);
            bottomIndex = Math.min(length, bottomIndex);
            proxy._visibleRange = { top: topIndex, bottom: bottomIndex };
        },

        _getrowposition: function (y) {
            return Math.ceil((y) / this.model.rowHeight);
        },


        //returns the date object
        _getDateType: function (date) {

            if (date instanceof Date) {
                return date;
            }
            else if (date != null) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
            return null;
        },

        // Returns the date as per date format
        _getDateFromFormat: function (date) {

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },

        _createScheduleTopDayTemplate: function () {
            var proxy = this,
                model = proxy.model,
                dayFormat = model.scheduleHeaderSettings.dayHeaderFormat == "" && model.scheduleHeaderSettings.scheduleHeaderType == "day"
                            ? "ddd" : model.scheduleHeaderSettings.dayHeaderFormat,
                helpers = {};
                    helpers["_" + proxy._id + "renderDayTop"] = $.proxy(proxy._getDaySplit, proxy);
            $.views.helpers(helpers);

            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:"
                + ((proxy.model.perHourWidth * 24)) + "px;'>";

            var td = "<div class='e-schedule-week-headercell-content'  style='width:"
                + ((proxy.model.perHourWidth*24)-1) + "px;box-sizing:border-box;margin:auto;white-space:nowrap;'>"
                + "{{:~_" + proxy._id + "renderDayTop('" + dayFormat + "',#data)}}" + "</div>" +
            "</div>"

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleTopDayTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper methood for day schedule mode

        _getDaySplit: function (dateformat,data) {
            var date = new Date(data),
               proxy = this,
               model = proxy.model,
               formatedDate;
            switch (dateformat) {
                case "D":
                case "d":
                    return date.getDate();
                case "DD":
                case "dd":
                    return (('0' + date.getDate()).slice(-2));
                case "DDD":
                case "ddd":
                case "DDDD":
                case "dddd":
                    return ej.format(date, dateformat, model.locale);
            }
            formatedDate = ej.format(date, dateformat, model.locale);
            return formatedDate;
        },


        // Month Week Schedule Mode

        _createScheduleTopMonthTemplate: function () {

            var proxy = this, td, i = 0,
                model = proxy.model,
                monthFormat = model.scheduleHeaderSettings.monthHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderMonthTop"] = $.proxy(proxy._getMonthsplit, proxy);
                helpers["_" + proxy._id + "setMonthWidth"] = $.proxy(proxy._setMonthWidth, proxy);
                helpers["_" + proxy._id + "isLastMonth"] = $.proxy(proxy._checkLastMonthWidth, proxy);

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:{{:~_" + proxy._id + "setMonthWidth(#data)}}" + "px;'>";

            td = "<div class='e-schedule-week-headercell-content'  style='box-sizing:border-box;-moz-box-sizing:border-box;margin:auto;white-space:nowrap;width:{{:~_" + proxy._id + "setMonthWidth(#data)-1}}" + "px;'>"
                + "{{:~_" + proxy._id + "renderMonthTop('" + monthFormat + "',#data)}}" + "</div>"
                 + "{{if ~_" + proxy._id + "isLastMonth(#data)}}"
                 + "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;'>"
                    + "<div class='e-schedule-week-headercell-content' style='box-sizing:border-box;-moz-box-sizing:border-box;margin:auto;white-space:nowrap;width:" + (proxy._balanceWidth - 1) + "px;'>"
                +"</div></th>{{/if}}"
            
                parentTr += td;
                parentTr += "</th>";
                //if (proxy._balanceWidth) {
                //    parentTr += tdx;
                //    parentTr += "</th>";
                //}

            var templates = {};
            templates[proxy._id + "ScheduleTopMonthTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for calculating unique month width
        _setMonthWidth: function (data) {
            var proxy = this;
            var date;
            if (typeof data === "object") {
                date = new Date(data);
            }
            else {
                date = ej.parseDate(data, this.model.dateFormat, this.model.locale);
            }

            var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

            var lastDate = monthLastDay.getDate();
            // condition to check whether first month having only few weeks.
            if (date.getTime() === proxy.model.scheduleMonths[0].getTime())
            {
                var datediff = monthLastDay.getDate() - date.getDate();
                return (this.model.perDayWidth * (datediff+1));
            }
            else if (lastDate == 31)
                return (this.model.perDayWidth * 31);
            else if (lastDate == 30)
                return (this.model.perDayWidth * 30);
            else if (lastDate == 28)
                return (this.model.perDayWidth * 28);
            else if (lastDate == 29)
                return (this.model.perDayWidth * 29);
        },

        _checkLastMonthWidth: function (data) {
            var proxy = this;
            if (data == proxy.model.scheduleMonths[proxy.model.scheduleMonths.length - 1] && proxy._balanceWidth>0) {
                return true;
            }
            else
            {
                return false;
            }
        },


        //helper method for _createScheduleMonthTemplate
        _getMonthsplit: function (monthFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;

            formatedDate = ej.format(date, monthFormat, model.locale);
            return formatedDate;

        },


        _createScheduleYearTemplate: function () {

            var proxy = this, td,
                model = proxy.model,
                yearFormat = model.scheduleHeaderSettings.yearHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderYear"] = $.proxy(proxy._getYearsplit, proxy);
                helpers["_" + proxy._id + "getYearWidth"] = $.proxy(proxy._getTemplateYearWidth, proxy);

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:{{:~_" + proxy._id + "getYearWidth(#data)}}px;'>";
            
            td = "<div class='e-schedule-week-headercell-content' style='margin:auto;white-space:nowrap;width:{{:~_" + proxy._id + "getYearWidth(#data)-1}}px;box-sizing:border-box;-moz-box-sizing:border-box;'>"
                + "{{:~_" + proxy._id + "renderYear('" + yearFormat + "',#data)}}" + "</div>";

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleYearTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for _createScheduleYearTemplate
        _getYearsplit: function (yearFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;

            formatedDate = ej.format(date, yearFormat, model.locale);
            return formatedDate;

        },

        _getMonthWidthForYearMode: function (date) {
            var proxy = this,
                model = proxy.model,
                date,
                dayCount = 0;
                // get the number of months the year contains
                // endMonth = new Date(date.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;
                //endMonth = new Date(date.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;
            
            //loop through the each month to get the days count
            for (var i = date.getMonth() ; i < 12; i++) {
                var startDate = date;

                if (typeof startDate === "object") {
                    date = new Date(startDate);
                }
                else {
                    date = ej.parseDate(startDate, model.dateFormat, model.locale);
                }
                var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);
                var beginDate =date.getDate();
                var lastDate = monthLastDay.getDate();
                if (beginDate != 1)
                    dayCount += lastDate - date.getDate();
                else if (lastDate == 31)
                    dayCount += 31;
                else if (lastDate == 30)
                    dayCount += 30;
                else if (lastDate == 28)
                    dayCount += 28;
                else if (lastDate == 29)
                    dayCount += 29;
                date=new Date(date.getFullYear(), i+1, 1);

            }
            return dayCount;
        },

        _getTemplateYearWidth: function (date) {

            var year = date.getFullYear(),
                monthWidth = this._getMonthWidthForYearMode(date);
            return monthWidth * this.model.perDayWidth;
        },
        //Template to render schedule week view
        _createScheduleWeekTemplate: function () {

            var proxy = this, td,
                model = proxy.model,
                dateFormat = model.scheduleHeaderSettings.weekHeaderFormat,
                helpers = {};
                    helpers["_" + proxy._id + "renderWeek"] = $.proxy(proxy._getWeeksplit, proxy);

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-week-headercell' style='box-sizing:border-box;-moz-box-sizing:border-box;width:"+ (proxy._scheduleWeekWidth) + "px;'>";

            td = "<div class='e-schedule-week-headercell-content'  style='width:"
                + (proxy._scheduleWeekWidth - 1) + "px;box-sizing:border-box;margin:auto;white-space:nowrap;'>"
                + "{{:~_" + proxy._id + "renderWeek('" + dateFormat + "',#data)}}" + "</div>";

            parentTr += td;
            parentTr += "</th>";

            var templates = {};
            templates[proxy._id + "ScheduleWeekTemplate"] = parentTr;
            $.templates(templates);
        },

        //helper method for _createScheduleWeekTemplate
        _getWeeksplit: function (dateFormat, data) {

            var date = new Date(data),
                proxy = this,
                model = proxy.model,
                formatedDate;
            formatedDate = ej.format(date, dateFormat, model.locale);

            return formatedDate.toLowerCase().replace(/(-(\w)|(^| )(\w)|:(\w)|,(\w)|\/(\w)|\.(\w))/g, function (x) {
                return x.toUpperCase();
            });
        },

        _createScheduleHourTemplate: function () {
            var proxy = this, model = proxy.model,td,
                hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderHour"] = $.proxy(proxy._getHourTemplate, proxy);

            $.views.helpers(helpers);
            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + (proxy.model.perHourWidth) + "px;'>";
            td = "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perHourWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~_" + proxy._id + "renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "scheduleHourTemplate"] = parentTr;
            $.templates(templates);
        },
        //Method to create template for upper part of schedule header in hour-minute schedule mode.
        _createScheduleTopHourTemplate: function () {
            var proxy = this, model = proxy.model, minuteInterval = model.minuteInterval, td, interval,
                hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderHour"] = $.proxy(proxy._getHourTemplate, proxy);

            if (minuteInterval == 30)
                interval = 2;
            if (minuteInterval == 15)
                interval = 4;
            if (minuteInterval == 5)
                interval= 12;
            if (minuteInterval == 1)
                interval = 60;
            proxy._totalInterval = interval;//To calculate schedule length
            $.views.helpers(helpers);
            var parentTr = "<th  class='e-schedule-hour-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + ((proxy.model.perMinuteWidth * interval)) + "px;'>";
            td = "<div class='e-schedule-hour-headercell-content' style='width:"
                + ((proxy.model.perMinuteWidth*interval)-1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~_" + proxy._id + "renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "ScheduleTopHourTemplate"] = parentTr;
            $.templates(templates);
        },
        //Method to create template for lower part of schedule header in hour-minute schedule mode.
        _createMinuteTemplate: function () {
            var proxy = this, model = proxy.model, td,
                hourHeaderFormat = model.scheduleHeaderSettings.minuteHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderHour"] = $.proxy(proxy._getHourTemplate, proxy);

            $.views.helpers(helpers);
            var parentTr = "<th class='e-schedule-hour-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:"
                + (proxy.model.perMinuteWidth) + "px;'>";
            td = "<div class='e-schedule-hour-headercell-content' style='width:"
                + (proxy.model.perMinuteWidth-1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip'>" +
                "{{:~_" + proxy._id + "renderHour('" + hourHeaderFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "scheduleMinuteTemplate"] = parentTr;
            $.templates(templates);
        },
        _getHourTemplate: function (format,data) {
            var date = new Date(data),
              proxy = this,
              model = proxy.model,
              formatedDate;

            formatedDate = ej.format(date, format, model.locale);
            return formatedDate;
        },


        //Template to render schedule week view in month-week schedule mode
        _createScheduleBottomWeekTemplate: function () {

            var proxy = this, td, model = proxy.model,
                weekFormat = model.scheduleHeaderSettings.weekHeaderFormat,
                helpers = {};
            helpers["_" + proxy._id + "renderWeek"] = $.proxy(proxy._getMonthWeekTemplate, proxy);

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perWeekWidth) + "px;'>";
            td = "<div class='e-schedule-day-headercell-content' style='position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;padding-left:2px;width:" + (proxy.model.perWeekWidth-1) + "px;'>" +
                "{{:~_" + proxy._id + "renderWeek('" + weekFormat + "',#data)}}</div>";

            parentTr += td;

            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "ScheduleBottomWeekTemplate"] = parentTr;
            $.templates(templates);
        },

        _getMonthWeekTemplate: function (weekFormat, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;

            //date.setDate(date.getDate() + (weekLength * 7));

            switch (weekFormat) {
                case "d":
                case "dd":
                    //return (('0' + date.getDate()).slice(-2));
                case "ddd":

                default: return ej.format(date, weekFormat, model.locale);
            }
        },




        //Template to render schedule day view
        _createScheduleMonthTemplate: function () {

            var proxy = this, td, model = proxy.model,
                monthFormat = model.scheduleHeaderSettings.monthHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderMonth"] = $.proxy(proxy._getMonthTemplate, proxy);
                helpers["_" + proxy._id + "getMonthWidth"] = $.proxy(proxy._setMonthWidthYearMode, proxy);

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:{{:~_" + proxy._id + "getMonthWidth(#data)}}px;'>" +

                "<div class='e-schedule-day-headercell-content' style='"
                + "position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;width:{{:~_" + proxy._id + "getMonthWidth(#data)-1}}px;'>" +
                "{{:~_" + proxy._id + "renderMonth('" + monthFormat + "',#data)}}</div></th>";

            
            var templates = {};
            templates[proxy._id + "ScheduleMonthTemplate"] = parentTr;
            $.templates(templates);
        },

        _getMonthTemplate: function (monthFormat, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;
            switch (monthFormat) {
                case "M":
                case "m":
                    return (('0' + date.getDate()).slice(-2));
                case "MM":
                case "mm":
                    return date.getDate();
                case "MMM":
                case "mmm":
                case "MMMM":
                case "mmmm":
                    return ej.format(date, monthFormat, model.locale);
                default: return ej.format(date, monthFormat, model.locale);
            }
        },

        //For year template set month width accordance with num of days
        _setMonthWidthYearMode: function (data) {

            var proxy = this;
            var date = new Date(data);
            var monthLastDay = new Date(date.getFullYear(), date.getMonth() + 1, 0);

            var beginDate = date.getDate();
            var lastDate = monthLastDay.getDate();

            if (beginDate != 1)
                return (this.model.perDayWidth * (lastDate - date.getDate()));
            else if (lastDate == 31)
                return (this.model.perDayWidth * 31);
            else if (lastDate == 30)
                return (this.model.perDayWidth * 30);
            else if (lastDate == 28)
                return (this.model.perDayWidth * 28);
            else if (lastDate == 29)
                return (this.model.perDayWidth * 29);

        },      
        _getHeaderWeek: function (length, weekday) {
            var date = new Date(weekday);
            date.setDate(date.getDate() + length);
            if (this._nonWorkingDayIndex.indexOf(date.getDay()) != -1) {
                return true;
            }         
        },


        //Template to render schedule day view
        _createScheduleDayTemplate: function () {

            var proxy = this, td, model = proxy.model,
                dayFormat = model.scheduleHeaderSettings.dayHeaderFormat == "" && model.scheduleHeaderSettings.scheduleHeaderType == "day"
                            ? "ddd" : model.scheduleHeaderSettings.dayHeaderFormat,
                helpers = {};
                helpers["_" + proxy._id + "renderDay"] = $.proxy(proxy._getDayTemplate, proxy);                 
                helpers["_" + proxy._id + "getHeader"] = $.proxy(proxy._getHeaderWeek, proxy);

            $.views.helpers(helpers);

            var parentTr = "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(0,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;" +
                "{{if ~_" + proxy._id + "getHeader(0,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>";
            td = "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(0,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',0,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(1,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_" + proxy._id + "getHeader(1,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(1,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',1,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(2,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_" + proxy._id + "getHeader(2,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(2,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',2,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(3,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_" + proxy._id + "getHeader(3,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(3,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',3,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(4,#data)}} e-headercell-weekend {{/if}}'" +
                " style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_" + proxy._id + "getHeader(4,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(4,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',4,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(5,#data)}} e-headercell-weekend {{/if}}'" +
                " style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;{{if ~_" + proxy._id + "getHeader(5,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(5,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',5,#data)}}</div>" +

                "<th  class='e-schedule-day-headercell {{if ~_" + proxy._id + "getHeader(6,#data)}} e-headercell-weekend {{/if}}' " +
                "style='-moz-box-sizing:border-box;box-sizing:border-box;width:" + (proxy.model.perDayWidth) + "px;" +
                "{{if ~_" + proxy._id + "getHeader(6,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "<div class='e-schedule-day-headercell-content' style='width:"
                + (proxy.model.perDayWidth - 1) + "px;position:static;box-sizing:border-box;overflow:hidden;text-overflow:clip;{{if ~_" + proxy._id + "getHeader(6,#data)}} background-color:" + this.model.scheduleHeaderSettings.weekendBackground + "{{/if}}'>" +
                "{{:~_" + proxy._id + "renderDay('" + dayFormat + "',6,#data)}}</div>";

            parentTr += td;
            parentTr += "</th>";
            var templates = {};
            templates[proxy._id + "_CustomTemplate1"] = parentTr;
            $.templates(templates);
        },

        _getDayTemplate: function (dayFormat, dayLength, data) {

            var date = new Date(data),
                proxy = this, model = proxy.model;
            date.setDate(date.getDate() + dayLength);

            switch (dayFormat) {
                case "D":
                case "d":
                    return date.getDate();
                case "DD":
                case "dd":
                    return (('0' + date.getDate()).slice(-2));                    
                case "DDD":
                case "ddd":
                case "DDDD":
                case "dddd":
                    return ej.format(date, dayFormat, model.locale);                                  
                case "":
                    dayFormat = "ddd";
                    return ej.format(date, dayFormat, model.locale)[0].toUpperCase();
                default:                    
                    return ej.format(date, dayFormat, model.locale).toUpperCase();
            }
        },

        // get schedule months for year month schedule mode.
        _getScheduleMonth: function (startdate, enddate) {
            var proxy = this,
                model = proxy.model,
                dates = [],
                count = 0;

            enddate = enddate.getMonth() < 11 ? new Date(enddate.getFullYear(), 11, 31) : enddate;
            var endMonth = new Date(startdate.getFullYear(), 11, 31) < new Date(model.scheduleEndDate) ? 12 : new Date(model.scheduleEndDate).getMonth() + 1;

          
            for (var i = startdate.getMonth() ; startdate < enddate; i++) {
                dates.push(startdate);
                startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, 1);
                //startdate.setMonth(i + 1);
            }

            return dates;
        },


        //Method to render schedule header
        _createSchedule: function (startdate, enddate) {

            var proxy = this,
                model=proxy.model,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                $colsgroup, $column, $thead,
                $tr, $td, $div, $table;

            startdate = startdate == null ? new Date() : startdate;
            enddate = enddate == null ? new Date(null) : enddate;

            proxy._createScheduleWeekTemplate();
            proxy._createScheduleYearTemplate();
            proxy._createScheduleTopMonthTemplate();//template for MONTH week schedule mode
            proxy._createScheduleTopDayTemplate();
            proxy._createScheduleTopHourTemplate();
            $table = ej.buildTag("table.e-schedule-headerrow-week e-zerospacing", "",
                { 'display': 'block' }                
            );

            $colsgroup = ej.buildTag("colgroup", "", {}, {});
            $column = $(document.createElement("col"));
            $column.css("width", proxy._getScheduleLength(scheduleMode) + 'px');
            
            $colsgroup.append($column);

            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});

            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleWeekTemplate"](proxy.model.scheduleWeeks), {}, {});
            else if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleYearTemplate"](proxy.model.scheduleYears), {}, {});
            else if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopMonthTemplate"](proxy.model.scheduleMonths), {}, {});
            else if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopDayTemplate"](proxy.model.scheduleDays), {}, {});
            else if (scheduleMode == "hour")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleTopHourTemplate"](proxy.model.scheduleHours), {}, {});

            $td = ej.buildTag("th.e-ganttchart-schedule", "", {}, {});
            $div = ej.buildTag("div.e-ganttchart-schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            $tr = null;

            proxy._createScheduleDayTemplate();
            proxy._createScheduleMonthTemplate();//for year - month schedule mode
            proxy._createScheduleBottomWeekTemplate(); //for month - week schedule mode
            proxy._createMinuteTemplate();
            proxy._createScheduleHourTemplate();

            $table = ej.buildTag("table.e-schedule-headerrow-day e-zerospacing", "",
                {
                    'display': 'block',
                    'border-collapse': 'collapse'
                });
            $thead = ej.buildTag("thead.e-ejganttschedule", "",
                { 'display': 'block', 'border-collapse': 'collapse' }, {});
            
            var scheduleMonths = proxy._getScheduleMonth(new Date(model.scheduleYears[0]), enddate);
            if (scheduleMode == "week")
                $tr = ej.buildTag("tr", $.render[this._id + "_CustomTemplate1"](model.scheduleWeeks), {}, {});
            if (scheduleMode == "year")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleMonthTemplate"](scheduleMonths), {}, {});
            if (scheduleMode == "month")
                $tr = ej.buildTag("tr", $.render[this._id + "ScheduleBottomWeekTemplate"](proxy._numOfWeeks), {}, {});
            if (scheduleMode == "day")
                $tr = ej.buildTag("tr", $.render[this._id + "scheduleHourTemplate"](proxy._getScheduleHours()), {}, {});
            if (scheduleMode == "hour")               
                 $tr = ej.buildTag("tr", $.render[this._id + "scheduleMinuteTemplate"](proxy._getScheduleMinutes()), {}, {});

            $td = ej.buildTag("th.e-ganttchart-schedule", "", {}, {});
            $div = ej.buildTag("div.e-ganttchart-schedule", "", { 'width': 20 + 'px' }, {});
            $td.append($div);
            $tr.append($td);

            $thead.append($tr);
            $table.append($colsgroup);
            $table.append($thead);
            proxy._$scheduleDiv.append($table);

            proxy._$headerContainer.append(proxy._$scheduleDiv);
            proxy._$ganttChartContainer.append(proxy._$headerContainer);
            $("#" + proxy._id).append(proxy._$ganttChartContainer);
        },

        _getScheduleHours: function () {
            var proxy = this, model = proxy.model,
                startHour = new Date(proxy.model.projectStartDate),
                endHour = new Date(model.projectEndDate);
                proxy._scheduleHours = [];
                endHour.setHours(24);
            do {
                proxy._scheduleHours.push(new Date(startHour));
                startHour.setHours(startHour.getHours() + 1);
            } while (!(startHour.getTime()>= endHour.getTime()));

            return proxy._scheduleHours;
        },
        //Calculate total number of minutes to render template.
        _getScheduleMinutes: function () {
            var proxy = this, model = proxy.model,                
                startDate = new Date(proxy.model.projectStartDate),
                endDate = new Date(model.projectEndDate);
            endDate.setMinutes(60);
            startDate.setMinutes(0);
            proxy._scheduleMinutes = [];
            do {
                proxy._scheduleMinutes.push(new Date(startDate));
                startDate.setMinutes(startDate.getMinutes() + model.minuteInterval);
            } while (!(startDate.getTime() >= endDate.getTime()));
        
            return proxy._scheduleMinutes;
        },
        createGridLinesTable: function () {
            var proxy=this,
                model = proxy.model,
                $gridLinesTable,
                gridLineTable,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleLength,
                tableRows;

            $gridLinesTable = ej.buildTag("table.e-ganttgridLinesTable e-zerospacing#ganttgridLinesTable" + proxy._id, "", {
                'z-index': '2',
                'position': 'absolute',
            });
            var $colsgroup = ej.buildTag("colgroup", "", {}, {});
            var $column = $(document.createElement("col"));

            switch (scheduleMode) {
                case "week":
                    scheduleLength = model.scheduleWeeks.length,
                    $gridLinesTable.css("width",(scheduleLength * proxy._scheduleWeekWidth) + 'px');
                    $column.css("width", (scheduleLength * this._scheduleWeekWidth) + 'px');
                    break;

                case "year":
                    scheduleLength = model.scheduleYears.length,                    
                    $gridLinesTable.css("width", (proxy._scheduleYearWidth) + 'px');
                    $column.css("width", (this._scheduleYearWidth) + 'px');

                    break;
                case "month":
                    scheduleLength = model.scheduleMonths.length,
                    $gridLinesTable.css("width", (proxy._scheduleMonthWidth) + 'px');
                    $column.css("width", (this._scheduleMonthWidth) + 'px');
                    break;
                case "day":
                    scheduleLength = model.scheduleDays.length,
                    $gridLinesTable.css("width", (scheduleLength * (proxy.model.perHourWidth*24)) + 'px');
                    $column.css("width", (scheduleLength * (proxy.model.perHourWidth * 24)) + 'px');
                    break;
                case "hour":
                    scheduleLength = model.scheduleHours.length,
                    $gridLinesTable.css("width", (scheduleLength * (proxy.model.perMinuteWidth * proxy._totalInterval)) + 'px');
                    $column.css("width", (scheduleLength * (proxy.model.perMinuteWidth * proxy._totalInterval)) + 'px');
                    break;
                default:
                    break;

            }

            $colsgroup.append($column);
            $gridLinesTable.append($colsgroup);

            tableRows = proxy._createGridLinesTableRow(model.updatedRecords.length);
            
            var $gridLinesTablebody = ej.buildTag("tbody.e-gantt-viewer-gridLinesTablebody#gridLinesTablebody" + proxy._id + "",
                tableRows, {}, {});
            proxy._$gridLinesTablebody = $gridLinesTablebody;
            $gridLinesTable.append(proxy._$gridLinesTablebody);
            proxy._$bodyContent.append($gridLinesTable);
        },


        _createGridLinesTableRow: function (length) {
            var proxy = this,
                tableRows="";

            for (var i = 0; i < length; i++) {
                tableRows += "<tr style='display:table-row;height:" + this.model.rowHeight + "px'><td class='e-ganttgridlines'></td></tr>";
            }
            return tableRows;
        },

        _SelectState: function (args) {
            var proxy = this,
                model = this.model;
            if (model.allowSelection)
                return true;
            else
                return false;
        },

        _getFontSize: function () {
            var proxy = this,
                model = proxy.model,
                taskbarHeight = model.taskbarHeight, fontSize;
            fontSize = (70 * taskbarHeight) / 100;
            var decimalPoint = fontSize % 1;
            fontSize = decimalPoint == 0.5 ? fontSize : (decimalPoint < 0.5 ? Math.floor(fontSize) : Math.ceil(fontSize));
            return fontSize;
        },
        _getLeftTaskLabel: function () {
            var proxy = this,
                model = proxy.model,
                leftMappingItems = "",
                length = model._columns.length;
         
            if (this.model.leftTaskLabelMapping == this.model.resourceNameMapping)
                leftMappingItems = "{{:~_" + proxy._id + "resources(#data)}}";
            else if (this.model.leftTaskLabelMapping == this.model.predecessorMapping)
                leftMappingItems = "{{:predecessorsName}}";
            else {
                for (var i = 0; i < length; i++) {
                    if (this.model.leftTaskLabelMapping == model._columns[i].mappingName) {
                        leftMappingItems = "{{:" + model._columns[i].field + "}}";
                        break;
                    }
                }
            }
            if (leftMappingItems == "") {
                leftMappingItems = "{{:" + this.model.leftTaskLabelMapping + "}}";
            }
            return leftMappingItems;
        },
        _getRightTaskLabel: function () {
            var proxy = this,
                model = proxy.model,
                rightMappingItems = "",
                length = model._columns.length;
            if (this.model.rightTaskLabelMapping == this.model.resourceNameMapping)
                rightMappingItems = "{{:~_" + proxy._id + "resources(#data)}}";
            else if (this.model.rightTaskLabelMapping == this.model.predecessorMapping)
                rightMappingItems = "{{:predecessorsName}}";
            else {
                for (var i = 0; i < length; i++) {
                    if (this.model.rightTaskLabelMapping == model._columns[i].mappingName) {
                        rightMappingItems = "{{:" + model._columns[i].field + "}}";
                        break;
                    }
                }
            }
            if (rightMappingItems == "") {
                rightMappingItems = "{{:" + this.model.rightTaskLabelMapping + "}}";
            }
            return rightMappingItems;
        },

        _getMargin: function () {
            var proxy = this,
                taskbarHeight = this.model.taskbarHeight, margin;
            margin = (taskbarHeight - proxy._fontSize-3) / 2;                        
            return Math.floor(margin);
        },

        _getResizerLeftAdjust: function () {
            var proxy = this,
                taskbarHeight = this.model.taskbarHeight,
                fontSize = proxy._fontSize,
                margin = proxy._resizerMargin, leftResize;
            leftResize = (2 * taskbarHeight) / 100;
            var decimalPoint = leftResize % 1;
            leftResize = decimalPoint < 0.5 ? Math.floor(leftResize) : Math.ceil(leftResize);
            leftResize = leftResize < 0 ? 0 : leftResize;
            return leftResize;
        },

        //Template to render taskbar and milestone items
        _createTaskbarTemplate: function () {

            var proxy = this,
                model = proxy.model,
                tdWidth,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                tr, baselineHeight = 4, taskbarHeight, baseLineTop,
                shrinkedTaskbarHeight = 0,
                labelHeight,
                milesStoneRadius = 0,
                connectorPointWidth = 0,
                connectorPointRadius = 0,
                connectorPointMargin = 0,
                tHeight = 0,
                leftLabelFlag = false,
                rightLabelFlag = false,
                leftField = "",
                touchLeftConnectorpoint = "",
                touchRightConnectorpoint = "",
                rightField = "", istouchLeftConnectorpoint = false,
                baselineColor = model.baselineColor,
                template = model.taskbarTemplate, taskbarTemplate, isTaskbarTemplate = false, isProgressbarTemplate = false,
                parentTemplate = model.parentTaskbarTemplate, parentTaskbarTemplate, isParentTaskbarTemplate = false, isParentProgressbarTemplate = false,
                milestoneTemplate = model.milestoneTemplate, isMilestoneTemplate = false, milestoneTemplateString = "",
                leftTaskLabelTemplate = model.leftTaskLabelTemplate, isLeftTaskLabelTemplate = false, leftTaskLabelTemplateString = "",
                rightTaskLabelTemplate = model.rightTaskLabelTemplate, isRightTaskLabelTemplate = false, rightTaskLabelTemplateString = "",
                helpers = {};
                helpers["_" + proxy._id + "SelectState"] = $.proxy(proxy._SelectState, proxy);
                helpers["_" + proxy._id + "getType"] = proxy._getTypedata;
                helpers["_" + proxy._id + "expander"] = proxy._addRecordExpandCollapse;
                helpers["_" + proxy._id + "milestoneMapping"] = proxy._isMilestone;
                helpers["_" + proxy._id + "resources"] = $.proxy(proxy._getResourceInfo, proxy);
                helpers["_" + proxy._id + "rowClassName"] = ej.TreeGrid._getrowClassName;//proxy._getrowClassName,
                helpers["_" + proxy._id + "expandStatus"] = $.proxy(proxy._getExpandStatusRecord, proxy);
                helpers["_" + proxy._id + "borderRadius"] = proxy._getBorderRadius;

            proxy._fontSize = proxy._getFontSize();
            proxy._resizerRightAdjust = proxy._fontSize * 0.8;
            proxy._resizerMargin = proxy._getMargin();
            proxy._resizerLeftAdjust = proxy._getResizerLeftAdjust();

            if (scheduleMode == "week") {
                tdWidth = model.scheduleWeeks.length * proxy._scheduleWeekWidth;
            }
            else if (scheduleMode == "year") {
                tdWidth = proxy._scheduleYearWidth;
            }
            else if (scheduleMode == "month") {
                tdWidth = proxy._scheduleMonthWidth;
            }
            else if (scheduleMode == "day") {
                tdWidth = model.scheduleDays.length * (model.perHourWidth * 24);
            }
            else if (scheduleMode == "hour") {
                tdWidth = model.scheduleHours.length * (model.perMinuteWidth * proxy._totalInterval);
            }
            if (model.renderBaseline) {
                //taskbarHeight = model.rowHeight;
                var height;
                if ((model.taskbarHeight + baselineHeight) <= model.rowHeight) {
                    height = model.taskbarHeight;
                    baseLineTop = 0;
                }
                else {
                    height = model.taskbarHeight - baselineHeight;
                    baseLineTop = -4;
                }
                taskbarHeight = height;
                shrinkedTaskbarHeight = 0;
                labelHeight = model.rowHeight - baselineHeight - 5;
            } else {
                taskbarHeight = model.taskbarHeight;
                labelHeight = model.rowHeight - 10;
            }
            tHeight = taskbarHeight /5;
            milesStoneRadius = Math.floor((model.taskbarHeight) / 2);
            proxy._milesStoneWidth = (milesStoneRadius * 2);
            proxy._connectorPointWidth = connectorPointWidth = taskbarHeight / 2;
            connectorPointRadius = connectorPointWidth / 2;
            connectorPointMargin = connectorPointWidth - (connectorPointWidth / 2);
            $.views.helpers(helpers);

            if (!model.progressMapping) {


                this.model.showProgressStatus = false;
            }

            if (!model.resourceInfoMapping) {
                model.showResourceNames = false;
            }

            //Process child taskbar template
            if (template) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var templateString = template.charAt(0);
                isTaskbarTemplate = true;
                var taskbarTemplateString = "";
                if (template.charAt(0) == "#") {
                    taskbarTemplate = $(template)[0].innerHTML;
                }
                else
                    taskbarTemplate = template;
                taskbarTemplate = taskbarTemplate.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(taskbarTemplate);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-taskbar")) {
                        var classes = "e-gantt-childtaskbar " + $(this).attr("class");
                        $(this).css({ "height": (taskbarHeight) + "px"}).attr("class", classes);
                        var innerHtml = "";
                        $(this.childNodes).each(function () {
                            if ($(this).hasClass("e-gantt-template-progressbar")) {
                                isProgressbarTemplate = true;
                                var classes = "e-gantt-childtaskbar-progress " + " " + $(this).attr("class");
                                $(this).css({
                                    "height": (model.progressbarHeight * ((taskbarHeight) / 100)) + "px",
                                    "position": "absolute", "top": "-1px", "left": "-1px",
                                }).attr("class", classes);
                                var outerHtml = this.outerHTML,
                                    index = outerHtml.indexOf("style");
                                outerHtml = outerHtml.substr(0, index + 7) + "border-style:{{if progressWidth}}solid{{else}}none{{/if}};width:{{:progressWidth}}px;" + outerHtml.substr(index + 7);
                                innerHtml += outerHtml;
                            }
                            else
                                innerHtml += (this.nodeName == "#comment" ? "" : (this.nodeName == "#text") ? (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")) : this.outerHTML);
                        });
                        var outerHtml = $(this).clone().empty()[0].outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left}}px;width:{{:width}}px;" + outerHtml.substr(index + 7);
                        var innerIndex = (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) ? outerHtml.indexOf("</" + this.tagName + ">") : outerHtml.indexOf("</" + this.tagName.toLowerCase() + ">");
                        outerHtml = outerHtml.substr(0, innerIndex) + innerHtml + outerHtml.substr(innerIndex);
                        taskbarTemplateString += outerHtml;
                    }
                    else {
                        taskbarTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                taskbarTemplateString = taskbarTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            //Process parent taskbar template
            if (parentTemplate) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var parentTemplateString = parentTemplate.charAt(0);
                isParentTaskbarTemplate = true;
                var parentTaskbarTemplateString = ""
                if (parentTemplateString == "#") {
                    parentTaskbarTemplate = $(parentTemplate)[0].innerHTML;
                }
                else
                    parentTaskbarTemplate = parentTemplate;
                parentTaskbarTemplate = parentTaskbarTemplate.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(parentTaskbarTemplate);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-taskbar")) {
                        $(this).addClass("e-parentTask");
                        var classes = "e-gantt-parenttaskbar-innerdiv e-parentTask" + $(this).attr("class");
                        $(this).css({ "height": (taskbarHeight) + "px"}).attr("class", classes);
                        var innerHtml = "";
                        $(this.childNodes).each(function () {
                            if ($(this).hasClass("e-gantt-template-progressbar")) {
                                var classes = "e-gantt-parenttaskbar-progress e-parentTask" + " " +$(this).attr("class");
                                $(this).css({
                                    "height": (model.progressbarHeight * ((taskbarHeight) / 100)) + "px", "top": "-1px", "left": "-1px",
                                    "position": "absolute", "z-index": "3",
                                }).attr("class", classes);
                                var outerHtml = this.outerHTML,
                                    index = outerHtml.indexOf("style");
                                outerHtml = outerHtml.substr(0, index + 7) + "border-style:{{if progressWidth}}solid{{else}}none{{/if}};width:{{:progressWidth}}px;" + outerHtml.substr(index + 7);
                                innerHtml += outerHtml;
                            }
                            else {
                                innerHtml += (this.nodeName == "#comment" ? "" : (this.nodeName == "#text") ? (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")) : this.outerHTML);
                            }
                        });
                        var outerHtml = $(this).clone().empty()[0].outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left}}px;width:{{:width}}px;" + outerHtml.substr(index + 7);
                        var innerIndex = (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) ? outerHtml.indexOf("</" + this.tagName + ">") : outerHtml.indexOf("</" + this.tagName.toLowerCase() + ">");
                        outerHtml = outerHtml.substr(0, innerIndex) + innerHtml + outerHtml.substr(innerIndex);
                        parentTaskbarTemplateString += outerHtml;
                    }
                    else {
                        parentTaskbarTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                parentTaskbarTemplateString = parentTaskbarTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            // Process milestone template
            if (milestoneTemplate) {
                var parentDiv = ej.buildTag("div", "", {}, {});
                var templateString = milestoneTemplate.charAt(0), template;
                isMilestoneTemplate = true;
                if (templateString == "#") {
                    template = $(milestoneTemplate)[0].innerHTML;
                }
                else
                    template = milestoneTemplate;
                template = template.replace(/src/gi, proxy._id + "src");
                $(parentDiv[0]).html(template);
                $(parentDiv[0].childNodes).each(function () {
                    if ($(this).hasClass("e-gantt-template-milestone")) {
                        var classes = "e-gantt-milestone " + $(this).attr("class");
                        $(this).css({
                            "width": (model.taskbarHeight - 3) + "px", //6 is margin-top and margin-bottom total
                            "position": "absolute", "z-index": "3"
                        }).attr("class", classes);
                        var outerHtml = this.outerHTML,
                            index = outerHtml.indexOf("style");
                        outerHtml = outerHtml.substr(0, index + 7) + "left:{{:left -" + milesStoneRadius + "}}px;" + outerHtml.substr(index + 7);
                        milestoneTemplateString += outerHtml;
                    }
                    else {
                        milestoneTemplateString += (this.nodeName == "#comment" ? "" : (this.textContent ? this.textContent.replace(/(\r\n|\n|\r)/gm, "") : this.nodeValue.replace(/(\r\n|\n|\r)/gm, "")));
                    }
                });
                milestoneTemplateString = milestoneTemplateString.replace(RegExp((proxy._id + "src").toLowerCase(), "g"), "src");
            }

            //leftTaskLabelTemplate mapping
            if (leftTaskLabelTemplate)
            {

                var templateString = leftTaskLabelTemplate.charAt(0);
                if (templateString == "#") {
                    if ($(leftTaskLabelTemplate)[0]) {
                        leftTaskLabelTemplateString = $(leftTaskLabelTemplate)[0].innerHTML;
                    }
                } else if (document.getElementById(leftTaskLabelTemplate))
                    leftTaskLabelTemplateString = $("#" + leftTaskLabelTemplate)[0].innerHTML;
                else
                    leftTaskLabelTemplateString = leftTaskLabelTemplate;

                isLeftTaskLabelTemplate = true;

            }

            //rightTaskLabelTemplate mapping
            if (rightTaskLabelTemplate)
            {
                
                var templateString = rightTaskLabelTemplate.charAt(0);
                if (templateString == "#") {
                    if ($(rightTaskLabelTemplate)[0])
                        rightTaskLabelTemplateString = $(rightTaskLabelTemplate)[0].innerHTML;
                } else if (document.getElementById(rightTaskLabelTemplate))
                    rightTaskLabelTemplateString = $("#" + rightTaskLabelTemplate)[0].innerHTML;
                else
                    rightTaskLabelTemplateString = rightTaskLabelTemplate;

                isRightTaskLabelTemplate = true;

            }
            if (this.model.leftTaskLabelMapping  && isLeftTaskLabelTemplate == false) {
                leftLabelFlag = true;
                leftField = proxy._getLeftTaskLabel();
            }

            if (this.model.rightTaskLabelMapping && isRightTaskLabelTemplate == false) {
                rightLabelFlag = true;
                rightField = proxy._getRightTaskLabel();
            }
            if (this.model.taskbarHeight < 45) {
                touchLeftConnectorpoint = "<div class='e-connectortouchpoint' style='right:0px;width:20px;margin-top:" + ((connectorPointWidth - 20) / 2) + "px;height:20px;" +
                "border-radius:10px'></div>";
                touchRightConnectorpoint = "<div class='e-connectortouchpoint' style='left:0px;width:20px;margin-top:" + ((connectorPointWidth - 20) / 2) + "px;height:20px;"
                    +"border-radius:10px'></div>";
            } 

            var rightLabelRowHeight = Math.round(-((this.model.rowHeight - 1) / 2));

            var parentTr = "<tr class='{{:~_" + proxy._id + "rowClassName()}}  {{if isSelected && ~_" + proxy._id + "SelectState()}}e-ganttrowcell {{:~_" + proxy._id + "expander()}} e-gantt-mouseclick{{else}}e-ganttrowcell {{:~_" + proxy._id + "expander()}}{{/if}}'"
                + "style='display:{{:~_" + proxy._id + "expandStatus(#data)}};background-color:{{if rowBGColor }}{{:rowBGColor}}{{else}} none{{/if}};height:" + model.rowHeight + "px;'>";
            var radius = "{{:~_" + proxy._id + "borderRadius()}}";

            tr = "{{if ~_" + proxy._id + "getType()}}" +

                //Parent taskbar Item

                "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{if !isAutoSchedule}}{{if left<manualLeft}}{{:left-10}}{{else}}{{:manualLeft-10}}{{/if}}{{else}}{{:left-10}}{{/if}}px;overflow:hidden;text-overflow: ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;margin-right:30px;height:" + (labelHeight) + "px;font-weight:bold'>{{if " + isLeftTaskLabelTemplate + "}}" +
                leftTaskLabelTemplateString + "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>" +
                "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

                "<td  class='e-chartcell' style='width:" + tdWidth + "px; vertical-align:middle;'>" +

               "<div class='e-parentContainer{{if !isAutoSchedule}} e-manualParenttaskbar{{/if}}' style='height:" + (this.model.taskbarHeight-1) + "px;z-index:3;'>" +

                
                //Manual Parent taskbar
                "{{if !isAutoSchedule}}<div class='e-gantt-manualparenttaskbar {{:~_" + proxy._id + "expander()}}' style='left: {{:left}}px;height:" + (tHeight) + "px; width: {{:width}}px;'>" +
                "<div class='e-gantt-manualparenttaskbar-left' style='height:" + (taskbarHeight) + "px;border-left-width:" + tHeight + "px;border-bottom:" + tHeight + "px solid transparent;'></div>" +
                "<div class='e-gantt-manualparenttaskbar-right' style='left:{{:width - " + parseInt(tHeight) + "}}px;height:" + (taskbarHeight) + "px;border-right-width:" + tHeight + "px;border-bottom:" + tHeight + "px solid transparent;'></div>" +
                "<div class='e-taskbarresizer-right' style='left:{{:width -" + (tHeight) + "}}px;width:" + (tHeight) + "px;" +
                "height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;position:absolute;z-index:10;'></div>" +
                "</div>{{/if}}" +

                "{{if " + isParentTaskbarTemplate + "}}" + parentTaskbarTemplateString + "{{else}}" +
                "<div class='e-gantt-parenttaskbar-innerdiv {{:~_" + proxy._id + "expander()}} e-parentTask' style='margin-top:{{if !isAutoSchedule}}" + (tHeight * 2) +
                "{{/if}}px;background-color:{{if parentTaskbarBackground }}{{:parentTaskbarBackground}}{{else}} " + this.model.parentTaskbarBackground +
                "{{/if}}; left:{{if isAutoSchedule}}{{:left}}{{else}}{{:manualLeft}}{{/if}}px;width:{{if isAutoSchedule}}{{:width}}{{else}}{{:manualWidth}}{{/if}}px;height:{{if isAutoSchedule}}" +(taskbarHeight)+ "{{else}}" + (tHeight * 3) + "{{/if}}px;'>" +

                "<div  class='e-gantt-parenttaskbar-progress {{:~_" + proxy._id + "expander()}} e-parentTask progressbar' " +
                "style='top:-1px;border-style:{{if progressWidth}}solid{{else}}none{{/if}}; left:-1px;width:{{:progressWidth}}px;position:absolute;background-color:{{if parentProgressbarBackground }}{{:parentProgressbarBackground}}{{else}} "
                + this.model.parentProgressbarBackground + "{{/if}};z-index:3;" +
                "border-top-right-radius:{{if isAutoSchedule}}" + radius + "{{else}}" + tHeight + "{{/if}}px;border-bottom-right-radius:{{if isAutoSchedule}}" + radius + "{{else}}"
                + tHeight + "{{/if}}px;height:{{if isAutoSchedule}}" + (taskbarHeight) + "{{else}}" + (tHeight * 3) + "{{/if}}px;'></div>" + "</div>" + "{{/if}}" +

                  

             "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate }}" +
                "<div  class='e-baselinebar' style='margin-top:" + baseLineTop +"px;left:{{:baselineLeft}}px;" +
                "width:{{:baselineWidth}}px;height:" + baselineHeight + "px;background-color: " + baselineColor + ";" +
                "position:absolute;z-index:3;box-sizing:border-box;-moz-box-sizing:border-box;'></div>{{/if}}" +

                "</td>" +

               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='left:{{if (left+width)>(manualLeft+manualWidth)}}{{:left+width+30}}{{else}}{{:manualLeft+manualWidth+30}}{{/if}}px;" +
                "margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;position:absolute;background-color:transparent;font-weight:bold;height:" + (this.model.rowHeight - 1) + "px;'>" +
                "<div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;outline:none;'>{{if " + isRightTaskLabelTemplate + "}}" + rightTaskLabelTemplateString +
                "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_" + proxy._id + "resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>" +


               //Milestone Item

                "{{else ~_" + proxy._id + "milestoneMapping()}}" +
                    
                "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{:left-10}}px;overflow:hidden;text-overflow:ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isLeftTaskLabelTemplate + "}}" + leftTaskLabelTemplateString +
                "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>"
                + "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

               "<td class='e-chartcell' style='width:" + tdWidth + "px;'>" +
                "<div class='e-gantt-milestone-container' style=height:" + (this.model.taskbarHeight - 1) + "px;>" +
                "<div class='e-connectorpoint-left' style='left:{{:left-" + (connectorPointWidth + milesStoneRadius) + "}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;border-radius:" +
                connectorPointRadius + "px;'>" + touchLeftConnectorpoint + "</div>" +
                "{{if " + isMilestoneTemplate + "}}" + milestoneTemplateString + "{{else}}" +
                "<div class='e-gantt-milestone' style='position:absolute;left:{{:left-" + milesStoneRadius + "}}px;'>" +
                "<div class='e-gantt-milestone e-milestone-top'  style='border-right-width:" + milesStoneRadius + "px;border-left-width:" + milesStoneRadius + "px;border-bottom-width:" + milesStoneRadius + "px; border-right-color:transparent;border-left-color:transparent;border-style:none solid solid;border-top: none;'></div>" +
                "<div class='e-gantt-milestone e-milestone-bottom'  style='top:" + (milesStoneRadius) + "px;border-right-width:" + milesStoneRadius + "px; border-left-width:" + milesStoneRadius + "px; border-top-width:" + milesStoneRadius + "px; border-right-color:transparent;border-left-color:transparent;border-style:solid solid none; border-bottom: none;'></div>" +
                "</div>" + "{{/if}}" +
                 "<div class='e-connectorpoint-right' style='left:{{:(left+" + (milesStoneRadius) + ")}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;border-radius:"
                 + connectorPointRadius + "px;'>" + touchRightConnectorpoint + "</div>" +
                "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate}}" +
                "<div class='e-baseline-gantt-milestone-container' >" +
                "<div class='e-baseline-gantt-milestone' style='position:absolute;left:{{:baselineLeft -" + (milesStoneRadius) + "}}px;z-index:2;margin-top:4px;'>" +
                "<div class='e-baseline-gantt-milestone e-baseline-milestone-top'  " +
                "style='z-index:2;top:" + (- this.model.taskbarHeight) + "px;border:" + milesStoneRadius + "px solid transparent;border-top: none;border-bottom-color: " + baselineColor + ";'></div>" +
                "<div class='e-baseline-gantt-milestone e-baseline-milestone-bottom'  " +
                "style='z-index:2;top:" + (milesStoneRadius - this.model.taskbarHeight) + "px;border:" + milesStoneRadius + "px solid transparent;border-bottom: none;border-top-color: " + baselineColor + ";'></div>" +
                "</div></div>" +
                "{{/if}}" +

                "</td>" +

               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='margin-top:5px;left:{{:left+56}}px;margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;height:" + (this.model.rowHeight - 1) + "px;" +
                "position:absolute;background-color:transparent;'><div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isRightTaskLabelTemplate + "}}" +
                rightTaskLabelTemplateString + "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_" + proxy._id + "resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>" +

                //Child Taskbar Item

                "{{else}}" +

                //left label
               "<td class='e-chartcell'>" +
                "<div class='e-tasknameContainer' style='height:" + (this.model.rowHeight - 1) + "px;width:{{:left-10}}px;overflow:hidden;text-overflow: ellipsis;'>" +
                "<div class='e-taskbarname'  style='overflow: hidden;text-overflow: ellipsis;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isLeftTaskLabelTemplate + "}}" + leftTaskLabelTemplateString +
                "{{else " + this.model.showTaskNames + " && left > 0 && !" + leftLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:taskName}}</span>"
                + "{{else " + leftLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + leftField + "</span>{{/if}}</div></div></td>" +

                //taskbar
               "<td class='e-chartcell' style='width:" + tdWidth + "px;'>" +

               

               "<div  class='e-childContainer' style='height:" + (this.model.taskbarHeight - 1) + "px;'>" +

               "<div class='e-connectorpoint-left' style='left:{{:left-" + connectorPointWidth + "}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;" +
               "border-radius:" + connectorPointRadius + "px'>" + touchLeftConnectorpoint + "</div>" +

               "<div class='e-taskbarresizer-left e-icon' style='left:{{:left+2-" + proxy._resizerLeftAdjust + "}}px;width:10px;margin-top:" + proxy._resizerMargin + "px;height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;'></div>" +
               "{{if " + isTaskbarTemplate + "}}" + taskbarTemplateString + "{{else}}" +
               "<div  class='e-gantt-childtaskbar {{if isCritical}} e-criticaltaskbar{{/if}} {{if !isAutoSchedule}} e-manualchildtaskbar{{/if}}' style='left:{{:left}}px;width:{{:width}}px;height:"
               + (taskbarHeight) + "px;background-color:{{if taskbarBackground }}{{:taskbarBackground}}{{else}} "
               + this.model.taskbarBackground + "{{/if}};'>" +

               "<div  class='e-gantt-childtaskbar-progress  {{if isAutoSchedule}} progressbar{{else}} e-manualprogressbar{{/if}} {{if isCritical}} e-criticalprogressbar{{/if}}' style='border-style:{{if progressWidth}}solid{{else}}none{{/if}};" +
                "width:{{:progressWidth}}px;text-align:right;line-height:" + (taskbarHeight - 1) + "px;" +
                //"margin-top:" + (((taskbarHeight) - (this.model.progressbarHeight * ((taskbarHeight) / 100))) / 2) + "px;" +
                "height:" + (this.model.progressbarHeight * (taskbarHeight / 100)) + "px; top:-1px;left:-1px;" +
                "position:absolute;background-color:{{if progressbarBackground }}{{:progressbarBackground}}{{else}} " + this.model.progressbarBackground + "{{/if}};" +
                "border-top-right-radius:" + radius + "px;border-bottom-right-radius:" + radius + "px;'>" +
                "{{if " + this.model.showProgressStatus + "}}<span class='e-tasklabel' style='line-height:" + (taskbarHeight - 1) + "px'>{{:status}}%</span>{{/if}}</div></div>" + "{{/if}}" +
                "{{if " + (!isTaskbarTemplate || isProgressbarTemplate) + "}}" +
               "<div class='e-progressbarresizer-right' style='left:{{:left+progressWidth-10}}px;width:20px;margin-top:" + (taskbarHeight-5) + "px;" +
               "height:15px;position:absolute;z-index:5;'>" +
               "<div class='e-progressbarhandler' style='top:" + (10) + "px;position:absolute;z-index:-1;'><div class='e-progresshandler-element'></div></div>" +//-" + (shrinkedTaskbarHeight/2) + "
               "<div class='e-progressbarhandler' style='top:" + (5) + "px;position:absolute;z-index:-1;'><div class='e-progresshandlerafter-element'></div></div></div>" + "{{/if}}" +

               "<div class='e-taskbarresizer-right e-icon' style='left:{{:left+width-" + proxy._resizerRightAdjust + "}}px;width:10px;" +
                "height:" + (taskbarHeight) + "px;font-size:" + proxy._fontSize + "px;position:absolute;z-index:2;margin-top:" + proxy._resizerMargin + "px;'></div>" +

                "<div class='e-connectorpoint-right' style='left:{{:left+width}}px;width:" + connectorPointWidth + "px;margin-top:" + connectorPointMargin + "px;height:" + (taskbarHeight / 2) + "px;"
                + "border-radius:" + connectorPointRadius + "px'>" + touchRightConnectorpoint + "</div>" +
                //"<div class='e-connectorpoint-right' style='left:{{:left-20}}px;width:20px;margin-top:10px;background-color:black;height:" + (taskbarHeight) + "px;'></div>"+
                 "</div>" +

                "{{if " + this.model.renderBaseline + " && baselineStartDate && baselineEndDate }}" +
                "<div  class='e-baselinebar' style='margin-top:"+ baseLineTop + "px;left:{{:baselineLeft}}px;" +
                "width:{{:baselineWidth}}px;height:" + baselineHeight + "px;background-color: " + baselineColor + ";" +
                "position:absolute;z-index:3;box-sizing:border-box;-moz-box-sizing:border-box;'></div>{{/if}}" +

                "</td>" +

                //right label
               "<td class='e-chartcell' >" +
                "<div class='e-resourceinfo' style='left:{{:left+width+30}}px;margin:0;margin-left:5px;margin-top:" + rightLabelRowHeight + "px;height:" + (this.model.rowHeight - 1) + "px;" +
                "position:absolute;text-align:left;background-color:transparent;'><div class='e-resourcename'  style='overflow-y:hidden;margin-top:5px;height:" + (labelHeight) + "px;margin-right:30px;'>{{if " + isRightTaskLabelTemplate + "}}"
                + rightTaskLabelTemplateString + "{{else " + this.model.showResourceNames + " && left > 0 && !" + rightLabelFlag + " }}<span style='line-height:" + (labelHeight) + "px;'>{{:~_" + proxy._id + "resources(#data)}}</span>" +
                "{{else " + rightLabelFlag + "}}<span style='line-height:" + (labelHeight) + "px;'>" + rightField + "</span>{{/if}}</div></div></td>{{/if}}";

            parentTr += tr;
            parentTr += "</tr>";

            var templates = {};
            templates[this._id + "_CustomTemplate2"] = parentTr;
            $.templates(templates);

        },

        _getResourceInfo: function (data) {
            var resource = null;
            if (data.resourceInfo != null) {
                var resourcelength = data.resourceInfo.length;
                if (resourcelength > 0) {
                    for (var i = 0; i < resourcelength; i++) {
                        var unit = data.resourceInfo[i][this.model.resourceUnitMapping];
                        if (resource == null) {                           
                            resource = data.resourceInfo[i][this.model.resourceNameMapping];
                            if (unit != 100)
                                resource += "[" + unit + "%]";
                        }
                        else {
                            resource += " , " + data.resourceInfo[i][this.model.resourceNameMapping];
                            if (unit != 100)
                                resource += "[" + unit + "%]";
                        }
                    }
                    return resource;
                } else
                    return String.empty;
            }
            return String.empty;
        },

        _getrowClassName: function () {
            var rowClass = "gridrowtaskId",
                proxy = this;
            if (proxy.data.parentItem)
                rowClass += proxy.data.parentItem.taskId.toString();
            rowClass += "level";
            rowClass += proxy.data.level.toString();
            return rowClass;
        },

        _getExpandStatusRecord: function (data) {
            var proxy = this;
            if (proxy._getExpandStatus(data)) {
                return 'table-row';
            }
            return 'none';
        },


        _isMilestone: function () {
            if (this.data.isMilestone)
                return true;
            else
                return false;
        },

        _addRecordExpandCollapse: function () {
            if (this.data.expanded)
                return 'e-chartexpand';
            else if (!this.data.expanded && this.data.hasChildRecords) {
                return 'e-chartcollapse';
            }
            return false;
        },

        _getTypedata: function () {
            return this.data.hasChildRecords;
        },


        _getBorderRadius: function () {

            var proxy = this,
                diff = proxy.data.width - proxy.data.progressWidth;

            if (diff <= 4) {
                return 4 - diff;
            }
            else
                return 0;

        },

        _getHeightValue: function () {
            return (this.data.ParentIndex * this.data.RowHeight) > (this.data.ChildIndex * this.data.RowHeight) ? ((this.data.ParentIndex * this.data.RowHeight) - (this.data.ChildIndex * this.data.RowHeight)) : ((this.data.ChildIndex * this.data.RowHeight) - (this.data.ParentIndex * this.data.RowHeight));
        
        },

        _createConnectorLineTemplate: function () {
            var proxy = this,
                lineStroke = (proxy.model.connectorlineWidth) > 4 ? 4 : proxy.model.connectorlineWidth,
                shrinkedTaskbarHeight = 0,
                deltaTop, taskbarMidpoint,
                lineColor = proxy.model.connectorLineBackground,
                helpers = {};
            helpers["_" + proxy._id + "getWidthVal"] = proxy._getWidth;
            helpers["_" + proxy._id + "getTop"] = proxy._getPredecessorTop;
            helpers["_" + proxy._id + "getPosition"] = proxy._getParentPosition;
            helpers["_" + proxy._id + "setContainerWidthSSType2"] = proxy._getContainerWidthSSType2;
            helpers["_" + proxy._id + "setInnerChildWidthSSType2"] = proxy._getInnerChildWidthSSType2;
            helpers["_" + proxy._id + "setInnerElementLeftSSType2"] = proxy._getInnerElementLeftSSType2;
            helpers["_" + proxy._id + "setInnerElementWidthSSType2"] = proxy._getInnerElementWidthSSType2;
            helpers["_" + proxy._id + "isMilestone"] = proxy._isTaskMilestone;
            helpers["_" + proxy._id + "isMilestoneParent"] = proxy._isMilestoneParent;
            helpers["_" + proxy._id + "getHeightValue"] = proxy._getHeightValue;

            if (proxy.model.renderBaseline) {
                deltaTop = shrinkedTaskbarHeight / 2;
                taskbarMidpoint = ((proxy.model.rowHeight) / 2) - deltaTop;
            } else {
                taskbarMidpoint = ((proxy.model.rowHeight) / 2);
            }

            $.views.helpers(helpers);
            var connectorContainer = "<div  id='ConnectorLine{{:ConnectorLineId}}' style='background-color=black'>";

            var div = "{{if ~_" + proxy._id + "getPosition()=='FSType1'}}"//FS
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:(ChildLeft - (ParentLeft + ParentWidth + 20))}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FSType1'>"
            + "<div class='e-line' style='left:{{if milestoneParent}}-7px{{else}}0px{{/if}};width:{{if milestoneParent}}{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-2}}px{{else}}{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px{{/if}};" +
                "border-top:" + lineStroke + "px solid " + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px;" +
                "width:0px;border-right:" + lineStroke + "px solid " + lineColor + ";border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid " + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft-(ParentLeft + ParentWidth + 10))+" + lineStroke + "-10}}px;width:10px;" +
                "border-top:" + lineStroke + "px solid " + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-rightarrow' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else  ~_" + proxy._id + "getPosition()=='FSType2'}}"//FS
            + "<div style='left:{{:ParentLeft}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:~_" + proxy._id + "getWidthVal()}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FSType2'>"
            + "<div class='e-line' style='left:{{if milestoneParent}}{{:ParentWidth-7}}px{{else}}{{:ParentWidth}}px{{/if}};width:{{if milestoneParent}}17px{{else}}10px{{/if}};border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:ParentWidth+10-" + lineStroke + "}}px;border-left:" + lineStroke + "px solid;width:0px;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-14-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div><div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;" +
                "width:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30 )}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;width:0px;" +
                "border-top:{{:14-" + lineStroke + "}}px solid;border-left:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 20))}}px;width:10px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-rightarrow' style='left:{{:(ParentWidth - (((ParentLeft + ParentWidth) - ChildLeft) + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;top:{{:-6-" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FSType3'}}"
            + "<div style='left:{{:ChildLeft-20}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentWidth+ChildWidth}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FSType3'>"
            + "<div class='e-connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;" +
                "top:{{:-5-" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;'></div>"
            + "<div class='e-line' style='width:" + lineStroke + "px;border-top:{{:~_" + proxy._id + "getHeightValue()-14-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-" + (13 + ((lineStroke - 1) * 2)) + "px'></div>"
            + "<div class='e-line' style='width:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30)}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;'></div>"
            + "<div class='e-line' style='left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 30)}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "height:{{:14-" + lineStroke + "}}px;border-color:" + lineColor + ";position:relative;" +
                "top:-" + (13 + ((lineStroke - 1) * 2)) + "px;'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestoneParent()}}left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 14)}}px;width:16px;{{else}}left:{{:(((ParentLeft + ParentWidth) - ChildLeft) + 20)}}px;width:10px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FSType4'}}"
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:(ChildLeft - (ParentLeft + ParentWidth + 20))}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FSType4'>"
            + "<div class='e-connectorline-rightarrow' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth + 10))}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='left:{{:(ChildLeft - (ParentLeft + ParentWidth) - 20)}}px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:10px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" + (13 + ((lineStroke - 1) * 2)) + "px;left:{{:(ChildLeft - (ParentLeft + ParentWidth) - 20)}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestoneParent()}}left:-6px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:{{if ~_" + proxy._id + "isMilestoneParent()}}{{:(ChildLeft-(ParentLeft + ParentWidth+20 )+ 6)+" + lineStroke + "}}px;{{else}}{{:(ChildLeft-(ParentLeft + ParentWidth + 20))+" + lineStroke + "}}px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SSType4'}}"
            + "<div  style='left:{{:ParentLeft-10}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ChildLeft-ParentLeft}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SSType4'>"
            + "<div class='e-connectorline-rightarrow' style='left:{{:ChildLeft-ParentLeft}}px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke -1 ) *2)) + "px;width:{{:ChildLeft-ParentLeft}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke - 1) * 2)) + "px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SSType3'}}"
            + "<div  style='left:{{:ChildLeft-20}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentLeft-ChildLeft}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SSType3'>"
            + "<div class='e-connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke - 1) * 2)) + "px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" +(13 + ((lineStroke - 1) * 2)) + "px;width:{{:ParentLeft-ChildLeft+20}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SSType2'}}"
            + "<div  style='left:{{:~_" + proxy._id + "setInnerElementLeftSSType2()}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:~_" + proxy._id + "setContainerWidthSSType2()}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SSType2'>"
            + "<div class='e-line' style='width:{{:~_" + proxy._id + "setInnerChildWidthSSType2()}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:{{:~_" + proxy._id + "setInnerElementWidthSSType2()}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-rightarrow' style='left:{{:~_" + proxy._id + "setInnerElementWidthSSType2()}}px;" +
                "border-left: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;" +
                "height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SSType1'}}"
            + "<div  style='left:{{:ChildLeft-20}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ParentLeft-ChildLeft}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SSType1'>"
            + "<div class='e-line' style='width:{{:ParentLeft-ChildLeft+20}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-connectorline-rightarrow' style='left:10px;border-left: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FFType1'}}"
            + "<div class='FFtype1' style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft + ChildWidth)-(ParentLeft + ParentWidth))+30}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FFType1'>"
            + "<div class='e-line' style='left:{{if ~_" + proxy._id + "isMilestoneParent()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))-10}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))}}px;{{/if}}" +
                "width:{{if ~_" + proxy._id + "isMilestoneParent()}}30px;{{else}}20px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_" + proxy._id + "isMilestoneParent()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;{{/if}}width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_" + proxy._id + "isMilestone()}}4px;{{else}}10px;{{/if}}width:{{if ~_" + proxy._id + "isMilestone()}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+16}}px;{{else}}{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+10}}px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-leftarrow' style='{{if ~_" + proxy._id + "isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FFType2'}}"
            + "<div style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FFType2'>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestoneParent()}}left:-6px;{{/if}}width:{{if ~_" + proxy._id + "isMilestoneParent()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+26}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_" + proxy._id + "isMilestone()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+4}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+10}}px;{{/if}}" +
                "width:{{if ~_" + proxy._id + "isMilestone()}}16px;{{else}}10px;{{/if}}" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-leftarrow' style='left:{{if ~_" + proxy._id + "isMilestone()}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))-6}}px;{{else}}{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FFType3'}}"
            + "<div  style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FFType3'>"
            + "<div class='e-connectorline-leftarrow' style='{{if ~_" + proxy._id + "isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-5-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestone()}}left:4px;width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+16}}px;{{else}}left:10px;width:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+10}}px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))+20}}px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;" +
                "width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestoneParent()}}left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))-6}}px;width:26px;{{else}}left:{{:((ParentLeft + ParentWidth) - (ChildLeft + ChildWidth))}}px;width:20px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='FFType4'}}"
            + "<div  style='left:{{:ParentLeft+ParentWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='FFType4'>"
            + "<div  class='e-connectorline-leftarrow' style='{{if ~_" + proxy._id + "isMilestone()}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))-6}}px;{{else}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;" +
                "position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestone()}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+4}}px;width:16px;{{else}}left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+10}}px;width:10px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestoneParent()}}left:-6px;width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+26}}px;{{else}}width:{{:((ChildLeft +ChildWidth)-(ParentLeft + ParentWidth))+20}}px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else  ~_" + proxy._id + "getPosition()=='SFType4'}}"//SF
            + "<div style='left:{{:ParentLeft-10}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;" +
                "height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SFType4'>"
            + "<div class='e-connectorline-leftarrow' style='left:{{if ~_" + proxy._id + "isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+4}}px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+10}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-5-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;" +
                "position:relative'></div>"
            + "<div class='e-line' style='left:{{if ~_" + proxy._id + "isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+14}}px;width:16px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;width:10px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SFType3'}}"//SF
            + "<div style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ChildIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft)-(ChildLeft + ChildWidth))}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SFType3'>"
            + "<div class='e-connectorline-leftarrow' style='{{if ~_" + proxy._id + "isMilestone()}}left:-6px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-5-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;" +
                "border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestone()}}left:4px;width:16px;{{else}}left:10px;width:10px;{{/if}}top:-" + (13 + ((lineStroke - 1) * 2)) + "px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:20px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:20px;top:-" + (13 + ((lineStroke - 1) * 2)) + "px;width:{{:(ChildLeft-(ParentLeft + ParentWidth + 20))+" + lineStroke + "}}px;" +
                "border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "</div>"

            + "{{else  ~_" + proxy._id + "getPosition()=='SFType1'}}"//SF
            + "<div style='left:{{:ParentLeft-10}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:ChildLeft+ChildWidth+20}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SFType1'>"
            + "<div class='e-line' style='width:10px;border-top:" + lineStroke + "px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='width:0px;border-left:" + lineStroke + "px solid;border-top:{{:~_" + proxy._id + "getHeightValue()-15-" + lineStroke + "}}px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='width:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+30}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:15-" + lineStroke + "}}px solid;border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestone()}}left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+(15-" + lineStroke +")}}px;width:16px;{{else}}left:{{:((ChildLeft + ChildWidth) - (ParentLeft ))+20}}px;width:10px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-leftarrow' style='left:{{if ~_" + proxy._id + "isMilestone()}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+4}}px;{{else}}{{:((ChildLeft + ChildWidth) - (ParentLeft ))+10}}px;{{/if}}" +
                "border-right: 10px solid " + lineColor + ";top:{{:-6-" + lineStroke + "}}px;" +
                "border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;" +
                "width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{else ~_" + proxy._id + "getPosition()=='SFType2'}}"//SF
            + "<div  style='left:{{:ChildLeft+ChildWidth}}px;top:{{:(ParentIndex * RowHeight) +" + taskbarMidpoint + "}}px;" +
                "width:{{:((ParentLeft) - (ChildLeft + ChildWidth))}}px;height:{{:~_" + proxy._id + "getHeightValue()}}px;position:absolute' data-connectortype='SFType2'>"
            + "<div class='e-line' style='left:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;width:10px;border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-line' style='left:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;width:0px;border-left:" + lineStroke + "px solid;" +
                "border-top:{{:~_" + proxy._id + "getHeightValue()-" + lineStroke + "}}px solid;border-color:" + lineColor + ";" +
                "position:relative'></div>"
            + "<div class='e-line' style='{{if ~_" + proxy._id + "isMilestone()}}left:0px;width:{{:((ParentLeft) - (ChildLeft + ChildWidth))-10}}px;{{else}}left:10px;width:{{:((ParentLeft) - (ChildLeft + ChildWidth))-20}}px;{{/if}}border-top:" + lineStroke + "px solid;" +
                "border-color:" + lineColor + ";position:relative'></div>"
            + "<div class='e-connectorline-leftarrow' style='left:{{if ~_" + proxy._id + "isMilestone()}}-6px;{{else}}0px;{{/if}}border-right: 10px solid " + lineColor + ";" +
                "top:{{:-6-" + lineStroke + "}}px;border-bottom-width:{{:5+" + lineStroke + "}}px;border-top-width:{{:5+" + lineStroke + "}}px;width:0;height:0;position:relative'></div>"
            + "</div>"

            + "{{/if}}";

            connectorContainer += div;
            connectorContainer += "</div>";

            var templates = {};
            templates[this._id + "ConnectorLineTemplate"] = connectorContainer;
            $.templates(templates);
        },

        _isTaskMilestone: function () {
            if (this.data.milestoneChild)
                return true;
            else
                return false;
            
        },

        _isMilestoneParent: function () {
            if (this.data.milestoneParent)
                return true;
            else
                return false;
        },

        _getInnerChildWidthSSType2: function () {
            if ((this.data.ParentLeft + this.data.ParentWidth) < this.data.ChildLeft) {
                return 10;
            }
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 20;
            }
            if ((this.data.ParentLeft + this.data.ParentWidth) >= this.data.ChildLeft) {
                return 10;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },

        _getInnerElementLeftSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return (this.data.ParentLeft - 20);
            }
            return (this.data.ParentLeft - 10);
        },

        _getInnerElementWidthSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 10;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },


        _getContainerWidthSSType2: function () {
            if (this.data.ParentLeft == this.data.ChildLeft) {
                return 20;
            }
            return (this.data.ChildLeft - this.data.ParentLeft);
        },

        _getPredecessorTop: function () {
            if (this.data.ParentIndex > this.data.ChildIndex)
                return true;
            else
                return false;
        },

        _getParentPosition: function () {
            if (this.data.ParentIndex < this.data.ChildIndex) {

                if (this.data.Type == "FF") {
                    if ((this.data.ChildLeft + this.data.ChildWidth) >= (this.data.ParentLeft + this.data.ParentWidth)) {
                        return "FFType2";
                    }
                    else {
                        return "FFType1";
                    }
                }

                else if ((this.data.ParentLeft < this.data.ChildLeft) && (this.data.ChildLeft > (this.data.ParentLeft + this.data.ParentWidth + 25))) {
                    if (this.data.Type == "FS") return "FSType1";
                    if (this.data.Type == "SF") return "SFType1";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "FF") return "FFType2";
                }
                else if ((this.data.ParentLeft < this.data.ChildLeft && (this.data.ChildLeft < (this.data.ParentLeft + this.data.ParentWidth)))
                    || (this.data.ParentLeft == this.data.ChildLeft || this.data.ParentLeft > this.data.ChildLeft)) {

                    if (this.data.ParentLeft > (this.data.ChildLeft + this.data.ChildWidth + 25)) {
                        if (this.data.Type == "SF") return "SFType2";
                    }

                    if (this.data.ParentLeft > this.data.ChildLeft) {
                        if (this.data.Type == "SS") return "SSType1";
                        if (this.data.Type == "SF") return "SFType1";
                        if (this.data.Type == "FF") return "FFType1";
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType2";
                    }
                    if (this.data.Type == "FS") return "FSType2";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "FF") return "FFType1";
                    else if (this.data.Type == "SF") return "SFType1";
                }
                else if ((this.data.ParentLeft) < this.data.ChildLeft) {

                    if (this.data.Type == "FS") return "FSType2";
                    else if (this.data.Type == "FF") return "FFType2";
                    else if (this.data.Type == "SS") return "SSType2";
                    else if (this.data.Type == "SF") return "SFType1";
                }

            }
            else if (this.data.ParentIndex > this.data.ChildIndex) {
                if ((this.data.ParentLeft < this.data.ChildLeft) && (this.data.ChildLeft > (this.data.ParentLeft + this.data.ParentWidth))) {
                    if (this.data.Type == "FS")
                        if (30 >= (this.data.ChildLeft - (this.data.milestoneParent ? (this.data.ParentLeft + this.data.ParentWidth + 4) : (this.data.ParentLeft + this.data.ParentWidth))))
                            return "FSType3";
                        else
                            return "FSType4";
                    if (this.data.ParentLeft < this.data.ChildLeft || ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth))) {
                        if (this.data.Type == "SS") return "SSType4";
                        if (this.data.Type == "FF") return "FFType4";
                        if (this.data.Type == "SF") return "SFType4";
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType4";
                    }
                }
                else if ((this.data.ParentLeft < this.data.ChildLeft && (this.data.ChildLeft < (this.data.ParentLeft + this.data.ParentWidth)))
                    || (this.data.ParentLeft == this.data.ChildLeft || this.data.ParentLeft > this.data.ChildLeft)) {
                    if ((this.data.ChildLeft + this.data.ChildWidth) <= (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType3";
                        if (this.data.Type == "SF") {
                            if ((this.data.ChildLeft + this.data.ChildWidth + 25) < (this.data.ParentLeft)) {
                                return "SFType3";
                            } else {
                                return "SFType4";
                            }
                        }
                        if (this.data.Type == "SS") {
                            if (this.data.ChildLeft <= this.data.ParentLeft)
                                return "SSType3";
                            else
                                 return "SSType4";
                        }
                    }
                    else if ((this.data.ChildLeft + this.data.ChildWidth) > (this.data.ParentLeft + this.data.ParentWidth)) {
                        if (this.data.Type == "FF") return "FFType4";
                        if (this.data.Type == "SF") return "SFType4";
                        if (this.data.Type == "SS")
                            if (this.data.ChildLeft <= this.data.ParentLeft)
                                return "SSType3";
                            else
                                return "SSType4";
                    }
                    if (this.data.Type == "FS") return "FSType3";
                }
                else if (this.data.ParentLeft < this.data.ChildLeft) {

                    if (this.data.Type == "FS") return "FSType3";
                    if (this.data.Type == "SS") return "SSType4";
                    if (this.data.Type == "FF") return "FFType4";
                    if (this.data.Type == "SF") return "SFType4";
                }
            }
            return false;
        },

        _getWidth: function () {
            return ((this.data.ChildLeft + this.data.ChildWidth) < (this.data.ParentLeft + this.data.ParentWidth)) ?
                this.data.ParentWidth : (this.data.ChildWidth + this.data.ParentWidth);
        },


        //renders Weekends in chart
        _renderWeekends: function () {
            var proxy = this,
                model = proxy.model,
                left = 0,
                width = (proxy.model.perDayWidth) + 1,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                count = proxy.model.scheduleWeeks.length,
                $day, saturdayIndex,
                $weekendContainer = ej.buildTag("div.e-secondary_canvas", "", { 'height': height + 'px' }, {}),
                weekStartDay = model.scheduleHeaderSettings.weekStartDay,
                dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                saturdayIndex = 6 - dayIndex,
                nonWorkDayLength = proxy._nonWorkingDayIndex.length;
            for (var i = 0; i < count; i++) {
                var weeDayIndex;
                for (var j = 0; j < nonWorkDayLength; j++) {
                    if (proxy._nonWorkingDayIndex[j] != 6) {
                        var index = (saturdayIndex + proxy._nonWorkingDayIndex[j] + 1);
                        weeDayIndex = (index >= 7 ? proxy._nonWorkingDayIndex[j] - dayIndex : index);
                    }
                    else
                        weeDayIndex = saturdayIndex;
                    $day = ej.buildTag("div.e-weekends", "", {
                        'left': (left + (proxy.model.perDayWidth * weeDayIndex)) + 'px',
                        'width': width + 'px',
                        'height': height + 'px',
                        'background-color': this.model.weekendBackground
                    }, {});
                    $weekendContainer.append($day);
                }
                left = left + this._scheduleWeekWidth;
            }

            proxy._$weekendsContainer.html($weekendContainer);
            proxy._$bodyContent.append(proxy._$weekendsContainer);
        },



        //Renders StripLines for given striplines collection object
        _renderStripLines: function (stripLines) {

            var proxy = this,
                height = ((proxy.model.updatedRecords.length) * this.model.rowHeight),
                stripLineCount = stripLines.length, day, left,
                projectStartDate = proxy.model.projectStartDate,
                dayWidth = this.model.perDayWidth,
                stripLineContainer = ej.buildTag("div.e-stripLines", "", { 'height': height + 'px' }, {});

            for (var i = 0; i < stripLineCount; i++) {

                day = this._getDateFromFormat(stripLines[i].day);
                left = ((day - this._getDateFromFormat(projectStartDate)) / 86400000) * dayWidth;
                stripLines[i].lineWidth = stripLines[i].lineWidth > 30 ? 30 : stripLines[i].lineWidth;

                var stripline = ej.buildTag("div.e-stripline#stripline" + [i] + "", "", {
                    'left': left + 'px',
                    'width': '1px',
                    'height': height + 'px',
                    'border-left-width': stripLines[i].lineWidth + 'px',
                    'border-left-color': stripLines[i].lineColor,
                    'border-left-style': stripLines[i].lineStyle
                }, {});

                var innerspan = ej.buildTag("span.e-striplinespan", stripLines[i].label, {
                    'background-color': stripLines[i].lineColor,
                }, {});

                if (stripLines[i].day && stripLines[i].day.length > 0) {
                    if (stripLines[i].label && stripLines[i].label.length > 0) {
                        stripline.append(innerspan);
                    }
                    stripLineContainer.append(stripline);
                }
            }
            proxy._$stripLineContainer.append(stripLineContainer);
            proxy._$bodyContent.append(proxy._$stripLineContainer);
        },


        //returns progress width for the taskbar
        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },


        //returns progress percentage of the taskbar
        _getProgressPercent: function (parentwidth, progresswidth) {
            return Math.ceil(((progresswidth / parentwidth) * 100).toFixed(2));
        },


        //renders holidays for holiday collection object
        _renderHoliday: function (holiday) {

            var proxy = this, scheduleHeaderType = proxy.model.scheduleHeaderSettings.scheduleHeaderType,
                date = this._getDateFromFormat(holiday.day),
                weekCount = proxy.model.scheduleWeeks.length,
                monthcount = proxy.model.scheduleMonths.length,
                yearcount = proxy.model.scheduleYears.length,
                daycount=proxy.model.scheduleDays.length,
                prevDate = 0,
                left = 0, textLength, text, $holidayContainer, $holidaySpan,
                ganttRecords = proxy.model.updatedRecords.length, height;

            left = ((date - this._getDateFromFormat(proxy.model.projectStartDate)) / 86400000) * this.model.perDayWidth;

            height = (ganttRecords * this.model.rowHeight);
            textLength = holiday.label != null ? holiday.label.length : 0;
            if (holiday.background == null)
                holiday.background = "white";


            var holidayLableSelector = ".e-holiday-label";
            /* for rotate holiday lable in ie8 */
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                holidayLableSelector = ".e-holiday-label-ie8";
            }
            if (proxy.model.scheduleHeaderSettings.scheduleHeaderType != "day") {
                text = ej.buildTag("div" + holidayLableSelector, holiday.label, {
                    'top': (proxy._getHolidayLabelHeight(textLength)) + 'px',
                }, {});
            }
            else
            {
                text = ej.buildTag("div" + holidayLableSelector, holiday.label, {
                    'bottom': (proxy._getHolidayLabelHeight(textLength)) + 'px',
                }, {});
            }
            $holidayContainer = ej.buildTag("div.e-secondary-canvas-holiday");
            $holidaySpan = ej.buildTag("div.e-holidays", "", {
                'left': left + 'px',
                'width': proxy.model.perDayWidth + 'px',
                'height': height + 'px',
                'background-color': holiday.background
            }, {});

            if (holiday.label != null)
                $holidaySpan.append(text);
            $holidayContainer.append($holidaySpan);

            proxy._$secondaryCanvas.append($holidayContainer);
            proxy._$bodyContent.append(proxy._$secondaryCanvas);
        },

        _getHolidayLabelHeight: function (textlength) {
            var proxy = this, model = proxy.model,
                containerHeight = proxy._getHeight(),
                totalHeight = model.updatedRecords.length * proxy.model.rowHeight;
            if (containerHeight > 0)
                return (containerHeight / 2);
            else if (proxy._viewportHeight < totalHeight)
                return (proxy._viewportHeight / 2);
            else
                return totalHeight / 2;

        },
        updateWorkWeek:function(workWeek)
        {
            var proxy = this,
                model = proxy.model;
            model.workWeek = workWeek
            proxy._getNonWorkingDayIndex();
        },
        _getNonWorkingDayIndex:function()
        {
            var proxy = this,
                model = proxy.model,
                weekDay = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"],
                weekDayLength = weekDay.length,
                workWeek = model.workWeek.slice(),
                length = workWeek.length;
            for (var i = 0; i < length; i++)
                workWeek[i] = workWeek[i].toLowerCase();
            proxy._nonWorkingDayIndex = [];
            for(var i=0;i < weekDayLength;i++)
            {
                if (workWeek.indexOf(weekDay[i]) == -1)
                    proxy._nonWorkingDayIndex.push(i);
            }
        },
        // all events bound using this._on will be unbind automatically
        _destroy: function () {

            var proxy = this;
            proxy.element.off();
            $(document.body).unbind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
            $(document).unbind("mouseup", $.proxy(proxy._tooltipMouseup, proxy));
            $(document.body).bind("touchmove", $.proxy(proxy.handleMouseMove, proxy));
            proxy.element.empty().removeClass("e-ganttchart-core e-ganttchart" + proxy.model.cssClass);

        },
    });

    jQuery.uaMatch = function (ua) {
        ua = ua.toLowerCase();

        var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
            /(webkit)[ \/]([\w.]+)/.exec(ua) ||
            /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
            /(msie) ([\w.]+)/.exec(ua) ||
            ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) ||
            [];

        return {
            browser: match[1] || "",
            version: match[2] || "0"
        };
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Toolbar elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejToolbar", "ej.Toolbar", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _setFirst: false,

        _rootCSS: "e-toolbar",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            enabled: true,

            hide: false,

            disabledItemIndices: [],

            enabledItemIndices: [],

            enableSeparator: false,

            orientation: "horizontal",

            enableRTL: false,

            isResponsive: false,

            showRoundedCorner: false,

            htmlAttributes: {},

            dataSource: null,
			
			Items:{

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },

            query: null,
		
			responsiveType:"popup",


            fields: {

                id: "id",

                tooltipText: "tooltipText",

                imageUrl: "imageUrl",

                text: "text",

                imageAttributes: "imageAttributes",

                spriteCssClass: "spriteCssClass",

                htmlAttributes: "htmlAttributes",

                group: "group",
				
				template:"template"
            },
            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 },
					adjust: { xValue: 17, yValue: 17 }
                },
                isBalloon: false
            },

            cssClass: "",
			
			targetID : null,

            create: null,

            click: null,

            itemHover: null,

            itemLeave: null,
			
			overflowOpen:null,
			
			overflowClose:null,

            destroy: null

        },


        dataTypes: {
            enabled: "boolean",
            hide: "boolean",
            enableSeparator: "boolean",
            disabledItemIndices: "data",
            enabledItemIndices: "data",
            orientation: "enum",
            enableRTL: "boolean",
            showRoundedCorner: "boolean",
            isResponsive: "boolean",
            dataSource: "data",
            query: "data",
            fields: "data",
            cssClass: "string",
            htmlAttributes: "data",
			targetID: "string",
			responsiveType:"enum"
        },



        hide: function () {
            if (!this.model.enabled && (this.element.css("display") == "none")) return false;
            this.element.css("display", "none");
			this.model.hide = true;
        },

        show: function () {
            if (!this.model.enabled && (this.element.css("display") != "none")) return false;
            this.element.css("display", "block");
			this.model.hide = false;
        },


        _init: function () {
            if(this.model.targetID != null)
				this.element.html($("#" + this.model.targetID).find('ul,ol'));
			this._cloneElement = $(this.element).clone();
			//Stored the local & remote data source processed value. 
			 
			this._localDataSource=null;
            if (this.model.dataSource != null) {
                this._generateTemplate();
            }
			else if(this.model.Items != null)
			{
			  this._generateTemplate();
			}
            (!(this.model.dataSource instanceof ej.DataManager)) && this._initialize();
            this._renderTooltip(this.model.tooltipSettings);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this.model.width = options[option];
                        this._setWidth();
                        this._bindUnbindWidth();
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "disabledItemIndices": {
                        this._disableItemByIndex(options[option]);
						options[option] = this.model.disabledItemIndices;
                        break;
                    }
                    case "enabledItemIndices": {
						this._enableItemByIndex(options[option]); 
						break;
					}
                    case "isResponsive":
                        this.model.isResponsive = options[option];
                        if(this.model.isResponsive) {
							this._responsiveLayout();
							this._renderTooltip(this.model.tooltipSettings);
						}
						else
							this._removeResponsive();
                        break;
                    case "hide":
                        this._controlVisibleOptions(options[option]);
                        break;
                    case "orientation":
                        this._setOrientation(options[option]);
                        this.model.orientation = options[option];
                        this._wireResizing();
                        break;
					case "tooltipSettings":
					    this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
						this._renderTooltip(this.model.tooltipSettings);
						break;
                    case "enableRTL":
                        this._enableRTL(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                    case "enableSeparator":
                        this.model.enableSeparator = options[option];
                        this._renderToolbarSeparator();
                        break;
                    case "fields":
                        $.extend(this.model.fields, options[option]);
                        break;
                    case "query":
                        this.model.query = options[option];
                        break;
                    case "dataSource":
                        for (var optio in options) {
                            if (optio == "fields") $.extend(this.model.fields, options[optio]);
                            if (optio == "query") this.model.query = options[optio];
                        }
                        this._refreshTagItems(option, options[option]);
                        break;
					case "Items":
					 
					   $.extend(this.model.Items, options[option]);
					   this._refreshTagItems(option, options[option]);
					   break;
					case "targetID":
						this.model.targetID = options[option];
						this._setTargetID();					
						break;
					
                }
            }
        },
		
		_setTargetID: function() {
			this.element.removeAttr('role tabindex aria-disabled style');			
			$(this._spantag).remove();
			$(this._liTemplte).remove();			
			this._liTemplte = this._tipRes = null;		
			this.element.removeClass('e-widget e-box e-toolbarspan e-rtl');
			this.element.find('ul,ol').removeClass('e-ul e-horizontal e-vertical e-separator e-comnrtl');
			this.element.find('li').removeClass('e-tooltxt e-comnrtl');
			this.element.find('li').removeAttr('aria-label');
			this._init();
		},
		
        _refreshTagItems: function (key, value) {
            this.model[key] = value;
            this.element.empty();
            this._generateTemplate();
            this._initialize();
        },

        _setHeight: function (val) {
            this.element.css('height', val);
        },

        _setWidth: function () {
            if (this.model.width == "auto") {
                var itemswidth = parseFloat(this.element.css('border-left-width')) + parseFloat(this.element.css('border-right-width')),
                listElement = this.element.find('ul').children('li'), listUl = this.element.find('ul'),resEle;
				if(this.model.responsiveType=="inline")
				 resEle = this.element.find('.e-arrow-sans-down');
				 else
				resEle = this.element.find('.e-toolbar-res-arrow');
				
				for(var i=0, len = listUl.length; i < len; i++) {           // calculate separator width also
                    if (listUl[i] != null && $(listUl[i]).hasClass('e-separator'))
                        itemswidth += parseFloat(listUl.eq(i).css('border-right-width')) + parseFloat(listUl.eq(i).css('border-left-width'));
                }
                if (resEle[0] != null)
				 if(this.model.responsiveType=="inline")
                   itemswidth += Math.round(this.element.find('.e-arrow-sans-down').outerWidth()) + 8; // 8px for position
				 else
				   itemswidth += Math.round(this.element.find('.e-toolbar-res-arrow').outerWidth()) + 8;// 8px for position
                
                for (var i = 0, len = listElement.length; i < len; i++) {
                    if (listElement[i] != null)
                        itemswidth += Math.round(listElement.eq(i).outerWidth());
                }
                this.element.css("width", Math.ceil(itemswidth));
            } else
                this.element.css('width', this.model.width);
        },
        _bindUnbindWidth: function () {
            (this.model.width != "auto") ? this._off($(window), "resize", this._widthHandler) : this._on($(window), "resize", this._widthHandler);
        },
        _widthHandler: function (e) {
            this._setWidth(this.model.width);
        },

        _setOrientation: function (value) {
            if (value != ej.Orientation.Vertical) {
                this.element.removeClass(this.model.cssClass).addClass("e-toolbarspan " + this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-vertical").addClass("e-ul e-horizontal");
            }
            else {
                this.element.removeClass("e-toolbarspan " + this.model.cssClass).addClass(this.model.cssClass);
                this.itemsContainer.removeClass("e-ul e-horizontal").addClass("e-ul e-vertical");
            }
            this.items.addClass("e-tooltxt");
			
        },

        _reSizeHandler: function () {
			if (this._isResized && this._liTemplte.children().length > 0) {
                $(this._liTemplte.children()).insertBefore($(this.element).find("span.e-res-pos"));
                this._renderToolbarSeparator();
			  if(this.model.responsiveType!="inline")
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
            }
			this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
            this._liWidth = this._spanWidth;
            this._spantag.removeClass("e-display-block").addClass("e-display-none");
            for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true)+8;
                if (this._liWidth > this._elementWidth) {
                    if (!this._spantag.hasClass("e-display-block"))
                    this._spantag.removeClass("e-display-none").addClass("e-display-block");
                    this._spantag.addClass('e-res-pos');
					this._liTemplte.addClass('e-normal');
                    this._liTemplte.append(this.itemsContainer[i]);
                }
            }
			if(this.model.responsiveType=="inline")
			{
			this._liTemplte.removeClass('e-normal');
            this._liTemplte.css("width",this.element.width());
			}
		    this._isResized = true;
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _btnMouseClick: function (e) {
            var args, btnpos, btnposx, btnposy, poscur = 1, eleWidth = this.element.outerWidth(), eleHeight = this.element.outerHeight(), resWidth = $(this._liTemplte).outerWidth(), winWidth = $(window).width(), winLeft = $(window).scrollLeft();
            if (!$(e.currentTarget).hasClass("e-disable")) {
                /*Context Menu Functionality*///need to write enableRTL
              var maxZ = this._getZindexPartial();
                btnpos = this._getOffset(this.element);
                btnposx = this.model.enableRTL ? btnpos.left : (btnpos.left + eleWidth - resWidth);
                btnposy = btnpos.top + eleHeight - poscur + 2;
                btnposx = btnposx < winLeft ? winLeft + poscur : ((btnposx + resWidth) > (winWidth + winLeft) ? winWidth - resWidth + winLeft - poscur : btnposx);
                if (this._contstatus) {
                    this._liTemplte.addClass("e-display-none");
					if(this.model.responsiveType=="inline")
					   this._spantag.removeClass("e-active");
                    this._contstatus = false;	
                   args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};					
					this._trigger("overflowClose",args);
                  					
                } else {
				   this._liTemplte.removeClass("e-display-none");
                   if(this.model.responsiveType!="inline")
				     this._liTemplte.css({ "top": btnposy + "px", "left": btnposx + "px", "z-index": maxZ });
				   if(this.model.responsiveType=="inline")	
                      this._spantag.addClass("e-active");
                    this._contstatus = true;
					args = { currentTarget: e.currentTarget, clientX:e.clientX ,clientY:e.clientY , cancel:e.cancellable};
					this._trigger("overflowOpen",args);
				 if(this.model.responsiveType!="inline")
                    this._on(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                    this.element.bind("click", $.proxy(this._hidecontext, this));
                }
                if ((this._contstatus)&&(this.model.responsiveType!="inline"))
                    this._on($(document), "mouseup", this._documentClick);
					 if(!this._contstatus)
				 this._off($(document), "mouseup", this._documentClick);
                this._removeListHover();
            }
        },

        _hidecontext: function (e) {
            if ((!$(e.target).is($("#" + this.element[0].id + "_target")))&&(this.model.responsiveType!="inline")) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
                this.element.unbind("click", $.proxy(this._hidecontext, this));
                this._off(ej.getScrollableParents(this.element), "scroll", this._hidecontext);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is($("#" + this.element[0].id + "_target")) && !($(e.target).closest("div#" + this.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) {
                this._liTemplte.addClass("e-display-none");
                this._contstatus = false;
				var args = { currentTarget: e.currentTarget, clientX: e.clientX, clientY: e.clientY, cancel: e.cancellable };
                this._trigger("overflowClose", args);
                this._off($(document), "mouseup", this._documentClick);
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
			var tooltipCssClass = "e-toolbarTooltip " + skin; 
			this._subControlsSetModel("cssClass", tooltipCssClass);
        },
		_subControlsSetModel : function (prop, value){
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("option", prop, value);
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("option", prop, value);
		},

        _destroy: function () {
            this.element.html("");
			!ej.isNullOrUndefined(this._tipToolbar) && $(this.target).ejTooltip("destroy");
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            this._cloneElement.removeClass('e-toolbar e-js');
            this.element.replaceWith(this._cloneElement);
            this._liTemplte && this._liTemplte.remove();
            this._unWireResizing();
        },

        _initialize: function () {
            this.element.attr({ "role": "toolbar", "tabindex": "0" });
            var liList = this.element.children().find('li');
            this._focusEnable = true;
            this._renderControl();
            this._responsiveLayout();
            this._wireEvents();
        },
        _responsiveLayout: function () {
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.isResponsive && (this.model.orientation == "horizontal")) {
                if (!ej.isNullOrUndefined(this._liTemplte)) {
                    !ej.isNullOrUndefined(this._tipRes) && this._tipRes.destroy();
                    $(this._liTemplte).remove();
                }
				this._spantag = $("<span id='" + this.element[0].id + "_target' class='e-icon e-toolbar-res-arrow e-rel-position e-display-block' unselectable='on'></span>");
				if(this.model.responsiveType=="inline")
				{
				this._spantag.removeClass("e-toolbar-res-arrow").addClass("e-inlinearrow e-arrow-sans-down");
				}
                this._spantag.appendTo(this.element);
				this._liTemplte = $("<div id='" + this.element[0].id + "_hiddenlist' class='e-responsive-toolbar e-display-none e-abs-position " + $(this.element)[0].className + "'></div>");
                if(this.model.responsiveType=="inline")
                   this._liTemplte.removeClass("e-abs-position").addClass("e-inline");				 
                this._spantag.appendTo(this.element);
                this._spanWidth = this._spantag.outerWidth(true) + 8; // 8px from right of span 
                if (this.model.enableRTL) this._liTemplte.addClass('e-rtl');
                this._isResized = false;
				this._elementWidth = (typeof window.getComputedStyle == "function") ? parseFloat(window.getComputedStyle(this.element[0]).width) : this.element.width()-1; // -1 for IE8 get exact width of an element no border and margin            
				this._liWidth = this._spanWidth;
				for (var i = 0; i < this.itemsContainer.length; i++) {
                this._liWidth += $(this.itemsContainer[i]).outerWidth(true);
				}
                if (this._liWidth > this._elementWidth)
                this._reSizeHandler();
                else 
				this._spantag.removeClass("e-display-block").addClass("e-display-none");
				if(this.model.responsiveType=="inline")
				  $(this.element[0]).append(this._liTemplte);
				else
                  $('body').append(this._liTemplte);
                this._renderTooltip(this.model.tooltipSettings);
            }
            this._on($("#" + this.element[0].id + "_target"), "mousedown", this._btnMouseClick);
            this._wireResizing();
            this._controlVisibleOptions(this.model.hide);
            this._enableRTL(this.model.enableRTL);
			this._disabledItems = this.model.disabledItemIndices; 
            this._controlStatus(this.model.enabled);
			this.model.disabledItemIndices = this._disabledItems;
            if (this.model.disabledItemIndices.length != 0)
                this._disableItemByIndex(this.model.disabledItemIndices);
            if (this.model.enabledItemIndices.length != 0)
                this._enableItemByIndex(this.model.enabledItemIndices);
            this._setWidth();
        },
        _removeResponsive: function () {
            $(this._spantag).remove();
			!ej.isNullOrUndefined(this._tipRes) && $(this._liTemplte).ejTooltip("destroy");
            var list = $(this._liTemplte).children('ul');
            $(this._liTemplte).detach();
            $(this.element).append(list);
            this.itemsContainer = this.element.children("ol,ul");
            this.items = this.itemsContainer.children('li');
            this._off(this.items, "mouseup");
            this._off(this.items, "mousedown");
            this._off(this.element, "mousedown");
            this._wireEvents();
            this._wireResizing();
            this._setWidth();
        },

        _controlVisibleOptions: function (value) {
            value != false ? this.hide() : this.show();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                this._liTemplte && this._liTemplte.addClass('e-corner');
            } else {
                this.element.removeClass('e-corner');
                this._liTemplte && this._liTemplte.removeClass('e-corner');
            }
			this._subControlsSetModel("showRoundedCorner", value);
        },

        _generateTemplate: function () {
            var proxy = this, queryPromise;
            this.element.css("visibility", "hidden");
            if (this.model.dataSource instanceof ej.DataManager) {
                queryPromise = this.model.dataSource.executeQuery(this.model.query);
                queryPromise.done(function (e) {
                    proxy._generateGroup(e.result);
                    proxy._initialize();
                    proxy.element.css("visibility", "");
                });
            } else if(this.model.dataSource!=null)
			{ 
			    proxy._generateGroup(proxy.model.dataSource);
                proxy.element.css("visibility", "");
               
            }
			else {
                proxy._generateGroup(proxy.model.Items);
                proxy.element.css("visibility", "");
            }
        },
        _generateGroup: function (value) {
            var proxy = this;
			this._localDataSource=value;
            var y = -1;
            var groupArray = [];
            for (var i = 0; i < value.length; i++) {
                if (this._isNewGroup(value[i][this.model.fields.group], groupArray)) {
                    groupArray[++y] = value[i][this.model.fields.group];
                    var index = -1;
                    proxy.itemsSource = [];
                    for (var x = i; x < value.length; x++) {
                        if (value[i][this.model.fields.group] == value[x][this.model.fields.group]) {
                            proxy.itemsSource[++index] = value[x];
                        }
                    }
                    proxy.element.append(proxy._generateTagitems());
                }
            }

        },
        _isNewGroup: function (value, group) {
            if (!group)
                return true;
            for (var i = 0; i < group.length; i++) {
                if (value == group[i])
                    return false;
            }
            return true;
        },


        _renderControl: function () {
            this.element.addClass("e-widget e-box");
            this._renderToolbarItems();
            this._addAttr(this.model.htmlAttributes);
            this._setOrientation(this.model.orientation);
            this._renderToolbarSeparator();
            this._setHeight(this.model.height);
            this._bindUnbindWidth();
        },

        _renderToolbarItems: function () {
            this.target = this.element[0];
            this.itemsContainer = this.element.children("ol,ul");
            this.itemsContainer.children("ol,ul").remove();
            this.items = this.itemsContainer.children('li');
            for (var i = 0; i < this.items.length; i++) {
                if (ej.isNullOrUndefined($(this.items[i]).attr("title")))
                    $(this.items[i]).attr("aria-label", this.items[i].id);
            }
            this._liCount = this.items.length;
        },

        _generateTagitems: function () {
            var list, i;
            list = this.itemsSource;
            this.ultag = ej.buildTag('ul');
            for (i = 0; i < list.length; i++) {
                this.ultag.append(this._generateLi(list[i]));
            }
            return this.ultag;
        },

        _generateLi: function (toolbarItem) {
            var litag, imgtag, divtag, i;
            litag = ej.buildTag('li');
            if (toolbarItem[this.model.fields.id])
                litag.attr('id', toolbarItem[this.model.fields.id]);
            else 
                (toolbarItem[this.model.fields.text]) && litag.attr('id', toolbarItem[this.model.fields.text]);
            if (toolbarItem[this.model.fields.tooltipText])
                litag.attr('title', toolbarItem[this.model.fields.tooltipText]);
            if ((toolbarItem[this.model.fields.imageUrl]) && (toolbarItem[this.model.fields.imageUrl] != "")) {
                //Creating the image tag
                imgtag = ej.buildTag('img.e-align', '', {}, { 'src': toolbarItem[this.model.fields.imageUrl], 'alt': toolbarItem[this.model.fields.text] });
                if (toolbarItem[this.model.fields.imageAttributes]) this._setAttributes(toolbarItem[this.model.fields.imageAttributes], imgtag);
                litag.append(imgtag);
            }
            if ((toolbarItem[this.model.fields.spriteCssClass]) && (toolbarItem[this.model.fields.spriteCssClass] != "")) {
                //Creating the Sprite image tag
                divtag = ej.buildTag('div.e-align ' + toolbarItem[this.model.fields.spriteCssClass] + ' e-spriteimg');
                litag.append(divtag);
            }
            if ((toolbarItem[this.model.fields.text]) && (toolbarItem[this.model.fields.text] != "")) {
                //Creating text Content inside the  tag
                litag.append(toolbarItem[this.model.fields.text]);
            }
            if (toolbarItem[this.model.fields.htmlAttributes]) this._setAttributes(toolbarItem[this.model.fields.htmlAttributes], litag);
              if(toolbarItem[this.model.fields.template])
			{
			
			divtag=ej.buildTag('div .e-align' ,toolbarItem[this.model.fields.template]);
			litag.append(divtag);
			}
            return litag;
        },


        _setAttributes: function (data, element) {
            for (var key in data) {
                $(element).attr(key, data[key]);
            }
        },

        _renderToolbarSeparator: function () {
            var i, len;
            if (this.model.enableSeparator) {
                for (i = 0, len = this.itemsContainer.length - 1; i < len; i++) {
                    $(this.itemsContainer[i]).addClass("e-separator");
                }
				if (this.itemsContainer.length == 1) {
                        for (i = 0, len = this.itemsContainer[0].children.length; i < len; i++) {
                            if (i == len - 1) $(this.itemsContainer[0].children[i]).removeClass("e-separator");
                            else
                                $(this.itemsContainer[0].children[i]).addClass("e-separator");
                        }
                    }    
            } else {
                this.itemsContainer.removeClass('e-separator').find('.e-separator').removeClass('e-separator');
            }
            this._setWidth();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },


        _enableRTL: function (value) {
            if (value) {
                this.element.addClass('e-rtl');
                this.items.addClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.addClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.addClass('e-rtl');
            } else {
                this.element.removeClass('e-rtl');
                this.items.removeClass('e-comnrtl');
                if (this.model.orientation == ej.Orientation.Horizontal) {
                    this.itemsContainer.removeClass('e-comnrtl');
                }
                if (this._liTemplte) this._liTemplte.removeClass('e-rtl');
            }
            this.model.enableRTL = value;
			this._subControlsSetModel("enableRTL", value);
            this._renderToolbarSeparator();
        },

        _renderTooltip: function (options) {
            var model =$.extend(true, {}, options); 
			if(!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
				model.cssClass = model.cssClass + " e-toolbarTooltip " + this.model.cssClass;
			else 
				model.cssClass = "e-toolbarTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
			model.showRoundedCorner = this.model.showRoundedCorner;
			model.target ="li[data-content], li[title]" ;
			model.beforeOpen = this._showTooltip;
            this._tipToolbar = $(this.target).ejTooltip(model).data("ejTooltip");
			if(this.model.isResponsive && !ej.isNullOrUndefined(this._liTemplte))
				this._tipRes = $(this._liTemplte).ejTooltip(model).data("ejTooltip");
        },
		_showTooltip : function (e){
			var currentItem = $(e.event.currentTarget), targetItem = e.event.target;
			if (currentItem.hasClass("e-disable"))
				e.cancel = true;
		
		},
		_hideTooltip : function (){
			//tap to select the items, mousemove triggered after the tap, so private variable isHided of Tooltip is set as false
			if(!ej.isNullOrUndefined(this._tipToolbar)){ this._tipToolbar.hide(); this._tipToolbar._isHidden= false;}
			if(!ej.isNullOrUndefined(this._tipRes)){ this._tipRes.hide(); this._tipRes._isHidden = false;}
		},
        _addOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                if (!$(element[i]).hasClass('e-disable')) {
                    $(element[i]).addClass('e-disable');
                    var ele = ej.buildTag("div.e-item-overlay");
                    $(element[i]).append(ele);
                }
            }
        },
        _removeOverlay: function (element) {
            for (var i = 0; i < element.length; i++) {
                $(element[i]).children(".e-item-overlay").remove();
            }
        },



        disableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            if (!current.hasClass("e-disable")) {
                current.attr("aria-disabled", true).removeAttr("aria-label");
                this._addOverlay(current);
            }
            current.removeClass("e-hover e-active").attr("data-aria-selected", false);
        },


        enableItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-disable").attr("aria-disabled", false).removeClass('e-disable');
            this._removeOverlay(current);
        },


        disableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.disableItem(lielement);
        },

        enableItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.enableItem(lielement);
        },

        _enableItemByIndex: function (indices) {
            var index;
            if (!this.model.enabled) return false;
            if (indices.length != 0) {
                for (var i = 0; i < indices.length; i++) {
                    if ($.inArray(indices[i], this.model.disabledItemIndices) > -1) {
                        index = $.inArray(indices[i], this.model.disabledItemIndices);
                        this.enableItem(this.items[this.model.disabledItemIndices[index]]);
						this.model.disabledItemIndices.splice(index, 1);
                    }

                }
            }
        },

        _disableItemByIndex: function (indices) {
			if (!this.model.enabled) return false;
			this._disabledItems = this.model.disabledItemIndices; 
			for(var i=0; i< indices.length; i++){
				if ($.inArray(indices[i], this.model.disabledItemIndices) < 0)
					this._disabledItems.push(parseInt(indices[i]));
			}
			for (var i = 0; i < this.items.length; i++) {
				if ($.inArray(i, this.model.disabledItemIndices) > -1)
					this.disableItem(this.items[i]);
			}
			this.model.disabledItemIndices = this._disabledItems ;
        },

        disable: function () {
            if (this.element.attr("aria-disabled") == "true") return false;
            this.element.attr("aria-disabled", true).removeAttr("aria-label");
            this._addOverlay(this.items);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.addClass("e-disable");
            this.model.enabled = false;
			this._subControlsSetModel("enabled", false);
        },


        enable: function () {
			this.model.disabledItemIndices = [];
            if (this.element.attr("aria-disabled") == "false") return false;
            this.items.removeClass("e-disable");
            this._removeOverlay(this.items);
            this.element.attr("aria-disabled", false);
            if (this.model.isResponsive && (this.model.orientation == "horizontal"))
                this._spantag.removeClass("e-disable");
            this.model.enabled = true;
			this._subControlsSetModel("enabled", true);
        },


        selectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.addClass("e-active").attr("data-aria-selected", true);
            this._activeItem = $(this.items).index(current);
        },


        deselectItem: function (lielement) {
            var current = $(lielement);
            if ((current == null) || (current.length <= 0)) return;
            current.removeClass("e-active").attr("data-aria-selected", false);
        },

        selectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.selectItem(lielement);
        },


        deselectItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.deselectItem(lielement);
        },


        removeItem: function (lielement) {
            this.model.disabledItemIndices = [];
            var current = $(lielement);
			var j=0;
            if ((current == null) || (current.length <= 0)) return;
            current.remove();
            this.items = this.itemsContainer.children('li');
			for(var i=0; i< this.items.length ; i++){
				if($(this.items[i]).hasClass("e-disable"))
					this.model.disabledItemIndices [j++] = i;
			}
        },


        removeItemByID: function (liid) {
            var lielement = this.itemsContainer.find("li#" + liid);
            if ((lielement == null) || (lielement.length <= 0)) return;
            this.removeItem(lielement);
        },
        _wireResizing: function () {
            (this.model.isResponsive && (this.model.orientation == "horizontal")) ? $(window).bind('resize', $.proxy(this._reSizeHandler, this)) : this._unWireResizing();
        },

        _unWireResizing: function () {
            $(window).unbind('resize', $.proxy(this._reSizeHandler, this));
        },

        _wireEvents: function () {
            this._on(this.element, "mousedown", this._clickEventHandler);
            this._on(this.element, "focus", this._focusElement);
            this._on(this.element, "blur", this._targetBlur);
            this._on(this.items, "mouseenter", this._onItemHover);
            this._on(this.items, "mouseleave", this._onItemLeave);
            this._on(this.items, "mousedown", this._onItemClick);
            this._on(this.items, "mouseup", this._onItemClick);
        },

        _onItemHover: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this.items.removeClass("e-hover");
                currentItem.addClass("e-hover");
               var args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemHover", args);
            }
        },

        _onItemClick: function (e) {
            if ($(e.currentTarget).hasClass('e-disable') || e.which!=1) return false; //e.which for Opera
            var currentItem = e.currentTarget, targetItem = e.target;
			if(!ej.isDevice()) this._hideTooltip();
            if (e.type == "mousedown") {
                this._focusEnable = false;
                $(currentItem).addClass('e-active');
                this._focusedItem = this._currentItem = $(currentItem);
				
            }
            else if (e.type == "mouseup") {
                this._removeSelection();
				 if (!$(currentItem).hasClass("e-disable")) {
                    var args = { currentTarget: currentItem, text: $(currentItem).attr("data-content"), target: targetItem, status: this.model.enabled, event: e };
                    if (this.model.isResponsive && this._contstatus && $(currentItem).closest('.e-responsive-toolbar').length > 0)
                        this._activeItem = this._liTemplte.find('.e-tooltxt').index(currentItem);
                    else
                        this._activeItem = $(this.items).index(currentItem);
                    this._trigger("click", args);
                }
               
            }
        },

        _onItemLeave: function (e) {
            var currentItem = $(e.currentTarget), targetItem = e.target;
            if (!currentItem.hasClass("e-disable")) {
                this._removeSelection();
                currentItem.removeClass("e-hover");
               var args = { currentTarget: currentItem, target: targetItem, status: this.model.enabled };
                this._trigger("itemLeave", args);
            }
        },

        _onKeyPress: function(e) {
            var code, items, active, toFocus;
            code = (e.keyCode) ? e.keyCode : (e.which) ? e.which : e.charCode;
            if (this.model.isResponsive && this._liTemplte.find('.e-tooltxt').length > 0) {
                this._keyPressed = true;
                this._items = (this._contstatus) ? this._liTemplte.find('.e-tooltxt') : this.element.find('.e-tooltxt');
                items = this._items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            } else {
                this._keyPressed = false;
                items = this.items.filter('.e-tooltxt:visible:not(.e-hidden, .e-disable)');
            }
            if (this._focusedItem) {
                active = this._focusedItem;
                this._focusedItem = null;
            } else
                active = items.filter('.e-hover');
            if(e.type == 'keydown') {
                if(code == 9 && e.shiftKey && $(items[items.index(active) - 1]).length > 0 ){                    
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]);               
                } else if (code == 9 && $(items[items.index(active) + 1]).length > 0) {                    
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]);
                } else if(((code == 38 || code == 39) && this.model.orientation != ej.Orientation.Vertical) || ((code == 39 || code == 40) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) + 1]).length > 0 ? $(items[items.index(active) + 1]) : items.first();
                } else if(((code == 37 || code == 40) && this.model.orientation != ej.Orientation.Vertical) || ((code == 37 || code == 38) && this.model.orientation == ej.Orientation.Vertical)) {
                    e.preventDefault();
                    toFocus = $(items[items.index(active) - 1]).length > 0 ? $(items[items.index(active) - 1]) : items.last();
                } else if(code == 33 || code == 36) {
                    e.preventDefault();
                    toFocus = items.first();
                } else if(code == 34 || code == 35) {
                    e.preventDefault();
                    toFocus = items.last();
                }
                if(toFocus) {
                    this._removeListHover();
                    toFocus.addClass('e-hover');
                }
            } else {
                switch(code) {
                    case 33: case 34: case 35: case 36: case 37: case 38: case 39: case 40: break;
                    case 13: case 32:
                        e.preventDefault();
                        if (!active[0])
                            break;
                        var args = { currentTarget: active[0], target: $(active)[0], status: this.model.enabled, event: e };
                        this._trigger("click", args);
                        this._removeListHover();
                        break;
                    case 27:
                        e.preventDefault();
                        this.element.blur();
                        break;                    
                }
            }
        },

        _removeListHover: function () {
            $(this.items).removeClass("e-hover");
        },

        _addListHover: function () {
            var activeItem = this._getActiveItem();
            if (!activeItem.hasClass('e-disable'))
                activeItem.addClass("e-hover").focus();
        },

        _getActiveItem: function () {
            if (this.model.isResponsive && this._keyPressed)
                return $(this._items[this._activeItem]);
            else
                return $(this.items[this._activeItem]);
        },

        _targetBlur: function (e) {
            e.preventDefault();
            this.element.focusout().removeClass("e-focus");
            this._removeListHover();
            this._off(this.element, "keyup", this._onKeyPress)
                ._off(this.element, "keydown", this._onKeyPress);
            this._trigger("focusOut");
        },

        _clickEventHandler: function (e) {
            this._clicked = true;
        },

        _removeSelection: function() {
            (this._currentItem && this._currentItem.attr("data-aria-selected") != "true") && this._currentItem.removeClass('e-active');
        },

        _focusElement: function (e) {
		    if(!this.element.hasClass("e-focus")){
				this.element.addClass("e-focus");
				this._on(this.element, "keyup", this._onKeyPress)
					._on(this.element, "keydown", this._onKeyPress);
				if (!this._focusEnable) {
					this._focusEnable = true;
					return;
				}
			}
            this._removeListHover();
            this._activeItem = (this._clicked) ? -1 : 0;
            if (this._getActiveItem().hasClass('e-disable') || this._getActiveItem().is(':hidden'))
                this._activeItem = $(this.items).filter('li:not([class*="e-disable"])').first().index();
            this._addListHover();
        },
    });
ej.Toolbar.ResponsiveType = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar itself on clicking the arrow. */
        Inline: "inline"
    };
	
})(jQuery, Syncfusion);


;
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ejTooltip = (function (_super) {
    __extends(ejTooltip, _super);
    function ejTooltip(element, options) {
        _super.call(this);
        this._rootCSS = "e-tooltip";
        this._setFirst = false;
        this.PluginName = "ejTooltip";
        this.id = "null";
        this.model = null;
        this.defaults = {
            height: "auto",
            width: "auto",
            enabled: true,
            content: null,
            containment: "body",
            target: null,
            title: null,
            closeMode: "none",
            autoCloseTimeout: 4000,
            position: {
                stem: { horizontal: "center", vertical: "bottom" },
                target: { horizontal: "center", vertical: "top" }
            },
            associate: "target",
            collision: "flipfit",
            showShadow: false,
            cssClass: null,
            animation: {
                effect: "none",
                speed: 0
            },
            isBalloon: true,
            showRoundedCorner: false,
            enableRTL: false,
            allowKeyboardNavigation: true,
            tip: {
                size: {
                    width: 20,
                    height: 10
                },
                adjust: {
                    xValue: 0,
                    yValue: 0
                }
            },
            trigger: "hover",
            create: null,
            click: null,
            destroy: null,
            hover: null,
            tracking: null,
            beforeOpen: null,
            beforeClose: null,
            open: null,
            close: null,
        };
        this.dataTypes = {
            enabled: "boolean",
            closeMode: "enum",
            autoCloseTimeout: "number",
            trigger: "enum",
            position: {
                stem: "data",
                target: "data"
            },
            associate: "enum",
            collision: "enum",
            showShadow: "boolean",
            animation: {
                effect: "enum",
                speed: "number"
            },
            isBalloon: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            allowKeyboardNavigation: "boolean",
            tip: {
                size: {
                    width: "number",
                    height: "number"
                },
                adjust: {
                    xValue: "number",
                    yValue: "number"
                }
            }
        };
        this.isTrack = true;
        this._isCancel = false;
        this._isHidden = true;
        this.arrowValue = { left: 0, top: 0, width: 0, height: 0, display: null };
        this.tooltipPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.targetPos = { width: 0, height: 0, left: 0, top: 0, bottom: 0, right: 0, position: "absolute" };
        this.mouseTimer = null;
        this.positionTarget = null;
        this.positionTooltip = null;
        this.containerSize = null;
        this._createTitle = function () {
            this.tooltipTitle = ej.buildTag('div.e-def e-header', " ", {}, {});
            this.tooltipHeader = ej.buildTag('div', " ", {}, {});
            $(this.tooltipTitle).html(this.model.title).appendTo(this.tooltipHeader);
        };
        if (element) {
            if (!element["jquery"]) {
                element = $("#" + element);
            }
            if (element.length) {
                return $(element).ejTooltip(options).data(this.PluginName);
            }
        }
    }
    ejTooltip.prototype.setModel = function (opt, forceSet) {
        this.setModel(opt, forceSet);
    };
    ejTooltip.prototype.option = function (opt, forceSet) {
        this.option(opt, forceSet);
    };
    ejTooltip.prototype.triggerEvents = function (eventName, eventProp) {
        var temp;
        switch (eventName) {
            case "click":
                var clickArg = eventProp;
                temp = this._trigger(eventName, clickArg);
                break;
            case "hover":
                var hoverArg = eventProp;
                temp = this._trigger(eventName, hoverArg);
                break;
            case "tracking":
                var trackArg = eventProp;
                temp = this._trigger(eventName, trackArg);
                break;
            case "beforeOpen":
                var beforeOpenArg = eventProp;
                temp = this._trigger(eventName, beforeOpenArg);
                break;
            case "open":
                var openArg = eventProp;
                temp = this._trigger(eventName, openArg);
                break;
            case "beforeClose":
            case "close":
                var closeArg = eventProp;
                temp = this._trigger(eventName, closeArg);
                break;
        }
        return temp;
    };
    ejTooltip.prototype.enable = function (val) {
        if (this.tooltip.hasClass("e-disable")) {
            this.model.enabled = true;
            this.tooltip.removeClass("e-disable");
        }
    };
    ejTooltip.prototype.disable = function (val) {
        if (!this.tooltip.hasClass("e-disable")) {
            this.model.enabled = false;
            this.tooltip.addClass("e-disable");
        }
    };
    ejTooltip.prototype.show = function (targetElement, func) {
        if (this.model.enabled) {
            if (ej.isNullOrUndefined(targetElement)) {
                var target = (this.model.target == null) ? this.element : $(this.element).find(this.model.target + ":first");
                this._positionElement(target);
            }
            else {
                this._positionElement(targetElement);
            }
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).show(func);
                }
                else {
                    if (typeof func === "function") {
                        func.call.apply(this.tooltip);
                    }
                }
            }
            else {
                this._showTooltip();
            }
        }
    };
    ejTooltip.prototype.hide = function (func) {
        if (this.model.enabled) {
            if (!ej.isNullOrUndefined(func)) {
                if (typeof func === "string") {
                    $(this.tooltip).hide(func);
                }
                else if (typeof func === "function") {
                    func.call.apply(this.tooltip);
                }
            }
            else {
                this._hideTooltip();
            }
        }
    };
    ejTooltip.prototype._destroy = function () {
        this.mouseTimer && clearTimeout(this.mouseTimer);
        this.timer && clearTimeout(this.timer);
        $(this.tooltip).remove();
        this.tooltip = null;
    };
    ejTooltip.prototype._setModel = function (options) {
        var option;
        for (option in options) {
            switch (option) {
                case "height":
                    this._setHeight(options[option]);
                    break;
                case "width":
                    this._setWidth(options[option]);
                    break;
                case "enabled":
                    this._enabled(options[option]);
                    break;
                case "content":
                    this._setContent(options[option]);
                    break;
                case "title":
                    this.model.title = options[option];
                    if (this.model.title == null) {
                        $(this.tooltipHeader).remove();
                        this.tooltipHeader = null;
                        this.tooltipTitle = null;
                        if (this.model.closeMode === ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                    }
                    else
                        (ej.isNullOrUndefined(this.tooltipHeader)) ? this._createHeader() : $(this.tooltipTitle).html(this.model.title);
                    this.tooltipPos.height = $(this.tooltip).outerHeight();
                    break;
                case "associate":
                    this.model.associate = options[option];
                    this._wireMouseEvents(false);
                    this._wireMouseEvents(true);
                    break;
                case "position":
                    this._setPosition(options[option]);
                    break;
                case "collision":
                    this.model.collision = options[option];
                    break;
                case "closeMode":
                    if (typeof options[option] !== "undefined") {
                        this.model.closeMode = options[option];
                        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
                            this._iconRender();
                        else {
                            $(this.tooltipClose).remove();
                            this.tooltipClose = null;
                        }
                        this.tooltipPos.height = $(this.tooltip).outerHeight();
                    }
                    break;
                case "cssClass":
                    this._setSkin(options[option]);
                    break;
                case "showShadow":
                    this._shadowEffect(options[option], this.model.position);
                    break;
                case "isBalloon":
                    if (!ej.isNullOrUndefined(options[option])) {
                        this.model.isBalloon = options[option];
                        if (!this.model.isBalloon) {
                            $(this.tip).remove();
                            this.tip = null;
                        }
                        else
                            this._renderArrow();
                    }
                    break;
                case "animation":
                    var val = options[option];
                    this.model.animation = $.extend(true, this.model.animation, val);
                    if (this.model.animation.effect != ej.Tooltip.Effect.None) {
                        this._off($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._off($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    else if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                        this._on($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
                        this._on($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
                    }
                    break;
                case "enableRTL":
                    this._setRTL(options[option]);
                    break;
                case "target":
                    this._wireTriggerEvents(false);
                    this.model.target = options[option];
                    this._wireTriggerEvents(true);
                    this._renderTarget();
                    break;
                case "trigger":
                    this._setTrigger(options[option]);
                    break;
                case "showRoundedCorner":
                    this.model.showRoundedCorner = options[option];
                    this._roundedCorner(options[option]);
                    break;
                case "allowKeyboardNavigation":
                    this.model.allowKeyboardNavigation = options[option];
                    if (!this.model.allowKeyboardNavigation) {
                        this._off($(window), "keydown", this._keyDown);
                    }
                    else {
                        this._on($(window), "keydown", this._keyDown);
                    }
                    break;
            }
        }
    };
    ejTooltip.prototype._enabled = function (val) {
        (val) ? this.enable(val) : this.disable(val);
        this.model.enabled = val;
    };
    ejTooltip.prototype._shadowEffect = function (val, position) {
        this.model.showShadow = val;
        var shadowEffect = null;
        $(this.tooltip).removeClass("e-tooltipShadowLeft e-tooltipShadowRight");
        if (this.model.showShadow) {
            if (this.model.isBalloon) {
                switch (position.stem.horizontal) {
                    case "center":
                        shadowEffect = (position.stem.vertical == "top") ? "e-tooltipShadowLeft" : (position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                    case "right":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "top") ? "e-tooltipShadowLeft" : "e-tooltipShadowRight";
                        break;
                    case "left":
                        shadowEffect = (position.target.horizontal == "center" && position.stem.vertical == "bottom") ? "e-tooltipShadowRight" : "e-tooltipShadowLeft";
                        break;
                }
            }
            else
                shadowEffect = "e-tooltipShadowLeft";
            $(this.tooltip).addClass(shadowEffect);
        }
    };
    ejTooltip.prototype._setContent = function (val) {
        this.model.content = val;
        $(this.tooltipContent).html(this.model.content);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.tooltipPos.width = $(this.tooltip).outerWidth();
    };
    ejTooltip.prototype._setPosition = function (val) {
        this.model.position.stem = $.extend(true, this.model.position.stem, val.stem);
        this.model.position.target = $.extend(true, this.model.position.target, val.target);
    };
    ejTooltip.prototype._setTrigger = function (val) {
        this._wireTriggerEvents(false);
        this.model.trigger = val;
        this._wireTriggerEvents(true);
    };
    ejTooltip.prototype._init = function () {
        this.id = this.element[0].id;
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.tipSize = $.extend(true, {}, this.model.tip.size);
        this._initialize();
        this._render();
        this.enable(this.model.enabled);
        this._wireEvents(true);
    };
    ejTooltip.prototype._initialize = function () {
        if (ej.isNullOrUndefined(this.model.target)) {
            if (ej.isNullOrUndefined(this.model.content) && (!ej.isNullOrUndefined(this.element.attr("title")))) {
                this.model.content = this.element.attr("title");
                this.element.attr("data-content", this.model.content);
                this.element.removeAttr("title");
            }
        }
        else
            this._renderTarget();
    };
    ejTooltip.prototype._wireEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        this._wireTriggerEvents(val);
        if (this.model.allowKeyboardNavigation)
            this[wire]($(window), "keydown", this._keyDown);
        (this.model.target != null) ? this[wire](this.element, "scroll", this.model.target, this._hideTooltip) : this[wire](this.element, "scroll", this._hideTooltip);
        this[wire]($(this.tooltip), "mouseenter", this._onTooltipMouseEnter);
        this[wire]($(this.tooltip), "mouseleave", this._onTooltipMouseLeave);
        this[wire]($(window), "resize", this._hideTooltip);
        this[wire]($(window), "touchend", this._docTouchEndHandler);
    };
    ejTooltip.prototype._wireTriggerEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        if (this.model.trigger == ej.Tooltip.Trigger.Focus)
            (this.model.target != null) ? this[wire](this.element, "blur", this.model.target, this._hideTooltip) : this[wire](this.element, "blur", this._hideTooltip);
        else
            (this.model.target != null) ? this[wire](this.element, ej.isDevice() ? "touchstart" : "mouseleave", this.model.target, this._onMouseOut) : this[wire](this.element, ej.isDevice() ? "touchstart" : "mouseleave", this._onMouseOut);
        this._wireMouseEvents(val);
        var triggerEvent = (this.model.trigger == ej.Tooltip.Trigger.Click) ? (ej.isDevice() ? "touchstart" : "click") : (this.model.trigger == ej.Tooltip.Trigger.Focus) ? (ej.isDevice() ? "touchstart" : "focus") : (ej.isDevice() ? "touchstart" : "mouseenter");
        (this.model.target != null) ? this[wire](this.element, triggerEvent, this.model.target, this._targetHover) : this[wire](this.element, triggerEvent, this._targetHover);
    };
    ejTooltip.prototype._wireMouseEvents = function (val) {
        var wire = (val) ? "_on" : "_off";
        if (this.model.associate == ej.Tooltip.Associate.MouseEnter || this.model.associate == ej.Tooltip.Associate.MouseFollow)
            (this.model.target != null) ? this[wire](this.element, ej.isDevice() ? "touchstart" : "mousemove", this.model.target, this._tooltipMove) : this[wire](this.element, ej.isDevice() ? "touchstart" : "mousemove", this._tooltipMove);
    };
    ejTooltip.prototype._render = function () {
        this.tooltip = ej.buildTag("div.e-tooltip-wrap e-widget", "", {}, { role: "tooltip", 'aria-readonly': 'true', 'aria-hidden': 'true', 'aria-describedby': this.id + '_content', 'id': this.id + '_Main' });
        this.tooltipInter = ej.buildTag("div.e-tipContainer", "", {}, {});
        this.tooltip.append(this.tooltipInter);
        if (this.model.isBalloon)
            this._renderArrow();
        $(this.model.containment).append(this.tooltip);
        this._setHeight(this.model.height);
        this._setWidth(this.model.width);
        this._createHeader();
        this._tooltipContent();
        if (this.model.cssClass)
            this.tooltip.addClass(this.model.cssClass);
        if (this.model.showRoundedCorner)
            this._roundedCorner(this.model.showRoundedCorner);
        if (this.model.enableRTL)
            this._setRTL(this.model.enableRTL);
        $(this.tooltip).css({ "top": "auto", "left": "auto" });
        this.tooltipPos = { width: $(this.tooltip).outerWidth(), height: $(this.tooltip).outerHeight(), left: $(this.tooltip).offset().left, top: $(this.tooltip).offset().top, position: "absolute" };
        if (ej.isNullOrUndefined(this.model.target)) {
            this._containerCalc(this.element);
            this._positionElement(this.element);
        }
    };
    ejTooltip.prototype._containerCalc = function (target) {
        if (ej.isNullOrUndefined(target))
            target = this.element;
        var containerElement = { left: 0, top: 0 };
        var childElement = $(target).offset();
        this.containerSize = {
            height: (this.model.containment == "body") ? $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight : $(this.model.containment).innerHeight(),
            width: (this.model.containment == "body") ? $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth : $(this.model.containment).innerWidth()
        };
        this.containerSize.left = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().left - $(this.model.containment).offsetParent().offset().left) : 0 : 0;
        this.containerSize.top = (this.model.containment != "body") ? ($(this.model.containment).css("position") == "static") ? ($(this.model.containment).offset().top - $(this.model.containment).offsetParent().offset().top) : 0 : 0;
        childElement.left -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().left : $(this.model.containment).offset().left) : 0;
        childElement.top -= (this.model.containment != "body") ? (($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset().top : $(this.model.containment).offset().top) : 0;
        this.targetPos.left = childElement.left;
        this.targetPos.top = childElement.top;
    };
    ejTooltip.prototype._setHeight = function (val) {
        this.model.height = val;
        (!isNaN(+val) && isFinite(val)) ? $(this.tooltip).css("height", val + "px") : $(this.tooltip).css("height", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setWidth = function (val) {
        this.model.width = val;
        if (this.model.width != "auto") {
            val = (!isNaN(+val) && isFinite(val)) ? val + "px" : val;
            $(this.tooltip).css("max-width", val);
            $(this.tooltip).css("min-width", "0px");
        }
        $(this.tooltip).css("width", val);
        this.tooltipPos.height = $(this.tooltip).outerHeight();
    };
    ejTooltip.prototype._setRTL = function (val) {
        this.model.enableRTL = val;
        val ? this.tooltip.addClass("e-rtl") : this.tooltip.removeClass("e-rtl");
    };
    ejTooltip.prototype._setSkin = function (skin) {
        if (this.model.cssClass != skin) {
            this.tooltip.removeClass(this.model.cssClass).addClass(skin);
            this.model.cssClass = skin;
        }
    };
    ejTooltip.prototype._roundedCorner = function (val) {
        (this.model.showRoundedCorner) ? this.tooltip.addClass("e-corner") : this.tooltip.removeClass("e-corner");
    };
    ejTooltip.prototype._renderArrow = function () {
        if (ej.isNullOrUndefined(this.tip)) {
            this.tip = ej.buildTag('div.e-arrowTip', " ", { 'id': this.id + "_eTip" }, {});
            $(this.tip).append("<div class='e-arrowTipOuter'></div>").append("<div class='e-arrowTipInner'></div>");
            $(this.tip).insertBefore(this.tooltipInter);
        }
    };
    ejTooltip.prototype._adjustArrow = function (position) {
        var leftValue, topValue, tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        var positionTooltip = position.stem, positionTarget = position.target;
        var arrow = { "tipHeight": 0, "tipWidth": 0 };
        if (positionTarget.horizontal == "right" || positionTarget.horizontal == "left") {
            leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : (positionTooltip.horizontal == "right") ? tooltipWidth : ((tooltipWidth) / 2 - (this.tipSize.width / 2));
            if (positionTooltip.horizontal != "center")
                topValue = (positionTooltip.vertical == "top") ? 5 : (positionTooltip.vertical == "center") ? ((tooltipHeight / 2) - (this.tipSize.width / 2)) : ((tooltipHeight - 5) - this.tipSize.width);
            else
                topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((this.tooltipPos.height / 2) - (this.tipSize.width / 2));
            arrow = this._arrowBinding(position, "horizontal");
        }
        else {
            topValue = (positionTooltip.vertical == "top") ? -this.tipSize.height : (positionTooltip.vertical == "bottom") ? tooltipHeight : ((tooltipHeight / 2) - (this.tipSize.width / 2));
            if (positionTooltip.vertical == "center")
                leftValue = (positionTooltip.horizontal == "left") ? -(this.model.tip.size.height) : tooltipWidth;
            else
                leftValue = (positionTooltip.horizontal == "left") ? 10 : (positionTooltip.horizontal == "center") ? ((this.tooltipPos.width) / 2 - (this.tipSize.width / 2)) : ((tooltipWidth - 10) - this.tipSize.width);
            arrow = this._arrowBinding(position, "vertical");
        }
        this.arrowValue.left = leftValue;
        this.arrowValue.top = topValue;
        $(this.tip).css({ height: arrow.tipHeight + "px", width: arrow.tipWidth + "px", left: leftValue + "px", top: topValue + "px", display: (positionTooltip.horizontal == "center" && positionTooltip.vertical == "center") ? "none" : "block" });
    };
    ejTooltip.prototype._arrowBinding = function (position, arrowType) {
        var positionTooltip = position.stem, condition = (arrowType == "horizontal") ? (positionTooltip.horizontal != "center") : (positionTooltip.vertical == "center");
        var tipWidth, tipHeight, borderColor = $(this.tooltip).css("border-top-color"), backgroudColor = $(this.tooltip).css("background-color"), arrowOuterSize = this.model.tip.size.height, arrowInterSize = this.model.tip.size.height - 1, arrowCalculation = { "border-top": "none", "border-bottom": "none", "border-right": "none", "border-left": "none" };
        if (condition) {
            tipWidth = this.model.tip.size.height;
            tipHeight = this.model.tip.size.width;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "horizontal"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "horizontal"));
        }
        else {
            tipWidth = this.model.tip.size.width;
            tipHeight = this.model.tip.size.height;
            $(this.tip).find(".e-arrowTipOuter").css(this._arrow(position, arrowOuterSize, borderColor, arrowCalculation, "vertical"));
            $(this.tip).find(".e-arrowTipInner").css(this._arrow(position, arrowInterSize, backgroudColor, arrowCalculation, "vertical"));
        }
        return { tipHeight: tipHeight, tipWidth: tipWidth };
    };
    ejTooltip.prototype._arrow = function (position, size, color, arrowCalculation, arrowType) {
        var positionTooltip = position.stem, innerLeft = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? "0px" : "1px" : "1px", innerTop = (arrowType == "horizontal") ? "1px" : (positionTooltip.vertical == "bottom") ? "0px" : "1px";
        arrowCalculation["border-top"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "bottom") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-bottom"] = (arrowType == "horizontal") ? size + "px solid transparent" : (positionTooltip.vertical == "top") ? (size + "px solid " + color) : "none";
        arrowCalculation["border-right"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "left") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        arrowCalculation["border-left"] = (arrowType == "horizontal") ? (positionTooltip.horizontal == "right") ? (size + "px solid " + color) : "none" : size + "px solid transparent";
        if (size == this.model.tip.size.height - 1) {
            arrowCalculation["left"] = innerLeft;
            arrowCalculation["top"] = innerTop;
        }
        return arrowCalculation;
    };
    ejTooltip.prototype._iconRender = function () {
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky) {
            if (!ej.isNullOrUndefined(this.tooltipClose))
                $(this.tooltipClose).remove();
            this.tooltipClose = ej.buildTag("div .e-icon", " ", {}, { 'id': "_closeIcon" });
            (this.model.title != null) ? $(this.tooltipClose).insertAfter(this.tooltipTitle).addClass("e-close") : $(this.tooltipClose).insertBefore(this.tooltipInter).addClass("e-cross-circle");
            this._on($(this.tooltipClose), "click", this._hideTooltip);
        }
    };
    ejTooltip.prototype._renderTarget = function () {
        this.targetElement = $(this.element).find(this.model.target);
        for (var i = 0; i < this.targetElement.length; i++) {
            if (!ej.isNullOrUndefined($(this.targetElement[i]).attr("title"))) {
                this.targetElement[i].setAttribute("data-content", this.targetElement[i].title);
                this.targetElement[i].removeAttribute("title");
            }
        }
    };
    ejTooltip.prototype._tooltipContent = function () {
        this.tooltipContent = ej.buildTag('div.e-tipcontent e-def', "", {}, { 'id': this.id + '_content' });
        $(this.tooltipContent).html(this.model.content).addClass("e-def");
        (this.model.title != null) ? $(this.tooltipContent).insertAfter(this.tooltipHeader) : $(this.tooltipContent).appendTo(this.tooltipInter);
    };
    ejTooltip.prototype._positionElement = function (target) {
        this.tooltipPos.width = $(this.tooltip).outerWidth();
        this.tooltipPos.height = $(this.tooltip).outerHeight();
        this.targetPos.width = $(target).outerWidth();
        this.targetPos.height = $(target).outerHeight();
        this._containerCalc(target);
        if (this.model.associate == ej.Tooltip.Associate.Window)
            this._browserPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Axis)
            this._axisPosition();
        else if (this.model.associate == ej.Tooltip.Associate.Target)
            this._tooltipPosition(this.model.position);
        if (this.model.collision != ej.Tooltip.Collision.None && this.model.associate == ej.Tooltip.Associate.Target)
            this._calcCollision(this.model.position, target);
    };
    ejTooltip.prototype._browserPosition = function () {
        if (this.model.containment == "body") {
            this.containerSize = {
                height: $(window).innerHeight() || document.documentElement.clientHeight || document.body.clientHeight,
                width: $(window).innerWidth() || document.documentElement.clientWidth || document.body.clientWidth
            };
            var position = $.extend(true, {}, this.model.position);
            var calPosition = { position: "absolute", left: "auto", top: "auto", bottom: "auto", right: "auto" }, offsetTop, offsetLeft;
            if (!ej.isNullOrUndefined(this.tip))
                $(this.tip).css({ "display": "none" });
            (this.model.position.target.horizontal == "right") ? calPosition.right = 0 : (this.model.position.target.horizontal == "left") ? calPosition.left = 0 : (calPosition.left = (this.containerSize.width / 2) - (this.tooltipPos.width / 2));
            (this.model.position.target.vertical == "top") ? (calPosition.top = 0) : (this.model.position.target.vertical == "center") ? (calPosition.top = ((this.containerSize.height / 2) - (this.tooltipPos.height / 2))) : calPosition.bottom = 0;
            if (this.model.showShadow)
                this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css(calPosition);
        }
    };
    ejTooltip.prototype._tooltipMove = function (event) {
        if (this.model.closeMode == ej.Tooltip.CloseMode.None && this.model.enabled) {
            var proxy = this;
            if (this._isCancel)
                return;
            if (this.model.associate == ej.Tooltip.Associate.MouseFollow)
                this._mousePosition(event);
            else if (this.model.associate == ej.Tooltip.Associate.MouseEnter) {
                clearTimeout(this.mouseTimer);
                this.mouseTimer = setTimeout(function () {
                    if (proxy.isTrack)
                        proxy._mousePosition(event);
                }, 300);
            }
        }
    };
    ejTooltip.prototype._mousePosition = function (event) {
        var eventPageX, eventPageY;
        if (event.type == "touchstart") {
            event.preventDefault();
            eventPageX = event.touches[0].pageX;
            eventPageY = event.touches[0].pageY;
        }
        else if (event.type == "mousemove") {
            eventPageX = event.pageX;
            eventPageY = event.pageY;
        }
        this.isCollision = true;
        this._containerCalc(event.currentTarget);
        var tipGapX = 0, tipGapY = 0, tipSize = 0, positionTooltip = $.extend(true, {}, this.model.position.stem), position = $.extend(true, {}, this.model.position), containerElement = { left: 0, top: 0 }, calcPosition = { left: eventPageX, top: eventPageY }, childElement = { left: eventPageX, top: eventPageY }, containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        var targetLeft = (this.model.containment != "body") ? (eventPageX - $(this.model.containment).offset().left) : eventPageX, targetTop = (this.model.containment != "body") ? (eventPageY - $(this.model.containment).offset().top) : eventPageY;
        position.target.horizontal = position.target.vertical = "center";
        if (this.model.containment != "body")
            containerElement = ($(this.model.containment).css("position") == "static") ? $(this.model.containment).offsetParent().offset() : $(this.model.containment).offset();
        childElement.left -= containerElement.left;
        childElement.top -= containerElement.top;
        while (this.isCollision) {
            calcPosition = $.extend(true, {}, childElement);
            var tipY = (this.model.isBalloon) ? (positionTooltip.vertical == "top" || positionTooltip.vertical == "bottom") ? (5 + (this.tipSize.height / 2)) : 0 : 0, tipX = (this.model.isBalloon) ? (positionTooltip.horizontal == "right" || positionTooltip.horizontal == "left") ? (10 + (this.tipSize.width / 2)) : 0 : 0;
            tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : 7;
            tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : 10;
            tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal != "center") ? this.model.tip.size.height : (positionTooltip.vertical != "center") ? this.model.tip.size.height : 0 : 2;
            calcPosition.left += (positionTooltip.horizontal == "right") ? -this.tooltipPos.width : (positionTooltip.horizontal == "left") ? 0 : -(this.tooltipPos.width / 2);
            calcPosition.top += (positionTooltip.vertical == "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical == "top") ? 0 : -(this.tooltipPos.height / 2);
            calcPosition.left += (positionTooltip.vertical != "center") ? ((positionTooltip.horizontal == "right") ? tipX : (positionTooltip.horizontal == "left") ? -tipX : 0) : 0;
            calcPosition.left += (positionTooltip.vertical == "center") ? (positionTooltip.horizontal == "right") ? -(tipSize) : (positionTooltip.horizontal == "left") ? +(tipSize + tipGapX) : 0 : 0;
            calcPosition.top += (positionTooltip.vertical == "top") ? +(tipSize + tipGapY) : (positionTooltip.vertical == "bottom") ? -(tipSize) : 0;
            if (this.targetElement != event.currentTarget) {
                this.targetElement = event.currentTarget;
                if (calcPosition.left < containerLeft || (calcPosition.left + this.tooltipPos.width > (containerLeft + this.containerSize.width)))
                    this.positionTooltip.horizontal = (targetLeft >= this.tooltipPos.width) ? "right" : ((this.containerSize.width - targetLeft) >= this.tooltipPos.width) ? "left" : "center";
                if (calcPosition.top < containerTop || ((calcPosition.top + this.tooltipPos.height) > (this.containerSize.height + containerTop)))
                    this.positionTooltip.vertical = (targetTop >= this.tooltipPos.height) ? "bottom" : ((this.containerSize.height - targetTop) >= this.tooltipPos.height) ? "top" : "center";
            }
            if (this.positionTooltip.horizontal != positionTooltip.horizontal || this.positionTooltip.vertical != positionTooltip.vertical) {
                this.isCollision = true;
                positionTooltip = $.extend(true, {}, this.positionTooltip);
            }
            else {
                this.isCollision = false;
                $(this.tooltip).css({ top: calcPosition.top + "px", left: calcPosition.left + "px", position: "absolute", right: "auto", bottom: "auto" });
                position.stem = $.extend(true, {}, this.positionTooltip);
                if (this.model.showShadow)
                    this._shadowEffect(this.model.showShadow, position);
                if (this.model.isBalloon)
                    this._adjustArrow(position);
                this._showTooltip();
                if (this.model.associate == ej.Tooltip.Associate.MouseEnter)
                    this.isTrack = false;
                if (this.model.associate == ej.Tooltip.Associate.MouseFollow) {
                    if (this.triggerEvents("tracking", { position: this.model.position, event: event }))
                        return;
                }
            }
        }
    };
    ejTooltip.prototype._axisPosition = function () {
        var position = $.extend(true, {}, this.model.position);
        if (typeof this.model.position.target.horizontal == 'number')
            var leftValue = (this.model.position.target.horizontal).toString();
        if (typeof this.model.position.target.vertical == 'number')
            var topValue = (this.model.position.target.vertical).toString();
        var offsetLeft = parseInt(leftValue), offsetTop = parseInt(topValue);
        if (!ej.isNullOrUndefined(this.tip))
            $(this.tip).css({ "display": "none" });
        if (this.model.showShadow)
            this._shadowEffect(this.model.showShadow, position);
        if (this.model.isBalloon)
            this._adjustArrow(position);
        if (isFinite(offsetLeft) && isFinite(offsetTop))
            $(this.tooltip).css({ top: offsetTop, left: offsetLeft, position: "absolute" });
    };
    ejTooltip.prototype._tooltipPosition = function (position) {
        var tipSize = 0, tipGap = 0, tipAdjustment = 0, positionTooltip = $.extend(true, {}, position.stem), positionTarget = $.extend(true, {}, position.target);
        var calcPosition = $.extend(true, {}, this.targetPos);
        var tipY = (positionTooltip.vertical === "top" || positionTooltip.vertical === "bottom") ? (5 + (this.tipSize.width / 2)) : 0, tipX = (positionTooltip.horizontal === "right" || positionTooltip.horizontal === "left") ? (10 + (this.tipSize.width / 2)) : 0, tipSize = (this.model.isBalloon) ? (positionTooltip.horizontal !== "center") ? this.model.tip.size.height : (positionTooltip.vertical !== "center") ? this.model.tip.size.height : 0 : 0;
        var tipGapX = (this.model.tip.adjust.xValue != 0) ? this.model.tip.adjust.xValue : (this.model.isBalloon) ? 0 : 2, tipGapY = (this.model.tip.adjust.yValue != 0) ? this.model.tip.adjust.yValue : (this.model.isBalloon) ? 0 : 2;
        calcPosition.left += (positionTarget.horizontal === "right") ? this.targetPos.width : (positionTarget.horizontal === "left") ? 0 : (this.targetPos.width / 2);
        calcPosition.top += (positionTarget.vertical === "bottom") ? this.targetPos.height : (positionTarget.vertical === "top") ? 0 : (this.targetPos.height / 2);
        calcPosition.left += (positionTooltip.horizontal === "right") ? -this.tooltipPos.width : (positionTooltip.horizontal === "left") ? 0 : -(this.tooltipPos.width / 2);
        calcPosition.top += (positionTooltip.vertical === "bottom") ? -this.tooltipPos.height : (positionTooltip.vertical === "top") ? 0 : -(this.tooltipPos.height / 2);
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipSize : (positionTooltip.horizontal === "left") ? tipSize : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipSize : (positionTooltip.vertical === "top") ? tipSize : 0 : 0;
        calcPosition.left += (positionTarget.horizontal === "center" && positionTooltip.vertical !== "center") ? ((positionTooltip.horizontal === "right") ? tipX : (positionTooltip.horizontal === "left") ? -tipX : 0) : 0;
        calcPosition.top += (positionTarget.horizontal !== "center" && positionTooltip.horizontal !== "center") ? ((positionTooltip.vertical === "top") ? -tipY : (positionTooltip.vertical === "bottom") ? tipY : 0) : 0;
        calcPosition.left += (positionTarget.horizontal !== "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : (positionTooltip.vertical === "center") ? (positionTooltip.horizontal === "right") ? -tipGapX : (positionTooltip.horizontal === "left") ? tipGapX : 0 : 0;
        calcPosition.top += (positionTarget.horizontal === "center") ? ((positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0) : (positionTooltip.horizontal === "center") ? (positionTooltip.vertical === "bottom") ? -tipGapY : (positionTooltip.vertical === "top") ? tipGapY : 0 : 0;
        this.tooltipPos.left = calcPosition.left;
        this.tooltipPos.top = calcPosition.top;
        if (this.model.collision === ej.Tooltip.Collision.None) {
            if (this.model.isBalloon)
                this._adjustArrow(position);
            this._shadowEffect(this.model.showShadow, position);
            $(this.tooltip).css({ "top": calcPosition.top + "px", "left": calcPosition.left + "px", position: "absolute" });
        }
    };
    ejTooltip.prototype._calcCollision = function (position, target) {
        var position = $.extend(true, {}, position), newPosition = $.extend(true, {}, position), arrowSize = this.model.tip.size.height, isCollision = true;
        var targetLeft = (this.model.containment != "body") ? ($(target).offset().left - $(this.model.containment).offset().left) : $(target).offset().left, targetTop = (this.model.containment != "body") ? ($(target).offset().top - $(this.model.containment).offset().top) : $(target).offset().top;
        var availSpace = {
            topSpace: targetTop,
            rightSpace: this.containerSize.width - (targetLeft + this.targetPos.width),
            bottomSpace: this.containerSize.height - (targetTop + this.targetPos.height),
            leftSpace: targetLeft,
            centerRight: this.containerSize.width - (targetLeft + (this.targetPos.width / 2)),
            centerLeft: (targetLeft + (this.targetPos.width / 2)),
            centerTop: targetTop + (this.targetPos.height / 2),
            centerBottom: this.containerSize.height - (targetTop + (this.targetPos.height / 2)),
            tooltipWidth: this.tooltipPos.width + arrowSize,
            tooltipHeight: this.tooltipPos.height + arrowSize
        };
        if (this.model.collision === ej.Tooltip.Collision.Fit)
            this._collisionFit(position, availSpace);
        else {
            while (isCollision) {
                newPosition = this._collisionFlip(newPosition, availSpace);
                if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical || newPosition.stem.horizontal != position.stem.horizontal || newPosition.stem.vertical != position.stem.vertical) {
                    this._tooltipPosition(newPosition);
                    position = $.extend(true, {}, newPosition);
                }
                else
                    isCollision = false;
            }
            if (!isCollision) {
                if (this.model.collision == ej.Tooltip.Collision.FlipFit)
                    this._collisionFit(newPosition, availSpace);
                else {
                    this._adjustArrow(newPosition);
                    this._shadowEffect(this.model.showShadow, newPosition);
                    $(this.tooltip).css({ "top": this.tooltipPos.top + "px", "left": this.tooltipPos.left + "px", position: "absolute" });
                }
            }
        }
    };
    ejTooltip.prototype._collisionFlip = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), newPosition = $.extend(true, {}, position);
        var scrollLeft = $(this.model.containment).scrollLeft(), scrollTop = $(this.model.containment).scrollTop();
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if ((tooltipPos.left + tooltipPos.width) > (containerLeft + this.containerSize.width + scrollLeft) || (tooltipPos.left < containerLeft)) {
            if (position.target.horizontal != "center")
                newPosition.target.horizontal = (availSpace.leftSpace >= availSpace.tooltipWidth) ? "left" : (availSpace.rightSpace >= availSpace.tooltipWidth) ? "right" : "center";
            else
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
        }
        if (tooltipPos.top < containerTop)
            newPosition.target.vertical = (availSpace.bottomSpace >= availSpace.tooltipHeight) ? "bottom" : "center";
        if ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))
            newPosition.target.vertical = (availSpace.topSpace >= availSpace.tooltipHeight) ? "top" : "center";
        if (newPosition.target.horizontal != position.target.horizontal || newPosition.target.vertical != position.target.vertical) {
            if (newPosition.target.horizontal == "center")
                newPosition.stem.horizontal = (availSpace.centerLeft >= availSpace.tooltipWidth) ? "right" : (availSpace.centerRight >= availSpace.tooltipWidth) ? "left" : "center";
            else
                newPosition.stem.horizontal = (newPosition.target.horizontal == "right") ? "left" : "right";
        }
        if (newPosition.target.vertical != position.target.vertical || newPosition.target.horizontal != position.target.horizontal) {
            if (newPosition.target.vertical == "center")
                newPosition.stem.vertical = (availSpace.centerTop >= availSpace.tooltipHeight) ? "bottom" : (availSpace.centerBottom >= availSpace.tooltipHeight) ? "top" : (availSpace.centerTop > availSpace.centerBottom) ? "bottom" : "top";
            else
                newPosition.stem.vertical = (newPosition.target.vertical == "top") ? "bottom" : "top";
        }
        return newPosition;
    };
    ejTooltip.prototype._collisionFit = function (position, availSpace) {
        var tooltipPos = $.extend(true, {}, this.tooltipPos), isHorizontalCollision = false, isVerticalCollision = false;
        var leftValue = 1, topValue = 1, arrowValue = null;
        var scrollLeft = $(this.model.containment).scrollLeft();
        var scrollTop;
        if (this.model.containment == "body") {
            scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        }
        else {
            scrollTop = $(this.model.containment).scrollTop();
        }
        var containerLeft = this.containerSize.left, containerTop = this.containerSize.top;
        if (tooltipPos.left < containerLeft || ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft))) {
            leftValue = (tooltipPos.left < containerLeft) ? containerLeft : ((tooltipPos.left + tooltipPos.width) > (this.containerSize.width + scrollLeft + containerLeft)) ? (tooltipPos.left - ((tooltipPos.left + tooltipPos.width) - (this.containerSize.width + containerLeft))) : 1;
            isHorizontalCollision = true;
        }
        if (tooltipPos.top < containerTop || ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop))) {
            topValue = (tooltipPos.top < containerTop) ? containerTop : ((tooltipPos.top + tooltipPos.height) > (this.containerSize.height + scrollTop + containerTop)) ? (tooltipPos.top - ((tooltipPos.top + tooltipPos.height) - (this.containerSize.height + containerTop))) : 1;
            isVerticalCollision = true;
        }
        $(this.tooltip).css({
            top: (topValue != 1) ? topValue + "px" : tooltipPos.top + "px",
            left: (leftValue != 1) ? leftValue + "px" : tooltipPos.left + "px",
            position: "absolute"
        });
        this._adjustArrow(position);
        arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: $(this.tip).css("display") };
        this.tooltipPos.top = topValue = (topValue != 1) ? topValue : tooltipPos.top;
        this.tooltipPos.left = leftValue = (leftValue != 1) ? leftValue : tooltipPos.left;
        var tooltipWidth = $(this.tooltip).width(), tooltipHeight = $(this.tooltip).height();
        if (isHorizontalCollision || isVerticalCollision && (arrowValue.display != "none")) {
            if (this.model.isBalloon) {
                if (isHorizontalCollision)
                    this.arrowValue.left = this._horizontalAdjustment(position, availSpace);
                if (isVerticalCollision)
                    this.arrowValue.top = this._verticalAdjustment(position, availSpace);
            }
            if (this.arrowValue.left == -this.model.tip.size.height || this.arrowValue.left == tooltipWidth) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else if (this.arrowValue.top == -this.model.tip.size.height || this.arrowValue.top == tooltipHeight) {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "block" });
            }
            else {
                $(this.tip).css({ left: this.arrowValue.left + "px", top: this.arrowValue.top + "px", display: "none" });
            }
        }
        this._shadowEffect(this.model.showShadow, position);
    };
    ejTooltip.prototype._horizontalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowLeft = (position.target.horizontal != "center" && position.stem.horizontal == "left") ? $(this.tip).offset().left : (position.target.horizontal != "center" && position.stem.horizontal == "right") ? $(this.tip).offset().left + arrowSize : $(this.tip).offset().left;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowLeft > availSpace.leftSpace) && ((arrowLeft + arrowSize) < (availSpace.leftSpace + this.targetPos.width)))
            return arrowValue.left;
        else {
            if ((arrowLeft > (availSpace.leftSpace + this.targetPos.width)) || (arrowLeft < availSpace.leftSpace))
                arrowValue.left = (availSpace.leftSpace + this.targetPos.width / 2) - parseInt(this.tooltipPos.left.toString());
            return arrowValue.left;
        }
    };
    ejTooltip.prototype._verticalAdjustment = function (position, availSpace) {
        var arrowValue = { left: this.arrowValue.left, top: this.arrowValue.top, height: this.model.tip.size.height, width: this.model.tip.size.width, display: this.arrowValue.display };
        $(this.tooltip).css({ "display": "block" });
        var arrowSize = (position.target.horizontal != "center") ? this.model.tip.size.height : this.model.tip.size.height;
        var arrowTop = (position.target.horizontal == "center" && position.stem.vertical == "top") ? $(this.tip).offset().top : $(this.tip).offset().top + arrowSize;
        $(this.tooltip).css({ "display": "none" });
        if ((arrowTop > availSpace.topSpace) && (arrowTop < (availSpace.topSpace + this.targetPos.height)))
            return arrowValue.top;
        else {
            if ((arrowTop < availSpace.topSpace) || ((arrowTop + arrowSize) > (availSpace.topSpace + this.targetPos.height)))
                arrowValue.top = (availSpace.topSpace + this.targetPos.height / 2) - parseInt(this.tooltipPos.top.toString());
            return arrowValue.top;
        }
    };
    ejTooltip.prototype._createHeader = function () {
        if (this.model.title != null) {
            if (ej.isNullOrUndefined(this.tooltipTitle))
                this._createTitle();
            if (ej.isNullOrUndefined(this.tooltipContent))
                $(this.tooltipHeader).appendTo(this.tooltipInter).addClass("e-tooltipHeader");
            else
                $(this.tooltipHeader).insertBefore(this.tooltipContent).addClass("e-tooltipHeader");
        }
        if (this.model.closeMode == ej.Tooltip.CloseMode.Sticky)
            this._iconRender();
    };
    ejTooltip.prototype._hideTooltip = function () {
        var speed;
        this._isHidden = true;
        speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
        if (this.model.enabled == true && $(this.tooltip).css("display") == 'block') {
            if (this.triggerEvents("beforeClose", {}))
                return;
            (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeOut(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideUp(speed) : $(this.tooltip).css({ display: "none" });
            if ($(this.tooltip).css("display") == 'none')
                $(this.tooltip).attr('aria-hidden', 'true').removeClass("e-customAnimation");
            if (this.triggerEvents("close", {}))
                return;
        }
    };
    ejTooltip.prototype._showTooltip = function () {
        if (this._isHidden) {
            var speed = (this.model.animation.speed != 0) ? this.model.animation.speed : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? 200 : (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? 800 : 0;
            this._isHidden = false;
            if ($(this.tooltip).css("display") == 'none' && this.model.enabled == true) {
                (this.model.animation.effect == ej.Tooltip.Effect.Fade) ? $(this.tooltip).fadeIn(speed) : (this.model.animation.effect == ej.Tooltip.Effect.Slide) ? $(this.tooltip).slideDown(speed) : $(this.tooltip).css({ display: "block" });
                if ($(this.tooltip).css("display") == 'block') {
                    $(this.tooltip).attr('aria-hidden', 'false').css({ zIndex: ej.getMaxZindex() + 1 });
                    if (this.model.animation.effect == ej.Tooltip.Effect.None)
                        $(this.tooltip).addClass("e-customAnimation");
                    var elements = this._getScrollableParents();
                    this._on(elements, "scroll", this._hideTooltip);
                }
                if (this.triggerEvents("open", {}))
                    return;
            }
        }
    };
    ejTooltip.prototype._getScrollableParents = function () {
        return $(this.element).parentsUntil("html").filter(function () {
            return $(this).css("overflow") != "visible";
        }).add($(window));
    };
    ejTooltip.prototype._tooltipAuto = function () {
        var proxy = this;
        this.timer = setTimeout(function () {
            proxy._hideTooltip();
        }, proxy.model.autoCloseTimeout);
    };
    ejTooltip.prototype._beforeOpenTooltip = function (event) {
        this.positionTooltip = $.extend(true, {}, this.model.position.stem);
        this.positionTarget = $.extend(true, {}, this.model.position.target);
        this.targetElement = this.element;
        if (!ej.isNullOrUndefined(this.model.target)) {
            if (!ej.isNullOrUndefined($(event.currentTarget).attr('data-content'))) {
                this.model.content = $(event.currentTarget).attr('data-content');
                this._setContent(this.model.content);
            }
        }
    };
    ejTooltip.prototype._targetHover = function (event) {
        this.isTrack = true;
        if (this.model.enabled) {
            if (this._isHidden || ((ej.browserInfo().name == 'msie' || ej.browserInfo().name == 'edge') && this.model.associate == ej.Tooltip.Associate.MouseFollow)) {
                this.tooltip.stop(true, true);
                if (this.triggerEvents("beforeOpen", { event: event })) {
                    this._isCancel = true;
                    return;
                }
                this._isCancel = false;
                this._beforeOpenTooltip(event);
                if (this.model.associate != ej.Tooltip.Associate.MouseEnter && this.model.associate != ej.Tooltip.Associate.MouseFollow) {
                    (!ej.isNullOrUndefined(this.model.target)) ? this._positionElement(event.currentTarget) : this._positionElement(this.element);
                    clearTimeout(this.timer);
                    this._showTooltip();
                    if (this.model.closeMode == ej.Tooltip.CloseMode.Auto)
                        this._tooltipAuto();
                    (event.type == "click") ? this.triggerEvents("click", { event: event }) : this.triggerEvents("hover", { event: event });
                }
                else
                    this.isTrack = true;
            }
            else if (!ej.isNullOrUndefined(this.model.target))
                this._positionElement(event.currentTarget);
        }
    };
    ejTooltip.prototype._onMouseOut = function (event) {
        if (this.model.enabled && !this._isHidden) {
            if (this.model.closeMode == ej.Tooltip.CloseMode.None)
                this._hideTooltip();
            clearTimeout(this.mouseTimer);
        }
        this.isTrack = false;
    };
    ejTooltip.prototype._onTooltipMouseEnter = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None)
                $(proxy.tooltip).css({ display: "block" });
        }
    };
    ejTooltip.prototype._onTooltipMouseLeave = function (event) {
        var proxy = this;
        if (this.model.enabled) {
            if (this.model.animation.effect == ej.Tooltip.Effect.None) {
                if (proxy.model.closeMode == ej.Tooltip.CloseMode.None)
                    $(proxy.tooltip).css({ display: "none" });
            }
        }
    };
    ejTooltip.prototype._docTouchEndHandler = function (e) {
        if (!$(e.target).closest('.e-tooltip').length && this.model.closeMode == ej.Tooltip.CloseMode.None)
            this._hideTooltip();
    };
    ejTooltip.prototype._keyDown = function (event) {
        var code = (event.keyCode) ? event.keyCode : (event.which) ? event.which : event.charCode;
        if (this.model.enabled) {
            switch (code) {
                case 27:
                    event.preventDefault();
                    this._hideTooltip();
                    break;
            }
        }
    };
    return ejTooltip;
}(ej.WidgetBase));
window.ej.widget("ejTooltip", "ej.Tooltip", new ejTooltip());
window["ejTooltip"] = null;
ej.Tooltip.CloseMode = {
    Auto: "auto",
    None: "none",
    Sticky: "sticky"
};
ej.Tooltip.Effect = {
    Slide: "slide",
    Fade: "fade",
    None: "none"
};
ej.Tooltip.Trigger = {
    Hover: "hover",
    Click: "click",
    Focus: "focus"
};
ej.Tooltip.Collision = {
    Flip: "flip",
    FlipFit: "flipfit",
    None: "none",
    Fit: "fit"
};
ej.Tooltip.Associate = {
    Window: "window",
    MouseFollow: "mousefollow",
    MouseEnter: "mouseenter",
    Target: "target",
    Axis: "axis"
};
;
/**
* @fileOverview Plugin to style the Html input elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejMaskEdit", "ej.MaskEdit", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },

        defaults: {

            maskFormat: "",

            value: null,

            watermarkText: "",

            name : null,

            height: "",

            width: "",

            showError: false,

            htmlAttributes: {},

            cssClass: "",

            customCharacter: null,

            inputMode: "text",

            readOnly: false,

            textAlign: ej.TextAlign.Left,

            hidePromptOnLeave: false,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            locale:"en-US",

            showPromptChar: true,

            validationRules: null,

            validationMessage: null,

            keydown: null,

            keyup: null,

            keyPress: null,

            change: null,

            mouseover: null,

            mouseout: null,

            focusIn: null,

            focusOut: null,

            create: null,

            destroy: null

        },

        dataTypes: {
            maskFormat: "string",
            showError: "boolean",
            enabled: "boolean",
            customCharacter: "string",
            cssClass: "string",
            watermarkText: "string",
            showRoundedCorner: "boolean",
            showPromptChar: "boolean",
            inputMode: "enum",
            textAlign: "enum",
            hidePromptOnLeave: "boolean",
            readOnly: "boolean",
            validationRules: "data",
            validationMessage: "data",
            htmlAttributes: "data"
        },

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "value":
                        if (ej.isPlainObject(jsondata[key])) jsondata[key] = null;
                        this._setValue(jsondata[key]);
                        this._initObjects();
                        jsondata[key] = this.get_UnstrippedValue(); this._raiseEvents("change", true); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "watermarkText": this.model.watermarkText = jsondata[key]; this._changeWatermark(jsondata[key]); break;
                    case "showRoundedCorner": this._roundedCorner(jsondata[key]); break;
                    case "showPromptChar": this._setShowPrompt(jsondata[key]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this._hiddenInput.rules('remove');
                            this.model.validationMessage = null;
                        }
                        this.model.validationRules = jsondata[key];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessage = jsondata[key];
                        if (this.model.validationRules != null && this.model.validationMessage != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "textAlign": this._setTextAlign(jsondata[key]); break;
                    case "inputMode": this._setInputMode(jsondata[key]); break;
                    case "maskFormat":
                        this.model.maskFormat = jsondata[key];
                        this._valueMapper();
                        this._maskModel = this.model.maskFormat;
                        this._setMask(jsondata[key]);
                        this._initObjects();
                        jsondata[key] = this.model.maskFormat;
                        break;
                    case "locale":
                         this.model.value = this.get_StrippedValue();
                         this.model.locale = jsondata[key];
                         this._setValue(this.model.value);
                         this._initObjects();                        
                         break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "readOnly": this._setReadOnly(jsondata[key]); break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "hidePromptOnLeave": this.model.hidePromptOnLeave = jsondata[key];
                        if (this._textbox.value != "") {
                            if(this.model.hidePromptOnLeave) {
                                this._unStrippedMask = this._textbox.value;
                                this._textbox.value = this.get_UnstrippedValue();
                            }
                            else this._textbox.value = this._textbox.value.replace(/[ ]/g, '_');
                            this.model.value = this._textbox.value;
                        }
                }
            }
        },
        observables: ["value"],


        _destroy: function () {
            if (!ej.isNullOrUndefined(this._hiddenInput)) this.element.attr("name", this._hiddenInput.attr("name"));
            if (this._isWatermark) this.element.removeAttr("placeholder");
            this.element.insertAfter(this.wrapper);
            if (!ej.isNullOrUndefined(this.wrapper)) this.wrapper.remove();
            if (this.model.textAlign) this.element.css("text-align", "");
            this.element.val("").removeClass(' e-mask e-input e-disable').empty();
            this.element.removeAttr('aria-invalid aria-disabled');
        },


        _init: function (options) {
            this._options = options;
            this._tempMask = this.model.maskFormat;
            if (this.element.is("input") && (this.element.is("input[type=text]") || this.element.is("input[type=password]") || !this.element.attr('type'))) {
                this._isWatermark = 'placeholder' in document.createElement('input');
                this._setValues();
                this._valueMapper();
                this._renderControl();
                this._initObjects();
                this._wireEvents();
				this._addAttr(this.model.htmlAttributes);
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
            } else {
                this._destroy();
                return false;
            }
            if (options && options.value != undefined && this.model.value !== options.value)
                this._trigger("_change", { value: this.get_UnstrippedValue(), unmaskedValue: this.get_StrippedValue()});            
        },

        _initValidator: function () {
			(!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
				else if(keyName == "name") proxy._hiddenInput.attr(key,value);
                else if (keyName == "disabled" && value == "disabled") proxy.disable();
                else if (keyName == "readonly" && value == "readOnly") proxy._setReadOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], key)) proxy.element.attr(key, value);
                else proxy.wrapper.attr(key, value);
            });
        },
        _setValidation: function () {
            this._hiddenInput.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this._hiddenInput.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessage)
                            ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },

        _setShowPrompt:function(value){
            this.model.showPromptChar = value;
            this._textbox.value = this.model.showPromptChar ? this._unStrippedMask : this.get_UnstrippedValue();
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _setValues: function () {
            this._unStrippedMask = null;
            //Predefined character definitions
            this._charMap = {
                '9': "[0-9 ]",
                'a': "[A-Za-z0-9 ]",
                'A': "[A-Za-z0-9]",
                'N': "[0-9]",
                '#': "[0-9]",
                '&': '[^\x7f]+',
                '<': "",
                '>': "",
                'C': this.model.customCharacter != null ? "[" + this.model.customCharacter + "]" : "[A-Za-z ]",
                '?': "[A-Za-z]",
            };
        },

        _renderControl: function () {
            this.model.name = this.element.attr("name") != null ? this.element.attr("name") : (this.model.name != null ? this.model.name : this.element[0].id);
            if (this.element.attr("name") != null)
                this.element.removeAttr('name');
            this.wrapper = ej.buildTag("span.e-mask e-widget " + this.model.cssClass);
            this.innerWrapper = ej.buildTag("span.e-in-wrap e-box");
            this.wrapper.append(this.innerWrapper).insertBefore(this.element);
            this.innerWrapper.append(this.element);
            this._hiddenInput = ej.buildTag("input#" + this._id + "_hidden", "", {}, { type: "hidden" }).insertBefore(this.element);
            if (!this._isWatermark && this.model.inputMode != "password") {
                this._hiddenSpan = ej.buildTag("span.e-input e-placeholder ").insertAfter(this.element);
                this._hiddenSpan.text(this.model.watermarkText);
                this._hiddenSpan.css("display", "none");
                this._hiddenSpan.bind("mousedown", $.proxy(this._OnFocusHandler, this));
            }
            if(ej.isNullOrUndefined(this.model.value) && this.element[0].value != "") this.model.value =  this.element[0].value;
            if (!ej.isNullOrUndefined(this.model.value)) {
                this.wrapper.addClass('e-valid');
                if (typeof this.model.value == "number")
                    this.model.value = this.model.value.toString();
            }
            this._hiddenInput.attr({ "name": this.model.name, "value": this.model.value });
            this.element.attr({ 'aria-invalid': false }).addClass('e-input')
            if (this.model.maskFormat == "" && this.model.value == null) {
                var proxy = this;
                setTimeout(function () {
                    if (proxy.element.val() != "") {
                        proxy.option('value', proxy.element.val());
                        proxy.previousValue = proxy.model.value;
                        proxy._initObjects();
                    }
                }, 500)
            }
            else this.element.attr({ 'value': this.model.value });
            if (ej.isNullOrUndefined(this._options.inputMode) && !ej.isNullOrUndefined(this.element.attr("type")))
                this.model.inputMode = this.element.attr("type");
            else
                this._setInputMode(this.model.inputMode);
            this._setWidth(this.model.width);
            this._setHeight(this.model.height);
            this._roundedCorner(this.model.showRoundedCorner);
            this._setTextAlign(this.model.textAlign);
            this._setReadOnly(this.model.readOnly);
            this._controlStatus(this.model.enabled);
            this.previousValue = this.model.value;
        },

        _initObjects: function () {
            this._textbox = this.element[0];
            this._keypressFlag = 0;
            this._selectedTextKeyDown = 0;
            // KeyDown trace [ 0 - None, 1 - BackSpace, 2 - Delete]
            this._keydownFlag = 0;
            // Length of the Mask
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskLength = this.model.maskFormat.length;
            else {
                var _position = 0;
                for (var temp = 0; temp < this.model.maskFormat.length; temp++) {
                    if ((this.model.maskFormat[temp] == "\\"))
                        _position += 1;
                }
                this._maskLength = this.model.maskFormat.length - _position;
            }
            //Replacing all [9?$CANa*] to '_'           
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat;

            this._changeMask(this.model.locale);
            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
                this._valueMapper();
            }

            this._validatedValue = this._maskModel;
            if (this.model.inputMode != "password") {
                this._setValue(this.model.value);
                this._setWaterMark();
            }
            if (this.model.showError) {
                this.element.addClass("e-error").attr('aria-invalid', "true");
            }
        },


        _setWidth: function (value) {
            this.wrapper.width(value);
        },

        _setHeight: function (value) {
            this.wrapper.height(value);
        },

        _roundedCorner: function (value) {
            if (value && !this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.addClass('e-corner');
            }
            else if (this.innerWrapper.hasClass('e-corner')) {
                this.innerWrapper.removeClass('e-corner');
            }
        },

        _setTextAlign: function (align) {
            if (align == "right") {
                this.element.css("text-align","");
                this.wrapper.addClass('e-rtl');
            }
            else {
                this.wrapper.removeClass('e-rtl');
                this.element.css("text-align",align);
            }
        },

        _setInputMode: function (type) {
            this.element.attr('type', type);
        },

        _setReadOnly: function (bool) {
            this.model.readOnly = bool;
            if (bool) this.element.attr("readonly", true);
            else this.element.removeAttr("readonly");
        },

        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass);
            this.wrapper.addClass(skin);
        },

        _setWaterMark: function () {
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (!(this.model.maskFormat.indexOf("\\") >= 0))
                this._maskModel = $.trim(this.model.maskFormat.replace(/[9?CANa#&]/g, '_')) === "" ? null : this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
            else
                this._maskModel = this.model.maskFormat === "" ? null : this.model.maskFormat;
            if ((this._maskModel != ''&&this._maskModel !=null&& this._textbox.value == formatValue) || (formatValue == '' && this._textbox.value == "") && this.model.inputMode != "password") this._textbox.value = "";
            if(this.model.watermarkText.length==0 && !ej.isNullOrUndefined(this.element.attr("placeholder"))) this.model.watermarkText = this.element.attr("placeholder");
            if (this.model.watermarkText) {
                if (this._isWatermark)
                    this.element.attr("placeholder", this.model.watermarkText);
                else {
                    if (this._textbox.value) this._hiddenSpan.css("display", "none").text(this.model.watermarkText);
                    else this._hiddenSpan.css("display", "block").text(this.model.watermarkText);
                }
            }
            if (!this.model.watermarkText && !this._textbox.value && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
            else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _changeWatermark: function (text) {
            if (!this.model.enabled) return false;
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if ((this._textbox.value == formatValue || this._textbox.value == '' || $.trim(this.get_StrippedValue()) == "") && this.model.inputMode != "password") this._textbox.value = "";
            (this._isWatermark ? this.element.attr("placeholder", text) : this._hiddenSpan.text(text))
            if (!this.model.watermarkText && $.trim(this.get_StrippedValue()) == "" && this.model.maskFormat) {
                if (!this.model.hidePromptOnLeave) this._textbox.value = formatValue;
                else { this._unStrippedMask = this._maskModel; this._textbox.value = this.get_UnstrippedValue(); }
            }
        },

        _showAlert: function () {
            var ptr = this;
            this.element.addClass("e-error").attr('aria-invalid', "true").animate({ Opacity: 1 }, 700, null, function () {
                $(ptr._textbox).removeClass("e-error").attr('aria-invalid', "false");
            });
        },

        _unMask: function () {
            var tempModel = "";
            var valueIndex = -1, maskIndex = 0, i = 0, chr, prompt = "_", rule;
            var replacestring = this.model.value.toString();
            var tempValue = replacestring.replace(/[\(\)-]/g, "");
            while (maskIndex < this._rules.length) {
                chr = tempValue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    tempModel += chr === prompt ? prompt : "";
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined && chr.match(this._rules[maskIndex].rule)) {
                    var charCode = tempValue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        tempModel += tempValue.charAt(i);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = tempValue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            tempModel += tempValue.charAt(i);
                            maskIndex++;
                            i++;
                        }
                    } else { i++; maskIndex++;}
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            return tempModel;
        },

        _validateValue: function () {
            if (ej.isNullOrUndefined(this.model.value)) return;
            var tempValue = this.model.value;
            var tempModel = this._maskModel;
            var valueIndex = -1, maskIndex = i = 0, chr, prompt = "_", rule;
            var oldvalue = this._unMask();
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            // Check if Mask is Empty display the text
            if (this._maskLength == 0) {
                this._textbox.value = tempValue;
                this._setWaterMark();
                return true;
            }
            else {
                var replacestring = this.model.value.toString();
                if (!((this.model.maskFormat.indexOf("\\") >= 0)) && this.model.customCharacter == null)
                    tempValue = this.model.value = replacestring.replace(/[\(\)-]/g, "");
                else
                    tempValue = this.model.value;
            }

            while (maskIndex < this._rules.length) {
                chr = oldvalue[i];
                rule = this._rules[maskIndex];
                if (chr == undefined) break;
                if (chr === rule || chr === prompt) {
                    chr === prompt ? prompt : "";
                    var strBefore = tempModel.substring(0, maskIndex);
                    var strAfter = tempModel.substring(maskIndex);
                    tempModel = strBefore + chr + strAfter.substr(1, strAfter.length);
                    i += 1;
                    maskIndex += 1;
                }
                else if (this._rules[maskIndex].rule != undefined ) {
                    var charCode = oldvalue.charCodeAt(i);
                    if (this._validateChars(charCode, maskIndex)) {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                        maskIndex++;
                        i++;
                    } else maskIndex++;
                } 
                else if (typeof rule !== "string") {
                    if (chr.match(this._rules[maskIndex].rule)) {
                        var charCode = oldvalue.charCodeAt(i);
                        if (this._validateChars(charCode, maskIndex)) {
                            var strBefore = tempModel.substring(0, maskIndex);
                            var strAfter = tempModel.substring(maskIndex);
                            tempModel = strBefore + oldvalue.charAt(i) + strAfter.substr(1, strAfter.length);
                            maskIndex++;
                            i++;
                        } else maskIndex++;
                    } else {
                        var strBefore = tempModel.substring(0, maskIndex);
                        var strAfter = tempModel.substring(maskIndex);
                        tempModel = strBefore + prompt + strAfter.substr(1, strAfter.length);
                        i++;
                        maskIndex++;
                    }
                } else maskIndex++;
                if (i > tempValue.length) break;
            }
            if (this.model.value) {
                this._textbox.value = tempModel;
                this.model.value = this.get_UnstrippedValue();
                if (!((this.model.maskFormat.indexOf("\\") >= 0) || (this.model.maskFormat.indexOf("&") >= 0))) {
                    if (!this.model.hidePromptOnLeave) this._textbox.value = tempModel;
                    else { this._unStrippedMask = tempModel.replace(/[ ]/g, '_'); this._textbox.value = tempModel; }
                }         
                else {
                    this._textbox.value = "";
                    var _tPos = 0;
                    for (_pos = 0; _pos < this.model.maskFormat.length; _pos++) {
                        if (this.model.maskFormat[_pos] == "\\")
                            _tPos += 1;
                    }
                    var _position = 0;
                    if (this.model.value.length == tempModel.length - _tPos) {
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos] == "\\")
                                _position = _position + 1;
                            else if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempValue[pos - _position];
                            else if (!(this.model.maskFormat[pos] == "\\")) {
                                if (tempValue.length <= pos - _position)
                                    this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                                else
                                    this._textbox.value += tempValue[pos - _position].replace(/[9?CANa#&]/g, '_');
                            }

                        }
                    }
                    else {
                        this._textbox.value = "";
                        for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                            if (this.model.maskFormat[pos - 1] == "\\")
                                this._textbox.value += tempModel[pos];
                            else if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += tempModel[pos].replace(/[9?CANa#&]/g, '_');
                        }
                    }

                }
            }
            else {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];

                        else if (!(this.model.maskFormat[pos] == "\\"))
                            this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');

                    }
                }
            }
            if (this._textbox.value != undefined && this.model.hidePromptOnLeave) {
                this._unStrippedMask = this._textbox.value.replace(/[ ]/g, '_');
                this._textbox.value = this.get_UnstrippedValue();
            }
            if (this._maskModel!=null &&(this._textbox.value.indexOf(">") >= 0 || this._textbox.value.indexOf("<") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');                
            }
            if (!this.model.showPromptChar)
                this._textbox.value = this.get_UnstrippedValue();
            // Update the character to upper and lower case.
            if (this._tempMask != null) {
                for (var i = 0; i < this._textbox.value.length; i++) {
                    var tempkey = this._updateCasing(this._textbox.value[i], i);
                    if (!ej.isNullOrUndefined(tempkey))
                        this._textbox.value = this._textbox.value.substring(0, i) + tempkey + this._textbox.value.substring(i + tempkey.length);
                }
            }
            
            this._setWaterMark();
        },


        _selectionText: function (begin, end) {
            var replaceValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(begin, end):"";
            this._textbox.value = this._textbox.value.substring(0, begin) + replaceValue + this._textbox.value.substring(end);
            if (this._keydownFlag == 1) {
                this._setCaretPosition(begin);
                return begin;
            }
            else if (this._keydownFlag == 2) {
                this._setCaretPosition(end);
                return end;
            }
            return begin;
        },


        _caretPosition: function (textbox) {
            var caretPos = 0;
            // Microsoft supports only IE for using document.selection
            if (document.selection) {
                // Create a Range of selected position
                var selectedRange = document.selection.createRange();
                var selectionLength = selectedRange.text.length;
                // Move selection start to 0 position
                selectedRange.moveStart('character', -textbox.value.length);
                // Get caret position by selection length, becoz now range is from Zero to current focus
                caretPos = selectedRange.text.length - selectionLength;
                if (selectionLength != 0) {
                    caretPos = this._selectionText(caretPos, selectedRange.text.length);
                    this._selectedTextKeyDown = 1;
                }
            }
            // For Firefox
            else if (textbox.selectionStart || textbox.selectionStart == '0') {
                caretPos = textbox.selectionStart;
                if (textbox.selectionStart != textbox.selectionEnd) {
                    if (this._keydownFlag)
                        caretPos = this._selectionText(textbox.selectionStart, textbox.selectionEnd);
                    this._selectedTextKeyDown = 1;
                }
            }
            return (caretPos);
        },


        _setCaretPosition: function (caretPos) {
            var element = this._textbox;
            //For IE
            if (window.navigator.appName == "Microsoft Internet Explorer") {
                if (element.createTextRange) {
                    var range = element.createTextRange();
                    range.move('character', caretPos);
                    range.select();
                }
            }
            else
            /* For FireFox and Chrome */
                if (element.selectionStart || element.selectionStart == '0') {
                    element.focus();
                    element.setSelectionRange(caretPos, caretPos);
                }
                else
                    element.focus();
        },


        _validateChars: function (keyChar, caretPos) {
            var charmap = this._charMap, match = false;
            if (this.model.maskFormat.indexOf("\\") >= 0) {
                _position = this._getCunrrentPos(caretPos);
                var maskChar = this.model.maskFormat.substr(caretPos + _position, 1);
            }
            else
                var maskChar = this.model.maskFormat.substr(caretPos, 1);
            var customChar = this.model.customCharacter;
            var actualkey = String.fromCharCode(keyChar);
            $.each(charmap, function (key, value) {
                if (maskChar == key) {
                    if (customChar != null) {
                        if (key == "C")
                            value = "[" + customChar + "]";
                        else if (key == "A" || key == "N" || key == "#")
                            value = value.replace(("]"), "") + customChar + "]";
                    }
                    if (actualkey.match(new RegExp(value))) match = true;
                    else match = false;
                }
            });
            return match;
        },


        _seekNext: function () {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = currentPos;
            var seekFlag = true;
            //seeking the focus to next valid position on right of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    var _position = 0;
                    for (var temp = 0; temp <= currentPos; temp++) {
                        if ((this.model.maskFormat[temp] == "\\"))
                            _position += 1;
                    }
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (this.model.maskFormat.charAt(currentPos + _position) != "\\" && this.model.maskFormat.charAt(currentPos + _position - 1) != "\\") {
                                if (!this._charMap[this.model.maskFormat.charAt(currentPos + _position)]) {
                                    this._setCaretPosition(currentPos);
                                    currentPos++;
                                }
                            }
                        }
                        else {
                            if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                                this._setCaretPosition(currentPos);
                                currentPos++;
                            }
                        }
                        if (currentPos != tempPos) {
                            tempPos = currentPos;
                            continue;
                        }
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _seekBefore: function (caretPos) {
            var currentPos = this._caretPosition(this._textbox);
            var tempPos = --currentPos;
            var seekFlag = true;
            // Stop Seek when backspace of select more than a char
            if (this._selectedTextKeyDown == 1)
                seekFlag = false;
            //seeking the focus to next valid position on left of MaskEdit TextBox
            while (seekFlag) {
                if (currentPos >= 0 && currentPos < this._maskLength) {
                    if (this.model.maskFormat.charAt(currentPos) != "C") {
                        if (!this._charMap[this.model.maskFormat.charAt(currentPos)]) {
                            this._setCaretPosition(--currentPos);
                        }
                    }
                    if (currentPos != tempPos) {
                        tempPos = currentPos;
                        continue;
                    }
                }
                seekFlag = false;
            }
            return currentPos;
        },


        _writeBuffer: function (key, cursorPos) {
            if (cursorPos <= this._maskLength) {
                var input = this._textbox.value;
                if (this._tempMask != null)
                    var tempkey = this._updateCasing(key, cursorPos);
                key = (tempkey == undefined) ? key : tempkey;
                var strBeforeCursor = input.substring(0, cursorPos);
                var strAfterCursor = input.substring(cursorPos);
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    var _position = 0;
                    for (var temp = 0; temp <= cursorPos; temp++) {
                        if ((this.model.maskFormat[temp].indexOf("\\") >= 0) && (cursorPos != 0))
                            _position += 1;
                    }
                    if (this.model.maskFormat[cursorPos + _position].indexOf("\\") >= 0)
                        this._textbox.value = strBeforeCursor + input[cursorPos] + strAfterCursor.substr(1, strAfterCursor.length);
                    else
                        this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                }
                else
                    this._textbox.value = strBeforeCursor + key + strAfterCursor.substr(1, strAfterCursor.length);
                this._setCaretPosition(cursorPos + 1);
            }
        },

        _updateCasing: function (key, pos) {
            for (var i = 0; i < pos + 1; i++) {
                if (this._tempMask.substr(i, 1) == '<' || this._tempMask.substr(i, 1) == '>')
                    pos++;
            }

            for (var j = pos; j > -1; j--) {
                if (this._tempMask.substr(j, 1) == '<') {
                    return key.toLowerCase();
                }
                else if (this._tempMask.substr(j, 1) == '>') {
                    return key.toUpperCase();
                }
            }
        },


        get_StrippedValue: function () {
            var i, value, mask = this.model.maskFormat, stripVal = null;
            value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value;
            if (mask.length == 0) return value;
            var _position = 0;
            for (var i = 0; i < mask.length; i++) {
                stripVal = $.trim(stripVal);
                if ((this.model.maskFormat.indexOf("\\") >= 0)) {
                    if ((this.model.maskFormat[i] == "\\"))
                        _position += 1;
                    else if (this.model.maskFormat[i - 1] == "\\")
                        stripVal += this._textbox.value[i - _position];
                    else {
                        var char = mask[i], exp = null;

                        if ("9?$a*".indexOf(char) != -1)
                            exp = this._charMap[char];
                        else if (char == "A" || char == "N" || char == "#")
                            exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                        else if (char == "C")
                            exp = "[" + this.model.customCharacter + "]";
                        else if (char == "&")
                            stripVal += value[i - _position];
                        if (exp && value[i - _position] && value[i - _position].match(new RegExp(exp)))
                            stripVal += value[i - _position];
                    }

                }
                else {
                    var char = mask[i], exp = null;

                    if ("9?$a*".indexOf(char) != -1)
                        exp = this._charMap[char];
                    else if (char == "A" || char == "N" || char == "#")
                        exp = this._charMap[char].replace(("]"), "") + this.model.customCharacter + "]";
                    else if (char == "C")
                        exp = "[" + this.model.customCharacter + "]";
                    else if (char == "&")
                        stripVal += value[i - _position];
                    if (exp && value[i] && value[i].match(new RegExp(exp)))
                        stripVal += value[i];
                }
            }
            return stripVal;
        },


        get_UnstrippedValue: function () {
            var value = (this._textbox.value == "" && this.model.inputMode != "password") ? this._maskModel : this._textbox.value, unstripVal = null;
            if (this.model.maskFormat.length == 0) return value;

            if (value != undefined)
                unstripVal = $.trim(value.replace(/[_]/g, " ")) == "" ? null : value.replace(/[_]/g, " ");
            return unstripVal;
        },

        _setValue: function (value) {
            if (ej.isNullOrUndefined(value) || $.trim(value) == "") value = null;
            this.model.value = value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") {
                this._validateValue();
                if (ej.isNullOrUndefined(this.model.value)) { 
                    this._textbox.value = ej.isNullOrUndefined(value) ? "" : value; 
                    this._unStrippedMask = this._maskModel; 
                }
            }
            else { this._textbox.value = ej.isNullOrUndefined(value) ? "" : value;  this._unStrippedMask = this._textbox.value; }
            this._setWaterMark();
        },


        _valueMapper: function () {
            var mapper = [], mapperIdx = 0, mask = this.model.maskFormat || "", maskChars = mask.split(""), i = 0, chr;
            var emptyMask = "", rule, rules = this._charMap, promptChar = "_";

            for (; i < mask.length; i++) {
                chr = maskChars[i];
                rule = rules[chr];
                if (rule) {
                    mapper[mapperIdx] = { rule: rule };
                    emptyMask += promptChar;
                    mapperIdx += 1;
                } else {
                    if (chr === "\\") {
                        idx += 1;
                        chr = maskChars[idx];
                    }
                    chr = chr.split("");
                    for (var j = 0; j < chr.length; j++) {
                        mapper[mapperIdx] = chr[j];
                        emptyMask += chr[j];
                        mapperIdx += 1;
                    }
                }
            }
            this._rules = mapper;
            this._emptyMask = emptyMask;
            this._maskLength = emptyMask.length;
        },
        _changeMask:function(locale){
            if (this._maskModel.length != 0) {
                var preferredlocale = ej.preferredCulture(locale), groupSep, currecySymbol, decimalSep,unmask = "";
                groupSep = preferredlocale.numberFormat[','];
                currecySymbol = preferredlocale.numberFormat.currency.symbol;
                decimalSep = preferredlocale.numberFormat['.'];
                for (var i = 0; i < this._maskModel.length; i++) {
                    if (this._maskModel[i] == ",")
                        unmask += groupSep;
                    else if (this._maskModel[i] == ".")
                        unmask += decimalSep;
                    else if (this._maskModel[i] == "$")
                        unmask += currecySymbol;
                    else
                        unmask += this._maskModel[i];
                }
                this._maskModel = unmask;
            }
        },
        _setMask: function (maskValue) {
            this._maskLength = maskValue.length;
            this.model.maskFormat = maskValue;
            this._tempMask = this.model.maskFormat;
            this._maskModel = maskValue.replace(/[9?CANa]/g, '_');
            if (this._maskModel.indexOf("<") >= 0 || this._maskModel.indexOf(">") >= 0) {
                this._maskModel = this._maskModel.replace(/[<>]/g, '');
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }            
            if (!ej.isNullOrUndefined(this.model.maskFormat) && this.model.maskFormat != "") 
                this._validateValue();
            else if (!this.model.watermarkText && this._textbox.value != this._maskModel) {
                if (!this.model.maskFormat) {
                    unstripVal = this._unStrippedMask.replace(/[_]/g, " ");
                    this._textbox.value = (this.model.customCharacter == null) ? $.trim(unstripVal.replace(/[\(\)-]/g, "")) : $.trim(unstripVal);
                    this._unStrippedMask = this._textbox.value;
                }
                else if (this.model.hidePromptOnLeave) {
                    this._textbox.value = this._maskModel;
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._textbox.value = this._maskModel;
            }
        },

        enable: function () {
            this.element.disabled = false;			
            this.element.removeAttr("disabled").removeClass('e-disable').attr({ "aria-disabled": false });
            if (this.wrapper.find('.e-placeholder').length > 0) this.wrapper.find('.e-placeholder').removeAttr("disabled", "disabled");
			this.wrapper.removeClass('e-disable-wrap');
            this.model.enabled = true;
        },

        disable: function () {
            this.element.disabled = true;
            this.element.attr("disabled", "disabled").addClass('e-disable').attr({ "aria-disabled": true });
            if (this.wrapper.find('.e-placeholder').length > 0) this.wrapper.find('.e-placeholder').attr("disabled", "disabled");
			this.wrapper.addClass('e-disable-wrap');
            this.model.enabled = false;
        },

        clear: function () {
            this._textbox.value = this.model.maskFormat.replace(/[9?aCAN]/g, '_');
            this.model.value = this.get_StrippedValue();
        },

        _wireEvents: function () {
            this._on(this.element, 'focus', this._OnFocusHandler);
            this._on(this.element, 'blur', this._OnBlurHandler);
            this._on(this.element, 'keydown', this._OnKeyDownHandler);
            this._on(this.element, 'keypress', this._OnKeyPressHandler);
            this._on(this.element, 'keyup', this._OnKeyUpHandler);
            this._on(this.element, 'mouseover', this._OnMouseOverHandler);
            this._on(this.element, 'mouseout', this._OnMouseOutHandler);
            this._on(this.element, 'paste', this._OnPasteHandler);
            this._on(this.element, 'cut', this._OnCutHandler);
        },

        _OnCutHandler: function (e) {
            var selectedValue = !ej.isNullOrUndefined(this._maskModel)?this._maskModel.substring(this._textbox.selectionStart, this._textbox.selectionEnd):"";
            var beforeSelection = this._textbox.value.substring(0, this._textbox.selectionStart);
            var afterSelection = this._textbox.value.substring(this._textbox.selectionEnd);
            var cursorPosition = this._textbox.selectionStart;
            var context = this;
            setTimeout(function () {
                context._textbox.value = beforeSelection + selectedValue + afterSelection;
                context._setCaretPosition(cursorPosition);
                context._raiseEvents("change");
            }, 0);
        },


        _OnPasteHandler: function (e) {
            var context = this;
            setTimeout(function () {
                var text = $(context._textbox).val();
                context._setValue(text);
                context._raiseEvents("change");
            }, 0);
            return true;
        },


        _OnFocusHandler: function (e) {
            this.wrapper.addClass("e-focus");
            var formatValue = this.model.showPromptChar ? this._maskModel : (this._maskModel != "" && this._maskModel != null) ? this._maskModel.replace(/[_]/g, " ") : this._maskModel;
            if (this.model.readOnly)
                return;
            this._focusValue = this.model.value;
            if (!this._isWatermark && this.model.inputMode != "password")
                this._hiddenSpan.css("display", "none");
            if (this._textbox.value == "" && this._maskModel != "" && this.model.inputMode != "password")
                if (this.model.maskFormat.indexOf("\\") >= 0) {
                    this._textbox.value = this.model.watermarkText;
                }
                else
                    this._textbox.value = ej.isNullOrUndefined(this._maskModel) ? "" : formatValue;
            if (this._maskModel != null && (this._textbox.value.indexOf("<") >= 0 || this._textbox.value.indexOf(">") >= 0)) {
                this._textbox.value = this._textbox.value.replace(/[<>]/g, '');
                this._maskModel = this._textbox.value;
                this._tempMask = this.model.maskFormat;
                this.model.maskFormat = this.model.maskFormat.replace(/[<>]/g, '');
            }

            if (this._textbox.value != formatValue && this._unStrippedMask != null && this.model.hidePromptOnLeave)
                this._textbox.value = this._unStrippedMask;

            if (!this.model.showPromptChar) this._textbox.value = this.get_UnstrippedValue();

            $.fn.selectRange = function (start, end) {
                return this.each(function () {
                    if (this.setSelectionRange) {
                        this.focus();
                        this.setSelectionRange(start, end);
                    } else if (this.createTextRange) {
                        var range = this.createTextRange();
                        range.collapse(true);
                        range.moveEnd('character', end);
                        range.moveStart('character', start);
                        range.select();
                    }
                });
            };
            if (this.model.maskFormat) {
                $(this.element).selectRange(0, 0);
            }

            this._raiseEvents("focusIn");
        },

        _OnBlurHandler: function (e) {
            this.wrapper.removeClass("e-focus");            
            this.model.value = this.get_StrippedValue();
            var dup = new Array();
            var option = new Array();
            if ((this._textbox.value.indexOf('_') != -1 || this._textbox.value.indexOf(' ') != -1)&& !ej.isNullOrUndefined(this.model.value)) {
                for (var i = 0; i < this.model.maskFormat.length; i++) {
                    if ((this.model.maskFormat[i] == "A") || (this.model.maskFormat[i] == "?")) dup.push(i);
                    else if ((this.model.maskFormat[i] == "9") || (this.model.maskFormat[i] == "a") || (this.model.maskFormat[i] == "C")) {
                        option.push(i);
                    }
                }
                for (var i = 0; i < dup.length; i++) {
                    if (this._textbox.value[dup[i]] === "_") {
                        this._showAlert();
                        this.model.value = this._textbox.value;
                    }
                }
                for (var i = 0; i < option.length; i++) {
                    if ((this.model.value[option[i]] == "_") || (this.model.value[option[i]] == " ")) {
                        this.model.value = this.model.value.substr(0, option[i]) + this.model.value.substr(option[i] + 1, this.model.value.length)
                        for (var j = i; j < option.length; j++) {
                            option[j] = option[j] - 1;
                        }
                    }
                }
            }
            this.model.value = (this.model.value != null) ? this.model.value.replace(/\s+/g, "") : this.model.value;
            if (this._textbox.value != undefined && (this.model.watermarkText == "" || (this.model.watermarkText != "" && this.model.value != ""))) {
                if (this.model.hidePromptOnLeave) {
                    this._unStrippedMask = this._textbox.value;
                    this._textbox.value = this.get_UnstrippedValue();
                }
                else this._unStrippedMask = this._textbox.value;
            }
            if (this.model.inputMode != "password")
                this._setWaterMark();
            this._raiseEvents("change");
            this._raiseEvents("focusOut");
        },


        _OnKeyDownHandler: function (e) {
            if (this.model.readOnly) return;
            this._keypressFlag = 0;
            this._raiseEvents("onKeyDown", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });

            this.element.removeClass("error");

            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var currentPos = this._seekNext();
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var val = ej.browserInfo().name;
            if ((val == "msie") && (this._textbox.value == "")) {
                if (!(this.model.maskFormat.indexOf("\\") >= 0))
                    this._textbox.value = this.model.maskFormat.replace(/[9?CANa#&]/g, '_');
                else {
                    for (var pos = 0; pos < this.model.maskFormat.length; ++pos) {
                        var val;
                        if (this.model.maskFormat[pos - 1] == "\\")
                            this._textbox.value += this.model.maskFormat[pos];
                        else

                            if (!(this.model.maskFormat[pos] == "\\"))
                                this._textbox.value += this.model.maskFormat[pos].replace(/[9?CANa#&]/g, '_');
                    }
                }
                this._setCaretPosition(currentPos);
            }

            if (unicode >= 35 && unicode <= 41) {
                if (window.navigator.appCodeName == "Mozilla" || window.navigator.appCodeName == "opera") {
                    this._keypressFlag = 1;
                }
            }
            if (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39 || e.keyCode == 46 || e.keyCode == 127) || (e.ctrlKey && (e.keyCode == 86 || e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 88))) {
                this._keypressFlag = 1;
                return;
            }
            else if (unicode == 8) {

                if (this.model.inputMode != "password") {
                    this._keydownFlag = 1;
                    // Seek to next valid position
                    var currentPos = this._seekBefore();
                    if (!this._selectedTextKeyDown) {
                        if (currentPos >= 0 && currentPos < this._maskLength)
                            this._writeBuffer(promptChar, currentPos);                       
                        this._setCaretPosition(currentPos);
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown)
                    {                        
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos+1);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
            else if (e.keyCode == 46 || e.keyCode == 127) {
                if (this.model.inputMode != "password") {
                    this._keydownFlag = 2;
                    // Seek to next valid position
                    currentPos = this._seekNext();
                    if (!this._selectedTextKeyDown) {
                    if (currentPos >= 0 && currentPos < this._maskLength) {                        
                        _position=this. _getCunrrentPos(currentPos);
                            if (!((this.model.maskFormat[currentPos + _position] == "&")))
                                this._writeBuffer(promptChar, currentPos);
                        }
                    }
                    else if (!this.model.showPromptChar && this._selectedTextKeyDown) {
                        this._textbox.value = this.get_UnstrippedValue();
                        this._setCaretPosition(currentPos);
                    }
                    this._keydownFlag = 0;
                    this._selectedTextKeyDown = 0;
                    e.preventDefault();
                    return false;
                }
                this._keypressFlag = 1;
                return true;
            }
        },


        _ErrorHandler: function (currentPos) {
            var promptChar = this.model.showPromptChar ? "_" : " ";
            if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
            this._setCaretPosition(currentPos);
            this._showAlert();
        },
        _getCunrrentPos: function (currentPos) {
            var _position = 0;
            for (var temp = 0; temp <= currentPos + _position; temp++) {
                if ((this.model.maskFormat[temp] == "\\"))
                    _position += 1;
            }
            return _position;
        },


        _OnKeyPressHandler: function (e) {
            if (this.model.readOnly) return;
            this._raiseEvents("keyPress", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (this._maskLength == 0)
                return true;

            var unicode = e.keyCode ? e.keyCode : e.charCode;
            var actualkey = String.fromCharCode(unicode);
            var promptChar = this.model.showPromptChar ? "_" : " ";
            var currentPos = this._seekNext();
            var val = ej.browserInfo().name;
            if (this._validateChars(unicode, currentPos)) {
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else {
                    if (this._textbox.value == "") this._textbox.value = this.model.maskFormat.replace(/[9?$CANa*]/g, promptChar);
                    if (this.model.maskFormat.indexOf("\\") >= 0) {
                        if (currentPos < this._maskLength)
                            this._writeBuffer(actualkey, currentPos);
                    }
                    else
                        this._writeBuffer(actualkey, currentPos);
                }
            }
            else
                if (((val == "mozilla") || (val == "opera")) && (e.keyCode == 35 || e.keyCode == 36 || e.keyCode == 37 || e.keyCode == 39)) {
                }
                else if (((val == "mozilla") || (val == "opera")) && (e.ctrlKey && (unicode == 97 || unicode == 99 || unicode == 118 || unicode == 120))) {
                }
                else if (this.model.maskFormat.indexOf("&") >= 0 || this.model.maskFormat.indexOf("\\") >= 0) {
                    _position = this._getCunrrentPos(currentPos);
                    if (!((this.model.maskFormat[currentPos + _position] == "&") && (unicode == 127))) {
                        if (this.model.maskFormat.indexOf("\\") >= 0) {
                            if (currentPos < this._maskLength) {
                                if (this._validateChars(unicode, currentPos + _position) || (this.model.maskFormat[currentPos + _position - 1] == "\\"))
                                    this._writeBuffer(actualkey, currentPos);
                                else
                                    this._ErrorHandler(currentPos);
                            }
                        }
                        else {
                            if (this._validateChars(unicode, currentPos + _position))
                                this._writeBuffer(actualkey, currentPos);
                            else
                                this._ErrorHandler(currentPos);
                        }
                    }
                }
                else
                    this._ErrorHandler(currentPos);

            if (!this._keypressFlag && unicode != 9) {
                this._keypressFlag = 0;
                e.preventDefault();
                return false;
            }
            this._keypressFlag = 0;
        },

        _OnKeyUpHandler: function (e) {
            if (this._maskLength == 0) this._raiseEvents("change");
            this._raiseEvents("keyUp", null, { keyCode: e.keyCode, altKey: e.altKey, shiftKey: e.shiftKey, ctrlKey: e.ctrlKey, originalArgs: e });
            if (!ej.isNullOrUndefined(this.model.validationRules)) this._hiddenInput.valid();
        },


        _OnMouseOverHandler: function (e) {
            this._raiseEvents("mouseOver");
        },


        _OnMouseOutHandler: function (e) {
            this._raiseEvents("mouseOut");
        },


        _raiseEvents: function (eventName, isCode, additionalArgs) {
            var eventArgs, strippedVal = this.get_StrippedValue(), unstrippedVal = this.get_UnstrippedValue();
            this.model.value = unstrippedVal !== null ? (this.model.customCharacter == null && $.trim(unstrippedVal.replace(/[\(\)-]/g, "")) == "") ? null : unstrippedVal : null;
            if (eventName == "change") {
                if (this.previousValue != this.model.value) {
                    this.previousValue = this.model.value;
                }
                else {
                    if (this._focusValue == this.model.value)
                        return false;
                }
            }
            eventArgs = { value: unstrippedVal, unmaskedValue: strippedVal };
            if (eventName == "change") eventArgs["isInteraction"] = !isCode ;
            if (eventName == "change") {
                this._trigger("_change", eventArgs);
                ej.isNullOrUndefined(this.model.value) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            }
            if (additionalArgs) $.extend(true, eventArgs, additionalArgs);
			this._trigger(eventName, eventArgs);
            this._hiddenInput.val(strippedVal);
        },

        _OnValueChange: function () {
            if (this._textbox.value == "" && this._maskModel != "")
                this._textbox.value = this._maskModel;
            this._setValue(this._textbox.value);
        }

    });

    ej.InputMode = {
		/**  support for user enter character in password format. */
		Password: "password", 
		/**  support for user enter character in normal format. */
        Text: "text"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to select the date and time values.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejDateTimePicker", "ej.DateTimePicker", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["value"],
        _setFirst: false,
        _rootCSS: "e-datetimepicker",
        type: "editor",
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions'],
            requireFormatters: true
        },
        _requiresID: true,


        defaults: {

            cssClass: "",

            locale: "en-US",

            readOnly: false,

            showRoundedCorner: false,

            enableRTL: false,

            htmlAttributes: {},
            allowEdit: true,

            enabled: true,

            value: "",

            name: null,

            minDateTime: new Date("1/1/1900 12:00:00 AM"),

            maxDateTime: new Date("12/31/2099 11:59:59 PM"),

            height: "",

            width: "",

            dateTimeFormat: "",

            showPopupButton: true,

            enableStrictMode: false,

            buttonText: {

                today: "Today",

                timeNow: "Time Now",

                done: "Done",

                timeTitle: "Time"
            },

            watermarkText: "Select datetime",

            enablePersistence: false,

            interval: 30,

            timeDisplayFormat: "",

            timePopupWidth: 105,
            popupPosition: "bottom",

            dayHeaderFormat: "short",

            startLevel: "month",

            depthLevel: "",

            startDay: -1,

            stepMonths: 1,

            showOtherMonths: true,

            enableAnimation: true,

            headerFormat: 'MMMM yyyy',

            validationRules: null,

            validationMessage: null,

            validationMessages: null,
            timeDrillDown: {
                enabled: false,
                interval: 5,
                showMeridian: false,
                autoClose: true,
                showFooter: true
            },

            beforeOpen: null,

            beforeClose: null,

            open: null,

            close: null,

            change: null,

            create: null,

            destroy: null,

            focusIn: null,

            focusOut: null

        },


        dataTypes: {
            allowEdit: "boolean",
            cssClass: "string",
            locale: "string",
            readOnly: "boolean",
            showRoundedCorner: "boolean",
            enableRTL: "boolean",
            enabled: "boolean",
            enableAnimation: "boolean",
            dateTimeFormat: "string",
            showPopupButton: "boolean",
            buttonText: "data",
            watermarkText: "string",
            enablePersistence: "boolean",
            enableStrictMode: "boolean",
            interval: "number",
            timeDrillDown: "data",
            timeDisplayFormat: "string",
            dayHeaderFormat: "string",
            startLevel: "string",
            depthLevel: "string",
            startDay: "number",
            stepMonths: "number",
            showOtherMonths: "boolean",
            headerFormat: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },

        _setModel: function (options) {
            if (!this.popup) this._renderDropdown();
            var option, validate = false;
            for (option in options) {
                switch (option) {
                    case "allowEdit": this._changeEditable(options[option]); break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "locale": this._localize(options[option]); break;
                    case "readOnly": this._readOnly(options[option]); break;
                    case "showRoundedCorner": this._setRoundedCorner(options[option]); break;
                    case "enableRTL": this._setRtl(options[option]); break;
                    case "enabled": this._enabled(options[option]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[option];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessages":
                        this.model.validationMessages = options[option];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "value":
                        options[option] = this._setValue(options[option]);
                        if (this._specificFormat())
                            this._stopRefresh = true
                        validate = true;
                        this._prevDateTime = this._prevDateTimeVal || this._preVal;
                        break;
                    case "enableStrictMode":
                        this.model.enableStrictMode = options[option];
                        validate = true;
                        break;
                    case "minDateTime":
                        var temp = this._stringToObject(options[option]);
                        var mintime = this._getFormat(temp, this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("minDate", temp);
                            this.timePicker.option("minTime", mintime);
                            options[option] = temp;
                            this.model.minDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true;
                        break;
                    case "maxDateTime":
                        var temp = this._stringToObject(options[option]);
                        var maxtime = this._getFormat(options[option], this.timePicker.model.timeFormat);
                        if (this._isValidDate(temp)) {
                            this.datePicker.option("maxDate", temp);
                            this.timePicker.option("maxTime", maxtime);
                            options[option] = temp;
                            this.model.maxDateTime = temp;
                        }
                        else options[option] = this.model[option];
                        validate = true; break;
                    case "height": this.wrapper.height(options[option]); break;
                    case "width": this.wrapper.width(options[option]); break;
                    case "dateTimeFormat":
                        this.model.dateTimeFormat = options[option];
                        if (this.isValidState) this._setValue(this.model.value);
                        break;
                    case "showPopupButton": this._showButton(options[option]); break;
                    case "watermarkText":
                        if (ej.isNullOrUndefined(this._options)) this._options = {};
                        this._options[option] = this.model.watermarkText = options[option];
                        this._localizedLabels.watermarkText = this.model.watermarkText;
                        this._setWaterMark();
                        break;
                    case "buttonText":
                        if (!ej.isNullOrUndefined(this._options))
                            this._options["buttonText"] = this.model.buttonText = options[option];
                        this._localizedLabels.buttonText = this.model.buttonText;
                        this._buttonText(options[option]); break;
                    case "interval":
                        this._updateTimeHeight();
                        this.timePicker.option("interval", options[option]); break;
                    case "timeDisplayFormat":
                        this._updateTimeHeight();
                        this.timePicker.option("timeFormat", options[option]); break;
                    case "timePopupWidth":
                        this._updateTimeHeight();
                        this.timePicker.option("popupWidth", options[option]);
                        break;
                    case "dayHeaderFormat": this.datePicker.option("dayHeaderFormat", options[option]); break;
                    case "startLevel": this.datePicker.option("startLevel", options[option]); break;
                    case "depthLevel": this.datePicker.option("depthLevel", options[option]); break;
                    case "startDay": this.datePicker.option("startDay", options[option]);
                        this.model.startDay = this.datePicker.model.startDay;
                        options[option] = this.model.startDay; break;
                    case "stepMonths": this.datePicker.option("stepMonths", options[option]); break;
                    case "showOtherMonths": this.datePicker.option("showOtherMonths", options[option]); break;
                    case "headerFormat": this.datePicker.option("headerFormat", options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "popupPosition": this.model.popupPosition = options[option]; this._setListPosition(); break;
                    case "timeDrillDown":

                        // For timeDrillDown.enabled
                        if (!ej.isNullOrUndefined(options[option].enabled)) {
                            this.model.timeDrillDown.enabled = options[option].enabled; this._changeDesign();
                        }

                        // For timeDrillDown.interval
                        if (!ej.isNullOrUndefined(options[option].interval)) {
                            this.model.timeDrillDown.interval = options[option].interval;
                            this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));
                        }

                        // For timeDrillDown.showMeridian
                        if (!ej.isNullOrUndefined(options[option].showMeridian)) {
                            this.model.timeDrillDown.showMeridian = options[option].showMeridian;
                            this._sfTimeHour.empty(); this._renderHourTable();
                        }

                        // For timeDrillDown.showFooter
                        if (!ej.isNullOrUndefined(options[option].showFooter)) {
                            this.model.timeDrillDown.showFooter = options[option].showFooter;
                            this._changeDesign();
                        }
                        break;

                }
            }
            if (validate) this._validateMinMax();
            this._valueChange(true);
            if (option == "value") options[option] = this.model.value;
            this._updateTimeHeight();
            this._checkErrorClass();
        },
        observables: ["value"],

        _destroy: function () {
            if (this.isPopupOpen)
                this._hideResult();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
            }
            this._cloneElement.removeClass("e-js e-input").removeClass(ej.util.getNameSpace(this.sfType));
            this._cloneElement.insertAfter(this.element);
            this.element.remove();
            if (!ej.isNullOrUndefined(this.datePicker))
                this.datePicker.destroy();
            if (!ej.isNullOrUndefined(this.timePicker))
                this.timePicker.destroy();
			if(this.popup)this.popup.remove();
        },


        _init: function (options) {
            if (!this.element.is("input") || (this.element.attr('type') && this.element.attr('type') != "text")) return false;
            this._options = options;
            this._cloneElement = this.element.clone();
            this._ISORegex();
            this._isSupport = document.createElement("input").placeholder == undefined ? false : true;
            this._validateMeridian();
            this._checkAttribute();
            this._initialize();
            this._initial = true;
            this._interval = 60;
            this._render();
            this._wireEvents();
            this._addAttr(this.model.htmlAttributes);
            if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
                this.model.validationMessages = this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
			this._removeWatermark();
            if (options && options.value != undefined && options.value != this.element.val()) {
                this._trigger("_change", { value: this.element.val() });
            }
        },
        _ISORegex: function () {
            this._tokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,
            // complex case for iso 8601 regex only
            this._extISORegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._basicISORegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?/,
            this._numberRegex = {
                2: /\d\d?/,
                4: /^\d{4}/,
                "z": /Z|[+-]\d\d(?::?\d\d)?/gi,
                "t": /T/,
                "-": /\-/,
                ":": /:/
            };
            this._zeroRegex = /Z|[+-]\d\d(?::?\d\d)?/;
            this._dates = [
                ['YYYYYY-MM-DD', /[+-]\d{6}-\d\d-\d\d/],
                ['YYYY-MM-DD', /\d{4}-\d\d-\d\d/],
                ['GGGG-[W]WW-E', /\d{4}-W\d\d-\d/],
                ['GGGG-[W]WW', /\d{4}-W\d\d/, false],
                ['YYYY-DDD', /\d{4}-\d{3}/],
                ['YYYY-MM', /\d{4}-\d\d/, false],
                ['YYYYYYMMDD', /[+-]\d{10}/],
                ['YYYYMMDD', /\d{8}/],
                // YYYYMM is NOT allowed by the standard
                ['GGGG[W]WWE', /\d{4}W\d{3}/],
                ['GGGG[W]WW', /\d{4}W\d{2}/, false],
                ['YYYYDDD', /\d{7}/]
            ];

            // iso time formats and regexes
            this._times = [
                ['HH:mm:ss.SSSS', /\d\d:\d\d:\d\d\.\d+/],
                ['HH:mm:ss,SSSS', /\d\d:\d\d:\d\d,\d+/],
                ['HH:mm:ss', /\d\d:\d\d:\d\d/],
                ['HH:mm', /\d\d:\d\d/],
                ['HHmmss.SSSS', /\d\d\d\d\d\d\.\d+/],
                ['HHmmss,SSSS', /\d\d\d\d\d\d,\d+/],
                ['HHmmss', /\d\d\d\d\d\d/],
                ['HHmm', /\d\d\d\d/],
                ['HH', /\d\d/]
            ];
        },
        _changeDesign: function () {
            if (this.model.timeDrillDown.enabled) {
                var state = this.model.timeDrillDown.showFooter ? "block" : "none";
                this.popup.addClass("e-drill-down");
                this._timeContainer.css("display", "none");
                this._buttonContainer.css("display", "none");
                this.datePicker.option("showFooter", this.model.timeDrillDown.showFooter);
                $('.e-footer', this._sfTimeHour).css("display", state);
                $('.e-footer', this._sfTimeMins).css("display", state);
            }
            else {
                this.popup.removeClass("e-drill-down");
                this._sfTimeHour.hide();
                this._sfTimeMins.hide();
                this._updateTimeHeight();
                this._dateContainer.show();
                this._timeContainer.show();
                this._buttonContainer.show();
                this.datePicker.option("showFooter", false);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },
        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _checkAttribute: function () {
            this.model.value = this.model.value === "" ? this.element[0].value : this.model.value;
            if (!this._options.minDateTime) this.model.minDateTime = this.element[0].min;
            if (!this._options.maxDateTime) this.model.maxDateTime = this.element[0].max;
            if (ej.isNullOrUndefined(this._options.readOnly)) this.model.readOnly = this.element.is("[readonly]");
            if (ej.isNullOrUndefined(this._options.enabled)) this.model.enabled = !this.element.is("[disabled]");
        },
        _setValidation: function () {
            this.element.rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                var keyName = key.toLowerCase();
                if (keyName == "class") proxy.wrapper.addClass(value);
                else if (keyName == "disabled") proxy._enabled(false);
                else if (keyName == "readOnly") proxy._readOnly(true);
                else if (keyName == "style" || keyName == "id") proxy.wrapper.attr(key, value);
                else if (ej.isValidAttr(proxy.element[0], keyName)) proxy.element.attr(keyName, value);
                else proxy.wrapper.attr(keyName, value);
            });
        },
        _validateMeridian: function () {
            var culture = ej.preferredCulture(this.model.locale);
            if (culture) this.model.locale = culture.name == "en" ? "en-US" : culture.name;
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.timeDrillDown)) {
                    if (ej.isNullOrUndefined(this._options.timeDrillDown.showMeridian))
                        this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
                }
                else this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
            }
            else
                this.model.timeDrillDown.showMeridian = ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard["AM"]) ? false : true;
        },
        _initialize: function () {
            var val;
            this.popup = null;
            this.isPopupOpen = false;
            this.isValidState = true;
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            if (this.model.startDay == -1) this.model.startDay = ej.preferredCulture(this.model.locale).calendar.firstDay;
            this._isIE8 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "8.0") ? true : false;
            this._isIE9 = (ej.browserInfo().name == "msie") && (ej.browserInfo().version == "9.0") ? true : false;
            if (!this.model.dateTimeFormat || !this.model.timeDisplayFormat) this._getDateTimeFormat();
            if (!this.model.value || (typeof JSON === "object" && JSON.stringify(this.model.value) === "{}")) val = null;
            else if (!(this.model.value instanceof Date)) {
                var dateTimeObj = ej.parseDate(this.model.value, this.model.dateTimeFormat, this.model.locale);
                val = dateTimeObj ? dateTimeObj : (dateTimeObj = this._checkJSONString(this.model.value)) ? dateTimeObj : null;
            }
            else val = this.model.value;
            if (val) this.model.value = val;
            var min = this.model.minDateTime = this._stringToObject(this.model.minDateTime);
            if (!min || !this._isValidDate(min)) this.model.minDateTime = this.defaults.minDateTime;
            var max = this.model.maxDateTime = this._stringToObject(this.model.maxDateTime);
            if (!max || !this._isValidDate(max)) this.model.maxDateTime = this.defaults.maxDateTime;
        },
        _checkJSONString: function (dateTimeString) {
            // Validate the string value
            var dateTimeObj = new Date(dateTimeString);
            if (!isNaN(Date.parse(dateTimeObj))) {
                if ((dateTimeObj.toJSON() === this.model.value) || (dateTimeObj.toGMTString() === this.model.value) ||
                    (dateTimeObj.toISOString() === this.model.value) || (dateTimeObj.toLocaleString() === this.model.value) ||
                    (dateTimeObj.toString() === this.model.value) || (dateTimeObj.toUTCString() === this.model.value))
                    return dateTimeObj;
                else if (typeof dateTimeString == "string") return this._dateFromISO(dateTimeString);
            } else if (this._extISORegex.exec(dateTimeString) || this._basicISORegex.exec(dateTimeString)) return this._dateFromISO(dateTimeString);
        },
        _render: function () {
            this._renderWrapper();
            this._renderIcon();
            this._setDimentions();
            this._checkProperties();
        },

        _renderWrapper: function () {
            this.element.addClass("e-input").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', "tabindex": "0", 'role':'combobox','aria-expanded':'false' });
            this.wrapper = ej.buildTag("span.e-datetime-wrap e-widget " + this.model.cssClass + "#" + this.element[0].id + "_wrapper").insertAfter(this.element);
            this._setValue(this.model.value);
            this.wrapper.attr("style", this.element.attr("style"));
            this.element.removeAttr("style");
            if (!ej.isTouchDevice()) this.wrapper.addClass('e-ntouch');
            this.container = ej.buildTag("span.e-in-wrap e-box").append(this.element);
            this.wrapper.append(this.container);
            if (!this._isSupport) {
                this._hiddenInput = ej.buildTag("input.e-input e-placeholder ", "", {}, { type: "text" }).insertAfter(this.element);
                this._hiddenInput.val(this._localizedLabels.watermarkText);
                this._hiddenInput.css("display", "block");
                var proxy = this;
                $(this._hiddenInput).focus(function () {
                    proxy.element.focus();
                });
            }
        },
        _removeWatermark: function () {
            if (this.element.val() != "" && !this._isSupport && this._hiddenInput)
                this._hiddenInput.css("display", "none");
        },
        _renderIcon: function () {
            if (!this.model.showPopupButton) return false;
            this.datetimeIcon = ej.buildTag("span.e-select", "", {}).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var icon = ej.buildTag("span.e-icon e-datetime", "", {}, { "aria-label": "select" }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this.datetimeIcon.append(icon);
            this.container.append(this.datetimeIcon).addClass("e-padding");
            this._on(this.datetimeIcon, "click", this._iconClick);
            this._on(this.datetimeIcon, "mousedown", function (e) { e.preventDefault(); });
        },
        _setDimentions: function () {
            if (!this.model.height) this.model.height = this.element.attr("height"); if (!this.model.width) this.model.width = this.element.attr("width");
            this.wrapper.height(this.model.height);
            this.wrapper.width(this.model.width);
        },

        _renderDropdown: function () {
            var oldWrapper = $("#" + this.element[0].id + "_popup").get(0);
            if (oldWrapper)
                $(oldWrapper).remove();
            this.popup = ej.buildTag("div.e-datetime-popup e-popup e-widget e-box " + this.model.cssClass + "#" + this.element[0].id + "_popup").css("visibility", "hidden");
            if (!ej.isTouchDevice()) this.popup.addClass('e-ntouch');
            $('body').append(this.popup);
            this._renderControls();

            var _timeTitle, _dateContainer, popupContainer, _today, _now, _done;

            _timeTitle = ej.buildTag("div.e-header", this._localizedLabels.buttonText.timeTitle).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._dateContainer = ej.buildTag("div.e-datecontainer").append(this.datePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._timeContainer = ej.buildTag("div.e-timecontainer").append(_timeTitle, this.timePicker.popup).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._drillDownContainer = ej.buildTag("div.e-drillDowncontainer").append().attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            popupContainer = ej.buildTag("div.e-popup-container").append(this._dateContainer, this._timeContainer, this._drillDownContainer).attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            _today = ej.buildTag("div.e-dt-button e-dt-today e-btn e-select e-flat", this._localizedLabels.buttonText.today).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _now = ej.buildTag("div.e-dt-button e-dt-now e-btn e-select e-flat", this._localizedLabels.buttonText.timeNow).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            _done = ej.buildTag("div.e-dt-button e-dt-done e-btn e-select e-flat", this._localizedLabels.buttonText.done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._buttonContainer = ej.buildTag("div.e-button-container").append(_today, _now, _done).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._renderDrillDown();
            this.popup.append(popupContainer, this._buttonContainer);
            this._checkForResponsive();
            this._updateTimeHeight();

            this._bindOperations();
            this._updateValues();
            this.popup.css({ "visibility": "visible", "display": "none" });

            this._on(_today, "click", this._todayClick);
            this._on(_now, "click", this._nowClick);
            this._on(_done, "click", this._doneClick);
            this.popup.on("mouseenter touchstart", $.proxy(function () { this._popClose = true; }, this));
            this.popup.on("mouseleave touchend", $.proxy(function () { this._popClose = false; }, this));
            this._changeDesign();
        },
        _renderControls: function () {
            this._renderDateControl();
            this._renderTimeControl();

            var tempContainer = ej.buildTag("span").append(this.datePicker.wrapper, this.timePicker.wrapper);
            tempContainer.find("span").css("display", "none");
            this.popup.append(tempContainer);
        },
        _renderDrillDown: function () {
            this._renderHourPopup();
            this._renderMinsPopup();
        },
        _renderHourPopup: function () {
            var table;
            this._sfTimeHour = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-hours ', "", {}, { id: (this._id ? 'e-hours-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeHour.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeHour);
            this._renderHourTable();
        },
        _renderHourTable: function () {
            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-headertext").text("October 2015").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeHour);

            // Render meridian calendar popup.
            if (this._interval < 1) return false;
            var start, end, timeVal, rowCount, table, tr, interval = this._interval * 60000;
            var tableCount = this.model.timeDrillDown.showMeridian ? 2 : 1; rowCount = this.model.timeDrillDown.showMeridian ? 6 : 4;
            var timeDisplayFormat = this.model.timeDrillDown.showMeridian ? "hh" : "HH:00";
            var meridianText = ["AM", "PM"], count = 0, meridianClass = "";

            start = this.timePicker._createObject("12:00:00 AM");
            end = this.model.timeDrillDown.showMeridian ? this.timePicker._createObject("11:59:59 AM") : this.timePicker._createObject("11:59:59 PM");

            for (var i = 0; i < tableCount; i++) {
                if (this.model.timeDrillDown.showMeridian) {
                    meridianClass = meridianText[i].toLowerCase();
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    ej.buildTag("div.e-header-" + meridianClass).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                      .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-hours-meridiantxt-" + meridianClass).text(txt)
                      .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                      .appendTo(this._sfTimeHour);
                }

                // Table for Time Value
                table = ej.buildTag("table.e-dp-viewhours", "", {}).data("e-table", "data").attr({ 'role': 'grid' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                this._sfTimeHour.append(table);

                var tbody = ej.buildTag('tbody.e-timepicker-hours').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});

                while (this.timePicker._compareTime(end, start, true)) {
                    timeVal = this._localizeTime(start, timeDisplayFormat);
                    var tdtag = ej.buildTag("td.e-hour e-state-default", timeVal);
                    this.model.timeDrillDown.showMeridian && tdtag.addClass("e-hour-" + meridianClass);
                    if (this._isIE8) tdtag.attr("unselectable", "on");
                    tr.append(tdtag);
                    count++;
                    if (count >= rowCount) {
                        count = 0;
                        tbody.append(tr);
                        tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    }
                    start = this.timePicker._createObject(start).getTime() + interval;
                }

                //tbody.append(tr);
                table.append(tbody);

                if (this.model.timeDrillDown.showMeridian) {
                    start = this.timePicker._createObject("12:00:00 PM");
                    end = this.timePicker._createObject("11:59:59 PM");
                }
            }

            // Rendering the footer template
            ej.buildTag("div.e-footer")
              .append(ej.buildTag("span.e-footer-icon"))
              .append(ej.buildTag("span.e-footer-text"))
              .appendTo(this._sfTimeHour);
            $('.e-footer-text', this._sfTimeHour).html(this._localizedLabels.buttonText.timeNow);
            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));

            // Bind action to the item.
            this._on(this._sfTimeHour.find('.e-hour'), "click", $.proxy(this._hourNavHandler, this));
            this._on($('.e-next', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-prev', this._sfTimeHour), "click", $.proxy(this._prevNextHourHandler, this));
            this._on($('.e-footer', this._sfTimeHour), "click", this._todayBtn);
            $('.e-hours-headertext', this._sfTimeHour).on("click", $.proxy(this._forwardNavHandler, this));

            this._sfTimeHour.hide();
        },
        _localizeTime: function (value, format) {
            return $.trim(ej.format(this.timePicker._createObject(value), format, this.model.locale));
        },
        _renderMinsPopup: function () {
            this._sfTimeMins = ej.buildTag('div.e-timepicker e-popup e-widget ' + this.model.cssClass + ' e-time-minitues ', "", {}, { id: (this._id ? 'e-time-minitues-' + this._id : "") }).attr({ 'aria-hidden': 'true' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})
            if (!ej.isTouchDevice()) this._sfTimeMins.addClass('e-ntouch');
            this._drillDownContainer.append(this._sfTimeMins);

            // Rendering header template
            ej.buildTag("div.e-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                   .append(ej.buildTag("span.e-prev").append(ej.buildTag('a.e-icon e-arrow-sans-left').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-headertext").attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .append(ej.buildTag("span.e-next").append(ej.buildTag('a.e-icon e-arrow-sans-right').attr({ 'role': 'button' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                   .appendTo(this._sfTimeMins);

            // Meridian Header template
            ej.buildTag("div.e-mins-header").attr((this._isIE8) ? { 'unselectable': 'on' } : {})
                          .append(ej.buildTag("span.e-text").append(ej.buildTag("span.e-minitues-meridiantxt").text("AM")
                          .attr({ 'aria-atomic': 'true', 'aria-live': 'assertive', 'role': 'heading' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {})))
                          .appendTo(this._sfTimeMins);

            // Table for Time Value
            var table = ej.buildTag("table.e-dp-viewmins", "", {}).data("e-table", "data").attr({ 'role': 'grid' }).attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            this._sfTimeMins.append(table);

            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});

            // Render Time value
            if (this._intervall < 1) return false;
            var start, end, timeVal, interval = this._interval * 60000;
            start = this.timePicker._createObject("12:00:00 AM");
            end = this.timePicker._createObject("11:59:59 PM");
            var tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var count = 0;
            while (this.timePicker._compareTime(end, start, true)) {
                timeVal = this._localizeTime(start, "HH:00");
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                if (count >= 4) {
                    count = 0;
                    tbody.append(tr);
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                }
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            //tbody.append(tr);
            table.append(tbody);
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());

            // Rendering the footer template
            ej.buildTag("div.e-footer")
               .append(ej.buildTag("span.e-footer-icon"))
               .append(ej.buildTag("span.e-footer-text"))
               .appendTo(this._sfTimeMins);
            $('.e-footer-text', this._sfTimeMins).html(this._localizedLabels.buttonText.timeNow);
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this.datePicker.model.value, "dd MMM yyyy"));
            !this.model.timeDrillDown.showMeridian && $(".e-mins-header", this._sfTimeMins).css("display", "none");

            // Bind action to the item.
            this._on(table.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
            this._on($('.e-next', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-prev', this._sfTimeMins), "click", $.proxy(this._prevNextMinsHandler, this));
            this._on($('.e-footer', this._sfTimeMins), "click", this._todayBtn);
            $('.e-minitues-headertext', this._sfTimeMins).on("click", $.proxy(this._forwardNavHandler, this));
            this._sfTimeMins.hide();
        },
        _todayBtn: function () {
            this._nowClick();
            this._hideResult();
        },
        _hourNavHandler: function (e) {
            var value;
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();

            $("table", this._sfTimeHour).find("td").removeClass("e-active");
            $(e.target).addClass("e-active");

            this._sfTimeHour.hide();
            this._sfTimeMins.show();
            this._addFocus(this._sfTimeMins);
            if (this.model.timeDrillDown.showMeridian) {
                var txt = $(e.target).hasClass("e-hour-am") ? "AM" : "PM";
                value = $(e.target).text() + ":00 " + txt;
            }
            else
                value = $(e.target).text();
            this._generateMins(value);
            var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
            var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
            var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));
            var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
            index = Math.ceil(index);
            this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);
        },
        _minsNavHandler: function (e) {
            if (this.model.readOnly || !this.model.enabled) return false;
            if (e && $(e.target).hasClass("e-disable")) return false;
            if (e && e.type) e.preventDefault();
            $("table", this._sfTimeMins).find("td").removeClass("e-active").removeClass("e-state-hover");
            $(e.target).addClass("e-active");
            if (this.model.timeDrillDown.showMeridian) {
                var value = $(e.target).text() + " " + ej.format(this._datetimeValue, "tt", "en-US");
                value = this.timePicker._localizeTime(value)
            }
            else
                value = $(e.target).text();
            this.timePicker.option("value", value);
            this.datePicker.option("value", this._datetimeValue);
            this._datetimeValue = new Date(this.model.value.toString());
            this._updateInput();
            this.model.timeDrillDown.autoClose && this._hideResult(e);
        },
        _generateMins: function (value) {
            var minsTable = $('table', this._sfTimeMins);
            minsTable.empty();
            this.model.timeDrillDown.showMeridian ? $(".e-mins-header", this._sfTimeMins).show() : $(".e-mins-header", this._sfTimeMins).hide()
            var displayFormat = this.model.timeDrillDown.showMeridian ? "hh:mm" : "HH:mm";
            $('.e-minitues-headertext', this._sfTimeMins).text($('.e-hours-headertext', this._sfTimeHour).text());
            var tbody = ej.buildTag('tbody.e-timepicker-mins').attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            var start, tr, end, timeVal, count = 0, interval = this.model.timeDrillDown.interval * 60000;
            start = this.timePicker._createObject(value);
            this._datetimeValue.setHours(start.getHours());
            end = this.timePicker._createObject(start).getTime() + 59 * 60000;
            tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
            tbody.append(tr);
            while (this.timePicker._compareTime(end, start, true)) {
                if (count >= 4) {
                    count = 0;
                    tr = ej.buildTag('tr', "").attr((this._isIE8) ? { 'unselectable': 'on' } : {});
                    tbody.append(tr);
                }
                timeVal = this._localizeTime(start, displayFormat);
                var tdtag = ej.buildTag("td.e-mins e-state-default", timeVal);
                if (this._isIE8)
                    tdtag.attr("unselectable", "on");
                tr.append(tdtag);
                count++;
                start = this.timePicker._createObject(start).getTime() + interval;
            }
            minsTable.append(tbody);
            $(".e-mins-header", this._sfTimeMins).find('.e-minitues-meridiantxt').text(ej.format(this._datetimeValue, "tt", this.model.locale))
            this._disableRange("mins");
            this._on(minsTable.find('.e-mins'), "click", $.proxy(this._minsNavHandler, this));
        },
        _prevNextHourHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeHour);
        },
        _prevNextMinsHandler: function (event) {
            if (this.model.readOnly || !this.model.enabled) return false;
            event.preventDefault();
            var element = ($(event.target).is('a')) ? $(event.target.parentNode) : $(event.target);
            var progress = element.hasClass('e-prev') ? true : false;
            this._processNextPrev(progress, this._sfTimeMins);
        },
        _processNextPrev: function (progress, wrapper) {
            if (progress && wrapper.find(".e-arrow-sans-left").hasClass("e-disable")) return false;
            else if (!progress && wrapper.find(".e-arrow-sans-right").hasClass("e-disable")) return false;
            var currentTable = $("table", wrapper), temp;
            var incVal, tClassName = currentTable.get(0).className;
            switch (tClassName) {
                case "e-dp-viewhours":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setDate(this._datetimeValue.getDate() + incVal);
                    this._disableRange("hour");

                    this._hoverHour = this._setFocusByIndex("hour", this._hoverHour, this._sfTimeHour);
                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
                case "e-dp-viewmins":
                    incVal = progress ? -1 : 1;
                    this._datetimeValue.setHours(this._datetimeValue.getHours() + incVal);
                    this._generateMins($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)));

                    var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                    var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                    var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                    var index = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                    index = Math.ceil(index);

                    this._disableRange("mins");

                    this._hoverMins = this._setFocusByIndex("mins", index, this._sfTimeMins);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    break;
            }
        },
        _forwardNavHandler: function (event, table) {
            if (this.model.readOnly || !this.model.enabled) return false;
            var hclassName, proxy = this;
            if (event) event.preventDefault();
            if (event)
                hclassName = $(event.currentTarget).get(0).className;
            else
                hclassName = table.find(".e-text>span").get(0).className;

            switch (hclassName) {
                case "e-hours-headertext":
                    this._sfTimeHour.css("display", "none");
                    this._dateContainer.css("display", "block");
                    this._addFocus(this._dateContainer.find('.e-datepicker'));
                    break;
                case "e-minitues-headertext":
                    this._sfTimeMins.css("display", "none");
                    this._disableRange("hour");

                    var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                    var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
                    indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                    indx = Math.floor(indx);

                    this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

                    $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
                    this._sfTimeHour.css("display", "block");
                    this._addFocus(this._sfTimeHour);
                    break;
            }
        },
        _renderDateControl: function () {
            var dateInput = ej.buildTag("input#" + this.element[0].id + "_date", "", {}, { "type": "text" });
            this.popup.append(dateInput);
            dateInput.ejDatePicker({

                height: "0px", width: "0px",
                displayInline: true,
                showDateIcon: false,
                showFooter: this.model.timeDrillDown.enabled ? this.model.timeDrillDown.showFooter : false,
                enableStrictMode: true,
                buttonText: this._localizedLabels.buttonText.today,

                minDate: this._stringToObject(this.model.minDateTime),
                maxDate: this._stringToObject(this.model.maxDateTime),

                dayHeaderFormat: this.model.dayHeaderFormat,
                startLevel: this.model.startLevel,
                depthLevel: this.model.depthLevel,
                startDay: this.model.startDay,
                stepMonths: this.model.stepMonths,
                showOtherMonths: this.model.showOtherMonths,
                headerFormat: this.model.headerFormat,

                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale
            });
            if (!ej.isNullOrUndefined(this.model.value))
                this._datetimeValue = new Date(this.model.value.toString());
            this.datePicker = dateInput.data("ejDatePicker");
            this._datetimeValue = new Date(this.datePicker._dateValue.toString());
            this.model.startDay = this.datePicker.model.startDay;
            this.datePicker._getInternalEvents = true;
            this.datePicker._dt_drilldown = true;
            this.datePicker.popup.css({ "position": "static", "display": "block" });
        },
        _renderTimeControl: function () {
            var timeInput = ej.buildTag("input#" + this.element[0].id + "_time", "", {}, { "type": "text" });
            this.popup.append(timeInput);

            timeInput.ejTimePicker({
                height: "0px", width: "0px",
                interval: this.model.interval,
                timeFormat: this.model.timeDisplayFormat,
                popupWidth: this.model.timePopupWidth,
                enabled: this.model.enabled,
                enableRTL: this.model.enableRTL,
                showRoundedCorner: this.model.showRoundedCorner,
                readOnly: this.model.readOnly,
                cssClass: this.model.cssClass,
                locale: this.model.locale
            });
            this.timePicker = timeInput.data("ejTimePicker");
            this.timePicker._renderDropdown();
            this.timePicker.popup.css({ "position": "static", "display": "block" });
            this.timePicker._getInternalEvents = true;
            this.timePicker.showDropdown = true;
            this.timePicker._dateTimeInternal = true;
            var min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            var max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;

        },
        _updateTimeHeight: function () {
            var height = this.popup.find(".e-timecontainer .e-header").is(":visible") ? this.datePicker.popup.height() - this.popup.find(".e-header").height() : this.datePicker.popup.height();
            height = this.popup.hasClass("e-dt-responsive") ? "98px" : height;
            this.timePicker.option("popupHeight", height);
        },

        _bindOperations: function () {
            var proxy = this;
            this.datePicker.option("layoutChange", function () { proxy._updateTimeHeight(); });
            this.datePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.timePicker.option("outOfRange", function () { proxy.isValidState = false; });
            this.datePicker.option("change", function (a) {
                proxy._refreshTimes(a);
            });
            this.datePicker.option("select", function (e) {
                proxy._updateInput(e);
            });
            this.datePicker.option("dt_drilldown", function (e) {
                if (proxy.model.timeDrillDown.enabled) {
                    proxy._updateInput(e);
                    proxy._switchToDrilDown(e);
                }
            });
            this.timePicker.option("select", function () { proxy._updateInput(); });
        },
        _switchToDrilDown: function (e) {
            this._dateContainer.hide();
            this._sfTimeHour.show();
            this._addFocus(this._sfTimeHour);
            var selected = new Date(this.model.value.toString());
            this._datetimeValue = new Date(selected.setHours(this._datetimeValue.getHours(), this._datetimeValue.getMinutes(), this._datetimeValue.getSeconds(), this._datetimeValue.getMilliseconds()));

            // To hide the hours that exceeds the min and max.
            this._disableRange("hour");

            var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
            var val = $.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale));
            var indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
            indx = Math.floor(indx);

            this._hoverHour = this._setFocusByIndex("hour", indx, this._sfTimeHour);

            $(".e-hours-headertext", this._sfTimeHour).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
            $(".e-minitues-headertext", this._sfTimeMins).text(ej.format(this._datetimeValue, "dd MMM yyyy"));
        },
        _disableRange: function (view) {
            var interval = view == "hour" ? this._interval : this.model.timeDrillDown.interval, table = view == "hour" ? this._sfTimeHour : this._sfTimeMins
            var addClassName = view == "hour" ? "e-hide-hour e-disable" : "e-hide-mins e-disable";
            table.find('tbody tr td.e-' + view).removeClass(addClassName);
            table.find('.e-arrow-sans-left').removeClass("e-disable");
            table.find('.e-arrow-sans-right').removeClass("e-disable");
            var start = view == "hour" ? this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00") :
                this._localizeTime($.trim(ej.format(this.timePicker._createObject(this._datetimeValue), "HH:00", this.model.locale)), "HH:00");

            if (this._compareDate(this.model.minDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.minDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.minDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = view == "hour" ? Math.floor(indx) : Math.ceil(indx);
                for (i = 0; i < indx; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-left').addClass("e-disable");
            }
            if (this._compareDate(this.model.maxDateTime, this._datetimeValue)) {
                if (view == "mins")
                    if (!(this.model.maxDateTime.getHours() === this._datetimeValue.getHours())) return false;
                var val = $.trim(ej.format(this.timePicker._createObject(this.model.maxDateTime), "HH:mm", this.model.locale));
                indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (interval * 60000);
                indx = Math.floor(indx) + 1;
                var length = table.find('tbody tr td.e-' + view).length
                for (i = indx; i < length; i++) {
                    var allValues = table.find('tbody tr td.e-' + view), cell;
                    cell = allValues[i];
                    $(cell).addClass(addClassName);
                }
                table.find('.e-arrow-sans-right').addClass("e-disable");
            }
        },
        _setFocusByName: function (name, value, table) {
            var allValues = table.find('tbody tr td.e-' + name), index, cell;
            $(allValues).each(function (i, ele) {
                if (ele.innerHTML == value) {
                    index = i;
                    return;
                }
            });
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setFocusByIndex: function (name, index, table) {
            var allValues = table.find('tbody tr td.e-' + name), cell;
            cell = allValues[index];
            if (!cell) cell = allValues.last();
            table.find('table td').removeClass("e-state-hover").removeClass('e-active');
            if (!$(cell).hasClass("e-hide-" + name))
                $(cell).addClass("e-state-hover");
            this._setActiveState(name, table);
            return index;
        },

        _setActiveState: function (selection, table) {
            var items = table.find('tbody tr td.e-' + selection), cell, proxy = this;
            var indx = -1;
            switch (selection) {
                case "hour":
                    if (this._compareDate(this.model.value, this._datetimeValue)) {

                        var start = this._localizeTime(this.timePicker._createObject("12:00:00 AM"), "HH:00")
                        var val = $.trim(ej.format(this.timePicker._createObject(this.model.value), "HH:00", this.model.locale));
                        indx = (this.timePicker._parse(val) - this.timePicker._parse(start)) / (this._interval * 60000);
                        indx = Math.floor(indx);

                    }
                    break;
                case "mins":
                    if (this._compareDate(this.model.value, this._datetimeValue) && (this.model.value.getHours() === this._datetimeValue.getHours())) {

                        var temp = new Date(this._datetimeValue.toString()).setMinutes(this.model.value.getMinutes());
                        var val = $.trim(ej.format(this.timePicker._createObject(temp), "HH:mm", this.model.locale));
                        var val2 = $.trim(ej.format(this.timePicker._createObject(temp), "HH:00", this.model.locale));

                        indx = (this.timePicker._parse(val) - this.timePicker._parse(val2)) / (this.model.timeDrillDown.interval * 60000);
                        indx = Math.ceil(indx);
                    }
                    break;
            }
            cell = items[indx];
            if (cell) {
                table.find('table td').removeClass("e-active");
                $(cell).removeClass("e-state-hover").addClass("e-active");
            }
        },

        _compareDate: function (first, second) {
            var val1 = new Date(first.toString()).setHours(0, 0, 0, 0);
            var val2 = new Date(second.toString()).setHours(0, 0, 0, 0);
            var result = (+val1 === +val2) ? true : false;
            return result;
        },

        _updateInput: function (e) {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var date = this._getDate() || new Date(), time = this._getTime() || this.timePicker._createObject(minVal);
            this.model.value = new Date(date.getFullYear(), date.getMonth(), date.getDate(),
                time.getHours(), time.getMinutes(), time.getSeconds());
            this._updateDateTime();
            this._raiseChangeEvent();
            this._updateModel(e, true);
            if (e)
                e.cancel = true;
        },
        _updateDateTime: function () {
            this.isValidState = true;
            var datetime = this._objectToString(this.model.value);
            this.element.val(datetime);
            this._removeWatermark();
        },
        _refreshTimes: function (args) {
            var value = this._getDateObj(args.value, this.datePicker.model.dateFormat);
            if (!value) return false;
            this.isValidState = true;

            if (this._compare(value, this._setEmptyTime(this.model.minDateTime))) {
                var mintime = this._getFormat(this.model.minDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("minTime", mintime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("minTime", this._defaultMinVal());

            if (this._compare(value, this._setEmptyTime(this.model.maxDateTime))) {
                var maxtime = this._getFormat(this.model.maxDateTime, this.timePicker.model.timeFormat);
                var preTime = this._getTime();
                this.timePicker.option("maxTime", maxtime);
                if (!this.model.enableStrictMode) {
                    this._updateInput();
                }
            }
            else
                this.timePicker.option("maxTime", this._defaultMaxVal());

            this.timePicker._changeActiveEle();
        },

        _defaultMinVal: function () {
            var minVal = new Date().setHours(0, 0, 0, 0);
            var minTimeVal = ej.format(this.timePicker._createObject(minVal), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return minTimeVal;
        },
        _defaultMaxVal: function () {
            var maxval = new Date().setHours(23, 59, 59, 59);
            var maxTimeVal = ej.format(this.timePicker._createObject(maxval), this.timePicker.model.timeFormat, this.timePicker.model.locale);
            return maxTimeVal;
        },
        _updateValues: function () {
            var dateValue = this.model.value;
            if (this.model.value != null) {
                this.datePicker.option("value", this.model.value);
                this.timePicker.option("value", this.model.value);
            }
            this._setValue(dateValue);
            this._validateMinMax();
            this._preVal = this.element.val();
            this._checkErrorClass();
        },
        _specificFormat: function () {
            var parseInfo = ej.globalize._getDateParseRegExp(ej.globalize.findCulture(this.model.locale).calendar, this.model.dateFormat);
            return ($.inArray("dddd", parseInfo.groups) > -1 || $.inArray("ddd", parseInfo.groups) > -1)
        },
        _changeEditable: function (bool) {
            var action = bool ? "_on" : "_off";
            if (this.element.is(":input")) {
                if (bool) {
                    if (!this.model.readOnly) this.element.attr("readonly", false);
                    this.element.off("mousedown", $.proxy(this._showhidePopup, this));
                }
                else {
                    if (!this.model.readOnly) this.element.attr("readonly", "readonly");
                    this.element.on("mousedown", $.proxy(this._showhidePopup, this));
                }
                this[action](this.element, "blur", this._targetBlur);
                this[action](this.element, "focus", this._targetFocus);
                this[action](this.element, "keydown", this._keyDownOnInput);
            }
            this._change("allowEdit", bool);
        },
        _setValue: function (value) {
            if (!value || (typeof JSON === "object" && JSON.stringify(value) === "{}")) {
                this.element.val("");
                this.model.value = null;
                this.isValidState = true;
                this.wrapper.removeClass('e-valid');
            }
            else if (typeof value === "string") {
                if (this._extISORegex.exec(value) || this._basicISORegex.exec(value)) this._checkObject(this._dateFromISO(value));
                else {
                    this.element.val(value);
                    this._updateModel();
                    this._validateMinMax();
                    this._checkStrictMode();
                    this.wrapper.addClass('e-valid');
                }
            }
            else if (value instanceof Date && this._isValidDate(value)) {
                this._checkObject(value);
            }
            this._checkErrorClass();
            return this.model.value;
        },
        _checkObject: function (value) {
            if (value instanceof Date && this._isValidDate(value)) {
                this.model.value = value;
                this._updateDateTime();
                this._validateMinMax();
                this._checkStrictMode();
            }
        },
        _dateFromISO: function (date) {
            var result = this._extISORegex.exec(date) || this._basicISORegex.exec(date), dateFormat = '', timeFormat = '', zeroFormat = '', format;
            if (result) {
                for (var i = 0; i < this._dates.length; i++) {
                    if (this._dates[i][1].exec(result[1])) {
                        dateFormat = this._dates[i][0];
                        break;
                    }
                }
                if (result[3]) {
                    for (var k = 0; k < this._times.length; k++) {
                        if (this._times[k][1].exec(result[3])) {
                            // result[2] should be 'T' (time) or space
                            timeFormat = (result[2] || ' ') + this._times[k][0];
                            break;
                        }
                    }
                }
                if (result[4]) if (this._zeroRegex.exec(result[4])) zeroFormat = 'Z';
                format = dateFormat + timeFormat + zeroFormat;
                var token = format.match(this._tokens), input, val = [], literal, char;
                for (var j = 0; j < token.length; j++) {
                    var str = token[j];
                    literal = this._checkLiteral(token[j]);
                    var rg = this._numberRegex[literal ? token[j].toLowerCase() : str.length] || new RegExp('^\\d{1,' + str.length + '}');
                    input = date.match(rg);
                    if (input) {
                        if (date.substr(0, date.indexOf(input)) >= 0 && !literal) token[j].indexOf('M') >= 0 ? val.push(parseInt(input[0]) - 1) : val.push(parseInt(input[0]));
                        date = date.slice(date.indexOf(input[0]) + input[0].length);
                    }
                }
                //if you want to get the value in UTC format use the "new Date(Date.UTC.apply(null, val)"
                //return the date object value as exact as given input value
                //new Date(year, month, day, hour, minute, seconds);
                return result[4] == "Z" ? new Date(Date.UTC.apply(null, val)) : new Date(val[0], val[1], val[2], val[3], val[4], val[5]);
            }
            else {
                return new Date(date + "");
            }
        },
        _checkLiteral: function (str) {
            char = str.toLowerCase();
            return (char == 't' || char == 'z' || char == ':' || char == '-') ? true : false;
        },
        _validateValue: function (value) {
            var dateObj = ej.parseDate(value, this.model.dateTimeFormat);
            if (!dateObj || dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = false;
            }
            else {
                this._change("value", this.model.value);
                this.isValidState = true;
            }
        },
        _validateMinMax: function () {
            var value, min, max;
            value = (this.model.value) ? this._stringToObject(this.model.value) : null;
            min = (this.model.minDateTime) ? this._stringToObject(this.model.minDateTime) : this.defaults.minDateTime;
            max = (this.model.maxDateTime) ? this._stringToObject(this.model.maxDateTime) : this.defaults.maxDateTime;
            if (!value || !min || !max) return false;
            if (min > max) this.model.minDateTime = this.model.maxDateTime;
            if (value < min) {
                if (!this.model.enableStrictMode) {
                    this._setValue(min);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
                    this.datePicker.option('minDate', this._getFormat(min, this.datePicker.model.dateFormat));
                    this.timePicker.option('minTime', this._getFormat(min, this.timePicker.model.timeFormat));
                    this.isValidState = false;
                }
            }
            if (value > max) {
                if (!this.model.enableStrictMode) {
                    this._setValue(max);
                    this.isValidState = true;
                }
                else if (this.model.enableStrictMode) {
                    this.datePicker.option('maxDate', this._getFormat(max, this.datePicker.model.dateFormat));
                    this.timePicker.option('maxTime', this._getFormat(max, this.timePicker.model.timeFormat));

                    this.isValidState = false;

                }
            }

            if (!(value < min) && !(value > max)) this.isValidState = true;
        },

        _checkProperties: function () {
            this.model.readOnly && this._readOnly(true);
            this.model.showRoundedCorner && this._setRoundedCorner(true);
            this.model.enableRTL && this._setRtl(true);
            this.model.enabled && this._enabled(true);
            if (!this.model.enabled) this._enabled(false);
            else if (this.model.enabled && this.element.hasClass("e-disable")) this._enabled(true);
            this.model.name = !this._options.name ? !this.element.attr("name") ? this.element[0].id : this.element.attr("name") : this.model.name;
            this.element.attr("name", this.model.name);
            this._checkStrictMode();
            this._checkErrorClass();
            this._setWaterMark();
        },

        _checkStrictMode: function () {
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    if (this.model.value < this.model.minDateTime) {
                        this.element.val(this._objectToString(this.model.minDateTime));
                        this.model.value = this.model.minDateTime;
                        this.isValidState = true;
                    }
                    else if (this.model.value > this.model.maxDateTime) {
                        this.element.val(this._objectToString(this.model.maxDateTime));
                        this.model.value = this.model.maxDateTime;
                        this.isValidState = true;
                    }
                    else {
                        this.model.value = "";
                        this.element.val("");
                        this.isValidState = true;
                    }
                }
            }
            else if (this.model.enableStrictMode) {
                if (!this.isValidState) {

                    this.model.value = null;
                    this.isValidState = false;
                }
            }
        },

        _targetFocus: function (e) {
            e.preventDefault();
            this.isFocused = true;
            this.wrapper.addClass("e-focus");
            this.wrapper.removeClass("e-error");
            if (!this._isSupport) this._hiddenInput.css("display", "none");
            this._prevDateTimeVal = this.element.val();
            if (!this.model.showPopupButton && !this.model.readOnly) this._showResult();
            if (!this.model.showPopupButton) this._on(this.element, "click", this._elementClick);
            if (!this.model.showPopupButton && this.model.readOnly) this._off(this.element, "click", this._elementClick);
            this._trigger("focusIn", { value: this.model.value });
            this.wrapper.addClass('e-valid');
        },
        _targetBlur: function () {
            this.isFocused = false;
            this.wrapper.removeClass("e-focus");
            if (!this.model.showPopupButton) this._hideResult();
            var dateObj = ej.parseDate(this.element.val(), this.model.dateTimeFormat, this.model.locale);
            if (dateObj && !this.model.enableStrictMode) {
                if (dateObj < this.model.minDateTime || dateObj > this.model.maxDateTime) {
                    dateObj = dateObj < this.model.minDateTime ? this.model.minDateTime : this.model.maxDateTime;
                    this.element.val(this._objectToString(dateObj));
                }
            }
            var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat, this.model.locale);
            if (val == null && !this.model.enableStrictMode) {
                if (this._prevDateTimeVal == null || this.element.val() == "") {
                    this.element.val("");
                } else
                    this.element.val(this._preVal);
            }
            this._valueChange();
            if (!this.model.enableStrictMode) {
                if (!this.isValidState) {
                    this.element.val(this._prevDateTimeVal);
                    this._preVal = this._prevDateTimeVal;
                    this.model.value = this._stringToObject(this._prevDateTimeVal);
                    this.isValidState = true;
                }
                else
                    this._prevDateTimeVal = this.element.val();
            } else if (this.element.val() != "")
                this._validateValue(this.element.val());
            if (!this._isSupport && this.element.val() == "")
                this._hiddenInput.css("display", "block");
            this._checkErrorClass();
            if (!this.model.showPopupButton) this._off(this.element, "click", this._elementClick);
            this._trigger("focusOut", { value: this.model.value });
            (ej.isNullOrUndefined(this.model.value)) ? this.wrapper.removeClass('e-valid') : this.wrapper.addClass('e-valid');
            this._previousDateUpdate();
        },
        _previousDateUpdate: function () {
            var previous = ej.parseDate(this._prevDateTime, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preValString = this._prevDateTime;
                this._prevDateTime = this.element.val();
            }
            return this._preValString;
        },
        _elementClick: function () {
            if (!this.isPopupOpen) this._showResult();
        },
        _keyDownOnInput: function (e) {
            switch (e.keyCode) {
                case 40:
                    if (e.altKey) this._showhidePopup();
                    break;
                case 37:
                case 39:
                    if (!this.model.timeDrillDown.enabled)
                        if (e.altKey && this.isPopupOpen) {
                            e.preventDefault();
                            this._addPrevNextFocus(e.keyCode == 37);
                        }
                    break;
                case 27:
                    e.preventDefault();
                case 9:
                    this._hideResult();
                    break;
                case 13:    // Enter Key
                    var val = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
                    if (val == null && !this.model.enableStrictMode) {
                        if (this._prevDateTimeVal == null || this.element.val() == "") {
                            this.element.val("");
                        } else
                            this.element.val(this._preVal);
                    }
                    this._valueChange();
                    if (!this.model.timeDrillDown.enabled) {
                        this._valueChange();
                        if (this.model.enableStrictMode)
                            this._checkErrorClass();
                        break;
                    }
            }
        },
        _addFocus: function (target) {
            if (!target.hasClass("e-focus")) {
                this._removeFocus();
                target.addClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).on("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).on("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).on("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).on("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).on("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _removeFocus: function () {
            var target = this._getFocusedElement();
            if (target.length > 0) {
                target.removeClass("e-focus");
                if (target.hasClass("e-datepicker e-popup"))
                    $(document).off("keydown", $.proxy(this.datePicker._keyboardNavigation, this.datePicker));
                else if (target.hasClass("e-timecontainer"))
                    $(document).off("keydown", $.proxy(this.timePicker._keyDownOnInput, this.timePicker));
                else if (target.hasClass("e-time-hours"))
                    $(document).off("keydown", $.proxy(this._keyDownOnHours, this));
                else if (target.hasClass("e-time-minitues"))
                    $(document).off("keydown", $.proxy(this._keyDownOnMinutes, this));
                else if (target.hasClass("e-dt-button"))
                    $(document).off("keydown", $.proxy(this._buttonClick, this));
            }
        },
        _addPrevNextFocus: function (flag) {
            // flag true means previous focus, false means next focus
            var target = this._getFocusedElement(), next;
            if (target.length > 0) {
                if (target.hasClass("e-datepicker e-popup"))
                    next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-timecontainer");
                else if (target.hasClass("e-timecontainer"))
                    next = flag ? this.popup.find(".e-datecontainer >.e-datepicker.e-popup") : this.popup.find(".e-dt-today");
                else if (target.hasClass("e-dt-today"))
                    next = flag ? this.popup.find(".e-timecontainer") : this.popup.find(".e-dt-now");
                else if (target.hasClass("e-dt-now"))
                    next = flag ? this.popup.find(".e-dt-today") : this.popup.find(".e-dt-done");
                else if (target.hasClass("e-dt-done"))
                    next = flag ? this.popup.find(".e-dt-now") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            }
            else next = flag ? this.popup.find(".e-dt-done") : this.popup.find(".e-datecontainer >.e-datepicker.e-popup");
            this._addFocus(next);
        },
        _getFocusedElement: function () {
            return this.popup.children("div").find("div.e-focus")
        },
        _keyDownOnHours: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeHour.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeHour.find('tbody tr td.e-state-hover').parent().index();

                if (t.col != -1)
                    t.col = t.col + 1;
                else
                    t.col = this._sfTimeHour.find('tbody tr td.e-active').index() + 1;


                if (t.row != -1) {
                    t.row = t.row + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-state-hover').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }
                else {
                    t.row = this._sfTimeHour.find('tbody tr td.e-active').parent().index() + 1;
                    if (this.model.timeDrillDown.showMeridian && this._sfTimeHour.find('tbody tr td.e-active').hasClass('e-hour-pm'))
                        t.row = t.row + 2;
                }

                var tableClass = this._sfTimeHour.find('table')[0].className, next;
                rowLength = this._sfTimeHour.find('tbody.e-timepicker-hours tr').length, colLength = this.model.timeDrillDown.showMeridian ? 6 : 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "hours", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeHour.find('tbody.e-timepicker-hours tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeHour.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },

        _changeRowCol: function (t, key, rows, cols, target, ctrlKey) {
            var eleClass, table, cls = { parent: null, child: null };
            switch (target) {
                case "hours": eleClass = "tbody.e-timepicker-hours tr td.e-hour";
                    cls.parent = ".e-timepicker-hours", cls.child = ".e-hour";
                    hiddenClass = ".e-hide-hour";
                    table = this._sfTimeHour;
                    break;
                case "mins": eleClass = "tbody.e-timepicker-mins tr td.e-mins";
                    cls.parent = ".e-timepicker-mins", cls.child = ".e-mins";
                    hiddenClass = ".e-hide-mins";
                    table = this._sfTimeMins;
                    cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    break;

            }
            if (t.row <= 0 && t.col <= 0)
                return table.find(eleClass + ':not(.e-disable):first');
            var cell, proxy = this;
            switch (key) {
                case 36:
                    return table.find(eleClass + ':not(.e-disable):first');
                case 35:
                    return table.find(eleClass + ':not(.e-disable):last');
                case 38:
                    if (ctrlKey) {
                        this._forwardNavHandler(null, table);
                    }
                    else if (t.row > 1) {
                        t.row -= 1;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "up", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':nth-child(' + t.col + '):last');
                    }
                    return cell;
                case 37:
                    if (ctrlKey) {
                        this._processNextPrev(true, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col > 1)
                        t.col -= 1;
                    else if (t.row > 1) {
                        t = { row: t.row - 1, col: cols }
                        // different columns for the mins popup.
                        if (target == "mins") t.col = cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + t.row + ') td' + cls.child).length;
                    }
                    else {
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "left", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(true, table);
                        cell = table.find(eleClass + ':not(.e-disable):last');
                    }
                    return cell;
                case 39:
                    if (ctrlKey) {
                        this._processNextPrev(false, table);
                        return table.find('tbody tr td.e-state-hover');
                    }
                    else if (t.col < cols)
                        t.col += 1;
                    else if (t.row < rows) {
                        t = { row: t.row + 1, col: 1 }
                    }
                    else {
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                        return cell;
                    }
                    cell = this._getCell(t, cls, table).not(hiddenClass);
                    if (cell.length <= 0) {
                        cell = this._findVisible(t, cls, "right", table);
                        if (cell !== null) return cell;
                        this._processNextPrev(false, table);
                        cell = table.find(eleClass + ':not(.e-disable):first');
                    }
                    return cell;
                case 40:
                    if (!ctrlKey) {
                        if (t.row < rows) {
                            t.row += 1;
                        }
                        else {
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                            return cell;
                        }
                        cell = this._getCell(t, cls, table).not(hiddenClass);
                        if (cell.length <= 0) {
                            cell = this._findVisible(t, cls, "down", table);
                            if (cell !== null) return cell;
                            this._processNextPrev(false, table);
                            cell = table.find(eleClass + ':nth-child(' + t.col + '):first');
                        }
                        return cell;
                    }
                case 13:
                    var ele, element;
                    ele = this._getCell(t, cls, table); element = $(ele)[0];
                    args = { type: null, target: ele };
                    if (target == "hours") this._hourNavHandler(args);
                    if (target == "mins") this._minsNavHandler(args);
                    break;
            }
            return this._getCell(t, cls, table).not(hiddenClass);
        },
        _getCell: function (t, cls, table) {
            var row = t.row;
            if (this.model.timeDrillDown.showMeridian && t.row > 2 && table.hasClass('e-time-hours'))
                row = row - 2;
            var cell = table.find('tbody' + cls.parent + ' tr:nth-child(' + row + ') td' + cls.child + ':nth-child(' + t.col + ')');
            if (this.model.timeDrillDown.showMeridian && cell.length > 0 && table.hasClass('e-time-hours'))
                cell = t.row <= 2 ? $(cell[0]) : $(cell[1]);
            return cell;
        },
        _findVisible: function (t, cls, key, table) {
            var cols = t.col, rows = t.row, requiredClass = cls.child.slice(1, cls.child.length);
            for (i = 0; i >= 0; i++) {
                //nextElement = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td:nth-child(' + cols + ')');
                nextElement = this._getCell({ row: rows, col: cols }, cls, table)
                if (nextElement.length <= 0) {
                    return null;
                }
                if (nextElement.hasClass('e-disable') || !nextElement.is(":visible")) {
                    key == "right" || key == "left" ? (key == "right" ? cols++ : cols--) : (key == "down" ? rows++ : rows--);
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                    // Column exceeds the range. 
                    if (cols > table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length) {
                        //move to next row and select first column
                        rows++;
                        cols = 1;
                    }
                    if (cols <= 0) {
                        //move to previous row and select last column
                        rows--;
                        cols = table.find('tbody' + cls.parent + ' tr:nth-child(' + rows + ') td').length;
                    }
                    // Row exceeds the range.
                    if ((rows <= 0) || (rows > table.find('tbody' + cls.parent + ' tr').length)) {
                        // No more rows there in popup.
                        return null;
                    }
                } else if (nextElement.hasClass(requiredClass)) {
                    t.col = cols; t.row = rows;
                    nextElement = this._getCell(t, cls, table)
                    return nextElement;
                }
            }
        },
        _keyDownOnMinutes: function (e) {
            if ((e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40 || e.keyCode == 13 || e.keyCode == 36 || e.keyCode == 35)) {
                e.preventDefault && e.preventDefault();
                var t = { row: null, col: null };

                t.col = this._sfTimeMins.find('tbody tr td.e-state-hover').index();
                t.row = this._sfTimeMins.find('tbody tr td.e-state-hover').parent().index();

                t.col = (t.col != -1) ? t.col + 1 : this._sfTimeMins.find('tbody tr td.e-active').index() + 1;
                t.row = (t.row != -1) ? t.row + 1 : this._sfTimeMins.find('tbody tr td.e-active').parent().index() + 1;

                var tableClass = this._sfTimeMins.find('table')[0].className, next;
                rowLength = this._sfTimeMins.find('tbody.e-timepicker-mins tr').length, colLength = 4;
                next = this._changeRowCol(t, e.keyCode, rowLength, colLength, "mins", e.ctrlKey);
                if (!e.ctrlKey) this._hoverHour = this._sfTimeMins.find('tbody.e-timepicker-mins tr td').index(next);

                if (!e.ctrlKey) {
                    this._sfTimeMins.find('table td').removeClass("e-state-hover");
                    next.addClass("e-state-hover");
                }
            }
        },
        _valueChange: function (isCode) {
            if (!this.model.enableStrictMode) {
                if (this._preVal != this.element.val()) {
                    this._preVal = this.element.val();
                    this._updateModel();
                    this._validateMinMax();
                    this._raiseChangeEvent(isCode);
                }
                this._setWaterMark();
            }
            else if (this.model.enableStrictMode) {
                if (this._preVal != this.element.val() || this.model.value < this.model.minDateTime || this.model.value > this.model.maxDateTime) {
                    this._updateModel();
                    this._raiseChangeEvent(isCode);
                }
            }
        },
        _updateModel: function (e, stopUpdateModel) {
            if (this._stopRefresh) {
                this._stopRefresh = false
                return;
            }
            var value = this.element.val();
            if (value == "") {
                this.model.value = null;
                this._change("value", this.model.value);
                this.isValidState = true;
            }
            else {
                var dateObj;
                if (e != undefined && e.type == "select" || this._prevDateTimeVal == this.element.val()) dateObj = this.model.value;
                else dateObj = ej.parseDate(value, this.model.dateTimeFormat, this.model.locale);
                if (dateObj) {
                    this.model.value = dateObj;
                    this.isValidState = true;
                    if (!stopUpdateModel)
                        this._refreshPopup();
                    if (this._specificFormat() && this._prevDateTimeVal != this.element.val())
                        this.element.val(this._objectToString(this.model.value));
                }
                else {
                    this.model.value = null;
                    this._change("value", this.model.value);
                    this.isValidState = false;
                    if (!this.model.enableStrictMode)
                        this.element.val(this._objectToString(this.model.value));
                }
            }
        },
        _refreshPopup: function () {
            if (this.isValidState && this.isPopupOpen) {
                var date = this._setEmptyTime(this.model.value), time = this._setEmptyDate(this.model.value);
                var getDate = this._getDate(), getTime = this._getTime();
                if (!getDate || !this._compare(getDate, date)) this.datePicker.option("value", date);
                if (!getTime || !this._compare(getTime, time)) this.timePicker.option("value", time);
            }
        },

        _buttonClick: function (e) {
            if (e.keyCode == 13) {
                e.preventDefault();
                var target = this._getFocusedElement();
                if (target.hasClass("e-dt-today"))
                    this._todayClick();
                else if (target.hasClass("e-dt-now"))
                    this._nowClick();
                else if (target.hasClass("e-dt-done"))
                    this._doneClick();
            }
        },
        _todayClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            if (!this.datePicker.popup.find(".today").hasClass("e-active") ||
                !this.datePicker.popup.children("table").hasClass("e-dp-viewdays") ||
                this.element.val() == "" || !this.isValidState) {
                this.datePicker._setCurrDate();
                this._updateInput();
            }
        },
        _nowClick: function () {
            if (!this.model.enabled || this.model.readOnly) return false;
            this.timePicker.setCurrentTime();
            var mintime = this.model.minDateTime, maxtime = this.model.maxDateTime, date = this.datePicker.model.value, time = new Date();
            date = ej.isNullOrUndefined(date) ? new Date() : date;
            var currTime = new Date(date.getFullYear(), date.getMonth(), date.getDate(), time.getHours(), time.getMinutes(), time.getSeconds());
            if (currTime < mintime)
                this.timePicker.option("value", this.timePicker._localizeTime(mintime));
            else if (currTime > maxtime)
                this.timePicker.option("value", this.timePicker._localizeTime(maxtime));
            this._updateInput();
        },
        _doneClick: function () {
            this._hideResult();
        },

        _iconClick: function (e) {
            e.preventDefault();
            if (!this.isFocused && (!ej.isTouchDevice())) this.element.focus();
            this._showhidePopup();
            if (this._isIE9)
                this.popup.find(".e-popup-container").css("display", "inline-block");
        },
        _setInitialSelection: function () {
            var elements = this.timePicker.ul.find("li");
            if (elements.hasClass('e-hover')) return;
            var currentTime = this.timePicker._setEmptyDate(new Date()), selected;
            selected = currentTime;
            if (this.timePicker.minTime && !this._compareTime(this._createObject(currentTime), this.timePicker.minTime, true))
                selected = this.timePicker.minTime;
            if (this.timePicker.maxTime && !this._compareTime(this.timePicker.maxTime, this._createObject(currentTime), true))
                selected = this.timePicker.maxTime;
            var firstTime = elements.first().html(), index;
            index = (this.timePicker._parse(selected) - this.timePicker._parse(firstTime)) / (this.timePicker.model.interval * 60000);
            index = Math.round(index);
            var activeItem = (index == elements.length) ? index : index + 1;
            if (activeItem < 0 || activeItem > elements.length || isNaN(activeItem)) activeItem = 1;
            var activeEle = $(this.timePicker.ul.find("li")[activeItem - 1]);
            activeEle.addClass('e-hover');
            this._calcScrollTop();
        },
        _calcScrollTop: function () {
            var ulH = this.timePicker.ul.outerHeight(), liH = this.timePicker.ul.find("li").outerHeight(), index, top;
            index = this.timePicker.ul.find("li.e-hover").index();
            top = (liH * index) - ((this.timePicker.popupList.outerHeight() - liH) / 2);
            this.timePicker.scrollerObj.setModel({ "scrollTop": top });
        },
        _showhidePopup: function () {
            if (this.model.readOnly) return false;
            if (!this.isPopupOpen)
                this._showResult();
            else
                this._hideResult();
        },
        _showResult: function () {
            if (!this.popup) this._renderDropdown();
            if (this.isPopupOpen || !this.model.enabled) return false;
            if (this._trigger("beforeOpen", { element: this.popup })) return false;
            this.isPopupOpen = true;
			this.element.attr({'aria-expanded':'true'})
            this._setListPosition();
            this._checkForResponsive();
            var proxy = this;
            this.popup.slideDown(this.model.enableAnimation ? 200 : 0, function () {
                proxy._on($(document), "mousedown", proxy._OnDocumentClick);
                proxy.model.timeDrillDown.enabled && proxy._addFocus(proxy._dateContainer.find('.e-datepicker'));
                if (!proxy.timePicker.model.value) proxy._setInitialSelection();
            });
            this._updateModel();
            this._updateTimeHeight();
            this._validateMinMax();
            this._on($(window), "resize", this._OnWindowResize);
            this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._on(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this._raiseEvent("open");
            if (this._initial) {
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
                this._initial = false;
            }
            this.wrapper.addClass("e-active");
        },
        _hideResult: function (e) {
			if ( e && (e.type == "touchmove" || e.type== "scroll")) {
				if ($(e.target).parents("#"+this.popup[0].id).length > 0)
				return;
	        }
            var proxy = this;
            if (!this.isPopupOpen) return false;
            if (this._trigger("beforeClose", { element: this.popup })) return false;
            this.isPopupOpen = false;
			this.element.attr({'aria-expanded':'false'})
            this._removeFocus();
            if (this._popClose && e && e.type != "click") {
                this.isPopupOpen = true;
                return;
            }
            this.popup.slideUp(this.model.enableAnimation ? 100 : 0, function () {
                if (proxy.model) {
                    if (proxy.model.timeDrillDown.enabled) {
                        proxy._sfTimeHour.hide();
                        proxy._sfTimeMins.hide();
                        proxy._dateContainer.show();
                    }
                    if (!ej.isNullOrUndefined(proxy.model.value))
                        proxy._datetimeValue = new Date(proxy.model.value.toString());
                }
            });
            this._raiseEvent("close");
            this._off($(document), "mousedown", this._OnDocumentClick);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hideResult);
            this._off(ej.getScrollableParents(this.wrapper), "touchmove", this._hideResult);
            this.wrapper.removeClass("e-active");
        },

        _setListPosition: function () {
            var elementObj = this.wrapper, pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popup.outerHeight(),
            popupWidth = this.popup.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
			popupPosition = this.model.popupPosition;
            if (this.model.popupPosition == ej.PopupPosition.Bottom)
                var topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            else
                var topPos = ((popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (this.model.enableRTL || popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popup.outerWidth() - elementObj.outerWidth();
            this.popup.css({
                "left": left + "px",
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _OnDocumentClick: function (e) {
            if (this.model) {
                if (!$(e.target).is(this.popup) && !$(e.target).parents(".e-datetime-popup").is(this.popup) &&
                    !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-datetime-wrap").is(this.wrapper)) {
                    this._hideResult();
                }
                else if ($(e.target).is(this.popup) || $(e.target).parents(".e-datetime-popup").is(this.popup)) {
                    e.preventDefault();
                    if ($(e.target).parents(".e-datepicker").length > 0) this._addFocus($(e.target).parents(".e-datepicker"));
                    else if ($(e.target).parents(".e-timecontainer").length > 0) this._addFocus($(e.target).parents(".e-timecontainer"));
                    else if ($(e.target).hasClass("e-dt-button")) this._addFocus($(e.target));
                    else if ($(e.target).parents(".e-time-hours").length > 0) this._addFocus($(e.target).parents(".e-time-hours"));
                    else if ($(e.target).parents(".e-time-minitues").length > 0) this._addFocus($(e.target).parents(".e-time-minitues"));
                    else this._removeFocus();
                }
            }
        },
        _OnWindowResize: function (e) {
            this._setListPosition();
            this._checkForResponsive();
            this._updateTimeHeight();
        },

        _raiseChangeEvent: function (isCode) {
            var previous = ej.parseDate(this._prevDateTimeVal, this.model.dateTimeFormat);
            var current = ej.parseDate(this.element.val(), this.model.dateTimeFormat);
            if (!(+previous === +current)) {
                this._preVal = this.element.val();
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isInteraction: !isCode, isValidState: this.isValidState };
                this._trigger("_change", data);
                data.value = $.trim(this.element.val()) == "" ? null : this.element.val();
                this._trigger("change", data);
                this._prevDateTimeVal = this.element.val();
            }
            else if ((this._prevDateTimeVal != this.element.val())) {
                var data = { prevDateTime: this._prevDateTimeVal, value: this.element.val(), isValidState: this.isValidState };
                this._prevDateTimeVal = this.element.val()
                this._trigger("_change", data);
            }
        },
        _raiseEvent: function (name) {
            var dateStringVal = this._previousDateUpdate();
            if (this.element != null && this.model[name])
                return this._trigger(name, { prevDateTime: ej.isNullOrUndefined(dateStringVal || this._preValString) ? '' : dateStringVal || this._preValString, value: this.element.val() });
            return false;
        },
        _getDateTimeFormat: function () {
            var pattern = ej.preferredCulture(this.model.locale).calendar.patterns;

            if (!this.model.dateTimeFormat) this.model.dateTimeFormat = pattern.d + " " + pattern.t;
            if (!this.model.timeDisplayFormat) this.model.timeDisplayFormat = pattern.t;
        },
        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },
        _checkErrorClass: function () {
            if (this.isValidState) this.wrapper.removeClass("e-error");
            else this.wrapper.addClass("e-error");
        },
        _getDate: function () {
            return this.datePicker.model.value;
        },
        _getTime: function () {
            return this._getDateObj(this.timePicker.model.value, this.timePicker.model.timeFormat);
        },
        _setEmptyTime: function (date) {
            var newDate = new Date(date);
            newDate.setMilliseconds(0);
            newDate.setSeconds(0);
            newDate.setMinutes(0);
            newDate.setHours(0);
            return newDate;
        },
        _setEmptyDate: function (date) {
            var newDate = new Date(date);
            newDate.setDate(1);
            newDate.setMonth(0);
            newDate.setFullYear(2000);
            return newDate;
        },
        _objectToString: function (obj) {
            return this._getFormat(obj, this.model.dateTimeFormat);
        },
        _stringToObject: function (value) {
            return this._getDateObj(value, this.model.dateTimeFormat);
        },
        _getFormat: function (value, format) {
            if (value instanceof Date) {
                var newFormat = this._checkFormat(format);
                return ej.format(value, newFormat, this.model.locale);
            }
            else return value;
        },
        _checkFormat: function (format) {
            var proxy = this;
            var dateFormatRegExp = this._regExp();
            return format.replace(dateFormatRegExp, function (match) {
                match = match === "/" ? ej.preferredCulture(proxy.model.locale).calendars.standard['/'] !== "/" ? "'/'" : match : match;
                return match;
            });
        },
        _regExp: function () {
            return /\/dddd|ddd|dd|d|MMMM|MMM|MM|M|yyyy|yy|HH|H|hh|h|mm|m|fff|ff|f|tt|ss|s|zzz|zz|z|gg|g|"[^"]*"|'[^']*'|[/]/g;
        },
        _getDateObj: function (value, format) {
            if (typeof value === "string") {
                var newFormat = this._checkFormat(format);
                var temp = ej.parseDate(value, newFormat, this.model.locale);
                if (temp != null)
                    return temp;
                else {
                    if (value != "" && value != null) {
                        var dateregexp = /^\s*(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d).*Z\s*$/, month, datetimesplit = dateregexp.exec(value);
                        var datevariable = new Date();
                        if (datetimesplit) {
                            datevariable = new Date();
                            month = +datetimesplit[2];
                            datevariable.setUTCFullYear(datetimesplit[1], month - 1, datetimesplit[3]);
                            datevariable.setUTCHours(datetimesplit[4], datetimesplit[5], datetimesplit[6]);
                            if (month != datevariable.getUTCMonth() + 1)
                                datevariable.setTime();
                        }
                        if (this._isValidDate(datevariable))
                            return datevariable;
                    }
                    else return null;
                }
            }
            else return value;
        },
        _compare: function (obj1, obj2) {
            return obj1 && obj2 && obj1.getTime() == obj2.getTime();
        },
        _isValidDate: function (dateObj) {
            return dateObj && typeof dateObj.getTime === "function" && isFinite(dateObj.getTime());
        },


        _change: function (property, value) {
            if (this.popup) {
                this.datePicker.option(property, value);
                this.timePicker.option(property, value);
            }
        },
        _changeSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin);
            this.popup.removeClass(this.model.cssClass).addClass(skin);

            this._change("cssClass", skin);
        },
        _localize: function (culture) {
            this.model.locale = culture;
            if (ej.isNullOrUndefined(this._options.timeDisplayFormat))
                this.model.timeDisplayFormat = "";
            if (ej.isNullOrUndefined(this._options.dateTimeFormat))
                this.model.dateTimeFormat = "";
            var meridianText = ["AM", "PM"];
            this._getDateTimeFormat();
            this.timePicker.option("timeFormat", this.model.timeDisplayFormat);
            this._localizedLabels = this._getLocalizedLabels();
            if (!ej.isNullOrUndefined(this._options)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    $.extend(this._localizedLabels.buttonText, this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.watermarkText))
                    this._localizedLabels.watermarkText = this._options.watermarkText;
            }
            this._localizedLabelToModel();
            this._buttonText(this._localizedLabels.buttonText);
            if (this.isValidState || (this.model.value instanceof Date && this._isValidDate(this.model.value)))
                this.element.val(this._objectToString(this.model.value));
            this._preVal = this.element.val();
            this._change("locale", culture);
            this.model.startDay = this.datePicker.model.startDay;
            this._validateMeridian();
            this._sfTimeHour.empty();
            this._renderHourTable();

            // Update the meridian support
            if (this.model.timeDrillDown.showMeridian)
                for (i = 0; i < 2; i++) {
                    var txt = !ej.isNullOrUndefined(ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]]) ? ej.preferredCulture(this.model.locale).calendars.standard[meridianText[i]][0] : "";
                    $("span.e-hours-meridiantxt-" + meridianText[i].toLowerCase(), this._sfTimeHour).text(txt);

                }
        },
        _setWaterMark: function () {
            if (this.element != null && this.element.hasClass("e-input")) {
                if (this._localizedLabels.watermarkText && this.element.val() == "") {
                    this.isValidState = true;
                    this._checkErrorClass();
                }
                if ((!this._isSupport) && this.element.val() == "") {
                    this._hiddenInput.css("display", "block").val(this._localizedLabels.watermarkText);
                }
                else {
                    $(this.element).attr("placeholder", this._localizedLabels.watermarkText);
                }
                return true;
            }
        },
        _localizedLabelToModel: function () {
            this.model.watermarkText = this._localizedLabels.watermarkText;
            this.model.buttonText = this._localizedLabels.buttonText;
        },
        _readOnly: function (boolean) {
            this.model.readOnly = boolean;
            if (boolean) this.element.attr("readonly", "readonly");
            else this.element.prop("readonly", false);

            this._change("readOnly", boolean);
        },
        _setRoundedCorner: function (boolean) {
            if (boolean) {
                this.container.addClass("e-corner");
                if(this.popup)this.popup.addClass("e-corner");
            }
            else {
                this.container.removeClass("e-corner");
                if(this.popup) this.popup.removeClass("e-corner");
            }
            this.datePicker.option("showRoundedCorner", boolean);
        },
        _setRtl: function (boolean) {
            if (boolean) {
                this.wrapper.addClass("e-rtl");
                if(this.popup) this.popup.addClass("e-rtl");
            }
            else {
                this.wrapper.removeClass("e-rtl");
                if(this.popup) this.popup.removeClass("e-rtl");
            }

            this._change("enableRTL", boolean);
        },
        _enabled: function (boolean) {
            if (boolean) {
                this.model.enabled = false;
                this.enable();
            }
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _showButton: function (show) {
            this.model.showPopupButton = show;
            if (show) {
                this.container.addClass("e-padding");
                this._renderIcon();
            }
            else {
                this.container.removeClass("e-padding");
                this.datetimeIcon.remove();
                this.datetimeIcon = null;
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            this.popup.find(".e-dt-today").html(this.model.buttonText.today);
            this.popup.find(".e-dt-now").html(this.model.buttonText.timeNow);
            this.popup.find(".e-dt-done").html(this.model.buttonText.done);
            this.popup.find(".e-timecontainer").find(".e-header").html(this.model.buttonText.timeTitle);
        },
        _checkForResponsive: function () {
            if (($(window).outerWidth() > 200) && ($(window).outerWidth() <= 500)) {
                if (!this.popup.hasClass("e-dt-responsive")) {
                    this.popup.addClass("e-dt-responsive");
                    this.timePicker.option("popupWidth", this.datePicker.popup.outerWidth());
                    this.timePicker.option("popupHeight", 98);
                    this.timePicker._refreshScroller();
                    this.timePicker._changeActiveEle();
                }
            }
            else if (this.popup.hasClass("e-dt-responsive")) {
                this.popup.removeClass("e-dt-responsive");
                this.timePicker.option("popupWidth", this.model.timePopupWidth);
                var height = this.datePicker.popup.height() - this.popup.find(".e-header").height();
                this.timePicker.option("popupHeight", height);
                this.timePicker._refreshScroller();
                this.timePicker._changeActiveEle();
            }
        },

        enable: function () {
            if (!this.model.enabled) {
                this.element[0].disabled = false;
                this.model.enabled = true;
                this.element.prop("disabled", false);
                this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable").attr("aria-disabled", false);
                if (!this._isSupport)
                    this._hiddenInput.prop("disabled", false);
                if (this.datetimeIcon) this.datetimeIcon.removeClass("e-disable").attr("aria-disabled", false);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().removeClass("e-disable");
                if (this.popup) {
                    this.popup.children("div").removeClass("e-disable").attr("aria-disabled", false);
                    this._change("enabled", true);
                }
            }
        },


        disable: function () {
            if (this.model.enabled) {
                this.element[0].disabled = true;
                this.model.enabled = false;
                this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable").attr("aria-disabled", true);
                this.element.attr("disabled", "disabled");
                if (!this._isSupport)
                    this._hiddenInput.attr("disabled", "disabled");
                if (this.datetimeIcon) this.datetimeIcon.addClass("e-disable").attr("aria-disabled", true);
                if (this._isIE8 && this.datetimeIcon) this.datetimeIcon.children().addClass("e-disable");
                this._hideResult();
                this._change("enabled", false);
                if (this.popup) {
                    this.popup.children("div").addClass("e-disable").attr("aria-disabled", true);
                    this.datePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
                    this.timePicker.popup.removeClass("e-disable").attr("aria-disabled", false);
                }
            }
        },


        getValue: function () {
            return this._objectToString(this.model.value);
        },


        setCurrentDateTime: function () {
            if (!this.model.readOnly)
                this._setValue(new Date());
        },


        show: function () {
            this._showResult();
        },


        hide: function () {
            this._hideResult();
        },


        _wireEvents: function () {
            if (this.model.allowEdit) {
                this._on(this.element, "focus", this._targetFocus);
                this._on(this.element, "blur", this._targetBlur);
                this._on(this.element, "keydown", this._keyDownOnInput);
            }
            if (!this.model.allowEdit) {
                this.element.attr("readonly", "readonly");
                this.element.on("mousedown", $.proxy(this._showhidePopup, this));
            }


        },

        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        }
    });

    ej.DateTimePicker.Locale = ej.DateTimePicker.Locale || {};

    ej.DateTimePicker.Locale['default'] = ej.DateTimePicker.Locale['en-US'] = {
        watermarkText: "Select datetime",
        buttonText: {
            today: "Today",
            timeNow: "Time Now",
            done: "Done",
            timeTitle: "Time"
        }
    };

    ej.PopupPosition = {
        Bottom: "bottom",
        Top: "top"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to create the Gantt
* @copyright Copyright Syncfusion Inc. 2001 - 2013. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/

(function ($, ej, undefined) {
    'use strict';
    ej.widget("ejGantt", "ej.Gantt", {

        // widget element will be automatically set in this
        _rootCSS: "e-gantt",

        element: null,

        validTags: ["div"],
        // user defined model will be automatically set in this
        model: null,
        _tags: [{
            tag: "holidays",
            attr: ["day", "background", "label"],
            content: "template"
        },
        {
            tag: "stripLines",
            attr: ["day", "label", "lineStyle", "lineColor", "lineWidth"],
            content: "template"
        },
         {
             tag: "editDialogFields",
             attr: ["field", "editType"],
             content: "template"
         },
         {
             tag: "addDialogFields",
             attr: ["field", "editType"],
             content: "template"
         },
         {
             tag: "sortSettings.sortedColumns",
             attr: ["field","direction"]
         },
         {
             tag: "dayWorkingTime",
             attr: ["from", "to"],
             singular: "dayWorkingTime"
         }
        ],
        _holidays: function (index, property, value, old) {
            this._$ganttchartHelper.ejGanttChart("refreshHolidays");
            this._trigger("refresh");
        },
        _stripLines: function (index, property, value, old) {
            this._$ganttchartHelper.ejGanttChart("refreshStripLines");
            this._trigger("refresh");
        },
        _editDialogFields: function (index, property, value, old) {
            this._trigger("refresh");
        },
        _addDialogFields: function (index, property, value, old) {
            this._trigger("refresh");
        },
        defaults: {
            expandStateMapping:"",
            allowSorting: false,
            allowColumnResize: false,
            allowSelection: true,
            allowMultipleExporting: false,
            allowDragAndDrop: false,
            dragTooltip: {
                showTooltip: false,
                tooltipItems: [],
                tooltipTemplate: "",
            },
            dataSource: null,
            showColumnChooser: false,
            showColumnOptions: false,
            query: null,
            splitterSettings: {
                position: "",
                index: -1
            },
            splitterPosition: "",
            taskIdMapping: "",
            parentTaskIdMapping: "",
            taskNameMapping: "",
            startDateMapping: "",
            endDateMapping: "",
            baselineStartDateMapping: "",
            baselineEndDateMapping: "",
            childMapping: "",
            durationMapping: "",
            milestoneMapping: "",
            progressMapping: "",
            predecessorMapping: "",
            resourceInfoMapping: "",
            taskSchedulingModeMapping: "",
            workMapping: "",
            notesMapping:"",
            resources: [],
            holidays: [],
            searchSettings: {
                fields: [],
                key: "",
                operator: "contains",
                ignoreCase: true
            },
            highlightWeekends: true,
            scheduleStartDate: null,
            scheduleEndDate: null,
            enableProgressBarResizing: true,
            rowHeight: 30,
            includeWeekend: true,
            taskSchedulingMode: "auto",
            validateManualTasksOnLinking: false,
            toolbarSettings: {
                showToolbar: false,
                toolbarItems: [],
                customToolbarItems: []
            },
            stripLines: [],
            workingTimeScale: 'TimeScale8Hours',
            roundOffDayworkingTime: true,
            durationUnit: 'day',
            workUnit: 'hour',
            taskType: "fixedUnit",
            perMinuteWidth: null,
            perHourWidth: null,
            perDayWidth: null,
            perWeekWidth: null,
            perMonthWidth: null,
            minuteInterval: null,
            scheduleHeaderSettings:
            {
                weekHeaderFormat: "MMM dd , yyyy",
                dayHeaderFormat: "",
                yearHeaderFormat: "yyyy",
                monthHeaderFormat: "MMM",
                hourHeaderFormat: 'HH',
                scheduleHeaderType: 'week',
                minutesPerInterval: "auto",
                weekendBackground: '',
                timescaleStartDateMode: "auto",
                timescaleUnitSize:"100%",
                weekStartDay: 0
            },
            taskbarBackground: "",
            progressbarBackground: "",
            connectorLineBackground: "",
            parentTaskbarBackground: "",
            parentProgressbarBackground: "",
            connectorlineWidth: 1,
            readOnly:false,
            showTaskNames: true,
            leftTaskLabelMapping: "",
            rightTaskLabelMapping: "",
            leftTaskLabelTemplate: "",
            rightTaskLabelTemplate: "",
            showGridCellTooltip: false,
            cellTooltipTemplate:null,
            showGridExpandCellTooltip: false,
            showProgressStatus: true,
            showResourceNames: true,
            enableTaskbarDragTooltip: true,
            enableTaskbarTooltip: true,
            enableWBS:false,
            enableWBSPredecessor:false,
            editSettings: {
                allowEditing: false,
                allowAdding: false,
                allowDeleting: false,
                allowIndent: false,               
                editMode: "normal",
                beginEditAction: "dblclick",
                rowPosition: "belowselectedrow"
            },
            flatRecords: [],
            parentRecords: [],
            currentViewData: [],
            updatedRecords: [],
            ids: [],
            allowKeyboardNavigation: true,
            cssClass: "",
            locale: "en-US",
            allowMultiSorting: false,
            sortSettings: {
                sortedColumns: []
            },
            enableAltRow: true,
            enableVirtualization: false,
            progressbarHeight: 100,
            taskbarTooltipTemplate: "",
            progressbarTooltipTemplate: "",
            taskbarTooltipTemplateId: "",
            dateFormat: "",
            resourceIdMapping: "",
            resourceNameMapping: "",
            resourceUnitMapping: "",
            progressbarTooltipTemplateId: "",
            taskbarEditingTooltipTemplateId: "",
            taskbarEditingTooltipTemplate: "",
            selectedRowIndex: -1,
            allowGanttChartEditing: true,
            sizeSettings: {
                height: "",
                width: "",
            },
            selectedItem: null,
            selectionType: "single",
            selectionMode: "row",
            selectedCellIndexes: [],
            weekendBackground: "",
            baselineColor: '#fba41c',
            treeColumnIndex: 0,
            editDialogFields: [],
            addDialogFields: [],
            columnDialogFields: [],
            renderBaseline: false,
            enableContextMenu: false,
            enableResize: true,
            isResponsive: true,
            enableCollapseAll: false,
            enablePredecessorValidation: true,
            taskbarTemplate: "",
            parentTaskbarTemplate: "",
            milestoneTemplate: "",
            durationUnitMapping: "",
            dayWorkingTime: [{ "from": "08:00 AM", "to": "12:00 PM" }, { "from": "01:00 PM", "to": "05:00 PM" }],//, { from: "4:00 PM", to: "5:00 PM" }
            exportToExcelAction: "",
            exportToPdfAction: "",
            workWeek: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"],
            /*Events*/
            rowSelecting: null,
            rowSelected: null,
            rowDragStart: null,
            rowDrag: null,
            rowDragStop: null,
            cellSelecting: null,
            cellSelected: null,
            queryCellInfo: null,
            queryTaskbarInfo: null,            
            beginEdit: null,
            endEdit: null,
            rowDataBound: null,
            expanding: null,
            expanded: null,
            collapsing: null,
            collapsed: null,
            actionBegin: null,
            actionComplete: null,
            taskbarEditing: null,
            taskbarEdited: null,
            load: null,
            create:null,
            contextMenuOpen: null,
            taskbarClick: null,
            taskbarHeight: 20,
            criticalTask: "",
            toolbarClick: null,
        },

        dataTypes: {
            allowSorting: "boolean",
            allowColumnResize: "boolean",
            allowSelection: "boolean",
            dataSource: "data", //inline or remote data
            query: "data",
            taskIdMapping: "string",
            parentTaskIdMapping: "string",
            taskNameMapping: "string",
            startDateMapping: "string",
            endDateMapping: "string",
            baselineStartDateMapping: "string",
            baselineEndDateMapping: "string",
            childMapping: "string",
            durationMapping: "string",
            milestoneMapping: "string",
            progressMapping: "string",
            predecessorMapping: "string",
            resourceInfoMapping: "string",
            taskSchedulingModeMapping: "string",
            notesMapping: "string",
            workMapping: "string",
            resources: "array",
            holidays: "array",
            dayWorkingTime: "array",
            highlightWeekends: "boolean",
            scheduleStartDate: "data",
            scheduleEndDate: "data",
            enableProgressBarResizing: "boolean",
            rowHeight: "number",
            includeWeekend: "boolean",
            taskSchedulingMode: "string",
            validateManualTasksOnLinking: "boolean",
            toolbarSettings: {
                showToolbar: "boolean",
                toolbarItems: "array",
                customToolbarItems: "array"
            },
            stripLines: "array",
            scheduleHeaderSettings: "data",
            roundOffDayworkingTime: "boolean",
            taskbarBackground: "string",
            progressbarBackground: "string",
            connectorLineBackground: "string",
            parentTaskbarBackground: "string",
            parentProgressbarBackground: "string",
            connectorlineWidth: "number",
            readOnly:"boolean",
            showTaskNames: "boolean",
            leftTaskLabelMapping: "string",
            rightTaskLabelMapping: "string",
            leftTaskLabelTemplate: "string",
            rightTaskLabelTemplate: "string",
            showProgressStatus: "boolean",
            showResourceNames: "boolean",
            enableTaskbarDragTooltip: "boolean",
            enableTaskbarTooltip: "boolean",
            editSettings: "data",
            flatRecords: "array",
            parentRecords: "array",
            currentViewData: "array",
            ids: "array",
            updatedRecords: "array",
            allowKeyboardNavigation: "boolean",
            cssClass: "string",
            locale: "string",
            allowMultiSorting: "boolean",
            showGridExpandCellTooltip: "boolean",
            sortSettings: {
                sortedColumns: "array"
            },
            enableAltRow: "boolean",
            enableVirtualization: "boolean",
            progressbarHeight: "number",
            taskbarTooltipTemplate: "string",
            progressbarTooltipTemplate: "string",
            taskbarTooltipTemplateId: "string",
            dateFormat: "string",
            resourceIdMapping: "string",
            resourceNameMapping: "string",
            resourceUnitMapping: "string",
            progressbarTooltipTemplateId: "string",
            taskbarEditingTooltipTemplateId: "string",
            taskbarEditingTooltipTemplate: "string",
            allowGanttChartEditing: "boolean",
            size: {
                height: "string",
                width: "string"
            },            
            weekendBackground: "string",
            baselineColor: "string",
            renderBaseline: "boolean",
            enableContextMenu: "boolean",
            showGridCellTooltip: "boolean",
            treeColumnIndex: "number",
            editDialogFields: "array",
            addDialogFields: "array",
            showColumnChooser: "boolean",
            enableResize: "boolean",
            isResponsive: "boolean",
            enableCollapseAll: "boolean",
            enablePredecessorValidation: "boolean",
            durationUnitMapping: "string",
            taskbarTemplate: "string",
            parentTaskbarTemplate: "string",
            milestoneTemplate: "string",
            taskbarHeight: "number",
            criticalTask: "string",
            workWeek:"array"
        },
        ignoreOnExport: [
            "isEdit", "toolbarClick", "query", "queryCellInfo", "selectionType", "currentViewData", "enableRTL", "rowDataBound",
              "editSettings", "localization", "cssClass", "dataSource", "allowKeyboardNavigation"
        ],
        observables: ["selectedItem", "selectedRowIndex", "selectedCellIndexes", "splitterPosition", "dataSource","splitterSettings.position"],
        selectedItem: ej.util.valueFunction("selectedItem"),
        selectedRowIndex: ej.util.valueFunction("selectedRowIndex"),
        selectedCellIndexes: ej.util.valueFunction("selectedCellIndexes"),
        splitterPosition: ej.util.valueFunction("splitterSettings.position"),
        dataSource: ej.util.valueFunction("dataSource"),
        _splitterPosition: ej.util.valueFunction("splitterPosition"),

        //Retruns column value
        getColumns: function () {
            return this._columns;
        },
        //set column value
        setColumns: function(value) {
            this._columns = value;
        },

        // Initialize values to header Text and Gantt records for custom columns alone
        customColumnFields: function () {
            var proxy = this,
                totalColumns = proxy._columns, totalColumnsLength = totalColumns.length;

            for (var i = 0; i < totalColumnsLength; i++)
            {
                if (!proxy._columnHeaderTexts[totalColumns[i].field]) {
                    proxy._columnHeaderTexts[totalColumns[i].field] = totalColumns[i].headerText;
                }
            }           
        },

        //Control Rendering is initiated
        _init: function () {
            var proxy = this,
                model = proxy.model, startDate, endDate,interval = model.scheduleHeaderSettings.minutesPerInterval,
                durationUnit = model.durationUnit;

            //Default data source for ASP designer
            if (model.isdesignMode) {
                model.taskIdMapping = "Id";
                model.taskNameMapping = "Name";
                model.startDateMapping = "StartDate";
                model.durationMapping = "Duration";
                model.progressMapping = "Progress";
                model.scheduleStartDate = "02/23/2014";
                model.scheduleEndDate = "03/10/2014";
                this.dataSource([{ Id: 1, Name: "Task 1", StartDate: "02/23/2014", Duration: 5, Progress: 40 },
                { Id: 2, Name: "Task 2", StartDate: "02/24/2014", Duration: 5, Progress: 40 },
                { Id: 3, Name: "Task 3", StartDate: "02/25/2014", Duration: 5, Progress: 40 }]);
                model.sizeSettings.height = "300px";
                model.sizeSettings.width = "800px";
            }

            if (!(model.scheduleStartDate || model.scheduleEndDate) && interval == "auto")
                model.scheduleHeaderSettings.minutesPerInterval = ej.Gantt.minutesPerInterval.FiveMinutes;
            if (model.workMapping != "")
                model.taskType = ej.Gantt.TaskType.FixedWork;
            proxy._initPrivateProperties();
            //Load event triggered
            proxy._trigger("load");
            proxy.element.addClass("e-gantt-core");
            //Set the workWeek when workWeek is empty
            if (model.workWeek.length == 0)
                model.workWeek = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"];
            proxy._getNonWorkingDayIndex();
            if (this.dataSource() !== null) {
                this._checkDataBinding();
            }
            else {
                proxy._initialize();
            }
        },
        /*set taskbar height at load time*/
        _setTaskbarHeight: function (height) {

            if (height < this.model.rowHeight)
                this.taskbarHeight = height;
            else
                this.taskbarHeight = this.model.rowHeight;
            /*MilesStone width as by rowHeight*/
            this._milesStoneWidth = (Math.floor(this.taskbarHeight / 2) * 2);
        },
        //clear selected item
        _deSelectRowItem: function () {
            var proxy = this, model = proxy.model;
            proxy._$ganttchartHelper.ejGanttChart("selectRows", -1);
            proxy._$treegridHelper.ejTreeGrid("selectRows", -1);
            this.selectedRowIndex(-1);
            model.selectedItem = null;
        },
        
        //populate gantt records from data source
        _checkDataBinding: function () {
            var proxy = this, model = proxy.model;
           
            if (this.dataSource() == null) {
                this.dataSource([]);
            }
            if (this.dataSource() instanceof ej.DataManager) {
                this._initDataSource();
            }
            else if (this.dataSource().length > 0) {
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    var dataArray = proxy._retrivedData = proxy.dataSource(), data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (!ej.isNullOrUndefined(tempData[model.taskIdMapping])) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }
                  
                    if (!model.childMapping) model.childMapping = "Children";                                        
                    proxy._reconstructDatasource(data);
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                }
                else {
                    proxy._createGanttRecords(this.dataSource());
                }
                proxy._initialize();
            }
            else {
                proxy._initialize();
            }
        },

        //Create gantt records and render gantt if data source is remote data
        _initDataSource: function () {
            var proxy = this, model = proxy.model;     
            var query = this._columnToSelect();
            var queryPromise = this.dataSource().executeQuery(query);
            queryPromise.done(ej.proxy(function (e) {
                if (proxy.dataSource().dataSource.offline) {
                    proxy._retrivedData = proxy.dataSource().dataSource.json;
                } else {
                    proxy._retrivedData = e.result;
                }
               
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    //cloning the datasource
                    var dataArray = e.result, data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }
                    if (!model.childMapping) {
                        model.childMapping = "Children";
                    }
                    proxy._reconstructDatasource(data);
                }
                else {
                    proxy.secondaryDatasource = proxy._retrivedData;
                }
                proxy._createGanttRecords(proxy.secondaryDatasource);
                proxy._initialize();
            }));
        },

        //create ejQuery when remote data is initiated
        _columnToSelect: function () {
            var proxy = this,
                model = proxy.model,
                column = [], queryManager = ej.Query();

            queryManager = model.query ? model.query : queryManager;
            return queryManager;
        },

        //Ensure the predecessor ids and characters in string
        _ensurePredecessorCollection: function () {
            var proxy = this, model = proxy.model,
                predecessorsCollection = proxy._predecessorsCollection,
                plength = predecessorsCollection.length - 1;            
            for (var f = plength; f >= 0; f--) {
                var record = predecessorsCollection[f],
                    predecessors = record.predecessorsName;
                if (predecessors && predecessors.length) {
                    record.predecessor = record._calculatePredecessor(predecessors, proxy._durationUnitEditText, model.durationUnit, proxy);
                    if (!proxy._isValidPredecessorString) {
                        var ptxt = proxy._getPredecessorStringValue(record);
                        record.predecessorsName = ptxt;
                        record.item.predecessor = ptxt;
                        proxy._isValidPredecessorString = true;
                    }
                }
            }            
        },

        _intersectionObjects: function (flatCollection, rootCollection) {
            var result = [];
            while (flatCollection.length > 0 && rootCollection.length > 0) {
                var index = rootCollection.indexOf(flatCollection[0]);
                if (index == -1) {
                    flatCollection.shift();
                }
                else {
                    result.push(flatCollection.shift());
                    rootCollection.splice(index, 1);
                }
            }

            return result;
        },

        //If parentIdMapping is given data source is changed in hierarchical order
        _reconstructDatasource: function (datasource) {
            var proxy = this, model = proxy.model,
                data, filter;

            filter = ej.Predicate(model.parentTaskIdMapping, ej.FilterOperators.notEqual, "null");
            data = ej.DataManager(datasource).executeLocal(ej.Query().where(filter).group(model.parentTaskIdMapping));
            var tempParent = [];
            for (var i = 0; i < data.length; i++) {
                if (!ej.isNullOrUndefined(data[i].key)) {

                    var index = proxy._taskIds.indexOf(data[i].key);
                    if (index > -1) {
                        datasource[index][model.childMapping] = data[i].items;
                        continue;
                    }
                }
                var items = data[i].items;
                for (var item in data[i].items)
                    tempParent.push(items[item]);
            }
            proxy.secondaryDatasource = proxy._intersectionObjects(datasource, tempParent);
        },       

        //refresh the chart with updated schedule dates
        updateScheduleDates: function (startDate, endDate) {
            
            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType;
            model.scheduleStartDate = startDate;
            model.scheduleEndDate = endDate;
            proxy._scheduleDays = [];
            proxy._scheduleMonths = [];
            proxy._scheduleWeeks = [];
            proxy._scheduleYears = [];
            proxy._scheduleHours = [];
            proxy._scheduleMinutes = [];
            proxy._calculateHeaderDates();
            var chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance");
            var chartModel = chartObject.model;
            /* No need to re render parent item , because all the records are rerendered*/
            proxy._isTreeGridRendered = false;
            proxy._isGanttChartRendered = false;
            proxy._isChartRendering = true;
            proxy._updateGanttRecords();
            chartModel.projectStartDate = proxy._getDateFromFormat(proxy._projectStartDate);
            chartModel.projectEndDate = proxy._getDateFromFormat(proxy._projectEndDate);
            chartModel.scheduleDays = proxy._scheduleDays;
            chartModel.scheduleMonths = proxy._scheduleMonths;
            chartModel.scheduleWeeks = proxy._scheduleWeeks;
            chartModel.scheduleYears = proxy._scheduleYears;
            chartModel.scheduleHours = proxy._scheduleHours;
            chartModel.scheduleMinutes = proxy._scheduleMinutes;
            chartModel.renderBaseline = model.renderBaseline;
            chartModel.scheduleHeaderSettings.scheduleHeaderType = scheduleHeaderType;
            if (scheduleHeaderType == "week") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.weekHeaderFormat = model.scheduleHeaderSettings.weekHeaderFormat;
                chartModel.scheduleHeaderSettings.dayHeaderFormat = model.scheduleHeaderSettings.dayHeaderFormat;
                chartModel.durationUnit = model.durationUnit;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "day") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.dayHeaderFormat = model.scheduleHeaderSettings.dayHeaderFormat;
                chartModel.scheduleHeaderSettings.hourHeaderFormat = model.scheduleHeaderSettings.hourHeaderFormat;
                chartModel.durationUnit = model.durationUnit;
                chartModel.perHourWidth = proxy._perHourWidth;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "hour") {
                chartModel.dateFormat = model.dateFormat;
                chartModel.durationUnit = ej.Gantt.DurationUnit.Minute;
                chartModel.scheduleHeaderSettings.minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval;
                chartModel.workingTimeScale = model.workingTimeScale;
                chartModel.minuteInterval = proxy._minuteInterval;
                chartModel.perMinuteWidth = proxy._perMinuteWidth;
                chartModel.perDayWidth = proxy._perDayWidth;
            }
            else if (scheduleHeaderType == "month") {
                chartModel.durationUnit = model.durationUnit;
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.monthHeaderFormat = model.scheduleHeaderSettings.monthHeaderFormat;
                chartModel.scheduleHeaderSettings.weekHeaderFormat = model.scheduleHeaderSettings.weekHeaderFormat;
                chartModel.perDayWidth = proxy._perDayWidth;
                chartModel.perWeekWidth = proxy._perWeekWidth;
            }
            else if (scheduleHeaderType == "year") {
                chartModel.durationUnit = model.durationUnit;
                chartModel.dateFormat = model.dateFormat;
                chartModel.scheduleHeaderSettings.yearHeaderFormat = model.scheduleHeaderSettings.yearHeaderFormat;
                chartModel.perDayWidth = proxy._perDayWidth;
                chartModel._perMonthWidth = proxy._perMonthWidth;
            }
            $("#ejGanttChart" + proxy._id).ejGanttChart("refreshChartHeader", proxy._getDateFromFormat(startDate), proxy._getDateFromFormat(endDate));
            $("#ejGanttChart" + proxy._id).ejGanttChart("refreshContainersWidth");
            proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
            if (model.predecessorMapping) {
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._isValidationEnabled = false;
                proxy._createConnectorLinesCollection();
                proxy._isValidationEnabled = true;
            }
            chartObject._$bodyContainer.ejScroller("refresh");

            proxy._isTreeGridRendered = true;
            proxy._isGanttChartRendered = true;
            proxy._isChartRendering = false;
        },
        //used to change the schedule mode dynamically
        
        reRenderChart: function (scheduleMode) {
            var proxy = this, model = proxy.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate);
            model.flatRecords = [];
            model.parentRecords = [];
            $("#ejGanttChart" + proxy._id).empty();

            switch (scheduleMode) {
                case ej.Gantt.ScheduleHeaderType.Week:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._calculateWeekSplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Day:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Day;
                    proxy._perHourWidth = model.perHourWidth;
                    proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
                    proxy._calculateDaySplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Month:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Month;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._perWeekWidth = model.perWeekWidth;
                    proxy._calculateMonthSplit(startDate, endDate);
                    break;

                case ej.Gantt.ScheduleHeaderType.Year:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Year;
                    proxy._perDayWidth = model.perDayWidth;
                    proxy._perMonthWidth = model.perMonthWidth;
                    proxy._calculateYearSplit(startDate, endDate);
                    break;
                case ej.Gantt.ScheduleHeaderType.Hour:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Hour;
                    var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                        intervalValue = ej.Gantt.minutesPerInterval;
                    proxy._perMinuteWidth = model.perMinuteWidth;
                    if (minutesPerInterval) {
                        if (minutesPerInterval == intervalValue.Auto) {
                            var twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                                sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                                tenDaysTimeSpan = 10 * 86400000,
                                diff = endDate - startDate;

                            if (diff > tenDaysTimeSpan) {
                                proxy._minuteInterval = 30;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                            }
                            else if (diff > sevenDaysTimeSpan) {
                                proxy._minuteInterval = 15;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                            }
                            else if (diff > twoDaysTimeSpan) {
                                proxy._minuteInterval = 5;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                            }
                            else {
                                proxy._minuteInterval = 1;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                            }
                        }
                        else if (minutesPerInterval == intervalValue.OneMinute) {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                        }
                        else if (minutesPerInterval == intervalValue.FiveMinutes) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                    }
                    proxy._calculateHourSplit(startDate, endDate);
                    break;
            }
            proxy.element.ejGantt("destroy").ejGantt(model);
            proxy._isTreeGridRendered = false;
            proxy._isGanttChartRendered = false;

        },

        changeTaskMode:function(record, taskMode){
            var proxy = this, model = proxy.model, args = {};
            args.data = record;

            proxy._isValidationEnabled = true;
            if (taskMode == ej.Gantt.TaskSchedulingMode.Manual) {
                record.isAutoSchedule = false;
                record.item[model.taskSchedulingModeMapping] = true;                
            }
            else if (taskMode == ej.Gantt.TaskSchedulingMode.Auto) {
                record.isAutoSchedule = true;
                record.item[model.taskSchedulingModeMapping] = false;                
            }
            args.columnName = "taskMode";
            proxy._updateEditedGanttRecords(args,true);
            proxy._isValidationEnabled = false;
        },
        autoSchedule: function (taskId) {
            var proxy = this, model = proxy.model, targetRecord,
                updatedRecords = model.updatedRecords;
            targetRecord = updatedRecords.filter(function (record) {
                return record.taskId === taskId;
            });
            proxy.changeTaskMode(targetRecord[0], ej.Gantt.TaskSchedulingMode.Auto);
        },
        manualSchedule: function (taskId) {
            var proxy = this, model = proxy.model, targetRecord,
                updatedRecords = model.updatedRecords;
            targetRecord = updatedRecords.filter(function (record) {
                return record.taskId === taskId;
            });
            proxy.changeTaskMode(targetRecord[0], ej.Gantt.TaskSchedulingMode.Manual);
        },
        //update the all gantt records width,progresswidth and left value
        _updateGanttRecords: function () {

            var proxy = this, model = proxy.model,
                flatRecords = model.flatRecords,
                length = flatRecords.length,
                currentRecord, parentItem, childRecords;
          
            for (var i = 0; i < length; i++) {
                currentRecord = flatRecords[i];
                if (currentRecord.hasChildRecords === false) {
                    currentRecord.left = currentRecord._calculateLeft(this);
                    currentRecord.width = currentRecord._calculateWidth(this);
                    currentRecord.width = currentRecord.isMilestone == true ? proxy._milesStoneWidth : model.flatRecords[i].width;
                    currentRecord.progressWidth = currentRecord._getProgressWidth(currentRecord.width, currentRecord.status);
                }
                if (currentRecord.baselineStartDate && currentRecord.baselineEndDate) {
                    currentRecord.baselineLeft = currentRecord._calculateBaselineLeft(this);
                    currentRecord.baselineRight = currentRecord._calculateBaselineRight(this);
                    currentRecord.baselineWidth = currentRecord._calculateBaseLineWidth(this);
                } else {
                    currentRecord.baselineLeft = 0;
                    currentRecord.baselineRight = 0;
                    currentRecord.baselineWidth = 0;
                }

                parentItem = currentRecord.parentItem;
                childRecords = parentItem && parentItem.childRecords;

                if (parentItem && childRecords.indexOf(currentRecord) == childRecords.length - 1 && currentRecord.hasChildRecords === false) {
                    if (parentItem.isAutoSchedule)
                        proxy._updateParentItem(currentRecord);
                    else
                        proxy._updateManualParentItem(currentRecord);
                }                
            }

        },
        
        //Method for initialize private peoperties
        _initPrivateProperties: function () {

            var proxy = this,
                model = proxy.model,
            scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType;
            proxy._isFromGantt = true;
            proxy._disabledToolItems = [],
            proxy._id = proxy.element.attr('id'),
            proxy._scheduleWeeks = [],
            proxy._taskIds = [],
            proxy._duplicate = false,          
            proxy._wrongenddate=false,
            proxy._addPosition = null,
            proxy._datePickerChangeEvent=false,
            proxy._scheduleYears = [],//new property for year schedule modes

            proxy._scheduleMonths = [], //new property for month

            proxy._scheduleYears = [],//property for schedule years
            proxy._scheduleDays = [],//property for schedule days
            proxy._scheduleHours=[],
            proxy._projectStartDate, //property instead of scheduleWeeks[0] and scheduleYears[0]
            proxy._projectEndDate,

            proxy._columns = [],
            proxy._storedIndex = -1,
            proxy._perDayWidth,
            proxy._prevDayWidth = 0,
            proxy._rowIndexOfLastSelectedCell = -1,
            proxy._perMonthWidth,//new property for month
            proxy._perWeekWidth,//new property for month-week schedule

            proxy._$treegridPane = null,
            proxy._$ganttchartPane = null,
            proxy._$treegridHelper = null,
            proxy._$ganttchartHelper = null,
            proxy._$ejGantt = null,
            proxy._tdsOffsetWidth = [];
            proxy._subPosx = [];
            proxy._predecessorsCollection = [];
            proxy._connectorLinesCollection = [];            
            proxy._updatedConnectorLineCollection = [];
            proxy._connectorlineIds = [];
            proxy._gridRows = null;

            //variables used for ExpandCollapse action in non Virtualization 
            proxy._collapsedRecordCount = 0;
            proxy._expandedRecordsCount = 0;
            proxy._totalCollapseRecordCount = 0;
            proxy._isInExpandCollapse = false;

            proxy._hiddenRecordCount = 0;
            proxy._validationRuleOptions = null;
            proxy._validationDialogTitle = null;
            proxy._validationRuleText = null;
            proxy.prevPredecessorTO = null;
            proxy.prevPredecessorFrom = null;
            proxy.prevPredecessorcount = 0;
            proxy._isValidationEnabled = true;
            proxy._isTreeGridRendered = false;//indicate treegrid part is rendered or not for refresh row
            proxy._isGanttChartRendered = false;//indicate gantChart part is rendered or not
            proxy._isChartRendering = false;//To check chart is re-rendering for timescale unit size
            proxy._holidaysList = proxy._getHoliday();
            proxy._stringHolidays = proxy._getStringHolidays();
            proxy._isinBeginEdit = false;
            proxy._isMileStoneEdited = false;
            proxy._cellEditColumn = null;
            proxy._isinAddnewRecord = false;
           
            //variables for context menu items
            proxy._contextMenuItems = null; //proxy._getContextMenuItems();
            proxy._totalBorderWidth = 2;//Left and Right border width

            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 3 : 2;//top,bottom,toolbar div
            } else {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 1 : 0;//top box-sizing:border-box includes it's border
            }
            //private variable decalartion for localization
            proxy._columnHeaderTexts = null;
            proxy._predecessorEditingTexts = null;
            proxy._editDialogTexts = null;
            proxy._toolboxTooltipTexts = null;
            proxy._durationUnitTexts = null;
            proxy._durationUnitEditText = null;
            proxy._workUnitTexts = null;
            proxy._taskTypeTexts = null;
            proxy._effortDrivenTexts = null;
            proxy._contextMenuTexts = null;
            proxy._columnMenuTexts = null;
            proxy._editTypeText = null;
            proxy._clipModeText = null;
            proxy._textAlignTypeText = null;
            proxy._columnDialogTitle = null;
            proxy._deleteColumnText = null;
            proxy._okButtonText = null;
            proxy._cancelButtonText = null;
            proxy._confirmDeleteText = null;
            proxy._columnDialogTexts = null;
            proxy._newTaskTexts = null;
            proxy._months = null;  
            proxy._days = null;
            proxy._dialogTabTitleTexts = null;
            proxy._isLoad = true;
            proxy._updatedColumn = "";
            proxy._isExistingUnitIsUpdated = false;
            proxy._isDurationUpdated = false;
            proxy._isResourceAddedOrRemoved = false;
            proxy._newRecordResourceCollection = [];//maintan newly added row resources and its units.

            /*alert text localization*/
            proxy._alertTexts = null;

            proxy._commonColumnWidth = 150;
            proxy._searchString = "",
            proxy._emptyDataColumns = [],
            proxy.secondaryDatasource = [];
            proxy._datasourceChildItems = [];
            proxy._$predecessorTable = null;
            proxy._mappingItems = [];
            proxy._editedDialogRecord = null;
            proxy._calculateDimensions();
            proxy._retrivedData = this.dataSource();
            proxy._isInExpandCollapseAll = false;
            proxy._preTableCollection = [];
            proxy._defaultStartTime = null;
            proxy._defaultEndTime = null;
            proxy._workingTimeRanges = [];
            proxy._nonWorkingHours = [];
            this._validateTimeRange();
            //deprecate working timescaale API with dayWorkingTime API
            if (JSON.stringify(model.dayWorkingTime) == '[{\"from\":\"08:00 AM\",\"to\":\"12:00 PM\"},{\"from\":\"01:00 PM\",\"to\":\"05:00 PM\"}]') {
                if (model.workingTimeScale != ej.Gantt.workingTimeScale.TimeScale8Hours)
                    model.dayWorkingTime = [{ from: "12:00 AM", to: "12:00 AM" }];
                else
                    model.dayWorkingTime = [{ from: "08:00 AM", to: "12:00 PM" }, { from: "01:00 PM", to: "05:00 PM" }];
            }
            proxy._secondsPerDay = proxy._getSecondsPerDay();
            proxy._timelineWidthCalculation();
            proxy._localizedLabels = proxy._getLocalizedLabels();
            //culture info assigned for private variables
            proxy._setCultureInfo();
            //Column collection populated
            proxy.setColumns(model.columns && model.columns.length ? model.columns : proxy.createTreeGridColumns());

            //update columns dropdown data while changing localization dynamically.
            if (model.isRerender)
                proxy._updateColumnDropDownData();

            proxy._updateColumnLocaleText();
            /* flag for refreshing newly added record */
            proxy._isRefreshAddedRecord = false;
            /* Used as flag for refresh chart and grid rows on adding when parent item is in collpased state*/
            proxy._isInAdd = false;
            //context menu sctive item's ID
            proxy._activeMenuItemId = null;
            proxy._isAddEditDialogSave = false;
            proxy._setTaskbarHeight(model.taskbarHeight);            
            proxy.isCriticalPathEnable = false;
            proxy.criticalPathCollection = [];
            proxy.detailPredecessorCollection = [];
            proxy.collectionTaskId = [];
            proxy._isValidPredecessorString = true;
            proxy._enableDisableCriticalIcon = false;
            proxy._generalTabColumnFields = [];
            proxy._addDialogGeneralColumns = [];
            proxy._addDialogcustomColumns = [];
            proxy._editDialogGeneralColumns = [];
            proxy._editDialogCustomColumns = [];
            //update resource unit mapping value
            if (model.resourceUnitMapping == "")
                model.resourceUnitMapping = "unit";
            proxy._dialogTab = ["General", "Predecessors", "Resources", "Custom Fields", "Notes"];
            proxy._cssClass = model.cssClass;
            proxy._actionCompleteData = []; //collection of actionCompelte data
            proxy._isLastRefresh = false; // used for check the refreshGanttRecord method is called last time.
            proxy._nonWorkingDayIndex = [];
            proxy._lastInsertedId = -1;
        },
        //Update all the private variables widths to model
        _updateModelsWidth: function () {
            var proxy = this, model = proxy.model;
            model.perDayWidth = proxy._perDayWidth ? proxy._perDayWidth : null;
            model.perMonthWidth = proxy._perMonthWidth ? proxy._perMonthWidth : null;
            model.perWeekWidth = proxy._perWeekWidth ? proxy._perWeekWidth : null;
            model.perHourWidth = proxy._perHourWidth ? proxy._perHourWidth : null;
            model.perMinuteWidth = proxy._perMinuteWidth ? proxy._perMinuteWidth : null;
            model.minuteInterval = proxy._minuteInterval ? proxy._minuteInterval : null;
        },
        //Gantt chart timeline width calculation
        _timelineWidthCalculation: function (scaleSize) {
            var proxy = this, model = proxy.model,
                fitTimescaleSize = true,
                scheduleMode = model.scheduleHeaderSettings.scheduleHeaderType,
                timescaleUnitSize = model.scheduleHeaderSettings.timescaleUnitSize,
                timescaleUnitSizeStr = timescaleUnitSize.toString(),
                timescaleSizeValue;
            //On Initial loading - timescaleSizeValue
            if (scaleSize == undefined && timescaleUnitSize != "100%") {
                fitTimescaleSize = false;
                var negativeVal = timescaleUnitSizeStr.indexOf("-");
                if (negativeVal != -1)
                    timescaleSizeValue = 100;//default value
                else
                    timescaleSizeValue = +(timescaleUnitSizeStr.match(/\d+/)[0]);
                if (timescaleSizeValue < 50)
                    timescaleSizeValue = 50;
                else if (timescaleSizeValue > 500)
                    timescaleSizeValue = 500;
                model.scheduleHeaderSettings.timescaleUnitSize = timescaleSizeValue + "%";//To receive updated value
            }
            //Dynamic update - timescaleSizeValue
            if (scaleSize != undefined) {
                fitTimescaleSize = false;
                var negativeVal = timescaleUnitSizeStr.indexOf("-");
                if (negativeVal != -1)
                    timescaleSizeValue = timescaleUnitSize;//Existing scale value
                else
                    timescaleSizeValue = +(timescaleUnitSizeStr.match(/\d+/)[0]);
                if (timescaleSizeValue < 50)
                    timescaleSizeValue = 50;
                else if (timescaleSizeValue > 500)
                    timescaleSizeValue = 500;
                model.scheduleHeaderSettings.timescaleUnitSize = timescaleSizeValue + "%";//To receive updated value
            }
            if (scheduleMode == "week") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.3) : 30;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "year") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.03) : 3;
                proxy._perMonthWidth = proxy._perDayWidth * 30;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "month") {
                proxy._perDayWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.1) : 10;
                proxy._perWeekWidth = proxy._perDayWidth * 7;
                proxy._perHourWidth = proxy._perDayWidth / 24;
                proxy._perMinuteWidth = proxy._perDayWidth / (24 * 60);
            }
            else if (scheduleMode == "day") {
                proxy._perHourWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.2) : 20;
                proxy._perMinuteWidth = proxy._perHourWidth / 60;
                proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
            }
            else if (scheduleMode == "hour") {
                var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                    intervalValue = ej.Gantt.minutesPerInterval;
                proxy._perMinuteWidth = !fitTimescaleSize ? Math.round(timescaleSizeValue * 0.2) : 20;
                if (minutesPerInterval) {
                    if (minutesPerInterval == intervalValue.Auto) {
                        var scheduleStartDate = proxy._getDateFromFormat(model.scheduleStartDate),
                            scheduleEndDate = proxy._getDateFromFormat(model.scheduleEndDate),
                            twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                            sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                            tenDaysTimeSpan = 10 * 86400000,
                            diff = scheduleEndDate - scheduleStartDate;

                        if (diff > tenDaysTimeSpan) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                        else if (diff > sevenDaysTimeSpan) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (diff > twoDaysTimeSpan) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                        }
                    }
                    else if (minutesPerInterval == intervalValue.OneMinute) {
                        proxy._minuteInterval = 1;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                    }
                    else if (minutesPerInterval == intervalValue.FiveMinutes) {
                        proxy._minuteInterval = 5;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                    }
                    else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                        proxy._minuteInterval = 15;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                    }
                    else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                        proxy._minuteInterval = 30;
                        proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                    }
                }                
            }
            proxy._updateModelsWidth();
        },
        //Private method for changing timescaleSize
        _updateTimescaleUnitSize: function (sizeValue) {
            var proxy = this, model = proxy.model,
                scheduleHeaderSettings = model.scheduleHeaderSettings,
                previousTimescaleUnitSize = scheduleHeaderSettings.timescaleUnitSize;
            scheduleHeaderSettings.timescaleUnitSize = sizeValue;
            //Calculate timeline width for timescaleUnitSize value
            proxy._timelineWidthCalculation(sizeValue);
            //Re render the gantt chart side alone
            proxy.updateScheduleDates(model.scheduleStartDate, model.scheduleEndDate);
            // Update the scrollbar to focus the selected taskbar while zooming
            var selectedItemIndex = proxy.selectedRowIndex();
            if (selectedItemIndex >= 0) {
                proxy.focusOnTask(selectedItemIndex);
            }
        },

        /*validate dayWorkingTime API if it is not valid assign default value to this API*/
        _validateTimeRange: function () {
            var tempDay = "01/01/2016", tempEndDay = "01/02/2016", proxy = this, model = this.model,
               length = model.dayWorkingTime.length, isValid = true, prevTimeline = null;//MM/dd/yyyy
            for (var count = 0; count < length; count++) {
                var currentRange = model.dayWorkingTime[count];
                if (currentRange.from && currentRange.to) {
                    var startHour = ej.parseDate(tempDay + " " + currentRange.from, "MM/dd/yyyy h:mm tt", "en-US"),
                        endHour = currentRange.to != "12:00 AM" ? ej.parseDate(tempDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US") : ej.parseDate(tempEndDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US"),
                        timeDiff = endHour.getTime() - startHour.getTime(),
                        sdHour = this._getSecondsInDecimal(startHour),
                        edHour = this._getSecondsInDecimal(endHour);
                    if (edHour == 0)
                        edHour = 86400; // second in a day
                    if (sdHour >= edHour) {
                        isValid = false;
                    }
                    else {
                        if (prevTimeline == null)
                            prevTimeline = edHour;
                        else if (prevTimeline >= sdHour || prevTimeline >= edHour)
                            isValid = false;
                    }
                }
                else {
                    isValid = false;
                }
            }
            if (!isValid) {
                model.dayWorkingTime = [{ from: "08:00 AM", to: "12:00 PM" }, { from: "01:00 PM", to: "05:00 PM" }];
            }
        },
        /*Get date from string*/
        _getParsedDate: function (value, format, locale) {
            return ej.parseDate(value, format, locale);
        },
        _setTime: function (seconds, date) {
            var hour = parseInt(seconds / (3600)),
                min = parseInt((seconds - (hour * 3600)) / 60),
                sec = seconds - (hour * 3600) - (min * 60);
            date.setHours(hour, min, sec, 0);
        },
        // Update date next recent working hours
        _checkStartDate: function (date, record, validateAsMilestone) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), startRangeIndex = -1,
                isMilestone = ej.isNullOrUndefined(validateAsMilestone) ? !ej.isNullOrUndefined(record) ? record.isMilestone : false : validateAsMilestone;
            if (hour < this._defaultStartTime) {
                this._setTime(this._defaultStartTime, cloneDate);
            } else if (hour == this._defaultEndTime && (!record || !isMilestone)) {//milestone can fall at end of the day
                cloneDate.setDate(cloneDate.getDate() + 1);
                this._setTime(this._defaultStartTime, cloneDate);
            }
            else if (hour > this._defaultEndTime) {
                cloneDate.setDate(cloneDate.getDate() + 1);
                this._setTime(this._defaultStartTime, cloneDate);
            } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (hour >= val.to && (this._workingTimeRanges[i + 1] && hour < this._workingTimeRanges[i + 1].from)) {
                        //milestone can fall at end of any interval time
                        if (hour == val.to && (!record || !isMilestone))
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                        else if (hour != val.to)
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                        break;
                    }
                }
            }
            var tempStartDate;
            do{
                tempStartDate = new Date(cloneDate);
                //check holidays and weekends
                if ((!ej.isNullOrUndefined(record) && record.isAutoSchedule && (!model.includeWeekend || model.holidays.length > 0)) || (ej.isNullOrUndefined(record) && (!model.includeWeekend || model.holidays.length > 0))) {
                    if (!model.includeWeekend) {
                        cloneDate = this._getNextWorkingDay(cloneDate);
                    }
                    for (var count = 0; count < model.holidays.length; count++) {
                        var holidayFrom = this._getDateFromFormat(model.holidays[count].day),
                            holidayTo = new Date(holidayFrom);
                        holidayFrom.setHours(0, 0, 0, 0);
                        holidayTo.setHours(23, 59, 59, 59);
                        if (cloneDate.getTime() >= holidayFrom.getTime() && cloneDate.getTime() < holidayTo.getTime()) {
                            cloneDate.setDate(cloneDate.getDate() + 1);
                            this._setTime(this._defaultStartTime, cloneDate);
                            //cloneDate.setHours(this._defaultStartTime, 0, 0, 0);
                        }
                    }
                }
            } while (tempStartDate.getTime() != cloneDate.getTime());
            return new Date(cloneDate);
            //Holiday Update
        },
        //Update the date to previous working time
        _checkEndDate: function (date, record) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), endRangeIndex = -1;
            if (hour > this._defaultEndTime) {
                this._setTime(this._defaultEndTime, cloneDate);
            //    cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
            } else if (hour <= this._defaultStartTime) {
                cloneDate.setDate(cloneDate.getDate() - 1);
                this._setTime(this._defaultEndTime, cloneDate);
              //  cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
            } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (hour > val.to && (this._workingTimeRanges[i + 1] && hour <= this._workingTimeRanges[i + 1].from)) {
                        this._setTime(this._workingTimeRanges[i].to, cloneDate);
                        //cloneDate.setHours(this._workingTimeRanges[i].to, 0, 0, 0);
                        break;
                    }
                }
            }
            var tempCheckDate;
            do {
                tempCheckDate = new Date(cloneDate);
                if ((!ej.isNullOrUndefined(record) && record.isAutoSchedule && (!model.includeWeekend || model.holidays.length > 0)) || (ej.isNullOrUndefined(record) && (!model.includeWeekend || model.holidays.length > 0))) {

                    //Update Weekend and holidays
                    if (!model.includeWeekend) {
                        cloneDate = this._getPrevWorkingDay(cloneDate);
                    }
                    for (var count = 0; count < model.holidays.length; count++) {
                        var holidayFrom = this._getDateFromFormat(model.holidays[count].day),
                            holidayTo = new Date(holidayFrom),
                            tempHoliDay = new Date(cloneDate);
                        tempHoliDay.setMinutes(cloneDate.getMinutes() - 2);
                        holidayFrom.setHours(0, 0, 0, 0);
                        holidayTo.setHours(23, 59, 59, 59);
                        if (cloneDate.getTime() >= holidayFrom.getTime() && cloneDate.getTime() < holidayTo.getTime() || (tempHoliDay.getTime() >= holidayFrom.getTime() && tempHoliDay.getTime() < holidayTo.getTime())) {
                            cloneDate.setDate(cloneDate.getDate() - 1);
                            if (!(cloneDate.getTime() == holidayFrom.getTime() && this._defaultEndTime == 86400 && this._getSecondsInDecimal(cloneDate) == 0))
                                this._setTime(this._defaultEndTime, cloneDate);
                                //cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                        }
                    }
                }
            } while (tempCheckDate.getTime() != cloneDate.getTime());
            return new Date(cloneDate);
        },

        _checkBaseLineStartDate: function (date) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), startRangeIndex = -1;
            if (ej.isNullOrUndefined(date)) {
                return "";
            }
            else {
                if (hour < this._defaultStartTime) {
                    this._setTime(this._defaultStartTime, cloneDate);
                } else if (hour >= this._defaultEndTime) {
                    cloneDate.setDate(cloneDate.getDate() + 1);
                    this._setTime(this._defaultStartTime, cloneDate);
                } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                    for (var i = 0; i < this._workingTimeRanges.length; i++) {
                        var val = this._workingTimeRanges[i];
                        if (hour >= val.to && (this._workingTimeRanges[i + 1] && hour < this._workingTimeRanges[i + 1].from)) {
                            this._setTime(this._workingTimeRanges[i + 1].from, cloneDate);
                            break;
                        }
                    }
                }
                return cloneDate;
            }
        },

        _checkBaseLineEndDate: function (date) {
            var cloneDate = new Date(date), model = this.model, hour = this._getSecondsInDecimal(cloneDate), endRangeIndex = -1;
            if (ej.isNullOrUndefined(date)) {
                return "";
            }
            else {
                if (hour > this._defaultEndTime) {
                    this._setTime(this._defaultEndTime, cloneDate);
                    //    cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                } else if (hour <= this._defaultStartTime) {
                    cloneDate.setDate(cloneDate.getDate() - 1);
                    this._setTime(this._defaultEndTime, cloneDate);
                    //  cloneDate.setHours(this._defaultEndTime, 0, 0, 0);
                } else if (hour > this._defaultStartTime && hour < this._defaultEndTime) {
                    for (var i = 0; i < this._workingTimeRanges.length; i++) {
                        var val = this._workingTimeRanges[i];
                        if (hour > val.to && (this._workingTimeRanges[i + 1] && hour <= this._workingTimeRanges[i + 1].from)) {
                            this._setTime(this._workingTimeRanges[i].to, cloneDate);
                            //cloneDate.setHours(this._workingTimeRanges[i].to, 0, 0, 0);
                            break;
                        }
                    }
                }
                return cloneDate;
            }
        },
        /*get left value of task with schedule start*/
        _getTaskLeft: function (currentDate, isMilestone) {
            var date = new Date(currentDate), model = this.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType;
            if (headerType == ej.Gantt.ScheduleHeaderType.Week || headerType == ej.Gantt.ScheduleHeaderType.Month
                || headerType == ej.Gantt.ScheduleHeaderType.Year) {
                if (this._getSecondsInDecimal(date) == this._defaultStartTime) {
                    date.setHours(0, 0, 0, 0);
                }
                else if (isMilestone && this._getSecondsInDecimal(date) == this._defaultEndTime) {
                    date.setHours(24);
                }
            }
            if (this._projectStartDate)
                return (((date.getTime() - this._projectStartDate.getTime()) / (1000 * 60 * 60 * 24)) * this._perDayWidth);//this._perMinuteWidth
            else
                return 0;
        },
        /*get width value of task*/
        _getTaskWidth: function (startDate, endDate) {
            var sDate = new Date(startDate), eDate = new Date(endDate), model = this.model,
               headerType = model.scheduleHeaderSettings.scheduleHeaderType;

            if (headerType == ej.Gantt.ScheduleHeaderType.Week || headerType == ej.Gantt.ScheduleHeaderType.Month
                || headerType == ej.Gantt.ScheduleHeaderType.Year) {
                if (this._getSecondsInDecimal(sDate) == this._defaultStartTime) {
                    sDate.setHours(0, 0, 0, 0);
                }
                if (this._getSecondsInDecimal(eDate) == this._defaultEndTime) {
                    eDate.setHours(24);
                }
            }
            var timeDiff = eDate.getTime() - sDate.getTime();

            return ((timeDiff / (1000 * 60 * 60 * 24)) * this._perDayWidth);//per day width
        },
        /*Get holidays betwwen two dates range*/
        _getHolidaysCount: function (startDate, endDate) {
            var proxy = this,
                model = proxy.model,
                holidays = this.model.holidays,
                holidaysCount = 0;
            for (var i = 0; i < holidays.length; i++) {
                var currentHoliday = this._getDateFromFormat(holidays[i].day);
                if (startDate.getTime() < currentHoliday.getTime() && endDate.getTime() >= currentHoliday.getTime())
                    if (!model.includeWeekend && proxy._nonWorkingDayIndex.indexOf(currentHoliday.getDay())==-1)
                        holidaysCount += 1;
                    else if (model.includeWeekend) {
                        holidaysCount += 1;
                    }
            }
            return holidaysCount;
        },

        //get weekend days between two dates without including args dates
        _getWeekendCount: function (startDate, endDate) {
            var sDay = new Date(startDate), eDay = new Date(endDate), weekEndCount = 0,
                proxy = this;
            sDay.setHours(0, 0, 0, 0);
            sDay.setDate(sDay.getDate() + 1);
            eDay.setHours(0, 0, 0, 0);
            while (sDay.getTime() < eDay.getTime()) {
                if (proxy._nonWorkingDayIndex.indexOf(sDay.getDay()) != -1)
                    weekEndCount += 1;
                sDay.setDate(sDay.getDate() + 1);
            }
            return weekEndCount;
        },
        /*get days between two dates*/
        _getDayDiff: function (startDate, endDate) {
            return (endDate.getTime() - startDate.getTime()) / (1000 * 60 * 60 * 24);
        },
        //Get seconds between two Dates
        _getNumberOfSeconds: function (startDate, endDate) {
            var sDay = new Date(startDate), eDay = new Date(endDate), weekEndCount = 0, timeDiff = 0;
            sDay.setHours(0, 0, 0, 0);
            sDay.setDate(sDay.getDate() + 1);
            eDay.setHours(0, 0, 0, 0);
            if (sDay.getTime() < eDay.getTime())
                timeDiff = (eDay.getTime() - sDay.getTime()) / 1000;
            return timeDiff;
        },
        //Calculate end date with startDate,duration ,duration Unit
        _getEndDate: function (startDate, duration, durationUnit, record, validateAsMilestone) {
            var secondDuration = 0, sHour = -1, nextAvailDuration = 0, endDate = new Date(startDate), startRangeIndex = -1;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day)
                secondDuration = this._secondsPerDay * duration;
            else if (durationUnit == ej.Gantt.DurationUnit.Hour)
                secondDuration = duration * 3600;
            else
                secondDuration = duration * 60;

            while (secondDuration > 0) {
                sHour = this._getSecondsInDecimal(endDate);
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (sHour >= val.from && sHour <= val.to) {
                        startRangeIndex = i;
                        break;
                    }
                }
                nextAvailDuration = Math.round(this._workingTimeRanges[startRangeIndex].to - sHour);
                if (nextAvailDuration <= secondDuration) {
                    endDate.setSeconds(endDate.getSeconds() + nextAvailDuration);
                    secondDuration -= nextAvailDuration;
                } else {
                    endDate.setSeconds(endDate.getSeconds() + secondDuration);
                    break;
                }
                if (secondDuration > 0)
                    endDate = this._checkStartDate(endDate, record, validateAsMilestone);
            }
            return endDate;
        },
        //Calculate start date with endDate,duration ,duration Unit
        _getStartDate: function (endDate, duration, durationUnit, record) {
            var minuteDuraion = 0, sHour = -1, nextAvailDuration = 0, startDate = new Date(endDate), startRangeIndex = -1;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day)
                minuteDuraion = this._secondsPerDay * duration;
            else if (durationUnit == ej.Gantt.DurationUnit.Hour)
                minuteDuraion = duration * 3600;
            else
                minuteDuraion = duration * 60;

            while (minuteDuraion > 0) {
                sHour = this._getSecondsInDecimal(startDate);
                if (this._workingTimeRanges.length > 0 && this._workingTimeRanges[this._workingTimeRanges.length - 1].to == 86400 && sHour == 0) {
                    sHour = 86400;
                }
                for (var i = 0; i < this._workingTimeRanges.length; i++) {
                    var val = this._workingTimeRanges[i];
                    if (sHour >= val.from && sHour <= val.to) {
                        startRangeIndex = i;
                        break;
                    }
                }
                nextAvailDuration = Math.round(sHour - this._workingTimeRanges[startRangeIndex].from);//In Minutes
                if (nextAvailDuration <= minuteDuraion) {
                    startDate.setSeconds(startDate.getSeconds() - nextAvailDuration);
                    minuteDuraion -= nextAvailDuration;
                } else {
                    startDate.setSeconds(startDate.getSeconds() - minuteDuraion);
                    break;
                }
                if (minuteDuraion > 0)
                    startDate = this._checkEndDate(startDate, record);
            }
            return startDate;
        },
        /*get duration between two dates according to duration unit value*/
        _getDuration: function (sDate, eDate, durationUnit, isAutoSchedule) {
            var timeDiff = eDate.getTime() - sDate.getTime(), durationValue,
               weekendCount = !this.model.includeWeekend && isAutoSchedule ? this._getWeekendCount(sDate, eDate) : 0,
               nonWrkHours = 0, durationHrs = 0, totalHours = this._getNumberOfSeconds(sDate, eDate),
               holidaysCount = isAutoSchedule ? this._getHolidaysCount(sDate, eDate) : 0;
            timeDiff = timeDiff / 1000;
            totalHours = (totalHours - (weekendCount * 86400) - (holidaysCount * 86400)) / 86400; // days between two dates
            nonWrkHours = this._getNonWorkingSecondsOnDate(sDate, eDate);
            durationHrs = timeDiff - (totalHours * (86400 - this._secondsPerDay)) - (weekendCount * 86400) - (holidaysCount * 86400) - nonWrkHours;
            if (!durationUnit || durationUnit == ej.Gantt.DurationUnit.Day) {
                durationValue = durationHrs / this._secondsPerDay;
            } else if (durationUnit == ej.Gantt.DurationUnit.Minute) {
                durationValue = durationHrs / 60;
            } else {
                durationValue = durationHrs / 3600;
            }
            return parseFloat(durationValue);
        },
        /*Get four infomration in date*/
        _getSecondsInDecimal: function (date) {
            return (date.getHours() * 60 * 60) + (date.getMinutes() * 60) + date.getSeconds() + (date.getMilliseconds() / 1000);
        },
        /*get non working hours betwwen two dates*/
        _getNonWorkingSecondsOnDate: function (startDate, endDate) {

            var proxy = this, sHour = this._getSecondsInDecimal(startDate), eHour = this._getSecondsInDecimal(endDate), startRangeIndex = -1, endRangeIndex = -1, totNonWrkSecs = 0;
            for (var i = 0; i < this._workingTimeRanges.length; i++) {
                var val = this._workingTimeRanges[i];
                if (sHour >= val.from && sHour <= val.to)
                    startRangeIndex = i;
                if (eHour >= val.from && eHour <= val.to)
                    endRangeIndex = i;
            }
            if (startDate.getDate() != endDate.getDate() || startDate.getMonth() != endDate.getMonth() || startDate.getFullYear() != endDate.getFullYear()) {
                totNonWrkSecs = proxy._nonWorkingHours[proxy._nonWorkingHours.length - 1 - startRangeIndex] + 86400 - proxy._defaultEndTime;
                totNonWrkSecs += proxy._nonWorkingHours[endRangeIndex] + proxy._defaultStartTime;
            }
            else {
                if (startRangeIndex != endRangeIndex) {
                    totNonWrkSecs = proxy._nonWorkingHours[endRangeIndex] - proxy._nonWorkingHours[startRangeIndex];
                }
            }
            return totNonWrkSecs;
        },
        /*Get working hours between work time range value*/
        _getSecondsPerDay: function () {
            var tempDay = "01/01/2016", tempEndDay = "01/02/2016", proxy = this, model = this.model,
                length = model.dayWorkingTime.length, totalSeconds = 0;//MM/dd/yyyy
            for (var count = 0; count < length; count++) {
                var currentRange = model.dayWorkingTime[count];
                if (currentRange.from && currentRange.to) {

                    var startHour = ej.parseDate(tempDay + " " + currentRange.from, "MM/dd/yyyy h:mm tt", "en-US"),
                        endHour = currentRange.to != "12:00 AM" ? ej.parseDate(tempDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US") : ej.parseDate(tempEndDay + " " + currentRange.to, "MM/dd/yyyy h:mm tt", "en-US"),
                        timeDiff = endHour.getTime() - startHour.getTime(),
                        sdHour = this._getSecondsInDecimal(startHour),
                        edHour = this._getSecondsInDecimal(endHour);
                    if (edHour == 0)
                        edHour = 86400; // second in a day
                    totalSeconds += timeDiff / 1000;
                    if (count == 0)
                        proxy._defaultStartTime = sdHour;
                    if (count == length - 1)
                        proxy._defaultEndTime = edHour;
                    if (count > 0)
                        proxy._nonWorkingHours.push(proxy._nonWorkingHours[proxy._nonWorkingHours.length - 1] + sdHour - proxy._workingTimeRanges[count - 1].to);
                    else
                        proxy._nonWorkingHours.push(0);
                    proxy._workingTimeRanges.push({ from: sdHour, to: edHour });
                }
            }
            return totalSeconds;
        },

        _updateColumnLocaleText: function () {
            var model = this.model,
                columns = model.columns;
            if (columns && columns.length > 0) {
                for (var count = 0; count < columns.length; count++) {
                    if (columns[count].field && this._columnHeaderTexts[columns[count].field]) {
                        columns[count].headerText = this._columnHeaderTexts[columns[count].field];
                    }
                }
            }
        },
        //calculate height and width for gantt at load time
        _calculateDimensions: function ()
        {
            var proxy = this,
                sizeSettings = this.model.sizeSettings,
                sizeSettingHeight = sizeSettings.height,
                sizeSettingsWidth = sizeSettings.width,
                element = proxy.element,
                elementStyleHeight = element[0].style.height,
                elementStyleWidth = element[0].style.width,
                parentHeight = element.parent().height(),
                parentWidth = element.parent().width();

            if (sizeSettingsWidth)
                element.css("width", sizeSettingsWidth);

            if (sizeSettingHeight)
                element.css("height", sizeSettingHeight);

            /* check given value and assign default value for width and height */
            if (!sizeSettingHeight && !elementStyleHeight) {
                elementStyleHeight = "450px";
                element.css("height", "450px");
            }

            if (!sizeSettingsWidth && !elementStyleWidth) {
                elementStyleWidth = "100%";
                proxy.element.css("width", "100%");
            }
            proxy._ganttHeight = element.height();
            proxy._ganttWidth = element.width();

            if (proxy._ganttHeight === 0) {
                proxy._ganttHeight = 450;
                element.css("450px");
            }
        },
        _setCultureInfo:function() {
            var proxy = this,
               model = proxy.model,
               culture = model.locale,
               localization = $.extend({}, proxy._localizedLabels, 
                ej.isNullOrUndefined(ej.cultures[culture]) ? ej.cultures["default"] : ej.cultures[culture]),
               defaultLocalization = $.extend({}, ej.cultures["default"], ej.Gantt.Locale["default"]);
            model.dateFormat = !model.dateFormat ? ((localization && localization["calendars"] &&
                    localization["calendars"]["standard"]["patterns"]) ?
                (localization["calendars"]["standard"]["patterns"]["d"]) :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["patterns"]["d"] :
                    defaultLocalization["calendars"]["standard"]["patterns"]["d"]) : model.dateFormat;

            
            //EmptyRecord text to be displayed with dataSource is null
            proxy._emptyRecordText = (localization && localization["emptyRecord"]) ?
                localization["emptyRecord"] : defaultLocalization["emptyRecord"];
            
            //ColumnHeaderText to be displayed in treegrid
            proxy._columnHeaderTexts = ( localization && localization["columnHeaderTexts"] ) ?
                localization["columnHeaderTexts"] : defaultLocalization["columnHeaderTexts"];
            
            proxy._columnHeaderTexts = $.extend({}, defaultLocalization["columnHeaderTexts"], proxy._columnHeaderTexts);

            //taskModeDropDownValue to be displayed in treegrid
            proxy._taskModeTexts = (localization && localization["taskModeTexts"]) ?
                localization["taskModeTexts"] : defaultLocalization["taskModeTexts"];

            proxy._taskModeTexts = $.extend({}, defaultLocalization["taskModeTexts"], proxy._taskModeTexts);

            //EditDialog Text to be displayed in popup window
            proxy._editDialogTexts = (localization && localization["editDialogTexts"]) ?
                localization["editDialogTexts"] : defaultLocalization["editDialogTexts"];

            proxy._editDialogTexts = $.extend({}, defaultLocalization["editDialogTexts"], proxy._editDialogTexts);

            //Add Column Dialog Text to be displayed in popup window
            proxy._columnDialogTexts = (localization && localization["columnDialogTexts"]) ?
                localization["columnDialogTexts"] : defaultLocalization["columnDialogTexts"];

            //Tooltip Text to be displayed in the Toolbar
            proxy._toolboxTooltipTexts = (localization && localization["toolboxTooltipTexts"]) ?
                localization["toolboxTooltipTexts"] :
                defaultLocalization["toolboxTooltipTexts"];

            proxy._toolboxTooltipTexts = $.extend({}, defaultLocalization["toolboxTooltipTexts"], proxy._toolboxTooltipTexts);
            //Tooltip Text to be displayed on the Taskbar for duration units
            proxy._durationUnitTexts = (localization && localization["durationUnitTexts"]) ?
                localization["durationUnitTexts"] : defaultLocalization["durationUnitTexts"];

            proxy._durationUnitTexts = $.extend({}, defaultLocalization["durationUnitTexts"], proxy._durationUnitTexts);

            //Tooltip Text to be displayed on the Taskbar for duration units
            proxy._durationUnitEditText = (localization && localization["durationUnitEditText"]) ?
                localization["durationUnitEditText"] : defaultLocalization["durationUnitEditText"];

            proxy._durationUnitEditText = $.extend({}, defaultLocalization["durationUnitEditText"], proxy._durationUnitEditText);


            //Unit text to display in Work field.
            proxy._workUnitTexts = (localization && localization["workUnitTexts"]) ?
                localization["workUnitTexts"] : defaultLocalization["workUnitTexts"];
            
            proxy._workUnitTexts = $.extend({}, defaultLocalization["workUnitTexts"], proxy._workUnitTexts);
            
            //Text to be displayed in type drop down.
            proxy._taskTypeTexts = (localization && localization["taskTypeTexts"]) ?
                localization["taskTypeTexts"] : defaultLocalization["taskTypeTexts"];
            
            proxy._taskTypeTexts = $.extend({}, defaultLocalization["taskTypeTexts"], proxy._taskTypeTexts);
            
            //Text to be displayed in default type drop down.
            proxy._effortDrivenTexts = (localization && localization["effortDrivenTexts"]) ?
                localization["effortDrivenTexts"] : defaultLocalization["effortDrivenTexts"];
            
            proxy._effortDrivenTexts = $.extend({}, defaultLocalization["effortDrivenTexts"], proxy._effortDrivenTexts);

            //Context Menu Text
            proxy._contextMenuTexts = (localization && localization["contextMenuTexts"]) ?
                localization["contextMenuTexts"] : defaultLocalization["contextMenuTexts"];

            proxy._contextMenuTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._contextMenuTexts);
            //Name for New Task while adding
            proxy._newTaskTexts = (localization && localization["newTaskTexts"]) ?
                localization["newTaskTexts"] : defaultLocalization["newTaskTexts"];
            
            //Month names to be displayed in schedule
            proxy._months = (localization && localization["calendars"]) ?
                localization["calendars"]["standard"]["months"]["namesAbbr"] :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["months"]["namesAbbr"] :
                defaultLocalization["calendars"]["standard"]["months"]["namesAbbr"];
            
            //Day names to displayed in schedule
            proxy._days = (localization && localization["calendars"]) ?
                localization["calendars"]["standard"]["months"]["namesAbbr"] :
                ej.preferredCulture(culture) ? ej.preferredCulture(culture)["calendars"]["standard"]["days"]["namesAbbr"] :
                defaultLocalization["calendars"]["standard"]["days"]["namesAbbr"];

            //Column Menu Text
            proxy._columnMenuTexts = (localization && localization["columnMenuTexts"]) ?
                localization["columnMenuTexts"] : defaultLocalization["columnMenuTexts"];

            proxy._columnMenuTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._columnMenuTexts);

            //Column dialog title Text 
            proxy._columnDialogTitle = (localization && localization["columnDialogTitle"]) ?
                localization["columnDialogTitle"] : defaultLocalization["columnDialogTitle"];


            //Deleting the column texts 
            proxy._deleteColumnText = (localization && localization["deleteColumnText"]) ?
                localization["deleteColumnText"] : defaultLocalization["deleteColumnText"];

            proxy._okButtonText = (localization && localization["okButtonText"]) ?
                localization["okButtonText"] : defaultLocalization["okButtonText"];

            proxy._cancelButtonText = (localization && localization["cancelButtonText"]) ?
                localization["cancelButtonText"] : defaultLocalization["cancelButtonText"];

            proxy._confirmDeleteText = (localization && localization["confirmDeleteText"]) ?
                    localization["confirmDeleteText"] : defaultLocalization["confirmDeleteText"];

            //Predecssor Editing Text
            proxy._predecessorEditingTexts = localization && localization["predecessorEditingTexts"] ?
                localization["predecessorEditingTexts"] : defaultLocalization["predecessorEditingTexts"];

            proxy._predecessorEditingTexts = $.extend({}, defaultLocalization["contextMenuTexts"], proxy._predecessorEditingTexts);


            proxy._alertTexts = localization && localization["alertTexts"] ?
                localization["alertTexts"] : defaultLocalization["alertTexts"];

            proxy._alertTexts = $.extend({}, defaultLocalization["alertTexts"], proxy._alertTexts);
            
            //TabDialogText to be displayed in Gantt add and edit dialog
            proxy._dialogTabTitleTexts = (localization && localization["dialogTabTitleTexts"]) ?
                localization["dialogTabTitleTexts"] : defaultLocalization["dialogTabTitleTexts"];

            proxy._dialogTabTitleTexts = $.extend({}, defaultLocalization["dialogTabTitleTexts"], proxy._dialogTabTitleTexts);

            proxy._predecessorCollectionText = localization && localization["predecessorCollectionText"] ?
                localization["predecessorCollectionText"] : defaultLocalization["predecessorCollectionText"];

            //Edit type text
            proxy._editTypeText = (localization && localization["editTypeTexts"]) ?
                localization["editTypeTexts"] : defaultLocalization["editTypeTexts"];

            //Edit types text
            proxy._textAlignTypeText = (localization && localization["textAlignTypes"]) ?
                localization["textAlignTypes"] : defaultLocalization["textAlignTypes"];

            //Clip mode types text
            proxy._clipModeText = (localization && localization["clipModeTexts"]) ?
                localization["clipModeTexts"] : defaultLocalization["clipModeTexts"];

            //Validation rule dialog texts
            proxy._validationRuleText = (localization && localization["linkValidationRuleText"]) ?
                localization["linkValidationRuleText"] : defaultLocalization["linkValidationRuleText"];
            proxy._validationDialogTitle = (localization && localization["linkValidationDialogTitle"]) ?
                localization["linkValidationDialogTitle"] : defaultLocalization["linkValidationDialogTitle"];
            //Column dialog title Text 
            proxy._validationRuleOptions = (localization && localization["linkValidationRuleOptions"]) ?
                localization["linkValidationRuleOptions"] : defaultLocalization["linkValidationRuleOptions"];
        },

        //Populate available fields
        _getMappingItems: function () {
            var proxy = this,
                model = proxy.model,
                mappingItems = [],
                length = proxy._columns.length;

            for (var i = 0; i < length; i++) {
                mappingItems.push(proxy._columns[i].mappingName);
            }
            return mappingItems;
        },

        //populate the context menu with items
        _getContextMenuItems: function () {
            var contextMenuItems = [],
                proxy = this,
                contextMenuLabel = this._contextMenuTexts;

            contextMenuItems = [{
                headerText: contextMenuLabel["taskDetailsText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Task",

            }, {
                headerText: contextMenuLabel["addNewTaskText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Add"
            },
             {
                headerText: contextMenuLabel["indentText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Indent"
            }, {
                headerText: contextMenuLabel["outdentText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Outdent"
            }, {
                headerText: contextMenuLabel["deleteText"],
                eventHandler: null,
                isDefault: true,
                menuId: "Delete"
            },
            {
                iconPath: null,
                headerText: contextMenuLabel["aboveText"],
                eventHandler: null,
                menuId: "Above",
                parentMenuId: "Add"
            }, {
                iconPath: null,
                headerText: contextMenuLabel["belowText"],
                eventHandler: null,
                menuId: "Below",
                parentMenuId: "Add"
            }
           ];
            return contextMenuItems;
        },

        //rendering is initiated here
        _initialize: function () {

            if (this._isFromSetModel)
                return;
            else {
                var proxy = this, model = proxy.model;
                model.cssClass && (proxy.element.addClass(model.cssClass));
                proxy._$treegridPane = ej.buildTag('div.e-treegridPane');
                proxy._$ganttchartPane = ej.buildTag('div.e-ganttchartPane');
                proxy._$ejGantt = ej.buildTag('div.e-gantt-Spliter#e-ejSpliter' + proxy._id, "", {}, { 'data-unselectable': "on" });
                model.predecessorMapping && proxy._updatePredecessors();
                proxy._render();
                model.updatedRecords = model.flatRecords.slice();
                model.currentViewData = model.flatRecords.slice();
                model.predecessorMapping && model.enablePredecessorValidation && proxy._updatedRecordsDateByPredecessor();
                proxy._calculateScheduleDates();
                proxy._calculateHeaderDates();
                proxy._updateGanttRecords();
                proxy._checkDataManagerUpdate();
                proxy._renderTreeGrid();
                model.updatedRecords = proxy.getUpdatedRecords();
                model.currentViewData = proxy.getCurrentViewData();
                proxy._renderGanttChart();
                proxy._enableCreateCollection = true;
                proxy._isValidationEnabled = false;          //no validation require here
                proxy._isLoad = false,
                model.predecessorMapping && proxy._createConnectorLinesCollection();//connectorline oboject creates here
                proxy._isValidationEnabled = true;//reassign this value
                proxy._$treegridPane.css({ 'overflow': 'hidden' });
                //Dialog templates Rendering initiated
                proxy._initiateDialogTemplates();
                if (model.predecessorMapping && model.enablePredecessorValidation) 
                    proxy._validationDialogTemplate(); // To render predecessor link validation dialog 
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
                proxy._gridRows = proxy.getRows();
                proxy._ganttChartRows = proxy.getGanttChartRows();
                proxy._createContextMenuTemplate();
                proxy._wireEvents();
                proxy._initialEndRendering();
                proxy._getLocalizedLabels();
            }
        },

        _getLocalizedLabels:function(){
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },

        //apply row Selection and enable collapse all while loading
        _initialEndRendering:function()
        {
            var proxy = this,
                model = this.model;

            //Call collapse All
            if (model.enableCollapseAll) {
                if (this.selectedRowIndex() != -1) {
                    proxy._deSelectRowItem();
                }
                proxy._collapseAll();
            }           
            else if (model.expandStateMapping) {
                proxy._collapseRecordOnLoad();
            }

            //Select item by selected row index
            if (proxy.selectedRowIndex() >= 0 && proxy.selectedRowIndex() < proxy.model.updatedRecords.length && model.selectionMode == "row") {
                var rowSelectingArgs = {};
                rowSelectingArgs.recordIndex = proxy.selectedRowIndex();
                rowSelectingArgs.previousIndex = model.selectedItem ? model.updatedRecords.indexOf(model.selectedItem) : -1;
                if (proxy.rowSelecting(rowSelectingArgs)) {
                    proxy.selectRows(proxy.selectedRowIndex());
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                }
            }  
        },

        //Check if data manager is updatable
        _checkDataManagerUpdate: function ()
        {
            var proxy = this,
                dataSource =this.dataSource();
            proxy._isDataManagerUpdate = false;
            proxy._jsonData = null;

            if (dataSource instanceof ej.DataManager) {
                if (dataSource.dataSource.offline && dataSource.dataSource.json) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = dataSource.dataSource.json;
                }
                else if (!dataSource.dataSource.offline) {
                    proxy._isDataManagerUpdate = true;
                    proxy._jsonData = proxy._retrivedData;
                }
            }
        },
        //Render add,edit dialog templates
        _initiateDialogTemplates:function()
        {
            var proxy = this, model = this.model;

            proxy.customColumnFields();
            if (model.editSettings.allowEditing || model.editSettings.editMode == "normal" || model.editSettings.editMode == "dialogTemplate") {
                proxy.editDialogTemplate();
                if ($("#" + this._id + "_dialogEdit").length === 0)
                    proxy.element.append(proxy._renderDialog());
            }
            if (model.editSettings.allowAdding) {
                proxy.addDialogTemplate();
                if ($("#" + this._id + "_dialogAdd").length === 0) {
                    var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none", "overflow-x": "hidden" }, { id: this._id + "_dialogAdd" });
                    proxy.element.append($dialog);
                }
            }
        },

        //Toolbar,Gantt and treegrid parts are rendered and templates for add and edit dialog are created
        _render: function () {
            var proxy = this, element = proxy.element, model = proxy.model;
            if (proxy.model.toolbarSettings.showToolbar) {
                element.append(proxy._renderToolBar());
            }
            proxy._ganttHeight = parseInt(proxy._ganttHeight) - proxy._getToolBarHeight() - proxy._totalBorderHeight;
            proxy._$treegridHelper = ej.buildTag("div.ejTreeGrid#ejTreeGrid" + proxy._id, "", { "height": proxy._ganttHeight }, {});
            proxy._$ganttchartHelper = ej.buildTag("div.ejGanttChart#ejGanttChart" + proxy._id, "", { "height": proxy._ganttHeight }, {});
            proxy._$ganttchartPane.append(proxy._$ganttchartHelper);
            proxy._$treegridPane.append(proxy._$treegridHelper);
            proxy._$ejGantt.append(proxy._$treegridPane);
            proxy._$ejGantt.append(proxy._$ganttchartPane);    
            
            element.append(proxy._$ejGantt);
            proxy._renderGantt();
        },

        //Return dialog tag
        _renderDialog: function () {
            var $dialog = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none", "overflow-x":"hidden" }, { id: this._id + "_dialogEdit" });
            return $dialog;
        },
        //Create Template for edit dialog
        editDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = $.extend([], proxy._columns),
                length = columns.length,
                emptyDataColumns = [], column, predecessorColoumnIndex = -1, resourceColumnIndex = -1,
                treeGridObj = proxy._$treegridHelper.data("ejTreeGrid"),
                columnIndex,
                dialogTab = proxy._dialogTab,
                tabLength = dialogTab.length;
            proxy._editDialogGeneralColumns = [];
            proxy._editDialogCustomColumns = [];            
            proxy._generalTabColumnFields = ["taskId", "taskMode", "taskName", "startDate", "endDate", "duration", "resourceInfo", "status", "work", "taskType", "effortDriven", "baselineStartDate", "baselineEndDate", "predecessor", "WBS", "notesText"];
            proxy._mappingItems = proxy._getMappingItems();

            if (length == 0)
                return;

            if (model.editDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.editDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.editDialogFields[count].field;
                    });
                    if (resultColumn.length > 0) {
                        filteredColumns.push(resultColumn[0]);
                        if (proxy._generalTabColumnFields.indexOf(resultColumn[0].mappingName) == -1 && model.editDialogFields[count].displayInGeneralTab)
                            proxy._generalTabColumnFields.push(resultColumn[0].mappingName);
                    }
                }
                columns = filteredColumns;                
            }
            else {
                //To hide the WBS predecessor field
                if (model.enableWBS) {
                    var finalColumns;
                    if (model.enableWBSPredecessor) {
                        finalColumns = columns.filter(function (col) {
                            return col.mappingName != "WBSPredecessor";
                        });
                    }
                    if (finalColumns && finalColumns.length)
                        columns = finalColumns;
                }
            }
            var index = $.map(columns, function (column, index) {
                if (column.mappingName == model.taskNameMapping) {
                    return index;
                }
            });
            if ((index[0] + 1) % 3 == 0) {
                columns.splice(index[0] - 1, 0, columns.splice(index[0], 1)[0]);
            }
            length = columns.length;
            for (var i = 0; i < length; i++) {
                if ($.inArray(columns[i].mappingName, proxy._mappingItems) != -1) {
                    if (!model.resourceInfoMapping && (columns[i].field == "work" || columns[i].field == "taskType" || columns[i].field == "effortDriven"))
                        continue;
                    if (columns[i].mappingName !== model.predecessorMapping && columns[i].mappingName != model.resourceInfoMapping && columns[i].mappingName != model.notesMapping) {
                        var index = $.map(proxy._generalTabColumnFields, function (field, index) {
                            if (field == columns[i].field) {
                                return index;
                            }
                        });
                        if (index.length > 0) {
                            proxy._editDialogGeneralColumns.push(columns[i]);
                        }
                        else {
                            proxy._editDialogCustomColumns.push(columns[i]);
                        }
                    }
                    else {
                        if (columns[i].mappingName !== model.baselineStartDateMapping && columns[i].mappingName !== model.baselineEndDateMapping) {
                            if (columns[i].mappingName == model.resourceInfoMapping)
                                resourceColumnIndex = i;
                            else if (columns[i].mappingName == model.predecessorMapping)
                                predecessorColoumnIndex = i;
                        }
                    }
                }
            }
            var $tbody = ej.buildTag('div', "", {}, {}),
                $tab = ej.buildTag('div', "", {}, { id: proxy._id + "EditTab" }),
                $ul = ej.buildTag('ul', "", {}, {}),
                $inTr, $inTd, $inTr2, $inTd2, $preDiv;
            $tab.append($ul);
            $tbody.append($tab);
            for (var tabIndex = 0; tabIndex < tabLength; tabIndex++) {
                switch (dialogTab[tabIndex]) {
                    //General Tab
                    case "General":
                        $ul.append("<li><a href='#" + proxy._id + "EditGeneral'>" + proxy._dialogTabTitleTexts["generalTabText"] + "</a></li>");
                        var $general = ej.buildTag('div.e-gantt-editor-container', "", {}, { id: proxy._id + "EditGeneral" }),
                            $genearlForm = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "GeneralEditForm" });
                        $general.append($genearlForm);
                        $tab.append($general);
                       // var $form = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "EditForm" });
                        var $genearlTable = ej.buildTag('table.e-general-edit-div', "", { "border-spacing": "2px", "border-collapse": "separate", "margin-top": "0px" }, {}),
                        $tr = ej.buildTag('tr'), $td;
                        var columnCount = 0,
                            generalColumns = proxy._editDialogGeneralColumns,
                            length = generalColumns.length;
                        for (var i = 0; i < length; i++) {
                            if (columnCount < 3) {
                                if (generalColumns[i].mappingName !== model.taskNameMapping) {
                                    columnCount++;
                                    $td = ej.buildTag('td.e-property-container', "", {}, {});
                                }
                                else {
                                    columnCount += 2;
                                    $td = ej.buildTag('td.e-property-container', "", {}, { "colspan": "2" });
                                }
                                var $innerTable = ej.buildTag('table', "", { "outline": "none", "border-spacing": "2px", "border-collapse": "separate", "margin-top": "0px" }, {});
                                $inTr = ej.buildTag('tr', "", { "line-height": "1.4" }, {});
                                $inTd = ej.buildTag('td.e-editLabel', "", {}, {});
                                $inTd.append("<label>" + proxy._columnHeaderTexts[generalColumns[i].field] + "</label>");
                                $inTr.append($inTd);
                                $innerTable.append($inTr);
                                $inTr2 = ej.buildTag('tr');
                                $inTd2 = ej.buildTag('td.e-editValue', "", {}, {});
                                columnIndex = proxy._columns.indexOf(generalColumns[i]);
                                ej.TreeGrid._initCellEditType(treeGridObj, $inTd2, proxy._id, columnIndex, "Edit");
                                $inTr2.append($inTd2);
                                $innerTable.append($inTr2);
                                $td.append($innerTable);
                                $tr.append($td);
                            }
                            else {
                                $genearlTable.append($tr);
                                $tr = ej.buildTag('tr');
                                i--;
                                columnCount = 0;
                            }
                        }
                        $genearlTable.append($tr);
                        $genearlForm.append($genearlTable);
                        break;
                    case "Predecessors":
                        //Predecessor Tab
                        if (model.predecessorMapping && predecessorColoumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "EditPredecessors'>" + proxy._dialogTabTitleTexts["predecessorsTabText"] + "</a></li>");
                            var $predecessor = ej.buildTag('div.e-gantt-predecessor-container', "", {}, { id: proxy._id + "EditPredecessors" }),
                                $predecessorForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "PredecessorEditForm" });
                            $predecessor.append($predecessorForm);
                            $tab.append($predecessor);
                            var $predecessorTable = ej.buildTag('table#' + proxy._id + 'predecessoreditTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "margin-top": "0px", "position": "relative", "left": "-2px", "top": "2px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, "");
                            $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "EditDialog_PredecesorAdd' class='e-addpre e-icon e-enable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "EditDialog_PredecesorDelete' class='e-deletepre e-icon e-disable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $predecessorTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "predecessorEdit", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $predecessorTable.append($inTr2);
                            $predecessorForm.append($predecessorTable);
                        }
                        break;
                    case "Resources":
                        // Resource tab
                        if (model.resourceInfoMapping && resourceColumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "EditResources'>" + proxy._dialogTabTitleTexts["resourcesTabText"] + "</a></li>");
                            var $resource = ej.buildTag('div.e-gantt-resource-container', "", {}, { id: proxy._id + "EditResources" }),
                                $resourceForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "ResourceEditForm" });
                            $resource.append($resourceForm);
                            $tab.append($resource);
                            var $resourceTable = ej.buildTag('table#' + proxy._id + 'resourceeditTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "margin-top": "0px", "position": "relative", "left": "-2px", "top": "2px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "EditDialog_ResourceAdd' class='e-addpre e-icon e-enable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "EditDialog_ResourceDelete' class='e-deletepre e-icon e-disable e-edit-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $resourceTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "resourceEdit", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $resourceTable.append($inTr2);
                            $resourceForm.append($resourceTable);
                        }
                        break;
                    case "Custom Fields":
                        // Custom Field Tab
                        if (proxy._editDialogCustomColumns.length > 0) {
                            $ul.append("<li><a href='#" + proxy._id + "EditCustomFields'>" + proxy._dialogTabTitleTexts["customFieldsTabText"] + "</a></li>");
                            var $customField = ej.buildTag('div.e-gantt-csfield-container', "", {}, { id: proxy._id + "EditCustomFields" }),
                                $customFieldForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "CustomFieldsEditForm" });
                            $customField.append($customFieldForm);
                            $tab.append($customField);
                            var $customFieldTable = ej.buildTag('table#' + proxy._id + 'customFieldeditTable', "", { "width": "100%", "outline": "none", "position": "relative", "left": "-2px", "top": "4px", "border-collapse": "collapse", "margin-top": "0px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse" }, "");
                            $inTd = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "customFieldEdit", "", {}, {});
                            $inTd.append($preDiv);
                            $inTr.append($inTd);
                            $customFieldTable.append($inTr);
                            $customFieldForm.append($customFieldTable);
                        }
                        break;
                    case "Notes":
                        //Notes Tab
                        var editDialogFields = model.editDialogFields,
                            length = editDialogFields.length,
                            index = $.map(editDialogFields, function (dialogField, index) {
                                if (dialogField.field == model.notesMapping) {
                                    return index;
                                }
                            });
                        if ((model.notesMapping && length == 0) || (length > 0 && index.length > 0)) {
                            $ul.append("<li><a href='#" + proxy._id + "EditNotes'>" + proxy._dialogTabTitleTexts["notesTabText"] + "</a></li>");
                            var $notes = ej.buildTag('div.e-gantt-notes-container', "", {}, { id: proxy._id + "EditNotes" }),
                                $notesDiv = ej.buildTag('div', "", { "padding": "0px", "position": "relative", "top": "5px", "left": "-1px" }, {}),
                                $noteTextArea = ej.buildTag('textarea', "", {}, { id: proxy._id + "EditAreaNotes" });
                            $notesDiv.append($noteTextArea);
                            $notes.append($notesDiv);
                            $tab.append($notes);
                        }
                        break;
                }
            }
            $tbody = proxy.renderDiaglogButton("edit", $tbody);
            $.templates(proxy._id + "_JSONDialogEditingTemplate", $tbody.html());
        },
        //create template for add dialog
        addDialogTemplate: function () {

            var proxy = this,
                model = proxy.model,
                columns = $.extend([], proxy._columns),
                length = columns.length,
                emptyDataColumns = [], column, predecessorColoumnIndex = -1, resourceColumnIndex = -1,
                treeGridObj = proxy._$treegridHelper.data("ejTreeGrid"),
                columnIndex,
                dialogTab = proxy._dialogTab,
                tabLength = dialogTab.length;
            proxy._addDialogGeneralColumns = [];
            proxy._addDialogCustomColumns = [];            
            proxy._generalTabColumnFields = ["taskId", "taskMode", "taskName", "startDate", "endDate", "duration", "resourceInfo", "status", "work", "taskType", "effortDriven", "baselineStartDate", "baselineEndDate", "predecessor", "WBS", "notesText"];
            proxy._mappingItems = proxy._getMappingItems();

            if (length == 0)
                return;

            if (model.addDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.addDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.addDialogFields[count].field;
                    });
                    if(resultColumn.length > 0)
                    {
                        filteredColumns.push(resultColumn[0]);
                        if (proxy._generalTabColumnFields.indexOf(resultColumn[0].mappingName) == -1 && model.addDialogFields[count].displayInGeneralTab)
                            proxy._generalTabColumnFields.push(resultColumn[0].mappingName);
                    }
                }
                columns = filteredColumns;
            }
            else {
                //To hide the WBS predecessor field
                if (model.enableWBS) {
                    var finalColumns;
                    if (model.enableWBSPredecessor) {
                        finalColumns = columns.filter(function (col) {
                            return col.mappingName != "WBSPredecessor";
                        });
                    }
                    if (finalColumns && finalColumns.length)
                        columns = finalColumns;
                }
            }
            var index = $.map(columns, function (column, index) {
                if (column.mappingName == model.taskNameMapping) {
                    return index;
                }
            });
            if ((index[0] + 1) % 3 == 0) {
                columns.splice(index[0] - 1, 0, columns.splice(index[0], 1)[0]);
            }
            var $tbody = ej.buildTag('div', "", {}, {}),
                $tab = ej.buildTag('div', "", {}, { id: proxy._id + "AddTab" }),
                $ul = ej.buildTag('ul', "", {}, {}),
                $inTr, $inTd, $inTr2, $inTd2, $preDiv;
            $tab.append($ul);
            $tbody.append($tab);
            length = columns.length;
            for (var i = 0; i < length; i++) {
                if ($.inArray(columns[i].mappingName, proxy._mappingItems) != -1) {
                    if ((!columns[i].mappingName && columns[i].field == "work") || columns[i].field == "taskType" || columns[i].field == "effortDriven")
                        continue;
                    if (columns[i].mappingName !== model.predecessorMapping && columns[i].mappingName != model.resourceInfoMapping && columns[i].mappingName != model.notesMapping) {
                        var index = $.map(proxy._generalTabColumnFields, function (field, index) {
                            if (field == columns[i].field) {
                                return index;
                            }
                        });
                        if (index.length > 0) {
                            proxy._addDialogGeneralColumns.push(columns[i]);
                        }
                        else {
                            proxy._addDialogCustomColumns.push(columns[i]);
                        }
                    }
                    else {
                        if (columns[i].mappingName === model.predecessorMapping)
                            predecessorColoumnIndex = i;
                        else if (columns[i].mappingName === model.resourceInfoMapping)
                            resourceColumnIndex = i;
                    }
                }
            }
            for (var tabIndex = 0; tabIndex < tabLength; tabIndex++) {
                switch (dialogTab[tabIndex]) {
                    // General Tab
                    case "General":
                        $ul.append("<li><a href='#" + proxy._id + "AddGeneral'>" + proxy._dialogTabTitleTexts["generalTabText"] + "</a></li>");
                        var $general = ej.buildTag('div.e-gantt-editor-container', "", {}, { id: proxy._id + "AddGeneral" }),
                            $genearlForm = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "GeneralAddForm" });
                        $general.append($genearlForm);
                        $tab.append($general);
                        //$form = ej.buildTag('form', "", { 'height': 'auto', 'width': 'auto', 'font-size': '14px' }, { id: proxy._id + "AddForm" });
                        var $genearlTable = ej.buildTag('table.e-general-edit-div', "", { "border-spacing": "2px", "border-collapse": "separate", "margin-top": "0px" }, {}),
                        $tr = ej.buildTag('tr'), $td;
                        var columnCount = 0,
                            generalColumns = proxy._addDialogGeneralColumns,
                            length = generalColumns.length;
                        for (var i = 0; i < length; i++) {
                            if (columnCount < 3) {
                                if (generalColumns[i].mappingName !== model.taskNameMapping) {
                                    columnCount++;
                                    $td = ej.buildTag('td.e-property-container', "", {}, {});
                                }
                                else {
                                    columnCount += 2;
                                    $td = ej.buildTag('td.e-property-container', "", {}, { "colspan": "2" });
                                }
                                var $innerTable = ej.buildTag('table', "", { "outline": "none", "border-spacing": "2px", "border-collapse": "separate", "margin-top": "0px" }, {});
                                $inTr = ej.buildTag('tr', "", { "line-height": "1.4" }, {});
                                $inTd = ej.buildTag('td.e-editLabel', "", {}, {});
                                $inTd.append("<label>" + proxy._columnHeaderTexts[generalColumns[i].field] + "</label>");
                                $inTr.append($inTd);
                                $innerTable.append($inTr);
                                $inTr2 = ej.buildTag('tr');
                                $inTd2 = ej.buildTag('td.e-editValue', "", {}, {});
                                columnIndex = proxy._columns.indexOf(generalColumns[i]);
                                ej.TreeGrid._initCellEditType(treeGridObj, $inTd2, proxy._id, columnIndex, "Add");
                                $inTr2.append($inTd2);
                                $innerTable.append($inTr2);
                                $td.append($innerTable);
                                $tr.append($td);
                            }
                            else {
                                $genearlTable.append($tr);
                                $tr = ej.buildTag('tr');
                                i--;
                                columnCount = 0;
                            }
                        }
                        $genearlTable.append($tr);
                        $genearlForm.append($genearlTable);
                        break;
                    case "Predecessors":
                        //Predecessor Tab
                        if (model.predecessorMapping && predecessorColoumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "AddPredecessors'>" + proxy._dialogTabTitleTexts["predecessorsTabText"] + "</a></li>");
                            var $predecessor = ej.buildTag('div.e-gantt-predecessor-container', "", {}, { id: proxy._id + "AddPredecessors" }),
                                $predecessorForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "PredecessorAddForm" });
                            $predecessor.append($predecessorForm);
                            $tab.append($predecessor);
                            var $predecessorTable = ej.buildTag('table#' + proxy._id + 'predecessoraddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "2px", "margin-top": "0px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "AddDialog_PredecesorAdd' class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "AddDialog_PredecesorDelete' class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $predecessorTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "predecessorAdd", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $predecessorTable.append($inTr2);
                            $predecessorForm.append($predecessorTable);
                        }
                        break;
                    case "Resources":
                        // Resource tab
                        if (model.resourceInfoMapping && resourceColumnIndex != -1) {
                            $ul.append("<li><a href='#" + proxy._id + "AddResources'>" + proxy._dialogTabTitleTexts["resourcesTabText"] + "</a></li>");
                            var $resource = ej.buildTag('div.e-gantt-resource-container', "", {}, { id: proxy._id + "AddResources" }),
                                $resourceForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "ResourceAddForm" });
                            $resource.append($resourceForm);
                            $tab.append($resource);
                            var $resourceTable = ej.buildTag('table#' + proxy._id + 'resourceaddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "2px", "margin-top": "0px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse", "height": "40px" }, {});
                            $inTd = ej.buildTag('td.e-editLabel', "", { "outline": "none", "border-collapse": "collapse", "padding": "1px" }, {});
                            $inTd.append("<span id='" + proxy._id + "AddDialog_ResourceAdd' class='e-addpre e-icon e-enable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["addPredecessor"] + "</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id='" + proxy._id + "AddDialog_ResourceDelete' class='e-deletepre e-icon e-disable e-add-dialog' style='cursor:pointer; width: auto;position:relative;left:10px;'>&nbsp;&nbsp;" + proxy._editDialogTexts["removePredecessor"] + "</span>");
                            $inTr.append($inTd);
                            $resourceTable.append($inTr);
                            $inTr2 = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd2 = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "resourceAdd", "", { "width": "100%", "height": "150px" }, {});
                            $inTd2.append($preDiv);
                            $inTr2.append($inTd2);
                            $resourceTable.append($inTr2);
                            $resourceForm.append($resourceTable);
                        }
                        break;
                    case "Custom Fields":
                        // Custom Field Tab
                        if (proxy._addDialogCustomColumns.length > 0) {
                            $ul.append("<li><a href='#" + proxy._id + "AddCustomFields'>" + proxy._dialogTabTitleTexts["customFieldsTabText"] + "</a></li>");
                            var $customField = ej.buildTag('div.e-gantt-csfield-container', "", {}, { id: proxy._id + "AddCustomFields" }),
                                $customFieldForm = ej.buildTag('form', "", { 'height': 'auto', 'width': '592px', 'font-size': '14px' }, { id: proxy._id + "CustomfFieldsAddForm" });
                            $customField.append($customFieldForm);
                            $tab.append($customField);
                            var $customFieldTable = ej.buildTag('table#' + proxy._id + 'customfieldaddTable', "", { "width": "100%", "outline": "none", "border-collapse": "collapse", "position": "relative", "left": "-2px", "top": "4px" }, {});
                            $inTr = ej.buildTag('tr', "", { "border-collapse": "collapse" }, {});
                            $inTd = ej.buildTag('td.e-editValue', "", { "border-collapse": "collapse", "padding": "1px" }, {});
                            $preDiv = ej.buildTag("div#treegrid" + proxy._id + "customFieldAdd", "", {}, {});
                            $inTd.append($preDiv);
                            $inTr.append($inTd);
                            $customFieldTable.append($inTr);
                            $customFieldForm.append($customFieldTable);
                        }
                        break;
                    case "Notes":
                        //Notes Tab
                        var addDialogFields = model.addDialogFields,
                            length = addDialogFields.length,
                            index = $.map(addDialogFields, function (dialogField, index) {
                                if (dialogField.field == model.notesMapping) {
                                    return index;
                                }
                            });
                        if (model.notesMapping && (length == 0) || (length > 0 && index.length > 0)) {
                            $ul.append("<li><a href='#" + proxy._id + "AddNotes'>" + proxy._dialogTabTitleTexts["notesTabText"] + "</a></li>");
                            var $notes = ej.buildTag('div.e-gantt-notes-container', "", {}, { id: proxy._id + "AddNotes" }),
                                $notesDiv = ej.buildTag('div', "", { "padding": "0px", "position": "relative", "top": "5px", "left": "-1px" }, {}),
                                $noteTextArea = ej.buildTag('textarea', "", {}, { id: proxy._id + "AddAreaNotes" });
                            $notesDiv.append($noteTextArea);
                            $notes.append($notesDiv);
                            $tab.append($notes);
                        }
                        break;
                }
            }

            $tbody = proxy.renderDiaglogButton("add", $tbody);
            $.templates(proxy._id + "_JSONDialogAddingTemplate", $tbody.html());
        },
        //remove contextmenu from DOM
        _clearContextMenu: function () {
            //variables for context menu items
         
            $('.e-contextmenu').remove();
            $('.e-innerContextmenu').remove();
        },

        //JSRender Template for ContextMenu
        _createContextMenuTemplate: function () {
            var proxy = this;
            var helpers = {};
            helpers["_" + proxy._id + "getHeaderName"] = $.proxy(proxy._getHeaderName, proxy);

            $.views.helpers(helpers);
            var menuItemList = "<li style='list-style-type:none;margin:0px;'>";
            var listChild = "<div class='e-menuitem{{if disable}} e-disable{{/if}}{{if ~_" + proxy._id + "getHeaderName(#data)}} e-parent-menuitem{{/if}}' id={{:menuId}}  style='display:table;cursor:pointer;min-width:100px;'>" +
                            "{{if iconPath}}" +
                            "<div class='e-icon e-contextmenu-image'" +
                            " style='background-image:{{:iconPath}};background-repeat:no-repeat;'/>" +
                             "{{else}}" +
                            "<div class='e-icon {{:iconClass}} e-contextmenu-icon'/>" +
                            "{{/if}}" +
                            "<div class='e-contextmenu-label'>" +
                            "<span>{{:headerText}}</span></div>" +
                            "{{if ~_" + proxy._id + "getHeaderName(#data)}}<div class='e-icon e-expander e-contextmenu-icon'/> {{/if}}";

            menuItemList += listChild;
            menuItemList += "</div></li>";
            var templates = {};
            templates[proxy._id + "contextMenuTemplate"] = menuItemList;
            $.templates(templates);
        },

        //helper methods for context menu template
        _getHeaderName: function (data) {
            var childMenuItems = this._contextMenuItems.filter(function (value) {
                if (data.menuId != null && data.menuId == value.parentMenuId)
                    return true;
            });
            if (childMenuItems.length > 0) {
                return true;
            }
            return false;
        },

        //create templates for all columns edit types
        initCellEditType: function (column, element,editTarget) {

            var proxy = this,
                model = proxy.model,
                id,    
                helpers = {};
            id = editTarget ? editTarget : "";
            if (ej.isNullOrUndefined(column["editType"]))
                column["editType"] = "stringedit";

            switch (column["editType"]) {
                case "stringedit":
                    if (column.mappingName === model.predecessorMapping) {
                        helpers["_" + proxy._id + "predecessor"] = proxy._getPredecessorsValue;
                        $.views.helpers(helpers);
                        element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{:~_" + proxy._id + "predecessor('" + proxy._id + "Object','" + model.predecessorMapping + "','" + column.field + "')}}", id: proxy._id + column.field, name: column.field }));
                    } else {
                        element.html(ej.buildTag('input.e-field e-ejinputtext', "", {}, { value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, "data-dialog": editTarget }));
                    }
                    break;
                case "booleanedit":
                    element.html('{{if ' + column.field + '}} <input class="e-field e-checkbox" type ="checkbox" id=' + proxy._id + column.field + ' name=' + column.field + ' checked="checked"></input>{{else}} <input class="e-field e-checkbox" type ="checkbox" id=' + proxy._id + column.field + ' name=' + column.field + ' > {{/if}}');
                    break;
                case "numericedit":
                    var $numericText = ej.buildTag('input.e-numerictextbox e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, "data-dialog": editTarget });
                    element.append($numericText);
                    break;
                case "datepicker":
                case "datetimepicker":
                    var $datePicker = ej.buildTag('input.e-' + column["editType"] + ' e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, "data-dialog": editTarget });
                    element.append($datePicker);
                    break;
                case "dropdownedit":
                    var $dropDownList = ej.buildTag('input.e-field e-dropdownlist' + ' e-field', "", {}, { type: "text", value: "{{:#data['" + column.field + "']}}", id: proxy._id + column.field + id, name: column.field, "data-dialog": editTarget });
                    element.append($dropDownList);                    
                    break;
                case "maskedit":
                    var $maskEdit = ej.buildTag('input .e-field e-maskedit', "", {},
                                        {
                                            value: "{{:#data['" + column.field + "']}}",
                                            id: proxy._id + column.field + id,
                                            name: column.field,
                                            "data-dialog": editTarget
                                        });
                    element.append($maskEdit);
                    break;
            }
        },

        //returns predecessor value
        _getPredecessorsValue: function (gridObject, mappingName) {
            return this.data.item ? this.data.item[mappingName] : "";
        },

        /*get duration and duration unit value from given string*/
        _getDurationValues: function (val, isFromDialog) {
            var duration = 0,
                model = this.model,
                durationUnit = model.durationUnit, unitIndex;

            if (typeof val == "string") {
                var values = val.match(/(\d*\.*\d+|[A-z]+)/g);
                if (values && values.length <= 2) {
                    duration = parseFloat(values[0]);
                    durationUnit = values[1] ? values[1].toLowerCase() : "";
                    if (this._durationUnitEditText.minute.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Minute;
                    else if (this._durationUnitEditText.hour.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Hour;
                    else if (this._durationUnitEditText.day.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Day;
                    else
                        durationUnit = model.durationUnit;
                } 
            } else {
                duration = val;
                durationUnit = model.durationUnit;
            }

            if (isNaN(duration)) {
                duration = isFromDialog ? this._editedDialogRecord.duration : 0;
                durationUnit = isFromDialog ? this._editedDialogRecord.durationUnit : model.durationUnit;
            }
            var output = {};
            output.duration = duration;
            output.durationUnit = durationUnit;
            return output;
        },

        //calculate end date and duration on date change in edit dialog
        _editStartDateChange: function (element, args)
        {
            var proxy = this,
                id = proxy._id,
                model = proxy.model,
                targetId = element.attr("id"),
                holidays = this.model.holidays,
                dialog = element.attr("data-dialog"),
                selectedItem = model.selectionMode == "row" ? this.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell],
                editedObj = this._editedDialogRecord,
                effortDriven = editedObj.effortDriven == "true" ? true : false,
                effortDrivenId, typeId, workId,
                startDateId, endDateId, durationId, baselineStartDateId, baselineEndDateId, durationVal, durationUnit;

            if (this._editedDialogRecord.isUpdatedFromDialog)
                return;
            this._editedDialogRecord.isUpdatedFromDialog = true;

            if (dialog === "Add") {
                startDateId = "#" + id + "startDateAdd";
                endDateId = "#" + id + "endDateAdd";
                durationId = "#" + id + "durationAdd";
                effortDrivenId = "#" + id + "effortDrivenAdd";
                typeId = "#" + id + "taskTypeAdd";
                workId = "#" + id + "workAdd";
                baselineStartDateId = "#" + id + "baselineStartDateAdd";
                baselineEndDateId = "#" + id + "baselineEndDateAdd";
            }
            else {
                startDateId = "#" + id + "startDateEdit";
                endDateId = "#" + id + "endDateEdit";
                durationId = "#" + id + "durationEdit";
                effortDrivenId = "#" + id + "effortDrivenEdit";
                typeId = "#" + id + "taskTypeEdit";
                workId = "#" + id + "workEdit";
            }
            var startDate = $(startDateId).val(),
                endDate = $(endDateId).val(),
                duration = $(durationId).val(),
                work = $(workId).val();
            if ((targetId === id + "startDateEdit") || (targetId === id + "startDateAdd"))
            if (!startDate) {
                startDate = editedObj ? editedObj.startDate : undefined;
            }
            if (!duration) {
                duration = editedObj ? editedObj.duration : undefined;
            }
            if (!endDate) {
                endDate = editedObj ? editedObj.endDate : undefined;
            }
            if ((targetId === id + "startDateEdit") || (targetId === id + "startDateAdd")){
                startDate = args.value ? proxy._getDateFromFormat(args.value) : startDate;
                startDate = proxy._checkStartDate(startDate, editedObj);
                if (proxy.getFormatedDate(startDate) != args.value) {


                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $(startDateId).ejDateTimePicker("option", "value", startDate);
                    else
                        $(startDateId).ejDatePicker("option", "value", startDate);
                }
                var tempEndDate = proxy._getEndDate(startDate, editedObj.duration, editedObj.durationUnit, editedObj);
                editedObj.startDate = startDate;
                editedObj.endDate = tempEndDate;
                if (model.dateFormat.indexOf("hh") != -1)
                    $(endDateId).ejDateTimePicker("option", "value", tempEndDate);
                else
                    $(endDateId).ejDatePicker("option", "value", tempEndDate);
            }

            else if((targetId=== id + "endDateEdit") ||(targetId===id + "endDateAdd")){
                endDate = args.value ? proxy._getDateFromFormat(args.value) : endDate;
                if (endDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDate);
                endDate = this._checkEndDate(endDate, editedObj);
                if (proxy.getFormatedDate(endDate) != args.value) {
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }

                if (editedObj.isMilestone) {
                    editedObj.startDate = this._checkStartDate(editedObj.startDate, editedObj);

                    if (proxy.getFormatedDate(editedObj.startDate) != startDate) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(startDateId).ejDateTimePicker("option", "value", editedObj.startDate);
                        else
                            $(startDateId).ejDatePicker("option", "value", editedObj.startDate);
                    }
                proxy._updateResourceRelatedFields(editedObj);
                $(workId).ejNumericTextbox("option", "value", editedObj.work);
                $(durationId).val(proxy._getDurationStringValue(editedObj));
                }
                if (editedObj.startDate.getTime() <= endDate.getTime()) {
                    editedObj.endDate = endDate;
                    editedObj.duration = this._getDuration(editedObj.startDate, endDate, editedObj.durationUnit, editedObj.isAutoSchedule);
                    duration = proxy._getDurationStringValue(editedObj);
                    $(durationId).val(duration);
                } else {

                    if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", editedObj.endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", editedObj.endDate);

                }
            }
              
            else if ((targetId === id + "durationEdit") || (targetId === id + "durationAdd")) {
                var values = proxy._getDurationValues(duration, true);
                durationVal = values.duration;
                durationUnit = values.durationUnit;
                if (editedObj.duration != durationVal || editedObj.durationUnit != durationUnit) {
                    //calculate end date and update it
                    editedObj.duration = durationVal;
                    editedObj.durationUnit = durationUnit;
                    if (editedObj.isMilestone) {
                        if (editedObj.duration > 0)
                            editedObj.isMilestone = false;
                        else
                            editedObj.isMilestone = true;
                        editedObj.startDate = this._checkStartDate(editedObj.startDate, editedObj);
                        if (proxy.getFormatedDate(editedObj.startDate) != startDate) {
                            if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                                $(startDateId).ejDateTimePicker("option", "value", editedObj.startDate);
                            else
                                $(startDateId).ejDatePicker("option", "value", editedObj.startDate);
                        }
                    }
                    endDate = this._getEndDate(editedObj.startDate, durationVal, durationUnit, editedObj);
                    editedObj.endDate = endDate;
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }
                proxy._updateResourceRelatedFields(editedObj);
                if (!effortDriven)
                    $(workId).ejNumericTextbox("option", "value", editedObj.work);
                $(durationId).val(proxy._getDurationStringValue(editedObj));
                if (editedObj.taskType == "fixedWork")
                    proxy._updateResourceDataSource(editedObj);                                   
            }
            else if ((targetId === id + "workEdit") || (targetId === id + "workAdd")) {
                editedObj.work = parseInt(work);
                proxy._updateResourceRelatedFields(editedObj);
                if (editedObj.taskType != "fixedDuration" && editedObj.isAutoSchedule) {                    
                    $(durationId).val(proxy._getDurationStringValue(editedObj));
                    endDate = this._getEndDate(editedObj.startDate, editedObj.duration, editedObj.durationUnit, editedObj);
                    editedObj.endDate = endDate;
                    if (model.dateFormat.indexOf("hh") != -1)
                        $(endDateId).ejDateTimePicker("option", "value", endDate);
                    else
                        $(endDateId).ejDatePicker("option", "value", endDate);
                }
                else
                    proxy._updateResourceDataSource(editedObj);
            }
            else if (targetId === id + "baselineStartDateAdd") {
                if ($(baselineEndDateId).length > 0) {
                    var baselineStartDate = proxy._getDateFromFormat($(baselineStartDateId).val());
                    var baselineEndDate = proxy._getDateFromFormat($(baselineEndDateId).val());
                    if (baselineStartDate && baselineEndDate && baselineStartDate.getTime() > baselineEndDate.getTime()) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(baselineStartDateId).ejDateTimePicker("option", "value", args.prevDate);
                        else
                            $(baselineStartDateId).ejDatePicker("option", "value", args.prevDate);
                    }
                }

            } else if (targetId === id + "baselineEndDateAdd") {
                if ($(baselineStartDateId).length > 0) {
                    var baselineStartDate = proxy._getDateFromFormat($(baselineStartDateId).val());
                    var baselineEndDate = proxy._getDateFromFormat($(baselineEndDateId).val());
                    if (baselineStartDate && baselineEndDate && baselineStartDate.getTime() > baselineEndDate.getTime()) {
                        if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                            $(baselineEndDateId).ejDateTimePicker("option", "value", args.prevDate);
                        else
                            $(baselineEndDateId).ejDatePicker("option", "value", args.prevDate);
                    }
                }
            }
            this._editedDialogRecord.isUpdatedFromDialog = false;
        },

        //Create task name collection from records for edit dialog
        _taskNameCollection:function()
        {
            var proxy = this,
            records = proxy.model.flatRecords,
            names = [],
            idsCollection = [];
            proxy._preTableCollection = [];
            for(var i=0;i<records.length;i++)
            {
                var temp = { id: records[i].taskId.toString(), text: (records[i].taskId.toString() + "-" + records[i].taskName), value: (records[i].taskId.toString() + "-" + records[i].taskName)};
                var ids = { id: (records[i].taskId.toString() + "-" + records[i].taskName), text: records[i].taskId.toString(), value: records[i].taskId.toString() };
                names.push(temp);
                idsCollection.push(ids);
            }            
            proxy._preTableCollection.push(idsCollection);
            proxy._preTableCollection.push(names);
        },

        //get ID array from predecessor string
        _idFromPredecessor:function(pre)
        {
            var str = "123FS+2";
            var preArray = pre.split(',');
            var preIdArray = [];
           

            for (var j = 0; j < preArray.length; j++)
            {
                var strArray = [];
                for (var i = 0; i < preArray[j].length; i++) {
                    if (!isNaN(preArray[j].charAt(i))) {
                        strArray.push(preArray[j].charAt(i));
                    }
                    else {
                        break;
                    }
                }
                preIdArray.push((strArray.join('')));
            }
            return preIdArray;
        },

        //Change the id name while task name is selected in dialog
        _preIdChangByName:function()
        {
            var proxy = this,
                $form = $("#" + proxy._id + "PreEditForm"),
                $targetTr = $form.closest("tr"),
                $val = $form.find(".onEdit"),
                names = proxy._taskNameCollection();

            var id = $.map(names, function (obj, index) {
                if (obj.text === $val.val()) {
                    return obj.id;
                }
            });
            id = id[0];
            $targetTr.find(".id").html(id);
        },

        //handle end edit event in dialog box predecessor editing
        _preEndEdit:function(editDialogId,dialogType,args)
        {
            var proxy = this,
                dataSource = args.model.dataSource,
                selectedItem = args.model.selectedItem,
                tempId, id, curent;
            proxy._taskNameCollection();
            if (args.value !== null && (args.columnName === "name" || args.columnName === "id")) {
                if (args.columnName === "name" && args.value.length > 0) {
                    tempId = args.value.split('-');
                    id = $.map(proxy._preTableCollection[1], function (obj, index) {
                        if (obj.id === tempId[0]) {
                            return obj.id;
                        }
                    });
                    id = id[0];
                    selectedItem.id = id;
                    selectedItem.name = args.value;
                    curent = dataSource.indexOf(selectedItem.item);
                    if (curent === -1) {
                        dataSource.push(selectedItem.item);
                        curent = dataSource.indexOf(selectedItem.item);
                    }
                    dataSource[curent].id = id;
                    dataSource[curent].name = args.value;
                }
                if (args.columnName === "id" && args.value.length > 0) {

                    var name = $.map(proxy._preTableCollection[0], function (obj, index) {
                        if (obj.value === args.value) {
                            return obj.id;
                        }
                    });
                    name = name[0];
                    selectedItem.name = name;
                    selectedItem.id = id;
                    curent = dataSource.indexOf(selectedItem.item);
                    if (curent === -1) {
                        dataSource.push(selectedItem.item);
                        curent = dataSource.indexOf(selectedItem.item);
                    }
                    dataSource[curent].name = name;
                }

                if (!selectedItem.type && !ej.isNullOrUndefined(curent)) {
                    selectedItem.type = "Finish-Start";
                    dataSource[curent].type = "Finish-Start";
                }
                $(editDialogId).ejTreeGrid("refreshRow", args.model.selectedRowIndex);
                $(editDialogId).ejTreeGrid("selectRows", args.model.selectedRowIndex);
                proxy._enbleDisablePredecessorAddButton('enable', dialogType);
            }
        },
        //udapte the status of predecessor delete button in dialog
        _enableDisablePredecessorDelete: function (dialogType, args)
        {
            var proxy = this,
                predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_PredecesorDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_PredecesorDelete");
            $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy)).bind("click", $.proxy(proxy._deletepredecessor, proxy));
            $(predecessorDelete).removeClass("e-disable").addClass("e-enable");
        },

        //udapte the status of resource delete button in dialog
        _enableDisableResouceDelete: function (dialogType,args) {
            var proxy = this, resourceDelete;
            if (dialogType == "add")
                resourceDelete = $("#" + proxy._id + "AddDialog_ResourceDelete");
            else
                resourceDelete = $("#" + proxy._id + "EditDialog_ResourceDelete");
            $(resourceDelete).unbind("click", $.proxy(proxy._deleteResource, proxy)).bind("click", $.proxy(proxy._deleteResource, proxy));
            $(resourceDelete).removeClass("e-disable").addClass("e-enable");
        },

        //prepare data source for dropdown in predecessor edit in dialog box
        _predecessorEditCollection:function(){
        
            var proxy = this,
               model = proxy.model,
               collection,
               gridId,
               types,
               data = [],
               selectedItem;
            gridId = "#" + proxy._id + "predecessor";            
            types = proxy._predecessorCollectionText;
            data = [];
            selectedItem = model.selectedItem;
            proxy._taskNameCollection();
            collection = proxy._preTableCollection[1];
            if (!ej.isNullOrUndefined(selectedItem) && !ej.isNullOrUndefined(selectedItem.predecessor) && !ej.isNullOrUndefined(selectedItem.item[model.predecessorMapping]))
            {
                var predecessor = selectedItem.predecessor,
                    predecessorLength = predecessor.length,
                    typeLength = types.length,
                    collectionLength = collection.length;
                for (var i = 0; i < predecessorLength; i++) {
                    var id = predecessor[i].from;
                    if (selectedItem.taskId.toString()!==id.toString())
                    {
                        var taskName, type, lags = 0;
                        for (var j = 0; j < collectionLength; j++) {
                            if (collection[j].id === id) {
                                taskName = collection[j].value;
                                break;
                            }
                        }
                        for (var k = 0; k < typeLength; k++) {
                            if (types[k].id == predecessor[i].predecessorsType) {
                                type = types[k].text;
                            }
                        }

                        var multiple = Math.abs(predecessor[i].offset) != 1, val = "";
                        if (predecessor[i].offsetDurationUnit == "day")
                            val += multiple ? this._durationUnitTexts.days : this._durationUnitTexts.day;
                        else if (predecessor[i].offsetDurationUnit == "hour")
                            val += multiple ? this._durationUnitTexts.hours : this._durationUnitTexts.hour;
                        else
                            val += multiple ? this._durationUnitTexts.minutes : this._durationUnitTexts.minute;

                        lags = (predecessor[i].offset + " " + val);
                        var obj = { id: id, name: taskName, type: type, offset: lags };
                        data.push(obj);
                    }
                }
            }
            return data;
        },
        _getResourceInfoIndex: function (resourceIdcollection, resourcecollection) {

            var count = 0,
            resources = [];
            if (resourceIdcollection && resourcecollection) {
                for (count; count < resourceIdcollection.length; count++) {
                    if (resourcecollection[resourceIdcollection[count]])
                        resources.push(resourceIdcollection[count]);
                }
            }
            return resources;
        },
        //render control in diaog box as per template created
        _refreshEditForm: function (args) {
            var proxy = this,
                elementFocused = false,
                $formElement,
                percent = 86,
                i = 0, form, length,
                $element,
                inputWidth = "165px",
                model = proxy.model,
                width,
                params = {},
                value,
                column,
                customParams,
                toformat, newIdInstant,
                formatVal, editTreeGridId,
                selectedItem = model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];

            if (args.requestType == "add") {
                var tab = document.getElementById(proxy._id + "AddTab"),
                    dialog = $("#" + proxy._id + "_dialogAdd_wrapper"),
                form = document.getElementById(proxy._id + "GeneralAddForm"),
                editTreeGridId = "#treegrid" + proxy._id + "predecessorAdd",
                noteRteId = "#" + proxy._id + "AddAreaNotes",
                resourceTreeGridId = "#treegrid" + proxy._id + "resourceAdd",
                customFieldTreeGridId = "#treegrid" + proxy._id + "customFieldAdd";
                if (!ej.isNullOrUndefined(this.dataSource()) && this.dataSource().length == 0 && model.predecessorMapping && $(editTreeGridId).length > 0) {
                    var index = [];
                    index[0] = proxy._dialogTab.indexOf("Predecessors");
                    $("#" + proxy._id + "AddTab").ejTab("option", "disabledItemIndex", index);
                }
                else {
                    var index = [];
                    index[0] = proxy._dialogTab.indexOf("Predecessors");
                    $("#" + proxy._id + "AddTab").ejTab("option", "enabledItemIndex", index);
                    $("#" + proxy._id + "AddTab").find("div.e-content").css("overflow", "visible");
                }                
                newIdInstant = proxy._getNewTaskId();
                if (proxy.model.enableWBS) {
                    var rowPos = model.editSettings.rowPosition.toLowerCase(),
                        newWBSval = proxy._getNewWBSid(rowPos);
                }
            }
            else {
                var tab = document.getElementById(proxy._id + "EditTab"),
                    dialog = $("#" + proxy._id + "_dialogEdit_wrapper"),
                    form = document.getElementById(proxy._id + "GeneralEditForm"),
                    editTreeGridId = "#treegrid" + proxy._id + "predecessorEdit",
                    noteRteId = "#" + proxy._id + "EditAreaNotes",
                    resourceTreeGridId = "#treegrid" + proxy._id + "resourceEdit",
                    customFieldTreeGridId = "#treegrid" + proxy._id + "customFieldEdit";
                if (model.flatRecords.length <= 2 && model.parentRecords.length == 1
                    && model.predecessorMapping && $(editTreeGridId).length > 0)
                    $("#" + proxy._id + "EditTab").ejTab("removeItem", 1);

            }
            $formElement = $(form).find("input,select");
            length = $formElement.length;
            for (i; i < length; i++) {
                $element = $formElement.eq(i);
                params = {};
                inputWidth = 180;
                column = ej.TreeGrid.getColumnByField(proxy._columns, $element.prop("name"));

                if (column)
                    value = args.data[column.field];
                else
                    continue;

                if ($element.hasClass("e-numerictextbox")) {

                    width = inputWidth;
                    params.width = width;
                    params.showSpinButton = true;
                    params.cssClass = model.cssClass;
                    //for parent editing 
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && (tempId == "statusEdit" ||tempId == "workEdit")) {
                        params.readOnly = true;
                        $element.closest("td").css("opacity", 0.5);
                    }
                    if (tempId == "statusEdit" || tempId == "statusAdd") {
                            params.maxValue = 100;
                            params.minValue = 0;
                        }
                        if (tempId == "workEdit") {
                            params.change = function (args) {
                                proxy._updatedColumn = "work";
                                proxy._editStartDateChange($(this.element[0]));
                            }
                        }
                    if (value && value.toString().length)
                            params.value = parseFloat(value);
                        else
                        params.value = 0;

                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);
                    $element.ejNumericTextbox(params);
                    $element.prop("name", $element.prop("name").replace(proxy._id, ""));
                }
                else if ($element.hasClass("e-datepicker")) {

                    params.width = inputWidth;
                    params.cssClass = model.cssClass;
                    params.dateFormat = model.dateFormat;
                    params.locale = model.locale;
                    params.startDay = model.scheduleHeaderSettings.weekStartDay;
                    params.change = function (args) {
                        this.option("value", args.value);
                        proxy._updatedColumn = this.element[0].name;
                        proxy._editStartDateChange(this.element, args);
                        var tempId = this.element[0].id;
                        tempId = tempId.replace(proxy._id, '');
                        if (tempId == "startDateEdit" || tempId == "endDateEdit")
                            proxy._datePickerChangeEvent = true;
                    };
                    var tempId = $element[0].id;
                    tempId = tempId.replace(proxy._id, '');
                    if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && selectedItem.isAutoSchedule && (tempId == "startDateEdit" || tempId == "endDateEdit") && args.requestType !== "add") {
                        params.readOnly = true;
                        $element.closest("td").css("opacity", 0.5);
                    }
                    if (value && value.toString().length)
                        params.value = proxy._getDateFromFormat(value.toString());
                    else
                        params.value = proxy._getDateFromFormat(model.scheduleStartDate);


                    if (column["format"] !== undefined && column.format.length > 0) {
                        toformat = new RegExp("\\{0(:([^\\}]+))?\\}", "gm");
                        formatVal = toformat.exec(column.format);
                        params.dateFormat = formatVal[2];
                        params.value = ej.format(new Date(params.value), params.dateFormat, params.locale);
                        $element.val(params.value);
                    }
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(params, column["editParams"]);

                    $element.ejDatePicker(params);
                }
                else if ($element.hasClass("e-datetimepicker")) {

                    params = {
                        width: inputWidth,
                        rtl: model.rtl,
                        locale: model.locale,
                            cssClass: model.css,
                            dateTimeFormat: model.dateFormat,
                            startDay : model.scheduleHeaderSettings.weekStartDay
                        };
                        params.change = function (args) {
                            proxy._updatedColumn = this.element[0].name;
                            if (this._prevDateTimeVal)
                                proxy._editStartDateChange(this.element, args);
                            var tempId = this.element[0].id;
                            tempId = tempId.replace(proxy._id, '');
                            if (tempId == "startDateEdit" || tempId == "endDateEdit")
                                proxy._datePickerChangeEvent = true;
                        };
                        var tempId = $element[0].id;
                        tempId = tempId.replace(proxy._id, '');
                        if (!ej.isNullOrUndefined(selectedItem) && selectedItem.hasChildRecords && selectedItem.isAutoSchedule && selectedItem.isAutoSchedule && (tempId == "startDate" || tempId == "endDate") && args.requestType !== "add" ) {
                            params.readOnly = true;
                            $element.closest("td").css("opacity", 0.5);
                        }
                    if (value && value.toString().length)
                        params.value = proxy._getDateFromFormat(value.toString());
                        else
                        params.value = proxy._getDateFromFormat(model.scheduleStartDate);

                        if (!ej.isNullOrUndefined(column["editParams"]))
                            $.extend(params, column["editParams"]);
                        
                    $element.ejDateTimePicker(params);
                }
                else if ($element.hasClass("e-dropdownlist")) {

                    var dataSource = column.dropdownData;
                    if (column.field === "resourceInfo") {
                        $element.ejDropDownList({
                            cssClass: model.cssClass,
                            width: inputWidth,
                            showCheckbox: true,
                            dataSource: dataSource,
                            fields: { id: model.resourceIdMapping, text: model.resourceNameMapping, value: model.resourceNameMapping },
                                selectedItems: args.requestType == "add" ? proxy._getResourceInfoIndex(args.data.resourceInfo, model.resources) : proxy.getIndexofresourceInfo(dataSource, args.data)
                            });
                        }                       
                        else {
                            var controlArgs = {};
                            controlArgs.cssClass = model.cssClass;
                            controlArgs.width = inputWidth;
                            controlArgs.dataSource = dataSource;
                            controlArgs.value = value;
                            controlArgs.change = function (args) {
                                proxy._updateEditDialogFields(this);
                            };
                            if (!ej.isNullOrUndefined(column["editParams"]))
                                $.extend(controlArgs, column["editParams"]);
                            if ($element.val.length) {
                                if (column.field == "taskMode") {                                   
                                    var value = args.requestType == "beginedit" ? !args.data.isAutoSchedule : model.taskSchedulingMode == "manual" ? true : false;
                                    controlArgs.value = value.toString();
                                }
                                else if (column.field == "taskType") {
                                    controlArgs.value = args.requestType == "beginedit" ? args.data.taskType : proxy.model.taskType;                                    
                                }
                                else if (column.field == "effortDriven") {
                                    controlArgs.value = args.requestType == "beginedit" ? args.data.effortDriven : model.taskType == "fixedWork" ? true : false;                                   
                                }
                            }
                            if (args.requestType == "beginedit" && !args.data.isAutoSchedule && (column.field == "taskType" || column.field == "effortDriven"))
                                controlArgs.enabled = false;
                            if (args.data.taskType == "fixedWork" && column.field == "effortDriven")
                                controlArgs.enabled = false;
                            if (args.requestType == "add" && column.field == "effortDriven" && model.taskType == "fixedWork")
                                controlArgs.enabled = false;
                            if ((column.field == "taskType" || column.field == "effortDriven") && args.data.hasChildRecords)
                                controlArgs.enabled = false;
                            if (column.field == "taskMode" && model.taskSchedulingMode != ej.Gantt.TaskSchedulingMode.Custom)
                                controlArgs.enabled = false;
                            $element.val(controlArgs.value);
                            $element.ejDropDownList(controlArgs);

                            var obj = $element.ejDropDownList("instance");
                            obj._setValue($element.val());

                        }
                    }
                else if ($element.hasClass("e-maskedit")) {
                    var controlArgs = {};
                    controlArgs.locale = model.locale;
                    controlArgs.cssClass = model.cssClass;
                    controlArgs.width = inputWidth;
                    if (!ej.isNullOrUndefined(column["editParams"]))
                        $.extend(controlArgs, column["editParams"]);

                    $element.ejMaskEdit(controlArgs);
                }
                else {
                    switch ($element.prop('tagName')) {
                        case "INPUT":

                            if ($element.attr("type") != "checkbox") {
                                //For ID field id is read only

                                if ($element.attr("name") === "taskId") {
                                    if (args.requestType !== "add") {
                                        $element.attr("readonly", "readonly");
                                        $element.css("opacity", 0.5);
                                        $element.val(args.data.taskId);
                                    }
                                    else if (args.requestType === "add") {
                                        if (args.data.taskId == "" || ej.isNullOrUndefined(args.data.taskId))
                                            $element.val(newIdInstant);
                                        else
                                            $element.val(args.data.taskId);
                                    }
                                }
                                else if ($element.attr("name") === "taskName") {
                                    if (args.requestType === "add") {
                                        if (args.data.taskName == "" || ej.isNullOrUndefined(args.data.taskName))
                                            $element.val(proxy._newTaskTexts["newTaskName"] + " " + newIdInstant);
                                        else
                                            $element.val(args.data.taskName);
                                    }
                                    else
                                        $element.val(args.data.taskName);
                                }
                                else if ($element.attr("name") === "duration") {
                                    args.data && $element.val(proxy._getDurationStringValue(args.data));
                                    var durationValues = proxy._getDurationValues(args.data);
                                    if (args.requestType !== "add" && args.data.hasChildRecords && args.data.isAutoSchedule) {
                                        $element.attr("readonly", "readonly");
                                        $element.css("opacity", 0.5);
                                    } else if ((args.requestType == "add") && args.data.duration == "") {
                                        $element.val("0 " + proxy._durationUnitTexts[durationValues.durationUnit]);
                                    }
                                    else
                                    {
                                        var duration = args.data.duration;
                                        if (typeof duration == "string")
                                            duration = parseFloat(duration);
                                        duration = !isNaN(duration) ? duration : 0;
                                        $element.val(parseFloat(duration.toFixed(2)) + " " + proxy._durationUnitTexts[durationValues.durationUnit]);
                                    }
                                       

                                        $element.change(function () {
                                            proxy._updatedColumn = "duration";
                                            proxy._editStartDateChange($(this));                                            
                                        });
                                        $element.keyup(function (e) {
                                            if (e.keyCode == 13)
                                            proxy._editStartDateChange($(this));
                                    });
                                }
                                else if ($element.attr("name") === "WBS") {
                                    if (args.requestType !== "add") {
                                        $element.attr("readonly", "readonly").css("opacity", 0.5);
                                        $element.val(args.data.WBS);
                                    }
                                    else if (args.requestType === "add") {
                                        $element.val(newWBSval);
                                        $element.attr("readonly", "readonly").css("opacity", 0.5);
                                    }
                                }
                                else if ($element.attr("name") === "WBSPredecessor")
                                    $element.attr("readonly", "readonly").css("opacity", 0.5);
                                if ($element.attr("name") === "taskName")
                                    inputWidth = 380;
                                var tempId = $element[0].id;
                                tempId = tempId.replace(proxy._id, '');

                                $element.css("text-align", $element.attr("name") != null && ej.TreeGrid.getColumnByField(proxy._columns, $element.prop("name")) != null ?
                                    ej.TreeGrid.getColumnByField(proxy._columns, $element.attr("name")).textAlign : "center");
                                $element.outerWidth(inputWidth);
                            } else {
                                var controlArgs = {};
                                controlArgs.cssClass = model.cssClass;
                                controlArgs.size = "medium";
                                if (!ej.isNullOrUndefined(column["editParams"]))
                                    $.extend(params, column["editParams"]);
                                $element.ejCheckBox(controlArgs);
                            }
                            break;

                        case "SELECT":
                            $element.width(inputWidth).height(23);
                            break;
                    }
                }
                if (!$element.is(":disabled") && !elementFocused && (!$element.is(":hidden") || typeof $element.data("ejDropDownList") == "object")) {
                    if (!proxy._isEnterKeyPressed) {
                        proxy._focusElements($element.closest('td'));
                        elementFocused = true;
                    }
                }
            }
            //render prdecessor table in edit dialog
            if (model.predecessorMapping && $(editTreeGridId).length) {
                var ds = [];
                if (args.requestType !== "add") {
                    ds = proxy._predecessorEditCollection();
                }
                proxy._taskNameCollection();                
                var types = proxy._predecessorCollectionText;
                $(editTreeGridId).ejTreeGrid({
                    dataSource: ds,
                    allowSorting: false,
                    columns: [{ headerText: proxy._columnHeaderTexts["taskId"], field: "id", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: proxy._preTableCollection[0], width: "89px" },
                              { headerText: proxy._columnHeaderTexts["taskName"], field: "name", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: proxy._preTableCollection[1], width: "300px" },
                              { headerText: proxy._columnHeaderTexts["type"], field: "type", editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: types, width: "141px" },
                              { headerText: proxy._columnHeaderTexts["offset"], field: "offset", editType: ej.TreeGrid.EditingType.String, width: "88px" }],
                    enableAltRow: false,
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        rowPosition: "bottom",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    locale: model.locale,
                    endEdit: $.proxy(proxy._preEndEdit, proxy, editTreeGridId, args.requestType),
                    beginEdit: $.proxy(proxy._preBeginEdit, proxy),
                    rowSelected: $.proxy(proxy._enableDisablePredecessorDelete, proxy, args.requestType),
                    actionComplete: function (eventArgs) {
                        if (eventArgs.requestType == "delete") {
                            proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                            proxy._disablePredecessorAddButton(editTreeGridId, args.requestType);
                        }
                    },
                    treeColumnIndex: 5,
                    predecessorTable: proxy._isFromGantt,
                    sizeSettings: { width: "620px", height: "198px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });

                if (model.selectedItem && model.selectedItem.hasChildRecords && args.requestType !== "add") {
                    proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                    proxy._enbleDisablePredecessorAddButton('disable', args.requestType);
                }
                else {
                    proxy._enbleDisablePredecessorDeleteButton('disable', args.requestType);
                    proxy._enbleDisablePredecessorAddButton('enable', args.requestType);
                }
            }

            //Render resource table in add and edit dialog
            if (model.resourceInfoMapping && $(resourceTreeGridId).length) {
                var resourceData = [],
                    resoruce = $.extend(true, [], model.resources);
                if (args.requestType != "add") {
                    var resource = args.data.resourceInfo,
                        length = resource ? resource.length : 0;
                    for (var i = 0; i < length; i++) {
                        resourceData.push({ "name": resource[i][model.resourceIdMapping], "unit": resource[i][model.resourceUnitMapping] });
                    }
                }
                else if (args.data.resourceInfo.length != 0) {
                    ganttRecord = new ej.Gantt.GanttRecord();
                    ganttRecord.item = args.data;
                    var resourceCollection = model.resources, resourceInfo = args.data.resourceInfo;
                    ganttRecord.resourceInfo = resourceInfo && ganttRecord._setResourceInfo(resourceInfo, model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, resourceCollection);
                    var resource = ganttRecord.resourceInfo,
                        length = resource ? resource.length : 0;
                    for (var i = 0; i < length; i++) {
                        resourceData.push({ "name": resource[i][model.resourceIdMapping], "unit": resource[i][model.resourceUnitMapping] });
                    }
                }
                var resoruce = $.extend(true, [], model.resources);
                $(resourceTreeGridId).ejTreeGrid({
                    dataSource: resourceData,                    
                    columns: [{
                        headerText: proxy._columnHeaderTexts["resourceInfo"], field: "name", width: "309px",
                        editType: ej.TreeGrid.EditingType.Dropdown, dropdownData: resoruce, editParams: { fields: { text: model.resourceNameMapping, value: model.resourceIdMapping } }
                    },
                              {
                                  headerText: proxy._columnHeaderTexts["unit"], field: "unit", width: "309px",
                                  editType: ej.TreeGrid.EditingType.Numeric, visible: true, headerTextAlign: "center"
                              }
                    ],
                    enableAltRow: false,
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    locale: model.locale,
                    endEdit: $.proxy(proxy._resourceEndEdit, proxy, resourceTreeGridId, args.requestType),
                    beginEdit: $.proxy(proxy._resourceBeginEdit, proxy, resourceTreeGridId),
                    rowSelected: $.proxy(proxy._enableDisableResouceDelete, proxy, args.requestType),
                    actionBegin: function (args) {
                        if (args.requestType == "delete" || args.requestType == "sorting")
                            this.model.columns[0].dropdownData = $.extend(true, [], proxy.model.resources);
                    },
                    actionComplete: function (eventArgs) {
                        if (eventArgs.requestType == "delete") {
                            proxy._enableDisableResourceAddButton(eventArgs, true, args.requestType);
                            proxy.enbleDisableDeleteResourceButton('disable', args.requestType);
                        }
                    },
                    treeColumnIndex: 3,
                    resourceTable: proxy._isFromGantt,
                    sizeSettings: { width: "620px", height: "198px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });
                if (args.requestType !== "add" && resourceData.length == model.resources.length) {
                    proxy.enbleDisableDeleteResourceButton('enable', args.requestType);
                    proxy.enbleDisableAddResourceButton('disable', args.requestType);
                }
                else {
                    proxy.enbleDisableDeleteResourceButton('disable', args.requestType);
                    proxy.enbleDisableAddResourceButton('enable', args.requestType);
                }
            }
            //Render custom field tab in add and edit dialog
            if ($(customFieldTreeGridId).length) {
                if (args.requestType == "add") {
                    var customColumns = proxy._addDialogCustomColumns,
                        gridData = [],
                        id = 0,
                        length = customColumns.length;
                    for (var i = 0; i < length; i++) {
                        id++;
                        var data = {};
                        data.id = id;
                        data.field = customColumns[i].field;
                        data.headerText = customColumns[i].headerText;
                        data.value = args.data[customColumns[i].field];
                        data.text = args.data[customColumns[i].field];
                        data.editType = customColumns[i].editType ? customColumns[i].editType.toLowerCase() : "stringedit";
                        gridData.push(data);
                    }
                }
                else {
                    var customColumns = proxy._editDialogCustomColumns,
                        gridData = [],
                        id = 0,
                        length = customColumns.length;
                    for (var i = 0; i < length; i++) {
                        id++;
                        var data = {};
                        data.id = id;
                        data.field = customColumns[i].field;
                        data.headerText = customColumns[i].headerText;
                        data.value = args.data[customColumns[i].field];

                        data.editType = customColumns[i].editType ? customColumns[i].editType.toLowerCase() : "stringedit";
                        if (customColumns[i].editType.toLowerCase() == "dropdownedit") {
                            data.text = ej.isNullOrUndefined(args.data[customColumns[i].field]) ? "" : proxy._getDropDownText(customColumns[i], args.data[customColumns[i].field]);
                        }
                        else
                            data.text = args.data[customColumns[i].field];
                        gridData.push(data);
                    }
                }
                $(customFieldTreeGridId).ejTreeGrid({
                    dataSource: gridData,
                    allowSorting: false,
                    locale: model.locale,
                    enableAltRow: false,
                    rowHeight:30,
                    columns: [{ headerText: proxy._columnHeaderTexts["dialogCustomFieldName"], field: "headerText", allowEditing: false },
                              { headerText: "Original Value", field: "value", visible: false },
                              { headerText: "Field", field: "field", visible: false },
                              {
                                  headerText: proxy._columnHeaderTexts["dialogCustomFieldValue"], field: "text",
                                  editTemplate: {
                                      create: function () {
                                          return "<input style='width:100%;'>";
                                      },
                                      read: $.proxy(proxy._customColumnRead, proxy, customFieldTreeGridId),
                                      write: $.proxy(proxy._customColumnWrite, proxy, customColumns, customFieldTreeGridId),
                                  }
                              }
                    ],
                    allowColumnResize: true,
                    editSettings: {
                        allowAdding: true,
                        allowDeleting: true,
                        allowEditing: true,
                        editMode: "cellEditing",
                        beginEditAction: ej.TreeGrid.BeginEditAction.Click
                    },
                    sizeSettings: { width: "620px", height: "234px" },
                    isResponsive: false,
                    cssClass: model.cssClass
                });
            }
            //Render the RTE control for notes tab.
            if (model.notesMapping && $(noteRteId).length) {
                var value;
                if (args.requestType == "add")
                    value = args.data.notes;
                else {
                    var htmlText = args.data.item[model.notesMapping];
                    value = htmlText;
                }
                $(noteRteId).ejRTE({
                    width: "620px", isResponsive: false, height: "281px", value: value,
                    locale: model.locale,
                    cssClass: model.cssClass,
                    tools: {
                        font: ["fontName", "fontSize", "fontColor", "backgroundColor"],
                        style: ["bold", "italic", "underline", "strikethrough"],
                        alignment: ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],
                        doAction: ["undo", "redo"],
                        indenting: [],
                        clear: [],
                        links: ["createLink", "removeLink"],
                        images: [],
                        media: [],
                        tables: [],
                        lists: ["unorderedList"],
                        clipboard: [],
                        edit: [],
                        formatStyle: [],
                        view: []
                    }
                });
                $(noteRteId + "_wrapper").find(".e-toolbar.e-toolbarspan").css("border-bottom", "none"); // Remove the border bottom of rich text editor toolbar.
                $(noteRteId + "_editor").height("208");
                $(noteRteId + "_Iframe")[0].style.height = "203px";
                $(dialog).removeClass("e-rte");
            }
        },
        //updated the status of predecessor delelte button in dialog box
        _enbleDisablePredecessorDeleteButton: function (args, dialogType) {
            var proxy = this,
                 predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_PredecesorDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_PredecesorDelete");
            if (args === "enable") {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy)).bind("click", $.proxy(proxy._deletepredecessor, proxy));
                $(predecessorDelete).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deletepredecessor, proxy));
                $(predecessorDelete).addClass('e-disable').removeClass('e-enable');
            }
        },

        //updated the status of predecessor button in dialog box
        _enbleDisablePredecessorAddButton: function (args, dialogType) {
            var proxy = this,
                predecessorAdd = "";
            if (dialogType == "add")
                predecessorAdd = $("#" + proxy._id + "AddDialog_PredecesorAdd");
            else
                predecessorAdd = $("#" + proxy._id + "EditDialog_PredecesorAdd");

            if (args === "enable") {
                $(predecessorAdd).unbind("click", $.proxy(proxy._addpredecessor, proxy)).bind("click", $.proxy(proxy._addpredecessor, proxy));
                $(predecessorAdd).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorAdd).unbind("click", $.proxy(proxy._addpredecessor, proxy));
                $(predecessorAdd).addClass('e-disable').removeClass('e-enable');
            }
        },

        //updated the status of predecessor button in dialog box
        _disablePredecessorAddButton: function (treeGridId, dialogType) {
            var proxy = this;
            var table = $(treeGridId + "e-table");
            var flag = false;
            var len = table[0].rows.length;
            proxy._enbleDisablePredecessorAddButton('disable', dialogType);
            for (var j = 0; j < len; j++) {
                var currentRow = table[0].rows[j];
                if (currentRow.cells.length === 4)
                    if (currentRow.cells[1].innerText === "") {
                        flag = true;
                    }
            }
            if (!flag) {
                proxy._enbleDisablePredecessorAddButton('enable', dialogType);
            }
        },

        //Dynamically update input elements fields in add/edit dialog box according with another fields change.
        _updateEditDialogFields: function (editObj) {
            var proxy = this,
                typeObj, effortDrivenObj,
                reuestType = $(editObj.element).attr("data-dialog");
            if (reuestType == "Add") {
                effortDrivenObj = $("#" + proxy._id + "effortDrivenAdd").data("ejDropDownList");
                typeObj = $("#" + proxy._id + "taskTypeAdd").data("ejDropDownList");
            }
            else {
                effortDrivenObj = $("#" + proxy._id + "effortDrivenEdit").data("ejDropDownList");
                typeObj = $("#" + proxy._id + "taskTypeEdit").data("ejDropDownList");
            }
            if (!ej.isNullOrUndefined(effortDrivenObj) && editObj._name == "taskType") {
                if (editObj.model.value == "fixedWork") {
                    effortDrivenObj.selectItemByValue("true");
                    effortDrivenObj.disable();
                }
                else
                    effortDrivenObj.enable();

                proxy._editedDialogRecord[editObj._name] = editObj.model.value;
            }
            if (editObj._name == "taskMode") {
                if (editObj.model.text == "Auto") {
                    if (!ej.isNullOrUndefined(effortDrivenObj) && !ej.isNullOrUndefined(typeObj) && typeObj.model.value != "fixedWork")
                        effortDrivenObj.enable();
                    if (!ej.isNullOrUndefined(typeObj))
                        typeObj.enable();
                    proxy._editedDialogRecord["isAutoSchedule"] = true;
                }
                if (editObj.model.text == "Manual") {
                    if (!ej.isNullOrUndefined(effortDrivenObj))
                        effortDrivenObj.disable();
                    if (!ej.isNullOrUndefined(typeObj))
                        typeObj.disable();
                    proxy._editedDialogRecord["isAutoSchedule"] = false;
                }
            }

        },

        _customColumnWrite: function (customColumns, gridId, args) {
            var proxy = this,
                value = args.rowdata !== undefined ? args.rowdata["text"] : "",
                gridModel = $(gridId).ejTreeGrid("instance").model,
                column = customColumns[gridModel.selectedRowIndex],
                editParams = {};
            if (column.editParams)
                editParams = $.extend(true, {}, column.editParams);
            editParams.value = value;
            editParams.locale = proxy.model.locale;
            switch (args.rowdata.editType.toLowerCase()) {

                case "numericedit":
                    editParams.height = "25px";
                    args.element.ejNumericTextbox(editParams);
                    break;
                case "stringedit":
                    $(args.element).val(value).css({ "padding": "0px", "border": "0px", "height": "25px" }).addClass("e-ejinputtext");
                    break;
                case "datepicker":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.startDay = proxy.model.scheduleHeaderSettings.weekStartDay;
                    args.element.ejDatePicker(editParams);
                    break;
                case "datetimepicker":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.startDay = proxy.model.scheduleHeaderSettings.weekStartDay;
                    args.element.ejDateTimePicker(editParams);
                    break;
                case "maskedit":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    args.element.ejMaskEdit(editParams);
                    break;
                case "dropdownedit":
                    editParams.width = "100%";
                    editParams.height = "25px";
                    editParams.dataSource = column.dropdownData;
                    editParams.value = gridModel.currentViewData[gridModel.selectedRowIndex].value;
                    args.element.ejDropDownList(editParams);
                    break;
                case "booleanedit":
                    editParams.cssClass = proxy.model.cssClass;
                    editParams.size = "small";
                    editParams.checked = value;
                    args.element.ejCheckBox(editParams);
                    var parentElement = args.element.parent(".e-chkbox-wrap"),
                                formElement = parentElement.parent("form");

                    if (formElement.length > 0)
                        formElement.css("margin-left", "45%");
                    else
                        parentElement.css("margin-left", "45%");
                    break;
            }
        },

        _customColumnRead: function (gridId, args) {
            var value, text,
                treeGrid = $(gridId).ejTreeGrid("instance"),
                selectedRowIndex = treeGrid.model.selectedRowIndex,
                updatedRecords = treeGrid.model.updatedRecords;
            $(args).blur();
            $(args).focusout();
            if ($(args[0]).hasClass("e-numerictextbox"))
                value = text = $(args).ejNumericTextbox("getValue");
            else if ($(args[0]).hasClass("e-datepicker"))
                value = text = $(args).ejDatePicker("getValue");
            else if ($(args[0]).hasClass("e-datepicker"))
                value = text = $(args).ejDatePicker("getValue");
            else if ($(args[0]).hasClass("e-dattimeepicker"))
                value = text = $(args).ejDateTimePicker("getValue");
            else if ($(args[0]).hasClass("e-maskedit"))
                value = text = $(args[0]).ejMaskEdit("model.value");
            else if ($(args[0]).hasClass("e-dropdownlist")) {
                text = $(args[0]).ejDropDownList("model.text");
                value = $(args[0]).ejDropDownList("getSelectedValue");
            }
            else if ($(args[0]).hasClass("e-checkbox")) {
                value = text = $(args[0]).ejCheckBox('isChecked');
            }
            else
                value = text = $(args).val();
            updatedRecords[selectedRowIndex].value = value;
            updatedRecords[selectedRowIndex].text = text;
            treeGrid.refreshRow(selectedRowIndex);
            return text;
        },

        //updated the status of predecessor button in dialog box
        _enableDisableResourceAddButton: function (args,enableResourceAdd,dialogType) {
            var proxy = this,
                dataSource = args.model.dataSource,
                flag = false;
            proxy.enbleDisableAddResourceButton('disable', dialogType);
            if (enableResourceAdd) {
                var index = $.map(dataSource, function (data, index) {
                    if (data.name == "" || data.name == null) {
                        return index;
                    }
                });
                if (index.length > 0 && dataSource.length > 0)
                    flag = true;
                if (!flag) {
                    proxy.enbleDisableAddResourceButton('enable', dialogType);
                }
            }
        },
        //add empty row in predecessor grid in dialog box
        _addpredecessor: function (e) {
            var proxy = this,
                args = {}, treeGridId, grid,
                item = { id: "", name: "", type: "Finish-Start", offset: "0" }, dialogType;
            
            if ($(e.target).hasClass("e-edit-dialog")) {
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                dialogType = "edit";
            }
            else {
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                dialogType = "add";
            }
            proxy._enbleDisablePredecessorAddButton('disable', dialogType);
            grid = $(treeGridId).ejTreeGrid("instance");
            grid.addRow(item);
            grid.clearSelection(grid.model.selectedRowIndex);
            proxy._enbleDisablePredecessorDeleteButton('disable', dialogType);
        },
        //delete predecessor in dialog box 
        _deletepredecessor:function(e)
        {
            var proxy = this, treeGridId, dialogType;

            if ($(e.target).hasClass("e-edit-dialog")) {
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                dialogType = "edit";
            }
            else {
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                dialogType = "add";
            }

            var selectedItem = $(treeGridId).ejTreeGrid("option", "selectedRowIndex");
            var args = {};
            args["requestType"] = ej.TreeGrid.Actions.Delete;
            if (selectedItem !== -1) {
                $(treeGridId).ejTreeGrid("deleteRow");
                proxy._enbleDisablePredecessorDeleteButton('disable',dialogType);
            }
            proxy._disablePredecessorAddButton(treeGridId, dialogType);
        },

         //updated the status of Resource button in dialog box
        enbleDisableDeleteResourceButton:function(args,dialogType)
        {
            var proxy = this, predecessorDelete;
            if (dialogType == "add")
                predecessorDelete = $("#" + proxy._id + "AddDialog_ResourceDelete");
            else
                predecessorDelete = $("#" + proxy._id + "EditDialog_ResourceDelete");
            if(args==="enable")
            {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deleteResource, proxy)).bind("click", $.proxy(proxy._deleteResource, proxy));
                $(predecessorDelete).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(predecessorDelete).unbind("click", $.proxy(proxy._deleteResource, proxy));
                $(predecessorDelete).addClass('e-disable').removeClass('e-enable');
            }
        },
        //updated the status of Resource button in dialog box
        enbleDisableAddResourceButton: function (args,dialogType)
        {
            var proxy = this, resourceAdd;
            if (dialogType == "add")
                resourceAdd = $("#" + proxy._id + "AddDialog_ResourceAdd");
            else
                resourceAdd = $("#" + proxy._id + "EditDialog_ResourceAdd");
            if (args === "enable") {
                $(resourceAdd).unbind("click", $.proxy(proxy._addResource, proxy)).bind("click", $.proxy(proxy._addResource, proxy));
                $(resourceAdd).addClass('e-enable').removeClass('e-disable');
            }
            else {
                $(resourceAdd).unbind("click", $.proxy(proxy._addResource, proxy));
                $(resourceAdd).addClass('e-disable').removeClass('e-enable');
            }
        },

        //add empty row in predecessor grid in dialog box
        _addResource: function (e) {
            var proxy = this,
                args = {}, treeGridId, grid,
                item = { name: "", unit: "100" }, dialogType;
            if ($(e.target).hasClass("e-edit-dialog")) {
                dialogType = "edit";
                treeGridId = "#treegrid" + proxy._id + "resourceEdit";
            }
            else {
                dialogType = "add";
                treeGridId = "#treegrid" + proxy._id + "resourceAdd";
            }
            proxy.enbleDisableAddResourceButton('disable', dialogType);
            grid = $(treeGridId).ejTreeGrid("instance");
            grid.clearSelection(grid.model.selectedRowIndex);
            grid.addRow(item, "bottom");                       
            proxy.enbleDisableDeleteResourceButton('disable', dialogType);
        },
        //delete predecessor in dialog box 
        _deleteResource: function (e) {
            var proxy = this, treeGridId;

            if ($(e.target).hasClass("e-edit-dialog"))
                treeGridId = "#treegrid" + proxy._id + "resourceEdit";
            else
                treeGridId = "#treegrid" + proxy._id + "resourceAdd";

            var selectedItem = $(treeGridId).ejTreeGrid("option", "selectedRowIndex");
            var args = {};
            args["requestType"] = ej.TreeGrid.Actions.Delete;
            if (selectedItem !== -1) {
                $(treeGridId).ejTreeGrid("deleteRow");
            }
        },
            
        _resourceEndEdit:function(gridId,dialogType, args)
        {
            var proxy = this,
                columns = args.model.columns,
                enableResourceAdd;
            columns[0].dropdownData = $.extend(true, [], proxy.model.resources),
            enableResourceAdd = args.model.dataSource.length < proxy.model.resources.length;
            proxy._enableDisableResourceAddButton(args, enableResourceAdd, dialogType);
        },
        _resourceBeginEdit: function (gridId, args) {
            var proxy = this,
                idMapping = proxy.model.resourceIdMapping,
                gridModel = args.model,
                 columns = gridModel.columns,
                 dropDownData = columns[0].dropdownData,
                 dataSource = gridModel.dataSource,
                 length = dataSource.length,
                 value = args.data.item.name;
            for (var i = 0; i < length; i++) {
                if (dataSource[i].name != "" && dataSource[i].name != null && value != dataSource[i].name) {
                    var index = $.map(dropDownData, function (data, index) {
                        if (data[idMapping].toString() == dataSource[i].name) {
                            return index;
                        }
                    });
                    dropDownData.splice(index[0], 1);
                }
            }
        },
        //returns column value by field name
        getColumnIndexByField: function (field) {

            var proxy = this,
                columns = proxy.model.columns,
                length = columns.length,
                column = 0;

            for (column; column < length; column++) {

                if (columns[column]["field"] == field) break;

            }

            return column;
        },

        //returns selected resource index from rource value
        getIndexofresourceInfo: function (dataSource,data) {
            var resourceInfo = data.resourceInfo,
                count = 0, length = resourceInfo ? resourceInfo.length : 0, resourceIndex = [];
            
            for (count; count < length; count++) {
                if (dataSource.indexOf(resourceInfo[count]) != -1)
                    resourceIndex.push(dataSource.indexOf(resourceInfo[count]));
            }

            return resourceIndex;

        },
        //focus elements on editing
        _focusElements: function ($currentCell) {
            if ($currentCell.length) {
                $currentCell.focus();
                var $childElem = $currentCell.children();
                if ($childElem[0].tagName.toLowerCase() == "select" || $childElem[0].tagName.toLowerCase() == "input") {
                    $childElem.focus().select();
                    $childElem[0].focus();
                }
                else if ($childElem.find(".e-field.e-dropdownlist").length)
                    $childElem.find(".e-ddl").focus();
                else
                    $childElem.find('input,select').select().focus();
            }
        },
        //add button templates for add and edit dialog
        renderDiaglogButton: function (type, tbody) {

            var btnId,
                proxy = this,
                model = proxy.model;
            if (type == "edit")
                btnId = "EditDialog_";
            else
                btnId = "AddDialog_";

            var savebtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px',
                     "min-width": "70px"
                 },
                 { type: "button", id: btnId + proxy._id + "_Save" }),
             saveText = type == "edit" ? proxy._editDialogTexts["saveButton"] : proxy._editDialogTexts["addButton"];
            
            savebtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: saveText,
                    width: "auto"
                });

            var cancelText = proxy._editDialogTexts["cancelButton"],
             cancelbtn = ej.buildTag('input', "",
                 {
                     'margin-left': '18px',
                     'border-radius': '3px',
                     "min-width": "70px"
                 },
                 {
                     type: "button",
                     id: btnId + proxy._id + "_Cancel"
                 });
            
            cancelbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: cancelText,
                    width: "auto"
                });

            //Sample delete button
            var deleteText = proxy._editDialogTexts["deleteButton"],
                delbtn = ej.buildTag('input', "",
                {
                    'border-radius': '3px',
                    "min-width": "90px"
                },
                {
                    type: "button",
                    id: "EditDialog_" + proxy._id + "_Delete"
                });

            delbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: deleteText,
                    width: "auto"
                });



            var btnDiv = ej.buildTag('div', "", { 'float': 'right',"z-index":"10" }, { 'class': "e-editform-btn e-editfrom-btn-right" });
            var deleteBtnDiv = ej.buildTag('div', "", { 'float': 'left', "z-index": "10" }, { 'class': "e-editform-btn e-editfrom-btn-left" });

            btnDiv.append(savebtn);
            if (type == "edit" && model.editSettings.allowDeleting)
                deleteBtnDiv.append(delbtn);
            btnDiv.append(cancelbtn);
            btnDiv.appendTo(tbody);
            deleteBtnDiv.appendTo(tbody);
            return tbody;
        },
        //Tool bar rendering initiated
        _renderToolBar: function() {
            var proxy = this,
                model = proxy.model,
                $div = ej.buildTag("div.e-gantttoolbar#e-gantttoolbar" + proxy._id, "", { 'height': '50px' }, { id: proxy._id + "_toolbarItems" });                
            if (!ej.isNullOrUndefined(model.toolbarSettings.toolbarItems) && model.toolbarSettings.toolbarItems.length) {
                var $ul = ej.buildTag("ul", "", {}, {});
                proxy._renderLi($ul);
                $div.append($ul);
            }
            if (!ej.isNullOrUndefined(model.toolbarSettings.customToolbarItems) && model.toolbarSettings.customToolbarItems.length) {
                var $customUl = ej.buildTag("ul", "", {}, {});
                proxy._renderCustomLi($customUl);
                $div.append($customUl);
            }
            if (model.toolbarSettings.toolbarItems.indexOf(ej.Gantt.ToolbarItems.Search) != -1) {
                    var $searchUl = ej.buildTag("ul.e-gantt-search-container", "", {'float':'right'}, {}),
                    $li = ej.buildTag("li", "", {}, {
                        id: proxy._id + "_" + ej.Gantt.ToolbarItems.Search,
                        "tabindex": "0"
                    });
                    proxy._renderLiContent($li, ej.Gantt.ToolbarItems.Search);
                    $searchUl.append($li);
                    $div.append($searchUl);
                }            
            var helper = {};
            helper.click = proxy._toolBarClick;
            helper.cssClass = model.cssClass;
            helper.rtl = false;
            helper.itemSeparator = false;
            helper.width = proxy._ganttWidth;
            helper.fields = {
                id: "",
                tooltipText: "",
                imageUrl: "",
                text: "",
                imageAttributes: "",
                spriteCSS: "",
                htmlAttributes: "",
            };
            $div.ejToolbar(helper);
            $div.ejToolbar("disableItem", proxy._disabledToolItems);
            proxy._disabledToolItems = $();
            return $div;
        },
        //to renderCustom Li
        _renderCustomLi: function ($ul) {
            var proxy = this,
            model = proxy.model,
            $li, $item,
            customToolbarItems = model.toolbarSettings.customToolbarItems;
            for (var i = 0; i < customToolbarItems.length; i++) {
                if (customToolbarItems[i]["text"] || customToolbarItems[i]["templateID"]) {
                    if (customToolbarItems[i]["text"])
                    {
                       var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["text"];
                       $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["text"], title: customToolbar });
                       $item = ej.buildTag("a.e-toolbaricons e-icon e-ganttcustomtoolbaritem", "", {}).addClass(customToolbarItems[i]["text"]);
                       $li.addClass("e-gantttoolbaritem");
                    }
                    else {
                        var customToolbar = customToolbarItems[i]["tooltipText"] ? customToolbarItems[i]["tooltipText"] : customToolbarItems[i]["templateID"].replace("#", "");
                        $li = ej.buildTag("li", "", {}, { id: proxy._id + "_" + customToolbarItems[i]["templateID"].replace("#", ""), title: customToolbar });
                        $item = $(customToolbarItems[i]["templateID"]).hide().html();
                    }                    
                    $li.html($item);
                    $ul.append($li);
                }              
            }
        },
        //craete LI elements for tool bar
        _renderLi: function ($ul) {
            var proxy = this,
                toolBarItems = proxy.model.toolbarSettings.toolbarItems,
                length = toolBarItems.length,
                i = 0,
                $li;
            for (i; i < length; i++) {

                $li = ej.buildTag("li", "", {}, {
                    id: proxy._id + "_" + toolBarItems[i],                    
                    "tabindex": "0"
                });

                if (toolBarItems[i] !== "search") {
                    $li.addClass("e-gantttoolbaritem");                   
                    proxy._renderLiContent($li, toolBarItems[i]);
                    $ul.append($li);
                }
            }
        },

        //add attributes for tool bar li elements
        _renderLiContent: function ($li, item) {
            var $a, $input, selectionMode = this.model.selectionMode;
            var selectedRowIndex = this.selectedRowIndex();
            var editSetting = this.model.editSettings;
            switch (item) {

                case "add":
                    $a = ej.buildTag("a.e-addnewitem e-toolbaricons e-icon e-gantt-add", "", {});
                    //title: toolBarItems[i],
                    var addTitle = this._toolboxTooltipTexts["addTool"];
                    $li.attr("title", addTitle);
                        if (this.model.readOnly==true||!this.model.editSettings.allowAdding)
                        this._disabledToolItems.push($li.get(0));
                    break;

                case "edit":
                    $a = ej.buildTag("a.e-edititem e-toolbaricons e-icon e-gantt-edit", "", {});
                    var editTitle = this._toolboxTooltipTexts["editTool"];
                    $li.attr("title", editTitle);
                    if (this.model.readOnly == true || !this.model.allowSelection || (!this.model.editSettings.allowEditing || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")) || this.model.editSettings.beginEditAction == "click")) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    
                    break;

                case "delete":
                    var deleteTitle = this._toolboxTooltipTexts["deleteTool"];
                    $li.attr("title", deleteTitle);
                    $a = ej.buildTag("a.e-deleteitem e-toolbaricons e-icon e-gantt-delete", "", {});
                    
                    if (this.model.readOnly == true || !this.model.allowSelection || (!this.model.editSettings.allowDeleting || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")))) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    
                    break;

                case "update":
                    var saveTitle = this._toolboxTooltipTexts["saveTool"];
                    $li.attr("title", saveTitle);
                    $a = ej.buildTag("a.e-saveitem e-toolbaricons e-icon e-gantt-save e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "cancel":
                    var cancelTitle = this._toolboxTooltipTexts["cancelTool"];
                    $li.attr("title", cancelTitle);
                    $a = ej.buildTag("a.e-cancel e-toolbaricons e-icon e-gantt-cancel e-disabletool", "", {});
                    this._disabledToolItems.push($li.get(0));
                    break;

                case "indent":
                    var indentTitle = this._toolboxTooltipTexts["indentTool"];
                    $li.attr("title", indentTitle);
                    $input = ej.buildTag("a.e-indent e-toolbaricons e-icon e-disabletool e-gantt-indent", "", {}, {});
                    $li.append($input);
                    if (this.model.readOnly == true || !this.model.allowSelection || (!this.model.editSettings.allowIndent || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")))) {
                        this._disabledToolItems.push($li.get(0));
                    }

                    break;

                case "outdent":
                    var outdentTitle = this._toolboxTooltipTexts["outdentTool"];
                    $li.attr("title", outdentTitle);
                    $input = ej.buildTag("a.e-outdent e-toolbaricons e-icon e-disabletool e-gantt-outdent", "", {}, {});
                    $li.append($input);
                    if (this.model.readOnly == true || !this.model.allowSelection || (!this.model.editSettings.allowIndent || (selectedRowIndex == -1 || (selectedRowIndex != -1 && selectionMode == "cell")))) {
                        this._disabledToolItems.push($li.get(0));
                    }
                    break;

                case "expandAll":
                    var expandTitle = this._toolboxTooltipTexts["expandAllTool"];
                    $li.attr("title", expandTitle);
                    $input = ej.buildTag("a.e-expandall e-toolbaricons e-icon e-gantt-expandall", "", {}, {});
                    $li.append($input);
                    break;

                case "collapseAll":
                    var collapseTitle = this._toolboxTooltipTexts["collapseAllTool"];
                    $li.attr("title", collapseTitle);
                    $input = ej.buildTag("a.e-collapseall e-toolbaricons e-icon e-gantt-collapseall", "", {}, {});
                    $li.append($input); 
                    break;
                case "prevTimeSpan":
                    var prevTitle = this._toolboxTooltipTexts["prevTimeSpanTool"];
                    $li.attr("title", prevTitle);
                    $input = ej.buildTag("a.e-prevtimespan e-toolbaricons e-icon e-gantt-prevtimespan", "", {}, {});
                    $li.append($input);
                    break;
                case "nextTimeSpan":
                    var nextTitle = this._toolboxTooltipTexts["nextTimeSpanTool"];
                    $li.attr("title", nextTitle);
                    $input = ej.buildTag("a.e-nexttimespan e-toolbaricons e-icon e-gantt-nexttimespan", "", {}, {});
                    $li.append($input);
                    break;
                case "criticalPath":
                    var criticalTitle = this._toolboxTooltipTexts["criticalPathTool"];
                    $li.attr("title", criticalTitle);
                    $input = ej.buildTag("a.e-criticaltask e-toolbaricons e-icon e-gantt-criticaltask", "", {}, {});
                    $li.append($input);
                    break;
                case "search":
                    var searchTitle = this._toolboxTooltipTexts["searchTool"];
                    $input = ej.buildTag("input.e-ejinputtext", "", { 'margin': '4px', 'text-indent': '4px', 'width': 'auto', 'padding': '1px 4px 1px 0px' }, { type: "text", placeholder: searchTitle }, { 'color': "#E8E9E9" });
                    $li.css({ 'float': 'right', 'padding': '2px' });
                    $li.attr("title", searchTitle);
                    $li.addClass('e-search');
                    $li.append($input);
                    this.model.allowSearching = true;

                    $input.keydown($.proxy(this._keyDown, this));

                    break;
                case "excelExport":
                    var excelExportTitle = this._toolboxTooltipTexts["excelExportTool"];
                    $li.attr("title", excelExportTitle);
                    $input = ej.buildTag("a.e-excelIcon e-toolbaricons e-icon e-gantt-excelexport", "", {}, {});
                    $li.append($input);
                    break;
                case "pdfExport":
                    var pdfExportTitle = this._toolboxTooltipTexts["pdfExportTool"];
                    $li.attr("title", pdfExportTitle);
                    $input = ej.buildTag("a.e-pdfIcon e-toolbaricons e-icon", "", {}, {});
                    $li.append($input);
                    break;
            }
            $li.append($a);
        },

        //handle key down for searching in gantt
        _keyDown: function (e) {

            if (e.which ===13) { //13 is key code for Enter Key 
                this._toolbarOperation(this._id + "_search", e.currentTarget.value);
				e.preventDefault();
				return false;//prevent post back
            }          
        },

        //update the status of tool bar elements 
        _updateToolbarOptions:function(){

            var proxy = this,
                model = proxy.model,
                editSettings = model.editSettings,
                toolbar = $("#" + proxy._id + "_toolbarItems"),
                $addElement = $(toolbar).find(".e-addnewitem").parent()[0],
                $editElement = $(toolbar).find(".e-edititem").parent()[0],
                $deleteElement = $(toolbar).find(".e-deleteitem").parent()[0],
                $indentElement = $(toolbar).find(".e-indent").parent()[0],
                $outdentElement = $(toolbar).find(".e-outdent").parent()[0],                
                $updateElement = $(toolbar).find(".e-saveitem").parent()[0],
                $cancelElement = $(toolbar).find(".e-cancel").parent()[0],
                disabledItems = [], enabledItems = [];
            if (model.readOnly == true) {
                $addElement && disabledItems.push($($addElement));
                $editElement && disabledItems.push($($editElement));
                $deleteElement && disabledItems.push($($deleteElement));
                $indentElement && disabledItems.push($($indentElement));
                $outdentElement && disabledItems.push($($outdentElement));
                $updateElement && disabledItems.push($($updateElement));
                $cancelElement && disabledItems.push($($cancelElement));
                $(toolbar).ejToolbar('disableItem', disabledItems);
            }
            else {
                if (editSettings.allowAdding)
                    $addElement && enabledItems.push($addElement);
                else
                    $addElement && disabledItems.push($($addElement));

            if (!model.selectedItem) {

                if (editSettings.allowEditing) {
                    $editElement && disabledItems.push($($editElement));
                }

                if (editSettings.allowDeleting) {
                    $deleteElement && disabledItems.push($($deleteElement));
                    }

                if ($updateElement)
                    $updateElement && disabledItems.push($($updateElement));

                if ($cancelElement)
                    $cancelElement && disabledItems.push($($cancelElement));

                    if ($indentElement)
                        $indentElement && disabledItems.push($($indentElement));

                    if ($outdentElement)
                        $outdentElement && disabledItems.push($($outdentElement));
                }
                else {

                if (editSettings.allowEditing && model.editSettings.beginEditAction != "click")
                        $editElement && enabledItems.push($editElement);
                    else
                        $editElement && disabledItems.push($($editElement));

                    if (editSettings.allowDeleting)
                        $deleteElement && enabledItems.push($deleteElement);
                    else
                        $deleteElement && disabledItems.push($($deleteElement));

                    proxy.updateIndentOutdentOption(model.selectedItem);
                }

                $(toolbar).ejToolbar('disableItem', disabledItems);
                $(toolbar).ejToolbar('enableItem', enabledItems);
            }
        },

        //Splitter control is initiated
        _renderGantt: function () {

            var proxy = this,
                model = proxy.model,
                leftPaneSize,
                rightPaneSize,
                ganttWidth = parseInt(proxy._ganttWidth),
                splitterPosition = proxy.splitterPosition(),
                isPercentage = false, columnWidth,
                splitterColumnIndex = model.splitterSettings.index;
            if (!splitterPosition)
            {
                splitterPosition = proxy._splitterPosition();
                proxy.splitterPosition(splitterPosition);
            }
            //calculate treegrid pane size
            if (splitterPosition || splitterColumnIndex > -1) {
                if (splitterPosition) {
                    if (typeof splitterPosition == "string" && splitterPosition.indexOf("%") != -1) {
                        leftPaneSize = parseInt(splitterPosition);
                        isPercentage = true;
                    }
                    else {
                        leftPaneSize = parseInt(splitterPosition) / ganttWidth * 100;
                        isPercentage = false;
                    }
                }
                else {
                    var columns = proxy.getColumns(),
                        columnWidth = 0,
                    columnIndex = splitterColumnIndex;
                    if (columnIndex >= columns.length)
                        columnIndex = columns.length - 1;
                    for (var index = 0; index <= columnIndex; index++)
                        columnWidth += columns[index].width;
                    if (columnWidth <= ganttWidth) {
                        leftPaneSize = parseInt(columnWidth) / ganttWidth * 100;
                        splitterColumnIndex = index - 1;
                    }
                    else {
                        columnWidth = 0;
                        for (var index = 0; index <= columnIndex; index++) {
                            if ((columnWidth + columns[index].width) <= ganttWidth) {
                                columnWidth += columns[index].width;
                                splitterColumnIndex = index;
                            }
                            else {
                                leftPaneSize = parseInt(columnWidth) / ganttWidth * 100;
                                break;
                            }
                        }
                    }
                    model.splitterSettings.index = splitterColumnIndex;
                }
                // set grid width value is zero when grid width is less than zero or NAN.
                if (isNaN(leftPaneSize) || leftPaneSize < 0)
                    leftPaneSize = 0;
                // check the left pane size is greather than 100% of gantt width
                if (leftPaneSize > 100) {
                    leftPaneSize = (2 * proxy._commonColumnWidth + 3) / ganttWidth * 100;
                    leftPaneSize = leftPaneSize < 30 ? leftPaneSize : 30;
                    isPercentage = true;
                }
            }
            else {
                leftPaneSize = (2 * proxy._commonColumnWidth + 3) / ganttWidth * 100;
                leftPaneSize = leftPaneSize < 30 ? leftPaneSize : 30;
                isPercentage = true;
            }
            //Here 9 is the splitter span width
            rightPaneSize = 100 - leftPaneSize - (9 / ganttWidth * 100);
            // Check the right pane size is less than or euqal to 0.
            if (rightPaneSize <= 0) {
                if (isPercentage)
                    proxy.splitterPosition("100%");
                else
                    proxy.splitterPosition(ganttWidth.toString());
                leftPaneSize = 100 - (9 / ganttWidth * 100);
                rightPaneSize = 0;
            }
            else if (rightPaneSize > 0) {
                if (isPercentage)
                    proxy.splitterPosition(Math.round(leftPaneSize) + "%");
                else
                    proxy.splitterPosition(Math.round((leftPaneSize * ganttWidth / 100)).toString());
            }
            // assign the splitter position value to deprecated splitterPosition property
            proxy._splitterPosition(proxy.splitterPosition());
            $("#e-ejSpliter" + proxy._id).ejSplitter({
                //border width and height excluded
                height: proxy._ganttHeight,
                width: ganttWidth,
                orientation: ej.Orientation.Horizontal,
                properties: [{ paneSize: leftPaneSize + "%", collapsible: false }, { paneSize: rightPaneSize + "%", collapsible: false }],
                enableAutoResize: false,
                resize: $.proxy(proxy._onResize, proxy),
                cssClass: model.cssClass
            });
        },

        //Tree Grid part is initiated
        _renderTreeGrid: function() {
            var proxy = this, model = proxy.model;
            proxy._$treegridHelper.ejTreeGrid({
                enableAltRow: model.enableAltRow,
                allowColumnResize: model.allowColumnResize,
                enableVirtualization: model.enableVirtualization,
                allowSorting: model.allowSorting,
                showColumnChooser: model.showColumnChooser,
                showColumnOptions: model.showColumnOptions,
                allowMultiSorting: model.allowMultiSorting,
                sortSettings: model.sortSettings,
                allowSelection: model.allowSelection,
                selectionType: model.selectionMode == "cell" ? model.selectionType : "single",
                selectionMode: model.selectionMode,
                selectedRowIndex: this.selectedRowIndex(),
                allowDragAndDrop: model.allowDragAndDrop,
                dragTooltip: model.dragTooltip,
                allowSearching: model.allowSearching,
                parentIdMapping: model.parentTaskIdMapping,
                baselineStartDateMapping: model.baselineStartDateMapping,
                baselineEndDateMapping: model.baselineEndDateMapping,
                allowKeyboardNavigation: model.allowKeyboardNavigation,
                cssClass: model.cssClass,
                locale: model.locale,
                columns: proxy.getColumns(),
                editSettings: model.editSettings,
                toolbarSettings:model.toolbarSettings,
                rowTemplate: model.rowTemplate,
                rowDataBound: model.rowDataBound,
                queryCellInfo: model.queryCellInfo,
                cellSelecting: model.cellSelecting,
                cellSelected: model.cellSelected,
                selectedCellIndexes: this.selectedCellIndexes(),
                dataSource:this.dataSource(),
                flatRecords: model.flatRecords,
                parentRecords: model.parentRecords,
                ids: proxy.model.ids,                
                dateFormat: model.dateFormat,
                resourceInfoMapping: model.resourceInfoMapping,
                resourceNameMapping: model.resourceNameMapping,
                resourceIdMapping:model.resourceIdMapping,
                resourceUnitMapping: model.resourceUnitMapping,
                idMapping: model.taskIdMapping,
                readOnly:model.readOnly,
                notesMapping: model.notesMapping,
                showGridCellTooltip: model.showGridCellTooltip,
                cellTooltipTemplate:model.cellTooltipTemplate,
                showGridExpandCellTooltip: model.showGridExpandCellTooltip,
                taskNameMapping: model.taskNameMapping,
                taskSchedulingModeMapping: model.taskSchedulingModeMapping,
                startDateMapping: model.startDateMapping,
                endDateMapping: model.endDateMapping,
                childMapping: model.childMapping,
                durationMapping: model.durationMapping,
                durationUnitMapping: model.durationUnitMapping,
                durationUnit: model.durationUnit,
                progressMapping: model.progressMapping,
                predecessorMapping: model.predecessorMapping,
                rowHeight: model.rowHeight,
                emptyRecordText: proxy._emptyRecordText,
                isFromGantt: proxy._isFromGantt,
                treeColumnIndex: model.treeColumnIndex,
                workingTimeScale:model.workingTimeScale,
                enableWBS: model.enableWBS,
                enableWBSPredecessor: model.enableWBSPredecessor,
                columnMenuTexts: proxy._columnMenuTexts,
                editTypeText: proxy._editTypeText,
                clipModeText: proxy._clipModeText,
                textAlignTypeText: proxy._textAlignTypeText,
                columnDialogTitle: proxy._columnDialogTitle,
                deleteColumnText: proxy._deleteColumnText,
                okButtonText: proxy._okButtonText,
                cancelButtonText: proxy._cancelButtonText,
                confirmDeleteText: proxy._confirmDeleteText,
                columnDialogFields: model.columnDialogFields,
                columnDialogTexts: proxy._columnDialogTexts,
                workMapping: model.workMapping,
                workUnit: proxy._workUnitTexts[model.workUnit],
                taskTypeTexts: proxy._taskTypeTexts,
                effortDrivenTexts: proxy._effortDrivenTexts,
                dataManagerUpdate: { isDataManagerUpdate: proxy._isDataManagerUpdate, jsonData: proxy._jsonData },
                durationUnitEditText: this._durationUnitEditText,
                durationUnitTexts: proxy._durationUnitTexts,
                enableCollapseAll: model.enableCollapseAll,
                weekStartDay: model.scheduleHeaderSettings.weekStartDay,
                indentLevelWidth: this.indentLevelWidth,
                ganttElement: this.element
            });
        },
        //Chart part is initiated
        _renderGanttChart: function() {
            var proxy = this,
                model = this.model;
                proxy._$ganttchartHelper.ejGanttChart(
                {
                    dataSource: this.dataSource(),
                    scheduleStartDate: model.scheduleStartDate,
                    scheduleEndDate: model.scheduleEndDate,
                    startDateMapping: model.startDateMapping,
                    endDateMapping: model.endDateMapping,
                    taskNameMapping: model.taskNameMapping,
                    taskIdMapping: model.taskIdMapping,
                    progressMapping: model.progressMapping,
                    durationMapping: model.durationMapping,
                    childPropertyName: model.childMapping,
                    predecessorMapping: model.predecessorMapping,
                    enableVirtualization: model.enableVirtualization,
                    highlightWeekends: model.highlightWeekends,
                    milestoneMapping: model.milestoneMapping,
                    perDayWidth: proxy._perDayWidth,
                    workingTimeScale: model.workingTimeScale,
                    roundOffDayworkingTime: model.roundOffDayworkingTime,
                    durationUnit: model.durationUnit,
                    isCriticalPathEnable: this.isCriticalPathEnable,
                    criticalPathCollection: this.criticalPathCollection,
                    perMonthWidth: proxy._perMonthWidth,//new property for year - month schedule
                    perWeekWidth: proxy._perWeekWidth,//new property for week - month schedule
                    perHourWidth: proxy._perHourWidth,
                    perMinuteWidth: proxy._perMinuteWidth,
                    perTopHourWidth: proxy._perTopHourWidth,
                    minuteInterval:proxy._minuteInterval,
                    includeWeekend: model.includeWeekend,
                    connectorlineWidth: model.connectorlineWidth,
                    workingTimeRanges: proxy._workingTimeRanges,
                    secondsPerDay: proxy._secondsPerDay,
                    scheduleHeaderSettings: model.scheduleHeaderSettings,
                    taskbarBackground: model.taskbarBackground,
                    progressbarBackground: model.progressbarBackground,
                    connectorLineBackground: model.connectorLineBackground,
                    parentTaskbarBackground: model.parentTaskbarBackground,
                    parentProgressbarBackground: model.parentProgressbarBackground,
                    holidays: model.holidays,
                    dateFormat: model.dateFormat,
                    locale: model.locale,
                    enableTaskbarTooltip: model.enableTaskbarTooltip,
                    enableTaskbarDragTooltip:model.enableTaskbarDragTooltip,
                    flatRecords: model.flatRecords,
                    parentRecords: model.parentRecords,
                    scheduleWeeks: proxy._scheduleWeeks,

                    projectStartDate: proxy._projectStartDate, //new property instead of scheduleWeeks[0] and scheduleYears[0]
                    projectEndDate: proxy._projectEndDate,

                    scheduleYears: proxy._scheduleYears, //new property for year
                    scheduleMonths: proxy._scheduleMonths, //new property for month
                    scheduleDays:proxy._scheduleDays,
                    scheduleHours:proxy._scheduleHours,
                    progressbarHeight: model.progressbarHeight,
                    tooltipTemplate: model.taskbarTooltipTemplate,
                    tooltipTemplateId: model.taskbarTooltipTemplateId,
                    progressbarTooltipTemplate: model.progressbarTooltipTemplate,
                    progressbarTooltipTemplateId: model.progressbarTooltipTemplateId,
                    queryTaskbarInfo: model.queryTaskbarInfo,
                    readOnly:model.readOnly,
                    showTaskNames: model.showTaskNames,
                    leftTaskLabelMapping: model.leftTaskLabelMapping,
                    rightTaskLabelMapping: model.rightTaskLabelMapping,
                    leftTaskLabelTemplate: model.leftTaskLabelTemplate,
                    rightTaskLabelTemplate: model.rightTaskLabelTemplate,
                    showProgressStatus: model.showProgressStatus,
                    showResourceNames: model.showResourceNames,
                    resourceInfoMapping: model.resourceInfoMapping,
                    resourceNameMapping: model.resourceNameMapping,
                    resourceUnitMapping: model.resourceUnitMapping,
                    enableProgressBarResizing: model.enableProgressBarResizing,
                    allowGanttChartEditing: model.allowGanttChartEditing,
                    taskbarEditingTooltipTemplateId: model.taskbarEditingTooltipTemplateId,
                    taskbarEditingTooltipTemplate:model.taskbarEditingTooltipTemplate,
                    ids: proxy.model.ids,
                    stripLines: model.stripLines,
                    _predecessorCollection: proxy._predecessorsCollection,
                    _columns:proxy._columns,
                    weekendBackground: model.weekendBackground,
                    allowKeyboardNavigation: model.allowKeyboardNavigation,
                    updatedRecords: proxy.model.updatedRecords,
                    renderBaseline: model.renderBaseline,
                    baselineColor:model.baselineColor,
                    editSettings: model.editSettings,
                    columnHeaderTexts: proxy._columnHeaderTexts,
                    durationUnitTexts:proxy._durationUnitTexts,
                    predecessorEditingTexts: proxy._predecessorEditingTexts,
                    localizedDays: proxy._days,
                    localizedMonths:proxy._months,
                    rowHeight: model.rowHeight,
                    allowSelection: model.allowSelection,
                    selectionMode: model.selectionMode,
                    taskbarTemplate: model.taskbarTemplate,
                    parentTaskbarTemplate: model.parentTaskbarTemplate,
                    milestoneTemplate: model.milestoneTemplate,
                    durationUnitEditText: this._durationUnitEditText,
                    taskbarClick: model.taskbarClick,
                    predecessorText: proxy._getPredecessorText(),
                    taskbarHeight: proxy.taskbarHeight,
                    cssClass: model.cssClass,
                    workWeek: model.workWeek
                });
        },

        _getPredecessorText: function(){
            var temp = this._predecessorCollectionText[1], predecessorText = {};
            temp = temp.value.split("-");
            predecessorText["Start"] = temp[0],
            predecessorText["Finish"] = temp[1];
            return predecessorText;
        },

        //Dynamically update dropDown datasources while changing localization of a project.
        _updateColumnDropDownData:function(){
            var proxy = this, model = proxy.model, columns = model.columns,
                length = columns.length;
            for (var i = 0; i < length; i++) {
                if (columns[i].field == "taskMode") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._taskModeTexts["manual"], "value": "true" },
                                   { id: 2, "text": proxy._taskModeTexts["auto"], "value": "false" }];
                }
                if (columns[i].field == "taskType") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._taskTypeTexts["fixedWork"], "value": "fixedWork" },
                              { id: 2, "text": proxy._taskTypeTexts["fixedUnit"], "value": "fixedUnit" },
                              { id: 3, "text": proxy._taskTypeTexts["fixedDuration"], "value": "fixedDuration" }];
                }
                if (columns[i].field == "effortDriven") {
                    columns[i].dropdownData = [{ id: 1, "text": proxy._effortDrivenTexts["yes"], "value": "true" },
                              { id: 2, "text": proxy._effortDrivenTexts["no"], "value": "false" }];
                }
            }
        },

        //Populate columns for treegrid from mapping names
        createTreeGridColumns: function () {

            var proxy = this, model = proxy.model, column, columns = [];

            var mapping = (model.taskIdMapping);//?model.taskIdMapping:"Task Id";

            if (mapping.length) {
                if(model.showColumnChooser){
                    column = {
                        field: "taskId",
                        headerText: proxy._columnHeaderTexts["taskId"],
                        width: 40,
                        editType: ej.Gantt.EditingType.String,
                        mappingName: mapping,
                        allowEditing: false,
                        allowCellSelection: true 
                    };
                }
                else
                {
                    column = {
                        field: "taskId",
                        headerText: proxy._columnHeaderTexts["taskId"],
                        width: 30,
                        editType: ej.Gantt.EditingType.String,
                        mappingName: mapping,
                        allowEditing: false,
                        allowCellSelection: true
                    };
                }

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.taskNameMapping;// "Task Name";

            if (mapping.length) {
                column = {
                    field: "taskName",
                    headerText: proxy._columnHeaderTexts["taskName"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    mappingName: mapping,
                    allowCellSelection: true
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.startDateMapping;// "Start Date";

            if (mapping.length) {
                column = {
                    field: "startDate",
                    headerText:proxy._columnHeaderTexts["startDate"],
                    width: 150,
                    editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                              ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                    mappingName: mapping,
                    allowCellSelection: true,
                    format: "{0:" + model.dateFormat + "}"
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }


            mapping = model.endDateMapping;// "End Date";

            if (mapping.length) {
                column = {
                    field: "endDate",
                    headerText: proxy._columnHeaderTexts["endDate"],
                    width: 150,
                    editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                    mappingName: mapping,
                    allowCellSelection: true ,
                    format: "{0:" + model.dateFormat + "}"
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.resourceInfoMapping;//"Resources";

            if (mapping.length) {
                column = {
                    field: "resourceInfo",
                    headerText:proxy._columnHeaderTexts["resourceInfo"],
                    width: 150,
                    editType: ej.Gantt.EditingType.Dropdown,
                    mappingName: mapping,
                    allowCellSelection: true ,
                    dropdownData: model.resources //model.resources is null
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }

            mapping = model.durationMapping;// "Duration";

            if (mapping.length) {
                column = {
                    field: "duration",
                    headerText: proxy._columnHeaderTexts["duration"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    allowCellSelection: true ,
                    mappingName:mapping
                };

                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }           

            mapping = model.progressMapping;// "Progress";

            if (mapping.length) {
                column = {
                    field: "status",
                    headerText: proxy._columnHeaderTexts["status"],
                    width: 150,
                    editType: ej.Gantt.EditingType.Numeric,
                    mappingName: mapping,
                    allowCellSelection: true
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }
            mapping = model.predecessorMapping;//)?model.predecessorMapping: "Predecessor";

            if (mapping.length) {
                column = {
                    field: "predecessor",
                    headerText:proxy._columnHeaderTexts["predecessor"],
                    width: 150,
                    editType: ej.Gantt.EditingType.String,
                    mappingName: mapping,
                    allowCellSelection: true
                };
                columns.push(column);
                //proxy._emptyDataColumns.push(column.field);
            }
            /*If renderBaseline enabled baseline columns  are added*/
            if (model.renderBaseline && model.baselineStartDateMapping && model.baselineEndDateMapping) {

                mapping = model.baselineStartDateMapping;
                if (mapping.length) {
                    column = {
                        field: "baselineStartDate",
                        headerText: proxy._columnHeaderTexts["baselineStartDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    columns.push(column);
                }
                mapping = model.baselineEndDateMapping;

                if (mapping.length) {
                    column = {
                        field: "baselineEndDate",
                        headerText: proxy._columnHeaderTexts["baselineEndDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    columns.push(column);
                }
            }
            /*To insert WBS column*/
            if (model.enableWBS) {
                mapping = "WBS";

                if (mapping.length) {
                    column = {
                        field: "WBS",
                        headerText: proxy._columnHeaderTexts["WBS"],
                        width: 150,
                        editType: ej.Gantt.EditingType.String,
                        allowEditing: false,
                        mappingName: mapping
                    };
                    columns.push(column);
                }
            }
            /*To insert WBS Predecessor column*/
            if (model.enableWBS && model.enableWBSPredecessor) {
                mapping = "WBSPredecessor";

                if (mapping.length) {
                    column = {
                        field: "WBSPredecessor",
                        headerText: proxy._columnHeaderTexts["WBSPredecessor"],
                        width: 150,
                        editType: ej.Gantt.EditingType.String,
                        allowEditing: false,
                        mappingName: mapping
                    };
                    columns.push(column);
                }
            }
            mapping = model.notesMapping;

            if (mapping.length) {
                column = {
                    field: "notesText",
                    headerText: proxy._columnHeaderTexts["notes"],
                    width: 150,
                    editType: "stringedit",
                    mappingName: mapping,
                    allowEditing: true,
                    allowCellSelection: true
                };
                columns.push(column);
            }
            mapping = model.taskSchedulingModeMapping;// "Task Mode";
            if (mapping.length) {
                var enableColumn = false;
                if (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom)
                    enableColumn = true;
                column = {
                    field: "taskMode",
                    headerText: proxy._columnHeaderTexts["taskMode"],
                    width: 100,
                    editType: ej.Gantt.EditingType.Dropdown,
                    allowCellSelection: enableColumn,
                    allowEditing: enableColumn,
                    mappingName: mapping,
                    dropdownData: [{ id: 1, "text": proxy._taskModeTexts["manual"], "value": "true" },
                                   { id: 2, "text": proxy._taskModeTexts["auto"], "value": "false" }],
                    editParams: { field: { text: "text", value: "value" } }
                };
                columns.push(column);
            }
            mapping = model.workMapping;// work ;
            column = {
                field: "work",
                headerText: proxy._columnHeaderTexts["work"],
                width: 150,
                editType: ej.Gantt.EditingType.Numeric,
                allowEditing: true,
                allowCellSelection: true,
                visible: mapping ? true : false
            };
            if (mapping.length)
                column.mappingName = mapping;
            columns.push(column);
            column = {
                field: "taskType",
                headerText: proxy._columnHeaderTexts["taskType"],
                width: 150,
                editType: ej.Gantt.EditingType.Dropdown,
                dropdownData: [{ id: 1, "text": proxy._taskTypeTexts["fixedWork"], "value": "fixedWork" },
                               { id: 2, "text": proxy._taskTypeTexts["fixedUnit"], "value": "fixedUnit" },
                               { id: 3, "text": proxy._taskTypeTexts["fixedDuration"], "value": "fixedDuration" }],
                editParams: { field: { text: "text", value: "value" } },
                allowEditing: true,
                allowCellSelection: true,
                visible: false
            };
            columns.push(column);

            column = {
                field: "effortDriven",
                headerText: proxy._columnHeaderTexts["effortDriven"],
                width: 150,
                editType: ej.Gantt.EditingType.Dropdown,
                dropdownData: [{ id: 1, "text": proxy._effortDrivenTexts["yes"], "value": "true" },
                               { id: 2, "text": proxy._effortDrivenTexts["no"], "value": "false" }],
                editParams: { field: { text: "text", value: "value" } },
                allowEditing: true,
                allowCellSelection: true,
                visible: false
            };
            columns.push(column);

            return columns;
        },
        
        //Create gannt record from given data source
        _createGanttRecords: function(data) {
            var proxy = this,
                model = proxy.model,
                ganttRecords = model.flatRecords,
                length = data.length,
                count = 0,
                parentGanttRecord,
                parentRecords = model.parentRecords,
                enableSorting = model.allowSorting,
                enableAltRow = model.enableAltRow,
                ids = proxy.model.ids;


            for (count; count < length; count++) {
                if (model.enableWBS) {
                    data[count]["WBS"] = (count + 1).toString();
                }
                parentGanttRecord = proxy._createGanttRecord(data[count], 0, null,undefined,"Load");
                proxy._storedIndex++;
                //if (enableAltRow)
                parentGanttRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                parentGanttRecord.index = proxy._storedIndex;
                
                ids[proxy._storedIndex] = parentGanttRecord["taskId"].toString();
                proxy._updateLastInsertedId(parentGanttRecord["taskId"], true);
                ganttRecords.push(parentGanttRecord);
                //if (enableSorting)
                parentRecords.push(parentGanttRecord);
                parentGanttRecord.childRecords && proxy._addNestedGanttRecords(parentGanttRecord.childRecords);
            }
            model.predecessorMapping && proxy._ensurePredecessorCollection();
            if (model.enableWBS && model.enableWBSPredecessor)
                proxy.createWBSPredecessor();
        },
        
        /*Create WBS predecessors value*/
        createWBSPredecessor: function () {
            var proxy = this,
                model = proxy.model;
            if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                var linkedRecords = model.flatRecords.filter(function (record) {
                    return record && record["predecessor"];
                });
                for (var r = 0; r < linkedRecords.length; r++) {
                    var linkRecord = linkedRecords[r],
                        prdc = linkRecord["predecessor"],
                        wbspred = null;
                    for (var p = 0; p < prdc.length; p++) {
                        var refId = +prdc[p].from, refRecord;
                        refRecord = model.flatRecords.filter(function (record) {
                            return record && record.taskId == refId;
                        });
                        var newOne = refRecord[0]["WBS"] + prdc[p].predecessorsType;
                        wbspred = wbspred ? (wbspred + "," + newOne) : newOne;
                    }
                    linkRecord["WBSPredecessor"] = wbspred;
                    linkRecord["item"]["WBSPredecessor"] = wbspred;
                }
            }
        },
        //Calculate schedule dates from GanttRecord Collections
        _calculateScheduleDates:function(editArgs)
        {
            var proxy = this,
                minStartDate,
                maxEndDate,
                tempStartDate,
                tempEndDate,
                baseLineStartDate,
                baseLineEndDate,
                model = this.model,
                records = model.flatRecords,
                updatedDates;
            if (((!model.scheduleEndDate || !model.scheduleStartDate) && records.length > 0)  || editArgs) {

                $.each(records, function (index, value) {
                        tempStartDate = new Date(value.startDate);
                        tempEndDate = new Date(value.endDate);
                        baseLineStartDate = value.baselineStartDate ? new Date(value.baselineStartDate) : null;
                        baseLineEndDate = value.baselineEndDate ? new Date(value.baselineEndDate) : null;
                        //minimum startDate
                        if (minStartDate) {
                            if (minStartDate.getTime() >= tempStartDate.getTime()) {
                                minStartDate = tempStartDate;
                            }
                            if (baseLineStartDate && model.renderBaseline && (minStartDate.getTime() >= baseLineStartDate.getTime())) {
                                minStartDate = baseLineStartDate;
                            }
                            else if (baseLineEndDate && model.renderBaseline && (minStartDate.getTime() >= baseLineEndDate.getTime())) {
                                minStartDate = baseLineEndDate;
                            }
                        } else {
                            if (baseLineStartDate && model.renderBaseline && tempStartDate.getTime() >= baseLineStartDate.getTime())
                                minStartDate = baseLineStartDate;
                            else if (baseLineEndDate && model.renderBaseline && tempStartDate.getTime() >= baseLineEndDate.getTime())
                                minStartDate = baseLineEndDate;
                            else
                                minStartDate = tempStartDate;
                        }
                        //Maximum endDate
                        if (maxEndDate) {
                            if (maxEndDate.getTime() <= tempEndDate.getTime()) {
                                maxEndDate = tempEndDate;
                            }
                            if (baseLineEndDate && model.renderBaseline && (maxEndDate.getTime() <= baseLineEndDate.getTime())) {
                                maxEndDate = baseLineEndDate;
                            }
                            else if (baseLineStartDate && model.renderBaseline && (maxEndDate.getTime() <= baseLineStartDate.getTime())) {
                                maxEndDate = baseLineStartDate;
                            }
                        } else {
                            if (baseLineEndDate && model.renderBaseline && tempEndDate.getTime() <= baseLineEndDate.getTime())
                                maxEndDate = baseLineEndDate;
                            if (baseLineStartDate && model.renderBaseline && tempEndDate.getTime() <= baseLineStartDate.getTime())
                                maxEndDate = baseLineStartDate;
                            else
                                maxEndDate = tempEndDate;
                        }
                });
                updatedDates = proxy._updateScheduleDatesByTaskLables(minStartDate, maxEndDate);
                minStartDate = updatedDates.minStartDate;
                maxEndDate = updatedDates.maxEndDate;
            }
            else if ((!model.scheduleEndDate || !model.scheduleStartDate) && records.length === 0) {
                minStartDate = proxy._getDateFromFormat(new Date());
                maxEndDate = proxy._getDateFromFormat(new Date(minStartDate));
                maxEndDate.setDate(maxEndDate.getDate() + 20);
            }
            if (!editArgs) {
                model.scheduleStartDate = minStartDate ? proxy.getFormatedDate(minStartDate) : model.scheduleStartDate;
                model.scheduleEndDate = maxEndDate ? proxy.getFormatedDate(maxEndDate) : model.scheduleEndDate;
            }
            else {
                editArgs.minStartDate = minStartDate;
                editArgs.maxEndDate = maxEndDate;
            }

        },

        //update schedule dates as per showTaskName and showResourceName values  and 
        //holidays collection and strip line collections at loadtime and edit time
        _updateScheduleDatesByTaskLables: function (startDate, endDate)
        {
            var proxy = this,
                model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                resourceStringWidth = proxy._getResourceStringWidth(),
                numOfDays, returnValues = {},
                scheduleEndDate = model.scheduleEndDate && this._getDateFromFormat(model.scheduleEndDate);
              
            if (scheduleHeaderType == scheduleHeaderValue.Week) {
                //if (model.showTaskNames) {
                //    startDate.setDate(startDate.getDate() - 7);//one week before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime()))
                {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perDayWidth)+7 : 7;//one week after
                    endDate.setDate(endDate.getDate() + numOfDays);
                }
            }
            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                //if (model.showTaskNames) {
                //    startDate.setMonth(startDate.getMonth() - 2);//2 month before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perMonthWidth) + 1 : 1;//1 month after
                    endDate.setMonth(endDate.getMonth() + numOfDays);
                }
            }
             

            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                //if (model.showTaskNames) {
                //    startDate.setDate(startDate.getDate() - 14);//two week before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perDayWidth) + 7 : 7;//one week after
                    endDate.setDate(endDate.getDate() + numOfDays);
                }
            }


            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                //if (model.showTaskNames) {
                //    startDate.setHours(startDate.getHours() - 8);//8hrs before
                //}
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    numOfDays = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perHourWidth) + 7 : 7;//7hrs after
                    endDate.setHours(endDate.getHours() + numOfDays);
                }
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                if (!model.scheduleEndDate || (scheduleEndDate.getTime() !== endDate.getTime())) {
                    var numOfHours = resourceStringWidth > 0 ? (resourceStringWidth / proxy._perMinuteWidth) + 5 : 5;//5hrs after
                    endDate.setHours(endDate.getHours() + numOfHours);
                    startDate.setHours(startDate.getHours() - 1);//Add 1 hour before.
                }
            }

            /* Update schedule dates as per holiday and strip line collection */
            returnValues = proxy._updateScheduleDatesByStripLines(startDate, endDate);

            startDate = returnValues.startDate;
            endDate = returnValues.endDate;


            returnValues = proxy._updateScheduleDatesByHolidays(startDate, endDate);

            startDate = returnValues.startDate;
            endDate = returnValues.endDate;

            returnValues.minStartDate = startDate;
            returnValues.maxEndDate = endDate;
           
            return returnValues;

        },

         //update Schedule dates by holidays collection */
        _updateScheduleDatesByHolidays: function (startDate, endDate)
        {
            var proxy = this, model = this.model, returnValues = {};

            //Check holidays are in range of schedule dates
            if (proxy._holidaysList.length > 0) {
                $.each(proxy._holidaysList, function (idx, value) {
                    if (!(value.getTime() > startDate.getTime()) || !(value.getTime() < endDate.getTime())) {
                        if (value.getTime() < startDate.getTime())
                            startDate = new Date(value);
                        else
                            endDate = new Date(value);
                    }
                });
            }

            returnValues.startDate = startDate;
            returnValues.endDate = endDate;

            return returnValues;


        },

        //update Schedule dates by stripLines collection */
        _updateScheduleDatesByStripLines: function (startDate, endDate) {
            var proxy = this, model = this.model, returnValues = {};

            //Check striplines are in range of schedule dates
            if (model.stripLines.length > 0) {
                $.each(model.stripLines, function (idx, value) {
                    var currentValue = proxy._getDateFromFormat(value.day)
                    if (!(currentValue.getTime() > startDate.getTime()) || !(currentValue.getTime() < endDate.getTime())) {
                        if (currentValue.getTime() < startDate.getTime())
                            startDate = new Date(currentValue);
                        else
                            endDate = new Date(currentValue);
                    }
                });
            }
            returnValues.startDate = startDate;
            returnValues.endDate = endDate;

            return returnValues;
        },

        //Get reosurce collections width
        _getResourceStringWidth:function(){
            var proxy = this,
                model = this.model,
                resource = model.resources,
                totalString = "",width;
            if (resource.length > 0 && model.showResourceNames) {
                for (var count = 0; count < resource.length; count++) {
                    totalString += resource[count][model.resourceNameMapping] + " ,";
                }
                var $span = ej.buildTag("span", "", { "font-family": "Segoe UI", "font-size": "12px" }, {});
                $span.text(totalString);
                $(document.body).append($span);
                width = $span.width();
                $span.remove();
                return width;
            } else {
                return 0;
            }
        },

        //calculate project dates by schedule mode types
        _calculateHeaderDates: function () {

            var proxy = this,
                model=this.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate),
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType;

            if (headerType == headerValue.Week)
                proxy._calculateWeekSplit(startDate, endDate);

            if (headerType == headerValue.Year) {
                proxy._calculateYearSplit(startDate, endDate);//method for year split
            }

            if (headerType == headerValue.Month)
                proxy._calculateMonthSplit(startDate, endDate);//method for Month split

            if (headerType == headerValue.Day)
                proxy._calculateDaySplit(startDate, endDate);

            if (headerType == headerValue.Hour)
                proxy._calculateHourSplit(startDate, endDate);
        },
        //AddNested Gantt Records
        _addNestedGanttRecords: function (data) {
            var proxy = this,
               
                ids = proxy.model.ids,
                model = proxy.model,
                ganttRecords = model.flatRecords,
                count = 0,
                length = data.length,
                records = [],
                record,
                enableAltRow = model.enableAltRow;
            
            for (count; count < length; count++) {
                record = data[count];
                proxy._storedIndex++;
                //if (enableAltRow)
                record.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                record.index = proxy._storedIndex;
              
                ids[proxy._storedIndex] = record["taskId"].toString();
                proxy._updateLastInsertedId(record["taskId"], true);
                ganttRecords.push(record);
                records = record.childRecords;
                if (records) {
                    var j = 0, recordlength = records.length, childGanttRecord = null;
                    for (j; j < recordlength; j++) {
                        childGanttRecord = records[j];
                        proxy._storedIndex++;
                        //if (enableAltRow)
                        childGanttRecord.isAltRow = proxy._storedIndex % 2 == 0 ? false : true;
                        childGanttRecord.index = proxy._storedIndex;
                     
                        ids[proxy._storedIndex] = childGanttRecord["taskId"].toString();
                        proxy._updateLastInsertedId(childGanttRecord["taskId"], true);
                        ganttRecords.push(childGanttRecord);
                        childGanttRecord.childRecords && proxy._addNestedGanttRecords(childGanttRecord.childRecords);
                    }
                }

            }
            
        },
        //returns gantt record from data
        _createGanttRecord: function (data, level, parentItem, expanded, creatAt) {
            var proxy = this, ganttRecord, model = proxy.model,
                columnRecords = proxy._columns, columnRecordsLength = columnRecords.length,
                child = data[model.childMapping],
                duration = !ej.isNullOrUndefined(data[model.durationMapping]) ? data[model.durationMapping] : null,
                status = data[model.progressMapping] ? (!isNaN(parseFloat(data[model.progressMapping])) ? parseFloat(data[model.progressMapping]) : 0) : 0,
                startDateType = proxy._getDateFromFormat(data[model.startDateMapping]),
                endDateType = proxy._getDateFromFormat(data[model.endDateMapping]),
                work = !ej.isNullOrUndefined(data[model.workMapping]) ? data[model.workMapping] : null,
                resourceInfo = data[model.resourceInfoMapping],
                predecessors = data[model.predecessorMapping],
                notes = data[model.notesMapping],
                baselineStartDateType = proxy._getDateFromFormat(data[model.baselineStartDateMapping]),
                baselineEndDateType = proxy._getDateFromFormat(data[model.baselineEndDateMapping]),
                WBS_Val = data["WBS"] ? data["WBS"] : null,
                autoSchedule_val = (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Auto) ? true :
                                    (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Manual) ? false :
                                    (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom) ? data[model.taskSchedulingModeMapping] == true ? false : true :
                                    model.taskSchedulingMode,
                resourceName = [],
                predecessorscol = [],
                durationUnit = (model.durationUnitMapping && data[model.durationUnitMapping]) ? proxy._validateDurationUnitMapping(data[model.durationUnitMapping]) : null,
                isMilesStone = model.milestoneMapping && data[model.milestoneMapping];

            var sTime = startDateType ? new Date(startDateType.getFullYear(), startDateType.getMonth(),
                startDateType.getDate(), startDateType.getHours(), startDateType.getMinutes()).getTime() : null,
                eTime = endDateType ? new Date(endDateType.getFullYear(), endDateType.getMonth(),
                endDateType.getDate(), endDateType.getHours(), endDateType.getMinutes()).getTime() : null;

            ganttRecord = new ej.Gantt.GanttRecord();
            ganttRecord.taskId = data[model.taskIdMapping];
            ganttRecord.taskName = data[model.taskNameMapping];
            proxy._addItemValue(ganttRecord, data, creatAt);
            ganttRecord.isAutoSchedule = autoSchedule_val;            
            ganttRecord.startDate = this._checkStartDate(startDateType, ganttRecord);
            var resourceCollection = proxy._isinAddnewRecord ? proxy._newRecordResourceCollection : model.resources;
            ganttRecord.resourceInfo = resourceInfo && ganttRecord._setResourceInfo(data[(model.resourceInfoMapping)], model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, resourceCollection);
            proxy._updateResourceName(ganttRecord);
            //Update duration and endDate by miles stone mapping
            if (!ej.isNullOrUndefined(isMilesStone) && isMilesStone) {
                ganttRecord.duration = 0;
                ganttRecord.durationUnit = durationUnit;
                ganttRecord.isMilestone = true;
                ganttRecord.endDate = new Date(ganttRecord.startDate);
            }
            else if (model.workMapping) {
                ganttRecord.durationUnit = model.durationUnit;
                if (isNaN(work) || ej.isNullOrUndefined(work)) {
                    ganttRecord.work = 0;
                    ganttRecord.duration = 0;
                    ganttRecord.isMilestone = true;
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                }
                else {
                    ganttRecord.work = work;
                    ganttRecord._updateDurationWithWork(proxy);
                    if (ganttRecord.duration == 0) {
                        ganttRecord.isMilestone = true;
                        ganttRecord.endDate = new Date(ganttRecord.startDate);
                    } else
                        ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                }
                if (!ej.isNullOrUndefined(data[model.durationMapping]))
                    data[model.durationMapping] = ganttRecord.duration;
                if (!ej.isNullOrUndefined(data[model.durationMapping]))
                    data[model.endDateMapping] = ganttRecord.endDate;
            }
                //validate duration value
            else if (!ej.isNullOrUndefined(duration)) {
                var retrunVal = this._getDurationValues(duration);
                ganttRecord.duration = retrunVal.duration;
                ganttRecord.durationUnit = durationUnit ? durationUnit : retrunVal.durationUnit;
                if (ganttRecord.duration == 0) {
                    ganttRecord.isMilestone = true;
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                } else
                    ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
            } else if (endDateType) {
                //If No hour information on endate default end time is set
                if (endDateType.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDateType);
                ganttRecord.endDate = this._checkEndDate(endDateType, ganttRecord);
                if (ganttRecord.startDate.getTime() >= ganttRecord.endDate.getTime()) {
                    ganttRecord.endDate = new Date(ganttRecord.startDate);
                    ganttRecord.isMilestone = true;
                    ganttRecord.duration = 0;
                } else
                    ganttRecord.duration = this._getDuration(ganttRecord.startDate, ganttRecord.endDate, model.durationUnit, ganttRecord.isAutoSchedule);
                ganttRecord.durationUnit = model.durationUnit;
            } else if (!endDateType && ej.isNullOrUndefined(duration)) {
                ganttRecord.isMilestone = true;
                ganttRecord.duration = 0;
                ganttRecord.endDate = new Date(ganttRecord.startDate);
            }
            ganttRecord.baselineStartDate = this._checkBaseLineStartDate(baselineStartDateType);
            //If No hour information on endate default end time is set
            if (baselineEndDateType && baselineEndDateType.getHours() == 0 && this._defaultEndTime != 86400)
                this._setTime(this._defaultEndTime, baselineEndDateType);
            ganttRecord.baselineEndDate = this._checkBaseLineEndDate(baselineEndDateType);
            ganttRecord.WBS = WBS_Val;
            ganttRecord.notes = notes;
            ganttRecord["notesText"] = notes ? proxy._getPlainText(notes) : "";

            // updating Gantt record for custom columns while adding new row
            if (columnRecordsLength) {
                for (var i = 0; i < columnRecordsLength; i++) {
                    if (ganttRecord[columnRecords[i].field] == undefined)
                        ganttRecord[columnRecords[i].field] = data[columnRecords[i].mappingName];
                }
            }

            ganttRecord.status = status;
            ganttRecord.predecessorsName = predecessors;
            if (!creatAt) {
                ganttRecord.predecessor = predecessors && ganttRecord._calculatePredecessor(predecessors, this._durationUnitEditText, model.durationUnit, proxy);
                if (!proxy._isValidPredecessorString) {
                    var ptxt = proxy._getPredecessorStringValue(ganttRecord);
                    ganttRecord.predecessorsName = ptxt;
                    ganttRecord.item.predecessor = ptxt;
                    proxy._isValidPredecessorString = true;
                }
            }            
            ganttRecord.parentItem = parentItem;
            ganttRecord.level = level;

            if (!creatAt) {
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, status);

                if (ganttRecord.baselineStartDate && ganttRecord.baselineEndDate) {
                    ganttRecord.baselineLeft = ganttRecord._calculateBaselineLeft(this);
                    ganttRecord.baselineRight = ganttRecord._calculateBaselineRight(this);
                    ganttRecord.baselineWidth = ganttRecord._calculateBaseLineWidth(this);
                }
            }
            proxy._updateItemValueInRecord(ganttRecord);
            ganttRecord.childRecords = (child && child.length > 0) && proxy._createChildRecords(child, level + 1, ganttRecord),
            ganttRecord.hasChildRecords = (child && child.length > 0) ? true : false,
            ganttRecord.isMilestone = ganttRecord.hasChildRecords ? false : ganttRecord.isMilestone;
            if (model.expandStateMapping && ganttRecord.hasChildRecords) {
                if (!ej.isNullOrUndefined(data[model.expandStateMapping])) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping];
                } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && !model.enableCollapseAll) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping] = true;
                } else if (ej.isNullOrUndefined(data[model.expandStateMapping]) && model.enableCollapseAll) {
                    ganttRecord[model.expandStateMapping] = ganttRecord.item[model.expandStateMapping] = data[model.expandStateMapping] = false;
                }
            }
            ganttRecord.expanded = expanded !== undefined ? expanded : child ? child.length > 0 : false;
            if (model.enableVirtualization === false) {
                ganttRecord.isExpanded = true;
            }
            if (ganttRecord.hasChildRecords) {                               
                ganttRecord.manualStartDate = ganttRecord.startDate;
                ganttRecord.manualEndDate = ganttRecord.endDate;                
                ganttRecord.manualDuration = ganttRecord.duration;                
            }            
            ganttRecord.taskType = data.taskType ? data.taskType : model.taskType;
            ganttRecord.effortDriven = data.effortDriven ? data.effortDriven : ganttRecord.taskType != "fixedWork" ? "false" : "true";           
            //Calculate total works for this record.
            if (!model.workMapping)
                ganttRecord._updateWorkWithDuration(proxy);
            if (predecessors)
                proxy._predecessorsCollection.push(ganttRecord);
            return ganttRecord;
        },
        /*Validate duration unit value from data source*/
        _validateDurationUnitMapping: function (value) {
            var durationUnit = value;
            if (this._durationUnitEditText.minute.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Minute;
            else if (this._durationUnitEditText.hour.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Hour;
            else if (this._durationUnitEditText.day.indexOf(durationUnit) != -1)
                durationUnit = ej.Gantt.DurationUnit.Day;
          
            if (durationUnit == ej.Gantt.DurationUnit.Day || durationUnit == ej.Gantt.DurationUnit.Hour || durationUnit == ej.Gantt.DurationUnit.Minute)
                return durationUnit;
            else
                return this.model.durationUnit;
        },
        //Start date,end date and duration are validated update this value in data source
        _updateItemValueInRecord: function (ganttRecord) {
            var model = this.model;
            if (ganttRecord.item) {
                var data = ganttRecord.item;
                if (model.startDateMapping)
                    data[model.startDateMapping] = ganttRecord.startDate;
                if (model.endDateMapping)
                    data[model.endDateMapping] = ganttRecord.endDate;
                if (model.durationMapping)
                    data[model.durationMapping] = ganttRecord.duration;
                if (model.durationUnitMapping)
                    data[model.durationUnitMapping] = ganttRecord.durationUnit;
                if (model.workMapping)
                    data[model.workMapping] = ganttRecord.work;
                if (model.taskSchedulingModeMapping)
                    data[model.taskSchedulingModeMapping] = !ganttRecord.isAutoSchedule;
                if (model.baselineStartDateMapping)
                    data[model.baselineStartDateMapping] = ganttRecord.baselineStartDate;
                if (model.baselineEndDateMapping)
                    data[model.baselineEndDateMapping] = ganttRecord.baselineEndDate;
            }
        },
        _addItemValue: function (ganttRecord, data, creatAt) {
            var proxy = this, model = this.model;
            //add item value in Gantt record

            if (model.parentTaskIdMapping && creatAt) {
                var id = data[model.taskIdMapping],
                   index = proxy._taskIds.indexOf(id);
                ganttRecord.item = (index > -1) ? proxy._retrivedData[index] : [];
            }
            else {
                if (this.dataSource() instanceof ej.DataManager && this.dataSource().dataSource.json && this.dataSource().dataSource.offline && creatAt) {

                    if (model.parentTaskIdMapping) {
                        var id = data[model.taskIdMapping],
                            index = proxy._taskIds.indexOf(id);
                        ganttRecord.item = (index > -1) ? proxy._retrivedData[index] : [];
                    } else {
                        ganttRecord.item = data;
                    }
                }
                else {
                    ganttRecord.item = data;
                }
            }
        },

        //Get the plain text from html string
        _getPlainText: function (htmlString) {
            var div = document.createElement("DIV");
            div.innerHTML = htmlString;
            return div.textContent || div.innerText || "";
        },

        /* udpate resourceNames attribute of record*/
        _updateResourceName: function (ganttRecord) {
            var proxy = this, resourceInfo = ganttRecord.resourceInfo,
                model = this.model,
                resourceName = [], length;

            if (resourceInfo) {
                length = resourceInfo.length;
                ganttRecord.item ? ganttRecord.item[model.resourceInfoMapping] = [] : null;
                 for (var i = 0; i < length; i++){
                     resourceName.push(resourceInfo[i][model.resourceNameMapping]);
                     if (ganttRecord.item) {
                         if (model.resourceUnitMapping && !ej.isNullOrUndefined(resourceInfo[i][model.resourceUnitMapping]) && resourceInfo[i][model.resourceUnitMapping] != 100)
                         {
                             var resourceObj = {};
                             resourceObj[model.resourceIdMapping] = resourceInfo[i][this.model.resourceIdMapping];
                             resourceObj[model.resourceUnitMapping] = resourceInfo[i][this.model.resourceUnitMapping];
                             ganttRecord.item[this.model.resourceInfoMapping].push(resourceObj);
                         } else
                             ganttRecord.item[this.model.resourceInfoMapping].push(resourceInfo[i][this.model.resourceIdMapping]);
                     }
                 }
                 ganttRecord.resourceNames = resourceName.join(',');
             }
        },
        //Update duration, work or unit of a resource according with the changes.
        _updateResourceRelatedFields: function (ganttRecord) {
            var proxy = this, model = proxy.model, updatedWorks,
                calculationType = ganttRecord.taskType,
                isAutoSchedule = ganttRecord.isAutoSchedule,
                isEffortDriven = (ganttRecord.effortDriven === "true"); //Convert String true/false to boolean.

            if (!ej.isNullOrUndefined(ganttRecord.resourceInfo)) {
                if (ganttRecord.work > 0 || proxy._updatedColumn == "work") {
                    switch (calculationType) {
                        case "fixedUnit":
                            if (isAutoSchedule && ganttRecord.resourceInfo.length &&
                                (proxy._updatedColumn == "work" ||
                                (isEffortDriven && proxy._updatedColumn == "resourceInfo")))
                                ganttRecord._updateDurationWithWork(proxy);

                            else if (!isAutoSchedule && proxy._updatedColumn == "work")
                                ganttRecord._updateUnitWithWork(proxy);

                            else
                                ganttRecord._updateWorkWithDuration(proxy);
                            break;
                        case "fixedWork":
                            if (ganttRecord.resourceInfo.length == 0)
                                return;
                            else if (isAutoSchedule) {
                                if (proxy._updatedColumn == "duration" || proxy._updatedColumn == "endDate") {
                                    ganttRecord._updateUnitWithWork(proxy);
                                    if (ganttRecord.duration == 0) {
                                        ganttRecord.work = 0;
                                        if (model.workMapping)
                                            ganttRecord.item[model.workMapping] = 0;
                                    }
                                }
                                else
                                    ganttRecord._updateDurationWithWork(proxy);
                            }
                            else {
                                if (proxy._updatedColumn == "work")
                                    ganttRecord._updateUnitWithWork(proxy);
                                else
                                    ganttRecord._updateWorkWithDuration(proxy);
                            }
                            break;
                        case "fixedDuration":                                                       
                            if (ganttRecord.resourceInfo.length && (proxy._updatedColumn == "work" ||
                                (isAutoSchedule && isEffortDriven && proxy._updatedColumn == "resourceInfo")))
                                ganttRecord._updateUnitWithWork(proxy);
                            else
                                ganttRecord._updateWorkWithDuration(proxy);
                            break;
                    }
                }
                else 
                    ganttRecord._updateWorkWithDuration(proxy);
            }
        },

        //Dynamically update resource treegrid datasource in resource tab of edit dialog box, according with changes in other resource related fields.
        _updateResourceDataSource: function (editedObj) {
            var proxy = this, resourceData = [],
                length = editedObj.resourceInfo ? editedObj.resourceInfo.length : 0;
            for (var i = 0; i < length; i++) {
                resourceData.push({ "name": editedObj.resourceInfo[i][proxy.model.resourceIdMapping], "unit": editedObj.resourceInfo[i][proxy.model.resourceUnitMapping] });
            }
            var resourceTreeGridId = "#treegrid" + proxy._id + "resourceEdit",
                resourceTreeGridDataSource = $(resourceTreeGridId).data("ejTreeGrid").model.dataSource;

            for (var index = 0; index < resourceTreeGridDataSource.length; index++) {
                var resource = resourceData.filter(function (data) { return data.name === parseInt(resourceTreeGridDataSource[index].name); });
                if (resource && resource.length == 0)
                    resourceData.push(resourceTreeGridDataSource[index]);
            }

            $(resourceTreeGridId).ejTreeGrid("option", "dataSource", resourceData);
        },
        _getHoliday: function () {
            if (this.model.holidays != null) {
                var holidayList = this.model.holidays,
                    holidays = [],
                    holidayLength = holidayList.length;
                if (holidayLength > 0) {
                    for (var i = 0; i < holidayLength; i++) {
                        holidays[i] = this._getDateFromFormat(holidayList[i].day);
                    }
                    return holidays;
                }
            }
            return false;
        },

        _getStringHolidays: function() {
            if (this._holidaysList != null && this._holidaysList.length > 0) {
                var holidayList = this._holidaysList,
                    holidays = [],
                    holidayLength = holidayList.length;
                if (holidayLength > 0) {
                    for (var i = 0; i < holidayLength; i++) {
                        holidays[i] = ej.format(holidayList[i], this.model.dateFormat, this.model.locale);
                    }
                    return holidays;
                }
            }
            return [];
        },
        
        //create childRecords for particular GanttRecord
        _createChildRecords: function (data, level, parentItem) {
            var ganttRecords = [],
                proxy = this, model = proxy.model,
                i = 0,
                length = data.length;

            for (i = 0; i < length; i++) {
                if (model.enableWBS) {
                    var parentWBS = parentItem.WBS;
                    data[i]["WBS"] = parentWBS + "." + (i + 1);
                }
                if (data[i]) {
                    var parentRecord = proxy._createGanttRecord(data[i], level, parentItem,undefined,"Load");
                    ganttRecords.push(parentRecord);
                }
            }
            return ganttRecords;
        },

        _createResourceInfoCollection: function (data) {
            var proxy = this,
                count = 0,
                length = data.length;
            for (count; count < length; count++) {
                proxy._resourceInfoCollection.push(proxy._createResourceInfo(data[count]));
            }
        },

        _createResourceInfo: function (data) {
            var model = this.model, resourceInfo = {};
            resourceInfo.resourceId = data[model.resourceIdMapping];
            resourceInfo.resourceName = data[model.resourceNameMapping];
            return resourceInfo;
        },

        _calculateWeekSplit: function (startdate, enddate) {
            var proxy = this,model=proxy.model,
                weekStartDay = model.scheduleHeaderSettings.weekStartDay;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") 
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") 
                var dt = new Date(startdate.getFullYear(), 0, 1);
            else
                var dt = startdate;
            startdate = dt;
            var dayIndex = (weekStartDay >= 0 && weekStartDay < 7) ? weekStartDay : 0,
                roundOffStartDate = startdate.getDay() <= dayIndex ? (startdate.getDate()) - (7 - dayIndex + startdate.getDay()) :
              (startdate.getDate()) - startdate.getDay() + dayIndex;
            startdate.setDate(roundOffStartDate);
            startdate.setHours(0, 0, 0, 0);
            do {
                proxy._scheduleWeeks.push(new Date(startdate));
                startdate.setDate(startdate.getDate() + 7);
            } while (!(startdate > enddate));

            proxy._projectStartDate= new Date(proxy._scheduleWeeks[0]);
            proxy._projectEndDate = new Date(proxy._scheduleWeeks[proxy._scheduleWeeks.length - 1]);
        },

        //method for calculatting years (year-month schedule mode)
        _calculateYearSplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    startdate = new Date(startdate.getFullYear() + 1, 0, 1);
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0].getFullYear(), proxy._scheduleYears[0].getMonth(), 1);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                  (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    if (startdate.getDate() == 29 && startdate.getMonth() == 0 && startdate.getFullYear() % 4 != 0)
                        startdate = new Date(startdate.getFullYear()+1, startdate.getMonth(), startdate.getDate() - 1);
                    else
                        startdate = new Date(startdate.getFullYear()+1, startdate.getMonth(), startdate.getDate());
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0]);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }
            else {
                startdate.setMonth(0);
                startdate.setDate(1);
                startdate.setHours(0, 0, 0, 0);
                do {
                    proxy._scheduleYears.push(new Date(startdate));
                    startdate.setMonth(startdate.getMonth() + 12);
                } while (!(startdate >= enddate));
                var projectStartDate, projectEndDate;
                proxy._projectStartDate = new Date(proxy._scheduleYears[0].getFullYear(), proxy._scheduleYears[0].getMonth(), 1);
                proxy._projectEndDate = new Date(proxy._scheduleYears[proxy._scheduleYears.length - 1].getFullYear(), 11, 31);
            }        

           
        },

        //Method for calculating days (day-hour schedule mode)
        _calculateDaySplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                    (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
            }
            else {
                startdate.setHours(0, 0, 0, 0);
            }
            do {
                proxy._scheduleDays.push(new Date(startdate));
                startdate.setDate(startdate.getDate() + 1);
            } while ((startdate <= enddate));
            proxy._projectStartDate = new Date(proxy._scheduleDays[0]);
            proxy._projectEndDate = new Date(proxy._scheduleDays[proxy._scheduleDays.length - 1]);
        },

        //Method for calculating hours (Hour-Minute schedule mode)
        _calculateHourSplit: function (startdate, enddate) {
            var proxy = this, model=proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                    (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "month") {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;               
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
            }
            else {
                startdate.setMinutes(0);              
            }
            do {
                proxy._scheduleHours.push(new Date(startdate));
                startdate.setHours(startdate.getHours() + 1);
            } while (startdate <= enddate);
            proxy._projectStartDate = new Date(proxy._scheduleHours[0]);          
            proxy._projectEndDate = new Date(proxy._scheduleHours[proxy._scheduleHours.length - 1]);
        },
        //new method for calculatting months
        _calculateMonthSplit: function (startdate, enddate) {
            var proxy = this, model = proxy.model;
            if (model.scheduleHeaderSettings.timescaleStartDateMode == "week") {
                var roundOffStartDate = startdate.getDay() == 0 ? (startdate.getDate()) - 7 :
                   (startdate.getDate()) - startdate.getDay();
                startdate.setDate(roundOffStartDate);
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getDate() == 29 && startdate.getMonth() == 0 && startdate.getFullYear() % 4 != 0)
                        startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, startdate.getDate() - 1);
                    else
                        startdate = new Date(startdate.getFullYear(), startdate.getMonth() + 1, startdate.getDate());
                } while (!(startdate >= enddate));
            }
            else if (model.scheduleHeaderSettings.timescaleStartDateMode == "year") {
                var dt = new Date(startdate.getFullYear(), 0, 1);
                startdate = dt;
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getMonth() == 0 || startdate.getMonth() == 2 || startdate.getMonth() == 4 || startdate.getMonth() == 6 || startdate.getMonth() == 7 || startdate.getMonth() == 9 || startdate.getMonth() == 11)
                        startdate.setDate(startdate.getDate() + 31);
                    else if (startdate.getMonth() == 3 || startdate.getMonth() == 5 || startdate.getMonth() == 8 || startdate.getMonth() == 10)
                        startdate.setDate(startdate.getDate() + 30);
                    else if (startdate.getMonth() == 1) {
                        if (startdate.getFullYear() % 4 == 0)
                            startdate.setDate(startdate.getDate() + 29);
                        else
                            startdate.setDate(startdate.getDate() + 28);
                    }
                } while (!(startdate >= enddate));
            }
            else {
                var dt = new Date(startdate.getFullYear(), startdate.getMonth(), 1);
                startdate = dt;
                do {
                    proxy._scheduleMonths.push(new Date(startdate));
                    if (startdate.getMonth() == 0 || startdate.getMonth() == 2 || startdate.getMonth() == 4 || startdate.getMonth() == 6 || startdate.getMonth() == 7 || startdate.getMonth() == 9 || startdate.getMonth() == 11)
                        startdate.setDate(startdate.getDate() + 31);
                    else if (startdate.getMonth() == 3 || startdate.getMonth() == 5 || startdate.getMonth() == 8 || startdate.getMonth() == 10)
                        startdate.setDate(startdate.getDate() + 30);
                    else if (startdate.getMonth() == 1) {
                        if (startdate.getFullYear() % 4 == 0)
                            startdate.setDate(startdate.getDate() + 29);
                        else
                            startdate.setDate(startdate.getDate() + 28);
                    }
                } while (!(startdate >= enddate));
            }

            var projectStartDate, projectEndDate;
            projectStartDate = new Date(proxy._scheduleMonths[0]);
            projectEndDate = new Date(proxy._scheduleMonths[proxy._scheduleMonths.length - 1]);
            projectEndDate = new Date(projectEndDate.getFullYear(), projectEndDate.getMonth() + 1, 0);
            proxy._projectStartDate = projectStartDate;
            proxy._projectEndDate = projectEndDate;
        },



        _updatePredecessors: function () {
            var proxy = this,
                count = 0,
                predecessorsCollection = proxy._predecessorsCollection,
                length = predecessorsCollection.length,
                ganttRecord,
                connectorsCollection,
            i = 0,
            successorGanttRecord,
            connectorCount;
            for (count; count < length; count++) {
                ganttRecord = predecessorsCollection[count];
                connectorsCollection = ganttRecord["predecessor"];
                connectorCount = connectorsCollection.length;
                for (i=0; i < connectorCount; i++) {
                    var connector = connectorsCollection[i];
                    successorGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(connector.from)];
                    if (connector.from !== ganttRecord.taskId.toString()) {
                        if (successorGanttRecord) {
                            if (successorGanttRecord.predecessor) {
                                successorGanttRecord.predecessor.push(connector);
                            } else {
                                successorGanttRecord.predecessor = [];
                                successorGanttRecord.predecessor.push(connector);
                                predecessorsCollection.push(successorGanttRecord);
                            }
                        }
                    }

                }                
            }
        },
        
        getDateType: function (date) {
            if (date != null) {
                if (typeof (date) == "object") {
                    return date;
                }
                else {
                    var hyphenRegex = new RegExp("\\-", "g"),
                    dotRegex = new RegExp("\\.", "g");
                    date = date.replace(hyphenRegex, "/");
                    date = date.replace(dotRegex, "/");
                    return new Date(date);
                }
            }
            return null;
        },

        getFormatedDate: function(date) {
            return ej.format(date, this.model.dateFormat, this.model.locale);
        },

        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },

        
        _wireEvents: function () {
            var proxy = this,
                model=proxy.model,
                treeGrid = $("#ejTreeGrid" + proxy._id),
                ganttChart = $("#ejGanttChart" + proxy._id),
                gantt = proxy._$ejGantt;

            proxy._on(proxy.element, "click", proxy.clickHandler);
            proxy._on(proxy.element, "click", ".e-ejinputtext", proxy._searchTextFocusIn);
            proxy._on(proxy.element, "focusout", ".e-ejinputtext", proxy._searchTextFocusOut);
            if (model.enableContextMenu) {
                proxy._on(proxy.element, "contextmenu", proxy._rightClick);
                proxy._on(proxy.element, "keyup", this._preventContextMenu);
            }

            if (model.enableResize && model.isResponsive) {
                proxy._on($(window), "resize", proxy.windowResize);
            }

            treeGrid.ejTreeGrid({ rowSelecting: $.proxy(proxy.rowSelecting, proxy) });
            treeGrid.ejTreeGrid({ rowSelected: $.proxy(proxy.rowSelected, proxy) });
            treeGrid.ejTreeGrid({ cellSelecting: $.proxy(proxy.cellSelecting, proxy) });
            treeGrid.ejTreeGrid({ cellSelected: $.proxy(proxy.cellSelected, proxy) });
            treeGrid.ejTreeGrid({ rowDrag: $.proxy(proxy.rowDrag, proxy) });
            treeGrid.ejTreeGrid({ rowDragStart: $.proxy(proxy.rowDragStart, proxy) });
            treeGrid.ejTreeGrid({ rowDragStop: $.proxy(proxy.rowDragStop, proxy) });
            treeGrid.ejTreeGrid({ actionBegin: $.proxy(proxy.actionBegin, proxy) });
            treeGrid.ejTreeGrid({ actionComplete: $.proxy(proxy.actionComplete, proxy) });
            treeGrid.ejTreeGrid({ expandAllCollapseAllRequest: $.proxy(proxy.expandAllCollapseAllRequest, proxy) });
            treeGrid.ejTreeGrid({ contextMenuAction: $.proxy(proxy.contextMenuAction, proxy) });
            treeGrid.ejTreeGrid({ subContextMenuAction: $.proxy(proxy.subContextMenuAction, proxy) });
            treeGrid.ejTreeGrid({ setInitialData: $.proxy(proxy.setInitialData, proxy) });
            

            if (model.queryCellInfo) {
                treeGrid.ejTreeGrid({ queryCellInfo: $.proxy(proxy._queryCellInfo, proxy) });
            }
            
            if (model.rowDataBound) {
                treeGrid.ejTreeGrid({ rowDataBound: $.proxy(proxy._rowDataBound, proxy) });
            }
            
            treeGrid.ejTreeGrid({ beginEdit: $.proxy(proxy._beginEdit, proxy) });
            treeGrid.ejTreeGrid({ endEdit: $.proxy(proxy._endEdit, proxy) });            
            
            treeGrid.ejTreeGrid({ expanding: $.proxy(proxy.expanding, proxy) });
            treeGrid.ejTreeGrid({ collapsing: $.proxy(proxy.collapsing, proxy) });
            treeGrid.ejTreeGrid({ expanded: $.proxy(proxy.expanded, proxy) });
            treeGrid.ejTreeGrid({ collapsed: $.proxy(proxy.collapsed, proxy) });
            treeGrid.ejTreeGrid({ refreshRow: $.proxy(proxy.refreshRow, proxy) });
            treeGrid.ejTreeGrid({ cancelEditCell: $.proxy(proxy.cancelEditCell, proxy) });
            
            
            ganttChart.ejGanttChart({ rowSelecting: $.proxy(proxy.rowSelecting, proxy) });
            ganttChart.ejGanttChart({ rowSelected: $.proxy(proxy.rowSelected, proxy) });
            ganttChart.ejGanttChart({ rowHover: $.proxy(proxy._ganttChartRowHover, proxy) });
            ganttChart.ejGanttChart({ actionBegin: $.proxy(proxy.actionBegin, proxy) });
            ganttChart.ejGanttChart({ actionComplete: $.proxy(proxy.chartactionComplete, proxy) });
            ganttChart.ejGanttChart({ refreshRow: $.proxy(proxy.refreshRowData, proxy) }); 
            ganttChart.ejGanttChart({ zooming: $.proxy(proxy.zoomingChart, proxy) });
            ganttChart.ejGanttChart({ queryTaskbarInfo: $.proxy(proxy.queryTaskbarInfo, proxy) });
            ganttChart.ejGanttChart({ expanding: $.proxy(proxy.expanding, proxy) });
            ganttChart.ejGanttChart({ collapsing: $.proxy(proxy.collapsing, proxy) });
            ganttChart.ejGanttChart({ expanded: $.proxy(proxy.expanded, proxy) });
            ganttChart.ejGanttChart({ collapsed: $.proxy(proxy.collapsed, proxy) });
            ganttChart.ejGanttChart({ expandAllCollapseAllRequest: $.proxy(proxy.expandAllCollapseAllRequest, proxy) });
            ganttChart.ejGanttChart({ taskbarEditing: $.proxy(proxy.taskbarEditing, proxy) });
            ganttChart.ejGanttChart({ taskbarEdited: $.proxy(proxy.taskbarEdited, proxy) });
            ganttChart.ejGanttChart({ calculateEndDate: $.proxy(proxy.calculateEndDate, proxy) });
            ganttChart.ejGanttChart({ calculateDuration: $.proxy(proxy.calculateDuration, proxy) });
            ganttChart.ejGanttChart({ clearColumnMenu: $.proxy(proxy.clearColumnMenu, proxy) });
            ganttChart.ejGanttChart({ deleteRow: $.proxy(proxy.deleteRow, proxy) });
            ganttChart.ejGanttChart({ cancelEditCell: $.proxy(proxy.cancelEditCell, proxy) });
            gantt.ejSplitter({ allowResizing: $.proxy(proxy._onResize, proxy) });
            proxy._on(proxy.element, "mousedown", proxy._mousedownhandler);
            proxy._enableEditingEvents();
        },
 
        /* prevent context menu action by menu option key*/
        _preventContextMenu: function (e) {
            if (e.keyCode == 93) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
        },
        _onResize: function (args) {
            var proxy = this,
                isPercentage = false,
                splitterPosition = proxy.splitterPosition();
            /* cancel edited cell in treegrid while resize the splitter*/
            if (proxy._isinBeginEdit) {
                if ($("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
                    proxy._isinBeginEdit = false;
                }
            }
            if (splitterPosition.indexOf("%") != -1) 
                isPercentage = true;
            else 
                isPercentage = false;
            if (isPercentage)
                proxy.splitterPosition(Math.round(args.prevPane.size / proxy._ganttWidth * 100)+ "%");
            else
                proxy.splitterPosition(Math.round(args.prevPane.size).toString());
            proxy._splitterPosition(proxy.splitterPosition());
            proxy._$treegridHelper.ejTreeGrid("refreshScroller", args.prevPane.size);
            proxy._$ganttchartHelper.ejGanttChart("refreshScroller", args.nextPane.size - 1);// chart content parent div added with 1px right border

        },
        _searchTextFocusOut: function (e) {
            var focus = 0;
            var proxy = this,searchTitle = this._toolboxTooltipTexts["searchTool"];
            var $target = $(e.target);
            if ($($target).closest('li') && $($target).closest('li').attr('id') == proxy._id + "_search") {
                $($target).attr("placeholder", searchTitle);
            }
        },
        _searchTextFocusIn: function (e) {
            var proxy = this;
            var $target = $(e.target);
            var attr = $($target).attr('placeholder');
            if ($target.hasClass("e-ejinputtext") && attr)
                $target.removeAttr('placeholder');
        },
        clickHandler: function (e) {
            var proxy = this;
            var $target = $(e.target);

            //if ($target.closest(".e-popup").length == 0 &&
            //  $target.closest(".e-rowcell").find("#" + proxy._id + "EditForm").length == 0) {
                
            //}


            proxy._clearContextMenu();

            //Skip the scroll bar click in Gantt.
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-vdown"))
                return;
            if ($target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hup") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace"))
                return;            
            if (proxy._isinBeginEdit && document.getElementById(proxy._id).contains($target[0])) {

                if (!$target.closest('td').hasClass("e-editedcell") && !$target.hasClass('e-date') && !$target.hasClass('e-arrow') && !$target.hasClass('e-down-arrow') && $target.closest("form#ejTreeGrid" + proxy._id + "EditForm").length == 0
                    && $("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("saveCell");
                    proxy._isinBeginEdit = false;
                }
            }
            proxy.clearColumnMenu();
        },

        windowResize: function (e) {

            if (!this.element.is(":visible")) {
                return;
            }

            var proxy = this,
                ejGanttSplit = ("#e-ejSpliter" + this._id),
                toolbar = ("#" + this._id + "_toolbarItems"),
                ganttchart = ("#ejGanttChart" + this._id),
                treegrid = ("#ejTreeGrid" + this._id),
                ganttbody = $("#" + this._id).find(".e-ganttviewerbodyContianer"),
                gantthead = $("#" + this._id).find(".e-ganttviewerheaderContainer"),
                treegridhelp = ("#ejTreeGrid" + this._id),
                treegridcontent = ("#ejTreeGrid" + this._id + "e-gridcontent"),
                sizeSettingsWidth = proxy.model.sizeSettings.width,
                sizeSettingsHeight = proxy.model.sizeSettings.height,
                elementStyleHeight = proxy.element[0].style.height,
                elementStyleWidth = proxy.element[0].style.width,
                width, height, maxScrollWidth;
            //Width calculation
            if ((sizeSettingsWidth && (typeof(sizeSettingsWidth) != "number" && sizeSettingsWidth.indexOf("%") != -1)) || elementStyleWidth.indexOf("%") != -1) {

                var ganttWidth = sizeSettingsWidth ? sizeSettingsWidth : elementStyleWidth;
                var containerWidth = $(proxy.element).parent().width() ? $(proxy.element).parent().width() : $(proxy.element).width();
                width = (containerWidth / 100) * parseInt(ganttWidth);
                
            }
            else
                width = $(proxy.element).width();
            if (proxy.splitterPosition().indexOf("%") == -1){
                var splitterPosition = parseInt(proxy.splitterPosition()) + 7 + 2; // here 7 is splitter width, 2 is border width
                proxy._ganttWidth = width = Math.max(width, splitterPosition);
            }
            else
                proxy._ganttWidth = width;
            //height calculation
            if ((sizeSettingsHeight && (typeof(sizeSettingsWidth) != "number" && sizeSettingsHeight.indexOf("%") != -1 )) || elementStyleHeight.indexOf("%") != -1) {
                var ganttHeight = sizeSettingsHeight ? sizeSettingsHeight : elementStyleHeight;
                var containerHeight = $(proxy.element).parent().height() ? $(proxy.element).parent().height() : $(proxy.element).height();
                var tempHeight;
                if ($(proxy.element).parent().height())
                    tempHeight = (containerHeight / 100) * parseInt(ganttHeight);
                else
                    tempHeight = $(proxy.element).height();
                height = tempHeight;
            }
            else
                height = $(proxy.element).height();

            //Exclude bordor from width and height
            height = height - proxy._totalBorderHeight;
            width = Math.round(width);

            var ganttWidth, treeGridWidth, top,left,
                toolbarHeight = $(toolbar).length ? $(toolbar).height() : 0;
            $(ejGanttSplit).css("width", width);
            $(ejGanttSplit).css("height", (height - toolbarHeight));
            $(ejGanttSplit).ejSplitter("refresh");
            if ($(toolbar).length) {
                $(toolbar).css("width", width);              
            }

            ganttWidth = $(ganttchart).width();
            treeGridWidth = $(treegrid).width();
            $(ganttchart).height(height - toolbarHeight);

            top = ganttbody.ejScroller("option", "scrollTop");
            left = ganttbody.ejScroller("option", "scrollLeft");
            //set height for scroller div
            ganttbody.ejScroller({
                width: ganttWidth,
                height: (height - toolbarHeight - gantthead.height() - parseInt(gantthead.css("border-bottom-width"))),
            });
            ganttbody.ejScroller("refresh");
            maxScrollWidth = proxy._$ganttchartHelper.ejGanttChart("getMaxScrollWidth");
            if (left > maxScrollWidth)
                left = maxScrollWidth > 0 ? maxScrollWidth : 0;

            ganttbody.ejScroller("option", "scrollTop", top);
            ganttbody.ejScroller("option", "scrollLeft", left);

            $(treegridhelp).height(height - toolbarHeight);
            $(treegridcontent).height((height - toolbarHeight - gantthead.height() - proxy._totalBorderHeight));
            left = $(treegridcontent).ejScroller("option", "scrollLeft");
            //$(treegridcontent).ejScroller("destroy";
            $(treegridcontent).width(treeGridWidth);
            //$(treegridcontent).ejScroller({
            //    width: treeGridWidth,
            //    scrollTop: top,
            //    height: 0
            //});
            $(treegridcontent).ejScroller("refresh");
            maxScrollWidth = proxy._$treegridHelper.ejTreeGrid("getMaxScrollWidth");
            if (left > maxScrollWidth)
                left = maxScrollWidth > 0 ? maxScrollWidth : 0;

            $(treegridcontent).ejScroller("option", "scrollLeft", left);

            proxy._$treegridHelper.ejTreeGrid("updateViewPortHeight");
            proxy._$ganttchartHelper.ejGanttChart("updateViewPortHeight");
            if(proxy.model.enableVirtualization)
            {
                proxy._$treegridHelper.ejTreeGrid("cancelRowEditCell");                
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("processBindings", tempArgs);
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
            }
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._updateRowHeightInConnectorLine(proxy._connectorLinesCollection);
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines", proxy._connectorLinesCollection);
            proxy.setSplitterPosition(proxy.splitterPosition());
        },
        _updateRowHeightInConnectorLine: function (collection) {
            if (collection && collection.length) {
                var chartObject = $("#ejGanttChart" + this._id).ejGanttChart("instance");
                var rowHeight1 = $("#" + chartObject._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
                if (rowHeight1 && !isNaN(rowHeight1)) {
                    for (var count = 0; count < collection.length; count++) {
                        collection[count].RowHeight = rowHeight1;
                    }
                }
            }
        },
        /* Public method for scroll to the corresponding offset value */
        setScrollTop: function (top) {
            var proxy = this,
                max = proxy._$treegridHelper.ejTreeGrid("getMaxScrollHeight");
            if (proxy._isinBeginEdit)
                proxy._$treegridHelper.ejTreeGrid("saveCell");

            if ((typeof top == "number" || typeof parseInt(top) == "number")) {
                top = parseInt(top);
                if (top >= 0) {
                    if (max >= top)
                        proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
                    else
                        proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", max);
                }
            }
        },
        
        // handler for mouse right click
        _rightClick: function (e) {
            e.preventDefault();
            var proxy = this,
                model = proxy.model,
                $target = $(e.target),
                div = $target.closest('tr'),
                $ganttGridRows,
                row,
                recordIndexr,
                item,selectIndex, selectCellIndex,
                args = {};
            proxy._$treegridHelper.ejTreeGrid("disableTooltip");
            proxy.clearColumnMenu();
            if ($(div).hasClass("e-chartcell") || $(div).hasClass("e-ganttrowcell")) {
                $ganttGridRows = proxy._$ganttchartHelper.ejGanttChart("getGanttChartRows");
                args.target = "ejTreeGrid";
            } else {
                $ganttGridRows = $(proxy._$treegridHelper.ejTreeGrid("getRows"));
                args.target = "ejGanttChart";
            }
            row = $target.closest('tr');
            recordIndexr = $ganttGridRows.index(row);
            proxy.model.currentViewData = proxy.getCurrentViewData();
            item = proxy.model.currentViewData[recordIndexr];
            recordIndexr = proxy.model.updatedRecords.indexOf(item);
            args.data = item;
            args.recordIndex = recordIndexr;

            if (item && proxy.model.enableContextMenu) {
                proxy._contextMenuItems = [];
                proxy._contextMenuItems = proxy._getContextMenuItems();
                proxy._updateIndentOutdentContextmenuOption(item);
                proxy._clearContextMenu();
                if (proxy._contextMenuItems.length > 0) {
                    if (proxy.model.readOnly == true || !proxy.model.editSettings.allowAdding) {
                          proxy._removeContextMenuItem("Below");
                          proxy._removeContextMenuItem("Above");
                    }
                    proxy._renderContextMenu(e, recordIndexr, item);
                }
                if (model.selectionMode == "row") {
                if (recordIndexr != proxy.model.selectedRowIndex)
                    proxy.rowSelected(args);
                proxy._$treegridHelper.ejTreeGrid("selectRows", recordIndexr);
                proxy._$ganttchartHelper.ejGanttChart("selectRows", recordIndexr);
                proxy.updateIndentOutdentOption(args.data);
            }
                if (model.selectionMode == "cell")  {
                    proxy._rowIndexOfLastSelectedCell = recordIndexr;
                    selectCellIndex = proxy._$treegridHelper.ejTreeGrid("getCellIndex", e);
                    if (!$($target.closest('td')).hasClass("e-chartcell"))
                        proxy.selectCells([{ rowIndex: recordIndexr, cellIndex: selectCellIndex }]);
                }
                //To save edited data when beginEditAction as "click"
                if (model.editSettings.beginEditAction == "click" && $("#ejTreeGrid" + proxy._id + "EditForm").length > 0) {
                    proxy._$treegridHelper.ejTreeGrid("saveCell");
                    proxy._isinBeginEdit = false;
                }
            }
            else if (proxy.model.flatRecords.length === 0 && proxy.model.enableContextMenu) {
                proxy._contextMenuItems = [];
                proxy._contextMenuItems = proxy._getContextMenuItems();
                //remove subContextMenu Items
                proxy._contextMenuItems.splice(5, 2);
                proxy._updateIndentOutdentContextmenuOption(item);
                proxy._clearContextMenu();
                if (proxy._contextMenuItems.length > 0)
                    proxy._renderContextMenu(e, recordIndexr, item);
            }
        },
		 // Mouse down handler for gantt
        _mousedownhandler:function(e)
        {
            var $target = $(e.target),
            proxy = this;
            proxy._clearContextMenu();
            if ($target.hasClass("e-vhandle") || $target.hasClass("e-vscrollbar") || $target.hasClass("e-vup") || $target.hasClass("e-vdown") || $target.hasClass("e-vhandlespace") || $target.hasClass("e-hhandle") || $target.hasClass("e-hscrollbar") || $target.hasClass("e-hdown") || $target.hasClass("e-hhandlespace") || $target.hasClass("e-splitbar")) {
                
                proxy.clearColumnMenu();
            }
        },
        
        //remove corresponding menu item in contextmenu collection by it menuId
        _removeContextMenuItem: function (id) {
            var proxy = this,
                index, contextMenuItems = proxy._contextMenuItems,
                filteredMenuItem;

            filteredMenuItem = contextMenuItems.filter(function (value) {
                if (value.menuId === id)
                    return true;
            });

            if (filteredMenuItem.length > 0) {
                index = contextMenuItems.indexOf(filteredMenuItem[0]);
                contextMenuItems.splice(index, 1);
            }
        },

        //Update contextmenu item according to selected item and editSettings API values
        _updateIndentOutdentContextmenuOption: function (ganttRecord) {
            var proxy = this,
                model = proxy.model,
                flatRecords = this.model.flatRecords,
                recordIndex = flatRecords.indexOf(ganttRecord);
            if (proxy.model.readOnly == true) {
                proxy._removeContextMenuItem("Add");              
                proxy._removeContextMenuItem("Task");
                proxy._removeContextMenuItem("Delete");
                proxy._removeContextMenuItem("Indent");
                proxy._removeContextMenuItem("Outdent");
            }
            else {
                if (recordIndex === 0) {
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }
                else if (recordIndex > 0) {
                    if (ganttRecord.level === 0) {
                        proxy._removeContextMenuItem("Outdent");
                    }
                    else {
                        var previousGanttRecord = flatRecords[recordIndex - 1];
                        if (ganttRecord.level - previousGanttRecord.level === 1) {
                            proxy._removeContextMenuItem("Indent");
                        }
                    }
                }
                else if (recordIndex < 0) {
                    proxy._removeContextMenuItem("Task");
                    proxy._removeContextMenuItem("Delete");
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }

                if (!model.editSettings.allowAdding) {
                    proxy._removeContextMenuItem("Add");
                }

                if (!model.editSettings.allowDeleting) {
                    proxy._removeContextMenuItem("Delete");
                }

                if (!model.editSettings.allowEditing) {
                    proxy._removeContextMenuItem("Task");
                }
                if (!model.editSettings.allowIndent) {
                    proxy._removeContextMenuItem("Indent");
                    proxy._removeContextMenuItem("Outdent");
                }                
            }
        },
      
        queryTaskbarInfo: function (args) {        
            this._trigger("queryTaskbarInfo", args);
        },
        

        zoomingChart: function (args) {
            var proxy = this;
            proxy.reRenderChart(args.delta);
        },

        refreshRowData: function (args) {
            var proxy = this,
                treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            ej.TreeGrid.refreshRow(treegridObject, args.index);
        },

        expanding: function (args) {
            var proxy = this;           
            if (!proxy._trigger("expanding", args)) {
                if (proxy.model.enableVirtualization) {                    
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                } else {
                    proxy._isInExpandCollapse = true;
                    //If need refresh chart if record is added after searching or sorting
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = true;
                        proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", args.data, true);
                        proxy._refreshChartAndGridRows();
                        proxy._isRefreshAddedRecord = false;
                        return;
                    }
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    proxy._isInExpandCollapse = false;

                }
                proxy.updateSelectedItemIndex();
            }
        },

        collapsing: function (args) {
            var proxy = this, model= this.model,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (!proxy._trigger("collapsing", args)) {
                if (proxy.model.enableVirtualization) {                    
                    ej.TreeGrid.sendExpandCollapseRequest(proxy,args);
                } else {
                    proxy._isInExpandCollapse = true;
                    //If need refresh chart if record is added after searching or sorting
                    if (proxy._isRefreshAddedRecord) {
                        args.data.expanded = false;
                        proxy._$treegridHelper.ejTreeGrid("updateExpandStatus", args.data, false);
                        proxy._refreshChartAndGridRows();
                        proxy._isRefreshAddedRecord = false;
                        return;
                    }
                    proxy._gridRows = proxy.getRows();
                    ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    proxy._isInExpandCollapse = false;
                }
                var selectItem = proxy.selectedItem(), index;
                if (selectItem) {
                    var expanded = proxy.getExpandStatus(selectItem);
                    if (!expanded && !args.expanded) {
                        proxy._deSelectRowItem();
                        if (model.toolbarSettings.showToolbar) {
                            if (proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1) {
                                $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-deleteitem").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("indent") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-indent").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("outdent") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-outdent").parent()[0]);
                                if (proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                                    $(toolbar).ejToolbar('disableItem', $(toolbar).find(".e-edititem").parent()[0]);
                            }
                        }
                    }
                    else {
                        proxy.updateSelectedItemIndex();
                    }
                }
            }
        },

        refreshRow: function (args) {
            var proxy = this;
            proxy._$ganttchartHelper.ejGanttChart("refreshRow", args.recordIndex);
        },

        _enableEditingEvents: function () {
            var proxy = this,
                model = proxy.model;
            //To off the  event while changing the editSettings dynamically in setModel
            proxy._off($("#" + proxy._id + "_dialogEdit"),
                    "click keypress", "#EditDialog_" + proxy._id + "_Save ,#EditDialog_" + proxy._id + "_Cancel,#EditDialog_" + proxy._id + "_Delete", proxy._buttonClick);

            proxy._off($("#" + proxy._id + "_dialogAdd"),
               "click keypress", "#AddDialog_" + proxy._id + "_Save ,#AddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);

            if (model.editSettings.allowEditing|| model.editSettings.editMode == "dialogTemplate" ||
                (model.toolbarSettings.showToolbar && ((model.editSettings.allowAdding && model.toolbarSettings.toolbarItems.indexOf("add") !== -1) ||
                    (model.editSettings.allowEditing && model.toolbarSettings.toolbarItems.indexOf("index") !== -1)))) {
                
                proxy._on($("#" + proxy._id + "_dialogEdit"),
                    "click keypress", "#EditDialog_" + proxy._id + "_Save ,#EditDialog_" + proxy._id + "_Cancel,#EditDialog_" + proxy._id + "_Delete", proxy._buttonClick);

                proxy._on($("#" + proxy._id + "_dialogAdd"),
                   "click keypress", "#AddDialog_" + proxy._id + "_Save ,#AddDialog_" + proxy._id + "_Cancel", proxy._buttonClick);
                // $(proxy.element).on("click", ".e-icon", $.proxy(proxy._buttonClick, proxy));
            }
        },
        
        cancelEditCell: function () {

            var proxy = this;
            if ($("#ejTreeGrid" + proxy._id + "EditForm").length > 0)
                proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
        },

        _keyPressed: function (action, target, e) {
        },

        _buttonClick: function (e) {

            if (e.type !="click" && e.keyCode !== undefined && e.keyCode != 13)
                return true;
            
            var proxy = this,   
                model = proxy.model,
                args = {};
            
            if (model.editSettings.allowEditing || model.editSettings.editMode == "dialogTemplate" ||
                (model.toolbarSettings.showToolbar && ((model.editSettings.allowAdding && model.toolbarSettings.toolbarItems.indexOf("add") !== -1) ||
                    (model.editSettings.allowEditing && model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)))) {

                if (e.target.id == "EditDialog_" + proxy._id + "_Save") {
                    var newArgs = {},
                        validateMode = {
                            respectLink: false,
                            removeLink: false,
                            preserveLinkWithEditing: true,
                        };
                    newArgs.editMode = "dialogEdit";
                    newArgs.data = this._editedDialogRecord;
                    newArgs.requestType = "validateLinkedTask";
                    newArgs.validateMode = validateMode;
                    if (!proxy._trigger("actionBegin", newArgs)) {
                        if (proxy._datePickerChangeEvent && (this._editedDialogRecord.isAutoSchedule || model.validateManualTasksOnLinking)) {
                            proxy._datePickerChangeEvent = false;
                            if (model.enablePredecessorValidation && proxy._validateTypes(newArgs)) {
                                if (!proxy._sendSaveRequest("Edit")) {
                                    proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                                    $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                                }
                            }
                            else
                                $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                        }
                        else {
                            if (!proxy._sendSaveRequest("Edit")) {
                                proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                                $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                            }
                        }
                    }
                } else if (e.target.id == "EditDialog_" + proxy._id + "_Cancel") {
                    $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                }
                    //For delete option in editing dialog window
                else if (e.target.id == "EditDialog_" + proxy._id + "_Delete") {
                    var result;
                    if (model.allowSelection == false && !ej.isNullOrUndefined(proxy._contextMenuSelectedIndex)) {
                        result = proxy._$treegridHelper.ejTreeGrid("deleteRow", null, true, proxy._contextMenuSelectedIndex);
                    }else{
                        result = proxy._$treegridHelper.ejTreeGrid("deleteRow");
                    }

                    if (!(result == true)) {
                        proxy._isAddEditDialogSave = true;
                        $("#" + proxy._id + "_dialogEdit").ejDialog("close");
                    }
                }
                else if (e.target.id == "AddDialog_" + proxy._id + "_Save") {
                    if (!proxy._sendSaveRequest("Add"))
                        if (!this._duplicate && !this._wrongenddate) {
                            proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                            $("#" + proxy._id + "_dialogAdd").ejDialog("close");                            
                        }
                }
                else if (e.target.id == "AddDialog_" + proxy._id + "_Cancel") {
                  //  proxy._ids.splice(proxy._ids.length - 1, 1);
                    $("#" + proxy._id + "_dialogAdd").ejDialog("close");
                }
            }
            else {
                proxy._sendCancelRequest();
            }

            return false;
        },
        rowDrag: function (args) {
            var proxy = this;
            proxy.model.selectedCellIndexes = [];
            proxy._trigger("rowDrag", args);
        },
        rowDragStart: function (args) {
            var proxy = this;
            proxy._trigger("rowDragStart", args);
        },
        rowDragStop: function (args) {
            var proxy = this;
            proxy._trigger("rowDragStop", args);
        },
        cellSelecting: function (args) {
            var proxy = this, model = proxy.model;
            proxy._trigger("cellSelecting", args);           
        },
        cellSelected: function (args) {
            var proxy = this, model = proxy.model;
            proxy._trigger("cellSelected", args);
            model.selectedCellIndexes = proxy._$treegridHelper.ejTreeGrid("instance").model.selectedCellIndexes;
            proxy._rowIndexOfLastSelectedCell = model.selectedCellIndexes[0].rowIndex;
        },
        //trigger row selecting client side event
        rowSelecting: function (args) {
            var proxy = this, eventArgs = {}, model = this.model;
            if (proxy.model.rowSelecting && model.selectionMode == "row") {
                eventArgs.recordIndex = args.recordIndex;
                eventArgs.previousIndex = args.previousIndex;
                eventArgs.previousData = model.updatedRecords[args.previousIndex];
                eventArgs.data = model.updatedRecords[args.recordIndex];
                eventArgs.previousChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.previousIndex);
                eventArgs.previousGridRow = ej.TreeGrid.getRowByIndex(this, args.previousIndex);
                eventArgs.targetChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.recordIndex);
                eventArgs.targetGridRow = ej.TreeGrid.getRowByIndex(this, args.recordIndex);
                if (proxy._trigger("rowSelecting", eventArgs))
                    return false;
            }
            return true;
        },

        rowSelected: function (args) {
            var proxy = this, model = this.model,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (model.allowSelection) {
                if (args.target == "ejTreeGrid")
                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                if (args.target == "ejGanttChart")
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
            }
            var idx = args.recordIndex;
            this.selectedItem(args.data);
            this.selectedRowIndex(idx);
            if (proxy.model.toolbarSettings.showToolbar && args.requestType!="rowDragAndDrop") {
                if (proxy.model.readOnly == true) {
                    var disableItems = [];
                    disableItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    disableItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    disableItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    $(toolbar).ejToolbar('disableItem', disableItems);

                }

                else {

                    if ((proxy.model.toolbarSettings.toolbarItems.indexOf("indent") !== -1 || proxy.model.toolbarSettings.toolbarItems.indexOf("outdent") !== -1) && proxy.model.allowSelection) {

                        proxy.updateIndentOutdentOption(args.data);
                    }

                    var enableItems = [];

                    if (proxy.model.editSettings.allowDeleting && proxy.model.allowSelection) {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1)
                            enableItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    }
                    if (proxy.model.editSettings.allowAdding) {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("add") !== -1)
                            enableItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    }
                    if (proxy.model.editSettings.allowEditing && proxy.model.allowSelection && model.editSettings.beginEditAction != "click") {
                        if (proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                            enableItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    }

                    $(toolbar).ejToolbar('enableItem', enableItems);
                }
            }

            var eventArgs = {};
            eventArgs.recordIndex = args.recordIndex;
            var data = $.extend({}, model.updatedRecords[args.recordIndex]);
            /* Delete the childRecords and parentItem from data because of avoid circular reference
               while performing postback in ASP.NET */
            delete data.childRecords; 
            delete data.parentItem;
            eventArgs.data = data;
            eventArgs.targetChartRow = proxy._$ganttchartHelper.ejGanttChart("getRowByIndex", args.recordIndex);
            eventArgs.targetGridRow = ej.TreeGrid.getRowByIndex(this, args.recordIndex);
            if (model.allowSelection && model.selectionMode == "row")
                proxy._trigger("rowSelected", eventArgs);
        },

        updateIndentOutdentOption: function (ganttRecord) {
            var proxy = this,
                flatRecords = proxy.model.flatRecords;

            var recordIndex = flatRecords.indexOf(ganttRecord),
                previousGanttRecord;

            var toolbar = $("#" + proxy._id + "_toolbarItems"),
                indentIconElement = $(toolbar).find(".e-indent").parent()[0],
                outentIconElement = $(toolbar).find(".e-outdent").parent()[0];
            if (recordIndex === 0 || proxy.model.editSettings.allowIndent == false || proxy.model.readOnly == true || !proxy.model.allowSelection) {
                if (indentIconElement)
                    $(toolbar).ejToolbar('disableItem', indentIconElement);

                if (outentIconElement)
                    $(toolbar).ejToolbar('disableItem', outentIconElement);
            }
            else {
                if (ganttRecord.level === 0 && proxy.model.editSettings.allowIndent == true) {
                    if (indentIconElement)
                        $(toolbar).ejToolbar('enableItem', indentIconElement);
                    if (outentIconElement)
                        $(toolbar).ejToolbar('disableItem', outentIconElement);
                }
                else {
                    previousGanttRecord = flatRecords[recordIndex - 1];
                    if ((ganttRecord.level - previousGanttRecord.level === 1) && proxy.model.editSettings.allowIndent == true && proxy.selectedRowIndex() !=-1) {
                        if (outentIconElement)
                            $(toolbar).ejToolbar('enableItem', outentIconElement);
                        if (indentIconElement)
                            $(toolbar).ejToolbar('disableItem', indentIconElement);
                    }

                    else if (proxy.model.editSettings.allowIndent == true && proxy.selectedRowIndex() != -1) {
                        if (indentIconElement)
                            $(toolbar).ejToolbar('enableItem', indentIconElement);
                        if (outentIconElement)
                            $(toolbar).ejToolbar('enableItem', outentIconElement);
                    }
                }
            }
        },

        _ganttChartRowHover: function (args) {
            var proxy = this;
            if (args.reason == "mouseenter")
                proxy._$treegridHelper.ejTreeGrid("addRowHover", args.index);
            else if (args.reason == "mouseleave")
                proxy._$treegridHelper.ejTreeGrid("removeRowHover");
        },
        _removeChildRecordsPredecessor:function(record)
        {
            var proxy = this;
            if (record.hasChildRecords) {
                var length = record.childRecords.length, index = 0;
                for (index; index < length; index++) {
                    record.childRecords[index].predecessor && proxy._removePredecessor(record.childRecords[index].predecessor, record.childRecords[index]);
                    if(record.childRecords[index].hasChildRecords)
                    {
                        proxy._removeChildRecordsPredecessor(record.childRecords[index]);
                    }
                }
            }
        },
        getExpandedRecordCount: function (record, count)
        {
            var currentRecord, proxy = this;
            if (!record.hasChildRecords)
                return 0;
            for (var i = 0; i < record.childRecords.length; i++) {
                currentRecord = record.childRecords[i];
                if (proxy.getExpandStatus(currentRecord))
                    count++;
                
                if (currentRecord.hasChildRecords) {
                    count = proxy.getExpandedRecordCount(currentRecord, count);
                }
            }
            return count;
        },

        _updateExpandStatus:function()
        {
            var proxy = this,
                records = this.model.flatRecords,
            length = records.length, oldValue;
            for (var i = 0; i < length; i++) {
                oldValue = records[i].isExpanded;
                if (proxy.getExpandStatus(records[i]) !== records[i].isExpanded) {
                    records[i].isExpanded = proxy.getExpandStatus(records[i]);
                    if (records[i].isExpanded) {
                        proxy._totalCollapseRecordCount--;
                    }
                    else {
                        proxy._totalCollapseRecordCount++;
                    }
                }
            }
        },
        actionComplete: function (args) {
            var proxy = this,model = proxy.model,
                addedIndex = -1;
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            proxy._gridRows = proxy.getRows();
            proxy._ganttChartRows = proxy.getGanttChartRows();
            proxy._totalCollapseRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");

            if (args.requestType === "searching" || args.requestType === "sorting") {
                proxy._isRefreshAddedRecord = false;
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
                proxy._isValidationEnabled = false;
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._createConnectorLinesCollection();
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }
            if (args.requestType == "sorting") {
                proxy._deSelectRowItem();
            }

            if (args.requestType === "delete") {
                proxy._isRefreshAddedRecord = false;
                this.dataSource(proxy._$treegridHelper.ejTreeGrid("getDataSource"));
                if (proxy._isDataManagerUpdate)
                    this._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");
                proxy.model.flatRecords = proxy._$treegridHelper.ejTreeGrid("getFlatRecords");
                proxy.model.ids = proxy._$treegridHelper.ejTreeGrid("getUpdatedIds");
                proxy.model.updatedRecords = proxy.getUpdatedRecords();
                model.selectedItem = null;
                this.selectedRowIndex(-1);
                var childCount = 0,
                    expandedRecordCount=0;
                //Delete from parent collection if item is in parentsCollection
                if (model.parentRecords.indexOf(args.data) !== -1) {
                    model.parentRecords.splice(model.parentRecords.indexOf(args.data), 1);
                }
                //Delete predecessor from child records
                if (args.data.hasChildRecords) {
                    proxy._removeChildRecordsPredecessor(args.data)
                }
                //Delete Predecessor from record
                if (!args.isDragAndDropDelete)
                args.data.predecessor && proxy._removePredecessor(args.data.predecessor, args.data);
                //Update parent item if item has parent
                if (args.data.parentItem)
                {
                    var parentRecord=args.data.parentItem;
                    if(args.data.parentItem.childRecords.length>0)
                    {
                        if (args.data.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args.data);
                        else if(!args.data.parentItem.isAutoSchedule)
                            proxy._updateManualParentItem(args.data);
                    }else
                    {
                        parentRecord.expanded=false;
                        parentRecord.hasChildRecords = false;
                        proxy.refreshGanttRecord(parentRecord);
                    }
                }
                // To avoid refresh of gantt chart twice.
                if (args.isDragAndDropDelete)
                    return;
                proxy._isValidationEnabled = false;
                if (proxy.model.predecessorMapping) {
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._predecessorsCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                }
                if (this.isCriticalPathEnable == true) {
                    this.showCriticalPath(true, true);
                }
                //Scroller is not correctly updated before connector line cleared.
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.getCurrentViewData(), proxy.getUpdatedRecords(), proxy._totalCollapseRecordCount);

                proxy._updateToolbarOptions(); // for uypdating toolbar items after delete operation
                proxy.updateAltRow(proxy.getUpdatedRecords(), 0, 1);//for set e-alt-row style after deletion of element  
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }

            if (args.requestType === "selection") {
                proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
            }

            if (args.requestType === "rowHover") {
                proxy._$ganttchartHelper.ejGanttChart("addRowHover", args.index);
            }
            
            if (args.requestType === "scroll") {
                
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", args.delta);
            }
            if (args.requestType == "dragAndDrop") {
                proxy._isRefreshAddedRecord = false;
                this.dataSource(proxy._$treegridHelper.ejTreeGrid("getDataSource"));
                if (proxy._isDataManagerUpdate)
                    this._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");
                model.flatRecords = proxy._$treegridHelper.ejTreeGrid("getFlatRecords");
                model.ids = proxy._$treegridHelper.ejTreeGrid("getUpdatedIds");
                model.updatedRecords = proxy.getUpdatedRecords();               
                var parentData = args.draggedRow.parentItem;
                if (args.droppedPosition == "insertAsChild" && parentData) {
                    parentData.taskType = ej.Gantt.TaskType.FixedDuration;
                    parentData.effortDriven = "false";
                }
                if (model.predecessorMapping) {
                    //Remove predecessor information from parent of dropped record.
                    if (args.droppedPosition == "insertAsChild") {                       
                        parentData.predecessor && proxy._removePredecessor(parentData.predecessor, parentData);
                        parentData.item[model.predecessorMapping] = undefined;
                        parentData.predecessorsName = undefined;
                        parentData.predecessor = undefined;                        
                    }                    
                    proxy._isValidationEnabled = false;
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                    proxy._isValidationEnabled = true;
                }
                if (args.draggedRow.parentItem && args.draggedRow.parentItem.isAutoSchedule)
                    proxy._updateParentItem(args.draggedRow);
                else if (args.draggedRow.parentItem && !args.draggedRow.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(args.draggedRow);
                var previousParentItem = args.previousParentItem;
                if (previousParentItem && previousParentItem.isAutoSchedule)
                    proxy._updateParentItem(previousParentItem, null, true);
                else if (previousParentItem && !previousParentItem.isAutoSchedule)
                    proxy._updateManualParentItem(previousParentItem, null, true);
                if (this.isCriticalPathEnable == true) {
                    this.showCriticalPath(true, true);
                }
                if (args.draggedRow)
                    proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.getCurrentViewData(), proxy.getUpdatedRecords(), proxy._totalCollapseRecordCount);
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                }
            }
            if (args.requestType === "save") {
                if (args._cAddedRecord) {
                    //Update WBS value while adding through ADD DIALOG
                    if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                        proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args._cAddedRecord);
                    }
                    proxy._renderAddedRow(args.index, args._cAddedRecord);
                   

                    if (args._cAddedRecord.parentItem && args._cAddedRecord.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args._cAddedRecord);
                    else if (args._cAddedRecord.parentItem && !args._cAddedRecord.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(args._cAddedRecord);

                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

                    //proxy.updateAltRow(model.updatedRecords[0], 0, 0);

                    /* select newly added item */
                    proxy.selectRows(model.updatedRecords.indexOf(args._cAddedRecord));
                    addedIndex = proxy.selectedRowIndex();

                    /*trigger row events and taskbar event for new record*/
                    if (!model.enableVirtualization) {
                        var refreshArgs = {};
                        refreshArgs.index = refreshArgs.recordIndex = model.currentViewData.indexOf(args._cAddedRecord);
                        proxy.refreshRowData(refreshArgs);
                        proxy.refreshRow(refreshArgs);
                    }
                } else if (args._cModifiedData) {                    

                    if (args._cModifiedData.hasChildRecords && args._cModifiedData.isAutoSchedule) {
                        
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.manualStartDate, args._cModifiedData);                        
                        args._cModifiedData.left = args._cModifiedData._calculateManualLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateManualWidth(this);
                        args._cModifiedData.progressWidth = args._cModifiedData._getProgressWidth(args._cModifiedData.width, args._cModifiedData.status);
                        args._cModifiedData.endDate = args._cModifiedData.manualEndDate;
                        args._cModifiedData._calculateDuration(this);                                                
                    }
                    else if (args._cModifiedData.hasChildRecords && !args._cModifiedData.isAutoSchedule) {
                        args._cModifiedData.left = args._cModifiedData._calculateLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateWidth(this);
                        args._cModifiedData._calculateDuration(this);
                        args._cModifiedData.manualStartDate = args._cModifiedData.startDate;
                        args._cModifiedData.manualEndDate = args._cModifiedData.endDate;
                        proxy._updateManualParentItem(args._cModifiedData, null, true);
                    }
                    else {
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.startDate, args._cModifiedData);
                        args._cModifiedData.endDate = proxy._getEndDate(args._cModifiedData.startDate, args._cModifiedData.duration,args._cModifiedData.durationUnit, args._cModifiedData);
                        args._cModifiedData.left = args._cModifiedData._calculateLeft(this);
                        args._cModifiedData.width = args._cModifiedData._calculateWidth(this);
                        args._cModifiedData.progressWidth = args._cModifiedData._getProgressWidth(args._cModifiedData.width, args._cModifiedData.status);
                    }
                    //Update WBS value while editing through EDIT DIALOG
                    if (model.enableWBS && model.enableWBSPredecessor && model.predecessorMapping) {
                        proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args._cModifiedData);
                    }

                    proxy.refreshGanttRecord(args._cModifiedData);

                    if (args._cModifiedData.parentItem && args._cModifiedData.parentItem.isAutoSchedule)
                        proxy._updateParentItem(args._cModifiedData);
                    else if (args._cModifiedData.parentItem && !args._cModifiedData.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(args._cModifiedData);

                    if (args._cModifiedData.predecessor) {
                        if (args.previousValue) {
                            proxy._removeConnectorLine(args.previousValue, args._cModifiedData);
                        }
                    }
                }
                
                if (proxy.model.predecessorMapping) {

                    if ((args._cModifiedData && args._cModifiedData.predecessor)) {
                        proxy._isValidationEnabled = true;
                    }
                    else
                        proxy._isValidationEnabled = false;
                    if (args._cAddedRecord) {
                        if (args._cAddedRecord.predecessor) {
                            proxy._validatePredecessorDates(args._cAddedRecord);
                            proxy._addConnectorLine(args._cAddedRecord);
                        }
                        proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._createConnectorLinesCollection();
                    } else {
                        if (args._cModifiedData) {
                            if (args.previousValue) {
                                proxy._removeConnectorLine(args.previousValue, args._cModifiedData);
                            }
                            proxy._addConnectorLine(args._cModifiedData);
                            if (args._cModifiedData.predecessor) {
                                if(proxy._isUpdateOffset)
                                    proxy._editedTaskBarItem = args._cModifiedData;
                                proxy._isMileStoneEdited = args._cModifiedData.isMilestone;
                                proxy._updatedConnectorLineCollection = [];
                                proxy._connectorlineIds = [];
                                proxy._validatePredecessor(args._cModifiedData,args.previousValue);
                                if (proxy._isUpdateOffset)
                                   proxy._editedTaskBarItem = null;
                                if (proxy._updatedConnectorLineCollection.length > 0) {
                                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                                }
                            }
                            if (args._cModifiedData.parentItem && args._cModifiedData.parentItem.isAutoSchedule)
                                proxy._updateParentItem(args._cModifiedData);
                            else if(args._cModifiedData.parentItem && !args._cModifiedData.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(args._cModifiedData);
                        }
                    }
                }
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
            }

            if (args.requestType === "validatePredecessor") {
                var result = proxy._editedPredecessorValidation(args);
                args.result = result;
                return;
            }
            proxy._ganttActionCompleteTrigger(args);
            // Update the scrollbar for focus the newly added record
            if (addedIndex >= 0) {
                proxy.focusOnTask(addedIndex);
            }
        },

        /*Update the scrollbar to focus the selected task item by it's index*/
        focusOnTask: function (index) {
            var proxy = this, model = proxy.model,
                ganttbody = proxy.element.find(".e-ganttviewerbodyContianer"),
                scroller = ganttbody.ejScroller("instance"),
                taskbarLeft = model.updatedRecords[index].left,
                width = scroller.model.width,
                scrollLeft = scroller.model.scrollLeft,
                hScrollbar = scroller._hScrollbar;
            if (hScrollbar) {
                if (hScrollbar.model.maximum < scrollLeft)
                    scrollLeft = hScrollbar.model.maximum;
                if (scrollLeft > taskbarLeft || (scrollLeft + width) < taskbarLeft) {
                    var left = taskbarLeft - (width / 2);
                    left = left < 0 ? 0 : left;
                    ganttbody.ejScroller("scrollX", left, true);
                }
            }
            proxy._$ganttchartHelper.ejGanttChart("updateScrollBar");
        },
        calculateEndDate: function (args) {
            var proxy = this;
            var endDate = this._getEndDate(proxy._checkStartDate(args.startDate, args.record),
                args.duration, args.durationUnit, args.record);
            proxy._$ganttchartHelper.ejGanttChart("updateEditedRecordEndDate", proxy._checkEndDate(endDate, args.record));
        },

        calculateDuration: function (args) {
            var proxy = this;
            var duration = this._getDuration(proxy._checkStartDate(args.startDate, args.record),
                           proxy._checkEndDate(args.endDate, args.record), args.durationUnit, args.record.isAutoSchedule);
            proxy._$ganttchartHelper.ejGanttChart("updateEditedRecordDuration", duration);
        },
        expandAllCollapseAllRequest:function(args)
        {
            var proxy = this,
                $gridEle = $(proxy.element),//.closest(".e-gantt"),
                gridInstance = $gridEle.ejGantt("instance"),
                gridId = $gridEle.attr('id');
                gridInstance._toolbarOperation(gridId + "_" + args.requestType);
        },

        chartactionComplete: function (args) {
            var proxy = this, model = this.model;

            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();

            if (args.requestType === "updateConnectors") {
                if (proxy.model.predecessorMapping) {
                    var ganttRecord = args.ganttRecord;
                    proxy._isMileStoneEdited = ganttRecord.isMilestone;
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    proxy._editedTaskBarItem = ganttRecord;
                    proxy._validatePredecessor(ganttRecord);
                    if (proxy._updatedConnectorLineCollection.length > 0) {
                        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                        this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                    }
                    proxy._editedTaskBarItem = null;
                }
            }

            if (args.requestType === "rowHover") {
                proxy._$treegridHelper.ejTreeGrid('addRowHover', args.index);
            }
            
            if (args.requestType === "scroll") {

                proxy._isTreeGridRendered = false;
                proxy._isGanttChartRendered = false;
                if (args.vscrollExsist && args.delta !== undefined)
                    proxy._$treegridHelper.ejTreeGrid('onScrollHelper', args.delta);

                proxy.model.updatedRecords = proxy.getUpdatedRecords();
                proxy.model.currentViewData = proxy.getCurrentViewData();

                if (proxy.model.enableVirtualization) {

                    if (proxy.model.predecessorMapping) {

                        if (proxy._connectorLinesCollection.length > 0) {
                            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        }
                        proxy._isValidationEnabled = false;
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._createConnectorLinesCollection();
                    }
                }
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
            }
            
            if (args.requestType === "selection") {
                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
            }
            //for validate the predecessor on mouse hover and mouse up of second drag point
            if (args.requestType === "validatePredecessor") {
                var flag= proxy._editedPredecessorValidation(args);
                args.predecessorValidation = flag;
            }

            //on mouse up if validation is true then draw connector line
            if (args.requestType === "drawConnectorLine") {

                var currentPredecessor = args.toItem._calculatePredecessor(args.predecessor, this._durationUnitEditText, this.model.durationUnit, proxy);
                args.toItem.item[proxy.model.predecessorMapping] = args.predecessorString[0];
                args.toItem.predecessorsName = args.toItem.item[proxy.model.predecessorMapping];
                //Update WBS value while drawing the predecessor links
                if (model.enableWBS && model.enableWBSPredecessor) {
                    proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", args.toItem);
                }
                if (!args.fromItem.predecessor) {// for parent item
                    args.fromItem['predecessor'] = currentPredecessor;
                }
                else {
                    args.fromItem.predecessor.push(currentPredecessor[0]);
                }
                if (args.toItem.predecessor)
                {
                    args.toItem.predecessor.push(currentPredecessor[0]);
                }
                else
                {
                    args.toItem.predecessor=[];
                    args.toItem.predecessor.push(currentPredecessor[0]);
                }

                proxy._isMileStoneEdited = args.toItem.isMilestone;
                proxy._updatedConnectorLineCollection = [];
                proxy._connectorlineIds = [];
                if (proxy.model.enablePredecessorValidation && (args.toItem.isAutoSchedule || proxy.model.validateManualTasksOnLinking))
                    proxy._isValidationEnabled = true;
                else
                    proxy._isValidationEnabled = false;
                proxy._validatePredecessor(args.toItem);
                if (proxy._updatedConnectorLineCollection.length > 0) {
                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                }
                //Update predecessor cell value in treegrid while drawing a new connector line to/from manual task.
                if (!args.toItem.isAutoSchedule && !proxy.model.validateManualTasksOnLinking) {
                    var treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
                    ej.TreeGrid.refreshRow(treegridObject, proxy.model.currentViewData.indexOf(args.toItem));
                }
                /*update schedule dates on predecessor editing */
                var checkArgs = {};
                checkArgs.data = args.toItem;
                proxy._updateScheduleDatesOnEditing(checkArgs);
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
        }
            proxy._ganttActionCompleteTrigger(args);
        },

        //Public method for hidding column using header text
        // argument headerText is header text of the column

        
        hideColumn:function(headerText)
        {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("hideColumn",headerText);
        },

		//Public method for showing column using header text
        // argument headerText is header text of the column

        
        showColumn: function (headerText) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("showColumn", headerText);
        },
		 // public method for accessing tree grid clearColumnMenu method
        clearColumnMenu:function()
        {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("clearColumnMenu");
        },
        // public method for deleting row
        deleteRow: function () {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("deleteRow");
        },
        taskbarEditing: function (args) {
            
            this._trigger("taskbarEditing", args);
        },
        // public method for accessing _setInitialData Private method.
        setInitialData: function () {
            this._setInitialData();
        },

        sortColumn: function (columnName, columnSortDirection) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("sortColumn", columnName, columnSortDirection);
        },

        clearSorting: function()
        {
            var proxy = this,
                model = proxy.model;
            proxy._$treegridHelper.ejTreeGrid("clearSorting");
        },

        "export": function (action, serverEvent, multipleExport) {
            var proxy = this, model=proxy.model;
            //proxy.model.isFromGantt = proxy._isFromGantt;
            //proxy._$treegridHelper.ejTreeGrid("export", action, serverEvent, multipleExport, proxy);
            var attr = { action: action, method: 'post', "data-ajax": "false" };
            $('form#' + proxy._id + 'export').remove();
            var form = ej.buildTag('form#' + proxy._id + 'export', "", null, attr);
            var ignoreOnExport = proxy.ignoreOnExport,
                igonreLength = ignoreOnExport.length,
                modelClone;
            model.criticalTask = this.criticalPathCollection.join();
            if (!multipleExport) {
                var updatedRecords = model.updatedRecords,
                       currentViewData = model.currentViewData,
                       flatRecords = model.flatRecords,
                       parentRecords = model.parentRecords,
                       selectedItem = model.selectedItem,
                       selectedItems = model.selectedItems,
                       workUnit = model.workUnit;
                proxy._$treegridHelper.ejTreeGrid("contextMenuOperations", "Cancel");
                //proxy._contextMenuOperations("Cancel"); // Cancel the edit row or empty newly added row.
                // Delete the below internal items in model for avoid the circular reference while extend the model
                delete model.updatedRecords;
                delete model.currentViewData;
                delete model.flatRecords;
                delete model.parentRecords;
                delete model.selectedItem;
                delete model.selectedItems;
                delete model.workUnit;
                modelClone = $.extend(true, {}, model);
                model.updatedRecords = updatedRecords;
                model.currentViewData = currentViewData;
                model.flatRecords = flatRecords;
                model.parentRecords = parentRecords;
                model.selectedItem = selectedItem;
                model.selectedItems = selectedItems;
                model.workUnit = workUnit;
                var columns = modelClone.columns,
                    columnLength = columns.length;
                for (var i = 0; i < columnLength; i++) {
                    if (modelClone.columns[i].editType != undefined) {
                        switch (columns[i].editType) {
                            case "stringedit":
                                columns[i].editType = "string";
                                break;
                            case "numericedit":
                                columns[i].editType = "numeric";
                                break;
                            case "dropdownedit":
                                columns[i].editType = "dropdown";
                                break;
                            case "booleanedit":
                                columns[i].editType = "boolean";
                                break;
                            default:
                                break;
                        }
                    }
                }              
               
                if (this.ignoreOnExport) {
                    for (var i = 0; i < igonreLength; i++) {
                        delete modelClone[ignoreOnExport[i]];
                    }
                }
            }
            if (ej.raiseWebFormsServerEvents) {
               
                var locale = { "durationText": proxy._durationUnitTexts, "durationEditText": proxy._durationUnitEditText, "taskTypeTexts": proxy._taskTypeTexts, "effortDrivenTexts": proxy._effortDrivenTexts, "taskModeTexts": proxy._taskModeTexts };
                var args = { model: modelClone, originalEventType: serverEvent };
                var clientArgs = { model: JSON.stringify(modelClone), locale: JSON.stringify(locale) };
                ej.raiseWebFormsServerEvents(serverEvent, args, clientArgs);
            }
            else {
                var ganttObjectArray = {};
                if (multipleExport) {
                    $('body').find('.e-gantt').each(function (index, object) {
                        var ganttObject = $(object).data('ejGantt');
                        if (!ej.isNullOrUndefined(ganttObject)) {
                            var gridmodel = ganttObject.model;
                            updatedRecords = gridmodel.updatedRecords;
                            flatRecords = gridmodel.flatRecords;
                            currentViewData = gridmodel.currentViewData;
                            parentRecords = gridmodel.parentRecords;
                            selectedItem = gridmodel.selectedItem;
                            selectedItems = gridmodel.selectedItems;
                            workUnit = model.workUnit;
                            // Delete the below internal items in model for avoid the circular reference while extend the model
                            delete gridmodel.updatedRecords;
                            delete gridmodel.flatRecords;
                            delete gridmodel.currentViewData;
                            delete gridmodel.parentRecords;
                            delete gridmodel.selectedItem;
                            delete gridmodel.selectedItems;
                            delete gridmodel.workUnit;
                            var modelClone = JSON.parse(JSON.stringify(gridmodel));
                            gridmodel.updatedRecords = updatedRecords;
                            gridmodel.flatRecords = flatRecords;
                            gridmodel.currentViewData = currentViewData;
                            gridmodel.parentRecords = parentRecords;
                            gridmodel.selectedItem = selectedItem;
                            gridmodel.selectedItems = selectedItems;
                            gridmodel.workUnit = workUnit;
                            columns = modelClone.columns;
                            columnLength = columns.length;
                            for (var i = 0; i < columnLength; i++) {
                                if (columns[i].editType != undefined) {
                                    switch (columns[i].editType) {
                                        case "stringedit":
                                            columns[i].editType = "string";
                                            break;
                                        case "numericedit":
                                            columns[i].editType = "numeric";
                                            break;
                                        case "dropdownedit":
                                            columns[i].editType = "dropdown";
                                            break;
                                        case "booleanedit":
                                            columns[i].editType = "boolean";
                                            break;
                                        default:
                                            break;
                                    }
                                }
                            }
                            if (ignoreOnExport) {
                                for (var i = 0; i < igonreLength; i++) {
                                    delete modelClone[ignoreOnExport[i]];
                                }
                                ganttObjectArray[index] = JSON.stringify(modelClone);
                                var inputAttr = { name: 'GanttModel', type: 'hidden', value: JSON.stringify(modelClone) };
                                var input = ej.buildTag('input', "", null, inputAttr);
                                form.append(input);
                            }
                        }
                    });
                }
                else {
                    var inputAttr = { name: 'GanttModel', type: 'hidden', value: JSON.stringify(modelClone) };
                    var input = ej.buildTag('input', "", null, inputAttr);
                    form.append(input);
                    form.append(this);
                }
                var locale = { "durationText": proxy._durationUnitTexts, "durationEditText": proxy._durationUnitEditText, "taskTypeTexts": proxy._taskTypeTexts, "effortDrivenTexts": proxy._effortDrivenTexts, "taskModeTexts": proxy._taskModeTexts };
                var localeAttr = { name: 'locale', type: 'hidden', value: JSON.stringify(locale) };
                var localeInput = ej.buildTag('input', "", null, localeAttr);
                form.append(localeInput);
                $('body').append(form);
                form.submit();
            }
            return true;
        },


        _refreshParent: function (item) {
            this.refreshGanttRecord(item);
            if (item.parentItem) {
                this._refreshParent(item.parentItem);
            }
        },

        // predecessor link validation dialog
        _validationDialogTemplate: function () {
            var proxy = this, model = proxy.model,
                $tbody = ej.buildTag('div', "", {}, { 'data-unselectable': 'on' }),
                $form = ej.buildTag('form', "", { 'height': '100%', 'width': '100%', 'font-size': '14px' }, { id: proxy._id + "ValidationRuleForm" }),
                $headerdiv = ej.buildTag('div.e-validationHeader', "", { 'padding': "10px" }, { id: proxy._id + "_ValidationText" }),
                $contentdiv = ej.buildTag('div.e-ValidationContent', "", {}, {}),

                $innerTable = "<table style='outline:none;border-spacing:2px;border-collapse:separate;padding:10px'>" +
               "<tr style='line-height:1.4'><td class='e-editLabel'><input type='radio' id='" + proxy._id + "_ValidationCancel' name='ValidationRule' checked='checked'/><label for='" + proxy._id + "_ValidationCancel' style='padding-left:10px;font-weight:normal;' id= '" + proxy._id + "_cancelLink'>" + proxy._validationRuleOptions["cancel"] + "</label></td></tr>" +
               "<tr style='line-height:1.4'><td class='e-editLabel'><input type='radio' id='" + proxy._id + "_ValidationRemoveline' name='ValidationRule'/><label for='" + proxy._id + "_ValidationRemoveline' style='padding-left:10px;font-weight:normal;' id='" + proxy._id + "_removeLink'>" + proxy._validationRuleOptions["removeLink"] + "</label></td></tr>" +
               "<tr style='line-height:1.4'><td class='e-editLabel'>{{if additionalButton}}<input type='radio' id='" + proxy._id + "_ValidationAddlineOffset' name='ValidationRule'/><label for='" + proxy._id + "_ValidationAddlineOffset' style='padding-left:10px;font-weight:normal;' id='" + proxy._id + "_preserveLink'>" + proxy._validationRuleOptions["preserveLink"] + "</label>{{/if}}</td></tr>  </table>";

            $contentdiv.append($($innerTable));
            $form.append($headerdiv).append($contentdiv);
            $tbody = proxy._renderValidationDialogButton($form, $tbody);           
            $.templates(proxy._id + "_ValidationRuleTemplate", $tbody.html());
        },

        _renderValidationDialogButton: function (form, tbody) {

            var btnId = "ValidationRuleDialog_",
                proxy = this,
                model = proxy.model,
                okbtn = ej.buildTag('input', "",
                 {
                     'border-radius': '3px',
                     'min-width': '100px',
                     'max-width': '300px',
                     'float': 'right',                     
                 },
                 { type: "button", id: btnId + proxy._id + "_validationOk" }),
                 okText = proxy._okButtonText,
                 cancelText = proxy._cancelButtonText,
                 cancelbtn = ej.buildTag('input', "",
                {
                    'border-radius': '3px',
                    'min-width': '100px',
                    'max-width': '300px',
                    'float': 'right',
                    'margin-left': '10px'
                },
                {
                    type: "button",
                    id: btnId + proxy._id + "_validationCancel"
                }),
                btnDiv = ej.buildTag('div', "", {}, { 'class': "e-gantt-validation-btn" });

            okbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: okText,
                    minwidth: "auto"
                });
            cancelbtn.ejButton(
                {
                    cssClass: model.cssClass,
                    text: cancelText,
                    width: "auto"
                });
            btnDiv.append(cancelbtn).append(okbtn);
            form.appendTo(tbody)
            btnDiv.appendTo(tbody);
            return tbody;
        },

        // To validate the types while editing the taskbar 
        _validateTypes: function (args) {
             var proxy = this,
                model = proxy.model,
                flatRecords = model.flatRecords,
                ganttRecord = args.data,
                j = 0,
                parentGanttRecord = [],
                record = [],
                templateArgs = {},
                predecessorArray = [],
                predecessor = ganttRecord.predecessor,
                ids = model.ids,
                preLength = predecessor && predecessor.length,
                previousArgs = proxy._$ganttchartHelper.ejGanttChart("taskbarEditedArguments");
            proxy._editMode = args.editMode;
            if (!args.cancel && !ej.isNullOrUndefined(predecessor)) {
                for (var i = 0; i < preLength; i++) {
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor[i].from)],
                    record = flatRecords[ids.indexOf(predecessor[i].to)];
                    var startdate = proxy._getPredecessorDate(ganttRecord, predecessor);
                    if (predecessor[i].predecessorsType == "FS") {
                        //To check whether user dragged the task that is below to predecessor end date
                        if (predecessor[i].to == ganttRecord.taskId.toString() && ganttRecord.startDate < startdate && ganttRecord.startDate < parentGanttRecord.endDate) {
                            predecessorArray[j] = predecessor[i];
                            j++;
                            proxy._validationType = predecessor[i].predecessorsType
                            templateArgs = {
                                parentTask: parentGanttRecord,
                                task: ganttRecord,
                                previousData: previousArgs.previousData,
                                violationType: "taskBeforePredecessor",
                                additionalButton: false
                            }
                        }
                            //To check whether user dragged the task that exceeds the predecessor end date
                        else if (predecessor[i].to == ganttRecord.taskId.toString() && ganttRecord.startDate > startdate) {
                            predecessorArray[j] = predecessor[i];
                            j++;
                            proxy._validationType = predecessor[i].predecessorsType
                            templateArgs = {
                                parentTask: parentGanttRecord,
                                task: ganttRecord,
                                previousData: previousArgs.previousData,
                                violationType: "taskAfterPredecessor",
                                additionalButton: true
                            }
                        }
                    }
                }
                // to open and bind event to dialog button if any link violation occurs.
                if (!ej.isNullOrUndefined(templateArgs.violationType) && (!args.validateMode.removeLink || !args.validateMode.respectLink || !args.validateMode.preserveLinkWithEditing)) {
                   proxy._validationPredecessor = predecessorArray;
                    if ($("#" + proxy._id + "_dialogValidationRule").length === 0) {
                        var $dialogCol = ej.buildTag("div.e-dialog e-dialog-content e-shadow e-widget-content", "", { display: "none" }, { id: proxy._id + "_dialogValidationRule" });
                        proxy.element.append($dialogCol);
                        proxy._on($("#" + proxy._id + "_dialogValidationRule"),
                       "click keypress", "#ValidationRuleDialog_" + proxy._id + "_validationOk ,#ValidationRuleDialog_" + proxy._id + "_validationCancel", { args: args }, proxy._validationDialogButtonClick);
                    }

                    if (args.editMode == "dialogEdit" || args.editMode == "cellEdit") {
                        if (!args.validateMode.removeLink && !args.validateMode.respectLink && !args.validateMode.preserveLinkWithEditing)
                            proxy._renderValidationDialog(templateArgs);
                        else if (args.validateMode.removeLink || args.validateMode.respectLink || args.validateMode.preserveLinkWithEditing) {
                            proxy._validationDialogButtonClick(args);
                        }
                    }
                    else if (args.editMode == "dragging" && !proxy.taskbarEdited(previousArgs)) {
                        if (!args.validateMode.removeLink && !args.validateMode.respectLink && !args.validateMode.preserveLinkWithEditing)
                            proxy._renderValidationDialog(templateArgs);
                        else if (args.validateMode.removeLink || args.validateMode.respectLink || args.validateMode.preserveLinkWithEditing) {
                            proxy._validationDialogButtonClick(args);
                        }
                    }
                    else
                        proxy._$ganttchartHelper.ejGanttChart("taskbarEditedCancel", previousArgs);
                                        
                    return false;
                }
                else
                    return true;
            }
            else
                return true;
        },

        //To execute the action choosen by the user in validation dialog
        _validationDialogButtonClick: function (e) {
            var proxy = this, model = proxy.model,
                type = null,
                args,
                previousArgs = proxy._$ganttchartHelper.ejGanttChart("taskbarEditedArguments");
           
            if (e.target.id == "ValidationRuleDialog_" + proxy._id + "_validationOk" || e.target.id == "ValidationRuleDialog_" + proxy._id + "_validationCancel") {
                args = e.data.args;
                type = "dialog";
                if (e.keyCode != 0 && e.keyCode !== undefined && e.keyCode != 13)
                    return true;
            }
            else if (e.target.id == proxy._id + "_dialogValidationRule_closebutton") {
                type = "dialog";
            }
            else {
                args = e;
                type = "argument";
            }
        
            var ganttRecord = !(ej.isNullOrUndefined(previousArgs.data)) ? previousArgs.data : model.selectedItem,
                 arg = {},
                 predecessor = ganttRecord.predecessor,
                 treegridObject = proxy._$treegridHelper.ejTreeGrid("instance"),
                 previousData = previousArgs.previousData,
                 endEditArguments = proxy._endEditArgs;
            if (type == "dialog" || (args.validateMode && (args.validateMode.removeLink || args.validateMode.respectLink || args.validateMode.preserveLinkWithEditing))) {
                //if the user choosen the cancel option in the dialog or if the dialog closed from close button or choosen to cancel button.
                if ((type == "dialog" && e.target.id == "ValidationRuleDialog_" + proxy._id + "_validationOk" && document.getElementById(proxy._id + "_ValidationCancel").checked)
                    || (type == "dialog" && (e.target.id == "ValidationRuleDialog_" + proxy._id + "_validationCancel" || e.target.id == proxy._id + "_dialogValidationRule_closebutton"))
                    || (args.validateMode && (args.validateMode.respectLink))) {
                    if (proxy._editMode == "dragging") {
                        ganttRecord.startDate = previousData.startDate;
                        ganttRecord.endDate = previousData.endDate;
                        ganttRecord.left = ganttRecord._calculateLeft(this);
                        ganttRecord.width = previousData.width;
                        ganttRecord.status = previousData.status;
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                        //Update parentitem
                        if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule) {
                            proxy._updateParentItem(ganttRecord);
                        }
                        else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                            proxy._updateManualParentItem(ganttRecord);
                        proxy._isLastRefresh = true;
                        proxy.refreshGanttRecord(ganttRecord);
                        proxy._connectorlineIds = [];
                        proxy._updatedConnectorLineCollection = [];
                        proxy._validatePredecessor(ganttRecord);
                        if (proxy._updatedConnectorLineCollection.length > 0) {
                            proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                            this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                        }
                    }
                    else if (proxy._editMode == "dialogEdit") {
                        this._editedDialogRecord = ganttRecord;
                        if (!proxy._sendSaveRequest("Edit")) {
                            proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                        }
                    }
                    else if (proxy._editMode == "cellEdit") {
                        endEditArguments.data[endEditArguments.columnName] = endEditArguments.previousValue;
                        proxy._triggerEndEdit(endEditArguments);
                    }
                    type == "dialog" && $("#" + proxy._id + "_dialogValidationRule").ejDialog("close");
                }
                    //if the user choosen to remove link and keep the editing 
                else if ((type == "dialog" && document.getElementById(proxy._id + "_ValidationRemoveline").checked) || (args.validateMode && (args.validateMode.removeLink))) {
                    var eventArgs = {};
                    if (proxy._editMode == "dragging") {
                        eventArgs.ganttRecord = ganttRecord;
                        proxy._updatePredecessorValues(eventArgs);
                        ej.TreeGrid.refreshRow(treegridObject, model.updatedRecords.indexOf(ganttRecord));
                        proxy._isLastRefresh = true;
                        proxy.refreshGanttRecord(ganttRecord);
                    }
                    else if (proxy._editMode == "dialogEdit") {
                        var treeGridId = "#treegrid" + proxy._id + "predecessorEdit",
                            pre = $(treeGridId).ejTreeGrid("option", "dataSource"),
                            j = 0, index;
                        for (var i = 0; i < proxy._validationPredecessor.length; i++) {
                            if (proxy._validationPredecessor[i].predecessorsType == proxy._validationType)
                            {
                                if (proxy._validationPredecessor[i].from == predecessorTable[j].id) {
                                    index = predecessorTable.indexOf(predecessorTable[j]);
                                    predecessorTable.splice(index, 1);
                                }
                                else {
                                    i--;
                                    j++;
                                }
                            }
                        }
                        eventArgs.ganttRecord = this._editedDialogRecord;
                        proxy._updatePredecessorValues(eventArgs);                        
                        this._editedDialogRecord = eventArgs.ganttRecord;
                        if (!proxy._sendSaveRequest("Edit")) {
                            proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                        }
                    }
                    else if (proxy._editMode == "cellEdit") {
                        eventArgs.ganttRecord = ganttRecord;
                        proxy._updatePredecessorValues(eventArgs);                        
                        endEditArguments.data = eventArgs.ganttRecord;
                        proxy._triggerEndEdit(endEditArguments);
                    }
                    type == "dialog" && $("#" + proxy._id + "_dialogValidationRule").ejDialog("close");
                }
                   // if the user choosen to keep the both link and editing.
                else if ((type == "dialog" && document.getElementById(proxy._id + "_ValidationAddlineOffset").checked) || (args.validateMode && (args.validateMode.preserveLinkWithEditing))) {                    
                    if (proxy._editMode == "dialogEdit") {
                        if (!proxy._sendSaveRequest("Edit")) {
                            proxy._isAddEditDialogSave = true; // used for skip the actionBegin client side event while closing the dialog box
                        }
                    }
                    else if (proxy._editMode == "cellEdit") 
                        proxy._triggerEndEdit(endEditArguments);
                    type == "dialog" && $("#" + proxy._id + "_dialogValidationRule").ejDialog("close");
                }
                else
                    type == "dialog" && $("#" + proxy._id + "_dialogValidationRule").ejDialog("close");
            }
            else
                type == "dialog" && $("#" + proxy._id + "_dialogValidationRule").ejDialog("close");
        },

        _updatePredecessorValues: function (args) {            
            var proxy = this,
                model=proxy.model,
                predecessor = proxy._validationPredecessor,
                ganttRecord = args.ganttRecord,
                 ids = model.ids,
                 arg = {}, i,
                 preLength= predecessor.length,
                flatRecords = model.flatRecords;
            for (i = 0; i < preLength; i++) {
                if (predecessor[i].predecessorsType == proxy._validationType) {
                    var parentGanttRecord = flatRecords[ids.indexOf(predecessor[i].from)],
                        record = flatRecords[ids.indexOf(predecessor[i].to)],
                        id = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", id);
                    var index = proxy._predecessorsCollection.indexOf(ganttRecord);
                    if (index != 0)
                        proxy._predecessorsCollection.splice(index, 1);
                    arg.parentGanttRecord = parentGanttRecord;
                    arg.predecessor = predecessor[i];
                    arg.data = ganttRecord;
                    arg.validationType = proxy._validationType;
                    proxy._updateRecordCollection(arg);
                }
            }
        },
        _updateRecordCollection: function (args) {
            var ganttRecord = args.data,
                proxy = this,
                parentGanttRecord = args.parentGanttRecord,
                predecessorArray = ganttRecord.item[proxy.model.predecessorMapping].split(","),

                index = ganttRecord.predecessor.indexOf(args.predecessor);
            ganttRecord.predecessor.splice(index, 1);
            var predecessorIndex = predecessorArray.indexOf(args.predecessor.from + "FS");
           
            if (predecessorIndex != -1) {
                predecessorArray.splice(predecessorIndex, 1);
                ganttRecord.item[proxy.model.predecessorMapping] = predecessorArray.join(',');
                ganttRecord.predecessorsName = predecessorArray.join(',');
                var parentIndex = parentGanttRecord.predecessor.indexOf(args.predecessor);
                parentGanttRecord.predecessor.splice(parentIndex, 1);
            }
        },

        _renderValidationDialog: function (args) {
            var proxy = this,
                model = proxy.model,
                temp = document.createElement('div'), title, name, pName;
            $(temp).addClass("e-ValidationRules");
            temp.innerHTML = $.render[proxy._id + "_ValidationRuleTemplate"](args);
            $("#" + proxy._id + "_dialogValidationRule").html($(temp));
            var evntArgs = {};
            evntArgs.cssClass = model.cssClass,
            evntArgs.enableResize = false,
            evntArgs.width = "auto",
            evntArgs.height = "auto",
            evntArgs.contentSelector = "#" + proxy._id,
            evntArgs.allowKeyboardNavigation = false,
            title = proxy._validationDialogTitle;
            evntArgs.title = title;
            evntArgs.enableModal = true,
            evntArgs.allowDraggable = true,
            evntArgs.isResponsive = true,
            evntArgs.close = function () {
                $("#" + proxy._id + "EditAreaNotes").data("ejRTE") && $("#" + proxy._id + "EditAreaNotes").ejRTE("destroy");
            };
            name = !ej.isNullOrUndefined(args.task.taskName) ? args.task.taskName : "ID " + args.task.taskId,
            pName = !ej.isNullOrUndefined(args.parentTask.taskName) ? args.parentTask.taskName : "ID " + args.parentTask.taskId;
            document.getElementById(proxy._id+"_removeLink").innerHTML = String.format(proxy._validationRuleOptions["removeLink"], name, ej.format(args.task.startDate, model.dateFormat, model.locale));
            if (document.getElementById(proxy._id + "_preserveLink")) document.getElementById(proxy._id + "_preserveLink").innerHTML = String.format(proxy._validationRuleOptions["preserveLink"], name, ej.format(args.task.startDate, model.dateFormat, model.locale));

            document.getElementById(proxy._id + "_ValidationText").innerHTML = String.format(proxy._validationRuleText[args.violationType], name, pName);
            $("#" + proxy._id + "_dialogValidationRule").ejDialog(evntArgs);
            $("#" + proxy._id + "_dialogValidationRule_wrapper").addClass("e-gantt-dialog");
            $("#" + proxy._id + "_dialogValidationRule").ejDialog("open");
            $("#" + proxy._id + "_dialogValidationRule_closebutton").click(function (args) { proxy._validationDialogButtonClick(args); })
        },

        taskbarEdited: function (args) {
            var proxy = this,
                ganttRecord = args.data, model = proxy.model,
                projectStartDate = new Date(proxy._projectStartDate),
                remainDays, remainDaysInDecimal, 
                day, perDayHourUnit,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                durationUnitValue = ej.Gantt.DurationUnit,
                offset = 0;
            
            proxy._isValidationEnabled = false;
            
            if (args.dragging) {
                var editMode = "dragging";
                if (args.previousData.left !== ganttRecord.left) {
                    remainDays = ganttRecord.left % proxy._perDayWidth;
                    day = (ganttRecord.left - remainDays) / proxy._perDayWidth;
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.left = ganttRecord.left - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays + proxy._perDayWidth;
                        }
                    }
                    if (headerType == headerValue.Day || headerType == headerValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.startDate = proxy._checkStartDate(projectStartDate, ganttRecord);
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    ganttRecord._calculateEndDate(this);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                    proxy._isValidationEnabled = true;
                }

            } else if (args.rightResizing) {
                var editMode = "Resizing";
                if (args.previousData.width !== ganttRecord.width) {

                    if (headerType == headerValue.Day || headerType == headerValue.Hour) {
                        var tempStartDate = new Date(ganttRecord.startDate),
                                                         tempNewStartDate = new Date(ganttRecord.startDate), timeDiff, taskTempWidth;
                        tempNewStartDate.setHours(0, 0, 0, 0);
                        timeDiff = tempStartDate.getTime() - tempNewStartDate.getTime();
                        if (timeDiff > 0)
                            taskTempWidth = ganttRecord.width + ((timeDiff / (1000 * 60 * 60 * 24)) * proxy._perDayWidth);
                        else
                            taskTempWidth = ganttRecord.width;
                        remainDays = taskTempWidth % proxy._perDayWidth;
                        day = (taskTempWidth - remainDays) / proxy._perDayWidth;
                        perDayHourUnit = 24;
                    }
                    else {
                        remainDays = ganttRecord.width % proxy._perDayWidth,
                        day = (ganttRecord.width - remainDays) / proxy._perDayWidth;
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    }
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    var startDate = proxy._getDateFromFormat(ganttRecord.startDate);
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.width = ganttRecord.width - remainDays;
                        }
                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.width = ganttRecord.width - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.width = ganttRecord.width - remainDays + proxy._perDayWidth;
                        }
                    }
                    /*Calculating the remaining day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    var endDate = ganttRecord._endDateUpdate(startDate, day - 1, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.endDate = proxy._checkEndDate(endDate, ganttRecord);
                    
                    if (model.endDateMapping)
                        ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                    ganttRecord._calculateDuration(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);

                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                    proxy._updatedColumn = "duration";
                    proxy._updateResourceRelatedFields(ganttRecord);                    
                }

            } else if (args.leftResizing) {
                var editMode = "Resizing";
                if (args.previousData.left !== ganttRecord.left) {                    
                    remainDays = ganttRecord.left % proxy._perDayWidth;
                    day = (ganttRecord.left - remainDays) / proxy._perDayWidth;
                    remainDaysInDecimal = remainDays / proxy._perDayWidth;
                    /*Rounding the decimal value for week-month-year schedule mode*/
                    if (headerType == headerValue.Week || headerType == headerValue.Month || headerType == headerValue.Year) {
                        if (remainDaysInDecimal <= 0.25) {
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays;
                        }

                        else if (remainDaysInDecimal > 0.25 && remainDaysInDecimal <= 0.75) {
                            remainDaysInDecimal = 0.5;
                            var newRemainDays = remainDaysInDecimal * proxy._perDayWidth;
                            ganttRecord.left = ganttRecord.left - remainDays + newRemainDays;
                        }
                        else if (remainDaysInDecimal > 0.75) {
                            day += 1;
                            remainDaysInDecimal = 0;
                            ganttRecord.left = ganttRecord.left - remainDays + proxy._perDayWidth;
                        }
                    }
                    if (headerType == headerValue.Day || headerType == headerValue.Hour)
                        perDayHourUnit = 24;
                    else
                        perDayHourUnit = proxy._secondsPerDay / 3600;
                    /*Calculating the day decimal values in to hours and then minutes*/
                    if (perDayHourUnit && remainDaysInDecimal > 0) {
                        var perHourDecimalWidth = 1 / perDayHourUnit,
                            decimalWidthInHours = remainDaysInDecimal / perHourDecimalWidth,
                            inMinutes = Math.round(decimalWidthInHours * 60);
                    }
                    projectStartDate = ganttRecord._startDateUpdate(projectStartDate, day, inMinutes, proxy._workingTimeRanges, headerType);
                    ganttRecord.startDate = proxy._checkStartDate(projectStartDate, ganttRecord);
                    if (model.startDateMapping)
                        ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                    ganttRecord.endDate = proxy._checkEndDate(ganttRecord.endDate, ganttRecord);
                    if (ganttRecord.isAutoSchedule && model.includeWeekend == false && (headerType == headerValue.Hour || headerType == headerValue.Day))
                        ganttRecord._calculateEndDate(this);
                    ganttRecord._calculateDuration(this);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);                    
                    proxy._updatedColumn = "duration";
                    proxy._updateResourceRelatedFields(ganttRecord);
                }
            } 
            if (args.progressResizing) {
                if (args.previousData.status != args.data.status) {
                    ganttRecord.status = ganttRecord._getProgressPercent(ganttRecord.width, ganttRecord.progressWidth);
                    if (ganttRecord.parentItem) {
                        ganttRecord._updateParentProgress(ganttRecord.parentItem, model.progressMapping);
                    }
                    proxy._refreshParent(ganttRecord);
                }                
            }
            else {
                proxy._isValidationEnabled = true;
                proxy._updateEditedGanttRecord(ganttRecord);
                if (ganttRecord.predecessor) {
                    proxy._isMileStoneEdited = ganttRecord.isMilestone;
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    proxy._editedTaskBarItem = ganttRecord;
                    if (model.enablePredecessorValidation)
                        proxy._validatePredecessor(ganttRecord);
                    else
                        proxy._validatePredecessorOnEditing(ganttRecord);

                    if (proxy._updatedConnectorLineCollection.length > 0) {
                        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                        this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                    }
                }
                proxy._editedTaskBarItem = null;

                if (!ganttRecord.isAutoSchedule) {
                    if (ganttRecord.hasChildRecords && !args.isChildren && !args.rightResizing) {
                        proxy._validateAutoChildRecords(args);
                    }
                }
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord, editMode);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord, editMode);                
            }
            proxy._isLastRefresh = true;
            proxy.refreshGanttRecord(ganttRecord);
            proxy._trigger("taskbarEdited", args);
            if (!args.cancel && (args.leftResizing || args.rightResizing || args.dragging) && proxy._isValidationEnabled) {
                proxy._updateScheduleDatesOnEditing(args);
            }
            if (this.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                this.showCriticalPath(true);
            }
            return args.cancel;
        },

        _validatePredecessorOnEditing: function (ganttRecord, manualOffsetEditing) {
            var proxy = this,
                model = proxy.model,
                currentTaskId = ganttRecord['taskId'].toString(),
                model = this.model,
                predecessorsCollection = ganttRecord['predecessor'],
                flatRecords = model.flatRecords,
                ids = model.ids,
                predecessor, isOffsetChanged, parentGanttRecord, record, connectorLineObject, connectorLineId,
                previousValue = null,
                predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId; }),
                successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId; }),
                predecessorLength = predecessors.length;

            for (var count = 0; count < predecessorLength; count++) {
                predecessor = predecessors[count];
                isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                record = flatRecords[ids.indexOf(predecessor.to)];
                if (manualOffsetEditing) {
                    proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    manualOffsetEditing = false;
                }
                connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                if (proxy._$ganttchartHelper) {
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
            }
            for (var count = 0; count < predecessorLength; count++) {
                predecessor = predecessors[count];
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                record = flatRecords[ids.indexOf(predecessor.to)];

                if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))//(model.enableVirtualization === false && !parentGanttRecord.isExpanded && record.isExpanded === false)
                    continue;
                connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                if (connectorLineObject) {
                    if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.length == 0) {
                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                        var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                        proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                    }
                }

            }

            var length = successors.length;

            for (count = 0; count < length; count++) {

                predecessor = successors[count];
                parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                record = flatRecords[ids.indexOf(predecessor.to)];
                connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                if (proxy._$ganttchartHelper) {
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
                if (manualOffsetEditing) {
                    proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    manualOffsetEditing = false;
                }
                if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))
                    continue;
                connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                if (connectorLineObject) {
                    if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.length == 0) {
                        proxy._updatedConnectorLineCollection.push(connectorLineObject);
                        proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                    }
                    else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                        var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                        proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                    }
                }

            }
        },

        _validateAutoChildRecords: function (args) {
            var proxy = this,
                item = args.data,
                prevItem = args.previousData,
                childItem = item.childRecords,
                arg = {},
                diffLeft = item.left - prevItem.left;
            for (var i = 0; i < childItem.length; i++) {

                if (childItem[i].isAutoSchedule && !childItem[i].hasChildRecords) {
                    arg.previousData = $.extend({}, childItem[i]);
                    childItem[i].left += diffLeft;
                    arg.data = childItem[i];
                    arg.dragging = true;
                    args.isChildren = true;
                    proxy.taskbarEdited(arg);
                }
            }
        },

        actionBegin: function (args) {

            var proxy = this;

            if (!proxy._trigger("actionBegin", args)) {

                if (args.requestType === "beginedit") {
                    proxy._sendEditRequest();
                }   
                if (args.requestType == "validateLinkedTask") {
                    if (proxy.model.enablePredecessorValidation && (args.data.isAutoSchedule || proxy.model.validateManualTasksOnLinking) && proxy.model.predecessorMapping)
                        return args.cancel = proxy._validateTypes(args);
                    else
                        return args.cancel=true;
                }
            }

        },

        _ganttActionCompleteTrigger: function (args) {
            var proxy = this,
                model = proxy.model;
            if (args.requestType === "save" || args.requestType === "drawConnectorLine" || args.requestType === "delete" || args.requestType === "dragAndDrop")
            {
                if (args.requestType === "dragAndDrop") {
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.draggedRow["taskId"]) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                    index = null;
                    index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.targetRow["taskId"]) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                }
                else if (args.requestType == "save") {
                    var saveRecord;
                    if (args.addedRecord)
                        saveRecord = args.addedRecord;
                    else
                        saveRecord = args.modifiedRecord;
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == saveRecord.item[model.taskIdMapping]) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                }
                else if (!args.requestType === "drawConnectorLine") {
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.data[model.taskIdMapping]) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                }
                else if (args.requestType === "drawConnectorLine") {
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.fromItem.taskId) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                    index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.toItem.taskId) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                }
                if(proxy._actionCompleteData.length){
                    args.updatedRecords = proxy._actionCompleteData;
                    proxy._actionCompleteData = [];
                }
            }            
            proxy._trigger("actionComplete", args);
            if (!args.cancel && args.requestType === 'save') {
                if (args._cModifiedData) {
                    args.data = args._cModifiedData;
                    proxy._updateLastInsertedId(args.data.taskId);
                }
                if (args._cAddedRecord) {
                    args.data = args._cAddedRecord;
                    proxy._updateLastInsertedId(args.data.taskId, true);
                }                
                proxy._updateScheduleDatesOnEditing(args);
            }
        },

        _queryCellInfo: function (args) {
            this._trigger("queryCellInfo", args);
        },

        _beginEdit: function (args) {
            var proxy = this,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            if (!proxy._trigger("beginEdit", args)) {
                proxy._isinBeginEdit = true;
                if (proxy.model.toolbarSettings.showToolbar) {

                    var toolBarEnabledItems = [];

                    var cancelElement = $(toolbar).find(".e-cancel").parent()[0];
                    var saeveElement = $(toolbar).find(".e-saveitem").parent()[0];

                    if (cancelElement) {
                        toolBarEnabledItems.push(cancelElement);
                    }

                    if (saeveElement) {
                        toolBarEnabledItems.push(saeveElement);
                    }

                    $(toolbar).ejToolbar('enableItem', toolBarEnabledItems);
                    var disableToolItems = [];
                    if (proxy.model.editSettings.allowAdding && proxy.model.toolbarSettings.toolbarItems.indexOf("add") !== -1)
                        disableToolItems.push($(toolbar).find(".e-addnewitem").parent()[0]);
                    if (proxy.model.editSettings.allowEditing && proxy.model.toolbarSettings.toolbarItems.indexOf("edit") !== -1)
                        disableToolItems.push($(toolbar).find(".e-edititem").parent()[0]);
                    if (proxy.model.editSettings.allowDeleting && proxy.model.toolbarSettings.toolbarItems.indexOf("delete") !== -1)
                        disableToolItems.push($(toolbar).find(".e-deleteitem").parent()[0]);
                    $(toolbar).ejToolbar('disableItem', disableToolItems);
                }
            }
        },
        _triggerEndEdit: function (args) {
            var proxy = this, model = this.model;
            var toolbar = $("#" + proxy._id + "_toolbarItems");

            if (proxy._trigger("endEdit", args)) {
                var predecessorString = "";
                args.data[args.columnName] = args.previousValue;
                if (args.columnName === "predecessor") {
                    predecessorString = proxy._predecessorToString(args.data.predecessor, args.data);
                    args.data.item[args.columnObject.mappingName] = predecessorString;
                    args.data.predecessorsName = predecessorString;
                } else {
                    args.data.item[args.columnObject.mappingName] = args.previousValue;
                    if (args.columnName === "resourceInfo") {
                        proxy._updateResourceName(args.data);
                        proxy._updateResourceRelatedFields(args.data);
                    }
                }
            }
            else {
                proxy._updatedColumn = args.columnName;
                //Effort driven is always true for fixedWork type of calculation.
                if (args.columnName == "taskType" && args.value == "fixedWork")
                    args.data.effortDriven = "true";
                if (args.columnName === "duration" || args.columnName == "work")
                    proxy._updateResourceRelatedFields(args.data);

                if (args.columnName === "resourceInfo") {
                    proxy._updateResourceName(args.data);
                    proxy._updateResourceRelatedFields(args.data);
                    //update parent item while child works got updated, if duration is updated the
                    //corresponding parent will update automatically.
                    if (proxy._isDurationUpdated == false) {
                        var data = args.data,
                            isParent = args.data.hasChildRecords ? true : false;
                        if (isParent && data.isAutoSchedule)
                            proxy._updateParentItem(data, null, true);
                        else if (isParent && !data.isAutoSchedule)
                            proxy._updateManualParentItem(data, null, true);

                        if (data.parentItem && data.parentItem.isAutoSchedule)
                            proxy._updateParentItem(data, null, false);
                        else if(data.parentItem && !data.parentItem.isAutoSchedule)
                            proxy._updateManualParentItem(data, null, false);
                    }
                }
                // Remove predecessor from treegrid part and skip the rendering if it connects to parent item
                if (args.columnName == "predecessor" && model.predecessorMapping) {
                    var val = args.value.split(',');
                    for (var i = 0; i < val.length; i++) {
                        var record = model.flatRecords.filter(function (item) {
                            return item && item.taskId == val[i];
                        });
                        if (record[0] && record[0].hasChildRecords) {
                            var predecessorCollection = args.data.predecessor.filter(function (item) {
                                if (item && (item.from == val[i] || item.to == val[i]))
                                    return item;
                            });
                            var predecessorIndex = args.data.predecessor.indexOf(predecessorCollection[0]);
                            args.data.predecessor.splice(predecessorIndex, 1);
                            var treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
                            ej.TreeGrid.refreshRow(treegridObject, model.flatRecords.indexOf(args.data));
                        }
                    }
                }
                if (args.isModified || proxy._isDurationUpdated) {
                    proxy.model.currentViewData = proxy._$treegridHelper.ejTreeGrid("getCurrentViewData");
                    if (args.data.isAutoSchedule || model.validateManualTasksOnLinking)
                        proxy._isValidationEnabled = true;
                    else
                        proxy._isValidationEnabled = false;
                    proxy._updateEditedGanttRecords(args,false);
                }
            }

            proxy._isDurationUpdated = false;
            proxy._isinBeginEdit = false;
            proxy._isLastRefresh = true;
            proxy.refreshGanttRecord(args.data);
            
            delete args.isModified;
            if (proxy.model.toolbarSettings.showToolbar) {
                var toolBarDisableItems = [];

                if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                    toolBarDisableItems.push($(toolbar).find(".e-cancel").parent()[0]);
                }

                if (proxy.model.toolbarSettings.toolbarItems.indexOf("update") !== -1) {
                    toolBarDisableItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                }
                
                $(toolbar).ejToolbar('disableItem', toolBarDisableItems);
            }

            if (!args.cancel && (args.columnName === "startDate" || args.columnName === "endDate" || args.columnName === "duration" || args.columnName === "baselineStartDate" || args.columnName === "baselineEndDate")) {
                proxy._updateScheduleDatesOnEditing(args);
            }
            if (!args.cancel && (args.columnName === "taskMode" || args.columnName === "startDate" || args.columnName === "endDate" || args.columnName === "duration" || args.columnName === "status" || args.columnName === "predecessor")) {
                if (this.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                    this.showCriticalPath(true);
                }
            }
            // proxy._trigger("endEdit", args);
        },
        _endEdit: function (args) {
            var proxy = this,
                model = this.model,
                newArgs = {},
                       validateMode = {
                           respectLink: false,
                           removeLink: false,
                           preserveLinkWithEditing: true,
                       };
            newArgs.editMode = "cellEdit";
            newArgs.data = args.data;
            newArgs.requestType = "validateLinkedTask";
            newArgs.validateMode = validateMode;
            proxy._endEditArgs = args;
            if (!proxy._trigger("actionBegin", newArgs)) {
                if (model.enablePredecessorValidation && (args.columnName == "startDate" || args.columnName == "endDate") && proxy.getFormatedDate(args.value) != proxy.getFormatedDate(args.previousValue)
                    && proxy.model.predecessorMapping && (args.data.isAutoSchedule || model.validateManualTasksOnLinking) && !proxy._validateTypes(newArgs)) {
                    return;
                }
                else
                    proxy._triggerEndEdit(args);
            }
        },

        //updated the schedule dates while cellediting ,taskBarediting and dialogEditing and dialogAdding
        _updateScheduleDatesOnEditing:function(args)
        {
            var proxy = this,
                model = this.model,
                startDate = proxy._getDateFromFormat(args.data.startDate),
                endDate = proxy._getDateFromFormat(args.data.endDate),
                scheduleStartDate = proxy._projectStartDate,    //_getDateFromFormat(model.scheduleStartDate),
                scheduleEndDate = proxy._getDateFromFormat(model.scheduleEndDate),
                minStartDate, maxEndDate, minBaselineStartDate, maxBaseLineEndDate,
                isDateChanged = false,
                tempStartDate = model.scheduleStartDate,
                updatedDates,
                tempEndDate = model.scheduleEndDate;
            if(args.data.hasChildRecords && !args.data.isAutoSchedule){
                startDate = proxy._getDateFromFormat(args.data.manualStartDate),
                endDate = proxy._getDateFromFormat(args.data.manualEndDate)
            }            
                proxy._calculateDatesForScheduleCheck(startDate);
            if (!model.predecessorMapping) {
                if (!(startDate.getTime() >= scheduleStartDate.getTime()) || !(startDate.getTime() <= scheduleEndDate.getTime())) {
                    if (startDate.getTime() < scheduleStartDate.getTime()) {
                        minStartDate = startDate;
                        scheduleStartDate = startDate;
                    }
                    else {
                        maxEndDate = proxy._getDateFromFormat(args.data.startDate);
                        scheduleEndDate = proxy._getDateFromFormat(args.data.startDate);
                    }
                }
                if (!(endDate.getTime() >= scheduleStartDate.getTime()) || !(endDate.getTime() <= scheduleEndDate.getTime())) {
                    if (endDate.getTime() < scheduleStartDate.getTime())
                        minStartDate = endDate;
                    else
                        maxEndDate = endDate;
                }
                if (maxEndDate) {
                    isDateChanged = true;
                    tempEndDate = args.data._getFormatedDate(maxEndDate, model.dateFormat, model.locale);
                }
                if (minStartDate) {
                    isDateChanged = true;
                    tempStartDate = args.data._getFormatedDate(minStartDate, model.dateFormat, model.locale);
                }
                if (model.renderBaseline && args.data["baselineStartDate"] && args.data["baselineEndDate"])
                {
                    var baselineStartDate = proxy._getDateFromFormat(args.data["baselineStartDate"]),
                        baselineEndDate = proxy._getDateFromFormat(args.data["baselineEndDate"]),
                        tempStartDate = proxy._getDateFromFormat(tempStartDate),
                        tempEndDate = proxy._getDateFromFormat(tempEndDate);
                    if (!(baselineStartDate.getTime() >= tempStartDate.getTime()) || !(baselineStartDate.getTime() <= tempEndDate.getTime())) {
                        if (baselineStartDate.getTime() < tempStartDate.getTime()) {
                            minBaselineStartDate = baselineStartDate;
                            scheduleStartDate = baselineStartDate;
                        }
                        else {
                            maxBaseLineEndDate = baselineStartDate;
                            scheduleEndDate = baselineStartDate;
                        }
                    }

                    if (!(baselineEndDate.getTime() >= tempStartDate.getTime()) || !(baselineEndDate.getTime() <= tempEndDate.getTime())) {
                        if (baselineEndDate.getTime() < tempStartDate.getTime())
                            minBaselineStartDate = baselineEndDate;
                        else
                            maxBaseLineEndDate = baselineEndDate;
                    }
                }
                if (maxBaseLineEndDate) {
                    isDateChanged = true;
                    tempEndDate = args.data._getFormatedDate(maxBaseLineEndDate, model.dateFormat, model.locale);
                }
                if (minBaselineStartDate) {
                    isDateChanged = true;
                    tempStartDate = args.data._getFormatedDate(minBaselineStartDate, model.dateFormat, model.locale);
                }
                if (isDateChanged) {
                    updatedDates = proxy._updateScheduleDatesByTaskLables(proxy._getDateFromFormat(tempStartDate), proxy._getDateFromFormat(tempEndDate));
                    proxy.updateScheduleDates(args.data._getFormatedDate(updatedDates.minStartDate, model.dateFormat, model.locale), args.data._getFormatedDate(updatedDates.maxEndDate, model.dateFormat, model.locale));
                }
            }
            else {
                var editArgs = {};
                editArgs.onEditing = true;
                proxy._calculateScheduleDates(editArgs);
                proxy._calculateDatesForScheduleCheck(editArgs.minStartDate);
                if (editArgs.minStartDate.getTime() < scheduleStartDate) {
                    tempStartDate = args.data._getFormatedDate(editArgs.minStartDate, model.dateFormat, model.locale);
                    isDateChanged = true;
                }
                if(editArgs.maxEndDate.getTime() > scheduleEndDate)
                {
                    tempEndDate = args.data._getFormatedDate(editArgs.maxEndDate, model.dateFormat, model.locale);
                    isDateChanged = true;
                }
                if (isDateChanged)
                {
                    proxy.updateScheduleDates(tempStartDate, tempEndDate);
                }
            }
        },
        //add dates before edited dates for scheduleupdate 
        _calculateDatesForScheduleCheck:function(startdate)
        {
            var proxy = this, model = this.model,
                scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                scheduleHeaderValue = ej.Gantt.ScheduleHeaderType;
               
            if (scheduleHeaderType == scheduleHeaderValue.Week) {

                startdate.setDate(startdate.getDate() - 3);
            }

            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                startdate.setDate(startdate.getDate() - 5);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                startdate.setDate(startdate.getDate() - 3);
            }

            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                startdate.setHours(startdate.getHours() - 2);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                startdate.setMinutes(startdate.getMinutes() - 5);
            }
        },
        //update schedule dates by tool bar operation
        _updateScheduleDatesByToolBar:function(args)
        {
            var proxy = this, model = this.model,
                 startDate = args === "prevTimeSpan" ? proxy._projectStartDate : proxy._getDateFromFormat(proxy.model.scheduleStartDate),
                 endDate = proxy._getDateFromFormat(proxy.model.scheduleEndDate),
                 chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance"),
                 scheduleHeaderType = model.scheduleHeaderSettings.scheduleHeaderType,
                 scheduleHeaderValue = ej.Gantt.ScheduleHeaderType,
                 maxScrollWidth = 0;

            if (scheduleHeaderType == scheduleHeaderValue.Week) {
                if (args === "prevTimeSpan") {
                    startDate.setDate(startDate.getDate() - 6);
                }
                else {
                    endDate.setDate(endDate.getDate() + 7);
                }
            }

            if (scheduleHeaderType == scheduleHeaderValue.Year) {
                if (args === "prevTimeSpan")
                    startDate.setDate(startDate.getDate() - 360);
                else
                    endDate.setDate(endDate.getDate() + 365);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Month) {
                if (args === "prevTimeSpan")
                    startDate.setMonth(startDate.getMonth() - 1);
                else
                    endDate.setDate(endDate.getDate() + 30);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Day) {
                if (args === "prevTimeSpan")
                    startDate.setDate(startDate.getDate() - 1);
                else
                    endDate.setDate(endDate.getDate() + 1);
            }
            if (scheduleHeaderType == scheduleHeaderValue.Hour) {
                if (args === "prevTimeSpan")
                    startDate.setHours(startDate.getHours() - 1);
                else
                    endDate.setHours(endDate.getHours() + 1);
            }                                    
            if (args === "prevTimeSpan") {
                proxy.updateScheduleDates(proxy._getFormatedDate(startDate, model.dateFormat, model.locale), proxy._getFormatedDate(endDate, model.dateFormat, model.locale));
                chartObject._$bodyContainer.ejScroller("scrollX", 0, true);
                if (proxy.isCriticalPathEnable == true && model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
                }
            }
            else if (args === "nextTimeSpan") {
                proxy.updateScheduleDates(proxy._getFormatedDate(startDate, model.dateFormat, model.locale), proxy._getFormatedDate(endDate, model.dateFormat, model.locale));
                maxScrollWidth = chartObject.getMaxScrollWidth();
                chartObject._$bodyContainer.ejScroller("scrollX", maxScrollWidth, true);
                if (proxy.isCriticalPathEnable == true && model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
                }
            }
        },
        _rowDataBound: function (args) {
            this._trigger("rowDataBound", args);
        },
        _refreshToolBar: function () {
            var $toolbar = $("#" + this._id + "_toolbarItems");
            $toolbar.find("li").removeClass("e-hover");
        },

        _toolBarClick: function (sender) {
            var proxy = this,
                model=proxy.model,
                $ganttEle = $(this.itemsContainer).closest(".e-gantt"),
                ganttInstance = $ganttEle.ejGantt("instance"),
               ganttId = $ganttEle.attr('id'),
                toolbarObj = $("#" + ganttInstance._id + "_toolbarItems");

            ganttInstance._clearContextMenu();
            if (sender.event == undefined && sender.target.tagName == "INPUT" && sender.currentTarget.id == ganttId + "_search")
                return false;

            if (ganttInstance.model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $.isFunction($.fn.ejDateTimePicker) && $("#" + ganttId + "EditForm").find(".e-datetimepicker").ejDateTimePicker("hide");
            else
                $.isFunction($.fn.ejDatePicker) && $("#" + ganttId + "EditForm").find(".e-datepicker").ejDatePicker("hide");
            var currentTarget = sender.currentTarget; var target = sender.target;
            var args = {
                itemName: sender.text,
                currentTarget: currentTarget,
                model: ganttInstance.model,
            };

            if ($ganttEle.ejGantt("instance")._trigger("toolbarClick", args))
                return false;
            $(toolbarObj).ejToolbar('deselectItem', sender.currentTarget);
            switch (sender.currentTarget.id) {
                case ganttId + "_excelExport":
                    ganttInstance._toolbarOperation(ganttId + "_excelExport");
                    break;
                case ganttId + "_pdfExport":
                    ganttInstance._toolbarOperation(ganttId + "_pdfExport");
                    break;
                case ganttId + "_add":
                    ganttInstance._toolbarOperation(ganttId + "_add");
                    break;

                case ganttId + "_edit":
                    ganttInstance._toolbarOperation(ganttId + "_edit");
                    break;

                case ganttId + "_delete":
                    ganttInstance._toolbarOperation(ganttId + "_delete");
                    break;

                case ganttId + "_update":
                    ganttInstance._toolbarOperation(ganttId + "_update");
                    break;

                case ganttId + "_cancel":
                    ganttInstance._toolbarOperation(ganttId + "_cancel");
                    break;

                case ganttId + "_search":
                    ganttInstance._toolbarOperation(ganttId + "_search", $(sender.currentTarget).find("input").val());
                    break;

                case ganttId + "_indent":
                    ganttInstance._toolbarOperation(ganttId + "_indent");
                    break;

                case ganttId + "_outdent":
                    ganttInstance._toolbarOperation(ganttId + "_outdent");
                    break;
                    
                case ganttId + "_expandAll":
                    ganttInstance._toolbarOperation(ganttId + "_expandAll");
                    break;

                case ganttId + "_criticalPath":
                    if (!ganttInstance._enableDisableCriticalIcon) {
                        ganttInstance._toolbarOperation(ganttId + "_criticalEnable");
                    }
                    else if (ganttInstance._enableDisableCriticalIcon) {
                        ganttInstance._toolbarOperation(ganttId + "_criticalDisable");
                    }
                    break;

                case ganttId + "_collapseAll":
                    ganttInstance._toolbarOperation(ganttId + "_collapseAll");
                    break;
                case ganttId + "_prevTimeSpan":
                    ganttInstance._toolbarOperation(ganttId + "_prevTimeSpan");
                    break;
                case ganttId + "_nextTimeSpan":
                    ganttInstance._toolbarOperation(ganttId + "_nextTimeSpan");
                    break;
                }
            return false;
        },

        _toolbarOperation: function (operation, searchEle) {
            var $ganttEle = this.element,
                ganttObject = $ganttEle.ejGantt("instance"),
                //gridObject = $gridEle.ejTreeGrid("instance"),
                ganttId = $ganttEle.attr('id'),
                proxy = this,
                rowindex = proxy.selectedRowIndex();
            ganttObject._exportTo = ganttObject["export"];
            var toolbar = $("#" + proxy._id + "_toolbarItems");
            switch (operation) {

                case ganttId + "_add":
                    proxy._sendAddRequest();
                    break;

                case ganttId + "_edit":
                    proxy._sendEditRequest();
                    break;

                case ganttId + "_delete":
                    proxy._$treegridHelper.ejTreeGrid("deleteRow");
                    proxy._isRefreshAddedRecord = false;

                    break;

                case ganttId + "_update":
                    proxy._$treegridHelper.ejTreeGrid("endEdit");
                    //gridObject.sendSaveRequest();

                    if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                        proxy._disabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
                    }

                    if (proxy.model.toolbarSettings.toolbarItems.indexOf("update") !== -1) {
                        proxy._disabledToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
                    }
                    $(toolbar).ejToolbar('disableItem', proxy._disabledToolItems);
                    
                    proxy._disabledToolItems = [];
                    
                    break;

                case ganttId + "_cancel":
                    proxy._$treegridHelper.ejTreeGrid("cancelEditCell");                                                            
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_criticalEnable":
                    proxy.showCriticalPath(true);
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_criticalDisable":
                    proxy.showCriticalPath(false);
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_search":
                    proxy.cancelEditCell();
                    if (proxy._searchString != searchEle) {
                        proxy._$treegridHelper.ejTreeGrid("search", searchEle);
                        proxy._searchString = searchEle;
                        proxy.updateSelectedItemIndex();
                        proxy._updateToolbarOptions();
                        proxy._isRefreshAddedRecord = false;
                    }
                    break;

                case ganttId + "_indent":
                    proxy._sendIndentRequest();
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    proxy._isRefreshAddedRecord = false;
                    break;

                case ganttId + "_outdent":
                    proxy._sendOutdentRequest();
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    proxy._isRefreshAddedRecord = false;
                    break;

                case ganttId + "_expandAll":
                    proxy._expandAll();
                    proxy.updateSelectedItemIndex();
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_collapseAll":
                    proxy._collapseAll();
                    proxy.updateSelectedItemIndex();
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;
                case ganttId + "_prevTimeSpan":
                    proxy._updateScheduleDatesByToolBar("prevTimeSpan");
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;
                case ganttId + "_nextTimeSpan":
                    proxy._updateScheduleDatesByToolBar("nextTimeSpan");
                    proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    break;

                case ganttId + "_excelExport":
                    proxy._exportTo(ganttObject.model.exportToExcelAction, 'excelExporting', ganttObject.model.allowMultipleExporting);
                    break;
                case ganttId + "_pdfExport":
                    proxy._exportTo(ganttObject.model.exportToPdfAction, 'pdfExporting', ganttObject.model.allowMultipleExporting);
                    break;
            }
            proxy._refreshToolBar();
            return false;
        },

        /* update selected ietm index when selected item row position changed */
        updateSelectedItemIndex: function () {
            var proxy = this, model = this.model, updatedRecords = model.updatedRecords,
                index;
            if(model.allowSelection && !ej.isNullOrUndefined(this.selectedItem()))
            {
                if (proxy.getExpandStatus(this.selectedItem())) {
                    index = updatedRecords.indexOf(this.selectedItem());
                    proxy.selectRows(index);
                }
                else
                {
                    proxy.selectRows(-1);
                }
            } else if (!model.allowSelection && !ej.isNullOrUndefined(this.selectedItem())) {
                proxy.selectRows(-1);
            }
        },

        clearSelection:function(){
            var proxy = this;
            proxy.model.selectedCellIndexes = [];
            proxy._$treegridHelper.ejTreeGrid("clearSelection");
            proxy._$ganttchartHelper.ejGanttChart("clearSelection");
        },

        selectCells: function (indexes, preservePreviousSelectedCells) {
            var proxy = this,
                model = proxy.model;
            if (model.selectionMode == "cell" && model.allowSelection) {
                proxy._$treegridHelper.ejTreeGrid("selectCells", indexes, preservePreviousSelectedCells);
            }
        },

        //select rows index of this item
        selectRows: function (index)
        {
            var proxy = this, model = this.model;

            if (model.selectionMode == "cell")
                return;

            if (index !== -1 && !ej.isNullOrUndefined(index) && index < model.updatedRecords.length) {
                var args = {};
                args.recordIndex = index;
                args.data = model.updatedRecords[args.recordIndex];
                args.target = "ejTreeGrid";
                if (proxy.rowSelecting(args)) {
                    proxy.rowSelected(args);
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                }
                proxy.updateIndentOutdentOption(args.data);
            }
            else if (index === -1) {
                proxy._deSelectRowItem();
                proxy._updateToolbarOptions();
            }
        },

        _setModel: function (options) {
            
            var proxy = this, option,
                model = proxy.model;
            
            for (option in options) {
                switch (option) {
                    case "sortSettings":
                        proxy._sendSortingRequest(options[option]);
                        break;
                    case "allowSorting":
                        proxy._sortingRequest(options[option]);
                        if (model.showColumnChooser && model.showColumnOptions)
                            proxy._$treegridHelper.ejTreeGrid("columnAddDialogTemplate");
                        break;
                    case "allowMultiSorting":
                        model.allowMultiSorting = options[option];
                        proxy._$treegridHelper.ejTreeGrid("model.allowMultiSorting", model.allowMultiSorting);
                        break;
                    case "destroy":
                        proxy.destroy();
                        break;
                    case "treeColumnIndex":
                        proxy._columnIndex(options[option]);
                        break;
                    case "allowGanttChartEditing":
                        proxy._ganttChartEditing(options[option]);
                        break;
                    case "enableProgressBarResizing":
                        proxy._resizeProgressbar(options[option]);
                        break;
                    case "enableTaskbarTooltip":
                        proxy._showTooltip(options[option]);
                        break;
                    case "enableTaskbarDragTooltip":
                        proxy._showEditingTooltip(options[option]);
                        break;                  
                    case "validateManualTasksOnLinking":
                        model.validateManualTasksOnLinking = options[option];
                        break;
                    case "enableAltRow":
                        proxy._updateAltRow(options[option]);
                        break;
                    case "locale":
                        model.flatRecords = [];
                        model.parentRecords = [];
                        proxy._clearContextMenu();
                        model.locale = options[option];
                        model.isRerender = true;
                        proxy.element.ejGantt("destroy").ejGantt(model);                        
                        break;
                    case "allowSelection":
                        model.allowSelection = options[option];
                        if (model.allowSelection) {
                            proxy._$treegridHelper.ejTreeGrid("instance").model.allowSelection = true;
                            proxy._$ganttchartHelper.ejGanttChart("instance").model.allowSelection = true;
                        }
                        else {
                            proxy._deSelectRowItem();
                            proxy._$treegridHelper.ejTreeGrid("instance").model.allowSelection = false;
                            proxy._$ganttchartHelper.ejGanttChart("instance").model.allowSelection = false;
                        }
                        proxy._updateToolbarOptions();
                        break;
                    case "editSettings":
                        $.extend(model.editSettings, options[option]);
                        proxy._updateEditSettings(options[option]);
                        proxy._initiateDialogTemplates();
                        proxy._enableEditingEvents();
                        this.cancelEditCell();
                        break;
                    case "taskbarBackground":
                        proxy._updateTaskbarBackground(options[option]);
                        break;
                    case "progressbarBackground":
                        proxy._updateProgressbarBackground(options[option]);
                        break;
                    case "parentTaskbarBackground":
                        proxy._updateParentTaskbarBackground(options[option]);
                        break;
                    case "parentProgressbarBackground":
                        proxy._updateParentProgressbarBackground(options[option]);
                        break;
                    case "showTaskNames":
                        proxy._updateRenderTaskNames(options[option]);
                        break;
                    case "leftTaskLabelMapping":
                        proxy._refreshLeftTaskLabelMapping(options[option]);
                        break;

                    case "rightTaskLabelMapping":
                        proxy._refreshRightTaskLabelMapping(options[option]);
                        break;

                    case "leftTaskLabelTemplate":
                        proxy._refreshLeftTaskLabelTemplate(options[option]);
                        break;

                    case "rightTaskLabelTemplate":
                        proxy._refreshRightTaskLabelTemplate(options[option]);
                        break;
                    case "showProgressStatus":
                        proxy._updateRendeProgressStatus(options[option]);
                        break;
                    case "showResourceNames":
                        proxy._updateRenderResourceNames(options[option]);
                        break;
                    case "progressbarHeight":
                        proxy._updateProgressbarHeight(options[option]);
                        break;
                    case "baselineColor":
                        proxy._updateBaselineColor(options[option]);
                        break;
                    case "renderBaseline":
                        proxy._updateRenderBaseline(options[option]);
                        break;
                    case "allowColumnResize":
                        proxy._updateAllowColumnResize(options[option]);
                        break;
                    case "allowKeyboardNavigation":
                        proxy._updateAllowKeyboardNavigation(options[option]);
                        break;
                    case "selectedItem":
                        proxy._updateSelectedItem(options[option]);
                        break;
                    case "dataSource":
                        proxy._deSelectRowItem();
                        proxy._updateToolbarOptions();
                        this._refreshDataSource(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy.showCriticalPath(true);
                        }
                        break;
                    case "readOnly":
                        proxy._updateReadOnly(options[option]);
                        break;
                    case "showGridCellTooltip":
                        proxy._updateShowGridCellTooltip(options[option]);
                        break;
                    case "showGridExpandCellTooltip":
                        proxy._updateShowGridExpandCellTooltip(options[option]);
                        break;
                    case "highlightWeekends":
                        proxy._updateHighlightWeekends(options[option]);
                        break;
                    case "connectorLineBackground":
                        proxy._updateConnectorLineBackground(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                        }
                        break;
                    case "connectorlineWidth":
                        proxy._updateConnectorlineWidth(options[option]);
                        if (proxy._enableDisableCriticalIcon) {
                            proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
                        }
                        break;
                    case "weekendBackground":
                        proxy._updateWeekendBackground(options[option]);
                        break;
                    case "scheduleHeaderSettings":
                        var settings = options[option];
                        for (var setting in settings) {
                            switch (setting) {
                                case "timescaleUnitSize":
                                    proxy._updateTimescaleUnitSize(settings[setting]);
                                    break;
                                case "scheduleHeaderType":
                                    proxy._changeChartSchedule(settings[setting]);
                                    break;
                            }
                        }
                        break;
                    case "enableContextMenu":
                        model.enableContextMenu = options[option];
                        proxy._clearContextMenu();
                        proxy._off(proxy.element, "contextmenu", proxy._rightClick);
                        if (model.enableContextMenu) {
                            proxy._on(proxy.element, "contextmenu", proxy._rightClick);
                        }
                        break;
                    case "enableResize":
                        if (model.enableResize) {
                            proxy.model.enableResize = options[option];
                            proxy._on($(window), "resize", proxy.windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy.windowResize);
                        }
                        break;
                    case "isResponsive":
                        if (model.isResponsive) {
                            proxy.model.isResponsive = options[option];
                            proxy._on($(window), "resize", proxy.windowResize);
                        }
                        else {
                            proxy._off($(window), "resize", proxy.windowResize);
                        }
                        break;
                    case "selectedRowIndex":
                        if (this.selectedRowIndex() === -1 || this.selectedRowIndex() === "") {
                            proxy._deSelectRowItem();
                            proxy._updateToolbarOptions();
                        }
                        else if (this.selectedRowIndex() !== -1 && !ej.isNullOrUndefined(this.selectedRowIndex()) && this.selectedRowIndex() < proxy.model.updatedRecords.length) {
                            var rowSelectingArgs = {};
                            rowSelectingArgs.recordIndex = proxy.selectedRowIndex();
                            rowSelectingArgs.previousIndex = model.selectedItem ? model.updatedRecords.indexOf(model.selectedItem) : -1;
                            if (proxy.rowSelecting(rowSelectingArgs)) {
                                var args = {};
                                args.recordIndex = this.selectedRowIndex();
                                args.data = proxy.model.updatedRecords[args.recordIndex];
                                args.target = "ejTreeGrid";
                                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                                proxy.rowSelected(args);
                            }
                        }
                        break;
                    case "selectedCellIndexes":
                        if (model.allowSelection && model.selectionMode == "cell") {
                            proxy.selectCells(options[option]);
                        }
                        break;
                    case "selectionMode":
                        if (model.allowSelection) {
                            proxy.clearSelection();
                            proxy._$treegridHelper.ejTreeGrid("selectRows", -1);
                            proxy._$ganttchartHelper.ejGanttChart("selectRows", -1);
                            model.selectedItem = null;
                            model.selectionMode = options[option];
                            proxy._$treegridHelper.ejTreeGrid("option", "selectionMode", options[option]);
                            proxy._$ganttchartHelper.ejGanttChart("option", "selectionMode", options[option]);
                            if (options[option] == "row")
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = "single";
                            proxy._updateToolbarOptions();
                        }
                        break;
                    case "selectionType":
                        if (model.allowSelection) {
                            proxy.clearSelection();
                            if (model.selectionMode == "cell") {
                                model.selectionType = options[option];
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = options[option];
                            }
                            else {
                                model.selectionType = "single";
                                proxy._$treegridHelper.ejTreeGrid("instance").model.selectionSettings.selectionType = "single";
                            }
                        }
                        break;
                    case "showColumnChooser":
                        model.showColumnChooser = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", {"showColumnChooser":model.showColumnChooser});
                        break;
                    case "showColumnOptions":
                        model.showColumnOptions = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "showColumnOptions": model.showColumnOptions });
                        break;
                    case "splitterPosition":
                        proxy.setSplitterPosition(proxy._splitterPosition());
                        break;
                    case "addDialogFields":
                        if (model.editSettings.allowAdding) {
                            model.addDialogFields = options[option];
                            proxy.addDialogTemplate();
                        }
                        break;
                    case "dragTooltip":
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "dragTooltip": options[option] });
                        break;

                    case "allowDragAndDrop":
                        model.allowDragAndDrop = options[option];
                        proxy._$treegridHelper.ejTreeGrid("setModel", { "allowDragAndDrop": model.allowDragAndDrop });
                        break;
                    case "editDialogFields":
                        if (model.editSettings.allowEditing) {
                            model.editDialogFields = options[option];
                            proxy.editDialogTemplate();
                        }
                        break;
                    case "toolbarSettings":
                        $.extend(proxy.model.toolbarSettings, options[option]);
                        proxy._updateToolbar();
                        break;
                    case "holidays":
                        model.holidays = options[option];
                        proxy._refreshHolidays();
                        break;
                    case "stripLines":
                        model.stripLines = options[option];
                        proxy._updateStripLines();
                        break;
                    case "splitterSettings":
                        $.extend(model.splitterSettings, options[option]);
                         if (!ej.isNullOrUndefined(options[option].index) && ej.isNullOrUndefined(options[option].position))
                            proxy.setSplitterIndex(model.splitterSettings.index);
                        else
                            proxy.setSplitterPosition(proxy.splitterPosition());
                        break;
                    case "enablePredecessorValidation":
                        model.enablePredecessorValidation = options[option];
                        break;
                    case "sizeSettings":
                        this._calculateDimensions();
                        this.windowResize();
                        break;
                    case "milestoneTemplate":
                        proxy._milestoneTemplate(options[option]);
                        break;
                    case "taskbarTemplate":
                        proxy._taskbarTemplate(options[option]);
                        break;
                    case "parentTaskbarTemplate":
                        proxy._parentTaskbarTemplate(options[option]);
                        break;
                    case "dayWorkingTime":
                        model.dayWorkingTime = options[option].slice();
                        model.flatRecords = [];
                        model.parentRecords = [];
                        model.updatedRecords = [];
                        model.ids = [];
                        model.scheduleStartDate = model.scheduleStartDate;
                        model.scheduleEndDate = model.scheduleEndDate;
                        proxy._storedIndex = -1;
                        proxy._lastInsertedId = -1;

                        proxy.selectedRowIndex(-1);
                        proxy._predecessorsCollection = [];
                        proxy.element.ejGantt("destroy").ejGantt(model);
                        break;
                    case "workUnit":
                        model.workUnit = options[option];
                        this._updateWorkUnit();
                        break;
                    case "resources":                        
                        proxy._updateResourcesData(options[option]);
                        break;
                    case "cssClass":
                        this.element.removeClass(proxy._cssClass).addClass(options[option]);
                        model.toolbarSettings.showToolbar && $("#" + proxy._id + "_toolbarItems").ejToolbar("model.cssClass", options[option]);
                        $("#e-ejSpliter" + proxy._id).data("ejSplitter") && $("#e-ejSpliter" + proxy._id).ejSplitter("model.cssClass", options[option]);
                        proxy._$treegridHelper.ejTreeGrid("model.cssClass", options[option]);
                        proxy._$ganttchartHelper.removeClass(proxy._cssClass).addClass(options[option]);
                        proxy._$ganttchartHelper.ejGanttChart("model.cssClass", options[option]);
                        proxy.addDialogTemplate();
                        proxy.editDialogTemplate();
                        this._cssClass = options[option];
                        break;
                    case "workWeek":
                        model.workWeek = options[option].slice();
                        //Set the default workWeek when workWeek is empty
                        if (model.workWeek.length == 0)
                            model.workWeek = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"];
                        proxy._getNonWorkingDayIndex();
                        proxy._$ganttchartHelper.ejGanttChart("updateWorkWeek", model.workWeek);
                        proxy._refreshDataSource(model.dataSource);
                        break;
                }
            }
        },

        _updateResourcesData: function (updatedResources) {
            var proxy = this, model = proxy.model, ganttObj, columnIndex = -1,
                columns = proxy.getColumns(),
                flatRecords;
            model.resources = $.extend(true, [], updatedResources);

            $.each(columns, function (index, column) {
                if (column.mappingName == model.resourceInfoMapping) {
                    columnIndex = index;
                    return;
                }
            });
            if (columnIndex > -1) columns[columnIndex]["dropdownData"] = model.resources;
            flatRecords = model.flatRecords.slice();
            flatRecords.reverse();
            ganttObj = ej.Gantt.GanttRecord.prototype;
            $.each(flatRecords, function (index, record) {
                if (record.resourceInfo && record.resourceInfo.length > 0) {                    
                    record.resourceInfo = ganttObj._setResourceInfo(record.item[model.resourceInfoMapping], model.resourceIdMapping, model.resourceNameMapping, model.resourceUnitMapping, model.resources);
                    proxy._updateResourceName(record);
                    proxy._updateResourceRelatedFields(record);
                    if (record.hasChildRecords) {
                        if (record.isAutoSchedule)
                            proxy._updateParentItem(record, null, true);
                        else if (!record.isAutoSchedule)
                            proxy._updateManualParentItem(record, null, true);
                    }
                    else
                        proxy.refreshGanttRecord(record);                   
                }                
            });            
        },
        //To change schedule mode of gantt on chart side
        _changeChartSchedule: function (headerType) {
            var proxy = this, model = proxy.model,
                startDate = proxy._getDateFromFormat(model.scheduleStartDate),
                endDate = proxy._getDateFromFormat(model.scheduleEndDate);
            switch (headerType) {
                case ej.Gantt.ScheduleHeaderType.Week:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Week;
                    proxy._perDayWidth = 30;
                    break;
                case ej.Gantt.ScheduleHeaderType.Day:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Day;
                    proxy._perHourWidth = 20;
                    if (model.workingTimeScale == ej.Gantt.workingTimeScale.TimeScale24Hours)
                        proxy._perDayWidth = (proxy._perHourWidth * 24);//24 hours
                    else if (model.workingTimeScale == ej.Gantt.workingTimeScale.TimeScale8Hours)
                        proxy._perDayWidth = (proxy._perHourWidth * 24);//9 hours
                    break;
                case ej.Gantt.ScheduleHeaderType.Month:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Month;
                    proxy._perDayWidth = 10;
                    proxy._perWeekWidth = 70;
                    break;
                case ej.Gantt.ScheduleHeaderType.Year:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Year;
                    proxy._perDayWidth = 3;
                    proxy._perMonthWidth = 90;
                    break;
                case ej.Gantt.ScheduleHeaderType.Hour:
                    model.scheduleHeaderSettings.scheduleHeaderType = ej.Gantt.ScheduleHeaderType.Hour;
                    var minutesPerInterval = model.scheduleHeaderSettings.minutesPerInterval,
                        intervalValue = ej.Gantt.minutesPerInterval;
                    proxy._perMinuteWidth = 20;
                    if (minutesPerInterval) {
                        if (minutesPerInterval == intervalValue.Auto) {
                            var twoDaysTimeSpan = 2 * 86400000,// Time in milliseconds
                                sevenDaysTimeSpan = 7 * 86400000,//Time in milliseconds
                                tenDaysTimeSpan = 10 * 86400000,
                                diff = endDate - startDate;
                            if (diff > tenDaysTimeSpan) {
                                proxy._minuteInterval = 30;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                            }
                            else if (diff > sevenDaysTimeSpan) {
                                proxy._minuteInterval = 15;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                            }
                            else if (diff > twoDaysTimeSpan) {
                                proxy._minuteInterval = 5;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                            }
                            else {
                                proxy._minuteInterval = 1;
                                proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);//24 hours
                            }
                        }
                        else if (minutesPerInterval == intervalValue.OneMinute) {
                            proxy._minuteInterval = 1;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 60);
                        }
                        else if (minutesPerInterval == intervalValue.FiveMinutes) {
                            proxy._minuteInterval = 5;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 12);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.FifteenMinutes) {
                            proxy._minuteInterval = 15;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 4);//24 hours
                        }
                        else if (minutesPerInterval == intervalValue.ThirtyMinutes) {
                            proxy._minuteInterval = 30;
                            proxy._perDayWidth = (proxy._perMinuteWidth * 24 * 2);//24 hours
                        }
                    }
                    break;
            }                        
            proxy._updateModelsWidth();
            //Re render the gantt chart side alone
            proxy.updateScheduleDates(model.scheduleStartDate, model.scheduleEndDate);
        },        
        //Change work unit for whole project using set model.
        _updateWorkUnit: function () {
            var proxy = this, model = proxy.model,
                flatRecords = model.flatRecords,              
                currentViewData = proxy.getCurrentViewData(),
                treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            treegridObject.model.workUnit = proxy._workUnitTexts[model.workUnit];
            for (var index = 0; index < flatRecords.length; index++) {
                var record = flatRecords[index],
                    currentRecordIndex = currentViewData.indexOf(record);
                record._updateWorkWithDuration(proxy);
                if (record.parentItem)
                    proxy._updateParentItem(record);
                if (currentRecordIndex != -1)
                    ej.TreeGrid.refreshRow(treegridObject, currentRecordIndex);
            }
        },
        /*Data binding method for dynamic update of dataSource*/
        _dataBindingForSetModel: function () {
            var proxy = this, model = proxy.model;
            if (this.dataSource() == null) {
                this.dataSource([]);
            }
            if (this.dataSource() instanceof ej.DataManager) {
                var query = this._columnToSelect();
                var queryPromise = this.dataSource().executeQuery(query);
                queryPromise.done(ej.proxy(function (e) {
                    if (proxy.dataSource().dataSource.offline) {
                        proxy._retrivedData = proxy.dataSource().dataSource.json;
                    } else {
                        proxy._retrivedData = e.result;
                    }
                    
                    if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                        var dataArray = proxy._retrivedData, data = [];
                        proxy._taskIds = [];
                        for (var i = 0; i < dataArray.length; i++) {
                            var tempData = dataArray[i];
                            data.push($.extend(true, {}, tempData));
                            if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                        }

                        if (!model.childMapping) model.childMapping = "Children";
                        proxy._reconstructDatasource(data);                     
                    }
                    else {
                        proxy.secondaryDatasource = proxy._retrivedData;
                    }
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                    proxy._refreshGanttWithNewRecords();
                }));
            }
            else if (this.dataSource().length > 0) {
                if ((model.taskIdMapping.length > 0) && (model.parentTaskIdMapping.length > 0)) {
                    var dataArray = proxy.dataSource(), data = [];
                    proxy._taskIds = [];
                    for (var i = 0; i < dataArray.length; i++) {
                        var tempData = dataArray[i];
                        data.push($.extend(true, {}, tempData));
                        if (tempData[model.taskIdMapping]) proxy._taskIds.push(tempData[model.taskIdMapping]);
                    }

                    if (!model.childMapping) model.childMapping = "Children";
                    proxy._reconstructDatasource(data);
                    proxy._createGanttRecords(proxy.secondaryDatasource);
                }
                else {
                    proxy._createGanttRecords(this.dataSource());
                }
                this._refreshGanttWithNewRecords();
            } else {
                this._refreshGanttWithNewRecords();
            }
            if (model.expandStateMapping)
                proxy._collapseRecordOnLoad();
        },
        /*Refresh all Gantt rows on new data source update*/
        _refreshGanttWithNewRecords: function () {
            var proxy = this,
                model = this.model,
                args = {};
            this._updatePredecessors();
            model.predecessorMapping && model.enablePredecessorValidation && proxy._updatedRecordsDateByPredecessor();
            this._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());
            this._$treegridHelper.ejTreeGrid("processBindings");
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            proxy._gridRows = proxy.getRows();
            proxy._totalCollapseRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            this._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            this._calculateScheduleDates();
            this.updateScheduleDates(model.scheduleStartDate, this.model.scheduleEndDate);
            args.requestType = ej.TreeGrid.Actions.Refresh;
            proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
            this._isFromSetModel = false;
        },
        /*Method to update the data source dynamically*/
        _refreshDataSource: function (dataSource) {
            var proxy = this;
            this.resetModelCollections();
            this.dataSource(dataSource);
            this._isFromSetModel = true;
            proxy.secondaryDatasource = [];
            proxy._retrivedData = this.dataSource();
            this._dataBindingForSetModel();
        },

        resetModelCollections: function () {
            var proxy = this,
                model = proxy.model;
            model.dataSource = [];
            model.flatRecords = [];
            model.parentRecords = [];
            model.updatedRecords = [];
            model.ids = [];
            model.scheduleStartDate = model.scheduleStartDate;
            model.scheduleEndDate = model.scheduleEndDate;
            proxy._storedIndex = -1;
            proxy._lastInsertedId = -1;
            proxy.selectedRowIndex(-1);
            proxy._predecessorsCollection = [];
        },
        /* refresh holidays collections */
        _refreshHolidays: function () {
            var proxy = this,
                model = this.model, updatedDates;
            proxy._holidaysList = proxy._getHoliday();
            proxy._stringHolidays = proxy._getStringHolidays();

            updatedDates = proxy._updateScheduleDatesByHolidays(new Date(proxy._projectStartDate), new Date(proxy._projectEndDate));
            if (updatedDates.startDate.getTime() !== proxy._projectStartDate.getTime() || updatedDates.endDate.getTime() !== proxy._projectEndDate.getTime()) {
                var ganttObject = proxy._$ganttchartHelper.data("ejGanttChart");
                ganttObject.model.holidays = model.holidays;
                proxy.updateScheduleDates(updatedDates.startDate, updatedDates.endDate);
            }
            else {
                /* prevent refresh parent Item on update the child records */
                proxy._isTreeGridRendered = false;
                proxy._isGanttChartRendered = false;

                /* Update Left and Width Value of all records with new holidays*/
                proxy._updateGanttRecords();

                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords, proxy._totalCollapseRecordCount);
                /* refresh the connector line collection */
                if (model.predecessorMapping) {
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._isValidationEnabled = false;
                    proxy._createConnectorLinesCollection();
                    proxy._isValidationEnabled = true;
                }
                /*refresh the holiday container */
                this._$ganttchartHelper.ejGanttChart("refreshHolidays", model.holidays);
                proxy._isTreeGridRendered = true;
                proxy._isGanttChartRendered = true;
            }

            /* refresh chart and Treegrid part */
            proxy._$treegridHelper.ejTreeGrid("renderRecords");
        },

        /* refreh the strip lines collection */
        _updateStripLines : function()
        {
            var proxy = this, model = this.model, updatedDates;

            updatedDates = proxy._updateScheduleDatesByStripLines(new Date(proxy._projectStartDate), new Date(proxy._projectEndDate));

            if (updatedDates.startDate.getTime() !== proxy._projectStartDate.getTime() || updatedDates.endDate.getTime() !== proxy._projectEndDate.getTime()) {
                var ganttObject = proxy._$ganttchartHelper.data("ejGanttChart");
                ganttObject.model.stripLines = model.stripLines;
                proxy.updateScheduleDates(updatedDates.startDate, updatedDates.endDate);
            }
            else {
                this._$ganttchartHelper.ejGanttChart("refreshStripLines", this.model.stripLines);
            }
        },
        _updateWeekendBackground: function (bgcolor) {
            var proxy = this;
            this.model.weekendBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateWeekendBackground", bgcolor);

        },

        _updateConnectorlineWidth: function (lineWidth) {
            var proxy = this;
            this.model.connectorlineWidth = lineWidth;
            proxy._$ganttchartHelper.ejGanttChart("updateConnectorlineWidth", lineWidth);
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);

        },

        _updateConnectorLineBackground: function (bgcolor) {
            var proxy = this;
            this.model.connectorLineBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateConnectorLineBackground", bgcolor);
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);

        },

        _updateHighlightWeekends: function (bool) {
            var proxy = this;
            this.model.highlightWeekends = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateHighlightWeekends", bool);
        },

        _updateReadOnly:function(bool){
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateReadOnly", bool);
            proxy._$ganttchartHelper.ejGanttChart("updateReadOnly", bool);
            proxy._updateToolbarOptions();
        },
        _updateShowGridCellTooltip: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateShowGridCellTooltip", bool);
        },

        _updateShowGridExpandCellTooltip: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateShowGridExpandCellTooltip", bool);
        },

        _updateSelectedItem: function (item) {
            var proxy = this,
                args = {};
            if (item[proxy.model.taskIdMapping] != null) {


                args.recordIndex =proxy.model.ids.indexOf((item[proxy.model.taskIdMapping]).toString());
                args.item = proxy.model.flatRecords[args.recordIndex];
                args.target = "ejTreeGrid";
                proxy.rowSelected(args);
                proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                proxy._$ganttchartHelper.ejGanttChart("updateSelectedItem", args.recordIndex);
            }
        },

        /* udpate allowKeyboardNavigation API value in treegrid and chart side */
        _updateAllowKeyboardNavigation: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateAllowKeyboardNavigation", bool);
            proxy._$ganttchartHelper.ejGanttChart("updateAllowKeyboardNavigation", bool);
        },
        
        _updateAllowColumnResize: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateAllowColumnResize", bool);
        },
        
        _updateProgressbarHeight: function (height) {
            var proxy = this;
            this.model.progressbarHeight = height;
            proxy._$ganttchartHelper.ejGanttChart("updateProgressbarHeight", height);
        },
        
        _updateBaselineColor: function (color) {
            var proxy = this;
            this.model.baselineColor = color;
            proxy._$ganttchartHelper.ejGanttChart("updateBaselineColor", color);
        },
        
        _showBaselineColumns: function () {
            var proxy = this, model = proxy.model, column, mapping;
            /*If renderBaseline enabled baseline columns  are added*/
            if (model.renderBaseline && model.baselineStartDateMapping && model.baselineEndDateMapping) {

                mapping = model.baselineStartDateMapping;
                if (mapping.length) {
                    column = {
                        field: "baselineStartDate",
                        headerText: proxy._columnHeaderTexts["baselineStartDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    proxy._columns.push(column);
                }
                mapping = model.baselineEndDateMapping;

                if (mapping.length) {
                    column = {
                        field: "baselineEndDate",
                        headerText: proxy._columnHeaderTexts["baselineEndDate"],
                        width: 150,
                        editType: (model.dateFormat.toLowerCase().indexOf("hh") == -1) ?
                             ej.Gantt.EditingType.DatePicker : ej.Gantt.EditingType.DateTimePicker,
                        mappingName: mapping,
                        format: "{0:" + model.dateFormat + "}",
                        allowEditing: true,
                        allowCellSelection: true
                    };
                    proxy._columns.push(column);
                }
            }
        },
        _updateRenderBaseline: function (bool) {
            var proxy = this, model=proxy.model;
            this.model.renderBaseline = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderBaseline", bool);
            //Show Baseline columns in TreeGrid Side.
            if (model.renderBaseline) {
                proxy._showBaselineColumns();
                proxy._trigger("load");
            }
            //Delete Baseline Columns From TreeGrid.
            if (!model.renderBaseline) {
                var baselineStartDateColumIndex = proxy._getbaselineColumnIndex(proxy._columns).indexOf("baselineStartDate");
                proxy._columns.splice(baselineStartDateColumIndex, 1);
                var baselineEndDateColumIndex = proxy._getbaselineColumnIndex(proxy._columns).indexOf("baselineEndDate");
                proxy._columns.splice(baselineEndDateColumIndex, 1);
            }
            //Update Column Collection of Gantt in TreeGrid side.
            proxy._$treegridHelper.ejTreeGrid("updateColumns", proxy._columns);
            proxy.addDialogTemplate();
            proxy.editDialogTemplate();
        },
        // to get the column fields as an array collection to find particular column index
        _getbaselineColumnIndex: function (columns) {
            var proxy = this, columnIndexArray = [];
            for (var i = 0; i < columns.length; i++) {
                columnIndexArray[i] = columns[i].field;
            }
            return columnIndexArray;
        },
        _updateRenderTaskNames: function (bool) {
            var proxy = this;
            this.model.showTaskNames = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderTaskNames", bool);
        },
        _refreshLeftTaskLabelMapping: function (leftLabel) {
            var proxy = this;
            this.model.leftTaskLabelMapping = leftLabel;
            proxy._$ganttchartHelper.ejGanttChart("refreshLeftTaskLabelMapping", leftLabel);
        },
        _refreshRightTaskLabelMapping: function (rightLabel) {
            var proxy = this;
            this.model.rightTaskLabelMapping = rightLabel;
            proxy._$ganttchartHelper.ejGanttChart("refreshRightTaskLabelMapping", rightLabel);
        },
        _refreshLeftTaskLabelTemplate: function (leftLabelTemplate) {
            var proxy = this;
            this.model.leftTaskLabelTemplate = leftLabelTemplate;
            proxy._$ganttchartHelper.ejGanttChart("refreshLeftTaskLabelTemplate", leftLabelTemplate);
        },
        _refreshRightTaskLabelTemplate: function (rightLabelTemplate) {
            var proxy = this;
            this.model.rightTaskLabelTemplate = rightLabelTemplate;
            proxy._$ganttchartHelper.ejGanttChart("refreshRightTaskLabelTemplate", rightLabelTemplate);
        },
        
        _updateRendeProgressStatus: function (bool) {
            var proxy = this;
            this.model.showProgressStatus = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRendeProgressStatus", bool);
        },
        
        _updateRenderResourceNames: function (bool) {
            var proxy = this;
            this.model.showResourceNames = bool;
            proxy._$ganttchartHelper.ejGanttChart("updateRenderResourceNames", bool);
        },
        
        _updateTaskbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.taskbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateTaskbarBackground", bgcolor);
        },

        _updateProgressbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.progressbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateProgressbarBackground", bgcolor);
        },

        _updateParentTaskbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.parentTaskbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateParentTaskbarBackground", bgcolor);
        },

        _updateParentProgressbarBackground: function (bgcolor) {
            var proxy = this;
            this.model.parentProgressbarBackground = bgcolor;
            proxy._$ganttchartHelper.ejGanttChart("updateParentProgressbarBackground", bgcolor);
        },
        
        _updateEditSettings: function (edit) {
            var proxy = this;
            proxy._$ganttchartHelper.ejGanttChart("updateEditSettings", edit);
            proxy._$treegridHelper.ejTreeGrid("updateEditSettings", edit);
            proxy._updateToolbarOptions();
            
        },
        
        _updateRowSelection: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("updateRowSelection", bool);
        },

        _updateAltRow: function (bool) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("option", "enableAltRow", bool);
        },

        //Insert templated row in DOM for newly added record
        _renderAddedRow: function (index, data)
        {
            var proxy = this, model = this.model;
            model.currentViewData = proxy._$treegridHelper.ejTreeGrid("getUpdatedCurrentViewData");
            proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            if (model.enableVirtualization) {
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
            }
            else {
                proxy._$treegridHelper.ejTreeGrid("renderNewAddedRow", index, data);
                proxy._$ganttchartHelper.ejGanttChart("renderNewAddedRow", index, data);
            }
            proxy._$treegridHelper.ejTreeGrid("updateHeight");
            proxy._gridRows = proxy.getRows();
            proxy._ganttChartRows = proxy.getGanttChartRows();
        },
        
        /* get visible child record count in udpated records */
        _getVisibleChildRecordCount:function(data,count,collection)
        {
            var proxy = this, model = this.model, childRecords, length;

            if (data.hasChildRecords) {
                childRecords = data.childRecords;
                length = childRecords.length;
                for (var i = 0; i < length; i++) {
                    if (collection.indexOf(childRecords[i]) !== -1)
                        count++;
                    if (childRecords[i].hasChildRecords) {
                        count = proxy._getVisibleChildRecordCount(childRecords[i], count, collection);
                    }
                }
            }
            else {
                if (collection.indexOf(data) !== -1) {
                    count++;
                }
            }
            return count;
        },

        /* validate predecessor value of adding record*/
        _validateAddRecordPrecessorValue :function(args){
            var proxy = this, data = args.data, model = this.model;
            /* Validate the predecessor value*/
            if (model.predecessorMapping && data[model.predecessorMapping] && data[model.predecessorMapping].length > 0) {
                var validateArgs = {};
                validateArgs.currentRecord = args.currentRecord;
                validateArgs.predecessorString = data[model.predecessorMapping].split(",");
                if (!proxy._editedPredecessorValidation(validateArgs)) {
                    data[model.predecessorMapping] = "";
                    args.currentRecord.predecessor = null;
                    args.currentRecord.predecessorsName = "";
                    return false;
                }
                else {
                    return true;
                }
            } else {
                return true;
            }
        },
        
        openAddDialog: function () {
            this.cancelEditCell();
            this._sendAddRequest();
        },

        
        openEditDialog: function () {
            this.cancelEditCell();
            this._sendEditRequest();
        },
        
        
        searchItem: function (searchString) {
            var proxy = this;
            proxy.cancelEditCell();
            if (proxy._searchString != searchString) {
                proxy._$treegridHelper.ejTreeGrid("search", searchString);
                proxy._searchString = searchString;
                $("#gantt_search input").val(searchString);
            }
        },
        
        
        addRecord: function (data, rowPosition) {
            var proxy = this, model = this.model,
                selectedRowIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell,
                selectedItem = model.updatedRecords[selectedRowIndex], _cAddedRecord,
                taskIdMapping = model.taskIdMapping,
                updatedRecords = model.updatedRecords,
                flatRecords = model.flatRecords,
                parentRecords = model.parentRecords,
                ids = model.ids,
                dataSource = this.dataSource(), dataChildCount,
                level = 0, insertIndex, validateArgs = {},
                parentItem, nextBelowItemInflatRecords, nextBelowItemInUpdatedRecords;
            proxy.clearSelection();
            /* clear if treegrid is in edit state*/
            proxy.cancelEditCell();
            if ($.type(dataSource) !== "array" && !(dataSource instanceof ej.DataManager))
            {
                this.dataSource([]);
                dataSource = this.dataSource();
            }
            if (Object.prototype.toString.call(data) !== "[object Object]") {
                data = {};
            }

            if (selectedRowIndex === -1 && (rowPosition === ej.Gantt.RowPosition.AboveSelectedRow
                 || rowPosition === ej.Gantt.RowPosition.BelowSelectedRow
                 || rowPosition === ej.Gantt.RowPosition.Child) || !rowPosition) {
                rowPosition = ej.Gantt.RowPosition.Top;
            }

            /*Validate Task Id of data*/
            if (data[taskIdMapping]) {
                if(model.ids.indexOf(data[taskIdMapping].toString()) != -1) {
                    data[taskIdMapping] = null;
                } else {
                    data[taskIdMapping] = isNaN(parseInt(data[taskIdMapping])) ? null : parseInt(data[taskIdMapping]);
                }
            }

            //Add default value for missing fields
            proxy._updateAddData(data, rowPosition);
            //get updated json data of data manager from TreeGrid 
            if (proxy._isDataManagerUpdate)
                proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDataManagerData");

            switch (rowPosition) {
                case ej.Gantt.RowPosition.Top:
                    level = 0;
                    parentItem = null;
                    _cAddedRecord = proxy._createGanttRecord(data, level);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    /*record update*/
                    flatRecords.splice(0, 0, _cAddedRecord);
                    updatedRecords.splice(0, 0, _cAddedRecord);
                    ids.splice(0, 0, _cAddedRecord.taskId.toString());
                    parentRecords.splice(0, 0, _cAddedRecord);
                    /*data source update*/
                    if (proxy._isDataManagerUpdate) {
                        proxy._jsonData.splice(0, 0, _cAddedRecord.item);
                    } else {
                        dataSource.splice(0, 0, _cAddedRecord.item);
                    }
                    insertIndex = 0;
                    break;

                case ej.Gantt.RowPosition.Bottom:
                    level = 0;
                    parentItem = null;
                    _cAddedRecord = proxy._createGanttRecord(data, level);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    /*record update*/
                    flatRecords.push(_cAddedRecord);
                    updatedRecords.push(_cAddedRecord);
                    ids.push(_cAddedRecord.taskId.toString());
                    parentRecords.push(_cAddedRecord);
                    /*data source update*/
                    if (proxy._isDataManagerUpdate) {
                        proxy._jsonData.push(_cAddedRecord.item);
                    } else {
                        dataSource.push(_cAddedRecord.item);
                    }
                    insertIndex = updatedRecords.indexOf(_cAddedRecord);
                    break;

                case ej.Gantt.RowPosition.AboveSelectedRow:
                    level = selectedItem.level;
                    parentItem = selectedItem.parentItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }
                    var childIndex, recordIndex, updatedCollectionIndex;
                    /*Record Updates*/
                    recordIndex = flatRecords.indexOf(selectedItem);
                    updatedCollectionIndex = updatedRecords.indexOf(selectedItem);
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    } else {
                        /* Parent records collection and data source update*/
                        parentRecords.splice(parentRecords.indexOf(selectedItem), 0, _cAddedRecord);
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                        }
                        else {
                            dataSource.splice(dataSource.indexOf(selectedItem.item), 0, _cAddedRecord.item);
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
                case ej.Gantt.RowPosition.BelowSelectedRow:
                    level = selectedItem.level;
                    parentItem = selectedItem.parentItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    //find next item position
                    var currentItemIndex = flatRecords.indexOf(selectedItem)

                    if (selectedItem.hasChildRecords) {
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", selectedItem, 0);
                        recordIndex = currentItemIndex + dataChildCount + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                    } else {
                        recordIndex = currentItemIndex + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                    }

                    /* Record collection update */
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    /* data Source update */
                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    } else {
                        /* Parent records collection and data source update*/
                        parentRecords.splice(parentRecords.indexOf(selectedItem) + 1, 0, _cAddedRecord);
                        if (proxy._isDataManagerUpdate) {
                            proxy._jsonData.splice(proxy._jsonData.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            dataSource.splice(dataSource.indexOf(selectedItem.item) + 1, 0, _cAddedRecord.item);
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
                case ej.Gantt.RowPosition.Child:
                    level = selectedItem.level + 1;
                    parentItem = selectedItem;
                    _cAddedRecord = proxy._createGanttRecord(data, level, parentItem);
                    _cAddedRecord.index = _cAddedRecord.taskId;

                    //validate predecessor of new record
                    validateArgs.data = data;
                    validateArgs.currentRecord = _cAddedRecord;
                    if (!proxy._validateAddRecordPrecessorValue(validateArgs) && proxy._isinAddnewRecord) {
                        return false;
                    }

                    //find next item position
                    var currentItemIndex = flatRecords.indexOf(selectedItem)

                    if (selectedItem.hasChildRecords) {
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", selectedItem, 0);
                        recordIndex = currentItemIndex + dataChildCount + 1;
                        //Expand Add record's parent item 
                        if (!selectedItem.expanded) {
                            var expanargs = {};
                            expanargs.expanded = true;
                            expanargs.data = selectedItem;
                            proxy._isInAdd = true;
                            proxy.expanding(expanargs);
                            proxy._isInAdd = false;
                            updatedRecords = proxy.getUpdatedRecords();
                        }
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + proxy._getVisibleChildRecordCount(selectedItem, 0, updatedRecords) + 1;

                    } else {
                        selectedItem.hasChildRecords = true;
                        selectedItem.childRecords = [];
                        selectedItem.expanded = true;
                        if (!model.parentTaskIdMapping) {
                            selectedItem.item[model.childMapping] = [];
                        }
                        selectedItem.isMilestone = false;
                        recordIndex = currentItemIndex + 1;
                        updatedCollectionIndex = updatedRecords.indexOf(selectedItem) + 1;
                        selectedItem.predecessor && proxy._updatePredecessorOnIndentOutdent(selectedItem);
                    }
                  
                    /* Record collection update */
                    flatRecords.splice(recordIndex, 0, _cAddedRecord);
                    updatedRecords.splice(updatedCollectionIndex, 0, _cAddedRecord);
                    ids.splice(recordIndex, 0, _cAddedRecord.taskId.toString());

                    /* data Source update */
                    if (!ej.isNullOrUndefined(parentItem)) {
                        childIndex = parentItem.childRecords.indexOf(selectedItem);
                        /*Child collection update*/
                        parentItem.childRecords.splice(childIndex + 1, 0, _cAddedRecord);
                        if (!model.parentTaskIdMapping) {
                            parentItem.item[model.childMapping].splice(childIndex + 1, 0, _cAddedRecord.item);
                        }
                        else {
                            _cAddedRecord.item[model.parentTaskIdMapping] = _cAddedRecord.parentItem.taskId;
                            if (proxy._isDataManagerUpdate) {
                                proxy._jsonData.push(_cAddedRecord.item);

                            } else {
                                dataSource.push(_cAddedRecord.item);
                            }
                        }
                    }
                    insertIndex = updatedCollectionIndex;
                    break;
            }

            //Clear previously selected Item
            proxy._deSelectRowItem()

            /*Updated record collections in treegrid side*/
            proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());

            if (model.enableWBS) {
                proxy.updateWBSdetails(_cAddedRecord);
            }
            /* Trigger action complete event for further updated*/
            var eventArgs = {};
            eventArgs.requestType = "save";
            eventArgs._cAddedRecord = eventArgs.addedRecord = _cAddedRecord;
            eventArgs.index = insertIndex;
            proxy.actionComplete(eventArgs);
            /*Set flag for refresh newly added record in non virtalization mode*/
            var treeGridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            if (model.enableVirtualization === false &&
                (treeGridObject.model.sortSettings.sortedColumns.length > 0 || treeGridObject._searchString.length > 0)) {
                proxy._isRefreshAddedRecord = true;
            }
            //Maintain index of newly added row to update scrollbar while selection mode is cell.
            if (model.selectionMode == "cell") {
                var selectedRowIndex = model.updatedRecords.indexOf(_cAddedRecord);
                proxy._$treegridHelper.ejTreeGrid("updateScrollBar", selectedRowIndex);
            }
            else
                /* scroll to new added record */
                proxy._$treegridHelper.ejTreeGrid("updateScrollBar");
            //For dialog add reference
            return true;
        },
        
        /*Update the WBS value of all the records that are below the newly added row*/
        updateWBSdetails: function (targetedRow, isOutdentMinus, isReRenderWBSPred) {
            var proxy = this,
                model = proxy.model,
                dataW = targetedRow ? targetedRow : model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell],
                      //^^ during indent-outdent    ^^ Newly added row
                newWBS = dataW["WBS"];
           
            //Updating the WBS value of other records that are below the newly added row
            var childItems, markedIndex, markedRecords, dataS, dataLength;
            if (dataW.parentItem) {
                childItems = dataW.parentItem.childRecords;
                markedIndex = childItems.indexOf(dataW);
                dataS = childItems;
                dataLength = dataS.length;
            } else if (model.flatRecords.length) {
                var flatData = model.flatRecords,
                    Level0 = flatData.filter(function (item) {
                        return item && item.level == 0;
                    });
                dataS = Level0;
                markedIndex = dataS.indexOf(dataW);
                dataLength = dataS.length;
            }
            if (isOutdentMinus)
                markedRecords = dataS.slice(markedIndex, dataLength);
            else
                markedRecords = dataS.slice(markedIndex + 1, dataLength);
            if (markedRecords.length) {
                var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                    parentVal = dataW.parentItem ? dataW.parentItem.WBS : null;
                if (isOutdentMinus && !isReRenderWBSPred)
                    lastVal--;
                else if (isOutdentMinus && isReRenderWBSPred)
                    lastVal = lastVal; // Here we no need to change the last digit of WBS value to update WBS, because it is in updated state
                else
                    lastVal++;
                proxy.reCalculateWBS(markedRecords, lastVal, parentVal);
            }
        },
        
        deleteItem: function () {
            var proxy = this;
            proxy.cancelEditCell();
            proxy._$treegridHelper.ejTreeGrid("deleteRow");
        },

        expandAllItems: function () {
            this.cancelEditCell();
            this._expandAll();
            this.updateSelectedItemIndex();
            this._$treegrid.focus();
        },

        collapseAllItems:function() {
            this._collapseAll();
            this.updateSelectedItemIndex();
            this._$treegrid.focus();
        },
        
          
        indentItem: function () {
            var proxy = this, model = this.model,
                flatRecords = proxy.model.flatRecords,
                ganttRecord = model.selectedItem, indentFlag = true;
            if (model.editSettings.allowIndent == false) {
                return true;
            }

            if (ganttRecord) {
                var recordIndex = flatRecords.indexOf(ganttRecord),
                previousGanttRecord;
                if (recordIndex === 0) {
                    indentFlag = false;
                }
                else {
                    if (ganttRecord.level === 0) {
                        indentFlag = true;
                    }
                    else {
                        previousGanttRecord = flatRecords[recordIndex - 1];
                        if (ganttRecord.level - previousGanttRecord.level === 1) {
                            indentFlag = false;
                        }
                        else {
                            indentFlag = true;
                        }
                    }
                }
            }
            if (indentFlag) {
                this._sendIndentRequest();
            } else {
                return false;
            }
        },

        
        outdentItem:function() {
            this._sendOutdentRequest();
        },
        
        //Updating the Gantt Columns from TreeGrid Columns.
        updateGanttColumns: function (tColumns) {
            var proxy = this,
                model = proxy.model;                
            model.columns = tColumns;
            proxy._columns = tColumns;
        },
        
        cancelEdit:function() {
            this.sendCancelRequest();
        },
        

        
        expandCollapseRecord: function (taskId) {
            var proxy = this, args = {},
                record, model = this.model, expandStatus,
                currentViewIndex, $gridRow, $chartRow;

            record = model.flatRecords[model.ids.indexOf(taskId.toString())];

            if (!ej.isNullOrUndefined(record) && record.hasChildRecords) {
                var args = {};
                args.expanded = record.expanded == true ? false : true;
                expandStatus = proxy.getExpandStatus(record);

                /*If the record is within expanded parent item*/
                if (expandStatus) {
                    args.data = record;
                    if (args.expanded) {
                        proxy.expanding(args);
                    } else {
                        proxy.collapsing(args);
                    }
                }
                /*If the record is within collapsed parent item*/
                else {
                    record.expanded = args.expanded;
                    currentViewIndex = model.currentViewData.indexOf(record);
                    if (currentViewIndex != -1 && !model.enableVirtualization) {
                        $gridRow = $(proxy.getRows()[currentViewIndex]);
                        if (record.expanded) {
                            $gridRow.find(".e-treegridcollapse").removeClass('e-treegridcollapse').addClass('e-treegridexpand');
                            $gridRow.removeClass('e-treegridrowcollapse').addClass('e-treegridrowexpand');
                        } else {
                            $gridRow.find(".e-treegridexpand").removeClass('e-treegridexpand').addClass('e-treegridcollapse');
                            $gridRow.removeClass('e-treegridrowexpand').addClass('e-treegridrowcollapse');
                        }
                    }
                }
            }
        },

        
        saveEdit: function () {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("endEdit");
        },

       // Set the splitter position based on column index.
        setSplitterIndex: function(index)
        {
            var proxy = this,
                model = proxy.model,
                columns = proxy.getColumns(),
                columnWidth = 0,
                treegridContent = $("#ejTreeGrid" + proxy._id + "e-gridcontent"),
                columnIndex = parseInt(index);
            if (columnIndex > -1 && columnIndex < columns.length)
            {
                for (var i = 0; i <= columnIndex; i++)
                    columnWidth += columns[i].width;
                if (columnWidth > proxy._ganttWidth) {
                    columnWidth = 0;
                    for (var i = 0; i <= columnIndex; i++) {
                        if ((columnWidth + columns[i].width) <= proxy._ganttWidth) {
                            columnWidth += columns[i].width;
                            index = i;
                        }
                        else {
                            model.splitterSettings.index = index;
                            break;
                        }
                    }
                }
                else
                    model.splitterSettings.index = columnIndex;
                //Check tree grid side have horizontal scrollbar or not.
                if (treegridContent.ejScroller("isHScroll"))
                    treegridContent.ejScroller("scrollLeft", 0);
                proxy.setSplitterPosition(columnWidth.toString());
            }
        },

        // calculation to find critical path.

        showCriticalPath: function (isShown, isRefreshed) {

            var proxy = this, modelRecordIds = this.model.ids, flatRecords = this.model.flatRecords;
            proxy._$treegridHelper.ejTreeGrid("cancelEditCell"); // Cancel the edit cell, if it is in edit mode.
            // execute if we enable critical path.
            if (isShown == true) {
                this.isCriticalPathEnable = true;

                // execute if the flat records contains task.
                if (flatRecords.length != 0) {

                    var totalPredecessorsCollection = [], individualPredecessorLength, taskid, todate, fromdateID, collection = [], collectionTaskId = [], criticalPathIds = [],
                        checkBeyondEnddate = [], totalPredecessorsCollectionId = [], taskBeyondEnddate = [], updatedRecords = this.model.flatRecords,
                        parentRecords = this.model.parentRecords, predecessorTaskBeyondEnddate = [], just1 = 0, dateDifference = 0,
                         mediater2 = 0, fromDataObject = [], checkEndDate, checkEndDateTaskid;


                    checkEndDate = this.model.parentRecords[0].endDate;

                    if (this.model.parentRecords[0].manualEndDate > this.model.parentRecords[0].endDate && !this.model.parentRecords[0].isAutoSchedule)
                        checkEndDate = this.model.parentRecords[0].manualEndDate;

                    checkEndDateTaskid = this.model.parentRecords[0].taskId;

                    // Find the total project endDate
                    for (var js = 1; js < parentRecords.length; js++) {
                        if (parentRecords[js].endDate >= checkEndDate) {
                            checkEndDate = parentRecords[js].endDate;
                            checkEndDateTaskid = parentRecords[js].taskId;
                        }
                        if (!parentRecords[js].isAutoSchedule) {
                            if (parentRecords[js].manualEndDate >= checkEndDate) {
                                checkEndDate = parentRecords[js].manualEndDate;
                                checkEndDateTaskid = parentRecords[js].taskId;
                            }
                        }
                    }

                    // find the taskes that ends on total project end date that stored in checkBeyondEnddate
                    // find the taskes with predecessor that stored in totalPredecessorsCollectionId.
                    for (var kk = 0; kk < updatedRecords.length; kk++) {
                        updatedRecords[kk].isCritical = false;
                        dateDifference = proxy._getDuration(updatedRecords[kk].endDate, checkEndDate, updatedRecords[kk].durationUnit, updatedRecords[kk].isAutoSchedule);
                        updatedRecords[kk].slack = dateDifference + " " + updatedRecords[kk].durationUnit;
                        if (updatedRecords[kk].endDate >= checkEndDate) {
                            checkBeyondEnddate.push(updatedRecords[kk].taskId);
                        }
                        if (updatedRecords[kk].predecessor) {
                            if (updatedRecords[kk].predecessor.length != 0) {
                                totalPredecessorsCollection.push(updatedRecords[kk]);
                                totalPredecessorsCollectionId.push(updatedRecords[kk].taskId);
                            }
                        }
                    }

                    // seperate the predecessor connected taskes from the individual taskes that ends on total project end date 
                    for (var ss = 0; ss < checkBeyondEnddate.length; ss++) {
                        if (totalPredecessorsCollectionId.indexOf(checkBeyondEnddate[ss]) == -1) {
                            mediater2 = modelRecordIds.indexOf(checkBeyondEnddate[ss].toString());
                            if (flatRecords[mediater2].status < 100)
                                flatRecords[mediater2].isCritical = true;
                            flatRecords[mediater2].slack = 0 + flatRecords[mediater2].durationUnit;
                            taskBeyondEnddate.push(checkBeyondEnddate[ss]);
                        }
                        else
                            predecessorTaskBeyondEnddate.push(checkBeyondEnddate[ss]);
                    }
                    var predecessorLength = totalPredecessorsCollection.length, endTask = [];

                    // find the detail collection of predecessor for each taskes that stored in collection.
                    for (var x = 0; x < predecessorLength; x++) {
                        var to = -1, from = -1, toPredecessor = -1, fromPredecessor = -1, currentIndex = x;
                        individualPredecessorLength = totalPredecessorsCollection[x].predecessor.length,
                         taskid = parseInt(totalPredecessorsCollection[x].taskId);

                        for (var y = 0; y < individualPredecessorLength; y++) {
                            if (totalPredecessorsCollection[x].predecessor[y].from == taskid) {
                                if (to == -1) {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {
                                        to = totalPredecessorsCollection[x].predecessor[y].to;
                                        toPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        to = totalPredecessorsCollection[x].predecessor[y].to + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        toPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                } else {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {

                                        to = to + "," + totalPredecessorsCollection[x].predecessor[y].to;
                                        toPredecessor = toPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        to = to + "," + totalPredecessorsCollection[x].predecessor[y].to + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        toPredecessor = toPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                }
                            }
                            if (totalPredecessorsCollection[x].predecessor[y].to == taskid) {
                                if (from == -1) {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {

                                        from = totalPredecessorsCollection[x].predecessor[y].from;
                                        fromPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {
                                        from = totalPredecessorsCollection[x].predecessor[y].from + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        fromPredecessor = totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                } else {
                                    if (!totalPredecessorsCollection[x].predecessor[y].offset) {
                                        from = from + "," + totalPredecessorsCollection[x].predecessor[y].from;
                                        fromPredecessor = fromPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    } else {

                                        from = from + "," + totalPredecessorsCollection[x].predecessor[y].from + ":" + totalPredecessorsCollection[x].predecessor[y].offset + totalPredecessorsCollection[x].predecessor[y].offsetDurationUnit;
                                        fromPredecessor = fromPredecessor + "," + totalPredecessorsCollection[x].predecessor[y].predecessorsType;
                                    }
                                }
                            }
                        }
                        if (from == -1) {
                            from = null;
                            fromPredecessor = null;
                        }
                        if (to == -1) {
                            to = null;
                            toPredecessor = null;
                        }
                        collection.push({ from: from, fromPredecessor: fromPredecessor, taskid: taskid, to: to, toPredecessor: toPredecessor, currentIndex: currentIndex, slack: null, ff: 0, fs: 0, enddate: null, fsslack: 0 });
                        collectionTaskId.push(parseInt(taskid));
                    }
                    var collectionLength = collection.length, indexenddate = 0, num;

                    // find the predecessors connected taskes that does not contains any successor.
                    for (var z = 0; z < collectionLength; z++) {
                        if (!collection[z].to) {
                            num = collection[z].taskid;
                            indexenddate = modelRecordIds.indexOf(num.toString());
                            dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, checkEndDate, "minute",flatRecords[indexenddate].isAutoSchedule);
                            collection[z].slack = dateDifference;
                            collection[z].fs = -1;
                            collection[z].enddate = flatRecords[indexenddate].endDate;
                            endTask.push({ fromdata: collection[z].from, todateID: collection[z].taskid, fromDataPredecessor: collection[z].fromPredecessor });

                        }
                    }
                    for (var k = 0; k < endTask.length; k++) {
                        fromDataObject.push(endTask[k]);
                        proxy._slackCalculation(fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds);
                    }
                    criticalPathIds = proxy._finalCriticalPath(collection, taskBeyondEnddate, flatRecords, modelRecordIds);
                    this.criticalPathCollection = criticalPathIds;
                    this.detailPredecessorCollection = collection;
                    this.collectionTaskId = collectionTaskId;
                    if (!isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                        proxy._$treegridHelper.ejTreeGrid("refresh");
                    } else if (isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                      //proxy._$treegridHelper.ejTreeGrid("refresh");
                    }
                    proxy._enableDisableCriticalIcon = true;
                }
                else {
                    var criticalPathIds = [], collection = [], collectionTaskId = [];
                    if (!isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                        this._$treegridHelper.ejTreeGrid("refresh");
                    } else if (isRefreshed) {
                        this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                      //proxy._$treegridHelper.ejTreeGrid("refresh");
                    }
                    proxy._enableDisableCriticalIcon = true;
                }
            }

            // execute if we disable critical path
            if (isShown == false) {
                var criticalPathIds = [], collection = [], collectionTaskId = [], distructIndex = 0;
                this.isCriticalPathEnable = false;
                for (var zs = 0; zs < proxy.criticalPathCollection.length ; zs++) {
                    distructIndex = modelRecordIds.indexOf(proxy.criticalPathCollection[zs].toString());
                    flatRecords[distructIndex].isCritical = false;
                }
                if (!isRefreshed) {
                    this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                    this._$ganttchartHelper.ejGanttChart("criticalPathColor", criticalPathIds, isShown, collection, collectionTaskId);
                    this._$treegridHelper.ejTreeGrid("refresh");
                } else if (isRefreshed) {
                    this._$ganttchartHelper.ejGanttChart("criticalDataMapping", criticalPathIds, isShown, collection, collectionTaskId);
                  //proxy._$treegridHelper.ejTreeGrid("refresh");
                }
                proxy._enableDisableCriticalIcon = false;
            }
        },

        // calculation to find critical task ids with the help of slack values.
        _finalCriticalPath: function (collection, taskBeyondEnddate, flatRecords, modelRecordIds) {
            var proxy = this;
            var criticalPathIds = [], index;
            for (var x = 0; x < collection.length; x++) {
                index = modelRecordIds.indexOf(collection[x].taskid.toString());
                if (flatRecords[index].durationUnit == "day") {
                    flatRecords[index].slack = collection[x].slack / 60 / (proxy._secondsPerDay / 3600);
                    if (flatRecords[index].slack % 1 != 0)
                        flatRecords[index].slack = flatRecords[index].slack.toFixed(2) + " day";
                    else
                        flatRecords[index].slack = flatRecords[index].slack + " day";
                }
                else if (flatRecords[index].durationUnit == "hour") {
                    flatRecords[index].slack = collection[x].slack / 60;
                    if (flatRecords[index].slack % 1 != 0)
                        flatRecords[index].slack = flatRecords[index].slack.toFixed(2) + " hour";
                    else
                        flatRecords[index].slack = flatRecords[index].slack + " hour";
                }
                else {
                    flatRecords[index].slack = collection[x].slack + " minutes";
                }
                if ((collection[x].slack <= 0)) {

                    if (flatRecords[index].status < 100) {
                        flatRecords[index].isCritical = true;
                        criticalPathIds.push(collection[x].taskid);
                    }
                }
            }
            criticalPathIds = criticalPathIds.concat(taskBeyondEnddate);
            return criticalPathIds;
        },

        // calculation to find slack values.
        _slackCalculation: function (fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds) {
            var proxy = this, fromDateArray = fromDataObject[0].fromdata.split(","), fromDataPredecessor = fromDataObject[0].fromDataPredecessor.split(","),
                fromDateArray1 = [], fromTaskIdIndex, indexfromtaskid, indexenddate, totaskId, arraylength = fromDateArray.length, prevTaskEnddate, ffslack, mediater, holidayCount, diffInMilliSec, dateDifference, offsetInMillSec;
            for (var xx = 0; xx < arraylength; xx++) {
                fromDateArray1 = fromDateArray[xx].split(":");
                fromTaskIdIndex = collectionTaskId.indexOf(parseInt(fromDateArray1[0]));
                totaskId = collectionTaskId.indexOf(parseInt(fromDataObject[0].todateID));

                // calculate slack value for the task contains predecessor connection in "finish to start".
                if (fromDataPredecessor[xx] == "FS") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                    if (flatRecords[indexfromtaskid].endDate > flatRecords[indexenddate].startDate)
                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].startDate, flatRecords[indexfromtaskid].endDate, "minute",flatRecords[indexfromtaskid].isAutoSchedule));
                    else
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, flatRecords[indexenddate].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                    // execute if the slack value is not set initially.
                    if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {

                        // execute if the offset value is not given.
                        if (fromDateArray1.length <= 1) {
                            if (collection[totaskId].slack + dateDifference < 0) {
                                collection[fromTaskIdIndex].slack = 0;
                            }
                            else {
                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            }
                        }
                            // execute if the offset value is given.
                        else if (fromDateArray1.length > 1) {
                            if (fromDateArray1[1].indexOf("hour") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                            else if (fromDateArray1[1].indexOf("day") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                            else
                                offsetInMillSec = parseInt(fromDateArray1[1]);

                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                            if (collection[fromTaskIdIndex].slack < 0)
                                collection[fromTaskIdIndex].slack = 0;
                        }
                        collection[fromTaskIdIndex].fs = 1;
                        collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                        collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                    }

                        // execute if the current calculated slack value is less than the previous slack value.
                    else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {

                        // execute if the offset value is not given.
                        if (fromDateArray1.length <= 1) {
                            if (collection[totaskId].slack + dateDifference < 0) {
                                collection[fromTaskIdIndex].slack = 0;
                            }
                            else {
                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            }
                        }

                            // execute if the offset value is given.
                        else if (fromDateArray1.length > 1) {

                            if (fromDateArray1[1].indexOf("hour") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                            else if (fromDateArray1[1].indexOf("day") != -1)
                                offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                            else
                                offsetInMillSec = parseInt(fromDateArray1[1]);

                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                            collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                            if (collection[fromTaskIdIndex].slack < 0)
                                collection[fromTaskIdIndex].slack = 0;
                        }
                        collection[fromTaskIdIndex].fs = 1;
                        collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                        collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "start to start".
                if (fromDataPredecessor[xx] == "SS") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());

                    // It execute if the task is in auto mode.
                    if (flatRecords[indexfromtaskid].isAutoSchedule) {
                        indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                        if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].startDate)
                            dateDifference = -(proxy._getDuration(flatRecords[indexenddate].startDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                        else
                            dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // It execute while the slack value is not set to the corresponding task. 
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            if (fromDateArray1.length <= 1) {
                                if (collection[totaskId].slack + dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                }
                            } else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                            //It execute while already the slack value is set and it is higher than the datedifference. 
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            if (fromDateArray1.length <= 1) {
                                if (collection[totaskId].slack + dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                }
                            } else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                    }
                        // It execute if the task is in not an auto mode task.
                    else if (!flatRecords[indexfromtaskid].isAutoSchedule) {
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "finish to finish".
                if (fromDataPredecessor[xx] == "FF") {

                    // execute if the previous task is from finish to start or finish to finish state.
                    if (collection[totaskId].fs == 1 || collection[totaskId].ff == 1 || collection[totaskId].fs == -1) {
                        indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                        indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());

                        if (collection[totaskId].fs == 1) {
                            prevTaskEnddate = flatRecords[indexenddate].endDate;
                            ffslack = collection[totaskId].slack;
                        }
                        else if (collection[totaskId].ff == 1) {
                            prevTaskEnddate = flatRecords[indexenddate].endDate;
                            ffslack = collection[totaskId].slack;
                        }
                        if (collection[totaskId].fs == -1) {
                            prevTaskEnddate = collection[totaskId].enddate;
                            ffslack = collection[totaskId].slack;
                        }
                        if (prevTaskEnddate > flatRecords[indexfromtaskid].endDate)
                            dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].endDate, prevTaskEnddate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                        else
                            dateDifference = proxy._getDuration(prevTaskEnddate, flatRecords[indexfromtaskid].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // set the slack value if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {

                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ffslack - dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = ffslack - dateDifference;
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack - dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].ff = 1;
                            collection[fromTaskIdIndex].enddate = prevTaskEnddate;
                            collection[fromTaskIdIndex].fsslack = ffslack;
                        }
                            // overright the slack value if the current calculated slack value is less than the previous slack value.
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {

                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ffslack - dateDifference < 0) {
                                    collection[fromTaskIdIndex].slack = 0;
                                }
                                else {
                                    collection[fromTaskIdIndex].slack = ffslack - dateDifference;
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {

                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack - dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].ff = 1;
                            collection[fromTaskIdIndex].enddate = prevTaskEnddate;
                            collection[fromTaskIdIndex].fsslack = ffslack;
                        }
                    }
                        // execute if the previous task is from start to start or start to finish state.
                    else {
                        indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                        // execute if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack))
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                else if (collection[fromTaskIdIndex].slack > dateDifference)
                                    collection[fromTaskIdIndex].slack = dateDifference;

                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                        }
                            // execute if the current calculated slack value is less than the previous slack value.
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack))
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                else if (collection[fromTaskIdIndex].slack > dateDifference)
                                    collection[fromTaskIdIndex].slack = dateDifference;
                            }
                                // execute if the offset value is not given.
                            else if (fromDateArray1.length > 1) {
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                        }
                        collection[fromTaskIdIndex].ff = 1;
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }

                //  calculate slack value for the task contains predecessor connection in "start to finish".
                if (fromDataPredecessor[xx] == "SF") {
                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());

                    //It execute if the task is an auto mode task.
                    if (flatRecords[indexfromtaskid].isAutoSchedule) {
                        //execute if the slack value is not set initially.
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            // execute if the offset value is not given.
                            if (fromDateArray1.length <= 1) {
                                // execute if the previous task does no has sucessor. 
                                if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                    collection[fromTaskIdIndex].slack = dateDifference;
                                }
                                    // execute if the previous task has sucessor.
                                else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                    if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].startDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                    if (collection[totaskId].slack + dateDifference < 0) {
                                        collection[fromTaskIdIndex].slack = 0;
                                    }
                                    else {
                                        collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                    }
                                }
                            }
                                // execute if the offset value is given.
                            else if (fromDateArray1.length > 1) {
                                indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].endDate) {
                                    if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].endDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else {
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                }
                                if (fromDateArray1[1].indexOf("hour") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                else if (fromDateArray1[1].indexOf("day") != -1)
                                    offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                else
                                    offsetInMillSec = parseInt(fromDateArray1[1]);

                                collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                if (collection[fromTaskIdIndex].slack < 0)
                                    collection[fromTaskIdIndex].slack = 0;
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                        else {

                            if (fromDateArray1.length <= 1) {
                                if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                    indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                    indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());
                                    if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].startDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);

                                }
                                // execute if the current calculated slack value is less than the previous slack value.
                                if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                                    if (ej.isNullOrUndefined(collection[totaskId].to)) {
                                        collection[fromTaskIdIndex].slack = dateDifference;
                                    } else if (!ej.isNullOrUndefined(collection[totaskId].to)) {
                                        if (collection[totaskId].slack + dateDifference < 0) {
                                            collection[fromTaskIdIndex].slack = 0;
                                        }
                                        else {
                                            collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                        }
                                    }
                                }
                            } else if (fromDateArray1.length > 1) {
                                indexfromtaskid = modelRecordIds.indexOf(fromDateArray1[0].toString());
                                indexenddate = modelRecordIds.indexOf(fromDataObject[0].todateID.toString());

                                if (flatRecords[indexenddate].endDate > flatRecords[indexfromtaskid].endDate) {
                                    if (flatRecords[indexfromtaskid].startDate > flatRecords[indexenddate].endDate)
                                        dateDifference = -(proxy._getDuration(flatRecords[indexenddate].endDate, flatRecords[indexfromtaskid].startDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule));
                                    else
                                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].startDate, flatRecords[indexenddate].endDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                } else {
                                    dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                                }
                                // execute if the current calculated slack value is less than the previous slack value.
                                if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                                    if (fromDateArray1[1].indexOf("hour") != -1)
                                        offsetInMillSec = parseInt(fromDateArray1[1]) * 60;
                                    else if (fromDateArray1[1].indexOf("day") != -1)
                                        offsetInMillSec = parseInt(fromDateArray1[1]) * (proxy._secondsPerDay / 3600) * 60;
                                    else
                                        offsetInMillSec = parseInt(fromDateArray1[1]);

                                    collection[fromTaskIdIndex].slack = collection[totaskId].slack + dateDifference;
                                    collection[fromTaskIdIndex].slack = collection[fromTaskIdIndex].slack - (offsetInMillSec);
                                    if (collection[fromTaskIdIndex].slack < 0)
                                        collection[fromTaskIdIndex].slack = 0;
                                }
                            }
                            collection[fromTaskIdIndex].fs = 1;
                            collection[fromTaskIdIndex].fsslack = collection[fromTaskIdIndex].slack;
                            collection[fromTaskIdIndex].enddate = flatRecords[indexfromtaskid].startDate;
                        }
                    }
                        //It execute if the task is an auto mode task.
                    else if (!flatRecords[indexfromtaskid].isAutoSchedule) {
                        dateDifference = proxy._getDuration(flatRecords[indexfromtaskid].endDate, checkEndDate, "minute", flatRecords[indexfromtaskid].isAutoSchedule);
                        if (ej.isNullOrUndefined(collection[fromTaskIdIndex].slack)) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                        else if (collection[fromTaskIdIndex].slack > dateDifference && collection[fromTaskIdIndex].slack != 0) {
                            collection[fromTaskIdIndex].slack = dateDifference;
                        }
                    }
                    if (flatRecords[indexfromtaskid].endDate >= checkEndDate && flatRecords[indexfromtaskid].endDate <= checkEndDate) {
                        collection[fromTaskIdIndex].slack = 0;
                    }
                }
                if (collection[fromTaskIdIndex].from)
                    fromDataObject.push({ fromdata: collection[fromTaskIdIndex].from, todateID: collection[fromTaskIdIndex].taskid, fromDataPredecessor: collection[fromTaskIdIndex].fromPredecessor });
            }
            if (fromDataObject) {
                fromDataObject.splice(0, 1);
                if (fromDataObject.length > 0)
                    proxy._slackCalculation(fromDataObject, collection, collectionTaskId, checkEndDate, flatRecords, modelRecordIds);
            }
        },

        setSplitterPosition: function(width)
        {
            var proxy = this,
                model = proxy.model,
                leftPaneSize = 0,
                rightPaneSize = 0,
                splitter,
                ganttWidth = parseInt(proxy._ganttWidth) - proxy._totalBorderWidth,
                isPercentage = false;
            if (!ej.isNullOrUndefined(width)) {
                if (width.indexOf("%") != -1){
                    leftPaneSize = parseInt(width);
                    isPercentage = true;
                }
                else
                {
                    leftPaneSize = parseInt(width) / proxy._ganttWidth * 100;
                    isPercentage = false;
                }
                leftPaneSize = isNaN(leftPaneSize) ? 0 : leftPaneSize;
                
                //Check the grid width is less than or equal to 100% of gantt width.
                if (leftPaneSize <= 100)
                {
                    leftPaneSize = leftPaneSize < 0 ? 0 : leftPaneSize;
                    //Here 9 is the splitter span width
                    rightPaneSize = 100 - leftPaneSize - (9 / ganttWidth * 100);
                    // Check the right pane size is less than or equal to 0.
                    // if it is less than 0 mean adjust rightpane size is 0 and left pane size is 100
                    if (rightPaneSize <= 0)
                    {
                        if (isPercentage)
                            proxy.splitterPosition("100%");
                        else
                            proxy.splitterPosition(ganttWidth.toString());
                        leftPaneSize = 100 - (9 / ganttWidth * 100);
                        rightPaneSize = 0;
                    }
                    else if (rightPaneSize > 0) {
                        if (isPercentage)
                            proxy.splitterPosition(Math.round(leftPaneSize) + "%");
                        else
                            proxy.splitterPosition(Math.round((leftPaneSize * proxy._ganttWidth / 100)).toString());
                    }
                    splitter = $("#e-ejSpliter" + proxy._id).ejSplitter("instance");
                    // Set left and right pane size to ejSplitter
                    splitter.model.properties[0].paneSize = leftPaneSize+"%";
                    splitter.model.properties[1].paneSize = rightPaneSize + "%";
                    splitter.refresh();
                    proxy._$treegridHelper.ejTreeGrid("refreshScroller", Math.round((leftPaneSize * ganttWidth) / 100));
                    var secondSplitterSize = parseFloat(splitter.model.properties[1].paneSize) > 0 ? splitter.model.properties[1].paneSize - 1 : 0;
                    proxy._$ganttchartHelper.ejGanttChart("refreshScroller", secondSplitterSize);
                    proxy._clearContextMenu();
                }
                else
                {
                    splitter = $("#e-ejSpliter" + proxy._id).ejSplitter("instance");
                    leftPaneSize = splitter.model.properties[0].paneSize;
                    rightPaneSize = splitter.model.properties[1].paneSize;
                    if (parseInt(rightPaneSize) == 0)
                    {
                        if (isPercentage)
                            proxy.splitterPosition("100%");
                        else
                            proxy.splitterPosition(ganttWidth.toString());
                    }
                    else
                    {
                        if (isPercentage)
                            proxy.splitterPosition(Math.round((parseInt(leftPaneSize) / ganttWidth * 100)) + "%");
                        else
                            proxy.splitterPosition((leftPaneSize).toString());
                    }

                }
                proxy._splitterPosition(proxy.splitterPosition());
            }
        },

        _showTooltip: function (boolValue) {
            var proxy = this;
            this.model.enableTaskbarTooltip = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("showTooltip", boolValue);
        },

        _showEditingTooltip: function (boolValue) {
            var proxy = this;
            this.model.enableTaskbarDragTooltip = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("showEditingTooltip", boolValue);
        },
        
        _ganttChartEditing:function(boolValue) {
            var proxy = this;
            proxy.model.allowGanttChartEditing = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("ganttChartEditing", boolValue);
            //Dynamically updated the cursor styles.
            if (!boolValue) {                
                $(".e-gantt-childtaskbar, .e-tasklabel, .progressbar, .taskbarresizer-right, .taskbarresizer-left").css({ cursor: "auto" });
            }
            else {
                $(".e-gantt-childtaskbar, .e-tasklabel, .progressbar").css({ cursor: "move" });
                $(".taskbarresizer-right").css({ cursor: "w-resize" });
                $(".taskbarresizer-left").css({ cursor: "e-resize" });
            }
        },
        
        _resizeProgressbar: function (boolValue) {
            var proxy = this;
            proxy.model.enableProgressBarResizing = boolValue;
            proxy._$ganttchartHelper.ejGanttChart("resizeProgressbar", boolValue);

        },

        _milestoneTemplate: function (value) {
            var proxy = this;
            proxy.model.milestoneTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeMilestoneTemplate", proxy.model.milestoneTemplate);
        },

        _taskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.taskbarTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeTaskbarTemplate", proxy.model.taskbarTemplate);
        },

        _parentTaskbarTemplate: function (value) {
            var proxy = this;
            proxy.model.parentTaskbarTemplate = value;
            proxy._$ganttchartHelper.ejGanttChart("changeParentTaskbarTemplate", proxy.model.parentTaskbarTemplate);
        },
        _sendSortingRequest: function(sortSettings) {
            var proxy = this;
            proxy.model.sortSettings = sortSettings;
            proxy._$treegridHelper.ejTreeGrid("option", "sortSettings", sortSettings);
        },
        
        _sortingRequest: function (boolValue) {
            var proxy = this, model = proxy.model, sorting;
            model.allowSorting = boolValue;
            if (!model.allowSorting)
                model.sortSettings.sortedColumns = [];
            proxy._$treegridHelper.ejTreeGrid("sortSetting", boolValue);
        },
        _columnIndex: function (value) {
            var proxy = this;
            proxy._$treegridHelper.ejTreeGrid("columnIndex", value);
        },
        sendCancelRequest: function () {
            var proxy = this,
                toolbar = $("#" + proxy._id + "_toolbarItems");
            proxy._$treegridHelper.ejTreeGrid("cancelEditCell");

            if (proxy.model.toolbarSettings.toolbarItems.indexOf("cancel") !== -1) {
                proxy._disabledToolItems.push($(toolbar).find(".e-cancel").parent()[0]);
            }

            if (proxy.model.toolbarSettings.toolbarItems.indexOf("save") !== -1) {
                proxy._disabledToolItems.push($(toolbar).find(".e-saveitem").parent()[0]);
            }

            $(toolbar).ejToolbar('disableItem', proxy._disabledToolItems);
            proxy._disabledToolItems = [];
        },
        
        _sendAddRequest: function () {
            
            var proxy = this,                
                columns = proxy._columns,
                length = columns.length,
                columnCount = 0,
                cloneData = {},
                fieldData = {},
                args = {};
            proxy._isinAddnewRecord = true;
            
            for (columnCount; columnCount < length; columnCount++)
                columns[columnCount].mappingName && (cloneData[columns[columnCount].mappingName] = "");

            args.data = cloneData;
            args.requestType = "add";
            proxy.renderedEditDialog(args);
        },

        _sendEditRequest: function ($tr) {
            var proxy = this,
                model = proxy.model,
                args={},
                data;
            
            if (ej.isNullOrUndefined($tr)) {
                proxy._currentTrIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell;
                proxy._$currentTr = $(proxy._$treegridHelper.ejTreeGrid("getRows")).eq(this.selectedRowIndex());
            } else {
                proxy._currentTrIndex = $tr.index();
                proxy._$currentTr = $tr;
            }
            data = proxy.getUpdatedRecords()[proxy._currentTrIndex];

            args.data = data;
            args.requestType = "beginedit";
            if (args.data)
                proxy.renderedEditDialog(args);
        },
        _updateAddData: function (obj, rowPosition)
        {
            var proxy = this, model = this.model, id, startDate;
           
            if (!obj[model.taskIdMapping])
            {                
                id = proxy._getNewTaskId();
                obj[model.taskIdMapping] = id;
            }

            if (model.taskNameMapping && !obj[model.taskNameMapping]) {
                obj[model.taskNameMapping] = proxy._newTaskTexts["newTaskName"] + " " + obj[model.taskIdMapping];
            }

            if (!obj[model.startDateMapping]) {
                obj[model.startDateMapping] = model.scheduleStartDate;
            }

            if (model.durationMapping && ej.isNullOrUndefined(obj[model.durationMapping])) {
                if (!obj[model.endDateMapping])
                    obj[model.durationMapping] = "5";
            }
            if (model.progressMapping) {
                obj[model.progressMapping] = obj[model.progressMapping] ? (obj[model.progressMapping] > 100 ? 100 : obj[model.progressMapping]) : 0;
            }

            if (!obj[model.endDateMapping] && model.endDateMapping) {

                if (!obj[model.durationMapping]) {
                    var startDate = proxy._getDateFromFormat(model.scheduleStartDate);
                    startDate.setDate(startDate.getDate() + 4);
                    obj[model.endDateMapping] = ej.format(startDate, this.model.dateFormat, this.model.locale);
                }
            }
            if (model.enableWBS && !obj["WBS"]) {
                obj["WBS"] = proxy._getNewWBSid(rowPosition);
            }
             if(model.enableWBS && !obj["WBS"])
            {
                obj["WBS"] = proxy._getNewWBSid(rowPosition);
             }
             if (!ej.isNullOrUndefined(model.selectedItem)) {
                 obj["taskType"] = model.workMapping ? ej.Gantt.TaskType.FixedWork : model.selectedItem.taskType;
                 obj["effortDriven"] = model.workMapping ? "true" : model.selectedItem.effortDriven;
             }
        },
        _sendSaveRequest: function (saveType) {
            var obj = {},
                doc = document,
                proxy = this,
                model = proxy.model,
                index = 0,
                formelement,
                length,
                editedRowWrap,
                columnName,
                $element,
                startdate,
                enddate,
                column,
                value, dialogId, treeGridId, resourceGridId, customGridId, noteRteId,
                args = {},
                generalColumns, generalColumnsLength, customColumns, customColumnsLength;
            this._duplicate = false;
            this._wrongenddate = false;
            if (saveType === "Add")
            {
                formelement = doc.querySelectorAll("#" + proxy._id + "GeneralAddForm", "#" + proxy._id + "PredecessorAddForm", "#" + proxy._id + "ReosurceAddForm", "#" + proxy._id + "CustomFieldsAddForm");
                length = formelement && formelement.length;
                dialogId = "Add";
                treeGridId = "#treegrid" + proxy._id + "predecessorAdd";
                resourceGridId = "#treegrid" + proxy._id + "resourceAdd";
                customGridId = "#treegrid" + proxy._id + "customFieldAdd";
                noteRteId = "#" + proxy._id + "AddAreaNotes";
                $element = $("#" + proxy._id + "taskId" + dialogId);             
                column = ej.TreeGrid.getColumnByField(proxy._columns, "taskId");
                proxy._cellEditColumn = column;
                generalColumns = proxy._addDialogGeneralColumns;
                generalColumnsLength = generalColumns.length;
                customColumns = proxy._addDialogCustomColumns;
                customColumnsLength = customColumns.length;
                if (column && $element.length>0)
                    value = proxy.getCurrentEditCellData($element, column.dropdownData);

                if (proxy.model.ids.indexOf(value) != -1 && value)
                    this._duplicate = true;
                else if (value) {
                    this._duplicate = false;
                }

                if (!this.addFormValidate())
                    return true;
            }
            else
            {
                formelement = doc.getElementById(proxy._id + "GeneralEditForm");
                length = formelement && formelement.length;
                treeGridId = "#treegrid" + proxy._id + "predecessorEdit";
                resourceGridId = "#treegrid" + proxy._id + "resourceEdit";
                customGridId = "#treegrid" + proxy._id + "customFieldEdit";
                noteRteId = "#" + proxy._id + "EditAreaNotes";
                dialogId = "Edit";
                generalColumns = proxy._editDialogGeneralColumns;
                generalColumnsLength = generalColumns.length;
                customColumns = proxy._editDialogCustomColumns;
                customColumnsLength = customColumns.length;

                if (!this.editFormValidate())
                    return true;
            }
            editedRowWrap = $(formelement).closest('div');                    
                      
            if (!this._duplicate) {


                for (var count = 0; count < generalColumnsLength; count++) {
                    $element = $(formelement).find("#" + proxy._id + generalColumns[count].field + dialogId);
                    if ($element.length > 0) {
                        proxy._cellEditColumn = generalColumns[count];
                        if (proxy._cellEditColumn.field == "duration" || proxy._cellEditColumn.field == "startDate" || proxy._cellEditColumn.field == "endDate") {
                            obj[generalColumns[count].mappingName] = this._editedDialogRecord[proxy._cellEditColumn.field];
                            if (proxy._cellEditColumn.field == "duration" && model.durationUnitMapping) {
                                obj[model.durationUnitMapping] = this._editedDialogRecord.durationUnit;
                            }
                            continue;
                        }
                        value = proxy.getCurrentEditCellData($element, generalColumns[count].dropdownData); // formelement[index].value;
                        if (proxy._isinAddnewRecord === false && generalColumns[count].mappingName === proxy.model.predecessorMapping) {
                            args.previousValue = proxy._updatePredecessorValue(null, value);
                        }
                        /*Validate progress value is null or undefined*/
                        if (generalColumns[count].mappingName === proxy.model.progressMapping && ej.isNullOrUndefined(value))
                            value = 0;
                        if ((!model.workMapping && proxy._cellEditColumn.field == "work") || proxy._cellEditColumn.field == "taskType" || proxy._cellEditColumn.field == "effortDriven")
                            obj[generalColumns[count].field] = value;
                        else
                            obj[generalColumns[count].mappingName] = value;
                    }
                }

                // Get the custom column values from custom column table.
                if ($(customGridId).length) {
                    /* save tree grid if it is in edit mode */
                    if ($(customGridId).ejTreeGrid("model.isEdit")) {
                        $(customGridId).ejTreeGrid("saveCell");
                    }
                    var data = $(customGridId).ejTreeGrid("model.updatedRecords");
                    for (var count = 0; count < customColumnsLength; count++) {
                        if (customColumns[count].editType == "dropdownedit")
                            obj[customColumns[count].mappingName] = data[count].value;
                        else
                            obj[customColumns[count].mappingName] = data[count].text;
                    }
                }
                // Adding notes value to newly added task.
                var noteRte = $(noteRteId);
                if (noteRte.length) {
                    var noteobj=$(noteRteId).data("ejRTE");
                    if (ej.isNullOrUndefined(noteobj))
                        $(noteRteId).ejRTE({});
                    obj[model.notesMapping] = noteRte.ejRTE("getHtml");
                }

                var date1 = proxy._getDateFromFormat(obj[model.startDateMapping]),
                date2 = proxy._getDateFromFormat(obj[model.endDateMapping]);
                var diffdays=0;
                if (date1 && date2)
                    diffdays = date2.getTime() - date1.getTime();
                if (diffdays < 0)
                    this._wrongenddate = true;
                else
                    this._wrongenddate = false;
                if (!this._wrongenddate) {
                    // when adding new task resource value changes.
                    var resourceGrid = $(resourceGridId), resourceFlag = true;
                    if (resourceGrid.length > 0) {
                        /* save tree grid if it is in edit mode */
                        if ($(resourceGrid).ejTreeGrid("model.isEdit")) {
                            $(resourceGrid).ejTreeGrid("saveCell");
                        }
                        var resource = [];
                        var data = $(resourceGridId).ejTreeGrid("option", "dataSource"),
                            selectedRowIndex = $(resourceGridId).ejTreeGrid("option", "selectedRowIndex"),
                            newResource,
                            ganttRecord = proxy._editedDialogRecord,
                            resourceInfo = [],
                            resourceIdMapping = model.resourceIdMapping;
                        if (saveType != "Add") {
                            if (ej.isNullOrUndefined(model.selectedItem.resourceInfo))
                                model.selectedItem.resourceInfo = [];
                            $.extend(true, resourceInfo, model.selectedItem.resourceInfo);
                        }
                        $.each(data, function (indx, value) {
                            if (value.name !== null && value.name !== "") {

                                for (var rCount = 0; rCount < model.resources.length; rCount++) {
                                    if (model.resources[rCount][model.resourceIdMapping].toString() == value.name) {
                                        newResource = $.extend({}, model.resources[rCount]);
                                        break;
                                    }
                                } 
                                if (saveType === "Add") {
                                    resource.push(newResource[model.resourceIdMapping]);
                                    newResource[model.resourceUnitMapping] = value.unit;
                                    proxy._newRecordResourceCollection.push(newResource);
                                }
                                    //update duration, work, resource units of a task, while add/remove/changes in existing resource unit.
                                else {

                                    if (ej.isNullOrUndefined(resourceInfo) || resourceInfo.length != data.length)
                                        proxy._isResourceAddedOrRemoved = true;

                                    if (resourceInfo.length > 0) {
                                        for (var index = 0; index < resourceInfo.length; index++) {
                                            if (resourceInfo[index][resourceIdMapping] === newResource[resourceIdMapping]) {
                                                var resourceIndex = index;
                                                break;
                                            }
                                            else
                                                var resourceIndex = -1;
                                        }
                                    }
                                    if ((ej.isNullOrUndefined(resourceIndex) || resourceIndex == -1) &&  resourceInfo.length != data.length) {
                                        var ganttRecordResource = $.extend({}, newResource);
                                        ganttRecord._updateResourceUnit(newResource, ganttRecordResource, model.resourceUnitMapping);
                                        //Unit for newly selected resource should be 100, even there is a defined unit for the selected resource.
                                        ganttRecordResource[model.resourceUnitMapping] = 100;
                                        resourceInfo.push(ganttRecordResource);                                        
                                    }
                                    if (resourceInfo[indx] && resourceInfo[indx][model.resourceUnitMapping] != data[indx].unit)
                                        proxy._isExistingUnitIsUpdated = true;
                                    var editedResource = model.resources.filter(function (item) {
                                        return item && item[model.resourceIdMapping] == parseInt(data[indx].name);
                                    });
                                    resourceInfo[indx] = $.extend({},editedResource[0]);                                    
                                    resourceInfo[indx][model.resourceUnitMapping] = data[indx].unit;
                                    resource.push(resourceInfo[indx]);

                                    //update duration as per changes in existing resources unit before adding new resources.
                                    if (proxy._isExistingUnitIsUpdated) {
                                        if (!ganttRecord.isAutoSchedule || ganttRecord.taskType == "fixedDuration")
                                            ganttRecord._updateWorkWithDuration(proxy, resourceInfo);
                                        else
                                            ganttRecord._updateDurationWithWork(proxy, resourceInfo);
                                        obj.Duration = ganttRecord.duration;
                                        if (model.workMapping)
                                            obj[model.workMapping] = ganttRecord.work;
                                        else
                                            obj.work = ganttRecord.work;
                                        proxy._editedDialogRecord.duration = ganttRecord.duration;
                                        proxy._editedDialogRecord.work = ganttRecord.work;
                                        proxy._isExistingUnitIsUpdated = false;
                                    }
                                }
                            }
                            else {
                                resourceFlag = false;
                                return false;
                            }
                        });
                        if (resourceFlag)
                            obj[model.resourceInfoMapping] = resource;
                        else {
                            alert(proxy._alertTexts["dialogResourceAlert"]);
                            return true;
                        }
                }

                if (!obj[model.taskIdMapping] && saveType === "Edit")
                    obj[model.taskIdMapping] = proxy._editedDialogRecord.taskId;

                args.data = obj;

                //getting predecessor from edit dialog table    
                var prdecessor_validation_flag = false;
                var results = [], resultFlag = false;
                if (model.predecessorMapping)
                {
                    if (saveType === "Edit") {
                        resultFlag = model.editDialogFields.length === 0 ? true : false;
                        results = $.grep(model.editDialogFields, function (val, idx) {
                            return (val.field === model.predecessorMapping);
                        });
                    } else if (saveType === "Add")
                    {
                        resultFlag = model.addDialogFields.length === 0 ? true : false;
                        results = $.grep(model.addDialogFields, function (val, idx) {
                            return (val.field === model.predecessorMapping);
                        });
                    }
                }
                if (results.length > 0 || resultFlag)
                {
                    var pre = [];
                    var taskNameFlag = true;

                    /* save tree grid if it is in edit mode */
                    if ($(treeGridId).ejTreeGrid("model.isEdit")) {
                        $(treeGridId).ejTreeGrid("saveCell");
                    }

                    pre = $(treeGridId).ejTreeGrid("option", "dataSource");
                    $.each(pre, function (idx, value) {
                        if (ej.isNullOrUndefined(value.id) || ej.isNullOrUndefined(value.name) || ej.isNullOrUndefined(value.type) || !(value.id.length > 0 && value.name.length && value.type.length))
                        {
                            taskNameFlag = false;
                        }
                    });
                    if (taskNameFlag) {
                        var predecessorColl = [], predecessorString = [],//from,to,offset,predecessorType,isdrawn                        
                        types = proxy._predecessorCollectionText;
                        var tempType;
                        for (var i = 0; i < pre.length; i++) {
                            var predecessor = {};
                            predecessor["from"] = obj.taskID;
                            predecessor["to"] = pre[i].id;
                            predecessor["isdrawn"] = false;
                            predecessor["offset"] = pre[i].offset;
                            for (var j = 0; j < types.length; j++) {
                                if (pre[i].type == types[j].text) {
                                    predecessor["predecessorType"] = types[j].id;
                                    tempType = types[j].id;
                                    break;
                                }
                            }
                            var tem = pre[i].id + tempType//+data[i].lags.toString();
                            pre[i].offset = parseFloat(pre[i].offset);
                            if (pre[i].offset !== 0) {
                                if (pre[i].offset < 0)
                                    tem += pre[i].offset.toString();
                                else
                                    tem += "+" + pre[i].offset.toString();
                            }
                            predecessorString.push(tem);
                            predecessorColl.push(predecessor);
                        }
                        args.predecessorString = predecessorString;
                    } else {
                        //Break here and give notification to users
                        alert(proxy._alertTexts["predecessorAddingValidationAlert"]);
                        return true;
                    }
                    //Validate predecessoe for editing
                    if (proxy._isinAddnewRecord === false) {
                        args.currentRecord = model.selectionMode == "row" ? this.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                        if(proxy._editedPredecessorValidation(args))
                        {
                            args.previousValue = proxy._updatePredecessorValue(null, predecessorString.join(','));
                        }
                        else {
                            alert(proxy._alertTexts["predecessorEditingValidationAlert"]);
                            return true;
                        }
                    }
                    obj[model.predecessorMapping] = predecessorString.join(',');
                }

                args.requestType = ej.TreeGrid.Actions.Save;
                args.recordIndex = (this.selectedRowIndex() !== -1) ? this.selectedRowIndex() : -1;
                if (proxy._trigger("actionBegin", args))
                    return true;
                if (saveType === "Edit") {
                    args._cModifiedData = proxy._updateRecord(obj);
                    if (proxy._editedDialogRecord) {
                        args._cModifiedData.startDate = new Date(proxy._editedDialogRecord.startDate);
                        args._cModifiedData.endDate = new Date(proxy._editedDialogRecord.endDate);
                        args._cModifiedData.duration = proxy._editedDialogRecord.duration;                        
                        args._cModifiedData.durationUnit = proxy._editedDialogRecord.durationUnit;
                        args._cModifiedData.work = proxy._editedDialogRecord.work;
                        if (model.workMapping)
                            args._cModifiedData.item[model.workMapping] = proxy._editedDialogRecord.work;
                        if (proxy._isResourceAddedOrRemoved)
                            proxy._updateResourceRelatedFields(args._cModifiedData);
                        model.durationUnitMapping && (args._cModifiedData.item[model.durationUnitMapping] = proxy._editedDialogRecord.durationUnit);
                        proxy._editedDialogRecord = null;
                    }
                    if (args.data[model.endDateMapping] && (ej.isNullOrUndefined(args.data[model.durationMapping]) || args.data[model.durationMapping] === "") && proxy._isDurationUpdated == false) {
                        args._cModifiedData.startDate = proxy._checkStartDate(args._cModifiedData.startDate, args._cModifiedData);
                        args._cModifiedData.endDate = proxy._checkEndDate(args._cModifiedData.endDate, args._cModifiedData);
                        args._cModifiedData._calculateDuration(this);
                    }
                    /*Milestone status update if start date,end date , duration fields not given in edit dialog fields*/
                    if (args._cModifiedData.duration == 0 && args._cModifiedData.startDate.getTime() == args._cModifiedData.endDate.getTime())
                        args._cModifiedData.isMilestone = true;
                    else
                        args._cModifiedData.isMilestone = false;
                    if (args.data[model.baselineStartDateMapping] && args.data[model.baselineEndDateMapping])
                    {
                        var baseLineStartDate = proxy._getDateFromFormat(args.data[model.baselineStartDateMapping]),
                            baseLineEndDate = proxy._getDateFromFormat(args.data[model.baselineEndDateMapping]);
                        if (baseLineEndDate && baseLineEndDate.getHours() == 0 && this._defaultEndTime != 86400)
                            this._setTime(this._defaultEndTime, baseLineEndDate);
                        args._cModifiedData.baselineStartDate = this._checkBaseLineStartDate(baseLineStartDate);
                        args._cModifiedData.baselineEndDate = this._checkBaseLineEndDate(baseLineEndDate);
                        args._cModifiedData.baselineLeft = args._cModifiedData._calculateBaselineLeft(this);
                        args._cModifiedData.baselineRight = args._cModifiedData._calculateBaselineRight(this);
                        args._cModifiedData.baselineWidth = args._cModifiedData._calculateBaseLineWidth(this);
                    }
                    args.modifiedRecord = args._cModifiedData;                    
                    proxy.actionComplete(args);
                }
                else if (saveType === "Add") {
                    var rowPosition = proxy._addPosition != null ? proxy._addPosition : model.editSettings.rowPosition;
                    if (!proxy.addRecord(obj, rowPosition)) {
                        alert(proxy._alertTexts["predecessorEditingValidationAlert"]);
                        return true;
                    }                 
                }  
                proxy._cModifiedData = null;
                proxy._cAddedRecord = null;
                proxy._primaryKeyValues = [];
                proxy._isinAddnewRecord = false;
                proxy._isResourceAddedOrRemoved = false;
                return false;
                }
                else {
                    alert(proxy._alertTexts["dateValidationAlert"]);
                    return true;
                }
            }
            else {
                alert(proxy._alertTexts["idValidationAlert"]);
                return true;
            }   
        },

        _recordReturnerByID:function(id)
        {
            var proxy = this,
                records = proxy.model.flatRecords;
            for (var i = 0; i < records.length; i++) {
                if (records[i].taskId.toString() === id.toString()) {
                    return records[i]
                }
            }
            return null;

        },
        _editedPredecessorValidation: function (args) {

            var proxy = this,
                flag = true,
                recordId = args.currentRecord.taskId, currentId,
                predecessor = args.predecessorString.join(','), predecessorIdArray;
            if (predecessor.length > 0) {
                predecessorIdArray = proxy._idFromPredecessor(predecessor);
                for (var count = 0; count < predecessorIdArray.length; count++) {
                    //Check edited item has parent item in predecessor collection
                    var editingData = args.currentRecord;
                    if (editingData && editingData.parentItem) {
                        if (predecessorIdArray.indexOf(editingData.parentItem.taskId.toString()) !== -1) {
                            return false;
                        }
                    }
                    // Check if predecessor exist more then one 
                    var tempIdArray = predecessorIdArray.slice(0),checkArray=[],countFlag=true;
                    $.each(tempIdArray, function (index, value) { 
                        if(checkArray.indexOf(value)===-1)
                            checkArray.push(value);
                        else
                            countFlag = false;
                    });
                    if (countFlag === false) {
                        return false;

                    }
                    //Cyclick check  
                    currentId = predecessorIdArray[count];
                    var visitedIdArray = [];
                    var predecessorCollection = predecessorIdArray.slice(0);
                    predecessorCollection.splice(count, 1);


                    while (currentId !== null) {
                        var currentIdArray = [], currentIdIndex,
                            currentRecord;
                        if (visitedIdArray.indexOf(currentId) === -1)
                        {
                            currentRecord = proxy._recordReturnerByID(currentId);
                            //Predecessor id not in records collection
                            if (ej.isNullOrUndefined(currentRecord))
                                return false;
                          //  var currentPredecessor="";
                            if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length>0)
                            {
                                $.each(currentRecord.predecessor, function (index, value) {
                                    if (currentRecord.taskId.toString() !== value.from) {
                                        currentIdArray.push(value.from.toString());
                                        currentIdIndex = index;
                                    }
                                });
                            //    currentPredecessor=currentRecord.predecessor[0].from
                            }
                            if (recordId.toString() === currentRecord.taskId.toString() || currentIdArray.indexOf(recordId.toString()) !== -1) { // || predecessorCollection.indexOf(currentPredecessor) !== -1
                                //cycylic occurs//break;
                                return false;
                            }
                            visitedIdArray.push(currentId);
                            if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                                var result;
                                if (currentIdArray.length > 1) {
                                    result=this._predecessorValidation(currentIdArray, args);
                                }
                                else if (currentIdArray.length == 1)
                                    currentId = currentRecord.predecessor[currentIdIndex].from;

                                if (result === false) {
                                    return false;
                                }
                            }
                            else
                                break;
                        }
                        else
                        {
                            break;
                        }
                    }
                }
            }
            return flag;
        },

        _predecessorValidation: function (predecessor,args) {
            var proxy = this;
            var recordId = args.currentRecord.taskId, currentId, currentRecord;
            for (var count = 0; count < predecessor.length; count++) {
                currentId = predecessor[count];
                var visitedIdArray = [];
                var predecessorCollection = predecessor.slice(0);
                predecessorCollection.splice(count, 1);

                while (currentId !== null) {
                    var currentIdArray = [];
                    if (visitedIdArray.indexOf(currentId) === -1) {
                        currentRecord = proxy._recordReturnerByID(currentId);
                        //Predecessor id not in records collection
                        if (ej.isNullOrUndefined(currentRecord))
                            return false;

                        if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                            $.each(currentRecord.predecessor, function (index, value) {
                                if (currentRecord.taskId.toString() !== value.from)
                                    currentIdArray.push(value.from.toString());
                            });
                        }
                        if (recordId.toString() === currentRecord.taskId.toString() || currentIdArray.indexOf(recordId.toString()) !== -1) { // || predecessorCollection.indexOf(currentPredecessor) !== -1
                            //cycylic occurs//break;
                            return false;
                        }
                        visitedIdArray.push(currentId);
                        if (!ej.isNullOrUndefined(currentRecord.predecessor) && currentRecord.predecessor.length > 0) {
                            currentId = currentRecord.predecessor[0].from;
                        }
                        else
                            break;
                    }
                    else {
                        break;
                    }
                }
            }
            return true;
            
        },
        _sendCancelRequest: function () {
            var proxy = this,
                model=proxy.model,
                args = {};

            if (model.dateFormat.toLowerCase().indexOf("hh") != -1)
                $("#" + proxy._id + "EditForm").find(".e-datepicker").ejDateTimePicker("destroy");
            else
                $("#" + proxy._id + "EditForm").find(".e-datepicker").ejDatePicker("destroy");

            args.requestType = ej.TreeGrid.Actions.Cancel;
            proxy._$treegridHelper.ejTreeGrid("processBindings", args);
            proxy._primaryKeyValues = [];
            proxy.model.currentData = null;
        },
        //obj contains gantt record
        _updatePredecessorValue: function (obj, value) {
            var proxy = this,
                prevPredecessors,
                model = this.model,
                modifiedPredecessors,
                length=0,
                predecessor,
                ganttPredecessor = [],
                count = 0,
                selectedItem = !ej.isNullOrUndefined(obj) ? obj : model.selectionMode == "row" ? proxy.selectedItem() : model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
            prevPredecessors = selectedItem["predecessor"];

            if (value.length > 0) {
                modifiedPredecessors = selectedItem._calculatePredecessor(value, this._durationUnitEditText, this.model.durationUnit, proxy);
            }
            if (modifiedPredecessors)
                length = modifiedPredecessors.length;

            var index = 0, prevPrdecessorlength=0;
            if(prevPredecessors)
                prevPrdecessorlength = prevPredecessors.length;


            for (index = 0; index < prevPrdecessorlength; index++) {
                predecessor = prevPredecessors[index];
                if (predecessor.from === selectedItem.taskId.toString()) {
                    ganttPredecessor.push(predecessor);
                }
            }
            for (count = 0; count < length; count++) {
                ganttPredecessor.push(modifiedPredecessors[count]);
            }
            selectedItem.predecessor = ganttPredecessor;
            if (proxy.model.predecessorMapping) {
                selectedItem.item[proxy.model.predecessorMapping] = value;
                selectedItem.predecessorsName = value;
            }

            return prevPredecessors;          //
        },


        getCurrentEditCellData: function ($element, dropdownData) {
            var proxy = this, model = proxy.model, date;
            if ($("#" + proxy._id + "EditForm").length || $("#" + proxy._id + "GeneralAddForm").length || $("#" + proxy._id + "GeneralEditForm").length) {
                var cellValue="";// $element = $("#" + proxy._id + proxy._columnFieldName), 
                switch (proxy._cellEditColumn.editType) {
                    case ej.TreeGrid.EditingType.String:
                        cellValue = $element.val();
                        break;
                    case ej.TreeGrid.EditingType.Numeric:
                        cellValue = $element.ejNumericTextbox("getValue");
                        break;
                    case ej.TreeGrid.EditingType.Dropdown:
                        if ($element.attr("id").indexOf("resourceInfo") > 0) {
                            cellValue = proxy._getSelectedItem($element.ejDropDownList("model.selectedItems"), dropdownData);
                        }
                        else if ($element.attr("id").indexOf("taskMode") > 0) {
                            cellValue = $element.ejDropDownList("model.value") == "true" ? true : false;
                        }
                        else
                            cellValue = $element.ejDropDownList("model.value");
                        break;
                    case ej.TreeGrid.EditingType.Boolean:
                        cellValue = $element.is(':checked');
                        break;

                    case ej.TreeGrid.EditingType.DatePicker:
                        date = $element.ejDatePicker("model.value");

                        if (proxy._cellEditColumn && !proxy._cellEditColumn.format) {
                            cellValue = proxy.getFormatedDate(date);
                        } else {
                            cellValue = date;
                        }
                        break;
                    case ej.TreeGrid.EditingType.DateTimePicker:
                        date = $element.ejDateTimePicker("model.value");
                        if (proxy._cellEditColumn && !proxy._cellEditColumn.format) {
                            cellValue = cellValue = proxy.getFormatedDate(date);
                        } else {
                            cellValue = date;
                        }
                        break;
                    case ej.TreeGrid.EditingType.Maskedit:
                        cellValue = $element.ejMaskEdit("model.value");
                        break;
                }
                return cellValue;
            }
            return null;
        },


        _getSelectedItem: function (indexArray, dropDownData) {
            var count = 0,
                length = indexArray.length,
                    selectedItems = [];
            if (dropDownData) {
                for (count = 0; count < length; count++) {
                    $.each(dropDownData, function (index, resourceInfo) {
                        if (indexArray[count] === index) {
                            selectedItems.push(resourceInfo);
                        }
                    });
                }
            }

            return selectedItems;
        },

        _getDropDownText: function (column,indexArray) {
            var count = 0,
                length, editParams, value, text,
                dropDownData = column.dropdownData,
                selectedDropDownText = [];
            indexArray = indexArray.split(",");
            length = indexArray.length;
            editParams = column.editParams;
            if (editParams && editParams.fields) {
                text = editParams.fields.text ? editParams.fields.text : "text";
                value = editParams.fields.value ? editParams.fields.value : "value";
            }
            else {
                value = "value";
                text = "text";
            }
            for (var i = 0; i < length; i++) {
                $.each(dropDownData, function (index, data) {
                    if (!ej.isNullOrUndefined(data[value])) {
                        if (indexArray[i] === data[value].toString()) {
                            selectedDropDownText.push(data[text]);
                            return false;
                        }
                    }
                    else
                    {
                        if (indexArray[i] === data[text].toString()) {
                            selectedDropDownText.push(data[text].toString());
                            return false;
                        }
                    }
                });
            }
            return selectedDropDownText.join(",");
        },
        _updateRecord: function (data) {
            var proxy = this, model = this.model,
                columns=proxy._columns,
               length,
                index = 0,
                targetIndex = model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell,
                ganttRecord = proxy.getUpdatedRecords()[targetIndex];
            proxy._isUpdateOffset = false;

            if (model.editDialogFields.length > 0) {
                var filteredColumns = [];
                var count = 0, resultColumn;
                for (; count < model.editDialogFields.length; count++) {
                    resultColumn = $.grep(proxy._columns, function (val) {
                        return val.mappingName === model.editDialogFields[count].field;
                    });
                    resultColumn.length && filteredColumns.push(resultColumn[0]);
                }
                columns = filteredColumns;
            }
            length = columns.length;

            for (index = 0; index < length; index++) {

                if (columns[index].field.toString() === "predecessor")
                    continue;
                //for predecessor from edit dialog window 
                if (!ej.isNullOrUndefined(data[columns[index].mappingName])) {
                    if ((columns[index].field == "startDate")) {
                        if (ganttRecord[columns[index].field].getTime() != data[columns[index].mappingName].getTime())
                            proxy._isUpdateOffset = true;
                    }
                    if (columns[index].field == "endDate") {
                        if (ganttRecord[columns[index].field].getTime() != data[columns[index].mappingName].getTime())
                            proxy._isUpdateOffset = true;
                    }
                    if (columns[index].field == "duration") {
                        if (ganttRecord[columns[index].field] != data[columns[index].mappingName])
                            proxy._isUpdateOffset = true;
                    }

                    if (columns[index].field != "work" && columns[index].field != "taskType") {
                        ganttRecord[columns[index].field] = data[columns[index].mappingName];
                        ganttRecord.item[columns[index].mappingName] = data[columns[index].mappingName];//field
                    }
                    if (columns[index].field == "work") {
                        if (model.workMapping) {
                            ganttRecord[columns[index].field] = data[columns[index].mappingName];
                            ganttRecord.item[columns[index].mappingName] = data[columns[index].mappingName];
                        }
                        else
                            ganttRecord[columns[index].field] = data[columns[index].field];
                    }
                }
                if (columns[index].field == "taskMode") {
                    ganttRecord["isAutoSchedule"] = !data[model.taskSchedulingModeMapping];                    
                }
                if (columns[index].field == "taskType" || columns[index].field == "effortDriven")
                    ganttRecord[columns[index].field] = data[columns[index].field];
                if (columns[index].field.toString() === "resourceInfo")
                    proxy._updateResourceName(ganttRecord);
                if (columns[index].field.toString() === "notesText") {
                    ganttRecord["notes"] = data[model.notesMapping];
                    ganttRecord["notesText"] = proxy._getPlainText(data[model.notesMapping]);
                    ganttRecord.item[model.notesMapping] = data[model.notesMapping];
                }
            }
            return ganttRecord;
            
        },
        updateRecordByTaskId: function(data){
            var proxy = this, model = proxy.model,
                flatIndex,updatedIndex, taskId = data[model.taskIdMapping],
                id = typeof (taskId) == 'number' ? taskId.toString() : typeof (taskId) == 'string' ? taskId : null;
            if (!ej.isNullOrUndefined(id)) {
                flatIndex = model.ids.indexOf(id);
                if (flatIndex > -1) {
                    var flatRecord = model.flatRecords[flatIndex],
                        updatedIndex = model.updatedRecords.indexOf(flatRecord);                    
                        proxy.updateRecordByIndex(updatedIndex, data);
                }
            }
        },

        updateRecordByIndex: function (index, data) {
            var proxy = this,
                model = proxy.model,
                updatedRecords = model.updatedRecords, args = {},
                recordIndex = index, ganttRecord,
                record = recordIndex > -1 ? updatedRecords.length > 0 ? updatedRecords[recordIndex] : null : null;
            proxy.cancelEditCell();
            if (!ej.isNullOrUndefined(record)) {
                var prevData = $.extend({}, record.item);
                $.each(data, function (key, value) {
                    prevData[key] = value;
                });
                data = prevData;
                var ganttRecord, columns = proxy.getColumns();
                data[model.taskIdMapping] = record.item[model.taskIdMapping];
                ganttRecord = proxy._createGanttRecord(data, record.level, record.parentItem, undefined);
                record.isAutoSchedule = ganttRecord.isAutoSchedule;
                record.isMilestone = ganttRecord.isMilestone;
                var updateNeeded = ["WBS", "baselineEndDate", "effortDriven", "endDate", "baselineStartDate", "baselineStartDate", "duration", "manualEndDate", "durationUnit", "manualStartDate",
                "notes", "notesText", "predecessorsName", "resourceInfo", "resourceNames", "startDate", "isAutoSchedule", "manualDuration", "taskType", "taskName", "work", "status", "item", "predecessor"];
                for (var index = 0; index < updateNeeded.length; index++) {
                    if (updateNeeded[index] != "taskId") {
                        if (!(record.hasChildRecords && record.isAutoSchedule && (updateNeeded[index] == "startDate" ||
                            updateNeeded[index] == "endDate" || updateNeeded[index] == "duration" || updateNeeded[index] == "status" || updateNeeded[index] == "predecessor"))) {
                            if (updateNeeded[index] == "predecessor") {
                                var predecessorName = ej.isNullOrUndefined(ganttRecord.item[model.predecessorMapping]) ? "" :
                                                        ganttRecord.item[model.predecessorMapping];
                                args.previousValue = proxy._updatePredecessorValue(record, predecessorName);
                            } else if (updateNeeded[index] == "item") {
                                var prevData = $.extend({}, ganttRecord.item);
                                $.each(prevData, function (key, value) {
                                    record.item[key] = value;
                                });
                            }
                            else {
                                if (!ej.isNullOrUndefined(ganttRecord[updateNeeded[index]]))
                                    record[updateNeeded[index]] = ganttRecord[updateNeeded[index]];
                            }
                        }
                    }
                }                
                args.requestType = ej.TreeGrid.Actions.Save;
                args.recordIndex = recordIndex;
                args._cModifiedData = record;
                args.modifiedRecord = record;
                proxy.actionComplete(args);
            }
        },

        _splitAndReplace: function(stringValue, find, replace, splitBy){
            var i = 0;
            if (!ej.isNullOrUndefined(splitBy) && splitBy.length > 0) {
                var splitString = splitBy.shift(),
                    stringArray = stringValue.split(splitString);
                for (var index = 0; index < stringArray.length; index++) {
                    if (splitBy.length > 0) {
                        stringArray[index] = this._splitAndReplace(stringArray[index], find, replace, splitBy);
                    }
                    else if (stringArray[index] == find) {
                        stringArray[index] = replace;
                    }
                }
                return stringArray.join(splitString);
            }
        },

        _updateDetailPredecessorCollection: function (currentId, newId) {
            var detailPredecessorCollection = this.detailPredecessorCollection;
            for (var i = 0; i < detailPredecessorCollection.length; i++) {
                var pCollection = this.detailPredecessorCollection[i];
                if (pCollection.taskid == parseInt(currentId))
                    pCollection.taskid = parseInt(newId);
                var splitBy = [",", ":"];
                if (!ej.isNullOrUndefined(pCollection.from)) {                    
                    pCollection.from = this._splitAndReplace(pCollection.from, currentId, newId, splitBy);
                }
                else {
                    if (!ej.isNullOrUndefined(pCollection.to)) {
                        pCollection.to = this._splitAndReplace(pCollection.to, currentId, newId, splitBy);
                    }
                }
            }
        },    
        
        //Update connectorLineId for new taskId
        _updateConnectorLineId: function (parentGanttRecord, childGanttRecord, predecessor) {
            var proxy = this, connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, childGanttRecord, predecessor);
            if (connectorLineObject) {
                if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                    proxy._updatedConnectorLineCollection.push(connectorLineObject);
                    proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                }
                else if (proxy._connectorlineIds.length == 0) {
                    proxy._updatedConnectorLineCollection.push(connectorLineObject);
                    proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                }                
                proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
            }
        },
        // Dynamically update new taskId by this method.
        updateTaskId: function(currentId, newId){
            var proxy = this, model = this.model, ids = model.ids,
                flatRecords = model.flatRecords, currentViewData = model.currentViewData,
                cId = typeof currentId == 'number' ? currentId.toString() : currentId,
                nId = typeof newId == 'number' ? newId.toString() : newId;
            if (!ej.isNullOrUndefined(cId) && !ej.isNullOrUndefined(nId)) {
                var cIndex = ids.indexOf(cId),
                    nIndex = ids.indexOf(nId),
                    record;
                //Return false for invalid TaskId
                if (cIndex == -1 || nIndex > -1)
                    return false;
                record = flatRecords[cIndex];                
                record['taskId'] = record.item[model.taskIdMapping] = newId;
                ids[cIndex] = nId;

                if (this.criticalPathCollection.length > 0 || this.collectionTaskId.length > 0) {
                    var pathIndex = this.criticalPathCollection.indexOf(parseInt(cId)),
                        collectionIndex = this.collectionTaskId.indexOf(parseInt(cId));
                    this.criticalPathCollection[pathIndex] = parseInt(nId);
                    this.collectionTaskId[collectionIndex] = parseInt(nId);
                }
                if (this.detailPredecessorCollection.length > 0) {
                    proxy._updateDetailPredecessorCollection(cId, nId);
                }

                // ParentTaskIdMapping updation
                if (record.hasChildRecords && model.parentTaskIdMapping) {
                    var childRecords = record.childRecords,
                        childLength = childRecords.length;
                    for (var i = 0; i < childLength; i++) {
                        var childRecord = childRecords[i];
                        childRecord.item[model.parentTaskIdMapping] = newId;
                        proxy.refreshGanttRecord(childRecord);
                    }
                }               
                
                // Predecessor & connectorLines updation
                if (model.predecessorMapping && !ej.isNullOrUndefined(record.predecessor)) {
                    var predecessors = record.predecessor,
                        length = predecessors.length;
                    
                    for (var count = 0; count < length; count++) {
                        var predecessor = predecessors[count], childGanttRecord, parentGanttRecord;
                        if (predecessor.to == cId) {
                            parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                            childGanttRecord = flatRecords[cIndex];                            
                            proxy._connectorlineIds = [];
                            proxy._updatedConnectorLineCollection = [];
                            //Condition to check connector line existing in DOM before remove it
                            if (currentViewData.indexOf(parentGanttRecord) > -1 && currentViewData.indexOf(childGanttRecord) > -1) {
                                var connectorLineId = "parent" + predecessor.from + "child" + predecessor.to;
                                proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                               
                                proxy._updateConnectorLineCollection(connectorLineId);
                                predecessor.to = nId;
                                proxy._updateConnectorLineId(parentGanttRecord, childGanttRecord, predecessor);                                                                
                            }
                            else { predecessor.to = nId; }
                        }

                        else if (predecessor.from == cId) {
                            parentGanttRecord = flatRecords[cIndex];
                            childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];                            
                            proxy._connectorlineIds = [];
                            proxy._updatedConnectorLineCollection = [];
                            //Condition to check connector line existing in DOM before remove it
                            if (currentViewData.indexOf(parentGanttRecord) > -1 && currentViewData.indexOf(childGanttRecord) > -1) {
                                var connectorLineId = "parent" + predecessor.from + "child" + predecessor.to;
                                proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                               
                                proxy._updateConnectorLineCollection(connectorLineId);
                                predecessor.from = nId;
                                proxy._updateConnectorLineId(parentGanttRecord, childGanttRecord, predecessor);                                
                            }
                            else { predecessor.from = nId; }

                            if (!ej.isNullOrUndefined(childGanttRecord)) {
                                var predecessorName = proxy._predecessorToString(childGanttRecord.predecessor, childGanttRecord);
                                childGanttRecord.predecessorsName = predecessorName;
                                childGanttRecord.item[model.predecessorMapping] = predecessorName;                               
                                proxy.refreshGanttRecord(childGanttRecord);
                            }
                        }
                    }                    
                }
                proxy._isLastRefresh = true;
                proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());
                proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);                
                proxy.refreshGanttRecord(record);
                proxy._updateLastInsertedId(record.taskId);
                if (proxy.isCriticalPathEnable == true) {
                    proxy._$ganttchartHelper.ejGanttChart("criticalDataMapping", proxy.criticalPathCollection, true, proxy.detailPredecessorCollection, proxy.collectionTaskId);
                    proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
                }
                return true;
            }                 
        },

        _sendIndentRequest: function () {

            var proxy = this,
                model = proxy.model,
                data = proxy.getCurrentData(),
                args = {},
                eveargs = {},
                previousGanttRecord,
                isRefresh = false,
                treeGridObject = proxy._$treegridHelper.ejTreeGrid("instance");
            proxy.cancelEditCell();
            if (ej.isNullOrUndefined(data)) {
                alert(proxy._alertTexts["indentAlert"]);
            }
            else {
                previousGanttRecord = model.flatRecords[model.flatRecords.indexOf(data) - 1];
                args.data = data;
                args.requestType = "indent";
                if (!proxy._trigger("actionBegin", args)) {

                    if (data.parentItem) {
                        var childIndex = data.parentItem.childRecords.indexOf(data);
                        data.parentItem.childRecords.splice(childIndex, 1);
                        if (!model.parentTaskIdMapping)
                            data.parentItem.item[model.childMapping].splice(childIndex, 1);
                    } else {
                        if (this.dataSource() instanceof ej.DataManager) {
                            if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                                var dataSourceIndex = this.dataSource().dataSource.json.indexOf(data.item);
                                if (!model.parentTaskIdMapping)
                                    this.dataSource().dataSource.json.splice(dataSourceIndex, 1);
                            }
                            else if (proxy._isDataManagerUpdate) {
                                var dataSourceIndex = proxy._jsonData.indexOf(data.item);
                                if (!model.parentTaskIdMapping) {
                                    proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDatamanagerData");
                                    proxy._jsonData.splice(dataSourceIndex, 1);
                                }
                            }
                        }
                        else {
                            var dataSourceIndex = this.dataSource().indexOf(data.item);
                            if (!model.parentTaskIdMapping)
                                this.dataSource().splice(dataSourceIndex, 1);
                        }
                    }
                    if (data.level === previousGanttRecord.level) {
                        if (previousGanttRecord.childRecords) {
                            if (!previousGanttRecord.expanded) {
                                previousGanttRecord.childRecords.splice(previousGanttRecord.childRecords.length, 0, data);
                                data.parentItem = previousGanttRecord;
                                if (!model.parentTaskIdMapping)
                                    previousGanttRecord.item[model.childMapping].splice(previousGanttRecord.childRecords.length, 0, data.item);
                                else
                                    data.item[model.parentTaskIdMapping] = previousGanttRecord.taskId;
                            }
                        } else {
                            previousGanttRecord.childRecords = [];
                            previousGanttRecord.childRecords.push(data);
                            previousGanttRecord.expanded = true;
                            previousGanttRecord.taskType = ej.Gantt.TaskType.FixedDuration;
                            previousGanttRecord.effortDriven = "false";                            
                            data.parentItem = previousGanttRecord;
                            previousGanttRecord.item[model.childMapping] = [];
                            if (!model.parentTaskIdMapping)
                                previousGanttRecord.item[model.childMapping].push(data.item);
                            else
                                data.item[model.parentTaskIdMapping] = previousGanttRecord.taskId;
                        }
                    } else if (previousGanttRecord.level - data.level === 1) {
                        previousGanttRecord.parentItem.childRecords.splice(previousGanttRecord.parentItem.childRecords.length, 0, data);
                        if (!model.parentTaskIdMapping)
                            previousGanttRecord.parentItem.item[model.childMapping].splice(previousGanttRecord.parentItem.childRecords.length, 0, data.item);
                        else
                            data.item[model.parentTaskIdMapping] = previousGanttRecord.parentItem.taskId;
                        data.parentItem = previousGanttRecord.parentItem;
                    } else if (previousGanttRecord.level - data.level > 1) {

                        var parentItem = proxy.getParentItem(previousGanttRecord, data.level);
                        parentItem.childRecords.splice(parentItem.childRecords.length, 0, data);
                        if (!model.parentTaskIdMapping)
                            parentItem.item[model.childMapping].splice(parentItem.childRecords.length, 0, data.item);
                        else
                            data.item[model.parentTaskIdMapping] = parentItem.taskId;
                        data.parentItem = parentItem;

                    }

                    if (data.parentItem.isMilestone) {
                        data.parentItem.isMilestone = false;
                    }
                    previousGanttRecord.hasChildRecords = previousGanttRecord.childRecords ? previousGanttRecord.childRecords.length > 0 : false;
                    data.level += 1;

                    if (treeGridObject._searchString.length > 0 || treeGridObject.model.sortSettings.sortedColumns.length > 0) {
                        isRefresh = true;
                    }
                    proxy.updateLevel(data, +1, isRefresh);

                    if (!isRefresh)
                        proxy.refreshGanttRecord(data);

                    //update parent recordsCollections
                    if (previousGanttRecord.level === 0) {
                        if (model.parentRecords.indexOf(previousGanttRecord) === -1) {
                            model.parentRecords.push(previousGanttRecord);
                        }
                    }
                    if (data.level > 0) {
                        if (model.parentRecords.indexOf(data) !== -1) {
                            var idx = model.parentRecords.indexOf(data);
                            model.parentRecords.splice(idx, 1);
                        }
                    }
                    //Update parentitem
                    if (data.parentItem && data.parentItem.isAutoSchedule) {
                        proxy._updateParentItem(data);
                    }
                    else if (data.parentItem && !data.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(data);
                    //Remove child predecessor from Parent item
                    if (data.parentItem && data.parentItem.predecessor && model.predecessorMapping) {
                        proxy._updatePredecessorOnIndentOutdent(data.parentItem);
                    }
                    if (!isRefresh)
                        proxy.refreshGanttRecord(previousGanttRecord);



                    if (!proxy.getExpandStatus(data)) {
                        var expanargs = {};
                        expanargs.expanded = true;
                        expanargs.data = data.parentItem;
                        proxy.expanding(expanargs);
                    }
                    proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords, this.dataSource());
                    if (isRefresh) {
                        

                        args.requestType = "indent";
                        //update oudented reocords as per searching and sorting
                        proxy._$treegridHelper.ejTreeGrid("processBindings", args);
                        var tempArgs = {};
                        tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                        proxy.model.updatedRecords = proxy.getUpdatedRecords();
                        proxy.model.currentViewData = proxy.getCurrentViewData();
                        proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
                        proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
                        proxy.updateAltRow(model.updatedRecords, 0, 1);
                    }

                    if (model.predecessorMapping) {
                        proxy._isValidationEnabled = false;
                        proxy._connectorlineIds = [];
                        proxy._connectorLinesCollection = [];
                        proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                        proxy._createConnectorLinesCollection();
                    }

                    //row selection
                    var rowToindex = model.updatedRecords.indexOf(data);
                    var $ganttChartRows = proxy.getGanttChartRows();
                    args = {
                        rowElement: $ganttChartRows.eq(rowToindex),
                        data: proxy.model.selectedItem,
                        recordIndex: rowToindex
                    };

                    proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                    proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                    this.selectedItem(args.data);
                    this.selectedRowIndex(args.recordIndex);
                    if (model.allowSelection && model.selectionMode != "cell")
                        proxy.updateIndentOutdentOption(data);
                    if (model.enableWBS) {
                        var parentVal = data.parentItem.WBS,
                            inRowIndex = data.parentItem.childRecords.length,
                            target = [data];
                        //Updating WBS for the indent record
                        proxy.reCalculateWBS(target, inRowIndex, parentVal);
                        //Updating WBS for corresponding below records
                        proxy.updateWBSdetails(data.parentItem);
                    }
                    eveargs.data = data;
                    eveargs.requestType = "indent";
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == args.data.taskId) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                    if (proxy._actionCompleteData.length) {
                        eveargs.updatedRecords = proxy._actionCompleteData;
                        proxy._actionCompleteData = [];
                    }
                    this._trigger("actionComplete", eveargs);
                }
            }
            if (this.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, false, this.collectionTaskId);
                this.showCriticalPath(true);
            }
        },
        
        _updatePredecessorOnIndentOutdent:function(parentRecord)
        {

            var proxy = this, len = parentRecord.predecessor.length,
                predecessorCollection = parentRecord.predecessor,
                predecessorIndex,
                childRecord,
                id,
                updatedPredecessor = [],
                model = proxy.model;
            for (var count = 0; count < len; count++) {
                //remove predecessor connect with parent item
                if (predecessorCollection[count].to === parentRecord.taskId.toString()) {
                    childRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessorCollection[count].from)];
                    predecessorIndex = childRecord.predecessor.indexOf(predecessorCollection[count]);
                    childRecord.predecessor.splice(predecessorIndex, 1);
                    id = "parent" + childRecord['taskId'] + "child" + parentRecord['taskId'];
                }
                    //remove predecessor if parent record as predecessor of it's child record
                else if (predecessorCollection[count].from === parentRecord.taskId.toString()) {
                    childRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessorCollection[count].to)];
                    var stringPredecessor = proxy._predecessorToString(childRecord.predecessor, childRecord);                    
                    var prdcList = childRecord["predecessorsName"].split(',');
                    var str = predecessorCollection[count].from + predecessorCollection[count].predecessorsType;
                    var ind = prdcList.indexOf(str);
                    prdcList.splice(ind,1);
                    childRecord.item[model.predecessorMapping] = prdcList.join(',');
                    childRecord.predecessorsName = prdcList.join(',');
                    predecessorIndex = childRecord.predecessor.indexOf(predecessorCollection[count]);
                    childRecord.predecessor.splice(predecessorIndex, 1);
                    if (model.enableWBS && model.enableWBSPredecessor) {
                        proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", childRecord);
                    }
                    id = "parent" + parentRecord['taskId'] + "child" + childRecord['taskId'];
                    proxy.refreshGanttRecord(childRecord);
                }              
                proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", id);
                this._updateConnectorLineCollection(id);
               
            }
            parentRecord.predecessor = updatedPredecessor;
            parentRecord.item[model.predecessorMapping] = "";
            parentRecord.predecessorsName = "";
            if (model.enableWBS && model.enableWBSPredecessor) {
                parentRecord["WBSPredecessor"] = "";
                parentRecord["item"]["WBSPredecessor"] = "";
            }

            //if (updatedPredecessor.length > 0) {
            //    proxy._updatedConnectorLineCollection = [];
            //    proxy._connectorlineIds = [];
            //    proxy._validatePredecessor(parentRecord);
            //    if (proxy._updatedConnectorLineCollection.length > 0) {
            //        proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
            //    }
            //}
        },
        
        _removePredecessor:function(predecessor,record)
        {
            var proxy = this, length = predecessor.length, count = 0, model = proxy.model, parentGanttRecord, childGanttRecord;
            for (count; count < length; count++)
            {
                if (predecessor[count].from !== record.taskId.toString())
                {
                    childGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessor[count].from)];  //index st
                }
                else if (predecessor[count].to !== record.taskId.toString())
                {
                    childGanttRecord = proxy.model.flatRecords[proxy.model.ids.indexOf(predecessor[count].to)];
                }

                if (childGanttRecord) {
                    var cIndex = childGanttRecord.predecessor.indexOf(predecessor[count]);
                    if (cIndex !== -1)
                        childGanttRecord.predecessor.splice(cIndex, 1);

                    if (childGanttRecord.item[model.predecessorMapping]) {
                        childGanttRecord.item[model.predecessorMapping] = proxy._predecessorToString(childGanttRecord.predecessor, childGanttRecord);
                        childGanttRecord.predecessorsName = childGanttRecord.item[model.predecessorMapping];
                        if (model.enableWBS && model.enableWBSPredecessor)
                            proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", childGanttRecord);
                        proxy.refreshGanttRecord(childGanttRecord);
                    }
                }
            }

        },

        _predecessorToString:function(predecessorCollection,record)
        {
            var proxy = this, predecessorString=[],count=0,length=predecessorCollection.length;
            
            for (count; count < length;count++)
            {
                if(record.taskId.toString()!==predecessorCollection[count].from)
                    {
                        var tem = predecessorCollection[count].from + predecessorCollection[count].predecessorsType;
                        predecessorCollection[count].offset = isNaN(predecessorCollection[count].offset) ? 0 : predecessorCollection[count].offset;

                        if (predecessorCollection[count].offset !== 0) {
                            if (predecessorCollection[count].offset < 0)
                                tem += predecessorCollection[count].offset.toString()+"d";
                            else if (predecessorCollection[count].offset > 0)
                                tem += "+" + predecessorCollection[count].offset.toString()+"d";
                        }
                        predecessorString.push(tem);
                }
            }
           
            return predecessorString.join(',');
        },
        //get the parentItem of selected ganttRecord to perform the indent operation
        
        getParentItem:function(ganttRecord,level) {

            var proxy = this;

            if (ganttRecord.parentItem.level === level)
                return ganttRecord.parentItem;

            return proxy.getParentItem(ganttRecord.parentItem, level);
        },

        //Change the position or index for the outdent element 
        getSubChangeIndex: function (itemLevel, itemIndex, item) {
            var proxy = this, changetoIndex;
            for (var items = 0; items < proxy.model.updatedRecords.length; items++) {
                if (proxy.model.updatedRecords[items].level == itemLevel && proxy.model.updatedRecords[items].index > itemIndex) {
                    if (item.parentItem && proxy.model.updatedRecords[items].parentItem.taskId == item.parentItem.taskId)
                        changetoIndex = proxy.model.updatedRecords[items].index;
                    break;
                }
            }
            return changetoIndex;
        },

        //get the next sample level item from 
        _nextSameLevelItem:function(data,totRecords)
        {
            var proxy = this,
                level = data.parentItem.level, dataIndex = totRecords.indexOf(data), nextItem;
            for (var i = dataIndex; i < totRecords.length; i++)
            {
                if (level === totRecords[i].level || level > totRecords[i].level) {
                    nextItem = totRecords[i];
                    break;
                }
            }
            return nextItem;
        },

        //Indent operation for gantt records
        _sendOutdentRequest: function () {
            var proxy = this,
                model = proxy.model,
                data = proxy.getCurrentData(),
                args = {},
                eveargs = {},
                updateNextItem,
                rowNextItem,
                updateInsertIndex,
                rowInsertIndex,
                dataUpdatedRecordIndex,
                dataRowIndex,
                outParent,
                childDataIndex,
                insertParentItem,
                rowNextItemChildIndex,
                dataChildCount, splicedRows, splicedIds;
            proxy.cancelEditCell();
            if (ej.isNullOrUndefined(data)) {
                alert(proxy._alertTexts["outdentAlert"]);
            } else {
                args.data = data;
                args.requestType = "outdent";
                if (!proxy._trigger("actionBegin", args)) {
                    if (data.level === 0 || model.editSettings.allowIndent == false)
                        return;
                    else {
                        //find where to insert data
                        rowNextItem = proxy._nextSameLevelItem(data, model.flatRecords);
                        dataRowIndex = model.flatRecords.indexOf(data);

                        outParent = data.parentItem;
                        childDataIndex = data.parentItem.childRecords.indexOf(data);
                        insertParentItem = data.parentItem.parentItem;
                        rowNextItemChildIndex = insertParentItem && data.parentItem.parentItem.childRecords.indexOf(rowNextItem);

                        //remove data from current parent item
                        data.parentItem.childRecords.splice(childDataIndex, 1);

                        if(!model.parentTaskIdMapping)
                            data.parentItem.item[model.childMapping].splice(childDataIndex, 1);

                        if (data.parentItem.childRecords.length == 0) {

                            data.parentItem.childRecords = null;
                            data.parentItem.expanded = false;
                            data.parentItem.hasChildRecords = false;
                        }
                        else
                        {
                            if (data.parentItem && data.parentItem.isAutoSchedule)
                                proxy._updateParentItem(data.parentItem.childRecords[0]);
                            else if (data.parentItem && !data.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(data.parentItem.childRecords[0]);
                        }

                        //add to next parent item
                        if (insertParentItem) {
                            if (rowNextItemChildIndex != -1)
                            insertParentItem.childRecords.splice(rowNextItemChildIndex, 0, data);
                            else
                                insertParentItem.childRecords.push(data);
                            if (!model.parentTaskIdMapping) {
                                if (rowNextItemChildIndex != -1)
                                insertParentItem.item[model.childMapping].splice(rowNextItemChildIndex, 0, data.item);
                            else
                                    insertParentItem.item[model.childMapping].push(data.item);
                            }
                            else
                                data.item[model.parentTaskIdMapping] = insertParentItem.taskId;

                            data.parentItem = insertParentItem;
                        } else {

                            if (this.dataSource() instanceof ej.DataManager) {
                                if (this.dataSource().dataSource.offline && this.dataSource().dataSource.json) {
                                    if (!model.parentTaskIdMapping)
                                        this.dataSource().dataSource.json.push(data.item);
                                }
                                else if (proxy._isDataManagerUpdate) {
                                    if (!model.parentTaskIdMapping) {
                                        proxy._jsonData = proxy._$treegridHelper.ejTreeGrid("getUpdatedDatamanagerData");
                                        proxy._jsonData.push(data.item);
                                    }
                                }
                            } else {
                                if (!model.parentTaskIdMapping)
                                    if (rowNextItem) {
                                        var index = this.dataSource().indexOf(rowNextItem.item);
                                        this.dataSource().splice(index, 0, data.item);
                                    }
                                    else
                                        this.dataSource().push(data.item);
                            }
                            data.parentItem = null;
                            if (model.parentTaskIdMapping)
                                data.item[model.parentTaskIdMapping] = null;

                        }

                        //Records updates _rows collections
                        dataChildCount = proxy._$treegridHelper.ejTreeGrid("getChildCount", data, 0);
                        splicedRows = model.flatRecords.splice(dataRowIndex, dataChildCount + 1);
                        splicedIds = model.ids.splice(dataRowIndex, dataChildCount + 1);

                        if (rowNextItem) {
                            rowInsertIndex = model.flatRecords.indexOf(rowNextItem);
                        }
                        else {
                            rowInsertIndex = model.flatRecords.length;
                        }

                        if (data.hasChildRecords && data.childRecords.length > 0) {

                            for (var i = 0; i < splicedRows.length; i++) {
                                model.flatRecords.splice(rowInsertIndex, 0, splicedRows[i]);
                                model.ids.splice(rowInsertIndex, 0, splicedIds[i]);
                                splicedRows[i].level -= 1;
                                rowInsertIndex++;
                                var index = $.map(proxy._actionCompleteData, function (data, index) {
                                    if (data.taskId == splicedRows[i].taskId) {
                                        return index;
                                    }
                                });
                                if (index.length)
                                    proxy._actionCompleteData[index[0]] = splicedRows[i];
                                else
                                    proxy._actionCompleteData.push(splicedRows[i]);
                            }
                        }
                        else {
                            model.flatRecords.splice(rowInsertIndex, 0, splicedRows[0]);
                            model.ids.splice(rowInsertIndex, 0, splicedIds[0]);
                            splicedRows[0].level -= 1;
                        }
                        //update parentitem of selected item after changing of its child 
                        if (data.parentItem) {
                            //change the structure of milestone after outdent
                            if (data.parentItem.isMilestone) {
                                data.parentItem.isMilestone = false;
                            }
                            if (data.parentItem && data.parentItem.isAutoSchedule)
                                proxy._updateParentItem(data);
                            else if (data.parentItem && !data.parentItem.isAutoSchedule)
                                proxy._updateManualParentItem(data);
                        }

                        if (data.hasChildRecords) {
                            if (data.isAutoSchedule)
                                proxy._updateParentItem(data, null, true);
                            else
                                proxy._updateManualParentItem(data, null, true);
                        }

                        //update parent recordsCollections
                        if (data.level === 0) {
                            if (model.parentRecords.indexOf(data) === -1) {
                                model.parentRecords.push(data);
                            }
                        }

                        //update predecessor
                        if (data.predecessor && data.predecessor.length > 0 && model.predecessorMapping && data.hasChildRecords) {
                            proxy._updatePredecessorOnIndentOutdent(data);
                        }

                        if (model.enableVirtualization) {
                            model.updatedRecords = proxy._$treegridHelper.ejTreeGrid("getExpandedRecords", model.flatRecords);
                        }
                        else {
                            model.updatedRecords = model.flatRecords.slice();
                        }

                        //Refreshing the Gantt and TreeGrid data
                        proxy._$treegridHelper.ejTreeGrid("setUpdatedRecords", model.flatRecords, model.updatedRecords, model.ids, model.parentRecords,this.dataSource());
                        args.requestType = "outdent";
                        //update oudented reocords as per searching and sorting
                        proxy._$treegridHelper.ejTreeGrid("processBindings", args);
                        var tempArgs = {};
                        tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                        proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);

                        proxy.model.updatedRecords = proxy.getUpdatedRecords();
                        proxy.model.currentViewData = proxy.getCurrentViewData();
                        proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
                        if (proxy.model.predecessorMapping) {
                            proxy._isValidationEnabled = false;
                            proxy._connectorlineIds = [];
                            proxy._connectorLinesCollection = [];
                            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                            proxy._createConnectorLinesCollection();
                        }

                        proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
                        proxy.updateAltRow(model.updatedRecords, 0, 1);

                        //   Making the outdented row as selected row 
                        var rowToindex = model.updatedRecords.indexOf(data);
                        var $ganttChartRows = proxy.getGanttChartRows();
                        args = {
                            data: proxy.model.selectedItem,
                            recordIndex: rowToindex
                        };

                        proxy._$ganttchartHelper.ejGanttChart("selectRows", args.recordIndex);
                        proxy._$treegridHelper.ejTreeGrid("selectRows", args.recordIndex);
                        this.selectedItem(args.data);
                        this.selectedRowIndex(args.recordIndex);
                        if (model.allowSelection && model.selectionMode != "cell")
                            proxy.updateIndentOutdentOption(data);
                        if (model.enableWBS) {                           
                            //Updating WBS for the old siblings
                            var oldNxtSibling = outParent.childRecords && outParent.childRecords[childDataIndex];
                            if (oldNxtSibling)
                                proxy.updateWBSdetails(oldNxtSibling, true);
                            //Updating WBS for other records that are below the outdented item
                            proxy.updateWBSdetails(outParent);
                            //Again update the WBS for the updated WBSPredecessor value
                            if (oldNxtSibling)
                                proxy.updateWBSdetails(oldNxtSibling, true, true);
                        }
                        eveargs.data = data;
                        eveargs.requestType = "outdent";
                        var index = $.map(proxy._actionCompleteData, function (task, index) {
                            if (task.taskId == data.taskId) {
                                return index;
                            }
                        });
                        index.length && proxy._actionCompleteData.splice(index[0], 1);
                        if (proxy._actionCompleteData.length) {
                            eveargs.updatedRecords = proxy._actionCompleteData;
                            proxy._actionCompleteData = [];
                        }
                        this._trigger("actionComplete", eveargs);
                    }
                }
            }
            if (this.isCriticalPathEnable == true) {
                this.showCriticalPath(true, true);
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", this.criticalPathCollection, this.detailPredecessorCollection, true, this.collectionTaskId);
            }
        },
        
        _refreshChildLevel: function (ganttRecord) {

            var proxy = this,
                count = 0,
                childRecords = ganttRecord.childRecords,
                length = childRecords.length,
                record;

            for (count = 0; count < length; count++) {
                record = childRecords[count];                
                proxy.refreshGanttRecord(record);
                if (record.hasChildRecords) {
                    proxy._refreshChildLevel(record);
                }
            }
        },

        _updateChildLevel:function(ganttRecord) {

            var proxy = this,
                count = 0,
                childRecords = ganttRecord.childRecords,
                length = childRecords.length,
                record;
            
            for (count = 0; count < length; count++) {
                record = childRecords[count];                
                record.level = record.level - 1;
                // proxy.refreshGanttRecord(record);
                if (record.hasChildRecords) {
                    proxy._updateChildLevel(record);
                }
            }
        },

        _removeChildRecords:function(ganttRecord,index){

            if (ganttRecord.parentItem) {
                var proxy = this,
                    model = proxy.model,
                    childIndex = 0,
                    record,
                    addedChildGanttRecordCount = 0,
                    length = 0,
                    parentChildRecords = ganttRecord.parentItem.childRecords,
                    parentChildRecordsLength = parentChildRecords && parentChildRecords.length;

                for (childIndex = index; childIndex < parentChildRecordsLength; childIndex++) {

                    record = parentChildRecords[childIndex];


                    if (record) {

                        if (ganttRecord.childRecords) {

                            length = ganttRecord.childRecords.length;
                            ganttRecord.childRecords.splice(length, 0, record);
                            if (!model.parentTaskIdMapping)
                                ganttRecord.item[model.childMapping].splice(length, 0, record.item);
                            else
                                record.item[model.parentTaskIdMapping] = ganttRecord.taskId;
                        } else {
                            ganttRecord.childRecords = [];
                            ganttRecord.item[model.childMapping] = [];
                            ganttRecord.childRecords.push(record);
                            if (!model.parentTaskIdMapping)
                                ganttRecord.item[model.childMapping].push(record.item);
                            else
                                record.item[model.parentTaskIdMapping] = ganttRecord.taskId;
                        }
                        record.parentItem = ganttRecord;                                             
                        addedChildGanttRecordCount++;
                    }
                }

                if (ganttRecord.parentItem.childRecords) {

                    ganttRecord.parentItem.childRecords.splice(index, addedChildGanttRecordCount);
                    if(!model.parentTaskIdMapping)
                        ganttRecord.parentItem.item[model.childMapping].splice(index, addedChildGanttRecordCount);
                    if (ganttRecord.parentItem.childRecords.length == 0) {
                        ganttRecord.parentItem.childRecords = null;
                        ganttRecord.parentItem.expanded = false;
                        ganttRecord.parentItem.hasChildRecords = false;
                        proxy.refreshGanttRecord(ganttRecord.parentItem);
                    }
                }
            }
        },

        updateChildGanttRecordLevel: function (data,index) {
            var childIndex = 0, proxy = this, model = proxy.model,
                parentChildRecords = data.parentItem&& data.parentItem.parentItem&& data.parentItem.parentItem.childRecords,
                parentChildRecordsLength =parentChildRecords&&parentChildRecords.length,
                addedChildGanttRecordCount = 0;
            for (childIndex = index; childIndex < parentChildRecordsLength; childIndex++) {
                var childGanttRecord = parentChildRecords[childIndex];
                if (childGanttRecord.childRecords) {
                    childGanttRecord.childRecords.splice(childGanttRecord.childRecords.length, 0, childGanttRecord);
                    childGanttRecord.item[model.childMapping].splice(childGanttRecord.childRecords.length, 0, childGanttRecord.item);
                }
                else {
                    childGanttRecord.childRecords = [];
                    childGanttRecord.item[model.childMapping] = [];
                    if (childGanttRecord) {
                        childGanttRecord.childRecords.push(childGanttRecord);
                        childGanttRecord.item[model.childMapping].push(childGanttRecord.item);
                    }
                }
                proxy.refreshGanttRecord(data.parentItem);
                data.parentItem = childGanttRecord;
                ++addedChildGanttRecordCount;
            }
            data.parentItem.childRecords.splice(index, addedChildGanttRecordCount);
            if (data.parentItem.childRecords.length == 0) {
                data.parentItem.childRecords = null;
                data.parentItem.expanded = false;
                data.parentItem.hasChildRecords = false;
            }

            proxy.refreshGanttRecord(data.parentItem);

        },

        updateLevel: function (childGanttRecord, offset, isRefresh) {
            var proxy = this,
                count = 0,
                childRecords = childGanttRecord.childRecords,
                length =childRecords&& childRecords.length,
                ganttRecord;
            for (count; count < length; count++) {
                ganttRecord = childRecords[count];
                ganttRecord.level += offset;
                if (!isRefresh)
                    proxy.refreshGanttRecord(ganttRecord);
                if (ganttRecord.childRecords) 
                    proxy.updateLevel(ganttRecord, offset, isRefresh);
            }
        },

        getExpandStatus: function (record) {

            var parentRecord = record.parentItem;

            if (parentRecord != null) {

                if (parentRecord.expanded === false) {
                    return false;
                } else if (parentRecord.parentItem) {

                    if (parentRecord.parentItem.expanded === false) {
                        return false;
                    } else {
                        return this.getExpandStatus(parentRecord.parentItem);
                    }

                } else return true;
            } else return true;
        },
        subContextMenuAction: function (args) {
            var proxy = this,
                model = proxy.model,
            data = $.extend(true, {}, proxy._contextMenuSelectedItem.item), rowPosition;
            if (!model.durationUnitMapping && model.durationMapping)
                data[model.durationMapping] = this._getDurationStringValue(this._contextMenuSelectedItem);
            delete data[model.childMapping];
            delete data[model.predecessorMapping];
            delete data["WBSPredecessor"];
            delete data[model.taskNameMapping];
            
            if (args.position === "Below") {
                rowPosition = ej.Gantt.RowPosition.BelowSelectedRow;
            } else {
                rowPosition = ej.Gantt.RowPosition.AboveSelectedRow;
            }
            /*Assign or update WBS value*/
            if (model.enableWBS)
                data["WBS"] = proxy._getNewWBSid(rowPosition);
            proxy.addRecord(data, rowPosition);
        },

        /* To recalculate the WBS value */
        reCalculateWBS: function (selectedRecords, lastDigit, parentWBS) {
            var proxy = this, model = proxy.model, final;

            if (parentWBS) {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = lastDigit + i;
                    selectedRecords[i]["WBS"] = parentWBS + "." + final;
                    selectedRecords[i]["item"]["WBS"] = parentWBS + "." + final;
                    if (model.enableWBSPredecessor && model.predecessorMapping)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i]);
                }
            }
            else {
                for (var i = 0; i < selectedRecords.length; i++) {
                    final = (lastDigit + i).toString();
                    selectedRecords[i]["WBS"] = final;
                    selectedRecords[i]["item"]["WBS"] = final;
                    if (model.enableWBSPredecessor && model.predecessorMapping)
                        proxy._getPredecessorIds(selectedRecords[i]);
                    proxy.refreshGanttRecord(selectedRecords[i]);
                    if (selectedRecords[i].hasChildRecords)
                        proxy._updateChildWBS(selectedRecords[i]);
                }
            }
        },

        _updateChildWBS: function (parentRecord) {
            var proxy = this, model = proxy.model,
                childRecs = parentRecord.childRecords,
                pWBS = parentRecord["WBS"];
            for (var c = 0; c < childRecs.length; c++) {
                childRecs[c]["WBS"] = pWBS + "." + (c + 1);
                childRecs[c]["item"]["WBS"] = pWBS + "." + (c + 1);
                if (model.enableWBSPredecessor && model.predecessorMapping)
                    proxy._getPredecessorIds(childRecs[c]);
                proxy.refreshGanttRecord(childRecs[c]);
                if (childRecs[c].hasChildRecords) {
                    proxy._updateChildWBS(childRecs[c]);
                }
            }
        },

        /*Get all the predecessor rows that are matching the taskId*/
        _getPredecessorIds: function (pData) {
            var proxy = this,
                model = proxy.model,
                dataTID = pData.taskId,
                flatDatas = model.flatRecords,
                targetRecords = flatDatas.filter(function (item) {
                    if (item["predecessorsName"]) {
                        var prdcList = item["predecessorsName"].split(',');
                        for (var p = 0; p < prdcList.length; p++) {
                            var ref = prdcList[p].match(/(\d+|[A-z]+)/g),
                                refId = +ref[0];
                            if (refId == dataTID)
                                return item;
                        }
                    }
                });
            if (targetRecords.length) {
                for (var t = 0; t < targetRecords.length; t++) {
                    proxy._$treegridHelper.ejTreeGrid("updateWBSPredecessor", targetRecords[t]);
                    proxy.refreshGanttRecord(targetRecords[t]);
                }
            }
        },

        /*Get new WBS id for newly adding row*/
        _getNewWBSid: function (rowPosition) {
            var proxy = this,
                model = proxy.model,
                data = model.selectionMode == "row" ? model.selectedItem : model.updatedRecords[proxy._rowIndexOfLastSelectedCell], //selected row item before adding the new row
                newWBS;
            if (data)
                newWBS = data["WBS"];//Same WBS value to new row if it is AboveSelectedRow
            else
                newWBS = 1;// While adding new row without selecting the row (i.e. Adding to the TOP)

            //Creating new WBS value to new row if the RowPosition is BelowSelectedRow
            if (data) {
                switch (rowPosition) {
                    case ej.Gantt.RowPosition.BelowSelectedRow:
                        var lastVal = newWBS.lastIndexOf('.') != -1 ? parseInt(newWBS.substr(newWBS.lastIndexOf('.') + 1)) : parseInt(newWBS),
                            newLastVal = lastVal + 1;
                        if (data.parentItem) {
                            var parentVal = data.parentItem ? data.parentItem.WBS : null;
                            newWBS = parentVal + '.' + newLastVal;
                        }
                        else {
                            newWBS = newLastVal;
                        }
                        break;
                    case ej.Gantt.RowPosition.Top:
                        newWBS = 1;
                        break;
                    case ej.Gantt.RowPosition.Bottom:
                        newWBS = (model.parentRecords ? model.parentRecords.length : 0) + 1;
                        break;
                    case ej.Gantt.RowPosition.Child:
                        var childRecordLength = data.childRecords ? data.childRecords.length : 0;
                        newWBS = newWBS + "." + (childRecordLength + 1);
                        break;
                }
            }
            return newWBS.toString();
        },

        _getNewTaskId: function (nextId) {
            var proxy = this,
                newTaskId = ej.isNullOrUndefined(nextId) ? proxy._lastInsertedId > 0 ? proxy._lastInsertedId + 1 : 
                            1 : nextId;
            if (proxy.model.ids.indexOf(newTaskId.toString()) > -1)
                proxy._getNewTaskId(newTaskId + 1);
            else {                
                return (newTaskId);
            }
        },
        _updateLastInsertedId: function (Id, isNewRow) {
            var proxy = this, newId = isNaN(parseInt(Id)) ? proxy._lastInsertedId < 1 ? 1 : proxy._lastInsertedId : parseInt(Id);
            if (isNewRow)
                proxy._lastInsertedId = proxy._lastInsertedId < newId ? newId : proxy._lastInsertedId + 1;
            else
                proxy._lastInsertedId = proxy._lastInsertedId < newId ? newId : proxy._lastInsertedId;
        },

        contextMenuAction: function (args) {
            var proxy = this;
            if (args.requestType == "contextMenuAdd")
                proxy._sendAddRequest();
            if (args.requestType == "contextMenuIndent")
                proxy._sendIndentRequest();
            if (args.requestType == "contextMenuOutdent")
                proxy._sendOutdentRequest();
            if (args.requestType == "contextMenuDelete")
                proxy._$treegridHelper.ejTreeGrid("deleteRow", null, true, proxy._contextMenuSelectedIndex);
            if (args.requestType == "contextMenuTaskDetails")
                proxy._sendEditRequest();
        },

        _renderContextMenu: function (e, index, item) {

            var proxy = this,
                eventArgs = {},
                args = {},
                posx,
				subposx,
                posy, addItemPositionY,addItemIndex,
                contextMenu,
                contextMenuUList,
                length, columnIndex;
            proxy._contextMenuSelectedIndex = index;
            proxy._contextMenuSelectedItem = item;
            proxy._contextMenuEvent = e;
            columnIndex = proxy._$treegridHelper.ejTreeGrid("getCellIndex", e);
            if (!e) e = window.event;
            if (e.pageX || e.pageY) {
                subposx = posx = e.pageX;
                posy = e.pageY;
            } else if (e.clientX || e.clientY) {
                subposx = posx = e.clientX + document.body.scrollLeft
                    + document.documentElement.scrollLeft;
                posy = e.clientY + document.body.scrollTop
                    + document.documentElement.scrollTop;
            }

            var ganttOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", proxy.element[0]);
            ganttOffset.bottom = ganttOffset.top + this.element[0].offsetHeight;
            ganttOffset.right = ganttOffset.left + $(this.element).width();            
            args.requestType = "ContextMenuOpen";
            args.contextMenuItems = proxy._contextMenuItems;
            args.columnIndex = columnIndex;
            args.item = proxy._contextMenuSelectedItem;
            args.targetElement = e;
            args.index = index;
            if (proxy._trigger("contextMenuOpen", args))
                return;

            proxy._activeMenuItemId = null;
            proxy._contextMenuItems = args.contextMenuItems;
            if (proxy._contextMenuItems.length == 0)
                return;
            contextMenu = ej.buildTag("div.e-contextmenu", "", {
                'position': 'absolute',
                'z-index': proxy._$treegridHelper.ejTreeGrid("getMaxZIndex") + 1,
            }, { "id": proxy._id + "_ContextMenu" });
            proxy.model.cssClass && (contextMenu.addClass(proxy.model.cssClass));
            //Get zero th level menu items
            var parentMenuItems = args.contextMenuItems.filter(function (value) {
                if (value.parentMenuId == null || value.parentMenuId == undefined)
                    return true;
            });

            contextMenuUList = ej.buildTag("ul.e-gantt-contextmenu", $.render[proxy._id + "contextMenuTemplate"](parentMenuItems), {
                'margin': '0px',
                'padding-left': '0px',
                'list-style-type':'none'
            }, {
                'data-icon': false,
                'data-role': 'list-divider'
            });
            contextMenu.append(contextMenuUList);
            $(document.body).append(contextMenu);

            var contextMenuHeight = $(contextMenu).outerHeight(),
                contextMenuWidth = $(contextMenu).outerWidth(),
                contextMenuItems = contextMenu.find(".e-menuitem");
            contextMenuItems.width(contextMenuWidth + 2);
            contextMenuWidth = $(contextMenu).outerWidth();
            if (ganttOffset.left > posx || (ganttOffset.right < (posx + contextMenuWidth))) {

                if (ganttOffset.right < (posx + contextMenuWidth)) {
                    posx = posx - contextMenuWidth;
                }
                if (posx < 0) {
                    posx = ganttOffset.left + 10;
                }
            }

            if (ganttOffset.bottom < posy + ($(contextMenuUList).outerHeight())) {
                var tempPosY = posy - ($(contextMenuUList).outerHeight());
                if (tempPosY > 0) {
                    posy = tempPosY;
                }
            }

            else if (($(window).height() + $(window).scrollTop()) < posy + contextMenuHeight)
                posy = posy - contextMenuHeight;

            contextMenu.css({ 'left': posx + 'px', 'top': posy + 'px', });
            proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
            $(contextMenu).css({ 'height': 'auto' });
            proxy._on(contextMenu, "contextmenu", function (argsE) {
                argsE.preventDefault();
            });

            //click event handlers for contextmenu items and subcontextmenu items
            $(contextMenuItems).click(function () {
                proxy._contextMenuClickHandler(this);
            });

            //Mouseenter and mouse leave handler for contextmenu items and Subcontextmenuitems
            $(contextMenuItems).mouseenter(function () {
                if (!$(this).hasClass("e-disable")) {
                    contextMenu.find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                    $(this).addClass("e-contextmenu-mouseover");
                    proxy._activeMenuItemId = $(this).attr("id");
                    proxy._showSubContextMenu(this, args.contextMenuItems);
                }
            });

            e.preventDefault();
        },
        //Show SubContext menu for selected Menu items
        _showSubContextMenu: function (element, menuItems) {
            var model = this.model,
                proxy = this,
                currentMenuItem = [],
                menuId = $(element).attr("id"),
                subContextMenu, subContextMenuUList, subMenuItems = [], subContextMenuItems;

            subMenuItems = menuItems.filter(function (value) {
                if (value.menuId == menuId)
                    currentMenuItem = value;
                if (value.parentMenuId == menuId)
                    return true;
            });

            if (!currentMenuItem.parentMenuId)
                $(".e-innerContextmenu").remove();

            if (currentMenuItem.parentMenuId) {
                this._removeContextMenu(currentMenuItem, menuItems);
            }

            if (subMenuItems.length > 0) {
                subContextMenu = ej.buildTag("div.e-innerContextmenu", "", {
                    'position': 'absolute',
                    'z-index': proxy._$treegridHelper.ejTreeGrid("getMaxZIndex") + 1,
                }, { "id": this._id + "_SubContextMenu" + menuId });
                model.cssClass && (subContextMenu.addClass(model.cssClass));
                subContextMenuUList = ej.buildTag("ul.e-gantt-innercontextmenu", $.render[proxy._id + "contextMenuTemplate"](subMenuItems), {
                    'margin': '0px',
                    'padding-left': '0px'
                }, {
                    'data-icon': false,
                    'type': 'none',
                    'data-role': 'list-divider'
                });
                subContextMenu.append(subContextMenuUList);
                $(document.body).append(subContextMenu);
                subContextMenuItems = subContextMenu.find(".e-menuitem");
                var menuWidth = $(subContextMenu).outerWidth();
                subContextMenuItems.width(menuWidth > 100 ? menuWidth : 100);
                var subMenuOffset = proxy._getSubContextMenuPosition(element, subContextMenu);
                $(subContextMenu).css({ "top": subMenuOffset.top, "left": subMenuOffset.left });
                $(subContextMenuItems).mouseenter(function () {
                    if (!$(this).hasClass("e-disable")) {
                        proxy._showSubContextMenu(this, menuItems);
                        $(this).closest(".e-innerContextmenu").find(".e-contextmenu-mouseover").removeClass("e-contextmenu-mouseover");
                        $(this).addClass("e-contextmenu-mouseover");
                        proxy._activeMenuItemId = $(this).attr("id");
                    }
                });
                proxy._on(subContextMenu, "contextmenu", function (argsE) {
                    argsE.preventDefault();
                });
                $(subContextMenuItems).click(function () {
                    proxy._contextMenuClickHandler(this);
                });
            }
        },
        _removeContextMenu: function (menuItem, menuItems) {

            var currentMeuItemContainer = $("#" + this._id + "_SubContextMenu" + menuItem.parentMenuId),
                expandedMenu = $(currentMeuItemContainer).find(".e-contextmenu-mouseover");
            if ($(expandedMenu).length > 0) {
                var innerMenu = menuItems.filter(function (value) {
                    if (value.menuId == $(expandedMenu).attr("id"))
                        return true;
                });
                if (innerMenu.length > 0) {
                    var nextLevelItem = menuItems.filter(function (value) {
                        if (value.parentMenuId == innerMenu[0].menuId)
                            return true;
                    });
                    if (nextLevelItem.length > 0)
                        this._removeContextMenu(nextLevelItem[0], menuItems);
                }
                $("#" + this._id + "_SubContextMenu" + $(expandedMenu).attr("id")).remove();
            }
        },
        _getSubContextMenuPosition: function (element, subMenu) {
            var model = this.model,
                subContextMenuWidth = $(subMenu).outerWidth(),
                 subContextMenuHeight = $(subMenu).outerHeight(),
                elementOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", element), subMenuOffset = { top: "", left: "" },
                parentElement = $(element).closest(".e-contextmenu"),
                posx, posy,
                contextMenuWidth;
            if (parentElement.length == 0)
                parentElement = $(element).closest(".e-innerContextmenu");
            contextMenuWidth = $(parentElement).outerWidth();
            subMenuOffset.top = elementOffset.top - 1;
            subMenuOffset.left = elementOffset.left + $(parentElement).width() + 1;
            posx = subMenuOffset.left;

            //Edge detection for context menu
            var treeGridOffset = this._$treegridHelper.ejTreeGrid("getOffsetRect", this.element[0]);
            treeGridOffset.bottom = treeGridOffset.top + this.element[0].offsetHeight;
            treeGridOffset.right = treeGridOffset.left + $(this.element).width();
            if (treeGridOffset.left > posx || (treeGridOffset.right < (posx + subContextMenuWidth))) {
                if (treeGridOffset.right < (posx + subContextMenuWidth)) {
                    posx = posx - contextMenuWidth - subContextMenuWidth;
                }
                if (posx > 0) {
                    subMenuOffset.left = posx;
                }
            }
            if (treeGridOffset.bottom < subMenuOffset.top + subContextMenuHeight) {
                var tempPosY = (subMenuOffset.top + subContextMenuHeight) - treeGridOffset.bottom;
                tempPosY = subMenuOffset.top - tempPosY - 2;
                if (tempPosY > 0) {
                    subMenuOffset.top = tempPosY;
                }
            }

            return subMenuOffset;
        },
        //Click event handler for context menu items
        _contextMenuClickHandler: function (target) {
            var choice = $(target).attr('id'),
                proxy = this,
                eventArgs = {};
            if (!$(target).hasClass("e-disable") && $(target).find(".e-expander").length == 0) {
                switch (choice) {
                    case "Task":
                        eventArgs.requestType = "contextMenuTaskDetails";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        break;
                    case "Indent": eventArgs.requestType = "contextMenuIndent";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Outdent": eventArgs.requestType = "contextMenuOutdent";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Delete": eventArgs.requestType = "contextMenuDelete";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Above": eventArgs.requestType = "save";
                        eventArgs.position = "Above";
                        proxy.subContextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Below": eventArgs.requestType = "save";
                        eventArgs.position = "Below";
                        proxy.subContextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Open":
                        eventArgs.requestType = "contextMenuAdd";
                        proxy.contextMenuAction(eventArgs);
                        proxy._clearContextMenu();
                        proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                        break;
                    case "Add":
                        proxy._setInitialData();
                        break;
                    default:
                        eventArgs.data = proxy._contextMenuSelectedItem;
                        proxy._triggerMenuEventHandler(choice, eventArgs);
                        proxy._clearContextMenu();
                        break;
                }
            }
        },
        //Call custom context menu event handlers
        _triggerMenuEventHandler:function(menuId,eventArgs){
            var proxy = this,
                contextMenuItems = proxy._contextMenuItems,
                currentMenuItemCollection, menuItem;

            if (!ej.isNullOrUndefined(contextMenuItems)) {
                currentMenuItemCollection = contextMenuItems.filter(function (value) {
                    //convert menu id to string since id accepts only string values
                    if (value.menuId.toString() === menuId)
                        return true;
                });

                if (currentMenuItemCollection.length > 0) {
                    menuItem = currentMenuItemCollection[0];
                    eventArgs.menuId = menuId;
                    var fn = menuItem.eventHandler;
                    if (fn) {
                        if (typeof fn === "string") {
                            fn = ej.util.getObject(fn, window);
                        }
                        if ($.isFunction(fn)) {
                            var args = ej.event("customContextMenuHandler", this.model, eventArgs);
                            fn.call(this, args);
                        }
                    }

                }
            }
        },
        _setInitialData: function () {
            var eventArgs = {}, proxy = this,
                model = proxy.model;
            if (model.flatRecords.length == 0) {
                proxy.addRecord();
                proxy._clearContextMenu();
            }
        },

        //Updated the all child records expandstatus on expandCollapse
        updateConnectorLines: function ($gridRows, expanded) {
            var proxy = this,
                length = $gridRows.length / 2,
                count = 0,
                row,
                index,
                record;
            
            for (count = 0; count < length; count++) {
                row = $gridRows[count];
                index = $(proxy._gridRows).index(row);
                if (index !== -1) {
                    record = proxy.model.currentViewData[index];
                    record.isExpanded = expanded;                  
                }
            }
                   
        },

        updateAltRow: function (ganttRecord, recordIndex, offset) {
            var proxy = this;
            if (proxy.model.enableAltRow) {
                var count = 0,
                currentViewData = proxy.model.currentViewData,
                length = currentViewData.length,
                isAltRow = ganttRecord.isAltRow,
                record,
                $gridRows = $(proxy._gridRows);
            for (count = recordIndex + offset; count < length; count++) {
                if ($($gridRows[count]).css('display') === "none")
                    continue;
                record = currentViewData[count];
                record.isAltRow = !isAltRow;
                isAltRow = record.isAltRow;
                if (isAltRow)
                    $($gridRows[count]).addClass('e-alt-row');
                else
                    $($gridRows[count]).removeClass('e-alt-row');
            }
        }
        },
        renderedEditDialog: function (args) {
            var proxy = this,
                model = this.model,
                columns = model.columns,
                length = columns.length,
                fieldData = {};
            switch (args.requestType) {
                case ej.TreeGrid.Actions.Add:
                    var temp = document.createElement('div'),
                        dialog = $("#" + proxy._id + "_dialogAdd");
                    $(temp).addClass("e-addedrow");
                    temp.innerHTML = $.render[proxy._id + "_JSONDialogAddingTemplate"](args.data);
                    $(dialog).html($(temp));
                    var evntArgs = {};
                    evntArgs.cssClass = model.cssClass;
                    evntArgs.enableModal = true;
                    evntArgs.width = "650px";
                    evntArgs.height = "auto";
                    evntArgs.enableResize = false;
                    evntArgs.isResponsive = false;
                    evntArgs.contentSelector = "#" + proxy._id;
                    evntArgs.rtl = model.rtl;
                    evntArgs.showOnInit = false;
                    evntArgs.allowKeyboardNavigation = false;
                    evntArgs.close = function () {
                        $("#" + proxy._id + "AddAreaNotes").data("ejRTE") && $("#" + proxy._id + "AddAreaNotes").ejRTE("destroy");
                    };
                    evntArgs.beforeClose = function (args) {
                        if (proxy._closeAddEditDialog(args, "Add"))
                            args.cancel = true; // Cancel the add dialog box close.
                        else
                            proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    },
                    title = proxy._editDialogTexts["addFormTitle"];
                    evntArgs.title = title;
                    proxy._editedDialogRecord = {};
                    var tab = $("#" + proxy._id + "AddTab");
                    $(tab).ejTab({
                        headerSize: "25px",
                        height: "310px",
                        heightAdjustMode: ej.Tab.HeightAdjustMode.None,
                        locale: model.locale,
                        cssClass: model.cssClass,
                        enableAnimation: false,
                        itemActive: function (args) {
                            var activeHeader = $(args.activeHeader).find("a").attr("href");
                            if (activeHeader == "#" + proxy._id + "AddNotes") {
                                $("#" + proxy._id + "AddAreaNotes_Iframe").height("202");
                            }
                            else if (activeHeader == "#" + proxy._id + "AddCustomFields") {
                                var treeGrid = $("#treegrid" + proxy._id + "customFieldAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "280px" } });
                            } else if (activeHeader == "#" + proxy._id + "AddPredecessors") {
                                var treeGrid = $("#treegrid" + proxy._id + "predecessorAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } else if (activeHeader == "#" + proxy._id + "AddResources") {
                                var treeGrid = $("#treegrid" + proxy._id + "resourceAdd").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            }
                        }
                    });
                    
                    $(tab).find("div.e-hidebottom.e-addborderbottom.e-content").css("min-height", "283px");
                    $(dialog).ejDialog(evntArgs);
                    $(dialog).ejDialog("instance").contentDiv.ejScroller("setModel",{"scrollerSize": 0});
                    var dialogArgs = {};
                    dialogArgs.data = args.data;
                    dialogArgs.rowPosition = model.editSettings.rowPosition;
                    dialogArgs.requestType = "beforeOpenAddDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogAdd");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        for (var columnCount = 0; columnCount < length; columnCount++)
                            fieldData[columns[columnCount].field] = dialogArgs.data[columns[columnCount].mappingName];
                        args.data = fieldData;
                        proxy._refreshEditForm(args);
                        dialogArgs.data = args.data;
                        dialogArgs.requestType = "OpenAddDialog";
                        dialogArgs.element = $("#" + proxy._id + "_dialogAdd");
                        if (!proxy._trigger("actionBegin", dialogArgs)) {
                            var dialogWrapper = $("#" + proxy._id + "_dialogAdd_wrapper");
                            $(dialog).find(".e-addedrow").css("overflow", "hidden");
                            dialogWrapper.addClass("e-ganttdialog");
                            $(dialog).ejDialog("refresh");
                            $(dialog).ejDialog("open");
                        }
                    }
                    $(tab).find("div#"+proxy._id+"AddGeneral.e-content").css({"overflow-y": "auto","overflow-x":"hidden"});
                    proxy._addPosition = dialogArgs.rowPosition;
                    var tempDate = this._getDateFromFormat(model.scheduleStartDate);
                    if (this._getSecondsInDecimal(tempDate) != this._defaultStartTime) {
                        this._setTime(this._defaultStartTime, tempDate);
                    }
                    this._editedDialogRecord.isUpdatedFromDialog = false;
                    var autoSchedule_val = (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Auto) ? true :
                                   (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Manual) ? false :
                                   (model.taskSchedulingMode == ej.Gantt.TaskSchedulingMode.Custom) ? args.data.taskMode == true ? false : true :
                                   model.taskSchedulingMode;
                    proxy._editedDialogRecord.isAutoSchedule = autoSchedule_val;
                    proxy._editedDialogRecord.startDate = args.data.startDate ? this._checkStartDate(new Date(args.data.startDate)) : this._checkStartDate(new Date(tempDate));
                    proxy._editedDialogRecord.endDate = args.data.endDate ? proxy._editedDialogRecord.startDate.getTime() > new Date(args.data.endDate).getTime() ? new Date(proxy._editedDialogRecord.startDate) : new Date(args.data.endDate) : new Date(proxy._editedDialogRecord.startDate);
                    proxy._editedDialogRecord.duration = args.data.duration != "" ? args.data.duration : 0;
                    proxy._editedDialogRecord.durationUnit = model.durationUnit;

                    break;
                case ej.TreeGrid.Actions.BeginEdit:
                    var temp = document.createElement('div'),
                        dialog = $("#" + proxy._id + "_dialogEdit");
                    $(temp).addClass("e-editedrow");
                    temp.innerHTML = $.render[proxy._id + "_JSONDialogEditingTemplate"](args.data);
                    $(dialog).html($(temp));
                    var evntArgs = {};
                    evntArgs.cssClass = proxy.model.cssClass;
                    evntArgs.rtl = model.rtl;
                    evntArgs.width = "650px";
                    evntArgs.height = "auto";
                    evntArgs.enableResize = false;
                    evntArgs.isResponsive = false;
                    evntArgs.contentSelector = "#" + proxy._id;
                    evntArgs.enableModal = true;
                    evntArgs.showOnInit = false;
                    evntArgs.allowKeyboardNavigation = false;
                    evntArgs.close = function () {
                        $("#" + proxy._id + "EditAreaNotes").data("ejRTE") && $("#" + proxy._id + "EditAreaNotes").ejRTE("destroy");
                    };
                    evntArgs.beforeClose = function (args) {
                        if (proxy._closeAddEditDialog(args, "Edit"))
                            args.cancel = true; // Cancel the add dialog box close.
                        else
                            proxy._$treegridHelper.ejTreeGrid('setFocusOnTreeGridElement');
                    };
                    if (model.selectionMode == "row")
                        var selectedItem = proxy.selectedItem()
                    else
                        var selectedItem = proxy.model.updatedRecords[proxy._rowIndexOfLastSelectedCell];
                    var title = proxy._editDialogTexts["editFormTitle"];
                    evntArgs.open = function () {
                        var dialog = this, id = this._id;
                        var titleElement = $("#" + id + "_title").children(".e-title");
                        titleElement.width("450px");
                        titleElement.css({ "word-wrap": "normal", "text-overflow": "ellipsis", "white-space": "nowrap", "display": "inline-block", "overflow-x": "hidden", "float": "left" });
                        titleElement.attr("title", title);
                    };
                    evntArgs.title = title;
                    var tab = $("#" + proxy._id + "EditTab");
                    $(tab).ejTab({
                        headerSize: "25px",
                        height: "310px",
                        heightAdjustMode: ej.Tab.HeightAdjustMode.None,
                        locale: model.locale,
                        cssClass: model.cssClass,
                        enableAnimation: false,
                        itemActive: function (args) {
                            var activeHeader = $(args.activeHeader).find("a").attr("href");
                            if (activeHeader == "#" + proxy._id + "EditNotes") {
                                $("#" + proxy._id + "EditAreaNotes_Iframe").height("202");
                            }
                            else if (activeHeader == "#" + proxy._id + "EditCustomFields") {
                                var treeGrid = $("#treegrid" + proxy._id + "customFieldEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "279px" } });
                            } else if (activeHeader == "#" + proxy._id + "EditPredecessors") {
                                var treeGrid = $("#treegrid" + proxy._id + "predecessorEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } else if (activeHeader == "#" + proxy._id + "EditResources") {
                                var treeGrid = $("#treegrid" + proxy._id + "resourceEdit").ejTreeGrid("instance");
                                treeGrid.setModel({ sizeSettings: { width: "620", height: "240px" } });
                            } 
                        }
                    });
                    $(tab).find("div.e-content").css("overflow", "hidden");
                    $(tab).find("div#" + proxy._id + "EditGeneral.e-content").css({ "overflow-y": "auto", "overflow-x": "hidden" });
                    $(tab).find("div.e-hidebottom.e-addborderbottom.e-content").css("min-height", "283px");
                    $(dialog).ejDialog(evntArgs);
                    $(dialog).ejDialog("instance").contentDiv.ejScroller("setModel", { "scrollerSize": 0 });
                    var dialogArgs = {};
                    dialogArgs.data = args.data;
                    dialogArgs.requestType = "beforeOpenEditDialog";
                    dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                    if (!proxy._trigger("actionBegin", dialogArgs)) {
                        proxy._editedDialogRecord = jQuery.extend({}, selectedItem);
                        this._editedDialogRecord.isUpdatedFromDialog = false;
                        proxy._refreshEditForm(args);
                        dialogArgs.data = args.data;
                        dialogArgs.requestType = "openEditDialog";
                        dialogArgs.element = $("#" + proxy._id + "_dialogEdit");
                        if (!proxy._trigger("actionBegin", dialogArgs)) {
                            var dialogWrapper = $("#" + proxy._id + "_dialogEdit_wrapper");
                            $(dialog).find(".e-editedrow").css("overflow", "hidden");
                            dialogWrapper.addClass("e-ganttdialog");
                            $(dialog).ejDialog("refresh");
                            $(dialog).ejDialog("open");
                        }
                    }
                    this._editedDialogRecord && (this._editedDialogRecord.isUpdatedFromDialog = false);
                    break;                    
            }
        },

        _closeAddEditDialog: function (args, type) {
            var proxy = this;
            if (proxy._isAddEditDialogSave)
                proxy._isAddEditDialogSave = false;
            else {
                var eventArgs = {};
                if (type === "Add")
                    eventArgs.requestType = "closeAddDialog";
                else
                    eventArgs.requestType = "closeEditDialog";
                return proxy._trigger("actionBegin", eventArgs);
            }
        },
        editFormValidate: function () {
            if ($.isFunction($.validator) && $("#" + this._id + "GeneralEditForm").length > 0)
                return $("#" + this._id + "GeneralEditForm").validate().form();
            return true;
        },

        addFormValidate: function () {
            if ($.isFunction($.validator) && $("#" + this._id + "GeneralAddForm").length > 0)
                return $("#" + this._id + "GeneralAddForm").validate().form();
            return true;
        },
        getCurrentData: function () {
            var proxy = this,
                updatedRecords = proxy.getUpdatedRecords(),
                currentRowIndex = proxy.model.selectionMode == "row" ? this.selectedRowIndex() : proxy._rowIndexOfLastSelectedCell;
            return updatedRecords && updatedRecords[currentRowIndex];
        },

        getCurrentViewData: function () {
            return this._$treegridHelper.ejTreeGrid("getCurrentViewData");
        },

        getUpdatedCurrentViewData: function () {
            return this._$treegridHelper.ejTreeGrid("getUpdatedCurrentViewData");
        },

        getRows: function () {
            return this._$treegridHelper.ejTreeGrid("getRows");
        },
        
        getSelectedCells: function () {
            return this._$treegridHelper.ejTreeGrid("getSelectedCells");
        },

        getGanttChartRows: function() {
            return this._$ganttchartHelper.ejGanttChart("getGanttChartRows");
        },

        getUpdatedRecords: function () {
            return this._$treegridHelper.ejTreeGrid("getUpdatedRecords");
        },

        _getToolBarHeight: function () {
            var toolbarH = 0;
            if (this.model.toolbarSettings.showToolbar) {
                toolbarH = this.element.find(".e-gantttoolbar").height();
            }
            return toolbarH;
        },

        _initValidator: function () {
            var gridObject = this;
            $("#" + this._id + "EditForm").validate({
                errorClass: 'e-field-validation-error',
                errorElement: 'div',
                wrapper: "div",
                errorPlacement: function (error, element) {
                    var $td = element.closest("td"), $container = $(error).addClass("e-error")
                    , $tail = ej.buildTag("div.e-errortail e-toparrow");
                    $td.find(".e-error").remove();
                    element.hasClass("e-numerictextbox") ? $container.insertAfter(element.closest(".e-numeric")) : $container.insertAfter(element);
                    $container.prepend($tail);
                    gridObject.model.editSettings.editMode != "normal" && $container.offset({ left: element.offset().left });
                    $container.fadeIn("slow");
                },

            });
        },

        setValidation: function () {
            this._initValidator();
            for (var i = 0; i < this._columns.length; i++) {
                if (!ej.isNullOrUndefined(this._columns[i]["validationRules"])) {
                    this.setValidationToField(this._columns[i].field, this._columns[i].validationRules);
                }
            }
        },

        setValidationToField: function (name, rules) {
            var ele = $("#" + this._id + name).length > 0 ? $("#" + this._id + name) : $("#" + name);
            ele.rules("add", rules);
            var validator = $("#" + this._id + "EditForm").validate();
            if (!ej.isNullOrUndefined(rules["required"])) {
                validator.settings.messages["Name"] = {};
                validator.settings.messages["Name"]["required"] = ej.TreeGrid.getColumnByField(this._columns, name).headerText + " is required";
            }
        },

        _createConnectorLinesCollection: function (args) {

            var proxy = this,
                model = this.model,
                recordLength = model.currentViewData.length,
                count,
                prdecessorIndex = -1,
                predecessorsCollection,
                ganttRecord,
                connectorLinesCollection = proxy._predecessorsCollection,
                connectorLinesLength = connectorLinesCollection.length,
                x = connectorLinesLength / 2,
                connectorLinesCount,
                enableVirtualization = model.enableVirtualization,
                record;


            if (model.enableVirtualization && args === "Load") {
                //THis is done for validate all the record during load time
                recordLength = model.updatedRecords.length;
                for (count = 0; count < recordLength; count++) {
                    ganttRecord = model.updatedRecords[count];
                    predecessorsCollection = ganttRecord["predecessor"];
                    if (predecessorsCollection) {
                        record = ganttRecord;
                        proxy._addPredecessorsCollection(ganttRecord, predecessorsCollection);
                    }
                }
            }
            else {

                for (count = 0; count < recordLength; count++) {
                    ganttRecord = model.currentViewData[count];
                    if (enableVirtualization === false && ganttRecord.isExpanded === false)
                        continue;
                    if (model.currentViewData.indexOf(ganttRecord) !== -1) {
                        predecessorsCollection = ganttRecord["predecessor"];
                        if (predecessorsCollection) {
                            record = ganttRecord;
                            proxy._addPredecessorsCollection(ganttRecord, predecessorsCollection);
                        }
                    }
                }

            }
            proxy._$ganttchartHelper && proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines", proxy._connectorLinesCollection);
        },

        _addPredecessorsCollection: function (ganttRecord, predecessorsCollection) {
            var proxy = this,
                predecessorsLength,
                predecessorCount,
                predecessor,
                parentGanttRecord,
                childGanttRecord,
                model = proxy.model,
                connectorObj = {},
                predecessorValue = [],
                flatRecords = model.flatRecords,
                updatedRecords = model.updatedRecords,
                ids = model.ids;

            if (predecessorsCollection) {

                predecessorsLength = predecessorsCollection.length;

                for (predecessorCount = 0; predecessorCount < predecessorsLength; predecessorCount++) {

                    predecessor = predecessorsCollection[predecessorCount];


                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];

                        if (!model.enableVirtualization) {
                            if ((parentGanttRecord && parentGanttRecord.isExpanded === false) || 
                                (childGanttRecord && childGanttRecord.isExpanded === false))
                                continue;
                        }

                        if (proxy._isValidationEnabled && !proxy._isInExpandCollapse && childGanttRecord)
                           proxy._validatePredecessorDates(childGanttRecord);
                }

                //for calculate auto schedule only validation is enough  
                if (!proxy._enableCreateCollection)
                    return;

				// for correct re draw the alreadey created line in multiple predecessor for same task
                var count = 0;
                 $.each(predecessorsCollection, function (inx, value) {

                    if (value.to === ganttRecord.taskId.toString()) {
                        count++;
                    }
                    return count;
                });
				
				
				
                    for (predecessorCount = 0; predecessorCount < predecessorsLength; predecessorCount++) {

                        predecessor = predecessorsCollection[predecessorCount];
						if (count > 1)
                        {
                            predecessor.isdrawn = false;
                        }
						
						parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
						childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];

                    if (updatedRecords.indexOf(parentGanttRecord) === -1 || updatedRecords.indexOf(childGanttRecord) == -1)
                                continue;

                            if (!model.enableVirtualization) {
                                if (parentGanttRecord.isExpanded === false || childGanttRecord.isExpanded === false)
                                    continue;
                            }

                            //if (proxy._isValidationEnabled && !proxy._isInExpandCollapse)
                            //    proxy._validateChildGanttRecord(parentGanttRecord, childGanttRecord, predecessor);

                        if (parentGanttRecord && childGanttRecord) {

                            connectorObj = proxy._createConnectorLineObject(parentGanttRecord, childGanttRecord, predecessor);
                          
                            if (connectorObj) {

                                if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId) == -1) {

                                    proxy._connectorLinesCollection.push(connectorObj);
                                    proxy._connectorlineIds.push(connectorObj.ConnectorLineId);
                                }
                                else if (proxy._connectorlineIds.length == 0) {
                                    proxy._connectorLinesCollection.push(connectorObj);
                                    proxy._connectorlineIds.push(connectorObj.ConnectorLineId);
                                }
                                else if (proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId) != -1) {
                                    var index = proxy._connectorlineIds.indexOf(connectorObj.ConnectorLineId);
                                    proxy._connectorLinesCollection[index] = connectorObj;
                                }
                                predecessor.isdrawn = true;
                            }
                        }
                   // }
                }

            }
          
        },
        //create connector line object collection for rendering
        _createConnectorLineObject: function (parentGanttRecord, childGanttRecord, predecessor) {
            var connectorObj = {},
                proxy = this,
                model = proxy.model,
                parentTop,
                childTop,
                updatedRecords = model.updatedRecords,
                parentIndex = updatedRecords.indexOf(parentGanttRecord),
                childIndex = updatedRecords.indexOf(childGanttRecord),
                count = 0,
                index = 0;
            
            if (parentIndex === -1 || childIndex === -1){
                return;
            }
            if (!model.enableVirtualization) {
                var collapsedCount = 0;
                if (childIndex > parentIndex) {
                    
                    for (count = 0; count < parentIndex; count++) {
                        if (updatedRecords[count].isExpanded===false)
                            ++collapsedCount;
                    }
                    index = parentIndex;
                    parentIndex -= collapsedCount;
                    
                    for (index; index < childIndex; index++) {
                        if (updatedRecords[index].isExpanded === false)
                            ++collapsedCount;
                    }
                    childIndex -= collapsedCount;
                }
                else if (parentIndex > childIndex) {
                    for (count = 0; count < childIndex; count++) {
                        if (updatedRecords[count].isExpanded === false)
                            ++collapsedCount;
                    }
                    index = childIndex;
                    childIndex -= collapsedCount;
                    
                    for (index ; index < parentIndex; index++) {
                        if (updatedRecords[index].isExpanded === false)
                            ++collapsedCount;
                    }
                    parentIndex -= collapsedCount;
                }
            }

            var chartObject = $("#ejGanttChart" + proxy._id).ejGanttChart("instance");
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                var rowHeight = model.rowHeight;
            } else {
                var rowHeight = $("#" + chartObject._$ganttViewTablebody[0].id).find("tr:first")[0].getBoundingClientRect().height;
            }
            if (parentIndex != -1 && childIndex != -1) {
                //As Milestone position as changed to midpoint, hence reducing predecessor left based on milestone left point.
                connectorObj["ParentLeft"] = parentGanttRecord.isMilestone ? parentGanttRecord['left'] - proxy._milesStoneWidth / 2 : parentGanttRecord['left'];
                connectorObj["ChildLeft"] = childGanttRecord.isMilestone ? childGanttRecord['left'] - proxy._milesStoneWidth / 2 : childGanttRecord['left'];
                connectorObj["ParentWidth"] = parentGanttRecord['width'] == 0 || parentGanttRecord['isMilestone'] ? (Math.floor(proxy._milesStoneWidth * 1.2)) : parentGanttRecord['width'];
                connectorObj["ChildWidth"] = childGanttRecord['width'] == 0 || childGanttRecord['isMilestone'] ? (Math.floor(proxy._milesStoneWidth * 1.2)) : childGanttRecord['width'];
                connectorObj["ParentIndex"] = parentIndex;
                connectorObj["ChildIndex"] = childIndex;
                connectorObj["RowHeight"] = rowHeight;
                connectorObj["Type"] = predecessor.predecessorsType;
                connectorObj["ConnectorLineId"] = "parent"+ parentGanttRecord['taskId'] + "child" + childGanttRecord['taskId'];                
                connectorObj["milestoneParent"] = parentGanttRecord.isMilestone ? true : false;
                connectorObj["milestoneChild"] = childGanttRecord.isMilestone ? true : false;
                
                return connectorObj;
            }
        },

        /* update date as per offset value */
        _updateDateByOffset: function (date, predecessor, isMilestone, record)
        {
            var resultDate,
                offsetValue = predecessor.offset,
                durationUnit = predecessor.offsetDurationUnit;
            if (offsetValue < 0) {
                resultDate = this._getStartDate(this._checkEndDate(date, record), (offsetValue * -1), durationUnit, record);
            } else {
                resultDate = this._getEndDate(date, offsetValue, durationUnit, record, false);
                if (!isMilestone)
                    resultDate = this._checkStartDate(resultDate, record);
            }
            return resultDate;
        },

        //Validate the child Gantt Record
        _validateChildGanttRecord: function (parentGanttRecord, childGanttRecord, predecessor, predecessorValidation,offsetChanged) {
            var proxy = this,
            model = proxy.model,
            predecessorType;

            if (proxy._editedTaskBarItem === childGanttRecord) {
                return;
            }
            if (predecessorValidation) {
                switch (predecessor.predecessorsType) {

                    case 'SS':
                        var currentTaskId = childGanttRecord['taskId'].toString(),
                            predecessorsCollection = childGanttRecord['predecessor'],
                            childPredecessor = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                            minStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                        childGanttRecord.startDate = new Date(minStartDate);
                        childGanttRecord._calculateEndDate(this);
                        childGanttRecord.left = childGanttRecord._calculateLeft(this);
                        childGanttRecord.width = childGanttRecord._calculateWidth(this);
                        childGanttRecord.progressWidth = childGanttRecord._getProgressWidth(childGanttRecord.width, childGanttRecord.status);
                        break;

                    case 'SF':
                        var currentTaskId = childGanttRecord['taskId'].toString(),
                            predecessorsCollection = childGanttRecord['predecessor'],
                            childPredecessor = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                            minStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                        childGanttRecord.startDate = new Date(minStartDate);
                        childGanttRecord._calculateEndDate(this);
                        childGanttRecord.left = childGanttRecord._calculateLeft(this);
                        childGanttRecord.width = childGanttRecord._calculateWidth(this);
                        childGanttRecord.progressWidth = childGanttRecord._getProgressWidth(childGanttRecord.width, childGanttRecord.status);
                        break;

                    case 'FS':

                        var predecessorsCollection = childGanttRecord['predecessor'],
                            currentTaskId = childGanttRecord['taskId'].toString(),
                            childPredecessor = predecessorsCollection && predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                            maxStartDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);

                        childGanttRecord.startDate = new Date(maxStartDate);
                        childGanttRecord._calculateEndDate(this);
                        childGanttRecord.left = childGanttRecord._calculateLeft(this);
                        childGanttRecord.width = childGanttRecord._calculateWidth(this);
                        childGanttRecord.progressWidth = childGanttRecord._getProgressWidth(childGanttRecord.width, childGanttRecord.status);

                        break;

                    case 'FF':
                        var currentTaskId = childGanttRecord['taskId'].toString(),
                            predecessorsCollection = childGanttRecord['predecessor'],
                            childPredecessor = predecessorsCollection && predecessorsCollection.filter(function (data) { return data.to === currentTaskId });
                        childGanttRecord.startDate = proxy._getPredecessorDate(childGanttRecord, childPredecessor, predecessor.predecessorsType);
                        childGanttRecord._calculateEndDate(this);
                        childGanttRecord.left = childGanttRecord._calculateLeft(this);
                        childGanttRecord.width = childGanttRecord._calculateWidth(this);
                        childGanttRecord.progressWidth = childGanttRecord._getProgressWidth(childGanttRecord.width, childGanttRecord.status);
                        break;
                }
            }
            this._updateItemValueInRecord(childGanttRecord);            

            if (childGanttRecord.parentItem && childGanttRecord.parentItem.isAutoSchedule && predecessorValidation)
                proxy._updateParentItem(childGanttRecord);
            else if (childGanttRecord.parentItem && !childGanttRecord.parentItem.isAutoSchedule && predecessorValidation)
                proxy._updateManualParentItem(childGanttRecord);
            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered) {
                proxy.refreshGanttRecord(childGanttRecord);
            }
        },

        /*Get validated start of task on all predecessor type*/
        _getValidatedStartDate: function (ganttRecord, parentGanttRecord, predecessor) {
            var type = predecessor.predecessorsType,
                offset = predecessor.offset,
                tempDate, returnStartDate;
            switch (type) {
                case "FS":
                    tempDate = new Date(parentGanttRecord.endDate);
                    if (!ganttRecord.isMilestone || offset != 0)
                        tempDate = this._checkStartDate(tempDate, ganttRecord);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        returnStartDate = this._checkStartDate(tempDate, ganttRecord);
                    else
                        returnStartDate = new Date(tempDate);
                    break;
                case "FF":
                    tempDate = new Date(parentGanttRecord.endDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        tempDate = this._checkEndDate(tempDate, ganttRecord);
                    returnStartDate = this._getStartDate(tempDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                    break;
                case "SF":
                    tempDate = new Date(parentGanttRecord.startDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        tempDate = this._checkEndDate(tempDate, ganttRecord);
                    returnStartDate = this._getStartDate(tempDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                    break;
                case "SS":
                    tempDate = new Date(parentGanttRecord.startDate);
                    if (offset != 0)
                        tempDate = this._updateDateByOffset(tempDate, predecessor, ganttRecord.isMilestone, ganttRecord);
                    if (!ganttRecord.isMilestone)
                        returnStartDate = this._checkStartDate(tempDate, ganttRecord);
                    else
                        returnStartDate = tempDate;
                    break;
            }
            return returnStartDate;
        },
        //Get maximum or minimum date as per predecessor type
        _getPredecessorDate: function (ganttRecord, predecessorsCollection) {
            var minStartDate = null, model = this.model,
                maxStartDate = null,
                length, i,
                flatRecords = model.flatRecords,
                ids = model.ids,
                tempStartDate,
                parentGanttRecord,
                childGanttRecord,
                validatedpredecessor = predecessorsCollection.filter(function (data) {
                    if (data.to === ganttRecord.taskId.toString())
                        return true;
                });

            if (validatedpredecessor) {
                length = validatedpredecessor.length;
                for (i = 0; i < length; i++) {
                    var predecessor = validatedpredecessor[i];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    childGanttRecord = flatRecords[ids.indexOf(predecessor.to)];
                    tempStartDate = this._getValidatedStartDate(childGanttRecord, parentGanttRecord, predecessor);
                    if (maxStartDate == null)
                        maxStartDate = new Date(tempStartDate);
                    else if (tempStartDate.getTime() > maxStartDate.getTime())
                        maxStartDate = new Date(tempStartDate);
                }
            }
            return maxStartDate;
        },

        _setBeforeWeekend: function (date) {
            var proxy = this;
            if (proxy._nonWorkingDayIndex(date.getDay()) != -1) {
                date.setDate(date.getDate() - 1);
                proxy._setBeforeWeekend();
                return true;
            }
            return false;
        },
        
        _setAfterWeekend: function (date) {
            var proxy = this;
            if (proxy._nonWorkingDayIndex(date.getDay()) != -1) {
                date.setDate(date.getDate() + 1);
                proxy._setAfterWeekend();
                return true;
            }
            return false;
        },
        
        _updateEditedGanttRecords: function (args,isTrigger) {
            var proxy = this, model = proxy.model,
                ganttRecord = args.data,
                startDate = new Date(ganttRecord.startDate),
                isAutoSchedule = ganttRecord.isAutoSchedule,
                isPredecessorsModified = false;

            if (args.columnName === "startDate") {
                var previousData = $.extend({}, args.data);
                startDate = proxy._checkStartDate(startDate, ganttRecord);
                ganttRecord.startDate = new Date(startDate);
                if (model.startDateMapping)
                    ganttRecord.item[model.startDateMapping] = ganttRecord.startDate;
                ganttRecord._calculateEndDate(this);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);// model.holidays
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
                else {
                    var arg = {};
                    arg.previousData = previousData;
                    arg.data = ganttRecord;
                    proxy._validateAutoChildRecords(arg);
                }
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord);
            }

            else if (args.columnName === "endDate") {
                //validate start date
                var endDate = new Date(ganttRecord.endDate);
                if (endDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, endDate);
                endDate = this._checkEndDate(endDate, ganttRecord);
                ganttRecord.endDate = new Date(endDate);
                if (model.endDateMapping)
                    ganttRecord.item[model.endDateMapping] = ganttRecord.endDate;
                if (ganttRecord.isMilestone) {
                    ganttRecord.startDate = this._checkStartDate(ganttRecord.startDate, ganttRecord);
                    model.startDateMapping && (ganttRecord.item[model.startDateMapping] = ganttRecord.startDate);
                }

                if (startDate.getTime() <= endDate.getTime()) {
                    ganttRecord._calculateDuration(this);
                    ganttRecord.width = ganttRecord._calculateWidth(this);                    
                    if (!ganttRecord.hasChildRecords)
                        ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);

                    if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                        proxy._updateParentItem(ganttRecord);
                    else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                        proxy._updateManualParentItem(ganttRecord);
                }
                else
                {
                    ganttRecord.endDate = args.previousValue;
                    ganttRecord.item[model.endDateMapping] = args.previousValue;
                }
                if (ganttRecord.duration === 0)
                    ganttRecord.isMilestone = true;
                else
                    ganttRecord.isMilestone = false;
                
                proxy._updateResourceRelatedFields(ganttRecord);
            }
            
            else if (args.columnName == "duration" || proxy._isDurationUpdated) {
                var currentDuration = ganttRecord.duration;
                if (currentDuration != 0 && ganttRecord.isMilestone) {
                    ganttRecord.isMilestone = false;
                    ganttRecord.startDate = this._checkStartDate(ganttRecord.startDate, ganttRecord);
                    model.startDateMapping && (ganttRecord.item[model.startDateMapping] = ganttRecord.startDate);
                    ganttRecord.left = ganttRecord._calculateLeft(this);
                }
                if (currentDuration === 0) {
                    ganttRecord.isMilestone = true;
                } else {
                    ganttRecord.isMilestone = false;
                }
                ganttRecord._calculateEndDate(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);

                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateParentItem(ganttRecord);
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                    proxy._updateManualParentItem(ganttRecord);
            }

            else if (args.columnName == "predecessor") {
                isPredecessorsModified = true;
                if (args.previousValue) {
                    proxy._removeConnectorLine(args.previousValue, ganttRecord);
                }
                proxy._addConnectorLine(ganttRecord);
            }

            else if (args.columnName == "status") {
                ganttRecord.status = ganttRecord.status > 100 ? 100 : ganttRecord.status;
                if (!ganttRecord.hasChildRecords)
                    ganttRecord.progressWidth = proxy._getProgressWidth(ganttRecord.width, ganttRecord.status);
                if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule) {                    
                    proxy._updateParentItem(ganttRecord);
                }
                else if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule) {                    
                    proxy._updateManualParentItem(ganttRecord);
                }
            }
            else if (args.columnName == "taskMode") {
                proxy._updateGanttRecord(ganttRecord);
            }
            else if (args.columnName == "baselineStartDate" || args.columnName == "baselineEndDate")
            {
                var baseLineStartDate = proxy._getDateFromFormat(ganttRecord.baselineStartDate),
                    baseLineEndDate = proxy._getDateFromFormat(ganttRecord.baselineEndDate);
                if (baseLineEndDate && baseLineEndDate.getHours() == 0 && this._defaultEndTime != 86400)
                    this._setTime(this._defaultEndTime, baseLineEndDate);
                ganttRecord.baselineStartDate = this._checkBaseLineStartDate(baseLineStartDate);
                ganttRecord.baselineEndDate = this._checkBaseLineEndDate(baseLineEndDate);
                if (ganttRecord.baselineStartDate && ganttRecord.baselineEndDate) {
                    ganttRecord.baselineLeft = ganttRecord._calculateBaselineLeft(this);
                    ganttRecord.baselineRight = ganttRecord._calculateBaselineRight(this);
                    ganttRecord.baselineWidth = ganttRecord._calculateBaseLineWidth(this);
                }
            }
            //proxy._updateEditedGanttRecord(ganttRecord);
            if (ganttRecord.predecessor) {
                
                proxy._isMileStoneEdited = ganttRecord.isMilestone;
                proxy._updatedConnectorLineCollection = [];
                proxy._connectorlineIds = [];
                if (args.columnName === "predecessor") {
                    if (model.enablePredecessorValidation)
                        proxy._validatePredecessor(ganttRecord, args.previousValue);
                    else{
                        var manualOffsetEditing=true;
                        proxy._validatePredecessorOnEditing(ganttRecord, manualOffsetEditing);
                    }
                }
                else
                    proxy._validatePredecessor(ganttRecord, undefined, "successor");
                if (proxy._updatedConnectorLineCollection.length > 0) {
                    proxy._$ganttchartHelper.ejGanttChart("appendConnectorLine", proxy._updatedConnectorLineCollection);
                    this._updateConnectorLineCollection(proxy._updatedConnectorLineCollection);
                }
            }
            proxy._isValidationEnabled = false;
            if(isTrigger)
                proxy.refreshGanttRecord(ganttRecord);
        },

        _removeConnectorLine: function (predecessor,ganttRecord) {
            var proxy = this,
                model = this.model,
                connectorLineId,
                parentGanttRecord,
                record,
                i = 0,
                length = predecessor && predecessor.length,
                index = -1,
                flatRecords = model.flatRecords,
                ids = model.ids;
                
            for (i = 0; i < length; i++) {
                parentGanttRecord = flatRecords[ids.indexOf(predecessor[i].from)];
                record = flatRecords[ids.indexOf(predecessor[i].to)];
                
                if (ganttRecord.taskId.toString() === predecessor[i].to.toString()) {
                    
                    index = parentGanttRecord.predecessor.indexOf(predecessor[i]);
                    index >= 0 && parentGanttRecord.predecessor.splice(index, 1);
                }

                if (parentGanttRecord && record) {
                    connectorLineId = "parent"+parentGanttRecord['taskId'] + "child" + record['taskId'];
                    proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                    this._updateConnectorLineCollection(connectorLineId);
                }
            }
        },

        _addConnectorLine:function(ganttRecord) {
            var proxy = this,
                count = 0,
                model = proxy.model,
                predecessors = ganttRecord.predecessor,
                length,
                predecessor,
                flatRecords = model.flatRecords,
                ids = model.ids,
                successorGanttRecord;

            if (predecessors) {

                length = predecessors.length;

                for (count = 0; count < length; count++) {

                    predecessor = predecessors[count];
                    
                    if (predecessor.to === ganttRecord.taskId.toString()) {
                        successorGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    }

                    if (successorGanttRecord) {
                        if (successorGanttRecord.predecessor) {
                            successorGanttRecord.predecessor.push(predecessor);
                        } else {
                            successorGanttRecord.predecessor = [];
                            successorGanttRecord.predecessor.push(predecessor);
                            proxy._predecessorsCollection.push(successorGanttRecord);
                        }
                    }
                }
            }
        },

        _updateEditedGanttRecord: function (ganttRecord) {
            var proxy = this;
            if (ganttRecord.predecessor) {
                var predecessorsCollection = ganttRecord.predecessor,
                    count = 0,
                    length = predecessorsCollection.length,
                    predecessor,
                    parentGanttRecord,
                    record,
                    connectorLineId,
                    connectorLineObject,
                    model = proxy.model,
                    flatRecords = model.flatRecords,
                    ids = model.ids;

                for (count = 0; count < length; count++) {
                    proxy._updatedConnectorLineCollection = [];
                    proxy._connectorlineIds = [];
                    predecessor = predecessorsCollection[count];
                    if (predecessor.to === ganttRecord['taskId'].toString()) {

                        parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                        record = flatRecords[ids.indexOf(predecessor.to)];
                        
                        if (parentGanttRecord && record) {
                            connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                            proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                            this._updateConnectorLineCollection(connectorLineId);                            
                            proxy._updateConnectorLineId(parentGanttRecord, record, predecessor)
                        }                        
                    }
                }
            }
        },
        

        _updateTargetGanttRecord: function (ganttRecord) {
            var proxy = this,
                model = proxy.model;
            ganttRecord.startDate = proxy._checkStartDate(ganttRecord.startDate, ganttRecord);
            ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
            ganttRecord.left = ganttRecord._calculateLeft(this);
            ganttRecord.width = ganttRecord._calculateWidth(this);
            ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
            if (ganttRecord.parentItem) {
                if (ganttRecord.parentItem.isAutoSchedule == true) {
                    proxy._updateParentItem(ganttRecord);
                }
                else {
                    proxy._updateManualParentItem(ganttRecord);
                }
            }
            proxy.refreshGanttRecord(ganttRecord);
        },

        _updateGanttRecord: function (ganttRecord) {
            var proxy = this,
                model = proxy.model;

            if (ganttRecord.hasChildRecords && ganttRecord.isAutoSchedule) {
                ganttRecord.startDate = proxy._checkStartDate(ganttRecord.manualStartDate, ganttRecord);                
                ganttRecord.left = ganttRecord._calculateManualLeft(this);
                ganttRecord.width = ganttRecord._calculateManualWidth(this);
                ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);                
                ganttRecord.endDate = ganttRecord.manualEndDate;
                ganttRecord._calculateDuration(this);
            }
            else if (ganttRecord.hasChildRecords && !ganttRecord.isAutoSchedule) {                
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord._calculateDuration(this);
                ganttRecord.manualStartDate = ganttRecord.startDate;
                ganttRecord.manualEndDate = ganttRecord.endDate;                
                proxy._updateManualParentItem(ganttRecord, null, true);
            }
            else {
                ganttRecord.startDate = proxy._checkStartDate(ganttRecord.startDate, ganttRecord);
                ganttRecord.endDate = this._getEndDate(ganttRecord.startDate, ganttRecord.duration, ganttRecord.durationUnit, ganttRecord);
                ganttRecord.left = ganttRecord._calculateLeft(this);
                ganttRecord.width = ganttRecord._calculateWidth(this);
                ganttRecord.progressWidth = ganttRecord._getProgressWidth(ganttRecord.width, ganttRecord.status);
            }
            if (ganttRecord.parentItem && ganttRecord.parentItem.isAutoSchedule)
                proxy._updateParentItem(ganttRecord);
            if (ganttRecord.parentItem && !ganttRecord.parentItem.isAutoSchedule)
                proxy._updateManualParentItem(ganttRecord);

            proxy.refreshGanttRecord(ganttRecord);
        },

        refreshGanttRecord: function (ganttRecord) {
            var proxy = this;
            if (proxy._isTreeGridRendered) {
                proxy.model.currentViewData = proxy.getCurrentViewData();
                var index = proxy.model.currentViewData.indexOf(ganttRecord);
                var treegridObject = proxy._$treegridHelper.ejTreeGrid("instance");
                treegridObject.model.allowSelection = proxy.model.allowSelection;
                ej.TreeGrid.refreshRow(treegridObject, index);
                if (proxy._isGanttChartRendered) {
                    proxy._$ganttchartHelper.ejGanttChart("refreshRow", index);
                }
                
                if (!proxy._isLastRefresh) {
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == ganttRecord.taskId) {
                            return index;
                        }
                    });
                    if (index.length)
                        proxy._actionCompleteData[index[0]] = ganttRecord;
                    else
                        proxy._actionCompleteData.push(ganttRecord);
                }
                else
                {
                    //Client side event is triggerd for upadte the server side database
                    var eventArgs = {};
                    eventArgs.data = ganttRecord;
                    eventArgs.item = ganttRecord.item;
                    eventArgs.requestType = "recordUpdate";
                    var index = $.map(proxy._actionCompleteData, function (data, index) {
                        if (data.taskId == ganttRecord.taskId) {
                            return index;
                        }
                    });
                    index.length && proxy._actionCompleteData.splice(index[0], 1);
                    if (proxy._actionCompleteData.length) {
                        eventArgs.updatedRecords = proxy._actionCompleteData;
                        proxy._actionCompleteData = [];
                    }
                    proxy._isLastRefresh = false;
                    proxy._trigger("actionComplete",eventArgs);
                }
            }
        },

        _updateManualParentItem: function (ganttRecord, editmode, isParent) {

            var proxy = this,
                parentGanttRecord = isParent ? ganttRecord : ganttRecord.parentItem,
                model = proxy.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                prevStartDate = new Date(parentGanttRecord.startDate),
                prevManualStartDate = new Date(parentGanttRecord.manualStartDate),
                currentStartDate = new Date(ganttRecord.startDate),
                prevEndDate = new Date(parentGanttRecord.endDate),
                prevManualEndDate = new Date(parentGanttRecord.manualEndDate),
                currentEndDate = new Date(ganttRecord.endDate);                    
           
            if (currentStartDate.getTime() < prevManualStartDate.getTime()) {
                parentGanttRecord.manualStartDate = ganttRecord.startDate;                
            }

            if (currentEndDate.getTime() > prevEndDate.getTime() && proxy._isLoad) {
                //dateDiff = proxy._daydiff(prevEndDate, currentEndDate);                                
            }

            if (currentEndDate.getTime() > prevManualEndDate.getTime()) {
                parentGanttRecord.manualEndDate = ganttRecord.endDate;
                //dateManualDiff = proxy._daydiff(prevManualEndDate, currentEndDate);                
            }

            var count = 0,
                childRecords = parentGanttRecord.childRecords,
                length = childRecords && childRecords.length,
                childGanttRecord,
                index = null,
                minStartDate = null,
                maxEndDate = null,
                parentProgress = 0,
                milestoneCount = 0,
                totalProgress = 0,               
                childCompletedWorks = 0;

            for (count = 0; count < length; count++) {

                childGanttRecord = childRecords[count];

                if (!childGanttRecord.isAutoSchedule && childGanttRecord.hasChildRecords) {

                    var childManualStartDate = new Date(childGanttRecord.manualStartDate),
                        childManualEndDate = new Date(childGanttRecord.manualEndDate),
                        childNormalStartDate = new Date(childGanttRecord.startDate),
                        childNormalEndDate = new Date(childGanttRecord.endDate),

                        childStartDate = childManualStartDate.getTime() < childNormalStartDate.getTime() ? childGanttRecord.manualStartDate : childGanttRecord.startDate,
                        childEndDate = childManualEndDate.getTime() > childNormalEndDate.getTime() ? childGanttRecord.manualEndDate : childGanttRecord.endDate;
                }
                else {
                    var childStartDate = childGanttRecord.startDate,
                        childEndDate = childGanttRecord.endDate;
                }

                if (minStartDate === null) {
                    minStartDate = new Date(childStartDate);
                }
                if (maxEndDate === null) {
                    maxEndDate = new Date(childEndDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (childEndDate.getTime() > maxEndDate.getTime()) {
                    maxEndDate = new Date(childEndDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (childStartDate.getTime() < minStartDate.getTime()) {
                    minStartDate = new Date(childStartDate);
                }

                childCompletedWorks += parseInt(childGanttRecord.work);

                if (!childGanttRecord.isMilestone)
                    totalProgress += parseInt(childGanttRecord.status);
                else
                    milestoneCount++;
            }

            if (prevManualStartDate.getTime() !== minStartDate.getTime()) {
                parentGanttRecord.manualStartDate = new Date(minStartDate);                
            }

            if (prevManualEndDate.getTime() != maxEndDate.getTime()) {
                parentGanttRecord.manualEndDate = new Date(maxEndDate);                
            }
           
            if (proxy._isLoad || proxy._isChartRendering) {
                parentGanttRecord._calculateDuration(this);
                parentGanttRecord.width = parentGanttRecord._calculateWidth(this);
            }
                
            parentGanttRecord.left = parentGanttRecord._calculateLeft(this);
            parentGanttRecord.manualLeft = parentGanttRecord._calculateManualLeft(this);
            parentGanttRecord._calculateManualDuration(this);
            parentGanttRecord.manualWidth = parentGanttRecord._calculateManualWidth(this);            

            //update parent works 
            parentGanttRecord._updateWorkWithDuration(proxy);
            //Add child works to parent
            parentGanttRecord.work += childCompletedWorks;

            if (model.workMapping)
                parentGanttRecord.item[model.workMapping] = parentGanttRecord.work;

            //Calculate progressWidth after left and width calulation            
            var taskCount = length - milestoneCount;
            parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;
            parentGanttRecord.progressWidth = proxy._getProgressWidth(parentGanttRecord.manualWidth, parentProgress);
            parentGanttRecord.status = Math.floor(parentProgress);

            if (model.progressMapping)
                parentGanttRecord.item[model.progressMapping] = parentGanttRecord.status;

            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered)
                proxy.refreshGanttRecord(parentGanttRecord);

            if (parentGanttRecord.parentItem && parentGanttRecord.parentItem.isAutoSchedule && !isParent) {
                proxy._updateParentItem(parentGanttRecord);
            }
            else if (parentGanttRecord.parentItem && !parentGanttRecord.parentItem.isAutoSchedule && !isParent)
                proxy._updateManualParentItem(parentGanttRecord,editmode);
        },

        _updateParentItem: function (ganttRecord, editmode, isParent) {

            var proxy = this,
                parentGanttRecord = isParent ? ganttRecord : ganttRecord.parentItem,                               
                model = proxy.model,
                headerType = model.scheduleHeaderSettings.scheduleHeaderType,
                headerValue = ej.Gantt.ScheduleHeaderType,
                prevStartDate = new Date(parentGanttRecord.startDate),
                currentStartDate = new Date(ganttRecord.startDate),
                prevEndDate = new Date(parentGanttRecord.endDate),
                currentEndDate = new Date(ganttRecord.endDate);
                            
            
            if (currentStartDate.getTime() < prevStartDate.getTime()) {
                parentGanttRecord.startDate = ganttRecord.startDate;
                if (model.startDateMapping)
                    parentGanttRecord.item[model.startDateMapping] = parentGanttRecord.startDate;                
            }

            if (currentEndDate.getTime() > prevEndDate.getTime()) {                
                //dateDiff = proxy._daydiff(prevEndDate, currentEndDate);
                parentGanttRecord.endDate = ganttRecord.endDate;
                if(model.endDateMapping)
                    parentGanttRecord.item[model.endDateMapping] = parentGanttRecord.endDate;

            }

            var count = 0,
                childRecords = parentGanttRecord.childRecords,
                length = childRecords && childRecords.length,
                childGanttRecord,
                index = null,
                minStartDate = null,
                maxEndDate = null,
                parentProgress = 0,
                milestoneCount = 0,
                totalProgress = 0,               
                childCompletedWorks = 0;

            for (count = 0; count < length; count++) {

                childGanttRecord = childRecords[count];
                var startDate = childGanttRecord.startDate,
                                    endDate = childGanttRecord.endDate;

                if (childGanttRecord.hasChildRecords && !childGanttRecord.isAutoSchedule) {
                    startDate = childGanttRecord.startDate.getTime() > childGanttRecord.manualStartDate.getTime() ?
                                    childGanttRecord.manualStartDate : childGanttRecord.startDate;
                }

                if (childGanttRecord.hasChildRecords && !childGanttRecord.isAutoSchedule) {
                    endDate = childGanttRecord.endDate.getTime() < childGanttRecord.manualEndDate.getTime() ?
                                    childGanttRecord.manualEndDate : childGanttRecord.endDate;
                }

                if (minStartDate === null) {
                    minStartDate = new Date(startDate);
                }
                if (maxEndDate === null) {
                    maxEndDate = new Date(endDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (endDate.getTime() > maxEndDate.getTime()) {
                    maxEndDate = new Date(endDate);
                    index = model.flatRecords.indexOf(childGanttRecord);
                }
                if (startDate.getTime() < minStartDate.getTime()) {
                    minStartDate = new Date(startDate);
                }

                childCompletedWorks += parseInt(childGanttRecord.work);

                if (!childGanttRecord.isMilestone) {
                    totalProgress += parseInt(childGanttRecord.status);
                }
                else
                    milestoneCount++;
            }

            if (prevStartDate.getTime() !== minStartDate.getTime()) {
                parentGanttRecord.startDate = new Date(minStartDate);
                if (model.startDateMapping)
                    parentGanttRecord.item[model.startDateMapping] = parentGanttRecord.startDate;
            }
            
            if (prevEndDate.getTime() != maxEndDate.getTime()) {                                                       
                parentGanttRecord.endDate = new Date(maxEndDate);
                if(model.endDateMapping)
                    parentGanttRecord.item[model.endDateMapping] = parentGanttRecord.endDate;

            }

            parentGanttRecord._calculateDuration(this);
            parentGanttRecord.left = parentGanttRecord._calculateLeft(this);
            parentGanttRecord.width = parentGanttRecord._calculateWidth(this);
            if (milestoneCount == parentGanttRecord.childRecords.length) {
                if (parentGanttRecord.startDate.getTime() == parentGanttRecord.endDate.getTime())
                    parentGanttRecord.width = Math.floor((model.rowHeight - 6) / 2) * 2; //milestone width
                else
                    parentGanttRecord.width += Math.floor((model.rowHeight - 6) / 2) * 2;
            }

            //Calculate progressWidth after Left and width calculation
            var taskCount = length - milestoneCount;
            parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;            
            parentGanttRecord.progressWidth = proxy._getProgressWidth(parentGanttRecord.width, parentProgress);
            parentGanttRecord.status = Math.floor(parentProgress);

            //update parent works 
            parentGanttRecord._updateWorkWithDuration(proxy);
            //Add child works to parent
            parentGanttRecord.work += childCompletedWorks;

            if (model.workMapping)
                parentGanttRecord.item[model.workMapping] = parentGanttRecord.work;

            //Default Values of Parent tasks.
            parentGanttRecord.taskType = ej.Gantt.TaskType.FixedDuration;
            parentGanttRecord.effortDriven = "false";

            parentGanttRecord.manualStartDate = parentGanttRecord.startDate;
            parentGanttRecord.manualEndDate = parentGanttRecord.endDate;

            if (model.progressMapping)
                parentGanttRecord.item[model.progressMapping] = parentGanttRecord.status;

            if (proxy._isTreeGridRendered || proxy._isGanttChartRendered)
                proxy.refreshGanttRecord(parentGanttRecord);

            if (parentGanttRecord.parentItem && parentGanttRecord.parentItem.isAutoSchedule && !isParent) {
                proxy._updateParentItem(parentGanttRecord);
            }
            else if (parentGanttRecord.parentItem && !parentGanttRecord.parentItem.isAutoSchedule && !isParent)
                proxy._updateManualParentItem(parentGanttRecord);
        },
        UpdatePredecessor: function () {
            var proxy = this;
            proxy._updatedRecordsDateByPredecessor();
            
            proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
            proxy._connectorLinesCollection = [];
            proxy._createConnectorLinesCollection();
            proxy._$ganttchartHelper.ejGanttChart("renderConnectorLines",
                proxy._connectorLinesCollection);
        },

        /* updated all records dates as per predecessor and successor collections */
        _updatedRecordsDateByPredecessor:function()
        {
            var proxy = this, model = this.model,
                flatRecords = model.flatRecords, length = flatRecords.length;
            for (var count = 0; count < length ; count++) {
                (flatRecords[count].predecessor && flatRecords[count].item[model.predecessorMapping]) && proxy._validatePredecessorDates(flatRecords[count]);
            }
        },

        /* updated the record dates as per predecessor and successor collections */
        _validatePredecessorDates: function (childGanttRecord) {

            var proxy = this, model = proxy.model;

            if (childGanttRecord.predecessor) {

                var predecessorsCollection = childGanttRecord['predecessor'],
                    count,
                    parentGanttRecord,
                    record = null,
                    isValidated = false,
                    predecessor,
                    lowestOffset,
                    flatRecords = model.flatRecords,
                    ids = model.ids;

                var currentTaskId = childGanttRecord['taskId'].toString(),
                    predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                    successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId });
                var predecessorLength = predecessors.length;

                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    if (record.isAutoSchedule || model.validateManualTasksOnLinking)
                        proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation);
                }

                var length = successors.length;

            }
        },


        _validatePredecessor: function (childGanttRecord, previousValue, validationOn) {

            var proxy = this, model = proxy.model;

            if (childGanttRecord.predecessor) {

                var predecessorsCollection = childGanttRecord['predecessor'],
                    count,                    
                    parentGanttRecord,
                    record=null,
                    connectorLineId,
                    isValidated = false,
                    predecessor,
                    connectorLineObject,
                    lowestOffset,
                    flatRecords = model.flatRecords,
                    ids = model.ids,
                     isOffsetChanged = false;

                var currentTaskId = childGanttRecord['taskId'].toString(),

                    predecessors = predecessorsCollection.filter(function (data) { return data.to === currentTaskId }),
                    successors = predecessorsCollection.filter(function (data) { return data.from === currentTaskId });
               var predecessorLength = predecessors.length;

                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                    if (proxy._$ganttchartHelper) {
                        proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                        this._updateConnectorLineCollection(connectorLineId);
                    }

                    if (model.enablePredecessorValidation && (record.isAutoSchedule || model.validateManualTasksOnLinking))
                       proxy._isValidationEnabled = true;
                   else
                       proxy._isValidationEnabled = false;
                   if ((childGanttRecord.taskId.toString() === predecessor.to || childGanttRecord.taskId.toString() === predecessor.from) &&
                       (!validationOn || validationOn == "predecessor"))
                       proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                }
                for (count = 0; count < predecessorLength; count++) {
                    predecessor = predecessors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];//THis is going to exception when id is not corrct order
                    record = flatRecords[ids.indexOf(predecessor.to)];
             
                    if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))//(model.enableVirtualization === false && !parentGanttRecord.isExpanded && record.isExpanded === false)
                        continue;
                    connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                    if (connectorLineObject) {
                        if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.length == 0) {
                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                            var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                            proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                        }
                    }                   

                }

                var length = successors.length;

                for (count = 0; count < length; count++) {

                    predecessor = successors[count];
                    parentGanttRecord = flatRecords[ids.indexOf(predecessor.from)];
                    record = flatRecords[ids.indexOf(predecessor.to)];
                    connectorLineId = "parent" + parentGanttRecord['taskId'] + "child" + record['taskId'];
                    isOffsetChanged = proxy._isOffsetChange(predecessor, previousValue, count);
                    if (model.enablePredecessorValidation && (record.isAutoSchedule || model.validateManualTasksOnLinking))
                        proxy._isValidationEnabled = true;
                    else
                        proxy._isValidationEnabled = false;
                    if (proxy._$ganttchartHelper) {
                        proxy._$ganttchartHelper.ejGanttChart("removeConnectorline", connectorLineId);
                        this._updateConnectorLineCollection(connectorLineId);
                    }
                    if (validationOn != "predecessor" && proxy._isValidationEnabled)
                        proxy._validateChildGanttRecord(parentGanttRecord, record, predecessor, model.enablePredecessorValidation, isOffsetChanged);
                    if ((model.enableVirtualization === false && (parentGanttRecord.isExpanded === false || record.isExpanded == false)))
                        continue;
                    connectorLineObject = proxy._createConnectorLineObject(parentGanttRecord, record, predecessor);
                    if (connectorLineObject) {
                        if (proxy._connectorlineIds.length > 0 && proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) == -1) {

                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.length == 0) {
                            proxy._updatedConnectorLineCollection.push(connectorLineObject);
                            proxy._connectorlineIds.push(connectorLineObject.ConnectorLineId);
                        }
                        else if (proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId) != -1) {
                            var index = proxy._connectorlineIds.indexOf(connectorLineObject.ConnectorLineId);
                            proxy._updatedConnectorLineCollection[index] = connectorLineObject;
                        }
                    }

                    record && proxy._validatePredecessor(record, undefined, "successor");

                }                
            }
        },

        /*While zooming the browser we have re-rendered the connector lines collection
        for this we need keep the connectot lines collection updated*/
        _updateConnectorLineCollection: function (connectorLines) {
            if (typeof connectorLines == "string") {
                for (var count = 0; count < this._connectorLinesCollection.length; count++) {
                    if (this._connectorLinesCollection[count].ConnectorLineId == connectorLines) {
                        this._connectorLinesCollection.splice(count, 1);
                        break;
                    }
                }
            } else {
                for (var count = 0; count < connectorLines.length; count++) {
                    var currentObj, index = 0;
                    for (var inCount = 0; inCount < this._connectorLinesCollection.length; inCount++) {
                        if (this._connectorLinesCollection[inCount].ConnectorLineId == connectorLines[count].ConnectorLineId) {
                            currentObj = connectorLines[count];
                            index = count;
                            break;
                        }
                    }
                    if (currentObj)
                        this._connectorLinesCollection[index] = currentObj;
                    else
                        this._connectorLinesCollection.push(connectorLines[count]);
                }
            }
        },
        // Check whether the predecessor offset is changed or not.
        _isOffsetChange: function (predecessor, previousValue, count)
        {
            var proxy = this,
                model = proxy.model,
                isOffsetChanged = false;
            if (!model.enablePredecessorValidation) {
                if (previousValue && previousValue.length) {
                    var predecessorOffset = predecessor.offset ? parseInt(predecessor.offset) : 0,
                        previousPredecessor = previousValue[count],
                        previousPredecessorOffset = previousPredecessor.offset ? parseInt(previousPredecessor.offset) : 0;
                    isOffsetChanged = predecessorOffset != previousPredecessorOffset ? true : false;

                }
                else if (ej.isNullOrUndefined(previousValue)) {
                    isOffsetChanged = false;
                }
                else
                    isOffsetChanged = true;
            }
            return isOffsetChanged;
        },

        _daydiff: function (first, second) {
            return ((new Date(second) - new Date(first)) / (1000 * 60 * 60 * 24));
        },

        //refresh treegrid and gantt rows
        _refreshChartAndGridRows: function ()
        {
            var proxy = this, model = this.model, collapsedRecordCount, height;
            proxy._$treegridHelper.ejTreeGrid("processBindings");
            var tempArgs = {};
            tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
            proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
            proxy.model.updatedRecords = proxy.getUpdatedRecords();
            proxy.model.currentViewData = proxy.getCurrentViewData();
            collapsedRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
            proxy._totalCollapseRecordCount = collapsedRecordCount;
            height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;
            proxy._$ganttchartHelper.ejGanttChart("setUpdatedRecords", model.currentViewData, model.updatedRecords, model.flatRecords, model.ids);
            proxy._$ganttchartHelper.ejGanttChart("refreshHelper", model.currentViewData, model.updatedRecords, proxy._totalCollapseRecordCount);
            if (!proxy._isInAdd) {
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
                proxy._$ganttchartHelper.ejGanttChart("updateHeight", height);
                proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);

                if (model.predecessorMapping) {
                    proxy._isValidationEnabled = false;
                    proxy._connectorlineIds = [];
                    proxy._connectorLinesCollection = [];
                    proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                    proxy._createConnectorLinesCollection();
                }
            }
        },
        //Refresh gantt after expnadAll or collapseAll operation
        _refreshGanttOnExpandCollapseAll:function()
        {
            var proxy = this,
                args = {},
                model = this.model,
                collapsedRecordCount = 0,
                height = 0;

            if (model.enableVirtualization) {
                args.requestType = ej.TreeGrid.Actions.ExpandCollapse;
                proxy._$treegridHelper.ejTreeGrid("updateAltRowOnCollapseAll");
                proxy._$treegridHelper.ejTreeGrid("updateAltRowOnRendering");
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", args);
                model.updatedRecords = proxy.getUpdatedRecords();
                model.currentViewData = proxy.getCurrentViewData();
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
            } else {
                //If need refresh chart if record is added after searching or sorting
                if (proxy._isRefreshAddedRecord) {
                    proxy._refreshChartAndGridRows();
                    proxy._isRefreshAddedRecord = false;
                    return;
                }
                collapsedRecordCount = proxy._$treegridHelper.ejTreeGrid("getCollapsedRecordCount");
                proxy._totalCollapseRecordCount = collapsedRecordCount;
                height = (proxy.model.updatedRecords.length - collapsedRecordCount) * model.rowHeight;
                proxy._$ganttchartHelper.ejGanttChart("clearConnectorLines");
                proxy._$treegridHelper.ejTreeGrid("updateHeight");
                proxy._$ganttchartHelper.ejGanttChart("updateHeight", height);
                proxy._$ganttchartHelper.ejGanttChart("setCollapsedRecordCount", collapsedRecordCount);
                proxy._$ganttchartHelper.ejGanttChart("refreshGridLinesTable", proxy.model.updatedRecords.length - collapsedRecordCount);
                if (model.enableAltRow && model.currentViewData.length > 0)
                    ej.TreeGrid.updateAltRow(proxy, model.currentViewData[0], 0, 0);
            }
            if (model.predecessorMapping) {
                proxy._isValidationEnabled = false;
                proxy._connectorlineIds = [];
                proxy._connectorLinesCollection = [];
                proxy._createConnectorLinesCollection();
            }
            if (proxy.isCriticalPathEnable == true) {
                proxy._$ganttchartHelper.ejGanttChart("criticalConnectorLine", proxy.criticalPathCollection, proxy.detailPredecessorCollection, true, proxy.collectionTaskId);
            }
        },
        //get all the visible records in Gantt
        _collapsedRecords: function () {
            var proxy = this,
                model = proxy.model;
            var records = model.updatedRecords.filter(function (record) {
                if (record.parentItem == null)
                    return record;
                else if (record.parentItem[model.expandStateMapping] || ej.isNullOrUndefined(record.parentItem[model.expandStateMapping]))
                    return record;
            });
            return records;            
        },
        //collapse the defined records from data source on load time.
        _collapseRecordOnLoad: function () {
            var proxy = this,
               model = proxy.model,
               count = 0,
               ganttRecord,
               args = {},
               records,
               enableVirtualization = model.enableVirtualization,
               $gridRows = proxy.getRows(),
               $rowElement = null;

            proxy._gridRows = $gridRows;
            proxy._isInExpandCollapseAll = true;
            records = proxy._collapsedRecords();
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control            
            for (count = 0; count < records.length; count++) {
                ganttRecord = records[count];
                if (!ganttRecord[model.expandStateMapping]) {
                    if (ganttRecord[model.expandStateMapping] || ej.isNullOrUndefined(ganttRecord[model.expandStateMapping])) continue;
                    args.data = ganttRecord;
                    args.recordIndex = count;                    
                    args.expanded = false;
                    if (ganttRecord.hasChildRecords) {
                        !ganttRecord[model.expandStateMapping] && ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();
            proxy._isInExpandCollapseAll = false;
        },
        //Collapse all parent and inner level parent records
        _collapseAll: function () {
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                $gridRows = proxy.getRows(),
                $rowElement = null;

            proxy._$treegridHelper.ejTreeGrid("cancelEditCell"); // Cancel the edit cell, if it is in edit mode.
            proxy._gridRows = $gridRows;
            proxy._isInExpandCollapse = true;
            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords preseent in the Gantt Control            
            for (count = 0; count < proxy.model.parentRecords.length; count++) {
                    ganttRecord = proxy.model.parentRecords[count];
                    args.data = ganttRecord;
                    args.recordIndex = count;
                    args.expanded = false;
                    if (ganttRecord.hasChildRecords) {
                        proxy._expandCollapseInnerLevelRecord(ganttRecord, args.expanded);
                        ganttRecord.expanded && ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                    }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();

            proxy._isInExpandCollapse = false;
            proxy._isInExpandCollapseAll = false;
        },
        //expand or collapse all inner level parent records
        _expandCollapseInnerLevelRecord:function(record,expanded)
        {
            var proxy = this,
                length = record.childRecords.length,
                tempArgs = {};

            for (var count = 0; count < length; count++) {
                if (record.childRecords[count].hasChildRecords) {
                    proxy._expandCollapseInnerLevelRecord(record.childRecords[count], expanded);
                    tempArgs.data = record.childRecords[count];
                    tempArgs.expanded = expanded;
                    if(record.childRecords[count].expanded !== expanded)
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, tempArgs);

                }
            }
        },
        //Method for expand all the GanttRecords
        _expandAll: function () {
            
            var proxy = this,
                model = proxy.model,
                count = 0,
                ganttRecord,
                args = {},
                enableVirtualization = model.enableVirtualization,
                parentRecords = model.parentRecords,
                length = parentRecords.length;

            proxy._isInExpandCollapse = true;
            proxy._isInExpandCollapseAll = true;
            //loop excecute for iterate the GanttRecords present in the Gantt Control

            for (count = 0; count < length; count++) {
                ganttRecord = parentRecords[count];
                args.data = ganttRecord;
                args.recordIndex = count;
                args.expanded = true;
                if (ganttRecord.hasChildRecords ) {
                    proxy._expandCollapseInnerLevelRecord(ganttRecord, args.expanded);
                    if(!ganttRecord.expanded)
                        ej.TreeGrid.sendExpandCollapseRequest(proxy, args);
                }
            }
            if (model.flatRecords.length > 0)
                proxy._refreshGanttOnExpandCollapseAll();

            proxy._isInExpandCollapse = false;
            proxy._isInExpandCollapseAll = false;
        },
        _getDateFromFormat: function (date) {
            
            if (date == null)
                return;

            if (typeof date === "object") {
                return new Date(date);
            }
            if (date) {
                return ej.parseDate(date, this.model.dateFormat, this.model.locale) == null ?
                    new Date(date) : ej.parseDate(date, this.model.dateFormat, this.model.locale);
            }
        },
        _getFormatedDate: function (dateObject, dateformat, locale) {
            return ej.format(dateObject, dateformat, locale);
        },

        _getNonWorkingDayIndex: function () {
            var proxy = this,
                model = proxy.model,
                weekDay = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"],
                weekDayLength = weekDay.length,
                workWeek = model.workWeek.slice(),
                length = workWeek.length;
            for (var i = 0; i < length; i++)
                workWeek[i] = workWeek[i].toLowerCase();
            proxy._nonWorkingDayIndex = [];
            for (var i = 0; i < weekDayLength; i++) {
                if (workWeek.indexOf(weekDay[i]) == -1)
                    proxy._nonWorkingDayIndex.push(i);
            }
        },

        _getNextWorkingDay:function(date)
        {
            var proxy = this,
                model = proxy.model,
                dayIndex = date.getDay();
            if (proxy._nonWorkingDayIndex.indexOf(dayIndex) != -1) {
                date.setDate(date.getDate() + 1);
                date =  proxy._getNextWorkingDay(date);
                this._setTime(this._defaultStartTime, date);
                return date;;
            }
            else
                return date;
        },

        _getPrevWorkingDay: function (date) {
            var proxy = this,
                model = proxy.model,
                dayIndex = date.getDay(),
                prevIndex = (dayIndex == 0) ? 6 : dayIndex - 1;
            if (proxy._nonWorkingDayIndex.indexOf(dayIndex) != -1 || (proxy._nonWorkingDayIndex.indexOf(prevIndex) !=-1 && this._defaultEndTime == 86400 && this._getSecondsInDecimal(date) == 0)) {
                date.setDate(date.getDate() - 1);
                date = proxy._getPrevWorkingDay(date);;
                this._setTime(this._defaultEndTime, date);
                return date;
            }
            else
                return date;
        },

        _destroy: function () {
            var proxy = this;
            //Unbind all events binded to Document and window and chart side and TreeGrid side
            this.element.off();
            proxy._off($(window), "resize", proxy.windowResize);
            $("#" + this._id + "_dialogEdit_wrapper").clearQueue();
            $("#" + this._id + "_dialogEdit_wrapper").stop();
            $("#" + this._id + "_dialogAdd_wrapper").clearQueue();
            $("#" + this._id + "_dialogAdd_wrapper").stop();
            $("#" + proxy._id + "_dialogAdd").find('.e-treegrid').ejTreeGrid("destroy");
            $("#" + proxy._id + "_dialogEdit").find('.e-treegrid').ejTreeGrid("destroy");
            $("#" + proxy._id + "_dialogEdit").data("ejDialog") && $("#" + proxy._id + "_dialogEdit").data("ejDialog").destroy();
            $("#" + proxy._id + "_dialogAdd").data("ejDialog") && $("#" + proxy._id + "_dialogAdd").data("ejDialog").destroy();
            $("#" + proxy._id + "_dialogAdd").remove();
            $("#" + proxy._id + "_dialogEdit").remove();
            $("#" + this._id + "_toolbarItems_Main").remove();
            $("#" + this._id + "_dialogEdit_wrapper").remove();
            $("#" + this._id + "startDateEdit_popup").remove();
            $("#" + this._id + "endDateEdit_popup").remove();
            $("#" + this._id + "startDateAdd_popup").remove();
            $("#" + this._id + "endDateAdd_popup").remove();
            $("#" + this._id + "taskTypeEdit_popup_wrapper").remove();
            $("#" + this._id + "_dialogAdd_wrapper").remove();
            $("#" + this._id + "effortDrivenEdit_popup_wrapper").remove();
            $("#" + this._id + "_dialogValidationRule_wrapper").remove();
            //Chart side
            var ganttChartObj = proxy._$ganttchartHelper.ejGanttChart("instance");
            ganttChartObj.destroy();
            //TreeGrid side
            var treeGridObj = proxy._$treegridHelper.ejTreeGrid("instance");
            treeGridObj.destroy();
            proxy.element.empty().removeClass("e-gantt-core e-gantt " + proxy.model.cssClass);
        },
        /*Refresh Gantt toolbar elements*/
        _updateToolbar: function () {
            var proxy = this,
                model = proxy.model,
                ganttHeight;
            $("#" + proxy._id + "_toolbarItems").remove();
            $("#" + proxy._id + "_toolbarItems_Main").remove();
            if (model.toolbarSettings.showToolbar) {
                proxy._renderToolBar().insertBefore($("#e-ejSpliter" + proxy._id));
                proxy._updateToolbarOptions("");
            }
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version < 9) {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 3 : 2;//top,bottom,toolbar div
            } else {
                proxy._totalBorderHeight = model.toolbarSettings.showToolbar ? 1 : 0;//top box-sizing:border-box includes it's border
            }
            proxy._$treegridHelper.ejTreeGrid("cancelEditCell");
            //Calculate the viewport height based on toolbar height
            //Change the tree grid and gantt chart container height based on view port height
            var toolbar = $("#" + proxy._id + "_toolbarItems"),
                ganttbody = proxy.element.find(".e-ganttviewerbodyContianer"),
                gantthead = proxy.element.find(".e-ganttviewerheaderContainer"),
                treegridcontent = ("#ejTreeGrid" + proxy._id + "e-gridcontent"),
                splitter = $("#e-ejSpliter" + proxy._id),
                height = $(proxy.element).height() - proxy._totalBorderHeight,
                viewPortHeight = height - gantthead.height() - 2 - toolbar.height(), // 2 is border width
                top = ganttbody.ejScroller("option", "scrollTop"),
                left = ganttbody.ejScroller("option", "scrollLeft");
            ganttbody.ejScroller({
                height: viewPortHeight
            });
            ganttHeight = height - toolbar.height();
            splitter.height(ganttHeight);
            $("#ejTreeGrid" + proxy._id).height(ganttHeight);
            $("#ejGanttChart" + proxy._id).height(ganttHeight);
            $(treegridcontent).height(viewPortHeight);
            ganttbody.height(viewPortHeight);
            $(treegridcontent).ejScroller("refresh");
            ganttbody.ejScroller("option", "scrollTop", top);
            ganttbody.ejScroller("option", "scrollLeft", left);
            proxy._$treegridHelper.ejTreeGrid("updateViewPortHeight");
            proxy._$ganttchartHelper.ejGanttChart("updateViewPortHeight");
            if (proxy.model.enableVirtualization) {
                proxy._$treegridHelper.ejTreeGrid("processBindings");
                var tempArgs = {};
                tempArgs.requestType = ej.TreeGrid.Actions.Refresh;
                proxy._$treegridHelper.ejTreeGrid("sendDataRenderingRequest", tempArgs);
                proxy._$ganttchartHelper.ejGanttChart("refreshHelper", proxy.model.currentViewData, proxy.model.updatedRecords);
                proxy._$ganttchartHelper.ejGanttChart("onScrollHelper", top);
            }
            proxy._clearContextMenu();
        },
        /*Get string value from record*/
        _getDurationStringValue: function (data) {
            var val = "";
            if (data.duration != null && data.duration != undefined && data.duration != "")
                if (typeof data.duration == "string")
                {
                    var duration = parseFloat(data.duration);
                    val += !isNaN(duration) ? parseFloat(duration.toFixed(2)) + " " : "";
                }
            else
                val += parseFloat(data.duration.toFixed(2)) + " ";
            if (data.durationUnit != null && data.durationUnit != undefined) {
                var multiple = data.duration != 1;
                if (data.durationUnit == "day")
                    val += multiple ? this._durationUnitTexts.days : this._durationUnitTexts.day;
                else if (data.durationUnit == "hour")
                    val += multiple ? this._durationUnitTexts.hours : this._durationUnitTexts.hour;
                else
                    val += multiple ? this._durationUnitTexts.minutes : this._durationUnitTexts.minute;
            }
            return val;
        },

        //Get predecessor value as string with offset values
        _getPredecessorStringValue:function(data)
        {
            var proxy = this,
                predecessors = data.predecessor,
                returnVal = "";
            if (predecessors) {
                var length = predecessors.length,
                    resultString = "";
                for (var i = 0; i < length; i++) {
                    var cPredecessor = predecessors[i],
                        temp = "";
                    if (cPredecessor.from != data.taskId) {
                        temp = cPredecessor.from + cPredecessor.predecessorsType;
                        if (cPredecessor.offset != 0) {
                            temp += cPredecessor.offset > 0 ? ("+" + cPredecessor.offset + " ") : (cPredecessor.offset + " ");
                            var multiple = Math.abs(cPredecessor.offset) != 1;
                            if (cPredecessor.offsetDurationUnit == "day")
                                temp += multiple ? proxy._durationUnitTexts.days : proxy._durationUnitTexts.day;
                            else if (cPredecessor.offsetDurationUnit == "hour")
                                temp += multiple ? proxy._durationUnitTexts.hours : proxy._durationUnitTexts.hour;
                            else
                                temp += multiple ? proxy._durationUnitTexts.minutes : proxy._durationUnitTexts.minute;
                        }
                        if (resultString.length > 0)
                            resultString = resultString + "," + temp;
                        else
                            resultString = temp;
                    }
                }
            }
            return resultString;
        }
    });
    
    ej.Gantt.EditingType = {
        String: "stringedit",
        Boolean: "booleanedit",
        Numeric: "numericedit",
        Dropdown: "dropdownedit",
        DatePicker: "datepicker",
        DateTimePicker: "datetimepicker",
        Maskedit: "maskedEdit"
    };

    ej.Gantt.ToolbarItems = {
        Add: "add",
        Edit: "edit",
        Delete: "delete",
        Update: "update",
        Cancel: "cancel",
        Search: "search",
        Indent: "indent",
        Outdent: "outdent",
        ExpandAll: "expandAll",
        CollapseAll: "collapseAll",
        PrevTimeSpan: "prevTimeSpan",
        NextTimeSpan: "nextTimeSpan",        
        CriticalPath: "criticalPath",
        ExcelExport: "excelExport",
        PdfExport: "pdfExport"
    };

    ej.Gantt.ScheduleHeaderType = {
        Year: "year",
        Month: "month",
        Week: "week",
        Day: "day",
        Hour:"hour"
    };

    ej.Gantt.minutesPerInterval = {
        Auto:"auto",
        OneMinute: "oneMinute",
        FiveMinutes: "fiveMinutes",
        FifteenMinutes: "fifteenMinutes",
        ThirtyMinutes:"thirtyMinutes"
    };

    ej.Gantt.DurationUnit = {
        Day: "day",
        Hour: "hour",
        Minute:"minute"
    };
    ej.Gantt.WorkUnit = {
        Day: "day",
        Hour: "hour",
        Minute: "minute"
    };
    ej.Gantt.TaskType = {
        FixedUnit: "fixedUnit",
        FixedWork: "fixedWork",
        FixedDuration: "fixedDuration"
    }
    ej.Gantt.workingTimeScale = {
        TimeScale8Hours: "TimeScale8Hours",
        TimeScale24Hours: "TimeScale24Hours",
    };

    ej.Gantt.RowPosition = {
        Top: "top",
        Bottom: "bottom",
        AboveSelectedRow: "aboveselectedrow",
        BelowSelectedRow: "belowselectedrow",
        Child:"child"
    };

    //Enum for Edit Action of TreeGrid.
    ej.Gantt.BeginEditAction = {
        DblClick: "dblClick",
        Click: "click"
    };

    //Enum Value of selectionType.
    ej.Gantt.SelectionType = {
        Single: "single",
        Multiple:"multiple"
    };

    //Enum Value of selectionType.
    ej.Gantt.TimescaleRoundMode = {
        Auto:"auto",
        Year: "year",
        Month: "month",
        Week:"week"
    };


    //Enum Value of selectionMode.
    ej.Gantt.SelectionMode = {
        Row: "row",
        Cell: "cell"
    };

    ej.Gantt.TaskSchedulingMode = {
        Auto: "auto",
        Manual: "manual",
        Custom: "custom"
    };

    ej.Gantt.Locale = ej.Gantt.Locale || {};

    ej.Gantt.Locale["default"] = ej.Gantt.Locale["en-US"] = {

        //string to display with dataSource contains 0 objects
        emptyRecord: "No records to display",

        alertTexts: {
            indentAlert: "There is no gantt record is selected to perform the Indent",
            outdentAlert: "There is no gantt record is selected to perform the Outdent",
            predecessorEditingValidationAlert: "Cyclic Dependency Occured, Please Check The Predecessor",
            predecessorAddingValidationAlert: "Fill all the columns in predecessor table",
            idValidationAlert: "Duplicate ID",
            dateValidationAlert: "Invalid End date",
            dialogResourceAlert: "Fill All the columns in resource table"
        },

        //headerText to be displayed in treegrid
        columnHeaderTexts: {
            taskId: "ID",
            taskName: "Task Name",
            startDate: "Start Date",
            endDate: "End Date",
            resourceInfo: "Resources",
            duration: "Duration",
            status: "Progress",
            taskMode: "Task Mode",
            subTasksStartDate: "SubTasks Start Date",
            subTasksEndDate: "SubTasks End Date",
            scheduleStartDate: "Schedule Start Date",
            scheduleEndDate: "Schedule End Date",
            predecessor: "Predecessors",
            type: "Type",
            offset: "Offset",
            baselineStartDate: "Baseline Start Date",
            baselineEndDate: "Baseline End Date",
            WBS: "WBS",
            WBSPredecessor: "WBS Predecessor",
            dialogCustomFieldName: "Column Name",
            dialogCustomFieldValue: "Value",
            notes: "Notes",
            taskType: "Task Type",
            work: "Work",
            unit:"Unit",
            effortDriven: "Effort Driven"
        },

        //string to display in dialog 
        editDialogTexts: {
            addFormTitle: "New Task",
            editFormTitle: "Task Information",
            saveButton: "Save",
            deleteButton: "Delete Task",
            cancelButton: "Cancel",
            addPredecessor: "Add New",
            removePredecessor: "Remove",
            addButton: "Add"
        },

        //string to display in column add dialog 
        columnDialogTexts: {
            field: "Field",
            headerText: "Header Text",
            editType: "Edit Type",
            filterEditType: "Filter Edit Type",
            allowFiltering: "Allow Filtering",
            allowFilteringBlankContent: "Allow Filtering Blank Content",
            allowSorting: "Allow Sorting",
            visible: "Visible",
            width: "Width",
            textAlign: "Text Alignment",
            headerTextAlign: "Header Text Alignment",
            columnsDropdownData: "Column Dropdown Data",
            dropdownTableText: "Text",
            dropdownTableValue: "Value",
            addData: "Add",
            deleteData: "Remove",
            allowCellSelection: "Allow Cell Selection",
            displayAsCheckbox: "Display As Checkbox",
            clipMode: "Clip Mode",
            tooltip: "Tooltip",
            showInColumnChooser: "Show In Column Chooser",
            headerTooltip: "Header Tooltip"
        },

        //string to be displayed in Toolbox's tooltip 
        toolboxTooltipTexts: {
            addTool: "Add",
            editTool: "Edit",
            saveTool: "Update",
            deleteTool: "Delete",
            cancelTool: "Cancel",
            searchTool: "Search",
            indentTool: "Indent",
            outdentTool: "Outdent",
            expandAllTool: "Expand All",
            collapseAllTool: "Collapse All",
            nextTimeSpanTool: "Next Timespan",
            prevTimeSpanTool: "Previous Timespan",            
            criticalPathTool: "Critical Path",
            excelExportTool: "Excel Export",
            pdfExportTool:"PDF Export"
        },

        //string to be displayed in taskbar tooltip for duration unit 
        durationUnitTexts: {           
            days: "days",
            hours: "hours",
            minutes: "minutes",
            day: "day",
            hour: "hour",
            minute: "minute",
        },
        durationUnitEditText: { minute: ["m", "min", "minute", "minutes"], hour: ["h", "hr", "hour", "hours"], day: ["d", "dy", "day", "days"] },

        //string to be displayed in taskbar tooltip for duration unit 
        workUnitTexts: {
            day: "days",
            hour: "hours",
            minute: "minutes"           
        },

        //String to be displayed in default type drop down.
        taskTypeTexts: {
            fixedWork: "Fixed Work",
            fixedUnit: "Fixed Units",
            fixedDuration: "Fixed Duration"
        },

        //String to be displayed in effort drven drop down box.
        effortDrivenTexts: {
            yes: "Yes",
            no: "No"
        },

        //string to be displayed in context menu 
        contextMenuTexts: {
            taskDetailsText: "Task Details...",
            addNewTaskText: "Add New Task",
            indentText: "Indent",
            outdentText: "Outdent",
            deleteText: "Delete",
            aboveText: "Above",
            belowText: "Below"
        },

        //Name to be displayed for New Task while adding  
        newTaskTexts: {           
            newTaskName: "New Task"
        },

        //string to be displayed in column menu 
        columnMenuTexts: {
            sortAscendingText: "Sort Ascending",
            sortDescendingText: "Sort Descending",
            columnsText: "Columns",
            insertColumnLeft: "Insert Column Left",
            insertColumnRight: "Insert Column Right",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        taskModeTexts: {
            manual: "Manual",
            auto: "Auto"
        },

        //String to be display for edittype and filter edit type.
        editTypeTexts: {
            string: "String",
            numeric: "Numeric",
            datePicker: "Date Picker",
            dateTimePicker: "Date Time Picker",
            dropdown: "Dropdown",
            boolean: "Boolean"

        },

        // String to be display for text align type.
        textAlignTypes: {
            right: "Right",
            left: "Left",
            center: "Center"
        },

        // String to be display for clip mode type.
        clipModeTexts: {
            clip: "Clip",
            ellipsis: "Ellipsis"
        },

        //string to be displayed in column add dialog title 
        columnDialogTitle: {
            insertColumn: "Insert Column",
            deleteColumn: "Delete Column",
            renameColumn: "Rename Column"
        },

        //Locale Text for delete confirm dialog
        deleteColumnText: "Are you sure you want to delete this column?",
        okButtonText: "OK",
        cancelButtonText: "Cancel",
        confirmDeleteText: "Confirm Delete",

        predecessorEditingTexts: {
            fromText: "From",
            toText : "To"
        },

        dialogTabTitleTexts: {
            generalTabText: "General",
            predecessorsTabText: "Predecessors",
            resourcesTabText: "Resources",
            customFieldsTabText: "Custom Fields",
            notesTabText:"Notes"
        },
        predecessorCollectionText: [
                { id: "SS", text: "Start-Start", value: "Start-Start" },
                { id: "SF", text: "Start-Finish", value: "Start-Finish" },
                { id: "FS", text: "Finish-Start", value: "Finish-Start" },
                { id: "FF", text: "Finish-Finish", value: "Finish-Finish" }
        ],

        //Validation dialog text
        linkValidationRuleText: {
            taskBeforePredecessor: "You moved '{0}' to start before '{1}' finishes and the two tasks are linked. As the result, the links cannot be honored. Select one action below to perform",
            taskAfterPredecessor: "You moved '{0}' away from '{1}' and the two tasks are linked. As the result, the links cannot be honored. Select one action below to perform",
        },

        linkValidationDialogTitle: "Validate Editing",

        //string to be displayed in column add dialog title 
        linkValidationRuleOptions: {
            cancel: "Cancel, Keep the existing link",
            removeLink: "Remove the link and move '{0}' to start on '{1}'.", //previous data task name and startdate
            preserveLink: "Move the '{0}' to start on '{1}' and keep the link." // current data task name and startdate
        },
    };

    /*-----Initialize the GanttRecord object--------------*/

    ej.Gantt.GanttRecord = function () {
        var proxy = this;
        proxy.taskId = null;
        proxy.taskName = null;
        proxy.startDate = null;
        proxy.endDate = null;
        proxy.duration = null;
        proxy.isMilestone = false;
        proxy.status = null;
        proxy.predecessor = null;
        proxy.resourceInfo = null;
        proxy.parentItem = null;
        proxy.isSelected = false;
        proxy.childRecords = null;
        proxy.hasChildRecords = false;
        proxy.expanded = false;
        proxy.level = 0;
        proxy.left = 0;
        proxy.width = 0;
        proxy.progressWidth = 0;
        proxy.item = null;
        proxy.baselineLeft = 0;
        proxy.baselineWidth = 0;
        proxy.baselineStartDate = null;
        proxy.baselineEndDate = null;
        proxy.isCritical = false,
        proxy.slack = null,
        proxy.isReadOnly = false;
        proxy.hasFilteredChildRecords = true;
        proxy.taskbarBackground = null;
        proxy.progressbarBackground = null;
        proxy.parentProgressbarBackground = null;
        proxy.cellBackgroundColor = null;
        proxy.rowBackgroundColor = null;
        proxy.treeMappingName = [];
        proxy.dragState = true;
        proxy.isSelected = false;
        proxy.durationUnit = "";
        proxy.isAutoSchedule = true;
        proxy.manualStartDate = null;
        proxy.manualEndDate = null;
        proxy.manualLeft = 0;
        proxy.manualDuration = 0;
        proxy.manualWidth = 0;
    }

    ej.Gantt.GanttRecord.prototype = {

        //calculate the left position of the taskbar with starte date and schedule start date
        _calculateLeft: function (ganttObj) {            
            return ganttObj._getTaskLeft(this.startDate, this.isMilestone);
        },
        //calculate the left position of the taskbar with manual starte date and schedule start date
        _calculateManualLeft: function (ganttObj) {
            return ganttObj._getTaskLeft(this.manualStartDate);
        },

        //calculate the left margin of the baseLine element.
        _calculateBaselineLeft: function (ganttObj) {
            var beginDate = new Date(this.baselineStartDate),
                endDate = new Date(this.baselineEndDate);
            if (beginDate && endDate) {
                return ganttObj._getTaskLeft(beginDate, this.isMilestone);
            } else {
                return 0;
            }
        },

        //calculate the right margin of the baseLine element.
        _calculateBaselineRight: function (ganttObj) {
            var beginDate = new Date(this.baselineStartDate),
                endDate = new Date(this.baselineEndDate);
            if (beginDate && endDate) {
                return ganttObj._getTaskLeft(endDate);
            } else {
                return 0;
            }
        },

        //calculate the with between start date and end date
        _calculateWidth: function (ganttObj) {
            var proxy = this,
                startdate = new Date(proxy.startDate),
                enddate = new Date(proxy.endDate);
            return ganttObj._getTaskWidth(startdate, enddate);
        },

        //calculate the with between manual start date and manual end date
        _calculateManualWidth: function (ganttObj) {
            var proxy = this,
                manualStartDate = new Date(proxy.manualStartDate),
                manualEndDate = new Date(proxy.manualEndDate);
            return ganttObj._getTaskWidth(manualStartDate, manualEndDate);
        },

        //calculate the with between baseline start date and baseline end date
        _calculateBaseLineWidth: function (ganttObj) {
            var proxy = this,
               startdate = new Date(this.baselineStartDate),
                   enddate = new Date(this.baselineEndDate);
            return ganttObj._getTaskWidth(startdate, enddate);
        },
        /*Get string format of date object */
        _getFormatedDate: function (dateObject, dateformat, locale) {
            return ej.format(dateObject, dateformat, locale);
        },
        /*Get date object from string value*/
        _getDateFromFormat: function (dateString, dateformat, locale) {
            if (dateString) {
                return ej.parseDate(dateString, dateformat, locale) == null ?
                    new Date(dateString) : ej.parseDate(dateString, dateformat, locale);
            }
        },

        /*Assing resource collection to record from data source value*/
        _setResourceInfo: function (resourceIdcollection, resourceIdMapping, resourceNameMapping, resourceUnitMapping, resourcecollection) {

            var proxy=this, count = 0,
            resources = [];

            for (count; count < resourceIdcollection.length; count++) {

                var resource = resourcecollection.filter(function (resourceInfo) {
                    if (typeof resourceIdcollection[count] == "object" && resourceIdcollection[count][resourceIdMapping] === resourceInfo[resourceIdMapping])
                        return true;
                    else 
                        return resourceIdcollection[count] === resourceInfo[resourceIdMapping];
                });

                var ganttRecordResource = $.extend({}, resource[0]);
                if (resource.length) {
                    resources.push(ganttRecordResource);
                    if (resourceUnitMapping != "" && !ej.isNullOrUndefined(resourceIdcollection[count][resourceUnitMapping])) {
                        ganttRecordResource[resourceUnitMapping] = resourceIdcollection[count][resourceUnitMapping];
                    } else {
                        proxy._updateResourceUnit(resource[0], ganttRecordResource, resourceUnitMapping);
                    }
                }
                else {
                    resourceIdcollection.splice(count, 1);
                    count--;
                }
            }
            return resources;
        },
        /*Update resource unit with value or default value*/
        _updateResourceUnit: function (resource, ganttRecordResource, resourceUnitMapping) {
            if (resourceUnitMapping != "") {
                if (ej.isNullOrUndefined(resource[resourceUnitMapping]))
                    ganttRecordResource[resourceUnitMapping] = 100;
            }
            else                
                ganttRecordResource.unit = 100;            
        },

        /*Update progress of parent record with child records progress value*/
        _updateParentProgress: function (parent, progressMapping) {
            var parentProgress = 0,
                childRecords = parent.childRecords,
                childCount = childRecords ? childRecords.length : 0,
                totalProgress = 0,
                milesStoneCount = 0,
                taskCount = 0;

            if (childRecords) {
                for (var i = 0; i < childCount; i++) {
                    if (!childRecords[i].isMilestone)
                        totalProgress += parseInt(childRecords[i].status);
                    else
                        milesStoneCount += 1;
                }
                taskCount = childCount - milesStoneCount;
                parentProgress = taskCount > 0 ? (totalProgress / taskCount) : 0;
                if (isNaN(parentProgress))
                    parentProgress = 0;
                var width = parent.isAutoSchedule ? parent.width : parent.manualWidth;
                parent.progressWidth = this._getProgressWidth(width, parentProgress);
                parent.status = Math.floor(parentProgress);
                if (progressMapping)
                    parent.item[progressMapping] = parent.status;
            }
            if (parent.parentItem) {
                this._updateParentProgress(parent.parentItem, progressMapping);
            }
        },
        /*Get with of progress value*/
        _getProgressWidth: function (parentwidth, percent) {
            return (parentwidth * percent) / 100;
        },
        /*Get predecessor collection object from predecessor string value*/
        _calculatePredecessor: function (string, durationUnitLabels, defaultDurationUnit, gantt) {
            var collection = [],
                match,
                obj = {},
                values,
                to = this.taskId.toString(),
                offsetvalue,
                ganttRecord = this,
                proxyGantt = gantt, predecessorText;
            if (typeof string === 'string')
            {
                string.split(',').forEach(function (el) {
                    values = el.split('+');
                    offsetvalue = '+';
                    if (el.indexOf('-') >= 0) {
                        values = el.split('-');
                        offsetvalue = '-';
                    }
                    match = values[0].match(/(\d+|[A-z]+)/g);
                    //Validate for appropriate predecessor 
                    if (match[0] && proxyGantt.model.ids.indexOf(match[0]) != -1) {
                        if (match.length > 1) {
                            var type = match[1].toUpperCase();
                            if (type == 'FS' || type == 'FF' || type == 'SF' || type == 'SS')
                                predecessorText = type;
                            else {
                                if (proxyGantt._isValidPredecessorString)
                                    proxyGantt._isValidPredecessorString = false; // Flag for updating proper predecessor string
                                predecessorText = 'FS';
                            }
                        }
                        else {
                            if (proxyGantt._isValidPredecessorString)
                                proxyGantt._isValidPredecessorString = false; // Flag for updating proper predecessor string
                            predecessorText = 'FS';                            
                        }
                    }
                    else {
                        if (proxyGantt._isValidPredecessorString)
                            proxyGantt._isValidPredecessorString = false; // Flag for updating proper predecessor string
                        return;//Exit current loop for invalid id (match[0])
                    }
                    obj = {
                        from: match[0],
                        predecessorsType: predecessorText,
                        offset: values.length > 1 ? offsetvalue + "" + values[1] : "0",
                        isdrawn: false,
                        to: to
                    };
                    var offsetUnits = ganttRecord._getOffsetDurationUnit(obj.offset, durationUnitLabels, defaultDurationUnit);
                    obj.offset = offsetUnits.duration;
                    obj.offsetDurationUnit = offsetUnits.durationUnit;
                    collection.push(obj);
                });
           }
            return collection;
        },
        /*Get duration and duration unit value from tasks*/
        _getOffsetDurationUnit: function (val, durationUnitLabels, defaultDurationUnit) {
            var duration = 0,
                  durationUnit = defaultDurationUnit;

            if (typeof val == "string") {
                var values = val.match(/(-?\d*\.*\d+|[A-z]+)/g);
                if (values && values.length <= 2) {
                    duration = parseFloat(values[0]);
                    durationUnit = values[1] ? values[1].toLowerCase() : "";
                    if (durationUnitLabels.minute.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Minute;
                    else if (durationUnitLabels.hour.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Hour;
                    else if (durationUnitLabels.day.indexOf(durationUnit) != -1)
                        durationUnit = ej.Gantt.DurationUnit.Day;
                    else
                        durationUnit = defaultDurationUnit;
                }
            } else {
                duration = val;
                durationUnit = defaultDurationUnit;
            }
            if (isNaN(duration)) {
                duration = 0;
                durationUnit = ej.Gantt.DurationUnit.Day;
            }
            var output = {};
            output.duration = duration;
            output.durationUnit = durationUnit;
            return output;
        },

        /*Get end date of Gantt record with start date and duration*/
        _calculateEndDate: function (ganttObj) {
            var model = ganttObj.model,
                tempEndDate = ganttObj._getEndDate(this.startDate, this.duration, this.durationUnit, this);
            this.endDate = new Date(tempEndDate);
            if (model.endDateMapping)
                this.item[model.endDateMapping] = this.endDate;
        },
        /*Get duration of Gantt record with start date and end date*/
        _calculateDuration: function (ganttObj) {
            var model = ganttObj.model, tempDuration = ganttObj._getDuration(this.startDate, this.endDate, this.durationUnit, this.isAutoSchedule);
            this.duration = tempDuration;
            if (model.durationMapping && this.item) {
                this.item[model.durationMapping] = tempDuration;
                model.durationUnitMapping && (this.item[model.durationUnitMapping] = this.durationUnit);
            }
        },
        /*Get duration of Gantt record with manual start date and manual end date*/
        _calculateManualDuration: function (ganttObj) {
            var tempDuration = ganttObj._getDuration(this.manualStartDate, this.manualEndDate, this.durationUnit, this.isAutoSchedule);
            this.manualDuration = tempDuration;
        },

        //Update duration with respect to work and units of resources of a task.
        _updateDurationWithWork: function (proxy, resourceCollection) {
            var model = proxy.model, totalHours,
                resourceInfo = resourceCollection ? resourceCollection : this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                totalResourceOneDayWork = 0,
                updatedDuration = 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60); //in hours

            for (var length = 0; length < resourceLength; length++) {
                var resourceUnit = resourceInfo[length][model.resourceUnitMapping], //in percentage 
                    resourceOneDayWork = resourceUnit > 0 ? (ActualOneDayWork * resourceUnit) / 100 : ActualOneDayWork;//in hours

                totalResourceOneDayWork += resourceOneDayWork;
            }

            totalHours = this._getTotalWorksInHours(model,ActualOneDayWork);

            if (resourceLength != 0)
                updatedDuration += (totalHours / totalResourceOneDayWork);

            //Update work as per defined unit.
            if (this.durationUnit == "minute")
                updatedDuration = updatedDuration * ActualOneDayWork * 60;
            if (this.durationUnit == "hour")
                updatedDuration = updatedDuration * ActualOneDayWork;

            //To check the decimal places.
            if (updatedDuration % 1 != 0)
                updatedDuration = parseFloat(updatedDuration.toFixed(2));

            proxy._isDurationUpdated = true;

            this.duration = updatedDuration;

            if (model.durationMapping)
                this.item[model.durationMapping] = this.duration;
        },
        //Update work with respect to duration and units of resources of a task.
        _updateWorkWithDuration: function (proxy, resourceCollection) {
            var model = proxy.model,
                resourceInfo = resourceCollection ? resourceCollection : this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                updatedWorks = 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60), //in hours
                durationInDay = this._getDurationInDays(ActualOneDayWork);

            for (var length = 0; length < resourceLength; length++) {
                var resourceUnit = resourceInfo[length][model.resourceUnitMapping], //in percentage 
                    resourceOneDayWork = resourceUnit > 0 ? (ActualOneDayWork * resourceUnit) / 100 : ActualOneDayWork;//in hours
                updatedWorks += (resourceOneDayWork * durationInDay);
            }

            //Update work as per defined unit.
            if (model.workUnit == "minute")
                updatedWorks = updatedWorks * 60;
            if (model.workUnit == "day")
                updatedWorks = updatedWorks / ActualOneDayWork;

            //To check the decimal places.
            if (updatedWorks % 1 != 0)
                updatedWorks = updatedWorks.toFixed(2);

            this.work = parseFloat(updatedWorks);
            if (model.workMapping)
                this.item[model.workMapping] = this.work;
        },
        //Update units of resources with respect to duration and work of a task.
        _updateUnitWithWork: function (proxy) {
            var model = proxy.model,
                resourceInfo = this.resourceInfo,
                resourceLength = resourceInfo ? resourceInfo.length : 0,
                ActualOneDayWork = proxy._secondsPerDay / (60 * 60); //in hours
            if (resourceLength == 0)
                return;
            var durationInDay = this._getDurationInDays(ActualOneDayWork),
                totalWorksInHour = this._getTotalWorksInHours(model, ActualOneDayWork),
                totalUnitInPercentage = durationInDay > 0 ? (totalWorksInHour / (durationInDay * ActualOneDayWork)) * 100 : 0,
                individualUnit = totalUnitInPercentage > 0 ? totalUnitInPercentage / resourceLength : 100;

            //To check the decimal places.
            if (individualUnit % 1 != 0)
                individualUnit =parseFloat(individualUnit.toFixed(2));           

            for (var length = 0; length < resourceLength; length++) {
                resourceInfo[length][model.resourceUnitMapping] = individualUnit;
            }
            //To update the unit value in data source
            proxy._updateResourceName(this);
        },
        _getTotalWorksInHours: function (model, oneDayWork) {
            var proxy = this, worksInHour;
            if (model.workUnit == "day")
                worksInHour = proxy.work * oneDayWork;
            else if (model.workUnit == "minute")
                worksInHour = proxy.work / 60;
            else
                worksInHour = proxy.work;

            return worksInHour;
        },
        _getDurationInDays:function(oneDayWork){
            var proxy = this, durationInDay;
            if (this.durationUnit == "hour")
                durationInDay = proxy.duration / oneDayWork;
            else if (this.durationUnit == "minute")
                durationInDay = proxy.duration / (oneDayWork * 60);
            else
                durationInDay = proxy.duration;

            return durationInDay;
        },
        //Get progress value from taskbar width and progrssbar width
        _getProgressPercent: function (parentwidth, progresswidth) {
            return Math.ceil(((progresswidth / parentwidth) * 100).toFixed(2));
        },
        /*update given miliseconds value in given date obect*/
        _setTime: function (seconds, date) {
            var hour = parseInt(seconds / (3600)),
               min = parseInt((seconds - (hour * 3600)) / 60),
               sec = seconds - (hour * 3600) - (min * 60);
            date.setHours(hour, min, sec, 0);
        },
        /*Returns updated end date with working time range and schedule mode type*/
        _endDateUpdate: function (date, days, minutes, workingTimeRanges, headerType) {
            if (!minutes)
                minutes = 0;
            var newDate = new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours(),
                date.getMinutes(),
                date.getSeconds(),
                date.getMilliseconds()
            );
            if (headerType == "day" || headerType == "hour") {
                //Rounding off to next day
                newDate.setHours(24);
                //Then assigning the dayDecimal duration values in Minutes for exact time
                newDate.setMinutes(minutes);
            }
            else {
                if (workingTimeRanges.length) {
                    if (minutes > 0) {
                        //Rounding off to next day
                        newDate.setHours(24);
                        //Updating to start time of the next day
                        this._setTime(workingTimeRanges[0].from, newDate);
                        //Then assigning the dayDecimal duration values in Minutes for exact time
                        newDate.setMinutes(minutes);
                    }
                    else
                        this._setTime(workingTimeRanges[workingTimeRanges.length - 1].to, newDate);
                }
            }
            return newDate;
        },
        /*Returns updated start date with working time range and schedule mode type*/
        _startDateUpdate: function (date, days, minutes, workingTimeRanges, headerType) {
            if (!minutes)
                minutes = 0;
            var newDate = new Date(
                date.getFullYear(),
                date.getMonth(),
                date.getDate() + days,
                date.getHours(),
                date.getMinutes(),
                date.getSeconds(),
                date.getMilliseconds()
            );
            if (headerType == "day" || headerType == "hour") {
                newDate.setMinutes(minutes);
            }
            else {
                if (workingTimeRanges.length) {
                    if (minutes > 0) {
                        //Updating to start time of the day
                        this._setTime(workingTimeRanges[0].from, newDate);
                        //Then add the balance dayDecimal duration values in Minutes for exact time
                        newDate.setMinutes(minutes);
                    }
                    else
                        this._setTime(workingTimeRanges[0].from, newDate);
                }
            }
            return newDate;
        }
    };
    
    /*Get duration value as string with duration unit value*/
    ej.Gantt._getDurationStringValue = function (data) {
        var val = "";
        if (data.duration != null && data.duration != undefined && data.duration != "")
            if (typeof data.duration == "string") {
                var duration = parseFloat(data.duration);
                val += !isNaN(duration) ? parseFloat(duration.toFixed(2)) + " " : "";
            }
            else
                val += parseFloat(data.duration.toFixed(2)) + " ";
        if (data.durationUnit != null && data.durationUnit != undefined) {
            var multiple = data.duration != 1;
            if (data.durationUnit == "day")
                val += multiple ? this.model.durationUnitTexts.days : this.model.durationUnitTexts.day;
            else if (data.durationUnit == "hour")
                val += multiple ? this.model.durationUnitTexts.hours : this.model.durationUnitTexts.hour;
            else
                val += multiple ? this.model.durationUnitTexts.minutes : this.model.durationUnitTexts.minute;
        }
        return val;
    };
    //Returns cell value
    ej.Gantt._getCellValue = function (columnName) {

        var cellValue = this.data[columnName];

        if (cellValue) {
            return cellValue;
        } else {
            return this.data.item && this.data.item[columnName];
        }


    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the tab control.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejTab", "ej.Tab", {
        _rootCSS: "e-tab",

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["selectedItemIndex"],
        _setFirst: false,
        angular: {
            terminal: false
        },

        defaults: {

            collapsible: false,

            enableAnimation: true,

            ajaxSettings: {

                type: 'GET',

                cache: false,

                data: {},

                dataType: "html",

                contentType: "html",

                async: true
            },

            disabledItemIndex: [],

            enabledItemIndex: [],

            hiddenItemIndex: [],

            events: "click",

            idPrefix: "ej-tab-",

            heightAdjustMode: "content",

            selectedItemIndex: 0,

            cssClass: "",

            showCloseButton: false,

            htmlAttributes: {},

            enableTabScroll: false,

            showReloadIcon: false,

            headerPosition: "top",

            width: null,

            height: null,

            headerSize: null,

            enableRTL: false,

            allowKeyboardNavigation: true,

            showRoundedCorner: false,

            enablePersistence: false,

            enabled: true,

            ajaxLoad: null,

            ajaxBeforeLoad: null,

            ajaxSuccess: null,

            ajaxError: null,

            itemActive: null,

            beforeActive: null,

            itemAdd: null,

            itemRemove: null,

            beforeItemRemove: null,

            create: null,

            destroy: null

        },
        dataTypes: {
            cssClass: "string",
            collapsible: "boolean",
            events: "string",
            heightAdjustMode: "enum",
            enabled: "boolean",
            ajaxSettings: "data",
            disabledItemIndex: "data",
            enabledItemIndex: "data",
            enableAnimation: "boolean",
            htmlAttributes: "data"
        },
        observables: ["selectedItemIndex"],
        selectedItemIndex: ej.util.valueFunction("selectedItemIndex"),


        _destroy: function () {
            this._unWireEvents();
            this._removeBaseClass();
        },

        _setModel: function (options) {
            for (var key in options) {
                switch (key) {
                    case "events": {
                        this._off(this.items, this.model.events);
                        this._on(this.items, options[key], this._tabItemClick);
                        break;
                    }
                    case "disabledItemIndex": {
                        this._disableItems(options[key]);
                        options[key] = this.model.disabledItemIndex;
                        break;
                    }
                    case "enabledItemIndex": this._enableItems(options[key]); break;
                    case "enabled": this._enabledAction(options[key]); break;
                    case "selectedItemIndex": {
                        this._isInteraction = false;
                        this.showItem(ej.util.getVal(options[key]));
                        options[key] = this.model.selectedItemIndex;
                        break;
                    }
                    case "heightAdjustMode": {
                        this.model.heightAdjustMode = options[key];
                        this._setTabsHeightStyle(options[key]);
                        this._resizeEvents(options[key]);
                        break;
                    }
                    case "cssClass": this._changeSkin(options[key]); break;
                    case "showRoundedCorner": this._roundedCorner(options[key]); break;
                    case "height": {
                        this.model.height = options[key];
                        this._setTabsHeightStyle(this.model.heightAdjustMode);
                        break;
                    }
                    case "width": this.element.width(options[key]);
                        $(this.contentPanels).width(Number(options[key]));
                        this.refreshTabScroll();
                        break;
                    case "headerSize": this._setHeaderSize(options[key]); break;
                    case "allowKeyboardNavigation": {
                        if (options[key])
                            this._on(this.element, 'keydown', this._keyPress);
                        else
                            this._off(this.element, "keydown");
                        break;
                    }
                    case "headerPosition":
                        {
                            this.model.headerPosition = options[key];
                            if (this.model.headerPosition == ej.Tab.Position.Top) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.itemsContainer.remove();
                                this.itemsContainer.insertBefore(this.element.find(">div").first());
                                this.element.find("div.e-active-content").removeClass("e-activebottom");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Bottom) {
                                this._removeVerticalClass();
                                this._removeScroll();
                                this.element.find("div.e-active-content").removeClass("e-activetop");
                                this.model.enableTabScroll ? $(this.contentPanels).css("margin-top", "0") : $(this.contentPanels).css("position", "relative")
                            }
                            else if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._removeHeaderClass();
                                $(this.items).css('display', '');
                                this._removeScroll();

                            }
                            this._refresh();
                            if (this.model.headerPosition == ej.Tab.Position.Right)
                                this.element.css("position", "")
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                if (this.model.height && this.model.enableTabScroll) {
                                    $(this.contentPanels).height(Number(this.model.height) - 2);
                                    this.element.find("div.e-active-content").height(Number(this.model.height) - 32)
                                }

                            }

                            this.scrollstep = 30
                            break;
                        }
                    case "showCloseButton":
                        {
                            if (options[key]) {
                                this._addDeleteIcon();
                                this._on(this.element.find("div.e-close"), "click", this._tabDeleteClick);
                            } else
                                this.element.find("div.e-close").remove();
                            break;
                        }
                    case "enableTabScroll":
                        {
                            this.model.enableTabScroll = options[key];
                            if (options[key]) {
                                this._removeScroll();
                                this._addScroll();
                                if (this.model.headerPosition == "left") {
                                    this._refresh();
                                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                }
                            } else {
                                this._removeScroll();
                                this.itemsContainer.removeAttr("style");
                                $(this.contentPanels).css("margin-top", "0")
                            }
                            if (this.model.headerPosition == ej.Tab.Position.Left || this.model.headerPosition == ej.Tab.Position.Right) {
                                this._refresh();
                                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                                if (this.model.headerPosition == ej.Tab.Position.Right && !this.model.enableTabScroll)
                                    this.element.css("margin-left", "")
                            }
                            break;
                        }
                    case "showReloadIcon":
                        {
                            if (options[key]) {
                                this._addReloadIcon();
                            } else
                                this.element.find("div.e-reload").remove();
                            break;
                        }
                    case "enableRTL":
                        {
                            this.model.enableRTL = options[key];
                            this._removeScroll();
                            this.itemsContainer.removeAttr("style");
                            $(this.contentPanels).css("margin-top", "0")
                            this.element.find("ul").removeAttr("style")
                            options[key] ? this.element.addClass("e-rtl") : this.element.removeClass("e-rtl");
                            if (this.model.enableTabScroll)
                                this._addScroll();
                            this._refresh();
                            this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                            if (this.model.headerPosition == ej.Tab.Position.Right && this.model.enableRTL)
                                this.element.css("margin-left", '')

                            break;
                        }
                    case "htmlAttributes": this._addAttr(options[key]); break;
                    case "hiddenItemIndex": {
                        if (this.model.headerPosition == ej.Tab.Position.Top || this.model.headerPosition == ej.Tab.Position.Bottom)
                            $(this.items).css('display', 'inline-block');
                        else $(this.items).css('display', '');
                        this.model.hiddenItemIndex = options[key];
                        this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
                        break;
                    }
                }
            }
        },

        _removeScroll: function () {
            this.itemsContainer.removeAttr("style");
            this.element.find("div.e-chevron-circle-right").remove();
            this.element.find("div.e-chevron-circle-left").remove();
        },

        _addScroll: function () {
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                this._checkScroll();
            this._addScrollIcon();
            this.refreshTabScroll();
        },

        _init: function () {
            this._addItemIndex = null;
            this.tabId = 0;
            this._hiddenIndex = this.model.hiddenItemIndex;
            this._initialize();
            this._prevSize = this._getDimension($(this.element).parent(), "height");
        },


        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _tabContentsWidth: function () {
            var length = this.element.find("li").length;
            var tabLength = 0;
            for (var i = 0; i < length; i++) {
                tabLength = tabLength + $(this.element.find("li")[i]).width();
            }
            return tabLength
        },

        _tabContentsHeight: function () {
            var length = this.element.find("li").length;
            var tabHeight = 0;
            for (var i = 0; i < length; i++) {
                tabHeight = tabHeight + $(this.element.find("li")[i]).height();
            }
            return tabHeight
        },

        _initialize: function () {
            this.initialRender = true;
            this.element.attr("tabindex", 0).attr("role", "tablist");
            this._itemsRefreshing();
            $(this.anchors).addClass("e-link");
            this._preTabSelectedIndex = this._preTabIndex = -1;
            if (!ej.isNullOrUndefined(this.model.width))
                this.element.width(this.model.width);
            if (!ej.isNullOrUndefined(this.model.height))
                this.element.height(this.model.height);
            this._setTabPosition(this.model.headerPosition);
            if (this.model.showCloseButton)
                this._addDeleteIcon();
            if (this.model.showReloadIcon)
                this._addReloadIcon();
            if (this.model.showRoundedCorner)
                this._roundedCorner(this.model.showRoundedCorner);
            this._enabledAction(this.model.enabled);
            this.contentPanels = [];
            this._addAttr(this.model.htmlAttributes);
            this._reinitialize();
            this._addBaseClass();
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            this._disableTabs();
            this._roundedCorner(this.model.showRoundedCorner);
            if (this.model.enableTabScroll) {
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (this.itemsContainer.width() > (this.element.width()))
                        this._addScrollIcon();
                }
                else {
                    if (this.element.height() < (this.items.height() * this.items.length))
                        this._addScrollIcon();
                }
            }
            this._wireEvents(this.model.events);
            // Added for rendering the Windows tab...
            this.showItem(this.selectedItemIndex());
            this._setTabsHeightStyle(this.model.heightAdjustMode);
            this._enabledAction(this.model.enabled);
            this._resizeEvents(this.model.heightAdjustMode);
            this.model.hiddenItemIndex.length > 0 && this._hiddenIndexItem(this.model.hiddenItemIndex);
        },

        _reinitialize: function ( addContentBaseClass ) {
            var hid, href, hrefBase;
            for (var i = (this._addItemIndex != null) ? this._addItemIndex : 0; i < this.anchors.length; i++) {
                hid = this.anchors[i];
                if (this.divId == undefined)
                    href = $(hid).attr("href");
                else
                    href = this.divId;
                this.divId = undefined;
                hrefBase = href.split("#")[0];
                if (hrefBase && (hrefBase === location.toString().split("#")[0])) {
                    href = a.hash;
                    hid.href = href;
                }
                if (href && href !== "#") {
                    this._addContentTag(href, i);
                    if(addContentBaseClass) this._addContentBaseClass($(this.contentPanels[i]));
                }
                else if (!this.model.enablePersistence) {
                    this.model.disabledItemIndex.push(i);
                }
                if (this._addItemIndex != null) {
                    this._unWireEvents();
                    this._wireEvents(this.model.events);
				if (this.items.length == 1) {
					this.showItem(this.selectedItemIndex());
				}
                    break;
                }
            }

        },
        _itemsRefreshing: function () {
            this.itemsContainer = this.element.find("ol,ul").eq(0);
            this.items = this.itemsContainer.find(" > li:has(a[href])");
            this.anchors = this.items.find('a[href]');
        },
        _setHeaderSize: function (size) {
            this.element.find(">ul li.e-item").css("height", "auto");
            this.element.find(">ul li.e-item").children("a.e-link").css("margin-top", "0px");
            if (this.model.headerPosition == "left") {
                this.element.find(">ul.e-left").css({ "width": size, "text-align": "center" });
            }
            else if (this.model.headerPosition == "right") {
                this.element.find(">ul.e-right").css({ "width": size, "text-align": "center" });
            }
            else {
                this.element.find(">ul.e-header li.e-item").css("height", size);
                this.element.find(">ul.e-header li.e-item a.e-link").css("margin-top", ((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item a.e-link").outerHeight()).toString() + "px");
				this.element.find(">ul.e-header li.e-item .e-icon.e-tabdelete").css("margin-top", (((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item .e-icon.e-tabdelete").outerHeight())-5).toString() + "px");
				this.element.find(">ul.e-header li.e-item .e-icon.e-reload").css("margin-top", (((this.element.find(">ul.e-header").outerHeight() / 2) - this.element.find(">.e-header li.e-item .e-icon.e-reload").outerHeight())-5).toString() + "px");
            }
        },
        _enabledAction: function (flag) {
            if (flag) {
                this.element.removeClass("e-disable");
            }
            else {
                this.element.addClass("e-disable");
            }
        },
        _hiddenIndexItem: function (value) {
            var elementId;
            for (var i = 0; i < value.length; i++) {
                if (!$.inArray(parseInt(value[i]), this._hiddenIndex) > -1) {
                    elementId = $(this.items[parseInt(value[i])]).children('a').attr('href');
                    this._hidePanel(elementId);
                }
            }
            this._hideContentPanel(this.selectedItemIndex(), this.model.hiddenItemIndex);
            this._hiddenIndex = this.model.hiddenItemIndex;
        },
        _hidePanel: function (value) {
            for (var j = 0; j < this.contentPanels.length; j++) {
                if ("#" + $(this.contentPanels[j]).attr('id') == value) {
                    $(this.contentPanels[j]).css('display', 'none');
                    break;
                }
            }
            for (var i = 0; i < this.items.length; i++) {
                if ($(this.items.children('a')[i]).attr('href') == value) {
                    $(this.items[i]).css('display', 'none');
                    break;
                }
            }
        },
        _hideContentPanel: function (index, value) {
            if ($.inArray(index, value) > -1) {
                index += 1;
                if (index <= this.items.length - 1) {
                    this._hideContentPanel(index, value);
                }
                else if (index > this.items.length - 1 && value.length != this.items.length) {
                    this._hideContentPanel(0, value);
                }
            }
            else this.showItem(index);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.element.addClass(value);
                else if (key == "disabled" && value == "disabled") { proxy.model.enabled = false; proxy._enabledAction(false); }
                else proxy.element.attr(key, value)
            });
        },


        _setTabPosition: function (position) {
            if (position == ej.Tab.Position.Bottom) {
                this.itemsContainer.appendTo(this.element);
                this.items.removeClass("e-bottom-line");
                this.items.addClass("e-top-line");
            }
            else if (position == ej.Tab.Position.Top) {
                this.items.removeClass("e-top-line");
				this.itemsContainer.prependTo(this.element);
                if (this.model.enableRTL)
                    this.items.addClass("e-rtl-top-line e-top-hover");
                else
                    this.items.addClass("e-bottom-line");
            }
            else if (position == ej.Tab.Position.Left || position == ej.Tab.Position.Right) {
                if (this.items.length >= 0) {
                    if (this.model.height)
                        this.itemsContainer.css("height", this.model.height);
                    else {
                        if (!this.model.heightAdjustMode === "fill") $(this.itemsContainer).css("height", "");
                    }
                    this.element.addClass("e-vertical");
                }
            }
        },


        _addDeleteIcon: function () {
            if (this.element.find("div.e-close.e-tabdelete").length <= 0 && this.items.length > 0) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var delIconPosition = this.items.find("a");
                    deleteIcon.insertBefore(delIconPosition);
                }
                else
                    this.items.append(deleteIcon);
            }
        },
        _addScrollIcon: function () {
            this.element.addClass("e-tabscroll");
            if (this.element.find("div.e-chevron-circle-right").length <= 0 && this.items.length > 0) {
                this._rightScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-right', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.append(this._rightScrollIcon);
                this.scrollstep = 30;
                this._rightScrollIcon.css("position", "relative");
                if (!this.model.enableRTL) {
                    if (this.model.headerPosition == "left")
                        this._rightScrollIcon.css("margin-right", this.itemsContainer.width() / 2 + "px");
                    else if (this.model.headerPosition == "right")
                        this._rightScrollIcon.css("margin-left", this.itemsContainer.width() / 2 - this.scrollstep + "px");
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelWidth))
                            this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - this.scrollPanelWidth + 20 - ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px");
                        else
                            this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - this.scrollPanelWidth + 20 + "px");
                    }
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    this._rightScrollIcon.css("transform", "rotate(270deg)");
                    if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                        if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")
                            this._rightScrollIcon.css("margin-top", "-" + ((this.itemsContainer.height() + this.scrollPanelWidth) - 3) + "px");
                        else {
                            if (!this.model.enableRTL)
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length) - 20) + "px");
                            else
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length)) + "px");
                        }
                    }
                    else {
                        if (this.model.enablePersistence == true && this._beforeWidth != 0 && (this._beforeWidth > this.scrollPanelHeight))
                            this._rightScrollIcon.css("margin-top", "-" + ((this.items[this.selectedItemIndex()].offsetTop * 3 - this.scrollPanelHeight * 2)) + "px");
                        else
                            if (!this.model.enableRTL)
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length) - 20) + "px");
                            else
                                this._rightScrollIcon.css("margin-top", "-" + ((this.items.height() * this.items.length)) + "px");
                    }
                }

                else {
                    if (this.model.enableRTL) {
                        this._rightScrollIcon.css("margin-top", "-" + (this.itemsContainer.height()) + "px");
                        this._rightScrollIcon.css("margin-left", (this.itemsContainer.width() - 14) + "px");
                    }
                    else
                        this._rightScrollIcon.css("margin-top", "-" + ((this.itemsContainer.height() / 2) + 10) + "px");
                }
                if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11) {
                    if (this.model.headerPosition == "top") {
                        if (parseInt(this._rightScrollIcon.prev().offset().top) - parseInt(this._rightScrollIcon.offset().top) == (-parseInt(this._rightScrollIcon.css("margin-top"))))
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");
                    }
                    else if (this.model.headerPosition == "bottom") {
                        if (!this.model.enableRTL)
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 27) + "px");
                        else
                            this._rightScrollIcon.css("top", ((this.itemsContainer.height() / 2) + 20) + "px");
                    }
                }
                if (this.model.headerPosition == "left") {
                    this._rightScrollIcon.css("margin-right", this.itemsContainer.width() / 2 + "px");
                }
                else if (this.model.headerPosition == "right")
                    this._rightScrollIcon.css("margin-left", this.itemsContainer.width() / 2 - this.scrollstep + "px");
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
            }
        },
        _addScrollBackIcon: function () {
            if (this.element.find("div.e-chevron-circle-left").length <= 0) {
                this._leftScrollIcon = ej.buildTag('div.e-icon e-chevron-circle-left', "", {}, { role: "presentation" }).css("visibility", "hidden");
                this.itemsContainer.prepend(this._leftScrollIcon);
                this.rightscrollstep = 30;
                this.element.attr('unselectable', 'on')
                this.element.css('user-select', 'none')
                this.element.on('selectstart', false);
                this._leftScrollIcon.css("position", "absolute").css("z-index", "10");
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    if (!this.model.enableRTL) {
                        this._leftScrollIcon.css("margin-left", "20px");
                    }
                    else
                        this._leftScrollIcon.css("margin-right", (this.element.width() - 20) + "px");
                }
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    if (!this.model.enableRTL) {
                        if (this.model.headerPosition == "right")
                            this._leftScrollIcon.css("margin-left", ((this.itemsContainer.width() / 2) - 30) + "px");
                        else if (this.model.headerPosition == "left")
                            this._leftScrollIcon.css("margin-left", ((this.itemsContainer.width() / 2) - 15) + "px");
                        this._leftScrollIcon.css("margin-top", +this.scrollPanelHeight + 20 + "px");
                    }
                    else {
                        this._leftScrollIcon.css("margin-top", +(this.scrollPanelHeight - 4) + "px");
                        if (this.model.headerPosition == "right")
                            this._leftScrollIcon.css("margin-right", (this.itemsContainer.width() / 2 + 14) + "px");
                        else
                            this._leftScrollIcon.css("margin-right", (this.itemsContainer.width() / 2) + "px");
                    }
                    this._leftScrollIcon.css("transform", "rotate(270deg)");
                }
                else
                    if (ej.browserInfo().name == "msie" && parseInt(ej.browserInfo().version) < 11)
                        this._leftScrollIcon.css("margin-top", "0px");
                    else {
                        if (!this.model.enableRTL)
                            this._leftScrollIcon.css("margin-top", "-5px");
                        else
                            this._leftScrollIcon.css("margin-top", "0px");
                    }
                this._on(this._leftScrollIcon, "click", this._tabScrollBackClick);
            }
        },


        _addReloadIcon: function () {
            if (this.element.find("div.e-reload").length <= 0 && this.items.length > 0) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                    var iconPosition = this.items.find("a");
                    reloadIcon.insertBefore(iconPosition);
                }
                else
                    this.items.append(reloadIcon);
            }
        },


        _addBaseClass: function () {
            this.element.addClass("e-widget " + this.model.cssClass);
            this.itemsContainer.addClass("e-box")
            if (this.model.enableRTL)
                this.element.addClass("e-rtl");
            // To avoid border blinking 
            if (this.model.headerPosition == "top") {
                $(this.contentPanels).addClass("e-hidebottom e-addborderbottom");
                $(this.itemsContainer).addClass("e-addborderbottom");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderright e-addborderleft");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-top-line");
                    this.items.removeClass("e-rtl-bottom-line");
                }
            }
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels).removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addborderbottom e-addborderright e-addborderleft");
                $(this.contentPanels).addClass("e-hidetop e-addbordertop");
                $(this.itemsContainer).addClass("e-addbordertop");
                this.items.length > 0 && this.itemsContainer.addClass("e-header");
                if (this.model.enableRTL) {
                    this.items.addClass("e-rtl-bottom-line")
                    this.items.removeClass("e-rtl-top-line e-top-line");
                }
            }
            if (this.model.headerPosition == "left") {
                this.items.length > 0 && this.itemsContainer.addClass("e-left");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderright");
                $(this.contentPanels).addClass("e-hideleft e-addborderleft");
                $(this.itemsContainer).addClass("e-addborderleft");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            if (this.model.headerPosition == "right") {
                this.items.length > 0 && this.itemsContainer.addClass("e-right");
                $(this.contentPanels).removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                $(this.itemsContainer).removeClass("e-addbordertop e-addborderbottom e-addborderleft");
                $(this.contentPanels).addClass("e-hideright e-addborderright");
                $(this.itemsContainer).addClass("e-addborderright");
                if (this.model.enableTabScroll && this._tabContentsHeight() > (this.element.height || Number(this.model.height)))
                    $(this.itemsContainer).css("z-index", "12").css("margin-left", "-" + this.itemsContainer.find("li").width() + "px");
                $(this.items).removeClass("e-rtl-bottom-line e-rtl-top-line");
            }
            this.items.addClass("e-select e-item").attr("role", "tab").attr("tabindex", -1).attr("aria-expanded", true).attr("aria-selected", false);
            $(this.contentPanels).addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
            if (((this.model.headerPosition == "left" || this.model.headerPosition == "right") && (this._tabContentsHeight() > (this.element.height() || Number(this.model.height)))) || ((this.model.headerPosition == "top" || this.model.headerPosition == "bottom") && this._tabContentsWidth() > ((ej.getDimension(this.element, "width")) || this.model.width)))
                this._checkScroll();
        },
        _addContentBaseClass: function (panelElement) {
            if (this.model.headerPosition == "top") {
                panelElement.addClass("e-hidebottom e-addborderbottom");
                panelElement.removeClass("e-hidetop e-addbordertop e-hideright e-addborderright e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "bottom") {
                panelElement.removeClass("e-hidebottom e-addborderbottom e-hideright e-addborderright e-hideleft e-addborderleft");
                panelElement.addClass("e-hidetop e-addbordertop");
            }
            if (this.model.headerPosition == "left") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideright e-addborderright");
                panelElement.addClass("e-hideleft e-addborderleft");
            }
            if (this.model.headerPosition == "right") {
                panelElement.removeClass("e-hidetop e-addbordertop e-hidebottom e-addborderbottom e-hideleft e-addborderleft");
                panelElement.addClass("e-hideright e-addborderright");
            }
            panelElement.addClass("e-content  e-content-item e-box").attr("role", "tabpanel").attr("aria-hidden", true);
        },

        _checkScroll: function () {
            this.scrollPanelWidth = ej.getDimension(this.element, "width");
            this.scrollPanelHeight = ej.getDimension(this.element, "height");
            if (this.model.enableTabScroll == true && this._tabContentsHeight() > this.items.height()) {
                this.scrollstep = 0;
                this.model.enableTabScroll = true;
                if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                    this.itemsContainer.css({ "width": ((ej.getDimension(this.element, "width") + (parseInt(this.items.css("width")) * this.items.length))) + "px", "position": "absolute" });
                }
                this._beforeWidth = 0;
                if (this.model.enablePersistence == true) {
                    if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetWidth;
                        }
                    }
                    else {
                        for (var val = 0; val < this.selectedItemIndex() ; val++) {
                            this._beforeWidth += this.items[val].offsetHeight;
                        }
                    }
                }
                var widthValue = parseInt(this.itemsContainer.css("width"));
                if (this.model.headerPosition == "top") {
                    var item = $(this.contentPanels);
                    item.css("padding-top", this.itemsContainer.outerHeight() + (item.hasClass("e-activetop") ? 0 : (this.model.enableRTL ? 4 : 3)) + "px");
                    $(this.contentPanels).css({"border-top": "none", "width": ej.getDimension(this.element, "width") - 1 + "px" });
                    this.itemsContainer.css("border-bottom", "1px solid #bbbcbb");
                }
                if (this.model.headerPosition == "bottom") {
                    $(this.contentPanels).css({ "position": "relative", "width": ej.getDimension(this.element, "width") - 1 + "px", "border-bottom": "none" });
                    this.itemsContainer.css("border-top", "1px solid #bbbcbb");
                    $(this.contentPanels).css({ "border-top": "" });
                }

                var rigtVaule = parseInt(widthValue - (this.scrollPanelWidth + this.scrollstep - 1));
                if (this.model.enableRTL && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                    this.itemsContainer.css("clip", "rect(0px," + widthValue + "px,100px," + rigtVaule + "px)");
                }
                else if (this.model.headerPosition == "left") {
                    if (this._tabContentsHeight() > Number(this.model.height)) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "border-right": "1px solid #bbbcbb", "background": "white" });
                        $(this.contentPanels).css("padding-left", this.itemsContainer.width() + 5 + "px");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", (ej.getDimension(this.element, "width") - this.itemsContainer.width()));
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + (this.itemsContainer.width() + 4) + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }

                        this.element.removeClass("e-scrolltab");
                    }
                }
                else if (this.model.headerPosition == "right") {
                    if (this._tabContentsHeight() > Number(this.model.height)) {
                        this.itemsContainer.css({ "height": ((parseInt(this.itemsContainer.css("height")) + (parseInt(this.items.css("height")) * this.items.length)) + 30) + "px", "position": "absolute", "margin-left": "-1px" }).css("z-index", "12")
                        $(this.contentPanels).css({ "position": "absolute", "width": parseInt(this.element.width() - 1) + "px", "height": ej.getDimension(this.element, "height") + "px", "margin-left": "-" + ej.getDimension(this.element, "width") + "px", "border-right": "none" });
                        if (!this.model.enableRTL)
                            $(this.element).css("margin-left", ej.getDimension(this.element, "width") + "px");
                        this.itemsContainer.css("border-left", "1px solid #bbbcbb");
                        if (this.model.enableRTL)
                            this.itemsContainer.css("margin-right", "-" + (this.itemsContainer.width() + 1) + "px");
                        if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelHeight)
                            this.itemsContainer.css("clip", "rect(0px," + this.itemsContainer.width() + 2 + "px," + this.scrollPanelHeight + "px," + (this.scrollstep) + "px)");
                        else {
                            if (this._beforeWidth > this.scrollPanelHeight) {
                                this.itemsContainer.css({
                                    "clip": "rect(" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px," + (this.itemsContainer.width() + 2) + "px," + (this.items[this.selectedItemIndex()].offsetTop * 2 - this.scrollPanelHeight) + "px,0px)",
                                    "margin-top": "-" + ((this.items[this.selectedItemIndex()].offsetTop - this.scrollPanelHeight) * 2) + "px"
                                });
                            }
                        }
                        this.element.removeClass("e-scrolltab");
                    }
                }
                else {
                    if (this._beforeWidth == 0 || this._beforeWidth < this.scrollPanelWidth) {
                        this.itemsContainer.css({ "clip": "rect(0px," + (this.scrollPanelWidth + this.scrollstep) + "px,100px," + (this.scrollstep) + "px)", "margin-left": "-" + this.scrollstep + "px" });
                    }
                    else {
                        if (this._beforeWidth > this.scrollPanelWidth) {
                            this.itemsContainer.css({ "clip": "rect(0px," + (this.items[this.selectedItemIndex()].offsetLeft * 2 - this.scrollPanelWidth) + "px,100px," + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px)", "margin-left": "-" + ((this.items[this.selectedItemIndex()].offsetLeft - this.scrollPanelWidth) * 2) + "px" });
                        }
                    }
                }
                this.itemsContainer.find(".e-icon.e-chevron-circle-left").length && this.itemsContainer.find(".e-icon.e-chevron-circle-left").css("display", "none");
                this._initialClip = this.itemsContainer.css("clip");
            }
        },
        _executeForwardScrolling: function (args , scrollStep) {
            this._rightScrollIcon.css("position", "relative");
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 + tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-right", (scrollValue - tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-left", (ClipValue2 + tabScrollStep) + "px") : "";
					if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
					if ((this._leftScrollIcon && this._leftScrollIcon.css("margin-left")) && (Number(this._leftScrollIcon.css("margin-left").split("px")[0]) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))) {
                        this._rightScrollIcon.css("display", "none"); 
						this._off(this.items, "swipeleft", this._tabSwipe);
                    }

                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = this.itemsContainer.css("margin-right") ? Number(this.itemsContainer.css("margin-right").split("px")[0].replace(",", "")) : 0;
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin + tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue - tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll + tabScrollStep) + "px") : "";
					 if(args.type=='swipeleft' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) >= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
					   this._off(this.items, "swipeleft", this._tabSwipe);
                    if (this._leftScrollIcon && this._leftScrollIcon.css("margin-right") && (Number(this._leftScrollIcon.css("margin-right").split("px")[0])) >= (this._tabContentsWidth() - 40))
                        this._rightScrollIcon.css("display", "none")

                }

            }
            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0].replace(",", ""));
                var RightTop = this._leftScrollIcon && this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 + tabScrollStep) + "px, " + (this.itemsContainer.width() + 4) + "px," + (ClipValue2 + tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop + tabScrollStep) + "px" });
                this._rightScrollIcon.css("margin-top", (scrollValue + tabScrollStep) + "px");
                this._leftScrollIcon ? this._leftScrollIcon.css("margin-top", (RightTop + tabScrollStep) + "px") : "";
                if (ClipValue2 > (this._tabContentsHeight() - 20)) {
                    this.itemsContainer.css({ "clip": "rect(" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px, " + (this.itemsContainer.width() + 4) + "px, " + (this._tabContentsHeight() + 2) + "px, 0px", "margin-top": "-" + (this._tabContentsHeight() - Number(this.model.height) + 2) + "px" })
                    this._leftScrollIcon.css("margin-top", (this._tabContentsHeight() - 12) + "px")
                    this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - (this._tabContentsHeight() - Number(this.model.height)) - 22) + "px");
                    this._rightScrollIcon.css("display", "none");
                }
            }
        },
        _executeBackwardScrolling: function ( args , scrollStep ) {
            if (this._rightScrollIcon != "") this._rightScrollIcon.css("display", "block");
			var tabScrollStep= (scrollStep) ? scrollStep :(args.type=='swiperight'||args.type=='swipeleft')? 50: 30;
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom") {
                if (!this.model.enableRTL) {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var scrollValue = Number(this._rightScrollIcon.css("margin-right").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 - tabScrollStep) + "px,100px," + (ClipValue2 - tabScrollStep) + "px)", "margin-left": "-" + (ClipValue2 - tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-right", (scrollValue + tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-left", (ClipValue2 - tabScrollStep) + "px") : "";
                    if (ClipValue2 - tabScrollStep < 0) {
                        this.itemsContainer.css({ "clip": "rect(0px," + ej.getDimension(this.element, "width") + "px,100px, 0px", "margin-left": "0px" });
                        this._rightScrollIcon.css("margin-right", this.itemsContainer.width() - ej.getDimension(this.element, "width") + 20 + "px");
                    }
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-left')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (ClipValue2 <= tabScrollStep && this._leftScrollIcon)
                        this._leftScrollIcon.css("display", "none");
                }
                else {
                    var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[1].replace(",", ""));
                    var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[3].replace(",", ""));
                    var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                    var RightScroll = this._leftScrollIcon && this._leftScrollIcon.css("margin-right") ? Number(this._leftScrollIcon.css("margin-right").split("px")[0]) : "";
                    var scrollValue = Number(this._rightScrollIcon.css("margin-left").split("px")[0]);
                    this.itemsContainer.css({ "clip": "rect(0px," + (ClipValue1 + tabScrollStep) + "px,100px," + (ClipValue2 + tabScrollStep) + "px)", "margin-right": "-" + (-itemsMargin - tabScrollStep) + "px" });
                    this._rightScrollIcon.css("margin-left", (scrollValue + tabScrollStep) + "px");
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-right", (RightScroll - tabScrollStep) + "px") : "";
					if(args.type=='swiperight' && Math.abs(Number((this.itemsContainer.css('margin-right')).split("px")[0])) <= (this._tabContentsWidth() - ej.getDimension(this.element, "width")))
						this._on(this.items, "swipeleft", this._tabSwipe);
                    if (itemsMargin >= -tabScrollStep && this._leftScrollIcon) {
                        this._leftScrollIcon.css("display", "none");
                    }
                }
            }

            else if (this.model.headerPosition == "left" || this.model.headerPosition == "right") {
                var ClipValue1 = Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]);
                var ClipValue2 = Number(this.itemsContainer.css("clip").split("px")[2].replace(",", ""));
                var scrollValue = Number(this._rightScrollIcon.css("margin-top").split("px")[0]);
                var RightTop = this._leftScrollIcon.css("margin-top") ? Number(this._leftScrollIcon.css("margin-top").split("px")[0]) : 0;
                var MarginTop = this.itemsContainer.css("margin-top") ? Number(this.itemsContainer.css("margin-top").split("px")[0]) : 0;
                this.itemsContainer.css({ "clip": "rect(" + (ClipValue1 - tabScrollStep) + "px, " + this.itemsContainer.width() + "px," + (ClipValue2 - tabScrollStep) + "px, 0px)", "margin-top": "-" + (-MarginTop - tabScrollStep) + "px" });
                this._rightScrollIcon.css("margin-top", (scrollValue - tabScrollStep) + "px").css("display", "block");
                this._leftScrollIcon.css("margin-top", (RightTop - tabScrollStep) + "px");
                if (Number(this.itemsContainer.css("clip").split("px")[0].split("(")[1]) <= 0) {
                    this.itemsContainer.css({ "clip": "rect( 0px, " + this.itemsContainer.width() + "px," + (Number(this.model.height)) + "px, 0px)", "margin-top": "0px" });
                    this._leftScrollIcon.css("display", "none");
                    this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - 22) + "px");
                }
            }
        },

        _removeHeaderClass: function () {
            this.itemsContainer.remove();
            this.itemsContainer.insertBefore(this.element.find(">div").first());
            this.items.removeClass("e-bottom-line e-top-line");
            $(this.contentPanels).removeClass("e-content-bottom e-activetop e-activebottom");
            this.itemsContainer.removeClass("e-header e-left e-right");
        },

        _removeVerticalClass: function () {
            this.element.removeClass("e-vertical");
            this.itemsContainer.removeClass("e-left e-right").removeAttr("style");
        },


        _removeBaseClass: function () {
            this.element.removeClass("e-tab e-widget e-corner e-js e-tabscroll").removeAttr("role tabindex unselectable");
            if ((this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                this._removeVerticalClass();
            this.itemsContainer.removeClass("e-header e-box e-clearall e-select e-addborderbottom e-addbordertop e-addborderleft e-addborderright");
            this.anchors.removeClass("e-link");
            this.items.removeClass("e-select e-item e-active e-bottom-line e-top-line e-margine-top e-margine-bottom e-rtl-top-line e-top-hover e-rtl-bottom-line e-disable").removeAttr("role tabindex aria-selected aria-expanded");
            $(this.contentPanels).removeClass("e-content  e-content-item e-box e-content-bottom e-activetop e-activebottom e-active-content e-hidebottom e-addborderbottom e-hidetop e-addbordertop e-hideleft e-addborderleft e-hideright e-addborderright e-disable").removeAttr("role aria-hidden").css("display", "");
            this.itemsContainer.find("div.e-close.e-tabdelete,div.e-icon.e-chevron-circle-right,div.e-icon.e-chevron-circle-left,div.e-icon.e-reload").remove();
        },


        _addContentTag: function (href, index) {
            var id = this._getTabId(href);
            var panel = this.element.find("#" + id);
            if (!panel.length) {
                panel = ej.buildTag("div.e-content  e-content-item e-box e-content-bottom #" + id)
                    .insertAfter(this.contentPanels[index - 1] || this.itemsContainer);
            }
            this.contentPanels.splice(index, 0, panel[0]);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
            }
            else if (this.element.hasClass('e-corner')) {
                this.element.removeClass('e-corner');
            }
        },


        _setTabsHeightStyle: function (heightFormat) {
            if (ej.Tab.HeightAdjustMode.Content != heightFormat) $(this.contentPanels).height("");
            if (ej.Tab.HeightAdjustMode.Fill == heightFormat) {
                if (ej.Tab.Position.Left === this.model.headerPosition || ej.Tab.Position.Right === this.model.headerPosition) {
                    $(this.contentPanels).css("height", "100vh");
                }
                this._contentPaneSize();
            }
            else if (ej.Tab.HeightAdjustMode.Auto == heightFormat) {
                var maxHeight = 0;
                $(this.contentPanels).css({ "display": "none" }).addClass('e-active-content');
                for (var i = 0; i < this.contentPanels.length; i++) {
                    maxHeight = Math.max(maxHeight, this._getDimension($(this.contentPanels[i]), "outerHeight"));
                }
                $(this.contentPanels).removeClass('e-active-content');
                $(this.contentPanels).height(maxHeight);
                this.maxAutoHeight = maxHeight;
                this.showItem(this.selectedItemIndex());
            }
            else if (ej.Tab.HeightAdjustMode.None == heightFormat) {
                if (this.model.height != null) {
                    this._contentPaneSize();
                }
            }
            if (ej.Tab.HeightAdjustMode.Fill !== heightFormat) $(this.itemsContainer).height("");
            if (ej.Tab.HeightAdjustMode.Content == heightFormat)
                $(this.contentPanels).height("auto");

            if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },
        _getDimension: function (element, method) {
            var value;
            var $hidden = $(element).parents().addBack().filter(':hidden');
            var prop = { visibility: 'hidden', display: 'block' };
            var hiddenCollection = [];
            $hidden.each(function () {
                var hidden = {}, name;
                for (name in prop) {
                    hidden[name] = this.style[name];
                    this.style[name] = prop[name];
                }
                hiddenCollection.push(hidden);
            });
            value = /(outer)/g.test(method) ?
            $(element)[method](true) :
           $(element)[method]();

            $hidden.each(function (i) {
                var hidden = hiddenCollection[i], name;
                for (name in prop) {
                    this.style[name] = hidden[name];
                }
            });
            return value;
        },
        // Tab to active given index value
        showItem: function (index) {
            if ($.inArray(index, this.model.disabledItemIndex) < 0) {
                var proxy = this;
                if (this._isInteraction != false) this._isInteraction = true;
                this._preTabSelectedIndex = this.selectedItemIndex();
                this.selectedItemIndex(index);
                if (this.selectedItemIndex() >= this.contentPanels.length) {
                    this.selectedItemIndex(0);
                    index = this.selectedItemIndex();
                }
                if (index >= 0 && !this.initialRender && true === this._onBeforeActive(index)){
                    this.selectedItemIndex(this._preTabSelectedIndex);
                    return false;
                } 
                else this._preTabIndex = this._preTabSelectedIndex;
                $(this.items[this.selectedItemIndex()]).attr("aria-expanded", true).attr("aria-selected", true).attr("tabindex", 0);
                if (this.selectedItemIndex() != null && this.selectedItemIndex() < this.contentPanels.length) {
                    this._ajaxLoad();
                    this.hideItem(this._preTabIndex);
                    $(this.contentPanels[this.selectedItemIndex()]).fadeIn(this.model.enableAnimation ? 20 : 0, function () {
                        if (!proxy.initialRender && proxy._onActive())
                            return true;
                        proxy.initialRender = false;
                    });
                    if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                        var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
                        $(this.contentPanels[this.selectedItemIndex()]).addClass(activeClass)
                    }
                    else
                        $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content ");
                    $(this.items[this.selectedItemIndex()]).addClass("e-active").removeClass("e-select");
                    $(this.items[this.selectedItemIndex()]).removeClass("e-margine-top e-margine-bottom");

                    for (var i = 0; i <= $(this.items).length; i++) {
                        if ($(this.items[i]).hasClass("e-select")) {
                            if (this.model.headerPosition == "right") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "left") {
                                $(this.items[i]).removeClass("e-margine-top e-margine-bottom");
                            }
                            if (this.model.headerPosition == "top") {
                                if (!this.element.hasClass("e-tab-collapsed"))
                                    $(this.items[i]).addClass("e-margine-top");
                                else
                                    $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).removeClass("e-margine-bottom");
                            }
                            if (this.model.headerPosition == "bottom") {
                                $(this.items[i]).removeClass("e-margine-top");
                                $(this.items[i]).addClass("e-margine-bottom");
                            }
                        }
                    }
                    $(this.contentPanels[this.selectedItemIndex()]).addClass("e-active-content").removeAttr("aria-hidden", false);
                }
            }
            if (this.model.enableTabScroll && this._tabContentsWidth() > (this.model.width || this.element.width()) && this.itemsContainer.find("li").length && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                if (!this.model.enableRTL) {
                    var itemPosition = Number(this.itemsContainer.find("li.e-active").position().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() - ej.getDimension(this.element, "width");
                    if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() > ej.getDimension(this.element, "width") || (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) - this.itemsContainer.find("li.e-active").width() < 0))) {
                        this.itemsContainer.css("clip", "rect(0 ," + (ej.getDimension(this.element, "width") + (itemPosition + 10)) + "px, 100px," + (itemPosition + 10) + "px)").css("margin-left", "-" + (itemPosition + 10) + "px")
                        this._rightScrollIcon ? this._rightScrollIcon.css("margin-right", (this.itemsContainer.width() - ej.getDimension(this.element, "width") + 10 - itemPosition) + "px").css("display", "block") : "";
                        this._addScrollBackIcon();
                        this._leftScrollIcon ? this._leftScrollIcon.css("display", "block").css("margin-left", (itemPosition + 10) + "px") : "";
                    }
                    else if ((itemPosition < 0) && (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) + this.itemsContainer.find("li.e-active").width() > ej.getDimension(this.element, "width") || (Number(this.itemsContainer.find("li.e-active").offset().left.toFixed(0)) - this.itemsContainer.find("li.e-active").width() < 0))) {
                        this.itemsContainer.css("clip", "rect(0 ," + (ej.getDimension(this.element, "width")) + "px, 100px, 0px)").css("margin-left", "0px")
                        this._rightScrollIcon ? this._rightScrollIcon.css("margin-right", (this.itemsContainer.width() - ej.getDimension(this.element, "width") + 20) + "px").css("display", "block") : "";
                        this._leftScrollIcon ? this._leftScrollIcon.css('display', 'none') : "";
                    }
                }
            }
            else if (this.model.enableTabScroll && this.model.height && (this.model.headerPosition == "left" || this.model.headerPosition == "right") && !this.model.enableRTL) {
                var itemPosition = Number(this.itemsContainer.find("li.e-active").position().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() - Number(this.model.height);
                if ((itemPosition > 0) && (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() > Number(this.model.height) || (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) - this.itemsContainer.find("li.e-active").height() < 0))) {
                    this.itemsContainer.css("clip", "rect(" + itemPosition + "px," + (this.itemsContainer.outerWidth() + 2) + "px, " + (Number(this.model.height) + itemPosition) + "px, 0px").css("margin-top", "-" + itemPosition + "px");
                    this._rightScrollIcon ? this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - itemPosition - 22) + "px").css("display", "block") : "";
                    this._addScrollBackIcon();
                    this._leftScrollIcon ? this._leftScrollIcon.css("margin-top", Number(this.model.height) + itemPosition - 10 + "px").css("display", "block") : "";
                }
                else if ((itemPosition < 0) && (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) + this.itemsContainer.find("li.e-active").height() > Number(this.model.height) || (Number(this.itemsContainer.find("li.e-active").offset().top.toFixed(0)) - this.itemsContainer.find("li.e-active").height() < 0))) {
                    this.itemsContainer.css("clip", "rect(0px ," + (this.itemsContainer.outerWidth() + 2) + "px, " + Number(this.model.height) + "px, 0px").css("margin-top", "0px")
                    this._rightScrollIcon ? this._rightScrollIcon.css("margin-top", "-" + (this._tabContentsHeight() - 22) + "px").css("display", "block") : "";
                    this._leftScrollIcon ? this._leftScrollIcon.css('display', 'none').css("margin-top", (Number(this.model.height) - 10) + "px") : "";
                }
            }

        },

        hideItem: function (index) {
            $(this.contentPanels[index]).fadeOut(0);
            if (!(this.model.headerPosition == "left" || this.model.headerPosition == "right"))
                var activeClass = this.model.headerPosition == ej.Tab.Position.Top ? "e-activetop" : "e-activebottom";
            $(this.items[index]).removeClass("e-active").addClass("e-select");
            $(this.contentPanels[index]).removeClass("e-active-content " + activeClass).attr("aria-hidden", true);
        },


        _ajaxLoad: function () {
            var content = $(this.contentPanels[this.selectedItemIndex()]);
            var link = this.anchors[this.selectedItemIndex()];
            var href = $(link).attr("href");
            if (content.is(':empty') && href.indexOf("#") !== 0)
                this._sendAjaxOptions(content, link);
        },


        _getTabId: function (href) {
            return !href.indexOf("#") ? href.replace("#", "") : this.model.idPrefix + this._getNextTabId();
        },

        _getNextTabId: function () {
            return ++this.tabId;
        },


        _disableTabs: function () {
            for (var i = 0, li; (li = this.items[i]) ; i++) {
                if ($.inArray(i, this.model.disabledItemIndex) > -1) {
                    $(li).find("a").off(this.model.events);
                    $(li).find("div.e-close").off("click");
                }
                $(li)[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(li).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
                $(this.contentPanels[i])[$.inArray(i, this.model.disabledItemIndex) != -1 &&
                    !$(this.contentPanels[i]).hasClass("e-tab-selected") ? "addClass" : "removeClass"]("e-disable");
            }
        },


        _tabItemClick: function (args) {

            if (this.model.enabled) {
                args.preventDefault(); // Prevent the ancher tag url action
                var index;
                if (this.selectedItemIndex() == $(this.items).index($(args.currentTarget)) && this.model.collapsible) {
                    index = -1; $(this.element).addClass("e-tab-collapsed");
                }
                else {
                    index = $(this.items).index($(args.currentTarget));
                }
                if (index != this.selectedItemIndex())
                    this.showItem(index);
                $(this.element).removeClass("e-tab-collapsed");
            }
        },

        _tabDeleteClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                var tabWidth = $(args.target).parent().width();
                if (currentTab.hasClass("e-close"))
                    var index = $(this.items).index($(args.target).parent());
                if (index == this.selectedItemIndex() && this.items.length > index)
                    this.selectedItemIndex(this.selectedItemIndex() + 1)
                var itemsMargin = Number(this.itemsContainer.css("margin-right").split("px")[0]) ? Number(this.itemsContainer.css("margin-right").split("px")[0]) : 0;
                if(this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                     if(!this.model.enableRTL || (this.model.enableRTL && itemsMargin < -tabWidth )) this._executeBackwardScrolling(args,tabWidth);
                     else {
                         this.itemsContainer.css({"margin-right":"0px","clip":this._initialClip});
                         this._leftScrollIcon && this._leftScrollIcon.css("display", "none");
                         this._rightScrollIcon && this._rightScrollIcon.css("display", "none");
                     }	 
                }
                this.removeItem(index);
            }
        },
        _tabScrollClick: function (args) {
            if (this.model.enabled) {
                if ((this._rightScrollIcon[0] == args.target)) {
                    this._executeForwardScrolling(args);

                    this._addScrollBackIcon();
                    this._leftScrollIcon.css("display", "block");
                }
            }
        },
		
		_tabSwipe: function(e){ 
			 if(e.type=='swipeleft')  
			this._executeForwardScrolling(e);
			else 
			this._executeBackwardScrolling(e);
		},
        _tabScrollBackClick: function (args) { 
            if (this.model.enabled) {
                if ((this._leftScrollIcon[0] == args.target)) {
                    this._executeBackwardScrolling(args);
                }
            }
        },

        _tabReloadClick: function (args) {
            if (this.model.enabled) {
                var currentTab = $(args.target);
                if (currentTab.hasClass("e-reload")) {
                    var link = this.anchors[this.selectedItemIndex()];
                    var href = $(link).attr("href");
                    var content = $(this.contentPanels[this.selectedItemIndex()]);
                    if (href.indexOf("#") !== 0)
                        this._sendAjaxOptions(content, link);
                    else
                        this.showItem(this.selectedItemIndex());
                }
            }
        },


        _sendAjaxOptions: function (content, link) {
            //load waiting popup
            if (this._onBeforeLoad(link))
                return true;
            content.addClass("e-load");
            var proxy = this;
            var curTabTitle = $(link).html();
            var hrefLink = link.href.replace("#", "");
            var ajaxOptions = {
                type: this.model.ajaxSettings.type, cache: this.model.ajaxSettings.cache, url: hrefLink, data: this.model.ajaxSettings.data,
                dataType: this.model.ajaxSettings.dataType, contentType: this.model.ajaxSettings.contentType, async: this.model.ajaxSettings.async,
                "success": function (data) {
                    try {
                        proxy._ajaxSuccessHandler(data, content, link, curTabTitle);
                    } catch (e) {

                    }
                }, "error": function () {
                    try {
                        proxy._ajaxErrorHandler(link, proxy.selectedItemIndex(), curTabTitle);
                    } catch (e) {

                    }
                }
            };
            this._sendAjaxRequest(ajaxOptions);
        },

        _sendAjaxRequest: function (ajaxOptions) {
            $.ajax({
                type: ajaxOptions.type,
                cache: ajaxOptions.cache,
                url: ajaxOptions.url,
                dataType: ajaxOptions.dataType,
                data: ajaxOptions.data,
                contentType: ajaxOptions.contentType,
                async: ajaxOptions.async,
                success: ajaxOptions.success,
                error: ajaxOptions.error,
                beforeSend: ajaxOptions.beforeSend,
                complete: ajaxOptions.complete
            });
        },


        _ajaxSuccessHandler: function (data, content, link, curTabTitle) {
            if (curTabTitle != null)
                $(link).html(curTabTitle);
            content.removeClass("e-load");
            content.html(data).addClass("e-tab-loaded"); //to indicate the content is already loaded
            var eventData = { data: data, url: link, content: content };
            this._trigger("ajaxSuccess", eventData);
            if (this._onLoad(link))
                return true;
        },


        _ajaxErrorHandler: function (data, link, index, title) {
            this._trigger("ajaxError", { data: data, url: link });
            this._onLoad(link);
        },

        _createContentPanel: function (id) {
            return $('<div></div>')
				.attr("id", id)
				.addClass("e-content  e-content-item e-content-bottom e-box");
        },


        _refresh: function () {
            this._unWireEvents();
            this.itemsContainer.removeAttr("style class");
            $(this.contentPanels).removeAttr("style class");
            this.element.css("margin-left", "");
            this._removeVerticalClass();
            this._removeHeaderClass();
            this._initialize();
        },

        _keyPress: function (e) {
            if (this.model.enabled) {
                var index, currentEle, targetEle = $(e.target),code;
                if (e.keyCode) code = e.keyCode; // ie and mozilla/gecko
                else if (e.which) code = e.which; // ns4 and opera
                else code = e.charCode;
                if (targetEle.hasClass("e-link") || targetEle.hasClass("e-item")) {
                    switch (code) {
                        case 39:
                        case 40:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex() + 1);
                                break;
                            }
                        case 37:
                        case 38:
                            {
                                e.preventDefault();
                                if (this.selectedItemIndex() != 0)
                                    this.showItem(this.selectedItemIndex() - 1);
                                else if (this.selectedItemIndex() == 0)
                                    this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 35:
                            {
                                e.preventDefault();
                                this.showItem(this.getItemsCount() - 1);
                                break;
                            }
                        case 36:
                            {
                                e.preventDefault();
                                this.showItem(0);
                                break;
                            }
                        case 13:
                            {
                                e.preventDefault();
                                this.showItem(this.selectedItemIndex());
                                break;
                            }
                    }
                }
                else if (e.ctrlKey && !targetEle.hasClass("e-tab")) {
                    switch (code) {
                        case 38:
                            e.preventDefault();
                            index = $(this.contentPanels).index(targetEle.parent(".e-content"));
                            currentEle = $(this.items[index]);
                            break;
                        case 33:
                            e.preventDefault();
                            currentEle = $(this.items[0]);
                            this.showItem(0);
                            break;
                        case 34:
                            e.preventDefault();
                            currentEle = $(this._headers[this.getItemsCount() - 1]);
                            this.showItem(this.getItemsCount() - 1);
                            break;
                    }
                }
                if (!ej.isNullOrUndefined(currentEle)) {
                    currentEle.addClass("e-focus");
                    currentEle.focus();
                }
            }
        },

        _hoverHandler: function (args) {
            args.preventDefault();
            if (this.model.enabled) {
                var index = $(this.items).index($(args.target).parent());
                if (index == -1)
                    index = $(this.items).index($(args.target));
				if(!$(this.items[index]).hasClass("e-disable")){
                args.type === "mouseout" ? $(this.element.find("div.e-tabdelete")[index]).css("visibility", "hidden") : $(this.element.find("div.e-tabdelete")[index]).css("visibility", "visible");
				args.type === "mouseout" ? $(this.element.find("div.e-reload")[index]).css("visibility", "hidden") : $(this.element.find("div.e-reload")[index]).css("visibility", "visible");
				}
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-right")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-right")).css("visibility", "visible");
                args.type === "mouseout" ? $(this.element.find("div.e-chevron-circle-left")).css("visibility", "hidden") : $(this.element.find("div.e-chevron-circle-left")).css("visibility", "visible");
            }
        },


        _wireEvents: function (event) {
            this._on(this.items, event, this._tabItemClick);
            this._on(this.itemsContainer, "mouseover", this._hoverHandler);
            this._on(this.itemsContainer, "mouseout", this._hoverHandler);
            this._on(this.element.find(">ul").eq(0).find(">li div.e-close"), "click", this._tabDeleteClick);
            this._on(this.element.find(">ul").eq(0).find("div.e-chevron-circle-left"), "click", this._tabScrollBackClick);
			if (this.model.enableTabScroll)this._on(this.items, "swipeleft swiperight", this._tabSwipe);
            this._on(this.itemsContainer, "focusin", this._focusIn);
            this._on(this.itemsContainer, "focusout", this._focusOut);
            $(window).on('resize', $.proxy(this._resize, this));
            this._on(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click", this._tabReloadClick);
        },
        _resize: function () {
            if (this.model && this.model.width == null && this.model.enableTabScroll && (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")) {
                this._removeScroll()
                this._addScroll()
            }
        },


        _unWireEvents: function () {
            this._off(this.items, this.model.events);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-close"), "click");
            this._off(this.element.find(">ul").eq(0).find("div.e-chevron-circle-right"), "click");
            this._off(this.element.find(">ul").eq(0).find("div.e-chevron-circle-left"), "click");
			if (this.model.enableTabScroll)this._off(this.items, "swipeleft swiperight", this._tabSwipe);
            this._off(this.itemsContainer, "mouseover", this._hoverHandler);
            this._off(this.itemsContainer, "mouseout", this._hoverHandler);
            this._off(this.itemsContainer, "focusin", this._focusIn);
            this._off(this.itemsContainer, "focusout", this._focusOut);
            this._off(this.element.find(">ul").eq(0).find(">li div.e-reload"), "click");
            this._resizeEvents();
        },
        _resizeEvents: function (value) {
            if (value === "fill") $(window).on('resize', $.proxy(this._windowResized, this));
            else $(window).off('resize', $.proxy(this._windowResized, this));
        },


        _windowResized: function (e) {
            var maxHeight = this._getDimension($(this.element).parent(), "height");
            if (this._prevSize == maxHeight) return;
            else this._contentPaneSize();
            this._prevSize = maxHeight;
            if (!this.model.width && this.model.enableTabScroll)
                this._addScroll();
        },
        _contentPaneSize: function () {
            if (this.model.height != null && this.model.heightAdjustMode == "none") {
                $(this.element).height(this.model.height);
                var maxHeight = this._getDimension($(this.element), "height");
            }
            else var maxHeight = this._getDimension($(this.element).parent(), "height");
            $(this.contentPanels).height("");
            $(this.element).parent().css({ "overflow": "auto" });
            if (this.model.headerPosition === "top" || this.model.headerPosition === "bottom")
                maxHeight -= this._getDimension($(this.itemsContainer), "outerHeight");
            var maxPadding = 0, padding;
            for (var i = 0; i < this.contentPanels.length; i++) {
                if ($(this.contentPanels[i]).hasClass("e-active-content")) {
                    padding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - padding).css({ "overflow": "auto" });
                } else {
                    maxPadding = Math.max(maxPadding, this._getDimension($(this.contentPanels[i]), "outerHeight") - this._getDimension($(this.contentPanels[i]), "height"));
                    if (this.model.height != null && this.model.heightAdjustMode == "none") $(this.contentPanels[i]).outerHeight(maxHeight).css({ "overflow": "auto" })
                    else $(this.contentPanels[i]).height(maxHeight - maxPadding).css({ "overflow": "auto" });
                }
            }
        },
        _disableItems: function (indexes) {
            if (!this.model.enabled) return false;
            if (indexes != null) {
                for (var i = 0; i < indexes.length; i++) {
                    if ($.inArray(indexes[i], this.model.disabledItemIndex) == -1)
                        this.model.disabledItemIndex.push(indexes[i]);
                }
                this.model.disabledItemIndex.sort();
                this._disableTabs();
            }
        },

        _enableItems: function (indexes) {
            if (!this.model.enabled) return false;
            for (var i = 0; i < indexes.length; i++) {
                var index = indexes[i];
                this.model.disabledItemIndex = $.grep(this.model.disabledItemIndex, function (n, i) {
                    return n != index;
                });
            }
            this._disableTabs();
        },


        disable: function () {
            var indexes = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                indexes.push(index);
            }
            this._disableItems(indexes);
            this.model.enabledItemIndex = [];
            this._unWireEvents();
        },

        enable: function () {
            var indexes = [];
            this.model.disabledItemIndex = [];
            for (var index = 0; index < this.getItemsCount() ; index++) {
                if ($.inArray(index, this.model.enabledItemIndex) < 0) {
                    this.model.enabledItemIndex.push(index);
                    indexes.push(index);
                }
                this._enableItems(index);
            }
        },

        getItemsCount: function () {
            if (this.items) {
                return this.items.length;
            }
        },

        addItem: function (url, displayLabel, index, cssClass, id) {
            (index >= 0 && index < this.items.length) ? this._addItemIndex = index : this._addItemIndex = this.items.length;
            for (var disable_index = 0; disable_index < this.model.disabledItemIndex.length; disable_index++) {
                if (this.model.disabledItemIndex[disable_index] >= index)
                    this.model.disabledItemIndex[disable_index]++;
            }
            if (this.model.headerPosition == "left") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-left");
            }
            else if (this.model.headerPosition == "right") {
                this.items.length >= 0 && this.itemsContainer.addClass("e-right");
            }
            else
                this.items.length == 0 && this.itemsContainer.addClass("e-header");
            var liTag = ej.buildTag("li.e-select e-item");
            if ((this.model.headerPosition == "top"))
                if (this.model.enableRTL)
                    $(liTag).addClass("e-rtl-top-line e-top-hover");
                else
                    $(liTag).addClass("e-bottom-line");
            if (!ej.isNullOrUndefined(cssClass)) {
                var span = ej.buildTag('span').addClass(cssClass);
                liTag.append(span);
            }
            if (index === undefined && displayLabel === undefined && url != null)
                displayLabel = "Item";
            if (index === undefined && displayLabel === undefined && id === undefined) {
                url = "#Item" + this.items.length;
                displayLabel = "Item"
            }
            if (id != undefined) {
                if (id.indexOf("#") != 0)
                    id = "#" + id;
                this.divId = id;
            }
            else if (url != undefined)
                id = url;
            var aTag = ej.buildTag("a", displayLabel, {}, { href: url });
            aTag.addClass("e-link");
            if (this.model.headerPosition == "top" || this.model.headerPosition == "bottom")
                aTag.appendTo(liTag);
            if (this.model.showCloseButton) {
                var deleteIcon = ej.buildTag('div.e-icon e-close e-tabdelete', "", {}, {}).css("visibility", "hidden");
                liTag.append(deleteIcon);
                this._on(deleteIcon, "click", this._tabDeleteClick);
            }
            if (this.model.headerPosition == "left" || this.model.headerPosition == "right")
                aTag.appendTo(liTag);
            if (index === undefined) {
                index = this.anchors.length;
            }
            var insertIndex = index >= this.items.length;
            if (insertIndex) {
                liTag.appendTo(this.itemsContainer);
            } else {
                liTag.insertBefore(this.items[index]);
            }
            if (!ej.isNullOrUndefined(this.model.headerSize))
                this._setHeaderSize(this.model.headerSize);
            if (this.selectedItemIndex() == index) {
                this.hideItem[index];
                this.selectedItemIndex(this.selectedItemIndex() + 1);
            } else {
                this.hideItem[index];
                if (index < this.selectedItemIndex())
                    this.selectedItemIndex(this.selectedItemIndex() + 1);
            }
            this._itemsRefreshing();
            this._reinitialize(true);
            if (this.model.headerPosition == "top")
                $(this.contentPanels[index]).addClass("e-hidebottom");
            if (this.model.headerPosition == "bottom") {
                $(this.contentPanels[index]).addClass("e-hidetop");
                liTag.addClass("e-top-line e-item e-select e-margine-bottom")
            }
            if (this.model.headerPosition == "left")
                $(this.contentPanels[index]).addClass("e-hideleft");
            if (this.model.headerPosition == "right")
                $(this.contentPanels[index]).addClass("e-hideright");
            var data = {
                tabHeader: this.anchors[index],
                tabContent: this.contentPanels[index]
            };
            this.refreshTabScroll();
            this._addItemIndex = null;
            this._onAdd(data);
            if (this.model.showReloadIcon) {
                var reloadIcon = ej.buildTag('div.e-icon e-reload', "", {}, { role: "presentation" }).css("visibility", "hidden");
                $(this.element.find("li")[index]).append(reloadIcon)
            }
            if (this.model.enableTabScroll && this.model.headerPosition == "right") {
                $(this.contentPanels).css("height", this.model.height + "px");
            }

        },

        _isSizeExceeded: function () {
            var eleWidth = this.element.width(), itemsWidth = 0;
            var tabcount = this.items.length;
            for (var tabVal = 0; tabVal < tabcount; tabVal++) {
                var tabWidth = $(this.items[tabVal]).width();
                itemsWidth += tabWidth;
            }
            return (itemsWidth > eleWidth ? true : false);
        },

        refreshTabScroll: function () {
            if (this._isSizeExceeded()) {
                this.element.find("div.e-chevron-circle-right").length >= 1 && this.element.find("div.e-chevron-circle-right").remove();
                if (this.model.enableTabScroll) {
                    this._checkScroll();
                    this._addScrollIcon();
                }
            }
            else {
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right" && this._tabContentsHeight() > (this.element.width() || Number(this.model.height))) || (this.model.headerPosition == "top" || this.model.headerPosition == "bottom"))
                    this._checkScroll();
            }
        },

        removeItem: function (index) {
            if (!this.model.enabled) return false;
            if (index != null && index > -1 && index < this.items.length) {
                if (this._onBrforeRemove({ index: index }) === true)
                    return false;
                var removedTab = $(this.items[index]).remove();
                this.model.disabledItemIndex = [];
                if (removedTab.hasClass("e-active")) {
                    index == 0 ? this.selectedItemIndex(index + 1) : this.selectedItemIndex(index - 1);
                    this.showItem(this.selectedItemIndex());
                }
                $(this.element.find(">div.e-content")[index]).remove();
                this.contentPanels.splice(index, 1);
                index < this.selectedItemIndex() ? this.selectedItemIndex(this.selectedItemIndex() - 1) : this.selectedItemIndex();

                if (index < 0 || index >= this.anchors.length) {
                    this.selectedItemIndex(0);
                }
                if ((this.model.headerPosition == "left" || this.model.headerPosition == "right") && this.items.length == 1)
                    this._removeVerticalClass();
                else
                    this.items.length == 1 && this.itemsContainer.removeClass("e-header");
                this._unWireEvents();
                this._itemsRefreshing();
                this._wireEvents(this.model.events);
                if (this.model.enableTabScroll)
                    this._on(this.element.find("div.e-chevron-circle-right"), "click", this._tabScrollClick);
                for (var indx = 0; indx < this.items.length; indx++)
                    if ($(this.items[indx]).hasClass('e-disable'))
                        this.model.disabledItemIndex.push(indx);
                this._disableTabs();
                var data = {
                    removedTab: removedTab
                };
                this._onRemove(data);
            }
            if (this.getItemsCount() == 0) {
                this.itemsContainer.removeAttr("style")
                this.itemsContainer.find("div").remove()
            }
            if (this._tabContentsHeight() < Number(this.model.height) && this.itemsContainer.css("clip").split("px").length && this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                this._refresh();
                this.itemsContainer.removeAttr("style");
                this._leftScrollIcon ? this._leftScrollIcon.remove() : "";
                this._rightScrollIcon ? this._rightScrollIcon.remove() : "";
            }
            else if (this.model.enableTabScroll && (this.model.headerPosition == "left" || this.model.headerPosition == "right")) {
                if (this._leftScrollIcon && Number(this.itemsContainer.css("clip").split("px")[0].replace(",", "").split("(")[1]) != -(Number(this._leftScrollIcon.css("margin-top").split("px")[0]))) {
                    this._removeScroll();
                    this._addScroll();
                } else
                    this.refreshTabScroll();
                this.showItem(this.selectedItemIndex())
            }

        },

        show: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "visible");
        },

        hide: function () {
            if (!this.model.enabled) return false;
            this.element.css("visibility", "hidden");
        },

        _onBeforeLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxBeforeLoad", data);
        },

        _focusIn: function () {
            if (!this.model.readOnly && this.model.allowKeyboardNavigation)
                $(this.element).on("keydown", $.proxy(this._keyPress, this));
        },

        _focusOut: function (e) {
            $(this.element).off("keydown", $.proxy(this._keyPress, this));
        },

        _onLoad: function (link) {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, url: link, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), url: link, isInteraction: this._isInteraction };
            return this._trigger("ajaxLoad", data);
        },

        _onActive: function () {
            var data;
            if (this.selectedItemIndex() == -1 && this.model.collapsible)
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
            else
                data = { prevActiveHeader: this.items[this._preTabIndex], prevActiveIndex: this._preTabIndex, activeHeader: this.items[this.selectedItemIndex()], activeIndex: this.selectedItemIndex(), isInteraction: this._isInteraction };
            this._isInteraction = true;
            return this._trigger("itemActive", data);

        },

        _onBeforeActive: function (index) {
            if (this.model.beforeActive != null) {
                var data;
                if (this.selectedItemIndex() == -1 && this.model.collapsible)
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: null, activeIndex: null, isInteraction: this._isInteraction };
                else
                    data = { prevActiveHeader: this.items[this._preTabSelectedIndex], prevActiveIndex: this._preTabSelectedIndex, activeHeader: this.items[index], activeIndex: index, isInteraction: this._isInteraction };
                return this._trigger("beforeActive", data);
            }
        },

        _onAdd: function (data) {
            return this._trigger("itemAdd", data);
        },

        _onRemove: function (data) {
            return this._trigger("itemRemove", data);
        },

        _onBrforeRemove: function (data) {
            return this._trigger("beforeItemRemove", data);
        }
    });

    ej.Tab.HeightAdjustMode = {
        /**  Panel height adjusts based on the content */
        Content: "content",
        /**  All panel height will be set the tallest panel height. */
        Auto: "auto",
        /**  Content panel take based on the parent height. */
        Fill: "fill",
        /**  Content panel take based on the height property. */
        None: "none"
    };

    ej.Tab.Position = {
        /**  Tab headers display to top position. */
        Top: "top",
        /**  Tab headers display to bottom position. */
        Bottom: "bottom",
        /**  Tab headers display to left position. */
        Left: "left",
        /** Tab headers display to right position. */
        Right: "right"
    };

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html TextArea
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    var xhr = null;
    ej.widget("ejRTE", "ej.RTE", {

        element: null,

        model: null,
        _rootCSS: "e-rte",
        validTags: ["textarea"],
        _addOnPersist: ["value", "height", "width"],
        _setFirst: false,
        _requiresID: true,
        _operationHandler: null,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            allowEditing: true,

            isResponsive: false,

            allowKeyboardNavigation: true,

            enableTabKeyNavigation: true,

            cssClass: "",

            height: "370",

            width: "786",

            enabled: true,

            htmlAttributes: null,

            externalCSS: null,

            enableXHTML: false,

            importSettings: { url: "" },

            exportToPdfSettings: { url: "", fileName: "PdfExport" },

            exportToWordSettings: { url: "", fileName: "WordExport" },

            validationRules: null,

            validationMessage: null,
            maxLength: 7000,

            minWidth: "400",

            maxWidth: null,

            minHeight: "280",

            maxHeight: null,

            showToolbar: true,

            showFooter: false,

            showHtmlSource: false,

            showWordCount: true,
            showCharCount: true,

            showHtmlTagInfo: true,

            showClearAll: false,

            iframeAttributes: null,

            showClearFormat: true,
            showContextMenu: true,

            showFontOption: true,
            autoFocus: false,
            enableHtmlEncode: false,
            showDimensions: false,

            showRoundedCorner: false,

            locale: "en-US",

            name: "",
            pasteCleanupSettings: {
				listConversion: false, 
				cleanCSS: false,
				removeStyles: false,
				cleanElements: false
			},
			toolbarOverflowMode:"popup",

            tools: {

                formatStyle: ["format"],

                edit: [],

                style: ["bold", "italic", "underline", "strikethrough"],

                alignment: ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],

                lists: ["unorderedList", "orderedList"],

                indenting: ["outdent", "indent"],

                doAction: ["undo", "redo"],

                links: ["createLink", "removeLink"],

                images: ["image"],
                media: ["video"],

                tables: ["createTable", "addRowAbove", "addRowBelow", "addColumnLeft", "addColumnRight", "deleteRow", "deleteColumn", "deleteTable"],
                view: ["fullScreen"],
                customTools: [],
                print: [],
                customOrderList: [],
                customUnOrderList: [],
                font: [],
                clipboard: [],
                clear: [],
                effects: [],
                casing: [],
                importExport: [],
            },

            tooltipSettings: {
                associate: "mouseenter",
                showShadow: true,
                position: {
                    stem: { horizontal: "left", vertical: "top" }
                },
                tip: {
                    size: { width: 5, height: 5 }
                },
                isBalloon: false
            },
            toolsList: ["formatStyle", "font", "style", "effects", "alignment", "lists", "indenting", "clipboard", "doAction", "clear", "links", "images", "media", "tables", "casing", "customTools", "view", "print", "edit", "importExport"],

            colorCode: [
			            "000000", "FFFFFF", "C4C4C4", "ADADAD", "595959", "262626", "4f81bd", "dbe5f1", "b8cce4", "95b3d7", "366092", "244061", "c0504d", "f2dcdb", "e5b9b7", "d99694", "953734",
			            "632423", "9bbb59", "ebf1dd", "d7e3bc", "c3d69b", "76923c", "4f6128", "8064a2", "e5e0ec", "ccc1d9", "b2a2c7", "5f497a", "3f3151", "f79646", "fdeada", "fbd5b5", "fac08f",
			            "e36c09", "974806"
            ],

            format: [
                { text: "Paragraph", value: "<p>", spriteCssClass: "e-paragraph" },
                { text: "Quotation", value: "<blockquote>", spriteCssClass: "e-quotation" },
                { text: "Heading 1", value: "<h1>", spriteCssClass: "e-h1" },
                { text: "Heading 2", value: "<h2>", spriteCssClass: "e-h2" },
                { text: "Heading 3", value: "<h3>", spriteCssClass: "e-h3" },
                { text: "Heading 4", value: "<h4>", spriteCssClass: "e-h4" },
                { text: "Heading 5", value: "<h5>", spriteCssClass: "e-h5" },
                { text: "Heading 6", value: "<h6>", spriteCssClass: "e-h6" }
            ],

            fontName: [
                       {
                           text: "Segoe UI",
                           value: "Segoe UI"
                       },
                       {
                           text: "Arial",
                           value: "Arial,Helvetica,sans-serif"
                       },
                       {
                           text: "Courier New",
                           value: "Courier New,Courier,monospace"
                       },
                       {
                           text: "Georgia",
                           value: "Georgia,serif"
                       },
                       {
                           text: "Impact",
                           value: "Impact,Charcoal,sans-serif"
                       },
                       {
                           text: "Lucida Console",
                           value: "Lucida Console,Monaco,monospace"
                       },
                       {
                           text: "Tahoma",
                           value: "Tahoma,Geneva,sans-serif"
                       },
                       {
                           text: "Times New Roman",
                           value: "Times New Roman,Times,serif"
                       },
                       {
                           text: "Trebuchet MS",
                           value: "Trebuchet MS,Helvetica,sans-serif"
                       },
                       {
                           text: "Verdana",
                           value: "Verdana,Geneva,sans-serif"
                       }
            ],

            fontSize: [
                {
                    text: "1 (8pt)",
                    value: "8pt"
                },
                {
                    text: "2 (10pt)",
                    value: "10pt"
                },
                {
                    text: "3 (12pt)",
                    value: "12pt"
                },
                {
                    text: "4 (14pt)",
                    value: "14pt"
                },
                {
                    text: "5 (18pt)",
                    value: "18pt"
                },
                {
                    text: "6 (24pt)",
                    value: "24pt"
                },
                {
                    text: "7 (36pt)",
                    value: "36pt"
                }
            ],

            tableRows: 8,

            tableColumns: 10,

            colorPaletteRows: 6,

            colorPaletteColumns: 6,

            showCustomTable: true,

            value: null,

            undoStackLimit: 50,

            enableResize: true,

            enablePersistence: false,

            enableRTL: false,

            autoHeight: false,

            zoomStep: '0.05',

            imageBrowser: {

                filePath: "",

                extensionAllow: "*.png,*.gif,*.jpg,*.jpeg",

                ajaxAction: "",

                ajaxSettings: ""
            },

            fileBrowser: {

                filePath: "",

                extensionAllow: "*.doc,*.docx,*.pdf,*.txt",

                ajaxAction: ""
            },


            change: null,

            execute: null,

            keydown: null,

            keyup: null,

            create: null,

            destroy: null,
            contextMenuClick: null,
            preRender: null,
            select: null
        },

        dataTypes: {
            enabled: "boolean",
            autoFocus: "boolean",
            enableHtmlEncode: "boolean",
            autoHeight: "boolean",
            enableXHTML: "boolean",
            isResponsive: "boolean",
            enablePersistence: "boolean",
            showRoundedCorner: "boolean",
            showCustomTable: "boolean",
            enableResize: "boolean",
            importSettings: { url: "string" },
            exportToPdfSettings: { url: "string", fileName: "string" },
            exportToWordSettings: { url: "string", fileName: "string" },
            pasteCleanupSettings: {
				listConversion: "boolean", 
				cleanCSS: "boolean",
				removeStyles: "boolean",
				cleanElements: "boolean"
			},
            showDimensions: "boolean",
            showFontOption: "boolean",
            showClearFormat: "boolean",
            showClearAll: "boolean",
            showHtmlTagInfo: "boolean",
            showWordCount: "boolean",
            showCharCount: "boolean",
            showHtmlSource: "boolean",
            allowKeyboardNavigation: "boolean",
            enableTabKeyNavigation: "boolean",
            allowEditing: "boolean",
            showToolbar: "boolean",
            showFooter: "boolean",
            showContextMenu: "boolean",
            enableRTL: "boolean",
            toolsList: "array",
            colorCode: "array",
			toolbarOverflowMode:"enum",
            format: "data",
            fontName: "data",
            fontSize: "data",
            htmlAttributes: "data",
            iframeAttributes: "data",
            tools: {
                formatStyle: "array",
                font: "array",
                edit: "array",
                style: "array",
                effects: "array",
                alignment: "array",
                lists: "array",
                indenting: "array",
                clipboard: "array",
                doAction: "array",
                clear: "array",
                links: "array",
                media: "array",
                images: "array",
                tables: "array",
                casing: "array",
                customTools: "array",
                view: "array",
                print: "array",
                importExport: "array",
                customOrderList: "array",
                customUnOrderList: "array"
            }
        },

        _rteIconsList: {
            "format": "format",
            "bold": "e-bold_01",
            "italic": "e-italic_01",
            "underline": "e-underline_01",
            "strikethrough": "e-strikethrough_01",
            "justifyLeft": "e-align-left_01",
            "justifyCenter": "e-align-center_01",
            "justifyRight": "e-align-right_01",
            "justifyFull": "e-align-justify_01",
            "unorderedList": "e-bullets_01",
            "orderedList": "orderedList",
            "outdent": "outdent",
            "indent": "indent",
            "undo": "undo",
            "redo": "redo",
            "createLink": "e-link_01",
            "removeLink": "e-unlink_01",
            "image": "e-image",
            "video": "e-video",
            "createTable": "e-table_02",
            "addRowAbove": "e-insert-row-above_02",
            "addRowBelow": "e-insert-row-below_02",
            "addColumnLeft": "e-insert-column-left_02",
            "addColumnRight": "e-insert-column-right_02",
            "deleteRow": "e-delete-row_01",
            "deleteColumn": "e-delete-column_01",
            "deleteTable": "deleteTable",
            "fullScreen": "fullScreen",
            "superscript": "e-superscript_01",
            "subscript": "e-subscript_01",
            "upperCase": "e-uppercase_01",
            "lowerCase": "e-lowercase_01",
            "zoomIn": "e-zoom-in",
            "zoomOut": "e-zoom-out",
            "print": "print",
            "import": "e-upload",
            "wordExport": "e-icon e-word-export",
            "pdfExport": "e-icon e-pdf-export",
            "findAndReplace": "findAndReplace",
            "cut": "e-cut_01",
            "copy": "e-copy_02",
            "paste": "e-paste_01",
            "clearFormat": "clearFormat",
            "clearAll": "e-delete_05",
            "fontName": "fontName",
            "fontSize": "fontSize",
            "fontColor": "e-font",
            "backgroundColor": "e-background-color",
            "rteResize": "e-resize-handle",
            "rteSource": "e-file-code",
            "customTableImage": "e-table",
            "resize": "e-full-screen-collapse_01",
            "maximize": "e-full-screen-expand_01",
            //Added empty strings for context menu
            "openLink": "",
            "deleteTables": "",
            "insertTable": "",
            "tableProperties": "",
            "imageProperties": ""
        },

        observables: ["value"],
        value: ej.util.valueFunction("value"),

        _setModel: function (options) {
            this._isInteraction = false;
            var option;
            for (option in options) {
                switch (option) {
                    case "allowEditing": this._enableEdit(options[option]); break;
                    case "autoFocus ": { this.model.autoFocus = options[option]; if (options[option]) this._focus(); break; }
                    case "showToolbar": {
                        options[option] ? (ej.isNullOrUndefined(this._rteToolbar) ? this._renderToolBar() : (this._rteToolbar.show() , (this.model.isResponsive && this._toolBarObj._reSizeHandler()))): this._rteToolbar.hide();
                        break;
                    }
                    case "showFooter": {
                        this.model.showFooter = options[option];
                        options[option] ? ej.isNullOrUndefined(this._rteFooter) ? this._renderFooter() : this._rteFooter.show() : this._rteFooter.hide();
                        break;
                    }
                    case "pasteCleanupSettings":
                        this.model.pasteCleanupSettings = options[option];
                        if (ej.clipboardCleaner) {
                            if (!this._pasteCleaner)
                                this._enableContentCleaner();
                            this._pasteCleaner && (this._pasteCleaner.filterOptions = options[option]);
                        }						
                    case "isResponsive": {
                        this.model.isResponsive = options[option];
                        this._renderToolBarList();
                        var iframeHeight = $(this._rteIframe).outerHeight();
                        var toolListHeight = $(this._rteToolbar).outerHeight();
                        $(this._rteWapper).height(iframeHeight + toolListHeight);
                        if (!ej.isNullOrUndefined($(this._rteFooter))) {
                            var footerHeight = $(this._rteFooter).outerHeight();
                            $(this._rteWapper).height(iframeHeight + footerHeight + toolListHeight);
                        }
                        break;
                    }
                    case "enabled": this._disabled(options[option]); break;
                    case "height": { this.model.height = options[option]; this._rteWapper.height(options[option]); } break;
                    case "width": { this.model.height = options[option]; this._rteWapper.css("width", options[option]); } break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showHtmlSource": this._footerElement("div.e-rte-source", options[option]); break;
                    case "showHtmlTagInfo": this._footerElement("div.e-rte-htmltaginfo", options[option]); break;
                    case "showWordCount": {
                        this.model.showWordCount = options[option];
                        this._createCountElement(options[option], this._wordCount);
                        break;
                    }
                    case "showCharCount": {
                        this.model.showCharCount = options[option];
                        this._createCountElement(options[option], this._charCount);
                        break;
                    }
                    case "tooltipSettings": {
                        this.model.tooltipSettings = $.extend(true, this.model.tooltipSettings, options[option]);
                        if (this.model.showToolbar)
                            this._toolBarItems.ejToolbar("option", "tooltipSettings", options[option]);
                        this._renderTooltip(this.model.tooltipSettings);
                        break;
                    }
                    case "showClearAll": this._footerElement("div.clearAll", options[option]); break;
                    case "showClearFormat": this._footerElement("div.clearFormat", options[option]); break;
                    case "enableResize": this._footerElement("div.e-rte-resize", options[option]); break;
                    case "fontName": this._fontStyleDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "fontSize": this._fontSizeDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "format": this._formatDDL.ejDropDownList({ dataSource: options[option] }); break;
                    case "value":
                        if (ej.isPlainObject(options[option])) options[option] = null;
                        var optionValue = ej.util.getVal(options[option]);
                        if (optionValue != this._getDocument().body.innerHTML){
                            this._getDocument().body.innerHTML=optionValue;
                            var args = { text: this._getText(), htmlText: this.getHtml() };
                            this._onChange();
                        } 
                        break;
                    case "showDimensions":
                        this._renderImageDialog();
                        if (options[option]) {
                            this._imgDialog.find("div.e-rte-imgdimensions").show();
                            this._imgDialog.find("div.e-rte-videoDimensions").show();
                        }
                        else {
                            this._imgDialog.find("div.e-rte-imgdimensions").hide();
                            this._imgDialog.find("div.e-rte-videoDimensions").hide();
                        }
                        break;
                    case "showFontOption":
                        if (options[option])
                            this._rteWapper.find("ul.e-rte-fontgroup").show();
                        else
                            this._rteWapper.find("ul.e-rte-fontgroup").hide();
                        break;
                    case "locale":
                        this.model.locale = options[option];
                        var model = this.model;
                        this.element.ejRTE("destroy").ejRTE(model);
                        break;
                    case "importSettings": {
                        this.model.importSettings = $.extend(true, this.model.importSettings, options[option]);
                        break;
                    }
                    case "exportToPdfSettings": {
                        this.model.exportToPdfSettings = $.extend(true, this.model.exportToPdfSettings, options[option]);
                        break;
                    }
                    case "exportToWordSettings": {
                        this.model.exportToWordSettings = $.extend(true, this.model.exportToWordSettings, options[option]);
                        break;
                    }
                    case "tableRows": {
                        this.model.tableRows = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "iframeAttributes": {
                        this._updateIframeSkin(options[option]);
                        break;
                    }
                    case "tableColumns": {
                        this.model.tableColumns = options[option];
                        var tblDiv = this._createTable.find("div.e-rte-table").html("");
                        this._drawTable(tblDiv);
                        break;
                    }
                    case "showCustomTable": {
                        this._createCustomTable();
                        var custLink = this._createTable.find("div.customtable-group");
                        options[option] ? ej.isNullOrUndefined(this._customTableDialog) ? this._createCustomTable() : custLink.show() : custLink.hide();
                        break;
                    }
                    case "colorPaletteRows": {
                        this.model.colorPaletteRows = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorPaletteColumns": {
                        this.model.colorPaletteColumns = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "colorCode": {
                        this.model.colorCode = options[option];
                        this._updateColorPalette();
                        break;
                    }
                    case "name": {
                        this.model.name = options[option];
                        this._checkNameAttr();
                        break;
                    }
                    case "showContextMenu":
                        this.model.showContextMenu = options[option];
                        this._showHideContextMenu();
                        break;
                    case "enableRTL": this._enableRTL(options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "validationRules":
                        if (this.element.closest("form").length != 0) {
                            if (this.model.validationRules != null) {
                                this.element.rules('remove');
                                this.model.validationMessage = null;
                            }
                            this.model.validationRules = options[option];
                            if (this.model.validationRules != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "validationMessage":
                        if (this.element.closest("form").length != 0) {
                            this.model.validationMessage = options[option];
                            if (this.model.validationRules != null && this.model.validationMessage != null) {
                                this._initValidator();
                                this._setValidation();
                            }
                        }
                        break;
                    case "autoHeight": this.model.autoHeight = options[option];
                        this._setAutoHeight();
                }
                if (option != "locale")
                    this._setIframeHeight();
            }
            this._updateCount();
        },
		_updateLocalConstant:function(){
			this._localizedLabels = ej.getLocalizedConstants("ej.RTE", this.model.locale);
		},
		_enableContentCleaner:function(){
			if(ej.clipboardCleaner && !this._isIE8()){
				!this._pasteCleaner && (this._pasteCleaner=new ej.clipboardCleaner(this._getDocument(),this._iframePaste,this));
				this._pasteCleaner.filterOptions = this.model.pasteCleanupSettings;
			}
		},
        _init: function () {
            if (!ej.isNullOrUndefined(this.element) && this.element[0].type == "textarea") {
				this._updateLocalConstant();
                this.element.hide();
                this._initialize()
                    ._render();
                this.model.allowEditing && this._wireEvents();
                this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion) && this._enableContentCleaner();
                if(this.model.iframeAttributes != null) this._updateIframeSkin(this.model.iframeAttributes);
                if (this.model.enabled == false) this._disabled(this.model.enabled);
                if(this.model.htmlAttributes != null) this._addAttr(this.model.htmlAttributes);
                if (this.model.autoFocus) {
                    this._focus();
                    this._updateToolbarStatus();
                    this._updateFontOptionStatus();
                    this._updateFormat();
                }
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._decode(this.value())));
                if (this.model.showToolbar) {
                    this.disableToolbarItem("removeLink");
                    if (!ej.isNullOrUndefined(this._getWindow()))
                        this._updateIndentStatus();
                }
                if (this.model.enableRTL)
                    this._enableRTL(true);
                this.model.externalCSS && this._addCssToIframe(this.model.externalCSS);
                this.wrapper = this._rteWapper;
                if (this.model.validationRules != null) {
                    this._initValidator();
                    this._setValidation();
                }
                if (this.model.showContextMenu) {
                    this._showHideContextMenu();
                }
                this._isInteraction = true;
            }
        },
        _hideContextMenuByItem: function (data) {
            for (var index1 = 0; index1 < $(this._textMenuObj.element).children("li").length; index1++)
                ($.inArray($(this._textMenuObj.element.children("li")[index1]).attr("id"), data) != -1) ? $(this._textMenuObj.element.children("li")[index1]).show() : $(this._textMenuObj.element.children("li")[index1]).hide();
        },
        _filterMenuItems: function (e) {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode(), node = this._saveSelection().commonAncestorContainer;
            if (!ej.isNullOrUndefined(selectNode) && !ej.isNullOrUndefined(selectNode.tagName) && (selectNode.tagName.toLowerCase() === "img" || e.target.tagName.toLowerCase() == "img")) {
                this._hideContextMenuByItem(this._contextType.image);
                this._updateContextMenuItemState(true);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("table").length) {
                this._hideContextMenuByItem($(selectNode).closest("a").length ? this._contextType.table_hyper : this._contextType.table);
                this._contextValidation(node, e);
            }
            else if (!ej.isNullOrUndefined(selectNode) && $(selectNode).closest("a").length) {
                this._hideContextMenuByItem(this._contextType.hyperlink);
                this._contextValidation(node, e);
            }
            else if (this._isIE8()) {
                this._hideContextMenuByItem(this._contextType.text);
                this._updateContextMenuItemState(this._getRange().text !== "");
            }
            else {
                this._hideContextMenuByItem(this._contextType.text);
                this._contextValidation(node, e);
            }
            this._rteIframe.contents().find("body").addClass("e-cursor");
        },
        _contextmenuPosition: function (e) {
            var posX = (( e.clientX == undefined ) ? 0 : e.clientX ) + this._rteWapper.offset().left , posY = (( e.clientY == undefined ) ? 0 : e.clientY ) + this._rteWapper.offset().top + (this._rteToolbar ? this._rteToolbar.outerHeight() : 0) , menuHeight = this._textMenuObj.element.attr("style", "visibility: visible;display:block;").height() ,  menuWidth = this._textMenuObj.element.width();
            posY = ((posY + menuHeight) < ($(document).scrollTop() + $(window).height())) ? posY : ((posY - menuHeight) < 0 ? posY : (posY - menuHeight));
            posX = ((posX + menuWidth) < ($(document).scrollLeft() + $(window).width())) ? posX : (posX - menuWidth);
            this._textMenuObj.element.attr("style", ("width:auto;left:" + posX + "px;top:" + posY + "px;z-index:" + (this._onGetMaxZindex() + 1))).focus();
        },
        _contextValidation: function (node, e) {
            var data;
            this._updateContextMenuItemState(node && (data = node.nodeValue ? node.nodeValue : node.textContent) && ((this._saveSelection().endContainer == this._saveSelection().startContainer) ? (data.substring(this._saveSelection().startOffset, this._saveSelection().endOffset) !== "") : true));
        },
        _updateContextMenuItemState: function (stauts) {
            stauts ? (this._textMenuObj.enableItemByID("cut"), this._textMenuObj.enableItemByID('copy')) : (this._textMenuObj.disableItemByID("cut"), this._textMenuObj.disableItemByID('copy'));
        },
        _contextMenuClick: function (e) {
            var spellObj = this._rteIframe.data("ejSpellCheck");
            var action = e.ID ? e.ID.toLowerCase() : $(e.element).attr("id").toLowerCase(), _node;
            this._isIE() && this._ieSelectionRange && this.selectRange(this._ieSelectionRange);
            switch (action) {
                case "cut":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("cutAlert")) : this._getDocument().execCommand(action, false, undefined);
                    if (this._imgOrg && this._imgDupDiv && this._imgBoxMouseMove) {
                        $(this._imgOrg).css("outline", "");
                        $(this._imgDupDiv).remove();
                        this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
                    }
                    this._updateCursor();
                    break;
                case "copy":
                    (!this._isIE() && this._getValidbrowser(ej.browserInfo().name)) ? this._openAlert(this._getLocalizedLabels("copyAlert")) : this._getDocument().execCommand(action, false, undefined);
                    this.selectRange(this._getRange());
                    break;
                case "paste":
                    (!this._isIE()) ? this._openAlert(this._getLocalizedLabels("pasteAlert")) : this._getDocument().execCommand(action, false, undefined);
                    break;
                case "openlink":
                    this._onOpen();
                    break;
                case "createlink":
                    this._renderLinkDialog();
                    (!this._linkDialog) && this._renderLinkDialog();
                    this._hyperLinkManager(false);
                    break;
                case "imageproperties":
                    this._renderImageDialog();
                    (!this._imgDialog) && this._renderImageDialog();
                    this._imageManager();
                    break;
                case "addcolumnleft":
                    _node = this.insertColumn(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addcolumnright":
                    _node = this.insertColumn(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowabove":
                    _node = this.insertRow(true, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "addrowbelow":
                    _node = this.insertRow(false, this._currentSelNode);
                    this._updateCursor(_node);
                    break;
                case "deleterow":
                    this.removeRow(this._currentSelNode);
                    break;
                case "deletecolumn":
                    this.removeColumn(this._currentSelNode);
                    break;
                case "deletetable":
                    this.removeTable($(this._currentSelNode).closest('table'));
                    break;
                case "tableproperties":
                    this._renderEditTableDialog();
                    (!this._eTblDialog) && this._renderEditTableDialog()
                    this._eTblManager();
                    this._eTblDialog.ejDialog("open");
                    break;
                case "removelink":
                    this._onUnlink();
                    break;
                case "add to dictionary":
                    var addWord = (this._currentSelNode.innerText).trim();
                    spellObj._currentElement = $("#"+ spellObj._id);
                    spellObj.addToDictionary(addWord);
                    this._ieCursorMaintainance();
                    break;
                case "ignoreall":
                    var errorWord = (this._currentSelNode.innerText).trim();
                    var result = spellObj.ignoreAll(errorWord, this.getHtml()); 
                    this.setHtml(result.resultHTML);
                    this._ieCursorMaintainance();
                    break;
                default:
                    if(!ej.isNullOrUndefined(spellObj)){
                    var replaceItem = document.createTextNode(e.text);
                    this._currentSelNode.parentNode.insertBefore(replaceItem, this._currentSelNode);
                    $(this._currentSelNode).remove();
                    }
            }
            this._trigger("contextMenuClick", { event: e });
            this._onChange();
        },
        _updateCursor: function (node, rangeData) {
            if (!this._isIE8()) {
                var _range = this._getDocument().createRange(), _currentRange = this._getRange();
                if (node)
                    this._setRange(node, _currentRange, true);
                else if (rangeData) {
                    _range.setStart(rangeData.startContainer, rangeData.startOffset);
                    _range.setEnd(rangeData.endContainer, rangeData.endOffset);
                    this.selectRange(_range);
                }
                else {
                    _range.setStart(_currentRange.startContainer, _currentRange.startOffset);
                    _range.setEnd(_currentRange.startContainer, _currentRange.startOffset);
                    this.selectRange(_range);
                }
            }
        },
        _loadRules: function () {
            var rteObj= this.element.data('ejRTE');
            jQuery.validator.addMethod("contentRequired", function (value, element) {
                return $.trim(rteObj._getText());
            }, "Please specify the value.");
            jQuery.validator.addMethod("maxWordCount", function (value, element, params) {
                return $.trim(rteObj._getText()).split(/\W+/).length <= params;
            }, "Please enter the content with in max word count.");
            jQuery.validator.addMethod("minWordCount", function (value, element, params) {
                return $.trim(rteObj._getText()).split(/\W+/).length >= params;
            }, "Please enter the content with min word count.");
            jQuery.validator.addMethod("minCharCount", function (value, element, params) {
                return rteObj._getText().length >= params;
            }, "Please enter the content with min length.");
            jQuery.validator.addMethod("maxCharCount", function (value, element, params) {
                return rteObj._getText().length <= params;
            }, "Please enter the content with in  max length.");
            this._customRules = { "required": "contentRequired", "maxWordCount": "maxWordCount", "minWordCount": "minWordCount", "maxlength": "maxCharCount", "minlength": "minCharCount", "equalTo": "equalTo" };
        },
        _initValidator: function () {
            this._loadRules();
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _getRuleData: function (rule, data) {
            var ruleData = null;
            switch (rule) {
                case "contentRequired":
                    ruleData = { 'contentRequired': data };
                    break;
                case "minCharCount":
                    ruleData = { 'minCharCount': data };
                    break;
                case "maxCharCount":
                    ruleData = { 'maxCharCount': data };
                    break;
                case "maxWordCount":
                    ruleData = { 'maxWordCount': data };
                    break;
                case "minWordCount":
                    ruleData = { 'minWordCount': data };
                    break;
                case "equalTo":
                    ruleData = { 'equalTo': data };
                    break;
            }
            return ruleData;
        },
        _setValidation: function () {
            if (this.element.closest("form").length != 0) {
                var validator = this.element.closest("form").validate(), rule, ruleVal, name = this.element.attr("name");
                validator.settings.messages[name] = {};
                for (var ruleName in this.model.validationRules) {
                    var message = null;
                    if (!ej.isNullOrUndefined(this.model.validationRules[ruleName]) && this._customRules[ruleName]) {
                        rule = this._customRules[ruleName], ruleVal = this.model.validationRules[ruleName];
                        this.element.rules("add", this._getRuleData(rule, ruleVal));
                        if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][rule]))
                            message = this.model.validationRules["messages"][rule];
                        else {
                            validator.settings.messages[name][rule] = $.validator.messages[rule];
                            for (var msgName in this.model.validationMessage)
                                ruleName == msgName ? (message = this.model.validationMessage[ruleName]) : "";
                        }
                        validator.settings.messages[name][rule] = message != null ? message : $.validator.messages[rule];
                    }
                }
            }
        },
        _addAttr: function (htmlAttr) {
            if (htmlAttr != null) {
                var proxy = this;
                $.map(htmlAttr, function (value, key) {
                    if (key == "class") proxy._rteWapper.addClass(value);
                    else if (key == "name") proxy.element.attr(key, value);
                    else if (key == "required") proxy.element.attr(key, value);
                    else if (key == "disabled" && value == "disabled") proxy.disable();
                    else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                    else proxy._rteWapper.attr(key, value);
                });
            }
        },
        _addCssToIframe: function (value) {
            var substr = $.isArray(value) ? value : value.split(',');
            for (var i = 0; i < substr.length; i++) {
                var linkTag = document.createElement("link");
                linkTag.href = substr[i];
                linkTag.rel = "stylesheet";
                linkTag.type = "text/css";
                this._rteIframe.contents().find("head").append(linkTag);
            }
        },
        _disabled: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _destroy: function () {
            this.element.insertBefore(this._rteWapper);
            !ej.isNullOrUndefined(this._tooltip) && $(this._rteFooter).ejTooltip("destroy");
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("destroy");
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._unOrderSplit) && this._unOrderSplit.ejSplitButton("destroy");
            !ej.isNullOrUndefined(this._orderSplit) && this._orderSplit.ejSplitButton("destroy");
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-ddlAlignment")) && this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("destroy");
                !ej.isNullOrUndefined(this._customTableDialog.find(".e-rte-txtBorder")) && this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("destroy");
            }
            !ej.isNullOrUndefined(this._linkDialog) && $(this._linkDialog).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("destroy");
                $(this._imgDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._videoDialog) && $(this._videoDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._createTable) && $(this._createTable).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._sourceDialog) && $(this._sourceDialog).closest("div.e-dialog-wrap").remove();
		    !ej.isNullOrUndefined(this._customColor )&& $(this._customColor ).closest("div.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
			!ej.isNullOrUndefined(this._customTableDialog) && $(this._customTableDialog).closest("div.e-rte.e-dialog-wrap").remove();
            !ej.isNullOrUndefined(this._alertWindow) && $(this._alertWindow).closest("div.e-rte.e-dialog-wrap").remove();
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("destroy");
                $(this._eTblDialog).closest("div.e-rte.e-dialog-wrap").remove();
            }
            !ej.isNullOrUndefined(this._explorerObj) && this._explorerObj.destroy();
            !ej.isNullOrUndefined(this._imgPicker) && this._imgPicker.destroy();
			!ej.isNullOrUndefined(this._tblborderPicker) && this._tblborderPicker.destroy();
            !ej.isNullOrUndefined(this._fileDialog) && $(this._fileDialog).closest("div.e-rte.e-dialog-wrap").remove();
			this._textMenuObj && this._textMenuObj.destroy();
            this._toolBarObj && this._toolBarObj.destroy();
            this._rteWapper.remove();
			if($("#"+this._rteId+"customcolor_popup").length>0)
			$("#"+this._rteId+"customcolor_popup").remove();
			if($("#"+this._rteId+"customcolor_Presets").length>0)
			$("#"+this._rteId+"customcolor_Presets").remove();
            this.element.show();
            this.element.focus();
            this._createTable = null;
            this._unwireEvents();
        },

        _initialize: function () {
            this._toolsList = this.model.toolsList;
            this._rteId = this.element[0].id;
            this._rteId = this._rteId ? this._rteId : "";
            this._backupArray = new Array();
            this._undoRedoPosition = 0;
            this._fontColor = "#000000";
            this._bgColor = "#ffffff";
            this._imgWidth = 0;
            this._imgHeight = 0;
            this._videoWidth = 0;
            this._videoHeight = 0;
            this._keypressFlag = true;
            this._styleItems = ej.isNullOrUndefined(this.model.tools["style"]) ? [] : this.model.tools["style"];
            this._alignItems = ej.isNullOrUndefined(this.model.tools["alignment"]) ? [] : this.model.tools["alignment"];
            this._listItems = ej.isNullOrUndefined(this.model.tools["lists"]) ? [] : this.model.tools["lists"];
            this._scriptsItems = ej.isNullOrUndefined(this.model.tools["effects"]) ? [] : this.model.tools["effects"];
            this._contextMenu = ["cut", "copy", "paste", "|", "insertTable", ["addColumnLeft", "addColumnRight", "addRowAbove", "addRowBelow"], "|", "deleteTables", ["deleteRow", "deleteColumn", "deleteTable"], "|", "tableProperties", "|", "createLink", "openLink", "removeLink", "imageProperties"];
            this._contextType = { text: ["cut", "copy", "paste", "createLink"], image: ["cut", "copy", "paste", "imageProperties"], hyperlink: ["cut", "copy", "paste", "createLink", "openLink", "removeLink"], table: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink"], table_hyper: ["cut", "copy", "paste", "insertTable", "deleteTables", "tableProperties", "createLink", "openLink", "removeLink"] };
            return this;
        },

        _render: function () {
            this._renderWrapper()
            ._checkNameAttr();
            if (this.model.showToolbar) {
                this._renderToolBar();
            }
            this._trigger("preRender", this.element);
            this._renderEditArea();
            this.model.showFooter && this._renderFooter();
            this._setIframeHeight();
            this._rteWidth = this.model.width;
            this._rteHeight = this.model.height;
            this._renderAlertDialog();
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _initContextMenu: function () {
            var menuOptions = [], subMenuOptions = [];
            for (var i = 0; i < this._contextMenu.length; i++) {
                if (this._contextMenu[i] != "|") {
                    if (typeof this._contextMenu[i] === "object") {
                        var temp = i + 1;
                        for (var j = 0; j < this._contextMenu[i].length; j++) {
                            if (this._contextMenu[i][j] != "|") {
                                menuOptions.push({ id: this._contextMenu[i][j], parentId: this._contextMenu[i - 1], text: this._getLocalizedLabels(this._contextMenu[i][j]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i][j] + " " + this._rteIconsList[this._contextMenu[i][j]], htmlAttr: (this._contextMenu[i + 1][j + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i][j] } : { "id": this._contextMenu[i][j] }) });
                            }
                        }
                    } else {
                        menuOptions.push({ id: this._contextMenu[i], parentId: null, text: this._getLocalizedLabels(this._contextMenu[i]), sprite: "e-rte-toolbar-icon " + this._contextMenu[i] + " " + this._rteIconsList[this._contextMenu[i]], htmlAttr: (this._contextMenu[i + 1] == "|" ? { "class": "e-rte-separator", "id": this._contextMenu[i] } : { "id": this._contextMenu[i] }) });
                    }
                }
            }
            return menuOptions;
        },
        _createContextMenu: function () {
            var ContextMenutag = ej.buildTag('ul.e-rte-context-menu #' + this._id + "_contextmenu");
            var proxy = this;
            ContextMenutag.ejMenu({
                menuType: ej.MenuType.ContextMenu,
                enableSeparator: true,
                width: "auto",
                enableRTL: this.model.enableRTL,
                cssClass: this.model.cssClass,
                contextMenuTarget: this._getDocument(),
                click: $.proxy(this._contextMenuClick, this),
                fields: { dataSource: this._initContextMenu(), id: "id", parentId: "parentId", text: "text", htmlAttribute: "htmlAttr", spriteCssClass: "sprite" },
                beforeOpen: function (args) { 
                this._spellObj = proxy._rteIframe.data("ejSpellCheck");
                      if($(args.target).hasClass("errorspan") && !ej.isNullOrUndefined(this._spellObj)){  
                    this._spellObj._selectedTarget=args.target;
                    this._spellObj._selectedValue=args.target.innerText;
                    var filterValue = this._spellObj._filterSuggestions(this._spellObj, this._spellObj._selectedValue);
                    if (filterValue.length > 0) { 
                        this._spellObj._suggestedWords = filterValue[0].SuggestedWords;
                        } else {
                        this._spellObj.getSuggestionWords(args.target.innerText); 
                        }   
                        proxy._spellcheckContextMenu(args, this._spellObj);          
                    }
                    else{
                        var customMenus = $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions"); 
                        if (customMenus.length > 0 )
                            $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parent().parent().remove();
                      }
                    (proxy._isIE() && proxy._ieSelectionRange) && proxy.selectRange(proxy._ieSelectionRange);
                    proxy.model.enabled ? this.enable() : this.disable();
                    proxy._filterMenuItems(proxy._contextMenuEventArgs = args.events);
                    $(this.element).parent().hide();
                    $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parents("li").css('display', 'block');
                },
                open: function () {
                    this.element.attr("style", ("visibility:visible;width:auto;display:block;left:0px;top:0px;"));
                    this.element.parent().show();
                    proxy._contextmenuPosition(proxy._contextMenuEventArgs);
                    this._showAnimation(this.element, this._showAnim);
                    $(this.element).focus();
                },
                close: function () {
                    $(proxy._getDocument()).find("body").removeClass("e-cursor");
                }
            });
            return ContextMenutag;
        },
         _spellcheckContextMenu: function(args, spellcheck){
            var proxy= this;   
            var target = args.events.target;  
            var customMenus = $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions"); 
            if (customMenus.length > 0 )
                $("#" + proxy._textMenuObj._id).find("span.e-spellsuggestions").parent().parent().remove();
            var suggestionList= [this._getLocalizedLabels("addtodictionary"), this._getLocalizedLabels("ignoreall")].concat(spellcheck._suggestedWords);   
                for (var k = 0; k < suggestionList.length; k++) {
                    proxy.insertMenuOption({
                    newItem: suggestionList[k],
                    targetItem: this._getLocalizedLabels("paste"),
                    insertType: ("insertAfter"),
                    menuType: { text: true, image: false, hyperlink: true, table: false },
                    spriteCssClass: "e-spellsuggestions"  
                });   
            } 
        },
        _showHideContextMenu: function () {
            if (this.model.allowEditing && this.model.enabled && this.model.showContextMenu && this._getDocument()) {
                this._textMenuObj = this._createContextMenu().data("ejMenu");
                //below codes unbinds the contextMenu taphold event.
                this._textMenuObj["_off"]($(this._textMenuObj.model.contextMenuTarget), "mouseup taphold", this._textMenuObj._ContextMenuHandler);
                this._textMenuObj["_on"]($(this._textMenuObj.model.contextMenuTarget), "mouseup", this._textMenuObj._ContextMenuHandler);
            }
            else
                (this._textMenuObj) && this._textMenuObj.destroy();
        },
        _checkNameAttr: function () {
            if (this.model.name)
                this.element.attr({ "name": this.model.name });
            else if (ej.isNullOrUndefined(this.element.attr("name")))
                this.element.attr({ "name": this.element[0].id });
        },
        _enableEdit: function (args) {
            this.model.allowEditing = args;
            if (args) {
                this._wireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", this._toolBarClick);
                this._rteIframe.contents().find("body").attr("contenteditable", true);
            }
            else {
                this._unwireEvents();
                this.model.showToolbar && this._toolBarItems.ejToolbar("option", "click", null);
                this._rteIframe.contents().find("body").attr("contenteditable", false);
            }
            this._showHideContextMenu();
            this._disableResizeObj(args);
        },
        _disableResizeObj: function (value) {
            if (value) {
                if (!this.model.enableRTL) this._on($(this._getDocument()).find("table.e-rte-table"), "mouseover", this._tableMouseOver);
            }
            else {
                if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
                this._off($(this._getDocument()).find("table.e-rte-table"), "mouseover", this._tableMouseOver);
                this._removeResizeObject();
            }
        },
        _changeSkin: function (value) {
            this._rteWapper.removeClass(this.model.cssClass).addClass(value);
            this._subControlsSetModel("cssClass", value);
        },

        _updateIframeSkin: function (htmlAttr) {
            try {
                var target = this._rteIframe.contents().find("body");
                if (htmlAttr) {
                    proxy = this;
                    $.map(htmlAttr, function (value, key) {
                        if (key == "class") target.addClass(value);
                        else if (key == "required") target.attr(key, value);
                        else if (key == "disabled" && value == "disabled") proxy.disable();
                        else if (key == "readOnly" && value == "readOnly") proxy._enableEdit(false);
                        else target.attr(key, value);
                    });
                }
            }
            catch (err) {
                return false;
            }
        },


        _renderWrapper: function () {
            if (this.model.minHeight.toString().indexOf("%") > 0)
                this.model.minHeight = (parseInt(this.model.height) * parseInt(this.model.minHeight)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxHeight) && (this.model.maxHeight.toString().indexOf("%") > 0))
                this.model.maxHeight = parseInt(this.model.height) + (parseInt(this.model.height) * parseInt(this.model.maxHeight)) / 100;
            if (this.model.minWidth.toString().indexOf("%") > 0)
                this.model.minWidth = (parseInt(this.model.width) * parseInt(this.model.minWidth)) / 100;
            if (!ej.isNullOrUndefined(this.model.maxWidth) && (this.model.maxWidth.toString().indexOf("%") > 0))
                this.model.maxWidth = parseInt(this.model.width) + (parseInt(this.model.width) * parseInt(this.model.maxWidth)) / 100;
            this._rteWapper = ej.buildTag("div.e-rte e-rte-wrapper e-widget e-box " + this.model.cssClass + "#" + this._rteId + "_wrapper", "", {}, { role: "presentation" }).insertBefore(this.element);
            this._rteWapper.css("height", this.model.height).css("width", this.model.width).css("min-height", this.model.minHeight).css("min-width", this.model.minWidth).css("max-height", this.model.maxHeight).css("max-width", this.model.maxWidth);
            this._rteWapper.append(this.element.hide());
            return this;
        },

        _renderToolBar: function () {
            this._rteToolbar = ej.buildTag("div.e-rte-toolbar #" + this._rteId + "_tools").insertAfter(this.element);
            this._crateToolbarTemplate()
            ._initToolBarItems()
            ._renderToolBarList();
            this._renderToolBarItems();
            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._toolBarObj.disableItemByID(this._rteId + "_" + "video");
        },
        _renderToolBarList: function () {
            var model = {};
            model.click = this.model.allowEditing ? this._toolBarClick : null;
            model.cssClass = this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.enableSeparator = true;
			if(this.model.toolbarOverflowMode=="inline")
			model.responsiveType="inline";
            model.isResponsive = this.model.isResponsive;
            model.height = model.isResponsive ? "" : "auto";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.tooltipSettings = this.model.tooltipSettings;
            model.create = function () {
                var ddl = $(this.element).find(".e-ddl.e-widget .e-dropdownlist"), spbtn = $(this.element).find(".e-split.e-widget .e-splitbutton");
                ddl.length && ddl.ejDropDownList({ height: "30px" });
                spbtn.length && spbtn.ejSplitButton({ height: '30px' });
            }
            this._toolBarItems.ejToolbar(model);
            this._disableTabkeyNavigation(this._toolBarItems)._disableTabkeyNavigation(this._toolBarItems.find("[tabindex],.e-split-btn"));
            this._toolBarObj = this._toolBarItems.ejToolbar("instance");
             if(this.model.toolbarOverflowMode=="inline"){
            this._rteinline = this._toolBarObj._spantag;
            this._on(this._rteinline, "click", this._rteinlineClick);
             }
            this._on($(document), "mouseup touchend", this._zoomUp);
            this._on($(this._toolBarObj.itemsContainer).find(".e-rteItem-zoomIn , .e-rteItem-zoomOut"), "mousedown touchstart", this._zoomDown);
        },
        _disableTabkeyNavigation: function (elements) {
            $(elements).attr("tabindex", '-1');
            return this;
        },
        _crateToolbarTemplate: function () {
            this._toolBarItems = ej.buildTag("div#" + this._rteId + "_toolbar").appendTo(this._rteToolbar).height(30);
            for (var items in this._toolsList) {
                items = this._toolsList[items];
                if (!ej.isNullOrUndefined(this.model.tools[items])) {
                    if (items == "customTools")
                        !ej.isNullOrUndefined(this.model.tools[items]) && this._customTools(this.model.tools[items]);
                    else
                        this.model.tools[items].length > 0 && this._createToolsItems(this.model.tools[items], items);
                }
            }
            if (this.model.fileBrowser.filePath != "") {
                var ulTag = ej.buildTag("ul#" + this._rteId + "-file-exporer"), liTag;
                liTag = $("<li id='" + this._rteId + "_fileBrowser" + "' class='e-rte-explorer e-rteItem-fileBrowser' title='" + this._getLocalizedLabels("fileBrowser") + "' ><div class='e-rte-toolbar-icon fileBrowser e-fileBrowser' unselectable = 'on'></div></li>");
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
            return this;
        },

        _createToolsItems: function (items, itemName) {
            var ulTag = ej.buildTag("ul#" + (this._rteId + "_" + itemName)), liTag;
            (itemName == "font") && ulTag.addClass("e-rte-fontgroup");
            (itemName == "formatStyle") && ulTag.addClass("e-rte-format");
            (itemName == "lists") && ulTag.addClass("e-rte-lists");
            for (var i = 0; i < items.length; i++) {
                liTag = $("<li id='" + (this._rteId + "_" + items[i].replace(/ /g, '')) + "' class='e-rteItem-" + items[i] + "' ><div class='e-rte-toolbar-icon " + items[i] + " " + this._rteIconsList[items[i]] + "' unselectable = 'on'></div></li>");
                if (items[i] === "video" && ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") liTag.attr('title', this._getLocalizedLabels("html5Support"));
                else liTag.attr('title', this._getLocalizedLabels(items[i].replace(/ /g, '')));
                if (items[i] === "fullScreen") liTag.attr('data-content', this._getLocalizedLabels("maximize")).children(".e-rte-toolbar-icon").addClass(this._rteIconsList["maximize"]);
                else if (items[i] === "findAndReplace")
                    liTag.attr('title', this._getLocalizedLabels("FindAndReplace"));
                liTag.appendTo(ulTag);
            }
            ulTag.appendTo(this._toolBarItems);
            if (itemName == "font" && !this.model.showFontOption)
                ulTag.hide();
        },

        _customTools: function (toolbarItems) {
            for (var item = 0; item < toolbarItems.length; item++) {
                var ulTag = ej.buildTag("ul"), liTag;
                liTag = $("<li id='" + toolbarItems[item].name + "' title='" + toolbarItems[item].tooltip + "' ><div class='" + (ej.isNullOrUndefined(toolbarItems[item].css) ? "" : toolbarItems[item].css) + "'>" + (ej.isNullOrUndefined(toolbarItems[item].text) ? "" : toolbarItems[item].text) + "</div></li>");
                var fn = toolbarItems[item].action;
                if (typeof fn === "string") {
                    fn = ej.util.getObject(fn, window);
                }
                !ej.isNullOrUndefined(toolbarItems[item].action) && this._on(liTag, "click", fn);
                $(toolbarItems[item].template).appendTo(liTag.find("div"));
                liTag.appendTo(ulTag);
                ulTag.appendTo(this._toolBarItems);
            }
        },

        _initToolBarItems: function () {
            this._rteToolbar.find("li.e-rteItem-format").length > 0 && this._renderFormat(); 
            this._rteToolbar.find("li.e-rteItem-createTable").length > 0 && this._renderTableDialog();
            this._rteToolbar.find("li.e-rteItem-fontName").length > 0 && this._renderFontStyle();
            this._rteToolbar.find("li.e-rteItem-fontSize").length > 0 && this._renderFontSize();
            this._rteToolbar.find("li.e-rteItem-fontColor").length > 0 && this._renderFontColor();
            this._rteToolbar.find("li.e-rteItem-backgroundColor").length > 0 && this._renderBGColor();   
            this._rteToolbar.find("li.e-rteItem-unorderedList").length > 0 && this._renderUnOrderList();
            this._rteToolbar.find("li.e-rteItem-orderedList").length > 0 && this._renderOrderList();
            this._rteToolbar.find("li.e-rteItem-import").length > 0 && this._renderimport();
            !this.model.showClearAll && this._rteToolbar.find("li.e-rteItem-clearAll").hide();
            return this;
        },
        _renderToolBarItems: function () {
            this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
            this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
            // Default action when render the RTE
            if (!this.model.enableRTL)
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
            else
                this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyRight");
            //Hide the editable table icons
            var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
            if (this.model.isResponsive && items.length == 0) this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            else this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable").hide();
            return this;
        },

        _renderEditArea: function () {
            this._rteEditor = ej.buildTag("div.editarea #" + this._rteId + "_editor").appendTo(this._rteWapper);
            this._rteIframe = ej.buildTag("iframe.content-iframe #" + this._rteId + "_Iframe", "", {}).appendTo(this._rteEditor);
            this._rteIframe.css({ "border": "0" });
			this._setIFrames();
            if (navigator.userAgent.match(/(iPhone|iPod|iPad)/i) != null){
                this._rteEditor.addClass('e-ipadscroll');
                this._rteEditor.css("height", (this._rteWapper.outerHeight()- (this._rteToolbar.height())));
            }
        },

        _xhtmlTagValidation: function () {
            if (this.value() != null) {
                var htmlText = this.value();
                htmlText = htmlText.replace(/\r/gi, " ").replace(/\n/gi, "<br/> ").replace(/\r\n/gi, " ").replace(/( )+/gi, " ").replace(/&nbsp;/gi, " ").replace(/&bull;/gi, "*").replace(/&ltquo;/gi, "<").replace(/&rtquo;/gi, ">").replace(/&trze;/gi, "(tm)").replace(/&copy;/gi, "(c)").replace(/&reg;/gi, "(r)");
                if (htmlText.indexOf("<body>") != -1) {
                    var indexBody = htmlText.indexOf("<body>");
                    var delBody = htmlText.slice(0, indexBody + 6);
                    htmlText = htmlText.replace(delBody, "").replace("</body></html>", "");
                }
                htmlText = htmlText.replace(/<br>/g, "<br/>").replace(/<hr>/g, "<hr/>");
                htmlText = this._imageXhtml(htmlText);
                htmlText = this._styleXhtml(htmlText);
                htmlText = this._startXhtml(htmlText);
                if (htmlText.indexOf("alt=") != -1) {
                    var imageTag = /alt=\"(.*?)\"/ig;
                    var altTemp = new Array();
                    var tempAlt;
                    var j = 0;
                    while ((tempAlt = imageTag.exec(htmlText)) != null) {
                        altTemp[j] = tempAlt[0];
                        j++;
                    }
                    for (var i = 0; i < altTemp.length; i++) {
                        htmlText = htmlText.replace(altTemp[i], "alt=\"\"");
                    }
                }
                if (!ej.isNullOrUndefined(this._fontXhtml(htmlText))) {
                    htmlText = this._fontXhtml(htmlText);
                    if (htmlText.indexOf("ol") != -1) {
                        var olStyle = /<ol(.*)<\/ol>/ig;
                        var tempOl;
                        var k = 0;
                        var olTemp = new Array();
                        while ((tempOl = olStyle.exec(htmlText)) !== null) {
                            olTemp[k] = tempOl[0].toString();
                            k++;
                        }
                        var olEx = new Array();
                        for (var f = 0; f < olTemp.length; f++) {
                            olEx[f] = olTemp[f];
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            olTemp[i] = olTemp[i].replace(/<br\/>/gi, "");
                        }
                        for (var i = 0; i < olTemp.length; i++) {
                            htmlText = htmlText.replace(olEx[i], olTemp[i]);
                        }
                    }
                    htmlText = htmlText.replace(/<o:p>/gi, "").replace(/<\/o:p>/gi, "");
                }
                this.value(htmlText);
            }
        },

        _setIFrames: function () {
            var rteContent = null;
            if ((this.value() != null && this.value() != "")) rteContent = this.value().replace(/'/g, "\"");
            if (rteContent == null) this.value($.trim(this.element[0].value));
            var isIE8 = ej.browserInfo().name == 'msie' && parseInt(ej.browserInfo().version) == 8;
            var _htmlText = ("<!DOCTYPE html> <html> <head> <meta charset='utf-8' /> <style>html, body{height: 100%;margin: 0;}body.e-cursor{cursor:default} span.e-selected-node	{background-color: #939393;color: white;}span.e-selected-node.e-highlight{background-color: #1d9dd8;}body{font-family:Times New Roman,Times,serif;color:#5C5C5C;word-wrap:break-word;padding: 8px;box-sizing: border-box;}.e-rte-table caption{border: 1px solid;border-bottom:none}td{word-wrap:break-word;word-break:break-all;}.e-rteColumnResizer{position: absolute;bottom:0;overflow: visible;cursor: col-resize;background-repeat:repeat;background-color:transparent}.e-rteRowResizer{position: absolute;bottom:0;overflow: visible;margin-left: -4px;cursor: row-resize;background-repeat:repeat;background-color:transparent} span.e-rte-imageboxmark{width:5px;height:5px;position:absolute;display:block;background:#fff;border:1px solid #000;}</style></head><body spellcheck='false' autocorrect='off' contenteditable=" + (this.model.allowEditing ? 'true' : 'false') + ">" + ((this.value() != "" && this.value() != "<br>" ) ? $.trim(this.value()) : "<p><span>&#65279;</span></p>" ) + "</body></html>");
            this._rteIframe.css({ "width": "100%" });
            if (this.element[0].value == "<div></div>" || this.element[0].value == "")
                this.element[0].innerHTML = this.value();

            this._setContent(_htmlText);
            if (this._isIE8()) this.value(this._getDocument().body.innerHTML);
			var _tableEle = $(this._getDocument()).find("table");       
            if (!this.model.enableRTL && _tableEle.length > 0 ) this._on(_tableEle, "mouseover", this._tableMouseOver);
            if (this.model.enableXHTML) this._updateValue();
            this._setAutoHeight();
            if (!ej.isNullOrUndefined(this.model.undoStackLimit) || this.model.undoStackLimit !== "" || this.model.undoStackLimit > 0)
                this._backupArray[0] = this.getHtml();
        },


        _setIframeHeight: function () {
            var _height = (!ej.isNullOrUndefined(this._rteToolbar) && this._rteToolbar.is(':visible') ? this._rteToolbar.outerHeight() : 6) + (!ej.isNullOrUndefined(this._rteFooter) && this._rteFooter.is(':visible') ? this._rteFooter.outerHeight() : 0);
            this._rteIframe.css("height", (_height == 0 ? this.model.height : ((this._rteWapper.outerHeight() - _height) - (parseInt(this._rteEditor.css("padding-top")) + parseInt($(".e-rte-wrapper").css("border-bottom-width")) + parseInt(this.model.showFooter ? $(".e-rte-footer").css("margin-top") : 0)))));
        },

        // Footer Div render 
        _renderFooter: function () {
            var options = this.model;
            this._rteFooter = ej.buildTag("div.e-rte-footer #" + this._rteId + "_footer").appendTo(this._rteWapper);
            var _leftPan = ej.buildTag("div.e-rte-footer-left");
            this._htmlSource = ej.buildTag("div.e-rte-icons e-rte-footeritems e-rte-footericon e-rte-source " + this._rteIconsList["rteSource"], "", {}, { title: this._getLocalizedLabels("viewHtml") }).appendTo(_leftPan);
            this._htmlInfo = ej.buildTag("div.e-rte-htmltaginfo e-rte-footeritems").appendTo(_leftPan);
            _leftPan.appendTo(this._rteFooter);
            var _rightPan = ej.buildTag("div.e-rte-footer-right");
            this._wordCount = ej.buildTag("div.e-rte-wordcount e-rte-footeritems").appendTo(_rightPan);
            this._charCount = ej.buildTag("div.e-rte-charcount e-rte-footeritems").appendTo(_rightPan);
            this._clearFormat = ej.buildTag("div.e-rte-icons " + this._rteIconsList["clearFormat"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearFormat"), "unselectable": "on" }).appendTo(_rightPan);
            this._clearAll = ej.buildTag("div.e-rte-icons clearAll " + this._rteIconsList["clearAll"] + " e-rte-footericon e-rte-footeritems", "", {}, { title: this._getLocalizedLabels("clearAll") }).appendTo(_rightPan);
            this._resize = ej.buildTag("div.e-icons e-rte-resize " + this._rteIconsList["rteResize"] + " e-rte-footeritems").appendTo(_rightPan);
            _rightPan.appendTo(this._rteFooter);
            this._footerEvents("_on");
            !this.model.showHtmlSource && this._htmlSource.hide().removeClass("e-rte-footeritems");
            !this.model.showHtmlTagInfo && this._htmlInfo.hide().removeClass("e-rte-footeritems");
            !this.model.showWordCount && this._wordCount.hide().removeClass("e-rte-footeritems");
            !this.model.showCharCount && this._charCount.hide().removeClass("e-rte-footeritems");
            !this.model.showClearAll && this._clearAll.hide().removeClass("e-rte-footeritems");
            !this.model.showClearFormat && this._clearFormat.hide().removeClass("e-rte-footeritems");
            //if (options.showFooter && this.model.enableRTL) this._rteFooter.addClass("e-rtl");
            if (options.enableResize)
                this._enableResize();
            else
                this._resize.hide().removeClass("e-rte-footeritems");
            this._updateCount();
            if (this.model.showWordCount) this._on(this._wordCount, "click", this._wordCharClick);
            if (this.model.showCharCount) this._on(this._charCount, "click", this._wordCharClick);
            this._renderTooltip(this.model.tooltipSettings);

        },
        _renderTooltip: function (options) {
            var model = $.extend(true, {}, options);
            if (!ej.isNullOrUndefined(model.cssClass))//which holds the css for the tooltip
                model.cssClass = model.cssClass + " e-rteTooltip " + this.model.cssClass;
            else
                model.cssClass = "e-rteTooltip " + this.model.cssClass;
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.target = ".e-rte-icons";
            if (this.model.showFooter)
                this._tooltip = $(this._rteFooter).ejTooltip(model).data("ejTooltip");
        },
        _hideTooltip: function () {
            if (!ej.isNullOrUndefined(this._tooltip))
                this._tooltip.hide();
        },
        _footerElement: function (selector, visible) {
            if (this.model.showFooter) {
                var ele = this._rteFooter.find(selector);
                visible ? ele.show().addClass("e-rte-footeritems") : ele.hide().addClass("e-rte-footeritems");
            }
        },
        _wordCharClick: function (e) {
            this._alertWindow.ejDialog("option", { "showHeader": true, "title": "<span style='padding-left:0.4em;'>" + this._getLocalizedLabels("wordCount") + "</span>" });
            this.model.enableRTL && this._alertWindow.find(".e-alert-ok").removeClass("e-rte-alertBtnRTL");
            this._alertWindow.find(".e-rte-button").removeClass("e-fieldseparate").css({ "text-align": "center", "padding-bottom": "1em", "padding-top": "0.5em" });
            this._alertWindow.ejDialog("instance").refresh();
            this._openAlert("<div style='padding-left:0.3em;padding-right:0.3em;'><div style='" + ((this.model.enableRTL) ? 'float:right' : 'float:left') + "'>" + this._getLocalizedLabels("words") + "<p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charSpace") + "</p><p style='margin:0.875em 0em;'>" + this._getLocalizedLabels("charNoSpace") + "</p></div><div style='" + ((this.model.enableRTL) ? 'float:left;padding-right:2em;' : 'float:right;padding-left:2em;') + "'>"
			+ ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0) + "<p style='margin:0.875em 0em;'>" + this._getText().length + "</p><p style='margin:0.875em 0em;'>" + this._getText().replace(/\s/g, "").length + "</p></div></div><br/>");
        },
        _updateColorPalette: function () {
            var _fontColor = $("ul#" + this._rteId + "_colorTable");
            var _bgColor = $("ul#" + this._rteId + "_colorBGTable");
            _fontColor.find("div.e-rte-table").remove();
            _fontColor.find("li").append(this._colorTable());
            //Bg Color table Update
            _bgColor.find("div.e-rte-table").remove();
            _bgColor.find("li").append(this._colorTable());
        },
        _enableRTL: function (value) {
            try {
                if (value)
                    this._rteIframe.contents().find("body").css("direction", "rtl");
                else
                    this._rteIframe.contents().find("body").css("direction", "ltr");
            }
            catch (error) { }
            this._subControlsSetModel("enableRTL", value);
            //if (this.model.showFooter && this._rteFooter) this._rteFooter.addClass("e-rtl");
        },
        _roundedCorner: function (value) {
            if (value) this._rteWapper.toggleClass('e-corner-all');
            this._subControlsSetModel("showRoundedCorner", value);
        },
        _subControlsSetModel: function (prop, value) {
            if (!ej.isNullOrUndefined(this._tooltip)) {
                if (prop == "cssClass")
                    $(this._rteFooter).ejTooltip("option", prop, "e-rteTooltip " + value);
                else
                    $(this._rteFooter).ejTooltip("option", prop, value);
            }
            !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.ejDropDownList("option", prop, value);
            !ej.isNullOrUndefined(this._fontColorSplit) && this._fontColorSplit.ejSplitButton("option", prop, value);
            !ej.isNullOrUndefined(this._bgColorSplit) && this._bgColorSplit.ejSplitButton("option", prop, value);
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-top"))
                    this._toolBarItems.removeClass("e-corner-top").addClass("e-corner-all");
                this._toolBarItems.ejToolbar("option", prop, value);
                if ((prop == "showRoundedCorner") && this._toolBarItems.hasClass("e-corner-all"))
                    this._toolBarItems.removeClass("e-corner-all").addClass("e-corner-top");
            }
            if (!ej.isNullOrUndefined(this._linkDialog)) {
                this._linkDialog.ejDialog("option", prop, value);
                this._linkDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._linkDialog.find(".e-inputtext").addClass('e-corner-all') : this._linkDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._imgDialog)) {
                this._imgDialog.ejDialog("option", prop, value);
                this._imgDialog.find("div.e-rte-imageTab").ejTab("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox("option", prop, value);
                this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList("option", prop, value);
                this._chkImgDimensions.ejCheckBox("option", prop, value);
                this._dialogchkTarget.ejCheckBox("option", prop, value);
                this._imgDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._imgDialog.find(".e-inputtext").addClass('e-corner-all') : this._imgDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._videoDialog)) {
                this._videoDialog.ejDialog("option", prop, value);
                this._videoDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkvideoDimensions.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._videoDialog.find(".e-inputtext").addClass('e-corner-all') : this._videoDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("option", prop, value);
            if (!ej.isNullOrUndefined(this._sourceDialog)) {
                this._sourceDialog.ejDialog("option", prop, value);
                this._sourceDialog.find(".e-rte-btn").ejButton("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._sourceDialog.find(".e-inputtext").addClass('e-corner-all') : this._sourceDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._alertWindow)) {
                this._alertWindow.ejDialog("option", prop, value);
                this._alertWindow.find(".e-rte-btn").ejButton("option", prop, value);
            }
            if (!ej.isNullOrUndefined(this._customTableDialog)) {
                this._customTableDialog.ejDialog("option", prop, value);
                this._customTableDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._customTableDialog.find(".numerictextbox").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", prop, value);
                this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("option", prop, value);
                this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("option", prop, value);
                this._chkTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._customTableDialog.find(".e-inputtext").addClass('e-corner-all') : this._customTableDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._eTblDialog)) {
                this._eTblDialog.ejDialog("option", prop, value);
                this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox("option", prop, value);
                this._eTblDialog.find(".e-rte-dropdown").ejDropDownList("option", prop, value);
                this._getTableObj("_Tab").ejTab("option", prop, value);
                this._eTblDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._eTblCaption.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._eTblDialog.find(".e-inputtext").addClass('e-corner-all') : this._eTblDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._fileDialog)) {
                this._fileDialog.ejDialog("option", prop, value);
                this._fileDialog.find(".e-rte-btn").ejButton("option", prop, value);
                this._chkFileTarget.ejCheckBox("option", prop, value);
                if (prop == "showRoundedCorner") (value == true) ? this._fileDialog.find(".e-inputtext").addClass('e-corner-all') : this._fileDialog.find(".e-inputtext").removeClass('e-corner-all');
            }
            if (!ej.isNullOrUndefined(this._explorerObj))
                this._explorerObj.option(prop, value);
            if (!ej.isNullOrUndefined(this._fileBrowserObj))
                this._fileBrowserObj.option(prop, value);
        },
        _createCountElement: function (option, element) {
            option ? element.show() : element.hide();
            element.toggleClass("e-rte-footeritems");
        },

        _enableResize: function () {
            if (this.model.enableResize && this.model.enabled) {
                this._rteWapper.addClass("e-resizable");
                this._resizeRTE();
            }
        },

        _resizeRTE: function () {
            var proxy = this;
            this._overlayElement = ej.buildTag('div.e-rte-overlay');
            this._rteEditor.css("position", "relative");
            this._rteWapper.find("div.e-rte-resize").ejResizable(
                {
                    minHeight: parseInt(proxy.model.minHeight),
                    minWidth: parseInt(proxy.model.minWidth),
                    maxHeight: parseInt(proxy.model.maxHeight),
                    maxWidth: parseInt(proxy.model.maxWidth),
                    resizeStart: function (event) {
                        proxy._rteEditor.append(proxy._overlayElement);
                        proxy._trigger("resizeStart", { event: event });
                    },
                    resize: function (event) {
					    proxy._updateCount();
                        proxy._resizeHeight(event.element);
                        proxy._trigger("resize", { event: event });
                        if (proxy.model.isResponsive && proxy.model.showToolbar) proxy._toolBarObj._reSizeHandler();
                    },
                    resizeStop: function (event) {
                        proxy._overlayElement.remove();
                        proxy._trigger("resizeStop", { event: event });
                    },
                    helper: function (event) {
                        proxy._resizeHeight(event.element);
                        return $(proxy._rteWapper);
                    }
                });
        },
        _getDocumentHandler: function () {
            (!this._operationHandler) && (this._operationHandler = new ej.editorManager(this.getDocument(), this._getWindow()));
            return this._operationHandler;
        },
        _resizeHeight: function (element) {
            var reElement = element.parents("div.e-rte-wrapper");
            this._rteWidth = reElement.width();
            this._rteHeight = reElement.height();
            this._rteWapper.height(this._rteHeight);
            this._rteWapper.width(this._rteWidth);
            this._setIframeHeight();
        },

        _getDialogModel: function () {
            var dialogModel;
            var rtecontent = this._rteWapper;
            return dialogModel = {
                enableResize: false,
                showOnInit: false,
                enableModal: true,
                cssClass: this.model.cssClass,
                target: rtecontent,
				isResponsive:true,
                enableRTL: this.model.enableRTL
            };
        },
        _labelFor: function (val) {
            return this._rteId ? " for=" + this._rteId + val + " " : "";
        },
        _TagId: function (val) {
            return this._rteId ? " id=" + this._rteId + val + " " : "";
        },
        _renderLinkDialog: function () {
            var proxy = this;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var createLink = this._linkDialog = ej.buildTag("div#" + this._rteId + "_link");
            var content = $("<div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_link_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-linkUrl' " + this._TagId("_link_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkText' " + this._TagId("_link_text") + "></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_link_title") + ">" + this._getLocalizedLabels("linkTooltipLabel") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-linkTitle' " + this._TagId("_link_title") + "></div><div class='e-rte-label " + btnDiv + "'></div>" +
                           "<div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-linkTarget'  data-role ='none' " + this._TagId("_link_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='link_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='link_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(createLink);
            createLink.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.minWidth="340px";
			model.width="auto";
            model.title = this._getLocalizedLabels("createLink");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            createLink.ejDialog(model);
            createLink.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && createLink.find(".e-inputtext").addClass('e-corner-all');
            this._chkTarget = createLink.find(".e-rte-linkTarget");
            this._chkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            createLink.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(createLink.find(".e-rte-btn"), "click", this._linkBtnClick)
            ._on(this._linkDialog.find(".e-rte-linkUrl"), "keypress", this._urlValidation);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },


        _renderImageDialog: function () {
            var proxy = this, pathData = "";
            this._imgDialog = ej.buildTag("div#" + this._rteId + "_Image");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = "<div " + this._TagId("_img_Tab") + " class='e-rte-imageTab'><ul><li class='e-first'><a href='#" + this._rteId + "_general'>" + this._getLocalizedLabels("general") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_advanced'>" + this._getLocalizedLabels("advanced") + " </a></li></ul>" +
                "<div id='" + this._rteId + "_general'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_url") + ">" + this._getLocalizedLabels("imageWebUrl") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgUrl' " + this._TagId("_img_url") + "></div></div><div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'>" +
                         "<label " + this._labelFor("_img_text") + ">" + this._getLocalizedLabels("imageAltText") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none'  class='e-inputtext e-rte-imgText' " + this._TagId("_img_text") + "></div></div>" +
                        "<div class='e-rte-imgdimensions' " + this._TagId("_imgdimensions") + "><div class='e-rte-label " + btnDiv + "'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "'  data-role ='none' class='e-inputtext e-dimensions e-rte-imgX' maxlength='3' " + this._TagId("_imgX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-imgY' maxlength='3' " + this._TagId("_imgY") + "></div>" +
                 "<input type='checkbox' class='e-rte-imgConsrn' data-role ='none'" + this._TagId("_img_consrn") + "<label " + this._labelFor("_img_consrn") + "  style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div>" +
                "</div>" +
                "<div id='" + this._rteId + "_advanced'>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_link") + ">" + this._getLocalizedLabels("imageLink") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-imgLink' " + this._TagId("_img_link") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_border_px") + ">" + this._getLocalizedLabels("imageBorder") + "</label></div><div class='e-rte-field " + btnDiv + "'><div class='e-img-border-field'><input type='text' data-role ='none' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-rte-imgBorderPx' maxlength='3' " + this._TagId("_img_border_px") + "></div><div class='e-img-border-field'><select class='e-rte-imgBorderStyle'  data-role ='none' " + this._TagId("_img_border_style") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("imageBorder") + "' class='e-inputtext e-rte-imgBorderColor' " + this._TagId("_img_border_color") + "></div></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_img_style") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none'  class='e-inputtext e-rte-imgStyle' " + this._TagId("_img_style") + "></div></div>" +
                        "<div class='e-img-field-group'><div class='e-rte-label " + btnDiv + "'></div><div class='e-rte-field " + btnDiv + "'><input type='checkbox' class='e-rte-imgLinkTarget' data-role ='none' " + this._TagId("_img_link_target") + "><label " + this._labelFor("_img_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div></div>" +
                "</div>" +

                "</div>" +
                "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none'  type='button' id='" + this._rteId + "_img_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_img_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            if (this.model.imageBrowser.filePath != "")
                pathData = "<div " + this._TagId("_img_explorer") + " class='e-rte-explorer e-rte-imgBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._imgDialog);
            this._imgDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find("div.e-rte-imgdimensions").hide();
            var model = this._getDialogModel();
			this.model.imageBrowser.filePath=="" ? model.maxWidth="470px" : model.maxWidth="720px";
            model.width ="auto";
		    model.title = this._getLocalizedLabels("image");
            model.target = null;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._explorerObj && proxy._explorerObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._imgSplitObj))
                    proxy._imgSplitObj.option("enableAutoResize", false);
            };
            this._imgDialog.ejDialog(model);
            this._imgDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            if (this.model.imageBrowser.filePath != "") {
                var ajaxSettings = { upload: { url: this.model.imageBrowser.uploadAction } };
                if (this.model.imageBrowser.ajaxSettings)
                    $.extend(true, ajaxSettings, this.model.imageBrowser.ajaxSettings);

                this._explorerObj = this._imgDialog.find("div.e-rte-imgBrowser").ejFileExplorer({
                    allowMultiSelection: false, showFooter: false, showTreeview: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth: "690px", isResponsive:true,minWidth:"330px",height: "300px", path: this.model.imageBrowser.filePath, fileTypes: this.model.imageBrowser.extensionAllow, layout: ej.FileExplorer.layoutType.LargeIcons, select: function (e) { proxy._UpdateImgDetails(e); },
                    tools: {
                        creation: ["NewFolder", "Open"],
                        navigation: ["Back", "Forward"],
                        addressBar: ["Addressbar"],
                        editing: ["Refresh", "Upload", "Delete"],
                        searchBar: ["Searchbar"]
                    }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                    ajaxAction: this.model.imageBrowser.ajaxAction, locale: this.model.locale,
                    ajaxSettings: ajaxSettings
                }).data('ejFileExplorer');
                this._imgSplitObj = this._imgDialog.find(".e-splitter").data("ejSplitter");
                this._imgSplitObj.option("enableAutoResize", false);
            }
            this.model.showRoundedCorner && this._imgDialog.find(".e-inputtext").addClass('e-corner-all');
            this._imgDialog.find("div.e-rte-imageTab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderPx").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-imgBorderStyle").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkImgDimensions = this._imgDialog.find(".e-rte-imgConsrn");
            this._chkImgDimensions.ejCheckBox({ check: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._imgPicker = this._imgDialog.find(".e-rte-imgBorderColor").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._imgDialog.parents("#" + this._rteId + "_Image_wrapper").css({ "visibility": "visible", "display": "none" });
            this._dialogchkTarget = this._imgDialog.find(".e-rte-imgLinkTarget");
            this._dialogchkTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._imgDialog.find(".e-rte-btn"), "click", this._imageBtnClick)
            this._on(this._imgDialog.find(".e-rte-imgUrl , .e-rte-imgLink"), "keypress", this._urlValidation);
            this._on(this._imgDialog.find("input.e-dimensions"), "change", this._recalcImgSize);
            this.model.showRoundedCorner && this._subControlsSetModel();    
        },
        _renderFileBrowserDialog: function () {
            var proxy = this, pathData = "";
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._fileDialog = ej.buildTag("div#" + this._rteId + "_fileDialog");
            var content = "<div class='e-rte-elements'><div class='e-rte-label " + btnDiv + "'><label " + this._labelFor("_file_url") + ">" + this._getLocalizedLabels("linkWebUrl") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text'  data-role ='none' class='e-inputtext e-rte-fileUrl' " + this._TagId("_file_url") + "/></div><div class='e-rte-label " + btnDiv + "'>" +
                           "<label " + this._labelFor("_file_text") + ">" + this._getLocalizedLabels("linkText") + "</label></div><div class='e-rte-field " + btnDiv + "'><input type='text' data-role ='none' class='e-inputtext e-rte-fileText' " + this._TagId("_file_text") + "></div> </div>" +
                           "<div class='e-rte-field'><input type='checkbox' class='e-rte-fileTarget'  data-role ='none' " + this._TagId("_file_target") + "><label " + this._labelFor("_link_target") + " style='padding: 5px;'>" + this._getLocalizedLabels("linkOpenInNewWindow") + "</label></div>" +
                           "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' type='button' data-role ='none' id='" + this._rteId + "_file_insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "'type='button' data-role ='none' id='" + this._rteId + "_file_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>";
            pathData = "<div " + this._TagId("_file_explorer") + " class='e-rte-explorer e-rte-fileBrowser'></div>";
            content = $(pathData + content);
            content.appendTo(this._fileDialog);
            this._fileDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
			model.width="auto";
            model.title = this._getLocalizedLabels("fileBrowser");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.open = function () {
                proxy._fileBrowserObj.adjustSize();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", true);
            };
            model.close = function () {
                proxy._ieCursorMaintainance();
                if (!ej.isNullOrUndefined(proxy._fileSplitObj))
                    proxy._fileSplitObj.option("enableAutoResize", false);
            };
            this._fileDialog.ejDialog(model);
            this._fileDialog.closest(".e-dialog-wrap").css({ "visibility": "hidden", "display": "block" }).addClass("e-rte");
            var ajaxSettings = { upload: { url: this.model.fileBrowser.uploadAction } };
            if (this.model.fileBrowser.ajaxSettings)
                $.extend(true, ajaxSettings, this.model.fileBrowser.ajaxSettings);

            this._fileBrowserObj = this._fileDialog.find("div.e-rte-fileBrowser").ejFileExplorer({
                allowMultiSelection: false, showFooter: false, showTreeview: false, enableRTL: this.model.enableRTL, showRoundedCorner: this.model.showRoundedCorner, cssClass: this.model.cssClass, maxWidth:"690px", height: "300px",isResponsive:true,minWidth:"330px", path: this.model.fileBrowser.filePath, fileTypes: this.model.fileBrowser.extensionAllow, layout: "list", select: function (e) { proxy._UpdateFileDetails(e); },
                tools: {
                    creation: ["NewFolder", "Open"],
                    navigation: ["Back", "Forward"],
                    addressBar: ["Addressbar"],
                    editing: ["Refresh", "Upload", "Delete"],
                    searchBar: ["Searchbar"]
                }, toolsList: ["creation", "navigation", "addressBar", "editing", "searchBar"], enableResize: false, showContextMenu: false,
                ajaxAction: this.model.fileBrowser.ajaxAction, locale: this.model.locale,
                ajaxSettings: ajaxSettings
            }).data('ejFileExplorer');
            this._fileSplitObj = this._fileDialog.find(".e-splitter").data("ejSplitter");
            this._fileSplitObj.option("enableAutoResize", false);
            this.model.showRoundedCorner && this._fileDialog.find(".e-inputtext").addClass('e-corner-all');
            this._fileDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._fileDialog.parents("#" + this._rteId + "_fileDialog_wrapper").css({ "visibility": "visible", "display": "none" });
            this._chkFileTarget = content.find(".e-rte-fileTarget");
            this._chkFileTarget.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._fileDialog.find(".e-rte-btn"), "click", this._fileBtnClick);
            this.model.showRoundedCorner && this._subControlsSetModel(); 
        },
        _UpdateImgDetails: function (e) {
            if ($(this._imgURL).hasClass('e-error')) this._imgURL.removeClass("e-error");
            if (e.path === "") this._imgURL.val("http://");
            else this._imgDialog.find("div.e-rte-imageTab").find('.e-rte-imgUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _UpdateFileDetails: function (e) {
            if ($(this._fileURL).hasClass('e-error')) this._fileURL.removeClass("e-error");
            if (e.path === "") this._fileURL.val("http://");
            else this._fileDialog.find('.e-rte-fileUrl').val(e.path + (e.name[0] ? e.name[0] : ""));
        },
        _fileBtnClick: function (sender) {
            this._renderLinkDialog();
            if (sender.target.id === this._rteId + "_file_cancel") {
                this._clearFileFields();
                this._fileDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_file_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._fileDialog.find('e-rte-fileUrl').val() != "")
                    this._onInsertFileLink();
                else this._linkDialog.ejDialog("close");
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },
        _clearFileFields: function () {
            this._fileURL = this._fileDialog.find(".e-rte-fileUrl");
            this._fileURL.val("http://");
            this._fileLinkText = this._fileDialog.find(".e-rte-fileText");
            this._fileLinkText.val("");
            this._chkFileTarget.ejCheckBox({ check: false });
        },
        _onGetInsertFileContent: function (Url) {
            if (this._fileLinkText.val() === "") this._selectedHTML = Url;
            else this._selectedHTML = this._fileLinkText.val();
        },
        _onInsertFileLink: function () {
            var oEl, sHtml;
            var fileVal = this._fileURL.val().match(/(ftp:|http:|https:)\/\//g);
            var fsrcUrl = (this._fileURL.val().startsWith("~")) ? this._fileURL.val().replace(this._fileURL.val().substr('0', '1'), "..") : this._fileURL.val();
            if ((ej.isNullOrUndefined(fileVal) && fsrcUrl !== "") || (!ej.isNullOrUndefined(fileVal) && fileVal[0].length < fsrcUrl.length)) {
                var selectedNode = ((this._isIE()) && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
                if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                    selectedNode.href = fsrcUrl;
                    selectedNode.innerHTML = this._fileLinkText.val();
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "_self";
                }
                else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                    var parentNode = $(selectedNode).parent('a')[0];
                    if (ej.isNullOrUndefined(parentNode)) {
                        oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                        $(selectedNode.outerHTML).appendTo($(oEl));
                        $(selectedNode).replaceWith($(oEl));
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    } else {
                        parentNode.href = fsrcUrl;
                        (this._chkFileTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "_self";
                    }
                }
                else {
                    oEl = ej.buildTag("a", "", {}, { href: fsrcUrl });
                    (this._chkFileTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "_self";
                    var oSelection;
                    var oSelRange;
                    this._focus();
                    if (this._isIE()) {
                        if (!ej.isNullOrUndefined(this._selectedHTML)) {
                            if (this._selectedHTML.length == 0)
                                this._onGetInsertFileContent(fsrcUrl);
                        }
                        else
                            this._onGetInsertFileContent(fsrcUrl);
                        oEl[0].innerHTML = this._selectedHTML;
                        sHtml = oEl[0].outerHTML;
                    }
                    else {
                        if (this._fileLinkText.val() === "")
                            oEl.html(fsrcUrl);
                        else oEl.html(this._fileLinkText.val());
                        sHtml = $('<div>').append($(oEl).clone()).html();
                    }
                    if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                        this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                        this._focus();
                    }
                }
                this._fileDialog.ejDialog("close");
            } else {
                this._fileURL.addClass("e-error");
                return false;
            }
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },
        //Render the Table selection rows and columans popup
        _renderVideoDialog: function () {
            var proxy = this;
            this._videoDialog = ej.buildTag("div#" + this._rteId + "_video");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div><label>" + this._getLocalizedLabels("embedVideo") + "</label></div><textarea class='e-rte-video e-inputtext'  aria-label=" + this._getLocalizedLabels("embedVideo") + "></textarea>" +
               "<div class='e-rte-videoDimensions'" + this._TagId("_videodimensions") + " style='margin-top:7px'><div class='e-rte-label'><label>" + this._getLocalizedLabels("dimensions") + " </label></div><div><input type='text'  data-role ='none' title='" + this._getLocalizedLabels("dimensions") + "' class='e-inputtext e-dimensions e-rte-videoX' maxlength='3' " + this._TagId("_videoX") + "><label style='padding: 5px;'>X</label><input type='text'  data-role ='none'  title='" + this._getLocalizedLabels("dimensions") + "' style='margin-right: 5px;' class='e-inputtext e-dimensions e-rte-videoY' maxlength='3'" + this._TagId("_videoY") + ">" +
               "<input type='checkbox' class='e-rte-videoConsrn' data-role ='none'" + this._TagId("_video_consrn") + "<label " + this._labelFor("_video_consrn") + "style='padding: 5px;'>" + this._getLocalizedLabels("constrainProportions") + "</label></div></div>" +
                "<div class='e-rte-button e-fieldseparate'><button id='video_insert'type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogInsert") + "</button><button id='video_cancel' type='button' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._videoDialog);
            this._videoDialog.appendTo(this._rteWapper);
            !this.model.showDimensions && this._rteWapper.find(".e-rte-videoDimensions").hide();
            var model = this._getDialogModel();
            model.width="auto";
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.title = this._getLocalizedLabels("video");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._videoDialog.ejDialog(model);
            this._videoDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._videoDialog.find(".e-inputtext").addClass('e-corner-all');
            this._chkvideoDimensions = this._videoDialog.find(".e-rte-videoConsrn");
            this._chkvideoDimensions.ejCheckBox({ checked: true, enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._videoDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._videoDialog.find(".e-rte-btn"), "click", this._insertVideo);
            this._on(this._videoDialog.find("input.e-dimensions"), "change", this._recalcVideoSize);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },


        _renderTableDialog: function () {
            var proxy = this;
            this._createTable = ej.buildTag("div.e-rte-table-picker#" + this._rteId + "_table");
            this._customTable = $("<div class='customtable-group e-rte-createCustomTableLink' " + this._TagId("_createCustomTableLink") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("customTable") + "'>" + this._getLocalizedLabels("customTable") + "</a></div>" +
               "<div class='customtable-group e-rte-eTblProperties e-disable' " + this._TagId("_eTblProperties") + "><span class='e-rte-toolbar-icon " + this._rteIconsList["customTableImage"] + "'></span><a class='customtable-link' role='button' title='" + this._getLocalizedLabels("editTable") + "'>" + this._getLocalizedLabels("editTable") + "</a></div>");  
            var tableCell, rowDiv, colDiv, tableDiv;
            this._tblheaderDiv = ej.buildTag("div.e-rte-tableheader");
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
            this._tblheaderDiv.appendTo(this._createTable);
            var tableDiv = ej.buildTag("div.e-rte-table");
            this._drawTable(tableDiv);
            tableDiv.appendTo(this._createTable); 
            this._createTable.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.enableModal = false;
            model.showHeader = false;
            model.width = "auto";
            model.minWidth = "270px";
            model.maxWidth = "270px";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function (args) {
				args.event&& args.event.clickAction && proxy._ieCursorMaintainance();
            };
            this._createTable.ejDialog(model); 
            this._on(this._customTable, "click", this._openCustomTable);
            this._customTable.appendTo(this._createTable); 
        },

        _createCustomTable: function () { 
            if (!this.model.showCustomTable)
                this._createTable.find("#" + this._rteId + "_createCustomTableLink").hide();
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            this._customTableDialog = ej.buildTag("div.e-rte-customtable#" + this._rteId + "_customTable");
            var content = $("<div class='e-fieldgroup'><div class='e-rte-tablefields'><label " + this._labelFor("_txtColumns") + ">" + this._getLocalizedLabels("tableColumns") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtColumns' " + this._TagId("_txtColumns") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtRows") + ">" + this._getLocalizedLabels("tableRows") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='numerictextbox e-rte-txtRows' " + this._TagId("_txtRows") + "></div><div class='e-rte-tablefields'>" +
                 "<label " + this._labelFor("_txtWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtWidth'" + this._TagId("_txtWidth") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtHeight'" + this._TagId("_txtHeight") + "></div></div>" +
                 "<div class='e-fieldseparate'><div class='e-rte-tablefields'><label " + this._labelFor("_txtSpacing") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtSpacing' " + this._TagId("_txtSpacing") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtPadding") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-rte-txtPadding'" + this._TagId("_txtPadding") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_txtBorder") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-txtBorder' data-role ='none' " + this._TagId("_txtBorder") + "><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_chkCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' class='e-rte-chkCaption'  data-role ='none'" + this._TagId("_chkCaption") + "></div>" +
                 "<div class='e-rte-tablefields'><label " + this._labelFor("_ddlAlignment") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select class='e-rte-ddlAlignment' data-role ='none' " + this._TagId("_ddlAlignment") + "><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div></div>" +
                 "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='insert'>" + this._getLocalizedLabels("dialogInsert") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._customTableDialog);
			var model = this._getDialogModel();
            model.width = "auto";
			model.maxWidth="480px";
            model.title = this._getLocalizedLabels("customTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customTableDialog.ejDialog(model);
            this._customTableDialog.closest(".e-dialog-wrap").addClass("e-rte");
            this.model.showRoundedCorner && this._customTableDialog.find(".e-inputtext").addClass('e-corner-all');
            this._createTable.find("div.e-rte-eTblProperties");
            this._customTableDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 1, value: 3, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox({ maxValue: 63, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: false, showRoundedCorner: this.model.showRoundedCorner });
            this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._chkTblCaption = this._customTableDialog.find(".e-rte-chkCaption");
            this._chkTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._customTableDialog.find(".e-rte-btn"), "click", this._insertCustomTable);
            this._on(this._customTableDialog.find(".e-rte-txtWidth"), "focusout", this._widthFocusOut);
        },
        _renderEditTableDialog: function () {
            var proxy = this;
            this._eTblDialog = ej.buildTag("div.e-rte-edittable#" + this._rteId + "_eTbl");
            var rteID = this._rteId;
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<div id='" + this._rteId + "_eTbl_Tab'><ul><li class='e-first'><a href='#" + this._rteId + "_eTblTable'>" + this._getLocalizedLabels("table") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblRow'>" + this._getLocalizedLabels("row") + " </a></li><li class='e-nofirst'><a href='#" + this._rteId + "_eTblCell'>" + this._getLocalizedLabels("cell") + " </a></li></ul>" +
            "<div id='" + this._rteId + "_eTblTable'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellSpace") + ">" + this._getLocalizedLabels("tableCellSpacing") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellSpace") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCellPad") + ">" + this._getLocalizedLabels("tableCellPadding") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext e-numerictextbox' " + this._TagId("_eTblCellPad") + "></div>" +
                   "<div class='e-rte-tablefields'><label  " + this._labelFor("_eTblAlign") + ">" + this._getLocalizedLabels("tableAlignment") + "</label></div><div class='e-rte-tablefields'><select id='" + rteID + "_eTblAlign' data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblCaption") + ">" + this._getLocalizedLabels("tableCaption") + "</label></div><div class='e-rte-tablefields'><input type='checkbox' data-role ='none' " + this._TagId("_eTblCaption") + "></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input  data-role ='none' type='text' title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTbl_border_style") + " class='e-rte-dropdown' data-role ='none' ><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTbl_border_color") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblRow'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRHeight") + ">" + this._getLocalizedLabels("tableHeight") + "</label></div><div class='e-rte-tablefields'><input  data-role ='none' type='text' class='e-inputtext' " + this._TagId("_eTblRHeight") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblRAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblRAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3'  " + this._TagId("_eTblRBrdrPx") + "></div><div class='e-img-border-field'><select " + this._TagId("_eTblRBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblRBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblRStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblRStyle") + "></div></div>" +
            "</div>" +
            "<div id='" + rteID + "_eTblCell'>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClWidth") + ">" + this._getLocalizedLabels("tableWidth") + "</label></div><div class='e-rte-tablefields'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClWidth") + "></div>" +
                    "<div class='e-rte-tablefields'><label " + this._labelFor("_eTblClAlign") + ">" + this._getLocalizedLabels("textAlign") + "</label></div><div class='e-rte-tablefields'><select " + this._TagId("_eTblClAlign") + " data-role ='none'  class='e-rte-dropdown'><option value='left'>" + this._getLocalizedLabels("left") + "</option><option value='right'>" + this._getLocalizedLabels("right") + "</option><option value='center'>" + this._getLocalizedLabels("center") + "</option></select></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClBrdrPx") + ">" + this._getLocalizedLabels("tableBorder") + "</label></div><div class='e-rte-stylefield'><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext e-numerictextbox' maxlength='3' " + this._TagId("_eTblClBrdrPx") + " ></div><div class='e-img-border-field'><select " + this._TagId("_eTblClBrdrStyle") + " data-role ='none' class='e-rte-dropdown'><option value='solid'>" + this._getLocalizedLabels("solid") + "</option><option value='dotted'>" + this._getLocalizedLabels("dotted") + "</option><option value='dashed'>" + this._getLocalizedLabels("dashed") + "</option><option value='double'>" + this._getLocalizedLabels("doubled") + "</option></select></div><div class='e-img-border-field'><input type='text' data-role ='none'  title='" + this._getLocalizedLabels("tableBorder") + "' class='e-inputtext' " + this._TagId("_eTblClBrdrColor") + "></div></div></div>" +
                    "<div class='e-img-field-group'><div class='e-rte-tablefields'><label " + this._labelFor("_eTblClStyle") + ">" + this._getLocalizedLabels("imageStyle") + " </label></div><div class='e-rte-stylefield'><input type='text' data-role ='none'  class='e-inputtext' " + this._TagId("_eTblClStyle") + "></div></div>" +
            "</div>" +
            "</div>" +
            "<div class='e-rte-button e-fieldseparate'><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_apply'>" + this._getLocalizedLabels("dialogApply") + "</button><button class='e-rte-btn " + btnDiv + "' data-role ='none' id='" + rteID + "_eTbl_cancel'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>"
            );
            content.appendTo(this._eTblDialog);
            this._tblborderPicker = this._eTblDialog.find("#"+this._rteId +"_eTbl_border_color").ejColorPicker({ cssClass: this.model.cssClass, modelType: "palette", buttonText: { apply: this._getLocalizedLabels("buttonApply"), cancel: this._getLocalizedLabels("buttonCancel"), swatches: this._getLocalizedLabels("swatches") } }).data('ejColorPicker');
            this._eTblDialog.appendTo(this._rteWapper);
            var model = this._getDialogModel();
            model.width = "auto";
            model.title = this._getLocalizedLabels("editTable");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            this._eTblDialog.ejDialog(model);
            this._eTblDialog.closest(".e-dialog-wrap").addClass("e-rte e-edittable");
            this.model.showRoundedCorner && this._eTblDialog.find(".e-inputtext").addClass('e-corner-all');
            this._eTblDialog.find(".e-numerictextbox").ejNumericTextbox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", minValue: 0, value: 0, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-dropdown").ejDropDownList({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", showRoundedCorner: this.model.showRoundedCorner });
            this._eTblAlign = this._getTableObj("Align").data('ejDropDownList');
            this._eTblAlign.option('enabled', false);
            this._getTableObj("_Tab").ejTab({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, width: "100%", enabled: true, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblCaption = this._getTableObj("Caption");
            this._eTblCaption.ejCheckBox({ enableRTL: this.model.enableRTL, cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._eTblDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._eTblDialog.find(".e-rte-btn"), "click", this._eTblBtnClick);
            this.model.showRoundedCorner && this._subControlsSetModel();
        },

        _drawTable: function (tableDiv) {
            var rowDiv, tableCell;
            for (var row = 0; row < this.model.tableRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.tableColumns; col++) {
                    tableCell = ej.buildTag("div.e-rte-tablecell e-default");
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
        },


        _renderSourceDialog: function () {
            var proxy = this;
            this._sourceDialog = ej.buildTag("div.e-rte-source#" + this._rteId + "_Source");
            var btnDiv = (this.model.enableRTL) ? "e-rtlrte" : "";
            var content = $("<textarea class='e-rte-srctextarea e-inputtext'></textarea><div class='e-rte-button e-fieldseparate'><button id='src_update' data-role ='none' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogUpdate") + "</button><button id='src_cancel' class='e-rte-btn " + btnDiv + "'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._sourceDialog);
            var model = this._getDialogModel();
            model.title = this._getLocalizedLabels("viewHtml");
            model.width = "auto";
			model.minWidth="330px";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._sourceDialog.ejDialog(model);
			this._sourceDialog.closest(".e-dialog-wrap").addClass("e-rte e-sourcedialog")
            this.model.showRoundedCorner && this._sourceDialog.find(".e-inputtext").addClass('e-corner-all');
            this._sourceDialog.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._sourceDialog.find(".e-rte-btn"), "click", this._srcBtnClick)
        },


        _renderAlertDialog: function () {
            var proxy = this;
            this._alertWindow = ej.buildTag("div#" + this._rteId + "_Alert");
            var content = $("<p class='e-alerttext' style='margin:0.875em 0em;'></p><div class='e-rte-button e-fieldseparate'><button data-role ='none' class='e-rte-btn e-alert-ok' type='button'>" + this._getLocalizedLabels("dialogOk") + "</button><button class='e-rte-btn e-alert-cancel' data-role='none'>" + this._getLocalizedLabels("dialogCancel") + "</button></div>");
            content.appendTo(this._alertWindow);
            var model = this._getDialogModel();
            model.showHeader = false;
            model.width = "auto";
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.close = function () {
                proxy._ieCursorMaintainance();
            };
            model.minHeight = "50px";
            this._alertWindow.ejDialog(model);
            this._alertWindow.closest(".e-dialog-wrap").addClass("e-rte");
            this._alertWindow.find(".e-rte-btn").ejButton({ enableRTL: this.model.enableRTL, type: "button", cssClass: this.model.cssClass, showRoundedCorner: this.model.showRoundedCorner });
            this._on(this._alertWindow.find(".e-rte-btn"), "click", this._alertBtnClick)
            this._alertWindow.find(".e-alert-cancel").hide();
        },

        _alertBtnClick: function (e) {
            if ($.trim(this._alertWindow.find(".e-alerttext").html()) == this._getLocalizedLabels("deleteAlert") && $(e.target).hasClass("e-alert-ok")) {
                this._getDocument().body.innerHTML = " ";
				this._emptyContent();
                if (this.model.showToolbar)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft");
                this._setBackupData();
                this._updateCount();
                var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
                this._updateTagInfo(selectNode);
                this._onChange();
            }
            this._alertWindow.ejDialog("close");
            this._alertWindow.find(".e-alert-cancel").hide();
        },

		_emptyContent: function (){
			var setNode,tempSpanNode = document.createElement("span");
			tempSpanNode.innerHTML = "&#65279;"
			 var range = this._getDocument().createRange(), Selection = this._getDocument().getSelection();
			 this._getDocument().body.firstChild && this._getDocument().body.firstChild.remove();
				this._getDocument().body.appendChild(setNode=this._getDocument().createElement("p"));
				setNode.appendChild(tempSpanNode);
				Selection.removeAllRanges();
                range.setStart(tempSpanNode.firstChild, 0);
                range.setEnd(tempSpanNode.firstChild, 0);
                Selection.addRange(range);
                $(this._getDocument().body).find('p span').remove();
		},
        _openAlert: function (alertText) {
            this._alertWindow.find(".e-alerttext").html(alertText);
            this._alertWindow.ejDialog("instance")._centerPosition();
            $("#" + this._rteId + "_Alert_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._alertWindow.ejDialog("open");
        },


        _renderFormat: function () {
            this._formatDDL = ej.buildTag("input#" + this._rteId + "_formatDDL", "", "", { type: "text", title: this._getLocalizedLabels("format"), "data-role": "none" });
            var defaultText = [
                { text: "paragraph", value: "<p>" },
                { text: "quotation", value: "<blockquote>" },
                { text: "heading1", value: "<h1>" },
                { text: "heading2", value: "<h2>" },
                { text: "heading3", value: "<h3>" },
                { text: "heading4", value: "<h4>" },
                { text: "heading5", value: "<h5>" },
                { text: "heading6", value: "<h6>" }];
            var model = {};
            model.dataSource = this._formatText(this.model.format, defaultText);
            model.width = "105px";
            model.enableRTL = this.model.enableRTL;
            model.popupWidth = "175px";
            model.popupHeight = "auto";
            model.selectedItemIndex = 0;
            model.select = this._formatChange;
            model.cssClass = "e-rte-format-ddl";
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value", spriteCssClass: "spriteCssClass" };
            this._formatDDL.appendTo(this._rteToolbar.find("li.e-rteItem-format").html(""));
            this._formatDDL.ejDropDownList(model);
            this._formatPopupStyle();
        },

        _formatText: function (formatSource, formatText) {
            for (var i = 0; i < formatSource.length; i++)
                for (var j = 0; j < formatText.length; j++)
                    if (formatSource[i].value == formatText[j].value) {
                        formatSource[i].text = this._getLocalizedLabels(formatText[j].text) ? this._getLocalizedLabels(formatText[j].text) : formatSource[i].text;
                        break;
                    }
            return formatSource;
        },

        _formatPopupStyle: function () {
            var _liList = this._formatDDL.data("ejDropDownList").popupPanelWrapper.find("li");
            for (var i = 0; i < _liList.length; i++) {
                $(_liList[i]).addClass(this.model.format[i].spriteCssClass);
            }
        },


        _renderFontStyle: function () {
            this._fontStyleDDL = ej.buildTag("input#" + this._rteId + "_fontNameDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontName"), "data-role": "none" });
            var defaultText = [
				{ text: "timesnewroman", value: "Times New Roman,Times,serif" },
			    { text: "segoeui", value: "Segoe UI" },
				{ text: "arial", value: "Arial,Helvetica,sans-serif" },
				{ text: "couriernew", value: "Courier New,Courier,monospace" },
				{ text: "georgia", value: "Georgia,serif" },
				{ text: "impact", value: "Impact,Charcoal,sans-serif" },
                { text: "lucidaconsole", value: "Lucida Console,Monaco,monospace" },
                { text: "tahoma", value: "Tahoma,Geneva,sans-serif" },
                { text: "trebuchetms", value: "Trebuchet MS,Helvetica,sans-serif" },
                { text: "verdana", value: "Verdana,Geneva,sans-serif" }
            ];
            var model = {};
            model.dataSource = this._formatText(this.model.fontName, defaultText);
            model.enableRTL = this.model.enableRTL;
            model.selectedItemIndex = 0;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontStyleChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontStyleDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontName").html(""));
            this._fontStyleDDL.ejDropDownList(model);
        },


        _renderFontSize: function () {
            this._fontSizeDDL = ej.buildTag("input#" + this._rteId + "_fontSizeDDL", "", "", { type: "text", title: this._getLocalizedLabels("fontSize"), "data-role": "none" });
            var model = {};
            model.dataSource = this.model.fontSize;
            model.width = "100px";
            model.enableRTL = this.model.enableRTL
            model.selectedItemIndex = 2;
			model.htmlAttributes={datafontid:""+this._rteId};
            model.select = this._fontSizeChange;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.fields = { text: "text", value: "value" };
            this._fontSizeDDL.appendTo(this._rteToolbar.find("li.e-rteItem-fontSize").html(""));
            this._fontSizeDDL.ejDropDownList(model);
        },


        _renderFontColor: function () {
            var proxy = this;
            this._fontColorSplit = ej.buildTag("button#" + this._rteId + "_fontColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
            var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["fontColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            this._fontColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
			 var FontColors = $("<div class='customcolor e-rte-customcolor' " + this._TagId("_customcolor") + "><a class='customcolor-link' role='button' title='" + this._getLocalizedLabels("customColor") + "'>" + this._getLocalizedLabels("customFontColor") + "</a></div>");
             _liTemplte.append(FontColors);
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-fontColor"));
			 this._on(FontColors, "click", this._openColorpalette);
            this._fontColorSplit.ejSplitButton(model);
            this._splitObj = this._fontColorSplit.ejSplitButton("instance");
            this._splitObj.option("beforeOpen", function () { proxy._bindClickOperation("FontColor"); });
            this._on(this._fontColorSplit, "click", this._fontColorClick);
            this._fontColorSplit.find("span." + this._rteIconsList["fontColor"]).removeClass("e-icon");
            this._fontColorSplit.find("span.e-btntxt").css("background-color", this._fontColor);
        },
        _renderUnOrderList: function () {
            var proxy = this;
            this._unOrderSplit = ej.buildTag("button#" + this._rteId + "_unorder", "", {}, { type: "button", "data-role": "none" });
            this._unorderLiTemplate = ej.buildTag("ul#" + this._rteId + "_unorderlist", "", { "height": "auto", "width": "84px" }, { "class": "e-rte-unorderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-nonelist-icon'></span></li><li id='disc' title='" + this._getLocalizedLabels("disc") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-disclist-icon'></span></li><li id='square' title='" + this._getLocalizedLabels("square") + "' class='square' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-squarelist-icon'></span></li><li id='circle' title='" + this._getLocalizedLabels("circle") + "' style='float:left;width:50%;'><span class='e-rte-toolbar-icon e-rte-unlistitems e-circlelist-icon'></span></li>").appendTo(this._unorderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customUnorderedList"]))
                $.each(proxy.model.tools["customUnorderedList"], function (i, val) {
                    if (i == 0) $(proxy._unorderLiTemplate).find("#circle,#square").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("ulcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._unorderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.targetID = this._rteId + "_unorderlist";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["unorderedList"];
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.itemSelected = $.proxy(this._onUnorderList, this);
            this._unOrderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-unorderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_unorderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._unorderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-unorderedList") : $('body')));
            this._unOrderSplit.ejSplitButton(model);
            this._unOrderSplitObj = this._unOrderSplit.ejSplitButton("instance");
            this._unOrderSplit.find("span.e-unorderedList-icon").removeClass("e-icon");
            this._on(this._unOrderSplit, "click", this._onUnorderList);
        },
        _renderOrderList: function () {
            var proxy = this;
            this._orderSplit = ej.buildTag("button#" + this._rteId + "_order", "", {}, { type: "button", "data-role": "none" });
            this._orderLiTemplate = ej.buildTag("ul#" + this._rteId + "_orderlist", "", { "height": "auto", "width": "124.05px" }, { "class": "e-rte-orderlistname" });
            $("<li id='none' title='" + this._getLocalizedLabels("none") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-nonelist-icon'></span></li><li id='decimal' title='" + this._getLocalizedLabels("number") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-numbering-icon'></span></li><li id='lower-alpha' title='" + this._getLocalizedLabels("loweralpha") + "'  style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-loweralpha-icon'></span></li><li id='lower-roman' title='" + this._getLocalizedLabels("lowerroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-lowerroman-icon'></span></li><li id='upper-alpha' title='" + this._getLocalizedLabels("upperalpha") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperalpha-icon'></span></li><li id='upper-roman' title='" + this._getLocalizedLabels("upperroman") + "' style='float:left;width:33.33%;'><span class='e-rte-toolbar-icon e-rte-listitems e-upperroman-icon'></span></li>").appendTo(this._orderLiTemplate);
            if (!ej.isNullOrUndefined(proxy.model.tools["customOrderedList"]))
                $.each(proxy.model.tools["customOrderedList"], function (i, val) {
                    if (i == 0) $(proxy._orderLiTemplate).find("#upper-roman,#upper-alpha,#lower-roman").attr("class", "e-liseparator");
                    $("<li id='" + (val["name"] ? val["name"] : ("olcustom" + i)) + "' class='" + (val["css"] ? val["css"] : "") + "' title='" + (val["tooltip"] ? val["tooltip"] : "") + "' style='float:left;width:100%;'>" + (val["text"] ? val["text"] : "") + "</li>").appendTo(proxy._orderLiTemplate);
                });
            var model = {};
            model.width = "42px";
            model.contentType = "imageonly";
            model.enableRTL = this.model.enableRTL;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.targetID = this._rteId + "_orderlist";
            model.prefixIcon = "e-icon e-rte-toolbar-icon " + this._rteIconsList["orderedList"];
            model.itemSelected = $.proxy(this._onOrderList, this);
            this._orderSplit.appendTo(this._rteToolbar.find("li.e-rteItem-orderedList").html(""));
            var oldWrapper = $("#" + this._rteId + "_orderlist").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._orderLiTemplate.appendTo((this._rteToolbar.parents("body").length > 0 ? this._rteToolbar.find("li.e-rteItem-orderedList") : $('body')));
            this._orderSplit.ejSplitButton(model);
            this._orderSplitObj = this._orderSplit.ejSplitButton("instance");
            this._on(this._orderSplit, "click", this._onOrderList);
        },
        _renderBGColor: function () {
            var proxy = this;
            this._bgColorSplit = ej.buildTag("button#" + this._rteId + "_backgroundColorbtn", "", {}, { type: "button", "data-role": "none" });
            var _liTemplte = $("<ul id='" + this._rteId + "_colorBGTable' class='e-rte-colorpalette'><li></li></ul>");
            _liTemplte.find("li").append(this._colorTable());
			var _bgTransparent=$("<button id='"+this._rteId+"_backgroundtransparentbtn'class='e-rte-transbtn' role='button' title='"+this._getLocalizedLabels("TransBGColor")+"'>"+this._getLocalizedLabels("TransBGColor") + "</button>");
			var model = {};
            model.width = "42px";
            model.contentType = "textandimage";
            model.targetID = this._rteId + "_colorBGTable";
            model.enableRTL = this.model.enableRTL;
            model.prefixIcon = this._rteIconsList["backgroundColor"];
            model.showRoundedCorner = this.model.showRoundedCorner;
			var BGColors = $("<div class='customBGcolor e-rte-customcolor' " + this._TagId("_customBGcolor") + "><a class='customcolor-link ' role='button' title='" + this._getLocalizedLabels("customBGColor") + "'>" + this._getLocalizedLabels("customBGColor") + "</a></div>");
             _liTemplte.append(BGColors);
			 this._on(BGColors, "click", this._openColorpalette);
			_bgTransparent.prependTo(_liTemplte);
			this._bgColorSplit.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor").html(""));
            var oldWrapper = $("#" + this._rteId + "_colorBGTable").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            _liTemplte.appendTo(this._rteToolbar.find("li.e-rteItem-backgroundColor"));
            this._bgColorSplit.ejSplitButton(model);
			_bgTransparent.ejButton({width:"100%",contentType:"text",targetID:this._rteId+"_colorBGTable",showRoundercorner:this.model.showRounderCorner});
			this._bgObj=_bgTransparent.ejButton("instance");
			 this._on(_bgTransparent, "click", this._bgTransClick);
            this._bgSplitObj = this._bgColorSplit.ejSplitButton("instance");
            this._bgSplitObj.option("beforeOpen", function () { proxy._bindClickOperation("BGColor"); });
            this._on(this._bgColorSplit, "click", this._bgColorClick);
            this._bgColorSplit.find("span." + this._rteIconsList["backgroundColor"]).removeClass("e-icon");
            this._bgColorSplit.find("span.e-btntxt").css("background-color", this._bgColor);
        },
        _bindClickOperation: function (toolName) {
            var proxy = this, SplitMenu;
            var splitObj = toolName == "BGColor" ? proxy._bgSplitObj : proxy._splitObj;
            var element = toolName == "BGColor" ? "_backgroundColorbtn" : "_fontColorbtn";
			var tblelement=toolName == "BGColor" ? "_colorBGTable" : "_colorTable";
            SplitMenu = $("#" + proxy._rteId + element).ejSplitButton("instance");
            toolName == "BGColor" ? proxy._bgSplitMenu = SplitMenu : proxy._splitMenu = SplitMenu;
            SplitMenu.model.close = function () {
                splitObj.contstatus = false;
                proxy._off($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
            }
            proxy._on($("#" + proxy._rteId + tblelement).find("div.e-rte-palettetable"), "click", toolName == "BGColor" ? proxy._bgColorPaletteClick : proxy._colorPaletteClick);
        },
        _colorTable: function () {
            var tableDiv = ej.buildTag("div.e-rte-table");
            var color = 0, hexCode, rowDiv, tableCell;
            for (var row = 0; row < this.model.colorPaletteRows ; row++) {
                rowDiv = ej.buildTag("div.e-rtetablerow");
                for (var col = 0; col < this.model.colorPaletteColumns ; col++) {
                    if (color < this.model.colorCode.length) {
                        hexCode = "#" + this.model.colorCode[color];
                        tableCell = ej.buildTag("div.e-rte-palettetable", "", { "background-color": hexCode }, { title: hexCode, "color-code": hexCode });
                        tableCell.appendTo(rowDiv);
                        color++;
                    }
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },

        _recalcVideoSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._videoDialog.find(".e-rte-videoX");
            txtheight = this._videoDialog.find(".e-rte-videoY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();
            if (this._chkvideoDimensions.ejCheckBox("isChecked") && !!this._videoWidth && !!this._videoHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._videoWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._videoHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._videoWidth = newWidth;
            this._videoHeight = newHeight;
        },


        _recalcImgSize: function (e) {
            var txtWidth, txtheight, newWidth, newHeight;
            txtWidth = this._imgDialog.find(".e-rte-imgX");
            txtheight = this._imgDialog.find(".e-rte-imgY");

            newWidth = txtWidth.val();
            newHeight = txtheight.val();

            if (this._chkImgDimensions.ejCheckBox("isChecked") && !!this._imgWidth && !!this._imgHeight && !!newWidth && !!newHeight) {
                if (e.target.id == txtWidth[0].id) {
                    newHeight = Math.round((newWidth / this._imgWidth) * newHeight);
                    txtheight.val(newHeight);
                } else {
                    newWidth = Math.round((newHeight / this._imgHeight) * newWidth);
                    txtWidth.val(newWidth);
                }
            }
            this._imgWidth = newWidth;
            this._imgHeight = newHeight;
        },

        _urlValidation: function (e) {
            var _target = $(e.target);
            _target.hasClass("e-error") && _target.removeClass("e-error");
        },
        _ieLinkRange: function () {
            var rang = this._getRange();
            if (!this._isIE() && !this._isIE8()) {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html"
                this._selectionRange = rang;
            }
            else {
                !ej.isNullOrUndefined(this._currentSelNode) && this._currentSelNode.nodeName.toLowerCase() != "html" && rang.setStart(this._currentSelNode, this._currentSelNode.childNodes.length)
                this._selectionRange = rang;
            }
        },
        _ieCursorMaintainance: function () {
            if (!this._isIE8()) {
                this._ieLinkRange();
                this._focus();
            }
            else
                this._setRange(this._currentSelNode, this._getDocument().body.createTextRange(), true);
        },
        _linkBtnClick: function (sender) {
            if (sender.target.id === "link_cancel") {
                this._clearLinkFields();
                this._linkDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === "link_insert") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._restoreSelection(this._selectionRange);
                if (this._txtURL.val() != "")
                    this._onInsertLink();
                else {
                    this._onUnlink();
                    this._linkDialog.ejDialog("close");
                }
                this._trigger("execute", { commandName: "hyperlink" });
                this._onChange();
                this._setBackupData();
            }
        },

        _imageBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_img_cancel") {
                this._imgDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_img_insert") {
                var imageVal = this._imgURL.val().match(/(ftp:|http:|https:)\/\//g);
                if ((ej.isNullOrUndefined(imageVal) && this._imgURL.val() !== "") || (!ej.isNullOrUndefined(imageVal) && imageVal[0].length < this._imgURL.val().length)) {
                    (this.model.maxLength != null && this.model.maxLength > $.trim(this._getText()).length) ? this._onInsertImage() : this._imgDialog.ejDialog("close");
                    this._onChange();
                    this._setBackupData();
                } else {
                    this._imgURL.addClass("e-error");
                    if (!this._isUrl($.trim(this._imageLink.val()))) this._imageLink.addClass("e-error");
                    return false;
                }
            }
        },


        _srcBtnClick: function (sender) {
            if (sender.target.id === "src_update") {
                var _editHTML = $.trim(this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value);
                if (this.model.enableHtmlEncode)
                    _editHTML = this._decode(_editHTML);
                try {
                    this._getDocument().documentElement.innerHTML = _editHTML.replace("<html>", "").replace("</html>", "");
                    if (this.model.enableXHTML)
                        this._getDocument().documentElement.innerHTML = this._updateXhtml();
                }
                catch (e) {
                    var regEX = /<body[^>]*>((.|[\n\r])*)<\/body>/i;
                    if (!ej.isNullOrUndefined(regEX.exec(_editHTML))) {
                        _editHTML = regEX.exec(_editHTML)[1];
                        this._getDocument().body.innerHTML = _editHTML;
                    }
                }
                this._onChange();
                this._updateCount();
            }
            this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = "";
            var _tableEle = $(this._getDocument()).find("table.e-rte-table");
            if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
            this._sourceDialog.ejDialog("close");
            this._showHideContextMenu();
        },

        _eTblBtnClick: function (sender) {
            if (sender.target.id === this._rteId + "_eTbl_cancel") {
                this._eTblDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else if (sender.target.id === this._rteId + "_eTbl_apply") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                this._oneditTable();
                this._onChange();
                this._setBackupData();
            }
        },

        _insertCustomTable: function (sender) {
            this._customTableValidation = false;
            if (sender.target.id === "insert") {
                var cols = this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("getValue");
                var row = this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("getValue");
                var height = this._customInputValidation(this._customTableDialog.find(".e-rte-txtHeight"));
                var width = this._customInputValidation(this._customTableDialog.find(".e-rte-txtWidth"));
                var align = this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("getSelectedValue");
                var spacing = this._customInputValidation(this._customTableDialog.find(".e-rte-txtSpacing"));
                var padding = this._customInputValidation(this._customTableDialog.find(".e-rte-txtPadding"));
                var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("getSelectedValue");
                var caption = this._chkTblCaption.ejCheckBox("isChecked");
                if (!this._customTableValidation) {
                    if (!ej.isNullOrUndefined(this._tableInsertAt) && !ej.isNullOrUndefined(this._tableInsertAt.startContainer))
                        this._restoreSelection(this._tableInsertAt);
                    var tableEle = this._tableGenerator(row, cols, false, width, height, spacing, padding, align, border, caption);
                    this.executeCommand('inserthtml', tableEle);
                    var _tableEle = $(this._getDocument()).find("table.e-rte-table");
                    var drpDwnObj = this._customTableDialog.find(".e-rte-ddlAlignment").data("ejDropDownList");
                    if (drpDwnObj.option('value') == "Center")
                        _tableEle.attr('style', "margin: 0 auto");
                    if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
                    this._onChange();
                    drpDwnObj.option({ value: "", enabled: false });
                }
                this._on(this._customTableDialog.find(".e-rte-txtHeight"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtWidth"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtSpacing"), "keypress", this._urlValidation)
				._on(this._customTableDialog.find(".e-rte-txtPadding"), "keypress", this._urlValidation);

            }
            if (!this._customTableValidation) {
                this._customTableDialog.ejDialog("close");
                this._clearTableFields();
                this._ieCursorMaintainance();
            }
        },

        _customInputValidation: function (validation) {
            var value = validation.val().toLowerCase();
            var lastPos = value.substr(value.length - 2, 2);
            var specChar = value.match(/[!@#$%^&*()_+\-=\[\]{};':"\\|,<>\/?]/gi);
            var alphaChar = value.match(/[a-z]/gi);
            if (((!isNaN(value) && (specChar == null || specChar.length == 0)) || (value.length > 1 && value.substr(value.length - 1, 1) == "%" && specChar.length == 1) && (alphaChar == null || alphaChar.length == 0)) || (value.length > 2 && (specChar == null || specChar.length == 0) && (alphaChar != null && alphaChar.length == 2) && (lastPos == "px" || lastPos == "in" || lastPos == "cm" || lastPos == "mm" || lastPos == "em" || lastPos == "ex" || lastPos == "pt" || lastPos == "pc")))
                return value;
            else {
                validation.addClass("e-error");
                this._customTableValidation = true;
                return 0;
            }
        },

        _clearTableFields: function () {
            this._customTableDialog.find(".e-rte-txtColumns").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtRows").ejNumericTextbox("option", "value", 3);
            this._customTableDialog.find(".e-rte-txtHeight").val("");
            this._customTableDialog.find(".e-rte-txtWidth").val("");
            this._customTableDialog.find(".e-rte-ddlAlignment").ejDropDownList("clearText");
            this._customTableDialog.find(".e-rte-txtSpacing").val("");
            this._customTableDialog.find(".e-rte-txtPadding").val("");
            var border = this._customTableDialog.find(".e-rte-txtBorder").ejDropDownList("clearText");
            var caption = this._chkTblCaption.ejCheckBox({ check: false });
        },

        _clearEditTableFields: function () {
            this._eTblHeight = this._eTblDialog.find("input").val("");
            this._eTblDialog.find(".e-numerictextbox").data("ejNumericTextbox").option("value", "");
            this._eTblDialog.find(".e-rte-dropdown").data("ejDropDownList").option("value", "");
            this._eTblAlign.disable();
            this._eTblCaption.ejCheckBox({ check: false });
        },

        _clearLinkFields: function () {
            this._txtURL = this._linkDialog.find(".e-rte-linkUrl");
            this._txtURL.removeClass("e-error");
            this._txtURL.val("http://");
            this._txtLinkText = this._linkDialog.find(".e-rte-linkText");
            this._txtLinkText.val("");
            this._txtLinkTitle = this._linkDialog.find(".e-rte-linkTitle");
            this._txtLinkTitle.val("");
            this._chkTarget.ejCheckBox({ check: false });
            this._txtURL.focus();
        },
        _textFieldFocus: function (ele, start, end) {
            if (!this._isIE8()) ele.setSelectionRange(start, end);
            else {
                var range = ele.createTextRange();
                range.collapse(true);
                range.moveEnd('character', start);
                range.moveStart('character', end);
                range.select();
            }
        },
        _clearImgFields: function () {
            this._imgURL = this._imgDialog.find(".e-rte-imgUrl").val("http://").removeClass("e-error");
            this._imgDialog.find(".e-rte-imgText").val("");
            this._chkImgDimensions.ejCheckBox({ checked: true });
            this._imageLink = this._imgDialog.find(".e-rte-imgLink");
            this._imageLink.removeClass("e-error");
            this._imageLink.val("");
            this._imageBorderPx = this._imgDialog.find(".e-rte-imgBorderPx").data('ejNumericTextbox');
            this._imageBorderPx.option('value', 0);
            this._imageBorderStyle = this._imgDialog.find(".e-rte-imgBorderStyle").data('ejDropDownList');
            this._imageBorderStyle.option('value', "");
            this._imgPicker.option('value', null);
            this._imgDialog.find('.e-selected-color').removeAttr('style');
            this._imageStyle = this._imgDialog.find(".e-rte-imgStyle");
            this._imageStyle.val("");
            this._dialogchkTarget.ejCheckBox({ check: false });
        },

        _videoManager: function () {
            this._renderVideoDialog();
            var selectNode = this._getSelectedNode();
            this._editVideo = null;
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode.tagName)) {
                this._editVideo = selectNode;
                this._videoWidth = parseInt($(selectNode).width());
                this._videoHeight = parseInt($(selectNode).width());
                if (this.model.showDimensions) {
                    this._videoDialog.find(".e-rte-videoX").val(this._videoWidth);
                    this._videoDialog.find(".e-rte-videoY").val(this._videoHeight);
                }
            }
            $("#" + this._rteId + "_video_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._videoDialog.ejDialog("open");
            this._videoDialog.find("textarea.e-rte-video").focus();
        },

        _sourceCodeManager: function () {
            ej.isNullOrUndefined(this._sourceDialog) && this._renderSourceDialog();
            this._updateTagInfo("body");
            this._hideTooltip();
            if (!ej.isNullOrUndefined(this._getDocument().documentElement)) {
                this._sourceDialog.find("textarea.e-rte-srctextarea")[0].value = (this.model.enableHtmlEncode) ? this._encode(this._getDocument().documentElement.outerHTML) : this._getDocument().documentElement.outerHTML;
                $("#" + this._rteId + "_Source_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._sourceDialog.ejDialog("open");
                this._sourceDialog.find("textarea.e-rte-srctextarea").focus();
            }
            else
                this._htmlSource.addClass("e-disable");
        },
        _getPasteRangeVal: function () {
            if (this._isIE()) {
                this._pasteRangeVal = this._getRange();
                this._pasteFlag = true;
            }
        },
        _hyperLinkManager: function (filebrowser) {
            this._renderLinkDialog();
            filebrowser && this._renderFileBrowserDialog();
            this._getPasteRangeVal();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();

            this._selectedHTML = (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? this._pasteRangeVal.toString() : this._getSelText();
            if (filebrowser) {
                this._clearFileFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._fileLinkText.val($(selectNode).html()) : this._fileLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_fileDialog_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._fileDialog.ejDialog("open");
            }
            else {
                this._clearLinkFields();
                (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toUpperCase() == 'A') ? this._txtLinkText.val($(selectNode).html()) : this._txtLinkText.val(this._selectedHTML);
                $("#" + this._rteId + "_link_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._linkDialog.ejDialog("open");
                this._textFieldFocus(this._txtURL[0], this._txtURL.val().length, this._txtURL.val().length);
            }

            if (selectNode && !(/^(A)$/).test(selectNode.nodeName)) {
                if (selectNode.tagName.toUpperCase() == "IMG")
                    selectNode = $(selectNode).parent('a')[0];
            }
            if (filebrowser) {
                if (selectNode && (/^(A)$/).test(selectNode.nodeName)) this._fileURL.val(selectNode.href);
            }
            else if (selectNode && (/^(A)$/).test(selectNode.nodeName)) {
                this._txtURL.val(selectNode.href);
                this._txtLinkTitle.val(selectNode.title);
            }
        },
        _tableManager: function () {
            var tableLi = this._rteToolbar.find("li.e-rteItem-createTable"), Xpos, Ypos;
            this._getPasteRangeVal();
            if (this._getSelectedNode().nodeName.toLowerCase() == "td")
                this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
            if (this.model.isResponsive && tableLi.length == 0) {
                var border = $(this._toolBarObj._liTemplte).outerHeight() - $(this._toolBarObj._liTemplte).height();
                tableLi = this._toolBarObj._liTemplte.find("li.e-rteItem-createTable");
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "hidden", "display": "block" });
                Ypos = ($(this._toolBarObj._liTemplte).offset().top + $(this._toolBarObj._liTemplte).outerHeight() + border - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().top);
                if($(tableLi).offset().left>230)
                   Xpos = ($(tableLi).offset().left - $("#" + this._rteId + "_table_wrapper").offsetParent().offset().left);
				else
				   Xpos =$("#" + this._rteId + "_table_wrapper").offsetParent().offset().left;
                $("#" + this._rteId + "_table_wrapper").css({ "visibility": "visible" });
            }
            else
                Xpos = $(tableLi).position().left, Ypos = $(tableLi).position().top + tableLi.height() + 7;
            if (((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > document.body.clientWidth) || ((parseInt(Xpos) + parseInt($("#" + this._id + "_table_wrapper").css("width"))) > parseInt($("#" + this._id + "_wrapper").css("width")) + $("#" + this._id + "_wrapper").position().left)) Xpos = (parseInt(Xpos) - (parseInt($("#" + this._id + "_table_wrapper").css("width")) - $(tableLi).width())) + "px";
            var top = (document.documentElement && document.documentElement.scrollTop) || document.body.scrollTop;
            if (top < Ypos && $(window).height() < (Ypos - top + parseInt($("#" + this._id + "_table_wrapper").css("height"))))
                Ypos = (parseInt($("#" + this._id + "_table_wrapper").css("height")) > $(window).height()) ? top : ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height"))) > 0 ? ($(window).height() - parseInt($("#" + this._id + "_table_wrapper").css("height")) + top) : top;
            var parentOffset=this._rteWapper.offset();
		    Xpos=parseInt(Xpos)-parseInt(parentOffset["left"]);
			Ypos=parseInt(Ypos)-parseInt(parentOffset["top"]);
			this._createTable.ejDialog("option", "position", { X: Xpos, Y: Ypos });
            this._createTable.ejDialog("open");
            this._on(ej.getScrollableParents(this._createTable), "scroll", function () {
                this._createTable.ejDialog("close");
            });
        },
        _eTblManager: function () {
            this._renderEditTableDialog();
            this._clearEditTableFields();
            var rteID = this._rteId;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            if (!ej.isNullOrUndefined(selectNode) && selectNode.tagName.toLowerCase() === "td") {
                var parentTable = $(selectNode).closest('tbody').closest('table');
                this._getTableObj("Height").val($(parentTable).height());
                this._getTableObj("Width").val($(parentTable).width());
                if (!ej.isNullOrUndefined(parentTable[0])) {
                    this._getTableObj("CellSpace").data('ejNumericTextbox').option('value', parentTable[0].cellSpacing);
                    this._getTableObj("CellPad").data('ejNumericTextbox').option('value', parentTable[0].cellPadding);
                    var align = parentTable[0].align;
                }
                if (!ej.isNullOrUndefined(align) && align != "") {
                    this._eTblAlign.enable();
                    this._eTblAlign.option('value', align);
                }
                var captionEle = $($(selectNode).closest('tbody')).prev('caption');
                if (captionEle.length > 0)
                    this._eTblCaption.ejCheckBox({ checked: true });
                if (!ej.isNullOrUndefined(parentTable[0]) && parentTable[0].style != "") {
                    this._getTableObj("BrdrPx").data('ejNumericTextbox').option('value', parentTable[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("_border_style").data('ejDropDownList');
                    (parentTable[0].style.borderStyle != "") ? obj.selectItemByValue(parentTable[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("_border_color").val(parentTable[0].style.borderColor);
                }
                this._getTableObj("Style").val(parentTable.attr('style'));


                var parentRow = $(selectNode).closest('tr');
                this._getTableObj("RHeight").val($(parentRow).height());
                this._getTableObj("RAlign").data('ejDropDownList').option('value', parentRow[0].style.textAlign);
                if (parentRow[0].style != "") {
                    this._getTableObj("RBrdrPx").data('ejNumericTextbox').option('value', parentRow[0].style.borderWidth.split('px')[0]);
                    var obj = this._getTableObj("RBrdrStyle").data('ejDropDownList');
                    (parentRow[0].style.borderStyle != "") ? obj.selectItemByValue(parentRow[0].style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("RBrdrColor").val(parentRow[0].style.borderColor);
                }
                this._getTableObj("RStyle").val(parentRow.attr('style'));
                this._getTableObj("ClWidth").val($(selectNode).width());
                this._getTableObj("ClAlign").data('ejDropDownList').option('value', selectNode.style.textAlign);
                if (selectNode.style != "") {
                    this._getTableObj("ClBrdrPx").data('ejNumericTextbox').option('value', selectNode.style.borderLeftWidth.split('px')[0]);
                    var obj = this._getTableObj("ClBrdrStyle").data('ejDropDownList');
                    (selectNode.style.borderStyle != "") ? obj.selectItemByValue(selectNode.style.borderStyle) : obj.option({ selectedItemIndex: 0 });
                    this._getTableObj("ClBrdrColor").val(selectNode.style.borderColor);
                }
                this._getTableObj("ClStyle").val($(selectNode).attr('style'));
            }
        },

        _getTableObj: function (value) {
            return this._eTblDialog.find('#' + this._rteId + "_eTbl" + value);
        },

        _imageManager: function () {
            this._renderImageDialog();
            this._clearImgFields();
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._getPasteRangeVal();
            if (selectNode && !ej.isNullOrUndefined(selectNode)) {
                this._imgWidth = parseInt($(selectNode).width());
                this._imgHeight = parseInt($(selectNode).height());
                if (this.model.showDimensions) {
                    this._imgDialog.find(".e-rte-imgX").val(this._imgWidth);
                    this._imgDialog.find(".e-rte-imgY").val(this._imgHeight);
                }
                var linkNode = $(selectNode).parent('a');
                if (linkNode.length > 0)
                    this._imageLink.val(linkNode.attr('href'));
                if (selectNode.tagName.toLowerCase() === "img") {
                    this._imgDialog.find(".e-rte-imgUrl").val(selectNode.src);
                    this._imgDialog.find(".e-rte-imgText").val(selectNode.alt);
                    if (selectNode.style != "") {
                        this._imageBorderPx.option('value', selectNode.style.borderWidth.split('px')[0]);
                        this._imageBorderStyle.option('value', selectNode.style.borderStyle);
                        if (selectNode.style.borderColor.length > 0) {
                            if (ej.browserInfo().name === "msie" && ej.browserInfo().version === "8.0") this._imgPicker.option('value', selectNode.style.borderColor);
                            else {
                                var colorCode = selectNode.style.borderColor.split("(")[1].split(")")[0];
                                colorCode = colorCode.split(",");
                                colorCode = { r: $.trim(colorCode[0]), g: $.trim(colorCode[1]), b: $.trim(colorCode[2]) };
                                this._imgPicker.option('value', this._imgPicker.RGBToHEX(colorCode));
                            }
                        }
                    }
                    this._imageStyle.val($(selectNode).attr('style'));
                }
            }
            $("#" + this._rteId + "_Image_wrapper").css({ "z-index": this._onGetMaxZindex() });
            this._imgDialog.ejDialog("open");
            this._textFieldFocus(this._imgURL[0], this._imgURL.val().length, this._imgURL.val().length);
            if (ej.isNullOrUndefined(this._explorerObj)) this._imgDialog.find(".e-rte-imgUrl").focus();
        },
        _getValidbrowser: function (name) {
            switch (name) {
                case "chrome":
                    return ej.browserInfo().version < 42
                    break;
                case "mozilla":
                    return ej.browserInfo().version < 41
                    break;
                case "opera":
                    return ej.browserInfo().version < 29
                    break;
                default:
                    return true;
                    break;
            }
        },
        _alertHeader: function (rteInstcne) {
            rteInstcne._alertWindow.ejDialog("option", "showHeader", false);
            this.model.enableRTL && !this._alertWindow.find(".e-alert-ok").hasClass("e-rte-alertBtnRTL") && this._alertWindow.find(".e-alert-ok").addClass("e-rte-alertBtnRTL");
            rteInstcne._alertWindow.find(".e-rte-button").css({ "text-align": "", "padding-bottom": "", "padding-top": "" }).addClass("e-fieldseparate");
            rteInstcne._alertWindow.ejDialog("instance").refresh();
        },
        _toolBarClick: function (sender) {
            if (sender.event && ((sender.event.which && sender.event.which == 3) || (sender.event.button && sender.event.button == 2)))
                return;
            var $rteEle = $(this.itemsContainer).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
            var _itemId = ej.isNullOrUndefined(rteId) ? sender.currentTarget.id.replace("_", "") : sender.currentTarget.id.replace(rteId + "_", "");
            rteInstcne._alertHeader(rteInstcne);
            if (ej.browserInfo().name === "mozilla") rteInstcne._getDocument().designMode = "off";
            if ($(sender.currentTarget).hasClass("e-rteItem-copy") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("copyAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-cut") && !rteInstcne._isIE() && rteInstcne._getValidbrowser(ej.browserInfo().name))
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("cutAlert"));
            else if ($(sender.currentTarget).hasClass("e-rteItem-paste") && !rteInstcne._isIE())
                rteInstcne._openAlert(rteInstcne._getLocalizedLabels("pasteAlert"));
            else {
                if (ej.browserInfo().name != "chrome") {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0 && $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).hasClass("e-active"))
                        rteInstcne._selectCommand(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
                    var commandName = $.grep(sender.currentTarget.children[0].className.split(/\s+/), function (a) {
                        return !/^e-(rteItem|rte-toolbar-icon)$/i.test(a)
                    });
                if (commandName.indexOf("e-split") >= 0 || commandName.indexOf("e-ddl") >= 0)
                    commandName[0] = _itemId;
                rteInstcne._selectCommand(commandName[0]);
            }

            if (rteInstcne._styleItems.indexOf(_itemId) >= 0 || rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                if (rteInstcne._scriptsItems.indexOf(_itemId) >= 0) {
                    var index = rteInstcne._scriptsItems.indexOf(_itemId);
                    $("#" + rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                    this.deselectItemByID(rteId + "_" + rteInstcne._scriptsItems[index == 0 ? 1 : 0]);
                }
            }


            else if (rteInstcne._alignItems.indexOf(_itemId) >= 0) {
                this.selectItemByID(sender.currentTarget.id);
                var index = rteInstcne._alignItems.indexOf(_itemId)
                for (var i = 0; i < rteInstcne._alignItems.length; i++) {
                    if (i != index)
                        this.deselectItemByID(rteId + "_" + rteInstcne._alignItems[i]);
                }
            }

            else if (rteInstcne._listItems.indexOf(_itemId) >= 0) {
                if (!$(sender.currentTarget).hasClass("e-isactive"))
                    this.selectItemByID(sender.currentTarget.id);
                else
                    this.deselectItemByID(sender.currentTarget.id);
                $(sender.currentTarget).hasClass("e-isactive") ? $(sender.currentTarget).removeClass("e-isactive") : $(sender.currentTarget).addClass("e-isactive");
                var index = rteInstcne._listItems.indexOf(_itemId);
                $("#" + rteId + "_" + rteInstcne._listItems[index == 0 ? 1 : 0]).removeClass("e-isactive");
                if (index == 0)
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[1]);
                else
                    this.deselectItemByID(rteId + "_" + rteInstcne._listItems[0]);
            }
        },

        _toggleEditTable: function () {
            if (this._isIE8())
                this._getRange().parentElement&& (this._currentSelNode = this._getRange().parentElement());
            var isTable = $(this._getSelectedNode()).closest("table");
            var selTag = (isTable.length > 0) ? isTable[0] : this._getSelectedNode(), _eTblItems;
            if (ej.isNullOrUndefined(selTag)) return false;
            if (!ej.isNullOrUndefined(this._toolBarItems)) {
                var items = this._rteToolbar.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (this.model.isResponsive && items.length == 0)
                    _eTblItems = this._toolBarObj._liTemplte.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                else _eTblItems = this._toolBarItems.find("li.e-rteItem-addColumnLeft,li.e-rteItem-addColumnRight,li.e-rteItem-addRowAbove,li.e-rteItem-addRowBelow,li.e-rteItem-deleteRow,li.e-rteItem-deleteColumn,li.e-rteItem-deleteTable");
                if (!ej.isNullOrUndefined(selTag.tagName)) {
                    if (selTag && selTag.tagName && selTag.tagName.toLowerCase() == "td" || selTag.tagName.toLowerCase() == "table" || selTag.tagName.toLowerCase() == "tr") {
                        _eTblItems.show();
                        this._createTable && this._createTable.find("div.e-rte-eTblProperties").removeClass('e-disable');
                    }
                    else if (!ej.isNullOrUndefined(this._createTable)) {
                        _eTblItems.hide();
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                }
            }
            if (this.model.isResponsive && this.model.showToolbar) this._toolBarObj._reSizeHandler();
            if (!this.model.autoHeight ||(this._toolBarObj && $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length))
                this._setIframeHeight();
        },


        _formatChange: function (args) {
            if (args.isInteraction) {
                var $rteEle = $(this.element).closest("div.e-rte").find("textarea.e-rte"), rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                args.value !== "" && rteInstcne._onFormatBlock(args.value);
                rteInstcne._isIE() && rteInstcne._focus();
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }

        },


        _fontStyleChange: function (args) {
            if (args.isInteraction) {
			     var $rteEle;
               (this.element.closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = this.element.closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontName(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _fontSizeChange: function (args) {
            if (args.isInteraction) {
                var $rteEle;
               (this.element.closest("div").hasClass("e-normal"))? $rteEle = $("textarea#"+args.model.htmlAttributes.datafontid):$rteEle = this.element.closest("div.e-rte").find("textarea.e-rte");
				var rteInstcne = $rteEle.ejRTE("instance"), rteId = $rteEle.attr('id');
                rteInstcne._focus();
                args.value !== "" && rteInstcne._onFontSize(args.value);
                rteInstcne._onChange();
				rteInstcne._setBackupData();
            }
        },


        _colorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onFontColor(value);
                this._splitMenu.hide(e);
                this._fontColor = value;
                this._fontColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },


        _bgColorPaletteClick: function (e) {
            var value;
            if ((value = e.target.getAttribute('color-code'))) {
                this._focus();
                this._onBGColor(value);
                this._bgSplitMenu.hide(e);
                this._bgColor = value;
                this._bgColorSplit.find("span.e-btntxt").css("background-color", value);
				this._onChange();
				this._setBackupData();
            }
        },

        _fontColorClick: function (e) {
            this._onFontColor(this._fontColor);
            if (ej.isNullOrUndefined(this._splitMenu)) return false;
            this._splitMenu.hide(e);
        },

		_bgTransClick:function(e)
		{
		    this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, "transparent");
            this._trigger("execute", { commandName: "backColor" });
			this._bgColorSplit.find("span.e-btntxt").css("background-color", "transparent");
		    if (!ej.isNullOrUndefined(this._bgSplitMenu));
            this._bgSplitMenu.hide(e);
			this._bgColor="transparent";
		},
        _bgColorClick: function (e) {
            this._onBGColor(this._bgColor);
            if (ej.isNullOrUndefined(this._bgSplitMenu)) return false;
            this._bgSplitMenu.hide(e);
        },

        _selectCommand: function (selectedId) {
			$(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline","");
                if (ej.browserInfo().name != "edge" && !(selectedId == "format" || selectedId == "fontName" || selectedId == "fontSize" || selectedId == "fontColor" || selectedId == "backgroundColor" || selectedId == "createTable" )) {
                this._focus();
            }
            switch (selectedId) {
                case "fullScreen":
                    this._onFullScreen();
                    break;
                case "print":
                    this._onPrint();
                    break;
                case "import":
                    this._onImport();
                    break;
                case "wordExport":
                    this._onExportToWord();
                    break;
                case "pdfExport":
                    this._onExportToPdf();
                    break;
                case "findAndReplace":
                    if (ej.RTE.FindAndReplace)
                        this._showFindAndReplace();
                    break;
                case "bold":
                    this._onBold();
                    break;
                case "italic":
                    this._onItalics();
                    break;
                case "underline":
                    this._onUnderLine();
                    break;
                case "strikethrough":
                    this._onStrikeThrough();
                    break;
                case "justifyLeft":
                    this._onJustifyLeft();
                    break;
                case "justifyRight":
                    this._onJustifyRight();
                    break;
                case "justifyCenter":
                    this._onJustifyCenter();
                    break;
                case "justifyFull":
                    this._onJustifyFull();
                    break;
                case "cut":
                    this._onCut();
                    break;
                case "copy":
                    this._onCopy();
                    break;
                case "paste":
                    this._onPaste();
                    break;
                case "clearFormat":
                    this._onClearFormat();
                    break;
                case "clearAll":
                    this._clearAllManager();
                    break;
                case "orderedList":
                case "unorderedList":
                    this._getPasteRangeVal();
                    break;
                case "undo":
                    this._undo();
                    break;
                case "redo":
                    this._redo();
                    break;
                case "indent":
                    this._onIndent();
                    this._indentdepth++;
                    break;
                case "outdent":
                    this._onOutdent();
                    if (this._indentdepth > 0)
                        this._indentdepth--;
                    break;
                case "createLink":
                    this._hyperLinkManager(false);
                    break;
                case "removeLink":
                    this._onUnlink();
                    break;
                case "image":
                    this._imageManager();
                    break;
                case "createTable":
                    (!this._createTable.ejDialog("isOpen")) ? this._tableManager() : this._createTable.ejDialog("close");
                    break;
                case "addRowAbove":
                    this.insertRow(true);
                    break;
                case "addRowBelow":
                    this.insertRow(false);
                    break;
                case "addColumnLeft":
                    this.insertColumn(true);
                    break;
                case "addColumnRight":
                    this.insertColumn(false);
                    break;
                case "deleteRow":
                    this.removeRow();
                    break;
                case "deleteColumn":
                    this.removeColumn();
                    break;
                case "deleteTable":
                    this.removeTable();
                    break;
                case "superscript":
                    this._onSuperScript();
                    break;
                case "subscript":
                    this._onSubScript();
                    break;
                case "upperCase":
                    this._onUpperCase();
                    break;
                case "lowerCase":
                    this._onLowerCase();
                    break;
                case "video":
                    this._videoManager();
                    break;
                case "fileBrowser":
                    this._hyperLinkManager(true);
                    break;
                default:
                    this._onChange();
                    break;
            }
            if (selectedId != "createLink" && selectedId != "image" && selectedId != "video" && selectedId != "createTable") {
                this._onChange();
            }
            if ((selectedId != "undo") && (selectedId != "redo"))
                this._setBackupData();
            var selectEle = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            this._updateTagInfo(selectEle);
        },
        _focus: function () {
          var  browserInfo = ej.browserInfo();
            if (browserInfo.name == "webkit")
                this._getWindow().focus();
            else
                this._getWindow().document.body.focus();
            this._restoreSelection(this._selectionRange);
        },
        _getWindow: function () {
            var iframe = $($(this._rteWapper.find(".content-iframe"))[0].contentWindow)[0];
            return iframe;
        },
        _getDocument: function () {
            var iframe = this._rteWapper.find(".content-iframe");
            try {
                return iframe.contents()[0];
            }
            catch (err) {
                return "";
            }
        },
        _onFullScreen: function () {
            if (!$(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).length) {
                this._rteOffset = $(this._rteWapper).position();
                this._rtePosition = $(this._rteWapper).css("position");
                $(this._rteWapper).css({ "top": "0px", "left": "0px", "width": "100%", "height": "100%", "position": "fixed", "z-index": this._onGetMaxZindex() });
                $("body").css("overflow", "hidden");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["maximize"])).removeClass(this._rteIconsList["maximize"]).addClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("resize"));
            }
            else {
                $(this._rteWapper).css({ "top": this._rteOffset.top, "left": this._rteOffset.left, "width": this._rteWidth, "height": this._rteHeight, "position": this._rtePosition, "z-index": "" });
                $("body").css("overflow", "");
                $(this._toolBarObj.itemsContainer.find("." + this._rteIconsList["resize"])).addClass(this._rteIconsList["maximize"]).removeClass(this._rteIconsList["resize"]).parent("li").attr("data-content", this._getLocalizedLabels("maximize"));
            }
            if ($(this._getDocument()).find("table.e-rte-table").length > 0) this._removeResizeObject();
            this._setAutoHeight();
            if (this.model.showToolbar && this.model.isResponsive) this._toolBarObj._reSizeHandler();
            this._setIframeHeight();
            if (!ej.isNullOrUndefined(this._createTable))
                this._createTableClose();
        },
        _onGetMaxZindex: function () {
            return Math.max.apply(null,
                  $.map($('body *'), function (e, n) {
                      return parseInt($(e).css('z-index')) + 1 || 1;
                  }));
        },
        _onZooming: function (_proxy) {
            _proxy._zoomValue = 0;
            var size = Number(_proxy.getDocument().body.style.zoom == "" || ej.isNullOrUndefined(_proxy.getDocument().body.style.zoom) ? 1 : _proxy.getDocument().body.style.zoom);
            var zoomStep = (isNaN(_proxy.model.zoomStep) && _proxy.model.zoomStep.indexOf("%") != -1) ? parseInt(_proxy.model.zoomStep) / 100 : Number(_proxy.model.zoomStep);
            _proxy._zoomValue = (_proxy._zoomArgs == "IN") ? size + zoomStep : ((size - zoomStep) > 0.1) ? size - zoomStep : 0.1;
            $(_proxy.getDocument().body).css({ "zoom": _proxy._zoomValue, "transform": "scale(" + _proxy._zoomValue + ")", "transform-origin": "0 0", "-o-transform": "scale(" + _proxy._zoomValue + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + _proxy._zoomValue + ")", "-webkit-transform-origin": "0 0" });
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " " + Math.round(_proxy._zoomValue * 100) + "%");
            if (_proxy._isIE()) return _proxy;
        },
        _onKeyZoom: function (args) {
            var _proxy = this;
            this._mouseStillDown = true;
            this._zoomArgs = args;
            this._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onPrint: function () {
            var _proxy = this;
            if (this._isIE() || ej.browserInfo().name === "mozilla") this._getWindow().onafterprint = function () { $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" }); };
            else _proxy._getWindow().matchMedia('print').addListener(function (args) {
                if (!args.matches) $(_proxy.getDocument().body).css({ "zoom": ((_proxy._zoomValue) ? _proxy._zoomValue : 1), "transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "transform-origin": "0 0", "-o-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-o-transform-origin": "0 0", "-webkit-transform": "scale(" + ((_proxy._zoomValue) ? _proxy._zoomValue : 1) + ")", "-webkit-transform-origin": "0 0" });
            });
            $(_proxy.getDocument().body).css({ "zoom": "", "transform": "", "-o-transform": "", "-webkit-transform": "" });
            this._getWindow().print();
        },
        _renderimport: function () {
            var divEle = ej.buildTag("div#" + this._id + "_importUpload", "", "", ""), url = this.model.importSettings.url + "?rteid=" + this._id;
            this._rteToolbar.find("li.e-rteItem-import").append(divEle);
            divEle.ejUploadbox({
                multipleFilesSelection: false, width: "0px", height: "0px", autoUpload: true, extensionsAllow: ".docx,.doc", showBrowseButton: false, buttonText: { browse: this._id }, showFileDetails: false, saveUrl: url,
                success: function (args) {
                    var rteID = args.model.buttonText.browse, rteObj = $("#" + rteID).data("ejRTE"), htmlText = args.responseText, iframe = $(rteObj._getDocument().body);
                    htmlText = htmlText.replace('<string xmlns="http://schemas.microsoft.com/2003/10/Serialization/">', '').replace('</string>', '').replace(/"/gi, '');
                    iframe.children().remove();
                    iframe.append($.parseHTML(htmlText));
                }
            });
            divEle.addClass("e-browse-hide");
        },
        _onImport: function () {
            this._toolBarItems.find("div#" + this._id + "_importUpload").find('input[type=file]').trigger("click");
			if(this.model.isResponsive)$("div#" + this._id + "_toolbar_hiddenlist").find("div#" + this._id + "_importUpload").find('input[type=file]').trigger("click"); 
        },
        _onExportToWord: function () {
            var str = this._getDocument().body, url = this.model.exportToWordSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToWordSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _onExportToPdf: function () {
            var str = this._getDocument().body, url = this.model.exportToPdfSettings.url, htmlText = str.innerHTML, formAttr = { action: url + "?rteid=" + this._id, method: "post" }, formEle = ej.buildTag("form", "", null, formAttr), textAttr = { name: this._id + "_inputVal", type: "hidden", value: htmlText }, textEle = ej.buildTag("input", "", null, textAttr), textAttr2 = { name: this._id + "_inputFile", type: "hidden", value: this.model.exportToPdfSettings.fileName }, textEle2 = ej.buildTag("input", "", null, textAttr2);
            $("body").append(formEle.append(textEle).append(textEle2));
            formEle.submit();
            formEle.remove();
        },
        _zoomUp: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            if (this._setInterval) {
                this._mouseStillDown = false;
                clearInterval(this._setInterval);
                this._setInterval = null;
            }
        },
        _zoomDown: function (e) {
            if (e && ((e.which && e.which == 3) || (e.button && e.button == 2)))
                return;
            var _proxy = this;
            _proxy._mouseStillDown = true;
            _proxy._zoomArgs = $(e.target).hasClass("e-rte-toolbar-icon zoomIn " + this._rteIconsList["zoomIn"]) || $(e.target).hasClass("e-rteItem-zoomIn") ? "IN" : "OUT";
            if (e.type == "mousedown") _proxy._setInterval = setInterval(function () { _proxy._onZooming(_proxy); }, 100);
            else _proxy._setInterval = setInterval(_proxy._onZooming(_proxy), 100);
        },
        _onBold: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('bold', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.bold, null);
                this._trigger("execute", { commandName: "bold" });
            }
        },

        _onItalics: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('italic', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.italic, null);
                this._trigger("execute", { commandName: "italic" });
            }

        },
        _onStrikeThrough: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('strikethrough', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.strikethrough, null);
                this._trigger("execute", { commandName: "strikethrough" });
            }
        },

        _onUnderLine: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('underline', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.underline, null);
                this._trigger("execute", { commandName: "underline" });
            }
        },

        _onJustifyLeft: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyLeft', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyleft, null);
                this._trigger("execute", { commandName: "JustifyLeft" });
            }
        },

        _onJustifyRight: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyRight', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyright, null);
                this._trigger("execute", { commandName: "JustifyRight" });
            }
        },

        _onJustifyCenter: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('JustifyCenter', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifycenter, null);
                this._trigger("execute", { commandName: "JustifyCenter" });
            }
        },

        _onJustifyFull: function () {
            this._alignFlag = true;
            if (this._isIE8())
                this.executeCommand('justifyfull');
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.justifyfull, null);
                this._trigger("execute", { commandName: "justifyfull" });
            }
        },

        _onCut: function () {
            var args;
            this.executeCommand('cut', args);
        },
        _onCopy: function () {
            var args;
            this.executeCommand('copy', args);
        },
        _onOpen: function () {
            var selectNode = (this._isIE()) ? this._currentSelNode : this._getSelectedNode();
            window.open($(selectNode).attr('href'));
        },
        _onPaste: function () {
            var args;
            this.executeCommand('paste', args);

        },
        _onOrderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "OL" && $(_listSelect).parents("ol").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "OL" || $(_listSelect).parents("ol").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listOrderType == "none"))
                this.executeCommand('insertorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ol").length >= 0) e.ID = this._listOrderType;
            if (!ej.isNullOrUndefined(e.ID)) var orderParent = ($(_listSelect).prop("tagName") == "OL") ? _listSelect : $(_listSelect).parents("ol");
            this._generateListItems(e, orderParent, !ej.isNullOrUndefined(this.model.tools["customOrderedList"]) ? this.model.tools["customOrderedList"] : []);
            this._listOrderType = e.ID;
            this._updateIndent(_listSelect);
        },
        _onUnorderList: function (e) {
            var _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if ((($(_listSelect).prop("tagName") != "UL" && $(_listSelect).parents("ul").length == 0 && e.ID != "none") || e.type == "click" || (($(_listSelect).prop("tagName") == "UL" || $(_listSelect).parents("ul").length > 0) && e.ID == "none")) && !(ej.isNullOrUndefined(e.ID) && this._listType == "none"))
                this.executeCommand('insertunorderedlist', "listItem");
            _listSelect = (this._isIE()) ? ((this._isIE8()) ? this._pasteRangeVal.parentElement() : this._pasteRangeVal.startContainer.parentNode) : this._getSelectedNode();
            if (e.type == "click" && $(_listSelect).parents("ul").length >= 0) e.ID = this._listType;
            if (!ej.isNullOrUndefined(e.ID)) var unOrderParent = ($(_listSelect).prop("tagName") == "UL") ? _listSelect : $(_listSelect).parents("ul");
            this._generateListItems(e, unOrderParent, !ej.isNullOrUndefined(this.model.tools["customUnorderedList"]) ? this.model.tools["customUnorderedList"] : []);
            this._listType = e.ID;
            this._updateIndent(_listSelect);
        },
        _generateListItems: function (e, list, template) {
            $(list).css({ "list-style-type": e.ID, "list-style-image": "" });
            var proxy = this;
            if (["none", "disc", "circle", "square", "decimal", "upper-roman", "lower-roman", "upper-alpha", "lower-alpha"].indexOf(e.ID) == -1)
                $.each(template, function (i, val) {
                    if (val["name"] == e.ID) $(list).css({ "list-style-type": val["listStyle"], "list-style-image": val["listImage"] });
                });
            this._setBackupData();
            (this._isIE()) ? this.selectRange(this._pasteRangeVal) : this.selectRange(this._getRange());
            this._updateTagInfo((this._isIE()) ? this._currentSelNode : this._getSelectedNode());
        },
        _onUndo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('undo', null);
            else
                this._undo();
        },
        _onDelete: function () {
            var args;
            this.executeCommand('delete', null);
        },

        _onRedo: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('redo', null);
            else
                this._redo();
        },

        _onClearFormat: function () {
            var args;
            this.executeCommand('removeformat', args);
            this._hideTooltip();
            this._setBackupData();
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateToolbarStatus();
        },

        _onFormatBlock: function (formatBlock) {
            this._focus();
            if (this._isIE8()) {
                var selection, range, node;
                node = document.getSelection ? this._getSelectedNode() : this._getWindow().document.selection.createRange().parentElement();
                this._onClearFormat();
                this.executeCommand('formatBlock', formatBlock);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.formatblock, formatBlock);
                this._trigger("execute", { commandName: "formatBlock" });
            }

            
            this._updateToolbarStatus();
            this._updateFontOptionStatus();

        },

        _onFontName: function (fontsname) {
            if ((this._isIE8()))
                this.executeCommand("fontName", fontsname);//backColor,fontName,fontSize,foreColor
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontname, fontsname);
                this._trigger("execute", { commandName: "fontName" });
            }
        },

        _onFontSize: function (Size) {
            if ((this._isIE8()))
                this.executeCommand('fontSize', Size);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.fontsize, Size);
                this._trigger("execute", { commandName: "fontSize" });
            }
        },

       _onFontColor: function (color) {
	         this._fontColorSplit.find("span.e-btntxt").css("background-color", color);
		     if(this._customDialogobj&&this._customDialogobj.isOpen())
			    this._customColor.ejDialog("close");
             if (this._isIE8())
                this.executeCommand('foreColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.forecolor, color);
                this._trigger("execute", { commandName: "foreColor" });
            }
            this._onChange();
            this._updateIframeSkin(this.model.iframeAttributes);
        },

       _onBGColor: function (color) {
	        this._bgColorSplit.find("span.e-btntxt").css("background-color", color);
		    if(this._customDialogobj&&this._customDialogobj.isOpen())
               this._customColor.ejDialog("close");	 
            if (this._isIE8())
                this.executeCommand('backColor', color);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.backcolor, color);
                this._trigger("execute", { commandName: "backColor" });
            }
            this._onChange();
        },

        _onIndent: function () {
            if (this._isIE8()) {
                this._getWindow().document.body.style.wordWrap = "break-word";
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listIndent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listIndent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('indent', false);

                node && $(node).focus();
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.indent, null);
                this._trigger("execute", { commandName: "indent" });
            }

            this._updateIframeSkin(this.model.iframeAttributes);
            this._updateIndentStatus();
        },

        _onOutdent: function () {
            if (this._isIE8()) {
                var node = document.getSelection ? this._getWindow().document.getSelection().focusNode : this._getWindow().document.selection.createRange().parentElement();
                if (node && (/^(OL|UL|LI)$/).test(node.nodeName))
                    this._listOutdent(node);
                else if (node && (/^(#text)$/).test(node.nodeName) && (/^(OL|UL|LI)$/).test($(node).parent()[0].nodeName)) {
                    this._listOutdent($(node).parents("li")[0], node);
                }
                else
                    this.executeCommand('outdent', false);
            }
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.outdent, null);
                this._trigger("execute", { commandName: "outdent" });
            }
            this._updateIndentStatus();
        },

        _onSelectAll: function () {
            this.executeCommand('selectall');
        },
        selectAll: function () {
            this._onSelectAll();
        },
        _onHyperLink: function (val) {
            this.executeCommand('createlink', val);
        },

        _onInsertLink: function () {
            var oEl, sHtml;
            if (!this._isUrl($.trim(this._txtURL.val()))) {
                this._txtURL.addClass("e-error");
                return false;
            }
            var selectedNode = ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && $(this._currentSelNode).parents("body").length > 0) ? this._currentSelNode : this._getSelectedNode();
            if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'A') {
                selectedNode.href = this._txtURL.val();
                selectedNode.title = this._txtLinkTitle.val();
                selectedNode.innerHTML = this._txtLinkText.val();
                (this._chkTarget.ejCheckBox("isChecked")) ? selectedNode.target = "_blank" : selectedNode.target = "";
            }
            else if (!ej.isNullOrUndefined(selectedNode) && selectedNode.tagName.toUpperCase() == 'IMG') {
                var parentNode = $(selectedNode).parent('a')[0];
                if (ej.isNullOrUndefined(parentNode)) {
                    oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                    (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";
                    $(selectedNode.outerHTML).appendTo($(oEl));
                    $(selectedNode).replaceWith($(oEl));
                } else {
                    parentNode.href = this._txtURL.val();
                    parentNode.title = this._txtLinkTitle.val();
                    (this._chkTarget.ejCheckBox("isChecked")) ? parentNode.target = "_blank" : parentNode.target = "";
                }
            }
            else {
                oEl = ej.buildTag("a", "", {}, { href: this._txtURL.val(), title: this._txtLinkTitle.val() == "" ? (this._txtURL.val() + "\n" + this._getLocalizedLabels("linkTooltip")) : this._txtLinkTitle.val() });
                (this._chkTarget.ejCheckBox("isChecked")) ? oEl[0].target = "_blank" : oEl[0].target = "";

                var oSelection;
                var oSelRange;
                this._focus();
                if (this._isIE()) {
                    if (this._selectedHTML.length == 0) {
                        if (this._txtLinkText.val() === "") this._selectedHTML = this._txtURL.val();
                        else this._selectedHTML = this._txtLinkText.val();
                    }
                    oEl[0].innerHTML = this._selectedHTML;
                    sHtml = oEl[0].outerHTML;
                }
                else {
                    if (this._txtLinkText.val() === "") oEl.html(this._txtURL.val());
                    else oEl.html(this._txtLinkText.val());
                    sHtml = $('<div>').append($(oEl).clone()).html();
                }
                if (sHtml && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length))) {
                    this._isIE() ? this._pasteHtml(sHtml) : this._getDocument().execCommand('inserthtml', false, sHtml);
                    this.selectRange(this._getRange());
                }
            }
            this._linkDialog.ejDialog("close");
            this.enableToolbarItem("removeLink");
            this._updateCount();
        },

        _setImageProperties: function (imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor) {
            if (this.model.showDimensions) {
                (imgX != "") && (imgEle[0].width = imgX);
                (imgY != "") && (imgEle[0].height = imgY);
            }

            imgEle = $(imgEle).attr('style', imageStyle);

            var border = borderPx + "px ";
            (!ej.isNullOrUndefined(borderStyle) && borderStyle != "") ? border += borderStyle + " " : border += "solid ";
            (!ej.isNullOrUndefined(borderColor) && borderColor != "") ? border += borderColor : border += "#000000";
            imgEle = imgEle.css('border', border);
        },
        _onInsertImage: function () {
            var url = this._imgDialog.find(".e-rte-imgUrl");
            var altText = this._imgDialog.find(".e-rte-imgText");
            var imgX = this._imgDialog.find(".e-rte-imgX").val();
            var imgY = this._imgDialog.find(".e-rte-imgY").val();
            var proxy = this;
            this._restoreSelection(this._selectionRange);
            var element, border, nodeName = "", imageLink = proxy._imageLink.val(), borderPx = proxy._imageBorderPx.getValue(), borderStyle = proxy._imageBorderStyle.getSelectedValue(), borderColor = proxy._imgPicker.getValue(), imageStyle = proxy._imageStyle.val();
            var selectedNode = (proxy._isIE()) ? proxy._currentSelNode : proxy._getSelectedNode();
            (!ej.isNullOrUndefined(selectedNode)) && (nodeName = selectedNode.nodeName.toUpperCase());
            borderColor = !ej.isNullOrUndefined(borderColor) && borderColor.length > 0 ? borderColor : "";
            var srcUrl = (url.val().startsWith("~")) ? url.val().replace(url.val().substr('0', '1'), "..") : url.val();
            if (nodeName != 'IMG') {
                //Url Validation
                var _img = $("<img>", {
                    src: srcUrl,
                    error: function () { url.addClass("e-error"); },
                    success: function () {
                        var imgEle = ej.buildTag("img", "", {}, { alt: altText.val(), src: srcUrl });
                        proxy._setImageProperties(imgEle, imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                        if (imageLink != "") {
                            if (proxy._isUrl($.trim(imageLink))) {
                                var link = ej.buildTag("a", "", {}, { href: imageLink });
                                (proxy._dialogchkTarget.ejCheckBox("isChecked")) ? link[0].target = "_blank" : link[0].target = "_self";
                                $(imgEle[0].outerHTML).appendTo(link);
                                imgEle = link;
                            }
                            else {
                                proxy._imageLink.addClass("e-error");
                                return false;
                            }
                        }
                        var element = imgEle[0].outerHTML;
                        proxy.executeCommand('inserthtml', element);
                    }
                });
            }
            else {
                selectedNode.src = srcUrl;
                selectedNode.alt = altText.val();
                proxy._setImageProperties($(selectedNode), imgX, imgY, imageStyle, borderPx, borderStyle, borderColor);
                var linkNode = $(selectedNode).parent('a');
                if (imageLink != "") {
                    if (proxy._isUrl($.trim(imageLink))) {
                        if (linkNode.length > 0)
                            linkNode.attr('href', imageLink);
                        else {
                            var linkNode = ej.buildTag("a", "", {}, { href: imageLink });
                            $(selectedNode.outerHTML).appendTo(linkNode);
                            $(selectedNode).replaceWith(linkNode);
                        }
                    }
                    else {
                        proxy._imageLink.addClass("e-error");
                        return false;
                    }
                }
                else 
                    (linkNode.length > 0) && (linkNode.attr('href', ""));
                if (!ej.isNullOrUndefined(linkNode) && linkNode.length > 0)
                    (this._dialogchkTarget.ejCheckBox("isChecked")) ? linkNode[0].target = "_blank" : linkNode[0].target = "_self";
            }
            proxy._setAutoHeight();
            if (!proxy._imageLink.hasClass("e-error")) proxy._imgDialog.ejDialog("close");
            proxy._on(proxy._imageLink, "keypress", proxy._urlValidation)._on(proxy._imageLink, "blur", proxy._urlValidation);
        },

        _insertVideo: function (sender) {
            var videoLink = $.trim(this._videoDialog.find("textarea.e-rte-video")[0].value);
            var videoX = this._videoDialog.find(".e-rte-videoX").val();
            var videoY = this._videoDialog.find(".e-rte-videoY").val();
            this._restoreSelection(this._selectionRange);
            this._alertHeader(this);
            if (sender.target.id === "video_insert" && videoLink !== "") {
                if (this._isIE() && !this._isIE8()) this._ieLinkRange();
                var ele = $(videoLink)[0];
                if (this.model.showDimensions && !ej.isNullOrUndefined(ele)) {
                    (videoX != "") && (ele.width = videoX);
                    (videoY != "") && (ele.height = videoY);
                }
                if (!ej.isNullOrUndefined(ele) && (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)))
                    this.executeCommand('inserthtml', ele.outerHTML + "<br/>");

                this._onChange();
                this._setBackupData();
                this._videoDialog.ejDialog("close");
            }
            else if (sender.target.id === "video_cancel") {
                this._videoDialog.ejDialog("close");
                this._ieCursorMaintainance();
            }
            else
                this._openAlert(this._getLocalizedLabels("videoError"));
            this._videoDialog.find("textarea.e-rte-video")[0].value = "";
            this._videoDialog.find(".e-rte-videoX").val("");
            this._videoDialog.find(".e-rte-videoY").val("");
            this._chkvideoDimensions.ejCheckBox({ check: true });
            this._setAutoHeight();
        },

        _oneditTable: function () {
            //var selectedNode = this._currentSelNode;
            var isTable = $(this._getSelectedNode()).closest("td");
            var selectedNode = (isTable.length > 0) ? isTable[0] : this._currentSelNode;
            var parentTable = $(selectedNode).closest('tbody').closest('table');
            var captionEle = $($(selectedNode).closest('tbody')).prev('caption');
            (this._eTblCaption.ejCheckBox("isChecked")) ? (captionEle.length == 0) && ej.buildTag('caption').append($('<br type="_moz">')).insertBefore($($(selectedNode).closest('tbody'))) : (captionEle.length > 0) && captionEle.remove();
            var tblAlign = this._eTblAlign.getSelectedValue();
            var style = this._getTableObj("Style").val();
            style = style.replace((tblAlign == 'center') ? /float(.*?);/ig : /margin(.*?);/ig ,"");
            if (tblAlign == 'center') style += ";margin: 0 auto;";
            (style) && parentTable.attr('style', style);
            this._customTableValidation = false;
            var tableWid = this._customInputValidation(this._getTableObj("Width"));
            var tableHgt = this._customInputValidation(this._getTableObj("Height"));
            var rowHgt = this._customInputValidation(this._getTableObj("RHeight"));
            var cellWid = this._customInputValidation(this._getTableObj("ClWidth"));
            var borderSpa = this._getTableObj("CellSpace").data('ejNumericTextbox').getValue();
            var cellPad = this._getTableObj("CellPad").data('ejNumericTextbox').getValue();
            if (!this._customTableValidation) {
                parentTable.css({
					'width':isNaN(Number(tableWid))?tableWid:tableWid+"px",
                    'height': isNaN(Number(tableWid))?tableWid:tableWid+"px",
                    'border-spacing': isNaN(Number(borderSpa))?borderSpa:borderSpa+"px",
                    'float': tblAlign,
                    'border-width': this._getTableObj("BrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("_border_style").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("_border_color").val()
                });
                parentTable.find("td,th").css("padding",isNaN(Number(cellPad))?cellPad:cellPad+"px");
                var parentRow = $(selectedNode).closest('tr');
                parentRow.attr({
                    style: this._getTableObj("RStyle").val()
                }).css({
                    'height': isNaN(Number(rowHgt))?rowHgt:rowHgt+"px",
                    'text-align': this._getTableObj("RAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("RBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("RBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("RBrdrColor").val()
                });
                $(selectedNode).attr({
                    style: this._getTableObj("ClStyle").val()
                }).css({
                    'width': isNaN(Number(cellWid))?cellWid:cellWid+"px",
                    'text-align': this._getTableObj("ClAlign").data('ejDropDownList').getSelectedValue(),
                    'border-width': this._getTableObj("ClBrdrPx").data('ejNumericTextbox').getValue() + "px",
                    'border-style': this._getTableObj("ClBrdrStyle").data('ejDropDownList').getSelectedValue(),
                    'border-color': this._getTableObj("ClBrdrColor").val()
                });
                this._eTblDialog.ejDialog("close");
            }
            this._on(this._getTableObj("Width"), "keypress", this._urlValidation)
				._on(this._getTableObj("Height"), "keypress", this._urlValidation)
				._on(this._getTableObj("RHeight"), "keypress", this._urlValidation)
				._on(this._getTableObj("ClWidth"), "keypress", this._urlValidation);
        },


        _clearAllManager: function () {
            this._hideTooltip();
            this._alertWindow.find(".e-alert-cancel").show();
            this._alertHeader(this);
            this._openAlert(this._getLocalizedLabels("deleteAlert"));
        },

        _onUnlink: function () {
            var args;
            this.executeCommand('unlink', args);
            this.disableToolbarItem("removeLink");
        },
        _onSuperScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SuperScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.superscript, null);
                this._trigger("execute", { commandName: "SuperScript" });
            }
        },
        _onSubScript: function () {
            var args;
            if (this._isIE8())
                this.executeCommand('SubScript', args);
            else
            {
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.subscript, null);
                this._trigger("execute", { commandName: "SubScript" });
            }
        },
        _onInsertTable: function (rows, cols, designTime) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                $(this._getDocument().body).css("display", "inline-block");
                var tableEle = this._tableGenerator(rows, cols, designTime);
                this.executeCommand('inserthtml', tableEle);
                if ((ej.isNullOrUndefined($(this._getDocument().body).find("table:last")[0].nextSibling)) || ($(this._getDocument().body).find("table:last")[0].nextSibling.nodeName.toLowerCase() == "#text" && $.trim($(this._getDocument().body).find("table:last")[0].nextSibling.nodeValue) == "\n"))
                    $("<p><br/></p>").insertAfter($(this._getDocument().body).find("table"))
                $(this._getDocument().body).css("display", "");
                this._setAutoHeight();
            }
        },

        _onUpperCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toLowerCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toUpperCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents()
                        var result = this._changeCase(contents, "Upper");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toUpperCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.uppercase, null);


            this._trigger("execute", { commandName: "uppercase" });
        },

        _changeCase: function (parentNode, toChangeCase) {
            var s = parentNode.childNodes;
            if (s.length > 0) {
                for (var t = 0; t < s.length; t++) {
                    if (s[t].nodeType == 3) {
                        s[t].nodeValue = toChangeCase == "Upper" ? s[t].nodeValue.toUpperCase() : s[t].nodeValue.toLowerCase();
                    }
                    else {
                        if (s[t].nodeType == 1 && s[t].tagName.toUpperCase() != "FONT") {
                            this._changeCase(s[t], toChangeCase);
                        }
                    }
                }
            }
            return s;
        },


        _onLowerCase: function () {
            if (this._isIE8()) {
                if (!document.getSelection) {
                    if (this._getWindow().document.selection.type.toUpperCase() == "control") {
                        return;
                    }
                    this._seleText = ej.isNullOrUndefined(this._seleText) ? "" : this._seleText;
                    this._getDocument().selection.createRange().pasteHTML(this._seleText.toLowerCase());
                }
                else {
                    var selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    var node = range.commonAncestorContainer;
                    var children = range.commonAncestorContainer.children;
                    if (children != null) {
                        var contents = range.cloneContents();
                        var result = this._changeCase(contents, "Lower");
                        var resultCopy = $(result).clone();
                        var tempDiv = document.createElement('div');
                        $(tempDiv).append($(resultCopy));
                        if (tempDiv.innerHTML != null && tempDiv.innerHTML != "")
                            this._getWindow().document.execCommand('inserthtml', false, tempDiv.innerHTML);
                    }
                    else {
                        var replaceString = node.nodeValue.substring(range.startOffset, range.endOffset).toLowerCase();
                        var startString = node.nodeValue.substr(0, range.startOffset);
                        var endString = node.nodeValue.substring(range.endOffset);
                        node.nodeValue = startString + replaceString + endString;
                    }
                }
            }
            else
                this._getDocumentHandler() && this._operationHandler.execCommand(ej.execCommand.lowercase, null);
            //execCommand=emphasize-contentformat-indent-contentalignment-formatblock-captionconvertion
            this._trigger("execute", { commandName: "lowercase" });
        },

        _listIndent: function (node, selection) {
            var sibling, newList;
            sibling = node.previousSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.appendChild(node);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(sibling.lastChild)) {
                sibling.lastChild.appendChild(node);
                this._combineLists(node.lastChild, sibling.lastChild, node);
                return true;
            }
            sibling = node.nextSibling;
            if (sibling && this._isListNode(sibling)) {
                sibling.insertBefore(node, sibling.firstChild);
                return true;
            }
            if (sibling && sibling.nodeName == 'LI' && this._isListNode(node.lastChild)) {
                return false;
            }
            sibling = node.previousSibling;
            if (sibling && sibling.nodeName == 'LI') {
                newList = ej.buildTag(node.parentNode.nodeName)[0];
                sibling.appendChild(newList);
                newList.appendChild(node);
                this._combineLists(node.lastChild, newList, node);
                return true;
            }
            return true;
        },

        _combineLists: function (from, to, li) {
            var node;
            if (this._isListNode(from)) {
                while ((node = li.lastChild.firstChild)) {
                    to.appendChild(node);
                }
                $(from).remove();
            }
        },
        _isListNode: function (node) {
            return node && (/^(OL|UL)$/).test(node.nodeName);
        },
        _isFirstChild: function (node) {
            return node.parentNode.firstChild == node;
        },

        _isLastChild: function (node) {
            return node.parentNode.lastChild == node;
        },
        _removeEmptyList: function (node) {
            if (node && $(node).children().length === 0)
                $(node).remove();
        },
        _listOutdent: function (node) {
            var ul = $(node.parentNode), ulParent = ul[0].parentNode, newBlock;
            node = $(node);
            if (this._isFirstChild(node[0]) && this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    this._removeEmptyList(ulParent);
                    ul.remove();
                } else if (this._isListNode(ulParent)) {
                    ul.remove();
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isFirstChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                    node[0].appendChild(ul[0]);
                    this._removeEmptyList(ulParent);
                } else if (this._isListNode(ulParent)) {
                    ulParent.insertBefore(node[0], ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }

                return true;
            } else if (this._isLastChild(node[0])) {
                if (ulParent.nodeName == "LI") {
                    node.insertAfter(ulParent);
                } else if (this._isListNode(ulParent)) {
                    node.insertAfter(ul[0]);
                } else {
                    this.executeCommand('outdent', false);
                }
                return true;
            } else {
                this.executeCommand('outdent', false);
            }
            return false;
        },
        _updateIndent: function (node) {
            if (!ej.isNullOrUndefined(this._toolBarObj)) {
                if ($("#" + this._rteId + "_" + "indent").hasClass('e-disable')) this._toolBarObj.enableItemByID(this._rteId + "_" + "indent");
                if (node && (/^(LI)$/).test(node.nodeName)) {
                    if ($(node).parents(node.parentNode.nodeName).last().find("li").index(node) === 0)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "indent");
                }
            }
        },
         _updateCount: function () {
            if (!ej.isNullOrUndefined(this.model)) {
                if (this.model.showFooter && this.model.showWordCount)
				{
                   this._wordCount.html(this._getLocalizedLabels("words") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
				  if(this._rteFooter.width()<400)
				  this._wordCount.html(this._getLocalizedLabels("w") + " : " + ($.trim(this._getText()) != "" ? $.trim(this._getText()).split(/\W+/).length : 0));
					}
				
                if (this.model.showFooter && this.model.showCharCount)
				{
                    this._charCount.html(this._getLocalizedLabels("characters") + " : " + this._getText().length);
					if(this._rteFooter.width()<400)
					this._charCount.html(this._getLocalizedLabels("c")+ " : " + this._getText().length);
					}
            }
        },
        _updateTagInfo: function (element) {
            var text = "", pTag, count = 1;
            if (!ej.isNullOrUndefined(element))
                if (element.localName == "body" || element.localName == "html")
                    element = this._getSelectedNode();
            if (ej.isNullOrUndefined(element)) this._curNode = "";
            else this._curNode = element.tagName ? element.tagName.toLowerCase() : "html";
            if (this.model.showFooter && this.model.showHtmlTagInfo) {
                if (this._curNode != "html" && this._curNode !== "") {
                    var parentNodes = $(element).parents();
                    for (var i = parentNodes.length - 1; i >= 0; i--) {
                        pTag = parentNodes[i].tagName.toLowerCase();
                        if (pTag != "html")
                            text += " » " + pTag;
                        else count++;
                    }
                    text += " » " + this._curNode;
                    if ($(element).parents().length > 0) {
                        if (!ej.isNullOrUndefined(parentNodes[parentNodes.length - count]))
                            this._pTag = parentNodes[parentNodes.length - count].tagName.toLowerCase();
                    }
                }
                this._tags = text;
                this._responsiveTagList();
            }
        },
        _responsiveTagList: function () {
            $(this._htmlInfo).html(this._tags);
            if ($(this._rteWapper).outerWidth() < $(this._rteWapper).find('.e-rte-footer-left').outerWidth() + $(this._rteWapper).find('.e-rte-footer-right').outerWidth())
                $(this._htmlInfo).html(" » " + this._pTag + " » ... ...  » " + this._curNode);
            else $(this._htmlInfo).html(this._tags);
        },
		_removeNoSpaceChar:function(data){
			data &&(data=data.replace(/[\uFEFF]/g,""));
			return data
		},
        _updateValue: function () {
            var updatedval = this._removeNoSpaceChar(this._updateXhtml());
            if (this.model.enableHtmlEncode)
                updatedval = this._encode(this._decode(updatedval));
            this.value(updatedval);
            this.element.val(updatedval);
        },
        _imageXhtml: function (imgVal) {
            var imgRegexp = /<img(.*?)>/ig;
            var imgTemp;
            var j = 0;
            var imgDup = new Array();
            while ((imgTemp = imgRegexp.exec(imgVal)) !== null) {
                imgDup.push(imgTemp[0].toString());
            }
            var imgEx = new Array();
            imgEx = imgDup.slice(0);
            for (var i = 0; i < imgDup.length; i++) {
                if (imgDup[i].indexOf("/") == -1) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
                else if (imgDup[i].lastIndexOf("/") != imgDup[i].length - 2) {
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 1) + "/" + imgDup[i].substr(imgDup[i].length - 1, imgDup[i].length);
                }
            }
            var altReg = /(alt)=("[^"]*")/i;
            var srcReg = /(src)=("[^"]*")/g;
            var altRegS = /(alt)=('[^"]*')/i;
            var srcRegS = /(src)=('[^"]*')/g;
            for (var i = 0; i < imgDup.length; i++) {
                var temp = ej.isNullOrUndefined(altReg.exec(imgDup[i])) ? altRegS.exec(imgDup[i]) : altReg.exec(imgDup[i]);
                var dup = ej.isNullOrUndefined(srcReg.exec(imgDup[i])) ? srcRegS.exec(imgDup[i]) : srcReg.exec(imgDup[i]);
                var srcVar = ej.isNullOrUndefined(imgDup[i].match(srcReg)) ? imgDup[i].match(srcRegS) : imgDup[i].match(srcReg);
                var altVar = ej.isNullOrUndefined(imgDup[i].match(/(alt)=("[^"]*")/g)) ? imgDup[i].match(/(alt)=('[^"]*')/g) : imgDup[i].match(/(alt)=("[^"]*")/g);
                if (temp == null && altVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " alt=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = altVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(altVar[j], "");
                    }
                }
                if (dup == null && srcVar == null)
                    imgDup[i] = imgDup[i].substr(0, imgDup[i].length - 2) + " src=\"\"" + imgDup[i].substr(imgDup[i].length - 2, imgDup[i].length);
                else {
                    for (var j = srcVar.length - 1; j > 0; j--) {
                        imgDup[i] = imgDup[i].replace(srcVar[j], "");
                    }
                }
            }
            for (var g = 0; g < imgDup.length; g++) {
                imgVal = imgVal.replace(imgEx[g], imgDup[g]);
            }
            return imgVal;
        },
        _tagCssReplace: function (styleTag, styleDup, styleRegval) {
            var tagStyle = /(style)=("[^"]*")/i;
            var tagCss = tagStyle.exec(styleDup);
            if (tagCss != null) {
                var cssTag = tagCss[0];
                if (styleTag != "")
                    cssTag = cssTag.substr(0, cssTag.length - 1) + styleTag + ";\"";
                if (!ej.isNullOrUndefined(styleTag))
                    styleDup = styleDup.replace(styleRegval[0], "").replace(tagCss[0], cssTag);
                return styleDup;
            }
        },
        _updateIndentStatus: function () {
            if (this._isIE8())
                ($(this._getSelectedNode()).closest("BLOCKQUOTE").length > 0) ? this.enableToolbarItem("outdent") : this.disableToolbarItem("outdent");
            else {
                if (this._getDocumentHandler() && this._operationHandler._validateIndent(this._getRange().startContainer))
                    this.enableToolbarItem("outdent");
                else
                    this.disableToolbarItem("outdent");
            }

        },
        _replaceHeightWidth: function (htmlTagreg, styleDup) {
            var styleRegval = htmlTagreg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":");
            }
            return (this._tagCssReplace(styleTag, styleDup, styleRegval));
        },
        _typeXhtmlValidation: function (styleDup) {
            var styleTag = styleRegval[0];
            if (styleTag == "type=\"a\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("a", "lower-alpha");
            else if (styleTag == "type=\"A\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("A", "upper-alpha");
            else if (styleTag == "type=\"1\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("1", "decimal");
            else if (styleTag == "type=\"i\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("i", "lower-roman");
            else if (styleTag == "type=\"I\"")
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type").replace("I", "upper-roman");
            else
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("type", "list-style-type");
        },
        _getCssXhtml: function (tagReg, styleDup) {
            var styleRegval = tagReg.exec(styleDup);
            if (!ej.isNullOrUndefined(styleRegval)) {
                var styleTag = styleRegval[0];
                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "text-align").replace("align", "text-align");
                styleDup = styleDup.replace(styleRegval[0], "style=\"" + styleTag + ";\"");
            }
            return styleDup;
        },
        _styleXhtml: function (styleVal) {
            var styleRegex = /<((?:(?!\/)).)*?>/ig;
            var styleTemp;
            var k = 0;
            var styleDup = new Array();
            var arr = new Array();
            while ((styleTemp = styleRegex.exec(styleVal)) !== null) {
                styleDup.push(styleTemp[0].toString());
            }
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                if (styleDup[i].indexOf("style=") != -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /( height)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /( width)=("[^"]*")/i;
                        styleDup[i] = this._replaceHeightWidth(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        var styleRegval = typeTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval))
                            var styleTag = this._typeXhtmlValidation(styleDup[i]);
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /( valign)=("[^"]*")/i;
                        var styleRegval = valignTag.exec(styleDup[i]);
                        var styleTag = styleRegval[0];
                        if (styleDup[i].indexOf("vertical-align:") != -1)
                            styleTag = "";
                        else
                            styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("valign", "vertical-align");
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /( align)=("[^"]*")/i;
                        var styleRegval = alignTag.exec(styleDup[i]);
                        if (!ej.isNullOrUndefined(styleRegval)) {
                            var styleTag = styleRegval[0];
                            if (styleDup[i].indexOf("text-align:") != -1)
                                styleTag = "";
                            else
                                styleTag = styleTag.replace(/\"/gi, "").replace("=", ":").replace("align", "text-align");
                        }
                        styleDup[i] = this._tagCssReplace(styleTag, styleDup[i], styleRegval);
                    }
                }
                if (styleDup[i].indexOf("style=") == -1) {
                    if (styleDup[i].indexOf("height=") != -1) {
                        var htmlTagreg = /(height)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(htmlTagreg, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("width=") != -1) {
                        var widthTag = /(width)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(widthTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("type=") != -1) {
                        var typeTag = /( type)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(typeTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("valign=") != -1) {
                        var valignTag = /(valign)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(valignTag, styleDup[i]);
                    }
                    if (styleDup[i].indexOf("align=") != -1) {
                        var alignTag = /(align)=("[^"]*")/i;
                        styleDup[i] = this._getCssXhtml(alignTag, styleDup[i]);
                    }
                }
            }
            for (var i = 0; i < styleDup.length; i++) {
                styleVal = styleVal.replace(styleEx[i], styleDup[i]);
            }
            return styleVal;
        },
        _getFormatXhtml: function (startRegex, startVal) {
            var startDup = new Array();
            var j = 0;
            var startTemp;
            while ((startTemp = startRegex.exec(startVal)) != null) {
                startDup.push(startTemp[0]);
            }
            for (var i = 0; i < startDup.length; i++) {
                startVal = startVal.replace(startDup[i], "");
            }
        },
        _startXhtml: function (startVal) {
            if (startVal.indexOf("start=") != -1) {
                var startRegex = /start=\"(.*?)\"/ig;
                startVal = this._getFormatXhtml(startRegex, startVal);
            }
            return startVal;
        },
        _fontXhtml: function (fontVal) {
            if (fontVal.indexOf("<font") != -1) {
                var fontRegex = /<font(.*?)>/ig;
                fontVal = this._getFormatXhtml(fontRegex, fontVal);
            }
            return fontVal;
        },
        _filerXhtmlNode: function (tableRegex, xhtmlVal) {
            var dupArray = new Array();
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                dupArray.push(tableTemp[0]);
            }
            return dupArray;
        },
        _replaceXhtmlNode: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _tdXhtml: function (xhtmlVal) {
            var tableRegex = /<td((?:(?!<\/td>).))*?<td/ig;
            var tableDup = new Array();
            tableDup = this._filerXhtmlNode(tableRegex, xhtmlVal);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var z = tableDup[i].lastIndexOf("<td");
                tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
            }
            xhtmlVal = this._replaceXhtmlNode(tableDup, xhtmlVal, tableEx);
            return xhtmlVal;
        },
        _ptagXhtml: function (htmlText) {
            var ptagRegex1 = /<\/p>((?:(?!<p).))*<\/p>/ig;
            var pTemp1;
            var pEx = new Array();
            if ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                while ((pTemp1 = ptagRegex1.exec(htmlText)) != null) {
                    pEx.push(pTemp1[0]);
                }
            }
            var ptagEx = new Array();
            ptagEx = pEx.slice(0);
            for (var i = 0; i < pEx.length; i++) {
                if (pEx[i].indexOf("<p") == -1)
                    pEx[i] = pEx[i].substr(0, pEx[i].length - 4);
            }
            for (var i = 0; i < pEx.length; i++) {
                htmlText = htmlText.replace(ptagEx[i], pEx[i]);
            }
            return htmlText;
        },
        _getUpdaeNodeXhtml: function (tableRegex, xhtmlVal, tableDup) {
            var tableTemp;
            while ((tableTemp = tableRegex.exec(xhtmlVal)) != null) {
                tableDup.push(tableTemp[0]);
            }
            return tableDup;
        },
        _replaceUpdateXhtml: function (tableRegex, xhtmlVal, value) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableDup[i], value);
            }
            return xhtmlVal;
        },
        _replaceXhtmlVal: function (tableDup, xhtmlVal, tableEx) {
            for (var i = 0; i < tableDup.length; i++) {
                xhtmlVal = xhtmlVal.replace(tableEx[i], tableDup[i]);
            }
            return xhtmlVal;
        },
        _replaceTagUpdateXhtml: function (tagRegex, xhtmlVal, value1, value2) {
            var tempArray = new Array();
            tempArray = this._getUpdaeNodeXhtml(tagRegex, xhtmlVal, tempArray);
            var tempEx = new Array();
            tempEx = tempArray.slice(0);
            tempArray[0] = value1 + tempArray[0] + value2;
            return xhtmlVal.replace(tempEx[0], tempArray[0]);
        },
        _replaceTagXHTML: function (styleRegex, xhtmlVal) {
            var styleDup = new Array();
            styleDup = this._getUpdaeNodeXhtml(styleRegex, xhtmlVal, styleDup);
            var styleEx = new Array();
            styleEx = styleDup.slice(0);
            for (var i = 0; i < styleDup.length; i++) {
                styleDup[i] = styleDup[i].replace(/<br\/>/gi, "");
            }
            return this._replaceXhtmlVal(styleDup, xhtmlVal, styleEx);
        },
        _replaceInputParams: function (inputRegex, xhtmlVal) {
            var tableDup = new Array();
            tableDup = this._getUpdaeNodeXhtml(inputRegex, xhtmlVal, tableDup);
            var tableEx = new Array();
            tableEx = tableDup.slice(0);
            for (var i = 0; i < tableDup.length; i++) {
                var divInndex = tableDup[i].indexOf(">");
                tableDup[i] = tableDup[i].substr(0, divInndex) + "/" + tableDup[i].substr(divInndex, tableDup[i].length - 1);
            }
            return this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
        },
        _updateXhtml: function () {
            var updateVal = this._getDocument().body.innerHTML;
            if (this.model.enableXHTML) {
                updateVal = updateVal.replace(/hhh/g, "").replace(/<br>/g, "<br/>").replace(/contenteditable="false"/g, "").replace(/contenteditable="true"/g, "").replace(/&nbsp;/g, " ").replace(/<hr>/g, "<hr/>").replace(/cellspacing =[0-9]/g, "").replace(/cellpadding  =[0-9]/g, "");
                this.value(updateVal);
                this._xhtmlTagValidation();
                updateVal = this.value();
                var xhtmlVal = updateVal.replace(/\s+/g, ' ').replace(/> </gi, "><");
                if (xhtmlVal.indexOf("<?xml") != -1) {
                    var xmlRegexp = /<?xml:(.*?)>/ig;
                    var xmlDup = new Array();
                    var k = 0;
                    while ((xmlTemp = xmlRegexp.exec(xhtmlVal)) != null) {
                        var j = xhtmlVal.indexOf("<?xml");
                        xmlDup[k] = xmlTemp[0];
                        xmlDup[k] = xhtmlVal.substr(j, xmlDup[k].length + 2);
                        xhtmlVal = xhtmlVal.replace(xmlDup[k], "");
                        k++;
                    }
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    //tabletag
                    var tableRegex = /<table(.*?)<\/table>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        tableDup[i] = tableDup[i].replace(/<p>/gi, "").replace(/<\/p>/gi, "");
                        if (tableDup[i].indexOf("<p") != -1) {
                            for (var k = 0; k < tableDup[i].length; k++) {
                                var divInndex = tableDup[i].indexOf("<p");
                                var t = 0;
                                if (divInndex != -1) {
                                    for (var j = divInndex + 4; j < tableDup[i].length - 7; j++) {
                                        if (tableDup[i].charAt(j) == '>') {
                                            if (t == 0) {
                                                tableDup[i] = tableDup[i].substr(0, divInndex) + tableDup[i].substr(j + 1, tableDup[i].length - 1);
                                                t++;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //td tag
                if (xhtmlVal.indexOf("<td") != -1) {
                    for (var i = 0; i < 2; i++) {
                        xhtmlVal = this._tdXhtml(xhtmlVal);
                    }
                }
                //tr tag
                if (xhtmlVal.indexOf("<tr") != -1) {
                    var trtdRegex = /<tr(.*?)>(?!<\/td>)/ig;
                    var tabletrDup = new Array();
                    tabletrDup = this._getUpdaeNodeXhtml(trtdRegex, xhtmlVal, tabletrDup);
                    var tabletrEx = new Array();
                    tabletrEx = tabletrDup.slice(0);
                    for (var i = 0; i < tabletrDup.length; i++) {
                        if (tabletrDup[i].indexOf("</td>") != -1)
                            tabletrDup[i] = tabletrDup[i].replace("</td>", "");
                    }
                    xhtmlVal = this._replaceXhtmlVal(tabletrDup, xhtmlVal, tabletrEx);
                    var tableRegex = /<tr(.*?)<\/tr>/ig;
                    var tableDup = new Array();
                    tableDup = this._getUpdaeNodeXhtml(tableRegex, xhtmlVal, tableDup);
                    var tableEx = new Array();
                    tableEx = tableDup.slice(0);
                    for (var i = 0; i < tableDup.length; i++) {
                        var z = tableDup[i].lastIndexOf("</tr>");
                        var w = tableDup[i].charAt(z - 5) + tableDup[i].charAt(z - 4) + tableDup[i].charAt(z - 3) + tableDup[i].charAt(z - 2) + tableDup[i].charAt(z - 1);
                        if (w != "</td>") {
                            tableDup[i] = tableDup[i].substr(0, z) + "</td>" + tableDup[i].substr(z, tableDup[i].length);
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(tableDup, xhtmlVal, tableEx);
                }
                //input tag
                if (xhtmlVal.indexOf("<input") != -1) {
                    var inputRegex = /<input((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/input>/gi, "");
                }
                if (xhtmlVal.indexOf("<param") != -1) {
                    var inputRegex = /<param((?:(?!\/).))*?>/ig;
                    xhtmlVal = this._replaceInputParams(inputRegex, xhtmlVal);
                    xhtmlVal = xhtmlVal.replace(/<\/param>/gi, "");
                }
                if (xhtmlVal.indexOf("<p ") != -1 || xhtmlVal.indexOf("<p>") != -1) {
                    var ptagRegex = /<p(.*)<\/p>/ig;
                    var pDup = new Array();
                    pDup = this._getUpdaeNodeXhtml(ptagRegex, xhtmlVal, pDup);
                    var pEx = new Array();
                    pEx.slice(0);
                    var r = pDup[0].length - 1;
                    var htmlText = pDup[0];
                    if (htmlText.indexOf("<p") != -1) {
                        for (var m = htmlText.indexOf("<p") ; m <= r; m++) {
                            var z = "";
                            var i = 0;
                            if (m < r - 3) {
                                z = htmlText.charAt(m) + htmlText.charAt(m + 1);
                            }
                            if (z == "<p") {
                                for (var s = m + 1; s <= r; s++) {
                                    var w;
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1) + htmlText.charAt(s + 2) + htmlText.charAt(s + 3)) == "</p>") {
                                        i++;
                                    }
                                    if ((w = htmlText.charAt(s) + htmlText.charAt(s + 1)) == "<p") {
                                        if (i == 0) {
                                            if (htmlText.indexOf("<div") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<div") != -1) {
                                                    var divIn = divSplit.indexOf("<div");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5);
                                                        if (z == "</div>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 6)) + "<p><span>" + htmlText.substr(u + 6, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                        }
                                        if (i == 0) {
                                            if (htmlText.indexOf("<table") != -1) {
                                                var divSplit = htmlText.substr(m, s - m);
                                                if (divSplit.indexOf("<table") != -1) {
                                                    var divIn = divSplit.indexOf("<table");
                                                    var q = 0;
                                                    var u;
                                                    for (var l = m + divIn + 1; l < htmlText.length - 1; l++) {
                                                        var z = htmlText.charAt(l) + htmlText.charAt(l + 1) + htmlText.charAt(l + 2) + htmlText.charAt(l + 3) + htmlText.charAt(l + 4) + htmlText.charAt(l + 5) + htmlText.charAt(l + 6) + htmlText.charAt(l + 7);
                                                        if (z == "</table>")
                                                            if (q == 0) {
                                                                u = l;
                                                            }
                                                    }
                                                    htmlText = htmlText.substr(0, m + divIn) + "</span></p>" + htmlText.substr(m + divIn, ((-(m + divIn) + u) + 8)) + "<p><span>" + htmlText.substr(u + 8, htmlText.length - 1);
                                                    i++;
                                                }
                                            }
                                            if (i == 0) {
                                                htmlText = htmlText.substr(0, s - 1) + "</p>" + htmlText.substr(s, htmlText.length - 1);
                                                r++;
                                                i++;
                                            }
                                        }
                                    }

                                }
                            }
                        }
                    }
                    htmlText = htmlText.replace(/<\/p><\/p>/gi, "</p>");
                    var pDupex = new Array();
                    pDupex = pDup.slice(0);
                    for (var i = 0; i < 2; i++) {
                        htmlText = this._ptagXhtml(htmlText);
                    }
                    var htmlRegex = /<p(.*?)<\/p>/ig;
                    var htmlDup = new Array();
                    htmlDup = this._getUpdaeNodeXhtml(htmlRegex, htmlText, htmlDup);
                    var htmlEx = new Array();
                    htmlEx.slice(0);
                    for (var j = 0; j < htmlDup.length; j++) {
                        if (htmlDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                        if (htmlDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            htmlDup[j] = this._replaceTagUpdateXhtml(tagRegex, htmlDup[j], "</span></p>", "<p><span>");
                        }
                    }
                    htmlText = this._replaceXhtmlVal(htmlDup, htmlText, htmlEx);
                    xhtmlVal = xhtmlVal.replace(pEx[0], htmlText);
                }
                if (xhtmlVal.indexOf("<span") != -1) {
                    var spanRegex = /<span(.*?)<\/span>/ig;
                    //var spanTemp;                    
                    var spanDup = new Array();
                    spanDup = this._getUpdaeNodeXhtml(spanRegex, xhtmlVal, spanDup);
                    var spanEx = new Array();
                    sapnEX = spanDup.slice(0);
                    for (var j = 0; j < spanDup.length; j++) {
                        if (spanDup[j].indexOf("<table") != -1) {
                            var tagRegex = /<table(.*)<\/table>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<div") != -1) {
                            var tagRegex = /<div(.*)<\/div>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                        if (spanDup[j].indexOf("<p") != -1) {
                            var tagRegex = /<p(.*)<\/p>/ig;
                            spanDup[j] = this._replaceTagUpdateXhtml(tagRegex, spanDup[j], "</span>", "<span>");
                        }
                    }
                    xhtmlVal = this._replaceXhtmlVal(spanDup, xhtmlVal, spanEx);
                }
                if (xhtmlVal.indexOf("<ol") != -1) {
                    var styleRegex = /<ol(.*?)<\/ol>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("<table") != -1) {
                    var styleRegex = /<table(.*?)><\/table>/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                if (xhtmlVal.indexOf("style") != -1) {
                    var styleRegex = /style="(.*?)"/ig;
                    xhtmlVal = this._replaceTagXHTML(styleRegex, xhtmlVal);
                }
                //style tag 
                if (!ej.isNullOrUndefined(this._fontXhtml(xhtmlVal)))
                    xhtmlVal = this._fontXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("<br ") != -1 || xhtmlVal.indexOf("<br>") != -1) {
                    var htmlTagreg = /<br(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<br/>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1 || xhtmlVal.indexOf("<strong>") != -1) {
                    var htmlTagreg = /<strong((?:(?!r).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<strong ") != -1) {
                    var htmlTagreg = /<strong (.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<b>").replace(/<\/strong>/gi, "</b>");
                }
                if (xhtmlVal.indexOf("<u") != -1) {
                    var htmlTagreg = /<u((?:(?!l).))*?>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<span style=\"text-decoration: underline;\">").replace(/<\/u>/gi, "</span>");
                }
                if (xhtmlVal.indexOf("<hr") != -1) {
                    var htmlTagreg = /<hr(.*?)>/ig;
                    var htmlTagtemp = new Array();
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "<hr/>");
                }
                if (!ej.isNullOrUndefined(this._startXhtml(xhtmlVal)))
                    xhtmlVal = this._startXhtml(xhtmlVal);
                if (xhtmlVal.indexOf("v:shapes=") != -1) {
                    var htmlTagreg = /v:shapes=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("v:") != -1) {
                    var htmlTagreg = /<v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/v:") != -1) {
                    var htmlTagreg = /<\/v:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("o:") != -1) {
                    var htmlTagreg = /<o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("/o:") != -1) {
                    var htmlTagreg = /<\/o:(.*?)>/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("role=") != -1) {
                    var htmlTagreg = /role=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("target=") != -1) {
                    var htmlTagreg = /target=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("language=") != -1) {
                    var htmlTagreg = /language=\"(.*?)\"/ig;
                    xhtmlVal = this._replaceUpdateXhtml(htmlTagreg, xhtmlVal, "");
                }
                if (xhtmlVal.indexOf("lang=") != -1) {
                    var htmlTagreg = /lang=\"(.*?)\"/ig;
					var htmlTagtemp = new Array();
                    htmlTagtemp = this._getUpdaeNodeXhtml(htmlTagreg, xhtmlVal, htmlTagtemp);
                    var height3 = new Array();
                    height3 = htmlTagtemp.slice(0);
                    for (var i = 0; i < htmlTagtemp.length; i++) {
                        xhtmlVal = xhtmlVal.replace(height3[i], htmlTagtemp[i].toLowerCase());
                    }
                }
                xhtmlVal = xhtmlVal.replace(/<\/td><\/td>/gi, "</td>").replace(/<\/th><\/td>/gi, "</th>");
                xhtmlVal = (xhtmlVal == "" || /<div class="e-xhtml">/ig.test(xhtmlVal) ) ? xhtmlVal : "<div class='e-xhtml'>" + xhtmlVal + "</div>";
                updateVal = xhtmlVal.replace(/&quot;/g, "'").replace(/cellspacing=("[0-9]")/g, '').replace(/cellSpacing=("[0-9]")/g, '').replace(/cellpadding=("[0-9]")/g, '').replace(/cellPadding=("[0-9]")/g, '').replace(/border=("[^"]")/g, '').replace(/<!--(.*?)-->/gm, '').replace(/(vAlign)=("[^"]*")/g, "").replace(/(valign)=("[^"]*")/g, "").replace(/(colspan)=("[^"]*")/g, "").replace(/(colSpan)=("[^"]*")/g, "");
                this.value(updateVal);
            }
            return updateVal;
        },
        _setClearFormat: function () {
            var selItemslength = this._rteToolbar.find(".e-active").length;
        },
        //Updates the status of the toolbar items
        _updateToolbarStatus: function () {
            try {
                var _isAligned = false;
                if (this.model.showToolbar) {
                    //Style Tools
                    for (var i = 0; i < this._styleItems.length; i++) {
                        var rtestyleid= document.getElementById(this._rteId + "_" + this._styleItems[i]);
                        if (this._getCommandStatus($.trim(this._styleItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._styleItems[i]);
                             rtestyleid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._styleItems[i]);
                            rtestyleid.classList.remove("e-isactive");
                        }  
                        } 
                    for (var i = 0; i < this._alignItems.length; i++) {
                        if (this._getCommandStatus($.trim(this._alignItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._alignItems[i]);
                            _isAligned = true;
                        } else
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]); 
                } 
                    if (!_isAligned) this._toolBarObj.selectItemByID(this._rteId + "_" + "justifyLeft"); 
                    for (var i = 0; i < this._scriptsItems.length; i++) {
                         var rtescriptid= document.getElementById(this._rteId + "_" + this._scriptsItems[i]);
                         if (this._getCommandStatus($.trim(this._scriptsItems[i].toLowerCase()))) {
                            this._toolBarObj.selectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                             rtescriptid.classList.add("e-isactive");
                        } else {
                            this._toolBarObj.deselectItemByID(this._rteId + "_" + this._scriptsItems[i]);
                           rtescriptid.classList.remove("e-isactive");
                        }
                    } 
                     var rteorderid=document.getElementById(this._rteId + "_" + "orderedList"); 
                    var rteunorderid= document.getElementById(this._rteId + "_" + "unorderedList");
                    if (this._getCommandStatus('InsertOrderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "orderedList");
                        rteorderid.classList.remove("e-isactive");
                    } if (this._getCommandStatus('InsertUnorderedList')) {
                        this._toolBarObj.selectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.add("e-isactive");
                    } else {
                        this._toolBarObj.deselectItemByID(this._rteId + "_" + "unorderedList");
                        rteunorderid.classList.remove("e-isactive");
                    }
                
                   this._updateIndentStatus(); 
                }
            }
            catch (error) { }
        },

        _updateFormat: function () {
            try {
                if (this._formatDDL && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["formatStyle"])) {
                    var formatName = $.trim(this._getCommandValue('formatblock').replace(/'/g, ""));
                    if (!this._isIE())
                        formatName = "<" + formatName + ">"; 
                    if (this._formatDDL.hasClass('e-dropdownlist')) {
                        if (ej.isNullOrUndefined(formatName) || formatName == "")
                            this._formatDDL.ejDropDownList({ "value": this._getLocalizedLabels("format") });
                        else if (!$(this._formatDDL).parents("ul.e-rte-format").length == 0)
                            this._formatDDL.ejDropDownList("setSelectedValue", formatName);
                    }
                }
            }
            catch (error) { }
        },

        _updateFontOptionStatus: function () {
            try {
                if (this.model.showFontOption && this.model.showToolbar && !ej.isNullOrUndefined(this.model.tools["font"])) {
                    var fontName = $.trim(this._getCommandValue('fontname').replace(/"/g, "").replace(/'/g, "").replace(/, /g, ","));
                    (ej.isNullOrUndefined(fontName) || fontName == "") && (fontName = "Segoe UI");
                    if (!ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass('e-dropdownlist') && !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontStyleDDL.ejDropDownList("setSelectedValue", fontName);

                    var fontSize = (this._isIE8()) ? this._getCommandValue('fontsize') : (this._getDocumentHandler() && this._operationHandler._validateFontSize(this._getRange().startContainer));
                    (ej.isNullOrUndefined(fontSize) || fontSize == "") && (fontSize = 2);
                    if (!ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass('e-dropdownlist') && !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0)
                        this._fontSizeDDL.ejDropDownList("setSelectedValue", fontSize);
                }
            }
            catch (error) { }
        },

        _getSelText: function () {
            var selectedtext = '';
            var selection;
            var textnode;
            if (!this._isIE()) {
                if (window.getSelection) {
                    selection = this._getWindow().getSelection();
                    var range = this._saveSelection();
                    textnode = document.createTextNode(range.toString());
                    selectedtext = textnode.nodeValue;
                }
                else if (document.getSelection) {
                    selectedtext = this._getWindow().document.getSelection();
                }
            }
            else
                selectedtext = this._seleText;
            return selectedtext;
        },

        _isIE: function () {
            var _ie = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie') {
                _ie = true;
            }
            return _ie;
        },

        _isIE8: function () {
            var _ie8 = false, browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == "8.0") {
                _ie8 = true;
            }
            return _ie8;
        },
        //Vaidate the input URL string
        _isUrl: function (url) {
            var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
            return regexp.test(url);
        },
        _pasteHtml: function (html, textnodeType) {
            var sel, range;
            if (this._pasteAPIFlag) {
                if (this._isIE())
                    this._focus();
            }
            else
                this._focus();
            if (window.getSelection) {
                // IE9 and non-IE
                sel = this._getWindow().getSelection();
                if (sel.getRangeAt && sel.rangeCount) {
                    range = this._pasteFlag ? this._pasteRangeVal : sel.getRangeAt(0);
                    var cnode = range.commonAncestorContainer, parentElement, i, container;
                    parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                    for (i = parentElement.length - 1; i >= 0; i--) {
                        if (parentElement[i].textContent == range.toString() && parentElement[i].nodeName.toLowerCase() != "li") {
                            range.selectNode(parentElement[i]);
                            break;
                        }
                    }
                    range.deleteContents();
                    // some browsers (IE9, for one)
                    var el = document.createElement("div");
                    el.innerHTML = html;
                    var frag = this._getDocument().createDocumentFragment(), node, lastNode;
                    var parent = el.firstChild;
                    if (!(this._pasteFlag || this._pasteAPIFlag)) {
                        while ((node = el.firstChild)) {
                            lastNode = frag.appendChild(node);
                        }
                    }
                    else {
                        while ((node = el.firstChild)) {
                            if (parent != node)
                                lastNode = parent.appendChild(node);
                            else
                                el.removeChild(el.firstChild);
                        }
                        lastNode = frag.appendChild(parent);
                    }
                    range.insertNode(frag);
                    // Preserve the selection
                    if (lastNode && !textnodeType) {
                        range = range.cloneRange();
                        range.setStartAfter(lastNode);
                        range.collapse(true);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                    else {
                        range = this.createRange();
                        range.setStart(lastNode, lastNode.data.length);
                        range.setEnd(lastNode, lastNode.data.length);
                        sel.removeAllRanges();
                        sel.addRange(range);
                    }
                }
            } else if (this._getDocument().selection && this._getDocument().selection.type != "Control") {
                // IE < 9
                if (this._ieSelectionRange && !(this._ieSelectionRange.offsetLeft == 0 && this._ieSelectionRange.offsetTop == 0 && this._ieSelectionRange.boundingHeight == 0)) {
                    if (this._pasteFlag)
                        this.selectRange(this._pasteRangeVal);
                    var ieParentElement = this._ieParents(this._getRange()), i, isParent = false;
                    if (this._pasteAPIFlag)
                        this._getRange().pasteHTML(html);
                    else {
                        var text = this._getRange().text;
                        for (i = ieParentElement.length - 1; i >= 0; i--) {
                            if (ieParentElement[i].innerText == text && ieParentElement[i].nodeName.toLowerCase() != "li") {
                                ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML = html : ieParentElement[i].outerHTML = html;
                                isParent = true;
                                break;
                            }
                        }
                        if (!isParent)
                            this._getRange().pasteHTML(html);
                    }
                }
                else
                    this._getDocument().body.insertAdjacentHTML("afterBegin", html);
            }
            this._pasteAPIFlag = this._pasteFlag = false;
        },
        _ieParents: function (range) {
            var parentElement = [];
            rangeval = this._isIE8() ? range.duplicate() : range.cloneRange();
            range.parentElement = rangeval.parentElement();
            while (range.parentElement.nodeName != "HTML") {
                if (range.parentElement.nodeName == "TD" || range.parentElement.nodeName == "TH")
                    break;
                parentElement.push(range.parentElement);
                range = range.parentElement;
            }
            return parentElement;
        },

        _getLocalizedLabels: function (property) {
			return this._localizedLabels[property] === undefined ? ej.RTE.Locale["en-US"][property] : this._localizedLabels[property];
        },


        _getSelectedNode: function () {
            var temp = this._getRange();
            var element, rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
            var startContainer = rng.startContainer, endContainer = rng.endContainer;
            var startOffset = rng.startOffset, endOffset = rng.endOffset;
            // if (!ej.isNullOrUndefined(rng.commonAncestorContainer))
            // if (rng.commonAncestorContainer.nodeName == "BODY")
            // this._tempEle = $(rng.commonAncestorContainer);
            // else if ($(rng.cloneContents()).text() == $($($(rng.startContainer).parents("li")).contents()[0]).text() && (startOffset == 0 && endOffset == $(rng.startContainer).parents("li").text().length) || startOffset == endOffset || startOffset == 0 && endOffset == 1)
            // this._tempEle = $($(rng.startContainer).parents("li"));
            // else if ((rng.commonAncestorContainer.nodeName == "OL") && startOffset != endOffset && endOffset != 0 && endOffset != 1)
            // this._tempEle = $(rng.commonAncestorContainer);
            // else
            // this._tempEle = $(rng.startContainer);
            if (!rng) {
                return this._getDocument().selection;
            }
            if (rng.setStart) {
                element = rng.commonAncestorContainer;
                //Image tage and link selection
                if (!rng.collapsed) {
                    if (startContainer == endContainer) {
                        if (endOffset - startOffset < 2) {
                            if (startContainer.hasChildNodes()) {
                                element = startContainer.childNodes[startOffset];
                            }
                        }
                    }
                    if (startContainer.nodeType === 3 && endContainer.nodeType === 3) {
                        if (startContainer.length === startOffset) {
                            startContainer = this._skipEmptyNode(startContainer.nextSibling, true);
                        } else {
                            startContainer = startContainer.parentNode;
                        }

                        if (endOffset === 0) {
                            endContainer = this._skipEmptyNode(endContainer.previousSibling, false);
                        } else {
                            endContainer = endContainer.parentNode;
                        }

                        if (startContainer && startContainer === endContainer) {
                            return startContainer;
                        }
                    }
                }

                if (element && element.nodeType == 3) {
                    return element.parentNode;
                }
                return element;
            }
            element = rng.item ? rng.item(0) : rng.parentElement();
            return element;
        },

        _skipEmptyNode: function (node, forwards) {
            var orig = node;
            while (node && node.nodeType === 3 && node.length === 0) {
                node = forwards ? node.nextSibling : node.previousSibling;
            }
            return node || orig;
        },

        _getSelection: function () {
            var selCurrent;
            if (this._isIE()) {
                selCurrent = this._getDocument().selection.createRange();
                selCurrent.type = this._getDocument().selection.type;
            }
            else {
                selCurrent = window.getSelection();
                if (selCurrent.rangeCount) {
                    sText = selCurrent.getRangeAt(0);
                }
                selCurrent.type = this._getWindow().getSelection().type;
            }
            return selCurrent;
        },

        _saveSelection: function () {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            var range;

            if (sel) {
                if (sel.createRange) {
                    range = sel.createRange();
                } else if (sel.rangeCount > 0 && sel.getRangeAt(0)) {
                    range = sel.getRangeAt(0);
                } else if (sel.anchorNode && sel.focusNode && doc.createRange) {
                    // Older WebKit browsers
                    range = doc.createRange();
                    range.setStart(sel.anchorNode, sel.anchorOffset);
                    range.setEnd(sel.focusNode, sel.focusOffset);
                    if (range.collapsed !== sel.isCollapsed) {
                        range.setStart(sel.focusNode, sel.focusOffset);
                        range.setEnd(sel.anchorNode, sel.anchorOffset);
                    }
                }
                else if (doc.createRange()) {
                    range = doc.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                else {
                    var iframe = document.getElementsByTagName("iframe")[0];
                    var win = iframe.contentWindow;
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
            }
            return range;
        },

        _restoreSelection: function (range) {
            var win = this._getWindow();
            var doc = win.document;
            var sel = win.getSelection ? win.getSelection() : doc.selection;
            if (sel && range) {
                if (range.select) {
                    range.select();
                } else if (sel.removeAllRanges && sel.addRange) {
                    sel.removeAllRanges();
                    sel.addRange(range);
                }
            }
        },

        _getRange: function () {
            if (this._isIE8()) {
                var temp = this._saveSelection();
                var rng = (this._ieSelectionRange && temp.offsetLeft == 0 && temp.offsetTop == 0 && temp.boundingHeight == 0) ? this._ieSelectionRange : temp;
                return rng;
            }
            else if (this._isIE())
                //Table Aciton Not working in IE condition (this._selectionRange.length>0)
                return this._ieSelection = (window.getSelection && (ej.isNullOrUndefined(this._selectionRange) ? false : (this._selectionRange.length > 0))) ? this._selectionRange : this._saveSelection();
            else if (this._getWindow().getSelection() && this._getWindow().getSelection().rangeCount > 0)
                return this._getWindow().getSelection().getRangeAt(0);
            else {
                var iframe = document.getElementsByTagName("iframe")[0];
                var win = iframe.contentWindow;
                var range
                try {
                    range = win.document.createRange();
                    range.setStart(win.document.body, 0);
                    range.setEnd(win.document.body, 0);
                }
                catch (error) {
                    range = this._getDocument().createRange();
                    range.setStart(this._getDocument().body, 0);
                    range.setEnd(this._getDocument().body, 0);
                }
                return range;
            }
        },
        _setBackupData: function () {
            var htmlTxt = this.getHtml();
            var bkuplen = this._backupArray.length;
            if (bkuplen == this.model.undoStackLimit + 1)
                this._backupArray.splice(0, 1);
            if (htmlTxt != this._backupArray[bkuplen - 1] && this.model.undoStackLimit > 0)
                this._backupArray.push(htmlTxt);
            this._undoRedoPosition = this._backupArray.length - 1;
            if (this.model.showToolbar && this._rteToolbar.find("li.e-rteItem-undo") && this._backupArray.length > 1 && !$("#" + this._rteId + "_" + "undo").hasClass("e-rteTooldisable"))
                this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
        },
        _getSelectedHtmlString: function () {
            if (typeof document.selection != "undefined" && this._isIE8()) {
                var ieParentElement = this._ieParents(this._getRange()), i, isParent = false, html;
                for (i = ieParentElement.length - 1; i >= 0; i--) {
                    if (ieParentElement[i].innerText == this._getRange().text) {
                        html = ieParentElement[i].nodeName == "BODY" ? ieParentElement[i].innerHTML : ieParentElement[i].outerHTML;
                        isParent = true;
                        break;
                    }
                }
                if (!isParent)
                    html = this._getRange().htmlText.substring(0, 1) == "<" ? this._getRange().text : this._getRange().htmlText;
                return html;
            }
            else {
                var range = this._getRange(), cnode = range.commonAncestorContainer, parentElement, i, container;
                parentElement = cnode.nodeType == 3 ? $(cnode).parentsUntil("body") : $(cnode).children();
                for (i = parentElement.length - 1; i >= 0; i--) {
                    if (parentElement[i].textContent != "" && parentElement[i].textContent == range.toString()) {
                        range.selectNode(parentElement[i]);
                        break;
                    }
                }
                container = document.createElement("div");
                container.appendChild(range.cloneContents());
                return container.innerHTML;
            }
        },

        _getText: function () {
            var _body = this._getDocument().body;
            if (_body != null) {
                if (!this._isIE())
                    return _body.textContent;
                else
                    return _body.innerText;
            }
        },
        _validateMaxLength: function (e) {
            if (this.model.maxLength != null) {
                var len = this.model.maxLength;
                var usertext = this._getText();
                if (len <= usertext.length) {
                    if (!(e.keyCode < 47 || e.ctrlKey && e.keyCode == 65 || e.ctrlKey && e.keyCode == 67 || e.ctrlKey && e.keyCode == 86 || e.ctrlKey && e.keyCode == 88)) {
                        this._keypressFlag = false;
                        this._cancelEvent(e);
                    }
                }
            }
        },
        _cancelEvent: function (e) {
            e.returnValue = false;
            e.stopPropagation();
            e.preventDefault();
            return false;
        },

        _alignToolUpdate: function (name) {
            for (var i = 0; i < this._alignItems.length; i++) {
                if (this._alignItems[i] === name)
                    this._toolBarObj.selectItemByID(this._rteId + "_" + name);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + this._alignItems[i]);
            }
        },


        _getCommandStatus: function (commandName) {
            var state = this._getDocument().queryCommandState(commandName);
            return state;
        },


        _getCommandValue: function (commandName) {
            var value = this._getDocument().queryCommandValue(commandName);
            if (this._isIE()) {
                if (commandName == "fontname") {
                    for (var i = 0; i < this.model.fontName.length; i++) {
                        if (value == this.model.fontName[i].text) {
                            value = this.model.fontName[i].value;
                            break;
                        }
                    }
                    if (ej.isNullOrUndefined(value) || value == "")
                        value = this.model.fontName[0].value;
                }
                if (commandName == "formatblock") {
                    for (var i = 2; i < this.model.format.length; i++) {
                        if (value == this.model.format[i].text) {
                            value = this.model.format[i].value;
                            break;
                        }
                    }
                    if (value == "Normal")
                        value = this.model.format[0].value;
                }
            }
            return value;
        },


        _undo: function () {
            if (this._undoRedoPosition > 0) {
                if (this.model.enableHtmlEncode)
                    this.setHtml(this._decode(this._backupArray[this._undoRedoPosition - 1]));
                else
                    this.setHtml(this._backupArray[this._undoRedoPosition - 1]);
                this._undoRedoPosition--;
                this._focus();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                this._toggleEditTable();
                if (this.model.isResponsive) this._toolBarObj._liTemplte.removeClass("e-display-none");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            if (this._undoRedoPosition == 0) {
                this._toolBarObj.disableItemByID(this._rteId + "_" + "undo");
                this._toolBarObj.enableItemByID(this._rteId + "_" + "redo");
            }
            this._updateToolbarStatus();
            this._trigger("execute", { commandName: "undo" });
        },
        _getRedoContent: function () {
            if (this.model.enableHtmlEncode)
                return (this._decode(this._backupArray[this._undoRedoPosition + 1]));
            else
                return (this._backupArray[this._undoRedoPosition + 1]);
        },

        _redo: function () {
            if (this._undoRedoPosition != this._backupArray.length) {
                if (this._backupArray[this._undoRedoPosition + 1] != null) {
                    var _redoContent = this._getRedoContent();
                    this.setHtml(_redoContent)
                    this._undoRedoPosition++;
                }
                else {
                    var redoString = this._getRedoContent();
                    if (!ej.isNullOrUndefined(redoString)) this.setHtml(redoString);
                    this._undoRedoPosition = this._backupArray.length - 2;
                }
                this._focus();
                this._updateToolbarStatus();
                this._updateFontOptionStatus();
                this._updateFormat();
                this._updateCount();
                if (!ej.isNullOrUndefined(this._toolBarObj)) {
                    if (this._backupArray.length - 1 > 0)
                        this._toolBarObj.enableItemByID(this._rteId + "_" + "undo");
                    if (this._undoRedoPosition == this._backupArray.length - 1)
                        this._toolBarObj.disableItemByID(this._rteId + "_" + "redo");
                }
            }
            this._trigger("execute", { commandName: "redo" });
        },


        _setContent: function (htmltxt) {
            var editdoc = this._getDocument();
            if (editdoc != "" && !ej.isNullOrUndefined(editdoc)) {
                editdoc.open();
                editdoc.write(htmltxt);
                editdoc.close();
                editdoc.EditMode = true;
            }
        },
        _removeResizeObject: function () {
            $(this._getDocument()).find(".e-rteColumnResizer , .e-rteRowResizer , .e-rteLastcolumn").remove();
        },
        _tableMouseOver: function (e) {
            if (e.target.nodeName == "TABLE" || (ej.browserInfo().name === "mozilla" && e.target.nodeName == "TD")) {
                this._curTable = (e.target.nodeName == "TD") ? $(e.target).closest("table")[0] : e.target;
                this._removeResizeObject();
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableResizeObject($(this._curTable));
            }
        },
        _preventDefaultResize: function () {
            var proxy = this._getDocument();
            (ej.browserInfo().name === "msie" && ej.browserInfo().version === "11.0") ? proxy.body.addEventListener('mscontrolselect', this._ieDefaultTableHandler) : (this._isIE()) && proxy.body.attachEvent('oncontrolselect', this._ieTableHandler);
            if (ej.browserInfo().name === "mozilla") {
                proxy.designMode = "on";
                proxy.execCommand("enableObjectResizing", false, "false");
                proxy.execCommand("enableInlineTableEditing", false, "false");
            }
        },
        _tableResizeObject: function (_tableEle) {
            if (this.model.allowEditing) this._preventDefaultResize();
            var cellspace = parseInt($(_tableEle).attr("cellspacing") ? $(_tableEle).attr("cellspacing") : 0);
            this._newcol = _tableEle.find("tr:first td").not(":first"), this._newRow = _tableEle.find("tr td:nth-child(1)"), this._newlas = _tableEle.find("tr:first td:last");
            for (var i = 0; this._newcol.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteColumnResizer\"  unselectable=\"on\" contenteditable=\"false\" data-col =" + (i + 1) + " style=\"top:" + $(this._newcol[i]).closest("table").offset().top + "px;left:" + $(this._newcol[i]).offset().left + "px;height:" + $(this._newcol[i]).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left: " + (-4 - cellspace) + "px;\"></div>");
            for (var i = 0; this._newRow.length > i ; i++)
                $(this._getDocument().body).after("<div class =\"e-rteRowResizer\" unselectable=\"on\"  contenteditable=\"false\" data-row =" + (i) + " style=\"top:" + ($(this._newRow[i]).offset().top + $(this._newRow[i]).height()) + "px;left:" + $(this._newRow[i]).offset().left + "px;width:" + $(this._newRow[i]).closest("table").width() + "px;height:" + (5 + cellspace) + "px;\"></div>");
            $(this._getDocument().body).after("<div class =\"e-rteColumnResizer e-rtelastcol\" data-col =" + (this._newcol.length) + "  contenteditable=\"false\" style=\"top:" + $(this._newlas).closest("table").offset().top + "px;left:" + ($(this._newlas).offset().left + $(this._newlas).width()) + "px;height:" + $(this._newlas).closest("table").outerHeight() + "px;width:" + (5 + cellspace) + "px;margin-left:3px;\"></div>");
            this._botRigTab = ej.buildTag("span.e-rte-tablebox e-rte-botrig", "", { "cursor": "nwse-resize", "width": "5px", "height": "5px", "position": "absolute", "display": "block", "background": "#fff", "border": "1px solid #000" }, {});
            var tableBox = _tableEle.find("tr:last td:last:not(:has(>span.e-rte-tablebox))");
            if (tableBox.length > 0) $(this._getDocument().body).after($(this._botRigTab).css({ "left": ((parseInt(tableBox.closest("table").width())) + tableBox.closest("table").offset().left) + "px", "top": ((parseInt(tableBox.closest("table").height())) + tableBox.closest("table").offset().top) + "px" }));
        },
        _ieDefaultTableHandler: function (e) {
            e.preventDefault();
        },
        _ieTableHandler: function (e) {
            return false;
        },


        _tableCellStart: function (e) {
            this._tableInsertAt = this._saveSelection();
        },


        _tableCellSelect: function (e) {
            var cellEle, target = $(e.target);
            var row = target.parent().index();
            var col = target.index();
            this._createTable.find("div.e-rte-tablecell").each(function (index) {
                cellEle = $(this);
                if (cellEle.index() <= col && cellEle.parent().index() <= row) {
                    cellEle.addClass("e-active");
                }
                else {
                    cellEle.removeClass("e-active");
                }
            });
            this._tblheaderDiv.html((col + 1) + "x" + (row + 1) + this._getLocalizedLabels("table"));
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt))
                this._restoreSelection(this._tableInsertAt);
        },
        _tableCellLeave: function (e) {
            this._createTable.find("div.e-rte-tablecell").removeClass("e-active");
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            this._tblheaderDiv.html(this._getLocalizedLabels("createTable"));
        },
        _tableCellDown: function (e) {
            var target = $(e.target);
            var row = target.parent().index() + 1;
            var col = target.index() + 1;
            this._focus();
            $(this._getDocument()).find("table.e-rte-tableremove").remove();
            if (!ej.isNullOrUndefined(this._tableInsertAt)) {
                this._restoreSelection(this._tableInsertAt);
                this._onInsertTable(row, col, false);
            }
            var _tableEle = $(this._getDocument()).find("table.e-rte-table");
            //Content editable propert for table and td removed and key navigation support added in keydown           
            if (!this.model.enableRTL) this._on(_tableEle, "mouseover", this._tableMouseOver);
            this._createTable.ejDialog("close",{clickAction:true});
            this._setBackupData();
            this._onChange();
            if (this.model.isResponsive && !($(this._toolBarObj._liTemplte).hasClass("e-inline"))){
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
        },

        _tableGenerator: function (rows, cols, designTime, width, height, spacing, padding, align, border, caption) {
            var tblClass = "e-rte-table", borderstyle;
            if (designTime)
                tblClass += " e-rte-tableremove";
            width = ej.isNullOrUndefined(width) || width == "" ? "width:99%;" : "width:" + (isNaN(Number(width))?width:width+"px") + ";";
            height = ej.isNullOrUndefined(height) || height == "" ? "" : "height:" + (isNaN(Number(height))?height:height+"px") + ";";
            spacing = ej.isNullOrUndefined(spacing) || spacing == "" ? "" : "border-spacing:" + (isNaN(Number(spacing))?spacing:spacing+"px") + ";";
            padding = ej.isNullOrUndefined(padding) || padding == "" ? "" : " style='padding:" + (isNaN(Number(padding))?padding:padding+"px") + ";'";
            align = ej.isNullOrUndefined(align) || align=="" ? "" : (align=="center") ?" margin: 0 auto;" : " float:" + align + ";";
            var  colTemplate = "<td"+ padding+"><br _moz_dirty=''/></td>"
            switch (border) {

                case "dotted": borderstyle = "dotted";
                    break;
                case "double":
                    this._border = "border:3px double #5C5C5C;";
                    borderstyle = "double";
                    return "<table border='1' class='" + tblClass + "' style='" + width + " " + height + " " + this._border + " " + spacing + " " + padding + " " + align + "' >" + (caption ? "<caption></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td"+padding+"><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
                    break;
                case "dashed": borderstyle = "dashed";
                    break;
                case "solid": borderstyle = "solid";
                    break;
                default: borderstyle = "solid";
                    break;
            }
            if (borderstyle != "double") {
                this._border = "border:1px " + borderstyle + "#5C5C5C;";
                return "<table border='1' class='" + tblClass + "' style='" + width + height + this._border + spacing  + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join("<td"+padding+"><br _moz_dirty=''/></td>") + "</tr>") + "</table>";
            }

            return "<table border='1' class='" + tblClass + "' style='border:1px solid #5C5C5C; " + width + height + spacing + align + "' >" + (caption ? "<caption><br type=\"_moz\"></caption>" : "") + Array(rows + 1).join("<tr>" + Array(cols + 1).join(colTemplate) + "</tr>") + "</table>";
        },

        _openCustomTable: function (e) {
            this._createCustomTable();
            if (e.currentTarget.id == this._rteId + "_createCustomTableLink") {
                $("#" + this._rteId + "_customTable_wrapper").css({ "z-index": this._onGetMaxZindex() });
                this._customTableDialog.ejDialog("open");
                this._createTable.ejDialog("close");
                this._widthFocusOut();
            }
            else {
                if (!this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')) {
                    this._eTblManager();
                    $("#" + this._rteId + "_eTbl_wrapper").css({ "z-index": this._onGetMaxZindex() });
                    this._eTblDialog.ejDialog("open");
                    this._createTable.ejDialog("close");
                    this._on(this._getTableObj("Width"), "focusout", this._widthFocusOut);
                    this._widthFocusOut();
                }
            }
        },
		_createcustomColorpalette:function(e)
		{
		    var proxy = $("#" + this._rteId).data("ejRTE");
			var palette=ej.buildTag("div.e-custom-palette");
		    this._customColor = ej.buildTag("div.e-rte-customColor#" + this._rteId + "_customColorDialog");
            var colorpalette= ej.buildTag("input.e-custom-palette#" + this._rteId + "customcolor");
            colorpalette.appendTo(this._customColor);
			this.colorobj=this._customColor.find(".e-custom-palette").ejColorPicker({ enableRTL: this.model.enableRTL,enableOpacity:true,showRecentColors:true,modelType: "picker",cssClass: this.model.cssClass,showSwitcher: false,select:function(args){ 
			
			   proxy._checkColor(args.value); 
			   
			 },
			
		    }).data("ejColorPicker");
            var model = this._getDialogModel();
            model.width = "auto";
		    model.height="auto";
			model.minWidth="220px";
		    model.htmlAttributes={"class":"e-custom-Dialog"}
            model.title = this._getLocalizedLabels("customFontColor");
            model.target = null;
            model.showRoundedCorner = this.model.showRoundedCorner;
            model.closeIconTooltip = this._getLocalizedLabels("closeIcon");
            this._customColor.ejDialog(model);
	        this._customDialogobj=(this._customColor).ejDialog("instance");
            this._customColor.closest(".e-dialog-wrap").addClass("e-rte");
		    this.colorobj.popupContainer.appendTo(palette);
		    this.colorobj.popupContainer.css({"display":"block","border-style":"none"});
		    $("#"+this._rteId+"_customColorDialog").find("span.e-colorwidget.e-picker").remove();
		    $("#"+this._rteId+"_customColorDialog").prepend(palette);
		    this.colorobj._hidePopup=function () {
              if($("#"+this._rteId+"_customColorDialog").ejDialog("isOpen"))
			     $("#"+this._rteId+"_customColorDialog").ejDialog("close"); 
		    !this.colorobj.model.displayInline && this.colorobj.hide();
		     }
           this._on(this.colorobj._cancelTag, "click", this.colorobj._hidePopup);
            
        },
		
		_openColorpalette:function(e)
		{
		  if(!this._customColor)
				this._createcustomColorpalette();
		  if (e.currentTarget.id == this._rteId + "_customcolor") {
		       this._fontclick=true;
		   if (!ej.isNullOrUndefined(this._splitMenu))
               this._splitMenu.hide(e);
	    } 
		else if (e.currentTarget.id == this._rteId + "_customBGcolor") {
	     	     this._fontclick=false;
		    if (!ej.isNullOrUndefined(this._bgSplitMenu))
                this._bgSplitMenu.hide(e);
		
		}
		     this._customColor.ejDialog("open");

		},
		
		
		_checkColor:function(e)
		{
		  if(this._fontclick)
		  {
		  this._onFontColor(e);
		  this._fontColor=e;
		  }
		  else
		  {
		  this._onBGColor(e);
		  this._bgColor=e;		
		  }
		},
	
		
		
        _createTableClose: function (e) {
            if ((!ej.isNullOrUndefined(this._createTable)) && ((!ej.isNullOrUndefined(e) && $(e.target).parents("#" + this._rteId + "_" + "tables").length <= 0) || ej.isNullOrUndefined(e))) {
                if (!ej.isNullOrUndefined(this._createTable.data("ejDialog"))) {
                    if (ej.isNullOrUndefined(e) || (e.target != this._createTable[0] && $(e.target).parents(".e-rte-table-picker").length <= 0)) {
                        this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
                        this._createTable.find("div.e-rte-eTblProperties").addClass('e-disable');
                    }
                    if (this._createTable.ejDialog("isOpened") && this.model.isResponsive&&(!$(e.target).find("div#" + this._toolBarObj.element[0].id + "_hiddenlist").hasClass("e-inline"))) this._toolBarObj._liTemplte.removeClass("e-display-none");
                    else if (this.model.isResponsive && !ej.isNullOrUndefined(e) && !$(e.target).is($("#" + this._toolBarObj.element[0].id + "_target")) && !($(e.target).closest("div#" + this._toolBarObj.element[0].id + "_hiddenlist").length != 0 || $(e.target).parents().hasClass("e-ddl-popup"))) this._toolBarObj._liTemplte.addClass("e-display-none");
                }
            }
            else
                $(this._createTable.find("div.e-rte-eTblProperties").hasClass('e-disable')).addClass('e-disable');
        },
        _rteinlineClick: function(e){
            if($(e.target).hasClass("e-inlinearrow"))
		       this._setIframeHeight();
        },
        _documentClick: function (e) { 
          if(this.model.toolbarOverflowMode!="inline")
              this._createTableClose(e);
            if (this._isIE() && !window.getSelection) {
                var checkdropdown = e.target.id;
                if (checkdropdown == "")
                    checkdropdown = e.target.parentNode.id;
                if (checkdropdown == (this._rteId + "_fontSizeDDL") || checkdropdown == (this._rteId + "_fontNameDDL") || checkdropdown == (this._rteId + "_formatDDL") || checkdropdown == (this._rteId + "_fontSizeDDL_dropdown") || checkdropdown == (this._rteId + "_fontNameDDL_dropdown") || checkdropdown == (this._rteId + "_formatDDL_dropdown"))
                    this._restoreSelection(this._selectionRange);
            }
        },


        _iframeFocus: function (e) {
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("isOpened") && this._createTable.ejDialog("close");
            !$(this._fontSizeDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontSizeDDL) && this._fontSizeDDL.hasClass("e-dropdownlist") && this._fontSizeDDL.ejDropDownList("hidePopup");
            !$(this._fontStyleDDL).parents("ul.e-rte-fontgroup").length == 0 && !ej.isNullOrUndefined(this._fontStyleDDL) && this._fontStyleDDL.hasClass("e-dropdownlist") && this._fontStyleDDL.ejDropDownList("hidePopup");
            !$(this._formatDDL).parents("ul.e-rte-format").length == 0 && !ej.isNullOrUndefined(this._formatDDL) && this._formatDDL.hasClass("e-dropdownlist") && this._formatDDL.ejDropDownList("hidePopup");
            !ej.isNullOrUndefined(this._createTable) && this._createTable.ejDialog("close");
            !ej.isNullOrUndefined(this._splitMenu) && this._splitMenu.hide(e);
            !ej.isNullOrUndefined(this._bgSplitMenu) && this._bgSplitMenu.hide(e);
            !ej.isNullOrUndefined(this._orderSplitObj) && this._orderSplitObj.hide(e);
            !ej.isNullOrUndefined(this._unOrderSplitObj) && this._unOrderSplitObj.hide(e);
        },
        _updateKeyDownSelectStatus: function (_toolEle, commandName) {
            if (!_toolEle.hasClass("e-active"))
                this._toolBarObj.selectItemByID(this._rteId + "_" + commandName);
            else
                this._toolBarObj.deselectItemByID(this._rteId + "_" + commandName);
        },
        _iframeKeyDown: function (e) {
            var _toolEle, ele, _newElement;
            
            if (this.model.showToolbar && this.model.allowKeyboardNavigation && e) {
                if (e.ctrlKey) {
                    e.keyCode == 65 ? this._contolAKeyfalg = true : ej.isNullOrUndefined(this._contolAKeyfalg) ? this._contolAKeyfalg : this._contolAKeyfalg = false;
                    var _proxy = this;
                    switch (e.keyCode) {
                        case 48://Reset zoom
                            e.preventDefault();
                            $(this.getDocument().body).css({ "zoom": 1, "transform": "scale(1)", "transform-origin": "0 0", "-o-transform": "scale(1)", "-o-transform-origin": "0 0", "-webkit-transform": "scale(1)", "-webkit-transform-origin": "0 0" });
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomIn")).attr("title", _proxy._getLocalizedLabels("zoomIn") + " 100%");
                            $(_proxy._toolBarObj.itemsContainer.find(".e-rteItem-zoomOut")).attr("title", _proxy._getLocalizedLabels("zoomOut") + " 100%");
                            _proxy._zoomValue = 1;
                            return false;
                        case 57:// Zoom in
                            e.preventDefault();
                            this._onKeyZoom("IN");
                            return false;
                        case 173:
                        case 189:// Zoom out
                            e.preventDefault();
                            this._onKeyZoom("OUT");
                            return false;
                        case 80:// Print
                            e.preventDefault();
                            this._onPrint();
                            return false;
                        case 66://B
                            if (!e.shiftKey) {//bold
                                e.preventDefault();
                                _toolEle = this._toolBarItems.find("li.e-rteItem-bold");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onBold();
                                    this._updateKeyDownSelectStatus(_toolEle, "bold");
                                    this._onChange();
                                    this._setBackupData()
                                };
                                return false;
                            }
                            break;
                        case 72:
                            if (e.shiftKey) {//sourcecode	view.
                                e.preventDefault();
                                this._getPasteRangeVal();
                                this._sourceCodeManager();
                                return false
                            }
                            break;
                        case 73://I
                            e.preventDefault();
                            if (e.shiftKey)
                                this._imageManager();
                            else {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-italic");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onItalics();
                                    this._setBackupData();
                                    this._updateKeyDownSelectStatus(_toolEle, "italic");
                                    this._onChange();
                                }
                            }
                            return false;
                        case 85://U
                            e.preventDefault();
                            if (e.shiftKey)//UpperCase
                                this._onUpperCase();
                            else//Underline
                            {
                                _toolEle = this._toolBarItems.find("li.e-rteItem-underline");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onUnderLine();
                                    this._updateKeyDownSelectStatus(_toolEle, "underline");                                    
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 76://L
                            e.preventDefault();
                            if (e.shiftKey)//Lowercase
                                this._onLowerCase();
                            else {
                                if (!this._toolBarItems.find("li.e-rteItem-justifyLeft").hasClass("e-disable")) {
                                    this._onJustifyLeft();
                                    this._alignToolUpdate("justifyLeft");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 82://R
                            e.preventDefault();
                            if (e.altKey)//Remove table row.
                                this.removeRow();
                            else if (e.shiftKey)//remove formate
                                this._onClearFormat();
                            else {//Jutfy Right.
                                _toolEle = this._toolBarItems.find("li.e-rteItem-justifyRight");
                                if (!_toolEle.hasClass("e-disable")) {
                                    this._onJustifyRight();
                                    this._alignToolUpdate("justifyRight");
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 69://E
                            if (e.shiftKey) {//editable                          
                                e.preventDefault();
                                this._openCustomTable(e);
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            else if (!this._toolBarItems.find("li.e-rteItem-justifyCenter").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyCenter();
                                this._setBackupData();
                                this._alignToolUpdate("justifyCenter");
                                this._onChange();
                                return false;
                            }
                            break;
                        case 74://J							
                            if (!this._toolBarItems.find("li.e-rteItem-justifyFull").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onJustifyFull();
                                this._alignToolUpdate("justifyFull");
                                this._setBackupData();
                                this._onChange();
                                return false;
                            }
                            break;
                        case 90://Z							
                            if (!this._toolBarItems.find("li.e-rteItem-undo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onUndo();
                                return false;

                            }
                            break;
                        case 89://Y

                            if (!this._toolBarItems.find("li.e-rteItem-redo").hasClass("e-disable")) {
                                e.preventDefault();
                                this._onRedo();
                                return false;
                            }
                            break;
                        case 67://C							
                            if (e.altKey)//Remove table column
                            {
                                e.preventDefault();
                                this.removeColumn();
                                return false;
                            }
                            else if (e.shiftKey) {//custom Table
                                e.preventDefault();
                                this._getPasteRangeVal();
                                if (this._customTableDialog)
                                    this._renderTableDialog();
                                this._customTableDialog.ejDialog("open");
                                return false;
                            }
                            else if (this._toolBarItems.find("li.e-rteItem-copy").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            break
                        case 88://X
                            if (this._toolBarItems.find("li.e-rteItem-cut").hasClass("e-disable")) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            this._onChange();
                            break;
                        case 86://V
                            if (this._toolBarItems.find("li.e-rteItem-paste").hasClass("e-disable") || ((this.model.maxLength <= $.trim(this._getText()).length) && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : this._contolAKeyfalg))) {
                                e.preventDefault();
                                this._keypressFlag = false;
                                return false;
                            }
                            else if (e.shiftKey)//Video insertion.
                            {
                                e.preventDefault();
                                this._keypressFlag = false;
                                this._selectCommand("video");
                                return false;
                            }
                            break;
                        case 77://M
                            e.preventDefault();
                            if (e.shiftKey) {//Outdent.
                                if (!this._toolBarItems.find("li.e-rteItem-outdent").hasClass("e-disable")) {
                                    this._onOutdent();
                                    if (this._indentdepth > 0)
                                        this._indentdepth--;
                                }
                            }
                            else { //Indent.
                                if (!this._toolBarItems.find("li.e-rteItem-indent").hasClass("e-disable")) {
                                    this._onIndent();
                                    this._indentdepth++;
                                }
                            }
                            this._setBackupData();
                            this._onChange();
                            return false;
                        case 75:
                            e.preventDefault();
                            if (e.shiftKey)
                                this._onUnlink();
                            else
                                if (!this._toolBarItems.find("li.e-rteItem-createLink").hasClass("e-disable"))
                                    this._hyperLinkManager(false);
                            return false;

                        case 188://<							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(false);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            this._onChange();
                            break;
                        case 190://>							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._changeFontsize(true);
                                this._onChange();
                                return false;
                            }
                            this._setBackupData();
                            break;
                        case 61:
                        case 187://+
                            e.preventDefault();
                            (e.shiftKey) ? this._onSuperScript() : this._onSubScript();
                            this._onChange();
                            this._setBackupData();
                            return false;
                        case 79://O							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this.executeCommand('insertorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            else if (e.altKey) {
                                e.preventDefault();
                                this.executeCommand('insertunorderedlist', "listItem");
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 83://S							
                            if (e.shiftKey)//strike the content.
                            {
                                e.preventDefault();
                                this._onStrikeThrough();
                                this._onChange();
                                this._setBackupData();
                                return false;
                            }
                            break;
                        case 70://F							
                            if (e.shiftKey) {
                                e.preventDefault();
                                this._selectCommand("fullScreen");
                                return false;
                            }
                            else if (!e.altKey) {
                                e.preventDefault();
                                if (ej.RTE.FindAndReplace)
                                    this._showFindAndReplace();
                                return false;
                            }
                            break;
                        case 37://left arrow.							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 39://right arrow.							
                            if (e.shiftKey  && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertColumn(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 38://up arrow.
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(true);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 40://downarrow							
                            if (e.shiftKey && $(this._currentSelNode).closest("table").length) {
                                e.preventDefault();
                                this.insertRow(false);
                                this._onChange();
                                return false;
                            }
                            break;
                        case 65://A
                            if (e.altKey) {
                                e.preventDefault();
                                this.removeTable();
                                return false;
                            };
                            break
                        case 121://F10
                            e.preventDefault();
                            this._clearAllManager();
                            return false;
                        case 84://T
                            if (e.altKey && this._toolBarItems) { // Alt+ Ctrl + T.
                                this._toolBarItems.focus();
                                break;
                            }
                    }
                }
                else if ((e.keyCode == 9 ) && !(this._isIE8() ? this._currentSelNode.nodeName.toLowerCase() == "td" : this._getSelectedNode().nodeName.toLowerCase() == "td")) {
                    this._keypressFlag = true;
                    this.executeCommand('inserthtml', "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", true);
                    return false;
                }
                else if (e.keyCode == 8) {//Backspace for removing the indent.
                    ele = this._getSelectedNode();
                    if ($(ele).find("span#RTE_imgDupDiv").length > 0)
                        $(this._imgDupDiv).remove();
                    if ($(ele).parents("BLOCKQUOTE").length > 0) {
                        this._onOutdent();
                        e.preventDefault();
                    }
                }
            }
            else if (e.ctrlKey == true && (e.keyCode == 66 || e.keyCode == 73 || e.keyCode == 85 || e.keyCode == 76 || e.keyCode == 82 || e.keyCode == 69 || e.keyCode == 74 || e.keyCode == 90 || e.keyCode == 89 || e.keyCode == 67 || e.keyCode == 88 || e.keyCode == 86 || e.keyCode == 8 || e.keyCode == 46) && !this.model.allowKeyboardNavigation)
                e.preventDefault();
            if (this.model.maxLength != null && (ej.isNullOrUndefined(this._contolAKeyfalg) ? true : !this._contolAKeyfalg)) {
                try {
                    if (this._isIE8() && e.keyCode == 86 && !((this.model.maxLength) >= (window.clipboardData.getData("Text").length + $.trim(this._getText()).length)))
                        e.preventDefault();
                    else
                        this._validateMaxLength(e);
                }
                catch (error) { }
            }
            if (this._isIE8() ? (this._currentSelNode && this._currentSelNode.nodeName.toLowerCase() == "td") : this._getSelectedNode().nodeName.toLowerCase() == "td") {
                ele = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
               var _newElementIndex = $(ele).parent().children().index($(ele));
                if (e.keyCode == 9 && !e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.nextSibling)) ? ele.nextSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling) ? $(ele).parents("tr")[0].nextSibling.childNodes[0] : (!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling)) ? ($(ele).parents("table")[0].nextSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].nextSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                if (e.keyCode == 9 && e.shiftKey) {
                    _newElement = (!ej.isNullOrUndefined(ele.previousSibling)) ? ele.previousSibling : (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling) ? $(ele).parents("tr")[0].previousSibling.childNodes[$(ele).parents("tr")[0].previousSibling.childNodes.length - 1] : (!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) ? ($(ele).parents("table")[0].previousSibling.nodeName.toLowerCase() == "td") ? $(ele).parents("table")[0].previousSibling : ele : ele);
                    this._setTableSelection(_newElement, e);
                }
                else if (e.keyCode == 40)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].nextSibling)) ? $(ele).parents("tr")[0].nextSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].nextSibling) && !this._isIE8()) ? $(ele).parents("table")[0].nextSibling : ele);
                else if (e.keyCode == 38)
                    _newElement = (!ej.isNullOrUndefined($(ele).parents("tr")[0].previousSibling)) ? $(ele).parents("tr")[0].previousSibling.children[_newElementIndex] : ((!ej.isNullOrUndefined($(ele).parents("table")[0].previousSibling)) && !this._isIE8() ? $(ele).parents("table")[0].previousSibling : ele);
                if (e.keyCode == 9 && ele == _newElement && !ej.isNullOrUndefined($(ele).parents("tr")[0])) {
                    this.insertRow(false);
                    this._setRange(this._isIE8() ? $(this._getRange().parentElement()).parents("tr").next().children().first()[0] : $(this._getRange().startContainer).parents("tr").next().children().first()[0], this._getRange(), true);
                    e.preventDefault();
                }
                else if ((e.keyCode == 9 && this._isIE8()) || e.keyCode == 40 || e.keyCode == 38) {
                    this._setRange(_newElement, this._getRange(), true);
                    e.preventDefault();
                }
                if (this._isIE8())
                    this._getRange().parentElement && (this._currentSelNode = this._getRange().parentElement());
            }
            if ($(e.target).parents("table").length == 0) $(this._getDocument()).find(".e-rte-tablebox").remove();
            this._setAutoHeight();
            this._trigger("keydown", { keyCode: e.keyCode });
        },
        _changeFontsize: function (status) {
            var fontSize = parseInt(this._getCommandValue('fontsize')) ? parseInt(this._getCommandValue('fontsize')) : 2;
            if ((!status && fontSize > this.model.fontSize[0].value) || (status && fontSize < this.model.fontSize[this.model.fontSize.length - 1].value)) {
                this._onFontSize(status ? fontSize + 1 : fontSize - 1);
                this._updateFontOptionStatus();
            }
        },
        _iframeKeypress: function (e) {
            if (!this._keypressFlag) {
                e.preventDefault();
                this._keypressFlag = true;
                return false;
            }
        },
        _setTableSelection: function (_newElement, e) {
            if (!this._isIE8() && !((_newElement.childNodes.length == 1 && _newElement.childNodes[0].nodeName == "BR") || (_newElement.childNodes.length == 0))) {
                var range = this._getDocument().createRange();
                range.selectNodeContents(_newElement);
                this.selectRange(range);
            }
            else this._setRange(_newElement, this._getRange(), true);
            e.preventDefault();
        },
        _setAutoHeightValue: function (selectedtext) {
            if (selectedtext.nodeName == "#text") {
                if (selectedtext.parentNode.nodeName == "BODY") {
                    $(selectedtext).wrap("<div></div>");
                    this.selectRange(this._getRange());
                }
               var range = $(selectedtext.parentNode).position().top + parseInt($(selectedtext.parentNode).css("height"));
            }
            if (selectedtext.nodeName == "DIV")
                range = $(selectedtext).position().top + parseInt($(selectedtext).css("height"));
            return range;
        },
        _setAutoHeight: function () {
            if (this.model.autoHeight)
                this._autoHeight();
            else if (!ej.isNullOrUndefined(this._getDocument())) $(this._getDocument().body).css("overflow", "");
        },
        _autoHeight: function () {
			var toolbarHeight = this._toolBarItems?this._toolBarItems.outerHeight():0;
            if (!ej.isNullOrUndefined(this._getDocument().body)) {
                $(this._getDocument().body).css("overflow", "hidden");
                var iframeTop = (!ej.isNullOrUndefined(this._getDocument().body.lastChild)) ? this._getDocument().body.lastChild.clientHeight + this._getDocument().body.lastChild.offsetTop : 0;
                if ((parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) <= iframeTop)
                    $(this._rteIframe[0]).css("height", (iframeTop + 30) + "px");
                else
                    $(this._rteIframe[0]).css("height", (parseInt($(this._rteWapper[0]).css("min-height")) - toolbarHeight) + "px");
                var range = 0;
                range = (window.getSelection && !ej.isNullOrUndefined(this._getRange().startContainer)) ? this._setAutoHeightValue(this._getRange().startContainer) : (((this._getDocument().selection) && !ej.isNullOrUndefined(this._ieParents(this._getRange())[0])) ? this._setAutoHeightValue(this._ieParents(this._getRange())[0]) : 0);
                if (range >= (this._rteIframe.height() - 30)) {
                    if (this._rteIframe[0].contentDocument)
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentDocument.documentElement.scrollHeight + 20) + "px");
                    else
                        $(this._rteIframe[0]).css("height", (this._rteIframe[0].contentWindow.document.body.scrollHeight + 20) + "px");
                }
                this._rteWapper.outerHeight(this._rteEditor.outerHeight() + toolbarHeight + parseInt(this.model.showFooter ? 19 : 0));
            }
        },
        _ieSelRange: function () {
            if (this._isIE()) {
                this._selectionRange = "";
                this._ieSelectionRange = this._getRange();
                this._seleText = ej.isNullOrUndefined(this._getWindow().document.selection) ? this._selectionRange.toString() : this._getWindow().document.selection.createRange().text;
            }
            else
                this._ieSelectionRange = this._ieSelection;
        },
        _iframeSelectionChange: function (e) {
            this._trigger("select", { event: e, model: this.model });
        },
        _ignorekeyArray: [13, 32, 8, 46],
        _iframeKeyUp: function (e) {
            //if (!(e.which >= 37 && e.which <= 40))
            //    this._updateValue();
            $(this._imgDupDiv).remove();
            $(this._imgOrg).css("outline", "");
            if(this._getSelectedNode().parentNode.localName == "td" || this._getSelectedNode().parentNode.localName == "tr")this._toggleEditTable();
            if ($.inArray(e.which, this._ignorekeyArray) != -1)
                this._setBackupData();
            if (e.ctrlKey && (e.keyCode == 57 || e.keyCode == 189))
                this._zoomUp();
                if(e.keyCode == 37 ||e.keyCode == 39 || e.keyCode == 38 || e.keyCode == 40 || e.keyCode == 36 || e.keyCode == 35 || e.keyCode==9){               // top, left, right, left, home and end key code
            this._updateToolbarStatus();
            this._updateFontOptionStatus();
            this._updateFormat();
                }
            if(this.model.showFooter && (this.model.showWordCount||this.model.showCharCount))this._updateCount();
            var selectEle = this._isIE8() ? this._currentSelNode : this._getSelectedNode();
            if (this.model.showToolbar)
                this._isIE8() ? selectEle.nodeName.toLowerCase() : selectEle.nodeName.toLowerCase() != "a" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            this._updateTagInfo(selectEle);            
            this._ieSelRange();
            this._trigger("keyup", { keyCode: e.keyCode });
            this._iframeSelectionChange(e);
            if (e.ctrlKey)
                switch (e.keyCode) {
                    case 88://X
                    case 86://V
                        this._onChange();
                        break;
                }
			if((e.keyCode==46||e.keyCode==8) && (this._getDocument().body.innerHTML==''||this._getDocument().body.innerHTML=="<br>"))
			 this._emptyContent();
			
        },
        _iframeMouseUp: function (e) {
            this._tableResizeUp(e);
			this._zoomUp(e);
            this._resizeBtnInit();
            if (!ej.isNullOrUndefined(this._imgDup) && $(this._imgOrg).parents("body").length > 0) {
                $(this._imgOrg).css({ "width": $(this._imgDup).css("width"), "height": $(this._imgDup).css("height") });
                $(this._imgOrg).position({ left: $(this._imgDup).position().left, top: $(this._imgDup).position().top });
                $(this._imgDup).css("display", "none");
                this._resizeImgPos();
                this._setAutoHeight();
            }
            if (e.target.nodeName != "IMG" && !$(e.target).hasClass("e-rte-imageboxmark")) {
                $(this._imgOrg).css("outline", "");
                $(this._imgDupDiv).remove();
                this._off($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            }
            if (e.target.nodeName == "IMG" && $(e.target).parents("body").length > 0) {
                var range = (this._isIE8()) ? this._getDocument().body.createTextRange() : this._getDocument().createRange();
                (this._isIE8()) ? range.moveToElementText(e.target) : range.selectNode(e.target);
                this.selectRange(range);
            }
            this._currentSelNode = e.target; //For IE
            if (e.currentTarget && e.target.nodeName && e.target.nodeName.toLowerCase() == "html" && this._getDocument() && this._getDocument().body && (this._isIE8() ? true : this._getRange().startOffset == this._getRange().endOffset)) {
                this._isIE() && e.currentTarget.createRange && this._setRange(this._isIE8() ? this._getDocument().body : this._getRange().startContainer, e.currentTarget.createRange(), true);
                this._getDocument().body.focus();
            }
            this._toggleEditTable();
            this._updateToolbarStatus();
            var isRightClick;
            if (e.button) isRightClick = (e.button == 2);
            else if (e.which) isRightClick = (e.which == 3);
            if (!isRightClick) {
                this._updateFormat();
                this._updateFontOptionStatus();
            }
            this._ieSelRange();
            this._iframeSelectionChange(e);
            if (this._fontStyleDDL && !ej.isNullOrUndefined(this._fontStyleDDL.data("ejDropDownList")) && this._fontStyleDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontStyleDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");
            if (this._fontSizeDDL && !ej.isNullOrUndefined(this._fontSizeDDL.data("ejDropDownList")) && this._fontSizeDDL.ejDropDownList("instance")._isPopupShown()) $(this._fontSizeDDL.ejDropDownList("instance").popupList.ejScroller("instance").element).trigger("mouseup");

        },
        _iframeMouseDown: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().designMode = "off";
            if (ej.browserInfo().name == "msie" && ej.browserInfo().version == "8.0")
                this._focus();
            this._contolAKeyfalg = false;
            this._updateTagInfo(e.target);
            this._updateIndent(e.target);
            if (this.model.showToolbar)
                e.target.nodeName != "A" ? this.disableToolbarItem("removeLink") : this.enableToolbarItem("removeLink");
            if (e.target.nodeName == "VIDEO" && this.model.allowEditing) this._preventDefaultResize();
            if (e.target.nodeName == "IMG" && this.model.allowEditing) {
                this._preventDefaultResize();
                this._imageClick(e.target);
            }
            if ($(e.target).hasClass("e-rte-imageboxmark")) {
                this._resizeBtnInit();
                this._commonBoxDown = true;
                if ($(e.target).hasClass("e-rte-rigmed")) this._rigMidBox = true;
                if ($(e.target).hasClass("e-rte-toplef")) this._topLefBox = true;
                if ($(e.target).hasClass("e-rte-topmed")) this._topMidBox = true;
                if ($(e.target).hasClass("e-rte-toprig")) this._topRigBox = true;
                if ($(e.target).hasClass("e-rte-lefmed")) this._lefMidBox = true;
                if ($(e.target).hasClass("e-rte-botlef")) this._botLefBox = true;
                if ($(e.target).hasClass("e-rte-botmid")) this._botMidBox = true;
                if ($(e.target).hasClass("e-rte-botrig")) this._botRigBox = true;
                return false;
            }
            if ($(e.target).hasClass("e-rteColumnResizer")) {
                this._lastCol = $(e.target).hasClass("e-rtelastcol") ? true : false;
                this._columnEle = $(this._curTable).find("tr:first td").eq(parseInt($(e.target).attr("data-col")))[0];
                this._columnDown = true;
                this._columnIndex = this._columnEle.cellIndex;
                $(this._getDocument().body).after("<span class='colresizerline'style='cursor:col-resize;position:absolute;width:0px;border-left: 1px dashed #787878;height:" + $(this._columnEle).closest("table").height() + "px;left:" + e.pageX + "px;top:" + $(this._columnEle).offset().top + "px;'></span>");
            }
            if ($(e.target).hasClass("e-rteRowResizer")) {
                this._rowEle = $(this._curTable).find("tr").eq(parseInt($(e.target).attr("data-row")))[0];
                this._rowDown = true;
            }
            if ($(e.target).hasClass("e-rte-tablebox")) {
                this._boxDown = true;
                this._boxElement = this._curTable;
            }
            if ($(e.target).hasClass("e-rte-tablebox") || $(e.target).hasClass("e-rteRowResizer") || $(e.target).hasClass("e-rteColumnResizer"))
                this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);
            if ((ej.browserInfo().name == "msie" || ej.browserInfo().name == "chrome") && (e.ctrlKey == true && e.which == 1)) {
                if (e.target.tagName.toUpperCase() == 'A' && !ej.isNullOrUndefined($(e.target).attr('href')))
                    window.open($(e.target).attr('href'), "_blank");
            }
            if (this.model.isResponsive && !ej.isNullOrUndefined(this._toolBarObj) && this._toolBarObj._liTemplte.children('ul').length > 0&&(!$(this._toolBarObj._liTemplte).hasClass("e-inline"))) {
                this._toolBarObj.contstatus = true;
                this._toolBarObj._liTemplte.addClass("e-display-none");
                this._toolBarObj.contstatus = false;
            }
            this._iframeFocus();
            this._onChange();
        },
        _iframeFocusOut: function (e) {
            if (e.data) {
                e.data._proxy._onChange();
                e.data._proxy._selectionRange = e.data._proxy._isIE8() ? e.data._proxy._getRange() : e.data._proxy._saveSelection();
                e.data._proxy._seleText = ej.isNullOrUndefined(e.data._proxy._getWindow().document.selection) ? e.data._proxy._selectionRange.toString() : !e.data._proxy._isIE8() ? e.data._proxy._getWindow().getSelection().toString() : e.data._proxy._getWindow().document.selection.createRange().text;
            }
        },
        _widthFocusOut: function (e) {
            var dialog, drpdwnId, widthId;
            if (this._customTableDialog.ejDialog("isOpen")) {
                dialog = this._customTableDialog;
                drpdwnId = "#" + this._rteId + "_ddlAlignment";
                widthId = "#" + this._rteId + "_txtWidth";
            }
            else {
                dialog = this._eTblDialog;
                drpdwnId = "#" + this._rteId + "_eTblAlign";
                widthId = "#" + this._rteId + "_eTblWidth";
            }
            var val = dialog.find(widthId).val();
            var obj = $(drpdwnId).data('ejDropDownList');
            var option = (val && val != '' && !isNaN(val) || (val.slice(-2) == 'px') || (val.slice(-2) == 'em') || (val.slice(-2) == 'pt') || (val.slice(-1) == '%')) ? true : false;
            obj.option('enabled', option);
        },
        _windowResize: function (e) {
            this._setAutoHeight();
            this._setIframeHeight();
			this._updateCount();
        },
        _tableResizeUp: function (e) {
            if ($(this._getDocument()).find("table.e-rte-table").length && (this._columnDown || this._rowDown || this._boxDown)) {
                if (this._currentTable && this._columnDown && this._columnDownClick) {
                    if (!this._lastCol) {
                        this._currentTable.eq(this._columnIndex - 1).width(this.nexColIndexWid);
                        this._currentTable.eq(this._columnIndex).width(this._columnIndexWid);
                    }
                    else {
                        this._currentTable.closest("table").find("tr:first td").each(function () {
                            if (this.style.width == "") $(this).width(parseInt($(this).closest("table").width() / ($(this).siblings().length + 1)));
                        });
                        this._currentTable.eq(this._columnIndex).width(this.lasColIndexWid);
                        this._currentTable.closest("table").css({ "width": "" });
                        $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (this._currentTable.eq(this._columnIndex).offset().left + this._currentTable.eq(this._columnIndex).outerWidth()) + "px" });
                    }
                }
                this._removeResizeObject();
                $(this._getDocument()).find(".colresizerline").remove();
                $(this._getDocument()).find(".e-rte-tablebox").css("display", "none");
                this._restoreSelection(this._tableSelection);
                this._columnDown = false;
                this._rowDown = false;
                this._boxDown = false;
                this._columnDownClick = false;
            }
            else {
                $(this._getDocument()).find(".e-rte-tablebox").remove();
                this._tableSelection = this._getRange();
            }
        },
        _resizeBtnInit: function () {
            this._commonBoxDown = false;
            this._rigMidBox = false;
            this._topLefBox = false;
            this._topMidBox = false;
            this._topRigBox = false;
            this._lefMidBox = false;
            this._botLefBox = false;
            this._botMidBox = false;
            this._botRigBox = false;
        },
        _imgSpanBox: function (e) {
            this._resizeBtnInit();
            this._imgOrg = e;
            this._imgDupDiv = ej.buildTag("span#RTE_imgDupDiv");
            this._imgDup = ej.buildTag("img#RTE_imgdivspan", "", { "display": "none", "position": "absolute", "background-size": "100% 100%", "outline": "1px dashed #000", "opacity": ".64" }, {}).appendTo(this._imgDupDiv);
            this._topLef = ej.buildTag("span.e-rte-imageboxmark e-rte-toplef#RTE_toplef", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._topMid = ej.buildTag("span.e-rte-imageboxmark e-rte-topmed#RTE_topmed", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._topRig = ej.buildTag("span.e-rte-imageboxmark e-rte-toprig#RTE_toprig", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._leftMid = ej.buildTag("span.e-rte-imageboxmark e-rte-lefmed#RTE_lefmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._rigMid = ej.buildTag("span.e-rte-imageboxmark e-rte-rigmed#RTE_rigmed", "", { "cursor": "ew-resize" }, {}).appendTo(this._imgDupDiv);
            this._botLef = ej.buildTag("span.e-rte-imageboxmark e-rte-botlef#RTE_botlef", "", { "cursor": "nesw-resize" }, {}).appendTo(this._imgDupDiv);
            this._botMid = ej.buildTag("span.e-rte-imageboxmark e-rte-botmid#RTE_botmid", "", { "cursor": "ns-resize" }, {}).appendTo(this._imgDupDiv);
            this._botRig = ej.buildTag("span.e-rte-imageboxmark e-rte-botrig#RTE_botrig", "", { "cursor": "nwse-resize" }, {}).appendTo(this._imgDupDiv);
            this._resizeImgPos();
            this._resizeImgDupPos();
            $(this._getDocument().body).after(this._imgDupDiv);
            $(e).css({ "outline": "1px dashed #5C5C5C" });
            this._on($(this._getDocument()), "mousemove", this._imgBoxMouseMove);

        },
        _resizeImgPos: function () {
            this._ltPos = $(this._imgOrg).position();
            this._imgWid = $(this._imgOrg).css("width");
            this._imgHgt = $(this._imgOrg).css("height");
            this._imgDup.css({ "width": this._imgWid, "height": this._imgHgt, "left": this._ltPos.left + "px", "top": this._ltPos.top + "px", "border": $(this._imgOrg).css("border") });
            this._imgDup.attr({ "src": $(this._imgOrg).attr("src") });
            var _wid = (parseInt($(this._imgOrg).css("width")) - 2) + this._ltPos.left;
            var _midWid = ((parseInt($(this._imgOrg).css("width")) - 2) / 2) + this._ltPos.left;
            var _hgt = (parseInt($(this._imgOrg).css("height")) - 2) + this._ltPos.top;
            var _midHgt = ((parseInt($(this._imgOrg).css("height")) - 2) / 2) + this._ltPos.top;
            var _imgborder = parseInt($(this._imgOrg).css("border-width") == "" ? 0 : $(this._imgOrg).css("border-width"));
            $(this._rigMid).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_midHgt) + "px" });
            $(this._botLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._botMid).css({ "left": (_midWid) + "px", "top": (_hgt + (2 * _imgborder)) + "px" });
            $(this._topRig).css({ "left": (_wid + (2 * _imgborder)) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topLef).css({ "left": (this._ltPos.left - 3) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._topMid).css({ "left": (_midWid) + "px", "top": (this._ltPos.top - 3) + "px" });
            $(this._leftMid).css({ "left": (this._ltPos.left - 3) + "px", "top": (_midHgt) + "px" });

        },
        _resizeImgDupPos: function () {
            this._ltDupPos = $(this._imgOrg).position();
            this._imgMidWid = $(this._imgOrg).css("width");
            this._imgDupHgt = $(this._imgOrg).css("height");
        },
        _imgBoxMouseMove: function (e) {
            if (this._commonBoxDown) {
                if (this._rigMidBox)
                    this._imgDupMouseMove(parseInt(e.pageX) - this._ltDupPos.left + "px", this._imgDupHgt, e);
                else if (this._lefMidBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", this._imgDupHgt, e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topMidBox) {
                    this._imgDupMouseMove(this._img_wid, ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._botMidBox)
                    this._imgDupMouseMove(this._img_wid, (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botRigBox)
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                else if (this._botLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", (e.pageY - this._ltDupPos.top) + "px", e);
                    $(this._imgDup).offset({ left: e.pageX });
                }
                else if (this._topRigBox) {
                    this._imgDupMouseMove((e.pageX - this._ltDupPos.left) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY });
                }
                else if (this._topLefBox) {
                    this._imgDupMouseMove(((parseInt(this._imgMidWid) + this._ltDupPos.left) - e.pageX) + "px", ((parseInt(this._imgDupHgt) + this._ltDupPos.top) - e.pageY) + "px", e);
                    $(this._imgDup).offset({ top: e.pageY, left: e.pageX });
                }
            }
            else if (this._columnDown) {
                this._columnDownClick = true;
                this._currentTable = $(this._columnEle).closest("table").find("tr:first td");
                var prevcolwid = (this._columnEle.style.width == "") ? $(this._columnEle).width() : parseInt(this._columnEle.style.width);
                var _columnEleLeft = $(this._columnEle).offset().left, actualwid = (_columnEleLeft > e.pageX) ? prevcolwid + (_columnEleLeft - e.pageX) : prevcolwid - (e.pageX - _columnEleLeft);
                var nexnodeWid = ($(this._currentTable).eq(this._columnIndex - 1)[0].style.width == "") ? $($(this._currentTable).eq(this._columnIndex - 1)).width() : parseInt($(this._currentTable).eq(this._columnIndex - 1)[0].style.width), totalwid = prevcolwid + nexnodeWid;
                if (!this._lastCol && actualwid > 15 && totalwid - actualwid > 15) {
                    this.nexColIndexWid = totalwid - actualwid;
                    this._columnIndexWid = actualwid;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                else if (this._lastCol && _columnEleLeft < e.pageX && e.pageX - _columnEleLeft > 15) {
                    this.lasColIndexWid = e.pageX - _columnEleLeft;
                    $(this._getDocument()).find(".colresizerline").css({ "left": e.pageX + "px" });
                }
                this._removeMouseSelection(e);
                $(this._columnEle).closest("table").find("tr:last td:last span.e-rte-tablebox").css({ "display": "none" });
            }
            else if (this._rowDown) {
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
                var _rowOffset = this._rowEle.offsetTop, _rowParentTop = this._rowEle.parentElement.parentElement.offsetTop;
                if ((e.pageY - (_rowOffset + _rowParentTop)) > 20)
                    this._rowEle.style.height = (e.pageY - (_rowOffset + _rowParentTop)) + "px";
                this._removeMouseSelection(e);
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": ($(this._rowEle).closest("table").width() + $(this._rowEle).closest("table").offset().left) + "px", "top": ($(this._rowEle).closest("table").height() + $(this._rowEle).closest("table").offset().top) + "px" });
            }
            else if (this._boxDown) {
                var boxEle = $(this._boxElement),boxParent = boxEle.parent(),boxPosition = boxEle.offset(), _width = (((e.pageX - boxPosition.left) / boxParent.width()) * 100), _height = (((e.pageY - boxPosition.top) / boxParent.height()) * 100);		
                if (ej.browserInfo().name === "chrome" || ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
                if(e.pageX > 0 && _width > 10 && _height > 0) {
                boxEle.attr({ "width": ( _width + "%"), "height": (_height + "%") });               
                $(this._getDocument()).find(".e-rte-tablebox").css({ "left": (boxEle.width() + boxPosition.left) + "px", "top": (boxEle.height() + boxPosition.top) + "px" });
                boxEle.find("tr:first td").each(function () {
                    var tdEle = $(this);
                    tdEle.width(parseInt(tdEle.closest("table").width() / (tdEle.siblings().length + 1))); });
                
                }
                this._removeMouseSelection(e);
            }

        },
        _removeMouseSelection: function (e) {
            if (ej.browserInfo().name === "mozilla") this._getDocument().getSelection().removeAllRanges();
            if (e.stopPropagation) e.stopPropagation();
            if (e.preventDefault) e.preventDefault();
            e.cancelBubble = true;
            e.returnValue = false;
            return false;
        },
        _imgDupMouseMove: function (width, height, e) {
            $(this._imgDup).css({ "display": "block", "width": width, "height": height });
            this._resizeImgDupPos();
            if (this._isIE8()) this._removeMouseSelection(e);
        },
        _imageClick: function (e) {
            $(this._getDocument().body).find("img").css("outline", "");
            if (this._imgDupDiv)
                this._imgDupDiv.remove();
            this._imgSpanBox(e);
        },
        _iframePaste: function (e) {
            var _proxy = this,temp=ej;
			if(e){
				try {
					var val = ej.isNullOrUndefined(window.clipboardData) ? e.originalEvent.clipboardData.getData("text/plain") : window.clipboardData.getData("Text");
					if (val.length != 0) {
						if (!((_proxy.model.maxLength) >= (val.length + $.trim(_proxy._getText()).length)))
							e.preventDefault();
					}
					else {
						var blob = e.originalEvent.clipboardData.items[0].getAsFile();
						var reader = new FileReader();
						reader.onload = function (event) {
							_proxy.executeCommand('inserthtml', "<img src=" + event.target.result + " alt />");
						};
						reader.readAsDataURL(blob);
					}
				}
				catch (error) { }
			}
            setTimeout(function () {
				_proxy._setBackupData();
				_proxy._onChange();
                _proxy._setAutoHeight();
                _proxy._updateCount();
                _proxy._pasteTableResize();
				
			if (temp.browserInfo().name == "webkit")
                _proxy._getWindow().focus();
            else
                _proxy._getWindow().document.body.focus();
            }, 0);
        },
        _pasteTableResize: function () {
            var tableCollection = $(this._getDocument()).find("table").not(".e-rte-table"), tableElement;
            for (var tableItem = 0; tableItem < tableCollection.length; tableItem++) {
                tableElement = $(tableCollection[tableItem]);
                tableElement.addClass("e-rte-table").removeAttr("style cellspacing").attr({ "border": 1, "cellspacing": 1, "width": tableElement.width() }).css({ "border": "1px solid#5C5C5C", "border-collapse": "separate", "border-spacing": "2px" });
                tableElement.find("table tr,td").removeAttr("style width");
                this._on(tableElement, "mouseover", this._tableMouseOver);
            }
        },
        _wireEvents: function () {
            var _iframe = $(this._getDocument());
            if (this._getDocument() != "") {
                if (!ej.isNullOrUndefined(this._createTable)) {
                    this._on(this._createTable, "mouseenter", "div.e-rte-tablecell", this._tableCellStart)
                    ._on(this._createTable, "mousemove", "div.e-rte-tablecell", this._tableCellSelect)
                    ._on(this._createTable, "mouseleave", "div.e-rte-table", this._tableCellLeave)
                    ._on(this._createTable, "mousedown", "div.e-rte-tablecell", this._tableCellDown)
                    ._on($(document), "click", this._documentClick);
                }
                this._on(_iframe, "focus", this._iframeFocus)
                ._on(_iframe, "keydown", this._iframeKeyDown)
                ._on(_iframe, "keypress", this._iframeKeypress)
                ._on(_iframe, "keyup", this._iframeKeyUp)
                ._on(_iframe, "mouseup", this._iframeMouseUp)
                ._on(_iframe, "mousedown", this._iframeMouseDown)                
                ._on($(window), "resize", this._windowResize);				
                if (this._isIE8() || !(this.model.pasteCleanupSettings && (this.model.pasteCleanupSettings.cleanElements || this.model.pasteCleanupSettings.removeStyles || this.model.pasteCleanupSettings.cleanCSS || this.model.pasteCleanupSettings.listConversion)))
					this._on(_iframe, "paste", this._iframePaste);
					
                if (!ej.isNullOrUndefined((document.getElementById(this._id + "_Iframe"))))
                    $(document.getElementById(this._id + "_Iframe").contentWindow).on('blur', { _proxy: this }, this._iframeFocusOut);
            }
        },

        _unwireEvents: function () {
            var _iframe = $(this._getDocument());
            if (!ej.isNullOrUndefined(this._createTable)) {
                this._off(this._createTable, "mousemove", "div.e-rte-tablecell")
                ._off(this._createTable, "mouseleave", "div.e-rte-table")
                ._off(this._createTable, "mousedown", "div.e-rte-tablecell")
                ._off($(document), "click", this._documentClick);
            }
            this._off(_iframe, "focus")
            ._off(_iframe, "keydown")
            ._off(_iframe, "keyup")
            ._off(_iframe, "mouseup")
            ._off(_iframe, "mousedown")
            ._off($(window), "resize", this._windowResize);
            $(document.getElementById(this._id + "_Iframe").contentWindow).off('blur', this._iframeFocusOut);
            if (!ej.isNullOrUndefined(this._customTableDialog))
                this._off(this._customTableDialog.find(".e-rte-txtWidth"), "focusout");

        },

        _footerEvents: function (val) {
            this[val](this._htmlSource, "click", this._sourceCodeManager);
            this[val](this._clearFormat, "click", this._onClearFormat);
            this[val](this._clearAll, "click", this._clearAllManager);
        },


        _onChange: function () {
           var _prevhtml = $.trim(this.value());
            if (this.model.enableXHTML) {
                this._updateXhtml();
                if (this.model.enableHtmlEncode)
                    this.value(this._encode(this._removeNoSpaceChar(this.value())));
            }
            if (_prevhtml !== this._removeNoSpaceChar(this.getHtml())) {
                this._updateValue();
                var args = { text: this._getText(), htmlText: this.getHtml(), isInteraction: this._isInteraction, };
                this._trigger("change", args);
                this._isInteraction = true;
            }
        },
        _disableIframeContent: function () {
            try {
                this._rteIframe.contents().find("body,[contenteditable='true']").attr("contenteditable", false);
            }
            catch (err) { }
        },

        disable: function () {
            this.model.enabled = false; this._showHideContextMenu();
            this.element.attr("disabled", "disabled");
            this._unwireEvents();
            this.model.showToolbar && this._toolBarObj.disable();
            $(this._rteFooter).ejTooltip("option", "enabled", false);
            this._disableIframeContent();
            this._rteEditor.addClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.addClass("e-disable");
                this._resize.removeClass("e-resizable");
                this._footerEvents("_off");
            }
            this._disableResizeObj(false);
        },

        enable: function () {
            this.model.enabled = true; this._showHideContextMenu();
            this.element.removeAttr("disabled");
            this._wireEvents();
            this.model.showToolbar && this._toolBarObj.enable();
            $(this._rteFooter).ejTooltip("option", "enabled", true);
            this._rteIframe.contents().find("body,[contenteditable='false']").attr("contenteditable", true);
            this._rteEditor.removeClass("e-disable");
            if (this.model.showFooter) {
                this._rteFooter.removeClass("e-disable");
                this._resize.addClass("e-resizable");
                this._footerEvents("_on");
            }
            this._disableResizeObj(true);
        },

        disableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.disableItemByID(this._rteId + "_" + id) : this._toolBarObj.disableItemByID(id);
            if (id == "undo") $("#" + this._rteId + "_" + id).addClass("e-rteTooldisable");
        },


        enableToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && ($(this._toolBarObj.target).find("#" + this._rteId + "_" + id).length != 0 || $(this._toolBarObj._liTemplte).find("#" + this._rteId + "_" + id).length != 0) ? this._toolBarObj.enableItemByID(this._rteId + "_" + id) : this._toolBarObj.enableItemByID(id);
            if (id == "undo" && $("#" + this._rteId + "_" + id).hasClass("e-rteTooldisable"));
            $("#" + id).removeClass("e-rteTooldisable");
        },


        removeToolbarItem: function (id) {
            !ej.isNullOrUndefined(id) && this._toolBarObj.removeItemByID(this._rteId + "_" + id);
            this._setIframeHeight();
        },

        refresh: function () {
            this._unwireEvents();
            this._setIFrames();
            this._setIframeHeight();
            if (this.model.enabled) this._wireEvents();
            else this._disableIframeContent();
            if (this.model.enableRTL) this._rteIframe.contents().find("body").css("direction", "rtl");
            this._showHideContextMenu();
        },


        show: function () {
            this._rteWapper.show();
            this._setIFrames();
        },


        hide: function () {
            this._rteWapper.hide();
        },

        setColorPickerType: function (value) {
            if (value == "palette" || value === "picker")
                this._imgPicker.option('modelType', value);
            else
                this._imgPicker.option('modelType', "default");
        },
        pasteContent: function (html) {
            this._pasteAPIFlag = true;
            this._pasteHtml(html);
            this._onChange();
        },
        getDocument: function () {
            return this._getDocument();
        },
        getHtml: function (encode) {
            if (this.model.enableXHTML) {
                if (this.model.enableHtmlEncode) {
                    if (encode == false)
                        return this._removeNoSpaceChar($.trim(this._decode(this.value())));
                    else
                        return this._removeNoSpaceChar($.trim(this.value()));
                }
                else
                    return this._removeNoSpaceChar($.trim(this.value()));
            }
            else {
                try {
                    if (this.model.enableHtmlEncode) {
                        if (encode == false)
                            return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                        else
                            return this._removeNoSpaceChar(this._encode($.trim(this._getDocument().body.innerHTML)));
                    }
                    else
                        return this._removeNoSpaceChar($.trim(this._getDocument().body.innerHTML));
                }
                catch (err) {
                    return "";
                }
            }
        },
        setHtml: function (value) {
            this._getDocument().body.innerHTML = "";
            this._getDocument().body.innerHTML = $.trim(value);
            this._onChange();
			var _tableEle = $(this._getDocument()).find("table");       
            if (!this.model.enableRTL && _tableEle.length > 0 ) this._on(_tableEle, "mouseover", this._tableMouseOver);
        },


        getText: function () {
            return this._getText();
        },


        executeCommand: function (cmdName, args, textnodeType) {
            if (this._isIE8() && ej.isNullOrUndefined(this._ieSelectionRange)) this._ieSelectionRange = this._getRange();
            else if (this._isIE() && cmdName.toLowerCase() == "inserthtml" && !this._isIE8()) {
                if (this._getRange().startContainer.nodeName.toLowerCase() != "body") {
                    this._currentSelNode = this._getRange().startContainer;
                }
                else {
                    this._ieLinkRange();
                }
            }
            if (this._trigger("execute", { commandName: cmdName })) return false;
            var anchor = "";
            if (ej.browserInfo().name == "chrome" && this._getWindow().getSelection().rangeCount == 0)
                this._restoreSelection(this._saveSelection());
            if (cmdName == "underline") {
                if (window.getSelection) {
                    anchor = $(this._getWindow().getSelection().anchorNode).parents("a");
                    if (anchor.length > 0) {
                        $(anchor).css("text-decoration", ($(anchor).css("text-decoration") == "none") ? "underline" : "none");
                        return;
                    }
                }
            }
            else if (cmdName.toLowerCase() == "inserthtml") {
                if (this._isIE() || (ej.browserInfo().name=="mozilla" && /class=(.*?)e-rte-table(.*?)>/ig.test(args))) {
                    this._pasteHtml(args, textnodeType);
                }
                else
                    this._getDocument().execCommand(cmdName, false, args);
                return;
            }
            else if (cmdName.toLowerCase() == "formatblock") {
                if (this._isIE()) {
                    if (args.charAt(0) != "<" && args.charAt(args.length - 1) != ">")
                        args = "<" + args + ">";
                }
            }
            if (ej.browserInfo().name == "msie")
                this._focus();
            if (this._isIE() && cmdName == "fontName") args = args.substring(0, args.indexOf(","));
            // if (!ej.isNullOrUndefined(this._tempEle) && this._tempEle.length > 0)
            // if ((this._tempEle.get(0).nodeName == "#text") && ($(this._tempEle.parents("li")).length > 0))
            // if ($(this._tempEle.parents("li")).prop("style")["font-size"] != "")
            // var lisize = $(this._tempEle.parents("li")).css("font-size");
            this._getDocument().execCommand(cmdName, false, args);
            this._onChange();
            if (cmdName != "fontName" && cmdName != "fontSize" && cmdName != "indent" && cmdName != "cut" && cmdName != "copy" && cmdName != "paste" && cmdName != "undo" && cmdName != "redo" && cmdName != "outdent" && !ej.isNullOrUndefined(this._toolBarObj))
                if (!this._toolBarObj.itemsContainer.find("li#" + this._rteId + "_" + cmdName).hasClass("e-active"))
                    this._toolBarObj.selectItemByID(this._rteId + "_" + cmdName);
                else
                    this._toolBarObj.deselectItemByID(this._rteId + "_" + cmdName);
            //  if (!ej.isNullOrUndefined(this._tempEle)) this._bulletsResizing(lisize, cmdName);
            if (args != "listItem") this._setBackupData();
        },
        //The commented lines behavior need to achieve in custom exec-command task if possible
        // _bulletsResizing: function (lisize, cmd) {
        // if ((!ej.isNullOrUndefined(this._tempEle.get(0))) && cmd=="fontSize")
        // var li = this._tempEle.get(0).tagName == "BODY" ? this._tempEle.find("li") : this._tempEle.get(0).nodeName != "#text" ? $(this._tempEle.parents("body")).find("li") : "";
        // if (li != "")
        // $(li).each(function (index) {
        // //refreshig the li font size after font size of li content executed
        // fonttag = $(this).find("font")[0] || "";
        // if (fonttag != "") {
        // $(this).css("font-size", $($(fonttag)[0]).css("font-size"));
        // // $(li).find("font").removeAttr("style");
        // }
        // else
        // {
        // $(this).css("font-size", $(this).css("font-size"));
        // }
        // });


        // if (cmd == "fontSize" && (this._getCommandStatus('InsertOrderedList') || this._getCommandStatus('InsertOrderedList')))
        // if (this._tempEle.get(0).tagName == "LI" || this._tempEle.get(0).tagName == "OL") {

        // this._tempEle.css("font-Size", this._tempEle.find("font").css("font-Size"));
        // $(this._tempEle.find("font")).removeProp("style")["font-size"];
        // }
        // if (lisize != null) {

        // $(this._tempEle.parents("li")).css("font-size", lisize);
        // $(this._tempEle.parents("li")).find("font").removeAttr("style");
        // }

        // },


        focus: function () {
            this._focus();
        },


        getCommandStatus: function (value) {
            if (ej.isNullOrUndefined(value) || value != "")
                return this._getCommandStatus(value);
        },


        getSelectedHtml: function () {
            return this._getSelectedHtmlString();
        },

        insertMenuOption: function (option) {
            if (option.newItem && option.targetItem && option.insertType && option.menuType) {
                var menuObj = this._textMenuObj, element, elementId = option.newItem, data = option.spriteCssClass ? [{ text: option.newItem, id: elementId, spriteCssClass: option.spriteCssClass }] : [{ text: option.newItem, id: elementId }];
                for (var i = 0; i < menuObj.element.find('li a').length; i++) {
                    if ($(menuObj.element.find('li a')[i]).text() == option.targetItem) {
                        element = $(menuObj.element.find('li')[i]).attr('id');
                        break;
                    }
                }
                if (option.insertType == "insert") menuObj.insert(data, element ? "#" + element : element);
                else if (option.insertType == "insertAfter") menuObj.insertAfter(data, "#" + element);
                else if (option.insertType == "insertBefore") menuObj.insertBefore(data, "#" + element);
                (option.menuType.text && this._contextType.text.push(elementId));
                (option.menuType.image && this._contextType.image.push(elementId));
                (option.menuType.hyperlink && this._contextType.hyperlink.push(elementId));
                (option.menuType.table && (this._contextType.table.push(elementId), this._contextType.table_hyper.push(elementId)));
            }
        },
        removeMenuOption: function (targetElement) {
            var menuObj = this._textMenuObj; menuObj.remove(["#" + targetElement]);
            (index = $.inArray(targetElement, this._contextType.text)) != -1 && (this._contextType.text = this._removeContextData(index, this._contextType.text));
            (index = $.inArray(targetElement, this._contextType.image)) != -1 && (this._contextType.image = this._removeContextData(index, this._contextType.image));
            (index = $.inArray(targetElement, this._contextType.hyperlink)) != -1 && (this._contextType.hyperlink = this._removeContextData(index, this._contextType.hyperlink));
            (index = $.inArray(targetElement, this._contextType.table)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table));
            (index = $.inArray(targetElement, this._contextType.table_hyper)) != -1 && (this._contextType.textablet = this._removeContextData(index, this._contextType.table_hyper));
        },
        _removeContextData: function (index, data) {
            var temp = [];
            $(data).each(function (ind, elem) { (index != ind) && temp.push(elem); });
            return temp;
        },
        insertRow: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
				var newRow =  $(seletedCell).closest("tr").clone(), curRow = $(seletedCell).closest("tr");
                var cols = newRow.find("td").html("<br _moz_dirty=''/>");
                before ? newRow.insertBefore(curRow) : newRow.insertAfter(curRow);
                newRow.find("td:first").focus();
                this._setAutoHeight();
                return seletedCell;
            }
        },


        insertColumn: function (before, cell) {
            if (this.model.maxLength != null && (this.model.maxLength > $.trim(this._getText()).length)) {
                var isTable = $(this._getSelectedNode()).closest("td");
                var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
                var colTemplate = $(seletedCell).clone(), curRow = $(seletedCell).closest("tr"), curCell;
				colTemplate[0].innerHTML = "<br _moz_dirty=''/>";
                var allRows = curRow.closest("table").find("tr");
                var colIndex = curRow.find("td").index(seletedCell);
                for (var i = 0; i < allRows.length; i++) {
                    curCell = $(allRows[i]).find("td")[colIndex];
                    before ? $(colTemplate.clone()).insertBefore(curCell) : $(colTemplate.clone()).insertAfter(curCell);
                }
                return seletedCell;
            }
        },


        removeRow: function (cell) {
            var seletedCell = ej.isNullOrUndefined(cell) ? this._getSelectedNode() : cell;
            var range = this._getRange();
            var select; var node = null, curRow;
            var parentTable = $(seletedCell).closest("table");

            if (parentTable.find("tr").length == 1) {
                node = $(seletedCell).parent("tr").closest("table").next()[0] || $(seletedCell).parent("tr").closest("table").prev()[0];
                $(seletedCell).parent("tr").closest("table").remove();
            }
            else {
                node = ($(seletedCell).parent("tr").prev("tr").length != 0) ? $(seletedCell).parent("tr").prev("tr").find("td:last")[0] : $(seletedCell).parent("tr").next("tr").find("td:first")[0];
                curRow = $(seletedCell).closest("tr").remove();
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
            this._setAutoHeight();
        },
        selectRange: function (range, node) {
            this._focus();
            var select;
            if (!this._isIE8()) {
                select = this._getDocument().getSelection();
                select.removeAllRanges();
                select.addRange(range);
            }
            else {
                range.select();
            }
        },
        _encode: function (value) {
            return $('<div/>').text(value).html();
        },
        _decode: function (value) {
            return value.replace(/&amp;/g, "&").replace(/&amp;lt;/g, "<").replace(/&lt;/g, "<").replace(/&amp;gt;/g, ">").replace(/&gt;/g, ">").replace(/&nbsp;/g, " ").replace(/&amp;nbsp;/g, " ").replace(/&quot;/g);
        },
        createRange: function () {
            if (!this._isIE8())
                return this._getRange();
            else
                return this.getDocument().body.createTextRange();
        },
        _setRange: function (node, range, collapse) {
            if (!this._isIE8()) {
                range.setStart(node, 0);
                range.collapse(true);
                if ((ej.browserInfo().name != "msie" || ej.browserInfo().version == "11.0") || !ej.isNullOrUndefined(collapse)) {
                    this.selectRange(range);
                }
                else if (ej.isNullOrUndefined(collapse)) {
                    selection = this._getDocument().body.createTextRange();
                    selection.moveToElementText(node);
                }
            }
            else if (!ej.isNullOrUndefined(node)) {
                range.collapse(true);
                range.moveToElementText(node);
                range.moveStart("character", 1);
                range.select();
            }
        },

        removeColumn: function (cell) {
            var isTable = $(this._getSelectedNode()).closest("td");
            var seletedCell = ej.isNullOrUndefined(cell) ? (isTable.length > 0) ? isTable[0] : this._getSelectedNode() : cell;
            var range = this._getRange();
            var curRow = $(seletedCell).closest("tr");
            var allRows = curRow.closest("table").find("tr");
            var colIndex = curRow.find("td").index(seletedCell);
            var node = !ej.isNullOrUndefined(seletedCell.nextElementSibling) ? $(seletedCell.nextElementSibling)[0] : $(seletedCell.previousSibling)[0];
            if (ej.isNullOrUndefined(node))
                $(seletedCell).parent("tr").parents("table").remove();
            else {
                for (var i = 0; i < allRows.length; i++) {
                    $($(allRows[i]).find("td")[colIndex]).remove();
                }
            }
            if (!ej.isNullOrUndefined(node)) {
                this._setRange(node, range);
            }
        },


        removeTable: function (table) {
            var seletedTable = ej.isNullOrUndefined(table) ? $(this._getSelectedNode()).closest("table") : table, tableAction = $(seletedTable).parent().closest('table').length < 1;
            this._currentSelNode = $(seletedTable).parent()[0];
            $(seletedTable).remove();
            if (tableAction)
                this._toggleEditTable();
            this._setAutoHeight();
            this._removeResizeObject();
            $(this._getDocument()).find(".e-rte-tablebox").remove();
        }
    });

    ej.RTE.Locale = ej.RTE.Locale || {};

    ej.RTE.Locale["default"] = ej.RTE.Locale["en-US"] = {
        bold: "Bold",
        italic: "Italic",
        underline: "Underline",
        strikethrough: "Strikethrough",
        superscript: "Superscript",
        subscript: "Subscript",
        justifyCenter: "Align text center",
        justifyLeft: "Align text left",
        justifyRight: "Align text right",
        justifyFull: "Justify",
        unorderedList: "Insert unordered list",
        orderedList: "Insert ordered list",
        indent: "Increase Indent",
        fileBrowser: "File Browser",
        outdent: "Decrease Indent",
        cut: "Cut",
        copy: "Copy",
        paste: "Paste",
        paragraph: "Paragraph",
        undo: "Undo",
        redo: "Redo",
        upperCase: "Upper Case",
        lowerCase: "Lower Case",
        clearAll: "Clear All",
        clearFormat: "Clear Format",
        createLink: "Insert/Edit Hyperlink",
        removeLink: "Remove Hyperlink",
        tableProperties: "Table Properties",
        insertTable: "Insert",
        deleteTables: "Delete",
        imageProperties: "Image Properties",
        openLink: "Open Hyperlink",
        image: "Insert image",
        video: "Insert video",
        editTable: "Edit Table Properties",
        embedVideo: "Paste your embed code below",
        viewHtml: "View HTML",
        fontName: "Select font family",
        fontSize: "Select font size",
        fontColor: "Select color",
		customFontColor:"More Colors...",
		customBGColor:"More Colors...",
        format: "Format",
        backgroundColor: "Background color",
		TransBGColor:"Transparent",
        style: "Styles",
        deleteAlert: "Are you sure you want to clear all the contents?",
        copyAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+C keyboard shortcut instead of copy operation.",
        pasteAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+V keyboard shortcut instead of paste operation.",
        cutAlert: "Your browser doesn't support direct access to the clipboard. Please use the Ctrl+X keyboard shortcut instead of cut operation.",
        videoError: "The text area can not be empty",
        imageWebUrl: "Web Address",
        imageAltText: "Alternate text",
        dimensions: "Dimensions",
        constrainProportions: "Constrain Proportions",
        linkWebUrl: "Web Address",
        imageLink: "Image as Link",
        imageBorder: "Image Border",
        imageStyle: "Style",
        linkText: "Text",
        linkTooltipLabel: "Tooltip",
        html5Support: "This tool icon only enabled in HTML5 supported browsers",
        linkOpenInNewWindow: "Open link in new window",
        tableColumns: "No.of Columns",
        tableRows: "No.of Rows",
        tableWidth: "Width",
        tableHeight: "Height",
        tableCellSpacing: "Cell spacing",
        tableCellPadding: "Cell padding",
        tableBorder: "Border",
        tableCaption: "Caption",
        tableAlignment: "Alignment",
        textAlign: "Text align",
        dialogUpdate: "Update",
        dialogInsert: "Insert",
        dialogCancel: "Cancel",
        dialogApply: "Apply",
        dialogOk: "Ok",
        createTable: "Insert Table",
        addColumnLeft: "Insert Columns to the Left",
        addColumnRight: "Insert Columns to the Right",
        addRowAbove: "Insert Rows Above",
        addRowBelow: "Insert Rows Below",
        deleteRow: "Delete entire row",
        deleteColumn: "Delete entire column",
        deleteTable: "Delete Table",
        customTable: "Create custom table...",
        characters: "Characters",
        words: "Words",
		w:"W",
		c:"C",
        general: "General",
        advanced: "Advanced",
        table: "Table",
        row: "Row",
        column: "Column",
        cell: "Cell",
        solid: "Solid",
        dotted: "Dotted",
        dashed: "Dashed",
        doubled: "Double",
        maximize: "Maximize",
        resize: "Minimize",
        swatches: "Swatches",
        quotation: "Quotation",
        heading1: "Heading 1",
        heading2: "Heading 2",
        heading3: "Heading 3",
        heading4: "Heading 4",
        heading5: "Heading 5",
        heading6: "Heading 6",
        segoeui: "Segoe UI",
        arial: "Arial",
        couriernew: "Courier New",
        georgia: "Georgia",
        impact: "Impact",
        lucidaconsole: "Lucida Console",
        tahoma: "Tahoma",
        timesnewroman: "Times New Roman",
        trebuchetms: "Trebuchet MS",
        verdana: "Verdana",
        disc: "Disc",
        circle: "Circle",
        square: "Square",
        number: "Number",
        loweralpha: "Lower Alpha",
        upperalpha: "Upper Alpha",
        lowerroman: "Lower Roman",
        upperroman: "Upper Roman",
        none: "None",
        linkTooltip: "ctrl + click to follow link",
        charSpace: "Characters (with spaces)",
        charNoSpace: "Characters (no spaces)",
        wordCount: "Word Count",
        left: "Left",
        right: "Right",
        center: "Center",
        zoomIn: "Zoom In",
        zoomOut: "Zoom Out",
        print: "Print",
        'import': "Import a Document",
        wordExport: "Export as Word Document",
        pdfExport: "Export as Pdf File",
        FindAndReplace: "Find and Replace",
        Find: "Find",
        MatchCase: "Match Case",
        WholeWord: "Whole Word",
        ReplaceWith: "Replace with",
        Replace: "Replace",
        ReplaceAll: "Replace All",
        FindErrorMsg: "Couldn't find specified word.",
		FindOf: " of ", 
		ReplaceCount: " occurrences were replaced.",
        addtodictionary: "Add to Dictionary",
        ignoreall: "IgnoreAll"
    };
ej.RTE.ToolbarOverflowMode = {
        /**  Renders overflow popup with hamburger icon as usual. */
        Popup:"popup",
        /**  Renders overflow popup  below the toolbar as inline on clicking the arrow. */
        Inline: "inline"
    };
})(jQuery, Syncfusion);;
(function ($, ej, undefined) {
	"use strict";
    ej.RTE = ej.RTE || {};
    ej.RTE.FindAndReplace = {
	_findObject:null,
	_selectedIndex:-1,
	_findAndReplaceClick:function (args){
		var dialog=this._findDialog.element,text=$.trim($(dialog).find("[ej-function='findtxt']").val()),targetElement=(args.target.tagName=="SPAN"||args.target.tagName=="DIV")?$(args.target).closest("button")[0]:args.target,replacetxt=$(dialog).find("[ej-function='replacetxt']").val(),target=this.getDocument().body,findElement=$(dialog).find("[ej-function='replace'],[ej-function='replaceAll']"),navElement=$(dialog).find("[ej-function='prev'],[ej-function='next']");
		$(this._findDialog.element).children('span').html('');
		if(!$(targetElement).hasClass("e-disable"))
		switch(targetElement.getAttribute('ej-function'))
		{
			case "find":
			if(text){			
				this._findObject.find(text,target,!$(dialog).find("[ej-function='matchCase']")[0].checked,$(dialog).find("[ej-function='wholeWords']")[0].checked),this._selectedIndex=-1;
				if(this._findObject.nodeCollection.length){
					$('#'+ this._id + '_rtefindcount').html('');
					(this._findObject.nodeCollection.length>0)?findElement.ejButton("enable"):findElement.ejButton("disable");
					this._highlightNode(++this._selectedIndex,target);
					this._updateBtnStatus(this._selectedIndex,navElement);
				}
				else{
					$.merge(navElement,findElement).ejButton("disable");					
					this._findObject.revertAll();
					$(this._findDialog.element).children('span').html(this._getLocalizedLabels("FindErrorMsg"));
				}
			}
			else if(this._findObject.nodeCollection.length)
			this._findObject.revertAll();
			break;
			case "next":
			if(this._selectedIndex<this._findObject.nodeCollection.length){
				$('#'+ this._id + '_rtefindcount').html('');
			this._highlightNode(++this._selectedIndex,target);
			}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break
			case "prev":
			if(this._selectedIndex>0){
				$('#'+ this._id + '_rtefindcount').html('');
				this._highlightNode(--this._selectedIndex,target);
				}
			this._updateBtnStatus(this._selectedIndex,navElement);
			break;
			case "replace":
					this._findObject.replaceByIndex(this._selectedIndex,replacetxt);
					if(!this._findObject.nodeCollection.length){
						$('#'+ this._id + '_rtefindcount').html('');	
						this._selectedIndex=-1;
					}
					else if (this._selectedIndex>this._findObject.nodeCollection.length-1) --this._selectedIndex;
					
					if(this._selectedIndex>-1){
						$('#'+ this._id + '_rtefindcount').html('');
						this._highlightNode(this._selectedIndex,target);
						this._updateBtnStatus(this._selectedIndex,navElement); 
					}
					else
						$.merge(navElement,findElement).ejButton("disable");
					this._setBackupData(); 
			break;
			case "replaceAll":
					var _replaceCount = this._findObject.replaceAll(replacetxt);this._selectedIndex=-1;
					$('#'+ this._id +'_rteReplaceCount').append(_replaceCount +this._getLocalizedLabels("ReplaceCount") );
					$.merge(navElement,findElement).ejButton("disable");					
					this._setBackupData(); 
			break;		
		}
		this._updateCount();        
	
	}, 
	_updateBtnStatus:function(_selectedIndex,element){
		(_selectedIndex<this._findObject.nodeCollection.length-1)?$(element[1]).ejButton("enable"):$(element[1]).ejButton("disable");
		(_selectedIndex>0)?$(element[0]).ejButton("enable"):$(element[0]).ejButton("disable");
	},
	_highlightNode:function(nodeIndex,target){
		$(target).find(".e-highlight").removeClass("e-highlight");
		for (var index=0;index<this._findObject.nodeCollection.length;index++){
			if(nodeIndex==index)
				for (var index1=0;index1<this._findObject.nodeCollection[index].length;index1++){
					$(this._findObject.nodeCollection[index][index1].node).addClass("e-highlight");
					$((ej.browserInfo().name=="msie"||ej.browserInfo().name=="mozilla")?target.parentElement:target).scrollTop($(this._findObject.nodeCollection[index][index1].node).offset().top - 25);
				}
				
		}
		$('#'+ this._id + '_rtefindcount').append(nodeIndex+ this._getLocalizedLabels("FindOf") + this._findObject.nodeCollection.length);		 
	},	

	_renderFindDialog:function (target){
		
	    var content = "<div id='" + this._id + "_basicDialog' title='" + this._getLocalizedLabels("FindAndReplace") + "'><div class='e-maincontent'><div class='e-fd-findcontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("Find") + "</span></div><div class='e-txtbox'><input type='text' ej-function='findtxt' id='" + this._id + "_findtxt' class='e-js e-input'></div><div id='" + this._id + "_rtefindcount' class='e-rtefindcount'></div></div><div class='e-fd-InnerContent'><div><input type='checkbox' ej-function='matchCase' id='" + this._id + "_matchCase' value='true'><label for='" + this._id + "_matchCase' class='e-fd-checkboxlable' style=''>" + this._getLocalizedLabels("MatchCase") + "</label></div><div class='e-checkbx'><input type='checkbox' ej-function='wholeWords' id='" + this._id + "_wholeWords' value='true'><label for='" + this._id + "_wholeWords' class='e-fd-checkboxlable'>" + this._getLocalizedLabels("WholeWord") + "</label></div></div><div class='e-fd-replacecontent'><div class='e-fd-lable'><span>" + this._getLocalizedLabels("ReplaceWith") + "</span></div><div class='e-txtbox'><input type='text' ej-function='replacetxt' id='" + this._id + "_replacetxt' class='e-js e-input'></div></div></div><div id='" + this._id + "_rteReplaceCount' class='e-rteReplaceCount'></div><span style='text-align: center;'></span><div class='e-fd-btncol'><div class='e-btn-left'><button id='" + this._id + "_find' ej-function='find'>" + this._getLocalizedLabels("Find") + "</button><button id='" + this._id + "_replace' ej-function='replace'>" + this._getLocalizedLabels("Replace") + "</button><button id='" + this._id + "_replaceAll' class='ejRTE-replaceAll' ej-function='replaceAll'>" + this._getLocalizedLabels("ReplaceAll") + "</button></div><div class='e-btn-right'><button id='" + this._id + "_prev' ej-function='prev'></button><button id='" + this._id + "_next' ej-function='next'></button></div></div></div>";
		target._findDialog=$(content).ejDialog({
                width: "auto",
				minWidth:"300px",
				maxWidth:"380px",
				isResponsive:true,
                close:this._onCloseFindAndReplace,cssClass:"e-rte e-findandreplace",enableRTL:target.model.enableRTL,enableResize: false,enableModal: true				
            }).data("ejDialog");
			$(target._findDialog.element).find("input[type=text]").val("");
			$(target._findDialog.element).find("button").ejButton({height: 30});
			$(target._findDialog.element).find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
			$(target._findDialog.element).find("[ej-function='prev'],[ej-function='next']").ejButton({height: 30, width: 30,contentType: "imageonly"});
			$(target._findDialog.element).find("[ej-function='prev']").ejButton({ prefixIcon:"e-icon e-chevron-left_02"}).next().ejButton({ prefixIcon: "e-icon e-chevron-right_02"});
			$(target._findDialog.element).find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({enableRTL:target.model.enableRTL,checked:  false});				
			this._findObject=new ej.FindAndReplace()
			this._on(target._findDialog.element.find("button"), "click", this._findAndReplaceClick);
	},
	_onCloseFindAndReplace:function(args){
					$("#"+this._id.replace("_basicDialog","")).data("ejRTE")._findObject.revertAll();
					this.element.find("[ej-function='replace'],[ej-function='replaceAll'],[ej-function='prev'],[ej-function='next']").ejButton("disable");
					this.element.find("input[type=text]").val("");
					this.element.find("[ej-function='wholeWords'],[ej-function='matchCase']").ejCheckBox({checked:false});
					this.element.children('span').html('');
					$('.e-rteReplaceCount').html('');
					$('.e-rtefindcount').html('');
	},
	_showFindAndReplace:function (){
		this._findDialog?this._findDialog.open():this._renderFindDialog(this);
	}
	
	}
	
})(jQuery, Syncfusion);

(function() {

  ej.FindAndReplace = function() {
    this.indexLength=0,this.elements=[],this.matches=[],this.nodeCollection=[];
	this.specialChar=/([{}()|[\]\/\\.*+?^=!:$])/g,this.escapeContent='\\$1';
  }
  ej.FindAndReplace.prototype._addContentEscape=function(content){
	return String(content).replace(this.specialChar, this.escapeContent);
  }

  ej.FindAndReplace.prototype.find=function(text,node,igncase,wholeword){
	if(this.nodeCollection.length)
		this.revertAll();
	this._validateTextContent(text,this._getFormatedText(node),igncase,wholeword);
	if(this.matches.length)
	{
		this._iterateNodes(node),this.matches=[];
		return true;
	}
	else
		return false;
  }
  ej.FindAndReplace.prototype._replace=function(collection,text){
	for(var index1=0;index1<collection.length;index1++) 
		(!index1||!text)?this._elementDefragment(collection[index1].node,text):$(collection[index1].node).remove();	
}
  ej.FindAndReplace.prototype.replaceByIndex=function(Index,text){
	var tempNodes=[]
	for(var index=0;index<this.nodeCollection.length;index++) 
		(index==Index)?	this._replace(this.nodeCollection[index],text):tempNodes.push(this.nodeCollection[index]);	
	this.nodeCollection=tempNodes;
}
  ej.FindAndReplace.prototype.replaceAll=function(text){
	for(var index=0;index<this.nodeCollection.length;index++) 
		this._replace(this.nodeCollection[index],text);	
	this.nodeCollection=[];
	return index;
}

  ej.FindAndReplace.prototype.revertAll=function(){
	for(var index=0;index<this.nodeCollection.length;index++) 
	this._replace(this.nodeCollection[index]);
	this.nodeCollection=[];
}
  
 ej.FindAndReplace.prototype._elementDefragment=function (node,text){
var tempNode=node.nextSibling,tempNode1=node.previousSibling;

if(tempNode&&tempNode1&&tempNode.nodeType==3 && tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data)+node.nextSibling.data;	
	$(node.nextSibling).remove();
	$(node).remove();
}
else if(tempNode&&tempNode.nodeType==3)
{	
	tempNode=node.nextSibling;
	tempNode.data=(text!= undefined ? text:node.firstChild.data)+tempNode.data;
	$(node).remove();
}
else if(tempNode1&&tempNode1.nodeType==3)
{
	tempNode=node.previousSibling;
	tempNode.data=tempNode.data+(text!= undefined ? text:node.firstChild.data);
	$(node).remove();
}
else 
{
	tempNode=(text!= undefined) ? document.createTextNode(text):node.firstChild;
	$(node).replaceWith(tempNode);
}
}

  ej.FindAndReplace.prototype._validateTextContent=function(text,content,igncase,wholeword){
 	var target=this._addContentEscape(text),regx=new RegExp(wholeword ? "\\b"+target+"\\b":target,igncase?'gi':'g');
	while(data=regx.exec(content))
		this.matches.push({startIndex:data.index,endIndex:data.index+text.length});
	return this.matches;
}

 ej.FindAndReplace.prototype._traverseNode=function(element,data){

	if (element.nodeType === 3)	
	{	
		out=this._validateData(element,data);
		if(out.curNode) element=out.curNode;
			if(out.status)
			return true;
	}
	
	if(element=element.firstChild)
	do
	{	  
		if(element.nodeType === 3)
		{
			out=this._validateData(element,data);
			if(out.curNode) element=out.curNode;
			if(out.status)
				return true;
		}
		else 		
		{		
			if(this._traverseNode(element,data))
				return true;
		}
	}while(element=element.nextSibling)
	
	return false;
}

 ej.FindAndReplace.prototype._validateData=function(curNode,data){
	var startIndex=this.indexLength,endIndex=this.indexLength+curNode.length;this.indexLength=this.indexLength+curNode.length;	
	if(startIndex>=data.startIndex||data.startIndex<endIndex)
		return this._elementFragment(data,{startIndex:startIndex,endIndex:endIndex},curNode);
	else 
		return {status:false};

}

 ej.FindAndReplace.prototype._elementFragment=function(cIndex,eIndex,element){
	var tempdata=element.data,finalNode=element;
	if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))//full Element Replacement
	{
		finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(element.data))[0];
		$(element).replaceWith(finalNode);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex<=eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempindex=(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(0,tempindex)))[0];
		$(dataNode).insertBefore(element);
		element.data=tempdata.substr(tempindex);
		this.elements.push({node:dataNode});
	}	
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex>=eIndex.endIndex))
	{
		
		tempindex=(cIndex.startIndex-eIndex.startIndex),finalNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substr(tempindex)))[0];
		$(finalNode).insertAfter(element);
		element.data=tempdata.substr(0,tempindex);
		this.elements.push({node:finalNode});
	}
	else if((cIndex.startIndex>eIndex.startIndex)&&(cIndex.endIndex<eIndex.endIndex))
	{
		var tempstart=(cIndex.startIndex-eIndex.startIndex),tempend=tempstart+(cIndex.endIndex-cIndex.startIndex),dataNode=ej.buildTag("span.e-selected-node").append(document.createTextNode(tempdata.substring(tempstart,tempend)))[0];finalNode=document.createTextNode(tempdata.substring(tempend));		
		element.data=tempdata.substr(0,tempstart);
		$(finalNode).insertAfter(element);
		$(dataNode).insertAfter(element);		
		this.elements.push({node:dataNode});
	}
	return {status:cIndex.endIndex>eIndex.startIndex && cIndex.endIndex<=eIndex.endIndex,curNode:finalNode};
}

 ej.FindAndReplace.prototype._getFormatedText=function (element){
	var text='';
	if (element.nodeType === 3) return element.data.replace(/\n/g,' ');
	
	if(element=element.firstChild)
	do
	{	  
		text+= (element.nodeType === 3)?element.data.replace(/\n/g,' '):this._getFormatedText(element);		
	}while(element=element.nextSibling)
	
	return text;
				
}

 ej.FindAndReplace.prototype._iterateNodes=function (curNode){
	temp=this;
	$(this.matches).each(function(index,data)
	{
		temp._traverseNode(curNode,data),temp.nodeCollection.push(temp.elements),temp.indexLength=0,temp.elements=[];		
	});
}
}());


if(ej.RTE.FindAndReplace)
 $.extend(ej.RTE.prototype, ej.RTE.FindAndReplace);;
"use strict";
var documentManager;
(function (documentManager) {
    var editorManager = (function () {
        function editorManager(target, win) {
            this.formatInfo = new formateDataCollection();
            this._nodeCollection = [];
            this._iterationStatus = false;
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.advanceFilterNode = ["img", "video", "table", "tbody", "tr", "td", "th"];
            this.indentFilter = ["img", "video"];
            this._junkSpanNodes = [];
            this.currentDocument = target;
            this.currentWindow = win;
            this._rangeExtract = new RangeExtractor(this.currentDocument);
            this._bindEvent();
        }
        editorManager.prototype._bindEvent = function () {
            $(this.currentDocument.body).on("keydown", $.proxy(this._editorKeyUpEvent, this));
        };
        editorManager.prototype._editorKeyUpEvent = function (e) {
            if (this._junkContentStatus) {
                var range = this._getRangy(this.currentWindow, this.currentDocument), rangeContainer = range.startContainer, rangeOffset = range.startOffset;
                if (!e.shiftKey && (e.which >= 37 && e.which <= 40) && (rangeContainer.nodeType == 3)) {
                    this._junkContentStatus = false;
                    this._iterateCompleteNode(rangeContainer, e, rangeOffset);
                }
            }
        };
        editorManager.prototype._iterateCompleteNode = function (element, e, range) {
            var oldlen = element.data.length;
            this._junkSpanNodes = [];
            this._removeJunkContent(this.currentDocument.body);
            this._collectJunkSpanNodes(this.currentDocument.body);
            this._removeJunkSpanNodes();
            (oldlen > element.data.length) && range--;
            !element.data && $(element).remove();
            if (element.data.trim()) {
                this._updateCursor(element, range);
            }
        };
        editorManager.prototype._collectJunkSpanNodes = function (stNode) {
            var startNode = stNode;
            if ($(startNode).is("span") && !$(startNode).attr("style"))
                this._junkSpanNodes.push(startNode);
            if (startNode = startNode.firstChild)
                do {
                    if ($(startNode).is("span") && !$(startNode).attr("style"))
                        this._junkSpanNodes.push(startNode);
                    this._collectJunkSpanNodes(startNode);
                } while (startNode = startNode.nextSibling);
        };
        editorManager.prototype._removeJunkSpanNodes = function () {
            var temp;
            while (temp = this._junkSpanNodes.shift()) {
                if (temp.childNodes.length)
                    $(temp).replaceWith(temp.childNodes);
                else
                    $(temp).remove();
            }
        };
        editorManager.prototype._removeJunkContent = function (startNode) {
            var temp = startNode;
            if (temp.nodeType == 3)
                this._removeCursorText(temp);
            if (temp = temp.firstChild)
                do {
                    if (temp.nodeType == 3)
                        this._removeCursorText(temp);
                    else
                        this._removeJunkContent(temp);
                } while (temp = temp.nextSibling);
        };
        editorManager.prototype._removeCursorText = function (element) {
            element.data = element.data.replace(String.fromCharCode(65279), "");
        };
        editorManager.prototype.focus = function () {
            var objExec = this;
            setTimeout(function () {
                var browserInfo = ej.browserInfo();
                if (browserInfo.name == "webkit")
                    objExec.currentWindow.focus();
                else
                    objExec.currentWindow.document.body.focus();
            }, 100);
        };
        editorManager.prototype._justifyContent = function (Value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._onApplyjustify(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyFormateBlock = function (Value) {
            var range = this._getRangy(this.currentWindow, this.currentDocument);
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._applyChanges(Value, this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
            this._selectionRange = this._getRangy(this.currentWindow, this.currentDocument);
        };
        editorManager.prototype._applyList = function (value, listType) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            this._applyOrderedList(value.toLowerCase() == "orderlist" ? "ol" : "ul", this.currentDocument, this.currentWindow, listType);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._applyIndent = function (value) {
            this._backUpRange(this.currentDocument, this.currentWindow);
            this._getModifedRange(this._getRangy(this.currentWindow, this.currentDocument));
            if (value)
                this._onApplyIndent(this.currentDocument, this.currentWindow);
            else
                this._onApplyDecreaseIndent(this.currentDocument, this.currentWindow);
            this._resetRange(this.currentDocument, this.currentWindow);
        };
        editorManager.prototype._getRangy = function (_window, _document) {
            if (_window.getSelection() && _window.getSelection().rangeCount > 0)
                return _window.getSelection().getRangeAt(0);
            else {
                var range;
                try {
                    range = _window.document.createRange();
                    range.setStart(_window.document.body, 0);
                    range.setEnd(_window.document.body, 0);
                }
                catch (error) {
                    range = _document.createRange();
                    range.setStart(_document.body, 0);
                    range.setEnd(_document.body, 0);
                }
                return range;
            }
        };
        editorManager.prototype._getexactSelectedNode = function (range, parentDoc) {
            var nodeDetails = [];
            var _parentNode = [];
            this._parentDoc = parentDoc;
            var startNode = $(this._parentDoc.body).find("span#startRange");
            var that = this;
            function visit(node) {
                if (node.nodeType == 3 && (($.trim(node.nodeValue) != "" || node.nodeValue == "\ufeff") || ($.trim(node.nodeValue) == "" && node.nextSibling == startNode[0]))) {
                    nodeDetails.push(node);
                }
                else if (node.nodeValue && node.nodeName != "#comment" && node.nodeValue.trim() == "" && that.range.endContainer.parentNode.nextSibling != that._next) {
                    if ($.inArray(node.previousElementSibling, _parentNode) < 0)
                        _parentNode.push(node.previousElementSibling);
                }
                else if ((node.nodeName.toLowerCase() == "br" || ($.inArray(node.nodeName.toLowerCase(), that.filterNode) < 0)) && ($.inArray(node.parentNode, nodeDetails) < 0) && node.nodeName.toLowerCase() != "body" && $.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) < 0 && ((!ej.isNullOrUndefined(nodeDetails[nodeDetails.length - 1])) && nodeDetails[nodeDetails.length - 1].parentNode != node.parentNode) && node.previousSibling && node.previousSibling.parentNode != node.parentNode)
                    nodeDetails.push(node.parentNode);
                else if (($.inArray(node.nodeName.toLowerCase(), that.advanceFilterNode) >= 0) && ej.isNullOrUndefined(node.firstChild))
                    nodeDetails.push(node);
                else {
                    node = node.firstChild;
                    while (node) {
                        visit(node);
                        node = node.nextSibling;
                    }
                }
            }
            this._generateRange(range);
            this._traverse(visit);
            return nodeDetails;
        };
        editorManager.prototype._getStartEndElement = function (tnode, root) {
            if (this._isAncestor(root, tnode)) {
                while (tnode && tnode.parentNode != root) {
                    tnode = tnode.parentNode;
                }
            }
            return tnode;
        };
        editorManager.prototype._generateRange = function (range) {
            var root = range.commonAncestorContainer;
            this._next = range.startContainer == root && !this._isTextNode(range.startContainer) ? range.startContainer.childNodes[range.startOffset] : this._getStartEndElement(range.startContainer, root);
            this._end = range.endContainer == root && !this._isTextNode(range.endContainer) ? range.endContainer.childNodes[range.endOffset] : (this._getStartEndElement(range.endContainer, root).nodeName.toLowerCase() != "body") && this._getStartEndElement(range.endContainer, root).nextSibling;
        };
        editorManager.prototype._traverse = function (callback) {
            var that = this, current;
            function next() {
                if (that._next != ((that._isTextNode(that.range.endContainer) ? that.range.endContainer.parentNode.nextSibling : that.range.endContainer.nextElementSibling)) && that.range.endContainer.parentNode.nextSibling != that._next) {
                    that._current = that._next;
                    that._next = that._current && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0] && that._current.nextSibling != (ej.isNullOrUndefined(that._end) ? that.range.endContainer.nextSibling : that._end) ? that._current.nextSibling : null;
                    return that._current;
                }
                else {
                    return null;
                }
            }
            while (current = next()) {
                if (that._hasSubNodes()) {
                    that._getSubtree(that._getRangy(that.currentWindow, that.currentDocument));
                    that._traverse(callback);
                }
                else {
                    var _nextNode = current;
                    if (that.range.startContainer.nodeName.toLowerCase() != "body") {
                        if (that._next == null && _nextNode != (that.range.endContainer)) {
                            while (ej.isNullOrUndefined(that._next) && !ej.isNullOrUndefined(_nextNode)) {
                                _nextNode = _nextNode.parentNode;
                                if ((!ej.isNullOrUndefined(_nextNode)) && that._current.nextSibling != $(that._parentDoc.body).find("span#endRange")[0])
                                    that._next = _nextNode.nextSibling;
                            }
                        }
                    }
                    callback(current);
                }
            }
            return current;
        };
        editorManager.prototype._hasSubNodes = function () {
            return !this._isTextNode(this._current) && (this._isAncestorItself(this._current, this.range.startContainer) ||
                this._isAncestorItself(this._current, this.range.endContainer));
        };
        editorManager.prototype._isTextNode = function (node) {
            return node && node.nodeValue !== null && node.data !== null;
        };
        editorManager.prototype._isAncestor = function (parent, node) {
            try {
                return !this._isTextNode(parent) && ($.contains(parent, (this._isTextNode(node) ? node.parentNode : node)) || node.parentNode == parent);
            }
            catch (e) {
                return false;
            }
        };
        editorManager.prototype._isAncestorItself = function (root, node) {
            return this._isAncestor(root, node) || root == node;
        };
        editorManager.prototype._getSubtree = function (range) {
            var that = this;
            var subRange = that.range.cloneRange();
            subRange.selectNodeContents(that._current);
            if (that._isAncestorItself(that._current, that.range.startContainer)) {
                subRange.setStart(that.range.startContainer, that.range.startOffset);
            }
            if (that._isAncestorItself(that._current, that.range.endContainer)) {
                subRange.setEnd(that.range.endContainer, that.range.endOffset);
            }
            return this._generateRange(subRange);
        };
        editorManager.prototype._getModifedRange = function (range) {
            if (range.endOffset == 0 && range.startContainer != range.endContainer) {
                var ele = range.endContainer;
                do {
                    ele = ej.isNullOrUndefined(range.endContainer.previousSibling) ? ele.parentNode : ele;
                } while (ej.isNullOrUndefined(ele.previousSibling));
                if (this._isTextNode(ele.previousSibling) && $.trim(ele.previousSibling.textContent).length != 0)
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                else {
                    range.setEnd(ele.previousSibling, ele.previousSibling.childNodes.length);
                }
            }
        };
        editorManager.prototype._getSelectedParent = function (selNode1) {
            var _parentNode = [], selNode = selNode1;
            for (var i = 0; i < selNode.length; i++) {
                if (this._isTextNode(selNode[i])) {
                    while (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && ($.inArray(selNode[i].parentNode.nodeName.toLowerCase(), this.filterNode)) < 0) {
                        selNode[i] = selNode[i].parentNode;
                    }
                    if (selNode[i].parentNode.nodeName.toLowerCase() == "body")
                        _parentNode.push(this._updateParent(selNode[i]));
                }
                if (selNode[i] && selNode[i].parentNode && selNode[i].parentNode.nodeName.toLowerCase() != "body" && $.inArray(selNode[i].parentNode, _parentNode) < 0) {
                    if (selNode[i].parentNode.nodeName.toLowerCase() != "body" && selNode[i].nodeName.toLowerCase() != "img" && selNode[i].nodeName.toLowerCase() != "video")
                        _parentNode.push(selNode[i].parentNode);
                    else
                        _parentNode.push(selNode[i]);
                }
            }
            return _parentNode;
        };
        editorManager.prototype._updateParent = function (node) {
            var nodeColl = [node], temp = node, leftBlockNode, rightBlockNode, tempDiv = document.createElement("div");
            ;
            while (temp = temp.previousSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    leftBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            nodeColl = nodeColl.reverse();
            temp = node;
            while (temp = temp.nextSibling) {
                if ($.inArray(temp.nodeName.toLowerCase(), this.filterNode) != -1) {
                    rightBlockNode = temp;
                    break;
                }
                else
                    nodeColl.push(temp);
            }
            $(nodeColl).appendTo(tempDiv);
            if (leftBlockNode)
                $(tempDiv).insertAfter(leftBlockNode);
            else if (rightBlockNode)
                $(tempDiv).insertBefore(rightBlockNode);
            else
                $(tempDiv).appendTo(this.currentDocument.body);
            return tempDiv;
        };
        editorManager.prototype._applyChanges = function (formatBlock, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var tag = (document.createElement(formatBlock.substring(formatBlock.indexOf("<") + 1, formatBlock.indexOf(">"))));
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
                this.focus();
                tag.innerHTML = "&nbsp;";
                this._parentDoc.body.innerHTML = tag.outerHTML;
            }
            else {
                var exatSelNode = this._getSelectedParent(selNode);
                var nodeArray = [];
                nodeArray.push(selNode[0]);
                var _prevParent = this._getSelectedParent(nodeArray)[0];
                var _childNode = [];
                var tval = 0;
                var condi = false;
                var _tdiv = document.createElement("div");
                var dummyNode = document.createElement("div");
                var _newparent = this._getSelectedParent(nodeArray)[0];
                var _prevParntNode, selVal, tnode, _isListNode, _tobj, _liNode, _liPrevious;
                for (selVal = 0; selVal < exatSelNode.length; selVal++) {
                    nodeArray = [];
                    nodeArray.push(exatSelNode[selVal]);
                    _prevParent = this._getSelectedParent(nodeArray)[0];
                    if ($(exatSelNode[selVal]).attr("style"))
                        $(tag).attr("style", $(exatSelNode[selVal]).attr("style"));
                    if ($.inArray(_prevParent, _childNode) >= 0) {
                        var node;
                    }
                    else {
                        _childNode.push(_prevParent);
                        if (tag.innerHTML.length != 0) {
                            if (_childNode[tval].nodeName.toLowerCase() != "td" && _childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody" && _childNode[tval].nodeName.toLowerCase() != "li" && _childNode[tval].nodeName.toLowerCase() != "body") {
                                $(_childNode[tval]).replaceWith(tag.outerHTML);
                            }
                            else if (_childNode[tval].nodeName.toLowerCase() != "tr" && _childNode[tval].nodeName.toLowerCase() != "tbody") {
                                $(_childNode[tval]).prepend("<div></div>");
                                _tdiv.innerHTML = tag.outerHTML;
                                _childNode[tval].replaceChild(_tdiv.firstChild, _childNode[tval].firstChild);
                            }
                            tval++;
                        }
                        tag.innerHTML = "";
                        _tdiv.innerHTML = "";
                    }
                    tnode = exatSelNode[selVal];
                    _tobj = false;
                    if (!ej.isNullOrUndefined(tnode.parentNode)) {
                        _isListNode = tnode.nodeName.toLowerCase() == "li";
                    }
                    if (!ej.isNullOrUndefined(tnode)) {
                        _liNode = tnode;
                        while (_liNode.childNodes.length != 0) {
                            if ($.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                while (tnode.firstChild && $.inArray(tnode.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                    $(tag).append(_liNode.childNodes[0]);
                                }
                            }
                            else {
                                break;
                            }
                        }
                        _liPrevious = tnode.previousSibling;
                    }
                    _prevParntNode = tnode.parentNode;
                    if (tag.innerHTML.length != 0) {
                        if (tnode.nodeName.toLowerCase() != "td" && tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody" && tnode.nodeName.toLowerCase() != "li" && tnode.nodeName.toLowerCase() != "body") {
                            $(tnode).replaceWith(tag.outerHTML);
                        }
                        else if (tnode.nodeName.toLowerCase() != "tr" && tnode.nodeName.toLowerCase() != "tbody") {
                            $(tnode).prepend("<div></div>");
                            _tdiv.innerHTML = tag.outerHTML;
                            tnode.replaceChild(_tdiv.firstChild, tnode.firstChild);
                        }
                        tval++;
                    }
                    tag.innerHTML = "";
                    _tdiv.innerHTML = "";
                    $(tag).removeAttr("style");
                }
            }
        };
        editorManager.prototype._validateIndent = function (element) {
            var _indentStatus = false;
            do {
                if ($(element).attr("style") && (parseInt($(element).css("margin-left")) > 0)) {
                    _indentStatus = true;
                }
            } while ((element = element.parentNode) && !$(element).is("body"));
            return _indentStatus;
        };
        editorManager.prototype._validateFontSize = function (element) {
            var size = parseInt($(((element.nodeType == 3) ? element.parentNode : element)).css("font-size"));
            return (Math.round(size * (3 / 4))) + "pt";
        };
        editorManager.prototype._onApplyIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc), temp;
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            if (selNode.length == 0 && this.range.startContainer.nodeName.toLowerCase() == "body" && this.range.endContainer.nodeName.toLowerCase() == "body" && this.range.commonAncestorContainer.nodeName.toLowerCase() == "body" && this._parentDoc.body.innerHTML == "") {
            }
            else {
                for (var node = 0; node <= exatSelNode.length - 1; node++) {
                    if (exatSelNode[node].nodeName.toLowerCase() == "td") {
                        $(exatSelNode[node]).append($(temp = (document.createElement("p"))).append(exatSelNode[node].childNodes));
                        exatSelNode[node] = temp;
                    }
                    if (exatSelNode[node].nodeName.toLowerCase() != "li")
                        $(exatSelNode[node]).css("margin-left", 40 + parseInt($(exatSelNode[node]).css("margin-left")) + "px");
                    else {
                        if ($(exatSelNode[node]).prev().length == 0)
                            $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) + 40 + "px");
                        else
                            $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) + 40 + "px");
                    }
                }
            }
        };
        editorManager.prototype._onApplyDecreaseIndent = function (parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode1 = this._getexactSelectedNode(this.range, parentDoc);
            var selNode = selNode1.slice();
            var exatSelNode = this._getSelectedParent(selNode);
            for (var node = 0; node <= exatSelNode.length - 1; node++) {
                if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40 && exatSelNode[node].nodeName.toLowerCase() != "li")
                    $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                else {
                    if ($(exatSelNode[node]).prev().length == 0 && parseInt($(exatSelNode[node].parentNode).css("margin-left")) >= 40)
                        $(exatSelNode[node].parentNode).css("margin-left", parseInt($(exatSelNode[node].parentNode).css("margin-left")) - 40);
                    else if (parseInt($(exatSelNode[node]).css("margin-left")) >= 40)
                        $(exatSelNode[node]).css("margin-left", parseInt($(exatSelNode[node]).css("margin-left")) - 40);
                }
            }
        };
        editorManager.prototype._getNodeName = function (node) {
            if (this._isTextNode(node))
                return "#text";
            else
                return node.nodeName.toLowerCase();
        };
        editorManager.prototype._onApplyjustify = function (justify, parentDoc, _window) {
            this.range = this._getRangy(_window, parentDoc);
            var selNode = this._getexactSelectedNode(this.range, parentDoc);
            var _exactparentEle = this._getSelectedParent(selNode);
            for (var a = 0; a < _exactparentEle.length; a++) {
                var node = document.createElement("div");
                if (_exactparentEle[a].nodeName.toLowerCase() == "li") {
                    var _tnode = $(_exactparentEle[a]).children(), _val = 0;
                    for (var b = 0; b < _tnode.length; b++) {
                        if ($.inArray(this._getNodeName(_tnode[b]), this.filterNode) > 0)
                            _val++;
                    }
                    if (_val > 0) {
                        while (_exactparentEle[a].childNodes.length > 0) {
                            if (this._isTextNode(_exactparentEle[a].childNodes[0]) || $.inArray(this._getNodeName(_exactparentEle[a].childNodes[0]), this.filterNode) < 0)
                                node.appendChild(_exactparentEle[a].childNodes[0]);
                            else
                                break;
                        }
                    }
                    else
                        $(_exactparentEle[a]).css("text-align", justify);
                    if (node.childNodes.length > 0) {
                        $(node).css("text-align", justify);
                        _exactparentEle[a].insertBefore(node, _exactparentEle[a].childNodes[0]);
                        _val = 0;
                    }
                }
                else {
                    $(_exactparentEle[a]).css("text-align", justify);
                }
            }
        };
        editorManager.prototype._getParentNodeCollection = function (selNode) {
            var _backUpSelNode = selNode;
            var _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
            var _nodeDetails = [];
            _nodeDetails.push(_backUpSelNode);
            while (_backUpSelNodeName != "body" && (_backUpSelNodeName == "li" || _backUpSelNodeName == "ol" || _backUpSelNodeName == "ul")) {
                _backUpSelNode = _backUpSelNode.parentNode;
                _backUpSelNodeName = _backUpSelNode.parentNode.nodeName.toLowerCase();
                _nodeDetails.push(_backUpSelNode);
            }
            return _nodeDetails;
        };
        editorManager.prototype._generateListParentTag = function (list, selNode, listType) {
            var tag = document.createElement(list);
            $(tag).css("list-style-type", listType);
            if (selNode.nodeName.toLowerCase() != "li")
                $(tag).insertBefore(selNode);
            else
                $(tag).insertBefore(selNode.parentNode);
            return tag;
        };
        editorManager.prototype._applyOrderedList = function (list, parentDoc, _window, listType) {
            this.range = this._getRangy(_window, parentDoc);
            var nodeArray = this._getexactSelectedNode(this.range, parentDoc);
            var beforeNode = document.createElement(list);
            var afterNode = document.createElement(list);
            var _childNode = new Array();
            var selNode = this._getSelectedParent(nodeArray);
            var _parentNode = this._getParentNodeCollection(selNode[0]);
            var _startNode = document.createElement("p");
            var replaceEle = new Array();
            var removeParent, topMostParent, innerTag, tag, elemN, _node, node, _exactParentEle = _parentNode[_parentNode.length - 1];
            if (listType != "none") {
                tag = this._generateListParentTag(list, selNode[0], listType);
            }
            for (var i = 0; i <= selNode.length - 1; i++) {
                innerTag = document.createElement("li");
                if (selNode[i].parentNode.nodeName.toLowerCase() == "li")
                    selNode[i] = selNode[i].parentNode;
                if (listType == "none") {
                    if ($(selNode[i]).closest("ul,ol").length < 1)
                        continue;
                    if ($(selNode[i]).find("ol").length != 0 || $(selNode[i]).find("ul").length != 0) {
                        removeParent = $(selNode[i]).parents(list).first();
                        var _exactLi = removeParent.parents("li:last");
                        var _prevNode = removeParent.parents("li:last").prevAll();
                        var _nexNode = removeParent.parents("li:last").nextAll();
                        node = $(selNode[i]).parents("li:last")[0];
                    }
                    else {
                        removeParent = $(selNode[i]);
                        var _exactLi = removeParent;
                        var _prevNode = removeParent.prevAll();
                        var _nexNode = removeParent.nextAll();
                        node = $(selNode[i])[0];
                    }
                    topMostParent = $(selNode[i]).parents(list).last();
                    var _selectionComplete = 0;
                    if (_prevNode.length != 0) {
                        $(afterNode).append(_exactLi);
                        $(afterNode).append(_nexNode);
                        $(afterNode).insertAfter(topMostParent);
                    }
                    var ele = document.createElement("p"), elem = elemN = document.createElement("li");
                    beforeNode.appendChild(elem);
                    var backupFirstNode = topMostParent, _removeSibling = new Array(), _inc = false, newNode;
                    while (node) {
                        if ($.inArray(node, selNode) >= 0 || $.inArray(node.firstChild, selNode) >= 0 || $.inArray(node.firstChild, nodeArray) >= 0) {
                            if (_selectionComplete == 0 && elem.firstChild && elem.firstChild.innerHTML != "") {
                                topMostParent.append(elem);
                                elem = elemN = document.createElement("li");
                            }
                            newNode = document.createElement("p");
                            while (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0) {
                                newNode.appendChild(node.firstChild);
                                _inc = true;
                            }
                            if (_inc) {
                                _selectionComplete++;
                                $(newNode).insertAfter(backupFirstNode);
                                backupFirstNode = $(newNode);
                                if ($(node).children().length == 0) {
                                    _removeSibling.push(node);
                                }
                            }
                            if (_selectionComplete == selNode.length) {
                                var _nextEle = document.createElement(list);
                                if ($(node).children().length != 0)
                                    $(_nextEle).append($(node).parents("li:last").nextAll());
                                else
                                    $(_nextEle).append($(node).nextAll());
                                if (node.nodeName.toLowerCase() == "ol" || node.nodeName.toLowerCase() == "ul")
                                    $(node).insertAfter(backupFirstNode);
                                else if (node.nodeName.toLowerCase() == "li") {
                                    var _tnewNode = document.createElement(list);
                                    $(_tnewNode).append(node);
                                    $(_tnewNode).insertAfter(backupFirstNode);
                                    node = _tnewNode;
                                }
                                $(_nextEle).insertAfter(node);
                                for (var _remove = 0; _remove < _removeSibling.length; _remove++) {
                                    var _removeNodeparent;
                                    _node = _removeSibling[_remove];
                                    while (_node.nodeName.toLowerCase() != "body") {
                                        _removeNodeparent = _node.parentNode;
                                        $(_node).remove();
                                        _node = _removeNodeparent;
                                    }
                                }
                                i = selNode.length;
                                break;
                            }
                        }
                        if (this._isTextNode(node.firstChild) || (node.firstChild && $.inArray(node.firstChild.nodeName.toLowerCase(), this.filterNode) < 0)) {
                            elemN.appendChild(node.firstChild);
                            if (ej.isNullOrUndefined(node.firstChild)) {
                                node = node.nextSibling;
                            }
                        }
                        else if (this._isTextNode(node)) {
                            var _tflag = 0;
                            var appendElement = node;
                            node = node.nextSibling;
                            if (ej.isNullOrUndefined(node)) {
                                node = appendElement;
                                while ($(node.parentNode).next().length == 0) {
                                    node = node.parentNode;
                                    _tflag++;
                                }
                                if (_tflag > 0) {
                                    node = $(node.parentNode).next()[0];
                                }
                            }
                            elemN.appendChild(appendElement);
                            if (_tflag == 0 && !this._isTextNode(node))
                                elemN = this._createElement(node.nodeName.toLowerCase(), elemN.parentNode, null);
                            else
                                elemN = this._createElement(node.nodeName.toLowerCase(), this._getParentnodeName(_tflag, elemN), "after");
                            _tflag = 0;
                        }
                        else {
                            if (node.firstChild) {
                                elemN = this._createElement(node.firstChild.nodeName.toLowerCase(), elemN, null);
                                node = node.firstChild;
                            }
                            else
                                node = node.nextSibling;
                        }
                    }
                }
                else if (selNode[i].nodeName.toLowerCase() != "li") {
                    if ($(selNode[i]).is("h1,h2,h3,h4,h5,h6,p,blockquote")) {
                        $(innerTag).append(selNode[i]);
                        tag.appendChild(innerTag);
                    }
                    else {
                        if ($(selNode[i]).attr("style"))
                            $(innerTag).attr("style", $(selNode[i]).attr("style"));
                        $(innerTag).append(selNode[i].childNodes);
                        tag.appendChild(innerTag);
                        $(selNode[i]).remove();
                    }
                }
                else if (selNode[i] = $(selNode[i]).closest("li")) {
                    tag = document.createElement(list);
                    $(tag).css("list-style-type", listType);
                    $(tag).append(selNode[i].parentNode.childNodes);
                    $(selNode[i].parentNode).replaceWith(tag);
                }
            }
            if (listType != "none" && _exactParentEle.childNodes.length == 0 && (_exactParentEle.nodeName.toLowerCase() == "ol" || _exactParentEle.nodeName.toLowerCase() == "ul"))
                $(_exactParentEle).remove();
        };
        editorManager.prototype._getParentnodeName = function (_tflag, elemN) {
            var node = elemN;
            for (var a = 0; a <= _tflag; a++) {
                node = node.parentNode;
            }
            return node;
        };
        editorManager.prototype._createElement = function (element, elem, place) {
            var newEle = document.createElement(element);
            if (place != "after")
                elem.appendChild(newEle);
            else
                $(newEle).insertAfter(elem);
            return newEle;
        };
        editorManager.prototype._backUpRange = function (_parentDoc, _window) {
            var nodeStart = _parentDoc.createElement("span");
            nodeStart.id = "startRange";
            var nodeEnd = _parentDoc.createElement("span");
            nodeEnd.id = "endRange";
            var rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(false);
            rng.insertNode(nodeEnd);
            rng = this._getRangy(_window, _parentDoc).cloneRange();
            rng.collapse(true);
            rng.insertNode(nodeStart);
        };
        editorManager.prototype._resetRange = function (_parentDoc, _window) {
            var a = $(_parentDoc.body).find("span#startRange");
            var b = $(_parentDoc.body).find("span#endRange");
            var len = ej.isNullOrUndefined(b[0].previousSibling) ? 0 : this._isTextNode(b[0].previousSibling) ? b[0].previousSibling.length : b[0].previousSibling.childNodes.length > 0 ? b[0].previousSibling.childNodes.length : 0;
            var rng = this._getRangy(_window, _parentDoc);
            if (a[0].nextSibling != b[0])
                rng.setStart(a[0].nextSibling, 0);
            else
                rng.setStart(a[0].nextSibling.nextSibling, 0);
            if (b[0].previousSibling != a[0])
                ej.isNullOrUndefined(b[0].previousSibling) ? rng.setEnd(b[0].parentNode, len) : rng.setEnd(b[0].previousSibling, len);
            else
                rng.setEnd(b[0].nextSibling, 0);
            a.remove();
            b.remove();
            this._selectRange(rng, _parentDoc);
        };
        editorManager.prototype._selectRange = function (range, _parentDoc) {
            var select = _parentDoc.getSelection();
            select.removeAllRanges();
            select.addRange(range);
        };
        editorManager.prototype._validateFormatData = function (target, data) {
            var nodeData = [], element = target.parentNode, childNode = target, nodeOrder = [], _tagResult, _cssResult;
            if (element)
                do {
                    nodeOrder.push(childNode);
                    if ((_tagResult = this._tagCheck(element, data)) || (_cssResult = this._styleCheck(element, data)))
                        nodeData.push(new ValidatedData(element, target, _tagResult, _cssResult));
                } while (!$(element).is("body") && (childNode = element) && (element = element.parentNode));
            return nodeData;
        };
        editorManager.prototype._tagCheck = function (element, data) {
            return this.formatInfo.getFormatData(data).Value.tag ? $(element).is(this.formatInfo.getFormatData(data).Value.tag) : false;
        };
        editorManager.prototype._styleCheck = function (element, data) {
            var tempArrayData;
            if (!$(element).is(this.formatInfo.filterNode) && this.formatInfo.getFormatData(data).Value.css && (element.getAttribute("style"))) {
                var valStatus = true;
                tempArrayData = this.formatInfo.getFormatData(data).Value.css.split(";");
                $(tempArrayData).each(function (index, styledata) {
                    styledata && (element.getAttribute("style").replace(/\s/g, "").indexOf(styledata) == -1) && (valStatus = false);
                });
                return valStatus;
            }
            return false;
        };
        editorManager.prototype._validateFormat = function (element, format) {
            var data = [], collection = { Info: null, status: null }, status;
            format = format.toLowerCase();
            if ($.inArray(format, this.formatInfo.actionList) != -1) {
                if ((data = this._validateFormatData(element, format)) && data.length)
                    collection.Info = data;
                collection.status = (data.length > 0);
            }
            return collection;
        };
        editorManager.prototype._CurrentformateStatus = function (selectedNode, format) {
            var data = { Info: null, status: null }, status = true;
            for (var index = 0; index < selectedNode.length; index++) {
                data = this._validateFormat(selectedNode[index], format);
                (!data.status) && (status = false);
            }
            return status;
        };
        editorManager.prototype._getSelectNode = function () {
            return this._rangeExtract.ProcessRange();
        };
        editorManager.prototype._getFormatedTagOrder = function (data, index) {
            data[index].currentNode = this._getNodeOrder(data[index].textNode, data[index].node);
            return (!index) ? data : data.slice(index, index + 1);
        };
        editorManager.prototype._getNodeOrder = function (endNode, targetNode) {
            var currentNode = endNode, nodeOrder = [];
            do
                nodeOrder.push(currentNode);
            while ((currentNode = currentNode.parentNode) && currentNode != targetNode);
            return nodeOrder;
        };
        editorManager.prototype._splitNode = function (node) {
            var temp = node, siblingData = { rightSide: [], leftSide: [] };
            while (temp = temp.nextSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (this._validateCommentNode(temp))
                    siblingData.leftSide.push(temp);
            }
            return siblingData;
        };
        editorManager.prototype._validateCommentNode = function (node) {
            return (node.nodeType != 8);
        };
        editorManager.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        editorManager.prototype._validateType = function (node) {
            return (this._validateTextNode(node) && (node.data.length));
        };
        editorManager.prototype._formatechildNodes = function (nodeCollection, format, node) {
            var adjacentNodes = { rightSide: [], leftSide: [] }, cloneNode;
            for (var index = nodeCollection.length - 1; index >= 0; index--) {
                adjacentNodes = this._splitNode(nodeCollection[index]);
                (adjacentNodes.rightSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(nodeCollection[index]));
                cloneNode = node;
                (adjacentNodes.leftSide.length) && ($($(node.cloneNode(false)).append(adjacentNodes.leftSide.reverse())).insertBefore(nodeCollection[index]));
            }
        };
        editorManager.prototype._removeFormat = function (nodeData, format, matches) {
            var temp = this._getFormatedTagOrder(nodeData.Info, matches), tempcloneNode, currentNode = temp[0].currentNode.slice(temp[0].currentNode.length - 1), tempSpanNode = document.createElement("span");
            temp[0].currentNode = temp[0].currentNode.slice(0, temp[0].currentNode.length - 1);
            var adjacentNodes = this._splitNode(currentNode[0]);
            (adjacentNodes.rightSide.length) &&
                ($($(temp[0].node.cloneNode(false)).append(adjacentNodes.rightSide)).insertAfter(temp[0].node));
            if (temp[0].tag) {
                if (this._rangeExtract.cursorBasedCollection && !temp[0].textNode.data.trim().length) {
                    $(tempSpanNode).append(currentNode).insertAfter($(temp[0].node));
                }
                else
                    $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = temp[0].textNode;
                if (this._rangeExtract.cursorBasedCollection)
                    this._setCursorOnNode(tempcloneNode, temp[0].textNode);
            }
            else {
                tempcloneNode = $(temp[0].node.cloneNode(false));
                tempcloneNode.css(this.formatInfo.getFormatData(format).Value.removeCSS);
                (tempcloneNode[0].getAttribute("style")) ? $(tempcloneNode.append(currentNode)).insertAfter(temp[0].node) : $(currentNode).insertAfter(temp[0].node);
                tempcloneNode = currentNode;
            }
            (temp[0].currentNode.length) && (this._formatechildNodes(temp[0].currentNode, format, temp[0].node));
            (!adjacentNodes.leftSide.length) && ($(temp[0].node).remove());
            return tempcloneNode[0] ? tempcloneNode[0] : tempcloneNode;
        };
        editorManager.prototype._applyFormat = function (node, format, styleData) {
            var adjacentNodes = this._splitNode(node), tempcloneNode, currentNode = node, tempSpanNode = document.createElement("span");
            if (adjacentNodes.leftSide.length && (adjacentNodes.leftSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.leftSide[0], format) || this._compareCSS(adjacentNodes.leftSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.leftSide[0]).append(node);
            else if (adjacentNodes.rightSide.length && (adjacentNodes.rightSide[0].nodeType != 3) && (this._tagCheck(adjacentNodes.rightSide[0], format) || this._compareCSS(adjacentNodes.rightSide[0], (styleData ? (this.formatInfo.getFormatData(format).Value.css + ":" + styleData + ";") : this.formatInfo.getFormatData(format).Value.css))))
                $(adjacentNodes.rightSide[0]).prepend(node);
            else if (!adjacentNodes.leftSide.length && !adjacentNodes.rightSide.length && $(node.parentNode).is(this.formatInfo.getFormatData(format).Value.styleParent)) {
                if (styleData)
                    $(node.parentNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
                else
                    $(node.parentNode).css(this._collectStyleData(this.formatInfo.getFormatData(format).Value.css));
            }
            else {
                tempcloneNode = document.createElement(this.formatInfo.getFormatData(format).Value.result);
                if (this._rangeExtract.cursorBasedCollection) {
                    if (this._validateTextNode(node)) {
                        if (!$(tempcloneNode).is("span") && this._rangeExtract._noContent)
                            $(tempSpanNode).append(tempcloneNode);
                        else
                            (tempSpanNode = tempcloneNode);
                        tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, currentNode);
                        }
                        $(node).replaceWith(tempSpanNode);
                    }
                    else {
                        tempcloneNode.innerHTML = "&#65279;";
                        $(tempSpanNode).append(tempcloneNode);
                        if (node.firstChild && $(node.firstChild).is("br"))
                            $(tempSpanNode).insertBefore(node.firstChild);
                        else
                            $(node).append(tempSpanNode);
                        if (this._rangeExtract.cursorBasedCollection) {
                            this._setCursorOnNode(node, tempcloneNode.firstChild);
                        }
                        currentNode = tempcloneNode;
                    }
                }
                else {
                    tempcloneNode.appendChild(currentNode = document.createTextNode(node.data));
                    $(node).replaceWith(tempcloneNode);
                }
                styleData && $(tempcloneNode).css(this.formatInfo.getFormatData(format).Value.css, styleData);
            }
            return currentNode;
        };
        editorManager.prototype._setCursorOnNode = function (node, currentNode) {
            if (this._rangeExtract._cursorData.node == node)
                this._rangeExtract._cursorData.node = currentNode;
        };
        editorManager.prototype._compareCSS = function (element, css) {
            return element.getAttribute('style') && element.getAttribute('style').toLowerCase().trim().replace(/\s/g, "") == css.toLowerCase().trim().replace(/\s/g, "");
        };
        editorManager.prototype._collectStyleData = function (styledata) {
            var styleList = styledata.replace(/\s/g, "").split(';'), data = {}, temp;
            $(styleList).each(function (index) {
                var style = styleList[index];
                temp = style.split(':');
                (temp.length > 1) && (data[temp[0].toLowerCase().trim()] = temp[1].toLowerCase().trim());
            });
            return data;
        };
        editorManager.prototype._validateStyleData = function (node, style, styleData) {
            var nodeList = node.getAttribute('style').split(';'), status = false;
            $(nodeList).each(function (index) {
                var data = nodeList[index], temp = data.split(':');
                if (temp[0].toLowerCase().trim() == style.toLowerCase().trim() && temp[1].toLowerCase().trim() == styleData.toLowerCase().trim()) {
                    status = true;
                    return false;
                }
            });
            return status;
        };
        editorManager.prototype._caseConvert = function (casing) {
            var selectedNode = this._getSelectNode(), node, startNode, endNode, tempNode;
            if (!selectedNode.length || (selectedNode.length == 1 && !selectedNode[0].data.length))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index];
                tempNode = document.createTextNode(node.data[this.formatInfo.captionConvert[casing]]());
                if (this._rangeExtract._cursorData.node == node)
                    this._rangeExtract._cursorData.node = tempNode;
                node.data && ($(node).replaceWith(tempNode));
                tempNode && (selectedNode.length == 1) ? ((startNode = tempNode) && (endNode = tempNode)) : (index == 0) ? (startNode = tempNode) : (index == selectedNode.length - 1) ? (endNode = tempNode) : null;
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
        };
        editorManager.prototype._validateSelectedNode = function (selectedNode) {
            return (!selectedNode.length || (selectedNode.length == 1 && selectedNode[0].data && !selectedNode[0].data.length));
        };
        editorManager.prototype._tagFormatProcess = function (format, remove) {
            var selectedNode = this._getSelectNode();
            if (this._validateSelectedNode(selectedNode))
                return;
            var status = this._CurrentformateStatus(selectedNode, format), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format), retNode = null;
                if (((remove || status) && nodeData.status))
                    for (var matches = 0; matches < nodeData.Info.length; matches++)
                        retNode = this._removeFormat(nodeData, format, matches);
                else if (!nodeData.status && !remove)
                    retNode = this._applyFormat(node, format, null);
                else
                    retNode = node;
                if (retNode) {
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
                }
            }
            startNode && endNode && this._refreshRange(startNode, endNode);
            this.focus();
            return { data: nodeData, nodeStatus: status };
        };
        editorManager.prototype._refreshRange = function (startNode, endNode) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection(), cursorOnNode, cursorOffset;
            if (this._rangeExtract)
                (cursorOnNode = this._rangeExtract._cursorData.node) && (cursorOffset = this._rangeExtract._cursorData.offSet);
            if (this._rangeExtract.cursorBasedCollection && cursorOnNode && cursorOffset > -1) {
                cursorOffset = this._validateTextNode(cursorOnNode) ?
                    ((cursorOffset > cursorOnNode.data.length) ? cursorOnNode.data.length : cursorOffset) : 0;
                if (cursorOnNode.nodeType == 3 && !cursorOnNode.data.trim()) {
                    cursorOnNode.data = String.fromCharCode(65279) + cursorOnNode.data;
                    cursorOffset++;
                }
                this._updateCursor(cursorOnNode, cursorOffset);
            }
            else if (startNode && endNode) {
                if (startNode.data && !startNode.data.trim() && (startNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    startNode.data = String.fromCharCode(65279) + startNode.data;
                if (endNode.data && !endNode.data.trim() && (endNode.data.indexOf(String.fromCharCode(65279)) == -1))
                    endNode.data = String.fromCharCode(65279);
                Selection.removeAllRanges();
                range.setStart(startNode, 0);
                range.setEnd(endNode, endNode.data ? endNode.data.length : 0);
                Selection.addRange(range);
            }
            $(this.currentWindow).focus();
        };
        editorManager.prototype._updateCursor = function (node, offset) {
            var range = this.currentDocument.createRange(), Selection = this.currentDocument.getSelection();
            range.setStart(node, offset);
            range.setEnd(node, offset);
            Selection.removeAllRanges();
            Selection.addRange(range);
        };
        editorManager.prototype._cssFormatProcess = function (format, styleData, remove) {
            var selectedNode = this._getSelectNode(), node, nodeData = { Info: null, status: null }, retNode, startNode, endNode;
            if (this._validateSelectedNode(selectedNode))
                return;
            for (var index = 0; index < selectedNode.length; index++) {
                node = selectedNode[index], nodeData = this._validateFormat(node, format);
                if (nodeData.status)
                    for (var matches = 0; matches < nodeData.Info.length; matches++) {
                        if (!remove && this._validateStyleData(nodeData.Info[matches].node, this.formatInfo.getFormatData(format).Value.css, styleData))
                            continue;
                        retNode = this._removeFormat(nodeData, format, matches);
                    }
                if (!remove)
                    retNode = this._applyFormat(node, format, styleData);
                if (retNode)
                    (selectedNode.length == 1) ? ((startNode = retNode) && (endNode = retNode)) : (index == 0) ? (startNode = retNode) : (index == selectedNode.length - 1) ? (endNode = retNode) : null;
            }
            this._refreshRange(startNode, endNode);
            this.focus();
        };
        editorManager.prototype.execCommand = function (command, value) {
            try {
                switch (command) {
                    case execCommand.bold:
                        this._tagFormatProcess("bold", false);
                        break;
                    case execCommand.italic:
                        this._tagFormatProcess("italic", false);
                        break;
                    case execCommand.underline:
                        this._tagFormatProcess("underline", false);
                        break;
                    case execCommand.strikethrough:
                        this._tagFormatProcess("strikethrough", false);
                        break;
                    case execCommand.superscript:
                        this._tagFormatProcess("subscript", true);
                        this._tagFormatProcess("superscript", false);
                        break;
                    case execCommand.subscript:
                        this._tagFormatProcess("superscript", true);
                        this._tagFormatProcess("subscript", false);
                        break;
                    case execCommand.fontsize:
                        this._cssFormatProcess("fontsize", value, false);
                        break;
                    case execCommand.fontname:
                        this._cssFormatProcess("fontname", value, false);
                        break;
                    case execCommand.forecolor:
                        this._cssFormatProcess("forecolor", value, false);
                        break;
                    case execCommand.backcolor:
                        this._cssFormatProcess("backcolor", value, false);
                        break;
                    case execCommand.uppercase:
                        this._caseConvert("uppercase");
                        break;
                    case execCommand.lowercase:
                        this._caseConvert("lowercase");
                        break;
                    case execCommand.indent:
                        this._applyIndent(true);
                        break;
                    case execCommand.outdent:
                        this._applyIndent(false);
                        break;
                    case execCommand.justifyleft:
                        this._justifyContent("left");
                        break;
                    case execCommand.justifycenter:
                        this._justifyContent("center");
                        break;
                    case execCommand.justifyright:
                        this._justifyContent("right");
                        break;
                    case execCommand.justifyfull:
                        this._justifyContent("justify");
                        break;
                    case execCommand.formatblock:
                        this._applyFormateBlock(value);
                        break;
                }
                this._junkContentStatus = true;
            }
            catch (e) {
            }
        };
        return editorManager;
    }());
    documentManager.editorManager = editorManager;
    (function (execCommand) {
        execCommand[execCommand["bold"] = 0] = "bold";
        execCommand[execCommand["italic"] = 1] = "italic";
        execCommand[execCommand["underline"] = 2] = "underline";
        execCommand[execCommand["strikethrough"] = 3] = "strikethrough";
        execCommand[execCommand["superscript"] = 4] = "superscript";
        execCommand[execCommand["subscript"] = 5] = "subscript";
        execCommand[execCommand["fontsize"] = 6] = "fontsize";
        execCommand[execCommand["fontname"] = 7] = "fontname";
        execCommand[execCommand["forecolor"] = 8] = "forecolor";
        execCommand[execCommand["backcolor"] = 9] = "backcolor";
        execCommand[execCommand["uppercase"] = 10] = "uppercase";
        execCommand[execCommand["lowercase"] = 11] = "lowercase";
        execCommand[execCommand["indent"] = 12] = "indent";
        execCommand[execCommand["outdent"] = 13] = "outdent";
        execCommand[execCommand["justifyleft"] = 14] = "justifyleft";
        execCommand[execCommand["justifycenter"] = 15] = "justifycenter";
        execCommand[execCommand["justifyright"] = 16] = "justifyright";
        execCommand[execCommand["justifyfull"] = 17] = "justifyfull";
        execCommand[execCommand["formatblock"] = 18] = "formatblock";
    })(documentManager.execCommand || (documentManager.execCommand = {}));
    var execCommand = documentManager.execCommand;
    var ValidatedData = (function () {
        function ValidatedData(node, textNode, tag, css) {
            this.textNode = textNode;
            this.node = node;
            this.css = css;
            this.tag = tag;
        }
        return ValidatedData;
    }());
    var actionType = (function () {
        function actionType(tag, css, result, removeCSS, styleParent) {
            this.tag = tag;
            this.css = css;
            this.result = result;
            this.removeCSS = removeCSS;
            this.styleParent = styleParent;
        }
        return actionType;
    }());
    var captionConvertion = (function () {
        function captionConvertion() {
            this.uppercase = "toUpperCase";
            this.lowercase = "toLowerCase";
        }
        return captionConvertion;
    }());
    var KeyDictionary = (function () {
        function KeyDictionary(target, value) {
            this.Key = target;
            this.Value = value;
        }
        return KeyDictionary;
    }());
    var formateDataCollection = (function () {
        function formateDataCollection() {
            this.filterNode = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this.actionList = ["bold", "italic", "underline", "strikethrough", "superscript", "subscript", "fontsize", "fontname", "forecolor", "backcolor"];
            this.captionConvert = new captionConvertion();
            this._updateData();
        }
        formateDataCollection.prototype._updateData = function () {
            var temp = Array();
            temp.push(new KeyDictionary("bold", new actionType("b,strong", "font-weight:bold;", "b", { "font-weight": '' }, "span")));
            temp.push(new KeyDictionary("italic", new actionType("i, cite, em, var, address, dfn", "font-style:italic", "i", { "font-style": '' }, "span")));
            temp.push(new KeyDictionary("underline", new actionType("u,ins", "text-decoration:underline;", "u", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("strikethrough", new actionType("s, strike, del", "text-decoration:line-through;", "s", { "text-decoration": '' }, "span")));
            temp.push(new KeyDictionary("superscript", new actionType("sup", "vertical-align:super;font-size:smaller;", "sup", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("subscript", new actionType("sub", "vertical-align:sub;font-size:smaller;", "sub", { "vertical-align": '', "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontsize", new actionType(null, "font-size", "span", { "font-size": '' }, "span")));
            temp.push(new KeyDictionary("fontname", new actionType(null, "font-family", "span", { "font-family": '' }, "span")));
            temp.push(new KeyDictionary("forecolor", new actionType(null, "color", "span", { "color": '' }, "span")));
            temp.push(new KeyDictionary("backcolor", new actionType(null, "background-color", "span", { "background-color": '' }, "span")));
            this.tempCollection = temp;
        };
        formateDataCollection.prototype.getFormatData = function (format) {
            var temp;
            for (var index = 0; index < this.tempCollection.length; index++) {
                temp = this.tempCollection[index];
                if (temp.Key == format)
                    return this.tempCollection[index];
            }
        };
        return formateDataCollection;
    }());
    var RangeExtractor = (function () {
        function RangeExtractor(target) {
            this.exp = /\s/g;
            this._findStatus = { leftSide: null, rightSide: null };
            this._iterationStatus = false;
            this._cursorData = { node: null, offSet: null };
            this._nodeCollection = [];
            this._traverseData = {
                leftSide: { childNode: "lastChild", sibling: "previousSibling" },
                rightSide: { childNode: "firstChild", sibling: "nextSibling" }
            };
            this._blockNodes = ["div", "p", "h1", "h2", "h3", "h4", "h5", "h6", "address", "applet", "blockquote", "button", "center", "dd", "dir", "dl", "dt", "fieldset", "form", "frameset", "hr", "iframe", "isindex", "li", "map", "menu", "noframes", "noscript", "object", "ol", "pre", "script", "table", "tbody", "td", "tfoot", "th", "thead", "tr", "ul", "header", "article", "nav", "footer", "section", "aside", "main", "figure", "figcaption"];
            this._noContent = false;
            this.nodeCollection = { leftSide: [], rightSide: [] };
            this.currentDocument = target;
        }
        RangeExtractor.prototype.ProcessRange = function () {
            var tempRange = this._getRange();
            if (($(this.currentDocument.body).attr("contenteditable") == "true") && tempRange) {
                this._nodeCollection = [], this._noContent = false;
                this._iterationStatus = false;
                this._cursorData = { node: null, offSet: null };
                if ((tempRange.startContainer == tempRange.endContainer) && (tempRange.startOffset == tempRange.endOffset)) {
                    this._collectCursorBasedTextNode(tempRange.startContainer, tempRange.startOffset);
                    this.cursorBasedCollection = true;
                }
                else {
                    this._collectSelectionBasedTextNode(tempRange);
                    this.cursorBasedCollection = false;
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._insertCursor = function (startContainer, startOffset) {
            var firstNodeData = startContainer.data.substring(0, startOffset), middleNodeData = "", lastNodeData = startContainer.data.substr(startOffset), tempNode;
            firstNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
            lastNodeData.replace(String.fromCharCode(65279), "") && $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
            $(startContainer).replaceWith(tempNode = document.createTextNode(middleNodeData));
            this._cursorData = { node: tempNode, offSet: 0 };
            this._nodeCollection.push(tempNode);
            this._noContent = true;
        };
        RangeExtractor.prototype._collectCursorBasedTextNode = function (startContainer, startOffset) {
            var tempLeftIndex, temp, validString, tempNode, tempRightIndex, regx = new RegExp(this.exp);
            while (temp = regx.exec(startContainer.data)) {
                if (startContainer.data.substring(temp.index, temp.index + 1).indexOf(" ") != -1) {
                    if (temp.index < startOffset) {
                        tempLeftIndex = temp;
                    }
                    if (!tempRightIndex && (startOffset <= temp.index)) {
                        tempRightIndex = temp;
                    }
                }
            }
            if (tempLeftIndex && tempRightIndex) {
                if ((startOffset - (tempLeftIndex.index + 1) == 0 || startOffset - (tempLeftIndex.index + 1) == startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index).replace("\n", '').length)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1), lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                }
            }
            else if (tempLeftIndex) {
                var rightSideNode;
                this._collectNodeData(startContainer, false);
                rightSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if ((rightSideNode.length == 0) && (((startOffset - (tempLeftIndex.index + 1)) == 0) || ((startOffset - (tempLeftIndex.index + 1)) == startContainer.data.substring(tempLeftIndex.index + 1).replace("\n", '').length))) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var firstNodeData = startContainer.data.substring(0, tempLeftIndex.index + 1);
                    $(document.createTextNode(firstNodeData)).insertBefore(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(tempLeftIndex.index + 1)));
                    this._cursorData = { node: tempNode, offSet: startOffset - (tempLeftIndex.index + 1) };
                    this._nodeCollection.push(tempNode);
                    this._nodeCollection.concat(rightSideNode);
                }
            }
            else if (tempRightIndex) {
                var leftSideNode;
                this._collectNodeData(startContainer, true);
                leftSideNode = this._nodeCollection;
                this._nodeCollection = [];
                if (leftSideNode.length == 0 && ((startOffset == startContainer.data.substring(0, tempRightIndex.index).replace("\n", '').length) || startOffset == 0)) {
                    this._insertCursor(startContainer, startOffset);
                }
                else {
                    var lastNodeData = startContainer.data.substring(tempRightIndex.index);
                    $(document.createTextNode(lastNodeData)).insertAfter(startContainer);
                    $(startContainer).replaceWith(tempNode = document.createTextNode(startContainer.data.substring(0, tempRightIndex.index)));
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._nodeCollection = leftSideNode.reverse();
                    this._nodeCollection.push(tempNode);
                }
            }
            else {
                if (startContainer.nodeType != 3) {
                    tempNode = document.createTextNode("");
                    if (startContainer.firstChild)
                        $(tempNode).insertBefore(startContainer.firstChild);
                    else
                        $(tempNode).appendTo(startContainer);
                    this._nodeCollection.push(tempNode);
                    this._cursorData = { node: tempNode, offSet: startOffset };
                    this._noContent = true;
                }
                else {
                    var rightSideNode, leftSideNode;
                    this._collectNodeData(tempNode = startContainer, false);
                    rightSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    this._collectNodeData(tempNode, true);
                    leftSideNode = this._nodeCollection;
                    this._nodeCollection = [];
                    if (tempNode.data == String.fromCharCode(65279) || (leftSideNode.length == 0 && startOffset == 0) || (rightSideNode.length == 0 && tempNode.data.replace(String.fromCharCode(65279), "").replace("\n", '').length == startOffset)) {
                        this._insertCursor(startContainer, startOffset);
                    }
                    else {
                        this._nodeCollection = leftSideNode.reverse();
                        this._nodeCollection.push(tempNode);
                        this._nodeCollection = this._nodeCollection.concat(rightSideNode);
                        this._cursorData = { node: tempNode, offSet: startOffset };
                    }
                }
            }
            return this._nodeCollection;
        };
        RangeExtractor.prototype._validateContent = function (node, traverse) {
            var regx = new RegExp(this.exp), temp, _matches = [], tempTxtNode, textIndex;
            while (temp = regx.exec(node.data)) {
                _matches.push(temp);
            }
            if (_matches.length) {
                temp = _matches[(traverse == "leftSide") ? _matches.length - 1 : 0], textIndex = (traverse == "leftSide") ? temp.index + 1 : temp.index;
                $(tempTxtNode = document.createTextNode(node.data.substring(textIndex))).insertAfter(node);
                node.data = node.data.substring(0, textIndex);
                if ((traverse == "rightSide") && $.trim(node.data))
                    this._nodeCollection.push(node);
                else if ((traverse == "leftSide") && $.trim(tempTxtNode.data))
                    this._nodeCollection.push(tempTxtNode);
                this._findStatus[traverse] = true;
            }
            else
                this._nodeCollection.push(node);
        };
        RangeExtractor.prototype._iterateNodes = function (element, traverse) {
            if (!this._findStatus[traverse]) {
                if (element.nodeType == 3 && element.data)
                    this._validateContent(element, traverse);
                else if ((element = element[this._traverseData[traverse]["childNode"]]) && !this._findStatus[traverse])
                    do {
                        (element.nodeType == 3 && element.data) ? this._validateContent(element, traverse) : this._iterateNodes(element, traverse);
                    } while ((element = element[this._traverseData[traverse]["sibling"]]) && !this._findStatus[traverse]);
            }
        };
        RangeExtractor.prototype._collectNodeData = function (node, leftSide) {
            this._findStatus = { leftSide: undefined, rightSide: undefined };
            var _proxy = this;
            var traverse = leftSide ? "leftSide" : "rightSide";
            do {
                this.nodeCollection = this._splitSiblingNode(node);
                $(this.nodeCollection[traverse]).each(function (index, element) { _proxy._iterateNodes(element, traverse); });
            } while (!this._validateBlockType(node.parentNode) && (node = node.parentNode) && !this._findStatus[traverse]);
        };
        RangeExtractor.prototype._validateBlockType = function (node) {
            return ($.inArray(node.tagName.toLowerCase(), this._blockNodes.concat("body")) != -1);
        };
        RangeExtractor.prototype._validateTextNode = function (node) {
            return (node.nodeType == 3);
        };
        RangeExtractor.prototype._splitSiblingNode = function (node) {
            var temp = node, nodeSiblingData = { leftSide: [], rightSide: [] };
            while (temp = temp.nextSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.rightSide.push(temp);
            }
            temp = node;
            while (temp = temp.previousSibling) {
                if (temp.tagName && this._validateBlockType(temp)) {
                    continue;
                }
                nodeSiblingData.leftSide.push(temp);
            }
            return nodeSiblingData;
        };
        RangeExtractor.prototype._getRange = function () {
            var selCurrent = this.currentDocument.getSelection(), range = null;
            (selCurrent.rangeCount) && (range = selCurrent.getRangeAt(0));
            return range;
        };
        RangeExtractor.prototype._collectSelectionBasedTextNode = function (tempRange) {
            var leftData, rightData, centerData, leftNode, rightNode, centerNode, startNode = tempRange.startContainer, endNode = tempRange.endContainer;
            this._nodeCollection = [];
            if (tempRange.startContainer == tempRange.endContainer) {
                if (this._validateTextNode(tempRange.endContainer)) {
                    if (tempRange.startOffset)
                        leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    if (tempRange.startContainer.data.length != tempRange.endOffset)
                        rightData = tempRange.startContainer.data.substr(tempRange.endOffset);
                    centerData = tempRange.startContainer.data.substr(tempRange.startOffset, (tempRange.endOffset - tempRange.startOffset));
                    leftData && ($((leftNode = document.createTextNode(leftData))).insertBefore(tempRange.startContainer));
                    rightData && ($((rightNode = document.createTextNode(rightData))).insertAfter(tempRange.startContainer));
                    centerData && ($(tempRange.startContainer).replaceWith(centerNode = document.createTextNode(centerData))) && this._nodeCollection.push(centerNode);
                }
                else
                    this._updateNodeCollection((tempRange.startContainer.nodeName.toLowerCase() == 'html') ? $(tempRange.startContainer).find('body')[0] : tempRange.startContainer, startNode, null);
            }
            else {
                if (tempRange.startContainer.nodeType == 3 && tempRange.startOffset) {
                    leftData = tempRange.startContainer.data.substr(0, tempRange.startOffset);
                    rightData = tempRange.startContainer.data.substr(tempRange.startOffset);
                    ($(document.createTextNode(leftData)).insertBefore(tempRange.startContainer));
                    ($(startNode).replaceWith(startNode = document.createTextNode(rightData)));
                }
                if (tempRange.endContainer.nodeType == 3 && tempRange.endContainer.data.length != tempRange.endOffset) {
                    rightData = tempRange.endContainer.data.substr(tempRange.endOffset);
                    leftData = tempRange.endContainer.data.substr(0, tempRange.endOffset);
                    ($(document.createTextNode(rightData)).insertAfter(tempRange.endContainer));
                    ($(endNode).replaceWith(endNode = document.createTextNode(leftData)));
                }
                else if (tempRange.endOffset && tempRange.endContainer.lastChild)
                    endNode = tempRange.endContainer.lastChild;
                this._updateNodeCollection(tempRange.commonAncestorContainer, startNode, endNode);
            }
        };
        RangeExtractor.prototype._updateNodeCollection = function (targetNode, startNode, endNode) {
            this._updateIterationStatus(targetNode, startNode, endNode);
            if (targetNode = targetNode.firstChild)
                do
                    this._updateNodeCollection(targetNode, startNode, endNode);
                while (targetNode = targetNode.nextSibling);
        };
        RangeExtractor.prototype._updateIterationStatus = function (targetNode, startNode, endNode) {
            (targetNode == startNode && !this._iterationStatus) && (this._iterationStatus = true);
            if (targetNode.nodeType == 3 && this._iterationStatus)
                this._nodeCollection.push(targetNode);
            (targetNode == endNode && this._iterationStatus) && (this._iterationStatus = false);
        };
        return RangeExtractor;
    }());
})(documentManager || (documentManager = {}));
$.extend(ej, documentManager);
window["documentManager"] = null;
;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejToggleButton", "ej.ToggleButton", {

        element: null,

        model: null,
        validTags: ["input"],
        _addToPersist: ["toggleState"],
        _setFirst: false,

        _rootCSS: "e-togglebutton",

        defaults: {

            size: "normal",

            type: "button",

            width: "",

            height: "",

            enabled: true,

            toggleState: false,

            defaultText: null,

            preventToggle: false,

            activeText: null,

            contentType: "textonly",

            htmlAttributes: {},

            imagePosition: "imageleft",

            showRoundedCorner: false,

            enablePersistence: false,

            cssClass: "",

            defaultPrefixIcon: null,

            defaultSuffixIcon: null,

            activePrefixIcon: null,

            activeSuffixIcon: null,

            enableRTL: false,

            create: null,

            click: null,

            change: null,

            destroy: null
        },


        dataTypes: {
            size: "string",
            type: "enum",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            preventToggle: "boolean",
            defaultText: "string",
            activeText: "string",
            contentType: "enum",
            imagePosition: "enum",
            defaultPrefixIcon: "string",
            defaultSuffixIcon: "string",
            activePrefixIcon: "string",
            activeSuffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data"
        },
        observables: ["toggleState"],
        toggleState: ej.util.valueFunction("toggleState"),


        disable: function () {
            this.buttontag.addClass("e-disable").attr({ "aria-disabled": true });
            this.model.enabled = false;
        },

        enable: function () {
            if (this.buttontag.hasClass("e-disable")) {
                this.buttontag.removeClass("e-disable").attr({ "aria-disabled": false });
                this.model.enabled = true;
            }
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._wireEvents();
            this.initialRender = false;
        },

        _destroy: function () {
            this._off(this.buttontag, "blur", this._tglebtnblur);
            this.element.unwrap();
            this.element.removeClass('e-chkbx-hidden e-tbtn');
            !this._cloneElement.attr("name") && this.element.attr("name") && this.element.removeAttr("name");
            this.labelFinder.empty();
            this.labelFinder.text(this.model.defaultText);
            this.buttontag.remove();
            this.element.unwrap();
            this.defaultLabel.insertAfter(this.element);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "type":
                        this._settype(options[option]);
                        break;
                    case "height":
                        this._setHeight(options[option]);
                        break;
                    case "width":
                        this._setWidth(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "defaultText":
                        this._setDefaultText(options[option]);
                        break;
                    case "activeText":
                        this._setActiveText(options[option]);
                        break;
                    case "defaultPrefixIcon":
                        this._setDefaultMajorIcon(options[option]);
                        break;
                    case "defaultSuffixIcon":
                        this._setDefaultMinorIcon(options[option]);
                        break;
                    case "activePrefixIcon":
                        this._setActiveMajorIcon(options[option]);
                        break;
                    case "activeSuffixIcon":
                        this._setActiveMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "toggleState":
                        this._tglevaluestatus(ej.util.getVal(options[option]));
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                }
            }
        },

        _setSize: function (val) {
            this.buttontag.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal');
            this.buttontag.addClass("e-btn-" + val);
        },

        _settype: function (val) {
            this.model.type = val;
        },


        _setHeight: function (val) {
            this.buttontag.css('height', val);
        },

        _setWidth: function (val) {
            this.buttontag.css('width', val);
        },

        _setDefaultText: function (val) {
            if (!this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }	
        },

        _setActiveText: function (val) {
            if (this.toggleState()) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(val);
                } else {
                    this.defaulttxtspan.html(val);
                }
            }
        },

        _setDefaultMajorIcon: function (val) {
            this.defMainIcon.removeClass(this.model.defaultPrefixIcon);
            this.defMainIcon.addClass(val);
        },

        _setDefaultMinorIcon: function (val) {
            this.defMiniIcon.removeClass(this.model.defaultSuffixIcon);
            this.defMiniIcon.addClass(val);
        },

        _setActiveMajorIcon: function (val) {
            if (this.toggleState()) {
                this.defMainIcon.removeClass(this.model.activePrefixIcon);
                this.defMainIcon.addClass(val);
            }
        },

        _setActiveMinorIcon: function (val) {
            if (this.toggleState()) {
                this.defMiniIcon.removeClass(this.model.activeSuffixIcon);
                this.defMiniIcon.addClass(val);
            }
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.buttontag.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                this.buttontag.empty();
                this.model.imagePosition = val;
                this._renderButtonContent();
            }
        },

        _setRTL: function (val) {
            if (val) {
                this.buttontag.addClass("e-rtl");
            } else {
                this.buttontag.removeClass("e-rtl");
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.buttontag.removeClass(this.model.cssClass);
                this.buttontag.addClass(skin);
            }
        },

        _initialize: function () {
            if (this.element.is('[type = "checkbox"]')) {
                this._render();
            } else {
                this.element.removeClass("e-togglebutton");
            }
        },


        _render: function () {
			this.initialRender = true;
            var predecessor, labelSelector;
            /*Determine Button Type*/
            this.element.addClass('e-chkbx-hidden e-tbtn');
            if (!this.element.attr("name"))
                this.element.attr("name", this.element[0].id);
            /*Finding the label element in the dom*/
            predecessor = this.element.parents().last();
            labelSelector = "label[for='" + this.element[0].id + "']";
            this.labelFinder = predecessor.find(labelSelector);
            this.defaultLabel = predecessor.find(labelSelector).clone();
            if (!this.labelFinder.length) {
                this.labelFinder = ej.buildTag('label', "Button", {}, { "for": this.element[0].id });
                this.labelFinder.insertAfter(this.element);
            }
            if ((this.model.defaultText == null) || (this.model.defaultText == "")) {
                this.model.defaultText = this.labelFinder.text();
            }
            this.labelFinder.empty();
            this.wrapper = $('<span id="' + this.element[0].id + '-wrapper" class="e-tbtn-wrap e-widget"></span>');
            this.labelFinder.append(this.element);
            this.buttontag = ej.buildTag('button.e-togglebutton e-btn e-tbtn ' + this.model.cssClass + ' e-select', "", {}, { "role": "button", "tabindex": 0, "type": this.model.type, "data-role": "none" });
            if (!ej.isTouchDevice()) this.buttontag.addClass("e-ntouch");
            $(this.labelFinder).wrap(this.wrapper);
            this.buttontag.insertAfter(this.labelFinder);
            if (ej.util.isNullOrUndefined(this.model.activeText)) {
                this.model.activeText = this.model.defaultText;
            }
            if (ej.util.isNullOrUndefined(this.model.activePrefixIcon)) {
                this.model.activePrefixIcon = this.model.defaultPrefixIcon;
            }
            if (ej.util.isNullOrUndefined(this.model.activeSuffixIcon)) {
                this.model.activeSuffixIcon = this.model.defaultSuffixIcon;
            }
            this._setSize(this.model.size);
            this._setHeight(this.model.height);
            this._setWidth(this.model.width);
            this._setRTL(this.model.enableRTL);
            this._renderButtonContent();
            if (!this.toggleState() && !ej.isNullOrUndefined(this.element.attr('checked')))
                this.toggleState(true);
            this._tglevaluestatus(this.toggleState());
            this._roundedCorner(this.model.showRoundedCorner);
            this._addAttr(this.model.htmlAttributes);
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._tglevaluestatus(this.toggleState());
                else proxy.wrapper.attr(key, value);
            });
        },

        _renderButtonContent: function () {
            this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');
            this.defaulttxtspan = ej.buildTag('span.e-btntxt' + '#' + this.element[0].id + 'textstatic',(this.toggleState() ? this.model.activeText : this.model.defaultText));
            if (this.model.contentType.indexOf("image") > -1) {
                this.defMainIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'mainiconstatic');
                this.defMiniIcon = ej.buildTag('span ' + '#' + this.element[0].id + 'miniconstatic');
                (this.toggleState() ? this.defMainIcon.addClass(this.model.activePrefixIcon) : this.defMainIcon.addClass(this.model.defaultPrefixIcon));
                (this.toggleState() ? this.defMiniIcon.addClass(this.model.activeSuffixIcon) : this.defMiniIcon.addClass(this.model.defaultSuffixIcon))
            }
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defaulttxtspan, this.defMainIcon);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.defMainIcon.attr("style", "display:inherit");
                        this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan);
                        break;
                }
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.defMainIcon, this.defaulttxtspan, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.defMainIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.defMainIcon, this.defMiniIcon);
                this.buttontag.append(this.imgtxtwrap);
            } else {
                this.buttontag.addClass("e-txt");
                this.buttontag.text(this.model.defaultText);
            }
        },

        _tglevaluestatus: function (value) {
            if (value) {
                this._toggleButtonStatus(value);
                this.element.attr("checked", "checked");
            } else {
                this._toggleButtonStatus(value);
                this.element.prop("checked",false);
            }
        },

        _roundedCorner: function (value) {
            value == true ? this.buttontag.addClass('e-corner') : this.buttontag.removeClass('e-corner');
        },


        _wireEvents: function () {
            this._on(this.buttontag, "click", this._tglebtnclicked);
            this._on(this.buttontag, "blur", this._tglebtnblur);
        },

        _tglebtnblur:function(e){
            this.buttontag.removeClass("e-animate");
        },

        _tglebtnclicked: function (e) {
            if (this.model.preventToggle && !this.model.enabled) return false;
            if (!this.model.preventToggle) {
                if (!this.buttontag.hasClass("e-disable")) {
                    this.toggleState(this.toggleState() ? false : true);
                    if (ej.browserInfo().name == "msie" && (ej.browserInfo().version == "8.0"))
                        this._tglevaluestatus(this.toggleState());
                    else
                        this._toggleButtonStatus(this.toggleState());
                    $(this.element).prop("checked", this.toggleState());
                    e.preventDefault();
                    this.buttontag.addClass("e-animate");
                    this._trigger("click", { "isChecked": this.toggleState(), status: this.model.enabled });
                }
            }
        },

        _toggleButtonStatus: function (buttonstatus) {
            if (buttonstatus) {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.activeText);
                } else {
                    this.defaulttxtspan.html(this.model.activeText);
                    this.defMainIcon.removeClass(this.model.defaultPrefixIcon).addClass(this.model.activePrefixIcon);
                    this.defMiniIcon.removeClass(this.model.defaultSuffixIcon).addClass(this.model.activeSuffixIcon);
                }
                this.buttontag.addClass("e-active").attr("aria-pressed", true);
            } else {
                if (this.model.contentType == ej.ContentType.TextOnly) {
                    this.buttontag.html(this.model.defaultText);
                } else {
                    this.defaulttxtspan.html(this.model.defaultText);
                    this.defMainIcon.removeClass(this.model.activePrefixIcon).addClass(this.model.defaultPrefixIcon);
                    this.defMiniIcon.removeClass(this.model.activeSuffixIcon).addClass(this.model.defaultSuffixIcon);
                }
                this.buttontag.removeClass("e-active").attr("aria-pressed", false);
            }
            this.toggleState(buttonstatus);
            if(!this.initialRender)
            this._trigger('change', { "isChecked": this.toggleState() });
        },

    });

    ej.ContentType = {
		/**  Supports only for text content only */
		TextOnly: "textonly", 
		/** Supports only for image content only */
		ImageOnly: "imageonly", 
		/** Supports image for both ends of the button */
		ImageBoth: "imageboth", 
		/** Supports image with the text content */
		TextAndImage: "textandimage", 
		/** Supports image with both ends of the text */
        ImageTextImage: "imagetextimage"
    };


    ej.ImagePosition = {
		/**  support for aligning text in left and image in right. */
		ImageRight: "imageright", 
		/**  support for aligning text in right and image in left. */
		ImageLeft: "imageleft", 
		/**  support for aligning text in bottom and image in top. */
		ImageTop: "imagetop", 
		/**  support for aligning text in top and image in bottom. */
        ImageBottom: "imagebottom"
    };

    ej.ButtonSize = {
		/**  Creates button with inbuilt default size height, width specified */
		Normal : "normal",
		/**  Creates button with inbuilt mini size height, width specified */
		Mini: "mini", 
		/**  Creates button with inbuilt small size height, width specified */
		Small: "small",
		/**  Creates button with inbuilt medium size height, width specified */
		Medium:"medium", 
		/**  Creates button with inbuilt large size height, width specified */
		Large: "large" 
    };
        
    ej.ButtonType = {
        /**  Creates button with button type as button */
        Button: "button",
        /**  Creates button with button type as reset */
        Reset: "reset",
        /**  Creates button with button type as submit */
        Submit: "submit"

    };
})(jQuery, Syncfusion);;;
/**
* @fileOverview Plugin provides support to display color picker within your web page and allows to pick the color.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws.
* @version 12.1
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejColorPicker", "ej.ColorPicker", {
        _rootCSS: "e-colorpicker",

        element: null,

        model: null,
        validTags: ["input", "div"],
        _addToPersist: ["value", "opacityValue"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },


        defaults: {

            enableOpacity: true,

            opacityValue: 100,

            columns: 10,

            palette: "basicpalette",

            htmlAttributes: {},

            buttonMode: "split",

            custom: [],

            presetType: "basic",

            modelType: "picker",

            locale: "en-US",

            showPreview: true,

            showTooltip: false,

            showClearButton: false,

            showSwitcher: true,

            value: null,

            displayInline: false,

            buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            },

            showApplyCancel: true,

            showRecentColors: false,

            toolIcon: null,

            cssClass: "",

            enabled: true,

            change: null,

            select: null,

            open: null,

            close: null,

            create: null,

            destroy: null,
        },
        dataTypes: {
            modelType: "enum",
            palette: "enum",
            presetType: "enum",
            cssClass: "string",
            displayInline: "boolean",
            locale: "string",
            showSwitcher: "boolean",
            showRecentColors: "boolean",
            enabled: "boolean",
            showPreview: "boolean",
            enableOpacity: "boolean",
            buttonText: "data",
            custom: "array",
            htmlAttributs: "data"
        },

        observables: ["value", "opacityValue"],
        value: ej.util.valueFunction("value"),
        opacityValue: ej.util.valueFunction("opacityValue"),

        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "enableOpacity":
                        this.model.enableOpacity = jsondata[key];
                        this._previewSlider(this.model.enableOpacity);
                        this._valueOperation();
                        break;
                    case "opacityValue":
                        if (this.model.enableOpacity) {
                            this._tempOpacity = parseFloat(ej.util.getVal(jsondata[key]));
                            this._opacity.option('value', this._tempOpacity);
                            !this._switch && this._changeOpacity();
                            this._updateValue();
                            this.opacityValue(this._tempOpacity);
                            typeof jsondata[key] == "function" ? jsondata[key](this.opacityValue()) : jsondata[key] = this.opacityValue();
                            break;
                        } else return false;
                    case "custom":
                        this.model.custom = jsondata[key];
                        this._reInitialize();
                        break;
                    case "palette":
                        this.model.palette = jsondata[key];
                        this._reInitialize();
                        break;
                    case "columns":
                        this.model.columns = parseFloat(jsondata[key]);
                        this._reInitialize();
                        jsondata[key] = this.model.columns;
                        break;
                    case "presetType":
                        this.model.presetType = jsondata[key];
                        if (ej.isNullOrUndefined(Colors[this.model.presetType])) return false;
                        else
                            this._reInitialize();
                        break;
                    case "buttonMode":
                        this._unBindIconClick();
                        this._buttonElement = ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.dropdownbutton : this.wrapper;
                        ej.ColorPicker.ButtonMode.Split == jsondata[key] ? this.wrapper.addClass("e-split") : this.wrapper.removeClass("e-split");
                        this._bindIconClick();
                        break;
                    case "showTooltip":
                        this._colorSlider.option('showTooltip', jsondata[key]);
                        this._opacity.option('showTooltip', jsondata[key]);
                        break;
                    case "value":
                        this._setValue(ej.util.getVal(jsondata[key]), true);
                        if (typeof jsondata[key] == "function")
                            jsondata[key](this.value());
                        else
                            jsondata[key] = this.value();
                        break;
                    case "modelType":
                        this.model.modelType = jsondata[key];
                        this._reInitialize();
                        break;
                    case "showSwitcher":
                        this.model.showSwitcher = jsondata[key];
                        this._showSwitcher();
                        break;
                    case "tooltipText":
                        this._toolTipText(jsondata[key]);
                        break;
                    case "locale": 
                        this.model.locale = jsondata[key];
                        this._localize(jsondata[key]);
                        break;
                    case "showPreview":
                        this.model.showPreview = jsondata[key];
                        this._previewPane(this.model.showPreview);
                        break;
                    case "buttonText":
                        this._buttonText(jsondata[key]);
                        break;
                    case "displayInline":
                        this._setDisplayInline(jsondata[key]);
                        break;
                    case "cssClass":
                        this._setSkin(jsondata[key]);
                        this.model.cssClass = jsondata[key];
                        break;
                    case "enabled":
                        this._enabled(jsondata[key]);
                        break;
                    case "showRecentColors":
                        this.model.showRecentColors = jsondata[key];
                        this._previewColor(this.model.showRecentColors);
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "showClearButton": this._showClearIcon(jsondata[key]); break;
                    case "showApplyCancel": this.model.showApplyCancel = jsondata[key]; this._buttonContainer(); break;
                }
            }
        },


        _setSkin: function (className) {
            if (this.wrapper)
                this.wrapper.removeClass(this.model.cssClass).addClass(className);
            else
                this.element.removeClass(this.model.cssClass).addClass(className);
        },
        _showSwitcher: function () {
            if (this.model.showSwitcher) {
                this._changeTag.removeClass('e-hide');
                this.model.modelType == "picker" ? this._switcher.addClass('e-paletteModel').removeClass('e-pickerModel') : this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
            else
                this._changeTag.addClass('e-hide');
        },
        _pickerType: function () {
            this._modelType = "picker";
            this.PaletteWrapper.removeAttr('style');
            this.PaletteWrapper.addClass('e-hide');
            this._gradient.removeClass('e-hide');
            this._gradient.fadeIn(200);
            this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this._switcher.removeAttr('class');
            this._switcher.addClass('e-color-image e-paletteModel');
            this._switch = true;
            this._rgbValue();
            this._hueGradient();
            this._updateUI();
            this._alphaGradient(this.RGBToHEX(this.rgb));
            this._hsva.ejButton("enable");
            this._switchEvents();
            this._unSwitchEvents();
            this._hideUnBindEvents();
            this.isPopupOpen && this._showBindEvents();
            this.model.modelType == "default" ? this._changeTag.removeClass('e-hide') : this._changeTag.addClass('e-hide');
            this.popupList.prepend(this._gradient);
            this._showSwitcher();
        },
        _paletteType: function () {
            this._gradient.removeAttr('style');
            this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.PaletteWrapper.removeClass('e-hide');
            this.PaletteWrapper.fadeIn(200);
            this._switch = false;
            this._disableHSVButton();
            this._cellSelect();
            this._switchEvents();
            this._unSwitchEvents();
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            this.popupList.prepend(this.PaletteWrapper);
            this._showSwitcher();
        },
        _reInitialize: function () {
            this._destroyPalette(false);
        },
        _destroyPalette: function (presets) {
            this.PaletteWrapper.remove();
            if (presets || this._columns != this.model.columns && this.model.palette !== "custompalette") this.PaletteWrapper = this._presetType(this._presetsId);
            if (this._temp !== this.model.presetType) this.PaletteWrapper = this._layoutType(this.model.palette);
            if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._hideUnBindEvents();
                this.isPopupOpen && this._showBindEvents();
                this._gradient.addClass('e-hide');
                this._paletteType();
                presets || this.model.palette == "custompalette" ? "" : this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            }
            if (this.model.modelType == "picker") {
                this._pickerType();
                if (this.model.displayInline && !this.element.is('input'))
                    this._footer.addClass('e-hide');
            }
            this._temp = this.model.presetType; this._columns = this.model.columns;
            if (this._modelType == "picker")
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            else
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
            this.refresh();
        },
        _previewColor: function (color) {
            if (color) {
                this._swatchesArea.fadeIn(200);
                this._bindRecentEvent();
            }
            else {
                this._swatchesArea.fadeOut(200);
                this._unBindRecentEvent();
            }
        },
        _buttonText: function (data) {
            $.extend(this.model.buttonText, data);
            if (!ej.isNullOrUndefined(this._buttonTag)) this._buttonTag.html(this.model.buttonText.apply);
            if (!ej.isNullOrUndefined(this._cancelTag)) this._cancelTag.html(this.model.buttonText.cancel);
            this._spnTag.html(this.model.buttonText.swatches);
        },
        _toolTipText: function (data) {
            $.extend(this.model.tooltipText, data);
            this._addTitleText();
        },
        _previewPane: function (showPreview) {
            showPreview ? this._previewTag.removeClass("e-hide") : this._previewTag.addClass("e-hide");
        },
        _previewSlider: function (slider) {
            slider ? this._opacity.enable() : this._opacity.disable();
        },
        _getLocalizedLabels: function () {
            return ej.getLocalizedConstants(this.sfType, this.model.locale);
        },
        _localize: function () {
            this._localizedLabels = this._getLocalizedLabels();
            if (this._options.locale == "en-US" && !ej.isNullOrUndefined(this._options.buttonText) || !ej.isNullOrUndefined(this._options.tooltipText)) {
                if (!ej.isNullOrUndefined(this._options.buttonText))
                    this._buttonText(this._options.buttonText);
                if (!ej.isNullOrUndefined(this._options.tooltipText))
                    this._toolTipText(this._options.tooltipText);
            }
            else if (!ej.isNullOrUndefined(this._localizedLabels)) {
                if (!ej.isNullOrUndefined(this._localizedLabels.buttonText))
                    this._buttonText(this._localizedLabels.buttonText)
                if (!ej.isNullOrUndefined(this._localizedLabels.tooltipText))
                    this._toolTipText(this._localizedLabels.tooltipText)
            }
        },
        _destroy: function () {
            if (this.model.displayInline)
                $(window).off("resize", $.proxy(this._OnWindowResize, this));
            if (this.isPopupOpen) this.hide();
            this.popupContainer.remove();
            if (this.wrapper) {
                this.element.insertAfter(this.wrapper);
                this.wrapper.remove();
                this._presetContainer.parent('.e-menu-wrap').remove();
            }
            this.element.removeClass('e-colorpicker e-input e-widget').removeAttr("style name").val(this.element.attr("value"));
        },
        _init: function (options) {
            this._options = options;
            this._browser = ej.browserInfo();
            this._isFocused = false;
            this.isPopupOpen = false;
            this._dataBind = false;
            this._modelType = "picker";
            if (this._id)
                $("#" + this._id + "_popup").remove();
            if ("#" + this._id + "_Presets")
                $('#' + this._id + "_Presets").parent('.e-menu-wrap').remove();
            this.model.palette === "basicpalette" ? this._presetsId = "e-presets30" : "";
            if (ej.isNullOrUndefined(this.value()) && this.element[0].value !== "") this._tempValue = this.element[0].value;
            else this._tempValue = this.value();
            this._previousValue = this._previousColor = this._tempValue;
            this._renderControl();
            this._tempOpacity = this.opacityValue();
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            this.popupContainer.find('button.e-presets').ejSplitButton({ targetID: this._presetContainer.attr('id') });
            if (this._tempValue) {
                this._setValue(this._tempValue);
                if (this._switch) this._rgbValue();
            }
            this._hsvValue();
            this._hueGradient();
            this._addTitleText();
            this._showClearIcon(this.model.showClearButton);
            this._columns = this.model.columns;
            this._temp = this.model.presetType;
            if (!this._tempValue) {
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this._tempOpacity);
                this._alphaGradient("#fff");
                this._previousValue = "";
            }
            !this.model.enabled && this._enabled(this.model.enabled);
        },
        _renderControl: function () {
            this._createWrapper();
            this._renderPopupPanelWrapper();
            this._selectedButton = this._groupTag.find('.e-click');
            this._buttonContainer();
            this._renderPopupElement();
            this._buttonElement = ej.ColorPicker.ButtonMode.Split == this.model.buttonMode ? this.dropdownbutton : this.wrapper;
            if (this.model.buttonMode == ej.ColorPicker.ButtonMode.Split && this.element.is('input')) this.wrapper.addClass("e-split");
            this._addAttr(this.model.htmlAttributes);
            this._setDisplayInline(this.model.displayInline);
            this._previewPane(this.model.showPreview);
            this._previewColor(this.model.showRecentColors);
            this._localize();
            if (this._switch) this._previewSlider(this.model.enableOpacity);
            this._wireEvents();
            this._switchEvents();
        },

        _createWrapper: function () {
            if (this.element.is("input")) {
                this.element.addClass('e-input e-widget');
                this.spanElement = ej.buildTag("span.e-selected-color");
                this.wrapper = ej.buildTag("span.e-colorwidget e-picker e-widget " + this.model.cssClass).attr({ 'tabindex': '0', "aria-expanded": false, "aria-haspopup": true, "aria-owns": "popup" });
                if (this._id) this.wrapper.attr('id', this._id + "Wrapper");
                this.container = ej.buildTag("span.e-in-wrap e-box e-splitarrowright");
                this.drpbtnspan = ej.buildTag("span.e-icon e-arrow-sans-down", "", {}, { "aria-label": "select" });
                this.dropdownbutton = ej.buildTag("span.e-select", "", {}, { "role": "button" }).append(this.drpbtnspan);
                this.iconWrapper = ej.buildTag("span.e-tool-icon " + this.model.toolIcon);
                this.colorContainer = ej.buildTag("span.e-color-container");
                this.colorContainer.append(this.spanElement);
                this.container.insertAfter(this.element);
                if (!ej.isNullOrUndefined(this.model.toolIcon)) {
                    this.colorContainer.prepend(this.iconWrapper);
                    this.container.addClass('e-tool');
                    this.container.append(this.colorContainer);
                }
                else
                    this.container.append(this.colorContainer);
                this.container.append(this.element, this.dropdownbutton);
                this.wrapper.insertBefore(this.container);
                this.wrapper.append(this.container);
                this.element.css("display", "none").val(this.value());
            }
            this._checkNameAttr();
        },
        _addTitleText: function () {
            this._switcher.attr('title', this.model.tooltipText.switcher);
            this._spanTag.attr('title', this.model.tooltipText.addButton);
            this._presetLi.find("#e-presets00").attr('title', this.model.tooltipText.webColors);
            this._presetLi.find("#e-presets01").attr('title', this.model.tooltipText.vintage);
            this._presetLi.find("#e-presets02").attr('title', this.model.tooltipText.seaWolf);
            this._presetLi.find("#e-presets10").attr('title', this.model.tooltipText.sandy);
            this._presetLi.find("#e-presets11").attr('title', this.model.tooltipText.pinkShades);
            this._presetLi.find("#e-presets12").attr('title', this.model.tooltipText.moonLight);
            this._presetLi.find("#e-presets20").attr('title', this.model.tooltipText.monoChrome);
            this._presetLi.find("#e-presets21").attr('title', this.model.tooltipText.misty);
            this._presetLi.find("#e-presets22").attr('title', this.model.tooltipText.flatColors);
            this._presetLi.find("#e-presets30").attr('title', this.model.tooltipText.basic);
            this._presetLi.find("#e-presets31").attr('title', this.model.tooltipText.candyCrush);
            this._presetLi.find("#e-presets32").attr('title', this.model.tooltipText.citrus);
            this._currentTag.attr('title', this.model.tooltipText.currentColor);
            this._previousTag.attr('title', this.model.tooltipText.selectedColor);
        },
        _renderPopupPanelWrapper: function () {
            this.popupContainer = ej.buildTag("div.e-colorpicker e-box e-popup e-widget " + this.model.cssClass, "", {}, { "role": "grid", "aria-readonly": "true", "tabindex": '0', "style": "visibility:hidden" });
            if (this._id) this.popupContainer.attr('id', this._id + "_popup");
            $('body').append(this.popupContainer);

            this.popupList = ej.buildTag("div.e-popupWrapper");

            this._gradient = ej.buildTag("div.e-container");

            this._colorArea = ej.buildTag("div.e-hsv-color");
            this._gradientArea = ej.buildTag("div.e-hsv-gradient")
            this._handleArea = ej.buildTag("div.e-draghandle e-color-image");
            this._browser == "msie" && this._handleArea.addClass('e-pinch');
            this._colorArea.append(this._gradientArea, this._handleArea);

            this._picker = ej.buildTag("div.e-gradient");
            this._hueSlider = ej.buildTag("div.e-widget e-hue e-state-default");
            this._alphaSlider = ej.buildTag("div.e-widget e-opacity e-state-default");
            this._picker.append(this._hueSlider, this._alphaSlider);

            this._gradient.append(this._colorArea, this._picker);

            this.popupList.append(this._gradient);


            this._footerBlock = ej.buildTag("div.e-footerContainer");

            this._templateWrapper = ej.buildTag("div.e-buttons");


            this._groupTag = ej.buildTag("div.e-grpbtn");

            this._formEle = ej.buildTag("div.e-form");
            this._rgb = ej.buildTag("button.e-rgbButton e-click", "", {}, { type: "button" });
            this._hexCode = ej.buildTag("button.e-hexButton", "", {}, { type: "button" });
            this._hsva = ej.buildTag("button.e-hsvButton", "", {}, { type: "button" });
            this._groupTag.append(this._rgb, this._hexCode, this._hsva);


            this._codeEditor = ej.buildTag("div.e-codeeditor");
            this._inputTag = ej.buildTag("input.e-color-code", "", {}, { "type": "text", 'tabindex': '0', "maxLength": "22" });
            this._codeEditor.append(this._inputTag);

            this._formEle.append(this._groupTag, this._codeEditor);

            this._previewTag = ej.buildTag("div.e-preview").attr({ 'tabindex': '0' });
            this._currentTag = ej.buildTag("div.e-current");
            this._previousTag = ej.buildTag("div.e-previous");
            this._previewTag.append(this._currentTag, this._previousTag);

            this._templateWrapper.append(this._formEle, this._previewTag);

            this._swatchesArea = ej.buildTag("div.e-color-labels");
            var blockCount = 11;
            this._divTag = ej.buildTag("div.e-recent-color");
            this._addTag = ej.buildTag('div.e-colorblock e-block');
            this._spanTag = ej.buildTag('div.e-color e-color-image e-add');
            this._addTag.append(this._spanTag)
            this._divTag.append(this._addTag);
            for (var count = 0; count < blockCount; count++) {
                this._liTag = ej.buildTag('div.e-colorblock e-block');
                var spanTag = ej.buildTag('div.e-color e-color-image e-empty');
                this._liTag.append(spanTag);
                this._divTag.prepend(this._liTag);
            }
            this._swatchesArea.append(this._divTag);

            this._footer = ej.buildTag('div.e-footer');
            this._swatches = ej.buildTag('div.e-element');
            this._changeTag = ej.buildTag('div.e-switcher').attr('tabindex', '0');
            this._switcher = ej.buildTag('div.e-color-image');
            this._presetTag = ej.buildTag('button.e-presets e-colorSplit');
            this._presets = ej.buildTag('div');
            this._changeTag.append(this._switcher);
            this._presetTag.append(this._presets);
            this._swatches.append(this._changeTag, this._presetTag);
            this._footer.append(this._swatches);
            this._footerBlock.append(this._templateWrapper, this._swatchesArea, this._footer);

            this.PaletteWrapper = this._layoutType(this.model.palette);
            this.popupList.append(this.PaletteWrapper, this._footerBlock);
            var oldWrapper = $("#" + this._id + "_Presets").get(0);
            if (oldWrapper) {
                if ($(oldWrapper).parent().hasClass("e-menu-wrap"))
                    $(oldWrapper).parent().remove();
                else
                    $(oldWrapper).remove();
            }
            this._presetContainer = $("<ul id='" + this._id + "_Presets' class='e-presetWrapper' style= top:87px ></ul>");
            this._presetLi = ej.buildTag('li.e-item');
            this._presetLi.append(this._renderPresets());
            this._presetContainer.append(this._presetLi);
            this.popupList.append(this._presetContainer);
            this.popupContainer.append(this.popupList);

            //IE Support
            if (this._browser.name = "msie" && (this._browser.version == "9.0" || this._browser.version == "8.0"))
                this._hueSlider.addClass('e-color-image e-filter');
            else
                this._hueSlider.addClass('e-common');
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },
        _buttonContainer: function () {
            if (this.model.showApplyCancel) {
                this._buttonTag = ej.buildTag("button.e-applyButton", "", {}, { type: "button" });
                this._cancelTag = ej.buildTag("button.e-cancelButton", "", {}, { type: "button" });
                this._footer.append(this._buttonTag, this._cancelTag);
                this._applyObj = this.popupContainer.find('button.e-applyButton').ejButton({ text: this.model.buttonText.apply, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._cancelObj = this.popupContainer.find('button.e-cancelButton').ejButton({ text: this.model.buttonText.cancel, type: "button", cssClass: "e-flat" }).data('ejButton');
                this._on(this._cancelTag, "click", this._hidePopup);
                this._on(this._buttonTag, "click", this._buttonClick);
            } else if (this._buttonTag !== undefined && this._cancelTag !== undefined) {
                this._buttonTag.remove();
                this._cancelTag.remove();
                this._off(this._cancelTag, "click", this._hidePopup);
                this._off(this._buttonTag, "click", this._buttonClick);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "required") proxy.element.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy._enabled(false);
                else proxy.wrapper.attr(key, value)
            });
        },
        _showClearIcon: function (bool) {
            if (bool) {
                this._clearIcon = ej.buildTag("div", {}, {}, { "class": "e-icon e-close_01" }).hide();
                this._codeEditor.append(this._clearIcon);
                this._on(this._clearIcon, "mousedown", this._clearColor);
                this._on(this._clearIcon, "click", this._clearColor);
            } else {
                this._clearIcon && this._clearIcon.remove();
                this._off(this._clearIcon, "mousedown", this._clearColor);
                this._off(this._clearIcon, "click", this._clearColor);
            }
        },
        _colorPresetsClick: function (e) {
            this._presetsId = e.currentTarget.id;
            if (this._presetsId === "e-presets00") this.model.presetType = "webcolors";
            else if (this._presetsId === "e-presets01") this.model.presetType = "vintage";
            else if (this._presetsId === "e-presets02") this.model.presetType = "seawolf";
            else if (this._presetsId === "e-presets10") this.model.presetType = "sandy";
            else if (this._presetsId === "e-presets11") this.model.presetType = "pinkshades";
            else if (this._presetsId === "e-presets12") this.model.presetType = "moonlight";
            else if (this._presetsId === "e-presets20") this.model.presetType = "monochrome";
            else if (this._presetsId === "e-presets21") this.model.presetType = "misty";
            else if (this._presetsId === "e-presets22") this.model.presetType = "flatcolors";
            else if (this._presetsId === "e-presets30") this.model.presetType = "basic";
            else if (this._presetsId === "e-presets31") this.model.presetType = "candycrush";
            else if (this._presetsId === "e-presets32") this.model.presetType = "citrus";
            this._splitObj.option('prefixIcon', 'e-icon e-color-image e-' + this.model.presetType);
            $("#" + this._id + "_Presets").find("li.e-preset-row").removeClass("e-presetsactive");
            $("#" + this._presetsId).addClass("e-presetsactive");
            this.PaletteWrapper.remove();
            if (this._modelType == "palette") {
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.addClass('e-pickerModel').removeClass('e-paletteModel');
            }
        },

        _renderPresets: function () {
            var tableDiv = ej.buildTag("div.e-presets-table");
            this._spnTag = ej.buildTag("span.e-presetHeader");
            this._spnTag.html(this.model.buttonText.swatches);
            tableDiv.append(this._spnTag);
            var color = 0, hexCode, rowDiv;
            for (var row = 0; row < 4 ; row++) {
                rowDiv = ej.buildTag("ul.e-tablerow");
                for (var col = 0; col < 3 ; col++) {
                    var tableCell = ej.buildTag("li.e-color-image e-preset-row" + "#" + "e-presets" + [row] + [col]);
                    tableCell.appendTo(rowDiv);
                }
                rowDiv.appendTo(tableDiv);
            }
            return tableDiv;
        },
        _renderPopupElement: function () {
            var proxy = this;
            this._hsv =
            {
                h: 360, s: 0, v: 100
            };
            this._rgb.ejButton({ text: "RGBA", type: "button" });
            this._hexCode.ejButton({ text: "HEX", type: "button" });
            this._hsva.ejButton({ text: "HSVA", type: "button" });
            this._splitObj = this._presetTag.ejSplitButton({ size: "normal", showRoundedCorner: true, contentType: "imageonly" }).data('ejSplitButton');
            this._splitObj.option("beforeOpen", function (e) { proxy._bindClickOperation(e); });
            this._presetTag.parents('.e-split.e-widget').css({ "height": "27px" });
            this.model.custom.length == 0 ? this._splitObj.option('prefixIcon', "e-icon e-color-image e-" + this.model.presetType) : "";
            $("#" + this._presetsId).addClass("e-presetsactive");
            this._splitObj._getXYpos = function (e) {
                $("#" + this.model.targetID).ejMenu({ animationType: "none" });
                var btnposx, btnposy, btnpos = this.dropbutton.offset();
                btnposx = btnpos.left - this.dropbutton.prev().outerWidth() - 1;
                btnposy = (btnpos.top - $("#" + this.model.targetID).outerHeight()) - 1;
                return { x: btnposx, y: btnposy }
            }
            this._colorSlider = this._hueSlider.ejSlider({ orientation: "Vertical", showTooltip: this.model.showTooltip, minValue: 0, maxValue: 360, change: function (e) { proxy._changeHue(e); }, slide: function (e) { proxy._changeHue(e); } }).data('ejSlider');
            this._opacity = this._alphaSlider.ejSlider({ value: this.opacityValue(), showTooltip: this.model.showTooltip, orientation: "Vertical", incrementStep: 5, value: 100, change: function (e) { proxy._changeAlpha(e); }, slide: function (e) { proxy._changeAlpha(e); } }).data('ejSlider');
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._handleTag = ej.buildTag("div.e-handle-wrapper");
                this._handleTag.appendTo(this._opacity.element.find("a.e-handle"));
            }
            this._colorSlider.firstHandle.css({ "height": "13px", "width": "13px" });
            this._opacity.firstHandle.css({ "height": "13px", "width": "13px" });
            this.popupContainer.css({ "visibility": "visible", "display": "none" });
            if (this.model.modelType == "picker") {
                this._modelType = "picker";
                this._gradient.removeClass('e-hide');
                this.PaletteWrapper.addClass('e-hide');
                this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                this._showSwitcher();
                this._switch = true;
            } else if (this.model.modelType == "palette") {
                this._modelType = "palette";
                this._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                this.PaletteWrapper.removeClass('e-hide');
                this._gradient.addClass('e-hide');
                this._hsva.ejButton("disable");
                this._showSwitcher();
                this._switch = false;
            }
        },
        _layoutType: function (type) {
            if (typeof type === "string" && type == "basicpalette")
                this._collection = this._paletteGenerate(Colors[this.model.presetType], this.model.columns);
            else if (typeof type === "string" && type == "custompalette" && this.model.modelType == "palette")
                this._collection = this._paletteGenerate(this.model.custom, this.model.columns);
            type == "custompalette" ? this._collection.addClass('e-custom') : "";
            return this._collection;
        },
        _presetType: function (type) {
            if (type === "e-presets00") this._collection = this._paletteGenerate(Colors.webcolors, this.model.columns);
            else if (type === "e-presets01") this._collection = this._paletteGenerate(Colors.vintage, this.model.columns);
            else if (type === "e-presets02") this._collection = this._paletteGenerate(Colors.seawolf, this.model.columns);
            else if (type === "e-presets10") this._collection = this._paletteGenerate(Colors.sandy, this.model.columns);
            else if (type === "e-presets11") this._collection = this._paletteGenerate(Colors.pinkshades, this.model.columns);
            else if (type === "e-presets12") this._collection = this._paletteGenerate(Colors.moonlight, this.model.columns);
            else if (type === "e-presets20") this._collection = this._paletteGenerate(Colors.monochrome, this.model.columns);
            else if (type === "e-presets21") this._collection = this._paletteGenerate(Colors.misty, this.model.columns);
            else if (type === "e-presets22") this._collection = this._paletteGenerate(Colors.flatcolors, this.model.columns);
            else if (type === "e-presets30") this._collection = this._paletteGenerate(Colors.basic, this.model.columns);
            else if (type === "e-presets31") this._collection = this._paletteGenerate(Colors.candycrush, this.model.columns);
            else if (type === "e-presets32") this._collection = this._paletteGenerate(Colors.citrus, this.model.columns);
            return this._collection;
        },
        _paletteGenerate: function (colors, columns) {
            var color;
            this._PresetTable = ej.buildTag("div.e-palette-color").attr({ "role": "presentation" });
            this._tag = ej.buildTag("div.e-row").attr({"role":"row"});
            for (color = 0; color < colors.length; color++) {
                if (color && color % columns == 0)
                    this._tag = ej.buildTag("div.e-row").attr({"role":"row"});
                this._td = ej.buildTag("div.e-item").attr({ 'role': 'gridcell', "aria-label": "#" + $.trim(colors[color]), "data-value": "#" + $.trim(colors[color]), "style": "background-color:" + "#" + $.trim(colors[color]) });
                this._tag.append(this._td);
                this._PresetTable.append(this._tag);
            }
            return this._PresetTable;
        },
        _checkNameAttr: function () {
            if (!this.element.attr("name")) this.element.attr({ "name": this.element[0].id });
        },
        _enabled: function (bool) {
            if (bool) this.enable();
            else {
                this.model.enabled = true;
                this.disable();
            }
        },
        _setDisplayInline: function (isDisplayInline) {
            this.model.displayInline = isDisplayInline;
            if (isDisplayInline && this.element.is("input")) {
                this.popupContainer.insertAfter(this.wrapper);
                this._footer.css({ "display": "none" });
                this._setPopupPosition();
            }
            else if (isDisplayInline) {
                this.element.append(this.popupContainer);
                this.popupContainer.find('button.e-applyButton').css({ "display": "none" });
                this.popupContainer.find('button.e-cancelButton').css({ "display": "none" });
                this._footer.css({ "display": "none" });
            }
            else {
                this.popupContainer.css('display', 'none');
                $('body').append(this.popupContainer);
                this._isOpen = false;
                if (this.element.is("input")) {
                    this._bindIconClick();
                    if (this.popupContainer.find('button.e-applyButton').length==0) {
                        this._buttonContainer();
                    }
                    this._footer.css({ "display": "block" });
                    this.wrapper.removeClass("e-focus");
                    this._off($(document), "mousedown", this._onDocumentClick);
                }
                this._isFocused = this.isPopupOpen = false;
            }
            if (isDisplayInline) {
                this.show();
                if (this.element.is("input")) this._off($(this._buttonElement), "mousedown", this._iconClick);
                this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            }
        },
        _bindIconClick: function () {
            var count = $._data($(this._buttonElement)[0], "events");
            if (ej.isNullOrUndefined(count) || ej.isNullOrUndefined(count.mousedown)) this._on(this._buttonElement, "mousedown", this._iconClick);
            else if (count.mousedown.length == 0) this._on(this._buttonElement, "mousedown", this._iconClick);
        },
        _unBindIconClick: function () {
            this._off(this._buttonElement, "mousedown", this._iconClick);
        },
        _setPopupPosition: function () {
            var elementObj = this.element.is('input') ? this.wrapper : this.element;
            var pos = this._getOffset(elementObj), winWidth,
            winBottomHeight = $(document).scrollTop() + $(window).height() - (pos.top + $(elementObj).outerHeight()),
            winTopHeight = pos.top - $(document).scrollTop(),
            popupHeight = this.popupContainer.outerHeight(),
            popupWidth = this.popupContainer.outerWidth(),
            left = pos.left,
            totalHeight = elementObj.outerHeight(),
            border = (totalHeight - elementObj.height()) / 2,
            maxZ = this._getZindexPartial(), popupmargin = 3,
            topPos = ((popupHeight < winBottomHeight || popupHeight > winTopHeight) ? pos.top + totalHeight + popupmargin : pos.top - popupHeight - popupmargin) - border;
            winWidth = $(document).scrollLeft() + $(window).width() - left;
            if (popupWidth > winWidth && (popupWidth < left + elementObj.outerWidth())) left -= this.popupContainer.outerWidth() - elementObj.outerWidth();
            if (popupWidth + elementObj.offset().left > $(window).width()) left = Math.abs(popupWidth - ($(window).width()));
            this.popupContainer.css({
                "left": left + "px",
                'position': 'absolute',
                "top": topPos + "px",
                "z-index": maxZ
            });
        },

        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },

        _getZindexPartial: function () {
            return ej.util.getZindexPartial(this.element, this.popupContainer);
        },

        _setValue: function (value, isCode) {
            var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$";
            if (typeof value == "object" || (typeof value == "number") || ej.isNullOrUndefined(value.match(reg))) value = null;
            this.value(value);
            this._tempValue = value;
            ej.isNullOrUndefined(value) ? this._setEmptyValue() : this._renderModelValue(value);
            this._changeEvent(false, isCode);
            this._selectEvent();
            this.element.is("input") && this._updateValue();
        },
        _renderModelValue: function (value) {
            var color;
            if (value && typeof value === "string") {
                color = this._HexToHSV(value);
                this._oldValue = this.rgb;
                if (this._switch) {
                    this._valueOperation();
                    this._colorSlider.option('value', parseInt(this._hsv.h));
                }
                this._inputTagValue(this._selectedButton);
                if (!this._switch) {
                    this._updateUI();
                    this.element.val(this.value());
                }
                this._hueGradient();
            }
        },
        setValue: function (code) {
            this._setValue(code);
        },

        enable: function () {
            if (this.model.enabled) return false;
            if (this.wrapper && this.wrapper.hasClass("e-disable")) {
                this.wrapper.removeClass("e-disable");
                this.element.prop("disabled", false);
                if (this.container.hasClass("e-disable")) this.container.removeClass('e-disable');
                this.popupList.removeClass('e-disable');
                this.dropdownbutton.removeClass('e-disable');
            } else if (this.model.displayInline) this.element.removeClass('e-disable');
            var temp = this._switch;
            this._switch = true;
            this._cancelObj.enable();
            this._colorSlider.enable();
            this.model.enableOpacity ? this._opacity.enable() : this._opacity.disable();
            this._splitObj.enable();
            this._applyObj.enable();
            this._wireEvents();
            this._switchEvents();
            this._switch = temp;
            $(this._inputTag).prop('readonly', false);
            (this._buttonElement) && this._on(this._buttonElement, "mousedown", this._iconClick);
            this.model.enabled = true;
        },

        disable: function () {
            if (!this.model.enabled) return false;
            if (this.wrapper && !this.wrapper.hasClass("e-disable")) {
                this.wrapper.addClass("e-disable");
                this.element.attr("disabled", "disabled");
                if (!this.container.hasClass("e-disable")) this.container.addClass('e-disable');
                this.popupList.addClass('e-disable');
                this.dropdownbutton.addClass('e-disable');
            } else if (this.model.displayInline) this.element.addClass('e-disable');
            var temp = this._switch;
            this._switch = false;
            this._cancelObj.disable();
            this._colorSlider.disable();
            this._opacity.disable();
            this._splitObj.disable();
            this._applyObj.disable();
            this._unWireEvents();
            this._unSwitchEvents();
            this._switch = temp;
            this._unBindIconClick();
            $(this._inputTag).attr('readonly', 'readonly');
            if (this.isPopupOpen && !this.model.displayInline) this.hide();
            this.model.enabled = false;
        },

        getColor: function () {
            return this.rgb;
        },

        getValue: function () {
            return this.value();
        },
        _alphaGradient: function (value) {
            var browser = ej.browserInfo();
            var value = ej.isNullOrUndefined(value) ? "#000000" : value;
            if (browser.name == "mozilla")
                this._alphaSlider.attr({ "style": "background:-moz-linear-gradient(center top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if ((browser.name == "msie") || (browser.name == "edge"))
                this._alphaSlider.attr({ "style": "background:-ms-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "opera" && browser.version <= "11.61")
                this._alphaSlider.attr({ "style": "background:-o-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            else if (browser.name == "chrome" || browser.name == "safari" || (browser.name == "opera"))
                this._alphaSlider.attr({ "style": "background:-webkit-linear-gradient(top," + value + ",#fff) repeat scroll 0 0 rgba(0, 0, 0, 0);" });
            if ((browser.name == "msie") && (browser.version == "8.0" || browser.version == "9.0"))
                this._alphaSlider.attr({ "style": "progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr=" + value + ", endColorstr=#ffffff)"});            
            if (browser.name == "msie" && browser.version == "8.0")
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
        },
        _hueGradient: function () {
            var temp = this._hsv;
            var value = { h: this._hsv.h, s: 100, v: 100 };
            this._hueSlider.children(".e-handle").css({ "background": this._formRGB(this.HSVToRGB(value)) });
            this._hsv = temp;
        },
        _updateColor: function () {
            if (this.model.displayInline || !this.model.showApplyCancel) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeEvent: function (element, isCode) {
            if (this._change && this._previousValue !== this._tempValue) {
                this._alphaGradient(this._tempValue);
                this._previousValue = this._tempValue;
                this._trigger("change", { value: this._tempValue, changeFrom: element ? "slider" : "picker", isInteraction: !isCode });
                this._updateColor(element);
            }
        },
        _selectEvent: function () {
            if (this._previousColor !== this._tempValue || this._tempOpacity !== this.opacityValue()) {
                this.value(this._tempValue);
                if (this.element.is("input")) this._updateValue();
                this.element.val(this.value());
                this._trigger("select", { value: this.value() });
                this._previousColor = this._tempValue;
            }
        },
        _changeHue: function (e) {
            this._handleArea.css("visibility", "visible");
            if (parseInt(this._hsv.h) !== parseInt(e.value) && this._switch) {
                this._hsv.h = Math.round(e.value);
                this._hueGradient();
                this._hsvValue();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(true);
            }
        },
        _changeAlpha: function (e) {
            this._handleArea.css("visibility", "visible");
            if (this._switch) {
                this.rgb.a = e.value / 100;
                this._tempOpacity = parseInt(this.rgb.a * 100);
                this._changeOpacity(e);
            }
        },
        _changeOpacity: function (e) {
            this.rgb.a = this._tempOpacity / 100;
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._handleTag.css({ "background": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css("background-color", this._formRGBA(this.rgb));
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._inputTagValue(this._selectedButton);
            if (this.model.displayInline) {
                this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction : false });
                (this._trigger("select", { value: this.value() }));
            }
        else this._trigger("change", { value: this._tempValue, changeFrom: "slider", isInteraction: !ej.isNullOrUndefined(e) ? e.isInteraction: false });
        },
        _updateValue: function () {
            if (this.value()) {
                if (this._browser.name = "msie" && this._browser.version == "8.0") this.spanElement.css({ "background-color": this._formRGB(this._HexToRGB(this.value())), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                else this.spanElement.css({ "background-color": this._formRGBA(this._HexToRGB(this.value())) });
            }
            else this.spanElement.removeAttr('style');
        },
        _bindClickOperation: function (e) {
            var proxy = this, splitMenu;
            proxy._on($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            var SplitMenu = $("#" + proxy._presetContainer.attr('id')).ejMenu("instance");
                SplitMenu.model.close = function () {
                proxy._splitObj.contstatus = false;
                proxy._off($("#" + this._id + "_Presets").find("li.e-preset-row"), "mousedown", proxy._colorPresetsClick);
            }
        },
        _wireEvents: function () {
            if (this.element.is('input')) {
                this._on(this.wrapper, "blur", this._targetBlur);
                this._on(this.wrapper, "focus", this._targetFocus);
                this._on(this.wrapper, "keydown", this._popupShown);
                this._on(this.colorContainer, "click", this._containerClick);
            }
            this._on(this._changeTag, "click", this._switchModel);
            this._on(this._groupTag, "click", this._groupButton);
            this._on(this._addTag, "click", this._addColor);
            this._on(this._codeEditor, "mouseenter", this._inputEvent);
            this._on(this._codeEditor, "mouseleave", this._inputEvent);
            this._on(this._inputTag, "blur", this._inputEvent);
            this._on(this._inputTag, "focus", this._inputEvent);
            this._on(this._inputTag, "keyup", this._inputEvent);
            this._on(this.popupContainer, "focus", this._targetFocus);
            this._on(this.popupContainer, "blur", this._targetBlur);
        },
        _unWireEvents: function () {
            if (!this.model.displayInline && this.element.is('input')) {
                this._off(this.wrapper, "blur", this._targetBlur);
                this._off(this.wrapper, "focus", this._targetFocus);
                this._off(this.wrapper, "keydown", this._popupShown);
                this._off(this.colorContainer, "click", this._containerClick);
            }
            this._off(this._changeTag, "click", this._switchModel);
            this._off(this._groupTag, "click", this._groupButton);
            this._off(this._addTag, "click", this._addColor);
            this._off(this._codeEditor, "mouseenter", this._inputEvent);
            this._off(this._codeEditor, "mouseleave", this._inputEvent);
            this._off(this._inputTag, "blur", this._inputEvent);
            this._off(this._inputTag, "focus", this._inputEvent);
            this._off(this._inputTag, "keyup", this._inputEvent);
            this._off(this.popupContainer, "focus", this._targetFocus);
            this._off(this.popupContainer, "blur", this._targetBlur);
        },
        _inputEvent: function (e) {
            if (e.type === "focus") {
                if (e.target.className.indexOf("e-color-code") > -1) {
                    this._codeEditor.addClass("e-focus");
                }
            }
            if (e.type === "blur") {
                if (e.target.className.indexOf("e-color-code") > -1) {
                    this._codeEditor.removeClass("e-focus");
                }
            }
            if (!this._clearIcon) return;
            if (e.type === "focus") this._off(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "blur") this._on(this._codeEditor, "mouseleave", this._inputEvent);
            if (e.type === "keyup") this._inputTag.val() !== "" ? (this._clearIcon.show(), this._handleArea.css("visibility", "visible")) : (this._clearIcon.hide(), this._handleArea.css("visibility", "hidden"));
            if (e.type === "mouseleave" || e.type === "blur" || this._inputTag.val() == "") this._clearIcon.hide();
            else this._clearIcon.show();
        },
        _clearColor: function (e) {
            this._tempValue = "";
            this._inputTag.val("");
            this._setEmptyValue();
            if (e.type == "click") {
                this._clearIcon.hide();
                this._inputTag.focus();
            }
        },
        _containerClick: function () {
            if (this.model.buttonMode == "split") this._trigger("select", { value: this.value() });
        },
        _popupShown: function (e) {
            if (e.keyCode == 13) {
                this._showHidePopup();
                if (!this.isPopupOpen)
                    this._buttonClick(e);
                return false;
            }
        },
        _recentColor: function (e) {
            this._divTag.find('.e-select').removeClass('e-select').addClass('e-block');
            var hexCode = e.target.attributes.getNamedItem("data-value"), value;
            var rgbCode = e.target.attributes.style;
            if (ej.isNullOrUndefined(hexCode) || ej.isNullOrUndefined(rgbCode)) { this._change = false; return false; }
            $(e.target.parentNode).addClass('e-select').removeClass('e-block');
            var alpha = rgbCode.value.replace(/^(background-color:rgb|background-color:rgba)\(/, '').replace(/\)$/, '').replace(/\s/g, '').split(',');
            if (!ej.isNullOrUndefined(alpha[3])) {
                this._opacity.option('value', parseInt((parseFloat(alpha[3]) * 100).toFixed(2)));
                this.rgb.a = parseFloat(parseFloat(alpha[3]).toFixed(2));
            }
            else if (this._browser.name = "msie" && this._browser.version == "8.0") {
                value = parseInt(rgbCode.nodeValue.replace(/^(FILTER: alpha)\(/, '').split('=')[1].split(')')[0]);
                this._opacity.option('value', value);
                this.rgb.a = value / 100;
            }
            else {
                this._opacity.option('value', 100);
                this.rgb.a = 1;
            }
            this._HexToHSV(hexCode.value);
            this._inputTagValue(this._selectedButton);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._valueOperation();
            this._colorSlider.option('value', parseInt(this._hsv.h));
            this._hueGradient();
            this._changeEvent(false);
            if (!this.model.displayInline || this.element.is("input"))
                this.wrapper.focus();
        },

        _handleClick: function (e) {
            e.preventDefault();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            if (this.model.displayInline)
                this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            this.mouseDownPos = this._handlePos;
            $(document).on("mousemove touchmove", $.proxy(this._handleMovement, this));
            $(document).on("mouseup touchend", $.proxy(this._handleUp, this));
        },
        _handleMove: function (e) {
            this._handleArea.css("visibility", "visible");
            this._handleMovement(e);
            this._focusWrapper(e);
        },
        _handleMovement: function (e) {
            if (!this.model.enabled) return false;
            var clientX = e.pageX, clientY = e.pageY;
            this.element.is("input") && this.wrapper.focus();
            if (e.type == "touchstart" || e.type == "touchmove") {
                clientX = e.originalEvent.changedTouches[0].pageX;
                clientY = e.originalEvent.changedTouches[0].pageY;
            }
            this._hsv.v = parseInt(100 * (this._gradientArea.height() - Math.max(0, Math.min(this._gradientArea.height(), (clientY - this._gradientArea.offset().top)))) / this._gradientArea.height(), 10);
            this._hsv.s = parseInt(100 * (Math.max(0, Math.min(this._gradientArea.width(), (clientX - this._gradientArea.offset().left)))) / this._gradientArea.width(), 10);
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._change = true;
            this._changeEvent(false);
        },
        _handleUp: function (e) {
            $(document).off('mouseup touchend', this._handleUp);
            $(document).off('mousemove touchmove', this._handleMovement);
            this._focusWrapper(e);
            return false;
        },
        _handlePosition: function () {
            this._handlePos = this._handleArea ? {
                left: parseInt(parseInt(this._width) * this._hsv.s / 100, 10) + "px",
                top: parseInt(parseInt(this._height) * (100 - this._hsv.v) / 100, 10) + "px"
            } : "";
            this._handleArea.css({ "left": this._handlePos.left, "top": this._handlePos.top });
        },
        _addColor: function () {
            var value, collection = this._divTag.find('> div');
            value = this._selectedButton.html() != "HSVA" ? this._inputTag.val() : this._formRGBA(this.HSVToRGB(this._hsv));
            if (value !== "" && this._change) {
                if (this.model.showRecentColors && collection.length <= 12) {
                    $($(collection)[collection.length - 2]).remove();
                    this._generateLi();
                }
            }
            if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
        },
        _buttonClick: function (e) {
            this._change = true;
            var value = this._inputTag.val(), collection = this._divTag.find('div');
            this._opacity.option('value', this._tempOpacity);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._updatePreviewColor();
            if (this._inputTag.val() === "") {
                this._tempValue = "";
                if (this.model.showClearButton) this._setValue("");
                else {
                    this._inputTag.addClass('e-error');
                    return false;
                }
            }
            this._selectEvent();
            if (this.element.is("input")) {
                this._updateValue();
                this.wrapper.focus();
            }
            !this.model.displayInline && this.hide();
            this._tempOpacity !== this.opacityValue() && this.opacityValue(this._tempOpacity);
        },
        _generateLi: function () {
            this._liTag = ej.buildTag('div.e-colorblock e-block e-colorset').attr({ "data-value": this.RGBToHEX(this.rgb), "tabindex": "0" });
            var spanTag = ej.buildTag('div.e-color e-set').attr({ "data-value": this.RGBToHEX(this.rgb), "title": this.RGBToHEX(this.rgb) });
            if (this._browser.name = "msie" && this._browser.version == "8.0") spanTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else spanTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._liTag.append(spanTag);
            this._divTag.prepend(this._liTag);
        },
        _colorCodeValue: function (e) {
            var newValue = "", codeValue = this._inputTag.val(), value, code, count;
            value = $.trim(codeValue);
            value.length == 5 ? this._inputTag.removeClass('e-error') : "";
            if ((e.shiftKey && e.keyCode >= 35 && e.keyCode <= 40 || (e.keyCode >= 65 && e.keyCode < 71) ) || (e.keyCode == 51) || (e.ctrlKey && (e.keyCode == 88 || e.keyCode == 86)) || e.keyCode == 190)
                this._keyPressFlag = 1;
            else if ((!e.crtlKey && !e.shiftKey) && ((e.keyCode >= 65 && e.keyCode < 71) || (e.keyCode >= 35 && e.keyCode <= 40) || (e.keyCode >= 96 && e.keyCode <= 105) || (e.keyCode >= 48 && e.keyCode <= 57) || e.keyCode == 13 || e.keyCode == 8 || e.keyCode == 46 || e.type === "blur"))
                this._keyPressFlag = 1;
            else this._keyPressFlag = 0;
            if (this.model.enableOpacity && (e.keyCode == 188 || e.keyCode == 71 || e.keyCode == 72 || e.keyCode == 82 || e.keyCode == 83 || e.keyCode == 86) || (e.shiftKey && (e.keyCode == 57 || e.keyCode == 48)))
                this._keyPressFlag = 1;
            if (this._keyPressFlag == 1) {
                this._inputTag.removeClass('e-error');
                if (e.keyCode === 13 || e.type === "blur") {
                    if (value === "") {
                        if (this.model.showClearButton) this._setEmptyValue();
                        else this._inputTag.addClass('e-error');
                    }
                    var regex = /^\#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/;
                    code = value.match(regex);
                    if (!ej.isNullOrUndefined(code)) {
                        if (code[1].length === 3) {
                            for (count = 0; count < code[1].length; count++) {
                                newValue += code[1][count] + code[1][count];
                            }
                        }
                        else if (code[1].length === 6)
                            newValue = code[1];
                        value = this.hexCodeToRGB("#" + newValue);
                        this._inputTag.val("#" + newValue);
                        this.rgb = this.HSVToRGB(this.RGBToHSV(value));
                        this._tempValue = this.RGBToHEX(this.rgb);
                        this._change = true;
                    }
                    else {
                        var rgbRegex = /^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                        code = value.match(rgbRegex);
                        if (!ej.isNullOrUndefined(code)) this._rgbaColor(code);
                        else {
                            var hsvRegex = /^hsva?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+(?:\.\d+)?))?\)$/;
                            code = value.match(hsvRegex);
                            if (!ej.isNullOrUndefined(code)) {
                                this._hsvColor(code);
                            }
                            else {
                                value != "" && this._inputTag.addClass('e-error');
                                this._change = false;
                                return false;
                            }
                        }
                    }
                    if (this._change) {
                        this._valueOperation();
                        this._colorSlider.option('value', parseInt(this._hsv.h));
                        this._hueGradient();
                        this._changeEvent(false);
                        !this.element.is('input') && this._selectEvent();
                        if (this._inputTag.val() !== "") this._inputTag.removeClass("e-error");
                    }
                }
            }
            else {
                if (e.keyCode != 9) e.preventDefault();
                if (!e.shiftKey && !e.ctrlKey && e.keyCode !== 27 && e.keyCode !=20) this._inputTag.addClass('e-error');
            }
        },
        _setEmptyValue: function () {
            this._handleArea.css("visibility", "hidden");
            this._currentTag.css({ "background-color": "" });
            this._removeClass();
            this._tempValue = null;
            this._inputTag.val(null);
            if (this._previousValue !== this._tempValue) {
                this._trigger("change", { value: null });
                this._previousValue = this._tempValue
            }
        },
        _rgbaColor: function (code) {
            var rgb = {}, color;
            if (code[0].split('(')[0] == "rgba" && !ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = code[4];
            }
            else if (code[0].split('(')[0] == "rgb" && ej.isNullOrUndefined(code[4])) {
                rgb.r = code[1]; rgb.g = code[2]; rgb.b = code[3]; rgb.a = this.rgb.a;
                this._inputTag.val("rgba(" + rgb.r + "," + rgb.g + "," + rgb.b + "," + rgb.a + ")");
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(rgb.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this._tempValue = this.RGBToHEX(rgb);
            this._HexToHSV(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _hsvColor: function (code) {
            var hsv = {};
            if (!ej.isNullOrUndefined(code[4])) {
                hsv.h = code[1]; hsv.s = code[2]; hsv.v = code[3]; hsv.a = code[4];
            }
            else {
                this._inputTag.addClass('e-error');
                this._change = false;
                return false;
            }
            this.rgb.a = parseFloat(hsv.a);
            this._tempOpacity = this.rgb.a * 100;
            this._opacity.option('value', this._tempOpacity);
            this.opacityValue(this._tempOpacity);
            this.rgb = this.HSVToRGB(hsv);
            this._tempValue = this.RGBToHEX(this.rgb);
            this._inputTag.removeClass("e-error");
            this._change = true;
        },
        _iconClick: function (e) {
            e.preventDefault();
            this._showHidePopup();
            this.wrapper.focus();
        },
        _showHidePopup: function () {
            if (this.model.displayInline) return false;
            if (!this.isPopupOpen) this.show();
            else {
                this.hide();
                this.wrapper.focus();
            }
        },

        hide: function () {
            var proxy = this;
            if (!this.isPopupOpen||this.model.displayInline) return false;
            this.isPopupOpen = this._dataBind = false;
            if (this.element.is('input')) {
                this.wrapper.focus();
                this.wrapper.removeClass("e-active");
            }
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
            this.popupContainer.slideUp(200, function () {
                if (proxy.model) {
                    proxy._tempOpacity = proxy.opacityValue();
                    proxy.rgb.a = proxy._tempOpacity / 100;
                    proxy._tempValue = proxy.value();
                    proxy._renderModelValue(proxy.value());
                    proxy._opacity.option('value', parseInt(proxy.opacityValue()));
                    if (!proxy.model.displayInline)
                        proxy._off($(document), "mousedown", proxy._onDocumentClick);
                    proxy._trigger("close");
                }
            });
            if (!this.model.displayInline)
                this._off($(document), "mousedown", this._onDocumentClick);
            this._off(this._inputTag, "keydown", this._colorCodeValue);
            this._off(this._inputTag, "blur", this._colorCodeValue);
            this._modelType == "palette" ? this._off($(document), "keydown", this._keyDown) : this._off($(document), "keydown", this._onKeyDown);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            $(window).off("resize", $.proxy(this._OnWindowResize, this));
        },
        _hidePopup: function () {
            !this.model.displayInline && this.hide();
        },

        show: function () {
            if (this.element.is("input")) {
                this.wrapper.focus();
                this.wrapper.addClass("e-active");
            }
            if (this.isPopupOpen || !this.model.enabled) return false;
            this.isPopupOpen = true;
            if (this.model.modelType == "palette") this._cellSelect();
            if (!this.model.displayInline && (this.value() === "" || ej.isNullOrUndefined(this.value())))
                this._setEmptyValue();
            else
                this._handleArea.css("visibility", "visible");
            this._previousColor = this._previousValue = this.value();
            this.popupContainer.children().find('.e-focus').removeClass('e-focus');
            if (!this.model.displayInline) this._setPopupPosition();
            var proxy = this;
            this.popupContainer.slideDown(200, function () {
                proxy.isFocused = true;
                proxy._on($(document), "mousedown", proxy._onDocumentClick);
                proxy._trigger("open");
            });
            if (!this._dataBind)
                this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
            this._on(this._inputTag, "keydown", this._colorCodeValue);
            this._on(this._inputTag, "blur", this._colorCodeValue);
            this._dataBind = true;
            $(window).on("resize", $.proxy(this._OnWindowResize, this));
            if (!this.model.displayInline) this._on(ej.getScrollableParents(this.wrapper), "scroll", this.hide);
            if (this._prevSize !== $(window).width()) this.refresh();
        },
        _showBindEvents: function () {
            this._modelType == "palette" ? this._on($(document), "keydown", this._keyDown) : this._on($(document), "keydown", this._onKeyDown);
        },
        _hideUnBindEvents: function () {
            this._modelType == "palette" ? this._off($(document), "keydown", this._onKeyDown) : this._off($(document), "keydown", this._keyDown);
        },
        _switchEvents: function () {
            if (this._switch) {
                this._on(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._on(this._handleArea, "mousedown touchstart", this._handleClick);
                this._on(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._on(this._collection, "mousedown", this._onSelect);
        },
        _unSwitchEvents: function () {
            if (!this._switch) {
                this._off(this._gradientArea, "mousedown touchstart", this._handleMove);
                this._off(this._handleArea, "mousedown touchstart", this._handleClick);
                this._off(this._gradientArea, "mousedown touchstart", this._handleClick);
            }
            else this._off(this._collection, "mousedown", this._onSelect);
        },
        _groupButton: function (e) {
            if ($(e.target).hasClass('e-disable')) return false;
            if ($(e.target).hasClass("e-button")) {
                var element = this._groupTag.find('.e-btn.e-select');
                if (this._inputTag.val() !== "") this._inputTagValue($(e.target));
                else this._selectedButton = $(e.target);
                this._selectedButton.html() !== "HEX" ? this._inputTag.attr('maxLength', '22') : this._inputTag.attr('maxLength', '7');
                this._groupTag.find('.e-click').removeClass('e-click');
                $(e.target).addClass('e-click');
                this._inputTag.removeClass('e-error');
            }
        },
        _inputTagValue: function (type) {
            if (type.html() == "RGBA") this._inputTag.val(this._formRGBA(this.rgb));
            else if (type.html() == "HEX") this._inputTag.val(this.RGBToHEX(this.rgb));
            else if (type.html() == "HSVA") {
                if (this._modelType != "palette")
                    this._inputTag.val("hsva(" + Math.round(this._hsv.h) + "," + Math.round(this._hsv.s) + "," + Math.round(this._hsv.v) + "," + this.rgb.a + ")");
            }
            this._selectedButton = type;
        },
        _bindRecentEvent: function () {
            this._on(this._divTag, "click", this._recentColor);
        },
        _unBindRecentEvent: function () {
            this._off(this._divTag, "click", this._recentColor);
        },
        _handlePlacement: function (prop, value, bool) {
            this._handleArea.css("visibility", "visible");
            var hsv = this._hsv;
            hsv[prop] += value * (bool ? 1 : 3);
            if (hsv[prop] < 0) { hsv[prop] = 0; }
            prop === "s" ? this._hsv.s = hsv[prop] : this._hsv.v = hsv[prop];
            this._hsvValue();
            this._tempValue = this.RGBToHEX(this.rgb);
            this._changeEvent(false);
        },
        _onKeyDown: function (e) {
            var key = e.keyCode;
            if (!this.model.enabled) return;
            if (e.shiftKey && key == 9) if ($(this._hueSlider).find('.e-handle').hasClass('e-focus')) this._focusWrapper(e);
            if (!this._isFocused) if (key == 9 && key !== 27) return;
            this._change = true;
            if ((!e.altKey && !e.shiftKey)) {
                switch (key) {
                    case 39:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", 1, e.ctrlKey);
                        }
                        break;
                    case 38:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", 1, e.ctrlKey);
                        }
                        break;
                    case 37:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("s", -1, e.ctrlKey);
                        }
                        break;
                    case 40:
                        if (this.element.is('input') && $(e.target).is(this.wrapper)) {
                            e.preventDefault();
                            this._handlePlacement("v", -1, e.ctrlKey);
                        }
                        break;
                    case 13:
                        e.preventDefault();
                        if ($(e.target).hasClass('e-switcher')) {
                            this._switchModel();
                            $(e.target).focus();
                        }
                        else if ($(e.target).hasClass('e-applyButton')) this._buttonClick(e);
                        break;
                    case 27:
                        e.preventDefault();
                        !this.model.displayInline && this.hide();
                        this._tempValue = this.value();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPopup(e);
                        break;
                }
            }
        },
        _focusPopup: function (e) {
            $(this._hueSlider).find('.e-handle').focus();
            e.preventDefault();
        },
        _focusWrapper: function (e) {
            this.element.is('input') && $(this.wrapper).focus();
            e.preventDefault();
        },
        _onDocumentClick: function (e) {
            if (!$(e.target).is(this.popupContainer) && !$(e.target).parents(".e-colorpicker").is(this.popupContainer) &&
              !$(e.target).is(this.wrapper) && !$(e.target).parents(".e-colorpickerwidget").is(this.wrapper) && !$(e.target).parents('.e-presetWrapper').is("#" + this._id + "_Presets")) {
                if (!this.model.displayInline) {
                    this.hide();
                    if (this.element.is('input')) this.wrapper.removeClass('e-focus');
                }
                this._isFocused = false;
            }
        },

        _OnWindowResize: function (e) {
            if (this.element.is('input')) this._setPopupPosition();
            this.refresh();
        },
        refresh: function () {
            var element = $(this._PresetTable.find('.e-item')[1]);
            var count = 10, paddingSize = 36; //paddingSize is fixed for  palette model cells
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "block", "visibility": "hidden" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "block", "visibility": "hidden" });
            }
            if (parseFloat(this._tag.outerHeight()) > element.outerHeight(true) || (($(this._tag).outerWidth() - ($(element).outerWidth(true) * count)) > element.outerWidth()) || $(this._tag).outerWidth() == 0) {
                var rowSize = parseFloat($(this._tag).outerWidth()) - paddingSize;
                var cellWidth = (rowSize / count) - (element.outerWidth() - element.width());
                this._PresetTable.find('.e-item').css('width', cellWidth);
                if (element.outerWidth(true) * count > this._tag.outerWidth()) this._PresetTable.find('.e-item').css('width', cellWidth - 1);
            }
            if (!this.isPopupOpen) {
                this.popupContainer.css({ "display": "none", "visibility": "visible" });
                this._modelType == "palette" && this.PaletteWrapper.css({ "visibility": "visible" });
            } else if (this._modelType == "picker") {
                this.PaletteWrapper.css({ "display": "none", "visibility": "visible" });
            }
            this._prevSize = $(window).width();
            this._width = this._gradientArea.width(); this._height = this._gradientArea.height();
        },

        _range: function (range, value) {
            if (value === "") return value = 0;
            else if (value > range) return range;
            else return value;
        },
        _hsvValue: function () {
            var colorCode, hsv;
            this._change = true;
            this._hsv.v = this._hsv.v >= 100 ? 100 : this._hsv.v;
            this._hsv.s = this._hsv.s >= 100 ? 100 : this._hsv.s;
            this.hsv = this._hsv;
            this.rgb = this.HSVToRGB(this.hsv);
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _formRGB: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgb(" + value.r + "," + value.g + "," + value.b + ")";
        },
        _formRGBA: function (value) {
            if (!ej.isNullOrUndefined(value)) return "rgba(" + value.r + "," + value.g + "," + value.b + "," + value.a + ")";
        },
        _rgbValue: function (e) {
            var rgbColor, colorCode, value;
            value = this._HexToRGB(this._tempValue);
            if (!ej.isNullOrUndefined(value)) {
                this.rgb = value;
                this._change = true;
                this.HSVToRGB(this.RGBToHSV(this.rgb));
                this._colorSlider.option('value', parseInt(this._hsv.h));
                this._opacity.option('value', this.rgb.a * 100);
            }
            this._valueOperation();
            this._inputTagValue(this._selectedButton);
        },
        _valueOperation: function () {
            this._handlePosition();
            this._alphaGradient(this._tempValue);
            this._inputTag.removeClass("e-error");
            this._updateUI();
        },
        _HexToHSV: function (hex) {
            return this.HSVToRGB(this.RGBToHSV(this._HexToRGB(hex)));
        },
        _HexToRGB: function (hex) {
            if (!ej.isNullOrUndefined(hex)) {
                var reg = "^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$", hex, validate = hex.match(reg);
                if (ej.isNullOrUndefined(validate)) { this._change = false; return false; }
                if (validate[1].length == 3)
                    hex = "#" + validate[1][0] + validate[1][0] + validate[1][1] + validate[1][1] + validate[1][2] + validate[1][2];
                this._change = true;
                hex = parseInt(((hex.indexOf('#') > -1) ? hex.substring(1) : hex), 16);
                var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
                return this.rgb = { r: hex >> 16, g: (hex & 0x00FF00) >> 8, b: (hex & 0x0000FF), a: value };
            }
        },

        RGBToHSV: function (rgb) {
            var hsv = { h: 0, s: 0, v: 0 };
            var min = Math.min(rgb.r, rgb.g, rgb.b);
            var max = Math.max(rgb.r, rgb.g, rgb.b);
            var differ = max - min;
            hsv.v = max;
            hsv.v *= 100 / 255;
            if (differ === 0) {
                this._hsv = hsv;
                return hsv;
            }
            hsv.s = max != 0 ? 255 * differ / max : 0;
            if (hsv.s != 0) {
                if (rgb.r == max) hsv.h = (rgb.g - rgb.b) / differ;
                else if (rgb.g == max) hsv.h = 2 + (rgb.b - rgb.r) / differ;
                else hsv.h = 4 + (rgb.r - rgb.g) / differ;
            } else hsv.h = -1;
            hsv.h *= 60;
            if (hsv.h < 0) hsv.h += 360;
            hsv.s *= 100 / 255;
            this._hsv = hsv;
            return hsv;
        },

        HSVToRGB: function (hsv) {
            var rgb = {};
            var h = Math.round(hsv.h);
            var s = Math.round(hsv.s * 255 / 100);
            var v = Math.round(hsv.v * 255 / 100);
            if (s == 0) {
                rgb.r = rgb.g = rgb.b = v;
            } else {
                var t1 = v;
                var t2 = (255 - s) * v / 255;
                var t3 = (t1 - t2) * (h % 60) / 60;
                if (h == 360) h = 0;
                if (h < 60) { rgb.r = t1; rgb.b = t2; rgb.g = t2 + t3 }
                else if (h < 120) { rgb.g = t1; rgb.b = t2; rgb.r = t1 - t3 }
                else if (h < 180) { rgb.g = t1; rgb.r = t2; rgb.b = t2 + t3 }
                else if (h < 240) { rgb.b = t1; rgb.r = t2; rgb.g = t1 - t3 }
                else if (h < 300) { rgb.b = t1; rgb.g = t2; rgb.r = t2 + t3 }
                else if (h < 360) { rgb.r = t1; rgb.g = t2; rgb.b = t1 - t3 }
                else { rgb.r = 0; rgb.g = 0; rgb.b = 0 }
            }
            this._hsv = hsv;
            var value = ej.isNullOrUndefined(this.rgb) ? parseFloat(this._tempOpacity) / 100 : this.rgb.a;
            return { r: Math.round(rgb.r), g: Math.round(rgb.g), b: Math.round(rgb.b), a: value }
        },
        _HSVToHex: function (hsv) {
            return this.RGBToHEX(this.HSVToRGB(hsv));
        },
        _toHEX: function (rgb) {
            if (rgb.indexOf("#") !== -1) return rgb;
            rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
            return "#" + this._hex(rgb[1]) + this._hex(rgb[2]) + this._hex(rgb[3]);
        },



        RGBToHEX: function (rgb) {
            if (!ej.isNullOrUndefined(rgb))
                return "#" + this._hex(rgb.r) + this._hex(rgb.g) + this._hex(rgb.b);
        },
        _hex: function (x) {
            return ("0" + parseInt(x).toString(16)).slice(-2);
        },
        _colorValue: function (value) {
            this._color = value.indexOf("#") != -1 ? this.hexCodeToRGB(value) : "";
            return "rgb(" + this._color.r + ", " + this._color.g + ", " + this._color.b + ")";
        },


        hexCodeToRGB: function (colorCode) {
            var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(colorCode);
            return result ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16),
                a: this.rgb.a
            } : null;
        },

        _updatePreviewColor: function () {
            if (this._browser.name = "msie" && this._browser.version == "8.0")
                this._previousTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            else
                this._previousTag.css({ "background-color": this._formRGBA(this.rgb) });
            this._oldValue = this.rgb;
        },
        _updateUI: function () {
            var value = this._hsv;
            if (this._switch) {
                var hsv = { h: this._hsv.h, s: 100, v: 100 };
                this._gradientArea.css({ "background-color": this._colorValue(this._HSVToHex(hsv)) });
            } else this._cellSelect();
            if (this._browser.name = "msie" && this._browser.version == "8.0") {
                this._currentTag.css({ "background-color": this._formRGB(this.rgb), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
                this._previousTag.css({ "background-color": this._formRGB(this._oldValue), "filter": "alpha(opacity=" + this.rgb.a * 100 + ")" });
            }
            else {
                this._currentTag.css({ "background-color": this._formRGBA(this.rgb) });
                this._previousTag.css({ "background-color": this._formRGBA(this._oldValue) });
                this._alphaSlider.children(".e-handle").css({ "background": this._formRGBA(this.rgb) });
            }
            this._hsv = value;
        },

        _targetFocus: function (e) {
            e.preventDefault();
            if (!this._isFocused) {
                this._isFocused = true;
                if (this.element.is("input")) this.wrapper.addClass("e-focus");
            }
        },
        _targetBlur: function (e) {
            this._isFocused = false;
            if (!this.isPopupOpen && this.element.is("input")) this.wrapper.removeClass("e-focus");
        },
        _switchModel: function () {
            this._tempValue = this.RGBToHEX(this.rgb);
            this.refresh();
            var proxy = this;
            this._off(this._changeTag, "click", this._switchModel);
            if (this._modelType == "palette") {
                this._modelType = "picker";
                this._switcher.removeClass("e-pickerModel").addClass("e-paletteModel");
                this.PaletteWrapper.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').addClass('e-hide');
                    proxy._gradient.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                this._switch = true;
                this._rgbValue();
                this._hueGradient();
                this._hsva.ejButton("enable");
            } else {
                this.PaletteWrapper.remove();
                this._modelType = "palette";
                this.PaletteWrapper = this._layoutType(this.model.palette);
                this._gradient.addClass('e-hide');
                this._paletteType();
                this._switcher.removeClass("e-paletteModel").addClass("e-pickerModel");
                this._gradient.fadeOut(300, function () {
                    proxy._presetTag.parents('.e-split.e-widget').removeClass('e-hide');
                    if (ej.isNullOrUndefined(proxy.PaletteWrapper)) {
                        proxy.PaletteWrapper = proxy._layoutType(proxy.model.palette);
                        proxy._splitObj.option('prefixIcon', 'e-color-image e-' + proxy.model.presetType);
                        proxy.popupList.prepend(proxy.PaletteWrapper);
                    }
                    proxy.PaletteWrapper.fadeIn(300);
                    proxy._on(proxy._changeTag, "click", proxy._switchModel);
                });
                if (this.value() !== "")
                    this._cellSelect();
                this._disableHSVButton();
            }
            this.model.palette === "custompalette" && this._presetTag.parents('.e-split.e-widget').addClass('e-hide');
            if (!this.model.displayInline || this.element.is(":input")) this.wrapper.focus();
            this._switchEvents();
            this._unSwitchEvents();
            if (this.isPopupOpen) {
                this._hideUnBindEvents();
                this._showBindEvents();
            }
        },
        _disableHSVButton: function () {
            if ($(this._groupTag.find('.e-click')).hasClass('e-hsvButton')) {
                this._inputTagValue(this._rgb);
                this._rgb.addClass('e-click');
                this._hsva.removeClass('e-click');
            }
            this._hsva.ejButton("disable");
        },

        _cellSelect: function () {
            var code, element, proxy = this;
            this._removeClass();
            this._collection.find('.e-item').each(function () {
                code = $(this).css("background-color");
                if (proxy._browser.name = "msie" && proxy._browser.version == "8.0") {
                    if (code && code.replace(/ /g, '') === proxy.RGBToHEX(proxy.rgb)) {
                        element = this;
                        $(element).addClass("e-filter");
                    }
                } else {
                    if (code && code.replace(/ /g, '') === proxy._formRGB(proxy.rgb)) element = this;
                }
            });
            $(element).addClass("e-state-selected").attr("aria-selected", true);
        },
        _removeClass: function () {
            this._collection.find('.e-item').removeClass('e-state-selected').removeClass("e-filter").removeAttr("aria-selected");
        },
        _position: function (items, element, columns) {
            items = Array.prototype.slice.call(items);
            var n = items.length,
            index = items.indexOf(element);
            if (index < 0) return columns < 0 ? items[n - 1] : items[0];
            index += columns;
            return items[index < 0 ? index += n : index %= n];
        },
        _onSelect: function (e) {
            if (!this.model.enabled) return false;
            this._isFocused = true;
            this._handleArea.css("visibility", "visible");
            if (e.target.style.backgroundColor != "") {
                this._collection.find('.e-item').removeClass("e-state-selected").removeAttr('aria-selected');
                this._HexToRGB(this._toHEX(e.target.style.backgroundColor));
                this._updateUI();
                this._inputTagValue(this._selectedButton);
                if (!this.model.displayInline || this.element.is("input")) this.wrapper.focus();
                this._tempValue = this.RGBToHEX(this.rgb);
                this._changeEvent(false);
            }
            e.preventDefault();
        },
        _keyDown: function (e) {
            if (this._isFocused) {
                this._change = true;
                if (!this.model.enabled) return false;
                var selected = "",
                    key = e.keyCode,
                    items = this._collection.find('.e-item'),
                    element = items.filter(".e-state-selected").get(0),
                    columnSize = this.model.columns;
                if (!e.altKey && (key == 37 || key == 38 || key == 39 || key == 40) && (e.target.className !== "e-color-code"))
                    this._removeClass();
                switch (!e.altKey && key) {
                    case 40:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, columnSize);
                        }
                        break;
                    case 37:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -1);
                        }
                        break;
                    case 38:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, -columnSize);
                        }
                        break;
                    case 39:
                        if (e.target.className !== "e-color-code") {
                            e.preventDefault();
                            selected = this._position(items, element, 1);
                        }
                        break;
                    case 13:
                        this._collection.find('.e-item').removeClass('e-state-selected').removeAttr("aria-selected");
                        if ($(e.target).hasClass('e-switcher')){
                            this._switchModel();
                            $(e.target).focus();
                        } 
                        else if ($(e.target).hasClass('e-applyButton')) {
                            this._buttonClick(e);
                            this._updateUI();
                            !this.model.displayInline && this.hide();
                            if (this.element.is("input")) this.wrapper.focus();
                        }
                        break;
                    case 27:
                        !this.model.displayInline && this.hide();
                        $(this._presetContainer).hide();
                        if (this.element.is("input")) this.wrapper.focus();
                        break;
                    case 9:
                        active = document.activeElement;
                        if ($(active).is(this.wrapper)) this._focusPalettePopup(e, true);
                        break;
                }
                if (selected) {
                    $(selected).addClass('e-state-selected').attr("aria-selected", true);
                    this._currentTag.css({ "background-color": this._formRGB(this._HexToRGB($(selected).attr("data-value")))});
                    this._inputTagValue(this._selectedButton);
                    this._tempValue = this.RGBToHEX(this.rgb);
                    this._changeEvent(false);
                }
            } else {
                if (e.keyCode == 27) {
                    this.hide();
                    $(this._presetContainer).hide();
                }
            }
        },
        _focusPalettePopup: function (e, type) {
            $(this.popupContainer).focus();
            e.preventDefault();
        },
    })

    ej.ColorPicker.Locale = ej.ColorPicker.Locale || {};

    ej.ColorPicker.Locale["default"] = ej.ColorPicker.Locale["en-US"] = {
        buttonText: {
                apply: "Apply",
                cancel: "Cancel",
                swatches: "Swatches"
            },

            tooltipText: {
                switcher: "Switcher",
                addButton: "Add Color",
                basic: "Basic",
                monoChrome: "Mono Chrome",
                flatColors: "Flat Colors",
                seaWolf: "Sea Wolf",
                webColors: "Web Colors",
                sandy: "Sandy",
                pinkShades: "Pink Shades",
                misty: "Misty",
                citrus: "Citrus",
                vintage: "Vintage",
                moonLight: "Moon Light",
                candyCrush: "Candy Crush",
                currentColor: "Current Color",
                selectedColor: "Selected Color",
            }
    }
    ej.ColorPicker.Palette = {
        /**  Represents the basic Palette. This is default Type*/
        BasicPalette: "basicpalette",
        /**  Represents the custom Palette. User will customize the palette*/
        CustomPalette: "custompalette",
    }

    ej.ColorPicker.ModelType = {
        /**  Represents Palette Type*/
        Palette: "palette",
        /** Represents Picker Type */
        Picker: "picker"
    }

    ej.ColorPicker.ButtonMode = {
        /**  Represents the default bahavior*/
        Default: "dropdown",
        /**  Represents the Split bahavior, to perform the separete operation for each button*/
        Split: "split",
    }

    ej.ColorPicker.PresetType = {
        Basic: "basic",
        MonoChrome: "monochrome",
        FlatColors: "flatcolors",
        SeaWolf: "seawolf",
        WebColors: "webcolors",
        Sandy: "sandy",
        PinkShades: "pinkshades",
        Misty: "misty",
        Citrus: "citrus",
        Vintage: "vintage",
        MoonLight: "moonlight",
        CandyCrush: "candycrush",
    }
    var Colors = {
        basic: ["ffffff", "facbcb", "fccb98", "faf39a", "fbf8cd", "a6d38b", "aadee8", "d1ecf2", "cdcae5", "eecde1", "cccbcb", "f16667", "f69668", "f8ee6b", "f7ec37", "89c987", "75cddd", "8bd3e1", "7f7fcc", "9494c8", "b3b2b3", "ec2024", "f7971d", "ffcb67", "f5ea14", "74bf44", "69c8c9", "46c7f4", "6666ad", "b76cab", "676767", "971b1e", "ca6828", "ca9732", "979937", "0d9948", "339898", "4857a6", "62449a", "973794", "000000", "2f1110", "973620", "663433", "343416", "183319", "023334", "22205f", "3b2f8d", "310e31"],
        monochrome: ["ffffff", "e3e3e3", "c6c6c6", "aaaaaa", "8e8e8e", "717171", "555555", "393939", "1c1c1c", "000000", "f9e6e7", "f4d0d2", "efbabc", "e9a4a7", "e48e92", "df787c", "da6267", "d44c52", "cf363c", "ca2027", "fff4ca", "ffeb9e", "fff0b4", "ffefb1", "ffe788", "ffe272", "ffd947", "ffd531", "ffd01b", "ffcc05", "e4f4eb", "ccead9", "b4e0c7", "9cd6b5", "84cca3", "6dc190", "55b77e", "3dad6c", "25a35a", "0d9948", "e8f4f4", "d6e3eb", "c4d1e3", "b3c0da", "a1aed1", "8f9dc9", "7d8bc0", "6c7ab7", "5a68af", "4857a6"],
        flatcolors: ["7477b8", "488bca", "18b1d4", "1db369", "78c162", "acc063", "ffe84e", "f6b757", "f79853", "ed6346", "E87F3D", "E4C45D", "B7A575", "999999", "67809F", "002228", "00A578", "F9A41F", "F3770B", "D7401B", "FFCB36", "82CC2C", "36B595", "6370AD", "D4264E", "004D8E", "22A04B", "F3A414", "C77405", "F3420B", "1ABC9C", "3498DB", "9B59B6", "E67E22", "E74C3C", "3A738A", "EBD9A7", "89AD78", "FF766D", "C76160", "BF3542", "CDC5BA", "EBE3D6", "3C3C3C", "2E2E2E", "77A7FB", "E57368", "FBCB43", "34B67A", "FFFFFF"],
        seawolf: ["0EEAFF", "15A9FA", "1B76FF", "1C3FFD", "2C1DFF", "0B3C4C", "0E5066", "13647F", "127899", "1A8BB2", "74B8E8", "659EBB", "3C9FFF", "26466F", "2472FF", "0069A4", "009BF2", "004165", "49A0B4", "274C5F", "000000", "7A5848", "E0A088", "F9DEC6", "3A2A22", "DC3522", "D9CB9E", "374140", "2A2C2B", "1E1E20", "CB3937", "FE6B2C", "654E44", "6DD16F", "70FE2C", "275673", "4681A6", "FDDEC9", "F22816", "400101", "071C2F", "388494", "E6A934", "F3DB5F", "534329", "206956", "47683B", "E1BFA6", "BF7950", "903932"],
        webcolors: ["0066aa", "00bbdd", "338800", "77bb00", "ffcc99", "990c0c", "0303c9", "336699", "669933", "cccccc", "EEEEEE", "E7C36F", "F7B230", "E35B20", "000033", "7D7A74", "BD524A", "FCB200", "8CFCC2", "2ACD6B", "666666", "666553", "FFFEEC", "B2B2A4", "AAA4B2", "9CA5E3", "5A668C", "BBA469", "CFC295", "FFFFFF", "DBBF56", "2E94B3", "808080", "E96656", "14A168", "DE185B", "D8806F", "DBE186", "D8CC63", "DCC527", "4E6C89", "E2BDAD", "EC6053", "81BBAD", "DFCDA5", "453394", "66398A", "313E7D", "336694", "788E91"],
        sandy: ["c0a986", "ecd9c3", "dfc79b", "f6d58e", "ecdaad", "fff3e0", "7f6b4a", "ffd694", "7f7a70", "ccac76", "E6E2AF", "A79A71", "EFECCA", "806F4C", "2F2F2E", "997F1A", "CCB65F", "FFD291", "6B674A", "635F3A", "7F693A", "FFEBC1", "FFD275", "7F7561", "CCA85E", "D29854", "4A4034", "C9AD8D", "4A351D", "968169", "E6E39F", "9A9757", "FFFDC9", "94909A", "E2E0E6", "960010", "EB1517", "CD7C29", "9A571C", "1F7A94", "7F6826", "7F724C", "FFE499", "FFD04C", "CCA63D", "FFA669", "92FFB6", "FFF352", "E8C269", "D7E8CB"],
        pinkshades: ["F6B1C3", "F0788C", "DE264C", "BC0D35", "A20D1E", "E12256", "BB1C48", "7B132F", "3B0917", "FA2660", "FFB7B5", "9A423F", "FF6D68", "BB5855", "CC5753", "E88161", "D66C60", "C2646E", "996072", "705262", "FFA1BD", "FF8FB7", "FF82AE", "E9719B", "CC6882", "F250C7", "BF1774", "BF2696", "AC60AA", "BB90C5", "BF1553", "F20775", "F2F2F2", "e5566d", "f2afc1", "f43fa5", "fc8c99", "FF6887", "7F3443", "CC536C", "D06AA9", "E65F41", "650017", "BC1620", "FA427E", "3B1132", "84476E", "B83D65", "E6E0E8", "FF6EE8"],
        misty: ["5C7A84", "3D5372", "7C9196", "50748A", "ADBFBF", "010735", "052159", "194073", "376B8C", "FFFFFF", "985999", "C811CC", "892EFF", "FF6852", "DBA211", "0A0D0C", "85A67C", "46593E", "BBD9AD", "202616", "BF8E63", "734327", "A66C4B", "593A2F", "BFBFBF", "8DB0B6", "1B778A", "F46C1B", "881801", "192129", "81808C", "ABAABF", "0C0E09", "6A7366", "37402F", "5D6663", "84867B", "A4A66A", "BABBB1", "20211C", "6B9695", "646E8C", "6B8196", "61787F", "648C80", "8E9FBA", "89A8C8", "799ED1", "7FAEE7", "849EBD"],
        citrus: ["FAEA41", "E7F03E", "E3C647", "FAC541", "F0AB3E", "CCCA1F", "FFF300", "FFCB0D", "FF9500", "804A00", "6A692A", "FFFCA0", "FFFFFF", "CF664E", "EFAC66", "EFF299", "F2DC6D", "F29727", "F2600C", "592202", "214001", "4F7302", "1A2601", "BCD97E", "C0D904", "AAFEFF", "359D6D", "E5FF45", "65FCCF", "ABDC4B", "42B200", "C6FF00", "F2E304", "FFB200", "FF8600", "52EC04", "04E206", "94D507", "ECE404", "E2C904", "DA321C", "FF7913", "FBD028", "C0D725", "9FC131", "547312", "ADBF26", "DEB329", "F1DB47", "E08214"],
        vintage: ["684132", "fdbe30", "eaac21", "87783c", "3e4028", "ffc706", "cd5648", "5bafa9", "828282", "363636", "424862", "fb9a63", "bfc4d5", "f6fbf4", "febc98", "657050", "FCF082", "D8D98B", "A2AB80", "4D584A", "5ADED4", "4DAAAB", "26596A", "163342", "6C98A1", "010A26", "28403B", "557359", "AEBF8A", "C7D9AD", "AFFCCB", "CB4243", "D2997E", "36857E", "4AC6BB", "28394B", "191313", "AF0A18", "DC373D", "122438", "43734A", "A6A26D", "D9B448", "BF8C2C", "734002", "26010F", "866F53", "ACBD91", "7BAB87", "546859"],
        moonlight: ["241D37", "2A233D", "322B45", "362F49", "D4BA73", "261225", "592040", "8C3063", "A64985", "73345D", "A3C8FF", "85B6FF", "000040", "213190", "050859", "FFFFFF", "6AAED9", "4184BF", "224573", "2e4154", "bcad7e", "955351", "c36a57", "9a8556", "7e6029", "dbd78e", "beae3b", "c3a04c", "58504d", "967644", "CFC496", "B3B391", "889486", "61797B", "366577", "123340", "436E73", "7B8C61", "D7D996", "F0EBB4", "341F36", "D9B5E0", "9889AB", "4D4E66", "1B2129", "5CBBE3", "FCF1BC", "5C8182", "383A47", "B4F257"],
        candycrush: ["0779f4", "30da00", "fb8006", "f9d802", "a71df7", "f70200", "fd49ae", "682e07", "9b2424", "5e7693", "F9AB3B", "EF5627", "FF0000", "00A398", "803C2C", "DE5711", "FFF026", "FF0048", "14A0CC", "00B229", "FFFFBE", "F7CD99", "FF77A1", "9886E8", "97CACB", "EAEDE5", "FFD127", "FF870C", "EC4610", "9A1900", "993460", "CC1464", "C300FF", "FFFFBC", "CCB914", "FFFEE2", "B24C5F", "FF274F", "0A94CC", "679DB2", "C2FFE6", "16B271", "5FFFBC", "B2442F", "FFA190", "E89359", "FFFB75", "F36EFF", "5999E8", "73EB86"],
    }

})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html div elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSlider", "ej.Slider", {

        element: null,

        model: null,
        validTags: ["div", "span"],
        _addToPersist: ["value", "values"],
        _rootCSS: "e-slider",
        _setFirst: false,
        _requiresID: true,

        defaults: {

            orientation: "horizontal",

            enableAnimation: true,

            animationSpeed: 500,

            showTooltip: true,

            cssClass: "",

            showRoundedCorner: false,

            readOnly: false,

            enableRTL: false,

            htmlAttributes: {},

            minValue: 0,

            maxValue: 100,

            sliderType: "default",

            value: null,

            values: null,

            incrementStep: 1,

            height: null,

            width: null,

            enabled: true,

            showScale: false,

            largeStep: 10,

            smallStep: 1,

            showSmallTicks: true,

            enablePersistence: false,
            
            allowMouseWheel:false,

            start: null,

            stop: null,

            slide: null,

            change: null,

            create: null,

            destroy: null,

            tooltipChange: null,

            renderingTicks: null
        },

        dataTypes: {
            orientation: "enum",
            enableAnimation: "boolean",
            animationSpeed: "number",
            cssClass: "string",
            showRoundedCorner: "boolean",
            readOnly: "boolean",
            enableRTL: "boolean",
            minValue: "number",
            maxValue: "number",
            sliderType: "enum",
            incrementStep: "number",
            enabled: "boolean",
            showScale: "boolean",
            largeStep: "number",
            smallStep: "number",
            showSmallTicks: "boolean",
            enablePersistence: "boolean",
            htmlAttributes: "data",
            allowMouseWheel:"boolean"
        },

        observables: ["value", "values"],
        value: ej.util.valueFunction("value"),
        values: ej.util.valueFunction("values"),

        enable: function () {
            if (!this.model.enabled) {
                this.model.enabled = true;
                if (this.wrapper) this.wrapper.removeClass("e-disable");
                this.element.removeClass("e-disable");
                this._wireEvents();
            }
        },

        disable: function () {
            if (this.model.enabled) {
                this.model.enabled = false;
                if (this.wrapper) this.wrapper.addClass("e-disable");
                this.element.addClass("e-disable");
                this._unWireEvents();
            }
        },

        _validateValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null || value === "") value = this.model.minValue;
            else if (typeof value === "string") value = parseFloat(value);

            if (this._isNumber(value)) {
                this._hidden.val(value);
                this.value(value);
            }
            else if (!this._isNumber(this.value())) {
                this._hidden.val(this.model.minValue);
                this.value(this.model.minValue);
            }
            if (this.model.sliderType != "range") this._setValue(animation);
        },

        _validateRangeValue: function (value, animation) {
            animation = (typeof animation === 'undefined') ? false : animation;
            if (value == null) value = new Array(this.model.minValue, this.model.maxValue);
            else if (typeof value === "string") {
                var vals = value.split(",");
                if (vals.length > 1) value = new Array(parseFloat(vals[0]), parseFloat(vals[1]));
            }

            if (typeof value === "object" && this._isNumber(value[0]) && this._isNumber(value[1])) {
                this._hidden.val(new Array(value[0], value[1]));
                this.values(new Array(value[0], value[1]));
            }
            else if (!(typeof this.values() === "object" && this._isNumber(this.values()[0]) && this._isNumber(this.values()[1]))) {
                this._hidden.val(new Array(this.model.minValue, this.model.maxValue));
                this.values(new Array(this.model.minValue, this.model.maxValue));
            }
            if (this.model.sliderType == "range") this._setRangeValue(animation);
        },

        _validateStartEnd: function () {
            if (isNaN(this.model.minValue)) this.model.minValue = 0;
            if (isNaN(this.model.maxValue)) this.model.maxValue = 100;
        },

        _isNumber: function (number) {
            return typeof number === "number" && !isNaN(number);
        },

        _outerCorner: function (boolean) {
            if (boolean) this._roundedCorner();
            else this._sharpedCorner();
        },

        _changeSkin: function (skin) {
            this.element.removeClass(this.model.cssClass).addClass(skin);
            if (this.model.showScale)
                this.ul.removeClass(this.model.cssClass).addClass(skin);
        },

        getValue: function () {

            return this._getHandleValue();
        },

        setValue: function (value, animation) {
            if (this.model.sliderType == "range")
                this._validateRangeValue(value, animation);
            else
                this._validateValue(value, animation);
        },

        _init: function () {
            this._isInteraction = true;
            this._initialize();
            this._render();
        },

        _setModel: function (options) {
            this._isInteraction = false;
            if (!ej.isNullOrUndefined(options["minValue"]) || !ej.isNullOrUndefined(options["maxValue"])) {
                if (this._isNumber(options["minValue"])) this.model.minValue = options["minValue"];
                else options["minValue"] = this.model.minValue;

                if (this._isNumber(options["maxValue"])) this.model.maxValue = options["maxValue"];
                else options["maxValue"] = this.model.maxValue;

                if (this.model.sliderType == "range" && options["values"] == undefined) this._setRangeValue();
                else if (this.model.sliderType != "range" && options["value"] == undefined) this._setValue();
            }

            var option;
            for (option in options) {
                switch (option) {
                    case "value":
                        this._validateValue(ej.util.getVal(options[option]));
                        options[option] = this.model.value;
                        break;
                    case "values":
                        var val= typeof options.values == "function" ? options.values() : options.values;
                        if (!ej.isNullOrUndefined(val) && !ej.isNullOrUndefined(val.length) && typeof val != "string")
                        {
                            if (!isNaN(val[0]) && !isNaN(val[1])) {
                                var actualValue = typeof this.values().join == "function" ? val.join() : val;
                                if (actualValue == this._hidden.val()) break;
                            }
                        }
                        this._validateRangeValue(ej.util.getVal(options[option]));
                        options[option] = this.model.values;
                        break;
                    case "height": this.model.height = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "width": this.model.width = options[option]; this._setDimension();
                        if (this.model.showScale) this._scaleAlignment();
                        break;
                    case "enabled": this._disabled(!options[option]); break;
                    case "showRoundedCorner": this._outerCorner(options[option]); break;
                    case "enableRTL": this.model.enableRTL = options[option]; this._checkRTL();
                        options[option] = this.model.enableRTL;
                        break;
                    case "cssClass": this._changeSkin(options[option]); break;
                    case "showScale": this._renderScale(options[option]); break;
                    case "orientation":
                        var t = this.model.height;
                        this.model.height = this.model.width;
                        this.model.width = t;
                    case "sliderType":
                        this._sliderOptions(option, options[option]); break;
                    case "smallStep":
                    case "largeStep":
                    case "showSmallTicks":
                    case "minValue":
                    case "maxValue":
                        this._scaleOptions(option, options[option]); break;
                    case "htmlAttributes": this._addAttr(options[option]); break;
                    case "tooltipChange":
                        this.model.tooltipChange = options[option]; break;
                    case "allowMouseWheel": this.model.allowMouseWheel = options[option]; break;
                    case "renderingTicks": this.model.renderingTicks = options[option]; break;
                }
            }
        },

        _destroy: function () {
            if (this.model.showScale) this._destroyScale();
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            this.element.removeClass("e-widget e-box " + this.model.cssClass).empty();
        },

        _initialize: function () {
            this.target = this.element[0];
            this.horDir = "left";
            this.verDir = "bottom";
            this._isFocused = false;
        },

        _render: function () {
            this.initialRender = true;
            this._isIE8 = (ej.browserInfo().name == 'msie' && ej.browserInfo().version == '8.0') ? true : false
            this.wrapper = ej.buildTag("div.e-slider-wrap e-widget" + this.model.cssClass + "#" + this.target.id + "_wrapper", { tabindex: "0", role: "slider" })
                .insertAfter(this.element);
            this.wrapper.append(this.element);

            this.element.addClass("e-widget e-box " + this.model.cssClass);
            if (this.model.sliderType != "default") {
                this.header = ej.buildTag("div.e-range");
                this.element.append(this.header);
                if (this.model.sliderType == "range") {
                    this.secondHandle = this._createHandle();
                }
            }
            this.firstHandle = this._createHandle();
            this._setOrientation();
            this._setDimension();
            this._insertHiddenField();
            this._checkProperties();
            this._addAttr(this.model.htmlAttributes);
            this._setSliderValue();
        },

        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._disabled(true);
                else proxy.element.attr(key, value)
            });
        },

        _renderScale: function (showScale) {
            if (showScale) {
                this.wrapper.addClass("e-scale-wrap");
                var width = "width", orien = "h", spanText;
                if (this.model.orientation == "vertical") {
                    width = "height";
                    orien = "v";
                }

                var _smallStep = this.model.smallStep;
                if (!this.model.showSmallTicks) {
                    if (this.model.largeStep > 0)
                        _smallStep = this.model.largeStep;
                    else
                        _smallStep = this.model.maxValue - this.model.minValue;
                }
                else if (_smallStep <= 0)
                    _smallStep = this.model.incrementStep;
                var count = Math.abs(this.model.maxValue - this.model.minValue) / _smallStep;

                this.ul = ej.buildTag("ul.e-scale e-" + orien + "-scale " + this.model.cssClass);
                if (this._isIE8) this.ul.addClass('e-ie8')
                this.wrapper.append(this.ul);

                var li, args, start = this.model.minValue, left = 0, tickWidth = 100 / count;
                if (orien == "v") start = this.model.maxValue;
                for (var i = 0; i <= count; i++) {
                    li = ej.buildTag("li.e-tick", "", {}, { "title": start });
                    var islargeTick = (start % this.model.largeStep == 0) ? true : false;
                    if (islargeTick) li.addClass("e-large");
                    li.css(width, tickWidth + "%");
                    if (this.model.renderingTicks) {
                        args = { value: start, valueType: "tooltip", tick: li[0]};
                        this._trigger("renderingTicks", args);
                        li.attr("title", args.value);
                    }
                    if (islargeTick) {
                        if (this.model.renderingTicks) {
                            args.valueType = "label";
                            args.value = start;
                            this._trigger("renderingTicks", args);
                            spanText = args.value;
                        }
                        else spanText = start;
                        var span = ej.buildTag("span.e-tick-value", "" + spanText);
                        li.append(span);
                    }
                    this.ul.append(li);

                    if (orien == "h") start += _smallStep;
                    else start -= _smallStep;
                    left += _smallStep;
                }

                this.ul.children().first().addClass("e-first-tick").css(width, (tickWidth / 2) + "%");
                this.ul.children().last().addClass("e-last-tick").css(width, (tickWidth / 2) + "%");

                this._scaleAlignment();
            }
            else this._destroyScale();
            this._setWrapperHeight();
        },
        _destroyScale: function () {
            this.wrapper.removeClass("e-scale-wrap");
            this.ul.remove();
            this.ul = null;
        },

        _tickValuePosition: function () {
            var width = (this.model.orientation == "vertical") ? "height" : "width";
            var left = (this.model.orientation == "vertical") ? "top" : "left";
            var firstTick = this.ul.find(".e-tick.e-first-tick");
            var first = firstTick.find(".e-tick-value");
            var other = this.ul.find(".e-tick.e-large:not(.e-first-tick)").find(".e-tick-value");
            var tickWidth = firstTick[width]() * 2;
            first.css(left, -first[width]() / 2);
            other.css(left, (tickWidth - other[width]()) / 2);
        },

        _scaleAlignment: function () {
            this._tickValuePosition();
            var smallTick = 12, largeTick = 20, half = largeTick / 2;
            var height = "height", top = "top", orien = "h";
            if (this.model.orientation == "vertical") {
                height = "width";
                top = "right";
                orien = "v";
                (this.element.width() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            }
            else
                (this.element.height() <= 15) ? this.wrapper.addClass("e-small-size") : this.wrapper.removeClass("e-small-size");
            // scale
            this.ul.css(top, -(this.wrapper[height]() + half));
            if (orien == "v") this.ul.css("top", -this.wrapper.height()).css(top, half);
            this.ul[height](this.wrapper[height]() + largeTick);
            // small-ticks
            var topSize = -(largeTick - smallTick) / 2;
            if (this.model.largeStep == null && orien != "v") topSize = -topSize;
            this.ul.find(".e-tick:not(.e-large)").css(height, this.wrapper[height]() + smallTick).css(top, topSize);
            // tick-values   // 4 - distance between tick value and tick
            if (orien == "v") this.ul.children(".e-large").find(".e-tick-value").css("right", this.wrapper.width() + largeTick + 4);
        },

        _setWrapperHeight : function(){
            var wrapHeight, wrapWidth;
            if (this.model.orientation == "horizontal") {
                if (this.ul)
                    wrapHeight = (this.firstHandle.outerHeight() > this.ul.height()) ? this.firstHandle.outerHeight() : this.ul.height();
                else wrapHeight = this.firstHandle.outerHeight();
                var top = (wrapHeight - this.element.outerHeight()) / 2;
                if (top < 0) top = 0;
                this.wrapper.css({ "padding": top + "px 0px" });
            }
            else {
                if (this.ul)
                    wrapWidth = (this.firstHandle.outerWidth() > this.ul.width()) ? this.firstHandle.outerWidth() : this.ul.width();
                else wrapWidth = this.firstHandle.outerWidth();
                var right = ( wrapWidth - this.element.outerWidth()) / 2;
                if (right < 0) right = 0;
                this.wrapper.css({ "padding": "0px " + right + "px" });
            }
        },


        _createHandle: function () {
			var handle = ej.buildTag("a.e-handle e-select", "", {}, { "aria-label": "drag", "tabindex": 0});
			this.element.attr({ role: "slider", "aria-valuemin": this.model.minValue, "aria-valuemax": this.model.maxValue});
            ej.browserInfo().name == "msie" && handle.addClass("e-pinch");
            this.element.append(handle);
            return handle;
        },

        _setDimension: function () {
            if (this.model.height) this.wrapper.height(this.model.height);
            if (this.model.width) this.wrapper.width(this.model.width);
            this._setHandleSize();
            this._handleAlignment(this.model.enableRTL);
        },

        _insertHiddenField: function () {
            this._hidden = ej.buildTag("input", "", {},
                { "type": "hidden", "name": this.element[0].id });
            this._hidden.val(this._getHandleValue());
            this.element.append(this._hidden);
        },

        _checkProperties: function () {
            if (!this.model.enabled) {
                if (this.wrapper) this.wrapper.addClass("e-disable");
                else this.element.addClass("e-disable");
            }
            else this._wireEvents();
            if (this.model.showScale) this._renderScale(true);
            else this._setWrapperHeight();
            if (this.model.enableRTL) this._checkRTL();
            if (this.model.showRoundedCorner) this._roundedCorner();
        },

        _roundedCorner: function () {
            this.element.addClass("e-corner");
        },

        _sharpedCorner: function () {
            this.element.removeClass("e-corner");
        },

        _handleAlignment: function (rtl) {
            var mar = -(this.firstHandle.outerWidth() / 2) + "px", margin;
            if (this.model.orientation != "vertical") {
                if (!rtl) margin = "0 0 0 " + mar;
                else margin = "0 " + mar + " 0 0";
            }
            else {
                if (!rtl) margin = "0 0 " + mar + " 0";
                else margin = mar + " 0 0 0";
            }
            this.element.children('.e-handle').css("margin", margin);
        },

        _checkRTL: function () {
            if (this.model.showScale && this.model.orientation == "vertical" && this.model.enableRTL) this.model.enableRTL = false;
            var rtl = this.model.enableRTL, preDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;
            if (rtl) {
                this.wrapper.addClass("e-rtl");
                this.horDir = "right";
                this.verDir = "top";
            }
            else {
                this.wrapper.removeClass("e-rtl");
                this.horDir = "left";
                this.verDir = "bottom";
            }
            var currDir = (this.model.orientation != "vertical") ? this.horDir : this.verDir;

            if (preDir != currDir) {
                this.firstHandle.css(currDir, this.firstHandle[0].style[preDir]).css(preDir, "auto");
                if (this.model.sliderType != "default") {
                    this.header.css(currDir, this.header[0].style[preDir]).css(preDir, "auto");
                    if (this.model.sliderType == "range")
                        this.secondHandle.css(currDir, this.secondHandle[0].style[preDir]).css(preDir, "auto");
                }
            }
            this._handleAlignment(rtl);
        },

        _setOrientation: function () {
            if (this.model.orientation != "vertical") {
                this.wrapper.addClass("e-horizontal");
            }
            else {
                this.wrapper.addClass("e-vertical");
                this.firstHandle.css(this.verDir, "0");
            }
        },

        _setHandleSize: function () {
            if ((this.model.height != null && this.model.orientation == "horizontal") || (this.model.width != null && this.model.orientation == "vertical") ) {
                var size;
                if (this.model.orientation != "vertical")
                    size = this.wrapper.height() + 2;
                else
                    size = this.wrapper.width() + 2;
                this.element.find(".e-handle").height(size).width(size);
            }
            else{
                this.wrapper.addClass("e-default-wrap");
                this.element.find(".e-handle").addClass("e-default");
            }
        },

        _disabled: function (boolean) {
            if (boolean) this.disable();
            else this.enable();
        },

        _sliderOptions: function (prop, value) {
            this._unWireEvents();
            this._destroy();
            this.model[prop] = value;
            this._init();
        },

        _scaleOptions: function (prop, value) {
            if (this.model.showScale) {
                this._destroyScale();
                this.model[prop] = value;
                this._renderScale(true);
            }
        },

        _showTooltip: function () {
            if (this.model.showTooltip) {
                this._timeOut && clearTimeout(this._timeOut);
                var _tooltip = this.tooltip ? $('body .e-tooltipbox').text().replace(/\s+/g, '').replace("-", ",") : "";
                if (this.tooltip && this.tooltip.length && this.tooltip.css("display") != "none" && this._getHandle()[0] == this._oldHandle && _tooltip == this.preValue) {
                    if (this._getHandleValue().toString() != this.preValue)
                        this._setTooltipPosition();
                    return;
                }
                this._oldHandle = this._getHandle()[0];
                $('body .e-tooltipbox').remove();
                this.tooltip = ej.buildTag("div.e-tooltipbox" + this.model.cssClass + " e-corner", { role: "tooltip" }).css(this._getOffset(this._getHandle()));
                $("body").append(this.tooltip);
                if (this.model.orientation == "vertical") {
                    this.tooltip.addClass("e-vertical");
                }
                this._setTooltipPosition();
            }
        },

        _hideTooltip: function () {
            if (this.model.showTooltip) {
                var proxy = this;
                this._timeOut = setTimeout(function () {
                    proxy.tooltip.fadeOut(800);
                }, 1500);
            }
                
        },

        _showhideTooltip: function (showTooltip) {
            if (this.model.showTooltip && showTooltip) {
                this._showTooltip();
                this._timeOut && clearTimeout(this._timeOut);
                this._hideTooltip();
            }
        },

        _setTooltipPosition: function () {
            if (this.model.showTooltip) {
                this._updateTooltipValue();
                var top, left, remainLeft, remainTop, handle, pos, gap = 5, broder, tooltipPos, border; // gap -> distance between tooltip and slider
                handle = this._getHandle(), pos = this._getOffset(handle), tooltipPos = this._getOffset(this.tooltip);
                border = $(handle).outerHeight() - $(handle).height();
                if (this.model.orientation == "vertical") {
                    remainTop = (this.tooltip.outerHeight() - handle.outerHeight()) / 2;
                    remainLeft = handle.outerWidth() + gap;
                    top = pos.top - remainTop;
                    left = pos.left + remainLeft;
					var height=$(window).height();
                    if (window.pageYOffset > 0) height+=window.pageYOffset; 
                    if (top < 0) top = 0;
                    else if (height < top + this.tooltip.outerHeight()) top = height - this.tooltip.outerHeight() - border;
                    if ($(window).width() < left + this.tooltip.outerWidth()) left = pos.left - this.tooltip.outerWidth() - border;
                }
                else {
                    if (tooltipPos.left + this.tooltip.outerWidth() > $(window).width()) this.tooltip.css({ "left": '0px' });
                    remainLeft = (this.tooltip.outerWidth() - handle.outerWidth()) / 2;
                    remainTop = this.tooltip.outerHeight() + gap;
                    top = pos.top - remainTop;
                    left = pos.left - remainLeft;
					var width=$(window).width();
                    if (window.pageXOffset > 0) width+=window.pageXOffset;    
                    if (left < 0) left = 0;
                    else if (width < left + this.tooltip.outerWidth()) left = width - this.tooltip.outerWidth() - border;
                    if (top < 0 || pos.top < remainTop) {
                        if (pos.top + handle.outerHeight() + border + this.tooltip.outerHeight() > $(window).height()) {
                            top = pos.top;
                            if (pos.left > this.tooltip.outerWidth() + gap + border) left = pos.left - (this.tooltip.outerWidth() + border);
                            else left = pos.left + (handle.outerWidth() + gap + border);
                        } else top = pos.top + handle.outerHeight() + border;
                    }
                }
                var zindex = this._maxZindex();
                this.tooltip.css({ "top": top, "left": left, "zIndex": zindex + 1 });
            }
        },
        _getOffset: function (ele) {
            return ej.util.getOffset(ele);
        },


        _maxZindex: function () {
            return ej.util.getZindexPartial(this.element, this.popup);
        },

        _updateTooltipValue: function () {
            var one = 0, two = 1, val;
            if (this.model.enableRTL) { one = 1, two = 0; }
            if (this.model.tooltipChange)
                val = this._raiseEvent("tooltipChange");
            else
                val = this._getHandleValue();
            if (this.model.sliderType != "range")
                this.tooltip[0].innerHTML = val;
            else
                this.tooltip[0].innerHTML = val[one] + " - " + val[two];
        },

        _increaseHeaderWidth: function (animation) {
            if (this.model.sliderType != "default") {
                var size = "width", direction = this.horDir, properties = {};
                if (this.model.orientation == "vertical") { size = "height", direction = this.verDir; }

                if (this.model.sliderType == "range") {
                    properties[size] = this.handlePos - this.handlePos2 + "%";
                    properties[direction] = this.handlePos2 + "%";
                }
                else {
                    properties[size] = this.handlePos + "%";
                    properties[direction] = 0;
                }
                if (!animation) this.header.css(properties);
                else this.header.animate(properties, this.model.animationSpeed);
            }
        },

        _setSliderValue: function () {
            this._validateStartEnd();

            if (this.model.sliderType == "range")
                this._validateRangeValue(this.values());
            else
                this._validateValue(this.value());
            this.preValue = this.getValue().toString();
        },


        _hoverOnHandle: function (evt) {
            $(evt.currentTarget).addClass("e-hover");
        },

        _leaveFromHandle: function (evt) {
            $(evt.currentTarget).removeClass("e-hover");
        },

        _firstHandleClick: function (evt) {
            evt.preventDefault();
            this.firstHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos = this.handlePos;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._on($(document),"mouseleave",this._firstHandleUp);
            this._showTooltip();
        },

        _firstHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position = { x: evt.pageX, y: evt.pageY };
            this.handlePos = this._xyToPosition(position);

            if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
            }
            if (this.handlePos != this.preHandlePos) {
                this.preHandlePos = this.handlePos;
                this.handleVal = this._positionToValue(this.handlePos);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _firstHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove, this._firstHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._firstHandleUp);
            this._off($(document), "mouseleave", this._firstHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos != this.handlePos) this._raiseChangeEvent();
        },

        _secondHandleClick: function (evt) {
            evt.preventDefault();
            this.secondHandle.focus().addClass("e-no-tab");
            if (this._raiseEvent("start")) return false;

            this.mouseDownPos2 = this.handlePos2;
            if (!this.model.readOnly)
            this._on($(document),ej.eventType.mouseMove, this._secondHandleMove);
            this._on($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._on($(document),"mouseleave",this._secondHandleUp);
            this._showTooltip();
        },

        _secondHandleMove: function (evt) {
            evt.preventDefault();
            evt = evt.type == "touchmove" ? evt.originalEvent.changedTouches[0] : evt;
            var position2 = { x: evt.pageX, y: evt.pageY };
            this.handlePos2 = this._xyToPosition(position2);

            if (this.handlePos2 > this.handlePos) {
                this.handlePos2 = this.handlePos;
            }
            if (this.handlePos2 != this.preHandlePos2) {
                this.preHandlePos2 = this.handlePos2;
                this.handleVal2 = this._positionToValue(this.handlePos2);
                this._increaseHeaderWidth(false);
                this._setHandlePosition(false, false, false);
                this._setTooltipPosition();

                this._updateModelValue();
                this._raiseEvent("slide");
            }
        },

        _secondHandleUp: function (evt) {
            evt.preventDefault();
            this._off($(document),ej.eventType.mouseMove,this._secondHandleMove);
            this._off($(document),ej.eventType.mouseUp,this._secondHandleUp);
            this._off($(document), "mouseleave", this._secondHandleUp);
            this._timeOut && clearTimeout(this._timeOut);
            this._hideTooltip();

            if (this.mouseDownPos2 != this.handlePos2) this._raiseChangeEvent();
        },

        _focusInHandle: function (evt) {
            if (!this._isFocused) {
                this._isFocused = true;
                $(evt.currentTarget).addClass("e-focus");
                if (!this.model.readOnly)
                   this._on($(document),"keydown",this._moveHandle);
                if (this.model.allowMouseWheel && !this.model.readOnly) {
                    this._on(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
                }
                this.activeHandle = $(evt.currentTarget).is(this.firstHandle) ? 1 : 2;
                this._setZindex();
            }
        },

        _focusOutHandle: function (evt) {
            this._isFocused = false;
            if (this.model.showTooltip && this.tooltip)
                this.tooltip.fadeOut(800);
            this.element.find(".e-no-tab").removeClass("e-no-tab");
            $(evt.currentTarget).removeClass("e-focus");
         this._off($(document),"keydown",this._moveHandle);
            this._off(this.element,"mousewheel DOMMouseScroll", this._moveHandle);
        },

        _moveHandle: function (e) {
            if ((e.type == 'mousewheel') || (e.type=='DOMMouseScroll')) e.preventDefault()
            var oper, val, handleNo;
            handleNo = this._getHandleIndex(this.activeHandle) - 1;
            if ((e.type == 'mousewheel') || (e.type == 'DOMMouseScroll')) {
                var rawEvent = e.originalEvent;
                if (rawEvent.wheelDelta) {
                    delta = rawEvent.wheelDelta / 120;
                }
                else if (rawEvent.detail) {
                    // Firefox uses detail property, which is a multiple of 3.
                    delta = -rawEvent.detail / 3;
                }
                oper = delta > 0 ? 'add' : 'sub';
            }

            switch (e.keyCode || e.originalEvent.wheelDelta) {
                case -120:
                case 37:
                case 40:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "sub";
                    break;
                case 120:
                case 38:
                case 39:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    oper = "add";
                    break;
                case 36:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.minValue) {
                        this._changeHandleValue(this.model.minValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 2) ? this.model.minValue : this.handleVal2;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 35:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    if (this._raiseEvent("start")) return false;
                    if (this.model.sliderType != "range" && this.value() != this.model.maxValue) {
                        this._changeHandleValue(this.model.maxValue, this.model.enableAnimation);
                    }
                    else if (this.model.sliderType == "range") {
                        val = (this.activeHandle == 1) ? this.model.maxValue : this.handleVal;
                        if (this.values()[handleNo] != val)
                            this._changeHandleValue(val, this.model.enableAnimation);
                    }
                    break;
                case 27:
                    this._getHandle().addClass("e-no-tab");
                    e.preventDefault();
                    this._getHandle().focusout();
                    break;
            }

            if (oper == "add" || oper == "sub") {
                if (this._raiseEvent("start")) return false;
                var hVal = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
                var value = (oper == "add") ? this._add(hVal, this.model.incrementStep, true) : this._add(hVal, this.model.incrementStep, false);
                this._changeHandleValue(value, false);
            }
        },

        _changeHandleValue: function (value, animate) {
            var position = null;
            if (this.activeHandle == 1) {
                this.handleVal = this._checkHandleValue(value);
                this.handlePos = this._checkHandlePosition(this.handleVal);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos = this.handlePos2;
                    this.handleVal = this.handleVal2;
                }
                if (this.handlePos != this.preHandlePos)
                    position = this.preHandlePos = this.handlePos;
            }
            else {
                this.handleVal2 = this._checkHandleValue(value);
                this.handlePos2 = this._checkHandlePosition(this.handleVal2);

                if (this.model.sliderType == "range" && this.handlePos < this.handlePos2) {
                    this.handlePos2 = this.handlePos;
                    this.handleVal2 = this.handleVal;
                }
                if (this.handlePos2 != this.preHandlePos2)
                    position = this.preHandlePos2 = this.handlePos2;
            }

            if (position != null) {
                this._increaseHeaderWidth(animate);
                this._setHandlePosition(animate, true, true);
            }
        },

        _sliderBarClick: function (evt) {
            if (this.model.readOnly) return false;
            if (evt.target == this.target || (this.model.sliderType != "default" && evt.target == this.header[0]) || $(evt.target).hasClass('e-tick') || $(evt.target).hasClass('e-scale') || evt.target == this.wrapper[0]) {
                evt.preventDefault();
                if (this._raiseEvent("start")) return false;
                var pos = { x: evt.pageX, y: evt.pageY },
                handlepos = this._xyToPosition(pos),
                handleVal = this._positionToValue(handlepos);

                if (this.model.sliderType == "range" && (this.handlePos - handlepos) > (handlepos - this.handlePos2)) {
                    this.handlePos2 = this.preHandlePos2 = handlepos;
                    this.handleVal2 = handleVal;
                    this.activeHandle = 2;
                }
                else {
                    this.handlePos = this.preHandlePos = handlepos;
                    this.handleVal = handleVal;
                    this.activeHandle = 1;
                }

                this._getHandle().focus().addClass("e-no-tab");;
                if (this.model.sliderType != "default") this._increaseHeaderWidth(this.model.enableAnimation);
                this._setHandlePosition(this.model.enableAnimation, true, true);
            }
        },

        _setHandlePosition: function (animation, showTooltip, changeEvt) {
            var Handle = this._getHandle(), proxy = this, properties = {}, pos, val, direction;
            pos = (this.activeHandle == 1) ? this.handlePos : this.handlePos2;
            val = (this.activeHandle == 1) ? this.handleVal : this.handleVal2;
            Handle.attr("aria-label", val);
            direction = (this.model.orientation == "vertical") ? this.verDir : this.horDir;
            properties[direction] = pos + "%";
            if (pos == 0) {
                this.model.sliderType != "range" && this._getHandle().addClass("e-handle-start");
            }
            else {
                this._getHandle().removeClass("e-handle-start");
            }
            if (!animation) {
                Handle.css(properties);
                this._showhideTooltip(showTooltip);
                if (changeEvt) this._raiseChangeEvent();
            }
            else Handle.animate(properties, this.model.animationSpeed, function () {
                proxy._showhideTooltip(showTooltip);
                if (changeEvt) proxy._raiseChangeEvent();
            });
        },

        _xyToPosition: function (position) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            if (this.model.orientation != "vertical") {
                var left = position.x - this.element.offset().left,
                num = this.element.width() / 100,
                val = (left / num);
            }
            else {
                var top = position.y - this.element.offset().top,
                num = this.element.height() / 100,
                val = 100 - (top / num);
            }
            val = this._stepValueCalculation(val);
            if (val < 0) val = 0;
            else if (val > 100) val = 100;
            if (this.model.enableRTL) return 100 - val;
            return val;
        },

        _updateValue: function () {
            this.handleVal = this._checkHandleValue(this.value());
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.preHandlePos = this.handlePos;
            this.activeHandle = 1;
        },

        _setValue: function (animation) {
            this._updateValue();
            this._increaseHeaderWidth(animation);
            this._setHandlePosition(animation, false, true);
        },

        _updateRangeValue: function () {
            var values = this.values();
            this.handleVal = this._checkHandleValue(values[1]);
            this.handleVal2 = this._checkHandleValue(values[0]);
            this.handlePos = this._checkHandlePosition(this.handleVal);
            this.handlePos2 = this._checkHandlePosition(this.handleVal2);

            if (this.handlePos < this.handlePos2) {
                this.handlePos = this.handlePos2;
                this.handleVal = this.handleVal2;
            }
            this.preHandlePos = this.handlePos;
            this.preHandlePos2 = this.handlePos2;
        },

        _setRangeValue: function (animation) {
            this._updateRangeValue();
            this._increaseHeaderWidth(animation);
            this.activeHandle = 1;
            this._setHandlePosition(animation, false, false);
            this.activeHandle = 2;
            this._setHandlePosition(animation, false, true);
        },

        _checkHandlePosition: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return 100;
            var handle = this._tempStartEnd();
            if (value >= handle.start && value <= handle.end)
                value = (100 * (value - this.model.minValue)) / (this.model.maxValue - this.model.minValue);
            else if (value < handle.start) value = 0;
            else value = 100;
            return value;
        },

        _checkHandleValue: function (value) {
            if (this.model.minValue == this.model.maxValue)
                return this.model.minValue;
            var handle = this._tempStartEnd();
            if (value < handle.start) value = handle.start;
            else if (value > handle.end) value = handle.end;
            return value;
        },

        _tempStartEnd: function () {
            if (this.model.minValue > this.model.maxValue)
                return {
                    start: this.model.maxValue,
                    end: this.model.minValue
                };
            else
                return {
                    start: this.model.minValue,
                    end: this.model.maxValue
                };
        },

        _positionToValue: function (pos) {
            var diff = this.model.maxValue - this.model.minValue,
            val = this._round(diff * pos / 100),
            total = this._add(val, this.model.minValue, true);
            return total;
        },

        _getHandle: function () {
            return (this.activeHandle == 1) ? this.firstHandle : this.secondHandle;
        },

        _getHandleIndex: function (no) {
            if (this.model.sliderType == "range" && no == 1)
                return 2;
            return 1;
        },

        _getHandleValue: function () {
            if (this.model.sliderType == "range") return [this.handleVal2, this.handleVal];
            else return this.handleVal;
        },

        _updateModelValue: function () {
            var value = this._getHandleValue();
            this._hidden.val(value);
            if (this.model.sliderType == "range") this.values(value);
            else this.value(value);
        },

        _add: function (a, b, addition, precision) {
            var x = Math.pow(10, precision || 3), val;
            if (addition) val = (Math.round(a * x) + Math.round(b * x)) / x;
            else val = (Math.round(a * x) - Math.round(b * x)) / x;
            return val;
        },

        _round: function (a) {
            var _f = this.model.incrementStep.toString().split(".");
            return _f[1] ? parseFloat(a.toFixed(_f[1].length)) : Math.round(a);
        },

        _raiseChangeEvent: function () {
            this._updateModelValue();
            if (this.initialRender)
                this.initialRender = false;
            else {
                if(this.getValue().toString() != this.preValue.toString()){
                        this._raiseEvent("change");
                        this._raiseEvent("stop");
                        this.preValue = this.getValue().toString();
                        this._isInteraction = true;
                }
            }
        },

        _raiseEvent: function (name) {
            var data = { id: this.target.id, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "change")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            if (name == "tooltipChange")
                data = { id: this.target.id, isInteraction: this._isInteraction, value: this._getHandleValue(), sliderIndex: this._getHandleIndex(this.activeHandle) };
            var status = this._trigger(name, data);
            if (name == "tooltipChange")
                return data.value;
            return status;
        },

        _setZindex: function () {
            if (this.model.sliderType == "range") {
                if (this.activeHandle == 1) {
                    this.firstHandle.css("z-index", 2);
                    this.secondHandle.css("z-index", 1);
                }
                else {
                    this.firstHandle.css("z-index", 1);
                    this.secondHandle.css("z-index", 2);
                }
            }
        },

        _stepValueCalculation: function (value) {
            if (this.model.incrementStep == 0) this.model.incrementStep = 1;
            var percentStep = this.model.incrementStep / ((this.model.maxValue - this.model.minValue) / 100);
            var remain = value % Math.abs(percentStep);
            if (remain != 0) {
                if ((percentStep / 2) > remain) value -= remain;
                else value += Math.abs(percentStep) - remain;
            }
            return value;
        },

        _wireEvents: function () {
            this._on(this.wrapper, "mousedown", this._sliderBarClick);
            this._on(this.firstHandle, ej.eventType.mouseDown, this._firstHandleClick);
            this._on(this.firstHandle, "mouseenter", this._hoverOnHandle);
            this._on(this.firstHandle, "mouseleave", this._leaveFromHandle);
            this._on(this.firstHandle, "focusin", this._focusInHandle);
            this._on(this.firstHandle, "focusout", this._focusOutHandle);

            if (this.model.sliderType == "range") {
                this._on(this.secondHandle, ej.eventType.mouseDown, this._secondHandleClick);
                this._on(this.secondHandle, "mouseenter", this._hoverOnHandle);
                this._on(this.secondHandle, "mouseleave", this._leaveFromHandle);
                this._on(this.secondHandle, "focusin", this._focusInHandle);
                this._on(this.secondHandle, "focusout", this._focusOutHandle);
            }
        },


        _unWireEvents: function () {
            this._off(this.wrapper, "mousedown");
            this._off(this.firstHandle, ej.eventType.mouseDown);
            this._off(this.firstHandle, "mouseenter");
            this._off(this.firstHandle, "mouseleave");
            this._off(this.firstHandle, "focusin");
            this._off(this.firstHandle, "focusout");

            if (this.model.sliderType == "range") {
                this._off(this.secondHandle, ej.eventType.mouseDown);
                this._off(this.secondHandle, "mouseenter");
                this._off(this.secondHandle, "mouseleave");
                this._off(this.secondHandle, "focusin");
                this._off(this.secondHandle, "focusout");
            }
        }
    });

    ej.SliderType = {
        /**  support for slider control to select a single value. */
        Default: "default",
        /**  support for slider control to select a single value considered from start value to current handle. */
        MinRange: "minrange",
        /**  support for slider control to select a range of value between the two handles. */
        Range: "range"
    };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Button elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejSplitButton", "ej.SplitButton", {

        element: null,

        model: null,
        validTags: ["button"],
        _setFirst: false,

        _rootCSS: "e-splitbutton",

        defaults: {

            size: "normal",

            width: "",

            height: "",

            enabled: true,

            htmlAttributes: {},

            text: null,

            contentType: "textonly",

            imagePosition: "imageleft",

            buttonMode: "split",

            arrowPosition: "right",

            targetID: null,

            target: null, 

            showRoundedCorner: false,

            prefixIcon: null,

            suffixIcon: null,

            cssClass: "",

            enableRTL: false,

            create: null,

            beforeOpen: null,

            click: null,

            itemMouseOver: null,

            itemMouseOut: null,

            itemSelected: null,

            open: null,

            close: null,

            destroy: null
        },

        dataTypes: {
            size: "string",
            enabled: "boolean",
            showRoundedCorner: "boolean",
            text: "string",
            contentType: "enum",
            imagePosition: "enum",
            buttonMode: "enum",
            arrowPosition: "enum",
            target: "string",       
            targetID: "string",
            prefixIcon: "string",
            suffixIcon: "string",
            cssClass: "string",
            enableRTL: "boolean",
            htmlAttributes: "data"
        },


        disable: function () {
            this.element.addClass("e-disable");
            this.wrapper.addClass("e-disable");
            if (this.contstatus) {
                this._hidePopup();
            }
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.addClass("e-disable").attr("aria-disabled", true);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.addClass("e-disable").attr("aria-disabled", true);
            this.model.enabled = false;
        },

        visible: function (display) {
            if (!display) {
               this.wrapper.addClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "hidden");
            }
            else {
               this.wrapper.removeClass("e-split-btn-hide");
               this.wrapper.find(".e-icon").css("visibility", "");
            }
        },

        enable: function () {
            this.element.removeClass("e-disable");
            this.wrapper.removeClass("e-disable");
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this.dropbutton.removeClass("e-disable").attr("aria-disabled", false);
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.btnimgwrap.removeClass("e-disable").attr("aria-disabled", false);
            this.model.enabled = true;
        },

        hide: function () {
            if (this.contstatus) {
                this._hidePopup();
            }
        },

        show: function () {
            if (!this.contstatus) {
                if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                    this.element.click();
                else if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.dropbutton.click();
            }
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this._initialize();
            this._controlStatus(this.model.enabled);
            this._documentClickHandler = $.proxy(this._documentClick, this);
            this._wireEvents();
        },

        _createElement: function (tagName, attrs) {
            var ele = document.createElement(tagName);
            this._setAttributes(ele, attrs);
            return $(ele);
        },
        _setAttributes: function (ele, attrs) {
            for (var key in attrs) {
                ele.setAttribute(key, attrs[key]);
            }
        },

        _destroy: function () {
            if (this.contstatus) {
                this._hide();
            }
            this.splitwrap.removeClass("e-drop");
            this.splitwrap.removeClass("e-btn-" + this.model.size);
            this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
            this.element.removeClass(this.model.cssClass + "e-ntouch e-select e-corner e-btn e-disable e-split-btn e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop e-left-btn e-txt").empty();
            this.element.append(this._cloneElement.text());
            this.element.insertAfter(this.wrapper);
            this.wrapper.remove();
            if(this._contextObj) this._contextObj.model && this._contextObj.destroy();
			if(this._contextObj) this._contextObj = null;			
            //this has to be worked out in Menu
            $(this.model.target).show();
            $(this.model.target).insertAfter(this.element); 
            this._off(this.element, "click", this._btnMouseClick);
        },

        _setModel: function (options) {
            var option;
            for (option in options) {
                switch (option) {
                    case "size":
                        this._setSize(options[option]);
                        break;
                    case "width":
                        this._splitbtnWidth(options[option]);
                        break;
                    case "height":
                        this._splitbtnHeight(options[option]);
                        break;
                    case "contentType":
                        this._setContentType(options[option]);
                        break;
                    case "imagePosition":
                        this._setImagePosition(options[option]);
                        break;
                    case "buttonMode":
                        this._setButtonMode(options[option]);
                        break;
                    case "arrowPosition":
                        this._setArrowPosition(options[option]);
                        break;
                    case "text":
                        this._setText(options[option]);
                        break;
                    case "prefixIcon":
                        this._setMajorIcon(options[option]);
                        break;
                    case "suffixIcon":
                        this._setMinorIcon(options[option]);
                        break;
                    case "enabled":
                        this._controlStatus(options[option]);
                        break;
                    case "targetID":
                    case "target":
                        this._setTarget(options[option]);
                        break;
                    case "showRoundedCorner":
                        this._roundedCorner(options[option]);
                        break;
                    case "cssClass":
                        this._setSkin(options[option]);
                        break;
                    case "enableRTL":
                        this._setRTL(options[option]);
                        break;
                    case "htmlAttributes":
                        this._addAttr(options[option]);
                        break;
                }
            }
        },

        _setText: function (val) {
            if (this.model.contentType == ej.ContentType.TextOnly) {
                if (this.model.buttonMode == ej.ButtonMode.Split)
                    this.element.html(val);
                else {
                    this.element.empty();
                    this.imgtxtwrap = val;
                    if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Top)
                        this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    else
                        this.element.append(this.imgtxtwrap, this.btnimgwrap);
                }
            } else {
                this.textspan.html(val);
            }
        },

        _setMajorIcon: function (val) {
            this.majorimgtag.removeClass(this.model.prefixIcon);
            this.majorimgtag.addClass(val);
        },

        _setMinorIcon: function (val) {
            this.minorimgtag.removeClass(this.model.suffixIcon);
            this.minorimgtag.addClass(val);
        },
        _setTarget: function (val) {
            if ((val.substring(0, 1) == ".") || (val.substring(0, 1) == "#")) {
                this.model.target = val; 
            }
            else {
                this.model.targetID = val;
                this.model.target = "#" + val;
            }
            this._renderContxtMenu();
        },

        _setContentType: function (val) {
            if (val != this.model.contentType) {
                this.element.empty();
                this.model.contentType = val;
                this._renderButtonContent();
            }
        },

        _setImagePosition: function (val) {
            if (val == ej.ImagePosition.ImageRight || val == ej.ImagePosition.ImageLeft || val == ej.ImagePosition.ImageBottom || val == ej.ImagePosition.ImageTop) {
                if ((this.model.contentType == ej.ContentType.TextAndImage) && (val != this.model.imagePosition)) {
                    this.element.empty();
                    this.model.imagePosition = val;
                    this._renderButtonContent();
                }
            }
        },

        _setButtonMode: function (val) {
            if (val == ej.ButtonMode.Split || val == ej.ButtonMode.Dropdown) {
                if (val != this.model.buttonMode) {
                    this._destroy();
                    this.model.buttonMode = val;
                    this._init();
                }
            }
        },

        _setArrowPosition: function (val) {
            if (val == ej.ArrowPosition.Right || val == ej.ArrowPosition.Left || val == ej.ArrowPosition.Bottom || val == ej.ArrowPosition.Top) {
                if ((this.model.buttonMode == ej.ButtonMode.Dropdown) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this.element.empty();
                    this._setSize(this.model.size);
                    this.element.removeClass("e-droparrowright e-droparrowleft e-droparrowbottom e-droparrowtop");
                    this._renderButtonContent();
                }
                else if ((this.model.buttonMode == ej.ButtonMode.Split) && (val != this.model.arrowPosition)) {
                    this.model.arrowPosition = val;
                    this._setSize(this.model.size);
                    this.innerWrap.removeClass("e-splitarrowright e-splitarrowleft e-splitarrowbottom e-splitarrowtop");
                    this._setRTL(this.model.enableRTL);
                }
            }
        },

        _setRTL: function (val) {
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
                switch (this.model.arrowPosition) {
                    case ej.ArrowPosition.Right:
                        this.innerWrap.addClass("e-splitarrowright");
                        break;
                    case ej.ArrowPosition.Left:
                        this.innerWrap.addClass("e-splitarrowleft");
                        break;
                    case ej.ArrowPosition.Bottom:
                        this.innerWrap.addClass("e-splitarrowbottom");
                        break;
                    case ej.ArrowPosition.Top:
                        this.innerWrap.addClass("e-splitarrowtop");
                        this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                        break;
                }
                val == true ? this.splitwrap.addClass("e-rtl e-btnrtl") && (this._contextObj && this._contextObj.model && this._contextObj.element.addClass('e-rtl')) : this.splitwrap.removeClass("e-rtl e-btnrtl") && (this._contextObj && this._contextObj.model && this._contextObj.element.removeClass('e-rtl'));
            }
            else
                val == true ? this.splitwrap.addClass('e-rtl') && (this._contextObj && this._contextObj.model && this._contextObj.element.addClass('e-rtl')) : this.splitwrap.removeClass('e-rtl') && (this._contextObj && this._contextObj.model && this._contextObj.element.removeClass('e-rtl'));
            this.model.enableRTL = val;
            this._roundedCorner(this.model.showRoundedCorner);
        },

        _roundedCorner: function (value) {
            if (value) {
                this.element.addClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).addClass('e-corner');  
            } else {
                this.element.removeClass('e-corner');
                if ($(this.model.target).length > 0) $(this.model.target).removeClass('e-corner');
            }
        },

        _controlStatus: function (value) {
            if (!value) {
                this.disable();
            } else {
                this.enable();
            }
        },

        _setSkin: function (skin) {
            this.element.removeClass(this.model.cssClass);
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton.removeClass(this.model.cssClass);
                this.dropbutton.addClass(skin);
            }
            this.element.addClass(skin);
            if(this._contextObj) this._contextObj.model && this._contextObj.option('cssClass', skin);  
        },

        _initialize: function () {
            if (this.element.is("button") || this.element.is("ej-splitbutton")) {
                this._render();
            } else {
                this.element.removeClass("e-splitbutton");//need to change in src level
            }
            this._timeout = null;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy._controlStatus(false);
                else proxy.wrapper.attr(key, value)
            });
        },


        _render: function () {
            this.element.addClass(this.model.cssClass + " e-btn e-select e-split-btn " + (!ej.isTouchDevice() ? "e-ntouch" : ""));
            this._setAttributes(this.element[0]);
            if ((this.model.text == null) || (this.model.text == "")) {
                this.model.text = this.element.text();
            }
            else
                this._setAttributes(this.element[0],{"aria-describedby": this.model.text});
            if (this.model.buttonMode != ej.ButtonMode.Split && this.model.buttonMode != ej.ButtonMode.Dropdown)
                this.model.buttonMode = ej.ButtonMode.Split;
            if (this.model.arrowPosition != ej.ArrowPosition.Right && this.model.arrowPosition != ej.ArrowPosition.Left && this.model.arrowPosition != ej.ArrowPosition.Bottom && this.model.arrowPosition != ej.ArrowPosition.Top)
                this.model.arrowPosition = ej.ArrowPosition.Right;
            this.element.empty();
            this.splitwrap = (this.model.buttonMode == ej.ButtonMode.Split ? this._createElement('span', { 'class': 'e-split e-widget' }) : this._createElement('span', { 'class': 'e-split e-drop e-widget' }));
            this.splitwrap.insertBefore(this.element);
            this.innerWrap = this._createElement('span', { 'class': 'e-in-wrap e-box e-padding' });
            this.splitwrap[0].appendChild(this.innerWrap[0]);
            this.wrapper = this.splitwrap;
            /*DropDown Image*/
            this.dropdownimg = this._createElement('span',{"class":"e-icon e-arrow-sans-down"});
            this.btnimgwrap = this._createElement('span', { 'class': 'e-split-btn-div e-btn-span' });
            this.btnimgwrap[0].appendChild(this.dropdownimg[0]);
            /*Split Button*/
            if (this.model.buttonMode == ej.ButtonMode.Split) {
                this.dropbutton = ej.buildTag('button.e-split-btn e-btn e-select ' + this.model.cssClass + ' e-drp-btn' + (!ej.isTouchDevice() ? " e-ntouch" : ""), "", {}, { type: "button", "data-role": "none", "id": this.element[0].id + 'drpbtn' });
                this.dropbutton[0].appendChild(this.btnimgwrap[0]);
                this.dropbutton.insertAfter(this.element);
                if (this.model.contentType == ej.ContentType.TextOnly)
                    this.dropbutton.addClass("e-btn-txt");
                else
                    this.dropbutton.addClass("e-rht-btn");
            }
            this._setSize(this.model.size);
            this.element.addClass("e-left-btn");
            this._renderButtonContent();
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this.innerWrap[0].appendChild(this.element[0]);
            else {
                this.innerWrap[0].appendChild(this.element[0]);
                this.innerWrap[0].appendChild(this.dropbutton[0]);
            }
            /* If target ID is set, the value of target will be set to target prefixed with # tag */
            if ((this.model.target == null) && (this.model.targetID != null)) {
                this.model.target = "#"+this.model.targetID;
            }
            /*Rendering Context menu*/
            $(this.model.target).hide();
            this._roundedCorner(this.model.showRoundedCorner);
            this._setRTL(this.model.enableRTL);
            this._addAttr(this.model.htmlAttributes);
        },

        _renderButtonContent: function () {
            /*Image and Text*/
            this.textspan = ej.buildTag('span.e-btntxt', this.model.text);
            this.majorimgtag = ej.buildTag('span').addClass(this.model.prefixIcon);
            this.minorimgtag = ej.buildTag('span').addClass(this.model.suffixIcon);
            this.imgtxtwrap = ej.buildTag('span').addClass('e-btn-span');;
            /*Rendering Option*/
            if (this.model.contentType == ej.ContentType.TextAndImage) {
                switch (this.model.imagePosition) {
                    case ej.ImagePosition.ImageRight:
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageLeft:
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                    case ej.ImagePosition.ImageBottom:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.textspan, this.majorimgtag);
                        break;
                    case ej.ImagePosition.ImageTop:
                        this.majorimgtag.css("display", "inline-table");
                        this.imgtxtwrap.append(this.majorimgtag, this.textspan);
                        break;
                }
            } else if (this.model.contentType == ej.ContentType.ImageTextImage) {
                this.imgtxtwrap.append(this.majorimgtag, this.textspan, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageBoth) {
                this.imgtxtwrap.append(this.majorimgtag, this.minorimgtag);
            } else if (this.model.contentType == ej.ContentType.ImageOnly) {
                this.imgtxtwrap.append(this.majorimgtag);
            } else {
                this.element.addClass("e-txt");
                this.imgtxtwrap = this.model.text;
            }
            if (this.model.buttonMode == ej.ButtonMode.Dropdown)
                this._renderDropdownArrow();
            else
                this.element.append(this.imgtxtwrap);
        },

        _renderDropdownArrow: function () {
            this.btnimgwrap.css("position", "absolute");
            this.dropdownimg.removeClass("e-arrow-sans-up").addClass("e-arrow-sans-down");
            switch (this.model.arrowPosition) {
                case ej.ArrowPosition.Right:
                    this.element.addClass("e-droparrowright");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Left:
                    this.element.addClass("e-droparrowleft");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
                case ej.ArrowPosition.Bottom:
                    this.element.addClass("e-droparrowbottom");
                    this.element.append(this.imgtxtwrap, this.btnimgwrap);
                    break;
                case ej.ArrowPosition.Top:
                    this.element.addClass("e-droparrowtop");
                    this.dropdownimg.addClass("e-arrow-sans-up").removeClass("e-arrow-sans-down");
                    this.element.append(this.btnimgwrap, this.imgtxtwrap);
                    break;
            }
        },


        _setSize: function (val) {
            this.wrapper.css({ "height": "", "width": "" });
            switch (val) {
                case "mini":
                    this._splitbtnSize(val);
                    break;
                case "small":
                    this._splitbtnSize(val);
                    break;
                case "medium":
                    this._splitbtnSize(val);
                    break;
                case "large":
                    this._splitbtnSize(val); 
                    break;
                default:
                    this._splitbtnSize(val);
                    break;
            }
            if ((this.model.arrowPosition == ej.ArrowPosition.Bottom || this.model.arrowPosition == ej.ArrowPosition.Top) && this.model.height == "")
                this.splitwrap.addClass("e-btn-arrowsplit-" + val);		   // 15px added the height of the wrapper due to Arrow positioned in bottom
            var wd, ht = this.model.height === "" ? this.wrapper.outerHeight() + "px" : this.model.height;
            this._splitbtnHeight(ht);
            if (this.model.size !== "normal") {
                wd = this.model.width === "" ? this.wrapper.outerWidth() + "px" : this.model.width;
                this._splitbtnWidth(wd);
            }
            else if (this.model.width !== "") {
                wd = this.model.width;
                this._splitbtnWidth(wd);
            }
        },

        _splitbtnSize: function (val) {
        
            this.splitwrap.removeClass('e-btn-mini e-btn-medium e-btn-small e-btn-large e-btn-normal e-btn-arrowsplit-large e-btn-arrowsplit-small e-btn-arrowsplit-mini e-btn-arrowsplit-medium e-btn-arrowsplit-normal');
            if (this.model.arrowPosition == ej.ArrowPosition.Left || this.model.arrowPosition == ej.ArrowPosition.Right)
            {
            this.splitwrap.addClass("e-btn-" + val);
            }
        },
        _splitbtnHeight: function (val) {
           if ((val == "") || (val == null)) val = '30px';
          this.splitwrap.css("height", val);
        },


        _splitbtnWidth: function (val) {
            this.splitwrap.css("width", val);
        },


        _renderContxtMenu: function () {
            /* Check whether target is a class and add a id to that target element if id of that element is not given */
            if ((this.model.target != null) && ($(this.model.target).attr("id") == null)) {
                if (this.model.target.substring(0, 1) == ".") {
                    $(this.model.target).attr("id", this.element.attr('id') + "_" + this.model.target.replace(".", ""));
                }
            }
            
            $(this.model.target).ejMenu({
                menuType: ej.MenuType.ContextMenu,
                openOnClick: false,
                contextMenuTarget: "",
                fields: this.model.fields,
                showArrow: true,
                cssClass: "e-split " + this.model.cssClass,
                enableRTL: this.model.enableRTL
            }).on("ejMenuclose", $.proxy(this._onKeyDown, this));
            this._contextObj = $(this.model.target).ejMenu("instance");
        },
        _onKeyDown: function (e) {
            e.keyCode == 27 && this._hide();
        },
        _itemClick: function (args) {
            args = { status: this.model.enabled, ID: args.ID, text: args.text };
            this._trigger("itemSelected", args);
            (!$(args.element).hasClass("e-haschild")) && this._hide();
        },

        _itemMouseOver: function (args) {
            this._trigger("itemMouseOver", args);
        },

        _itemMouseOut: function (args) {
            this._trigger("itemMouseOut", args);
        },


        _wireEvents: function () {
            this._on(this.element, "click", this._btnMouseClick);
            this._on(this.element, "mousedown", this._btnMouseDown);
            /*DrpBTN*/
            if (this.model.buttonMode == ej.ButtonMode.Split)
                this._on(this.dropbutton, "click", this._btnMouseClick);
            /*DocClk*/
            this._on($(document), "mousedown", this._docrhtclk);
        },


        _btnMouseClick: function (e) {
            !this._contextObj ? this._renderContxtMenu() : !this._contextObj.model && this._renderContxtMenu();
            var args;
            if(!this.model.enabled) return false;
            if (!$(e.currentTarget).hasClass("e-disable")) {
                if (e.currentTarget.id != this.element[0].id + "drpbtn" && this.model.buttonMode == ej.ButtonMode.Split) {
                    args = { status: this.model.enabled };
                    this._trigger("click", args);
                } else {
                    !this.contstatus && this._trigger("beforeOpen");
                    this.wrapper.addClass('e-active');
                    if (this.contstatus) {
                        this._hidecontext(e);
                    } else {
                        this._contextPosition(e);
                        this._trigger("open");
                        this._on($(window), "resize", this._OnWindowResize);
                        this.contstatus = true;
                        this.element.on("click", $.proxy(this._hidecontext, this));
                        ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, false, this);
                        this._on(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
                    }
                }
            }
        },

        _OnWindowResize: function (e) {
            this._contextPosition(e);
        },

        _contextPosition: function (e) {
            if (this._contextObj.model) {
                var position = this._getXYpos(e), posleft, targetElement;
                targetElement = (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
                var contextObj = this._contextObj;
                posleft = position.x - ($(this.model.target).outerWidth() - (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerWidth() : this.element.outerWidth()));
                if (this.model.enableRTL)
                    position.x = (posleft < $(this.model.target).outerWidth()) ? position.x : posleft;
                else
                    position.x = (position.x + $(this.model.target).outerWidth() < $(window).width()) ? position.x : posleft;

                contextObj.option({
                    click: $.proxy(this._itemClick, this),
                    mouseover: $.proxy(this._itemMouseOver, this),
                    mouseout: $.proxy(this._itemMouseOut, this)
                });
                contextObj.show(position.x, position.y, targetElement, e);
            }
        },

        _getXYpos: function (e) {
            var btnpos, btnposx, btnposy, poscur = 1, postop;
            btnpos = this._getOffset(this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton : this.element);
            btnposx = btnpos.left;
            postop = this.model.arrowPosition == ej.ArrowPosition.Top ? (btnpos.top - $(this.model.target).outerHeight() + 1) : (this.model.buttonMode == ej.ButtonMode.Split ? (btnpos.top + this.dropbutton.outerHeight()) : (btnpos.top + this.element.outerHeight())) - poscur;//1px added to top due to element border-top as none
            btnposy = (postop < 0) ? (btnpos.top + (this.model.buttonMode == ej.ButtonMode.Split ? this.dropbutton.outerHeight() + this.element.outerHeight() : this.element.outerHeight()) - poscur) : postop;
            return { x: btnposx, y: btnposy };
        },
        _getOffset: function (ele) {
            var pos = ele.offset();
            if ($("body").css("position") != "static") {
                var bodyPos = $("body").offset();
                pos.left -= bodyPos.left;
                pos.top -= bodyPos.top;
            }
            return pos;
        },


        _btnMouseDown: function (e) {
            if (!$(e.currentTarget).hasClass("e-disable")) {
                this._docrhtclk(e);
            }
        },
        _hidePopup: function (e) {
           this._contextObj && this._contextObj.hide(e);   
            this._hide();
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hidePopup);
        },
        _hide: function () {
            this.contstatus = false;
            this.wrapper.removeClass('e-active');
            this.element.off("click", $.proxy(this._hidecontext, this));
            ej.listenTouchEvent($(document), ej.startEvent(), this._documentClickHandler, true, this);
            this._off($(window), "resize", this._OnWindowResize);
            this._off(ej.getScrollableParents(this.wrapper), "scroll", this._hide);
            this._closeEvent();
        },
        _closeEvent: function () {
            this._trigger("close");
        },

        _hidecontext: function (e) {
            if (($(e.target).is(this.element) || $(e.target).is(this.dropbutton) || $(e.target).is(this.textspan) || $(e.target).is(this.dropdownimg) || $(e.target).is(this.btnimgwrap) || !$(e.target).is(this.majorimgtag) || !$(e.target).is(this.minorimgtag)) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) || (this.element.hasClass("e-txt") || $(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _documentClick: function (e) {
            if (!$(e.target).is(this.element) && !$(e.target).is(this.dropbutton) && !$(e.target).is(this.textspan) && !$(e.target).is(this.dropdownimg) && !$(e.target).is(this.btnimgwrap) && !$(e.target).is(this.majorimgtag) && !$(e.target).is(this.minorimgtag) && !$(e.target).is(this.splitwrap) && !$(e.target).parents().is($(this.model.target)) && (this.element.hasClass("e-txt") || !$(e.target).is(this.imgtxtwrap))) {
                this._hidePopup(e);
            }
        },

        _docrhtclk: function (e) {
            var isRightClick, targetElement;
            isRightClick = false;
            if (e.button) {
                isRightClick = (e.button == 2);
            } else if (e.which) {
                isRightClick = (e.which == 3); //for Opera
            }
            targetElement = e.target;
            if (isRightClick) {
                e.preventDefault();
            }
        },

    });

    ej.ContentType = { TextOnly: "textonly", ImageOnly: "imageonly", ImageBoth: "imageboth", TextAndImage: "textandimage", ImageTextImage: "imagetextimage" };

    ej.ImagePosition = { ImageRight: "imageright", ImageLeft: "imageleft", ImageTop: "imagetop", ImageBottom: "imagebottom" };

    ej.ButtonSize = { Mini: "mini", Small: "small", Medium: "medium", Large: "large" };

    ej.ButtonMode = { Split: "split", Dropdown: "dropdown" };

    ej.ArrowPosition = { Right: "right", Left: "left", Top: "top", Bottom: "bottom" };
})(jQuery, Syncfusion);;
/**
* @fileOverview Plugin to style the Html Radiobutton elements
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) {

    ej.widget("ejRadioButton", "ej.RadioButton", {
        _rootCSS: "e-radiobtn",

        element: null,
        _requiresID: true,
        model: null,
        validTags: ["input"],
        _addToPersist: ["checked"],
        _setFirst: false,
        angular: {
            require: ['?ngModel', '^?form', '^?ngModelOptions']
        },

        defaults: {

            id: null,

            name: null,

            value: null,

            checked: false,

            cssClass: "",

            text: "",

            enableRTL: false,

            htmlAttributes: {},

            enablePersistence: false,

            idPrefix: "ej",

            size: "small",

            enabled: true,

            validationRules: null,

            validationMessage: null,
            validationMessages: null,

            beforeChange: null,

            change: null,

            create: null,

            destroy: null
        },


        dataTypes: {
            id: "string",
            name: "string",
            enablePersistence: "boolean",
            size: "enum",
            enabled: "boolean",
            idPrefix: "string",
            validationRules: "data",
            validationMessage: "data",
            validationMessages: "data",
            htmlAttributes: "data"
        },

        observables: ["checked"],
        checked: ej.util.valueFunction("checked"),

        _init: function (options) {
            var browserInfo = ej.browserInfo();
            this._cloneElement = this.element.clone();
            this._isIE8 = (browserInfo.name == 'msie' && browserInfo.version == '8.0') ? true : false;
            this._setValue();
            this._renderControl();
            if (this.isChecked)
                this._checkedHandler();
            if(!ej.isNullOrUndefined(this.radbtn.attr("disabled"))) this.model.enabled = false;
            this._setEnabled(this.model.enabled);
            this._addAttr(this.model.htmlAttributes);
			if (!ej.isNullOrUndefined(options) && !ej.isNullOrUndefined(options.validationMessage))
				this.model.validationMessages= this.model.validationMessage;
            if (this.model.validationRules != null) {
                this._initValidator();
                this._setValidation();
            }
            this._wireEvents();
            this.initialRender = false;
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.div.addClass(value);
                else if (key == "name") proxy.radbtn.attr(key, value);
                else if (key == "required") proxy.radbtn.attr(key, value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else if (key == "checked" && value == "checked") proxy._checkedChange(true, true);
                else proxy.div.attr(key, value);
            });
        },

        _initValidator: function () {
            (!this.element.closest("form").data("validator")) && this.element.closest("form").validate();
        },
        _setValidation: function () {
            this.element.find("input").rules("add", this.model.validationRules);
            var validator = this.element.closest("form").data("validator");
            validator = validator ? validator : this.element.closest("form").validate();
            name = this.element.find('input').attr("name");
            validator.settings.messages[name] = {};
            for (var ruleName in this.model.validationRules) {
                var message = null;
                if (!ej.isNullOrUndefined(this.model.validationRules[ruleName])) {
                    if (!ej.isNullOrUndefined(this.model.validationRules["messages"] && this.model.validationRules["messages"][ruleName]))
                        message = this.model.validationRules["messages"][ruleName];
                    else {
                        validator.settings.messages[name][ruleName] = $.validator.messages[ruleName];
                        for (var msgName in this.model.validationMessages)
                            ruleName == msgName ? (message = this.model.validationMessages[ruleName]) : "";
                    }
                    validator.settings.messages[name][ruleName] = message != null ? message : $.validator.messages[ruleName];
                }
            }
        },


        _setModel: function (options) {
            for (var prop in options) {
                switch (prop) {
                    case "cssClass": this._changeSkin(options[prop]); break;
                    case "enableRTL":
                        if (this.model.text)
                            (options[prop]) ? this.div.addClass("e-rtl") : this.div.removeClass("e-rtl") && this.element.closest('.e-radiobtn-wrap').hasClass('e-rtl') ? this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl') : "";
                        else
                            (options[prop]) ? this.element.closest('.e-radiobtn-wrap').addClass('e-rtl') : this.element.closest('.e-radiobtn-wrap').removeClass('e-rtl');
                        break;
                    case "text": this._setText(options[prop]); break;
                    case "size": this._setSize(options[prop]); break;
                    case "validationRules":
                        if (this.model.validationRules != null) {
                            this.element.find('input').rules('remove');
                            this.model.validationMessages = null;
                        }
                        this.model.validationRules = options[prop];
                        if (this.model.validationRules != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "validationMessage":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                     case "validationMessages":
                        this.model.validationMessages = options[prop];
                        if (this.model.validationRules != null && this.model.validationMessages != null) {
                            this._initValidator();
                            this._setValidation();
                        }
                        break;
                    case "checked":
						$(this.div).removeClass("e-material-animate");
                        if (typeof this.checked() == "boolean") {
                            this.model.checked = options[prop];
                            this._checkedChange(this.model.checked);
                        }
                        else if (options[prop]() != null) {
                            if (options[prop]() == this.element.find(".e-input").attr("value"))
                                this._checkedChange(options[prop]());
                        }
                        break;
                    case "enabled": this._setEnabled(options[prop]); break;
                    case "id": this._setIdAttr(options[prop]); break;
                    case "name": this.radbtn.attr('name', options[prop]); break;
                    case "value":
                        this.radbtn.attr("value", options[prop]);
                        break;
                    case "htmlAttributes": this._addAttr(options[prop]); break;
                }
            }
        },

        _destroy: function () {
            this.radbtn.remove();
            this._cloneElement.removeClass("e-js e-input e-radiobtn");
            this._cloneElement.insertBefore(this.element)
            this.element.remove();
        },

        _changeSkin: function (skin) {
            if (this.model.cssClass != skin) {
                this.element.removeClass(this.model.cssClass).addClass(skin);
                this.div.removeClass(this.model.cssClass).addClass(skin);
            }
        },

        _setValue: function () {
            if (ej.isNullOrUndefined(this.element.attr("type")))
                this.element.attr("type", "radio");
            if (!ej.isNullOrUndefined(this.element.attr("id")))
                this.model.id = this.element.attr("id");
            if (!ej.isNullOrUndefined(this.element.attr("name")))
                this.model.name = this.element.attr("name");
            if (!ej.isNullOrUndefined(this.element.attr("value")))
                this.model.value = (this.element.attr("value"));
            this.element.attr({ "id": this.model.id, "name": this.model.name, "value": this.model.value });
            if (typeof this.checked() == "boolean")
                this.model.checked = this.isChecked = this.model.checked || this.element.attr('checked') == "checked"
            else
                this.isChecked = this.element.attr("value") == this.checked();
            if (this.isChecked) this.element.attr('checked', 'checked');
            this._hiddenValue = this.element.attr("value");
            this._isUI = false;
        },

        _setIdAttr: function (val) {
            $("#" + this.model.idPrefix + this.model.id + "_wrapper").attr('id', this.model.idPrefix + val + "_wrapper");
            $("#" + this.model.idPrefix + this.model.id).attr('id', this.model.idPrefix + val);
            this.radbtn.attr('id', val);
        },

        _setSize: function (val) {
            if (val == ej.RadioButtonSize.Medium) {
                this.span.removeClass('e-radsmaller').addClass('e-radmedium');
                this.div.removeClass('e-radsmall').addClass('e-radmed');
			}
            else {
                this.span.removeClass('e-radmedium').addClass('e-radsmaller');
                this.div.removeClass('e-radmed').addClass('e-radsmall');
			}
        },

        _setEnabled: function (val) {
            if (val) {
                this.enable();
            } else {
                this.disable();
            }
        },

        _renderControl: function () {
            this.initialRender = true;
            var browserInfo = ej.browserInfo();
            if (browserInfo.name == 'msie' && browserInfo.version == '8.0')
                this.div = $('<div class="e-radiobtn-wrap e-widget e-rad-outer" ></div>');
            else
                this.div = $('<div class="e-radiobtn-wrap e-widget" ></div>');
            this.div.attr({ 'id': this.model.idPrefix + this.model.id, "role": "radio", "tabindex": 0, "aria-checked": false });
            this.span = $('<span></span>');
            this.span.addClass("e-spanicon");
            this._setSize(this.model.size);
            this.spanImg = $('<span class="e-rad-icon e-icon e-rad-select"></span>', "", {}, { "role": "presentation" });
            this.element.addClass("e-input");
            this.div.addClass(this.model.cssClass);
            this.span.append(this.spanImg);
            this.div.insertBefore(this.element);
            this.div.append(this.element);
            this.div.append(this.span);
            this._setTextWrapper(this.model.text);
            this.radbtn = this.element;
            this.element = this.div;
        },

        _setTextWrapper: function (val) {
            if (val != "") {
                this.txtSpan = ej.buildTag("div.e-text", val);
                this.div.append(this.txtSpan);
                if (this.model.enableRTL)
                    this.div.addClass("e-rtl");
            } else if (this.model.enableRTL)
                this.element.closest('.e-radiobtn-wrap').addClass('e-rtl');
        },

        _setText: function (val) {
            if ((this.model.text == "") && (val != "")) {
                this._setTextWrapper(val);
            } else {
                this.txtSpan.html(val);
            }
        },

        _wireEvents: function () {
            this._on(this.element, "click", function (e) {
                this._isUI = true;

                this._checkedHandler(e);
            });
            this._on(this.element, "focus", this._focusIn);
            this._on(this.element, "focusout", this._focusOut);
        },
        _focusIn: function (evt) {
            $(this.element).addClass("e-focus");
            $(this.element).on("keydown", $.proxy(this._checkUnCheck, this));
        },
        _focusOut: function (evt) {
            $(this.element).removeClass("e-focus");
            $(this.element).off("keydown", $.proxy(this._checkUnCheck, this));
        },

        _checkUnCheck: function (evt) {
            //Space bar,and arrow keys to check and uncheck
            if (evt.keyCode == 32 || evt.keyCode == 37 || evt.keyCode == 38 || evt.keyCode == 39 || evt.keyCode == 40) {
                evt.preventDefault();
                this._checkedHandler();
            }
        },

        _checkedHandler: function (evt) {
			if (evt) this._interacted = true;
            if (!this.element.hasClass('e-disable')) {
                if (typeof this.checked() == "boolean")
                    this.isChecked = this.radbtn.attr('checked') == 'checked' ? true : false;
                else
                    this.isChecked = this.checked() == this.radbtn.attr('value');
                if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) this._changeEvent(true);
				if (evt) $(this.div).addClass("e-material-animate");
            }
        },

        _checkedChange: function (val, interaction) {
            this.isChecked = val;
            this._changeEvent(interaction);
        },

        _changeEvent: function (interaction) {
            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender) {
                if (true == this._trigger("beforeChange", data))
                    return false;
            }

            if (!$(this.element).find(".e-rad-icon").hasClass("e-circle_01")) {
                var curname = this.element.find(".e-input").attr('name'),
                input = $('input.e-radiobtn[name="' + curname + '"]:radio'),
                proxy = this,
                currElement = this.element.find('.e-input'),
                currObj = $(currElement).data("ejRadioButton");
                if (data.isChecked) {
                    this.spanImg.addClass("e-circle_01").removeClass('e-rad-select');
                    this.span.addClass("e-rad-active");
                    this.div.attr({ "tabindex": 0, "aria-checked": true });
                    this.radbtn.attr("checked", "checked");
                }
                $.each(input, function (i, obj) {
					if (proxy._interacted && $($(obj).closest(".e-widget")).find("span.e-spanicon").hasClass("e-rad-active")) $(obj).closest(".e-radiobtn-wrap").addClass("e-material-animate");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-rad-icon").removeClass("e-circle_01").addClass("e-rad-select");
                    $(obj).closest(".e-radiobtn-wrap").find(".e-spanicon").removeClass("e-rad-active");
                    $(obj).closest(".e-radiobtn-wrap").attr({ "tabindex": 0, "aria-checked": false });
                    var prevObj = $(obj).data("ejRadioButton");
                    if (prevObj != null && prevObj.checked() != null && typeof prevObj.checked() == "boolean")
                        prevObj.model.checked = false;
                });
                if (currObj != null && currObj.checked() != null && typeof currObj.checked() == "boolean")
                    currObj.model.checked = true;
                else
                    currObj.checked(currObj.radbtn.attr("value"));
                this.element.find(".e-rad-icon").addClass("e-circle_01").removeClass("e-rad-select");
                this.span.addClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": true });
                this.isChecked = true;
                if (this._isUI) this.element.find(".e-input").click();
			    (this.isChecked==true) ? this.radbtn.attr("checked","checked"):this.radbtn.removeAttr("checked");
            }
            else {
                this.spanImg.removeClass("e-circle_01").addClass('e-rad-select');
                this.span.removeClass("e-rad-active");
                this.div.attr({ "tabindex": 0, "aria-checked": false });
                this.radbtn.removeAttr("checked");
            }

            var data = { isChecked: this.isChecked, isInteraction: !!interaction };
            if (!this.initialRender)
                this._trigger("change", data);
            if (interaction) this._trigger("_change", { value: this._hiddenValue });
        },

        disable: function () {
            if (!this.element.hasClass("e-disable")) {
                this.element.addClass("e-disable");
                this.radbtn.attr("disabled", "disabled");
            }
            if (this._isIE8) this.span.addClass("e-disable");
            this.div.attr("aria-disabled", true);
            this.model.enabled = false;
        },

        enable: function () {
            if (this.element.hasClass("e-disable")) {
                this.element.removeClass("e-disable");
                this.radbtn.prop("disabled", false);
            }
            if (this._isIE8) this.span.removeClass("e-disable");
            this.div.attr("aria-disabled", false);
            this.model.enabled = true;
        }
    });

    ej.RadioButtonSize = {
        /**  Creates radio button with inbuilt small size height, width specified */
        Small: "small",
        /**  Creates radio button with inbuilt medium size height, width specified */
        Medium: "medium"
    };
})(jQuery, Syncfusion);
;
/**
* @fileOverview Plugin to style the Menu control.
* @copyright Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
*  Use of this code is subject to the terms of our license.
*  A copy of the current license can be obtained at any time by e-mailing
*  licensing@syncfusion.com. Any infringement will be prosecuted under
*  applicable laws. 
* @version 12.1 
* @author <a href="mailto:licensing@syncfusion.com">Syncfusion Inc</a>
*/
(function ($, ej, undefined) { 
    ej.widget("ejMenu", "ej.Menu", {

        element: null,

        model: null,
        validTags: ["ul"],
        _setFirst: false,
        _rootCss: "e-menu",
        angular: {
            terminal: false
        },


        defaults: {

            height: "",

            width: "",

            animationType: "default",

            orientation: ej.Orientation.Horizontal,

            menuType: "normalmenu",
			
			isResponsive: true,

            contextMenuTarget: null,

            htmlAttributes: {},

            cssClass: "",

            openOnClick: false,

            subMenuDirection: "none",

            enableCenterAlign: false,

            showRootLevelArrows: true,

            showSubLevelArrows: true,

            enableAnimation: true,
            
            container: null,

            enableSeparator: true,

            enabled: true,

            overflowHeight: "auto",

            overflowWidth: "auto",

            fields: {

                child: null,

                dataSource: null,

                query: null,

                tableName: null,

                id: "id",

                parentId: "parentId",

                text: "text",

                spriteCssClass: "spriteCssClass",

                url: "url",

                imageAttribute: "imageAttribute",

                htmlAttribute: "htmlAttribute",

                linkAttribute: "linkAttribute",

                imageUrl: "imageUrl",
            },

            enableRTL: false,

            titleText: "Menu",

            locale: "en-US",

            excludeTarget: null,

            beforeOpen: null,

            open: null,

            close: null,

            mouseover: null,

            mouseout: null,

            click: null,

            keydown: null,

            overflowOpen: null,

            overflowClose:null,

            create: null,

            destroy: null
        },

        dataTypes: {
            animationType: "enum",
            cssClass: "string",
            titleText: "string",
            locale: "string",
            openOnClick: "boolean",
            enabled: "boolean",
            enableCenterAlign: "boolean",
            showArrow: "boolean",
            showRootLevelArrows: "boolean",
            showSubLevelArrows: "boolean",
            enableSeparator: "boolean",
			isResponsive: "boolean",
            enableRTL: "boolean",
            enableAnimation: "boolean",
            fields: {
                dataSource: "data",
                query: "data",
                child: "data"
            },
            excludeTarget: "string",
            htmlAttributes: "data"
        },


        _setModel: function (jsondata) {
            for (var key in jsondata) {
                switch (key) {
                    case "menuType":
                        jsondata[key] = this.model.menuType;
                        break;
                    case "fields":
                        this._wireEvents("_off");
                        this.element.empty().insertBefore(this.wrapper);
                        this.wrapper.remove();
                        $.extend(this.model.fields, jsondata[key]);
                        this._intializeData();
                        if (!this.model.enabled)
                            this._wireEvents("_off");
                        break;
                    case "orientation": this._setOrientation(jsondata[key]); break;
                    case "showRootLevelArrows": this._addArrow(jsondata[key], this.model.showSubLevelArrows); break;
                    case "showSubLevelArrows": this._addArrow(this.model.showRootLevelArrows, jsondata[key]); break;
                    case "enableSeparator": this._setSeparator(jsondata[key]); break;
                    case "height": this._setHeight(jsondata[key]); break;
                    case "width": this._setWidth(jsondata[key]); break;
                    case "cssClass": this._setSkin(jsondata[key]); break;
                    case "isResponsive":
                        if (this.model.isResponsive)
                            this._responsiveLayout();
                        else {
                            $(this.resWrap).remove();
                            $(this.wrapper).removeClass("e-menu-responsive");
                            $(this.element).removeClass("e-menu-responsive");
                            this.resWrap = null;
                        }
                        break;
                    case "htmlAttributes": this._addAttr(jsondata[key]); break;
                    case "enableRTL": this._setRTL(jsondata[key]); break;
                    case "enableCenterAlign": this._centerAlign(jsondata[key]); break;
                    case "excludeTarget": this.model.excludeTarget = jsondata[key];
                        break;
                    case "enabled": this.model.enabled = jsondata[key]; this._controlStatus(jsondata[key]); break;
                    case "animationType":
                        this._setAnimation(jsondata[key]);
                        break;
                    case "enableAnimation": this.model.enableAnimation = jsondata[key]; break;
                    case "openOnClick":
                            this._hoverOpen = !jsondata[key];
                            this._hoverClose = !jsondata[key]; 
                        break;
                    case "subMenuDirection": this._setSubMenuDirection(this.model.subMenuDirection); break;
                    case "titleText":
						this._titleText(jsondata[key]);
                        break;
                    case "locale":
                        this.model.locale = jsondata[key];
                        this._updateLocalConstant();
                        this._setLocale();
                        break;
                    case "overflowHeight":                       
                            this._setOverflowDimensions("height",jsondata[key]); break;
                    case "overflowWidth":                      
                        this._setOverflowDimensions("width",jsondata[key]); break;

                }
            }
        },
        _updateLocalConstant: function () {
            this._localizedLabels = ej.getLocalizedConstants("ej.Menu", this.model.locale);
        },
        		
        _setLocale: function () {
            this._titleText(this._localizedLabels.titleText);
        },
        _titleText: function(val){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                $(this.label).text(val);
        },

        _destroy: function () {
            this.model.menuType == ej.MenuType.ContextMenu ? this._referenceElement.append(this._cloneElement) : this._cloneElement.insertBefore(this.wrapper);
            this._cloneElement.removeClass('e-menu e-js');
            this.wrapper.remove();
        },


        _init: function () {
            this._cloneElement = this.element.clone();
            this.element.css("visibility", "hidden");
            this._setValues();
            this._intializeData();
            this.element.css("visibility", "visible");
        },

        _setValues: function () {
            this._mouseOver = true;
            this._hoverOpen = true;
            this._hoverClose = true;
            this._isMenuOpen = false;
            this._hideSpeed = 100;
            this._showSpeed = 100;
            this._isSubMenuOpen = false;
            this._isContextMenuOpen = false;
            this._disabledMenuItems = new Array();
            this._hiddenMenuItems = new Array();
            this._delayMenuHover = 0;
            this._delaySubMenuHover = 0;
            this._delaySubMenuShow = 0;
            this._preventContextOpen = true;
            this._setAnimation(this.model.animationType);
            this._isFocused = true;
            this._menuOverflowItems = new Array();
            this._menuHeaderItems = new Array();
            this._menuCloneItems = new Array();
            this._itemWidth = 0; 
        },
        _intializeData: function () {
            if (!ej.isNullOrUndefined(this.model.fields) && this.model.fields["dataSource"] != null) {
                this._generateTemplate(this.model.fields["dataSource"]);
                this._renderMenu();
            }
            else {
                this._renderMenu();
                this._wireEvents("_on");
                this._calculateOverflowItems();
            }
        },
        _renderMenu: function () {
            this._renderControl();
            this._addArrow(this.model.showRootLevelArrows, this.model.showSubLevelArrows);
			this._renderArrow();
			this._intializeMenu();
            //item Width for width property		
			    this._itemWidth = this.element.width();
			    if (this.model.isResponsive) {
			        this._ensureResponsiveClasses($(window).width() < 767);
			    }
			    if (this.model.orientation == "horizontal") {
			        this._on(this.element.parent().find("span.e-check-wrap.e-icon"), "click", this._mobileResponsiveMenu);
			        if(this.model.fields["dataSource"] != null) this._calculateOverflowItems();
			    }
        },      

        _renderControl: function () {
            var label, checkBox, checkObj, list, spanlist, i;
            if (this.model.menuType == "normalmenu") {
                this.wrapper = ej.buildTag("div");
                this.wrapper.addClass(this.model.cssClass + " e-menu-wrap");
            } else
                this.wrapper = ej.buildTag("div.e-menu-wrap");
            if (this.model.isResponsive) this._responsiveLayout();
            if (this.model.menuType != ej.MenuType.ContextMenu) {
                this.wrapper.insertBefore(this.element);
                this.wrapper.append(this.element);
                }            
            this.element.addClass("e-menu e-widget e-box").attr({ "role": "menu", "tabindex": 0 });
            this._addAttr(this.model.htmlAttributes);
            if (this.model.enableRTL) this._setRTL(this.model.enableRTL);
            this._setSubMenuDirection(this.model.subMenuDirection);
            if (this.model.menuType == "normalmenu") {
                this.model.orientation == "horizontal" ? this.element.addClass("e-horizontal") : this.element.addClass("e-vertical");
            }
            //For ContextMenu Mode
            else this._contextMenu_Template();
            this._addClass();
            if (this.model.enableCenterAlign) this._centerAlign(this.model.enableCenterAlign);
            if (this.model.enableSeparator) this._setSeparator(true);
            (!this.model.enabled) && this.disable();
        },
        _renderPopupWrapper: function (e) {
            if(this._ensureOverflowPopup()){                          
                this.popupWrapper = ej.buildTag("div.e-menu-popwrap");                         
                this.popupWrapper.insertAfter(this.element);              
                var height = typeof value === "number" ? this.model.overflowHeight + "px" :this.model.overflowHeight;
                var width = typeof value === "number" ? this.model.overflowWidth + "px" : this.model.overflowWidth;
                this.popupWrapper.css({ "height": height,"width":width});
                this.popupWrapper.hide();
                this._addOverflowItems();                
            }
        
        },
        _calculateOverflowItems: function (e) {        
            if (this._ensureOverflowPopup()) {
                this.element.find("li.e-list").removeClass("e-menu-show");
                $(this.lastelement).removeClass("e-last");
                this._menuHeaderItems = [];  
                var menuHeaderWidth = this.element.outerWidth();               
                if (this.element.find("li.e-ham-wrap").length > 0) //for window resizing event neglect the hamburger icon list from the listCollection
                {                   
                    if ((this._itemWidth<=this.element.width())||(this._itemWidth>=this.element.width()) && (!(this._isOverflowPopupOpen()))) {
						if(!ej.isNullOrUndefined(this.popupWrapper))
							this.popupWrapper.hide();                        
                    }
                }
				this._renderHamburgerIcon();	
				this.element.find("li.e-ham-wrap").css({display: 'list-item'});
                var hamburgerWidth = this.element.find("li.e-ham-wrap").outerWidth(), itemsOuterWidth = 0, hideState=true;
				this.element.find("li.e-ham-wrap").hide();
                this._menuHeaderItems = this.element.find(">li.e-list");
                this._menuOverflowItems = [];
                for ( var i = 0; i < this._menuHeaderItems.length; i++) {
                   var menuItem = $(this._menuHeaderItems[i]);                                        
                        itemsOuterWidth = itemsOuterWidth + menuItem.outerWidth();
                        if (itemsOuterWidth < menuHeaderWidth) {                      
                            menuItem.removeClass('e-menu-hide');
							this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");
                            if (this.model.enableSeparator) this._setSeparator(true);                  
                        }
                        else {
							if(hideState)
							{
								hideState=false;
								this.element.find("li.e-ham-wrap").css({display: 'list-item'}); 
								itemsOuterWidth = itemsOuterWidth - menuItem.outerWidth() + hamburgerWidth;
								if(i>1){
									(itemsOuterWidth = itemsOuterWidth - $(this._menuHeaderItems[i-1]).outerWidth());
									i=i-2;
								}								
								continue;
							}
                            this._menuOverflowItems.push($(menuItem).clone(true));                            
                            menuItem.addClass('e-menu-hide');                            
                        }
                }            
                if (this._menuOverflowItems.length>0) {
                    this._renderHamburgerIcon();
                    $('.e-menu-popwrap').length ?  this._addOverflowItems():  this._renderPopupWrapper();                     
                    this.lastelement = this.element.find('>li.e-list:visible').last().addClass('e-last');
                    this.element.find(">li.e-list.e-haschild>ul").find("li.e-haschild").find("span.e-icon.e-arrowhead-down").removeClass("e-arrowhead-down").addClass("e-arrowhead-right");            
                }
                else if (this._menuOverflowItems.length == 0 && $("li.e-ham-wrap").length > 0) {
                    this.element.find("li.e-ham-wrap").remove();
                }

            }           
            if (this.model.orientation == "vertical" || this.model.menuType == ej.MenuType.ContextMenu && ($(window).width() >= 768) && (this.model.isResponsive)) {
                this.element.find("span.e-icon.e-arrowhead-down").removeClass('e-arrowhead-down').addClass('e-arrowhead-right');
            }
            

        },
        _renderHamburgerIcon: function () {
            if((this._ensureOverflowPopup())&& (this.element.find("li.e-ham-wrap").length==0)){            
                var liTag = ej.buildTag("li.e-ham-wrap");
                var divTag = ej.buildTag("div");
                this.hamburgerspan = ej.buildTag('span.e-hamburger');                                                     
                divTag.append(this.hamburgerspan);
                liTag.append(divTag);    
                this.element.append(liTag);
                //to set border
                if (this.model.height != 0) this._setHeight(this.model.height);
                else {                       
                    $("li.e-ham-wrap").css({"height":this.element.find("li.e-list").first().height()});
                }
                //button click event
                this._on(this.element.find("li.e-ham-wrap"), "click", this._overflowOpen);                
            }
        },
        _addOverflowItems: function () {
            if ((this._ensureOverflowPopup()) && ($('.e-menu-popwrap').length>0)) {
				if(!ej.isNullOrUndefined(this.popupWrapper)){
					this.popupWrapper.empty();
					this._menuCloneItems.length = 0;                
					for (var i = 0; i < this._menuOverflowItems.length; i++) {
						this._menuCloneItems.push($(this._menuOverflowItems[i]).clone(true));                    
					}
					this.ulTag = ej.buildTag("ul");
					this.ulTag.addClass("e-menu e-js e-responsive e-widget e-box e-vertical");
					this.popupWrapper.append(this.ulTag);
					for (var i = 0; i < this._menuCloneItems.length; i++) {
						if ($(this._menuCloneItems[i]).hasClass('e-haschild')) {
							$(this._menuCloneItems[i]).find('span.e-icon').removeClass('e-arrowhead-down e-arrowhead-right').addClass('e-arrowhead-down');
							$(this._menuCloneItems[i]).children('span.e-menu-arrow.e-menu-left').remove();                       
						}
						this.ulTag.append(this._menuCloneItems[i]);
					}
					$(this.ulTag).children("li").removeClass("e-menu-hide");
					//to set width of ULTag          
					var popupWidth = Math.round(this.popupWrapper.width());
					if (popupWidth>0) {
						var popupWrapperWidth = this.popupWrapper.innerWidth();
						this.popupWrapper.find("ul.e-menu").css({ "width":popupWrapperWidth+ "px" });                
					}
					//to set the separator                  
					if (this.model.enableSeparator) this._setSeparator(true);                    
				}
            }         
        },
        _overflowOpen: function (e) {           
            if(this._isOverflowPopupOpen ()){   
                //set popup wrapper left position 
                 var location = ej.util.getOffset(this.element);
					var left = location.left + (this.model.enableRTL? 0 :(this.element.outerWidth() - this.popupWrapper.outerWidth()));
					var top = location.top + this.element.outerHeight();
					
					if(this.wrapper.parent().length && (this.wrapper.parent().css("position") == "absolute" || this.wrapper.parent().css("position") == "relative"))
					{
						location = ej.util.getOffset(this.wrapper.parent());
						left = left-location.left;
						top = top-location.top;
					}						
					this.popupWrapper.css({ "left": left,"top":top});                          
                this.popupWrapper.show();                                
                this._trigger("overflowOpen",  {e:e});
            }
            else {
                this._overflowClose(e);
            }
        },           
        _overflowClose: function (e) {
            if(this._ensureOverflowPopup() && !ej.isNullOrUndefined(this.popupWrapper)){            
                this.popupWrapper.find("li.e-list").removeClass(".e-mhover.e-active.e-mfocused");
                this._hideAnimation(this.popupWrapper.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
                this.popupWrapper.hide();                               
                this._trigger("overflowClose", { e: e });
            }
        },
        _isOverflowPopupOpen: function () {
		       if($(this.popupWrapper).length>0)
            return this.popupWrapper.css("display")=="none";           
        },
        _removePopup:function(e){
            if(($(window).width()<767)&& (this.model.isResponsive)){
			        this._ensureResponsiveClasses($(window).width());
                if ((this.element.find("li.e-ham-wrap").length > 0) && (this.popupWrapper.length>0)){
                    this.element.find("li.e-ham-wrap").remove();
                    $('.e-menu-popwrap').remove();                   
                    this.element.find("li.e-list").addClass("e-menu-show");             
                }
            }          
        },      
        _mobileResponsiveMenu:function(e){            
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ((this.element.css("display")=="none"))) {
                    this.element.removeClass("e-res-hide").addClass("e-res-show");                 
                }
            else if((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && (!(this.element.css("display")=="none")))
                {
                    this.element.removeClass("e-res-show").addClass("e-res-hide");                    
                }          
        },
        _ensureOverflowPopup:function(e){
            return (this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical") && ($(window).width() >= 768) && (this.model.isResponsive);                
        },
        _onResize:function(e){
			this.element.find("li.e-ham-wrap").hide(); 
            $(window).width()>=768 ? this._calculateOverflowItems() : this._removePopup();
        },
        _ensureResponsiveClasses:function(viewport){
            if (viewport && this.element.find("span.e-icon").hasClass("e-arrowhead-right") ) this.element.find("span.e-icon.e-arrowhead-right").removeClass('e-arrowhead-right').addClass('e-arrowhead-down');            
        },

        _responsiveLayout: function () {
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
                this.wrapper.addClass("e-menu-responsive");
                this.element.addClass("e-menu-responsive")
                this.resWrap = ej.buildTag('span.e-menu-res-wrap e-menu-responsive');
                this.inResWrap = ej.buildTag('span.e-in-wrap e-box e-menu-res-in-wrap');
                this.label = ej.buildTag('span.e-res-title').html(this.model.locale == "en-US" ? this.model.titleText : (ej.Menu.Locale[this.model.locale] && ej.Menu.Locale[this.model.locale].titleText)?ej.Menu.Locale[this.model.locale].titleText:this.model.titleText);
                this.check = ej.buildTag('span.e-check-wrap e-icon');
                this.wrapper.append(this.resWrap)
                this.resWrap.append(this.inResWrap);
                this.inResWrap.append(this.label).append(this.check);
            }
        },
        _addAttr: function (htmlAttr) {
            var proxy = this;
            $.map(htmlAttr, function (value, key) {
                if (key == "class") proxy.wrapper.addClass(value);
                else if (key == "disabled" && value == "disabled") proxy.disable();
                else proxy.element.attr(key, value)
            });
        },

        _oncheck: function (e) {
            var obj = this.element.parents('.e-menu-wrap').children('.e-menu');
            e.isChecked ? obj.removeClass('e-res-hide').addClass('e-res-show') : obj.removeClass('e-res-show').addClass('e-res-hide');
        },
        _addClass : function (){
            //Adding arrows to items with sub items
            this.element.find('li:has("> ul")').find('> a,> span').addClass('aschild');
            this.element.find('>li').addClass('e-list').attr({ "role": "menuitem" });
			this.element.find('li').find(">a, >span").addClass('e-menulink');
            var list = this.element.find('.e-list a.aschild');
            var spanlist = this.element.find('.e-list span.aschild');
            var listElement, spanElement;
            for ( var i = 0; i < list.length; i++) {
                listElement = $(list[i]);
                listElement.siblings().attr({ "aria-hidden": true });
                listElement.parent().attr({ "aria-haspopup": true, "role": "menuitem" }).addClass("e-haschild");
                listElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
            for ( var i = 0; i < spanlist.length; i++) {
                spanElement = $(spanlist[i]);
                spanElement.siblings().attr({ "aria-hidden": true });
                spanElement.parent().attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                spanElement.siblings('ul').children('li').addClass('e-list').attr("role", "menuitem");
            }
        },
		_renderArrow : function(){
			 if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) {
				if( $($(this.element).find("span.e-menu-arrow")).length == 0){
					var arrow = ej.buildTag("span.e-menu-arrow e-menu-left");
					$(arrow).append("<span class='e-arrowMenuOuter'></span>").append("<span class='e-arrowMenuInner'></span>");
					this.element.find('>li.e-list.e-haschild').append(arrow);
				}
			 }
		},
        _generateTemplate: function (data) {
            var proxy = this, queryPromise;
            if (data instanceof ej.DataManager) {
                queryPromise = data.executeQuery(this._columnToSelect(this.model.fields));
                queryPromise.done(function (e) {
                    proxy._odataFlag = true;
                    proxy._generateItemTemplate(e.result);
                    proxy._wireEvents("_on");
                });
            } else {
                proxy._odataFlag = false;
                this._generateItemTemplate(proxy.model.fields['dataSource']);
                this._wireEvents("_on");
            }
        },

        _generateItemTemplate: function (items) {
            for (var i = 0; i < items.length; i++) {
                if ((items[i][this.model.fields.parentId] == null) || (items[i][this.model.fields.parentId] == 0)) {
                    var subItem = this._menuTemplate(items[i], items, this.model.fields);
                    this.element.append(subItem);
                }
            }
        },

        _menuTemplate: function (item, tableData, mapper) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr("class", 'e-list');
            if (item[mapper.htmlAttribute]) this._setAttributes(item[mapper.htmlAttribute], liTag);
			aTag = $(document.createElement('a'));
			aTag.attr("class", 'e-menulink');
			if (item[mapper.imageUrl] && item[mapper.imageUrl] != "") {
				imgTag = $(document.createElement('img'));
				imgTag.attr('src', item[mapper.imageUrl]);
				if (item[mapper.imageAttribute]) this._setAttributes(item[mapper.imageAttribute], imgTag);
				aTag.append(imgTag);
			}
			else if (item[mapper.spriteCssClass] && item[mapper.spriteCssClass] != "") {
				spanTag = $(document.createElement('span'));
				spanTag.addClass(item[mapper.spriteCssClass]);
				aTag.append(spanTag);
			}
			aTag.append(item[mapper.text]);
			if (item[mapper.linkAttribute]) this._setAttributes(item[mapper.linkAttribute], aTag);
			if (item[mapper.url])
				aTag.attr('href', item[mapper.url]);
			liTag.append(aTag);
            if (item[mapper.id]) {
                liTag.prop("id", item[mapper.id]);
            }
            if (!ej.isNullOrUndefined(mapper["child"])) {
                this._odataFlag = true;
                if (mapper["child"]["dataSource"] instanceof ej.DataManager) {
                    var proxy = this, queryManager = ej.Query();
					$(liTag).attr({ "aria-haspopup": true, "role": "menu" }).addClass("e-haschild");
                    queryManager = this._columnToSelect(mapper["child"]);
                    queryManager.where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]);
                    var queryPromise = mapper["child"]["dataSource"].executeQuery(queryManager);
                    queryPromise.done(function (e) {
                        var childItems = e.result;
                        if (childItems && childItems.length > 0) {
                            var ul = $(document.createElement('ul'));
                            for (var i = 0; i < childItems.length; i++) {
                                var liItem = proxy._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                                ul.append(liItem);
                            }
                            liTag.append(ul);
                            $(liTag).children('a').addClass('aschild');
                            if ($(liTag).parent().hasClass('e-menu') && (proxy.model.showRootLevelArrows))
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
                            else if (proxy.model.showSubLevelArrows)
                                $(liTag).children('a.aschild').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
                        }
                    });
                    queryPromise.then(function (e) {
                        proxy._renderArrow();
                    });
                }
                else {
					var childItems;
					if(!ej.isNullOrUndefined(item.child)){
						if(ej.isPlainObject(item.child))
							childItems = ej.DataManager(mapper["child"]["dataSource"]).executeLocal(ej.Query().where(mapper["child"]["parentId"], ej.FilterOperators.equal, item[mapper.id]));
						else if(item.child instanceof Array)
							childItems =  item.child;
					}	
                    if (childItems && childItems.length > 0) {
                        var ul = $(document.createElement('ul'));
                        for (var i = 0; i < childItems.length; i++) {
                            var liItem = this._menuTemplate(childItems[i], mapper["child"]["dataSource"], mapper["child"]);
                            ul.append(liItem);
                        }
                        liTag.append(ul);
                    }
                }
            }
            else if (!this._odataFlag) {
                var childItems = ej.DataManager(mapper["dataSource"]).executeLocal(ej.Query().where(mapper["parentId"], ej.FilterOperators.equal, item[mapper.id]));
                if (childItems && childItems.length > 0) {
                    var ul = ej.buildTag('ul');
                    for (var i = 0; i < childItems.length; i++) {
                        var liItem = this._menuTemplate(childItems[i], mapper["dataSource"], mapper);
                        ul.append(liItem);
                    }
                    liTag.append(ul);
                }
            }
            return liTag;
        },

        _setAttributes: function (data, element) {
            for (var key in data) {
                if (key == "class")
                    element.addClass(data[key]);
                else
                    element.attr(key, data[key]);
            }
        },

        _addArrow: function (topArrows, bottomArrows) {
            if (topArrows) {
				var arrowIcon = (this.model.orientation == "horizontal") ? "e-arrowhead-down" : "e-arrowhead-right";
				this.element.find('>li.e-list:has("> ul")').children('a').append($('<span>').addClass("e-icon "+arrowIcon)).addClass("e-arrow-space");
			}
            else {
                this.element.find('>li.e-list:has("> ul")').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

            if (bottomArrows)
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else {
                this.element.find('>li.e-list > ul li.e-list:has(>ul)').children('a').removeClass("e-arrow-space").children('span.e-icon').remove();
            }

        },

        _intializeMenu: function () {
            if (this.model.height != 0) this._setHeight(this.model.height);
            if (this.model.width != 0) this._setWidth(this.model.width);
            if (this.model.menuType == "contextmenu")
                this.model.openOnClick = false;
            if (this.model.openOnClick) {
                this._hoverOpen = false;
                this._hoverClose = false;
            }
        },

        _setOrientation: function (val) {
            if (val == "horizontal") {
                this.element.removeClass("e-vertical e-horizontal").addClass("e-horizontal");
            } else {
                this.element.removeClass("e-horizontal e-vertical").addClass("e-vertical");
            }
            if (val == "vertical") {
                this._removePopup();
            }
        },

        _setHeight: function (value) {
            if (this.model.orientation == "horizontal" && value !=="auto") {
                value = typeof value === "number" ? value + "px" : value;
                this.element.find('> li').find('>a:first').css("line-height", value);
                if (this.model.showRootLevelArrows)
                    this.element.find('> li').find('>a:first').find('> span:first').css({ "line-height": value, "top": "0px" })
                if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")){
                    if ($("li.e-ham-wrap").length > 0) {                        
                        this.element.find("li.e-ham-wrap").children("div").css({ "line-height": value });
                        this.element.find("li.e-ham-wrap").css({ "height": value });
                        if($(".e-menu-popwrap").length>0)
                        this.popupWrapper.find("a.e-menulink").css({ "line-height":value });                        
                    }
                }
            }
            else
                this.element.height(value);
        },

        _setWidth: function (value) {
            this.element.css("width", value);
            if (this.model.orientation === "horizontal" && value !== "auto") {
                if (this.model.isResponsive)
                    this.resWrap.css("width", value);
            }
            if (this.model.orientation == "horizontal" &&  ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical")) ) {
                this._calculateOverflowItems();
            }
            
        },        
        _setOverflowDimensions:function(property,value){
            if ((this.model.menuType != ej.MenuType.ContextMenu) && (this.model.orientation != "vertical"))
                value = typeof value == "number" ? value + "px" : value;
                if (property == "height") this.popupWrapper.css({ height: value });
                else if (property == "width") this.popupWrapper.css({ width: value });                           
                this._addOverflowItems();
        },

        _setRTL: function (isRTL) {
            if (isRTL) {
                this.element.removeClass("e-rtl").addClass("e-rtl");
            } else {
                this.element.removeClass("e-rtl");
            }
            if (isRTL && this.model.orientation === "horizontal")
                this.wrapper.removeClass("e-menu-rtl").addClass("e-menu-rtl");
            else
                this.wrapper.removeClass("e-menu-rtl");
			this.model.subMenuDirection = isRTL ? "left" : "right";
        },

        _setSubMenuDirection: function (direction) {
            if (direction != "left" && direction != "right")
                this.model.subMenuDirection = this.model.enableRTL ? "left" : "right";
        },

        _setAnimation: function (value) {
            value === "none" ? (this._showAnim = "none", this._hideAnim = "none") : (this._showAnim = "slideDown", this._hideAnim = "slideUp");
        },

        _controlStatus: function (value) {
            value != true ? this.disable() : this.enable();
        },

        _centerAlign: function (enableCenterAlign) {
            if (this.model.orientation == "horizontal" && enableCenterAlign)
                this.element.css('text-align', 'center');
            else
                this.element.css('text-align', 'inherit');
        },
        _columnToSelect: function (mapper) {
            var column = [], queryManager = ej.Query();
            if (ej.isNullOrUndefined(mapper.query)) {
                for (var col in mapper) {
                    if (col !== "tableName" && col !== "child" && col !== "dataSource" && mapper[col])
                        column.push(mapper[col]);
                }
                if (column.length > 0)
                    queryManager.select(column);
                if (!this.model.fields["dataSource"].dataSource.url.match(mapper.tableName + "$"))
                    !ej.isNullOrUndefined(mapper.tableName) && queryManager.from(mapper.tableName);
            }
            else
                queryManager = mapper.query;
            return queryManager;
        },


        _max_zindex: function () {
            var parents, bodyEle, maxZ, index;
            if (this.model.menuType == "contextmenu") {
                parents = $(this._targetElement).parents();
                parents.push(this._targetElement);
            }
            else
                parents = $(this.element).parents();
            bodyEle = $('body').children(), index = bodyEle.index(this.popup);
            bodyEle.splice(index, 1);
            $(bodyEle).each(function (i, ele) { parents.push(ele); });
            maxZ = Math.max.apply(maxZ, $.map(parents, function (e, n) {
                if ($(e).css('position') != 'static') return parseInt($(e).css('z-index')) || 1;
            }));
            if (!maxZ || maxZ < 10000) maxZ = 10000;
            else maxZ += 1;
            return maxZ;

        },

        _recursiveFunction: function (items, menuText) {
            var context = this;
            var isFound = false;
            $.each(items, function (key, value) {
                if (value.Text == menuText) {
                    context.selectedItem = value;
                    isFound = true;
                    return false;
                }
                else if (value.ChildItems != null) {
                    context._recursiveFunction(value.ChildItems, menuText);
                }
                if (isFound)
                    return false;
            });
        },

        _contextMenu_Template: function () {
            if(this.element[0].id !="")
            var oldWrapper = $(".e-menu-wrap #" + this.element[0].id).get(0);
            if (oldWrapper)
                $(oldWrapper.parentElement).remove();
            this.model.orientation = "vertical";
            this.element.addClass(this.model.cssClass + " e-context");
			 this.element.css("display", "none");
            this._referenceElement = this.element.parent();
            $("body").append(this.element);
            this.wrapper.insertBefore(this.element);
            this.wrapper.append(this.element);
        },

        _closeMenu: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
        },

        _onMenuIntent: function (element, obj, canOpen) {
            obj._delayMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == true && canOpen) {
                    var showanim = obj._showAnim;
                    var hideanim = obj._hideAnim;
                    var showSpeed = obj._showSpeed;
                    var hideSpeed = obj._hideSpeed;
                    obj._show(element, showanim, hideanim);
                }
            }, this._showSpeed);
        },

        _onHide: function (element, obj, canHide) {
            obj._delaySubMenuHover = window.setTimeout(function () {
                if (obj._mouseOver == false && canHide) {
                    var id = obj._id;
                    var hideanim = obj._hideAnim;
                    var hideSpeed = obj._hideSpeed;
                    obj._closeAll();
                }

            }, obj._hideSpeed);
        },

        _subMenuPos: function (element, direction) {
            var pos = $(element).offset();
            var subMenuLeft, subMenuRight ;
            var posLeft = pos.left;
            var subMenu = $('ul:first', element);
            var menuWidth = $(element).outerWidth();
            if (pos == null || pos == undefined)
                return false;
            var submenuWidth = subMenu.outerWidth() + 1; // +1 for the space between menu and submenu
            var left = this.model.container ? $(this.model.container).width() + $(document).scrollLeft() : document.documentElement.clientWidth + $(document).scrollLeft();
            if (this.model.menuType == "normalmenu") {
                if ($(element.parentNode).is(this.element)) {
                    if (this.model.orientation == "horizontal"){
                        subMenu.css("top", $(element).outerHeight() + "px");
                        if (!this.model.enableRTL) {
                            subMenuLeft = (left < (posLeft + submenuWidth)) ? ((posLeft + submenuWidth) - left) : 1;
                            subMenu.css("left", (subMenuLeft *(-1)) + "px");
                        }
                        else {
                            subMenuRight = (((posLeft + menuWidth) - submenuWidth) < 0) ? ((posLeft + menuWidth) - submenuWidth) : 1;
                            subMenu.css({ "left": "auto", "right": subMenuRight + "px" });
                        }
                    }
                    else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth))
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                    else {
                        subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    }
                } else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth &&  posLeft > submenuWidth)) {
                    subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                else {
                    subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                    var submenuHeight = subMenu.outerHeight();
                    var winHeight = $(window).height();
                    var submenuTop = (winHeight - (pos.top - $(window).scrollTop()));
                    if (winHeight < submenuHeight) {
					     var menuPos = pos.top - $(window).scrollTop();
						subMenu.css("top", -(menuPos) + 4 + "px");
					}
                    else if (submenuTop < submenuHeight) {
                        var menuPos = submenuTop - submenuHeight;
						subMenu.css("top", menuPos - 2 + "px");
					}
					else subMenu.css("top", "");
				}
            }
            else {
                left -= (pos.left + (2 * submenuWidth) + 4);
                if (left < 0) {
                    var menuLeftPos = (submenuWidth == null) ? "-206.5px" : "-" + (submenuWidth + 5) + "px";
                    subMenu.css("left", menuLeftPos);
                }
                else {
                    if (subMenu.parent('li.e-list').parent('ul').width() && direction == "right") {
                        subMenu.css("left", (subMenu.parent('li.e-list').parent('ul').width() + 4) + "px");
                    }
                    else if (pos.left > submenuWidth)
                        subMenu.css("left", -(submenuWidth + 4) + "px");
                }
                var submenuHeight = subMenu.outerHeight();
                if ((pos.top + submenuHeight > $(window).height())) {
                    var top = -(submenuHeight) + $(element).outerHeight();
                    if (submenuHeight > (pos.top + ($(element).outerHeight() / 2))) {
                        subMenu.css("top", -(submenuHeight / 2) + "px");
                    }
                    else
                        subMenu.css("top", top + "px");
                }
                else
                    subMenu.css("top","0px");
            }
        },


        _setSkin: function (skin) {
            this.wrapper.removeClass(this.model.cssClass).addClass(skin + " e-menu-wrap");
        },

        _setSeparator: function (separator) {
            if (separator){
                this.element.addClass("e-separator");
                if ($('.e-menu-popwrap').length>0 && !ej.isNullOrUndefined(this.ulTag))
                    this.ulTag.addClass("e-separator");     
            }
            else this.element.removeClass("e-separator");
        },

        _contextMenuEvents: function (action) {
            this[action]($(this.model.contextMenuTarget), "mouseup taphold", this._ContextMenuHandler);
            this[action](this.element, "contextmenu", this._onDefaultPreventer);
            this[action]($(this.model.contextMenuTarget), "contextmenu", this._onDefaultPreventer);
            this[action]($(document), "mousedown", this._onContextClose);
        },

        _show: function (element, showanim, hideanim) {
            var siblingElement;
            var sibling = $('> ul', element);
			var zIndex = this._max_zindex();
            sibling.attr({ "aria-hidden": false });
            this._hideAnimation($(element).siblings().find(' > ul:visible'), hideanim);
            if (!($.inArray(this._disabledMenuItems, element) > -1)) {
                if (sibling.css('display') != "none") {
                    siblingElement = this.model.openOnClick ? $(sibling) : sibling.children().find('> ul');
                    this._hideAnimation(siblingElement, hideanim);
                }
                else $('> ul', element).children().find('> ul').hide();
                this._subMenuPos(element, this.model.subMenuDirection);
                sibling.css({ "z-index": zIndex + 1 });
				$(element).children('span.e-menu-arrow').css({"z-index": zIndex + 2 });
                if ($('> ul', element).css('display') != 'block' && !$(element).hasClass("e-disable-item")) {
                    this._showAnimation(sibling, showanim);
                    sibling.closest('li').addClass('e-active e-mfocused');
                }
                if ($(element).siblings("li.e-active").length > 0)
                    $(element).siblings("li.e-active").removeClass("e-active e-mfocused");
            }
        },

        _closeAll: function () {
            this._hideAnimation(this.element.find('li.e-list:has("> ul")').find('> ul:visible'), this._hideAnim);
            this._hideAnimation(this.element.find('> ul:visible'), this._hideAnim);
        },

        _showAnimation: function (element, anim) {
            switch (anim) {
                case "slideDown":
                    element.slideDown(this.model.enableAnimation ? 200 : 0); break;
                case "none":
                    element.css("display", "block"); break;
            }
        },

        _hideAnimation: function (element, anim) {
            switch (anim) {
                case "slideUp":
                    $(element).attr({ "aria-hidden": true });
                    element.slideUp(this.model.enableAnimation ? 100 : 0); break;
                case "none":
                    element.css("display", "none"); break;
            }
            element.closest('li').removeClass('e-active e-mfocused');
        },

        _removeValue: function (text, disableList) {
            var $browInfo = ej.browserInfo(), elementText;
            $browInfo.version === "8.0" && $browInfo.name === "msie" ? elementText = text[0].outerText : elementText = text[0].textContent;
            var count = $(disableList).length, i = 0;
            var childEle = $(disableList).children('a').length == 0 ? $(disableList).children('span') : $(disableList).children('a');
            while (i <= count) {
                if ($(childEle[i]).text() === elementText)
                    return i;
                i++;
            }
        },

        _createSubLevelItem: function (target, element) {
            var ulTag;
            ulTag = $(document.createElement('ul'));
            ulTag.append(element);
            target.append(ulTag);
            target.attr({ 'role': 'menu', 'aria-haspopup': 'true' });
            target.addClass("e-haschild");
            this.element.find('li:has("> ul")').find('> a,>span').addClass('aschild e-arrow-space');
            this._insertArrows(ulTag);
        },

        _insertArrows: function (ulTag) {
            if (this.model.showRootLevelArrows)
                ulTag.find('>a,>span').append($('<span>').addClass("e-icon e-arrowhead-down")).addClass("e-arrow-space");
            else
                ulTag.find('>a,>span').removeClass("e-arrow-space").find('>span.e-icon').remove();

            if (this.model.showSubLevelArrows)
                ulTag.parent('li.e-list:has(>ul)').children('a,span').append($('<span>').addClass("e-icon e-arrowhead-right")).addClass("e-arrow-space");
            else
                ulTag.parent('li.e-list:has(>ul)').children('a,span').removeClass("e-arrow-space").find('>span.e-icon').remove();
        },

        _createMenuItem: function (item) {
            var liTag, aTag, imgTag, spanTag;
            liTag = $(document.createElement('li'));
            liTag.attr({ "class": 'e-list', "role": "menuitem" });
            if (item["htmlAttribute"]) this._setAttributes(item["htmlAttribute"], liTag);
            if (item["text"] && item["text"] != "") {
                aTag = $(document.createElement('a'));
				aTag.attr({ "class": 'e-menulink'});
                if (item["imageUrl"] && item["imageUrl"] != "") {
                    imgTag = $(document.createElement('img'));
                    imgTag.attr('src', item["imageUrl"]);
                    if (item["imageAttribute"]) this._setAttributes(item["imageAttribute"], imgTag);
                    aTag.append(imgTag);
                }
                else if (item["spriteCssClass"] && item["spriteCssClass"] != "") {
                    spanTag = $(document.createElement('span'));
                    spanTag.addClass(item["spriteCssClass"]);
                    aTag.append(spanTag);
                }
                aTag.append(item["text"]);
                if (item["linkAttribute"]) this._setAttributes(item["linkAttribute"], aTag);
                if (item["url"])
                    aTag.attr('href', item["url"]);
                liTag.append(aTag);
            }
            if (item["id"]) {
                liTag.prop("id", item["id"]);
            }
            if (!this.model.enabled)
                liTag.addClass("e-disable-item");
            return liTag;
        },

        _insertNode: function (itemCollection, targetNode, operation) {
            var item = 0, targetList = 0, target = 0, targetCollection = [];
            if ($(targetNode).is(this.element))
                targetCollection.push(this.element);
            else
                typeof (targetNode) === "string" ? targetCollection.push(this.element.find(targetNode)) : typeof (targetNode) === "undefined" ? targetCollection.push(this.element) : targetCollection.push(targetNode);
            for (targetList = 0; targetList < targetCollection.length; targetList++) {
                for (target = 0; target < targetCollection[targetList].length; target++)
                    for (item = 0; item < itemCollection.length && !ej.isNullOrUndefined(itemCollection[item]) ; item++)
                        this._addItem(itemCollection[item], targetCollection[targetList][target], operation);
            }
        },

        _addItem: function (item, target, operation) {
            var element, targetElement;
            this._wireEvents("_off");
            element = this._createMenuItem(item);
            target = target === "default" ? $("#" + item["parentId"]) : $(target);
            switch (operation) {
                case "insert":
                    $(target).is(this.element) ? targetElement = target : targetElement = target.children('ul');
                    targetElement.length != 0 ? targetElement.append(element) : this._createSubLevelItem(target, element);
                    break;
                case "insertBefore":
                    if (!$(target).is(this.element))
                        element.insertBefore(target);
                    else
                        target.prepend(element);
                    break;
                case "insertAfter":
                    if (!$(target).is(this.element))
                        element.insertAfter(target);
                    else
                        target.append(element);
                    break;
            }
            this._wireEvents("_on");
        },

        _removeItem: function (item) {
            if (item.siblings('li').length == 0) {
                item.closest("ul").siblings('a.aschild').removeClass("aschild e-arrow-space").children('span.e-icon').remove();
                !item.closest("ul").hasClass("e-menu") ? item.closest("ul").remove() : item.remove();
            }
            else
                item.remove();
        },

        _hiddenElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) == -1)) {
                ele.addClass("e-hidden-item");
                this._hiddenMenuItems.push(ele[0]);
            }
        },

        _showElement: function (ele) {
            if (ele.length > 0 && ($.inArray(ele[0], this._hiddenMenuItems) > -1)) {
                ele.removeClass("e-hidden-item");
                this._hiddenMenuItems.splice(this._hiddenMenuItems.indexOf(ele[0]), 1);
            }
        },

        _getNodeByID: function (node) {
            (typeof node != "object" && node != "") && (node = this.element.find(".e-list" + node));
            return $(node);
        },

        _processItems: function (node, bool) {
            var ele = this._getNodeByID(node);
            for (var i = 0; i < ele.length; i++) bool ? this._showElement($(ele[i])) : this._hiddenElement($(ele[i]));
        },

        insert: function (item, target) {
            this._insertNode(item, target, "insert");
        },

        insertBefore: function (item, target) {
            this._insertNode(item, target, "insertBefore");
        },

        insertAfter: function (item, target) {
            this._insertNode(item, target, "insertAfter");
        },

        remove: function (targetCollection) {
            var target = 0, innerTarget = 0;
            for (target = 0; target < targetCollection.length; target++) {
                targetCollection[target] = typeof (targetCollection[target]) === "string" ? (this.element.find(targetCollection[target])) : targetCollection[target];
                for (innerTarget = 0; innerTarget < targetCollection[target].length; innerTarget++)
                    (targetCollection[target][innerTarget].tagName === "LI" || targetCollection[target][innerTarget].tagName === "UL") ? this._removeItem($(targetCollection[target][innerTarget])) : targetCollection[target][innerTarget].remove();
            }
        },

        showContextMenu: function (locationX, locationY, targetElement, e, update) {
            this._closeMenu();
            this._eventArgs = e;
            if (!ej.isNullOrUndefined(e) && this._checkForExclusion(e.target)) return;
            if (this._trigger("beforeOpen", { target: targetElement, events: e })) return false;
            if (this._preventContextOpen) {
                if (!ej.isNullOrUndefined(targetElement))
                    this._targetElement = targetElement;
                else if (!ej.isNullOrUndefined(target))
                    this._targetElement = target;
                else
                    this._targetElement = this.element;
                if (update) {
                    var position = this._calculateContextMenuPosition(e);
                    locationX = position.X;
                    locationY = position.Y;
                }
                this.element.css({ "left": locationX, "top": locationY });
                this.element.css({ "z-index": this._max_zindex() + 1 });
                this._showAnimation(this.element, this._showAnim);
                this._isContextMenuOpen = true;
                this.element.focus();

                this._trigger("open", { target: targetElement });
                this._on(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
            }
            return false;
        },

        _checkForExclusion: function (e) {
            if (!ej.isNullOrUndefined(this.model.excludeTarget)) {
                var excludeTargets = this.model.excludeTarget.split(",");
                for (var target = 0; target < excludeTargets.length; target++) {
                    if ($(e).closest(this.model.excludeTarget).is($.trim(excludeTargets[target])))
                        return true;
                }
            }
        },


        hideContextMenu: function (e) {
            this._closeMenu();
            this.element.find(".e-mhover").removeClass("e-mhover");
            this.element.find(".e-mfocused").removeClass("e-mfocused");
            this._hideAnimation(this.element, this._hideAnim);
            this._isContextMenuOpen = false;

            this._trigger("close", $.extend({ events: e }, e));
            this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
        },


        disableItem: function (itemToDisable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToDisable; });
            if (isMenuItem.length > 0 && !($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().addClass("e-disable-item").attr({ "aria-disabled": true });
                isMenuItem.parent().find('>a.aschild span.e-icon').addClass("e-disable");
                this._disabledMenuItems.push(isMenuItem.parent()[0]);
            }
        },


        disableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToDisable = this.element.find("#" + itemId) ? this.element.find("#" + itemId)[0] : undefined;
                if (itemToDisable && !($.inArray(itemToDisable, this._disabledMenuItems) > -1)) {
                    $(itemToDisable).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(itemToDisable).find('>a.aschild span.e-icon').addClass("e-disable");
                    this._disabledMenuItems.push(itemToDisable);
                }
            }
        },

        getHiddenItems:function(){
            return this._hiddenMenuItems;
        },

        hideItems: function (node) {
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], false);                
            }
            else this._processItems(node, false);
        },

        showItems:function(node){
            if (typeof node == "object" && node.length !== undefined) {
                for (var i = 0; i < node.length; i++) this._processItems(node[i], true);
            }
            else this._processItems(node, true);
        },

        enableItem: function (itemToEnable) {
            var isMenuItem = $(this.element.find('li.e-list >a ,li.e-list >span')).filter(function () { return $.trim($(this).text()) === itemToEnable; });
            if (isMenuItem.length > 0 && ($.inArray(isMenuItem.parent()[0], this._disabledMenuItems) > -1)) {
                isMenuItem.parent().removeClass("e-disable-item").attr({ "aria-disabled": false });
                isMenuItem.parent().find('>a.aschild span.e-icon').removeClass("e-disable");
                var index = this._removeValue(isMenuItem, this._disabledMenuItems);
                this._disabledMenuItems.splice(index, 1);
            }
        },


        enableItemByID: function (itemId) {
            if (itemId && itemId != "") {
                var itemToEnable = this.element.find("#" + itemId)[0];
                if (itemToEnable && ($.inArray(itemToEnable, this._disabledMenuItems) > -1)) {
                    $(itemToEnable).removeClass("e-disable-item").attr({ "aria-disabled": false });
                    $(itemToEnable).find('>a.aschild span.e-icon').removeClass("e-disable");
                    for (var i = this._disabledMenuItems.length - 1; i >= 0; i--) {
                        if (this._disabledMenuItems[i].id == itemId) {
                            this._disabledMenuItems.splice(i, 1);
                        }
                    }
                }
            }
        },


        disable: function () {
            this.model.enabled = false;
            var menuItemCollection = this.element.find('>li[class~=e-list]');
            var proxy = this;
            $.each(menuItemCollection, function (key, value) {
                if (!($.inArray(value, proxy._disabledMenuItems) > -1))
                {
                    $(value).addClass("e-disable-item").attr({ "aria-disabled": true });
                    $(value).find('>a.aschild span.e-icon').addClass("e-disable");
                    proxy._disabledMenuItems.push(value);
                }
                
            });
        },


        enable: function () {
            var proxy = this;
            this.model.enabled = true;
            var menuItemCollection = this.element.find('li.e-disable-item');
            $.each(menuItemCollection, function (key, value) {
                $(value).removeClass("e-disable-item").attr({ "aria-disabled": false });
                $(value).find('>a.aschild span.e-icon').removeClass("e-disable");
                proxy._disabledMenuItems.pop(value);
            });
        },

        show: function (locationX, locationY, targetElement, e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.showContextMenu(locationX, locationY, targetElement, e, false);
            else
                this.element.css("display", "block");
        },

        hide: function (e) {
            if (!this.model.enabled) return false;
            if (this.model.menuType == "contextmenu")
                this.hideContextMenu(e);
            else {
                this._closeMenu();
                this.element.css("display", "none");
            }
        },

        _wireEvents: function (action) {
            this[action](this.element.find("li.e-list"), "mouseout", this._mouseOutHandler);
            this[action](this.element.find("li.e-list"), "mouseover", this._mouseOverHandler);
            this[action](this.element.children(), "click", this._onClickHandler); 
            this[action](this.element, "keydown", this._onKeyDownHandler);
            this[action](this.element, "focus", this._OnFocusHandler);
            this[action](this.element, "blur", this._OnFocusOutHandler);
            if (this.model.menuType == "contextmenu" && $(this.model.contextMenuTarget)[0] != null) {
                this._contextMenuEvents(action);
            }
            if (this.model.menuType != "contextmenu") {
                this[action]($(document), "click", this._onDocumentClick);
                this[action](this.element, "mousedown", this._onMouseDownHandler);
            }
            this[action]($(window),"resize", $.proxy(this._onResize, this));            
        },

        _mouseOverHandler: function (event) {
            var element, itemId = "";
            this.element.find(".e-mhover").removeClass("e-mhover");
            event.currentTarget = $(event.target).closest("li")[0];
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                $(event.currentTarget).addClass("e-mhover");
            else this._isFocused = false;
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = true;
            this._isMenuOpen = true;
            if ($(event.currentTarget.parentNode.parentNode).is(this.element)) {
                this._isSubMenuOpen = false;
            }
            else {
                this._isSubMenuOpen = true;
            }
            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            if (!$(event.currentTarget).hasClass('e-disable-item'))
                this._onMenuIntent(element, this, this._hoverOpen);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseover", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onMouseDownHandler: function (e) {
            if ($(e.target).hasClass('e-menu')) this._isFocused = false;
        },


        _mouseOutHandler: function (event) {
            var element, itemId = "";
            $(event.currentTarget).removeClass("e-mhover");
            if (event.stopPropagation)
                event.stopPropagation();
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delaySubMenuHover);
            }
            if (typeof (this._delaySubMenuHover) !== 'undefined') {
                clearTimeout(this._delayMenuHover);
            }
            this._mouseOver = false;
            this._isMenuOpen = false;

            if (event.currentTarget.nodeName == "LI")
                element = event.currentTarget;
            else if (event.currentTarget.parentNode) {
                if (event.currentTarget.parentNode.nodeName == "LI")
                    element = event.currentTarget.parentNode;
                else
                    return false;
            }
            else {
                event.preventDefault();
                return false;
            }
            this._onHide(element, this, this._hoverClose);
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "ID": itemId };

                this._trigger("mouseout", $.extend({ events: eventArgs }, eventArgs));
            }
        },

        _onClickHandler: function (event) {
            var element, itemId = "" , parentId, parentText;
            this._isFocused = true;
            var openOnClickStart = false;
            if (!$(event.target).closest("li.e-list").hasClass('e-disable-item') && $(event.target).closest("li.e-list").length > 0) {
                element = $(event.target).closest("li.e-list")[0];
                if ($(element).is(this.element.find(">li.e-list")))
                    this._activeElement = element;
            }
            else {
                if ($(event.target).is(this.element))
                    this._activeElement = this.element.find(">li:first");
                return;
            }
            if ($(event.target).is("a") && $(element).find(">a,>span").hasClass('aschild') && this.model.openOnClick) {
                this._isFocused = false;
            }
            if (!this._hoverOpen && $(element).find(">a,>span").hasClass('aschild')) {
                this._show(element, this._showAnim, this._hideAnim);
                this._hoverOpen = false;
                openOnClickStart = true;
            }
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                //Check if Context Menu, then hide the context menu firing the events
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && !$(element).hasClass("e-haschild")) {
                        this._hideAnimation(this.element, this._hideAnim);
                        this._isContextMenuOpen = false;

                        this._trigger("close", $.extend({ events: event }, event));
						this._off(ej.getScrollableParents($(this.model.contextMenuTarget)), "scroll", this.hideContextMenu);
                    }
                }
                if (!openOnClickStart) {



                    if (!$(element).find(">a,>span").hasClass("aschild")) {
                        this._closeMenu();
                        if (this.model.openOnClick)
                            this._hoverOpen = false;
                    }
                }
                var menuText = $(element).children('a,span').text();
                var parent = $(element).closest("ul").parent("li");
                if (parent.length != 0) {
                    parentId = ej.isNullOrUndefined(parent.attr("id")) ? null : parent.attr("id");
                    parentText = parent.children('a,span').text();
                }
                else {
                    parentId = null;
                    parentText = null;
                }
                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                var eventArgs = { "text": menuText, "element": element, "event": event, "selectedItem": this.selectedItem, "ID": itemId, "parentId": parentId, "parentText": parentText };
                this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                this.selectedItem = null;
                if (this.model.openOnClick && this.model.menuType != "contextmenu")
                    this.element.focus();
            }
        },


        _onKeyDownHandler: function (e) {
            if (this.model.menuType == "contextmenu" && !this._isContextMenuOpen) return;
            var element, focusEle, itemId = "", hoverElement = this.element.find(".e-mhover"), focusedElement = this.element.find(".e-mfocused"), currentElement, liVisible;
            if (!$(hoverElement).length > 0 && $(this._activeElement).length > 0)
                hoverElement = focusedElement = $(this._activeElement);

            if (e.keyCode == 9) {
                this._isFocused = false;
                this._OnFocusOutHandler();
            }
            else if (e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
                e.preventDefault();

            if (e.keyCode == 40) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-mhover").children("ul").length > 0 || $(this._activeElement).length > 0) {
                        if ($(hoverElement).children("ul").css('display') === "none")
                            this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                        hoverElement.removeClass("e-mhover e-mfocused").children("ul:first").find("li:first").addClass("e-mhover");
                        this._activeElement == null ? hoverElement.addClass("e-mfocused") : $(this._activeElement).addClass("e-mfocused");
                    } else {
                        liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        $(hoverElement[hoverElement.length-1]).removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mfocused");
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    } else focusEle = liVisible.first();
                    focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 39) {
                if (this.model.orientation == "horizontal" && (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0)) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) + 1]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if ($(hoverElement).children("ul").length > 0) {
                    hoverElement.removeClass("e-mfocused e-mhover");
                    var firstChild = hoverElement.children("ul:first").find("li:first");
                    this._show(hoverElement[hoverElement.length - 1], this._showAnim, this._hideAnim);
                    liVisible = hoverElement.addClass('e-mfocused').children("ul:first").children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    focusEle = $(liVisible[liVisible.index(firstChild)]).length > 0 ? $(liVisible[liVisible.index(firstChild)]) : liVisible.first();
                    focusEle.addClass("e-mhover");
                }
                else if (hoverElement.children("ul").length <= 0) {
                    if (this.model.orientation == "horizontal" && hoverElement.parent().closest('.e-list').parent().hasClass('e-menu')) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) + 1]) : $(liVisible[liVisible.index(focusedElement.first())]);
                        focusEle.addClass("e-mhover");
                    }
                }
            }

            if (e.keyCode == 38) {
                if (this.model.orientation == "horizontal") {
                    liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    hoverElement.removeClass("e-mfocused e-mhover");
                    focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                }
                else if (this.model.orientation != "horizontal") {
                    if (hoverElement.length == 0) liVisible = this.element.children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    else liVisible = hoverElement.parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                    if (hoverElement.length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                    } else focusEle = liVisible.last();
                }
                focusEle.addClass("e-mhover");
            }

            if (e.keyCode == 37) {
                if (this.model.orientation == "horizontal") {
                    if (this.element.find(">li.e-list").hasClass("e-mhover") || $(this._activeElement).length > 0) {
                        hoverElement.removeClass("e-mfocused e-mhover");
                        liVisible = this.element.find('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(hoverElement[hoverElement.length - 1]) - 1]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                    else {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused e-active");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        if (hoverElement.parent().closest('.e-list').parent('.e-menu').length > 0)
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1]) - 1]) : liVisible.last();
                        else
                            focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : liVisible.last();
                        focusEle.addClass("e-mhover");
                    }
                }
                else if (hoverElement.parent(".e-menu").length == 0 || (this.model.menuType == "contextmenu" && hoverElement.parent("ul.e-context").length == 0)) {
                        this._hideAnimation(hoverElement.parent(), this._hideAnim);
                        hoverElement.removeClass("e-mfocused e-mhover");
                        $(focusedElement[focusedElement.length - 1]).removeClass("e-mfocused");
                        liVisible = hoverElement.parent().closest('.e-list').parent().children('li.e-list:visible:not(.e-hidden-item, .e-disable-item)');
                        focusEle = $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]).length > 0 ? $(liVisible[liVisible.index(focusedElement[focusedElement.length - 1])]) : $(liVisible[liVisible.index(focusedElement.last())]);
                        focusEle.addClass("e-mhover");
                }
            }
            if (e.keyCode == 13) {
                var menuText = $(hoverElement).children('a,span').text();
                itemId = !ej.isNullOrUndefined($(hoverElement)[0]) ? $(hoverElement)[0].id : "";
                var eventArgs = { "menuId": this.element[0].id, "text": menuText, "selectedItem": focusedElement, "ID": itemId };
                if (this.model.menuType == "contextmenu") {
                    if (this._isContextMenuOpen && hoverElement.length > 0 && !focusedElement.hasClass("e-disable-item")) {
                        if (this.model.click)
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                        this.selectedItem = null;
                        this.hideContextMenu(e);
                    }
                } else {
                    if (hoverElement.length > 0 && !hoverElement.hasClass("e-disable-item")) {
                        if ($(hoverElement).find(">a,>span").hasClass('aschild') && $(hoverElement).children("ul").css('display') === "none") {
                            this._show(hoverElement[0], this._showAnim, this._hideAnim);
                            hoverElement.removeClass("e-mhover").children("ul:first").find("li:first").addClass("e-mhover");
                        }
                        else {
                            this.element.find(".e-mhover >a,.e-mhover >span ").focus();
                            this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                            this._closeAll();
                        }
                        if (ej.isNullOrUndefined($(hoverElement).find(">a").attr("href")))
                            this._trigger("click", $.extend({ events: eventArgs }, eventArgs));
                    }
                }
            }
            if (e.keyCode == 27) {
                if (this.model.menuType == "contextmenu")
                    this.hideContextMenu(e);
                else
					this.element.find("li.e-list").removeClass("e-mhover");
                    this.element.find('li.e-list:has("> ul")').find('> ul:visible').parents("li.e-list").addClass("e-mhover");
                    this._closeAll();
            }
            if ($(e.target).is(this.element) && e.target.parentNode) {
                if (hoverElement.length)
                    element = hoverElement;
            }
            else
                return false;
            if (!($.inArray(element, this._disabledMenuItems) > -1)) {
                var menuText = $(element).children('a,span').text();

                itemId = !ej.isNullOrUndefined(element) ? $(element)[0].id : "";
                if (this.element.find('li.e-mfocused.e-mhover').length || e.keyCode == 13)
                    currentElement = (e.keyCode == 13) ? hoverElement : this.element.find('li.e-mfocused.e-mhover');
                var eventArgs = { "text": menuText, "element": element, "targetElement": currentElement , "event": e, "ID": itemId };

                this._trigger("keydown", $.extend({ events: eventArgs }, eventArgs));
            }
            this._activeElement = null; focusedElement = this.element.find(".e-mfocused");
        },

        _OnFocusHandler: function (event) {
            if (this.model.menuType != "contextmenu" && !this.element.find(">li:first").hasClass("e-disable-item") && this._isFocused && this.element.find(".e-mhover").length == 0 && $('li.e-ham-wrap').length ==0) {
                this.element.find(">li:first").addClass("e-mhover");
            }
            else this._isFocused = true;
            if (this.model.menuType != "contextmenu")
                this._activeElement = this.element.find(">li:first");
        },

        _OnFocusOutHandler: function () {
            if (!this._isFocused) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
            }
            this._isFocused = false;
        },

        _onDocumentClick: function (event) {
            if (this.model.openOnClick)
                this._hoverOpen = false;
            if (!$(event.target).parents(".e-menu").is(this.element)) {
                this.element.find("li.e-list").removeClass("e-mhover e-mfocused");
                this._closeAll();
                this._isFocused = true;
            }
            if ((!$(event.target).parents("ul.e-menu").is(this.popupWrapper)) && (!$(event.target).hasClass('e-ham-wrap')) && (!($(event.target).parent().hasClass('e-ham-wrap'))) && (!$(event.target).hasClass('e-hamburger')) && (!$(event.target).parent("li").hasClass("e-haschild")) && (!$(event.target).is('span.e-icon.e-arrowhead-down')) && !(this._isOverflowPopupOpen()) && this.model.menuType != "contextmenu" && $("li.e-ham-wrap").length > 0) {
                this._overflowClose();
            }           
        },


        _ContextMenuHandler: function (e) {
            var isRightClick = false;
            if (e.type == "taphold" && e.button != 0)
                isRightClick = true;
            else if (e.button)
                isRightClick = (e.button == 2);
            else if (e.which)
                isRightClick = (e.which == 3); //for Opera
            var targetElement = e.target;
            if (isRightClick) {
                var evt = e;
                if (e.type == "taphold") {
                    if (e.options.type == "touchstart") evt = e.options.touches[0];
                    else evt = e.options;
                }
                var showSpeed = this._showSpeed;
                this.showContextMenu(null, null, targetElement, evt, true);
            }
            else {
                if (this._isContextMenuOpen) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                }
            }
        },

        _calculateContextMenuPosition: function (e) {
            var locationX, locationY;
            this.element.css({"top": "", "left": ""}); 
            locationX = (e.clientX + this.element.width() < $(window).width()) ? e.pageX : e.pageX - this.element.width();
            locationY = (e.clientY + this.element.height() < $(window).height()) ? e.pageY : (e.clientY > this.element.height()) ? e.pageY - this.element.height() : $(window).height() - this.element.outerHeight();
            var bodyPos = $("body").css("position") != "static" ? $("body").offset() : { left: 0, top: 0 };
            locationX -= bodyPos.left, locationY -= bodyPos.top;
            return {
                X: locationX,
                Y: locationY
            };
        },


        _onDefaultPreventer: function (e) {
            e.preventDefault();
            e.stopPropagation();
            return false;
        },


        _onContextClose: function (e) {
            var proxy = this;
            if (this._isContextMenuOpen) {
                var isRightClick = false;
                if ($(e.target).is(this.element) || $(e.target).parents(".e-context").is(this.element))
                    isRightClick = true;
                if (!isRightClick) {
                    var hideanim = this._hideAnim;
                    var hideSpeed = this._hideSpeed;
                    this.hideContextMenu(e, hideanim, hideSpeed);
                    var parentElements = $(e.target).parents();
                    $.each(parentElements, function (index, value) {
                        if (value.id == proxy._ContextTargetId) {
                            return;
                        }
                    });

                }
            }
        }

    });

    ej.Menu.Locale = ej.Menu.Locale || {} ;
       
    ej.Menu.Locale['default'] = ej.Menu.Locale["en-US"] = {  	
        titleText: "Menu"
    };
    ej.MenuType = {
        /**  support for list of items appears as normal menu in horizontal or vertical direction. */
        NormalMenu: "normalmenu",
        /**  support for list of items appears as menu when right clicked on target area, thereby preventing browser’s default right click.. */
        ContextMenu: "contextmenu"
    };

    ej.Direction = {
        /**  support for Render sub menu popup in left direction. */
        Left: "left",
        /**  support for Render sub menu popup in Right direction. */
        Right: "right",
        /** Default opening direction of menu sub items */
        None: "none",
    };

    ej.AnimationType = {
        /**  support for disable the AnimationType while hover or click an menu items. */
        None: "none",
        /**  support for enable the AnimationType while hover or click an menu items. */
        Default: "default"
    };

})(jQuery, Syncfusion);;